#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e2f5d98abb4529b811183acfa9f4c89618406e0";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"util\" as util",
  "import \"identifierKinds\" as k",
  "",
  "// This module contains classes and pseudo-classes for all the AST nodes used",
  "// in the parser. Because of the limitations of the class syntax, classes that",
  "// need more than one method are written as object literals containing methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is given by type ASTNode ",
  "//",
  "// Most nodes also contain a \"value\" field, with varied type, holding the `main value`",
  "// in the node.  This field is confusing and should be appropriately re-named in",
  "// each case. Some nodes contain other fields for their specific use: while has",
  "// both a value (the condition) and a body, for example.",
  "",
  "def lineLength is public = 80",
  "",
  "method listMap(l, b) ancestors(as) is confidential {",
  "    def newList = [ ]",
  "    l.do { nd -> newList.addLast(nd.map(b) ancestors(as)) }",
  "    newList",
  "}",
  "method maybeMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        n.map(b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "method maybeListMap(n, b) ancestors(as) is confidential {",
  "    if (false != n) then {",
  "        listMap(n, b) ancestors(as)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def ancestorChain = object {",
  "    class empty {",
  "        method isEmpty { true }",
  "        method asString { \"ancestorChain ▫\" }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "    method with(n) { empty.extend(n) }",
  "    class cons(p) onto(as) is confidential {",
  "        method forebears { as }",
  "        method isEmpty { false }",
  "        method parent { p }",
  "        method grandparent { forebears.parent }",
  "        ",
  "        method asString {",
  "            var a := self",
  "            var s := \"ancestorChain \"",
  "            while { a.isEmpty.not } do {",
  "                s := s ++ a.parent ++ \"➤\"",
  "                a := a.forebears",
  "            }",
  "            s ++ \"▫\"",
  "        }",
  "        method extend(n) { cons(n) onto(self) }",
  "    }",
  "}",
  "",
  "def emptySeq = emptySequence",
  "",
  "type AstNode = type {",
  "    kind -> String ",
  "        // Used for pseudo-instanceof tests.",
  "    register -> String",
  "        // Used in the code generator on to name the resulting object",
  "    line -> Number",
  "        // The source line the node came from",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    scope -> SymbolTable",
  "        // The symbolTable for names defined in this node and its sub-nodes",
  "    pretty(n:Number) -> String ",
  "        // Pretty-print-string of node at depth n",
  "    comments -> AstNode",
  "        // Comments associated with this node",
  "}",
  "",
  "type SymbolTable = Unknown",
  "",
  "class baseNode {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var symbolTable := fakeSymbolTable",
  "    var comments is public := false",
  "",
  "    method kind { abstract }",
  "    method ==(other) { self.isMe(other) }       // for usesAsType",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isLegalInTrait { false }",
  "    method isMember { false }",
  "    method isMethod { false }",
  "    method isExecutable { true }",
  "    method isCall { false }",
  "    method isComment { false }",
  "    method isClass { false }    // is a method that returns a fresh object",
  "    method inClass { false }    // object in a syntactic class definiton",
  "    method isTrait { false }    // is a method that returns a trait object",
  "    method inTrait { false }    // object in a syntactic trait definition",
  "    method isBind { false }",
  "    method isBlock { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method isDialect { false }",
  "    method isImport { false }",
  "    method isTypeDec { false }",
  "    method isExternal { false }",
  "    method canInherit { false }",
  "    method returnsObject { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"{kind} {nameString}\" }",
  "    method nameString { \"?\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (false == self.dtype) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method isSimple { true }  // needs no parens when used as reciever",
  "    method description { kind }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (ancestorChain.empty)",
  "    }",
  "    method scope { symbolTable }",
  "",
  "    method scope:=(st) {",
  "        // override this method in subobjects that open a new scope. In such",
  "        // subobjects, and only in such subobjects, there should be a 2-way",
  "        // conection between the node and the symbol table that defines its scope.",
  "        symbolTable := st",
  "    }",
  "",
  "    method shallowCopyFieldsFrom(other) {",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        scope := other.scope",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((scope.node == self) && {util.target == \"symbols\"}) then {",
  "            \"{line}:{linePos} {description}\\n{spc}Symbols({scope.variety}): {scope}{scope.elementScopesAsString}\"",
  "        } elseif {scope.variety == \"fake\"} then {",
  "            \"{line}:{linePos} {description}\"",
  "        } else {",
  "            \"{line}:{linePos} {description} {scope.asDebugString}\"",
  "        }",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } ancestors(ancestorChain.empty)",
  "    }",
  "    method enclosingObject {",
  "        def obj = scope.enclosingObjectScope.node",
  "        obj",
  "    }",
  "    method addComment(cmtNode) {",
  "        if (false == comments) then {",
  "            comments := cmtNode",
  "        } else {",
  "            comments.extendCommentUsing(cmtNode)",
  "        }",
  "    }",
  "    method addComments(cmtNodeList) {",
  "        cmtNodeList.do { each -> addComment(each) }",
  "    }",
  "    method statementName { kind }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits baseNode",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "    method asString { \"the nullNode\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def fakeSymbolTable = object {",
  "    var node is public := nullNode",
  "    method asString { \"the fakeSymbolTable\" }",
  "    method addNode (n) as (kind) {",
  "        ProgrammingError.raise \"fakeSymbolTable(on node {node}).addNode({n}) as \\\"{kind}\\\" requested\"",
  "    }",
  "    method thatDefines (name) ifNone (action) {",
  "        ProgrammingError.raise \"fakeSymbolTable.thatDefines({name}).\"",
  "    }",
  "    method enclosingObjectScope {",
  "        ProgrammingError.raise \"fakeSymbolTable.enclosingObjectScope on node {node}\"",
  "    }",
  "    method variety { \"fake\" }",
  "    method ==(other) { self.isMe(other) }",
  "}",
  "",
  "def ifNode is public = object {",
  "  class new(cond, thenblock', elseblock') {",
  "    inherits baseNode",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitIf(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            value.accept(visitor) from(newChain)",
  "            thenblock.accept(visitor) from(newChain)",
  "            elseblock.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.thenblock := thenblock.map(blk) ancestors(newChain)",
  "        n.elseblock := elseblock.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.isntEmpty) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "  }",
  "}",
  "def blockNode is public = object {",
  "  class new(params', body') {",
  "    inherits baseNode",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(ancestorChain.with(self))",
  "    }",
  "    method isBlock { true }",
  "    method isEmpty { body.size == 0 }",
  "    method isntEmpty { body.size > 0 }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.parameter }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method returnsObject {",
  "        (body.size > 0) && { body.last.returnsObject }",
  "    }",
  "    method returnedObjectScope {",
  "        // precondition: returnsObject",
  "        body.last.returnedObjectScope",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBlock(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.matchingPattern) then {",
  "                self.matchingPattern.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        n.body := listMap(body, blk) ancestors(newChain)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (false != self.matchingPattern) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params.at(i)",
  "                if (false != self.matchingPattern) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "  }",
  "}",
  "def tryCatchNode is public = object {",
  "  class new(block, cases', finally') {",
  "    inherits baseNode",
  "    def kind is public = \"trycatch\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTryCatch(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.finally) then {",
  "                self.finally.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.finally := maybeMap(finally, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"try \" ++ self.value.toGrace(depth + 1) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"catch \" ++ case.toGrace(depth + 1)",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        tryCatchNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def matchCaseNode is public = object {",
  "  class new(matchee', cases', elsecase') {",
  "    inherits baseNode",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method isSimple { false }  // needs parens when used as reciever",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMatchCase(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.elsecase) then {",
  "                self.elsecase.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.cases := listMap(cases, blk) ancestors(newChain)",
  "        n.elsecase := maybeMap(elsecase, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def methodTypeNode is public = object {",
  "  class new(name', signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // signature is an Iterable of callWithPart objects",
  "",
  "    inherits baseNode",
  "    def kind is public = \"methodtype\"",
  "    var value is public := name'",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var typeParams is public := false",
  "    def nameString:String is public = value",
  "",
  "    method isExecutable { false }",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the symbol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitMethodType(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            if (false != rtype) then {",
  "                rtype.accept(visitor) from(newChain)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.rtype := maybeMap(rtype, blk) ancestors(newChain)",
  "        n.signature := listMap(signature, blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (false != rtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (false != typeParams) then {",
  "            s := \"{s}\\n{spc}TypeParams:\\n\" ",
  "            s := s ++ typeParams.pretty(depth + 2)",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        var firstPart := true",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if (firstPart) then {",
  "                firstPart := false",
  "                if (false != typeParams) then {",
  "                    typeParams.toGrace(depth + 1)",
  "                }",
  "            }",
  "            if (part.params.size > 0) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params.at(pnr)",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if (pnr < part.params.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (false != self.rtype) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        methodTypeNode.new(value, emptySeq, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def typeLiteralNode is public = object {",
  "  class new(methods', types') {",
  "    inherits baseNode",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "    ",
  "    method name { value }",
  "    method name:=(n) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"typeliteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method declarationKindWithAncestors(as) { k.typedec }",
  "    method isExecutable { false }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeLiteral(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.methods := listMap(methods, blk) ancestors (as)",
  "        n.types := listMap(types, blk) ancestors (as)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopy {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "    method shallowCopyFieldsFrom(other) {",
  "        super.shallowCopyFieldsFrom(other)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "  }",
  "}",
  "",
  "def typeDecNode is public = object {",
  "  class new(name', typeValue) {",
  "    inherits baseNode",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString:String is public = name.value",
  "    var annotations is public := [ ]",
  "    var typeParams is public := false",
  "",
  "    method isLegalInTrait { true }",
  "    method isTypeDec { true }",
  "    method scope:=(st) {",
  "        // sets up the 2-way conection between this node",
  "        // and the synmol table that defines the scope that I open.",
  "        symbolTable := st",
  "        st.node := self",
  "    }",
  "    ",
  "    method isExecutable { true }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            name.accept(visitor) from(newChain)",
  "            if (false != typeParams) then {",
  "                typeParams.accept(visitor) from(newChain)",
  "            }",
  "            annotations.do { each -> each.accept(visitor) from(newChain) }",
  "            value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (false != typeParams) then {",
  "            s := \"{s}{spc}Type parameters:\\n{typeParams.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (false != typeParams) then {",
  "            typeParams.toGrace(0)",
  "        }",
  "        s ++ \" = \" ++ value.toGrace(depth + 2)",
  "    }",
  "    method shallowCopy {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def methodNode = object {",
  "    method new(name, signature, body, dtype) scope(s) {",
  "        def result = new(name, signature, body, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "    ",
  "    class new(name', signature', body', dtype') {",
  "        // Represents a method declaration",
  "        // name' is the name of the method (an identifierNode),",
  "        // signature is a sequence of signatureParts,",
  "        // body is a sequence of statements and declarations,",
  "        // dtype is the declared return type of the method, or false.",
  "",
  "        inherits baseNode",
  "        def kind is public = \"method\"",
  "        var value is public := name'",
  "        var signature is public := signature'",
  "        var body is public := body'",
  "        var dtype is public := dtype'",
  "        var typeParams is public := false",
  "        var selfclosure is public := false",
  "        def nameString:String is public = value.value",
  "        var annotations is public := [ ]",
  "        var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "        var usesClassSyntax is public := false",
  "",
  "        method isMethod { true }",
  "        method isExecutable { false }",
  "        method isLegalInTrait { true }",
  "        method isClass { isFresh || usesClassSyntax }",
  "        method isTrait {",
  "            if (isFresh) then {",
  "                body.last.isTrait",
  "            } else {",
  "                false",
  "            }",
  "        }",
  "        method needsArgChecks {",
  "            signature.do { part -> ",
  "                part.params.do { p ->",
  "                    if ((false != p.dtype) && { ",
  "                            p.dtype.nameString != \"Unknown\" }) then {",
  "                        return true",
  "                    }",
  "                }",
  "            }",
  "            return false",
  "        }",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the synmol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method isConfidential {",
  "            if (annotations.size == 0) then { return false }",
  "            findAnnotation(self, \"confidential\")",
  "        }",
  "        method isPublic { isConfidential.not }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method returnsObject {",
  "            body.isEmpty.not && {body.last.returnsObject}",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            body.last.returnedObjectScope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMethod(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "                for (self.signature) do { part ->",
  "                    for (part.params) do { p ->",
  "                        p.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != dtype) then {",
  "                    dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                for (self.body) do { mx ->",
  "                    mx.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as){",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.body := listMap(body, blk) ancestors(newChain)",
  "            n.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            n.signature := listMap(signature, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "            s := s ++ \"\\n\"",
  "            if (false != self.dtype) then {",
  "                s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "                s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "            if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "            s := \"{s}{spc}Signature:\"",
  "            for (signature) do { part ->",
  "                s := \"{s}\\n  {spc}Part: {part.name}\"",
  "                s := \"{s}\\n    {spc}Parameters:\"",
  "                for (part.params) do { p ->",
  "                    s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "                }",
  "            }",
  "            s := s ++ \"\\n\"",
  "            if (false != typeParams) then {",
  "                s := \"{s}{spc}Generics:\"",
  "                typeParams.do {g->",
  "                    s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            if (annotations.size > 0) then {",
  "                s := \"{s}{spc}Annotations:\"",
  "                for (annotations) do {an->",
  "                    s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "                }",
  "                s := s ++ \"\\n\"",
  "            }",
  "            s := s ++ spc ++ \"Body:\"",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"method \"",
  "            var firstPart := true",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart && {false != typeParams}) then {",
  "                    s := s ++ typeParams.toGrace(depth + 1)",
  "                }",
  "                firstPart := false",
  "                if (part.params.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params.at(pnr)",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if (pnr < part.params.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            s := s ++ \" \\{\"",
  "            if (false != comments) then {",
  "                s := s ++ comments.toGrace(depth + 1)",
  "            }",
  "            for (self.body) do { mx ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            methodNode.new(value, signature, body, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isFresh := other.isFresh",
  "            selfclosure := other.selfclosure",
  "            self",
  "        }",
  "    }",
  "}",
  "def callNode = object {",
  "    method new(what, with) scope(s) {",
  "        def result = new(what, with)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(what, with') {",
  "        // requested as callNode.new(target:AstNode, parts:List)",
  "        // Represents a method request with arguments.",
  "        // The ‹target›.‹methodName› part is in `value`",
  "        // The argument list is in `with`, as a sequence of `callWithPart`s.",
  "        // [with]",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := emptySequence",
  "        //     }",
  "        //     object {",
  "        //         name := \"\"",
  "        //         args := emptySequence",
  "        //     }",
  "        //     ...",
  "        //     object {",
  "        //         ...",
  "        //     }",
  "        inherits baseNode",
  "        def kind is public = \"call\"",
  "        var value is public := what        // method being requested",
  "        var with is public := with'        // arguments",
  "        var generics is public := false",
  "        var isPattern is public := false",
  "        def nameString:String is public = value.nameString",
  "        ",
  "        method target { value }",
  "        method isCall { true }",
  "        method returnsObject {",
  "            if (value.isMember.not) then { return false }",
  "            if (value.nameString == \"clone\") then { return true }",
  "            if (value.nameString == \"copy\") then { return true }",
  "            return false",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            self.scope",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitCall(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.value.accept(visitor) from(newChain)",
  "                for (self.with) do { part ->",
  "                    for (part.args) do { arg ->",
  "                        arg.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "                if (false != generics) then {",
  "                    generics.do { each ->",
  "                        each.accept(visitor) from(newChain)",
  "                    }",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.with := listMap(with, blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ \"Method Name: {self.value.pretty(depth + 1)}\"",
  "            s := s ++ \"\\n\"",
  "            if (false != generics) then {",
  "                s := s ++ spc ++ \"  Generics:\\n\"",
  "                for (generics) do {g->",
  "                    s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "                }",
  "            }",
  "            s := s ++ spc ++ \"Arguments:\"",
  "            for (self.with) do { part ->",
  "                s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "                for (part.args) do { arg ->",
  "                    s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            repeat (depth) times {",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"\"",
  "            // only the last member is the method call we need to handle",
  "            if (self.value.kind == \"member\") then {",
  "                var member := self.value",
  "                if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                    s := member.value.substringFrom(7)to(member.value.size)",
  "                    return s ++ member.in.toGrace(0)",
  "                }",
  "                if (member.in.isSimple) then {",
  "                    s := \"{member.in.toGrace 0}.\"",
  "                } else {",
  "                    s := \"({member.in.toGrace 0}).\"",
  "                }",
  "            }",
  "            var firstPart := true",
  "            for (self.with) do { part ->",
  "                s := s ++ part.name",
  "                if (firstPart && {false != generics}) then {",
  "                    s := s ++ \"<\"",
  "                    for (1..(generics.size - 1)) do {ix ->",
  "                        s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                    }",
  "                    s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "                }",
  "                firstPart := false",
  "                if (part.args.size > 0) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.args.indices) do { anr ->",
  "                        var arg := part.args.at(anr)",
  "                        s := s ++ arg.toGrace(depth + 1)",
  "                        if (anr < part.args.size) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method asString { \"call {what.pretty(0)}\" }",
  "        method shallowCopy {",
  "            callNode.new(value, with).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            isPattern := other.isPattern",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "def moduleNode = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        def result = body(b)",
  "        result.name := n",
  "        result",
  "    }",
  "    class body(b) {",
  "        inherits objectNode.new(b, false)",
  "        def kind is public = \"module\"",
  "        def sourceLines = util.lines",
  "        line := 0       // because the module is always implicit",
  "        linePos := 0",
  "        var imports is public := [ ]",
  "",
  "        method isModule { true }",
  "        method returnsObject { false }",
  "        method externalsDo(action) {",
  "            value.do { o -> ",
  "                if (o.isExternal) then { action.apply(o) }",
  "            }",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitModule(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.superclass) then {",
  "                    self.superclass.accept(visitor) from(newChain)",
  "                }",
  "                for (self.value) do { x ->",
  "                    x.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            moduleNode.body(emptySeq).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            imports := other.imports",
  "            self",
  "        }",
  "    }",
  "}",
  "def objectNode is public = object {",
  "    method body(b) named(n) scope(s) {",
  "        def result = new(b, false)",
  "        result.name := n",
  "        result.scope := s",
  "        result",
  "    }",
  "    method body(b) named(n) {",
  "        body(b) named(n) scope(fakeSymbolTable)",
  "    }",
  "    class new(b, superclass') {",
  "        inherits baseNode",
  "        def kind is public = \"object\"",
  "        var value is public := b",
  "        var superclass is public := superclass'",
  "        var usedTraits is public := [ ]",
  "        var name:String is public := \"object\"",
  "        var inClass is public := false",
  "        var inTrait is public := false",
  "        var myLocalNames := false",
  "        var annotations is public := [ ]",
  "        ",
  "        method description -> String { ",
  "            if (isTrait) then { ",
  "                \"{kind} (trait)\" ",
  "            } elseif { inClass } then {",
  "                \"{kind} (class)\"",
  "            } else {",
  "                kind",
  "            }",
  "        }",
  "        method isTrait {",
  "            // answers true if this object qualifies to be a trait, whether",
  "            // or not it was declared with the trait syntax",
  "            if (inTrait) then { return true }",
  "            if (false != superclass) then { return false }",
  "            value.do { each -> ",
  "                if (each.isLegalInTrait.not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "                ",
  "        method localNames -> Set<String> { ",
  "            // answers the names of all of the methods defined directly in",
  "            // this object.  Inherited names are _not_ included.",
  "            if (false == myLocalNames) then {",
  "                myLocalNames := emptySet",
  "                value.do { node ->",
  "                    if (node.isFieldDec || node.isMethod) then {",
  "                        myLocalNames.add(node.nameString)",
  "                    }",
  "                }",
  "            }",
  "            myLocalNames",
  "        }",
  "        ",
  "        method parentsDo(action) {",
  "            // iterate over my superclass and my used traits",
  "",
  "            if (false != superclass) then { action.apply(superclass) }",
  "            usedTraits.do { t -> action.apply(t) }",
  "        }",
  "        ",
  "        method methodsDo(action) {",
  "            // iterate over my method declarations",
  "            ",
  "            value.do { o ->",
  "                if (o.isMethod) then { action.apply(o) }",
  "            }",
  "        }",
  "        ",
  "        method executableComponentsDo(action) {",
  "            // iterate over my executable code, including",
  "            // field declarations (since they may have initializers)",
  "            value.do { o ->",
  "                if (o.isExecutable) then { action.apply(o) }",
  "            }",
  "        }",
  "",
  "        method scope:=(st) {",
  "            // sets up the 2-way conection between this node",
  "            // and the symbol table that defines the scope that I open.",
  "            symbolTable := st",
  "            st.node := self",
  "        }",
  "        method body { value }",
  "        method returnsObject { true }",
  "        method returnedObjectScope { scope }",
  "        method canInherit { inTrait.not }   // an object can inherit if not in a trait",
  "        method canUse { true }",
  "        method isObject { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitObject(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != superclass) then {",
  "                    superclass.accept(visitor) from(newChain)",
  "                }",
  "                usedTraits.do { t -> t.accept(visitor) from(newChain) }",
  "                value.do { x -> x.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method nameString { ",
  "            if (name == \"object\") then {",
  "                \"object_on_line_{line}\"",
  "            } else {",
  "                name",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := listMap(value, blk) ancestors(newChain)",
  "            n.superclass := maybeMap(superclass, blk) ancestors(newChain)",
  "            n.usedTraits := listMap(usedTraits, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth') {",
  "            var depth := depth'",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            s := \"{s}\\n{spc}Name: {self.name}\"",
  "            if (false != self.superclass) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Superclass: \" ++ ",
  "                        self.superclass.pretty(depth + 1)",
  "            }",
  "            if (usedTraits.isEmpty.not) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Traits:\"",
  "                usedTraits.do { t -> ",
  "                    s := \"{s}\\n{spc}  {t.pretty(depth + 1)}\"",
  "                }",
  "            }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\"++ spc ++ x.pretty(depth + 1)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"object \\{\"",
  "            if (inTrait) then { s := s ++ \"   // trait\" }",
  "            if (inClass) then { s := s ++ \"   // class\" }",
  "            if (false != superclass) then { ",
  "                s := s ++ \"\\n\" ++ superclass.toGrace(depth + 1)",
  "            }",
  "            usedTraits.do { t -> s := s ++ \"\\n\" ++ t.toGrace(depth + 1) }",
  "            value.do { x ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "            }",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            name := other.name",
  "            value := other.value",
  "            superclass := other.superclass",
  "            usedTraits := other.usedTraits",
  "            inClass := other.inClass",
  "            inTrait := other.inTrait",
  "            annotations := other.annotations",
  "            self",
  "        }",
  "        method asString {",
  "            \"object {nameString}\"",
  "        }",
  "    }",
  "}",
  "def arrayNode is public = object {",
  "  class new(values) {",
  "    inherits baseNode",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitArray(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := listMap(value, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value.at(i).toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def memberNode = object {",
  "    method new(request, receiver) scope(s) {",
  "        def result = new(request, receiver)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(request, receiver) {",
  "        // Represents a dotted request ‹receiver›.‹request›",
  "        inherits baseNode",
  "        def kind is public = \"member\"",
  "        var value is public := request  // NB: value is a String, not an Identifier",
  "        var in is public := receiver",
  "        var generics is public := false",
  "",
  "        method target { in }",
  "        method nameString { value }",
  "        method isMember { true }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitMember(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != generics) then {",
  "                    generics.do { each -> each.accept(visitor) from(newChain) }",
  "                }",
  "                in.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.in := in.map(blk) ancestors(newChain)",
  "            n.generics := maybeListMap(generics, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\\n\"",
  "            s := s ++ spc ++ in.pretty(depth)",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := \"\"",
  "            if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := self.value.substringFrom(7)to(value.size)",
  "                s := s ++ \" \" ++ self.in.toGrace(0)",
  "            } else {",
  "                s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "        method asString { \"{in}.{value}\" }",
  "        method asIdentifier {",
  "            // make and return an identifiderNode for my request",
  "            if (fakeSymbolTable == scope) then {",
  "                ProgrammingError.raise \"asIdentifier requested on {pretty 0} when scope was fake\"",
  "            }",
  "            def resultNode = identifierNode.new (value, false) scope (scope)",
  "            resultNode.inRequest := true",
  "            resultNode.line := line",
  "            resultNode.linePos := linePos",
  "            return resultNode",
  "        }",
  "        method shallowCopy {",
  "            memberNode.new(value, nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def genericNode is public = object {",
  "  class new(base, arguments) {",
  "    // represents an application of a parameterized type to some arguments.",
  "    inherits baseNode",
  "    def kind is public = \"generic\"",
  "    var value is public := base        ",
  "        // in a generic application, `value` is the applied type",
  "        // e.g. in List<Number>, value is Identifier‹List›",
  "    var args is public := arguments",
  "    method nameString { value.nameString }",
  "    method asString { toGrace 0 }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitGeneric(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "            for (self.args) do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.args := listMap(args, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}({value.pretty(depth)})<\"",
  "        args.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := nameString ++ \"<\"",
  "        args.do { each -> s := s ++ each.toGrace(0) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        genericNode.new(value, args).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "",
  "def typeParametersNode is public = object {",
  "  class new(params') {",
  "    inherits baseNode",
  "    def kind is public = \"typeparams\"",
  "    var params is public := params'",
  "    method asString { toGrace 0 }",
  "    method declarationKindWithAncestors(as) { k.typeparam }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitTypeParameters(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            params.do { p ->",
  "                p.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method do(blk) {",
  "        params.do(blk)",
  "    }",
  "    method size { params.size }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.params := listMap(params, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := spc ++ super.pretty(depth) ++ \"<\"",
  "        params.do { each -> s := s ++ each.pretty(depth+2) }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method toGrace(depth:Number) -> String {",
  "        var s := \"<\"",
  "        params.do { each -> s := \"{s}{each.toGrace(depth)}\" }",
  "            separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method shallowCopy {",
  "        typeParametersNode.new(emptySeq).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def identifierNode = object {",
  "",
  "    method new(name, dtype) scope(s) {",
  "        def result = new(name, dtype)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"identifier\"",
  "        var value is public := name",
  "        var wildcard is public := false",
  "        var dtype is public := dtype'",
  "        var isBindingOccurrence is public := false",
  "        var isAssigned is public := false",
  "        var inRequest is public := false",
  "        var generics is public := false",
  "        var isDeclaredByParent is public := false",
  "",
  "        method nameString { value }     //  value changes when parsing \"[]\"",
  "        method quoted { value.quoted }",
  "        method isIdentifier { true }",
  "",
  "        method isAppliedOccurenceOfIdentifier {",
  "            if (wildcard) then { ",
  "                false ",
  "            } else {",
  "                isBindingOccurrence.not",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) {",
  "            as.parent.declarationKindWithAncestors(as)",
  "        }",
  "        method inTypePositionWithAncestors(as) {",
  "            // am I used by my parent node as a type?",
  "            // This is a hack, used as a subsitute for having information in the .gct",
  "            // telling us which identifiers represent types",
  "            if (as.isEmpty) then { return false }",
  "            as.parent.usesAsType(self)",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitIdentifier(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if ( wildcard ) then {",
  "                s := s ++ \" Wildcard\"",
  "            } elseif { isBindingOccurrence } then {",
  "                s := s ++ \"Binding‹{value}›\"",
  "            } else {",
  "                s := s ++ \"‹{value}›\"",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "                s := s ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "                for (generics) do {g->",
  "                    s := s ++ \"\\n\" ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "                }",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s",
  "            if(self.wildcard) then {",
  "                s := \"_\"",
  "            } else {",
  "                s := self.value",
  "            }",
  "            if (false != self.dtype) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "            }",
  "            if (false != generics) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            s",
  "        }",
  "",
  "        method asString { ",
  "            if (isBindingOccurrence) then {",
  "                \"identifierBinding‹{value}›\"",
  "            } else { ",
  "                \"identifier‹{value}›\"",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            identifierNode.new(value, false).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            wildcard := other.wildcard",
  "            isBindingOccurrence := other.isBindingOccurrence",
  "            isDeclaredByParent := other.isDeclaredByParent",
  "            isAssigned := other.isAssigned",
  "            inRequest := other.inRequest",
  "            self",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "def stringNode = object {",
  "    method new(v) scope(s) {",
  "        def result = new(v)",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(v) {",
  "        inherits baseNode",
  "        def kind is public = \"string\"",
  "        var value is public := v",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitString(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            def q = \"\\\"\"",
  "            q ++ value.quoted ++ q",
  "        }",
  "        method shallowCopy {",
  "            stringNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def numNode is public = object {",
  "    class new(val) {",
  "        inherits baseNode",
  "        def kind is public = \"num\"",
  "        var value is public := val",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitNum(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            \"{super.pretty(depth)}({self.value})\"",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            self.value.asString",
  "        }",
  "        method asString { \"num {value}\" }",
  "        method shallowCopy {",
  "            numNode.new(value).shallowCopyFieldsFrom(self)",
  "        }",
  "        method statementName { \"expression\" }",
  "    }",
  "}",
  "def opNode is public = object {",
  "  class new(op, l, r) {",
  "    inherits baseNode",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method isSimple { false }    // needs parens when used as reciever",
  "    method nameString { value }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitOp(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.left.accept(visitor) from(newChain)",
  "            self.right.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.left := left.map(blk) ancestors(newChain)",
  "        n.right := right.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new (value, false) scope (scope)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        return resultNode",
  "    }",
  "    method shallowCopy {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def bindNode is public = object {",
  "  class new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "    ",
  "    method isBind { true }",
  "    method asString { \"bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitBind(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.dest.accept(visitor) from(newChain)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.dest := dest.map(blk) ancestors(newChain)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"assignment or assigment request\" }",
  "  }",
  "}",
  "def defDecNode = object {",
  "    method new(name', val, dtype') scope(s) {",
  "        def result = new(name', val, dtype')",
  "        result.scope := s",
  "        result",
  "    }",
  "",
  "    class new(name', val, dtype') {",
  "        inherits baseNode",
  "        def kind is public = \"defdec\"",
  "        var name is public := name'",
  "        var value is public := val",
  "        var dtype is public := dtype'",
  "        def nameString:String is public = name.nameString",
  "        var annotations is public := [ ]",
  "        var startToken is public := false",
  "",
  "        method isPublic {",
  "            // defs are confidential by default",
  "            if (annotations.size == 0) then { return false }",
  "            if (findAnnotation(self, \"public\")) then { return true }",
  "            findAnnotation(self, \"readable\")",
  "        }",
  "        method isFieldDec { true }",
  "        method isWritable { false }",
  "        method isReadable { isPublic }",
  "",
  "        method returnsObject {",
  "            value.returnsObject",
  "        }",
  "        method returnedObjectScope {",
  "            // precondition: returnsObject",
  "            value.returnedObjectScope",
  "        }",
  "        method usesAsType(aNode) {",
  "            aNode == dtype",
  "        }",
  "        method declarationKindWithAncestors(as) { k.defdec }",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitDefDec(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                self.name.accept(visitor) from(newChain)",
  "                if (false != self.dtype) then {",
  "                    self.dtype.accept(visitor) from(newChain)",
  "                }",
  "                for (self.annotations) do { ann ->",
  "                    ann.accept(visitor) from(newChain)",
  "                }",
  "                value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.name := name.map(blk) ancestors(newChain)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "            n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth) ++ \"\\n\"",
  "            s := s ++ spc ++ self.name.pretty(depth)",
  "            if (false != dtype) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "            }",
  "            if (false != value) then {",
  "                s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "            }",
  "            if (annotations.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Annotations:\"",
  "                annotations.do { ann ->",
  "                    s := \"{s} {ann.pretty(depth + 2)}\"",
  "                }",
  "            }",
  "            if (false != comments) then {",
  "                s := s ++ comments.pretty(depth+2)",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var spc := \"\"",
  "            for (0..(depth - 1)) do { i ->",
  "                spc := spc ++ \"    \"",
  "            }",
  "            var s := \"def {self.name.toGrace(0)}\"",
  "            if ( (false != self.dtype) && {",
  "                    self.dtype.value != \"Unknown\" }) then {",
  "                s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "            }",
  "            if (self.annotations.size > 0) then {",
  "                s := s ++ \" is \"",
  "                s := s ++ self.annotations.fold{ a,b ->",
  "                    if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                        startingWith \"\"",
  "            }",
  "            if (false != self.value) then {",
  "                s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            startToken := other.startToken",
  "            self",
  "        }",
  "        method statementName { \"definition\" }",
  "    }",
  "}",
  "def varDecNode is public = object {",
  "  class new(name', val', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString:String is public = name.value",
  "    var annotations is public := [ ]",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { true }",
  "",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "",
  "    method declarationKindWithAncestors(as) { k.vardec }",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitVarDec(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.name.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            if (false != self.value) then {",
  "                self.value.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.name := name.map(blk) ancestors(newChain)",
  "        n.value := maybeMap(value, blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (false != self.dtype) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        if (false != comments) then {",
  "            s := s ++ comments.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        repeat (depth) times {",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if ( (false != self.dtype) && {",
  "                self.dtype.value != \"Unknown\" }) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.fold{ a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) }",
  "                    startingWith \"\"",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopy {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self)",
  "    }",
  "    method statementName { \"variable declaration\" }",
  "",
  "  }",
  "}",
  "def importNode is public = object {",
  "  class new(path', name', dtype') {",
  "    inherits baseNode",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := [ ]",
  "    var dtype is public := dtype'",
  "    method isImport { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (path) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKindWithAncestors(as) { k.defdec }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitImport(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            for (self.annotations) do { ann ->",
  "                ann.accept(visitor) from(newChain)",
  "            }",
  "            self.value.accept(visitor) from(newChain)",
  "            if (false != self.dtype) then {",
  "                self.dtype.accept(visitor) from(newChain)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        n.dtype := maybeMap(dtype, blk) ancestors(newChain)",
  "        n.annotations := listMap(annotations, blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopy {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def dialectNode is public = object {",
  "  class new(path') {",
  "    inherits baseNode",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "    ",
  "    method isDialect { true }",
  "    method isExternal { true }",
  "    method isExecutable { false }",
  "    method moduleName {",
  "        var bnm := \"\"",
  "        for (value) do {c->",
  "            if (c == \"/\") then {",
  "                bnm := \"\"",
  "            } else {",
  "                bnm := bnm ++ c",
  "            }",
  "        }",
  "        bnm",
  "    }",
  "    method path {",
  "        value",
  "    }",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        visitor.visitDialect(self) up(as)",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopy {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def returnNode is public = object {",
  "  class new(expr) {",
  "    inherits baseNode",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(as) {",
  "        if (visitor.visitReturn(self) up(as)) then {",
  "            def newChain = as.extend(self)",
  "            self.value.accept(visitor) from(newChain)",
  "        }",
  "    }",
  "    method map(blk) ancestors(as) {",
  "        var n := shallowCopy",
  "        def newChain = as.extend(n)",
  "        n.value := value.map(blk) ancestors(newChain)",
  "        blk.apply(n, as)",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopy {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "    }",
  "  }",
  "}",
  "def inheritsNode = object {",
  "    method new(expr) scope(s) {",
  "        def result = new(expr)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class new(expr) {",
  "        inherits baseNode",
  "        def kind is public = \"inherits\"",
  "        var value is public := expr",
  "        var providedNames is public := emptySet",
  "        var aliases is public := [ ]",
  "        var exclusions is public := [ ]",
  "        var isUse is public := false  // this is a `use trait` clause, not an inherits",
  "        ",
  "        method isLegalInTrait { isUse }",
  "        method isInherits { true }",
  "        method inheritsFromMember { value.isMember }",
  "        method inheritsFromCall { value.isCall }",
  "        method isExecutable { false }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitInherits(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                value.accept(visitor) from(newChain)",
  "                aliases.do { a ->",
  "                    a.newName.accept(visitor) from(newChain)",
  "                    a.oldName.accept(visitor) from(newChain)",
  "                }",
  "                exclusions.do { e -> e.accept(visitor) from(newChain) }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { ",
  "            // identifiers declared in an inherits statement are aliases for ",
  "            // methods.  We treat them as methods, because (unlike inherited names)",
  "            // they can't be overridden by local methods.",
  "            k.methdec",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.value := value.map(blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := super.pretty(depth)",
  "            if (isUse) then { s := \"{s} (use)\" }",
  "            s := s ++ \"\\n\" ++ spc ++ self.value.pretty(depth + 1)",
  "            aliases.do { a ->",
  "                s := \"{s}\\n{a.pretty(depth)}\"",
  "            }",
  "            if (exclusions.isEmpty.not) then { s := \"{s}\\n{spc}\" }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e} \"",
  "            }",
  "            if (providedNames.isEmpty.not) then {",
  "                s := s ++ \"\\n{spc}Provided names: {providedNames.asList.sort}\"",
  "            }",
  "            s",
  "        }",
  "        method toGrace(depth : Number) -> String {",
  "            var s := if (isUse) then { \"use \" } else { \"inherit \" }",
  "            s := s ++ self.value.toGrace(0)",
  "            aliases.do { a ->",
  "                s := \"{s} {a} \"",
  "            }",
  "            exclusions.do { e ->",
  "                s := \"{s} exclude {e.nameString} \"",
  "            }",
  "            s",
  "        }",
  "        method asString {",
  "            if (isUse) then { \"use \" } else { \"inherit \" } ++ value.toGrace 0",
  "        }",
  "        method nameString { value.toGrace(0) }",
  "        method addAlias (newName) for (oldName) {",
  "            aliases.push(aliasNew(newName) old(oldName))",
  "        }",
  "        method addExclusion(methName) {",
  "            exclusions.push(methName)",
  "        }",
  "        method shallowCopy {",
  "            inheritsNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            providedNames := other.providedNames",
  "            aliases := other.aliases",
  "            exclusions := other.exclusions",
  "            isUse := other.isUse",
  "            self",
  "        }",
  "        method statementName { ",
  "            if (isUse) then { \"use\" } else { \"inherit\" }",
  "        }",
  "    }",
  "}",
  "type AliasPair = {",
  "    newName",
  "    oldName",
  "}",
  "",
  "class aliasNew(n) old(o) {",
  "    method newName {n}",
  "    method oldName {o}",
  "    method asString { \"alias {n.nameString} = {o.nameString}\" }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        \"{spc}  alias {n.pretty(depth)} = {o.pretty(depth)}\"",
  "    }",
  "    method hash { (n.hash * 1171) + o.hash }",
  "    method isExecutable { false }",
  "    method == (other) {",
  "        match (other)",
  "            case { that:AliasPair -> (n == that.newName) && (o == that.oldName) }",
  "            case { _ -> false }",
  "    }",
  "}",
  "def blankNode is public = object {",
  "    class new {",
  "        inherits baseNode",
  "        def kind is public = \"blank\"",
  "        def value is public = \"blank\"",
  "        method isExecutable { false }",
  "",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitBlank(self) up(as)",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method nameString { \"\" }",
  "        method asString { \"blank\" }",
  "        method toGrace(depth : Number) -> String { \"\" }",
  "        method shallowCopy {",
  "            blankNode.new.shallowCopyFieldsFrom(self)",
  "        }",
  "    }",
  "}",
  "def signaturePart = object {",
  "    method new {",
  "        partName \"\" params []",
  "    }",
  "    method partName(n) scope(s) {",
  "        def result = partName(n) params []",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) params(ps) scope(s) {",
  "        def result = partName(n) params(ps)",
  "        result.scope := s",
  "        result",
  "    }",
  "    method partName(n) {",
  "        partName(n) params []",
  "    }",
  "    class partName(n) params(ps) {",
  "        inherits baseNode",
  "        def kind is public = \"signaturepart\"",
  "        var name is public := n",
  "        var params is public := ps",
  "        var typeParams is public := false",
  "        var lineLength is public := 0",
  "",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            if (visitor.visitSignaturePart(self) up(as)) then {",
  "                def newChain = as.extend(self)",
  "                params.do { p -> p.accept(visitor) from(newChain) }",
  "                if (false != typeParams) then {",
  "                    typeParams.accept(visitor) from(newChain)",
  "                }",
  "            }",
  "        }",
  "        method declarationKindWithAncestors(as) { k.parameter }",
  "        method map(blk) ancestors(as) {",
  "            var nd := shallowCopy",
  "            def newChain = as.extend(nd)",
  "            nd.params := listMap(params, blk) ancestors(newChain)",
  "            nd.typeParams := maybeMap(typeParams, blk) ancestors(newChain)",
  "            blk.apply(nd, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            for (0..depth) do { i ->",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            if (params.isEmpty.not) then { s := \"{s}\\n{spc}Parameters:\" }",
  "            for (params) do { p ->",
  "                s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "            }",
  "            if (false != typeParams) then {",
  "                s := \"{s}\\n  {spc}TypeParams: {typeParams.pretty(depth + 1)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            signaturePart.partName(name) params(params)",
  "                .shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            typeParams := other.typeParams",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method asString {",
  "            \"part: {name}\"",
  "        }",
  "    }",
  "}",
  "",
  "def callWithPart = object {",
  "    method new {",
  "        request \"\" withArgs( [] )",
  "    }",
  "    method request(name) withArgs(argList) scope (s) {",
  "        def result = request(name) withArgs(argList)",
  "        result.scope := s",
  "        result",
  "    }",
  "    class request(rPart:String) withArgs(xs) {",
  "        inherits baseNode",
  "        def kind is public = \"callwithpart\"",
  "        var name is public := rPart",
  "        var args is public := xs",
  "        var lineLength is public := 0",
  "",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            n.args := listMap(args, blk) ancestors(newChain)",
  "            blk.apply(n, as)",
  "        }",
  "        method pretty(depth) {",
  "            var spc := \"\"",
  "            repeat (depth+1) times {",
  "                spc := spc ++ \"  \"",
  "            }",
  "            var s := \"{super.pretty(depth)}: {name}\"",
  "            s := \"{s}\\n    {spc}Args:\"",
  "            for (args) do { a ->",
  "                s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "            }",
  "            s",
  "        }",
  "        method shallowCopy {",
  "            callWithPart.request(name) withArgs(args).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            lineLength := other.lineLength",
  "            self",
  "        }",
  "        method statementName { \"request\" }",
  "    }",
  "}",
  "",
  "def commentNode = object {",
  "    class new(val') {",
  "        inherits baseNode",
  "        def kind is public = \"comment\"",
  "        var value:String is public := val'",
  "        var isPartialLine:Boolean is public := false",
  "        var isPreceededByBlankLine is public := false",
  "        var endLine is public := util.linenum",
  "        method isComment { true }",
  "        method isLegalInTrait { true }",
  "        method isExecutable { false }",
  "        method asString { \"comment ({line}–{endLine}): {value}\" }",
  "        method extendCommentUsing(cmtNode) {",
  "            value := value ++ \" \" ++ cmtNode.value",
  "            endLine := cmtNode.endLine",
  "        }",
  "        method map(blk) ancestors(as) {",
  "            var n := shallowCopy",
  "            def newChain = as.extend(n)",
  "            blk.apply(n, as)",
  "        }",
  "        method accept(visitor : ASTVisitor) from(as) {",
  "            visitor.visitComment(self) up(as)",
  "        }",
  "        method pretty(depth) {",
  "            var s := \"\\n\"",
  "            repeat (depth-1) times {",
  "                s := s ++ \"  \"",
  "            }",
  "            def pb = if (isPreceededByBlankLine) then { \" > blank\" } else { \"\" }",
  "            \"{s}Comment{pb}({line}–{endLine}): ‹{value}›\"",
  "        }",
  "        method toGrace(depth) {",
  "            // Partial line comments don't start with a newline, whereas",
  "            // full-line comments do.  No newline at end in either case.",
  "            if (isPartialLine) then {",
  "                \"// (partial) {value}\"",
  "            } else {",
  "                var spc := \"\"",
  "                repeat (depth) times { spc := spc ++ \"    \" }",
  "                wrap(value) to (lineLength) prefix (spc ++ \"// \")",
  "            }",
  "        }",
  "        method shallowCopy {",
  "            commentNode.new(nullNode).shallowCopyFieldsFrom(self)",
  "        }",
  "        method shallowCopyFieldsFrom(other) {",
  "            super.shallowCopyFieldsFrom(other)",
  "            value := other.value",
  "            isPartialLine := other.isPartialLine",
  "            endLine := other.endLine",
  "            self",
  "        }",
  "    }",
  "}",
  "",
  "method wrap(str:String) to (l:Number) prefix (margin:String) {",
  "    def ind = margin.size",
  "    def len = max(ind + 4, l)",
  "    if ((ind + str.size) <= len) then {",
  "        return \"\\n\" ++ margin ++ str",
  "    }",
  "    var currBreak ",
  "    var trimmedLine",
  "",
  "    try {",
  "        currBreak := str.lastIndexOf \" \" startingAt (len - ind)",
  "            ifAbsent {len - ind}",
  "        trimmedLine := str.substringFrom (1) to (currBreak).trim",
  "    } catch { ex:NoSuchMethod ->  // C string libraries lack methods",
  "        currBreak := min(len - ind, str.size)",
  "        (1..currBreak).do { ix ->",
  "            if (str.at(ix) == \" \") then { currBreak := ix }",
  "        }",
  "        var end := currBreak",
  "        while {(end >= 1) && {str.at(end) == \" \"}} do {",
  "            end := end - 1",
  "        }",
  "        var start := 1",
  "        while {(start <= str.size) && {str.at(start) == \" \"}} do {",
  "            start := start + 1",
  "        }",
  "        trimmedLine := str.substringFrom (start) to (end)",
  "    }",
  "    \"\\n\" ++ margin ++ trimmedLine ++",
  "        wrap(str.substringFrom (currBreak+1) to (str.size))",
  "            to (l) prefix (margin)",
  "}",
  "",
  "",
  "type ASTVisitor = {",
  "     visitIf(o) up(as) -> Boolean",
  "     visitBlock(o) up(as) -> Boolean",
  "     visitMatchCase(o) up(as) -> Boolean",
  "     visitTryCatch(o) up(as) -> Boolean",
  "     visitMethodType(o) up(as) -> Boolean",
  "     visitSignaturePart(o) up(as) -> Boolean",
  "     visitTypeLiteral(o) up(as) -> Boolean",
  "     visitTypeParameters(o) up(as) -> Boolean",
  "     visitTypeDec(o) up(as) -> Boolean",
  "     visitMethod(o) up(as) -> Boolean",
  "     visitCall(o) up(as) -> Boolean",
  "     visitObject(o) up(as) -> Boolean",
  "     visitModule(o) up(as) -> Boolean",
  "     visitArray(o) up(as) -> Boolean",
  "     visitMember(o) up(as) -> Boolean",
  "     visitGeneric(o) up(as) -> Boolean",
  "     visitIdentifier(o) up(as) -> Boolean",
  "     visitString(o) up(as) -> Boolean",
  "     visitNum(o) up(as) -> Boolean",
  "     visitOp(o) up(as) -> Boolean",
  "     visitBind(o) up(as) -> Boolean",
  "     visitDefDec(o) up(as) -> Boolean",
  "     visitVarDec(o) up(as) -> Boolean",
  "     visitImport(o) up(as) -> Boolean",
  "     visitReturn(o) up(as) -> Boolean",
  "     visitInherits(o) up(as) -> Boolean",
  "     visitDialect(o) up(as) -> Boolean",
  "     visitBlank(o) up(as) -> Boolean",
  "     visitComment(o) up(as) -> Boolean",
  "}",
  "",
  "class baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(as) { visitIf(o) }",
  "    method visitBlock(o) up(as) { visitBlock(o) }",
  "    method visitMatchCase(o) up(as) { visitMatchCase(o) }",
  "    method visitTryCatch(o) up(as) { visitTryCatch(o) }",
  "    method visitMethodType(o) up(as) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(as) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(as) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(as) { visitTypeLiteral(o) }",
  "    method visitTypeParameters(o) up(as) { visitTypeParameters(o) }",
  "    method visitMethod(o) up(as) { visitMethod(o) }",
  "    method visitCall(o) up(as) { visitCall(o) }",
  "    method visitObject(o) up(as) { visitObject(o) }",
  "    method visitModule(o) up(as) { visitObject(o) }",
  "    method visitArray(o) up(as) { visitArray(o) }",
  "    method visitMember(o) up(as) { visitMember(o) }",
  "    method visitGeneric(o) up(as) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(as) { visitIdentifier(o) }",
  "    method visitString(o) up(as) { visitString(o) }",
  "    method visitNum(o) up(as) { visitNum(o) }",
  "    method visitOp(o) up(as) { visitOp(o) }",
  "    method visitBind(o) up(as) { visitBind(o) }",
  "    method visitDefDec(o) up(as) { visitDefDec(o) }",
  "    method visitVarDec(o) up(as) { visitVarDec(o) }",
  "    method visitImport(o) up(as) { visitImport(o) }",
  "    method visitReturn(o) up(as) { visitReturn(o) }",
  "    method visitInherits(o) up(as) { visitInherits(o) }",
  "    method visitDialect(o) up(as) { visitDialect(o) }",
  "    method visitBlank(o) up(as) { visitBlank(o) }",
  "    method visitComment(o) up(as) { visitComment(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitTryCatch(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitTypeParameters(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitModule(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "    method visitBlank(o) -> Boolean { true }",
  "    method visitComment(o) -> Boolean { true }",
  "    ",
  "    method asString { \"an AST visitor\" }",
  "}",
  "",
  "class pluggableVisitor(visitation:Block2) -> ASTVisitor {",
  "    // Manufactures a default visitor, given a 2-parameter block.",
  "    // Typically, some of the methods will be overridden.",
  "    // The block will be applied with the AST node as the first argument",
  "    // and the ancestor chain as the second, and should answer true if",
  "    // the visitation is to continue and false if it is to go no deeper.",
  "",
  "    method visitIf(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlock(o) up(as) { visitation.apply (o, as) }",
  "    method visitMatchCase(o) up(as) { visitation.apply (o, as) }",
  "    method visitTryCatch(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethodType(o) up(as) { visitation.apply (o, as) }",
  "    method visitSignaturePart(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitTypeLiteral(o) up(as) { visitation.apply (o, as) }",
  "    method visitMethod(o) up(as) { visitation.apply (o, as) }",
  "    method visitCall(o) up(as) { visitation.apply (o, as) }",
  "    method visitObject(o) up(as) { visitation.apply (o, as) }",
  "    method visitModule(o) up(as) { visitation.apply (o, as) }",
  "    method visitArray(o) up(as) { visitation.apply (o, as) }",
  "    method visitMember(o) up(as) { visitation.apply (o, as) }",
  "    method visitGeneric(o) up(as) { visitation.apply (o, as) }",
  "    method visitIdentifier(o) up(as) { visitation.apply (o, as) }",
  "    method visitString(o) up(as) { visitation.apply (o, as) }",
  "    method visitNum(o) up(as) { visitation.apply (o, as) }",
  "    method visitOp(o) up(as) { visitation.apply (o, as) }",
  "    method visitBind(o) up(as) { visitation.apply (o, as) }",
  "    method visitDefDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitVarDec(o) up(as) { visitation.apply (o, as) }",
  "    method visitImport(o) up(as) { visitation.apply (o, as) }",
  "    method visitReturn(o) up(as) { visitation.apply (o, as) }",
  "    method visitInherits(o) up(as) { visitation.apply (o, as) }",
  "    method visitDialect(o) up(as) { visitation.apply (o, as) }",
  "    method visitBlank(o) up(as) { visitation.apply (o, as) }",
  "    method visitComment(o) up(as) { visitation.apply (o, as) }",
  "    ",
  "    method asString { \"a pluggable AST visitor\" }",
  "}",
  "",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(as) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\") && {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_31(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_32(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_33(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_symbolTable_34(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_comments_35(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_407(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_841(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_954(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_955(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_963(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_966(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_984(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_1057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_node_1058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_node_1058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_1125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1128(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1129(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1130(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_1131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_1131(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_1132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_1132(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_1133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_1133(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1487(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1489(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1490(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1492(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1493(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1493(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1494(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1494(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1945(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1948(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1949(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_1951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_1951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_1952(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_1952(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2261(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_2263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_2263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_2264(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_2264(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2570(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2570(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_2571(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_2571(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_rtype_2572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_rtype_2572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_typeParams_2573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_typeParams_2573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_2574(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_2988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_2993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_2993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_2994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_2994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_2995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_2995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_2996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_2996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_2997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_2997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3305(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_3306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_3306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_3307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_3307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_3308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_3309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_3309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_typeParams_3310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_typeParams_3310(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3631(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_3641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_3642(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_3642(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_3643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_3643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_3644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_typeParams_3645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_typeParams_3645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_selfclosure_3646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_selfclosure_3646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_nameString_3647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object reader_ast_annotations_3648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_3648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_isFresh_3649(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_isFresh_3649(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_usesClassSyntax_3650(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_usesClassSyntax_3650(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_4573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4581(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4582(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_4583(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_with_4584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_with_4584(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_4585(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_4585(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_4586(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_4586(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_4587(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_5120(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5135(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5136(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_sourceLines_5137(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_imports_5138(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_imports_5138(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_5210(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5224(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5225(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5226(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5226(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_5227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_5227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_usedTraits_5228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_usedTraits_5228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_name_5229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_name_5229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inClass_5230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inClass_5230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inTrait_5231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inTrait_5231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_myLocalNames_5232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_myLocalNames_5232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_5233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_5233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_5823(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5827(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5828(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_5958(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5966(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5967(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_5969(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_in_5969(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_5970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_5970(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_6309(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6312(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6313(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6314(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6314(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_6315(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_6315(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_6470(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6473(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6474(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_params_6475(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_params_6475(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6633(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6642(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6643(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_6644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_6644(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_6645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6645(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_6646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_6646(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_6647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_6647(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_6648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_6648(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_6649(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_6649(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_6650(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_6650(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_7034(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7109(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7177(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7180(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7183(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7183(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7184(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7184(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_7451(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7455(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_7456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_7456(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7457(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7457(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7626(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7634(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7635(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7636(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7636(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7637(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7638(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_7639(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_7640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_7640(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_7641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_7641(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_8092(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8095(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8550(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8553(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8554(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_8556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_8556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_8557(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_8557(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_8558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_8558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_8830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_8946(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8949(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9045(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9047(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9047(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_aliases_9048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_aliases_9048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_exclusions_9049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_exclusions_9049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isUse_9050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isUse_9050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9417(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9420(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9421(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9422(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_9457(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9480(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9481(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9482(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9482(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_9483(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_9483(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_typeParams_9484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_typeParams_9484(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_lineLength_9485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_lineLength_9485(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_9717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9730(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9731(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9732(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9732(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_9733(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_9733(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_9734(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_9734(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_9868(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9873(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_isPartialLine_9874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_isPartialLine_9874(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_isPreceededByBlankLine_9875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_isPreceededByBlankLine_9875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_endLine_9876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_endLine_9876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_10077(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass29;
static Object strlit106;
static Object strlit113;
static Object strlit119;
static Object strlit125;
static Object strlit181;
static Object strlit190;
static Object strlit201;
static Object strlit217;
static Object strlit226;
static Object strlit233;
static Object strlit242;
static Object strlit247;
static Object strlit254;
static Object strlit261;
static Object strlit267;
static Object strlit284;
static Object strlit292;
static Object strlit299;
static Object strlit306;
static Object strlit312;
static Object strlit320;
static Object strlit329;
static Object strlit336;
static Object strlit343;
static Object strlit349;
static Object strlit398;
static ClassData objclass406;
static Object strlit412;
static Object strlit419;
static Object strlit425;
static Object strlit431;
static Object strlit440;
static Object strlit447;
static Object strlit454;
static Object strlit461;
static Object strlit465;
static Object strlit506;
static Object strlit540;
static Object strlit547;
static Object strlit581;
static Object strlit600;
static Object strlit630;
static Object strlit659;
static Object strlit684;
static ClassData objclass689;
static Object strlit837;
static ClassData objclass840;
static Object strlit927;
static Object strlit947;
static ClassData objclass953;
Object module_util;
Object module_util_init();
Object module_identifierKinds;
Object module_identifierKinds_init();
static ClassData objclass962;
static ClassData objclass965;
static Object strlit970;
static ClassData objclass983;
static Object strlit995;
static Object strlit1007;
static Object strlit1022;
static ClassData objclass1040;
static Object strlit1044;
static Object strlit1046;
static Object strlit1054;
static ClassData objclass1056;
static Object strlit1060;
static Object strlit1064;
static Object strlit1069;
static Object strlit1074;
static Object strlit1080;
static Object strlit1093;
static Object strlit1097;
static Object strlit1106;
static Object strlit1112;
static Object strlit1119;
static ClassData objclass1124;
static ClassData objclass1127;
static Object strlit1180;
static Object strlit1189;
static Object strlit1196;
static Object strlit1217;
static Object strlit1223;
static Object strlit1230;
static Object strlit1242;
static Object strlit1253;
static Object strlit1265;
static Object strlit1275;
static Object strlit1300;
static Object strlit1309;
static Object strlit1314;
static Object strlit1339;
static Object strlit1348;
static Object strlit1353;
static Object strlit1360;
static Object strlit1369;
static Object strlit1388;
static Object strlit1393;
static Object strlit1408;
static Object strlit1413;
static Object strlit1435;
static Object strlit1440;
static Object strlit1450;
static Object strlit1455;
static Object strlit1479;
static ClassData objclass1483;
static ClassData objclass1486;
static Object strlit1638;
static Object strlit1647;
static Object strlit1654;
static Object strlit1660;
static Object strlit1683;
static Object strlit1692;
static Object strlit1697;
static Object strlit1720;
static Object strlit1736;
static Object strlit1741;
static Object strlit1761;
static Object strlit1768;
static Object strlit1781;
static Object strlit1787;
static Object strlit1798;
static Object strlit1821;
static Object strlit1829;
static Object strlit1851;
static Object strlit1856;
static Object strlit1876;
static Object strlit1881;
static Object strlit1891;
static Object strlit1896;
static Object strlit1928;
static Object strlit1929;
static ClassData objclass1944;
static ClassData objclass1947;
static Object strlit2019;
static Object strlit2028;
static Object strlit2035;
static Object strlit2041;
static Object strlit2066;
static Object strlit2077;
static Object strlit2082;
static Object strlit2086;
static Object strlit2107;
static Object strlit2120;
static Object strlit2125;
static Object strlit2129;
static Object strlit2140;
static Object strlit2153;
static Object strlit2160;
static Object strlit2172;
static Object strlit2189;
static Object strlit2192;
static Object strlit2197;
static Object strlit2225;
static Object strlit2228;
static Object strlit2233;
static Object strlit2253;
static ClassData objclass2256;
static ClassData objclass2259;
static Object strlit2334;
static Object strlit2343;
static Object strlit2350;
static Object strlit2377;
static Object strlit2388;
static Object strlit2393;
static Object strlit2397;
static Object strlit2418;
static Object strlit2431;
static Object strlit2436;
static Object strlit2440;
static Object strlit2451;
static Object strlit2464;
static Object strlit2471;
static Object strlit2480;
static Object strlit2497;
static Object strlit2500;
static Object strlit2505;
static Object strlit2533;
static Object strlit2536;
static Object strlit2541;
static Object strlit2561;
static ClassData objclass2564;
static ClassData objclass2567;
static Object strlit2677;
static Object strlit2686;
static Object strlit2693;
static Object strlit2699;
static Object strlit2706;
static Object strlit2711;
static Object strlit2715;
static Object strlit2731;
static Object strlit2744;
static Object strlit2749;
static Object strlit2754;
static Object strlit2758;
static Object strlit2776;
static Object strlit2781;
static Object strlit2785;
static Object strlit2804;
static Object strlit2809;
static Object strlit2813;
static Object strlit2825;
static Object strlit2836;
static Object strlit2841;
static Object strlit2845;
static Object strlit2856;
static Object strlit2897;
static Object strlit2931;
static Object strlit2938;
static Object strlit2962;
static Object strlit2981;
static ClassData objclass2987;
static ClassData objclass2990;
static Object strlit3009;
static Object strlit3016;
static Object strlit3022;
static Object strlit3084;
static Object strlit3093;
static Object strlit3100;
static Object strlit3106;
static Object strlit3110;
static Object strlit3133;
static Object strlit3142;
static Object strlit3147;
static Object strlit3169;
static Object strlit3178;
static Object strlit3183;
static Object strlit3196;
static Object strlit3202;
static Object strlit3204;
static Object strlit3222;
static Object strlit3227;
static Object strlit3250;
static Object strlit3255;
static Object strlit3265;
static Object strlit3294;
static Object strlit3297;
static ClassData objclass3300;
static ClassData objclass3303;
static Object strlit3337;
static Object strlit3427;
static Object strlit3436;
static Object strlit3443;
static Object strlit3449;
static Object strlit3475;
static Object strlit3488;
static Object strlit3493;
static Object strlit3497;
static Object strlit3506;
static Object strlit3526;
static Object strlit3550;
static Object strlit3563;
static Object strlit3569;
static Object strlit3571;
static Object strlit3577;
static Object strlit3604;
static Object strlit3621;
static ClassData objclass3630;
static ClassData objclass3638;
static Object strlit3688;
static Object strlit3734;
static Object strlit3906;
static Object strlit3915;
static Object strlit3922;
static Object strlit3938;
static Object strlit3947;
static Object strlit3959;
static Object strlit3964;
static Object strlit3974;
static Object strlit3993;
static Object strlit4001;
static Object strlit4006;
static Object strlit4010;
static Object strlit4022;
static Object strlit4029;
static Object strlit4034;
static Object strlit4038;
static Object strlit4047;
static Object strlit4052;
static Object strlit4056;
static Object strlit4068;
static Object strlit4079;
static Object strlit4084;
static Object strlit4088;
static Object strlit4101;
static Object strlit4113;
static Object strlit4118;
static Object strlit4122;
static Object strlit4132;
static Object strlit4140;
static Object strlit4145;
static Object strlit4149;
static Object strlit4162;
static Object strlit4176;
static Object strlit4181;
static Object strlit4185;
static Object strlit4197;
static Object strlit4208;
static Object strlit4213;
static Object strlit4217;
static Object strlit4228;
static Object strlit4233;
static Object strlit4256;
static Object strlit4284;
static Object strlit4297;
static Object strlit4303;
static Object strlit4353;
static Object strlit4387;
static Object strlit4394;
static Object strlit4409;
static Object strlit4418;
static Object strlit4434;
static Object strlit4449;
static Object strlit4453;
static Object strlit4456;
static Object strlit4459;
static Object strlit4467;
static Object strlit4504;
static Object strlit4509;
static Object strlit4519;
static Object strlit4524;
static Object strlit4560;
static ClassData objclass4572;
static ClassData objclass4580;
static Object strlit4604;
static Object strlit4614;
static Object strlit4702;
static Object strlit4711;
static Object strlit4718;
static Object strlit4725;
static Object strlit4737;
static Object strlit4747;
static Object strlit4759;
static Object strlit4772;
static Object strlit4783;
static Object strlit4795;
static Object strlit4812;
static Object strlit4817;
static Object strlit4840;
static Object strlit4851;
static Object strlit4856;
static Object strlit4862;
static Object strlit4865;
static Object strlit4876;
static Object strlit4909;
static Object strlit4918;
static Object strlit4923;
static Object strlit4932;
static Object strlit4962;
static Object strlit4998;
static Object strlit5027;
static Object strlit5061;
static Object strlit5068;
static Object strlit5076;
static Object strlit5083;
static Object strlit5103;
static Object strlit5110;
static ClassData objclass5119;
static ClassData objclass5134;
static Object strlit5197;
static ClassData objclass5209;
static ClassData objclass5223;
static Object strlit5239;
static Object strlit5245;
static Object strlit5252;
static Object strlit5258;
static Object strlit5432;
static Object strlit5438;
static Object strlit5444;
static Object strlit5487;
static Object strlit5496;
static Object strlit5505;
static Object strlit5512;
static Object strlit5517;
static Object strlit5521;
static Object strlit5547;
static Object strlit5552;
static Object strlit5567;
static Object strlit5572;
static Object strlit5582;
static Object strlit5593;
static Object strlit5598;
static Object strlit5602;
static Object strlit5628;
static Object strlit5639;
static Object strlit5652;
static Object strlit5658;
static Object strlit5663;
static Object strlit5671;
static Object strlit5693;
static Object strlit5710;
static Object strlit5731;
static Object strlit5736;
static Object strlit5748;
static Object strlit5753;
static Object strlit5798;
static Object strlit5804;
static Object strlit5813;
static Object strlit5815;
static ClassData objclass5822;
static ClassData objclass5825;
static Object strlit5862;
static Object strlit5871;
static Object strlit5895;
static Object strlit5904;
static Object strlit5932;
static Object strlit5939;
static Object strlit5954;
static ClassData objclass5957;
static ClassData objclass5965;
static Object strlit6029;
static Object strlit6038;
static Object strlit6045;
static Object strlit6052;
static Object strlit6058;
static Object strlit6082;
static Object strlit6087;
static Object strlit6104;
static Object strlit6109;
static Object strlit6119;
static Object strlit6122;
static Object strlit6149;
static Object strlit6159;
static Object strlit6176;
static Object strlit6212;
static Object strlit6231;
static Object strlit6238;
static Object strlit6244;
static Object strlit6258;
static Object strlit6265;
static Object strlit6297;
static Object strlit6304;
static ClassData objclass6308;
static ClassData objclass6311;
static Object strlit6369;
static Object strlit6378;
static Object strlit6384;
static Object strlit6406;
static Object strlit6415;
static Object strlit6420;
static Object strlit6439;
static Object strlit6448;
static Object strlit6466;
static ClassData objclass6469;
static ClassData objclass6472;
static Object strlit6526;
static Object strlit6535;
static Object strlit6542;
static Object strlit6567;
static Object strlit6576;
static Object strlit6580;
static Object strlit6585;
static Object strlit6592;
static Object strlit6596;
static Object strlit6606;
static Object strlit6615;
static Object strlit6629;
static ClassData objclass6632;
static ClassData objclass6640;
static Object strlit6725;
static Object strlit6734;
static Object strlit6746;
static Object strlit6755;
static Object strlit6761;
static Object strlit6769;
static Object strlit6775;
static Object strlit6789;
static Object strlit6794;
static Object strlit6820;
static Object strlit6825;
static Object strlit6845;
static Object strlit6850;
static Object strlit6863;
static Object strlit6886;
static Object strlit6899;
static Object strlit6935;
static Object strlit6957;
static Object strlit6963;
static Object strlit6967;
static Object strlit6973;
static Object strlit7008;
static Object strlit7015;
static Object strlit7025;
static Object strlit7030;
static ClassData objclass7033;
static ClassData objclass7041;
static Object strlit7057;
static Object strlit7064;
static Object strlit7070;
static Object strlit7076;
static Object strlit7095;
static Object strlit7102;
static ClassData objclass7105;
static ClassData objclass7108;
static Object strlit7124;
static Object strlit7131;
static Object strlit7137;
static Object strlit7149;
static Object strlit7155;
static Object strlit7166;
static Object strlit7173;
static ClassData objclass7176;
static ClassData objclass7179;
static Object strlit7224;
static Object strlit7233;
static Object strlit7240;
static Object strlit7247;
static Object strlit7253;
static Object strlit7259;
static Object strlit7279;
static Object strlit7299;
static Object strlit7313;
static Object strlit7322;
static Object strlit7331;
static Object strlit7343;
static Object strlit7355;
static Object strlit7362;
static Object strlit7381;
static Object strlit7390;
static Object strlit7400;
static Object strlit7447;
static ClassData objclass7450;
static ClassData objclass7453;
static Object strlit7462;
static Object strlit7468;
static Object strlit7505;
static Object strlit7514;
static Object strlit7521;
static Object strlit7542;
static Object strlit7562;
static Object strlit7575;
static Object strlit7600;
static Object strlit7615;
static Object strlit7622;
static ClassData objclass7625;
static ClassData objclass7633;
static Object strlit7655;
static Object strlit7663;
static Object strlit7769;
static Object strlit7778;
static Object strlit7785;
static Object strlit7819;
static Object strlit7824;
static Object strlit7849;
static Object strlit7854;
static Object strlit7870;
static Object strlit7874;
static Object strlit7884;
static Object strlit7895;
static Object strlit7899;
static Object strlit7929;
static Object strlit7942;
static Object strlit7949;
static Object strlit7958;
static Object strlit7966;
static Object strlit7990;
static Object strlit8005;
static Object strlit8020;
static Object strlit8024;
static Object strlit8027;
static Object strlit8030;
static Object strlit8051;
static Object strlit8075;
static Object strlit8082;
static ClassData objclass8091;
static ClassData objclass8094;
static Object strlit8115;
static Object strlit8123;
static Object strlit8142;
static Object strlit8151;
static Object strlit8172;
static Object strlit8181;
static Object strlit8285;
static Object strlit8294;
static Object strlit8301;
static Object strlit8329;
static Object strlit8334;
static Object strlit8360;
static Object strlit8365;
static Object strlit8403;
static Object strlit8408;
static Object strlit8415;
static Object strlit8424;
static Object strlit8432;
static Object strlit8456;
static Object strlit8471;
static Object strlit8486;
static Object strlit8490;
static Object strlit8493;
static Object strlit8496;
static Object strlit8517;
static Object strlit8534;
static Object strlit8541;
static ClassData objclass8549;
static ClassData objclass8552;
static Object strlit8586;
static Object strlit8594;
static Object strlit8601;
static Object strlit8609;
static Object strlit8612;
static Object strlit8698;
static Object strlit8707;
static Object strlit8714;
static Object strlit8721;
static Object strlit8728;
static Object strlit8732;
static Object strlit8742;
static Object strlit8749;
static Object strlit8753;
static Object strlit8772;
static Object strlit8779;
static Object strlit8783;
static Object strlit8793;
static Object strlit8800;
static Object strlit8806;
static Object strlit8825;
static ClassData objclass8829;
static ClassData objclass8832;
static Object strlit8843;
static Object strlit8851;
static Object strlit8854;
static Object strlit8876;
static Object strlit8885;
static Object strlit8892;
static Object strlit8899;
static Object strlit8906;
static Object strlit8910;
static Object strlit8920;
static Object strlit8926;
static Object strlit8942;
static ClassData objclass8945;
static ClassData objclass8948;
static Object strlit8976;
static Object strlit8985;
static Object strlit8992;
static Object strlit9019;
static Object strlit9032;
static ClassData objclass9035;
static ClassData objclass9043;
static Object strlit9119;
static Object strlit9128;
static Object strlit9140;
static Object strlit9144;
static Object strlit9161;
static Object strlit9171;
static Object strlit9178;
static Object strlit9182;
static Object strlit9200;
static Object strlit9205;
static Object strlit9209;
static Object strlit9219;
static Object strlit9224;
static Object strlit9228;
static Object strlit9247;
static Object strlit9258;
static Object strlit9262;
static Object strlit9274;
static Object strlit9275;
static Object strlit9289;
static Object strlit9294;
static Object strlit9298;
static Object strlit9312;
static Object strlit9319;
static Object strlit9323;
static Object strlit9344;
static Object strlit9345;
static Object strlit9397;
static Object strlit9398;
static Object strlit9405;
static ClassData objclass9416;
static ClassData objclass9419;
static Object strlit9436;
static Object strlit9438;
static Object strlit9440;
static Object strlit9452;
static Object strlit9453;
static ClassData objclass9456;
static Object strlit9460;
static ClassData objclass9479;
static Object strlit9543;
static Object strlit9552;
static Object strlit9559;
static Object strlit9566;
static Object strlit9572;
static Object strlit9585;
static Object strlit9590;
static Object strlit9594;
static Object strlit9606;
static Object strlit9617;
static Object strlit9622;
static Object strlit9626;
static Object strlit9644;
static Object strlit9657;
static Object strlit9662;
static Object strlit9666;
static Object strlit9696;
static Object strlit9702;
static Object strlit9711;
static ClassData objclass9716;
static Object strlit9720;
static ClassData objclass9729;
static Object strlit9753;
static Object strlit9762;
static Object strlit9769;
static Object strlit9776;
static Object strlit9782;
static Object strlit9788;
static Object strlit9793;
static Object strlit9797;
static Object strlit9809;
static Object strlit9820;
static Object strlit9825;
static Object strlit9829;
static Object strlit9856;
static Object strlit9863;
static ClassData objclass9867;
static ClassData objclass9870;
static Object strlit9885;
static Object strlit9892;
static Object strlit9899;
static Object strlit9905;
static Object strlit9919;
static Object strlit9941;
static Object strlit9950;
static Object strlit9959;
static Object strlit9960;
static Object strlit9962;
static Object strlit9969;
static Object strlit9976;
static Object strlit9983;
static Object strlit9988;
static Object strlit9992;
static Object strlit10008;
static Object strlit10014;
static Object strlit10017;
static Object strlit10022;
static Object strlit10032;
static Object strlit10066;
static ClassData objclass10076;
Object meth_ast__apply5(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_as = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe7 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8 = callmethod(*var_nd, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7);
// compiled call node returning call8 (depth = 5)
  gc_frame_newslot(call8);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call8;
  partcv[0] = 1;
  Object call9 = callmethod(*var_newList, "addLast",
    1, partcv, params);
  gc_frame_end(callframe6);
// compiled call node returning call9 (depth = 4)
  gc_frame_end(frame);
  return call9;
}
Object meth_ast_listMap_40__41_ancestors1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "listMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method listMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method listMap()ancestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for listMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for listMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array2 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2 (depth = 3)
  *var_newList = array2;
  if (array2 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4 = alloc_Block(NULL, NULL, "ast", 20);
  gc_frame_newslot(block4);
// method "_apply"
  block_savedest(block4);
  Object closure5 = createclosure(4, "_apply");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_b);
  addtoclosure(closure5, var_as);
  addtoclosure(closure5, var_newList);
  addtoclosure(closure5, selfslot);
  struct UserObject *uo5 = (struct UserObject*)block4;
  uo5->data[0] = (Object)closure5;
  Method *meth_meth_ast__apply5 = addmethod2pos(block4, "_apply", &meth_ast__apply5, 0);
  int argcv_meth_ast__apply5[] = {1};
  meth_meth_ast__apply5->type = alloc_MethodType(1, argcv_meth_ast__apply5);
  meth_meth_ast__apply5->definitionModule = modulename;
  meth_meth_ast__apply5->definitionLine = 2802;
// compiled block node returning block4 (depth = 3)
  gc_frame_newslot(block4);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = block4;
  partcv[0] = 1;
  Object call11 = callmethod(*var_l, "do",
    1, partcv, params);
  gc_frame_end(callframe3);
// compiled call node returning call11 (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40__41_ancestors12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeMap()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for maybeMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_14 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool16 = alloc_Boolean(0);
// compiled identifier node returning bool16 (depth = 4)
  int op_slot_left_14 = gc_frame_newslot(bool16);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult17 = callmethod(bool16, "≠", 1, partcv, params);
// compiled op node returning opresult17 (depth = 3)
  Object if13 = done;
  if (istrue(opresult17)) {
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe18 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call19 = callmethod(*var_n, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 3)
    gc_frame_newslot(call19);
    if13 = call19;
  } else {
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if13 = *var_n;
  }
// compiled if node returning if13 (depth = 2)
  gc_frame_end(frame);
  return if13;
}
Object meth_ast_maybeListMap_40__41_ancestors20(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeListMap()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method maybeListMap()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for maybeListMap()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for maybeListMap");
  Object *var_as = &(stackframe->slots[2]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_right_22 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
  Object bool24 = alloc_Boolean(0);
// compiled identifier node returning bool24 (depth = 4)
  int op_slot_left_22 = gc_frame_newslot(bool24);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult25 = callmethod(bool24, "≠", 1, partcv, params);
// compiled op node returning opresult25 (depth = 3)
  Object if21 = done;
  if (istrue(opresult25)) {
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_b;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call27 = callmethodflags(self, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe26);
// compiled call node returning call27 (depth = 3)
    gc_frame_newslot(call27);
    if21 = call27;
  } else {
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if21 = *var_n;
  }
// compiled if node returning if21 (depth = 2)
  gc_frame_end(frame);
  return if21;
}
Object meth_ast_kind36(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "kind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for kind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for kind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe37 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call38 = callmethodflags(prelude, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled call node returning call38 (depth = 3)
// compiled member node returning call38 (depth = 2)
  gc_frame_end(frame);
  return call38;
}
Object meth_ast__61__61_39(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe40 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call41 = callmethodflags(self, "isMe", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe40);
// compiled call node returning call41 (depth = 2)
  gc_frame_end(frame);
  return call41;
}
Object meth_ast_isAppliedOccurenceOfIdentifier42(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool43 = alloc_Boolean(0);
// compiled identifier node returning bool43 (depth = 2)
  gc_frame_end(frame);
  return bool43;
}
Object meth_ast_isMatchingBlock44(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool45 = alloc_Boolean(0);
// compiled identifier node returning bool45 (depth = 2)
  gc_frame_end(frame);
  return bool45;
}
Object meth_ast_isFieldDec46(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool47 = alloc_Boolean(0);
// compiled identifier node returning bool47 (depth = 2)
  gc_frame_end(frame);
  return bool47;
}
Object meth_ast_isInherits48(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool49 = alloc_Boolean(0);
// compiled identifier node returning bool49 (depth = 2)
  gc_frame_end(frame);
  return bool49;
}
Object meth_ast_isLegalInTrait50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool51 = alloc_Boolean(0);
// compiled identifier node returning bool51 (depth = 2)
  gc_frame_end(frame);
  return bool51;
}
Object meth_ast_isMember52(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool53 = alloc_Boolean(0);
// compiled identifier node returning bool53 (depth = 2)
  gc_frame_end(frame);
  return bool53;
}
Object meth_ast_isMethod54(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool55 = alloc_Boolean(0);
// compiled identifier node returning bool55 (depth = 2)
  gc_frame_end(frame);
  return bool55;
}
Object meth_ast_isExecutable56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool57 = alloc_Boolean(1);
// compiled identifier node returning bool57 (depth = 2)
  gc_frame_end(frame);
  return bool57;
}
Object meth_ast_isCall58(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool59 = alloc_Boolean(0);
// compiled identifier node returning bool59 (depth = 2)
  gc_frame_end(frame);
  return bool59;
}
Object meth_ast_isComment60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool61 = alloc_Boolean(0);
// compiled identifier node returning bool61 (depth = 2)
  gc_frame_end(frame);
  return bool61;
}
Object meth_ast_isClass62(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool63 = alloc_Boolean(0);
// compiled identifier node returning bool63 (depth = 2)
  gc_frame_end(frame);
  return bool63;
}
Object meth_ast_inClass64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool65 = alloc_Boolean(0);
// compiled identifier node returning bool65 (depth = 2)
  gc_frame_end(frame);
  return bool65;
}
Object meth_ast_isTrait66(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool67 = alloc_Boolean(0);
// compiled identifier node returning bool67 (depth = 2)
  gc_frame_end(frame);
  return bool67;
}
Object meth_ast_inTrait68(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool69 = alloc_Boolean(0);
// compiled identifier node returning bool69 (depth = 2)
  gc_frame_end(frame);
  return bool69;
}
Object meth_ast_isBind70(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool71 = alloc_Boolean(0);
// compiled identifier node returning bool71 (depth = 2)
  gc_frame_end(frame);
  return bool71;
}
Object meth_ast_isBlock72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool73 = alloc_Boolean(0);
// compiled identifier node returning bool73 (depth = 2)
  gc_frame_end(frame);
  return bool73;
}
Object meth_ast_isObject74(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool75 = alloc_Boolean(0);
// compiled identifier node returning bool75 (depth = 2)
  gc_frame_end(frame);
  return bool75;
}
Object meth_ast_isIdentifier76(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool77 = alloc_Boolean(0);
// compiled identifier node returning bool77 (depth = 2)
  gc_frame_end(frame);
  return bool77;
}
Object meth_ast_isDialect78(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool79 = alloc_Boolean(0);
// compiled identifier node returning bool79 (depth = 2)
  gc_frame_end(frame);
  return bool79;
}
Object meth_ast_isImport80(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool81 = alloc_Boolean(0);
// compiled identifier node returning bool81 (depth = 2)
  gc_frame_end(frame);
  return bool81;
}
Object meth_ast_isTypeDec82(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTypeDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 2)
  gc_frame_end(frame);
  return bool83;
}
Object meth_ast_isExternal84(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 2)
  gc_frame_end(frame);
  return bool85;
}
Object meth_ast_canInherit86(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool87 = alloc_Boolean(0);
// compiled identifier node returning bool87 (depth = 2)
  gc_frame_end(frame);
  return bool87;
}
Object meth_ast_returnsObject88(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool89 = alloc_Boolean(0);
// compiled identifier node returning bool89 (depth = 2)
  gc_frame_end(frame);
  return bool89;
}
Object meth_ast_usesAsType90(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 2)
  gc_frame_end(frame);
  return bool91;
}
Object meth_ast_hash92(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe94 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe95 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call96 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe95);
// compiled call node returning call96 (depth = 6)
// compiled member node returning call96 (depth = 5)
  partcv[0] = 0;
  Object call97 = callmethod(call96, "hash",
    1, partcv, params);
  gc_frame_end(callframe94);
// compiled call node returning call97 (depth = 4)
// compiled member node returning call97 (depth = 3)
  int op_slot_right_93 = gc_frame_newslot(call97);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe99 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call101 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call101 (depth = 6)
// compiled member node returning call101 (depth = 5)
  partcv[0] = 0;
  Object call102 = callmethod(call101, "hash",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call102 (depth = 4)
// compiled member node returning call102 (depth = 3)
  int op_slot_left_93 = gc_frame_newslot(call102);
  params[0] = call97;
  partcv[0] = 1;
  Object prod103 = callmethod(call102, "*", 1, partcv, params);
// compiled op node returning prod103 (depth = 2)
  gc_frame_end(frame);
  return prod103;
}
Object meth_ast_asString104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit106 == NULL) {
    strlit106 = alloc_String("");
    gc_root(strlit106);
  }
// compiled string node returning strlit106 (depth = 3)
  int op_slot_right_105 = gc_frame_newslot(strlit106);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call110 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe109);
// compiled call node returning call110 (depth = 5)
// compiled member node returning call110 (depth = 4)
  int op_slot_right_108 = gc_frame_newslot(call110);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit113 == NULL) {
    strlit113 = alloc_String(" ");
    gc_root(strlit113);
  }
// compiled string node returning strlit113 (depth = 5)
  int op_slot_right_112 = gc_frame_newslot(strlit113);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call117 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe116);
// compiled call node returning call117 (depth = 7)
// compiled member node returning call117 (depth = 6)
  int op_slot_right_115 = gc_frame_newslot(call117);
// starting to compile string node (depth = 6)
  if (strlit119 == NULL) {
    strlit119 = alloc_String("");
    gc_root(strlit119);
  }
// compiled string node returning strlit119 (depth = 6)
  int op_slot_left_115 = gc_frame_newslot(strlit119);
  params[0] = call117;
  partcv[0] = 1;
  Object opresult120 = callmethod(strlit119, "++", 1, partcv, params);
// compiled op node returning opresult120 (depth = 5)
  int op_slot_left_112 = gc_frame_newslot(opresult120);
  params[0] = strlit113;
  partcv[0] = 1;
  Object opresult121 = callmethod(opresult120, "++", 1, partcv, params);
// compiled op node returning opresult121 (depth = 4)
  int op_slot_left_108 = gc_frame_newslot(opresult121);
  params[0] = call110;
  partcv[0] = 1;
  Object opresult122 = callmethod(opresult121, "++", 1, partcv, params);
// compiled op node returning opresult122 (depth = 3)
  int op_slot_left_105 = gc_frame_newslot(opresult122);
  params[0] = strlit106;
  partcv[0] = 1;
  Object opresult123 = callmethod(opresult122, "++", 1, partcv, params);
// compiled op node returning opresult123 (depth = 2)
  gc_frame_end(frame);
  return opresult123;
}
Object meth_ast_nameString124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit125 == NULL) {
    strlit125 = alloc_String("?");
    gc_root(strlit125);
  }
// compiled string node returning strlit125 (depth = 2)
  gc_frame_end(frame);
  return strlit125;
}
Object meth_ast_isWritable126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool127 = alloc_Boolean(1);
// compiled identifier node returning bool127 (depth = 2)
  gc_frame_end(frame);
  return bool127;
}
Object meth_ast_isReadable128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool129 = alloc_Boolean(1);
// compiled identifier node returning bool129 (depth = 2)
  gc_frame_end(frame);
  return bool129;
}
Object meth_ast_isPublic130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool131 = alloc_Boolean(1);
// compiled identifier node returning bool131 (depth = 2)
  gc_frame_end(frame);
  return bool131;
}
Object meth_ast_isConfidential132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe133 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call135 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe134);
// compiled call node returning call135 (depth = 5)
// compiled member node returning call135 (depth = 4)
  partcv[0] = 0;
  Object call136 = callmethod(call135, "not",
    1, partcv, params);
  gc_frame_end(callframe133);
// compiled call node returning call136 (depth = 3)
// compiled member node returning call136 (depth = 2)
  gc_frame_end(frame);
  return call136;
}
Object meth_ast_decType137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call141 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe140);
// compiled call node returning call141 (depth = 5)
// compiled member node returning call141 (depth = 4)
  int op_slot_right_139 = gc_frame_newslot(call141);
// starting to compile identifier node (depth = 4)
  Object bool143 = alloc_Boolean(0);
// compiled identifier node returning bool143 (depth = 4)
  int op_slot_left_139 = gc_frame_newslot(bool143);
  params[0] = call141;
  partcv[0] = 1;
  Object opresult144 = callmethod(bool143, "==", 1, partcv, params);
// compiled op node returning opresult144 (depth = 3)
  Object if138 = done;
  if (istrue(opresult144)) {
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unknownType (depth = 4)
  return *var_unknownType;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if138 = undefined;
  } else {
  }
// compiled if node returning if138 (depth = 2)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call146 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe145);
// compiled call node returning call146 (depth = 4)
// compiled member node returning call146 (depth = 3)
  return call146;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_isSimple147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool148 = alloc_Boolean(1);
// compiled identifier node returning bool148 (depth = 2)
  gc_frame_end(frame);
  return bool148;
}
Object meth_ast_description149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for description (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for description");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call151 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe150);
// compiled call node returning call151 (depth = 3)
// compiled member node returning call151 (depth = 2)
  gc_frame_end(frame);
  return call151;
}
Object meth_ast_accept152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept");
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe153 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitor (depth = 3)
  gc_frame_newslot(*var_visitor);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ancestorChain (depth = 5)
  partcv[0] = 0;
  Object call155 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe154);
// compiled call node returning call155 (depth = 4)
// compiled member node returning call155 (depth = 3)
  gc_frame_newslot(call155);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = call155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call156 = callmethodflags(self, "accept()from", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe153);
// compiled call node returning call156 (depth = 2)
  gc_frame_end(frame);
  return call156;
}
Object meth_ast_scope157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call159 = callmethodflags(self, "symbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compiled call node returning call159 (depth = 3)
// compiled member node returning call159 (depth = 2)
  gc_frame_end(frame);
  return call159;
}
Object meth_ast_scope_58__61_160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe161 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_st (depth = 3)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call162 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe161);
// compiled call node returning call162 (depth = 2)
  gc_frame_end(frame);
  return call162;
}
Object meth_ast_shallowCopyFieldsFrom163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe164 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call166 = callmethod(*var_other, "register",
    1, partcv, params);
  gc_frame_end(callframe165);
// compiled call node returning call166 (depth = 4)
// compiled member node returning call166 (depth = 3)
  gc_frame_newslot(call166);
// call case 4: self request
  params[0] = call166;
  partcv[0] = 1;
  Object call167 = callmethodflags(self, "register:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe164);
// compiled call node returning call167 (depth = 2)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe168 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call170 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe169);
// compiled call node returning call170 (depth = 4)
// compiled member node returning call170 (depth = 3)
  gc_frame_newslot(call170);
// call case 4: self request
  params[0] = call170;
  partcv[0] = 1;
  Object call171 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe168);
// compiled call node returning call171 (depth = 2)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe172 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call174 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe173);
// compiled call node returning call174 (depth = 4)
// compiled member node returning call174 (depth = 3)
  gc_frame_newslot(call174);
// call case 4: self request
  params[0] = call174;
  partcv[0] = 1;
  Object call175 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe172);
// compiled call node returning call175 (depth = 2)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe176 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  partcv[0] = 0;
  Object call178 = callmethod(*var_other, "scope",
    1, partcv, params);
  gc_frame_end(callframe177);
// compiled call node returning call178 (depth = 4)
// compiled member node returning call178 (depth = 3)
  gc_frame_newslot(call178);
// call case 4: self request
  params[0] = call178;
  partcv[0] = 1;
  Object call179 = callmethodflags(self, "scope:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe176);
// compiled call node returning call179 (depth = 2)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit190 == NULL) {
    strlit190 = alloc_String("  ");
    gc_root(strlit190);
  }
// compiled string node returning strlit190 (depth = 6)
  int op_slot_right_189 = gc_frame_newslot(strlit190);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_189 = gc_frame_newslot(*var_spc);
  params[0] = strlit190;
  partcv[0] = 1;
  Object opresult192 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult192 (depth = 5)
  *var_spc = opresult192;
  if (opresult192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply199(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit201 == NULL) {
    strlit201 = alloc_String("symbols");
    gc_root(strlit201);
  }
// compiled string node returning strlit201 (depth = 6)
  int op_slot_right_200 = gc_frame_newslot(strlit201);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call204 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe203);
// compiled call node returning call204 (depth = 7)
// compiled member node returning call204 (depth = 6)
  int op_slot_left_200 = gc_frame_newslot(call204);
  params[0] = strlit201;
  partcv[0] = 1;
  Object opresult205 = callmethod(call204, "==", 1, partcv, params);
// compiled op node returning opresult205 (depth = 5)
  gc_frame_end(frame);
  return opresult205;
}
Object meth_ast_pretty180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit181 == NULL) {
    strlit181 = alloc_String("");
    gc_root(strlit181);
  }
// compiled string node returning strlit181 (depth = 3)
  *var_spc = strlit181;
  if (strlit181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe182 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_183 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num185 = alloc_Float64(0);
// compiled num node returning num185 (depth = 4)
  int op_slot_left_183 = gc_frame_newslot(num185);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult186 = callmethod(num185, "..", 1, partcv, params);
// compiled op node returning opresult186 (depth = 3)
  gc_frame_newslot(opresult186);
// starting to compile block node (depth = 3)
  Object block187 = alloc_Block(NULL, NULL, "ast", 157);
  gc_frame_newslot(block187);
// method "_apply"
  block_savedest(block187);
  Object closure188 = createclosure(2, "_apply");
  setclosureframe(closure188, stackframe);
  addtoclosure(closure188, var_spc);
  addtoclosure(closure188, selfslot);
  struct UserObject *uo188 = (struct UserObject*)block187;
  uo188->data[0] = (Object)closure188;
  Method *meth_meth_ast__apply188 = addmethod2pos(block187, "_apply", &meth_ast__apply188, 0);
  int argcv_meth_ast__apply188[] = {1};
  meth_meth_ast__apply188->type = alloc_MethodType(1, argcv_meth_ast__apply188);
  meth_meth_ast__apply188->definitionModule = modulename;
  meth_meth_ast__apply188->definitionLine = 152;
// compiled block node returning block187 (depth = 3)
  gc_frame_newslot(block187);
// call case 5: prelude request
  params[0] = opresult186;
  params[1] = block187;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call195 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe182);
// compiled call node returning call195 (depth = 2)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block198 = alloc_Block(NULL, NULL, "ast", 160);
  gc_frame_newslot(block198);
// method "_apply"
  block_savedest(block198);
  Object closure199 = createclosure(2, "_apply");
  setclosureframe(closure199, stackframe);
  addtoclosure(closure199, var_util);
  addtoclosure(closure199, selfslot);
  struct UserObject *uo199 = (struct UserObject*)block198;
  uo199->data[0] = (Object)closure199;
  Method *meth_meth_ast__apply199 = addmethod2pos(block198, "_apply", &meth_ast__apply199, 0);
  int argcv_meth_ast__apply199[] = {0};
  meth_meth_ast__apply199->type = alloc_MethodType(1, argcv_meth_ast__apply199);
  meth_meth_ast__apply199->definitionModule = modulename;
  meth_meth_ast__apply199->definitionLine = 152;
// compiled block node returning block198 (depth = 4)
  int op_slot_right_197 = gc_frame_newslot(block198);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  int op_slot_right_208 = gc_frame_newslot(self);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe210 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call212 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe211);
// compiled call node returning call212 (depth = 8)
// compiled member node returning call212 (depth = 7)
  partcv[0] = 0;
  Object call213 = callmethod(call212, "node",
    1, partcv, params);
  gc_frame_end(callframe210);
// compiled call node returning call213 (depth = 6)
// compiled member node returning call213 (depth = 5)
  int op_slot_left_208 = gc_frame_newslot(call213);
  params[0] = self;
  partcv[0] = 1;
  Object opresult214 = callmethod(call213, "==", 1, partcv, params);
// compiled op node returning opresult214 (depth = 4)
  int op_slot_left_197 = gc_frame_newslot(opresult214);
  params[0] = block198;
  partcv[0] = 1;
  Object opresult215 = callmethod(opresult214, "&&", 1, partcv, params);
// compiled op node returning opresult215 (depth = 3)
  Object if196 = done;
  if (istrue(opresult215)) {
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit217 == NULL) {
    strlit217 = alloc_String("");
    gc_root(strlit217);
  }
// compiled string node returning strlit217 (depth = 4)
  int op_slot_right_216 = gc_frame_newslot(strlit217);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe220 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call222 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe221);
// compiled call node returning call222 (depth = 8)
// compiled member node returning call222 (depth = 7)
  partcv[0] = 0;
  Object call223 = callmethod(call222, "elementScopesAsString",
    1, partcv, params);
  gc_frame_end(callframe220);
// compiled call node returning call223 (depth = 6)
// compiled member node returning call223 (depth = 5)
  int op_slot_right_219 = gc_frame_newslot(call223);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit226 == NULL) {
    strlit226 = alloc_String("");
    gc_root(strlit226);
  }
// compiled string node returning strlit226 (depth = 6)
  int op_slot_right_225 = gc_frame_newslot(strlit226);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call230 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe229);
// compiled call node returning call230 (depth = 8)
// compiled member node returning call230 (depth = 7)
  int op_slot_right_228 = gc_frame_newslot(call230);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit233 == NULL) {
    strlit233 = alloc_String("): ");
    gc_root(strlit233);
  }
// compiled string node returning strlit233 (depth = 8)
  int op_slot_right_232 = gc_frame_newslot(strlit233);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe236 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call238 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe237);
// compiled call node returning call238 (depth = 12)
// compiled member node returning call238 (depth = 11)
  partcv[0] = 0;
  Object call239 = callmethod(call238, "variety",
    1, partcv, params);
  gc_frame_end(callframe236);
// compiled call node returning call239 (depth = 10)
// compiled member node returning call239 (depth = 9)
  int op_slot_right_235 = gc_frame_newslot(call239);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit242 == NULL) {
    strlit242 = alloc_String("Symbols(");
    gc_root(strlit242);
  }
// compiled string node returning strlit242 (depth = 10)
  int op_slot_right_241 = gc_frame_newslot(strlit242);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_244 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit247 == NULL) {
    strlit247 = alloc_String("""\x0a""");
    gc_root(strlit247);
  }
// compiled string node returning strlit247 (depth = 12)
  int op_slot_right_246 = gc_frame_newslot(strlit247);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call251 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe250);
// compiled call node returning call251 (depth = 14)
// compiled member node returning call251 (depth = 13)
  int op_slot_right_249 = gc_frame_newslot(call251);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit254 == NULL) {
    strlit254 = alloc_String(" ");
    gc_root(strlit254);
  }
// compiled string node returning strlit254 (depth = 14)
  int op_slot_right_253 = gc_frame_newslot(strlit254);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe257 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call258 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe257);
// compiled call node returning call258 (depth = 16)
// compiled member node returning call258 (depth = 15)
  int op_slot_right_256 = gc_frame_newslot(call258);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit261 == NULL) {
    strlit261 = alloc_String(":");
    gc_root(strlit261);
  }
// compiled string node returning strlit261 (depth = 16)
  int op_slot_right_260 = gc_frame_newslot(strlit261);
// starting to compile op node (depth = 16)
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call265 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe264);
// compiled call node returning call265 (depth = 18)
// compiled member node returning call265 (depth = 17)
  int op_slot_right_263 = gc_frame_newslot(call265);
// starting to compile string node (depth = 17)
  if (strlit267 == NULL) {
    strlit267 = alloc_String("");
    gc_root(strlit267);
  }
// compiled string node returning strlit267 (depth = 17)
  int op_slot_left_263 = gc_frame_newslot(strlit267);
  params[0] = call265;
  partcv[0] = 1;
  Object opresult268 = callmethod(strlit267, "++", 1, partcv, params);
// compiled op node returning opresult268 (depth = 16)
  int op_slot_left_260 = gc_frame_newslot(opresult268);
  params[0] = strlit261;
  partcv[0] = 1;
  Object opresult269 = callmethod(opresult268, "++", 1, partcv, params);
// compiled op node returning opresult269 (depth = 15)
  int op_slot_left_256 = gc_frame_newslot(opresult269);
  params[0] = call258;
  partcv[0] = 1;
  Object opresult270 = callmethod(opresult269, "++", 1, partcv, params);
// compiled op node returning opresult270 (depth = 14)
  int op_slot_left_253 = gc_frame_newslot(opresult270);
  params[0] = strlit254;
  partcv[0] = 1;
  Object opresult271 = callmethod(opresult270, "++", 1, partcv, params);
// compiled op node returning opresult271 (depth = 13)
  int op_slot_left_249 = gc_frame_newslot(opresult271);
  params[0] = call251;
  partcv[0] = 1;
  Object opresult272 = callmethod(opresult271, "++", 1, partcv, params);
// compiled op node returning opresult272 (depth = 12)
  int op_slot_left_246 = gc_frame_newslot(opresult272);
  params[0] = strlit247;
  partcv[0] = 1;
  Object opresult273 = callmethod(opresult272, "++", 1, partcv, params);
// compiled op node returning opresult273 (depth = 11)
  int op_slot_left_244 = gc_frame_newslot(opresult273);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult274 = callmethod(opresult273, "++", 1, partcv, params);
// compiled op node returning opresult274 (depth = 10)
  int op_slot_left_241 = gc_frame_newslot(opresult274);
  params[0] = strlit242;
  partcv[0] = 1;
  Object opresult275 = callmethod(opresult274, "++", 1, partcv, params);
// compiled op node returning opresult275 (depth = 9)
  int op_slot_left_235 = gc_frame_newslot(opresult275);
  params[0] = call239;
  partcv[0] = 1;
  Object opresult276 = callmethod(opresult275, "++", 1, partcv, params);
// compiled op node returning opresult276 (depth = 8)
  int op_slot_left_232 = gc_frame_newslot(opresult276);
  params[0] = strlit233;
  partcv[0] = 1;
  Object opresult277 = callmethod(opresult276, "++", 1, partcv, params);
// compiled op node returning opresult277 (depth = 7)
  int op_slot_left_228 = gc_frame_newslot(opresult277);
  params[0] = call230;
  partcv[0] = 1;
  Object opresult278 = callmethod(opresult277, "++", 1, partcv, params);
// compiled op node returning opresult278 (depth = 6)
  int op_slot_left_225 = gc_frame_newslot(opresult278);
  params[0] = strlit226;
  partcv[0] = 1;
  Object opresult279 = callmethod(opresult278, "++", 1, partcv, params);
// compiled op node returning opresult279 (depth = 5)
  int op_slot_left_219 = gc_frame_newslot(opresult279);
  params[0] = call223;
  partcv[0] = 1;
  Object opresult280 = callmethod(opresult279, "++", 1, partcv, params);
// compiled op node returning opresult280 (depth = 4)
  int op_slot_left_216 = gc_frame_newslot(opresult280);
  params[0] = strlit217;
  partcv[0] = 1;
  Object opresult281 = callmethod(opresult280, "++", 1, partcv, params);
// compiled op node returning opresult281 (depth = 3)
    gc_frame_newslot(opresult281);
    if196 = opresult281;
  } else {
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit284 == NULL) {
    strlit284 = alloc_String("fake");
    gc_root(strlit284);
  }
// compiled string node returning strlit284 (depth = 5)
  int op_slot_right_283 = gc_frame_newslot(strlit284);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe286 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call288 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe287);
// compiled call node returning call288 (depth = 8)
// compiled member node returning call288 (depth = 7)
  partcv[0] = 0;
  Object call289 = callmethod(call288, "variety",
    1, partcv, params);
  gc_frame_end(callframe286);
// compiled call node returning call289 (depth = 6)
// compiled member node returning call289 (depth = 5)
  int op_slot_left_283 = gc_frame_newslot(call289);
  params[0] = strlit284;
  partcv[0] = 1;
  Object opresult290 = callmethod(call289, "==", 1, partcv, params);
// compiled op node returning opresult290 (depth = 4)
  Object if282 = done;
  if (istrue(opresult290)) {
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit292 == NULL) {
    strlit292 = alloc_String("");
    gc_root(strlit292);
  }
// compiled string node returning strlit292 (depth = 5)
  int op_slot_right_291 = gc_frame_newslot(strlit292);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call296 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe295);
// compiled call node returning call296 (depth = 7)
// compiled member node returning call296 (depth = 6)
  int op_slot_right_294 = gc_frame_newslot(call296);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit299 == NULL) {
    strlit299 = alloc_String(" ");
    gc_root(strlit299);
  }
// compiled string node returning strlit299 (depth = 7)
  int op_slot_right_298 = gc_frame_newslot(strlit299);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call303 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe302);
// compiled call node returning call303 (depth = 9)
// compiled member node returning call303 (depth = 8)
  int op_slot_right_301 = gc_frame_newslot(call303);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit306 == NULL) {
    strlit306 = alloc_String(":");
    gc_root(strlit306);
  }
// compiled string node returning strlit306 (depth = 9)
  int op_slot_right_305 = gc_frame_newslot(strlit306);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call310 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe309);
// compiled call node returning call310 (depth = 11)
// compiled member node returning call310 (depth = 10)
  int op_slot_right_308 = gc_frame_newslot(call310);
// starting to compile string node (depth = 10)
  if (strlit312 == NULL) {
    strlit312 = alloc_String("");
    gc_root(strlit312);
  }
// compiled string node returning strlit312 (depth = 10)
  int op_slot_left_308 = gc_frame_newslot(strlit312);
  params[0] = call310;
  partcv[0] = 1;
  Object opresult313 = callmethod(strlit312, "++", 1, partcv, params);
// compiled op node returning opresult313 (depth = 9)
  int op_slot_left_305 = gc_frame_newslot(opresult313);
  params[0] = strlit306;
  partcv[0] = 1;
  Object opresult314 = callmethod(opresult313, "++", 1, partcv, params);
// compiled op node returning opresult314 (depth = 8)
  int op_slot_left_301 = gc_frame_newslot(opresult314);
  params[0] = call303;
  partcv[0] = 1;
  Object opresult315 = callmethod(opresult314, "++", 1, partcv, params);
// compiled op node returning opresult315 (depth = 7)
  int op_slot_left_298 = gc_frame_newslot(opresult315);
  params[0] = strlit299;
  partcv[0] = 1;
  Object opresult316 = callmethod(opresult315, "++", 1, partcv, params);
// compiled op node returning opresult316 (depth = 6)
  int op_slot_left_294 = gc_frame_newslot(opresult316);
  params[0] = call296;
  partcv[0] = 1;
  Object opresult317 = callmethod(opresult316, "++", 1, partcv, params);
// compiled op node returning opresult317 (depth = 5)
  int op_slot_left_291 = gc_frame_newslot(opresult317);
  params[0] = strlit292;
  partcv[0] = 1;
  Object opresult318 = callmethod(opresult317, "++", 1, partcv, params);
// compiled op node returning opresult318 (depth = 4)
    gc_frame_newslot(opresult318);
    if282 = opresult318;
  } else {
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit320 == NULL) {
    strlit320 = alloc_String("");
    gc_root(strlit320);
  }
// compiled string node returning strlit320 (depth = 5)
  int op_slot_right_319 = gc_frame_newslot(strlit320);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe323 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call325 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe324);
// compiled call node returning call325 (depth = 9)
// compiled member node returning call325 (depth = 8)
  partcv[0] = 0;
  Object call326 = callmethod(call325, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe323);
// compiled call node returning call326 (depth = 7)
// compiled member node returning call326 (depth = 6)
  int op_slot_right_322 = gc_frame_newslot(call326);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit329 == NULL) {
    strlit329 = alloc_String(" ");
    gc_root(strlit329);
  }
// compiled string node returning strlit329 (depth = 7)
  int op_slot_right_328 = gc_frame_newslot(strlit329);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call333 = callmethodflags(self, "description", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe332);
// compiled call node returning call333 (depth = 9)
// compiled member node returning call333 (depth = 8)
  int op_slot_right_331 = gc_frame_newslot(call333);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit336 == NULL) {
    strlit336 = alloc_String(" ");
    gc_root(strlit336);
  }
// compiled string node returning strlit336 (depth = 9)
  int op_slot_right_335 = gc_frame_newslot(strlit336);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe339 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call340 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe339);
// compiled call node returning call340 (depth = 11)
// compiled member node returning call340 (depth = 10)
  int op_slot_right_338 = gc_frame_newslot(call340);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit343 == NULL) {
    strlit343 = alloc_String(":");
    gc_root(strlit343);
  }
// compiled string node returning strlit343 (depth = 11)
  int op_slot_right_342 = gc_frame_newslot(strlit343);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call347 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe346);
// compiled call node returning call347 (depth = 13)
// compiled member node returning call347 (depth = 12)
  int op_slot_right_345 = gc_frame_newslot(call347);
// starting to compile string node (depth = 12)
  if (strlit349 == NULL) {
    strlit349 = alloc_String("");
    gc_root(strlit349);
  }
// compiled string node returning strlit349 (depth = 12)
  int op_slot_left_345 = gc_frame_newslot(strlit349);
  params[0] = call347;
  partcv[0] = 1;
  Object opresult350 = callmethod(strlit349, "++", 1, partcv, params);
// compiled op node returning opresult350 (depth = 11)
  int op_slot_left_342 = gc_frame_newslot(opresult350);
  params[0] = strlit343;
  partcv[0] = 1;
  Object opresult351 = callmethod(opresult350, "++", 1, partcv, params);
// compiled op node returning opresult351 (depth = 10)
  int op_slot_left_338 = gc_frame_newslot(opresult351);
  params[0] = call340;
  partcv[0] = 1;
  Object opresult352 = callmethod(opresult351, "++", 1, partcv, params);
// compiled op node returning opresult352 (depth = 9)
  int op_slot_left_335 = gc_frame_newslot(opresult352);
  params[0] = strlit336;
  partcv[0] = 1;
  Object opresult353 = callmethod(opresult352, "++", 1, partcv, params);
// compiled op node returning opresult353 (depth = 8)
  int op_slot_left_331 = gc_frame_newslot(opresult353);
  params[0] = call333;
  partcv[0] = 1;
  Object opresult354 = callmethod(opresult353, "++", 1, partcv, params);
// compiled op node returning opresult354 (depth = 7)
  int op_slot_left_328 = gc_frame_newslot(opresult354);
  params[0] = strlit329;
  partcv[0] = 1;
  Object opresult355 = callmethod(opresult354, "++", 1, partcv, params);
// compiled op node returning opresult355 (depth = 6)
  int op_slot_left_322 = gc_frame_newslot(opresult355);
  params[0] = call326;
  partcv[0] = 1;
  Object opresult356 = callmethod(opresult355, "++", 1, partcv, params);
// compiled op node returning opresult356 (depth = 5)
  int op_slot_left_319 = gc_frame_newslot(opresult356);
  params[0] = strlit320;
  partcv[0] = 1;
  Object opresult357 = callmethod(opresult356, "++", 1, partcv, params);
// compiled op node returning opresult357 (depth = 4)
    gc_frame_newslot(opresult357);
    if282 = opresult357;
  }
// compiled if node returning if282 (depth = 3)
    gc_frame_newslot(if282);
    if196 = if282;
  }
// compiled if node returning if196 (depth = 2)
  gc_frame_end(frame);
  return if196;
}
Object meth_ast__apply361(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_each (depth = 4)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deepCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for deepCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe359 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block360 = alloc_Block(NULL, NULL, "ast", 169);
  gc_frame_newslot(block360);
// method "_apply"
  block_savedest(block360);
  Object closure361 = createclosure(1, "_apply");
  setclosureframe(closure361, stackframe);
  addtoclosure(closure361, selfslot);
  struct UserObject *uo361 = (struct UserObject*)block360;
  uo361->data[0] = (Object)closure361;
  Method *meth_meth_ast__apply361 = addmethod2pos(block360, "_apply", &meth_ast__apply361, 0);
  int argcv_meth_ast__apply361[] = {1};
  meth_meth_ast__apply361->type = alloc_MethodType(1, argcv_meth_ast__apply361);
  meth_meth_ast__apply361->definitionModule = modulename;
  meth_meth_ast__apply361->definitionLine = 165;
// compiled block node returning block360 (depth = 3)
  gc_frame_newslot(block360);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ancestorChain (depth = 5)
  partcv[0] = 0;
  Object call364 = callmethod(*var_ancestorChain, "empty",
    1, partcv, params);
  gc_frame_end(callframe363);
// compiled call node returning call364 (depth = 4)
// compiled member node returning call364 (depth = 3)
  gc_frame_newslot(call364);
// call case 4: self request
  params[0] = block360;
  params[1] = call364;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call365 = callmethodflags(self, "map()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe359);
// compiled call node returning call365 (depth = 2)
  gc_frame_end(frame);
  return call365;
}
Object meth_ast_enclosingObject366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for enclosingObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for enclosingObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_obj = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "obj");
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe367 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe368 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call370 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe369);
// compiled call node returning call370 (depth = 8)
// compiled member node returning call370 (depth = 7)
  partcv[0] = 0;
  Object call371 = callmethod(call370, "enclosingObjectScope",
    1, partcv, params);
  gc_frame_end(callframe368);
// compiled call node returning call371 (depth = 6)
// compiled member node returning call371 (depth = 5)
  partcv[0] = 0;
  Object call372 = callmethod(call371, "node",
    1, partcv, params);
  gc_frame_end(callframe367);
// compiled call node returning call372 (depth = 4)
// compiled member node returning call372 (depth = 3)
  *var_obj = call372;
  if (call372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_obj (depth = 2)
  gc_frame_end(frame);
  return *var_obj;
}
Object meth_ast_addComment373(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call377 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe376);
// compiled call node returning call377 (depth = 5)
// compiled member node returning call377 (depth = 4)
  int op_slot_right_375 = gc_frame_newslot(call377);
// starting to compile identifier node (depth = 4)
  Object bool379 = alloc_Boolean(0);
// compiled identifier node returning bool379 (depth = 4)
  int op_slot_left_375 = gc_frame_newslot(bool379);
  params[0] = call377;
  partcv[0] = 1;
  Object opresult380 = callmethod(bool379, "==", 1, partcv, params);
// compiled op node returning opresult380 (depth = 3)
  Object if374 = done;
  if (istrue(opresult380)) {
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe381 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 4: self request
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call382 = callmethodflags(self, "comments:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe381);
// compiled call node returning call382 (depth = 3)
    gc_frame_newslot(call382);
    if374 = call382;
  } else {
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe383 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cmtNode (depth = 4)
  gc_frame_newslot(*var_cmtNode);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call385 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe384);
// compiled call node returning call385 (depth = 5)
// compiled member node returning call385 (depth = 4)
  params[0] = *var_cmtNode;
  partcv[0] = 1;
  Object call386 = callmethod(call385, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe383);
// compiled call node returning call386 (depth = 3)
    gc_frame_newslot(call386);
    if374 = call386;
  }
// compiled if node returning if374 (depth = 2)
  gc_frame_end(frame);
  return if374;
}
Object meth_ast__apply390(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe391 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call392 = callmethodflags(self, "addComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe391);
// compiled call node returning call392 (depth = 4)
  gc_frame_end(frame);
  return call392;
}
Object meth_ast_addComments387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addComments");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addComments (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNodeList = &(stackframe->slots[0]);
  *var_cmtNodeList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addComments");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe388 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block389 = alloc_Block(NULL, NULL, "ast", 183);
  gc_frame_newslot(block389);
// method "_apply"
  block_savedest(block389);
  Object closure390 = createclosure(1, "_apply");
  setclosureframe(closure390, stackframe);
  addtoclosure(closure390, selfslot);
  struct UserObject *uo390 = (struct UserObject*)block389;
  uo390->data[0] = (Object)closure390;
  Method *meth_meth_ast__apply390 = addmethod2pos(block389, "_apply", &meth_ast__apply390, 0);
  int argcv_meth_ast__apply390[] = {1};
  meth_meth_ast__apply390->type = alloc_MethodType(1, argcv_meth_ast__apply390);
  meth_meth_ast__apply390->definitionModule = modulename;
  meth_meth_ast__apply390->definitionLine = 179;
// compiled block node returning block389 (depth = 3)
  gc_frame_newslot(block389);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cmtNodeList (depth = 3)
  params[0] = block389;
  partcv[0] = 1;
  Object call394 = callmethod(*var_cmtNodeList, "do",
    1, partcv, params);
  gc_frame_end(callframe388);
// compiled call node returning call394 (depth = 2)
  gc_frame_end(frame);
  return call394;
}
Object meth_ast_statementName395(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call397 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe396);
// compiled call node returning call397 (depth = 3)
// compiled member node returning call397 (depth = 2)
  gc_frame_end(frame);
  return call397;
}
Object meth_ast_baseNode28(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(57,53, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "ast.baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register",&reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=",&writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 88;
  writer31->definitionLine = 88;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line",&reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=",&writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 89;
  writer32->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos",&reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=",&writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 90;
  writer33->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable",&reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=",&writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 91;
  writer34->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments",&reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=",&writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 92;
  writer35->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "kind"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_kind36 = addmethod2pos(obj29, "kind", &meth_ast_kind36, 6);
  int argcv_meth_ast_kind36[] = {0};
  meth_meth_ast_kind36->type = alloc_MethodType(1, argcv_meth_ast_kind36);
  meth_meth_ast_kind36->definitionModule = modulename;
  meth_meth_ast_kind36->definitionLine = 94;
// method "=="
  struct UserObject *uo39 = (struct UserObject*)obj29;
  uo39->data[7] = emptyclosure;
  Method *meth_meth_ast__61__61_39 = addmethod2pos(obj29, "==", &meth_ast__61__61_39, 7);
  int argcv_meth_ast__61__61_39[] = {1};
  meth_meth_ast__61__61_39->type = alloc_MethodType(1, argcv_meth_ast__61__61_39);
  meth_meth_ast__61__61_39->definitionModule = modulename;
  meth_meth_ast__61__61_39->definitionLine = 95;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo42 = (struct UserObject*)obj29;
  uo42->data[8] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier42 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier42, 8);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier42[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier42);
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionLine = 96;
// method "isMatchingBlock"
  struct UserObject *uo44 = (struct UserObject*)obj29;
  uo44->data[9] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock44 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock44, 9);
  int argcv_meth_ast_isMatchingBlock44[] = {0};
  meth_meth_ast_isMatchingBlock44->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock44);
  meth_meth_ast_isMatchingBlock44->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock44->definitionLine = 97;
// method "isFieldDec"
  struct UserObject *uo46 = (struct UserObject*)obj29;
  uo46->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec46 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec46, 10);
  int argcv_meth_ast_isFieldDec46[] = {0};
  meth_meth_ast_isFieldDec46->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec46);
  meth_meth_ast_isFieldDec46->definitionModule = modulename;
  meth_meth_ast_isFieldDec46->definitionLine = 98;
// method "isInherits"
  struct UserObject *uo48 = (struct UserObject*)obj29;
  uo48->data[11] = emptyclosure;
  Method *meth_meth_ast_isInherits48 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits48, 11);
  int argcv_meth_ast_isInherits48[] = {0};
  meth_meth_ast_isInherits48->type = alloc_MethodType(1, argcv_meth_ast_isInherits48);
  meth_meth_ast_isInherits48->definitionModule = modulename;
  meth_meth_ast_isInherits48->definitionLine = 99;
// method "isLegalInTrait"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[12] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait50 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait50, 12);
  int argcv_meth_ast_isLegalInTrait50[] = {0};
  meth_meth_ast_isLegalInTrait50->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait50);
  meth_meth_ast_isLegalInTrait50->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait50->definitionLine = 100;
// method "isMember"
  struct UserObject *uo52 = (struct UserObject*)obj29;
  uo52->data[13] = emptyclosure;
  Method *meth_meth_ast_isMember52 = addmethod2pos(obj29, "isMember", &meth_ast_isMember52, 13);
  int argcv_meth_ast_isMember52[] = {0};
  meth_meth_ast_isMember52->type = alloc_MethodType(1, argcv_meth_ast_isMember52);
  meth_meth_ast_isMember52->definitionModule = modulename;
  meth_meth_ast_isMember52->definitionLine = 101;
// method "isMethod"
  struct UserObject *uo54 = (struct UserObject*)obj29;
  uo54->data[14] = emptyclosure;
  Method *meth_meth_ast_isMethod54 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod54, 14);
  int argcv_meth_ast_isMethod54[] = {0};
  meth_meth_ast_isMethod54->type = alloc_MethodType(1, argcv_meth_ast_isMethod54);
  meth_meth_ast_isMethod54->definitionModule = modulename;
  meth_meth_ast_isMethod54->definitionLine = 102;
// method "isExecutable"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[15] = emptyclosure;
  Method *meth_meth_ast_isExecutable56 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable56, 15);
  int argcv_meth_ast_isExecutable56[] = {0};
  meth_meth_ast_isExecutable56->type = alloc_MethodType(1, argcv_meth_ast_isExecutable56);
  meth_meth_ast_isExecutable56->definitionModule = modulename;
  meth_meth_ast_isExecutable56->definitionLine = 103;
// method "isCall"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[16] = emptyclosure;
  Method *meth_meth_ast_isCall58 = addmethod2pos(obj29, "isCall", &meth_ast_isCall58, 16);
  int argcv_meth_ast_isCall58[] = {0};
  meth_meth_ast_isCall58->type = alloc_MethodType(1, argcv_meth_ast_isCall58);
  meth_meth_ast_isCall58->definitionModule = modulename;
  meth_meth_ast_isCall58->definitionLine = 104;
// method "isComment"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[17] = emptyclosure;
  Method *meth_meth_ast_isComment60 = addmethod2pos(obj29, "isComment", &meth_ast_isComment60, 17);
  int argcv_meth_ast_isComment60[] = {0};
  meth_meth_ast_isComment60->type = alloc_MethodType(1, argcv_meth_ast_isComment60);
  meth_meth_ast_isComment60->definitionModule = modulename;
  meth_meth_ast_isComment60->definitionLine = 105;
// method "isClass"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[18] = emptyclosure;
  Method *meth_meth_ast_isClass62 = addmethod2pos(obj29, "isClass", &meth_ast_isClass62, 18);
  int argcv_meth_ast_isClass62[] = {0};
  meth_meth_ast_isClass62->type = alloc_MethodType(1, argcv_meth_ast_isClass62);
  meth_meth_ast_isClass62->definitionModule = modulename;
  meth_meth_ast_isClass62->definitionLine = 106;
// method "inClass"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[19] = emptyclosure;
  Method *meth_meth_ast_inClass64 = addmethod2pos(obj29, "inClass", &meth_ast_inClass64, 19);
  int argcv_meth_ast_inClass64[] = {0};
  meth_meth_ast_inClass64->type = alloc_MethodType(1, argcv_meth_ast_inClass64);
  meth_meth_ast_inClass64->definitionModule = modulename;
  meth_meth_ast_inClass64->definitionLine = 107;
// method "isTrait"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[20] = emptyclosure;
  Method *meth_meth_ast_isTrait66 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait66, 20);
  int argcv_meth_ast_isTrait66[] = {0};
  meth_meth_ast_isTrait66->type = alloc_MethodType(1, argcv_meth_ast_isTrait66);
  meth_meth_ast_isTrait66->definitionModule = modulename;
  meth_meth_ast_isTrait66->definitionLine = 108;
// method "inTrait"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[21] = emptyclosure;
  Method *meth_meth_ast_inTrait68 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait68, 21);
  int argcv_meth_ast_inTrait68[] = {0};
  meth_meth_ast_inTrait68->type = alloc_MethodType(1, argcv_meth_ast_inTrait68);
  meth_meth_ast_inTrait68->definitionModule = modulename;
  meth_meth_ast_inTrait68->definitionLine = 109;
// method "isBind"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[22] = emptyclosure;
  Method *meth_meth_ast_isBind70 = addmethod2pos(obj29, "isBind", &meth_ast_isBind70, 22);
  int argcv_meth_ast_isBind70[] = {0};
  meth_meth_ast_isBind70->type = alloc_MethodType(1, argcv_meth_ast_isBind70);
  meth_meth_ast_isBind70->definitionModule = modulename;
  meth_meth_ast_isBind70->definitionLine = 110;
// method "isBlock"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[23] = emptyclosure;
  Method *meth_meth_ast_isBlock72 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock72, 23);
  int argcv_meth_ast_isBlock72[] = {0};
  meth_meth_ast_isBlock72->type = alloc_MethodType(1, argcv_meth_ast_isBlock72);
  meth_meth_ast_isBlock72->definitionModule = modulename;
  meth_meth_ast_isBlock72->definitionLine = 111;
// method "isObject"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[24] = emptyclosure;
  Method *meth_meth_ast_isObject74 = addmethod2pos(obj29, "isObject", &meth_ast_isObject74, 24);
  int argcv_meth_ast_isObject74[] = {0};
  meth_meth_ast_isObject74->type = alloc_MethodType(1, argcv_meth_ast_isObject74);
  meth_meth_ast_isObject74->definitionModule = modulename;
  meth_meth_ast_isObject74->definitionLine = 112;
// method "isIdentifier"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[25] = emptyclosure;
  Method *meth_meth_ast_isIdentifier76 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier76, 25);
  int argcv_meth_ast_isIdentifier76[] = {0};
  meth_meth_ast_isIdentifier76->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier76);
  meth_meth_ast_isIdentifier76->definitionModule = modulename;
  meth_meth_ast_isIdentifier76->definitionLine = 113;
// method "isDialect"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[26] = emptyclosure;
  Method *meth_meth_ast_isDialect78 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect78, 26);
  int argcv_meth_ast_isDialect78[] = {0};
  meth_meth_ast_isDialect78->type = alloc_MethodType(1, argcv_meth_ast_isDialect78);
  meth_meth_ast_isDialect78->definitionModule = modulename;
  meth_meth_ast_isDialect78->definitionLine = 114;
// method "isImport"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[27] = emptyclosure;
  Method *meth_meth_ast_isImport80 = addmethod2pos(obj29, "isImport", &meth_ast_isImport80, 27);
  int argcv_meth_ast_isImport80[] = {0};
  meth_meth_ast_isImport80->type = alloc_MethodType(1, argcv_meth_ast_isImport80);
  meth_meth_ast_isImport80->definitionModule = modulename;
  meth_meth_ast_isImport80->definitionLine = 115;
// method "isTypeDec"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[28] = emptyclosure;
  Method *meth_meth_ast_isTypeDec82 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec82, 28);
  int argcv_meth_ast_isTypeDec82[] = {0};
  meth_meth_ast_isTypeDec82->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec82);
  meth_meth_ast_isTypeDec82->definitionModule = modulename;
  meth_meth_ast_isTypeDec82->definitionLine = 116;
// method "isExternal"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[29] = emptyclosure;
  Method *meth_meth_ast_isExternal84 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal84, 29);
  int argcv_meth_ast_isExternal84[] = {0};
  meth_meth_ast_isExternal84->type = alloc_MethodType(1, argcv_meth_ast_isExternal84);
  meth_meth_ast_isExternal84->definitionModule = modulename;
  meth_meth_ast_isExternal84->definitionLine = 117;
// method "canInherit"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[30] = emptyclosure;
  Method *meth_meth_ast_canInherit86 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit86, 30);
  int argcv_meth_ast_canInherit86[] = {0};
  meth_meth_ast_canInherit86->type = alloc_MethodType(1, argcv_meth_ast_canInherit86);
  meth_meth_ast_canInherit86->definitionModule = modulename;
  meth_meth_ast_canInherit86->definitionLine = 118;
// method "returnsObject"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[31] = emptyclosure;
  Method *meth_meth_ast_returnsObject88 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject88, 31);
  int argcv_meth_ast_returnsObject88[] = {0};
  meth_meth_ast_returnsObject88->type = alloc_MethodType(1, argcv_meth_ast_returnsObject88);
  meth_meth_ast_returnsObject88->definitionModule = modulename;
  meth_meth_ast_returnsObject88->definitionLine = 119;
// method "usesAsType"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[32] = emptyclosure;
  Method *meth_meth_ast_usesAsType90 = addmethod2pos(obj29, "usesAsType", &meth_ast_usesAsType90, 32);
  int argcv_meth_ast_usesAsType90[] = {1};
  meth_meth_ast_usesAsType90->type = alloc_MethodType(1, argcv_meth_ast_usesAsType90);
  meth_meth_ast_usesAsType90->definitionModule = modulename;
  meth_meth_ast_usesAsType90->definitionLine = 120;
// method "hash"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[33] = emptyclosure;
  Method *meth_meth_ast_hash92 = addmethod2pos(obj29, "hash", &meth_ast_hash92, 33);
  int argcv_meth_ast_hash92[] = {0};
  meth_meth_ast_hash92->type = alloc_MethodType(1, argcv_meth_ast_hash92);
  meth_meth_ast_hash92->definitionModule = modulename;
  meth_meth_ast_hash92->definitionLine = 121;
// method "asString"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_asString104 = addmethod2pos(obj29, "asString", &meth_ast_asString104, 34);
  int argcv_meth_ast_asString104[] = {0};
  meth_meth_ast_asString104->type = alloc_MethodType(1, argcv_meth_ast_asString104);
  meth_meth_ast_asString104->definitionModule = modulename;
  meth_meth_ast_asString104->definitionLine = 122;
// method "nameString"
  struct UserObject *uo124 = (struct UserObject*)obj29;
  uo124->data[35] = emptyclosure;
  Method *meth_meth_ast_nameString124 = addmethod2pos(obj29, "nameString", &meth_ast_nameString124, 35);
  int argcv_meth_ast_nameString124[] = {0};
  meth_meth_ast_nameString124->type = alloc_MethodType(1, argcv_meth_ast_nameString124);
  meth_meth_ast_nameString124->definitionModule = modulename;
  meth_meth_ast_nameString124->definitionLine = 123;
// method "isWritable"
  struct UserObject *uo126 = (struct UserObject*)obj29;
  uo126->data[36] = emptyclosure;
  Method *meth_meth_ast_isWritable126 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable126, 36);
  int argcv_meth_ast_isWritable126[] = {0};
  meth_meth_ast_isWritable126->type = alloc_MethodType(1, argcv_meth_ast_isWritable126);
  meth_meth_ast_isWritable126->definitionModule = modulename;
  meth_meth_ast_isWritable126->definitionLine = 124;
// method "isReadable"
  struct UserObject *uo128 = (struct UserObject*)obj29;
  uo128->data[37] = emptyclosure;
  Method *meth_meth_ast_isReadable128 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable128, 37);
  int argcv_meth_ast_isReadable128[] = {0};
  meth_meth_ast_isReadable128->type = alloc_MethodType(1, argcv_meth_ast_isReadable128);
  meth_meth_ast_isReadable128->definitionModule = modulename;
  meth_meth_ast_isReadable128->definitionLine = 125;
// method "isPublic"
  struct UserObject *uo130 = (struct UserObject*)obj29;
  uo130->data[38] = emptyclosure;
  Method *meth_meth_ast_isPublic130 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic130, 38);
  int argcv_meth_ast_isPublic130[] = {0};
  meth_meth_ast_isPublic130->type = alloc_MethodType(1, argcv_meth_ast_isPublic130);
  meth_meth_ast_isPublic130->definitionModule = modulename;
  meth_meth_ast_isPublic130->definitionLine = 126;
// method "isConfidential"
  struct UserObject *uo132 = (struct UserObject*)obj29;
  uo132->data[39] = emptyclosure;
  Method *meth_meth_ast_isConfidential132 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential132, 39);
  int argcv_meth_ast_isConfidential132[] = {0};
  meth_meth_ast_isConfidential132->type = alloc_MethodType(1, argcv_meth_ast_isConfidential132);
  meth_meth_ast_isConfidential132->definitionModule = modulename;
  meth_meth_ast_isConfidential132->definitionLine = 127;
// method "decType"
  block_savedest(obj29);
  Object closure137 = createclosure(1, "decType");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_unknownType);
  struct UserObject *uo137 = (struct UserObject*)obj29;
  uo137->data[40] = (Object)closure137;
  Method *meth_meth_ast_decType137 = addmethod2pos(obj29, "decType", &meth_ast_decType137, 40);
  int argcv_meth_ast_decType137[] = {0};
  meth_meth_ast_decType137->type = alloc_MethodType(1, argcv_meth_ast_decType137);
  meth_meth_ast_decType137->definitionModule = modulename;
  meth_meth_ast_decType137->definitionLine = 128;
// method "isSimple"
  struct UserObject *uo147 = (struct UserObject*)obj29;
  uo147->data[41] = emptyclosure;
  Method *meth_meth_ast_isSimple147 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple147, 41);
  int argcv_meth_ast_isSimple147[] = {0};
  meth_meth_ast_isSimple147->type = alloc_MethodType(1, argcv_meth_ast_isSimple147);
  meth_meth_ast_isSimple147->definitionModule = modulename;
  meth_meth_ast_isSimple147->definitionLine = 134;
// method "description"
  struct UserObject *uo149 = (struct UserObject*)obj29;
  uo149->data[42] = emptyclosure;
  Method *meth_meth_ast_description149 = addmethod2pos(obj29, "description", &meth_ast_description149, 42);
  int argcv_meth_ast_description149[] = {0};
  meth_meth_ast_description149->type = alloc_MethodType(1, argcv_meth_ast_description149);
  meth_meth_ast_description149->definitionModule = modulename;
  meth_meth_ast_description149->definitionLine = 135;
// method "accept"
  block_savedest(obj29);
  Object closure152 = createclosure(1, "accept");
  setclosureframe(closure152, stackframe);
  addtoclosure(closure152, var_ancestorChain);
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[43] = (Object)closure152;
  Method *meth_meth_ast_accept152 = addmethod2pos(obj29, "accept", &meth_ast_accept152, 43);
  int argcv_meth_ast_accept152[] = {1};
  meth_meth_ast_accept152->type = alloc_MethodType(1, argcv_meth_ast_accept152);
  meth_meth_ast_accept152->definitionModule = modulename;
  meth_meth_ast_accept152->definitionLine = 136;
// method "scope"
  struct UserObject *uo157 = (struct UserObject*)obj29;
  uo157->data[44] = emptyclosure;
  Method *meth_meth_ast_scope157 = addmethod2pos(obj29, "scope", &meth_ast_scope157, 44);
  int argcv_meth_ast_scope157[] = {0};
  meth_meth_ast_scope157->type = alloc_MethodType(1, argcv_meth_ast_scope157);
  meth_meth_ast_scope157->definitionModule = modulename;
  meth_meth_ast_scope157->definitionLine = 139;
// method "scope:="
  struct UserObject *uo160 = (struct UserObject*)obj29;
  uo160->data[45] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_160 = addmethod2pos(obj29, "scope:=", &meth_ast_scope_58__61_160, 45);
  int argcv_meth_ast_scope_58__61_160[] = {1};
  meth_meth_ast_scope_58__61_160->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_160);
  meth_meth_ast_scope_58__61_160->definitionModule = modulename;
  meth_meth_ast_scope_58__61_160->definitionLine = 141;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo163 = (struct UserObject*)obj29;
  uo163->data[46] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom163 = addmethod2pos(obj29, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom163, 46);
  int argcv_meth_ast_shallowCopyFieldsFrom163[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom163->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom163);
  meth_meth_ast_shallowCopyFieldsFrom163->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom163->definitionLine = 148;
// method "pretty"
  block_savedest(obj29);
  Object closure180 = createclosure(1, "pretty");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_util);
  struct UserObject *uo180 = (struct UserObject*)obj29;
  uo180->data[47] = (Object)closure180;
  Method *meth_meth_ast_pretty180 = addmethod2pos(obj29, "pretty", &meth_ast_pretty180, 47);
  int argcv_meth_ast_pretty180[] = {1};
  meth_meth_ast_pretty180->type = alloc_MethodType(1, argcv_meth_ast_pretty180);
  meth_meth_ast_pretty180->definitionModule = modulename;
  meth_meth_ast_pretty180->definitionLine = 155;
// method "deepCopy"
  block_savedest(obj29);
  Object closure358 = createclosure(1, "deepCopy");
  setclosureframe(closure358, stackframe);
  addtoclosure(closure358, var_ancestorChain);
  struct UserObject *uo358 = (struct UserObject*)obj29;
  uo358->data[48] = (Object)closure358;
  Method *meth_meth_ast_deepCopy358 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy358, 48);
  int argcv_meth_ast_deepCopy358[] = {0};
  meth_meth_ast_deepCopy358->type = alloc_MethodType(1, argcv_meth_ast_deepCopy358);
  meth_meth_ast_deepCopy358->definitionModule = modulename;
  meth_meth_ast_deepCopy358->definitionLine = 168;
// method "enclosingObject"
  struct UserObject *uo366 = (struct UserObject*)obj29;
  uo366->data[49] = emptyclosure;
  Method *meth_meth_ast_enclosingObject366 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject366, 49);
  int argcv_meth_ast_enclosingObject366[] = {0};
  meth_meth_ast_enclosingObject366->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject366);
  meth_meth_ast_enclosingObject366->definitionModule = modulename;
  meth_meth_ast_enclosingObject366->definitionLine = 171;
// method "addComment"
  struct UserObject *uo373 = (struct UserObject*)obj29;
  uo373->data[50] = emptyclosure;
  Method *meth_meth_ast_addComment373 = addmethod2pos(obj29, "addComment", &meth_ast_addComment373, 50);
  int argcv_meth_ast_addComment373[] = {1};
  meth_meth_ast_addComment373->type = alloc_MethodType(1, argcv_meth_ast_addComment373);
  meth_meth_ast_addComment373->definitionModule = modulename;
  meth_meth_ast_addComment373->definitionLine = 175;
// method "addComments"
  struct UserObject *uo387 = (struct UserObject*)obj29;
  uo387->data[51] = emptyclosure;
  Method *meth_meth_ast_addComments387 = addmethod2pos(obj29, "addComments", &meth_ast_addComments387, 51);
  int argcv_meth_ast_addComments387[] = {1};
  meth_meth_ast_addComments387->type = alloc_MethodType(1, argcv_meth_ast_addComments387);
  meth_meth_ast_addComments387->definitionModule = modulename;
  meth_meth_ast_addComments387->definitionLine = 182;
// method "statementName"
  struct UserObject *uo395 = (struct UserObject*)obj29;
  uo395->data[52] = emptyclosure;
  Method *meth_meth_ast_statementName395 = addmethod2pos(obj29, "statementName", &meth_ast_statementName395, 52);
  int argcv_meth_ast_statementName395[] = {0};
  meth_meth_ast_statementName395->type = alloc_MethodType(1, argcv_meth_ast_statementName395);
  meth_meth_ast_statementName395->definitionModule = modulename;
  meth_meth_ast_statementName395->definitionLine = 185;
  sourceObject = obj29;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit398 == NULL) {
    strlit398 = alloc_String("");
    gc_root(strlit398);
  }
// compiled string node returning strlit398 (depth = 2)
  adddatum2(obj29, strlit398, 1);
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call400 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call400 (depth = 3)
// compiled member node returning call400 (depth = 2)
  adddatum2(obj29, call400, 2);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call402 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe401);
// compiled call node returning call402 (depth = 3)
// compiled member node returning call402 (depth = 2)
  adddatum2(obj29, call402, 3);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool403 = alloc_Boolean(0);
// compiled identifier node returning bool403 (depth = 2)
  adddatum2(obj29, bool403, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 86;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_baseNode28_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_fakeSymbolTable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject29 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj29 = alloc_userobj2(57,53, objclass29);
  gc_frame_newslot(obj29);
if (objclass29 == NULL) {
  glfree(obj29->class->name);
  obj29->class->name = "ast.baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj29, self, 0);
  addmethodreal(obj29,"outer", &reader_ast_outer_30);
  Object oldself29 = self;
  struct StackFrameObject *oldstackframe29 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe29);
  gc_frame_newslot((Object)stackframe);
  self = obj29;
  Object *oldselfslot29 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter29 = (*(struct UserObject *)self).data[0], lowerouter29 = thisouter29;
  if (inheritingObject29) {
    struct UserObject *inho29 = (struct UserObject *)inheritingObject29;
    while (inho29->super != GraceDefaultObject) inho29 = (struct UserObject *)inho29->super;
    inho29->super = obj29;
    self = inheritingObject29;
    *selfslot = self;
    lowerouter29 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter29;
  }
if (objclass29 == NULL) {
  Method *reader31 = addmethodrealflags(obj29, "register",&reader_ast_register_31, 0);
  Method *writer31 = addmethodrealflags(obj29, "register:=",&writer_ast_register_31, 0);
  reader31->definitionModule = modulename;
  writer31->definitionModule = modulename;
  reader31->definitionLine = 88;
  writer31->definitionLine = 88;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 1);
if (objclass29 == NULL) {
  Method *reader32 = addmethodrealflags(obj29, "line",&reader_ast_line_32, 0);
  Method *writer32 = addmethodrealflags(obj29, "line:=",&writer_ast_line_32, 0);
  reader32->definitionModule = modulename;
  writer32->definitionModule = modulename;
  reader32->definitionLine = 89;
  writer32->definitionLine = 89;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 2);
if (objclass29 == NULL) {
  Method *reader33 = addmethodrealflags(obj29, "linePos",&reader_ast_linePos_33, 0);
  Method *writer33 = addmethodrealflags(obj29, "linePos:=",&writer_ast_linePos_33, 0);
  reader33->definitionModule = modulename;
  writer33->definitionModule = modulename;
  reader33->definitionLine = 90;
  writer33->definitionLine = 90;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 3);
if (objclass29 == NULL) {
  Method *reader34 = addmethodrealflags(obj29, "symbolTable",&reader_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  Method *writer34 = addmethodrealflags(obj29, "symbolTable:=",&writer_ast_symbolTable_34, MFLAG_CONFIDENTIAL);
  reader34->definitionModule = modulename;
  writer34->definitionModule = modulename;
  reader34->definitionLine = 91;
  writer34->definitionLine = 91;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 4);
if (objclass29 == NULL) {
  Method *reader35 = addmethodrealflags(obj29, "comments",&reader_ast_comments_35, 0);
  Method *writer35 = addmethodrealflags(obj29, "comments:=",&writer_ast_comments_35, 0);
  reader35->definitionModule = modulename;
  writer35->definitionModule = modulename;
  reader35->definitionLine = 92;
  writer35->definitionLine = 92;
}
obj29->flags |= OFLAG_MUTABLE;
adddatum2(obj29, alloc_Undefined(), 5);
// method "kind"
  struct UserObject *uo36 = (struct UserObject*)obj29;
  uo36->data[6] = emptyclosure;
  Method *meth_meth_ast_kind36 = addmethod2pos(obj29, "kind", &meth_ast_kind36, 6);
  int argcv_meth_ast_kind36[] = {0};
  meth_meth_ast_kind36->type = alloc_MethodType(1, argcv_meth_ast_kind36);
  meth_meth_ast_kind36->definitionModule = modulename;
  meth_meth_ast_kind36->definitionLine = 94;
// method "=="
  struct UserObject *uo39 = (struct UserObject*)obj29;
  uo39->data[7] = emptyclosure;
  Method *meth_meth_ast__61__61_39 = addmethod2pos(obj29, "==", &meth_ast__61__61_39, 7);
  int argcv_meth_ast__61__61_39[] = {1};
  meth_meth_ast__61__61_39->type = alloc_MethodType(1, argcv_meth_ast__61__61_39);
  meth_meth_ast__61__61_39->definitionModule = modulename;
  meth_meth_ast__61__61_39->definitionLine = 95;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo42 = (struct UserObject*)obj29;
  uo42->data[8] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier42 = addmethod2pos(obj29, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier42, 8);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier42[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier42);
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier42->definitionLine = 96;
// method "isMatchingBlock"
  struct UserObject *uo44 = (struct UserObject*)obj29;
  uo44->data[9] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock44 = addmethod2pos(obj29, "isMatchingBlock", &meth_ast_isMatchingBlock44, 9);
  int argcv_meth_ast_isMatchingBlock44[] = {0};
  meth_meth_ast_isMatchingBlock44->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock44);
  meth_meth_ast_isMatchingBlock44->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock44->definitionLine = 97;
// method "isFieldDec"
  struct UserObject *uo46 = (struct UserObject*)obj29;
  uo46->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec46 = addmethod2pos(obj29, "isFieldDec", &meth_ast_isFieldDec46, 10);
  int argcv_meth_ast_isFieldDec46[] = {0};
  meth_meth_ast_isFieldDec46->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec46);
  meth_meth_ast_isFieldDec46->definitionModule = modulename;
  meth_meth_ast_isFieldDec46->definitionLine = 98;
// method "isInherits"
  struct UserObject *uo48 = (struct UserObject*)obj29;
  uo48->data[11] = emptyclosure;
  Method *meth_meth_ast_isInherits48 = addmethod2pos(obj29, "isInherits", &meth_ast_isInherits48, 11);
  int argcv_meth_ast_isInherits48[] = {0};
  meth_meth_ast_isInherits48->type = alloc_MethodType(1, argcv_meth_ast_isInherits48);
  meth_meth_ast_isInherits48->definitionModule = modulename;
  meth_meth_ast_isInherits48->definitionLine = 99;
// method "isLegalInTrait"
  struct UserObject *uo50 = (struct UserObject*)obj29;
  uo50->data[12] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait50 = addmethod2pos(obj29, "isLegalInTrait", &meth_ast_isLegalInTrait50, 12);
  int argcv_meth_ast_isLegalInTrait50[] = {0};
  meth_meth_ast_isLegalInTrait50->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait50);
  meth_meth_ast_isLegalInTrait50->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait50->definitionLine = 100;
// method "isMember"
  struct UserObject *uo52 = (struct UserObject*)obj29;
  uo52->data[13] = emptyclosure;
  Method *meth_meth_ast_isMember52 = addmethod2pos(obj29, "isMember", &meth_ast_isMember52, 13);
  int argcv_meth_ast_isMember52[] = {0};
  meth_meth_ast_isMember52->type = alloc_MethodType(1, argcv_meth_ast_isMember52);
  meth_meth_ast_isMember52->definitionModule = modulename;
  meth_meth_ast_isMember52->definitionLine = 101;
// method "isMethod"
  struct UserObject *uo54 = (struct UserObject*)obj29;
  uo54->data[14] = emptyclosure;
  Method *meth_meth_ast_isMethod54 = addmethod2pos(obj29, "isMethod", &meth_ast_isMethod54, 14);
  int argcv_meth_ast_isMethod54[] = {0};
  meth_meth_ast_isMethod54->type = alloc_MethodType(1, argcv_meth_ast_isMethod54);
  meth_meth_ast_isMethod54->definitionModule = modulename;
  meth_meth_ast_isMethod54->definitionLine = 102;
// method "isExecutable"
  struct UserObject *uo56 = (struct UserObject*)obj29;
  uo56->data[15] = emptyclosure;
  Method *meth_meth_ast_isExecutable56 = addmethod2pos(obj29, "isExecutable", &meth_ast_isExecutable56, 15);
  int argcv_meth_ast_isExecutable56[] = {0};
  meth_meth_ast_isExecutable56->type = alloc_MethodType(1, argcv_meth_ast_isExecutable56);
  meth_meth_ast_isExecutable56->definitionModule = modulename;
  meth_meth_ast_isExecutable56->definitionLine = 103;
// method "isCall"
  struct UserObject *uo58 = (struct UserObject*)obj29;
  uo58->data[16] = emptyclosure;
  Method *meth_meth_ast_isCall58 = addmethod2pos(obj29, "isCall", &meth_ast_isCall58, 16);
  int argcv_meth_ast_isCall58[] = {0};
  meth_meth_ast_isCall58->type = alloc_MethodType(1, argcv_meth_ast_isCall58);
  meth_meth_ast_isCall58->definitionModule = modulename;
  meth_meth_ast_isCall58->definitionLine = 104;
// method "isComment"
  struct UserObject *uo60 = (struct UserObject*)obj29;
  uo60->data[17] = emptyclosure;
  Method *meth_meth_ast_isComment60 = addmethod2pos(obj29, "isComment", &meth_ast_isComment60, 17);
  int argcv_meth_ast_isComment60[] = {0};
  meth_meth_ast_isComment60->type = alloc_MethodType(1, argcv_meth_ast_isComment60);
  meth_meth_ast_isComment60->definitionModule = modulename;
  meth_meth_ast_isComment60->definitionLine = 105;
// method "isClass"
  struct UserObject *uo62 = (struct UserObject*)obj29;
  uo62->data[18] = emptyclosure;
  Method *meth_meth_ast_isClass62 = addmethod2pos(obj29, "isClass", &meth_ast_isClass62, 18);
  int argcv_meth_ast_isClass62[] = {0};
  meth_meth_ast_isClass62->type = alloc_MethodType(1, argcv_meth_ast_isClass62);
  meth_meth_ast_isClass62->definitionModule = modulename;
  meth_meth_ast_isClass62->definitionLine = 106;
// method "inClass"
  struct UserObject *uo64 = (struct UserObject*)obj29;
  uo64->data[19] = emptyclosure;
  Method *meth_meth_ast_inClass64 = addmethod2pos(obj29, "inClass", &meth_ast_inClass64, 19);
  int argcv_meth_ast_inClass64[] = {0};
  meth_meth_ast_inClass64->type = alloc_MethodType(1, argcv_meth_ast_inClass64);
  meth_meth_ast_inClass64->definitionModule = modulename;
  meth_meth_ast_inClass64->definitionLine = 107;
// method "isTrait"
  struct UserObject *uo66 = (struct UserObject*)obj29;
  uo66->data[20] = emptyclosure;
  Method *meth_meth_ast_isTrait66 = addmethod2pos(obj29, "isTrait", &meth_ast_isTrait66, 20);
  int argcv_meth_ast_isTrait66[] = {0};
  meth_meth_ast_isTrait66->type = alloc_MethodType(1, argcv_meth_ast_isTrait66);
  meth_meth_ast_isTrait66->definitionModule = modulename;
  meth_meth_ast_isTrait66->definitionLine = 108;
// method "inTrait"
  struct UserObject *uo68 = (struct UserObject*)obj29;
  uo68->data[21] = emptyclosure;
  Method *meth_meth_ast_inTrait68 = addmethod2pos(obj29, "inTrait", &meth_ast_inTrait68, 21);
  int argcv_meth_ast_inTrait68[] = {0};
  meth_meth_ast_inTrait68->type = alloc_MethodType(1, argcv_meth_ast_inTrait68);
  meth_meth_ast_inTrait68->definitionModule = modulename;
  meth_meth_ast_inTrait68->definitionLine = 109;
// method "isBind"
  struct UserObject *uo70 = (struct UserObject*)obj29;
  uo70->data[22] = emptyclosure;
  Method *meth_meth_ast_isBind70 = addmethod2pos(obj29, "isBind", &meth_ast_isBind70, 22);
  int argcv_meth_ast_isBind70[] = {0};
  meth_meth_ast_isBind70->type = alloc_MethodType(1, argcv_meth_ast_isBind70);
  meth_meth_ast_isBind70->definitionModule = modulename;
  meth_meth_ast_isBind70->definitionLine = 110;
// method "isBlock"
  struct UserObject *uo72 = (struct UserObject*)obj29;
  uo72->data[23] = emptyclosure;
  Method *meth_meth_ast_isBlock72 = addmethod2pos(obj29, "isBlock", &meth_ast_isBlock72, 23);
  int argcv_meth_ast_isBlock72[] = {0};
  meth_meth_ast_isBlock72->type = alloc_MethodType(1, argcv_meth_ast_isBlock72);
  meth_meth_ast_isBlock72->definitionModule = modulename;
  meth_meth_ast_isBlock72->definitionLine = 111;
// method "isObject"
  struct UserObject *uo74 = (struct UserObject*)obj29;
  uo74->data[24] = emptyclosure;
  Method *meth_meth_ast_isObject74 = addmethod2pos(obj29, "isObject", &meth_ast_isObject74, 24);
  int argcv_meth_ast_isObject74[] = {0};
  meth_meth_ast_isObject74->type = alloc_MethodType(1, argcv_meth_ast_isObject74);
  meth_meth_ast_isObject74->definitionModule = modulename;
  meth_meth_ast_isObject74->definitionLine = 112;
// method "isIdentifier"
  struct UserObject *uo76 = (struct UserObject*)obj29;
  uo76->data[25] = emptyclosure;
  Method *meth_meth_ast_isIdentifier76 = addmethod2pos(obj29, "isIdentifier", &meth_ast_isIdentifier76, 25);
  int argcv_meth_ast_isIdentifier76[] = {0};
  meth_meth_ast_isIdentifier76->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier76);
  meth_meth_ast_isIdentifier76->definitionModule = modulename;
  meth_meth_ast_isIdentifier76->definitionLine = 113;
// method "isDialect"
  struct UserObject *uo78 = (struct UserObject*)obj29;
  uo78->data[26] = emptyclosure;
  Method *meth_meth_ast_isDialect78 = addmethod2pos(obj29, "isDialect", &meth_ast_isDialect78, 26);
  int argcv_meth_ast_isDialect78[] = {0};
  meth_meth_ast_isDialect78->type = alloc_MethodType(1, argcv_meth_ast_isDialect78);
  meth_meth_ast_isDialect78->definitionModule = modulename;
  meth_meth_ast_isDialect78->definitionLine = 114;
// method "isImport"
  struct UserObject *uo80 = (struct UserObject*)obj29;
  uo80->data[27] = emptyclosure;
  Method *meth_meth_ast_isImport80 = addmethod2pos(obj29, "isImport", &meth_ast_isImport80, 27);
  int argcv_meth_ast_isImport80[] = {0};
  meth_meth_ast_isImport80->type = alloc_MethodType(1, argcv_meth_ast_isImport80);
  meth_meth_ast_isImport80->definitionModule = modulename;
  meth_meth_ast_isImport80->definitionLine = 115;
// method "isTypeDec"
  struct UserObject *uo82 = (struct UserObject*)obj29;
  uo82->data[28] = emptyclosure;
  Method *meth_meth_ast_isTypeDec82 = addmethod2pos(obj29, "isTypeDec", &meth_ast_isTypeDec82, 28);
  int argcv_meth_ast_isTypeDec82[] = {0};
  meth_meth_ast_isTypeDec82->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec82);
  meth_meth_ast_isTypeDec82->definitionModule = modulename;
  meth_meth_ast_isTypeDec82->definitionLine = 116;
// method "isExternal"
  struct UserObject *uo84 = (struct UserObject*)obj29;
  uo84->data[29] = emptyclosure;
  Method *meth_meth_ast_isExternal84 = addmethod2pos(obj29, "isExternal", &meth_ast_isExternal84, 29);
  int argcv_meth_ast_isExternal84[] = {0};
  meth_meth_ast_isExternal84->type = alloc_MethodType(1, argcv_meth_ast_isExternal84);
  meth_meth_ast_isExternal84->definitionModule = modulename;
  meth_meth_ast_isExternal84->definitionLine = 117;
// method "canInherit"
  struct UserObject *uo86 = (struct UserObject*)obj29;
  uo86->data[30] = emptyclosure;
  Method *meth_meth_ast_canInherit86 = addmethod2pos(obj29, "canInherit", &meth_ast_canInherit86, 30);
  int argcv_meth_ast_canInherit86[] = {0};
  meth_meth_ast_canInherit86->type = alloc_MethodType(1, argcv_meth_ast_canInherit86);
  meth_meth_ast_canInherit86->definitionModule = modulename;
  meth_meth_ast_canInherit86->definitionLine = 118;
// method "returnsObject"
  struct UserObject *uo88 = (struct UserObject*)obj29;
  uo88->data[31] = emptyclosure;
  Method *meth_meth_ast_returnsObject88 = addmethod2pos(obj29, "returnsObject", &meth_ast_returnsObject88, 31);
  int argcv_meth_ast_returnsObject88[] = {0};
  meth_meth_ast_returnsObject88->type = alloc_MethodType(1, argcv_meth_ast_returnsObject88);
  meth_meth_ast_returnsObject88->definitionModule = modulename;
  meth_meth_ast_returnsObject88->definitionLine = 119;
// method "usesAsType"
  struct UserObject *uo90 = (struct UserObject*)obj29;
  uo90->data[32] = emptyclosure;
  Method *meth_meth_ast_usesAsType90 = addmethod2pos(obj29, "usesAsType", &meth_ast_usesAsType90, 32);
  int argcv_meth_ast_usesAsType90[] = {1};
  meth_meth_ast_usesAsType90->type = alloc_MethodType(1, argcv_meth_ast_usesAsType90);
  meth_meth_ast_usesAsType90->definitionModule = modulename;
  meth_meth_ast_usesAsType90->definitionLine = 120;
// method "hash"
  struct UserObject *uo92 = (struct UserObject*)obj29;
  uo92->data[33] = emptyclosure;
  Method *meth_meth_ast_hash92 = addmethod2pos(obj29, "hash", &meth_ast_hash92, 33);
  int argcv_meth_ast_hash92[] = {0};
  meth_meth_ast_hash92->type = alloc_MethodType(1, argcv_meth_ast_hash92);
  meth_meth_ast_hash92->definitionModule = modulename;
  meth_meth_ast_hash92->definitionLine = 121;
// method "asString"
  struct UserObject *uo104 = (struct UserObject*)obj29;
  uo104->data[34] = emptyclosure;
  Method *meth_meth_ast_asString104 = addmethod2pos(obj29, "asString", &meth_ast_asString104, 34);
  int argcv_meth_ast_asString104[] = {0};
  meth_meth_ast_asString104->type = alloc_MethodType(1, argcv_meth_ast_asString104);
  meth_meth_ast_asString104->definitionModule = modulename;
  meth_meth_ast_asString104->definitionLine = 122;
// method "nameString"
  struct UserObject *uo124 = (struct UserObject*)obj29;
  uo124->data[35] = emptyclosure;
  Method *meth_meth_ast_nameString124 = addmethod2pos(obj29, "nameString", &meth_ast_nameString124, 35);
  int argcv_meth_ast_nameString124[] = {0};
  meth_meth_ast_nameString124->type = alloc_MethodType(1, argcv_meth_ast_nameString124);
  meth_meth_ast_nameString124->definitionModule = modulename;
  meth_meth_ast_nameString124->definitionLine = 123;
// method "isWritable"
  struct UserObject *uo126 = (struct UserObject*)obj29;
  uo126->data[36] = emptyclosure;
  Method *meth_meth_ast_isWritable126 = addmethod2pos(obj29, "isWritable", &meth_ast_isWritable126, 36);
  int argcv_meth_ast_isWritable126[] = {0};
  meth_meth_ast_isWritable126->type = alloc_MethodType(1, argcv_meth_ast_isWritable126);
  meth_meth_ast_isWritable126->definitionModule = modulename;
  meth_meth_ast_isWritable126->definitionLine = 124;
// method "isReadable"
  struct UserObject *uo128 = (struct UserObject*)obj29;
  uo128->data[37] = emptyclosure;
  Method *meth_meth_ast_isReadable128 = addmethod2pos(obj29, "isReadable", &meth_ast_isReadable128, 37);
  int argcv_meth_ast_isReadable128[] = {0};
  meth_meth_ast_isReadable128->type = alloc_MethodType(1, argcv_meth_ast_isReadable128);
  meth_meth_ast_isReadable128->definitionModule = modulename;
  meth_meth_ast_isReadable128->definitionLine = 125;
// method "isPublic"
  struct UserObject *uo130 = (struct UserObject*)obj29;
  uo130->data[38] = emptyclosure;
  Method *meth_meth_ast_isPublic130 = addmethod2pos(obj29, "isPublic", &meth_ast_isPublic130, 38);
  int argcv_meth_ast_isPublic130[] = {0};
  meth_meth_ast_isPublic130->type = alloc_MethodType(1, argcv_meth_ast_isPublic130);
  meth_meth_ast_isPublic130->definitionModule = modulename;
  meth_meth_ast_isPublic130->definitionLine = 126;
// method "isConfidential"
  struct UserObject *uo132 = (struct UserObject*)obj29;
  uo132->data[39] = emptyclosure;
  Method *meth_meth_ast_isConfidential132 = addmethod2pos(obj29, "isConfidential", &meth_ast_isConfidential132, 39);
  int argcv_meth_ast_isConfidential132[] = {0};
  meth_meth_ast_isConfidential132->type = alloc_MethodType(1, argcv_meth_ast_isConfidential132);
  meth_meth_ast_isConfidential132->definitionModule = modulename;
  meth_meth_ast_isConfidential132->definitionLine = 127;
// method "decType"
  block_savedest(obj29);
  Object closure137 = createclosure(1, "decType");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_unknownType);
  struct UserObject *uo137 = (struct UserObject*)obj29;
  uo137->data[40] = (Object)closure137;
  Method *meth_meth_ast_decType137 = addmethod2pos(obj29, "decType", &meth_ast_decType137, 40);
  int argcv_meth_ast_decType137[] = {0};
  meth_meth_ast_decType137->type = alloc_MethodType(1, argcv_meth_ast_decType137);
  meth_meth_ast_decType137->definitionModule = modulename;
  meth_meth_ast_decType137->definitionLine = 128;
// method "isSimple"
  struct UserObject *uo147 = (struct UserObject*)obj29;
  uo147->data[41] = emptyclosure;
  Method *meth_meth_ast_isSimple147 = addmethod2pos(obj29, "isSimple", &meth_ast_isSimple147, 41);
  int argcv_meth_ast_isSimple147[] = {0};
  meth_meth_ast_isSimple147->type = alloc_MethodType(1, argcv_meth_ast_isSimple147);
  meth_meth_ast_isSimple147->definitionModule = modulename;
  meth_meth_ast_isSimple147->definitionLine = 134;
// method "description"
  struct UserObject *uo149 = (struct UserObject*)obj29;
  uo149->data[42] = emptyclosure;
  Method *meth_meth_ast_description149 = addmethod2pos(obj29, "description", &meth_ast_description149, 42);
  int argcv_meth_ast_description149[] = {0};
  meth_meth_ast_description149->type = alloc_MethodType(1, argcv_meth_ast_description149);
  meth_meth_ast_description149->definitionModule = modulename;
  meth_meth_ast_description149->definitionLine = 135;
// method "accept"
  block_savedest(obj29);
  Object closure152 = createclosure(1, "accept");
  setclosureframe(closure152, stackframe);
  addtoclosure(closure152, var_ancestorChain);
  struct UserObject *uo152 = (struct UserObject*)obj29;
  uo152->data[43] = (Object)closure152;
  Method *meth_meth_ast_accept152 = addmethod2pos(obj29, "accept", &meth_ast_accept152, 43);
  int argcv_meth_ast_accept152[] = {1};
  meth_meth_ast_accept152->type = alloc_MethodType(1, argcv_meth_ast_accept152);
  meth_meth_ast_accept152->definitionModule = modulename;
  meth_meth_ast_accept152->definitionLine = 136;
// method "scope"
  struct UserObject *uo157 = (struct UserObject*)obj29;
  uo157->data[44] = emptyclosure;
  Method *meth_meth_ast_scope157 = addmethod2pos(obj29, "scope", &meth_ast_scope157, 44);
  int argcv_meth_ast_scope157[] = {0};
  meth_meth_ast_scope157->type = alloc_MethodType(1, argcv_meth_ast_scope157);
  meth_meth_ast_scope157->definitionModule = modulename;
  meth_meth_ast_scope157->definitionLine = 139;
// method "scope:="
  struct UserObject *uo160 = (struct UserObject*)obj29;
  uo160->data[45] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_160 = addmethod2pos(obj29, "scope:=", &meth_ast_scope_58__61_160, 45);
  int argcv_meth_ast_scope_58__61_160[] = {1};
  meth_meth_ast_scope_58__61_160->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_160);
  meth_meth_ast_scope_58__61_160->definitionModule = modulename;
  meth_meth_ast_scope_58__61_160->definitionLine = 141;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo163 = (struct UserObject*)obj29;
  uo163->data[46] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom163 = addmethod2pos(obj29, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom163, 46);
  int argcv_meth_ast_shallowCopyFieldsFrom163[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom163->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom163);
  meth_meth_ast_shallowCopyFieldsFrom163->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom163->definitionLine = 148;
// method "pretty"
  block_savedest(obj29);
  Object closure180 = createclosure(1, "pretty");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_util);
  struct UserObject *uo180 = (struct UserObject*)obj29;
  uo180->data[47] = (Object)closure180;
  Method *meth_meth_ast_pretty180 = addmethod2pos(obj29, "pretty", &meth_ast_pretty180, 47);
  int argcv_meth_ast_pretty180[] = {1};
  meth_meth_ast_pretty180->type = alloc_MethodType(1, argcv_meth_ast_pretty180);
  meth_meth_ast_pretty180->definitionModule = modulename;
  meth_meth_ast_pretty180->definitionLine = 155;
// method "deepCopy"
  block_savedest(obj29);
  Object closure358 = createclosure(1, "deepCopy");
  setclosureframe(closure358, stackframe);
  addtoclosure(closure358, var_ancestorChain);
  struct UserObject *uo358 = (struct UserObject*)obj29;
  uo358->data[48] = (Object)closure358;
  Method *meth_meth_ast_deepCopy358 = addmethod2pos(obj29, "deepCopy", &meth_ast_deepCopy358, 48);
  int argcv_meth_ast_deepCopy358[] = {0};
  meth_meth_ast_deepCopy358->type = alloc_MethodType(1, argcv_meth_ast_deepCopy358);
  meth_meth_ast_deepCopy358->definitionModule = modulename;
  meth_meth_ast_deepCopy358->definitionLine = 168;
// method "enclosingObject"
  struct UserObject *uo366 = (struct UserObject*)obj29;
  uo366->data[49] = emptyclosure;
  Method *meth_meth_ast_enclosingObject366 = addmethod2pos(obj29, "enclosingObject", &meth_ast_enclosingObject366, 49);
  int argcv_meth_ast_enclosingObject366[] = {0};
  meth_meth_ast_enclosingObject366->type = alloc_MethodType(1, argcv_meth_ast_enclosingObject366);
  meth_meth_ast_enclosingObject366->definitionModule = modulename;
  meth_meth_ast_enclosingObject366->definitionLine = 171;
// method "addComment"
  struct UserObject *uo373 = (struct UserObject*)obj29;
  uo373->data[50] = emptyclosure;
  Method *meth_meth_ast_addComment373 = addmethod2pos(obj29, "addComment", &meth_ast_addComment373, 50);
  int argcv_meth_ast_addComment373[] = {1};
  meth_meth_ast_addComment373->type = alloc_MethodType(1, argcv_meth_ast_addComment373);
  meth_meth_ast_addComment373->definitionModule = modulename;
  meth_meth_ast_addComment373->definitionLine = 175;
// method "addComments"
  struct UserObject *uo387 = (struct UserObject*)obj29;
  uo387->data[51] = emptyclosure;
  Method *meth_meth_ast_addComments387 = addmethod2pos(obj29, "addComments", &meth_ast_addComments387, 51);
  int argcv_meth_ast_addComments387[] = {1};
  meth_meth_ast_addComments387->type = alloc_MethodType(1, argcv_meth_ast_addComments387);
  meth_meth_ast_addComments387->definitionModule = modulename;
  meth_meth_ast_addComments387->definitionLine = 182;
// method "statementName"
  struct UserObject *uo395 = (struct UserObject*)obj29;
  uo395->data[52] = emptyclosure;
  Method *meth_meth_ast_statementName395 = addmethod2pos(obj29, "statementName", &meth_ast_statementName395, 52);
  int argcv_meth_ast_statementName395[] = {0};
  meth_meth_ast_statementName395->type = alloc_MethodType(1, argcv_meth_ast_statementName395);
  meth_meth_ast_statementName395->definitionModule = modulename;
  meth_meth_ast_statementName395->definitionLine = 185;
  sourceObject = obj29;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit398 == NULL) {
    strlit398 = alloc_String("");
    gc_root(strlit398);
  }
// compiled string node returning strlit398 (depth = 2)
  adddatum2(obj29, strlit398, 1);
  sourceObject = obj29;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call400 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call400 (depth = 3)
// compiled member node returning call400 (depth = 2)
  adddatum2(obj29, call400, 2);
  sourceObject = obj29;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  partcv[0] = 0;
  Object call402 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe401);
// compiled call node returning call402 (depth = 3)
// compiled member node returning call402 (depth = 2)
  adddatum2(obj29, call402, 3);
  sourceObject = obj29;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_fakeSymbolTable (depth = 2)
  adddatum2(obj29, *var_fakeSymbolTable, 4);
  sourceObject = obj29;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool403 = alloc_Boolean(0);
// compiled identifier node returning bool403 (depth = 2)
  adddatum2(obj29, bool403, 5);
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  sourceObject = obj29;
  objclass29 = obj29->class;
  objclass29->definitionModule = modulename;
  objclass29->definitionLine = 86;
  (*(struct UserObject *)self).data[0] = lowerouter29;
  self = oldself29;
  selfslot = oldselfslot29;
  stackframe = oldstackframe29;
  gc_frame_end(frame);
  return obj29;
}
Object meth_ast_newName408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for newName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_n (depth = 2)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_oldName409(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "oldName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oldName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for oldName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_ast_asString410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit412 == NULL) {
    strlit412 = alloc_String("");
    gc_root(strlit412);
  }
// compiled string node returning strlit412 (depth = 3)
  int op_slot_right_411 = gc_frame_newslot(strlit412);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call416 = callmethod(*var_o, "nameString",
    1, partcv, params);
  gc_frame_end(callframe415);
// compiled call node returning call416 (depth = 5)
// compiled member node returning call416 (depth = 4)
  int op_slot_right_414 = gc_frame_newslot(call416);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit419 == NULL) {
    strlit419 = alloc_String(" = ");
    gc_root(strlit419);
  }
// compiled string node returning strlit419 (depth = 5)
  int op_slot_right_418 = gc_frame_newslot(strlit419);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe422 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call423 = callmethod(*var_n, "nameString",
    1, partcv, params);
  gc_frame_end(callframe422);
// compiled call node returning call423 (depth = 7)
// compiled member node returning call423 (depth = 6)
  int op_slot_right_421 = gc_frame_newslot(call423);
// starting to compile string node (depth = 6)
  if (strlit425 == NULL) {
    strlit425 = alloc_String("alias ");
    gc_root(strlit425);
  }
// compiled string node returning strlit425 (depth = 6)
  int op_slot_left_421 = gc_frame_newslot(strlit425);
  params[0] = call423;
  partcv[0] = 1;
  Object opresult426 = callmethod(strlit425, "++", 1, partcv, params);
// compiled op node returning opresult426 (depth = 5)
  int op_slot_left_418 = gc_frame_newslot(opresult426);
  params[0] = strlit419;
  partcv[0] = 1;
  Object opresult427 = callmethod(opresult426, "++", 1, partcv, params);
// compiled op node returning opresult427 (depth = 4)
  int op_slot_left_414 = gc_frame_newslot(opresult427);
  params[0] = call416;
  partcv[0] = 1;
  Object opresult428 = callmethod(opresult427, "++", 1, partcv, params);
// compiled op node returning opresult428 (depth = 3)
  int op_slot_left_411 = gc_frame_newslot(opresult428);
  params[0] = strlit412;
  partcv[0] = 1;
  Object opresult429 = callmethod(opresult428, "++", 1, partcv, params);
// compiled op node returning opresult429 (depth = 2)
  gc_frame_end(frame);
  return opresult429;
}
Object meth_ast__apply438(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit440 == NULL) {
    strlit440 = alloc_String("  ");
    gc_root(strlit440);
  }
// compiled string node returning strlit440 (depth = 6)
  int op_slot_right_439 = gc_frame_newslot(strlit440);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_439 = gc_frame_newslot(*var_spc);
  params[0] = strlit440;
  partcv[0] = 1;
  Object opresult442 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult442 (depth = 5)
  *var_spc = opresult442;
  if (opresult442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty430(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit431 == NULL) {
    strlit431 = alloc_String("");
    gc_root(strlit431);
  }
// compiled string node returning strlit431 (depth = 3)
  *var_spc = strlit431;
  if (strlit431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe432 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  int op_slot_right_433 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 4)
  Object num435 = alloc_Float64(0);
// compiled num node returning num435 (depth = 4)
  int op_slot_left_433 = gc_frame_newslot(num435);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult436 = callmethod(num435, "..", 1, partcv, params);
// compiled op node returning opresult436 (depth = 3)
  gc_frame_newslot(opresult436);
// starting to compile block node (depth = 3)
  Object block437 = alloc_Block(NULL, NULL, "ast", 2402);
  gc_frame_newslot(block437);
// method "_apply"
  block_savedest(block437);
  Object closure438 = createclosure(2, "_apply");
  setclosureframe(closure438, stackframe);
  addtoclosure(closure438, var_spc);
  addtoclosure(closure438, selfslot);
  struct UserObject *uo438 = (struct UserObject*)block437;
  uo438->data[0] = (Object)closure438;
  Method *meth_meth_ast__apply438 = addmethod2pos(block437, "_apply", &meth_ast__apply438, 0);
  int argcv_meth_ast__apply438[] = {1};
  meth_meth_ast__apply438->type = alloc_MethodType(1, argcv_meth_ast__apply438);
  meth_meth_ast__apply438->definitionModule = modulename;
  meth_meth_ast__apply438->definitionLine = 2399;
// compiled block node returning block437 (depth = 3)
  gc_frame_newslot(block437);
// call case 5: prelude request
  params[0] = opresult436;
  params[1] = block437;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call445 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe432);
// compiled call node returning call445 (depth = 2)
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit447 == NULL) {
    strlit447 = alloc_String("");
    gc_root(strlit447);
  }
// compiled string node returning strlit447 (depth = 3)
  int op_slot_right_446 = gc_frame_newslot(strlit447);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe450 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call451 = callmethod(*var_o, "pretty",
    1, partcv, params);
  gc_frame_end(callframe450);
// compiled call node returning call451 (depth = 4)
  int op_slot_right_449 = gc_frame_newslot(call451);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit454 == NULL) {
    strlit454 = alloc_String(" = ");
    gc_root(strlit454);
  }
// compiled string node returning strlit454 (depth = 5)
  int op_slot_right_453 = gc_frame_newslot(strlit454);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe457 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call458 = callmethod(*var_n, "pretty",
    1, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 6)
  int op_slot_right_456 = gc_frame_newslot(call458);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit461 == NULL) {
    strlit461 = alloc_String("  alias ");
    gc_root(strlit461);
  }
// compiled string node returning strlit461 (depth = 7)
  int op_slot_right_460 = gc_frame_newslot(strlit461);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_463 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit465 == NULL) {
    strlit465 = alloc_String("");
    gc_root(strlit465);
  }
// compiled string node returning strlit465 (depth = 8)
  int op_slot_left_463 = gc_frame_newslot(strlit465);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult466 = callmethod(strlit465, "++", 1, partcv, params);
// compiled op node returning opresult466 (depth = 7)
  int op_slot_left_460 = gc_frame_newslot(opresult466);
  params[0] = strlit461;
  partcv[0] = 1;
  Object opresult467 = callmethod(opresult466, "++", 1, partcv, params);
// compiled op node returning opresult467 (depth = 6)
  int op_slot_left_456 = gc_frame_newslot(opresult467);
  params[0] = call458;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "++", 1, partcv, params);
// compiled op node returning opresult468 (depth = 5)
  int op_slot_left_453 = gc_frame_newslot(opresult468);
  params[0] = strlit454;
  partcv[0] = 1;
  Object opresult469 = callmethod(opresult468, "++", 1, partcv, params);
// compiled op node returning opresult469 (depth = 4)
  int op_slot_left_449 = gc_frame_newslot(opresult469);
  params[0] = call451;
  partcv[0] = 1;
  Object opresult470 = callmethod(opresult469, "++", 1, partcv, params);
// compiled op node returning opresult470 (depth = 3)
  int op_slot_left_446 = gc_frame_newslot(opresult470);
  params[0] = strlit447;
  partcv[0] = 1;
  Object opresult471 = callmethod(opresult470, "++", 1, partcv, params);
// compiled op node returning opresult471 (depth = 2)
  gc_frame_end(frame);
  return opresult471;
}
Object meth_ast_hash472(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe474 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  partcv[0] = 0;
  Object call475 = callmethod(*var_o, "hash",
    1, partcv, params);
  gc_frame_end(callframe474);
// compiled call node returning call475 (depth = 4)
// compiled member node returning call475 (depth = 3)
  int op_slot_right_473 = gc_frame_newslot(call475);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num478 = alloc_Float64(1171);
// compiled num node returning num478 (depth = 4)
  int op_slot_right_477 = gc_frame_newslot(num478);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call481 = callmethod(*var_n, "hash",
    1, partcv, params);
  gc_frame_end(callframe480);
// compiled call node returning call481 (depth = 5)
// compiled member node returning call481 (depth = 4)
  int op_slot_left_477 = gc_frame_newslot(call481);
  params[0] = num478;
  partcv[0] = 1;
  Object prod482 = callmethod(call481, "*", 1, partcv, params);
// compiled op node returning prod482 (depth = 3)
  int op_slot_left_473 = gc_frame_newslot(prod482);
  params[0] = call475;
  partcv[0] = 1;
  Object sum483 = callmethod(prod482, "+", 1, partcv, params);
// compiled op node returning sum483 (depth = 2)
  gc_frame_end(frame);
  return sum483;
}
Object meth_ast_isExecutable484(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool485 = alloc_Boolean(0);
// compiled identifier node returning bool485 (depth = 2)
  gc_frame_end(frame);
  return bool485;
}
Object meth_ast__apply489(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_that = &(stackframe->slots[0]);
  *var_that = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe492 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_that (depth = 8)
  partcv[0] = 0;
  Object call493 = callmethod(*var_that, "oldName",
    1, partcv, params);
  gc_frame_end(callframe492);
// compiled call node returning call493 (depth = 7)
// compiled member node returning call493 (depth = 6)
  int op_slot_right_491 = gc_frame_newslot(call493);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  int op_slot_left_491 = gc_frame_newslot(*var_o);
  params[0] = call493;
  partcv[0] = 1;
  Object opresult495 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult495 (depth = 5)
  int op_slot_right_490 = gc_frame_newslot(opresult495);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_that (depth = 8)
  partcv[0] = 0;
  Object call499 = callmethod(*var_that, "newName",
    1, partcv, params);
  gc_frame_end(callframe498);
// compiled call node returning call499 (depth = 7)
// compiled member node returning call499 (depth = 6)
  int op_slot_right_497 = gc_frame_newslot(call499);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_497 = gc_frame_newslot(*var_n);
  params[0] = call499;
  partcv[0] = 1;
  Object opresult501 = callmethod(*var_n, "==", 1, partcv, params);
// compiled op node returning opresult501 (depth = 5)
  int op_slot_left_490 = gc_frame_newslot(opresult501);
  params[0] = opresult495;
  partcv[0] = 1;
  Object opresult502 = callmethod(opresult501, "&&", 1, partcv, params);
// compiled op node returning opresult502 (depth = 4)
  gc_frame_end(frame);
  return opresult502;
}
Object meth_ast__apply514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool515 = alloc_Boolean(0);
// compiled identifier node returning bool515 (depth = 4)
  gc_frame_end(frame);
  return bool515;
}
Object meth_ast__61__61_486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_o = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_AliasPair = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame487 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block488 = alloc_Block(NULL, NULL, "ast", 2411);
  gc_frame_newslot(block488);
// method "_apply"
  block_savedest(block488);
  Object closure489 = createclosure(3, "_apply");
  setclosureframe(closure489, stackframe);
  addtoclosure(closure489, var_o);
  addtoclosure(closure489, var_n);
  addtoclosure(closure489, selfslot);
  struct UserObject *uo489 = (struct UserObject*)block488;
  uo489->data[0] = (Object)closure489;
  Method *meth_meth_ast__apply489 = addmethod2pos(block488, "_apply", &meth_ast__apply489, 0);
  int argcv_meth_ast__apply489[] = {1};
  meth_meth_ast__apply489->type = alloc_MethodType(1, argcv_meth_ast__apply489);
  meth_meth_ast__apply489->definitionModule = modulename;
  meth_meth_ast__apply489->definitionLine = 2407;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe504 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe505 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit506 == NULL) {
    strlit506 = alloc_String("that");
    gc_root(strlit506);
  }
// compiled string node returning strlit506 (depth = 6)
  gc_frame_newslot(strlit506);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe507 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call508 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe507);
// compiled call node returning call508 (depth = 7)
// compiled member node returning call508 (depth = 6)
  params[0] = strlit506;
  partcv[0] = 1;
  Object call509 = callmethod(call508, "new",
    1, partcv, params);
  gc_frame_end(callframe505);
// compiled call node returning call509 (depth = 5)
  gc_frame_newslot(call509);
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_AliasPair (depth = 5)
  gc_frame_newslot(*var_AliasPair);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe510 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call511 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe510);
// compiled call node returning call511 (depth = 6)
// compiled member node returning call511 (depth = 5)
  params[0] = call509;
  params[1] = *var_AliasPair;
  partcv[0] = 2;
  Object call512 = callmethod(call511, "new",
    1, partcv, params);
  gc_frame_end(callframe504);
// compiled call node returning call512 (depth = 4)
((struct UserObject *)block488)->data[1] = call512;
// compiled block node returning block488 (depth = 3)
  gc_frame_newslot(block488);
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block513 = alloc_Block(NULL, NULL, "ast", 2412);
  gc_frame_newslot(block513);
// method "_apply"
  block_savedest(block513);
  Object closure514 = createclosure(1, "_apply");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, selfslot);
  struct UserObject *uo514 = (struct UserObject*)block513;
  uo514->data[0] = (Object)closure514;
  Method *meth_meth_ast__apply514 = addmethod2pos(block513, "_apply", &meth_ast__apply514, 0);
  int argcv_meth_ast__apply514[] = {1};
  meth_meth_ast__apply514->type = alloc_MethodType(1, argcv_meth_ast__apply514);
  meth_meth_ast__apply514->definitionModule = modulename;
  meth_meth_ast__apply514->definitionLine = 0;
// compiled block node returning block513 (depth = 3)
  gc_frame_newslot(block513);
  params[0] = block488;
  params[1] = block513;
  Object matchres487 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame487);
// compiled matchcase node returning matchres487 (depth = 2)
  gc_frame_end(frame);
  return matchres487;
}
Object meth_ast_aliasNew_40__41_old405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew()old");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew()old (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for aliasNew");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for old");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject406 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj406 = alloc_userobj2(7,8, objclass406);
  gc_frame_newslot(obj406);
if (objclass406 == NULL) {
  glfree(obj406->class->name);
  obj406->class->name = "ast.aliasNew()old";
}
// OBJECT OUTER DEC outer
  adddatum2(obj406, self, 0);
  addmethodreal(obj406,"outer", &reader_ast_outer_407);
  Object oldself406 = self;
  struct StackFrameObject *oldstackframe406 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe406);
  gc_frame_newslot((Object)stackframe);
  self = obj406;
  Object *oldselfslot406 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter406 = (*(struct UserObject *)self).data[0], lowerouter406 = thisouter406;
  if (inheritingObject406) {
    struct UserObject *inho406 = (struct UserObject *)inheritingObject406;
    while (inho406->super != GraceDefaultObject) inho406 = (struct UserObject *)inho406->super;
    inho406->super = obj406;
    self = inheritingObject406;
    *selfslot = self;
    lowerouter406 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter406;
  }
// method "newName"
  block_savedest(obj406);
  Object closure408 = createclosure(1, "newName");
  setclosureframe(closure408, stackframe);
  addtoclosure(closure408, var_n);
  struct UserObject *uo408 = (struct UserObject*)obj406;
  uo408->data[1] = (Object)closure408;
  Method *meth_meth_ast_newName408 = addmethod2pos(obj406, "newName", &meth_ast_newName408, 1);
  int argcv_meth_ast_newName408[] = {0};
  meth_meth_ast_newName408->type = alloc_MethodType(1, argcv_meth_ast_newName408);
  meth_meth_ast_newName408->definitionModule = modulename;
  meth_meth_ast_newName408->definitionLine = 2397;
// method "oldName"
  block_savedest(obj406);
  Object closure409 = createclosure(1, "oldName");
  setclosureframe(closure409, stackframe);
  addtoclosure(closure409, var_o);
  struct UserObject *uo409 = (struct UserObject*)obj406;
  uo409->data[2] = (Object)closure409;
  Method *meth_meth_ast_oldName409 = addmethod2pos(obj406, "oldName", &meth_ast_oldName409, 2);
  int argcv_meth_ast_oldName409[] = {0};
  meth_meth_ast_oldName409->type = alloc_MethodType(1, argcv_meth_ast_oldName409);
  meth_meth_ast_oldName409->definitionModule = modulename;
  meth_meth_ast_oldName409->definitionLine = 2398;
// method "asString"
  block_savedest(obj406);
  Object closure410 = createclosure(2, "asString");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_o);
  addtoclosure(closure410, var_n);
  struct UserObject *uo410 = (struct UserObject*)obj406;
  uo410->data[3] = (Object)closure410;
  Method *meth_meth_ast_asString410 = addmethod2pos(obj406, "asString", &meth_ast_asString410, 3);
  int argcv_meth_ast_asString410[] = {0};
  meth_meth_ast_asString410->type = alloc_MethodType(1, argcv_meth_ast_asString410);
  meth_meth_ast_asString410->definitionModule = modulename;
  meth_meth_ast_asString410->definitionLine = 2399;
// method "pretty"
  block_savedest(obj406);
  Object closure430 = createclosure(2, "pretty");
  setclosureframe(closure430, stackframe);
  addtoclosure(closure430, var_o);
  addtoclosure(closure430, var_n);
  struct UserObject *uo430 = (struct UserObject*)obj406;
  uo430->data[4] = (Object)closure430;
  Method *meth_meth_ast_pretty430 = addmethod2pos(obj406, "pretty", &meth_ast_pretty430, 4);
  int argcv_meth_ast_pretty430[] = {1};
  meth_meth_ast_pretty430->type = alloc_MethodType(1, argcv_meth_ast_pretty430);
  meth_meth_ast_pretty430->definitionModule = modulename;
  meth_meth_ast_pretty430->definitionLine = 2400;
// method "hash"
  block_savedest(obj406);
  Object closure472 = createclosure(2, "hash");
  setclosureframe(closure472, stackframe);
  addtoclosure(closure472, var_o);
  addtoclosure(closure472, var_n);
  struct UserObject *uo472 = (struct UserObject*)obj406;
  uo472->data[5] = (Object)closure472;
  Method *meth_meth_ast_hash472 = addmethod2pos(obj406, "hash", &meth_ast_hash472, 5);
  int argcv_meth_ast_hash472[] = {0};
  meth_meth_ast_hash472->type = alloc_MethodType(1, argcv_meth_ast_hash472);
  meth_meth_ast_hash472->definitionModule = modulename;
  meth_meth_ast_hash472->definitionLine = 2407;
// method "isExecutable"
  struct UserObject *uo484 = (struct UserObject*)obj406;
  uo484->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable484 = addmethod2pos(obj406, "isExecutable", &meth_ast_isExecutable484, 6);
  int argcv_meth_ast_isExecutable484[] = {0};
  meth_meth_ast_isExecutable484->type = alloc_MethodType(1, argcv_meth_ast_isExecutable484);
  meth_meth_ast_isExecutable484->definitionModule = modulename;
  meth_meth_ast_isExecutable484->definitionLine = 2408;
// method "=="
  block_savedest(obj406);
  Object closure486 = createclosure(3, "==");
  setclosureframe(closure486, stackframe);
  addtoclosure(closure486, var_o);
  addtoclosure(closure486, var_n);
  addtoclosure(closure486, var_AliasPair);
  struct UserObject *uo486 = (struct UserObject*)obj406;
  uo486->data[7] = (Object)closure486;
  Method *meth_meth_ast__61__61_486 = addmethod2pos(obj406, "==", &meth_ast__61__61_486, 7);
  int argcv_meth_ast__61__61_486[] = {1};
  meth_meth_ast__61__61_486->type = alloc_MethodType(1, argcv_meth_ast__61__61_486);
  meth_meth_ast__61__61_486->definitionModule = modulename;
  meth_meth_ast__61__61_486->definitionLine = 2409;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  objclass406 = obj406->class;
  objclass406->definitionModule = modulename;
  objclass406->definitionLine = 2396;
  (*(struct UserObject *)self).data[0] = lowerouter406;
  self = oldself406;
  selfslot = oldselfslot406;
  stackframe = oldstackframe406;
  gc_frame_end(frame);
  return obj406;
}
Object meth_ast_aliasNew_40__41_old405_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "aliasNew()old()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method aliasNew()old()object");
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for aliasNew()old (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for aliasNew");
  Object *var_o = &(stackframe->slots[1]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for old");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject406 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj406 = alloc_userobj2(7,8, objclass406);
  gc_frame_newslot(obj406);
if (objclass406 == NULL) {
  glfree(obj406->class->name);
  obj406->class->name = "ast.aliasNew()old";
}
// OBJECT OUTER DEC outer
  adddatum2(obj406, self, 0);
  addmethodreal(obj406,"outer", &reader_ast_outer_407);
  Object oldself406 = self;
  struct StackFrameObject *oldstackframe406 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe406);
  gc_frame_newslot((Object)stackframe);
  self = obj406;
  Object *oldselfslot406 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter406 = (*(struct UserObject *)self).data[0], lowerouter406 = thisouter406;
  if (inheritingObject406) {
    struct UserObject *inho406 = (struct UserObject *)inheritingObject406;
    while (inho406->super != GraceDefaultObject) inho406 = (struct UserObject *)inho406->super;
    inho406->super = obj406;
    self = inheritingObject406;
    *selfslot = self;
    lowerouter406 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter406;
  }
// method "newName"
  block_savedest(obj406);
  Object closure408 = createclosure(1, "newName");
  setclosureframe(closure408, stackframe);
  addtoclosure(closure408, var_n);
  struct UserObject *uo408 = (struct UserObject*)obj406;
  uo408->data[1] = (Object)closure408;
  Method *meth_meth_ast_newName408 = addmethod2pos(obj406, "newName", &meth_ast_newName408, 1);
  int argcv_meth_ast_newName408[] = {0};
  meth_meth_ast_newName408->type = alloc_MethodType(1, argcv_meth_ast_newName408);
  meth_meth_ast_newName408->definitionModule = modulename;
  meth_meth_ast_newName408->definitionLine = 2397;
// method "oldName"
  block_savedest(obj406);
  Object closure409 = createclosure(1, "oldName");
  setclosureframe(closure409, stackframe);
  addtoclosure(closure409, var_o);
  struct UserObject *uo409 = (struct UserObject*)obj406;
  uo409->data[2] = (Object)closure409;
  Method *meth_meth_ast_oldName409 = addmethod2pos(obj406, "oldName", &meth_ast_oldName409, 2);
  int argcv_meth_ast_oldName409[] = {0};
  meth_meth_ast_oldName409->type = alloc_MethodType(1, argcv_meth_ast_oldName409);
  meth_meth_ast_oldName409->definitionModule = modulename;
  meth_meth_ast_oldName409->definitionLine = 2398;
// method "asString"
  block_savedest(obj406);
  Object closure410 = createclosure(2, "asString");
  setclosureframe(closure410, stackframe);
  addtoclosure(closure410, var_o);
  addtoclosure(closure410, var_n);
  struct UserObject *uo410 = (struct UserObject*)obj406;
  uo410->data[3] = (Object)closure410;
  Method *meth_meth_ast_asString410 = addmethod2pos(obj406, "asString", &meth_ast_asString410, 3);
  int argcv_meth_ast_asString410[] = {0};
  meth_meth_ast_asString410->type = alloc_MethodType(1, argcv_meth_ast_asString410);
  meth_meth_ast_asString410->definitionModule = modulename;
  meth_meth_ast_asString410->definitionLine = 2399;
// method "pretty"
  block_savedest(obj406);
  Object closure430 = createclosure(2, "pretty");
  setclosureframe(closure430, stackframe);
  addtoclosure(closure430, var_o);
  addtoclosure(closure430, var_n);
  struct UserObject *uo430 = (struct UserObject*)obj406;
  uo430->data[4] = (Object)closure430;
  Method *meth_meth_ast_pretty430 = addmethod2pos(obj406, "pretty", &meth_ast_pretty430, 4);
  int argcv_meth_ast_pretty430[] = {1};
  meth_meth_ast_pretty430->type = alloc_MethodType(1, argcv_meth_ast_pretty430);
  meth_meth_ast_pretty430->definitionModule = modulename;
  meth_meth_ast_pretty430->definitionLine = 2400;
// method "hash"
  block_savedest(obj406);
  Object closure472 = createclosure(2, "hash");
  setclosureframe(closure472, stackframe);
  addtoclosure(closure472, var_o);
  addtoclosure(closure472, var_n);
  struct UserObject *uo472 = (struct UserObject*)obj406;
  uo472->data[5] = (Object)closure472;
  Method *meth_meth_ast_hash472 = addmethod2pos(obj406, "hash", &meth_ast_hash472, 5);
  int argcv_meth_ast_hash472[] = {0};
  meth_meth_ast_hash472->type = alloc_MethodType(1, argcv_meth_ast_hash472);
  meth_meth_ast_hash472->definitionModule = modulename;
  meth_meth_ast_hash472->definitionLine = 2407;
// method "isExecutable"
  struct UserObject *uo484 = (struct UserObject*)obj406;
  uo484->data[6] = emptyclosure;
  Method *meth_meth_ast_isExecutable484 = addmethod2pos(obj406, "isExecutable", &meth_ast_isExecutable484, 6);
  int argcv_meth_ast_isExecutable484[] = {0};
  meth_meth_ast_isExecutable484->type = alloc_MethodType(1, argcv_meth_ast_isExecutable484);
  meth_meth_ast_isExecutable484->definitionModule = modulename;
  meth_meth_ast_isExecutable484->definitionLine = 2408;
// method "=="
  block_savedest(obj406);
  Object closure486 = createclosure(3, "==");
  setclosureframe(closure486, stackframe);
  addtoclosure(closure486, var_o);
  addtoclosure(closure486, var_n);
  addtoclosure(closure486, var_AliasPair);
  struct UserObject *uo486 = (struct UserObject*)obj406;
  uo486->data[7] = (Object)closure486;
  Method *meth_meth_ast__61__61_486 = addmethod2pos(obj406, "==", &meth_ast__61__61_486, 7);
  int argcv_meth_ast__61__61_486[] = {1};
  meth_meth_ast__61__61_486->type = alloc_MethodType(1, argcv_meth_ast__61__61_486);
  meth_meth_ast__61__61_486->definitionModule = modulename;
  meth_meth_ast__61__61_486->definitionLine = 2409;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  sourceObject = obj406;
  objclass406 = obj406->class;
  objclass406->definitionModule = modulename;
  objclass406->definitionLine = 2396;
  (*(struct UserObject *)self).data[0] = lowerouter406;
  self = oldself406;
  selfslot = oldselfslot406;
  stackframe = oldstackframe406;
  gc_frame_end(frame);
  return obj406;
}
Object meth_ast__apply552(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ind (depth = 8)
  int op_slot_right_553 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_len (depth = 8)
  int op_slot_left_553 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff555 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff555 (depth = 7)
  gc_frame_end(frame);
  return diff555;
}
Object meth_ast__apply545(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe546 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit547 == NULL) {
    strlit547 = alloc_String(" ");
    gc_root(strlit547);
  }
// compiled string node returning strlit547 (depth = 6)
  gc_frame_newslot(strlit547);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_548 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_548 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff550 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff550 (depth = 6)
  gc_frame_newslot(diff550);
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 6)
  Object block551 = alloc_Block(NULL, NULL, "ast", 2625);
  gc_frame_newslot(block551);
// method "_apply"
  block_savedest(block551);
  Object closure552 = createclosure(3, "_apply");
  setclosureframe(closure552, stackframe);
  addtoclosure(closure552, var_ind);
  addtoclosure(closure552, var_len);
  addtoclosure(closure552, selfslot);
  struct UserObject *uo552 = (struct UserObject*)block551;
  uo552->data[0] = (Object)closure552;
  Method *meth_meth_ast__apply552 = addmethod2pos(block551, "_apply", &meth_ast__apply552, 0);
  int argcv_meth_ast__apply552[] = {0};
  meth_meth_ast__apply552->type = alloc_MethodType(1, argcv_meth_ast__apply552);
  meth_meth_ast__apply552->definitionModule = modulename;
  meth_meth_ast__apply552->definitionLine = 2617;
// compiled block node returning block551 (depth = 6)
  gc_frame_newslot(block551);
// call case 6: other member request
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = strlit547;
  params[1] = diff550;
  params[2] = block551;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call557 = callmethod(*var_str, "lastIndexOf()startingAt()ifAbsent",
    3, partcv, params);
  gc_frame_end(callframe546);
// compiled call node returning call557 (depth = 5)
  *var_currBreak = call557;
  if (call557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe559 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe560 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num561 = alloc_Float64(1);
// compiled num node returning num561 (depth = 8)
  gc_frame_newslot(num561);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_currBreak (depth = 8)
  gc_frame_newslot(*var_currBreak);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  params[0] = num561;
  params[1] = *var_currBreak;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call562 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe560);
// compiled call node returning call562 (depth = 7)
  partcv[0] = 0;
  Object call563 = callmethod(call562, "trim",
    1, partcv, params);
  gc_frame_end(callframe559);
// compiled call node returning call563 (depth = 6)
// compiled member node returning call563 (depth = 5)
  *var_trimmedLine = call563;
  if (call563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_str = getfromclosure(closure, 0);
  Object *var_currBreak = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit581 == NULL) {
    strlit581 = alloc_String(" ");
    gc_root(strlit581);
  }
// compiled string node returning strlit581 (depth = 8)
  int op_slot_right_580 = gc_frame_newslot(strlit581);
// starting to compile call node (depth = 8)
  int callframe583 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_str (depth = 9)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call584 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe583);
// compiled call node returning call584 (depth = 8)
  int op_slot_left_580 = gc_frame_newslot(call584);
  params[0] = strlit581;
  partcv[0] = 1;
  Object opresult585 = callmethod(call584, "==", 1, partcv, params);
// compiled op node returning opresult585 (depth = 7)
  Object if579 = done;
  if (istrue(opresult585)) {
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  *var_currBreak = *var_ix;
  if (*var_ix == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if579 = done;
  } else {
  }
// compiled if node returning if579 (depth = 6)
  gc_frame_end(frame);
  return if579;
}
Object meth_ast__apply598(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit600 == NULL) {
    strlit600 = alloc_String(" ");
    gc_root(strlit600);
  }
// compiled string node returning strlit600 (depth = 9)
  int op_slot_right_599 = gc_frame_newslot(strlit600);
// starting to compile call node (depth = 9)
  int callframe602 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_end (depth = 10)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_end;
  partcv[0] = 1;
  Object call603 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe602);
// compiled call node returning call603 (depth = 9)
  int op_slot_left_599 = gc_frame_newslot(call603);
  params[0] = strlit600;
  partcv[0] = 1;
  Object opresult604 = callmethod(call603, "==", 1, partcv, params);
// compiled op node returning opresult604 (depth = 8)
  gc_frame_end(frame);
  return opresult604;
}
Object meth_ast__apply595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block597 = alloc_Block(NULL, NULL, "ast", 2633);
  gc_frame_newslot(block597);
// method "_apply"
  block_savedest(block597);
  Object closure598 = createclosure(3, "_apply");
  setclosureframe(closure598, stackframe);
  addtoclosure(closure598, var_end);
  addtoclosure(closure598, var_str);
  addtoclosure(closure598, selfslot);
  struct UserObject *uo598 = (struct UserObject*)block597;
  uo598->data[0] = (Object)closure598;
  Method *meth_meth_ast__apply598 = addmethod2pos(block597, "_apply", &meth_ast__apply598, 0);
  int argcv_meth_ast__apply598[] = {0};
  meth_meth_ast__apply598->type = alloc_MethodType(1, argcv_meth_ast__apply598);
  meth_meth_ast__apply598->definitionModule = modulename;
  meth_meth_ast__apply598->definitionLine = 2628;
// compiled block node returning block597 (depth = 7)
  int op_slot_right_596 = gc_frame_newslot(block597);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num608 = alloc_Float64(1);
// compiled num node returning num608 (depth = 8)
  int op_slot_right_607 = gc_frame_newslot(num608);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_607 = gc_frame_newslot(*var_end);
  params[0] = num608;
  partcv[0] = 1;
  Object opresult610 = callmethod(*var_end, "≥", 1, partcv, params);
// compiled op node returning opresult610 (depth = 7)
  int op_slot_left_596 = gc_frame_newslot(opresult610);
  params[0] = block597;
  partcv[0] = 1;
  Object opresult611 = callmethod(opresult610, "&&", 1, partcv, params);
// compiled op node returning opresult611 (depth = 6)
  gc_frame_end(frame);
  return opresult611;
}
Object meth_ast__apply614(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num616 = alloc_Float64(1);
// compiled num node returning num616 (depth = 8)
  int op_slot_right_615 = gc_frame_newslot(num616);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_615 = gc_frame_newslot(*var_end);
  params[0] = num616;
  partcv[0] = 1;
  Object diff618 = callmethod(*var_end, "-", 1, partcv, params);
// compiled op node returning diff618 (depth = 7)
  *var_end = diff618;
  if (diff618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit630 == NULL) {
    strlit630 = alloc_String(" ");
    gc_root(strlit630);
  }
// compiled string node returning strlit630 (depth = 9)
  int op_slot_right_629 = gc_frame_newslot(strlit630);
// starting to compile call node (depth = 9)
  int callframe632 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_start (depth = 10)
  gc_frame_newslot(*var_start);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  params[0] = *var_start;
  partcv[0] = 1;
  Object call633 = callmethod(*var_str, "at",
    1, partcv, params);
  gc_frame_end(callframe632);
// compiled call node returning call633 (depth = 9)
  int op_slot_left_629 = gc_frame_newslot(call633);
  params[0] = strlit630;
  partcv[0] = 1;
  Object opresult634 = callmethod(call633, "==", 1, partcv, params);
// compiled op node returning opresult634 (depth = 8)
  gc_frame_end(frame);
  return opresult634;
}
Object meth_ast__apply625(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object *var_str = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block627 = alloc_Block(NULL, NULL, "ast", 2637);
  gc_frame_newslot(block627);
// method "_apply"
  block_savedest(block627);
  Object closure628 = createclosure(3, "_apply");
  setclosureframe(closure628, stackframe);
  addtoclosure(closure628, var_start);
  addtoclosure(closure628, var_str);
  addtoclosure(closure628, selfslot);
  struct UserObject *uo628 = (struct UserObject*)block627;
  uo628->data[0] = (Object)closure628;
  Method *meth_meth_ast__apply628 = addmethod2pos(block627, "_apply", &meth_ast__apply628, 0);
  int argcv_meth_ast__apply628[] = {0};
  meth_meth_ast__apply628->type = alloc_MethodType(1, argcv_meth_ast__apply628);
  meth_meth_ast__apply628->definitionModule = modulename;
  meth_meth_ast__apply628->definitionLine = 2628;
// compiled block node returning block627 (depth = 7)
  int op_slot_right_626 = gc_frame_newslot(block627);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
  partcv[0] = 0;
  Object call639 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe638);
// compiled call node returning call639 (depth = 9)
// compiled member node returning call639 (depth = 8)
  int op_slot_right_637 = gc_frame_newslot(call639);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_637 = gc_frame_newslot(*var_start);
  params[0] = call639;
  partcv[0] = 1;
  Object opresult641 = callmethod(*var_start, "≤", 1, partcv, params);
// compiled op node returning opresult641 (depth = 7)
  int op_slot_left_626 = gc_frame_newslot(opresult641);
  params[0] = block627;
  partcv[0] = 1;
  Object opresult642 = callmethod(opresult641, "&&", 1, partcv, params);
// compiled op node returning opresult642 (depth = 6)
  gc_frame_end(frame);
  return opresult642;
}
Object meth_ast__apply645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_start = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num647 = alloc_Float64(1);
// compiled num node returning num647 (depth = 8)
  int op_slot_right_646 = gc_frame_newslot(num647);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  int op_slot_left_646 = gc_frame_newslot(*var_start);
  params[0] = num647;
  partcv[0] = 1;
  Object sum649 = callmethod(*var_start, "+", 1, partcv, params);
// compiled op node returning sum649 (depth = 7)
  *var_start = sum649;
  if (sum649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply567(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ind = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_currBreak = getfromclosure(closure, 3);
  Object *var_trimmedLine = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "end");
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe568 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ind (depth = 7)
  int op_slot_right_569 = gc_frame_newslot(*var_ind);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_len (depth = 7)
  int op_slot_left_569 = gc_frame_newslot(*var_len);
  params[0] = *var_ind;
  partcv[0] = 1;
  Object diff571 = callmethod(*var_len, "-", 1, partcv, params);
// compiled op node returning diff571 (depth = 6)
  gc_frame_newslot(diff571);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_str (depth = 8)
  partcv[0] = 0;
  Object call573 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe572);
// compiled call node returning call573 (depth = 7)
// compiled member node returning call573 (depth = 6)
  gc_frame_newslot(call573);
// call case 5: prelude request
  params[0] = diff571;
  params[1] = call573;
  partcv[0] = 2;
  Object call574 = callmethodflags(prelude, "min", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe568);
// compiled call node returning call574 (depth = 5)
  *var_currBreak = call574;
  if (call574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe576 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block577 = alloc_Block(NULL, NULL, "ast", 2629);
  gc_frame_newslot(block577);
// method "_apply"
  block_savedest(block577);
  Object closure578 = createclosure(3, "_apply");
  setclosureframe(closure578, stackframe);
  addtoclosure(closure578, var_str);
  addtoclosure(closure578, var_currBreak);
  addtoclosure(closure578, selfslot);
  struct UserObject *uo578 = (struct UserObject*)block577;
  uo578->data[0] = (Object)closure578;
  Method *meth_meth_ast__apply578 = addmethod2pos(block577, "_apply", &meth_ast__apply578, 0);
  int argcv_meth_ast__apply578[] = {1};
  meth_meth_ast__apply578->type = alloc_MethodType(1, argcv_meth_ast__apply578);
  meth_meth_ast__apply578->definitionModule = modulename;
  meth_meth_ast__apply578->definitionLine = 2628;
// compiled block node returning block577 (depth = 5)
  gc_frame_newslot(block577);
// call case 6: other member request
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_right_588 = gc_frame_newslot(*var_currBreak);
// starting to compile num node (depth = 6)
  Object num590 = alloc_Float64(1);
// compiled num node returning num590 (depth = 6)
  int op_slot_left_588 = gc_frame_newslot(num590);
  params[0] = *var_currBreak;
  partcv[0] = 1;
  Object opresult591 = callmethod(num590, "..", 1, partcv, params);
// compiled op node returning opresult591 (depth = 5)
  params[0] = block577;
  partcv[0] = 1;
  Object call592 = callmethod(opresult591, "do",
    1, partcv, params);
  gc_frame_end(callframe576);
// compiled call node returning call592 (depth = 4)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_currBreak (depth = 5)
  *var_end = *var_currBreak;
  if (*var_currBreak == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe593 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block594 = alloc_Block(NULL, NULL, "ast", 2633);
  gc_frame_newslot(block594);
// method "_apply"
  block_savedest(block594);
  Object closure595 = createclosure(3, "_apply");
  setclosureframe(closure595, stackframe);
  addtoclosure(closure595, var_end);
  addtoclosure(closure595, var_str);
  addtoclosure(closure595, selfslot);
  struct UserObject *uo595 = (struct UserObject*)block594;
  uo595->data[0] = (Object)closure595;
  Method *meth_meth_ast__apply595 = addmethod2pos(block594, "_apply", &meth_ast__apply595, 0);
  int argcv_meth_ast__apply595[] = {0};
  meth_meth_ast__apply595->type = alloc_MethodType(1, argcv_meth_ast__apply595);
  meth_meth_ast__apply595->definitionModule = modulename;
  meth_meth_ast__apply595->definitionLine = 2628;
// compiled block node returning block594 (depth = 5)
  gc_frame_newslot(block594);
// starting to compile block node (depth = 5)
  Object block613 = alloc_Block(NULL, NULL, "ast", 2633);
  gc_frame_newslot(block613);
// method "_apply"
  block_savedest(block613);
  Object closure614 = createclosure(2, "_apply");
  setclosureframe(closure614, stackframe);
  addtoclosure(closure614, var_end);
  addtoclosure(closure614, selfslot);
  struct UserObject *uo614 = (struct UserObject*)block613;
  uo614->data[0] = (Object)closure614;
  Method *meth_meth_ast__apply614 = addmethod2pos(block613, "_apply", &meth_ast__apply614, 0);
  int argcv_meth_ast__apply614[] = {0};
  meth_meth_ast__apply614->type = alloc_MethodType(1, argcv_meth_ast__apply614);
  meth_meth_ast__apply614->definitionModule = modulename;
  meth_meth_ast__apply614->definitionLine = 2628;
// compiled block node returning block613 (depth = 5)
  gc_frame_newslot(block613);
// call case 5: prelude request
  params[0] = block594;
  params[1] = block613;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call621 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe593);
// compiled call node returning call621 (depth = 4)
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile num node (depth = 5)
  Object num622 = alloc_Float64(1);
// compiled num node returning num622 (depth = 5)
  *var_start = num622;
  if (num622 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe623 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block624 = alloc_Block(NULL, NULL, "ast", 2637);
  gc_frame_newslot(block624);
// method "_apply"
  block_savedest(block624);
  Object closure625 = createclosure(3, "_apply");
  setclosureframe(closure625, stackframe);
  addtoclosure(closure625, var_start);
  addtoclosure(closure625, var_str);
  addtoclosure(closure625, selfslot);
  struct UserObject *uo625 = (struct UserObject*)block624;
  uo625->data[0] = (Object)closure625;
  Method *meth_meth_ast__apply625 = addmethod2pos(block624, "_apply", &meth_ast__apply625, 0);
  int argcv_meth_ast__apply625[] = {0};
  meth_meth_ast__apply625->type = alloc_MethodType(1, argcv_meth_ast__apply625);
  meth_meth_ast__apply625->definitionModule = modulename;
  meth_meth_ast__apply625->definitionLine = 2628;
// compiled block node returning block624 (depth = 5)
  gc_frame_newslot(block624);
// starting to compile block node (depth = 5)
  Object block644 = alloc_Block(NULL, NULL, "ast", 2637);
  gc_frame_newslot(block644);
// method "_apply"
  block_savedest(block644);
  Object closure645 = createclosure(2, "_apply");
  setclosureframe(closure645, stackframe);
  addtoclosure(closure645, var_start);
  addtoclosure(closure645, selfslot);
  struct UserObject *uo645 = (struct UserObject*)block644;
  uo645->data[0] = (Object)closure645;
  Method *meth_meth_ast__apply645 = addmethod2pos(block644, "_apply", &meth_ast__apply645, 0);
  int argcv_meth_ast__apply645[] = {0};
  meth_meth_ast__apply645->type = alloc_MethodType(1, argcv_meth_ast__apply645);
  meth_meth_ast__apply645->definitionModule = modulename;
  meth_meth_ast__apply645->definitionLine = 2637;
// compiled block node returning block644 (depth = 5)
  gc_frame_newslot(block644);
// call case 5: prelude request
  params[0] = block624;
  params[1] = block644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call652 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe623);
// compiled call node returning call652 (depth = 4)
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe653 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_str (depth = 6)
  params[0] = *var_start;
  params[1] = *var_end;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call654 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe653);
// compiled call node returning call654 (depth = 5)
  *var_trimmedLine = call654;
  if (call654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_wrap_40__41_to_40__41_prefix518(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "wrap()to()prefix");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method wrap()to()prefix");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for wrap()to()prefix (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for wrap");
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for to");
  Object *var_margin = &(stackframe->slots[2]);
  *var_margin = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for prefix");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ind = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ind");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
  Object *var_currBreak = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "currBreak");
  Object *var_trimmedLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "trimmedLine");
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  partcv[0] = 0;
  Object call520 = callmethod(*var_margin, "size",
    1, partcv, params);
  gc_frame_end(callframe519);
// compiled call node returning call520 (depth = 4)
// compiled member node returning call520 (depth = 3)
  *var_ind = call520;
  if (call520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe521 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num523 = alloc_Float64(4);
// compiled num node returning num523 (depth = 5)
  int op_slot_right_522 = gc_frame_newslot(num523);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_522 = gc_frame_newslot(*var_ind);
  params[0] = num523;
  partcv[0] = 1;
  Object sum525 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum525 (depth = 4)
  gc_frame_newslot(sum525);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// call case 5: prelude request
  params[0] = sum525;
  params[1] = *var_l;
  partcv[0] = 2;
  Object call526 = callmethodflags(prelude, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe521);
// compiled call node returning call526 (depth = 3)
  *var_len = call526;
  if (call526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_len (depth = 4)
  int op_slot_right_528 = gc_frame_newslot(*var_len);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe531 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call532 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe531);
// compiled call node returning call532 (depth = 6)
// compiled member node returning call532 (depth = 5)
  int op_slot_right_530 = gc_frame_newslot(call532);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ind (depth = 5)
  int op_slot_left_530 = gc_frame_newslot(*var_ind);
  params[0] = call532;
  partcv[0] = 1;
  Object sum534 = callmethod(*var_ind, "+", 1, partcv, params);
// compiled op node returning sum534 (depth = 4)
  int op_slot_left_528 = gc_frame_newslot(sum534);
  params[0] = *var_len;
  partcv[0] = 1;
  Object opresult535 = callmethod(sum534, "≤", 1, partcv, params);
// compiled op node returning opresult535 (depth = 3)
  Object if527 = done;
  if (istrue(opresult535)) {
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  int op_slot_right_536 = gc_frame_newslot(*var_str);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_margin (depth = 6)
  int op_slot_right_538 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 6)
  if (strlit540 == NULL) {
    strlit540 = alloc_String("""\x0a""");
    gc_root(strlit540);
  }
// compiled string node returning strlit540 (depth = 6)
  int op_slot_left_538 = gc_frame_newslot(strlit540);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult541 = callmethod(strlit540, "++", 1, partcv, params);
// compiled op node returning opresult541 (depth = 5)
  int op_slot_left_536 = gc_frame_newslot(opresult541);
  params[0] = *var_str;
  partcv[0] = 1;
  Object opresult542 = callmethod(opresult541, "++", 1, partcv, params);
// compiled op node returning opresult542 (depth = 4)
  return opresult542;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if527 = undefined;
  } else {
  }
// compiled if node returning if527 (depth = 2)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_currBreak = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_trimmedLine = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block544 = alloc_Block(NULL, NULL, "ast", 2623);
  gc_frame_newslot(block544);
// method "_apply"
  block_savedest(block544);
  Object closure545 = createclosure(6, "_apply");
  setclosureframe(closure545, stackframe);
  addtoclosure(closure545, var_ind);
  addtoclosure(closure545, var_len);
  addtoclosure(closure545, var_str);
  addtoclosure(closure545, var_currBreak);
  addtoclosure(closure545, var_trimmedLine);
  addtoclosure(closure545, selfslot);
  struct UserObject *uo545 = (struct UserObject*)block544;
  uo545->data[0] = (Object)closure545;
  Method *meth_meth_ast__apply545 = addmethod2pos(block544, "_apply", &meth_ast__apply545, 0);
  int argcv_meth_ast__apply545[] = {0};
  meth_meth_ast__apply545->type = alloc_MethodType(1, argcv_meth_ast__apply545);
  meth_meth_ast__apply545->definitionModule = modulename;
  meth_meth_ast__apply545->definitionLine = 2617;
// compiled block node returning block544 (depth = 3)
  int frame543 = gc_frame_new();
  gc_frame_newslot(block544);
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block566 = alloc_Block(NULL, NULL, "ast", 2627);
  gc_frame_newslot(block566);
// method "_apply"
  block_savedest(block566);
  Object closure567 = createclosure(6, "_apply");
  setclosureframe(closure567, stackframe);
  addtoclosure(closure567, var_ind);
  addtoclosure(closure567, var_len);
  addtoclosure(closure567, var_str);
  addtoclosure(closure567, var_currBreak);
  addtoclosure(closure567, var_trimmedLine);
  addtoclosure(closure567, selfslot);
  struct UserObject *uo567 = (struct UserObject*)block566;
  uo567->data[0] = (Object)closure567;
  Method *meth_meth_ast__apply567 = addmethod2pos(block566, "_apply", &meth_ast__apply567, 0);
  int argcv_meth_ast__apply567[] = {1};
  meth_meth_ast__apply567->type = alloc_MethodType(1, argcv_meth_ast__apply567);
  meth_meth_ast__apply567->definitionModule = modulename;
  meth_meth_ast__apply567->definitionLine = 2626;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe657 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe658 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit659 == NULL) {
    strlit659 = alloc_String("ex");
    gc_root(strlit659);
  }
// compiled string node returning strlit659 (depth = 6)
  gc_frame_newslot(strlit659);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe660 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call661 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe660);
// compiled call node returning call661 (depth = 7)
// compiled member node returning call661 (depth = 6)
  params[0] = strlit659;
  partcv[0] = 1;
  Object call662 = callmethod(call661, "new",
    1, partcv, params);
  gc_frame_end(callframe658);
// compiled call node returning call662 (depth = 5)
  gc_frame_newslot(call662);
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe663 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call664 = callmethodflags(prelude, "NoSuchMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe663);
// compiled call node returning call664 (depth = 6)
// compiled member node returning call664 (depth = 5)
  gc_frame_newslot(call664);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe665 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call666 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe665);
// compiled call node returning call666 (depth = 6)
// compiled member node returning call666 (depth = 5)
  params[0] = call662;
  params[1] = call664;
  partcv[0] = 2;
  Object call667 = callmethod(call666, "new",
    1, partcv, params);
  gc_frame_end(callframe657);
// compiled call node returning call667 (depth = 4)
((struct UserObject *)block566)->data[1] = call667;
// compiled block node returning block566 (depth = 3)
  gc_frame_newslot(block566);
  params[0] = block566;
  setline(2623);
  Object catchres543 = tryCatch(block544, params, 1,NULL);
  gc_frame_end(frame543);
// compiled trycatch node returning catchres543 (depth = 2)
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe669 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe670 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num672 = alloc_Float64(1);
// compiled num node returning num672 (depth = 6)
  int op_slot_right_671 = gc_frame_newslot(num672);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_currBreak (depth = 6)
  int op_slot_left_671 = gc_frame_newslot(*var_currBreak);
  params[0] = num672;
  partcv[0] = 1;
  Object sum674 = callmethod(*var_currBreak, "+", 1, partcv, params);
// compiled op node returning sum674 (depth = 5)
  gc_frame_newslot(sum674);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_str (depth = 7)
  partcv[0] = 0;
  Object call676 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe675);
// compiled call node returning call676 (depth = 6)
// compiled member node returning call676 (depth = 5)
  gc_frame_newslot(call676);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_str (depth = 5)
  params[0] = sum674;
  params[1] = call676;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call677 = callmethod(*var_str, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe670);
// compiled call node returning call677 (depth = 4)
  gc_frame_newslot(call677);
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  gc_frame_newslot(*var_l);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_margin (depth = 4)
  gc_frame_newslot(*var_margin);
// call case 4: self request
  params[0] = call677;
  params[1] = *var_l;
  params[2] = *var_margin;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call678 = callmethodflags(self, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe669);
// compiled call node returning call678 (depth = 3)
  int op_slot_right_668 = gc_frame_newslot(call678);
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_trimmedLine (depth = 4)
  int op_slot_right_680 = gc_frame_newslot(*var_trimmedLine);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_margin (depth = 5)
  int op_slot_right_682 = gc_frame_newslot(*var_margin);
// starting to compile string node (depth = 5)
  if (strlit684 == NULL) {
    strlit684 = alloc_String("""\x0a""");
    gc_root(strlit684);
  }
// compiled string node returning strlit684 (depth = 5)
  int op_slot_left_682 = gc_frame_newslot(strlit684);
  params[0] = *var_margin;
  partcv[0] = 1;
  Object opresult685 = callmethod(strlit684, "++", 1, partcv, params);
// compiled op node returning opresult685 (depth = 4)
  int op_slot_left_680 = gc_frame_newslot(opresult685);
  params[0] = *var_trimmedLine;
  partcv[0] = 1;
  Object opresult686 = callmethod(opresult685, "++", 1, partcv, params);
// compiled op node returning opresult686 (depth = 3)
  int op_slot_left_668 = gc_frame_newslot(opresult686);
  params[0] = call678;
  partcv[0] = 1;
  Object opresult687 = callmethod(opresult686, "++", 1, partcv, params);
// compiled op node returning opresult687 (depth = 2)
  gc_frame_end(frame);
  return opresult687;
}
Object meth_ast_visitIf_40__41_up691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe692 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call693 = callmethodflags(self, "visitIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe692);
// compiled call node returning call693 (depth = 2)
  gc_frame_end(frame);
  return call693;
}
Object meth_ast_visitBlock_40__41_up694(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe695 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call696 = callmethodflags(self, "visitBlock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe695);
// compiled call node returning call696 (depth = 2)
  gc_frame_end(frame);
  return call696;
}
Object meth_ast_visitMatchCase_40__41_up697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe698 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call699 = callmethodflags(self, "visitMatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe698);
// compiled call node returning call699 (depth = 2)
  gc_frame_end(frame);
  return call699;
}
Object meth_ast_visitTryCatch_40__41_up700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe701 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call702 = callmethodflags(self, "visitTryCatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe701);
// compiled call node returning call702 (depth = 2)
  gc_frame_end(frame);
  return call702;
}
Object meth_ast_visitMethodType_40__41_up703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe704 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call705 = callmethodflags(self, "visitMethodType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 2)
  gc_frame_end(frame);
  return call705;
}
Object meth_ast_visitSignaturePart_40__41_up706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe707 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call708 = callmethodflags(self, "visitSignaturePart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe707);
// compiled call node returning call708 (depth = 2)
  gc_frame_end(frame);
  return call708;
}
Object meth_ast_visitTypeDec_40__41_up709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe710 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call711 = callmethodflags(self, "visitTypeDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe710);
// compiled call node returning call711 (depth = 2)
  gc_frame_end(frame);
  return call711;
}
Object meth_ast_visitTypeLiteral_40__41_up712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe713 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call714 = callmethodflags(self, "visitTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe713);
// compiled call node returning call714 (depth = 2)
  gc_frame_end(frame);
  return call714;
}
Object meth_ast_visitTypeParameters_40__41_up715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeParameters");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe716 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call717 = callmethodflags(self, "visitTypeParameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe716);
// compiled call node returning call717 (depth = 2)
  gc_frame_end(frame);
  return call717;
}
Object meth_ast_visitMethod_40__41_up718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe719 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call720 = callmethodflags(self, "visitMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled call node returning call720 (depth = 2)
  gc_frame_end(frame);
  return call720;
}
Object meth_ast_visitCall_40__41_up721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe722 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call723 = callmethodflags(self, "visitCall", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe722);
// compiled call node returning call723 (depth = 2)
  gc_frame_end(frame);
  return call723;
}
Object meth_ast_visitObject_40__41_up724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe725 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call726 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe725);
// compiled call node returning call726 (depth = 2)
  gc_frame_end(frame);
  return call726;
}
Object meth_ast_visitModule_40__41_up727(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe728 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call729 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe728);
// compiled call node returning call729 (depth = 2)
  gc_frame_end(frame);
  return call729;
}
Object meth_ast_visitArray_40__41_up730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe731 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call732 = callmethodflags(self, "visitArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe731);
// compiled call node returning call732 (depth = 2)
  gc_frame_end(frame);
  return call732;
}
Object meth_ast_visitMember_40__41_up733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe734 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call735 = callmethodflags(self, "visitMember", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe734);
// compiled call node returning call735 (depth = 2)
  gc_frame_end(frame);
  return call735;
}
Object meth_ast_visitGeneric_40__41_up736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe737 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call738 = callmethodflags(self, "visitGeneric", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe737);
// compiled call node returning call738 (depth = 2)
  gc_frame_end(frame);
  return call738;
}
Object meth_ast_visitIdentifier_40__41_up739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe740 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call741 = callmethodflags(self, "visitIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe740);
// compiled call node returning call741 (depth = 2)
  gc_frame_end(frame);
  return call741;
}
Object meth_ast_visitString_40__41_up742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe743 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call744 = callmethodflags(self, "visitString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe743);
// compiled call node returning call744 (depth = 2)
  gc_frame_end(frame);
  return call744;
}
Object meth_ast_visitNum_40__41_up745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe746 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call747 = callmethodflags(self, "visitNum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe746);
// compiled call node returning call747 (depth = 2)
  gc_frame_end(frame);
  return call747;
}
Object meth_ast_visitOp_40__41_up748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe749 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call750 = callmethodflags(self, "visitOp", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe749);
// compiled call node returning call750 (depth = 2)
  gc_frame_end(frame);
  return call750;
}
Object meth_ast_visitBind_40__41_up751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe752 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call753 = callmethodflags(self, "visitBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe752);
// compiled call node returning call753 (depth = 2)
  gc_frame_end(frame);
  return call753;
}
Object meth_ast_visitDefDec_40__41_up754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe755 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call756 = callmethodflags(self, "visitDefDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe755);
// compiled call node returning call756 (depth = 2)
  gc_frame_end(frame);
  return call756;
}
Object meth_ast_visitVarDec_40__41_up757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe758 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call759 = callmethodflags(self, "visitVarDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe758);
// compiled call node returning call759 (depth = 2)
  gc_frame_end(frame);
  return call759;
}
Object meth_ast_visitImport_40__41_up760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe761 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call762 = callmethodflags(self, "visitImport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe761);
// compiled call node returning call762 (depth = 2)
  gc_frame_end(frame);
  return call762;
}
Object meth_ast_visitReturn_40__41_up763(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe764 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call765 = callmethodflags(self, "visitReturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe764);
// compiled call node returning call765 (depth = 2)
  gc_frame_end(frame);
  return call765;
}
Object meth_ast_visitInherits_40__41_up766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe767 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call768 = callmethodflags(self, "visitInherits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe767);
// compiled call node returning call768 (depth = 2)
  gc_frame_end(frame);
  return call768;
}
Object meth_ast_visitDialect_40__41_up769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe770 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call771 = callmethodflags(self, "visitDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe770);
// compiled call node returning call771 (depth = 2)
  gc_frame_end(frame);
  return call771;
}
Object meth_ast_visitBlank_40__41_up772(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe773 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call774 = callmethodflags(self, "visitBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe773);
// compiled call node returning call774 (depth = 2)
  gc_frame_end(frame);
  return call774;
}
Object meth_ast_visitComment_40__41_up775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe776 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call777 = callmethodflags(self, "visitComment", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe776);
// compiled call node returning call777 (depth = 2)
  gc_frame_end(frame);
  return call777;
}
Object meth_ast_visitIf778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool779 = alloc_Boolean(1);
// compiled identifier node returning bool779 (depth = 2)
  gc_frame_end(frame);
  return bool779;
}
Object meth_ast_visitBlock780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool781 = alloc_Boolean(1);
// compiled identifier node returning bool781 (depth = 2)
  gc_frame_end(frame);
  return bool781;
}
Object meth_ast_visitMatchCase782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool783 = alloc_Boolean(1);
// compiled identifier node returning bool783 (depth = 2)
  gc_frame_end(frame);
  return bool783;
}
Object meth_ast_visitTryCatch784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTryCatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2714
  setline(2714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool785 = alloc_Boolean(1);
// compiled identifier node returning bool785 (depth = 2)
  gc_frame_end(frame);
  return bool785;
}
Object meth_ast_visitMethodType786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool787 = alloc_Boolean(1);
// compiled identifier node returning bool787 (depth = 2)
  gc_frame_end(frame);
  return bool787;
}
Object meth_ast_visitSignaturePart788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool789 = alloc_Boolean(1);
// compiled identifier node returning bool789 (depth = 2)
  gc_frame_end(frame);
  return bool789;
}
Object meth_ast_visitTypeDec790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool791 = alloc_Boolean(1);
// compiled identifier node returning bool791 (depth = 2)
  gc_frame_end(frame);
  return bool791;
}
Object meth_ast_visitTypeLiteral792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool793 = alloc_Boolean(1);
// compiled identifier node returning bool793 (depth = 2)
  gc_frame_end(frame);
  return bool793;
}
Object meth_ast_visitTypeParameters794(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeParameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeParameters");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeParameters (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeParameters");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool795 = alloc_Boolean(1);
// compiled identifier node returning bool795 (depth = 2)
  gc_frame_end(frame);
  return bool795;
}
Object meth_ast_visitMethod796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool797 = alloc_Boolean(1);
// compiled identifier node returning bool797 (depth = 2)
  gc_frame_end(frame);
  return bool797;
}
Object meth_ast_visitCall798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool799 = alloc_Boolean(1);
// compiled identifier node returning bool799 (depth = 2)
  gc_frame_end(frame);
  return bool799;
}
Object meth_ast_visitObject800(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool801 = alloc_Boolean(1);
// compiled identifier node returning bool801 (depth = 2)
  gc_frame_end(frame);
  return bool801;
}
Object meth_ast_visitModule802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitModule (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool803 = alloc_Boolean(1);
// compiled identifier node returning bool803 (depth = 2)
  gc_frame_end(frame);
  return bool803;
}
Object meth_ast_visitArray804(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool805 = alloc_Boolean(1);
// compiled identifier node returning bool805 (depth = 2)
  gc_frame_end(frame);
  return bool805;
}
Object meth_ast_visitMember806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool807 = alloc_Boolean(1);
// compiled identifier node returning bool807 (depth = 2)
  gc_frame_end(frame);
  return bool807;
}
Object meth_ast_visitGeneric808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool809 = alloc_Boolean(1);
// compiled identifier node returning bool809 (depth = 2)
  gc_frame_end(frame);
  return bool809;
}
Object meth_ast_visitIdentifier810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool811 = alloc_Boolean(1);
// compiled identifier node returning bool811 (depth = 2)
  gc_frame_end(frame);
  return bool811;
}
Object meth_ast_visitString812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool813 = alloc_Boolean(1);
// compiled identifier node returning bool813 (depth = 2)
  gc_frame_end(frame);
  return bool813;
}
Object meth_ast_visitNum814(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool815 = alloc_Boolean(1);
// compiled identifier node returning bool815 (depth = 2)
  gc_frame_end(frame);
  return bool815;
}
Object meth_ast_visitOp816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool817 = alloc_Boolean(1);
// compiled identifier node returning bool817 (depth = 2)
  gc_frame_end(frame);
  return bool817;
}
Object meth_ast_visitBind818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool819 = alloc_Boolean(1);
// compiled identifier node returning bool819 (depth = 2)
  gc_frame_end(frame);
  return bool819;
}
Object meth_ast_visitDefDec820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool821 = alloc_Boolean(1);
// compiled identifier node returning bool821 (depth = 2)
  gc_frame_end(frame);
  return bool821;
}
Object meth_ast_visitVarDec822(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool823 = alloc_Boolean(1);
// compiled identifier node returning bool823 (depth = 2)
  gc_frame_end(frame);
  return bool823;
}
Object meth_ast_visitImport824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool825 = alloc_Boolean(1);
// compiled identifier node returning bool825 (depth = 2)
  gc_frame_end(frame);
  return bool825;
}
Object meth_ast_visitReturn826(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool827 = alloc_Boolean(1);
// compiled identifier node returning bool827 (depth = 2)
  gc_frame_end(frame);
  return bool827;
}
Object meth_ast_visitInherits828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool829 = alloc_Boolean(1);
// compiled identifier node returning bool829 (depth = 2)
  gc_frame_end(frame);
  return bool829;
}
Object meth_ast_visitDialect830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool831 = alloc_Boolean(1);
// compiled identifier node returning bool831 (depth = 2)
  gc_frame_end(frame);
  return bool831;
}
Object meth_ast_visitBlank832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool833 = alloc_Boolean(1);
// compiled identifier node returning bool833 (depth = 2)
  gc_frame_end(frame);
  return bool833;
}
Object meth_ast_visitComment834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for visitComment (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool835 = alloc_Boolean(1);
// compiled identifier node returning bool835 (depth = 2)
  gc_frame_end(frame);
  return bool835;
}
Object meth_ast_asString836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit837 == NULL) {
    strlit837 = alloc_String("an AST visitor");
    gc_root(strlit837);
  }
// compiled string node returning strlit837 (depth = 2)
  gc_frame_end(frame);
  return strlit837;
}
Object meth_ast_baseVisitor688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject689 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj689 = alloc_userobj2(59,60, objclass689);
  gc_frame_newslot(obj689);
if (objclass689 == NULL) {
  glfree(obj689->class->name);
  obj689->class->name = "ast.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj689, self, 0);
  addmethodreal(obj689,"outer", &reader_ast_outer_690);
  Object oldself689 = self;
  struct StackFrameObject *oldstackframe689 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe689);
  gc_frame_newslot((Object)stackframe);
  self = obj689;
  Object *oldselfslot689 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter689 = (*(struct UserObject *)self).data[0], lowerouter689 = thisouter689;
  if (inheritingObject689) {
    struct UserObject *inho689 = (struct UserObject *)inheritingObject689;
    while (inho689->super != GraceDefaultObject) inho689 = (struct UserObject *)inho689->super;
    inho689->super = obj689;
    self = inheritingObject689;
    *selfslot = self;
    lowerouter689 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter689;
  }
// method "visitIf()up"
  struct UserObject *uo691 = (struct UserObject*)obj689;
  uo691->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up691 = addmethod2pos(obj689, "visitIf()up", &meth_ast_visitIf_40__41_up691, 1);
  int argcv_meth_ast_visitIf_40__41_up691[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up691->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up691);
  meth_meth_ast_visitIf_40__41_up691->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up691->definitionLine = 2681;
// method "visitBlock()up"
  struct UserObject *uo694 = (struct UserObject*)obj689;
  uo694->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up694 = addmethod2pos(obj689, "visitBlock()up", &meth_ast_visitBlock_40__41_up694, 2);
  int argcv_meth_ast_visitBlock_40__41_up694[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up694->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up694);
  meth_meth_ast_visitBlock_40__41_up694->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up694->definitionLine = 2682;
// method "visitMatchCase()up"
  struct UserObject *uo697 = (struct UserObject*)obj689;
  uo697->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up697 = addmethod2pos(obj689, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up697, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up697[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up697->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up697);
  meth_meth_ast_visitMatchCase_40__41_up697->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up697->definitionLine = 2683;
// method "visitTryCatch()up"
  struct UserObject *uo700 = (struct UserObject*)obj689;
  uo700->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40__41_up700 = addmethod2pos(obj689, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up700, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up700[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up700->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up700);
  meth_meth_ast_visitTryCatch_40__41_up700->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up700->definitionLine = 2684;
// method "visitMethodType()up"
  struct UserObject *uo703 = (struct UserObject*)obj689;
  uo703->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up703 = addmethod2pos(obj689, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up703, 5);
  int argcv_meth_ast_visitMethodType_40__41_up703[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up703->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up703);
  meth_meth_ast_visitMethodType_40__41_up703->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up703->definitionLine = 2685;
// method "visitSignaturePart()up"
  struct UserObject *uo706 = (struct UserObject*)obj689;
  uo706->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up706 = addmethod2pos(obj689, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up706, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up706[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up706->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up706);
  meth_meth_ast_visitSignaturePart_40__41_up706->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up706->definitionLine = 2686;
// method "visitTypeDec()up"
  struct UserObject *uo709 = (struct UserObject*)obj689;
  uo709->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up709 = addmethod2pos(obj689, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up709, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up709[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up709->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up709);
  meth_meth_ast_visitTypeDec_40__41_up709->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up709->definitionLine = 2687;
// method "visitTypeLiteral()up"
  struct UserObject *uo712 = (struct UserObject*)obj689;
  uo712->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up712 = addmethod2pos(obj689, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up712, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up712[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up712->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up712);
  meth_meth_ast_visitTypeLiteral_40__41_up712->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up712->definitionLine = 2688;
// method "visitTypeParameters()up"
  struct UserObject *uo715 = (struct UserObject*)obj689;
  uo715->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up715 = addmethod2pos(obj689, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up715, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up715[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up715->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up715);
  meth_meth_ast_visitTypeParameters_40__41_up715->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up715->definitionLine = 2689;
// method "visitMethod()up"
  struct UserObject *uo718 = (struct UserObject*)obj689;
  uo718->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up718 = addmethod2pos(obj689, "visitMethod()up", &meth_ast_visitMethod_40__41_up718, 10);
  int argcv_meth_ast_visitMethod_40__41_up718[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up718->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up718);
  meth_meth_ast_visitMethod_40__41_up718->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up718->definitionLine = 2690;
// method "visitCall()up"
  struct UserObject *uo721 = (struct UserObject*)obj689;
  uo721->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up721 = addmethod2pos(obj689, "visitCall()up", &meth_ast_visitCall_40__41_up721, 11);
  int argcv_meth_ast_visitCall_40__41_up721[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up721->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up721);
  meth_meth_ast_visitCall_40__41_up721->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up721->definitionLine = 2691;
// method "visitObject()up"
  struct UserObject *uo724 = (struct UserObject*)obj689;
  uo724->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up724 = addmethod2pos(obj689, "visitObject()up", &meth_ast_visitObject_40__41_up724, 12);
  int argcv_meth_ast_visitObject_40__41_up724[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up724->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up724);
  meth_meth_ast_visitObject_40__41_up724->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up724->definitionLine = 2692;
// method "visitModule()up"
  struct UserObject *uo727 = (struct UserObject*)obj689;
  uo727->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up727 = addmethod2pos(obj689, "visitModule()up", &meth_ast_visitModule_40__41_up727, 13);
  int argcv_meth_ast_visitModule_40__41_up727[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up727->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up727);
  meth_meth_ast_visitModule_40__41_up727->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up727->definitionLine = 2693;
// method "visitArray()up"
  struct UserObject *uo730 = (struct UserObject*)obj689;
  uo730->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up730 = addmethod2pos(obj689, "visitArray()up", &meth_ast_visitArray_40__41_up730, 14);
  int argcv_meth_ast_visitArray_40__41_up730[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up730->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up730);
  meth_meth_ast_visitArray_40__41_up730->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up730->definitionLine = 2694;
// method "visitMember()up"
  struct UserObject *uo733 = (struct UserObject*)obj689;
  uo733->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up733 = addmethod2pos(obj689, "visitMember()up", &meth_ast_visitMember_40__41_up733, 15);
  int argcv_meth_ast_visitMember_40__41_up733[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up733->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up733);
  meth_meth_ast_visitMember_40__41_up733->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up733->definitionLine = 2695;
// method "visitGeneric()up"
  struct UserObject *uo736 = (struct UserObject*)obj689;
  uo736->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up736 = addmethod2pos(obj689, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up736, 16);
  int argcv_meth_ast_visitGeneric_40__41_up736[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up736->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up736);
  meth_meth_ast_visitGeneric_40__41_up736->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up736->definitionLine = 2696;
// method "visitIdentifier()up"
  struct UserObject *uo739 = (struct UserObject*)obj689;
  uo739->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up739 = addmethod2pos(obj689, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up739, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up739[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up739->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up739);
  meth_meth_ast_visitIdentifier_40__41_up739->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up739->definitionLine = 2697;
// method "visitString()up"
  struct UserObject *uo742 = (struct UserObject*)obj689;
  uo742->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up742 = addmethod2pos(obj689, "visitString()up", &meth_ast_visitString_40__41_up742, 18);
  int argcv_meth_ast_visitString_40__41_up742[] = {1, 1};
  meth_meth_ast_visitString_40__41_up742->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up742);
  meth_meth_ast_visitString_40__41_up742->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up742->definitionLine = 2698;
// method "visitNum()up"
  struct UserObject *uo745 = (struct UserObject*)obj689;
  uo745->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up745 = addmethod2pos(obj689, "visitNum()up", &meth_ast_visitNum_40__41_up745, 19);
  int argcv_meth_ast_visitNum_40__41_up745[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up745->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up745);
  meth_meth_ast_visitNum_40__41_up745->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up745->definitionLine = 2699;
// method "visitOp()up"
  struct UserObject *uo748 = (struct UserObject*)obj689;
  uo748->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up748 = addmethod2pos(obj689, "visitOp()up", &meth_ast_visitOp_40__41_up748, 20);
  int argcv_meth_ast_visitOp_40__41_up748[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up748->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up748);
  meth_meth_ast_visitOp_40__41_up748->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up748->definitionLine = 2700;
// method "visitBind()up"
  struct UserObject *uo751 = (struct UserObject*)obj689;
  uo751->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up751 = addmethod2pos(obj689, "visitBind()up", &meth_ast_visitBind_40__41_up751, 21);
  int argcv_meth_ast_visitBind_40__41_up751[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up751->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up751);
  meth_meth_ast_visitBind_40__41_up751->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up751->definitionLine = 2701;
// method "visitDefDec()up"
  struct UserObject *uo754 = (struct UserObject*)obj689;
  uo754->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up754 = addmethod2pos(obj689, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up754, 22);
  int argcv_meth_ast_visitDefDec_40__41_up754[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up754->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up754);
  meth_meth_ast_visitDefDec_40__41_up754->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up754->definitionLine = 2702;
// method "visitVarDec()up"
  struct UserObject *uo757 = (struct UserObject*)obj689;
  uo757->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up757 = addmethod2pos(obj689, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up757, 23);
  int argcv_meth_ast_visitVarDec_40__41_up757[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up757->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up757);
  meth_meth_ast_visitVarDec_40__41_up757->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up757->definitionLine = 2703;
// method "visitImport()up"
  struct UserObject *uo760 = (struct UserObject*)obj689;
  uo760->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up760 = addmethod2pos(obj689, "visitImport()up", &meth_ast_visitImport_40__41_up760, 24);
  int argcv_meth_ast_visitImport_40__41_up760[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up760->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up760);
  meth_meth_ast_visitImport_40__41_up760->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up760->definitionLine = 2704;
// method "visitReturn()up"
  struct UserObject *uo763 = (struct UserObject*)obj689;
  uo763->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up763 = addmethod2pos(obj689, "visitReturn()up", &meth_ast_visitReturn_40__41_up763, 25);
  int argcv_meth_ast_visitReturn_40__41_up763[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up763->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up763);
  meth_meth_ast_visitReturn_40__41_up763->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up763->definitionLine = 2705;
// method "visitInherits()up"
  struct UserObject *uo766 = (struct UserObject*)obj689;
  uo766->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up766 = addmethod2pos(obj689, "visitInherits()up", &meth_ast_visitInherits_40__41_up766, 26);
  int argcv_meth_ast_visitInherits_40__41_up766[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up766->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up766);
  meth_meth_ast_visitInherits_40__41_up766->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up766->definitionLine = 2706;
// method "visitDialect()up"
  struct UserObject *uo769 = (struct UserObject*)obj689;
  uo769->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up769 = addmethod2pos(obj689, "visitDialect()up", &meth_ast_visitDialect_40__41_up769, 27);
  int argcv_meth_ast_visitDialect_40__41_up769[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up769->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up769);
  meth_meth_ast_visitDialect_40__41_up769->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up769->definitionLine = 2707;
// method "visitBlank()up"
  struct UserObject *uo772 = (struct UserObject*)obj689;
  uo772->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up772 = addmethod2pos(obj689, "visitBlank()up", &meth_ast_visitBlank_40__41_up772, 28);
  int argcv_meth_ast_visitBlank_40__41_up772[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up772->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up772);
  meth_meth_ast_visitBlank_40__41_up772->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up772->definitionLine = 2708;
// method "visitComment()up"
  struct UserObject *uo775 = (struct UserObject*)obj689;
  uo775->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up775 = addmethod2pos(obj689, "visitComment()up", &meth_ast_visitComment_40__41_up775, 29);
  int argcv_meth_ast_visitComment_40__41_up775[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up775->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up775);
  meth_meth_ast_visitComment_40__41_up775->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up775->definitionLine = 2709;
// method "visitIf"
  struct UserObject *uo778 = (struct UserObject*)obj689;
  uo778->data[30] = emptyclosure;
  Method *meth_meth_ast_visitIf778 = addmethod2pos(obj689, "visitIf", &meth_ast_visitIf778, 30);
  int argcv_meth_ast_visitIf778[] = {1};
  meth_meth_ast_visitIf778->type = alloc_MethodType(1, argcv_meth_ast_visitIf778);
  meth_meth_ast_visitIf778->definitionModule = modulename;
  meth_meth_ast_visitIf778->definitionLine = 2711;
// method "visitBlock"
  struct UserObject *uo780 = (struct UserObject*)obj689;
  uo780->data[31] = emptyclosure;
  Method *meth_meth_ast_visitBlock780 = addmethod2pos(obj689, "visitBlock", &meth_ast_visitBlock780, 31);
  int argcv_meth_ast_visitBlock780[] = {1};
  meth_meth_ast_visitBlock780->type = alloc_MethodType(1, argcv_meth_ast_visitBlock780);
  meth_meth_ast_visitBlock780->definitionModule = modulename;
  meth_meth_ast_visitBlock780->definitionLine = 2712;
// method "visitMatchCase"
  struct UserObject *uo782 = (struct UserObject*)obj689;
  uo782->data[32] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase782 = addmethod2pos(obj689, "visitMatchCase", &meth_ast_visitMatchCase782, 32);
  int argcv_meth_ast_visitMatchCase782[] = {1};
  meth_meth_ast_visitMatchCase782->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase782);
  meth_meth_ast_visitMatchCase782->definitionModule = modulename;
  meth_meth_ast_visitMatchCase782->definitionLine = 2713;
// method "visitTryCatch"
  struct UserObject *uo784 = (struct UserObject*)obj689;
  uo784->data[33] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch784 = addmethod2pos(obj689, "visitTryCatch", &meth_ast_visitTryCatch784, 33);
  int argcv_meth_ast_visitTryCatch784[] = {1};
  meth_meth_ast_visitTryCatch784->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch784);
  meth_meth_ast_visitTryCatch784->definitionModule = modulename;
  meth_meth_ast_visitTryCatch784->definitionLine = 2714;
// method "visitMethodType"
  struct UserObject *uo786 = (struct UserObject*)obj689;
  uo786->data[34] = emptyclosure;
  Method *meth_meth_ast_visitMethodType786 = addmethod2pos(obj689, "visitMethodType", &meth_ast_visitMethodType786, 34);
  int argcv_meth_ast_visitMethodType786[] = {1};
  meth_meth_ast_visitMethodType786->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType786);
  meth_meth_ast_visitMethodType786->definitionModule = modulename;
  meth_meth_ast_visitMethodType786->definitionLine = 2715;
// method "visitSignaturePart"
  struct UserObject *uo788 = (struct UserObject*)obj689;
  uo788->data[35] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart788 = addmethod2pos(obj689, "visitSignaturePart", &meth_ast_visitSignaturePart788, 35);
  int argcv_meth_ast_visitSignaturePart788[] = {1};
  meth_meth_ast_visitSignaturePart788->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart788);
  meth_meth_ast_visitSignaturePart788->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart788->definitionLine = 2716;
// method "visitTypeDec"
  struct UserObject *uo790 = (struct UserObject*)obj689;
  uo790->data[36] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec790 = addmethod2pos(obj689, "visitTypeDec", &meth_ast_visitTypeDec790, 36);
  int argcv_meth_ast_visitTypeDec790[] = {1};
  meth_meth_ast_visitTypeDec790->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec790);
  meth_meth_ast_visitTypeDec790->definitionModule = modulename;
  meth_meth_ast_visitTypeDec790->definitionLine = 2717;
// method "visitTypeLiteral"
  struct UserObject *uo792 = (struct UserObject*)obj689;
  uo792->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral792 = addmethod2pos(obj689, "visitTypeLiteral", &meth_ast_visitTypeLiteral792, 37);
  int argcv_meth_ast_visitTypeLiteral792[] = {1};
  meth_meth_ast_visitTypeLiteral792->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral792);
  meth_meth_ast_visitTypeLiteral792->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral792->definitionLine = 2718;
// method "visitTypeParameters"
  struct UserObject *uo794 = (struct UserObject*)obj689;
  uo794->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters794 = addmethod2pos(obj689, "visitTypeParameters", &meth_ast_visitTypeParameters794, 38);
  int argcv_meth_ast_visitTypeParameters794[] = {1};
  meth_meth_ast_visitTypeParameters794->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters794);
  meth_meth_ast_visitTypeParameters794->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters794->definitionLine = 2719;
// method "visitMethod"
  struct UserObject *uo796 = (struct UserObject*)obj689;
  uo796->data[39] = emptyclosure;
  Method *meth_meth_ast_visitMethod796 = addmethod2pos(obj689, "visitMethod", &meth_ast_visitMethod796, 39);
  int argcv_meth_ast_visitMethod796[] = {1};
  meth_meth_ast_visitMethod796->type = alloc_MethodType(1, argcv_meth_ast_visitMethod796);
  meth_meth_ast_visitMethod796->definitionModule = modulename;
  meth_meth_ast_visitMethod796->definitionLine = 2720;
// method "visitCall"
  struct UserObject *uo798 = (struct UserObject*)obj689;
  uo798->data[40] = emptyclosure;
  Method *meth_meth_ast_visitCall798 = addmethod2pos(obj689, "visitCall", &meth_ast_visitCall798, 40);
  int argcv_meth_ast_visitCall798[] = {1};
  meth_meth_ast_visitCall798->type = alloc_MethodType(1, argcv_meth_ast_visitCall798);
  meth_meth_ast_visitCall798->definitionModule = modulename;
  meth_meth_ast_visitCall798->definitionLine = 2721;
// method "visitObject"
  struct UserObject *uo800 = (struct UserObject*)obj689;
  uo800->data[41] = emptyclosure;
  Method *meth_meth_ast_visitObject800 = addmethod2pos(obj689, "visitObject", &meth_ast_visitObject800, 41);
  int argcv_meth_ast_visitObject800[] = {1};
  meth_meth_ast_visitObject800->type = alloc_MethodType(1, argcv_meth_ast_visitObject800);
  meth_meth_ast_visitObject800->definitionModule = modulename;
  meth_meth_ast_visitObject800->definitionLine = 2722;
// method "visitModule"
  struct UserObject *uo802 = (struct UserObject*)obj689;
  uo802->data[42] = emptyclosure;
  Method *meth_meth_ast_visitModule802 = addmethod2pos(obj689, "visitModule", &meth_ast_visitModule802, 42);
  int argcv_meth_ast_visitModule802[] = {1};
  meth_meth_ast_visitModule802->type = alloc_MethodType(1, argcv_meth_ast_visitModule802);
  meth_meth_ast_visitModule802->definitionModule = modulename;
  meth_meth_ast_visitModule802->definitionLine = 2723;
// method "visitArray"
  struct UserObject *uo804 = (struct UserObject*)obj689;
  uo804->data[43] = emptyclosure;
  Method *meth_meth_ast_visitArray804 = addmethod2pos(obj689, "visitArray", &meth_ast_visitArray804, 43);
  int argcv_meth_ast_visitArray804[] = {1};
  meth_meth_ast_visitArray804->type = alloc_MethodType(1, argcv_meth_ast_visitArray804);
  meth_meth_ast_visitArray804->definitionModule = modulename;
  meth_meth_ast_visitArray804->definitionLine = 2724;
// method "visitMember"
  struct UserObject *uo806 = (struct UserObject*)obj689;
  uo806->data[44] = emptyclosure;
  Method *meth_meth_ast_visitMember806 = addmethod2pos(obj689, "visitMember", &meth_ast_visitMember806, 44);
  int argcv_meth_ast_visitMember806[] = {1};
  meth_meth_ast_visitMember806->type = alloc_MethodType(1, argcv_meth_ast_visitMember806);
  meth_meth_ast_visitMember806->definitionModule = modulename;
  meth_meth_ast_visitMember806->definitionLine = 2725;
// method "visitGeneric"
  struct UserObject *uo808 = (struct UserObject*)obj689;
  uo808->data[45] = emptyclosure;
  Method *meth_meth_ast_visitGeneric808 = addmethod2pos(obj689, "visitGeneric", &meth_ast_visitGeneric808, 45);
  int argcv_meth_ast_visitGeneric808[] = {1};
  meth_meth_ast_visitGeneric808->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric808);
  meth_meth_ast_visitGeneric808->definitionModule = modulename;
  meth_meth_ast_visitGeneric808->definitionLine = 2726;
// method "visitIdentifier"
  struct UserObject *uo810 = (struct UserObject*)obj689;
  uo810->data[46] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier810 = addmethod2pos(obj689, "visitIdentifier", &meth_ast_visitIdentifier810, 46);
  int argcv_meth_ast_visitIdentifier810[] = {1};
  meth_meth_ast_visitIdentifier810->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier810);
  meth_meth_ast_visitIdentifier810->definitionModule = modulename;
  meth_meth_ast_visitIdentifier810->definitionLine = 2727;
// method "visitString"
  struct UserObject *uo812 = (struct UserObject*)obj689;
  uo812->data[47] = emptyclosure;
  Method *meth_meth_ast_visitString812 = addmethod2pos(obj689, "visitString", &meth_ast_visitString812, 47);
  int argcv_meth_ast_visitString812[] = {1};
  meth_meth_ast_visitString812->type = alloc_MethodType(1, argcv_meth_ast_visitString812);
  meth_meth_ast_visitString812->definitionModule = modulename;
  meth_meth_ast_visitString812->definitionLine = 2728;
// method "visitNum"
  struct UserObject *uo814 = (struct UserObject*)obj689;
  uo814->data[48] = emptyclosure;
  Method *meth_meth_ast_visitNum814 = addmethod2pos(obj689, "visitNum", &meth_ast_visitNum814, 48);
  int argcv_meth_ast_visitNum814[] = {1};
  meth_meth_ast_visitNum814->type = alloc_MethodType(1, argcv_meth_ast_visitNum814);
  meth_meth_ast_visitNum814->definitionModule = modulename;
  meth_meth_ast_visitNum814->definitionLine = 2729;
// method "visitOp"
  struct UserObject *uo816 = (struct UserObject*)obj689;
  uo816->data[49] = emptyclosure;
  Method *meth_meth_ast_visitOp816 = addmethod2pos(obj689, "visitOp", &meth_ast_visitOp816, 49);
  int argcv_meth_ast_visitOp816[] = {1};
  meth_meth_ast_visitOp816->type = alloc_MethodType(1, argcv_meth_ast_visitOp816);
  meth_meth_ast_visitOp816->definitionModule = modulename;
  meth_meth_ast_visitOp816->definitionLine = 2730;
// method "visitBind"
  struct UserObject *uo818 = (struct UserObject*)obj689;
  uo818->data[50] = emptyclosure;
  Method *meth_meth_ast_visitBind818 = addmethod2pos(obj689, "visitBind", &meth_ast_visitBind818, 50);
  int argcv_meth_ast_visitBind818[] = {1};
  meth_meth_ast_visitBind818->type = alloc_MethodType(1, argcv_meth_ast_visitBind818);
  meth_meth_ast_visitBind818->definitionModule = modulename;
  meth_meth_ast_visitBind818->definitionLine = 2731;
// method "visitDefDec"
  struct UserObject *uo820 = (struct UserObject*)obj689;
  uo820->data[51] = emptyclosure;
  Method *meth_meth_ast_visitDefDec820 = addmethod2pos(obj689, "visitDefDec", &meth_ast_visitDefDec820, 51);
  int argcv_meth_ast_visitDefDec820[] = {1};
  meth_meth_ast_visitDefDec820->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec820);
  meth_meth_ast_visitDefDec820->definitionModule = modulename;
  meth_meth_ast_visitDefDec820->definitionLine = 2732;
// method "visitVarDec"
  struct UserObject *uo822 = (struct UserObject*)obj689;
  uo822->data[52] = emptyclosure;
  Method *meth_meth_ast_visitVarDec822 = addmethod2pos(obj689, "visitVarDec", &meth_ast_visitVarDec822, 52);
  int argcv_meth_ast_visitVarDec822[] = {1};
  meth_meth_ast_visitVarDec822->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec822);
  meth_meth_ast_visitVarDec822->definitionModule = modulename;
  meth_meth_ast_visitVarDec822->definitionLine = 2733;
// method "visitImport"
  struct UserObject *uo824 = (struct UserObject*)obj689;
  uo824->data[53] = emptyclosure;
  Method *meth_meth_ast_visitImport824 = addmethod2pos(obj689, "visitImport", &meth_ast_visitImport824, 53);
  int argcv_meth_ast_visitImport824[] = {1};
  meth_meth_ast_visitImport824->type = alloc_MethodType(1, argcv_meth_ast_visitImport824);
  meth_meth_ast_visitImport824->definitionModule = modulename;
  meth_meth_ast_visitImport824->definitionLine = 2734;
// method "visitReturn"
  struct UserObject *uo826 = (struct UserObject*)obj689;
  uo826->data[54] = emptyclosure;
  Method *meth_meth_ast_visitReturn826 = addmethod2pos(obj689, "visitReturn", &meth_ast_visitReturn826, 54);
  int argcv_meth_ast_visitReturn826[] = {1};
  meth_meth_ast_visitReturn826->type = alloc_MethodType(1, argcv_meth_ast_visitReturn826);
  meth_meth_ast_visitReturn826->definitionModule = modulename;
  meth_meth_ast_visitReturn826->definitionLine = 2735;
// method "visitInherits"
  struct UserObject *uo828 = (struct UserObject*)obj689;
  uo828->data[55] = emptyclosure;
  Method *meth_meth_ast_visitInherits828 = addmethod2pos(obj689, "visitInherits", &meth_ast_visitInherits828, 55);
  int argcv_meth_ast_visitInherits828[] = {1};
  meth_meth_ast_visitInherits828->type = alloc_MethodType(1, argcv_meth_ast_visitInherits828);
  meth_meth_ast_visitInherits828->definitionModule = modulename;
  meth_meth_ast_visitInherits828->definitionLine = 2736;
// method "visitDialect"
  struct UserObject *uo830 = (struct UserObject*)obj689;
  uo830->data[56] = emptyclosure;
  Method *meth_meth_ast_visitDialect830 = addmethod2pos(obj689, "visitDialect", &meth_ast_visitDialect830, 56);
  int argcv_meth_ast_visitDialect830[] = {1};
  meth_meth_ast_visitDialect830->type = alloc_MethodType(1, argcv_meth_ast_visitDialect830);
  meth_meth_ast_visitDialect830->definitionModule = modulename;
  meth_meth_ast_visitDialect830->definitionLine = 2737;
// method "visitBlank"
  struct UserObject *uo832 = (struct UserObject*)obj689;
  uo832->data[57] = emptyclosure;
  Method *meth_meth_ast_visitBlank832 = addmethod2pos(obj689, "visitBlank", &meth_ast_visitBlank832, 57);
  int argcv_meth_ast_visitBlank832[] = {1};
  meth_meth_ast_visitBlank832->type = alloc_MethodType(1, argcv_meth_ast_visitBlank832);
  meth_meth_ast_visitBlank832->definitionModule = modulename;
  meth_meth_ast_visitBlank832->definitionLine = 2738;
// method "visitComment"
  struct UserObject *uo834 = (struct UserObject*)obj689;
  uo834->data[58] = emptyclosure;
  Method *meth_meth_ast_visitComment834 = addmethod2pos(obj689, "visitComment", &meth_ast_visitComment834, 58);
  int argcv_meth_ast_visitComment834[] = {1};
  meth_meth_ast_visitComment834->type = alloc_MethodType(1, argcv_meth_ast_visitComment834);
  meth_meth_ast_visitComment834->definitionModule = modulename;
  meth_meth_ast_visitComment834->definitionLine = 2739;
// method "asString"
  struct UserObject *uo836 = (struct UserObject*)obj689;
  uo836->data[59] = emptyclosure;
  Method *meth_meth_ast_asString836 = addmethod2pos(obj689, "asString", &meth_ast_asString836, 59);
  int argcv_meth_ast_asString836[] = {0};
  meth_meth_ast_asString836->type = alloc_MethodType(1, argcv_meth_ast_asString836);
  meth_meth_ast_asString836->definitionModule = modulename;
  meth_meth_ast_asString836->definitionLine = 2741;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  objclass689 = obj689->class;
  objclass689->definitionModule = modulename;
  objclass689->definitionLine = 2680;
  (*(struct UserObject *)self).data[0] = lowerouter689;
  self = oldself689;
  selfslot = oldselfslot689;
  stackframe = oldstackframe689;
  gc_frame_end(frame);
  return obj689;
}
Object meth_ast_baseVisitor688_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject689 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj689 = alloc_userobj2(59,60, objclass689);
  gc_frame_newslot(obj689);
if (objclass689 == NULL) {
  glfree(obj689->class->name);
  obj689->class->name = "ast.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj689, self, 0);
  addmethodreal(obj689,"outer", &reader_ast_outer_690);
  Object oldself689 = self;
  struct StackFrameObject *oldstackframe689 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe689);
  gc_frame_newslot((Object)stackframe);
  self = obj689;
  Object *oldselfslot689 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter689 = (*(struct UserObject *)self).data[0], lowerouter689 = thisouter689;
  if (inheritingObject689) {
    struct UserObject *inho689 = (struct UserObject *)inheritingObject689;
    while (inho689->super != GraceDefaultObject) inho689 = (struct UserObject *)inho689->super;
    inho689->super = obj689;
    self = inheritingObject689;
    *selfslot = self;
    lowerouter689 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter689;
  }
// method "visitIf()up"
  struct UserObject *uo691 = (struct UserObject*)obj689;
  uo691->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up691 = addmethod2pos(obj689, "visitIf()up", &meth_ast_visitIf_40__41_up691, 1);
  int argcv_meth_ast_visitIf_40__41_up691[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up691->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up691);
  meth_meth_ast_visitIf_40__41_up691->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up691->definitionLine = 2681;
// method "visitBlock()up"
  struct UserObject *uo694 = (struct UserObject*)obj689;
  uo694->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up694 = addmethod2pos(obj689, "visitBlock()up", &meth_ast_visitBlock_40__41_up694, 2);
  int argcv_meth_ast_visitBlock_40__41_up694[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up694->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up694);
  meth_meth_ast_visitBlock_40__41_up694->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up694->definitionLine = 2682;
// method "visitMatchCase()up"
  struct UserObject *uo697 = (struct UserObject*)obj689;
  uo697->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up697 = addmethod2pos(obj689, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up697, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up697[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up697->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up697);
  meth_meth_ast_visitMatchCase_40__41_up697->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up697->definitionLine = 2683;
// method "visitTryCatch()up"
  struct UserObject *uo700 = (struct UserObject*)obj689;
  uo700->data[4] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch_40__41_up700 = addmethod2pos(obj689, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up700, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up700[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up700->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up700);
  meth_meth_ast_visitTryCatch_40__41_up700->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up700->definitionLine = 2684;
// method "visitMethodType()up"
  struct UserObject *uo703 = (struct UserObject*)obj689;
  uo703->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up703 = addmethod2pos(obj689, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up703, 5);
  int argcv_meth_ast_visitMethodType_40__41_up703[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up703->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up703);
  meth_meth_ast_visitMethodType_40__41_up703->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up703->definitionLine = 2685;
// method "visitSignaturePart()up"
  struct UserObject *uo706 = (struct UserObject*)obj689;
  uo706->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up706 = addmethod2pos(obj689, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up706, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up706[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up706->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up706);
  meth_meth_ast_visitSignaturePart_40__41_up706->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up706->definitionLine = 2686;
// method "visitTypeDec()up"
  struct UserObject *uo709 = (struct UserObject*)obj689;
  uo709->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up709 = addmethod2pos(obj689, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up709, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up709[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up709->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up709);
  meth_meth_ast_visitTypeDec_40__41_up709->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up709->definitionLine = 2687;
// method "visitTypeLiteral()up"
  struct UserObject *uo712 = (struct UserObject*)obj689;
  uo712->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up712 = addmethod2pos(obj689, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up712, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up712[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up712->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up712);
  meth_meth_ast_visitTypeLiteral_40__41_up712->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up712->definitionLine = 2688;
// method "visitTypeParameters()up"
  struct UserObject *uo715 = (struct UserObject*)obj689;
  uo715->data[9] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters_40__41_up715 = addmethod2pos(obj689, "visitTypeParameters()up", &meth_ast_visitTypeParameters_40__41_up715, 9);
  int argcv_meth_ast_visitTypeParameters_40__41_up715[] = {1, 1};
  meth_meth_ast_visitTypeParameters_40__41_up715->type = alloc_MethodType(2, argcv_meth_ast_visitTypeParameters_40__41_up715);
  meth_meth_ast_visitTypeParameters_40__41_up715->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters_40__41_up715->definitionLine = 2689;
// method "visitMethod()up"
  struct UserObject *uo718 = (struct UserObject*)obj689;
  uo718->data[10] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up718 = addmethod2pos(obj689, "visitMethod()up", &meth_ast_visitMethod_40__41_up718, 10);
  int argcv_meth_ast_visitMethod_40__41_up718[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up718->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up718);
  meth_meth_ast_visitMethod_40__41_up718->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up718->definitionLine = 2690;
// method "visitCall()up"
  struct UserObject *uo721 = (struct UserObject*)obj689;
  uo721->data[11] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up721 = addmethod2pos(obj689, "visitCall()up", &meth_ast_visitCall_40__41_up721, 11);
  int argcv_meth_ast_visitCall_40__41_up721[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up721->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up721);
  meth_meth_ast_visitCall_40__41_up721->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up721->definitionLine = 2691;
// method "visitObject()up"
  struct UserObject *uo724 = (struct UserObject*)obj689;
  uo724->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up724 = addmethod2pos(obj689, "visitObject()up", &meth_ast_visitObject_40__41_up724, 12);
  int argcv_meth_ast_visitObject_40__41_up724[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up724->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up724);
  meth_meth_ast_visitObject_40__41_up724->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up724->definitionLine = 2692;
// method "visitModule()up"
  struct UserObject *uo727 = (struct UserObject*)obj689;
  uo727->data[13] = emptyclosure;
  Method *meth_meth_ast_visitModule_40__41_up727 = addmethod2pos(obj689, "visitModule()up", &meth_ast_visitModule_40__41_up727, 13);
  int argcv_meth_ast_visitModule_40__41_up727[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up727->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up727);
  meth_meth_ast_visitModule_40__41_up727->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up727->definitionLine = 2693;
// method "visitArray()up"
  struct UserObject *uo730 = (struct UserObject*)obj689;
  uo730->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up730 = addmethod2pos(obj689, "visitArray()up", &meth_ast_visitArray_40__41_up730, 14);
  int argcv_meth_ast_visitArray_40__41_up730[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up730->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up730);
  meth_meth_ast_visitArray_40__41_up730->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up730->definitionLine = 2694;
// method "visitMember()up"
  struct UserObject *uo733 = (struct UserObject*)obj689;
  uo733->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up733 = addmethod2pos(obj689, "visitMember()up", &meth_ast_visitMember_40__41_up733, 15);
  int argcv_meth_ast_visitMember_40__41_up733[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up733->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up733);
  meth_meth_ast_visitMember_40__41_up733->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up733->definitionLine = 2695;
// method "visitGeneric()up"
  struct UserObject *uo736 = (struct UserObject*)obj689;
  uo736->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up736 = addmethod2pos(obj689, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up736, 16);
  int argcv_meth_ast_visitGeneric_40__41_up736[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up736->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up736);
  meth_meth_ast_visitGeneric_40__41_up736->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up736->definitionLine = 2696;
// method "visitIdentifier()up"
  struct UserObject *uo739 = (struct UserObject*)obj689;
  uo739->data[17] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up739 = addmethod2pos(obj689, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up739, 17);
  int argcv_meth_ast_visitIdentifier_40__41_up739[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up739->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up739);
  meth_meth_ast_visitIdentifier_40__41_up739->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up739->definitionLine = 2697;
// method "visitString()up"
  struct UserObject *uo742 = (struct UserObject*)obj689;
  uo742->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up742 = addmethod2pos(obj689, "visitString()up", &meth_ast_visitString_40__41_up742, 18);
  int argcv_meth_ast_visitString_40__41_up742[] = {1, 1};
  meth_meth_ast_visitString_40__41_up742->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up742);
  meth_meth_ast_visitString_40__41_up742->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up742->definitionLine = 2698;
// method "visitNum()up"
  struct UserObject *uo745 = (struct UserObject*)obj689;
  uo745->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up745 = addmethod2pos(obj689, "visitNum()up", &meth_ast_visitNum_40__41_up745, 19);
  int argcv_meth_ast_visitNum_40__41_up745[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up745->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up745);
  meth_meth_ast_visitNum_40__41_up745->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up745->definitionLine = 2699;
// method "visitOp()up"
  struct UserObject *uo748 = (struct UserObject*)obj689;
  uo748->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up748 = addmethod2pos(obj689, "visitOp()up", &meth_ast_visitOp_40__41_up748, 20);
  int argcv_meth_ast_visitOp_40__41_up748[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up748->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up748);
  meth_meth_ast_visitOp_40__41_up748->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up748->definitionLine = 2700;
// method "visitBind()up"
  struct UserObject *uo751 = (struct UserObject*)obj689;
  uo751->data[21] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up751 = addmethod2pos(obj689, "visitBind()up", &meth_ast_visitBind_40__41_up751, 21);
  int argcv_meth_ast_visitBind_40__41_up751[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up751->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up751);
  meth_meth_ast_visitBind_40__41_up751->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up751->definitionLine = 2701;
// method "visitDefDec()up"
  struct UserObject *uo754 = (struct UserObject*)obj689;
  uo754->data[22] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up754 = addmethod2pos(obj689, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up754, 22);
  int argcv_meth_ast_visitDefDec_40__41_up754[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up754->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up754);
  meth_meth_ast_visitDefDec_40__41_up754->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up754->definitionLine = 2702;
// method "visitVarDec()up"
  struct UserObject *uo757 = (struct UserObject*)obj689;
  uo757->data[23] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up757 = addmethod2pos(obj689, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up757, 23);
  int argcv_meth_ast_visitVarDec_40__41_up757[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up757->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up757);
  meth_meth_ast_visitVarDec_40__41_up757->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up757->definitionLine = 2703;
// method "visitImport()up"
  struct UserObject *uo760 = (struct UserObject*)obj689;
  uo760->data[24] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up760 = addmethod2pos(obj689, "visitImport()up", &meth_ast_visitImport_40__41_up760, 24);
  int argcv_meth_ast_visitImport_40__41_up760[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up760->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up760);
  meth_meth_ast_visitImport_40__41_up760->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up760->definitionLine = 2704;
// method "visitReturn()up"
  struct UserObject *uo763 = (struct UserObject*)obj689;
  uo763->data[25] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up763 = addmethod2pos(obj689, "visitReturn()up", &meth_ast_visitReturn_40__41_up763, 25);
  int argcv_meth_ast_visitReturn_40__41_up763[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up763->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up763);
  meth_meth_ast_visitReturn_40__41_up763->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up763->definitionLine = 2705;
// method "visitInherits()up"
  struct UserObject *uo766 = (struct UserObject*)obj689;
  uo766->data[26] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up766 = addmethod2pos(obj689, "visitInherits()up", &meth_ast_visitInherits_40__41_up766, 26);
  int argcv_meth_ast_visitInherits_40__41_up766[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up766->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up766);
  meth_meth_ast_visitInherits_40__41_up766->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up766->definitionLine = 2706;
// method "visitDialect()up"
  struct UserObject *uo769 = (struct UserObject*)obj689;
  uo769->data[27] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up769 = addmethod2pos(obj689, "visitDialect()up", &meth_ast_visitDialect_40__41_up769, 27);
  int argcv_meth_ast_visitDialect_40__41_up769[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up769->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up769);
  meth_meth_ast_visitDialect_40__41_up769->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up769->definitionLine = 2707;
// method "visitBlank()up"
  struct UserObject *uo772 = (struct UserObject*)obj689;
  uo772->data[28] = emptyclosure;
  Method *meth_meth_ast_visitBlank_40__41_up772 = addmethod2pos(obj689, "visitBlank()up", &meth_ast_visitBlank_40__41_up772, 28);
  int argcv_meth_ast_visitBlank_40__41_up772[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up772->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up772);
  meth_meth_ast_visitBlank_40__41_up772->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up772->definitionLine = 2708;
// method "visitComment()up"
  struct UserObject *uo775 = (struct UserObject*)obj689;
  uo775->data[29] = emptyclosure;
  Method *meth_meth_ast_visitComment_40__41_up775 = addmethod2pos(obj689, "visitComment()up", &meth_ast_visitComment_40__41_up775, 29);
  int argcv_meth_ast_visitComment_40__41_up775[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up775->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up775);
  meth_meth_ast_visitComment_40__41_up775->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up775->definitionLine = 2709;
// method "visitIf"
  struct UserObject *uo778 = (struct UserObject*)obj689;
  uo778->data[30] = emptyclosure;
  Method *meth_meth_ast_visitIf778 = addmethod2pos(obj689, "visitIf", &meth_ast_visitIf778, 30);
  int argcv_meth_ast_visitIf778[] = {1};
  meth_meth_ast_visitIf778->type = alloc_MethodType(1, argcv_meth_ast_visitIf778);
  meth_meth_ast_visitIf778->definitionModule = modulename;
  meth_meth_ast_visitIf778->definitionLine = 2711;
// method "visitBlock"
  struct UserObject *uo780 = (struct UserObject*)obj689;
  uo780->data[31] = emptyclosure;
  Method *meth_meth_ast_visitBlock780 = addmethod2pos(obj689, "visitBlock", &meth_ast_visitBlock780, 31);
  int argcv_meth_ast_visitBlock780[] = {1};
  meth_meth_ast_visitBlock780->type = alloc_MethodType(1, argcv_meth_ast_visitBlock780);
  meth_meth_ast_visitBlock780->definitionModule = modulename;
  meth_meth_ast_visitBlock780->definitionLine = 2712;
// method "visitMatchCase"
  struct UserObject *uo782 = (struct UserObject*)obj689;
  uo782->data[32] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase782 = addmethod2pos(obj689, "visitMatchCase", &meth_ast_visitMatchCase782, 32);
  int argcv_meth_ast_visitMatchCase782[] = {1};
  meth_meth_ast_visitMatchCase782->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase782);
  meth_meth_ast_visitMatchCase782->definitionModule = modulename;
  meth_meth_ast_visitMatchCase782->definitionLine = 2713;
// method "visitTryCatch"
  struct UserObject *uo784 = (struct UserObject*)obj689;
  uo784->data[33] = emptyclosure;
  Method *meth_meth_ast_visitTryCatch784 = addmethod2pos(obj689, "visitTryCatch", &meth_ast_visitTryCatch784, 33);
  int argcv_meth_ast_visitTryCatch784[] = {1};
  meth_meth_ast_visitTryCatch784->type = alloc_MethodType(1, argcv_meth_ast_visitTryCatch784);
  meth_meth_ast_visitTryCatch784->definitionModule = modulename;
  meth_meth_ast_visitTryCatch784->definitionLine = 2714;
// method "visitMethodType"
  struct UserObject *uo786 = (struct UserObject*)obj689;
  uo786->data[34] = emptyclosure;
  Method *meth_meth_ast_visitMethodType786 = addmethod2pos(obj689, "visitMethodType", &meth_ast_visitMethodType786, 34);
  int argcv_meth_ast_visitMethodType786[] = {1};
  meth_meth_ast_visitMethodType786->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType786);
  meth_meth_ast_visitMethodType786->definitionModule = modulename;
  meth_meth_ast_visitMethodType786->definitionLine = 2715;
// method "visitSignaturePart"
  struct UserObject *uo788 = (struct UserObject*)obj689;
  uo788->data[35] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart788 = addmethod2pos(obj689, "visitSignaturePart", &meth_ast_visitSignaturePart788, 35);
  int argcv_meth_ast_visitSignaturePart788[] = {1};
  meth_meth_ast_visitSignaturePart788->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart788);
  meth_meth_ast_visitSignaturePart788->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart788->definitionLine = 2716;
// method "visitTypeDec"
  struct UserObject *uo790 = (struct UserObject*)obj689;
  uo790->data[36] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec790 = addmethod2pos(obj689, "visitTypeDec", &meth_ast_visitTypeDec790, 36);
  int argcv_meth_ast_visitTypeDec790[] = {1};
  meth_meth_ast_visitTypeDec790->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec790);
  meth_meth_ast_visitTypeDec790->definitionModule = modulename;
  meth_meth_ast_visitTypeDec790->definitionLine = 2717;
// method "visitTypeLiteral"
  struct UserObject *uo792 = (struct UserObject*)obj689;
  uo792->data[37] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral792 = addmethod2pos(obj689, "visitTypeLiteral", &meth_ast_visitTypeLiteral792, 37);
  int argcv_meth_ast_visitTypeLiteral792[] = {1};
  meth_meth_ast_visitTypeLiteral792->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral792);
  meth_meth_ast_visitTypeLiteral792->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral792->definitionLine = 2718;
// method "visitTypeParameters"
  struct UserObject *uo794 = (struct UserObject*)obj689;
  uo794->data[38] = emptyclosure;
  Method *meth_meth_ast_visitTypeParameters794 = addmethod2pos(obj689, "visitTypeParameters", &meth_ast_visitTypeParameters794, 38);
  int argcv_meth_ast_visitTypeParameters794[] = {1};
  meth_meth_ast_visitTypeParameters794->type = alloc_MethodType(1, argcv_meth_ast_visitTypeParameters794);
  meth_meth_ast_visitTypeParameters794->definitionModule = modulename;
  meth_meth_ast_visitTypeParameters794->definitionLine = 2719;
// method "visitMethod"
  struct UserObject *uo796 = (struct UserObject*)obj689;
  uo796->data[39] = emptyclosure;
  Method *meth_meth_ast_visitMethod796 = addmethod2pos(obj689, "visitMethod", &meth_ast_visitMethod796, 39);
  int argcv_meth_ast_visitMethod796[] = {1};
  meth_meth_ast_visitMethod796->type = alloc_MethodType(1, argcv_meth_ast_visitMethod796);
  meth_meth_ast_visitMethod796->definitionModule = modulename;
  meth_meth_ast_visitMethod796->definitionLine = 2720;
// method "visitCall"
  struct UserObject *uo798 = (struct UserObject*)obj689;
  uo798->data[40] = emptyclosure;
  Method *meth_meth_ast_visitCall798 = addmethod2pos(obj689, "visitCall", &meth_ast_visitCall798, 40);
  int argcv_meth_ast_visitCall798[] = {1};
  meth_meth_ast_visitCall798->type = alloc_MethodType(1, argcv_meth_ast_visitCall798);
  meth_meth_ast_visitCall798->definitionModule = modulename;
  meth_meth_ast_visitCall798->definitionLine = 2721;
// method "visitObject"
  struct UserObject *uo800 = (struct UserObject*)obj689;
  uo800->data[41] = emptyclosure;
  Method *meth_meth_ast_visitObject800 = addmethod2pos(obj689, "visitObject", &meth_ast_visitObject800, 41);
  int argcv_meth_ast_visitObject800[] = {1};
  meth_meth_ast_visitObject800->type = alloc_MethodType(1, argcv_meth_ast_visitObject800);
  meth_meth_ast_visitObject800->definitionModule = modulename;
  meth_meth_ast_visitObject800->definitionLine = 2722;
// method "visitModule"
  struct UserObject *uo802 = (struct UserObject*)obj689;
  uo802->data[42] = emptyclosure;
  Method *meth_meth_ast_visitModule802 = addmethod2pos(obj689, "visitModule", &meth_ast_visitModule802, 42);
  int argcv_meth_ast_visitModule802[] = {1};
  meth_meth_ast_visitModule802->type = alloc_MethodType(1, argcv_meth_ast_visitModule802);
  meth_meth_ast_visitModule802->definitionModule = modulename;
  meth_meth_ast_visitModule802->definitionLine = 2723;
// method "visitArray"
  struct UserObject *uo804 = (struct UserObject*)obj689;
  uo804->data[43] = emptyclosure;
  Method *meth_meth_ast_visitArray804 = addmethod2pos(obj689, "visitArray", &meth_ast_visitArray804, 43);
  int argcv_meth_ast_visitArray804[] = {1};
  meth_meth_ast_visitArray804->type = alloc_MethodType(1, argcv_meth_ast_visitArray804);
  meth_meth_ast_visitArray804->definitionModule = modulename;
  meth_meth_ast_visitArray804->definitionLine = 2724;
// method "visitMember"
  struct UserObject *uo806 = (struct UserObject*)obj689;
  uo806->data[44] = emptyclosure;
  Method *meth_meth_ast_visitMember806 = addmethod2pos(obj689, "visitMember", &meth_ast_visitMember806, 44);
  int argcv_meth_ast_visitMember806[] = {1};
  meth_meth_ast_visitMember806->type = alloc_MethodType(1, argcv_meth_ast_visitMember806);
  meth_meth_ast_visitMember806->definitionModule = modulename;
  meth_meth_ast_visitMember806->definitionLine = 2725;
// method "visitGeneric"
  struct UserObject *uo808 = (struct UserObject*)obj689;
  uo808->data[45] = emptyclosure;
  Method *meth_meth_ast_visitGeneric808 = addmethod2pos(obj689, "visitGeneric", &meth_ast_visitGeneric808, 45);
  int argcv_meth_ast_visitGeneric808[] = {1};
  meth_meth_ast_visitGeneric808->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric808);
  meth_meth_ast_visitGeneric808->definitionModule = modulename;
  meth_meth_ast_visitGeneric808->definitionLine = 2726;
// method "visitIdentifier"
  struct UserObject *uo810 = (struct UserObject*)obj689;
  uo810->data[46] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier810 = addmethod2pos(obj689, "visitIdentifier", &meth_ast_visitIdentifier810, 46);
  int argcv_meth_ast_visitIdentifier810[] = {1};
  meth_meth_ast_visitIdentifier810->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier810);
  meth_meth_ast_visitIdentifier810->definitionModule = modulename;
  meth_meth_ast_visitIdentifier810->definitionLine = 2727;
// method "visitString"
  struct UserObject *uo812 = (struct UserObject*)obj689;
  uo812->data[47] = emptyclosure;
  Method *meth_meth_ast_visitString812 = addmethod2pos(obj689, "visitString", &meth_ast_visitString812, 47);
  int argcv_meth_ast_visitString812[] = {1};
  meth_meth_ast_visitString812->type = alloc_MethodType(1, argcv_meth_ast_visitString812);
  meth_meth_ast_visitString812->definitionModule = modulename;
  meth_meth_ast_visitString812->definitionLine = 2728;
// method "visitNum"
  struct UserObject *uo814 = (struct UserObject*)obj689;
  uo814->data[48] = emptyclosure;
  Method *meth_meth_ast_visitNum814 = addmethod2pos(obj689, "visitNum", &meth_ast_visitNum814, 48);
  int argcv_meth_ast_visitNum814[] = {1};
  meth_meth_ast_visitNum814->type = alloc_MethodType(1, argcv_meth_ast_visitNum814);
  meth_meth_ast_visitNum814->definitionModule = modulename;
  meth_meth_ast_visitNum814->definitionLine = 2729;
// method "visitOp"
  struct UserObject *uo816 = (struct UserObject*)obj689;
  uo816->data[49] = emptyclosure;
  Method *meth_meth_ast_visitOp816 = addmethod2pos(obj689, "visitOp", &meth_ast_visitOp816, 49);
  int argcv_meth_ast_visitOp816[] = {1};
  meth_meth_ast_visitOp816->type = alloc_MethodType(1, argcv_meth_ast_visitOp816);
  meth_meth_ast_visitOp816->definitionModule = modulename;
  meth_meth_ast_visitOp816->definitionLine = 2730;
// method "visitBind"
  struct UserObject *uo818 = (struct UserObject*)obj689;
  uo818->data[50] = emptyclosure;
  Method *meth_meth_ast_visitBind818 = addmethod2pos(obj689, "visitBind", &meth_ast_visitBind818, 50);
  int argcv_meth_ast_visitBind818[] = {1};
  meth_meth_ast_visitBind818->type = alloc_MethodType(1, argcv_meth_ast_visitBind818);
  meth_meth_ast_visitBind818->definitionModule = modulename;
  meth_meth_ast_visitBind818->definitionLine = 2731;
// method "visitDefDec"
  struct UserObject *uo820 = (struct UserObject*)obj689;
  uo820->data[51] = emptyclosure;
  Method *meth_meth_ast_visitDefDec820 = addmethod2pos(obj689, "visitDefDec", &meth_ast_visitDefDec820, 51);
  int argcv_meth_ast_visitDefDec820[] = {1};
  meth_meth_ast_visitDefDec820->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec820);
  meth_meth_ast_visitDefDec820->definitionModule = modulename;
  meth_meth_ast_visitDefDec820->definitionLine = 2732;
// method "visitVarDec"
  struct UserObject *uo822 = (struct UserObject*)obj689;
  uo822->data[52] = emptyclosure;
  Method *meth_meth_ast_visitVarDec822 = addmethod2pos(obj689, "visitVarDec", &meth_ast_visitVarDec822, 52);
  int argcv_meth_ast_visitVarDec822[] = {1};
  meth_meth_ast_visitVarDec822->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec822);
  meth_meth_ast_visitVarDec822->definitionModule = modulename;
  meth_meth_ast_visitVarDec822->definitionLine = 2733;
// method "visitImport"
  struct UserObject *uo824 = (struct UserObject*)obj689;
  uo824->data[53] = emptyclosure;
  Method *meth_meth_ast_visitImport824 = addmethod2pos(obj689, "visitImport", &meth_ast_visitImport824, 53);
  int argcv_meth_ast_visitImport824[] = {1};
  meth_meth_ast_visitImport824->type = alloc_MethodType(1, argcv_meth_ast_visitImport824);
  meth_meth_ast_visitImport824->definitionModule = modulename;
  meth_meth_ast_visitImport824->definitionLine = 2734;
// method "visitReturn"
  struct UserObject *uo826 = (struct UserObject*)obj689;
  uo826->data[54] = emptyclosure;
  Method *meth_meth_ast_visitReturn826 = addmethod2pos(obj689, "visitReturn", &meth_ast_visitReturn826, 54);
  int argcv_meth_ast_visitReturn826[] = {1};
  meth_meth_ast_visitReturn826->type = alloc_MethodType(1, argcv_meth_ast_visitReturn826);
  meth_meth_ast_visitReturn826->definitionModule = modulename;
  meth_meth_ast_visitReturn826->definitionLine = 2735;
// method "visitInherits"
  struct UserObject *uo828 = (struct UserObject*)obj689;
  uo828->data[55] = emptyclosure;
  Method *meth_meth_ast_visitInherits828 = addmethod2pos(obj689, "visitInherits", &meth_ast_visitInherits828, 55);
  int argcv_meth_ast_visitInherits828[] = {1};
  meth_meth_ast_visitInherits828->type = alloc_MethodType(1, argcv_meth_ast_visitInherits828);
  meth_meth_ast_visitInherits828->definitionModule = modulename;
  meth_meth_ast_visitInherits828->definitionLine = 2736;
// method "visitDialect"
  struct UserObject *uo830 = (struct UserObject*)obj689;
  uo830->data[56] = emptyclosure;
  Method *meth_meth_ast_visitDialect830 = addmethod2pos(obj689, "visitDialect", &meth_ast_visitDialect830, 56);
  int argcv_meth_ast_visitDialect830[] = {1};
  meth_meth_ast_visitDialect830->type = alloc_MethodType(1, argcv_meth_ast_visitDialect830);
  meth_meth_ast_visitDialect830->definitionModule = modulename;
  meth_meth_ast_visitDialect830->definitionLine = 2737;
// method "visitBlank"
  struct UserObject *uo832 = (struct UserObject*)obj689;
  uo832->data[57] = emptyclosure;
  Method *meth_meth_ast_visitBlank832 = addmethod2pos(obj689, "visitBlank", &meth_ast_visitBlank832, 57);
  int argcv_meth_ast_visitBlank832[] = {1};
  meth_meth_ast_visitBlank832->type = alloc_MethodType(1, argcv_meth_ast_visitBlank832);
  meth_meth_ast_visitBlank832->definitionModule = modulename;
  meth_meth_ast_visitBlank832->definitionLine = 2738;
// method "visitComment"
  struct UserObject *uo834 = (struct UserObject*)obj689;
  uo834->data[58] = emptyclosure;
  Method *meth_meth_ast_visitComment834 = addmethod2pos(obj689, "visitComment", &meth_ast_visitComment834, 58);
  int argcv_meth_ast_visitComment834[] = {1};
  meth_meth_ast_visitComment834->type = alloc_MethodType(1, argcv_meth_ast_visitComment834);
  meth_meth_ast_visitComment834->definitionModule = modulename;
  meth_meth_ast_visitComment834->definitionLine = 2739;
// method "asString"
  struct UserObject *uo836 = (struct UserObject*)obj689;
  uo836->data[59] = emptyclosure;
  Method *meth_meth_ast_asString836 = addmethod2pos(obj689, "asString", &meth_ast_asString836, 59);
  int argcv_meth_ast_asString836[] = {0};
  meth_meth_ast_asString836->type = alloc_MethodType(1, argcv_meth_ast_asString836);
  meth_meth_ast_asString836->definitionModule = modulename;
  meth_meth_ast_asString836->definitionLine = 2741;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  sourceObject = obj689;
  objclass689 = obj689->class;
  objclass689->definitionModule = modulename;
  objclass689->definitionLine = 2680;
  (*(struct UserObject *)self).data[0] = lowerouter689;
  self = oldself689;
  selfslot = oldselfslot689;
  stackframe = oldstackframe689;
  gc_frame_end(frame);
  return obj689;
}
Object meth_ast_visitIf_40__41_up842(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIf()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIf");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe843 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call844 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe843);
// compiled call node returning call844 (depth = 2)
  gc_frame_end(frame);
  return call844;
}
Object meth_ast_visitBlock_40__41_up845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlock()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlock");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe846 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call847 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe846);
// compiled call node returning call847 (depth = 2)
  gc_frame_end(frame);
  return call847;
}
Object meth_ast_visitMatchCase_40__41_up848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMatchCase()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMatchCase");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe849 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call850 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe849);
// compiled call node returning call850 (depth = 2)
  gc_frame_end(frame);
  return call850;
}
Object meth_ast_visitTryCatch_40__41_up851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTryCatch()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTryCatch()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTryCatch()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTryCatch");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe852 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call853 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe852);
// compiled call node returning call853 (depth = 2)
  gc_frame_end(frame);
  return call853;
}
Object meth_ast_visitMethodType_40__41_up854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethodType()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethodType");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe855 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call856 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe855);
// compiled call node returning call856 (depth = 2)
  gc_frame_end(frame);
  return call856;
}
Object meth_ast_visitSignaturePart_40__41_up857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitSignaturePart()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitSignaturePart");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe858 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call859 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe858);
// compiled call node returning call859 (depth = 2)
  gc_frame_end(frame);
  return call859;
}
Object meth_ast_visitTypeDec_40__41_up860(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe861 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call862 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe861);
// compiled call node returning call862 (depth = 2)
  gc_frame_end(frame);
  return call862;
}
Object meth_ast_visitTypeLiteral_40__41_up863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitTypeLiteral()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitTypeLiteral");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe864 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call865 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe864);
// compiled call node returning call865 (depth = 2)
  gc_frame_end(frame);
  return call865;
}
Object meth_ast_visitMethod_40__41_up866(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMethod()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMethod");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe867 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call868 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe867);
// compiled call node returning call868 (depth = 2)
  gc_frame_end(frame);
  return call868;
}
Object meth_ast_visitCall_40__41_up869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe870 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call871 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe870);
// compiled call node returning call871 (depth = 2)
  gc_frame_end(frame);
  return call871;
}
Object meth_ast_visitObject_40__41_up872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitObject()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitObject");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe873 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call874 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe873);
// compiled call node returning call874 (depth = 2)
  gc_frame_end(frame);
  return call874;
}
Object meth_ast_visitModule_40__41_up875(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitModule()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitModule()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitModule()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitModule");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe876 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call877 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe876);
// compiled call node returning call877 (depth = 2)
  gc_frame_end(frame);
  return call877;
}
Object meth_ast_visitArray_40__41_up878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitArray()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitArray");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe879 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call880 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe879);
// compiled call node returning call880 (depth = 2)
  gc_frame_end(frame);
  return call880;
}
Object meth_ast_visitMember_40__41_up881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitMember()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitMember");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe882 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call883 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe882);
// compiled call node returning call883 (depth = 2)
  gc_frame_end(frame);
  return call883;
}
Object meth_ast_visitGeneric_40__41_up884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitGeneric()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitGeneric");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe885 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call886 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe885);
// compiled call node returning call886 (depth = 2)
  gc_frame_end(frame);
  return call886;
}
Object meth_ast_visitIdentifier_40__41_up887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitIdentifier()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitIdentifier");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe888 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call889 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe888);
// compiled call node returning call889 (depth = 2)
  gc_frame_end(frame);
  return call889;
}
Object meth_ast_visitString_40__41_up890(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitString()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitString");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe891 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call892 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe891);
// compiled call node returning call892 (depth = 2)
  gc_frame_end(frame);
  return call892;
}
Object meth_ast_visitNum_40__41_up893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitNum()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitNum");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe894 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call895 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe894);
// compiled call node returning call895 (depth = 2)
  gc_frame_end(frame);
  return call895;
}
Object meth_ast_visitOp_40__41_up896(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitOp()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitOp");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe897 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call898 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe897);
// compiled call node returning call898 (depth = 2)
  gc_frame_end(frame);
  return call898;
}
Object meth_ast_visitBind_40__41_up899(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBind()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBind");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe900 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call901 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe900);
// compiled call node returning call901 (depth = 2)
  gc_frame_end(frame);
  return call901;
}
Object meth_ast_visitDefDec_40__41_up902(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDefDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDefDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe903 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call904 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe903);
// compiled call node returning call904 (depth = 2)
  gc_frame_end(frame);
  return call904;
}
Object meth_ast_visitVarDec_40__41_up905(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitVarDec()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitVarDec");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe906 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call907 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe906);
// compiled call node returning call907 (depth = 2)
  gc_frame_end(frame);
  return call907;
}
Object meth_ast_visitImport_40__41_up908(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitImport()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitImport");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe909 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call910 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe909);
// compiled call node returning call910 (depth = 2)
  gc_frame_end(frame);
  return call910;
}
Object meth_ast_visitReturn_40__41_up911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitReturn()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitReturn");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe912 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call913 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe912);
// compiled call node returning call913 (depth = 2)
  gc_frame_end(frame);
  return call913;
}
Object meth_ast_visitInherits_40__41_up914(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitInherits()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitInherits");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe915 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call916 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe915);
// compiled call node returning call916 (depth = 2)
  gc_frame_end(frame);
  return call916;
}
Object meth_ast_visitDialect_40__41_up917(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitDialect()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitDialect");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe918 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call919 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe918);
// compiled call node returning call919 (depth = 2)
  gc_frame_end(frame);
  return call919;
}
Object meth_ast_visitBlank_40__41_up920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitBlank()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitBlank()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitBlank()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitBlank");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe921 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call922 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe921);
// compiled call node returning call922 (depth = 2)
  gc_frame_end(frame);
  return call922;
}
Object meth_ast_visitComment_40__41_up923(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "visitComment()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitComment()up");
  Object params[2];
  int partcv[1];
  Object *var_visitation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitComment()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitComment");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe924 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_visitation (depth = 3)
  params[0] = *var_o;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call925 = callmethod(*var_visitation, "apply",
    1, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 2)
  gc_frame_end(frame);
  return call925;
}
Object meth_ast_asString926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit927 == NULL) {
    strlit927 = alloc_String("a pluggable AST visitor");
    gc_root(strlit927);
  }
// compiled string node returning strlit927 (depth = 2)
  gc_frame_end(frame);
  return strlit927;
}
Object meth_ast_pluggableVisitor839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject840 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj840 = alloc_userobj2(29,30, objclass840);
  gc_frame_newslot(obj840);
if (objclass840 == NULL) {
  glfree(obj840->class->name);
  obj840->class->name = "ast.pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj840, self, 0);
  addmethodreal(obj840,"outer", &reader_ast_outer_841);
  Object oldself840 = self;
  struct StackFrameObject *oldstackframe840 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe840);
  gc_frame_newslot((Object)stackframe);
  self = obj840;
  Object *oldselfslot840 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter840 = (*(struct UserObject *)self).data[0], lowerouter840 = thisouter840;
  if (inheritingObject840) {
    struct UserObject *inho840 = (struct UserObject *)inheritingObject840;
    while (inho840->super != GraceDefaultObject) inho840 = (struct UserObject *)inho840->super;
    inho840->super = obj840;
    self = inheritingObject840;
    *selfslot = self;
    lowerouter840 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter840;
  }
// method "visitIf()up"
  block_savedest(obj840);
  Object closure842 = createclosure(1, "visitIf()up");
  setclosureframe(closure842, stackframe);
  addtoclosure(closure842, var_visitation);
  struct UserObject *uo842 = (struct UserObject*)obj840;
  uo842->data[1] = (Object)closure842;
  Method *meth_meth_ast_visitIf_40__41_up842 = addmethod2pos(obj840, "visitIf()up", &meth_ast_visitIf_40__41_up842, 1);
  int argcv_meth_ast_visitIf_40__41_up842[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up842->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up842);
  meth_meth_ast_visitIf_40__41_up842->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up842->definitionLine = 2751;
// method "visitBlock()up"
  block_savedest(obj840);
  Object closure845 = createclosure(1, "visitBlock()up");
  setclosureframe(closure845, stackframe);
  addtoclosure(closure845, var_visitation);
  struct UserObject *uo845 = (struct UserObject*)obj840;
  uo845->data[2] = (Object)closure845;
  Method *meth_meth_ast_visitBlock_40__41_up845 = addmethod2pos(obj840, "visitBlock()up", &meth_ast_visitBlock_40__41_up845, 2);
  int argcv_meth_ast_visitBlock_40__41_up845[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up845->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up845);
  meth_meth_ast_visitBlock_40__41_up845->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up845->definitionLine = 2752;
// method "visitMatchCase()up"
  block_savedest(obj840);
  Object closure848 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure848, stackframe);
  addtoclosure(closure848, var_visitation);
  struct UserObject *uo848 = (struct UserObject*)obj840;
  uo848->data[3] = (Object)closure848;
  Method *meth_meth_ast_visitMatchCase_40__41_up848 = addmethod2pos(obj840, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up848, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up848[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up848->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up848);
  meth_meth_ast_visitMatchCase_40__41_up848->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up848->definitionLine = 2753;
// method "visitTryCatch()up"
  block_savedest(obj840);
  Object closure851 = createclosure(1, "visitTryCatch()up");
  setclosureframe(closure851, stackframe);
  addtoclosure(closure851, var_visitation);
  struct UserObject *uo851 = (struct UserObject*)obj840;
  uo851->data[4] = (Object)closure851;
  Method *meth_meth_ast_visitTryCatch_40__41_up851 = addmethod2pos(obj840, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up851, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up851[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up851->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up851);
  meth_meth_ast_visitTryCatch_40__41_up851->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up851->definitionLine = 2754;
// method "visitMethodType()up"
  block_savedest(obj840);
  Object closure854 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure854, stackframe);
  addtoclosure(closure854, var_visitation);
  struct UserObject *uo854 = (struct UserObject*)obj840;
  uo854->data[5] = (Object)closure854;
  Method *meth_meth_ast_visitMethodType_40__41_up854 = addmethod2pos(obj840, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up854, 5);
  int argcv_meth_ast_visitMethodType_40__41_up854[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up854->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up854);
  meth_meth_ast_visitMethodType_40__41_up854->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up854->definitionLine = 2755;
// method "visitSignaturePart()up"
  block_savedest(obj840);
  Object closure857 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure857, stackframe);
  addtoclosure(closure857, var_visitation);
  struct UserObject *uo857 = (struct UserObject*)obj840;
  uo857->data[6] = (Object)closure857;
  Method *meth_meth_ast_visitSignaturePart_40__41_up857 = addmethod2pos(obj840, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up857, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up857[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up857->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up857);
  meth_meth_ast_visitSignaturePart_40__41_up857->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up857->definitionLine = 2756;
// method "visitTypeDec()up"
  block_savedest(obj840);
  Object closure860 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure860, stackframe);
  addtoclosure(closure860, var_visitation);
  struct UserObject *uo860 = (struct UserObject*)obj840;
  uo860->data[7] = (Object)closure860;
  Method *meth_meth_ast_visitTypeDec_40__41_up860 = addmethod2pos(obj840, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up860, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up860[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up860->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up860);
  meth_meth_ast_visitTypeDec_40__41_up860->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up860->definitionLine = 2757;
// method "visitTypeLiteral()up"
  block_savedest(obj840);
  Object closure863 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure863, stackframe);
  addtoclosure(closure863, var_visitation);
  struct UserObject *uo863 = (struct UserObject*)obj840;
  uo863->data[8] = (Object)closure863;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up863 = addmethod2pos(obj840, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up863, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up863[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up863->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up863);
  meth_meth_ast_visitTypeLiteral_40__41_up863->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up863->definitionLine = 2758;
// method "visitMethod()up"
  block_savedest(obj840);
  Object closure866 = createclosure(1, "visitMethod()up");
  setclosureframe(closure866, stackframe);
  addtoclosure(closure866, var_visitation);
  struct UserObject *uo866 = (struct UserObject*)obj840;
  uo866->data[9] = (Object)closure866;
  Method *meth_meth_ast_visitMethod_40__41_up866 = addmethod2pos(obj840, "visitMethod()up", &meth_ast_visitMethod_40__41_up866, 9);
  int argcv_meth_ast_visitMethod_40__41_up866[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up866->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up866);
  meth_meth_ast_visitMethod_40__41_up866->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up866->definitionLine = 2759;
// method "visitCall()up"
  block_savedest(obj840);
  Object closure869 = createclosure(1, "visitCall()up");
  setclosureframe(closure869, stackframe);
  addtoclosure(closure869, var_visitation);
  struct UserObject *uo869 = (struct UserObject*)obj840;
  uo869->data[10] = (Object)closure869;
  Method *meth_meth_ast_visitCall_40__41_up869 = addmethod2pos(obj840, "visitCall()up", &meth_ast_visitCall_40__41_up869, 10);
  int argcv_meth_ast_visitCall_40__41_up869[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up869->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up869);
  meth_meth_ast_visitCall_40__41_up869->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up869->definitionLine = 2760;
// method "visitObject()up"
  block_savedest(obj840);
  Object closure872 = createclosure(1, "visitObject()up");
  setclosureframe(closure872, stackframe);
  addtoclosure(closure872, var_visitation);
  struct UserObject *uo872 = (struct UserObject*)obj840;
  uo872->data[11] = (Object)closure872;
  Method *meth_meth_ast_visitObject_40__41_up872 = addmethod2pos(obj840, "visitObject()up", &meth_ast_visitObject_40__41_up872, 11);
  int argcv_meth_ast_visitObject_40__41_up872[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up872->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up872);
  meth_meth_ast_visitObject_40__41_up872->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up872->definitionLine = 2761;
// method "visitModule()up"
  block_savedest(obj840);
  Object closure875 = createclosure(1, "visitModule()up");
  setclosureframe(closure875, stackframe);
  addtoclosure(closure875, var_visitation);
  struct UserObject *uo875 = (struct UserObject*)obj840;
  uo875->data[12] = (Object)closure875;
  Method *meth_meth_ast_visitModule_40__41_up875 = addmethod2pos(obj840, "visitModule()up", &meth_ast_visitModule_40__41_up875, 12);
  int argcv_meth_ast_visitModule_40__41_up875[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up875->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up875);
  meth_meth_ast_visitModule_40__41_up875->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up875->definitionLine = 2762;
// method "visitArray()up"
  block_savedest(obj840);
  Object closure878 = createclosure(1, "visitArray()up");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_visitation);
  struct UserObject *uo878 = (struct UserObject*)obj840;
  uo878->data[13] = (Object)closure878;
  Method *meth_meth_ast_visitArray_40__41_up878 = addmethod2pos(obj840, "visitArray()up", &meth_ast_visitArray_40__41_up878, 13);
  int argcv_meth_ast_visitArray_40__41_up878[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up878->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up878);
  meth_meth_ast_visitArray_40__41_up878->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up878->definitionLine = 2763;
// method "visitMember()up"
  block_savedest(obj840);
  Object closure881 = createclosure(1, "visitMember()up");
  setclosureframe(closure881, stackframe);
  addtoclosure(closure881, var_visitation);
  struct UserObject *uo881 = (struct UserObject*)obj840;
  uo881->data[14] = (Object)closure881;
  Method *meth_meth_ast_visitMember_40__41_up881 = addmethod2pos(obj840, "visitMember()up", &meth_ast_visitMember_40__41_up881, 14);
  int argcv_meth_ast_visitMember_40__41_up881[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up881->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up881);
  meth_meth_ast_visitMember_40__41_up881->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up881->definitionLine = 2764;
// method "visitGeneric()up"
  block_savedest(obj840);
  Object closure884 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure884, stackframe);
  addtoclosure(closure884, var_visitation);
  struct UserObject *uo884 = (struct UserObject*)obj840;
  uo884->data[15] = (Object)closure884;
  Method *meth_meth_ast_visitGeneric_40__41_up884 = addmethod2pos(obj840, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up884, 15);
  int argcv_meth_ast_visitGeneric_40__41_up884[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up884->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up884);
  meth_meth_ast_visitGeneric_40__41_up884->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up884->definitionLine = 2765;
// method "visitIdentifier()up"
  block_savedest(obj840);
  Object closure887 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure887, stackframe);
  addtoclosure(closure887, var_visitation);
  struct UserObject *uo887 = (struct UserObject*)obj840;
  uo887->data[16] = (Object)closure887;
  Method *meth_meth_ast_visitIdentifier_40__41_up887 = addmethod2pos(obj840, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up887, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up887[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up887->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up887);
  meth_meth_ast_visitIdentifier_40__41_up887->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up887->definitionLine = 2766;
// method "visitString()up"
  block_savedest(obj840);
  Object closure890 = createclosure(1, "visitString()up");
  setclosureframe(closure890, stackframe);
  addtoclosure(closure890, var_visitation);
  struct UserObject *uo890 = (struct UserObject*)obj840;
  uo890->data[17] = (Object)closure890;
  Method *meth_meth_ast_visitString_40__41_up890 = addmethod2pos(obj840, "visitString()up", &meth_ast_visitString_40__41_up890, 17);
  int argcv_meth_ast_visitString_40__41_up890[] = {1, 1};
  meth_meth_ast_visitString_40__41_up890->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up890);
  meth_meth_ast_visitString_40__41_up890->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up890->definitionLine = 2767;
// method "visitNum()up"
  block_savedest(obj840);
  Object closure893 = createclosure(1, "visitNum()up");
  setclosureframe(closure893, stackframe);
  addtoclosure(closure893, var_visitation);
  struct UserObject *uo893 = (struct UserObject*)obj840;
  uo893->data[18] = (Object)closure893;
  Method *meth_meth_ast_visitNum_40__41_up893 = addmethod2pos(obj840, "visitNum()up", &meth_ast_visitNum_40__41_up893, 18);
  int argcv_meth_ast_visitNum_40__41_up893[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up893->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up893);
  meth_meth_ast_visitNum_40__41_up893->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up893->definitionLine = 2768;
// method "visitOp()up"
  block_savedest(obj840);
  Object closure896 = createclosure(1, "visitOp()up");
  setclosureframe(closure896, stackframe);
  addtoclosure(closure896, var_visitation);
  struct UserObject *uo896 = (struct UserObject*)obj840;
  uo896->data[19] = (Object)closure896;
  Method *meth_meth_ast_visitOp_40__41_up896 = addmethod2pos(obj840, "visitOp()up", &meth_ast_visitOp_40__41_up896, 19);
  int argcv_meth_ast_visitOp_40__41_up896[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up896->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up896);
  meth_meth_ast_visitOp_40__41_up896->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up896->definitionLine = 2769;
// method "visitBind()up"
  block_savedest(obj840);
  Object closure899 = createclosure(1, "visitBind()up");
  setclosureframe(closure899, stackframe);
  addtoclosure(closure899, var_visitation);
  struct UserObject *uo899 = (struct UserObject*)obj840;
  uo899->data[20] = (Object)closure899;
  Method *meth_meth_ast_visitBind_40__41_up899 = addmethod2pos(obj840, "visitBind()up", &meth_ast_visitBind_40__41_up899, 20);
  int argcv_meth_ast_visitBind_40__41_up899[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up899->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up899);
  meth_meth_ast_visitBind_40__41_up899->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up899->definitionLine = 2770;
// method "visitDefDec()up"
  block_savedest(obj840);
  Object closure902 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure902, stackframe);
  addtoclosure(closure902, var_visitation);
  struct UserObject *uo902 = (struct UserObject*)obj840;
  uo902->data[21] = (Object)closure902;
  Method *meth_meth_ast_visitDefDec_40__41_up902 = addmethod2pos(obj840, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up902, 21);
  int argcv_meth_ast_visitDefDec_40__41_up902[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up902->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up902);
  meth_meth_ast_visitDefDec_40__41_up902->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up902->definitionLine = 2771;
// method "visitVarDec()up"
  block_savedest(obj840);
  Object closure905 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure905, stackframe);
  addtoclosure(closure905, var_visitation);
  struct UserObject *uo905 = (struct UserObject*)obj840;
  uo905->data[22] = (Object)closure905;
  Method *meth_meth_ast_visitVarDec_40__41_up905 = addmethod2pos(obj840, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up905, 22);
  int argcv_meth_ast_visitVarDec_40__41_up905[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up905->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up905);
  meth_meth_ast_visitVarDec_40__41_up905->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up905->definitionLine = 2772;
// method "visitImport()up"
  block_savedest(obj840);
  Object closure908 = createclosure(1, "visitImport()up");
  setclosureframe(closure908, stackframe);
  addtoclosure(closure908, var_visitation);
  struct UserObject *uo908 = (struct UserObject*)obj840;
  uo908->data[23] = (Object)closure908;
  Method *meth_meth_ast_visitImport_40__41_up908 = addmethod2pos(obj840, "visitImport()up", &meth_ast_visitImport_40__41_up908, 23);
  int argcv_meth_ast_visitImport_40__41_up908[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up908->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up908);
  meth_meth_ast_visitImport_40__41_up908->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up908->definitionLine = 2773;
// method "visitReturn()up"
  block_savedest(obj840);
  Object closure911 = createclosure(1, "visitReturn()up");
  setclosureframe(closure911, stackframe);
  addtoclosure(closure911, var_visitation);
  struct UserObject *uo911 = (struct UserObject*)obj840;
  uo911->data[24] = (Object)closure911;
  Method *meth_meth_ast_visitReturn_40__41_up911 = addmethod2pos(obj840, "visitReturn()up", &meth_ast_visitReturn_40__41_up911, 24);
  int argcv_meth_ast_visitReturn_40__41_up911[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up911->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up911);
  meth_meth_ast_visitReturn_40__41_up911->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up911->definitionLine = 2774;
// method "visitInherits()up"
  block_savedest(obj840);
  Object closure914 = createclosure(1, "visitInherits()up");
  setclosureframe(closure914, stackframe);
  addtoclosure(closure914, var_visitation);
  struct UserObject *uo914 = (struct UserObject*)obj840;
  uo914->data[25] = (Object)closure914;
  Method *meth_meth_ast_visitInherits_40__41_up914 = addmethod2pos(obj840, "visitInherits()up", &meth_ast_visitInherits_40__41_up914, 25);
  int argcv_meth_ast_visitInherits_40__41_up914[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up914->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up914);
  meth_meth_ast_visitInherits_40__41_up914->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up914->definitionLine = 2775;
// method "visitDialect()up"
  block_savedest(obj840);
  Object closure917 = createclosure(1, "visitDialect()up");
  setclosureframe(closure917, stackframe);
  addtoclosure(closure917, var_visitation);
  struct UserObject *uo917 = (struct UserObject*)obj840;
  uo917->data[26] = (Object)closure917;
  Method *meth_meth_ast_visitDialect_40__41_up917 = addmethod2pos(obj840, "visitDialect()up", &meth_ast_visitDialect_40__41_up917, 26);
  int argcv_meth_ast_visitDialect_40__41_up917[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up917->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up917);
  meth_meth_ast_visitDialect_40__41_up917->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up917->definitionLine = 2776;
// method "visitBlank()up"
  block_savedest(obj840);
  Object closure920 = createclosure(1, "visitBlank()up");
  setclosureframe(closure920, stackframe);
  addtoclosure(closure920, var_visitation);
  struct UserObject *uo920 = (struct UserObject*)obj840;
  uo920->data[27] = (Object)closure920;
  Method *meth_meth_ast_visitBlank_40__41_up920 = addmethod2pos(obj840, "visitBlank()up", &meth_ast_visitBlank_40__41_up920, 27);
  int argcv_meth_ast_visitBlank_40__41_up920[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up920->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up920);
  meth_meth_ast_visitBlank_40__41_up920->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up920->definitionLine = 2777;
// method "visitComment()up"
  block_savedest(obj840);
  Object closure923 = createclosure(1, "visitComment()up");
  setclosureframe(closure923, stackframe);
  addtoclosure(closure923, var_visitation);
  struct UserObject *uo923 = (struct UserObject*)obj840;
  uo923->data[28] = (Object)closure923;
  Method *meth_meth_ast_visitComment_40__41_up923 = addmethod2pos(obj840, "visitComment()up", &meth_ast_visitComment_40__41_up923, 28);
  int argcv_meth_ast_visitComment_40__41_up923[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up923->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up923);
  meth_meth_ast_visitComment_40__41_up923->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up923->definitionLine = 2778;
// method "asString"
  struct UserObject *uo926 = (struct UserObject*)obj840;
  uo926->data[29] = emptyclosure;
  Method *meth_meth_ast_asString926 = addmethod2pos(obj840, "asString", &meth_ast_asString926, 29);
  int argcv_meth_ast_asString926[] = {0};
  meth_meth_ast_asString926->type = alloc_MethodType(1, argcv_meth_ast_asString926);
  meth_meth_ast_asString926->definitionModule = modulename;
  meth_meth_ast_asString926->definitionLine = 2780;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  objclass840 = obj840->class;
  objclass840->definitionModule = modulename;
  objclass840->definitionLine = 2744;
  (*(struct UserObject *)self).data[0] = lowerouter840;
  self = oldself840;
  selfslot = oldselfslot840;
  stackframe = oldstackframe840;
  gc_frame_end(frame);
  return obj840;
}
Object meth_ast_pluggableVisitor839_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pluggableVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pluggableVisitor()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pluggableVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitation = &(stackframe->slots[0]);
  *var_visitation = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pluggableVisitor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject840 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj840 = alloc_userobj2(29,30, objclass840);
  gc_frame_newslot(obj840);
if (objclass840 == NULL) {
  glfree(obj840->class->name);
  obj840->class->name = "ast.pluggableVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj840, self, 0);
  addmethodreal(obj840,"outer", &reader_ast_outer_841);
  Object oldself840 = self;
  struct StackFrameObject *oldstackframe840 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe840);
  gc_frame_newslot((Object)stackframe);
  self = obj840;
  Object *oldselfslot840 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter840 = (*(struct UserObject *)self).data[0], lowerouter840 = thisouter840;
  if (inheritingObject840) {
    struct UserObject *inho840 = (struct UserObject *)inheritingObject840;
    while (inho840->super != GraceDefaultObject) inho840 = (struct UserObject *)inho840->super;
    inho840->super = obj840;
    self = inheritingObject840;
    *selfslot = self;
    lowerouter840 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter840;
  }
// method "visitIf()up"
  block_savedest(obj840);
  Object closure842 = createclosure(1, "visitIf()up");
  setclosureframe(closure842, stackframe);
  addtoclosure(closure842, var_visitation);
  struct UserObject *uo842 = (struct UserObject*)obj840;
  uo842->data[1] = (Object)closure842;
  Method *meth_meth_ast_visitIf_40__41_up842 = addmethod2pos(obj840, "visitIf()up", &meth_ast_visitIf_40__41_up842, 1);
  int argcv_meth_ast_visitIf_40__41_up842[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up842->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up842);
  meth_meth_ast_visitIf_40__41_up842->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up842->definitionLine = 2751;
// method "visitBlock()up"
  block_savedest(obj840);
  Object closure845 = createclosure(1, "visitBlock()up");
  setclosureframe(closure845, stackframe);
  addtoclosure(closure845, var_visitation);
  struct UserObject *uo845 = (struct UserObject*)obj840;
  uo845->data[2] = (Object)closure845;
  Method *meth_meth_ast_visitBlock_40__41_up845 = addmethod2pos(obj840, "visitBlock()up", &meth_ast_visitBlock_40__41_up845, 2);
  int argcv_meth_ast_visitBlock_40__41_up845[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up845->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up845);
  meth_meth_ast_visitBlock_40__41_up845->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up845->definitionLine = 2752;
// method "visitMatchCase()up"
  block_savedest(obj840);
  Object closure848 = createclosure(1, "visitMatchCase()up");
  setclosureframe(closure848, stackframe);
  addtoclosure(closure848, var_visitation);
  struct UserObject *uo848 = (struct UserObject*)obj840;
  uo848->data[3] = (Object)closure848;
  Method *meth_meth_ast_visitMatchCase_40__41_up848 = addmethod2pos(obj840, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up848, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up848[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up848->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up848);
  meth_meth_ast_visitMatchCase_40__41_up848->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up848->definitionLine = 2753;
// method "visitTryCatch()up"
  block_savedest(obj840);
  Object closure851 = createclosure(1, "visitTryCatch()up");
  setclosureframe(closure851, stackframe);
  addtoclosure(closure851, var_visitation);
  struct UserObject *uo851 = (struct UserObject*)obj840;
  uo851->data[4] = (Object)closure851;
  Method *meth_meth_ast_visitTryCatch_40__41_up851 = addmethod2pos(obj840, "visitTryCatch()up", &meth_ast_visitTryCatch_40__41_up851, 4);
  int argcv_meth_ast_visitTryCatch_40__41_up851[] = {1, 1};
  meth_meth_ast_visitTryCatch_40__41_up851->type = alloc_MethodType(2, argcv_meth_ast_visitTryCatch_40__41_up851);
  meth_meth_ast_visitTryCatch_40__41_up851->definitionModule = modulename;
  meth_meth_ast_visitTryCatch_40__41_up851->definitionLine = 2754;
// method "visitMethodType()up"
  block_savedest(obj840);
  Object closure854 = createclosure(1, "visitMethodType()up");
  setclosureframe(closure854, stackframe);
  addtoclosure(closure854, var_visitation);
  struct UserObject *uo854 = (struct UserObject*)obj840;
  uo854->data[5] = (Object)closure854;
  Method *meth_meth_ast_visitMethodType_40__41_up854 = addmethod2pos(obj840, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up854, 5);
  int argcv_meth_ast_visitMethodType_40__41_up854[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up854->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up854);
  meth_meth_ast_visitMethodType_40__41_up854->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up854->definitionLine = 2755;
// method "visitSignaturePart()up"
  block_savedest(obj840);
  Object closure857 = createclosure(1, "visitSignaturePart()up");
  setclosureframe(closure857, stackframe);
  addtoclosure(closure857, var_visitation);
  struct UserObject *uo857 = (struct UserObject*)obj840;
  uo857->data[6] = (Object)closure857;
  Method *meth_meth_ast_visitSignaturePart_40__41_up857 = addmethod2pos(obj840, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up857, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up857[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up857->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up857);
  meth_meth_ast_visitSignaturePart_40__41_up857->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up857->definitionLine = 2756;
// method "visitTypeDec()up"
  block_savedest(obj840);
  Object closure860 = createclosure(1, "visitTypeDec()up");
  setclosureframe(closure860, stackframe);
  addtoclosure(closure860, var_visitation);
  struct UserObject *uo860 = (struct UserObject*)obj840;
  uo860->data[7] = (Object)closure860;
  Method *meth_meth_ast_visitTypeDec_40__41_up860 = addmethod2pos(obj840, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up860, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up860[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up860->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up860);
  meth_meth_ast_visitTypeDec_40__41_up860->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up860->definitionLine = 2757;
// method "visitTypeLiteral()up"
  block_savedest(obj840);
  Object closure863 = createclosure(1, "visitTypeLiteral()up");
  setclosureframe(closure863, stackframe);
  addtoclosure(closure863, var_visitation);
  struct UserObject *uo863 = (struct UserObject*)obj840;
  uo863->data[8] = (Object)closure863;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up863 = addmethod2pos(obj840, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up863, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up863[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up863->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up863);
  meth_meth_ast_visitTypeLiteral_40__41_up863->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up863->definitionLine = 2758;
// method "visitMethod()up"
  block_savedest(obj840);
  Object closure866 = createclosure(1, "visitMethod()up");
  setclosureframe(closure866, stackframe);
  addtoclosure(closure866, var_visitation);
  struct UserObject *uo866 = (struct UserObject*)obj840;
  uo866->data[9] = (Object)closure866;
  Method *meth_meth_ast_visitMethod_40__41_up866 = addmethod2pos(obj840, "visitMethod()up", &meth_ast_visitMethod_40__41_up866, 9);
  int argcv_meth_ast_visitMethod_40__41_up866[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up866->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up866);
  meth_meth_ast_visitMethod_40__41_up866->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up866->definitionLine = 2759;
// method "visitCall()up"
  block_savedest(obj840);
  Object closure869 = createclosure(1, "visitCall()up");
  setclosureframe(closure869, stackframe);
  addtoclosure(closure869, var_visitation);
  struct UserObject *uo869 = (struct UserObject*)obj840;
  uo869->data[10] = (Object)closure869;
  Method *meth_meth_ast_visitCall_40__41_up869 = addmethod2pos(obj840, "visitCall()up", &meth_ast_visitCall_40__41_up869, 10);
  int argcv_meth_ast_visitCall_40__41_up869[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up869->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up869);
  meth_meth_ast_visitCall_40__41_up869->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up869->definitionLine = 2760;
// method "visitObject()up"
  block_savedest(obj840);
  Object closure872 = createclosure(1, "visitObject()up");
  setclosureframe(closure872, stackframe);
  addtoclosure(closure872, var_visitation);
  struct UserObject *uo872 = (struct UserObject*)obj840;
  uo872->data[11] = (Object)closure872;
  Method *meth_meth_ast_visitObject_40__41_up872 = addmethod2pos(obj840, "visitObject()up", &meth_ast_visitObject_40__41_up872, 11);
  int argcv_meth_ast_visitObject_40__41_up872[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up872->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up872);
  meth_meth_ast_visitObject_40__41_up872->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up872->definitionLine = 2761;
// method "visitModule()up"
  block_savedest(obj840);
  Object closure875 = createclosure(1, "visitModule()up");
  setclosureframe(closure875, stackframe);
  addtoclosure(closure875, var_visitation);
  struct UserObject *uo875 = (struct UserObject*)obj840;
  uo875->data[12] = (Object)closure875;
  Method *meth_meth_ast_visitModule_40__41_up875 = addmethod2pos(obj840, "visitModule()up", &meth_ast_visitModule_40__41_up875, 12);
  int argcv_meth_ast_visitModule_40__41_up875[] = {1, 1};
  meth_meth_ast_visitModule_40__41_up875->type = alloc_MethodType(2, argcv_meth_ast_visitModule_40__41_up875);
  meth_meth_ast_visitModule_40__41_up875->definitionModule = modulename;
  meth_meth_ast_visitModule_40__41_up875->definitionLine = 2762;
// method "visitArray()up"
  block_savedest(obj840);
  Object closure878 = createclosure(1, "visitArray()up");
  setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_visitation);
  struct UserObject *uo878 = (struct UserObject*)obj840;
  uo878->data[13] = (Object)closure878;
  Method *meth_meth_ast_visitArray_40__41_up878 = addmethod2pos(obj840, "visitArray()up", &meth_ast_visitArray_40__41_up878, 13);
  int argcv_meth_ast_visitArray_40__41_up878[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up878->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up878);
  meth_meth_ast_visitArray_40__41_up878->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up878->definitionLine = 2763;
// method "visitMember()up"
  block_savedest(obj840);
  Object closure881 = createclosure(1, "visitMember()up");
  setclosureframe(closure881, stackframe);
  addtoclosure(closure881, var_visitation);
  struct UserObject *uo881 = (struct UserObject*)obj840;
  uo881->data[14] = (Object)closure881;
  Method *meth_meth_ast_visitMember_40__41_up881 = addmethod2pos(obj840, "visitMember()up", &meth_ast_visitMember_40__41_up881, 14);
  int argcv_meth_ast_visitMember_40__41_up881[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up881->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up881);
  meth_meth_ast_visitMember_40__41_up881->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up881->definitionLine = 2764;
// method "visitGeneric()up"
  block_savedest(obj840);
  Object closure884 = createclosure(1, "visitGeneric()up");
  setclosureframe(closure884, stackframe);
  addtoclosure(closure884, var_visitation);
  struct UserObject *uo884 = (struct UserObject*)obj840;
  uo884->data[15] = (Object)closure884;
  Method *meth_meth_ast_visitGeneric_40__41_up884 = addmethod2pos(obj840, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up884, 15);
  int argcv_meth_ast_visitGeneric_40__41_up884[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up884->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up884);
  meth_meth_ast_visitGeneric_40__41_up884->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up884->definitionLine = 2765;
// method "visitIdentifier()up"
  block_savedest(obj840);
  Object closure887 = createclosure(1, "visitIdentifier()up");
  setclosureframe(closure887, stackframe);
  addtoclosure(closure887, var_visitation);
  struct UserObject *uo887 = (struct UserObject*)obj840;
  uo887->data[16] = (Object)closure887;
  Method *meth_meth_ast_visitIdentifier_40__41_up887 = addmethod2pos(obj840, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up887, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up887[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up887->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up887);
  meth_meth_ast_visitIdentifier_40__41_up887->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up887->definitionLine = 2766;
// method "visitString()up"
  block_savedest(obj840);
  Object closure890 = createclosure(1, "visitString()up");
  setclosureframe(closure890, stackframe);
  addtoclosure(closure890, var_visitation);
  struct UserObject *uo890 = (struct UserObject*)obj840;
  uo890->data[17] = (Object)closure890;
  Method *meth_meth_ast_visitString_40__41_up890 = addmethod2pos(obj840, "visitString()up", &meth_ast_visitString_40__41_up890, 17);
  int argcv_meth_ast_visitString_40__41_up890[] = {1, 1};
  meth_meth_ast_visitString_40__41_up890->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up890);
  meth_meth_ast_visitString_40__41_up890->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up890->definitionLine = 2767;
// method "visitNum()up"
  block_savedest(obj840);
  Object closure893 = createclosure(1, "visitNum()up");
  setclosureframe(closure893, stackframe);
  addtoclosure(closure893, var_visitation);
  struct UserObject *uo893 = (struct UserObject*)obj840;
  uo893->data[18] = (Object)closure893;
  Method *meth_meth_ast_visitNum_40__41_up893 = addmethod2pos(obj840, "visitNum()up", &meth_ast_visitNum_40__41_up893, 18);
  int argcv_meth_ast_visitNum_40__41_up893[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up893->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up893);
  meth_meth_ast_visitNum_40__41_up893->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up893->definitionLine = 2768;
// method "visitOp()up"
  block_savedest(obj840);
  Object closure896 = createclosure(1, "visitOp()up");
  setclosureframe(closure896, stackframe);
  addtoclosure(closure896, var_visitation);
  struct UserObject *uo896 = (struct UserObject*)obj840;
  uo896->data[19] = (Object)closure896;
  Method *meth_meth_ast_visitOp_40__41_up896 = addmethod2pos(obj840, "visitOp()up", &meth_ast_visitOp_40__41_up896, 19);
  int argcv_meth_ast_visitOp_40__41_up896[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up896->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up896);
  meth_meth_ast_visitOp_40__41_up896->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up896->definitionLine = 2769;
// method "visitBind()up"
  block_savedest(obj840);
  Object closure899 = createclosure(1, "visitBind()up");
  setclosureframe(closure899, stackframe);
  addtoclosure(closure899, var_visitation);
  struct UserObject *uo899 = (struct UserObject*)obj840;
  uo899->data[20] = (Object)closure899;
  Method *meth_meth_ast_visitBind_40__41_up899 = addmethod2pos(obj840, "visitBind()up", &meth_ast_visitBind_40__41_up899, 20);
  int argcv_meth_ast_visitBind_40__41_up899[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up899->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up899);
  meth_meth_ast_visitBind_40__41_up899->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up899->definitionLine = 2770;
// method "visitDefDec()up"
  block_savedest(obj840);
  Object closure902 = createclosure(1, "visitDefDec()up");
  setclosureframe(closure902, stackframe);
  addtoclosure(closure902, var_visitation);
  struct UserObject *uo902 = (struct UserObject*)obj840;
  uo902->data[21] = (Object)closure902;
  Method *meth_meth_ast_visitDefDec_40__41_up902 = addmethod2pos(obj840, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up902, 21);
  int argcv_meth_ast_visitDefDec_40__41_up902[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up902->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up902);
  meth_meth_ast_visitDefDec_40__41_up902->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up902->definitionLine = 2771;
// method "visitVarDec()up"
  block_savedest(obj840);
  Object closure905 = createclosure(1, "visitVarDec()up");
  setclosureframe(closure905, stackframe);
  addtoclosure(closure905, var_visitation);
  struct UserObject *uo905 = (struct UserObject*)obj840;
  uo905->data[22] = (Object)closure905;
  Method *meth_meth_ast_visitVarDec_40__41_up905 = addmethod2pos(obj840, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up905, 22);
  int argcv_meth_ast_visitVarDec_40__41_up905[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up905->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up905);
  meth_meth_ast_visitVarDec_40__41_up905->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up905->definitionLine = 2772;
// method "visitImport()up"
  block_savedest(obj840);
  Object closure908 = createclosure(1, "visitImport()up");
  setclosureframe(closure908, stackframe);
  addtoclosure(closure908, var_visitation);
  struct UserObject *uo908 = (struct UserObject*)obj840;
  uo908->data[23] = (Object)closure908;
  Method *meth_meth_ast_visitImport_40__41_up908 = addmethod2pos(obj840, "visitImport()up", &meth_ast_visitImport_40__41_up908, 23);
  int argcv_meth_ast_visitImport_40__41_up908[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up908->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up908);
  meth_meth_ast_visitImport_40__41_up908->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up908->definitionLine = 2773;
// method "visitReturn()up"
  block_savedest(obj840);
  Object closure911 = createclosure(1, "visitReturn()up");
  setclosureframe(closure911, stackframe);
  addtoclosure(closure911, var_visitation);
  struct UserObject *uo911 = (struct UserObject*)obj840;
  uo911->data[24] = (Object)closure911;
  Method *meth_meth_ast_visitReturn_40__41_up911 = addmethod2pos(obj840, "visitReturn()up", &meth_ast_visitReturn_40__41_up911, 24);
  int argcv_meth_ast_visitReturn_40__41_up911[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up911->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up911);
  meth_meth_ast_visitReturn_40__41_up911->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up911->definitionLine = 2774;
// method "visitInherits()up"
  block_savedest(obj840);
  Object closure914 = createclosure(1, "visitInherits()up");
  setclosureframe(closure914, stackframe);
  addtoclosure(closure914, var_visitation);
  struct UserObject *uo914 = (struct UserObject*)obj840;
  uo914->data[25] = (Object)closure914;
  Method *meth_meth_ast_visitInherits_40__41_up914 = addmethod2pos(obj840, "visitInherits()up", &meth_ast_visitInherits_40__41_up914, 25);
  int argcv_meth_ast_visitInherits_40__41_up914[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up914->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up914);
  meth_meth_ast_visitInherits_40__41_up914->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up914->definitionLine = 2775;
// method "visitDialect()up"
  block_savedest(obj840);
  Object closure917 = createclosure(1, "visitDialect()up");
  setclosureframe(closure917, stackframe);
  addtoclosure(closure917, var_visitation);
  struct UserObject *uo917 = (struct UserObject*)obj840;
  uo917->data[26] = (Object)closure917;
  Method *meth_meth_ast_visitDialect_40__41_up917 = addmethod2pos(obj840, "visitDialect()up", &meth_ast_visitDialect_40__41_up917, 26);
  int argcv_meth_ast_visitDialect_40__41_up917[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up917->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up917);
  meth_meth_ast_visitDialect_40__41_up917->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up917->definitionLine = 2776;
// method "visitBlank()up"
  block_savedest(obj840);
  Object closure920 = createclosure(1, "visitBlank()up");
  setclosureframe(closure920, stackframe);
  addtoclosure(closure920, var_visitation);
  struct UserObject *uo920 = (struct UserObject*)obj840;
  uo920->data[27] = (Object)closure920;
  Method *meth_meth_ast_visitBlank_40__41_up920 = addmethod2pos(obj840, "visitBlank()up", &meth_ast_visitBlank_40__41_up920, 27);
  int argcv_meth_ast_visitBlank_40__41_up920[] = {1, 1};
  meth_meth_ast_visitBlank_40__41_up920->type = alloc_MethodType(2, argcv_meth_ast_visitBlank_40__41_up920);
  meth_meth_ast_visitBlank_40__41_up920->definitionModule = modulename;
  meth_meth_ast_visitBlank_40__41_up920->definitionLine = 2777;
// method "visitComment()up"
  block_savedest(obj840);
  Object closure923 = createclosure(1, "visitComment()up");
  setclosureframe(closure923, stackframe);
  addtoclosure(closure923, var_visitation);
  struct UserObject *uo923 = (struct UserObject*)obj840;
  uo923->data[28] = (Object)closure923;
  Method *meth_meth_ast_visitComment_40__41_up923 = addmethod2pos(obj840, "visitComment()up", &meth_ast_visitComment_40__41_up923, 28);
  int argcv_meth_ast_visitComment_40__41_up923[] = {1, 1};
  meth_meth_ast_visitComment_40__41_up923->type = alloc_MethodType(2, argcv_meth_ast_visitComment_40__41_up923);
  meth_meth_ast_visitComment_40__41_up923->definitionModule = modulename;
  meth_meth_ast_visitComment_40__41_up923->definitionLine = 2778;
// method "asString"
  struct UserObject *uo926 = (struct UserObject*)obj840;
  uo926->data[29] = emptyclosure;
  Method *meth_meth_ast_asString926 = addmethod2pos(obj840, "asString", &meth_ast_asString926, 29);
  int argcv_meth_ast_asString926[] = {0};
  meth_meth_ast_asString926->type = alloc_MethodType(1, argcv_meth_ast_asString926);
  meth_meth_ast_asString926->definitionModule = modulename;
  meth_meth_ast_asString926->definitionLine = 2780;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  sourceObject = obj840;
  objclass840 = obj840->class;
  objclass840->definitionModule = modulename;
  objclass840->definitionLine = 2744;
  (*(struct UserObject *)self).data[0] = lowerouter840;
  self = oldself840;
  selfslot = oldselfslot840;
  stackframe = oldstackframe840;
  gc_frame_end(frame);
  return obj840;
}
Object meth_ast__apply938(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_939 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  partcv[0] = 0;
  Object call942 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe941);
// compiled call node returning call942 (depth = 9)
// compiled member node returning call942 (depth = 8)
  int op_slot_left_939 = gc_frame_newslot(call942);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult943 = callmethod(call942, "==", 1, partcv, params);
// compiled op node returning opresult943 (depth = 7)
  gc_frame_end(frame);
  return opresult943;
}
Object meth_ast__apply934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block937 = alloc_Block(NULL, NULL, "ast", 2794);
  gc_frame_newslot(block937);
// method "_apply"
  block_savedest(block937);
  Object closure938 = createclosure(3, "_apply");
  setclosureframe(closure938, stackframe);
  addtoclosure(closure938, var_annName);
  addtoclosure(closure938, var_ann);
  addtoclosure(closure938, selfslot);
  struct UserObject *uo938 = (struct UserObject*)block937;
  uo938->data[0] = (Object)closure938;
  Method *meth_meth_ast__apply938 = addmethod2pos(block937, "_apply", &meth_ast__apply938, 0);
  int argcv_meth_ast__apply938[] = {0};
  meth_meth_ast__apply938->type = alloc_MethodType(1, argcv_meth_ast__apply938);
  meth_meth_ast__apply938->definitionModule = modulename;
  meth_meth_ast__apply938->definitionLine = 2793;
// compiled block node returning block937 (depth = 6)
  int op_slot_right_936 = gc_frame_newslot(block937);
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit947 == NULL) {
    strlit947 = alloc_String("identifier");
    gc_root(strlit947);
  }
// compiled string node returning strlit947 (depth = 7)
  int op_slot_right_946 = gc_frame_newslot(strlit947);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  partcv[0] = 0;
  Object call950 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe949);
// compiled call node returning call950 (depth = 8)
// compiled member node returning call950 (depth = 7)
  int op_slot_left_946 = gc_frame_newslot(call950);
  params[0] = strlit947;
  partcv[0] = 1;
  Object opresult951 = callmethod(call950, "==", 1, partcv, params);
// compiled op node returning opresult951 (depth = 6)
  int op_slot_left_936 = gc_frame_newslot(opresult951);
  params[0] = block937;
  partcv[0] = 1;
  Object opresult952 = callmethod(opresult951, "&&", 1, partcv, params);
// compiled op node returning opresult952 (depth = 5)
  Object if935 = done;
  if (istrue(opresult952)) {
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject953 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj953 = alloc_userobj2(1,2, objclass953);
  gc_frame_newslot(obj953);
// OBJECT OUTER DEC outer
  adddatum2(obj953, self, 0);
  addmethodreal(obj953,"outer", &reader_ast_outer_954);
  Object oldself953 = self;
  struct StackFrameObject *oldstackframe953 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe953);
  gc_frame_newslot((Object)stackframe);
  self = obj953;
  Object *oldselfslot953 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter953 = (*(struct UserObject *)self).data[0], lowerouter953 = thisouter953;
  if (inheritingObject953) {
    struct UserObject *inho953 = (struct UserObject *)inheritingObject953;
    while (inho953->super != GraceDefaultObject) inho953 = (struct UserObject *)inho953->super;
    inho953->super = obj953;
    self = inheritingObject953;
    *selfslot = self;
    lowerouter953 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter953;
  }
if (objclass953 == NULL) {
  Method *reader955 = addmethodrealflags(obj953, "value",&reader_ast_value_955, MFLAG_DEF);
  reader955->definitionModule = modulename;
  reader955->definitionLine = 2798;
}
adddatum2(obj953, alloc_Undefined(), 1);
  sourceObject = obj953;
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool956 = alloc_Boolean(1);
// compiled identifier node returning bool956 (depth = 7)
  struct UserObject *obj953_uo = (struct UserObject *)obj953;
  obj953_uo->super = bool956;
  sourceObject = obj953;
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj953, *var_ann, 1);
  objclass953 = obj953->class;
  objclass953->definitionModule = modulename;
  objclass953->definitionLine = 2796;
  (*(struct UserObject *)self).data[0] = lowerouter953;
  self = oldself953;
  selfslot = oldselfslot953;
  stackframe = oldstackframe953;
// compiled object node returning obj953 (depth = 6)
  block_return(realself, obj953);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if935 = undefined;
  } else {
  }
// compiled if node returning if935 (depth = 4)
  gc_frame_end(frame);
  return if935;
}
Object meth_ast_findAnnotation929(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findAnnotation");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe930 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call932 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe931);
// compiled call node returning call932 (depth = 4)
// compiled member node returning call932 (depth = 3)
  gc_frame_newslot(call932);
// starting to compile block node (depth = 3)
  Object block933 = alloc_Block(NULL, NULL, "ast", 2793);
  gc_frame_newslot(block933);
// method "_apply"
  block_savedest(block933);
  Object closure934 = createclosure(2, "_apply");
  setclosureframe(closure934, stackframe);
  addtoclosure(closure934, var_annName);
  addtoclosure(closure934, selfslot);
  struct UserObject *uo934 = (struct UserObject*)block933;
  uo934->data[0] = (Object)closure934;
  Method *meth_meth_ast__apply934 = addmethod2pos(block933, "_apply", &meth_ast__apply934, 0);
  int argcv_meth_ast__apply934[] = {1};
  meth_meth_ast__apply934->type = alloc_MethodType(1, argcv_meth_ast__apply934);
  meth_meth_ast__apply934->definitionModule = modulename;
  meth_meth_ast__apply934->definitionLine = 2793;
// compiled block node returning block933 (depth = 3)
  gc_frame_newslot(block933);
// call case 5: prelude request
  params[0] = call932;
  params[1] = block933;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call958 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe930);
// compiled call node returning call958 (depth = 2)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool959 = alloc_Boolean(0);
// compiled identifier node returning bool959 (depth = 2)
  gc_frame_end(frame);
  return bool959;
}
Object meth_ast_lineLength961(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lineLength");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lineLength (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lineLength");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lineLength (depth = 3)
  gc_frame_end(frame);
  return *var_lineLength;
}
Object meth_ast_isEmpty967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool968 = alloc_Boolean(1);
// compiled identifier node returning bool968 (depth = 3)
  gc_frame_end(frame);
  return bool968;
}
Object meth_ast_asString969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit970 == NULL) {
    strlit970 = alloc_String("ancestorChain ""\xe2""""\x96""""\xab""");
    gc_root(strlit970);
  }
// compiled string node returning strlit970 (depth = 3)
  gc_frame_end(frame);
  return strlit970;
}
Object meth_ast_extend971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe972 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe973 = gc_frame_new();
// call case 3: self.outer request
  Object call974 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe973);
// compiled call node returning call974 (depth = 5)
// compiled member node returning call974 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call975 = callmethodflags(call974, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe972);
// compiled call node returning call975 (depth = 3)
  gc_frame_end(frame);
  return call975;
}
Object meth_ast_empty964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj965 = alloc_userobj2(3,4, objclass965);
  gc_frame_newslot(obj965);
if (objclass965 == NULL) {
  glfree(obj965->class->name);
  obj965->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj965, self, 0);
  addmethodreal(obj965,"outer", &reader_ast_outer_966);
  Object oldself965 = self;
  struct StackFrameObject *oldstackframe965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe965);
  gc_frame_newslot((Object)stackframe);
  self = obj965;
  Object *oldselfslot965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter965 = (*(struct UserObject *)self).data[0], lowerouter965 = thisouter965;
  if (inheritingObject965) {
    struct UserObject *inho965 = (struct UserObject *)inheritingObject965;
    while (inho965->super != GraceDefaultObject) inho965 = (struct UserObject *)inho965->super;
    inho965->super = obj965;
    self = inheritingObject965;
    *selfslot = self;
    lowerouter965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter965;
  }
// method "isEmpty"
  struct UserObject *uo967 = (struct UserObject*)obj965;
  uo967->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty967 = addmethod2pos(obj965, "isEmpty", &meth_ast_isEmpty967, 1);
  int argcv_meth_ast_isEmpty967[] = {0};
  meth_meth_ast_isEmpty967->type = alloc_MethodType(1, argcv_meth_ast_isEmpty967);
  meth_meth_ast_isEmpty967->definitionModule = modulename;
  meth_meth_ast_isEmpty967->definitionLine = 40;
// method "asString"
  struct UserObject *uo969 = (struct UserObject*)obj965;
  uo969->data[2] = emptyclosure;
  Method *meth_meth_ast_asString969 = addmethod2pos(obj965, "asString", &meth_ast_asString969, 2);
  int argcv_meth_ast_asString969[] = {0};
  meth_meth_ast_asString969->type = alloc_MethodType(1, argcv_meth_ast_asString969);
  meth_meth_ast_asString969->definitionModule = modulename;
  meth_meth_ast_asString969->definitionLine = 41;
// method "extend"
  struct UserObject *uo971 = (struct UserObject*)obj965;
  uo971->data[3] = emptyclosure;
  Method *meth_meth_ast_extend971 = addmethod2pos(obj965, "extend", &meth_ast_extend971, 3);
  int argcv_meth_ast_extend971[] = {1};
  meth_meth_ast_extend971->type = alloc_MethodType(1, argcv_meth_ast_extend971);
  meth_meth_ast_extend971->definitionModule = modulename;
  meth_meth_ast_extend971->definitionLine = 42;
  sourceObject = obj965;
  sourceObject = obj965;
  sourceObject = obj965;
  objclass965 = obj965->class;
  objclass965->definitionModule = modulename;
  objclass965->definitionLine = 39;
  (*(struct UserObject *)self).data[0] = lowerouter965;
  self = oldself965;
  selfslot = oldselfslot965;
  stackframe = oldstackframe965;
  gc_frame_end(frame);
  return obj965;
}
Object meth_ast_empty964_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj965 = alloc_userobj2(3,4, objclass965);
  gc_frame_newslot(obj965);
if (objclass965 == NULL) {
  glfree(obj965->class->name);
  obj965->class->name = "ancestorChain.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj965, self, 0);
  addmethodreal(obj965,"outer", &reader_ast_outer_966);
  Object oldself965 = self;
  struct StackFrameObject *oldstackframe965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe965);
  gc_frame_newslot((Object)stackframe);
  self = obj965;
  Object *oldselfslot965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter965 = (*(struct UserObject *)self).data[0], lowerouter965 = thisouter965;
  if (inheritingObject965) {
    struct UserObject *inho965 = (struct UserObject *)inheritingObject965;
    while (inho965->super != GraceDefaultObject) inho965 = (struct UserObject *)inho965->super;
    inho965->super = obj965;
    self = inheritingObject965;
    *selfslot = self;
    lowerouter965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter965;
  }
// method "isEmpty"
  struct UserObject *uo967 = (struct UserObject*)obj965;
  uo967->data[1] = emptyclosure;
  Method *meth_meth_ast_isEmpty967 = addmethod2pos(obj965, "isEmpty", &meth_ast_isEmpty967, 1);
  int argcv_meth_ast_isEmpty967[] = {0};
  meth_meth_ast_isEmpty967->type = alloc_MethodType(1, argcv_meth_ast_isEmpty967);
  meth_meth_ast_isEmpty967->definitionModule = modulename;
  meth_meth_ast_isEmpty967->definitionLine = 40;
// method "asString"
  struct UserObject *uo969 = (struct UserObject*)obj965;
  uo969->data[2] = emptyclosure;
  Method *meth_meth_ast_asString969 = addmethod2pos(obj965, "asString", &meth_ast_asString969, 2);
  int argcv_meth_ast_asString969[] = {0};
  meth_meth_ast_asString969->type = alloc_MethodType(1, argcv_meth_ast_asString969);
  meth_meth_ast_asString969->definitionModule = modulename;
  meth_meth_ast_asString969->definitionLine = 41;
// method "extend"
  struct UserObject *uo971 = (struct UserObject*)obj965;
  uo971->data[3] = emptyclosure;
  Method *meth_meth_ast_extend971 = addmethod2pos(obj965, "extend", &meth_ast_extend971, 3);
  int argcv_meth_ast_extend971[] = {1};
  meth_meth_ast_extend971->type = alloc_MethodType(1, argcv_meth_ast_extend971);
  meth_meth_ast_extend971->definitionModule = modulename;
  meth_meth_ast_extend971->definitionLine = 42;
  sourceObject = obj965;
  sourceObject = obj965;
  sourceObject = obj965;
  objclass965 = obj965->class;
  objclass965->definitionModule = modulename;
  objclass965->definitionLine = 39;
  (*(struct UserObject *)self).data[0] = lowerouter965;
  self = oldself965;
  selfslot = oldselfslot965;
  stackframe = oldstackframe965;
  gc_frame_end(frame);
  return obj965;
}
Object meth_ast_with977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method with");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for with (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe978 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe979 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call980 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe979);
// compiled call node returning call980 (depth = 5)
// compiled member node returning call980 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call981 = callmethod(call980, "extend",
    1, partcv, params);
  gc_frame_end(callframe978);
// compiled call node returning call981 (depth = 3)
  gc_frame_end(frame);
  return call981;
}
Object meth_ast_forebears985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forebears");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_as = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for forebears (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for forebears");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_as (depth = 3)
  gc_frame_end(frame);
  return *var_as;
}
Object meth_ast_isEmpty986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool987 = alloc_Boolean(0);
// compiled identifier node returning bool987 (depth = 3)
  gc_frame_end(frame);
  return bool987;
}
Object meth_ast_parent988(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_p (depth = 3)
  gc_frame_end(frame);
  return *var_p;
}
Object meth_ast_grandparent989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "grandparent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for grandparent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for grandparent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe990 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe991 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call992 = callmethodflags(self, "forebears", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe991);
// compiled call node returning call992 (depth = 6)
// compiled member node returning call992 (depth = 5)
  partcv[0] = 0;
  Object call993 = callmethod(call992, "parent",
    1, partcv, params);
  gc_frame_end(callframe990);
// compiled call node returning call993 (depth = 4)
// compiled member node returning call993 (depth = 3)
  gc_frame_end(frame);
  return call993;
}
Object meth_ast__apply998(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe999 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1000 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call1001 = callmethod(*var_a, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe1000);
// compiled call node returning call1001 (depth = 8)
// compiled member node returning call1001 (depth = 7)
  partcv[0] = 0;
  Object call1002 = callmethod(call1001, "not",
    1, partcv, params);
  gc_frame_end(callframe999);
// compiled call node returning call1002 (depth = 6)
// compiled member node returning call1002 (depth = 5)
  gc_frame_end(frame);
  return call1002;
}
Object meth_ast__apply1005(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1007 == NULL) {
    strlit1007 = alloc_String("""\xe2""""\x9e""""\xa4""");
    gc_root(strlit1007);
  }
// compiled string node returning strlit1007 (depth = 7)
  int op_slot_right_1006 = gc_frame_newslot(strlit1007);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  partcv[0] = 0;
  Object call1011 = callmethod(*var_a, "parent",
    1, partcv, params);
  gc_frame_end(callframe1010);
// compiled call node returning call1011 (depth = 9)
// compiled member node returning call1011 (depth = 8)
  int op_slot_right_1009 = gc_frame_newslot(call1011);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1009 = gc_frame_newslot(*var_s);
  params[0] = call1011;
  partcv[0] = 1;
  Object opresult1013 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 7)
  int op_slot_left_1006 = gc_frame_newslot(opresult1013);
  params[0] = strlit1007;
  partcv[0] = 1;
  Object opresult1014 = callmethod(opresult1013, "++", 1, partcv, params);
// compiled op node returning opresult1014 (depth = 6)
  *var_s = opresult1014;
  if (opresult1014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call1017 = callmethod(*var_a, "forebears",
    1, partcv, params);
  gc_frame_end(callframe1016);
// compiled call node returning call1017 (depth = 7)
// compiled member node returning call1017 (depth = 6)
  *var_a = call1017;
  if (call1017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString994(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  *var_a = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit995 == NULL) {
    strlit995 = alloc_String("ancestorChain ");
    gc_root(strlit995);
  }
// compiled string node returning strlit995 (depth = 4)
  *var_s = strlit995;
  if (strlit995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe996 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block997 = alloc_Block(NULL, NULL, "ast", 54);
  gc_frame_newslot(block997);
// method "_apply"
  block_savedest(block997);
  Object closure998 = createclosure(2, "_apply");
  setclosureframe(closure998, stackframe);
  addtoclosure(closure998, var_a);
  addtoclosure(closure998, selfslot);
  struct UserObject *uo998 = (struct UserObject*)block997;
  uo998->data[0] = (Object)closure998;
  Method *meth_meth_ast__apply998 = addmethod2pos(block997, "_apply", &meth_ast__apply998, 0);
  int argcv_meth_ast__apply998[] = {0};
  meth_meth_ast__apply998->type = alloc_MethodType(1, argcv_meth_ast__apply998);
  meth_meth_ast__apply998->definitionModule = modulename;
  meth_meth_ast__apply998->definitionLine = 49;
// compiled block node returning block997 (depth = 4)
  gc_frame_newslot(block997);
// starting to compile block node (depth = 4)
  Object block1004 = alloc_Block(NULL, NULL, "ast", 54);
  gc_frame_newslot(block1004);
// method "_apply"
  block_savedest(block1004);
  Object closure1005 = createclosure(3, "_apply");
  setclosureframe(closure1005, stackframe);
  addtoclosure(closure1005, var_a);
  addtoclosure(closure1005, var_s);
  addtoclosure(closure1005, selfslot);
  struct UserObject *uo1005 = (struct UserObject*)block1004;
  uo1005->data[0] = (Object)closure1005;
  Method *meth_meth_ast__apply1005 = addmethod2pos(block1004, "_apply", &meth_ast__apply1005, 0);
  int argcv_meth_ast__apply1005[] = {0};
  meth_meth_ast__apply1005->type = alloc_MethodType(1, argcv_meth_ast__apply1005);
  meth_meth_ast__apply1005->definitionModule = modulename;
  meth_meth_ast__apply1005->definitionLine = 54;
// compiled block node returning block1004 (depth = 4)
  gc_frame_newslot(block1004);
// call case 5: prelude request
  params[0] = block997;
  params[1] = block1004;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1020 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe996);
// compiled call node returning call1020 (depth = 3)
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1022 == NULL) {
    strlit1022 = alloc_String("""\xe2""""\x96""""\xab""");
    gc_root(strlit1022);
  }
// compiled string node returning strlit1022 (depth = 4)
  int op_slot_right_1021 = gc_frame_newslot(strlit1022);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_1021 = gc_frame_newslot(*var_s);
  params[0] = strlit1022;
  partcv[0] = 1;
  Object opresult1024 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1024 (depth = 3)
  gc_frame_end(frame);
  return opresult1024;
}
Object meth_ast_extend1025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1026 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1027 = gc_frame_new();
// call case 3: self.outer request
  Object call1028 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1027);
// compiled call node returning call1028 (depth = 5)
// compiled member node returning call1028 (depth = 4)
  params[0] = *var_n;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1029 = callmethodflags(call1028, "cons()onto", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1026);
// compiled call node returning call1029 (depth = 3)
  gc_frame_end(frame);
  return call1029;
}
Object meth_ast_cons_40__41_onto982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject983 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj983 = alloc_userobj2(6,7, objclass983);
  gc_frame_newslot(obj983);
if (objclass983 == NULL) {
  glfree(obj983->class->name);
  obj983->class->name = "ancestorChain.cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj983, self, 0);
  addmethodreal(obj983,"outer", &reader_ast_outer_984);
  Object oldself983 = self;
  struct StackFrameObject *oldstackframe983 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe983);
  gc_frame_newslot((Object)stackframe);
  self = obj983;
  Object *oldselfslot983 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter983 = (*(struct UserObject *)self).data[0], lowerouter983 = thisouter983;
  if (inheritingObject983) {
    struct UserObject *inho983 = (struct UserObject *)inheritingObject983;
    while (inho983->super != GraceDefaultObject) inho983 = (struct UserObject *)inho983->super;
    inho983->super = obj983;
    self = inheritingObject983;
    *selfslot = self;
    lowerouter983 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter983;
  }
// method "forebears"
  block_savedest(obj983);
  Object closure985 = createclosure(1, "forebears");
  setclosureframe(closure985, stackframe);
  addtoclosure(closure985, var_as);
  struct UserObject *uo985 = (struct UserObject*)obj983;
  uo985->data[1] = (Object)closure985;
  Method *meth_meth_ast_forebears985 = addmethod2pos(obj983, "forebears", &meth_ast_forebears985, 1);
  int argcv_meth_ast_forebears985[] = {0};
  meth_meth_ast_forebears985->type = alloc_MethodType(1, argcv_meth_ast_forebears985);
  meth_meth_ast_forebears985->definitionModule = modulename;
  meth_meth_ast_forebears985->definitionLine = 46;
// method "isEmpty"
  struct UserObject *uo986 = (struct UserObject*)obj983;
  uo986->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty986 = addmethod2pos(obj983, "isEmpty", &meth_ast_isEmpty986, 2);
  int argcv_meth_ast_isEmpty986[] = {0};
  meth_meth_ast_isEmpty986->type = alloc_MethodType(1, argcv_meth_ast_isEmpty986);
  meth_meth_ast_isEmpty986->definitionModule = modulename;
  meth_meth_ast_isEmpty986->definitionLine = 47;
// method "parent"
  block_savedest(obj983);
  Object closure988 = createclosure(1, "parent");
  setclosureframe(closure988, stackframe);
  addtoclosure(closure988, var_p);
  struct UserObject *uo988 = (struct UserObject*)obj983;
  uo988->data[3] = (Object)closure988;
  Method *meth_meth_ast_parent988 = addmethod2pos(obj983, "parent", &meth_ast_parent988, 3);
  int argcv_meth_ast_parent988[] = {0};
  meth_meth_ast_parent988->type = alloc_MethodType(1, argcv_meth_ast_parent988);
  meth_meth_ast_parent988->definitionModule = modulename;
  meth_meth_ast_parent988->definitionLine = 48;
// method "grandparent"
  struct UserObject *uo989 = (struct UserObject*)obj983;
  uo989->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent989 = addmethod2pos(obj983, "grandparent", &meth_ast_grandparent989, 4);
  int argcv_meth_ast_grandparent989[] = {0};
  meth_meth_ast_grandparent989->type = alloc_MethodType(1, argcv_meth_ast_grandparent989);
  meth_meth_ast_grandparent989->definitionModule = modulename;
  meth_meth_ast_grandparent989->definitionLine = 49;
// method "asString"
  struct UserObject *uo994 = (struct UserObject*)obj983;
  uo994->data[5] = emptyclosure;
  Method *meth_meth_ast_asString994 = addmethod2pos(obj983, "asString", &meth_ast_asString994, 5);
  int argcv_meth_ast_asString994[] = {0};
  meth_meth_ast_asString994->type = alloc_MethodType(1, argcv_meth_ast_asString994);
  meth_meth_ast_asString994->definitionModule = modulename;
  meth_meth_ast_asString994->definitionLine = 51;
// method "extend"
  struct UserObject *uo1025 = (struct UserObject*)obj983;
  uo1025->data[6] = emptyclosure;
  Method *meth_meth_ast_extend1025 = addmethod2pos(obj983, "extend", &meth_ast_extend1025, 6);
  int argcv_meth_ast_extend1025[] = {1};
  meth_meth_ast_extend1025->type = alloc_MethodType(1, argcv_meth_ast_extend1025);
  meth_meth_ast_extend1025->definitionModule = modulename;
  meth_meth_ast_extend1025->definitionLine = 60;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  objclass983 = obj983->class;
  objclass983->definitionModule = modulename;
  objclass983->definitionLine = 45;
  (*(struct UserObject *)self).data[0] = lowerouter983;
  self = oldself983;
  selfslot = oldselfslot983;
  stackframe = oldstackframe983;
  gc_frame_end(frame);
  return obj983;
}
Object meth_ast_cons_40__41_onto982_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cons()onto()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cons()onto()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for cons()onto (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for cons");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onto");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject983 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj983 = alloc_userobj2(6,7, objclass983);
  gc_frame_newslot(obj983);
if (objclass983 == NULL) {
  glfree(obj983->class->name);
  obj983->class->name = "ancestorChain.cons()onto";
}
// OBJECT OUTER DEC outer
  adddatum2(obj983, self, 0);
  addmethodreal(obj983,"outer", &reader_ast_outer_984);
  Object oldself983 = self;
  struct StackFrameObject *oldstackframe983 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe983);
  gc_frame_newslot((Object)stackframe);
  self = obj983;
  Object *oldselfslot983 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter983 = (*(struct UserObject *)self).data[0], lowerouter983 = thisouter983;
  if (inheritingObject983) {
    struct UserObject *inho983 = (struct UserObject *)inheritingObject983;
    while (inho983->super != GraceDefaultObject) inho983 = (struct UserObject *)inho983->super;
    inho983->super = obj983;
    self = inheritingObject983;
    *selfslot = self;
    lowerouter983 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter983;
  }
// method "forebears"
  block_savedest(obj983);
  Object closure985 = createclosure(1, "forebears");
  setclosureframe(closure985, stackframe);
  addtoclosure(closure985, var_as);
  struct UserObject *uo985 = (struct UserObject*)obj983;
  uo985->data[1] = (Object)closure985;
  Method *meth_meth_ast_forebears985 = addmethod2pos(obj983, "forebears", &meth_ast_forebears985, 1);
  int argcv_meth_ast_forebears985[] = {0};
  meth_meth_ast_forebears985->type = alloc_MethodType(1, argcv_meth_ast_forebears985);
  meth_meth_ast_forebears985->definitionModule = modulename;
  meth_meth_ast_forebears985->definitionLine = 46;
// method "isEmpty"
  struct UserObject *uo986 = (struct UserObject*)obj983;
  uo986->data[2] = emptyclosure;
  Method *meth_meth_ast_isEmpty986 = addmethod2pos(obj983, "isEmpty", &meth_ast_isEmpty986, 2);
  int argcv_meth_ast_isEmpty986[] = {0};
  meth_meth_ast_isEmpty986->type = alloc_MethodType(1, argcv_meth_ast_isEmpty986);
  meth_meth_ast_isEmpty986->definitionModule = modulename;
  meth_meth_ast_isEmpty986->definitionLine = 47;
// method "parent"
  block_savedest(obj983);
  Object closure988 = createclosure(1, "parent");
  setclosureframe(closure988, stackframe);
  addtoclosure(closure988, var_p);
  struct UserObject *uo988 = (struct UserObject*)obj983;
  uo988->data[3] = (Object)closure988;
  Method *meth_meth_ast_parent988 = addmethod2pos(obj983, "parent", &meth_ast_parent988, 3);
  int argcv_meth_ast_parent988[] = {0};
  meth_meth_ast_parent988->type = alloc_MethodType(1, argcv_meth_ast_parent988);
  meth_meth_ast_parent988->definitionModule = modulename;
  meth_meth_ast_parent988->definitionLine = 48;
// method "grandparent"
  struct UserObject *uo989 = (struct UserObject*)obj983;
  uo989->data[4] = emptyclosure;
  Method *meth_meth_ast_grandparent989 = addmethod2pos(obj983, "grandparent", &meth_ast_grandparent989, 4);
  int argcv_meth_ast_grandparent989[] = {0};
  meth_meth_ast_grandparent989->type = alloc_MethodType(1, argcv_meth_ast_grandparent989);
  meth_meth_ast_grandparent989->definitionModule = modulename;
  meth_meth_ast_grandparent989->definitionLine = 49;
// method "asString"
  struct UserObject *uo994 = (struct UserObject*)obj983;
  uo994->data[5] = emptyclosure;
  Method *meth_meth_ast_asString994 = addmethod2pos(obj983, "asString", &meth_ast_asString994, 5);
  int argcv_meth_ast_asString994[] = {0};
  meth_meth_ast_asString994->type = alloc_MethodType(1, argcv_meth_ast_asString994);
  meth_meth_ast_asString994->definitionModule = modulename;
  meth_meth_ast_asString994->definitionLine = 51;
// method "extend"
  struct UserObject *uo1025 = (struct UserObject*)obj983;
  uo1025->data[6] = emptyclosure;
  Method *meth_meth_ast_extend1025 = addmethod2pos(obj983, "extend", &meth_ast_extend1025, 6);
  int argcv_meth_ast_extend1025[] = {1};
  meth_meth_ast_extend1025->type = alloc_MethodType(1, argcv_meth_ast_extend1025);
  meth_meth_ast_extend1025->definitionModule = modulename;
  meth_meth_ast_extend1025->definitionLine = 60;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  sourceObject = obj983;
  objclass983 = obj983->class;
  objclass983->definitionModule = modulename;
  objclass983->definitionLine = 45;
  (*(struct UserObject *)self).data[0] = lowerouter983;
  self = oldself983;
  selfslot = oldselfslot983;
  stackframe = oldstackframe983;
  gc_frame_end(frame);
  return obj983;
}
Object meth_ast_ancestorChain1031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ancestorChain");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ancestorChain = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ancestorChain (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ancestorChain");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ancestorChain (depth = 3)
  gc_frame_end(frame);
  return *var_ancestorChain;
}
Object meth_ast_emptySeq1034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for emptySeq (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for emptySeq");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode1037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for AstNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for AstNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_SymbolTable1039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for SymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for SymbolTable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_SymbolTable;
}
Object meth_ast_toGrace1043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1044 == NULL) {
    strlit1044 = alloc_String("// null");
    gc_root(strlit1044);
  }
// compiled string node returning strlit1044 (depth = 3)
  gc_frame_end(frame);
  return strlit1044;
}
Object meth_ast_asString1045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1046 == NULL) {
    strlit1046 = alloc_String("the nullNode");
    gc_root(strlit1046);
  }
// compiled string node returning strlit1046 (depth = 3)
  gc_frame_end(frame);
  return strlit1046;
}
Object meth_ast__61__61_1047(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1048 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1049 = callmethodflags(self, "isMe", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1048);
// compiled call node returning call1049 (depth = 3)
  gc_frame_end(frame);
  return call1049;
}
Object meth_ast_nullNode1055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nullNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nullNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_asString1059(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1060 == NULL) {
    strlit1060 = alloc_String("the fakeSymbolTable");
    gc_root(strlit1060);
  }
// compiled string node returning strlit1060 (depth = 3)
  gc_frame_end(frame);
  return strlit1060;
}
Object meth_ast_addNode_40__41_as1061(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addNode()as");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode()as");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addNode()as");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addNode()as (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addNode");
  Object *var_kind = &(stackframe->slots[1]);
  *var_kind = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for as");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1062 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1064 == NULL) {
    strlit1064 = alloc_String("""\x22"" requested");
    gc_root(strlit1064);
  }
// compiled string node returning strlit1064 (depth = 5)
  int op_slot_right_1063 = gc_frame_newslot(strlit1064);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_kind (depth = 6)
  int op_slot_right_1066 = gc_frame_newslot(*var_kind);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1069 == NULL) {
    strlit1069 = alloc_String(") as ""\x22""");
    gc_root(strlit1069);
  }
// compiled string node returning strlit1069 (depth = 7)
  int op_slot_right_1068 = gc_frame_newslot(strlit1069);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1071 = gc_frame_newslot(*var_n);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1074 == NULL) {
    strlit1074 = alloc_String(").addNode(");
    gc_root(strlit1074);
  }
// compiled string node returning strlit1074 (depth = 9)
  int op_slot_right_1073 = gc_frame_newslot(strlit1074);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1078 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1077);
// compiled call node returning call1078 (depth = 11)
// compiled member node returning call1078 (depth = 10)
  int op_slot_right_1076 = gc_frame_newslot(call1078);
// starting to compile string node (depth = 10)
  if (strlit1080 == NULL) {
    strlit1080 = alloc_String("fakeSymbolTable(on node ");
    gc_root(strlit1080);
  }
// compiled string node returning strlit1080 (depth = 10)
  int op_slot_left_1076 = gc_frame_newslot(strlit1080);
  params[0] = call1078;
  partcv[0] = 1;
  Object opresult1081 = callmethod(strlit1080, "++", 1, partcv, params);
// compiled op node returning opresult1081 (depth = 9)
  int op_slot_left_1073 = gc_frame_newslot(opresult1081);
  params[0] = strlit1074;
  partcv[0] = 1;
  Object opresult1082 = callmethod(opresult1081, "++", 1, partcv, params);
// compiled op node returning opresult1082 (depth = 8)
  int op_slot_left_1071 = gc_frame_newslot(opresult1082);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1083 = callmethod(opresult1082, "++", 1, partcv, params);
// compiled op node returning opresult1083 (depth = 7)
  int op_slot_left_1068 = gc_frame_newslot(opresult1083);
  params[0] = strlit1069;
  partcv[0] = 1;
  Object opresult1084 = callmethod(opresult1083, "++", 1, partcv, params);
// compiled op node returning opresult1084 (depth = 6)
  int op_slot_left_1066 = gc_frame_newslot(opresult1084);
  params[0] = *var_kind;
  partcv[0] = 1;
  Object opresult1085 = callmethod(opresult1084, "++", 1, partcv, params);
// compiled op node returning opresult1085 (depth = 5)
  int op_slot_left_1063 = gc_frame_newslot(opresult1085);
  params[0] = strlit1064;
  partcv[0] = 1;
  Object opresult1086 = callmethod(opresult1085, "++", 1, partcv, params);
// compiled op node returning opresult1086 (depth = 4)
  gc_frame_newslot(opresult1086);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1087 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1088 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compiled call node returning call1088 (depth = 5)
// compiled member node returning call1088 (depth = 4)
  params[0] = opresult1086;
  partcv[0] = 1;
  Object call1089 = callmethod(call1088, "raise",
    1, partcv, params);
  gc_frame_end(callframe1062);
// compiled call node returning call1089 (depth = 3)
  gc_frame_end(frame);
  return call1089;
}
Object meth_ast_thatDefines_40__41_ifNone1090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "thatDefines()ifNone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines()ifNone");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method thatDefines()ifNone");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for thatDefines()ifNone (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for thatDefines");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifNone");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1091 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1093 == NULL) {
    strlit1093 = alloc_String(").");
    gc_root(strlit1093);
  }
// compiled string node returning strlit1093 (depth = 5)
  int op_slot_right_1092 = gc_frame_newslot(strlit1093);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_name (depth = 6)
  int op_slot_right_1095 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 6)
  if (strlit1097 == NULL) {
    strlit1097 = alloc_String("fakeSymbolTable.thatDefines(");
    gc_root(strlit1097);
  }
// compiled string node returning strlit1097 (depth = 6)
  int op_slot_left_1095 = gc_frame_newslot(strlit1097);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult1098 = callmethod(strlit1097, "++", 1, partcv, params);
// compiled op node returning opresult1098 (depth = 5)
  int op_slot_left_1092 = gc_frame_newslot(opresult1098);
  params[0] = strlit1093;
  partcv[0] = 1;
  Object opresult1099 = callmethod(opresult1098, "++", 1, partcv, params);
// compiled op node returning opresult1099 (depth = 4)
  gc_frame_newslot(opresult1099);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1100 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1101 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled call node returning call1101 (depth = 5)
// compiled member node returning call1101 (depth = 4)
  params[0] = opresult1099;
  partcv[0] = 1;
  Object call1102 = callmethod(call1101, "raise",
    1, partcv, params);
  gc_frame_end(callframe1091);
// compiled call node returning call1102 (depth = 3)
  gc_frame_end(frame);
  return call1102;
}
Object meth_ast_enclosingObjectScope1103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "enclosingObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for enclosingObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for enclosingObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1104 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1106 == NULL) {
    strlit1106 = alloc_String("");
    gc_root(strlit1106);
  }
// compiled string node returning strlit1106 (depth = 5)
  int op_slot_right_1105 = gc_frame_newslot(strlit1106);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1110 = callmethodflags(self, "node", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1109);
// compiled call node returning call1110 (depth = 7)
// compiled member node returning call1110 (depth = 6)
  int op_slot_right_1108 = gc_frame_newslot(call1110);
// starting to compile string node (depth = 6)
  if (strlit1112 == NULL) {
    strlit1112 = alloc_String("fakeSymbolTable.enclosingObjectScope on node ");
    gc_root(strlit1112);
  }
// compiled string node returning strlit1112 (depth = 6)
  int op_slot_left_1108 = gc_frame_newslot(strlit1112);
  params[0] = call1110;
  partcv[0] = 1;
  Object opresult1113 = callmethod(strlit1112, "++", 1, partcv, params);
// compiled op node returning opresult1113 (depth = 5)
  int op_slot_left_1105 = gc_frame_newslot(opresult1113);
  params[0] = strlit1106;
  partcv[0] = 1;
  Object opresult1114 = callmethod(opresult1113, "++", 1, partcv, params);
// compiled op node returning opresult1114 (depth = 4)
  gc_frame_newslot(opresult1114);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1115 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1116 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1115);
// compiled call node returning call1116 (depth = 5)
// compiled member node returning call1116 (depth = 4)
  params[0] = opresult1114;
  partcv[0] = 1;
  Object call1117 = callmethod(call1116, "raise",
    1, partcv, params);
  gc_frame_end(callframe1104);
// compiled call node returning call1117 (depth = 3)
  gc_frame_end(frame);
  return call1117;
}
Object meth_ast_variety1118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "variety");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for variety (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for variety");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1119 == NULL) {
    strlit1119 = alloc_String("fake");
    gc_root(strlit1119);
  }
// compiled string node returning strlit1119 (depth = 3)
  gc_frame_end(frame);
  return strlit1119;
}
Object meth_ast__61__61_1120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1121 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1122 = callmethodflags(self, "isMe", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1121);
// compiled call node returning call1122 (depth = 3)
  gc_frame_end(frame);
  return call1122;
}
Object meth_ast_fakeSymbolTable1123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fakeSymbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fakeSymbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for fakeSymbolTable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_fakeSymbolTable (depth = 3)
  gc_frame_end(frame);
  return *var_fakeSymbolTable;
}
Object meth_ast_isSimple1134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1135 = alloc_Boolean(0);
// compiled identifier node returning bool1135 (depth = 3)
  gc_frame_end(frame);
  return bool1135;
}
Object meth_ast_accept_40__41_from1136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1138 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1139 = callmethod(*var_visitor, "visitIf()up",
    2, partcv, params);
  gc_frame_end(callframe1138);
// compiled call node returning call1139 (depth = 4)
  Object if1137 = done;
  if (istrue(call1139)) {
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1140 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1141 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1140);
// compiled call node returning call1141 (depth = 5)
  *var_newChain = call1141;
  if (call1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1142 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1143 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1144 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled call node returning call1144 (depth = 6)
// compiled member node returning call1144 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1145 = callmethod(call1144, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1142);
// compiled call node returning call1145 (depth = 4)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1146 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1148 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1147);
// compiled call node returning call1148 (depth = 6)
// compiled member node returning call1148 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1149 = callmethod(call1148, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1146);
// compiled call node returning call1149 (depth = 4)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1150 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1151 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1152 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1151);
// compiled call node returning call1152 (depth = 6)
// compiled member node returning call1152 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1153 = callmethod(call1152, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1150);
// compiled call node returning call1153 (depth = 4)
    gc_frame_newslot(call1153);
    if1137 = call1153;
  } else {
  }
// compiled if node returning if1137 (depth = 3)
  gc_frame_end(frame);
  return if1137;
}
Object meth_ast_map_40__41_ancestors1154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1155 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1156 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1155);
// compiled call node returning call1156 (depth = 5)
// compiled member node returning call1156 (depth = 4)
  *var_n = call1156;
  if (call1156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1157 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1158 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 4)
  *var_newChain = call1158;
  if (call1158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1159 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1160 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1162 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1161);
// compiled call node returning call1162 (depth = 6)
// compiled member node returning call1162 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1163 = callmethod(call1162, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1160);
// compiled call node returning call1163 (depth = 4)
  gc_frame_newslot(call1163);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1163;
  partcv[0] = 1;
  Object call1164 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1159);
// compiled call node returning call1164 (depth = 3)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1165 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1166 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1168 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1167);
// compiled call node returning call1168 (depth = 6)
// compiled member node returning call1168 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1169 = callmethod(call1168, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1166);
// compiled call node returning call1169 (depth = 4)
  gc_frame_newslot(call1169);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1169;
  partcv[0] = 1;
  Object call1170 = callmethod(*var_n, "thenblock:=",
    1, partcv, params);
  gc_frame_end(callframe1165);
// compiled call node returning call1170 (depth = 3)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1171 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1172 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1174 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled call node returning call1174 (depth = 6)
// compiled member node returning call1174 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1175 = callmethod(call1174, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1172);
// compiled call node returning call1175 (depth = 4)
  gc_frame_newslot(call1175);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1175;
  partcv[0] = 1;
  Object call1176 = callmethod(*var_n, "elseblock:=",
    1, partcv, params);
  gc_frame_end(callframe1171);
// compiled call node returning call1176 (depth = 3)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1177 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1178 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1177);
// compiled call node returning call1178 (depth = 3)
  gc_frame_end(frame);
  return call1178;
}
Object meth_ast__apply1187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1189 == NULL) {
    strlit1189 = alloc_String("  ");
    gc_root(strlit1189);
  }
// compiled string node returning strlit1189 (depth = 7)
  int op_slot_right_1188 = gc_frame_newslot(strlit1189);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1188 = gc_frame_newslot(*var_spc);
  params[0] = strlit1189;
  partcv[0] = 1;
  Object opresult1191 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1191 (depth = 6)
  *var_spc = opresult1191;
  if (opresult1191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1288(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1290 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1292 = alloc_Float64(2);
// compiled num node returning num1292 (depth = 10)
  int op_slot_right_1291 = gc_frame_newslot(num1292);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1291 = gc_frame_newslot(*var_depth);
  params[0] = num1292;
  partcv[0] = 1;
  Object sum1294 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1294 (depth = 9)
  gc_frame_newslot(sum1294);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1294;
  partcv[0] = 1;
  Object call1295 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1290);
// compiled call node returning call1295 (depth = 8)
  int op_slot_right_1289 = gc_frame_newslot(call1295);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1297 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1300 == NULL) {
    strlit1300 = alloc_String("""\x0a""  ");
    gc_root(strlit1300);
  }
// compiled string node returning strlit1300 (depth = 10)
  int op_slot_right_1299 = gc_frame_newslot(strlit1300);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1299 = gc_frame_newslot(*var_s);
  params[0] = strlit1300;
  partcv[0] = 1;
  Object opresult1302 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1302 (depth = 9)
  int op_slot_left_1297 = gc_frame_newslot(opresult1302);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1303 = callmethod(opresult1302, "++", 1, partcv, params);
// compiled op node returning opresult1303 (depth = 8)
  int op_slot_left_1289 = gc_frame_newslot(opresult1303);
  params[0] = call1295;
  partcv[0] = 1;
  Object opresult1304 = callmethod(opresult1303, "++", 1, partcv, params);
// compiled op node returning opresult1304 (depth = 7)
  *var_s = opresult1304;
  if (opresult1304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1329 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1331 = alloc_Float64(2);
// compiled num node returning num1331 (depth = 10)
  int op_slot_right_1330 = gc_frame_newslot(num1331);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1330 = gc_frame_newslot(*var_depth);
  params[0] = num1331;
  partcv[0] = 1;
  Object sum1333 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1333 (depth = 9)
  gc_frame_newslot(sum1333);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1333;
  partcv[0] = 1;
  Object call1334 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1329);
// compiled call node returning call1334 (depth = 8)
  int op_slot_right_1328 = gc_frame_newslot(call1334);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1336 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1339 == NULL) {
    strlit1339 = alloc_String("""\x0a""  ");
    gc_root(strlit1339);
  }
// compiled string node returning strlit1339 (depth = 10)
  int op_slot_right_1338 = gc_frame_newslot(strlit1339);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1338 = gc_frame_newslot(*var_s);
  params[0] = strlit1339;
  partcv[0] = 1;
  Object opresult1341 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1341 (depth = 9)
  int op_slot_left_1336 = gc_frame_newslot(opresult1341);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1342 = callmethod(opresult1341, "++", 1, partcv, params);
// compiled op node returning opresult1342 (depth = 8)
  int op_slot_left_1328 = gc_frame_newslot(opresult1342);
  params[0] = call1334;
  partcv[0] = 1;
  Object opresult1343 = callmethod(opresult1342, "++", 1, partcv, params);
// compiled op node returning opresult1343 (depth = 7)
  *var_s = opresult1343;
  if (opresult1343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1180 == NULL) {
    strlit1180 = alloc_String("");
    gc_root(strlit1180);
  }
// compiled string node returning strlit1180 (depth = 4)
  *var_spc = strlit1180;
  if (strlit1180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1181 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1182 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1184 = alloc_Float64(0);
// compiled num node returning num1184 (depth = 5)
  int op_slot_left_1182 = gc_frame_newslot(num1184);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1185 = callmethod(num1184, "..", 1, partcv, params);
// compiled op node returning opresult1185 (depth = 4)
  gc_frame_newslot(opresult1185);
// starting to compile block node (depth = 4)
  Object block1186 = alloc_Block(NULL, NULL, "ast", 241);
  gc_frame_newslot(block1186);
// method "_apply"
  block_savedest(block1186);
  Object closure1187 = createclosure(2, "_apply");
  setclosureframe(closure1187, stackframe);
  addtoclosure(closure1187, var_spc);
  addtoclosure(closure1187, selfslot);
  struct UserObject *uo1187 = (struct UserObject*)block1186;
  uo1187->data[0] = (Object)closure1187;
  Method *meth_meth_ast__apply1187 = addmethod2pos(block1186, "_apply", &meth_ast__apply1187, 0);
  int argcv_meth_ast__apply1187[] = {1};
  meth_meth_ast__apply1187->type = alloc_MethodType(1, argcv_meth_ast__apply1187);
  meth_meth_ast__apply1187->definitionModule = modulename;
  meth_meth_ast__apply1187->definitionLine = 236;
// compiled block node returning block1186 (depth = 4)
  gc_frame_newslot(block1186);
// call case 5: prelude request
  params[0] = opresult1185;
  params[1] = block1186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1194 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1181);
// compiled call node returning call1194 (depth = 3)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1196 == NULL) {
    strlit1196 = alloc_String("""\x0a""");
    gc_root(strlit1196);
  }
// compiled string node returning strlit1196 (depth = 5)
  int op_slot_right_1195 = gc_frame_newslot(strlit1196);
// starting to compile call node (depth = 5)
  int callframe1198 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1199 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1198);
// compiled call node returning call1199 (depth = 5)
  int op_slot_left_1195 = gc_frame_newslot(call1199);
  params[0] = strlit1196;
  partcv[0] = 1;
  Object opresult1200 = callmethod(call1199, "++", 1, partcv, params);
// compiled op node returning opresult1200 (depth = 4)
  *var_s = opresult1200;
  if (opresult1200 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1202 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1204 = alloc_Float64(1);
// compiled num node returning num1204 (depth = 7)
  int op_slot_right_1203 = gc_frame_newslot(num1204);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1203 = gc_frame_newslot(*var_depth);
  params[0] = num1204;
  partcv[0] = 1;
  Object sum1206 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1206 (depth = 6)
  gc_frame_newslot(sum1206);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1208 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1207);
// compiled call node returning call1208 (depth = 7)
// compiled member node returning call1208 (depth = 6)
  params[0] = sum1206;
  partcv[0] = 1;
  Object call1209 = callmethod(call1208, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1202);
// compiled call node returning call1209 (depth = 5)
  int op_slot_right_1201 = gc_frame_newslot(call1209);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1211 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1211 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1213 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1213 (depth = 5)
  int op_slot_left_1201 = gc_frame_newslot(opresult1213);
  params[0] = call1209;
  partcv[0] = 1;
  Object opresult1214 = callmethod(opresult1213, "++", 1, partcv, params);
// compiled op node returning opresult1214 (depth = 4)
  *var_s = opresult1214;
  if (opresult1214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1217 == NULL) {
    strlit1217 = alloc_String("""\x0a""");
    gc_root(strlit1217);
  }
// compiled string node returning strlit1217 (depth = 5)
  int op_slot_right_1216 = gc_frame_newslot(strlit1217);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1216 = gc_frame_newslot(*var_s);
  params[0] = strlit1217;
  partcv[0] = 1;
  Object opresult1219 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1219 (depth = 4)
  *var_s = opresult1219;
  if (opresult1219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1223 == NULL) {
    strlit1223 = alloc_String("symbols");
    gc_root(strlit1223);
  }
// compiled string node returning strlit1223 (depth = 5)
  int op_slot_right_1222 = gc_frame_newslot(strlit1223);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call1226 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe1225);
// compiled call node returning call1226 (depth = 6)
// compiled member node returning call1226 (depth = 5)
  int op_slot_left_1222 = gc_frame_newslot(call1226);
  params[0] = strlit1223;
  partcv[0] = 1;
  Object opresult1227 = callmethod(call1226, "==", 1, partcv, params);
// compiled op node returning opresult1227 (depth = 4)
  Object if1221 = done;
  if (istrue(opresult1227)) {
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1230 == NULL) {
    strlit1230 = alloc_String("""\x0a""");
    gc_root(strlit1230);
  }
// compiled string node returning strlit1230 (depth = 7)
  int op_slot_right_1229 = gc_frame_newslot(strlit1230);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1233 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1235 = alloc_Float64(2);
// compiled num node returning num1235 (depth = 10)
  int op_slot_right_1234 = gc_frame_newslot(num1235);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1234 = gc_frame_newslot(*var_depth);
  params[0] = num1235;
  partcv[0] = 1;
  Object sum1237 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1237 (depth = 9)
  gc_frame_newslot(sum1237);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1239 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compiled call node returning call1239 (depth = 10)
// compiled member node returning call1239 (depth = 9)
  params[0] = sum1237;
  partcv[0] = 1;
  Object call1240 = callmethod(call1239, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1233);
// compiled call node returning call1240 (depth = 8)
  int op_slot_right_1232 = gc_frame_newslot(call1240);
// starting to compile string node (depth = 8)
  if (strlit1242 == NULL) {
    strlit1242 = alloc_String("Then: ");
    gc_root(strlit1242);
  }
// compiled string node returning strlit1242 (depth = 8)
  int op_slot_left_1232 = gc_frame_newslot(strlit1242);
  params[0] = call1240;
  partcv[0] = 1;
  Object opresult1243 = callmethod(strlit1242, "++", 1, partcv, params);
// compiled op node returning opresult1243 (depth = 7)
  int op_slot_left_1229 = gc_frame_newslot(opresult1243);
  params[0] = strlit1230;
  partcv[0] = 1;
  Object opresult1244 = callmethod(opresult1243, "++", 1, partcv, params);
// compiled op node returning opresult1244 (depth = 6)
  int op_slot_right_1228 = gc_frame_newslot(opresult1244);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1246 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1246 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1248 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1248 (depth = 6)
  int op_slot_left_1228 = gc_frame_newslot(opresult1248);
  params[0] = opresult1244;
  partcv[0] = 1;
  Object opresult1249 = callmethod(opresult1248, "++", 1, partcv, params);
// compiled op node returning opresult1249 (depth = 5)
  *var_s = opresult1249;
  if (opresult1249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1253 == NULL) {
    strlit1253 = alloc_String("");
    gc_root(strlit1253);
  }
// compiled string node returning strlit1253 (depth = 7)
  int op_slot_right_1252 = gc_frame_newslot(strlit1253);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1256 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1258 = alloc_Float64(2);
// compiled num node returning num1258 (depth = 10)
  int op_slot_right_1257 = gc_frame_newslot(num1258);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1257 = gc_frame_newslot(*var_depth);
  params[0] = num1258;
  partcv[0] = 1;
  Object sum1260 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1260 (depth = 9)
  gc_frame_newslot(sum1260);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1262 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compiled call node returning call1262 (depth = 10)
// compiled member node returning call1262 (depth = 9)
  params[0] = sum1260;
  partcv[0] = 1;
  Object call1263 = callmethod(call1262, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1256);
// compiled call node returning call1263 (depth = 8)
  int op_slot_right_1255 = gc_frame_newslot(call1263);
// starting to compile string node (depth = 8)
  if (strlit1265 == NULL) {
    strlit1265 = alloc_String("Else: ");
    gc_root(strlit1265);
  }
// compiled string node returning strlit1265 (depth = 8)
  int op_slot_left_1255 = gc_frame_newslot(strlit1265);
  params[0] = call1263;
  partcv[0] = 1;
  Object opresult1266 = callmethod(strlit1265, "++", 1, partcv, params);
// compiled op node returning opresult1266 (depth = 7)
  int op_slot_left_1252 = gc_frame_newslot(opresult1266);
  params[0] = strlit1253;
  partcv[0] = 1;
  Object opresult1267 = callmethod(opresult1266, "++", 1, partcv, params);
// compiled op node returning opresult1267 (depth = 6)
  int op_slot_right_1251 = gc_frame_newslot(opresult1267);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1269 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1269 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1271 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1271 (depth = 6)
  int op_slot_left_1251 = gc_frame_newslot(opresult1271);
  params[0] = opresult1267;
  partcv[0] = 1;
  Object opresult1272 = callmethod(opresult1271, "++", 1, partcv, params);
// compiled op node returning opresult1272 (depth = 5)
  *var_s = opresult1272;
  if (opresult1272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1221 = done;
  } else {
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1275 == NULL) {
    strlit1275 = alloc_String("Then:");
    gc_root(strlit1275);
  }
// compiled string node returning strlit1275 (depth = 6)
  int op_slot_right_1274 = gc_frame_newslot(strlit1275);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1277 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1277 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1279 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1279 (depth = 6)
  int op_slot_left_1274 = gc_frame_newslot(opresult1279);
  params[0] = strlit1275;
  partcv[0] = 1;
  Object opresult1280 = callmethod(opresult1279, "++", 1, partcv, params);
// compiled op node returning opresult1280 (depth = 5)
  *var_s = opresult1280;
  if (opresult1280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1282 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1283 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1284 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1285 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1284);
// compiled call node returning call1285 (depth = 8)
// compiled member node returning call1285 (depth = 7)
  partcv[0] = 0;
  Object call1286 = callmethod(call1285, "body",
    1, partcv, params);
  gc_frame_end(callframe1283);
// compiled call node returning call1286 (depth = 6)
// compiled member node returning call1286 (depth = 5)
  gc_frame_newslot(call1286);
// starting to compile block node (depth = 5)
  Object block1287 = alloc_Block(NULL, NULL, "ast", 252);
  gc_frame_newslot(block1287);
// method "_apply"
  block_savedest(block1287);
  Object closure1288 = createclosure(4, "_apply");
  setclosureframe(closure1288, stackframe);
  addtoclosure(closure1288, var_depth);
  addtoclosure(closure1288, var_spc);
  addtoclosure(closure1288, var_s);
  addtoclosure(closure1288, selfslot);
  struct UserObject *uo1288 = (struct UserObject*)block1287;
  uo1288->data[0] = (Object)closure1288;
  Method *meth_meth_ast__apply1288 = addmethod2pos(block1287, "_apply", &meth_ast__apply1288, 0);
  int argcv_meth_ast__apply1288[] = {1};
  meth_meth_ast__apply1288->type = alloc_MethodType(1, argcv_meth_ast__apply1288);
  meth_meth_ast__apply1288->definitionModule = modulename;
  meth_meth_ast__apply1288->definitionLine = 252;
// compiled block node returning block1287 (depth = 5)
  gc_frame_newslot(block1287);
// call case 5: prelude request
  params[0] = call1286;
  params[1] = block1287;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1307 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1282);
// compiled call node returning call1307 (depth = 4)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1309 == NULL) {
    strlit1309 = alloc_String("""\x0a""");
    gc_root(strlit1309);
  }
// compiled string node returning strlit1309 (depth = 6)
  int op_slot_right_1308 = gc_frame_newslot(strlit1309);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1308 = gc_frame_newslot(*var_s);
  params[0] = strlit1309;
  partcv[0] = 1;
  Object opresult1311 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1311 (depth = 5)
  *var_s = opresult1311;
  if (opresult1311 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1314 == NULL) {
    strlit1314 = alloc_String("Else:");
    gc_root(strlit1314);
  }
// compiled string node returning strlit1314 (depth = 6)
  int op_slot_right_1313 = gc_frame_newslot(strlit1314);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1316 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1316 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1318 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1318 (depth = 6)
  int op_slot_left_1313 = gc_frame_newslot(opresult1318);
  params[0] = strlit1314;
  partcv[0] = 1;
  Object opresult1319 = callmethod(opresult1318, "++", 1, partcv, params);
// compiled op node returning opresult1319 (depth = 5)
  *var_s = opresult1319;
  if (opresult1319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1321 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1322 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1324 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1323);
// compiled call node returning call1324 (depth = 8)
// compiled member node returning call1324 (depth = 7)
  partcv[0] = 0;
  Object call1325 = callmethod(call1324, "body",
    1, partcv, params);
  gc_frame_end(callframe1322);
// compiled call node returning call1325 (depth = 6)
// compiled member node returning call1325 (depth = 5)
  gc_frame_newslot(call1325);
// starting to compile block node (depth = 5)
  Object block1326 = alloc_Block(NULL, NULL, "ast", 257);
  gc_frame_newslot(block1326);
// method "_apply"
  block_savedest(block1326);
  Object closure1327 = createclosure(4, "_apply");
  setclosureframe(closure1327, stackframe);
  addtoclosure(closure1327, var_depth);
  addtoclosure(closure1327, var_spc);
  addtoclosure(closure1327, var_s);
  addtoclosure(closure1327, selfslot);
  struct UserObject *uo1327 = (struct UserObject*)block1326;
  uo1327->data[0] = (Object)closure1327;
  Method *meth_meth_ast__apply1327 = addmethod2pos(block1326, "_apply", &meth_ast__apply1327, 0);
  int argcv_meth_ast__apply1327[] = {1};
  meth_meth_ast__apply1327->type = alloc_MethodType(1, argcv_meth_ast__apply1327);
  meth_meth_ast__apply1327->definitionModule = modulename;
  meth_meth_ast__apply1327->definitionLine = 257;
// compiled block node returning block1326 (depth = 5)
  gc_frame_newslot(block1326);
// call case 5: prelude request
  params[0] = call1325;
  params[1] = block1326;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1346 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1321);
// compiled call node returning call1346 (depth = 4)
    gc_frame_newslot(call1346);
    if1221 = call1346;
  }
// compiled if node returning if1221 (depth = 3)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1351(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1353 == NULL) {
    strlit1353 = alloc_String("    ");
    gc_root(strlit1353);
  }
// compiled string node returning strlit1353 (depth = 7)
  int op_slot_right_1352 = gc_frame_newslot(strlit1353);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1352 = gc_frame_newslot(*var_spc);
  params[0] = strlit1353;
  partcv[0] = 1;
  Object opresult1355 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1355 (depth = 6)
  *var_spc = opresult1355;
  if (opresult1355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1380 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1382 = alloc_Float64(1);
// compiled num node returning num1382 (depth = 9)
  int op_slot_right_1381 = gc_frame_newslot(num1382);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1381 = gc_frame_newslot(*var_depth);
  params[0] = num1382;
  partcv[0] = 1;
  Object sum1384 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1384 (depth = 8)
  gc_frame_newslot(sum1384);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  params[0] = sum1384;
  partcv[0] = 1;
  Object call1385 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1380);
// compiled call node returning call1385 (depth = 7)
  int op_slot_right_1379 = gc_frame_newslot(call1385);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1388 == NULL) {
    strlit1388 = alloc_String("    ");
    gc_root(strlit1388);
  }
// compiled string node returning strlit1388 (depth = 8)
  int op_slot_right_1387 = gc_frame_newslot(strlit1388);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1390 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1393 == NULL) {
    strlit1393 = alloc_String("""\x0a""");
    gc_root(strlit1393);
  }
// compiled string node returning strlit1393 (depth = 10)
  int op_slot_right_1392 = gc_frame_newslot(strlit1393);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1392 = gc_frame_newslot(*var_s);
  params[0] = strlit1393;
  partcv[0] = 1;
  Object opresult1395 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1395 (depth = 9)
  int op_slot_left_1390 = gc_frame_newslot(opresult1395);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1396 = callmethod(opresult1395, "++", 1, partcv, params);
// compiled op node returning opresult1396 (depth = 8)
  int op_slot_left_1387 = gc_frame_newslot(opresult1396);
  params[0] = strlit1388;
  partcv[0] = 1;
  Object opresult1397 = callmethod(opresult1396, "++", 1, partcv, params);
// compiled op node returning opresult1397 (depth = 7)
  int op_slot_left_1379 = gc_frame_newslot(opresult1397);
  params[0] = call1385;
  partcv[0] = 1;
  Object opresult1398 = callmethod(opresult1397, "++", 1, partcv, params);
// compiled op node returning opresult1398 (depth = 6)
  *var_s = opresult1398;
  if (opresult1398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1425(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1427 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1429 = alloc_Float64(1);
// compiled num node returning num1429 (depth = 10)
  int op_slot_right_1428 = gc_frame_newslot(num1429);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1428 = gc_frame_newslot(*var_depth);
  params[0] = num1429;
  partcv[0] = 1;
  Object sum1431 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1431 (depth = 9)
  gc_frame_newslot(sum1431);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum1431;
  partcv[0] = 1;
  Object call1432 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1427);
// compiled call node returning call1432 (depth = 8)
  int op_slot_right_1426 = gc_frame_newslot(call1432);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("    ");
    gc_root(strlit1435);
  }
// compiled string node returning strlit1435 (depth = 9)
  int op_slot_right_1434 = gc_frame_newslot(strlit1435);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1437 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1440 == NULL) {
    strlit1440 = alloc_String("""\x0a""");
    gc_root(strlit1440);
  }
// compiled string node returning strlit1440 (depth = 11)
  int op_slot_right_1439 = gc_frame_newslot(strlit1440);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1439 = gc_frame_newslot(*var_s);
  params[0] = strlit1440;
  partcv[0] = 1;
  Object opresult1442 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1442 (depth = 10)
  int op_slot_left_1437 = gc_frame_newslot(opresult1442);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1443 = callmethod(opresult1442, "++", 1, partcv, params);
// compiled op node returning opresult1443 (depth = 9)
  int op_slot_left_1434 = gc_frame_newslot(opresult1443);
  params[0] = strlit1435;
  partcv[0] = 1;
  Object opresult1444 = callmethod(opresult1443, "++", 1, partcv, params);
// compiled op node returning opresult1444 (depth = 8)
  int op_slot_left_1426 = gc_frame_newslot(opresult1444);
  params[0] = call1432;
  partcv[0] = 1;
  Object opresult1445 = callmethod(opresult1444, "++", 1, partcv, params);
// compiled op node returning opresult1445 (depth = 7)
  *var_s = opresult1445;
  if (opresult1445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1348 == NULL) {
    strlit1348 = alloc_String("");
    gc_root(strlit1348);
  }
// compiled string node returning strlit1348 (depth = 4)
  *var_spc = strlit1348;
  if (strlit1348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1349 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block1350 = alloc_Block(NULL, NULL, "ast", 265);
  gc_frame_newslot(block1350);
// method "_apply"
  block_savedest(block1350);
  Object closure1351 = createclosure(2, "_apply");
  setclosureframe(closure1351, stackframe);
  addtoclosure(closure1351, var_spc);
  addtoclosure(closure1351, selfslot);
  struct UserObject *uo1351 = (struct UserObject*)block1350;
  uo1351->data[0] = (Object)closure1351;
  Method *meth_meth_ast__apply1351 = addmethod2pos(block1350, "_apply", &meth_ast__apply1351, 0);
  int argcv_meth_ast__apply1351[] = {0};
  meth_meth_ast__apply1351->type = alloc_MethodType(1, argcv_meth_ast__apply1351);
  meth_meth_ast__apply1351->definitionModule = modulename;
  meth_meth_ast__apply1351->definitionLine = 257;
// compiled block node returning block1350 (depth = 4)
  gc_frame_newslot(block1350);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block1350;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1358 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1349);
// compiled call node returning call1358 (depth = 3)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1360 == NULL) {
    strlit1360 = alloc_String(") then {");
    gc_root(strlit1360);
  }
// compiled string node returning strlit1360 (depth = 5)
  int op_slot_right_1359 = gc_frame_newslot(strlit1360);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1363 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num1364 = alloc_Float64(0);
// compiled num node returning num1364 (depth = 7)
  gc_frame_newslot(num1364);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1366 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1365);
// compiled call node returning call1366 (depth = 8)
// compiled member node returning call1366 (depth = 7)
  params[0] = num1364;
  partcv[0] = 1;
  Object call1367 = callmethod(call1366, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1363);
// compiled call node returning call1367 (depth = 6)
  int op_slot_right_1362 = gc_frame_newslot(call1367);
// starting to compile string node (depth = 6)
  if (strlit1369 == NULL) {
    strlit1369 = alloc_String("if (");
    gc_root(strlit1369);
  }
// compiled string node returning strlit1369 (depth = 6)
  int op_slot_left_1362 = gc_frame_newslot(strlit1369);
  params[0] = call1367;
  partcv[0] = 1;
  Object opresult1370 = callmethod(strlit1369, "++", 1, partcv, params);
// compiled op node returning opresult1370 (depth = 5)
  int op_slot_left_1359 = gc_frame_newslot(opresult1370);
  params[0] = strlit1360;
  partcv[0] = 1;
  Object opresult1371 = callmethod(opresult1370, "++", 1, partcv, params);
// compiled op node returning opresult1371 (depth = 4)
  *var_s = opresult1371;
  if (opresult1371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1372 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1374 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1375 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1374);
// compiled call node returning call1375 (depth = 7)
// compiled member node returning call1375 (depth = 6)
  partcv[0] = 0;
  Object call1376 = callmethod(call1375, "body",
    1, partcv, params);
  gc_frame_end(callframe1373);
// compiled call node returning call1376 (depth = 5)
// compiled member node returning call1376 (depth = 4)
  gc_frame_newslot(call1376);
// starting to compile block node (depth = 4)
  Object block1377 = alloc_Block(NULL, NULL, "ast", 269);
  gc_frame_newslot(block1377);
// method "_apply"
  block_savedest(block1377);
  Object closure1378 = createclosure(4, "_apply");
  setclosureframe(closure1378, stackframe);
  addtoclosure(closure1378, var_depth);
  addtoclosure(closure1378, var_spc);
  addtoclosure(closure1378, var_s);
  addtoclosure(closure1378, selfslot);
  struct UserObject *uo1378 = (struct UserObject*)block1377;
  uo1378->data[0] = (Object)closure1378;
  Method *meth_meth_ast__apply1378 = addmethod2pos(block1377, "_apply", &meth_ast__apply1378, 0);
  int argcv_meth_ast__apply1378[] = {1};
  meth_meth_ast__apply1378->type = alloc_MethodType(1, argcv_meth_ast__apply1378);
  meth_meth_ast__apply1378->definitionModule = modulename;
  meth_meth_ast__apply1378->definitionLine = 269;
// compiled block node returning block1377 (depth = 4)
  gc_frame_newslot(block1377);
// call case 5: prelude request
  params[0] = call1376;
  params[1] = block1377;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1401 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1372);
// compiled call node returning call1401 (depth = 3)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1403 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1405 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1404);
// compiled call node returning call1405 (depth = 7)
// compiled member node returning call1405 (depth = 6)
  partcv[0] = 0;
  Object call1406 = callmethod(call1405, "isntEmpty",
    1, partcv, params);
  gc_frame_end(callframe1403);
// compiled call node returning call1406 (depth = 5)
// compiled member node returning call1406 (depth = 4)
  Object if1402 = done;
  if (istrue(call1406)) {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1408 == NULL) {
    strlit1408 = alloc_String("} else {");
    gc_root(strlit1408);
  }
// compiled string node returning strlit1408 (depth = 6)
  int op_slot_right_1407 = gc_frame_newslot(strlit1408);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1410 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1413 == NULL) {
    strlit1413 = alloc_String("""\x0a""");
    gc_root(strlit1413);
  }
// compiled string node returning strlit1413 (depth = 8)
  int op_slot_right_1412 = gc_frame_newslot(strlit1413);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1412 = gc_frame_newslot(*var_s);
  params[0] = strlit1413;
  partcv[0] = 1;
  Object opresult1415 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1415 (depth = 7)
  int op_slot_left_1410 = gc_frame_newslot(opresult1415);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1416 = callmethod(opresult1415, "++", 1, partcv, params);
// compiled op node returning opresult1416 (depth = 6)
  int op_slot_left_1407 = gc_frame_newslot(opresult1416);
  params[0] = strlit1408;
  partcv[0] = 1;
  Object opresult1417 = callmethod(opresult1416, "++", 1, partcv, params);
// compiled op node returning opresult1417 (depth = 5)
  *var_s = opresult1417;
  if (opresult1417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1419 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1420 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1422 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1421);
// compiled call node returning call1422 (depth = 8)
// compiled member node returning call1422 (depth = 7)
  partcv[0] = 0;
  Object call1423 = callmethod(call1422, "body",
    1, partcv, params);
  gc_frame_end(callframe1420);
// compiled call node returning call1423 (depth = 6)
// compiled member node returning call1423 (depth = 5)
  gc_frame_newslot(call1423);
// starting to compile block node (depth = 5)
  Object block1424 = alloc_Block(NULL, NULL, "ast", 274);
  gc_frame_newslot(block1424);
// method "_apply"
  block_savedest(block1424);
  Object closure1425 = createclosure(4, "_apply");
  setclosureframe(closure1425, stackframe);
  addtoclosure(closure1425, var_depth);
  addtoclosure(closure1425, var_spc);
  addtoclosure(closure1425, var_s);
  addtoclosure(closure1425, selfslot);
  struct UserObject *uo1425 = (struct UserObject*)block1424;
  uo1425->data[0] = (Object)closure1425;
  Method *meth_meth_ast__apply1425 = addmethod2pos(block1424, "_apply", &meth_ast__apply1425, 0);
  int argcv_meth_ast__apply1425[] = {1};
  meth_meth_ast__apply1425->type = alloc_MethodType(1, argcv_meth_ast__apply1425);
  meth_meth_ast__apply1425->definitionModule = modulename;
  meth_meth_ast__apply1425->definitionLine = 274;
// compiled block node returning block1424 (depth = 5)
  gc_frame_newslot(block1424);
// call case 5: prelude request
  params[0] = call1423;
  params[1] = block1424;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1448 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1419);
// compiled call node returning call1448 (depth = 4)
    gc_frame_newslot(call1448);
    if1402 = call1448;
  } else {
  }
// compiled if node returning if1402 (depth = 3)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1450 == NULL) {
    strlit1450 = alloc_String("}");
    gc_root(strlit1450);
  }
// compiled string node returning strlit1450 (depth = 5)
  int op_slot_right_1449 = gc_frame_newslot(strlit1450);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1452 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String("""\x0a""");
    gc_root(strlit1455);
  }
// compiled string node returning strlit1455 (depth = 7)
  int op_slot_right_1454 = gc_frame_newslot(strlit1455);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1454 = gc_frame_newslot(*var_s);
  params[0] = strlit1455;
  partcv[0] = 1;
  Object opresult1457 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1457 (depth = 6)
  int op_slot_left_1452 = gc_frame_newslot(opresult1457);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1458 = callmethod(opresult1457, "++", 1, partcv, params);
// compiled op node returning opresult1458 (depth = 5)
  int op_slot_left_1449 = gc_frame_newslot(opresult1458);
  params[0] = strlit1450;
  partcv[0] = 1;
  Object opresult1459 = callmethod(opresult1458, "++", 1, partcv, params);
// compiled op node returning opresult1459 (depth = 4)
  *var_s = opresult1459;
  if (opresult1459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1462 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe1463 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ifNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1464 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1463);
// compiled call node returning call1464 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1465 = callmethod(call1464, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1462);
// compiled call node returning call1465 (depth = 3)
  gc_frame_end(frame);
  return call1465;
}
Object meth_ast_shallowCopyFieldsFrom1466(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1467 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1468 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1467);
// compiled call node returning call1468 (depth = 3)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1469 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1471 = callmethod(*var_other, "handledIdentifiers",
    1, partcv, params);
  gc_frame_end(callframe1470);
// compiled call node returning call1471 (depth = 5)
// compiled member node returning call1471 (depth = 4)
  gc_frame_newslot(call1471);
// call case 4: self request
  params[0] = call1471;
  partcv[0] = 1;
  Object call1472 = callmethodflags(self, "handledIdentifiers:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1469);
// compiled call node returning call1472 (depth = 3)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new1126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1127 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1127 = alloc_userobj2(16,13, objclass1127);
  gc_frame_newslot(obj1127);
if (objclass1127 == NULL) {
  glfree(obj1127->class->name);
  obj1127->class->name = "ifNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1127, self, 0);
  addmethodreal(obj1127,"outer", &reader_ast_outer_1128);
  Object oldself1127 = self;
  struct StackFrameObject *oldstackframe1127 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1127);
  gc_frame_newslot((Object)stackframe);
  self = obj1127;
  Object *oldselfslot1127 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1127 = (*(struct UserObject *)self).data[0], lowerouter1127 = thisouter1127;
  if (inheritingObject1127) {
    struct UserObject *inho1127 = (struct UserObject *)inheritingObject1127;
    while (inho1127->super != GraceDefaultObject) inho1127 = (struct UserObject *)inho1127->super;
    inho1127->super = obj1127;
    self = inheritingObject1127;
    *selfslot = self;
    lowerouter1127 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1127;
  }
if (objclass1127 == NULL) {
  Method *reader1129 = addmethodrealflags(obj1127, "kind",&reader_ast_kind_1129, MFLAG_DEF);
  reader1129->definitionModule = modulename;
  reader1129->definitionLine = 217;
}
adddatum2(obj1127, alloc_Undefined(), 1);
if (objclass1127 == NULL) {
  Method *reader1130 = addmethodrealflags(obj1127, "value",&reader_ast_value_1130, 0);
  Method *writer1130 = addmethodrealflags(obj1127, "value:=",&writer_ast_value_1130, 0);
  reader1130->definitionModule = modulename;
  writer1130->definitionModule = modulename;
  reader1130->definitionLine = 218;
  writer1130->definitionLine = 218;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 2);
if (objclass1127 == NULL) {
  Method *reader1131 = addmethodrealflags(obj1127, "thenblock",&reader_ast_thenblock_1131, 0);
  Method *writer1131 = addmethodrealflags(obj1127, "thenblock:=",&writer_ast_thenblock_1131, 0);
  reader1131->definitionModule = modulename;
  writer1131->definitionModule = modulename;
  reader1131->definitionLine = 219;
  writer1131->definitionLine = 219;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 3);
if (objclass1127 == NULL) {
  Method *reader1132 = addmethodrealflags(obj1127, "elseblock",&reader_ast_elseblock_1132, 0);
  Method *writer1132 = addmethodrealflags(obj1127, "elseblock:=",&writer_ast_elseblock_1132, 0);
  reader1132->definitionModule = modulename;
  writer1132->definitionModule = modulename;
  reader1132->definitionLine = 220;
  writer1132->definitionLine = 220;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 4);
if (objclass1127 == NULL) {
  Method *reader1133 = addmethodrealflags(obj1127, "handledIdentifiers",&reader_ast_handledIdentifiers_1133, 0);
  Method *writer1133 = addmethodrealflags(obj1127, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1133, 0);
  reader1133->definitionModule = modulename;
  writer1133->definitionModule = modulename;
  reader1133->definitionLine = 221;
  writer1133->definitionLine = 221;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1134 = (struct UserObject*)obj1127;
  uo1134->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1134 = addmethod2pos(obj1127, "isSimple", &meth_ast_isSimple1134, 6);
  int argcv_meth_ast_isSimple1134[] = {0};
  meth_meth_ast_isSimple1134->type = alloc_MethodType(1, argcv_meth_ast_isSimple1134);
  meth_meth_ast_isSimple1134->definitionModule = modulename;
  meth_meth_ast_isSimple1134->definitionLine = 222;
// method "accept()from"
  struct UserObject *uo1136 = (struct UserObject*)obj1127;
  uo1136->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1136 = addmethod2pos(obj1127, "accept()from", &meth_ast_accept_40__41_from1136, 7);
  int argcv_meth_ast_accept_40__41_from1136[] = {1, 1};
  meth_meth_ast_accept_40__41_from1136->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1136);
  meth_meth_ast_accept_40__41_from1136->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1136->definitionLine = 223;
// method "map()ancestors"
  struct UserObject *uo1154 = (struct UserObject*)obj1127;
  uo1154->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1154 = addmethod2pos(obj1127, "map()ancestors", &meth_ast_map_40__41_ancestors1154, 8);
  int argcv_meth_ast_map_40__41_ancestors1154[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1154->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1154);
  meth_meth_ast_map_40__41_ancestors1154->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1154->definitionLine = 231;
// method "pretty"
  block_savedest(obj1127);
  Object closure1179 = createclosure(1, "pretty");
  setclosureframe(closure1179, stackframe);
  addtoclosure(closure1179, var_util);
  struct UserObject *uo1179 = (struct UserObject*)obj1127;
  uo1179->data[9] = (Object)closure1179;
  Method *meth_meth_ast_pretty1179 = addmethod2pos(obj1127, "pretty", &meth_ast_pretty1179, 9);
  int argcv_meth_ast_pretty1179[] = {1};
  meth_meth_ast_pretty1179->type = alloc_MethodType(1, argcv_meth_ast_pretty1179);
  meth_meth_ast_pretty1179->definitionModule = modulename;
  meth_meth_ast_pretty1179->definitionLine = 239;
// method "toGrace"
  struct UserObject *uo1347 = (struct UserObject*)obj1127;
  uo1347->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1347 = addmethod2pos(obj1127, "toGrace", &meth_ast_toGrace1347, 10);
  int argcv_meth_ast_toGrace1347[] = {1};
  meth_meth_ast_toGrace1347->type = alloc_MethodType(1, argcv_meth_ast_toGrace1347);
meth_meth_ast_toGrace1347->type->types[0] = type_Number;
meth_meth_ast_toGrace1347->type->names[0] = "depth";
  meth_meth_ast_toGrace1347->definitionModule = modulename;
  meth_meth_ast_toGrace1347->definitionLine = 263;
// method "shallowCopy"
  block_savedest(obj1127);
  Object closure1461 = createclosure(2, "shallowCopy");
  setclosureframe(closure1461, stackframe);
  addtoclosure(closure1461, var_nullNode);
  addtoclosure(closure1461, var_ifNode);
  struct UserObject *uo1461 = (struct UserObject*)obj1127;
  uo1461->data[11] = (Object)closure1461;
  Method *meth_meth_ast_shallowCopy1461 = addmethod2pos(obj1127, "shallowCopy", &meth_ast_shallowCopy1461, 11);
  int argcv_meth_ast_shallowCopy1461[] = {0};
  meth_meth_ast_shallowCopy1461->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1461);
  meth_meth_ast_shallowCopy1461->definitionModule = modulename;
  meth_meth_ast_shallowCopy1461->definitionLine = 281;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1466 = (struct UserObject*)obj1127;
  uo1466->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1466 = addmethod2pos(obj1127, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1466, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1466[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1466->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1466);
  meth_meth_ast_shallowCopyFieldsFrom1466->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1466->definitionLine = 284;
  sourceObject = obj1127;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1473 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1474 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1475 = gc_frame_new();
// call case 3: self.outer request
  Object call1476 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1475);
// compiled call node returning call1476 (depth = 7)
// compiled member node returning call1476 (depth = 6)
  partcv[0] = 0;
  Object call1477 = callmethodflags(call1476, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled call node returning call1477 (depth = 5)
// compiled member node returning call1477 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1478 = callmethodflags(call1477, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1473);
// compiled call node returning call1478 (depth = 3)
  struct UserObject *obj1127_uo = (struct UserObject *)obj1127;
  obj1127_uo->super = call1478;
  sourceObject = obj1127;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("if");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 3)
  adddatum2(obj1127, strlit1479, 1);
  sourceObject = obj1127;
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1127, *var_cond, 2);
  sourceObject = obj1127;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1127, *var_thenblock_39_, 3);
  sourceObject = obj1127;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1127, *var_elseblock_39_, 4);
  sourceObject = obj1127;
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1480 = alloc_Boolean(0);
// compiled identifier node returning bool1480 (depth = 3)
  adddatum2(obj1127, bool1480, 5);
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  objclass1127 = obj1127->class;
  objclass1127->definitionModule = modulename;
  objclass1127->definitionLine = 215;
  (*(struct UserObject *)self).data[0] = lowerouter1127;
  self = oldself1127;
  selfslot = oldselfslot1127;
  stackframe = oldstackframe1127;
  gc_frame_end(frame);
  return obj1127;
}
Object meth_ast_new1126_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1127 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1127 = alloc_userobj2(16,13, objclass1127);
  gc_frame_newslot(obj1127);
if (objclass1127 == NULL) {
  glfree(obj1127->class->name);
  obj1127->class->name = "ifNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1127, self, 0);
  addmethodreal(obj1127,"outer", &reader_ast_outer_1128);
  Object oldself1127 = self;
  struct StackFrameObject *oldstackframe1127 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1127);
  gc_frame_newslot((Object)stackframe);
  self = obj1127;
  Object *oldselfslot1127 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1127 = (*(struct UserObject *)self).data[0], lowerouter1127 = thisouter1127;
  if (inheritingObject1127) {
    struct UserObject *inho1127 = (struct UserObject *)inheritingObject1127;
    while (inho1127->super != GraceDefaultObject) inho1127 = (struct UserObject *)inho1127->super;
    inho1127->super = obj1127;
    self = inheritingObject1127;
    *selfslot = self;
    lowerouter1127 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1127;
  }
if (objclass1127 == NULL) {
  Method *reader1129 = addmethodrealflags(obj1127, "kind",&reader_ast_kind_1129, MFLAG_DEF);
  reader1129->definitionModule = modulename;
  reader1129->definitionLine = 217;
}
adddatum2(obj1127, alloc_Undefined(), 1);
if (objclass1127 == NULL) {
  Method *reader1130 = addmethodrealflags(obj1127, "value",&reader_ast_value_1130, 0);
  Method *writer1130 = addmethodrealflags(obj1127, "value:=",&writer_ast_value_1130, 0);
  reader1130->definitionModule = modulename;
  writer1130->definitionModule = modulename;
  reader1130->definitionLine = 218;
  writer1130->definitionLine = 218;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 2);
if (objclass1127 == NULL) {
  Method *reader1131 = addmethodrealflags(obj1127, "thenblock",&reader_ast_thenblock_1131, 0);
  Method *writer1131 = addmethodrealflags(obj1127, "thenblock:=",&writer_ast_thenblock_1131, 0);
  reader1131->definitionModule = modulename;
  writer1131->definitionModule = modulename;
  reader1131->definitionLine = 219;
  writer1131->definitionLine = 219;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 3);
if (objclass1127 == NULL) {
  Method *reader1132 = addmethodrealflags(obj1127, "elseblock",&reader_ast_elseblock_1132, 0);
  Method *writer1132 = addmethodrealflags(obj1127, "elseblock:=",&writer_ast_elseblock_1132, 0);
  reader1132->definitionModule = modulename;
  writer1132->definitionModule = modulename;
  reader1132->definitionLine = 220;
  writer1132->definitionLine = 220;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 4);
if (objclass1127 == NULL) {
  Method *reader1133 = addmethodrealflags(obj1127, "handledIdentifiers",&reader_ast_handledIdentifiers_1133, 0);
  Method *writer1133 = addmethodrealflags(obj1127, "handledIdentifiers:=",&writer_ast_handledIdentifiers_1133, 0);
  reader1133->definitionModule = modulename;
  writer1133->definitionModule = modulename;
  reader1133->definitionLine = 221;
  writer1133->definitionLine = 221;
}
obj1127->flags |= OFLAG_MUTABLE;
adddatum2(obj1127, alloc_Undefined(), 5);
// method "isSimple"
  struct UserObject *uo1134 = (struct UserObject*)obj1127;
  uo1134->data[6] = emptyclosure;
  Method *meth_meth_ast_isSimple1134 = addmethod2pos(obj1127, "isSimple", &meth_ast_isSimple1134, 6);
  int argcv_meth_ast_isSimple1134[] = {0};
  meth_meth_ast_isSimple1134->type = alloc_MethodType(1, argcv_meth_ast_isSimple1134);
  meth_meth_ast_isSimple1134->definitionModule = modulename;
  meth_meth_ast_isSimple1134->definitionLine = 222;
// method "accept()from"
  struct UserObject *uo1136 = (struct UserObject*)obj1127;
  uo1136->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1136 = addmethod2pos(obj1127, "accept()from", &meth_ast_accept_40__41_from1136, 7);
  int argcv_meth_ast_accept_40__41_from1136[] = {1, 1};
  meth_meth_ast_accept_40__41_from1136->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1136);
  meth_meth_ast_accept_40__41_from1136->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1136->definitionLine = 223;
// method "map()ancestors"
  struct UserObject *uo1154 = (struct UserObject*)obj1127;
  uo1154->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1154 = addmethod2pos(obj1127, "map()ancestors", &meth_ast_map_40__41_ancestors1154, 8);
  int argcv_meth_ast_map_40__41_ancestors1154[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1154->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1154);
  meth_meth_ast_map_40__41_ancestors1154->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1154->definitionLine = 231;
// method "pretty"
  block_savedest(obj1127);
  Object closure1179 = createclosure(1, "pretty");
  setclosureframe(closure1179, stackframe);
  addtoclosure(closure1179, var_util);
  struct UserObject *uo1179 = (struct UserObject*)obj1127;
  uo1179->data[9] = (Object)closure1179;
  Method *meth_meth_ast_pretty1179 = addmethod2pos(obj1127, "pretty", &meth_ast_pretty1179, 9);
  int argcv_meth_ast_pretty1179[] = {1};
  meth_meth_ast_pretty1179->type = alloc_MethodType(1, argcv_meth_ast_pretty1179);
  meth_meth_ast_pretty1179->definitionModule = modulename;
  meth_meth_ast_pretty1179->definitionLine = 239;
// method "toGrace"
  struct UserObject *uo1347 = (struct UserObject*)obj1127;
  uo1347->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace1347 = addmethod2pos(obj1127, "toGrace", &meth_ast_toGrace1347, 10);
  int argcv_meth_ast_toGrace1347[] = {1};
  meth_meth_ast_toGrace1347->type = alloc_MethodType(1, argcv_meth_ast_toGrace1347);
meth_meth_ast_toGrace1347->type->types[0] = type_Number;
meth_meth_ast_toGrace1347->type->names[0] = "depth";
  meth_meth_ast_toGrace1347->definitionModule = modulename;
  meth_meth_ast_toGrace1347->definitionLine = 263;
// method "shallowCopy"
  block_savedest(obj1127);
  Object closure1461 = createclosure(2, "shallowCopy");
  setclosureframe(closure1461, stackframe);
  addtoclosure(closure1461, var_nullNode);
  addtoclosure(closure1461, var_ifNode);
  struct UserObject *uo1461 = (struct UserObject*)obj1127;
  uo1461->data[11] = (Object)closure1461;
  Method *meth_meth_ast_shallowCopy1461 = addmethod2pos(obj1127, "shallowCopy", &meth_ast_shallowCopy1461, 11);
  int argcv_meth_ast_shallowCopy1461[] = {0};
  meth_meth_ast_shallowCopy1461->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1461);
  meth_meth_ast_shallowCopy1461->definitionModule = modulename;
  meth_meth_ast_shallowCopy1461->definitionLine = 281;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1466 = (struct UserObject*)obj1127;
  uo1466->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1466 = addmethod2pos(obj1127, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1466, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom1466[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1466->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1466);
  meth_meth_ast_shallowCopyFieldsFrom1466->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1466->definitionLine = 284;
  sourceObject = obj1127;
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1473 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1474 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1475 = gc_frame_new();
// call case 3: self.outer request
  Object call1476 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1475);
// compiled call node returning call1476 (depth = 7)
// compiled member node returning call1476 (depth = 6)
  partcv[0] = 0;
  Object call1477 = callmethodflags(call1476, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled call node returning call1477 (depth = 5)
// compiled member node returning call1477 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1478 = callmethodflags(call1477, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1473);
// compiled call node returning call1478 (depth = 3)
  struct UserObject *obj1127_uo = (struct UserObject *)obj1127;
  obj1127_uo->super = call1478;
  sourceObject = obj1127;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1479 == NULL) {
    strlit1479 = alloc_String("if");
    gc_root(strlit1479);
  }
// compiled string node returning strlit1479 (depth = 3)
  adddatum2(obj1127, strlit1479, 1);
  sourceObject = obj1127;
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  adddatum2(obj1127, *var_cond, 2);
  sourceObject = obj1127;
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenblock_39_ (depth = 3)
  adddatum2(obj1127, *var_thenblock_39_, 3);
  sourceObject = obj1127;
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseblock_39_ (depth = 3)
  adddatum2(obj1127, *var_elseblock_39_, 4);
  sourceObject = obj1127;
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1480 = alloc_Boolean(0);
// compiled identifier node returning bool1480 (depth = 3)
  adddatum2(obj1127, bool1480, 5);
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  sourceObject = obj1127;
  objclass1127 = obj1127->class;
  objclass1127->definitionModule = modulename;
  objclass1127->definitionLine = 215;
  (*(struct UserObject *)self).data[0] = lowerouter1127;
  self = oldself1127;
  selfslot = oldselfslot1127;
  stackframe = oldstackframe1127;
  gc_frame_end(frame);
  return obj1127;
}
Object meth_ast_ifNode1482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_isBlock1495(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1496 = alloc_Boolean(1);
// compiled identifier node returning bool1496 (depth = 3)
  gc_frame_end(frame);
  return bool1496;
}
Object meth_ast_isEmpty1497(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1499 = alloc_Float64(0);
// compiled num node returning num1499 (depth = 4)
  int op_slot_right_1498 = gc_frame_newslot(num1499);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1501 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1503 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1502);
// compiled call node returning call1503 (depth = 7)
// compiled member node returning call1503 (depth = 6)
  partcv[0] = 0;
  Object call1504 = callmethod(call1503, "size",
    1, partcv, params);
  gc_frame_end(callframe1501);
// compiled call node returning call1504 (depth = 5)
// compiled member node returning call1504 (depth = 4)
  int op_slot_left_1498 = gc_frame_newslot(call1504);
  params[0] = num1499;
  partcv[0] = 1;
  Object opresult1505 = callmethod(call1504, "==", 1, partcv, params);
// compiled op node returning opresult1505 (depth = 3)
  gc_frame_end(frame);
  return opresult1505;
}
Object meth_ast_isntEmpty1506(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isntEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isntEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isntEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1508 = alloc_Float64(0);
// compiled num node returning num1508 (depth = 4)
  int op_slot_right_1507 = gc_frame_newslot(num1508);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1511 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1512 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1511);
// compiled call node returning call1512 (depth = 7)
// compiled member node returning call1512 (depth = 6)
  partcv[0] = 0;
  Object call1513 = callmethod(call1512, "size",
    1, partcv, params);
  gc_frame_end(callframe1510);
// compiled call node returning call1513 (depth = 5)
// compiled member node returning call1513 (depth = 4)
  int op_slot_left_1507 = gc_frame_newslot(call1513);
  params[0] = num1508;
  partcv[0] = 1;
  Object opresult1514 = callmethod(call1513, ">", 1, partcv, params);
// compiled op node returning opresult1514 (depth = 3)
  gc_frame_end(frame);
  return opresult1514;
}
Object meth_ast_scope_58__61_1515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1516 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call1517 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1516);
// compiled call node returning call1517 (depth = 3)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1518 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1519 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe1518);
// compiled call node returning call1519 (depth = 3)
  gc_frame_end(frame);
  return call1519;
}
Object meth_ast_declarationKindWithAncestors1520(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call1522 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe1521);
// compiled call node returning call1522 (depth = 4)
// compiled member node returning call1522 (depth = 3)
  gc_frame_end(frame);
  return call1522;
}
Object meth_ast_isMatchingBlock1523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1525 = alloc_Float64(1);
// compiled num node returning num1525 (depth = 4)
  int op_slot_right_1524 = gc_frame_newslot(num1525);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1527 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1529 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1528);
// compiled call node returning call1529 (depth = 7)
// compiled member node returning call1529 (depth = 6)
  partcv[0] = 0;
  Object call1530 = callmethod(call1529, "size",
    1, partcv, params);
  gc_frame_end(callframe1527);
// compiled call node returning call1530 (depth = 5)
// compiled member node returning call1530 (depth = 4)
  int op_slot_left_1524 = gc_frame_newslot(call1530);
  params[0] = num1525;
  partcv[0] = 1;
  Object opresult1531 = callmethod(call1530, "==", 1, partcv, params);
// compiled op node returning opresult1531 (depth = 3)
  gc_frame_end(frame);
  return opresult1531;
}
Object meth_ast__apply1535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1536 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1537 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1538 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1539 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1538);
// compiled call node returning call1539 (depth = 10)
// compiled member node returning call1539 (depth = 9)
  partcv[0] = 0;
  Object call1540 = callmethod(call1539, "last",
    1, partcv, params);
  gc_frame_end(callframe1537);
// compiled call node returning call1540 (depth = 8)
// compiled member node returning call1540 (depth = 7)
  partcv[0] = 0;
  Object call1541 = callmethod(call1540, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe1536);
// compiled call node returning call1541 (depth = 6)
// compiled member node returning call1541 (depth = 5)
  gc_frame_end(frame);
  return call1541;
}
Object meth_ast_returnsObject1532(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block1534 = alloc_Block(NULL, NULL, "ast", 316);
  gc_frame_newslot(block1534);
// method "_apply"
  block_savedest(block1534);
  Object closure1535 = createclosure(1, "_apply");
  setclosureframe(closure1535, stackframe);
  addtoclosure(closure1535, selfslot);
  struct UserObject *uo1535 = (struct UserObject*)block1534;
  uo1535->data[0] = (Object)closure1535;
  Method *meth_meth_ast__apply1535 = addmethod2pos(block1534, "_apply", &meth_ast__apply1535, 0);
  int argcv_meth_ast__apply1535[] = {0};
  meth_meth_ast__apply1535->type = alloc_MethodType(1, argcv_meth_ast__apply1535);
  meth_meth_ast__apply1535->definitionModule = modulename;
  meth_meth_ast__apply1535->definitionLine = 314;
// compiled block node returning block1534 (depth = 4)
  int op_slot_right_1533 = gc_frame_newslot(block1534);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1545 = alloc_Float64(0);
// compiled num node returning num1545 (depth = 5)
  int op_slot_right_1544 = gc_frame_newslot(num1545);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1547 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1548 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1549 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1548);
// compiled call node returning call1549 (depth = 8)
// compiled member node returning call1549 (depth = 7)
  partcv[0] = 0;
  Object call1550 = callmethod(call1549, "size",
    1, partcv, params);
  gc_frame_end(callframe1547);
// compiled call node returning call1550 (depth = 6)
// compiled member node returning call1550 (depth = 5)
  int op_slot_left_1544 = gc_frame_newslot(call1550);
  params[0] = num1545;
  partcv[0] = 1;
  Object opresult1551 = callmethod(call1550, ">", 1, partcv, params);
// compiled op node returning opresult1551 (depth = 4)
  int op_slot_left_1533 = gc_frame_newslot(opresult1551);
  params[0] = block1534;
  partcv[0] = 1;
  Object opresult1552 = callmethod(opresult1551, "&&", 1, partcv, params);
// compiled op node returning opresult1552 (depth = 3)
  gc_frame_end(frame);
  return opresult1552;
}
Object meth_ast_returnedObjectScope1553(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1554 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1555 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1557 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1556);
// compiled call node returning call1557 (depth = 8)
// compiled member node returning call1557 (depth = 7)
  partcv[0] = 0;
  Object call1558 = callmethod(call1557, "last",
    1, partcv, params);
  gc_frame_end(callframe1555);
// compiled call node returning call1558 (depth = 6)
// compiled member node returning call1558 (depth = 5)
  partcv[0] = 0;
  Object call1559 = callmethod(call1558, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe1554);
// compiled call node returning call1559 (depth = 4)
// compiled member node returning call1559 (depth = 3)
  gc_frame_end(frame);
  return call1559;
}
Object meth_ast_parametersDo1560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1561 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1563 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1562);
// compiled call node returning call1563 (depth = 5)
// compiled member node returning call1563 (depth = 4)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1564 = callmethod(call1563, "do",
    1, partcv, params);
  gc_frame_end(callframe1561);
// compiled call node returning call1564 (depth = 3)
  gc_frame_end(frame);
  return call1564;
}
Object meth_ast__apply1575(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1576 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1577 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1576);
// compiled call node returning call1577 (depth = 6)
  gc_frame_end(frame);
  return call1577;
}
Object meth_ast__apply1584(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1585 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1586 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1585);
// compiled call node returning call1586 (depth = 6)
  gc_frame_end(frame);
  return call1586;
}
Object meth_ast_accept_40__41_from1565(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1567 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1568 = callmethod(*var_visitor, "visitBlock()up",
    2, partcv, params);
  gc_frame_end(callframe1567);
// compiled call node returning call1568 (depth = 4)
  Object if1566 = done;
  if (istrue(call1568)) {
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1569 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1570 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1569);
// compiled call node returning call1570 (depth = 5)
  *var_newChain = call1570;
  if (call1570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1571 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1572 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1573 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1572);
// compiled call node returning call1573 (depth = 6)
// compiled member node returning call1573 (depth = 5)
  gc_frame_newslot(call1573);
// starting to compile block node (depth = 5)
  Object block1574 = alloc_Block(NULL, NULL, "ast", 328);
  gc_frame_newslot(block1574);
// method "_apply"
  block_savedest(block1574);
  Object closure1575 = createclosure(3, "_apply");
  setclosureframe(closure1575, stackframe);
  addtoclosure(closure1575, var_visitor);
  addtoclosure(closure1575, var_newChain);
  addtoclosure(closure1575, selfslot);
  struct UserObject *uo1575 = (struct UserObject*)block1574;
  uo1575->data[0] = (Object)closure1575;
  Method *meth_meth_ast__apply1575 = addmethod2pos(block1574, "_apply", &meth_ast__apply1575, 0);
  int argcv_meth_ast__apply1575[] = {1};
  meth_meth_ast__apply1575->type = alloc_MethodType(1, argcv_meth_ast__apply1575);
  meth_meth_ast__apply1575->definitionModule = modulename;
  meth_meth_ast__apply1575->definitionLine = 328;
// compiled block node returning block1574 (depth = 5)
  gc_frame_newslot(block1574);
// call case 5: prelude request
  params[0] = call1573;
  params[1] = block1574;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1579 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1571);
// compiled call node returning call1579 (depth = 4)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1580 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1581 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1582 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1581);
// compiled call node returning call1582 (depth = 6)
// compiled member node returning call1582 (depth = 5)
  gc_frame_newslot(call1582);
// starting to compile block node (depth = 5)
  Object block1583 = alloc_Block(NULL, NULL, "ast", 331);
  gc_frame_newslot(block1583);
// method "_apply"
  block_savedest(block1583);
  Object closure1584 = createclosure(3, "_apply");
  setclosureframe(closure1584, stackframe);
  addtoclosure(closure1584, var_visitor);
  addtoclosure(closure1584, var_newChain);
  addtoclosure(closure1584, selfslot);
  struct UserObject *uo1584 = (struct UserObject*)block1583;
  uo1584->data[0] = (Object)closure1584;
  Method *meth_meth_ast__apply1584 = addmethod2pos(block1583, "_apply", &meth_ast__apply1584, 0);
  int argcv_meth_ast__apply1584[] = {1};
  meth_meth_ast__apply1584->type = alloc_MethodType(1, argcv_meth_ast__apply1584);
  meth_meth_ast__apply1584->definitionModule = modulename;
  meth_meth_ast__apply1584->definitionLine = 331;
// compiled block node returning block1583 (depth = 5)
  gc_frame_newslot(block1583);
// call case 5: prelude request
  params[0] = call1582;
  params[1] = block1583;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1588 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1580);
// compiled call node returning call1588 (depth = 4)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1592 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compiled call node returning call1592 (depth = 7)
// compiled member node returning call1592 (depth = 6)
  int op_slot_right_1590 = gc_frame_newslot(call1592);
// starting to compile identifier node (depth = 6)
  Object bool1594 = alloc_Boolean(0);
// compiled identifier node returning bool1594 (depth = 6)
  int op_slot_left_1590 = gc_frame_newslot(bool1594);
  params[0] = call1592;
  partcv[0] = 1;
  Object opresult1595 = callmethod(bool1594, "≠", 1, partcv, params);
// compiled op node returning opresult1595 (depth = 5)
  Object if1589 = done;
  if (istrue(opresult1595)) {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1596 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1597 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1598 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1597);
// compiled call node returning call1598 (depth = 7)
// compiled member node returning call1598 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1599 = callmethod(call1598, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1596);
// compiled call node returning call1599 (depth = 5)
    gc_frame_newslot(call1599);
    if1589 = call1599;
  } else {
  }
// compiled if node returning if1589 (depth = 4)
    gc_frame_newslot(if1589);
    if1566 = if1589;
  } else {
  }
// compiled if node returning if1566 (depth = 3)
  gc_frame_end(frame);
  return if1566;
}
Object meth_ast_map_40__41_ancestors1600(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1601 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1602 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1601);
// compiled call node returning call1602 (depth = 5)
// compiled member node returning call1602 (depth = 4)
  *var_n = call1602;
  if (call1602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1603 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1604 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1603);
// compiled call node returning call1604 (depth = 4)
  *var_newChain = call1604;
  if (call1604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1605 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1606 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1608 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1607);
// compiled call node returning call1608 (depth = 6)
// compiled member node returning call1608 (depth = 5)
  gc_frame_newslot(call1608);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1609 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1610 = gc_frame_new();
// call case 3: self.outer request
  Object call1611 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1610);
// compiled call node returning call1611 (depth = 8)
// compiled member node returning call1611 (depth = 7)
  partcv[0] = 0;
  Object call1612 = callmethodflags(call1611, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1609);
// compiled call node returning call1612 (depth = 6)
// compiled member node returning call1612 (depth = 5)
  params[0] = call1608;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1613 = callmethodflags(call1612, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1606);
// compiled call node returning call1613 (depth = 4)
  gc_frame_newslot(call1613);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1613;
  partcv[0] = 1;
  Object call1614 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe1605);
// compiled call node returning call1614 (depth = 3)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1615 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1616 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1617 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1618 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1617);
// compiled call node returning call1618 (depth = 6)
// compiled member node returning call1618 (depth = 5)
  gc_frame_newslot(call1618);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1619 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1620 = gc_frame_new();
// call case 3: self.outer request
  Object call1621 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1620);
// compiled call node returning call1621 (depth = 8)
// compiled member node returning call1621 (depth = 7)
  partcv[0] = 0;
  Object call1622 = callmethodflags(call1621, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1619);
// compiled call node returning call1622 (depth = 6)
// compiled member node returning call1622 (depth = 5)
  params[0] = call1618;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1623 = callmethodflags(call1622, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1616);
// compiled call node returning call1623 (depth = 4)
  gc_frame_newslot(call1623);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1623;
  partcv[0] = 1;
  Object call1624 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe1615);
// compiled call node returning call1624 (depth = 3)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1625 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1626 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1628 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled call node returning call1628 (depth = 6)
// compiled member node returning call1628 (depth = 5)
  gc_frame_newslot(call1628);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1629 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1630 = gc_frame_new();
// call case 3: self.outer request
  Object call1631 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1630);
// compiled call node returning call1631 (depth = 8)
// compiled member node returning call1631 (depth = 7)
  partcv[0] = 0;
  Object call1632 = callmethodflags(call1631, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1629);
// compiled call node returning call1632 (depth = 6)
// compiled member node returning call1632 (depth = 5)
  params[0] = call1628;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1633 = callmethodflags(call1632, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1626);
// compiled call node returning call1633 (depth = 4)
  gc_frame_newslot(call1633);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1633;
  partcv[0] = 1;
  Object call1634 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1625);
// compiled call node returning call1634 (depth = 3)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1635 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call1636 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1635);
// compiled call node returning call1636 (depth = 3)
  gc_frame_end(frame);
  return call1636;
}
Object meth_ast__apply1645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1647 == NULL) {
    strlit1647 = alloc_String("  ");
    gc_root(strlit1647);
  }
// compiled string node returning strlit1647 (depth = 7)
  int op_slot_right_1646 = gc_frame_newslot(strlit1647);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1646 = gc_frame_newslot(*var_spc);
  params[0] = strlit1647;
  partcv[0] = 1;
  Object opresult1649 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1649 (depth = 6)
  *var_spc = opresult1649;
  if (opresult1649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1671(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1673 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1675 = alloc_Float64(2);
// compiled num node returning num1675 (depth = 9)
  int op_slot_right_1674 = gc_frame_newslot(num1675);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1674 = gc_frame_newslot(*var_depth);
  params[0] = num1675;
  partcv[0] = 1;
  Object sum1677 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1677 (depth = 8)
  gc_frame_newslot(sum1677);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1677;
  partcv[0] = 1;
  Object call1678 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1673);
// compiled call node returning call1678 (depth = 7)
  int op_slot_right_1672 = gc_frame_newslot(call1678);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1680 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1683 == NULL) {
    strlit1683 = alloc_String("""\x0a""  ");
    gc_root(strlit1683);
  }
// compiled string node returning strlit1683 (depth = 9)
  int op_slot_right_1682 = gc_frame_newslot(strlit1683);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1682 = gc_frame_newslot(*var_s);
  params[0] = strlit1683;
  partcv[0] = 1;
  Object opresult1685 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1685 (depth = 8)
  int op_slot_left_1680 = gc_frame_newslot(opresult1685);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1686 = callmethod(opresult1685, "++", 1, partcv, params);
// compiled op node returning opresult1686 (depth = 7)
  int op_slot_left_1672 = gc_frame_newslot(opresult1686);
  params[0] = call1678;
  partcv[0] = 1;
  Object opresult1687 = callmethod(opresult1686, "++", 1, partcv, params);
// compiled op node returning opresult1687 (depth = 6)
  *var_s = opresult1687;
  if (opresult1687 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1708(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1710 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1712 = alloc_Float64(2);
// compiled num node returning num1712 (depth = 9)
  int op_slot_right_1711 = gc_frame_newslot(num1712);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1711 = gc_frame_newslot(*var_depth);
  params[0] = num1712;
  partcv[0] = 1;
  Object sum1714 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1714 (depth = 8)
  gc_frame_newslot(sum1714);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1714;
  partcv[0] = 1;
  Object call1715 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1710);
// compiled call node returning call1715 (depth = 7)
  int op_slot_right_1709 = gc_frame_newslot(call1715);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1717 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1720 == NULL) {
    strlit1720 = alloc_String("""\x0a""  ");
    gc_root(strlit1720);
  }
// compiled string node returning strlit1720 (depth = 9)
  int op_slot_right_1719 = gc_frame_newslot(strlit1720);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1719 = gc_frame_newslot(*var_s);
  params[0] = strlit1720;
  partcv[0] = 1;
  Object opresult1722 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1722 (depth = 8)
  int op_slot_left_1717 = gc_frame_newslot(opresult1722);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1723 = callmethod(opresult1722, "++", 1, partcv, params);
// compiled op node returning opresult1723 (depth = 7)
  int op_slot_left_1709 = gc_frame_newslot(opresult1723);
  params[0] = call1715;
  partcv[0] = 1;
  Object opresult1724 = callmethod(opresult1723, "++", 1, partcv, params);
// compiled op node returning opresult1724 (depth = 6)
  *var_s = opresult1724;
  if (opresult1724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1637(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1638 == NULL) {
    strlit1638 = alloc_String("");
    gc_root(strlit1638);
  }
// compiled string node returning strlit1638 (depth = 4)
  *var_spc = strlit1638;
  if (strlit1638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1639 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_1640 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num1642 = alloc_Float64(0);
// compiled num node returning num1642 (depth = 5)
  int op_slot_left_1640 = gc_frame_newslot(num1642);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1643 = callmethod(num1642, "..", 1, partcv, params);
// compiled op node returning opresult1643 (depth = 4)
  gc_frame_newslot(opresult1643);
// starting to compile block node (depth = 4)
  Object block1644 = alloc_Block(NULL, NULL, "ast", 349);
  gc_frame_newslot(block1644);
// method "_apply"
  block_savedest(block1644);
  Object closure1645 = createclosure(2, "_apply");
  setclosureframe(closure1645, stackframe);
  addtoclosure(closure1645, var_spc);
  addtoclosure(closure1645, selfslot);
  struct UserObject *uo1645 = (struct UserObject*)block1644;
  uo1645->data[0] = (Object)closure1645;
  Method *meth_meth_ast__apply1645 = addmethod2pos(block1644, "_apply", &meth_ast__apply1645, 0);
  int argcv_meth_ast__apply1645[] = {1};
  meth_meth_ast__apply1645->type = alloc_MethodType(1, argcv_meth_ast__apply1645);
  meth_meth_ast__apply1645->definitionModule = modulename;
  meth_meth_ast__apply1645->definitionLine = 344;
// compiled block node returning block1644 (depth = 4)
  gc_frame_newslot(block1644);
// call case 5: prelude request
  params[0] = opresult1643;
  params[1] = block1644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1639);
// compiled call node returning call1652 (depth = 3)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1654 == NULL) {
    strlit1654 = alloc_String("""\x0a""");
    gc_root(strlit1654);
  }
// compiled string node returning strlit1654 (depth = 5)
  int op_slot_right_1653 = gc_frame_newslot(strlit1654);
// starting to compile call node (depth = 5)
  int callframe1656 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1657 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1656);
// compiled call node returning call1657 (depth = 5)
  int op_slot_left_1653 = gc_frame_newslot(call1657);
  params[0] = strlit1654;
  partcv[0] = 1;
  Object opresult1658 = callmethod(call1657, "++", 1, partcv, params);
// compiled op node returning opresult1658 (depth = 4)
  *var_s = opresult1658;
  if (opresult1658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1660 == NULL) {
    strlit1660 = alloc_String("Parameters:");
    gc_root(strlit1660);
  }
// compiled string node returning strlit1660 (depth = 5)
  int op_slot_right_1659 = gc_frame_newslot(strlit1660);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1662 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1662 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1664 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1664 (depth = 5)
  int op_slot_left_1659 = gc_frame_newslot(opresult1664);
  params[0] = strlit1660;
  partcv[0] = 1;
  Object opresult1665 = callmethod(opresult1664, "++", 1, partcv, params);
// compiled op node returning opresult1665 (depth = 4)
  *var_s = opresult1665;
  if (opresult1665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1667 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1669 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled call node returning call1669 (depth = 5)
// compiled member node returning call1669 (depth = 4)
  gc_frame_newslot(call1669);
// starting to compile block node (depth = 4)
  Object block1670 = alloc_Block(NULL, NULL, "ast", 354);
  gc_frame_newslot(block1670);
// method "_apply"
  block_savedest(block1670);
  Object closure1671 = createclosure(4, "_apply");
  setclosureframe(closure1671, stackframe);
  addtoclosure(closure1671, var_depth);
  addtoclosure(closure1671, var_spc);
  addtoclosure(closure1671, var_s);
  addtoclosure(closure1671, selfslot);
  struct UserObject *uo1671 = (struct UserObject*)block1670;
  uo1671->data[0] = (Object)closure1671;
  Method *meth_meth_ast__apply1671 = addmethod2pos(block1670, "_apply", &meth_ast__apply1671, 0);
  int argcv_meth_ast__apply1671[] = {1};
  meth_meth_ast__apply1671->type = alloc_MethodType(1, argcv_meth_ast__apply1671);
  meth_meth_ast__apply1671->definitionModule = modulename;
  meth_meth_ast__apply1671->definitionLine = 354;
// compiled block node returning block1670 (depth = 4)
  gc_frame_newslot(block1670);
// call case 5: prelude request
  params[0] = call1669;
  params[1] = block1670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1690 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1667);
// compiled call node returning call1690 (depth = 3)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1692 == NULL) {
    strlit1692 = alloc_String("""\x0a""");
    gc_root(strlit1692);
  }
// compiled string node returning strlit1692 (depth = 5)
  int op_slot_right_1691 = gc_frame_newslot(strlit1692);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_1691 = gc_frame_newslot(*var_s);
  params[0] = strlit1692;
  partcv[0] = 1;
  Object opresult1694 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1694 (depth = 4)
  *var_s = opresult1694;
  if (opresult1694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1697 == NULL) {
    strlit1697 = alloc_String("Body:");
    gc_root(strlit1697);
  }
// compiled string node returning strlit1697 (depth = 5)
  int op_slot_right_1696 = gc_frame_newslot(strlit1697);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1699 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1699 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1701 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1701 (depth = 5)
  int op_slot_left_1696 = gc_frame_newslot(opresult1701);
  params[0] = strlit1697;
  partcv[0] = 1;
  Object opresult1702 = callmethod(opresult1701, "++", 1, partcv, params);
// compiled op node returning opresult1702 (depth = 4)
  *var_s = opresult1702;
  if (opresult1702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1704 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1705 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1706 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1705);
// compiled call node returning call1706 (depth = 5)
// compiled member node returning call1706 (depth = 4)
  gc_frame_newslot(call1706);
// starting to compile block node (depth = 4)
  Object block1707 = alloc_Block(NULL, NULL, "ast", 359);
  gc_frame_newslot(block1707);
// method "_apply"
  block_savedest(block1707);
  Object closure1708 = createclosure(4, "_apply");
  setclosureframe(closure1708, stackframe);
  addtoclosure(closure1708, var_depth);
  addtoclosure(closure1708, var_spc);
  addtoclosure(closure1708, var_s);
  addtoclosure(closure1708, selfslot);
  struct UserObject *uo1708 = (struct UserObject*)block1707;
  uo1708->data[0] = (Object)closure1708;
  Method *meth_meth_ast__apply1708 = addmethod2pos(block1707, "_apply", &meth_ast__apply1708, 0);
  int argcv_meth_ast__apply1708[] = {1};
  meth_meth_ast__apply1708->type = alloc_MethodType(1, argcv_meth_ast__apply1708);
  meth_meth_ast__apply1708->definitionModule = modulename;
  meth_meth_ast__apply1708->definitionLine = 359;
// compiled block node returning block1707 (depth = 4)
  gc_frame_newslot(block1707);
// call case 5: prelude request
  params[0] = call1706;
  params[1] = block1707;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1727 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1704);
// compiled call node returning call1727 (depth = 3)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1731 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1730);
// compiled call node returning call1731 (depth = 6)
// compiled member node returning call1731 (depth = 5)
  int op_slot_right_1729 = gc_frame_newslot(call1731);
// starting to compile identifier node (depth = 5)
  Object bool1733 = alloc_Boolean(0);
// compiled identifier node returning bool1733 (depth = 5)
  int op_slot_left_1729 = gc_frame_newslot(bool1733);
  params[0] = call1731;
  partcv[0] = 1;
  Object opresult1734 = callmethod(bool1733, "≠", 1, partcv, params);
// compiled op node returning opresult1734 (depth = 4)
  Object if1728 = done;
  if (istrue(opresult1734)) {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1736 == NULL) {
    strlit1736 = alloc_String("""\x0a""");
    gc_root(strlit1736);
  }
// compiled string node returning strlit1736 (depth = 6)
  int op_slot_right_1735 = gc_frame_newslot(strlit1736);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1735 = gc_frame_newslot(*var_s);
  params[0] = strlit1736;
  partcv[0] = 1;
  Object opresult1738 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1738 (depth = 5)
  *var_s = opresult1738;
  if (opresult1738 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1741 == NULL) {
    strlit1741 = alloc_String("Pattern:");
    gc_root(strlit1741);
  }
// compiled string node returning strlit1741 (depth = 6)
  int op_slot_right_1740 = gc_frame_newslot(strlit1741);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1743 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1743 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1745 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1745 (depth = 6)
  int op_slot_left_1740 = gc_frame_newslot(opresult1745);
  params[0] = strlit1741;
  partcv[0] = 1;
  Object opresult1746 = callmethod(opresult1745, "++", 1, partcv, params);
// compiled op node returning opresult1746 (depth = 5)
  *var_s = opresult1746;
  if (opresult1746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1749 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1751 = alloc_Float64(2);
// compiled num node returning num1751 (depth = 8)
  int op_slot_right_1750 = gc_frame_newslot(num1751);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1750 = gc_frame_newslot(*var_depth);
  params[0] = num1751;
  partcv[0] = 1;
  Object sum1753 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1753 (depth = 7)
  gc_frame_newslot(sum1753);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1754 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1755 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1754);
// compiled call node returning call1755 (depth = 8)
// compiled member node returning call1755 (depth = 7)
  params[0] = sum1753;
  partcv[0] = 1;
  Object call1756 = callmethod(call1755, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1749);
// compiled call node returning call1756 (depth = 6)
  int op_slot_right_1748 = gc_frame_newslot(call1756);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1758 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1761 == NULL) {
    strlit1761 = alloc_String("""\x0a""  ");
    gc_root(strlit1761);
  }
// compiled string node returning strlit1761 (depth = 8)
  int op_slot_right_1760 = gc_frame_newslot(strlit1761);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1760 = gc_frame_newslot(*var_s);
  params[0] = strlit1761;
  partcv[0] = 1;
  Object opresult1763 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1763 (depth = 7)
  int op_slot_left_1758 = gc_frame_newslot(opresult1763);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1764 = callmethod(opresult1763, "++", 1, partcv, params);
// compiled op node returning opresult1764 (depth = 6)
  int op_slot_left_1748 = gc_frame_newslot(opresult1764);
  params[0] = call1756;
  partcv[0] = 1;
  Object opresult1765 = callmethod(opresult1764, "++", 1, partcv, params);
// compiled op node returning opresult1765 (depth = 5)
  *var_s = opresult1765;
  if (opresult1765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1728 = done;
  } else {
  }
// compiled if node returning if1728 (depth = 3)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1781 == NULL) {
    strlit1781 = alloc_String("    ");
    gc_root(strlit1781);
  }
// compiled string node returning strlit1781 (depth = 7)
  int op_slot_right_1780 = gc_frame_newslot(strlit1781);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_1780 = gc_frame_newslot(*var_spc);
  params[0] = strlit1781;
  partcv[0] = 1;
  Object opresult1783 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1783 (depth = 6)
  *var_spc = opresult1783;
  if (opresult1783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1808(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1809 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1810 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1811 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1810);
// compiled call node returning call1811 (depth = 9)
// compiled member node returning call1811 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1812 = callmethod(call1811, "at",
    1, partcv, params);
  gc_frame_end(callframe1809);
// compiled call node returning call1812 (depth = 7)
  *var_p = call1812;
  if (call1812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1815 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1816 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1815);
// compiled call node returning call1816 (depth = 9)
// compiled member node returning call1816 (depth = 8)
  int op_slot_right_1814 = gc_frame_newslot(call1816);
// starting to compile identifier node (depth = 8)
  Object bool1818 = alloc_Boolean(0);
// compiled identifier node returning bool1818 (depth = 8)
  int op_slot_left_1814 = gc_frame_newslot(bool1818);
  params[0] = call1816;
  partcv[0] = 1;
  Object opresult1819 = callmethod(bool1818, "≠", 1, partcv, params);
// compiled op node returning opresult1819 (depth = 7)
  Object if1813 = done;
  if (istrue(opresult1819)) {
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1821 == NULL) {
    strlit1821 = alloc_String(")");
    gc_root(strlit1821);
  }
// compiled string node returning strlit1821 (depth = 9)
  int op_slot_right_1820 = gc_frame_newslot(strlit1821);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1824 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1825 = alloc_Float64(0);
// compiled num node returning num1825 (depth = 11)
  gc_frame_newslot(num1825);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1825;
  partcv[0] = 1;
  Object call1826 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1824);
// compiled call node returning call1826 (depth = 10)
  int op_slot_right_1823 = gc_frame_newslot(call1826);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1829 == NULL) {
    strlit1829 = alloc_String("(");
    gc_root(strlit1829);
  }
// compiled string node returning strlit1829 (depth = 11)
  int op_slot_right_1828 = gc_frame_newslot(strlit1829);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1828 = gc_frame_newslot(*var_s);
  params[0] = strlit1829;
  partcv[0] = 1;
  Object opresult1831 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1831 (depth = 10)
  int op_slot_left_1823 = gc_frame_newslot(opresult1831);
  params[0] = call1826;
  partcv[0] = 1;
  Object opresult1832 = callmethod(opresult1831, "++", 1, partcv, params);
// compiled op node returning opresult1832 (depth = 9)
  int op_slot_left_1820 = gc_frame_newslot(opresult1832);
  params[0] = strlit1821;
  partcv[0] = 1;
  Object opresult1833 = callmethod(opresult1832, "++", 1, partcv, params);
// compiled op node returning opresult1833 (depth = 8)
  *var_s = opresult1833;
  if (opresult1833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1813 = done;
  } else {
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1836 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num1837 = alloc_Float64(0);
// compiled num node returning num1837 (depth = 10)
  gc_frame_newslot(num1837);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = num1837;
  partcv[0] = 1;
  Object call1838 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1836);
// compiled call node returning call1838 (depth = 9)
  int op_slot_right_1835 = gc_frame_newslot(call1838);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1835 = gc_frame_newslot(*var_s);
  params[0] = call1838;
  partcv[0] = 1;
  Object opresult1840 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1840 (depth = 8)
  *var_s = opresult1840;
  if (opresult1840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1813 = done;
  }
// compiled if node returning if1813 (depth = 6)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1844 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1846 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1845);
// compiled call node returning call1846 (depth = 11)
// compiled member node returning call1846 (depth = 10)
  partcv[0] = 0;
  Object call1847 = callmethod(call1846, "size",
    1, partcv, params);
  gc_frame_end(callframe1844);
// compiled call node returning call1847 (depth = 9)
// compiled member node returning call1847 (depth = 8)
  int op_slot_right_1843 = gc_frame_newslot(call1847);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1843 = gc_frame_newslot(*var_i);
  params[0] = call1847;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 7)
  Object if1842 = done;
  if (istrue(opresult1849)) {
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1851 == NULL) {
    strlit1851 = alloc_String(", ");
    gc_root(strlit1851);
  }
// compiled string node returning strlit1851 (depth = 9)
  int op_slot_right_1850 = gc_frame_newslot(strlit1851);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1850 = gc_frame_newslot(*var_s);
  params[0] = strlit1851;
  partcv[0] = 1;
  Object opresult1853 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1853 (depth = 8)
  *var_s = opresult1853;
  if (opresult1853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1842 = done;
  } else {
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1856 == NULL) {
    strlit1856 = alloc_String(" ->");
    gc_root(strlit1856);
  }
// compiled string node returning strlit1856 (depth = 9)
  int op_slot_right_1855 = gc_frame_newslot(strlit1856);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1855 = gc_frame_newslot(*var_s);
  params[0] = strlit1856;
  partcv[0] = 1;
  Object opresult1858 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1858 (depth = 8)
  *var_s = opresult1858;
  if (opresult1858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1842 = done;
  }
// compiled if node returning if1842 (depth = 6)
  gc_frame_end(frame);
  return if1842;
}
Object meth_ast__apply1866(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1868 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1870 = alloc_Float64(1);
// compiled num node returning num1870 (depth = 9)
  int op_slot_right_1869 = gc_frame_newslot(num1870);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1869 = gc_frame_newslot(*var_depth);
  params[0] = num1870;
  partcv[0] = 1;
  Object sum1872 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1872 (depth = 8)
  gc_frame_newslot(sum1872);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum1872;
  partcv[0] = 1;
  Object call1873 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1868);
// compiled call node returning call1873 (depth = 7)
  int op_slot_right_1867 = gc_frame_newslot(call1873);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1876 == NULL) {
    strlit1876 = alloc_String("    ");
    gc_root(strlit1876);
  }
// compiled string node returning strlit1876 (depth = 8)
  int op_slot_right_1875 = gc_frame_newslot(strlit1876);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1878 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1881 == NULL) {
    strlit1881 = alloc_String("""\x0a""");
    gc_root(strlit1881);
  }
// compiled string node returning strlit1881 (depth = 10)
  int op_slot_right_1880 = gc_frame_newslot(strlit1881);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1880 = gc_frame_newslot(*var_s);
  params[0] = strlit1881;
  partcv[0] = 1;
  Object opresult1883 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1883 (depth = 9)
  int op_slot_left_1878 = gc_frame_newslot(opresult1883);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1884 = callmethod(opresult1883, "++", 1, partcv, params);
// compiled op node returning opresult1884 (depth = 8)
  int op_slot_left_1875 = gc_frame_newslot(opresult1884);
  params[0] = strlit1876;
  partcv[0] = 1;
  Object opresult1885 = callmethod(opresult1884, "++", 1, partcv, params);
// compiled op node returning opresult1885 (depth = 7)
  int op_slot_left_1867 = gc_frame_newslot(opresult1885);
  params[0] = call1873;
  partcv[0] = 1;
  Object opresult1886 = callmethod(opresult1885, "++", 1, partcv, params);
// compiled op node returning opresult1886 (depth = 6)
  *var_s = opresult1886;
  if (opresult1886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 4)
  *var_spc = strlit1768;
  if (strlit1768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1769 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1772 = alloc_Float64(1);
// compiled num node returning num1772 (depth = 6)
  int op_slot_right_1771 = gc_frame_newslot(num1772);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_1771 = gc_frame_newslot(*var_depth);
  params[0] = num1772;
  partcv[0] = 1;
  Object diff1774 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1774 (depth = 5)
  int op_slot_right_1770 = gc_frame_newslot(diff1774);
// starting to compile num node (depth = 5)
  Object num1776 = alloc_Float64(0);
// compiled num node returning num1776 (depth = 5)
  int op_slot_left_1770 = gc_frame_newslot(num1776);
  params[0] = diff1774;
  partcv[0] = 1;
  Object opresult1777 = callmethod(num1776, "..", 1, partcv, params);
// compiled op node returning opresult1777 (depth = 4)
  gc_frame_newslot(opresult1777);
// starting to compile block node (depth = 4)
  Object block1778 = alloc_Block(NULL, NULL, "ast", 371);
  gc_frame_newslot(block1778);
// method "_apply"
  block_savedest(block1778);
  Object closure1779 = createclosure(2, "_apply");
  setclosureframe(closure1779, stackframe);
  addtoclosure(closure1779, var_spc);
  addtoclosure(closure1779, selfslot);
  struct UserObject *uo1779 = (struct UserObject*)block1778;
  uo1779->data[0] = (Object)closure1779;
  Method *meth_meth_ast__apply1779 = addmethod2pos(block1778, "_apply", &meth_ast__apply1779, 0);
  int argcv_meth_ast__apply1779[] = {1};
  meth_meth_ast__apply1779->type = alloc_MethodType(1, argcv_meth_ast__apply1779);
  meth_meth_ast__apply1779->definitionModule = modulename;
  meth_meth_ast__apply1779->definitionLine = 365;
// compiled block node returning block1778 (depth = 4)
  gc_frame_newslot(block1778);
// call case 5: prelude request
  params[0] = opresult1777;
  params[1] = block1778;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1786 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1769);
// compiled call node returning call1786 (depth = 3)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit1787 == NULL) {
    strlit1787 = alloc_String("{");
    gc_root(strlit1787);
  }
// compiled string node returning strlit1787 (depth = 4)
  *var_s = strlit1787;
  if (strlit1787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1790 = alloc_Float64(0);
// compiled num node returning num1790 (depth = 5)
  int op_slot_right_1789 = gc_frame_newslot(num1790);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1792 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1794 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1793);
// compiled call node returning call1794 (depth = 8)
// compiled member node returning call1794 (depth = 7)
  partcv[0] = 0;
  Object call1795 = callmethod(call1794, "size",
    1, partcv, params);
  gc_frame_end(callframe1792);
// compiled call node returning call1795 (depth = 6)
// compiled member node returning call1795 (depth = 5)
  int op_slot_left_1789 = gc_frame_newslot(call1795);
  params[0] = num1790;
  partcv[0] = 1;
  Object opresult1796 = callmethod(call1795, ">", 1, partcv, params);
// compiled op node returning opresult1796 (depth = 4)
  Object if1788 = done;
  if (istrue(opresult1796)) {
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1798 == NULL) {
    strlit1798 = alloc_String(" ");
    gc_root(strlit1798);
  }
// compiled string node returning strlit1798 (depth = 6)
  int op_slot_right_1797 = gc_frame_newslot(strlit1798);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1797 = gc_frame_newslot(*var_s);
  params[0] = strlit1798;
  partcv[0] = 1;
  Object opresult1800 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1800 (depth = 5)
  *var_s = opresult1800;
  if (opresult1800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1802 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1803 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1805 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 8)
// compiled member node returning call1805 (depth = 7)
  partcv[0] = 0;
  Object call1806 = callmethod(call1805, "indices",
    1, partcv, params);
  gc_frame_end(callframe1803);
// compiled call node returning call1806 (depth = 6)
// compiled member node returning call1806 (depth = 5)
  gc_frame_newslot(call1806);
// starting to compile block node (depth = 5)
  Object block1807 = alloc_Block(NULL, NULL, "ast", 377);
  gc_frame_newslot(block1807);
// method "_apply"
  block_savedest(block1807);
  Object closure1808 = createclosure(2, "_apply");
  setclosureframe(closure1808, stackframe);
  addtoclosure(closure1808, var_s);
  addtoclosure(closure1808, selfslot);
  struct UserObject *uo1808 = (struct UserObject*)block1807;
  uo1808->data[0] = (Object)closure1808;
  Method *meth_meth_ast__apply1808 = addmethod2pos(block1807, "_apply", &meth_ast__apply1808, 0);
  int argcv_meth_ast__apply1808[] = {1};
  meth_meth_ast__apply1808->type = alloc_MethodType(1, argcv_meth_ast__apply1808);
  meth_meth_ast__apply1808->definitionModule = modulename;
  meth_meth_ast__apply1808->definitionLine = 377;
// compiled block node returning block1807 (depth = 5)
  gc_frame_newslot(block1807);
// call case 5: prelude request
  params[0] = call1806;
  params[1] = block1807;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1861 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1802);
// compiled call node returning call1861 (depth = 4)
    gc_frame_newslot(call1861);
    if1788 = call1861;
  } else {
  }
// compiled if node returning if1788 (depth = 3)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1862 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1864 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1863);
// compiled call node returning call1864 (depth = 5)
// compiled member node returning call1864 (depth = 4)
  gc_frame_newslot(call1864);
// starting to compile block node (depth = 4)
  Object block1865 = alloc_Block(NULL, NULL, "ast", 391);
  gc_frame_newslot(block1865);
// method "_apply"
  block_savedest(block1865);
  Object closure1866 = createclosure(4, "_apply");
  setclosureframe(closure1866, stackframe);
  addtoclosure(closure1866, var_depth);
  addtoclosure(closure1866, var_spc);
  addtoclosure(closure1866, var_s);
  addtoclosure(closure1866, selfslot);
  struct UserObject *uo1866 = (struct UserObject*)block1865;
  uo1866->data[0] = (Object)closure1866;
  Method *meth_meth_ast__apply1866 = addmethod2pos(block1865, "_apply", &meth_ast__apply1866, 0);
  int argcv_meth_ast__apply1866[] = {1};
  meth_meth_ast__apply1866->type = alloc_MethodType(1, argcv_meth_ast__apply1866);
  meth_meth_ast__apply1866->definitionModule = modulename;
  meth_meth_ast__apply1866->definitionLine = 391;
// compiled block node returning block1865 (depth = 4)
  gc_frame_newslot(block1865);
// call case 5: prelude request
  params[0] = call1864;
  params[1] = block1865;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1889 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1862);
// compiled call node returning call1889 (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1891 == NULL) {
    strlit1891 = alloc_String("}");
    gc_root(strlit1891);
  }
// compiled string node returning strlit1891 (depth = 5)
  int op_slot_right_1890 = gc_frame_newslot(strlit1891);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_1893 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1896 == NULL) {
    strlit1896 = alloc_String("""\x0a""");
    gc_root(strlit1896);
  }
// compiled string node returning strlit1896 (depth = 7)
  int op_slot_right_1895 = gc_frame_newslot(strlit1896);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1895 = gc_frame_newslot(*var_s);
  params[0] = strlit1896;
  partcv[0] = 1;
  Object opresult1898 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1898 (depth = 6)
  int op_slot_left_1893 = gc_frame_newslot(opresult1898);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1899 = callmethod(opresult1898, "++", 1, partcv, params);
// compiled op node returning opresult1899 (depth = 5)
  int op_slot_left_1890 = gc_frame_newslot(opresult1899);
  params[0] = strlit1891;
  partcv[0] = 1;
  Object opresult1900 = callmethod(opresult1899, "++", 1, partcv, params);
// compiled op node returning opresult1900 (depth = 4)
  *var_s = opresult1900;
  if (opresult1900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy1902(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1903 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe1904 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1906 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1905);
// compiled call node returning call1906 (depth = 6)
// compiled member node returning call1906 (depth = 5)
  gc_frame_newslot(call1906);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1908 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1907);
// compiled call node returning call1908 (depth = 6)
// compiled member node returning call1908 (depth = 5)
  gc_frame_newslot(call1908);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blockNode (depth = 5)
  params[0] = call1906;
  params[1] = call1908;
  partcv[0] = 2;
  Object call1909 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1904);
// compiled call node returning call1909 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1910 = callmethod(call1909, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compiled call node returning call1910 (depth = 3)
  gc_frame_end(frame);
  return call1910;
}
Object meth_ast_shallowCopyFieldsFrom1911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1912 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call1913 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1912);
// compiled call node returning call1913 (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1914 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1916 = callmethod(*var_other, "matchingPattern",
    1, partcv, params);
  gc_frame_end(callframe1915);
// compiled call node returning call1916 (depth = 5)
// compiled member node returning call1916 (depth = 4)
  gc_frame_newslot(call1916);
// call case 4: self request
  params[0] = call1916;
  partcv[0] = 1;
  Object call1917 = callmethodflags(self, "matchingPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1914);
// compiled call node returning call1917 (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1918 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call1920 = callmethod(*var_other, "extraRuntimeData",
    1, partcv, params);
  gc_frame_end(callframe1919);
// compiled call node returning call1920 (depth = 5)
// compiled member node returning call1920 (depth = 4)
  gc_frame_newslot(call1920);
// call case 4: self request
  params[0] = call1920;
  partcv[0] = 1;
  Object call1921 = callmethodflags(self, "extraRuntimeData:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1918);
// compiled call node returning call1921 (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply1935(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object *var_ancestorChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1936 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_patternMarkVisitor (depth = 6)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile call node (depth = 6)
  int callframe1937 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ancestorChain (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1938 = callmethod(*var_ancestorChain, "with",
    1, partcv, params);
  gc_frame_end(callframe1937);
// compiled call node returning call1938 (depth = 6)
  gc_frame_newslot(call1938);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  params[0] = *var_patternMarkVisitor;
  params[1] = call1938;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1939 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1936);
// compiled call node returning call1939 (depth = 5)
  gc_frame_end(frame);
  return call1939;
}
Object meth_ast_new1485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1486 = alloc_userobj2(27,24, objclass1486);
  gc_frame_newslot(obj1486);
if (objclass1486 == NULL) {
  glfree(obj1486->class->name);
  obj1486->class->name = "blockNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1486, self, 0);
  addmethodreal(obj1486,"outer", &reader_ast_outer_1487);
  Object oldself1486 = self;
  struct StackFrameObject *oldstackframe1486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1486);
  gc_frame_newslot((Object)stackframe);
  self = obj1486;
  Object *oldselfslot1486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1486 = (*(struct UserObject *)self).data[0], lowerouter1486 = thisouter1486;
  if (inheritingObject1486) {
    struct UserObject *inho1486 = (struct UserObject *)inheritingObject1486;
    while (inho1486->super != GraceDefaultObject) inho1486 = (struct UserObject *)inho1486->super;
    inho1486->super = obj1486;
    self = inheritingObject1486;
    *selfslot = self;
    lowerouter1486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1486;
  }
if (objclass1486 == NULL) {
  Method *reader1488 = addmethodrealflags(obj1486, "kind",&reader_ast_kind_1488, MFLAG_DEF);
  reader1488->definitionModule = modulename;
  reader1488->definitionLine = 294;
}
adddatum2(obj1486, alloc_Undefined(), 1);
if (objclass1486 == NULL) {
  Method *reader1489 = addmethodrealflags(obj1486, "value",&reader_ast_value_1489, MFLAG_DEF);
  reader1489->definitionModule = modulename;
  reader1489->definitionLine = 295;
}
adddatum2(obj1486, alloc_Undefined(), 2);
if (objclass1486 == NULL) {
  Method *reader1490 = addmethodrealflags(obj1486, "params",&reader_ast_params_1490, 0);
  Method *writer1490 = addmethodrealflags(obj1486, "params:=",&writer_ast_params_1490, 0);
  reader1490->definitionModule = modulename;
  writer1490->definitionModule = modulename;
  reader1490->definitionLine = 296;
  writer1490->definitionLine = 296;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 3);
if (objclass1486 == NULL) {
  Method *reader1491 = addmethodrealflags(obj1486, "body",&reader_ast_body_1491, 0);
  Method *writer1491 = addmethodrealflags(obj1486, "body:=",&writer_ast_body_1491, 0);
  reader1491->definitionModule = modulename;
  writer1491->definitionModule = modulename;
  reader1491->definitionLine = 297;
  writer1491->definitionLine = 297;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 4);
if (objclass1486 == NULL) {
  Method *reader1492 = addmethodrealflags(obj1486, "selfclosure",&reader_ast_selfclosure_1492, MFLAG_DEF);
  reader1492->definitionModule = modulename;
  reader1492->definitionLine = 298;
}
adddatum2(obj1486, alloc_Undefined(), 5);
if (objclass1486 == NULL) {
  Method *reader1493 = addmethodrealflags(obj1486, "matchingPattern",&reader_ast_matchingPattern_1493, 0);
  Method *writer1493 = addmethodrealflags(obj1486, "matchingPattern:=",&writer_ast_matchingPattern_1493, 0);
  reader1493->definitionModule = modulename;
  writer1493->definitionModule = modulename;
  reader1493->definitionLine = 299;
  writer1493->definitionLine = 299;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 6);
if (objclass1486 == NULL) {
  Method *reader1494 = addmethodrealflags(obj1486, "extraRuntimeData",&reader_ast_extraRuntimeData_1494, 0);
  Method *writer1494 = addmethodrealflags(obj1486, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1494, 0);
  reader1494->definitionModule = modulename;
  writer1494->definitionModule = modulename;
  reader1494->definitionLine = 300;
  writer1494->definitionLine = 300;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1495 = (struct UserObject*)obj1486;
  uo1495->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1495 = addmethod2pos(obj1486, "isBlock", &meth_ast_isBlock1495, 8);
  int argcv_meth_ast_isBlock1495[] = {0};
  meth_meth_ast_isBlock1495->type = alloc_MethodType(1, argcv_meth_ast_isBlock1495);
  meth_meth_ast_isBlock1495->definitionModule = modulename;
  meth_meth_ast_isBlock1495->definitionLine = 304;
// method "isEmpty"
  struct UserObject *uo1497 = (struct UserObject*)obj1486;
  uo1497->data[9] = emptyclosure;
  Method *meth_meth_ast_isEmpty1497 = addmethod2pos(obj1486, "isEmpty", &meth_ast_isEmpty1497, 9);
  int argcv_meth_ast_isEmpty1497[] = {0};
  meth_meth_ast_isEmpty1497->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1497);
  meth_meth_ast_isEmpty1497->definitionModule = modulename;
  meth_meth_ast_isEmpty1497->definitionLine = 305;
// method "isntEmpty"
  struct UserObject *uo1506 = (struct UserObject*)obj1486;
  uo1506->data[10] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1506 = addmethod2pos(obj1486, "isntEmpty", &meth_ast_isntEmpty1506, 10);
  int argcv_meth_ast_isntEmpty1506[] = {0};
  meth_meth_ast_isntEmpty1506->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1506);
  meth_meth_ast_isntEmpty1506->definitionModule = modulename;
  meth_meth_ast_isntEmpty1506->definitionLine = 306;
// method "scope:="
  struct UserObject *uo1515 = (struct UserObject*)obj1486;
  uo1515->data[11] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1515 = addmethod2pos(obj1486, "scope:=", &meth_ast_scope_58__61_1515, 11);
  int argcv_meth_ast_scope_58__61_1515[] = {1};
  meth_meth_ast_scope_58__61_1515->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1515);
  meth_meth_ast_scope_58__61_1515->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1515->definitionLine = 307;
// method "declarationKindWithAncestors"
  block_savedest(obj1486);
  Object closure1520 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure1520, stackframe);
  addtoclosure(closure1520, var_k);
  struct UserObject *uo1520 = (struct UserObject*)obj1486;
  uo1520->data[12] = (Object)closure1520;
  Method *meth_meth_ast_declarationKindWithAncestors1520 = addmethod2pos(obj1486, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1520, 12);
  int argcv_meth_ast_declarationKindWithAncestors1520[] = {1};
  meth_meth_ast_declarationKindWithAncestors1520->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1520);
  meth_meth_ast_declarationKindWithAncestors1520->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1520->definitionLine = 313;
// method "isMatchingBlock"
  struct UserObject *uo1523 = (struct UserObject*)obj1486;
  uo1523->data[13] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1523 = addmethod2pos(obj1486, "isMatchingBlock", &meth_ast_isMatchingBlock1523, 13);
  int argcv_meth_ast_isMatchingBlock1523[] = {0};
  meth_meth_ast_isMatchingBlock1523->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1523);
  meth_meth_ast_isMatchingBlock1523->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1523->definitionLine = 314;
// method "returnsObject"
  struct UserObject *uo1532 = (struct UserObject*)obj1486;
  uo1532->data[14] = emptyclosure;
  Method *meth_meth_ast_returnsObject1532 = addmethod2pos(obj1486, "returnsObject", &meth_ast_returnsObject1532, 14);
  int argcv_meth_ast_returnsObject1532[] = {0};
  meth_meth_ast_returnsObject1532->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1532);
  meth_meth_ast_returnsObject1532->definitionModule = modulename;
  meth_meth_ast_returnsObject1532->definitionLine = 315;
// method "returnedObjectScope"
  struct UserObject *uo1553 = (struct UserObject*)obj1486;
  uo1553->data[15] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1553 = addmethod2pos(obj1486, "returnedObjectScope", &meth_ast_returnedObjectScope1553, 15);
  int argcv_meth_ast_returnedObjectScope1553[] = {0};
  meth_meth_ast_returnedObjectScope1553->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1553);
  meth_meth_ast_returnedObjectScope1553->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1553->definitionLine = 318;
// method "parametersDo"
  struct UserObject *uo1560 = (struct UserObject*)obj1486;
  uo1560->data[16] = emptyclosure;
  Method *meth_meth_ast_parametersDo1560 = addmethod2pos(obj1486, "parametersDo", &meth_ast_parametersDo1560, 16);
  int argcv_meth_ast_parametersDo1560[] = {1};
  meth_meth_ast_parametersDo1560->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1560);
  meth_meth_ast_parametersDo1560->definitionModule = modulename;
  meth_meth_ast_parametersDo1560->definitionLine = 322;
// method "accept()from"
  struct UserObject *uo1565 = (struct UserObject*)obj1486;
  uo1565->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1565 = addmethod2pos(obj1486, "accept()from", &meth_ast_accept_40__41_from1565, 17);
  int argcv_meth_ast_accept_40__41_from1565[] = {1, 1};
  meth_meth_ast_accept_40__41_from1565->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1565);
  meth_meth_ast_accept_40__41_from1565->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1565->definitionLine = 325;
// method "map()ancestors"
  struct UserObject *uo1600 = (struct UserObject*)obj1486;
  uo1600->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1600 = addmethod2pos(obj1486, "map()ancestors", &meth_ast_map_40__41_ancestors1600, 18);
  int argcv_meth_ast_map_40__41_ancestors1600[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1600->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1600);
  meth_meth_ast_map_40__41_ancestors1600->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1600->definitionLine = 339;
// method "pretty"
  struct UserObject *uo1637 = (struct UserObject*)obj1486;
  uo1637->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty1637 = addmethod2pos(obj1486, "pretty", &meth_ast_pretty1637, 19);
  int argcv_meth_ast_pretty1637[] = {1};
  meth_meth_ast_pretty1637->type = alloc_MethodType(1, argcv_meth_ast_pretty1637);
  meth_meth_ast_pretty1637->definitionModule = modulename;
  meth_meth_ast_pretty1637->definitionLine = 347;
// method "toGrace"
  struct UserObject *uo1767 = (struct UserObject*)obj1486;
  uo1767->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace1767 = addmethod2pos(obj1486, "toGrace", &meth_ast_toGrace1767, 20);
  int argcv_meth_ast_toGrace1767[] = {1};
  meth_meth_ast_toGrace1767->type = alloc_MethodType(1, argcv_meth_ast_toGrace1767);
meth_meth_ast_toGrace1767->type->types[0] = type_Number;
meth_meth_ast_toGrace1767->type->names[0] = "depth";
  meth_meth_ast_toGrace1767->definitionModule = modulename;
  meth_meth_ast_toGrace1767->definitionLine = 369;
// method "shallowCopy"
  block_savedest(obj1486);
  Object closure1902 = createclosure(1, "shallowCopy");
  setclosureframe(closure1902, stackframe);
  addtoclosure(closure1902, var_blockNode);
  struct UserObject *uo1902 = (struct UserObject*)obj1486;
  uo1902->data[21] = (Object)closure1902;
  Method *meth_meth_ast_shallowCopy1902 = addmethod2pos(obj1486, "shallowCopy", &meth_ast_shallowCopy1902, 21);
  int argcv_meth_ast_shallowCopy1902[] = {0};
  meth_meth_ast_shallowCopy1902->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1902);
  meth_meth_ast_shallowCopy1902->definitionModule = modulename;
  meth_meth_ast_shallowCopy1902->definitionLine = 397;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1911 = (struct UserObject*)obj1486;
  uo1911->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1911 = addmethod2pos(obj1486, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1911, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom1911[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1911->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1911);
  meth_meth_ast_shallowCopyFieldsFrom1911->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1911->definitionLine = 400;
  sourceObject = obj1486;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1922 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1923 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1924 = gc_frame_new();
// call case 3: self.outer request
  Object call1925 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1924);
// compiled call node returning call1925 (depth = 7)
// compiled member node returning call1925 (depth = 6)
  partcv[0] = 0;
  Object call1926 = callmethodflags(call1925, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1923);
// compiled call node returning call1926 (depth = 5)
// compiled member node returning call1926 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1927 = callmethodflags(call1926, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1922);
// compiled call node returning call1927 (depth = 3)
  struct UserObject *obj1486_uo = (struct UserObject *)obj1486;
  obj1486_uo->super = call1927;
  sourceObject = obj1486;
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1928 == NULL) {
    strlit1928 = alloc_String("block");
    gc_root(strlit1928);
  }
// compiled string node returning strlit1928 (depth = 3)
  adddatum2(obj1486, strlit1928, 1);
  sourceObject = obj1486;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1929 == NULL) {
    strlit1929 = alloc_String("block");
    gc_root(strlit1929);
  }
// compiled string node returning strlit1929 (depth = 3)
  adddatum2(obj1486, strlit1929, 2);
  sourceObject = obj1486;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1486, *var_params_39_, 3);
  sourceObject = obj1486;
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1486, *var_body_39_, 4);
  sourceObject = obj1486;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1930 = alloc_Boolean(1);
// compiled identifier node returning bool1930 (depth = 3)
  adddatum2(obj1486, bool1930, 5);
  sourceObject = obj1486;
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1931 = alloc_Boolean(0);
// compiled identifier node returning bool1931 (depth = 3)
  adddatum2(obj1486, bool1931, 6);
  sourceObject = obj1486;
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1932 = alloc_Boolean(0);
// compiled identifier node returning bool1932 (depth = 3)
  adddatum2(obj1486, bool1932, 7);
  sourceObject = obj1486;
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1933 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block1934 = alloc_Block(NULL, NULL, "ast", 301);
  gc_frame_newslot(block1934);
// method "_apply"
  block_savedest(block1934);
  Object closure1935 = createclosure(3, "_apply");
  setclosureframe(closure1935, stackframe);
  addtoclosure(closure1935, var_patternMarkVisitor);
  addtoclosure(closure1935, var_ancestorChain);
  addtoclosure(closure1935, selfslot);
  struct UserObject *uo1935 = (struct UserObject*)block1934;
  uo1935->data[0] = (Object)closure1935;
  Method *meth_meth_ast__apply1935 = addmethod2pos(block1934, "_apply", &meth_ast__apply1935, 0);
  int argcv_meth_ast__apply1935[] = {1};
  meth_meth_ast__apply1935->type = alloc_MethodType(1, argcv_meth_ast__apply1935);
  meth_meth_ast__apply1935->definitionModule = modulename;
  meth_meth_ast__apply1935->definitionLine = 293;
// compiled block node returning block1934 (depth = 4)
  gc_frame_newslot(block1934);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1941 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1933);
// compiled call node returning call1941 (depth = 3)
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  objclass1486 = obj1486->class;
  objclass1486->definitionModule = modulename;
  objclass1486->definitionLine = 292;
  (*(struct UserObject *)self).data[0] = lowerouter1486;
  self = oldself1486;
  selfslot = oldselfslot1486;
  stackframe = oldstackframe1486;
  gc_frame_end(frame);
  return obj1486;
}
Object meth_ast_new1485_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[2];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_blockNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  Object *var_ancestorChain = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1486 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1486 = alloc_userobj2(27,24, objclass1486);
  gc_frame_newslot(obj1486);
if (objclass1486 == NULL) {
  glfree(obj1486->class->name);
  obj1486->class->name = "blockNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1486, self, 0);
  addmethodreal(obj1486,"outer", &reader_ast_outer_1487);
  Object oldself1486 = self;
  struct StackFrameObject *oldstackframe1486 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1486);
  gc_frame_newslot((Object)stackframe);
  self = obj1486;
  Object *oldselfslot1486 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1486 = (*(struct UserObject *)self).data[0], lowerouter1486 = thisouter1486;
  if (inheritingObject1486) {
    struct UserObject *inho1486 = (struct UserObject *)inheritingObject1486;
    while (inho1486->super != GraceDefaultObject) inho1486 = (struct UserObject *)inho1486->super;
    inho1486->super = obj1486;
    self = inheritingObject1486;
    *selfslot = self;
    lowerouter1486 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1486;
  }
if (objclass1486 == NULL) {
  Method *reader1488 = addmethodrealflags(obj1486, "kind",&reader_ast_kind_1488, MFLAG_DEF);
  reader1488->definitionModule = modulename;
  reader1488->definitionLine = 294;
}
adddatum2(obj1486, alloc_Undefined(), 1);
if (objclass1486 == NULL) {
  Method *reader1489 = addmethodrealflags(obj1486, "value",&reader_ast_value_1489, MFLAG_DEF);
  reader1489->definitionModule = modulename;
  reader1489->definitionLine = 295;
}
adddatum2(obj1486, alloc_Undefined(), 2);
if (objclass1486 == NULL) {
  Method *reader1490 = addmethodrealflags(obj1486, "params",&reader_ast_params_1490, 0);
  Method *writer1490 = addmethodrealflags(obj1486, "params:=",&writer_ast_params_1490, 0);
  reader1490->definitionModule = modulename;
  writer1490->definitionModule = modulename;
  reader1490->definitionLine = 296;
  writer1490->definitionLine = 296;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 3);
if (objclass1486 == NULL) {
  Method *reader1491 = addmethodrealflags(obj1486, "body",&reader_ast_body_1491, 0);
  Method *writer1491 = addmethodrealflags(obj1486, "body:=",&writer_ast_body_1491, 0);
  reader1491->definitionModule = modulename;
  writer1491->definitionModule = modulename;
  reader1491->definitionLine = 297;
  writer1491->definitionLine = 297;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 4);
if (objclass1486 == NULL) {
  Method *reader1492 = addmethodrealflags(obj1486, "selfclosure",&reader_ast_selfclosure_1492, MFLAG_DEF);
  reader1492->definitionModule = modulename;
  reader1492->definitionLine = 298;
}
adddatum2(obj1486, alloc_Undefined(), 5);
if (objclass1486 == NULL) {
  Method *reader1493 = addmethodrealflags(obj1486, "matchingPattern",&reader_ast_matchingPattern_1493, 0);
  Method *writer1493 = addmethodrealflags(obj1486, "matchingPattern:=",&writer_ast_matchingPattern_1493, 0);
  reader1493->definitionModule = modulename;
  writer1493->definitionModule = modulename;
  reader1493->definitionLine = 299;
  writer1493->definitionLine = 299;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 6);
if (objclass1486 == NULL) {
  Method *reader1494 = addmethodrealflags(obj1486, "extraRuntimeData",&reader_ast_extraRuntimeData_1494, 0);
  Method *writer1494 = addmethodrealflags(obj1486, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1494, 0);
  reader1494->definitionModule = modulename;
  writer1494->definitionModule = modulename;
  reader1494->definitionLine = 300;
  writer1494->definitionLine = 300;
}
obj1486->flags |= OFLAG_MUTABLE;
adddatum2(obj1486, alloc_Undefined(), 7);
// method "isBlock"
  struct UserObject *uo1495 = (struct UserObject*)obj1486;
  uo1495->data[8] = emptyclosure;
  Method *meth_meth_ast_isBlock1495 = addmethod2pos(obj1486, "isBlock", &meth_ast_isBlock1495, 8);
  int argcv_meth_ast_isBlock1495[] = {0};
  meth_meth_ast_isBlock1495->type = alloc_MethodType(1, argcv_meth_ast_isBlock1495);
  meth_meth_ast_isBlock1495->definitionModule = modulename;
  meth_meth_ast_isBlock1495->definitionLine = 304;
// method "isEmpty"
  struct UserObject *uo1497 = (struct UserObject*)obj1486;
  uo1497->data[9] = emptyclosure;
  Method *meth_meth_ast_isEmpty1497 = addmethod2pos(obj1486, "isEmpty", &meth_ast_isEmpty1497, 9);
  int argcv_meth_ast_isEmpty1497[] = {0};
  meth_meth_ast_isEmpty1497->type = alloc_MethodType(1, argcv_meth_ast_isEmpty1497);
  meth_meth_ast_isEmpty1497->definitionModule = modulename;
  meth_meth_ast_isEmpty1497->definitionLine = 305;
// method "isntEmpty"
  struct UserObject *uo1506 = (struct UserObject*)obj1486;
  uo1506->data[10] = emptyclosure;
  Method *meth_meth_ast_isntEmpty1506 = addmethod2pos(obj1486, "isntEmpty", &meth_ast_isntEmpty1506, 10);
  int argcv_meth_ast_isntEmpty1506[] = {0};
  meth_meth_ast_isntEmpty1506->type = alloc_MethodType(1, argcv_meth_ast_isntEmpty1506);
  meth_meth_ast_isntEmpty1506->definitionModule = modulename;
  meth_meth_ast_isntEmpty1506->definitionLine = 306;
// method "scope:="
  struct UserObject *uo1515 = (struct UserObject*)obj1486;
  uo1515->data[11] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_1515 = addmethod2pos(obj1486, "scope:=", &meth_ast_scope_58__61_1515, 11);
  int argcv_meth_ast_scope_58__61_1515[] = {1};
  meth_meth_ast_scope_58__61_1515->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_1515);
  meth_meth_ast_scope_58__61_1515->definitionModule = modulename;
  meth_meth_ast_scope_58__61_1515->definitionLine = 307;
// method "declarationKindWithAncestors"
  block_savedest(obj1486);
  Object closure1520 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure1520, stackframe);
  addtoclosure(closure1520, var_k);
  struct UserObject *uo1520 = (struct UserObject*)obj1486;
  uo1520->data[12] = (Object)closure1520;
  Method *meth_meth_ast_declarationKindWithAncestors1520 = addmethod2pos(obj1486, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors1520, 12);
  int argcv_meth_ast_declarationKindWithAncestors1520[] = {1};
  meth_meth_ast_declarationKindWithAncestors1520->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors1520);
  meth_meth_ast_declarationKindWithAncestors1520->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors1520->definitionLine = 313;
// method "isMatchingBlock"
  struct UserObject *uo1523 = (struct UserObject*)obj1486;
  uo1523->data[13] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1523 = addmethod2pos(obj1486, "isMatchingBlock", &meth_ast_isMatchingBlock1523, 13);
  int argcv_meth_ast_isMatchingBlock1523[] = {0};
  meth_meth_ast_isMatchingBlock1523->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1523);
  meth_meth_ast_isMatchingBlock1523->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1523->definitionLine = 314;
// method "returnsObject"
  struct UserObject *uo1532 = (struct UserObject*)obj1486;
  uo1532->data[14] = emptyclosure;
  Method *meth_meth_ast_returnsObject1532 = addmethod2pos(obj1486, "returnsObject", &meth_ast_returnsObject1532, 14);
  int argcv_meth_ast_returnsObject1532[] = {0};
  meth_meth_ast_returnsObject1532->type = alloc_MethodType(1, argcv_meth_ast_returnsObject1532);
  meth_meth_ast_returnsObject1532->definitionModule = modulename;
  meth_meth_ast_returnsObject1532->definitionLine = 315;
// method "returnedObjectScope"
  struct UserObject *uo1553 = (struct UserObject*)obj1486;
  uo1553->data[15] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope1553 = addmethod2pos(obj1486, "returnedObjectScope", &meth_ast_returnedObjectScope1553, 15);
  int argcv_meth_ast_returnedObjectScope1553[] = {0};
  meth_meth_ast_returnedObjectScope1553->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope1553);
  meth_meth_ast_returnedObjectScope1553->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope1553->definitionLine = 318;
// method "parametersDo"
  struct UserObject *uo1560 = (struct UserObject*)obj1486;
  uo1560->data[16] = emptyclosure;
  Method *meth_meth_ast_parametersDo1560 = addmethod2pos(obj1486, "parametersDo", &meth_ast_parametersDo1560, 16);
  int argcv_meth_ast_parametersDo1560[] = {1};
  meth_meth_ast_parametersDo1560->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1560);
  meth_meth_ast_parametersDo1560->definitionModule = modulename;
  meth_meth_ast_parametersDo1560->definitionLine = 322;
// method "accept()from"
  struct UserObject *uo1565 = (struct UserObject*)obj1486;
  uo1565->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1565 = addmethod2pos(obj1486, "accept()from", &meth_ast_accept_40__41_from1565, 17);
  int argcv_meth_ast_accept_40__41_from1565[] = {1, 1};
  meth_meth_ast_accept_40__41_from1565->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1565);
  meth_meth_ast_accept_40__41_from1565->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1565->definitionLine = 325;
// method "map()ancestors"
  struct UserObject *uo1600 = (struct UserObject*)obj1486;
  uo1600->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1600 = addmethod2pos(obj1486, "map()ancestors", &meth_ast_map_40__41_ancestors1600, 18);
  int argcv_meth_ast_map_40__41_ancestors1600[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1600->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1600);
  meth_meth_ast_map_40__41_ancestors1600->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1600->definitionLine = 339;
// method "pretty"
  struct UserObject *uo1637 = (struct UserObject*)obj1486;
  uo1637->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty1637 = addmethod2pos(obj1486, "pretty", &meth_ast_pretty1637, 19);
  int argcv_meth_ast_pretty1637[] = {1};
  meth_meth_ast_pretty1637->type = alloc_MethodType(1, argcv_meth_ast_pretty1637);
  meth_meth_ast_pretty1637->definitionModule = modulename;
  meth_meth_ast_pretty1637->definitionLine = 347;
// method "toGrace"
  struct UserObject *uo1767 = (struct UserObject*)obj1486;
  uo1767->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace1767 = addmethod2pos(obj1486, "toGrace", &meth_ast_toGrace1767, 20);
  int argcv_meth_ast_toGrace1767[] = {1};
  meth_meth_ast_toGrace1767->type = alloc_MethodType(1, argcv_meth_ast_toGrace1767);
meth_meth_ast_toGrace1767->type->types[0] = type_Number;
meth_meth_ast_toGrace1767->type->names[0] = "depth";
  meth_meth_ast_toGrace1767->definitionModule = modulename;
  meth_meth_ast_toGrace1767->definitionLine = 369;
// method "shallowCopy"
  block_savedest(obj1486);
  Object closure1902 = createclosure(1, "shallowCopy");
  setclosureframe(closure1902, stackframe);
  addtoclosure(closure1902, var_blockNode);
  struct UserObject *uo1902 = (struct UserObject*)obj1486;
  uo1902->data[21] = (Object)closure1902;
  Method *meth_meth_ast_shallowCopy1902 = addmethod2pos(obj1486, "shallowCopy", &meth_ast_shallowCopy1902, 21);
  int argcv_meth_ast_shallowCopy1902[] = {0};
  meth_meth_ast_shallowCopy1902->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy1902);
  meth_meth_ast_shallowCopy1902->definitionModule = modulename;
  meth_meth_ast_shallowCopy1902->definitionLine = 397;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo1911 = (struct UserObject*)obj1486;
  uo1911->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom1911 = addmethod2pos(obj1486, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom1911, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom1911[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom1911->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom1911);
  meth_meth_ast_shallowCopyFieldsFrom1911->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom1911->definitionLine = 400;
  sourceObject = obj1486;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1922 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1923 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1924 = gc_frame_new();
// call case 3: self.outer request
  Object call1925 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1924);
// compiled call node returning call1925 (depth = 7)
// compiled member node returning call1925 (depth = 6)
  partcv[0] = 0;
  Object call1926 = callmethodflags(call1925, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1923);
// compiled call node returning call1926 (depth = 5)
// compiled member node returning call1926 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1927 = callmethodflags(call1926, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1922);
// compiled call node returning call1927 (depth = 3)
  struct UserObject *obj1486_uo = (struct UserObject *)obj1486;
  obj1486_uo->super = call1927;
  sourceObject = obj1486;
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1928 == NULL) {
    strlit1928 = alloc_String("block");
    gc_root(strlit1928);
  }
// compiled string node returning strlit1928 (depth = 3)
  adddatum2(obj1486, strlit1928, 1);
  sourceObject = obj1486;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1929 == NULL) {
    strlit1929 = alloc_String("block");
    gc_root(strlit1929);
  }
// compiled string node returning strlit1929 (depth = 3)
  adddatum2(obj1486, strlit1929, 2);
  sourceObject = obj1486;
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj1486, *var_params_39_, 3);
  sourceObject = obj1486;
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj1486, *var_body_39_, 4);
  sourceObject = obj1486;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1930 = alloc_Boolean(1);
// compiled identifier node returning bool1930 (depth = 3)
  adddatum2(obj1486, bool1930, 5);
  sourceObject = obj1486;
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1931 = alloc_Boolean(0);
// compiled identifier node returning bool1931 (depth = 3)
  adddatum2(obj1486, bool1931, 6);
  sourceObject = obj1486;
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1932 = alloc_Boolean(0);
// compiled identifier node returning bool1932 (depth = 3)
  adddatum2(obj1486, bool1932, 7);
  sourceObject = obj1486;
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1933 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 4)
  Object block1934 = alloc_Block(NULL, NULL, "ast", 301);
  gc_frame_newslot(block1934);
// method "_apply"
  block_savedest(block1934);
  Object closure1935 = createclosure(3, "_apply");
  setclosureframe(closure1935, stackframe);
  addtoclosure(closure1935, var_patternMarkVisitor);
  addtoclosure(closure1935, var_ancestorChain);
  addtoclosure(closure1935, selfslot);
  struct UserObject *uo1935 = (struct UserObject*)block1934;
  uo1935->data[0] = (Object)closure1935;
  Method *meth_meth_ast__apply1935 = addmethod2pos(block1934, "_apply", &meth_ast__apply1935, 0);
  int argcv_meth_ast__apply1935[] = {1};
  meth_meth_ast__apply1935->type = alloc_MethodType(1, argcv_meth_ast__apply1935);
  meth_meth_ast__apply1935->definitionModule = modulename;
  meth_meth_ast__apply1935->definitionLine = 293;
// compiled block node returning block1934 (depth = 4)
  gc_frame_newslot(block1934);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1941 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1933);
// compiled call node returning call1941 (depth = 3)
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  sourceObject = obj1486;
  objclass1486 = obj1486->class;
  objclass1486->definitionModule = modulename;
  objclass1486->definitionLine = 292;
  (*(struct UserObject *)self).data[0] = lowerouter1486;
  self = oldself1486;
  selfslot = oldselfslot1486;
  stackframe = oldstackframe1486;
  gc_frame_end(frame);
  return obj1486;
}
Object meth_ast_blockNode1943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_isSimple1953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1954 = alloc_Boolean(0);
// compiled identifier node returning bool1954 (depth = 3)
  gc_frame_end(frame);
  return bool1954;
}
Object meth_ast__apply1969(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1970 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1971 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1970);
// compiled call node returning call1971 (depth = 6)
  gc_frame_end(frame);
  return call1971;
}
Object meth_ast_accept_40__41_from1955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1957 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1958 = callmethod(*var_visitor, "visitTryCatch()up",
    2, partcv, params);
  gc_frame_end(callframe1957);
// compiled call node returning call1958 (depth = 4)
  Object if1956 = done;
  if (istrue(call1958)) {
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1959 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call1960 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1959);
// compiled call node returning call1960 (depth = 5)
  *var_newChain = call1960;
  if (call1960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1961 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1962 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1963 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1962);
// compiled call node returning call1963 (depth = 6)
// compiled member node returning call1963 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1964 = callmethod(call1963, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1961);
// compiled call node returning call1964 (depth = 4)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1965 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1966 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1967 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1966);
// compiled call node returning call1967 (depth = 6)
// compiled member node returning call1967 (depth = 5)
  gc_frame_newslot(call1967);
// starting to compile block node (depth = 5)
  Object block1968 = alloc_Block(NULL, NULL, "ast", 421);
  gc_frame_newslot(block1968);
// method "_apply"
  block_savedest(block1968);
  Object closure1969 = createclosure(3, "_apply");
  setclosureframe(closure1969, stackframe);
  addtoclosure(closure1969, var_visitor);
  addtoclosure(closure1969, var_newChain);
  addtoclosure(closure1969, selfslot);
  struct UserObject *uo1969 = (struct UserObject*)block1968;
  uo1969->data[0] = (Object)closure1969;
  Method *meth_meth_ast__apply1969 = addmethod2pos(block1968, "_apply", &meth_ast__apply1969, 0);
  int argcv_meth_ast__apply1969[] = {1};
  meth_meth_ast__apply1969->type = alloc_MethodType(1, argcv_meth_ast__apply1969);
  meth_meth_ast__apply1969->definitionModule = modulename;
  meth_meth_ast__apply1969->definitionLine = 421;
// compiled block node returning block1968 (depth = 5)
  gc_frame_newslot(block1968);
// call case 5: prelude request
  params[0] = call1967;
  params[1] = block1968;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1973 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1965);
// compiled call node returning call1973 (depth = 4)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1976 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1977 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1976);
// compiled call node returning call1977 (depth = 7)
// compiled member node returning call1977 (depth = 6)
  int op_slot_right_1975 = gc_frame_newslot(call1977);
// starting to compile identifier node (depth = 6)
  Object bool1979 = alloc_Boolean(0);
// compiled identifier node returning bool1979 (depth = 6)
  int op_slot_left_1975 = gc_frame_newslot(bool1979);
  params[0] = call1977;
  partcv[0] = 1;
  Object opresult1980 = callmethod(bool1979, "≠", 1, partcv, params);
// compiled op node returning opresult1980 (depth = 5)
  Object if1974 = done;
  if (istrue(opresult1980)) {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1981 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1982 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1983 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1982);
// compiled call node returning call1983 (depth = 7)
// compiled member node returning call1983 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1984 = callmethod(call1983, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1981);
// compiled call node returning call1984 (depth = 5)
    gc_frame_newslot(call1984);
    if1974 = call1984;
  } else {
  }
// compiled if node returning if1974 (depth = 4)
    gc_frame_newslot(if1974);
    if1956 = if1974;
  } else {
  }
// compiled if node returning if1956 (depth = 3)
  gc_frame_end(frame);
  return if1956;
}
Object meth_ast_map_40__41_ancestors1985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1986 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1987 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1986);
// compiled call node returning call1987 (depth = 5)
// compiled member node returning call1987 (depth = 4)
  *var_n = call1987;
  if (call1987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1988 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1989 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe1988);
// compiled call node returning call1989 (depth = 4)
  *var_newChain = call1989;
  if (call1989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1990 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1991 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1992 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1993 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1992);
// compiled call node returning call1993 (depth = 6)
// compiled member node returning call1993 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1994 = callmethod(call1993, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe1991);
// compiled call node returning call1994 (depth = 4)
  gc_frame_newslot(call1994);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call1994;
  partcv[0] = 1;
  Object call1995 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1990);
// compiled call node returning call1995 (depth = 3)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1996 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1997 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1999 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1998);
// compiled call node returning call1999 (depth = 6)
// compiled member node returning call1999 (depth = 5)
  gc_frame_newslot(call1999);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2000 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2001 = gc_frame_new();
// call case 3: self.outer request
  Object call2002 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2001);
// compiled call node returning call2002 (depth = 8)
// compiled member node returning call2002 (depth = 7)
  partcv[0] = 0;
  Object call2003 = callmethodflags(call2002, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2000);
// compiled call node returning call2003 (depth = 6)
// compiled member node returning call2003 (depth = 5)
  params[0] = call1999;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2004 = callmethodflags(call2003, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1997);
// compiled call node returning call2004 (depth = 4)
  gc_frame_newslot(call2004);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2004;
  partcv[0] = 1;
  Object call2005 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe1996);
// compiled call node returning call2005 (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2006 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2007 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2008 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2009 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2008);
// compiled call node returning call2009 (depth = 6)
// compiled member node returning call2009 (depth = 5)
  gc_frame_newslot(call2009);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2010 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2011 = gc_frame_new();
// call case 3: self.outer request
  Object call2012 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2011);
// compiled call node returning call2012 (depth = 8)
// compiled member node returning call2012 (depth = 7)
  partcv[0] = 0;
  Object call2013 = callmethodflags(call2012, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2010);
// compiled call node returning call2013 (depth = 6)
// compiled member node returning call2013 (depth = 5)
  params[0] = call2009;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2014 = callmethodflags(call2013, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2007);
// compiled call node returning call2014 (depth = 4)
  gc_frame_newslot(call2014);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2014;
  partcv[0] = 1;
  Object call2015 = callmethod(*var_n, "finally:=",
    1, partcv, params);
  gc_frame_end(callframe2006);
// compiled call node returning call2015 (depth = 3)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2016 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2017 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2016);
// compiled call node returning call2017 (depth = 3)
  gc_frame_end(frame);
  return call2017;
}
Object meth_ast__apply2026(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2028 == NULL) {
    strlit2028 = alloc_String("  ");
    gc_root(strlit2028);
  }
// compiled string node returning strlit2028 (depth = 7)
  int op_slot_right_2027 = gc_frame_newslot(strlit2028);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2027 = gc_frame_newslot(*var_spc);
  params[0] = strlit2028;
  partcv[0] = 1;
  Object opresult2030 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2030 (depth = 6)
  *var_spc = opresult2030;
  if (opresult2030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2063(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2066 == NULL) {
    strlit2066 = alloc_String("");
    gc_root(strlit2066);
  }
// compiled string node returning strlit2066 (depth = 8)
  int op_slot_right_2065 = gc_frame_newslot(strlit2066);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2069 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2071 = alloc_Float64(2);
// compiled num node returning num2071 (depth = 11)
  int op_slot_right_2070 = gc_frame_newslot(num2071);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2070 = gc_frame_newslot(*var_depth);
  params[0] = num2071;
  partcv[0] = 1;
  Object sum2073 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2073 (depth = 10)
  gc_frame_newslot(sum2073);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2073;
  partcv[0] = 1;
  Object call2074 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2074 (depth = 9)
  int op_slot_right_2068 = gc_frame_newslot(call2074);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2077 == NULL) {
    strlit2077 = alloc_String("  ");
    gc_root(strlit2077);
  }
// compiled string node returning strlit2077 (depth = 10)
  int op_slot_right_2076 = gc_frame_newslot(strlit2077);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2079 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2082 == NULL) {
    strlit2082 = alloc_String("Case:""\x0a""");
    gc_root(strlit2082);
  }
// compiled string node returning strlit2082 (depth = 12)
  int op_slot_right_2081 = gc_frame_newslot(strlit2082);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2084 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2086 == NULL) {
    strlit2086 = alloc_String("""\x0a""");
    gc_root(strlit2086);
  }
// compiled string node returning strlit2086 (depth = 13)
  int op_slot_left_2084 = gc_frame_newslot(strlit2086);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2087 = callmethod(strlit2086, "++", 1, partcv, params);
// compiled op node returning opresult2087 (depth = 12)
  int op_slot_left_2081 = gc_frame_newslot(opresult2087);
  params[0] = strlit2082;
  partcv[0] = 1;
  Object opresult2088 = callmethod(opresult2087, "++", 1, partcv, params);
// compiled op node returning opresult2088 (depth = 11)
  int op_slot_left_2079 = gc_frame_newslot(opresult2088);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2089 = callmethod(opresult2088, "++", 1, partcv, params);
// compiled op node returning opresult2089 (depth = 10)
  int op_slot_left_2076 = gc_frame_newslot(opresult2089);
  params[0] = strlit2077;
  partcv[0] = 1;
  Object opresult2090 = callmethod(opresult2089, "++", 1, partcv, params);
// compiled op node returning opresult2090 (depth = 9)
  int op_slot_left_2068 = gc_frame_newslot(opresult2090);
  params[0] = call2074;
  partcv[0] = 1;
  Object opresult2091 = callmethod(opresult2090, "++", 1, partcv, params);
// compiled op node returning opresult2091 (depth = 8)
  int op_slot_left_2065 = gc_frame_newslot(opresult2091);
  params[0] = strlit2066;
  partcv[0] = 1;
  Object opresult2092 = callmethod(opresult2091, "++", 1, partcv, params);
// compiled op node returning opresult2092 (depth = 7)
  int op_slot_right_2064 = gc_frame_newslot(opresult2092);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2064 = gc_frame_newslot(*var_s);
  params[0] = opresult2092;
  partcv[0] = 1;
  Object opresult2094 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2094 (depth = 6)
  *var_s = opresult2094;
  if (opresult2094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 4)
  *var_spc = strlit2019;
  if (strlit2019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2020 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2021 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2023 = alloc_Float64(0);
// compiled num node returning num2023 (depth = 5)
  int op_slot_left_2021 = gc_frame_newslot(num2023);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2024 = callmethod(num2023, "..", 1, partcv, params);
// compiled op node returning opresult2024 (depth = 4)
  gc_frame_newslot(opresult2024);
// starting to compile block node (depth = 4)
  Object block2025 = alloc_Block(NULL, NULL, "ast", 439);
  gc_frame_newslot(block2025);
// method "_apply"
  block_savedest(block2025);
  Object closure2026 = createclosure(2, "_apply");
  setclosureframe(closure2026, stackframe);
  addtoclosure(closure2026, var_spc);
  addtoclosure(closure2026, selfslot);
  struct UserObject *uo2026 = (struct UserObject*)block2025;
  uo2026->data[0] = (Object)closure2026;
  Method *meth_meth_ast__apply2026 = addmethod2pos(block2025, "_apply", &meth_ast__apply2026, 0);
  int argcv_meth_ast__apply2026[] = {1};
  meth_meth_ast__apply2026->type = alloc_MethodType(1, argcv_meth_ast__apply2026);
  meth_meth_ast__apply2026->definitionModule = modulename;
  meth_meth_ast__apply2026->definitionLine = 434;
// compiled block node returning block2025 (depth = 4)
  gc_frame_newslot(block2025);
// call case 5: prelude request
  params[0] = opresult2024;
  params[1] = block2025;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2033 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2020);
// compiled call node returning call2033 (depth = 3)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2035 == NULL) {
    strlit2035 = alloc_String("""\x0a""");
    gc_root(strlit2035);
  }
// compiled string node returning strlit2035 (depth = 5)
  int op_slot_right_2034 = gc_frame_newslot(strlit2035);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2038 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2039 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2038);
// compiled call node returning call2039 (depth = 6)
  int op_slot_right_2037 = gc_frame_newslot(call2039);
// starting to compile string node (depth = 6)
  if (strlit2041 == NULL) {
    strlit2041 = alloc_String("");
    gc_root(strlit2041);
  }
// compiled string node returning strlit2041 (depth = 6)
  int op_slot_left_2037 = gc_frame_newslot(strlit2041);
  params[0] = call2039;
  partcv[0] = 1;
  Object opresult2042 = callmethod(strlit2041, "++", 1, partcv, params);
// compiled op node returning opresult2042 (depth = 5)
  int op_slot_left_2034 = gc_frame_newslot(opresult2042);
  params[0] = strlit2035;
  partcv[0] = 1;
  Object opresult2043 = callmethod(opresult2042, "++", 1, partcv, params);
// compiled op node returning opresult2043 (depth = 4)
  *var_s = opresult2043;
  if (opresult2043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2045 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2047 = alloc_Float64(2);
// compiled num node returning num2047 (depth = 7)
  int op_slot_right_2046 = gc_frame_newslot(num2047);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2046 = gc_frame_newslot(*var_depth);
  params[0] = num2047;
  partcv[0] = 1;
  Object sum2049 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2049 (depth = 6)
  gc_frame_newslot(sum2049);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2051 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2050);
// compiled call node returning call2051 (depth = 7)
// compiled member node returning call2051 (depth = 6)
  params[0] = sum2049;
  partcv[0] = 1;
  Object call2052 = callmethod(call2051, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2045);
// compiled call node returning call2052 (depth = 5)
  int op_slot_right_2044 = gc_frame_newslot(call2052);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2054 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2054 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2056 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2056 (depth = 5)
  int op_slot_left_2044 = gc_frame_newslot(opresult2056);
  params[0] = call2052;
  partcv[0] = 1;
  Object opresult2057 = callmethod(opresult2056, "++", 1, partcv, params);
// compiled op node returning opresult2057 (depth = 4)
  *var_s = opresult2057;
  if (opresult2057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2059 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2061 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2060);
// compiled call node returning call2061 (depth = 5)
// compiled member node returning call2061 (depth = 4)
  gc_frame_newslot(call2061);
// starting to compile block node (depth = 4)
  Object block2062 = alloc_Block(NULL, NULL, "ast", 444);
  gc_frame_newslot(block2062);
// method "_apply"
  block_savedest(block2062);
  Object closure2063 = createclosure(4, "_apply");
  setclosureframe(closure2063, stackframe);
  addtoclosure(closure2063, var_depth);
  addtoclosure(closure2063, var_spc);
  addtoclosure(closure2063, var_s);
  addtoclosure(closure2063, selfslot);
  struct UserObject *uo2063 = (struct UserObject*)block2062;
  uo2063->data[0] = (Object)closure2063;
  Method *meth_meth_ast__apply2063 = addmethod2pos(block2062, "_apply", &meth_ast__apply2063, 0);
  int argcv_meth_ast__apply2063[] = {1};
  meth_meth_ast__apply2063->type = alloc_MethodType(1, argcv_meth_ast__apply2063);
  meth_meth_ast__apply2063->definitionModule = modulename;
  meth_meth_ast__apply2063->definitionLine = 444;
// compiled block node returning block2062 (depth = 4)
  gc_frame_newslot(block2062);
// call case 5: prelude request
  params[0] = call2061;
  params[1] = block2062;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2097 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2059);
// compiled call node returning call2097 (depth = 3)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2101 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2100);
// compiled call node returning call2101 (depth = 6)
// compiled member node returning call2101 (depth = 5)
  int op_slot_right_2099 = gc_frame_newslot(call2101);
// starting to compile identifier node (depth = 5)
  Object bool2103 = alloc_Boolean(0);
// compiled identifier node returning bool2103 (depth = 5)
  int op_slot_left_2099 = gc_frame_newslot(bool2103);
  params[0] = call2101;
  partcv[0] = 1;
  Object opresult2104 = callmethod(bool2103, "≠", 1, partcv, params);
// compiled op node returning opresult2104 (depth = 4)
  Object if2098 = done;
  if (istrue(opresult2104)) {
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2107 == NULL) {
    strlit2107 = alloc_String("");
    gc_root(strlit2107);
  }
// compiled string node returning strlit2107 (depth = 7)
  int op_slot_right_2106 = gc_frame_newslot(strlit2107);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2110 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2112 = alloc_Float64(2);
// compiled num node returning num2112 (depth = 10)
  int op_slot_right_2111 = gc_frame_newslot(num2112);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2111 = gc_frame_newslot(*var_depth);
  params[0] = num2112;
  partcv[0] = 1;
  Object sum2114 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2114 (depth = 9)
  gc_frame_newslot(sum2114);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2115 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2116 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2115);
// compiled call node returning call2116 (depth = 10)
// compiled member node returning call2116 (depth = 9)
  params[0] = sum2114;
  partcv[0] = 1;
  Object call2117 = callmethod(call2116, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2110);
// compiled call node returning call2117 (depth = 8)
  int op_slot_right_2109 = gc_frame_newslot(call2117);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2120 == NULL) {
    strlit2120 = alloc_String("  ");
    gc_root(strlit2120);
  }
// compiled string node returning strlit2120 (depth = 9)
  int op_slot_right_2119 = gc_frame_newslot(strlit2120);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2122 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2125 == NULL) {
    strlit2125 = alloc_String("Finally:""\x0a""");
    gc_root(strlit2125);
  }
// compiled string node returning strlit2125 (depth = 11)
  int op_slot_right_2124 = gc_frame_newslot(strlit2125);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2127 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2129 == NULL) {
    strlit2129 = alloc_String("""\x0a""");
    gc_root(strlit2129);
  }
// compiled string node returning strlit2129 (depth = 12)
  int op_slot_left_2127 = gc_frame_newslot(strlit2129);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2130 = callmethod(strlit2129, "++", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 11)
  int op_slot_left_2124 = gc_frame_newslot(opresult2130);
  params[0] = strlit2125;
  partcv[0] = 1;
  Object opresult2131 = callmethod(opresult2130, "++", 1, partcv, params);
// compiled op node returning opresult2131 (depth = 10)
  int op_slot_left_2122 = gc_frame_newslot(opresult2131);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2132 = callmethod(opresult2131, "++", 1, partcv, params);
// compiled op node returning opresult2132 (depth = 9)
  int op_slot_left_2119 = gc_frame_newslot(opresult2132);
  params[0] = strlit2120;
  partcv[0] = 1;
  Object opresult2133 = callmethod(opresult2132, "++", 1, partcv, params);
// compiled op node returning opresult2133 (depth = 8)
  int op_slot_left_2109 = gc_frame_newslot(opresult2133);
  params[0] = call2117;
  partcv[0] = 1;
  Object opresult2134 = callmethod(opresult2133, "++", 1, partcv, params);
// compiled op node returning opresult2134 (depth = 7)
  int op_slot_left_2106 = gc_frame_newslot(opresult2134);
  params[0] = strlit2107;
  partcv[0] = 1;
  Object opresult2135 = callmethod(opresult2134, "++", 1, partcv, params);
// compiled op node returning opresult2135 (depth = 6)
  int op_slot_right_2105 = gc_frame_newslot(opresult2135);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2105 = gc_frame_newslot(*var_s);
  params[0] = opresult2135;
  partcv[0] = 1;
  Object opresult2137 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2137 (depth = 5)
  *var_s = opresult2137;
  if (opresult2137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2098 = done;
  } else {
  }
// compiled if node returning if2098 (depth = 3)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2151(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2153 == NULL) {
    strlit2153 = alloc_String("    ");
    gc_root(strlit2153);
  }
// compiled string node returning strlit2153 (depth = 7)
  int op_slot_right_2152 = gc_frame_newslot(strlit2153);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2152 = gc_frame_newslot(*var_spc);
  params[0] = strlit2153;
  partcv[0] = 1;
  Object opresult2155 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2155 (depth = 6)
  *var_spc = opresult2155;
  if (opresult2155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2179(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2181 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2183 = alloc_Float64(1);
// compiled num node returning num2183 (depth = 9)
  int op_slot_right_2182 = gc_frame_newslot(num2183);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2182 = gc_frame_newslot(*var_depth);
  params[0] = num2183;
  partcv[0] = 1;
  Object sum2185 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2185 (depth = 8)
  gc_frame_newslot(sum2185);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2185;
  partcv[0] = 1;
  Object call2186 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2181);
// compiled call node returning call2186 (depth = 7)
  int op_slot_right_2180 = gc_frame_newslot(call2186);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2189 == NULL) {
    strlit2189 = alloc_String("catch ");
    gc_root(strlit2189);
  }
// compiled string node returning strlit2189 (depth = 8)
  int op_slot_right_2188 = gc_frame_newslot(strlit2189);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2192 == NULL) {
    strlit2192 = alloc_String("    ");
    gc_root(strlit2192);
  }
// compiled string node returning strlit2192 (depth = 9)
  int op_slot_right_2191 = gc_frame_newslot(strlit2192);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2194 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2197 == NULL) {
    strlit2197 = alloc_String("""\x0a""");
    gc_root(strlit2197);
  }
// compiled string node returning strlit2197 (depth = 11)
  int op_slot_right_2196 = gc_frame_newslot(strlit2197);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2196 = gc_frame_newslot(*var_s);
  params[0] = strlit2197;
  partcv[0] = 1;
  Object opresult2199 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2199 (depth = 10)
  int op_slot_left_2194 = gc_frame_newslot(opresult2199);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2200 = callmethod(opresult2199, "++", 1, partcv, params);
// compiled op node returning opresult2200 (depth = 9)
  int op_slot_left_2191 = gc_frame_newslot(opresult2200);
  params[0] = strlit2192;
  partcv[0] = 1;
  Object opresult2201 = callmethod(opresult2200, "++", 1, partcv, params);
// compiled op node returning opresult2201 (depth = 8)
  int op_slot_left_2188 = gc_frame_newslot(opresult2201);
  params[0] = strlit2189;
  partcv[0] = 1;
  Object opresult2202 = callmethod(opresult2201, "++", 1, partcv, params);
// compiled op node returning opresult2202 (depth = 7)
  int op_slot_left_2180 = gc_frame_newslot(opresult2202);
  params[0] = call2186;
  partcv[0] = 1;
  Object opresult2203 = callmethod(opresult2202, "++", 1, partcv, params);
// compiled op node returning opresult2203 (depth = 6)
  *var_s = opresult2203;
  if (opresult2203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2140 == NULL) {
    strlit2140 = alloc_String("");
    gc_root(strlit2140);
  }
// compiled string node returning strlit2140 (depth = 4)
  *var_spc = strlit2140;
  if (strlit2140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2141 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2144 = alloc_Float64(1);
// compiled num node returning num2144 (depth = 6)
  int op_slot_right_2143 = gc_frame_newslot(num2144);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2143 = gc_frame_newslot(*var_depth);
  params[0] = num2144;
  partcv[0] = 1;
  Object diff2146 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2146 (depth = 5)
  int op_slot_right_2142 = gc_frame_newslot(diff2146);
// starting to compile num node (depth = 5)
  Object num2148 = alloc_Float64(0);
// compiled num node returning num2148 (depth = 5)
  int op_slot_left_2142 = gc_frame_newslot(num2148);
  params[0] = diff2146;
  partcv[0] = 1;
  Object opresult2149 = callmethod(num2148, "..", 1, partcv, params);
// compiled op node returning opresult2149 (depth = 4)
  gc_frame_newslot(opresult2149);
// starting to compile block node (depth = 4)
  Object block2150 = alloc_Block(NULL, NULL, "ast", 454);
  gc_frame_newslot(block2150);
// method "_apply"
  block_savedest(block2150);
  Object closure2151 = createclosure(2, "_apply");
  setclosureframe(closure2151, stackframe);
  addtoclosure(closure2151, var_spc);
  addtoclosure(closure2151, selfslot);
  struct UserObject *uo2151 = (struct UserObject*)block2150;
  uo2151->data[0] = (Object)closure2151;
  Method *meth_meth_ast__apply2151 = addmethod2pos(block2150, "_apply", &meth_ast__apply2151, 0);
  int argcv_meth_ast__apply2151[] = {1};
  meth_meth_ast__apply2151->type = alloc_MethodType(1, argcv_meth_ast__apply2151);
  meth_meth_ast__apply2151->definitionModule = modulename;
  meth_meth_ast__apply2151->definitionLine = 448;
// compiled block node returning block2150 (depth = 4)
  gc_frame_newslot(block2150);
// call case 5: prelude request
  params[0] = opresult2149;
  params[1] = block2150;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2158 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2141);
// compiled call node returning call2158 (depth = 3)
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2160 == NULL) {
    strlit2160 = alloc_String(" ");
    gc_root(strlit2160);
  }
// compiled string node returning strlit2160 (depth = 5)
  int op_slot_right_2159 = gc_frame_newslot(strlit2160);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2163 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2165 = alloc_Float64(1);
// compiled num node returning num2165 (depth = 8)
  int op_slot_right_2164 = gc_frame_newslot(num2165);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2164 = gc_frame_newslot(*var_depth);
  params[0] = num2165;
  partcv[0] = 1;
  Object sum2167 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2167 (depth = 7)
  gc_frame_newslot(sum2167);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2169 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2168);
// compiled call node returning call2169 (depth = 8)
// compiled member node returning call2169 (depth = 7)
  params[0] = sum2167;
  partcv[0] = 1;
  Object call2170 = callmethod(call2169, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2163);
// compiled call node returning call2170 (depth = 6)
  int op_slot_right_2162 = gc_frame_newslot(call2170);
// starting to compile string node (depth = 6)
  if (strlit2172 == NULL) {
    strlit2172 = alloc_String("try ");
    gc_root(strlit2172);
  }
// compiled string node returning strlit2172 (depth = 6)
  int op_slot_left_2162 = gc_frame_newslot(strlit2172);
  params[0] = call2170;
  partcv[0] = 1;
  Object opresult2173 = callmethod(strlit2172, "++", 1, partcv, params);
// compiled op node returning opresult2173 (depth = 5)
  int op_slot_left_2159 = gc_frame_newslot(opresult2173);
  params[0] = strlit2160;
  partcv[0] = 1;
  Object opresult2174 = callmethod(opresult2173, "++", 1, partcv, params);
// compiled op node returning opresult2174 (depth = 4)
  *var_s = opresult2174;
  if (opresult2174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2175 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2177 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2176);
// compiled call node returning call2177 (depth = 5)
// compiled member node returning call2177 (depth = 4)
  gc_frame_newslot(call2177);
// starting to compile block node (depth = 4)
  Object block2178 = alloc_Block(NULL, NULL, "ast", 458);
  gc_frame_newslot(block2178);
// method "_apply"
  block_savedest(block2178);
  Object closure2179 = createclosure(4, "_apply");
  setclosureframe(closure2179, stackframe);
  addtoclosure(closure2179, var_depth);
  addtoclosure(closure2179, var_spc);
  addtoclosure(closure2179, var_s);
  addtoclosure(closure2179, selfslot);
  struct UserObject *uo2179 = (struct UserObject*)block2178;
  uo2179->data[0] = (Object)closure2179;
  Method *meth_meth_ast__apply2179 = addmethod2pos(block2178, "_apply", &meth_ast__apply2179, 0);
  int argcv_meth_ast__apply2179[] = {1};
  meth_meth_ast__apply2179->type = alloc_MethodType(1, argcv_meth_ast__apply2179);
  meth_meth_ast__apply2179->definitionModule = modulename;
  meth_meth_ast__apply2179->definitionLine = 458;
// compiled block node returning block2178 (depth = 4)
  gc_frame_newslot(block2178);
// call case 5: prelude request
  params[0] = call2177;
  params[1] = block2178;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2206 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled call node returning call2206 (depth = 3)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2210 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2209);
// compiled call node returning call2210 (depth = 6)
// compiled member node returning call2210 (depth = 5)
  int op_slot_right_2208 = gc_frame_newslot(call2210);
// starting to compile identifier node (depth = 5)
  Object bool2212 = alloc_Boolean(0);
// compiled identifier node returning bool2212 (depth = 5)
  int op_slot_left_2208 = gc_frame_newslot(bool2212);
  params[0] = call2210;
  partcv[0] = 1;
  Object opresult2213 = callmethod(bool2212, "≠", 1, partcv, params);
// compiled op node returning opresult2213 (depth = 4)
  Object if2207 = done;
  if (istrue(opresult2213)) {
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2215 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2217 = alloc_Float64(1);
// compiled num node returning num2217 (depth = 8)
  int op_slot_right_2216 = gc_frame_newslot(num2217);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2216 = gc_frame_newslot(*var_depth);
  params[0] = num2217;
  partcv[0] = 1;
  Object sum2219 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2219 (depth = 7)
  gc_frame_newslot(sum2219);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2220 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2221 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2220);
// compiled call node returning call2221 (depth = 8)
// compiled member node returning call2221 (depth = 7)
  params[0] = sum2219;
  partcv[0] = 1;
  Object call2222 = callmethod(call2221, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2215);
// compiled call node returning call2222 (depth = 6)
  int op_slot_right_2214 = gc_frame_newslot(call2222);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2225 == NULL) {
    strlit2225 = alloc_String("finally ");
    gc_root(strlit2225);
  }
// compiled string node returning strlit2225 (depth = 7)
  int op_slot_right_2224 = gc_frame_newslot(strlit2225);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2228 == NULL) {
    strlit2228 = alloc_String("    ");
    gc_root(strlit2228);
  }
// compiled string node returning strlit2228 (depth = 8)
  int op_slot_right_2227 = gc_frame_newslot(strlit2228);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2230 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2233 == NULL) {
    strlit2233 = alloc_String("""\x0a""");
    gc_root(strlit2233);
  }
// compiled string node returning strlit2233 (depth = 10)
  int op_slot_right_2232 = gc_frame_newslot(strlit2233);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2232 = gc_frame_newslot(*var_s);
  params[0] = strlit2233;
  partcv[0] = 1;
  Object opresult2235 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2235 (depth = 9)
  int op_slot_left_2230 = gc_frame_newslot(opresult2235);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2236 = callmethod(opresult2235, "++", 1, partcv, params);
// compiled op node returning opresult2236 (depth = 8)
  int op_slot_left_2227 = gc_frame_newslot(opresult2236);
  params[0] = strlit2228;
  partcv[0] = 1;
  Object opresult2237 = callmethod(opresult2236, "++", 1, partcv, params);
// compiled op node returning opresult2237 (depth = 7)
  int op_slot_left_2224 = gc_frame_newslot(opresult2237);
  params[0] = strlit2225;
  partcv[0] = 1;
  Object opresult2238 = callmethod(opresult2237, "++", 1, partcv, params);
// compiled op node returning opresult2238 (depth = 6)
  int op_slot_left_2214 = gc_frame_newslot(opresult2238);
  params[0] = call2222;
  partcv[0] = 1;
  Object opresult2239 = callmethod(opresult2238, "++", 1, partcv, params);
// compiled op node returning opresult2239 (depth = 5)
  *var_s = opresult2239;
  if (opresult2239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2207 = done;
  } else {
  }
// compiled if node returning if2207 (depth = 3)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2242 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2244 = alloc_Boolean(0);
// compiled identifier node returning bool2244 (depth = 5)
  gc_frame_newslot(bool2244);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tryCatchNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2244;
  partcv[0] = 3;
  Object call2245 = callmethod(*var_tryCatchNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2243);
// compiled call node returning call2245 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2246 = callmethod(call2245, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2242);
// compiled call node returning call2246 (depth = 3)
  gc_frame_end(frame);
  return call2246;
}
Object meth_ast_new1946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1947 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1947 = alloc_userobj2(13,11, objclass1947);
  gc_frame_newslot(obj1947);
if (objclass1947 == NULL) {
  glfree(obj1947->class->name);
  obj1947->class->name = "tryCatchNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1947, self, 0);
  addmethodreal(obj1947,"outer", &reader_ast_outer_1948);
  Object oldself1947 = self;
  struct StackFrameObject *oldstackframe1947 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1947);
  gc_frame_newslot((Object)stackframe);
  self = obj1947;
  Object *oldselfslot1947 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1947 = (*(struct UserObject *)self).data[0], lowerouter1947 = thisouter1947;
  if (inheritingObject1947) {
    struct UserObject *inho1947 = (struct UserObject *)inheritingObject1947;
    while (inho1947->super != GraceDefaultObject) inho1947 = (struct UserObject *)inho1947->super;
    inho1947->super = obj1947;
    self = inheritingObject1947;
    *selfslot = self;
    lowerouter1947 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1947;
  }
if (objclass1947 == NULL) {
  Method *reader1949 = addmethodrealflags(obj1947, "kind",&reader_ast_kind_1949, MFLAG_DEF);
  reader1949->definitionModule = modulename;
  reader1949->definitionLine = 411;
}
adddatum2(obj1947, alloc_Undefined(), 1);
if (objclass1947 == NULL) {
  Method *reader1950 = addmethodrealflags(obj1947, "value",&reader_ast_value_1950, 0);
  Method *writer1950 = addmethodrealflags(obj1947, "value:=",&writer_ast_value_1950, 0);
  reader1950->definitionModule = modulename;
  writer1950->definitionModule = modulename;
  reader1950->definitionLine = 412;
  writer1950->definitionLine = 412;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 2);
if (objclass1947 == NULL) {
  Method *reader1951 = addmethodrealflags(obj1947, "cases",&reader_ast_cases_1951, 0);
  Method *writer1951 = addmethodrealflags(obj1947, "cases:=",&writer_ast_cases_1951, 0);
  reader1951->definitionModule = modulename;
  writer1951->definitionModule = modulename;
  reader1951->definitionLine = 413;
  writer1951->definitionLine = 413;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 3);
if (objclass1947 == NULL) {
  Method *reader1952 = addmethodrealflags(obj1947, "finally",&reader_ast_finally_1952, 0);
  Method *writer1952 = addmethodrealflags(obj1947, "finally:=",&writer_ast_finally_1952, 0);
  reader1952->definitionModule = modulename;
  writer1952->definitionModule = modulename;
  reader1952->definitionLine = 414;
  writer1952->definitionLine = 414;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo1953 = (struct UserObject*)obj1947;
  uo1953->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1953 = addmethod2pos(obj1947, "isSimple", &meth_ast_isSimple1953, 5);
  int argcv_meth_ast_isSimple1953[] = {0};
  meth_meth_ast_isSimple1953->type = alloc_MethodType(1, argcv_meth_ast_isSimple1953);
  meth_meth_ast_isSimple1953->definitionModule = modulename;
  meth_meth_ast_isSimple1953->definitionLine = 415;
// method "accept()from"
  struct UserObject *uo1955 = (struct UserObject*)obj1947;
  uo1955->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1955 = addmethod2pos(obj1947, "accept()from", &meth_ast_accept_40__41_from1955, 6);
  int argcv_meth_ast_accept_40__41_from1955[] = {1, 1};
  meth_meth_ast_accept_40__41_from1955->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1955);
  meth_meth_ast_accept_40__41_from1955->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1955->definitionLine = 417;
// method "map()ancestors"
  struct UserObject *uo1985 = (struct UserObject*)obj1947;
  uo1985->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1985 = addmethod2pos(obj1947, "map()ancestors", &meth_ast_map_40__41_ancestors1985, 7);
  int argcv_meth_ast_map_40__41_ancestors1985[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1985->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1985);
  meth_meth_ast_map_40__41_ancestors1985->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1985->definitionLine = 429;
// method "pretty"
  struct UserObject *uo2018 = (struct UserObject*)obj1947;
  uo2018->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty2018 = addmethod2pos(obj1947, "pretty", &meth_ast_pretty2018, 8);
  int argcv_meth_ast_pretty2018[] = {1};
  meth_meth_ast_pretty2018->type = alloc_MethodType(1, argcv_meth_ast_pretty2018);
  meth_meth_ast_pretty2018->definitionModule = modulename;
  meth_meth_ast_pretty2018->definitionLine = 437;
// method "toGrace"
  struct UserObject *uo2139 = (struct UserObject*)obj1947;
  uo2139->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2139 = addmethod2pos(obj1947, "toGrace", &meth_ast_toGrace2139, 9);
  int argcv_meth_ast_toGrace2139[] = {1};
  meth_meth_ast_toGrace2139->type = alloc_MethodType(1, argcv_meth_ast_toGrace2139);
meth_meth_ast_toGrace2139->type->types[0] = type_Number;
meth_meth_ast_toGrace2139->type->names[0] = "depth";
  meth_meth_ast_toGrace2139->definitionModule = modulename;
  meth_meth_ast_toGrace2139->definitionLine = 452;
// method "shallowCopy"
  block_savedest(obj1947);
  Object closure2241 = createclosure(3, "shallowCopy");
  setclosureframe(closure2241, stackframe);
  addtoclosure(closure2241, var_nullNode);
  addtoclosure(closure2241, var_emptySeq);
  addtoclosure(closure2241, var_tryCatchNode);
  struct UserObject *uo2241 = (struct UserObject*)obj1947;
  uo2241->data[10] = (Object)closure2241;
  Method *meth_meth_ast_shallowCopy2241 = addmethod2pos(obj1947, "shallowCopy", &meth_ast_shallowCopy2241, 10);
  int argcv_meth_ast_shallowCopy2241[] = {0};
  meth_meth_ast_shallowCopy2241->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2241);
  meth_meth_ast_shallowCopy2241->definitionModule = modulename;
  meth_meth_ast_shallowCopy2241->definitionLine = 466;
  sourceObject = obj1947;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2247 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2248 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2249 = gc_frame_new();
// call case 3: self.outer request
  Object call2250 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2249);
// compiled call node returning call2250 (depth = 7)
// compiled member node returning call2250 (depth = 6)
  partcv[0] = 0;
  Object call2251 = callmethodflags(call2250, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2248);
// compiled call node returning call2251 (depth = 5)
// compiled member node returning call2251 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2252 = callmethodflags(call2251, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2247);
// compiled call node returning call2252 (depth = 3)
  struct UserObject *obj1947_uo = (struct UserObject *)obj1947;
  obj1947_uo->super = call2252;
  sourceObject = obj1947;
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2253 == NULL) {
    strlit2253 = alloc_String("trycatch");
    gc_root(strlit2253);
  }
// compiled string node returning strlit2253 (depth = 3)
  adddatum2(obj1947, strlit2253, 1);
  sourceObject = obj1947;
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj1947, *var_block, 2);
  sourceObject = obj1947;
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj1947, *var_cases_39_, 3);
  sourceObject = obj1947;
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj1947, *var_finally_39_, 4);
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  objclass1947 = obj1947->class;
  objclass1947->definitionModule = modulename;
  objclass1947->definitionLine = 409;
  (*(struct UserObject *)self).data[0] = lowerouter1947;
  self = oldself1947;
  selfslot = oldselfslot1947;
  stackframe = oldstackframe1947;
  gc_frame_end(frame);
  return obj1947;
}
Object meth_ast_new1946_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_tryCatchNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1947 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1947 = alloc_userobj2(13,11, objclass1947);
  gc_frame_newslot(obj1947);
if (objclass1947 == NULL) {
  glfree(obj1947->class->name);
  obj1947->class->name = "tryCatchNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1947, self, 0);
  addmethodreal(obj1947,"outer", &reader_ast_outer_1948);
  Object oldself1947 = self;
  struct StackFrameObject *oldstackframe1947 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1947);
  gc_frame_newslot((Object)stackframe);
  self = obj1947;
  Object *oldselfslot1947 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1947 = (*(struct UserObject *)self).data[0], lowerouter1947 = thisouter1947;
  if (inheritingObject1947) {
    struct UserObject *inho1947 = (struct UserObject *)inheritingObject1947;
    while (inho1947->super != GraceDefaultObject) inho1947 = (struct UserObject *)inho1947->super;
    inho1947->super = obj1947;
    self = inheritingObject1947;
    *selfslot = self;
    lowerouter1947 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1947;
  }
if (objclass1947 == NULL) {
  Method *reader1949 = addmethodrealflags(obj1947, "kind",&reader_ast_kind_1949, MFLAG_DEF);
  reader1949->definitionModule = modulename;
  reader1949->definitionLine = 411;
}
adddatum2(obj1947, alloc_Undefined(), 1);
if (objclass1947 == NULL) {
  Method *reader1950 = addmethodrealflags(obj1947, "value",&reader_ast_value_1950, 0);
  Method *writer1950 = addmethodrealflags(obj1947, "value:=",&writer_ast_value_1950, 0);
  reader1950->definitionModule = modulename;
  writer1950->definitionModule = modulename;
  reader1950->definitionLine = 412;
  writer1950->definitionLine = 412;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 2);
if (objclass1947 == NULL) {
  Method *reader1951 = addmethodrealflags(obj1947, "cases",&reader_ast_cases_1951, 0);
  Method *writer1951 = addmethodrealflags(obj1947, "cases:=",&writer_ast_cases_1951, 0);
  reader1951->definitionModule = modulename;
  writer1951->definitionModule = modulename;
  reader1951->definitionLine = 413;
  writer1951->definitionLine = 413;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 3);
if (objclass1947 == NULL) {
  Method *reader1952 = addmethodrealflags(obj1947, "finally",&reader_ast_finally_1952, 0);
  Method *writer1952 = addmethodrealflags(obj1947, "finally:=",&writer_ast_finally_1952, 0);
  reader1952->definitionModule = modulename;
  writer1952->definitionModule = modulename;
  reader1952->definitionLine = 414;
  writer1952->definitionLine = 414;
}
obj1947->flags |= OFLAG_MUTABLE;
adddatum2(obj1947, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo1953 = (struct UserObject*)obj1947;
  uo1953->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple1953 = addmethod2pos(obj1947, "isSimple", &meth_ast_isSimple1953, 5);
  int argcv_meth_ast_isSimple1953[] = {0};
  meth_meth_ast_isSimple1953->type = alloc_MethodType(1, argcv_meth_ast_isSimple1953);
  meth_meth_ast_isSimple1953->definitionModule = modulename;
  meth_meth_ast_isSimple1953->definitionLine = 415;
// method "accept()from"
  struct UserObject *uo1955 = (struct UserObject*)obj1947;
  uo1955->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1955 = addmethod2pos(obj1947, "accept()from", &meth_ast_accept_40__41_from1955, 6);
  int argcv_meth_ast_accept_40__41_from1955[] = {1, 1};
  meth_meth_ast_accept_40__41_from1955->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1955);
  meth_meth_ast_accept_40__41_from1955->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1955->definitionLine = 417;
// method "map()ancestors"
  struct UserObject *uo1985 = (struct UserObject*)obj1947;
  uo1985->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors1985 = addmethod2pos(obj1947, "map()ancestors", &meth_ast_map_40__41_ancestors1985, 7);
  int argcv_meth_ast_map_40__41_ancestors1985[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors1985->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors1985);
  meth_meth_ast_map_40__41_ancestors1985->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors1985->definitionLine = 429;
// method "pretty"
  struct UserObject *uo2018 = (struct UserObject*)obj1947;
  uo2018->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty2018 = addmethod2pos(obj1947, "pretty", &meth_ast_pretty2018, 8);
  int argcv_meth_ast_pretty2018[] = {1};
  meth_meth_ast_pretty2018->type = alloc_MethodType(1, argcv_meth_ast_pretty2018);
  meth_meth_ast_pretty2018->definitionModule = modulename;
  meth_meth_ast_pretty2018->definitionLine = 437;
// method "toGrace"
  struct UserObject *uo2139 = (struct UserObject*)obj1947;
  uo2139->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace2139 = addmethod2pos(obj1947, "toGrace", &meth_ast_toGrace2139, 9);
  int argcv_meth_ast_toGrace2139[] = {1};
  meth_meth_ast_toGrace2139->type = alloc_MethodType(1, argcv_meth_ast_toGrace2139);
meth_meth_ast_toGrace2139->type->types[0] = type_Number;
meth_meth_ast_toGrace2139->type->names[0] = "depth";
  meth_meth_ast_toGrace2139->definitionModule = modulename;
  meth_meth_ast_toGrace2139->definitionLine = 452;
// method "shallowCopy"
  block_savedest(obj1947);
  Object closure2241 = createclosure(3, "shallowCopy");
  setclosureframe(closure2241, stackframe);
  addtoclosure(closure2241, var_nullNode);
  addtoclosure(closure2241, var_emptySeq);
  addtoclosure(closure2241, var_tryCatchNode);
  struct UserObject *uo2241 = (struct UserObject*)obj1947;
  uo2241->data[10] = (Object)closure2241;
  Method *meth_meth_ast_shallowCopy2241 = addmethod2pos(obj1947, "shallowCopy", &meth_ast_shallowCopy2241, 10);
  int argcv_meth_ast_shallowCopy2241[] = {0};
  meth_meth_ast_shallowCopy2241->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2241);
  meth_meth_ast_shallowCopy2241->definitionModule = modulename;
  meth_meth_ast_shallowCopy2241->definitionLine = 466;
  sourceObject = obj1947;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2247 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2248 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2249 = gc_frame_new();
// call case 3: self.outer request
  Object call2250 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2249);
// compiled call node returning call2250 (depth = 7)
// compiled member node returning call2250 (depth = 6)
  partcv[0] = 0;
  Object call2251 = callmethodflags(call2250, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2248);
// compiled call node returning call2251 (depth = 5)
// compiled member node returning call2251 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2252 = callmethodflags(call2251, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2247);
// compiled call node returning call2252 (depth = 3)
  struct UserObject *obj1947_uo = (struct UserObject *)obj1947;
  obj1947_uo->super = call2252;
  sourceObject = obj1947;
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2253 == NULL) {
    strlit2253 = alloc_String("trycatch");
    gc_root(strlit2253);
  }
// compiled string node returning strlit2253 (depth = 3)
  adddatum2(obj1947, strlit2253, 1);
  sourceObject = obj1947;
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block (depth = 3)
  adddatum2(obj1947, *var_block, 2);
  sourceObject = obj1947;
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj1947, *var_cases_39_, 3);
  sourceObject = obj1947;
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_finally_39_ (depth = 3)
  adddatum2(obj1947, *var_finally_39_, 4);
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  sourceObject = obj1947;
  objclass1947 = obj1947->class;
  objclass1947->definitionModule = modulename;
  objclass1947->definitionLine = 409;
  (*(struct UserObject *)self).data[0] = lowerouter1947;
  self = oldself1947;
  selfslot = oldselfslot1947;
  stackframe = oldstackframe1947;
  gc_frame_end(frame);
  return obj1947;
}
Object meth_ast_tryCatchNode2255(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tryCatchNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tryCatchNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tryCatchNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tryCatchNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tryCatchNode (depth = 3)
  gc_frame_end(frame);
  return *var_tryCatchNode;
}
Object meth_ast_isSimple2265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2266 = alloc_Boolean(0);
// compiled identifier node returning bool2266 (depth = 3)
  gc_frame_end(frame);
  return bool2266;
}
Object meth_ast_matchee2267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchee (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchee");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2268 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2269 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2268);
// compiled call node returning call2269 (depth = 4)
// compiled member node returning call2269 (depth = 3)
  gc_frame_end(frame);
  return call2269;
}
Object meth_ast__apply2284(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2285 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2286 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2285);
// compiled call node returning call2286 (depth = 6)
  gc_frame_end(frame);
  return call2286;
}
Object meth_ast_accept_40__41_from2270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2272 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2273 = callmethod(*var_visitor, "visitMatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe2272);
// compiled call node returning call2273 (depth = 4)
  Object if2271 = done;
  if (istrue(call2273)) {
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2274 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2275 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2274);
// compiled call node returning call2275 (depth = 5)
  *var_newChain = call2275;
  if (call2275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2276 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2278 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2277);
// compiled call node returning call2278 (depth = 6)
// compiled member node returning call2278 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2279 = callmethod(call2278, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2276);
// compiled call node returning call2279 (depth = 4)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2280 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2281 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2282 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2281);
// compiled call node returning call2282 (depth = 6)
// compiled member node returning call2282 (depth = 5)
  gc_frame_newslot(call2282);
// starting to compile block node (depth = 5)
  Object block2283 = alloc_Block(NULL, NULL, "ast", 484);
  gc_frame_newslot(block2283);
// method "_apply"
  block_savedest(block2283);
  Object closure2284 = createclosure(3, "_apply");
  setclosureframe(closure2284, stackframe);
  addtoclosure(closure2284, var_visitor);
  addtoclosure(closure2284, var_newChain);
  addtoclosure(closure2284, selfslot);
  struct UserObject *uo2284 = (struct UserObject*)block2283;
  uo2284->data[0] = (Object)closure2284;
  Method *meth_meth_ast__apply2284 = addmethod2pos(block2283, "_apply", &meth_ast__apply2284, 0);
  int argcv_meth_ast__apply2284[] = {1};
  meth_meth_ast__apply2284->type = alloc_MethodType(1, argcv_meth_ast__apply2284);
  meth_meth_ast__apply2284->definitionModule = modulename;
  meth_meth_ast__apply2284->definitionLine = 484;
// compiled block node returning block2283 (depth = 5)
  gc_frame_newslot(block2283);
// call case 5: prelude request
  params[0] = call2282;
  params[1] = block2283;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2288 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2280);
// compiled call node returning call2288 (depth = 4)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2291 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2292 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2291);
// compiled call node returning call2292 (depth = 7)
// compiled member node returning call2292 (depth = 6)
  int op_slot_right_2290 = gc_frame_newslot(call2292);
// starting to compile identifier node (depth = 6)
  Object bool2294 = alloc_Boolean(0);
// compiled identifier node returning bool2294 (depth = 6)
  int op_slot_left_2290 = gc_frame_newslot(bool2294);
  params[0] = call2292;
  partcv[0] = 1;
  Object opresult2295 = callmethod(bool2294, "≠", 1, partcv, params);
// compiled op node returning opresult2295 (depth = 5)
  Object if2289 = done;
  if (istrue(opresult2295)) {
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2296 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2298 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2297);
// compiled call node returning call2298 (depth = 7)
// compiled member node returning call2298 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2299 = callmethod(call2298, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2296);
// compiled call node returning call2299 (depth = 5)
    gc_frame_newslot(call2299);
    if2289 = call2299;
  } else {
  }
// compiled if node returning if2289 (depth = 4)
    gc_frame_newslot(if2289);
    if2271 = if2289;
  } else {
  }
// compiled if node returning if2271 (depth = 3)
  gc_frame_end(frame);
  return if2271;
}
Object meth_ast_map_40__41_ancestors2300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2301 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2302 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2301);
// compiled call node returning call2302 (depth = 5)
// compiled member node returning call2302 (depth = 4)
  *var_n = call2302;
  if (call2302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2303 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2304 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2303);
// compiled call node returning call2304 (depth = 4)
  *var_newChain = call2304;
  if (call2304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2305 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2306 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2307 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2308 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2307);
// compiled call node returning call2308 (depth = 6)
// compiled member node returning call2308 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2309 = callmethod(call2308, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe2306);
// compiled call node returning call2309 (depth = 4)
  gc_frame_newslot(call2309);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2309;
  partcv[0] = 1;
  Object call2310 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe2305);
// compiled call node returning call2310 (depth = 3)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2311 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2312 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2314 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2313);
// compiled call node returning call2314 (depth = 6)
// compiled member node returning call2314 (depth = 5)
  gc_frame_newslot(call2314);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2315 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2316 = gc_frame_new();
// call case 3: self.outer request
  Object call2317 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2316);
// compiled call node returning call2317 (depth = 8)
// compiled member node returning call2317 (depth = 7)
  partcv[0] = 0;
  Object call2318 = callmethodflags(call2317, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2315);
// compiled call node returning call2318 (depth = 6)
// compiled member node returning call2318 (depth = 5)
  params[0] = call2314;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2319 = callmethodflags(call2318, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2312);
// compiled call node returning call2319 (depth = 4)
  gc_frame_newslot(call2319);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2319;
  partcv[0] = 1;
  Object call2320 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe2311);
// compiled call node returning call2320 (depth = 3)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2321 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2322 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2324 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2323);
// compiled call node returning call2324 (depth = 6)
// compiled member node returning call2324 (depth = 5)
  gc_frame_newslot(call2324);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2325 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2326 = gc_frame_new();
// call case 3: self.outer request
  Object call2327 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2326);
// compiled call node returning call2327 (depth = 8)
// compiled member node returning call2327 (depth = 7)
  partcv[0] = 0;
  Object call2328 = callmethodflags(call2327, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2325);
// compiled call node returning call2328 (depth = 6)
// compiled member node returning call2328 (depth = 5)
  params[0] = call2324;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2329 = callmethodflags(call2328, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2322);
// compiled call node returning call2329 (depth = 4)
  gc_frame_newslot(call2329);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2329;
  partcv[0] = 1;
  Object call2330 = callmethod(*var_n, "elsecase:=",
    1, partcv, params);
  gc_frame_end(callframe2321);
// compiled call node returning call2330 (depth = 3)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2331 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2332 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2331);
// compiled call node returning call2332 (depth = 3)
  gc_frame_end(frame);
  return call2332;
}
Object meth_ast__apply2341(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2343 == NULL) {
    strlit2343 = alloc_String("  ");
    gc_root(strlit2343);
  }
// compiled string node returning strlit2343 (depth = 7)
  int op_slot_right_2342 = gc_frame_newslot(strlit2343);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2342 = gc_frame_newslot(*var_spc);
  params[0] = strlit2343;
  partcv[0] = 1;
  Object opresult2345 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2345 (depth = 6)
  *var_spc = opresult2345;
  if (opresult2345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2374(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2377 == NULL) {
    strlit2377 = alloc_String("");
    gc_root(strlit2377);
  }
// compiled string node returning strlit2377 (depth = 8)
  int op_slot_right_2376 = gc_frame_newslot(strlit2377);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2380 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2382 = alloc_Float64(2);
// compiled num node returning num2382 (depth = 11)
  int op_slot_right_2381 = gc_frame_newslot(num2382);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2381 = gc_frame_newslot(*var_depth);
  params[0] = num2382;
  partcv[0] = 1;
  Object sum2384 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2384 (depth = 10)
  gc_frame_newslot(sum2384);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mx (depth = 10)
  params[0] = sum2384;
  partcv[0] = 1;
  Object call2385 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2380);
// compiled call node returning call2385 (depth = 9)
  int op_slot_right_2379 = gc_frame_newslot(call2385);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2388 == NULL) {
    strlit2388 = alloc_String("  ");
    gc_root(strlit2388);
  }
// compiled string node returning strlit2388 (depth = 10)
  int op_slot_right_2387 = gc_frame_newslot(strlit2388);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2390 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2393 == NULL) {
    strlit2393 = alloc_String("Case:""\x0a""");
    gc_root(strlit2393);
  }
// compiled string node returning strlit2393 (depth = 12)
  int op_slot_right_2392 = gc_frame_newslot(strlit2393);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_2395 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit2397 == NULL) {
    strlit2397 = alloc_String("""\x0a""");
    gc_root(strlit2397);
  }
// compiled string node returning strlit2397 (depth = 13)
  int op_slot_left_2395 = gc_frame_newslot(strlit2397);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2398 = callmethod(strlit2397, "++", 1, partcv, params);
// compiled op node returning opresult2398 (depth = 12)
  int op_slot_left_2392 = gc_frame_newslot(opresult2398);
  params[0] = strlit2393;
  partcv[0] = 1;
  Object opresult2399 = callmethod(opresult2398, "++", 1, partcv, params);
// compiled op node returning opresult2399 (depth = 11)
  int op_slot_left_2390 = gc_frame_newslot(opresult2399);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2400 = callmethod(opresult2399, "++", 1, partcv, params);
// compiled op node returning opresult2400 (depth = 10)
  int op_slot_left_2387 = gc_frame_newslot(opresult2400);
  params[0] = strlit2388;
  partcv[0] = 1;
  Object opresult2401 = callmethod(opresult2400, "++", 1, partcv, params);
// compiled op node returning opresult2401 (depth = 9)
  int op_slot_left_2379 = gc_frame_newslot(opresult2401);
  params[0] = call2385;
  partcv[0] = 1;
  Object opresult2402 = callmethod(opresult2401, "++", 1, partcv, params);
// compiled op node returning opresult2402 (depth = 8)
  int op_slot_left_2376 = gc_frame_newslot(opresult2402);
  params[0] = strlit2377;
  partcv[0] = 1;
  Object opresult2403 = callmethod(opresult2402, "++", 1, partcv, params);
// compiled op node returning opresult2403 (depth = 7)
  int op_slot_right_2375 = gc_frame_newslot(opresult2403);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2375 = gc_frame_newslot(*var_s);
  params[0] = opresult2403;
  partcv[0] = 1;
  Object opresult2405 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2405 (depth = 6)
  *var_s = opresult2405;
  if (opresult2405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2334 == NULL) {
    strlit2334 = alloc_String("");
    gc_root(strlit2334);
  }
// compiled string node returning strlit2334 (depth = 4)
  *var_spc = strlit2334;
  if (strlit2334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2335 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2336 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2338 = alloc_Float64(0);
// compiled num node returning num2338 (depth = 5)
  int op_slot_left_2336 = gc_frame_newslot(num2338);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2339 = callmethod(num2338, "..", 1, partcv, params);
// compiled op node returning opresult2339 (depth = 4)
  gc_frame_newslot(opresult2339);
// starting to compile block node (depth = 4)
  Object block2340 = alloc_Block(NULL, NULL, "ast", 502);
  gc_frame_newslot(block2340);
// method "_apply"
  block_savedest(block2340);
  Object closure2341 = createclosure(2, "_apply");
  setclosureframe(closure2341, stackframe);
  addtoclosure(closure2341, var_spc);
  addtoclosure(closure2341, selfslot);
  struct UserObject *uo2341 = (struct UserObject*)block2340;
  uo2341->data[0] = (Object)closure2341;
  Method *meth_meth_ast__apply2341 = addmethod2pos(block2340, "_apply", &meth_ast__apply2341, 0);
  int argcv_meth_ast__apply2341[] = {1};
  meth_meth_ast__apply2341->type = alloc_MethodType(1, argcv_meth_ast__apply2341);
  meth_meth_ast__apply2341->definitionModule = modulename;
  meth_meth_ast__apply2341->definitionLine = 497;
// compiled block node returning block2340 (depth = 4)
  gc_frame_newslot(block2340);
// call case 5: prelude request
  params[0] = opresult2339;
  params[1] = block2340;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2348 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2335);
// compiled call node returning call2348 (depth = 3)
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2350 == NULL) {
    strlit2350 = alloc_String("""\x0a""");
    gc_root(strlit2350);
  }
// compiled string node returning strlit2350 (depth = 5)
  int op_slot_right_2349 = gc_frame_newslot(strlit2350);
// starting to compile call node (depth = 5)
  int callframe2352 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2353 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2352);
// compiled call node returning call2353 (depth = 5)
  int op_slot_left_2349 = gc_frame_newslot(call2353);
  params[0] = strlit2350;
  partcv[0] = 1;
  Object opresult2354 = callmethod(call2353, "++", 1, partcv, params);
// compiled op node returning opresult2354 (depth = 4)
  *var_s = opresult2354;
  if (opresult2354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2356 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2358 = alloc_Float64(2);
// compiled num node returning num2358 (depth = 7)
  int op_slot_right_2357 = gc_frame_newslot(num2358);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2357 = gc_frame_newslot(*var_depth);
  params[0] = num2358;
  partcv[0] = 1;
  Object sum2360 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2360 (depth = 6)
  gc_frame_newslot(sum2360);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2362 = callmethodflags(self, "matchee", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2361);
// compiled call node returning call2362 (depth = 7)
// compiled member node returning call2362 (depth = 6)
  params[0] = sum2360;
  partcv[0] = 1;
  Object call2363 = callmethod(call2362, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2356);
// compiled call node returning call2363 (depth = 5)
  int op_slot_right_2355 = gc_frame_newslot(call2363);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2365 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2365 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2367 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2367 (depth = 5)
  int op_slot_left_2355 = gc_frame_newslot(opresult2367);
  params[0] = call2363;
  partcv[0] = 1;
  Object opresult2368 = callmethod(opresult2367, "++", 1, partcv, params);
// compiled op node returning opresult2368 (depth = 4)
  *var_s = opresult2368;
  if (opresult2368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2370 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2372 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2371);
// compiled call node returning call2372 (depth = 5)
// compiled member node returning call2372 (depth = 4)
  gc_frame_newslot(call2372);
// starting to compile block node (depth = 4)
  Object block2373 = alloc_Block(NULL, NULL, "ast", 507);
  gc_frame_newslot(block2373);
// method "_apply"
  block_savedest(block2373);
  Object closure2374 = createclosure(4, "_apply");
  setclosureframe(closure2374, stackframe);
  addtoclosure(closure2374, var_depth);
  addtoclosure(closure2374, var_spc);
  addtoclosure(closure2374, var_s);
  addtoclosure(closure2374, selfslot);
  struct UserObject *uo2374 = (struct UserObject*)block2373;
  uo2374->data[0] = (Object)closure2374;
  Method *meth_meth_ast__apply2374 = addmethod2pos(block2373, "_apply", &meth_ast__apply2374, 0);
  int argcv_meth_ast__apply2374[] = {1};
  meth_meth_ast__apply2374->type = alloc_MethodType(1, argcv_meth_ast__apply2374);
  meth_meth_ast__apply2374->definitionModule = modulename;
  meth_meth_ast__apply2374->definitionLine = 507;
// compiled block node returning block2373 (depth = 4)
  gc_frame_newslot(block2373);
// call case 5: prelude request
  params[0] = call2372;
  params[1] = block2373;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2408 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2370);
// compiled call node returning call2408 (depth = 3)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2412 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2411);
// compiled call node returning call2412 (depth = 6)
// compiled member node returning call2412 (depth = 5)
  int op_slot_right_2410 = gc_frame_newslot(call2412);
// starting to compile identifier node (depth = 5)
  Object bool2414 = alloc_Boolean(0);
// compiled identifier node returning bool2414 (depth = 5)
  int op_slot_left_2410 = gc_frame_newslot(bool2414);
  params[0] = call2412;
  partcv[0] = 1;
  Object opresult2415 = callmethod(bool2414, "≠", 1, partcv, params);
// compiled op node returning opresult2415 (depth = 4)
  Object if2409 = done;
  if (istrue(opresult2415)) {
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2418 == NULL) {
    strlit2418 = alloc_String("");
    gc_root(strlit2418);
  }
// compiled string node returning strlit2418 (depth = 7)
  int op_slot_right_2417 = gc_frame_newslot(strlit2418);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2421 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2423 = alloc_Float64(2);
// compiled num node returning num2423 (depth = 10)
  int op_slot_right_2422 = gc_frame_newslot(num2423);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2422 = gc_frame_newslot(*var_depth);
  params[0] = num2423;
  partcv[0] = 1;
  Object sum2425 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2425 (depth = 9)
  gc_frame_newslot(sum2425);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2426 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2427 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2426);
// compiled call node returning call2427 (depth = 10)
// compiled member node returning call2427 (depth = 9)
  params[0] = sum2425;
  partcv[0] = 1;
  Object call2428 = callmethod(call2427, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2421);
// compiled call node returning call2428 (depth = 8)
  int op_slot_right_2420 = gc_frame_newslot(call2428);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2431 == NULL) {
    strlit2431 = alloc_String("  ");
    gc_root(strlit2431);
  }
// compiled string node returning strlit2431 (depth = 9)
  int op_slot_right_2430 = gc_frame_newslot(strlit2431);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2433 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2436 == NULL) {
    strlit2436 = alloc_String("Else:""\x0a""");
    gc_root(strlit2436);
  }
// compiled string node returning strlit2436 (depth = 11)
  int op_slot_right_2435 = gc_frame_newslot(strlit2436);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2438 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 12)
  if (strlit2440 == NULL) {
    strlit2440 = alloc_String("""\x0a""");
    gc_root(strlit2440);
  }
// compiled string node returning strlit2440 (depth = 12)
  int op_slot_left_2438 = gc_frame_newslot(strlit2440);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2441 = callmethod(strlit2440, "++", 1, partcv, params);
// compiled op node returning opresult2441 (depth = 11)
  int op_slot_left_2435 = gc_frame_newslot(opresult2441);
  params[0] = strlit2436;
  partcv[0] = 1;
  Object opresult2442 = callmethod(opresult2441, "++", 1, partcv, params);
// compiled op node returning opresult2442 (depth = 10)
  int op_slot_left_2433 = gc_frame_newslot(opresult2442);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2443 = callmethod(opresult2442, "++", 1, partcv, params);
// compiled op node returning opresult2443 (depth = 9)
  int op_slot_left_2430 = gc_frame_newslot(opresult2443);
  params[0] = strlit2431;
  partcv[0] = 1;
  Object opresult2444 = callmethod(opresult2443, "++", 1, partcv, params);
// compiled op node returning opresult2444 (depth = 8)
  int op_slot_left_2420 = gc_frame_newslot(opresult2444);
  params[0] = call2428;
  partcv[0] = 1;
  Object opresult2445 = callmethod(opresult2444, "++", 1, partcv, params);
// compiled op node returning opresult2445 (depth = 7)
  int op_slot_left_2417 = gc_frame_newslot(opresult2445);
  params[0] = strlit2418;
  partcv[0] = 1;
  Object opresult2446 = callmethod(opresult2445, "++", 1, partcv, params);
// compiled op node returning opresult2446 (depth = 6)
  int op_slot_right_2416 = gc_frame_newslot(opresult2446);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2416 = gc_frame_newslot(*var_s);
  params[0] = opresult2446;
  partcv[0] = 1;
  Object opresult2448 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2448 (depth = 5)
  *var_s = opresult2448;
  if (opresult2448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2409 = done;
  } else {
  }
// compiled if node returning if2409 (depth = 3)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2462(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2464 == NULL) {
    strlit2464 = alloc_String("    ");
    gc_root(strlit2464);
  }
// compiled string node returning strlit2464 (depth = 7)
  int op_slot_right_2463 = gc_frame_newslot(strlit2464);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2463 = gc_frame_newslot(*var_spc);
  params[0] = strlit2464;
  partcv[0] = 1;
  Object opresult2466 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2466 (depth = 6)
  *var_spc = opresult2466;
  if (opresult2466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2487(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2489 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2491 = alloc_Float64(2);
// compiled num node returning num2491 (depth = 9)
  int op_slot_right_2490 = gc_frame_newslot(num2491);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2490 = gc_frame_newslot(*var_depth);
  params[0] = num2491;
  partcv[0] = 1;
  Object sum2493 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2493 (depth = 8)
  gc_frame_newslot(sum2493);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_case (depth = 8)
  params[0] = sum2493;
  partcv[0] = 1;
  Object call2494 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2489);
// compiled call node returning call2494 (depth = 7)
  int op_slot_right_2488 = gc_frame_newslot(call2494);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2497 == NULL) {
    strlit2497 = alloc_String("case ");
    gc_root(strlit2497);
  }
// compiled string node returning strlit2497 (depth = 8)
  int op_slot_right_2496 = gc_frame_newslot(strlit2497);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2500 == NULL) {
    strlit2500 = alloc_String("    ");
    gc_root(strlit2500);
  }
// compiled string node returning strlit2500 (depth = 9)
  int op_slot_right_2499 = gc_frame_newslot(strlit2500);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2502 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2505 == NULL) {
    strlit2505 = alloc_String("""\x0a""");
    gc_root(strlit2505);
  }
// compiled string node returning strlit2505 (depth = 11)
  int op_slot_right_2504 = gc_frame_newslot(strlit2505);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2504 = gc_frame_newslot(*var_s);
  params[0] = strlit2505;
  partcv[0] = 1;
  Object opresult2507 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 10)
  int op_slot_left_2502 = gc_frame_newslot(opresult2507);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2508 = callmethod(opresult2507, "++", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 9)
  int op_slot_left_2499 = gc_frame_newslot(opresult2508);
  params[0] = strlit2500;
  partcv[0] = 1;
  Object opresult2509 = callmethod(opresult2508, "++", 1, partcv, params);
// compiled op node returning opresult2509 (depth = 8)
  int op_slot_left_2496 = gc_frame_newslot(opresult2509);
  params[0] = strlit2497;
  partcv[0] = 1;
  Object opresult2510 = callmethod(opresult2509, "++", 1, partcv, params);
// compiled op node returning opresult2510 (depth = 7)
  int op_slot_left_2488 = gc_frame_newslot(opresult2510);
  params[0] = call2494;
  partcv[0] = 1;
  Object opresult2511 = callmethod(opresult2510, "++", 1, partcv, params);
// compiled op node returning opresult2511 (depth = 6)
  *var_s = opresult2511;
  if (opresult2511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2451 == NULL) {
    strlit2451 = alloc_String("");
    gc_root(strlit2451);
  }
// compiled string node returning strlit2451 (depth = 4)
  *var_spc = strlit2451;
  if (strlit2451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2452 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2455 = alloc_Float64(1);
// compiled num node returning num2455 (depth = 6)
  int op_slot_right_2454 = gc_frame_newslot(num2455);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_2454 = gc_frame_newslot(*var_depth);
  params[0] = num2455;
  partcv[0] = 1;
  Object diff2457 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2457 (depth = 5)
  int op_slot_right_2453 = gc_frame_newslot(diff2457);
// starting to compile num node (depth = 5)
  Object num2459 = alloc_Float64(0);
// compiled num node returning num2459 (depth = 5)
  int op_slot_left_2453 = gc_frame_newslot(num2459);
  params[0] = diff2457;
  partcv[0] = 1;
  Object opresult2460 = callmethod(num2459, "..", 1, partcv, params);
// compiled op node returning opresult2460 (depth = 4)
  gc_frame_newslot(opresult2460);
// starting to compile block node (depth = 4)
  Object block2461 = alloc_Block(NULL, NULL, "ast", 517);
  gc_frame_newslot(block2461);
// method "_apply"
  block_savedest(block2461);
  Object closure2462 = createclosure(2, "_apply");
  setclosureframe(closure2462, stackframe);
  addtoclosure(closure2462, var_spc);
  addtoclosure(closure2462, selfslot);
  struct UserObject *uo2462 = (struct UserObject*)block2461;
  uo2462->data[0] = (Object)closure2462;
  Method *meth_meth_ast__apply2462 = addmethod2pos(block2461, "_apply", &meth_ast__apply2462, 0);
  int argcv_meth_ast__apply2462[] = {1};
  meth_meth_ast__apply2462->type = alloc_MethodType(1, argcv_meth_ast__apply2462);
  meth_meth_ast__apply2462->definitionModule = modulename;
  meth_meth_ast__apply2462->definitionLine = 511;
// compiled block node returning block2461 (depth = 4)
  gc_frame_newslot(block2461);
// call case 5: prelude request
  params[0] = opresult2460;
  params[1] = block2461;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2469 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2452);
// compiled call node returning call2469 (depth = 3)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2471 == NULL) {
    strlit2471 = alloc_String(")");
    gc_root(strlit2471);
  }
// compiled string node returning strlit2471 (depth = 5)
  int op_slot_right_2470 = gc_frame_newslot(strlit2471);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2474 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num2475 = alloc_Float64(0);
// compiled num node returning num2475 (depth = 7)
  gc_frame_newslot(num2475);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2477 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2476);
// compiled call node returning call2477 (depth = 8)
// compiled member node returning call2477 (depth = 7)
  params[0] = num2475;
  partcv[0] = 1;
  Object call2478 = callmethod(call2477, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2474);
// compiled call node returning call2478 (depth = 6)
  int op_slot_right_2473 = gc_frame_newslot(call2478);
// starting to compile string node (depth = 6)
  if (strlit2480 == NULL) {
    strlit2480 = alloc_String("match(");
    gc_root(strlit2480);
  }
// compiled string node returning strlit2480 (depth = 6)
  int op_slot_left_2473 = gc_frame_newslot(strlit2480);
  params[0] = call2478;
  partcv[0] = 1;
  Object opresult2481 = callmethod(strlit2480, "++", 1, partcv, params);
// compiled op node returning opresult2481 (depth = 5)
  int op_slot_left_2470 = gc_frame_newslot(opresult2481);
  params[0] = strlit2471;
  partcv[0] = 1;
  Object opresult2482 = callmethod(opresult2481, "++", 1, partcv, params);
// compiled op node returning opresult2482 (depth = 4)
  *var_s = opresult2482;
  if (opresult2482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2483 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2485 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2484);
// compiled call node returning call2485 (depth = 5)
// compiled member node returning call2485 (depth = 4)
  gc_frame_newslot(call2485);
// starting to compile block node (depth = 4)
  Object block2486 = alloc_Block(NULL, NULL, "ast", 521);
  gc_frame_newslot(block2486);
// method "_apply"
  block_savedest(block2486);
  Object closure2487 = createclosure(4, "_apply");
  setclosureframe(closure2487, stackframe);
  addtoclosure(closure2487, var_depth);
  addtoclosure(closure2487, var_spc);
  addtoclosure(closure2487, var_s);
  addtoclosure(closure2487, selfslot);
  struct UserObject *uo2487 = (struct UserObject*)block2486;
  uo2487->data[0] = (Object)closure2487;
  Method *meth_meth_ast__apply2487 = addmethod2pos(block2486, "_apply", &meth_ast__apply2487, 0);
  int argcv_meth_ast__apply2487[] = {1};
  meth_meth_ast__apply2487->type = alloc_MethodType(1, argcv_meth_ast__apply2487);
  meth_meth_ast__apply2487->definitionModule = modulename;
  meth_meth_ast__apply2487->definitionLine = 521;
// compiled block node returning block2486 (depth = 4)
  gc_frame_newslot(block2486);
// call case 5: prelude request
  params[0] = call2485;
  params[1] = block2486;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2514 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2483);
// compiled call node returning call2514 (depth = 3)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2518 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2517);
// compiled call node returning call2518 (depth = 6)
// compiled member node returning call2518 (depth = 5)
  int op_slot_right_2516 = gc_frame_newslot(call2518);
// starting to compile identifier node (depth = 5)
  Object bool2520 = alloc_Boolean(0);
// compiled identifier node returning bool2520 (depth = 5)
  int op_slot_left_2516 = gc_frame_newslot(bool2520);
  params[0] = call2518;
  partcv[0] = 1;
  Object opresult2521 = callmethod(bool2520, "≠", 1, partcv, params);
// compiled op node returning opresult2521 (depth = 4)
  Object if2515 = done;
  if (istrue(opresult2521)) {
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2523 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2525 = alloc_Float64(2);
// compiled num node returning num2525 (depth = 8)
  int op_slot_right_2524 = gc_frame_newslot(num2525);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2524 = gc_frame_newslot(*var_depth);
  params[0] = num2525;
  partcv[0] = 1;
  Object sum2527 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2527 (depth = 7)
  gc_frame_newslot(sum2527);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2529 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2528);
// compiled call node returning call2529 (depth = 8)
// compiled member node returning call2529 (depth = 7)
  params[0] = sum2527;
  partcv[0] = 1;
  Object call2530 = callmethod(call2529, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2523);
// compiled call node returning call2530 (depth = 6)
  int op_slot_right_2522 = gc_frame_newslot(call2530);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2533 == NULL) {
    strlit2533 = alloc_String("else ");
    gc_root(strlit2533);
  }
// compiled string node returning strlit2533 (depth = 7)
  int op_slot_right_2532 = gc_frame_newslot(strlit2533);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2536 == NULL) {
    strlit2536 = alloc_String("    ");
    gc_root(strlit2536);
  }
// compiled string node returning strlit2536 (depth = 8)
  int op_slot_right_2535 = gc_frame_newslot(strlit2536);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2538 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2541 == NULL) {
    strlit2541 = alloc_String("""\x0a""");
    gc_root(strlit2541);
  }
// compiled string node returning strlit2541 (depth = 10)
  int op_slot_right_2540 = gc_frame_newslot(strlit2541);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2540 = gc_frame_newslot(*var_s);
  params[0] = strlit2541;
  partcv[0] = 1;
  Object opresult2543 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2543 (depth = 9)
  int op_slot_left_2538 = gc_frame_newslot(opresult2543);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2544 = callmethod(opresult2543, "++", 1, partcv, params);
// compiled op node returning opresult2544 (depth = 8)
  int op_slot_left_2535 = gc_frame_newslot(opresult2544);
  params[0] = strlit2536;
  partcv[0] = 1;
  Object opresult2545 = callmethod(opresult2544, "++", 1, partcv, params);
// compiled op node returning opresult2545 (depth = 7)
  int op_slot_left_2532 = gc_frame_newslot(opresult2545);
  params[0] = strlit2533;
  partcv[0] = 1;
  Object opresult2546 = callmethod(opresult2545, "++", 1, partcv, params);
// compiled op node returning opresult2546 (depth = 6)
  int op_slot_left_2522 = gc_frame_newslot(opresult2546);
  params[0] = call2530;
  partcv[0] = 1;
  Object opresult2547 = callmethod(opresult2546, "++", 1, partcv, params);
// compiled op node returning opresult2547 (depth = 5)
  *var_s = opresult2547;
  if (opresult2547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2515 = done;
  } else {
  }
// compiled if node returning if2515 (depth = 3)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2550 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2551 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2552 = alloc_Boolean(0);
// compiled identifier node returning bool2552 (depth = 5)
  gc_frame_newslot(bool2552);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchCaseNode (depth = 5)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2552;
  partcv[0] = 3;
  Object call2553 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2551);
// compiled call node returning call2553 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2554 = callmethod(call2553, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2550);
// compiled call node returning call2554 (depth = 3)
  gc_frame_end(frame);
  return call2554;
}
Object meth_ast_new2258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2259 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2259 = alloc_userobj2(14,12, objclass2259);
  gc_frame_newslot(obj2259);
if (objclass2259 == NULL) {
  glfree(obj2259->class->name);
  obj2259->class->name = "matchCaseNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2259, self, 0);
  addmethodreal(obj2259,"outer", &reader_ast_outer_2260);
  Object oldself2259 = self;
  struct StackFrameObject *oldstackframe2259 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2259);
  gc_frame_newslot((Object)stackframe);
  self = obj2259;
  Object *oldselfslot2259 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2259 = (*(struct UserObject *)self).data[0], lowerouter2259 = thisouter2259;
  if (inheritingObject2259) {
    struct UserObject *inho2259 = (struct UserObject *)inheritingObject2259;
    while (inho2259->super != GraceDefaultObject) inho2259 = (struct UserObject *)inho2259->super;
    inho2259->super = obj2259;
    self = inheritingObject2259;
    *selfslot = self;
    lowerouter2259 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2259;
  }
if (objclass2259 == NULL) {
  Method *reader2261 = addmethodrealflags(obj2259, "kind",&reader_ast_kind_2261, MFLAG_DEF);
  reader2261->definitionModule = modulename;
  reader2261->definitionLine = 474;
}
adddatum2(obj2259, alloc_Undefined(), 1);
if (objclass2259 == NULL) {
  Method *reader2262 = addmethodrealflags(obj2259, "value",&reader_ast_value_2262, 0);
  Method *writer2262 = addmethodrealflags(obj2259, "value:=",&writer_ast_value_2262, 0);
  reader2262->definitionModule = modulename;
  writer2262->definitionModule = modulename;
  reader2262->definitionLine = 475;
  writer2262->definitionLine = 475;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 2);
if (objclass2259 == NULL) {
  Method *reader2263 = addmethodrealflags(obj2259, "cases",&reader_ast_cases_2263, 0);
  Method *writer2263 = addmethodrealflags(obj2259, "cases:=",&writer_ast_cases_2263, 0);
  reader2263->definitionModule = modulename;
  writer2263->definitionModule = modulename;
  reader2263->definitionLine = 476;
  writer2263->definitionLine = 476;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 3);
if (objclass2259 == NULL) {
  Method *reader2264 = addmethodrealflags(obj2259, "elsecase",&reader_ast_elsecase_2264, 0);
  Method *writer2264 = addmethodrealflags(obj2259, "elsecase:=",&writer_ast_elsecase_2264, 0);
  reader2264->definitionModule = modulename;
  writer2264->definitionModule = modulename;
  reader2264->definitionLine = 477;
  writer2264->definitionLine = 477;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2265 = (struct UserObject*)obj2259;
  uo2265->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2265 = addmethod2pos(obj2259, "isSimple", &meth_ast_isSimple2265, 5);
  int argcv_meth_ast_isSimple2265[] = {0};
  meth_meth_ast_isSimple2265->type = alloc_MethodType(1, argcv_meth_ast_isSimple2265);
  meth_meth_ast_isSimple2265->definitionModule = modulename;
  meth_meth_ast_isSimple2265->definitionLine = 478;
// method "matchee"
  struct UserObject *uo2267 = (struct UserObject*)obj2259;
  uo2267->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2267 = addmethod2pos(obj2259, "matchee", &meth_ast_matchee2267, 6);
  int argcv_meth_ast_matchee2267[] = {0};
  meth_meth_ast_matchee2267->type = alloc_MethodType(1, argcv_meth_ast_matchee2267);
  meth_meth_ast_matchee2267->definitionModule = modulename;
  meth_meth_ast_matchee2267->definitionLine = 479;
// method "accept()from"
  struct UserObject *uo2270 = (struct UserObject*)obj2259;
  uo2270->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2270 = addmethod2pos(obj2259, "accept()from", &meth_ast_accept_40__41_from2270, 7);
  int argcv_meth_ast_accept_40__41_from2270[] = {1, 1};
  meth_meth_ast_accept_40__41_from2270->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2270);
  meth_meth_ast_accept_40__41_from2270->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2270->definitionLine = 480;
// method "map()ancestors"
  struct UserObject *uo2300 = (struct UserObject*)obj2259;
  uo2300->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2300 = addmethod2pos(obj2259, "map()ancestors", &meth_ast_map_40__41_ancestors2300, 8);
  int argcv_meth_ast_map_40__41_ancestors2300[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2300->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2300);
  meth_meth_ast_map_40__41_ancestors2300->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2300->definitionLine = 492;
// method "pretty"
  struct UserObject *uo2333 = (struct UserObject*)obj2259;
  uo2333->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2333 = addmethod2pos(obj2259, "pretty", &meth_ast_pretty2333, 9);
  int argcv_meth_ast_pretty2333[] = {1};
  meth_meth_ast_pretty2333->type = alloc_MethodType(1, argcv_meth_ast_pretty2333);
  meth_meth_ast_pretty2333->definitionModule = modulename;
  meth_meth_ast_pretty2333->definitionLine = 500;
// method "toGrace"
  struct UserObject *uo2450 = (struct UserObject*)obj2259;
  uo2450->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2450 = addmethod2pos(obj2259, "toGrace", &meth_ast_toGrace2450, 10);
  int argcv_meth_ast_toGrace2450[] = {1};
  meth_meth_ast_toGrace2450->type = alloc_MethodType(1, argcv_meth_ast_toGrace2450);
meth_meth_ast_toGrace2450->type->types[0] = type_Number;
meth_meth_ast_toGrace2450->type->names[0] = "depth";
  meth_meth_ast_toGrace2450->definitionModule = modulename;
  meth_meth_ast_toGrace2450->definitionLine = 515;
// method "shallowCopy"
  block_savedest(obj2259);
  Object closure2549 = createclosure(3, "shallowCopy");
  setclosureframe(closure2549, stackframe);
  addtoclosure(closure2549, var_nullNode);
  addtoclosure(closure2549, var_emptySeq);
  addtoclosure(closure2549, var_matchCaseNode);
  struct UserObject *uo2549 = (struct UserObject*)obj2259;
  uo2549->data[11] = (Object)closure2549;
  Method *meth_meth_ast_shallowCopy2549 = addmethod2pos(obj2259, "shallowCopy", &meth_ast_shallowCopy2549, 11);
  int argcv_meth_ast_shallowCopy2549[] = {0};
  meth_meth_ast_shallowCopy2549->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2549);
  meth_meth_ast_shallowCopy2549->definitionModule = modulename;
  meth_meth_ast_shallowCopy2549->definitionLine = 529;
  sourceObject = obj2259;
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2555 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2556 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2557 = gc_frame_new();
// call case 3: self.outer request
  Object call2558 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2557);
// compiled call node returning call2558 (depth = 7)
// compiled member node returning call2558 (depth = 6)
  partcv[0] = 0;
  Object call2559 = callmethodflags(call2558, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2559 (depth = 5)
// compiled member node returning call2559 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2560 = callmethodflags(call2559, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2555);
// compiled call node returning call2560 (depth = 3)
  struct UserObject *obj2259_uo = (struct UserObject *)obj2259;
  obj2259_uo->super = call2560;
  sourceObject = obj2259;
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2561 == NULL) {
    strlit2561 = alloc_String("matchcase");
    gc_root(strlit2561);
  }
// compiled string node returning strlit2561 (depth = 3)
  adddatum2(obj2259, strlit2561, 1);
  sourceObject = obj2259;
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2259, *var_matchee_39_, 2);
  sourceObject = obj2259;
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2259, *var_cases_39_, 3);
  sourceObject = obj2259;
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2259, *var_elsecase_39_, 4);
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  objclass2259 = obj2259->class;
  objclass2259->definitionModule = modulename;
  objclass2259->definitionLine = 472;
  (*(struct UserObject *)self).data[0] = lowerouter2259;
  self = oldself2259;
  selfslot = oldselfslot2259;
  stackframe = oldstackframe2259;
  gc_frame_end(frame);
  return obj2259;
}
Object meth_ast_new2258_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2259 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2259 = alloc_userobj2(14,12, objclass2259);
  gc_frame_newslot(obj2259);
if (objclass2259 == NULL) {
  glfree(obj2259->class->name);
  obj2259->class->name = "matchCaseNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2259, self, 0);
  addmethodreal(obj2259,"outer", &reader_ast_outer_2260);
  Object oldself2259 = self;
  struct StackFrameObject *oldstackframe2259 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2259);
  gc_frame_newslot((Object)stackframe);
  self = obj2259;
  Object *oldselfslot2259 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2259 = (*(struct UserObject *)self).data[0], lowerouter2259 = thisouter2259;
  if (inheritingObject2259) {
    struct UserObject *inho2259 = (struct UserObject *)inheritingObject2259;
    while (inho2259->super != GraceDefaultObject) inho2259 = (struct UserObject *)inho2259->super;
    inho2259->super = obj2259;
    self = inheritingObject2259;
    *selfslot = self;
    lowerouter2259 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2259;
  }
if (objclass2259 == NULL) {
  Method *reader2261 = addmethodrealflags(obj2259, "kind",&reader_ast_kind_2261, MFLAG_DEF);
  reader2261->definitionModule = modulename;
  reader2261->definitionLine = 474;
}
adddatum2(obj2259, alloc_Undefined(), 1);
if (objclass2259 == NULL) {
  Method *reader2262 = addmethodrealflags(obj2259, "value",&reader_ast_value_2262, 0);
  Method *writer2262 = addmethodrealflags(obj2259, "value:=",&writer_ast_value_2262, 0);
  reader2262->definitionModule = modulename;
  writer2262->definitionModule = modulename;
  reader2262->definitionLine = 475;
  writer2262->definitionLine = 475;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 2);
if (objclass2259 == NULL) {
  Method *reader2263 = addmethodrealflags(obj2259, "cases",&reader_ast_cases_2263, 0);
  Method *writer2263 = addmethodrealflags(obj2259, "cases:=",&writer_ast_cases_2263, 0);
  reader2263->definitionModule = modulename;
  writer2263->definitionModule = modulename;
  reader2263->definitionLine = 476;
  writer2263->definitionLine = 476;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 3);
if (objclass2259 == NULL) {
  Method *reader2264 = addmethodrealflags(obj2259, "elsecase",&reader_ast_elsecase_2264, 0);
  Method *writer2264 = addmethodrealflags(obj2259, "elsecase:=",&writer_ast_elsecase_2264, 0);
  reader2264->definitionModule = modulename;
  writer2264->definitionModule = modulename;
  reader2264->definitionLine = 477;
  writer2264->definitionLine = 477;
}
obj2259->flags |= OFLAG_MUTABLE;
adddatum2(obj2259, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo2265 = (struct UserObject*)obj2259;
  uo2265->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple2265 = addmethod2pos(obj2259, "isSimple", &meth_ast_isSimple2265, 5);
  int argcv_meth_ast_isSimple2265[] = {0};
  meth_meth_ast_isSimple2265->type = alloc_MethodType(1, argcv_meth_ast_isSimple2265);
  meth_meth_ast_isSimple2265->definitionModule = modulename;
  meth_meth_ast_isSimple2265->definitionLine = 478;
// method "matchee"
  struct UserObject *uo2267 = (struct UserObject*)obj2259;
  uo2267->data[6] = emptyclosure;
  Method *meth_meth_ast_matchee2267 = addmethod2pos(obj2259, "matchee", &meth_ast_matchee2267, 6);
  int argcv_meth_ast_matchee2267[] = {0};
  meth_meth_ast_matchee2267->type = alloc_MethodType(1, argcv_meth_ast_matchee2267);
  meth_meth_ast_matchee2267->definitionModule = modulename;
  meth_meth_ast_matchee2267->definitionLine = 479;
// method "accept()from"
  struct UserObject *uo2270 = (struct UserObject*)obj2259;
  uo2270->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2270 = addmethod2pos(obj2259, "accept()from", &meth_ast_accept_40__41_from2270, 7);
  int argcv_meth_ast_accept_40__41_from2270[] = {1, 1};
  meth_meth_ast_accept_40__41_from2270->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2270);
  meth_meth_ast_accept_40__41_from2270->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2270->definitionLine = 480;
// method "map()ancestors"
  struct UserObject *uo2300 = (struct UserObject*)obj2259;
  uo2300->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2300 = addmethod2pos(obj2259, "map()ancestors", &meth_ast_map_40__41_ancestors2300, 8);
  int argcv_meth_ast_map_40__41_ancestors2300[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2300->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2300);
  meth_meth_ast_map_40__41_ancestors2300->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2300->definitionLine = 492;
// method "pretty"
  struct UserObject *uo2333 = (struct UserObject*)obj2259;
  uo2333->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty2333 = addmethod2pos(obj2259, "pretty", &meth_ast_pretty2333, 9);
  int argcv_meth_ast_pretty2333[] = {1};
  meth_meth_ast_pretty2333->type = alloc_MethodType(1, argcv_meth_ast_pretty2333);
  meth_meth_ast_pretty2333->definitionModule = modulename;
  meth_meth_ast_pretty2333->definitionLine = 500;
// method "toGrace"
  struct UserObject *uo2450 = (struct UserObject*)obj2259;
  uo2450->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2450 = addmethod2pos(obj2259, "toGrace", &meth_ast_toGrace2450, 10);
  int argcv_meth_ast_toGrace2450[] = {1};
  meth_meth_ast_toGrace2450->type = alloc_MethodType(1, argcv_meth_ast_toGrace2450);
meth_meth_ast_toGrace2450->type->types[0] = type_Number;
meth_meth_ast_toGrace2450->type->names[0] = "depth";
  meth_meth_ast_toGrace2450->definitionModule = modulename;
  meth_meth_ast_toGrace2450->definitionLine = 515;
// method "shallowCopy"
  block_savedest(obj2259);
  Object closure2549 = createclosure(3, "shallowCopy");
  setclosureframe(closure2549, stackframe);
  addtoclosure(closure2549, var_nullNode);
  addtoclosure(closure2549, var_emptySeq);
  addtoclosure(closure2549, var_matchCaseNode);
  struct UserObject *uo2549 = (struct UserObject*)obj2259;
  uo2549->data[11] = (Object)closure2549;
  Method *meth_meth_ast_shallowCopy2549 = addmethod2pos(obj2259, "shallowCopy", &meth_ast_shallowCopy2549, 11);
  int argcv_meth_ast_shallowCopy2549[] = {0};
  meth_meth_ast_shallowCopy2549->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2549);
  meth_meth_ast_shallowCopy2549->definitionModule = modulename;
  meth_meth_ast_shallowCopy2549->definitionLine = 529;
  sourceObject = obj2259;
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2555 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2556 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2557 = gc_frame_new();
// call case 3: self.outer request
  Object call2558 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2557);
// compiled call node returning call2558 (depth = 7)
// compiled member node returning call2558 (depth = 6)
  partcv[0] = 0;
  Object call2559 = callmethodflags(call2558, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2559 (depth = 5)
// compiled member node returning call2559 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2560 = callmethodflags(call2559, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2555);
// compiled call node returning call2560 (depth = 3)
  struct UserObject *obj2259_uo = (struct UserObject *)obj2259;
  obj2259_uo->super = call2560;
  sourceObject = obj2259;
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2561 == NULL) {
    strlit2561 = alloc_String("matchcase");
    gc_root(strlit2561);
  }
// compiled string node returning strlit2561 (depth = 3)
  adddatum2(obj2259, strlit2561, 1);
  sourceObject = obj2259;
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchee_39_ (depth = 3)
  adddatum2(obj2259, *var_matchee_39_, 2);
  sourceObject = obj2259;
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cases_39_ (depth = 3)
  adddatum2(obj2259, *var_cases_39_, 3);
  sourceObject = obj2259;
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elsecase_39_ (depth = 3)
  adddatum2(obj2259, *var_elsecase_39_, 4);
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  sourceObject = obj2259;
  objclass2259 = obj2259->class;
  objclass2259->definitionModule = modulename;
  objclass2259->definitionLine = 472;
  (*(struct UserObject *)self).data[0] = lowerouter2259;
  self = oldself2259;
  selfslot = oldselfslot2259;
  stackframe = oldstackframe2259;
  gc_frame_end(frame);
  return obj2259;
}
Object meth_ast_matchCaseNode2563(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast_isExecutable2575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2576 = alloc_Boolean(0);
// compiled identifier node returning bool2576 (depth = 3)
  gc_frame_end(frame);
  return bool2576;
}
Object meth_ast__apply2583(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2584 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2585 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe2584);
// compiled call node returning call2585 (depth = 7)
  gc_frame_end(frame);
  return call2585;
}
Object meth_ast__apply2580(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2581 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2582 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2582);
// method "_apply"
  block_savedest(block2582);
  Object closure2583 = createclosure(2, "_apply");
  setclosureframe(closure2583, stackframe);
  addtoclosure(closure2583, var_b);
  addtoclosure(closure2583, selfslot);
  struct UserObject *uo2583 = (struct UserObject*)block2582;
  uo2583->data[0] = (Object)closure2583;
  Method *meth_meth_ast__apply2583 = addmethod2pos(block2582, "_apply", &meth_ast__apply2583, 0);
  int argcv_meth_ast__apply2583[] = {1};
  meth_meth_ast__apply2583->type = alloc_MethodType(1, argcv_meth_ast__apply2583);
  meth_meth_ast__apply2583->definitionModule = modulename;
  meth_meth_ast__apply2583->definitionLine = 473;
// compiled block node returning block2582 (depth = 6)
  gc_frame_newslot(block2582);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2587 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call2588 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2587);
// compiled call node returning call2588 (depth = 7)
// compiled member node returning call2588 (depth = 6)
  params[0] = block2582;
  partcv[0] = 1;
  Object call2589 = callmethod(call2588, "do",
    1, partcv, params);
  gc_frame_end(callframe2581);
// compiled call node returning call2589 (depth = 5)
  gc_frame_end(frame);
  return call2589;
}
Object meth_ast_parametersDo2577(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2578 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2579 = alloc_Block(NULL, NULL, "ast", 549);
  gc_frame_newslot(block2579);
// method "_apply"
  block_savedest(block2579);
  Object closure2580 = createclosure(2, "_apply");
  setclosureframe(closure2580, stackframe);
  addtoclosure(closure2580, var_b);
  addtoclosure(closure2580, selfslot);
  struct UserObject *uo2580 = (struct UserObject*)block2579;
  uo2580->data[0] = (Object)closure2580;
  Method *meth_meth_ast__apply2580 = addmethod2pos(block2579, "_apply", &meth_ast__apply2580, 0);
  int argcv_meth_ast__apply2580[] = {1};
  meth_meth_ast__apply2580->type = alloc_MethodType(1, argcv_meth_ast__apply2580);
  meth_meth_ast__apply2580->definitionModule = modulename;
  meth_meth_ast__apply2580->definitionLine = 473;
// compiled block node returning block2579 (depth = 4)
  gc_frame_newslot(block2579);
// call case 6: other member request
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2592 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2591);
// compiled call node returning call2592 (depth = 5)
// compiled member node returning call2592 (depth = 4)
  params[0] = block2579;
  partcv[0] = 1;
  Object call2593 = callmethod(call2592, "do",
    1, partcv, params);
  gc_frame_end(callframe2578);
// compiled call node returning call2593 (depth = 3)
  gc_frame_end(frame);
  return call2593;
}
Object meth_ast_scope_58__61_2594(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2595 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call2596 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2595);
// compiled call node returning call2596 (depth = 3)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2597 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2598 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe2597);
// compiled call node returning call2598 (depth = 3)
  gc_frame_end(frame);
  return call2598;
}
Object meth_ast_declarationKindWithAncestors2599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call2601 = callmethod(*var_k, "typedec",
    1, partcv, params);
  gc_frame_end(callframe2600);
// compiled call node returning call2601 (depth = 4)
// compiled member node returning call2601 (depth = 3)
  gc_frame_end(frame);
  return call2601;
}
Object meth_ast__apply2634(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2635 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2636 = callmethod(*var_part, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2635);
// compiled call node returning call2636 (depth = 6)
  gc_frame_end(frame);
  return call2636;
}
Object meth_ast_accept_40__41_from2602(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2604 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2605 = callmethod(*var_visitor, "visitMethodType()up",
    2, partcv, params);
  gc_frame_end(callframe2604);
// compiled call node returning call2605 (depth = 4)
  Object if2603 = done;
  if (istrue(call2605)) {
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2606 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call2607 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2606);
// compiled call node returning call2607 (depth = 5)
  *var_newChain = call2607;
  if (call2607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2610 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2611 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2610);
// compiled call node returning call2611 (depth = 7)
// compiled member node returning call2611 (depth = 6)
  int op_slot_right_2609 = gc_frame_newslot(call2611);
// starting to compile identifier node (depth = 6)
  Object bool2613 = alloc_Boolean(0);
// compiled identifier node returning bool2613 (depth = 6)
  int op_slot_left_2609 = gc_frame_newslot(bool2613);
  params[0] = call2611;
  partcv[0] = 1;
  Object opresult2614 = callmethod(bool2613, "≠", 1, partcv, params);
// compiled op node returning opresult2614 (depth = 5)
  Object if2608 = done;
  if (istrue(opresult2614)) {
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2615 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2616 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2617 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2616);
// compiled call node returning call2617 (depth = 7)
// compiled member node returning call2617 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2618 = callmethod(call2617, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2615);
// compiled call node returning call2618 (depth = 5)
    gc_frame_newslot(call2618);
    if2608 = call2618;
  } else {
  }
// compiled if node returning if2608 (depth = 4)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2621 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2622 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2621);
// compiled call node returning call2622 (depth = 7)
// compiled member node returning call2622 (depth = 6)
  int op_slot_right_2620 = gc_frame_newslot(call2622);
// starting to compile identifier node (depth = 6)
  Object bool2624 = alloc_Boolean(0);
// compiled identifier node returning bool2624 (depth = 6)
  int op_slot_left_2620 = gc_frame_newslot(bool2624);
  params[0] = call2622;
  partcv[0] = 1;
  Object opresult2625 = callmethod(bool2624, "≠", 1, partcv, params);
// compiled op node returning opresult2625 (depth = 5)
  Object if2619 = done;
  if (istrue(opresult2625)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2626 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2628 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2627);
// compiled call node returning call2628 (depth = 7)
// compiled member node returning call2628 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2629 = callmethod(call2628, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2626);
// compiled call node returning call2629 (depth = 5)
    gc_frame_newslot(call2629);
    if2619 = call2629;
  } else {
  }
// compiled if node returning if2619 (depth = 4)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2630 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2632 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2631);
// compiled call node returning call2632 (depth = 6)
// compiled member node returning call2632 (depth = 5)
  gc_frame_newslot(call2632);
// starting to compile block node (depth = 5)
  Object block2633 = alloc_Block(NULL, NULL, "ast", 569);
  gc_frame_newslot(block2633);
// method "_apply"
  block_savedest(block2633);
  Object closure2634 = createclosure(3, "_apply");
  setclosureframe(closure2634, stackframe);
  addtoclosure(closure2634, var_visitor);
  addtoclosure(closure2634, var_newChain);
  addtoclosure(closure2634, selfslot);
  struct UserObject *uo2634 = (struct UserObject*)block2633;
  uo2634->data[0] = (Object)closure2634;
  Method *meth_meth_ast__apply2634 = addmethod2pos(block2633, "_apply", &meth_ast__apply2634, 0);
  int argcv_meth_ast__apply2634[] = {1};
  meth_meth_ast__apply2634->type = alloc_MethodType(1, argcv_meth_ast__apply2634);
  meth_meth_ast__apply2634->definitionModule = modulename;
  meth_meth_ast__apply2634->definitionLine = 569;
// compiled block node returning block2633 (depth = 5)
  gc_frame_newslot(block2633);
// call case 5: prelude request
  params[0] = call2632;
  params[1] = block2633;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2638 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2630);
// compiled call node returning call2638 (depth = 4)
    gc_frame_newslot(call2638);
    if2603 = call2638;
  } else {
  }
// compiled if node returning if2603 (depth = 3)
  gc_frame_end(frame);
  return if2603;
}
Object meth_ast_map_40__41_ancestors2639(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2640 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2641 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2640);
// compiled call node returning call2641 (depth = 5)
// compiled member node returning call2641 (depth = 4)
  *var_n = call2641;
  if (call2641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2642 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2643 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe2642);
// compiled call node returning call2643 (depth = 4)
  *var_newChain = call2643;
  if (call2643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2644 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2645 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2646 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2647 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2646);
// compiled call node returning call2647 (depth = 6)
// compiled member node returning call2647 (depth = 5)
  gc_frame_newslot(call2647);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2648 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2649 = gc_frame_new();
// call case 3: self.outer request
  Object call2650 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2649);
// compiled call node returning call2650 (depth = 8)
// compiled member node returning call2650 (depth = 7)
  partcv[0] = 0;
  Object call2651 = callmethodflags(call2650, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2648);
// compiled call node returning call2651 (depth = 6)
// compiled member node returning call2651 (depth = 5)
  params[0] = call2647;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2652 = callmethodflags(call2651, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2645);
// compiled call node returning call2652 (depth = 4)
  gc_frame_newslot(call2652);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2652;
  partcv[0] = 1;
  Object call2653 = callmethod(*var_n, "rtype:=",
    1, partcv, params);
  gc_frame_end(callframe2644);
// compiled call node returning call2653 (depth = 3)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2654 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2655 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2657 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2656);
// compiled call node returning call2657 (depth = 6)
// compiled member node returning call2657 (depth = 5)
  gc_frame_newslot(call2657);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2658 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2659 = gc_frame_new();
// call case 3: self.outer request
  Object call2660 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2659);
// compiled call node returning call2660 (depth = 8)
// compiled member node returning call2660 (depth = 7)
  partcv[0] = 0;
  Object call2661 = callmethodflags(call2660, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2658);
// compiled call node returning call2661 (depth = 6)
// compiled member node returning call2661 (depth = 5)
  params[0] = call2657;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2662 = callmethodflags(call2661, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2655);
// compiled call node returning call2662 (depth = 4)
  gc_frame_newslot(call2662);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2662;
  partcv[0] = 1;
  Object call2663 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe2654);
// compiled call node returning call2663 (depth = 3)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2664 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe2665 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2666 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2667 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2666);
// compiled call node returning call2667 (depth = 6)
// compiled member node returning call2667 (depth = 5)
  gc_frame_newslot(call2667);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2668 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2669 = gc_frame_new();
// call case 3: self.outer request
  Object call2670 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2669);
// compiled call node returning call2670 (depth = 8)
// compiled member node returning call2670 (depth = 7)
  partcv[0] = 0;
  Object call2671 = callmethodflags(call2670, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2668);
// compiled call node returning call2671 (depth = 6)
// compiled member node returning call2671 (depth = 5)
  params[0] = call2667;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2672 = callmethodflags(call2671, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2665);
// compiled call node returning call2672 (depth = 4)
  gc_frame_newslot(call2672);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call2672;
  partcv[0] = 1;
  Object call2673 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe2664);
// compiled call node returning call2673 (depth = 3)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2674 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call2675 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2674);
// compiled call node returning call2675 (depth = 3)
  gc_frame_end(frame);
  return call2675;
}
Object meth_ast__apply2684(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2686 == NULL) {
    strlit2686 = alloc_String("  ");
    gc_root(strlit2686);
  }
// compiled string node returning strlit2686 (depth = 7)
  int op_slot_right_2685 = gc_frame_newslot(strlit2686);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_2685 = gc_frame_newslot(*var_spc);
  params[0] = strlit2686;
  partcv[0] = 1;
  Object opresult2688 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2688 (depth = 6)
  *var_spc = opresult2688;
  if (opresult2688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2823(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2825 == NULL) {
    strlit2825 = alloc_String("");
    gc_root(strlit2825);
  }
// compiled string node returning strlit2825 (depth = 7)
  int op_slot_right_2824 = gc_frame_newslot(strlit2825);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2828 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2830 = alloc_Float64(2);
// compiled num node returning num2830 (depth = 10)
  int op_slot_right_2829 = gc_frame_newslot(num2830);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2829 = gc_frame_newslot(*var_depth);
  params[0] = num2830;
  partcv[0] = 1;
  Object sum2832 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2832 (depth = 9)
  gc_frame_newslot(sum2832);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = sum2832;
  partcv[0] = 1;
  Object call2833 = callmethod(*var_part, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2828);
// compiled call node returning call2833 (depth = 8)
  int op_slot_right_2827 = gc_frame_newslot(call2833);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2836 == NULL) {
    strlit2836 = alloc_String("");
    gc_root(strlit2836);
  }
// compiled string node returning strlit2836 (depth = 9)
  int op_slot_right_2835 = gc_frame_newslot(strlit2836);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2838 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2841 == NULL) {
    strlit2841 = alloc_String("""\x0a""  ");
    gc_root(strlit2841);
  }
// compiled string node returning strlit2841 (depth = 11)
  int op_slot_right_2840 = gc_frame_newslot(strlit2841);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_2843 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit2845 == NULL) {
    strlit2845 = alloc_String("");
    gc_root(strlit2845);
  }
// compiled string node returning strlit2845 (depth = 12)
  int op_slot_left_2843 = gc_frame_newslot(strlit2845);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2846 = callmethod(strlit2845, "++", 1, partcv, params);
// compiled op node returning opresult2846 (depth = 11)
  int op_slot_left_2840 = gc_frame_newslot(opresult2846);
  params[0] = strlit2841;
  partcv[0] = 1;
  Object opresult2847 = callmethod(opresult2846, "++", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 10)
  int op_slot_left_2838 = gc_frame_newslot(opresult2847);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2848 = callmethod(opresult2847, "++", 1, partcv, params);
// compiled op node returning opresult2848 (depth = 9)
  int op_slot_left_2835 = gc_frame_newslot(opresult2848);
  params[0] = strlit2836;
  partcv[0] = 1;
  Object opresult2849 = callmethod(opresult2848, "++", 1, partcv, params);
// compiled op node returning opresult2849 (depth = 8)
  int op_slot_left_2827 = gc_frame_newslot(opresult2849);
  params[0] = call2833;
  partcv[0] = 1;
  Object opresult2850 = callmethod(opresult2849, "++", 1, partcv, params);
// compiled op node returning opresult2850 (depth = 7)
  int op_slot_left_2824 = gc_frame_newslot(opresult2850);
  params[0] = strlit2825;
  partcv[0] = 1;
  Object opresult2851 = callmethod(opresult2850, "++", 1, partcv, params);
// compiled op node returning opresult2851 (depth = 6)
  *var_s = opresult2851;
  if (opresult2851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2677 == NULL) {
    strlit2677 = alloc_String("");
    gc_root(strlit2677);
  }
// compiled string node returning strlit2677 (depth = 4)
  *var_spc = strlit2677;
  if (strlit2677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2678 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_2679 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num2681 = alloc_Float64(0);
// compiled num node returning num2681 (depth = 5)
  int op_slot_left_2679 = gc_frame_newslot(num2681);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2682 = callmethod(num2681, "..", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 4)
  gc_frame_newslot(opresult2682);
// starting to compile block node (depth = 4)
  Object block2683 = alloc_Block(NULL, NULL, "ast", 584);
  gc_frame_newslot(block2683);
// method "_apply"
  block_savedest(block2683);
  Object closure2684 = createclosure(2, "_apply");
  setclosureframe(closure2684, stackframe);
  addtoclosure(closure2684, var_spc);
  addtoclosure(closure2684, selfslot);
  struct UserObject *uo2684 = (struct UserObject*)block2683;
  uo2684->data[0] = (Object)closure2684;
  Method *meth_meth_ast__apply2684 = addmethod2pos(block2683, "_apply", &meth_ast__apply2684, 0);
  int argcv_meth_ast__apply2684[] = {1};
  meth_meth_ast__apply2684->type = alloc_MethodType(1, argcv_meth_ast__apply2684);
  meth_meth_ast__apply2684->definitionModule = modulename;
  meth_meth_ast__apply2684->definitionLine = 579;
// compiled block node returning block2683 (depth = 4)
  gc_frame_newslot(block2683);
// call case 5: prelude request
  params[0] = opresult2682;
  params[1] = block2683;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2691 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2678);
// compiled call node returning call2691 (depth = 3)
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2693 == NULL) {
    strlit2693 = alloc_String("""\x0a""");
    gc_root(strlit2693);
  }
// compiled string node returning strlit2693 (depth = 5)
  int op_slot_right_2692 = gc_frame_newslot(strlit2693);
// starting to compile call node (depth = 5)
  int callframe2695 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2696 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2695);
// compiled call node returning call2696 (depth = 5)
  int op_slot_left_2692 = gc_frame_newslot(call2696);
  params[0] = strlit2693;
  partcv[0] = 1;
  Object opresult2697 = callmethod(call2696, "++", 1, partcv, params);
// compiled op node returning opresult2697 (depth = 4)
  *var_s = opresult2697;
  if (opresult2697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2699 == NULL) {
    strlit2699 = alloc_String("""\x0a""");
    gc_root(strlit2699);
  }
// compiled string node returning strlit2699 (depth = 5)
  int op_slot_right_2698 = gc_frame_newslot(strlit2699);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2703 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2702);
// compiled call node returning call2703 (depth = 7)
// compiled member node returning call2703 (depth = 6)
  int op_slot_right_2701 = gc_frame_newslot(call2703);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2706 == NULL) {
    strlit2706 = alloc_String("Name: ");
    gc_root(strlit2706);
  }
// compiled string node returning strlit2706 (depth = 7)
  int op_slot_right_2705 = gc_frame_newslot(strlit2706);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2708 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2711 == NULL) {
    strlit2711 = alloc_String("");
    gc_root(strlit2711);
  }
// compiled string node returning strlit2711 (depth = 9)
  int op_slot_right_2710 = gc_frame_newslot(strlit2711);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2713 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2715 == NULL) {
    strlit2715 = alloc_String("");
    gc_root(strlit2715);
  }
// compiled string node returning strlit2715 (depth = 10)
  int op_slot_left_2713 = gc_frame_newslot(strlit2715);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2716 = callmethod(strlit2715, "++", 1, partcv, params);
// compiled op node returning opresult2716 (depth = 9)
  int op_slot_left_2710 = gc_frame_newslot(opresult2716);
  params[0] = strlit2711;
  partcv[0] = 1;
  Object opresult2717 = callmethod(opresult2716, "++", 1, partcv, params);
// compiled op node returning opresult2717 (depth = 8)
  int op_slot_left_2708 = gc_frame_newslot(opresult2717);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2718 = callmethod(opresult2717, "++", 1, partcv, params);
// compiled op node returning opresult2718 (depth = 7)
  int op_slot_left_2705 = gc_frame_newslot(opresult2718);
  params[0] = strlit2706;
  partcv[0] = 1;
  Object opresult2719 = callmethod(opresult2718, "++", 1, partcv, params);
// compiled op node returning opresult2719 (depth = 6)
  int op_slot_left_2701 = gc_frame_newslot(opresult2719);
  params[0] = call2703;
  partcv[0] = 1;
  Object opresult2720 = callmethod(opresult2719, "++", 1, partcv, params);
// compiled op node returning opresult2720 (depth = 5)
  int op_slot_left_2698 = gc_frame_newslot(opresult2720);
  params[0] = strlit2699;
  partcv[0] = 1;
  Object opresult2721 = callmethod(opresult2720, "++", 1, partcv, params);
// compiled op node returning opresult2721 (depth = 4)
  *var_s = opresult2721;
  if (opresult2721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2725 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2726 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2725);
// compiled call node returning call2726 (depth = 6)
// compiled member node returning call2726 (depth = 5)
  int op_slot_right_2724 = gc_frame_newslot(call2726);
// starting to compile identifier node (depth = 5)
  Object bool2728 = alloc_Boolean(0);
// compiled identifier node returning bool2728 (depth = 5)
  int op_slot_left_2724 = gc_frame_newslot(bool2728);
  params[0] = call2726;
  partcv[0] = 1;
  Object opresult2729 = callmethod(bool2728, "≠", 1, partcv, params);
// compiled op node returning opresult2729 (depth = 4)
  Object if2723 = done;
  if (istrue(opresult2729)) {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2731 == NULL) {
    strlit2731 = alloc_String("");
    gc_root(strlit2731);
  }
// compiled string node returning strlit2731 (depth = 6)
  int op_slot_right_2730 = gc_frame_newslot(strlit2731);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2734 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2736 = alloc_Float64(2);
// compiled num node returning num2736 (depth = 9)
  int op_slot_right_2735 = gc_frame_newslot(num2736);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2735 = gc_frame_newslot(*var_depth);
  params[0] = num2736;
  partcv[0] = 1;
  Object sum2738 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2738 (depth = 8)
  gc_frame_newslot(sum2738);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2739 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2740 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2739);
// compiled call node returning call2740 (depth = 9)
// compiled member node returning call2740 (depth = 8)
  params[0] = sum2738;
  partcv[0] = 1;
  Object call2741 = callmethod(call2740, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2734);
// compiled call node returning call2741 (depth = 7)
  int op_slot_right_2733 = gc_frame_newslot(call2741);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2744 == NULL) {
    strlit2744 = alloc_String("");
    gc_root(strlit2744);
  }
// compiled string node returning strlit2744 (depth = 8)
  int op_slot_right_2743 = gc_frame_newslot(strlit2744);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2746 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2749 == NULL) {
    strlit2749 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2749);
  }
// compiled string node returning strlit2749 (depth = 10)
  int op_slot_right_2748 = gc_frame_newslot(strlit2749);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2751 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2754 == NULL) {
    strlit2754 = alloc_String("");
    gc_root(strlit2754);
  }
// compiled string node returning strlit2754 (depth = 12)
  int op_slot_right_2753 = gc_frame_newslot(strlit2754);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2756 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2758 == NULL) {
    strlit2758 = alloc_String("");
    gc_root(strlit2758);
  }
// compiled string node returning strlit2758 (depth = 13)
  int op_slot_left_2756 = gc_frame_newslot(strlit2758);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2759 = callmethod(strlit2758, "++", 1, partcv, params);
// compiled op node returning opresult2759 (depth = 12)
  int op_slot_left_2753 = gc_frame_newslot(opresult2759);
  params[0] = strlit2754;
  partcv[0] = 1;
  Object opresult2760 = callmethod(opresult2759, "++", 1, partcv, params);
// compiled op node returning opresult2760 (depth = 11)
  int op_slot_left_2751 = gc_frame_newslot(opresult2760);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2761 = callmethod(opresult2760, "++", 1, partcv, params);
// compiled op node returning opresult2761 (depth = 10)
  int op_slot_left_2748 = gc_frame_newslot(opresult2761);
  params[0] = strlit2749;
  partcv[0] = 1;
  Object opresult2762 = callmethod(opresult2761, "++", 1, partcv, params);
// compiled op node returning opresult2762 (depth = 9)
  int op_slot_left_2746 = gc_frame_newslot(opresult2762);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2763 = callmethod(opresult2762, "++", 1, partcv, params);
// compiled op node returning opresult2763 (depth = 8)
  int op_slot_left_2743 = gc_frame_newslot(opresult2763);
  params[0] = strlit2744;
  partcv[0] = 1;
  Object opresult2764 = callmethod(opresult2763, "++", 1, partcv, params);
// compiled op node returning opresult2764 (depth = 7)
  int op_slot_left_2733 = gc_frame_newslot(opresult2764);
  params[0] = call2741;
  partcv[0] = 1;
  Object opresult2765 = callmethod(opresult2764, "++", 1, partcv, params);
// compiled op node returning opresult2765 (depth = 6)
  int op_slot_left_2730 = gc_frame_newslot(opresult2765);
  params[0] = strlit2731;
  partcv[0] = 1;
  Object opresult2766 = callmethod(opresult2765, "++", 1, partcv, params);
// compiled op node returning opresult2766 (depth = 5)
  *var_s = opresult2766;
  if (opresult2766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2723 = done;
  } else {
  }
// compiled if node returning if2723 (depth = 3)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2771 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2770);
// compiled call node returning call2771 (depth = 6)
// compiled member node returning call2771 (depth = 5)
  int op_slot_right_2769 = gc_frame_newslot(call2771);
// starting to compile identifier node (depth = 5)
  Object bool2773 = alloc_Boolean(0);
// compiled identifier node returning bool2773 (depth = 5)
  int op_slot_left_2769 = gc_frame_newslot(bool2773);
  params[0] = call2771;
  partcv[0] = 1;
  Object opresult2774 = callmethod(bool2773, "≠", 1, partcv, params);
// compiled op node returning opresult2774 (depth = 4)
  Object if2768 = done;
  if (istrue(opresult2774)) {
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2776 == NULL) {
    strlit2776 = alloc_String("TypeParams:""\x0a""");
    gc_root(strlit2776);
  }
// compiled string node returning strlit2776 (depth = 6)
  int op_slot_right_2775 = gc_frame_newslot(strlit2776);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2778 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2781 == NULL) {
    strlit2781 = alloc_String("""\x0a""");
    gc_root(strlit2781);
  }
// compiled string node returning strlit2781 (depth = 8)
  int op_slot_right_2780 = gc_frame_newslot(strlit2781);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2783 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2785 == NULL) {
    strlit2785 = alloc_String("");
    gc_root(strlit2785);
  }
// compiled string node returning strlit2785 (depth = 9)
  int op_slot_left_2783 = gc_frame_newslot(strlit2785);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2786 = callmethod(strlit2785, "++", 1, partcv, params);
// compiled op node returning opresult2786 (depth = 8)
  int op_slot_left_2780 = gc_frame_newslot(opresult2786);
  params[0] = strlit2781;
  partcv[0] = 1;
  Object opresult2787 = callmethod(opresult2786, "++", 1, partcv, params);
// compiled op node returning opresult2787 (depth = 7)
  int op_slot_left_2778 = gc_frame_newslot(opresult2787);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2788 = callmethod(opresult2787, "++", 1, partcv, params);
// compiled op node returning opresult2788 (depth = 6)
  int op_slot_left_2775 = gc_frame_newslot(opresult2788);
  params[0] = strlit2776;
  partcv[0] = 1;
  Object opresult2789 = callmethod(opresult2788, "++", 1, partcv, params);
// compiled op node returning opresult2789 (depth = 5)
  *var_s = opresult2789;
  if (opresult2789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2792 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2794 = alloc_Float64(2);
// compiled num node returning num2794 (depth = 8)
  int op_slot_right_2793 = gc_frame_newslot(num2794);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2793 = gc_frame_newslot(*var_depth);
  params[0] = num2794;
  partcv[0] = 1;
  Object sum2796 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2796 (depth = 7)
  gc_frame_newslot(sum2796);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2798 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2797);
// compiled call node returning call2798 (depth = 8)
// compiled member node returning call2798 (depth = 7)
  params[0] = sum2796;
  partcv[0] = 1;
  Object call2799 = callmethod(call2798, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2792);
// compiled call node returning call2799 (depth = 6)
  int op_slot_right_2791 = gc_frame_newslot(call2799);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2791 = gc_frame_newslot(*var_s);
  params[0] = call2799;
  partcv[0] = 1;
  Object opresult2801 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2801 (depth = 5)
  *var_s = opresult2801;
  if (opresult2801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2768 = done;
  } else {
  }
// compiled if node returning if2768 (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2804 == NULL) {
    strlit2804 = alloc_String("Signature:");
    gc_root(strlit2804);
  }
// compiled string node returning strlit2804 (depth = 5)
  int op_slot_right_2803 = gc_frame_newslot(strlit2804);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_2806 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2809 == NULL) {
    strlit2809 = alloc_String("""\x0a""");
    gc_root(strlit2809);
  }
// compiled string node returning strlit2809 (depth = 7)
  int op_slot_right_2808 = gc_frame_newslot(strlit2809);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_2811 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit2813 == NULL) {
    strlit2813 = alloc_String("");
    gc_root(strlit2813);
  }
// compiled string node returning strlit2813 (depth = 8)
  int op_slot_left_2811 = gc_frame_newslot(strlit2813);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2814 = callmethod(strlit2813, "++", 1, partcv, params);
// compiled op node returning opresult2814 (depth = 7)
  int op_slot_left_2808 = gc_frame_newslot(opresult2814);
  params[0] = strlit2809;
  partcv[0] = 1;
  Object opresult2815 = callmethod(opresult2814, "++", 1, partcv, params);
// compiled op node returning opresult2815 (depth = 6)
  int op_slot_left_2806 = gc_frame_newslot(opresult2815);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2816 = callmethod(opresult2815, "++", 1, partcv, params);
// compiled op node returning opresult2816 (depth = 5)
  int op_slot_left_2803 = gc_frame_newslot(opresult2816);
  params[0] = strlit2804;
  partcv[0] = 1;
  Object opresult2817 = callmethod(opresult2816, "++", 1, partcv, params);
// compiled op node returning opresult2817 (depth = 4)
  *var_s = opresult2817;
  if (opresult2817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2819 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2820 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2821 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2820);
// compiled call node returning call2821 (depth = 5)
// compiled member node returning call2821 (depth = 4)
  gc_frame_newslot(call2821);
// starting to compile block node (depth = 4)
  Object block2822 = alloc_Block(NULL, NULL, "ast", 597);
  gc_frame_newslot(block2822);
// method "_apply"
  block_savedest(block2822);
  Object closure2823 = createclosure(4, "_apply");
  setclosureframe(closure2823, stackframe);
  addtoclosure(closure2823, var_depth);
  addtoclosure(closure2823, var_spc);
  addtoclosure(closure2823, var_s);
  addtoclosure(closure2823, selfslot);
  struct UserObject *uo2823 = (struct UserObject*)block2822;
  uo2823->data[0] = (Object)closure2823;
  Method *meth_meth_ast__apply2823 = addmethod2pos(block2822, "_apply", &meth_ast__apply2823, 0);
  int argcv_meth_ast__apply2823[] = {1};
  meth_meth_ast__apply2823->type = alloc_MethodType(1, argcv_meth_ast__apply2823);
  meth_meth_ast__apply2823->definitionModule = modulename;
  meth_meth_ast__apply2823->definitionLine = 597;
// compiled block node returning block2822 (depth = 4)
  gc_frame_newslot(block2822);
// call case 5: prelude request
  params[0] = call2821;
  params[1] = block2822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2854 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2819);
// compiled call node returning call2854 (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2907(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2908 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  gc_frame_newslot(*var_pnr);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call2910 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2909);
// compiled call node returning call2910 (depth = 11)
// compiled member node returning call2910 (depth = 10)
  params[0] = *var_pnr;
  partcv[0] = 1;
  Object call2911 = callmethod(call2910, "at",
    1, partcv, params);
  gc_frame_end(callframe2908);
// compiled call node returning call2911 (depth = 9)
  *var_p = call2911;
  if (call2911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2913 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2915 = alloc_Float64(1);
// compiled num node returning num2915 (depth = 12)
  int op_slot_right_2914 = gc_frame_newslot(num2915);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_2914 = gc_frame_newslot(*var_depth);
  params[0] = num2915;
  partcv[0] = 1;
  Object sum2917 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2917 (depth = 11)
  gc_frame_newslot(sum2917);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum2917;
  partcv[0] = 1;
  Object call2918 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2913);
// compiled call node returning call2918 (depth = 10)
  int op_slot_right_2912 = gc_frame_newslot(call2918);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2912 = gc_frame_newslot(*var_s);
  params[0] = call2918;
  partcv[0] = 1;
  Object opresult2920 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2920 (depth = 9)
  *var_s = opresult2920;
  if (opresult2920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2924 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call2926 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2925);
// compiled call node returning call2926 (depth = 13)
// compiled member node returning call2926 (depth = 12)
  partcv[0] = 0;
  Object call2927 = callmethod(call2926, "size",
    1, partcv, params);
  gc_frame_end(callframe2924);
// compiled call node returning call2927 (depth = 11)
// compiled member node returning call2927 (depth = 10)
  int op_slot_right_2923 = gc_frame_newslot(call2927);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  int op_slot_left_2923 = gc_frame_newslot(*var_pnr);
  params[0] = call2927;
  partcv[0] = 1;
  Object opresult2929 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult2929 (depth = 9)
  Object if2922 = done;
  if (istrue(opresult2929)) {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2931 == NULL) {
    strlit2931 = alloc_String(", ");
    gc_root(strlit2931);
  }
// compiled string node returning strlit2931 (depth = 11)
  int op_slot_right_2930 = gc_frame_newslot(strlit2931);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2930 = gc_frame_newslot(*var_s);
  params[0] = strlit2931;
  partcv[0] = 1;
  Object opresult2933 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2933 (depth = 10)
  *var_s = opresult2933;
  if (opresult2933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2922 = done;
  } else {
  }
// compiled if node returning if2922 (depth = 8)
  gc_frame_end(frame);
  return if2922;
}
Object meth_ast__apply2862(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call2865 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2864);
// compiled call node returning call2865 (depth = 8)
// compiled member node returning call2865 (depth = 7)
  int op_slot_right_2863 = gc_frame_newslot(call2865);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2863 = gc_frame_newslot(*var_s);
  params[0] = call2865;
  partcv[0] = 1;
  Object opresult2867 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2867 (depth = 6)
  *var_s = opresult2867;
  if (opresult2867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_firstPart (depth = 6)
  Object if2869 = done;
  if (istrue(*var_firstPart)) {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2870 = alloc_Boolean(0);
// compiled identifier node returning bool2870 (depth = 7)
  *var_firstPart = bool2870;
  if (bool2870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2874 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2875 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2874);
// compiled call node returning call2875 (depth = 9)
// compiled member node returning call2875 (depth = 8)
  int op_slot_right_2873 = gc_frame_newslot(call2875);
// starting to compile identifier node (depth = 8)
  Object bool2877 = alloc_Boolean(0);
// compiled identifier node returning bool2877 (depth = 8)
  int op_slot_left_2873 = gc_frame_newslot(bool2877);
  params[0] = call2875;
  partcv[0] = 1;
  Object opresult2878 = callmethod(bool2877, "≠", 1, partcv, params);
// compiled op node returning opresult2878 (depth = 7)
  Object if2872 = done;
  if (istrue(opresult2878)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2879 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2881 = alloc_Float64(1);
// compiled num node returning num2881 (depth = 9)
  int op_slot_right_2880 = gc_frame_newslot(num2881);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2880 = gc_frame_newslot(*var_depth);
  params[0] = num2881;
  partcv[0] = 1;
  Object sum2883 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2883 (depth = 8)
  gc_frame_newslot(sum2883);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2884 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2885 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2884);
// compiled call node returning call2885 (depth = 9)
// compiled member node returning call2885 (depth = 8)
  params[0] = sum2883;
  partcv[0] = 1;
  Object call2886 = callmethod(call2885, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2879);
// compiled call node returning call2886 (depth = 7)
    gc_frame_newslot(call2886);
    if2872 = call2886;
  } else {
  }
// compiled if node returning if2872 (depth = 6)
    gc_frame_newslot(if2872);
    if2869 = if2872;
  } else {
  }
// compiled if node returning if2869 (depth = 5)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2889 = alloc_Float64(0);
// compiled num node returning num2889 (depth = 7)
  int op_slot_right_2888 = gc_frame_newslot(num2889);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2891 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2893 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2892);
// compiled call node returning call2893 (depth = 10)
// compiled member node returning call2893 (depth = 9)
  partcv[0] = 0;
  Object call2894 = callmethod(call2893, "size",
    1, partcv, params);
  gc_frame_end(callframe2891);
// compiled call node returning call2894 (depth = 8)
// compiled member node returning call2894 (depth = 7)
  int op_slot_left_2888 = gc_frame_newslot(call2894);
  params[0] = num2889;
  partcv[0] = 1;
  Object opresult2895 = callmethod(call2894, ">", 1, partcv, params);
// compiled op node returning opresult2895 (depth = 6)
  Object if2887 = done;
  if (istrue(opresult2895)) {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2897 == NULL) {
    strlit2897 = alloc_String("(");
    gc_root(strlit2897);
  }
// compiled string node returning strlit2897 (depth = 8)
  int op_slot_right_2896 = gc_frame_newslot(strlit2897);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2896 = gc_frame_newslot(*var_s);
  params[0] = strlit2897;
  partcv[0] = 1;
  Object opresult2899 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2899 (depth = 7)
  *var_s = opresult2899;
  if (opresult2899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2901 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2902 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2904 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2903);
// compiled call node returning call2904 (depth = 10)
// compiled member node returning call2904 (depth = 9)
  partcv[0] = 0;
  Object call2905 = callmethod(call2904, "indices",
    1, partcv, params);
  gc_frame_end(callframe2902);
// compiled call node returning call2905 (depth = 8)
// compiled member node returning call2905 (depth = 7)
  gc_frame_newslot(call2905);
// starting to compile block node (depth = 7)
  Object block2906 = alloc_Block(NULL, NULL, "ast", 615);
  gc_frame_newslot(block2906);
// method "_apply"
  block_savedest(block2906);
  Object closure2907 = createclosure(4, "_apply");
  setclosureframe(closure2907, stackframe);
  addtoclosure(closure2907, var_part);
  addtoclosure(closure2907, var_depth);
  addtoclosure(closure2907, var_s);
  addtoclosure(closure2907, selfslot);
  struct UserObject *uo2907 = (struct UserObject*)block2906;
  uo2907->data[0] = (Object)closure2907;
  Method *meth_meth_ast__apply2907 = addmethod2pos(block2906, "_apply", &meth_ast__apply2907, 0);
  int argcv_meth_ast__apply2907[] = {1};
  meth_meth_ast__apply2907->type = alloc_MethodType(1, argcv_meth_ast__apply2907);
  meth_meth_ast__apply2907->definitionModule = modulename;
  meth_meth_ast__apply2907->definitionLine = 615;
// compiled block node returning block2906 (depth = 7)
  gc_frame_newslot(block2906);
// call case 5: prelude request
  params[0] = call2905;
  params[1] = block2906;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2936 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2901);
// compiled call node returning call2936 (depth = 6)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2938 == NULL) {
    strlit2938 = alloc_String(")");
    gc_root(strlit2938);
  }
// compiled string node returning strlit2938 (depth = 8)
  int op_slot_right_2937 = gc_frame_newslot(strlit2938);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2937 = gc_frame_newslot(*var_s);
  params[0] = strlit2938;
  partcv[0] = 1;
  Object opresult2940 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2940 (depth = 7)
  *var_s = opresult2940;
  if (opresult2940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2887 = done;
  } else {
  }
// compiled if node returning if2887 (depth = 5)
  gc_frame_end(frame);
  return if2887;
}
Object meth_ast_toGrace2855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_firstPart = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstPart");
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit2856 == NULL) {
    strlit2856 = alloc_String("");
    gc_root(strlit2856);
  }
// compiled string node returning strlit2856 (depth = 4)
  *var_s = strlit2856;
  if (strlit2856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2857 = alloc_Boolean(1);
// compiled identifier node returning bool2857 (depth = 4)
  *var_firstPart = bool2857;
  if (bool2857 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2858 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2860 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2859);
// compiled call node returning call2860 (depth = 5)
// compiled member node returning call2860 (depth = 4)
  gc_frame_newslot(call2860);
// starting to compile block node (depth = 4)
  Object block2861 = alloc_Block(NULL, NULL, "ast", 605);
  gc_frame_newslot(block2861);
// method "_apply"
  block_savedest(block2861);
  Object closure2862 = createclosure(4, "_apply");
  setclosureframe(closure2862, stackframe);
  addtoclosure(closure2862, var_s);
  addtoclosure(closure2862, var_firstPart);
  addtoclosure(closure2862, var_depth);
  addtoclosure(closure2862, selfslot);
  struct UserObject *uo2862 = (struct UserObject*)block2861;
  uo2862->data[0] = (Object)closure2862;
  Method *meth_meth_ast__apply2862 = addmethod2pos(block2861, "_apply", &meth_ast__apply2862, 0);
  int argcv_meth_ast__apply2862[] = {1};
  meth_meth_ast__apply2862->type = alloc_MethodType(1, argcv_meth_ast__apply2862);
  meth_meth_ast__apply2862->definitionModule = modulename;
  meth_meth_ast__apply2862->definitionLine = 605;
// compiled block node returning block2861 (depth = 4)
  gc_frame_newslot(block2861);
// call case 5: prelude request
  params[0] = call2860;
  params[1] = block2861;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2943 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2858);
// compiled call node returning call2943 (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2946 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2947 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2946);
// compiled call node returning call2947 (depth = 6)
// compiled member node returning call2947 (depth = 5)
  int op_slot_right_2945 = gc_frame_newslot(call2947);
// starting to compile identifier node (depth = 5)
  Object bool2949 = alloc_Boolean(0);
// compiled identifier node returning bool2949 (depth = 5)
  int op_slot_left_2945 = gc_frame_newslot(bool2949);
  params[0] = call2947;
  partcv[0] = 1;
  Object opresult2950 = callmethod(bool2949, "≠", 1, partcv, params);
// compiled op node returning opresult2950 (depth = 4)
  Object if2944 = done;
  if (istrue(opresult2950)) {
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2952 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2954 = alloc_Float64(1);
// compiled num node returning num2954 (depth = 8)
  int op_slot_right_2953 = gc_frame_newslot(num2954);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_2953 = gc_frame_newslot(*var_depth);
  params[0] = num2954;
  partcv[0] = 1;
  Object sum2956 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2956 (depth = 7)
  gc_frame_newslot(sum2956);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2958 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2957);
// compiled call node returning call2958 (depth = 8)
// compiled member node returning call2958 (depth = 7)
  params[0] = sum2956;
  partcv[0] = 1;
  Object call2959 = callmethod(call2958, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2952);
// compiled call node returning call2959 (depth = 6)
  int op_slot_right_2951 = gc_frame_newslot(call2959);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2962 == NULL) {
    strlit2962 = alloc_String(" -> ");
    gc_root(strlit2962);
  }
// compiled string node returning strlit2962 (depth = 7)
  int op_slot_right_2961 = gc_frame_newslot(strlit2962);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2961 = gc_frame_newslot(*var_s);
  params[0] = strlit2962;
  partcv[0] = 1;
  Object opresult2964 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2964 (depth = 6)
  int op_slot_left_2951 = gc_frame_newslot(opresult2964);
  params[0] = call2959;
  partcv[0] = 1;
  Object opresult2965 = callmethod(opresult2964, "++", 1, partcv, params);
// compiled op node returning opresult2965 (depth = 5)
  *var_s = opresult2965;
  if (opresult2965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if2944 = done;
  } else {
  }
// compiled if node returning if2944 (depth = 3)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy2967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2968 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2969 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2970 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2971 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2970);
// compiled call node returning call2971 (depth = 6)
// compiled member node returning call2971 (depth = 5)
  gc_frame_newslot(call2971);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool2972 = alloc_Boolean(0);
// compiled identifier node returning bool2972 (depth = 5)
  gc_frame_newslot(bool2972);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeNode (depth = 5)
  params[0] = call2971;
  params[1] = *var_emptySeq;
  params[2] = bool2972;
  partcv[0] = 3;
  Object call2973 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2969);
// compiled call node returning call2973 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call2974 = callmethod(call2973, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe2968);
// compiled call node returning call2974 (depth = 3)
  gc_frame_end(frame);
  return call2974;
}
Object meth_ast_new2566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_methodTypeNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2567 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2567 = alloc_userobj2(19,16, objclass2567);
  gc_frame_newslot(obj2567);
if (objclass2567 == NULL) {
  glfree(obj2567->class->name);
  obj2567->class->name = "methodTypeNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2567, self, 0);
  addmethodreal(obj2567,"outer", &reader_ast_outer_2568);
  Object oldself2567 = self;
  struct StackFrameObject *oldstackframe2567 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2567);
  gc_frame_newslot((Object)stackframe);
  self = obj2567;
  Object *oldselfslot2567 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2567 = (*(struct UserObject *)self).data[0], lowerouter2567 = thisouter2567;
  if (inheritingObject2567) {
    struct UserObject *inho2567 = (struct UserObject *)inheritingObject2567;
    while (inho2567->super != GraceDefaultObject) inho2567 = (struct UserObject *)inho2567->super;
    inho2567->super = obj2567;
    self = inheritingObject2567;
    *selfslot = self;
    lowerouter2567 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2567;
  }
if (objclass2567 == NULL) {
  Method *reader2569 = addmethodrealflags(obj2567, "kind",&reader_ast_kind_2569, MFLAG_DEF);
  reader2569->definitionModule = modulename;
  reader2569->definitionLine = 540;
}
adddatum2(obj2567, alloc_Undefined(), 1);
if (objclass2567 == NULL) {
  Method *reader2570 = addmethodrealflags(obj2567, "value",&reader_ast_value_2570, 0);
  Method *writer2570 = addmethodrealflags(obj2567, "value:=",&writer_ast_value_2570, 0);
  reader2570->definitionModule = modulename;
  writer2570->definitionModule = modulename;
  reader2570->definitionLine = 541;
  writer2570->definitionLine = 541;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 2);
if (objclass2567 == NULL) {
  Method *reader2571 = addmethodrealflags(obj2567, "signature",&reader_ast_signature_2571, 0);
  Method *writer2571 = addmethodrealflags(obj2567, "signature:=",&writer_ast_signature_2571, 0);
  reader2571->definitionModule = modulename;
  writer2571->definitionModule = modulename;
  reader2571->definitionLine = 542;
  writer2571->definitionLine = 542;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 3);
if (objclass2567 == NULL) {
  Method *reader2572 = addmethodrealflags(obj2567, "rtype",&reader_ast_rtype_2572, 0);
  Method *writer2572 = addmethodrealflags(obj2567, "rtype:=",&writer_ast_rtype_2572, 0);
  reader2572->definitionModule = modulename;
  writer2572->definitionModule = modulename;
  reader2572->definitionLine = 543;
  writer2572->definitionLine = 543;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 4);
if (objclass2567 == NULL) {
  Method *reader2573 = addmethodrealflags(obj2567, "typeParams",&reader_ast_typeParams_2573, 0);
  Method *writer2573 = addmethodrealflags(obj2567, "typeParams:=",&writer_ast_typeParams_2573, 0);
  reader2573->definitionModule = modulename;
  writer2573->definitionModule = modulename;
  reader2573->definitionLine = 544;
  writer2573->definitionLine = 544;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 5);
if (objclass2567 == NULL) {
  Method *reader2574 = addmethodrealflags(obj2567, "nameString",&reader_ast_nameString_2574, MFLAG_DEF);
  reader2574->definitionModule = modulename;
  reader2574->definitionLine = 545;
}
adddatum2(obj2567, alloc_Undefined(), 6);
// method "isExecutable"
  struct UserObject *uo2575 = (struct UserObject*)obj2567;
  uo2575->data[7] = emptyclosure;
  Method *meth_meth_ast_isExecutable2575 = addmethod2pos(obj2567, "isExecutable", &meth_ast_isExecutable2575, 7);
  int argcv_meth_ast_isExecutable2575[] = {0};
  meth_meth_ast_isExecutable2575->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2575);
  meth_meth_ast_isExecutable2575->definitionModule = modulename;
  meth_meth_ast_isExecutable2575->definitionLine = 547;
// method "parametersDo"
  struct UserObject *uo2577 = (struct UserObject*)obj2567;
  uo2577->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2577 = addmethod2pos(obj2567, "parametersDo", &meth_ast_parametersDo2577, 8);
  int argcv_meth_ast_parametersDo2577[] = {1};
  meth_meth_ast_parametersDo2577->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2577);
  meth_meth_ast_parametersDo2577->definitionModule = modulename;
  meth_meth_ast_parametersDo2577->definitionLine = 548;
// method "scope:="
  struct UserObject *uo2594 = (struct UserObject*)obj2567;
  uo2594->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2594 = addmethod2pos(obj2567, "scope:=", &meth_ast_scope_58__61_2594, 9);
  int argcv_meth_ast_scope_58__61_2594[] = {1};
  meth_meth_ast_scope_58__61_2594->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2594);
  meth_meth_ast_scope_58__61_2594->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2594->definitionLine = 553;
// method "declarationKindWithAncestors"
  block_savedest(obj2567);
  Object closure2599 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure2599, stackframe);
  addtoclosure(closure2599, var_k);
  struct UserObject *uo2599 = (struct UserObject*)obj2567;
  uo2599->data[10] = (Object)closure2599;
  Method *meth_meth_ast_declarationKindWithAncestors2599 = addmethod2pos(obj2567, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2599, 10);
  int argcv_meth_ast_declarationKindWithAncestors2599[] = {1};
  meth_meth_ast_declarationKindWithAncestors2599->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2599);
  meth_meth_ast_declarationKindWithAncestors2599->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2599->definitionLine = 559;
// method "accept()from"
  struct UserObject *uo2602 = (struct UserObject*)obj2567;
  uo2602->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2602 = addmethod2pos(obj2567, "accept()from", &meth_ast_accept_40__41_from2602, 11);
  int argcv_meth_ast_accept_40__41_from2602[] = {1, 1};
  meth_meth_ast_accept_40__41_from2602->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2602);
  meth_meth_ast_accept_40__41_from2602->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2602->definitionLine = 560;
// method "map()ancestors"
  struct UserObject *uo2639 = (struct UserObject*)obj2567;
  uo2639->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2639 = addmethod2pos(obj2567, "map()ancestors", &meth_ast_map_40__41_ancestors2639, 12);
  int argcv_meth_ast_map_40__41_ancestors2639[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2639->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2639);
  meth_meth_ast_map_40__41_ancestors2639->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2639->definitionLine = 574;
// method "pretty"
  struct UserObject *uo2676 = (struct UserObject*)obj2567;
  uo2676->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2676 = addmethod2pos(obj2567, "pretty", &meth_ast_pretty2676, 13);
  int argcv_meth_ast_pretty2676[] = {1};
  meth_meth_ast_pretty2676->type = alloc_MethodType(1, argcv_meth_ast_pretty2676);
  meth_meth_ast_pretty2676->definitionModule = modulename;
  meth_meth_ast_pretty2676->definitionLine = 582;
// method "toGrace"
  struct UserObject *uo2855 = (struct UserObject*)obj2567;
  uo2855->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2855 = addmethod2pos(obj2567, "toGrace", &meth_ast_toGrace2855, 14);
  int argcv_meth_ast_toGrace2855[] = {1};
  meth_meth_ast_toGrace2855->type = alloc_MethodType(1, argcv_meth_ast_toGrace2855);
meth_meth_ast_toGrace2855->type->types[0] = type_Number;
meth_meth_ast_toGrace2855->type->names[0] = "depth";
  meth_meth_ast_toGrace2855->definitionModule = modulename;
  meth_meth_ast_toGrace2855->definitionLine = 602;
// method "shallowCopy"
  block_savedest(obj2567);
  Object closure2967 = createclosure(2, "shallowCopy");
  setclosureframe(closure2967, stackframe);
  addtoclosure(closure2967, var_emptySeq);
  addtoclosure(closure2967, var_methodTypeNode);
  struct UserObject *uo2967 = (struct UserObject*)obj2567;
  uo2967->data[15] = (Object)closure2967;
  Method *meth_meth_ast_shallowCopy2967 = addmethod2pos(obj2567, "shallowCopy", &meth_ast_shallowCopy2967, 15);
  int argcv_meth_ast_shallowCopy2967[] = {0};
  meth_meth_ast_shallowCopy2967->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2967);
  meth_meth_ast_shallowCopy2967->definitionModule = modulename;
  meth_meth_ast_shallowCopy2967->definitionLine = 630;
  sourceObject = obj2567;
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2975 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2976 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2977 = gc_frame_new();
// call case 3: self.outer request
  Object call2978 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2977);
// compiled call node returning call2978 (depth = 7)
// compiled member node returning call2978 (depth = 6)
  partcv[0] = 0;
  Object call2979 = callmethodflags(call2978, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2976);
// compiled call node returning call2979 (depth = 5)
// compiled member node returning call2979 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2980 = callmethodflags(call2979, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2975);
// compiled call node returning call2980 (depth = 3)
  struct UserObject *obj2567_uo = (struct UserObject *)obj2567;
  obj2567_uo->super = call2980;
  sourceObject = obj2567;
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2981 == NULL) {
    strlit2981 = alloc_String("methodtype");
    gc_root(strlit2981);
  }
// compiled string node returning strlit2981 (depth = 3)
  adddatum2(obj2567, strlit2981, 1);
  sourceObject = obj2567;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj2567, *var_name_39_, 2);
  sourceObject = obj2567;
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2567, *var_signature_39_, 3);
  sourceObject = obj2567;
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2567, *var_rtype_39_, 4);
  sourceObject = obj2567;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2982 = alloc_Boolean(0);
// compiled identifier node returning bool2982 (depth = 3)
  adddatum2(obj2567, bool2982, 5);
  sourceObject = obj2567;
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2984 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2983);
// compiled call node returning call2984 (depth = 4)
// compiled member node returning call2984 (depth = 3)
  adddatum2(obj2567, call2984, 6);
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  objclass2567 = obj2567->class;
  objclass2567->definitionModule = modulename;
  objclass2567->definitionLine = 535;
  (*(struct UserObject *)self).data[0] = lowerouter2567;
  self = oldself2567;
  selfslot = oldselfslot2567;
  stackframe = oldstackframe2567;
  gc_frame_end(frame);
  return obj2567;
}
Object meth_ast_new2566_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_methodTypeNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2567 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2567 = alloc_userobj2(19,16, objclass2567);
  gc_frame_newslot(obj2567);
if (objclass2567 == NULL) {
  glfree(obj2567->class->name);
  obj2567->class->name = "methodTypeNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2567, self, 0);
  addmethodreal(obj2567,"outer", &reader_ast_outer_2568);
  Object oldself2567 = self;
  struct StackFrameObject *oldstackframe2567 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2567);
  gc_frame_newslot((Object)stackframe);
  self = obj2567;
  Object *oldselfslot2567 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2567 = (*(struct UserObject *)self).data[0], lowerouter2567 = thisouter2567;
  if (inheritingObject2567) {
    struct UserObject *inho2567 = (struct UserObject *)inheritingObject2567;
    while (inho2567->super != GraceDefaultObject) inho2567 = (struct UserObject *)inho2567->super;
    inho2567->super = obj2567;
    self = inheritingObject2567;
    *selfslot = self;
    lowerouter2567 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2567;
  }
if (objclass2567 == NULL) {
  Method *reader2569 = addmethodrealflags(obj2567, "kind",&reader_ast_kind_2569, MFLAG_DEF);
  reader2569->definitionModule = modulename;
  reader2569->definitionLine = 540;
}
adddatum2(obj2567, alloc_Undefined(), 1);
if (objclass2567 == NULL) {
  Method *reader2570 = addmethodrealflags(obj2567, "value",&reader_ast_value_2570, 0);
  Method *writer2570 = addmethodrealflags(obj2567, "value:=",&writer_ast_value_2570, 0);
  reader2570->definitionModule = modulename;
  writer2570->definitionModule = modulename;
  reader2570->definitionLine = 541;
  writer2570->definitionLine = 541;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 2);
if (objclass2567 == NULL) {
  Method *reader2571 = addmethodrealflags(obj2567, "signature",&reader_ast_signature_2571, 0);
  Method *writer2571 = addmethodrealflags(obj2567, "signature:=",&writer_ast_signature_2571, 0);
  reader2571->definitionModule = modulename;
  writer2571->definitionModule = modulename;
  reader2571->definitionLine = 542;
  writer2571->definitionLine = 542;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 3);
if (objclass2567 == NULL) {
  Method *reader2572 = addmethodrealflags(obj2567, "rtype",&reader_ast_rtype_2572, 0);
  Method *writer2572 = addmethodrealflags(obj2567, "rtype:=",&writer_ast_rtype_2572, 0);
  reader2572->definitionModule = modulename;
  writer2572->definitionModule = modulename;
  reader2572->definitionLine = 543;
  writer2572->definitionLine = 543;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 4);
if (objclass2567 == NULL) {
  Method *reader2573 = addmethodrealflags(obj2567, "typeParams",&reader_ast_typeParams_2573, 0);
  Method *writer2573 = addmethodrealflags(obj2567, "typeParams:=",&writer_ast_typeParams_2573, 0);
  reader2573->definitionModule = modulename;
  writer2573->definitionModule = modulename;
  reader2573->definitionLine = 544;
  writer2573->definitionLine = 544;
}
obj2567->flags |= OFLAG_MUTABLE;
adddatum2(obj2567, alloc_Undefined(), 5);
if (objclass2567 == NULL) {
  Method *reader2574 = addmethodrealflags(obj2567, "nameString",&reader_ast_nameString_2574, MFLAG_DEF);
  reader2574->definitionModule = modulename;
  reader2574->definitionLine = 545;
}
adddatum2(obj2567, alloc_Undefined(), 6);
// method "isExecutable"
  struct UserObject *uo2575 = (struct UserObject*)obj2567;
  uo2575->data[7] = emptyclosure;
  Method *meth_meth_ast_isExecutable2575 = addmethod2pos(obj2567, "isExecutable", &meth_ast_isExecutable2575, 7);
  int argcv_meth_ast_isExecutable2575[] = {0};
  meth_meth_ast_isExecutable2575->type = alloc_MethodType(1, argcv_meth_ast_isExecutable2575);
  meth_meth_ast_isExecutable2575->definitionModule = modulename;
  meth_meth_ast_isExecutable2575->definitionLine = 547;
// method "parametersDo"
  struct UserObject *uo2577 = (struct UserObject*)obj2567;
  uo2577->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2577 = addmethod2pos(obj2567, "parametersDo", &meth_ast_parametersDo2577, 8);
  int argcv_meth_ast_parametersDo2577[] = {1};
  meth_meth_ast_parametersDo2577->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2577);
  meth_meth_ast_parametersDo2577->definitionModule = modulename;
  meth_meth_ast_parametersDo2577->definitionLine = 548;
// method "scope:="
  struct UserObject *uo2594 = (struct UserObject*)obj2567;
  uo2594->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_2594 = addmethod2pos(obj2567, "scope:=", &meth_ast_scope_58__61_2594, 9);
  int argcv_meth_ast_scope_58__61_2594[] = {1};
  meth_meth_ast_scope_58__61_2594->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_2594);
  meth_meth_ast_scope_58__61_2594->definitionModule = modulename;
  meth_meth_ast_scope_58__61_2594->definitionLine = 553;
// method "declarationKindWithAncestors"
  block_savedest(obj2567);
  Object closure2599 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure2599, stackframe);
  addtoclosure(closure2599, var_k);
  struct UserObject *uo2599 = (struct UserObject*)obj2567;
  uo2599->data[10] = (Object)closure2599;
  Method *meth_meth_ast_declarationKindWithAncestors2599 = addmethod2pos(obj2567, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors2599, 10);
  int argcv_meth_ast_declarationKindWithAncestors2599[] = {1};
  meth_meth_ast_declarationKindWithAncestors2599->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors2599);
  meth_meth_ast_declarationKindWithAncestors2599->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors2599->definitionLine = 559;
// method "accept()from"
  struct UserObject *uo2602 = (struct UserObject*)obj2567;
  uo2602->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2602 = addmethod2pos(obj2567, "accept()from", &meth_ast_accept_40__41_from2602, 11);
  int argcv_meth_ast_accept_40__41_from2602[] = {1, 1};
  meth_meth_ast_accept_40__41_from2602->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2602);
  meth_meth_ast_accept_40__41_from2602->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2602->definitionLine = 560;
// method "map()ancestors"
  struct UserObject *uo2639 = (struct UserObject*)obj2567;
  uo2639->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors2639 = addmethod2pos(obj2567, "map()ancestors", &meth_ast_map_40__41_ancestors2639, 12);
  int argcv_meth_ast_map_40__41_ancestors2639[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors2639->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors2639);
  meth_meth_ast_map_40__41_ancestors2639->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors2639->definitionLine = 574;
// method "pretty"
  struct UserObject *uo2676 = (struct UserObject*)obj2567;
  uo2676->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2676 = addmethod2pos(obj2567, "pretty", &meth_ast_pretty2676, 13);
  int argcv_meth_ast_pretty2676[] = {1};
  meth_meth_ast_pretty2676->type = alloc_MethodType(1, argcv_meth_ast_pretty2676);
  meth_meth_ast_pretty2676->definitionModule = modulename;
  meth_meth_ast_pretty2676->definitionLine = 582;
// method "toGrace"
  struct UserObject *uo2855 = (struct UserObject*)obj2567;
  uo2855->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2855 = addmethod2pos(obj2567, "toGrace", &meth_ast_toGrace2855, 14);
  int argcv_meth_ast_toGrace2855[] = {1};
  meth_meth_ast_toGrace2855->type = alloc_MethodType(1, argcv_meth_ast_toGrace2855);
meth_meth_ast_toGrace2855->type->types[0] = type_Number;
meth_meth_ast_toGrace2855->type->names[0] = "depth";
  meth_meth_ast_toGrace2855->definitionModule = modulename;
  meth_meth_ast_toGrace2855->definitionLine = 602;
// method "shallowCopy"
  block_savedest(obj2567);
  Object closure2967 = createclosure(2, "shallowCopy");
  setclosureframe(closure2967, stackframe);
  addtoclosure(closure2967, var_emptySeq);
  addtoclosure(closure2967, var_methodTypeNode);
  struct UserObject *uo2967 = (struct UserObject*)obj2567;
  uo2967->data[15] = (Object)closure2967;
  Method *meth_meth_ast_shallowCopy2967 = addmethod2pos(obj2567, "shallowCopy", &meth_ast_shallowCopy2967, 15);
  int argcv_meth_ast_shallowCopy2967[] = {0};
  meth_meth_ast_shallowCopy2967->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy2967);
  meth_meth_ast_shallowCopy2967->definitionModule = modulename;
  meth_meth_ast_shallowCopy2967->definitionLine = 630;
  sourceObject = obj2567;
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2975 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2976 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2977 = gc_frame_new();
// call case 3: self.outer request
  Object call2978 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2977);
// compiled call node returning call2978 (depth = 7)
// compiled member node returning call2978 (depth = 6)
  partcv[0] = 0;
  Object call2979 = callmethodflags(call2978, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2976);
// compiled call node returning call2979 (depth = 5)
// compiled member node returning call2979 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2980 = callmethodflags(call2979, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2975);
// compiled call node returning call2980 (depth = 3)
  struct UserObject *obj2567_uo = (struct UserObject *)obj2567;
  obj2567_uo->super = call2980;
  sourceObject = obj2567;
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit2981 == NULL) {
    strlit2981 = alloc_String("methodtype");
    gc_root(strlit2981);
  }
// compiled string node returning strlit2981 (depth = 3)
  adddatum2(obj2567, strlit2981, 1);
  sourceObject = obj2567;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj2567, *var_name_39_, 2);
  sourceObject = obj2567;
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj2567, *var_signature_39_, 3);
  sourceObject = obj2567;
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rtype_39_ (depth = 3)
  adddatum2(obj2567, *var_rtype_39_, 4);
  sourceObject = obj2567;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2982 = alloc_Boolean(0);
// compiled identifier node returning bool2982 (depth = 3)
  adddatum2(obj2567, bool2982, 5);
  sourceObject = obj2567;
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2984 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2983);
// compiled call node returning call2984 (depth = 4)
// compiled member node returning call2984 (depth = 3)
  adddatum2(obj2567, call2984, 6);
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  sourceObject = obj2567;
  objclass2567 = obj2567->class;
  objclass2567->definitionModule = modulename;
  objclass2567->definitionLine = 535;
  (*(struct UserObject *)self).data[0] = lowerouter2567;
  self = oldself2567;
  selfslot = oldselfslot2567;
  stackframe = oldstackframe2567;
  gc_frame_end(frame);
  return obj2567;
}
Object meth_ast_methodTypeNode2986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_name2998(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2999 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3000 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2999);
// compiled call node returning call3000 (depth = 4)
// compiled member node returning call3000 (depth = 3)
  gc_frame_end(frame);
  return call3000;
}
Object meth_ast_name_58__61_3001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for name:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3002 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3003 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 3)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool3005 = alloc_Boolean(0);
// compiled identifier node returning bool3005 (depth = 4)
  gc_frame_newslot(bool3005);
// call case 4: self request
  params[0] = bool3005;
  partcv[0] = 1;
  Object call3006 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled call node returning call3006 (depth = 3)
  gc_frame_end(frame);
  return call3006;
}
Object meth_ast_asString3007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String("");
    gc_root(strlit3009);
  }
// compiled string node returning strlit3009 (depth = 4)
  int op_slot_right_3008 = gc_frame_newslot(strlit3009);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3012 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3013 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3012);
// compiled call node returning call3013 (depth = 6)
// compiled member node returning call3013 (depth = 5)
  int op_slot_right_3011 = gc_frame_newslot(call3013);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3016 == NULL) {
    strlit3016 = alloc_String(", types = ");
    gc_root(strlit3016);
  }
// compiled string node returning strlit3016 (depth = 6)
  int op_slot_right_3015 = gc_frame_newslot(strlit3016);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3019 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3020 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3019);
// compiled call node returning call3020 (depth = 8)
// compiled member node returning call3020 (depth = 7)
  int op_slot_right_3018 = gc_frame_newslot(call3020);
// starting to compile string node (depth = 7)
  if (strlit3022 == NULL) {
    strlit3022 = alloc_String("typeliteral: methods = ");
    gc_root(strlit3022);
  }
// compiled string node returning strlit3022 (depth = 7)
  int op_slot_left_3018 = gc_frame_newslot(strlit3022);
  params[0] = call3020;
  partcv[0] = 1;
  Object opresult3023 = callmethod(strlit3022, "++", 1, partcv, params);
// compiled op node returning opresult3023 (depth = 6)
  int op_slot_left_3015 = gc_frame_newslot(opresult3023);
  params[0] = strlit3016;
  partcv[0] = 1;
  Object opresult3024 = callmethod(opresult3023, "++", 1, partcv, params);
// compiled op node returning opresult3024 (depth = 5)
  int op_slot_left_3011 = gc_frame_newslot(opresult3024);
  params[0] = call3013;
  partcv[0] = 1;
  Object opresult3025 = callmethod(opresult3024, "++", 1, partcv, params);
// compiled op node returning opresult3025 (depth = 4)
  int op_slot_left_3008 = gc_frame_newslot(opresult3025);
  params[0] = strlit3009;
  partcv[0] = 1;
  Object opresult3026 = callmethod(opresult3025, "++", 1, partcv, params);
// compiled op node returning opresult3026 (depth = 3)
  gc_frame_end(frame);
  return opresult3026;
}
Object meth_ast_declarationKindWithAncestors3027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3029 = callmethod(*var_k, "typedec",
    1, partcv, params);
  gc_frame_end(callframe3028);
// compiled call node returning call3029 (depth = 4)
// compiled member node returning call3029 (depth = 3)
  gc_frame_end(frame);
  return call3029;
}
Object meth_ast_isExecutable3030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3031 = alloc_Boolean(0);
// compiled identifier node returning bool3031 (depth = 3)
  gc_frame_end(frame);
  return bool3031;
}
Object meth_ast__apply3042(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3043 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3044 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3043);
// compiled call node returning call3044 (depth = 6)
  gc_frame_end(frame);
  return call3044;
}
Object meth_ast__apply3051(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3052 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3053 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3052);
// compiled call node returning call3053 (depth = 6)
  gc_frame_end(frame);
  return call3053;
}
Object meth_ast_accept_40__41_from3032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3034 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3035 = callmethod(*var_visitor, "visitTypeLiteral()up",
    2, partcv, params);
  gc_frame_end(callframe3034);
// compiled call node returning call3035 (depth = 4)
  Object if3033 = done;
  if (istrue(call3035)) {
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3036 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3037 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3036);
// compiled call node returning call3037 (depth = 5)
  *var_newChain = call3037;
  if (call3037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3038 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3039 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3040 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3039);
// compiled call node returning call3040 (depth = 6)
// compiled member node returning call3040 (depth = 5)
  gc_frame_newslot(call3040);
// starting to compile block node (depth = 5)
  Object block3041 = alloc_Block(NULL, NULL, "ast", 659);
  gc_frame_newslot(block3041);
// method "_apply"
  block_savedest(block3041);
  Object closure3042 = createclosure(3, "_apply");
  setclosureframe(closure3042, stackframe);
  addtoclosure(closure3042, var_visitor);
  addtoclosure(closure3042, var_newChain);
  addtoclosure(closure3042, selfslot);
  struct UserObject *uo3042 = (struct UserObject*)block3041;
  uo3042->data[0] = (Object)closure3042;
  Method *meth_meth_ast__apply3042 = addmethod2pos(block3041, "_apply", &meth_ast__apply3042, 0);
  int argcv_meth_ast__apply3042[] = {1};
  meth_meth_ast__apply3042->type = alloc_MethodType(1, argcv_meth_ast__apply3042);
  meth_meth_ast__apply3042->definitionModule = modulename;
  meth_meth_ast__apply3042->definitionLine = 659;
// compiled block node returning block3041 (depth = 5)
  gc_frame_newslot(block3041);
// call case 5: prelude request
  params[0] = call3040;
  params[1] = block3041;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3046 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3038);
// compiled call node returning call3046 (depth = 4)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3047 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3049 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3048);
// compiled call node returning call3049 (depth = 6)
// compiled member node returning call3049 (depth = 5)
  gc_frame_newslot(call3049);
// starting to compile block node (depth = 5)
  Object block3050 = alloc_Block(NULL, NULL, "ast", 662);
  gc_frame_newslot(block3050);
// method "_apply"
  block_savedest(block3050);
  Object closure3051 = createclosure(3, "_apply");
  setclosureframe(closure3051, stackframe);
  addtoclosure(closure3051, var_visitor);
  addtoclosure(closure3051, var_newChain);
  addtoclosure(closure3051, selfslot);
  struct UserObject *uo3051 = (struct UserObject*)block3050;
  uo3051->data[0] = (Object)closure3051;
  Method *meth_meth_ast__apply3051 = addmethod2pos(block3050, "_apply", &meth_ast__apply3051, 0);
  int argcv_meth_ast__apply3051[] = {1};
  meth_meth_ast__apply3051->type = alloc_MethodType(1, argcv_meth_ast__apply3051);
  meth_meth_ast__apply3051->definitionModule = modulename;
  meth_meth_ast__apply3051->definitionLine = 662;
// compiled block node returning block3050 (depth = 5)
  gc_frame_newslot(block3050);
// call case 5: prelude request
  params[0] = call3049;
  params[1] = block3050;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3055 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3047);
// compiled call node returning call3055 (depth = 4)
    gc_frame_newslot(call3055);
    if3033 = call3055;
  } else {
  }
// compiled if node returning if3033 (depth = 3)
  gc_frame_end(frame);
  return if3033;
}
Object meth_ast_map_40__41_ancestors3056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3058 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3057);
// compiled call node returning call3058 (depth = 5)
// compiled member node returning call3058 (depth = 4)
  *var_n = call3058;
  if (call3058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3059 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3060 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3059);
// compiled call node returning call3060 (depth = 4)
  *var_newChain = call3060;
  if (call3060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3061 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3062 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3064 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled call node returning call3064 (depth = 6)
// compiled member node returning call3064 (depth = 5)
  gc_frame_newslot(call3064);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3065 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3066 = gc_frame_new();
// call case 3: self.outer request
  Object call3067 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3066);
// compiled call node returning call3067 (depth = 8)
// compiled member node returning call3067 (depth = 7)
  partcv[0] = 0;
  Object call3068 = callmethodflags(call3067, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3065);
// compiled call node returning call3068 (depth = 6)
// compiled member node returning call3068 (depth = 5)
  params[0] = call3064;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3069 = callmethodflags(call3068, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3062);
// compiled call node returning call3069 (depth = 4)
  gc_frame_newslot(call3069);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3069;
  partcv[0] = 1;
  Object call3070 = callmethod(*var_n, "methods:=",
    1, partcv, params);
  gc_frame_end(callframe3061);
// compiled call node returning call3070 (depth = 3)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3071 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3072 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3073 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3074 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3073);
// compiled call node returning call3074 (depth = 6)
// compiled member node returning call3074 (depth = 5)
  gc_frame_newslot(call3074);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3075 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3076 = gc_frame_new();
// call case 3: self.outer request
  Object call3077 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3076);
// compiled call node returning call3077 (depth = 8)
// compiled member node returning call3077 (depth = 7)
  partcv[0] = 0;
  Object call3078 = callmethodflags(call3077, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3075);
// compiled call node returning call3078 (depth = 6)
// compiled member node returning call3078 (depth = 5)
  params[0] = call3074;
  params[1] = *var_blk;
  params[2] = *var_as;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3079 = callmethodflags(call3078, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3072);
// compiled call node returning call3079 (depth = 4)
  gc_frame_newslot(call3079);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3079;
  partcv[0] = 1;
  Object call3080 = callmethod(*var_n, "types:=",
    1, partcv, params);
  gc_frame_end(callframe3071);
// compiled call node returning call3080 (depth = 3)
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3081 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3082 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3081);
// compiled call node returning call3082 (depth = 3)
  gc_frame_end(frame);
  return call3082;
}
Object meth_ast__apply3091(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3093 == NULL) {
    strlit3093 = alloc_String("  ");
    gc_root(strlit3093);
  }
// compiled string node returning strlit3093 (depth = 7)
  int op_slot_right_3092 = gc_frame_newslot(strlit3093);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3092 = gc_frame_newslot(*var_spc);
  params[0] = strlit3093;
  partcv[0] = 1;
  Object opresult3095 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3095 (depth = 6)
  *var_spc = opresult3095;
  if (opresult3095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3121(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3123 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3125 = alloc_Float64(2);
// compiled num node returning num3125 (depth = 9)
  int op_slot_right_3124 = gc_frame_newslot(num3125);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3124 = gc_frame_newslot(*var_depth);
  params[0] = num3125;
  partcv[0] = 1;
  Object sum3127 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3127 (depth = 8)
  gc_frame_newslot(sum3127);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3127;
  partcv[0] = 1;
  Object call3128 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3123);
// compiled call node returning call3128 (depth = 7)
  int op_slot_right_3122 = gc_frame_newslot(call3128);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3130 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3133 == NULL) {
    strlit3133 = alloc_String("""\x0a""  ");
    gc_root(strlit3133);
  }
// compiled string node returning strlit3133 (depth = 9)
  int op_slot_right_3132 = gc_frame_newslot(strlit3133);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3132 = gc_frame_newslot(*var_s);
  params[0] = strlit3133;
  partcv[0] = 1;
  Object opresult3135 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3135 (depth = 8)
  int op_slot_left_3130 = gc_frame_newslot(opresult3135);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3136 = callmethod(opresult3135, "++", 1, partcv, params);
// compiled op node returning opresult3136 (depth = 7)
  int op_slot_left_3122 = gc_frame_newslot(opresult3136);
  params[0] = call3128;
  partcv[0] = 1;
  Object opresult3137 = callmethod(opresult3136, "++", 1, partcv, params);
// compiled op node returning opresult3137 (depth = 6)
  *var_s = opresult3137;
  if (opresult3137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3157(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3159 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3161 = alloc_Float64(2);
// compiled num node returning num3161 (depth = 9)
  int op_slot_right_3160 = gc_frame_newslot(num3161);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3160 = gc_frame_newslot(*var_depth);
  params[0] = num3161;
  partcv[0] = 1;
  Object sum3163 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3163 (depth = 8)
  gc_frame_newslot(sum3163);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3163;
  partcv[0] = 1;
  Object call3164 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3159);
// compiled call node returning call3164 (depth = 7)
  int op_slot_right_3158 = gc_frame_newslot(call3164);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3166 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3169 == NULL) {
    strlit3169 = alloc_String("""\x0a""  ");
    gc_root(strlit3169);
  }
// compiled string node returning strlit3169 (depth = 9)
  int op_slot_right_3168 = gc_frame_newslot(strlit3169);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3168 = gc_frame_newslot(*var_s);
  params[0] = strlit3169;
  partcv[0] = 1;
  Object opresult3171 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3171 (depth = 8)
  int op_slot_left_3166 = gc_frame_newslot(opresult3171);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3172 = callmethod(opresult3171, "++", 1, partcv, params);
// compiled op node returning opresult3172 (depth = 7)
  int op_slot_left_3158 = gc_frame_newslot(opresult3172);
  params[0] = call3164;
  partcv[0] = 1;
  Object opresult3173 = callmethod(opresult3172, "++", 1, partcv, params);
// compiled op node returning opresult3173 (depth = 6)
  *var_s = opresult3173;
  if (opresult3173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3083(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3084 == NULL) {
    strlit3084 = alloc_String("");
    gc_root(strlit3084);
  }
// compiled string node returning strlit3084 (depth = 4)
  *var_spc = strlit3084;
  if (strlit3084 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3085 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3086 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3088 = alloc_Float64(0);
// compiled num node returning num3088 (depth = 5)
  int op_slot_left_3086 = gc_frame_newslot(num3088);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3089 = callmethod(num3088, "..", 1, partcv, params);
// compiled op node returning opresult3089 (depth = 4)
  gc_frame_newslot(opresult3089);
// starting to compile block node (depth = 4)
  Object block3090 = alloc_Block(NULL, NULL, "ast", 676);
  gc_frame_newslot(block3090);
// method "_apply"
  block_savedest(block3090);
  Object closure3091 = createclosure(2, "_apply");
  setclosureframe(closure3091, stackframe);
  addtoclosure(closure3091, var_spc);
  addtoclosure(closure3091, selfslot);
  struct UserObject *uo3091 = (struct UserObject*)block3090;
  uo3091->data[0] = (Object)closure3091;
  Method *meth_meth_ast__apply3091 = addmethod2pos(block3090, "_apply", &meth_ast__apply3091, 0);
  int argcv_meth_ast__apply3091[] = {1};
  meth_meth_ast__apply3091->type = alloc_MethodType(1, argcv_meth_ast__apply3091);
  meth_meth_ast__apply3091->definitionModule = modulename;
  meth_meth_ast__apply3091->definitionLine = 671;
// compiled block node returning block3090 (depth = 4)
  gc_frame_newslot(block3090);
// call case 5: prelude request
  params[0] = opresult3089;
  params[1] = block3090;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3098 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3085);
// compiled call node returning call3098 (depth = 3)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3100 == NULL) {
    strlit3100 = alloc_String("""\x0a""");
    gc_root(strlit3100);
  }
// compiled string node returning strlit3100 (depth = 5)
  int op_slot_right_3099 = gc_frame_newslot(strlit3100);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3103 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3104 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3103);
// compiled call node returning call3104 (depth = 6)
  int op_slot_right_3102 = gc_frame_newslot(call3104);
// starting to compile string node (depth = 6)
  if (strlit3106 == NULL) {
    strlit3106 = alloc_String("");
    gc_root(strlit3106);
  }
// compiled string node returning strlit3106 (depth = 6)
  int op_slot_left_3102 = gc_frame_newslot(strlit3106);
  params[0] = call3104;
  partcv[0] = 1;
  Object opresult3107 = callmethod(strlit3106, "++", 1, partcv, params);
// compiled op node returning opresult3107 (depth = 5)
  int op_slot_left_3099 = gc_frame_newslot(opresult3107);
  params[0] = strlit3100;
  partcv[0] = 1;
  Object opresult3108 = callmethod(opresult3107, "++", 1, partcv, params);
// compiled op node returning opresult3108 (depth = 4)
  *var_s = opresult3108;
  if (opresult3108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3110 == NULL) {
    strlit3110 = alloc_String("Types:");
    gc_root(strlit3110);
  }
// compiled string node returning strlit3110 (depth = 5)
  int op_slot_right_3109 = gc_frame_newslot(strlit3110);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3112 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3112 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3114 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3114 (depth = 5)
  int op_slot_left_3109 = gc_frame_newslot(opresult3114);
  params[0] = strlit3110;
  partcv[0] = 1;
  Object opresult3115 = callmethod(opresult3114, "++", 1, partcv, params);
// compiled op node returning opresult3115 (depth = 4)
  *var_s = opresult3115;
  if (opresult3115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3117 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3119 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3119 (depth = 5)
// compiled member node returning call3119 (depth = 4)
  gc_frame_newslot(call3119);
// starting to compile block node (depth = 4)
  Object block3120 = alloc_Block(NULL, NULL, "ast", 681);
  gc_frame_newslot(block3120);
// method "_apply"
  block_savedest(block3120);
  Object closure3121 = createclosure(4, "_apply");
  setclosureframe(closure3121, stackframe);
  addtoclosure(closure3121, var_depth);
  addtoclosure(closure3121, var_spc);
  addtoclosure(closure3121, var_s);
  addtoclosure(closure3121, selfslot);
  struct UserObject *uo3121 = (struct UserObject*)block3120;
  uo3121->data[0] = (Object)closure3121;
  Method *meth_meth_ast__apply3121 = addmethod2pos(block3120, "_apply", &meth_ast__apply3121, 0);
  int argcv_meth_ast__apply3121[] = {1};
  meth_meth_ast__apply3121->type = alloc_MethodType(1, argcv_meth_ast__apply3121);
  meth_meth_ast__apply3121->definitionModule = modulename;
  meth_meth_ast__apply3121->definitionLine = 681;
// compiled block node returning block3120 (depth = 4)
  gc_frame_newslot(block3120);
// call case 5: prelude request
  params[0] = call3119;
  params[1] = block3120;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3140 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3117);
// compiled call node returning call3140 (depth = 3)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3142 == NULL) {
    strlit3142 = alloc_String("Methods:");
    gc_root(strlit3142);
  }
// compiled string node returning strlit3142 (depth = 5)
  int op_slot_right_3141 = gc_frame_newslot(strlit3142);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3144 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3147 == NULL) {
    strlit3147 = alloc_String("""\x0a""");
    gc_root(strlit3147);
  }
// compiled string node returning strlit3147 (depth = 7)
  int op_slot_right_3146 = gc_frame_newslot(strlit3147);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3146 = gc_frame_newslot(*var_s);
  params[0] = strlit3147;
  partcv[0] = 1;
  Object opresult3149 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3149 (depth = 6)
  int op_slot_left_3144 = gc_frame_newslot(opresult3149);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3150 = callmethod(opresult3149, "++", 1, partcv, params);
// compiled op node returning opresult3150 (depth = 5)
  int op_slot_left_3141 = gc_frame_newslot(opresult3150);
  params[0] = strlit3142;
  partcv[0] = 1;
  Object opresult3151 = callmethod(opresult3150, "++", 1, partcv, params);
// compiled op node returning opresult3151 (depth = 4)
  *var_s = opresult3151;
  if (opresult3151 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3153 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3154 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3155 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3154);
// compiled call node returning call3155 (depth = 5)
// compiled member node returning call3155 (depth = 4)
  gc_frame_newslot(call3155);
// starting to compile block node (depth = 4)
  Object block3156 = alloc_Block(NULL, NULL, "ast", 685);
  gc_frame_newslot(block3156);
// method "_apply"
  block_savedest(block3156);
  Object closure3157 = createclosure(4, "_apply");
  setclosureframe(closure3157, stackframe);
  addtoclosure(closure3157, var_depth);
  addtoclosure(closure3157, var_spc);
  addtoclosure(closure3157, var_s);
  addtoclosure(closure3157, selfslot);
  struct UserObject *uo3157 = (struct UserObject*)block3156;
  uo3157->data[0] = (Object)closure3157;
  Method *meth_meth_ast__apply3157 = addmethod2pos(block3156, "_apply", &meth_ast__apply3157, 0);
  int argcv_meth_ast__apply3157[] = {1};
  meth_meth_ast__apply3157->type = alloc_MethodType(1, argcv_meth_ast__apply3157);
  meth_meth_ast__apply3157->definitionModule = modulename;
  meth_meth_ast__apply3157->definitionLine = 685;
// compiled block node returning block3156 (depth = 4)
  gc_frame_newslot(block3156);
// call case 5: prelude request
  params[0] = call3155;
  params[1] = block3156;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3176 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3153);
// compiled call node returning call3176 (depth = 3)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3178 == NULL) {
    strlit3178 = alloc_String("""\x0a""");
    gc_root(strlit3178);
  }
// compiled string node returning strlit3178 (depth = 5)
  int op_slot_right_3177 = gc_frame_newslot(strlit3178);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3177 = gc_frame_newslot(*var_s);
  params[0] = strlit3178;
  partcv[0] = 1;
  Object opresult3180 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3180 (depth = 4)
  *var_s = opresult3180;
  if (opresult3180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3194(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3196 == NULL) {
    strlit3196 = alloc_String("    ");
    gc_root(strlit3196);
  }
// compiled string node returning strlit3196 (depth = 7)
  int op_slot_right_3195 = gc_frame_newslot(strlit3196);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3195 = gc_frame_newslot(*var_spc);
  params[0] = strlit3196;
  partcv[0] = 1;
  Object opresult3198 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3198 (depth = 6)
  *var_spc = opresult3198;
  if (opresult3198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3214 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3216 = alloc_Float64(1);
// compiled num node returning num3216 (depth = 9)
  int op_slot_right_3215 = gc_frame_newslot(num3216);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3215 = gc_frame_newslot(*var_depth);
  params[0] = num3216;
  partcv[0] = 1;
  Object sum3218 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3218 (depth = 8)
  gc_frame_newslot(sum3218);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3218;
  partcv[0] = 1;
  Object call3219 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3214);
// compiled call node returning call3219 (depth = 7)
  int op_slot_right_3213 = gc_frame_newslot(call3219);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3222 == NULL) {
    strlit3222 = alloc_String("    ");
    gc_root(strlit3222);
  }
// compiled string node returning strlit3222 (depth = 8)
  int op_slot_right_3221 = gc_frame_newslot(strlit3222);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3224 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3227 == NULL) {
    strlit3227 = alloc_String("""\x0a""");
    gc_root(strlit3227);
  }
// compiled string node returning strlit3227 (depth = 10)
  int op_slot_right_3226 = gc_frame_newslot(strlit3227);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3226 = gc_frame_newslot(*var_s);
  params[0] = strlit3227;
  partcv[0] = 1;
  Object opresult3229 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3229 (depth = 9)
  int op_slot_left_3224 = gc_frame_newslot(opresult3229);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3230 = callmethod(opresult3229, "++", 1, partcv, params);
// compiled op node returning opresult3230 (depth = 8)
  int op_slot_left_3221 = gc_frame_newslot(opresult3230);
  params[0] = strlit3222;
  partcv[0] = 1;
  Object opresult3231 = callmethod(opresult3230, "++", 1, partcv, params);
// compiled op node returning opresult3231 (depth = 7)
  int op_slot_left_3213 = gc_frame_newslot(opresult3231);
  params[0] = call3219;
  partcv[0] = 1;
  Object opresult3232 = callmethod(opresult3231, "++", 1, partcv, params);
// compiled op node returning opresult3232 (depth = 6)
  *var_s = opresult3232;
  if (opresult3232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3242 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3244 = alloc_Float64(1);
// compiled num node returning num3244 (depth = 9)
  int op_slot_right_3243 = gc_frame_newslot(num3244);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3243 = gc_frame_newslot(*var_depth);
  params[0] = num3244;
  partcv[0] = 1;
  Object sum3246 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3246 (depth = 8)
  gc_frame_newslot(sum3246);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum3246;
  partcv[0] = 1;
  Object call3247 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3242);
// compiled call node returning call3247 (depth = 7)
  int op_slot_right_3241 = gc_frame_newslot(call3247);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3250 == NULL) {
    strlit3250 = alloc_String("    ");
    gc_root(strlit3250);
  }
// compiled string node returning strlit3250 (depth = 8)
  int op_slot_right_3249 = gc_frame_newslot(strlit3250);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3252 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3255 == NULL) {
    strlit3255 = alloc_String("""\x0a""");
    gc_root(strlit3255);
  }
// compiled string node returning strlit3255 (depth = 10)
  int op_slot_right_3254 = gc_frame_newslot(strlit3255);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3254 = gc_frame_newslot(*var_s);
  params[0] = strlit3255;
  partcv[0] = 1;
  Object opresult3257 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3257 (depth = 9)
  int op_slot_left_3252 = gc_frame_newslot(opresult3257);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3258 = callmethod(opresult3257, "++", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 8)
  int op_slot_left_3249 = gc_frame_newslot(opresult3258);
  params[0] = strlit3250;
  partcv[0] = 1;
  Object opresult3259 = callmethod(opresult3258, "++", 1, partcv, params);
// compiled op node returning opresult3259 (depth = 7)
  int op_slot_left_3241 = gc_frame_newslot(opresult3259);
  params[0] = call3247;
  partcv[0] = 1;
  Object opresult3260 = callmethod(opresult3259, "++", 1, partcv, params);
// compiled op node returning opresult3260 (depth = 6)
  *var_s = opresult3260;
  if (opresult3260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3183 == NULL) {
    strlit3183 = alloc_String("");
    gc_root(strlit3183);
  }
// compiled string node returning strlit3183 (depth = 4)
  *var_spc = strlit3183;
  if (strlit3183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3184 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3187 = alloc_Float64(1);
// compiled num node returning num3187 (depth = 6)
  int op_slot_right_3186 = gc_frame_newslot(num3187);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3186 = gc_frame_newslot(*var_depth);
  params[0] = num3187;
  partcv[0] = 1;
  Object diff3189 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3189 (depth = 5)
  int op_slot_right_3185 = gc_frame_newslot(diff3189);
// starting to compile num node (depth = 5)
  Object num3191 = alloc_Float64(0);
// compiled num node returning num3191 (depth = 5)
  int op_slot_left_3185 = gc_frame_newslot(num3191);
  params[0] = diff3189;
  partcv[0] = 1;
  Object opresult3192 = callmethod(num3191, "..", 1, partcv, params);
// compiled op node returning opresult3192 (depth = 4)
  gc_frame_newslot(opresult3192);
// starting to compile block node (depth = 4)
  Object block3193 = alloc_Block(NULL, NULL, "ast", 693);
  gc_frame_newslot(block3193);
// method "_apply"
  block_savedest(block3193);
  Object closure3194 = createclosure(2, "_apply");
  setclosureframe(closure3194, stackframe);
  addtoclosure(closure3194, var_spc);
  addtoclosure(closure3194, selfslot);
  struct UserObject *uo3194 = (struct UserObject*)block3193;
  uo3194->data[0] = (Object)closure3194;
  Method *meth_meth_ast__apply3194 = addmethod2pos(block3193, "_apply", &meth_ast__apply3194, 0);
  int argcv_meth_ast__apply3194[] = {1};
  meth_meth_ast__apply3194->type = alloc_MethodType(1, argcv_meth_ast__apply3194);
  meth_meth_ast__apply3194->definitionModule = modulename;
  meth_meth_ast__apply3194->definitionLine = 685;
// compiled block node returning block3193 (depth = 4)
  gc_frame_newslot(block3193);
// call case 5: prelude request
  params[0] = opresult3192;
  params[1] = block3193;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3201 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3184);
// compiled call node returning call3201 (depth = 3)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3202 == NULL) {
    strlit3202 = alloc_String("type");
    gc_root(strlit3202);
  }
// compiled string node returning strlit3202 (depth = 4)
  *var_s = strlit3202;
  if (strlit3202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3204 == NULL) {
    strlit3204 = alloc_String(" = {");
    gc_root(strlit3204);
  }
// compiled string node returning strlit3204 (depth = 5)
  int op_slot_right_3203 = gc_frame_newslot(strlit3204);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3203 = gc_frame_newslot(*var_s);
  params[0] = strlit3204;
  partcv[0] = 1;
  Object opresult3206 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3206 (depth = 4)
  *var_s = opresult3206;
  if (opresult3206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3208 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3210 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3209);
// compiled call node returning call3210 (depth = 5)
// compiled member node returning call3210 (depth = 4)
  gc_frame_newslot(call3210);
// starting to compile block node (depth = 4)
  Object block3211 = alloc_Block(NULL, NULL, "ast", 698);
  gc_frame_newslot(block3211);
// method "_apply"
  block_savedest(block3211);
  Object closure3212 = createclosure(4, "_apply");
  setclosureframe(closure3212, stackframe);
  addtoclosure(closure3212, var_depth);
  addtoclosure(closure3212, var_spc);
  addtoclosure(closure3212, var_s);
  addtoclosure(closure3212, selfslot);
  struct UserObject *uo3212 = (struct UserObject*)block3211;
  uo3212->data[0] = (Object)closure3212;
  Method *meth_meth_ast__apply3212 = addmethod2pos(block3211, "_apply", &meth_ast__apply3212, 0);
  int argcv_meth_ast__apply3212[] = {1};
  meth_meth_ast__apply3212->type = alloc_MethodType(1, argcv_meth_ast__apply3212);
  meth_meth_ast__apply3212->definitionModule = modulename;
  meth_meth_ast__apply3212->definitionLine = 698;
// compiled block node returning block3211 (depth = 4)
  gc_frame_newslot(block3211);
// call case 5: prelude request
  params[0] = call3210;
  params[1] = block3211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3235 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3208);
// compiled call node returning call3235 (depth = 3)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3236 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3238 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3237);
// compiled call node returning call3238 (depth = 5)
// compiled member node returning call3238 (depth = 4)
  gc_frame_newslot(call3238);
// starting to compile block node (depth = 4)
  Object block3239 = alloc_Block(NULL, NULL, "ast", 701);
  gc_frame_newslot(block3239);
// method "_apply"
  block_savedest(block3239);
  Object closure3240 = createclosure(4, "_apply");
  setclosureframe(closure3240, stackframe);
  addtoclosure(closure3240, var_depth);
  addtoclosure(closure3240, var_spc);
  addtoclosure(closure3240, var_s);
  addtoclosure(closure3240, selfslot);
  struct UserObject *uo3240 = (struct UserObject*)block3239;
  uo3240->data[0] = (Object)closure3240;
  Method *meth_meth_ast__apply3240 = addmethod2pos(block3239, "_apply", &meth_ast__apply3240, 0);
  int argcv_meth_ast__apply3240[] = {1};
  meth_meth_ast__apply3240->type = alloc_MethodType(1, argcv_meth_ast__apply3240);
  meth_meth_ast__apply3240->definitionModule = modulename;
  meth_meth_ast__apply3240->definitionLine = 701;
// compiled block node returning block3239 (depth = 4)
  gc_frame_newslot(block3239);
// call case 5: prelude request
  params[0] = call3238;
  params[1] = block3239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3263 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3236);
// compiled call node returning call3263 (depth = 3)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3265 == NULL) {
    strlit3265 = alloc_String("}");
    gc_root(strlit3265);
  }
// compiled string node returning strlit3265 (depth = 4)
  int op_slot_right_3264 = gc_frame_newslot(strlit3265);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_3264 = gc_frame_newslot(*var_s);
  params[0] = strlit3265;
  partcv[0] = 1;
  Object opresult3267 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3267 (depth = 3)
  gc_frame_end(frame);
  return opresult3267;
}
Object meth_ast_shallowCopy3268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3269 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3270 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeLiteralNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call3271 = callmethod(*var_typeLiteralNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3270);
// compiled call node returning call3271 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3272 = callmethod(call3271, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3269);
// compiled call node returning call3272 (depth = 3)
  gc_frame_end(frame);
  return call3272;
}
Object meth_ast_shallowCopyFieldsFrom3273(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3274 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call3275 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3274);
// compiled call node returning call3275 (depth = 3)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3276 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3278 = callmethod(*var_other, "nominal",
    1, partcv, params);
  gc_frame_end(callframe3277);
// compiled call node returning call3278 (depth = 5)
// compiled member node returning call3278 (depth = 4)
  gc_frame_newslot(call3278);
// call case 4: self request
  params[0] = call3278;
  partcv[0] = 1;
  Object call3279 = callmethodflags(self, "nominal:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3276);
// compiled call node returning call3279 (depth = 3)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3280 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3282 = callmethod(*var_other, "anonymous",
    1, partcv, params);
  gc_frame_end(callframe3281);
// compiled call node returning call3282 (depth = 5)
// compiled member node returning call3282 (depth = 4)
  gc_frame_newslot(call3282);
// call case 4: self request
  params[0] = call3282;
  partcv[0] = 1;
  Object call3283 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled call node returning call3283 (depth = 3)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3284 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call3286 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe3285);
// compiled call node returning call3286 (depth = 5)
// compiled member node returning call3286 (depth = 4)
  gc_frame_newslot(call3286);
// call case 4: self request
  params[0] = call3286;
  partcv[0] = 1;
  Object call3287 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3284);
// compiled call node returning call3287 (depth = 3)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new2989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2990 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2990 = alloc_userobj2(22,18, objclass2990);
  gc_frame_newslot(obj2990);
if (objclass2990 == NULL) {
  glfree(obj2990->class->name);
  obj2990->class->name = "typeLiteralNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2990, self, 0);
  addmethodreal(obj2990,"outer", &reader_ast_outer_2991);
  Object oldself2990 = self;
  struct StackFrameObject *oldstackframe2990 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2990);
  gc_frame_newslot((Object)stackframe);
  self = obj2990;
  Object *oldselfslot2990 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2990 = (*(struct UserObject *)self).data[0], lowerouter2990 = thisouter2990;
  if (inheritingObject2990) {
    struct UserObject *inho2990 = (struct UserObject *)inheritingObject2990;
    while (inho2990->super != GraceDefaultObject) inho2990 = (struct UserObject *)inho2990->super;
    inho2990->super = obj2990;
    self = inheritingObject2990;
    *selfslot = self;
    lowerouter2990 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2990;
  }
if (objclass2990 == NULL) {
  Method *reader2992 = addmethodrealflags(obj2990, "kind",&reader_ast_kind_2992, MFLAG_DEF);
  reader2992->definitionModule = modulename;
  reader2992->definitionLine = 638;
}
adddatum2(obj2990, alloc_Undefined(), 1);
if (objclass2990 == NULL) {
  Method *reader2993 = addmethodrealflags(obj2990, "methods",&reader_ast_methods_2993, 0);
  Method *writer2993 = addmethodrealflags(obj2990, "methods:=",&writer_ast_methods_2993, 0);
  reader2993->definitionModule = modulename;
  writer2993->definitionModule = modulename;
  reader2993->definitionLine = 639;
  writer2993->definitionLine = 639;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 2);
if (objclass2990 == NULL) {
  Method *reader2994 = addmethodrealflags(obj2990, "types",&reader_ast_types_2994, 0);
  Method *writer2994 = addmethodrealflags(obj2990, "types:=",&writer_ast_types_2994, 0);
  reader2994->definitionModule = modulename;
  writer2994->definitionModule = modulename;
  reader2994->definitionLine = 640;
  writer2994->definitionLine = 640;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 3);
if (objclass2990 == NULL) {
  Method *reader2995 = addmethodrealflags(obj2990, "nominal",&reader_ast_nominal_2995, 0);
  Method *writer2995 = addmethodrealflags(obj2990, "nominal:=",&writer_ast_nominal_2995, 0);
  reader2995->definitionModule = modulename;
  writer2995->definitionModule = modulename;
  reader2995->definitionLine = 641;
  writer2995->definitionLine = 641;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 4);
if (objclass2990 == NULL) {
  Method *reader2996 = addmethodrealflags(obj2990, "anonymous",&reader_ast_anonymous_2996, 0);
  Method *writer2996 = addmethodrealflags(obj2990, "anonymous:=",&writer_ast_anonymous_2996, 0);
  reader2996->definitionModule = modulename;
  writer2996->definitionModule = modulename;
  reader2996->definitionLine = 642;
  writer2996->definitionLine = 642;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 5);
if (objclass2990 == NULL) {
  Method *reader2997 = addmethodrealflags(obj2990, "value",&reader_ast_value_2997, 0);
  Method *writer2997 = addmethodrealflags(obj2990, "value:=",&writer_ast_value_2997, 0);
  reader2997->definitionModule = modulename;
  writer2997->definitionModule = modulename;
  reader2997->definitionLine = 643;
  writer2997->definitionLine = 643;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo2998 = (struct UserObject*)obj2990;
  uo2998->data[7] = emptyclosure;
  Method *meth_meth_ast_name2998 = addmethod2pos(obj2990, "name", &meth_ast_name2998, 7);
  int argcv_meth_ast_name2998[] = {0};
  meth_meth_ast_name2998->type = alloc_MethodType(1, argcv_meth_ast_name2998);
  meth_meth_ast_name2998->definitionModule = modulename;
  meth_meth_ast_name2998->definitionLine = 645;
// method "name:="
  struct UserObject *uo3001 = (struct UserObject*)obj2990;
  uo3001->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_3001 = addmethod2pos(obj2990, "name:=", &meth_ast_name_58__61_3001, 8);
  int argcv_meth_ast_name_58__61_3001[] = {1};
  meth_meth_ast_name_58__61_3001->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_3001);
  meth_meth_ast_name_58__61_3001->definitionModule = modulename;
  meth_meth_ast_name_58__61_3001->definitionLine = 646;
// method "asString"
  struct UserObject *uo3007 = (struct UserObject*)obj2990;
  uo3007->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3007 = addmethod2pos(obj2990, "asString", &meth_ast_asString3007, 9);
  int argcv_meth_ast_asString3007[] = {0};
  meth_meth_ast_asString3007->type = alloc_MethodType(1, argcv_meth_ast_asString3007);
  meth_meth_ast_asString3007->definitionModule = modulename;
  meth_meth_ast_asString3007->definitionLine = 650;
// method "declarationKindWithAncestors"
  block_savedest(obj2990);
  Object closure3027 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_k);
  struct UserObject *uo3027 = (struct UserObject*)obj2990;
  uo3027->data[10] = (Object)closure3027;
  Method *meth_meth_ast_declarationKindWithAncestors3027 = addmethod2pos(obj2990, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3027, 10);
  int argcv_meth_ast_declarationKindWithAncestors3027[] = {1};
  meth_meth_ast_declarationKindWithAncestors3027->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3027);
  meth_meth_ast_declarationKindWithAncestors3027->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3027->definitionLine = 653;
// method "isExecutable"
  struct UserObject *uo3030 = (struct UserObject*)obj2990;
  uo3030->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3030 = addmethod2pos(obj2990, "isExecutable", &meth_ast_isExecutable3030, 11);
  int argcv_meth_ast_isExecutable3030[] = {0};
  meth_meth_ast_isExecutable3030->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3030);
  meth_meth_ast_isExecutable3030->definitionModule = modulename;
  meth_meth_ast_isExecutable3030->definitionLine = 654;
// method "accept()from"
  struct UserObject *uo3032 = (struct UserObject*)obj2990;
  uo3032->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3032 = addmethod2pos(obj2990, "accept()from", &meth_ast_accept_40__41_from3032, 12);
  int argcv_meth_ast_accept_40__41_from3032[] = {1, 1};
  meth_meth_ast_accept_40__41_from3032->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3032);
  meth_meth_ast_accept_40__41_from3032->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3032->definitionLine = 656;
// method "map()ancestors"
  struct UserObject *uo3056 = (struct UserObject*)obj2990;
  uo3056->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3056 = addmethod2pos(obj2990, "map()ancestors", &meth_ast_map_40__41_ancestors3056, 13);
  int argcv_meth_ast_map_40__41_ancestors3056[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3056->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3056);
  meth_meth_ast_map_40__41_ancestors3056->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3056->definitionLine = 667;
// method "pretty"
  struct UserObject *uo3083 = (struct UserObject*)obj2990;
  uo3083->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3083 = addmethod2pos(obj2990, "pretty", &meth_ast_pretty3083, 14);
  int argcv_meth_ast_pretty3083[] = {1};
  meth_meth_ast_pretty3083->type = alloc_MethodType(1, argcv_meth_ast_pretty3083);
  meth_meth_ast_pretty3083->definitionModule = modulename;
  meth_meth_ast_pretty3083->definitionLine = 674;
// method "toGrace"
  struct UserObject *uo3182 = (struct UserObject*)obj2990;
  uo3182->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3182 = addmethod2pos(obj2990, "toGrace", &meth_ast_toGrace3182, 15);
  int argcv_meth_ast_toGrace3182[] = {1};
  meth_meth_ast_toGrace3182->type = alloc_MethodType(1, argcv_meth_ast_toGrace3182);
meth_meth_ast_toGrace3182->type->types[0] = type_Number;
meth_meth_ast_toGrace3182->type->names[0] = "depth";
  meth_meth_ast_toGrace3182->definitionModule = modulename;
  meth_meth_ast_toGrace3182->definitionLine = 691;
// method "shallowCopy"
  block_savedest(obj2990);
  Object closure3268 = createclosure(2, "shallowCopy");
  setclosureframe(closure3268, stackframe);
  addtoclosure(closure3268, var_emptySeq);
  addtoclosure(closure3268, var_typeLiteralNode);
  struct UserObject *uo3268 = (struct UserObject*)obj2990;
  uo3268->data[16] = (Object)closure3268;
  Method *meth_meth_ast_shallowCopy3268 = addmethod2pos(obj2990, "shallowCopy", &meth_ast_shallowCopy3268, 16);
  int argcv_meth_ast_shallowCopy3268[] = {0};
  meth_meth_ast_shallowCopy3268->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3268);
  meth_meth_ast_shallowCopy3268->definitionModule = modulename;
  meth_meth_ast_shallowCopy3268->definitionLine = 706;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo3273 = (struct UserObject*)obj2990;
  uo3273->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3273 = addmethod2pos(obj2990, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3273, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom3273[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3273->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3273);
  meth_meth_ast_shallowCopyFieldsFrom3273->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3273->definitionLine = 709;
  sourceObject = obj2990;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3288 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3289 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3290 = gc_frame_new();
// call case 3: self.outer request
  Object call3291 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3290);
// compiled call node returning call3291 (depth = 7)
// compiled member node returning call3291 (depth = 6)
  partcv[0] = 0;
  Object call3292 = callmethodflags(call3291, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3289);
// compiled call node returning call3292 (depth = 5)
// compiled member node returning call3292 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3293 = callmethodflags(call3292, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3288);
// compiled call node returning call3293 (depth = 3)
  struct UserObject *obj2990_uo = (struct UserObject *)obj2990;
  obj2990_uo->super = call3293;
  sourceObject = obj2990;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3294 == NULL) {
    strlit3294 = alloc_String("typeliteral");
    gc_root(strlit3294);
  }
// compiled string node returning strlit3294 (depth = 3)
  adddatum2(obj2990, strlit3294, 1);
  sourceObject = obj2990;
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj2990, *var_methods_39_, 2);
  sourceObject = obj2990;
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj2990, *var_types_39_, 3);
  sourceObject = obj2990;
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3295 = alloc_Boolean(0);
// compiled identifier node returning bool3295 (depth = 3)
  adddatum2(obj2990, bool3295, 4);
  sourceObject = obj2990;
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3296 = alloc_Boolean(1);
// compiled identifier node returning bool3296 (depth = 3)
  adddatum2(obj2990, bool3296, 5);
  sourceObject = obj2990;
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 3)
  adddatum2(obj2990, strlit3297, 6);
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  objclass2990 = obj2990->class;
  objclass2990->definitionModule = modulename;
  objclass2990->definitionLine = 636;
  (*(struct UserObject *)self).data[0] = lowerouter2990;
  self = oldself2990;
  selfslot = oldselfslot2990;
  stackframe = oldstackframe2990;
  gc_frame_end(frame);
  return obj2990;
}
Object meth_ast_new2989_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeLiteralNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2990 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2990 = alloc_userobj2(22,18, objclass2990);
  gc_frame_newslot(obj2990);
if (objclass2990 == NULL) {
  glfree(obj2990->class->name);
  obj2990->class->name = "typeLiteralNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2990, self, 0);
  addmethodreal(obj2990,"outer", &reader_ast_outer_2991);
  Object oldself2990 = self;
  struct StackFrameObject *oldstackframe2990 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2990);
  gc_frame_newslot((Object)stackframe);
  self = obj2990;
  Object *oldselfslot2990 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2990 = (*(struct UserObject *)self).data[0], lowerouter2990 = thisouter2990;
  if (inheritingObject2990) {
    struct UserObject *inho2990 = (struct UserObject *)inheritingObject2990;
    while (inho2990->super != GraceDefaultObject) inho2990 = (struct UserObject *)inho2990->super;
    inho2990->super = obj2990;
    self = inheritingObject2990;
    *selfslot = self;
    lowerouter2990 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2990;
  }
if (objclass2990 == NULL) {
  Method *reader2992 = addmethodrealflags(obj2990, "kind",&reader_ast_kind_2992, MFLAG_DEF);
  reader2992->definitionModule = modulename;
  reader2992->definitionLine = 638;
}
adddatum2(obj2990, alloc_Undefined(), 1);
if (objclass2990 == NULL) {
  Method *reader2993 = addmethodrealflags(obj2990, "methods",&reader_ast_methods_2993, 0);
  Method *writer2993 = addmethodrealflags(obj2990, "methods:=",&writer_ast_methods_2993, 0);
  reader2993->definitionModule = modulename;
  writer2993->definitionModule = modulename;
  reader2993->definitionLine = 639;
  writer2993->definitionLine = 639;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 2);
if (objclass2990 == NULL) {
  Method *reader2994 = addmethodrealflags(obj2990, "types",&reader_ast_types_2994, 0);
  Method *writer2994 = addmethodrealflags(obj2990, "types:=",&writer_ast_types_2994, 0);
  reader2994->definitionModule = modulename;
  writer2994->definitionModule = modulename;
  reader2994->definitionLine = 640;
  writer2994->definitionLine = 640;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 3);
if (objclass2990 == NULL) {
  Method *reader2995 = addmethodrealflags(obj2990, "nominal",&reader_ast_nominal_2995, 0);
  Method *writer2995 = addmethodrealflags(obj2990, "nominal:=",&writer_ast_nominal_2995, 0);
  reader2995->definitionModule = modulename;
  writer2995->definitionModule = modulename;
  reader2995->definitionLine = 641;
  writer2995->definitionLine = 641;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 4);
if (objclass2990 == NULL) {
  Method *reader2996 = addmethodrealflags(obj2990, "anonymous",&reader_ast_anonymous_2996, 0);
  Method *writer2996 = addmethodrealflags(obj2990, "anonymous:=",&writer_ast_anonymous_2996, 0);
  reader2996->definitionModule = modulename;
  writer2996->definitionModule = modulename;
  reader2996->definitionLine = 642;
  writer2996->definitionLine = 642;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 5);
if (objclass2990 == NULL) {
  Method *reader2997 = addmethodrealflags(obj2990, "value",&reader_ast_value_2997, 0);
  Method *writer2997 = addmethodrealflags(obj2990, "value:=",&writer_ast_value_2997, 0);
  reader2997->definitionModule = modulename;
  writer2997->definitionModule = modulename;
  reader2997->definitionLine = 643;
  writer2997->definitionLine = 643;
}
obj2990->flags |= OFLAG_MUTABLE;
adddatum2(obj2990, alloc_Undefined(), 6);
// method "name"
  struct UserObject *uo2998 = (struct UserObject*)obj2990;
  uo2998->data[7] = emptyclosure;
  Method *meth_meth_ast_name2998 = addmethod2pos(obj2990, "name", &meth_ast_name2998, 7);
  int argcv_meth_ast_name2998[] = {0};
  meth_meth_ast_name2998->type = alloc_MethodType(1, argcv_meth_ast_name2998);
  meth_meth_ast_name2998->definitionModule = modulename;
  meth_meth_ast_name2998->definitionLine = 645;
// method "name:="
  struct UserObject *uo3001 = (struct UserObject*)obj2990;
  uo3001->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_3001 = addmethod2pos(obj2990, "name:=", &meth_ast_name_58__61_3001, 8);
  int argcv_meth_ast_name_58__61_3001[] = {1};
  meth_meth_ast_name_58__61_3001->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_3001);
  meth_meth_ast_name_58__61_3001->definitionModule = modulename;
  meth_meth_ast_name_58__61_3001->definitionLine = 646;
// method "asString"
  struct UserObject *uo3007 = (struct UserObject*)obj2990;
  uo3007->data[9] = emptyclosure;
  Method *meth_meth_ast_asString3007 = addmethod2pos(obj2990, "asString", &meth_ast_asString3007, 9);
  int argcv_meth_ast_asString3007[] = {0};
  meth_meth_ast_asString3007->type = alloc_MethodType(1, argcv_meth_ast_asString3007);
  meth_meth_ast_asString3007->definitionModule = modulename;
  meth_meth_ast_asString3007->definitionLine = 650;
// method "declarationKindWithAncestors"
  block_savedest(obj2990);
  Object closure3027 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_k);
  struct UserObject *uo3027 = (struct UserObject*)obj2990;
  uo3027->data[10] = (Object)closure3027;
  Method *meth_meth_ast_declarationKindWithAncestors3027 = addmethod2pos(obj2990, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3027, 10);
  int argcv_meth_ast_declarationKindWithAncestors3027[] = {1};
  meth_meth_ast_declarationKindWithAncestors3027->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3027);
  meth_meth_ast_declarationKindWithAncestors3027->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3027->definitionLine = 653;
// method "isExecutable"
  struct UserObject *uo3030 = (struct UserObject*)obj2990;
  uo3030->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable3030 = addmethod2pos(obj2990, "isExecutable", &meth_ast_isExecutable3030, 11);
  int argcv_meth_ast_isExecutable3030[] = {0};
  meth_meth_ast_isExecutable3030->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3030);
  meth_meth_ast_isExecutable3030->definitionModule = modulename;
  meth_meth_ast_isExecutable3030->definitionLine = 654;
// method "accept()from"
  struct UserObject *uo3032 = (struct UserObject*)obj2990;
  uo3032->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3032 = addmethod2pos(obj2990, "accept()from", &meth_ast_accept_40__41_from3032, 12);
  int argcv_meth_ast_accept_40__41_from3032[] = {1, 1};
  meth_meth_ast_accept_40__41_from3032->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3032);
  meth_meth_ast_accept_40__41_from3032->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3032->definitionLine = 656;
// method "map()ancestors"
  struct UserObject *uo3056 = (struct UserObject*)obj2990;
  uo3056->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3056 = addmethod2pos(obj2990, "map()ancestors", &meth_ast_map_40__41_ancestors3056, 13);
  int argcv_meth_ast_map_40__41_ancestors3056[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3056->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3056);
  meth_meth_ast_map_40__41_ancestors3056->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3056->definitionLine = 667;
// method "pretty"
  struct UserObject *uo3083 = (struct UserObject*)obj2990;
  uo3083->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3083 = addmethod2pos(obj2990, "pretty", &meth_ast_pretty3083, 14);
  int argcv_meth_ast_pretty3083[] = {1};
  meth_meth_ast_pretty3083->type = alloc_MethodType(1, argcv_meth_ast_pretty3083);
  meth_meth_ast_pretty3083->definitionModule = modulename;
  meth_meth_ast_pretty3083->definitionLine = 674;
// method "toGrace"
  struct UserObject *uo3182 = (struct UserObject*)obj2990;
  uo3182->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3182 = addmethod2pos(obj2990, "toGrace", &meth_ast_toGrace3182, 15);
  int argcv_meth_ast_toGrace3182[] = {1};
  meth_meth_ast_toGrace3182->type = alloc_MethodType(1, argcv_meth_ast_toGrace3182);
meth_meth_ast_toGrace3182->type->types[0] = type_Number;
meth_meth_ast_toGrace3182->type->names[0] = "depth";
  meth_meth_ast_toGrace3182->definitionModule = modulename;
  meth_meth_ast_toGrace3182->definitionLine = 691;
// method "shallowCopy"
  block_savedest(obj2990);
  Object closure3268 = createclosure(2, "shallowCopy");
  setclosureframe(closure3268, stackframe);
  addtoclosure(closure3268, var_emptySeq);
  addtoclosure(closure3268, var_typeLiteralNode);
  struct UserObject *uo3268 = (struct UserObject*)obj2990;
  uo3268->data[16] = (Object)closure3268;
  Method *meth_meth_ast_shallowCopy3268 = addmethod2pos(obj2990, "shallowCopy", &meth_ast_shallowCopy3268, 16);
  int argcv_meth_ast_shallowCopy3268[] = {0};
  meth_meth_ast_shallowCopy3268->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3268);
  meth_meth_ast_shallowCopy3268->definitionModule = modulename;
  meth_meth_ast_shallowCopy3268->definitionLine = 706;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo3273 = (struct UserObject*)obj2990;
  uo3273->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom3273 = addmethod2pos(obj2990, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom3273, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom3273[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom3273->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom3273);
  meth_meth_ast_shallowCopyFieldsFrom3273->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom3273->definitionLine = 709;
  sourceObject = obj2990;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3288 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3289 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3290 = gc_frame_new();
// call case 3: self.outer request
  Object call3291 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3290);
// compiled call node returning call3291 (depth = 7)
// compiled member node returning call3291 (depth = 6)
  partcv[0] = 0;
  Object call3292 = callmethodflags(call3291, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3289);
// compiled call node returning call3292 (depth = 5)
// compiled member node returning call3292 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3293 = callmethodflags(call3292, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3288);
// compiled call node returning call3293 (depth = 3)
  struct UserObject *obj2990_uo = (struct UserObject *)obj2990;
  obj2990_uo->super = call3293;
  sourceObject = obj2990;
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3294 == NULL) {
    strlit3294 = alloc_String("typeliteral");
    gc_root(strlit3294);
  }
// compiled string node returning strlit3294 (depth = 3)
  adddatum2(obj2990, strlit3294, 1);
  sourceObject = obj2990;
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methods_39_ (depth = 3)
  adddatum2(obj2990, *var_methods_39_, 2);
  sourceObject = obj2990;
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_types_39_ (depth = 3)
  adddatum2(obj2990, *var_types_39_, 3);
  sourceObject = obj2990;
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3295 = alloc_Boolean(0);
// compiled identifier node returning bool3295 (depth = 3)
  adddatum2(obj2990, bool3295, 4);
  sourceObject = obj2990;
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3296 = alloc_Boolean(1);
// compiled identifier node returning bool3296 (depth = 3)
  adddatum2(obj2990, bool3296, 5);
  sourceObject = obj2990;
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 3)
  adddatum2(obj2990, strlit3297, 6);
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  sourceObject = obj2990;
  objclass2990 = obj2990->class;
  objclass2990->definitionModule = modulename;
  objclass2990->definitionLine = 636;
  (*(struct UserObject *)self).data[0] = lowerouter2990;
  self = oldself2990;
  selfslot = oldselfslot2990;
  stackframe = oldstackframe2990;
  gc_frame_end(frame);
  return obj2990;
}
Object meth_ast_typeLiteralNode3299(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeLiteralNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeLiteralNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_isLegalInTrait3311(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3312 = alloc_Boolean(1);
// compiled identifier node returning bool3312 (depth = 3)
  gc_frame_end(frame);
  return bool3312;
}
Object meth_ast_isTypeDec3313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTypeDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3314 = alloc_Boolean(1);
// compiled identifier node returning bool3314 (depth = 3)
  gc_frame_end(frame);
  return bool3314;
}
Object meth_ast_scope_58__61_3315(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3316 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3317 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3316);
// compiled call node returning call3317 (depth = 3)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3318 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3319 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3318);
// compiled call node returning call3319 (depth = 3)
  gc_frame_end(frame);
  return call3319;
}
Object meth_ast_isExecutable3320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3321 = alloc_Boolean(1);
// compiled identifier node returning bool3321 (depth = 3)
  gc_frame_end(frame);
  return bool3321;
}
Object meth_ast_declarationKindWithAncestors3322(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3324 = callmethod(*var_k, "typeparam",
    1, partcv, params);
  gc_frame_end(callframe3323);
// compiled call node returning call3324 (depth = 4)
// compiled member node returning call3324 (depth = 3)
  gc_frame_end(frame);
  return call3324;
}
Object meth_ast_isConfidential3325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3328 = alloc_Float64(0);
// compiled num node returning num3328 (depth = 5)
  int op_slot_right_3327 = gc_frame_newslot(num3328);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3330 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3332 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3331);
// compiled call node returning call3332 (depth = 8)
// compiled member node returning call3332 (depth = 7)
  partcv[0] = 0;
  Object call3333 = callmethod(call3332, "size",
    1, partcv, params);
  gc_frame_end(callframe3330);
// compiled call node returning call3333 (depth = 6)
// compiled member node returning call3333 (depth = 5)
  int op_slot_left_3327 = gc_frame_newslot(call3333);
  params[0] = num3328;
  partcv[0] = 1;
  Object opresult3334 = callmethod(call3333, "==", 1, partcv, params);
// compiled op node returning opresult3334 (depth = 4)
  Object if3326 = done;
  if (istrue(opresult3334)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3335 = alloc_Boolean(0);
// compiled identifier node returning bool3335 (depth = 5)
  return bool3335;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3326 = undefined;
  } else {
  }
// compiled if node returning if3326 (depth = 3)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3336 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3337 == NULL) {
    strlit3337 = alloc_String("confidential");
    gc_root(strlit3337);
  }
// compiled string node returning strlit3337 (depth = 4)
  gc_frame_newslot(strlit3337);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3338 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3339 = gc_frame_new();
// call case 3: self.outer request
  Object call3340 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3339);
// compiled call node returning call3340 (depth = 7)
// compiled member node returning call3340 (depth = 6)
  partcv[0] = 0;
  Object call3341 = callmethodflags(call3340, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3338);
// compiled call node returning call3341 (depth = 5)
// compiled member node returning call3341 (depth = 4)
  params[0] = self;
  params[1] = strlit3337;
  partcv[0] = 2;
  Object call3342 = callmethodflags(call3341, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3336);
// compiled call node returning call3342 (depth = 3)
  gc_frame_end(frame);
  return call3342;
}
Object meth_ast_isPublic3343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3344 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3346 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3345);
// compiled call node returning call3346 (depth = 6)
// compiled member node returning call3346 (depth = 5)
  partcv[0] = 0;
  Object call3347 = callmethod(call3346, "not",
    1, partcv, params);
  gc_frame_end(callframe3344);
// compiled call node returning call3347 (depth = 4)
// compiled member node returning call3347 (depth = 3)
  gc_frame_end(frame);
  return call3347;
}
Object meth_ast_isWritable3348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3349 = alloc_Boolean(0);
// compiled identifier node returning bool3349 (depth = 3)
  gc_frame_end(frame);
  return bool3349;
}
Object meth_ast_isReadable3350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3352 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3351);
// compiled call node returning call3352 (depth = 4)
// compiled member node returning call3352 (depth = 3)
  gc_frame_end(frame);
  return call3352;
}
Object meth_ast__apply3376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe3377 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3378 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3377);
// compiled call node returning call3378 (depth = 6)
  gc_frame_end(frame);
  return call3378;
}
Object meth_ast_accept_40__41_from3353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3355 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3356 = callmethod(*var_visitor, "visitTypeDec()up",
    2, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 4)
  Object if3354 = done;
  if (istrue(call3356)) {
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3357 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3358 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3357);
// compiled call node returning call3358 (depth = 5)
  *var_newChain = call3358;
  if (call3358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3359 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3361 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3360);
// compiled call node returning call3361 (depth = 6)
// compiled member node returning call3361 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3362 = callmethod(call3361, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3359);
// compiled call node returning call3362 (depth = 4)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3366 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3365);
// compiled call node returning call3366 (depth = 7)
// compiled member node returning call3366 (depth = 6)
  int op_slot_right_3364 = gc_frame_newslot(call3366);
// starting to compile identifier node (depth = 6)
  Object bool3368 = alloc_Boolean(0);
// compiled identifier node returning bool3368 (depth = 6)
  int op_slot_left_3364 = gc_frame_newslot(bool3368);
  params[0] = call3366;
  partcv[0] = 1;
  Object opresult3369 = callmethod(bool3368, "≠", 1, partcv, params);
// compiled op node returning opresult3369 (depth = 5)
  Object if3363 = done;
  if (istrue(opresult3369)) {
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3370 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3372 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3371);
// compiled call node returning call3372 (depth = 7)
// compiled member node returning call3372 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3373 = callmethod(call3372, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3370);
// compiled call node returning call3373 (depth = 5)
    gc_frame_newslot(call3373);
    if3363 = call3373;
  } else {
  }
// compiled if node returning if3363 (depth = 4)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3374 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3375 = alloc_Block(NULL, NULL, "ast", 755);
  gc_frame_newslot(block3375);
// method "_apply"
  block_savedest(block3375);
  Object closure3376 = createclosure(3, "_apply");
  setclosureframe(closure3376, stackframe);
  addtoclosure(closure3376, var_visitor);
  addtoclosure(closure3376, var_newChain);
  addtoclosure(closure3376, selfslot);
  struct UserObject *uo3376 = (struct UserObject*)block3375;
  uo3376->data[0] = (Object)closure3376;
  Method *meth_meth_ast__apply3376 = addmethod2pos(block3375, "_apply", &meth_ast__apply3376, 0);
  int argcv_meth_ast__apply3376[] = {1};
  meth_meth_ast__apply3376->type = alloc_MethodType(1, argcv_meth_ast__apply3376);
  meth_meth_ast__apply3376->definitionModule = modulename;
  meth_meth_ast__apply3376->definitionLine = 753;
// compiled block node returning block3375 (depth = 5)
  gc_frame_newslot(block3375);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3381 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3380);
// compiled call node returning call3381 (depth = 6)
// compiled member node returning call3381 (depth = 5)
  params[0] = block3375;
  partcv[0] = 1;
  Object call3382 = callmethod(call3381, "do",
    1, partcv, params);
  gc_frame_end(callframe3374);
// compiled call node returning call3382 (depth = 4)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3383 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3385 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled call node returning call3385 (depth = 6)
// compiled member node returning call3385 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3386 = callmethod(call3385, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3383);
// compiled call node returning call3386 (depth = 4)
    gc_frame_newslot(call3386);
    if3354 = call3386;
  } else {
  }
// compiled if node returning if3354 (depth = 3)
  gc_frame_end(frame);
  return if3354;
}
Object meth_ast_map_40__41_ancestors3387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3389 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3388);
// compiled call node returning call3389 (depth = 5)
// compiled member node returning call3389 (depth = 4)
  *var_n = call3389;
  if (call3389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3390 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3391 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3390);
// compiled call node returning call3391 (depth = 4)
  *var_newChain = call3391;
  if (call3391 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3392 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3393 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3395 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3394);
// compiled call node returning call3395 (depth = 6)
// compiled member node returning call3395 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3396 = callmethod(call3395, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3393);
// compiled call node returning call3396 (depth = 4)
  gc_frame_newslot(call3396);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3396;
  partcv[0] = 1;
  Object call3397 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe3392);
// compiled call node returning call3397 (depth = 3)
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3398 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3399 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3401 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3400);
// compiled call node returning call3401 (depth = 6)
// compiled member node returning call3401 (depth = 5)
  gc_frame_newslot(call3401);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3402 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3403 = gc_frame_new();
// call case 3: self.outer request
  Object call3404 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3403);
// compiled call node returning call3404 (depth = 8)
// compiled member node returning call3404 (depth = 7)
  partcv[0] = 0;
  Object call3405 = callmethodflags(call3404, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3402);
// compiled call node returning call3405 (depth = 6)
// compiled member node returning call3405 (depth = 5)
  params[0] = call3401;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3406 = callmethodflags(call3405, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3399);
// compiled call node returning call3406 (depth = 4)
  gc_frame_newslot(call3406);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3406;
  partcv[0] = 1;
  Object call3407 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe3398);
// compiled call node returning call3407 (depth = 3)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3408 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3409 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3410 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3411 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3410);
// compiled call node returning call3411 (depth = 6)
// compiled member node returning call3411 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3412 = callmethod(call3411, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe3409);
// compiled call node returning call3412 (depth = 4)
  gc_frame_newslot(call3412);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3412;
  partcv[0] = 1;
  Object call3413 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe3408);
// compiled call node returning call3413 (depth = 3)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3414 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3415 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3417 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3416);
// compiled call node returning call3417 (depth = 6)
// compiled member node returning call3417 (depth = 5)
  gc_frame_newslot(call3417);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3418 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3419 = gc_frame_new();
// call case 3: self.outer request
  Object call3420 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3419);
// compiled call node returning call3420 (depth = 8)
// compiled member node returning call3420 (depth = 7)
  partcv[0] = 0;
  Object call3421 = callmethodflags(call3420, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3418);
// compiled call node returning call3421 (depth = 6)
// compiled member node returning call3421 (depth = 5)
  params[0] = call3417;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3422 = callmethodflags(call3421, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3415);
// compiled call node returning call3422 (depth = 4)
  gc_frame_newslot(call3422);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3422;
  partcv[0] = 1;
  Object call3423 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3414);
// compiled call node returning call3423 (depth = 3)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3424 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3425 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3424);
// compiled call node returning call3425 (depth = 3)
  gc_frame_end(frame);
  return call3425;
}
Object meth_ast__apply3434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3436 == NULL) {
    strlit3436 = alloc_String("  ");
    gc_root(strlit3436);
  }
// compiled string node returning strlit3436 (depth = 7)
  int op_slot_right_3435 = gc_frame_newslot(strlit3436);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3435 = gc_frame_newslot(*var_spc);
  params[0] = strlit3436;
  partcv[0] = 1;
  Object opresult3438 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3438 (depth = 6)
  *var_spc = opresult3438;
  if (opresult3438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3427 == NULL) {
    strlit3427 = alloc_String("");
    gc_root(strlit3427);
  }
// compiled string node returning strlit3427 (depth = 4)
  *var_spc = strlit3427;
  if (strlit3427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3428 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3429 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3431 = alloc_Float64(0);
// compiled num node returning num3431 (depth = 5)
  int op_slot_left_3429 = gc_frame_newslot(num3431);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3432 = callmethod(num3431, "..", 1, partcv, params);
// compiled op node returning opresult3432 (depth = 4)
  gc_frame_newslot(opresult3432);
// starting to compile block node (depth = 4)
  Object block3433 = alloc_Block(NULL, NULL, "ast", 770);
  gc_frame_newslot(block3433);
// method "_apply"
  block_savedest(block3433);
  Object closure3434 = createclosure(2, "_apply");
  setclosureframe(closure3434, stackframe);
  addtoclosure(closure3434, var_spc);
  addtoclosure(closure3434, selfslot);
  struct UserObject *uo3434 = (struct UserObject*)block3433;
  uo3434->data[0] = (Object)closure3434;
  Method *meth_meth_ast__apply3434 = addmethod2pos(block3433, "_apply", &meth_ast__apply3434, 0);
  int argcv_meth_ast__apply3434[] = {1};
  meth_meth_ast__apply3434->type = alloc_MethodType(1, argcv_meth_ast__apply3434);
  meth_meth_ast__apply3434->definitionModule = modulename;
  meth_meth_ast__apply3434->definitionLine = 765;
// compiled block node returning block3433 (depth = 4)
  gc_frame_newslot(block3433);
// call case 5: prelude request
  params[0] = opresult3432;
  params[1] = block3433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3441 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3428);
// compiled call node returning call3441 (depth = 3)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3443 == NULL) {
    strlit3443 = alloc_String("""\x0a""");
    gc_root(strlit3443);
  }
// compiled string node returning strlit3443 (depth = 5)
  int op_slot_right_3442 = gc_frame_newslot(strlit3443);
// starting to compile call node (depth = 5)
  int callframe3445 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3446 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3445);
// compiled call node returning call3446 (depth = 5)
  int op_slot_left_3442 = gc_frame_newslot(call3446);
  params[0] = strlit3443;
  partcv[0] = 1;
  Object opresult3447 = callmethod(call3446, "++", 1, partcv, params);
// compiled op node returning opresult3447 (depth = 4)
  *var_s = opresult3447;
  if (opresult3447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3449 == NULL) {
    strlit3449 = alloc_String("""\x0a""");
    gc_root(strlit3449);
  }
// compiled string node returning strlit3449 (depth = 5)
  int op_slot_right_3448 = gc_frame_newslot(strlit3449);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3452 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3454 = alloc_Float64(1);
// compiled num node returning num3454 (depth = 8)
  int op_slot_right_3453 = gc_frame_newslot(num3454);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3453 = gc_frame_newslot(*var_depth);
  params[0] = num3454;
  partcv[0] = 1;
  Object sum3456 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3456 (depth = 7)
  gc_frame_newslot(sum3456);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3458 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 8)
// compiled member node returning call3458 (depth = 7)
  params[0] = sum3456;
  partcv[0] = 1;
  Object call3459 = callmethod(call3458, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3452);
// compiled call node returning call3459 (depth = 6)
  int op_slot_right_3451 = gc_frame_newslot(call3459);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3461 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3461 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3463 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3463 (depth = 6)
  int op_slot_left_3451 = gc_frame_newslot(opresult3463);
  params[0] = call3459;
  partcv[0] = 1;
  Object opresult3464 = callmethod(opresult3463, "++", 1, partcv, params);
// compiled op node returning opresult3464 (depth = 5)
  int op_slot_left_3448 = gc_frame_newslot(opresult3464);
  params[0] = strlit3449;
  partcv[0] = 1;
  Object opresult3465 = callmethod(opresult3464, "++", 1, partcv, params);
// compiled op node returning opresult3465 (depth = 4)
  *var_s = opresult3465;
  if (opresult3465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3470 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3469);
// compiled call node returning call3470 (depth = 6)
// compiled member node returning call3470 (depth = 5)
  int op_slot_right_3468 = gc_frame_newslot(call3470);
// starting to compile identifier node (depth = 5)
  Object bool3472 = alloc_Boolean(0);
// compiled identifier node returning bool3472 (depth = 5)
  int op_slot_left_3468 = gc_frame_newslot(bool3472);
  params[0] = call3470;
  partcv[0] = 1;
  Object opresult3473 = callmethod(bool3472, "≠", 1, partcv, params);
// compiled op node returning opresult3473 (depth = 4)
  Object if3467 = done;
  if (istrue(opresult3473)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3475 == NULL) {
    strlit3475 = alloc_String("""\x0a""");
    gc_root(strlit3475);
  }
// compiled string node returning strlit3475 (depth = 6)
  int op_slot_right_3474 = gc_frame_newslot(strlit3475);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3478 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3480 = alloc_Float64(2);
// compiled num node returning num3480 (depth = 9)
  int op_slot_right_3479 = gc_frame_newslot(num3480);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3479 = gc_frame_newslot(*var_depth);
  params[0] = num3480;
  partcv[0] = 1;
  Object sum3482 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3482 (depth = 8)
  gc_frame_newslot(sum3482);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3483 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3484 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3483);
// compiled call node returning call3484 (depth = 9)
// compiled member node returning call3484 (depth = 8)
  params[0] = sum3482;
  partcv[0] = 1;
  Object call3485 = callmethod(call3484, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3478);
// compiled call node returning call3485 (depth = 7)
  int op_slot_right_3477 = gc_frame_newslot(call3485);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3488 == NULL) {
    strlit3488 = alloc_String("Type parameters:""\x0a""");
    gc_root(strlit3488);
  }
// compiled string node returning strlit3488 (depth = 8)
  int op_slot_right_3487 = gc_frame_newslot(strlit3488);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3490 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3493 == NULL) {
    strlit3493 = alloc_String("");
    gc_root(strlit3493);
  }
// compiled string node returning strlit3493 (depth = 10)
  int op_slot_right_3492 = gc_frame_newslot(strlit3493);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3495 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3497 == NULL) {
    strlit3497 = alloc_String("");
    gc_root(strlit3497);
  }
// compiled string node returning strlit3497 (depth = 11)
  int op_slot_left_3495 = gc_frame_newslot(strlit3497);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3498 = callmethod(strlit3497, "++", 1, partcv, params);
// compiled op node returning opresult3498 (depth = 10)
  int op_slot_left_3492 = gc_frame_newslot(opresult3498);
  params[0] = strlit3493;
  partcv[0] = 1;
  Object opresult3499 = callmethod(opresult3498, "++", 1, partcv, params);
// compiled op node returning opresult3499 (depth = 9)
  int op_slot_left_3490 = gc_frame_newslot(opresult3499);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3500 = callmethod(opresult3499, "++", 1, partcv, params);
// compiled op node returning opresult3500 (depth = 8)
  int op_slot_left_3487 = gc_frame_newslot(opresult3500);
  params[0] = strlit3488;
  partcv[0] = 1;
  Object opresult3501 = callmethod(opresult3500, "++", 1, partcv, params);
// compiled op node returning opresult3501 (depth = 7)
  int op_slot_left_3477 = gc_frame_newslot(opresult3501);
  params[0] = call3485;
  partcv[0] = 1;
  Object opresult3502 = callmethod(opresult3501, "++", 1, partcv, params);
// compiled op node returning opresult3502 (depth = 6)
  int op_slot_left_3474 = gc_frame_newslot(opresult3502);
  params[0] = strlit3475;
  partcv[0] = 1;
  Object opresult3503 = callmethod(opresult3502, "++", 1, partcv, params);
// compiled op node returning opresult3503 (depth = 5)
  *var_s = opresult3503;
  if (opresult3503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3467 = done;
  } else {
  }
// compiled if node returning if3467 (depth = 3)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3506 == NULL) {
    strlit3506 = alloc_String("Value:");
    gc_root(strlit3506);
  }
// compiled string node returning strlit3506 (depth = 5)
  int op_slot_right_3505 = gc_frame_newslot(strlit3506);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_3508 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3508 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3510 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3510 (depth = 5)
  int op_slot_left_3505 = gc_frame_newslot(opresult3510);
  params[0] = strlit3506;
  partcv[0] = 1;
  Object opresult3511 = callmethod(opresult3510, "++", 1, partcv, params);
// compiled op node returning opresult3511 (depth = 4)
  *var_s = opresult3511;
  if (opresult3511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3514 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3516 = alloc_Float64(2);
// compiled num node returning num3516 (depth = 7)
  int op_slot_right_3515 = gc_frame_newslot(num3516);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3515 = gc_frame_newslot(*var_depth);
  params[0] = num3516;
  partcv[0] = 1;
  Object sum3518 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3518 (depth = 6)
  gc_frame_newslot(sum3518);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3519 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3520 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3519);
// compiled call node returning call3520 (depth = 7)
// compiled member node returning call3520 (depth = 6)
  params[0] = sum3518;
  partcv[0] = 1;
  Object call3521 = callmethod(call3520, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3514);
// compiled call node returning call3521 (depth = 5)
  int op_slot_right_3513 = gc_frame_newslot(call3521);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3513 = gc_frame_newslot(*var_s);
  params[0] = call3521;
  partcv[0] = 1;
  Object opresult3523 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3523 (depth = 4)
  *var_s = opresult3523;
  if (opresult3523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3526 == NULL) {
    strlit3526 = alloc_String("""\x0a""");
    gc_root(strlit3526);
  }
// compiled string node returning strlit3526 (depth = 5)
  int op_slot_right_3525 = gc_frame_newslot(strlit3526);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3525 = gc_frame_newslot(*var_s);
  params[0] = strlit3526;
  partcv[0] = 1;
  Object opresult3528 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3528 (depth = 4)
  *var_s = opresult3528;
  if (opresult3528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3532 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3533 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3532);
// compiled call node returning call3533 (depth = 6)
// compiled member node returning call3533 (depth = 5)
  int op_slot_right_3531 = gc_frame_newslot(call3533);
// starting to compile identifier node (depth = 5)
  Object bool3535 = alloc_Boolean(0);
// compiled identifier node returning bool3535 (depth = 5)
  int op_slot_left_3531 = gc_frame_newslot(bool3535);
  params[0] = call3533;
  partcv[0] = 1;
  Object opresult3536 = callmethod(bool3535, "≠", 1, partcv, params);
// compiled op node returning opresult3536 (depth = 4)
  Object if3530 = done;
  if (istrue(opresult3536)) {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3538 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3540 = alloc_Float64(2);
// compiled num node returning num3540 (depth = 8)
  int op_slot_right_3539 = gc_frame_newslot(num3540);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3539 = gc_frame_newslot(*var_depth);
  params[0] = num3540;
  partcv[0] = 1;
  Object sum3542 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3542 (depth = 7)
  gc_frame_newslot(sum3542);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3544 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3543);
// compiled call node returning call3544 (depth = 8)
// compiled member node returning call3544 (depth = 7)
  params[0] = sum3542;
  partcv[0] = 1;
  Object call3545 = callmethod(call3544, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3538);
// compiled call node returning call3545 (depth = 6)
  int op_slot_right_3537 = gc_frame_newslot(call3545);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3537 = gc_frame_newslot(*var_s);
  params[0] = call3545;
  partcv[0] = 1;
  Object opresult3547 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3547 (depth = 5)
  *var_s = opresult3547;
  if (opresult3547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3530 = done;
  } else {
  }
// compiled if node returning if3530 (depth = 3)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3563 == NULL) {
    strlit3563 = alloc_String("    ");
    gc_root(strlit3563);
  }
// compiled string node returning strlit3563 (depth = 7)
  int op_slot_right_3562 = gc_frame_newslot(strlit3563);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3562 = gc_frame_newslot(*var_spc);
  params[0] = strlit3563;
  partcv[0] = 1;
  Object opresult3565 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3565 (depth = 6)
  *var_spc = opresult3565;
  if (opresult3565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3550 == NULL) {
    strlit3550 = alloc_String("");
    gc_root(strlit3550);
  }
// compiled string node returning strlit3550 (depth = 4)
  *var_spc = strlit3550;
  if (strlit3550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3551 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3554 = alloc_Float64(1);
// compiled num node returning num3554 (depth = 6)
  int op_slot_right_3553 = gc_frame_newslot(num3554);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3553 = gc_frame_newslot(*var_depth);
  params[0] = num3554;
  partcv[0] = 1;
  Object diff3556 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3556 (depth = 5)
  int op_slot_right_3552 = gc_frame_newslot(diff3556);
// starting to compile num node (depth = 5)
  Object num3558 = alloc_Float64(0);
// compiled num node returning num3558 (depth = 5)
  int op_slot_left_3552 = gc_frame_newslot(num3558);
  params[0] = diff3556;
  partcv[0] = 1;
  Object opresult3559 = callmethod(num3558, "..", 1, partcv, params);
// compiled op node returning opresult3559 (depth = 4)
  gc_frame_newslot(opresult3559);
// starting to compile block node (depth = 4)
  Object block3560 = alloc_Block(NULL, NULL, "ast", 788);
  gc_frame_newslot(block3560);
// method "_apply"
  block_savedest(block3560);
  Object closure3561 = createclosure(2, "_apply");
  setclosureframe(closure3561, stackframe);
  addtoclosure(closure3561, var_spc);
  addtoclosure(closure3561, selfslot);
  struct UserObject *uo3561 = (struct UserObject*)block3560;
  uo3561->data[0] = (Object)closure3561;
  Method *meth_meth_ast__apply3561 = addmethod2pos(block3560, "_apply", &meth_ast__apply3561, 0);
  int argcv_meth_ast__apply3561[] = {1};
  meth_meth_ast__apply3561->type = alloc_MethodType(1, argcv_meth_ast__apply3561);
  meth_meth_ast__apply3561->definitionModule = modulename;
  meth_meth_ast__apply3561->definitionLine = 782;
// compiled block node returning block3560 (depth = 4)
  gc_frame_newslot(block3560);
// call case 5: prelude request
  params[0] = opresult3559;
  params[1] = block3560;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3568 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3551);
// compiled call node returning call3568 (depth = 3)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3569 == NULL) {
    strlit3569 = alloc_String("");
    gc_root(strlit3569);
  }
// compiled string node returning strlit3569 (depth = 4)
  *var_s = strlit3569;
  if (strlit3569 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3571 == NULL) {
    strlit3571 = alloc_String("");
    gc_root(strlit3571);
  }
// compiled string node returning strlit3571 (depth = 5)
  int op_slot_right_3570 = gc_frame_newslot(strlit3571);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3575 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3574);
// compiled call node returning call3575 (depth = 7)
// compiled member node returning call3575 (depth = 6)
  int op_slot_right_3573 = gc_frame_newslot(call3575);
// starting to compile string node (depth = 6)
  if (strlit3577 == NULL) {
    strlit3577 = alloc_String("type ");
    gc_root(strlit3577);
  }
// compiled string node returning strlit3577 (depth = 6)
  int op_slot_left_3573 = gc_frame_newslot(strlit3577);
  params[0] = call3575;
  partcv[0] = 1;
  Object opresult3578 = callmethod(strlit3577, "++", 1, partcv, params);
// compiled op node returning opresult3578 (depth = 5)
  int op_slot_left_3570 = gc_frame_newslot(opresult3578);
  params[0] = strlit3571;
  partcv[0] = 1;
  Object opresult3579 = callmethod(opresult3578, "++", 1, partcv, params);
// compiled op node returning opresult3579 (depth = 4)
  *var_s = opresult3579;
  if (opresult3579 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3584 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3583);
// compiled call node returning call3584 (depth = 6)
// compiled member node returning call3584 (depth = 5)
  int op_slot_right_3582 = gc_frame_newslot(call3584);
// starting to compile identifier node (depth = 5)
  Object bool3586 = alloc_Boolean(0);
// compiled identifier node returning bool3586 (depth = 5)
  int op_slot_left_3582 = gc_frame_newslot(bool3586);
  params[0] = call3584;
  partcv[0] = 1;
  Object opresult3587 = callmethod(bool3586, "≠", 1, partcv, params);
// compiled op node returning opresult3587 (depth = 4)
  Object if3581 = done;
  if (istrue(opresult3587)) {
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3588 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num3589 = alloc_Float64(0);
// compiled num node returning num3589 (depth = 5)
  gc_frame_newslot(num3589);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3590 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3591 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3590);
// compiled call node returning call3591 (depth = 6)
// compiled member node returning call3591 (depth = 5)
  params[0] = num3589;
  partcv[0] = 1;
  Object call3592 = callmethod(call3591, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3588);
// compiled call node returning call3592 (depth = 4)
    gc_frame_newslot(call3592);
    if3581 = call3592;
  } else {
  }
// compiled if node returning if3581 (depth = 3)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3594 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3596 = alloc_Float64(2);
// compiled num node returning num3596 (depth = 6)
  int op_slot_right_3595 = gc_frame_newslot(num3596);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_3595 = gc_frame_newslot(*var_depth);
  params[0] = num3596;
  partcv[0] = 1;
  Object sum3598 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3598 (depth = 5)
  gc_frame_newslot(sum3598);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3600 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3599);
// compiled call node returning call3600 (depth = 6)
// compiled member node returning call3600 (depth = 5)
  params[0] = sum3598;
  partcv[0] = 1;
  Object call3601 = callmethod(call3600, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3594);
// compiled call node returning call3601 (depth = 4)
  int op_slot_right_3593 = gc_frame_newslot(call3601);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3604 == NULL) {
    strlit3604 = alloc_String(" = ");
    gc_root(strlit3604);
  }
// compiled string node returning strlit3604 (depth = 5)
  int op_slot_right_3603 = gc_frame_newslot(strlit3604);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3603 = gc_frame_newslot(*var_s);
  params[0] = strlit3604;
  partcv[0] = 1;
  Object opresult3606 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3606 (depth = 4)
  int op_slot_left_3593 = gc_frame_newslot(opresult3606);
  params[0] = call3601;
  partcv[0] = 1;
  Object opresult3607 = callmethod(opresult3606, "++", 1, partcv, params);
// compiled op node returning opresult3607 (depth = 3)
  gc_frame_end(frame);
  return opresult3607;
}
Object meth_ast_shallowCopy3608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3609 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3610 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3612 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3611);
// compiled call node returning call3612 (depth = 6)
// compiled member node returning call3612 (depth = 5)
  gc_frame_newslot(call3612);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeDecNode (depth = 5)
  params[0] = call3612;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3613 = callmethod(*var_typeDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3610);
// compiled call node returning call3613 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3614 = callmethod(call3613, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe3609);
// compiled call node returning call3614 (depth = 3)
  gc_frame_end(frame);
  return call3614;
}
Object meth_ast_new3302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3303 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3303 = alloc_userobj2(24,21, objclass3303);
  gc_frame_newslot(obj3303);
if (objclass3303 == NULL) {
  glfree(obj3303->class->name);
  obj3303->class->name = "typeDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3303, self, 0);
  addmethodreal(obj3303,"outer", &reader_ast_outer_3304);
  Object oldself3303 = self;
  struct StackFrameObject *oldstackframe3303 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3303);
  gc_frame_newslot((Object)stackframe);
  self = obj3303;
  Object *oldselfslot3303 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3303 = (*(struct UserObject *)self).data[0], lowerouter3303 = thisouter3303;
  if (inheritingObject3303) {
    struct UserObject *inho3303 = (struct UserObject *)inheritingObject3303;
    while (inho3303->super != GraceDefaultObject) inho3303 = (struct UserObject *)inho3303->super;
    inho3303->super = obj3303;
    self = inheritingObject3303;
    *selfslot = self;
    lowerouter3303 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3303;
  }
if (objclass3303 == NULL) {
  Method *reader3305 = addmethodrealflags(obj3303, "kind",&reader_ast_kind_3305, MFLAG_DEF);
  reader3305->definitionModule = modulename;
  reader3305->definitionLine = 722;
}
adddatum2(obj3303, alloc_Undefined(), 1);
if (objclass3303 == NULL) {
  Method *reader3306 = addmethodrealflags(obj3303, "name",&reader_ast_name_3306, 0);
  Method *writer3306 = addmethodrealflags(obj3303, "name:=",&writer_ast_name_3306, 0);
  reader3306->definitionModule = modulename;
  writer3306->definitionModule = modulename;
  reader3306->definitionLine = 723;
  writer3306->definitionLine = 723;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 2);
if (objclass3303 == NULL) {
  Method *reader3307 = addmethodrealflags(obj3303, "value",&reader_ast_value_3307, 0);
  Method *writer3307 = addmethodrealflags(obj3303, "value:=",&writer_ast_value_3307, 0);
  reader3307->definitionModule = modulename;
  writer3307->definitionModule = modulename;
  reader3307->definitionLine = 724;
  writer3307->definitionLine = 724;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 3);
if (objclass3303 == NULL) {
  Method *reader3308 = addmethodrealflags(obj3303, "nameString",&reader_ast_nameString_3308, MFLAG_DEF);
  reader3308->definitionModule = modulename;
  reader3308->definitionLine = 725;
}
adddatum2(obj3303, alloc_Undefined(), 4);
if (objclass3303 == NULL) {
  Method *reader3309 = addmethodrealflags(obj3303, "annotations",&reader_ast_annotations_3309, 0);
  Method *writer3309 = addmethodrealflags(obj3303, "annotations:=",&writer_ast_annotations_3309, 0);
  reader3309->definitionModule = modulename;
  writer3309->definitionModule = modulename;
  reader3309->definitionLine = 726;
  writer3309->definitionLine = 726;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 5);
if (objclass3303 == NULL) {
  Method *reader3310 = addmethodrealflags(obj3303, "typeParams",&reader_ast_typeParams_3310, 0);
  Method *writer3310 = addmethodrealflags(obj3303, "typeParams:=",&writer_ast_typeParams_3310, 0);
  reader3310->definitionModule = modulename;
  writer3310->definitionModule = modulename;
  reader3310->definitionLine = 727;
  writer3310->definitionLine = 727;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3311 = (struct UserObject*)obj3303;
  uo3311->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3311 = addmethod2pos(obj3303, "isLegalInTrait", &meth_ast_isLegalInTrait3311, 7);
  int argcv_meth_ast_isLegalInTrait3311[] = {0};
  meth_meth_ast_isLegalInTrait3311->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3311);
  meth_meth_ast_isLegalInTrait3311->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3311->definitionLine = 729;
// method "isTypeDec"
  struct UserObject *uo3313 = (struct UserObject*)obj3303;
  uo3313->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3313 = addmethod2pos(obj3303, "isTypeDec", &meth_ast_isTypeDec3313, 8);
  int argcv_meth_ast_isTypeDec3313[] = {0};
  meth_meth_ast_isTypeDec3313->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3313);
  meth_meth_ast_isTypeDec3313->definitionModule = modulename;
  meth_meth_ast_isTypeDec3313->definitionLine = 730;
// method "scope:="
  struct UserObject *uo3315 = (struct UserObject*)obj3303;
  uo3315->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3315 = addmethod2pos(obj3303, "scope:=", &meth_ast_scope_58__61_3315, 9);
  int argcv_meth_ast_scope_58__61_3315[] = {1};
  meth_meth_ast_scope_58__61_3315->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3315);
  meth_meth_ast_scope_58__61_3315->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3315->definitionLine = 731;
// method "isExecutable"
  struct UserObject *uo3320 = (struct UserObject*)obj3303;
  uo3320->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3320 = addmethod2pos(obj3303, "isExecutable", &meth_ast_isExecutable3320, 10);
  int argcv_meth_ast_isExecutable3320[] = {0};
  meth_meth_ast_isExecutable3320->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3320);
  meth_meth_ast_isExecutable3320->definitionModule = modulename;
  meth_meth_ast_isExecutable3320->definitionLine = 738;
// method "declarationKindWithAncestors"
  block_savedest(obj3303);
  Object closure3322 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3322, stackframe);
  addtoclosure(closure3322, var_k);
  struct UserObject *uo3322 = (struct UserObject*)obj3303;
  uo3322->data[11] = (Object)closure3322;
  Method *meth_meth_ast_declarationKindWithAncestors3322 = addmethod2pos(obj3303, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3322, 11);
  int argcv_meth_ast_declarationKindWithAncestors3322[] = {1};
  meth_meth_ast_declarationKindWithAncestors3322->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3322);
  meth_meth_ast_declarationKindWithAncestors3322->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3322->definitionLine = 739;
// method "isConfidential"
  struct UserObject *uo3325 = (struct UserObject*)obj3303;
  uo3325->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3325 = addmethod2pos(obj3303, "isConfidential", &meth_ast_isConfidential3325, 12);
  int argcv_meth_ast_isConfidential3325[] = {0};
  meth_meth_ast_isConfidential3325->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3325);
  meth_meth_ast_isConfidential3325->definitionModule = modulename;
  meth_meth_ast_isConfidential3325->definitionLine = 740;
// method "isPublic"
  struct UserObject *uo3343 = (struct UserObject*)obj3303;
  uo3343->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3343 = addmethod2pos(obj3303, "isPublic", &meth_ast_isPublic3343, 13);
  int argcv_meth_ast_isPublic3343[] = {0};
  meth_meth_ast_isPublic3343->type = alloc_MethodType(1, argcv_meth_ast_isPublic3343);
  meth_meth_ast_isPublic3343->definitionModule = modulename;
  meth_meth_ast_isPublic3343->definitionLine = 744;
// method "isWritable"
  struct UserObject *uo3348 = (struct UserObject*)obj3303;
  uo3348->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3348 = addmethod2pos(obj3303, "isWritable", &meth_ast_isWritable3348, 14);
  int argcv_meth_ast_isWritable3348[] = {0};
  meth_meth_ast_isWritable3348->type = alloc_MethodType(1, argcv_meth_ast_isWritable3348);
  meth_meth_ast_isWritable3348->definitionModule = modulename;
  meth_meth_ast_isWritable3348->definitionLine = 745;
// method "isReadable"
  struct UserObject *uo3350 = (struct UserObject*)obj3303;
  uo3350->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3350 = addmethod2pos(obj3303, "isReadable", &meth_ast_isReadable3350, 15);
  int argcv_meth_ast_isReadable3350[] = {0};
  meth_meth_ast_isReadable3350->type = alloc_MethodType(1, argcv_meth_ast_isReadable3350);
  meth_meth_ast_isReadable3350->definitionModule = modulename;
  meth_meth_ast_isReadable3350->definitionLine = 746;
// method "accept()from"
  struct UserObject *uo3353 = (struct UserObject*)obj3303;
  uo3353->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3353 = addmethod2pos(obj3303, "accept()from", &meth_ast_accept_40__41_from3353, 16);
  int argcv_meth_ast_accept_40__41_from3353[] = {1, 1};
  meth_meth_ast_accept_40__41_from3353->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3353);
  meth_meth_ast_accept_40__41_from3353->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3353->definitionLine = 748;
// method "map()ancestors"
  struct UserObject *uo3387 = (struct UserObject*)obj3303;
  uo3387->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3387 = addmethod2pos(obj3303, "map()ancestors", &meth_ast_map_40__41_ancestors3387, 17);
  int argcv_meth_ast_map_40__41_ancestors3387[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3387->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3387);
  meth_meth_ast_map_40__41_ancestors3387->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3387->definitionLine = 759;
// method "pretty"
  struct UserObject *uo3426 = (struct UserObject*)obj3303;
  uo3426->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty3426 = addmethod2pos(obj3303, "pretty", &meth_ast_pretty3426, 18);
  int argcv_meth_ast_pretty3426[] = {1};
  meth_meth_ast_pretty3426->type = alloc_MethodType(1, argcv_meth_ast_pretty3426);
  meth_meth_ast_pretty3426->definitionModule = modulename;
  meth_meth_ast_pretty3426->definitionLine = 768;
// method "toGrace"
  struct UserObject *uo3549 = (struct UserObject*)obj3303;
  uo3549->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace3549 = addmethod2pos(obj3303, "toGrace", &meth_ast_toGrace3549, 19);
  int argcv_meth_ast_toGrace3549[] = {1};
  meth_meth_ast_toGrace3549->type = alloc_MethodType(1, argcv_meth_ast_toGrace3549);
meth_meth_ast_toGrace3549->type->types[0] = type_Number;
meth_meth_ast_toGrace3549->type->names[0] = "depth";
  meth_meth_ast_toGrace3549->definitionModule = modulename;
  meth_meth_ast_toGrace3549->definitionLine = 786;
// method "shallowCopy"
  block_savedest(obj3303);
  Object closure3608 = createclosure(2, "shallowCopy");
  setclosureframe(closure3608, stackframe);
  addtoclosure(closure3608, var_nullNode);
  addtoclosure(closure3608, var_typeDecNode);
  struct UserObject *uo3608 = (struct UserObject*)obj3303;
  uo3608->data[20] = (Object)closure3608;
  Method *meth_meth_ast_shallowCopy3608 = addmethod2pos(obj3303, "shallowCopy", &meth_ast_shallowCopy3608, 20);
  int argcv_meth_ast_shallowCopy3608[] = {0};
  meth_meth_ast_shallowCopy3608->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3608);
  meth_meth_ast_shallowCopy3608->definitionModule = modulename;
  meth_meth_ast_shallowCopy3608->definitionLine = 798;
  sourceObject = obj3303;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3615 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3616 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3617 = gc_frame_new();
// call case 3: self.outer request
  Object call3618 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3617);
// compiled call node returning call3618 (depth = 7)
// compiled member node returning call3618 (depth = 6)
  partcv[0] = 0;
  Object call3619 = callmethodflags(call3618, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3616);
// compiled call node returning call3619 (depth = 5)
// compiled member node returning call3619 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3620 = callmethodflags(call3619, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3615);
// compiled call node returning call3620 (depth = 3)
  struct UserObject *obj3303_uo = (struct UserObject *)obj3303;
  obj3303_uo->super = call3620;
  sourceObject = obj3303;
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("typedec");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 3)
  adddatum2(obj3303, strlit3621, 1);
  sourceObject = obj3303;
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3303, *var_name_39_, 2);
  sourceObject = obj3303;
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3303, *var_typeValue, 3);
  sourceObject = obj3303;
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3622 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3624 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3623);
// compiled call node returning call3624 (depth = 6)
// compiled member node returning call3624 (depth = 5)
  partcv[0] = 0;
  Object call3625 = callmethod(call3624, "value",
    1, partcv, params);
  gc_frame_end(callframe3622);
// compiled call node returning call3625 (depth = 4)
// compiled member node returning call3625 (depth = 3)
  adddatum2(obj3303, call3625, 4);
  sourceObject = obj3303;
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3626 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3626 (depth = 3)
  adddatum2(obj3303, array3626, 5);
  sourceObject = obj3303;
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3627 = alloc_Boolean(0);
// compiled identifier node returning bool3627 (depth = 3)
  adddatum2(obj3303, bool3627, 6);
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  objclass3303 = obj3303->class;
  objclass3303->definitionModule = modulename;
  objclass3303->definitionLine = 720;
  (*(struct UserObject *)self).data[0] = lowerouter3303;
  self = oldself3303;
  selfslot = oldselfslot3303;
  stackframe = oldstackframe3303;
  gc_frame_end(frame);
  return obj3303;
}
Object meth_ast_new3302_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_typeDecNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3303 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3303 = alloc_userobj2(24,21, objclass3303);
  gc_frame_newslot(obj3303);
if (objclass3303 == NULL) {
  glfree(obj3303->class->name);
  obj3303->class->name = "typeDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3303, self, 0);
  addmethodreal(obj3303,"outer", &reader_ast_outer_3304);
  Object oldself3303 = self;
  struct StackFrameObject *oldstackframe3303 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3303);
  gc_frame_newslot((Object)stackframe);
  self = obj3303;
  Object *oldselfslot3303 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3303 = (*(struct UserObject *)self).data[0], lowerouter3303 = thisouter3303;
  if (inheritingObject3303) {
    struct UserObject *inho3303 = (struct UserObject *)inheritingObject3303;
    while (inho3303->super != GraceDefaultObject) inho3303 = (struct UserObject *)inho3303->super;
    inho3303->super = obj3303;
    self = inheritingObject3303;
    *selfslot = self;
    lowerouter3303 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3303;
  }
if (objclass3303 == NULL) {
  Method *reader3305 = addmethodrealflags(obj3303, "kind",&reader_ast_kind_3305, MFLAG_DEF);
  reader3305->definitionModule = modulename;
  reader3305->definitionLine = 722;
}
adddatum2(obj3303, alloc_Undefined(), 1);
if (objclass3303 == NULL) {
  Method *reader3306 = addmethodrealflags(obj3303, "name",&reader_ast_name_3306, 0);
  Method *writer3306 = addmethodrealflags(obj3303, "name:=",&writer_ast_name_3306, 0);
  reader3306->definitionModule = modulename;
  writer3306->definitionModule = modulename;
  reader3306->definitionLine = 723;
  writer3306->definitionLine = 723;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 2);
if (objclass3303 == NULL) {
  Method *reader3307 = addmethodrealflags(obj3303, "value",&reader_ast_value_3307, 0);
  Method *writer3307 = addmethodrealflags(obj3303, "value:=",&writer_ast_value_3307, 0);
  reader3307->definitionModule = modulename;
  writer3307->definitionModule = modulename;
  reader3307->definitionLine = 724;
  writer3307->definitionLine = 724;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 3);
if (objclass3303 == NULL) {
  Method *reader3308 = addmethodrealflags(obj3303, "nameString",&reader_ast_nameString_3308, MFLAG_DEF);
  reader3308->definitionModule = modulename;
  reader3308->definitionLine = 725;
}
adddatum2(obj3303, alloc_Undefined(), 4);
if (objclass3303 == NULL) {
  Method *reader3309 = addmethodrealflags(obj3303, "annotations",&reader_ast_annotations_3309, 0);
  Method *writer3309 = addmethodrealflags(obj3303, "annotations:=",&writer_ast_annotations_3309, 0);
  reader3309->definitionModule = modulename;
  writer3309->definitionModule = modulename;
  reader3309->definitionLine = 726;
  writer3309->definitionLine = 726;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 5);
if (objclass3303 == NULL) {
  Method *reader3310 = addmethodrealflags(obj3303, "typeParams",&reader_ast_typeParams_3310, 0);
  Method *writer3310 = addmethodrealflags(obj3303, "typeParams:=",&writer_ast_typeParams_3310, 0);
  reader3310->definitionModule = modulename;
  writer3310->definitionModule = modulename;
  reader3310->definitionLine = 727;
  writer3310->definitionLine = 727;
}
obj3303->flags |= OFLAG_MUTABLE;
adddatum2(obj3303, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo3311 = (struct UserObject*)obj3303;
  uo3311->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3311 = addmethod2pos(obj3303, "isLegalInTrait", &meth_ast_isLegalInTrait3311, 7);
  int argcv_meth_ast_isLegalInTrait3311[] = {0};
  meth_meth_ast_isLegalInTrait3311->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3311);
  meth_meth_ast_isLegalInTrait3311->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3311->definitionLine = 729;
// method "isTypeDec"
  struct UserObject *uo3313 = (struct UserObject*)obj3303;
  uo3313->data[8] = emptyclosure;
  Method *meth_meth_ast_isTypeDec3313 = addmethod2pos(obj3303, "isTypeDec", &meth_ast_isTypeDec3313, 8);
  int argcv_meth_ast_isTypeDec3313[] = {0};
  meth_meth_ast_isTypeDec3313->type = alloc_MethodType(1, argcv_meth_ast_isTypeDec3313);
  meth_meth_ast_isTypeDec3313->definitionModule = modulename;
  meth_meth_ast_isTypeDec3313->definitionLine = 730;
// method "scope:="
  struct UserObject *uo3315 = (struct UserObject*)obj3303;
  uo3315->data[9] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3315 = addmethod2pos(obj3303, "scope:=", &meth_ast_scope_58__61_3315, 9);
  int argcv_meth_ast_scope_58__61_3315[] = {1};
  meth_meth_ast_scope_58__61_3315->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3315);
  meth_meth_ast_scope_58__61_3315->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3315->definitionLine = 731;
// method "isExecutable"
  struct UserObject *uo3320 = (struct UserObject*)obj3303;
  uo3320->data[10] = emptyclosure;
  Method *meth_meth_ast_isExecutable3320 = addmethod2pos(obj3303, "isExecutable", &meth_ast_isExecutable3320, 10);
  int argcv_meth_ast_isExecutable3320[] = {0};
  meth_meth_ast_isExecutable3320->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3320);
  meth_meth_ast_isExecutable3320->definitionModule = modulename;
  meth_meth_ast_isExecutable3320->definitionLine = 738;
// method "declarationKindWithAncestors"
  block_savedest(obj3303);
  Object closure3322 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3322, stackframe);
  addtoclosure(closure3322, var_k);
  struct UserObject *uo3322 = (struct UserObject*)obj3303;
  uo3322->data[11] = (Object)closure3322;
  Method *meth_meth_ast_declarationKindWithAncestors3322 = addmethod2pos(obj3303, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3322, 11);
  int argcv_meth_ast_declarationKindWithAncestors3322[] = {1};
  meth_meth_ast_declarationKindWithAncestors3322->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3322);
  meth_meth_ast_declarationKindWithAncestors3322->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3322->definitionLine = 739;
// method "isConfidential"
  struct UserObject *uo3325 = (struct UserObject*)obj3303;
  uo3325->data[12] = emptyclosure;
  Method *meth_meth_ast_isConfidential3325 = addmethod2pos(obj3303, "isConfidential", &meth_ast_isConfidential3325, 12);
  int argcv_meth_ast_isConfidential3325[] = {0};
  meth_meth_ast_isConfidential3325->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3325);
  meth_meth_ast_isConfidential3325->definitionModule = modulename;
  meth_meth_ast_isConfidential3325->definitionLine = 740;
// method "isPublic"
  struct UserObject *uo3343 = (struct UserObject*)obj3303;
  uo3343->data[13] = emptyclosure;
  Method *meth_meth_ast_isPublic3343 = addmethod2pos(obj3303, "isPublic", &meth_ast_isPublic3343, 13);
  int argcv_meth_ast_isPublic3343[] = {0};
  meth_meth_ast_isPublic3343->type = alloc_MethodType(1, argcv_meth_ast_isPublic3343);
  meth_meth_ast_isPublic3343->definitionModule = modulename;
  meth_meth_ast_isPublic3343->definitionLine = 744;
// method "isWritable"
  struct UserObject *uo3348 = (struct UserObject*)obj3303;
  uo3348->data[14] = emptyclosure;
  Method *meth_meth_ast_isWritable3348 = addmethod2pos(obj3303, "isWritable", &meth_ast_isWritable3348, 14);
  int argcv_meth_ast_isWritable3348[] = {0};
  meth_meth_ast_isWritable3348->type = alloc_MethodType(1, argcv_meth_ast_isWritable3348);
  meth_meth_ast_isWritable3348->definitionModule = modulename;
  meth_meth_ast_isWritable3348->definitionLine = 745;
// method "isReadable"
  struct UserObject *uo3350 = (struct UserObject*)obj3303;
  uo3350->data[15] = emptyclosure;
  Method *meth_meth_ast_isReadable3350 = addmethod2pos(obj3303, "isReadable", &meth_ast_isReadable3350, 15);
  int argcv_meth_ast_isReadable3350[] = {0};
  meth_meth_ast_isReadable3350->type = alloc_MethodType(1, argcv_meth_ast_isReadable3350);
  meth_meth_ast_isReadable3350->definitionModule = modulename;
  meth_meth_ast_isReadable3350->definitionLine = 746;
// method "accept()from"
  struct UserObject *uo3353 = (struct UserObject*)obj3303;
  uo3353->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3353 = addmethod2pos(obj3303, "accept()from", &meth_ast_accept_40__41_from3353, 16);
  int argcv_meth_ast_accept_40__41_from3353[] = {1, 1};
  meth_meth_ast_accept_40__41_from3353->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3353);
  meth_meth_ast_accept_40__41_from3353->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3353->definitionLine = 748;
// method "map()ancestors"
  struct UserObject *uo3387 = (struct UserObject*)obj3303;
  uo3387->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3387 = addmethod2pos(obj3303, "map()ancestors", &meth_ast_map_40__41_ancestors3387, 17);
  int argcv_meth_ast_map_40__41_ancestors3387[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3387->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3387);
  meth_meth_ast_map_40__41_ancestors3387->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3387->definitionLine = 759;
// method "pretty"
  struct UserObject *uo3426 = (struct UserObject*)obj3303;
  uo3426->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty3426 = addmethod2pos(obj3303, "pretty", &meth_ast_pretty3426, 18);
  int argcv_meth_ast_pretty3426[] = {1};
  meth_meth_ast_pretty3426->type = alloc_MethodType(1, argcv_meth_ast_pretty3426);
  meth_meth_ast_pretty3426->definitionModule = modulename;
  meth_meth_ast_pretty3426->definitionLine = 768;
// method "toGrace"
  struct UserObject *uo3549 = (struct UserObject*)obj3303;
  uo3549->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace3549 = addmethod2pos(obj3303, "toGrace", &meth_ast_toGrace3549, 19);
  int argcv_meth_ast_toGrace3549[] = {1};
  meth_meth_ast_toGrace3549->type = alloc_MethodType(1, argcv_meth_ast_toGrace3549);
meth_meth_ast_toGrace3549->type->types[0] = type_Number;
meth_meth_ast_toGrace3549->type->names[0] = "depth";
  meth_meth_ast_toGrace3549->definitionModule = modulename;
  meth_meth_ast_toGrace3549->definitionLine = 786;
// method "shallowCopy"
  block_savedest(obj3303);
  Object closure3608 = createclosure(2, "shallowCopy");
  setclosureframe(closure3608, stackframe);
  addtoclosure(closure3608, var_nullNode);
  addtoclosure(closure3608, var_typeDecNode);
  struct UserObject *uo3608 = (struct UserObject*)obj3303;
  uo3608->data[20] = (Object)closure3608;
  Method *meth_meth_ast_shallowCopy3608 = addmethod2pos(obj3303, "shallowCopy", &meth_ast_shallowCopy3608, 20);
  int argcv_meth_ast_shallowCopy3608[] = {0};
  meth_meth_ast_shallowCopy3608->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy3608);
  meth_meth_ast_shallowCopy3608->definitionModule = modulename;
  meth_meth_ast_shallowCopy3608->definitionLine = 798;
  sourceObject = obj3303;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3615 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3616 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3617 = gc_frame_new();
// call case 3: self.outer request
  Object call3618 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3617);
// compiled call node returning call3618 (depth = 7)
// compiled member node returning call3618 (depth = 6)
  partcv[0] = 0;
  Object call3619 = callmethodflags(call3618, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3616);
// compiled call node returning call3619 (depth = 5)
// compiled member node returning call3619 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3620 = callmethodflags(call3619, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3615);
// compiled call node returning call3620 (depth = 3)
  struct UserObject *obj3303_uo = (struct UserObject *)obj3303;
  obj3303_uo->super = call3620;
  sourceObject = obj3303;
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("typedec");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 3)
  adddatum2(obj3303, strlit3621, 1);
  sourceObject = obj3303;
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3303, *var_name_39_, 2);
  sourceObject = obj3303;
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeValue (depth = 3)
  adddatum2(obj3303, *var_typeValue, 3);
  sourceObject = obj3303;
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3622 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3624 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3623);
// compiled call node returning call3624 (depth = 6)
// compiled member node returning call3624 (depth = 5)
  partcv[0] = 0;
  Object call3625 = callmethod(call3624, "value",
    1, partcv, params);
  gc_frame_end(callframe3622);
// compiled call node returning call3625 (depth = 4)
// compiled member node returning call3625 (depth = 3)
  adddatum2(obj3303, call3625, 4);
  sourceObject = obj3303;
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3626 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3626 (depth = 3)
  adddatum2(obj3303, array3626, 5);
  sourceObject = obj3303;
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3627 = alloc_Boolean(0);
// compiled identifier node returning bool3627 (depth = 3)
  adddatum2(obj3303, bool3627, 6);
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  sourceObject = obj3303;
  objclass3303 = obj3303->class;
  objclass3303->definitionModule = modulename;
  objclass3303->definitionLine = 720;
  (*(struct UserObject *)self).data[0] = lowerouter3303;
  self = oldself3303;
  selfslot = oldselfslot3303;
  stackframe = oldstackframe3303;
  gc_frame_end(frame);
  return obj3303;
}
Object meth_ast_typeDecNode3629(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_new_40__41_scope3632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[4];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_body = &(stackframe->slots[2]);
  *var_body = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[3]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3633 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call3634 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3633);
// compiled call node returning call3634 (depth = 4)
  *var_result = call3634;
  if (call3634 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3635 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call3636 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe3635);
// compiled call node returning call3636 (depth = 3)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isMethod3651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3652 = alloc_Boolean(1);
// compiled identifier node returning bool3652 (depth = 3)
  gc_frame_end(frame);
  return bool3652;
}
Object meth_ast_isExecutable3653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3654 = alloc_Boolean(0);
// compiled identifier node returning bool3654 (depth = 3)
  gc_frame_end(frame);
  return bool3654;
}
Object meth_ast_isLegalInTrait3655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3656 = alloc_Boolean(1);
// compiled identifier node returning bool3656 (depth = 3)
  gc_frame_end(frame);
  return bool3656;
}
Object meth_ast_isClass3657(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3659 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3660 = callmethodflags(self, "usesClassSyntax", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3659);
// compiled call node returning call3660 (depth = 5)
// compiled member node returning call3660 (depth = 4)
  int op_slot_right_3658 = gc_frame_newslot(call3660);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3662 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3663 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3662);
// compiled call node returning call3663 (depth = 5)
// compiled member node returning call3663 (depth = 4)
  int op_slot_left_3658 = gc_frame_newslot(call3663);
  params[0] = call3660;
  partcv[0] = 1;
  Object opresult3664 = callmethod(call3663, "||", 1, partcv, params);
// compiled op node returning opresult3664 (depth = 3)
  gc_frame_end(frame);
  return opresult3664;
}
Object meth_ast_isTrait3665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3667 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3668 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3667);
// compiled call node returning call3668 (depth = 5)
// compiled member node returning call3668 (depth = 4)
  Object if3666 = done;
  if (istrue(call3668)) {
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3669 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3670 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3672 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3671);
// compiled call node returning call3672 (depth = 9)
// compiled member node returning call3672 (depth = 8)
  partcv[0] = 0;
  Object call3673 = callmethod(call3672, "last",
    1, partcv, params);
  gc_frame_end(callframe3670);
// compiled call node returning call3673 (depth = 7)
// compiled member node returning call3673 (depth = 6)
  partcv[0] = 0;
  Object call3674 = callmethod(call3673, "isTrait",
    1, partcv, params);
  gc_frame_end(callframe3669);
// compiled call node returning call3674 (depth = 5)
// compiled member node returning call3674 (depth = 4)
    gc_frame_newslot(call3674);
    if3666 = call3674;
  } else {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3675 = alloc_Boolean(0);
// compiled identifier node returning bool3675 (depth = 4)
    gc_frame_newslot(bool3675);
    if3666 = bool3675;
  }
// compiled if node returning if3666 (depth = 3)
  gc_frame_end(frame);
  return if3666;
}
Object meth_ast__apply3686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_p = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3688 == NULL) {
    strlit3688 = alloc_String("Unknown");
    gc_root(strlit3688);
  }
// compiled string node returning strlit3688 (depth = 11)
  int op_slot_right_3687 = gc_frame_newslot(strlit3688);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3690 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_p (depth = 15)
  partcv[0] = 0;
  Object call3692 = callmethod(*var_p, "dtype",
    1, partcv, params);
  gc_frame_end(callframe3691);
// compiled call node returning call3692 (depth = 14)
// compiled member node returning call3692 (depth = 13)
  partcv[0] = 0;
  Object call3693 = callmethod(call3692, "nameString",
    1, partcv, params);
  gc_frame_end(callframe3690);
// compiled call node returning call3693 (depth = 12)
// compiled member node returning call3693 (depth = 11)
  int op_slot_left_3687 = gc_frame_newslot(call3693);
  params[0] = strlit3688;
  partcv[0] = 1;
  Object opresult3694 = callmethod(call3693, "≠", 1, partcv, params);
// compiled op node returning opresult3694 (depth = 10)
  gc_frame_end(frame);
  return opresult3694;
}
Object meth_ast__apply3682(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block3685 = alloc_Block(NULL, NULL, "ast", 845);
  gc_frame_newslot(block3685);
// method "_apply"
  block_savedest(block3685);
  Object closure3686 = createclosure(2, "_apply");
  setclosureframe(closure3686, stackframe);
  addtoclosure(closure3686, var_p);
  addtoclosure(closure3686, selfslot);
  struct UserObject *uo3686 = (struct UserObject*)block3685;
  uo3686->data[0] = (Object)closure3686;
  Method *meth_meth_ast__apply3686 = addmethod2pos(block3685, "_apply", &meth_ast__apply3686, 0);
  int argcv_meth_ast__apply3686[] = {0};
  meth_meth_ast__apply3686->type = alloc_MethodType(1, argcv_meth_ast__apply3686);
  meth_meth_ast__apply3686->definitionModule = modulename;
  meth_meth_ast__apply3686->definitionLine = 837;
// compiled block node returning block3685 (depth = 9)
  int op_slot_right_3684 = gc_frame_newslot(block3685);
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  partcv[0] = 0;
  Object call3699 = callmethod(*var_p, "dtype",
    1, partcv, params);
  gc_frame_end(callframe3698);
// compiled call node returning call3699 (depth = 11)
// compiled member node returning call3699 (depth = 10)
  int op_slot_right_3697 = gc_frame_newslot(call3699);
// starting to compile identifier node (depth = 10)
  Object bool3701 = alloc_Boolean(0);
// compiled identifier node returning bool3701 (depth = 10)
  int op_slot_left_3697 = gc_frame_newslot(bool3701);
  params[0] = call3699;
  partcv[0] = 1;
  Object opresult3702 = callmethod(bool3701, "≠", 1, partcv, params);
// compiled op node returning opresult3702 (depth = 9)
  int op_slot_left_3684 = gc_frame_newslot(opresult3702);
  params[0] = block3685;
  partcv[0] = 1;
  Object opresult3703 = callmethod(opresult3702, "&&", 1, partcv, params);
// compiled op node returning opresult3703 (depth = 8)
  Object if3683 = done;
  if (istrue(opresult3703)) {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3704 = alloc_Boolean(1);
// compiled identifier node returning bool3704 (depth = 9)
  block_return(realself, bool3704);
// compiled return node returning undefined (depth = 8)
    gc_frame_newslot(undefined);
    if3683 = undefined;
  } else {
  }
// compiled if node returning if3683 (depth = 7)
  gc_frame_end(frame);
  return if3683;
}
Object meth_ast__apply3679(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3680 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3681 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3681);
// method "_apply"
  block_savedest(block3681);
  Object closure3682 = createclosure(1, "_apply");
  setclosureframe(closure3682, stackframe);
  addtoclosure(closure3682, selfslot);
  struct UserObject *uo3682 = (struct UserObject*)block3681;
  uo3682->data[0] = (Object)closure3682;
  Method *meth_meth_ast__apply3682 = addmethod2pos(block3681, "_apply", &meth_ast__apply3682, 0);
  int argcv_meth_ast__apply3682[] = {1};
  meth_meth_ast__apply3682->type = alloc_MethodType(1, argcv_meth_ast__apply3682);
  meth_meth_ast__apply3682->definitionModule = modulename;
  meth_meth_ast__apply3682->definitionLine = 837;
// compiled block node returning block3681 (depth = 6)
  gc_frame_newslot(block3681);
// call case 6: other member request
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call3707 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3706);
// compiled call node returning call3707 (depth = 7)
// compiled member node returning call3707 (depth = 6)
  params[0] = block3681;
  partcv[0] = 1;
  Object call3708 = callmethod(call3707, "do",
    1, partcv, params);
  gc_frame_end(callframe3680);
// compiled call node returning call3708 (depth = 5)
  gc_frame_end(frame);
  return call3708;
}
Object meth_ast_needsArgChecks3676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "needsArgChecks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for needsArgChecks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for needsArgChecks");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3677 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3678 = alloc_Block(NULL, NULL, "ast", 843);
  gc_frame_newslot(block3678);
// method "_apply"
  block_savedest(block3678);
  Object closure3679 = createclosure(1, "_apply");
  setclosureframe(closure3679, stackframe);
  addtoclosure(closure3679, selfslot);
  struct UserObject *uo3679 = (struct UserObject*)block3678;
  uo3679->data[0] = (Object)closure3679;
  Method *meth_meth_ast__apply3679 = addmethod2pos(block3678, "_apply", &meth_ast__apply3679, 0);
  int argcv_meth_ast__apply3679[] = {1};
  meth_meth_ast__apply3679->type = alloc_MethodType(1, argcv_meth_ast__apply3679);
  meth_meth_ast__apply3679->definitionModule = modulename;
  meth_meth_ast__apply3679->definitionLine = 837;
// compiled block node returning block3678 (depth = 4)
  gc_frame_newslot(block3678);
// call case 6: other member request
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3710 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3711 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3710);
// compiled call node returning call3711 (depth = 5)
// compiled member node returning call3711 (depth = 4)
  params[0] = block3678;
  partcv[0] = 1;
  Object call3712 = callmethod(call3711, "do",
    1, partcv, params);
  gc_frame_end(callframe3677);
// compiled call node returning call3712 (depth = 3)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3713 = alloc_Boolean(0);
// compiled identifier node returning bool3713 (depth = 4)
  return bool3713;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_scope_58__61_3714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3715 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call3716 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3715);
// compiled call node returning call3716 (depth = 3)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3717 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call3718 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe3717);
// compiled call node returning call3718 (depth = 3)
  gc_frame_end(frame);
  return call3718;
}
Object meth_ast_declarationKindWithAncestors3719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call3721 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe3720);
// compiled call node returning call3721 (depth = 4)
// compiled member node returning call3721 (depth = 3)
  gc_frame_end(frame);
  return call3721;
}
Object meth_ast_isConfidential3722(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3725 = alloc_Float64(0);
// compiled num node returning num3725 (depth = 5)
  int op_slot_right_3724 = gc_frame_newslot(num3725);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3727 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3729 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3728);
// compiled call node returning call3729 (depth = 8)
// compiled member node returning call3729 (depth = 7)
  partcv[0] = 0;
  Object call3730 = callmethod(call3729, "size",
    1, partcv, params);
  gc_frame_end(callframe3727);
// compiled call node returning call3730 (depth = 6)
// compiled member node returning call3730 (depth = 5)
  int op_slot_left_3724 = gc_frame_newslot(call3730);
  params[0] = num3725;
  partcv[0] = 1;
  Object opresult3731 = callmethod(call3730, "==", 1, partcv, params);
// compiled op node returning opresult3731 (depth = 4)
  Object if3723 = done;
  if (istrue(opresult3731)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool3732 = alloc_Boolean(0);
// compiled identifier node returning bool3732 (depth = 5)
  return bool3732;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if3723 = undefined;
  } else {
  }
// compiled if node returning if3723 (depth = 3)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3733 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit3734 == NULL) {
    strlit3734 = alloc_String("confidential");
    gc_root(strlit3734);
  }
// compiled string node returning strlit3734 (depth = 4)
  gc_frame_newslot(strlit3734);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3735 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3736 = gc_frame_new();
// call case 3: self.outer request
  Object call3737 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3736);
// compiled call node returning call3737 (depth = 7)
// compiled member node returning call3737 (depth = 6)
  partcv[0] = 0;
  Object call3738 = callmethodflags(call3737, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3735);
// compiled call node returning call3738 (depth = 5)
// compiled member node returning call3738 (depth = 4)
  params[0] = self;
  params[1] = strlit3734;
  partcv[0] = 2;
  Object call3739 = callmethodflags(call3738, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3733);
// compiled call node returning call3739 (depth = 3)
  gc_frame_end(frame);
  return call3739;
}
Object meth_ast_isPublic3740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3741 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3743 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3742);
// compiled call node returning call3743 (depth = 6)
// compiled member node returning call3743 (depth = 5)
  partcv[0] = 0;
  Object call3744 = callmethod(call3743, "not",
    1, partcv, params);
  gc_frame_end(callframe3741);
// compiled call node returning call3744 (depth = 4)
// compiled member node returning call3744 (depth = 3)
  gc_frame_end(frame);
  return call3744;
}
Object meth_ast_isWritable3745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3746 = alloc_Boolean(0);
// compiled identifier node returning bool3746 (depth = 3)
  gc_frame_end(frame);
  return bool3746;
}
Object meth_ast_isReadable3747(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3749 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3748);
// compiled call node returning call3749 (depth = 4)
// compiled member node returning call3749 (depth = 3)
  gc_frame_end(frame);
  return call3749;
}
Object meth_ast_usesAsType3750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3753 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3752);
// compiled call node returning call3753 (depth = 5)
// compiled member node returning call3753 (depth = 4)
  int op_slot_right_3751 = gc_frame_newslot(call3753);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_3751 = gc_frame_newslot(*var_aNode);
  params[0] = call3753;
  partcv[0] = 1;
  Object opresult3755 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult3755 (depth = 3)
  gc_frame_end(frame);
  return opresult3755;
}
Object meth_ast__apply3759(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3760 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3761 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3762 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3763 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3762);
// compiled call node returning call3763 (depth = 10)
// compiled member node returning call3763 (depth = 9)
  partcv[0] = 0;
  Object call3764 = callmethod(call3763, "last",
    1, partcv, params);
  gc_frame_end(callframe3761);
// compiled call node returning call3764 (depth = 8)
// compiled member node returning call3764 (depth = 7)
  partcv[0] = 0;
  Object call3765 = callmethod(call3764, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe3760);
// compiled call node returning call3765 (depth = 6)
// compiled member node returning call3765 (depth = 5)
  gc_frame_end(frame);
  return call3765;
}
Object meth_ast_returnsObject3756(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block3758 = alloc_Block(NULL, NULL, "ast", 871);
  gc_frame_newslot(block3758);
// method "_apply"
  block_savedest(block3758);
  Object closure3759 = createclosure(1, "_apply");
  setclosureframe(closure3759, stackframe);
  addtoclosure(closure3759, selfslot);
  struct UserObject *uo3759 = (struct UserObject*)block3758;
  uo3759->data[0] = (Object)closure3759;
  Method *meth_meth_ast__apply3759 = addmethod2pos(block3758, "_apply", &meth_ast__apply3759, 0);
  int argcv_meth_ast__apply3759[] = {0};
  meth_meth_ast__apply3759->type = alloc_MethodType(1, argcv_meth_ast__apply3759);
  meth_meth_ast__apply3759->definitionModule = modulename;
  meth_meth_ast__apply3759->definitionLine = 868;
// compiled block node returning block3758 (depth = 4)
  int op_slot_right_3757 = gc_frame_newslot(block3758);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3768 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3769 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3771 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3770);
// compiled call node returning call3771 (depth = 9)
// compiled member node returning call3771 (depth = 8)
  partcv[0] = 0;
  Object call3772 = callmethod(call3771, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe3769);
// compiled call node returning call3772 (depth = 7)
// compiled member node returning call3772 (depth = 6)
  partcv[0] = 0;
  Object call3773 = callmethod(call3772, "not",
    1, partcv, params);
  gc_frame_end(callframe3768);
// compiled call node returning call3773 (depth = 5)
// compiled member node returning call3773 (depth = 4)
  int op_slot_left_3757 = gc_frame_newslot(call3773);
  params[0] = block3758;
  partcv[0] = 1;
  Object opresult3774 = callmethod(call3773, "&&", 1, partcv, params);
// compiled op node returning opresult3774 (depth = 3)
  gc_frame_end(frame);
  return opresult3774;
}
Object meth_ast_returnedObjectScope3775(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3776 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3777 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3779 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3778);
// compiled call node returning call3779 (depth = 8)
// compiled member node returning call3779 (depth = 7)
  partcv[0] = 0;
  Object call3780 = callmethod(call3779, "last",
    1, partcv, params);
  gc_frame_end(callframe3777);
// compiled call node returning call3780 (depth = 6)
// compiled member node returning call3780 (depth = 5)
  partcv[0] = 0;
  Object call3781 = callmethod(call3780, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe3776);
// compiled call node returning call3781 (depth = 4)
// compiled member node returning call3781 (depth = 3)
  gc_frame_end(frame);
  return call3781;
}
Object meth_ast__apply3812(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3813 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3814 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3813);
// compiled call node returning call3814 (depth = 8)
  gc_frame_end(frame);
  return call3814;
}
Object meth_ast__apply3807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3808 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3810 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3809);
// compiled call node returning call3810 (depth = 8)
// compiled member node returning call3810 (depth = 7)
  gc_frame_newslot(call3810);
// starting to compile block node (depth = 7)
  Object block3811 = alloc_Block(NULL, NULL, "ast", 885);
  gc_frame_newslot(block3811);
// method "_apply"
  block_savedest(block3811);
  Object closure3812 = createclosure(3, "_apply");
  setclosureframe(closure3812, stackframe);
  addtoclosure(closure3812, var_visitor);
  addtoclosure(closure3812, var_newChain);
  addtoclosure(closure3812, selfslot);
  struct UserObject *uo3812 = (struct UserObject*)block3811;
  uo3812->data[0] = (Object)closure3812;
  Method *meth_meth_ast__apply3812 = addmethod2pos(block3811, "_apply", &meth_ast__apply3812, 0);
  int argcv_meth_ast__apply3812[] = {1};
  meth_meth_ast__apply3812->type = alloc_MethodType(1, argcv_meth_ast__apply3812);
  meth_meth_ast__apply3812->definitionModule = modulename;
  meth_meth_ast__apply3812->definitionLine = 885;
// compiled block node returning block3811 (depth = 7)
  gc_frame_newslot(block3811);
// call case 5: prelude request
  params[0] = call3810;
  params[1] = block3811;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3816 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3808);
// compiled call node returning call3816 (depth = 6)
  gc_frame_end(frame);
  return call3816;
}
Object meth_ast__apply3834(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3835 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3836 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3835);
// compiled call node returning call3836 (depth = 6)
  gc_frame_end(frame);
  return call3836;
}
Object meth_ast__apply3843(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3844 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mx (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3845 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3844);
// compiled call node returning call3845 (depth = 6)
  gc_frame_end(frame);
  return call3845;
}
Object meth_ast_accept_40__41_from3782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3784 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3785 = callmethod(*var_visitor, "visitMethod()up",
    2, partcv, params);
  gc_frame_end(callframe3784);
// compiled call node returning call3785 (depth = 4)
  Object if3783 = done;
  if (istrue(call3785)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3786 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call3787 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3786);
// compiled call node returning call3787 (depth = 5)
  *var_newChain = call3787;
  if (call3787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3788 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3790 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3789);
// compiled call node returning call3790 (depth = 6)
// compiled member node returning call3790 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3791 = callmethod(call3790, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3788);
// compiled call node returning call3791 (depth = 4)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3795 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3794);
// compiled call node returning call3795 (depth = 7)
// compiled member node returning call3795 (depth = 6)
  int op_slot_right_3793 = gc_frame_newslot(call3795);
// starting to compile identifier node (depth = 6)
  Object bool3797 = alloc_Boolean(0);
// compiled identifier node returning bool3797 (depth = 6)
  int op_slot_left_3793 = gc_frame_newslot(bool3797);
  params[0] = call3795;
  partcv[0] = 1;
  Object opresult3798 = callmethod(bool3797, "≠", 1, partcv, params);
// compiled op node returning opresult3798 (depth = 5)
  Object if3792 = done;
  if (istrue(opresult3798)) {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3799 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3801 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3800);
// compiled call node returning call3801 (depth = 7)
// compiled member node returning call3801 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3802 = callmethod(call3801, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3799);
// compiled call node returning call3802 (depth = 5)
    gc_frame_newslot(call3802);
    if3792 = call3802;
  } else {
  }
// compiled if node returning if3792 (depth = 4)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3803 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3805 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3804);
// compiled call node returning call3805 (depth = 6)
// compiled member node returning call3805 (depth = 5)
  gc_frame_newslot(call3805);
// starting to compile block node (depth = 5)
  Object block3806 = alloc_Block(NULL, NULL, "ast", 884);
  gc_frame_newslot(block3806);
// method "_apply"
  block_savedest(block3806);
  Object closure3807 = createclosure(3, "_apply");
  setclosureframe(closure3807, stackframe);
  addtoclosure(closure3807, var_visitor);
  addtoclosure(closure3807, var_newChain);
  addtoclosure(closure3807, selfslot);
  struct UserObject *uo3807 = (struct UserObject*)block3806;
  uo3807->data[0] = (Object)closure3807;
  Method *meth_meth_ast__apply3807 = addmethod2pos(block3806, "_apply", &meth_ast__apply3807, 0);
  int argcv_meth_ast__apply3807[] = {1};
  meth_meth_ast__apply3807->type = alloc_MethodType(1, argcv_meth_ast__apply3807);
  meth_meth_ast__apply3807->definitionModule = modulename;
  meth_meth_ast__apply3807->definitionLine = 884;
// compiled block node returning block3806 (depth = 5)
  gc_frame_newslot(block3806);
// call case 5: prelude request
  params[0] = call3805;
  params[1] = block3806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3818 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3803);
// compiled call node returning call3818 (depth = 4)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3822 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3821);
// compiled call node returning call3822 (depth = 7)
// compiled member node returning call3822 (depth = 6)
  int op_slot_right_3820 = gc_frame_newslot(call3822);
// starting to compile identifier node (depth = 6)
  Object bool3824 = alloc_Boolean(0);
// compiled identifier node returning bool3824 (depth = 6)
  int op_slot_left_3820 = gc_frame_newslot(bool3824);
  params[0] = call3822;
  partcv[0] = 1;
  Object opresult3825 = callmethod(bool3824, "≠", 1, partcv, params);
// compiled op node returning opresult3825 (depth = 5)
  Object if3819 = done;
  if (istrue(opresult3825)) {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3826 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3828 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3827);
// compiled call node returning call3828 (depth = 7)
// compiled member node returning call3828 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3829 = callmethod(call3828, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3826);
// compiled call node returning call3829 (depth = 5)
    gc_frame_newslot(call3829);
    if3819 = call3829;
  } else {
  }
// compiled if node returning if3819 (depth = 4)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3830 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3832 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3831);
// compiled call node returning call3832 (depth = 6)
// compiled member node returning call3832 (depth = 5)
  gc_frame_newslot(call3832);
// starting to compile block node (depth = 5)
  Object block3833 = alloc_Block(NULL, NULL, "ast", 892);
  gc_frame_newslot(block3833);
// method "_apply"
  block_savedest(block3833);
  Object closure3834 = createclosure(3, "_apply");
  setclosureframe(closure3834, stackframe);
  addtoclosure(closure3834, var_visitor);
  addtoclosure(closure3834, var_newChain);
  addtoclosure(closure3834, selfslot);
  struct UserObject *uo3834 = (struct UserObject*)block3833;
  uo3834->data[0] = (Object)closure3834;
  Method *meth_meth_ast__apply3834 = addmethod2pos(block3833, "_apply", &meth_ast__apply3834, 0);
  int argcv_meth_ast__apply3834[] = {1};
  meth_meth_ast__apply3834->type = alloc_MethodType(1, argcv_meth_ast__apply3834);
  meth_meth_ast__apply3834->definitionModule = modulename;
  meth_meth_ast__apply3834->definitionLine = 892;
// compiled block node returning block3833 (depth = 5)
  gc_frame_newslot(block3833);
// call case 5: prelude request
  params[0] = call3832;
  params[1] = block3833;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3838 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3830);
// compiled call node returning call3838 (depth = 4)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3839 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3841 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3840);
// compiled call node returning call3841 (depth = 6)
// compiled member node returning call3841 (depth = 5)
  gc_frame_newslot(call3841);
// starting to compile block node (depth = 5)
  Object block3842 = alloc_Block(NULL, NULL, "ast", 895);
  gc_frame_newslot(block3842);
// method "_apply"
  block_savedest(block3842);
  Object closure3843 = createclosure(3, "_apply");
  setclosureframe(closure3843, stackframe);
  addtoclosure(closure3843, var_visitor);
  addtoclosure(closure3843, var_newChain);
  addtoclosure(closure3843, selfslot);
  struct UserObject *uo3843 = (struct UserObject*)block3842;
  uo3843->data[0] = (Object)closure3843;
  Method *meth_meth_ast__apply3843 = addmethod2pos(block3842, "_apply", &meth_ast__apply3843, 0);
  int argcv_meth_ast__apply3843[] = {1};
  meth_meth_ast__apply3843->type = alloc_MethodType(1, argcv_meth_ast__apply3843);
  meth_meth_ast__apply3843->definitionModule = modulename;
  meth_meth_ast__apply3843->definitionLine = 895;
// compiled block node returning block3842 (depth = 5)
  gc_frame_newslot(block3842);
// call case 5: prelude request
  params[0] = call3841;
  params[1] = block3842;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3847 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3839);
// compiled call node returning call3847 (depth = 4)
    gc_frame_newslot(call3847);
    if3783 = call3847;
  } else {
  }
// compiled if node returning if3783 (depth = 3)
  gc_frame_end(frame);
  return if3783;
}
Object meth_ast_map_40__41_ancestors3848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3849 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3850 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3849);
// compiled call node returning call3850 (depth = 5)
// compiled member node returning call3850 (depth = 4)
  *var_n = call3850;
  if (call3850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3851 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3852 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe3851);
// compiled call node returning call3852 (depth = 4)
  *var_newChain = call3852;
  if (call3852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3853 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3854 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3855 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3856 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3855);
// compiled call node returning call3856 (depth = 6)
// compiled member node returning call3856 (depth = 5)
  gc_frame_newslot(call3856);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3857 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3858 = gc_frame_new();
// call case 3: self.outer request
  Object call3859 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3858);
// compiled call node returning call3859 (depth = 8)
// compiled member node returning call3859 (depth = 7)
  partcv[0] = 0;
  Object call3860 = callmethodflags(call3859, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3857);
// compiled call node returning call3860 (depth = 6)
// compiled member node returning call3860 (depth = 5)
  params[0] = call3856;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3861 = callmethodflags(call3860, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3854);
// compiled call node returning call3861 (depth = 4)
  gc_frame_newslot(call3861);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3861;
  partcv[0] = 1;
  Object call3862 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe3853);
// compiled call node returning call3862 (depth = 3)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3863 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3864 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3866 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3865);
// compiled call node returning call3866 (depth = 6)
// compiled member node returning call3866 (depth = 5)
  gc_frame_newslot(call3866);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3867 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3868 = gc_frame_new();
// call case 3: self.outer request
  Object call3869 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3868);
// compiled call node returning call3869 (depth = 8)
// compiled member node returning call3869 (depth = 7)
  partcv[0] = 0;
  Object call3870 = callmethodflags(call3869, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3867);
// compiled call node returning call3870 (depth = 6)
// compiled member node returning call3870 (depth = 5)
  params[0] = call3866;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3871 = callmethodflags(call3870, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3864);
// compiled call node returning call3871 (depth = 4)
  gc_frame_newslot(call3871);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3871;
  partcv[0] = 1;
  Object call3872 = callmethod(*var_n, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe3863);
// compiled call node returning call3872 (depth = 3)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3873 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3874 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3876 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3875);
// compiled call node returning call3876 (depth = 6)
// compiled member node returning call3876 (depth = 5)
  gc_frame_newslot(call3876);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3877 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3878 = gc_frame_new();
// call case 3: self.outer request
  Object call3879 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3878);
// compiled call node returning call3879 (depth = 8)
// compiled member node returning call3879 (depth = 7)
  partcv[0] = 0;
  Object call3880 = callmethodflags(call3879, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3877);
// compiled call node returning call3880 (depth = 6)
// compiled member node returning call3880 (depth = 5)
  params[0] = call3876;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3881 = callmethodflags(call3880, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3874);
// compiled call node returning call3881 (depth = 4)
  gc_frame_newslot(call3881);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3881;
  partcv[0] = 1;
  Object call3882 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe3873);
// compiled call node returning call3882 (depth = 3)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3883 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3884 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3886 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3885);
// compiled call node returning call3886 (depth = 6)
// compiled member node returning call3886 (depth = 5)
  gc_frame_newslot(call3886);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3887 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3888 = gc_frame_new();
// call case 3: self.outer request
  Object call3889 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3888);
// compiled call node returning call3889 (depth = 8)
// compiled member node returning call3889 (depth = 7)
  partcv[0] = 0;
  Object call3890 = callmethodflags(call3889, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3887);
// compiled call node returning call3890 (depth = 6)
// compiled member node returning call3890 (depth = 5)
  params[0] = call3886;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3891 = callmethodflags(call3890, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3884);
// compiled call node returning call3891 (depth = 4)
  gc_frame_newslot(call3891);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3891;
  partcv[0] = 1;
  Object call3892 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3883);
// compiled call node returning call3892 (depth = 3)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3893 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3894 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3895 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3896 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3895);
// compiled call node returning call3896 (depth = 6)
// compiled member node returning call3896 (depth = 5)
  gc_frame_newslot(call3896);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3897 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3898 = gc_frame_new();
// call case 3: self.outer request
  Object call3899 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3898);
// compiled call node returning call3899 (depth = 8)
// compiled member node returning call3899 (depth = 7)
  partcv[0] = 0;
  Object call3900 = callmethodflags(call3899, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3897);
// compiled call node returning call3900 (depth = 6)
// compiled member node returning call3900 (depth = 5)
  params[0] = call3896;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3901 = callmethodflags(call3900, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3894);
// compiled call node returning call3901 (depth = 4)
  gc_frame_newslot(call3901);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call3901;
  partcv[0] = 1;
  Object call3902 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe3893);
// compiled call node returning call3902 (depth = 3)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3903 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call3904 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3903);
// compiled call node returning call3904 (depth = 3)
  gc_frame_end(frame);
  return call3904;
}
Object meth_ast__apply3913(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3915 == NULL) {
    strlit3915 = alloc_String("  ");
    gc_root(strlit3915);
  }
// compiled string node returning strlit3915 (depth = 7)
  int op_slot_right_3914 = gc_frame_newslot(strlit3915);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_3914 = gc_frame_newslot(*var_spc);
  params[0] = strlit3915;
  partcv[0] = 1;
  Object opresult3917 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3917 (depth = 6)
  *var_spc = opresult3917;
  if (opresult3917 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4066(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4068 == NULL) {
    strlit4068 = alloc_String("");
    gc_root(strlit4068);
  }
// compiled string node returning strlit4068 (depth = 9)
  int op_slot_right_4067 = gc_frame_newslot(strlit4068);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4071 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4073 = alloc_Float64(4);
// compiled num node returning num4073 (depth = 12)
  int op_slot_right_4072 = gc_frame_newslot(num4073);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4072 = gc_frame_newslot(*var_depth);
  params[0] = num4073;
  partcv[0] = 1;
  Object sum4075 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4075 (depth = 11)
  gc_frame_newslot(sum4075);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4075;
  partcv[0] = 1;
  Object call4076 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4071);
// compiled call node returning call4076 (depth = 10)
  int op_slot_right_4070 = gc_frame_newslot(call4076);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String("");
    gc_root(strlit4079);
  }
// compiled string node returning strlit4079 (depth = 11)
  int op_slot_right_4078 = gc_frame_newslot(strlit4079);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4081 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit4084 == NULL) {
    strlit4084 = alloc_String("""\x0a""      ");
    gc_root(strlit4084);
  }
// compiled string node returning strlit4084 (depth = 13)
  int op_slot_right_4083 = gc_frame_newslot(strlit4084);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_4086 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit4088 == NULL) {
    strlit4088 = alloc_String("");
    gc_root(strlit4088);
  }
// compiled string node returning strlit4088 (depth = 14)
  int op_slot_left_4086 = gc_frame_newslot(strlit4088);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4089 = callmethod(strlit4088, "++", 1, partcv, params);
// compiled op node returning opresult4089 (depth = 13)
  int op_slot_left_4083 = gc_frame_newslot(opresult4089);
  params[0] = strlit4084;
  partcv[0] = 1;
  Object opresult4090 = callmethod(opresult4089, "++", 1, partcv, params);
// compiled op node returning opresult4090 (depth = 12)
  int op_slot_left_4081 = gc_frame_newslot(opresult4090);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4091 = callmethod(opresult4090, "++", 1, partcv, params);
// compiled op node returning opresult4091 (depth = 11)
  int op_slot_left_4078 = gc_frame_newslot(opresult4091);
  params[0] = strlit4079;
  partcv[0] = 1;
  Object opresult4092 = callmethod(opresult4091, "++", 1, partcv, params);
// compiled op node returning opresult4092 (depth = 10)
  int op_slot_left_4070 = gc_frame_newslot(opresult4092);
  params[0] = call4076;
  partcv[0] = 1;
  Object opresult4093 = callmethod(opresult4092, "++", 1, partcv, params);
// compiled op node returning opresult4093 (depth = 9)
  int op_slot_left_4067 = gc_frame_newslot(opresult4093);
  params[0] = strlit4068;
  partcv[0] = 1;
  Object opresult4094 = callmethod(opresult4093, "++", 1, partcv, params);
// compiled op node returning opresult4094 (depth = 8)
  *var_s = opresult4094;
  if (opresult4094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4020(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4022 == NULL) {
    strlit4022 = alloc_String("");
    gc_root(strlit4022);
  }
// compiled string node returning strlit4022 (depth = 7)
  int op_slot_right_4021 = gc_frame_newslot(strlit4022);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4026 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4025);
// compiled call node returning call4026 (depth = 9)
// compiled member node returning call4026 (depth = 8)
  int op_slot_right_4024 = gc_frame_newslot(call4026);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4029 == NULL) {
    strlit4029 = alloc_String("Part: ");
    gc_root(strlit4029);
  }
// compiled string node returning strlit4029 (depth = 9)
  int op_slot_right_4028 = gc_frame_newslot(strlit4029);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4031 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4034 == NULL) {
    strlit4034 = alloc_String("""\x0a""  ");
    gc_root(strlit4034);
  }
// compiled string node returning strlit4034 (depth = 11)
  int op_slot_right_4033 = gc_frame_newslot(strlit4034);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_4036 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 12)
  int op_slot_left_4036 = gc_frame_newslot(strlit4038);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4039 = callmethod(strlit4038, "++", 1, partcv, params);
// compiled op node returning opresult4039 (depth = 11)
  int op_slot_left_4033 = gc_frame_newslot(opresult4039);
  params[0] = strlit4034;
  partcv[0] = 1;
  Object opresult4040 = callmethod(opresult4039, "++", 1, partcv, params);
// compiled op node returning opresult4040 (depth = 10)
  int op_slot_left_4031 = gc_frame_newslot(opresult4040);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4041 = callmethod(opresult4040, "++", 1, partcv, params);
// compiled op node returning opresult4041 (depth = 9)
  int op_slot_left_4028 = gc_frame_newslot(opresult4041);
  params[0] = strlit4029;
  partcv[0] = 1;
  Object opresult4042 = callmethod(opresult4041, "++", 1, partcv, params);
// compiled op node returning opresult4042 (depth = 8)
  int op_slot_left_4024 = gc_frame_newslot(opresult4042);
  params[0] = call4026;
  partcv[0] = 1;
  Object opresult4043 = callmethod(opresult4042, "++", 1, partcv, params);
// compiled op node returning opresult4043 (depth = 7)
  int op_slot_left_4021 = gc_frame_newslot(opresult4043);
  params[0] = strlit4022;
  partcv[0] = 1;
  Object opresult4044 = callmethod(opresult4043, "++", 1, partcv, params);
// compiled op node returning opresult4044 (depth = 6)
  *var_s = opresult4044;
  if (opresult4044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4047 == NULL) {
    strlit4047 = alloc_String("Parameters:");
    gc_root(strlit4047);
  }
// compiled string node returning strlit4047 (depth = 7)
  int op_slot_right_4046 = gc_frame_newslot(strlit4047);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4049 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4052 == NULL) {
    strlit4052 = alloc_String("""\x0a""    ");
    gc_root(strlit4052);
  }
// compiled string node returning strlit4052 (depth = 9)
  int op_slot_right_4051 = gc_frame_newslot(strlit4052);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_4054 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit4056 == NULL) {
    strlit4056 = alloc_String("");
    gc_root(strlit4056);
  }
// compiled string node returning strlit4056 (depth = 10)
  int op_slot_left_4054 = gc_frame_newslot(strlit4056);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4057 = callmethod(strlit4056, "++", 1, partcv, params);
// compiled op node returning opresult4057 (depth = 9)
  int op_slot_left_4051 = gc_frame_newslot(opresult4057);
  params[0] = strlit4052;
  partcv[0] = 1;
  Object opresult4058 = callmethod(opresult4057, "++", 1, partcv, params);
// compiled op node returning opresult4058 (depth = 8)
  int op_slot_left_4049 = gc_frame_newslot(opresult4058);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4059 = callmethod(opresult4058, "++", 1, partcv, params);
// compiled op node returning opresult4059 (depth = 7)
  int op_slot_left_4046 = gc_frame_newslot(opresult4059);
  params[0] = strlit4047;
  partcv[0] = 1;
  Object opresult4060 = callmethod(opresult4059, "++", 1, partcv, params);
// compiled op node returning opresult4060 (depth = 6)
  *var_s = opresult4060;
  if (opresult4060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4062 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4064 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4063);
// compiled call node returning call4064 (depth = 7)
// compiled member node returning call4064 (depth = 6)
  gc_frame_newslot(call4064);
// starting to compile block node (depth = 6)
  Object block4065 = alloc_Block(NULL, NULL, "ast", 927);
  gc_frame_newslot(block4065);
// method "_apply"
  block_savedest(block4065);
  Object closure4066 = createclosure(4, "_apply");
  setclosureframe(closure4066, stackframe);
  addtoclosure(closure4066, var_depth);
  addtoclosure(closure4066, var_spc);
  addtoclosure(closure4066, var_s);
  addtoclosure(closure4066, selfslot);
  struct UserObject *uo4066 = (struct UserObject*)block4065;
  uo4066->data[0] = (Object)closure4066;
  Method *meth_meth_ast__apply4066 = addmethod2pos(block4065, "_apply", &meth_ast__apply4066, 0);
  int argcv_meth_ast__apply4066[] = {1};
  meth_meth_ast__apply4066->type = alloc_MethodType(1, argcv_meth_ast__apply4066);
  meth_meth_ast__apply4066->definitionModule = modulename;
  meth_meth_ast__apply4066->definitionLine = 927;
// compiled block node returning block4065 (depth = 6)
  gc_frame_newslot(block4065);
// call case 5: prelude request
  params[0] = call4064;
  params[1] = block4065;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4097 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4062);
// compiled call node returning call4097 (depth = 5)
  gc_frame_end(frame);
  return call4097;
}
Object meth_ast__apply4130(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4132 == NULL) {
    strlit4132 = alloc_String("");
    gc_root(strlit4132);
  }
// compiled string node returning strlit4132 (depth = 8)
  int op_slot_right_4131 = gc_frame_newslot(strlit4132);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4135 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4136 = alloc_Float64(0);
// compiled num node returning num4136 (depth = 10)
  gc_frame_newslot(num4136);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num4136;
  partcv[0] = 1;
  Object call4137 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4135);
// compiled call node returning call4137 (depth = 9)
  int op_slot_right_4134 = gc_frame_newslot(call4137);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4140 == NULL) {
    strlit4140 = alloc_String("  ");
    gc_root(strlit4140);
  }
// compiled string node returning strlit4140 (depth = 10)
  int op_slot_right_4139 = gc_frame_newslot(strlit4140);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4142 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4145 == NULL) {
    strlit4145 = alloc_String("""\x0a""");
    gc_root(strlit4145);
  }
// compiled string node returning strlit4145 (depth = 12)
  int op_slot_right_4144 = gc_frame_newslot(strlit4145);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4147 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4149 == NULL) {
    strlit4149 = alloc_String("");
    gc_root(strlit4149);
  }
// compiled string node returning strlit4149 (depth = 13)
  int op_slot_left_4147 = gc_frame_newslot(strlit4149);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4150 = callmethod(strlit4149, "++", 1, partcv, params);
// compiled op node returning opresult4150 (depth = 12)
  int op_slot_left_4144 = gc_frame_newslot(opresult4150);
  params[0] = strlit4145;
  partcv[0] = 1;
  Object opresult4151 = callmethod(opresult4150, "++", 1, partcv, params);
// compiled op node returning opresult4151 (depth = 11)
  int op_slot_left_4142 = gc_frame_newslot(opresult4151);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4152 = callmethod(opresult4151, "++", 1, partcv, params);
// compiled op node returning opresult4152 (depth = 10)
  int op_slot_left_4139 = gc_frame_newslot(opresult4152);
  params[0] = strlit4140;
  partcv[0] = 1;
  Object opresult4153 = callmethod(opresult4152, "++", 1, partcv, params);
// compiled op node returning opresult4153 (depth = 9)
  int op_slot_left_4134 = gc_frame_newslot(opresult4153);
  params[0] = call4137;
  partcv[0] = 1;
  Object opresult4154 = callmethod(opresult4153, "++", 1, partcv, params);
// compiled op node returning opresult4154 (depth = 8)
  int op_slot_left_4131 = gc_frame_newslot(opresult4154);
  params[0] = strlit4132;
  partcv[0] = 1;
  Object opresult4155 = callmethod(opresult4154, "++", 1, partcv, params);
// compiled op node returning opresult4155 (depth = 7)
  *var_s = opresult4155;
  if (opresult4155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4197 == NULL) {
    strlit4197 = alloc_String("");
    gc_root(strlit4197);
  }
// compiled string node returning strlit4197 (depth = 8)
  int op_slot_right_4196 = gc_frame_newslot(strlit4197);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4200 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4202 = alloc_Float64(2);
// compiled num node returning num4202 (depth = 11)
  int op_slot_right_4201 = gc_frame_newslot(num4202);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4201 = gc_frame_newslot(*var_depth);
  params[0] = num4202;
  partcv[0] = 1;
  Object sum4204 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4204 (depth = 10)
  gc_frame_newslot(sum4204);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_an (depth = 10)
  params[0] = sum4204;
  partcv[0] = 1;
  Object call4205 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4200);
// compiled call node returning call4205 (depth = 9)
  int op_slot_right_4199 = gc_frame_newslot(call4205);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4208 == NULL) {
    strlit4208 = alloc_String("  ");
    gc_root(strlit4208);
  }
// compiled string node returning strlit4208 (depth = 10)
  int op_slot_right_4207 = gc_frame_newslot(strlit4208);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4210 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4213 == NULL) {
    strlit4213 = alloc_String("""\x0a""");
    gc_root(strlit4213);
  }
// compiled string node returning strlit4213 (depth = 12)
  int op_slot_right_4212 = gc_frame_newslot(strlit4213);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_4215 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit4217 == NULL) {
    strlit4217 = alloc_String("");
    gc_root(strlit4217);
  }
// compiled string node returning strlit4217 (depth = 13)
  int op_slot_left_4215 = gc_frame_newslot(strlit4217);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4218 = callmethod(strlit4217, "++", 1, partcv, params);
// compiled op node returning opresult4218 (depth = 12)
  int op_slot_left_4212 = gc_frame_newslot(opresult4218);
  params[0] = strlit4213;
  partcv[0] = 1;
  Object opresult4219 = callmethod(opresult4218, "++", 1, partcv, params);
// compiled op node returning opresult4219 (depth = 11)
  int op_slot_left_4210 = gc_frame_newslot(opresult4219);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4220 = callmethod(opresult4219, "++", 1, partcv, params);
// compiled op node returning opresult4220 (depth = 10)
  int op_slot_left_4207 = gc_frame_newslot(opresult4220);
  params[0] = strlit4208;
  partcv[0] = 1;
  Object opresult4221 = callmethod(opresult4220, "++", 1, partcv, params);
// compiled op node returning opresult4221 (depth = 9)
  int op_slot_left_4199 = gc_frame_newslot(opresult4221);
  params[0] = call4205;
  partcv[0] = 1;
  Object opresult4222 = callmethod(opresult4221, "++", 1, partcv, params);
// compiled op node returning opresult4222 (depth = 8)
  int op_slot_left_4196 = gc_frame_newslot(opresult4222);
  params[0] = strlit4197;
  partcv[0] = 1;
  Object opresult4223 = callmethod(opresult4222, "++", 1, partcv, params);
// compiled op node returning opresult4223 (depth = 7)
  *var_s = opresult4223;
  if (opresult4223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4244(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4246 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4248 = alloc_Float64(2);
// compiled num node returning num4248 (depth = 9)
  int op_slot_right_4247 = gc_frame_newslot(num4248);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4247 = gc_frame_newslot(*var_depth);
  params[0] = num4248;
  partcv[0] = 1;
  Object sum4250 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4250 (depth = 8)
  gc_frame_newslot(sum4250);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4250;
  partcv[0] = 1;
  Object call4251 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4246);
// compiled call node returning call4251 (depth = 7)
  int op_slot_right_4245 = gc_frame_newslot(call4251);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4253 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4256 == NULL) {
    strlit4256 = alloc_String("""\x0a""  ");
    gc_root(strlit4256);
  }
// compiled string node returning strlit4256 (depth = 9)
  int op_slot_right_4255 = gc_frame_newslot(strlit4256);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4255 = gc_frame_newslot(*var_s);
  params[0] = strlit4256;
  partcv[0] = 1;
  Object opresult4258 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4258 (depth = 8)
  int op_slot_left_4253 = gc_frame_newslot(opresult4258);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4259 = callmethod(opresult4258, "++", 1, partcv, params);
// compiled op node returning opresult4259 (depth = 7)
  int op_slot_left_4245 = gc_frame_newslot(opresult4259);
  params[0] = call4251;
  partcv[0] = 1;
  Object opresult4260 = callmethod(opresult4259, "++", 1, partcv, params);
// compiled op node returning opresult4260 (depth = 6)
  *var_s = opresult4260;
  if (opresult4260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3905(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3906 == NULL) {
    strlit3906 = alloc_String("");
    gc_root(strlit3906);
  }
// compiled string node returning strlit3906 (depth = 4)
  *var_spc = strlit3906;
  if (strlit3906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3907 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_3908 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num3910 = alloc_Float64(0);
// compiled num node returning num3910 (depth = 5)
  int op_slot_left_3908 = gc_frame_newslot(num3910);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3911 = callmethod(num3910, "..", 1, partcv, params);
// compiled op node returning opresult3911 (depth = 4)
  gc_frame_newslot(opresult3911);
// starting to compile block node (depth = 4)
  Object block3912 = alloc_Block(NULL, NULL, "ast", 912);
  gc_frame_newslot(block3912);
// method "_apply"
  block_savedest(block3912);
  Object closure3913 = createclosure(2, "_apply");
  setclosureframe(closure3913, stackframe);
  addtoclosure(closure3913, var_spc);
  addtoclosure(closure3913, selfslot);
  struct UserObject *uo3913 = (struct UserObject*)block3912;
  uo3913->data[0] = (Object)closure3913;
  Method *meth_meth_ast__apply3913 = addmethod2pos(block3912, "_apply", &meth_ast__apply3913, 0);
  int argcv_meth_ast__apply3913[] = {1};
  meth_meth_ast__apply3913->type = alloc_MethodType(1, argcv_meth_ast__apply3913);
  meth_meth_ast__apply3913->definitionModule = modulename;
  meth_meth_ast__apply3913->definitionLine = 907;
// compiled block node returning block3912 (depth = 4)
  gc_frame_newslot(block3912);
// call case 5: prelude request
  params[0] = opresult3911;
  params[1] = block3912;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3920 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compiled call node returning call3920 (depth = 3)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3922 == NULL) {
    strlit3922 = alloc_String("""\x0a""");
    gc_root(strlit3922);
  }
// compiled string node returning strlit3922 (depth = 5)
  int op_slot_right_3921 = gc_frame_newslot(strlit3922);
// starting to compile call node (depth = 5)
  int callframe3924 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3925 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3924);
// compiled call node returning call3925 (depth = 5)
  int op_slot_left_3921 = gc_frame_newslot(call3925);
  params[0] = strlit3922;
  partcv[0] = 1;
  Object opresult3926 = callmethod(call3925, "++", 1, partcv, params);
// compiled op node returning opresult3926 (depth = 4)
  *var_s = opresult3926;
  if (opresult3926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3928 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3930 = alloc_Float64(1);
// compiled num node returning num3930 (depth = 7)
  int op_slot_right_3929 = gc_frame_newslot(num3930);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3929 = gc_frame_newslot(*var_depth);
  params[0] = num3930;
  partcv[0] = 1;
  Object sum3932 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3932 (depth = 6)
  gc_frame_newslot(sum3932);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3933 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3934 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3933);
// compiled call node returning call3934 (depth = 7)
// compiled member node returning call3934 (depth = 6)
  params[0] = sum3932;
  partcv[0] = 1;
  Object call3935 = callmethod(call3934, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3928);
// compiled call node returning call3935 (depth = 5)
  int op_slot_right_3927 = gc_frame_newslot(call3935);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("Name: ");
    gc_root(strlit3938);
  }
// compiled string node returning strlit3938 (depth = 6)
  int op_slot_right_3937 = gc_frame_newslot(strlit3938);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3940 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3940 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3942 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3942 (depth = 6)
  int op_slot_left_3937 = gc_frame_newslot(opresult3942);
  params[0] = strlit3938;
  partcv[0] = 1;
  Object opresult3943 = callmethod(opresult3942, "++", 1, partcv, params);
// compiled op node returning opresult3943 (depth = 5)
  int op_slot_left_3927 = gc_frame_newslot(opresult3943);
  params[0] = call3935;
  partcv[0] = 1;
  Object opresult3944 = callmethod(opresult3943, "++", 1, partcv, params);
// compiled op node returning opresult3944 (depth = 4)
  *var_s = opresult3944;
  if (opresult3944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("""\x0a""");
    gc_root(strlit3947);
  }
// compiled string node returning strlit3947 (depth = 5)
  int op_slot_right_3946 = gc_frame_newslot(strlit3947);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_3946 = gc_frame_newslot(*var_s);
  params[0] = strlit3947;
  partcv[0] = 1;
  Object opresult3949 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3949 (depth = 4)
  *var_s = opresult3949;
  if (opresult3949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3954 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3953);
// compiled call node returning call3954 (depth = 6)
// compiled member node returning call3954 (depth = 5)
  int op_slot_right_3952 = gc_frame_newslot(call3954);
// starting to compile identifier node (depth = 5)
  Object bool3956 = alloc_Boolean(0);
// compiled identifier node returning bool3956 (depth = 5)
  int op_slot_left_3952 = gc_frame_newslot(bool3956);
  params[0] = call3954;
  partcv[0] = 1;
  Object opresult3957 = callmethod(bool3956, "≠", 1, partcv, params);
// compiled op node returning opresult3957 (depth = 4)
  Object if3951 = done;
  if (istrue(opresult3957)) {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3959 == NULL) {
    strlit3959 = alloc_String("  ");
    gc_root(strlit3959);
  }
// compiled string node returning strlit3959 (depth = 6)
  int op_slot_right_3958 = gc_frame_newslot(strlit3959);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3961 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3964 == NULL) {
    strlit3964 = alloc_String("Returns:""\x0a""");
    gc_root(strlit3964);
  }
// compiled string node returning strlit3964 (depth = 8)
  int op_slot_right_3963 = gc_frame_newslot(strlit3964);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3966 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3966 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3968 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3968 (depth = 8)
  int op_slot_left_3963 = gc_frame_newslot(opresult3968);
  params[0] = strlit3964;
  partcv[0] = 1;
  Object opresult3969 = callmethod(opresult3968, "++", 1, partcv, params);
// compiled op node returning opresult3969 (depth = 7)
  int op_slot_left_3961 = gc_frame_newslot(opresult3969);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3970 = callmethod(opresult3969, "++", 1, partcv, params);
// compiled op node returning opresult3970 (depth = 6)
  int op_slot_left_3958 = gc_frame_newslot(opresult3970);
  params[0] = strlit3959;
  partcv[0] = 1;
  Object opresult3971 = callmethod(opresult3970, "++", 1, partcv, params);
// compiled op node returning opresult3971 (depth = 5)
  *var_s = opresult3971;
  if (opresult3971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3974 == NULL) {
    strlit3974 = alloc_String("""\x0a""");
    gc_root(strlit3974);
  }
// compiled string node returning strlit3974 (depth = 6)
  int op_slot_right_3973 = gc_frame_newslot(strlit3974);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3977 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3979 = alloc_Float64(2);
// compiled num node returning num3979 (depth = 9)
  int op_slot_right_3978 = gc_frame_newslot(num3979);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3978 = gc_frame_newslot(*var_depth);
  params[0] = num3979;
  partcv[0] = 1;
  Object sum3981 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3981 (depth = 8)
  gc_frame_newslot(sum3981);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3982 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3983 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3982);
// compiled call node returning call3983 (depth = 9)
// compiled member node returning call3983 (depth = 8)
  params[0] = sum3981;
  partcv[0] = 1;
  Object call3984 = callmethod(call3983, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3977);
// compiled call node returning call3984 (depth = 7)
  int op_slot_right_3976 = gc_frame_newslot(call3984);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3976 = gc_frame_newslot(*var_s);
  params[0] = call3984;
  partcv[0] = 1;
  Object opresult3986 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3986 (depth = 6)
  int op_slot_left_3973 = gc_frame_newslot(opresult3986);
  params[0] = strlit3974;
  partcv[0] = 1;
  Object opresult3987 = callmethod(opresult3986, "++", 1, partcv, params);
// compiled op node returning opresult3987 (depth = 5)
  *var_s = opresult3987;
  if (opresult3987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3951 = done;
  } else {
  }
// compiled if node returning if3951 (depth = 3)
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3990 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3991 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3990);
// compiled call node returning call3991 (depth = 5)
// compiled member node returning call3991 (depth = 4)
  Object if3989 = done;
  if (istrue(call3991)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3993 == NULL) {
    strlit3993 = alloc_String("Fresh""\x0a""");
    gc_root(strlit3993);
  }
// compiled string node returning strlit3993 (depth = 6)
  int op_slot_right_3992 = gc_frame_newslot(strlit3993);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3995 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3995 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3997 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3997 (depth = 6)
  int op_slot_left_3992 = gc_frame_newslot(opresult3997);
  params[0] = strlit3993;
  partcv[0] = 1;
  Object opresult3998 = callmethod(opresult3997, "++", 1, partcv, params);
// compiled op node returning opresult3998 (depth = 5)
  *var_s = opresult3998;
  if (opresult3998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if3989 = done;
  } else {
  }
// compiled if node returning if3989 (depth = 3)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4001 == NULL) {
    strlit4001 = alloc_String("Signature:");
    gc_root(strlit4001);
  }
// compiled string node returning strlit4001 (depth = 5)
  int op_slot_right_4000 = gc_frame_newslot(strlit4001);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4003 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4006 == NULL) {
    strlit4006 = alloc_String("");
    gc_root(strlit4006);
  }
// compiled string node returning strlit4006 (depth = 7)
  int op_slot_right_4005 = gc_frame_newslot(strlit4006);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_4008 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit4010 == NULL) {
    strlit4010 = alloc_String("");
    gc_root(strlit4010);
  }
// compiled string node returning strlit4010 (depth = 8)
  int op_slot_left_4008 = gc_frame_newslot(strlit4010);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4011 = callmethod(strlit4010, "++", 1, partcv, params);
// compiled op node returning opresult4011 (depth = 7)
  int op_slot_left_4005 = gc_frame_newslot(opresult4011);
  params[0] = strlit4006;
  partcv[0] = 1;
  Object opresult4012 = callmethod(opresult4011, "++", 1, partcv, params);
// compiled op node returning opresult4012 (depth = 6)
  int op_slot_left_4003 = gc_frame_newslot(opresult4012);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4013 = callmethod(opresult4012, "++", 1, partcv, params);
// compiled op node returning opresult4013 (depth = 5)
  int op_slot_left_4000 = gc_frame_newslot(opresult4013);
  params[0] = strlit4001;
  partcv[0] = 1;
  Object opresult4014 = callmethod(opresult4013, "++", 1, partcv, params);
// compiled op node returning opresult4014 (depth = 4)
  *var_s = opresult4014;
  if (opresult4014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4016 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4018 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4017);
// compiled call node returning call4018 (depth = 5)
// compiled member node returning call4018 (depth = 4)
  gc_frame_newslot(call4018);
// starting to compile block node (depth = 4)
  Object block4019 = alloc_Block(NULL, NULL, "ast", 924);
  gc_frame_newslot(block4019);
// method "_apply"
  block_savedest(block4019);
  Object closure4020 = createclosure(4, "_apply");
  setclosureframe(closure4020, stackframe);
  addtoclosure(closure4020, var_spc);
  addtoclosure(closure4020, var_s);
  addtoclosure(closure4020, var_depth);
  addtoclosure(closure4020, selfslot);
  struct UserObject *uo4020 = (struct UserObject*)block4019;
  uo4020->data[0] = (Object)closure4020;
  Method *meth_meth_ast__apply4020 = addmethod2pos(block4019, "_apply", &meth_ast__apply4020, 0);
  int argcv_meth_ast__apply4020[] = {1};
  meth_meth_ast__apply4020->type = alloc_MethodType(1, argcv_meth_ast__apply4020);
  meth_meth_ast__apply4020->definitionModule = modulename;
  meth_meth_ast__apply4020->definitionLine = 924;
// compiled block node returning block4019 (depth = 4)
  gc_frame_newslot(block4019);
// call case 5: prelude request
  params[0] = call4018;
  params[1] = block4019;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4099 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4016);
// compiled call node returning call4099 (depth = 3)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4101 == NULL) {
    strlit4101 = alloc_String("""\x0a""");
    gc_root(strlit4101);
  }
// compiled string node returning strlit4101 (depth = 5)
  int op_slot_right_4100 = gc_frame_newslot(strlit4101);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4100 = gc_frame_newslot(*var_s);
  params[0] = strlit4101;
  partcv[0] = 1;
  Object opresult4103 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4103 (depth = 4)
  *var_s = opresult4103;
  if (opresult4103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4108 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled call node returning call4108 (depth = 6)
// compiled member node returning call4108 (depth = 5)
  int op_slot_right_4106 = gc_frame_newslot(call4108);
// starting to compile identifier node (depth = 5)
  Object bool4110 = alloc_Boolean(0);
// compiled identifier node returning bool4110 (depth = 5)
  int op_slot_left_4106 = gc_frame_newslot(bool4110);
  params[0] = call4108;
  partcv[0] = 1;
  Object opresult4111 = callmethod(bool4110, "≠", 1, partcv, params);
// compiled op node returning opresult4111 (depth = 4)
  Object if4105 = done;
  if (istrue(opresult4111)) {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4113 == NULL) {
    strlit4113 = alloc_String("Generics:");
    gc_root(strlit4113);
  }
// compiled string node returning strlit4113 (depth = 6)
  int op_slot_right_4112 = gc_frame_newslot(strlit4113);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4115 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4118 == NULL) {
    strlit4118 = alloc_String("");
    gc_root(strlit4118);
  }
// compiled string node returning strlit4118 (depth = 8)
  int op_slot_right_4117 = gc_frame_newslot(strlit4118);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4120 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4122 == NULL) {
    strlit4122 = alloc_String("");
    gc_root(strlit4122);
  }
// compiled string node returning strlit4122 (depth = 9)
  int op_slot_left_4120 = gc_frame_newslot(strlit4122);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4123 = callmethod(strlit4122, "++", 1, partcv, params);
// compiled op node returning opresult4123 (depth = 8)
  int op_slot_left_4117 = gc_frame_newslot(opresult4123);
  params[0] = strlit4118;
  partcv[0] = 1;
  Object opresult4124 = callmethod(opresult4123, "++", 1, partcv, params);
// compiled op node returning opresult4124 (depth = 7)
  int op_slot_left_4115 = gc_frame_newslot(opresult4124);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4125 = callmethod(opresult4124, "++", 1, partcv, params);
// compiled op node returning opresult4125 (depth = 6)
  int op_slot_left_4112 = gc_frame_newslot(opresult4125);
  params[0] = strlit4113;
  partcv[0] = 1;
  Object opresult4126 = callmethod(opresult4125, "++", 1, partcv, params);
// compiled op node returning opresult4126 (depth = 5)
  *var_s = opresult4126;
  if (opresult4126 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4128 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4129 = alloc_Block(NULL, NULL, "ast", 934);
  gc_frame_newslot(block4129);
// method "_apply"
  block_savedest(block4129);
  Object closure4130 = createclosure(3, "_apply");
  setclosureframe(closure4130, stackframe);
  addtoclosure(closure4130, var_spc);
  addtoclosure(closure4130, var_s);
  addtoclosure(closure4130, selfslot);
  struct UserObject *uo4130 = (struct UserObject*)block4129;
  uo4130->data[0] = (Object)closure4130;
  Method *meth_meth_ast__apply4130 = addmethod2pos(block4129, "_apply", &meth_ast__apply4130, 0);
  int argcv_meth_ast__apply4130[] = {1};
  meth_meth_ast__apply4130->type = alloc_MethodType(1, argcv_meth_ast__apply4130);
  meth_meth_ast__apply4130->definitionModule = modulename;
  meth_meth_ast__apply4130->definitionLine = 932;
// compiled block node returning block4129 (depth = 5)
  gc_frame_newslot(block4129);
// call case 6: other member request
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4159 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4158);
// compiled call node returning call4159 (depth = 6)
// compiled member node returning call4159 (depth = 5)
  params[0] = block4129;
  partcv[0] = 1;
  Object call4160 = callmethod(call4159, "do",
    1, partcv, params);
  gc_frame_end(callframe4128);
// compiled call node returning call4160 (depth = 4)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4162 == NULL) {
    strlit4162 = alloc_String("""\x0a""");
    gc_root(strlit4162);
  }
// compiled string node returning strlit4162 (depth = 6)
  int op_slot_right_4161 = gc_frame_newslot(strlit4162);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4161 = gc_frame_newslot(*var_s);
  params[0] = strlit4162;
  partcv[0] = 1;
  Object opresult4164 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4164 (depth = 5)
  *var_s = opresult4164;
  if (opresult4164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4105 = done;
  } else {
  }
// compiled if node returning if4105 (depth = 3)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4168 = alloc_Float64(0);
// compiled num node returning num4168 (depth = 5)
  int op_slot_right_4167 = gc_frame_newslot(num4168);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4170 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4172 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4171);
// compiled call node returning call4172 (depth = 8)
// compiled member node returning call4172 (depth = 7)
  partcv[0] = 0;
  Object call4173 = callmethod(call4172, "size",
    1, partcv, params);
  gc_frame_end(callframe4170);
// compiled call node returning call4173 (depth = 6)
// compiled member node returning call4173 (depth = 5)
  int op_slot_left_4167 = gc_frame_newslot(call4173);
  params[0] = num4168;
  partcv[0] = 1;
  Object opresult4174 = callmethod(call4173, ">", 1, partcv, params);
// compiled op node returning opresult4174 (depth = 4)
  Object if4166 = done;
  if (istrue(opresult4174)) {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("Annotations:");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 6)
  int op_slot_right_4175 = gc_frame_newslot(strlit4176);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4178 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4181 == NULL) {
    strlit4181 = alloc_String("");
    gc_root(strlit4181);
  }
// compiled string node returning strlit4181 (depth = 8)
  int op_slot_right_4180 = gc_frame_newslot(strlit4181);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_4183 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit4185 == NULL) {
    strlit4185 = alloc_String("");
    gc_root(strlit4185);
  }
// compiled string node returning strlit4185 (depth = 9)
  int op_slot_left_4183 = gc_frame_newslot(strlit4185);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4186 = callmethod(strlit4185, "++", 1, partcv, params);
// compiled op node returning opresult4186 (depth = 8)
  int op_slot_left_4180 = gc_frame_newslot(opresult4186);
  params[0] = strlit4181;
  partcv[0] = 1;
  Object opresult4187 = callmethod(opresult4186, "++", 1, partcv, params);
// compiled op node returning opresult4187 (depth = 7)
  int op_slot_left_4178 = gc_frame_newslot(opresult4187);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4188 = callmethod(opresult4187, "++", 1, partcv, params);
// compiled op node returning opresult4188 (depth = 6)
  int op_slot_left_4175 = gc_frame_newslot(opresult4188);
  params[0] = strlit4176;
  partcv[0] = 1;
  Object opresult4189 = callmethod(opresult4188, "++", 1, partcv, params);
// compiled op node returning opresult4189 (depth = 5)
  *var_s = opresult4189;
  if (opresult4189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4191 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4193 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4192);
// compiled call node returning call4193 (depth = 6)
// compiled member node returning call4193 (depth = 5)
  gc_frame_newslot(call4193);
// starting to compile block node (depth = 5)
  Object block4194 = alloc_Block(NULL, NULL, "ast", 941);
  gc_frame_newslot(block4194);
// method "_apply"
  block_savedest(block4194);
  Object closure4195 = createclosure(4, "_apply");
  setclosureframe(closure4195, stackframe);
  addtoclosure(closure4195, var_depth);
  addtoclosure(closure4195, var_spc);
  addtoclosure(closure4195, var_s);
  addtoclosure(closure4195, selfslot);
  struct UserObject *uo4195 = (struct UserObject*)block4194;
  uo4195->data[0] = (Object)closure4195;
  Method *meth_meth_ast__apply4195 = addmethod2pos(block4194, "_apply", &meth_ast__apply4195, 0);
  int argcv_meth_ast__apply4195[] = {1};
  meth_meth_ast__apply4195->type = alloc_MethodType(1, argcv_meth_ast__apply4195);
  meth_meth_ast__apply4195->definitionModule = modulename;
  meth_meth_ast__apply4195->definitionLine = 941;
// compiled block node returning block4194 (depth = 5)
  gc_frame_newslot(block4194);
// call case 5: prelude request
  params[0] = call4193;
  params[1] = block4194;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4226 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4191);
// compiled call node returning call4226 (depth = 4)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4228 == NULL) {
    strlit4228 = alloc_String("""\x0a""");
    gc_root(strlit4228);
  }
// compiled string node returning strlit4228 (depth = 6)
  int op_slot_right_4227 = gc_frame_newslot(strlit4228);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4227 = gc_frame_newslot(*var_s);
  params[0] = strlit4228;
  partcv[0] = 1;
  Object opresult4230 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4230 (depth = 5)
  *var_s = opresult4230;
  if (opresult4230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4166 = done;
  } else {
  }
// compiled if node returning if4166 (depth = 3)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4233 == NULL) {
    strlit4233 = alloc_String("Body:");
    gc_root(strlit4233);
  }
// compiled string node returning strlit4233 (depth = 5)
  int op_slot_right_4232 = gc_frame_newslot(strlit4233);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4235 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4235 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4237 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4237 (depth = 5)
  int op_slot_left_4232 = gc_frame_newslot(opresult4237);
  params[0] = strlit4233;
  partcv[0] = 1;
  Object opresult4238 = callmethod(opresult4237, "++", 1, partcv, params);
// compiled op node returning opresult4238 (depth = 4)
  *var_s = opresult4238;
  if (opresult4238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4240 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4242 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4242 (depth = 5)
// compiled member node returning call4242 (depth = 4)
  gc_frame_newslot(call4242);
// starting to compile block node (depth = 4)
  Object block4243 = alloc_Block(NULL, NULL, "ast", 947);
  gc_frame_newslot(block4243);
// method "_apply"
  block_savedest(block4243);
  Object closure4244 = createclosure(4, "_apply");
  setclosureframe(closure4244, stackframe);
  addtoclosure(closure4244, var_depth);
  addtoclosure(closure4244, var_spc);
  addtoclosure(closure4244, var_s);
  addtoclosure(closure4244, selfslot);
  struct UserObject *uo4244 = (struct UserObject*)block4243;
  uo4244->data[0] = (Object)closure4244;
  Method *meth_meth_ast__apply4244 = addmethod2pos(block4243, "_apply", &meth_ast__apply4244, 0);
  int argcv_meth_ast__apply4244[] = {1};
  meth_meth_ast__apply4244->type = alloc_MethodType(1, argcv_meth_ast__apply4244);
  meth_meth_ast__apply4244->definitionModule = modulename;
  meth_meth_ast__apply4244->definitionLine = 947;
// compiled block node returning block4243 (depth = 4)
  gc_frame_newslot(block4243);
// call case 5: prelude request
  params[0] = call4242;
  params[1] = block4243;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4263 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4240);
// compiled call node returning call4263 (depth = 3)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4266 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4267 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4266);
// compiled call node returning call4267 (depth = 6)
// compiled member node returning call4267 (depth = 5)
  int op_slot_right_4265 = gc_frame_newslot(call4267);
// starting to compile identifier node (depth = 5)
  Object bool4269 = alloc_Boolean(0);
// compiled identifier node returning bool4269 (depth = 5)
  int op_slot_left_4265 = gc_frame_newslot(bool4269);
  params[0] = call4267;
  partcv[0] = 1;
  Object opresult4270 = callmethod(bool4269, "≠", 1, partcv, params);
// compiled op node returning opresult4270 (depth = 4)
  Object if4264 = done;
  if (istrue(opresult4270)) {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4272 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4274 = alloc_Float64(2);
// compiled num node returning num4274 (depth = 8)
  int op_slot_right_4273 = gc_frame_newslot(num4274);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4273 = gc_frame_newslot(*var_depth);
  params[0] = num4274;
  partcv[0] = 1;
  Object sum4276 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4276 (depth = 7)
  gc_frame_newslot(sum4276);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4278 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4277);
// compiled call node returning call4278 (depth = 8)
// compiled member node returning call4278 (depth = 7)
  params[0] = sum4276;
  partcv[0] = 1;
  Object call4279 = callmethod(call4278, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4272);
// compiled call node returning call4279 (depth = 6)
  int op_slot_right_4271 = gc_frame_newslot(call4279);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4271 = gc_frame_newslot(*var_s);
  params[0] = call4279;
  partcv[0] = 1;
  Object opresult4281 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4281 (depth = 5)
  *var_s = opresult4281;
  if (opresult4281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4264 = done;
  } else {
  }
// compiled if node returning if4264 (depth = 3)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4297 == NULL) {
    strlit4297 = alloc_String("    ");
    gc_root(strlit4297);
  }
// compiled string node returning strlit4297 (depth = 7)
  int op_slot_right_4296 = gc_frame_newslot(strlit4297);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4296 = gc_frame_newslot(*var_spc);
  params[0] = strlit4297;
  partcv[0] = 1;
  Object opresult4299 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4299 (depth = 6)
  *var_spc = opresult4299;
  if (opresult4299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4319(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4322 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4321);
// compiled call node returning call4322 (depth = 10)
// compiled member node returning call4322 (depth = 9)
  int op_slot_right_4320 = gc_frame_newslot(call4322);
// starting to compile identifier node (depth = 9)
  Object bool4324 = alloc_Boolean(0);
// compiled identifier node returning bool4324 (depth = 9)
  int op_slot_left_4320 = gc_frame_newslot(bool4324);
  params[0] = call4322;
  partcv[0] = 1;
  Object opresult4325 = callmethod(bool4324, "≠", 1, partcv, params);
// compiled op node returning opresult4325 (depth = 8)
  gc_frame_end(frame);
  return opresult4325;
}
Object meth_ast__apply4363(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4364 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  gc_frame_newslot(*var_pnr);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4365 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4366 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4365);
// compiled call node returning call4366 (depth = 11)
// compiled member node returning call4366 (depth = 10)
  params[0] = *var_pnr;
  partcv[0] = 1;
  Object call4367 = callmethod(call4366, "at",
    1, partcv, params);
  gc_frame_end(callframe4364);
// compiled call node returning call4367 (depth = 9)
  *var_p = call4367;
  if (call4367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4369 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4371 = alloc_Float64(1);
// compiled num node returning num4371 (depth = 12)
  int op_slot_right_4370 = gc_frame_newslot(num4371);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4370 = gc_frame_newslot(*var_depth);
  params[0] = num4371;
  partcv[0] = 1;
  Object sum4373 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4373 (depth = 11)
  gc_frame_newslot(sum4373);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = sum4373;
  partcv[0] = 1;
  Object call4374 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4369);
// compiled call node returning call4374 (depth = 10)
  int op_slot_right_4368 = gc_frame_newslot(call4374);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4368 = gc_frame_newslot(*var_s);
  params[0] = call4374;
  partcv[0] = 1;
  Object opresult4376 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4376 (depth = 9)
  *var_s = opresult4376;
  if (opresult4376 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4380 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call4382 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4381);
// compiled call node returning call4382 (depth = 13)
// compiled member node returning call4382 (depth = 12)
  partcv[0] = 0;
  Object call4383 = callmethod(call4382, "size",
    1, partcv, params);
  gc_frame_end(callframe4380);
// compiled call node returning call4383 (depth = 11)
// compiled member node returning call4383 (depth = 10)
  int op_slot_right_4379 = gc_frame_newslot(call4383);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_pnr (depth = 10)
  int op_slot_left_4379 = gc_frame_newslot(*var_pnr);
  params[0] = call4383;
  partcv[0] = 1;
  Object opresult4385 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult4385 (depth = 9)
  Object if4378 = done;
  if (istrue(opresult4385)) {
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4387 == NULL) {
    strlit4387 = alloc_String(", ");
    gc_root(strlit4387);
  }
// compiled string node returning strlit4387 (depth = 11)
  int op_slot_right_4386 = gc_frame_newslot(strlit4387);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4386 = gc_frame_newslot(*var_s);
  params[0] = strlit4387;
  partcv[0] = 1;
  Object opresult4389 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4389 (depth = 10)
  *var_s = opresult4389;
  if (opresult4389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if4378 = done;
  } else {
  }
// compiled if node returning if4378 (depth = 8)
  gc_frame_end(frame);
  return if4378;
}
Object meth_ast__apply4309(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4312 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4311);
// compiled call node returning call4312 (depth = 8)
// compiled member node returning call4312 (depth = 7)
  int op_slot_right_4310 = gc_frame_newslot(call4312);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4310 = gc_frame_newslot(*var_s);
  params[0] = call4312;
  partcv[0] = 1;
  Object opresult4314 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4314 (depth = 6)
  *var_s = opresult4314;
  if (opresult4314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block4318 = alloc_Block(NULL, NULL, "ast", 964);
  gc_frame_newslot(block4318);
// method "_apply"
  block_savedest(block4318);
  Object closure4319 = createclosure(1, "_apply");
  setclosureframe(closure4319, stackframe);
  addtoclosure(closure4319, selfslot);
  struct UserObject *uo4319 = (struct UserObject*)block4318;
  uo4319->data[0] = (Object)closure4319;
  Method *meth_meth_ast__apply4319 = addmethod2pos(block4318, "_apply", &meth_ast__apply4319, 0);
  int argcv_meth_ast__apply4319[] = {0};
  meth_meth_ast__apply4319->type = alloc_MethodType(1, argcv_meth_ast__apply4319);
  meth_meth_ast__apply4319->definitionModule = modulename;
  meth_meth_ast__apply4319->definitionLine = 963;
// compiled block node returning block4318 (depth = 7)
  int op_slot_right_4317 = gc_frame_newslot(block4318);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  int op_slot_left_4317 = gc_frame_newslot(*var_firstPart);
  params[0] = block4318;
  partcv[0] = 1;
  Object opresult4328 = callmethod(*var_firstPart, "&&", 1, partcv, params);
// compiled op node returning opresult4328 (depth = 6)
  Object if4316 = done;
  if (istrue(opresult4328)) {
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4330 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4332 = alloc_Float64(1);
// compiled num node returning num4332 (depth = 10)
  int op_slot_right_4331 = gc_frame_newslot(num4332);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4331 = gc_frame_newslot(*var_depth);
  params[0] = num4332;
  partcv[0] = 1;
  Object sum4334 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4334 (depth = 9)
  gc_frame_newslot(sum4334);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4335 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4336 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4335);
// compiled call node returning call4336 (depth = 10)
// compiled member node returning call4336 (depth = 9)
  params[0] = sum4334;
  partcv[0] = 1;
  Object call4337 = callmethod(call4336, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4330);
// compiled call node returning call4337 (depth = 8)
  int op_slot_right_4329 = gc_frame_newslot(call4337);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4329 = gc_frame_newslot(*var_s);
  params[0] = call4337;
  partcv[0] = 1;
  Object opresult4339 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4339 (depth = 7)
  *var_s = opresult4339;
  if (opresult4339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4316 = done;
  } else {
  }
// compiled if node returning if4316 (depth = 5)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4341 = alloc_Boolean(0);
// compiled identifier node returning bool4341 (depth = 6)
  *var_firstPart = bool4341;
  if (bool4341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4345 = alloc_Float64(0);
// compiled num node returning num4345 (depth = 7)
  int op_slot_right_4344 = gc_frame_newslot(num4345);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4347 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4349 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4348);
// compiled call node returning call4349 (depth = 10)
// compiled member node returning call4349 (depth = 9)
  partcv[0] = 0;
  Object call4350 = callmethod(call4349, "size",
    1, partcv, params);
  gc_frame_end(callframe4347);
// compiled call node returning call4350 (depth = 8)
// compiled member node returning call4350 (depth = 7)
  int op_slot_left_4344 = gc_frame_newslot(call4350);
  params[0] = num4345;
  partcv[0] = 1;
  Object opresult4351 = callmethod(call4350, ">", 1, partcv, params);
// compiled op node returning opresult4351 (depth = 6)
  Object if4343 = done;
  if (istrue(opresult4351)) {
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4353 == NULL) {
    strlit4353 = alloc_String("(");
    gc_root(strlit4353);
  }
// compiled string node returning strlit4353 (depth = 8)
  int op_slot_right_4352 = gc_frame_newslot(strlit4353);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4352 = gc_frame_newslot(*var_s);
  params[0] = strlit4353;
  partcv[0] = 1;
  Object opresult4355 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4355 (depth = 7)
  *var_s = opresult4355;
  if (opresult4355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4357 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4358 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4360 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4360 (depth = 10)
// compiled member node returning call4360 (depth = 9)
  partcv[0] = 0;
  Object call4361 = callmethod(call4360, "indices",
    1, partcv, params);
  gc_frame_end(callframe4358);
// compiled call node returning call4361 (depth = 8)
// compiled member node returning call4361 (depth = 7)
  gc_frame_newslot(call4361);
// starting to compile block node (depth = 7)
  Object block4362 = alloc_Block(NULL, NULL, "ast", 970);
  gc_frame_newslot(block4362);
// method "_apply"
  block_savedest(block4362);
  Object closure4363 = createclosure(4, "_apply");
  setclosureframe(closure4363, stackframe);
  addtoclosure(closure4363, var_part);
  addtoclosure(closure4363, var_depth);
  addtoclosure(closure4363, var_s);
  addtoclosure(closure4363, selfslot);
  struct UserObject *uo4363 = (struct UserObject*)block4362;
  uo4363->data[0] = (Object)closure4363;
  Method *meth_meth_ast__apply4363 = addmethod2pos(block4362, "_apply", &meth_ast__apply4363, 0);
  int argcv_meth_ast__apply4363[] = {1};
  meth_meth_ast__apply4363->type = alloc_MethodType(1, argcv_meth_ast__apply4363);
  meth_meth_ast__apply4363->definitionModule = modulename;
  meth_meth_ast__apply4363->definitionLine = 970;
// compiled block node returning block4362 (depth = 7)
  gc_frame_newslot(block4362);
// call case 5: prelude request
  params[0] = call4361;
  params[1] = block4362;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4392 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4357);
// compiled call node returning call4392 (depth = 6)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4394 == NULL) {
    strlit4394 = alloc_String(")");
    gc_root(strlit4394);
  }
// compiled string node returning strlit4394 (depth = 8)
  int op_slot_right_4393 = gc_frame_newslot(strlit4394);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4393 = gc_frame_newslot(*var_s);
  params[0] = strlit4394;
  partcv[0] = 1;
  Object opresult4396 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4396 (depth = 7)
  *var_s = opresult4396;
  if (opresult4396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4343 = done;
  } else {
  }
// compiled if node returning if4343 (depth = 5)
  gc_frame_end(frame);
  return if4343;
}
Object meth_ast__apply4441(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4443 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4444 = alloc_Float64(0);
// compiled num node returning num4444 (depth = 10)
  gc_frame_newslot(num4444);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num4444;
  partcv[0] = 1;
  Object call4445 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4443);
// compiled call node returning call4445 (depth = 9)
  int op_slot_right_4442 = gc_frame_newslot(call4445);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4449 == NULL) {
    strlit4449 = alloc_String("");
    gc_root(strlit4449);
  }
// compiled string node returning strlit4449 (depth = 11)
  int op_slot_right_4448 = gc_frame_newslot(strlit4449);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4448 = gc_frame_newslot(*var_a);
  params[0] = strlit4449;
  partcv[0] = 1;
  Object opresult4451 = callmethod(*var_a, "≠", 1, partcv, params);
// compiled op node returning opresult4451 (depth = 10)
  Object if4447 = done;
struct StackFrameObject *iftmpstackframe4447 = stackframe;
  if (istrue(opresult4451)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4447);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4453 == NULL) {
    strlit4453 = alloc_String(", ");
    gc_root(strlit4453);
  }
// compiled string node returning strlit4453 (depth = 11)
  int op_slot_right_4452 = gc_frame_newslot(strlit4453);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_4452 = gc_frame_newslot(*var_a);
  params[0] = strlit4453;
  partcv[0] = 1;
  Object opresult4455 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult4455 (depth = 10)
    gc_frame_newslot(opresult4455);
    if4447 = opresult4455;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4447);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit4456 == NULL) {
    strlit4456 = alloc_String("");
    gc_root(strlit4456);
  }
// compiled string node returning strlit4456 (depth = 10)
    gc_frame_newslot(strlit4456);
    if4447 = strlit4456;
  }
stackframe = iftmpstackframe4447;
// compiled if node returning if4447 (depth = 9)
  int op_slot_left_4442 = gc_frame_newslot(if4447);
  params[0] = call4445;
  partcv[0] = 1;
  Object opresult4457 = callmethod(if4447, "++", 1, partcv, params);
// compiled op node returning opresult4457 (depth = 8)
  gc_frame_end(frame);
  return opresult4457;
}
Object meth_ast__apply4494(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4496 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4498 = alloc_Float64(1);
// compiled num node returning num4498 (depth = 9)
  int op_slot_right_4497 = gc_frame_newslot(num4498);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4497 = gc_frame_newslot(*var_depth);
  params[0] = num4498;
  partcv[0] = 1;
  Object sum4500 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4500 (depth = 8)
  gc_frame_newslot(sum4500);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = sum4500;
  partcv[0] = 1;
  Object call4501 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4496);
// compiled call node returning call4501 (depth = 7)
  int op_slot_right_4495 = gc_frame_newslot(call4501);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4504 == NULL) {
    strlit4504 = alloc_String("    ");
    gc_root(strlit4504);
  }
// compiled string node returning strlit4504 (depth = 8)
  int op_slot_right_4503 = gc_frame_newslot(strlit4504);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4506 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4509 == NULL) {
    strlit4509 = alloc_String("""\x0a""");
    gc_root(strlit4509);
  }
// compiled string node returning strlit4509 (depth = 10)
  int op_slot_right_4508 = gc_frame_newslot(strlit4509);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4508 = gc_frame_newslot(*var_s);
  params[0] = strlit4509;
  partcv[0] = 1;
  Object opresult4511 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4511 (depth = 9)
  int op_slot_left_4506 = gc_frame_newslot(opresult4511);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4512 = callmethod(opresult4511, "++", 1, partcv, params);
// compiled op node returning opresult4512 (depth = 8)
  int op_slot_left_4503 = gc_frame_newslot(opresult4512);
  params[0] = strlit4504;
  partcv[0] = 1;
  Object opresult4513 = callmethod(opresult4512, "++", 1, partcv, params);
// compiled op node returning opresult4513 (depth = 7)
  int op_slot_left_4495 = gc_frame_newslot(opresult4513);
  params[0] = call4501;
  partcv[0] = 1;
  Object opresult4514 = callmethod(opresult4513, "++", 1, partcv, params);
// compiled op node returning opresult4514 (depth = 6)
  *var_s = opresult4514;
  if (opresult4514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace4283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4284 == NULL) {
    strlit4284 = alloc_String("");
    gc_root(strlit4284);
  }
// compiled string node returning strlit4284 (depth = 4)
  *var_spc = strlit4284;
  if (strlit4284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4285 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4288 = alloc_Float64(1);
// compiled num node returning num4288 (depth = 6)
  int op_slot_right_4287 = gc_frame_newslot(num4288);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_4287 = gc_frame_newslot(*var_depth);
  params[0] = num4288;
  partcv[0] = 1;
  Object diff4290 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff4290 (depth = 5)
  int op_slot_right_4286 = gc_frame_newslot(diff4290);
// starting to compile num node (depth = 5)
  Object num4292 = alloc_Float64(0);
// compiled num node returning num4292 (depth = 5)
  int op_slot_left_4286 = gc_frame_newslot(num4292);
  params[0] = diff4290;
  partcv[0] = 1;
  Object opresult4293 = callmethod(num4292, "..", 1, partcv, params);
// compiled op node returning opresult4293 (depth = 4)
  gc_frame_newslot(opresult4293);
// starting to compile block node (depth = 4)
  Object block4294 = alloc_Block(NULL, NULL, "ast", 957);
  gc_frame_newslot(block4294);
// method "_apply"
  block_savedest(block4294);
  Object closure4295 = createclosure(2, "_apply");
  setclosureframe(closure4295, stackframe);
  addtoclosure(closure4295, var_spc);
  addtoclosure(closure4295, selfslot);
  struct UserObject *uo4295 = (struct UserObject*)block4294;
  uo4295->data[0] = (Object)closure4295;
  Method *meth_meth_ast__apply4295 = addmethod2pos(block4294, "_apply", &meth_ast__apply4295, 0);
  int argcv_meth_ast__apply4295[] = {1};
  meth_meth_ast__apply4295->type = alloc_MethodType(1, argcv_meth_ast__apply4295);
  meth_meth_ast__apply4295->definitionModule = modulename;
  meth_meth_ast__apply4295->definitionLine = 951;
// compiled block node returning block4294 (depth = 4)
  gc_frame_newslot(block4294);
// call case 5: prelude request
  params[0] = opresult4293;
  params[1] = block4294;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4302 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4285);
// compiled call node returning call4302 (depth = 3)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4303 == NULL) {
    strlit4303 = alloc_String("method ");
    gc_root(strlit4303);
  }
// compiled string node returning strlit4303 (depth = 4)
  *var_s = strlit4303;
  if (strlit4303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4304 = alloc_Boolean(1);
// compiled identifier node returning bool4304 (depth = 4)
  *var_firstPart = bool4304;
  if (bool4304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4305 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4306 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4307 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4306);
// compiled call node returning call4307 (depth = 5)
// compiled member node returning call4307 (depth = 4)
  gc_frame_newslot(call4307);
// starting to compile block node (depth = 4)
  Object block4308 = alloc_Block(NULL, NULL, "ast", 962);
  gc_frame_newslot(block4308);
// method "_apply"
  block_savedest(block4308);
  Object closure4309 = createclosure(4, "_apply");
  setclosureframe(closure4309, stackframe);
  addtoclosure(closure4309, var_s);
  addtoclosure(closure4309, var_firstPart);
  addtoclosure(closure4309, var_depth);
  addtoclosure(closure4309, selfslot);
  struct UserObject *uo4309 = (struct UserObject*)block4308;
  uo4309->data[0] = (Object)closure4309;
  Method *meth_meth_ast__apply4309 = addmethod2pos(block4308, "_apply", &meth_ast__apply4309, 0);
  int argcv_meth_ast__apply4309[] = {1};
  meth_meth_ast__apply4309->type = alloc_MethodType(1, argcv_meth_ast__apply4309);
  meth_meth_ast__apply4309->definitionModule = modulename;
  meth_meth_ast__apply4309->definitionLine = 962;
// compiled block node returning block4308 (depth = 4)
  gc_frame_newslot(block4308);
// call case 5: prelude request
  params[0] = call4307;
  params[1] = block4308;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4399 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4305);
// compiled call node returning call4399 (depth = 3)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4403 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4402);
// compiled call node returning call4403 (depth = 6)
// compiled member node returning call4403 (depth = 5)
  int op_slot_right_4401 = gc_frame_newslot(call4403);
// starting to compile identifier node (depth = 5)
  Object bool4405 = alloc_Boolean(0);
// compiled identifier node returning bool4405 (depth = 5)
  int op_slot_left_4401 = gc_frame_newslot(bool4405);
  params[0] = call4403;
  partcv[0] = 1;
  Object opresult4406 = callmethod(bool4405, "≠", 1, partcv, params);
// compiled op node returning opresult4406 (depth = 4)
  Object if4400 = done;
  if (istrue(opresult4406)) {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4409 == NULL) {
    strlit4409 = alloc_String("");
    gc_root(strlit4409);
  }
// compiled string node returning strlit4409 (depth = 7)
  int op_slot_right_4408 = gc_frame_newslot(strlit4409);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4412 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4413 = alloc_Float64(0);
// compiled num node returning num4413 (depth = 9)
  gc_frame_newslot(num4413);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4415 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4414);
// compiled call node returning call4415 (depth = 10)
// compiled member node returning call4415 (depth = 9)
  params[0] = num4413;
  partcv[0] = 1;
  Object call4416 = callmethod(call4415, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4412);
// compiled call node returning call4416 (depth = 8)
  int op_slot_right_4411 = gc_frame_newslot(call4416);
// starting to compile string node (depth = 8)
  if (strlit4418 == NULL) {
    strlit4418 = alloc_String(" -> ");
    gc_root(strlit4418);
  }
// compiled string node returning strlit4418 (depth = 8)
  int op_slot_left_4411 = gc_frame_newslot(strlit4418);
  params[0] = call4416;
  partcv[0] = 1;
  Object opresult4419 = callmethod(strlit4418, "++", 1, partcv, params);
// compiled op node returning opresult4419 (depth = 7)
  int op_slot_left_4408 = gc_frame_newslot(opresult4419);
  params[0] = strlit4409;
  partcv[0] = 1;
  Object opresult4420 = callmethod(opresult4419, "++", 1, partcv, params);
// compiled op node returning opresult4420 (depth = 6)
  int op_slot_right_4407 = gc_frame_newslot(opresult4420);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4407 = gc_frame_newslot(*var_s);
  params[0] = opresult4420;
  partcv[0] = 1;
  Object opresult4422 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4422 (depth = 5)
  *var_s = opresult4422;
  if (opresult4422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4400 = done;
  } else {
  }
// compiled if node returning if4400 (depth = 3)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4426 = alloc_Float64(0);
// compiled num node returning num4426 (depth = 5)
  int op_slot_right_4425 = gc_frame_newslot(num4426);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4428 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4430 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4429);
// compiled call node returning call4430 (depth = 8)
// compiled member node returning call4430 (depth = 7)
  partcv[0] = 0;
  Object call4431 = callmethod(call4430, "size",
    1, partcv, params);
  gc_frame_end(callframe4428);
// compiled call node returning call4431 (depth = 6)
// compiled member node returning call4431 (depth = 5)
  int op_slot_left_4425 = gc_frame_newslot(call4431);
  params[0] = num4426;
  partcv[0] = 1;
  Object opresult4432 = callmethod(call4431, ">", 1, partcv, params);
// compiled op node returning opresult4432 (depth = 4)
  Object if4424 = done;
  if (istrue(opresult4432)) {
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4434 == NULL) {
    strlit4434 = alloc_String(" is ");
    gc_root(strlit4434);
  }
// compiled string node returning strlit4434 (depth = 6)
  int op_slot_right_4433 = gc_frame_newslot(strlit4434);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4433 = gc_frame_newslot(*var_s);
  params[0] = strlit4434;
  partcv[0] = 1;
  Object opresult4436 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4436 (depth = 5)
  *var_s = opresult4436;
  if (opresult4436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4439 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4440 = alloc_Block(NULL, NULL, "ast", 985);
  gc_frame_newslot(block4440);
// method "_apply"
  block_savedest(block4440);
  Object closure4441 = createclosure(1, "_apply");
  setclosureframe(closure4441, stackframe);
  addtoclosure(closure4441, selfslot);
  struct UserObject *uo4441 = (struct UserObject*)block4440;
  uo4441->data[0] = (Object)closure4441;
  Method *meth_meth_ast__apply4441 = addmethod2pos(block4440, "_apply", &meth_ast__apply4441, 0);
  int argcv_meth_ast__apply4441[] = {2};
  meth_meth_ast__apply4441->type = alloc_MethodType(1, argcv_meth_ast__apply4441);
  meth_meth_ast__apply4441->definitionModule = modulename;
  meth_meth_ast__apply4441->definitionLine = 983;
// compiled block node returning block4440 (depth = 7)
  gc_frame_newslot(block4440);
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4459 == NULL) {
    strlit4459 = alloc_String("");
    gc_root(strlit4459);
  }
// compiled string node returning strlit4459 (depth = 7)
  gc_frame_newslot(strlit4459);
// call case 6: other member request
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4461 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4460);
// compiled call node returning call4461 (depth = 8)
// compiled member node returning call4461 (depth = 7)
  params[0] = block4440;
  params[1] = strlit4459;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4462 = callmethod(call4461, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe4439);
// compiled call node returning call4462 (depth = 6)
  int op_slot_right_4438 = gc_frame_newslot(call4462);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4438 = gc_frame_newslot(*var_s);
  params[0] = call4462;
  partcv[0] = 1;
  Object opresult4464 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 5)
  *var_s = opresult4464;
  if (opresult4464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4424 = done;
  } else {
  }
// compiled if node returning if4424 (depth = 3)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4467 == NULL) {
    strlit4467 = alloc_String(" {");
    gc_root(strlit4467);
  }
// compiled string node returning strlit4467 (depth = 5)
  int op_slot_right_4466 = gc_frame_newslot(strlit4467);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4466 = gc_frame_newslot(*var_s);
  params[0] = strlit4467;
  partcv[0] = 1;
  Object opresult4469 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4469 (depth = 4)
  *var_s = opresult4469;
  if (opresult4469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4473 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4474 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4473);
// compiled call node returning call4474 (depth = 6)
// compiled member node returning call4474 (depth = 5)
  int op_slot_right_4472 = gc_frame_newslot(call4474);
// starting to compile identifier node (depth = 5)
  Object bool4476 = alloc_Boolean(0);
// compiled identifier node returning bool4476 (depth = 5)
  int op_slot_left_4472 = gc_frame_newslot(bool4476);
  params[0] = call4474;
  partcv[0] = 1;
  Object opresult4477 = callmethod(bool4476, "≠", 1, partcv, params);
// compiled op node returning opresult4477 (depth = 4)
  Object if4471 = done;
  if (istrue(opresult4477)) {
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4479 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4481 = alloc_Float64(1);
// compiled num node returning num4481 (depth = 8)
  int op_slot_right_4480 = gc_frame_newslot(num4481);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_4480 = gc_frame_newslot(*var_depth);
  params[0] = num4481;
  partcv[0] = 1;
  Object sum4483 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4483 (depth = 7)
  gc_frame_newslot(sum4483);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4485 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4484);
// compiled call node returning call4485 (depth = 8)
// compiled member node returning call4485 (depth = 7)
  params[0] = sum4483;
  partcv[0] = 1;
  Object call4486 = callmethod(call4485, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4479);
// compiled call node returning call4486 (depth = 6)
  int op_slot_right_4478 = gc_frame_newslot(call4486);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4478 = gc_frame_newslot(*var_s);
  params[0] = call4486;
  partcv[0] = 1;
  Object opresult4488 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4488 (depth = 5)
  *var_s = opresult4488;
  if (opresult4488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if4471 = done;
  } else {
  }
// compiled if node returning if4471 (depth = 3)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4490 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4492 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4491);
// compiled call node returning call4492 (depth = 5)
// compiled member node returning call4492 (depth = 4)
  gc_frame_newslot(call4492);
// starting to compile block node (depth = 4)
  Object block4493 = alloc_Block(NULL, NULL, "ast", 993);
  gc_frame_newslot(block4493);
// method "_apply"
  block_savedest(block4493);
  Object closure4494 = createclosure(4, "_apply");
  setclosureframe(closure4494, stackframe);
  addtoclosure(closure4494, var_depth);
  addtoclosure(closure4494, var_spc);
  addtoclosure(closure4494, var_s);
  addtoclosure(closure4494, selfslot);
  struct UserObject *uo4494 = (struct UserObject*)block4493;
  uo4494->data[0] = (Object)closure4494;
  Method *meth_meth_ast__apply4494 = addmethod2pos(block4493, "_apply", &meth_ast__apply4494, 0);
  int argcv_meth_ast__apply4494[] = {1};
  meth_meth_ast__apply4494->type = alloc_MethodType(1, argcv_meth_ast__apply4494);
  meth_meth_ast__apply4494->definitionModule = modulename;
  meth_meth_ast__apply4494->definitionLine = 993;
// compiled block node returning block4493 (depth = 4)
  gc_frame_newslot(block4493);
// call case 5: prelude request
  params[0] = call4492;
  params[1] = block4493;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4517 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4490);
// compiled call node returning call4517 (depth = 3)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4519 == NULL) {
    strlit4519 = alloc_String("}");
    gc_root(strlit4519);
  }
// compiled string node returning strlit4519 (depth = 5)
  int op_slot_right_4518 = gc_frame_newslot(strlit4519);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4521 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4524 == NULL) {
    strlit4524 = alloc_String("""\x0a""");
    gc_root(strlit4524);
  }
// compiled string node returning strlit4524 (depth = 7)
  int op_slot_right_4523 = gc_frame_newslot(strlit4524);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4523 = gc_frame_newslot(*var_s);
  params[0] = strlit4524;
  partcv[0] = 1;
  Object opresult4526 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4526 (depth = 6)
  int op_slot_left_4521 = gc_frame_newslot(opresult4526);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4527 = callmethod(opresult4526, "++", 1, partcv, params);
// compiled op node returning opresult4527 (depth = 5)
  int op_slot_left_4518 = gc_frame_newslot(opresult4527);
  params[0] = strlit4519;
  partcv[0] = 1;
  Object opresult4528 = callmethod(opresult4527, "++", 1, partcv, params);
// compiled op node returning opresult4528 (depth = 4)
  *var_s = opresult4528;
  if (opresult4528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy4530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4531 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe4532 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4533 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4534 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4533);
// compiled call node returning call4534 (depth = 6)
// compiled member node returning call4534 (depth = 5)
  gc_frame_newslot(call4534);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4536 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4535);
// compiled call node returning call4536 (depth = 6)
// compiled member node returning call4536 (depth = 5)
  gc_frame_newslot(call4536);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4538 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4537);
// compiled call node returning call4538 (depth = 6)
// compiled member node returning call4538 (depth = 5)
  gc_frame_newslot(call4538);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4539 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4540 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4539);
// compiled call node returning call4540 (depth = 6)
// compiled member node returning call4540 (depth = 5)
  gc_frame_newslot(call4540);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodNode (depth = 5)
  params[0] = call4534;
  params[1] = call4536;
  params[2] = call4538;
  params[3] = call4540;
  partcv[0] = 4;
  Object call4541 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4532);
// compiled call node returning call4541 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call4542 = callmethod(call4541, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe4531);
// compiled call node returning call4542 (depth = 3)
  gc_frame_end(frame);
  return call4542;
}
Object meth_ast_shallowCopyFieldsFrom4543(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4544 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call4545 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4544);
// compiled call node returning call4545 (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4546 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call4548 = callmethod(*var_other, "isFresh",
    1, partcv, params);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 5)
// compiled member node returning call4548 (depth = 4)
  gc_frame_newslot(call4548);
// call case 4: self request
  params[0] = call4548;
  partcv[0] = 1;
  Object call4549 = callmethodflags(self, "isFresh:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4546);
// compiled call node returning call4549 (depth = 3)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4550 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call4552 = callmethod(*var_other, "selfclosure",
    1, partcv, params);
  gc_frame_end(callframe4551);
// compiled call node returning call4552 (depth = 5)
// compiled member node returning call4552 (depth = 4)
  gc_frame_newslot(call4552);
// call case 4: self request
  params[0] = call4552;
  partcv[0] = 1;
  Object call4553 = callmethodflags(self, "selfclosure:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4550);
// compiled call node returning call4553 (depth = 3)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new3637(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3638 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3638 = alloc_userobj2(41,33, objclass3638);
  gc_frame_newslot(obj3638);
if (objclass3638 == NULL) {
  glfree(obj3638->class->name);
  obj3638->class->name = "methodNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3638, self, 0);
  addmethodreal(obj3638,"outer", &reader_ast_outer_3639);
  Object oldself3638 = self;
  struct StackFrameObject *oldstackframe3638 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3638);
  gc_frame_newslot((Object)stackframe);
  self = obj3638;
  Object *oldselfslot3638 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3638 = (*(struct UserObject *)self).data[0], lowerouter3638 = thisouter3638;
  if (inheritingObject3638) {
    struct UserObject *inho3638 = (struct UserObject *)inheritingObject3638;
    while (inho3638->super != GraceDefaultObject) inho3638 = (struct UserObject *)inho3638->super;
    inho3638->super = obj3638;
    self = inheritingObject3638;
    *selfslot = self;
    lowerouter3638 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3638;
  }
if (objclass3638 == NULL) {
  Method *reader3640 = addmethodrealflags(obj3638, "kind",&reader_ast_kind_3640, MFLAG_DEF);
  reader3640->definitionModule = modulename;
  reader3640->definitionLine = 819;
}
adddatum2(obj3638, alloc_Undefined(), 1);
if (objclass3638 == NULL) {
  Method *reader3641 = addmethodrealflags(obj3638, "value",&reader_ast_value_3641, 0);
  Method *writer3641 = addmethodrealflags(obj3638, "value:=",&writer_ast_value_3641, 0);
  reader3641->definitionModule = modulename;
  writer3641->definitionModule = modulename;
  reader3641->definitionLine = 820;
  writer3641->definitionLine = 820;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 2);
if (objclass3638 == NULL) {
  Method *reader3642 = addmethodrealflags(obj3638, "signature",&reader_ast_signature_3642, 0);
  Method *writer3642 = addmethodrealflags(obj3638, "signature:=",&writer_ast_signature_3642, 0);
  reader3642->definitionModule = modulename;
  writer3642->definitionModule = modulename;
  reader3642->definitionLine = 821;
  writer3642->definitionLine = 821;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 3);
if (objclass3638 == NULL) {
  Method *reader3643 = addmethodrealflags(obj3638, "body",&reader_ast_body_3643, 0);
  Method *writer3643 = addmethodrealflags(obj3638, "body:=",&writer_ast_body_3643, 0);
  reader3643->definitionModule = modulename;
  writer3643->definitionModule = modulename;
  reader3643->definitionLine = 822;
  writer3643->definitionLine = 822;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 4);
if (objclass3638 == NULL) {
  Method *reader3644 = addmethodrealflags(obj3638, "dtype",&reader_ast_dtype_3644, 0);
  Method *writer3644 = addmethodrealflags(obj3638, "dtype:=",&writer_ast_dtype_3644, 0);
  reader3644->definitionModule = modulename;
  writer3644->definitionModule = modulename;
  reader3644->definitionLine = 823;
  writer3644->definitionLine = 823;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 5);
if (objclass3638 == NULL) {
  Method *reader3645 = addmethodrealflags(obj3638, "typeParams",&reader_ast_typeParams_3645, 0);
  Method *writer3645 = addmethodrealflags(obj3638, "typeParams:=",&writer_ast_typeParams_3645, 0);
  reader3645->definitionModule = modulename;
  writer3645->definitionModule = modulename;
  reader3645->definitionLine = 824;
  writer3645->definitionLine = 824;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 6);
if (objclass3638 == NULL) {
  Method *reader3646 = addmethodrealflags(obj3638, "selfclosure",&reader_ast_selfclosure_3646, 0);
  Method *writer3646 = addmethodrealflags(obj3638, "selfclosure:=",&writer_ast_selfclosure_3646, 0);
  reader3646->definitionModule = modulename;
  writer3646->definitionModule = modulename;
  reader3646->definitionLine = 825;
  writer3646->definitionLine = 825;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 7);
if (objclass3638 == NULL) {
  Method *reader3647 = addmethodrealflags(obj3638, "nameString",&reader_ast_nameString_3647, MFLAG_DEF);
  reader3647->definitionModule = modulename;
  reader3647->definitionLine = 826;
}
adddatum2(obj3638, alloc_Undefined(), 8);
if (objclass3638 == NULL) {
  Method *reader3648 = addmethodrealflags(obj3638, "annotations",&reader_ast_annotations_3648, 0);
  Method *writer3648 = addmethodrealflags(obj3638, "annotations:=",&writer_ast_annotations_3648, 0);
  reader3648->definitionModule = modulename;
  writer3648->definitionModule = modulename;
  reader3648->definitionLine = 827;
  writer3648->definitionLine = 827;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 9);
if (objclass3638 == NULL) {
  Method *reader3649 = addmethodrealflags(obj3638, "isFresh",&reader_ast_isFresh_3649, 0);
  Method *writer3649 = addmethodrealflags(obj3638, "isFresh:=",&writer_ast_isFresh_3649, 0);
  reader3649->definitionModule = modulename;
  writer3649->definitionModule = modulename;
  reader3649->definitionLine = 828;
  writer3649->definitionLine = 828;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 10);
if (objclass3638 == NULL) {
  Method *reader3650 = addmethodrealflags(obj3638, "usesClassSyntax",&reader_ast_usesClassSyntax_3650, 0);
  Method *writer3650 = addmethodrealflags(obj3638, "usesClassSyntax:=",&writer_ast_usesClassSyntax_3650, 0);
  reader3650->definitionModule = modulename;
  writer3650->definitionModule = modulename;
  reader3650->definitionLine = 829;
  writer3650->definitionLine = 829;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 11);
// method "isMethod"
  struct UserObject *uo3651 = (struct UserObject*)obj3638;
  uo3651->data[12] = emptyclosure;
  Method *meth_meth_ast_isMethod3651 = addmethod2pos(obj3638, "isMethod", &meth_ast_isMethod3651, 12);
  int argcv_meth_ast_isMethod3651[] = {0};
  meth_meth_ast_isMethod3651->type = alloc_MethodType(1, argcv_meth_ast_isMethod3651);
  meth_meth_ast_isMethod3651->definitionModule = modulename;
  meth_meth_ast_isMethod3651->definitionLine = 831;
// method "isExecutable"
  struct UserObject *uo3653 = (struct UserObject*)obj3638;
  uo3653->data[13] = emptyclosure;
  Method *meth_meth_ast_isExecutable3653 = addmethod2pos(obj3638, "isExecutable", &meth_ast_isExecutable3653, 13);
  int argcv_meth_ast_isExecutable3653[] = {0};
  meth_meth_ast_isExecutable3653->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3653);
  meth_meth_ast_isExecutable3653->definitionModule = modulename;
  meth_meth_ast_isExecutable3653->definitionLine = 832;
// method "isLegalInTrait"
  struct UserObject *uo3655 = (struct UserObject*)obj3638;
  uo3655->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3655 = addmethod2pos(obj3638, "isLegalInTrait", &meth_ast_isLegalInTrait3655, 14);
  int argcv_meth_ast_isLegalInTrait3655[] = {0};
  meth_meth_ast_isLegalInTrait3655->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3655);
  meth_meth_ast_isLegalInTrait3655->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3655->definitionLine = 833;
// method "isClass"
  struct UserObject *uo3657 = (struct UserObject*)obj3638;
  uo3657->data[15] = emptyclosure;
  Method *meth_meth_ast_isClass3657 = addmethod2pos(obj3638, "isClass", &meth_ast_isClass3657, 15);
  int argcv_meth_ast_isClass3657[] = {0};
  meth_meth_ast_isClass3657->type = alloc_MethodType(1, argcv_meth_ast_isClass3657);
  meth_meth_ast_isClass3657->definitionModule = modulename;
  meth_meth_ast_isClass3657->definitionLine = 834;
// method "isTrait"
  struct UserObject *uo3665 = (struct UserObject*)obj3638;
  uo3665->data[16] = emptyclosure;
  Method *meth_meth_ast_isTrait3665 = addmethod2pos(obj3638, "isTrait", &meth_ast_isTrait3665, 16);
  int argcv_meth_ast_isTrait3665[] = {0};
  meth_meth_ast_isTrait3665->type = alloc_MethodType(1, argcv_meth_ast_isTrait3665);
  meth_meth_ast_isTrait3665->definitionModule = modulename;
  meth_meth_ast_isTrait3665->definitionLine = 835;
// method "needsArgChecks"
  struct UserObject *uo3676 = (struct UserObject*)obj3638;
  uo3676->data[17] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3676 = addmethod2pos(obj3638, "needsArgChecks", &meth_ast_needsArgChecks3676, 17);
  int argcv_meth_ast_needsArgChecks3676[] = {0};
  meth_meth_ast_needsArgChecks3676->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3676);
  meth_meth_ast_needsArgChecks3676->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3676->definitionLine = 842;
// method "scope:="
  struct UserObject *uo3714 = (struct UserObject*)obj3638;
  uo3714->data[18] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3714 = addmethod2pos(obj3638, "scope:=", &meth_ast_scope_58__61_3714, 18);
  int argcv_meth_ast_scope_58__61_3714[] = {1};
  meth_meth_ast_scope_58__61_3714->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3714);
  meth_meth_ast_scope_58__61_3714->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3714->definitionLine = 853;
// method "declarationKindWithAncestors"
  block_savedest(obj3638);
  Object closure3719 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3719, stackframe);
  addtoclosure(closure3719, var_k);
  struct UserObject *uo3719 = (struct UserObject*)obj3638;
  uo3719->data[19] = (Object)closure3719;
  Method *meth_meth_ast_declarationKindWithAncestors3719 = addmethod2pos(obj3638, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3719, 19);
  int argcv_meth_ast_declarationKindWithAncestors3719[] = {1};
  meth_meth_ast_declarationKindWithAncestors3719->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3719);
  meth_meth_ast_declarationKindWithAncestors3719->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3719->definitionLine = 859;
// method "isConfidential"
  struct UserObject *uo3722 = (struct UserObject*)obj3638;
  uo3722->data[20] = emptyclosure;
  Method *meth_meth_ast_isConfidential3722 = addmethod2pos(obj3638, "isConfidential", &meth_ast_isConfidential3722, 20);
  int argcv_meth_ast_isConfidential3722[] = {0};
  meth_meth_ast_isConfidential3722->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3722);
  meth_meth_ast_isConfidential3722->definitionModule = modulename;
  meth_meth_ast_isConfidential3722->definitionLine = 860;
// method "isPublic"
  struct UserObject *uo3740 = (struct UserObject*)obj3638;
  uo3740->data[21] = emptyclosure;
  Method *meth_meth_ast_isPublic3740 = addmethod2pos(obj3638, "isPublic", &meth_ast_isPublic3740, 21);
  int argcv_meth_ast_isPublic3740[] = {0};
  meth_meth_ast_isPublic3740->type = alloc_MethodType(1, argcv_meth_ast_isPublic3740);
  meth_meth_ast_isPublic3740->definitionModule = modulename;
  meth_meth_ast_isPublic3740->definitionLine = 864;
// method "isWritable"
  struct UserObject *uo3745 = (struct UserObject*)obj3638;
  uo3745->data[22] = emptyclosure;
  Method *meth_meth_ast_isWritable3745 = addmethod2pos(obj3638, "isWritable", &meth_ast_isWritable3745, 22);
  int argcv_meth_ast_isWritable3745[] = {0};
  meth_meth_ast_isWritable3745->type = alloc_MethodType(1, argcv_meth_ast_isWritable3745);
  meth_meth_ast_isWritable3745->definitionModule = modulename;
  meth_meth_ast_isWritable3745->definitionLine = 865;
// method "isReadable"
  struct UserObject *uo3747 = (struct UserObject*)obj3638;
  uo3747->data[23] = emptyclosure;
  Method *meth_meth_ast_isReadable3747 = addmethod2pos(obj3638, "isReadable", &meth_ast_isReadable3747, 23);
  int argcv_meth_ast_isReadable3747[] = {0};
  meth_meth_ast_isReadable3747->type = alloc_MethodType(1, argcv_meth_ast_isReadable3747);
  meth_meth_ast_isReadable3747->definitionModule = modulename;
  meth_meth_ast_isReadable3747->definitionLine = 866;
// method "usesAsType"
  struct UserObject *uo3750 = (struct UserObject*)obj3638;
  uo3750->data[24] = emptyclosure;
  Method *meth_meth_ast_usesAsType3750 = addmethod2pos(obj3638, "usesAsType", &meth_ast_usesAsType3750, 24);
  int argcv_meth_ast_usesAsType3750[] = {1};
  meth_meth_ast_usesAsType3750->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3750);
  meth_meth_ast_usesAsType3750->definitionModule = modulename;
  meth_meth_ast_usesAsType3750->definitionLine = 867;
// method "returnsObject"
  struct UserObject *uo3756 = (struct UserObject*)obj3638;
  uo3756->data[25] = emptyclosure;
  Method *meth_meth_ast_returnsObject3756 = addmethod2pos(obj3638, "returnsObject", &meth_ast_returnsObject3756, 25);
  int argcv_meth_ast_returnsObject3756[] = {0};
  meth_meth_ast_returnsObject3756->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3756);
  meth_meth_ast_returnsObject3756->definitionModule = modulename;
  meth_meth_ast_returnsObject3756->definitionLine = 870;
// method "returnedObjectScope"
  struct UserObject *uo3775 = (struct UserObject*)obj3638;
  uo3775->data[26] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3775 = addmethod2pos(obj3638, "returnedObjectScope", &meth_ast_returnedObjectScope3775, 26);
  int argcv_meth_ast_returnedObjectScope3775[] = {0};
  meth_meth_ast_returnedObjectScope3775->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3775);
  meth_meth_ast_returnedObjectScope3775->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3775->definitionLine = 873;
// method "accept()from"
  struct UserObject *uo3782 = (struct UserObject*)obj3638;
  uo3782->data[27] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3782 = addmethod2pos(obj3638, "accept()from", &meth_ast_accept_40__41_from3782, 27);
  int argcv_meth_ast_accept_40__41_from3782[] = {1, 1};
  meth_meth_ast_accept_40__41_from3782->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3782);
  meth_meth_ast_accept_40__41_from3782->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3782->definitionLine = 877;
// method "map()ancestors"
  struct UserObject *uo3848 = (struct UserObject*)obj3638;
  uo3848->data[28] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3848 = addmethod2pos(obj3638, "map()ancestors", &meth_ast_map_40__41_ancestors3848, 28);
  int argcv_meth_ast_map_40__41_ancestors3848[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3848->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3848);
  meth_meth_ast_map_40__41_ancestors3848->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3848->definitionLine = 900;
// method "pretty"
  struct UserObject *uo3905 = (struct UserObject*)obj3638;
  uo3905->data[29] = emptyclosure;
  Method *meth_meth_ast_pretty3905 = addmethod2pos(obj3638, "pretty", &meth_ast_pretty3905, 29);
  int argcv_meth_ast_pretty3905[] = {1};
  meth_meth_ast_pretty3905->type = alloc_MethodType(1, argcv_meth_ast_pretty3905);
  meth_meth_ast_pretty3905->definitionModule = modulename;
  meth_meth_ast_pretty3905->definitionLine = 910;
// method "toGrace"
  struct UserObject *uo4283 = (struct UserObject*)obj3638;
  uo4283->data[30] = emptyclosure;
  Method *meth_meth_ast_toGrace4283 = addmethod2pos(obj3638, "toGrace", &meth_ast_toGrace4283, 30);
  int argcv_meth_ast_toGrace4283[] = {1};
  meth_meth_ast_toGrace4283->type = alloc_MethodType(1, argcv_meth_ast_toGrace4283);
meth_meth_ast_toGrace4283->type->types[0] = type_Number;
meth_meth_ast_toGrace4283->type->names[0] = "depth";
  meth_meth_ast_toGrace4283->definitionModule = modulename;
  meth_meth_ast_toGrace4283->definitionLine = 955;
// method "shallowCopy"
  block_savedest(obj3638);
  Object closure4530 = createclosure(1, "shallowCopy");
  setclosureframe(closure4530, stackframe);
  addtoclosure(closure4530, var_methodNode);
  struct UserObject *uo4530 = (struct UserObject*)obj3638;
  uo4530->data[31] = (Object)closure4530;
  Method *meth_meth_ast_shallowCopy4530 = addmethod2pos(obj3638, "shallowCopy", &meth_ast_shallowCopy4530, 31);
  int argcv_meth_ast_shallowCopy4530[] = {0};
  meth_meth_ast_shallowCopy4530->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4530);
  meth_meth_ast_shallowCopy4530->definitionModule = modulename;
  meth_meth_ast_shallowCopy4530->definitionLine = 999;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo4543 = (struct UserObject*)obj3638;
  uo4543->data[32] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4543 = addmethod2pos(obj3638, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4543, 32);
  int argcv_meth_ast_shallowCopyFieldsFrom4543[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4543->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4543);
  meth_meth_ast_shallowCopyFieldsFrom4543->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4543->definitionLine = 1002;
  sourceObject = obj3638;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4554 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4555 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4556 = gc_frame_new();
// call case 3: self.outer request
  Object call4557 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4556);
// compiled call node returning call4557 (depth = 7)
// compiled member node returning call4557 (depth = 6)
  partcv[0] = 0;
  Object call4558 = callmethodflags(call4557, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4555);
// compiled call node returning call4558 (depth = 5)
// compiled member node returning call4558 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4559 = callmethodflags(call4558, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4554);
// compiled call node returning call4559 (depth = 3)
  struct UserObject *obj3638_uo = (struct UserObject *)obj3638;
  obj3638_uo->super = call4559;
  sourceObject = obj3638;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4560 == NULL) {
    strlit4560 = alloc_String("method");
    gc_root(strlit4560);
  }
// compiled string node returning strlit4560 (depth = 3)
  adddatum2(obj3638, strlit4560, 1);
  sourceObject = obj3638;
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3638, *var_name_39_, 2);
  sourceObject = obj3638;
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3638, *var_signature_39_, 3);
  sourceObject = obj3638;
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3638, *var_body_39_, 4);
  sourceObject = obj3638;
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3638, *var_dtype_39_, 5);
  sourceObject = obj3638;
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4561 = alloc_Boolean(0);
// compiled identifier node returning bool4561 (depth = 3)
  adddatum2(obj3638, bool4561, 6);
  sourceObject = obj3638;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4562 = alloc_Boolean(0);
// compiled identifier node returning bool4562 (depth = 3)
  adddatum2(obj3638, bool4562, 7);
  sourceObject = obj3638;
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4563 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4565 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4564);
// compiled call node returning call4565 (depth = 6)
// compiled member node returning call4565 (depth = 5)
  partcv[0] = 0;
  Object call4566 = callmethod(call4565, "value",
    1, partcv, params);
  gc_frame_end(callframe4563);
// compiled call node returning call4566 (depth = 4)
// compiled member node returning call4566 (depth = 3)
  adddatum2(obj3638, call4566, 8);
  sourceObject = obj3638;
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4567 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4567 (depth = 3)
  adddatum2(obj3638, array4567, 9);
  sourceObject = obj3638;
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4568 = alloc_Boolean(0);
// compiled identifier node returning bool4568 (depth = 3)
  adddatum2(obj3638, bool4568, 10);
  sourceObject = obj3638;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4569 = alloc_Boolean(0);
// compiled identifier node returning bool4569 (depth = 3)
  adddatum2(obj3638, bool4569, 11);
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  objclass3638 = obj3638->class;
  objclass3638->definitionModule = modulename;
  objclass3638->definitionLine = 811;
  (*(struct UserObject *)self).data[0] = lowerouter3638;
  self = oldself3638;
  selfslot = oldselfslot3638;
  stackframe = oldstackframe3638;
  gc_frame_end(frame);
  return obj3638;
}
Object meth_ast_new3637_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3638 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3638 = alloc_userobj2(41,33, objclass3638);
  gc_frame_newslot(obj3638);
if (objclass3638 == NULL) {
  glfree(obj3638->class->name);
  obj3638->class->name = "methodNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3638, self, 0);
  addmethodreal(obj3638,"outer", &reader_ast_outer_3639);
  Object oldself3638 = self;
  struct StackFrameObject *oldstackframe3638 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3638);
  gc_frame_newslot((Object)stackframe);
  self = obj3638;
  Object *oldselfslot3638 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3638 = (*(struct UserObject *)self).data[0], lowerouter3638 = thisouter3638;
  if (inheritingObject3638) {
    struct UserObject *inho3638 = (struct UserObject *)inheritingObject3638;
    while (inho3638->super != GraceDefaultObject) inho3638 = (struct UserObject *)inho3638->super;
    inho3638->super = obj3638;
    self = inheritingObject3638;
    *selfslot = self;
    lowerouter3638 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3638;
  }
if (objclass3638 == NULL) {
  Method *reader3640 = addmethodrealflags(obj3638, "kind",&reader_ast_kind_3640, MFLAG_DEF);
  reader3640->definitionModule = modulename;
  reader3640->definitionLine = 819;
}
adddatum2(obj3638, alloc_Undefined(), 1);
if (objclass3638 == NULL) {
  Method *reader3641 = addmethodrealflags(obj3638, "value",&reader_ast_value_3641, 0);
  Method *writer3641 = addmethodrealflags(obj3638, "value:=",&writer_ast_value_3641, 0);
  reader3641->definitionModule = modulename;
  writer3641->definitionModule = modulename;
  reader3641->definitionLine = 820;
  writer3641->definitionLine = 820;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 2);
if (objclass3638 == NULL) {
  Method *reader3642 = addmethodrealflags(obj3638, "signature",&reader_ast_signature_3642, 0);
  Method *writer3642 = addmethodrealflags(obj3638, "signature:=",&writer_ast_signature_3642, 0);
  reader3642->definitionModule = modulename;
  writer3642->definitionModule = modulename;
  reader3642->definitionLine = 821;
  writer3642->definitionLine = 821;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 3);
if (objclass3638 == NULL) {
  Method *reader3643 = addmethodrealflags(obj3638, "body",&reader_ast_body_3643, 0);
  Method *writer3643 = addmethodrealflags(obj3638, "body:=",&writer_ast_body_3643, 0);
  reader3643->definitionModule = modulename;
  writer3643->definitionModule = modulename;
  reader3643->definitionLine = 822;
  writer3643->definitionLine = 822;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 4);
if (objclass3638 == NULL) {
  Method *reader3644 = addmethodrealflags(obj3638, "dtype",&reader_ast_dtype_3644, 0);
  Method *writer3644 = addmethodrealflags(obj3638, "dtype:=",&writer_ast_dtype_3644, 0);
  reader3644->definitionModule = modulename;
  writer3644->definitionModule = modulename;
  reader3644->definitionLine = 823;
  writer3644->definitionLine = 823;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 5);
if (objclass3638 == NULL) {
  Method *reader3645 = addmethodrealflags(obj3638, "typeParams",&reader_ast_typeParams_3645, 0);
  Method *writer3645 = addmethodrealflags(obj3638, "typeParams:=",&writer_ast_typeParams_3645, 0);
  reader3645->definitionModule = modulename;
  writer3645->definitionModule = modulename;
  reader3645->definitionLine = 824;
  writer3645->definitionLine = 824;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 6);
if (objclass3638 == NULL) {
  Method *reader3646 = addmethodrealflags(obj3638, "selfclosure",&reader_ast_selfclosure_3646, 0);
  Method *writer3646 = addmethodrealflags(obj3638, "selfclosure:=",&writer_ast_selfclosure_3646, 0);
  reader3646->definitionModule = modulename;
  writer3646->definitionModule = modulename;
  reader3646->definitionLine = 825;
  writer3646->definitionLine = 825;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 7);
if (objclass3638 == NULL) {
  Method *reader3647 = addmethodrealflags(obj3638, "nameString",&reader_ast_nameString_3647, MFLAG_DEF);
  reader3647->definitionModule = modulename;
  reader3647->definitionLine = 826;
}
adddatum2(obj3638, alloc_Undefined(), 8);
if (objclass3638 == NULL) {
  Method *reader3648 = addmethodrealflags(obj3638, "annotations",&reader_ast_annotations_3648, 0);
  Method *writer3648 = addmethodrealflags(obj3638, "annotations:=",&writer_ast_annotations_3648, 0);
  reader3648->definitionModule = modulename;
  writer3648->definitionModule = modulename;
  reader3648->definitionLine = 827;
  writer3648->definitionLine = 827;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 9);
if (objclass3638 == NULL) {
  Method *reader3649 = addmethodrealflags(obj3638, "isFresh",&reader_ast_isFresh_3649, 0);
  Method *writer3649 = addmethodrealflags(obj3638, "isFresh:=",&writer_ast_isFresh_3649, 0);
  reader3649->definitionModule = modulename;
  writer3649->definitionModule = modulename;
  reader3649->definitionLine = 828;
  writer3649->definitionLine = 828;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 10);
if (objclass3638 == NULL) {
  Method *reader3650 = addmethodrealflags(obj3638, "usesClassSyntax",&reader_ast_usesClassSyntax_3650, 0);
  Method *writer3650 = addmethodrealflags(obj3638, "usesClassSyntax:=",&writer_ast_usesClassSyntax_3650, 0);
  reader3650->definitionModule = modulename;
  writer3650->definitionModule = modulename;
  reader3650->definitionLine = 829;
  writer3650->definitionLine = 829;
}
obj3638->flags |= OFLAG_MUTABLE;
adddatum2(obj3638, alloc_Undefined(), 11);
// method "isMethod"
  struct UserObject *uo3651 = (struct UserObject*)obj3638;
  uo3651->data[12] = emptyclosure;
  Method *meth_meth_ast_isMethod3651 = addmethod2pos(obj3638, "isMethod", &meth_ast_isMethod3651, 12);
  int argcv_meth_ast_isMethod3651[] = {0};
  meth_meth_ast_isMethod3651->type = alloc_MethodType(1, argcv_meth_ast_isMethod3651);
  meth_meth_ast_isMethod3651->definitionModule = modulename;
  meth_meth_ast_isMethod3651->definitionLine = 831;
// method "isExecutable"
  struct UserObject *uo3653 = (struct UserObject*)obj3638;
  uo3653->data[13] = emptyclosure;
  Method *meth_meth_ast_isExecutable3653 = addmethod2pos(obj3638, "isExecutable", &meth_ast_isExecutable3653, 13);
  int argcv_meth_ast_isExecutable3653[] = {0};
  meth_meth_ast_isExecutable3653->type = alloc_MethodType(1, argcv_meth_ast_isExecutable3653);
  meth_meth_ast_isExecutable3653->definitionModule = modulename;
  meth_meth_ast_isExecutable3653->definitionLine = 832;
// method "isLegalInTrait"
  struct UserObject *uo3655 = (struct UserObject*)obj3638;
  uo3655->data[14] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait3655 = addmethod2pos(obj3638, "isLegalInTrait", &meth_ast_isLegalInTrait3655, 14);
  int argcv_meth_ast_isLegalInTrait3655[] = {0};
  meth_meth_ast_isLegalInTrait3655->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait3655);
  meth_meth_ast_isLegalInTrait3655->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait3655->definitionLine = 833;
// method "isClass"
  struct UserObject *uo3657 = (struct UserObject*)obj3638;
  uo3657->data[15] = emptyclosure;
  Method *meth_meth_ast_isClass3657 = addmethod2pos(obj3638, "isClass", &meth_ast_isClass3657, 15);
  int argcv_meth_ast_isClass3657[] = {0};
  meth_meth_ast_isClass3657->type = alloc_MethodType(1, argcv_meth_ast_isClass3657);
  meth_meth_ast_isClass3657->definitionModule = modulename;
  meth_meth_ast_isClass3657->definitionLine = 834;
// method "isTrait"
  struct UserObject *uo3665 = (struct UserObject*)obj3638;
  uo3665->data[16] = emptyclosure;
  Method *meth_meth_ast_isTrait3665 = addmethod2pos(obj3638, "isTrait", &meth_ast_isTrait3665, 16);
  int argcv_meth_ast_isTrait3665[] = {0};
  meth_meth_ast_isTrait3665->type = alloc_MethodType(1, argcv_meth_ast_isTrait3665);
  meth_meth_ast_isTrait3665->definitionModule = modulename;
  meth_meth_ast_isTrait3665->definitionLine = 835;
// method "needsArgChecks"
  struct UserObject *uo3676 = (struct UserObject*)obj3638;
  uo3676->data[17] = emptyclosure;
  Method *meth_meth_ast_needsArgChecks3676 = addmethod2pos(obj3638, "needsArgChecks", &meth_ast_needsArgChecks3676, 17);
  int argcv_meth_ast_needsArgChecks3676[] = {0};
  meth_meth_ast_needsArgChecks3676->type = alloc_MethodType(1, argcv_meth_ast_needsArgChecks3676);
  meth_meth_ast_needsArgChecks3676->definitionModule = modulename;
  meth_meth_ast_needsArgChecks3676->definitionLine = 842;
// method "scope:="
  struct UserObject *uo3714 = (struct UserObject*)obj3638;
  uo3714->data[18] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_3714 = addmethod2pos(obj3638, "scope:=", &meth_ast_scope_58__61_3714, 18);
  int argcv_meth_ast_scope_58__61_3714[] = {1};
  meth_meth_ast_scope_58__61_3714->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_3714);
  meth_meth_ast_scope_58__61_3714->definitionModule = modulename;
  meth_meth_ast_scope_58__61_3714->definitionLine = 853;
// method "declarationKindWithAncestors"
  block_savedest(obj3638);
  Object closure3719 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure3719, stackframe);
  addtoclosure(closure3719, var_k);
  struct UserObject *uo3719 = (struct UserObject*)obj3638;
  uo3719->data[19] = (Object)closure3719;
  Method *meth_meth_ast_declarationKindWithAncestors3719 = addmethod2pos(obj3638, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors3719, 19);
  int argcv_meth_ast_declarationKindWithAncestors3719[] = {1};
  meth_meth_ast_declarationKindWithAncestors3719->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors3719);
  meth_meth_ast_declarationKindWithAncestors3719->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors3719->definitionLine = 859;
// method "isConfidential"
  struct UserObject *uo3722 = (struct UserObject*)obj3638;
  uo3722->data[20] = emptyclosure;
  Method *meth_meth_ast_isConfidential3722 = addmethod2pos(obj3638, "isConfidential", &meth_ast_isConfidential3722, 20);
  int argcv_meth_ast_isConfidential3722[] = {0};
  meth_meth_ast_isConfidential3722->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3722);
  meth_meth_ast_isConfidential3722->definitionModule = modulename;
  meth_meth_ast_isConfidential3722->definitionLine = 860;
// method "isPublic"
  struct UserObject *uo3740 = (struct UserObject*)obj3638;
  uo3740->data[21] = emptyclosure;
  Method *meth_meth_ast_isPublic3740 = addmethod2pos(obj3638, "isPublic", &meth_ast_isPublic3740, 21);
  int argcv_meth_ast_isPublic3740[] = {0};
  meth_meth_ast_isPublic3740->type = alloc_MethodType(1, argcv_meth_ast_isPublic3740);
  meth_meth_ast_isPublic3740->definitionModule = modulename;
  meth_meth_ast_isPublic3740->definitionLine = 864;
// method "isWritable"
  struct UserObject *uo3745 = (struct UserObject*)obj3638;
  uo3745->data[22] = emptyclosure;
  Method *meth_meth_ast_isWritable3745 = addmethod2pos(obj3638, "isWritable", &meth_ast_isWritable3745, 22);
  int argcv_meth_ast_isWritable3745[] = {0};
  meth_meth_ast_isWritable3745->type = alloc_MethodType(1, argcv_meth_ast_isWritable3745);
  meth_meth_ast_isWritable3745->definitionModule = modulename;
  meth_meth_ast_isWritable3745->definitionLine = 865;
// method "isReadable"
  struct UserObject *uo3747 = (struct UserObject*)obj3638;
  uo3747->data[23] = emptyclosure;
  Method *meth_meth_ast_isReadable3747 = addmethod2pos(obj3638, "isReadable", &meth_ast_isReadable3747, 23);
  int argcv_meth_ast_isReadable3747[] = {0};
  meth_meth_ast_isReadable3747->type = alloc_MethodType(1, argcv_meth_ast_isReadable3747);
  meth_meth_ast_isReadable3747->definitionModule = modulename;
  meth_meth_ast_isReadable3747->definitionLine = 866;
// method "usesAsType"
  struct UserObject *uo3750 = (struct UserObject*)obj3638;
  uo3750->data[24] = emptyclosure;
  Method *meth_meth_ast_usesAsType3750 = addmethod2pos(obj3638, "usesAsType", &meth_ast_usesAsType3750, 24);
  int argcv_meth_ast_usesAsType3750[] = {1};
  meth_meth_ast_usesAsType3750->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3750);
  meth_meth_ast_usesAsType3750->definitionModule = modulename;
  meth_meth_ast_usesAsType3750->definitionLine = 867;
// method "returnsObject"
  struct UserObject *uo3756 = (struct UserObject*)obj3638;
  uo3756->data[25] = emptyclosure;
  Method *meth_meth_ast_returnsObject3756 = addmethod2pos(obj3638, "returnsObject", &meth_ast_returnsObject3756, 25);
  int argcv_meth_ast_returnsObject3756[] = {0};
  meth_meth_ast_returnsObject3756->type = alloc_MethodType(1, argcv_meth_ast_returnsObject3756);
  meth_meth_ast_returnsObject3756->definitionModule = modulename;
  meth_meth_ast_returnsObject3756->definitionLine = 870;
// method "returnedObjectScope"
  struct UserObject *uo3775 = (struct UserObject*)obj3638;
  uo3775->data[26] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope3775 = addmethod2pos(obj3638, "returnedObjectScope", &meth_ast_returnedObjectScope3775, 26);
  int argcv_meth_ast_returnedObjectScope3775[] = {0};
  meth_meth_ast_returnedObjectScope3775->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope3775);
  meth_meth_ast_returnedObjectScope3775->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope3775->definitionLine = 873;
// method "accept()from"
  struct UserObject *uo3782 = (struct UserObject*)obj3638;
  uo3782->data[27] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3782 = addmethod2pos(obj3638, "accept()from", &meth_ast_accept_40__41_from3782, 27);
  int argcv_meth_ast_accept_40__41_from3782[] = {1, 1};
  meth_meth_ast_accept_40__41_from3782->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3782);
  meth_meth_ast_accept_40__41_from3782->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3782->definitionLine = 877;
// method "map()ancestors"
  struct UserObject *uo3848 = (struct UserObject*)obj3638;
  uo3848->data[28] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors3848 = addmethod2pos(obj3638, "map()ancestors", &meth_ast_map_40__41_ancestors3848, 28);
  int argcv_meth_ast_map_40__41_ancestors3848[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors3848->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors3848);
  meth_meth_ast_map_40__41_ancestors3848->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors3848->definitionLine = 900;
// method "pretty"
  struct UserObject *uo3905 = (struct UserObject*)obj3638;
  uo3905->data[29] = emptyclosure;
  Method *meth_meth_ast_pretty3905 = addmethod2pos(obj3638, "pretty", &meth_ast_pretty3905, 29);
  int argcv_meth_ast_pretty3905[] = {1};
  meth_meth_ast_pretty3905->type = alloc_MethodType(1, argcv_meth_ast_pretty3905);
  meth_meth_ast_pretty3905->definitionModule = modulename;
  meth_meth_ast_pretty3905->definitionLine = 910;
// method "toGrace"
  struct UserObject *uo4283 = (struct UserObject*)obj3638;
  uo4283->data[30] = emptyclosure;
  Method *meth_meth_ast_toGrace4283 = addmethod2pos(obj3638, "toGrace", &meth_ast_toGrace4283, 30);
  int argcv_meth_ast_toGrace4283[] = {1};
  meth_meth_ast_toGrace4283->type = alloc_MethodType(1, argcv_meth_ast_toGrace4283);
meth_meth_ast_toGrace4283->type->types[0] = type_Number;
meth_meth_ast_toGrace4283->type->names[0] = "depth";
  meth_meth_ast_toGrace4283->definitionModule = modulename;
  meth_meth_ast_toGrace4283->definitionLine = 955;
// method "shallowCopy"
  block_savedest(obj3638);
  Object closure4530 = createclosure(1, "shallowCopy");
  setclosureframe(closure4530, stackframe);
  addtoclosure(closure4530, var_methodNode);
  struct UserObject *uo4530 = (struct UserObject*)obj3638;
  uo4530->data[31] = (Object)closure4530;
  Method *meth_meth_ast_shallowCopy4530 = addmethod2pos(obj3638, "shallowCopy", &meth_ast_shallowCopy4530, 31);
  int argcv_meth_ast_shallowCopy4530[] = {0};
  meth_meth_ast_shallowCopy4530->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy4530);
  meth_meth_ast_shallowCopy4530->definitionModule = modulename;
  meth_meth_ast_shallowCopy4530->definitionLine = 999;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo4543 = (struct UserObject*)obj3638;
  uo4543->data[32] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom4543 = addmethod2pos(obj3638, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom4543, 32);
  int argcv_meth_ast_shallowCopyFieldsFrom4543[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom4543->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom4543);
  meth_meth_ast_shallowCopyFieldsFrom4543->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom4543->definitionLine = 1002;
  sourceObject = obj3638;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4554 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4555 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4556 = gc_frame_new();
// call case 3: self.outer request
  Object call4557 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4556);
// compiled call node returning call4557 (depth = 7)
// compiled member node returning call4557 (depth = 6)
  partcv[0] = 0;
  Object call4558 = callmethodflags(call4557, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4555);
// compiled call node returning call4558 (depth = 5)
// compiled member node returning call4558 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4559 = callmethodflags(call4558, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4554);
// compiled call node returning call4559 (depth = 3)
  struct UserObject *obj3638_uo = (struct UserObject *)obj3638;
  obj3638_uo->super = call4559;
  sourceObject = obj3638;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit4560 == NULL) {
    strlit4560 = alloc_String("method");
    gc_root(strlit4560);
  }
// compiled string node returning strlit4560 (depth = 3)
  adddatum2(obj3638, strlit4560, 1);
  sourceObject = obj3638;
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj3638, *var_name_39_, 2);
  sourceObject = obj3638;
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature_39_ (depth = 3)
  adddatum2(obj3638, *var_signature_39_, 3);
  sourceObject = obj3638;
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_body_39_ (depth = 3)
  adddatum2(obj3638, *var_body_39_, 4);
  sourceObject = obj3638;
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj3638, *var_dtype_39_, 5);
  sourceObject = obj3638;
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4561 = alloc_Boolean(0);
// compiled identifier node returning bool4561 (depth = 3)
  adddatum2(obj3638, bool4561, 6);
  sourceObject = obj3638;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4562 = alloc_Boolean(0);
// compiled identifier node returning bool4562 (depth = 3)
  adddatum2(obj3638, bool4562, 7);
  sourceObject = obj3638;
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4563 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4565 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4564);
// compiled call node returning call4565 (depth = 6)
// compiled member node returning call4565 (depth = 5)
  partcv[0] = 0;
  Object call4566 = callmethod(call4565, "value",
    1, partcv, params);
  gc_frame_end(callframe4563);
// compiled call node returning call4566 (depth = 4)
// compiled member node returning call4566 (depth = 3)
  adddatum2(obj3638, call4566, 8);
  sourceObject = obj3638;
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4567 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4567 (depth = 3)
  adddatum2(obj3638, array4567, 9);
  sourceObject = obj3638;
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4568 = alloc_Boolean(0);
// compiled identifier node returning bool4568 (depth = 3)
  adddatum2(obj3638, bool4568, 10);
  sourceObject = obj3638;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4569 = alloc_Boolean(0);
// compiled identifier node returning bool4569 (depth = 3)
  adddatum2(obj3638, bool4569, 11);
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  sourceObject = obj3638;
  objclass3638 = obj3638->class;
  objclass3638->definitionModule = modulename;
  objclass3638->definitionLine = 811;
  (*(struct UserObject *)self).data[0] = lowerouter3638;
  self = oldself3638;
  selfslot = oldselfslot3638;
  stackframe = oldstackframe3638;
  gc_frame_end(frame);
  return obj3638;
}
Object meth_ast_methodNode4571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methodNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_new_40__41_scope4574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with = &(stackframe->slots[1]);
  *var_with = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4575 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_what (depth = 5)
  gc_frame_newslot(*var_what);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_with (depth = 5)
  gc_frame_newslot(*var_with);
// call case 4: self request
  params[0] = *var_what;
  params[1] = *var_with;
  partcv[0] = 2;
  Object call4576 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4575);
// compiled call node returning call4576 (depth = 4)
  *var_result = call4576;
  if (call4576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4577 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call4578 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe4577);
// compiled call node returning call4578 (depth = 3)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target4588(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4589 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4590 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4589);
// compiled call node returning call4590 (depth = 4)
// compiled member node returning call4590 (depth = 3)
  gc_frame_end(frame);
  return call4590;
}
Object meth_ast_isCall4591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4592 = alloc_Boolean(1);
// compiled identifier node returning bool4592 (depth = 3)
  gc_frame_end(frame);
  return bool4592;
}
Object meth_ast_returnsObject4593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4595 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4596 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4597 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4598 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4597);
// compiled call node returning call4598 (depth = 9)
// compiled member node returning call4598 (depth = 8)
  partcv[0] = 0;
  Object call4599 = callmethod(call4598, "isMember",
    1, partcv, params);
  gc_frame_end(callframe4596);
// compiled call node returning call4599 (depth = 7)
// compiled member node returning call4599 (depth = 6)
  partcv[0] = 0;
  Object call4600 = callmethod(call4599, "not",
    1, partcv, params);
  gc_frame_end(callframe4595);
// compiled call node returning call4600 (depth = 5)
// compiled member node returning call4600 (depth = 4)
  Object if4594 = done;
  if (istrue(call4600)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4601 = alloc_Boolean(0);
// compiled identifier node returning bool4601 (depth = 5)
  return bool4601;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4594 = undefined;
  } else {
  }
// compiled if node returning if4594 (depth = 3)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("clone");
    gc_root(strlit4604);
  }
// compiled string node returning strlit4604 (depth = 5)
  int op_slot_right_4603 = gc_frame_newslot(strlit4604);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4606 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4608 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4607);
// compiled call node returning call4608 (depth = 8)
// compiled member node returning call4608 (depth = 7)
  partcv[0] = 0;
  Object call4609 = callmethod(call4608, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4606);
// compiled call node returning call4609 (depth = 6)
// compiled member node returning call4609 (depth = 5)
  int op_slot_left_4603 = gc_frame_newslot(call4609);
  params[0] = strlit4604;
  partcv[0] = 1;
  Object opresult4610 = callmethod(call4609, "==", 1, partcv, params);
// compiled op node returning opresult4610 (depth = 4)
  Object if4602 = done;
  if (istrue(opresult4610)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4611 = alloc_Boolean(1);
// compiled identifier node returning bool4611 (depth = 5)
  return bool4611;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4602 = undefined;
  } else {
  }
// compiled if node returning if4602 (depth = 3)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4614 == NULL) {
    strlit4614 = alloc_String("copy");
    gc_root(strlit4614);
  }
// compiled string node returning strlit4614 (depth = 5)
  int op_slot_right_4613 = gc_frame_newslot(strlit4614);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4616 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4617 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4618 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4617);
// compiled call node returning call4618 (depth = 8)
// compiled member node returning call4618 (depth = 7)
  partcv[0] = 0;
  Object call4619 = callmethod(call4618, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4616);
// compiled call node returning call4619 (depth = 6)
// compiled member node returning call4619 (depth = 5)
  int op_slot_left_4613 = gc_frame_newslot(call4619);
  params[0] = strlit4614;
  partcv[0] = 1;
  Object opresult4620 = callmethod(call4619, "==", 1, partcv, params);
// compiled op node returning opresult4620 (depth = 4)
  Object if4612 = done;
  if (istrue(opresult4620)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4621 = alloc_Boolean(1);
// compiled identifier node returning bool4621 (depth = 5)
  return bool4621;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4612 = undefined;
  } else {
  }
// compiled if node returning if4612 (depth = 3)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4622 = alloc_Boolean(0);
// compiled identifier node returning bool4622 (depth = 4)
  return bool4622;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_returnedObjectScope4623(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4625 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled call node returning call4625 (depth = 4)
// compiled member node returning call4625 (depth = 3)
  gc_frame_end(frame);
  return call4625;
}
Object meth_ast__apply4645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4646 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newChain (depth = 9)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4647 = callmethod(*var_arg, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4646);
// compiled call node returning call4647 (depth = 8)
  gc_frame_end(frame);
  return call4647;
}
Object meth_ast__apply4640(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4641 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4643 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4642);
// compiled call node returning call4643 (depth = 8)
// compiled member node returning call4643 (depth = 7)
  gc_frame_newslot(call4643);
// starting to compile block node (depth = 7)
  Object block4644 = alloc_Block(NULL, NULL, "ast", 1059);
  gc_frame_newslot(block4644);
// method "_apply"
  block_savedest(block4644);
  Object closure4645 = createclosure(3, "_apply");
  setclosureframe(closure4645, stackframe);
  addtoclosure(closure4645, var_visitor);
  addtoclosure(closure4645, var_newChain);
  addtoclosure(closure4645, selfslot);
  struct UserObject *uo4645 = (struct UserObject*)block4644;
  uo4645->data[0] = (Object)closure4645;
  Method *meth_meth_ast__apply4645 = addmethod2pos(block4644, "_apply", &meth_ast__apply4645, 0);
  int argcv_meth_ast__apply4645[] = {1};
  meth_meth_ast__apply4645->type = alloc_MethodType(1, argcv_meth_ast__apply4645);
  meth_meth_ast__apply4645->definitionModule = modulename;
  meth_meth_ast__apply4645->definitionLine = 1059;
// compiled block node returning block4644 (depth = 7)
  gc_frame_newslot(block4644);
// call case 5: prelude request
  params[0] = call4643;
  params[1] = block4644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4649 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4641);
// compiled call node returning call4649 (depth = 6)
  gc_frame_end(frame);
  return call4649;
}
Object meth_ast__apply4661(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4662 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4663 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4662);
// compiled call node returning call4663 (depth = 7)
  gc_frame_end(frame);
  return call4663;
}
Object meth_ast_accept_40__41_from4626(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4628 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4629 = callmethod(*var_visitor, "visitCall()up",
    2, partcv, params);
  gc_frame_end(callframe4628);
// compiled call node returning call4629 (depth = 4)
  Object if4627 = done;
  if (istrue(call4629)) {
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4630 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call4631 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4630);
// compiled call node returning call4631 (depth = 5)
  *var_newChain = call4631;
  if (call4631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4632 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4634 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4633);
// compiled call node returning call4634 (depth = 6)
// compiled member node returning call4634 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4635 = callmethod(call4634, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4632);
// compiled call node returning call4635 (depth = 4)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4636 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4638 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4637);
// compiled call node returning call4638 (depth = 6)
// compiled member node returning call4638 (depth = 5)
  gc_frame_newslot(call4638);
// starting to compile block node (depth = 5)
  Object block4639 = alloc_Block(NULL, NULL, "ast", 1058);
  gc_frame_newslot(block4639);
// method "_apply"
  block_savedest(block4639);
  Object closure4640 = createclosure(3, "_apply");
  setclosureframe(closure4640, stackframe);
  addtoclosure(closure4640, var_visitor);
  addtoclosure(closure4640, var_newChain);
  addtoclosure(closure4640, selfslot);
  struct UserObject *uo4640 = (struct UserObject*)block4639;
  uo4640->data[0] = (Object)closure4640;
  Method *meth_meth_ast__apply4640 = addmethod2pos(block4639, "_apply", &meth_ast__apply4640, 0);
  int argcv_meth_ast__apply4640[] = {1};
  meth_meth_ast__apply4640->type = alloc_MethodType(1, argcv_meth_ast__apply4640);
  meth_meth_ast__apply4640->definitionModule = modulename;
  meth_meth_ast__apply4640->definitionLine = 1058;
// compiled block node returning block4639 (depth = 5)
  gc_frame_newslot(block4639);
// call case 5: prelude request
  params[0] = call4638;
  params[1] = block4639;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4651 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4636);
// compiled call node returning call4651 (depth = 4)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4655 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4654);
// compiled call node returning call4655 (depth = 7)
// compiled member node returning call4655 (depth = 6)
  int op_slot_right_4653 = gc_frame_newslot(call4655);
// starting to compile identifier node (depth = 6)
  Object bool4657 = alloc_Boolean(0);
// compiled identifier node returning bool4657 (depth = 6)
  int op_slot_left_4653 = gc_frame_newslot(bool4657);
  params[0] = call4655;
  partcv[0] = 1;
  Object opresult4658 = callmethod(bool4657, "≠", 1, partcv, params);
// compiled op node returning opresult4658 (depth = 5)
  Object if4652 = done;
  if (istrue(opresult4658)) {
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4659 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4660 = alloc_Block(NULL, NULL, "ast", 1064);
  gc_frame_newslot(block4660);
// method "_apply"
  block_savedest(block4660);
  Object closure4661 = createclosure(3, "_apply");
  setclosureframe(closure4661, stackframe);
  addtoclosure(closure4661, var_visitor);
  addtoclosure(closure4661, var_newChain);
  addtoclosure(closure4661, selfslot);
  struct UserObject *uo4661 = (struct UserObject*)block4660;
  uo4661->data[0] = (Object)closure4661;
  Method *meth_meth_ast__apply4661 = addmethod2pos(block4660, "_apply", &meth_ast__apply4661, 0);
  int argcv_meth_ast__apply4661[] = {1};
  meth_meth_ast__apply4661->type = alloc_MethodType(1, argcv_meth_ast__apply4661);
  meth_meth_ast__apply4661->definitionModule = modulename;
  meth_meth_ast__apply4661->definitionLine = 1063;
// compiled block node returning block4660 (depth = 6)
  gc_frame_newslot(block4660);
// call case 6: other member request
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4665 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4666 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4665);
// compiled call node returning call4666 (depth = 7)
// compiled member node returning call4666 (depth = 6)
  params[0] = block4660;
  partcv[0] = 1;
  Object call4667 = callmethod(call4666, "do",
    1, partcv, params);
  gc_frame_end(callframe4659);
// compiled call node returning call4667 (depth = 5)
    gc_frame_newslot(call4667);
    if4652 = call4667;
  } else {
  }
// compiled if node returning if4652 (depth = 4)
    gc_frame_newslot(if4652);
    if4627 = if4652;
  } else {
  }
// compiled if node returning if4627 (depth = 3)
  gc_frame_end(frame);
  return if4627;
}
Object meth_ast_map_40__41_ancestors4668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4670 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4669);
// compiled call node returning call4670 (depth = 5)
// compiled member node returning call4670 (depth = 4)
  *var_n = call4670;
  if (call4670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4671 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4672 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe4671);
// compiled call node returning call4672 (depth = 4)
  *var_newChain = call4672;
  if (call4672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4673 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4674 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4676 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4675);
// compiled call node returning call4676 (depth = 6)
// compiled member node returning call4676 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4677 = callmethod(call4676, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe4674);
// compiled call node returning call4677 (depth = 4)
  gc_frame_newslot(call4677);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4677;
  partcv[0] = 1;
  Object call4678 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe4673);
// compiled call node returning call4678 (depth = 3)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4679 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4680 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4682 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4681);
// compiled call node returning call4682 (depth = 6)
// compiled member node returning call4682 (depth = 5)
  gc_frame_newslot(call4682);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4683 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4684 = gc_frame_new();
// call case 3: self.outer request
  Object call4685 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4684);
// compiled call node returning call4685 (depth = 8)
// compiled member node returning call4685 (depth = 7)
  partcv[0] = 0;
  Object call4686 = callmethodflags(call4685, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4683);
// compiled call node returning call4686 (depth = 6)
// compiled member node returning call4686 (depth = 5)
  params[0] = call4682;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4687 = callmethodflags(call4686, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4680);
// compiled call node returning call4687 (depth = 4)
  gc_frame_newslot(call4687);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4687;
  partcv[0] = 1;
  Object call4688 = callmethod(*var_n, "with:=",
    1, partcv, params);
  gc_frame_end(callframe4679);
// compiled call node returning call4688 (depth = 3)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4689 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe4690 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4691 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4692 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4691);
// compiled call node returning call4692 (depth = 6)
// compiled member node returning call4692 (depth = 5)
  gc_frame_newslot(call4692);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4693 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4694 = gc_frame_new();
// call case 3: self.outer request
  Object call4695 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4694);
// compiled call node returning call4695 (depth = 8)
// compiled member node returning call4695 (depth = 7)
  partcv[0] = 0;
  Object call4696 = callmethodflags(call4695, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4693);
// compiled call node returning call4696 (depth = 6)
// compiled member node returning call4696 (depth = 5)
  params[0] = call4692;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4697 = callmethodflags(call4696, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4690);
// compiled call node returning call4697 (depth = 4)
  gc_frame_newslot(call4697);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call4697;
  partcv[0] = 1;
  Object call4698 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe4689);
// compiled call node returning call4698 (depth = 3)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4699 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call4700 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4699);
// compiled call node returning call4700 (depth = 3)
  gc_frame_end(frame);
  return call4700;
}
Object meth_ast__apply4709(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4711 == NULL) {
    strlit4711 = alloc_String("  ");
    gc_root(strlit4711);
  }
// compiled string node returning strlit4711 (depth = 7)
  int op_slot_right_4710 = gc_frame_newslot(strlit4711);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4710 = gc_frame_newslot(*var_spc);
  params[0] = strlit4711;
  partcv[0] = 1;
  Object opresult4713 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4713 (depth = 6)
  *var_spc = opresult4713;
  if (opresult4713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4770(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4772 == NULL) {
    strlit4772 = alloc_String("""\x0a""");
    gc_root(strlit4772);
  }
// compiled string node returning strlit4772 (depth = 8)
  int op_slot_right_4771 = gc_frame_newslot(strlit4772);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4775 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4777 = alloc_Float64(2);
// compiled num node returning num4777 (depth = 11)
  int op_slot_right_4776 = gc_frame_newslot(num4777);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4776 = gc_frame_newslot(*var_depth);
  params[0] = num4777;
  partcv[0] = 1;
  Object sum4779 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4779 (depth = 10)
  gc_frame_newslot(sum4779);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum4779;
  partcv[0] = 1;
  Object call4780 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4775);
// compiled call node returning call4780 (depth = 9)
  int op_slot_right_4774 = gc_frame_newslot(call4780);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4783 == NULL) {
    strlit4783 = alloc_String("    ");
    gc_root(strlit4783);
  }
// compiled string node returning strlit4783 (depth = 10)
  int op_slot_right_4782 = gc_frame_newslot(strlit4783);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4785 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4785 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4787 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4787 (depth = 10)
  int op_slot_left_4782 = gc_frame_newslot(opresult4787);
  params[0] = strlit4783;
  partcv[0] = 1;
  Object opresult4788 = callmethod(opresult4787, "++", 1, partcv, params);
// compiled op node returning opresult4788 (depth = 9)
  int op_slot_left_4774 = gc_frame_newslot(opresult4788);
  params[0] = call4780;
  partcv[0] = 1;
  Object opresult4789 = callmethod(opresult4788, "++", 1, partcv, params);
// compiled op node returning opresult4789 (depth = 8)
  int op_slot_left_4771 = gc_frame_newslot(opresult4789);
  params[0] = strlit4772;
  partcv[0] = 1;
  Object opresult4790 = callmethod(opresult4789, "++", 1, partcv, params);
// compiled op node returning opresult4790 (depth = 7)
  *var_s = opresult4790;
  if (opresult4790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4828(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4830 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num4832 = alloc_Float64(2);
// compiled num node returning num4832 (depth = 11)
  int op_slot_right_4831 = gc_frame_newslot(num4832);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_4831 = gc_frame_newslot(*var_depth);
  params[0] = num4832;
  partcv[0] = 1;
  Object sum4834 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4834 (depth = 10)
  gc_frame_newslot(sum4834);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = sum4834;
  partcv[0] = 1;
  Object call4835 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4830);
// compiled call node returning call4835 (depth = 9)
  int op_slot_right_4829 = gc_frame_newslot(call4835);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4837 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String("""\x0a""      ");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 11)
  int op_slot_right_4839 = gc_frame_newslot(strlit4840);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4839 = gc_frame_newslot(*var_s);
  params[0] = strlit4840;
  partcv[0] = 1;
  Object opresult4842 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4842 (depth = 10)
  int op_slot_left_4837 = gc_frame_newslot(opresult4842);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4843 = callmethod(opresult4842, "++", 1, partcv, params);
// compiled op node returning opresult4843 (depth = 9)
  int op_slot_left_4829 = gc_frame_newslot(opresult4843);
  params[0] = call4835;
  partcv[0] = 1;
  Object opresult4844 = callmethod(opresult4843, "++", 1, partcv, params);
// compiled op node returning opresult4844 (depth = 8)
  *var_s = opresult4844;
  if (opresult4844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4806(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4809 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4808);
// compiled call node returning call4809 (depth = 8)
// compiled member node returning call4809 (depth = 7)
  int op_slot_right_4807 = gc_frame_newslot(call4809);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4812 == NULL) {
    strlit4812 = alloc_String("Part: ");
    gc_root(strlit4812);
  }
// compiled string node returning strlit4812 (depth = 8)
  int op_slot_right_4811 = gc_frame_newslot(strlit4812);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_4814 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4817 == NULL) {
    strlit4817 = alloc_String("""\x0a""  ");
    gc_root(strlit4817);
  }
// compiled string node returning strlit4817 (depth = 10)
  int op_slot_right_4816 = gc_frame_newslot(strlit4817);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4816 = gc_frame_newslot(*var_s);
  params[0] = strlit4817;
  partcv[0] = 1;
  Object opresult4819 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4819 (depth = 9)
  int op_slot_left_4814 = gc_frame_newslot(opresult4819);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4820 = callmethod(opresult4819, "++", 1, partcv, params);
// compiled op node returning opresult4820 (depth = 8)
  int op_slot_left_4811 = gc_frame_newslot(opresult4820);
  params[0] = strlit4812;
  partcv[0] = 1;
  Object opresult4821 = callmethod(opresult4820, "++", 1, partcv, params);
// compiled op node returning opresult4821 (depth = 7)
  int op_slot_left_4807 = gc_frame_newslot(opresult4821);
  params[0] = call4809;
  partcv[0] = 1;
  Object opresult4822 = callmethod(opresult4821, "++", 1, partcv, params);
// compiled op node returning opresult4822 (depth = 6)
  *var_s = opresult4822;
  if (opresult4822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4824 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call4826 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4825);
// compiled call node returning call4826 (depth = 7)
// compiled member node returning call4826 (depth = 6)
  gc_frame_newslot(call4826);
// starting to compile block node (depth = 6)
  Object block4827 = alloc_Block(NULL, NULL, "ast", 1095);
  gc_frame_newslot(block4827);
// method "_apply"
  block_savedest(block4827);
  Object closure4828 = createclosure(4, "_apply");
  setclosureframe(closure4828, stackframe);
  addtoclosure(closure4828, var_depth);
  addtoclosure(closure4828, var_spc);
  addtoclosure(closure4828, var_s);
  addtoclosure(closure4828, selfslot);
  struct UserObject *uo4828 = (struct UserObject*)block4827;
  uo4828->data[0] = (Object)closure4828;
  Method *meth_meth_ast__apply4828 = addmethod2pos(block4827, "_apply", &meth_ast__apply4828, 0);
  int argcv_meth_ast__apply4828[] = {1};
  meth_meth_ast__apply4828->type = alloc_MethodType(1, argcv_meth_ast__apply4828);
  meth_meth_ast__apply4828->definitionModule = modulename;
  meth_meth_ast__apply4828->definitionLine = 1095;
// compiled block node returning block4827 (depth = 6)
  gc_frame_newslot(block4827);
// call case 5: prelude request
  params[0] = call4826;
  params[1] = block4827;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4847 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4824);
// compiled call node returning call4847 (depth = 5)
  gc_frame_end(frame);
  return call4847;
}
Object meth_ast_pretty4701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4702 == NULL) {
    strlit4702 = alloc_String("");
    gc_root(strlit4702);
  }
// compiled string node returning strlit4702 (depth = 4)
  *var_spc = strlit4702;
  if (strlit4702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4703 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_4704 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num4706 = alloc_Float64(0);
// compiled num node returning num4706 (depth = 5)
  int op_slot_left_4704 = gc_frame_newslot(num4706);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4707 = callmethod(num4706, "..", 1, partcv, params);
// compiled op node returning opresult4707 (depth = 4)
  gc_frame_newslot(opresult4707);
// starting to compile block node (depth = 4)
  Object block4708 = alloc_Block(NULL, NULL, "ast", 1080);
  gc_frame_newslot(block4708);
// method "_apply"
  block_savedest(block4708);
  Object closure4709 = createclosure(2, "_apply");
  setclosureframe(closure4709, stackframe);
  addtoclosure(closure4709, var_spc);
  addtoclosure(closure4709, selfslot);
  struct UserObject *uo4709 = (struct UserObject*)block4708;
  uo4709->data[0] = (Object)closure4709;
  Method *meth_meth_ast__apply4709 = addmethod2pos(block4708, "_apply", &meth_ast__apply4709, 0);
  int argcv_meth_ast__apply4709[] = {1};
  meth_meth_ast__apply4709->type = alloc_MethodType(1, argcv_meth_ast__apply4709);
  meth_meth_ast__apply4709->definitionModule = modulename;
  meth_meth_ast__apply4709->definitionLine = 1075;
// compiled block node returning block4708 (depth = 4)
  gc_frame_newslot(block4708);
// call case 5: prelude request
  params[0] = opresult4707;
  params[1] = block4708;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4716 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4703);
// compiled call node returning call4716 (depth = 3)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4718 == NULL) {
    strlit4718 = alloc_String("""\x0a""");
    gc_root(strlit4718);
  }
// compiled string node returning strlit4718 (depth = 5)
  int op_slot_right_4717 = gc_frame_newslot(strlit4718);
// starting to compile call node (depth = 5)
  int callframe4720 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4721 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4720);
// compiled call node returning call4721 (depth = 5)
  int op_slot_left_4717 = gc_frame_newslot(call4721);
  params[0] = strlit4718;
  partcv[0] = 1;
  Object opresult4722 = callmethod(call4721, "++", 1, partcv, params);
// compiled op node returning opresult4722 (depth = 4)
  *var_s = opresult4722;
  if (opresult4722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4725 == NULL) {
    strlit4725 = alloc_String("");
    gc_root(strlit4725);
  }
// compiled string node returning strlit4725 (depth = 6)
  int op_slot_right_4724 = gc_frame_newslot(strlit4725);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4728 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4730 = alloc_Float64(1);
// compiled num node returning num4730 (depth = 9)
  int op_slot_right_4729 = gc_frame_newslot(num4730);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_4729 = gc_frame_newslot(*var_depth);
  params[0] = num4730;
  partcv[0] = 1;
  Object sum4732 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4732 (depth = 8)
  gc_frame_newslot(sum4732);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4733 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4734 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4733);
// compiled call node returning call4734 (depth = 9)
// compiled member node returning call4734 (depth = 8)
  params[0] = sum4732;
  partcv[0] = 1;
  Object call4735 = callmethod(call4734, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4728);
// compiled call node returning call4735 (depth = 7)
  int op_slot_right_4727 = gc_frame_newslot(call4735);
// starting to compile string node (depth = 7)
  if (strlit4737 == NULL) {
    strlit4737 = alloc_String("Method Name: ");
    gc_root(strlit4737);
  }
// compiled string node returning strlit4737 (depth = 7)
  int op_slot_left_4727 = gc_frame_newslot(strlit4737);
  params[0] = call4735;
  partcv[0] = 1;
  Object opresult4738 = callmethod(strlit4737, "++", 1, partcv, params);
// compiled op node returning opresult4738 (depth = 6)
  int op_slot_left_4724 = gc_frame_newslot(opresult4738);
  params[0] = strlit4725;
  partcv[0] = 1;
  Object opresult4739 = callmethod(opresult4738, "++", 1, partcv, params);
// compiled op node returning opresult4739 (depth = 5)
  int op_slot_right_4723 = gc_frame_newslot(opresult4739);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4741 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4741 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4743 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4743 (depth = 5)
  int op_slot_left_4723 = gc_frame_newslot(opresult4743);
  params[0] = opresult4739;
  partcv[0] = 1;
  Object opresult4744 = callmethod(opresult4743, "++", 1, partcv, params);
// compiled op node returning opresult4744 (depth = 4)
  *var_s = opresult4744;
  if (opresult4744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4747 == NULL) {
    strlit4747 = alloc_String("""\x0a""");
    gc_root(strlit4747);
  }
// compiled string node returning strlit4747 (depth = 5)
  int op_slot_right_4746 = gc_frame_newslot(strlit4747);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_4746 = gc_frame_newslot(*var_s);
  params[0] = strlit4747;
  partcv[0] = 1;
  Object opresult4749 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4749 (depth = 4)
  *var_s = opresult4749;
  if (opresult4749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4754 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4753);
// compiled call node returning call4754 (depth = 6)
// compiled member node returning call4754 (depth = 5)
  int op_slot_right_4752 = gc_frame_newslot(call4754);
// starting to compile identifier node (depth = 5)
  Object bool4756 = alloc_Boolean(0);
// compiled identifier node returning bool4756 (depth = 5)
  int op_slot_left_4752 = gc_frame_newslot(bool4756);
  params[0] = call4754;
  partcv[0] = 1;
  Object opresult4757 = callmethod(bool4756, "≠", 1, partcv, params);
// compiled op node returning opresult4757 (depth = 4)
  Object if4751 = done;
  if (istrue(opresult4757)) {
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4759 == NULL) {
    strlit4759 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit4759);
  }
// compiled string node returning strlit4759 (depth = 6)
  int op_slot_right_4758 = gc_frame_newslot(strlit4759);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4761 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4761 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4763 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4763 (depth = 6)
  int op_slot_left_4758 = gc_frame_newslot(opresult4763);
  params[0] = strlit4759;
  partcv[0] = 1;
  Object opresult4764 = callmethod(opresult4763, "++", 1, partcv, params);
// compiled op node returning opresult4764 (depth = 5)
  *var_s = opresult4764;
  if (opresult4764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4766 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4767 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4768 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4767);
// compiled call node returning call4768 (depth = 6)
// compiled member node returning call4768 (depth = 5)
  gc_frame_newslot(call4768);
// starting to compile block node (depth = 5)
  Object block4769 = alloc_Block(NULL, NULL, "ast", 1088);
  gc_frame_newslot(block4769);
// method "_apply"
  block_savedest(block4769);
  Object closure4770 = createclosure(4, "_apply");
  setclosureframe(closure4770, stackframe);
  addtoclosure(closure4770, var_depth);
  addtoclosure(closure4770, var_spc);
  addtoclosure(closure4770, var_s);
  addtoclosure(closure4770, selfslot);
  struct UserObject *uo4770 = (struct UserObject*)block4769;
  uo4770->data[0] = (Object)closure4770;
  Method *meth_meth_ast__apply4770 = addmethod2pos(block4769, "_apply", &meth_ast__apply4770, 0);
  int argcv_meth_ast__apply4770[] = {1};
  meth_meth_ast__apply4770->type = alloc_MethodType(1, argcv_meth_ast__apply4770);
  meth_meth_ast__apply4770->definitionModule = modulename;
  meth_meth_ast__apply4770->definitionLine = 1088;
// compiled block node returning block4769 (depth = 5)
  gc_frame_newslot(block4769);
// call case 5: prelude request
  params[0] = call4768;
  params[1] = block4769;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4793 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4766);
// compiled call node returning call4793 (depth = 4)
    gc_frame_newslot(call4793);
    if4751 = call4793;
  } else {
  }
// compiled if node returning if4751 (depth = 3)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4795 == NULL) {
    strlit4795 = alloc_String("Arguments:");
    gc_root(strlit4795);
  }
// compiled string node returning strlit4795 (depth = 5)
  int op_slot_right_4794 = gc_frame_newslot(strlit4795);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_4797 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4797 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4799 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4799 (depth = 5)
  int op_slot_left_4794 = gc_frame_newslot(opresult4799);
  params[0] = strlit4795;
  partcv[0] = 1;
  Object opresult4800 = callmethod(opresult4799, "++", 1, partcv, params);
// compiled op node returning opresult4800 (depth = 4)
  *var_s = opresult4800;
  if (opresult4800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4802 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4804 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4803);
// compiled call node returning call4804 (depth = 5)
// compiled member node returning call4804 (depth = 4)
  gc_frame_newslot(call4804);
// starting to compile block node (depth = 4)
  Object block4805 = alloc_Block(NULL, NULL, "ast", 1093);
  gc_frame_newslot(block4805);
// method "_apply"
  block_savedest(block4805);
  Object closure4806 = createclosure(4, "_apply");
  setclosureframe(closure4806, stackframe);
  addtoclosure(closure4806, var_spc);
  addtoclosure(closure4806, var_s);
  addtoclosure(closure4806, var_depth);
  addtoclosure(closure4806, selfslot);
  struct UserObject *uo4806 = (struct UserObject*)block4805;
  uo4806->data[0] = (Object)closure4806;
  Method *meth_meth_ast__apply4806 = addmethod2pos(block4805, "_apply", &meth_ast__apply4806, 0);
  int argcv_meth_ast__apply4806[] = {1};
  meth_meth_ast__apply4806->type = alloc_MethodType(1, argcv_meth_ast__apply4806);
  meth_meth_ast__apply4806->definitionModule = modulename;
  meth_meth_ast__apply4806->definitionLine = 1093;
// compiled block node returning block4805 (depth = 4)
  gc_frame_newslot(block4805);
// call case 5: prelude request
  params[0] = call4804;
  params[1] = block4805;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4849 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4802);
// compiled call node returning call4849 (depth = 3)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4854(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4856 == NULL) {
    strlit4856 = alloc_String("    ");
    gc_root(strlit4856);
  }
// compiled string node returning strlit4856 (depth = 7)
  int op_slot_right_4855 = gc_frame_newslot(strlit4856);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_4855 = gc_frame_newslot(*var_spc);
  params[0] = strlit4856;
  partcv[0] = 1;
  Object opresult4858 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4858 (depth = 6)
  *var_spc = opresult4858;
  if (opresult4858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4951(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4954 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4953);
// compiled call node returning call4954 (depth = 10)
// compiled member node returning call4954 (depth = 9)
  int op_slot_right_4952 = gc_frame_newslot(call4954);
// starting to compile identifier node (depth = 9)
  Object bool4956 = alloc_Boolean(0);
// compiled identifier node returning bool4956 (depth = 9)
  int op_slot_left_4952 = gc_frame_newslot(bool4956);
  params[0] = call4954;
  partcv[0] = 1;
  Object opresult4957 = callmethod(bool4956, "≠", 1, partcv, params);
// compiled op node returning opresult4957 (depth = 8)
  gc_frame_end(frame);
  return opresult4957;
}
Object meth_ast__apply4980(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4982 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4984 = alloc_Float64(1);
// compiled num node returning num4984 (depth = 12)
  int op_slot_right_4983 = gc_frame_newslot(num4984);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4983 = gc_frame_newslot(*var_depth);
  params[0] = num4984;
  partcv[0] = 1;
  Object sum4986 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4986 (depth = 11)
  gc_frame_newslot(sum4986);
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe4987 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ix (depth = 12)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4989 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4988);
// compiled call node returning call4989 (depth = 13)
// compiled member node returning call4989 (depth = 12)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call4990 = callmethod(call4989, "at",
    1, partcv, params);
  gc_frame_end(callframe4987);
// compiled call node returning call4990 (depth = 11)
  params[0] = sum4986;
  partcv[0] = 1;
  Object call4991 = callmethod(call4990, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4982);
// compiled call node returning call4991 (depth = 10)
  int op_slot_right_4981 = gc_frame_newslot(call4991);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4981 = gc_frame_newslot(*var_s);
  params[0] = call4991;
  partcv[0] = 1;
  Object opresult4993 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4993 (depth = 9)
  *var_s = opresult4993;
  if (opresult4993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5037(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5038 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  gc_frame_newslot(*var_anr);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5040 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5039);
// compiled call node returning call5040 (depth = 11)
// compiled member node returning call5040 (depth = 10)
  params[0] = *var_anr;
  partcv[0] = 1;
  Object call5041 = callmethod(call5040, "at",
    1, partcv, params);
  gc_frame_end(callframe5038);
// compiled call node returning call5041 (depth = 9)
  *var_arg = call5041;
  if (call5041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5043 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num5045 = alloc_Float64(1);
// compiled num node returning num5045 (depth = 12)
  int op_slot_right_5044 = gc_frame_newslot(num5045);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_5044 = gc_frame_newslot(*var_depth);
  params[0] = num5045;
  partcv[0] = 1;
  Object sum5047 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5047 (depth = 11)
  gc_frame_newslot(sum5047);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  params[0] = sum5047;
  partcv[0] = 1;
  Object call5048 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5043);
// compiled call node returning call5048 (depth = 10)
  int op_slot_right_5042 = gc_frame_newslot(call5048);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5042 = gc_frame_newslot(*var_s);
  params[0] = call5048;
  partcv[0] = 1;
  Object opresult5050 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5050 (depth = 9)
  *var_s = opresult5050;
  if (opresult5050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5054 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5056 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5055);
// compiled call node returning call5056 (depth = 13)
// compiled member node returning call5056 (depth = 12)
  partcv[0] = 0;
  Object call5057 = callmethod(call5056, "size",
    1, partcv, params);
  gc_frame_end(callframe5054);
// compiled call node returning call5057 (depth = 11)
// compiled member node returning call5057 (depth = 10)
  int op_slot_right_5053 = gc_frame_newslot(call5057);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_anr (depth = 10)
  int op_slot_left_5053 = gc_frame_newslot(*var_anr);
  params[0] = call5057;
  partcv[0] = 1;
  Object opresult5059 = callmethod(*var_anr, "<", 1, partcv, params);
// compiled op node returning opresult5059 (depth = 9)
  Object if5052 = done;
  if (istrue(opresult5059)) {
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5061 == NULL) {
    strlit5061 = alloc_String(", ");
    gc_root(strlit5061);
  }
// compiled string node returning strlit5061 (depth = 11)
  int op_slot_right_5060 = gc_frame_newslot(strlit5061);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5060 = gc_frame_newslot(*var_s);
  params[0] = strlit5061;
  partcv[0] = 1;
  Object opresult5063 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5063 (depth = 10)
  *var_s = opresult5063;
  if (opresult5063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if5052 = done;
  } else {
  }
// compiled if node returning if5052 (depth = 8)
  gc_frame_end(frame);
  return if5052;
}
Object meth_ast__apply4941(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4944 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4943);
// compiled call node returning call4944 (depth = 8)
// compiled member node returning call4944 (depth = 7)
  int op_slot_right_4942 = gc_frame_newslot(call4944);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4942 = gc_frame_newslot(*var_s);
  params[0] = call4944;
  partcv[0] = 1;
  Object opresult4946 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 6)
  *var_s = opresult4946;
  if (opresult4946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block4950 = alloc_Block(NULL, NULL, "ast", 1123);
  gc_frame_newslot(block4950);
// method "_apply"
  block_savedest(block4950);
  Object closure4951 = createclosure(1, "_apply");
  setclosureframe(closure4951, stackframe);
  addtoclosure(closure4951, selfslot);
  struct UserObject *uo4951 = (struct UserObject*)block4950;
  uo4951->data[0] = (Object)closure4951;
  Method *meth_meth_ast__apply4951 = addmethod2pos(block4950, "_apply", &meth_ast__apply4951, 0);
  int argcv_meth_ast__apply4951[] = {0};
  meth_meth_ast__apply4951->type = alloc_MethodType(1, argcv_meth_ast__apply4951);
  meth_meth_ast__apply4951->definitionModule = modulename;
  meth_meth_ast__apply4951->definitionLine = 1122;
// compiled block node returning block4950 (depth = 7)
  int op_slot_right_4949 = gc_frame_newslot(block4950);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstPart (depth = 7)
  int op_slot_left_4949 = gc_frame_newslot(*var_firstPart);
  params[0] = block4950;
  partcv[0] = 1;
  Object opresult4960 = callmethod(*var_firstPart, "&&", 1, partcv, params);
// compiled op node returning opresult4960 (depth = 6)
  Object if4948 = done;
  if (istrue(opresult4960)) {
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String("<");
    gc_root(strlit4962);
  }
// compiled string node returning strlit4962 (depth = 8)
  int op_slot_right_4961 = gc_frame_newslot(strlit4962);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4961 = gc_frame_newslot(*var_s);
  params[0] = strlit4962;
  partcv[0] = 1;
  Object opresult4964 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4964 (depth = 7)
  *var_s = opresult4964;
  if (opresult4964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4966 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num4969 = alloc_Float64(1);
// compiled num node returning num4969 (depth = 9)
  int op_slot_right_4968 = gc_frame_newslot(num4969);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4971 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4973 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4972);
// compiled call node returning call4973 (depth = 12)
// compiled member node returning call4973 (depth = 11)
  partcv[0] = 0;
  Object call4974 = callmethod(call4973, "size",
    1, partcv, params);
  gc_frame_end(callframe4971);
// compiled call node returning call4974 (depth = 10)
// compiled member node returning call4974 (depth = 9)
  int op_slot_left_4968 = gc_frame_newslot(call4974);
  params[0] = num4969;
  partcv[0] = 1;
  Object diff4975 = callmethod(call4974, "-", 1, partcv, params);
// compiled op node returning diff4975 (depth = 8)
  int op_slot_right_4967 = gc_frame_newslot(diff4975);
// starting to compile num node (depth = 8)
  Object num4977 = alloc_Float64(1);
// compiled num node returning num4977 (depth = 8)
  int op_slot_left_4967 = gc_frame_newslot(num4977);
  params[0] = diff4975;
  partcv[0] = 1;
  Object opresult4978 = callmethod(num4977, "..", 1, partcv, params);
// compiled op node returning opresult4978 (depth = 7)
  gc_frame_newslot(opresult4978);
// starting to compile block node (depth = 7)
  Object block4979 = alloc_Block(NULL, NULL, "ast", 1125);
  gc_frame_newslot(block4979);
// method "_apply"
  block_savedest(block4979);
  Object closure4980 = createclosure(3, "_apply");
  setclosureframe(closure4980, stackframe);
  addtoclosure(closure4980, var_depth);
  addtoclosure(closure4980, var_s);
  addtoclosure(closure4980, selfslot);
  struct UserObject *uo4980 = (struct UserObject*)block4979;
  uo4980->data[0] = (Object)closure4980;
  Method *meth_meth_ast__apply4980 = addmethod2pos(block4979, "_apply", &meth_ast__apply4980, 0);
  int argcv_meth_ast__apply4980[] = {1};
  meth_meth_ast__apply4980->type = alloc_MethodType(1, argcv_meth_ast__apply4980);
  meth_meth_ast__apply4980->definitionModule = modulename;
  meth_meth_ast__apply4980->definitionLine = 1125;
// compiled block node returning block4979 (depth = 7)
  gc_frame_newslot(block4979);
// call case 5: prelude request
  params[0] = opresult4978;
  params[1] = block4979;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4996 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4966);
// compiled call node returning call4996 (depth = 6)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4998 == NULL) {
    strlit4998 = alloc_String(">");
    gc_root(strlit4998);
  }
// compiled string node returning strlit4998 (depth = 8)
  int op_slot_right_4997 = gc_frame_newslot(strlit4998);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5001 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5003 = alloc_Float64(1);
// compiled num node returning num5003 (depth = 11)
  int op_slot_right_5002 = gc_frame_newslot(num5003);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5002 = gc_frame_newslot(*var_depth);
  params[0] = num5003;
  partcv[0] = 1;
  Object sum5005 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5005 (depth = 10)
  gc_frame_newslot(sum5005);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5006 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5007 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5008 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5007);
// compiled call node returning call5008 (depth = 13)
// compiled member node returning call5008 (depth = 12)
  partcv[0] = 0;
  Object call5009 = callmethod(call5008, "last",
    1, partcv, params);
  gc_frame_end(callframe5006);
// compiled call node returning call5009 (depth = 11)
// compiled member node returning call5009 (depth = 10)
  params[0] = sum5005;
  partcv[0] = 1;
  Object call5010 = callmethod(call5009, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5001);
// compiled call node returning call5010 (depth = 9)
  int op_slot_right_5000 = gc_frame_newslot(call5010);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5000 = gc_frame_newslot(*var_s);
  params[0] = call5010;
  partcv[0] = 1;
  Object opresult5012 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5012 (depth = 8)
  int op_slot_left_4997 = gc_frame_newslot(opresult5012);
  params[0] = strlit4998;
  partcv[0] = 1;
  Object opresult5013 = callmethod(opresult5012, "++", 1, partcv, params);
// compiled op node returning opresult5013 (depth = 7)
  *var_s = opresult5013;
  if (opresult5013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if4948 = done;
  } else {
  }
// compiled if node returning if4948 (depth = 5)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5015 = alloc_Boolean(0);
// compiled identifier node returning bool5015 (depth = 6)
  *var_firstPart = bool5015;
  if (bool5015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5019 = alloc_Float64(0);
// compiled num node returning num5019 (depth = 7)
  int op_slot_right_5018 = gc_frame_newslot(num5019);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5021 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5023 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5022);
// compiled call node returning call5023 (depth = 10)
// compiled member node returning call5023 (depth = 9)
  partcv[0] = 0;
  Object call5024 = callmethod(call5023, "size",
    1, partcv, params);
  gc_frame_end(callframe5021);
// compiled call node returning call5024 (depth = 8)
// compiled member node returning call5024 (depth = 7)
  int op_slot_left_5018 = gc_frame_newslot(call5024);
  params[0] = num5019;
  partcv[0] = 1;
  Object opresult5025 = callmethod(call5024, ">", 1, partcv, params);
// compiled op node returning opresult5025 (depth = 6)
  Object if5017 = done;
  if (istrue(opresult5025)) {
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5027 == NULL) {
    strlit5027 = alloc_String("(");
    gc_root(strlit5027);
  }
// compiled string node returning strlit5027 (depth = 8)
  int op_slot_right_5026 = gc_frame_newslot(strlit5027);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5026 = gc_frame_newslot(*var_s);
  params[0] = strlit5027;
  partcv[0] = 1;
  Object opresult5029 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5029 (depth = 7)
  *var_s = opresult5029;
  if (opresult5029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5031 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5032 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5033 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5034 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5033);
// compiled call node returning call5034 (depth = 10)
// compiled member node returning call5034 (depth = 9)
  partcv[0] = 0;
  Object call5035 = callmethod(call5034, "indices",
    1, partcv, params);
  gc_frame_end(callframe5032);
// compiled call node returning call5035 (depth = 8)
// compiled member node returning call5035 (depth = 7)
  gc_frame_newslot(call5035);
// starting to compile block node (depth = 7)
  Object block5036 = alloc_Block(NULL, NULL, "ast", 1133);
  gc_frame_newslot(block5036);
// method "_apply"
  block_savedest(block5036);
  Object closure5037 = createclosure(4, "_apply");
  setclosureframe(closure5037, stackframe);
  addtoclosure(closure5037, var_part);
  addtoclosure(closure5037, var_depth);
  addtoclosure(closure5037, var_s);
  addtoclosure(closure5037, selfslot);
  struct UserObject *uo5037 = (struct UserObject*)block5036;
  uo5037->data[0] = (Object)closure5037;
  Method *meth_meth_ast__apply5037 = addmethod2pos(block5036, "_apply", &meth_ast__apply5037, 0);
  int argcv_meth_ast__apply5037[] = {1};
  meth_meth_ast__apply5037->type = alloc_MethodType(1, argcv_meth_ast__apply5037);
  meth_meth_ast__apply5037->definitionModule = modulename;
  meth_meth_ast__apply5037->definitionLine = 1133;
// compiled block node returning block5036 (depth = 7)
  gc_frame_newslot(block5036);
// call case 5: prelude request
  params[0] = call5035;
  params[1] = block5036;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5066 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5031);
// compiled call node returning call5066 (depth = 6)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5068 == NULL) {
    strlit5068 = alloc_String(")");
    gc_root(strlit5068);
  }
// compiled string node returning strlit5068 (depth = 8)
  int op_slot_right_5067 = gc_frame_newslot(strlit5068);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5067 = gc_frame_newslot(*var_s);
  params[0] = strlit5068;
  partcv[0] = 1;
  Object opresult5070 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5070 (depth = 7)
  *var_s = opresult5070;
  if (opresult5070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5017 = done;
  } else {
  }
// compiled if node returning if5017 (depth = 5)
  gc_frame_end(frame);
  return if5017;
}
Object meth_ast_toGrace4850(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
  Object *var_firstPart = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "firstPart");
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4851 == NULL) {
    strlit4851 = alloc_String("");
    gc_root(strlit4851);
  }
// compiled string node returning strlit4851 (depth = 4)
  *var_spc = strlit4851;
  if (strlit4851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4852 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block4853 = alloc_Block(NULL, NULL, "ast", 1103);
  gc_frame_newslot(block4853);
// method "_apply"
  block_savedest(block4853);
  Object closure4854 = createclosure(2, "_apply");
  setclosureframe(closure4854, stackframe);
  addtoclosure(closure4854, var_spc);
  addtoclosure(closure4854, selfslot);
  struct UserObject *uo4854 = (struct UserObject*)block4853;
  uo4854->data[0] = (Object)closure4854;
  Method *meth_meth_ast__apply4854 = addmethod2pos(block4853, "_apply", &meth_ast__apply4854, 0);
  int argcv_meth_ast__apply4854[] = {0};
  meth_meth_ast__apply4854->type = alloc_MethodType(1, argcv_meth_ast__apply4854);
  meth_meth_ast__apply4854->definitionModule = modulename;
  meth_meth_ast__apply4854->definitionLine = 1095;
// compiled block node returning block4853 (depth = 4)
  gc_frame_newslot(block4853);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block4853;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4861 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4852);
// compiled call node returning call4861 (depth = 3)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4862 == NULL) {
    strlit4862 = alloc_String("");
    gc_root(strlit4862);
  }
// compiled string node returning strlit4862 (depth = 4)
  *var_s = strlit4862;
  if (strlit4862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4865 == NULL) {
    strlit4865 = alloc_String("member");
    gc_root(strlit4865);
  }
// compiled string node returning strlit4865 (depth = 5)
  int op_slot_right_4864 = gc_frame_newslot(strlit4865);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4867 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4869 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled call node returning call4869 (depth = 8)
// compiled member node returning call4869 (depth = 7)
  partcv[0] = 0;
  Object call4870 = callmethod(call4869, "kind",
    1, partcv, params);
  gc_frame_end(callframe4867);
// compiled call node returning call4870 (depth = 6)
// compiled member node returning call4870 (depth = 5)
  int op_slot_left_4864 = gc_frame_newslot(call4870);
  params[0] = strlit4865;
  partcv[0] = 1;
  Object opresult4871 = callmethod(call4870, "==", 1, partcv, params);
// compiled op node returning opresult4871 (depth = 4)
  Object if4863 = done;
  if (istrue(opresult4871)) {
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4873 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4872);
// compiled call node returning call4873 (depth = 6)
// compiled member node returning call4873 (depth = 5)
  *var_member = call4873;
  if (call4873 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4876 == NULL) {
    strlit4876 = alloc_String("prefix");
    gc_root(strlit4876);
  }
// compiled string node returning strlit4876 (depth = 6)
  int op_slot_right_4875 = gc_frame_newslot(strlit4876);
// starting to compile call node (depth = 6)
  int callframe4878 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num4879 = alloc_Float64(1);
// compiled num node returning num4879 (depth = 7)
  gc_frame_newslot(num4879);
// starting to compile num node (depth = 7)
  Object num4880 = alloc_Float64(6);
// compiled num node returning num4880 (depth = 7)
  gc_frame_newslot(num4880);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4882 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4881);
// compiled call node returning call4882 (depth = 8)
// compiled member node returning call4882 (depth = 7)
  params[0] = num4879;
  params[1] = num4880;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4883 = callmethod(call4882, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4878);
// compiled call node returning call4883 (depth = 6)
  int op_slot_left_4875 = gc_frame_newslot(call4883);
  params[0] = strlit4876;
  partcv[0] = 1;
  Object opresult4884 = callmethod(call4883, "==", 1, partcv, params);
// compiled op node returning opresult4884 (depth = 5)
  Object if4874 = done;
  if (istrue(opresult4884)) {
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4885 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num4886 = alloc_Float64(7);
// compiled num node returning num4886 (depth = 7)
  gc_frame_newslot(num4886);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4887 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4889 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4888);
// compiled call node returning call4889 (depth = 10)
// compiled member node returning call4889 (depth = 9)
  partcv[0] = 0;
  Object call4890 = callmethod(call4889, "size",
    1, partcv, params);
  gc_frame_end(callframe4887);
// compiled call node returning call4890 (depth = 8)
// compiled member node returning call4890 (depth = 7)
  gc_frame_newslot(call4890);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4892 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4891);
// compiled call node returning call4892 (depth = 8)
// compiled member node returning call4892 (depth = 7)
  params[0] = num4886;
  params[1] = call4890;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4893 = callmethod(call4892, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4885);
// compiled call node returning call4893 (depth = 6)
  *var_s = call4893;
  if (call4893 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4896 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4897 = alloc_Float64(0);
// compiled num node returning num4897 (depth = 8)
  gc_frame_newslot(num4897);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4898 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call4899 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4898);
// compiled call node returning call4899 (depth = 9)
// compiled member node returning call4899 (depth = 8)
  params[0] = num4897;
  partcv[0] = 1;
  Object call4900 = callmethod(call4899, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4896);
// compiled call node returning call4900 (depth = 7)
  int op_slot_right_4895 = gc_frame_newslot(call4900);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4895 = gc_frame_newslot(*var_s);
  params[0] = call4900;
  partcv[0] = 1;
  Object opresult4902 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4902 (depth = 6)
  return opresult4902;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4874 = undefined;
  } else {
  }
// compiled if node returning if4874 (depth = 4)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4904 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4905 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_member (depth = 9)
  partcv[0] = 0;
  Object call4906 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4905);
// compiled call node returning call4906 (depth = 8)
// compiled member node returning call4906 (depth = 7)
  partcv[0] = 0;
  Object call4907 = callmethod(call4906, "isSimple",
    1, partcv, params);
  gc_frame_end(callframe4904);
// compiled call node returning call4907 (depth = 6)
// compiled member node returning call4907 (depth = 5)
  Object if4903 = done;
  if (istrue(call4907)) {
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4909 == NULL) {
    strlit4909 = alloc_String(".");
    gc_root(strlit4909);
  }
// compiled string node returning strlit4909 (depth = 7)
  int op_slot_right_4908 = gc_frame_newslot(strlit4909);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4912 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4913 = alloc_Float64(0);
// compiled num node returning num4913 (depth = 9)
  gc_frame_newslot(num4913);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4914 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4915 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4914);
// compiled call node returning call4915 (depth = 10)
// compiled member node returning call4915 (depth = 9)
  params[0] = num4913;
  partcv[0] = 1;
  Object call4916 = callmethod(call4915, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4912);
// compiled call node returning call4916 (depth = 8)
  int op_slot_right_4911 = gc_frame_newslot(call4916);
// starting to compile string node (depth = 8)
  if (strlit4918 == NULL) {
    strlit4918 = alloc_String("");
    gc_root(strlit4918);
  }
// compiled string node returning strlit4918 (depth = 8)
  int op_slot_left_4911 = gc_frame_newslot(strlit4918);
  params[0] = call4916;
  partcv[0] = 1;
  Object opresult4919 = callmethod(strlit4918, "++", 1, partcv, params);
// compiled op node returning opresult4919 (depth = 7)
  int op_slot_left_4908 = gc_frame_newslot(opresult4919);
  params[0] = strlit4909;
  partcv[0] = 1;
  Object opresult4920 = callmethod(opresult4919, "++", 1, partcv, params);
// compiled op node returning opresult4920 (depth = 6)
  *var_s = opresult4920;
  if (opresult4920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4903 = done;
  } else {
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4923 == NULL) {
    strlit4923 = alloc_String(").");
    gc_root(strlit4923);
  }
// compiled string node returning strlit4923 (depth = 7)
  int op_slot_right_4922 = gc_frame_newslot(strlit4923);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4926 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4927 = alloc_Float64(0);
// compiled num node returning num4927 (depth = 9)
  gc_frame_newslot(num4927);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4929 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4928);
// compiled call node returning call4929 (depth = 10)
// compiled member node returning call4929 (depth = 9)
  params[0] = num4927;
  partcv[0] = 1;
  Object call4930 = callmethod(call4929, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4926);
// compiled call node returning call4930 (depth = 8)
  int op_slot_right_4925 = gc_frame_newslot(call4930);
// starting to compile string node (depth = 8)
  if (strlit4932 == NULL) {
    strlit4932 = alloc_String("(");
    gc_root(strlit4932);
  }
// compiled string node returning strlit4932 (depth = 8)
  int op_slot_left_4925 = gc_frame_newslot(strlit4932);
  params[0] = call4930;
  partcv[0] = 1;
  Object opresult4933 = callmethod(strlit4932, "++", 1, partcv, params);
// compiled op node returning opresult4933 (depth = 7)
  int op_slot_left_4922 = gc_frame_newslot(opresult4933);
  params[0] = strlit4923;
  partcv[0] = 1;
  Object opresult4934 = callmethod(opresult4933, "++", 1, partcv, params);
// compiled op node returning opresult4934 (depth = 6)
  *var_s = opresult4934;
  if (opresult4934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4903 = done;
  }
// compiled if node returning if4903 (depth = 4)
    gc_frame_newslot(if4903);
    if4863 = if4903;
  } else {
  }
// compiled if node returning if4863 (depth = 3)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool4936 = alloc_Boolean(1);
// compiled identifier node returning bool4936 (depth = 4)
  *var_firstPart = bool4936;
  if (bool4936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4937 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4938 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4939 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4938);
// compiled call node returning call4939 (depth = 5)
// compiled member node returning call4939 (depth = 4)
  gc_frame_newslot(call4939);
// starting to compile block node (depth = 4)
  Object block4940 = alloc_Block(NULL, NULL, "ast", 1121);
  gc_frame_newslot(block4940);
// method "_apply"
  block_savedest(block4940);
  Object closure4941 = createclosure(4, "_apply");
  setclosureframe(closure4941, stackframe);
  addtoclosure(closure4941, var_s);
  addtoclosure(closure4941, var_firstPart);
  addtoclosure(closure4941, var_depth);
  addtoclosure(closure4941, selfslot);
  struct UserObject *uo4941 = (struct UserObject*)block4940;
  uo4941->data[0] = (Object)closure4941;
  Method *meth_meth_ast__apply4941 = addmethod2pos(block4940, "_apply", &meth_ast__apply4941, 0);
  int argcv_meth_ast__apply4941[] = {1};
  meth_meth_ast__apply4941->type = alloc_MethodType(1, argcv_meth_ast__apply4941);
  meth_meth_ast__apply4941->definitionModule = modulename;
  meth_meth_ast__apply4941->definitionLine = 1121;
// compiled block node returning block4940 (depth = 4)
  gc_frame_newslot(block4940);
// call case 5: prelude request
  params[0] = call4939;
  params[1] = block4940;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5073 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4937);
// compiled call node returning call5073 (depth = 3)
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString5074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_what = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5076 == NULL) {
    strlit5076 = alloc_String("");
    gc_root(strlit5076);
  }
// compiled string node returning strlit5076 (depth = 4)
  int op_slot_right_5075 = gc_frame_newslot(strlit5076);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5079 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num5080 = alloc_Float64(0);
// compiled num node returning num5080 (depth = 6)
  gc_frame_newslot(num5080);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_what (depth = 6)
  params[0] = num5080;
  partcv[0] = 1;
  Object call5081 = callmethod(*var_what, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5079);
// compiled call node returning call5081 (depth = 5)
  int op_slot_right_5078 = gc_frame_newslot(call5081);
// starting to compile string node (depth = 5)
  if (strlit5083 == NULL) {
    strlit5083 = alloc_String("call ");
    gc_root(strlit5083);
  }
// compiled string node returning strlit5083 (depth = 5)
  int op_slot_left_5078 = gc_frame_newslot(strlit5083);
  params[0] = call5081;
  partcv[0] = 1;
  Object opresult5084 = callmethod(strlit5083, "++", 1, partcv, params);
// compiled op node returning opresult5084 (depth = 4)
  int op_slot_left_5075 = gc_frame_newslot(opresult5084);
  params[0] = strlit5076;
  partcv[0] = 1;
  Object opresult5085 = callmethod(opresult5084, "++", 1, partcv, params);
// compiled op node returning opresult5085 (depth = 3)
  gc_frame_end(frame);
  return opresult5085;
}
Object meth_ast_shallowCopy5086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5087 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5088 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5090 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5089);
// compiled call node returning call5090 (depth = 6)
// compiled member node returning call5090 (depth = 5)
  gc_frame_newslot(call5090);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5091 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5092 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5091);
// compiled call node returning call5092 (depth = 6)
// compiled member node returning call5092 (depth = 5)
  gc_frame_newslot(call5092);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callNode (depth = 5)
  params[0] = call5090;
  params[1] = call5092;
  partcv[0] = 2;
  Object call5093 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5088);
// compiled call node returning call5093 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5094 = callmethod(call5093, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5087);
// compiled call node returning call5094 (depth = 3)
  gc_frame_end(frame);
  return call5094;
}
Object meth_ast_shallowCopyFieldsFrom5095(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5096 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5097 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5096);
// compiled call node returning call5097 (depth = 3)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5098 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5099 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5100 = callmethod(*var_other, "isPattern",
    1, partcv, params);
  gc_frame_end(callframe5099);
// compiled call node returning call5100 (depth = 5)
// compiled member node returning call5100 (depth = 4)
  gc_frame_newslot(call5100);
// call case 4: self request
  params[0] = call5100;
  partcv[0] = 1;
  Object call5101 = callmethodflags(self, "isPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5098);
// compiled call node returning call5101 (depth = 3)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName5102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5103 == NULL) {
    strlit5103 = alloc_String("request");
    gc_root(strlit5103);
  }
// compiled string node returning strlit5103 (depth = 3)
  gc_frame_end(frame);
  return strlit5103;
}
Object meth_ast_new4579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4580 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4580 = alloc_userobj2(22,19, objclass4580);
  gc_frame_newslot(obj4580);
if (objclass4580 == NULL) {
  glfree(obj4580->class->name);
  obj4580->class->name = "callNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4580, self, 0);
  addmethodreal(obj4580,"outer", &reader_ast_outer_4581);
  Object oldself4580 = self;
  struct StackFrameObject *oldstackframe4580 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4580);
  gc_frame_newslot((Object)stackframe);
  self = obj4580;
  Object *oldselfslot4580 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4580 = (*(struct UserObject *)self).data[0], lowerouter4580 = thisouter4580;
  if (inheritingObject4580) {
    struct UserObject *inho4580 = (struct UserObject *)inheritingObject4580;
    while (inho4580->super != GraceDefaultObject) inho4580 = (struct UserObject *)inho4580->super;
    inho4580->super = obj4580;
    self = inheritingObject4580;
    *selfslot = self;
    lowerouter4580 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4580;
  }
if (objclass4580 == NULL) {
  Method *reader4582 = addmethodrealflags(obj4580, "kind",&reader_ast_kind_4582, MFLAG_DEF);
  reader4582->definitionModule = modulename;
  reader4582->definitionLine = 1035;
}
adddatum2(obj4580, alloc_Undefined(), 1);
if (objclass4580 == NULL) {
  Method *reader4583 = addmethodrealflags(obj4580, "value",&reader_ast_value_4583, 0);
  Method *writer4583 = addmethodrealflags(obj4580, "value:=",&writer_ast_value_4583, 0);
  reader4583->definitionModule = modulename;
  writer4583->definitionModule = modulename;
  reader4583->definitionLine = 1036;
  writer4583->definitionLine = 1036;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 2);
if (objclass4580 == NULL) {
  Method *reader4584 = addmethodrealflags(obj4580, "with",&reader_ast_with_4584, 0);
  Method *writer4584 = addmethodrealflags(obj4580, "with:=",&writer_ast_with_4584, 0);
  reader4584->definitionModule = modulename;
  writer4584->definitionModule = modulename;
  reader4584->definitionLine = 1037;
  writer4584->definitionLine = 1037;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 3);
if (objclass4580 == NULL) {
  Method *reader4585 = addmethodrealflags(obj4580, "generics",&reader_ast_generics_4585, 0);
  Method *writer4585 = addmethodrealflags(obj4580, "generics:=",&writer_ast_generics_4585, 0);
  reader4585->definitionModule = modulename;
  writer4585->definitionModule = modulename;
  reader4585->definitionLine = 1038;
  writer4585->definitionLine = 1038;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 4);
if (objclass4580 == NULL) {
  Method *reader4586 = addmethodrealflags(obj4580, "isPattern",&reader_ast_isPattern_4586, 0);
  Method *writer4586 = addmethodrealflags(obj4580, "isPattern:=",&writer_ast_isPattern_4586, 0);
  reader4586->definitionModule = modulename;
  writer4586->definitionModule = modulename;
  reader4586->definitionLine = 1039;
  writer4586->definitionLine = 1039;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 5);
if (objclass4580 == NULL) {
  Method *reader4587 = addmethodrealflags(obj4580, "nameString",&reader_ast_nameString_4587, MFLAG_DEF);
  reader4587->definitionModule = modulename;
  reader4587->definitionLine = 1040;
}
adddatum2(obj4580, alloc_Undefined(), 6);
// method "target"
  struct UserObject *uo4588 = (struct UserObject*)obj4580;
  uo4588->data[7] = emptyclosure;
  Method *meth_meth_ast_target4588 = addmethod2pos(obj4580, "target", &meth_ast_target4588, 7);
  int argcv_meth_ast_target4588[] = {0};
  meth_meth_ast_target4588->type = alloc_MethodType(1, argcv_meth_ast_target4588);
  meth_meth_ast_target4588->definitionModule = modulename;
  meth_meth_ast_target4588->definitionLine = 1042;
// method "isCall"
  struct UserObject *uo4591 = (struct UserObject*)obj4580;
  uo4591->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4591 = addmethod2pos(obj4580, "isCall", &meth_ast_isCall4591, 8);
  int argcv_meth_ast_isCall4591[] = {0};
  meth_meth_ast_isCall4591->type = alloc_MethodType(1, argcv_meth_ast_isCall4591);
  meth_meth_ast_isCall4591->definitionModule = modulename;
  meth_meth_ast_isCall4591->definitionLine = 1043;
// method "returnsObject"
  struct UserObject *uo4593 = (struct UserObject*)obj4580;
  uo4593->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4593 = addmethod2pos(obj4580, "returnsObject", &meth_ast_returnsObject4593, 9);
  int argcv_meth_ast_returnsObject4593[] = {0};
  meth_meth_ast_returnsObject4593->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4593);
  meth_meth_ast_returnsObject4593->definitionModule = modulename;
  meth_meth_ast_returnsObject4593->definitionLine = 1044;
// method "returnedObjectScope"
  struct UserObject *uo4623 = (struct UserObject*)obj4580;
  uo4623->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4623 = addmethod2pos(obj4580, "returnedObjectScope", &meth_ast_returnedObjectScope4623, 10);
  int argcv_meth_ast_returnedObjectScope4623[] = {0};
  meth_meth_ast_returnedObjectScope4623->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4623);
  meth_meth_ast_returnedObjectScope4623->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4623->definitionLine = 1050;
// method "accept()from"
  struct UserObject *uo4626 = (struct UserObject*)obj4580;
  uo4626->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4626 = addmethod2pos(obj4580, "accept()from", &meth_ast_accept_40__41_from4626, 11);
  int argcv_meth_ast_accept_40__41_from4626[] = {1, 1};
  meth_meth_ast_accept_40__41_from4626->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4626);
  meth_meth_ast_accept_40__41_from4626->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4626->definitionLine = 1054;
// method "map()ancestors"
  struct UserObject *uo4668 = (struct UserObject*)obj4580;
  uo4668->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4668 = addmethod2pos(obj4580, "map()ancestors", &meth_ast_map_40__41_ancestors4668, 12);
  int argcv_meth_ast_map_40__41_ancestors4668[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4668->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4668);
  meth_meth_ast_map_40__41_ancestors4668->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4668->definitionLine = 1070;
// method "pretty"
  struct UserObject *uo4701 = (struct UserObject*)obj4580;
  uo4701->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4701 = addmethod2pos(obj4580, "pretty", &meth_ast_pretty4701, 13);
  int argcv_meth_ast_pretty4701[] = {1};
  meth_meth_ast_pretty4701->type = alloc_MethodType(1, argcv_meth_ast_pretty4701);
  meth_meth_ast_pretty4701->definitionModule = modulename;
  meth_meth_ast_pretty4701->definitionLine = 1078;
// method "toGrace"
  struct UserObject *uo4850 = (struct UserObject*)obj4580;
  uo4850->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4850 = addmethod2pos(obj4580, "toGrace", &meth_ast_toGrace4850, 14);
  int argcv_meth_ast_toGrace4850[] = {1};
  meth_meth_ast_toGrace4850->type = alloc_MethodType(1, argcv_meth_ast_toGrace4850);
meth_meth_ast_toGrace4850->type->types[0] = type_Number;
meth_meth_ast_toGrace4850->type->names[0] = "depth";
  meth_meth_ast_toGrace4850->definitionModule = modulename;
  meth_meth_ast_toGrace4850->definitionLine = 1101;
// method "asString"
  block_savedest(obj4580);
  Object closure5074 = createclosure(1, "asString");
  setclosureframe(closure5074, stackframe);
  addtoclosure(closure5074, var_what);
  struct UserObject *uo5074 = (struct UserObject*)obj4580;
  uo5074->data[15] = (Object)closure5074;
  Method *meth_meth_ast_asString5074 = addmethod2pos(obj4580, "asString", &meth_ast_asString5074, 15);
  int argcv_meth_ast_asString5074[] = {0};
  meth_meth_ast_asString5074->type = alloc_MethodType(1, argcv_meth_ast_asString5074);
  meth_meth_ast_asString5074->definitionModule = modulename;
  meth_meth_ast_asString5074->definitionLine = 1145;
// method "shallowCopy"
  block_savedest(obj4580);
  Object closure5086 = createclosure(1, "shallowCopy");
  setclosureframe(closure5086, stackframe);
  addtoclosure(closure5086, var_callNode);
  struct UserObject *uo5086 = (struct UserObject*)obj4580;
  uo5086->data[16] = (Object)closure5086;
  Method *meth_meth_ast_shallowCopy5086 = addmethod2pos(obj4580, "shallowCopy", &meth_ast_shallowCopy5086, 16);
  int argcv_meth_ast_shallowCopy5086[] = {0};
  meth_meth_ast_shallowCopy5086->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5086);
  meth_meth_ast_shallowCopy5086->definitionModule = modulename;
  meth_meth_ast_shallowCopy5086->definitionLine = 1146;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5095 = (struct UserObject*)obj4580;
  uo5095->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5095 = addmethod2pos(obj4580, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5095, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5095[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5095->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5095);
  meth_meth_ast_shallowCopyFieldsFrom5095->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5095->definitionLine = 1149;
// method "statementName"
  struct UserObject *uo5102 = (struct UserObject*)obj4580;
  uo5102->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName5102 = addmethod2pos(obj4580, "statementName", &meth_ast_statementName5102, 18);
  int argcv_meth_ast_statementName5102[] = {0};
  meth_meth_ast_statementName5102->type = alloc_MethodType(1, argcv_meth_ast_statementName5102);
  meth_meth_ast_statementName5102->definitionModule = modulename;
  meth_meth_ast_statementName5102->definitionLine = 1154;
  sourceObject = obj4580;
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5104 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5105 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5106 = gc_frame_new();
// call case 3: self.outer request
  Object call5107 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5106);
// compiled call node returning call5107 (depth = 7)
// compiled member node returning call5107 (depth = 6)
  partcv[0] = 0;
  Object call5108 = callmethodflags(call5107, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5105);
// compiled call node returning call5108 (depth = 5)
// compiled member node returning call5108 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5109 = callmethodflags(call5108, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5104);
// compiled call node returning call5109 (depth = 3)
  struct UserObject *obj4580_uo = (struct UserObject *)obj4580;
  obj4580_uo->super = call5109;
  sourceObject = obj4580;
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String("call");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 3)
  adddatum2(obj4580, strlit5110, 1);
  sourceObject = obj4580;
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4580, *var_what, 2);
  sourceObject = obj4580;
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4580, *var_with_39_, 3);
  sourceObject = obj4580;
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5111 = alloc_Boolean(0);
// compiled identifier node returning bool5111 (depth = 3)
  adddatum2(obj4580, bool5111, 4);
  sourceObject = obj4580;
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5112 = alloc_Boolean(0);
// compiled identifier node returning bool5112 (depth = 3)
  adddatum2(obj4580, bool5112, 5);
  sourceObject = obj4580;
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5113 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5115 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5114);
// compiled call node returning call5115 (depth = 6)
// compiled member node returning call5115 (depth = 5)
  partcv[0] = 0;
  Object call5116 = callmethod(call5115, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5113);
// compiled call node returning call5116 (depth = 4)
// compiled member node returning call5116 (depth = 3)
  adddatum2(obj4580, call5116, 6);
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  objclass4580 = obj4580->class;
  objclass4580->definitionModule = modulename;
  objclass4580->definitionLine = 1016;
  (*(struct UserObject *)self).data[0] = lowerouter4580;
  self = oldself4580;
  selfslot = oldselfslot4580;
  stackframe = oldstackframe4580;
  gc_frame_end(frame);
  return obj4580;
}
Object meth_ast_new4579_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4580 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4580 = alloc_userobj2(22,19, objclass4580);
  gc_frame_newslot(obj4580);
if (objclass4580 == NULL) {
  glfree(obj4580->class->name);
  obj4580->class->name = "callNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4580, self, 0);
  addmethodreal(obj4580,"outer", &reader_ast_outer_4581);
  Object oldself4580 = self;
  struct StackFrameObject *oldstackframe4580 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4580);
  gc_frame_newslot((Object)stackframe);
  self = obj4580;
  Object *oldselfslot4580 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4580 = (*(struct UserObject *)self).data[0], lowerouter4580 = thisouter4580;
  if (inheritingObject4580) {
    struct UserObject *inho4580 = (struct UserObject *)inheritingObject4580;
    while (inho4580->super != GraceDefaultObject) inho4580 = (struct UserObject *)inho4580->super;
    inho4580->super = obj4580;
    self = inheritingObject4580;
    *selfslot = self;
    lowerouter4580 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4580;
  }
if (objclass4580 == NULL) {
  Method *reader4582 = addmethodrealflags(obj4580, "kind",&reader_ast_kind_4582, MFLAG_DEF);
  reader4582->definitionModule = modulename;
  reader4582->definitionLine = 1035;
}
adddatum2(obj4580, alloc_Undefined(), 1);
if (objclass4580 == NULL) {
  Method *reader4583 = addmethodrealflags(obj4580, "value",&reader_ast_value_4583, 0);
  Method *writer4583 = addmethodrealflags(obj4580, "value:=",&writer_ast_value_4583, 0);
  reader4583->definitionModule = modulename;
  writer4583->definitionModule = modulename;
  reader4583->definitionLine = 1036;
  writer4583->definitionLine = 1036;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 2);
if (objclass4580 == NULL) {
  Method *reader4584 = addmethodrealflags(obj4580, "with",&reader_ast_with_4584, 0);
  Method *writer4584 = addmethodrealflags(obj4580, "with:=",&writer_ast_with_4584, 0);
  reader4584->definitionModule = modulename;
  writer4584->definitionModule = modulename;
  reader4584->definitionLine = 1037;
  writer4584->definitionLine = 1037;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 3);
if (objclass4580 == NULL) {
  Method *reader4585 = addmethodrealflags(obj4580, "generics",&reader_ast_generics_4585, 0);
  Method *writer4585 = addmethodrealflags(obj4580, "generics:=",&writer_ast_generics_4585, 0);
  reader4585->definitionModule = modulename;
  writer4585->definitionModule = modulename;
  reader4585->definitionLine = 1038;
  writer4585->definitionLine = 1038;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 4);
if (objclass4580 == NULL) {
  Method *reader4586 = addmethodrealflags(obj4580, "isPattern",&reader_ast_isPattern_4586, 0);
  Method *writer4586 = addmethodrealflags(obj4580, "isPattern:=",&writer_ast_isPattern_4586, 0);
  reader4586->definitionModule = modulename;
  writer4586->definitionModule = modulename;
  reader4586->definitionLine = 1039;
  writer4586->definitionLine = 1039;
}
obj4580->flags |= OFLAG_MUTABLE;
adddatum2(obj4580, alloc_Undefined(), 5);
if (objclass4580 == NULL) {
  Method *reader4587 = addmethodrealflags(obj4580, "nameString",&reader_ast_nameString_4587, MFLAG_DEF);
  reader4587->definitionModule = modulename;
  reader4587->definitionLine = 1040;
}
adddatum2(obj4580, alloc_Undefined(), 6);
// method "target"
  struct UserObject *uo4588 = (struct UserObject*)obj4580;
  uo4588->data[7] = emptyclosure;
  Method *meth_meth_ast_target4588 = addmethod2pos(obj4580, "target", &meth_ast_target4588, 7);
  int argcv_meth_ast_target4588[] = {0};
  meth_meth_ast_target4588->type = alloc_MethodType(1, argcv_meth_ast_target4588);
  meth_meth_ast_target4588->definitionModule = modulename;
  meth_meth_ast_target4588->definitionLine = 1042;
// method "isCall"
  struct UserObject *uo4591 = (struct UserObject*)obj4580;
  uo4591->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4591 = addmethod2pos(obj4580, "isCall", &meth_ast_isCall4591, 8);
  int argcv_meth_ast_isCall4591[] = {0};
  meth_meth_ast_isCall4591->type = alloc_MethodType(1, argcv_meth_ast_isCall4591);
  meth_meth_ast_isCall4591->definitionModule = modulename;
  meth_meth_ast_isCall4591->definitionLine = 1043;
// method "returnsObject"
  struct UserObject *uo4593 = (struct UserObject*)obj4580;
  uo4593->data[9] = emptyclosure;
  Method *meth_meth_ast_returnsObject4593 = addmethod2pos(obj4580, "returnsObject", &meth_ast_returnsObject4593, 9);
  int argcv_meth_ast_returnsObject4593[] = {0};
  meth_meth_ast_returnsObject4593->type = alloc_MethodType(1, argcv_meth_ast_returnsObject4593);
  meth_meth_ast_returnsObject4593->definitionModule = modulename;
  meth_meth_ast_returnsObject4593->definitionLine = 1044;
// method "returnedObjectScope"
  struct UserObject *uo4623 = (struct UserObject*)obj4580;
  uo4623->data[10] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope4623 = addmethod2pos(obj4580, "returnedObjectScope", &meth_ast_returnedObjectScope4623, 10);
  int argcv_meth_ast_returnedObjectScope4623[] = {0};
  meth_meth_ast_returnedObjectScope4623->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope4623);
  meth_meth_ast_returnedObjectScope4623->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope4623->definitionLine = 1050;
// method "accept()from"
  struct UserObject *uo4626 = (struct UserObject*)obj4580;
  uo4626->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4626 = addmethod2pos(obj4580, "accept()from", &meth_ast_accept_40__41_from4626, 11);
  int argcv_meth_ast_accept_40__41_from4626[] = {1, 1};
  meth_meth_ast_accept_40__41_from4626->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4626);
  meth_meth_ast_accept_40__41_from4626->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4626->definitionLine = 1054;
// method "map()ancestors"
  struct UserObject *uo4668 = (struct UserObject*)obj4580;
  uo4668->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors4668 = addmethod2pos(obj4580, "map()ancestors", &meth_ast_map_40__41_ancestors4668, 12);
  int argcv_meth_ast_map_40__41_ancestors4668[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors4668->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors4668);
  meth_meth_ast_map_40__41_ancestors4668->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors4668->definitionLine = 1070;
// method "pretty"
  struct UserObject *uo4701 = (struct UserObject*)obj4580;
  uo4701->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty4701 = addmethod2pos(obj4580, "pretty", &meth_ast_pretty4701, 13);
  int argcv_meth_ast_pretty4701[] = {1};
  meth_meth_ast_pretty4701->type = alloc_MethodType(1, argcv_meth_ast_pretty4701);
  meth_meth_ast_pretty4701->definitionModule = modulename;
  meth_meth_ast_pretty4701->definitionLine = 1078;
// method "toGrace"
  struct UserObject *uo4850 = (struct UserObject*)obj4580;
  uo4850->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace4850 = addmethod2pos(obj4580, "toGrace", &meth_ast_toGrace4850, 14);
  int argcv_meth_ast_toGrace4850[] = {1};
  meth_meth_ast_toGrace4850->type = alloc_MethodType(1, argcv_meth_ast_toGrace4850);
meth_meth_ast_toGrace4850->type->types[0] = type_Number;
meth_meth_ast_toGrace4850->type->names[0] = "depth";
  meth_meth_ast_toGrace4850->definitionModule = modulename;
  meth_meth_ast_toGrace4850->definitionLine = 1101;
// method "asString"
  block_savedest(obj4580);
  Object closure5074 = createclosure(1, "asString");
  setclosureframe(closure5074, stackframe);
  addtoclosure(closure5074, var_what);
  struct UserObject *uo5074 = (struct UserObject*)obj4580;
  uo5074->data[15] = (Object)closure5074;
  Method *meth_meth_ast_asString5074 = addmethod2pos(obj4580, "asString", &meth_ast_asString5074, 15);
  int argcv_meth_ast_asString5074[] = {0};
  meth_meth_ast_asString5074->type = alloc_MethodType(1, argcv_meth_ast_asString5074);
  meth_meth_ast_asString5074->definitionModule = modulename;
  meth_meth_ast_asString5074->definitionLine = 1145;
// method "shallowCopy"
  block_savedest(obj4580);
  Object closure5086 = createclosure(1, "shallowCopy");
  setclosureframe(closure5086, stackframe);
  addtoclosure(closure5086, var_callNode);
  struct UserObject *uo5086 = (struct UserObject*)obj4580;
  uo5086->data[16] = (Object)closure5086;
  Method *meth_meth_ast_shallowCopy5086 = addmethod2pos(obj4580, "shallowCopy", &meth_ast_shallowCopy5086, 16);
  int argcv_meth_ast_shallowCopy5086[] = {0};
  meth_meth_ast_shallowCopy5086->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5086);
  meth_meth_ast_shallowCopy5086->definitionModule = modulename;
  meth_meth_ast_shallowCopy5086->definitionLine = 1146;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5095 = (struct UserObject*)obj4580;
  uo5095->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5095 = addmethod2pos(obj4580, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5095, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom5095[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5095->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5095);
  meth_meth_ast_shallowCopyFieldsFrom5095->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5095->definitionLine = 1149;
// method "statementName"
  struct UserObject *uo5102 = (struct UserObject*)obj4580;
  uo5102->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName5102 = addmethod2pos(obj4580, "statementName", &meth_ast_statementName5102, 18);
  int argcv_meth_ast_statementName5102[] = {0};
  meth_meth_ast_statementName5102->type = alloc_MethodType(1, argcv_meth_ast_statementName5102);
  meth_meth_ast_statementName5102->definitionModule = modulename;
  meth_meth_ast_statementName5102->definitionLine = 1154;
  sourceObject = obj4580;
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5104 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5105 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5106 = gc_frame_new();
// call case 3: self.outer request
  Object call5107 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5106);
// compiled call node returning call5107 (depth = 7)
// compiled member node returning call5107 (depth = 6)
  partcv[0] = 0;
  Object call5108 = callmethodflags(call5107, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5105);
// compiled call node returning call5108 (depth = 5)
// compiled member node returning call5108 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5109 = callmethodflags(call5108, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5104);
// compiled call node returning call5109 (depth = 3)
  struct UserObject *obj4580_uo = (struct UserObject *)obj4580;
  obj4580_uo->super = call5109;
  sourceObject = obj4580;
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5110 == NULL) {
    strlit5110 = alloc_String("call");
    gc_root(strlit5110);
  }
// compiled string node returning strlit5110 (depth = 3)
  adddatum2(obj4580, strlit5110, 1);
  sourceObject = obj4580;
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_what (depth = 3)
  adddatum2(obj4580, *var_what, 2);
  sourceObject = obj4580;
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_with_39_ (depth = 3)
  adddatum2(obj4580, *var_with_39_, 3);
  sourceObject = obj4580;
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5111 = alloc_Boolean(0);
// compiled identifier node returning bool5111 (depth = 3)
  adddatum2(obj4580, bool5111, 4);
  sourceObject = obj4580;
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5112 = alloc_Boolean(0);
// compiled identifier node returning bool5112 (depth = 3)
  adddatum2(obj4580, bool5112, 5);
  sourceObject = obj4580;
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5113 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5115 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5114);
// compiled call node returning call5115 (depth = 6)
// compiled member node returning call5115 (depth = 5)
  partcv[0] = 0;
  Object call5116 = callmethod(call5115, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5113);
// compiled call node returning call5116 (depth = 4)
// compiled member node returning call5116 (depth = 3)
  adddatum2(obj4580, call5116, 6);
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  sourceObject = obj4580;
  objclass4580 = obj4580->class;
  objclass4580->definitionModule = modulename;
  objclass4580->definitionLine = 1016;
  (*(struct UserObject *)self).data[0] = lowerouter4580;
  self = oldself4580;
  selfslot = oldselfslot4580;
  stackframe = oldstackframe4580;
  gc_frame_end(frame);
  return obj4580;
}
Object meth_ast_callNode5118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for callNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_body_40__41_named_40__41_scope5121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5122 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5123 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5122);
// compiled call node returning call5123 (depth = 4)
  *var_result = call5123;
  if (call5123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5124 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5125 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5124);
// compiled call node returning call5125 (depth = 3)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5126 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5127 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe5126);
// compiled call node returning call5127 (depth = 3)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40__41_named5128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body()named (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5129 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 4: self request
  params[0] = *var_b;
  partcv[0] = 1;
  Object call5130 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5129);
// compiled call node returning call5130 (depth = 4)
  *var_result = call5130;
  if (call5130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5131 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5132 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5131);
// compiled call node returning call5132 (depth = 3)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isModule5139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isModule");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isModule (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isModule");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5140 = alloc_Boolean(1);
// compiled identifier node returning bool5140 (depth = 3)
  gc_frame_end(frame);
  return bool5140;
}
Object meth_ast_returnsObject5141(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5142 = alloc_Boolean(0);
// compiled identifier node returning bool5142 (depth = 3)
  gc_frame_end(frame);
  return bool5142;
}
Object meth_ast__apply5146(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5149 = callmethod(*var_o, "isExternal",
    1, partcv, params);
  gc_frame_end(callframe5148);
// compiled call node returning call5149 (depth = 7)
// compiled member node returning call5149 (depth = 6)
  Object if5147 = done;
  if (istrue(call5149)) {
// starting to compile call node (depth = 6)
  int callframe5150 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5151 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5150);
// compiled call node returning call5151 (depth = 6)
    gc_frame_newslot(call5151);
    if5147 = call5151;
  } else {
  }
// compiled if node returning if5147 (depth = 5)
  gc_frame_end(frame);
  return if5147;
}
Object meth_ast_externalsDo5143(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "externalsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method externalsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for externalsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for externalsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5144 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5145 = alloc_Block(NULL, NULL, "ast", 1180);
  gc_frame_newslot(block5145);
// method "_apply"
  block_savedest(block5145);
  Object closure5146 = createclosure(2, "_apply");
  setclosureframe(closure5146, stackframe);
  addtoclosure(closure5146, var_action);
  addtoclosure(closure5146, selfslot);
  struct UserObject *uo5146 = (struct UserObject*)block5145;
  uo5146->data[0] = (Object)closure5146;
  Method *meth_meth_ast__apply5146 = addmethod2pos(block5145, "_apply", &meth_ast__apply5146, 0);
  int argcv_meth_ast__apply5146[] = {1};
  meth_meth_ast__apply5146->type = alloc_MethodType(1, argcv_meth_ast__apply5146);
  meth_meth_ast__apply5146->definitionModule = modulename;
  meth_meth_ast__apply5146->definitionLine = 1040;
// compiled block node returning block5145 (depth = 4)
  gc_frame_newslot(block5145);
// call case 6: other member request
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5154 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled call node returning call5154 (depth = 5)
// compiled member node returning call5154 (depth = 4)
  params[0] = block5145;
  partcv[0] = 1;
  Object call5155 = callmethod(call5154, "do",
    1, partcv, params);
  gc_frame_end(callframe5144);
// compiled call node returning call5155 (depth = 3)
  gc_frame_end(frame);
  return call5155;
}
Object meth_ast__apply5177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5178 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5179 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5178);
// compiled call node returning call5179 (depth = 6)
  gc_frame_end(frame);
  return call5179;
}
Object meth_ast_accept_40__41_from5156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5158 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5159 = callmethod(*var_visitor, "visitModule()up",
    2, partcv, params);
  gc_frame_end(callframe5158);
// compiled call node returning call5159 (depth = 4)
  Object if5157 = done;
  if (istrue(call5159)) {
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5160 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5161 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5160);
// compiled call node returning call5161 (depth = 5)
  *var_newChain = call5161;
  if (call5161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5165 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5164);
// compiled call node returning call5165 (depth = 7)
// compiled member node returning call5165 (depth = 6)
  int op_slot_right_5163 = gc_frame_newslot(call5165);
// starting to compile identifier node (depth = 6)
  Object bool5167 = alloc_Boolean(0);
// compiled identifier node returning bool5167 (depth = 6)
  int op_slot_left_5163 = gc_frame_newslot(bool5167);
  params[0] = call5165;
  partcv[0] = 1;
  Object opresult5168 = callmethod(bool5167, "≠", 1, partcv, params);
// compiled op node returning opresult5168 (depth = 5)
  Object if5162 = done;
  if (istrue(opresult5168)) {
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5169 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5170 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5171 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5170);
// compiled call node returning call5171 (depth = 7)
// compiled member node returning call5171 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5172 = callmethod(call5171, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5169);
// compiled call node returning call5172 (depth = 5)
    gc_frame_newslot(call5172);
    if5162 = call5172;
  } else {
  }
// compiled if node returning if5162 (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5173 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5174 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5175 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5174);
// compiled call node returning call5175 (depth = 6)
// compiled member node returning call5175 (depth = 5)
  gc_frame_newslot(call5175);
// starting to compile block node (depth = 5)
  Object block5176 = alloc_Block(NULL, NULL, "ast", 1190);
  gc_frame_newslot(block5176);
// method "_apply"
  block_savedest(block5176);
  Object closure5177 = createclosure(3, "_apply");
  setclosureframe(closure5177, stackframe);
  addtoclosure(closure5177, var_visitor);
  addtoclosure(closure5177, var_newChain);
  addtoclosure(closure5177, selfslot);
  struct UserObject *uo5177 = (struct UserObject*)block5176;
  uo5177->data[0] = (Object)closure5177;
  Method *meth_meth_ast__apply5177 = addmethod2pos(block5176, "_apply", &meth_ast__apply5177, 0);
  int argcv_meth_ast__apply5177[] = {1};
  meth_meth_ast__apply5177->type = alloc_MethodType(1, argcv_meth_ast__apply5177);
  meth_meth_ast__apply5177->definitionModule = modulename;
  meth_meth_ast__apply5177->definitionLine = 1190;
// compiled block node returning block5176 (depth = 5)
  gc_frame_newslot(block5176);
// call case 5: prelude request
  params[0] = call5175;
  params[1] = block5176;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5181 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5173);
// compiled call node returning call5181 (depth = 4)
    gc_frame_newslot(call5181);
    if5157 = call5181;
  } else {
  }
// compiled if node returning if5157 (depth = 3)
  gc_frame_end(frame);
  return if5157;
}
Object meth_ast_shallowCopy5182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5183 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5184 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_moduleNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call5185 = callmethod(*var_moduleNode, "body",
    1, partcv, params);
  gc_frame_end(callframe5184);
// compiled call node returning call5185 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5186 = callmethod(call5185, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5183);
// compiled call node returning call5186 (depth = 3)
  gc_frame_end(frame);
  return call5186;
}
Object meth_ast_shallowCopyFieldsFrom5187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5188 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5189 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5188);
// compiled call node returning call5189 (depth = 3)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5190 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5191 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5192 = callmethod(*var_other, "imports",
    1, partcv, params);
  gc_frame_end(callframe5191);
// compiled call node returning call5192 (depth = 5)
// compiled member node returning call5192 (depth = 4)
  gc_frame_newslot(call5192);
// call case 4: self request
  params[0] = call5192;
  partcv[0] = 1;
  Object call5193 = callmethodflags(self, "imports:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5190);
// compiled call node returning call5193 (depth = 3)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_body5133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5134 = alloc_userobj2(12,12, objclass5134);
  gc_frame_newslot(obj5134);
if (objclass5134 == NULL) {
  glfree(obj5134->class->name);
  obj5134->class->name = "moduleNode.body";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5134, self, 0);
  addmethodreal(obj5134,"outer", &reader_ast_outer_5135);
  Object oldself5134 = self;
  struct StackFrameObject *oldstackframe5134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5134);
  gc_frame_newslot((Object)stackframe);
  self = obj5134;
  Object *oldselfslot5134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5134 = (*(struct UserObject *)self).data[0], lowerouter5134 = thisouter5134;
  if (inheritingObject5134) {
    struct UserObject *inho5134 = (struct UserObject *)inheritingObject5134;
    while (inho5134->super != GraceDefaultObject) inho5134 = (struct UserObject *)inho5134->super;
    inho5134->super = obj5134;
    self = inheritingObject5134;
    *selfslot = self;
    lowerouter5134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5134;
  }
if (objclass5134 == NULL) {
  Method *reader5136 = addmethodrealflags(obj5134, "kind",&reader_ast_kind_5136, MFLAG_DEF);
  reader5136->definitionModule = modulename;
  reader5136->definitionLine = 1171;
}
adddatum2(obj5134, alloc_Undefined(), 1);
if (objclass5134 == NULL) {
  Method *reader5137 = addmethodrealflags(obj5134, "sourceLines",&reader_ast_sourceLines_5137, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5137->definitionModule = modulename;
  reader5137->definitionLine = 1172;
}
adddatum2(obj5134, alloc_Undefined(), 2);
if (objclass5134 == NULL) {
  Method *reader5138 = addmethodrealflags(obj5134, "imports",&reader_ast_imports_5138, 0);
  Method *writer5138 = addmethodrealflags(obj5134, "imports:=",&writer_ast_imports_5138, 0);
  reader5138->definitionModule = modulename;
  writer5138->definitionModule = modulename;
  reader5138->definitionLine = 1175;
  writer5138->definitionLine = 1175;
}
obj5134->flags |= OFLAG_MUTABLE;
adddatum2(obj5134, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5139 = (struct UserObject*)obj5134;
  uo5139->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5139 = addmethod2pos(obj5134, "isModule", &meth_ast_isModule5139, 4);
  int argcv_meth_ast_isModule5139[] = {0};
  meth_meth_ast_isModule5139->type = alloc_MethodType(1, argcv_meth_ast_isModule5139);
  meth_meth_ast_isModule5139->definitionModule = modulename;
  meth_meth_ast_isModule5139->definitionLine = 1177;
// method "returnsObject"
  struct UserObject *uo5141 = (struct UserObject*)obj5134;
  uo5141->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5141 = addmethod2pos(obj5134, "returnsObject", &meth_ast_returnsObject5141, 5);
  int argcv_meth_ast_returnsObject5141[] = {0};
  meth_meth_ast_returnsObject5141->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5141);
  meth_meth_ast_returnsObject5141->definitionModule = modulename;
  meth_meth_ast_returnsObject5141->definitionLine = 1178;
// method "externalsDo"
  struct UserObject *uo5143 = (struct UserObject*)obj5134;
  uo5143->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo5143 = addmethod2pos(obj5134, "externalsDo", &meth_ast_externalsDo5143, 6);
  int argcv_meth_ast_externalsDo5143[] = {1};
  meth_meth_ast_externalsDo5143->type = alloc_MethodType(1, argcv_meth_ast_externalsDo5143);
  meth_meth_ast_externalsDo5143->definitionModule = modulename;
  meth_meth_ast_externalsDo5143->definitionLine = 1179;
// method "accept()from"
  struct UserObject *uo5156 = (struct UserObject*)obj5134;
  uo5156->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5156 = addmethod2pos(obj5134, "accept()from", &meth_ast_accept_40__41_from5156, 7);
  int argcv_meth_ast_accept_40__41_from5156[] = {1, 1};
  meth_meth_ast_accept_40__41_from5156->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5156);
  meth_meth_ast_accept_40__41_from5156->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5156->definitionLine = 1184;
// method "shallowCopy"
  block_savedest(obj5134);
  Object closure5182 = createclosure(2, "shallowCopy");
  setclosureframe(closure5182, stackframe);
  addtoclosure(closure5182, var_emptySeq);
  addtoclosure(closure5182, var_moduleNode);
  struct UserObject *uo5182 = (struct UserObject*)obj5134;
  uo5182->data[8] = (Object)closure5182;
  Method *meth_meth_ast_shallowCopy5182 = addmethod2pos(obj5134, "shallowCopy", &meth_ast_shallowCopy5182, 8);
  int argcv_meth_ast_shallowCopy5182[] = {0};
  meth_meth_ast_shallowCopy5182->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5182);
  meth_meth_ast_shallowCopy5182->definitionModule = modulename;
  meth_meth_ast_shallowCopy5182->definitionLine = 1195;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5187 = (struct UserObject*)obj5134;
  uo5187->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5187 = addmethod2pos(obj5134, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5187, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom5187[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5187->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5187);
  meth_meth_ast_shallowCopyFieldsFrom5187->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5187->definitionLine = 1198;
  sourceObject = obj5134;
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5194 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5195 = alloc_Boolean(0);
// compiled identifier node returning bool5195 (depth = 4)
  gc_frame_newslot(bool5195);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5195;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5196 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5194);
// compiled call node returning call5196 (depth = 3)
  struct UserObject *obj5134_uo = (struct UserObject *)obj5134;
  obj5134_uo->super = call5196;
  sourceObject = obj5134;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5197 == NULL) {
    strlit5197 = alloc_String("module");
    gc_root(strlit5197);
  }
// compiled string node returning strlit5197 (depth = 3)
  adddatum2(obj5134, strlit5197, 1);
  sourceObject = obj5134;
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call5199 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5198);
// compiled call node returning call5199 (depth = 4)
// compiled member node returning call5199 (depth = 3)
  adddatum2(obj5134, call5199, 2);
  sourceObject = obj5134;
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5200 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5201 = alloc_Float64(0);
// compiled num node returning num5201 (depth = 4)
  gc_frame_newslot(num5201);
// call case 4: self request
  params[0] = num5201;
  partcv[0] = 1;
  Object call5202 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5200);
// compiled call node returning call5202 (depth = 3)
  sourceObject = obj5134;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5203 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5204 = alloc_Float64(0);
// compiled num node returning num5204 (depth = 4)
  gc_frame_newslot(num5204);
// call case 4: self request
  params[0] = num5204;
  partcv[0] = 1;
  Object call5205 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5203);
// compiled call node returning call5205 (depth = 3)
  sourceObject = obj5134;
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5206 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5206 (depth = 3)
  adddatum2(obj5134, array5206, 3);
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  objclass5134 = obj5134->class;
  objclass5134->definitionModule = modulename;
  objclass5134->definitionLine = 1169;
  (*(struct UserObject *)self).data[0] = lowerouter5134;
  self = oldself5134;
  selfslot = oldselfslot5134;
  stackframe = oldstackframe5134;
  gc_frame_end(frame);
  return obj5134;
}
Object meth_ast_body5133_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()object");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_moduleNode = getfromclosure(closure, 1);
  Object *var_objectNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5134 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5134 = alloc_userobj2(12,12, objclass5134);
  gc_frame_newslot(obj5134);
if (objclass5134 == NULL) {
  glfree(obj5134->class->name);
  obj5134->class->name = "moduleNode.body";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5134, self, 0);
  addmethodreal(obj5134,"outer", &reader_ast_outer_5135);
  Object oldself5134 = self;
  struct StackFrameObject *oldstackframe5134 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5134);
  gc_frame_newslot((Object)stackframe);
  self = obj5134;
  Object *oldselfslot5134 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5134 = (*(struct UserObject *)self).data[0], lowerouter5134 = thisouter5134;
  if (inheritingObject5134) {
    struct UserObject *inho5134 = (struct UserObject *)inheritingObject5134;
    while (inho5134->super != GraceDefaultObject) inho5134 = (struct UserObject *)inho5134->super;
    inho5134->super = obj5134;
    self = inheritingObject5134;
    *selfslot = self;
    lowerouter5134 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5134;
  }
if (objclass5134 == NULL) {
  Method *reader5136 = addmethodrealflags(obj5134, "kind",&reader_ast_kind_5136, MFLAG_DEF);
  reader5136->definitionModule = modulename;
  reader5136->definitionLine = 1171;
}
adddatum2(obj5134, alloc_Undefined(), 1);
if (objclass5134 == NULL) {
  Method *reader5137 = addmethodrealflags(obj5134, "sourceLines",&reader_ast_sourceLines_5137, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader5137->definitionModule = modulename;
  reader5137->definitionLine = 1172;
}
adddatum2(obj5134, alloc_Undefined(), 2);
if (objclass5134 == NULL) {
  Method *reader5138 = addmethodrealflags(obj5134, "imports",&reader_ast_imports_5138, 0);
  Method *writer5138 = addmethodrealflags(obj5134, "imports:=",&writer_ast_imports_5138, 0);
  reader5138->definitionModule = modulename;
  writer5138->definitionModule = modulename;
  reader5138->definitionLine = 1175;
  writer5138->definitionLine = 1175;
}
obj5134->flags |= OFLAG_MUTABLE;
adddatum2(obj5134, alloc_Undefined(), 3);
// method "isModule"
  struct UserObject *uo5139 = (struct UserObject*)obj5134;
  uo5139->data[4] = emptyclosure;
  Method *meth_meth_ast_isModule5139 = addmethod2pos(obj5134, "isModule", &meth_ast_isModule5139, 4);
  int argcv_meth_ast_isModule5139[] = {0};
  meth_meth_ast_isModule5139->type = alloc_MethodType(1, argcv_meth_ast_isModule5139);
  meth_meth_ast_isModule5139->definitionModule = modulename;
  meth_meth_ast_isModule5139->definitionLine = 1177;
// method "returnsObject"
  struct UserObject *uo5141 = (struct UserObject*)obj5134;
  uo5141->data[5] = emptyclosure;
  Method *meth_meth_ast_returnsObject5141 = addmethod2pos(obj5134, "returnsObject", &meth_ast_returnsObject5141, 5);
  int argcv_meth_ast_returnsObject5141[] = {0};
  meth_meth_ast_returnsObject5141->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5141);
  meth_meth_ast_returnsObject5141->definitionModule = modulename;
  meth_meth_ast_returnsObject5141->definitionLine = 1178;
// method "externalsDo"
  struct UserObject *uo5143 = (struct UserObject*)obj5134;
  uo5143->data[6] = emptyclosure;
  Method *meth_meth_ast_externalsDo5143 = addmethod2pos(obj5134, "externalsDo", &meth_ast_externalsDo5143, 6);
  int argcv_meth_ast_externalsDo5143[] = {1};
  meth_meth_ast_externalsDo5143->type = alloc_MethodType(1, argcv_meth_ast_externalsDo5143);
  meth_meth_ast_externalsDo5143->definitionModule = modulename;
  meth_meth_ast_externalsDo5143->definitionLine = 1179;
// method "accept()from"
  struct UserObject *uo5156 = (struct UserObject*)obj5134;
  uo5156->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5156 = addmethod2pos(obj5134, "accept()from", &meth_ast_accept_40__41_from5156, 7);
  int argcv_meth_ast_accept_40__41_from5156[] = {1, 1};
  meth_meth_ast_accept_40__41_from5156->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5156);
  meth_meth_ast_accept_40__41_from5156->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5156->definitionLine = 1184;
// method "shallowCopy"
  block_savedest(obj5134);
  Object closure5182 = createclosure(2, "shallowCopy");
  setclosureframe(closure5182, stackframe);
  addtoclosure(closure5182, var_emptySeq);
  addtoclosure(closure5182, var_moduleNode);
  struct UserObject *uo5182 = (struct UserObject*)obj5134;
  uo5182->data[8] = (Object)closure5182;
  Method *meth_meth_ast_shallowCopy5182 = addmethod2pos(obj5134, "shallowCopy", &meth_ast_shallowCopy5182, 8);
  int argcv_meth_ast_shallowCopy5182[] = {0};
  meth_meth_ast_shallowCopy5182->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5182);
  meth_meth_ast_shallowCopy5182->definitionModule = modulename;
  meth_meth_ast_shallowCopy5182->definitionLine = 1195;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5187 = (struct UserObject*)obj5134;
  uo5187->data[9] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5187 = addmethod2pos(obj5134, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5187, 9);
  int argcv_meth_ast_shallowCopyFieldsFrom5187[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5187->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5187);
  meth_meth_ast_shallowCopyFieldsFrom5187->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5187->definitionLine = 1198;
  sourceObject = obj5134;
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5194 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
  Object bool5195 = alloc_Boolean(0);
// compiled identifier node returning bool5195 (depth = 4)
  gc_frame_newslot(bool5195);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objectNode (depth = 4)
  params[0] = *var_b;
  params[1] = bool5195;
  params[2] = self;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5196 = callmethod(*var_objectNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5194);
// compiled call node returning call5196 (depth = 3)
  struct UserObject *obj5134_uo = (struct UserObject *)obj5134;
  obj5134_uo->super = call5196;
  sourceObject = obj5134;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5197 == NULL) {
    strlit5197 = alloc_String("module");
    gc_root(strlit5197);
  }
// compiled string node returning strlit5197 (depth = 3)
  adddatum2(obj5134, strlit5197, 1);
  sourceObject = obj5134;
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call5199 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5198);
// compiled call node returning call5199 (depth = 4)
// compiled member node returning call5199 (depth = 3)
  adddatum2(obj5134, call5199, 2);
  sourceObject = obj5134;
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5200 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5201 = alloc_Float64(0);
// compiled num node returning num5201 (depth = 4)
  gc_frame_newslot(num5201);
// call case 4: self request
  params[0] = num5201;
  partcv[0] = 1;
  Object call5202 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5200);
// compiled call node returning call5202 (depth = 3)
  sourceObject = obj5134;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5203 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5204 = alloc_Float64(0);
// compiled num node returning num5204 (depth = 4)
  gc_frame_newslot(num5204);
// call case 4: self request
  params[0] = num5204;
  partcv[0] = 1;
  Object call5205 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5203);
// compiled call node returning call5205 (depth = 3)
  sourceObject = obj5134;
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5206 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5206 (depth = 3)
  adddatum2(obj5134, array5206, 3);
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  sourceObject = obj5134;
  objclass5134 = obj5134->class;
  objclass5134->definitionModule = modulename;
  objclass5134->definitionLine = 1169;
  (*(struct UserObject *)self).data[0] = lowerouter5134;
  self = oldself5134;
  selfslot = oldselfslot5134;
  stackframe = oldstackframe5134;
  gc_frame_end(frame);
  return obj5134;
}
Object meth_ast_moduleNode5208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleNode (depth = 3)
  gc_frame_end(frame);
  return *var_moduleNode;
}
Object meth_ast_body_40__41_named_40__41_scope5211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body()named()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for body()named()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5212 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
  Object bool5213 = alloc_Boolean(0);
// compiled identifier node returning bool5213 (depth = 5)
  gc_frame_newslot(bool5213);
// call case 4: self request
  params[0] = *var_b;
  params[1] = bool5213;
  partcv[0] = 2;
  Object call5214 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5212);
// compiled call node returning call5214 (depth = 4)
  *var_result = call5214;
  if (call5214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5215 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5216 = callmethod(*var_result, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5215);
// compiled call node returning call5216 (depth = 3)
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5217 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5218 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe5217);
// compiled call node returning call5218 (depth = 3)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_body_40__41_named5219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "body()named");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method body()named");
  Object params[3];
  int partcv[3];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for body()named (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *var_n = &(stackframe->slots[1]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for named");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5220 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_fakeSymbolTable (depth = 4)
  gc_frame_newslot(*var_fakeSymbolTable);
// call case 4: self request
  params[0] = *var_b;
  params[1] = *var_n;
  params[2] = *var_fakeSymbolTable;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5221 = callmethodflags(self, "body()named()scope", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5220);
// compiled call node returning call5221 (depth = 3)
  gc_frame_end(frame);
  return call5221;
}
Object meth_ast_description5234(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "description");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for description (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for description");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5236 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5237 = callmethodflags(self, "isTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5236);
// compiled call node returning call5237 (depth = 5)
// compiled member node returning call5237 (depth = 4)
  Object if5235 = done;
  if (istrue(call5237)) {
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5239 == NULL) {
    strlit5239 = alloc_String(" (trait)");
    gc_root(strlit5239);
  }
// compiled string node returning strlit5239 (depth = 5)
  int op_slot_right_5238 = gc_frame_newslot(strlit5239);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5243 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5242);
// compiled call node returning call5243 (depth = 7)
// compiled member node returning call5243 (depth = 6)
  int op_slot_right_5241 = gc_frame_newslot(call5243);
// starting to compile string node (depth = 6)
  if (strlit5245 == NULL) {
    strlit5245 = alloc_String("");
    gc_root(strlit5245);
  }
// compiled string node returning strlit5245 (depth = 6)
  int op_slot_left_5241 = gc_frame_newslot(strlit5245);
  params[0] = call5243;
  partcv[0] = 1;
  Object opresult5246 = callmethod(strlit5245, "++", 1, partcv, params);
// compiled op node returning opresult5246 (depth = 5)
  int op_slot_left_5238 = gc_frame_newslot(opresult5246);
  params[0] = strlit5239;
  partcv[0] = 1;
  Object opresult5247 = callmethod(opresult5246, "++", 1, partcv, params);
// compiled op node returning opresult5247 (depth = 4)
    gc_frame_newslot(opresult5247);
    if5235 = opresult5247;
  } else {
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5250 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5249);
// compiled call node returning call5250 (depth = 6)
// compiled member node returning call5250 (depth = 5)
  Object if5248 = done;
  if (istrue(call5250)) {
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5252 == NULL) {
    strlit5252 = alloc_String(" (class)");
    gc_root(strlit5252);
  }
// compiled string node returning strlit5252 (depth = 6)
  int op_slot_right_5251 = gc_frame_newslot(strlit5252);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5256 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5255);
// compiled call node returning call5256 (depth = 8)
// compiled member node returning call5256 (depth = 7)
  int op_slot_right_5254 = gc_frame_newslot(call5256);
// starting to compile string node (depth = 7)
  if (strlit5258 == NULL) {
    strlit5258 = alloc_String("");
    gc_root(strlit5258);
  }
// compiled string node returning strlit5258 (depth = 7)
  int op_slot_left_5254 = gc_frame_newslot(strlit5258);
  params[0] = call5256;
  partcv[0] = 1;
  Object opresult5259 = callmethod(strlit5258, "++", 1, partcv, params);
// compiled op node returning opresult5259 (depth = 6)
  int op_slot_left_5251 = gc_frame_newslot(opresult5259);
  params[0] = strlit5252;
  partcv[0] = 1;
  Object opresult5260 = callmethod(opresult5259, "++", 1, partcv, params);
// compiled op node returning opresult5260 (depth = 5)
    gc_frame_newslot(opresult5260);
    if5248 = opresult5260;
  } else {
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5261 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5262 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5261);
// compiled call node returning call5262 (depth = 6)
// compiled member node returning call5262 (depth = 5)
    gc_frame_newslot(call5262);
    if5248 = call5262;
  }
// compiled if node returning if5248 (depth = 4)
    gc_frame_newslot(if5248);
    if5235 = if5248;
  }
// compiled if node returning if5235 (depth = 3)
  gc_frame_end(frame);
  return if5235;
}
Object meth_ast__apply5278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5280 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call5282 = callmethod(*var_each, "isLegalInTrait",
    1, partcv, params);
  gc_frame_end(callframe5281);
// compiled call node returning call5282 (depth = 9)
// compiled member node returning call5282 (depth = 8)
  partcv[0] = 0;
  Object call5283 = callmethod(call5282, "not",
    1, partcv, params);
  gc_frame_end(callframe5280);
// compiled call node returning call5283 (depth = 7)
// compiled member node returning call5283 (depth = 6)
  Object if5279 = done;
  if (istrue(call5283)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5284 = alloc_Boolean(0);
// compiled identifier node returning bool5284 (depth = 7)
  block_return(realself, bool5284);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5279 = undefined;
  } else {
  }
// compiled if node returning if5279 (depth = 5)
  gc_frame_end(frame);
  return if5279;
}
Object meth_ast_isTrait5263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5265 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5266 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5265);
// compiled call node returning call5266 (depth = 5)
// compiled member node returning call5266 (depth = 4)
  Object if5264 = done;
  if (istrue(call5266)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5267 = alloc_Boolean(1);
// compiled identifier node returning bool5267 (depth = 5)
  return bool5267;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5264 = undefined;
  } else {
  }
// compiled if node returning if5264 (depth = 3)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5271 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5270);
// compiled call node returning call5271 (depth = 6)
// compiled member node returning call5271 (depth = 5)
  int op_slot_right_5269 = gc_frame_newslot(call5271);
// starting to compile identifier node (depth = 5)
  Object bool5273 = alloc_Boolean(0);
// compiled identifier node returning bool5273 (depth = 5)
  int op_slot_left_5269 = gc_frame_newslot(bool5273);
  params[0] = call5271;
  partcv[0] = 1;
  Object opresult5274 = callmethod(bool5273, "≠", 1, partcv, params);
// compiled op node returning opresult5274 (depth = 4)
  Object if5268 = done;
  if (istrue(opresult5274)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5275 = alloc_Boolean(0);
// compiled identifier node returning bool5275 (depth = 5)
  return bool5275;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5268 = undefined;
  } else {
  }
// compiled if node returning if5268 (depth = 3)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5276 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5277 = alloc_Block(NULL, NULL, "ast", 1241);
  gc_frame_newslot(block5277);
// method "_apply"
  block_savedest(block5277);
  Object closure5278 = createclosure(1, "_apply");
  setclosureframe(closure5278, stackframe);
  addtoclosure(closure5278, selfslot);
  struct UserObject *uo5278 = (struct UserObject*)block5277;
  uo5278->data[0] = (Object)closure5278;
  Method *meth_meth_ast__apply5278 = addmethod2pos(block5277, "_apply", &meth_ast__apply5278, 0);
  int argcv_meth_ast__apply5278[] = {1};
  meth_meth_ast__apply5278->type = alloc_MethodType(1, argcv_meth_ast__apply5278);
  meth_meth_ast__apply5278->definitionModule = modulename;
  meth_meth_ast__apply5278->definitionLine = 1240;
// compiled block node returning block5277 (depth = 4)
  gc_frame_newslot(block5277);
// call case 6: other member request
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5287 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5286);
// compiled call node returning call5287 (depth = 5)
// compiled member node returning call5287 (depth = 4)
  params[0] = block5277;
  partcv[0] = 1;
  Object call5288 = callmethod(call5287, "do",
    1, partcv, params);
  gc_frame_end(callframe5276);
// compiled call node returning call5288 (depth = 3)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5289 = alloc_Boolean(1);
// compiled identifier node returning bool5289 (depth = 4)
  return bool5289;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply5304(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5307 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5308 = callmethod(*var_node, "isMethod",
    1, partcv, params);
  gc_frame_end(callframe5307);
// compiled call node returning call5308 (depth = 9)
// compiled member node returning call5308 (depth = 8)
  int op_slot_right_5306 = gc_frame_newslot(call5308);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5311 = callmethod(*var_node, "isFieldDec",
    1, partcv, params);
  gc_frame_end(callframe5310);
// compiled call node returning call5311 (depth = 9)
// compiled member node returning call5311 (depth = 8)
  int op_slot_left_5306 = gc_frame_newslot(call5311);
  params[0] = call5308;
  partcv[0] = 1;
  Object opresult5312 = callmethod(call5311, "||", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 7)
  Object if5305 = done;
  if (istrue(opresult5312)) {
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5313 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call5315 = callmethod(*var_node, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5314);
// compiled call node returning call5315 (depth = 9)
// compiled member node returning call5315 (depth = 8)
  gc_frame_newslot(call5315);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5317 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5316);
// compiled call node returning call5317 (depth = 9)
// compiled member node returning call5317 (depth = 8)
  params[0] = call5315;
  partcv[0] = 1;
  Object call5318 = callmethod(call5317, "add",
    1, partcv, params);
  gc_frame_end(callframe5313);
// compiled call node returning call5318 (depth = 7)
    gc_frame_newslot(call5318);
    if5305 = call5318;
  } else {
  }
// compiled if node returning if5305 (depth = 6)
  gc_frame_end(frame);
  return if5305;
}
Object meth_ast_localNames5290(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "localNames");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for localNames (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for localNames");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5294 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5293);
// compiled call node returning call5294 (depth = 6)
// compiled member node returning call5294 (depth = 5)
  int op_slot_right_5292 = gc_frame_newslot(call5294);
// starting to compile identifier node (depth = 5)
  Object bool5296 = alloc_Boolean(0);
// compiled identifier node returning bool5296 (depth = 5)
  int op_slot_left_5292 = gc_frame_newslot(bool5296);
  params[0] = call5294;
  partcv[0] = 1;
  Object opresult5297 = callmethod(bool5296, "==", 1, partcv, params);
// compiled op node returning opresult5297 (depth = 4)
  Object if5291 = done;
  if (istrue(opresult5297)) {
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5298 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5299 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5300 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5299);
// compiled call node returning call5300 (depth = 6)
// compiled member node returning call5300 (depth = 5)
  gc_frame_newslot(call5300);
// call case 4: self request
  params[0] = call5300;
  partcv[0] = 1;
  Object call5301 = callmethodflags(self, "myLocalNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5298);
// compiled call node returning call5301 (depth = 4)
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5302 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5303 = alloc_Block(NULL, NULL, "ast", 1252);
  gc_frame_newslot(block5303);
// method "_apply"
  block_savedest(block5303);
  Object closure5304 = createclosure(1, "_apply");
  setclosureframe(closure5304, stackframe);
  addtoclosure(closure5304, selfslot);
  struct UserObject *uo5304 = (struct UserObject*)block5303;
  uo5304->data[0] = (Object)closure5304;
  Method *meth_meth_ast__apply5304 = addmethod2pos(block5303, "_apply", &meth_ast__apply5304, 0);
  int argcv_meth_ast__apply5304[] = {1};
  meth_meth_ast__apply5304->type = alloc_MethodType(1, argcv_meth_ast__apply5304);
  meth_meth_ast__apply5304->definitionModule = modulename;
  meth_meth_ast__apply5304->definitionLine = 1251;
// compiled block node returning block5303 (depth = 5)
  gc_frame_newslot(block5303);
// call case 6: other member request
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5321 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5320);
// compiled call node returning call5321 (depth = 6)
// compiled member node returning call5321 (depth = 5)
  params[0] = block5303;
  partcv[0] = 1;
  Object call5322 = callmethod(call5321, "do",
    1, partcv, params);
  gc_frame_end(callframe5302);
// compiled call node returning call5322 (depth = 4)
    gc_frame_newslot(call5322);
    if5291 = call5322;
  } else {
  }
// compiled if node returning if5291 (depth = 3)
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5324 = callmethodflags(self, "myLocalNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5323);
// compiled call node returning call5324 (depth = 4)
// compiled member node returning call5324 (depth = 3)
  gc_frame_end(frame);
  return call5324;
}
Object meth_ast__apply5339(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5340 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call5341 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5340);
// compiled call node returning call5341 (depth = 5)
  gc_frame_end(frame);
  return call5341;
}
Object meth_ast_parentsDo5325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parentsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parentsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parentsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5329 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5328);
// compiled call node returning call5329 (depth = 6)
// compiled member node returning call5329 (depth = 5)
  int op_slot_right_5327 = gc_frame_newslot(call5329);
// starting to compile identifier node (depth = 5)
  Object bool5331 = alloc_Boolean(0);
// compiled identifier node returning bool5331 (depth = 5)
  int op_slot_left_5327 = gc_frame_newslot(bool5331);
  params[0] = call5329;
  partcv[0] = 1;
  Object opresult5332 = callmethod(bool5331, "≠", 1, partcv, params);
// compiled op node returning opresult5332 (depth = 4)
  Object if5326 = done;
  if (istrue(opresult5332)) {
// starting to compile call node (depth = 4)
  int callframe5333 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5335 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5334);
// compiled call node returning call5335 (depth = 6)
// compiled member node returning call5335 (depth = 5)
  gc_frame_newslot(call5335);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call5335;
  partcv[0] = 1;
  Object call5336 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5333);
// compiled call node returning call5336 (depth = 4)
    gc_frame_newslot(call5336);
    if5326 = call5336;
  } else {
  }
// compiled if node returning if5326 (depth = 3)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5337 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5338 = alloc_Block(NULL, NULL, "ast", 1265);
  gc_frame_newslot(block5338);
// method "_apply"
  block_savedest(block5338);
  Object closure5339 = createclosure(2, "_apply");
  setclosureframe(closure5339, stackframe);
  addtoclosure(closure5339, var_action);
  addtoclosure(closure5339, selfslot);
  struct UserObject *uo5339 = (struct UserObject*)block5338;
  uo5339->data[0] = (Object)closure5339;
  Method *meth_meth_ast__apply5339 = addmethod2pos(block5338, "_apply", &meth_ast__apply5339, 0);
  int argcv_meth_ast__apply5339[] = {1};
  meth_meth_ast__apply5339->type = alloc_MethodType(1, argcv_meth_ast__apply5339);
  meth_meth_ast__apply5339->definitionModule = modulename;
  meth_meth_ast__apply5339->definitionLine = 1264;
// compiled block node returning block5338 (depth = 4)
  gc_frame_newslot(block5338);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5344 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5343);
// compiled call node returning call5344 (depth = 5)
// compiled member node returning call5344 (depth = 4)
  params[0] = block5338;
  partcv[0] = 1;
  Object call5345 = callmethod(call5344, "do",
    1, partcv, params);
  gc_frame_end(callframe5337);
// compiled call node returning call5345 (depth = 3)
  gc_frame_end(frame);
  return call5345;
}
Object meth_ast__apply5349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5351 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5352 = callmethod(*var_o, "isMethod",
    1, partcv, params);
  gc_frame_end(callframe5351);
// compiled call node returning call5352 (depth = 7)
// compiled member node returning call5352 (depth = 6)
  Object if5350 = done;
  if (istrue(call5352)) {
// starting to compile call node (depth = 6)
  int callframe5353 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5354 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5353);
// compiled call node returning call5354 (depth = 6)
    gc_frame_newslot(call5354);
    if5350 = call5354;
  } else {
  }
// compiled if node returning if5350 (depth = 5)
  gc_frame_end(frame);
  return if5350;
}
Object meth_ast_methodsDo5346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "methodsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5347 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5348 = alloc_Block(NULL, NULL, "ast", 1271);
  gc_frame_newslot(block5348);
// method "_apply"
  block_savedest(block5348);
  Object closure5349 = createclosure(2, "_apply");
  setclosureframe(closure5349, stackframe);
  addtoclosure(closure5349, var_action);
  addtoclosure(closure5349, selfslot);
  struct UserObject *uo5349 = (struct UserObject*)block5348;
  uo5349->data[0] = (Object)closure5349;
  Method *meth_meth_ast__apply5349 = addmethod2pos(block5348, "_apply", &meth_ast__apply5349, 0);
  int argcv_meth_ast__apply5349[] = {1};
  meth_meth_ast__apply5349->type = alloc_MethodType(1, argcv_meth_ast__apply5349);
  meth_meth_ast__apply5349->definitionModule = modulename;
  meth_meth_ast__apply5349->definitionLine = 1265;
// compiled block node returning block5348 (depth = 4)
  gc_frame_newslot(block5348);
// call case 6: other member request
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5356 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5357 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5356);
// compiled call node returning call5357 (depth = 5)
// compiled member node returning call5357 (depth = 4)
  params[0] = block5348;
  partcv[0] = 1;
  Object call5358 = callmethod(call5357, "do",
    1, partcv, params);
  gc_frame_end(callframe5347);
// compiled call node returning call5358 (depth = 3)
  gc_frame_end(frame);
  return call5358;
}
Object meth_ast__apply5362(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5364 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call5365 = callmethod(*var_o, "isExecutable",
    1, partcv, params);
  gc_frame_end(callframe5364);
// compiled call node returning call5365 (depth = 7)
// compiled member node returning call5365 (depth = 6)
  Object if5363 = done;
  if (istrue(call5365)) {
// starting to compile call node (depth = 6)
  int callframe5366 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5367 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5366);
// compiled call node returning call5367 (depth = 6)
    gc_frame_newslot(call5367);
    if5363 = call5367;
  } else {
  }
// compiled if node returning if5363 (depth = 5)
  gc_frame_end(frame);
  return if5363;
}
Object meth_ast_executableComponentsDo5359(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "executableComponentsDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method executableComponentsDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for executableComponentsDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for executableComponentsDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5360 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5361 = alloc_Block(NULL, NULL, "ast", 1279);
  gc_frame_newslot(block5361);
// method "_apply"
  block_savedest(block5361);
  Object closure5362 = createclosure(2, "_apply");
  setclosureframe(closure5362, stackframe);
  addtoclosure(closure5362, var_action);
  addtoclosure(closure5362, selfslot);
  struct UserObject *uo5362 = (struct UserObject*)block5361;
  uo5362->data[0] = (Object)closure5362;
  Method *meth_meth_ast__apply5362 = addmethod2pos(block5361, "_apply", &meth_ast__apply5362, 0);
  int argcv_meth_ast__apply5362[] = {1};
  meth_meth_ast__apply5362->type = alloc_MethodType(1, argcv_meth_ast__apply5362);
  meth_meth_ast__apply5362->definitionModule = modulename;
  meth_meth_ast__apply5362->definitionLine = 1271;
// compiled block node returning block5361 (depth = 4)
  gc_frame_newslot(block5361);
// call case 6: other member request
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5369 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5370 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5369);
// compiled call node returning call5370 (depth = 5)
// compiled member node returning call5370 (depth = 4)
  params[0] = block5361;
  partcv[0] = 1;
  Object call5371 = callmethod(call5370, "do",
    1, partcv, params);
  gc_frame_end(callframe5360);
// compiled call node returning call5371 (depth = 3)
  gc_frame_end(frame);
  return call5371;
}
Object meth_ast_scope_58__61_5372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method scope:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for scope:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_st = &(stackframe->slots[0]);
  *var_st = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5373 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  gc_frame_newslot(*var_st);
// call case 4: self request
  params[0] = *var_st;
  partcv[0] = 1;
  Object call5374 = callmethodflags(self, "symbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5373);
// compiled call node returning call5374 (depth = 3)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5375 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_st (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5376 = callmethod(*var_st, "node:=",
    1, partcv, params);
  gc_frame_end(callframe5375);
// compiled call node returning call5376 (depth = 3)
  gc_frame_end(frame);
  return call5376;
}
Object meth_ast_body5377(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "body");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for body (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for body");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5378 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5379 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5378);
// compiled call node returning call5379 (depth = 4)
// compiled member node returning call5379 (depth = 3)
  gc_frame_end(frame);
  return call5379;
}
Object meth_ast_returnsObject5380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5381 = alloc_Boolean(1);
// compiled identifier node returning bool5381 (depth = 3)
  gc_frame_end(frame);
  return bool5381;
}
Object meth_ast_returnedObjectScope5382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5384 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5383);
// compiled call node returning call5384 (depth = 4)
// compiled member node returning call5384 (depth = 3)
  gc_frame_end(frame);
  return call5384;
}
Object meth_ast_canInherit5385(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canInherit");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canInherit (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canInherit");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5386 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5388 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5387);
// compiled call node returning call5388 (depth = 6)
// compiled member node returning call5388 (depth = 5)
  partcv[0] = 0;
  Object call5389 = callmethod(call5388, "not",
    1, partcv, params);
  gc_frame_end(callframe5386);
// compiled call node returning call5389 (depth = 4)
// compiled member node returning call5389 (depth = 3)
  gc_frame_end(frame);
  return call5389;
}
Object meth_ast_canUse5390(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "canUse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for canUse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for canUse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5391 = alloc_Boolean(1);
// compiled identifier node returning bool5391 (depth = 3)
  gc_frame_end(frame);
  return bool5391;
}
Object meth_ast_isObject5392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5393 = alloc_Boolean(1);
// compiled identifier node returning bool5393 (depth = 3)
  gc_frame_end(frame);
  return bool5393;
}
Object meth_ast__apply5413(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5414 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5415 = callmethod(*var_t, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5414);
// compiled call node returning call5415 (depth = 6)
  gc_frame_end(frame);
  return call5415;
}
Object meth_ast__apply5422(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5423 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5424 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5423);
// compiled call node returning call5424 (depth = 6)
  gc_frame_end(frame);
  return call5424;
}
Object meth_ast_accept_40__41_from5394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5396 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5397 = callmethod(*var_visitor, "visitObject()up",
    2, partcv, params);
  gc_frame_end(callframe5396);
// compiled call node returning call5397 (depth = 4)
  Object if5395 = done;
  if (istrue(call5397)) {
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5398 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5399 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5398);
// compiled call node returning call5399 (depth = 5)
  *var_newChain = call5399;
  if (call5399 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5403 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5402);
// compiled call node returning call5403 (depth = 7)
// compiled member node returning call5403 (depth = 6)
  int op_slot_right_5401 = gc_frame_newslot(call5403);
// starting to compile identifier node (depth = 6)
  Object bool5405 = alloc_Boolean(0);
// compiled identifier node returning bool5405 (depth = 6)
  int op_slot_left_5401 = gc_frame_newslot(bool5405);
  params[0] = call5403;
  partcv[0] = 1;
  Object opresult5406 = callmethod(bool5405, "≠", 1, partcv, params);
// compiled op node returning opresult5406 (depth = 5)
  Object if5400 = done;
  if (istrue(opresult5406)) {
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5407 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5408 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5409 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5408);
// compiled call node returning call5409 (depth = 7)
// compiled member node returning call5409 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5410 = callmethod(call5409, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5407);
// compiled call node returning call5410 (depth = 5)
    gc_frame_newslot(call5410);
    if5400 = call5410;
  } else {
  }
// compiled if node returning if5400 (depth = 4)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5411 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5412 = alloc_Block(NULL, NULL, "ast", 1302);
  gc_frame_newslot(block5412);
// method "_apply"
  block_savedest(block5412);
  Object closure5413 = createclosure(3, "_apply");
  setclosureframe(closure5413, stackframe);
  addtoclosure(closure5413, var_visitor);
  addtoclosure(closure5413, var_newChain);
  addtoclosure(closure5413, selfslot);
  struct UserObject *uo5413 = (struct UserObject*)block5412;
  uo5413->data[0] = (Object)closure5413;
  Method *meth_meth_ast__apply5413 = addmethod2pos(block5412, "_apply", &meth_ast__apply5413, 0);
  int argcv_meth_ast__apply5413[] = {1};
  meth_meth_ast__apply5413->type = alloc_MethodType(1, argcv_meth_ast__apply5413);
  meth_meth_ast__apply5413->definitionModule = modulename;
  meth_meth_ast__apply5413->definitionLine = 1300;
// compiled block node returning block5412 (depth = 5)
  gc_frame_newslot(block5412);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5417 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5418 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5417);
// compiled call node returning call5418 (depth = 6)
// compiled member node returning call5418 (depth = 5)
  params[0] = block5412;
  partcv[0] = 1;
  Object call5419 = callmethod(call5418, "do",
    1, partcv, params);
  gc_frame_end(callframe5411);
// compiled call node returning call5419 (depth = 4)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5420 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5421 = alloc_Block(NULL, NULL, "ast", 1303);
  gc_frame_newslot(block5421);
// method "_apply"
  block_savedest(block5421);
  Object closure5422 = createclosure(3, "_apply");
  setclosureframe(closure5422, stackframe);
  addtoclosure(closure5422, var_visitor);
  addtoclosure(closure5422, var_newChain);
  addtoclosure(closure5422, selfslot);
  struct UserObject *uo5422 = (struct UserObject*)block5421;
  uo5422->data[0] = (Object)closure5422;
  Method *meth_meth_ast__apply5422 = addmethod2pos(block5421, "_apply", &meth_ast__apply5422, 0);
  int argcv_meth_ast__apply5422[] = {1};
  meth_meth_ast__apply5422->type = alloc_MethodType(1, argcv_meth_ast__apply5422);
  meth_meth_ast__apply5422->definitionModule = modulename;
  meth_meth_ast__apply5422->definitionLine = 1302;
// compiled block node returning block5421 (depth = 5)
  gc_frame_newslot(block5421);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5426 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5427 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5426);
// compiled call node returning call5427 (depth = 6)
// compiled member node returning call5427 (depth = 5)
  params[0] = block5421;
  partcv[0] = 1;
  Object call5428 = callmethod(call5427, "do",
    1, partcv, params);
  gc_frame_end(callframe5420);
// compiled call node returning call5428 (depth = 4)
    gc_frame_newslot(call5428);
    if5395 = call5428;
  } else {
  }
// compiled if node returning if5395 (depth = 3)
  gc_frame_end(frame);
  return if5395;
}
Object meth_ast_nameString5429(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5432 == NULL) {
    strlit5432 = alloc_String("object");
    gc_root(strlit5432);
  }
// compiled string node returning strlit5432 (depth = 5)
  int op_slot_right_5431 = gc_frame_newslot(strlit5432);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5434 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5435 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5434);
// compiled call node returning call5435 (depth = 6)
// compiled member node returning call5435 (depth = 5)
  int op_slot_left_5431 = gc_frame_newslot(call5435);
  params[0] = strlit5432;
  partcv[0] = 1;
  Object opresult5436 = callmethod(call5435, "==", 1, partcv, params);
// compiled op node returning opresult5436 (depth = 4)
  Object if5430 = done;
  if (istrue(opresult5436)) {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5438 == NULL) {
    strlit5438 = alloc_String("");
    gc_root(strlit5438);
  }
// compiled string node returning strlit5438 (depth = 5)
  int op_slot_right_5437 = gc_frame_newslot(strlit5438);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5441 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5442 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5441);
// compiled call node returning call5442 (depth = 7)
// compiled member node returning call5442 (depth = 6)
  int op_slot_right_5440 = gc_frame_newslot(call5442);
// starting to compile string node (depth = 6)
  if (strlit5444 == NULL) {
    strlit5444 = alloc_String("object_on_line_");
    gc_root(strlit5444);
  }
// compiled string node returning strlit5444 (depth = 6)
  int op_slot_left_5440 = gc_frame_newslot(strlit5444);
  params[0] = call5442;
  partcv[0] = 1;
  Object opresult5445 = callmethod(strlit5444, "++", 1, partcv, params);
// compiled op node returning opresult5445 (depth = 5)
  int op_slot_left_5437 = gc_frame_newslot(opresult5445);
  params[0] = strlit5438;
  partcv[0] = 1;
  Object opresult5446 = callmethod(opresult5445, "++", 1, partcv, params);
// compiled op node returning opresult5446 (depth = 4)
    gc_frame_newslot(opresult5446);
    if5430 = opresult5446;
  } else {
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5448 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5447);
// compiled call node returning call5448 (depth = 5)
// compiled member node returning call5448 (depth = 4)
    gc_frame_newslot(call5448);
    if5430 = call5448;
  }
// compiled if node returning if5430 (depth = 3)
  gc_frame_end(frame);
  return if5430;
}
Object meth_ast_map_40__41_ancestors5449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5450 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5451 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5450);
// compiled call node returning call5451 (depth = 5)
// compiled member node returning call5451 (depth = 4)
  *var_n = call5451;
  if (call5451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5452 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5453 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5452);
// compiled call node returning call5453 (depth = 4)
  *var_newChain = call5453;
  if (call5453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5454 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5455 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5456 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5457 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5456);
// compiled call node returning call5457 (depth = 6)
// compiled member node returning call5457 (depth = 5)
  gc_frame_newslot(call5457);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5458 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5459 = gc_frame_new();
// call case 3: self.outer request
  Object call5460 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5459);
// compiled call node returning call5460 (depth = 8)
// compiled member node returning call5460 (depth = 7)
  partcv[0] = 0;
  Object call5461 = callmethodflags(call5460, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5458);
// compiled call node returning call5461 (depth = 6)
// compiled member node returning call5461 (depth = 5)
  params[0] = call5457;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5462 = callmethodflags(call5461, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5455);
// compiled call node returning call5462 (depth = 4)
  gc_frame_newslot(call5462);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5462;
  partcv[0] = 1;
  Object call5463 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5454);
// compiled call node returning call5463 (depth = 3)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5464 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5465 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5467 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5466);
// compiled call node returning call5467 (depth = 6)
// compiled member node returning call5467 (depth = 5)
  gc_frame_newslot(call5467);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5468 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5469 = gc_frame_new();
// call case 3: self.outer request
  Object call5470 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5469);
// compiled call node returning call5470 (depth = 8)
// compiled member node returning call5470 (depth = 7)
  partcv[0] = 0;
  Object call5471 = callmethodflags(call5470, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5468);
// compiled call node returning call5471 (depth = 6)
// compiled member node returning call5471 (depth = 5)
  params[0] = call5467;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5472 = callmethodflags(call5471, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5465);
// compiled call node returning call5472 (depth = 4)
  gc_frame_newslot(call5472);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5472;
  partcv[0] = 1;
  Object call5473 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe5464);
// compiled call node returning call5473 (depth = 3)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5474 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5475 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5477 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5476);
// compiled call node returning call5477 (depth = 6)
// compiled member node returning call5477 (depth = 5)
  gc_frame_newslot(call5477);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5478 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5479 = gc_frame_new();
// call case 3: self.outer request
  Object call5480 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5479);
// compiled call node returning call5480 (depth = 8)
// compiled member node returning call5480 (depth = 7)
  partcv[0] = 0;
  Object call5481 = callmethodflags(call5480, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5478);
// compiled call node returning call5481 (depth = 6)
// compiled member node returning call5481 (depth = 5)
  params[0] = call5477;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5482 = callmethodflags(call5481, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5475);
// compiled call node returning call5482 (depth = 4)
  gc_frame_newslot(call5482);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5482;
  partcv[0] = 1;
  Object call5483 = callmethod(*var_n, "usedTraits:=",
    1, partcv, params);
  gc_frame_end(callframe5474);
// compiled call node returning call5483 (depth = 3)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5484 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5485 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5484);
// compiled call node returning call5485 (depth = 3)
  gc_frame_end(frame);
  return call5485;
}
Object meth_ast__apply5494(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5496 == NULL) {
    strlit5496 = alloc_String("  ");
    gc_root(strlit5496);
  }
// compiled string node returning strlit5496 (depth = 7)
  int op_slot_right_5495 = gc_frame_newslot(strlit5496);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5495 = gc_frame_newslot(*var_spc);
  params[0] = strlit5496;
  partcv[0] = 1;
  Object opresult5498 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5498 (depth = 6)
  *var_spc = opresult5498;
  if (opresult5498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5580(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5582 == NULL) {
    strlit5582 = alloc_String("");
    gc_root(strlit5582);
  }
// compiled string node returning strlit5582 (depth = 8)
  int op_slot_right_5581 = gc_frame_newslot(strlit5582);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5585 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5587 = alloc_Float64(1);
// compiled num node returning num5587 (depth = 11)
  int op_slot_right_5586 = gc_frame_newslot(num5587);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_5586 = gc_frame_newslot(*var_depth);
  params[0] = num5587;
  partcv[0] = 1;
  Object sum5589 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5589 (depth = 10)
  gc_frame_newslot(sum5589);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  params[0] = sum5589;
  partcv[0] = 1;
  Object call5590 = callmethod(*var_t, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5585);
// compiled call node returning call5590 (depth = 9)
  int op_slot_right_5584 = gc_frame_newslot(call5590);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5593 == NULL) {
    strlit5593 = alloc_String("  ");
    gc_root(strlit5593);
  }
// compiled string node returning strlit5593 (depth = 10)
  int op_slot_right_5592 = gc_frame_newslot(strlit5593);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5595 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5598 == NULL) {
    strlit5598 = alloc_String("""\x0a""");
    gc_root(strlit5598);
  }
// compiled string node returning strlit5598 (depth = 12)
  int op_slot_right_5597 = gc_frame_newslot(strlit5598);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5600 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5602 == NULL) {
    strlit5602 = alloc_String("");
    gc_root(strlit5602);
  }
// compiled string node returning strlit5602 (depth = 13)
  int op_slot_left_5600 = gc_frame_newslot(strlit5602);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5603 = callmethod(strlit5602, "++", 1, partcv, params);
// compiled op node returning opresult5603 (depth = 12)
  int op_slot_left_5597 = gc_frame_newslot(opresult5603);
  params[0] = strlit5598;
  partcv[0] = 1;
  Object opresult5604 = callmethod(opresult5603, "++", 1, partcv, params);
// compiled op node returning opresult5604 (depth = 11)
  int op_slot_left_5595 = gc_frame_newslot(opresult5604);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5605 = callmethod(opresult5604, "++", 1, partcv, params);
// compiled op node returning opresult5605 (depth = 10)
  int op_slot_left_5592 = gc_frame_newslot(opresult5605);
  params[0] = strlit5593;
  partcv[0] = 1;
  Object opresult5606 = callmethod(opresult5605, "++", 1, partcv, params);
// compiled op node returning opresult5606 (depth = 9)
  int op_slot_left_5584 = gc_frame_newslot(opresult5606);
  params[0] = call5590;
  partcv[0] = 1;
  Object opresult5607 = callmethod(opresult5606, "++", 1, partcv, params);
// compiled op node returning opresult5607 (depth = 8)
  int op_slot_left_5581 = gc_frame_newslot(opresult5607);
  params[0] = strlit5582;
  partcv[0] = 1;
  Object opresult5608 = callmethod(opresult5607, "++", 1, partcv, params);
// compiled op node returning opresult5608 (depth = 7)
  *var_s = opresult5608;
  if (opresult5608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5616(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5618 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5620 = alloc_Float64(1);
// compiled num node returning num5620 (depth = 9)
  int op_slot_right_5619 = gc_frame_newslot(num5620);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5619 = gc_frame_newslot(*var_depth);
  params[0] = num5620;
  partcv[0] = 1;
  Object sum5622 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5622 (depth = 8)
  gc_frame_newslot(sum5622);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5622;
  partcv[0] = 1;
  Object call5623 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5618);
// compiled call node returning call5623 (depth = 7)
  int op_slot_right_5617 = gc_frame_newslot(call5623);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5625 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5628 == NULL) {
    strlit5628 = alloc_String("""\x0a""");
    gc_root(strlit5628);
  }
// compiled string node returning strlit5628 (depth = 9)
  int op_slot_right_5627 = gc_frame_newslot(strlit5628);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5627 = gc_frame_newslot(*var_s);
  params[0] = strlit5628;
  partcv[0] = 1;
  Object opresult5630 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5630 (depth = 8)
  int op_slot_left_5625 = gc_frame_newslot(opresult5630);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5631 = callmethod(opresult5630, "++", 1, partcv, params);
// compiled op node returning opresult5631 (depth = 7)
  int op_slot_left_5617 = gc_frame_newslot(opresult5631);
  params[0] = call5623;
  partcv[0] = 1;
  Object opresult5632 = callmethod(opresult5631, "++", 1, partcv, params);
// compiled op node returning opresult5632 (depth = 6)
  *var_s = opresult5632;
  if (opresult5632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth_39_ (depth = 4)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5487 == NULL) {
    strlit5487 = alloc_String("");
    gc_root(strlit5487);
  }
// compiled string node returning strlit5487 (depth = 4)
  *var_spc = strlit5487;
  if (strlit5487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5488 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5489 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5491 = alloc_Float64(0);
// compiled num node returning num5491 (depth = 5)
  int op_slot_left_5489 = gc_frame_newslot(num5491);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5492 = callmethod(num5491, "..", 1, partcv, params);
// compiled op node returning opresult5492 (depth = 4)
  gc_frame_newslot(opresult5492);
// starting to compile block node (depth = 4)
  Object block5493 = alloc_Block(NULL, NULL, "ast", 1324);
  gc_frame_newslot(block5493);
// method "_apply"
  block_savedest(block5493);
  Object closure5494 = createclosure(2, "_apply");
  setclosureframe(closure5494, stackframe);
  addtoclosure(closure5494, var_spc);
  addtoclosure(closure5494, selfslot);
  struct UserObject *uo5494 = (struct UserObject*)block5493;
  uo5494->data[0] = (Object)closure5494;
  Method *meth_meth_ast__apply5494 = addmethod2pos(block5493, "_apply", &meth_ast__apply5494, 0);
  int argcv_meth_ast__apply5494[] = {1};
  meth_meth_ast__apply5494->type = alloc_MethodType(1, argcv_meth_ast__apply5494);
  meth_meth_ast__apply5494->definitionModule = modulename;
  meth_meth_ast__apply5494->definitionLine = 1318;
// compiled block node returning block5493 (depth = 4)
  gc_frame_newslot(block5493);
// call case 5: prelude request
  params[0] = opresult5492;
  params[1] = block5493;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5501 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5488);
// compiled call node returning call5501 (depth = 3)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5502 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5503 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5502);
// compiled call node returning call5503 (depth = 4)
  *var_s = call5503;
  if (call5503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5505 == NULL) {
    strlit5505 = alloc_String("");
    gc_root(strlit5505);
  }
// compiled string node returning strlit5505 (depth = 5)
  int op_slot_right_5504 = gc_frame_newslot(strlit5505);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5508 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5509 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5508);
// compiled call node returning call5509 (depth = 7)
// compiled member node returning call5509 (depth = 6)
  int op_slot_right_5507 = gc_frame_newslot(call5509);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5512 == NULL) {
    strlit5512 = alloc_String("Name: ");
    gc_root(strlit5512);
  }
// compiled string node returning strlit5512 (depth = 7)
  int op_slot_right_5511 = gc_frame_newslot(strlit5512);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5514 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5517 == NULL) {
    strlit5517 = alloc_String("""\x0a""");
    gc_root(strlit5517);
  }
// compiled string node returning strlit5517 (depth = 9)
  int op_slot_right_5516 = gc_frame_newslot(strlit5517);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_5519 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit5521 == NULL) {
    strlit5521 = alloc_String("");
    gc_root(strlit5521);
  }
// compiled string node returning strlit5521 (depth = 10)
  int op_slot_left_5519 = gc_frame_newslot(strlit5521);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5522 = callmethod(strlit5521, "++", 1, partcv, params);
// compiled op node returning opresult5522 (depth = 9)
  int op_slot_left_5516 = gc_frame_newslot(opresult5522);
  params[0] = strlit5517;
  partcv[0] = 1;
  Object opresult5523 = callmethod(opresult5522, "++", 1, partcv, params);
// compiled op node returning opresult5523 (depth = 8)
  int op_slot_left_5514 = gc_frame_newslot(opresult5523);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5524 = callmethod(opresult5523, "++", 1, partcv, params);
// compiled op node returning opresult5524 (depth = 7)
  int op_slot_left_5511 = gc_frame_newslot(opresult5524);
  params[0] = strlit5512;
  partcv[0] = 1;
  Object opresult5525 = callmethod(opresult5524, "++", 1, partcv, params);
// compiled op node returning opresult5525 (depth = 6)
  int op_slot_left_5507 = gc_frame_newslot(opresult5525);
  params[0] = call5509;
  partcv[0] = 1;
  Object opresult5526 = callmethod(opresult5525, "++", 1, partcv, params);
// compiled op node returning opresult5526 (depth = 5)
  int op_slot_left_5504 = gc_frame_newslot(opresult5526);
  params[0] = strlit5505;
  partcv[0] = 1;
  Object opresult5527 = callmethod(opresult5526, "++", 1, partcv, params);
// compiled op node returning opresult5527 (depth = 4)
  *var_s = opresult5527;
  if (opresult5527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5532 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5531);
// compiled call node returning call5532 (depth = 6)
// compiled member node returning call5532 (depth = 5)
  int op_slot_right_5530 = gc_frame_newslot(call5532);
// starting to compile identifier node (depth = 5)
  Object bool5534 = alloc_Boolean(0);
// compiled identifier node returning bool5534 (depth = 5)
  int op_slot_left_5530 = gc_frame_newslot(bool5534);
  params[0] = call5532;
  partcv[0] = 1;
  Object opresult5535 = callmethod(bool5534, "≠", 1, partcv, params);
// compiled op node returning opresult5535 (depth = 4)
  Object if5529 = done;
  if (istrue(opresult5535)) {
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5537 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5539 = alloc_Float64(1);
// compiled num node returning num5539 (depth = 8)
  int op_slot_right_5538 = gc_frame_newslot(num5539);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5538 = gc_frame_newslot(*var_depth);
  params[0] = num5539;
  partcv[0] = 1;
  Object sum5541 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5541 (depth = 7)
  gc_frame_newslot(sum5541);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5542 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5543 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5542);
// compiled call node returning call5543 (depth = 8)
// compiled member node returning call5543 (depth = 7)
  params[0] = sum5541;
  partcv[0] = 1;
  Object call5544 = callmethod(call5543, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5537);
// compiled call node returning call5544 (depth = 6)
  int op_slot_right_5536 = gc_frame_newslot(call5544);
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5547 == NULL) {
    strlit5547 = alloc_String("Superclass: ");
    gc_root(strlit5547);
  }
// compiled string node returning strlit5547 (depth = 7)
  int op_slot_right_5546 = gc_frame_newslot(strlit5547);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5549 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5552 == NULL) {
    strlit5552 = alloc_String("""\x0a""");
    gc_root(strlit5552);
  }
// compiled string node returning strlit5552 (depth = 9)
  int op_slot_right_5551 = gc_frame_newslot(strlit5552);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5551 = gc_frame_newslot(*var_s);
  params[0] = strlit5552;
  partcv[0] = 1;
  Object opresult5554 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5554 (depth = 8)
  int op_slot_left_5549 = gc_frame_newslot(opresult5554);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5555 = callmethod(opresult5554, "++", 1, partcv, params);
// compiled op node returning opresult5555 (depth = 7)
  int op_slot_left_5546 = gc_frame_newslot(opresult5555);
  params[0] = strlit5547;
  partcv[0] = 1;
  Object opresult5556 = callmethod(opresult5555, "++", 1, partcv, params);
// compiled op node returning opresult5556 (depth = 6)
  int op_slot_left_5536 = gc_frame_newslot(opresult5556);
  params[0] = call5544;
  partcv[0] = 1;
  Object opresult5557 = callmethod(opresult5556, "++", 1, partcv, params);
// compiled op node returning opresult5557 (depth = 5)
  *var_s = opresult5557;
  if (opresult5557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5529 = done;
  } else {
  }
// compiled if node returning if5529 (depth = 3)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5560 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5561 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5563 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5562);
// compiled call node returning call5563 (depth = 9)
// compiled member node returning call5563 (depth = 8)
  partcv[0] = 0;
  Object call5564 = callmethod(call5563, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe5561);
// compiled call node returning call5564 (depth = 7)
// compiled member node returning call5564 (depth = 6)
  partcv[0] = 0;
  Object call5565 = callmethod(call5564, "not",
    1, partcv, params);
  gc_frame_end(callframe5560);
// compiled call node returning call5565 (depth = 5)
// compiled member node returning call5565 (depth = 4)
  Object if5559 = done;
  if (istrue(call5565)) {
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5567 == NULL) {
    strlit5567 = alloc_String("Traits:");
    gc_root(strlit5567);
  }
// compiled string node returning strlit5567 (depth = 6)
  int op_slot_right_5566 = gc_frame_newslot(strlit5567);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5569 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5572 == NULL) {
    strlit5572 = alloc_String("""\x0a""");
    gc_root(strlit5572);
  }
// compiled string node returning strlit5572 (depth = 8)
  int op_slot_right_5571 = gc_frame_newslot(strlit5572);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5571 = gc_frame_newslot(*var_s);
  params[0] = strlit5572;
  partcv[0] = 1;
  Object opresult5574 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5574 (depth = 7)
  int op_slot_left_5569 = gc_frame_newslot(opresult5574);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5575 = callmethod(opresult5574, "++", 1, partcv, params);
// compiled op node returning opresult5575 (depth = 6)
  int op_slot_left_5566 = gc_frame_newslot(opresult5575);
  params[0] = strlit5567;
  partcv[0] = 1;
  Object opresult5576 = callmethod(opresult5575, "++", 1, partcv, params);
// compiled op node returning opresult5576 (depth = 5)
  *var_s = opresult5576;
  if (opresult5576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5578 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5579 = alloc_Block(NULL, NULL, "ast", 1335);
  gc_frame_newslot(block5579);
// method "_apply"
  block_savedest(block5579);
  Object closure5580 = createclosure(4, "_apply");
  setclosureframe(closure5580, stackframe);
  addtoclosure(closure5580, var_depth);
  addtoclosure(closure5580, var_spc);
  addtoclosure(closure5580, var_s);
  addtoclosure(closure5580, selfslot);
  struct UserObject *uo5580 = (struct UserObject*)block5579;
  uo5580->data[0] = (Object)closure5580;
  Method *meth_meth_ast__apply5580 = addmethod2pos(block5579, "_apply", &meth_ast__apply5580, 0);
  int argcv_meth_ast__apply5580[] = {1};
  meth_meth_ast__apply5580->type = alloc_MethodType(1, argcv_meth_ast__apply5580);
  meth_meth_ast__apply5580->definitionModule = modulename;
  meth_meth_ast__apply5580->definitionLine = 1333;
// compiled block node returning block5579 (depth = 5)
  gc_frame_newslot(block5579);
// call case 6: other member request
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5612 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5611);
// compiled call node returning call5612 (depth = 6)
// compiled member node returning call5612 (depth = 5)
  params[0] = block5579;
  partcv[0] = 1;
  Object call5613 = callmethod(call5612, "do",
    1, partcv, params);
  gc_frame_end(callframe5578);
// compiled call node returning call5613 (depth = 4)
    gc_frame_newslot(call5613);
    if5559 = call5613;
  } else {
  }
// compiled if node returning if5559 (depth = 3)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5614 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5615 = alloc_Block(NULL, NULL, "ast", 1339);
  gc_frame_newslot(block5615);
// method "_apply"
  block_savedest(block5615);
  Object closure5616 = createclosure(4, "_apply");
  setclosureframe(closure5616, stackframe);
  addtoclosure(closure5616, var_depth);
  addtoclosure(closure5616, var_spc);
  addtoclosure(closure5616, var_s);
  addtoclosure(closure5616, selfslot);
  struct UserObject *uo5616 = (struct UserObject*)block5615;
  uo5616->data[0] = (Object)closure5616;
  Method *meth_meth_ast__apply5616 = addmethod2pos(block5615, "_apply", &meth_ast__apply5616, 0);
  int argcv_meth_ast__apply5616[] = {1};
  meth_meth_ast__apply5616->type = alloc_MethodType(1, argcv_meth_ast__apply5616);
  meth_meth_ast__apply5616->definitionModule = modulename;
  meth_meth_ast__apply5616->definitionLine = 1335;
// compiled block node returning block5615 (depth = 4)
  gc_frame_newslot(block5615);
// call case 6: other member request
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5635 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5636 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5635);
// compiled call node returning call5636 (depth = 5)
// compiled member node returning call5636 (depth = 4)
  params[0] = block5615;
  partcv[0] = 1;
  Object call5637 = callmethod(call5636, "do",
    1, partcv, params);
  gc_frame_end(callframe5614);
// compiled call node returning call5637 (depth = 3)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5650(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5652 == NULL) {
    strlit5652 = alloc_String("    ");
    gc_root(strlit5652);
  }
// compiled string node returning strlit5652 (depth = 7)
  int op_slot_right_5651 = gc_frame_newslot(strlit5652);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5651 = gc_frame_newslot(*var_spc);
  params[0] = strlit5652;
  partcv[0] = 1;
  Object opresult5654 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5654 (depth = 6)
  *var_spc = opresult5654;
  if (opresult5654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5700(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5702 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5704 = alloc_Float64(1);
// compiled num node returning num5704 (depth = 9)
  int op_slot_right_5703 = gc_frame_newslot(num5704);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5703 = gc_frame_newslot(*var_depth);
  params[0] = num5704;
  partcv[0] = 1;
  Object sum5706 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5706 (depth = 8)
  gc_frame_newslot(sum5706);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = sum5706;
  partcv[0] = 1;
  Object call5707 = callmethod(*var_t, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5702);
// compiled call node returning call5707 (depth = 7)
  int op_slot_right_5701 = gc_frame_newslot(call5707);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5710 == NULL) {
    strlit5710 = alloc_String("""\x0a""");
    gc_root(strlit5710);
  }
// compiled string node returning strlit5710 (depth = 8)
  int op_slot_right_5709 = gc_frame_newslot(strlit5710);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5709 = gc_frame_newslot(*var_s);
  params[0] = strlit5710;
  partcv[0] = 1;
  Object opresult5712 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5712 (depth = 7)
  int op_slot_left_5701 = gc_frame_newslot(opresult5712);
  params[0] = call5707;
  partcv[0] = 1;
  Object opresult5713 = callmethod(opresult5712, "++", 1, partcv, params);
// compiled op node returning opresult5713 (depth = 6)
  *var_s = opresult5713;
  if (opresult5713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5721(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5723 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5725 = alloc_Float64(1);
// compiled num node returning num5725 (depth = 9)
  int op_slot_right_5724 = gc_frame_newslot(num5725);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5724 = gc_frame_newslot(*var_depth);
  params[0] = num5725;
  partcv[0] = 1;
  Object sum5727 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5727 (depth = 8)
  gc_frame_newslot(sum5727);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = sum5727;
  partcv[0] = 1;
  Object call5728 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5723);
// compiled call node returning call5728 (depth = 7)
  int op_slot_right_5722 = gc_frame_newslot(call5728);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5731 == NULL) {
    strlit5731 = alloc_String("    ");
    gc_root(strlit5731);
  }
// compiled string node returning strlit5731 (depth = 8)
  int op_slot_right_5730 = gc_frame_newslot(strlit5731);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5733 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5736 == NULL) {
    strlit5736 = alloc_String("""\x0a""");
    gc_root(strlit5736);
  }
// compiled string node returning strlit5736 (depth = 10)
  int op_slot_right_5735 = gc_frame_newslot(strlit5736);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5735 = gc_frame_newslot(*var_s);
  params[0] = strlit5736;
  partcv[0] = 1;
  Object opresult5738 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5738 (depth = 9)
  int op_slot_left_5733 = gc_frame_newslot(opresult5738);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5739 = callmethod(opresult5738, "++", 1, partcv, params);
// compiled op node returning opresult5739 (depth = 8)
  int op_slot_left_5730 = gc_frame_newslot(opresult5739);
  params[0] = strlit5731;
  partcv[0] = 1;
  Object opresult5740 = callmethod(opresult5739, "++", 1, partcv, params);
// compiled op node returning opresult5740 (depth = 7)
  int op_slot_left_5722 = gc_frame_newslot(opresult5740);
  params[0] = call5728;
  partcv[0] = 1;
  Object opresult5741 = callmethod(opresult5740, "++", 1, partcv, params);
// compiled op node returning opresult5741 (depth = 6)
  *var_s = opresult5741;
  if (opresult5741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5638(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5639 == NULL) {
    strlit5639 = alloc_String("");
    gc_root(strlit5639);
  }
// compiled string node returning strlit5639 (depth = 4)
  *var_spc = strlit5639;
  if (strlit5639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5640 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5643 = alloc_Float64(1);
// compiled num node returning num5643 (depth = 6)
  int op_slot_right_5642 = gc_frame_newslot(num5643);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_5642 = gc_frame_newslot(*var_depth);
  params[0] = num5643;
  partcv[0] = 1;
  Object diff5645 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff5645 (depth = 5)
  int op_slot_right_5641 = gc_frame_newslot(diff5645);
// starting to compile num node (depth = 5)
  Object num5647 = alloc_Float64(0);
// compiled num node returning num5647 (depth = 5)
  int op_slot_left_5641 = gc_frame_newslot(num5647);
  params[0] = diff5645;
  partcv[0] = 1;
  Object opresult5648 = callmethod(num5647, "..", 1, partcv, params);
// compiled op node returning opresult5648 (depth = 4)
  gc_frame_newslot(opresult5648);
// starting to compile block node (depth = 4)
  Object block5649 = alloc_Block(NULL, NULL, "ast", 1346);
  gc_frame_newslot(block5649);
// method "_apply"
  block_savedest(block5649);
  Object closure5650 = createclosure(2, "_apply");
  setclosureframe(closure5650, stackframe);
  addtoclosure(closure5650, var_spc);
  addtoclosure(closure5650, selfslot);
  struct UserObject *uo5650 = (struct UserObject*)block5649;
  uo5650->data[0] = (Object)closure5650;
  Method *meth_meth_ast__apply5650 = addmethod2pos(block5649, "_apply", &meth_ast__apply5650, 0);
  int argcv_meth_ast__apply5650[] = {1};
  meth_meth_ast__apply5650->type = alloc_MethodType(1, argcv_meth_ast__apply5650);
  meth_meth_ast__apply5650->definitionModule = modulename;
  meth_meth_ast__apply5650->definitionLine = 1339;
// compiled block node returning block5649 (depth = 4)
  gc_frame_newslot(block5649);
// call case 5: prelude request
  params[0] = opresult5648;
  params[1] = block5649;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5657 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5640);
// compiled call node returning call5657 (depth = 3)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5658 == NULL) {
    strlit5658 = alloc_String("object {");
    gc_root(strlit5658);
  }
// compiled string node returning strlit5658 (depth = 4)
  *var_s = strlit5658;
  if (strlit5658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5661 = callmethodflags(self, "inTrait", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5660);
// compiled call node returning call5661 (depth = 5)
// compiled member node returning call5661 (depth = 4)
  Object if5659 = done;
  if (istrue(call5661)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5663 == NULL) {
    strlit5663 = alloc_String("   // trait");
    gc_root(strlit5663);
  }
// compiled string node returning strlit5663 (depth = 6)
  int op_slot_right_5662 = gc_frame_newslot(strlit5663);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5662 = gc_frame_newslot(*var_s);
  params[0] = strlit5663;
  partcv[0] = 1;
  Object opresult5665 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5665 (depth = 5)
  *var_s = opresult5665;
  if (opresult5665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5659 = done;
  } else {
  }
// compiled if node returning if5659 (depth = 3)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5669 = callmethodflags(self, "inClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5668);
// compiled call node returning call5669 (depth = 5)
// compiled member node returning call5669 (depth = 4)
  Object if5667 = done;
  if (istrue(call5669)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5671 == NULL) {
    strlit5671 = alloc_String("   // class");
    gc_root(strlit5671);
  }
// compiled string node returning strlit5671 (depth = 6)
  int op_slot_right_5670 = gc_frame_newslot(strlit5671);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5670 = gc_frame_newslot(*var_s);
  params[0] = strlit5671;
  partcv[0] = 1;
  Object opresult5673 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5673 (depth = 5)
  *var_s = opresult5673;
  if (opresult5673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5667 = done;
  } else {
  }
// compiled if node returning if5667 (depth = 3)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5678 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5677);
// compiled call node returning call5678 (depth = 6)
// compiled member node returning call5678 (depth = 5)
  int op_slot_right_5676 = gc_frame_newslot(call5678);
// starting to compile identifier node (depth = 5)
  Object bool5680 = alloc_Boolean(0);
// compiled identifier node returning bool5680 (depth = 5)
  int op_slot_left_5676 = gc_frame_newslot(bool5680);
  params[0] = call5678;
  partcv[0] = 1;
  Object opresult5681 = callmethod(bool5680, "≠", 1, partcv, params);
// compiled op node returning opresult5681 (depth = 4)
  Object if5675 = done;
  if (istrue(opresult5681)) {
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5683 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5685 = alloc_Float64(1);
// compiled num node returning num5685 (depth = 8)
  int op_slot_right_5684 = gc_frame_newslot(num5685);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_5684 = gc_frame_newslot(*var_depth);
  params[0] = num5685;
  partcv[0] = 1;
  Object sum5687 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5687 (depth = 7)
  gc_frame_newslot(sum5687);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5689 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5688);
// compiled call node returning call5689 (depth = 8)
// compiled member node returning call5689 (depth = 7)
  params[0] = sum5687;
  partcv[0] = 1;
  Object call5690 = callmethod(call5689, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5683);
// compiled call node returning call5690 (depth = 6)
  int op_slot_right_5682 = gc_frame_newslot(call5690);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5693 == NULL) {
    strlit5693 = alloc_String("""\x0a""");
    gc_root(strlit5693);
  }
// compiled string node returning strlit5693 (depth = 7)
  int op_slot_right_5692 = gc_frame_newslot(strlit5693);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5692 = gc_frame_newslot(*var_s);
  params[0] = strlit5693;
  partcv[0] = 1;
  Object opresult5695 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5695 (depth = 6)
  int op_slot_left_5682 = gc_frame_newslot(opresult5695);
  params[0] = call5690;
  partcv[0] = 1;
  Object opresult5696 = callmethod(opresult5695, "++", 1, partcv, params);
// compiled op node returning opresult5696 (depth = 5)
  *var_s = opresult5696;
  if (opresult5696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if5675 = done;
  } else {
  }
// compiled if node returning if5675 (depth = 3)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5698 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5699 = alloc_Block(NULL, NULL, "ast", 1355);
  gc_frame_newslot(block5699);
// method "_apply"
  block_savedest(block5699);
  Object closure5700 = createclosure(3, "_apply");
  setclosureframe(closure5700, stackframe);
  addtoclosure(closure5700, var_depth);
  addtoclosure(closure5700, var_s);
  addtoclosure(closure5700, selfslot);
  struct UserObject *uo5700 = (struct UserObject*)block5699;
  uo5700->data[0] = (Object)closure5700;
  Method *meth_meth_ast__apply5700 = addmethod2pos(block5699, "_apply", &meth_ast__apply5700, 0);
  int argcv_meth_ast__apply5700[] = {1};
  meth_meth_ast__apply5700->type = alloc_MethodType(1, argcv_meth_ast__apply5700);
  meth_meth_ast__apply5700->definitionModule = modulename;
  meth_meth_ast__apply5700->definitionLine = 1353;
// compiled block node returning block5699 (depth = 4)
  gc_frame_newslot(block5699);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5717 = callmethodflags(self, "usedTraits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5716);
// compiled call node returning call5717 (depth = 5)
// compiled member node returning call5717 (depth = 4)
  params[0] = block5699;
  partcv[0] = 1;
  Object call5718 = callmethod(call5717, "do",
    1, partcv, params);
  gc_frame_end(callframe5698);
// compiled call node returning call5718 (depth = 3)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5719 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5720 = alloc_Block(NULL, NULL, "ast", 1356);
  gc_frame_newslot(block5720);
// method "_apply"
  block_savedest(block5720);
  Object closure5721 = createclosure(4, "_apply");
  setclosureframe(closure5721, stackframe);
  addtoclosure(closure5721, var_depth);
  addtoclosure(closure5721, var_spc);
  addtoclosure(closure5721, var_s);
  addtoclosure(closure5721, selfslot);
  struct UserObject *uo5721 = (struct UserObject*)block5720;
  uo5721->data[0] = (Object)closure5721;
  Method *meth_meth_ast__apply5721 = addmethod2pos(block5720, "_apply", &meth_ast__apply5721, 0);
  int argcv_meth_ast__apply5721[] = {1};
  meth_meth_ast__apply5721->type = alloc_MethodType(1, argcv_meth_ast__apply5721);
  meth_meth_ast__apply5721->definitionModule = modulename;
  meth_meth_ast__apply5721->definitionLine = 1355;
// compiled block node returning block5720 (depth = 4)
  gc_frame_newslot(block5720);
// call case 6: other member request
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5745 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5744);
// compiled call node returning call5745 (depth = 5)
// compiled member node returning call5745 (depth = 4)
  params[0] = block5720;
  partcv[0] = 1;
  Object call5746 = callmethod(call5745, "do",
    1, partcv, params);
  gc_frame_end(callframe5719);
// compiled call node returning call5746 (depth = 3)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5748 == NULL) {
    strlit5748 = alloc_String("}");
    gc_root(strlit5748);
  }
// compiled string node returning strlit5748 (depth = 5)
  int op_slot_right_5747 = gc_frame_newslot(strlit5748);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_5750 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5753 == NULL) {
    strlit5753 = alloc_String("""\x0a""");
    gc_root(strlit5753);
  }
// compiled string node returning strlit5753 (depth = 7)
  int op_slot_right_5752 = gc_frame_newslot(strlit5753);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5752 = gc_frame_newslot(*var_s);
  params[0] = strlit5753;
  partcv[0] = 1;
  Object opresult5755 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5755 (depth = 6)
  int op_slot_left_5750 = gc_frame_newslot(opresult5755);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5756 = callmethod(opresult5755, "++", 1, partcv, params);
// compiled op node returning opresult5756 (depth = 5)
  int op_slot_left_5747 = gc_frame_newslot(opresult5756);
  params[0] = strlit5748;
  partcv[0] = 1;
  Object opresult5757 = callmethod(opresult5756, "++", 1, partcv, params);
// compiled op node returning opresult5757 (depth = 4)
  *var_s = opresult5757;
  if (opresult5757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy5759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5760 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5761 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 5)
  Object bool5762 = alloc_Boolean(0);
// compiled identifier node returning bool5762 (depth = 5)
  gc_frame_newslot(bool5762);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objectNode (depth = 5)
  params[0] = *var_emptySeq;
  params[1] = bool5762;
  partcv[0] = 2;
  Object call5763 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5761);
// compiled call node returning call5763 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5764 = callmethod(call5763, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5760);
// compiled call node returning call5764 (depth = 3)
  gc_frame_end(frame);
  return call5764;
}
Object meth_ast_shallowCopyFieldsFrom5765(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5766 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5767 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5766);
// compiled call node returning call5767 (depth = 3)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5768 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5770 = callmethod(*var_other, "name",
    1, partcv, params);
  gc_frame_end(callframe5769);
// compiled call node returning call5770 (depth = 5)
// compiled member node returning call5770 (depth = 4)
  gc_frame_newslot(call5770);
// call case 4: self request
  params[0] = call5770;
  partcv[0] = 1;
  Object call5771 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5768);
// compiled call node returning call5771 (depth = 3)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5772 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5773 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5774 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe5773);
// compiled call node returning call5774 (depth = 5)
// compiled member node returning call5774 (depth = 4)
  gc_frame_newslot(call5774);
// call case 4: self request
  params[0] = call5774;
  partcv[0] = 1;
  Object call5775 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5772);
// compiled call node returning call5775 (depth = 3)
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5776 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5778 = callmethod(*var_other, "superclass",
    1, partcv, params);
  gc_frame_end(callframe5777);
// compiled call node returning call5778 (depth = 5)
// compiled member node returning call5778 (depth = 4)
  gc_frame_newslot(call5778);
// call case 4: self request
  params[0] = call5778;
  partcv[0] = 1;
  Object call5779 = callmethodflags(self, "superclass:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5776);
// compiled call node returning call5779 (depth = 3)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5780 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5782 = callmethod(*var_other, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe5781);
// compiled call node returning call5782 (depth = 5)
// compiled member node returning call5782 (depth = 4)
  gc_frame_newslot(call5782);
// call case 4: self request
  params[0] = call5782;
  partcv[0] = 1;
  Object call5783 = callmethodflags(self, "usedTraits:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5780);
// compiled call node returning call5783 (depth = 3)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5784 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5786 = callmethod(*var_other, "inClass",
    1, partcv, params);
  gc_frame_end(callframe5785);
// compiled call node returning call5786 (depth = 5)
// compiled member node returning call5786 (depth = 4)
  gc_frame_newslot(call5786);
// call case 4: self request
  params[0] = call5786;
  partcv[0] = 1;
  Object call5787 = callmethodflags(self, "inClass:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5784);
// compiled call node returning call5787 (depth = 3)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5788 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5790 = callmethod(*var_other, "inTrait",
    1, partcv, params);
  gc_frame_end(callframe5789);
// compiled call node returning call5790 (depth = 5)
// compiled member node returning call5790 (depth = 4)
  gc_frame_newslot(call5790);
// call case 4: self request
  params[0] = call5790;
  partcv[0] = 1;
  Object call5791 = callmethodflags(self, "inTrait:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5788);
// compiled call node returning call5791 (depth = 3)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5792 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5793 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call5794 = callmethod(*var_other, "annotations",
    1, partcv, params);
  gc_frame_end(callframe5793);
// compiled call node returning call5794 (depth = 5)
// compiled member node returning call5794 (depth = 4)
  gc_frame_newslot(call5794);
// call case 4: self request
  params[0] = call5794;
  partcv[0] = 1;
  Object call5795 = callmethodflags(self, "annotations:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5792);
// compiled call node returning call5795 (depth = 3)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString5796(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5798 == NULL) {
    strlit5798 = alloc_String("");
    gc_root(strlit5798);
  }
// compiled string node returning strlit5798 (depth = 4)
  int op_slot_right_5797 = gc_frame_newslot(strlit5798);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5802 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5801);
// compiled call node returning call5802 (depth = 6)
// compiled member node returning call5802 (depth = 5)
  int op_slot_right_5800 = gc_frame_newslot(call5802);
// starting to compile string node (depth = 5)
  if (strlit5804 == NULL) {
    strlit5804 = alloc_String("object ");
    gc_root(strlit5804);
  }
// compiled string node returning strlit5804 (depth = 5)
  int op_slot_left_5800 = gc_frame_newslot(strlit5804);
  params[0] = call5802;
  partcv[0] = 1;
  Object opresult5805 = callmethod(strlit5804, "++", 1, partcv, params);
// compiled op node returning opresult5805 (depth = 4)
  int op_slot_left_5797 = gc_frame_newslot(opresult5805);
  params[0] = strlit5798;
  partcv[0] = 1;
  Object opresult5806 = callmethod(opresult5805, "++", 1, partcv, params);
// compiled op node returning opresult5806 (depth = 3)
  gc_frame_end(frame);
  return opresult5806;
}
Object meth_ast_new5222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5223 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5223 = alloc_userobj2(38,31, objclass5223);
  gc_frame_newslot(obj5223);
if (objclass5223 == NULL) {
  glfree(obj5223->class->name);
  obj5223->class->name = "objectNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5223, self, 0);
  addmethodreal(obj5223,"outer", &reader_ast_outer_5224);
  Object oldself5223 = self;
  struct StackFrameObject *oldstackframe5223 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5223);
  gc_frame_newslot((Object)stackframe);
  self = obj5223;
  Object *oldselfslot5223 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5223 = (*(struct UserObject *)self).data[0], lowerouter5223 = thisouter5223;
  if (inheritingObject5223) {
    struct UserObject *inho5223 = (struct UserObject *)inheritingObject5223;
    while (inho5223->super != GraceDefaultObject) inho5223 = (struct UserObject *)inho5223->super;
    inho5223->super = obj5223;
    self = inheritingObject5223;
    *selfslot = self;
    lowerouter5223 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5223;
  }
if (objclass5223 == NULL) {
  Method *reader5225 = addmethodrealflags(obj5223, "kind",&reader_ast_kind_5225, MFLAG_DEF);
  reader5225->definitionModule = modulename;
  reader5225->definitionLine = 1217;
}
adddatum2(obj5223, alloc_Undefined(), 1);
if (objclass5223 == NULL) {
  Method *reader5226 = addmethodrealflags(obj5223, "value",&reader_ast_value_5226, 0);
  Method *writer5226 = addmethodrealflags(obj5223, "value:=",&writer_ast_value_5226, 0);
  reader5226->definitionModule = modulename;
  writer5226->definitionModule = modulename;
  reader5226->definitionLine = 1218;
  writer5226->definitionLine = 1218;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 2);
if (objclass5223 == NULL) {
  Method *reader5227 = addmethodrealflags(obj5223, "superclass",&reader_ast_superclass_5227, 0);
  Method *writer5227 = addmethodrealflags(obj5223, "superclass:=",&writer_ast_superclass_5227, 0);
  reader5227->definitionModule = modulename;
  writer5227->definitionModule = modulename;
  reader5227->definitionLine = 1219;
  writer5227->definitionLine = 1219;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 3);
if (objclass5223 == NULL) {
  Method *reader5228 = addmethodrealflags(obj5223, "usedTraits",&reader_ast_usedTraits_5228, 0);
  Method *writer5228 = addmethodrealflags(obj5223, "usedTraits:=",&writer_ast_usedTraits_5228, 0);
  reader5228->definitionModule = modulename;
  writer5228->definitionModule = modulename;
  reader5228->definitionLine = 1220;
  writer5228->definitionLine = 1220;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 4);
if (objclass5223 == NULL) {
  Method *reader5229 = addmethodrealflags(obj5223, "name",&reader_ast_name_5229, 0);
  Method *writer5229 = addmethodrealflags(obj5223, "name:=",&writer_ast_name_5229, 0);
  reader5229->definitionModule = modulename;
  writer5229->definitionModule = modulename;
  reader5229->definitionLine = 1221;
  writer5229->definitionLine = 1221;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 5);
if (objclass5223 == NULL) {
  Method *reader5230 = addmethodrealflags(obj5223, "inClass",&reader_ast_inClass_5230, 0);
  Method *writer5230 = addmethodrealflags(obj5223, "inClass:=",&writer_ast_inClass_5230, 0);
  reader5230->definitionModule = modulename;
  writer5230->definitionModule = modulename;
  reader5230->definitionLine = 1222;
  writer5230->definitionLine = 1222;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 6);
if (objclass5223 == NULL) {
  Method *reader5231 = addmethodrealflags(obj5223, "inTrait",&reader_ast_inTrait_5231, 0);
  Method *writer5231 = addmethodrealflags(obj5223, "inTrait:=",&writer_ast_inTrait_5231, 0);
  reader5231->definitionModule = modulename;
  writer5231->definitionModule = modulename;
  reader5231->definitionLine = 1223;
  writer5231->definitionLine = 1223;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 7);
if (objclass5223 == NULL) {
  Method *reader5232 = addmethodrealflags(obj5223, "myLocalNames",&reader_ast_myLocalNames_5232, MFLAG_CONFIDENTIAL);
  Method *writer5232 = addmethodrealflags(obj5223, "myLocalNames:=",&writer_ast_myLocalNames_5232, MFLAG_CONFIDENTIAL);
  reader5232->definitionModule = modulename;
  writer5232->definitionModule = modulename;
  reader5232->definitionLine = 1224;
  writer5232->definitionLine = 1224;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 8);
if (objclass5223 == NULL) {
  Method *reader5233 = addmethodrealflags(obj5223, "annotations",&reader_ast_annotations_5233, 0);
  Method *writer5233 = addmethodrealflags(obj5223, "annotations:=",&writer_ast_annotations_5233, 0);
  reader5233->definitionModule = modulename;
  writer5233->definitionModule = modulename;
  reader5233->definitionLine = 1225;
  writer5233->definitionLine = 1225;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5234 = (struct UserObject*)obj5223;
  uo5234->data[10] = emptyclosure;
  Method *meth_meth_ast_description5234 = addmethod2pos(obj5223, "description", &meth_ast_description5234, 10);
  int argcv_meth_ast_description5234[] = {0};
  meth_meth_ast_description5234->type = alloc_MethodType(1, argcv_meth_ast_description5234);
  meth_meth_ast_description5234->definitionModule = modulename;
  meth_meth_ast_description5234->definitionLine = 1227;
// method "isTrait"
  struct UserObject *uo5263 = (struct UserObject*)obj5223;
  uo5263->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5263 = addmethod2pos(obj5223, "isTrait", &meth_ast_isTrait5263, 11);
  int argcv_meth_ast_isTrait5263[] = {0};
  meth_meth_ast_isTrait5263->type = alloc_MethodType(1, argcv_meth_ast_isTrait5263);
  meth_meth_ast_isTrait5263->definitionModule = modulename;
  meth_meth_ast_isTrait5263->definitionLine = 1236;
// method "localNames"
  struct UserObject *uo5290 = (struct UserObject*)obj5223;
  uo5290->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5290 = addmethod2pos(obj5223, "localNames", &meth_ast_localNames5290, 12);
  int argcv_meth_ast_localNames5290[] = {0};
  meth_meth_ast_localNames5290->type = alloc_MethodType(1, argcv_meth_ast_localNames5290);
  meth_meth_ast_localNames5290->definitionModule = modulename;
  meth_meth_ast_localNames5290->definitionLine = 1247;
// method "parentsDo"
  struct UserObject *uo5325 = (struct UserObject*)obj5223;
  uo5325->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo5325 = addmethod2pos(obj5223, "parentsDo", &meth_ast_parentsDo5325, 13);
  int argcv_meth_ast_parentsDo5325[] = {1};
  meth_meth_ast_parentsDo5325->type = alloc_MethodType(1, argcv_meth_ast_parentsDo5325);
  meth_meth_ast_parentsDo5325->definitionModule = modulename;
  meth_meth_ast_parentsDo5325->definitionLine = 1261;
// method "methodsDo"
  struct UserObject *uo5346 = (struct UserObject*)obj5223;
  uo5346->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo5346 = addmethod2pos(obj5223, "methodsDo", &meth_ast_methodsDo5346, 14);
  int argcv_meth_ast_methodsDo5346[] = {1};
  meth_meth_ast_methodsDo5346->type = alloc_MethodType(1, argcv_meth_ast_methodsDo5346);
  meth_meth_ast_methodsDo5346->definitionModule = modulename;
  meth_meth_ast_methodsDo5346->definitionLine = 1268;
// method "executableComponentsDo"
  struct UserObject *uo5359 = (struct UserObject*)obj5223;
  uo5359->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo5359 = addmethod2pos(obj5223, "executableComponentsDo", &meth_ast_executableComponentsDo5359, 15);
  int argcv_meth_ast_executableComponentsDo5359[] = {1};
  meth_meth_ast_executableComponentsDo5359->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo5359);
  meth_meth_ast_executableComponentsDo5359->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo5359->definitionLine = 1276;
// method "scope:="
  struct UserObject *uo5372 = (struct UserObject*)obj5223;
  uo5372->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5372 = addmethod2pos(obj5223, "scope:=", &meth_ast_scope_58__61_5372, 16);
  int argcv_meth_ast_scope_58__61_5372[] = {1};
  meth_meth_ast_scope_58__61_5372->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5372);
  meth_meth_ast_scope_58__61_5372->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5372->definitionLine = 1284;
// method "body"
  struct UserObject *uo5377 = (struct UserObject*)obj5223;
  uo5377->data[17] = emptyclosure;
  Method *meth_meth_ast_body5377 = addmethod2pos(obj5223, "body", &meth_ast_body5377, 17);
  int argcv_meth_ast_body5377[] = {0};
  meth_meth_ast_body5377->type = alloc_MethodType(1, argcv_meth_ast_body5377);
  meth_meth_ast_body5377->definitionModule = modulename;
  meth_meth_ast_body5377->definitionLine = 1290;
// method "returnsObject"
  struct UserObject *uo5380 = (struct UserObject*)obj5223;
  uo5380->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5380 = addmethod2pos(obj5223, "returnsObject", &meth_ast_returnsObject5380, 18);
  int argcv_meth_ast_returnsObject5380[] = {0};
  meth_meth_ast_returnsObject5380->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5380);
  meth_meth_ast_returnsObject5380->definitionModule = modulename;
  meth_meth_ast_returnsObject5380->definitionLine = 1291;
// method "returnedObjectScope"
  struct UserObject *uo5382 = (struct UserObject*)obj5223;
  uo5382->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5382 = addmethod2pos(obj5223, "returnedObjectScope", &meth_ast_returnedObjectScope5382, 19);
  int argcv_meth_ast_returnedObjectScope5382[] = {0};
  meth_meth_ast_returnedObjectScope5382->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5382);
  meth_meth_ast_returnedObjectScope5382->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5382->definitionLine = 1292;
// method "canInherit"
  struct UserObject *uo5385 = (struct UserObject*)obj5223;
  uo5385->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5385 = addmethod2pos(obj5223, "canInherit", &meth_ast_canInherit5385, 20);
  int argcv_meth_ast_canInherit5385[] = {0};
  meth_meth_ast_canInherit5385->type = alloc_MethodType(1, argcv_meth_ast_canInherit5385);
  meth_meth_ast_canInherit5385->definitionModule = modulename;
  meth_meth_ast_canInherit5385->definitionLine = 1293;
// method "canUse"
  struct UserObject *uo5390 = (struct UserObject*)obj5223;
  uo5390->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5390 = addmethod2pos(obj5223, "canUse", &meth_ast_canUse5390, 21);
  int argcv_meth_ast_canUse5390[] = {0};
  meth_meth_ast_canUse5390->type = alloc_MethodType(1, argcv_meth_ast_canUse5390);
  meth_meth_ast_canUse5390->definitionModule = modulename;
  meth_meth_ast_canUse5390->definitionLine = 1294;
// method "isObject"
  struct UserObject *uo5392 = (struct UserObject*)obj5223;
  uo5392->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5392 = addmethod2pos(obj5223, "isObject", &meth_ast_isObject5392, 22);
  int argcv_meth_ast_isObject5392[] = {0};
  meth_meth_ast_isObject5392->type = alloc_MethodType(1, argcv_meth_ast_isObject5392);
  meth_meth_ast_isObject5392->definitionModule = modulename;
  meth_meth_ast_isObject5392->definitionLine = 1295;
// method "accept()from"
  struct UserObject *uo5394 = (struct UserObject*)obj5223;
  uo5394->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5394 = addmethod2pos(obj5223, "accept()from", &meth_ast_accept_40__41_from5394, 23);
  int argcv_meth_ast_accept_40__41_from5394[] = {1, 1};
  meth_meth_ast_accept_40__41_from5394->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5394);
  meth_meth_ast_accept_40__41_from5394->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5394->definitionLine = 1296;
// method "nameString"
  struct UserObject *uo5429 = (struct UserObject*)obj5223;
  uo5429->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5429 = addmethod2pos(obj5223, "nameString", &meth_ast_nameString5429, 24);
  int argcv_meth_ast_nameString5429[] = {0};
  meth_meth_ast_nameString5429->type = alloc_MethodType(1, argcv_meth_ast_nameString5429);
  meth_meth_ast_nameString5429->definitionModule = modulename;
  meth_meth_ast_nameString5429->definitionLine = 1306;
// method "map()ancestors"
  struct UserObject *uo5449 = (struct UserObject*)obj5223;
  uo5449->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5449 = addmethod2pos(obj5223, "map()ancestors", &meth_ast_map_40__41_ancestors5449, 25);
  int argcv_meth_ast_map_40__41_ancestors5449[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5449->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5449);
  meth_meth_ast_map_40__41_ancestors5449->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5449->definitionLine = 1313;
// method "pretty"
  struct UserObject *uo5486 = (struct UserObject*)obj5223;
  uo5486->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty5486 = addmethod2pos(obj5223, "pretty", &meth_ast_pretty5486, 26);
  int argcv_meth_ast_pretty5486[] = {1};
  meth_meth_ast_pretty5486->type = alloc_MethodType(1, argcv_meth_ast_pretty5486);
  meth_meth_ast_pretty5486->definitionModule = modulename;
  meth_meth_ast_pretty5486->definitionLine = 1321;
// method "toGrace"
  struct UserObject *uo5638 = (struct UserObject*)obj5223;
  uo5638->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace5638 = addmethod2pos(obj5223, "toGrace", &meth_ast_toGrace5638, 27);
  int argcv_meth_ast_toGrace5638[] = {1};
  meth_meth_ast_toGrace5638->type = alloc_MethodType(1, argcv_meth_ast_toGrace5638);
meth_meth_ast_toGrace5638->type->types[0] = type_Number;
meth_meth_ast_toGrace5638->type->names[0] = "depth";
  meth_meth_ast_toGrace5638->definitionModule = modulename;
  meth_meth_ast_toGrace5638->definitionLine = 1344;
// method "shallowCopy"
  block_savedest(obj5223);
  Object closure5759 = createclosure(2, "shallowCopy");
  setclosureframe(closure5759, stackframe);
  addtoclosure(closure5759, var_emptySeq);
  addtoclosure(closure5759, var_objectNode);
  struct UserObject *uo5759 = (struct UserObject*)obj5223;
  uo5759->data[28] = (Object)closure5759;
  Method *meth_meth_ast_shallowCopy5759 = addmethod2pos(obj5223, "shallowCopy", &meth_ast_shallowCopy5759, 28);
  int argcv_meth_ast_shallowCopy5759[] = {0};
  meth_meth_ast_shallowCopy5759->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5759);
  meth_meth_ast_shallowCopy5759->definitionModule = modulename;
  meth_meth_ast_shallowCopy5759->definitionLine = 1362;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5765 = (struct UserObject*)obj5223;
  uo5765->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5765 = addmethod2pos(obj5223, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5765, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom5765[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5765->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5765);
  meth_meth_ast_shallowCopyFieldsFrom5765->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5765->definitionLine = 1365;
// method "asString"
  struct UserObject *uo5796 = (struct UserObject*)obj5223;
  uo5796->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5796 = addmethod2pos(obj5223, "asString", &meth_ast_asString5796, 30);
  int argcv_meth_ast_asString5796[] = {0};
  meth_meth_ast_asString5796->type = alloc_MethodType(1, argcv_meth_ast_asString5796);
  meth_meth_ast_asString5796->definitionModule = modulename;
  meth_meth_ast_asString5796->definitionLine = 1376;
  sourceObject = obj5223;
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5807 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5808 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5809 = gc_frame_new();
// call case 3: self.outer request
  Object call5810 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5809);
// compiled call node returning call5810 (depth = 7)
// compiled member node returning call5810 (depth = 6)
  partcv[0] = 0;
  Object call5811 = callmethodflags(call5810, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5808);
// compiled call node returning call5811 (depth = 5)
// compiled member node returning call5811 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5812 = callmethodflags(call5811, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5807);
// compiled call node returning call5812 (depth = 3)
  struct UserObject *obj5223_uo = (struct UserObject *)obj5223;
  obj5223_uo->super = call5812;
  sourceObject = obj5223;
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5813 == NULL) {
    strlit5813 = alloc_String("object");
    gc_root(strlit5813);
  }
// compiled string node returning strlit5813 (depth = 3)
  adddatum2(obj5223, strlit5813, 1);
  sourceObject = obj5223;
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5223, *var_b, 2);
  sourceObject = obj5223;
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5223, *var_superclass_39_, 3);
  sourceObject = obj5223;
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5814 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5814 (depth = 3)
  adddatum2(obj5223, array5814, 4);
  sourceObject = obj5223;
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("object");
    gc_root(strlit5815);
  }
// compiled string node returning strlit5815 (depth = 3)
  adddatum2(obj5223, strlit5815, 5);
  sourceObject = obj5223;
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5816 = alloc_Boolean(0);
// compiled identifier node returning bool5816 (depth = 3)
  adddatum2(obj5223, bool5816, 6);
  sourceObject = obj5223;
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5817 = alloc_Boolean(0);
// compiled identifier node returning bool5817 (depth = 3)
  adddatum2(obj5223, bool5817, 7);
  sourceObject = obj5223;
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5818 = alloc_Boolean(0);
// compiled identifier node returning bool5818 (depth = 3)
  adddatum2(obj5223, bool5818, 8);
  sourceObject = obj5223;
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5819 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5819 (depth = 3)
  adddatum2(obj5223, array5819, 9);
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  objclass5223 = obj5223->class;
  objclass5223->definitionModule = modulename;
  objclass5223->definitionLine = 1215;
  (*(struct UserObject *)self).data[0] = lowerouter5223;
  self = oldself5223;
  selfslot = oldselfslot5223;
  stackframe = oldstackframe5223;
  gc_frame_end(frame);
  return obj5223;
}
Object meth_ast_new5222_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5223 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5223 = alloc_userobj2(38,31, objclass5223);
  gc_frame_newslot(obj5223);
if (objclass5223 == NULL) {
  glfree(obj5223->class->name);
  obj5223->class->name = "objectNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5223, self, 0);
  addmethodreal(obj5223,"outer", &reader_ast_outer_5224);
  Object oldself5223 = self;
  struct StackFrameObject *oldstackframe5223 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5223);
  gc_frame_newslot((Object)stackframe);
  self = obj5223;
  Object *oldselfslot5223 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5223 = (*(struct UserObject *)self).data[0], lowerouter5223 = thisouter5223;
  if (inheritingObject5223) {
    struct UserObject *inho5223 = (struct UserObject *)inheritingObject5223;
    while (inho5223->super != GraceDefaultObject) inho5223 = (struct UserObject *)inho5223->super;
    inho5223->super = obj5223;
    self = inheritingObject5223;
    *selfslot = self;
    lowerouter5223 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5223;
  }
if (objclass5223 == NULL) {
  Method *reader5225 = addmethodrealflags(obj5223, "kind",&reader_ast_kind_5225, MFLAG_DEF);
  reader5225->definitionModule = modulename;
  reader5225->definitionLine = 1217;
}
adddatum2(obj5223, alloc_Undefined(), 1);
if (objclass5223 == NULL) {
  Method *reader5226 = addmethodrealflags(obj5223, "value",&reader_ast_value_5226, 0);
  Method *writer5226 = addmethodrealflags(obj5223, "value:=",&writer_ast_value_5226, 0);
  reader5226->definitionModule = modulename;
  writer5226->definitionModule = modulename;
  reader5226->definitionLine = 1218;
  writer5226->definitionLine = 1218;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 2);
if (objclass5223 == NULL) {
  Method *reader5227 = addmethodrealflags(obj5223, "superclass",&reader_ast_superclass_5227, 0);
  Method *writer5227 = addmethodrealflags(obj5223, "superclass:=",&writer_ast_superclass_5227, 0);
  reader5227->definitionModule = modulename;
  writer5227->definitionModule = modulename;
  reader5227->definitionLine = 1219;
  writer5227->definitionLine = 1219;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 3);
if (objclass5223 == NULL) {
  Method *reader5228 = addmethodrealflags(obj5223, "usedTraits",&reader_ast_usedTraits_5228, 0);
  Method *writer5228 = addmethodrealflags(obj5223, "usedTraits:=",&writer_ast_usedTraits_5228, 0);
  reader5228->definitionModule = modulename;
  writer5228->definitionModule = modulename;
  reader5228->definitionLine = 1220;
  writer5228->definitionLine = 1220;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 4);
if (objclass5223 == NULL) {
  Method *reader5229 = addmethodrealflags(obj5223, "name",&reader_ast_name_5229, 0);
  Method *writer5229 = addmethodrealflags(obj5223, "name:=",&writer_ast_name_5229, 0);
  reader5229->definitionModule = modulename;
  writer5229->definitionModule = modulename;
  reader5229->definitionLine = 1221;
  writer5229->definitionLine = 1221;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 5);
if (objclass5223 == NULL) {
  Method *reader5230 = addmethodrealflags(obj5223, "inClass",&reader_ast_inClass_5230, 0);
  Method *writer5230 = addmethodrealflags(obj5223, "inClass:=",&writer_ast_inClass_5230, 0);
  reader5230->definitionModule = modulename;
  writer5230->definitionModule = modulename;
  reader5230->definitionLine = 1222;
  writer5230->definitionLine = 1222;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 6);
if (objclass5223 == NULL) {
  Method *reader5231 = addmethodrealflags(obj5223, "inTrait",&reader_ast_inTrait_5231, 0);
  Method *writer5231 = addmethodrealflags(obj5223, "inTrait:=",&writer_ast_inTrait_5231, 0);
  reader5231->definitionModule = modulename;
  writer5231->definitionModule = modulename;
  reader5231->definitionLine = 1223;
  writer5231->definitionLine = 1223;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 7);
if (objclass5223 == NULL) {
  Method *reader5232 = addmethodrealflags(obj5223, "myLocalNames",&reader_ast_myLocalNames_5232, MFLAG_CONFIDENTIAL);
  Method *writer5232 = addmethodrealflags(obj5223, "myLocalNames:=",&writer_ast_myLocalNames_5232, MFLAG_CONFIDENTIAL);
  reader5232->definitionModule = modulename;
  writer5232->definitionModule = modulename;
  reader5232->definitionLine = 1224;
  writer5232->definitionLine = 1224;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 8);
if (objclass5223 == NULL) {
  Method *reader5233 = addmethodrealflags(obj5223, "annotations",&reader_ast_annotations_5233, 0);
  Method *writer5233 = addmethodrealflags(obj5223, "annotations:=",&writer_ast_annotations_5233, 0);
  reader5233->definitionModule = modulename;
  writer5233->definitionModule = modulename;
  reader5233->definitionLine = 1225;
  writer5233->definitionLine = 1225;
}
obj5223->flags |= OFLAG_MUTABLE;
adddatum2(obj5223, alloc_Undefined(), 9);
// method "description"
  struct UserObject *uo5234 = (struct UserObject*)obj5223;
  uo5234->data[10] = emptyclosure;
  Method *meth_meth_ast_description5234 = addmethod2pos(obj5223, "description", &meth_ast_description5234, 10);
  int argcv_meth_ast_description5234[] = {0};
  meth_meth_ast_description5234->type = alloc_MethodType(1, argcv_meth_ast_description5234);
  meth_meth_ast_description5234->definitionModule = modulename;
  meth_meth_ast_description5234->definitionLine = 1227;
// method "isTrait"
  struct UserObject *uo5263 = (struct UserObject*)obj5223;
  uo5263->data[11] = emptyclosure;
  Method *meth_meth_ast_isTrait5263 = addmethod2pos(obj5223, "isTrait", &meth_ast_isTrait5263, 11);
  int argcv_meth_ast_isTrait5263[] = {0};
  meth_meth_ast_isTrait5263->type = alloc_MethodType(1, argcv_meth_ast_isTrait5263);
  meth_meth_ast_isTrait5263->definitionModule = modulename;
  meth_meth_ast_isTrait5263->definitionLine = 1236;
// method "localNames"
  struct UserObject *uo5290 = (struct UserObject*)obj5223;
  uo5290->data[12] = emptyclosure;
  Method *meth_meth_ast_localNames5290 = addmethod2pos(obj5223, "localNames", &meth_ast_localNames5290, 12);
  int argcv_meth_ast_localNames5290[] = {0};
  meth_meth_ast_localNames5290->type = alloc_MethodType(1, argcv_meth_ast_localNames5290);
  meth_meth_ast_localNames5290->definitionModule = modulename;
  meth_meth_ast_localNames5290->definitionLine = 1247;
// method "parentsDo"
  struct UserObject *uo5325 = (struct UserObject*)obj5223;
  uo5325->data[13] = emptyclosure;
  Method *meth_meth_ast_parentsDo5325 = addmethod2pos(obj5223, "parentsDo", &meth_ast_parentsDo5325, 13);
  int argcv_meth_ast_parentsDo5325[] = {1};
  meth_meth_ast_parentsDo5325->type = alloc_MethodType(1, argcv_meth_ast_parentsDo5325);
  meth_meth_ast_parentsDo5325->definitionModule = modulename;
  meth_meth_ast_parentsDo5325->definitionLine = 1261;
// method "methodsDo"
  struct UserObject *uo5346 = (struct UserObject*)obj5223;
  uo5346->data[14] = emptyclosure;
  Method *meth_meth_ast_methodsDo5346 = addmethod2pos(obj5223, "methodsDo", &meth_ast_methodsDo5346, 14);
  int argcv_meth_ast_methodsDo5346[] = {1};
  meth_meth_ast_methodsDo5346->type = alloc_MethodType(1, argcv_meth_ast_methodsDo5346);
  meth_meth_ast_methodsDo5346->definitionModule = modulename;
  meth_meth_ast_methodsDo5346->definitionLine = 1268;
// method "executableComponentsDo"
  struct UserObject *uo5359 = (struct UserObject*)obj5223;
  uo5359->data[15] = emptyclosure;
  Method *meth_meth_ast_executableComponentsDo5359 = addmethod2pos(obj5223, "executableComponentsDo", &meth_ast_executableComponentsDo5359, 15);
  int argcv_meth_ast_executableComponentsDo5359[] = {1};
  meth_meth_ast_executableComponentsDo5359->type = alloc_MethodType(1, argcv_meth_ast_executableComponentsDo5359);
  meth_meth_ast_executableComponentsDo5359->definitionModule = modulename;
  meth_meth_ast_executableComponentsDo5359->definitionLine = 1276;
// method "scope:="
  struct UserObject *uo5372 = (struct UserObject*)obj5223;
  uo5372->data[16] = emptyclosure;
  Method *meth_meth_ast_scope_58__61_5372 = addmethod2pos(obj5223, "scope:=", &meth_ast_scope_58__61_5372, 16);
  int argcv_meth_ast_scope_58__61_5372[] = {1};
  meth_meth_ast_scope_58__61_5372->type = alloc_MethodType(1, argcv_meth_ast_scope_58__61_5372);
  meth_meth_ast_scope_58__61_5372->definitionModule = modulename;
  meth_meth_ast_scope_58__61_5372->definitionLine = 1284;
// method "body"
  struct UserObject *uo5377 = (struct UserObject*)obj5223;
  uo5377->data[17] = emptyclosure;
  Method *meth_meth_ast_body5377 = addmethod2pos(obj5223, "body", &meth_ast_body5377, 17);
  int argcv_meth_ast_body5377[] = {0};
  meth_meth_ast_body5377->type = alloc_MethodType(1, argcv_meth_ast_body5377);
  meth_meth_ast_body5377->definitionModule = modulename;
  meth_meth_ast_body5377->definitionLine = 1290;
// method "returnsObject"
  struct UserObject *uo5380 = (struct UserObject*)obj5223;
  uo5380->data[18] = emptyclosure;
  Method *meth_meth_ast_returnsObject5380 = addmethod2pos(obj5223, "returnsObject", &meth_ast_returnsObject5380, 18);
  int argcv_meth_ast_returnsObject5380[] = {0};
  meth_meth_ast_returnsObject5380->type = alloc_MethodType(1, argcv_meth_ast_returnsObject5380);
  meth_meth_ast_returnsObject5380->definitionModule = modulename;
  meth_meth_ast_returnsObject5380->definitionLine = 1291;
// method "returnedObjectScope"
  struct UserObject *uo5382 = (struct UserObject*)obj5223;
  uo5382->data[19] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope5382 = addmethod2pos(obj5223, "returnedObjectScope", &meth_ast_returnedObjectScope5382, 19);
  int argcv_meth_ast_returnedObjectScope5382[] = {0};
  meth_meth_ast_returnedObjectScope5382->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope5382);
  meth_meth_ast_returnedObjectScope5382->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope5382->definitionLine = 1292;
// method "canInherit"
  struct UserObject *uo5385 = (struct UserObject*)obj5223;
  uo5385->data[20] = emptyclosure;
  Method *meth_meth_ast_canInherit5385 = addmethod2pos(obj5223, "canInherit", &meth_ast_canInherit5385, 20);
  int argcv_meth_ast_canInherit5385[] = {0};
  meth_meth_ast_canInherit5385->type = alloc_MethodType(1, argcv_meth_ast_canInherit5385);
  meth_meth_ast_canInherit5385->definitionModule = modulename;
  meth_meth_ast_canInherit5385->definitionLine = 1293;
// method "canUse"
  struct UserObject *uo5390 = (struct UserObject*)obj5223;
  uo5390->data[21] = emptyclosure;
  Method *meth_meth_ast_canUse5390 = addmethod2pos(obj5223, "canUse", &meth_ast_canUse5390, 21);
  int argcv_meth_ast_canUse5390[] = {0};
  meth_meth_ast_canUse5390->type = alloc_MethodType(1, argcv_meth_ast_canUse5390);
  meth_meth_ast_canUse5390->definitionModule = modulename;
  meth_meth_ast_canUse5390->definitionLine = 1294;
// method "isObject"
  struct UserObject *uo5392 = (struct UserObject*)obj5223;
  uo5392->data[22] = emptyclosure;
  Method *meth_meth_ast_isObject5392 = addmethod2pos(obj5223, "isObject", &meth_ast_isObject5392, 22);
  int argcv_meth_ast_isObject5392[] = {0};
  meth_meth_ast_isObject5392->type = alloc_MethodType(1, argcv_meth_ast_isObject5392);
  meth_meth_ast_isObject5392->definitionModule = modulename;
  meth_meth_ast_isObject5392->definitionLine = 1295;
// method "accept()from"
  struct UserObject *uo5394 = (struct UserObject*)obj5223;
  uo5394->data[23] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5394 = addmethod2pos(obj5223, "accept()from", &meth_ast_accept_40__41_from5394, 23);
  int argcv_meth_ast_accept_40__41_from5394[] = {1, 1};
  meth_meth_ast_accept_40__41_from5394->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5394);
  meth_meth_ast_accept_40__41_from5394->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5394->definitionLine = 1296;
// method "nameString"
  struct UserObject *uo5429 = (struct UserObject*)obj5223;
  uo5429->data[24] = emptyclosure;
  Method *meth_meth_ast_nameString5429 = addmethod2pos(obj5223, "nameString", &meth_ast_nameString5429, 24);
  int argcv_meth_ast_nameString5429[] = {0};
  meth_meth_ast_nameString5429->type = alloc_MethodType(1, argcv_meth_ast_nameString5429);
  meth_meth_ast_nameString5429->definitionModule = modulename;
  meth_meth_ast_nameString5429->definitionLine = 1306;
// method "map()ancestors"
  struct UserObject *uo5449 = (struct UserObject*)obj5223;
  uo5449->data[25] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5449 = addmethod2pos(obj5223, "map()ancestors", &meth_ast_map_40__41_ancestors5449, 25);
  int argcv_meth_ast_map_40__41_ancestors5449[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5449->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5449);
  meth_meth_ast_map_40__41_ancestors5449->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5449->definitionLine = 1313;
// method "pretty"
  struct UserObject *uo5486 = (struct UserObject*)obj5223;
  uo5486->data[26] = emptyclosure;
  Method *meth_meth_ast_pretty5486 = addmethod2pos(obj5223, "pretty", &meth_ast_pretty5486, 26);
  int argcv_meth_ast_pretty5486[] = {1};
  meth_meth_ast_pretty5486->type = alloc_MethodType(1, argcv_meth_ast_pretty5486);
  meth_meth_ast_pretty5486->definitionModule = modulename;
  meth_meth_ast_pretty5486->definitionLine = 1321;
// method "toGrace"
  struct UserObject *uo5638 = (struct UserObject*)obj5223;
  uo5638->data[27] = emptyclosure;
  Method *meth_meth_ast_toGrace5638 = addmethod2pos(obj5223, "toGrace", &meth_ast_toGrace5638, 27);
  int argcv_meth_ast_toGrace5638[] = {1};
  meth_meth_ast_toGrace5638->type = alloc_MethodType(1, argcv_meth_ast_toGrace5638);
meth_meth_ast_toGrace5638->type->types[0] = type_Number;
meth_meth_ast_toGrace5638->type->names[0] = "depth";
  meth_meth_ast_toGrace5638->definitionModule = modulename;
  meth_meth_ast_toGrace5638->definitionLine = 1344;
// method "shallowCopy"
  block_savedest(obj5223);
  Object closure5759 = createclosure(2, "shallowCopy");
  setclosureframe(closure5759, stackframe);
  addtoclosure(closure5759, var_emptySeq);
  addtoclosure(closure5759, var_objectNode);
  struct UserObject *uo5759 = (struct UserObject*)obj5223;
  uo5759->data[28] = (Object)closure5759;
  Method *meth_meth_ast_shallowCopy5759 = addmethod2pos(obj5223, "shallowCopy", &meth_ast_shallowCopy5759, 28);
  int argcv_meth_ast_shallowCopy5759[] = {0};
  meth_meth_ast_shallowCopy5759->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5759);
  meth_meth_ast_shallowCopy5759->definitionModule = modulename;
  meth_meth_ast_shallowCopy5759->definitionLine = 1362;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo5765 = (struct UserObject*)obj5223;
  uo5765->data[29] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom5765 = addmethod2pos(obj5223, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom5765, 29);
  int argcv_meth_ast_shallowCopyFieldsFrom5765[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom5765->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom5765);
  meth_meth_ast_shallowCopyFieldsFrom5765->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom5765->definitionLine = 1365;
// method "asString"
  struct UserObject *uo5796 = (struct UserObject*)obj5223;
  uo5796->data[30] = emptyclosure;
  Method *meth_meth_ast_asString5796 = addmethod2pos(obj5223, "asString", &meth_ast_asString5796, 30);
  int argcv_meth_ast_asString5796[] = {0};
  meth_meth_ast_asString5796->type = alloc_MethodType(1, argcv_meth_ast_asString5796);
  meth_meth_ast_asString5796->definitionModule = modulename;
  meth_meth_ast_asString5796->definitionLine = 1376;
  sourceObject = obj5223;
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5807 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5808 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5809 = gc_frame_new();
// call case 3: self.outer request
  Object call5810 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5809);
// compiled call node returning call5810 (depth = 7)
// compiled member node returning call5810 (depth = 6)
  partcv[0] = 0;
  Object call5811 = callmethodflags(call5810, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5808);
// compiled call node returning call5811 (depth = 5)
// compiled member node returning call5811 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5812 = callmethodflags(call5811, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5807);
// compiled call node returning call5812 (depth = 3)
  struct UserObject *obj5223_uo = (struct UserObject *)obj5223;
  obj5223_uo->super = call5812;
  sourceObject = obj5223;
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5813 == NULL) {
    strlit5813 = alloc_String("object");
    gc_root(strlit5813);
  }
// compiled string node returning strlit5813 (depth = 3)
  adddatum2(obj5223, strlit5813, 1);
  sourceObject = obj5223;
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
  adddatum2(obj5223, *var_b, 2);
  sourceObject = obj5223;
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_superclass_39_ (depth = 3)
  adddatum2(obj5223, *var_superclass_39_, 3);
  sourceObject = obj5223;
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5814 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5814 (depth = 3)
  adddatum2(obj5223, array5814, 4);
  sourceObject = obj5223;
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5815 == NULL) {
    strlit5815 = alloc_String("object");
    gc_root(strlit5815);
  }
// compiled string node returning strlit5815 (depth = 3)
  adddatum2(obj5223, strlit5815, 5);
  sourceObject = obj5223;
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5816 = alloc_Boolean(0);
// compiled identifier node returning bool5816 (depth = 3)
  adddatum2(obj5223, bool5816, 6);
  sourceObject = obj5223;
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5817 = alloc_Boolean(0);
// compiled identifier node returning bool5817 (depth = 3)
  adddatum2(obj5223, bool5817, 7);
  sourceObject = obj5223;
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5818 = alloc_Boolean(0);
// compiled identifier node returning bool5818 (depth = 3)
  adddatum2(obj5223, bool5818, 8);
  sourceObject = obj5223;
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5819 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5819 (depth = 3)
  adddatum2(obj5223, array5819, 9);
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  sourceObject = obj5223;
  objclass5223 = obj5223->class;
  objclass5223->definitionModule = modulename;
  objclass5223->definitionLine = 1215;
  (*(struct UserObject *)self).data[0] = lowerouter5223;
  self = oldself5223;
  selfslot = oldselfslot5223;
  stackframe = oldstackframe5223;
  gc_frame_end(frame);
  return obj5223;
}
Object meth_ast_objectNode5821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for objectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply5839(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5840 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ax (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5841 = callmethod(*var_ax, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5840);
// compiled call node returning call5841 (depth = 6)
  gc_frame_end(frame);
  return call5841;
}
Object meth_ast_accept_40__41_from5829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5831 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5832 = callmethod(*var_visitor, "visitArray()up",
    2, partcv, params);
  gc_frame_end(callframe5831);
// compiled call node returning call5832 (depth = 4)
  Object if5830 = done;
  if (istrue(call5832)) {
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5833 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5834 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5833);
// compiled call node returning call5834 (depth = 5)
  *var_newChain = call5834;
  if (call5834 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5835 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5836 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5837 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5836);
// compiled call node returning call5837 (depth = 6)
// compiled member node returning call5837 (depth = 5)
  gc_frame_newslot(call5837);
// starting to compile block node (depth = 5)
  Object block5838 = alloc_Block(NULL, NULL, "ast", 1389);
  gc_frame_newslot(block5838);
// method "_apply"
  block_savedest(block5838);
  Object closure5839 = createclosure(3, "_apply");
  setclosureframe(closure5839, stackframe);
  addtoclosure(closure5839, var_visitor);
  addtoclosure(closure5839, var_newChain);
  addtoclosure(closure5839, selfslot);
  struct UserObject *uo5839 = (struct UserObject*)block5838;
  uo5839->data[0] = (Object)closure5839;
  Method *meth_meth_ast__apply5839 = addmethod2pos(block5838, "_apply", &meth_ast__apply5839, 0);
  int argcv_meth_ast__apply5839[] = {1};
  meth_meth_ast__apply5839->type = alloc_MethodType(1, argcv_meth_ast__apply5839);
  meth_meth_ast__apply5839->definitionModule = modulename;
  meth_meth_ast__apply5839->definitionLine = 1389;
// compiled block node returning block5838 (depth = 5)
  gc_frame_newslot(block5838);
// call case 5: prelude request
  params[0] = call5837;
  params[1] = block5838;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5843 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5835);
// compiled call node returning call5843 (depth = 4)
    gc_frame_newslot(call5843);
    if5830 = call5843;
  } else {
  }
// compiled if node returning if5830 (depth = 3)
  gc_frame_end(frame);
  return if5830;
}
Object meth_ast_map_40__41_ancestors5844(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5846 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5845);
// compiled call node returning call5846 (depth = 5)
// compiled member node returning call5846 (depth = 4)
  *var_n = call5846;
  if (call5846 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5847 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5848 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5847);
// compiled call node returning call5848 (depth = 4)
  *var_newChain = call5848;
  if (call5848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5849 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe5850 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5851 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5852 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5851);
// compiled call node returning call5852 (depth = 6)
// compiled member node returning call5852 (depth = 5)
  gc_frame_newslot(call5852);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5853 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5854 = gc_frame_new();
// call case 3: self.outer request
  Object call5855 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5854);
// compiled call node returning call5855 (depth = 8)
// compiled member node returning call5855 (depth = 7)
  partcv[0] = 0;
  Object call5856 = callmethodflags(call5855, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5853);
// compiled call node returning call5856 (depth = 6)
// compiled member node returning call5856 (depth = 5)
  params[0] = call5852;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5857 = callmethodflags(call5856, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5850);
// compiled call node returning call5857 (depth = 4)
  gc_frame_newslot(call5857);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call5857;
  partcv[0] = 1;
  Object call5858 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5849);
// compiled call node returning call5858 (depth = 3)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5859 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call5860 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5859);
// compiled call node returning call5860 (depth = 3)
  gc_frame_end(frame);
  return call5860;
}
Object meth_ast__apply5869(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5871 == NULL) {
    strlit5871 = alloc_String("  ");
    gc_root(strlit5871);
  }
// compiled string node returning strlit5871 (depth = 7)
  int op_slot_right_5870 = gc_frame_newslot(strlit5871);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_5870 = gc_frame_newslot(*var_spc);
  params[0] = strlit5871;
  partcv[0] = 1;
  Object opresult5873 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5873 (depth = 6)
  *var_spc = opresult5873;
  if (opresult5873 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5885 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5887 = alloc_Float64(1);
// compiled num node returning num5887 (depth = 9)
  int op_slot_right_5886 = gc_frame_newslot(num5887);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5886 = gc_frame_newslot(*var_depth);
  params[0] = num5887;
  partcv[0] = 1;
  Object sum5889 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5889 (depth = 8)
  gc_frame_newslot(sum5889);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = sum5889;
  partcv[0] = 1;
  Object call5890 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5885);
// compiled call node returning call5890 (depth = 7)
  int op_slot_right_5884 = gc_frame_newslot(call5890);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5892 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5895 == NULL) {
    strlit5895 = alloc_String("""\x0a""");
    gc_root(strlit5895);
  }
// compiled string node returning strlit5895 (depth = 9)
  int op_slot_right_5894 = gc_frame_newslot(strlit5895);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5894 = gc_frame_newslot(*var_s);
  params[0] = strlit5895;
  partcv[0] = 1;
  Object opresult5897 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5897 (depth = 8)
  int op_slot_left_5892 = gc_frame_newslot(opresult5897);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5898 = callmethod(opresult5897, "++", 1, partcv, params);
// compiled op node returning opresult5898 (depth = 7)
  int op_slot_left_5884 = gc_frame_newslot(opresult5898);
  params[0] = call5890;
  partcv[0] = 1;
  Object opresult5899 = callmethod(opresult5898, "++", 1, partcv, params);
// compiled op node returning opresult5899 (depth = 6)
  *var_s = opresult5899;
  if (opresult5899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5862 == NULL) {
    strlit5862 = alloc_String("");
    gc_root(strlit5862);
  }
// compiled string node returning strlit5862 (depth = 4)
  *var_spc = strlit5862;
  if (strlit5862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5863 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_5864 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num5866 = alloc_Float64(0);
// compiled num node returning num5866 (depth = 5)
  int op_slot_left_5864 = gc_frame_newslot(num5866);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5867 = callmethod(num5866, "..", 1, partcv, params);
// compiled op node returning opresult5867 (depth = 4)
  gc_frame_newslot(opresult5867);
// starting to compile block node (depth = 4)
  Object block5868 = alloc_Block(NULL, NULL, "ast", 1402);
  gc_frame_newslot(block5868);
// method "_apply"
  block_savedest(block5868);
  Object closure5869 = createclosure(2, "_apply");
  setclosureframe(closure5869, stackframe);
  addtoclosure(closure5869, var_spc);
  addtoclosure(closure5869, selfslot);
  struct UserObject *uo5869 = (struct UserObject*)block5868;
  uo5869->data[0] = (Object)closure5869;
  Method *meth_meth_ast__apply5869 = addmethod2pos(block5868, "_apply", &meth_ast__apply5869, 0);
  int argcv_meth_ast__apply5869[] = {1};
  meth_meth_ast__apply5869->type = alloc_MethodType(1, argcv_meth_ast__apply5869);
  meth_meth_ast__apply5869->definitionModule = modulename;
  meth_meth_ast__apply5869->definitionLine = 1397;
// compiled block node returning block5868 (depth = 4)
  gc_frame_newslot(block5868);
// call case 5: prelude request
  params[0] = opresult5867;
  params[1] = block5868;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5876 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5863);
// compiled call node returning call5876 (depth = 3)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5877 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5878 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5877);
// compiled call node returning call5878 (depth = 4)
  *var_s = call5878;
  if (call5878 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5879 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5881 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5880);
// compiled call node returning call5881 (depth = 5)
// compiled member node returning call5881 (depth = 4)
  gc_frame_newslot(call5881);
// starting to compile block node (depth = 4)
  Object block5882 = alloc_Block(NULL, NULL, "ast", 1406);
  gc_frame_newslot(block5882);
// method "_apply"
  block_savedest(block5882);
  Object closure5883 = createclosure(4, "_apply");
  setclosureframe(closure5883, stackframe);
  addtoclosure(closure5883, var_depth);
  addtoclosure(closure5883, var_spc);
  addtoclosure(closure5883, var_s);
  addtoclosure(closure5883, selfslot);
  struct UserObject *uo5883 = (struct UserObject*)block5882;
  uo5883->data[0] = (Object)closure5883;
  Method *meth_meth_ast__apply5883 = addmethod2pos(block5882, "_apply", &meth_ast__apply5883, 0);
  int argcv_meth_ast__apply5883[] = {1};
  meth_meth_ast__apply5883->type = alloc_MethodType(1, argcv_meth_ast__apply5883);
  meth_meth_ast__apply5883->definitionModule = modulename;
  meth_meth_ast__apply5883->definitionLine = 1406;
// compiled block node returning block5882 (depth = 4)
  gc_frame_newslot(block5882);
// call case 5: prelude request
  params[0] = call5881;
  params[1] = block5882;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5902 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5879);
// compiled call node returning call5902 (depth = 3)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5911(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5913 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5914 = alloc_Float64(0);
// compiled num node returning num5914 (depth = 8)
  gc_frame_newslot(num5914);
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5915 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5917 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5916);
// compiled call node returning call5917 (depth = 10)
// compiled member node returning call5917 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call5918 = callmethod(call5917, "at",
    1, partcv, params);
  gc_frame_end(callframe5915);
// compiled call node returning call5918 (depth = 8)
  params[0] = num5914;
  partcv[0] = 1;
  Object call5919 = callmethod(call5918, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5913);
// compiled call node returning call5919 (depth = 7)
  int op_slot_right_5912 = gc_frame_newslot(call5919);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5912 = gc_frame_newslot(*var_s);
  params[0] = call5919;
  partcv[0] = 1;
  Object opresult5921 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5921 (depth = 6)
  *var_s = opresult5921;
  if (opresult5921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5927 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5926);
// compiled call node returning call5927 (depth = 10)
// compiled member node returning call5927 (depth = 9)
  partcv[0] = 0;
  Object call5928 = callmethod(call5927, "size",
    1, partcv, params);
  gc_frame_end(callframe5925);
// compiled call node returning call5928 (depth = 8)
// compiled member node returning call5928 (depth = 7)
  int op_slot_right_5924 = gc_frame_newslot(call5928);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_5924 = gc_frame_newslot(*var_i);
  params[0] = call5928;
  partcv[0] = 1;
  Object opresult5930 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult5930 (depth = 6)
  Object if5923 = done;
  if (istrue(opresult5930)) {
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5932 == NULL) {
    strlit5932 = alloc_String(", ");
    gc_root(strlit5932);
  }
// compiled string node returning strlit5932 (depth = 8)
  int op_slot_right_5931 = gc_frame_newslot(strlit5932);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5931 = gc_frame_newslot(*var_s);
  params[0] = strlit5932;
  partcv[0] = 1;
  Object opresult5934 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5934 (depth = 7)
  *var_s = opresult5934;
  if (opresult5934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5923 = done;
  } else {
  }
// compiled if node returning if5923 (depth = 5)
  gc_frame_end(frame);
  return if5923;
}
Object meth_ast_toGrace5903(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5904 == NULL) {
    strlit5904 = alloc_String("[");
    gc_root(strlit5904);
  }
// compiled string node returning strlit5904 (depth = 4)
  *var_s = strlit5904;
  if (strlit5904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5905 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5906 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5908 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5907);
// compiled call node returning call5908 (depth = 7)
// compiled member node returning call5908 (depth = 6)
  partcv[0] = 0;
  Object call5909 = callmethod(call5908, "indices",
    1, partcv, params);
  gc_frame_end(callframe5906);
// compiled call node returning call5909 (depth = 5)
// compiled member node returning call5909 (depth = 4)
  gc_frame_newslot(call5909);
// starting to compile block node (depth = 4)
  Object block5910 = alloc_Block(NULL, NULL, "ast", 1413);
  gc_frame_newslot(block5910);
// method "_apply"
  block_savedest(block5910);
  Object closure5911 = createclosure(2, "_apply");
  setclosureframe(closure5911, stackframe);
  addtoclosure(closure5911, var_s);
  addtoclosure(closure5911, selfslot);
  struct UserObject *uo5911 = (struct UserObject*)block5910;
  uo5911->data[0] = (Object)closure5911;
  Method *meth_meth_ast__apply5911 = addmethod2pos(block5910, "_apply", &meth_ast__apply5911, 0);
  int argcv_meth_ast__apply5911[] = {1};
  meth_meth_ast__apply5911->type = alloc_MethodType(1, argcv_meth_ast__apply5911);
  meth_meth_ast__apply5911->definitionModule = modulename;
  meth_meth_ast__apply5911->definitionLine = 1413;
// compiled block node returning block5910 (depth = 4)
  gc_frame_newslot(block5910);
// call case 5: prelude request
  params[0] = call5909;
  params[1] = block5910;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5937 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5905);
// compiled call node returning call5937 (depth = 3)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5939 == NULL) {
    strlit5939 = alloc_String("]");
    gc_root(strlit5939);
  }
// compiled string node returning strlit5939 (depth = 5)
  int op_slot_right_5938 = gc_frame_newslot(strlit5939);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_5938 = gc_frame_newslot(*var_s);
  params[0] = strlit5939;
  partcv[0] = 1;
  Object opresult5941 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5941 (depth = 4)
  *var_s = opresult5941;
  if (opresult5941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy5943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5944 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe5945 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_arrayNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call5946 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5945);
// compiled call node returning call5946 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5947 = callmethod(call5946, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe5944);
// compiled call node returning call5947 (depth = 3)
  gc_frame_end(frame);
  return call5947;
}
Object meth_ast_new5824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5825 = alloc_userobj2(8,8, objclass5825);
  gc_frame_newslot(obj5825);
if (objclass5825 == NULL) {
  glfree(obj5825->class->name);
  obj5825->class->name = "arrayNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5825, self, 0);
  addmethodreal(obj5825,"outer", &reader_ast_outer_5826);
  Object oldself5825 = self;
  struct StackFrameObject *oldstackframe5825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5825);
  gc_frame_newslot((Object)stackframe);
  self = obj5825;
  Object *oldselfslot5825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5825 = (*(struct UserObject *)self).data[0], lowerouter5825 = thisouter5825;
  if (inheritingObject5825) {
    struct UserObject *inho5825 = (struct UserObject *)inheritingObject5825;
    while (inho5825->super != GraceDefaultObject) inho5825 = (struct UserObject *)inho5825->super;
    inho5825->super = obj5825;
    self = inheritingObject5825;
    *selfslot = self;
    lowerouter5825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5825;
  }
if (objclass5825 == NULL) {
  Method *reader5827 = addmethodrealflags(obj5825, "kind",&reader_ast_kind_5827, MFLAG_DEF);
  reader5827->definitionModule = modulename;
  reader5827->definitionLine = 1384;
}
adddatum2(obj5825, alloc_Undefined(), 1);
if (objclass5825 == NULL) {
  Method *reader5828 = addmethodrealflags(obj5825, "value",&reader_ast_value_5828, 0);
  Method *writer5828 = addmethodrealflags(obj5825, "value:=",&writer_ast_value_5828, 0);
  reader5828->definitionModule = modulename;
  writer5828->definitionModule = modulename;
  reader5828->definitionLine = 1385;
  writer5828->definitionLine = 1385;
}
obj5825->flags |= OFLAG_MUTABLE;
adddatum2(obj5825, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo5829 = (struct UserObject*)obj5825;
  uo5829->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5829 = addmethod2pos(obj5825, "accept()from", &meth_ast_accept_40__41_from5829, 3);
  int argcv_meth_ast_accept_40__41_from5829[] = {1, 1};
  meth_meth_ast_accept_40__41_from5829->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5829);
  meth_meth_ast_accept_40__41_from5829->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5829->definitionLine = 1386;
// method "map()ancestors"
  struct UserObject *uo5844 = (struct UserObject*)obj5825;
  uo5844->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5844 = addmethod2pos(obj5825, "map()ancestors", &meth_ast_map_40__41_ancestors5844, 4);
  int argcv_meth_ast_map_40__41_ancestors5844[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5844->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5844);
  meth_meth_ast_map_40__41_ancestors5844->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5844->definitionLine = 1394;
// method "pretty"
  struct UserObject *uo5861 = (struct UserObject*)obj5825;
  uo5861->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty5861 = addmethod2pos(obj5825, "pretty", &meth_ast_pretty5861, 5);
  int argcv_meth_ast_pretty5861[] = {1};
  meth_meth_ast_pretty5861->type = alloc_MethodType(1, argcv_meth_ast_pretty5861);
  meth_meth_ast_pretty5861->definitionModule = modulename;
  meth_meth_ast_pretty5861->definitionLine = 1400;
// method "toGrace"
  struct UserObject *uo5903 = (struct UserObject*)obj5825;
  uo5903->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace5903 = addmethod2pos(obj5825, "toGrace", &meth_ast_toGrace5903, 6);
  int argcv_meth_ast_toGrace5903[] = {1};
  meth_meth_ast_toGrace5903->type = alloc_MethodType(1, argcv_meth_ast_toGrace5903);
meth_meth_ast_toGrace5903->type->types[0] = type_Number;
meth_meth_ast_toGrace5903->type->names[0] = "depth";
  meth_meth_ast_toGrace5903->definitionModule = modulename;
  meth_meth_ast_toGrace5903->definitionLine = 1411;
// method "shallowCopy"
  block_savedest(obj5825);
  Object closure5943 = createclosure(2, "shallowCopy");
  setclosureframe(closure5943, stackframe);
  addtoclosure(closure5943, var_emptySeq);
  addtoclosure(closure5943, var_arrayNode);
  struct UserObject *uo5943 = (struct UserObject*)obj5825;
  uo5943->data[7] = (Object)closure5943;
  Method *meth_meth_ast_shallowCopy5943 = addmethod2pos(obj5825, "shallowCopy", &meth_ast_shallowCopy5943, 7);
  int argcv_meth_ast_shallowCopy5943[] = {0};
  meth_meth_ast_shallowCopy5943->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5943);
  meth_meth_ast_shallowCopy5943->definitionModule = modulename;
  meth_meth_ast_shallowCopy5943->definitionLine = 1422;
  sourceObject = obj5825;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5948 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5949 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5950 = gc_frame_new();
// call case 3: self.outer request
  Object call5951 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5950);
// compiled call node returning call5951 (depth = 7)
// compiled member node returning call5951 (depth = 6)
  partcv[0] = 0;
  Object call5952 = callmethodflags(call5951, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5949);
// compiled call node returning call5952 (depth = 5)
// compiled member node returning call5952 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5953 = callmethodflags(call5952, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5948);
// compiled call node returning call5953 (depth = 3)
  struct UserObject *obj5825_uo = (struct UserObject *)obj5825;
  obj5825_uo->super = call5953;
  sourceObject = obj5825;
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5954 == NULL) {
    strlit5954 = alloc_String("array");
    gc_root(strlit5954);
  }
// compiled string node returning strlit5954 (depth = 3)
  adddatum2(obj5825, strlit5954, 1);
  sourceObject = obj5825;
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj5825, *var_values, 2);
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  objclass5825 = obj5825->class;
  objclass5825->definitionModule = modulename;
  objclass5825->definitionLine = 1382;
  (*(struct UserObject *)self).data[0] = lowerouter5825;
  self = oldself5825;
  selfslot = oldselfslot5825;
  stackframe = oldstackframe5825;
  gc_frame_end(frame);
  return obj5825;
}
Object meth_ast_new5824_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5825 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5825 = alloc_userobj2(8,8, objclass5825);
  gc_frame_newslot(obj5825);
if (objclass5825 == NULL) {
  glfree(obj5825->class->name);
  obj5825->class->name = "arrayNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5825, self, 0);
  addmethodreal(obj5825,"outer", &reader_ast_outer_5826);
  Object oldself5825 = self;
  struct StackFrameObject *oldstackframe5825 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5825);
  gc_frame_newslot((Object)stackframe);
  self = obj5825;
  Object *oldselfslot5825 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5825 = (*(struct UserObject *)self).data[0], lowerouter5825 = thisouter5825;
  if (inheritingObject5825) {
    struct UserObject *inho5825 = (struct UserObject *)inheritingObject5825;
    while (inho5825->super != GraceDefaultObject) inho5825 = (struct UserObject *)inho5825->super;
    inho5825->super = obj5825;
    self = inheritingObject5825;
    *selfslot = self;
    lowerouter5825 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5825;
  }
if (objclass5825 == NULL) {
  Method *reader5827 = addmethodrealflags(obj5825, "kind",&reader_ast_kind_5827, MFLAG_DEF);
  reader5827->definitionModule = modulename;
  reader5827->definitionLine = 1384;
}
adddatum2(obj5825, alloc_Undefined(), 1);
if (objclass5825 == NULL) {
  Method *reader5828 = addmethodrealflags(obj5825, "value",&reader_ast_value_5828, 0);
  Method *writer5828 = addmethodrealflags(obj5825, "value:=",&writer_ast_value_5828, 0);
  reader5828->definitionModule = modulename;
  writer5828->definitionModule = modulename;
  reader5828->definitionLine = 1385;
  writer5828->definitionLine = 1385;
}
obj5825->flags |= OFLAG_MUTABLE;
adddatum2(obj5825, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo5829 = (struct UserObject*)obj5825;
  uo5829->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5829 = addmethod2pos(obj5825, "accept()from", &meth_ast_accept_40__41_from5829, 3);
  int argcv_meth_ast_accept_40__41_from5829[] = {1, 1};
  meth_meth_ast_accept_40__41_from5829->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5829);
  meth_meth_ast_accept_40__41_from5829->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5829->definitionLine = 1386;
// method "map()ancestors"
  struct UserObject *uo5844 = (struct UserObject*)obj5825;
  uo5844->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors5844 = addmethod2pos(obj5825, "map()ancestors", &meth_ast_map_40__41_ancestors5844, 4);
  int argcv_meth_ast_map_40__41_ancestors5844[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors5844->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors5844);
  meth_meth_ast_map_40__41_ancestors5844->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors5844->definitionLine = 1394;
// method "pretty"
  struct UserObject *uo5861 = (struct UserObject*)obj5825;
  uo5861->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty5861 = addmethod2pos(obj5825, "pretty", &meth_ast_pretty5861, 5);
  int argcv_meth_ast_pretty5861[] = {1};
  meth_meth_ast_pretty5861->type = alloc_MethodType(1, argcv_meth_ast_pretty5861);
  meth_meth_ast_pretty5861->definitionModule = modulename;
  meth_meth_ast_pretty5861->definitionLine = 1400;
// method "toGrace"
  struct UserObject *uo5903 = (struct UserObject*)obj5825;
  uo5903->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace5903 = addmethod2pos(obj5825, "toGrace", &meth_ast_toGrace5903, 6);
  int argcv_meth_ast_toGrace5903[] = {1};
  meth_meth_ast_toGrace5903->type = alloc_MethodType(1, argcv_meth_ast_toGrace5903);
meth_meth_ast_toGrace5903->type->types[0] = type_Number;
meth_meth_ast_toGrace5903->type->names[0] = "depth";
  meth_meth_ast_toGrace5903->definitionModule = modulename;
  meth_meth_ast_toGrace5903->definitionLine = 1411;
// method "shallowCopy"
  block_savedest(obj5825);
  Object closure5943 = createclosure(2, "shallowCopy");
  setclosureframe(closure5943, stackframe);
  addtoclosure(closure5943, var_emptySeq);
  addtoclosure(closure5943, var_arrayNode);
  struct UserObject *uo5943 = (struct UserObject*)obj5825;
  uo5943->data[7] = (Object)closure5943;
  Method *meth_meth_ast_shallowCopy5943 = addmethod2pos(obj5825, "shallowCopy", &meth_ast_shallowCopy5943, 7);
  int argcv_meth_ast_shallowCopy5943[] = {0};
  meth_meth_ast_shallowCopy5943->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy5943);
  meth_meth_ast_shallowCopy5943->definitionModule = modulename;
  meth_meth_ast_shallowCopy5943->definitionLine = 1422;
  sourceObject = obj5825;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5948 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5949 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5950 = gc_frame_new();
// call case 3: self.outer request
  Object call5951 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5950);
// compiled call node returning call5951 (depth = 7)
// compiled member node returning call5951 (depth = 6)
  partcv[0] = 0;
  Object call5952 = callmethodflags(call5951, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5949);
// compiled call node returning call5952 (depth = 5)
// compiled member node returning call5952 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5953 = callmethodflags(call5952, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5948);
// compiled call node returning call5953 (depth = 3)
  struct UserObject *obj5825_uo = (struct UserObject *)obj5825;
  obj5825_uo->super = call5953;
  sourceObject = obj5825;
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5954 == NULL) {
    strlit5954 = alloc_String("array");
    gc_root(strlit5954);
  }
// compiled string node returning strlit5954 (depth = 3)
  adddatum2(obj5825, strlit5954, 1);
  sourceObject = obj5825;
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  adddatum2(obj5825, *var_values, 2);
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  sourceObject = obj5825;
  objclass5825 = obj5825->class;
  objclass5825->definitionModule = modulename;
  objclass5825->definitionLine = 1382;
  (*(struct UserObject *)self).data[0] = lowerouter5825;
  self = oldself5825;
  selfslot = oldselfslot5825;
  stackframe = oldstackframe5825;
  gc_frame_end(frame);
  return obj5825;
}
Object meth_ast_arrayNode5956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast_new_40__41_scope5959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5960 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_request (depth = 5)
  gc_frame_newslot(*var_request);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_receiver (depth = 5)
  gc_frame_newslot(*var_receiver);
// call case 4: self request
  params[0] = *var_request;
  params[1] = *var_receiver;
  partcv[0] = 2;
  Object call5961 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5960);
// compiled call node returning call5961 (depth = 4)
  *var_result = call5961;
  if (call5961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5962 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call5963 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe5962);
// compiled call node returning call5963 (depth = 3)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_target5971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5973 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5972);
// compiled call node returning call5973 (depth = 4)
// compiled member node returning call5973 (depth = 3)
  gc_frame_end(frame);
  return call5973;
}
Object meth_ast_nameString5974(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5975 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5976 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5975);
// compiled call node returning call5976 (depth = 4)
// compiled member node returning call5976 (depth = 3)
  gc_frame_end(frame);
  return call5976;
}
Object meth_ast_isMember5977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5978 = alloc_Boolean(1);
// compiled identifier node returning bool5978 (depth = 3)
  gc_frame_end(frame);
  return bool5978;
}
Object meth_ast__apply5994(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe5995 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newChain (depth = 8)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5996 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5995);
// compiled call node returning call5996 (depth = 7)
  gc_frame_end(frame);
  return call5996;
}
Object meth_ast_accept_40__41_from5979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5981 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5982 = callmethod(*var_visitor, "visitMember()up",
    2, partcv, params);
  gc_frame_end(callframe5981);
// compiled call node returning call5982 (depth = 4)
  Object if5980 = done;
  if (istrue(call5982)) {
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call5984 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe5983);
// compiled call node returning call5984 (depth = 5)
  *var_newChain = call5984;
  if (call5984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5988 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5987);
// compiled call node returning call5988 (depth = 7)
// compiled member node returning call5988 (depth = 6)
  int op_slot_right_5986 = gc_frame_newslot(call5988);
// starting to compile identifier node (depth = 6)
  Object bool5990 = alloc_Boolean(0);
// compiled identifier node returning bool5990 (depth = 6)
  int op_slot_left_5986 = gc_frame_newslot(bool5990);
  params[0] = call5988;
  partcv[0] = 1;
  Object opresult5991 = callmethod(bool5990, "≠", 1, partcv, params);
// compiled op node returning opresult5991 (depth = 5)
  Object if5985 = done;
  if (istrue(opresult5991)) {
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5992 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block5993 = alloc_Block(NULL, NULL, "ast", 1448);
  gc_frame_newslot(block5993);
// method "_apply"
  block_savedest(block5993);
  Object closure5994 = createclosure(3, "_apply");
  setclosureframe(closure5994, stackframe);
  addtoclosure(closure5994, var_visitor);
  addtoclosure(closure5994, var_newChain);
  addtoclosure(closure5994, selfslot);
  struct UserObject *uo5994 = (struct UserObject*)block5993;
  uo5994->data[0] = (Object)closure5994;
  Method *meth_meth_ast__apply5994 = addmethod2pos(block5993, "_apply", &meth_ast__apply5994, 0);
  int argcv_meth_ast__apply5994[] = {1};
  meth_meth_ast__apply5994->type = alloc_MethodType(1, argcv_meth_ast__apply5994);
  meth_meth_ast__apply5994->definitionModule = modulename;
  meth_meth_ast__apply5994->definitionLine = 1447;
// compiled block node returning block5993 (depth = 6)
  gc_frame_newslot(block5993);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5999 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5998);
// compiled call node returning call5999 (depth = 7)
// compiled member node returning call5999 (depth = 6)
  params[0] = block5993;
  partcv[0] = 1;
  Object call6000 = callmethod(call5999, "do",
    1, partcv, params);
  gc_frame_end(callframe5992);
// compiled call node returning call6000 (depth = 5)
    gc_frame_newslot(call6000);
    if5985 = call6000;
  } else {
  }
// compiled if node returning if5985 (depth = 4)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6001 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6003 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6002);
// compiled call node returning call6003 (depth = 6)
// compiled member node returning call6003 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6004 = callmethod(call6003, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6001);
// compiled call node returning call6004 (depth = 4)
    gc_frame_newslot(call6004);
    if5980 = call6004;
  } else {
  }
// compiled if node returning if5980 (depth = 3)
  gc_frame_end(frame);
  return if5980;
}
Object meth_ast_map_40__41_ancestors6005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6006 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6007 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6006);
// compiled call node returning call6007 (depth = 5)
// compiled member node returning call6007 (depth = 4)
  *var_n = call6007;
  if (call6007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6008 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6009 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6008);
// compiled call node returning call6009 (depth = 4)
  *var_newChain = call6009;
  if (call6009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6010 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6011 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6012 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6013 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6012);
// compiled call node returning call6013 (depth = 6)
// compiled member node returning call6013 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6014 = callmethod(call6013, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe6011);
// compiled call node returning call6014 (depth = 4)
  gc_frame_newslot(call6014);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6014;
  partcv[0] = 1;
  Object call6015 = callmethod(*var_n, "in:=",
    1, partcv, params);
  gc_frame_end(callframe6010);
// compiled call node returning call6015 (depth = 3)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6016 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6017 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6018 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6019 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6018);
// compiled call node returning call6019 (depth = 6)
// compiled member node returning call6019 (depth = 5)
  gc_frame_newslot(call6019);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6020 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6021 = gc_frame_new();
// call case 3: self.outer request
  Object call6022 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6021);
// compiled call node returning call6022 (depth = 8)
// compiled member node returning call6022 (depth = 7)
  partcv[0] = 0;
  Object call6023 = callmethodflags(call6022, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6020);
// compiled call node returning call6023 (depth = 6)
// compiled member node returning call6023 (depth = 5)
  params[0] = call6019;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6024 = callmethodflags(call6023, "maybeListMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6017);
// compiled call node returning call6024 (depth = 4)
  gc_frame_newslot(call6024);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6024;
  partcv[0] = 1;
  Object call6025 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6016);
// compiled call node returning call6025 (depth = 3)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6026 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6027 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6026);
// compiled call node returning call6027 (depth = 3)
  gc_frame_end(frame);
  return call6027;
}
Object meth_ast__apply6036(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6038 == NULL) {
    strlit6038 = alloc_String("  ");
    gc_root(strlit6038);
  }
// compiled string node returning strlit6038 (depth = 7)
  int op_slot_right_6037 = gc_frame_newslot(strlit6038);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6037 = gc_frame_newslot(*var_spc);
  params[0] = strlit6038;
  partcv[0] = 1;
  Object opresult6040 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6040 (depth = 6)
  *var_spc = opresult6040;
  if (opresult6040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6097(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6099 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6100 = alloc_Float64(0);
// compiled num node returning num6100 (depth = 9)
  gc_frame_newslot(num6100);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = num6100;
  partcv[0] = 1;
  Object call6101 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6099);
// compiled call node returning call6101 (depth = 8)
  int op_slot_right_6098 = gc_frame_newslot(call6101);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6104 == NULL) {
    strlit6104 = alloc_String("    ");
    gc_root(strlit6104);
  }
// compiled string node returning strlit6104 (depth = 9)
  int op_slot_right_6103 = gc_frame_newslot(strlit6104);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6106 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6109 == NULL) {
    strlit6109 = alloc_String("""\x0a""");
    gc_root(strlit6109);
  }
// compiled string node returning strlit6109 (depth = 11)
  int op_slot_right_6108 = gc_frame_newslot(strlit6109);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6108 = gc_frame_newslot(*var_s);
  params[0] = strlit6109;
  partcv[0] = 1;
  Object opresult6111 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6111 (depth = 10)
  int op_slot_left_6106 = gc_frame_newslot(opresult6111);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6112 = callmethod(opresult6111, "++", 1, partcv, params);
// compiled op node returning opresult6112 (depth = 9)
  int op_slot_left_6103 = gc_frame_newslot(opresult6112);
  params[0] = strlit6104;
  partcv[0] = 1;
  Object opresult6113 = callmethod(opresult6112, "++", 1, partcv, params);
// compiled op node returning opresult6113 (depth = 8)
  int op_slot_left_6098 = gc_frame_newslot(opresult6113);
  params[0] = call6101;
  partcv[0] = 1;
  Object opresult6114 = callmethod(opresult6113, "++", 1, partcv, params);
// compiled op node returning opresult6114 (depth = 7)
  *var_s = opresult6114;
  if (opresult6114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6029 == NULL) {
    strlit6029 = alloc_String("");
    gc_root(strlit6029);
  }
// compiled string node returning strlit6029 (depth = 4)
  *var_spc = strlit6029;
  if (strlit6029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6030 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6031 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6033 = alloc_Float64(0);
// compiled num node returning num6033 (depth = 5)
  int op_slot_left_6031 = gc_frame_newslot(num6033);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6034 = callmethod(num6033, "..", 1, partcv, params);
// compiled op node returning opresult6034 (depth = 4)
  gc_frame_newslot(opresult6034);
// starting to compile block node (depth = 4)
  Object block6035 = alloc_Block(NULL, NULL, "ast", 1462);
  gc_frame_newslot(block6035);
// method "_apply"
  block_savedest(block6035);
  Object closure6036 = createclosure(2, "_apply");
  setclosureframe(closure6036, stackframe);
  addtoclosure(closure6036, var_spc);
  addtoclosure(closure6036, selfslot);
  struct UserObject *uo6036 = (struct UserObject*)block6035;
  uo6036->data[0] = (Object)closure6036;
  Method *meth_meth_ast__apply6036 = addmethod2pos(block6035, "_apply", &meth_ast__apply6036, 0);
  int argcv_meth_ast__apply6036[] = {1};
  meth_meth_ast__apply6036->type = alloc_MethodType(1, argcv_meth_ast__apply6036);
  meth_meth_ast__apply6036->definitionModule = modulename;
  meth_meth_ast__apply6036->definitionLine = 1457;
// compiled block node returning block6035 (depth = 4)
  gc_frame_newslot(block6035);
// call case 5: prelude request
  params[0] = opresult6034;
  params[1] = block6035;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6043 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6030);
// compiled call node returning call6043 (depth = 3)
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6045 == NULL) {
    strlit6045 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6045);
  }
// compiled string node returning strlit6045 (depth = 5)
  int op_slot_right_6044 = gc_frame_newslot(strlit6045);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6049 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6048);
// compiled call node returning call6049 (depth = 7)
// compiled member node returning call6049 (depth = 6)
  int op_slot_right_6047 = gc_frame_newslot(call6049);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6052);
  }
// compiled string node returning strlit6052 (depth = 7)
  int op_slot_right_6051 = gc_frame_newslot(strlit6052);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6055 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6056 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6055);
// compiled call node returning call6056 (depth = 8)
  int op_slot_right_6054 = gc_frame_newslot(call6056);
// starting to compile string node (depth = 8)
  if (strlit6058 == NULL) {
    strlit6058 = alloc_String("");
    gc_root(strlit6058);
  }
// compiled string node returning strlit6058 (depth = 8)
  int op_slot_left_6054 = gc_frame_newslot(strlit6058);
  params[0] = call6056;
  partcv[0] = 1;
  Object opresult6059 = callmethod(strlit6058, "++", 1, partcv, params);
// compiled op node returning opresult6059 (depth = 7)
  int op_slot_left_6051 = gc_frame_newslot(opresult6059);
  params[0] = strlit6052;
  partcv[0] = 1;
  Object opresult6060 = callmethod(opresult6059, "++", 1, partcv, params);
// compiled op node returning opresult6060 (depth = 6)
  int op_slot_left_6047 = gc_frame_newslot(opresult6060);
  params[0] = call6049;
  partcv[0] = 1;
  Object opresult6061 = callmethod(opresult6060, "++", 1, partcv, params);
// compiled op node returning opresult6061 (depth = 5)
  int op_slot_left_6044 = gc_frame_newslot(opresult6061);
  params[0] = strlit6045;
  partcv[0] = 1;
  Object opresult6062 = callmethod(opresult6061, "++", 1, partcv, params);
// compiled op node returning opresult6062 (depth = 4)
  *var_s = opresult6062;
  if (opresult6062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6064 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6066 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6065);
// compiled call node returning call6066 (depth = 7)
// compiled member node returning call6066 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6067 = callmethod(call6066, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6064);
// compiled call node returning call6067 (depth = 5)
  int op_slot_right_6063 = gc_frame_newslot(call6067);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_6069 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6069 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6071 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6071 (depth = 5)
  int op_slot_left_6063 = gc_frame_newslot(opresult6071);
  params[0] = call6067;
  partcv[0] = 1;
  Object opresult6072 = callmethod(opresult6071, "++", 1, partcv, params);
// compiled op node returning opresult6072 (depth = 4)
  *var_s = opresult6072;
  if (opresult6072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6077 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6076);
// compiled call node returning call6077 (depth = 6)
// compiled member node returning call6077 (depth = 5)
  int op_slot_right_6075 = gc_frame_newslot(call6077);
// starting to compile identifier node (depth = 5)
  Object bool6079 = alloc_Boolean(0);
// compiled identifier node returning bool6079 (depth = 5)
  int op_slot_left_6075 = gc_frame_newslot(bool6079);
  params[0] = call6077;
  partcv[0] = 1;
  Object opresult6080 = callmethod(bool6079, "≠", 1, partcv, params);
// compiled op node returning opresult6080 (depth = 4)
  Object if6074 = done;
  if (istrue(opresult6080)) {
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6082 == NULL) {
    strlit6082 = alloc_String("  Generics:");
    gc_root(strlit6082);
  }
// compiled string node returning strlit6082 (depth = 6)
  int op_slot_right_6081 = gc_frame_newslot(strlit6082);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6084 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6087 == NULL) {
    strlit6087 = alloc_String("""\x0a""");
    gc_root(strlit6087);
  }
// compiled string node returning strlit6087 (depth = 8)
  int op_slot_right_6086 = gc_frame_newslot(strlit6087);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6086 = gc_frame_newslot(*var_s);
  params[0] = strlit6087;
  partcv[0] = 1;
  Object opresult6089 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6089 (depth = 7)
  int op_slot_left_6084 = gc_frame_newslot(opresult6089);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6090 = callmethod(opresult6089, "++", 1, partcv, params);
// compiled op node returning opresult6090 (depth = 6)
  int op_slot_left_6081 = gc_frame_newslot(opresult6090);
  params[0] = strlit6082;
  partcv[0] = 1;
  Object opresult6091 = callmethod(opresult6090, "++", 1, partcv, params);
// compiled op node returning opresult6091 (depth = 5)
  *var_s = opresult6091;
  if (opresult6091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6093 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6095 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6094);
// compiled call node returning call6095 (depth = 6)
// compiled member node returning call6095 (depth = 5)
  gc_frame_newslot(call6095);
// starting to compile block node (depth = 5)
  Object block6096 = alloc_Block(NULL, NULL, "ast", 1469);
  gc_frame_newslot(block6096);
// method "_apply"
  block_savedest(block6096);
  Object closure6097 = createclosure(3, "_apply");
  setclosureframe(closure6097, stackframe);
  addtoclosure(closure6097, var_spc);
  addtoclosure(closure6097, var_s);
  addtoclosure(closure6097, selfslot);
  struct UserObject *uo6097 = (struct UserObject*)block6096;
  uo6097->data[0] = (Object)closure6097;
  Method *meth_meth_ast__apply6097 = addmethod2pos(block6096, "_apply", &meth_ast__apply6097, 0);
  int argcv_meth_ast__apply6097[] = {1};
  meth_meth_ast__apply6097->type = alloc_MethodType(1, argcv_meth_ast__apply6097);
  meth_meth_ast__apply6097->definitionModule = modulename;
  meth_meth_ast__apply6097->definitionLine = 1469;
// compiled block node returning block6096 (depth = 5)
  gc_frame_newslot(block6096);
// call case 5: prelude request
  params[0] = call6095;
  params[1] = block6096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6117 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6093);
// compiled call node returning call6117 (depth = 4)
    gc_frame_newslot(call6117);
    if6074 = call6117;
  } else {
  }
// compiled if node returning if6074 (depth = 3)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6194(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6196 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6198 = alloc_Float64(1);
// compiled num node returning num6198 (depth = 10)
  int op_slot_right_6197 = gc_frame_newslot(num6198);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6197 = gc_frame_newslot(*var_depth);
  params[0] = num6198;
  partcv[0] = 1;
  Object sum6200 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6200 (depth = 9)
  gc_frame_newslot(sum6200);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6201 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6202 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6203 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6202);
// compiled call node returning call6203 (depth = 11)
// compiled member node returning call6203 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6204 = callmethod(call6203, "at",
    1, partcv, params);
  gc_frame_end(callframe6201);
// compiled call node returning call6204 (depth = 9)
  params[0] = sum6200;
  partcv[0] = 1;
  Object call6205 = callmethod(call6204, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6196);
// compiled call node returning call6205 (depth = 8)
  int op_slot_right_6195 = gc_frame_newslot(call6205);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6195 = gc_frame_newslot(*var_s);
  params[0] = call6205;
  partcv[0] = 1;
  Object opresult6207 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6207 (depth = 7)
  *var_s = opresult6207;
  if (opresult6207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6119 == NULL) {
    strlit6119 = alloc_String("");
    gc_root(strlit6119);
  }
// compiled string node returning strlit6119 (depth = 4)
  *var_s = strlit6119;
  if (strlit6119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6122 == NULL) {
    strlit6122 = alloc_String("prefix");
    gc_root(strlit6122);
  }
// compiled string node returning strlit6122 (depth = 5)
  int op_slot_right_6121 = gc_frame_newslot(strlit6122);
// starting to compile call node (depth = 5)
  int callframe6124 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6125 = alloc_Float64(1);
// compiled num node returning num6125 (depth = 6)
  gc_frame_newslot(num6125);
// starting to compile num node (depth = 6)
  Object num6126 = alloc_Float64(6);
// compiled num node returning num6126 (depth = 6)
  gc_frame_newslot(num6126);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6128 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6127);
// compiled call node returning call6128 (depth = 7)
// compiled member node returning call6128 (depth = 6)
  params[0] = num6125;
  params[1] = num6126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6129 = callmethod(call6128, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6124);
// compiled call node returning call6129 (depth = 5)
  int op_slot_left_6121 = gc_frame_newslot(call6129);
  params[0] = strlit6122;
  partcv[0] = 1;
  Object opresult6130 = callmethod(call6129, "==", 1, partcv, params);
// compiled op node returning opresult6130 (depth = 4)
  Object if6120 = done;
  if (istrue(opresult6130)) {
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6131 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num6132 = alloc_Float64(7);
// compiled num node returning num6132 (depth = 6)
  gc_frame_newslot(num6132);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6133 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6135 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6134);
// compiled call node returning call6135 (depth = 9)
// compiled member node returning call6135 (depth = 8)
  partcv[0] = 0;
  Object call6136 = callmethod(call6135, "size",
    1, partcv, params);
  gc_frame_end(callframe6133);
// compiled call node returning call6136 (depth = 7)
// compiled member node returning call6136 (depth = 6)
  gc_frame_newslot(call6136);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6137 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6138 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6137);
// compiled call node returning call6138 (depth = 7)
// compiled member node returning call6138 (depth = 6)
  params[0] = num6132;
  params[1] = call6136;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6139 = callmethod(call6138, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6131);
// compiled call node returning call6139 (depth = 5)
  *var_s = call6139;
  if (call6139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6142 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6143 = alloc_Float64(0);
// compiled num node returning num6143 (depth = 7)
  gc_frame_newslot(num6143);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6145 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6144);
// compiled call node returning call6145 (depth = 8)
// compiled member node returning call6145 (depth = 7)
  params[0] = num6143;
  partcv[0] = 1;
  Object call6146 = callmethod(call6145, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6142);
// compiled call node returning call6146 (depth = 6)
  int op_slot_right_6141 = gc_frame_newslot(call6146);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6149 == NULL) {
    strlit6149 = alloc_String(" ");
    gc_root(strlit6149);
  }
// compiled string node returning strlit6149 (depth = 7)
  int op_slot_right_6148 = gc_frame_newslot(strlit6149);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6148 = gc_frame_newslot(*var_s);
  params[0] = strlit6149;
  partcv[0] = 1;
  Object opresult6151 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6151 (depth = 6)
  int op_slot_left_6141 = gc_frame_newslot(opresult6151);
  params[0] = call6146;
  partcv[0] = 1;
  Object opresult6152 = callmethod(opresult6151, "++", 1, partcv, params);
// compiled op node returning opresult6152 (depth = 5)
  *var_s = opresult6152;
  if (opresult6152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6120 = done;
  } else {
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6155 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6156 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6155);
// compiled call node returning call6156 (depth = 7)
// compiled member node returning call6156 (depth = 6)
  int op_slot_right_6154 = gc_frame_newslot(call6156);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6159 == NULL) {
    strlit6159 = alloc_String(".");
    gc_root(strlit6159);
  }
// compiled string node returning strlit6159 (depth = 7)
  int op_slot_right_6158 = gc_frame_newslot(strlit6159);
// starting to compile call node (depth = 7)
  int callframe6161 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6162 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6163 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6162);
// compiled call node returning call6163 (depth = 9)
// compiled member node returning call6163 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6164 = callmethod(call6163, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6161);
// compiled call node returning call6164 (depth = 7)
  int op_slot_left_6158 = gc_frame_newslot(call6164);
  params[0] = strlit6159;
  partcv[0] = 1;
  Object opresult6165 = callmethod(call6164, "++", 1, partcv, params);
// compiled op node returning opresult6165 (depth = 6)
  int op_slot_left_6154 = gc_frame_newslot(opresult6165);
  params[0] = call6156;
  partcv[0] = 1;
  Object opresult6166 = callmethod(opresult6165, "++", 1, partcv, params);
// compiled op node returning opresult6166 (depth = 5)
  *var_s = opresult6166;
  if (opresult6166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6120 = done;
  }
// compiled if node returning if6120 (depth = 3)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6170 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6171 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6170);
// compiled call node returning call6171 (depth = 6)
// compiled member node returning call6171 (depth = 5)
  int op_slot_right_6169 = gc_frame_newslot(call6171);
// starting to compile identifier node (depth = 5)
  Object bool6173 = alloc_Boolean(0);
// compiled identifier node returning bool6173 (depth = 5)
  int op_slot_left_6169 = gc_frame_newslot(bool6173);
  params[0] = call6171;
  partcv[0] = 1;
  Object opresult6174 = callmethod(bool6173, "≠", 1, partcv, params);
// compiled op node returning opresult6174 (depth = 4)
  Object if6168 = done;
  if (istrue(opresult6174)) {
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6176 == NULL) {
    strlit6176 = alloc_String("<");
    gc_root(strlit6176);
  }
// compiled string node returning strlit6176 (depth = 6)
  int op_slot_right_6175 = gc_frame_newslot(strlit6176);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6175 = gc_frame_newslot(*var_s);
  params[0] = strlit6176;
  partcv[0] = 1;
  Object opresult6178 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6178 (depth = 5)
  *var_s = opresult6178;
  if (opresult6178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6180 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6183 = alloc_Float64(1);
// compiled num node returning num6183 (depth = 7)
  int op_slot_right_6182 = gc_frame_newslot(num6183);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6185 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6186 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6187 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6186);
// compiled call node returning call6187 (depth = 10)
// compiled member node returning call6187 (depth = 9)
  partcv[0] = 0;
  Object call6188 = callmethod(call6187, "size",
    1, partcv, params);
  gc_frame_end(callframe6185);
// compiled call node returning call6188 (depth = 8)
// compiled member node returning call6188 (depth = 7)
  int op_slot_left_6182 = gc_frame_newslot(call6188);
  params[0] = num6183;
  partcv[0] = 1;
  Object diff6189 = callmethod(call6188, "-", 1, partcv, params);
// compiled op node returning diff6189 (depth = 6)
  int op_slot_right_6181 = gc_frame_newslot(diff6189);
// starting to compile num node (depth = 6)
  Object num6191 = alloc_Float64(1);
// compiled num node returning num6191 (depth = 6)
  int op_slot_left_6181 = gc_frame_newslot(num6191);
  params[0] = diff6189;
  partcv[0] = 1;
  Object opresult6192 = callmethod(num6191, "..", 1, partcv, params);
// compiled op node returning opresult6192 (depth = 5)
  gc_frame_newslot(opresult6192);
// starting to compile block node (depth = 5)
  Object block6193 = alloc_Block(NULL, NULL, "ast", 1485);
  gc_frame_newslot(block6193);
// method "_apply"
  block_savedest(block6193);
  Object closure6194 = createclosure(3, "_apply");
  setclosureframe(closure6194, stackframe);
  addtoclosure(closure6194, var_depth);
  addtoclosure(closure6194, var_s);
  addtoclosure(closure6194, selfslot);
  struct UserObject *uo6194 = (struct UserObject*)block6193;
  uo6194->data[0] = (Object)closure6194;
  Method *meth_meth_ast__apply6194 = addmethod2pos(block6193, "_apply", &meth_ast__apply6194, 0);
  int argcv_meth_ast__apply6194[] = {1};
  meth_meth_ast__apply6194->type = alloc_MethodType(1, argcv_meth_ast__apply6194);
  meth_meth_ast__apply6194->definitionModule = modulename;
  meth_meth_ast__apply6194->definitionLine = 1485;
// compiled block node returning block6193 (depth = 5)
  gc_frame_newslot(block6193);
// call case 5: prelude request
  params[0] = opresult6192;
  params[1] = block6193;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6210 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6180);
// compiled call node returning call6210 (depth = 4)
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6212 == NULL) {
    strlit6212 = alloc_String(">");
    gc_root(strlit6212);
  }
// compiled string node returning strlit6212 (depth = 6)
  int op_slot_right_6211 = gc_frame_newslot(strlit6212);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6215 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6217 = alloc_Float64(1);
// compiled num node returning num6217 (depth = 9)
  int op_slot_right_6216 = gc_frame_newslot(num6217);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6216 = gc_frame_newslot(*var_depth);
  params[0] = num6217;
  partcv[0] = 1;
  Object sum6219 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6219 (depth = 8)
  gc_frame_newslot(sum6219);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6220 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6222 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6221);
// compiled call node returning call6222 (depth = 11)
// compiled member node returning call6222 (depth = 10)
  partcv[0] = 0;
  Object call6223 = callmethod(call6222, "last",
    1, partcv, params);
  gc_frame_end(callframe6220);
// compiled call node returning call6223 (depth = 9)
// compiled member node returning call6223 (depth = 8)
  params[0] = sum6219;
  partcv[0] = 1;
  Object call6224 = callmethod(call6223, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6215);
// compiled call node returning call6224 (depth = 7)
  int op_slot_right_6214 = gc_frame_newslot(call6224);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6214 = gc_frame_newslot(*var_s);
  params[0] = call6224;
  partcv[0] = 1;
  Object opresult6226 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6226 (depth = 6)
  int op_slot_left_6211 = gc_frame_newslot(opresult6226);
  params[0] = strlit6212;
  partcv[0] = 1;
  Object opresult6227 = callmethod(opresult6226, "++", 1, partcv, params);
// compiled op node returning opresult6227 (depth = 5)
  *var_s = opresult6227;
  if (opresult6227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6168 = done;
  } else {
  }
// compiled if node returning if6168 (depth = 3)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6229(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6231 == NULL) {
    strlit6231 = alloc_String("");
    gc_root(strlit6231);
  }
// compiled string node returning strlit6231 (depth = 4)
  int op_slot_right_6230 = gc_frame_newslot(strlit6231);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6234 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6235 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6234);
// compiled call node returning call6235 (depth = 6)
// compiled member node returning call6235 (depth = 5)
  int op_slot_right_6233 = gc_frame_newslot(call6235);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6238 == NULL) {
    strlit6238 = alloc_String(".");
    gc_root(strlit6238);
  }
// compiled string node returning strlit6238 (depth = 6)
  int op_slot_right_6237 = gc_frame_newslot(strlit6238);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6242 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6241);
// compiled call node returning call6242 (depth = 8)
// compiled member node returning call6242 (depth = 7)
  int op_slot_right_6240 = gc_frame_newslot(call6242);
// starting to compile string node (depth = 7)
  if (strlit6244 == NULL) {
    strlit6244 = alloc_String("");
    gc_root(strlit6244);
  }
// compiled string node returning strlit6244 (depth = 7)
  int op_slot_left_6240 = gc_frame_newslot(strlit6244);
  params[0] = call6242;
  partcv[0] = 1;
  Object opresult6245 = callmethod(strlit6244, "++", 1, partcv, params);
// compiled op node returning opresult6245 (depth = 6)
  int op_slot_left_6237 = gc_frame_newslot(opresult6245);
  params[0] = strlit6238;
  partcv[0] = 1;
  Object opresult6246 = callmethod(opresult6245, "++", 1, partcv, params);
// compiled op node returning opresult6246 (depth = 5)
  int op_slot_left_6233 = gc_frame_newslot(opresult6246);
  params[0] = call6235;
  partcv[0] = 1;
  Object opresult6247 = callmethod(opresult6246, "++", 1, partcv, params);
// compiled op node returning opresult6247 (depth = 4)
  int op_slot_left_6230 = gc_frame_newslot(opresult6247);
  params[0] = strlit6231;
  partcv[0] = 1;
  Object opresult6248 = callmethod(opresult6247, "++", 1, partcv, params);
// compiled op node returning opresult6248 (depth = 3)
  gc_frame_end(frame);
  return opresult6248;
}
Object meth_ast_asIdentifier6249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6253 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6252);
// compiled call node returning call6253 (depth = 6)
// compiled member node returning call6253 (depth = 5)
  int op_slot_right_6251 = gc_frame_newslot(call6253);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_fakeSymbolTable (depth = 5)
  int op_slot_left_6251 = gc_frame_newslot(*var_fakeSymbolTable);
  params[0] = call6253;
  partcv[0] = 1;
  Object opresult6255 = callmethod(*var_fakeSymbolTable, "==", 1, partcv, params);
// compiled op node returning opresult6255 (depth = 4)
  Object if6250 = done;
  if (istrue(opresult6255)) {
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6256 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6258 == NULL) {
    strlit6258 = alloc_String(" when scope was fake");
    gc_root(strlit6258);
  }
// compiled string node returning strlit6258 (depth = 6)
  int op_slot_right_6257 = gc_frame_newslot(strlit6258);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6261 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6262 = alloc_Float64(0);
// compiled num node returning num6262 (depth = 8)
  gc_frame_newslot(num6262);
// call case 4: self request
  params[0] = num6262;
  partcv[0] = 1;
  Object call6263 = callmethodflags(self, "pretty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6261);
// compiled call node returning call6263 (depth = 7)
  int op_slot_right_6260 = gc_frame_newslot(call6263);
// starting to compile string node (depth = 7)
  if (strlit6265 == NULL) {
    strlit6265 = alloc_String("asIdentifier requested on ");
    gc_root(strlit6265);
  }
// compiled string node returning strlit6265 (depth = 7)
  int op_slot_left_6260 = gc_frame_newslot(strlit6265);
  params[0] = call6263;
  partcv[0] = 1;
  Object opresult6266 = callmethod(strlit6265, "++", 1, partcv, params);
// compiled op node returning opresult6266 (depth = 6)
  int op_slot_left_6257 = gc_frame_newslot(opresult6266);
  params[0] = strlit6258;
  partcv[0] = 1;
  Object opresult6267 = callmethod(opresult6266, "++", 1, partcv, params);
// compiled op node returning opresult6267 (depth = 5)
  gc_frame_newslot(opresult6267);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6268 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6269 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6268);
// compiled call node returning call6269 (depth = 6)
// compiled member node returning call6269 (depth = 5)
  params[0] = opresult6267;
  partcv[0] = 1;
  Object call6270 = callmethod(call6269, "raise",
    1, partcv, params);
  gc_frame_end(callframe6256);
// compiled call node returning call6270 (depth = 4)
    gc_frame_newslot(call6270);
    if6250 = call6270;
  } else {
  }
// compiled if node returning if6250 (depth = 3)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6271 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6273 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6272);
// compiled call node returning call6273 (depth = 6)
// compiled member node returning call6273 (depth = 5)
  gc_frame_newslot(call6273);
// starting to compile identifier node (depth = 5)
  Object bool6274 = alloc_Boolean(0);
// compiled identifier node returning bool6274 (depth = 5)
  gc_frame_newslot(bool6274);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6276 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6275);
// compiled call node returning call6276 (depth = 6)
// compiled member node returning call6276 (depth = 5)
  gc_frame_newslot(call6276);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6273;
  params[1] = bool6274;
  params[2] = call6276;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6277 = callmethod(*var_identifierNode, "new()scope",
    2, partcv, params);
  gc_frame_end(callframe6271);
// compiled call node returning call6277 (depth = 4)
  *var_resultNode = call6277;
  if (call6277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6278 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6279 = alloc_Boolean(1);
// compiled identifier node returning bool6279 (depth = 4)
  gc_frame_newslot(bool6279);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool6279;
  partcv[0] = 1;
  Object call6280 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe6278);
// compiled call node returning call6280 (depth = 3)
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6281 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6283 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6282);
// compiled call node returning call6283 (depth = 5)
// compiled member node returning call6283 (depth = 4)
  gc_frame_newslot(call6283);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6283;
  partcv[0] = 1;
  Object call6284 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6281);
// compiled call node returning call6284 (depth = 3)
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6285 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6287 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6286);
// compiled call node returning call6287 (depth = 5)
// compiled member node returning call6287 (depth = 4)
  gc_frame_newslot(call6287);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call6287;
  partcv[0] = 1;
  Object call6288 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6285);
// compiled call node returning call6288 (depth = 3)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy6289(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_memberNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6290 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6291 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6292 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6293 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6292);
// compiled call node returning call6293 (depth = 6)
// compiled member node returning call6293 (depth = 5)
  gc_frame_newslot(call6293);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_memberNode (depth = 5)
  params[0] = call6293;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call6294 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6291);
// compiled call node returning call6294 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6295 = callmethod(call6294, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6290);
// compiled call node returning call6295 (depth = 3)
  gc_frame_end(frame);
  return call6295;
}
Object meth_ast_statementName6296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6297 == NULL) {
    strlit6297 = alloc_String("expression");
    gc_root(strlit6297);
  }
// compiled string node returning strlit6297 (depth = 3)
  gc_frame_end(frame);
  return strlit6297;
}
Object meth_ast_new5964(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5965 = alloc_userobj2(18,16, objclass5965);
  gc_frame_newslot(obj5965);
if (objclass5965 == NULL) {
  glfree(obj5965->class->name);
  obj5965->class->name = "memberNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5965, self, 0);
  addmethodreal(obj5965,"outer", &reader_ast_outer_5966);
  Object oldself5965 = self;
  struct StackFrameObject *oldstackframe5965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5965);
  gc_frame_newslot((Object)stackframe);
  self = obj5965;
  Object *oldselfslot5965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5965 = (*(struct UserObject *)self).data[0], lowerouter5965 = thisouter5965;
  if (inheritingObject5965) {
    struct UserObject *inho5965 = (struct UserObject *)inheritingObject5965;
    while (inho5965->super != GraceDefaultObject) inho5965 = (struct UserObject *)inho5965->super;
    inho5965->super = obj5965;
    self = inheritingObject5965;
    *selfslot = self;
    lowerouter5965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5965;
  }
if (objclass5965 == NULL) {
  Method *reader5967 = addmethodrealflags(obj5965, "kind",&reader_ast_kind_5967, MFLAG_DEF);
  reader5967->definitionModule = modulename;
  reader5967->definitionLine = 1436;
}
adddatum2(obj5965, alloc_Undefined(), 1);
if (objclass5965 == NULL) {
  Method *reader5968 = addmethodrealflags(obj5965, "value",&reader_ast_value_5968, 0);
  Method *writer5968 = addmethodrealflags(obj5965, "value:=",&writer_ast_value_5968, 0);
  reader5968->definitionModule = modulename;
  writer5968->definitionModule = modulename;
  reader5968->definitionLine = 1437;
  writer5968->definitionLine = 1437;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 2);
if (objclass5965 == NULL) {
  Method *reader5969 = addmethodrealflags(obj5965, "in",&reader_ast_in_5969, 0);
  Method *writer5969 = addmethodrealflags(obj5965, "in:=",&writer_ast_in_5969, 0);
  reader5969->definitionModule = modulename;
  writer5969->definitionModule = modulename;
  reader5969->definitionLine = 1438;
  writer5969->definitionLine = 1438;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 3);
if (objclass5965 == NULL) {
  Method *reader5970 = addmethodrealflags(obj5965, "generics",&reader_ast_generics_5970, 0);
  Method *writer5970 = addmethodrealflags(obj5965, "generics:=",&writer_ast_generics_5970, 0);
  reader5970->definitionModule = modulename;
  writer5970->definitionModule = modulename;
  reader5970->definitionLine = 1439;
  writer5970->definitionLine = 1439;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 4);
// method "target"
  struct UserObject *uo5971 = (struct UserObject*)obj5965;
  uo5971->data[5] = emptyclosure;
  Method *meth_meth_ast_target5971 = addmethod2pos(obj5965, "target", &meth_ast_target5971, 5);
  int argcv_meth_ast_target5971[] = {0};
  meth_meth_ast_target5971->type = alloc_MethodType(1, argcv_meth_ast_target5971);
  meth_meth_ast_target5971->definitionModule = modulename;
  meth_meth_ast_target5971->definitionLine = 1441;
// method "nameString"
  struct UserObject *uo5974 = (struct UserObject*)obj5965;
  uo5974->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString5974 = addmethod2pos(obj5965, "nameString", &meth_ast_nameString5974, 6);
  int argcv_meth_ast_nameString5974[] = {0};
  meth_meth_ast_nameString5974->type = alloc_MethodType(1, argcv_meth_ast_nameString5974);
  meth_meth_ast_nameString5974->definitionModule = modulename;
  meth_meth_ast_nameString5974->definitionLine = 1442;
// method "isMember"
  struct UserObject *uo5977 = (struct UserObject*)obj5965;
  uo5977->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember5977 = addmethod2pos(obj5965, "isMember", &meth_ast_isMember5977, 7);
  int argcv_meth_ast_isMember5977[] = {0};
  meth_meth_ast_isMember5977->type = alloc_MethodType(1, argcv_meth_ast_isMember5977);
  meth_meth_ast_isMember5977->definitionModule = modulename;
  meth_meth_ast_isMember5977->definitionLine = 1443;
// method "accept()from"
  struct UserObject *uo5979 = (struct UserObject*)obj5965;
  uo5979->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5979 = addmethod2pos(obj5965, "accept()from", &meth_ast_accept_40__41_from5979, 8);
  int argcv_meth_ast_accept_40__41_from5979[] = {1, 1};
  meth_meth_ast_accept_40__41_from5979->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5979);
  meth_meth_ast_accept_40__41_from5979->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5979->definitionLine = 1444;
// method "map()ancestors"
  struct UserObject *uo6005 = (struct UserObject*)obj5965;
  uo6005->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6005 = addmethod2pos(obj5965, "map()ancestors", &meth_ast_map_40__41_ancestors6005, 9);
  int argcv_meth_ast_map_40__41_ancestors6005[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6005->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6005);
  meth_meth_ast_map_40__41_ancestors6005->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6005->definitionLine = 1453;
// method "pretty"
  struct UserObject *uo6028 = (struct UserObject*)obj5965;
  uo6028->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6028 = addmethod2pos(obj5965, "pretty", &meth_ast_pretty6028, 10);
  int argcv_meth_ast_pretty6028[] = {1};
  meth_meth_ast_pretty6028->type = alloc_MethodType(1, argcv_meth_ast_pretty6028);
  meth_meth_ast_pretty6028->definitionModule = modulename;
  meth_meth_ast_pretty6028->definitionLine = 1460;
// method "toGrace"
  struct UserObject *uo6118 = (struct UserObject*)obj5965;
  uo6118->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6118 = addmethod2pos(obj5965, "toGrace", &meth_ast_toGrace6118, 11);
  int argcv_meth_ast_toGrace6118[] = {1};
  meth_meth_ast_toGrace6118->type = alloc_MethodType(1, argcv_meth_ast_toGrace6118);
meth_meth_ast_toGrace6118->type->types[0] = type_Number;
meth_meth_ast_toGrace6118->type->names[0] = "depth";
  meth_meth_ast_toGrace6118->definitionModule = modulename;
  meth_meth_ast_toGrace6118->definitionLine = 1475;
// method "asString"
  struct UserObject *uo6229 = (struct UserObject*)obj5965;
  uo6229->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6229 = addmethod2pos(obj5965, "asString", &meth_ast_asString6229, 12);
  int argcv_meth_ast_asString6229[] = {0};
  meth_meth_ast_asString6229->type = alloc_MethodType(1, argcv_meth_ast_asString6229);
  meth_meth_ast_asString6229->definitionModule = modulename;
  meth_meth_ast_asString6229->definitionLine = 1492;
// method "asIdentifier"
  block_savedest(obj5965);
  Object closure6249 = createclosure(2, "asIdentifier");
  setclosureframe(closure6249, stackframe);
  addtoclosure(closure6249, var_fakeSymbolTable);
  addtoclosure(closure6249, var_identifierNode);
  struct UserObject *uo6249 = (struct UserObject*)obj5965;
  uo6249->data[13] = (Object)closure6249;
  Method *meth_meth_ast_asIdentifier6249 = addmethod2pos(obj5965, "asIdentifier", &meth_ast_asIdentifier6249, 13);
  int argcv_meth_ast_asIdentifier6249[] = {0};
  meth_meth_ast_asIdentifier6249->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6249);
  meth_meth_ast_asIdentifier6249->definitionModule = modulename;
  meth_meth_ast_asIdentifier6249->definitionLine = 1493;
// method "shallowCopy"
  block_savedest(obj5965);
  Object closure6289 = createclosure(2, "shallowCopy");
  setclosureframe(closure6289, stackframe);
  addtoclosure(closure6289, var_nullNode);
  addtoclosure(closure6289, var_memberNode);
  struct UserObject *uo6289 = (struct UserObject*)obj5965;
  uo6289->data[14] = (Object)closure6289;
  Method *meth_meth_ast_shallowCopy6289 = addmethod2pos(obj5965, "shallowCopy", &meth_ast_shallowCopy6289, 14);
  int argcv_meth_ast_shallowCopy6289[] = {0};
  meth_meth_ast_shallowCopy6289->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6289);
  meth_meth_ast_shallowCopy6289->definitionModule = modulename;
  meth_meth_ast_shallowCopy6289->definitionLine = 1504;
// method "statementName"
  struct UserObject *uo6296 = (struct UserObject*)obj5965;
  uo6296->data[15] = emptyclosure;
  Method *meth_meth_ast_statementName6296 = addmethod2pos(obj5965, "statementName", &meth_ast_statementName6296, 15);
  int argcv_meth_ast_statementName6296[] = {0};
  meth_meth_ast_statementName6296->type = alloc_MethodType(1, argcv_meth_ast_statementName6296);
  meth_meth_ast_statementName6296->definitionModule = modulename;
  meth_meth_ast_statementName6296->definitionLine = 1507;
  sourceObject = obj5965;
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6299 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6300 = gc_frame_new();
// call case 3: self.outer request
  Object call6301 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6300);
// compiled call node returning call6301 (depth = 7)
// compiled member node returning call6301 (depth = 6)
  partcv[0] = 0;
  Object call6302 = callmethodflags(call6301, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6299);
// compiled call node returning call6302 (depth = 5)
// compiled member node returning call6302 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6303 = callmethodflags(call6302, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6298);
// compiled call node returning call6303 (depth = 3)
  struct UserObject *obj5965_uo = (struct UserObject *)obj5965;
  obj5965_uo->super = call6303;
  sourceObject = obj5965;
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6304 == NULL) {
    strlit6304 = alloc_String("member");
    gc_root(strlit6304);
  }
// compiled string node returning strlit6304 (depth = 3)
  adddatum2(obj5965, strlit6304, 1);
  sourceObject = obj5965;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj5965, *var_request, 2);
  sourceObject = obj5965;
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj5965, *var_receiver, 3);
  sourceObject = obj5965;
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6305 = alloc_Boolean(0);
// compiled identifier node returning bool6305 (depth = 3)
  adddatum2(obj5965, bool6305, 4);
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  objclass5965 = obj5965->class;
  objclass5965->definitionModule = modulename;
  objclass5965->definitionLine = 1433;
  (*(struct UserObject *)self).data[0] = lowerouter5965;
  self = oldself5965;
  selfslot = oldselfslot5965;
  stackframe = oldstackframe5965;
  gc_frame_end(frame);
  return obj5965;
}
Object meth_ast_new5964_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_fakeSymbolTable = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_memberNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_request = &(stackframe->slots[0]);
  *var_request = args[curarg];
  curarg++;
  Object *var_receiver = &(stackframe->slots[1]);
  *var_receiver = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5965 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5965 = alloc_userobj2(18,16, objclass5965);
  gc_frame_newslot(obj5965);
if (objclass5965 == NULL) {
  glfree(obj5965->class->name);
  obj5965->class->name = "memberNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5965, self, 0);
  addmethodreal(obj5965,"outer", &reader_ast_outer_5966);
  Object oldself5965 = self;
  struct StackFrameObject *oldstackframe5965 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5965);
  gc_frame_newslot((Object)stackframe);
  self = obj5965;
  Object *oldselfslot5965 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5965 = (*(struct UserObject *)self).data[0], lowerouter5965 = thisouter5965;
  if (inheritingObject5965) {
    struct UserObject *inho5965 = (struct UserObject *)inheritingObject5965;
    while (inho5965->super != GraceDefaultObject) inho5965 = (struct UserObject *)inho5965->super;
    inho5965->super = obj5965;
    self = inheritingObject5965;
    *selfslot = self;
    lowerouter5965 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5965;
  }
if (objclass5965 == NULL) {
  Method *reader5967 = addmethodrealflags(obj5965, "kind",&reader_ast_kind_5967, MFLAG_DEF);
  reader5967->definitionModule = modulename;
  reader5967->definitionLine = 1436;
}
adddatum2(obj5965, alloc_Undefined(), 1);
if (objclass5965 == NULL) {
  Method *reader5968 = addmethodrealflags(obj5965, "value",&reader_ast_value_5968, 0);
  Method *writer5968 = addmethodrealflags(obj5965, "value:=",&writer_ast_value_5968, 0);
  reader5968->definitionModule = modulename;
  writer5968->definitionModule = modulename;
  reader5968->definitionLine = 1437;
  writer5968->definitionLine = 1437;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 2);
if (objclass5965 == NULL) {
  Method *reader5969 = addmethodrealflags(obj5965, "in",&reader_ast_in_5969, 0);
  Method *writer5969 = addmethodrealflags(obj5965, "in:=",&writer_ast_in_5969, 0);
  reader5969->definitionModule = modulename;
  writer5969->definitionModule = modulename;
  reader5969->definitionLine = 1438;
  writer5969->definitionLine = 1438;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 3);
if (objclass5965 == NULL) {
  Method *reader5970 = addmethodrealflags(obj5965, "generics",&reader_ast_generics_5970, 0);
  Method *writer5970 = addmethodrealflags(obj5965, "generics:=",&writer_ast_generics_5970, 0);
  reader5970->definitionModule = modulename;
  writer5970->definitionModule = modulename;
  reader5970->definitionLine = 1439;
  writer5970->definitionLine = 1439;
}
obj5965->flags |= OFLAG_MUTABLE;
adddatum2(obj5965, alloc_Undefined(), 4);
// method "target"
  struct UserObject *uo5971 = (struct UserObject*)obj5965;
  uo5971->data[5] = emptyclosure;
  Method *meth_meth_ast_target5971 = addmethod2pos(obj5965, "target", &meth_ast_target5971, 5);
  int argcv_meth_ast_target5971[] = {0};
  meth_meth_ast_target5971->type = alloc_MethodType(1, argcv_meth_ast_target5971);
  meth_meth_ast_target5971->definitionModule = modulename;
  meth_meth_ast_target5971->definitionLine = 1441;
// method "nameString"
  struct UserObject *uo5974 = (struct UserObject*)obj5965;
  uo5974->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString5974 = addmethod2pos(obj5965, "nameString", &meth_ast_nameString5974, 6);
  int argcv_meth_ast_nameString5974[] = {0};
  meth_meth_ast_nameString5974->type = alloc_MethodType(1, argcv_meth_ast_nameString5974);
  meth_meth_ast_nameString5974->definitionModule = modulename;
  meth_meth_ast_nameString5974->definitionLine = 1442;
// method "isMember"
  struct UserObject *uo5977 = (struct UserObject*)obj5965;
  uo5977->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember5977 = addmethod2pos(obj5965, "isMember", &meth_ast_isMember5977, 7);
  int argcv_meth_ast_isMember5977[] = {0};
  meth_meth_ast_isMember5977->type = alloc_MethodType(1, argcv_meth_ast_isMember5977);
  meth_meth_ast_isMember5977->definitionModule = modulename;
  meth_meth_ast_isMember5977->definitionLine = 1443;
// method "accept()from"
  struct UserObject *uo5979 = (struct UserObject*)obj5965;
  uo5979->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5979 = addmethod2pos(obj5965, "accept()from", &meth_ast_accept_40__41_from5979, 8);
  int argcv_meth_ast_accept_40__41_from5979[] = {1, 1};
  meth_meth_ast_accept_40__41_from5979->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5979);
  meth_meth_ast_accept_40__41_from5979->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5979->definitionLine = 1444;
// method "map()ancestors"
  struct UserObject *uo6005 = (struct UserObject*)obj5965;
  uo6005->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6005 = addmethod2pos(obj5965, "map()ancestors", &meth_ast_map_40__41_ancestors6005, 9);
  int argcv_meth_ast_map_40__41_ancestors6005[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6005->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6005);
  meth_meth_ast_map_40__41_ancestors6005->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6005->definitionLine = 1453;
// method "pretty"
  struct UserObject *uo6028 = (struct UserObject*)obj5965;
  uo6028->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6028 = addmethod2pos(obj5965, "pretty", &meth_ast_pretty6028, 10);
  int argcv_meth_ast_pretty6028[] = {1};
  meth_meth_ast_pretty6028->type = alloc_MethodType(1, argcv_meth_ast_pretty6028);
  meth_meth_ast_pretty6028->definitionModule = modulename;
  meth_meth_ast_pretty6028->definitionLine = 1460;
// method "toGrace"
  struct UserObject *uo6118 = (struct UserObject*)obj5965;
  uo6118->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6118 = addmethod2pos(obj5965, "toGrace", &meth_ast_toGrace6118, 11);
  int argcv_meth_ast_toGrace6118[] = {1};
  meth_meth_ast_toGrace6118->type = alloc_MethodType(1, argcv_meth_ast_toGrace6118);
meth_meth_ast_toGrace6118->type->types[0] = type_Number;
meth_meth_ast_toGrace6118->type->names[0] = "depth";
  meth_meth_ast_toGrace6118->definitionModule = modulename;
  meth_meth_ast_toGrace6118->definitionLine = 1475;
// method "asString"
  struct UserObject *uo6229 = (struct UserObject*)obj5965;
  uo6229->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6229 = addmethod2pos(obj5965, "asString", &meth_ast_asString6229, 12);
  int argcv_meth_ast_asString6229[] = {0};
  meth_meth_ast_asString6229->type = alloc_MethodType(1, argcv_meth_ast_asString6229);
  meth_meth_ast_asString6229->definitionModule = modulename;
  meth_meth_ast_asString6229->definitionLine = 1492;
// method "asIdentifier"
  block_savedest(obj5965);
  Object closure6249 = createclosure(2, "asIdentifier");
  setclosureframe(closure6249, stackframe);
  addtoclosure(closure6249, var_fakeSymbolTable);
  addtoclosure(closure6249, var_identifierNode);
  struct UserObject *uo6249 = (struct UserObject*)obj5965;
  uo6249->data[13] = (Object)closure6249;
  Method *meth_meth_ast_asIdentifier6249 = addmethod2pos(obj5965, "asIdentifier", &meth_ast_asIdentifier6249, 13);
  int argcv_meth_ast_asIdentifier6249[] = {0};
  meth_meth_ast_asIdentifier6249->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6249);
  meth_meth_ast_asIdentifier6249->definitionModule = modulename;
  meth_meth_ast_asIdentifier6249->definitionLine = 1493;
// method "shallowCopy"
  block_savedest(obj5965);
  Object closure6289 = createclosure(2, "shallowCopy");
  setclosureframe(closure6289, stackframe);
  addtoclosure(closure6289, var_nullNode);
  addtoclosure(closure6289, var_memberNode);
  struct UserObject *uo6289 = (struct UserObject*)obj5965;
  uo6289->data[14] = (Object)closure6289;
  Method *meth_meth_ast_shallowCopy6289 = addmethod2pos(obj5965, "shallowCopy", &meth_ast_shallowCopy6289, 14);
  int argcv_meth_ast_shallowCopy6289[] = {0};
  meth_meth_ast_shallowCopy6289->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6289);
  meth_meth_ast_shallowCopy6289->definitionModule = modulename;
  meth_meth_ast_shallowCopy6289->definitionLine = 1504;
// method "statementName"
  struct UserObject *uo6296 = (struct UserObject*)obj5965;
  uo6296->data[15] = emptyclosure;
  Method *meth_meth_ast_statementName6296 = addmethod2pos(obj5965, "statementName", &meth_ast_statementName6296, 15);
  int argcv_meth_ast_statementName6296[] = {0};
  meth_meth_ast_statementName6296->type = alloc_MethodType(1, argcv_meth_ast_statementName6296);
  meth_meth_ast_statementName6296->definitionModule = modulename;
  meth_meth_ast_statementName6296->definitionLine = 1507;
  sourceObject = obj5965;
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6298 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6299 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6300 = gc_frame_new();
// call case 3: self.outer request
  Object call6301 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6300);
// compiled call node returning call6301 (depth = 7)
// compiled member node returning call6301 (depth = 6)
  partcv[0] = 0;
  Object call6302 = callmethodflags(call6301, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6299);
// compiled call node returning call6302 (depth = 5)
// compiled member node returning call6302 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6303 = callmethodflags(call6302, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6298);
// compiled call node returning call6303 (depth = 3)
  struct UserObject *obj5965_uo = (struct UserObject *)obj5965;
  obj5965_uo->super = call6303;
  sourceObject = obj5965;
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6304 == NULL) {
    strlit6304 = alloc_String("member");
    gc_root(strlit6304);
  }
// compiled string node returning strlit6304 (depth = 3)
  adddatum2(obj5965, strlit6304, 1);
  sourceObject = obj5965;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_request (depth = 3)
  adddatum2(obj5965, *var_request, 2);
  sourceObject = obj5965;
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_receiver (depth = 3)
  adddatum2(obj5965, *var_receiver, 3);
  sourceObject = obj5965;
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6305 = alloc_Boolean(0);
// compiled identifier node returning bool6305 (depth = 3)
  adddatum2(obj5965, bool6305, 4);
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  sourceObject = obj5965;
  objclass5965 = obj5965->class;
  objclass5965->definitionModule = modulename;
  objclass5965->definitionLine = 1433;
  (*(struct UserObject *)self).data[0] = lowerouter5965;
  self = oldself5965;
  selfslot = oldselfslot5965;
  stackframe = oldstackframe5965;
  gc_frame_end(frame);
  return obj5965;
}
Object meth_ast_memberNode6307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for memberNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_nameString6316(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6317 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6319 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6318);
// compiled call node returning call6319 (depth = 6)
// compiled member node returning call6319 (depth = 5)
  partcv[0] = 0;
  Object call6320 = callmethod(call6319, "nameString",
    1, partcv, params);
  gc_frame_end(callframe6317);
// compiled call node returning call6320 (depth = 4)
// compiled member node returning call6320 (depth = 3)
  gc_frame_end(frame);
  return call6320;
}
Object meth_ast_asString6321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6322 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6323 = alloc_Float64(0);
// compiled num node returning num6323 (depth = 4)
  gc_frame_newslot(num6323);
// call case 4: self request
  params[0] = num6323;
  partcv[0] = 1;
  Object call6324 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6322);
// compiled call node returning call6324 (depth = 3)
  gc_frame_end(frame);
  return call6324;
}
Object meth_ast__apply6339(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6340 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6341 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6340);
// compiled call node returning call6341 (depth = 6)
  gc_frame_end(frame);
  return call6341;
}
Object meth_ast_accept_40__41_from6325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6327 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6328 = callmethod(*var_visitor, "visitGeneric()up",
    2, partcv, params);
  gc_frame_end(callframe6327);
// compiled call node returning call6328 (depth = 4)
  Object if6326 = done;
  if (istrue(call6328)) {
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6329 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6330 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6329);
// compiled call node returning call6330 (depth = 5)
  *var_newChain = call6330;
  if (call6330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6331 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6332 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6333 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6332);
// compiled call node returning call6333 (depth = 6)
// compiled member node returning call6333 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6334 = callmethod(call6333, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6331);
// compiled call node returning call6334 (depth = 4)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6335 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6336 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6337 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6336);
// compiled call node returning call6337 (depth = 6)
// compiled member node returning call6337 (depth = 5)
  gc_frame_newslot(call6337);
// starting to compile block node (depth = 5)
  Object block6338 = alloc_Block(NULL, NULL, "ast", 1525);
  gc_frame_newslot(block6338);
// method "_apply"
  block_savedest(block6338);
  Object closure6339 = createclosure(3, "_apply");
  setclosureframe(closure6339, stackframe);
  addtoclosure(closure6339, var_visitor);
  addtoclosure(closure6339, var_newChain);
  addtoclosure(closure6339, selfslot);
  struct UserObject *uo6339 = (struct UserObject*)block6338;
  uo6339->data[0] = (Object)closure6339;
  Method *meth_meth_ast__apply6339 = addmethod2pos(block6338, "_apply", &meth_ast__apply6339, 0);
  int argcv_meth_ast__apply6339[] = {1};
  meth_meth_ast__apply6339->type = alloc_MethodType(1, argcv_meth_ast__apply6339);
  meth_meth_ast__apply6339->definitionModule = modulename;
  meth_meth_ast__apply6339->definitionLine = 1525;
// compiled block node returning block6338 (depth = 5)
  gc_frame_newslot(block6338);
// call case 5: prelude request
  params[0] = call6337;
  params[1] = block6338;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6343 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6335);
// compiled call node returning call6343 (depth = 4)
    gc_frame_newslot(call6343);
    if6326 = call6343;
  } else {
  }
// compiled if node returning if6326 (depth = 3)
  gc_frame_end(frame);
  return if6326;
}
Object meth_ast_map_40__41_ancestors6344(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6346 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6345);
// compiled call node returning call6346 (depth = 5)
// compiled member node returning call6346 (depth = 4)
  *var_n = call6346;
  if (call6346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6347 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6348 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6347);
// compiled call node returning call6348 (depth = 4)
  *var_newChain = call6348;
  if (call6348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6349 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6350 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6352 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6351);
// compiled call node returning call6352 (depth = 6)
// compiled member node returning call6352 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6353 = callmethod(call6352, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe6350);
// compiled call node returning call6353 (depth = 4)
  gc_frame_newslot(call6353);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6353;
  partcv[0] = 1;
  Object call6354 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6349);
// compiled call node returning call6354 (depth = 3)
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6355 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6356 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6358 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6357);
// compiled call node returning call6358 (depth = 6)
// compiled member node returning call6358 (depth = 5)
  gc_frame_newslot(call6358);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6359 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6360 = gc_frame_new();
// call case 3: self.outer request
  Object call6361 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6360);
// compiled call node returning call6361 (depth = 8)
// compiled member node returning call6361 (depth = 7)
  partcv[0] = 0;
  Object call6362 = callmethodflags(call6361, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6359);
// compiled call node returning call6362 (depth = 6)
// compiled member node returning call6362 (depth = 5)
  params[0] = call6358;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6363 = callmethodflags(call6362, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6356);
// compiled call node returning call6363 (depth = 4)
  gc_frame_newslot(call6363);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6363;
  partcv[0] = 1;
  Object call6364 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe6355);
// compiled call node returning call6364 (depth = 3)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6365 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6366 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6365);
// compiled call node returning call6366 (depth = 3)
  gc_frame_end(frame);
  return call6366;
}
Object meth_ast__apply6391(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6393 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6395 = alloc_Float64(2);
// compiled num node returning num6395 (depth = 9)
  int op_slot_right_6394 = gc_frame_newslot(num6395);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6394 = gc_frame_newslot(*var_depth);
  params[0] = num6395;
  partcv[0] = 1;
  Object sum6397 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6397 (depth = 8)
  gc_frame_newslot(sum6397);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6397;
  partcv[0] = 1;
  Object call6398 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6393);
// compiled call node returning call6398 (depth = 7)
  int op_slot_right_6392 = gc_frame_newslot(call6398);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6392 = gc_frame_newslot(*var_s);
  params[0] = call6398;
  partcv[0] = 1;
  Object opresult6400 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6400 (depth = 6)
  *var_s = opresult6400;
  if (opresult6400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6404(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6406 == NULL) {
    strlit6406 = alloc_String(", ");
    gc_root(strlit6406);
  }
// compiled string node returning strlit6406 (depth = 7)
  int op_slot_right_6405 = gc_frame_newslot(strlit6406);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6405 = gc_frame_newslot(*var_s);
  params[0] = strlit6406;
  partcv[0] = 1;
  Object opresult6408 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6408 (depth = 6)
  *var_s = opresult6408;
  if (opresult6408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6367(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6369 == NULL) {
    strlit6369 = alloc_String(")<");
    gc_root(strlit6369);
  }
// compiled string node returning strlit6369 (depth = 5)
  int op_slot_right_6368 = gc_frame_newslot(strlit6369);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6372 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6374 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6373);
// compiled call node returning call6374 (depth = 8)
// compiled member node returning call6374 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6375 = callmethod(call6374, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6372);
// compiled call node returning call6375 (depth = 6)
  int op_slot_right_6371 = gc_frame_newslot(call6375);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6378 == NULL) {
    strlit6378 = alloc_String("(");
    gc_root(strlit6378);
  }
// compiled string node returning strlit6378 (depth = 7)
  int op_slot_right_6377 = gc_frame_newslot(strlit6378);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6381 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6382 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6381);
// compiled call node returning call6382 (depth = 8)
  int op_slot_right_6380 = gc_frame_newslot(call6382);
// starting to compile string node (depth = 8)
  if (strlit6384 == NULL) {
    strlit6384 = alloc_String("");
    gc_root(strlit6384);
  }
// compiled string node returning strlit6384 (depth = 8)
  int op_slot_left_6380 = gc_frame_newslot(strlit6384);
  params[0] = call6382;
  partcv[0] = 1;
  Object opresult6385 = callmethod(strlit6384, "++", 1, partcv, params);
// compiled op node returning opresult6385 (depth = 7)
  int op_slot_left_6377 = gc_frame_newslot(opresult6385);
  params[0] = strlit6378;
  partcv[0] = 1;
  Object opresult6386 = callmethod(opresult6385, "++", 1, partcv, params);
// compiled op node returning opresult6386 (depth = 6)
  int op_slot_left_6371 = gc_frame_newslot(opresult6386);
  params[0] = call6375;
  partcv[0] = 1;
  Object opresult6387 = callmethod(opresult6386, "++", 1, partcv, params);
// compiled op node returning opresult6387 (depth = 5)
  int op_slot_left_6368 = gc_frame_newslot(opresult6387);
  params[0] = strlit6369;
  partcv[0] = 1;
  Object opresult6388 = callmethod(opresult6387, "++", 1, partcv, params);
// compiled op node returning opresult6388 (depth = 4)
  *var_s = opresult6388;
  if (opresult6388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6389 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6390 = alloc_Block(NULL, NULL, "ast", 1539);
  gc_frame_newslot(block6390);
// method "_apply"
  block_savedest(block6390);
  Object closure6391 = createclosure(3, "_apply");
  setclosureframe(closure6391, stackframe);
  addtoclosure(closure6391, var_depth);
  addtoclosure(closure6391, var_s);
  addtoclosure(closure6391, selfslot);
  struct UserObject *uo6391 = (struct UserObject*)block6390;
  uo6391->data[0] = (Object)closure6391;
  Method *meth_meth_ast__apply6391 = addmethod2pos(block6390, "_apply", &meth_ast__apply6391, 0);
  int argcv_meth_ast__apply6391[] = {1};
  meth_meth_ast__apply6391->type = alloc_MethodType(1, argcv_meth_ast__apply6391);
  meth_meth_ast__apply6391->definitionModule = modulename;
  meth_meth_ast__apply6391->definitionLine = 1538;
// compiled block node returning block6390 (depth = 4)
  gc_frame_newslot(block6390);
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6403 = alloc_Block(NULL, NULL, "ast", 1540);
  gc_frame_newslot(block6403);
// method "_apply"
  block_savedest(block6403);
  Object closure6404 = createclosure(2, "_apply");
  setclosureframe(closure6404, stackframe);
  addtoclosure(closure6404, var_s);
  addtoclosure(closure6404, selfslot);
  struct UserObject *uo6404 = (struct UserObject*)block6403;
  uo6404->data[0] = (Object)closure6404;
  Method *meth_meth_ast__apply6404 = addmethod2pos(block6403, "_apply", &meth_ast__apply6404, 0);
  int argcv_meth_ast__apply6404[] = {0};
  meth_meth_ast__apply6404->type = alloc_MethodType(1, argcv_meth_ast__apply6404);
  meth_meth_ast__apply6404->definitionModule = modulename;
  meth_meth_ast__apply6404->definitionLine = 1538;
// compiled block node returning block6403 (depth = 4)
  gc_frame_newslot(block6403);
// call case 6: other member request
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6412 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6411);
// compiled call node returning call6412 (depth = 5)
// compiled member node returning call6412 (depth = 4)
  params[0] = block6390;
  params[1] = block6403;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6413 = callmethod(call6412, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6389);
// compiled call node returning call6413 (depth = 3)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6415 == NULL) {
    strlit6415 = alloc_String(">");
    gc_root(strlit6415);
  }
// compiled string node returning strlit6415 (depth = 4)
  int op_slot_right_6414 = gc_frame_newslot(strlit6415);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6414 = gc_frame_newslot(*var_s);
  params[0] = strlit6415;
  partcv[0] = 1;
  Object opresult6417 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6417 (depth = 3)
  gc_frame_end(frame);
  return opresult6417;
}
Object meth_ast__apply6427(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6429 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6430 = alloc_Float64(0);
// compiled num node returning num6430 (depth = 8)
  gc_frame_newslot(num6430);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = num6430;
  partcv[0] = 1;
  Object call6431 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6429);
// compiled call node returning call6431 (depth = 7)
  int op_slot_right_6428 = gc_frame_newslot(call6431);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6428 = gc_frame_newslot(*var_s);
  params[0] = call6431;
  partcv[0] = 1;
  Object opresult6433 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6433 (depth = 6)
  *var_s = opresult6433;
  if (opresult6433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6437(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6439 == NULL) {
    strlit6439 = alloc_String(", ");
    gc_root(strlit6439);
  }
// compiled string node returning strlit6439 (depth = 7)
  int op_slot_right_6438 = gc_frame_newslot(strlit6439);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6438 = gc_frame_newslot(*var_s);
  params[0] = strlit6439;
  partcv[0] = 1;
  Object opresult6441 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6441 (depth = 6)
  *var_s = opresult6441;
  if (opresult6441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6420 == NULL) {
    strlit6420 = alloc_String("<");
    gc_root(strlit6420);
  }
// compiled string node returning strlit6420 (depth = 5)
  int op_slot_right_6419 = gc_frame_newslot(strlit6420);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6423 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6422);
// compiled call node returning call6423 (depth = 6)
// compiled member node returning call6423 (depth = 5)
  int op_slot_left_6419 = gc_frame_newslot(call6423);
  params[0] = strlit6420;
  partcv[0] = 1;
  Object opresult6424 = callmethod(call6423, "++", 1, partcv, params);
// compiled op node returning opresult6424 (depth = 4)
  *var_s = opresult6424;
  if (opresult6424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6425 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6426 = alloc_Block(NULL, NULL, "ast", 1545);
  gc_frame_newslot(block6426);
// method "_apply"
  block_savedest(block6426);
  Object closure6427 = createclosure(2, "_apply");
  setclosureframe(closure6427, stackframe);
  addtoclosure(closure6427, var_s);
  addtoclosure(closure6427, selfslot);
  struct UserObject *uo6427 = (struct UserObject*)block6426;
  uo6427->data[0] = (Object)closure6427;
  Method *meth_meth_ast__apply6427 = addmethod2pos(block6426, "_apply", &meth_ast__apply6427, 0);
  int argcv_meth_ast__apply6427[] = {1};
  meth_meth_ast__apply6427->type = alloc_MethodType(1, argcv_meth_ast__apply6427);
  meth_meth_ast__apply6427->definitionModule = modulename;
  meth_meth_ast__apply6427->definitionLine = 1544;
// compiled block node returning block6426 (depth = 4)
  gc_frame_newslot(block6426);
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6436 = alloc_Block(NULL, NULL, "ast", 1546);
  gc_frame_newslot(block6436);
// method "_apply"
  block_savedest(block6436);
  Object closure6437 = createclosure(2, "_apply");
  setclosureframe(closure6437, stackframe);
  addtoclosure(closure6437, var_s);
  addtoclosure(closure6437, selfslot);
  struct UserObject *uo6437 = (struct UserObject*)block6436;
  uo6437->data[0] = (Object)closure6437;
  Method *meth_meth_ast__apply6437 = addmethod2pos(block6436, "_apply", &meth_ast__apply6437, 0);
  int argcv_meth_ast__apply6437[] = {0};
  meth_meth_ast__apply6437->type = alloc_MethodType(1, argcv_meth_ast__apply6437);
  meth_meth_ast__apply6437->definitionModule = modulename;
  meth_meth_ast__apply6437->definitionLine = 1544;
// compiled block node returning block6436 (depth = 4)
  gc_frame_newslot(block6436);
// call case 6: other member request
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6444 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6445 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6444);
// compiled call node returning call6445 (depth = 5)
// compiled member node returning call6445 (depth = 4)
  params[0] = block6426;
  params[1] = block6436;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6446 = callmethod(call6445, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6425);
// compiled call node returning call6446 (depth = 3)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6448 == NULL) {
    strlit6448 = alloc_String(">");
    gc_root(strlit6448);
  }
// compiled string node returning strlit6448 (depth = 4)
  int op_slot_right_6447 = gc_frame_newslot(strlit6448);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6447 = gc_frame_newslot(*var_s);
  params[0] = strlit6448;
  partcv[0] = 1;
  Object opresult6450 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6450 (depth = 3)
  gc_frame_end(frame);
  return opresult6450;
}
Object meth_ast_shallowCopy6451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6452 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6453 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6455 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6454);
// compiled call node returning call6455 (depth = 6)
// compiled member node returning call6455 (depth = 5)
  gc_frame_newslot(call6455);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6456 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6457 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6456);
// compiled call node returning call6457 (depth = 6)
// compiled member node returning call6457 (depth = 5)
  gc_frame_newslot(call6457);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericNode (depth = 5)
  params[0] = call6455;
  params[1] = call6457;
  partcv[0] = 2;
  Object call6458 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6453);
// compiled call node returning call6458 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6459 = callmethod(call6458, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6452);
// compiled call node returning call6459 (depth = 3)
  gc_frame_end(frame);
  return call6459;
}
Object meth_ast_new6310(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6311 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6311 = alloc_userobj2(12,11, objclass6311);
  gc_frame_newslot(obj6311);
if (objclass6311 == NULL) {
  glfree(obj6311->class->name);
  obj6311->class->name = "genericNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6311, self, 0);
  addmethodreal(obj6311,"outer", &reader_ast_outer_6312);
  Object oldself6311 = self;
  struct StackFrameObject *oldstackframe6311 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6311);
  gc_frame_newslot((Object)stackframe);
  self = obj6311;
  Object *oldselfslot6311 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6311 = (*(struct UserObject *)self).data[0], lowerouter6311 = thisouter6311;
  if (inheritingObject6311) {
    struct UserObject *inho6311 = (struct UserObject *)inheritingObject6311;
    while (inho6311->super != GraceDefaultObject) inho6311 = (struct UserObject *)inho6311->super;
    inho6311->super = obj6311;
    self = inheritingObject6311;
    *selfslot = self;
    lowerouter6311 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6311;
  }
if (objclass6311 == NULL) {
  Method *reader6313 = addmethodrealflags(obj6311, "kind",&reader_ast_kind_6313, MFLAG_DEF);
  reader6313->definitionModule = modulename;
  reader6313->definitionLine = 1514;
}
adddatum2(obj6311, alloc_Undefined(), 1);
if (objclass6311 == NULL) {
  Method *reader6314 = addmethodrealflags(obj6311, "value",&reader_ast_value_6314, 0);
  Method *writer6314 = addmethodrealflags(obj6311, "value:=",&writer_ast_value_6314, 0);
  reader6314->definitionModule = modulename;
  writer6314->definitionModule = modulename;
  reader6314->definitionLine = 1515;
  writer6314->definitionLine = 1515;
}
obj6311->flags |= OFLAG_MUTABLE;
adddatum2(obj6311, alloc_Undefined(), 2);
if (objclass6311 == NULL) {
  Method *reader6315 = addmethodrealflags(obj6311, "args",&reader_ast_args_6315, 0);
  Method *writer6315 = addmethodrealflags(obj6311, "args:=",&writer_ast_args_6315, 0);
  reader6315->definitionModule = modulename;
  writer6315->definitionModule = modulename;
  reader6315->definitionLine = 1518;
  writer6315->definitionLine = 1518;
}
obj6311->flags |= OFLAG_MUTABLE;
adddatum2(obj6311, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6316 = (struct UserObject*)obj6311;
  uo6316->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6316 = addmethod2pos(obj6311, "nameString", &meth_ast_nameString6316, 4);
  int argcv_meth_ast_nameString6316[] = {0};
  meth_meth_ast_nameString6316->type = alloc_MethodType(1, argcv_meth_ast_nameString6316);
  meth_meth_ast_nameString6316->definitionModule = modulename;
  meth_meth_ast_nameString6316->definitionLine = 1519;
// method "asString"
  struct UserObject *uo6321 = (struct UserObject*)obj6311;
  uo6321->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6321 = addmethod2pos(obj6311, "asString", &meth_ast_asString6321, 5);
  int argcv_meth_ast_asString6321[] = {0};
  meth_meth_ast_asString6321->type = alloc_MethodType(1, argcv_meth_ast_asString6321);
  meth_meth_ast_asString6321->definitionModule = modulename;
  meth_meth_ast_asString6321->definitionLine = 1520;
// method "accept()from"
  struct UserObject *uo6325 = (struct UserObject*)obj6311;
  uo6325->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6325 = addmethod2pos(obj6311, "accept()from", &meth_ast_accept_40__41_from6325, 6);
  int argcv_meth_ast_accept_40__41_from6325[] = {1, 1};
  meth_meth_ast_accept_40__41_from6325->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6325);
  meth_meth_ast_accept_40__41_from6325->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6325->definitionLine = 1521;
// method "map()ancestors"
  struct UserObject *uo6344 = (struct UserObject*)obj6311;
  uo6344->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6344 = addmethod2pos(obj6311, "map()ancestors", &meth_ast_map_40__41_ancestors6344, 7);
  int argcv_meth_ast_map_40__41_ancestors6344[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6344->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6344);
  meth_meth_ast_map_40__41_ancestors6344->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6344->definitionLine = 1530;
// method "pretty"
  struct UserObject *uo6367 = (struct UserObject*)obj6311;
  uo6367->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6367 = addmethod2pos(obj6311, "pretty", &meth_ast_pretty6367, 8);
  int argcv_meth_ast_pretty6367[] = {1};
  meth_meth_ast_pretty6367->type = alloc_MethodType(1, argcv_meth_ast_pretty6367);
  meth_meth_ast_pretty6367->definitionModule = modulename;
  meth_meth_ast_pretty6367->definitionLine = 1537;
// method "toGrace"
  struct UserObject *uo6418 = (struct UserObject*)obj6311;
  uo6418->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6418 = addmethod2pos(obj6311, "toGrace", &meth_ast_toGrace6418, 9);
  int argcv_meth_ast_toGrace6418[] = {1};
  meth_meth_ast_toGrace6418->type = alloc_MethodType(1, argcv_meth_ast_toGrace6418);
meth_meth_ast_toGrace6418->type->types[0] = type_Number;
meth_meth_ast_toGrace6418->type->names[0] = "depth";
  meth_meth_ast_toGrace6418->definitionModule = modulename;
  meth_meth_ast_toGrace6418->definitionLine = 1543;
// method "shallowCopy"
  block_savedest(obj6311);
  Object closure6451 = createclosure(1, "shallowCopy");
  setclosureframe(closure6451, stackframe);
  addtoclosure(closure6451, var_genericNode);
  struct UserObject *uo6451 = (struct UserObject*)obj6311;
  uo6451->data[10] = (Object)closure6451;
  Method *meth_meth_ast_shallowCopy6451 = addmethod2pos(obj6311, "shallowCopy", &meth_ast_shallowCopy6451, 10);
  int argcv_meth_ast_shallowCopy6451[] = {0};
  meth_meth_ast_shallowCopy6451->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6451);
  meth_meth_ast_shallowCopy6451->definitionModule = modulename;
  meth_meth_ast_shallowCopy6451->definitionLine = 1549;
  sourceObject = obj6311;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6460 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6461 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6462 = gc_frame_new();
// call case 3: self.outer request
  Object call6463 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6462);
// compiled call node returning call6463 (depth = 7)
// compiled member node returning call6463 (depth = 6)
  partcv[0] = 0;
  Object call6464 = callmethodflags(call6463, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6461);
// compiled call node returning call6464 (depth = 5)
// compiled member node returning call6464 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6465 = callmethodflags(call6464, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6460);
// compiled call node returning call6465 (depth = 3)
  struct UserObject *obj6311_uo = (struct UserObject *)obj6311;
  obj6311_uo->super = call6465;
  sourceObject = obj6311;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6466 == NULL) {
    strlit6466 = alloc_String("generic");
    gc_root(strlit6466);
  }
// compiled string node returning strlit6466 (depth = 3)
  adddatum2(obj6311, strlit6466, 1);
  sourceObject = obj6311;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6311, *var_base, 2);
  sourceObject = obj6311;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6311, *var_arguments, 3);
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  objclass6311 = obj6311->class;
  objclass6311->definitionModule = modulename;
  objclass6311->definitionLine = 1511;
  (*(struct UserObject *)self).data[0] = lowerouter6311;
  self = oldself6311;
  selfslot = oldselfslot6311;
  stackframe = oldstackframe6311;
  gc_frame_end(frame);
  return obj6311;
}
Object meth_ast_new6310_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_arguments = &(stackframe->slots[1]);
  *var_arguments = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6311 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6311 = alloc_userobj2(12,11, objclass6311);
  gc_frame_newslot(obj6311);
if (objclass6311 == NULL) {
  glfree(obj6311->class->name);
  obj6311->class->name = "genericNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6311, self, 0);
  addmethodreal(obj6311,"outer", &reader_ast_outer_6312);
  Object oldself6311 = self;
  struct StackFrameObject *oldstackframe6311 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6311);
  gc_frame_newslot((Object)stackframe);
  self = obj6311;
  Object *oldselfslot6311 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6311 = (*(struct UserObject *)self).data[0], lowerouter6311 = thisouter6311;
  if (inheritingObject6311) {
    struct UserObject *inho6311 = (struct UserObject *)inheritingObject6311;
    while (inho6311->super != GraceDefaultObject) inho6311 = (struct UserObject *)inho6311->super;
    inho6311->super = obj6311;
    self = inheritingObject6311;
    *selfslot = self;
    lowerouter6311 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6311;
  }
if (objclass6311 == NULL) {
  Method *reader6313 = addmethodrealflags(obj6311, "kind",&reader_ast_kind_6313, MFLAG_DEF);
  reader6313->definitionModule = modulename;
  reader6313->definitionLine = 1514;
}
adddatum2(obj6311, alloc_Undefined(), 1);
if (objclass6311 == NULL) {
  Method *reader6314 = addmethodrealflags(obj6311, "value",&reader_ast_value_6314, 0);
  Method *writer6314 = addmethodrealflags(obj6311, "value:=",&writer_ast_value_6314, 0);
  reader6314->definitionModule = modulename;
  writer6314->definitionModule = modulename;
  reader6314->definitionLine = 1515;
  writer6314->definitionLine = 1515;
}
obj6311->flags |= OFLAG_MUTABLE;
adddatum2(obj6311, alloc_Undefined(), 2);
if (objclass6311 == NULL) {
  Method *reader6315 = addmethodrealflags(obj6311, "args",&reader_ast_args_6315, 0);
  Method *writer6315 = addmethodrealflags(obj6311, "args:=",&writer_ast_args_6315, 0);
  reader6315->definitionModule = modulename;
  writer6315->definitionModule = modulename;
  reader6315->definitionLine = 1518;
  writer6315->definitionLine = 1518;
}
obj6311->flags |= OFLAG_MUTABLE;
adddatum2(obj6311, alloc_Undefined(), 3);
// method "nameString"
  struct UserObject *uo6316 = (struct UserObject*)obj6311;
  uo6316->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6316 = addmethod2pos(obj6311, "nameString", &meth_ast_nameString6316, 4);
  int argcv_meth_ast_nameString6316[] = {0};
  meth_meth_ast_nameString6316->type = alloc_MethodType(1, argcv_meth_ast_nameString6316);
  meth_meth_ast_nameString6316->definitionModule = modulename;
  meth_meth_ast_nameString6316->definitionLine = 1519;
// method "asString"
  struct UserObject *uo6321 = (struct UserObject*)obj6311;
  uo6321->data[5] = emptyclosure;
  Method *meth_meth_ast_asString6321 = addmethod2pos(obj6311, "asString", &meth_ast_asString6321, 5);
  int argcv_meth_ast_asString6321[] = {0};
  meth_meth_ast_asString6321->type = alloc_MethodType(1, argcv_meth_ast_asString6321);
  meth_meth_ast_asString6321->definitionModule = modulename;
  meth_meth_ast_asString6321->definitionLine = 1520;
// method "accept()from"
  struct UserObject *uo6325 = (struct UserObject*)obj6311;
  uo6325->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6325 = addmethod2pos(obj6311, "accept()from", &meth_ast_accept_40__41_from6325, 6);
  int argcv_meth_ast_accept_40__41_from6325[] = {1, 1};
  meth_meth_ast_accept_40__41_from6325->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6325);
  meth_meth_ast_accept_40__41_from6325->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6325->definitionLine = 1521;
// method "map()ancestors"
  struct UserObject *uo6344 = (struct UserObject*)obj6311;
  uo6344->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6344 = addmethod2pos(obj6311, "map()ancestors", &meth_ast_map_40__41_ancestors6344, 7);
  int argcv_meth_ast_map_40__41_ancestors6344[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6344->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6344);
  meth_meth_ast_map_40__41_ancestors6344->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6344->definitionLine = 1530;
// method "pretty"
  struct UserObject *uo6367 = (struct UserObject*)obj6311;
  uo6367->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6367 = addmethod2pos(obj6311, "pretty", &meth_ast_pretty6367, 8);
  int argcv_meth_ast_pretty6367[] = {1};
  meth_meth_ast_pretty6367->type = alloc_MethodType(1, argcv_meth_ast_pretty6367);
  meth_meth_ast_pretty6367->definitionModule = modulename;
  meth_meth_ast_pretty6367->definitionLine = 1537;
// method "toGrace"
  struct UserObject *uo6418 = (struct UserObject*)obj6311;
  uo6418->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6418 = addmethod2pos(obj6311, "toGrace", &meth_ast_toGrace6418, 9);
  int argcv_meth_ast_toGrace6418[] = {1};
  meth_meth_ast_toGrace6418->type = alloc_MethodType(1, argcv_meth_ast_toGrace6418);
meth_meth_ast_toGrace6418->type->types[0] = type_Number;
meth_meth_ast_toGrace6418->type->names[0] = "depth";
  meth_meth_ast_toGrace6418->definitionModule = modulename;
  meth_meth_ast_toGrace6418->definitionLine = 1543;
// method "shallowCopy"
  block_savedest(obj6311);
  Object closure6451 = createclosure(1, "shallowCopy");
  setclosureframe(closure6451, stackframe);
  addtoclosure(closure6451, var_genericNode);
  struct UserObject *uo6451 = (struct UserObject*)obj6311;
  uo6451->data[10] = (Object)closure6451;
  Method *meth_meth_ast_shallowCopy6451 = addmethod2pos(obj6311, "shallowCopy", &meth_ast_shallowCopy6451, 10);
  int argcv_meth_ast_shallowCopy6451[] = {0};
  meth_meth_ast_shallowCopy6451->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6451);
  meth_meth_ast_shallowCopy6451->definitionModule = modulename;
  meth_meth_ast_shallowCopy6451->definitionLine = 1549;
  sourceObject = obj6311;
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6460 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6461 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6462 = gc_frame_new();
// call case 3: self.outer request
  Object call6463 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6462);
// compiled call node returning call6463 (depth = 7)
// compiled member node returning call6463 (depth = 6)
  partcv[0] = 0;
  Object call6464 = callmethodflags(call6463, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6461);
// compiled call node returning call6464 (depth = 5)
// compiled member node returning call6464 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6465 = callmethodflags(call6464, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6460);
// compiled call node returning call6465 (depth = 3)
  struct UserObject *obj6311_uo = (struct UserObject *)obj6311;
  obj6311_uo->super = call6465;
  sourceObject = obj6311;
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6466 == NULL) {
    strlit6466 = alloc_String("generic");
    gc_root(strlit6466);
  }
// compiled string node returning strlit6466 (depth = 3)
  adddatum2(obj6311, strlit6466, 1);
  sourceObject = obj6311;
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_base (depth = 3)
  adddatum2(obj6311, *var_base, 2);
  sourceObject = obj6311;
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arguments (depth = 3)
  adddatum2(obj6311, *var_arguments, 3);
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  sourceObject = obj6311;
  objclass6311 = obj6311->class;
  objclass6311->definitionModule = modulename;
  objclass6311->definitionLine = 1511;
  (*(struct UserObject *)self).data[0] = lowerouter6311;
  self = oldself6311;
  selfslot = oldselfslot6311;
  stackframe = oldstackframe6311;
  gc_frame_end(frame);
  return obj6311;
}
Object meth_ast_genericNode6468(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_asString6476(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6477 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num6478 = alloc_Float64(0);
// compiled num node returning num6478 (depth = 4)
  gc_frame_newslot(num6478);
// call case 4: self request
  params[0] = num6478;
  partcv[0] = 1;
  Object call6479 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6477);
// compiled call node returning call6479 (depth = 3)
  gc_frame_end(frame);
  return call6479;
}
Object meth_ast_declarationKindWithAncestors6480(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call6482 = callmethod(*var_k, "typeparam",
    1, partcv, params);
  gc_frame_end(callframe6481);
// compiled call node returning call6482 (depth = 4)
// compiled member node returning call6482 (depth = 3)
  gc_frame_end(frame);
  return call6482;
}
Object meth_ast__apply6491(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6492 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6493 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6492);
// compiled call node returning call6493 (depth = 6)
  gc_frame_end(frame);
  return call6493;
}
Object meth_ast_accept_40__41_from6483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6485 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6486 = callmethod(*var_visitor, "visitTypeParameters()up",
    2, partcv, params);
  gc_frame_end(callframe6485);
// compiled call node returning call6486 (depth = 4)
  Object if6484 = done;
  if (istrue(call6486)) {
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6487 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6488 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6487);
// compiled call node returning call6488 (depth = 5)
  *var_newChain = call6488;
  if (call6488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6489 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6490 = alloc_Block(NULL, NULL, "ast", 1566);
  gc_frame_newslot(block6490);
// method "_apply"
  block_savedest(block6490);
  Object closure6491 = createclosure(3, "_apply");
  setclosureframe(closure6491, stackframe);
  addtoclosure(closure6491, var_visitor);
  addtoclosure(closure6491, var_newChain);
  addtoclosure(closure6491, selfslot);
  struct UserObject *uo6491 = (struct UserObject*)block6490;
  uo6491->data[0] = (Object)closure6491;
  Method *meth_meth_ast__apply6491 = addmethod2pos(block6490, "_apply", &meth_ast__apply6491, 0);
  int argcv_meth_ast__apply6491[] = {1};
  meth_meth_ast__apply6491->type = alloc_MethodType(1, argcv_meth_ast__apply6491);
  meth_meth_ast__apply6491->definitionModule = modulename;
  meth_meth_ast__apply6491->definitionLine = 1561;
// compiled block node returning block6490 (depth = 5)
  gc_frame_newslot(block6490);
// call case 6: other member request
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6496 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6495);
// compiled call node returning call6496 (depth = 6)
// compiled member node returning call6496 (depth = 5)
  params[0] = block6490;
  partcv[0] = 1;
  Object call6497 = callmethod(call6496, "do",
    1, partcv, params);
  gc_frame_end(callframe6489);
// compiled call node returning call6497 (depth = 4)
    gc_frame_newslot(call6497);
    if6484 = call6497;
  } else {
  }
// compiled if node returning if6484 (depth = 3)
  gc_frame_end(frame);
  return if6484;
}
Object meth_ast_do6498(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6499 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6501 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6500);
// compiled call node returning call6501 (depth = 5)
// compiled member node returning call6501 (depth = 4)
  params[0] = *var_blk;
  partcv[0] = 1;
  Object call6502 = callmethod(call6501, "do",
    1, partcv, params);
  gc_frame_end(callframe6499);
// compiled call node returning call6502 (depth = 3)
  gc_frame_end(frame);
  return call6502;
}
Object meth_ast_size6503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6504 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6505 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6506 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6505);
// compiled call node returning call6506 (depth = 6)
// compiled member node returning call6506 (depth = 5)
  partcv[0] = 0;
  Object call6507 = callmethod(call6506, "size",
    1, partcv, params);
  gc_frame_end(callframe6504);
// compiled call node returning call6507 (depth = 4)
// compiled member node returning call6507 (depth = 3)
  gc_frame_end(frame);
  return call6507;
}
Object meth_ast_map_40__41_ancestors6508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6510 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6509);
// compiled call node returning call6510 (depth = 5)
// compiled member node returning call6510 (depth = 4)
  *var_n = call6510;
  if (call6510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6511 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6512 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6511);
// compiled call node returning call6512 (depth = 4)
  *var_newChain = call6512;
  if (call6512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6513 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6514 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6516 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6515);
// compiled call node returning call6516 (depth = 6)
// compiled member node returning call6516 (depth = 5)
  gc_frame_newslot(call6516);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6517 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6518 = gc_frame_new();
// call case 3: self.outer request
  Object call6519 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6518);
// compiled call node returning call6519 (depth = 8)
// compiled member node returning call6519 (depth = 7)
  partcv[0] = 0;
  Object call6520 = callmethodflags(call6519, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6517);
// compiled call node returning call6520 (depth = 6)
// compiled member node returning call6520 (depth = 5)
  params[0] = call6516;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6521 = callmethodflags(call6520, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6514);
// compiled call node returning call6521 (depth = 4)
  gc_frame_newslot(call6521);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6521;
  partcv[0] = 1;
  Object call6522 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe6513);
// compiled call node returning call6522 (depth = 3)
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6523 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6524 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6523);
// compiled call node returning call6524 (depth = 3)
  gc_frame_end(frame);
  return call6524;
}
Object meth_ast__apply6533(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6535 == NULL) {
    strlit6535 = alloc_String("  ");
    gc_root(strlit6535);
  }
// compiled string node returning strlit6535 (depth = 7)
  int op_slot_right_6534 = gc_frame_newslot(strlit6535);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6534 = gc_frame_newslot(*var_spc);
  params[0] = strlit6535;
  partcv[0] = 1;
  Object opresult6537 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6537 (depth = 6)
  *var_spc = opresult6537;
  if (opresult6537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6552(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6554 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6556 = alloc_Float64(2);
// compiled num node returning num6556 (depth = 9)
  int op_slot_right_6555 = gc_frame_newslot(num6556);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6555 = gc_frame_newslot(*var_depth);
  params[0] = num6556;
  partcv[0] = 1;
  Object sum6558 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6558 (depth = 8)
  gc_frame_newslot(sum6558);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = sum6558;
  partcv[0] = 1;
  Object call6559 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6554);
// compiled call node returning call6559 (depth = 7)
  int op_slot_right_6553 = gc_frame_newslot(call6559);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6553 = gc_frame_newslot(*var_s);
  params[0] = call6559;
  partcv[0] = 1;
  Object opresult6561 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6561 (depth = 6)
  *var_s = opresult6561;
  if (opresult6561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6565(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6567 == NULL) {
    strlit6567 = alloc_String(", ");
    gc_root(strlit6567);
  }
// compiled string node returning strlit6567 (depth = 7)
  int op_slot_right_6566 = gc_frame_newslot(strlit6567);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6566 = gc_frame_newslot(*var_s);
  params[0] = strlit6567;
  partcv[0] = 1;
  Object opresult6569 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6569 (depth = 6)
  *var_s = opresult6569;
  if (opresult6569 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6525(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6526 == NULL) {
    strlit6526 = alloc_String("");
    gc_root(strlit6526);
  }
// compiled string node returning strlit6526 (depth = 4)
  *var_spc = strlit6526;
  if (strlit6526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6527 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6528 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6530 = alloc_Float64(0);
// compiled num node returning num6530 (depth = 5)
  int op_slot_left_6528 = gc_frame_newslot(num6530);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6531 = callmethod(num6530, "..", 1, partcv, params);
// compiled op node returning opresult6531 (depth = 4)
  gc_frame_newslot(opresult6531);
// starting to compile block node (depth = 4)
  Object block6532 = alloc_Block(NULL, NULL, "ast", 1583);
  gc_frame_newslot(block6532);
// method "_apply"
  block_savedest(block6532);
  Object closure6533 = createclosure(2, "_apply");
  setclosureframe(closure6533, stackframe);
  addtoclosure(closure6533, var_spc);
  addtoclosure(closure6533, selfslot);
  struct UserObject *uo6533 = (struct UserObject*)block6532;
  uo6533->data[0] = (Object)closure6533;
  Method *meth_meth_ast__apply6533 = addmethod2pos(block6532, "_apply", &meth_ast__apply6533, 0);
  int argcv_meth_ast__apply6533[] = {1};
  meth_meth_ast__apply6533->type = alloc_MethodType(1, argcv_meth_ast__apply6533);
  meth_meth_ast__apply6533->definitionModule = modulename;
  meth_meth_ast__apply6533->definitionLine = 1578;
// compiled block node returning block6532 (depth = 4)
  gc_frame_newslot(block6532);
// call case 5: prelude request
  params[0] = opresult6531;
  params[1] = block6532;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6540 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6527);
// compiled call node returning call6540 (depth = 3)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6542 == NULL) {
    strlit6542 = alloc_String("<");
    gc_root(strlit6542);
  }
// compiled string node returning strlit6542 (depth = 5)
  int op_slot_right_6541 = gc_frame_newslot(strlit6542);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6545 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6546 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6545);
// compiled call node returning call6546 (depth = 6)
  int op_slot_right_6544 = gc_frame_newslot(call6546);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_6544 = gc_frame_newslot(*var_spc);
  params[0] = call6546;
  partcv[0] = 1;
  Object opresult6548 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6548 (depth = 5)
  int op_slot_left_6541 = gc_frame_newslot(opresult6548);
  params[0] = strlit6542;
  partcv[0] = 1;
  Object opresult6549 = callmethod(opresult6548, "++", 1, partcv, params);
// compiled op node returning opresult6549 (depth = 4)
  *var_s = opresult6549;
  if (opresult6549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6550 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6551 = alloc_Block(NULL, NULL, "ast", 1587);
  gc_frame_newslot(block6551);
// method "_apply"
  block_savedest(block6551);
  Object closure6552 = createclosure(3, "_apply");
  setclosureframe(closure6552, stackframe);
  addtoclosure(closure6552, var_depth);
  addtoclosure(closure6552, var_s);
  addtoclosure(closure6552, selfslot);
  struct UserObject *uo6552 = (struct UserObject*)block6551;
  uo6552->data[0] = (Object)closure6552;
  Method *meth_meth_ast__apply6552 = addmethod2pos(block6551, "_apply", &meth_ast__apply6552, 0);
  int argcv_meth_ast__apply6552[] = {1};
  meth_meth_ast__apply6552->type = alloc_MethodType(1, argcv_meth_ast__apply6552);
  meth_meth_ast__apply6552->definitionModule = modulename;
  meth_meth_ast__apply6552->definitionLine = 1578;
// compiled block node returning block6551 (depth = 4)
  gc_frame_newslot(block6551);
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6564 = alloc_Block(NULL, NULL, "ast", 1588);
  gc_frame_newslot(block6564);
// method "_apply"
  block_savedest(block6564);
  Object closure6565 = createclosure(2, "_apply");
  setclosureframe(closure6565, stackframe);
  addtoclosure(closure6565, var_s);
  addtoclosure(closure6565, selfslot);
  struct UserObject *uo6565 = (struct UserObject*)block6564;
  uo6565->data[0] = (Object)closure6565;
  Method *meth_meth_ast__apply6565 = addmethod2pos(block6564, "_apply", &meth_ast__apply6565, 0);
  int argcv_meth_ast__apply6565[] = {0};
  meth_meth_ast__apply6565->type = alloc_MethodType(1, argcv_meth_ast__apply6565);
  meth_meth_ast__apply6565->definitionModule = modulename;
  meth_meth_ast__apply6565->definitionLine = 1578;
// compiled block node returning block6564 (depth = 4)
  gc_frame_newslot(block6564);
// call case 6: other member request
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6572 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6573 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6572);
// compiled call node returning call6573 (depth = 5)
// compiled member node returning call6573 (depth = 4)
  params[0] = block6551;
  params[1] = block6564;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6574 = callmethod(call6573, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6550);
// compiled call node returning call6574 (depth = 3)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6576 == NULL) {
    strlit6576 = alloc_String(">");
    gc_root(strlit6576);
  }
// compiled string node returning strlit6576 (depth = 4)
  int op_slot_right_6575 = gc_frame_newslot(strlit6576);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6575 = gc_frame_newslot(*var_s);
  params[0] = strlit6576;
  partcv[0] = 1;
  Object opresult6578 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6578 (depth = 3)
  gc_frame_end(frame);
  return opresult6578;
}
Object meth_ast__apply6583(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6585 == NULL) {
    strlit6585 = alloc_String("");
    gc_root(strlit6585);
  }
// compiled string node returning strlit6585 (depth = 7)
  int op_slot_right_6584 = gc_frame_newslot(strlit6585);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6588 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6589 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6588);
// compiled call node returning call6589 (depth = 8)
  int op_slot_right_6587 = gc_frame_newslot(call6589);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6592 == NULL) {
    strlit6592 = alloc_String("");
    gc_root(strlit6592);
  }
// compiled string node returning strlit6592 (depth = 9)
  int op_slot_right_6591 = gc_frame_newslot(strlit6592);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_6594 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit6596 == NULL) {
    strlit6596 = alloc_String("");
    gc_root(strlit6596);
  }
// compiled string node returning strlit6596 (depth = 10)
  int op_slot_left_6594 = gc_frame_newslot(strlit6596);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6597 = callmethod(strlit6596, "++", 1, partcv, params);
// compiled op node returning opresult6597 (depth = 9)
  int op_slot_left_6591 = gc_frame_newslot(opresult6597);
  params[0] = strlit6592;
  partcv[0] = 1;
  Object opresult6598 = callmethod(opresult6597, "++", 1, partcv, params);
// compiled op node returning opresult6598 (depth = 8)
  int op_slot_left_6587 = gc_frame_newslot(opresult6598);
  params[0] = call6589;
  partcv[0] = 1;
  Object opresult6599 = callmethod(opresult6598, "++", 1, partcv, params);
// compiled op node returning opresult6599 (depth = 7)
  int op_slot_left_6584 = gc_frame_newslot(opresult6599);
  params[0] = strlit6585;
  partcv[0] = 1;
  Object opresult6600 = callmethod(opresult6599, "++", 1, partcv, params);
// compiled op node returning opresult6600 (depth = 6)
  *var_s = opresult6600;
  if (opresult6600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6604(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6606 == NULL) {
    strlit6606 = alloc_String(", ");
    gc_root(strlit6606);
  }
// compiled string node returning strlit6606 (depth = 7)
  int op_slot_right_6605 = gc_frame_newslot(strlit6606);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6605 = gc_frame_newslot(*var_s);
  params[0] = strlit6606;
  partcv[0] = 1;
  Object opresult6608 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6608 (depth = 6)
  *var_s = opresult6608;
  if (opresult6608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6580 == NULL) {
    strlit6580 = alloc_String("<");
    gc_root(strlit6580);
  }
// compiled string node returning strlit6580 (depth = 4)
  *var_s = strlit6580;
  if (strlit6580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6581 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block6582 = alloc_Block(NULL, NULL, "ast", 1593);
  gc_frame_newslot(block6582);
// method "_apply"
  block_savedest(block6582);
  Object closure6583 = createclosure(3, "_apply");
  setclosureframe(closure6583, stackframe);
  addtoclosure(closure6583, var_depth);
  addtoclosure(closure6583, var_s);
  addtoclosure(closure6583, selfslot);
  struct UserObject *uo6583 = (struct UserObject*)block6582;
  uo6583->data[0] = (Object)closure6583;
  Method *meth_meth_ast__apply6583 = addmethod2pos(block6582, "_apply", &meth_ast__apply6583, 0);
  int argcv_meth_ast__apply6583[] = {1};
  meth_meth_ast__apply6583->type = alloc_MethodType(1, argcv_meth_ast__apply6583);
  meth_meth_ast__apply6583->definitionModule = modulename;
  meth_meth_ast__apply6583->definitionLine = 1587;
// compiled block node returning block6582 (depth = 4)
  gc_frame_newslot(block6582);
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6603 = alloc_Block(NULL, NULL, "ast", 1594);
  gc_frame_newslot(block6603);
// method "_apply"
  block_savedest(block6603);
  Object closure6604 = createclosure(2, "_apply");
  setclosureframe(closure6604, stackframe);
  addtoclosure(closure6604, var_s);
  addtoclosure(closure6604, selfslot);
  struct UserObject *uo6604 = (struct UserObject*)block6603;
  uo6604->data[0] = (Object)closure6604;
  Method *meth_meth_ast__apply6604 = addmethod2pos(block6603, "_apply", &meth_ast__apply6604, 0);
  int argcv_meth_ast__apply6604[] = {0};
  meth_meth_ast__apply6604->type = alloc_MethodType(1, argcv_meth_ast__apply6604);
  meth_meth_ast__apply6604->definitionModule = modulename;
  meth_meth_ast__apply6604->definitionLine = 1587;
// compiled block node returning block6603 (depth = 4)
  gc_frame_newslot(block6603);
// call case 6: other member request
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6612 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6611);
// compiled call node returning call6612 (depth = 5)
// compiled member node returning call6612 (depth = 4)
  params[0] = block6582;
  params[1] = block6603;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6613 = callmethod(call6612, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6581);
// compiled call node returning call6613 (depth = 3)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6615 == NULL) {
    strlit6615 = alloc_String(">");
    gc_root(strlit6615);
  }
// compiled string node returning strlit6615 (depth = 4)
  int op_slot_right_6614 = gc_frame_newslot(strlit6615);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_6614 = gc_frame_newslot(*var_s);
  params[0] = strlit6615;
  partcv[0] = 1;
  Object opresult6617 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6617 (depth = 3)
  gc_frame_end(frame);
  return opresult6617;
}
Object meth_ast_shallowCopy6618(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeParametersNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6619 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6620 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_emptySeq (depth = 5)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeParametersNode (depth = 5)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6621 = callmethod(*var_typeParametersNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6620);
// compiled call node returning call6621 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6622 = callmethod(call6621, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6619);
// compiled call node returning call6622 (depth = 3)
  gc_frame_end(frame);
  return call6622;
}
Object meth_ast_new6471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6472 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6472 = alloc_userobj2(12,12, objclass6472);
  gc_frame_newslot(obj6472);
if (objclass6472 == NULL) {
  glfree(obj6472->class->name);
  obj6472->class->name = "typeParametersNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6472, self, 0);
  addmethodreal(obj6472,"outer", &reader_ast_outer_6473);
  Object oldself6472 = self;
  struct StackFrameObject *oldstackframe6472 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6472);
  gc_frame_newslot((Object)stackframe);
  self = obj6472;
  Object *oldselfslot6472 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6472 = (*(struct UserObject *)self).data[0], lowerouter6472 = thisouter6472;
  if (inheritingObject6472) {
    struct UserObject *inho6472 = (struct UserObject *)inheritingObject6472;
    while (inho6472->super != GraceDefaultObject) inho6472 = (struct UserObject *)inho6472->super;
    inho6472->super = obj6472;
    self = inheritingObject6472;
    *selfslot = self;
    lowerouter6472 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6472;
  }
if (objclass6472 == NULL) {
  Method *reader6474 = addmethodrealflags(obj6472, "kind",&reader_ast_kind_6474, MFLAG_DEF);
  reader6474->definitionModule = modulename;
  reader6474->definitionLine = 1558;
}
adddatum2(obj6472, alloc_Undefined(), 1);
if (objclass6472 == NULL) {
  Method *reader6475 = addmethodrealflags(obj6472, "params",&reader_ast_params_6475, 0);
  Method *writer6475 = addmethodrealflags(obj6472, "params:=",&writer_ast_params_6475, 0);
  reader6475->definitionModule = modulename;
  writer6475->definitionModule = modulename;
  reader6475->definitionLine = 1559;
  writer6475->definitionLine = 1559;
}
obj6472->flags |= OFLAG_MUTABLE;
adddatum2(obj6472, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6476 = (struct UserObject*)obj6472;
  uo6476->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6476 = addmethod2pos(obj6472, "asString", &meth_ast_asString6476, 3);
  int argcv_meth_ast_asString6476[] = {0};
  meth_meth_ast_asString6476->type = alloc_MethodType(1, argcv_meth_ast_asString6476);
  meth_meth_ast_asString6476->definitionModule = modulename;
  meth_meth_ast_asString6476->definitionLine = 1560;
// method "declarationKindWithAncestors"
  block_savedest(obj6472);
  Object closure6480 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure6480, stackframe);
  addtoclosure(closure6480, var_k);
  struct UserObject *uo6480 = (struct UserObject*)obj6472;
  uo6480->data[4] = (Object)closure6480;
  Method *meth_meth_ast_declarationKindWithAncestors6480 = addmethod2pos(obj6472, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6480, 4);
  int argcv_meth_ast_declarationKindWithAncestors6480[] = {1};
  meth_meth_ast_declarationKindWithAncestors6480->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6480);
  meth_meth_ast_declarationKindWithAncestors6480->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6480->definitionLine = 1561;
// method "accept()from"
  struct UserObject *uo6483 = (struct UserObject*)obj6472;
  uo6483->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6483 = addmethod2pos(obj6472, "accept()from", &meth_ast_accept_40__41_from6483, 5);
  int argcv_meth_ast_accept_40__41_from6483[] = {1, 1};
  meth_meth_ast_accept_40__41_from6483->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6483);
  meth_meth_ast_accept_40__41_from6483->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6483->definitionLine = 1563;
// method "do"
  struct UserObject *uo6498 = (struct UserObject*)obj6472;
  uo6498->data[6] = emptyclosure;
  Method *meth_meth_ast_do6498 = addmethod2pos(obj6472, "do", &meth_ast_do6498, 6);
  int argcv_meth_ast_do6498[] = {1};
  meth_meth_ast_do6498->type = alloc_MethodType(1, argcv_meth_ast_do6498);
  meth_meth_ast_do6498->definitionModule = modulename;
  meth_meth_ast_do6498->definitionLine = 1571;
// method "size"
  struct UserObject *uo6503 = (struct UserObject*)obj6472;
  uo6503->data[7] = emptyclosure;
  Method *meth_meth_ast_size6503 = addmethod2pos(obj6472, "size", &meth_ast_size6503, 7);
  int argcv_meth_ast_size6503[] = {0};
  meth_meth_ast_size6503->type = alloc_MethodType(1, argcv_meth_ast_size6503);
  meth_meth_ast_size6503->definitionModule = modulename;
  meth_meth_ast_size6503->definitionLine = 1574;
// method "map()ancestors"
  struct UserObject *uo6508 = (struct UserObject*)obj6472;
  uo6508->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6508 = addmethod2pos(obj6472, "map()ancestors", &meth_ast_map_40__41_ancestors6508, 8);
  int argcv_meth_ast_map_40__41_ancestors6508[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6508->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6508);
  meth_meth_ast_map_40__41_ancestors6508->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6508->definitionLine = 1575;
// method "pretty"
  struct UserObject *uo6525 = (struct UserObject*)obj6472;
  uo6525->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty6525 = addmethod2pos(obj6472, "pretty", &meth_ast_pretty6525, 9);
  int argcv_meth_ast_pretty6525[] = {1};
  meth_meth_ast_pretty6525->type = alloc_MethodType(1, argcv_meth_ast_pretty6525);
  meth_meth_ast_pretty6525->definitionModule = modulename;
  meth_meth_ast_pretty6525->definitionLine = 1581;
// method "toGrace"
  struct UserObject *uo6579 = (struct UserObject*)obj6472;
  uo6579->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace6579 = addmethod2pos(obj6472, "toGrace", &meth_ast_toGrace6579, 10);
  int argcv_meth_ast_toGrace6579[] = {1};
  meth_meth_ast_toGrace6579->type = alloc_MethodType(1, argcv_meth_ast_toGrace6579);
meth_meth_ast_toGrace6579->type->types[0] = type_Number;
meth_meth_ast_toGrace6579->type->names[0] = "depth";
  meth_meth_ast_toGrace6579->definitionModule = modulename;
  meth_meth_ast_toGrace6579->definitionLine = 1591;
// method "shallowCopy"
  block_savedest(obj6472);
  Object closure6618 = createclosure(2, "shallowCopy");
  setclosureframe(closure6618, stackframe);
  addtoclosure(closure6618, var_emptySeq);
  addtoclosure(closure6618, var_typeParametersNode);
  struct UserObject *uo6618 = (struct UserObject*)obj6472;
  uo6618->data[11] = (Object)closure6618;
  Method *meth_meth_ast_shallowCopy6618 = addmethod2pos(obj6472, "shallowCopy", &meth_ast_shallowCopy6618, 11);
  int argcv_meth_ast_shallowCopy6618[] = {0};
  meth_meth_ast_shallowCopy6618->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6618);
  meth_meth_ast_shallowCopy6618->definitionModule = modulename;
  meth_meth_ast_shallowCopy6618->definitionLine = 1597;
  sourceObject = obj6472;
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6623 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6624 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6625 = gc_frame_new();
// call case 3: self.outer request
  Object call6626 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6625);
// compiled call node returning call6626 (depth = 7)
// compiled member node returning call6626 (depth = 6)
  partcv[0] = 0;
  Object call6627 = callmethodflags(call6626, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6624);
// compiled call node returning call6627 (depth = 5)
// compiled member node returning call6627 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6628 = callmethodflags(call6627, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6623);
// compiled call node returning call6628 (depth = 3)
  struct UserObject *obj6472_uo = (struct UserObject *)obj6472;
  obj6472_uo->super = call6628;
  sourceObject = obj6472;
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6629 == NULL) {
    strlit6629 = alloc_String("typeparams");
    gc_root(strlit6629);
  }
// compiled string node returning strlit6629 (depth = 3)
  adddatum2(obj6472, strlit6629, 1);
  sourceObject = obj6472;
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6472, *var_params_39_, 2);
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  objclass6472 = obj6472->class;
  objclass6472->definitionModule = modulename;
  objclass6472->definitionLine = 1556;
  (*(struct UserObject *)self).data[0] = lowerouter6472;
  self = oldself6472;
  selfslot = oldselfslot6472;
  stackframe = oldstackframe6472;
  gc_frame_end(frame);
  return obj6472;
}
Object meth_ast_new6471_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_typeParametersNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6472 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6472 = alloc_userobj2(12,12, objclass6472);
  gc_frame_newslot(obj6472);
if (objclass6472 == NULL) {
  glfree(obj6472->class->name);
  obj6472->class->name = "typeParametersNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6472, self, 0);
  addmethodreal(obj6472,"outer", &reader_ast_outer_6473);
  Object oldself6472 = self;
  struct StackFrameObject *oldstackframe6472 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6472);
  gc_frame_newslot((Object)stackframe);
  self = obj6472;
  Object *oldselfslot6472 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6472 = (*(struct UserObject *)self).data[0], lowerouter6472 = thisouter6472;
  if (inheritingObject6472) {
    struct UserObject *inho6472 = (struct UserObject *)inheritingObject6472;
    while (inho6472->super != GraceDefaultObject) inho6472 = (struct UserObject *)inho6472->super;
    inho6472->super = obj6472;
    self = inheritingObject6472;
    *selfslot = self;
    lowerouter6472 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6472;
  }
if (objclass6472 == NULL) {
  Method *reader6474 = addmethodrealflags(obj6472, "kind",&reader_ast_kind_6474, MFLAG_DEF);
  reader6474->definitionModule = modulename;
  reader6474->definitionLine = 1558;
}
adddatum2(obj6472, alloc_Undefined(), 1);
if (objclass6472 == NULL) {
  Method *reader6475 = addmethodrealflags(obj6472, "params",&reader_ast_params_6475, 0);
  Method *writer6475 = addmethodrealflags(obj6472, "params:=",&writer_ast_params_6475, 0);
  reader6475->definitionModule = modulename;
  writer6475->definitionModule = modulename;
  reader6475->definitionLine = 1559;
  writer6475->definitionLine = 1559;
}
obj6472->flags |= OFLAG_MUTABLE;
adddatum2(obj6472, alloc_Undefined(), 2);
// method "asString"
  struct UserObject *uo6476 = (struct UserObject*)obj6472;
  uo6476->data[3] = emptyclosure;
  Method *meth_meth_ast_asString6476 = addmethod2pos(obj6472, "asString", &meth_ast_asString6476, 3);
  int argcv_meth_ast_asString6476[] = {0};
  meth_meth_ast_asString6476->type = alloc_MethodType(1, argcv_meth_ast_asString6476);
  meth_meth_ast_asString6476->definitionModule = modulename;
  meth_meth_ast_asString6476->definitionLine = 1560;
// method "declarationKindWithAncestors"
  block_savedest(obj6472);
  Object closure6480 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure6480, stackframe);
  addtoclosure(closure6480, var_k);
  struct UserObject *uo6480 = (struct UserObject*)obj6472;
  uo6480->data[4] = (Object)closure6480;
  Method *meth_meth_ast_declarationKindWithAncestors6480 = addmethod2pos(obj6472, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6480, 4);
  int argcv_meth_ast_declarationKindWithAncestors6480[] = {1};
  meth_meth_ast_declarationKindWithAncestors6480->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6480);
  meth_meth_ast_declarationKindWithAncestors6480->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6480->definitionLine = 1561;
// method "accept()from"
  struct UserObject *uo6483 = (struct UserObject*)obj6472;
  uo6483->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6483 = addmethod2pos(obj6472, "accept()from", &meth_ast_accept_40__41_from6483, 5);
  int argcv_meth_ast_accept_40__41_from6483[] = {1, 1};
  meth_meth_ast_accept_40__41_from6483->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6483);
  meth_meth_ast_accept_40__41_from6483->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6483->definitionLine = 1563;
// method "do"
  struct UserObject *uo6498 = (struct UserObject*)obj6472;
  uo6498->data[6] = emptyclosure;
  Method *meth_meth_ast_do6498 = addmethod2pos(obj6472, "do", &meth_ast_do6498, 6);
  int argcv_meth_ast_do6498[] = {1};
  meth_meth_ast_do6498->type = alloc_MethodType(1, argcv_meth_ast_do6498);
  meth_meth_ast_do6498->definitionModule = modulename;
  meth_meth_ast_do6498->definitionLine = 1571;
// method "size"
  struct UserObject *uo6503 = (struct UserObject*)obj6472;
  uo6503->data[7] = emptyclosure;
  Method *meth_meth_ast_size6503 = addmethod2pos(obj6472, "size", &meth_ast_size6503, 7);
  int argcv_meth_ast_size6503[] = {0};
  meth_meth_ast_size6503->type = alloc_MethodType(1, argcv_meth_ast_size6503);
  meth_meth_ast_size6503->definitionModule = modulename;
  meth_meth_ast_size6503->definitionLine = 1574;
// method "map()ancestors"
  struct UserObject *uo6508 = (struct UserObject*)obj6472;
  uo6508->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6508 = addmethod2pos(obj6472, "map()ancestors", &meth_ast_map_40__41_ancestors6508, 8);
  int argcv_meth_ast_map_40__41_ancestors6508[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6508->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6508);
  meth_meth_ast_map_40__41_ancestors6508->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6508->definitionLine = 1575;
// method "pretty"
  struct UserObject *uo6525 = (struct UserObject*)obj6472;
  uo6525->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty6525 = addmethod2pos(obj6472, "pretty", &meth_ast_pretty6525, 9);
  int argcv_meth_ast_pretty6525[] = {1};
  meth_meth_ast_pretty6525->type = alloc_MethodType(1, argcv_meth_ast_pretty6525);
  meth_meth_ast_pretty6525->definitionModule = modulename;
  meth_meth_ast_pretty6525->definitionLine = 1581;
// method "toGrace"
  struct UserObject *uo6579 = (struct UserObject*)obj6472;
  uo6579->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace6579 = addmethod2pos(obj6472, "toGrace", &meth_ast_toGrace6579, 10);
  int argcv_meth_ast_toGrace6579[] = {1};
  meth_meth_ast_toGrace6579->type = alloc_MethodType(1, argcv_meth_ast_toGrace6579);
meth_meth_ast_toGrace6579->type->types[0] = type_Number;
meth_meth_ast_toGrace6579->type->names[0] = "depth";
  meth_meth_ast_toGrace6579->definitionModule = modulename;
  meth_meth_ast_toGrace6579->definitionLine = 1591;
// method "shallowCopy"
  block_savedest(obj6472);
  Object closure6618 = createclosure(2, "shallowCopy");
  setclosureframe(closure6618, stackframe);
  addtoclosure(closure6618, var_emptySeq);
  addtoclosure(closure6618, var_typeParametersNode);
  struct UserObject *uo6618 = (struct UserObject*)obj6472;
  uo6618->data[11] = (Object)closure6618;
  Method *meth_meth_ast_shallowCopy6618 = addmethod2pos(obj6472, "shallowCopy", &meth_ast_shallowCopy6618, 11);
  int argcv_meth_ast_shallowCopy6618[] = {0};
  meth_meth_ast_shallowCopy6618->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6618);
  meth_meth_ast_shallowCopy6618->definitionModule = modulename;
  meth_meth_ast_shallowCopy6618->definitionLine = 1597;
  sourceObject = obj6472;
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6623 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6624 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6625 = gc_frame_new();
// call case 3: self.outer request
  Object call6626 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6625);
// compiled call node returning call6626 (depth = 7)
// compiled member node returning call6626 (depth = 6)
  partcv[0] = 0;
  Object call6627 = callmethodflags(call6626, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6624);
// compiled call node returning call6627 (depth = 5)
// compiled member node returning call6627 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6628 = callmethodflags(call6627, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6623);
// compiled call node returning call6628 (depth = 3)
  struct UserObject *obj6472_uo = (struct UserObject *)obj6472;
  obj6472_uo->super = call6628;
  sourceObject = obj6472;
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6629 == NULL) {
    strlit6629 = alloc_String("typeparams");
    gc_root(strlit6629);
  }
// compiled string node returning strlit6629 (depth = 3)
  adddatum2(obj6472, strlit6629, 1);
  sourceObject = obj6472;
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_params_39_ (depth = 3)
  adddatum2(obj6472, *var_params_39_, 2);
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  sourceObject = obj6472;
  objclass6472 = obj6472->class;
  objclass6472->definitionModule = modulename;
  objclass6472->definitionLine = 1556;
  (*(struct UserObject *)self).data[0] = lowerouter6472;
  self = oldself6472;
  selfslot = oldselfslot6472;
  stackframe = oldstackframe6472;
  gc_frame_end(frame);
  return obj6472;
}
Object meth_ast_typeParametersNode6631(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeParametersNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeParametersNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeParametersNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeParametersNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeParametersNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeParametersNode;
}
Object meth_ast_new_40__41_scope6634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype = &(stackframe->slots[1]);
  *var_dtype = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6635 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_dtype;
  partcv[0] = 2;
  Object call6636 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6635);
// compiled call node returning call6636 (depth = 4)
  *var_result = call6636;
  if (call6636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6637 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call6638 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe6637);
// compiled call node returning call6638 (depth = 3)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_nameString6651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6653 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6652);
// compiled call node returning call6653 (depth = 4)
// compiled member node returning call6653 (depth = 3)
  gc_frame_end(frame);
  return call6653;
}
Object meth_ast_quoted6654(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "quoted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for quoted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for quoted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6655 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6657 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compiled call node returning call6657 (depth = 6)
// compiled member node returning call6657 (depth = 5)
  partcv[0] = 0;
  Object call6658 = callmethod(call6657, "quoted",
    1, partcv, params);
  gc_frame_end(callframe6655);
// compiled call node returning call6658 (depth = 4)
// compiled member node returning call6658 (depth = 3)
  gc_frame_end(frame);
  return call6658;
}
Object meth_ast_isIdentifier6659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6660 = alloc_Boolean(1);
// compiled identifier node returning bool6660 (depth = 3)
  gc_frame_end(frame);
  return bool6660;
}
Object meth_ast_isAppliedOccurenceOfIdentifier6661(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6664 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6663);
// compiled call node returning call6664 (depth = 5)
// compiled member node returning call6664 (depth = 4)
  Object if6662 = done;
  if (istrue(call6664)) {
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6665 = alloc_Boolean(0);
// compiled identifier node returning bool6665 (depth = 4)
    gc_frame_newslot(bool6665);
    if6662 = bool6665;
  } else {
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6666 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6667 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6668 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6667);
// compiled call node returning call6668 (depth = 7)
// compiled member node returning call6668 (depth = 6)
  partcv[0] = 0;
  Object call6669 = callmethod(call6668, "not",
    1, partcv, params);
  gc_frame_end(callframe6666);
// compiled call node returning call6669 (depth = 5)
// compiled member node returning call6669 (depth = 4)
    gc_frame_newslot(call6669);
    if6662 = call6669;
  }
// compiled if node returning if6662 (depth = 3)
  gc_frame_end(frame);
  return if6662;
}
Object meth_ast_declarationKindWithAncestors6670(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6671 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6673 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe6672);
// compiled call node returning call6673 (depth = 5)
// compiled member node returning call6673 (depth = 4)
  params[0] = *var_as;
  partcv[0] = 1;
  Object call6674 = callmethod(call6673, "declarationKindWithAncestors",
    1, partcv, params);
  gc_frame_end(callframe6671);
// compiled call node returning call6674 (depth = 3)
  gc_frame_end(frame);
  return call6674;
}
Object meth_ast_inTypePositionWithAncestors6675(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePositionWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inTypePositionWithAncestors");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inTypePositionWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for inTypePositionWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6678 = callmethod(*var_as, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe6677);
// compiled call node returning call6678 (depth = 5)
// compiled member node returning call6678 (depth = 4)
  Object if6676 = done;
  if (istrue(call6678)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6679 = alloc_Boolean(0);
// compiled identifier node returning bool6679 (depth = 5)
  return bool6679;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if6676 = undefined;
  } else {
  }
// compiled if node returning if6676 (depth = 3)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6680 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  partcv[0] = 0;
  Object call6682 = callmethod(*var_as, "parent",
    1, partcv, params);
  gc_frame_end(callframe6681);
// compiled call node returning call6682 (depth = 5)
// compiled member node returning call6682 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6683 = callmethod(call6682, "usesAsType",
    1, partcv, params);
  gc_frame_end(callframe6680);
// compiled call node returning call6683 (depth = 3)
  gc_frame_end(frame);
  return call6683;
}
Object meth_ast_usesAsType6684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6687 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6686);
// compiled call node returning call6687 (depth = 5)
// compiled member node returning call6687 (depth = 4)
  int op_slot_right_6685 = gc_frame_newslot(call6687);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_6685 = gc_frame_newslot(*var_aNode);
  params[0] = call6687;
  partcv[0] = 1;
  Object opresult6689 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult6689 (depth = 3)
  gc_frame_end(frame);
  return opresult6689;
}
Object meth_ast_accept_40__41_from6690(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6692 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6693 = callmethod(*var_visitor, "visitIdentifier()up",
    2, partcv, params);
  gc_frame_end(callframe6692);
// compiled call node returning call6693 (depth = 4)
  Object if6691 = done;
  if (istrue(call6693)) {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6694 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call6695 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6694);
// compiled call node returning call6695 (depth = 5)
  *var_newChain = call6695;
  if (call6695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6699 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6698);
// compiled call node returning call6699 (depth = 7)
// compiled member node returning call6699 (depth = 6)
  int op_slot_right_6697 = gc_frame_newslot(call6699);
// starting to compile identifier node (depth = 6)
  Object bool6701 = alloc_Boolean(0);
// compiled identifier node returning bool6701 (depth = 6)
  int op_slot_left_6697 = gc_frame_newslot(bool6701);
  params[0] = call6699;
  partcv[0] = 1;
  Object opresult6702 = callmethod(bool6701, "≠", 1, partcv, params);
// compiled op node returning opresult6702 (depth = 5)
  Object if6696 = done;
  if (istrue(opresult6702)) {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6703 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6705 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6704);
// compiled call node returning call6705 (depth = 7)
// compiled member node returning call6705 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6706 = callmethod(call6705, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6703);
// compiled call node returning call6706 (depth = 5)
    gc_frame_newslot(call6706);
    if6696 = call6706;
  } else {
  }
// compiled if node returning if6696 (depth = 4)
    gc_frame_newslot(if6696);
    if6691 = if6696;
  } else {
  }
// compiled if node returning if6691 (depth = 3)
  gc_frame_end(frame);
  return if6691;
}
Object meth_ast_map_40__41_ancestors6707(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6709 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6708);
// compiled call node returning call6709 (depth = 5)
// compiled member node returning call6709 (depth = 4)
  *var_n = call6709;
  if (call6709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6710 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6711 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe6710);
// compiled call node returning call6711 (depth = 4)
  *var_newChain = call6711;
  if (call6711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6712 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe6713 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6715 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6714);
// compiled call node returning call6715 (depth = 6)
// compiled member node returning call6715 (depth = 5)
  gc_frame_newslot(call6715);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6716 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6717 = gc_frame_new();
// call case 3: self.outer request
  Object call6718 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6717);
// compiled call node returning call6718 (depth = 8)
// compiled member node returning call6718 (depth = 7)
  partcv[0] = 0;
  Object call6719 = callmethodflags(call6718, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6716);
// compiled call node returning call6719 (depth = 6)
// compiled member node returning call6719 (depth = 5)
  params[0] = call6715;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6720 = callmethodflags(call6719, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6713);
// compiled call node returning call6720 (depth = 4)
  gc_frame_newslot(call6720);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call6720;
  partcv[0] = 1;
  Object call6721 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6712);
// compiled call node returning call6721 (depth = 3)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6722 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call6723 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6722);
// compiled call node returning call6723 (depth = 3)
  gc_frame_end(frame);
  return call6723;
}
Object meth_ast__apply6732(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6734 == NULL) {
    strlit6734 = alloc_String("  ");
    gc_root(strlit6734);
  }
// compiled string node returning strlit6734 (depth = 7)
  int op_slot_right_6733 = gc_frame_newslot(strlit6734);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_6733 = gc_frame_newslot(*var_spc);
  params[0] = strlit6734;
  partcv[0] = 1;
  Object opresult6736 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6736 (depth = 6)
  *var_spc = opresult6736;
  if (opresult6736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6835(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6837 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6839 = alloc_Float64(2);
// compiled num node returning num6839 (depth = 10)
  int op_slot_right_6838 = gc_frame_newslot(num6839);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6838 = gc_frame_newslot(*var_depth);
  params[0] = num6839;
  partcv[0] = 1;
  Object sum6841 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6841 (depth = 9)
  gc_frame_newslot(sum6841);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_g (depth = 9)
  params[0] = sum6841;
  partcv[0] = 1;
  Object call6842 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6837);
// compiled call node returning call6842 (depth = 8)
  int op_slot_right_6836 = gc_frame_newslot(call6842);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6845 == NULL) {
    strlit6845 = alloc_String("  ");
    gc_root(strlit6845);
  }
// compiled string node returning strlit6845 (depth = 9)
  int op_slot_right_6844 = gc_frame_newslot(strlit6845);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_6847 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit6850 == NULL) {
    strlit6850 = alloc_String("""\x0a""");
    gc_root(strlit6850);
  }
// compiled string node returning strlit6850 (depth = 11)
  int op_slot_right_6849 = gc_frame_newslot(strlit6850);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6849 = gc_frame_newslot(*var_s);
  params[0] = strlit6850;
  partcv[0] = 1;
  Object opresult6852 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6852 (depth = 10)
  int op_slot_left_6847 = gc_frame_newslot(opresult6852);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6853 = callmethod(opresult6852, "++", 1, partcv, params);
// compiled op node returning opresult6853 (depth = 9)
  int op_slot_left_6844 = gc_frame_newslot(opresult6853);
  params[0] = strlit6845;
  partcv[0] = 1;
  Object opresult6854 = callmethod(opresult6853, "++", 1, partcv, params);
// compiled op node returning opresult6854 (depth = 8)
  int op_slot_left_6836 = gc_frame_newslot(opresult6854);
  params[0] = call6842;
  partcv[0] = 1;
  Object opresult6855 = callmethod(opresult6854, "++", 1, partcv, params);
// compiled op node returning opresult6855 (depth = 7)
  *var_s = opresult6855;
  if (opresult6855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6725 == NULL) {
    strlit6725 = alloc_String("");
    gc_root(strlit6725);
  }
// compiled string node returning strlit6725 (depth = 4)
  *var_spc = strlit6725;
  if (strlit6725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6726 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_6727 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num6729 = alloc_Float64(0);
// compiled num node returning num6729 (depth = 5)
  int op_slot_left_6727 = gc_frame_newslot(num6729);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6730 = callmethod(num6729, "..", 1, partcv, params);
// compiled op node returning opresult6730 (depth = 4)
  gc_frame_newslot(opresult6730);
// starting to compile block node (depth = 4)
  Object block6731 = alloc_Block(NULL, NULL, "ast", 1662);
  gc_frame_newslot(block6731);
// method "_apply"
  block_savedest(block6731);
  Object closure6732 = createclosure(2, "_apply");
  setclosureframe(closure6732, stackframe);
  addtoclosure(closure6732, var_spc);
  addtoclosure(closure6732, selfslot);
  struct UserObject *uo6732 = (struct UserObject*)block6731;
  uo6732->data[0] = (Object)closure6732;
  Method *meth_meth_ast__apply6732 = addmethod2pos(block6731, "_apply", &meth_ast__apply6732, 0);
  int argcv_meth_ast__apply6732[] = {1};
  meth_meth_ast__apply6732->type = alloc_MethodType(1, argcv_meth_ast__apply6732);
  meth_meth_ast__apply6732->definitionModule = modulename;
  meth_meth_ast__apply6732->definitionLine = 1657;
// compiled block node returning block6731 (depth = 4)
  gc_frame_newslot(block6731);
// call case 5: prelude request
  params[0] = opresult6730;
  params[1] = block6731;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6739 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6726);
// compiled call node returning call6739 (depth = 3)
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6740 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6741 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6740);
// compiled call node returning call6741 (depth = 4)
  *var_s = call6741;
  if (call6741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6744 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6743);
// compiled call node returning call6744 (depth = 5)
// compiled member node returning call6744 (depth = 4)
  Object if6742 = done;
  if (istrue(call6744)) {
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6746 == NULL) {
    strlit6746 = alloc_String(" Wildcard");
    gc_root(strlit6746);
  }
// compiled string node returning strlit6746 (depth = 6)
  int op_slot_right_6745 = gc_frame_newslot(strlit6746);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6745 = gc_frame_newslot(*var_s);
  params[0] = strlit6746;
  partcv[0] = 1;
  Object opresult6748 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6748 (depth = 5)
  *var_s = opresult6748;
  if (opresult6748 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6742 = done;
  } else {
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6752 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6751);
// compiled call node returning call6752 (depth = 6)
// compiled member node returning call6752 (depth = 5)
  Object if6750 = done;
  if (istrue(call6752)) {
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6755 == NULL) {
    strlit6755 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6755);
  }
// compiled string node returning strlit6755 (depth = 8)
  int op_slot_right_6754 = gc_frame_newslot(strlit6755);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6758 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6759 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6758);
// compiled call node returning call6759 (depth = 10)
// compiled member node returning call6759 (depth = 9)
  int op_slot_right_6757 = gc_frame_newslot(call6759);
// starting to compile string node (depth = 9)
  if (strlit6761 == NULL) {
    strlit6761 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit6761);
  }
// compiled string node returning strlit6761 (depth = 9)
  int op_slot_left_6757 = gc_frame_newslot(strlit6761);
  params[0] = call6759;
  partcv[0] = 1;
  Object opresult6762 = callmethod(strlit6761, "++", 1, partcv, params);
// compiled op node returning opresult6762 (depth = 8)
  int op_slot_left_6754 = gc_frame_newslot(opresult6762);
  params[0] = strlit6755;
  partcv[0] = 1;
  Object opresult6763 = callmethod(opresult6762, "++", 1, partcv, params);
// compiled op node returning opresult6763 (depth = 7)
  int op_slot_right_6753 = gc_frame_newslot(opresult6763);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6753 = gc_frame_newslot(*var_s);
  params[0] = opresult6763;
  partcv[0] = 1;
  Object opresult6765 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6765 (depth = 6)
  *var_s = opresult6765;
  if (opresult6765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6750 = done;
  } else {
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6769 == NULL) {
    strlit6769 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6769);
  }
// compiled string node returning strlit6769 (depth = 8)
  int op_slot_right_6768 = gc_frame_newslot(strlit6769);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6773 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6772);
// compiled call node returning call6773 (depth = 10)
// compiled member node returning call6773 (depth = 9)
  int op_slot_right_6771 = gc_frame_newslot(call6773);
// starting to compile string node (depth = 9)
  if (strlit6775 == NULL) {
    strlit6775 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6775);
  }
// compiled string node returning strlit6775 (depth = 9)
  int op_slot_left_6771 = gc_frame_newslot(strlit6775);
  params[0] = call6773;
  partcv[0] = 1;
  Object opresult6776 = callmethod(strlit6775, "++", 1, partcv, params);
// compiled op node returning opresult6776 (depth = 8)
  int op_slot_left_6768 = gc_frame_newslot(opresult6776);
  params[0] = strlit6769;
  partcv[0] = 1;
  Object opresult6777 = callmethod(opresult6776, "++", 1, partcv, params);
// compiled op node returning opresult6777 (depth = 7)
  int op_slot_right_6767 = gc_frame_newslot(opresult6777);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6767 = gc_frame_newslot(*var_s);
  params[0] = opresult6777;
  partcv[0] = 1;
  Object opresult6779 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6779 (depth = 6)
  *var_s = opresult6779;
  if (opresult6779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6750 = done;
  }
// compiled if node returning if6750 (depth = 4)
    gc_frame_newslot(if6750);
    if6742 = if6750;
  }
// compiled if node returning if6742 (depth = 3)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6783 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6784 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6783);
// compiled call node returning call6784 (depth = 6)
// compiled member node returning call6784 (depth = 5)
  int op_slot_right_6782 = gc_frame_newslot(call6784);
// starting to compile identifier node (depth = 5)
  Object bool6786 = alloc_Boolean(0);
// compiled identifier node returning bool6786 (depth = 5)
  int op_slot_left_6782 = gc_frame_newslot(bool6786);
  params[0] = call6784;
  partcv[0] = 1;
  Object opresult6787 = callmethod(bool6786, "≠", 1, partcv, params);
// compiled op node returning opresult6787 (depth = 4)
  Object if6781 = done;
  if (istrue(opresult6787)) {
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6789 == NULL) {
    strlit6789 = alloc_String("  Type: ");
    gc_root(strlit6789);
  }
// compiled string node returning strlit6789 (depth = 6)
  int op_slot_right_6788 = gc_frame_newslot(strlit6789);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6791 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6794 == NULL) {
    strlit6794 = alloc_String("""\x0a""");
    gc_root(strlit6794);
  }
// compiled string node returning strlit6794 (depth = 8)
  int op_slot_right_6793 = gc_frame_newslot(strlit6794);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6793 = gc_frame_newslot(*var_s);
  params[0] = strlit6794;
  partcv[0] = 1;
  Object opresult6796 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6796 (depth = 7)
  int op_slot_left_6791 = gc_frame_newslot(opresult6796);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6797 = callmethod(opresult6796, "++", 1, partcv, params);
// compiled op node returning opresult6797 (depth = 6)
  int op_slot_left_6788 = gc_frame_newslot(opresult6797);
  params[0] = strlit6789;
  partcv[0] = 1;
  Object opresult6798 = callmethod(opresult6797, "++", 1, partcv, params);
// compiled op node returning opresult6798 (depth = 5)
  *var_s = opresult6798;
  if (opresult6798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6801 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6803 = alloc_Float64(2);
// compiled num node returning num6803 (depth = 8)
  int op_slot_right_6802 = gc_frame_newslot(num6803);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6802 = gc_frame_newslot(*var_depth);
  params[0] = num6803;
  partcv[0] = 1;
  Object sum6805 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6805 (depth = 7)
  gc_frame_newslot(sum6805);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6807 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6806);
// compiled call node returning call6807 (depth = 8)
// compiled member node returning call6807 (depth = 7)
  params[0] = sum6805;
  partcv[0] = 1;
  Object call6808 = callmethod(call6807, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6801);
// compiled call node returning call6808 (depth = 6)
  int op_slot_right_6800 = gc_frame_newslot(call6808);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6800 = gc_frame_newslot(*var_s);
  params[0] = call6808;
  partcv[0] = 1;
  Object opresult6810 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6810 (depth = 5)
  *var_s = opresult6810;
  if (opresult6810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6781 = done;
  } else {
  }
// compiled if node returning if6781 (depth = 3)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6815 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6814);
// compiled call node returning call6815 (depth = 6)
// compiled member node returning call6815 (depth = 5)
  int op_slot_right_6813 = gc_frame_newslot(call6815);
// starting to compile identifier node (depth = 5)
  Object bool6817 = alloc_Boolean(0);
// compiled identifier node returning bool6817 (depth = 5)
  int op_slot_left_6813 = gc_frame_newslot(bool6817);
  params[0] = call6815;
  partcv[0] = 1;
  Object opresult6818 = callmethod(bool6817, "≠", 1, partcv, params);
// compiled op node returning opresult6818 (depth = 4)
  Object if6812 = done;
  if (istrue(opresult6818)) {
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6820 == NULL) {
    strlit6820 = alloc_String("Generics:");
    gc_root(strlit6820);
  }
// compiled string node returning strlit6820 (depth = 6)
  int op_slot_right_6819 = gc_frame_newslot(strlit6820);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6822 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6825 == NULL) {
    strlit6825 = alloc_String("""\x0a""");
    gc_root(strlit6825);
  }
// compiled string node returning strlit6825 (depth = 8)
  int op_slot_right_6824 = gc_frame_newslot(strlit6825);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6824 = gc_frame_newslot(*var_s);
  params[0] = strlit6825;
  partcv[0] = 1;
  Object opresult6827 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6827 (depth = 7)
  int op_slot_left_6822 = gc_frame_newslot(opresult6827);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6828 = callmethod(opresult6827, "++", 1, partcv, params);
// compiled op node returning opresult6828 (depth = 6)
  int op_slot_left_6819 = gc_frame_newslot(opresult6828);
  params[0] = strlit6820;
  partcv[0] = 1;
  Object opresult6829 = callmethod(opresult6828, "++", 1, partcv, params);
// compiled op node returning opresult6829 (depth = 5)
  *var_s = opresult6829;
  if (opresult6829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6831 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6832 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6833 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6832);
// compiled call node returning call6833 (depth = 6)
// compiled member node returning call6833 (depth = 5)
  gc_frame_newslot(call6833);
// starting to compile block node (depth = 5)
  Object block6834 = alloc_Block(NULL, NULL, "ast", 1679);
  gc_frame_newslot(block6834);
// method "_apply"
  block_savedest(block6834);
  Object closure6835 = createclosure(4, "_apply");
  setclosureframe(closure6835, stackframe);
  addtoclosure(closure6835, var_depth);
  addtoclosure(closure6835, var_spc);
  addtoclosure(closure6835, var_s);
  addtoclosure(closure6835, selfslot);
  struct UserObject *uo6835 = (struct UserObject*)block6834;
  uo6835->data[0] = (Object)closure6835;
  Method *meth_meth_ast__apply6835 = addmethod2pos(block6834, "_apply", &meth_ast__apply6835, 0);
  int argcv_meth_ast__apply6835[] = {1};
  meth_meth_ast__apply6835->type = alloc_MethodType(1, argcv_meth_ast__apply6835);
  meth_meth_ast__apply6835->definitionModule = modulename;
  meth_meth_ast__apply6835->definitionLine = 1679;
// compiled block node returning block6834 (depth = 5)
  gc_frame_newslot(block6834);
// call case 5: prelude request
  params[0] = call6833;
  params[1] = block6834;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6858 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6831);
// compiled call node returning call6858 (depth = 4)
    gc_frame_newslot(call6858);
    if6812 = call6858;
  } else {
  }
// compiled if node returning if6812 (depth = 3)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6917(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6919 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6921 = alloc_Float64(1);
// compiled num node returning num6921 (depth = 10)
  int op_slot_right_6920 = gc_frame_newslot(num6921);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6920 = gc_frame_newslot(*var_depth);
  params[0] = num6921;
  partcv[0] = 1;
  Object sum6923 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6923 (depth = 9)
  gc_frame_newslot(sum6923);
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6924 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6925 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6926 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6925);
// compiled call node returning call6926 (depth = 11)
// compiled member node returning call6926 (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6927 = callmethod(call6926, "at",
    1, partcv, params);
  gc_frame_end(callframe6924);
// compiled call node returning call6927 (depth = 9)
  params[0] = sum6923;
  partcv[0] = 1;
  Object call6928 = callmethod(call6927, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6919);
// compiled call node returning call6928 (depth = 8)
  int op_slot_right_6918 = gc_frame_newslot(call6928);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6918 = gc_frame_newslot(*var_s);
  params[0] = call6928;
  partcv[0] = 1;
  Object opresult6930 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6930 (depth = 7)
  *var_s = opresult6930;
  if (opresult6930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6859(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_s = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6862 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6861);
// compiled call node returning call6862 (depth = 5)
// compiled member node returning call6862 (depth = 4)
  Object if6860 = done;
  if (istrue(call6862)) {
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6863 == NULL) {
    strlit6863 = alloc_String("_");
    gc_root(strlit6863);
  }
// compiled string node returning strlit6863 (depth = 5)
  *var_s = strlit6863;
  if (strlit6863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6860 = done;
  } else {
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6866 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6865);
// compiled call node returning call6866 (depth = 6)
// compiled member node returning call6866 (depth = 5)
  *var_s = call6866;
  if (call6866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6860 = done;
  }
// compiled if node returning if6860 (depth = 3)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6870 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6871 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6870);
// compiled call node returning call6871 (depth = 6)
// compiled member node returning call6871 (depth = 5)
  int op_slot_right_6869 = gc_frame_newslot(call6871);
// starting to compile identifier node (depth = 5)
  Object bool6873 = alloc_Boolean(0);
// compiled identifier node returning bool6873 (depth = 5)
  int op_slot_left_6869 = gc_frame_newslot(bool6873);
  params[0] = call6871;
  partcv[0] = 1;
  Object opresult6874 = callmethod(bool6873, "≠", 1, partcv, params);
// compiled op node returning opresult6874 (depth = 4)
  Object if6868 = done;
  if (istrue(opresult6874)) {
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6876 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6878 = alloc_Float64(1);
// compiled num node returning num6878 (depth = 8)
  int op_slot_right_6877 = gc_frame_newslot(num6878);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_6877 = gc_frame_newslot(*var_depth);
  params[0] = num6878;
  partcv[0] = 1;
  Object sum6880 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6880 (depth = 7)
  gc_frame_newslot(sum6880);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6882 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6881);
// compiled call node returning call6882 (depth = 8)
// compiled member node returning call6882 (depth = 7)
  params[0] = sum6880;
  partcv[0] = 1;
  Object call6883 = callmethod(call6882, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6876);
// compiled call node returning call6883 (depth = 6)
  int op_slot_right_6875 = gc_frame_newslot(call6883);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6886 == NULL) {
    strlit6886 = alloc_String(" : ");
    gc_root(strlit6886);
  }
// compiled string node returning strlit6886 (depth = 7)
  int op_slot_right_6885 = gc_frame_newslot(strlit6886);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6885 = gc_frame_newslot(*var_s);
  params[0] = strlit6886;
  partcv[0] = 1;
  Object opresult6888 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6888 (depth = 6)
  int op_slot_left_6875 = gc_frame_newslot(opresult6888);
  params[0] = call6883;
  partcv[0] = 1;
  Object opresult6889 = callmethod(opresult6888, "++", 1, partcv, params);
// compiled op node returning opresult6889 (depth = 5)
  *var_s = opresult6889;
  if (opresult6889 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6868 = done;
  } else {
  }
// compiled if node returning if6868 (depth = 3)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6893 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6894 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6893);
// compiled call node returning call6894 (depth = 6)
// compiled member node returning call6894 (depth = 5)
  int op_slot_right_6892 = gc_frame_newslot(call6894);
// starting to compile identifier node (depth = 5)
  Object bool6896 = alloc_Boolean(0);
// compiled identifier node returning bool6896 (depth = 5)
  int op_slot_left_6892 = gc_frame_newslot(bool6896);
  params[0] = call6894;
  partcv[0] = 1;
  Object opresult6897 = callmethod(bool6896, "≠", 1, partcv, params);
// compiled op node returning opresult6897 (depth = 4)
  Object if6891 = done;
  if (istrue(opresult6897)) {
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6899 == NULL) {
    strlit6899 = alloc_String("<");
    gc_root(strlit6899);
  }
// compiled string node returning strlit6899 (depth = 6)
  int op_slot_right_6898 = gc_frame_newslot(strlit6899);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6898 = gc_frame_newslot(*var_s);
  params[0] = strlit6899;
  partcv[0] = 1;
  Object opresult6901 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6901 (depth = 5)
  *var_s = opresult6901;
  if (opresult6901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6903 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6906 = alloc_Float64(1);
// compiled num node returning num6906 (depth = 7)
  int op_slot_right_6905 = gc_frame_newslot(num6906);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6909 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6910 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6909);
// compiled call node returning call6910 (depth = 10)
// compiled member node returning call6910 (depth = 9)
  partcv[0] = 0;
  Object call6911 = callmethod(call6910, "size",
    1, partcv, params);
  gc_frame_end(callframe6908);
// compiled call node returning call6911 (depth = 8)
// compiled member node returning call6911 (depth = 7)
  int op_slot_left_6905 = gc_frame_newslot(call6911);
  params[0] = num6906;
  partcv[0] = 1;
  Object diff6912 = callmethod(call6911, "-", 1, partcv, params);
// compiled op node returning diff6912 (depth = 6)
  int op_slot_right_6904 = gc_frame_newslot(diff6912);
// starting to compile num node (depth = 6)
  Object num6914 = alloc_Float64(1);
// compiled num node returning num6914 (depth = 6)
  int op_slot_left_6904 = gc_frame_newslot(num6914);
  params[0] = diff6912;
  partcv[0] = 1;
  Object opresult6915 = callmethod(num6914, "..", 1, partcv, params);
// compiled op node returning opresult6915 (depth = 5)
  gc_frame_newslot(opresult6915);
// starting to compile block node (depth = 5)
  Object block6916 = alloc_Block(NULL, NULL, "ast", 1697);
  gc_frame_newslot(block6916);
// method "_apply"
  block_savedest(block6916);
  Object closure6917 = createclosure(3, "_apply");
  setclosureframe(closure6917, stackframe);
  addtoclosure(closure6917, var_depth);
  addtoclosure(closure6917, var_s);
  addtoclosure(closure6917, selfslot);
  struct UserObject *uo6917 = (struct UserObject*)block6916;
  uo6917->data[0] = (Object)closure6917;
  Method *meth_meth_ast__apply6917 = addmethod2pos(block6916, "_apply", &meth_ast__apply6917, 0);
  int argcv_meth_ast__apply6917[] = {1};
  meth_meth_ast__apply6917->type = alloc_MethodType(1, argcv_meth_ast__apply6917);
  meth_meth_ast__apply6917->definitionModule = modulename;
  meth_meth_ast__apply6917->definitionLine = 1697;
// compiled block node returning block6916 (depth = 5)
  gc_frame_newslot(block6916);
// call case 5: prelude request
  params[0] = opresult6915;
  params[1] = block6916;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6933 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6903);
// compiled call node returning call6933 (depth = 4)
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6935 == NULL) {
    strlit6935 = alloc_String(">");
    gc_root(strlit6935);
  }
// compiled string node returning strlit6935 (depth = 6)
  int op_slot_right_6934 = gc_frame_newslot(strlit6935);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6938 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6940 = alloc_Float64(1);
// compiled num node returning num6940 (depth = 9)
  int op_slot_right_6939 = gc_frame_newslot(num6940);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6939 = gc_frame_newslot(*var_depth);
  params[0] = num6940;
  partcv[0] = 1;
  Object sum6942 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6942 (depth = 8)
  gc_frame_newslot(sum6942);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6943 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6945 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6944);
// compiled call node returning call6945 (depth = 11)
// compiled member node returning call6945 (depth = 10)
  partcv[0] = 0;
  Object call6946 = callmethod(call6945, "last",
    1, partcv, params);
  gc_frame_end(callframe6943);
// compiled call node returning call6946 (depth = 9)
// compiled member node returning call6946 (depth = 8)
  params[0] = sum6942;
  partcv[0] = 1;
  Object call6947 = callmethod(call6946, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6938);
// compiled call node returning call6947 (depth = 7)
  int op_slot_right_6937 = gc_frame_newslot(call6947);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6937 = gc_frame_newslot(*var_s);
  params[0] = call6947;
  partcv[0] = 1;
  Object opresult6949 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6949 (depth = 6)
  int op_slot_left_6934 = gc_frame_newslot(opresult6949);
  params[0] = strlit6935;
  partcv[0] = 1;
  Object opresult6950 = callmethod(opresult6949, "++", 1, partcv, params);
// compiled op node returning opresult6950 (depth = 5)
  *var_s = opresult6950;
  if (opresult6950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6891 = done;
  } else {
  }
// compiled if node returning if6891 (depth = 3)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6954 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6955 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6954);
// compiled call node returning call6955 (depth = 5)
// compiled member node returning call6955 (depth = 4)
  Object if6953 = done;
  if (istrue(call6955)) {
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6957 == NULL) {
    strlit6957 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6957);
  }
// compiled string node returning strlit6957 (depth = 5)
  int op_slot_right_6956 = gc_frame_newslot(strlit6957);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6961 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6960);
// compiled call node returning call6961 (depth = 7)
// compiled member node returning call6961 (depth = 6)
  int op_slot_right_6959 = gc_frame_newslot(call6961);
// starting to compile string node (depth = 6)
  if (strlit6963 == NULL) {
    strlit6963 = alloc_String("identifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit6963);
  }
// compiled string node returning strlit6963 (depth = 6)
  int op_slot_left_6959 = gc_frame_newslot(strlit6963);
  params[0] = call6961;
  partcv[0] = 1;
  Object opresult6964 = callmethod(strlit6963, "++", 1, partcv, params);
// compiled op node returning opresult6964 (depth = 5)
  int op_slot_left_6956 = gc_frame_newslot(opresult6964);
  params[0] = strlit6957;
  partcv[0] = 1;
  Object opresult6965 = callmethod(opresult6964, "++", 1, partcv, params);
// compiled op node returning opresult6965 (depth = 4)
    gc_frame_newslot(opresult6965);
    if6953 = opresult6965;
  } else {
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6967 == NULL) {
    strlit6967 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6967);
  }
// compiled string node returning strlit6967 (depth = 5)
  int op_slot_right_6966 = gc_frame_newslot(strlit6967);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6970 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6971 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6970);
// compiled call node returning call6971 (depth = 7)
// compiled member node returning call6971 (depth = 6)
  int op_slot_right_6969 = gc_frame_newslot(call6971);
// starting to compile string node (depth = 6)
  if (strlit6973 == NULL) {
    strlit6973 = alloc_String("identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit6973);
  }
// compiled string node returning strlit6973 (depth = 6)
  int op_slot_left_6969 = gc_frame_newslot(strlit6973);
  params[0] = call6971;
  partcv[0] = 1;
  Object opresult6974 = callmethod(strlit6973, "++", 1, partcv, params);
// compiled op node returning opresult6974 (depth = 5)
  int op_slot_left_6966 = gc_frame_newslot(opresult6974);
  params[0] = strlit6967;
  partcv[0] = 1;
  Object opresult6975 = callmethod(opresult6974, "++", 1, partcv, params);
// compiled op node returning opresult6975 (depth = 4)
    gc_frame_newslot(opresult6975);
    if6953 = opresult6975;
  }
// compiled if node returning if6953 (depth = 3)
  gc_frame_end(frame);
  return if6953;
}
Object meth_ast_shallowCopy6976(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6977 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe6978 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6979 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6980 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6979);
// compiled call node returning call6980 (depth = 6)
// compiled member node returning call6980 (depth = 5)
  gc_frame_newslot(call6980);
// starting to compile identifier node (depth = 5)
  Object bool6981 = alloc_Boolean(0);
// compiled identifier node returning bool6981 (depth = 5)
  gc_frame_newslot(bool6981);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call6980;
  params[1] = bool6981;
  partcv[0] = 2;
  Object call6982 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6978);
// compiled call node returning call6982 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call6983 = callmethod(call6982, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe6977);
// compiled call node returning call6983 (depth = 3)
  gc_frame_end(frame);
  return call6983;
}
Object meth_ast_shallowCopyFieldsFrom6984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6985 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6986 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6985);
// compiled call node returning call6986 (depth = 3)
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6987 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call6989 = callmethod(*var_other, "wildcard",
    1, partcv, params);
  gc_frame_end(callframe6988);
// compiled call node returning call6989 (depth = 5)
// compiled member node returning call6989 (depth = 4)
  gc_frame_newslot(call6989);
// call case 4: self request
  params[0] = call6989;
  partcv[0] = 1;
  Object call6990 = callmethodflags(self, "wildcard:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6987);
// compiled call node returning call6990 (depth = 3)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6991 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6992 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call6993 = callmethod(*var_other, "isBindingOccurrence",
    1, partcv, params);
  gc_frame_end(callframe6992);
// compiled call node returning call6993 (depth = 5)
// compiled member node returning call6993 (depth = 4)
  gc_frame_newslot(call6993);
// call case 4: self request
  params[0] = call6993;
  partcv[0] = 1;
  Object call6994 = callmethodflags(self, "isBindingOccurrence:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6991);
// compiled call node returning call6994 (depth = 3)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6995 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call6997 = callmethod(*var_other, "isDeclaredByParent",
    1, partcv, params);
  gc_frame_end(callframe6996);
// compiled call node returning call6997 (depth = 5)
// compiled member node returning call6997 (depth = 4)
  gc_frame_newslot(call6997);
// call case 4: self request
  params[0] = call6997;
  partcv[0] = 1;
  Object call6998 = callmethodflags(self, "isDeclaredByParent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6995);
// compiled call node returning call6998 (depth = 3)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6999 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7000 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7001 = callmethod(*var_other, "isAssigned",
    1, partcv, params);
  gc_frame_end(callframe7000);
// compiled call node returning call7001 (depth = 5)
// compiled member node returning call7001 (depth = 4)
  gc_frame_newslot(call7001);
// call case 4: self request
  params[0] = call7001;
  partcv[0] = 1;
  Object call7002 = callmethodflags(self, "isAssigned:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6999);
// compiled call node returning call7002 (depth = 3)
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7003 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call7005 = callmethod(*var_other, "inRequest",
    1, partcv, params);
  gc_frame_end(callframe7004);
// compiled call node returning call7005 (depth = 5)
// compiled member node returning call7005 (depth = 4)
  gc_frame_newslot(call7005);
// call case 4: self request
  params[0] = call7005;
  partcv[0] = 1;
  Object call7006 = callmethodflags(self, "inRequest:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7003);
// compiled call node returning call7006 (depth = 3)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName7007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7008 == NULL) {
    strlit7008 = alloc_String("expression");
    gc_root(strlit7008);
  }
// compiled string node returning strlit7008 (depth = 3)
  gc_frame_end(frame);
  return strlit7008;
}
Object meth_ast_new6639(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6640 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6640 = alloc_userobj2(32,25, objclass6640);
  gc_frame_newslot(obj6640);
if (objclass6640 == NULL) {
  glfree(obj6640->class->name);
  obj6640->class->name = "identifierNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6640, self, 0);
  addmethodreal(obj6640,"outer", &reader_ast_outer_6641);
  Object oldself6640 = self;
  struct StackFrameObject *oldstackframe6640 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6640);
  gc_frame_newslot((Object)stackframe);
  self = obj6640;
  Object *oldselfslot6640 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6640 = (*(struct UserObject *)self).data[0], lowerouter6640 = thisouter6640;
  if (inheritingObject6640) {
    struct UserObject *inho6640 = (struct UserObject *)inheritingObject6640;
    while (inho6640->super != GraceDefaultObject) inho6640 = (struct UserObject *)inho6640->super;
    inho6640->super = obj6640;
    self = inheritingObject6640;
    *selfslot = self;
    lowerouter6640 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6640;
  }
if (objclass6640 == NULL) {
  Method *reader6642 = addmethodrealflags(obj6640, "kind",&reader_ast_kind_6642, MFLAG_DEF);
  reader6642->definitionModule = modulename;
  reader6642->definitionLine = 1612;
}
adddatum2(obj6640, alloc_Undefined(), 1);
if (objclass6640 == NULL) {
  Method *reader6643 = addmethodrealflags(obj6640, "value",&reader_ast_value_6643, 0);
  Method *writer6643 = addmethodrealflags(obj6640, "value:=",&writer_ast_value_6643, 0);
  reader6643->definitionModule = modulename;
  writer6643->definitionModule = modulename;
  reader6643->definitionLine = 1613;
  writer6643->definitionLine = 1613;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 2);
if (objclass6640 == NULL) {
  Method *reader6644 = addmethodrealflags(obj6640, "wildcard",&reader_ast_wildcard_6644, 0);
  Method *writer6644 = addmethodrealflags(obj6640, "wildcard:=",&writer_ast_wildcard_6644, 0);
  reader6644->definitionModule = modulename;
  writer6644->definitionModule = modulename;
  reader6644->definitionLine = 1614;
  writer6644->definitionLine = 1614;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 3);
if (objclass6640 == NULL) {
  Method *reader6645 = addmethodrealflags(obj6640, "dtype",&reader_ast_dtype_6645, 0);
  Method *writer6645 = addmethodrealflags(obj6640, "dtype:=",&writer_ast_dtype_6645, 0);
  reader6645->definitionModule = modulename;
  writer6645->definitionModule = modulename;
  reader6645->definitionLine = 1615;
  writer6645->definitionLine = 1615;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 4);
if (objclass6640 == NULL) {
  Method *reader6646 = addmethodrealflags(obj6640, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6646, 0);
  Method *writer6646 = addmethodrealflags(obj6640, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6646, 0);
  reader6646->definitionModule = modulename;
  writer6646->definitionModule = modulename;
  reader6646->definitionLine = 1616;
  writer6646->definitionLine = 1616;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 5);
if (objclass6640 == NULL) {
  Method *reader6647 = addmethodrealflags(obj6640, "isAssigned",&reader_ast_isAssigned_6647, 0);
  Method *writer6647 = addmethodrealflags(obj6640, "isAssigned:=",&writer_ast_isAssigned_6647, 0);
  reader6647->definitionModule = modulename;
  writer6647->definitionModule = modulename;
  reader6647->definitionLine = 1617;
  writer6647->definitionLine = 1617;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 6);
if (objclass6640 == NULL) {
  Method *reader6648 = addmethodrealflags(obj6640, "inRequest",&reader_ast_inRequest_6648, 0);
  Method *writer6648 = addmethodrealflags(obj6640, "inRequest:=",&writer_ast_inRequest_6648, 0);
  reader6648->definitionModule = modulename;
  writer6648->definitionModule = modulename;
  reader6648->definitionLine = 1618;
  writer6648->definitionLine = 1618;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 7);
if (objclass6640 == NULL) {
  Method *reader6649 = addmethodrealflags(obj6640, "generics",&reader_ast_generics_6649, 0);
  Method *writer6649 = addmethodrealflags(obj6640, "generics:=",&writer_ast_generics_6649, 0);
  reader6649->definitionModule = modulename;
  writer6649->definitionModule = modulename;
  reader6649->definitionLine = 1619;
  writer6649->definitionLine = 1619;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 8);
if (objclass6640 == NULL) {
  Method *reader6650 = addmethodrealflags(obj6640, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6650, 0);
  Method *writer6650 = addmethodrealflags(obj6640, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6650, 0);
  reader6650->definitionModule = modulename;
  writer6650->definitionModule = modulename;
  reader6650->definitionLine = 1620;
  writer6650->definitionLine = 1620;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6651 = (struct UserObject*)obj6640;
  uo6651->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6651 = addmethod2pos(obj6640, "nameString", &meth_ast_nameString6651, 10);
  int argcv_meth_ast_nameString6651[] = {0};
  meth_meth_ast_nameString6651->type = alloc_MethodType(1, argcv_meth_ast_nameString6651);
  meth_meth_ast_nameString6651->definitionModule = modulename;
  meth_meth_ast_nameString6651->definitionLine = 1622;
// method "quoted"
  struct UserObject *uo6654 = (struct UserObject*)obj6640;
  uo6654->data[11] = emptyclosure;
  Method *meth_meth_ast_quoted6654 = addmethod2pos(obj6640, "quoted", &meth_ast_quoted6654, 11);
  int argcv_meth_ast_quoted6654[] = {0};
  meth_meth_ast_quoted6654->type = alloc_MethodType(1, argcv_meth_ast_quoted6654);
  meth_meth_ast_quoted6654->definitionModule = modulename;
  meth_meth_ast_quoted6654->definitionLine = 1623;
// method "isIdentifier"
  struct UserObject *uo6659 = (struct UserObject*)obj6640;
  uo6659->data[12] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6659 = addmethod2pos(obj6640, "isIdentifier", &meth_ast_isIdentifier6659, 12);
  int argcv_meth_ast_isIdentifier6659[] = {0};
  meth_meth_ast_isIdentifier6659->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6659);
  meth_meth_ast_isIdentifier6659->definitionModule = modulename;
  meth_meth_ast_isIdentifier6659->definitionLine = 1624;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6661 = (struct UserObject*)obj6640;
  uo6661->data[13] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6661 = addmethod2pos(obj6640, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6661, 13);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6661[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6661);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->definitionLine = 1626;
// method "declarationKindWithAncestors"
  struct UserObject *uo6670 = (struct UserObject*)obj6640;
  uo6670->data[14] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors6670 = addmethod2pos(obj6640, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6670, 14);
  int argcv_meth_ast_declarationKindWithAncestors6670[] = {1};
  meth_meth_ast_declarationKindWithAncestors6670->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6670);
  meth_meth_ast_declarationKindWithAncestors6670->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6670->definitionLine = 1633;
// method "inTypePositionWithAncestors"
  struct UserObject *uo6675 = (struct UserObject*)obj6640;
  uo6675->data[15] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors6675 = addmethod2pos(obj6640, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors6675, 15);
  int argcv_meth_ast_inTypePositionWithAncestors6675[] = {1};
  meth_meth_ast_inTypePositionWithAncestors6675->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors6675);
  meth_meth_ast_inTypePositionWithAncestors6675->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors6675->definitionLine = 1636;
// method "usesAsType"
  struct UserObject *uo6684 = (struct UserObject*)obj6640;
  uo6684->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType6684 = addmethod2pos(obj6640, "usesAsType", &meth_ast_usesAsType6684, 16);
  int argcv_meth_ast_usesAsType6684[] = {1};
  meth_meth_ast_usesAsType6684->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6684);
  meth_meth_ast_usesAsType6684->definitionModule = modulename;
  meth_meth_ast_usesAsType6684->definitionLine = 1643;
// method "accept()from"
  struct UserObject *uo6690 = (struct UserObject*)obj6640;
  uo6690->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6690 = addmethod2pos(obj6640, "accept()from", &meth_ast_accept_40__41_from6690, 17);
  int argcv_meth_ast_accept_40__41_from6690[] = {1, 1};
  meth_meth_ast_accept_40__41_from6690->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6690);
  meth_meth_ast_accept_40__41_from6690->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6690->definitionLine = 1646;
// method "map()ancestors"
  struct UserObject *uo6707 = (struct UserObject*)obj6640;
  uo6707->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6707 = addmethod2pos(obj6640, "map()ancestors", &meth_ast_map_40__41_ancestors6707, 18);
  int argcv_meth_ast_map_40__41_ancestors6707[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6707->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6707);
  meth_meth_ast_map_40__41_ancestors6707->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6707->definitionLine = 1654;
// method "pretty"
  struct UserObject *uo6724 = (struct UserObject*)obj6640;
  uo6724->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty6724 = addmethod2pos(obj6640, "pretty", &meth_ast_pretty6724, 19);
  int argcv_meth_ast_pretty6724[] = {1};
  meth_meth_ast_pretty6724->type = alloc_MethodType(1, argcv_meth_ast_pretty6724);
  meth_meth_ast_pretty6724->definitionModule = modulename;
  meth_meth_ast_pretty6724->definitionLine = 1660;
// method "toGrace"
  struct UserObject *uo6859 = (struct UserObject*)obj6640;
  uo6859->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace6859 = addmethod2pos(obj6640, "toGrace", &meth_ast_toGrace6859, 20);
  int argcv_meth_ast_toGrace6859[] = {1};
  meth_meth_ast_toGrace6859->type = alloc_MethodType(1, argcv_meth_ast_toGrace6859);
meth_meth_ast_toGrace6859->type->types[0] = type_Number;
meth_meth_ast_toGrace6859->type->names[0] = "depth";
  meth_meth_ast_toGrace6859->definitionModule = modulename;
  meth_meth_ast_toGrace6859->definitionLine = 1685;
// method "asString"
  struct UserObject *uo6952 = (struct UserObject*)obj6640;
  uo6952->data[21] = emptyclosure;
  Method *meth_meth_ast_asString6952 = addmethod2pos(obj6640, "asString", &meth_ast_asString6952, 21);
  int argcv_meth_ast_asString6952[] = {0};
  meth_meth_ast_asString6952->type = alloc_MethodType(1, argcv_meth_ast_asString6952);
  meth_meth_ast_asString6952->definitionModule = modulename;
  meth_meth_ast_asString6952->definitionLine = 1705;
// method "shallowCopy"
  block_savedest(obj6640);
  Object closure6976 = createclosure(1, "shallowCopy");
  setclosureframe(closure6976, stackframe);
  addtoclosure(closure6976, var_identifierNode);
  struct UserObject *uo6976 = (struct UserObject*)obj6640;
  uo6976->data[22] = (Object)closure6976;
  Method *meth_meth_ast_shallowCopy6976 = addmethod2pos(obj6640, "shallowCopy", &meth_ast_shallowCopy6976, 22);
  int argcv_meth_ast_shallowCopy6976[] = {0};
  meth_meth_ast_shallowCopy6976->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6976);
  meth_meth_ast_shallowCopy6976->definitionModule = modulename;
  meth_meth_ast_shallowCopy6976->definitionLine = 1712;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo6984 = (struct UserObject*)obj6640;
  uo6984->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6984 = addmethod2pos(obj6640, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6984, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom6984[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6984->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6984);
  meth_meth_ast_shallowCopyFieldsFrom6984->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6984->definitionLine = 1715;
// method "statementName"
  struct UserObject *uo7007 = (struct UserObject*)obj6640;
  uo7007->data[24] = emptyclosure;
  Method *meth_meth_ast_statementName7007 = addmethod2pos(obj6640, "statementName", &meth_ast_statementName7007, 24);
  int argcv_meth_ast_statementName7007[] = {0};
  meth_meth_ast_statementName7007->type = alloc_MethodType(1, argcv_meth_ast_statementName7007);
  meth_meth_ast_statementName7007->definitionModule = modulename;
  meth_meth_ast_statementName7007->definitionLine = 1724;
  sourceObject = obj6640;
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7009 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7010 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7011 = gc_frame_new();
// call case 3: self.outer request
  Object call7012 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7011);
// compiled call node returning call7012 (depth = 7)
// compiled member node returning call7012 (depth = 6)
  partcv[0] = 0;
  Object call7013 = callmethodflags(call7012, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7010);
// compiled call node returning call7013 (depth = 5)
// compiled member node returning call7013 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7014 = callmethodflags(call7013, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7009);
// compiled call node returning call7014 (depth = 3)
  struct UserObject *obj6640_uo = (struct UserObject *)obj6640;
  obj6640_uo->super = call7014;
  sourceObject = obj6640;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7015 == NULL) {
    strlit7015 = alloc_String("identifier");
    gc_root(strlit7015);
  }
// compiled string node returning strlit7015 (depth = 3)
  adddatum2(obj6640, strlit7015, 1);
  sourceObject = obj6640;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6640, *var_name, 2);
  sourceObject = obj6640;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7016 = alloc_Boolean(0);
// compiled identifier node returning bool7016 (depth = 3)
  adddatum2(obj6640, bool7016, 3);
  sourceObject = obj6640;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6640, *var_dtype_39_, 4);
  sourceObject = obj6640;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7017 = alloc_Boolean(0);
// compiled identifier node returning bool7017 (depth = 3)
  adddatum2(obj6640, bool7017, 5);
  sourceObject = obj6640;
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7018 = alloc_Boolean(0);
// compiled identifier node returning bool7018 (depth = 3)
  adddatum2(obj6640, bool7018, 6);
  sourceObject = obj6640;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7019 = alloc_Boolean(0);
// compiled identifier node returning bool7019 (depth = 3)
  adddatum2(obj6640, bool7019, 7);
  sourceObject = obj6640;
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7020 = alloc_Boolean(0);
// compiled identifier node returning bool7020 (depth = 3)
  adddatum2(obj6640, bool7020, 8);
  sourceObject = obj6640;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7021 = alloc_Boolean(0);
// compiled identifier node returning bool7021 (depth = 3)
  adddatum2(obj6640, bool7021, 9);
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  objclass6640 = obj6640->class;
  objclass6640->definitionModule = modulename;
  objclass6640->definitionLine = 1610;
  (*(struct UserObject *)self).data[0] = lowerouter6640;
  self = oldself6640;
  selfslot = oldselfslot6640;
  stackframe = oldstackframe6640;
  gc_frame_end(frame);
  return obj6640;
}
Object meth_ast_new6639_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6640 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6640 = alloc_userobj2(32,25, objclass6640);
  gc_frame_newslot(obj6640);
if (objclass6640 == NULL) {
  glfree(obj6640->class->name);
  obj6640->class->name = "identifierNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6640, self, 0);
  addmethodreal(obj6640,"outer", &reader_ast_outer_6641);
  Object oldself6640 = self;
  struct StackFrameObject *oldstackframe6640 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6640);
  gc_frame_newslot((Object)stackframe);
  self = obj6640;
  Object *oldselfslot6640 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6640 = (*(struct UserObject *)self).data[0], lowerouter6640 = thisouter6640;
  if (inheritingObject6640) {
    struct UserObject *inho6640 = (struct UserObject *)inheritingObject6640;
    while (inho6640->super != GraceDefaultObject) inho6640 = (struct UserObject *)inho6640->super;
    inho6640->super = obj6640;
    self = inheritingObject6640;
    *selfslot = self;
    lowerouter6640 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6640;
  }
if (objclass6640 == NULL) {
  Method *reader6642 = addmethodrealflags(obj6640, "kind",&reader_ast_kind_6642, MFLAG_DEF);
  reader6642->definitionModule = modulename;
  reader6642->definitionLine = 1612;
}
adddatum2(obj6640, alloc_Undefined(), 1);
if (objclass6640 == NULL) {
  Method *reader6643 = addmethodrealflags(obj6640, "value",&reader_ast_value_6643, 0);
  Method *writer6643 = addmethodrealflags(obj6640, "value:=",&writer_ast_value_6643, 0);
  reader6643->definitionModule = modulename;
  writer6643->definitionModule = modulename;
  reader6643->definitionLine = 1613;
  writer6643->definitionLine = 1613;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 2);
if (objclass6640 == NULL) {
  Method *reader6644 = addmethodrealflags(obj6640, "wildcard",&reader_ast_wildcard_6644, 0);
  Method *writer6644 = addmethodrealflags(obj6640, "wildcard:=",&writer_ast_wildcard_6644, 0);
  reader6644->definitionModule = modulename;
  writer6644->definitionModule = modulename;
  reader6644->definitionLine = 1614;
  writer6644->definitionLine = 1614;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 3);
if (objclass6640 == NULL) {
  Method *reader6645 = addmethodrealflags(obj6640, "dtype",&reader_ast_dtype_6645, 0);
  Method *writer6645 = addmethodrealflags(obj6640, "dtype:=",&writer_ast_dtype_6645, 0);
  reader6645->definitionModule = modulename;
  writer6645->definitionModule = modulename;
  reader6645->definitionLine = 1615;
  writer6645->definitionLine = 1615;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 4);
if (objclass6640 == NULL) {
  Method *reader6646 = addmethodrealflags(obj6640, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6646, 0);
  Method *writer6646 = addmethodrealflags(obj6640, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6646, 0);
  reader6646->definitionModule = modulename;
  writer6646->definitionModule = modulename;
  reader6646->definitionLine = 1616;
  writer6646->definitionLine = 1616;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 5);
if (objclass6640 == NULL) {
  Method *reader6647 = addmethodrealflags(obj6640, "isAssigned",&reader_ast_isAssigned_6647, 0);
  Method *writer6647 = addmethodrealflags(obj6640, "isAssigned:=",&writer_ast_isAssigned_6647, 0);
  reader6647->definitionModule = modulename;
  writer6647->definitionModule = modulename;
  reader6647->definitionLine = 1617;
  writer6647->definitionLine = 1617;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 6);
if (objclass6640 == NULL) {
  Method *reader6648 = addmethodrealflags(obj6640, "inRequest",&reader_ast_inRequest_6648, 0);
  Method *writer6648 = addmethodrealflags(obj6640, "inRequest:=",&writer_ast_inRequest_6648, 0);
  reader6648->definitionModule = modulename;
  writer6648->definitionModule = modulename;
  reader6648->definitionLine = 1618;
  writer6648->definitionLine = 1618;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 7);
if (objclass6640 == NULL) {
  Method *reader6649 = addmethodrealflags(obj6640, "generics",&reader_ast_generics_6649, 0);
  Method *writer6649 = addmethodrealflags(obj6640, "generics:=",&writer_ast_generics_6649, 0);
  reader6649->definitionModule = modulename;
  writer6649->definitionModule = modulename;
  reader6649->definitionLine = 1619;
  writer6649->definitionLine = 1619;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 8);
if (objclass6640 == NULL) {
  Method *reader6650 = addmethodrealflags(obj6640, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6650, 0);
  Method *writer6650 = addmethodrealflags(obj6640, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6650, 0);
  reader6650->definitionModule = modulename;
  writer6650->definitionModule = modulename;
  reader6650->definitionLine = 1620;
  writer6650->definitionLine = 1620;
}
obj6640->flags |= OFLAG_MUTABLE;
adddatum2(obj6640, alloc_Undefined(), 9);
// method "nameString"
  struct UserObject *uo6651 = (struct UserObject*)obj6640;
  uo6651->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6651 = addmethod2pos(obj6640, "nameString", &meth_ast_nameString6651, 10);
  int argcv_meth_ast_nameString6651[] = {0};
  meth_meth_ast_nameString6651->type = alloc_MethodType(1, argcv_meth_ast_nameString6651);
  meth_meth_ast_nameString6651->definitionModule = modulename;
  meth_meth_ast_nameString6651->definitionLine = 1622;
// method "quoted"
  struct UserObject *uo6654 = (struct UserObject*)obj6640;
  uo6654->data[11] = emptyclosure;
  Method *meth_meth_ast_quoted6654 = addmethod2pos(obj6640, "quoted", &meth_ast_quoted6654, 11);
  int argcv_meth_ast_quoted6654[] = {0};
  meth_meth_ast_quoted6654->type = alloc_MethodType(1, argcv_meth_ast_quoted6654);
  meth_meth_ast_quoted6654->definitionModule = modulename;
  meth_meth_ast_quoted6654->definitionLine = 1623;
// method "isIdentifier"
  struct UserObject *uo6659 = (struct UserObject*)obj6640;
  uo6659->data[12] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6659 = addmethod2pos(obj6640, "isIdentifier", &meth_ast_isIdentifier6659, 12);
  int argcv_meth_ast_isIdentifier6659[] = {0};
  meth_meth_ast_isIdentifier6659->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6659);
  meth_meth_ast_isIdentifier6659->definitionModule = modulename;
  meth_meth_ast_isIdentifier6659->definitionLine = 1624;
// method "isAppliedOccurenceOfIdentifier"
  struct UserObject *uo6661 = (struct UserObject*)obj6640;
  uo6661->data[13] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6661 = addmethod2pos(obj6640, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6661, 13);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6661[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6661);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6661->definitionLine = 1626;
// method "declarationKindWithAncestors"
  struct UserObject *uo6670 = (struct UserObject*)obj6640;
  uo6670->data[14] = emptyclosure;
  Method *meth_meth_ast_declarationKindWithAncestors6670 = addmethod2pos(obj6640, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors6670, 14);
  int argcv_meth_ast_declarationKindWithAncestors6670[] = {1};
  meth_meth_ast_declarationKindWithAncestors6670->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors6670);
  meth_meth_ast_declarationKindWithAncestors6670->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors6670->definitionLine = 1633;
// method "inTypePositionWithAncestors"
  struct UserObject *uo6675 = (struct UserObject*)obj6640;
  uo6675->data[15] = emptyclosure;
  Method *meth_meth_ast_inTypePositionWithAncestors6675 = addmethod2pos(obj6640, "inTypePositionWithAncestors", &meth_ast_inTypePositionWithAncestors6675, 15);
  int argcv_meth_ast_inTypePositionWithAncestors6675[] = {1};
  meth_meth_ast_inTypePositionWithAncestors6675->type = alloc_MethodType(1, argcv_meth_ast_inTypePositionWithAncestors6675);
  meth_meth_ast_inTypePositionWithAncestors6675->definitionModule = modulename;
  meth_meth_ast_inTypePositionWithAncestors6675->definitionLine = 1636;
// method "usesAsType"
  struct UserObject *uo6684 = (struct UserObject*)obj6640;
  uo6684->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType6684 = addmethod2pos(obj6640, "usesAsType", &meth_ast_usesAsType6684, 16);
  int argcv_meth_ast_usesAsType6684[] = {1};
  meth_meth_ast_usesAsType6684->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6684);
  meth_meth_ast_usesAsType6684->definitionModule = modulename;
  meth_meth_ast_usesAsType6684->definitionLine = 1643;
// method "accept()from"
  struct UserObject *uo6690 = (struct UserObject*)obj6640;
  uo6690->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6690 = addmethod2pos(obj6640, "accept()from", &meth_ast_accept_40__41_from6690, 17);
  int argcv_meth_ast_accept_40__41_from6690[] = {1, 1};
  meth_meth_ast_accept_40__41_from6690->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6690);
  meth_meth_ast_accept_40__41_from6690->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6690->definitionLine = 1646;
// method "map()ancestors"
  struct UserObject *uo6707 = (struct UserObject*)obj6640;
  uo6707->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors6707 = addmethod2pos(obj6640, "map()ancestors", &meth_ast_map_40__41_ancestors6707, 18);
  int argcv_meth_ast_map_40__41_ancestors6707[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors6707->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors6707);
  meth_meth_ast_map_40__41_ancestors6707->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors6707->definitionLine = 1654;
// method "pretty"
  struct UserObject *uo6724 = (struct UserObject*)obj6640;
  uo6724->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty6724 = addmethod2pos(obj6640, "pretty", &meth_ast_pretty6724, 19);
  int argcv_meth_ast_pretty6724[] = {1};
  meth_meth_ast_pretty6724->type = alloc_MethodType(1, argcv_meth_ast_pretty6724);
  meth_meth_ast_pretty6724->definitionModule = modulename;
  meth_meth_ast_pretty6724->definitionLine = 1660;
// method "toGrace"
  struct UserObject *uo6859 = (struct UserObject*)obj6640;
  uo6859->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace6859 = addmethod2pos(obj6640, "toGrace", &meth_ast_toGrace6859, 20);
  int argcv_meth_ast_toGrace6859[] = {1};
  meth_meth_ast_toGrace6859->type = alloc_MethodType(1, argcv_meth_ast_toGrace6859);
meth_meth_ast_toGrace6859->type->types[0] = type_Number;
meth_meth_ast_toGrace6859->type->names[0] = "depth";
  meth_meth_ast_toGrace6859->definitionModule = modulename;
  meth_meth_ast_toGrace6859->definitionLine = 1685;
// method "asString"
  struct UserObject *uo6952 = (struct UserObject*)obj6640;
  uo6952->data[21] = emptyclosure;
  Method *meth_meth_ast_asString6952 = addmethod2pos(obj6640, "asString", &meth_ast_asString6952, 21);
  int argcv_meth_ast_asString6952[] = {0};
  meth_meth_ast_asString6952->type = alloc_MethodType(1, argcv_meth_ast_asString6952);
  meth_meth_ast_asString6952->definitionModule = modulename;
  meth_meth_ast_asString6952->definitionLine = 1705;
// method "shallowCopy"
  block_savedest(obj6640);
  Object closure6976 = createclosure(1, "shallowCopy");
  setclosureframe(closure6976, stackframe);
  addtoclosure(closure6976, var_identifierNode);
  struct UserObject *uo6976 = (struct UserObject*)obj6640;
  uo6976->data[22] = (Object)closure6976;
  Method *meth_meth_ast_shallowCopy6976 = addmethod2pos(obj6640, "shallowCopy", &meth_ast_shallowCopy6976, 22);
  int argcv_meth_ast_shallowCopy6976[] = {0};
  meth_meth_ast_shallowCopy6976->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy6976);
  meth_meth_ast_shallowCopy6976->definitionModule = modulename;
  meth_meth_ast_shallowCopy6976->definitionLine = 1712;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo6984 = (struct UserObject*)obj6640;
  uo6984->data[23] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom6984 = addmethod2pos(obj6640, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom6984, 23);
  int argcv_meth_ast_shallowCopyFieldsFrom6984[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom6984->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom6984);
  meth_meth_ast_shallowCopyFieldsFrom6984->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom6984->definitionLine = 1715;
// method "statementName"
  struct UserObject *uo7007 = (struct UserObject*)obj6640;
  uo7007->data[24] = emptyclosure;
  Method *meth_meth_ast_statementName7007 = addmethod2pos(obj6640, "statementName", &meth_ast_statementName7007, 24);
  int argcv_meth_ast_statementName7007[] = {0};
  meth_meth_ast_statementName7007->type = alloc_MethodType(1, argcv_meth_ast_statementName7007);
  meth_meth_ast_statementName7007->definitionModule = modulename;
  meth_meth_ast_statementName7007->definitionLine = 1724;
  sourceObject = obj6640;
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7009 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7010 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7011 = gc_frame_new();
// call case 3: self.outer request
  Object call7012 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7011);
// compiled call node returning call7012 (depth = 7)
// compiled member node returning call7012 (depth = 6)
  partcv[0] = 0;
  Object call7013 = callmethodflags(call7012, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7010);
// compiled call node returning call7013 (depth = 5)
// compiled member node returning call7013 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7014 = callmethodflags(call7013, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7009);
// compiled call node returning call7014 (depth = 3)
  struct UserObject *obj6640_uo = (struct UserObject *)obj6640;
  obj6640_uo->super = call7014;
  sourceObject = obj6640;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7015 == NULL) {
    strlit7015 = alloc_String("identifier");
    gc_root(strlit7015);
  }
// compiled string node returning strlit7015 (depth = 3)
  adddatum2(obj6640, strlit7015, 1);
  sourceObject = obj6640;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name (depth = 3)
  adddatum2(obj6640, *var_name, 2);
  sourceObject = obj6640;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7016 = alloc_Boolean(0);
// compiled identifier node returning bool7016 (depth = 3)
  adddatum2(obj6640, bool7016, 3);
  sourceObject = obj6640;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj6640, *var_dtype_39_, 4);
  sourceObject = obj6640;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7017 = alloc_Boolean(0);
// compiled identifier node returning bool7017 (depth = 3)
  adddatum2(obj6640, bool7017, 5);
  sourceObject = obj6640;
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7018 = alloc_Boolean(0);
// compiled identifier node returning bool7018 (depth = 3)
  adddatum2(obj6640, bool7018, 6);
  sourceObject = obj6640;
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7019 = alloc_Boolean(0);
// compiled identifier node returning bool7019 (depth = 3)
  adddatum2(obj6640, bool7019, 7);
  sourceObject = obj6640;
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7020 = alloc_Boolean(0);
// compiled identifier node returning bool7020 (depth = 3)
  adddatum2(obj6640, bool7020, 8);
  sourceObject = obj6640;
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7021 = alloc_Boolean(0);
// compiled identifier node returning bool7021 (depth = 3)
  adddatum2(obj6640, bool7021, 9);
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  sourceObject = obj6640;
  objclass6640 = obj6640->class;
  objclass6640->definitionModule = modulename;
  objclass6640->definitionLine = 1610;
  (*(struct UserObject *)self).data[0] = lowerouter6640;
  self = oldself6640;
  selfslot = oldselfslot6640;
  stackframe = oldstackframe6640;
  gc_frame_end(frame);
  return obj6640;
}
Object meth_ast_identifierNode7023(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for identifierNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_typeType7028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7032(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for unknownType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for unknownType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_new_40__41_scope7035(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7036 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call7037 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7036);
// compiled call node returning call7037 (depth = 4)
  *var_result = call7037;
  if (call7037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7038 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7039 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7038);
// compiled call node returning call7039 (depth = 3)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_accept_40__41_from7045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7046 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7047 = callmethod(*var_visitor, "visitString()up",
    2, partcv, params);
  gc_frame_end(callframe7046);
// compiled call node returning call7047 (depth = 3)
  gc_frame_end(frame);
  return call7047;
}
Object meth_ast_map_40__41_ancestors7048(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7050 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7049);
// compiled call node returning call7050 (depth = 5)
// compiled member node returning call7050 (depth = 4)
  *var_n = call7050;
  if (call7050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7051 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7052 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7051);
// compiled call node returning call7052 (depth = 4)
  *var_newChain = call7052;
  if (call7052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7053 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7054 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7053);
// compiled call node returning call7054 (depth = 3)
  gc_frame_end(frame);
  return call7054;
}
Object meth_ast_pretty7055(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7057 == NULL) {
    strlit7057 = alloc_String(")");
    gc_root(strlit7057);
  }
// compiled string node returning strlit7057 (depth = 4)
  int op_slot_right_7056 = gc_frame_newslot(strlit7057);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7061 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7060);
// compiled call node returning call7061 (depth = 6)
// compiled member node returning call7061 (depth = 5)
  int op_slot_right_7059 = gc_frame_newslot(call7061);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7064 == NULL) {
    strlit7064 = alloc_String("(");
    gc_root(strlit7064);
  }
// compiled string node returning strlit7064 (depth = 6)
  int op_slot_right_7063 = gc_frame_newslot(strlit7064);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7067 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7068 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7067);
// compiled call node returning call7068 (depth = 7)
  int op_slot_right_7066 = gc_frame_newslot(call7068);
// starting to compile string node (depth = 7)
  if (strlit7070 == NULL) {
    strlit7070 = alloc_String("");
    gc_root(strlit7070);
  }
// compiled string node returning strlit7070 (depth = 7)
  int op_slot_left_7066 = gc_frame_newslot(strlit7070);
  params[0] = call7068;
  partcv[0] = 1;
  Object opresult7071 = callmethod(strlit7070, "++", 1, partcv, params);
// compiled op node returning opresult7071 (depth = 6)
  int op_slot_left_7063 = gc_frame_newslot(opresult7071);
  params[0] = strlit7064;
  partcv[0] = 1;
  Object opresult7072 = callmethod(opresult7071, "++", 1, partcv, params);
// compiled op node returning opresult7072 (depth = 5)
  int op_slot_left_7059 = gc_frame_newslot(opresult7072);
  params[0] = call7061;
  partcv[0] = 1;
  Object opresult7073 = callmethod(opresult7072, "++", 1, partcv, params);
// compiled op node returning opresult7073 (depth = 4)
  int op_slot_left_7056 = gc_frame_newslot(opresult7073);
  params[0] = strlit7057;
  partcv[0] = 1;
  Object opresult7074 = callmethod(opresult7073, "++", 1, partcv, params);
// compiled op node returning opresult7074 (depth = 3)
  gc_frame_end(frame);
  return opresult7074;
}
Object meth_ast_toGrace7075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_q = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "q");
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7076 == NULL) {
    strlit7076 = alloc_String("""\x22""");
    gc_root(strlit7076);
  }
// compiled string node returning strlit7076 (depth = 4)
  *var_q = strlit7076;
  if (strlit7076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_q (depth = 4)
  int op_slot_right_7077 = gc_frame_newslot(*var_q);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7080 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7081 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7082 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7081);
// compiled call node returning call7082 (depth = 8)
// compiled member node returning call7082 (depth = 7)
  partcv[0] = 0;
  Object call7083 = callmethod(call7082, "quoted",
    1, partcv, params);
  gc_frame_end(callframe7080);
// compiled call node returning call7083 (depth = 6)
// compiled member node returning call7083 (depth = 5)
  int op_slot_right_7079 = gc_frame_newslot(call7083);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_q (depth = 5)
  int op_slot_left_7079 = gc_frame_newslot(*var_q);
  params[0] = call7083;
  partcv[0] = 1;
  Object opresult7085 = callmethod(*var_q, "++", 1, partcv, params);
// compiled op node returning opresult7085 (depth = 4)
  int op_slot_left_7077 = gc_frame_newslot(opresult7085);
  params[0] = *var_q;
  partcv[0] = 1;
  Object opresult7086 = callmethod(opresult7085, "++", 1, partcv, params);
// compiled op node returning opresult7086 (depth = 3)
  gc_frame_end(frame);
  return opresult7086;
}
Object meth_ast_shallowCopy7087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7088 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7089 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7091 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7090);
// compiled call node returning call7091 (depth = 6)
// compiled member node returning call7091 (depth = 5)
  gc_frame_newslot(call7091);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_stringNode (depth = 5)
  params[0] = call7091;
  partcv[0] = 1;
  Object call7092 = callmethod(*var_stringNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7089);
// compiled call node returning call7092 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7093 = callmethod(call7092, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7088);
// compiled call node returning call7093 (depth = 3)
  gc_frame_end(frame);
  return call7093;
}
Object meth_ast_statementName7094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7095 == NULL) {
    strlit7095 = alloc_String("expression");
    gc_root(strlit7095);
  }
// compiled string node returning strlit7095 (depth = 3)
  gc_frame_end(frame);
  return strlit7095;
}
Object meth_ast_new7040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7041 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7041 = alloc_userobj2(9,9, objclass7041);
  gc_frame_newslot(obj7041);
if (objclass7041 == NULL) {
  glfree(obj7041->class->name);
  obj7041->class->name = "stringNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7041, self, 0);
  addmethodreal(obj7041,"outer", &reader_ast_outer_7042);
  Object oldself7041 = self;
  struct StackFrameObject *oldstackframe7041 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7041);
  gc_frame_newslot((Object)stackframe);
  self = obj7041;
  Object *oldselfslot7041 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7041 = (*(struct UserObject *)self).data[0], lowerouter7041 = thisouter7041;
  if (inheritingObject7041) {
    struct UserObject *inho7041 = (struct UserObject *)inheritingObject7041;
    while (inho7041->super != GraceDefaultObject) inho7041 = (struct UserObject *)inho7041->super;
    inho7041->super = obj7041;
    self = inheritingObject7041;
    *selfslot = self;
    lowerouter7041 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7041;
  }
if (objclass7041 == NULL) {
  Method *reader7043 = addmethodrealflags(obj7041, "kind",&reader_ast_kind_7043, MFLAG_DEF);
  reader7043->definitionModule = modulename;
  reader7043->definitionLine = 1740;
}
adddatum2(obj7041, alloc_Undefined(), 1);
if (objclass7041 == NULL) {
  Method *reader7044 = addmethodrealflags(obj7041, "value",&reader_ast_value_7044, 0);
  Method *writer7044 = addmethodrealflags(obj7041, "value:=",&writer_ast_value_7044, 0);
  reader7044->definitionModule = modulename;
  writer7044->definitionModule = modulename;
  reader7044->definitionLine = 1741;
  writer7044->definitionLine = 1741;
}
obj7041->flags |= OFLAG_MUTABLE;
adddatum2(obj7041, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7045 = (struct UserObject*)obj7041;
  uo7045->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7045 = addmethod2pos(obj7041, "accept()from", &meth_ast_accept_40__41_from7045, 3);
  int argcv_meth_ast_accept_40__41_from7045[] = {1, 1};
  meth_meth_ast_accept_40__41_from7045->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7045);
  meth_meth_ast_accept_40__41_from7045->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7045->definitionLine = 1742;
// method "map()ancestors"
  struct UserObject *uo7048 = (struct UserObject*)obj7041;
  uo7048->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7048 = addmethod2pos(obj7041, "map()ancestors", &meth_ast_map_40__41_ancestors7048, 4);
  int argcv_meth_ast_map_40__41_ancestors7048[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7048->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7048);
  meth_meth_ast_map_40__41_ancestors7048->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7048->definitionLine = 1745;
// method "pretty"
  struct UserObject *uo7055 = (struct UserObject*)obj7041;
  uo7055->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7055 = addmethod2pos(obj7041, "pretty", &meth_ast_pretty7055, 5);
  int argcv_meth_ast_pretty7055[] = {1};
  meth_meth_ast_pretty7055->type = alloc_MethodType(1, argcv_meth_ast_pretty7055);
  meth_meth_ast_pretty7055->definitionModule = modulename;
  meth_meth_ast_pretty7055->definitionLine = 1750;
// method "toGrace"
  struct UserObject *uo7075 = (struct UserObject*)obj7041;
  uo7075->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7075 = addmethod2pos(obj7041, "toGrace", &meth_ast_toGrace7075, 6);
  int argcv_meth_ast_toGrace7075[] = {1};
  meth_meth_ast_toGrace7075->type = alloc_MethodType(1, argcv_meth_ast_toGrace7075);
meth_meth_ast_toGrace7075->type->types[0] = type_Number;
meth_meth_ast_toGrace7075->type->names[0] = "depth";
  meth_meth_ast_toGrace7075->definitionModule = modulename;
  meth_meth_ast_toGrace7075->definitionLine = 1753;
// method "shallowCopy"
  block_savedest(obj7041);
  Object closure7087 = createclosure(1, "shallowCopy");
  setclosureframe(closure7087, stackframe);
  addtoclosure(closure7087, var_stringNode);
  struct UserObject *uo7087 = (struct UserObject*)obj7041;
  uo7087->data[7] = (Object)closure7087;
  Method *meth_meth_ast_shallowCopy7087 = addmethod2pos(obj7041, "shallowCopy", &meth_ast_shallowCopy7087, 7);
  int argcv_meth_ast_shallowCopy7087[] = {0};
  meth_meth_ast_shallowCopy7087->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7087);
  meth_meth_ast_shallowCopy7087->definitionModule = modulename;
  meth_meth_ast_shallowCopy7087->definitionLine = 1757;
// method "statementName"
  struct UserObject *uo7094 = (struct UserObject*)obj7041;
  uo7094->data[8] = emptyclosure;
  Method *meth_meth_ast_statementName7094 = addmethod2pos(obj7041, "statementName", &meth_ast_statementName7094, 8);
  int argcv_meth_ast_statementName7094[] = {0};
  meth_meth_ast_statementName7094->type = alloc_MethodType(1, argcv_meth_ast_statementName7094);
  meth_meth_ast_statementName7094->definitionModule = modulename;
  meth_meth_ast_statementName7094->definitionLine = 1760;
  sourceObject = obj7041;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7096 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7097 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7098 = gc_frame_new();
// call case 3: self.outer request
  Object call7099 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7098);
// compiled call node returning call7099 (depth = 7)
// compiled member node returning call7099 (depth = 6)
  partcv[0] = 0;
  Object call7100 = callmethodflags(call7099, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled call node returning call7100 (depth = 5)
// compiled member node returning call7100 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7101 = callmethodflags(call7100, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7096);
// compiled call node returning call7101 (depth = 3)
  struct UserObject *obj7041_uo = (struct UserObject *)obj7041;
  obj7041_uo->super = call7101;
  sourceObject = obj7041;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7102 == NULL) {
    strlit7102 = alloc_String("string");
    gc_root(strlit7102);
  }
// compiled string node returning strlit7102 (depth = 3)
  adddatum2(obj7041, strlit7102, 1);
  sourceObject = obj7041;
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7041, *var_v, 2);
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  objclass7041 = obj7041->class;
  objclass7041->definitionModule = modulename;
  objclass7041->definitionLine = 1738;
  (*(struct UserObject *)self).data[0] = lowerouter7041;
  self = oldself7041;
  selfslot = oldselfslot7041;
  stackframe = oldstackframe7041;
  gc_frame_end(frame);
  return obj7041;
}
Object meth_ast_new7040_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7041 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7041 = alloc_userobj2(9,9, objclass7041);
  gc_frame_newslot(obj7041);
if (objclass7041 == NULL) {
  glfree(obj7041->class->name);
  obj7041->class->name = "stringNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7041, self, 0);
  addmethodreal(obj7041,"outer", &reader_ast_outer_7042);
  Object oldself7041 = self;
  struct StackFrameObject *oldstackframe7041 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7041);
  gc_frame_newslot((Object)stackframe);
  self = obj7041;
  Object *oldselfslot7041 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7041 = (*(struct UserObject *)self).data[0], lowerouter7041 = thisouter7041;
  if (inheritingObject7041) {
    struct UserObject *inho7041 = (struct UserObject *)inheritingObject7041;
    while (inho7041->super != GraceDefaultObject) inho7041 = (struct UserObject *)inho7041->super;
    inho7041->super = obj7041;
    self = inheritingObject7041;
    *selfslot = self;
    lowerouter7041 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7041;
  }
if (objclass7041 == NULL) {
  Method *reader7043 = addmethodrealflags(obj7041, "kind",&reader_ast_kind_7043, MFLAG_DEF);
  reader7043->definitionModule = modulename;
  reader7043->definitionLine = 1740;
}
adddatum2(obj7041, alloc_Undefined(), 1);
if (objclass7041 == NULL) {
  Method *reader7044 = addmethodrealflags(obj7041, "value",&reader_ast_value_7044, 0);
  Method *writer7044 = addmethodrealflags(obj7041, "value:=",&writer_ast_value_7044, 0);
  reader7044->definitionModule = modulename;
  writer7044->definitionModule = modulename;
  reader7044->definitionLine = 1741;
  writer7044->definitionLine = 1741;
}
obj7041->flags |= OFLAG_MUTABLE;
adddatum2(obj7041, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7045 = (struct UserObject*)obj7041;
  uo7045->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7045 = addmethod2pos(obj7041, "accept()from", &meth_ast_accept_40__41_from7045, 3);
  int argcv_meth_ast_accept_40__41_from7045[] = {1, 1};
  meth_meth_ast_accept_40__41_from7045->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7045);
  meth_meth_ast_accept_40__41_from7045->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7045->definitionLine = 1742;
// method "map()ancestors"
  struct UserObject *uo7048 = (struct UserObject*)obj7041;
  uo7048->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7048 = addmethod2pos(obj7041, "map()ancestors", &meth_ast_map_40__41_ancestors7048, 4);
  int argcv_meth_ast_map_40__41_ancestors7048[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7048->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7048);
  meth_meth_ast_map_40__41_ancestors7048->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7048->definitionLine = 1745;
// method "pretty"
  struct UserObject *uo7055 = (struct UserObject*)obj7041;
  uo7055->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7055 = addmethod2pos(obj7041, "pretty", &meth_ast_pretty7055, 5);
  int argcv_meth_ast_pretty7055[] = {1};
  meth_meth_ast_pretty7055->type = alloc_MethodType(1, argcv_meth_ast_pretty7055);
  meth_meth_ast_pretty7055->definitionModule = modulename;
  meth_meth_ast_pretty7055->definitionLine = 1750;
// method "toGrace"
  struct UserObject *uo7075 = (struct UserObject*)obj7041;
  uo7075->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7075 = addmethod2pos(obj7041, "toGrace", &meth_ast_toGrace7075, 6);
  int argcv_meth_ast_toGrace7075[] = {1};
  meth_meth_ast_toGrace7075->type = alloc_MethodType(1, argcv_meth_ast_toGrace7075);
meth_meth_ast_toGrace7075->type->types[0] = type_Number;
meth_meth_ast_toGrace7075->type->names[0] = "depth";
  meth_meth_ast_toGrace7075->definitionModule = modulename;
  meth_meth_ast_toGrace7075->definitionLine = 1753;
// method "shallowCopy"
  block_savedest(obj7041);
  Object closure7087 = createclosure(1, "shallowCopy");
  setclosureframe(closure7087, stackframe);
  addtoclosure(closure7087, var_stringNode);
  struct UserObject *uo7087 = (struct UserObject*)obj7041;
  uo7087->data[7] = (Object)closure7087;
  Method *meth_meth_ast_shallowCopy7087 = addmethod2pos(obj7041, "shallowCopy", &meth_ast_shallowCopy7087, 7);
  int argcv_meth_ast_shallowCopy7087[] = {0};
  meth_meth_ast_shallowCopy7087->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7087);
  meth_meth_ast_shallowCopy7087->definitionModule = modulename;
  meth_meth_ast_shallowCopy7087->definitionLine = 1757;
// method "statementName"
  struct UserObject *uo7094 = (struct UserObject*)obj7041;
  uo7094->data[8] = emptyclosure;
  Method *meth_meth_ast_statementName7094 = addmethod2pos(obj7041, "statementName", &meth_ast_statementName7094, 8);
  int argcv_meth_ast_statementName7094[] = {0};
  meth_meth_ast_statementName7094->type = alloc_MethodType(1, argcv_meth_ast_statementName7094);
  meth_meth_ast_statementName7094->definitionModule = modulename;
  meth_meth_ast_statementName7094->definitionLine = 1760;
  sourceObject = obj7041;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7096 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7097 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7098 = gc_frame_new();
// call case 3: self.outer request
  Object call7099 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7098);
// compiled call node returning call7099 (depth = 7)
// compiled member node returning call7099 (depth = 6)
  partcv[0] = 0;
  Object call7100 = callmethodflags(call7099, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compiled call node returning call7100 (depth = 5)
// compiled member node returning call7100 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7101 = callmethodflags(call7100, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7096);
// compiled call node returning call7101 (depth = 3)
  struct UserObject *obj7041_uo = (struct UserObject *)obj7041;
  obj7041_uo->super = call7101;
  sourceObject = obj7041;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7102 == NULL) {
    strlit7102 = alloc_String("string");
    gc_root(strlit7102);
  }
// compiled string node returning strlit7102 (depth = 3)
  adddatum2(obj7041, strlit7102, 1);
  sourceObject = obj7041;
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  adddatum2(obj7041, *var_v, 2);
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  sourceObject = obj7041;
  objclass7041 = obj7041->class;
  objclass7041->definitionModule = modulename;
  objclass7041->definitionLine = 1738;
  (*(struct UserObject *)self).data[0] = lowerouter7041;
  self = oldself7041;
  selfslot = oldselfslot7041;
  stackframe = oldstackframe7041;
  gc_frame_end(frame);
  return obj7041;
}
Object meth_ast_stringNode7104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for stringNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept_40__41_from7112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7113 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7114 = callmethod(*var_visitor, "visitNum()up",
    2, partcv, params);
  gc_frame_end(callframe7113);
// compiled call node returning call7114 (depth = 3)
  gc_frame_end(frame);
  return call7114;
}
Object meth_ast_map_40__41_ancestors7115(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7117 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7116);
// compiled call node returning call7117 (depth = 5)
// compiled member node returning call7117 (depth = 4)
  *var_n = call7117;
  if (call7117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7118 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7119 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7118);
// compiled call node returning call7119 (depth = 4)
  *var_newChain = call7119;
  if (call7119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7120 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7121 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7120);
// compiled call node returning call7121 (depth = 3)
  gc_frame_end(frame);
  return call7121;
}
Object meth_ast_pretty7122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7124 == NULL) {
    strlit7124 = alloc_String(")");
    gc_root(strlit7124);
  }
// compiled string node returning strlit7124 (depth = 4)
  int op_slot_right_7123 = gc_frame_newslot(strlit7124);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7127 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7128 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7127);
// compiled call node returning call7128 (depth = 6)
// compiled member node returning call7128 (depth = 5)
  int op_slot_right_7126 = gc_frame_newslot(call7128);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7131 == NULL) {
    strlit7131 = alloc_String("(");
    gc_root(strlit7131);
  }
// compiled string node returning strlit7131 (depth = 6)
  int op_slot_right_7130 = gc_frame_newslot(strlit7131);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7134 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7135 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7134);
// compiled call node returning call7135 (depth = 7)
  int op_slot_right_7133 = gc_frame_newslot(call7135);
// starting to compile string node (depth = 7)
  if (strlit7137 == NULL) {
    strlit7137 = alloc_String("");
    gc_root(strlit7137);
  }
// compiled string node returning strlit7137 (depth = 7)
  int op_slot_left_7133 = gc_frame_newslot(strlit7137);
  params[0] = call7135;
  partcv[0] = 1;
  Object opresult7138 = callmethod(strlit7137, "++", 1, partcv, params);
// compiled op node returning opresult7138 (depth = 6)
  int op_slot_left_7130 = gc_frame_newslot(opresult7138);
  params[0] = strlit7131;
  partcv[0] = 1;
  Object opresult7139 = callmethod(opresult7138, "++", 1, partcv, params);
// compiled op node returning opresult7139 (depth = 5)
  int op_slot_left_7126 = gc_frame_newslot(opresult7139);
  params[0] = call7128;
  partcv[0] = 1;
  Object opresult7140 = callmethod(opresult7139, "++", 1, partcv, params);
// compiled op node returning opresult7140 (depth = 4)
  int op_slot_left_7123 = gc_frame_newslot(opresult7140);
  params[0] = strlit7124;
  partcv[0] = 1;
  Object opresult7141 = callmethod(opresult7140, "++", 1, partcv, params);
// compiled op node returning opresult7141 (depth = 3)
  gc_frame_end(frame);
  return opresult7141;
}
Object meth_ast_toGrace7142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7143 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7145 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7144);
// compiled call node returning call7145 (depth = 6)
// compiled member node returning call7145 (depth = 5)
  partcv[0] = 0;
  Object call7146 = callmethod(call7145, "asString",
    1, partcv, params);
  gc_frame_end(callframe7143);
// compiled call node returning call7146 (depth = 4)
// compiled member node returning call7146 (depth = 3)
  gc_frame_end(frame);
  return call7146;
}
Object meth_ast_asString7147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7149 == NULL) {
    strlit7149 = alloc_String("");
    gc_root(strlit7149);
  }
// compiled string node returning strlit7149 (depth = 4)
  int op_slot_right_7148 = gc_frame_newslot(strlit7149);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7153 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7152);
// compiled call node returning call7153 (depth = 6)
// compiled member node returning call7153 (depth = 5)
  int op_slot_right_7151 = gc_frame_newslot(call7153);
// starting to compile string node (depth = 5)
  if (strlit7155 == NULL) {
    strlit7155 = alloc_String("num ");
    gc_root(strlit7155);
  }
// compiled string node returning strlit7155 (depth = 5)
  int op_slot_left_7151 = gc_frame_newslot(strlit7155);
  params[0] = call7153;
  partcv[0] = 1;
  Object opresult7156 = callmethod(strlit7155, "++", 1, partcv, params);
// compiled op node returning opresult7156 (depth = 4)
  int op_slot_left_7148 = gc_frame_newslot(opresult7156);
  params[0] = strlit7149;
  partcv[0] = 1;
  Object opresult7157 = callmethod(opresult7156, "++", 1, partcv, params);
// compiled op node returning opresult7157 (depth = 3)
  gc_frame_end(frame);
  return opresult7157;
}
Object meth_ast_shallowCopy7158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7159 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7160 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7162 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7161);
// compiled call node returning call7162 (depth = 6)
// compiled member node returning call7162 (depth = 5)
  gc_frame_newslot(call7162);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_numNode (depth = 5)
  params[0] = call7162;
  partcv[0] = 1;
  Object call7163 = callmethod(*var_numNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7160);
// compiled call node returning call7163 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7164 = callmethod(call7163, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7159);
// compiled call node returning call7164 (depth = 3)
  gc_frame_end(frame);
  return call7164;
}
Object meth_ast_statementName7165(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7166 == NULL) {
    strlit7166 = alloc_String("expression");
    gc_root(strlit7166);
  }
// compiled string node returning strlit7166 (depth = 3)
  gc_frame_end(frame);
  return strlit7166;
}
Object meth_ast_new7107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7108 = alloc_userobj2(10,10, objclass7108);
  gc_frame_newslot(obj7108);
if (objclass7108 == NULL) {
  glfree(obj7108->class->name);
  obj7108->class->name = "numNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7108, self, 0);
  addmethodreal(obj7108,"outer", &reader_ast_outer_7109);
  Object oldself7108 = self;
  struct StackFrameObject *oldstackframe7108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7108);
  gc_frame_newslot((Object)stackframe);
  self = obj7108;
  Object *oldselfslot7108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7108 = (*(struct UserObject *)self).data[0], lowerouter7108 = thisouter7108;
  if (inheritingObject7108) {
    struct UserObject *inho7108 = (struct UserObject *)inheritingObject7108;
    while (inho7108->super != GraceDefaultObject) inho7108 = (struct UserObject *)inho7108->super;
    inho7108->super = obj7108;
    self = inheritingObject7108;
    *selfslot = self;
    lowerouter7108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7108;
  }
if (objclass7108 == NULL) {
  Method *reader7110 = addmethodrealflags(obj7108, "kind",&reader_ast_kind_7110, MFLAG_DEF);
  reader7110->definitionModule = modulename;
  reader7110->definitionLine = 1766;
}
adddatum2(obj7108, alloc_Undefined(), 1);
if (objclass7108 == NULL) {
  Method *reader7111 = addmethodrealflags(obj7108, "value",&reader_ast_value_7111, 0);
  Method *writer7111 = addmethodrealflags(obj7108, "value:=",&writer_ast_value_7111, 0);
  reader7111->definitionModule = modulename;
  writer7111->definitionModule = modulename;
  reader7111->definitionLine = 1767;
  writer7111->definitionLine = 1767;
}
obj7108->flags |= OFLAG_MUTABLE;
adddatum2(obj7108, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7112 = (struct UserObject*)obj7108;
  uo7112->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7112 = addmethod2pos(obj7108, "accept()from", &meth_ast_accept_40__41_from7112, 3);
  int argcv_meth_ast_accept_40__41_from7112[] = {1, 1};
  meth_meth_ast_accept_40__41_from7112->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7112);
  meth_meth_ast_accept_40__41_from7112->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7112->definitionLine = 1768;
// method "map()ancestors"
  struct UserObject *uo7115 = (struct UserObject*)obj7108;
  uo7115->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7115 = addmethod2pos(obj7108, "map()ancestors", &meth_ast_map_40__41_ancestors7115, 4);
  int argcv_meth_ast_map_40__41_ancestors7115[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7115->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7115);
  meth_meth_ast_map_40__41_ancestors7115->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7115->definitionLine = 1771;
// method "pretty"
  struct UserObject *uo7122 = (struct UserObject*)obj7108;
  uo7122->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7122 = addmethod2pos(obj7108, "pretty", &meth_ast_pretty7122, 5);
  int argcv_meth_ast_pretty7122[] = {1};
  meth_meth_ast_pretty7122->type = alloc_MethodType(1, argcv_meth_ast_pretty7122);
  meth_meth_ast_pretty7122->definitionModule = modulename;
  meth_meth_ast_pretty7122->definitionLine = 1776;
// method "toGrace"
  struct UserObject *uo7142 = (struct UserObject*)obj7108;
  uo7142->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7142 = addmethod2pos(obj7108, "toGrace", &meth_ast_toGrace7142, 6);
  int argcv_meth_ast_toGrace7142[] = {1};
  meth_meth_ast_toGrace7142->type = alloc_MethodType(1, argcv_meth_ast_toGrace7142);
meth_meth_ast_toGrace7142->type->types[0] = type_Number;
meth_meth_ast_toGrace7142->type->names[0] = "depth";
  meth_meth_ast_toGrace7142->definitionModule = modulename;
  meth_meth_ast_toGrace7142->definitionLine = 1779;
// method "asString"
  struct UserObject *uo7147 = (struct UserObject*)obj7108;
  uo7147->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7147 = addmethod2pos(obj7108, "asString", &meth_ast_asString7147, 7);
  int argcv_meth_ast_asString7147[] = {0};
  meth_meth_ast_asString7147->type = alloc_MethodType(1, argcv_meth_ast_asString7147);
  meth_meth_ast_asString7147->definitionModule = modulename;
  meth_meth_ast_asString7147->definitionLine = 1782;
// method "shallowCopy"
  block_savedest(obj7108);
  Object closure7158 = createclosure(1, "shallowCopy");
  setclosureframe(closure7158, stackframe);
  addtoclosure(closure7158, var_numNode);
  struct UserObject *uo7158 = (struct UserObject*)obj7108;
  uo7158->data[8] = (Object)closure7158;
  Method *meth_meth_ast_shallowCopy7158 = addmethod2pos(obj7108, "shallowCopy", &meth_ast_shallowCopy7158, 8);
  int argcv_meth_ast_shallowCopy7158[] = {0};
  meth_meth_ast_shallowCopy7158->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7158);
  meth_meth_ast_shallowCopy7158->definitionModule = modulename;
  meth_meth_ast_shallowCopy7158->definitionLine = 1783;
// method "statementName"
  struct UserObject *uo7165 = (struct UserObject*)obj7108;
  uo7165->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7165 = addmethod2pos(obj7108, "statementName", &meth_ast_statementName7165, 9);
  int argcv_meth_ast_statementName7165[] = {0};
  meth_meth_ast_statementName7165->type = alloc_MethodType(1, argcv_meth_ast_statementName7165);
  meth_meth_ast_statementName7165->definitionModule = modulename;
  meth_meth_ast_statementName7165->definitionLine = 1786;
  sourceObject = obj7108;
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7168 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7169 = gc_frame_new();
// call case 3: self.outer request
  Object call7170 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7169);
// compiled call node returning call7170 (depth = 7)
// compiled member node returning call7170 (depth = 6)
  partcv[0] = 0;
  Object call7171 = callmethodflags(call7170, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7168);
// compiled call node returning call7171 (depth = 5)
// compiled member node returning call7171 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7172 = callmethodflags(call7171, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7167);
// compiled call node returning call7172 (depth = 3)
  struct UserObject *obj7108_uo = (struct UserObject *)obj7108;
  obj7108_uo->super = call7172;
  sourceObject = obj7108;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7173 == NULL) {
    strlit7173 = alloc_String("num");
    gc_root(strlit7173);
  }
// compiled string node returning strlit7173 (depth = 3)
  adddatum2(obj7108, strlit7173, 1);
  sourceObject = obj7108;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7108, *var_val, 2);
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  objclass7108 = obj7108->class;
  objclass7108->definitionModule = modulename;
  objclass7108->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter7108;
  self = oldself7108;
  selfslot = oldselfslot7108;
  stackframe = oldstackframe7108;
  gc_frame_end(frame);
  return obj7108;
}
Object meth_ast_new7107_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7108 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7108 = alloc_userobj2(10,10, objclass7108);
  gc_frame_newslot(obj7108);
if (objclass7108 == NULL) {
  glfree(obj7108->class->name);
  obj7108->class->name = "numNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7108, self, 0);
  addmethodreal(obj7108,"outer", &reader_ast_outer_7109);
  Object oldself7108 = self;
  struct StackFrameObject *oldstackframe7108 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7108);
  gc_frame_newslot((Object)stackframe);
  self = obj7108;
  Object *oldselfslot7108 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7108 = (*(struct UserObject *)self).data[0], lowerouter7108 = thisouter7108;
  if (inheritingObject7108) {
    struct UserObject *inho7108 = (struct UserObject *)inheritingObject7108;
    while (inho7108->super != GraceDefaultObject) inho7108 = (struct UserObject *)inho7108->super;
    inho7108->super = obj7108;
    self = inheritingObject7108;
    *selfslot = self;
    lowerouter7108 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7108;
  }
if (objclass7108 == NULL) {
  Method *reader7110 = addmethodrealflags(obj7108, "kind",&reader_ast_kind_7110, MFLAG_DEF);
  reader7110->definitionModule = modulename;
  reader7110->definitionLine = 1766;
}
adddatum2(obj7108, alloc_Undefined(), 1);
if (objclass7108 == NULL) {
  Method *reader7111 = addmethodrealflags(obj7108, "value",&reader_ast_value_7111, 0);
  Method *writer7111 = addmethodrealflags(obj7108, "value:=",&writer_ast_value_7111, 0);
  reader7111->definitionModule = modulename;
  writer7111->definitionModule = modulename;
  reader7111->definitionLine = 1767;
  writer7111->definitionLine = 1767;
}
obj7108->flags |= OFLAG_MUTABLE;
adddatum2(obj7108, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo7112 = (struct UserObject*)obj7108;
  uo7112->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7112 = addmethod2pos(obj7108, "accept()from", &meth_ast_accept_40__41_from7112, 3);
  int argcv_meth_ast_accept_40__41_from7112[] = {1, 1};
  meth_meth_ast_accept_40__41_from7112->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7112);
  meth_meth_ast_accept_40__41_from7112->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7112->definitionLine = 1768;
// method "map()ancestors"
  struct UserObject *uo7115 = (struct UserObject*)obj7108;
  uo7115->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7115 = addmethod2pos(obj7108, "map()ancestors", &meth_ast_map_40__41_ancestors7115, 4);
  int argcv_meth_ast_map_40__41_ancestors7115[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7115->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7115);
  meth_meth_ast_map_40__41_ancestors7115->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7115->definitionLine = 1771;
// method "pretty"
  struct UserObject *uo7122 = (struct UserObject*)obj7108;
  uo7122->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7122 = addmethod2pos(obj7108, "pretty", &meth_ast_pretty7122, 5);
  int argcv_meth_ast_pretty7122[] = {1};
  meth_meth_ast_pretty7122->type = alloc_MethodType(1, argcv_meth_ast_pretty7122);
  meth_meth_ast_pretty7122->definitionModule = modulename;
  meth_meth_ast_pretty7122->definitionLine = 1776;
// method "toGrace"
  struct UserObject *uo7142 = (struct UserObject*)obj7108;
  uo7142->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7142 = addmethod2pos(obj7108, "toGrace", &meth_ast_toGrace7142, 6);
  int argcv_meth_ast_toGrace7142[] = {1};
  meth_meth_ast_toGrace7142->type = alloc_MethodType(1, argcv_meth_ast_toGrace7142);
meth_meth_ast_toGrace7142->type->types[0] = type_Number;
meth_meth_ast_toGrace7142->type->names[0] = "depth";
  meth_meth_ast_toGrace7142->definitionModule = modulename;
  meth_meth_ast_toGrace7142->definitionLine = 1779;
// method "asString"
  struct UserObject *uo7147 = (struct UserObject*)obj7108;
  uo7147->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7147 = addmethod2pos(obj7108, "asString", &meth_ast_asString7147, 7);
  int argcv_meth_ast_asString7147[] = {0};
  meth_meth_ast_asString7147->type = alloc_MethodType(1, argcv_meth_ast_asString7147);
  meth_meth_ast_asString7147->definitionModule = modulename;
  meth_meth_ast_asString7147->definitionLine = 1782;
// method "shallowCopy"
  block_savedest(obj7108);
  Object closure7158 = createclosure(1, "shallowCopy");
  setclosureframe(closure7158, stackframe);
  addtoclosure(closure7158, var_numNode);
  struct UserObject *uo7158 = (struct UserObject*)obj7108;
  uo7158->data[8] = (Object)closure7158;
  Method *meth_meth_ast_shallowCopy7158 = addmethod2pos(obj7108, "shallowCopy", &meth_ast_shallowCopy7158, 8);
  int argcv_meth_ast_shallowCopy7158[] = {0};
  meth_meth_ast_shallowCopy7158->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7158);
  meth_meth_ast_shallowCopy7158->definitionModule = modulename;
  meth_meth_ast_shallowCopy7158->definitionLine = 1783;
// method "statementName"
  struct UserObject *uo7165 = (struct UserObject*)obj7108;
  uo7165->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName7165 = addmethod2pos(obj7108, "statementName", &meth_ast_statementName7165, 9);
  int argcv_meth_ast_statementName7165[] = {0};
  meth_meth_ast_statementName7165->type = alloc_MethodType(1, argcv_meth_ast_statementName7165);
  meth_meth_ast_statementName7165->definitionModule = modulename;
  meth_meth_ast_statementName7165->definitionLine = 1786;
  sourceObject = obj7108;
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7167 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7168 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7169 = gc_frame_new();
// call case 3: self.outer request
  Object call7170 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7169);
// compiled call node returning call7170 (depth = 7)
// compiled member node returning call7170 (depth = 6)
  partcv[0] = 0;
  Object call7171 = callmethodflags(call7170, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7168);
// compiled call node returning call7171 (depth = 5)
// compiled member node returning call7171 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7172 = callmethodflags(call7171, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7167);
// compiled call node returning call7172 (depth = 3)
  struct UserObject *obj7108_uo = (struct UserObject *)obj7108;
  obj7108_uo->super = call7172;
  sourceObject = obj7108;
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7173 == NULL) {
    strlit7173 = alloc_String("num");
    gc_root(strlit7173);
  }
// compiled string node returning strlit7173 (depth = 3)
  adddatum2(obj7108, strlit7173, 1);
  sourceObject = obj7108;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7108, *var_val, 2);
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  sourceObject = obj7108;
  objclass7108 = obj7108->class;
  objclass7108->definitionModule = modulename;
  objclass7108->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter7108;
  self = oldself7108;
  selfslot = oldselfslot7108;
  stackframe = oldstackframe7108;
  gc_frame_end(frame);
  return obj7108;
}
Object meth_ast_numNode7175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_isSimple7185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSimple");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSimple (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isSimple");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7186 = alloc_Boolean(0);
// compiled identifier node returning bool7186 (depth = 3)
  gc_frame_end(frame);
  return bool7186;
}
Object meth_ast_nameString7187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7189 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7188);
// compiled call node returning call7189 (depth = 4)
// compiled member node returning call7189 (depth = 3)
  gc_frame_end(frame);
  return call7189;
}
Object meth_ast_accept_40__41_from7190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7192 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7193 = callmethod(*var_visitor, "visitOp()up",
    2, partcv, params);
  gc_frame_end(callframe7192);
// compiled call node returning call7193 (depth = 4)
  Object if7191 = done;
  if (istrue(call7193)) {
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7194 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7195 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7194);
// compiled call node returning call7195 (depth = 5)
  *var_newChain = call7195;
  if (call7195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7196 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7198 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7197);
// compiled call node returning call7198 (depth = 6)
// compiled member node returning call7198 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7199 = callmethod(call7198, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7196);
// compiled call node returning call7199 (depth = 4)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7200 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7202 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7201);
// compiled call node returning call7202 (depth = 6)
// compiled member node returning call7202 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7203 = callmethod(call7202, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7200);
// compiled call node returning call7203 (depth = 4)
    gc_frame_newslot(call7203);
    if7191 = call7203;
  } else {
  }
// compiled if node returning if7191 (depth = 3)
  gc_frame_end(frame);
  return if7191;
}
Object meth_ast_map_40__41_ancestors7204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7206 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7205);
// compiled call node returning call7206 (depth = 5)
// compiled member node returning call7206 (depth = 4)
  *var_n = call7206;
  if (call7206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7208 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7207);
// compiled call node returning call7208 (depth = 4)
  *var_newChain = call7208;
  if (call7208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7209 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7210 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7212 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7211);
// compiled call node returning call7212 (depth = 6)
// compiled member node returning call7212 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7213 = callmethod(call7212, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7210);
// compiled call node returning call7213 (depth = 4)
  gc_frame_newslot(call7213);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7213;
  partcv[0] = 1;
  Object call7214 = callmethod(*var_n, "left:=",
    1, partcv, params);
  gc_frame_end(callframe7209);
// compiled call node returning call7214 (depth = 3)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7215 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7216 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7218 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7217);
// compiled call node returning call7218 (depth = 6)
// compiled member node returning call7218 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7219 = callmethod(call7218, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7216);
// compiled call node returning call7219 (depth = 4)
  gc_frame_newslot(call7219);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7219;
  partcv[0] = 1;
  Object call7220 = callmethod(*var_n, "right:=",
    1, partcv, params);
  gc_frame_end(callframe7215);
// compiled call node returning call7220 (depth = 3)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7221 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7222 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7221);
// compiled call node returning call7222 (depth = 3)
  gc_frame_end(frame);
  return call7222;
}
Object meth_ast__apply7231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7233 == NULL) {
    strlit7233 = alloc_String("  ");
    gc_root(strlit7233);
  }
// compiled string node returning strlit7233 (depth = 7)
  int op_slot_right_7232 = gc_frame_newslot(strlit7233);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7232 = gc_frame_newslot(*var_spc);
  params[0] = strlit7233;
  partcv[0] = 1;
  Object opresult7235 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7235 (depth = 6)
  *var_spc = opresult7235;
  if (opresult7235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7223(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7224 == NULL) {
    strlit7224 = alloc_String("");
    gc_root(strlit7224);
  }
// compiled string node returning strlit7224 (depth = 4)
  *var_spc = strlit7224;
  if (strlit7224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7225 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7226 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7228 = alloc_Float64(0);
// compiled num node returning num7228 (depth = 5)
  int op_slot_left_7226 = gc_frame_newslot(num7228);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7229 = callmethod(num7228, "..", 1, partcv, params);
// compiled op node returning opresult7229 (depth = 4)
  gc_frame_newslot(opresult7229);
// starting to compile block node (depth = 4)
  Object block7230 = alloc_Block(NULL, NULL, "ast", 1814);
  gc_frame_newslot(block7230);
// method "_apply"
  block_savedest(block7230);
  Object closure7231 = createclosure(2, "_apply");
  setclosureframe(closure7231, stackframe);
  addtoclosure(closure7231, var_spc);
  addtoclosure(closure7231, selfslot);
  struct UserObject *uo7231 = (struct UserObject*)block7230;
  uo7231->data[0] = (Object)closure7231;
  Method *meth_meth_ast__apply7231 = addmethod2pos(block7230, "_apply", &meth_ast__apply7231, 0);
  int argcv_meth_ast__apply7231[] = {1};
  meth_meth_ast__apply7231->type = alloc_MethodType(1, argcv_meth_ast__apply7231);
  meth_meth_ast__apply7231->definitionModule = modulename;
  meth_meth_ast__apply7231->definitionLine = 1809;
// compiled block node returning block7230 (depth = 4)
  gc_frame_newslot(block7230);
// call case 5: prelude request
  params[0] = opresult7229;
  params[1] = block7230;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7238 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7225);
// compiled call node returning call7238 (depth = 3)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7240 == NULL) {
    strlit7240 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7240);
  }
// compiled string node returning strlit7240 (depth = 5)
  int op_slot_right_7239 = gc_frame_newslot(strlit7240);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7243 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7244 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7243);
// compiled call node returning call7244 (depth = 7)
// compiled member node returning call7244 (depth = 6)
  int op_slot_right_7242 = gc_frame_newslot(call7244);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7247 == NULL) {
    strlit7247 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7247);
  }
// compiled string node returning strlit7247 (depth = 7)
  int op_slot_right_7246 = gc_frame_newslot(strlit7247);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7250 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7251 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7250);
// compiled call node returning call7251 (depth = 8)
  int op_slot_right_7249 = gc_frame_newslot(call7251);
// starting to compile string node (depth = 8)
  if (strlit7253 == NULL) {
    strlit7253 = alloc_String("");
    gc_root(strlit7253);
  }
// compiled string node returning strlit7253 (depth = 8)
  int op_slot_left_7249 = gc_frame_newslot(strlit7253);
  params[0] = call7251;
  partcv[0] = 1;
  Object opresult7254 = callmethod(strlit7253, "++", 1, partcv, params);
// compiled op node returning opresult7254 (depth = 7)
  int op_slot_left_7246 = gc_frame_newslot(opresult7254);
  params[0] = strlit7247;
  partcv[0] = 1;
  Object opresult7255 = callmethod(opresult7254, "++", 1, partcv, params);
// compiled op node returning opresult7255 (depth = 6)
  int op_slot_left_7242 = gc_frame_newslot(opresult7255);
  params[0] = call7244;
  partcv[0] = 1;
  Object opresult7256 = callmethod(opresult7255, "++", 1, partcv, params);
// compiled op node returning opresult7256 (depth = 5)
  int op_slot_left_7239 = gc_frame_newslot(opresult7256);
  params[0] = strlit7240;
  partcv[0] = 1;
  Object opresult7257 = callmethod(opresult7256, "++", 1, partcv, params);
// compiled op node returning opresult7257 (depth = 4)
  *var_s = opresult7257;
  if (opresult7257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7259 == NULL) {
    strlit7259 = alloc_String("""\x0a""");
    gc_root(strlit7259);
  }
// compiled string node returning strlit7259 (depth = 5)
  int op_slot_right_7258 = gc_frame_newslot(strlit7259);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7258 = gc_frame_newslot(*var_s);
  params[0] = strlit7259;
  partcv[0] = 1;
  Object opresult7261 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7261 (depth = 4)
  *var_s = opresult7261;
  if (opresult7261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7264 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7266 = alloc_Float64(1);
// compiled num node returning num7266 (depth = 7)
  int op_slot_right_7265 = gc_frame_newslot(num7266);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7265 = gc_frame_newslot(*var_depth);
  params[0] = num7266;
  partcv[0] = 1;
  Object sum7268 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7268 (depth = 6)
  gc_frame_newslot(sum7268);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7269 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7270 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7269);
// compiled call node returning call7270 (depth = 7)
// compiled member node returning call7270 (depth = 6)
  params[0] = sum7268;
  partcv[0] = 1;
  Object call7271 = callmethod(call7270, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7264);
// compiled call node returning call7271 (depth = 5)
  int op_slot_right_7263 = gc_frame_newslot(call7271);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7273 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7273 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7275 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7275 (depth = 5)
  int op_slot_left_7263 = gc_frame_newslot(opresult7275);
  params[0] = call7271;
  partcv[0] = 1;
  Object opresult7276 = callmethod(opresult7275, "++", 1, partcv, params);
// compiled op node returning opresult7276 (depth = 4)
  *var_s = opresult7276;
  if (opresult7276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7279 == NULL) {
    strlit7279 = alloc_String("""\x0a""");
    gc_root(strlit7279);
  }
// compiled string node returning strlit7279 (depth = 5)
  int op_slot_right_7278 = gc_frame_newslot(strlit7279);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7278 = gc_frame_newslot(*var_s);
  params[0] = strlit7279;
  partcv[0] = 1;
  Object opresult7281 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7281 (depth = 4)
  *var_s = opresult7281;
  if (opresult7281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7284 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7286 = alloc_Float64(1);
// compiled num node returning num7286 (depth = 7)
  int op_slot_right_7285 = gc_frame_newslot(num7286);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7285 = gc_frame_newslot(*var_depth);
  params[0] = num7286;
  partcv[0] = 1;
  Object sum7288 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7288 (depth = 6)
  gc_frame_newslot(sum7288);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7289 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7290 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7289);
// compiled call node returning call7290 (depth = 7)
// compiled member node returning call7290 (depth = 6)
  params[0] = sum7288;
  partcv[0] = 1;
  Object call7291 = callmethod(call7290, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7284);
// compiled call node returning call7291 (depth = 5)
  int op_slot_right_7283 = gc_frame_newslot(call7291);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7293 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7293 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7295 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7295 (depth = 5)
  int op_slot_left_7283 = gc_frame_newslot(opresult7295);
  params[0] = call7291;
  partcv[0] = 1;
  Object opresult7296 = callmethod(opresult7295, "++", 1, partcv, params);
// compiled op node returning opresult7296 (depth = 4)
  *var_s = opresult7296;
  if (opresult7296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7299 == NULL) {
    strlit7299 = alloc_String("");
    gc_root(strlit7299);
  }
// compiled string node returning strlit7299 (depth = 4)
  *var_s = strlit7299;
  if (strlit7299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7304 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7303);
// compiled call node returning call7304 (depth = 7)
// compiled member node returning call7304 (depth = 6)
  int op_slot_right_7302 = gc_frame_newslot(call7304);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7306 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7307 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7308 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7307);
// compiled call node returning call7308 (depth = 9)
// compiled member node returning call7308 (depth = 8)
  partcv[0] = 0;
  Object call7309 = callmethod(call7308, "value",
    1, partcv, params);
  gc_frame_end(callframe7306);
// compiled call node returning call7309 (depth = 7)
// compiled member node returning call7309 (depth = 6)
  int op_slot_left_7302 = gc_frame_newslot(call7309);
  params[0] = call7304;
  partcv[0] = 1;
  Object opresult7310 = callmethod(call7309, "≠", 1, partcv, params);
// compiled op node returning opresult7310 (depth = 5)
  int op_slot_right_7301 = gc_frame_newslot(opresult7310);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7313 == NULL) {
    strlit7313 = alloc_String("op");
    gc_root(strlit7313);
  }
// compiled string node returning strlit7313 (depth = 6)
  int op_slot_right_7312 = gc_frame_newslot(strlit7313);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7315 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7317 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7316);
// compiled call node returning call7317 (depth = 9)
// compiled member node returning call7317 (depth = 8)
  partcv[0] = 0;
  Object call7318 = callmethod(call7317, "kind",
    1, partcv, params);
  gc_frame_end(callframe7315);
// compiled call node returning call7318 (depth = 7)
// compiled member node returning call7318 (depth = 6)
  int op_slot_left_7312 = gc_frame_newslot(call7318);
  params[0] = strlit7313;
  partcv[0] = 1;
  Object opresult7319 = callmethod(call7318, "==", 1, partcv, params);
// compiled op node returning opresult7319 (depth = 5)
  int op_slot_left_7301 = gc_frame_newslot(opresult7319);
  params[0] = opresult7310;
  partcv[0] = 1;
  Object opresult7320 = callmethod(opresult7319, "&&", 1, partcv, params);
// compiled op node returning opresult7320 (depth = 4)
  Object if7300 = done;
  if (istrue(opresult7320)) {
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7322 == NULL) {
    strlit7322 = alloc_String(")");
    gc_root(strlit7322);
  }
// compiled string node returning strlit7322 (depth = 6)
  int op_slot_right_7321 = gc_frame_newslot(strlit7322);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7325 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7326 = alloc_Float64(0);
// compiled num node returning num7326 (depth = 8)
  gc_frame_newslot(num7326);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7328 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 9)
// compiled member node returning call7328 (depth = 8)
  params[0] = num7326;
  partcv[0] = 1;
  Object call7329 = callmethod(call7328, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7325);
// compiled call node returning call7329 (depth = 7)
  int op_slot_right_7324 = gc_frame_newslot(call7329);
// starting to compile string node (depth = 7)
  if (strlit7331 == NULL) {
    strlit7331 = alloc_String("(");
    gc_root(strlit7331);
  }
// compiled string node returning strlit7331 (depth = 7)
  int op_slot_left_7324 = gc_frame_newslot(strlit7331);
  params[0] = call7329;
  partcv[0] = 1;
  Object opresult7332 = callmethod(strlit7331, "++", 1, partcv, params);
// compiled op node returning opresult7332 (depth = 6)
  int op_slot_left_7321 = gc_frame_newslot(opresult7332);
  params[0] = strlit7322;
  partcv[0] = 1;
  Object opresult7333 = callmethod(opresult7332, "++", 1, partcv, params);
// compiled op node returning opresult7333 (depth = 5)
  *var_s = opresult7333;
  if (opresult7333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7300 = done;
  } else {
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7335 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num7336 = alloc_Float64(0);
// compiled num node returning num7336 (depth = 6)
  gc_frame_newslot(num7336);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7338 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7337);
// compiled call node returning call7338 (depth = 7)
// compiled member node returning call7338 (depth = 6)
  params[0] = num7336;
  partcv[0] = 1;
  Object call7339 = callmethod(call7338, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7335);
// compiled call node returning call7339 (depth = 5)
  *var_s = call7339;
  if (call7339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7300 = done;
  }
// compiled if node returning if7300 (depth = 3)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7343 == NULL) {
    strlit7343 = alloc_String("..");
    gc_root(strlit7343);
  }
// compiled string node returning strlit7343 (depth = 5)
  int op_slot_right_7342 = gc_frame_newslot(strlit7343);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7345 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7346 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7345);
// compiled call node returning call7346 (depth = 6)
// compiled member node returning call7346 (depth = 5)
  int op_slot_left_7342 = gc_frame_newslot(call7346);
  params[0] = strlit7343;
  partcv[0] = 1;
  Object opresult7347 = callmethod(call7346, "==", 1, partcv, params);
// compiled op node returning opresult7347 (depth = 4)
  Object if7341 = done;
  if (istrue(opresult7347)) {
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7350 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7349);
// compiled call node returning call7350 (depth = 7)
// compiled member node returning call7350 (depth = 6)
  int op_slot_right_7348 = gc_frame_newslot(call7350);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7348 = gc_frame_newslot(*var_s);
  params[0] = call7350;
  partcv[0] = 1;
  Object opresult7352 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7352 (depth = 5)
  *var_s = opresult7352;
  if (opresult7352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7341 = done;
  } else {
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7355 == NULL) {
    strlit7355 = alloc_String(" ");
    gc_root(strlit7355);
  }
// compiled string node returning strlit7355 (depth = 6)
  int op_slot_right_7354 = gc_frame_newslot(strlit7355);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7359 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7358);
// compiled call node returning call7359 (depth = 8)
// compiled member node returning call7359 (depth = 7)
  int op_slot_right_7357 = gc_frame_newslot(call7359);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7362 == NULL) {
    strlit7362 = alloc_String(" ");
    gc_root(strlit7362);
  }
// compiled string node returning strlit7362 (depth = 8)
  int op_slot_right_7361 = gc_frame_newslot(strlit7362);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7361 = gc_frame_newslot(*var_s);
  params[0] = strlit7362;
  partcv[0] = 1;
  Object opresult7364 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7364 (depth = 7)
  int op_slot_left_7357 = gc_frame_newslot(opresult7364);
  params[0] = call7359;
  partcv[0] = 1;
  Object opresult7365 = callmethod(opresult7364, "++", 1, partcv, params);
// compiled op node returning opresult7365 (depth = 6)
  int op_slot_left_7354 = gc_frame_newslot(opresult7365);
  params[0] = strlit7355;
  partcv[0] = 1;
  Object opresult7366 = callmethod(opresult7365, "++", 1, partcv, params);
// compiled op node returning opresult7366 (depth = 5)
  *var_s = opresult7366;
  if (opresult7366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7341 = done;
  }
// compiled if node returning if7341 (depth = 3)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7372 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7371);
// compiled call node returning call7372 (depth = 7)
// compiled member node returning call7372 (depth = 6)
  int op_slot_right_7370 = gc_frame_newslot(call7372);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7374 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7376 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7375);
// compiled call node returning call7376 (depth = 9)
// compiled member node returning call7376 (depth = 8)
  partcv[0] = 0;
  Object call7377 = callmethod(call7376, "value",
    1, partcv, params);
  gc_frame_end(callframe7374);
// compiled call node returning call7377 (depth = 7)
// compiled member node returning call7377 (depth = 6)
  int op_slot_left_7370 = gc_frame_newslot(call7377);
  params[0] = call7372;
  partcv[0] = 1;
  Object opresult7378 = callmethod(call7377, "≠", 1, partcv, params);
// compiled op node returning opresult7378 (depth = 5)
  int op_slot_right_7369 = gc_frame_newslot(opresult7378);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7381 == NULL) {
    strlit7381 = alloc_String("op");
    gc_root(strlit7381);
  }
// compiled string node returning strlit7381 (depth = 6)
  int op_slot_right_7380 = gc_frame_newslot(strlit7381);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7383 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7385 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7384);
// compiled call node returning call7385 (depth = 9)
// compiled member node returning call7385 (depth = 8)
  partcv[0] = 0;
  Object call7386 = callmethod(call7385, "kind",
    1, partcv, params);
  gc_frame_end(callframe7383);
// compiled call node returning call7386 (depth = 7)
// compiled member node returning call7386 (depth = 6)
  int op_slot_left_7380 = gc_frame_newslot(call7386);
  params[0] = strlit7381;
  partcv[0] = 1;
  Object opresult7387 = callmethod(call7386, "==", 1, partcv, params);
// compiled op node returning opresult7387 (depth = 5)
  int op_slot_left_7369 = gc_frame_newslot(opresult7387);
  params[0] = opresult7378;
  partcv[0] = 1;
  Object opresult7388 = callmethod(opresult7387, "&&", 1, partcv, params);
// compiled op node returning opresult7388 (depth = 4)
  Object if7368 = done;
  if (istrue(opresult7388)) {
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7390 == NULL) {
    strlit7390 = alloc_String(")");
    gc_root(strlit7390);
  }
// compiled string node returning strlit7390 (depth = 6)
  int op_slot_right_7389 = gc_frame_newslot(strlit7390);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7393 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7394 = alloc_Float64(0);
// compiled num node returning num7394 (depth = 8)
  gc_frame_newslot(num7394);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7396 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7395);
// compiled call node returning call7396 (depth = 9)
// compiled member node returning call7396 (depth = 8)
  params[0] = num7394;
  partcv[0] = 1;
  Object call7397 = callmethod(call7396, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7393);
// compiled call node returning call7397 (depth = 7)
  int op_slot_right_7392 = gc_frame_newslot(call7397);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7400 == NULL) {
    strlit7400 = alloc_String("(");
    gc_root(strlit7400);
  }
// compiled string node returning strlit7400 (depth = 8)
  int op_slot_right_7399 = gc_frame_newslot(strlit7400);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7399 = gc_frame_newslot(*var_s);
  params[0] = strlit7400;
  partcv[0] = 1;
  Object opresult7402 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7402 (depth = 7)
  int op_slot_left_7392 = gc_frame_newslot(opresult7402);
  params[0] = call7397;
  partcv[0] = 1;
  Object opresult7403 = callmethod(opresult7402, "++", 1, partcv, params);
// compiled op node returning opresult7403 (depth = 6)
  int op_slot_left_7389 = gc_frame_newslot(opresult7403);
  params[0] = strlit7390;
  partcv[0] = 1;
  Object opresult7404 = callmethod(opresult7403, "++", 1, partcv, params);
// compiled op node returning opresult7404 (depth = 5)
  *var_s = opresult7404;
  if (opresult7404 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7368 = done;
  } else {
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7407 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7408 = alloc_Float64(0);
// compiled num node returning num7408 (depth = 7)
  gc_frame_newslot(num7408);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7409 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7410 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7409);
// compiled call node returning call7410 (depth = 8)
// compiled member node returning call7410 (depth = 7)
  params[0] = num7408;
  partcv[0] = 1;
  Object call7411 = callmethod(call7410, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7407);
// compiled call node returning call7411 (depth = 6)
  int op_slot_right_7406 = gc_frame_newslot(call7411);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7406 = gc_frame_newslot(*var_s);
  params[0] = call7411;
  partcv[0] = 1;
  Object opresult7413 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7413 (depth = 5)
  *var_s = opresult7413;
  if (opresult7413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7368 = done;
  }
// compiled if node returning if7368 (depth = 3)
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier7415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7416 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7417 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7418 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7417);
// compiled call node returning call7418 (depth = 6)
// compiled member node returning call7418 (depth = 5)
  gc_frame_newslot(call7418);
// starting to compile identifier node (depth = 5)
  Object bool7419 = alloc_Boolean(0);
// compiled identifier node returning bool7419 (depth = 5)
  gc_frame_newslot(bool7419);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7421 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7420);
// compiled call node returning call7421 (depth = 6)
// compiled member node returning call7421 (depth = 5)
  gc_frame_newslot(call7421);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_identifierNode (depth = 5)
  params[0] = call7418;
  params[1] = bool7419;
  params[2] = call7421;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7422 = callmethod(*var_identifierNode, "new()scope",
    2, partcv, params);
  gc_frame_end(callframe7416);
// compiled call node returning call7422 (depth = 4)
  *var_resultNode = call7422;
  if (call7422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7423 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7424 = alloc_Boolean(1);
// compiled identifier node returning bool7424 (depth = 4)
  gc_frame_newslot(bool7424);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = bool7424;
  partcv[0] = 1;
  Object call7425 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe7423);
// compiled call node returning call7425 (depth = 3)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7426 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7428 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7427);
// compiled call node returning call7428 (depth = 5)
// compiled member node returning call7428 (depth = 4)
  gc_frame_newslot(call7428);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7428;
  partcv[0] = 1;
  Object call7429 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7426);
// compiled call node returning call7429 (depth = 3)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7430 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7431 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7432 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7431);
// compiled call node returning call7432 (depth = 5)
// compiled member node returning call7432 (depth = 4)
  gc_frame_newslot(call7432);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  params[0] = call7432;
  partcv[0] = 1;
  Object call7433 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7430);
// compiled call node returning call7433 (depth = 3)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_resultNode (depth = 4)
  return *var_resultNode;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopy7434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7435 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7436 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7438 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7437);
// compiled call node returning call7438 (depth = 6)
// compiled member node returning call7438 (depth = 5)
  gc_frame_newslot(call7438);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opNode (depth = 5)
  params[0] = call7438;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call7439 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7436);
// compiled call node returning call7439 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7440 = callmethod(call7439, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7435);
// compiled call node returning call7440 (depth = 3)
  gc_frame_end(frame);
  return call7440;
}
Object meth_ast_new7178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7179 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7179 = alloc_userobj2(14,13, objclass7179);
  gc_frame_newslot(obj7179);
if (objclass7179 == NULL) {
  glfree(obj7179->class->name);
  obj7179->class->name = "opNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7179, self, 0);
  addmethodreal(obj7179,"outer", &reader_ast_outer_7180);
  Object oldself7179 = self;
  struct StackFrameObject *oldstackframe7179 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7179);
  gc_frame_newslot((Object)stackframe);
  self = obj7179;
  Object *oldselfslot7179 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7179 = (*(struct UserObject *)self).data[0], lowerouter7179 = thisouter7179;
  if (inheritingObject7179) {
    struct UserObject *inho7179 = (struct UserObject *)inheritingObject7179;
    while (inho7179->super != GraceDefaultObject) inho7179 = (struct UserObject *)inho7179->super;
    inho7179->super = obj7179;
    self = inheritingObject7179;
    *selfslot = self;
    lowerouter7179 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7179;
  }
if (objclass7179 == NULL) {
  Method *reader7181 = addmethodrealflags(obj7179, "kind",&reader_ast_kind_7181, MFLAG_DEF);
  reader7181->definitionModule = modulename;
  reader7181->definitionLine = 1792;
}
adddatum2(obj7179, alloc_Undefined(), 1);
if (objclass7179 == NULL) {
  Method *reader7182 = addmethodrealflags(obj7179, "value",&reader_ast_value_7182, MFLAG_DEF);
  reader7182->definitionModule = modulename;
  reader7182->definitionLine = 1793;
}
adddatum2(obj7179, alloc_Undefined(), 2);
if (objclass7179 == NULL) {
  Method *reader7183 = addmethodrealflags(obj7179, "left",&reader_ast_left_7183, 0);
  Method *writer7183 = addmethodrealflags(obj7179, "left:=",&writer_ast_left_7183, 0);
  reader7183->definitionModule = modulename;
  writer7183->definitionModule = modulename;
  reader7183->definitionLine = 1794;
  writer7183->definitionLine = 1794;
}
obj7179->flags |= OFLAG_MUTABLE;
adddatum2(obj7179, alloc_Undefined(), 3);
if (objclass7179 == NULL) {
  Method *reader7184 = addmethodrealflags(obj7179, "right",&reader_ast_right_7184, 0);
  Method *writer7184 = addmethodrealflags(obj7179, "right:=",&writer_ast_right_7184, 0);
  reader7184->definitionModule = modulename;
  writer7184->definitionModule = modulename;
  reader7184->definitionLine = 1795;
  writer7184->definitionLine = 1795;
}
obj7179->flags |= OFLAG_MUTABLE;
adddatum2(obj7179, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7185 = (struct UserObject*)obj7179;
  uo7185->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7185 = addmethod2pos(obj7179, "isSimple", &meth_ast_isSimple7185, 5);
  int argcv_meth_ast_isSimple7185[] = {0};
  meth_meth_ast_isSimple7185->type = alloc_MethodType(1, argcv_meth_ast_isSimple7185);
  meth_meth_ast_isSimple7185->definitionModule = modulename;
  meth_meth_ast_isSimple7185->definitionLine = 1796;
// method "nameString"
  struct UserObject *uo7187 = (struct UserObject*)obj7179;
  uo7187->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7187 = addmethod2pos(obj7179, "nameString", &meth_ast_nameString7187, 6);
  int argcv_meth_ast_nameString7187[] = {0};
  meth_meth_ast_nameString7187->type = alloc_MethodType(1, argcv_meth_ast_nameString7187);
  meth_meth_ast_nameString7187->definitionModule = modulename;
  meth_meth_ast_nameString7187->definitionLine = 1797;
// method "accept()from"
  struct UserObject *uo7190 = (struct UserObject*)obj7179;
  uo7190->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7190 = addmethod2pos(obj7179, "accept()from", &meth_ast_accept_40__41_from7190, 7);
  int argcv_meth_ast_accept_40__41_from7190[] = {1, 1};
  meth_meth_ast_accept_40__41_from7190->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7190);
  meth_meth_ast_accept_40__41_from7190->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7190->definitionLine = 1798;
// method "map()ancestors"
  struct UserObject *uo7204 = (struct UserObject*)obj7179;
  uo7204->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7204 = addmethod2pos(obj7179, "map()ancestors", &meth_ast_map_40__41_ancestors7204, 8);
  int argcv_meth_ast_map_40__41_ancestors7204[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7204->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7204);
  meth_meth_ast_map_40__41_ancestors7204->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7204->definitionLine = 1805;
// method "pretty"
  struct UserObject *uo7223 = (struct UserObject*)obj7179;
  uo7223->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7223 = addmethod2pos(obj7179, "pretty", &meth_ast_pretty7223, 9);
  int argcv_meth_ast_pretty7223[] = {1};
  meth_meth_ast_pretty7223->type = alloc_MethodType(1, argcv_meth_ast_pretty7223);
  meth_meth_ast_pretty7223->definitionModule = modulename;
  meth_meth_ast_pretty7223->definitionLine = 1812;
// method "toGrace"
  struct UserObject *uo7298 = (struct UserObject*)obj7179;
  uo7298->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7298 = addmethod2pos(obj7179, "toGrace", &meth_ast_toGrace7298, 10);
  int argcv_meth_ast_toGrace7298[] = {1};
  meth_meth_ast_toGrace7298->type = alloc_MethodType(1, argcv_meth_ast_toGrace7298);
meth_meth_ast_toGrace7298->type->types[0] = type_Number;
meth_meth_ast_toGrace7298->type->names[0] = "depth";
  meth_meth_ast_toGrace7298->definitionModule = modulename;
  meth_meth_ast_toGrace7298->definitionLine = 1824;
// method "asIdentifier"
  block_savedest(obj7179);
  Object closure7415 = createclosure(1, "asIdentifier");
  setclosureframe(closure7415, stackframe);
  addtoclosure(closure7415, var_identifierNode);
  struct UserObject *uo7415 = (struct UserObject*)obj7179;
  uo7415->data[11] = (Object)closure7415;
  Method *meth_meth_ast_asIdentifier7415 = addmethod2pos(obj7179, "asIdentifier", &meth_ast_asIdentifier7415, 11);
  int argcv_meth_ast_asIdentifier7415[] = {0};
  meth_meth_ast_asIdentifier7415->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7415);
  meth_meth_ast_asIdentifier7415->definitionModule = modulename;
  meth_meth_ast_asIdentifier7415->definitionLine = 1843;
// method "shallowCopy"
  block_savedest(obj7179);
  Object closure7434 = createclosure(2, "shallowCopy");
  setclosureframe(closure7434, stackframe);
  addtoclosure(closure7434, var_nullNode);
  addtoclosure(closure7434, var_opNode);
  struct UserObject *uo7434 = (struct UserObject*)obj7179;
  uo7434->data[12] = (Object)closure7434;
  Method *meth_meth_ast_shallowCopy7434 = addmethod2pos(obj7179, "shallowCopy", &meth_ast_shallowCopy7434, 12);
  int argcv_meth_ast_shallowCopy7434[] = {0};
  meth_meth_ast_shallowCopy7434->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7434);
  meth_meth_ast_shallowCopy7434->definitionModule = modulename;
  meth_meth_ast_shallowCopy7434->definitionLine = 1851;
  sourceObject = obj7179;
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7441 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7442 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7443 = gc_frame_new();
// call case 3: self.outer request
  Object call7444 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7443);
// compiled call node returning call7444 (depth = 7)
// compiled member node returning call7444 (depth = 6)
  partcv[0] = 0;
  Object call7445 = callmethodflags(call7444, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7442);
// compiled call node returning call7445 (depth = 5)
// compiled member node returning call7445 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7446 = callmethodflags(call7445, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7441);
// compiled call node returning call7446 (depth = 3)
  struct UserObject *obj7179_uo = (struct UserObject *)obj7179;
  obj7179_uo->super = call7446;
  sourceObject = obj7179;
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7447 == NULL) {
    strlit7447 = alloc_String("op");
    gc_root(strlit7447);
  }
// compiled string node returning strlit7447 (depth = 3)
  adddatum2(obj7179, strlit7447, 1);
  sourceObject = obj7179;
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7179, *var_op, 2);
  sourceObject = obj7179;
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7179, *var_l, 3);
  sourceObject = obj7179;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7179, *var_r, 4);
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  objclass7179 = obj7179->class;
  objclass7179->definitionModule = modulename;
  objclass7179->definitionLine = 1790;
  (*(struct UserObject *)self).data[0] = lowerouter7179;
  self = oldself7179;
  selfslot = oldselfslot7179;
  stackframe = oldstackframe7179;
  gc_frame_end(frame);
  return obj7179;
}
Object meth_ast_new7178_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7179 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7179 = alloc_userobj2(14,13, objclass7179);
  gc_frame_newslot(obj7179);
if (objclass7179 == NULL) {
  glfree(obj7179->class->name);
  obj7179->class->name = "opNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7179, self, 0);
  addmethodreal(obj7179,"outer", &reader_ast_outer_7180);
  Object oldself7179 = self;
  struct StackFrameObject *oldstackframe7179 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7179);
  gc_frame_newslot((Object)stackframe);
  self = obj7179;
  Object *oldselfslot7179 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7179 = (*(struct UserObject *)self).data[0], lowerouter7179 = thisouter7179;
  if (inheritingObject7179) {
    struct UserObject *inho7179 = (struct UserObject *)inheritingObject7179;
    while (inho7179->super != GraceDefaultObject) inho7179 = (struct UserObject *)inho7179->super;
    inho7179->super = obj7179;
    self = inheritingObject7179;
    *selfslot = self;
    lowerouter7179 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7179;
  }
if (objclass7179 == NULL) {
  Method *reader7181 = addmethodrealflags(obj7179, "kind",&reader_ast_kind_7181, MFLAG_DEF);
  reader7181->definitionModule = modulename;
  reader7181->definitionLine = 1792;
}
adddatum2(obj7179, alloc_Undefined(), 1);
if (objclass7179 == NULL) {
  Method *reader7182 = addmethodrealflags(obj7179, "value",&reader_ast_value_7182, MFLAG_DEF);
  reader7182->definitionModule = modulename;
  reader7182->definitionLine = 1793;
}
adddatum2(obj7179, alloc_Undefined(), 2);
if (objclass7179 == NULL) {
  Method *reader7183 = addmethodrealflags(obj7179, "left",&reader_ast_left_7183, 0);
  Method *writer7183 = addmethodrealflags(obj7179, "left:=",&writer_ast_left_7183, 0);
  reader7183->definitionModule = modulename;
  writer7183->definitionModule = modulename;
  reader7183->definitionLine = 1794;
  writer7183->definitionLine = 1794;
}
obj7179->flags |= OFLAG_MUTABLE;
adddatum2(obj7179, alloc_Undefined(), 3);
if (objclass7179 == NULL) {
  Method *reader7184 = addmethodrealflags(obj7179, "right",&reader_ast_right_7184, 0);
  Method *writer7184 = addmethodrealflags(obj7179, "right:=",&writer_ast_right_7184, 0);
  reader7184->definitionModule = modulename;
  writer7184->definitionModule = modulename;
  reader7184->definitionLine = 1795;
  writer7184->definitionLine = 1795;
}
obj7179->flags |= OFLAG_MUTABLE;
adddatum2(obj7179, alloc_Undefined(), 4);
// method "isSimple"
  struct UserObject *uo7185 = (struct UserObject*)obj7179;
  uo7185->data[5] = emptyclosure;
  Method *meth_meth_ast_isSimple7185 = addmethod2pos(obj7179, "isSimple", &meth_ast_isSimple7185, 5);
  int argcv_meth_ast_isSimple7185[] = {0};
  meth_meth_ast_isSimple7185->type = alloc_MethodType(1, argcv_meth_ast_isSimple7185);
  meth_meth_ast_isSimple7185->definitionModule = modulename;
  meth_meth_ast_isSimple7185->definitionLine = 1796;
// method "nameString"
  struct UserObject *uo7187 = (struct UserObject*)obj7179;
  uo7187->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString7187 = addmethod2pos(obj7179, "nameString", &meth_ast_nameString7187, 6);
  int argcv_meth_ast_nameString7187[] = {0};
  meth_meth_ast_nameString7187->type = alloc_MethodType(1, argcv_meth_ast_nameString7187);
  meth_meth_ast_nameString7187->definitionModule = modulename;
  meth_meth_ast_nameString7187->definitionLine = 1797;
// method "accept()from"
  struct UserObject *uo7190 = (struct UserObject*)obj7179;
  uo7190->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7190 = addmethod2pos(obj7179, "accept()from", &meth_ast_accept_40__41_from7190, 7);
  int argcv_meth_ast_accept_40__41_from7190[] = {1, 1};
  meth_meth_ast_accept_40__41_from7190->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7190);
  meth_meth_ast_accept_40__41_from7190->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7190->definitionLine = 1798;
// method "map()ancestors"
  struct UserObject *uo7204 = (struct UserObject*)obj7179;
  uo7204->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7204 = addmethod2pos(obj7179, "map()ancestors", &meth_ast_map_40__41_ancestors7204, 8);
  int argcv_meth_ast_map_40__41_ancestors7204[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7204->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7204);
  meth_meth_ast_map_40__41_ancestors7204->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7204->definitionLine = 1805;
// method "pretty"
  struct UserObject *uo7223 = (struct UserObject*)obj7179;
  uo7223->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7223 = addmethod2pos(obj7179, "pretty", &meth_ast_pretty7223, 9);
  int argcv_meth_ast_pretty7223[] = {1};
  meth_meth_ast_pretty7223->type = alloc_MethodType(1, argcv_meth_ast_pretty7223);
  meth_meth_ast_pretty7223->definitionModule = modulename;
  meth_meth_ast_pretty7223->definitionLine = 1812;
// method "toGrace"
  struct UserObject *uo7298 = (struct UserObject*)obj7179;
  uo7298->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7298 = addmethod2pos(obj7179, "toGrace", &meth_ast_toGrace7298, 10);
  int argcv_meth_ast_toGrace7298[] = {1};
  meth_meth_ast_toGrace7298->type = alloc_MethodType(1, argcv_meth_ast_toGrace7298);
meth_meth_ast_toGrace7298->type->types[0] = type_Number;
meth_meth_ast_toGrace7298->type->names[0] = "depth";
  meth_meth_ast_toGrace7298->definitionModule = modulename;
  meth_meth_ast_toGrace7298->definitionLine = 1824;
// method "asIdentifier"
  block_savedest(obj7179);
  Object closure7415 = createclosure(1, "asIdentifier");
  setclosureframe(closure7415, stackframe);
  addtoclosure(closure7415, var_identifierNode);
  struct UserObject *uo7415 = (struct UserObject*)obj7179;
  uo7415->data[11] = (Object)closure7415;
  Method *meth_meth_ast_asIdentifier7415 = addmethod2pos(obj7179, "asIdentifier", &meth_ast_asIdentifier7415, 11);
  int argcv_meth_ast_asIdentifier7415[] = {0};
  meth_meth_ast_asIdentifier7415->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7415);
  meth_meth_ast_asIdentifier7415->definitionModule = modulename;
  meth_meth_ast_asIdentifier7415->definitionLine = 1843;
// method "shallowCopy"
  block_savedest(obj7179);
  Object closure7434 = createclosure(2, "shallowCopy");
  setclosureframe(closure7434, stackframe);
  addtoclosure(closure7434, var_nullNode);
  addtoclosure(closure7434, var_opNode);
  struct UserObject *uo7434 = (struct UserObject*)obj7179;
  uo7434->data[12] = (Object)closure7434;
  Method *meth_meth_ast_shallowCopy7434 = addmethod2pos(obj7179, "shallowCopy", &meth_ast_shallowCopy7434, 12);
  int argcv_meth_ast_shallowCopy7434[] = {0};
  meth_meth_ast_shallowCopy7434->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7434);
  meth_meth_ast_shallowCopy7434->definitionModule = modulename;
  meth_meth_ast_shallowCopy7434->definitionLine = 1851;
  sourceObject = obj7179;
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7441 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7442 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7443 = gc_frame_new();
// call case 3: self.outer request
  Object call7444 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7443);
// compiled call node returning call7444 (depth = 7)
// compiled member node returning call7444 (depth = 6)
  partcv[0] = 0;
  Object call7445 = callmethodflags(call7444, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7442);
// compiled call node returning call7445 (depth = 5)
// compiled member node returning call7445 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7446 = callmethodflags(call7445, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7441);
// compiled call node returning call7446 (depth = 3)
  struct UserObject *obj7179_uo = (struct UserObject *)obj7179;
  obj7179_uo->super = call7446;
  sourceObject = obj7179;
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7447 == NULL) {
    strlit7447 = alloc_String("op");
    gc_root(strlit7447);
  }
// compiled string node returning strlit7447 (depth = 3)
  adddatum2(obj7179, strlit7447, 1);
  sourceObject = obj7179;
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_op (depth = 3)
  adddatum2(obj7179, *var_op, 2);
  sourceObject = obj7179;
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  adddatum2(obj7179, *var_l, 3);
  sourceObject = obj7179;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_r (depth = 3)
  adddatum2(obj7179, *var_r, 4);
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  sourceObject = obj7179;
  objclass7179 = obj7179->class;
  objclass7179->definitionModule = modulename;
  objclass7179->definitionLine = 1790;
  (*(struct UserObject *)self).data[0] = lowerouter7179;
  self = oldself7179;
  selfslot = oldselfslot7179;
  stackframe = oldstackframe7179;
  gc_frame_end(frame);
  return obj7179;
}
Object meth_ast_opNode7449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_isBind7458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7459 = alloc_Boolean(1);
// compiled identifier node returning bool7459 (depth = 3)
  gc_frame_end(frame);
  return bool7459;
}
Object meth_ast_asString7460(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7462 == NULL) {
    strlit7462 = alloc_String("");
    gc_root(strlit7462);
  }
// compiled string node returning strlit7462 (depth = 4)
  int op_slot_right_7461 = gc_frame_newslot(strlit7462);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7466 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7465);
// compiled call node returning call7466 (depth = 6)
// compiled member node returning call7466 (depth = 5)
  int op_slot_right_7464 = gc_frame_newslot(call7466);
// starting to compile string node (depth = 5)
  if (strlit7468 == NULL) {
    strlit7468 = alloc_String("bind ");
    gc_root(strlit7468);
  }
// compiled string node returning strlit7468 (depth = 5)
  int op_slot_left_7464 = gc_frame_newslot(strlit7468);
  params[0] = call7466;
  partcv[0] = 1;
  Object opresult7469 = callmethod(strlit7468, "++", 1, partcv, params);
// compiled op node returning opresult7469 (depth = 4)
  int op_slot_left_7461 = gc_frame_newslot(opresult7469);
  params[0] = strlit7462;
  partcv[0] = 1;
  Object opresult7470 = callmethod(opresult7469, "++", 1, partcv, params);
// compiled op node returning opresult7470 (depth = 3)
  gc_frame_end(frame);
  return opresult7470;
}
Object meth_ast_accept_40__41_from7471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7473 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7474 = callmethod(*var_visitor, "visitBind()up",
    2, partcv, params);
  gc_frame_end(callframe7473);
// compiled call node returning call7474 (depth = 4)
  Object if7472 = done;
  if (istrue(call7474)) {
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7475 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7476 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7475);
// compiled call node returning call7476 (depth = 5)
  *var_newChain = call7476;
  if (call7476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7477 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7479 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7478);
// compiled call node returning call7479 (depth = 6)
// compiled member node returning call7479 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7480 = callmethod(call7479, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7477);
// compiled call node returning call7480 (depth = 4)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7481 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7483 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7482);
// compiled call node returning call7483 (depth = 6)
// compiled member node returning call7483 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7484 = callmethod(call7483, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7481);
// compiled call node returning call7484 (depth = 4)
    gc_frame_newslot(call7484);
    if7472 = call7484;
  } else {
  }
// compiled if node returning if7472 (depth = 3)
  gc_frame_end(frame);
  return if7472;
}
Object meth_ast_map_40__41_ancestors7485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7486 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7487 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7486);
// compiled call node returning call7487 (depth = 5)
// compiled member node returning call7487 (depth = 4)
  *var_n = call7487;
  if (call7487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7488 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7489 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7488);
// compiled call node returning call7489 (depth = 4)
  *var_newChain = call7489;
  if (call7489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7490 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7491 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7493 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7492);
// compiled call node returning call7493 (depth = 6)
// compiled member node returning call7493 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7494 = callmethod(call7493, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7491);
// compiled call node returning call7494 (depth = 4)
  gc_frame_newslot(call7494);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7494;
  partcv[0] = 1;
  Object call7495 = callmethod(*var_n, "dest:=",
    1, partcv, params);
  gc_frame_end(callframe7490);
// compiled call node returning call7495 (depth = 3)
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7496 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7497 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7498 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7499 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7498);
// compiled call node returning call7499 (depth = 6)
// compiled member node returning call7499 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7500 = callmethod(call7499, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7497);
// compiled call node returning call7500 (depth = 4)
  gc_frame_newslot(call7500);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7500;
  partcv[0] = 1;
  Object call7501 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7496);
// compiled call node returning call7501 (depth = 3)
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7502 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7503 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7502);
// compiled call node returning call7503 (depth = 3)
  gc_frame_end(frame);
  return call7503;
}
Object meth_ast__apply7512(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7514 == NULL) {
    strlit7514 = alloc_String("  ");
    gc_root(strlit7514);
  }
// compiled string node returning strlit7514 (depth = 7)
  int op_slot_right_7513 = gc_frame_newslot(strlit7514);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7513 = gc_frame_newslot(*var_spc);
  params[0] = strlit7514;
  partcv[0] = 1;
  Object opresult7516 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7516 (depth = 6)
  *var_spc = opresult7516;
  if (opresult7516 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7504(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7505 == NULL) {
    strlit7505 = alloc_String("");
    gc_root(strlit7505);
  }
// compiled string node returning strlit7505 (depth = 4)
  *var_spc = strlit7505;
  if (strlit7505 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7506 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7507 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7509 = alloc_Float64(0);
// compiled num node returning num7509 (depth = 5)
  int op_slot_left_7507 = gc_frame_newslot(num7509);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7510 = callmethod(num7509, "..", 1, partcv, params);
// compiled op node returning opresult7510 (depth = 4)
  gc_frame_newslot(opresult7510);
// starting to compile block node (depth = 4)
  Object block7511 = alloc_Block(NULL, NULL, "ast", 1882);
  gc_frame_newslot(block7511);
// method "_apply"
  block_savedest(block7511);
  Object closure7512 = createclosure(2, "_apply");
  setclosureframe(closure7512, stackframe);
  addtoclosure(closure7512, var_spc);
  addtoclosure(closure7512, selfslot);
  struct UserObject *uo7512 = (struct UserObject*)block7511;
  uo7512->data[0] = (Object)closure7512;
  Method *meth_meth_ast__apply7512 = addmethod2pos(block7511, "_apply", &meth_ast__apply7512, 0);
  int argcv_meth_ast__apply7512[] = {1};
  meth_meth_ast__apply7512->type = alloc_MethodType(1, argcv_meth_ast__apply7512);
  meth_meth_ast__apply7512->definitionModule = modulename;
  meth_meth_ast__apply7512->definitionLine = 1877;
// compiled block node returning block7511 (depth = 4)
  gc_frame_newslot(block7511);
// call case 5: prelude request
  params[0] = opresult7510;
  params[1] = block7511;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7519 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7506);
// compiled call node returning call7519 (depth = 3)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7521 == NULL) {
    strlit7521 = alloc_String("""\x0a""");
    gc_root(strlit7521);
  }
// compiled string node returning strlit7521 (depth = 5)
  int op_slot_right_7520 = gc_frame_newslot(strlit7521);
// starting to compile call node (depth = 5)
  int callframe7523 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7524 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7523);
// compiled call node returning call7524 (depth = 5)
  int op_slot_left_7520 = gc_frame_newslot(call7524);
  params[0] = strlit7521;
  partcv[0] = 1;
  Object opresult7525 = callmethod(call7524, "++", 1, partcv, params);
// compiled op node returning opresult7525 (depth = 4)
  *var_s = opresult7525;
  if (opresult7525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7527 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7529 = alloc_Float64(1);
// compiled num node returning num7529 (depth = 7)
  int op_slot_right_7528 = gc_frame_newslot(num7529);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7528 = gc_frame_newslot(*var_depth);
  params[0] = num7529;
  partcv[0] = 1;
  Object sum7531 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7531 (depth = 6)
  gc_frame_newslot(sum7531);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7532 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7533 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7532);
// compiled call node returning call7533 (depth = 7)
// compiled member node returning call7533 (depth = 6)
  params[0] = sum7531;
  partcv[0] = 1;
  Object call7534 = callmethod(call7533, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7527);
// compiled call node returning call7534 (depth = 5)
  int op_slot_right_7526 = gc_frame_newslot(call7534);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7536 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7536 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7538 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7538 (depth = 5)
  int op_slot_left_7526 = gc_frame_newslot(opresult7538);
  params[0] = call7534;
  partcv[0] = 1;
  Object opresult7539 = callmethod(opresult7538, "++", 1, partcv, params);
// compiled op node returning opresult7539 (depth = 4)
  *var_s = opresult7539;
  if (opresult7539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7542 == NULL) {
    strlit7542 = alloc_String("""\x0a""");
    gc_root(strlit7542);
  }
// compiled string node returning strlit7542 (depth = 5)
  int op_slot_right_7541 = gc_frame_newslot(strlit7542);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_7541 = gc_frame_newslot(*var_s);
  params[0] = strlit7542;
  partcv[0] = 1;
  Object opresult7544 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7544 (depth = 4)
  *var_s = opresult7544;
  if (opresult7544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7547 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7549 = alloc_Float64(1);
// compiled num node returning num7549 (depth = 7)
  int op_slot_right_7548 = gc_frame_newslot(num7549);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7548 = gc_frame_newslot(*var_depth);
  params[0] = num7549;
  partcv[0] = 1;
  Object sum7551 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7551 (depth = 6)
  gc_frame_newslot(sum7551);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7553 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7552);
// compiled call node returning call7553 (depth = 7)
// compiled member node returning call7553 (depth = 6)
  params[0] = sum7551;
  partcv[0] = 1;
  Object call7554 = callmethod(call7553, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7547);
// compiled call node returning call7554 (depth = 5)
  int op_slot_right_7546 = gc_frame_newslot(call7554);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7556 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7556 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7558 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7558 (depth = 5)
  int op_slot_left_7546 = gc_frame_newslot(opresult7558);
  params[0] = call7554;
  partcv[0] = 1;
  Object opresult7559 = callmethod(opresult7558, "++", 1, partcv, params);
// compiled op node returning opresult7559 (depth = 4)
  *var_s = opresult7559;
  if (opresult7559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7573(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7575 == NULL) {
    strlit7575 = alloc_String("    ");
    gc_root(strlit7575);
  }
// compiled string node returning strlit7575 (depth = 7)
  int op_slot_right_7574 = gc_frame_newslot(strlit7575);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7574 = gc_frame_newslot(*var_spc);
  params[0] = strlit7575;
  partcv[0] = 1;
  Object opresult7577 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7577 (depth = 6)
  *var_spc = opresult7577;
  if (opresult7577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7562 == NULL) {
    strlit7562 = alloc_String("");
    gc_root(strlit7562);
  }
// compiled string node returning strlit7562 (depth = 4)
  *var_spc = strlit7562;
  if (strlit7562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7563 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7566 = alloc_Float64(1);
// compiled num node returning num7566 (depth = 6)
  int op_slot_right_7565 = gc_frame_newslot(num7566);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7565 = gc_frame_newslot(*var_depth);
  params[0] = num7566;
  partcv[0] = 1;
  Object diff7568 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7568 (depth = 5)
  int op_slot_right_7564 = gc_frame_newslot(diff7568);
// starting to compile num node (depth = 5)
  Object num7570 = alloc_Float64(0);
// compiled num node returning num7570 (depth = 5)
  int op_slot_left_7564 = gc_frame_newslot(num7570);
  params[0] = diff7568;
  partcv[0] = 1;
  Object opresult7571 = callmethod(num7570, "..", 1, partcv, params);
// compiled op node returning opresult7571 (depth = 4)
  gc_frame_newslot(opresult7571);
// starting to compile block node (depth = 4)
  Object block7572 = alloc_Block(NULL, NULL, "ast", 1893);
  gc_frame_newslot(block7572);
// method "_apply"
  block_savedest(block7572);
  Object closure7573 = createclosure(2, "_apply");
  setclosureframe(closure7573, stackframe);
  addtoclosure(closure7573, var_spc);
  addtoclosure(closure7573, selfslot);
  struct UserObject *uo7573 = (struct UserObject*)block7572;
  uo7573->data[0] = (Object)closure7573;
  Method *meth_meth_ast__apply7573 = addmethod2pos(block7572, "_apply", &meth_ast__apply7573, 0);
  int argcv_meth_ast__apply7573[] = {1};
  meth_meth_ast__apply7573->type = alloc_MethodType(1, argcv_meth_ast__apply7573);
  meth_meth_ast__apply7573->definitionModule = modulename;
  meth_meth_ast__apply7573->definitionLine = 1888;
// compiled block node returning block7572 (depth = 4)
  gc_frame_newslot(block7572);
// call case 5: prelude request
  params[0] = opresult7571;
  params[1] = block7572;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7580 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7563);
// compiled call node returning call7580 (depth = 3)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7581 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7583 = alloc_Float64(1);
// compiled num node returning num7583 (depth = 6)
  int op_slot_right_7582 = gc_frame_newslot(num7583);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7582 = gc_frame_newslot(*var_depth);
  params[0] = num7583;
  partcv[0] = 1;
  Object sum7585 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7585 (depth = 5)
  gc_frame_newslot(sum7585);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7587 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7586);
// compiled call node returning call7587 (depth = 6)
// compiled member node returning call7587 (depth = 5)
  params[0] = sum7585;
  partcv[0] = 1;
  Object call7588 = callmethod(call7587, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7581);
// compiled call node returning call7588 (depth = 4)
  *var_s = call7588;
  if (call7588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7590 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7592 = alloc_Float64(1);
// compiled num node returning num7592 (depth = 7)
  int op_slot_right_7591 = gc_frame_newslot(num7592);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7591 = gc_frame_newslot(*var_depth);
  params[0] = num7592;
  partcv[0] = 1;
  Object sum7594 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7594 (depth = 6)
  gc_frame_newslot(sum7594);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7596 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7595);
// compiled call node returning call7596 (depth = 7)
// compiled member node returning call7596 (depth = 6)
  params[0] = sum7594;
  partcv[0] = 1;
  Object call7597 = callmethod(call7596, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7590);
// compiled call node returning call7597 (depth = 5)
  int op_slot_right_7589 = gc_frame_newslot(call7597);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7600 == NULL) {
    strlit7600 = alloc_String(" := ");
    gc_root(strlit7600);
  }
// compiled string node returning strlit7600 (depth = 6)
  int op_slot_right_7599 = gc_frame_newslot(strlit7600);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7599 = gc_frame_newslot(*var_s);
  params[0] = strlit7600;
  partcv[0] = 1;
  Object opresult7602 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7602 (depth = 5)
  int op_slot_left_7589 = gc_frame_newslot(opresult7602);
  params[0] = call7597;
  partcv[0] = 1;
  Object opresult7603 = callmethod(opresult7602, "++", 1, partcv, params);
// compiled op node returning opresult7603 (depth = 4)
  *var_s = opresult7603;
  if (opresult7603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy7605(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7606 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7607 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7608 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7609 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7608);
// compiled call node returning call7609 (depth = 6)
// compiled member node returning call7609 (depth = 5)
  gc_frame_newslot(call7609);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7610 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7611 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7610);
// compiled call node returning call7611 (depth = 6)
// compiled member node returning call7611 (depth = 5)
  gc_frame_newslot(call7611);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_bindNode (depth = 5)
  params[0] = call7609;
  params[1] = call7611;
  partcv[0] = 2;
  Object call7612 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7607);
// compiled call node returning call7612 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call7613 = callmethod(call7612, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe7606);
// compiled call node returning call7613 (depth = 3)
  gc_frame_end(frame);
  return call7613;
}
Object meth_ast_statementName7614(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7615 == NULL) {
    strlit7615 = alloc_String("assignment or assigment request");
    gc_root(strlit7615);
  }
// compiled string node returning strlit7615 (depth = 3)
  gc_frame_end(frame);
  return strlit7615;
}
Object meth_ast_new7452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7453 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7453 = alloc_userobj2(13,12, objclass7453);
  gc_frame_newslot(obj7453);
if (objclass7453 == NULL) {
  glfree(obj7453->class->name);
  obj7453->class->name = "bindNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7453, self, 0);
  addmethodreal(obj7453,"outer", &reader_ast_outer_7454);
  Object oldself7453 = self;
  struct StackFrameObject *oldstackframe7453 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7453);
  gc_frame_newslot((Object)stackframe);
  self = obj7453;
  Object *oldselfslot7453 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7453 = (*(struct UserObject *)self).data[0], lowerouter7453 = thisouter7453;
  if (inheritingObject7453) {
    struct UserObject *inho7453 = (struct UserObject *)inheritingObject7453;
    while (inho7453->super != GraceDefaultObject) inho7453 = (struct UserObject *)inho7453->super;
    inho7453->super = obj7453;
    self = inheritingObject7453;
    *selfslot = self;
    lowerouter7453 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7453;
  }
if (objclass7453 == NULL) {
  Method *reader7455 = addmethodrealflags(obj7453, "kind",&reader_ast_kind_7455, MFLAG_DEF);
  reader7455->definitionModule = modulename;
  reader7455->definitionLine = 1860;
}
adddatum2(obj7453, alloc_Undefined(), 1);
if (objclass7453 == NULL) {
  Method *reader7456 = addmethodrealflags(obj7453, "dest",&reader_ast_dest_7456, 0);
  Method *writer7456 = addmethodrealflags(obj7453, "dest:=",&writer_ast_dest_7456, 0);
  reader7456->definitionModule = modulename;
  writer7456->definitionModule = modulename;
  reader7456->definitionLine = 1861;
  writer7456->definitionLine = 1861;
}
obj7453->flags |= OFLAG_MUTABLE;
adddatum2(obj7453, alloc_Undefined(), 2);
if (objclass7453 == NULL) {
  Method *reader7457 = addmethodrealflags(obj7453, "value",&reader_ast_value_7457, 0);
  Method *writer7457 = addmethodrealflags(obj7453, "value:=",&writer_ast_value_7457, 0);
  reader7457->definitionModule = modulename;
  writer7457->definitionModule = modulename;
  reader7457->definitionLine = 1862;
  writer7457->definitionLine = 1862;
}
obj7453->flags |= OFLAG_MUTABLE;
adddatum2(obj7453, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7458 = (struct UserObject*)obj7453;
  uo7458->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7458 = addmethod2pos(obj7453, "isBind", &meth_ast_isBind7458, 4);
  int argcv_meth_ast_isBind7458[] = {0};
  meth_meth_ast_isBind7458->type = alloc_MethodType(1, argcv_meth_ast_isBind7458);
  meth_meth_ast_isBind7458->definitionModule = modulename;
  meth_meth_ast_isBind7458->definitionLine = 1864;
// method "asString"
  struct UserObject *uo7460 = (struct UserObject*)obj7453;
  uo7460->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7460 = addmethod2pos(obj7453, "asString", &meth_ast_asString7460, 5);
  int argcv_meth_ast_asString7460[] = {0};
  meth_meth_ast_asString7460->type = alloc_MethodType(1, argcv_meth_ast_asString7460);
  meth_meth_ast_asString7460->definitionModule = modulename;
  meth_meth_ast_asString7460->definitionLine = 1865;
// method "accept()from"
  struct UserObject *uo7471 = (struct UserObject*)obj7453;
  uo7471->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7471 = addmethod2pos(obj7453, "accept()from", &meth_ast_accept_40__41_from7471, 6);
  int argcv_meth_ast_accept_40__41_from7471[] = {1, 1};
  meth_meth_ast_accept_40__41_from7471->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7471);
  meth_meth_ast_accept_40__41_from7471->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7471->definitionLine = 1866;
// method "map()ancestors"
  struct UserObject *uo7485 = (struct UserObject*)obj7453;
  uo7485->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7485 = addmethod2pos(obj7453, "map()ancestors", &meth_ast_map_40__41_ancestors7485, 7);
  int argcv_meth_ast_map_40__41_ancestors7485[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7485->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7485);
  meth_meth_ast_map_40__41_ancestors7485->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7485->definitionLine = 1873;
// method "pretty"
  struct UserObject *uo7504 = (struct UserObject*)obj7453;
  uo7504->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7504 = addmethod2pos(obj7453, "pretty", &meth_ast_pretty7504, 8);
  int argcv_meth_ast_pretty7504[] = {1};
  meth_meth_ast_pretty7504->type = alloc_MethodType(1, argcv_meth_ast_pretty7504);
  meth_meth_ast_pretty7504->definitionModule = modulename;
  meth_meth_ast_pretty7504->definitionLine = 1880;
// method "toGrace"
  struct UserObject *uo7561 = (struct UserObject*)obj7453;
  uo7561->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7561 = addmethod2pos(obj7453, "toGrace", &meth_ast_toGrace7561, 9);
  int argcv_meth_ast_toGrace7561[] = {1};
  meth_meth_ast_toGrace7561->type = alloc_MethodType(1, argcv_meth_ast_toGrace7561);
meth_meth_ast_toGrace7561->type->types[0] = type_Number;
meth_meth_ast_toGrace7561->type->names[0] = "depth";
  meth_meth_ast_toGrace7561->definitionModule = modulename;
  meth_meth_ast_toGrace7561->definitionLine = 1891;
// method "shallowCopy"
  block_savedest(obj7453);
  Object closure7605 = createclosure(1, "shallowCopy");
  setclosureframe(closure7605, stackframe);
  addtoclosure(closure7605, var_bindNode);
  struct UserObject *uo7605 = (struct UserObject*)obj7453;
  uo7605->data[10] = (Object)closure7605;
  Method *meth_meth_ast_shallowCopy7605 = addmethod2pos(obj7453, "shallowCopy", &meth_ast_shallowCopy7605, 10);
  int argcv_meth_ast_shallowCopy7605[] = {0};
  meth_meth_ast_shallowCopy7605->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7605);
  meth_meth_ast_shallowCopy7605->definitionModule = modulename;
  meth_meth_ast_shallowCopy7605->definitionLine = 1900;
// method "statementName"
  struct UserObject *uo7614 = (struct UserObject*)obj7453;
  uo7614->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7614 = addmethod2pos(obj7453, "statementName", &meth_ast_statementName7614, 11);
  int argcv_meth_ast_statementName7614[] = {0};
  meth_meth_ast_statementName7614->type = alloc_MethodType(1, argcv_meth_ast_statementName7614);
  meth_meth_ast_statementName7614->definitionModule = modulename;
  meth_meth_ast_statementName7614->definitionLine = 1903;
  sourceObject = obj7453;
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7616 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7617 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7618 = gc_frame_new();
// call case 3: self.outer request
  Object call7619 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7618);
// compiled call node returning call7619 (depth = 7)
// compiled member node returning call7619 (depth = 6)
  partcv[0] = 0;
  Object call7620 = callmethodflags(call7619, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7617);
// compiled call node returning call7620 (depth = 5)
// compiled member node returning call7620 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7621 = callmethodflags(call7620, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7616);
// compiled call node returning call7621 (depth = 3)
  struct UserObject *obj7453_uo = (struct UserObject *)obj7453;
  obj7453_uo->super = call7621;
  sourceObject = obj7453;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7622 == NULL) {
    strlit7622 = alloc_String("bind");
    gc_root(strlit7622);
  }
// compiled string node returning strlit7622 (depth = 3)
  adddatum2(obj7453, strlit7622, 1);
  sourceObject = obj7453;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7453, *var_dest_39_, 2);
  sourceObject = obj7453;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7453, *var_val_39_, 3);
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  objclass7453 = obj7453->class;
  objclass7453->definitionModule = modulename;
  objclass7453->definitionLine = 1857;
  (*(struct UserObject *)self).data[0] = lowerouter7453;
  self = oldself7453;
  selfslot = oldselfslot7453;
  stackframe = oldstackframe7453;
  gc_frame_end(frame);
  return obj7453;
}
Object meth_ast_new7452_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7453 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7453 = alloc_userobj2(13,12, objclass7453);
  gc_frame_newslot(obj7453);
if (objclass7453 == NULL) {
  glfree(obj7453->class->name);
  obj7453->class->name = "bindNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7453, self, 0);
  addmethodreal(obj7453,"outer", &reader_ast_outer_7454);
  Object oldself7453 = self;
  struct StackFrameObject *oldstackframe7453 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7453);
  gc_frame_newslot((Object)stackframe);
  self = obj7453;
  Object *oldselfslot7453 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7453 = (*(struct UserObject *)self).data[0], lowerouter7453 = thisouter7453;
  if (inheritingObject7453) {
    struct UserObject *inho7453 = (struct UserObject *)inheritingObject7453;
    while (inho7453->super != GraceDefaultObject) inho7453 = (struct UserObject *)inho7453->super;
    inho7453->super = obj7453;
    self = inheritingObject7453;
    *selfslot = self;
    lowerouter7453 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7453;
  }
if (objclass7453 == NULL) {
  Method *reader7455 = addmethodrealflags(obj7453, "kind",&reader_ast_kind_7455, MFLAG_DEF);
  reader7455->definitionModule = modulename;
  reader7455->definitionLine = 1860;
}
adddatum2(obj7453, alloc_Undefined(), 1);
if (objclass7453 == NULL) {
  Method *reader7456 = addmethodrealflags(obj7453, "dest",&reader_ast_dest_7456, 0);
  Method *writer7456 = addmethodrealflags(obj7453, "dest:=",&writer_ast_dest_7456, 0);
  reader7456->definitionModule = modulename;
  writer7456->definitionModule = modulename;
  reader7456->definitionLine = 1861;
  writer7456->definitionLine = 1861;
}
obj7453->flags |= OFLAG_MUTABLE;
adddatum2(obj7453, alloc_Undefined(), 2);
if (objclass7453 == NULL) {
  Method *reader7457 = addmethodrealflags(obj7453, "value",&reader_ast_value_7457, 0);
  Method *writer7457 = addmethodrealflags(obj7453, "value:=",&writer_ast_value_7457, 0);
  reader7457->definitionModule = modulename;
  writer7457->definitionModule = modulename;
  reader7457->definitionLine = 1862;
  writer7457->definitionLine = 1862;
}
obj7453->flags |= OFLAG_MUTABLE;
adddatum2(obj7453, alloc_Undefined(), 3);
// method "isBind"
  struct UserObject *uo7458 = (struct UserObject*)obj7453;
  uo7458->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7458 = addmethod2pos(obj7453, "isBind", &meth_ast_isBind7458, 4);
  int argcv_meth_ast_isBind7458[] = {0};
  meth_meth_ast_isBind7458->type = alloc_MethodType(1, argcv_meth_ast_isBind7458);
  meth_meth_ast_isBind7458->definitionModule = modulename;
  meth_meth_ast_isBind7458->definitionLine = 1864;
// method "asString"
  struct UserObject *uo7460 = (struct UserObject*)obj7453;
  uo7460->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7460 = addmethod2pos(obj7453, "asString", &meth_ast_asString7460, 5);
  int argcv_meth_ast_asString7460[] = {0};
  meth_meth_ast_asString7460->type = alloc_MethodType(1, argcv_meth_ast_asString7460);
  meth_meth_ast_asString7460->definitionModule = modulename;
  meth_meth_ast_asString7460->definitionLine = 1865;
// method "accept()from"
  struct UserObject *uo7471 = (struct UserObject*)obj7453;
  uo7471->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7471 = addmethod2pos(obj7453, "accept()from", &meth_ast_accept_40__41_from7471, 6);
  int argcv_meth_ast_accept_40__41_from7471[] = {1, 1};
  meth_meth_ast_accept_40__41_from7471->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7471);
  meth_meth_ast_accept_40__41_from7471->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7471->definitionLine = 1866;
// method "map()ancestors"
  struct UserObject *uo7485 = (struct UserObject*)obj7453;
  uo7485->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7485 = addmethod2pos(obj7453, "map()ancestors", &meth_ast_map_40__41_ancestors7485, 7);
  int argcv_meth_ast_map_40__41_ancestors7485[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7485->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7485);
  meth_meth_ast_map_40__41_ancestors7485->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7485->definitionLine = 1873;
// method "pretty"
  struct UserObject *uo7504 = (struct UserObject*)obj7453;
  uo7504->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7504 = addmethod2pos(obj7453, "pretty", &meth_ast_pretty7504, 8);
  int argcv_meth_ast_pretty7504[] = {1};
  meth_meth_ast_pretty7504->type = alloc_MethodType(1, argcv_meth_ast_pretty7504);
  meth_meth_ast_pretty7504->definitionModule = modulename;
  meth_meth_ast_pretty7504->definitionLine = 1880;
// method "toGrace"
  struct UserObject *uo7561 = (struct UserObject*)obj7453;
  uo7561->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7561 = addmethod2pos(obj7453, "toGrace", &meth_ast_toGrace7561, 9);
  int argcv_meth_ast_toGrace7561[] = {1};
  meth_meth_ast_toGrace7561->type = alloc_MethodType(1, argcv_meth_ast_toGrace7561);
meth_meth_ast_toGrace7561->type->types[0] = type_Number;
meth_meth_ast_toGrace7561->type->names[0] = "depth";
  meth_meth_ast_toGrace7561->definitionModule = modulename;
  meth_meth_ast_toGrace7561->definitionLine = 1891;
// method "shallowCopy"
  block_savedest(obj7453);
  Object closure7605 = createclosure(1, "shallowCopy");
  setclosureframe(closure7605, stackframe);
  addtoclosure(closure7605, var_bindNode);
  struct UserObject *uo7605 = (struct UserObject*)obj7453;
  uo7605->data[10] = (Object)closure7605;
  Method *meth_meth_ast_shallowCopy7605 = addmethod2pos(obj7453, "shallowCopy", &meth_ast_shallowCopy7605, 10);
  int argcv_meth_ast_shallowCopy7605[] = {0};
  meth_meth_ast_shallowCopy7605->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy7605);
  meth_meth_ast_shallowCopy7605->definitionModule = modulename;
  meth_meth_ast_shallowCopy7605->definitionLine = 1900;
// method "statementName"
  struct UserObject *uo7614 = (struct UserObject*)obj7453;
  uo7614->data[11] = emptyclosure;
  Method *meth_meth_ast_statementName7614 = addmethod2pos(obj7453, "statementName", &meth_ast_statementName7614, 11);
  int argcv_meth_ast_statementName7614[] = {0};
  meth_meth_ast_statementName7614->type = alloc_MethodType(1, argcv_meth_ast_statementName7614);
  meth_meth_ast_statementName7614->definitionModule = modulename;
  meth_meth_ast_statementName7614->definitionLine = 1903;
  sourceObject = obj7453;
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7616 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7617 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7618 = gc_frame_new();
// call case 3: self.outer request
  Object call7619 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7618);
// compiled call node returning call7619 (depth = 7)
// compiled member node returning call7619 (depth = 6)
  partcv[0] = 0;
  Object call7620 = callmethodflags(call7619, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7617);
// compiled call node returning call7620 (depth = 5)
// compiled member node returning call7620 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7621 = callmethodflags(call7620, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7616);
// compiled call node returning call7621 (depth = 3)
  struct UserObject *obj7453_uo = (struct UserObject *)obj7453;
  obj7453_uo->super = call7621;
  sourceObject = obj7453;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit7622 == NULL) {
    strlit7622 = alloc_String("bind");
    gc_root(strlit7622);
  }
// compiled string node returning strlit7622 (depth = 3)
  adddatum2(obj7453, strlit7622, 1);
  sourceObject = obj7453;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dest_39_ (depth = 3)
  adddatum2(obj7453, *var_dest_39_, 2);
  sourceObject = obj7453;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj7453, *var_val_39_, 3);
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  sourceObject = obj7453;
  objclass7453 = obj7453->class;
  objclass7453->definitionModule = modulename;
  objclass7453->definitionLine = 1857;
  (*(struct UserObject *)self).data[0] = lowerouter7453;
  self = oldself7453;
  selfslot = oldselfslot7453;
  stackframe = oldstackframe7453;
  gc_frame_end(frame);
  return obj7453;
}
Object meth_ast_bindNode7624(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_new_40__41_scope7627(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[3];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "result");
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7628 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name_39_ (depth = 5)
  gc_frame_newslot(*var_name_39_);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype_39_ (depth = 5)
  gc_frame_newslot(*var_dtype_39_);
// call case 4: self request
  params[0] = *var_name_39_;
  params[1] = *var_val;
  params[2] = *var_dtype_39_;
  partcv[0] = 3;
  Object call7629 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7628);
// compiled call node returning call7629 (depth = 4)
  *var_result = call7629;
  if (call7629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7630 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call7631 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe7630);
// compiled call node returning call7631 (depth = 3)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isPublic7642(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7645 = alloc_Float64(0);
// compiled num node returning num7645 (depth = 5)
  int op_slot_right_7644 = gc_frame_newslot(num7645);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7647 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7648 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7649 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7648);
// compiled call node returning call7649 (depth = 8)
// compiled member node returning call7649 (depth = 7)
  partcv[0] = 0;
  Object call7650 = callmethod(call7649, "size",
    1, partcv, params);
  gc_frame_end(callframe7647);
// compiled call node returning call7650 (depth = 6)
// compiled member node returning call7650 (depth = 5)
  int op_slot_left_7644 = gc_frame_newslot(call7650);
  params[0] = num7645;
  partcv[0] = 1;
  Object opresult7651 = callmethod(call7650, "==", 1, partcv, params);
// compiled op node returning opresult7651 (depth = 4)
  Object if7643 = done;
  if (istrue(opresult7651)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7652 = alloc_Boolean(0);
// compiled identifier node returning bool7652 (depth = 5)
  return bool7652;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7643 = undefined;
  } else {
  }
// compiled if node returning if7643 (depth = 3)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7654 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit7655 == NULL) {
    strlit7655 = alloc_String("public");
    gc_root(strlit7655);
  }
// compiled string node returning strlit7655 (depth = 5)
  gc_frame_newslot(strlit7655);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7656 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7657 = gc_frame_new();
// call case 3: self.outer request
  Object call7658 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7657);
// compiled call node returning call7658 (depth = 8)
// compiled member node returning call7658 (depth = 7)
  partcv[0] = 0;
  Object call7659 = callmethodflags(call7658, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7656);
// compiled call node returning call7659 (depth = 6)
// compiled member node returning call7659 (depth = 5)
  params[0] = self;
  params[1] = strlit7655;
  partcv[0] = 2;
  Object call7660 = callmethodflags(call7659, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7654);
// compiled call node returning call7660 (depth = 4)
  Object if7653 = done;
  if (istrue(call7660)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7661 = alloc_Boolean(1);
// compiled identifier node returning bool7661 (depth = 5)
  return bool7661;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if7653 = undefined;
  } else {
  }
// compiled if node returning if7653 (depth = 3)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7662 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit7663 == NULL) {
    strlit7663 = alloc_String("readable");
    gc_root(strlit7663);
  }
// compiled string node returning strlit7663 (depth = 4)
  gc_frame_newslot(strlit7663);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7664 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7665 = gc_frame_new();
// call case 3: self.outer request
  Object call7666 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7665);
// compiled call node returning call7666 (depth = 7)
// compiled member node returning call7666 (depth = 6)
  partcv[0] = 0;
  Object call7667 = callmethodflags(call7666, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7664);
// compiled call node returning call7667 (depth = 5)
// compiled member node returning call7667 (depth = 4)
  params[0] = self;
  params[1] = strlit7663;
  partcv[0] = 2;
  Object call7668 = callmethodflags(call7667, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7662);
// compiled call node returning call7668 (depth = 3)
  gc_frame_end(frame);
  return call7668;
}
Object meth_ast_isFieldDec7669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7670 = alloc_Boolean(1);
// compiled identifier node returning bool7670 (depth = 3)
  gc_frame_end(frame);
  return bool7670;
}
Object meth_ast_isWritable7671(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool7672 = alloc_Boolean(0);
// compiled identifier node returning bool7672 (depth = 3)
  gc_frame_end(frame);
  return bool7672;
}
Object meth_ast_isReadable7673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7674 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7675 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7674);
// compiled call node returning call7675 (depth = 4)
// compiled member node returning call7675 (depth = 3)
  gc_frame_end(frame);
  return call7675;
}
Object meth_ast_returnsObject7676(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnsObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnsObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnsObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7677 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7678 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7679 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7678);
// compiled call node returning call7679 (depth = 6)
// compiled member node returning call7679 (depth = 5)
  partcv[0] = 0;
  Object call7680 = callmethod(call7679, "returnsObject",
    1, partcv, params);
  gc_frame_end(callframe7677);
// compiled call node returning call7680 (depth = 4)
// compiled member node returning call7680 (depth = 3)
  gc_frame_end(frame);
  return call7680;
}
Object meth_ast_returnedObjectScope7681(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "returnedObjectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnedObjectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnedObjectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7682 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7684 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7683);
// compiled call node returning call7684 (depth = 6)
// compiled member node returning call7684 (depth = 5)
  partcv[0] = 0;
  Object call7685 = callmethod(call7684, "returnedObjectScope",
    1, partcv, params);
  gc_frame_end(callframe7682);
// compiled call node returning call7685 (depth = 4)
// compiled member node returning call7685 (depth = 3)
  gc_frame_end(frame);
  return call7685;
}
Object meth_ast_usesAsType7686(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7689 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7688);
// compiled call node returning call7689 (depth = 5)
// compiled member node returning call7689 (depth = 4)
  int op_slot_right_7687 = gc_frame_newslot(call7689);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_7687 = gc_frame_newslot(*var_aNode);
  params[0] = call7689;
  partcv[0] = 1;
  Object opresult7691 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult7691 (depth = 3)
  gc_frame_end(frame);
  return opresult7691;
}
Object meth_ast_declarationKindWithAncestors7692(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call7694 = callmethod(*var_k, "defdec",
    1, partcv, params);
  gc_frame_end(callframe7693);
// compiled call node returning call7694 (depth = 4)
// compiled member node returning call7694 (depth = 3)
  gc_frame_end(frame);
  return call7694;
}
Object meth_ast__apply7720(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7721 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7722 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7721);
// compiled call node returning call7722 (depth = 6)
  gc_frame_end(frame);
  return call7722;
}
Object meth_ast_accept_40__41_from7695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7697 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7698 = callmethod(*var_visitor, "visitDefDec()up",
    2, partcv, params);
  gc_frame_end(callframe7697);
// compiled call node returning call7698 (depth = 4)
  Object if7696 = done;
  if (istrue(call7698)) {
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7699 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call7700 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7699);
// compiled call node returning call7700 (depth = 5)
  *var_newChain = call7700;
  if (call7700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7701 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7703 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7702);
// compiled call node returning call7703 (depth = 6)
// compiled member node returning call7703 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7704 = callmethod(call7703, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7701);
// compiled call node returning call7704 (depth = 4)
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7708 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7707);
// compiled call node returning call7708 (depth = 7)
// compiled member node returning call7708 (depth = 6)
  int op_slot_right_7706 = gc_frame_newslot(call7708);
// starting to compile identifier node (depth = 6)
  Object bool7710 = alloc_Boolean(0);
// compiled identifier node returning bool7710 (depth = 6)
  int op_slot_left_7706 = gc_frame_newslot(bool7710);
  params[0] = call7708;
  partcv[0] = 1;
  Object opresult7711 = callmethod(bool7710, "≠", 1, partcv, params);
// compiled op node returning opresult7711 (depth = 5)
  Object if7705 = done;
  if (istrue(opresult7711)) {
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7712 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7714 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compiled call node returning call7714 (depth = 7)
// compiled member node returning call7714 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7715 = callmethod(call7714, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7712);
// compiled call node returning call7715 (depth = 5)
    gc_frame_newslot(call7715);
    if7705 = call7715;
  } else {
  }
// compiled if node returning if7705 (depth = 4)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7716 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7718 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7717);
// compiled call node returning call7718 (depth = 6)
// compiled member node returning call7718 (depth = 5)
  gc_frame_newslot(call7718);
// starting to compile block node (depth = 5)
  Object block7719 = alloc_Block(NULL, NULL, "ast", 1952);
  gc_frame_newslot(block7719);
// method "_apply"
  block_savedest(block7719);
  Object closure7720 = createclosure(3, "_apply");
  setclosureframe(closure7720, stackframe);
  addtoclosure(closure7720, var_visitor);
  addtoclosure(closure7720, var_newChain);
  addtoclosure(closure7720, selfslot);
  struct UserObject *uo7720 = (struct UserObject*)block7719;
  uo7720->data[0] = (Object)closure7720;
  Method *meth_meth_ast__apply7720 = addmethod2pos(block7719, "_apply", &meth_ast__apply7720, 0);
  int argcv_meth_ast__apply7720[] = {1};
  meth_meth_ast__apply7720->type = alloc_MethodType(1, argcv_meth_ast__apply7720);
  meth_meth_ast__apply7720->definitionModule = modulename;
  meth_meth_ast__apply7720->definitionLine = 1952;
// compiled block node returning block7719 (depth = 5)
  gc_frame_newslot(block7719);
// call case 5: prelude request
  params[0] = call7718;
  params[1] = block7719;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7724 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7716);
// compiled call node returning call7724 (depth = 4)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7725 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7727 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7726);
// compiled call node returning call7727 (depth = 6)
// compiled member node returning call7727 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7728 = callmethod(call7727, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7725);
// compiled call node returning call7728 (depth = 4)
    gc_frame_newslot(call7728);
    if7696 = call7728;
  } else {
  }
// compiled if node returning if7696 (depth = 3)
  gc_frame_end(frame);
  return if7696;
}
Object meth_ast_map_40__41_ancestors7729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7731 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7730);
// compiled call node returning call7731 (depth = 5)
// compiled member node returning call7731 (depth = 4)
  *var_n = call7731;
  if (call7731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7732 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7733 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe7732);
// compiled call node returning call7733 (depth = 4)
  *var_newChain = call7733;
  if (call7733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7734 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7735 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7737 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7736);
// compiled call node returning call7737 (depth = 6)
// compiled member node returning call7737 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7738 = callmethod(call7737, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7735);
// compiled call node returning call7738 (depth = 4)
  gc_frame_newslot(call7738);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7738;
  partcv[0] = 1;
  Object call7739 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe7734);
// compiled call node returning call7739 (depth = 3)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7740 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7741 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7743 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7742);
// compiled call node returning call7743 (depth = 6)
// compiled member node returning call7743 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7744 = callmethod(call7743, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe7741);
// compiled call node returning call7744 (depth = 4)
  gc_frame_newslot(call7744);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7744;
  partcv[0] = 1;
  Object call7745 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7740);
// compiled call node returning call7745 (depth = 3)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7746 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7747 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7749 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7748);
// compiled call node returning call7749 (depth = 6)
// compiled member node returning call7749 (depth = 5)
  gc_frame_newslot(call7749);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7750 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7751 = gc_frame_new();
// call case 3: self.outer request
  Object call7752 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7751);
// compiled call node returning call7752 (depth = 8)
// compiled member node returning call7752 (depth = 7)
  partcv[0] = 0;
  Object call7753 = callmethodflags(call7752, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7750);
// compiled call node returning call7753 (depth = 6)
// compiled member node returning call7753 (depth = 5)
  params[0] = call7749;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7754 = callmethodflags(call7753, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7747);
// compiled call node returning call7754 (depth = 4)
  gc_frame_newslot(call7754);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7754;
  partcv[0] = 1;
  Object call7755 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe7746);
// compiled call node returning call7755 (depth = 3)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7756 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7757 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7758 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7759 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7758);
// compiled call node returning call7759 (depth = 6)
// compiled member node returning call7759 (depth = 5)
  gc_frame_newslot(call7759);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7760 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7761 = gc_frame_new();
// call case 3: self.outer request
  Object call7762 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7761);
// compiled call node returning call7762 (depth = 8)
// compiled member node returning call7762 (depth = 7)
  partcv[0] = 0;
  Object call7763 = callmethodflags(call7762, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7760);
// compiled call node returning call7763 (depth = 6)
// compiled member node returning call7763 (depth = 5)
  params[0] = call7759;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7764 = callmethodflags(call7763, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7757);
// compiled call node returning call7764 (depth = 4)
  gc_frame_newslot(call7764);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call7764;
  partcv[0] = 1;
  Object call7765 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe7756);
// compiled call node returning call7765 (depth = 3)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7766 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call7767 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7766);
// compiled call node returning call7767 (depth = 3)
  gc_frame_end(frame);
  return call7767;
}
Object meth_ast__apply7776(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7778 == NULL) {
    strlit7778 = alloc_String("  ");
    gc_root(strlit7778);
  }
// compiled string node returning strlit7778 (depth = 7)
  int op_slot_right_7777 = gc_frame_newslot(strlit7778);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7777 = gc_frame_newslot(*var_spc);
  params[0] = strlit7778;
  partcv[0] = 1;
  Object opresult7780 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7780 (depth = 6)
  *var_spc = opresult7780;
  if (opresult7780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7884 == NULL) {
    strlit7884 = alloc_String("");
    gc_root(strlit7884);
  }
// compiled string node returning strlit7884 (depth = 8)
  int op_slot_right_7883 = gc_frame_newslot(strlit7884);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7887 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num7889 = alloc_Float64(2);
// compiled num node returning num7889 (depth = 11)
  int op_slot_right_7888 = gc_frame_newslot(num7889);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_7888 = gc_frame_newslot(*var_depth);
  params[0] = num7889;
  partcv[0] = 1;
  Object sum7891 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7891 (depth = 10)
  gc_frame_newslot(sum7891);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  params[0] = sum7891;
  partcv[0] = 1;
  Object call7892 = callmethod(*var_ann, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7887);
// compiled call node returning call7892 (depth = 9)
  int op_slot_right_7886 = gc_frame_newslot(call7892);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7895 == NULL) {
    strlit7895 = alloc_String(" ");
    gc_root(strlit7895);
  }
// compiled string node returning strlit7895 (depth = 10)
  int op_slot_right_7894 = gc_frame_newslot(strlit7895);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_7897 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit7899 == NULL) {
    strlit7899 = alloc_String("");
    gc_root(strlit7899);
  }
// compiled string node returning strlit7899 (depth = 11)
  int op_slot_left_7897 = gc_frame_newslot(strlit7899);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult7900 = callmethod(strlit7899, "++", 1, partcv, params);
// compiled op node returning opresult7900 (depth = 10)
  int op_slot_left_7894 = gc_frame_newslot(opresult7900);
  params[0] = strlit7895;
  partcv[0] = 1;
  Object opresult7901 = callmethod(opresult7900, "++", 1, partcv, params);
// compiled op node returning opresult7901 (depth = 9)
  int op_slot_left_7886 = gc_frame_newslot(opresult7901);
  params[0] = call7892;
  partcv[0] = 1;
  Object opresult7902 = callmethod(opresult7901, "++", 1, partcv, params);
// compiled op node returning opresult7902 (depth = 8)
  int op_slot_left_7883 = gc_frame_newslot(opresult7902);
  params[0] = strlit7884;
  partcv[0] = 1;
  Object opresult7903 = callmethod(opresult7902, "++", 1, partcv, params);
// compiled op node returning opresult7903 (depth = 7)
  *var_s = opresult7903;
  if (opresult7903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7769 == NULL) {
    strlit7769 = alloc_String("");
    gc_root(strlit7769);
  }
// compiled string node returning strlit7769 (depth = 4)
  *var_spc = strlit7769;
  if (strlit7769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7770 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_7771 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num7773 = alloc_Float64(0);
// compiled num node returning num7773 (depth = 5)
  int op_slot_left_7771 = gc_frame_newslot(num7773);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7774 = callmethod(num7773, "..", 1, partcv, params);
// compiled op node returning opresult7774 (depth = 4)
  gc_frame_newslot(opresult7774);
// starting to compile block node (depth = 4)
  Object block7775 = alloc_Block(NULL, NULL, "ast", 1969);
  gc_frame_newslot(block7775);
// method "_apply"
  block_savedest(block7775);
  Object closure7776 = createclosure(2, "_apply");
  setclosureframe(closure7776, stackframe);
  addtoclosure(closure7776, var_spc);
  addtoclosure(closure7776, selfslot);
  struct UserObject *uo7776 = (struct UserObject*)block7775;
  uo7776->data[0] = (Object)closure7776;
  Method *meth_meth_ast__apply7776 = addmethod2pos(block7775, "_apply", &meth_ast__apply7776, 0);
  int argcv_meth_ast__apply7776[] = {1};
  meth_meth_ast__apply7776->type = alloc_MethodType(1, argcv_meth_ast__apply7776);
  meth_meth_ast__apply7776->definitionModule = modulename;
  meth_meth_ast__apply7776->definitionLine = 1964;
// compiled block node returning block7775 (depth = 4)
  gc_frame_newslot(block7775);
// call case 5: prelude request
  params[0] = opresult7774;
  params[1] = block7775;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7783 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7770);
// compiled call node returning call7783 (depth = 3)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7785 == NULL) {
    strlit7785 = alloc_String("""\x0a""");
    gc_root(strlit7785);
  }
// compiled string node returning strlit7785 (depth = 5)
  int op_slot_right_7784 = gc_frame_newslot(strlit7785);
// starting to compile call node (depth = 5)
  int callframe7787 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7788 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7787);
// compiled call node returning call7788 (depth = 5)
  int op_slot_left_7784 = gc_frame_newslot(call7788);
  params[0] = strlit7785;
  partcv[0] = 1;
  Object opresult7789 = callmethod(call7788, "++", 1, partcv, params);
// compiled op node returning opresult7789 (depth = 4)
  *var_s = opresult7789;
  if (opresult7789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7791 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7793 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7792);
// compiled call node returning call7793 (depth = 7)
// compiled member node returning call7793 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7794 = callmethod(call7793, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7791);
// compiled call node returning call7794 (depth = 5)
  int op_slot_right_7790 = gc_frame_newslot(call7794);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_7796 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7796 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7798 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7798 (depth = 5)
  int op_slot_left_7790 = gc_frame_newslot(opresult7798);
  params[0] = call7794;
  partcv[0] = 1;
  Object opresult7799 = callmethod(opresult7798, "++", 1, partcv, params);
// compiled op node returning opresult7799 (depth = 4)
  *var_s = opresult7799;
  if (opresult7799 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7804 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7803);
// compiled call node returning call7804 (depth = 6)
// compiled member node returning call7804 (depth = 5)
  int op_slot_right_7802 = gc_frame_newslot(call7804);
// starting to compile identifier node (depth = 5)
  Object bool7806 = alloc_Boolean(0);
// compiled identifier node returning bool7806 (depth = 5)
  int op_slot_left_7802 = gc_frame_newslot(bool7806);
  params[0] = call7804;
  partcv[0] = 1;
  Object opresult7807 = callmethod(bool7806, "≠", 1, partcv, params);
// compiled op node returning opresult7807 (depth = 4)
  Object if7801 = done;
  if (istrue(opresult7807)) {
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7809 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7811 = alloc_Float64(2);
// compiled num node returning num7811 (depth = 8)
  int op_slot_right_7810 = gc_frame_newslot(num7811);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7810 = gc_frame_newslot(*var_depth);
  params[0] = num7811;
  partcv[0] = 1;
  Object sum7813 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7813 (depth = 7)
  gc_frame_newslot(sum7813);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7815 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7814);
// compiled call node returning call7815 (depth = 8)
// compiled member node returning call7815 (depth = 7)
  params[0] = sum7813;
  partcv[0] = 1;
  Object call7816 = callmethod(call7815, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7809);
// compiled call node returning call7816 (depth = 6)
  int op_slot_right_7808 = gc_frame_newslot(call7816);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7819 == NULL) {
    strlit7819 = alloc_String("Type: ");
    gc_root(strlit7819);
  }
// compiled string node returning strlit7819 (depth = 7)
  int op_slot_right_7818 = gc_frame_newslot(strlit7819);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_7821 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7824 == NULL) {
    strlit7824 = alloc_String("""\x0a""");
    gc_root(strlit7824);
  }
// compiled string node returning strlit7824 (depth = 9)
  int op_slot_right_7823 = gc_frame_newslot(strlit7824);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7823 = gc_frame_newslot(*var_s);
  params[0] = strlit7824;
  partcv[0] = 1;
  Object opresult7826 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7826 (depth = 8)
  int op_slot_left_7821 = gc_frame_newslot(opresult7826);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7827 = callmethod(opresult7826, "++", 1, partcv, params);
// compiled op node returning opresult7827 (depth = 7)
  int op_slot_left_7818 = gc_frame_newslot(opresult7827);
  params[0] = strlit7819;
  partcv[0] = 1;
  Object opresult7828 = callmethod(opresult7827, "++", 1, partcv, params);
// compiled op node returning opresult7828 (depth = 6)
  int op_slot_left_7808 = gc_frame_newslot(opresult7828);
  params[0] = call7816;
  partcv[0] = 1;
  Object opresult7829 = callmethod(opresult7828, "++", 1, partcv, params);
// compiled op node returning opresult7829 (depth = 5)
  *var_s = opresult7829;
  if (opresult7829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7801 = done;
  } else {
  }
// compiled if node returning if7801 (depth = 3)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7834 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7833);
// compiled call node returning call7834 (depth = 6)
// compiled member node returning call7834 (depth = 5)
  int op_slot_right_7832 = gc_frame_newslot(call7834);
// starting to compile identifier node (depth = 5)
  Object bool7836 = alloc_Boolean(0);
// compiled identifier node returning bool7836 (depth = 5)
  int op_slot_left_7832 = gc_frame_newslot(bool7836);
  params[0] = call7834;
  partcv[0] = 1;
  Object opresult7837 = callmethod(bool7836, "≠", 1, partcv, params);
// compiled op node returning opresult7837 (depth = 4)
  Object if7831 = done;
  if (istrue(opresult7837)) {
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7839 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7841 = alloc_Float64(2);
// compiled num node returning num7841 (depth = 8)
  int op_slot_right_7840 = gc_frame_newslot(num7841);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7840 = gc_frame_newslot(*var_depth);
  params[0] = num7841;
  partcv[0] = 1;
  Object sum7843 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7843 (depth = 7)
  gc_frame_newslot(sum7843);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7845 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7844);
// compiled call node returning call7845 (depth = 8)
// compiled member node returning call7845 (depth = 7)
  params[0] = sum7843;
  partcv[0] = 1;
  Object call7846 = callmethod(call7845, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7839);
// compiled call node returning call7846 (depth = 6)
  int op_slot_right_7838 = gc_frame_newslot(call7846);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7849 == NULL) {
    strlit7849 = alloc_String("Value: ");
    gc_root(strlit7849);
  }
// compiled string node returning strlit7849 (depth = 7)
  int op_slot_right_7848 = gc_frame_newslot(strlit7849);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_7851 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7854 == NULL) {
    strlit7854 = alloc_String("""\x0a""");
    gc_root(strlit7854);
  }
// compiled string node returning strlit7854 (depth = 9)
  int op_slot_right_7853 = gc_frame_newslot(strlit7854);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7853 = gc_frame_newslot(*var_s);
  params[0] = strlit7854;
  partcv[0] = 1;
  Object opresult7856 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7856 (depth = 8)
  int op_slot_left_7851 = gc_frame_newslot(opresult7856);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7857 = callmethod(opresult7856, "++", 1, partcv, params);
// compiled op node returning opresult7857 (depth = 7)
  int op_slot_left_7848 = gc_frame_newslot(opresult7857);
  params[0] = strlit7849;
  partcv[0] = 1;
  Object opresult7858 = callmethod(opresult7857, "++", 1, partcv, params);
// compiled op node returning opresult7858 (depth = 6)
  int op_slot_left_7838 = gc_frame_newslot(opresult7858);
  params[0] = call7846;
  partcv[0] = 1;
  Object opresult7859 = callmethod(opresult7858, "++", 1, partcv, params);
// compiled op node returning opresult7859 (depth = 5)
  *var_s = opresult7859;
  if (opresult7859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7831 = done;
  } else {
  }
// compiled if node returning if7831 (depth = 3)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7862 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7863 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7864 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7865 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7864);
// compiled call node returning call7865 (depth = 9)
// compiled member node returning call7865 (depth = 8)
  partcv[0] = 0;
  Object call7866 = callmethod(call7865, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe7863);
// compiled call node returning call7866 (depth = 7)
// compiled member node returning call7866 (depth = 6)
  partcv[0] = 0;
  Object call7867 = callmethod(call7866, "not",
    1, partcv, params);
  gc_frame_end(callframe7862);
// compiled call node returning call7867 (depth = 5)
// compiled member node returning call7867 (depth = 4)
  Object if7861 = done;
  if (istrue(call7867)) {
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7870 == NULL) {
    strlit7870 = alloc_String("Annotations:");
    gc_root(strlit7870);
  }
// compiled string node returning strlit7870 (depth = 7)
  int op_slot_right_7869 = gc_frame_newslot(strlit7870);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_7872 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 8)
  if (strlit7874 == NULL) {
    strlit7874 = alloc_String("""\x0a""");
    gc_root(strlit7874);
  }
// compiled string node returning strlit7874 (depth = 8)
  int op_slot_left_7872 = gc_frame_newslot(strlit7874);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7875 = callmethod(strlit7874, "++", 1, partcv, params);
// compiled op node returning opresult7875 (depth = 7)
  int op_slot_left_7869 = gc_frame_newslot(opresult7875);
  params[0] = strlit7870;
  partcv[0] = 1;
  Object opresult7876 = callmethod(opresult7875, "++", 1, partcv, params);
// compiled op node returning opresult7876 (depth = 6)
  int op_slot_right_7868 = gc_frame_newslot(opresult7876);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7868 = gc_frame_newslot(*var_s);
  params[0] = opresult7876;
  partcv[0] = 1;
  Object opresult7878 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7878 (depth = 5)
  *var_s = opresult7878;
  if (opresult7878 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7880 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7881 = alloc_Block(NULL, NULL, "ast", 1982);
  gc_frame_newslot(block7881);
// method "_apply"
  block_savedest(block7881);
  Object closure7882 = createclosure(3, "_apply");
  setclosureframe(closure7882, stackframe);
  addtoclosure(closure7882, var_depth);
  addtoclosure(closure7882, var_s);
  addtoclosure(closure7882, selfslot);
  struct UserObject *uo7882 = (struct UserObject*)block7881;
  uo7882->data[0] = (Object)closure7882;
  Method *meth_meth_ast__apply7882 = addmethod2pos(block7881, "_apply", &meth_ast__apply7882, 0);
  int argcv_meth_ast__apply7882[] = {1};
  meth_meth_ast__apply7882->type = alloc_MethodType(1, argcv_meth_ast__apply7882);
  meth_meth_ast__apply7882->definitionModule = modulename;
  meth_meth_ast__apply7882->definitionLine = 1980;
// compiled block node returning block7881 (depth = 5)
  gc_frame_newslot(block7881);
// call case 6: other member request
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7906 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7907 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7906);
// compiled call node returning call7907 (depth = 6)
// compiled member node returning call7907 (depth = 5)
  params[0] = block7881;
  partcv[0] = 1;
  Object call7908 = callmethod(call7907, "do",
    1, partcv, params);
  gc_frame_end(callframe7880);
// compiled call node returning call7908 (depth = 4)
    gc_frame_newslot(call7908);
    if7861 = call7908;
  } else {
  }
// compiled if node returning if7861 (depth = 3)
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7911 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7912 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7911);
// compiled call node returning call7912 (depth = 6)
// compiled member node returning call7912 (depth = 5)
  int op_slot_right_7910 = gc_frame_newslot(call7912);
// starting to compile identifier node (depth = 5)
  Object bool7914 = alloc_Boolean(0);
// compiled identifier node returning bool7914 (depth = 5)
  int op_slot_left_7910 = gc_frame_newslot(bool7914);
  params[0] = call7912;
  partcv[0] = 1;
  Object opresult7915 = callmethod(bool7914, "≠", 1, partcv, params);
// compiled op node returning opresult7915 (depth = 4)
  Object if7909 = done;
  if (istrue(opresult7915)) {
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7917 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7919 = alloc_Float64(2);
// compiled num node returning num7919 (depth = 8)
  int op_slot_right_7918 = gc_frame_newslot(num7919);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7918 = gc_frame_newslot(*var_depth);
  params[0] = num7919;
  partcv[0] = 1;
  Object sum7921 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7921 (depth = 7)
  gc_frame_newslot(sum7921);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7923 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7922);
// compiled call node returning call7923 (depth = 8)
// compiled member node returning call7923 (depth = 7)
  params[0] = sum7921;
  partcv[0] = 1;
  Object call7924 = callmethod(call7923, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7917);
// compiled call node returning call7924 (depth = 6)
  int op_slot_right_7916 = gc_frame_newslot(call7924);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7916 = gc_frame_newslot(*var_s);
  params[0] = call7924;
  partcv[0] = 1;
  Object opresult7926 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7926 (depth = 5)
  *var_s = opresult7926;
  if (opresult7926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7909 = done;
  } else {
  }
// compiled if node returning if7909 (depth = 3)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7940(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7942 == NULL) {
    strlit7942 = alloc_String("    ");
    gc_root(strlit7942);
  }
// compiled string node returning strlit7942 (depth = 7)
  int op_slot_right_7941 = gc_frame_newslot(strlit7942);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_7941 = gc_frame_newslot(*var_spc);
  params[0] = strlit7942;
  partcv[0] = 1;
  Object opresult7944 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7944 (depth = 6)
  *var_spc = opresult7944;
  if (opresult7944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7964(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7966 == NULL) {
    strlit7966 = alloc_String("Unknown");
    gc_root(strlit7966);
  }
// compiled string node returning strlit7966 (depth = 7)
  int op_slot_right_7965 = gc_frame_newslot(strlit7966);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7968 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7970 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7969);
// compiled call node returning call7970 (depth = 10)
// compiled member node returning call7970 (depth = 9)
  partcv[0] = 0;
  Object call7971 = callmethod(call7970, "value",
    1, partcv, params);
  gc_frame_end(callframe7968);
// compiled call node returning call7971 (depth = 8)
// compiled member node returning call7971 (depth = 7)
  int op_slot_left_7965 = gc_frame_newslot(call7971);
  params[0] = strlit7966;
  partcv[0] = 1;
  Object opresult7972 = callmethod(call7971, "≠", 1, partcv, params);
// compiled op node returning opresult7972 (depth = 6)
  gc_frame_end(frame);
  return opresult7972;
}
Object meth_ast__apply8012(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8014 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8015 = alloc_Float64(0);
// compiled num node returning num8015 (depth = 10)
  gc_frame_newslot(num8015);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8015;
  partcv[0] = 1;
  Object call8016 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8014);
// compiled call node returning call8016 (depth = 9)
  int op_slot_right_8013 = gc_frame_newslot(call8016);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8020 == NULL) {
    strlit8020 = alloc_String("");
    gc_root(strlit8020);
  }
// compiled string node returning strlit8020 (depth = 11)
  int op_slot_right_8019 = gc_frame_newslot(strlit8020);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8019 = gc_frame_newslot(*var_a);
  params[0] = strlit8020;
  partcv[0] = 1;
  Object opresult8022 = callmethod(*var_a, "≠", 1, partcv, params);
// compiled op node returning opresult8022 (depth = 10)
  Object if8018 = done;
struct StackFrameObject *iftmpstackframe8018 = stackframe;
  if (istrue(opresult8022)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8018);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8024 == NULL) {
    strlit8024 = alloc_String(", ");
    gc_root(strlit8024);
  }
// compiled string node returning strlit8024 (depth = 11)
  int op_slot_right_8023 = gc_frame_newslot(strlit8024);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8023 = gc_frame_newslot(*var_a);
  params[0] = strlit8024;
  partcv[0] = 1;
  Object opresult8026 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8026 (depth = 10)
    gc_frame_newslot(opresult8026);
    if8018 = opresult8026;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8018);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8027 == NULL) {
    strlit8027 = alloc_String("");
    gc_root(strlit8027);
  }
// compiled string node returning strlit8027 (depth = 10)
    gc_frame_newslot(strlit8027);
    if8018 = strlit8027;
  }
stackframe = iftmpstackframe8018;
// compiled if node returning if8018 (depth = 9)
  int op_slot_left_8013 = gc_frame_newslot(if8018);
  params[0] = call8016;
  partcv[0] = 1;
  Object opresult8028 = callmethod(if8018, "++", 1, partcv, params);
// compiled op node returning opresult8028 (depth = 8)
  gc_frame_end(frame);
  return opresult8028;
}
Object meth_ast_toGrace7928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7929 == NULL) {
    strlit7929 = alloc_String("");
    gc_root(strlit7929);
  }
// compiled string node returning strlit7929 (depth = 4)
  *var_spc = strlit7929;
  if (strlit7929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7930 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7933 = alloc_Float64(1);
// compiled num node returning num7933 (depth = 6)
  int op_slot_right_7932 = gc_frame_newslot(num7933);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_left_7932 = gc_frame_newslot(*var_depth);
  params[0] = num7933;
  partcv[0] = 1;
  Object diff7935 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7935 (depth = 5)
  int op_slot_right_7931 = gc_frame_newslot(diff7935);
// starting to compile num node (depth = 5)
  Object num7937 = alloc_Float64(0);
// compiled num node returning num7937 (depth = 5)
  int op_slot_left_7931 = gc_frame_newslot(num7937);
  params[0] = diff7935;
  partcv[0] = 1;
  Object opresult7938 = callmethod(num7937, "..", 1, partcv, params);
// compiled op node returning opresult7938 (depth = 4)
  gc_frame_newslot(opresult7938);
// starting to compile block node (depth = 4)
  Object block7939 = alloc_Block(NULL, NULL, "ast", 1993);
  gc_frame_newslot(block7939);
// method "_apply"
  block_savedest(block7939);
  Object closure7940 = createclosure(2, "_apply");
  setclosureframe(closure7940, stackframe);
  addtoclosure(closure7940, var_spc);
  addtoclosure(closure7940, selfslot);
  struct UserObject *uo7940 = (struct UserObject*)block7939;
  uo7940->data[0] = (Object)closure7940;
  Method *meth_meth_ast__apply7940 = addmethod2pos(block7939, "_apply", &meth_ast__apply7940, 0);
  int argcv_meth_ast__apply7940[] = {1};
  meth_meth_ast__apply7940->type = alloc_MethodType(1, argcv_meth_ast__apply7940);
  meth_meth_ast__apply7940->definitionModule = modulename;
  meth_meth_ast__apply7940->definitionLine = 1987;
// compiled block node returning block7939 (depth = 4)
  gc_frame_newslot(block7939);
// call case 5: prelude request
  params[0] = opresult7938;
  params[1] = block7939;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7947 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7930);
// compiled call node returning call7947 (depth = 3)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7949 == NULL) {
    strlit7949 = alloc_String("");
    gc_root(strlit7949);
  }
// compiled string node returning strlit7949 (depth = 5)
  int op_slot_right_7948 = gc_frame_newslot(strlit7949);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7952 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7953 = alloc_Float64(0);
// compiled num node returning num7953 (depth = 7)
  gc_frame_newslot(num7953);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7954 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7955 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7954);
// compiled call node returning call7955 (depth = 8)
// compiled member node returning call7955 (depth = 7)
  params[0] = num7953;
  partcv[0] = 1;
  Object call7956 = callmethod(call7955, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7952);
// compiled call node returning call7956 (depth = 6)
  int op_slot_right_7951 = gc_frame_newslot(call7956);
// starting to compile string node (depth = 6)
  if (strlit7958 == NULL) {
    strlit7958 = alloc_String("def ");
    gc_root(strlit7958);
  }
// compiled string node returning strlit7958 (depth = 6)
  int op_slot_left_7951 = gc_frame_newslot(strlit7958);
  params[0] = call7956;
  partcv[0] = 1;
  Object opresult7959 = callmethod(strlit7958, "++", 1, partcv, params);
// compiled op node returning opresult7959 (depth = 5)
  int op_slot_left_7948 = gc_frame_newslot(opresult7959);
  params[0] = strlit7949;
  partcv[0] = 1;
  Object opresult7960 = callmethod(opresult7959, "++", 1, partcv, params);
// compiled op node returning opresult7960 (depth = 4)
  *var_s = opresult7960;
  if (opresult7960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7963 = alloc_Block(NULL, NULL, "ast", 1997);
  gc_frame_newslot(block7963);
// method "_apply"
  block_savedest(block7963);
  Object closure7964 = createclosure(1, "_apply");
  setclosureframe(closure7964, stackframe);
  addtoclosure(closure7964, selfslot);
  struct UserObject *uo7964 = (struct UserObject*)block7963;
  uo7964->data[0] = (Object)closure7964;
  Method *meth_meth_ast__apply7964 = addmethod2pos(block7963, "_apply", &meth_ast__apply7964, 0);
  int argcv_meth_ast__apply7964[] = {0};
  meth_meth_ast__apply7964->type = alloc_MethodType(1, argcv_meth_ast__apply7964);
  meth_meth_ast__apply7964->definitionModule = modulename;
  meth_meth_ast__apply7964->definitionLine = 1996;
// compiled block node returning block7963 (depth = 5)
  int op_slot_right_7962 = gc_frame_newslot(block7963);
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7976 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7977 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7976);
// compiled call node returning call7977 (depth = 7)
// compiled member node returning call7977 (depth = 6)
  int op_slot_right_7975 = gc_frame_newslot(call7977);
// starting to compile identifier node (depth = 6)
  Object bool7979 = alloc_Boolean(0);
// compiled identifier node returning bool7979 (depth = 6)
  int op_slot_left_7975 = gc_frame_newslot(bool7979);
  params[0] = call7977;
  partcv[0] = 1;
  Object opresult7980 = callmethod(bool7979, "≠", 1, partcv, params);
// compiled op node returning opresult7980 (depth = 5)
  int op_slot_left_7962 = gc_frame_newslot(opresult7980);
  params[0] = block7963;
  partcv[0] = 1;
  Object opresult7981 = callmethod(opresult7980, "&&", 1, partcv, params);
// compiled op node returning opresult7981 (depth = 4)
  Object if7961 = done;
  if (istrue(opresult7981)) {
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7983 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7984 = alloc_Float64(0);
// compiled num node returning num7984 (depth = 7)
  gc_frame_newslot(num7984);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7985 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7986 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7985);
// compiled call node returning call7986 (depth = 8)
// compiled member node returning call7986 (depth = 7)
  params[0] = num7984;
  partcv[0] = 1;
  Object call7987 = callmethod(call7986, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7983);
// compiled call node returning call7987 (depth = 6)
  int op_slot_right_7982 = gc_frame_newslot(call7987);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7990 == NULL) {
    strlit7990 = alloc_String(" : ");
    gc_root(strlit7990);
  }
// compiled string node returning strlit7990 (depth = 7)
  int op_slot_right_7989 = gc_frame_newslot(strlit7990);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7989 = gc_frame_newslot(*var_s);
  params[0] = strlit7990;
  partcv[0] = 1;
  Object opresult7992 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7992 (depth = 6)
  int op_slot_left_7982 = gc_frame_newslot(opresult7992);
  params[0] = call7987;
  partcv[0] = 1;
  Object opresult7993 = callmethod(opresult7992, "++", 1, partcv, params);
// compiled op node returning opresult7993 (depth = 5)
  *var_s = opresult7993;
  if (opresult7993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7961 = done;
  } else {
  }
// compiled if node returning if7961 (depth = 3)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7997 = alloc_Float64(0);
// compiled num node returning num7997 (depth = 5)
  int op_slot_right_7996 = gc_frame_newslot(num7997);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7999 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8001 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8000);
// compiled call node returning call8001 (depth = 8)
// compiled member node returning call8001 (depth = 7)
  partcv[0] = 0;
  Object call8002 = callmethod(call8001, "size",
    1, partcv, params);
  gc_frame_end(callframe7999);
// compiled call node returning call8002 (depth = 6)
// compiled member node returning call8002 (depth = 5)
  int op_slot_left_7996 = gc_frame_newslot(call8002);
  params[0] = num7997;
  partcv[0] = 1;
  Object opresult8003 = callmethod(call8002, ">", 1, partcv, params);
// compiled op node returning opresult8003 (depth = 4)
  Object if7995 = done;
  if (istrue(opresult8003)) {
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8005 == NULL) {
    strlit8005 = alloc_String(" is ");
    gc_root(strlit8005);
  }
// compiled string node returning strlit8005 (depth = 6)
  int op_slot_right_8004 = gc_frame_newslot(strlit8005);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8004 = gc_frame_newslot(*var_s);
  params[0] = strlit8005;
  partcv[0] = 1;
  Object opresult8007 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8007 (depth = 5)
  *var_s = opresult8007;
  if (opresult8007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8010 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8011 = alloc_Block(NULL, NULL, "ast", 2003);
  gc_frame_newslot(block8011);
// method "_apply"
  block_savedest(block8011);
  Object closure8012 = createclosure(1, "_apply");
  setclosureframe(closure8012, stackframe);
  addtoclosure(closure8012, selfslot);
  struct UserObject *uo8012 = (struct UserObject*)block8011;
  uo8012->data[0] = (Object)closure8012;
  Method *meth_meth_ast__apply8012 = addmethod2pos(block8011, "_apply", &meth_ast__apply8012, 0);
  int argcv_meth_ast__apply8012[] = {2};
  meth_meth_ast__apply8012->type = alloc_MethodType(1, argcv_meth_ast__apply8012);
  meth_meth_ast__apply8012->definitionModule = modulename;
  meth_meth_ast__apply8012->definitionLine = 2001;
// compiled block node returning block8011 (depth = 7)
  gc_frame_newslot(block8011);
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8030 == NULL) {
    strlit8030 = alloc_String("");
    gc_root(strlit8030);
  }
// compiled string node returning strlit8030 (depth = 7)
  gc_frame_newslot(strlit8030);
// call case 6: other member request
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8032 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8031);
// compiled call node returning call8032 (depth = 8)
// compiled member node returning call8032 (depth = 7)
  params[0] = block8011;
  params[1] = strlit8030;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8033 = callmethod(call8032, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe8010);
// compiled call node returning call8033 (depth = 6)
  int op_slot_right_8009 = gc_frame_newslot(call8033);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8009 = gc_frame_newslot(*var_s);
  params[0] = call8033;
  partcv[0] = 1;
  Object opresult8035 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8035 (depth = 5)
  *var_s = opresult8035;
  if (opresult8035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7995 = done;
  } else {
  }
// compiled if node returning if7995 (depth = 3)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8039 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8040 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8039);
// compiled call node returning call8040 (depth = 6)
// compiled member node returning call8040 (depth = 5)
  int op_slot_right_8038 = gc_frame_newslot(call8040);
// starting to compile identifier node (depth = 5)
  Object bool8042 = alloc_Boolean(0);
// compiled identifier node returning bool8042 (depth = 5)
  int op_slot_left_8038 = gc_frame_newslot(bool8042);
  params[0] = call8040;
  partcv[0] = 1;
  Object opresult8043 = callmethod(bool8042, "≠", 1, partcv, params);
// compiled op node returning opresult8043 (depth = 4)
  Object if8037 = done;
  if (istrue(opresult8043)) {
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8045 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8047 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8046);
// compiled call node returning call8047 (depth = 8)
// compiled member node returning call8047 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8048 = callmethod(call8047, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8045);
// compiled call node returning call8048 (depth = 6)
  int op_slot_right_8044 = gc_frame_newslot(call8048);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8051 == NULL) {
    strlit8051 = alloc_String(" = ");
    gc_root(strlit8051);
  }
// compiled string node returning strlit8051 (depth = 7)
  int op_slot_right_8050 = gc_frame_newslot(strlit8051);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8050 = gc_frame_newslot(*var_s);
  params[0] = strlit8051;
  partcv[0] = 1;
  Object opresult8053 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8053 (depth = 6)
  int op_slot_left_8044 = gc_frame_newslot(opresult8053);
  params[0] = call8048;
  partcv[0] = 1;
  Object opresult8054 = callmethod(opresult8053, "++", 1, partcv, params);
// compiled op node returning opresult8054 (depth = 5)
  *var_s = opresult8054;
  if (opresult8054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8037 = done;
  } else {
  }
// compiled if node returning if8037 (depth = 3)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8057 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8058 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8060 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8059);
// compiled call node returning call8060 (depth = 6)
// compiled member node returning call8060 (depth = 5)
  gc_frame_newslot(call8060);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8061 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8062 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8061);
// compiled call node returning call8062 (depth = 6)
// compiled member node returning call8062 (depth = 5)
  gc_frame_newslot(call8062);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8064 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8063);
// compiled call node returning call8064 (depth = 6)
// compiled member node returning call8064 (depth = 5)
  gc_frame_newslot(call8064);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defDecNode (depth = 5)
  params[0] = call8060;
  params[1] = call8062;
  params[2] = call8064;
  partcv[0] = 3;
  Object call8065 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8058);
// compiled call node returning call8065 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8066 = callmethod(call8065, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8057);
// compiled call node returning call8066 (depth = 3)
  gc_frame_end(frame);
  return call8066;
}
Object meth_ast_shallowCopyFieldsFrom8067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8068 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call8069 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8068);
// compiled call node returning call8069 (depth = 3)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8070 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call8072 = callmethod(*var_other, "startToken",
    1, partcv, params);
  gc_frame_end(callframe8071);
// compiled call node returning call8072 (depth = 5)
// compiled member node returning call8072 (depth = 4)
  gc_frame_newslot(call8072);
// call case 4: self request
  params[0] = call8072;
  partcv[0] = 1;
  Object call8073 = callmethodflags(self, "startToken:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8070);
// compiled call node returning call8073 (depth = 3)
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName8074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8075 == NULL) {
    strlit8075 = alloc_String("definition");
    gc_root(strlit8075);
  }
// compiled string node returning strlit8075 (depth = 3)
  gc_frame_end(frame);
  return strlit8075;
}
Object meth_ast_new7632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7633 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7633 = alloc_userobj2(27,23, objclass7633);
  gc_frame_newslot(obj7633);
if (objclass7633 == NULL) {
  glfree(obj7633->class->name);
  obj7633->class->name = "defDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7633, self, 0);
  addmethodreal(obj7633,"outer", &reader_ast_outer_7634);
  Object oldself7633 = self;
  struct StackFrameObject *oldstackframe7633 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7633);
  gc_frame_newslot((Object)stackframe);
  self = obj7633;
  Object *oldselfslot7633 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7633 = (*(struct UserObject *)self).data[0], lowerouter7633 = thisouter7633;
  if (inheritingObject7633) {
    struct UserObject *inho7633 = (struct UserObject *)inheritingObject7633;
    while (inho7633->super != GraceDefaultObject) inho7633 = (struct UserObject *)inho7633->super;
    inho7633->super = obj7633;
    self = inheritingObject7633;
    *selfslot = self;
    lowerouter7633 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7633;
  }
if (objclass7633 == NULL) {
  Method *reader7635 = addmethodrealflags(obj7633, "kind",&reader_ast_kind_7635, MFLAG_DEF);
  reader7635->definitionModule = modulename;
  reader7635->definitionLine = 1915;
}
adddatum2(obj7633, alloc_Undefined(), 1);
if (objclass7633 == NULL) {
  Method *reader7636 = addmethodrealflags(obj7633, "name",&reader_ast_name_7636, 0);
  Method *writer7636 = addmethodrealflags(obj7633, "name:=",&writer_ast_name_7636, 0);
  reader7636->definitionModule = modulename;
  writer7636->definitionModule = modulename;
  reader7636->definitionLine = 1916;
  writer7636->definitionLine = 1916;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 2);
if (objclass7633 == NULL) {
  Method *reader7637 = addmethodrealflags(obj7633, "value",&reader_ast_value_7637, 0);
  Method *writer7637 = addmethodrealflags(obj7633, "value:=",&writer_ast_value_7637, 0);
  reader7637->definitionModule = modulename;
  writer7637->definitionModule = modulename;
  reader7637->definitionLine = 1917;
  writer7637->definitionLine = 1917;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 3);
if (objclass7633 == NULL) {
  Method *reader7638 = addmethodrealflags(obj7633, "dtype",&reader_ast_dtype_7638, 0);
  Method *writer7638 = addmethodrealflags(obj7633, "dtype:=",&writer_ast_dtype_7638, 0);
  reader7638->definitionModule = modulename;
  writer7638->definitionModule = modulename;
  reader7638->definitionLine = 1918;
  writer7638->definitionLine = 1918;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 4);
if (objclass7633 == NULL) {
  Method *reader7639 = addmethodrealflags(obj7633, "nameString",&reader_ast_nameString_7639, MFLAG_DEF);
  reader7639->definitionModule = modulename;
  reader7639->definitionLine = 1919;
}
adddatum2(obj7633, alloc_Undefined(), 5);
if (objclass7633 == NULL) {
  Method *reader7640 = addmethodrealflags(obj7633, "annotations",&reader_ast_annotations_7640, 0);
  Method *writer7640 = addmethodrealflags(obj7633, "annotations:=",&writer_ast_annotations_7640, 0);
  reader7640->definitionModule = modulename;
  writer7640->definitionModule = modulename;
  reader7640->definitionLine = 1920;
  writer7640->definitionLine = 1920;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 6);
if (objclass7633 == NULL) {
  Method *reader7641 = addmethodrealflags(obj7633, "startToken",&reader_ast_startToken_7641, 0);
  Method *writer7641 = addmethodrealflags(obj7633, "startToken:=",&writer_ast_startToken_7641, 0);
  reader7641->definitionModule = modulename;
  writer7641->definitionModule = modulename;
  reader7641->definitionLine = 1921;
  writer7641->definitionLine = 1921;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7642 = (struct UserObject*)obj7633;
  uo7642->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7642 = addmethod2pos(obj7633, "isPublic", &meth_ast_isPublic7642, 8);
  int argcv_meth_ast_isPublic7642[] = {0};
  meth_meth_ast_isPublic7642->type = alloc_MethodType(1, argcv_meth_ast_isPublic7642);
  meth_meth_ast_isPublic7642->definitionModule = modulename;
  meth_meth_ast_isPublic7642->definitionLine = 1923;
// method "isFieldDec"
  struct UserObject *uo7669 = (struct UserObject*)obj7633;
  uo7669->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7669 = addmethod2pos(obj7633, "isFieldDec", &meth_ast_isFieldDec7669, 9);
  int argcv_meth_ast_isFieldDec7669[] = {0};
  meth_meth_ast_isFieldDec7669->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7669);
  meth_meth_ast_isFieldDec7669->definitionModule = modulename;
  meth_meth_ast_isFieldDec7669->definitionLine = 1929;
// method "isWritable"
  struct UserObject *uo7671 = (struct UserObject*)obj7633;
  uo7671->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7671 = addmethod2pos(obj7633, "isWritable", &meth_ast_isWritable7671, 10);
  int argcv_meth_ast_isWritable7671[] = {0};
  meth_meth_ast_isWritable7671->type = alloc_MethodType(1, argcv_meth_ast_isWritable7671);
  meth_meth_ast_isWritable7671->definitionModule = modulename;
  meth_meth_ast_isWritable7671->definitionLine = 1930;
// method "isReadable"
  struct UserObject *uo7673 = (struct UserObject*)obj7633;
  uo7673->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7673 = addmethod2pos(obj7633, "isReadable", &meth_ast_isReadable7673, 11);
  int argcv_meth_ast_isReadable7673[] = {0};
  meth_meth_ast_isReadable7673->type = alloc_MethodType(1, argcv_meth_ast_isReadable7673);
  meth_meth_ast_isReadable7673->definitionModule = modulename;
  meth_meth_ast_isReadable7673->definitionLine = 1931;
// method "returnsObject"
  struct UserObject *uo7676 = (struct UserObject*)obj7633;
  uo7676->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7676 = addmethod2pos(obj7633, "returnsObject", &meth_ast_returnsObject7676, 12);
  int argcv_meth_ast_returnsObject7676[] = {0};
  meth_meth_ast_returnsObject7676->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7676);
  meth_meth_ast_returnsObject7676->definitionModule = modulename;
  meth_meth_ast_returnsObject7676->definitionLine = 1933;
// method "returnedObjectScope"
  struct UserObject *uo7681 = (struct UserObject*)obj7633;
  uo7681->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7681 = addmethod2pos(obj7633, "returnedObjectScope", &meth_ast_returnedObjectScope7681, 13);
  int argcv_meth_ast_returnedObjectScope7681[] = {0};
  meth_meth_ast_returnedObjectScope7681->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7681);
  meth_meth_ast_returnedObjectScope7681->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7681->definitionLine = 1936;
// method "usesAsType"
  struct UserObject *uo7686 = (struct UserObject*)obj7633;
  uo7686->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType7686 = addmethod2pos(obj7633, "usesAsType", &meth_ast_usesAsType7686, 14);
  int argcv_meth_ast_usesAsType7686[] = {1};
  meth_meth_ast_usesAsType7686->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7686);
  meth_meth_ast_usesAsType7686->definitionModule = modulename;
  meth_meth_ast_usesAsType7686->definitionLine = 1940;
// method "declarationKindWithAncestors"
  block_savedest(obj7633);
  Object closure7692 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure7692, stackframe);
  addtoclosure(closure7692, var_k);
  struct UserObject *uo7692 = (struct UserObject*)obj7633;
  uo7692->data[15] = (Object)closure7692;
  Method *meth_meth_ast_declarationKindWithAncestors7692 = addmethod2pos(obj7633, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7692, 15);
  int argcv_meth_ast_declarationKindWithAncestors7692[] = {1};
  meth_meth_ast_declarationKindWithAncestors7692->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7692);
  meth_meth_ast_declarationKindWithAncestors7692->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7692->definitionLine = 1943;
// method "accept()from"
  struct UserObject *uo7695 = (struct UserObject*)obj7633;
  uo7695->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7695 = addmethod2pos(obj7633, "accept()from", &meth_ast_accept_40__41_from7695, 16);
  int argcv_meth_ast_accept_40__41_from7695[] = {1, 1};
  meth_meth_ast_accept_40__41_from7695->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7695);
  meth_meth_ast_accept_40__41_from7695->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7695->definitionLine = 1945;
// method "map()ancestors"
  struct UserObject *uo7729 = (struct UserObject*)obj7633;
  uo7729->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7729 = addmethod2pos(obj7633, "map()ancestors", &meth_ast_map_40__41_ancestors7729, 17);
  int argcv_meth_ast_map_40__41_ancestors7729[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7729->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7729);
  meth_meth_ast_map_40__41_ancestors7729->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7729->definitionLine = 1958;
// method "pretty"
  struct UserObject *uo7768 = (struct UserObject*)obj7633;
  uo7768->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty7768 = addmethod2pos(obj7633, "pretty", &meth_ast_pretty7768, 18);
  int argcv_meth_ast_pretty7768[] = {1};
  meth_meth_ast_pretty7768->type = alloc_MethodType(1, argcv_meth_ast_pretty7768);
  meth_meth_ast_pretty7768->definitionModule = modulename;
  meth_meth_ast_pretty7768->definitionLine = 1967;
// method "toGrace"
  struct UserObject *uo7928 = (struct UserObject*)obj7633;
  uo7928->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace7928 = addmethod2pos(obj7633, "toGrace", &meth_ast_toGrace7928, 19);
  int argcv_meth_ast_toGrace7928[] = {1};
  meth_meth_ast_toGrace7928->type = alloc_MethodType(1, argcv_meth_ast_toGrace7928);
meth_meth_ast_toGrace7928->type->types[0] = type_Number;
meth_meth_ast_toGrace7928->type->names[0] = "depth";
  meth_meth_ast_toGrace7928->definitionModule = modulename;
  meth_meth_ast_toGrace7928->definitionLine = 1991;
// method "shallowCopy"
  block_savedest(obj7633);
  Object closure8056 = createclosure(1, "shallowCopy");
  setclosureframe(closure8056, stackframe);
  addtoclosure(closure8056, var_defDecNode);
  struct UserObject *uo8056 = (struct UserObject*)obj7633;
  uo8056->data[20] = (Object)closure8056;
  Method *meth_meth_ast_shallowCopy8056 = addmethod2pos(obj7633, "shallowCopy", &meth_ast_shallowCopy8056, 20);
  int argcv_meth_ast_shallowCopy8056[] = {0};
  meth_meth_ast_shallowCopy8056->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8056);
  meth_meth_ast_shallowCopy8056->definitionModule = modulename;
  meth_meth_ast_shallowCopy8056->definitionLine = 2012;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo8067 = (struct UserObject*)obj7633;
  uo8067->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8067 = addmethod2pos(obj7633, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8067, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom8067[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8067->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8067);
  meth_meth_ast_shallowCopyFieldsFrom8067->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8067->definitionLine = 2015;
// method "statementName"
  struct UserObject *uo8074 = (struct UserObject*)obj7633;
  uo8074->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8074 = addmethod2pos(obj7633, "statementName", &meth_ast_statementName8074, 22);
  int argcv_meth_ast_statementName8074[] = {0};
  meth_meth_ast_statementName8074->type = alloc_MethodType(1, argcv_meth_ast_statementName8074);
  meth_meth_ast_statementName8074->definitionModule = modulename;
  meth_meth_ast_statementName8074->definitionLine = 2020;
  sourceObject = obj7633;
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8076 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8077 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8078 = gc_frame_new();
// call case 3: self.outer request
  Object call8079 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8078);
// compiled call node returning call8079 (depth = 7)
// compiled member node returning call8079 (depth = 6)
  partcv[0] = 0;
  Object call8080 = callmethodflags(call8079, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8077);
// compiled call node returning call8080 (depth = 5)
// compiled member node returning call8080 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8081 = callmethodflags(call8080, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8076);
// compiled call node returning call8081 (depth = 3)
  struct UserObject *obj7633_uo = (struct UserObject *)obj7633;
  obj7633_uo->super = call8081;
  sourceObject = obj7633;
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8082 == NULL) {
    strlit8082 = alloc_String("defdec");
    gc_root(strlit8082);
  }
// compiled string node returning strlit8082 (depth = 3)
  adddatum2(obj7633, strlit8082, 1);
  sourceObject = obj7633;
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7633, *var_name_39_, 2);
  sourceObject = obj7633;
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7633, *var_val, 3);
  sourceObject = obj7633;
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7633, *var_dtype_39_, 4);
  sourceObject = obj7633;
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8083 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8084 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8085 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8084);
// compiled call node returning call8085 (depth = 6)
// compiled member node returning call8085 (depth = 5)
  partcv[0] = 0;
  Object call8086 = callmethod(call8085, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8083);
// compiled call node returning call8086 (depth = 4)
// compiled member node returning call8086 (depth = 3)
  adddatum2(obj7633, call8086, 5);
  sourceObject = obj7633;
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8087 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8087 (depth = 3)
  adddatum2(obj7633, array8087, 6);
  sourceObject = obj7633;
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8088 = alloc_Boolean(0);
// compiled identifier node returning bool8088 (depth = 3)
  adddatum2(obj7633, bool8088, 7);
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  objclass7633 = obj7633->class;
  objclass7633->definitionModule = modulename;
  objclass7633->definitionLine = 1913;
  (*(struct UserObject *)self).data[0] = lowerouter7633;
  self = oldself7633;
  selfslot = oldselfslot7633;
  stackframe = oldstackframe7633;
  gc_frame_end(frame);
  return obj7633;
}
Object meth_ast_new7632_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_defDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7633 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7633 = alloc_userobj2(27,23, objclass7633);
  gc_frame_newslot(obj7633);
if (objclass7633 == NULL) {
  glfree(obj7633->class->name);
  obj7633->class->name = "defDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7633, self, 0);
  addmethodreal(obj7633,"outer", &reader_ast_outer_7634);
  Object oldself7633 = self;
  struct StackFrameObject *oldstackframe7633 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7633);
  gc_frame_newslot((Object)stackframe);
  self = obj7633;
  Object *oldselfslot7633 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7633 = (*(struct UserObject *)self).data[0], lowerouter7633 = thisouter7633;
  if (inheritingObject7633) {
    struct UserObject *inho7633 = (struct UserObject *)inheritingObject7633;
    while (inho7633->super != GraceDefaultObject) inho7633 = (struct UserObject *)inho7633->super;
    inho7633->super = obj7633;
    self = inheritingObject7633;
    *selfslot = self;
    lowerouter7633 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7633;
  }
if (objclass7633 == NULL) {
  Method *reader7635 = addmethodrealflags(obj7633, "kind",&reader_ast_kind_7635, MFLAG_DEF);
  reader7635->definitionModule = modulename;
  reader7635->definitionLine = 1915;
}
adddatum2(obj7633, alloc_Undefined(), 1);
if (objclass7633 == NULL) {
  Method *reader7636 = addmethodrealflags(obj7633, "name",&reader_ast_name_7636, 0);
  Method *writer7636 = addmethodrealflags(obj7633, "name:=",&writer_ast_name_7636, 0);
  reader7636->definitionModule = modulename;
  writer7636->definitionModule = modulename;
  reader7636->definitionLine = 1916;
  writer7636->definitionLine = 1916;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 2);
if (objclass7633 == NULL) {
  Method *reader7637 = addmethodrealflags(obj7633, "value",&reader_ast_value_7637, 0);
  Method *writer7637 = addmethodrealflags(obj7633, "value:=",&writer_ast_value_7637, 0);
  reader7637->definitionModule = modulename;
  writer7637->definitionModule = modulename;
  reader7637->definitionLine = 1917;
  writer7637->definitionLine = 1917;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 3);
if (objclass7633 == NULL) {
  Method *reader7638 = addmethodrealflags(obj7633, "dtype",&reader_ast_dtype_7638, 0);
  Method *writer7638 = addmethodrealflags(obj7633, "dtype:=",&writer_ast_dtype_7638, 0);
  reader7638->definitionModule = modulename;
  writer7638->definitionModule = modulename;
  reader7638->definitionLine = 1918;
  writer7638->definitionLine = 1918;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 4);
if (objclass7633 == NULL) {
  Method *reader7639 = addmethodrealflags(obj7633, "nameString",&reader_ast_nameString_7639, MFLAG_DEF);
  reader7639->definitionModule = modulename;
  reader7639->definitionLine = 1919;
}
adddatum2(obj7633, alloc_Undefined(), 5);
if (objclass7633 == NULL) {
  Method *reader7640 = addmethodrealflags(obj7633, "annotations",&reader_ast_annotations_7640, 0);
  Method *writer7640 = addmethodrealflags(obj7633, "annotations:=",&writer_ast_annotations_7640, 0);
  reader7640->definitionModule = modulename;
  writer7640->definitionModule = modulename;
  reader7640->definitionLine = 1920;
  writer7640->definitionLine = 1920;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 6);
if (objclass7633 == NULL) {
  Method *reader7641 = addmethodrealflags(obj7633, "startToken",&reader_ast_startToken_7641, 0);
  Method *writer7641 = addmethodrealflags(obj7633, "startToken:=",&writer_ast_startToken_7641, 0);
  reader7641->definitionModule = modulename;
  writer7641->definitionModule = modulename;
  reader7641->definitionLine = 1921;
  writer7641->definitionLine = 1921;
}
obj7633->flags |= OFLAG_MUTABLE;
adddatum2(obj7633, alloc_Undefined(), 7);
// method "isPublic"
  struct UserObject *uo7642 = (struct UserObject*)obj7633;
  uo7642->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic7642 = addmethod2pos(obj7633, "isPublic", &meth_ast_isPublic7642, 8);
  int argcv_meth_ast_isPublic7642[] = {0};
  meth_meth_ast_isPublic7642->type = alloc_MethodType(1, argcv_meth_ast_isPublic7642);
  meth_meth_ast_isPublic7642->definitionModule = modulename;
  meth_meth_ast_isPublic7642->definitionLine = 1923;
// method "isFieldDec"
  struct UserObject *uo7669 = (struct UserObject*)obj7633;
  uo7669->data[9] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7669 = addmethod2pos(obj7633, "isFieldDec", &meth_ast_isFieldDec7669, 9);
  int argcv_meth_ast_isFieldDec7669[] = {0};
  meth_meth_ast_isFieldDec7669->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7669);
  meth_meth_ast_isFieldDec7669->definitionModule = modulename;
  meth_meth_ast_isFieldDec7669->definitionLine = 1929;
// method "isWritable"
  struct UserObject *uo7671 = (struct UserObject*)obj7633;
  uo7671->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7671 = addmethod2pos(obj7633, "isWritable", &meth_ast_isWritable7671, 10);
  int argcv_meth_ast_isWritable7671[] = {0};
  meth_meth_ast_isWritable7671->type = alloc_MethodType(1, argcv_meth_ast_isWritable7671);
  meth_meth_ast_isWritable7671->definitionModule = modulename;
  meth_meth_ast_isWritable7671->definitionLine = 1930;
// method "isReadable"
  struct UserObject *uo7673 = (struct UserObject*)obj7633;
  uo7673->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7673 = addmethod2pos(obj7633, "isReadable", &meth_ast_isReadable7673, 11);
  int argcv_meth_ast_isReadable7673[] = {0};
  meth_meth_ast_isReadable7673->type = alloc_MethodType(1, argcv_meth_ast_isReadable7673);
  meth_meth_ast_isReadable7673->definitionModule = modulename;
  meth_meth_ast_isReadable7673->definitionLine = 1931;
// method "returnsObject"
  struct UserObject *uo7676 = (struct UserObject*)obj7633;
  uo7676->data[12] = emptyclosure;
  Method *meth_meth_ast_returnsObject7676 = addmethod2pos(obj7633, "returnsObject", &meth_ast_returnsObject7676, 12);
  int argcv_meth_ast_returnsObject7676[] = {0};
  meth_meth_ast_returnsObject7676->type = alloc_MethodType(1, argcv_meth_ast_returnsObject7676);
  meth_meth_ast_returnsObject7676->definitionModule = modulename;
  meth_meth_ast_returnsObject7676->definitionLine = 1933;
// method "returnedObjectScope"
  struct UserObject *uo7681 = (struct UserObject*)obj7633;
  uo7681->data[13] = emptyclosure;
  Method *meth_meth_ast_returnedObjectScope7681 = addmethod2pos(obj7633, "returnedObjectScope", &meth_ast_returnedObjectScope7681, 13);
  int argcv_meth_ast_returnedObjectScope7681[] = {0};
  meth_meth_ast_returnedObjectScope7681->type = alloc_MethodType(1, argcv_meth_ast_returnedObjectScope7681);
  meth_meth_ast_returnedObjectScope7681->definitionModule = modulename;
  meth_meth_ast_returnedObjectScope7681->definitionLine = 1936;
// method "usesAsType"
  struct UserObject *uo7686 = (struct UserObject*)obj7633;
  uo7686->data[14] = emptyclosure;
  Method *meth_meth_ast_usesAsType7686 = addmethod2pos(obj7633, "usesAsType", &meth_ast_usesAsType7686, 14);
  int argcv_meth_ast_usesAsType7686[] = {1};
  meth_meth_ast_usesAsType7686->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7686);
  meth_meth_ast_usesAsType7686->definitionModule = modulename;
  meth_meth_ast_usesAsType7686->definitionLine = 1940;
// method "declarationKindWithAncestors"
  block_savedest(obj7633);
  Object closure7692 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure7692, stackframe);
  addtoclosure(closure7692, var_k);
  struct UserObject *uo7692 = (struct UserObject*)obj7633;
  uo7692->data[15] = (Object)closure7692;
  Method *meth_meth_ast_declarationKindWithAncestors7692 = addmethod2pos(obj7633, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors7692, 15);
  int argcv_meth_ast_declarationKindWithAncestors7692[] = {1};
  meth_meth_ast_declarationKindWithAncestors7692->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors7692);
  meth_meth_ast_declarationKindWithAncestors7692->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors7692->definitionLine = 1943;
// method "accept()from"
  struct UserObject *uo7695 = (struct UserObject*)obj7633;
  uo7695->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7695 = addmethod2pos(obj7633, "accept()from", &meth_ast_accept_40__41_from7695, 16);
  int argcv_meth_ast_accept_40__41_from7695[] = {1, 1};
  meth_meth_ast_accept_40__41_from7695->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7695);
  meth_meth_ast_accept_40__41_from7695->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7695->definitionLine = 1945;
// method "map()ancestors"
  struct UserObject *uo7729 = (struct UserObject*)obj7633;
  uo7729->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors7729 = addmethod2pos(obj7633, "map()ancestors", &meth_ast_map_40__41_ancestors7729, 17);
  int argcv_meth_ast_map_40__41_ancestors7729[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors7729->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors7729);
  meth_meth_ast_map_40__41_ancestors7729->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors7729->definitionLine = 1958;
// method "pretty"
  struct UserObject *uo7768 = (struct UserObject*)obj7633;
  uo7768->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty7768 = addmethod2pos(obj7633, "pretty", &meth_ast_pretty7768, 18);
  int argcv_meth_ast_pretty7768[] = {1};
  meth_meth_ast_pretty7768->type = alloc_MethodType(1, argcv_meth_ast_pretty7768);
  meth_meth_ast_pretty7768->definitionModule = modulename;
  meth_meth_ast_pretty7768->definitionLine = 1967;
// method "toGrace"
  struct UserObject *uo7928 = (struct UserObject*)obj7633;
  uo7928->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace7928 = addmethod2pos(obj7633, "toGrace", &meth_ast_toGrace7928, 19);
  int argcv_meth_ast_toGrace7928[] = {1};
  meth_meth_ast_toGrace7928->type = alloc_MethodType(1, argcv_meth_ast_toGrace7928);
meth_meth_ast_toGrace7928->type->types[0] = type_Number;
meth_meth_ast_toGrace7928->type->names[0] = "depth";
  meth_meth_ast_toGrace7928->definitionModule = modulename;
  meth_meth_ast_toGrace7928->definitionLine = 1991;
// method "shallowCopy"
  block_savedest(obj7633);
  Object closure8056 = createclosure(1, "shallowCopy");
  setclosureframe(closure8056, stackframe);
  addtoclosure(closure8056, var_defDecNode);
  struct UserObject *uo8056 = (struct UserObject*)obj7633;
  uo8056->data[20] = (Object)closure8056;
  Method *meth_meth_ast_shallowCopy8056 = addmethod2pos(obj7633, "shallowCopy", &meth_ast_shallowCopy8056, 20);
  int argcv_meth_ast_shallowCopy8056[] = {0};
  meth_meth_ast_shallowCopy8056->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8056);
  meth_meth_ast_shallowCopy8056->definitionModule = modulename;
  meth_meth_ast_shallowCopy8056->definitionLine = 2012;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo8067 = (struct UserObject*)obj7633;
  uo8067->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom8067 = addmethod2pos(obj7633, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom8067, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom8067[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom8067->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom8067);
  meth_meth_ast_shallowCopyFieldsFrom8067->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom8067->definitionLine = 2015;
// method "statementName"
  struct UserObject *uo8074 = (struct UserObject*)obj7633;
  uo8074->data[22] = emptyclosure;
  Method *meth_meth_ast_statementName8074 = addmethod2pos(obj7633, "statementName", &meth_ast_statementName8074, 22);
  int argcv_meth_ast_statementName8074[] = {0};
  meth_meth_ast_statementName8074->type = alloc_MethodType(1, argcv_meth_ast_statementName8074);
  meth_meth_ast_statementName8074->definitionModule = modulename;
  meth_meth_ast_statementName8074->definitionLine = 2020;
  sourceObject = obj7633;
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8076 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8077 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8078 = gc_frame_new();
// call case 3: self.outer request
  Object call8079 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8078);
// compiled call node returning call8079 (depth = 7)
// compiled member node returning call8079 (depth = 6)
  partcv[0] = 0;
  Object call8080 = callmethodflags(call8079, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8077);
// compiled call node returning call8080 (depth = 5)
// compiled member node returning call8080 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8081 = callmethodflags(call8080, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8076);
// compiled call node returning call8081 (depth = 3)
  struct UserObject *obj7633_uo = (struct UserObject *)obj7633;
  obj7633_uo->super = call8081;
  sourceObject = obj7633;
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8082 == NULL) {
    strlit8082 = alloc_String("defdec");
    gc_root(strlit8082);
  }
// compiled string node returning strlit8082 (depth = 3)
  adddatum2(obj7633, strlit8082, 1);
  sourceObject = obj7633;
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj7633, *var_name_39_, 2);
  sourceObject = obj7633;
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  adddatum2(obj7633, *var_val, 3);
  sourceObject = obj7633;
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj7633, *var_dtype_39_, 4);
  sourceObject = obj7633;
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8083 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8084 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8085 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8084);
// compiled call node returning call8085 (depth = 6)
// compiled member node returning call8085 (depth = 5)
  partcv[0] = 0;
  Object call8086 = callmethod(call8085, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8083);
// compiled call node returning call8086 (depth = 4)
// compiled member node returning call8086 (depth = 3)
  adddatum2(obj7633, call8086, 5);
  sourceObject = obj7633;
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8087 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8087 (depth = 3)
  adddatum2(obj7633, array8087, 6);
  sourceObject = obj7633;
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8088 = alloc_Boolean(0);
// compiled identifier node returning bool8088 (depth = 3)
  adddatum2(obj7633, bool8088, 7);
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  sourceObject = obj7633;
  objclass7633 = obj7633->class;
  objclass7633->definitionModule = modulename;
  objclass7633->definitionLine = 1913;
  (*(struct UserObject *)self).data[0] = lowerouter7633;
  self = oldself7633;
  selfslot = oldselfslot7633;
  stackframe = oldstackframe7633;
  gc_frame_end(frame);
  return obj7633;
}
Object meth_ast_defDecNode8090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_isPublic8102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8105 = alloc_Float64(0);
// compiled num node returning num8105 (depth = 5)
  int op_slot_right_8104 = gc_frame_newslot(num8105);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8107 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8109 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8108);
// compiled call node returning call8109 (depth = 8)
// compiled member node returning call8109 (depth = 7)
  partcv[0] = 0;
  Object call8110 = callmethod(call8109, "size",
    1, partcv, params);
  gc_frame_end(callframe8107);
// compiled call node returning call8110 (depth = 6)
// compiled member node returning call8110 (depth = 5)
  int op_slot_left_8104 = gc_frame_newslot(call8110);
  params[0] = num8105;
  partcv[0] = 1;
  Object opresult8111 = callmethod(call8110, "==", 1, partcv, params);
// compiled op node returning opresult8111 (depth = 4)
  Object if8103 = done;
  if (istrue(opresult8111)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8112 = alloc_Boolean(0);
// compiled identifier node returning bool8112 (depth = 5)
  return bool8112;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8103 = undefined;
  } else {
  }
// compiled if node returning if8103 (depth = 3)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8114 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8115 == NULL) {
    strlit8115 = alloc_String("public");
    gc_root(strlit8115);
  }
// compiled string node returning strlit8115 (depth = 5)
  gc_frame_newslot(strlit8115);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8116 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8117 = gc_frame_new();
// call case 3: self.outer request
  Object call8118 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8117);
// compiled call node returning call8118 (depth = 8)
// compiled member node returning call8118 (depth = 7)
  partcv[0] = 0;
  Object call8119 = callmethodflags(call8118, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8116);
// compiled call node returning call8119 (depth = 6)
// compiled member node returning call8119 (depth = 5)
  params[0] = self;
  params[1] = strlit8115;
  partcv[0] = 2;
  Object call8120 = callmethodflags(call8119, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8114);
// compiled call node returning call8120 (depth = 4)
  Object if8113 = done;
  if (istrue(call8120)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8121 = alloc_Boolean(1);
// compiled identifier node returning bool8121 (depth = 5)
  return bool8121;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8113 = undefined;
  } else {
  }
// compiled if node returning if8113 (depth = 3)
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8122 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8123 == NULL) {
    strlit8123 = alloc_String("readable");
    gc_root(strlit8123);
  }
// compiled string node returning strlit8123 (depth = 4)
  gc_frame_newslot(strlit8123);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8124 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8125 = gc_frame_new();
// call case 3: self.outer request
  Object call8126 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8125);
// compiled call node returning call8126 (depth = 7)
// compiled member node returning call8126 (depth = 6)
  partcv[0] = 0;
  Object call8127 = callmethodflags(call8126, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8124);
// compiled call node returning call8127 (depth = 5)
// compiled member node returning call8127 (depth = 4)
  params[0] = self;
  params[1] = strlit8123;
  partcv[0] = 2;
  Object call8128 = callmethodflags(call8127, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8122);
// compiled call node returning call8128 (depth = 3)
  gc_frame_end(frame);
  return call8128;
}
Object meth_ast_isWritable8129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8132 = alloc_Float64(0);
// compiled num node returning num8132 (depth = 5)
  int op_slot_right_8131 = gc_frame_newslot(num8132);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8134 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8136 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8135);
// compiled call node returning call8136 (depth = 8)
// compiled member node returning call8136 (depth = 7)
  partcv[0] = 0;
  Object call8137 = callmethod(call8136, "size",
    1, partcv, params);
  gc_frame_end(callframe8134);
// compiled call node returning call8137 (depth = 6)
// compiled member node returning call8137 (depth = 5)
  int op_slot_left_8131 = gc_frame_newslot(call8137);
  params[0] = num8132;
  partcv[0] = 1;
  Object opresult8138 = callmethod(call8137, "==", 1, partcv, params);
// compiled op node returning opresult8138 (depth = 4)
  Object if8130 = done;
  if (istrue(opresult8138)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8139 = alloc_Boolean(0);
// compiled identifier node returning bool8139 (depth = 5)
  return bool8139;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8130 = undefined;
  } else {
  }
// compiled if node returning if8130 (depth = 3)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8141 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8142 == NULL) {
    strlit8142 = alloc_String("public");
    gc_root(strlit8142);
  }
// compiled string node returning strlit8142 (depth = 5)
  gc_frame_newslot(strlit8142);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8143 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8144 = gc_frame_new();
// call case 3: self.outer request
  Object call8145 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8144);
// compiled call node returning call8145 (depth = 8)
// compiled member node returning call8145 (depth = 7)
  partcv[0] = 0;
  Object call8146 = callmethodflags(call8145, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8143);
// compiled call node returning call8146 (depth = 6)
// compiled member node returning call8146 (depth = 5)
  params[0] = self;
  params[1] = strlit8142;
  partcv[0] = 2;
  Object call8147 = callmethodflags(call8146, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8141);
// compiled call node returning call8147 (depth = 4)
  Object if8140 = done;
  if (istrue(call8147)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8148 = alloc_Boolean(1);
// compiled identifier node returning bool8148 (depth = 5)
  return bool8148;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8140 = undefined;
  } else {
  }
// compiled if node returning if8140 (depth = 3)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8150 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8151 == NULL) {
    strlit8151 = alloc_String("writable");
    gc_root(strlit8151);
  }
// compiled string node returning strlit8151 (depth = 5)
  gc_frame_newslot(strlit8151);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8152 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8153 = gc_frame_new();
// call case 3: self.outer request
  Object call8154 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8153);
// compiled call node returning call8154 (depth = 8)
// compiled member node returning call8154 (depth = 7)
  partcv[0] = 0;
  Object call8155 = callmethodflags(call8154, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8152);
// compiled call node returning call8155 (depth = 6)
// compiled member node returning call8155 (depth = 5)
  params[0] = self;
  params[1] = strlit8151;
  partcv[0] = 2;
  Object call8156 = callmethodflags(call8155, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8150);
// compiled call node returning call8156 (depth = 4)
  Object if8149 = done;
  if (istrue(call8156)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8157 = alloc_Boolean(1);
// compiled identifier node returning bool8157 (depth = 5)
  return bool8157;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8149 = undefined;
  } else {
  }
// compiled if node returning if8149 (depth = 3)
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8158 = alloc_Boolean(0);
// compiled identifier node returning bool8158 (depth = 3)
  gc_frame_end(frame);
  return bool8158;
}
Object meth_ast_isReadable8159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8162 = alloc_Float64(0);
// compiled num node returning num8162 (depth = 5)
  int op_slot_right_8161 = gc_frame_newslot(num8162);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8164 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8166 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8165);
// compiled call node returning call8166 (depth = 8)
// compiled member node returning call8166 (depth = 7)
  partcv[0] = 0;
  Object call8167 = callmethod(call8166, "size",
    1, partcv, params);
  gc_frame_end(callframe8164);
// compiled call node returning call8167 (depth = 6)
// compiled member node returning call8167 (depth = 5)
  int op_slot_left_8161 = gc_frame_newslot(call8167);
  params[0] = num8162;
  partcv[0] = 1;
  Object opresult8168 = callmethod(call8167, "==", 1, partcv, params);
// compiled op node returning opresult8168 (depth = 4)
  Object if8160 = done;
  if (istrue(opresult8168)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8169 = alloc_Boolean(0);
// compiled identifier node returning bool8169 (depth = 5)
  return bool8169;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8160 = undefined;
  } else {
  }
// compiled if node returning if8160 (depth = 3)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8171 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8172 == NULL) {
    strlit8172 = alloc_String("public");
    gc_root(strlit8172);
  }
// compiled string node returning strlit8172 (depth = 5)
  gc_frame_newslot(strlit8172);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8173 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8174 = gc_frame_new();
// call case 3: self.outer request
  Object call8175 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8174);
// compiled call node returning call8175 (depth = 8)
// compiled member node returning call8175 (depth = 7)
  partcv[0] = 0;
  Object call8176 = callmethodflags(call8175, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8173);
// compiled call node returning call8176 (depth = 6)
// compiled member node returning call8176 (depth = 5)
  params[0] = self;
  params[1] = strlit8172;
  partcv[0] = 2;
  Object call8177 = callmethodflags(call8176, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8171);
// compiled call node returning call8177 (depth = 4)
  Object if8170 = done;
  if (istrue(call8177)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8178 = alloc_Boolean(1);
// compiled identifier node returning bool8178 (depth = 5)
  return bool8178;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8170 = undefined;
  } else {
  }
// compiled if node returning if8170 (depth = 3)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8180 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8181 == NULL) {
    strlit8181 = alloc_String("readable");
    gc_root(strlit8181);
  }
// compiled string node returning strlit8181 (depth = 5)
  gc_frame_newslot(strlit8181);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8182 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8183 = gc_frame_new();
// call case 3: self.outer request
  Object call8184 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8183);
// compiled call node returning call8184 (depth = 8)
// compiled member node returning call8184 (depth = 7)
  partcv[0] = 0;
  Object call8185 = callmethodflags(call8184, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8182);
// compiled call node returning call8185 (depth = 6)
// compiled member node returning call8185 (depth = 5)
  params[0] = self;
  params[1] = strlit8181;
  partcv[0] = 2;
  Object call8186 = callmethodflags(call8185, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8180);
// compiled call node returning call8186 (depth = 4)
  Object if8179 = done;
  if (istrue(call8186)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8187 = alloc_Boolean(1);
// compiled identifier node returning bool8187 (depth = 5)
  return bool8187;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8179 = undefined;
  } else {
  }
// compiled if node returning if8179 (depth = 3)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8188 = alloc_Boolean(0);
// compiled identifier node returning bool8188 (depth = 3)
  gc_frame_end(frame);
  return bool8188;
}
Object meth_ast_isFieldDec8189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8190 = alloc_Boolean(1);
// compiled identifier node returning bool8190 (depth = 3)
  gc_frame_end(frame);
  return bool8190;
}
Object meth_ast_usesAsType8191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8193 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8194 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8193);
// compiled call node returning call8194 (depth = 5)
// compiled member node returning call8194 (depth = 4)
  int op_slot_right_8192 = gc_frame_newslot(call8194);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8192 = gc_frame_newslot(*var_aNode);
  params[0] = call8194;
  partcv[0] = 1;
  Object opresult8196 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8196 (depth = 3)
  gc_frame_end(frame);
  return opresult8196;
}
Object meth_ast_declarationKindWithAncestors8197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call8199 = callmethod(*var_k, "vardec",
    1, partcv, params);
  gc_frame_end(callframe8198);
// compiled call node returning call8199 (depth = 4)
// compiled member node returning call8199 (depth = 3)
  gc_frame_end(frame);
  return call8199;
}
Object meth_ast__apply8225(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8226 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8227 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8226);
// compiled call node returning call8227 (depth = 6)
  gc_frame_end(frame);
  return call8227;
}
Object meth_ast_accept_40__41_from8200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8202 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8203 = callmethod(*var_visitor, "visitVarDec()up",
    2, partcv, params);
  gc_frame_end(callframe8202);
// compiled call node returning call8203 (depth = 4)
  Object if8201 = done;
  if (istrue(call8203)) {
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8204 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8205 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compiled call node returning call8205 (depth = 5)
  *var_newChain = call8205;
  if (call8205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8206 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8208 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8207);
// compiled call node returning call8208 (depth = 6)
// compiled member node returning call8208 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8209 = callmethod(call8208, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8206);
// compiled call node returning call8209 (depth = 4)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8213 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8212);
// compiled call node returning call8213 (depth = 7)
// compiled member node returning call8213 (depth = 6)
  int op_slot_right_8211 = gc_frame_newslot(call8213);
// starting to compile identifier node (depth = 6)
  Object bool8215 = alloc_Boolean(0);
// compiled identifier node returning bool8215 (depth = 6)
  int op_slot_left_8211 = gc_frame_newslot(bool8215);
  params[0] = call8213;
  partcv[0] = 1;
  Object opresult8216 = callmethod(bool8215, "≠", 1, partcv, params);
// compiled op node returning opresult8216 (depth = 5)
  Object if8210 = done;
  if (istrue(opresult8216)) {
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8217 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8218 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8219 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8218);
// compiled call node returning call8219 (depth = 7)
// compiled member node returning call8219 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8220 = callmethod(call8219, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8217);
// compiled call node returning call8220 (depth = 5)
    gc_frame_newslot(call8220);
    if8210 = call8220;
  } else {
  }
// compiled if node returning if8210 (depth = 4)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8221 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8222 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8223 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8222);
// compiled call node returning call8223 (depth = 6)
// compiled member node returning call8223 (depth = 5)
  gc_frame_newslot(call8223);
// starting to compile block node (depth = 5)
  Object block8224 = alloc_Block(NULL, NULL, "ast", 2066);
  gc_frame_newslot(block8224);
// method "_apply"
  block_savedest(block8224);
  Object closure8225 = createclosure(3, "_apply");
  setclosureframe(closure8225, stackframe);
  addtoclosure(closure8225, var_visitor);
  addtoclosure(closure8225, var_newChain);
  addtoclosure(closure8225, selfslot);
  struct UserObject *uo8225 = (struct UserObject*)block8224;
  uo8225->data[0] = (Object)closure8225;
  Method *meth_meth_ast__apply8225 = addmethod2pos(block8224, "_apply", &meth_ast__apply8225, 0);
  int argcv_meth_ast__apply8225[] = {1};
  meth_meth_ast__apply8225->type = alloc_MethodType(1, argcv_meth_ast__apply8225);
  meth_meth_ast__apply8225->definitionModule = modulename;
  meth_meth_ast__apply8225->definitionLine = 2066;
// compiled block node returning block8224 (depth = 5)
  gc_frame_newslot(block8224);
// call case 5: prelude request
  params[0] = call8223;
  params[1] = block8224;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8229 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8221);
// compiled call node returning call8229 (depth = 4)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8232 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8233 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8232);
// compiled call node returning call8233 (depth = 7)
// compiled member node returning call8233 (depth = 6)
  int op_slot_right_8231 = gc_frame_newslot(call8233);
// starting to compile identifier node (depth = 6)
  Object bool8235 = alloc_Boolean(0);
// compiled identifier node returning bool8235 (depth = 6)
  int op_slot_left_8231 = gc_frame_newslot(bool8235);
  params[0] = call8233;
  partcv[0] = 1;
  Object opresult8236 = callmethod(bool8235, "≠", 1, partcv, params);
// compiled op node returning opresult8236 (depth = 5)
  Object if8230 = done;
  if (istrue(opresult8236)) {
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8237 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8239 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8238);
// compiled call node returning call8239 (depth = 7)
// compiled member node returning call8239 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8240 = callmethod(call8239, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8237);
// compiled call node returning call8240 (depth = 5)
    gc_frame_newslot(call8240);
    if8230 = call8240;
  } else {
  }
// compiled if node returning if8230 (depth = 4)
    gc_frame_newslot(if8230);
    if8201 = if8230;
  } else {
  }
// compiled if node returning if8201 (depth = 3)
  gc_frame_end(frame);
  return if8201;
}
Object meth_ast_map_40__41_ancestors8241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8243 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8242);
// compiled call node returning call8243 (depth = 5)
// compiled member node returning call8243 (depth = 4)
  *var_n = call8243;
  if (call8243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8244 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8245 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8244);
// compiled call node returning call8245 (depth = 4)
  *var_newChain = call8245;
  if (call8245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8246 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8247 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8248 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8249 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8248);
// compiled call node returning call8249 (depth = 6)
// compiled member node returning call8249 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8250 = callmethod(call8249, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8247);
// compiled call node returning call8250 (depth = 4)
  gc_frame_newslot(call8250);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8250;
  partcv[0] = 1;
  Object call8251 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8246);
// compiled call node returning call8251 (depth = 3)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8252 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8253 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8254 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8255 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8254);
// compiled call node returning call8255 (depth = 6)
// compiled member node returning call8255 (depth = 5)
  gc_frame_newslot(call8255);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8256 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8257 = gc_frame_new();
// call case 3: self.outer request
  Object call8258 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8257);
// compiled call node returning call8258 (depth = 8)
// compiled member node returning call8258 (depth = 7)
  partcv[0] = 0;
  Object call8259 = callmethodflags(call8258, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8256);
// compiled call node returning call8259 (depth = 6)
// compiled member node returning call8259 (depth = 5)
  params[0] = call8255;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8260 = callmethodflags(call8259, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8253);
// compiled call node returning call8260 (depth = 4)
  gc_frame_newslot(call8260);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8260;
  partcv[0] = 1;
  Object call8261 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8252);
// compiled call node returning call8261 (depth = 3)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8262 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8263 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8264 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8265 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8264);
// compiled call node returning call8265 (depth = 6)
// compiled member node returning call8265 (depth = 5)
  gc_frame_newslot(call8265);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8266 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8267 = gc_frame_new();
// call case 3: self.outer request
  Object call8268 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8267);
// compiled call node returning call8268 (depth = 8)
// compiled member node returning call8268 (depth = 7)
  partcv[0] = 0;
  Object call8269 = callmethodflags(call8268, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8266);
// compiled call node returning call8269 (depth = 6)
// compiled member node returning call8269 (depth = 5)
  params[0] = call8265;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8270 = callmethodflags(call8269, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8263);
// compiled call node returning call8270 (depth = 4)
  gc_frame_newslot(call8270);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8270;
  partcv[0] = 1;
  Object call8271 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8262);
// compiled call node returning call8271 (depth = 3)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8272 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8273 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8274 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8275 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8274);
// compiled call node returning call8275 (depth = 6)
// compiled member node returning call8275 (depth = 5)
  gc_frame_newslot(call8275);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8276 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8277 = gc_frame_new();
// call case 3: self.outer request
  Object call8278 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8277);
// compiled call node returning call8278 (depth = 8)
// compiled member node returning call8278 (depth = 7)
  partcv[0] = 0;
  Object call8279 = callmethodflags(call8278, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8276);
// compiled call node returning call8279 (depth = 6)
// compiled member node returning call8279 (depth = 5)
  params[0] = call8275;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8280 = callmethodflags(call8279, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8273);
// compiled call node returning call8280 (depth = 4)
  gc_frame_newslot(call8280);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8280;
  partcv[0] = 1;
  Object call8281 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8272);
// compiled call node returning call8281 (depth = 3)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8282 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8283 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8282);
// compiled call node returning call8283 (depth = 3)
  gc_frame_end(frame);
  return call8283;
}
Object meth_ast__apply8292(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8294 == NULL) {
    strlit8294 = alloc_String("  ");
    gc_root(strlit8294);
  }
// compiled string node returning strlit8294 (depth = 7)
  int op_slot_right_8293 = gc_frame_newslot(strlit8294);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8293 = gc_frame_newslot(*var_spc);
  params[0] = strlit8294;
  partcv[0] = 1;
  Object opresult8296 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8296 (depth = 6)
  *var_spc = opresult8296;
  if (opresult8296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8285 == NULL) {
    strlit8285 = alloc_String("");
    gc_root(strlit8285);
  }
// compiled string node returning strlit8285 (depth = 4)
  *var_spc = strlit8285;
  if (strlit8285 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8286 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8287 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8289 = alloc_Float64(0);
// compiled num node returning num8289 (depth = 5)
  int op_slot_left_8287 = gc_frame_newslot(num8289);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8290 = callmethod(num8289, "..", 1, partcv, params);
// compiled op node returning opresult8290 (depth = 4)
  gc_frame_newslot(opresult8290);
// starting to compile block node (depth = 4)
  Object block8291 = alloc_Block(NULL, NULL, "ast", 2085);
  gc_frame_newslot(block8291);
// method "_apply"
  block_savedest(block8291);
  Object closure8292 = createclosure(2, "_apply");
  setclosureframe(closure8292, stackframe);
  addtoclosure(closure8292, var_spc);
  addtoclosure(closure8292, selfslot);
  struct UserObject *uo8292 = (struct UserObject*)block8291;
  uo8292->data[0] = (Object)closure8292;
  Method *meth_meth_ast__apply8292 = addmethod2pos(block8291, "_apply", &meth_ast__apply8292, 0);
  int argcv_meth_ast__apply8292[] = {1};
  meth_meth_ast__apply8292->type = alloc_MethodType(1, argcv_meth_ast__apply8292);
  meth_meth_ast__apply8292->definitionModule = modulename;
  meth_meth_ast__apply8292->definitionLine = 2080;
// compiled block node returning block8291 (depth = 4)
  gc_frame_newslot(block8291);
// call case 5: prelude request
  params[0] = opresult8290;
  params[1] = block8291;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8299 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8286);
// compiled call node returning call8299 (depth = 3)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8301 == NULL) {
    strlit8301 = alloc_String("""\x0a""");
    gc_root(strlit8301);
  }
// compiled string node returning strlit8301 (depth = 5)
  int op_slot_right_8300 = gc_frame_newslot(strlit8301);
// starting to compile call node (depth = 5)
  int callframe8303 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8304 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8303);
// compiled call node returning call8304 (depth = 5)
  int op_slot_left_8300 = gc_frame_newslot(call8304);
  params[0] = strlit8301;
  partcv[0] = 1;
  Object opresult8305 = callmethod(call8304, "++", 1, partcv, params);
// compiled op node returning opresult8305 (depth = 4)
  *var_s = opresult8305;
  if (opresult8305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8307 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8309 = alloc_Float64(1);
// compiled num node returning num8309 (depth = 7)
  int op_slot_right_8308 = gc_frame_newslot(num8309);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8308 = gc_frame_newslot(*var_depth);
  params[0] = num8309;
  partcv[0] = 1;
  Object sum8311 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8311 (depth = 6)
  gc_frame_newslot(sum8311);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8312 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8313 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8312);
// compiled call node returning call8313 (depth = 7)
// compiled member node returning call8313 (depth = 6)
  params[0] = sum8311;
  partcv[0] = 1;
  Object call8314 = callmethod(call8313, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8307);
// compiled call node returning call8314 (depth = 5)
  int op_slot_right_8306 = gc_frame_newslot(call8314);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_8316 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8316 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8318 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8318 (depth = 5)
  int op_slot_left_8306 = gc_frame_newslot(opresult8318);
  params[0] = call8314;
  partcv[0] = 1;
  Object opresult8319 = callmethod(opresult8318, "++", 1, partcv, params);
// compiled op node returning opresult8319 (depth = 4)
  *var_s = opresult8319;
  if (opresult8319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8323 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8324 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8323);
// compiled call node returning call8324 (depth = 6)
// compiled member node returning call8324 (depth = 5)
  int op_slot_right_8322 = gc_frame_newslot(call8324);
// starting to compile identifier node (depth = 5)
  Object bool8326 = alloc_Boolean(0);
// compiled identifier node returning bool8326 (depth = 5)
  int op_slot_left_8322 = gc_frame_newslot(bool8326);
  params[0] = call8324;
  partcv[0] = 1;
  Object opresult8327 = callmethod(bool8326, "≠", 1, partcv, params);
// compiled op node returning opresult8327 (depth = 4)
  Object if8321 = done;
  if (istrue(opresult8327)) {
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8329 == NULL) {
    strlit8329 = alloc_String("Type: ");
    gc_root(strlit8329);
  }
// compiled string node returning strlit8329 (depth = 6)
  int op_slot_right_8328 = gc_frame_newslot(strlit8329);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8331 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8334 == NULL) {
    strlit8334 = alloc_String("""\x0a""");
    gc_root(strlit8334);
  }
// compiled string node returning strlit8334 (depth = 8)
  int op_slot_right_8333 = gc_frame_newslot(strlit8334);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8333 = gc_frame_newslot(*var_s);
  params[0] = strlit8334;
  partcv[0] = 1;
  Object opresult8336 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8336 (depth = 7)
  int op_slot_left_8331 = gc_frame_newslot(opresult8336);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8337 = callmethod(opresult8336, "++", 1, partcv, params);
// compiled op node returning opresult8337 (depth = 6)
  int op_slot_left_8328 = gc_frame_newslot(opresult8337);
  params[0] = strlit8329;
  partcv[0] = 1;
  Object opresult8338 = callmethod(opresult8337, "++", 1, partcv, params);
// compiled op node returning opresult8338 (depth = 5)
  *var_s = opresult8338;
  if (opresult8338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8341 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8343 = alloc_Float64(2);
// compiled num node returning num8343 (depth = 8)
  int op_slot_right_8342 = gc_frame_newslot(num8343);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8342 = gc_frame_newslot(*var_depth);
  params[0] = num8343;
  partcv[0] = 1;
  Object sum8345 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8345 (depth = 7)
  gc_frame_newslot(sum8345);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8347 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8346);
// compiled call node returning call8347 (depth = 8)
// compiled member node returning call8347 (depth = 7)
  params[0] = sum8345;
  partcv[0] = 1;
  Object call8348 = callmethod(call8347, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8341);
// compiled call node returning call8348 (depth = 6)
  int op_slot_right_8340 = gc_frame_newslot(call8348);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8340 = gc_frame_newslot(*var_s);
  params[0] = call8348;
  partcv[0] = 1;
  Object opresult8350 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8350 (depth = 5)
  *var_s = opresult8350;
  if (opresult8350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8321 = done;
  } else {
  }
// compiled if node returning if8321 (depth = 3)
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8355 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8354);
// compiled call node returning call8355 (depth = 6)
// compiled member node returning call8355 (depth = 5)
  int op_slot_right_8353 = gc_frame_newslot(call8355);
// starting to compile identifier node (depth = 5)
  Object bool8357 = alloc_Boolean(0);
// compiled identifier node returning bool8357 (depth = 5)
  int op_slot_left_8353 = gc_frame_newslot(bool8357);
  params[0] = call8355;
  partcv[0] = 1;
  Object opresult8358 = callmethod(bool8357, "≠", 1, partcv, params);
// compiled op node returning opresult8358 (depth = 4)
  Object if8352 = done;
  if (istrue(opresult8358)) {
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8360 == NULL) {
    strlit8360 = alloc_String("Value: ");
    gc_root(strlit8360);
  }
// compiled string node returning strlit8360 (depth = 6)
  int op_slot_right_8359 = gc_frame_newslot(strlit8360);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8362 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8365 == NULL) {
    strlit8365 = alloc_String("""\x0a""");
    gc_root(strlit8365);
  }
// compiled string node returning strlit8365 (depth = 8)
  int op_slot_right_8364 = gc_frame_newslot(strlit8365);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8364 = gc_frame_newslot(*var_s);
  params[0] = strlit8365;
  partcv[0] = 1;
  Object opresult8367 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8367 (depth = 7)
  int op_slot_left_8362 = gc_frame_newslot(opresult8367);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8368 = callmethod(opresult8367, "++", 1, partcv, params);
// compiled op node returning opresult8368 (depth = 6)
  int op_slot_left_8359 = gc_frame_newslot(opresult8368);
  params[0] = strlit8360;
  partcv[0] = 1;
  Object opresult8369 = callmethod(opresult8368, "++", 1, partcv, params);
// compiled op node returning opresult8369 (depth = 5)
  *var_s = opresult8369;
  if (opresult8369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8372 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8374 = alloc_Float64(2);
// compiled num node returning num8374 (depth = 8)
  int op_slot_right_8373 = gc_frame_newslot(num8374);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8373 = gc_frame_newslot(*var_depth);
  params[0] = num8374;
  partcv[0] = 1;
  Object sum8376 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8376 (depth = 7)
  gc_frame_newslot(sum8376);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8377 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8378 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8377);
// compiled call node returning call8378 (depth = 8)
// compiled member node returning call8378 (depth = 7)
  params[0] = sum8376;
  partcv[0] = 1;
  Object call8379 = callmethod(call8378, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8372);
// compiled call node returning call8379 (depth = 6)
  int op_slot_right_8371 = gc_frame_newslot(call8379);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8371 = gc_frame_newslot(*var_s);
  params[0] = call8379;
  partcv[0] = 1;
  Object opresult8381 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8381 (depth = 5)
  *var_s = opresult8381;
  if (opresult8381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8352 = done;
  } else {
  }
// compiled if node returning if8352 (depth = 3)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8385 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8386 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8385);
// compiled call node returning call8386 (depth = 6)
// compiled member node returning call8386 (depth = 5)
  int op_slot_right_8384 = gc_frame_newslot(call8386);
// starting to compile identifier node (depth = 5)
  Object bool8388 = alloc_Boolean(0);
// compiled identifier node returning bool8388 (depth = 5)
  int op_slot_left_8384 = gc_frame_newslot(bool8388);
  params[0] = call8386;
  partcv[0] = 1;
  Object opresult8389 = callmethod(bool8388, "≠", 1, partcv, params);
// compiled op node returning opresult8389 (depth = 4)
  Object if8383 = done;
  if (istrue(opresult8389)) {
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8391 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8393 = alloc_Float64(2);
// compiled num node returning num8393 (depth = 8)
  int op_slot_right_8392 = gc_frame_newslot(num8393);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8392 = gc_frame_newslot(*var_depth);
  params[0] = num8393;
  partcv[0] = 1;
  Object sum8395 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8395 (depth = 7)
  gc_frame_newslot(sum8395);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8397 = callmethodflags(self, "comments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8396);
// compiled call node returning call8397 (depth = 8)
// compiled member node returning call8397 (depth = 7)
  params[0] = sum8395;
  partcv[0] = 1;
  Object call8398 = callmethod(call8397, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8391);
// compiled call node returning call8398 (depth = 6)
  int op_slot_right_8390 = gc_frame_newslot(call8398);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8390 = gc_frame_newslot(*var_s);
  params[0] = call8398;
  partcv[0] = 1;
  Object opresult8400 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8400 (depth = 5)
  *var_s = opresult8400;
  if (opresult8400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8383 = done;
  } else {
  }
// compiled if node returning if8383 (depth = 3)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8408 == NULL) {
    strlit8408 = alloc_String("    ");
    gc_root(strlit8408);
  }
// compiled string node returning strlit8408 (depth = 7)
  int op_slot_right_8407 = gc_frame_newslot(strlit8408);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8407 = gc_frame_newslot(*var_spc);
  params[0] = strlit8408;
  partcv[0] = 1;
  Object opresult8410 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8410 (depth = 6)
  *var_spc = opresult8410;
  if (opresult8410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8430(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8432 == NULL) {
    strlit8432 = alloc_String("Unknown");
    gc_root(strlit8432);
  }
// compiled string node returning strlit8432 (depth = 7)
  int op_slot_right_8431 = gc_frame_newslot(strlit8432);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8434 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8436 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8435);
// compiled call node returning call8436 (depth = 10)
// compiled member node returning call8436 (depth = 9)
  partcv[0] = 0;
  Object call8437 = callmethod(call8436, "value",
    1, partcv, params);
  gc_frame_end(callframe8434);
// compiled call node returning call8437 (depth = 8)
// compiled member node returning call8437 (depth = 7)
  int op_slot_left_8431 = gc_frame_newslot(call8437);
  params[0] = strlit8432;
  partcv[0] = 1;
  Object opresult8438 = callmethod(call8437, "≠", 1, partcv, params);
// compiled op node returning opresult8438 (depth = 6)
  gc_frame_end(frame);
  return opresult8438;
}
Object meth_ast__apply8478(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8480 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num8481 = alloc_Float64(0);
// compiled num node returning num8481 (depth = 10)
  gc_frame_newslot(num8481);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_b (depth = 10)
  params[0] = num8481;
  partcv[0] = 1;
  Object call8482 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8480);
// compiled call node returning call8482 (depth = 9)
  int op_slot_right_8479 = gc_frame_newslot(call8482);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8486 == NULL) {
    strlit8486 = alloc_String("");
    gc_root(strlit8486);
  }
// compiled string node returning strlit8486 (depth = 11)
  int op_slot_right_8485 = gc_frame_newslot(strlit8486);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8485 = gc_frame_newslot(*var_a);
  params[0] = strlit8486;
  partcv[0] = 1;
  Object opresult8488 = callmethod(*var_a, "≠", 1, partcv, params);
// compiled op node returning opresult8488 (depth = 10)
  Object if8484 = done;
struct StackFrameObject *iftmpstackframe8484 = stackframe;
  if (istrue(opresult8488)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8484);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit8490 == NULL) {
    strlit8490 = alloc_String(", ");
    gc_root(strlit8490);
  }
// compiled string node returning strlit8490 (depth = 11)
  int op_slot_right_8489 = gc_frame_newslot(strlit8490);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  int op_slot_left_8489 = gc_frame_newslot(*var_a);
  params[0] = strlit8490;
  partcv[0] = 1;
  Object opresult8492 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8492 (depth = 10)
    gc_frame_newslot(opresult8492);
    if8484 = opresult8492;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8484);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 10)
  if (strlit8493 == NULL) {
    strlit8493 = alloc_String("");
    gc_root(strlit8493);
  }
// compiled string node returning strlit8493 (depth = 10)
    gc_frame_newslot(strlit8493);
    if8484 = strlit8493;
  }
stackframe = iftmpstackframe8484;
// compiled if node returning if8484 (depth = 9)
  int op_slot_left_8479 = gc_frame_newslot(if8484);
  params[0] = call8482;
  partcv[0] = 1;
  Object opresult8494 = callmethod(if8484, "++", 1, partcv, params);
// compiled op node returning opresult8494 (depth = 8)
  gc_frame_end(frame);
  return opresult8494;
}
Object meth_ast_toGrace8402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8403 == NULL) {
    strlit8403 = alloc_String("");
    gc_root(strlit8403);
  }
// compiled string node returning strlit8403 (depth = 4)
  *var_spc = strlit8403;
  if (strlit8403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8404 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_depth (depth = 4)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 4)
  Object block8405 = alloc_Block(NULL, NULL, "ast", 2105);
  gc_frame_newslot(block8405);
// method "_apply"
  block_savedest(block8405);
  Object closure8406 = createclosure(2, "_apply");
  setclosureframe(closure8406, stackframe);
  addtoclosure(closure8406, var_spc);
  addtoclosure(closure8406, selfslot);
  struct UserObject *uo8406 = (struct UserObject*)block8405;
  uo8406->data[0] = (Object)closure8406;
  Method *meth_meth_ast__apply8406 = addmethod2pos(block8405, "_apply", &meth_ast__apply8406, 0);
  int argcv_meth_ast__apply8406[] = {0};
  meth_meth_ast__apply8406->type = alloc_MethodType(1, argcv_meth_ast__apply8406);
  meth_meth_ast__apply8406->definitionModule = modulename;
  meth_meth_ast__apply8406->definitionLine = 2099;
// compiled block node returning block8405 (depth = 4)
  gc_frame_newslot(block8405);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block8405;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8413 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8404);
// compiled call node returning call8413 (depth = 3)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8415 == NULL) {
    strlit8415 = alloc_String("");
    gc_root(strlit8415);
  }
// compiled string node returning strlit8415 (depth = 5)
  int op_slot_right_8414 = gc_frame_newslot(strlit8415);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8418 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8419 = alloc_Float64(0);
// compiled num node returning num8419 (depth = 7)
  gc_frame_newslot(num8419);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8421 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8420);
// compiled call node returning call8421 (depth = 8)
// compiled member node returning call8421 (depth = 7)
  params[0] = num8419;
  partcv[0] = 1;
  Object call8422 = callmethod(call8421, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8418);
// compiled call node returning call8422 (depth = 6)
  int op_slot_right_8417 = gc_frame_newslot(call8422);
// starting to compile string node (depth = 6)
  if (strlit8424 == NULL) {
    strlit8424 = alloc_String("var ");
    gc_root(strlit8424);
  }
// compiled string node returning strlit8424 (depth = 6)
  int op_slot_left_8417 = gc_frame_newslot(strlit8424);
  params[0] = call8422;
  partcv[0] = 1;
  Object opresult8425 = callmethod(strlit8424, "++", 1, partcv, params);
// compiled op node returning opresult8425 (depth = 5)
  int op_slot_left_8414 = gc_frame_newslot(opresult8425);
  params[0] = strlit8415;
  partcv[0] = 1;
  Object opresult8426 = callmethod(opresult8425, "++", 1, partcv, params);
// compiled op node returning opresult8426 (depth = 4)
  *var_s = opresult8426;
  if (opresult8426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8429 = alloc_Block(NULL, NULL, "ast", 2109);
  gc_frame_newslot(block8429);
// method "_apply"
  block_savedest(block8429);
  Object closure8430 = createclosure(1, "_apply");
  setclosureframe(closure8430, stackframe);
  addtoclosure(closure8430, selfslot);
  struct UserObject *uo8430 = (struct UserObject*)block8429;
  uo8430->data[0] = (Object)closure8430;
  Method *meth_meth_ast__apply8430 = addmethod2pos(block8429, "_apply", &meth_ast__apply8430, 0);
  int argcv_meth_ast__apply8430[] = {0};
  meth_meth_ast__apply8430->type = alloc_MethodType(1, argcv_meth_ast__apply8430);
  meth_meth_ast__apply8430->definitionModule = modulename;
  meth_meth_ast__apply8430->definitionLine = 2108;
// compiled block node returning block8429 (depth = 5)
  int op_slot_right_8428 = gc_frame_newslot(block8429);
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8443 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compiled call node returning call8443 (depth = 7)
// compiled member node returning call8443 (depth = 6)
  int op_slot_right_8441 = gc_frame_newslot(call8443);
// starting to compile identifier node (depth = 6)
  Object bool8445 = alloc_Boolean(0);
// compiled identifier node returning bool8445 (depth = 6)
  int op_slot_left_8441 = gc_frame_newslot(bool8445);
  params[0] = call8443;
  partcv[0] = 1;
  Object opresult8446 = callmethod(bool8445, "≠", 1, partcv, params);
// compiled op node returning opresult8446 (depth = 5)
  int op_slot_left_8428 = gc_frame_newslot(opresult8446);
  params[0] = block8429;
  partcv[0] = 1;
  Object opresult8447 = callmethod(opresult8446, "&&", 1, partcv, params);
// compiled op node returning opresult8447 (depth = 4)
  Object if8427 = done;
  if (istrue(opresult8447)) {
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8449 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num8450 = alloc_Float64(0);
// compiled num node returning num8450 (depth = 7)
  gc_frame_newslot(num8450);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8451 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8452 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8451);
// compiled call node returning call8452 (depth = 8)
// compiled member node returning call8452 (depth = 7)
  params[0] = num8450;
  partcv[0] = 1;
  Object call8453 = callmethod(call8452, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8449);
// compiled call node returning call8453 (depth = 6)
  int op_slot_right_8448 = gc_frame_newslot(call8453);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8456 == NULL) {
    strlit8456 = alloc_String(" : ");
    gc_root(strlit8456);
  }
// compiled string node returning strlit8456 (depth = 7)
  int op_slot_right_8455 = gc_frame_newslot(strlit8456);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8455 = gc_frame_newslot(*var_s);
  params[0] = strlit8456;
  partcv[0] = 1;
  Object opresult8458 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8458 (depth = 6)
  int op_slot_left_8448 = gc_frame_newslot(opresult8458);
  params[0] = call8453;
  partcv[0] = 1;
  Object opresult8459 = callmethod(opresult8458, "++", 1, partcv, params);
// compiled op node returning opresult8459 (depth = 5)
  *var_s = opresult8459;
  if (opresult8459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8427 = done;
  } else {
  }
// compiled if node returning if8427 (depth = 3)
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8463 = alloc_Float64(0);
// compiled num node returning num8463 (depth = 5)
  int op_slot_right_8462 = gc_frame_newslot(num8463);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8465 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8466 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8467 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8466);
// compiled call node returning call8467 (depth = 8)
// compiled member node returning call8467 (depth = 7)
  partcv[0] = 0;
  Object call8468 = callmethod(call8467, "size",
    1, partcv, params);
  gc_frame_end(callframe8465);
// compiled call node returning call8468 (depth = 6)
// compiled member node returning call8468 (depth = 5)
  int op_slot_left_8462 = gc_frame_newslot(call8468);
  params[0] = num8463;
  partcv[0] = 1;
  Object opresult8469 = callmethod(call8468, ">", 1, partcv, params);
// compiled op node returning opresult8469 (depth = 4)
  Object if8461 = done;
  if (istrue(opresult8469)) {
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8471 == NULL) {
    strlit8471 = alloc_String(" is ");
    gc_root(strlit8471);
  }
// compiled string node returning strlit8471 (depth = 6)
  int op_slot_right_8470 = gc_frame_newslot(strlit8471);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8470 = gc_frame_newslot(*var_s);
  params[0] = strlit8471;
  partcv[0] = 1;
  Object opresult8473 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8473 (depth = 5)
  *var_s = opresult8473;
  if (opresult8473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8476 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block8477 = alloc_Block(NULL, NULL, "ast", 2115);
  gc_frame_newslot(block8477);
// method "_apply"
  block_savedest(block8477);
  Object closure8478 = createclosure(1, "_apply");
  setclosureframe(closure8478, stackframe);
  addtoclosure(closure8478, selfslot);
  struct UserObject *uo8478 = (struct UserObject*)block8477;
  uo8478->data[0] = (Object)closure8478;
  Method *meth_meth_ast__apply8478 = addmethod2pos(block8477, "_apply", &meth_ast__apply8478, 0);
  int argcv_meth_ast__apply8478[] = {2};
  meth_meth_ast__apply8478->type = alloc_MethodType(1, argcv_meth_ast__apply8478);
  meth_meth_ast__apply8478->definitionModule = modulename;
  meth_meth_ast__apply8478->definitionLine = 2113;
// compiled block node returning block8477 (depth = 7)
  gc_frame_newslot(block8477);
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8496 == NULL) {
    strlit8496 = alloc_String("");
    gc_root(strlit8496);
  }
// compiled string node returning strlit8496 (depth = 7)
  gc_frame_newslot(strlit8496);
// call case 6: other member request
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8498 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8497);
// compiled call node returning call8498 (depth = 8)
// compiled member node returning call8498 (depth = 7)
  params[0] = block8477;
  params[1] = strlit8496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8499 = callmethod(call8498, "fold()startingWith",
    2, partcv, params);
  gc_frame_end(callframe8476);
// compiled call node returning call8499 (depth = 6)
  int op_slot_right_8475 = gc_frame_newslot(call8499);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8475 = gc_frame_newslot(*var_s);
  params[0] = call8499;
  partcv[0] = 1;
  Object opresult8501 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8501 (depth = 5)
  *var_s = opresult8501;
  if (opresult8501 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8461 = done;
  } else {
  }
// compiled if node returning if8461 (depth = 3)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8505 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8506 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8505);
// compiled call node returning call8506 (depth = 6)
// compiled member node returning call8506 (depth = 5)
  int op_slot_right_8504 = gc_frame_newslot(call8506);
// starting to compile identifier node (depth = 5)
  Object bool8508 = alloc_Boolean(0);
// compiled identifier node returning bool8508 (depth = 5)
  int op_slot_left_8504 = gc_frame_newslot(bool8508);
  params[0] = call8506;
  partcv[0] = 1;
  Object opresult8509 = callmethod(bool8508, "≠", 1, partcv, params);
// compiled op node returning opresult8509 (depth = 4)
  Object if8503 = done;
  if (istrue(opresult8509)) {
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8511 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8512 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8513 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8512);
// compiled call node returning call8513 (depth = 8)
// compiled member node returning call8513 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8514 = callmethod(call8513, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8511);
// compiled call node returning call8514 (depth = 6)
  int op_slot_right_8510 = gc_frame_newslot(call8514);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8517 == NULL) {
    strlit8517 = alloc_String(" := ");
    gc_root(strlit8517);
  }
// compiled string node returning strlit8517 (depth = 7)
  int op_slot_right_8516 = gc_frame_newslot(strlit8517);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8516 = gc_frame_newslot(*var_s);
  params[0] = strlit8517;
  partcv[0] = 1;
  Object opresult8519 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8519 (depth = 6)
  int op_slot_left_8510 = gc_frame_newslot(opresult8519);
  params[0] = call8514;
  partcv[0] = 1;
  Object opresult8520 = callmethod(opresult8519, "++", 1, partcv, params);
// compiled op node returning opresult8520 (depth = 5)
  *var_s = opresult8520;
  if (opresult8520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8503 = done;
  } else {
  }
// compiled if node returning if8503 (depth = 3)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy8522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8523 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8524 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8525 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8526 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8525);
// compiled call node returning call8526 (depth = 6)
// compiled member node returning call8526 (depth = 5)
  gc_frame_newslot(call8526);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8528 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8527);
// compiled call node returning call8528 (depth = 6)
// compiled member node returning call8528 (depth = 5)
  gc_frame_newslot(call8528);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8529 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8530 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8529);
// compiled call node returning call8530 (depth = 6)
// compiled member node returning call8530 (depth = 5)
  gc_frame_newslot(call8530);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_varDecNode (depth = 5)
  params[0] = call8526;
  params[1] = call8528;
  params[2] = call8530;
  partcv[0] = 3;
  Object call8531 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8524);
// compiled call node returning call8531 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8532 = callmethod(call8531, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8523);
// compiled call node returning call8532 (depth = 3)
  gc_frame_end(frame);
  return call8532;
}
Object meth_ast_statementName8533(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8534 == NULL) {
    strlit8534 = alloc_String("variable declaration");
    gc_root(strlit8534);
  }
// compiled string node returning strlit8534 (depth = 3)
  gc_frame_end(frame);
  return strlit8534;
}
Object meth_ast_new8093(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8094 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8094 = alloc_userobj2(22,19, objclass8094);
  gc_frame_newslot(obj8094);
if (objclass8094 == NULL) {
  glfree(obj8094->class->name);
  obj8094->class->name = "varDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8094, self, 0);
  addmethodreal(obj8094,"outer", &reader_ast_outer_8095);
  Object oldself8094 = self;
  struct StackFrameObject *oldstackframe8094 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8094);
  gc_frame_newslot((Object)stackframe);
  self = obj8094;
  Object *oldselfslot8094 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8094 = (*(struct UserObject *)self).data[0], lowerouter8094 = thisouter8094;
  if (inheritingObject8094) {
    struct UserObject *inho8094 = (struct UserObject *)inheritingObject8094;
    while (inho8094->super != GraceDefaultObject) inho8094 = (struct UserObject *)inho8094->super;
    inho8094->super = obj8094;
    self = inheritingObject8094;
    *selfslot = self;
    lowerouter8094 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8094;
  }
if (objclass8094 == NULL) {
  Method *reader8096 = addmethodrealflags(obj8094, "kind",&reader_ast_kind_8096, MFLAG_DEF);
  reader8096->definitionModule = modulename;
  reader8096->definitionLine = 2026;
}
adddatum2(obj8094, alloc_Undefined(), 1);
if (objclass8094 == NULL) {
  Method *reader8097 = addmethodrealflags(obj8094, "name",&reader_ast_name_8097, 0);
  Method *writer8097 = addmethodrealflags(obj8094, "name:=",&writer_ast_name_8097, 0);
  reader8097->definitionModule = modulename;
  writer8097->definitionModule = modulename;
  reader8097->definitionLine = 2027;
  writer8097->definitionLine = 2027;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 2);
if (objclass8094 == NULL) {
  Method *reader8098 = addmethodrealflags(obj8094, "value",&reader_ast_value_8098, 0);
  Method *writer8098 = addmethodrealflags(obj8094, "value:=",&writer_ast_value_8098, 0);
  reader8098->definitionModule = modulename;
  writer8098->definitionModule = modulename;
  reader8098->definitionLine = 2028;
  writer8098->definitionLine = 2028;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 3);
if (objclass8094 == NULL) {
  Method *reader8099 = addmethodrealflags(obj8094, "dtype",&reader_ast_dtype_8099, 0);
  Method *writer8099 = addmethodrealflags(obj8094, "dtype:=",&writer_ast_dtype_8099, 0);
  reader8099->definitionModule = modulename;
  writer8099->definitionModule = modulename;
  reader8099->definitionLine = 2029;
  writer8099->definitionLine = 2029;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 4);
if (objclass8094 == NULL) {
  Method *reader8100 = addmethodrealflags(obj8094, "nameString",&reader_ast_nameString_8100, MFLAG_DEF);
  reader8100->definitionModule = modulename;
  reader8100->definitionLine = 2030;
}
adddatum2(obj8094, alloc_Undefined(), 5);
if (objclass8094 == NULL) {
  Method *reader8101 = addmethodrealflags(obj8094, "annotations",&reader_ast_annotations_8101, 0);
  Method *writer8101 = addmethodrealflags(obj8094, "annotations:=",&writer_ast_annotations_8101, 0);
  reader8101->definitionModule = modulename;
  writer8101->definitionModule = modulename;
  reader8101->definitionLine = 2031;
  writer8101->definitionLine = 2031;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8102 = (struct UserObject*)obj8094;
  uo8102->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8102 = addmethod2pos(obj8094, "isPublic", &meth_ast_isPublic8102, 7);
  int argcv_meth_ast_isPublic8102[] = {0};
  meth_meth_ast_isPublic8102->type = alloc_MethodType(1, argcv_meth_ast_isPublic8102);
  meth_meth_ast_isPublic8102->definitionModule = modulename;
  meth_meth_ast_isPublic8102->definitionLine = 2033;
// method "isWritable"
  struct UserObject *uo8129 = (struct UserObject*)obj8094;
  uo8129->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8129 = addmethod2pos(obj8094, "isWritable", &meth_ast_isWritable8129, 8);
  int argcv_meth_ast_isWritable8129[] = {0};
  meth_meth_ast_isWritable8129->type = alloc_MethodType(1, argcv_meth_ast_isWritable8129);
  meth_meth_ast_isWritable8129->definitionModule = modulename;
  meth_meth_ast_isWritable8129->definitionLine = 2039;
// method "isReadable"
  struct UserObject *uo8159 = (struct UserObject*)obj8094;
  uo8159->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8159 = addmethod2pos(obj8094, "isReadable", &meth_ast_isReadable8159, 9);
  int argcv_meth_ast_isReadable8159[] = {0};
  meth_meth_ast_isReadable8159->type = alloc_MethodType(1, argcv_meth_ast_isReadable8159);
  meth_meth_ast_isReadable8159->definitionModule = modulename;
  meth_meth_ast_isReadable8159->definitionLine = 2045;
// method "isFieldDec"
  struct UserObject *uo8189 = (struct UserObject*)obj8094;
  uo8189->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8189 = addmethod2pos(obj8094, "isFieldDec", &meth_ast_isFieldDec8189, 10);
  int argcv_meth_ast_isFieldDec8189[] = {0};
  meth_meth_ast_isFieldDec8189->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8189);
  meth_meth_ast_isFieldDec8189->definitionModule = modulename;
  meth_meth_ast_isFieldDec8189->definitionLine = 2051;
// method "usesAsType"
  struct UserObject *uo8191 = (struct UserObject*)obj8094;
  uo8191->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8191 = addmethod2pos(obj8094, "usesAsType", &meth_ast_usesAsType8191, 11);
  int argcv_meth_ast_usesAsType8191[] = {1};
  meth_meth_ast_usesAsType8191->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8191);
  meth_meth_ast_usesAsType8191->definitionModule = modulename;
  meth_meth_ast_usesAsType8191->definitionLine = 2053;
// method "declarationKindWithAncestors"
  block_savedest(obj8094);
  Object closure8197 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8197, stackframe);
  addtoclosure(closure8197, var_k);
  struct UserObject *uo8197 = (struct UserObject*)obj8094;
  uo8197->data[12] = (Object)closure8197;
  Method *meth_meth_ast_declarationKindWithAncestors8197 = addmethod2pos(obj8094, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8197, 12);
  int argcv_meth_ast_declarationKindWithAncestors8197[] = {1};
  meth_meth_ast_declarationKindWithAncestors8197->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8197);
  meth_meth_ast_declarationKindWithAncestors8197->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8197->definitionLine = 2057;
// method "accept()from"
  struct UserObject *uo8200 = (struct UserObject*)obj8094;
  uo8200->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8200 = addmethod2pos(obj8094, "accept()from", &meth_ast_accept_40__41_from8200, 13);
  int argcv_meth_ast_accept_40__41_from8200[] = {1, 1};
  meth_meth_ast_accept_40__41_from8200->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8200);
  meth_meth_ast_accept_40__41_from8200->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8200->definitionLine = 2059;
// method "map()ancestors"
  struct UserObject *uo8241 = (struct UserObject*)obj8094;
  uo8241->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8241 = addmethod2pos(obj8094, "map()ancestors", &meth_ast_map_40__41_ancestors8241, 14);
  int argcv_meth_ast_map_40__41_ancestors8241[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8241->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8241);
  meth_meth_ast_map_40__41_ancestors8241->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8241->definitionLine = 2074;
// method "pretty"
  struct UserObject *uo8284 = (struct UserObject*)obj8094;
  uo8284->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8284 = addmethod2pos(obj8094, "pretty", &meth_ast_pretty8284, 15);
  int argcv_meth_ast_pretty8284[] = {1};
  meth_meth_ast_pretty8284->type = alloc_MethodType(1, argcv_meth_ast_pretty8284);
  meth_meth_ast_pretty8284->definitionModule = modulename;
  meth_meth_ast_pretty8284->definitionLine = 2083;
// method "toGrace"
  struct UserObject *uo8402 = (struct UserObject*)obj8094;
  uo8402->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8402 = addmethod2pos(obj8094, "toGrace", &meth_ast_toGrace8402, 16);
  int argcv_meth_ast_toGrace8402[] = {1};
  meth_meth_ast_toGrace8402->type = alloc_MethodType(1, argcv_meth_ast_toGrace8402);
meth_meth_ast_toGrace8402->type->types[0] = type_Number;
meth_meth_ast_toGrace8402->type->names[0] = "depth";
  meth_meth_ast_toGrace8402->definitionModule = modulename;
  meth_meth_ast_toGrace8402->definitionLine = 2103;
// method "shallowCopy"
  block_savedest(obj8094);
  Object closure8522 = createclosure(1, "shallowCopy");
  setclosureframe(closure8522, stackframe);
  addtoclosure(closure8522, var_varDecNode);
  struct UserObject *uo8522 = (struct UserObject*)obj8094;
  uo8522->data[17] = (Object)closure8522;
  Method *meth_meth_ast_shallowCopy8522 = addmethod2pos(obj8094, "shallowCopy", &meth_ast_shallowCopy8522, 17);
  int argcv_meth_ast_shallowCopy8522[] = {0};
  meth_meth_ast_shallowCopy8522->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8522);
  meth_meth_ast_shallowCopy8522->definitionModule = modulename;
  meth_meth_ast_shallowCopy8522->definitionLine = 2124;
// method "statementName"
  struct UserObject *uo8533 = (struct UserObject*)obj8094;
  uo8533->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8533 = addmethod2pos(obj8094, "statementName", &meth_ast_statementName8533, 18);
  int argcv_meth_ast_statementName8533[] = {0};
  meth_meth_ast_statementName8533->type = alloc_MethodType(1, argcv_meth_ast_statementName8533);
  meth_meth_ast_statementName8533->definitionModule = modulename;
  meth_meth_ast_statementName8533->definitionLine = 2127;
  sourceObject = obj8094;
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8535 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8536 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8537 = gc_frame_new();
// call case 3: self.outer request
  Object call8538 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8537);
// compiled call node returning call8538 (depth = 7)
// compiled member node returning call8538 (depth = 6)
  partcv[0] = 0;
  Object call8539 = callmethodflags(call8538, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8536);
// compiled call node returning call8539 (depth = 5)
// compiled member node returning call8539 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8540 = callmethodflags(call8539, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8535);
// compiled call node returning call8540 (depth = 3)
  struct UserObject *obj8094_uo = (struct UserObject *)obj8094;
  obj8094_uo->super = call8540;
  sourceObject = obj8094;
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8541 == NULL) {
    strlit8541 = alloc_String("vardec");
    gc_root(strlit8541);
  }
// compiled string node returning strlit8541 (depth = 3)
  adddatum2(obj8094, strlit8541, 1);
  sourceObject = obj8094;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8094, *var_name_39_, 2);
  sourceObject = obj8094;
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8094, *var_val_39_, 3);
  sourceObject = obj8094;
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8094, *var_dtype_39_, 4);
  sourceObject = obj8094;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8542 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8544 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8543);
// compiled call node returning call8544 (depth = 6)
// compiled member node returning call8544 (depth = 5)
  partcv[0] = 0;
  Object call8545 = callmethod(call8544, "value",
    1, partcv, params);
  gc_frame_end(callframe8542);
// compiled call node returning call8545 (depth = 4)
// compiled member node returning call8545 (depth = 3)
  adddatum2(obj8094, call8545, 5);
  sourceObject = obj8094;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8546 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8546 (depth = 3)
  adddatum2(obj8094, array8546, 6);
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  objclass8094 = obj8094->class;
  objclass8094->definitionModule = modulename;
  objclass8094->definitionLine = 2024;
  (*(struct UserObject *)self).data[0] = lowerouter8094;
  self = oldself8094;
  selfslot = oldselfslot8094;
  stackframe = oldstackframe8094;
  gc_frame_end(frame);
  return obj8094;
}
Object meth_ast_new8093_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_varDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8094 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8094 = alloc_userobj2(22,19, objclass8094);
  gc_frame_newslot(obj8094);
if (objclass8094 == NULL) {
  glfree(obj8094->class->name);
  obj8094->class->name = "varDecNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8094, self, 0);
  addmethodreal(obj8094,"outer", &reader_ast_outer_8095);
  Object oldself8094 = self;
  struct StackFrameObject *oldstackframe8094 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8094);
  gc_frame_newslot((Object)stackframe);
  self = obj8094;
  Object *oldselfslot8094 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8094 = (*(struct UserObject *)self).data[0], lowerouter8094 = thisouter8094;
  if (inheritingObject8094) {
    struct UserObject *inho8094 = (struct UserObject *)inheritingObject8094;
    while (inho8094->super != GraceDefaultObject) inho8094 = (struct UserObject *)inho8094->super;
    inho8094->super = obj8094;
    self = inheritingObject8094;
    *selfslot = self;
    lowerouter8094 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8094;
  }
if (objclass8094 == NULL) {
  Method *reader8096 = addmethodrealflags(obj8094, "kind",&reader_ast_kind_8096, MFLAG_DEF);
  reader8096->definitionModule = modulename;
  reader8096->definitionLine = 2026;
}
adddatum2(obj8094, alloc_Undefined(), 1);
if (objclass8094 == NULL) {
  Method *reader8097 = addmethodrealflags(obj8094, "name",&reader_ast_name_8097, 0);
  Method *writer8097 = addmethodrealflags(obj8094, "name:=",&writer_ast_name_8097, 0);
  reader8097->definitionModule = modulename;
  writer8097->definitionModule = modulename;
  reader8097->definitionLine = 2027;
  writer8097->definitionLine = 2027;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 2);
if (objclass8094 == NULL) {
  Method *reader8098 = addmethodrealflags(obj8094, "value",&reader_ast_value_8098, 0);
  Method *writer8098 = addmethodrealflags(obj8094, "value:=",&writer_ast_value_8098, 0);
  reader8098->definitionModule = modulename;
  writer8098->definitionModule = modulename;
  reader8098->definitionLine = 2028;
  writer8098->definitionLine = 2028;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 3);
if (objclass8094 == NULL) {
  Method *reader8099 = addmethodrealflags(obj8094, "dtype",&reader_ast_dtype_8099, 0);
  Method *writer8099 = addmethodrealflags(obj8094, "dtype:=",&writer_ast_dtype_8099, 0);
  reader8099->definitionModule = modulename;
  writer8099->definitionModule = modulename;
  reader8099->definitionLine = 2029;
  writer8099->definitionLine = 2029;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 4);
if (objclass8094 == NULL) {
  Method *reader8100 = addmethodrealflags(obj8094, "nameString",&reader_ast_nameString_8100, MFLAG_DEF);
  reader8100->definitionModule = modulename;
  reader8100->definitionLine = 2030;
}
adddatum2(obj8094, alloc_Undefined(), 5);
if (objclass8094 == NULL) {
  Method *reader8101 = addmethodrealflags(obj8094, "annotations",&reader_ast_annotations_8101, 0);
  Method *writer8101 = addmethodrealflags(obj8094, "annotations:=",&writer_ast_annotations_8101, 0);
  reader8101->definitionModule = modulename;
  writer8101->definitionModule = modulename;
  reader8101->definitionLine = 2031;
  writer8101->definitionLine = 2031;
}
obj8094->flags |= OFLAG_MUTABLE;
adddatum2(obj8094, alloc_Undefined(), 6);
// method "isPublic"
  struct UserObject *uo8102 = (struct UserObject*)obj8094;
  uo8102->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8102 = addmethod2pos(obj8094, "isPublic", &meth_ast_isPublic8102, 7);
  int argcv_meth_ast_isPublic8102[] = {0};
  meth_meth_ast_isPublic8102->type = alloc_MethodType(1, argcv_meth_ast_isPublic8102);
  meth_meth_ast_isPublic8102->definitionModule = modulename;
  meth_meth_ast_isPublic8102->definitionLine = 2033;
// method "isWritable"
  struct UserObject *uo8129 = (struct UserObject*)obj8094;
  uo8129->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8129 = addmethod2pos(obj8094, "isWritable", &meth_ast_isWritable8129, 8);
  int argcv_meth_ast_isWritable8129[] = {0};
  meth_meth_ast_isWritable8129->type = alloc_MethodType(1, argcv_meth_ast_isWritable8129);
  meth_meth_ast_isWritable8129->definitionModule = modulename;
  meth_meth_ast_isWritable8129->definitionLine = 2039;
// method "isReadable"
  struct UserObject *uo8159 = (struct UserObject*)obj8094;
  uo8159->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8159 = addmethod2pos(obj8094, "isReadable", &meth_ast_isReadable8159, 9);
  int argcv_meth_ast_isReadable8159[] = {0};
  meth_meth_ast_isReadable8159->type = alloc_MethodType(1, argcv_meth_ast_isReadable8159);
  meth_meth_ast_isReadable8159->definitionModule = modulename;
  meth_meth_ast_isReadable8159->definitionLine = 2045;
// method "isFieldDec"
  struct UserObject *uo8189 = (struct UserObject*)obj8094;
  uo8189->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8189 = addmethod2pos(obj8094, "isFieldDec", &meth_ast_isFieldDec8189, 10);
  int argcv_meth_ast_isFieldDec8189[] = {0};
  meth_meth_ast_isFieldDec8189->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8189);
  meth_meth_ast_isFieldDec8189->definitionModule = modulename;
  meth_meth_ast_isFieldDec8189->definitionLine = 2051;
// method "usesAsType"
  struct UserObject *uo8191 = (struct UserObject*)obj8094;
  uo8191->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8191 = addmethod2pos(obj8094, "usesAsType", &meth_ast_usesAsType8191, 11);
  int argcv_meth_ast_usesAsType8191[] = {1};
  meth_meth_ast_usesAsType8191->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8191);
  meth_meth_ast_usesAsType8191->definitionModule = modulename;
  meth_meth_ast_usesAsType8191->definitionLine = 2053;
// method "declarationKindWithAncestors"
  block_savedest(obj8094);
  Object closure8197 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8197, stackframe);
  addtoclosure(closure8197, var_k);
  struct UserObject *uo8197 = (struct UserObject*)obj8094;
  uo8197->data[12] = (Object)closure8197;
  Method *meth_meth_ast_declarationKindWithAncestors8197 = addmethod2pos(obj8094, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8197, 12);
  int argcv_meth_ast_declarationKindWithAncestors8197[] = {1};
  meth_meth_ast_declarationKindWithAncestors8197->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8197);
  meth_meth_ast_declarationKindWithAncestors8197->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8197->definitionLine = 2057;
// method "accept()from"
  struct UserObject *uo8200 = (struct UserObject*)obj8094;
  uo8200->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8200 = addmethod2pos(obj8094, "accept()from", &meth_ast_accept_40__41_from8200, 13);
  int argcv_meth_ast_accept_40__41_from8200[] = {1, 1};
  meth_meth_ast_accept_40__41_from8200->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8200);
  meth_meth_ast_accept_40__41_from8200->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8200->definitionLine = 2059;
// method "map()ancestors"
  struct UserObject *uo8241 = (struct UserObject*)obj8094;
  uo8241->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8241 = addmethod2pos(obj8094, "map()ancestors", &meth_ast_map_40__41_ancestors8241, 14);
  int argcv_meth_ast_map_40__41_ancestors8241[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8241->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8241);
  meth_meth_ast_map_40__41_ancestors8241->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8241->definitionLine = 2074;
// method "pretty"
  struct UserObject *uo8284 = (struct UserObject*)obj8094;
  uo8284->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8284 = addmethod2pos(obj8094, "pretty", &meth_ast_pretty8284, 15);
  int argcv_meth_ast_pretty8284[] = {1};
  meth_meth_ast_pretty8284->type = alloc_MethodType(1, argcv_meth_ast_pretty8284);
  meth_meth_ast_pretty8284->definitionModule = modulename;
  meth_meth_ast_pretty8284->definitionLine = 2083;
// method "toGrace"
  struct UserObject *uo8402 = (struct UserObject*)obj8094;
  uo8402->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8402 = addmethod2pos(obj8094, "toGrace", &meth_ast_toGrace8402, 16);
  int argcv_meth_ast_toGrace8402[] = {1};
  meth_meth_ast_toGrace8402->type = alloc_MethodType(1, argcv_meth_ast_toGrace8402);
meth_meth_ast_toGrace8402->type->types[0] = type_Number;
meth_meth_ast_toGrace8402->type->names[0] = "depth";
  meth_meth_ast_toGrace8402->definitionModule = modulename;
  meth_meth_ast_toGrace8402->definitionLine = 2103;
// method "shallowCopy"
  block_savedest(obj8094);
  Object closure8522 = createclosure(1, "shallowCopy");
  setclosureframe(closure8522, stackframe);
  addtoclosure(closure8522, var_varDecNode);
  struct UserObject *uo8522 = (struct UserObject*)obj8094;
  uo8522->data[17] = (Object)closure8522;
  Method *meth_meth_ast_shallowCopy8522 = addmethod2pos(obj8094, "shallowCopy", &meth_ast_shallowCopy8522, 17);
  int argcv_meth_ast_shallowCopy8522[] = {0};
  meth_meth_ast_shallowCopy8522->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8522);
  meth_meth_ast_shallowCopy8522->definitionModule = modulename;
  meth_meth_ast_shallowCopy8522->definitionLine = 2124;
// method "statementName"
  struct UserObject *uo8533 = (struct UserObject*)obj8094;
  uo8533->data[18] = emptyclosure;
  Method *meth_meth_ast_statementName8533 = addmethod2pos(obj8094, "statementName", &meth_ast_statementName8533, 18);
  int argcv_meth_ast_statementName8533[] = {0};
  meth_meth_ast_statementName8533->type = alloc_MethodType(1, argcv_meth_ast_statementName8533);
  meth_meth_ast_statementName8533->definitionModule = modulename;
  meth_meth_ast_statementName8533->definitionLine = 2127;
  sourceObject = obj8094;
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8535 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8536 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8537 = gc_frame_new();
// call case 3: self.outer request
  Object call8538 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8537);
// compiled call node returning call8538 (depth = 7)
// compiled member node returning call8538 (depth = 6)
  partcv[0] = 0;
  Object call8539 = callmethodflags(call8538, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8536);
// compiled call node returning call8539 (depth = 5)
// compiled member node returning call8539 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8540 = callmethodflags(call8539, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8535);
// compiled call node returning call8540 (depth = 3)
  struct UserObject *obj8094_uo = (struct UserObject *)obj8094;
  obj8094_uo->super = call8540;
  sourceObject = obj8094;
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8541 == NULL) {
    strlit8541 = alloc_String("vardec");
    gc_root(strlit8541);
  }
// compiled string node returning strlit8541 (depth = 3)
  adddatum2(obj8094, strlit8541, 1);
  sourceObject = obj8094;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8094, *var_name_39_, 2);
  sourceObject = obj8094;
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj8094, *var_val_39_, 3);
  sourceObject = obj8094;
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8094, *var_dtype_39_, 4);
  sourceObject = obj8094;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8542 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8544 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8543);
// compiled call node returning call8544 (depth = 6)
// compiled member node returning call8544 (depth = 5)
  partcv[0] = 0;
  Object call8545 = callmethod(call8544, "value",
    1, partcv, params);
  gc_frame_end(callframe8542);
// compiled call node returning call8545 (depth = 4)
// compiled member node returning call8545 (depth = 3)
  adddatum2(obj8094, call8545, 5);
  sourceObject = obj8094;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8546 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8546 (depth = 3)
  adddatum2(obj8094, array8546, 6);
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  sourceObject = obj8094;
  objclass8094 = obj8094->class;
  objclass8094->definitionModule = modulename;
  objclass8094->definitionLine = 2024;
  (*(struct UserObject *)self).data[0] = lowerouter8094;
  self = oldself8094;
  selfslot = oldselfslot8094;
  stackframe = oldstackframe8094;
  gc_frame_end(frame);
  return obj8094;
}
Object meth_ast_varDecNode8548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isImport8559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isImport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isImport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8560 = alloc_Boolean(1);
// compiled identifier node returning bool8560 (depth = 3)
  gc_frame_end(frame);
  return bool8560;
}
Object meth_ast_isExternal8561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8562 = alloc_Boolean(1);
// compiled identifier node returning bool8562 (depth = 3)
  gc_frame_end(frame);
  return bool8562;
}
Object meth_ast_isExecutable8563(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8564 = alloc_Boolean(0);
// compiled identifier node returning bool8564 (depth = 3)
  gc_frame_end(frame);
  return bool8564;
}
Object meth_ast_name8565(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8567 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8566);
// compiled call node returning call8567 (depth = 4)
// compiled member node returning call8567 (depth = 3)
  gc_frame_end(frame);
  return call8567;
}
Object meth_ast_nameString8568(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8569 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8570 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8571 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8570);
// compiled call node returning call8571 (depth = 6)
// compiled member node returning call8571 (depth = 5)
  partcv[0] = 0;
  Object call8572 = callmethod(call8571, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8569);
// compiled call node returning call8572 (depth = 4)
// compiled member node returning call8572 (depth = 3)
  gc_frame_end(frame);
  return call8572;
}
Object meth_ast_isPublic8573(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8576 = alloc_Float64(0);
// compiled num node returning num8576 (depth = 5)
  int op_slot_right_8575 = gc_frame_newslot(num8576);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8578 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8579 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8580 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8579);
// compiled call node returning call8580 (depth = 8)
// compiled member node returning call8580 (depth = 7)
  partcv[0] = 0;
  Object call8581 = callmethod(call8580, "size",
    1, partcv, params);
  gc_frame_end(callframe8578);
// compiled call node returning call8581 (depth = 6)
// compiled member node returning call8581 (depth = 5)
  int op_slot_left_8575 = gc_frame_newslot(call8581);
  params[0] = num8576;
  partcv[0] = 1;
  Object opresult8582 = callmethod(call8581, "==", 1, partcv, params);
// compiled op node returning opresult8582 (depth = 4)
  Object if8574 = done;
  if (istrue(opresult8582)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8583 = alloc_Boolean(0);
// compiled identifier node returning bool8583 (depth = 5)
  return bool8583;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8574 = undefined;
  } else {
  }
// compiled if node returning if8574 (depth = 3)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8585 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8586 == NULL) {
    strlit8586 = alloc_String("public");
    gc_root(strlit8586);
  }
// compiled string node returning strlit8586 (depth = 5)
  gc_frame_newslot(strlit8586);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8587 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8588 = gc_frame_new();
// call case 3: self.outer request
  Object call8589 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8588);
// compiled call node returning call8589 (depth = 8)
// compiled member node returning call8589 (depth = 7)
  partcv[0] = 0;
  Object call8590 = callmethodflags(call8589, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8587);
// compiled call node returning call8590 (depth = 6)
// compiled member node returning call8590 (depth = 5)
  params[0] = self;
  params[1] = strlit8586;
  partcv[0] = 2;
  Object call8591 = callmethodflags(call8590, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8585);
// compiled call node returning call8591 (depth = 4)
  Object if8584 = done;
  if (istrue(call8591)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8592 = alloc_Boolean(1);
// compiled identifier node returning bool8592 (depth = 5)
  return bool8592;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if8584 = undefined;
  } else {
  }
// compiled if node returning if8584 (depth = 3)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8593 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile string node (depth = 4)
  if (strlit8594 == NULL) {
    strlit8594 = alloc_String("readable");
    gc_root(strlit8594);
  }
// compiled string node returning strlit8594 (depth = 4)
  gc_frame_newslot(strlit8594);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8595 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8596 = gc_frame_new();
// call case 3: self.outer request
  Object call8597 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8596);
// compiled call node returning call8597 (depth = 7)
// compiled member node returning call8597 (depth = 6)
  partcv[0] = 0;
  Object call8598 = callmethodflags(call8597, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8595);
// compiled call node returning call8598 (depth = 5)
// compiled member node returning call8598 (depth = 4)
  params[0] = self;
  params[1] = strlit8594;
  partcv[0] = 2;
  Object call8599 = callmethodflags(call8598, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8593);
// compiled call node returning call8599 (depth = 3)
  gc_frame_end(frame);
  return call8599;
}
Object meth_ast__apply8606(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8609 == NULL) {
    strlit8609 = alloc_String("/");
    gc_root(strlit8609);
  }
// compiled string node returning strlit8609 (depth = 7)
  int op_slot_right_8608 = gc_frame_newslot(strlit8609);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_8608 = gc_frame_newslot(*var_c);
  params[0] = strlit8609;
  partcv[0] = 1;
  Object opresult8611 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult8611 (depth = 6)
  Object if8607 = done;
  if (istrue(opresult8611)) {
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8612 == NULL) {
    strlit8612 = alloc_String("");
    gc_root(strlit8612);
  }
// compiled string node returning strlit8612 (depth = 7)
  *var_bnm = strlit8612;
  if (strlit8612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8607 = done;
  } else {
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_8614 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_8614 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult8616 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult8616 (depth = 7)
  *var_bnm = opresult8616;
  if (opresult8616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8607 = done;
  }
// compiled if node returning if8607 (depth = 5)
  gc_frame_end(frame);
  return if8607;
}
Object meth_ast_moduleName8600(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8601 == NULL) {
    strlit8601 = alloc_String("");
    gc_root(strlit8601);
  }
// compiled string node returning strlit8601 (depth = 4)
  *var_bnm = strlit8601;
  if (strlit8601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2152
  setline(2152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8602 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8604 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8603);
// compiled call node returning call8604 (depth = 5)
// compiled member node returning call8604 (depth = 4)
  gc_frame_newslot(call8604);
// starting to compile block node (depth = 4)
  Object block8605 = alloc_Block(NULL, NULL, "ast", 2152);
  gc_frame_newslot(block8605);
// method "_apply"
  block_savedest(block8605);
  Object closure8606 = createclosure(2, "_apply");
  setclosureframe(closure8606, stackframe);
  addtoclosure(closure8606, var_bnm);
  addtoclosure(closure8606, selfslot);
  struct UserObject *uo8606 = (struct UserObject*)block8605;
  uo8606->data[0] = (Object)closure8606;
  Method *meth_meth_ast__apply8606 = addmethod2pos(block8605, "_apply", &meth_ast__apply8606, 0);
  int argcv_meth_ast__apply8606[] = {1};
  meth_meth_ast__apply8606->type = alloc_MethodType(1, argcv_meth_ast__apply8606);
  meth_meth_ast__apply8606->definitionModule = modulename;
  meth_meth_ast__apply8606->definitionLine = 2152;
// compiled block node returning block8605 (depth = 4)
  gc_frame_newslot(block8605);
// call case 5: prelude request
  params[0] = call8604;
  params[1] = block8605;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8619 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8602);
// compiled call node returning call8619 (depth = 3)
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_isWritable8620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8621 = alloc_Boolean(0);
// compiled identifier node returning bool8621 (depth = 3)
  gc_frame_end(frame);
  return bool8621;
}
Object meth_ast_isReadable8622(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8624 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8623);
// compiled call node returning call8624 (depth = 4)
// compiled member node returning call8624 (depth = 3)
  gc_frame_end(frame);
  return call8624;
}
Object meth_ast_declarationKindWithAncestors8625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call8627 = callmethod(*var_k, "defdec",
    1, partcv, params);
  gc_frame_end(callframe8626);
// compiled call node returning call8627 (depth = 4)
// compiled member node returning call8627 (depth = 3)
  gc_frame_end(frame);
  return call8627;
}
Object meth_ast_usesAsType8628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8630 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8631 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8630);
// compiled call node returning call8631 (depth = 5)
// compiled member node returning call8631 (depth = 4)
  int op_slot_right_8629 = gc_frame_newslot(call8631);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aNode (depth = 4)
  int op_slot_left_8629 = gc_frame_newslot(*var_aNode);
  params[0] = call8631;
  partcv[0] = 1;
  Object opresult8633 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8633 (depth = 3)
  gc_frame_end(frame);
  return opresult8633;
}
Object meth_ast__apply8644(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8645 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8646 = callmethod(*var_ann, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8645);
// compiled call node returning call8646 (depth = 6)
  gc_frame_end(frame);
  return call8646;
}
Object meth_ast_accept_40__41_from8634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8636 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8637 = callmethod(*var_visitor, "visitImport()up",
    2, partcv, params);
  gc_frame_end(callframe8636);
// compiled call node returning call8637 (depth = 4)
  Object if8635 = done;
  if (istrue(call8637)) {
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8638 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8639 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8638);
// compiled call node returning call8639 (depth = 5)
  *var_newChain = call8639;
  if (call8639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8640 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8642 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8641);
// compiled call node returning call8642 (depth = 6)
// compiled member node returning call8642 (depth = 5)
  gc_frame_newslot(call8642);
// starting to compile block node (depth = 5)
  Object block8643 = alloc_Block(NULL, NULL, "ast", 2170);
  gc_frame_newslot(block8643);
// method "_apply"
  block_savedest(block8643);
  Object closure8644 = createclosure(3, "_apply");
  setclosureframe(closure8644, stackframe);
  addtoclosure(closure8644, var_visitor);
  addtoclosure(closure8644, var_newChain);
  addtoclosure(closure8644, selfslot);
  struct UserObject *uo8644 = (struct UserObject*)block8643;
  uo8644->data[0] = (Object)closure8644;
  Method *meth_meth_ast__apply8644 = addmethod2pos(block8643, "_apply", &meth_ast__apply8644, 0);
  int argcv_meth_ast__apply8644[] = {1};
  meth_meth_ast__apply8644->type = alloc_MethodType(1, argcv_meth_ast__apply8644);
  meth_meth_ast__apply8644->definitionModule = modulename;
  meth_meth_ast__apply8644->definitionLine = 2170;
// compiled block node returning block8643 (depth = 5)
  gc_frame_newslot(block8643);
// call case 5: prelude request
  params[0] = call8642;
  params[1] = block8643;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8648 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8640);
// compiled call node returning call8648 (depth = 4)
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8649 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8651 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8650);
// compiled call node returning call8651 (depth = 6)
// compiled member node returning call8651 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8652 = callmethod(call8651, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8649);
// compiled call node returning call8652 (depth = 4)
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8656 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8655);
// compiled call node returning call8656 (depth = 7)
// compiled member node returning call8656 (depth = 6)
  int op_slot_right_8654 = gc_frame_newslot(call8656);
// starting to compile identifier node (depth = 6)
  Object bool8658 = alloc_Boolean(0);
// compiled identifier node returning bool8658 (depth = 6)
  int op_slot_left_8654 = gc_frame_newslot(bool8658);
  params[0] = call8656;
  partcv[0] = 1;
  Object opresult8659 = callmethod(bool8658, "≠", 1, partcv, params);
// compiled op node returning opresult8659 (depth = 5)
  Object if8653 = done;
  if (istrue(opresult8659)) {
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8660 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8662 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8661);
// compiled call node returning call8662 (depth = 7)
// compiled member node returning call8662 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8663 = callmethod(call8662, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8660);
// compiled call node returning call8663 (depth = 5)
    gc_frame_newslot(call8663);
    if8653 = call8663;
  } else {
  }
// compiled if node returning if8653 (depth = 4)
    gc_frame_newslot(if8653);
    if8635 = if8653;
  } else {
  }
// compiled if node returning if8635 (depth = 3)
  gc_frame_end(frame);
  return if8635;
}
Object meth_ast_map_40__41_ancestors8664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8665 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8666 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8665);
// compiled call node returning call8666 (depth = 5)
// compiled member node returning call8666 (depth = 4)
  *var_n = call8666;
  if (call8666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8667 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8668 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8667);
// compiled call node returning call8668 (depth = 4)
  *var_newChain = call8668;
  if (call8668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8669 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8670 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8672 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8671);
// compiled call node returning call8672 (depth = 6)
// compiled member node returning call8672 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8673 = callmethod(call8672, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8670);
// compiled call node returning call8673 (depth = 4)
  gc_frame_newslot(call8673);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8673;
  partcv[0] = 1;
  Object call8674 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8669);
// compiled call node returning call8674 (depth = 3)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8675 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8676 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8678 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8677);
// compiled call node returning call8678 (depth = 6)
// compiled member node returning call8678 (depth = 5)
  gc_frame_newslot(call8678);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8679 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8680 = gc_frame_new();
// call case 3: self.outer request
  Object call8681 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8680);
// compiled call node returning call8681 (depth = 8)
// compiled member node returning call8681 (depth = 7)
  partcv[0] = 0;
  Object call8682 = callmethodflags(call8681, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8679);
// compiled call node returning call8682 (depth = 6)
// compiled member node returning call8682 (depth = 5)
  params[0] = call8678;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8683 = callmethodflags(call8682, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8676);
// compiled call node returning call8683 (depth = 4)
  gc_frame_newslot(call8683);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8683;
  partcv[0] = 1;
  Object call8684 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8675);
// compiled call node returning call8684 (depth = 3)
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8685 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8686 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8687 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8688 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8687);
// compiled call node returning call8688 (depth = 6)
// compiled member node returning call8688 (depth = 5)
  gc_frame_newslot(call8688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8689 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8690 = gc_frame_new();
// call case 3: self.outer request
  Object call8691 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8690);
// compiled call node returning call8691 (depth = 8)
// compiled member node returning call8691 (depth = 7)
  partcv[0] = 0;
  Object call8692 = callmethodflags(call8691, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8689);
// compiled call node returning call8692 (depth = 6)
// compiled member node returning call8692 (depth = 5)
  params[0] = call8688;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8693 = callmethodflags(call8692, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8686);
// compiled call node returning call8693 (depth = 4)
  gc_frame_newslot(call8693);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8693;
  partcv[0] = 1;
  Object call8694 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8685);
// compiled call node returning call8694 (depth = 3)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8695 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8696 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 3)
  gc_frame_end(frame);
  return call8696;
}
Object meth_ast__apply8705(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8707 == NULL) {
    strlit8707 = alloc_String("  ");
    gc_root(strlit8707);
  }
// compiled string node returning strlit8707 (depth = 7)
  int op_slot_right_8706 = gc_frame_newslot(strlit8707);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8706 = gc_frame_newslot(*var_spc);
  params[0] = strlit8707;
  partcv[0] = 1;
  Object opresult8709 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8709 (depth = 6)
  *var_spc = opresult8709;
  if (opresult8709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8698 == NULL) {
    strlit8698 = alloc_String("");
    gc_root(strlit8698);
  }
// compiled string node returning strlit8698 (depth = 4)
  *var_spc = strlit8698;
  if (strlit8698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8699 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8700 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8702 = alloc_Float64(0);
// compiled num node returning num8702 (depth = 5)
  int op_slot_left_8700 = gc_frame_newslot(num8702);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8703 = callmethod(num8702, "..", 1, partcv, params);
// compiled op node returning opresult8703 (depth = 4)
  gc_frame_newslot(opresult8703);
// starting to compile block node (depth = 4)
  Object block8704 = alloc_Block(NULL, NULL, "ast", 2189);
  gc_frame_newslot(block8704);
// method "_apply"
  block_savedest(block8704);
  Object closure8705 = createclosure(2, "_apply");
  setclosureframe(closure8705, stackframe);
  addtoclosure(closure8705, var_spc);
  addtoclosure(closure8705, selfslot);
  struct UserObject *uo8705 = (struct UserObject*)block8704;
  uo8705->data[0] = (Object)closure8705;
  Method *meth_meth_ast__apply8705 = addmethod2pos(block8704, "_apply", &meth_ast__apply8705, 0);
  int argcv_meth_ast__apply8705[] = {1};
  meth_meth_ast__apply8705->type = alloc_MethodType(1, argcv_meth_ast__apply8705);
  meth_meth_ast__apply8705->definitionModule = modulename;
  meth_meth_ast__apply8705->definitionLine = 2184;
// compiled block node returning block8704 (depth = 4)
  gc_frame_newslot(block8704);
// call case 5: prelude request
  params[0] = opresult8703;
  params[1] = block8704;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8712 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8699);
// compiled call node returning call8712 (depth = 3)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8714 == NULL) {
    strlit8714 = alloc_String("""\x0a""");
    gc_root(strlit8714);
  }
// compiled string node returning strlit8714 (depth = 5)
  int op_slot_right_8713 = gc_frame_newslot(strlit8714);
// starting to compile call node (depth = 5)
  int callframe8716 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8717 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8716);
// compiled call node returning call8717 (depth = 5)
  int op_slot_left_8713 = gc_frame_newslot(call8717);
  params[0] = strlit8714;
  partcv[0] = 1;
  Object opresult8718 = callmethod(call8717, "++", 1, partcv, params);
// compiled op node returning opresult8718 (depth = 4)
  *var_s = opresult8718;
  if (opresult8718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8721 == NULL) {
    strlit8721 = alloc_String("""\x0a""");
    gc_root(strlit8721);
  }
// compiled string node returning strlit8721 (depth = 6)
  int op_slot_right_8720 = gc_frame_newslot(strlit8721);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8724 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8725 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8724);
// compiled call node returning call8725 (depth = 8)
// compiled member node returning call8725 (depth = 7)
  int op_slot_right_8723 = gc_frame_newslot(call8725);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8728 == NULL) {
    strlit8728 = alloc_String("Path: ");
    gc_root(strlit8728);
  }
// compiled string node returning strlit8728 (depth = 8)
  int op_slot_right_8727 = gc_frame_newslot(strlit8728);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_8730 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit8732 == NULL) {
    strlit8732 = alloc_String("");
    gc_root(strlit8732);
  }
// compiled string node returning strlit8732 (depth = 9)
  int op_slot_left_8730 = gc_frame_newslot(strlit8732);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8733 = callmethod(strlit8732, "++", 1, partcv, params);
// compiled op node returning opresult8733 (depth = 8)
  int op_slot_left_8727 = gc_frame_newslot(opresult8733);
  params[0] = strlit8728;
  partcv[0] = 1;
  Object opresult8734 = callmethod(opresult8733, "++", 1, partcv, params);
// compiled op node returning opresult8734 (depth = 7)
  int op_slot_left_8723 = gc_frame_newslot(opresult8734);
  params[0] = call8725;
  partcv[0] = 1;
  Object opresult8735 = callmethod(opresult8734, "++", 1, partcv, params);
// compiled op node returning opresult8735 (depth = 6)
  int op_slot_left_8720 = gc_frame_newslot(opresult8735);
  params[0] = strlit8721;
  partcv[0] = 1;
  Object opresult8736 = callmethod(opresult8735, "++", 1, partcv, params);
// compiled op node returning opresult8736 (depth = 5)
  int op_slot_right_8719 = gc_frame_newslot(opresult8736);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8719 = gc_frame_newslot(*var_s);
  params[0] = opresult8736;
  partcv[0] = 1;
  Object opresult8738 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8738 (depth = 4)
  *var_s = opresult8738;
  if (opresult8738 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8742 == NULL) {
    strlit8742 = alloc_String("""\x0a""");
    gc_root(strlit8742);
  }
// compiled string node returning strlit8742 (depth = 6)
  int op_slot_right_8741 = gc_frame_newslot(strlit8742);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8745 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8746 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8745);
// compiled call node returning call8746 (depth = 8)
// compiled member node returning call8746 (depth = 7)
  int op_slot_right_8744 = gc_frame_newslot(call8746);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8749 == NULL) {
    strlit8749 = alloc_String("Identifier: ");
    gc_root(strlit8749);
  }
// compiled string node returning strlit8749 (depth = 8)
  int op_slot_right_8748 = gc_frame_newslot(strlit8749);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_8751 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit8753 == NULL) {
    strlit8753 = alloc_String("");
    gc_root(strlit8753);
  }
// compiled string node returning strlit8753 (depth = 9)
  int op_slot_left_8751 = gc_frame_newslot(strlit8753);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8754 = callmethod(strlit8753, "++", 1, partcv, params);
// compiled op node returning opresult8754 (depth = 8)
  int op_slot_left_8748 = gc_frame_newslot(opresult8754);
  params[0] = strlit8749;
  partcv[0] = 1;
  Object opresult8755 = callmethod(opresult8754, "++", 1, partcv, params);
// compiled op node returning opresult8755 (depth = 7)
  int op_slot_left_8744 = gc_frame_newslot(opresult8755);
  params[0] = call8746;
  partcv[0] = 1;
  Object opresult8756 = callmethod(opresult8755, "++", 1, partcv, params);
// compiled op node returning opresult8756 (depth = 6)
  int op_slot_left_8741 = gc_frame_newslot(opresult8756);
  params[0] = strlit8742;
  partcv[0] = 1;
  Object opresult8757 = callmethod(opresult8756, "++", 1, partcv, params);
// compiled op node returning opresult8757 (depth = 5)
  int op_slot_right_8740 = gc_frame_newslot(opresult8757);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8740 = gc_frame_newslot(*var_s);
  params[0] = opresult8757;
  partcv[0] = 1;
  Object opresult8759 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8759 (depth = 4)
  *var_s = opresult8759;
  if (opresult8759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8763 = alloc_Float64(0);
// compiled num node returning num8763 (depth = 5)
  int op_slot_right_8762 = gc_frame_newslot(num8763);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8765 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8766 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8767 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8766);
// compiled call node returning call8767 (depth = 8)
// compiled member node returning call8767 (depth = 7)
  partcv[0] = 0;
  Object call8768 = callmethod(call8767, "size",
    1, partcv, params);
  gc_frame_end(callframe8765);
// compiled call node returning call8768 (depth = 6)
// compiled member node returning call8768 (depth = 5)
  int op_slot_left_8762 = gc_frame_newslot(call8768);
  params[0] = num8763;
  partcv[0] = 1;
  Object opresult8769 = callmethod(call8768, ">", 1, partcv, params);
// compiled op node returning opresult8769 (depth = 4)
  Object if8761 = done;
  if (istrue(opresult8769)) {
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8772 == NULL) {
    strlit8772 = alloc_String("""\x0a""");
    gc_root(strlit8772);
  }
// compiled string node returning strlit8772 (depth = 7)
  int op_slot_right_8771 = gc_frame_newslot(strlit8772);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8776 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8775);
// compiled call node returning call8776 (depth = 9)
// compiled member node returning call8776 (depth = 8)
  int op_slot_right_8774 = gc_frame_newslot(call8776);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8779 == NULL) {
    strlit8779 = alloc_String("Anotations: ");
    gc_root(strlit8779);
  }
// compiled string node returning strlit8779 (depth = 9)
  int op_slot_right_8778 = gc_frame_newslot(strlit8779);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_8781 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit8783 == NULL) {
    strlit8783 = alloc_String("");
    gc_root(strlit8783);
  }
// compiled string node returning strlit8783 (depth = 10)
  int op_slot_left_8781 = gc_frame_newslot(strlit8783);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8784 = callmethod(strlit8783, "++", 1, partcv, params);
// compiled op node returning opresult8784 (depth = 9)
  int op_slot_left_8778 = gc_frame_newslot(opresult8784);
  params[0] = strlit8779;
  partcv[0] = 1;
  Object opresult8785 = callmethod(opresult8784, "++", 1, partcv, params);
// compiled op node returning opresult8785 (depth = 8)
  int op_slot_left_8774 = gc_frame_newslot(opresult8785);
  params[0] = call8776;
  partcv[0] = 1;
  Object opresult8786 = callmethod(opresult8785, "++", 1, partcv, params);
// compiled op node returning opresult8786 (depth = 7)
  int op_slot_left_8771 = gc_frame_newslot(opresult8786);
  params[0] = strlit8772;
  partcv[0] = 1;
  Object opresult8787 = callmethod(opresult8786, "++", 1, partcv, params);
// compiled op node returning opresult8787 (depth = 6)
  int op_slot_right_8770 = gc_frame_newslot(opresult8787);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8770 = gc_frame_newslot(*var_s);
  params[0] = opresult8787;
  partcv[0] = 1;
  Object opresult8789 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 5)
  *var_s = opresult8789;
  if (opresult8789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8761 = done;
  } else {
  }
// compiled if node returning if8761 (depth = 3)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace8791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8793 == NULL) {
    strlit8793 = alloc_String("");
    gc_root(strlit8793);
  }
// compiled string node returning strlit8793 (depth = 4)
  int op_slot_right_8792 = gc_frame_newslot(strlit8793);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8797 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8796);
// compiled call node returning call8797 (depth = 6)
// compiled member node returning call8797 (depth = 5)
  int op_slot_right_8795 = gc_frame_newslot(call8797);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8800 == NULL) {
    strlit8800 = alloc_String("""\x22"" as ");
    gc_root(strlit8800);
  }
// compiled string node returning strlit8800 (depth = 6)
  int op_slot_right_8799 = gc_frame_newslot(strlit8800);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8804 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8803);
// compiled call node returning call8804 (depth = 8)
// compiled member node returning call8804 (depth = 7)
  int op_slot_right_8802 = gc_frame_newslot(call8804);
// starting to compile string node (depth = 7)
  if (strlit8806 == NULL) {
    strlit8806 = alloc_String("import ""\x22""");
    gc_root(strlit8806);
  }
// compiled string node returning strlit8806 (depth = 7)
  int op_slot_left_8802 = gc_frame_newslot(strlit8806);
  params[0] = call8804;
  partcv[0] = 1;
  Object opresult8807 = callmethod(strlit8806, "++", 1, partcv, params);
// compiled op node returning opresult8807 (depth = 6)
  int op_slot_left_8799 = gc_frame_newslot(opresult8807);
  params[0] = strlit8800;
  partcv[0] = 1;
  Object opresult8808 = callmethod(opresult8807, "++", 1, partcv, params);
// compiled op node returning opresult8808 (depth = 5)
  int op_slot_left_8795 = gc_frame_newslot(opresult8808);
  params[0] = call8797;
  partcv[0] = 1;
  Object opresult8809 = callmethod(opresult8808, "++", 1, partcv, params);
// compiled op node returning opresult8809 (depth = 4)
  int op_slot_left_8792 = gc_frame_newslot(opresult8809);
  params[0] = strlit8793;
  partcv[0] = 1;
  Object opresult8810 = callmethod(opresult8809, "++", 1, partcv, params);
// compiled op node returning opresult8810 (depth = 3)
  gc_frame_end(frame);
  return opresult8810;
}
Object meth_ast_shallowCopy8811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8812 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8813 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8815 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8814);
// compiled call node returning call8815 (depth = 6)
// compiled member node returning call8815 (depth = 5)
  gc_frame_newslot(call8815);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 5)
  Object bool8816 = alloc_Boolean(0);
// compiled identifier node returning bool8816 (depth = 5)
  gc_frame_newslot(bool8816);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_importNode (depth = 5)
  params[0] = call8815;
  params[1] = *var_nullNode;
  params[2] = bool8816;
  partcv[0] = 3;
  Object call8817 = callmethod(*var_importNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8813);
// compiled call node returning call8817 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8818 = callmethod(call8817, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8812);
// compiled call node returning call8818 (depth = 3)
  gc_frame_end(frame);
  return call8818;
}
Object meth_ast_new8551(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8552 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8552 = alloc_userobj2(25,22, objclass8552);
  gc_frame_newslot(obj8552);
if (objclass8552 == NULL) {
  glfree(obj8552->class->name);
  obj8552->class->name = "importNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8552, self, 0);
  addmethodreal(obj8552,"outer", &reader_ast_outer_8553);
  Object oldself8552 = self;
  struct StackFrameObject *oldstackframe8552 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8552);
  gc_frame_newslot((Object)stackframe);
  self = obj8552;
  Object *oldselfslot8552 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8552 = (*(struct UserObject *)self).data[0], lowerouter8552 = thisouter8552;
  if (inheritingObject8552) {
    struct UserObject *inho8552 = (struct UserObject *)inheritingObject8552;
    while (inho8552->super != GraceDefaultObject) inho8552 = (struct UserObject *)inho8552->super;
    inho8552->super = obj8552;
    self = inheritingObject8552;
    *selfslot = self;
    lowerouter8552 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8552;
  }
if (objclass8552 == NULL) {
  Method *reader8554 = addmethodrealflags(obj8552, "kind",&reader_ast_kind_8554, MFLAG_DEF);
  reader8554->definitionModule = modulename;
  reader8554->definitionLine = 2134;
}
adddatum2(obj8552, alloc_Undefined(), 1);
if (objclass8552 == NULL) {
  Method *reader8555 = addmethodrealflags(obj8552, "value",&reader_ast_value_8555, 0);
  Method *writer8555 = addmethodrealflags(obj8552, "value:=",&writer_ast_value_8555, 0);
  reader8555->definitionModule = modulename;
  writer8555->definitionModule = modulename;
  reader8555->definitionLine = 2135;
  writer8555->definitionLine = 2135;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 2);
if (objclass8552 == NULL) {
  Method *reader8556 = addmethodrealflags(obj8552, "path",&reader_ast_path_8556, 0);
  Method *writer8556 = addmethodrealflags(obj8552, "path:=",&writer_ast_path_8556, 0);
  reader8556->definitionModule = modulename;
  writer8556->definitionModule = modulename;
  reader8556->definitionLine = 2136;
  writer8556->definitionLine = 2136;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 3);
if (objclass8552 == NULL) {
  Method *reader8557 = addmethodrealflags(obj8552, "annotations",&reader_ast_annotations_8557, 0);
  Method *writer8557 = addmethodrealflags(obj8552, "annotations:=",&writer_ast_annotations_8557, 0);
  reader8557->definitionModule = modulename;
  writer8557->definitionModule = modulename;
  reader8557->definitionLine = 2137;
  writer8557->definitionLine = 2137;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 4);
if (objclass8552 == NULL) {
  Method *reader8558 = addmethodrealflags(obj8552, "dtype",&reader_ast_dtype_8558, 0);
  Method *writer8558 = addmethodrealflags(obj8552, "dtype:=",&writer_ast_dtype_8558, 0);
  reader8558->definitionModule = modulename;
  writer8558->definitionModule = modulename;
  reader8558->definitionLine = 2138;
  writer8558->definitionLine = 2138;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8559 = (struct UserObject*)obj8552;
  uo8559->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8559 = addmethod2pos(obj8552, "isImport", &meth_ast_isImport8559, 6);
  int argcv_meth_ast_isImport8559[] = {0};
  meth_meth_ast_isImport8559->type = alloc_MethodType(1, argcv_meth_ast_isImport8559);
  meth_meth_ast_isImport8559->definitionModule = modulename;
  meth_meth_ast_isImport8559->definitionLine = 2139;
// method "isExternal"
  struct UserObject *uo8561 = (struct UserObject*)obj8552;
  uo8561->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8561 = addmethod2pos(obj8552, "isExternal", &meth_ast_isExternal8561, 7);
  int argcv_meth_ast_isExternal8561[] = {0};
  meth_meth_ast_isExternal8561->type = alloc_MethodType(1, argcv_meth_ast_isExternal8561);
  meth_meth_ast_isExternal8561->definitionModule = modulename;
  meth_meth_ast_isExternal8561->definitionLine = 2140;
// method "isExecutable"
  struct UserObject *uo8563 = (struct UserObject*)obj8552;
  uo8563->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8563 = addmethod2pos(obj8552, "isExecutable", &meth_ast_isExecutable8563, 8);
  int argcv_meth_ast_isExecutable8563[] = {0};
  meth_meth_ast_isExecutable8563->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8563);
  meth_meth_ast_isExecutable8563->definitionModule = modulename;
  meth_meth_ast_isExecutable8563->definitionLine = 2141;
// method "name"
  struct UserObject *uo8565 = (struct UserObject*)obj8552;
  uo8565->data[9] = emptyclosure;
  Method *meth_meth_ast_name8565 = addmethod2pos(obj8552, "name", &meth_ast_name8565, 9);
  int argcv_meth_ast_name8565[] = {0};
  meth_meth_ast_name8565->type = alloc_MethodType(1, argcv_meth_ast_name8565);
  meth_meth_ast_name8565->definitionModule = modulename;
  meth_meth_ast_name8565->definitionLine = 2142;
// method "nameString"
  struct UserObject *uo8568 = (struct UserObject*)obj8552;
  uo8568->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8568 = addmethod2pos(obj8552, "nameString", &meth_ast_nameString8568, 10);
  int argcv_meth_ast_nameString8568[] = {0};
  meth_meth_ast_nameString8568->type = alloc_MethodType(1, argcv_meth_ast_nameString8568);
  meth_meth_ast_nameString8568->definitionModule = modulename;
  meth_meth_ast_nameString8568->definitionLine = 2143;
// method "isPublic"
  struct UserObject *uo8573 = (struct UserObject*)obj8552;
  uo8573->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8573 = addmethod2pos(obj8552, "isPublic", &meth_ast_isPublic8573, 11);
  int argcv_meth_ast_isPublic8573[] = {0};
  meth_meth_ast_isPublic8573->type = alloc_MethodType(1, argcv_meth_ast_isPublic8573);
  meth_meth_ast_isPublic8573->definitionModule = modulename;
  meth_meth_ast_isPublic8573->definitionLine = 2144;
// method "moduleName"
  struct UserObject *uo8600 = (struct UserObject*)obj8552;
  uo8600->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8600 = addmethod2pos(obj8552, "moduleName", &meth_ast_moduleName8600, 12);
  int argcv_meth_ast_moduleName8600[] = {0};
  meth_meth_ast_moduleName8600->type = alloc_MethodType(1, argcv_meth_ast_moduleName8600);
  meth_meth_ast_moduleName8600->definitionModule = modulename;
  meth_meth_ast_moduleName8600->definitionLine = 2150;
// method "isWritable"
  struct UserObject *uo8620 = (struct UserObject*)obj8552;
  uo8620->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8620 = addmethod2pos(obj8552, "isWritable", &meth_ast_isWritable8620, 13);
  int argcv_meth_ast_isWritable8620[] = {0};
  meth_meth_ast_isWritable8620->type = alloc_MethodType(1, argcv_meth_ast_isWritable8620);
  meth_meth_ast_isWritable8620->definitionModule = modulename;
  meth_meth_ast_isWritable8620->definitionLine = 2161;
// method "isReadable"
  struct UserObject *uo8622 = (struct UserObject*)obj8552;
  uo8622->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8622 = addmethod2pos(obj8552, "isReadable", &meth_ast_isReadable8622, 14);
  int argcv_meth_ast_isReadable8622[] = {0};
  meth_meth_ast_isReadable8622->type = alloc_MethodType(1, argcv_meth_ast_isReadable8622);
  meth_meth_ast_isReadable8622->definitionModule = modulename;
  meth_meth_ast_isReadable8622->definitionLine = 2162;
// method "declarationKindWithAncestors"
  block_savedest(obj8552);
  Object closure8625 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8625, stackframe);
  addtoclosure(closure8625, var_k);
  struct UserObject *uo8625 = (struct UserObject*)obj8552;
  uo8625->data[15] = (Object)closure8625;
  Method *meth_meth_ast_declarationKindWithAncestors8625 = addmethod2pos(obj8552, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8625, 15);
  int argcv_meth_ast_declarationKindWithAncestors8625[] = {1};
  meth_meth_ast_declarationKindWithAncestors8625->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8625);
  meth_meth_ast_declarationKindWithAncestors8625->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8625->definitionLine = 2163;
// method "usesAsType"
  struct UserObject *uo8628 = (struct UserObject*)obj8552;
  uo8628->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType8628 = addmethod2pos(obj8552, "usesAsType", &meth_ast_usesAsType8628, 16);
  int argcv_meth_ast_usesAsType8628[] = {1};
  meth_meth_ast_usesAsType8628->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8628);
  meth_meth_ast_usesAsType8628->definitionModule = modulename;
  meth_meth_ast_usesAsType8628->definitionLine = 2164;
// method "accept()from"
  struct UserObject *uo8634 = (struct UserObject*)obj8552;
  uo8634->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8634 = addmethod2pos(obj8552, "accept()from", &meth_ast_accept_40__41_from8634, 17);
  int argcv_meth_ast_accept_40__41_from8634[] = {1, 1};
  meth_meth_ast_accept_40__41_from8634->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8634);
  meth_meth_ast_accept_40__41_from8634->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8634->definitionLine = 2167;
// method "map()ancestors"
  struct UserObject *uo8664 = (struct UserObject*)obj8552;
  uo8664->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8664 = addmethod2pos(obj8552, "map()ancestors", &meth_ast_map_40__41_ancestors8664, 18);
  int argcv_meth_ast_map_40__41_ancestors8664[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8664->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8664);
  meth_meth_ast_map_40__41_ancestors8664->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8664->definitionLine = 2179;
// method "pretty"
  struct UserObject *uo8697 = (struct UserObject*)obj8552;
  uo8697->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty8697 = addmethod2pos(obj8552, "pretty", &meth_ast_pretty8697, 19);
  int argcv_meth_ast_pretty8697[] = {1};
  meth_meth_ast_pretty8697->type = alloc_MethodType(1, argcv_meth_ast_pretty8697);
  meth_meth_ast_pretty8697->definitionModule = modulename;
  meth_meth_ast_pretty8697->definitionLine = 2187;
// method "toGrace"
  struct UserObject *uo8791 = (struct UserObject*)obj8552;
  uo8791->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace8791 = addmethod2pos(obj8552, "toGrace", &meth_ast_toGrace8791, 20);
  int argcv_meth_ast_toGrace8791[] = {1};
  meth_meth_ast_toGrace8791->type = alloc_MethodType(1, argcv_meth_ast_toGrace8791);
meth_meth_ast_toGrace8791->type->types[0] = type_Number;
meth_meth_ast_toGrace8791->type->names[0] = "depth";
  meth_meth_ast_toGrace8791->definitionModule = modulename;
  meth_meth_ast_toGrace8791->definitionLine = 2200;
// method "shallowCopy"
  block_savedest(obj8552);
  Object closure8811 = createclosure(2, "shallowCopy");
  setclosureframe(closure8811, stackframe);
  addtoclosure(closure8811, var_nullNode);
  addtoclosure(closure8811, var_importNode);
  struct UserObject *uo8811 = (struct UserObject*)obj8552;
  uo8811->data[21] = (Object)closure8811;
  Method *meth_meth_ast_shallowCopy8811 = addmethod2pos(obj8552, "shallowCopy", &meth_ast_shallowCopy8811, 21);
  int argcv_meth_ast_shallowCopy8811[] = {0};
  meth_meth_ast_shallowCopy8811->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8811);
  meth_meth_ast_shallowCopy8811->definitionModule = modulename;
  meth_meth_ast_shallowCopy8811->definitionLine = 2203;
  sourceObject = obj8552;
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8819 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8820 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8821 = gc_frame_new();
// call case 3: self.outer request
  Object call8822 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8821);
// compiled call node returning call8822 (depth = 7)
// compiled member node returning call8822 (depth = 6)
  partcv[0] = 0;
  Object call8823 = callmethodflags(call8822, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8820);
// compiled call node returning call8823 (depth = 5)
// compiled member node returning call8823 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8824 = callmethodflags(call8823, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8819);
// compiled call node returning call8824 (depth = 3)
  struct UserObject *obj8552_uo = (struct UserObject *)obj8552;
  obj8552_uo->super = call8824;
  sourceObject = obj8552;
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8825 == NULL) {
    strlit8825 = alloc_String("import");
    gc_root(strlit8825);
  }
// compiled string node returning strlit8825 (depth = 3)
  adddatum2(obj8552, strlit8825, 1);
  sourceObject = obj8552;
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8552, *var_name_39_, 2);
  sourceObject = obj8552;
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8552, *var_path_39_, 3);
  sourceObject = obj8552;
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8826 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8826 (depth = 3)
  adddatum2(obj8552, array8826, 4);
  sourceObject = obj8552;
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8552, *var_dtype_39_, 5);
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  objclass8552 = obj8552->class;
  objclass8552->definitionModule = modulename;
  objclass8552->definitionLine = 2132;
  (*(struct UserObject *)self).data[0] = lowerouter8552;
  self = oldself8552;
  selfslot = oldselfslot8552;
  stackframe = oldstackframe8552;
  gc_frame_end(frame);
  return obj8552;
}
Object meth_ast_new8551_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_importNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8552 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8552 = alloc_userobj2(25,22, objclass8552);
  gc_frame_newslot(obj8552);
if (objclass8552 == NULL) {
  glfree(obj8552->class->name);
  obj8552->class->name = "importNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8552, self, 0);
  addmethodreal(obj8552,"outer", &reader_ast_outer_8553);
  Object oldself8552 = self;
  struct StackFrameObject *oldstackframe8552 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8552);
  gc_frame_newslot((Object)stackframe);
  self = obj8552;
  Object *oldselfslot8552 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8552 = (*(struct UserObject *)self).data[0], lowerouter8552 = thisouter8552;
  if (inheritingObject8552) {
    struct UserObject *inho8552 = (struct UserObject *)inheritingObject8552;
    while (inho8552->super != GraceDefaultObject) inho8552 = (struct UserObject *)inho8552->super;
    inho8552->super = obj8552;
    self = inheritingObject8552;
    *selfslot = self;
    lowerouter8552 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8552;
  }
if (objclass8552 == NULL) {
  Method *reader8554 = addmethodrealflags(obj8552, "kind",&reader_ast_kind_8554, MFLAG_DEF);
  reader8554->definitionModule = modulename;
  reader8554->definitionLine = 2134;
}
adddatum2(obj8552, alloc_Undefined(), 1);
if (objclass8552 == NULL) {
  Method *reader8555 = addmethodrealflags(obj8552, "value",&reader_ast_value_8555, 0);
  Method *writer8555 = addmethodrealflags(obj8552, "value:=",&writer_ast_value_8555, 0);
  reader8555->definitionModule = modulename;
  writer8555->definitionModule = modulename;
  reader8555->definitionLine = 2135;
  writer8555->definitionLine = 2135;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 2);
if (objclass8552 == NULL) {
  Method *reader8556 = addmethodrealflags(obj8552, "path",&reader_ast_path_8556, 0);
  Method *writer8556 = addmethodrealflags(obj8552, "path:=",&writer_ast_path_8556, 0);
  reader8556->definitionModule = modulename;
  writer8556->definitionModule = modulename;
  reader8556->definitionLine = 2136;
  writer8556->definitionLine = 2136;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 3);
if (objclass8552 == NULL) {
  Method *reader8557 = addmethodrealflags(obj8552, "annotations",&reader_ast_annotations_8557, 0);
  Method *writer8557 = addmethodrealflags(obj8552, "annotations:=",&writer_ast_annotations_8557, 0);
  reader8557->definitionModule = modulename;
  writer8557->definitionModule = modulename;
  reader8557->definitionLine = 2137;
  writer8557->definitionLine = 2137;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 4);
if (objclass8552 == NULL) {
  Method *reader8558 = addmethodrealflags(obj8552, "dtype",&reader_ast_dtype_8558, 0);
  Method *writer8558 = addmethodrealflags(obj8552, "dtype:=",&writer_ast_dtype_8558, 0);
  reader8558->definitionModule = modulename;
  writer8558->definitionModule = modulename;
  reader8558->definitionLine = 2138;
  writer8558->definitionLine = 2138;
}
obj8552->flags |= OFLAG_MUTABLE;
adddatum2(obj8552, alloc_Undefined(), 5);
// method "isImport"
  struct UserObject *uo8559 = (struct UserObject*)obj8552;
  uo8559->data[6] = emptyclosure;
  Method *meth_meth_ast_isImport8559 = addmethod2pos(obj8552, "isImport", &meth_ast_isImport8559, 6);
  int argcv_meth_ast_isImport8559[] = {0};
  meth_meth_ast_isImport8559->type = alloc_MethodType(1, argcv_meth_ast_isImport8559);
  meth_meth_ast_isImport8559->definitionModule = modulename;
  meth_meth_ast_isImport8559->definitionLine = 2139;
// method "isExternal"
  struct UserObject *uo8561 = (struct UserObject*)obj8552;
  uo8561->data[7] = emptyclosure;
  Method *meth_meth_ast_isExternal8561 = addmethod2pos(obj8552, "isExternal", &meth_ast_isExternal8561, 7);
  int argcv_meth_ast_isExternal8561[] = {0};
  meth_meth_ast_isExternal8561->type = alloc_MethodType(1, argcv_meth_ast_isExternal8561);
  meth_meth_ast_isExternal8561->definitionModule = modulename;
  meth_meth_ast_isExternal8561->definitionLine = 2140;
// method "isExecutable"
  struct UserObject *uo8563 = (struct UserObject*)obj8552;
  uo8563->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable8563 = addmethod2pos(obj8552, "isExecutable", &meth_ast_isExecutable8563, 8);
  int argcv_meth_ast_isExecutable8563[] = {0};
  meth_meth_ast_isExecutable8563->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8563);
  meth_meth_ast_isExecutable8563->definitionModule = modulename;
  meth_meth_ast_isExecutable8563->definitionLine = 2141;
// method "name"
  struct UserObject *uo8565 = (struct UserObject*)obj8552;
  uo8565->data[9] = emptyclosure;
  Method *meth_meth_ast_name8565 = addmethod2pos(obj8552, "name", &meth_ast_name8565, 9);
  int argcv_meth_ast_name8565[] = {0};
  meth_meth_ast_name8565->type = alloc_MethodType(1, argcv_meth_ast_name8565);
  meth_meth_ast_name8565->definitionModule = modulename;
  meth_meth_ast_name8565->definitionLine = 2142;
// method "nameString"
  struct UserObject *uo8568 = (struct UserObject*)obj8552;
  uo8568->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString8568 = addmethod2pos(obj8552, "nameString", &meth_ast_nameString8568, 10);
  int argcv_meth_ast_nameString8568[] = {0};
  meth_meth_ast_nameString8568->type = alloc_MethodType(1, argcv_meth_ast_nameString8568);
  meth_meth_ast_nameString8568->definitionModule = modulename;
  meth_meth_ast_nameString8568->definitionLine = 2143;
// method "isPublic"
  struct UserObject *uo8573 = (struct UserObject*)obj8552;
  uo8573->data[11] = emptyclosure;
  Method *meth_meth_ast_isPublic8573 = addmethod2pos(obj8552, "isPublic", &meth_ast_isPublic8573, 11);
  int argcv_meth_ast_isPublic8573[] = {0};
  meth_meth_ast_isPublic8573->type = alloc_MethodType(1, argcv_meth_ast_isPublic8573);
  meth_meth_ast_isPublic8573->definitionModule = modulename;
  meth_meth_ast_isPublic8573->definitionLine = 2144;
// method "moduleName"
  struct UserObject *uo8600 = (struct UserObject*)obj8552;
  uo8600->data[12] = emptyclosure;
  Method *meth_meth_ast_moduleName8600 = addmethod2pos(obj8552, "moduleName", &meth_ast_moduleName8600, 12);
  int argcv_meth_ast_moduleName8600[] = {0};
  meth_meth_ast_moduleName8600->type = alloc_MethodType(1, argcv_meth_ast_moduleName8600);
  meth_meth_ast_moduleName8600->definitionModule = modulename;
  meth_meth_ast_moduleName8600->definitionLine = 2150;
// method "isWritable"
  struct UserObject *uo8620 = (struct UserObject*)obj8552;
  uo8620->data[13] = emptyclosure;
  Method *meth_meth_ast_isWritable8620 = addmethod2pos(obj8552, "isWritable", &meth_ast_isWritable8620, 13);
  int argcv_meth_ast_isWritable8620[] = {0};
  meth_meth_ast_isWritable8620->type = alloc_MethodType(1, argcv_meth_ast_isWritable8620);
  meth_meth_ast_isWritable8620->definitionModule = modulename;
  meth_meth_ast_isWritable8620->definitionLine = 2161;
// method "isReadable"
  struct UserObject *uo8622 = (struct UserObject*)obj8552;
  uo8622->data[14] = emptyclosure;
  Method *meth_meth_ast_isReadable8622 = addmethod2pos(obj8552, "isReadable", &meth_ast_isReadable8622, 14);
  int argcv_meth_ast_isReadable8622[] = {0};
  meth_meth_ast_isReadable8622->type = alloc_MethodType(1, argcv_meth_ast_isReadable8622);
  meth_meth_ast_isReadable8622->definitionModule = modulename;
  meth_meth_ast_isReadable8622->definitionLine = 2162;
// method "declarationKindWithAncestors"
  block_savedest(obj8552);
  Object closure8625 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure8625, stackframe);
  addtoclosure(closure8625, var_k);
  struct UserObject *uo8625 = (struct UserObject*)obj8552;
  uo8625->data[15] = (Object)closure8625;
  Method *meth_meth_ast_declarationKindWithAncestors8625 = addmethod2pos(obj8552, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors8625, 15);
  int argcv_meth_ast_declarationKindWithAncestors8625[] = {1};
  meth_meth_ast_declarationKindWithAncestors8625->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors8625);
  meth_meth_ast_declarationKindWithAncestors8625->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors8625->definitionLine = 2163;
// method "usesAsType"
  struct UserObject *uo8628 = (struct UserObject*)obj8552;
  uo8628->data[16] = emptyclosure;
  Method *meth_meth_ast_usesAsType8628 = addmethod2pos(obj8552, "usesAsType", &meth_ast_usesAsType8628, 16);
  int argcv_meth_ast_usesAsType8628[] = {1};
  meth_meth_ast_usesAsType8628->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8628);
  meth_meth_ast_usesAsType8628->definitionModule = modulename;
  meth_meth_ast_usesAsType8628->definitionLine = 2164;
// method "accept()from"
  struct UserObject *uo8634 = (struct UserObject*)obj8552;
  uo8634->data[17] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8634 = addmethod2pos(obj8552, "accept()from", &meth_ast_accept_40__41_from8634, 17);
  int argcv_meth_ast_accept_40__41_from8634[] = {1, 1};
  meth_meth_ast_accept_40__41_from8634->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8634);
  meth_meth_ast_accept_40__41_from8634->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8634->definitionLine = 2167;
// method "map()ancestors"
  struct UserObject *uo8664 = (struct UserObject*)obj8552;
  uo8664->data[18] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8664 = addmethod2pos(obj8552, "map()ancestors", &meth_ast_map_40__41_ancestors8664, 18);
  int argcv_meth_ast_map_40__41_ancestors8664[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8664->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8664);
  meth_meth_ast_map_40__41_ancestors8664->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8664->definitionLine = 2179;
// method "pretty"
  struct UserObject *uo8697 = (struct UserObject*)obj8552;
  uo8697->data[19] = emptyclosure;
  Method *meth_meth_ast_pretty8697 = addmethod2pos(obj8552, "pretty", &meth_ast_pretty8697, 19);
  int argcv_meth_ast_pretty8697[] = {1};
  meth_meth_ast_pretty8697->type = alloc_MethodType(1, argcv_meth_ast_pretty8697);
  meth_meth_ast_pretty8697->definitionModule = modulename;
  meth_meth_ast_pretty8697->definitionLine = 2187;
// method "toGrace"
  struct UserObject *uo8791 = (struct UserObject*)obj8552;
  uo8791->data[20] = emptyclosure;
  Method *meth_meth_ast_toGrace8791 = addmethod2pos(obj8552, "toGrace", &meth_ast_toGrace8791, 20);
  int argcv_meth_ast_toGrace8791[] = {1};
  meth_meth_ast_toGrace8791->type = alloc_MethodType(1, argcv_meth_ast_toGrace8791);
meth_meth_ast_toGrace8791->type->types[0] = type_Number;
meth_meth_ast_toGrace8791->type->names[0] = "depth";
  meth_meth_ast_toGrace8791->definitionModule = modulename;
  meth_meth_ast_toGrace8791->definitionLine = 2200;
// method "shallowCopy"
  block_savedest(obj8552);
  Object closure8811 = createclosure(2, "shallowCopy");
  setclosureframe(closure8811, stackframe);
  addtoclosure(closure8811, var_nullNode);
  addtoclosure(closure8811, var_importNode);
  struct UserObject *uo8811 = (struct UserObject*)obj8552;
  uo8811->data[21] = (Object)closure8811;
  Method *meth_meth_ast_shallowCopy8811 = addmethod2pos(obj8552, "shallowCopy", &meth_ast_shallowCopy8811, 21);
  int argcv_meth_ast_shallowCopy8811[] = {0};
  meth_meth_ast_shallowCopy8811->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8811);
  meth_meth_ast_shallowCopy8811->definitionModule = modulename;
  meth_meth_ast_shallowCopy8811->definitionLine = 2203;
  sourceObject = obj8552;
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8819 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8820 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8821 = gc_frame_new();
// call case 3: self.outer request
  Object call8822 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8821);
// compiled call node returning call8822 (depth = 7)
// compiled member node returning call8822 (depth = 6)
  partcv[0] = 0;
  Object call8823 = callmethodflags(call8822, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8820);
// compiled call node returning call8823 (depth = 5)
// compiled member node returning call8823 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8824 = callmethodflags(call8823, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8819);
// compiled call node returning call8824 (depth = 3)
  struct UserObject *obj8552_uo = (struct UserObject *)obj8552;
  obj8552_uo->super = call8824;
  sourceObject = obj8552;
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8825 == NULL) {
    strlit8825 = alloc_String("import");
    gc_root(strlit8825);
  }
// compiled string node returning strlit8825 (depth = 3)
  adddatum2(obj8552, strlit8825, 1);
  sourceObject = obj8552;
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_name_39_ (depth = 3)
  adddatum2(obj8552, *var_name_39_, 2);
  sourceObject = obj8552;
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8552, *var_path_39_, 3);
  sourceObject = obj8552;
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array8826 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8826 (depth = 3)
  adddatum2(obj8552, array8826, 4);
  sourceObject = obj8552;
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dtype_39_ (depth = 3)
  adddatum2(obj8552, *var_dtype_39_, 5);
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  sourceObject = obj8552;
  objclass8552 = obj8552->class;
  objclass8552->definitionModule = modulename;
  objclass8552->definitionLine = 2132;
  (*(struct UserObject *)self).data[0] = lowerouter8552;
  self = oldself8552;
  selfslot = oldselfslot8552;
  stackframe = oldstackframe8552;
  gc_frame_end(frame);
  return obj8552;
}
Object meth_ast_importNode8828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_isDialect8836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isDialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isDialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8837 = alloc_Boolean(1);
// compiled identifier node returning bool8837 (depth = 3)
  gc_frame_end(frame);
  return bool8837;
}
Object meth_ast_isExternal8838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExternal");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExternal (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExternal");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8839 = alloc_Boolean(1);
// compiled identifier node returning bool8839 (depth = 3)
  gc_frame_end(frame);
  return bool8839;
}
Object meth_ast_isExecutable8840(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8841 = alloc_Boolean(0);
// compiled identifier node returning bool8841 (depth = 3)
  gc_frame_end(frame);
  return bool8841;
}
Object meth_ast__apply8848(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_bnm = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8851 == NULL) {
    strlit8851 = alloc_String("/");
    gc_root(strlit8851);
  }
// compiled string node returning strlit8851 (depth = 7)
  int op_slot_right_8850 = gc_frame_newslot(strlit8851);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_8850 = gc_frame_newslot(*var_c);
  params[0] = strlit8851;
  partcv[0] = 1;
  Object opresult8853 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult8853 (depth = 6)
  Object if8849 = done;
  if (istrue(opresult8853)) {
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8854 == NULL) {
    strlit8854 = alloc_String("");
    gc_root(strlit8854);
  }
// compiled string node returning strlit8854 (depth = 7)
  *var_bnm = strlit8854;
  if (strlit8854 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8849 = done;
  } else {
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_8856 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_bnm (depth = 8)
  int op_slot_left_8856 = gc_frame_newslot(*var_bnm);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult8858 = callmethod(*var_bnm, "++", 1, partcv, params);
// compiled op node returning opresult8858 (depth = 7)
  *var_bnm = opresult8858;
  if (opresult8858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if8849 = done;
  }
// compiled if node returning if8849 (depth = 5)
  gc_frame_end(frame);
  return if8849;
}
Object meth_ast_moduleName8842(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "moduleName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_bnm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "bnm");
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8843 == NULL) {
    strlit8843 = alloc_String("");
    gc_root(strlit8843);
  }
// compiled string node returning strlit8843 (depth = 4)
  *var_bnm = strlit8843;
  if (strlit8843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8844 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8846 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8845);
// compiled call node returning call8846 (depth = 5)
// compiled member node returning call8846 (depth = 4)
  gc_frame_newslot(call8846);
// starting to compile block node (depth = 4)
  Object block8847 = alloc_Block(NULL, NULL, "ast", 2219);
  gc_frame_newslot(block8847);
// method "_apply"
  block_savedest(block8847);
  Object closure8848 = createclosure(2, "_apply");
  setclosureframe(closure8848, stackframe);
  addtoclosure(closure8848, var_bnm);
  addtoclosure(closure8848, selfslot);
  struct UserObject *uo8848 = (struct UserObject*)block8847;
  uo8848->data[0] = (Object)closure8848;
  Method *meth_meth_ast__apply8848 = addmethod2pos(block8847, "_apply", &meth_ast__apply8848, 0);
  int argcv_meth_ast__apply8848[] = {1};
  meth_meth_ast__apply8848->type = alloc_MethodType(1, argcv_meth_ast__apply8848);
  meth_meth_ast__apply8848->definitionModule = modulename;
  meth_meth_ast__apply8848->definitionLine = 2219;
// compiled block node returning block8847 (depth = 4)
  gc_frame_newslot(block8847);
// call case 5: prelude request
  params[0] = call8846;
  params[1] = block8847;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8861 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8844);
// compiled call node returning call8861 (depth = 3)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bnm (depth = 3)
  gc_frame_end(frame);
  return *var_bnm;
}
Object meth_ast_path8862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "path");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for path (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for path");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8864 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8863);
// compiled call node returning call8864 (depth = 4)
// compiled member node returning call8864 (depth = 3)
  gc_frame_end(frame);
  return call8864;
}
Object meth_ast_accept_40__41_from8865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8866 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8867 = callmethod(*var_visitor, "visitDialect()up",
    2, partcv, params);
  gc_frame_end(callframe8866);
// compiled call node returning call8867 (depth = 3)
  gc_frame_end(frame);
  return call8867;
}
Object meth_ast_map_40__41_ancestors8868(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8869 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8870 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8869);
// compiled call node returning call8870 (depth = 5)
// compiled member node returning call8870 (depth = 4)
  *var_n = call8870;
  if (call8870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8871 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8872 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8871);
// compiled call node returning call8872 (depth = 4)
  *var_newChain = call8872;
  if (call8872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8873 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8874 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8873);
// compiled call node returning call8874 (depth = 3)
  gc_frame_end(frame);
  return call8874;
}
Object meth_ast__apply8883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8885 == NULL) {
    strlit8885 = alloc_String("  ");
    gc_root(strlit8885);
  }
// compiled string node returning strlit8885 (depth = 7)
  int op_slot_right_8884 = gc_frame_newslot(strlit8885);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8884 = gc_frame_newslot(*var_spc);
  params[0] = strlit8885;
  partcv[0] = 1;
  Object opresult8887 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8887 (depth = 6)
  *var_spc = opresult8887;
  if (opresult8887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8875(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8876 == NULL) {
    strlit8876 = alloc_String("");
    gc_root(strlit8876);
  }
// compiled string node returning strlit8876 (depth = 4)
  *var_spc = strlit8876;
  if (strlit8876 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8877 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8878 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8880 = alloc_Float64(0);
// compiled num node returning num8880 (depth = 5)
  int op_slot_left_8878 = gc_frame_newslot(num8880);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8881 = callmethod(num8880, "..", 1, partcv, params);
// compiled op node returning opresult8881 (depth = 4)
  gc_frame_newslot(opresult8881);
// starting to compile block node (depth = 4)
  Object block8882 = alloc_Block(NULL, NULL, "ast", 2241);
  gc_frame_newslot(block8882);
// method "_apply"
  block_savedest(block8882);
  Object closure8883 = createclosure(2, "_apply");
  setclosureframe(closure8883, stackframe);
  addtoclosure(closure8883, var_spc);
  addtoclosure(closure8883, selfslot);
  struct UserObject *uo8883 = (struct UserObject*)block8882;
  uo8883->data[0] = (Object)closure8883;
  Method *meth_meth_ast__apply8883 = addmethod2pos(block8882, "_apply", &meth_ast__apply8883, 0);
  int argcv_meth_ast__apply8883[] = {1};
  meth_meth_ast__apply8883->type = alloc_MethodType(1, argcv_meth_ast__apply8883);
  meth_meth_ast__apply8883->definitionModule = modulename;
  meth_meth_ast__apply8883->definitionLine = 2235;
// compiled block node returning block8882 (depth = 4)
  gc_frame_newslot(block8882);
// call case 5: prelude request
  params[0] = opresult8881;
  params[1] = block8882;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8890 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8877);
// compiled call node returning call8890 (depth = 3)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8892 == NULL) {
    strlit8892 = alloc_String("""\x0a""");
    gc_root(strlit8892);
  }
// compiled string node returning strlit8892 (depth = 5)
  int op_slot_right_8891 = gc_frame_newslot(strlit8892);
// starting to compile call node (depth = 5)
  int callframe8894 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8895 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8894);
// compiled call node returning call8895 (depth = 5)
  int op_slot_left_8891 = gc_frame_newslot(call8895);
  params[0] = strlit8892;
  partcv[0] = 1;
  Object opresult8896 = callmethod(call8895, "++", 1, partcv, params);
// compiled op node returning opresult8896 (depth = 4)
  *var_s = opresult8896;
  if (opresult8896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8899 == NULL) {
    strlit8899 = alloc_String("""\x0a""");
    gc_root(strlit8899);
  }
// compiled string node returning strlit8899 (depth = 6)
  int op_slot_right_8898 = gc_frame_newslot(strlit8899);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8902 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8903 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 8)
// compiled member node returning call8903 (depth = 7)
  int op_slot_right_8901 = gc_frame_newslot(call8903);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8906 == NULL) {
    strlit8906 = alloc_String("Path: ");
    gc_root(strlit8906);
  }
// compiled string node returning strlit8906 (depth = 8)
  int op_slot_right_8905 = gc_frame_newslot(strlit8906);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_8908 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 9)
  if (strlit8910 == NULL) {
    strlit8910 = alloc_String("");
    gc_root(strlit8910);
  }
// compiled string node returning strlit8910 (depth = 9)
  int op_slot_left_8908 = gc_frame_newslot(strlit8910);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8911 = callmethod(strlit8910, "++", 1, partcv, params);
// compiled op node returning opresult8911 (depth = 8)
  int op_slot_left_8905 = gc_frame_newslot(opresult8911);
  params[0] = strlit8906;
  partcv[0] = 1;
  Object opresult8912 = callmethod(opresult8911, "++", 1, partcv, params);
// compiled op node returning opresult8912 (depth = 7)
  int op_slot_left_8901 = gc_frame_newslot(opresult8912);
  params[0] = call8903;
  partcv[0] = 1;
  Object opresult8913 = callmethod(opresult8912, "++", 1, partcv, params);
// compiled op node returning opresult8913 (depth = 6)
  int op_slot_left_8898 = gc_frame_newslot(opresult8913);
  params[0] = strlit8899;
  partcv[0] = 1;
  Object opresult8914 = callmethod(opresult8913, "++", 1, partcv, params);
// compiled op node returning opresult8914 (depth = 5)
  int op_slot_right_8897 = gc_frame_newslot(opresult8914);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_8897 = gc_frame_newslot(*var_s);
  params[0] = opresult8914;
  partcv[0] = 1;
  Object opresult8916 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8916 (depth = 4)
  *var_s = opresult8916;
  if (opresult8916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace8918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8920 == NULL) {
    strlit8920 = alloc_String("""\x22""");
    gc_root(strlit8920);
  }
// compiled string node returning strlit8920 (depth = 4)
  int op_slot_right_8919 = gc_frame_newslot(strlit8920);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8924 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8923);
// compiled call node returning call8924 (depth = 6)
// compiled member node returning call8924 (depth = 5)
  int op_slot_right_8922 = gc_frame_newslot(call8924);
// starting to compile string node (depth = 5)
  if (strlit8926 == NULL) {
    strlit8926 = alloc_String("dialect ""\x22""");
    gc_root(strlit8926);
  }
// compiled string node returning strlit8926 (depth = 5)
  int op_slot_left_8922 = gc_frame_newslot(strlit8926);
  params[0] = call8924;
  partcv[0] = 1;
  Object opresult8927 = callmethod(strlit8926, "++", 1, partcv, params);
// compiled op node returning opresult8927 (depth = 4)
  int op_slot_left_8919 = gc_frame_newslot(opresult8927);
  params[0] = strlit8920;
  partcv[0] = 1;
  Object opresult8928 = callmethod(opresult8927, "++", 1, partcv, params);
// compiled op node returning opresult8928 (depth = 3)
  gc_frame_end(frame);
  return opresult8928;
}
Object meth_ast_shallowCopy8929(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8930 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe8931 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8932 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8933 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8932);
// compiled call node returning call8933 (depth = 6)
// compiled member node returning call8933 (depth = 5)
  gc_frame_newslot(call8933);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dialectNode (depth = 5)
  params[0] = call8933;
  partcv[0] = 1;
  Object call8934 = callmethod(*var_dialectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8931);
// compiled call node returning call8934 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call8935 = callmethod(call8934, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe8930);
// compiled call node returning call8935 (depth = 3)
  gc_frame_end(frame);
  return call8935;
}
Object meth_ast_new8831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8832 = alloc_userobj2(13,13, objclass8832);
  gc_frame_newslot(obj8832);
if (objclass8832 == NULL) {
  glfree(obj8832->class->name);
  obj8832->class->name = "dialectNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8832, self, 0);
  addmethodreal(obj8832,"outer", &reader_ast_outer_8833);
  Object oldself8832 = self;
  struct StackFrameObject *oldstackframe8832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8832);
  gc_frame_newslot((Object)stackframe);
  self = obj8832;
  Object *oldselfslot8832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8832 = (*(struct UserObject *)self).data[0], lowerouter8832 = thisouter8832;
  if (inheritingObject8832) {
    struct UserObject *inho8832 = (struct UserObject *)inheritingObject8832;
    while (inho8832->super != GraceDefaultObject) inho8832 = (struct UserObject *)inho8832->super;
    inho8832->super = obj8832;
    self = inheritingObject8832;
    *selfslot = self;
    lowerouter8832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8832;
  }
if (objclass8832 == NULL) {
  Method *reader8834 = addmethodrealflags(obj8832, "kind",&reader_ast_kind_8834, MFLAG_DEF);
  reader8834->definitionModule = modulename;
  reader8834->definitionLine = 2211;
}
adddatum2(obj8832, alloc_Undefined(), 1);
if (objclass8832 == NULL) {
  Method *reader8835 = addmethodrealflags(obj8832, "value",&reader_ast_value_8835, 0);
  Method *writer8835 = addmethodrealflags(obj8832, "value:=",&writer_ast_value_8835, 0);
  reader8835->definitionModule = modulename;
  writer8835->definitionModule = modulename;
  reader8835->definitionLine = 2212;
  writer8835->definitionLine = 2212;
}
obj8832->flags |= OFLAG_MUTABLE;
adddatum2(obj8832, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo8836 = (struct UserObject*)obj8832;
  uo8836->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect8836 = addmethod2pos(obj8832, "isDialect", &meth_ast_isDialect8836, 3);
  int argcv_meth_ast_isDialect8836[] = {0};
  meth_meth_ast_isDialect8836->type = alloc_MethodType(1, argcv_meth_ast_isDialect8836);
  meth_meth_ast_isDialect8836->definitionModule = modulename;
  meth_meth_ast_isDialect8836->definitionLine = 2214;
// method "isExternal"
  struct UserObject *uo8838 = (struct UserObject*)obj8832;
  uo8838->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal8838 = addmethod2pos(obj8832, "isExternal", &meth_ast_isExternal8838, 4);
  int argcv_meth_ast_isExternal8838[] = {0};
  meth_meth_ast_isExternal8838->type = alloc_MethodType(1, argcv_meth_ast_isExternal8838);
  meth_meth_ast_isExternal8838->definitionModule = modulename;
  meth_meth_ast_isExternal8838->definitionLine = 2215;
// method "isExecutable"
  struct UserObject *uo8840 = (struct UserObject*)obj8832;
  uo8840->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable8840 = addmethod2pos(obj8832, "isExecutable", &meth_ast_isExecutable8840, 5);
  int argcv_meth_ast_isExecutable8840[] = {0};
  meth_meth_ast_isExecutable8840->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8840);
  meth_meth_ast_isExecutable8840->definitionModule = modulename;
  meth_meth_ast_isExecutable8840->definitionLine = 2216;
// method "moduleName"
  struct UserObject *uo8842 = (struct UserObject*)obj8832;
  uo8842->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName8842 = addmethod2pos(obj8832, "moduleName", &meth_ast_moduleName8842, 6);
  int argcv_meth_ast_moduleName8842[] = {0};
  meth_meth_ast_moduleName8842->type = alloc_MethodType(1, argcv_meth_ast_moduleName8842);
  meth_meth_ast_moduleName8842->definitionModule = modulename;
  meth_meth_ast_moduleName8842->definitionLine = 2217;
// method "path"
  struct UserObject *uo8862 = (struct UserObject*)obj8832;
  uo8862->data[7] = emptyclosure;
  Method *meth_meth_ast_path8862 = addmethod2pos(obj8832, "path", &meth_ast_path8862, 7);
  int argcv_meth_ast_path8862[] = {0};
  meth_meth_ast_path8862->type = alloc_MethodType(1, argcv_meth_ast_path8862);
  meth_meth_ast_path8862->definitionModule = modulename;
  meth_meth_ast_path8862->definitionLine = 2228;
// method "accept()from"
  struct UserObject *uo8865 = (struct UserObject*)obj8832;
  uo8865->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8865 = addmethod2pos(obj8832, "accept()from", &meth_ast_accept_40__41_from8865, 8);
  int argcv_meth_ast_accept_40__41_from8865[] = {1, 1};
  meth_meth_ast_accept_40__41_from8865->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8865);
  meth_meth_ast_accept_40__41_from8865->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8865->definitionLine = 2231;
// method "map()ancestors"
  struct UserObject *uo8868 = (struct UserObject*)obj8832;
  uo8868->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8868 = addmethod2pos(obj8832, "map()ancestors", &meth_ast_map_40__41_ancestors8868, 9);
  int argcv_meth_ast_map_40__41_ancestors8868[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8868->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8868);
  meth_meth_ast_map_40__41_ancestors8868->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8868->definitionLine = 2234;
// method "pretty"
  struct UserObject *uo8875 = (struct UserObject*)obj8832;
  uo8875->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty8875 = addmethod2pos(obj8832, "pretty", &meth_ast_pretty8875, 10);
  int argcv_meth_ast_pretty8875[] = {1};
  meth_meth_ast_pretty8875->type = alloc_MethodType(1, argcv_meth_ast_pretty8875);
  meth_meth_ast_pretty8875->definitionModule = modulename;
  meth_meth_ast_pretty8875->definitionLine = 2239;
// method "toGrace"
  struct UserObject *uo8918 = (struct UserObject*)obj8832;
  uo8918->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace8918 = addmethod2pos(obj8832, "toGrace", &meth_ast_toGrace8918, 11);
  int argcv_meth_ast_toGrace8918[] = {1};
  meth_meth_ast_toGrace8918->type = alloc_MethodType(1, argcv_meth_ast_toGrace8918);
meth_meth_ast_toGrace8918->type->types[0] = type_Number;
meth_meth_ast_toGrace8918->type->names[0] = "depth";
  meth_meth_ast_toGrace8918->definitionModule = modulename;
  meth_meth_ast_toGrace8918->definitionLine = 2248;
// method "shallowCopy"
  block_savedest(obj8832);
  Object closure8929 = createclosure(1, "shallowCopy");
  setclosureframe(closure8929, stackframe);
  addtoclosure(closure8929, var_dialectNode);
  struct UserObject *uo8929 = (struct UserObject*)obj8832;
  uo8929->data[12] = (Object)closure8929;
  Method *meth_meth_ast_shallowCopy8929 = addmethod2pos(obj8832, "shallowCopy", &meth_ast_shallowCopy8929, 12);
  int argcv_meth_ast_shallowCopy8929[] = {0};
  meth_meth_ast_shallowCopy8929->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8929);
  meth_meth_ast_shallowCopy8929->definitionModule = modulename;
  meth_meth_ast_shallowCopy8929->definitionLine = 2251;
  sourceObject = obj8832;
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8936 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8937 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8938 = gc_frame_new();
// call case 3: self.outer request
  Object call8939 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8938);
// compiled call node returning call8939 (depth = 7)
// compiled member node returning call8939 (depth = 6)
  partcv[0] = 0;
  Object call8940 = callmethodflags(call8939, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8937);
// compiled call node returning call8940 (depth = 5)
// compiled member node returning call8940 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8941 = callmethodflags(call8940, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8936);
// compiled call node returning call8941 (depth = 3)
  struct UserObject *obj8832_uo = (struct UserObject *)obj8832;
  obj8832_uo->super = call8941;
  sourceObject = obj8832;
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8942 == NULL) {
    strlit8942 = alloc_String("dialect");
    gc_root(strlit8942);
  }
// compiled string node returning strlit8942 (depth = 3)
  adddatum2(obj8832, strlit8942, 1);
  sourceObject = obj8832;
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8832, *var_path_39_, 2);
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  objclass8832 = obj8832->class;
  objclass8832->definitionModule = modulename;
  objclass8832->definitionLine = 2209;
  (*(struct UserObject *)self).data[0] = lowerouter8832;
  self = oldself8832;
  selfslot = oldselfslot8832;
  stackframe = oldstackframe8832;
  gc_frame_end(frame);
  return obj8832;
}
Object meth_ast_new8831_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8832 = alloc_userobj2(13,13, objclass8832);
  gc_frame_newslot(obj8832);
if (objclass8832 == NULL) {
  glfree(obj8832->class->name);
  obj8832->class->name = "dialectNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8832, self, 0);
  addmethodreal(obj8832,"outer", &reader_ast_outer_8833);
  Object oldself8832 = self;
  struct StackFrameObject *oldstackframe8832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8832);
  gc_frame_newslot((Object)stackframe);
  self = obj8832;
  Object *oldselfslot8832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8832 = (*(struct UserObject *)self).data[0], lowerouter8832 = thisouter8832;
  if (inheritingObject8832) {
    struct UserObject *inho8832 = (struct UserObject *)inheritingObject8832;
    while (inho8832->super != GraceDefaultObject) inho8832 = (struct UserObject *)inho8832->super;
    inho8832->super = obj8832;
    self = inheritingObject8832;
    *selfslot = self;
    lowerouter8832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8832;
  }
if (objclass8832 == NULL) {
  Method *reader8834 = addmethodrealflags(obj8832, "kind",&reader_ast_kind_8834, MFLAG_DEF);
  reader8834->definitionModule = modulename;
  reader8834->definitionLine = 2211;
}
adddatum2(obj8832, alloc_Undefined(), 1);
if (objclass8832 == NULL) {
  Method *reader8835 = addmethodrealflags(obj8832, "value",&reader_ast_value_8835, 0);
  Method *writer8835 = addmethodrealflags(obj8832, "value:=",&writer_ast_value_8835, 0);
  reader8835->definitionModule = modulename;
  writer8835->definitionModule = modulename;
  reader8835->definitionLine = 2212;
  writer8835->definitionLine = 2212;
}
obj8832->flags |= OFLAG_MUTABLE;
adddatum2(obj8832, alloc_Undefined(), 2);
// method "isDialect"
  struct UserObject *uo8836 = (struct UserObject*)obj8832;
  uo8836->data[3] = emptyclosure;
  Method *meth_meth_ast_isDialect8836 = addmethod2pos(obj8832, "isDialect", &meth_ast_isDialect8836, 3);
  int argcv_meth_ast_isDialect8836[] = {0};
  meth_meth_ast_isDialect8836->type = alloc_MethodType(1, argcv_meth_ast_isDialect8836);
  meth_meth_ast_isDialect8836->definitionModule = modulename;
  meth_meth_ast_isDialect8836->definitionLine = 2214;
// method "isExternal"
  struct UserObject *uo8838 = (struct UserObject*)obj8832;
  uo8838->data[4] = emptyclosure;
  Method *meth_meth_ast_isExternal8838 = addmethod2pos(obj8832, "isExternal", &meth_ast_isExternal8838, 4);
  int argcv_meth_ast_isExternal8838[] = {0};
  meth_meth_ast_isExternal8838->type = alloc_MethodType(1, argcv_meth_ast_isExternal8838);
  meth_meth_ast_isExternal8838->definitionModule = modulename;
  meth_meth_ast_isExternal8838->definitionLine = 2215;
// method "isExecutable"
  struct UserObject *uo8840 = (struct UserObject*)obj8832;
  uo8840->data[5] = emptyclosure;
  Method *meth_meth_ast_isExecutable8840 = addmethod2pos(obj8832, "isExecutable", &meth_ast_isExecutable8840, 5);
  int argcv_meth_ast_isExecutable8840[] = {0};
  meth_meth_ast_isExecutable8840->type = alloc_MethodType(1, argcv_meth_ast_isExecutable8840);
  meth_meth_ast_isExecutable8840->definitionModule = modulename;
  meth_meth_ast_isExecutable8840->definitionLine = 2216;
// method "moduleName"
  struct UserObject *uo8842 = (struct UserObject*)obj8832;
  uo8842->data[6] = emptyclosure;
  Method *meth_meth_ast_moduleName8842 = addmethod2pos(obj8832, "moduleName", &meth_ast_moduleName8842, 6);
  int argcv_meth_ast_moduleName8842[] = {0};
  meth_meth_ast_moduleName8842->type = alloc_MethodType(1, argcv_meth_ast_moduleName8842);
  meth_meth_ast_moduleName8842->definitionModule = modulename;
  meth_meth_ast_moduleName8842->definitionLine = 2217;
// method "path"
  struct UserObject *uo8862 = (struct UserObject*)obj8832;
  uo8862->data[7] = emptyclosure;
  Method *meth_meth_ast_path8862 = addmethod2pos(obj8832, "path", &meth_ast_path8862, 7);
  int argcv_meth_ast_path8862[] = {0};
  meth_meth_ast_path8862->type = alloc_MethodType(1, argcv_meth_ast_path8862);
  meth_meth_ast_path8862->definitionModule = modulename;
  meth_meth_ast_path8862->definitionLine = 2228;
// method "accept()from"
  struct UserObject *uo8865 = (struct UserObject*)obj8832;
  uo8865->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8865 = addmethod2pos(obj8832, "accept()from", &meth_ast_accept_40__41_from8865, 8);
  int argcv_meth_ast_accept_40__41_from8865[] = {1, 1};
  meth_meth_ast_accept_40__41_from8865->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8865);
  meth_meth_ast_accept_40__41_from8865->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8865->definitionLine = 2231;
// method "map()ancestors"
  struct UserObject *uo8868 = (struct UserObject*)obj8832;
  uo8868->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8868 = addmethod2pos(obj8832, "map()ancestors", &meth_ast_map_40__41_ancestors8868, 9);
  int argcv_meth_ast_map_40__41_ancestors8868[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8868->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8868);
  meth_meth_ast_map_40__41_ancestors8868->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8868->definitionLine = 2234;
// method "pretty"
  struct UserObject *uo8875 = (struct UserObject*)obj8832;
  uo8875->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty8875 = addmethod2pos(obj8832, "pretty", &meth_ast_pretty8875, 10);
  int argcv_meth_ast_pretty8875[] = {1};
  meth_meth_ast_pretty8875->type = alloc_MethodType(1, argcv_meth_ast_pretty8875);
  meth_meth_ast_pretty8875->definitionModule = modulename;
  meth_meth_ast_pretty8875->definitionLine = 2239;
// method "toGrace"
  struct UserObject *uo8918 = (struct UserObject*)obj8832;
  uo8918->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace8918 = addmethod2pos(obj8832, "toGrace", &meth_ast_toGrace8918, 11);
  int argcv_meth_ast_toGrace8918[] = {1};
  meth_meth_ast_toGrace8918->type = alloc_MethodType(1, argcv_meth_ast_toGrace8918);
meth_meth_ast_toGrace8918->type->types[0] = type_Number;
meth_meth_ast_toGrace8918->type->names[0] = "depth";
  meth_meth_ast_toGrace8918->definitionModule = modulename;
  meth_meth_ast_toGrace8918->definitionLine = 2248;
// method "shallowCopy"
  block_savedest(obj8832);
  Object closure8929 = createclosure(1, "shallowCopy");
  setclosureframe(closure8929, stackframe);
  addtoclosure(closure8929, var_dialectNode);
  struct UserObject *uo8929 = (struct UserObject*)obj8832;
  uo8929->data[12] = (Object)closure8929;
  Method *meth_meth_ast_shallowCopy8929 = addmethod2pos(obj8832, "shallowCopy", &meth_ast_shallowCopy8929, 12);
  int argcv_meth_ast_shallowCopy8929[] = {0};
  meth_meth_ast_shallowCopy8929->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy8929);
  meth_meth_ast_shallowCopy8929->definitionModule = modulename;
  meth_meth_ast_shallowCopy8929->definitionLine = 2251;
  sourceObject = obj8832;
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8936 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8937 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8938 = gc_frame_new();
// call case 3: self.outer request
  Object call8939 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8938);
// compiled call node returning call8939 (depth = 7)
// compiled member node returning call8939 (depth = 6)
  partcv[0] = 0;
  Object call8940 = callmethodflags(call8939, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8937);
// compiled call node returning call8940 (depth = 5)
// compiled member node returning call8940 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8941 = callmethodflags(call8940, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8936);
// compiled call node returning call8941 (depth = 3)
  struct UserObject *obj8832_uo = (struct UserObject *)obj8832;
  obj8832_uo->super = call8941;
  sourceObject = obj8832;
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit8942 == NULL) {
    strlit8942 = alloc_String("dialect");
    gc_root(strlit8942);
  }
// compiled string node returning strlit8942 (depth = 3)
  adddatum2(obj8832, strlit8942, 1);
  sourceObject = obj8832;
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_path_39_ (depth = 3)
  adddatum2(obj8832, *var_path_39_, 2);
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  sourceObject = obj8832;
  objclass8832 = obj8832->class;
  objclass8832->definitionModule = modulename;
  objclass8832->definitionLine = 2209;
  (*(struct UserObject *)self).data[0] = lowerouter8832;
  self = oldself8832;
  selfslot = oldselfslot8832;
  stackframe = oldstackframe8832;
  gc_frame_end(frame);
  return obj8832;
}
Object meth_ast_dialectNode8944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept_40__41_from8952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8954 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8955 = callmethod(*var_visitor, "visitReturn()up",
    2, partcv, params);
  gc_frame_end(callframe8954);
// compiled call node returning call8955 (depth = 4)
  Object if8953 = done;
  if (istrue(call8955)) {
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8956 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call8957 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8956);
// compiled call node returning call8957 (depth = 5)
  *var_newChain = call8957;
  if (call8957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8958 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8960 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8959);
// compiled call node returning call8960 (depth = 6)
// compiled member node returning call8960 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8961 = callmethod(call8960, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8958);
// compiled call node returning call8961 (depth = 4)
    gc_frame_newslot(call8961);
    if8953 = call8961;
  } else {
  }
// compiled if node returning if8953 (depth = 3)
  gc_frame_end(frame);
  return if8953;
}
Object meth_ast_map_40__41_ancestors8962(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8964 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8963);
// compiled call node returning call8964 (depth = 5)
// compiled member node returning call8964 (depth = 4)
  *var_n = call8964;
  if (call8964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8965 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8966 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe8965);
// compiled call node returning call8966 (depth = 4)
  *var_newChain = call8966;
  if (call8966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8967 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8968 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8969 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8970 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8969);
// compiled call node returning call8970 (depth = 6)
// compiled member node returning call8970 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8971 = callmethod(call8970, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe8968);
// compiled call node returning call8971 (depth = 4)
  gc_frame_newslot(call8971);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call8971;
  partcv[0] = 1;
  Object call8972 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8967);
// compiled call node returning call8972 (depth = 3)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8973 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call8974 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8973);
// compiled call node returning call8974 (depth = 3)
  gc_frame_end(frame);
  return call8974;
}
Object meth_ast__apply8983(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8985 == NULL) {
    strlit8985 = alloc_String("  ");
    gc_root(strlit8985);
  }
// compiled string node returning strlit8985 (depth = 7)
  int op_slot_right_8984 = gc_frame_newslot(strlit8985);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_8984 = gc_frame_newslot(*var_spc);
  params[0] = strlit8985;
  partcv[0] = 1;
  Object opresult8987 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8987 (depth = 6)
  *var_spc = opresult8987;
  if (opresult8987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8975(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit8976 == NULL) {
    strlit8976 = alloc_String("");
    gc_root(strlit8976);
  }
// compiled string node returning strlit8976 (depth = 4)
  *var_spc = strlit8976;
  if (strlit8976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8977 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_8978 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num8980 = alloc_Float64(0);
// compiled num node returning num8980 (depth = 5)
  int op_slot_left_8978 = gc_frame_newslot(num8980);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8981 = callmethod(num8980, "..", 1, partcv, params);
// compiled op node returning opresult8981 (depth = 4)
  gc_frame_newslot(opresult8981);
// starting to compile block node (depth = 4)
  Object block8982 = alloc_Block(NULL, NULL, "ast", 2276);
  gc_frame_newslot(block8982);
// method "_apply"
  block_savedest(block8982);
  Object closure8983 = createclosure(2, "_apply");
  setclosureframe(closure8983, stackframe);
  addtoclosure(closure8983, var_spc);
  addtoclosure(closure8983, selfslot);
  struct UserObject *uo8983 = (struct UserObject*)block8982;
  uo8983->data[0] = (Object)closure8983;
  Method *meth_meth_ast__apply8983 = addmethod2pos(block8982, "_apply", &meth_ast__apply8983, 0);
  int argcv_meth_ast__apply8983[] = {1};
  meth_meth_ast__apply8983->type = alloc_MethodType(1, argcv_meth_ast__apply8983);
  meth_meth_ast__apply8983->definitionModule = modulename;
  meth_meth_ast__apply8983->definitionLine = 2271;
// compiled block node returning block8982 (depth = 4)
  gc_frame_newslot(block8982);
// call case 5: prelude request
  params[0] = opresult8981;
  params[1] = block8982;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8990 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8977);
// compiled call node returning call8990 (depth = 3)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8992 == NULL) {
    strlit8992 = alloc_String("""\x0a""");
    gc_root(strlit8992);
  }
// compiled string node returning strlit8992 (depth = 5)
  int op_slot_right_8991 = gc_frame_newslot(strlit8992);
// starting to compile call node (depth = 5)
  int callframe8994 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8995 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8994);
// compiled call node returning call8995 (depth = 5)
  int op_slot_left_8991 = gc_frame_newslot(call8995);
  params[0] = strlit8992;
  partcv[0] = 1;
  Object opresult8996 = callmethod(call8995, "++", 1, partcv, params);
// compiled op node returning opresult8996 (depth = 4)
  *var_s = opresult8996;
  if (opresult8996 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8998 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9000 = alloc_Float64(1);
// compiled num node returning num9000 (depth = 7)
  int op_slot_right_8999 = gc_frame_newslot(num9000);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8999 = gc_frame_newslot(*var_depth);
  params[0] = num9000;
  partcv[0] = 1;
  Object sum9002 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9002 (depth = 6)
  gc_frame_newslot(sum9002);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9003 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9004 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9003);
// compiled call node returning call9004 (depth = 7)
// compiled member node returning call9004 (depth = 6)
  params[0] = sum9002;
  partcv[0] = 1;
  Object call9005 = callmethod(call9004, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8998);
// compiled call node returning call9005 (depth = 5)
  int op_slot_right_8997 = gc_frame_newslot(call9005);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9007 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9007 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9009 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9009 (depth = 5)
  int op_slot_left_8997 = gc_frame_newslot(opresult9009);
  params[0] = call9005;
  partcv[0] = 1;
  Object opresult9010 = callmethod(opresult9009, "++", 1, partcv, params);
// compiled op node returning opresult9010 (depth = 4)
  *var_s = opresult9010;
  if (opresult9010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9012(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9014 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9016 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9015);
// compiled call node returning call9016 (depth = 6)
// compiled member node returning call9016 (depth = 5)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9017 = callmethod(call9016, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9014);
// compiled call node returning call9017 (depth = 4)
  int op_slot_right_9013 = gc_frame_newslot(call9017);
// starting to compile string node (depth = 4)
  if (strlit9019 == NULL) {
    strlit9019 = alloc_String("return ");
    gc_root(strlit9019);
  }
// compiled string node returning strlit9019 (depth = 4)
  int op_slot_left_9013 = gc_frame_newslot(strlit9019);
  params[0] = call9017;
  partcv[0] = 1;
  Object opresult9020 = callmethod(strlit9019, "++", 1, partcv, params);
// compiled op node returning opresult9020 (depth = 3)
  gc_frame_end(frame);
  return opresult9020;
}
Object meth_ast_shallowCopy9021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9022 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9023 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_returnNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9024 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9023);
// compiled call node returning call9024 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9025 = callmethod(call9024, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9022);
// compiled call node returning call9025 (depth = 3)
  gc_frame_end(frame);
  return call9025;
}
Object meth_ast_new8947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8948 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8948 = alloc_userobj2(8,8, objclass8948);
  gc_frame_newslot(obj8948);
if (objclass8948 == NULL) {
  glfree(obj8948->class->name);
  obj8948->class->name = "returnNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8948, self, 0);
  addmethodreal(obj8948,"outer", &reader_ast_outer_8949);
  Object oldself8948 = self;
  struct StackFrameObject *oldstackframe8948 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8948);
  gc_frame_newslot((Object)stackframe);
  self = obj8948;
  Object *oldselfslot8948 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8948 = (*(struct UserObject *)self).data[0], lowerouter8948 = thisouter8948;
  if (inheritingObject8948) {
    struct UserObject *inho8948 = (struct UserObject *)inheritingObject8948;
    while (inho8948->super != GraceDefaultObject) inho8948 = (struct UserObject *)inho8948->super;
    inho8948->super = obj8948;
    self = inheritingObject8948;
    *selfslot = self;
    lowerouter8948 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8948;
  }
if (objclass8948 == NULL) {
  Method *reader8950 = addmethodrealflags(obj8948, "kind",&reader_ast_kind_8950, MFLAG_DEF);
  reader8950->definitionModule = modulename;
  reader8950->definitionLine = 2259;
}
adddatum2(obj8948, alloc_Undefined(), 1);
if (objclass8948 == NULL) {
  Method *reader8951 = addmethodrealflags(obj8948, "value",&reader_ast_value_8951, 0);
  Method *writer8951 = addmethodrealflags(obj8948, "value:=",&writer_ast_value_8951, 0);
  reader8951->definitionModule = modulename;
  writer8951->definitionModule = modulename;
  reader8951->definitionLine = 2260;
  writer8951->definitionLine = 2260;
}
obj8948->flags |= OFLAG_MUTABLE;
adddatum2(obj8948, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo8952 = (struct UserObject*)obj8948;
  uo8952->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8952 = addmethod2pos(obj8948, "accept()from", &meth_ast_accept_40__41_from8952, 3);
  int argcv_meth_ast_accept_40__41_from8952[] = {1, 1};
  meth_meth_ast_accept_40__41_from8952->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8952);
  meth_meth_ast_accept_40__41_from8952->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8952->definitionLine = 2262;
// method "map()ancestors"
  struct UserObject *uo8962 = (struct UserObject*)obj8948;
  uo8962->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8962 = addmethod2pos(obj8948, "map()ancestors", &meth_ast_map_40__41_ancestors8962, 4);
  int argcv_meth_ast_map_40__41_ancestors8962[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8962->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8962);
  meth_meth_ast_map_40__41_ancestors8962->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8962->definitionLine = 2268;
// method "pretty"
  struct UserObject *uo8975 = (struct UserObject*)obj8948;
  uo8975->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty8975 = addmethod2pos(obj8948, "pretty", &meth_ast_pretty8975, 5);
  int argcv_meth_ast_pretty8975[] = {1};
  meth_meth_ast_pretty8975->type = alloc_MethodType(1, argcv_meth_ast_pretty8975);
  meth_meth_ast_pretty8975->definitionModule = modulename;
  meth_meth_ast_pretty8975->definitionLine = 2274;
// method "toGrace"
  struct UserObject *uo9012 = (struct UserObject*)obj8948;
  uo9012->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9012 = addmethod2pos(obj8948, "toGrace", &meth_ast_toGrace9012, 6);
  int argcv_meth_ast_toGrace9012[] = {1};
  meth_meth_ast_toGrace9012->type = alloc_MethodType(1, argcv_meth_ast_toGrace9012);
meth_meth_ast_toGrace9012->type->types[0] = type_Number;
meth_meth_ast_toGrace9012->type->names[0] = "depth";
  meth_meth_ast_toGrace9012->definitionModule = modulename;
  meth_meth_ast_toGrace9012->definitionLine = 2283;
// method "shallowCopy"
  block_savedest(obj8948);
  Object closure9021 = createclosure(2, "shallowCopy");
  setclosureframe(closure9021, stackframe);
  addtoclosure(closure9021, var_nullNode);
  addtoclosure(closure9021, var_returnNode);
  struct UserObject *uo9021 = (struct UserObject*)obj8948;
  uo9021->data[7] = (Object)closure9021;
  Method *meth_meth_ast_shallowCopy9021 = addmethod2pos(obj8948, "shallowCopy", &meth_ast_shallowCopy9021, 7);
  int argcv_meth_ast_shallowCopy9021[] = {0};
  meth_meth_ast_shallowCopy9021->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9021);
  meth_meth_ast_shallowCopy9021->definitionModule = modulename;
  meth_meth_ast_shallowCopy9021->definitionLine = 2286;
  sourceObject = obj8948;
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9026 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9027 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9028 = gc_frame_new();
// call case 3: self.outer request
  Object call9029 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9028);
// compiled call node returning call9029 (depth = 7)
// compiled member node returning call9029 (depth = 6)
  partcv[0] = 0;
  Object call9030 = callmethodflags(call9029, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9027);
// compiled call node returning call9030 (depth = 5)
// compiled member node returning call9030 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9031 = callmethodflags(call9030, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9026);
// compiled call node returning call9031 (depth = 3)
  struct UserObject *obj8948_uo = (struct UserObject *)obj8948;
  obj8948_uo->super = call9031;
  sourceObject = obj8948;
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9032 == NULL) {
    strlit9032 = alloc_String("return");
    gc_root(strlit9032);
  }
// compiled string node returning strlit9032 (depth = 3)
  adddatum2(obj8948, strlit9032, 1);
  sourceObject = obj8948;
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj8948, *var_expr, 2);
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  objclass8948 = obj8948->class;
  objclass8948->definitionModule = modulename;
  objclass8948->definitionLine = 2257;
  (*(struct UserObject *)self).data[0] = lowerouter8948;
  self = oldself8948;
  selfslot = oldselfslot8948;
  stackframe = oldstackframe8948;
  gc_frame_end(frame);
  return obj8948;
}
Object meth_ast_new8947_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8948 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8948 = alloc_userobj2(8,8, objclass8948);
  gc_frame_newslot(obj8948);
if (objclass8948 == NULL) {
  glfree(obj8948->class->name);
  obj8948->class->name = "returnNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8948, self, 0);
  addmethodreal(obj8948,"outer", &reader_ast_outer_8949);
  Object oldself8948 = self;
  struct StackFrameObject *oldstackframe8948 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8948);
  gc_frame_newslot((Object)stackframe);
  self = obj8948;
  Object *oldselfslot8948 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8948 = (*(struct UserObject *)self).data[0], lowerouter8948 = thisouter8948;
  if (inheritingObject8948) {
    struct UserObject *inho8948 = (struct UserObject *)inheritingObject8948;
    while (inho8948->super != GraceDefaultObject) inho8948 = (struct UserObject *)inho8948->super;
    inho8948->super = obj8948;
    self = inheritingObject8948;
    *selfslot = self;
    lowerouter8948 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8948;
  }
if (objclass8948 == NULL) {
  Method *reader8950 = addmethodrealflags(obj8948, "kind",&reader_ast_kind_8950, MFLAG_DEF);
  reader8950->definitionModule = modulename;
  reader8950->definitionLine = 2259;
}
adddatum2(obj8948, alloc_Undefined(), 1);
if (objclass8948 == NULL) {
  Method *reader8951 = addmethodrealflags(obj8948, "value",&reader_ast_value_8951, 0);
  Method *writer8951 = addmethodrealflags(obj8948, "value:=",&writer_ast_value_8951, 0);
  reader8951->definitionModule = modulename;
  writer8951->definitionModule = modulename;
  reader8951->definitionLine = 2260;
  writer8951->definitionLine = 2260;
}
obj8948->flags |= OFLAG_MUTABLE;
adddatum2(obj8948, alloc_Undefined(), 2);
// method "accept()from"
  struct UserObject *uo8952 = (struct UserObject*)obj8948;
  uo8952->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8952 = addmethod2pos(obj8948, "accept()from", &meth_ast_accept_40__41_from8952, 3);
  int argcv_meth_ast_accept_40__41_from8952[] = {1, 1};
  meth_meth_ast_accept_40__41_from8952->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8952);
  meth_meth_ast_accept_40__41_from8952->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8952->definitionLine = 2262;
// method "map()ancestors"
  struct UserObject *uo8962 = (struct UserObject*)obj8948;
  uo8962->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors8962 = addmethod2pos(obj8948, "map()ancestors", &meth_ast_map_40__41_ancestors8962, 4);
  int argcv_meth_ast_map_40__41_ancestors8962[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors8962->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors8962);
  meth_meth_ast_map_40__41_ancestors8962->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors8962->definitionLine = 2268;
// method "pretty"
  struct UserObject *uo8975 = (struct UserObject*)obj8948;
  uo8975->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty8975 = addmethod2pos(obj8948, "pretty", &meth_ast_pretty8975, 5);
  int argcv_meth_ast_pretty8975[] = {1};
  meth_meth_ast_pretty8975->type = alloc_MethodType(1, argcv_meth_ast_pretty8975);
  meth_meth_ast_pretty8975->definitionModule = modulename;
  meth_meth_ast_pretty8975->definitionLine = 2274;
// method "toGrace"
  struct UserObject *uo9012 = (struct UserObject*)obj8948;
  uo9012->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9012 = addmethod2pos(obj8948, "toGrace", &meth_ast_toGrace9012, 6);
  int argcv_meth_ast_toGrace9012[] = {1};
  meth_meth_ast_toGrace9012->type = alloc_MethodType(1, argcv_meth_ast_toGrace9012);
meth_meth_ast_toGrace9012->type->types[0] = type_Number;
meth_meth_ast_toGrace9012->type->names[0] = "depth";
  meth_meth_ast_toGrace9012->definitionModule = modulename;
  meth_meth_ast_toGrace9012->definitionLine = 2283;
// method "shallowCopy"
  block_savedest(obj8948);
  Object closure9021 = createclosure(2, "shallowCopy");
  setclosureframe(closure9021, stackframe);
  addtoclosure(closure9021, var_nullNode);
  addtoclosure(closure9021, var_returnNode);
  struct UserObject *uo9021 = (struct UserObject*)obj8948;
  uo9021->data[7] = (Object)closure9021;
  Method *meth_meth_ast_shallowCopy9021 = addmethod2pos(obj8948, "shallowCopy", &meth_ast_shallowCopy9021, 7);
  int argcv_meth_ast_shallowCopy9021[] = {0};
  meth_meth_ast_shallowCopy9021->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9021);
  meth_meth_ast_shallowCopy9021->definitionModule = modulename;
  meth_meth_ast_shallowCopy9021->definitionLine = 2286;
  sourceObject = obj8948;
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9026 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9027 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9028 = gc_frame_new();
// call case 3: self.outer request
  Object call9029 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9028);
// compiled call node returning call9029 (depth = 7)
// compiled member node returning call9029 (depth = 6)
  partcv[0] = 0;
  Object call9030 = callmethodflags(call9029, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9027);
// compiled call node returning call9030 (depth = 5)
// compiled member node returning call9030 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9031 = callmethodflags(call9030, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9026);
// compiled call node returning call9031 (depth = 3)
  struct UserObject *obj8948_uo = (struct UserObject *)obj8948;
  obj8948_uo->super = call9031;
  sourceObject = obj8948;
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9032 == NULL) {
    strlit9032 = alloc_String("return");
    gc_root(strlit9032);
  }
// compiled string node returning strlit9032 (depth = 3)
  adddatum2(obj8948, strlit9032, 1);
  sourceObject = obj8948;
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj8948, *var_expr, 2);
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  sourceObject = obj8948;
  objclass8948 = obj8948->class;
  objclass8948->definitionModule = modulename;
  objclass8948->definitionLine = 2257;
  (*(struct UserObject *)self).data[0] = lowerouter8948;
  self = oldself8948;
  selfslot = oldselfslot8948;
  stackframe = oldstackframe8948;
  gc_frame_end(frame);
  return obj8948;
}
Object meth_ast_returnNode9034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_new_40__41_scope9037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()scope");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for new()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9038 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// call case 4: self request
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call9039 = callmethodflags(self, "new", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9038);
// compiled call node returning call9039 (depth = 4)
  *var_result = call9039;
  if (call9039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9040 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9041 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9040);
// compiled call node returning call9041 (depth = 3)
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_isLegalInTrait9051(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9053 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9052);
// compiled call node returning call9053 (depth = 4)
// compiled member node returning call9053 (depth = 3)
  gc_frame_end(frame);
  return call9053;
}
Object meth_ast_isInherits9054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9055 = alloc_Boolean(1);
// compiled identifier node returning bool9055 (depth = 3)
  gc_frame_end(frame);
  return bool9055;
}
Object meth_ast_inheritsFromMember9056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsFromMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsFromMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9057 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9059 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9058);
// compiled call node returning call9059 (depth = 6)
// compiled member node returning call9059 (depth = 5)
  partcv[0] = 0;
  Object call9060 = callmethod(call9059, "isMember",
    1, partcv, params);
  gc_frame_end(callframe9057);
// compiled call node returning call9060 (depth = 4)
// compiled member node returning call9060 (depth = 3)
  gc_frame_end(frame);
  return call9060;
}
Object meth_ast_inheritsFromCall9061(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsFromCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsFromCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9062 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9064 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9063);
// compiled call node returning call9064 (depth = 6)
// compiled member node returning call9064 (depth = 5)
  partcv[0] = 0;
  Object call9065 = callmethod(call9064, "isCall",
    1, partcv, params);
  gc_frame_end(callframe9062);
// compiled call node returning call9065 (depth = 4)
// compiled member node returning call9065 (depth = 3)
  gc_frame_end(frame);
  return call9065;
}
Object meth_ast_isExecutable9066(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9067 = alloc_Boolean(0);
// compiled identifier node returning bool9067 (depth = 3)
  gc_frame_end(frame);
  return bool9067;
}
Object meth_ast__apply9080(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9081 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9082 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call9083 = callmethod(*var_a, "newName",
    1, partcv, params);
  gc_frame_end(callframe9082);
// compiled call node returning call9083 (depth = 8)
// compiled member node returning call9083 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9084 = callmethod(call9083, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9081);
// compiled call node returning call9084 (depth = 6)
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9085 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call9087 = callmethod(*var_a, "oldName",
    1, partcv, params);
  gc_frame_end(callframe9086);
// compiled call node returning call9087 (depth = 8)
// compiled member node returning call9087 (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9088 = callmethod(call9087, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9085);
// compiled call node returning call9088 (depth = 6)
  gc_frame_end(frame);
  return call9088;
}
Object meth_ast__apply9095(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9096 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_e (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9097 = callmethod(*var_e, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9096);
// compiled call node returning call9097 (depth = 6)
  gc_frame_end(frame);
  return call9097;
}
Object meth_ast_accept_40__41_from9068(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9070 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9071 = callmethod(*var_visitor, "visitInherits()up",
    2, partcv, params);
  gc_frame_end(callframe9070);
// compiled call node returning call9071 (depth = 4)
  Object if9069 = done;
  if (istrue(call9071)) {
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9072 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9073 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9072);
// compiled call node returning call9073 (depth = 5)
  *var_newChain = call9073;
  if (call9073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9074 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9076 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9075);
// compiled call node returning call9076 (depth = 6)
// compiled member node returning call9076 (depth = 5)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9077 = callmethod(call9076, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9074);
// compiled call node returning call9077 (depth = 4)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9078 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9079 = alloc_Block(NULL, NULL, "ast", 2315);
  gc_frame_newslot(block9079);
// method "_apply"
  block_savedest(block9079);
  Object closure9080 = createclosure(3, "_apply");
  setclosureframe(closure9080, stackframe);
  addtoclosure(closure9080, var_visitor);
  addtoclosure(closure9080, var_newChain);
  addtoclosure(closure9080, selfslot);
  struct UserObject *uo9080 = (struct UserObject*)block9079;
  uo9080->data[0] = (Object)closure9080;
  Method *meth_meth_ast__apply9080 = addmethod2pos(block9079, "_apply", &meth_ast__apply9080, 0);
  int argcv_meth_ast__apply9080[] = {1};
  meth_meth_ast__apply9080->type = alloc_MethodType(1, argcv_meth_ast__apply9080);
  meth_meth_ast__apply9080->definitionModule = modulename;
  meth_meth_ast__apply9080->definitionLine = 2314;
// compiled block node returning block9079 (depth = 5)
  gc_frame_newslot(block9079);
// call case 6: other member request
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9090 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9091 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9090);
// compiled call node returning call9091 (depth = 6)
// compiled member node returning call9091 (depth = 5)
  params[0] = block9079;
  partcv[0] = 1;
  Object call9092 = callmethod(call9091, "do",
    1, partcv, params);
  gc_frame_end(callframe9078);
// compiled call node returning call9092 (depth = 4)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9093 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9094 = alloc_Block(NULL, NULL, "ast", 2319);
  gc_frame_newslot(block9094);
// method "_apply"
  block_savedest(block9094);
  Object closure9095 = createclosure(3, "_apply");
  setclosureframe(closure9095, stackframe);
  addtoclosure(closure9095, var_visitor);
  addtoclosure(closure9095, var_newChain);
  addtoclosure(closure9095, selfslot);
  struct UserObject *uo9095 = (struct UserObject*)block9094;
  uo9095->data[0] = (Object)closure9095;
  Method *meth_meth_ast__apply9095 = addmethod2pos(block9094, "_apply", &meth_ast__apply9095, 0);
  int argcv_meth_ast__apply9095[] = {1};
  meth_meth_ast__apply9095->type = alloc_MethodType(1, argcv_meth_ast__apply9095);
  meth_meth_ast__apply9095->definitionModule = modulename;
  meth_meth_ast__apply9095->definitionLine = 2315;
// compiled block node returning block9094 (depth = 5)
  gc_frame_newslot(block9094);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9099 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9100 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9099);
// compiled call node returning call9100 (depth = 6)
// compiled member node returning call9100 (depth = 5)
  params[0] = block9094;
  partcv[0] = 1;
  Object call9101 = callmethod(call9100, "do",
    1, partcv, params);
  gc_frame_end(callframe9093);
// compiled call node returning call9101 (depth = 4)
    gc_frame_newslot(call9101);
    if9069 = call9101;
  } else {
  }
// compiled if node returning if9069 (depth = 3)
  gc_frame_end(frame);
  return if9069;
}
Object meth_ast_declarationKindWithAncestors9102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call9104 = callmethod(*var_k, "methdec",
    1, partcv, params);
  gc_frame_end(callframe9103);
// compiled call node returning call9104 (depth = 4)
// compiled member node returning call9104 (depth = 3)
  gc_frame_end(frame);
  return call9104;
}
Object meth_ast_map_40__41_ancestors9105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9107 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9106);
// compiled call node returning call9107 (depth = 5)
// compiled member node returning call9107 (depth = 4)
  *var_n = call9107;
  if (call9107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9108 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9109 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9108);
// compiled call node returning call9109 (depth = 4)
  *var_newChain = call9109;
  if (call9109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9110 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9111 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9113 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9112);
// compiled call node returning call9113 (depth = 6)
// compiled member node returning call9113 (depth = 5)
  params[0] = *var_blk;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9114 = callmethod(call9113, "map()ancestors",
    2, partcv, params);
  gc_frame_end(callframe9111);
// compiled call node returning call9114 (depth = 4)
  gc_frame_newslot(call9114);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9114;
  partcv[0] = 1;
  Object call9115 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9110);
// compiled call node returning call9115 (depth = 3)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9116 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9117 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9116);
// compiled call node returning call9117 (depth = 3)
  gc_frame_end(frame);
  return call9117;
}
Object meth_ast__apply9126(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9128 == NULL) {
    strlit9128 = alloc_String("  ");
    gc_root(strlit9128);
  }
// compiled string node returning strlit9128 (depth = 7)
  int op_slot_right_9127 = gc_frame_newslot(strlit9128);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9127 = gc_frame_newslot(*var_spc);
  params[0] = strlit9128;
  partcv[0] = 1;
  Object opresult9130 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9130 (depth = 6)
  *var_spc = opresult9130;
  if (opresult9130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9171 == NULL) {
    strlit9171 = alloc_String("");
    gc_root(strlit9171);
  }
// compiled string node returning strlit9171 (depth = 7)
  int op_slot_right_9170 = gc_frame_newslot(strlit9171);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9174 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9175 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9174);
// compiled call node returning call9175 (depth = 8)
  int op_slot_right_9173 = gc_frame_newslot(call9175);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9178 == NULL) {
    strlit9178 = alloc_String("""\x0a""");
    gc_root(strlit9178);
  }
// compiled string node returning strlit9178 (depth = 9)
  int op_slot_right_9177 = gc_frame_newslot(strlit9178);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9180 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9182 == NULL) {
    strlit9182 = alloc_String("");
    gc_root(strlit9182);
  }
// compiled string node returning strlit9182 (depth = 10)
  int op_slot_left_9180 = gc_frame_newslot(strlit9182);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9183 = callmethod(strlit9182, "++", 1, partcv, params);
// compiled op node returning opresult9183 (depth = 9)
  int op_slot_left_9177 = gc_frame_newslot(opresult9183);
  params[0] = strlit9178;
  partcv[0] = 1;
  Object opresult9184 = callmethod(opresult9183, "++", 1, partcv, params);
// compiled op node returning opresult9184 (depth = 8)
  int op_slot_left_9173 = gc_frame_newslot(opresult9184);
  params[0] = call9175;
  partcv[0] = 1;
  Object opresult9185 = callmethod(opresult9184, "++", 1, partcv, params);
// compiled op node returning opresult9185 (depth = 7)
  int op_slot_left_9170 = gc_frame_newslot(opresult9185);
  params[0] = strlit9171;
  partcv[0] = 1;
  Object opresult9186 = callmethod(opresult9185, "++", 1, partcv, params);
// compiled op node returning opresult9186 (depth = 6)
  *var_s = opresult9186;
  if (opresult9186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9217(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9219 == NULL) {
    strlit9219 = alloc_String(" ");
    gc_root(strlit9219);
  }
// compiled string node returning strlit9219 (depth = 7)
  int op_slot_right_9218 = gc_frame_newslot(strlit9219);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_e (depth = 8)
  int op_slot_right_9221 = gc_frame_newslot(*var_e);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9224 == NULL) {
    strlit9224 = alloc_String(" exclude ");
    gc_root(strlit9224);
  }
// compiled string node returning strlit9224 (depth = 9)
  int op_slot_right_9223 = gc_frame_newslot(strlit9224);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9226 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9228 == NULL) {
    strlit9228 = alloc_String("");
    gc_root(strlit9228);
  }
// compiled string node returning strlit9228 (depth = 10)
  int op_slot_left_9226 = gc_frame_newslot(strlit9228);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9229 = callmethod(strlit9228, "++", 1, partcv, params);
// compiled op node returning opresult9229 (depth = 9)
  int op_slot_left_9223 = gc_frame_newslot(opresult9229);
  params[0] = strlit9224;
  partcv[0] = 1;
  Object opresult9230 = callmethod(opresult9229, "++", 1, partcv, params);
// compiled op node returning opresult9230 (depth = 8)
  int op_slot_left_9221 = gc_frame_newslot(opresult9230);
  params[0] = *var_e;
  partcv[0] = 1;
  Object opresult9231 = callmethod(opresult9230, "++", 1, partcv, params);
// compiled op node returning opresult9231 (depth = 7)
  int op_slot_left_9218 = gc_frame_newslot(opresult9231);
  params[0] = strlit9219;
  partcv[0] = 1;
  Object opresult9232 = callmethod(opresult9231, "++", 1, partcv, params);
// compiled op node returning opresult9232 (depth = 6)
  *var_s = opresult9232;
  if (opresult9232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9119 == NULL) {
    strlit9119 = alloc_String("");
    gc_root(strlit9119);
  }
// compiled string node returning strlit9119 (depth = 4)
  *var_spc = strlit9119;
  if (strlit9119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9120 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9121 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9123 = alloc_Float64(0);
// compiled num node returning num9123 (depth = 5)
  int op_slot_left_9121 = gc_frame_newslot(num9123);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9124 = callmethod(num9123, "..", 1, partcv, params);
// compiled op node returning opresult9124 (depth = 4)
  gc_frame_newslot(opresult9124);
// starting to compile block node (depth = 4)
  Object block9125 = alloc_Block(NULL, NULL, "ast", 2336);
  gc_frame_newslot(block9125);
// method "_apply"
  block_savedest(block9125);
  Object closure9126 = createclosure(2, "_apply");
  setclosureframe(closure9126, stackframe);
  addtoclosure(closure9126, var_spc);
  addtoclosure(closure9126, selfslot);
  struct UserObject *uo9126 = (struct UserObject*)block9125;
  uo9126->data[0] = (Object)closure9126;
  Method *meth_meth_ast__apply9126 = addmethod2pos(block9125, "_apply", &meth_ast__apply9126, 0);
  int argcv_meth_ast__apply9126[] = {1};
  meth_meth_ast__apply9126->type = alloc_MethodType(1, argcv_meth_ast__apply9126);
  meth_meth_ast__apply9126->definitionModule = modulename;
  meth_meth_ast__apply9126->definitionLine = 2331;
// compiled block node returning block9125 (depth = 4)
  gc_frame_newslot(block9125);
// call case 5: prelude request
  params[0] = opresult9124;
  params[1] = block9125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9133 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9120);
// compiled call node returning call9133 (depth = 3)
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9134 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9135 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9134);
// compiled call node returning call9135 (depth = 4)
  *var_s = call9135;
  if (call9135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9137 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9138 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9137);
// compiled call node returning call9138 (depth = 5)
// compiled member node returning call9138 (depth = 4)
  Object if9136 = done;
  if (istrue(call9138)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9140 == NULL) {
    strlit9140 = alloc_String(" (use)");
    gc_root(strlit9140);
  }
// compiled string node returning strlit9140 (depth = 6)
  int op_slot_right_9139 = gc_frame_newslot(strlit9140);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_9142 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 7)
  if (strlit9144 == NULL) {
    strlit9144 = alloc_String("");
    gc_root(strlit9144);
  }
// compiled string node returning strlit9144 (depth = 7)
  int op_slot_left_9142 = gc_frame_newslot(strlit9144);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9145 = callmethod(strlit9144, "++", 1, partcv, params);
// compiled op node returning opresult9145 (depth = 6)
  int op_slot_left_9139 = gc_frame_newslot(opresult9145);
  params[0] = strlit9140;
  partcv[0] = 1;
  Object opresult9146 = callmethod(opresult9145, "++", 1, partcv, params);
// compiled op node returning opresult9146 (depth = 5)
  *var_s = opresult9146;
  if (opresult9146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9136 = done;
  } else {
  }
// compiled if node returning if9136 (depth = 3)
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9149 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9151 = alloc_Float64(1);
// compiled num node returning num9151 (depth = 7)
  int op_slot_right_9150 = gc_frame_newslot(num9151);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_9150 = gc_frame_newslot(*var_depth);
  params[0] = num9151;
  partcv[0] = 1;
  Object sum9153 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9153 (depth = 6)
  gc_frame_newslot(sum9153);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9154 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9155 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9154);
// compiled call node returning call9155 (depth = 7)
// compiled member node returning call9155 (depth = 6)
  params[0] = sum9153;
  partcv[0] = 1;
  Object call9156 = callmethod(call9155, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9149);
// compiled call node returning call9156 (depth = 5)
  int op_slot_right_9148 = gc_frame_newslot(call9156);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9158 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9161 == NULL) {
    strlit9161 = alloc_String("""\x0a""");
    gc_root(strlit9161);
  }
// compiled string node returning strlit9161 (depth = 7)
  int op_slot_right_9160 = gc_frame_newslot(strlit9161);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9160 = gc_frame_newslot(*var_s);
  params[0] = strlit9161;
  partcv[0] = 1;
  Object opresult9163 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9163 (depth = 6)
  int op_slot_left_9158 = gc_frame_newslot(opresult9163);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9164 = callmethod(opresult9163, "++", 1, partcv, params);
// compiled op node returning opresult9164 (depth = 5)
  int op_slot_left_9148 = gc_frame_newslot(opresult9164);
  params[0] = call9156;
  partcv[0] = 1;
  Object opresult9165 = callmethod(opresult9164, "++", 1, partcv, params);
// compiled op node returning opresult9165 (depth = 4)
  *var_s = opresult9165;
  if (opresult9165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9167 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9168 = alloc_Block(NULL, NULL, "ast", 2342);
  gc_frame_newslot(block9168);
// method "_apply"
  block_savedest(block9168);
  Object closure9169 = createclosure(3, "_apply");
  setclosureframe(closure9169, stackframe);
  addtoclosure(closure9169, var_depth);
  addtoclosure(closure9169, var_s);
  addtoclosure(closure9169, selfslot);
  struct UserObject *uo9169 = (struct UserObject*)block9168;
  uo9169->data[0] = (Object)closure9169;
  Method *meth_meth_ast__apply9169 = addmethod2pos(block9168, "_apply", &meth_ast__apply9169, 0);
  int argcv_meth_ast__apply9169[] = {1};
  meth_meth_ast__apply9169->type = alloc_MethodType(1, argcv_meth_ast__apply9169);
  meth_meth_ast__apply9169->definitionModule = modulename;
  meth_meth_ast__apply9169->definitionLine = 2341;
// compiled block node returning block9168 (depth = 4)
  gc_frame_newslot(block9168);
// call case 6: other member request
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9189 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9190 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9189);
// compiled call node returning call9190 (depth = 5)
// compiled member node returning call9190 (depth = 4)
  params[0] = block9168;
  partcv[0] = 1;
  Object call9191 = callmethod(call9190, "do",
    1, partcv, params);
  gc_frame_end(callframe9167);
// compiled call node returning call9191 (depth = 3)
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9193 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9194 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9196 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9195);
// compiled call node returning call9196 (depth = 9)
// compiled member node returning call9196 (depth = 8)
  partcv[0] = 0;
  Object call9197 = callmethod(call9196, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9194);
// compiled call node returning call9197 (depth = 7)
// compiled member node returning call9197 (depth = 6)
  partcv[0] = 0;
  Object call9198 = callmethod(call9197, "not",
    1, partcv, params);
  gc_frame_end(callframe9193);
// compiled call node returning call9198 (depth = 5)
// compiled member node returning call9198 (depth = 4)
  Object if9192 = done;
  if (istrue(call9198)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9200 == NULL) {
    strlit9200 = alloc_String("");
    gc_root(strlit9200);
  }
// compiled string node returning strlit9200 (depth = 6)
  int op_slot_right_9199 = gc_frame_newslot(strlit9200);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9202 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9205 == NULL) {
    strlit9205 = alloc_String("""\x0a""");
    gc_root(strlit9205);
  }
// compiled string node returning strlit9205 (depth = 8)
  int op_slot_right_9204 = gc_frame_newslot(strlit9205);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9207 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9209 == NULL) {
    strlit9209 = alloc_String("");
    gc_root(strlit9209);
  }
// compiled string node returning strlit9209 (depth = 9)
  int op_slot_left_9207 = gc_frame_newslot(strlit9209);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9210 = callmethod(strlit9209, "++", 1, partcv, params);
// compiled op node returning opresult9210 (depth = 8)
  int op_slot_left_9204 = gc_frame_newslot(opresult9210);
  params[0] = strlit9205;
  partcv[0] = 1;
  Object opresult9211 = callmethod(opresult9210, "++", 1, partcv, params);
// compiled op node returning opresult9211 (depth = 7)
  int op_slot_left_9202 = gc_frame_newslot(opresult9211);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9212 = callmethod(opresult9211, "++", 1, partcv, params);
// compiled op node returning opresult9212 (depth = 6)
  int op_slot_left_9199 = gc_frame_newslot(opresult9212);
  params[0] = strlit9200;
  partcv[0] = 1;
  Object opresult9213 = callmethod(opresult9212, "++", 1, partcv, params);
// compiled op node returning opresult9213 (depth = 5)
  *var_s = opresult9213;
  if (opresult9213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9192 = done;
  } else {
  }
// compiled if node returning if9192 (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9215 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9216 = alloc_Block(NULL, NULL, "ast", 2346);
  gc_frame_newslot(block9216);
// method "_apply"
  block_savedest(block9216);
  Object closure9217 = createclosure(2, "_apply");
  setclosureframe(closure9217, stackframe);
  addtoclosure(closure9217, var_s);
  addtoclosure(closure9217, selfslot);
  struct UserObject *uo9217 = (struct UserObject*)block9216;
  uo9217->data[0] = (Object)closure9217;
  Method *meth_meth_ast__apply9217 = addmethod2pos(block9216, "_apply", &meth_ast__apply9217, 0);
  int argcv_meth_ast__apply9217[] = {1};
  meth_meth_ast__apply9217->type = alloc_MethodType(1, argcv_meth_ast__apply9217);
  meth_meth_ast__apply9217->definitionModule = modulename;
  meth_meth_ast__apply9217->definitionLine = 2345;
// compiled block node returning block9216 (depth = 4)
  gc_frame_newslot(block9216);
// call case 6: other member request
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9236 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9235);
// compiled call node returning call9236 (depth = 5)
// compiled member node returning call9236 (depth = 4)
  params[0] = block9216;
  partcv[0] = 1;
  Object call9237 = callmethod(call9236, "do",
    1, partcv, params);
  gc_frame_end(callframe9215);
// compiled call node returning call9237 (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9239 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9240 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9242 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9241);
// compiled call node returning call9242 (depth = 9)
// compiled member node returning call9242 (depth = 8)
  partcv[0] = 0;
  Object call9243 = callmethod(call9242, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9240);
// compiled call node returning call9243 (depth = 7)
// compiled member node returning call9243 (depth = 6)
  partcv[0] = 0;
  Object call9244 = callmethod(call9243, "not",
    1, partcv, params);
  gc_frame_end(callframe9239);
// compiled call node returning call9244 (depth = 5)
// compiled member node returning call9244 (depth = 4)
  Object if9238 = done;
  if (istrue(call9244)) {
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9247 == NULL) {
    strlit9247 = alloc_String("");
    gc_root(strlit9247);
  }
// compiled string node returning strlit9247 (depth = 7)
  int op_slot_right_9246 = gc_frame_newslot(strlit9247);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9250 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9251 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9253 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9252);
// compiled call node returning call9253 (depth = 13)
// compiled member node returning call9253 (depth = 12)
  partcv[0] = 0;
  Object call9254 = callmethod(call9253, "asList",
    1, partcv, params);
  gc_frame_end(callframe9251);
// compiled call node returning call9254 (depth = 11)
// compiled member node returning call9254 (depth = 10)
  partcv[0] = 0;
  Object call9255 = callmethod(call9254, "sort",
    1, partcv, params);
  gc_frame_end(callframe9250);
// compiled call node returning call9255 (depth = 9)
// compiled member node returning call9255 (depth = 8)
  int op_slot_right_9249 = gc_frame_newslot(call9255);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9258 == NULL) {
    strlit9258 = alloc_String("Provided names: ");
    gc_root(strlit9258);
  }
// compiled string node returning strlit9258 (depth = 9)
  int op_slot_right_9257 = gc_frame_newslot(strlit9258);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9260 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit9262 == NULL) {
    strlit9262 = alloc_String("""\x0a""");
    gc_root(strlit9262);
  }
// compiled string node returning strlit9262 (depth = 10)
  int op_slot_left_9260 = gc_frame_newslot(strlit9262);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9263 = callmethod(strlit9262, "++", 1, partcv, params);
// compiled op node returning opresult9263 (depth = 9)
  int op_slot_left_9257 = gc_frame_newslot(opresult9263);
  params[0] = strlit9258;
  partcv[0] = 1;
  Object opresult9264 = callmethod(opresult9263, "++", 1, partcv, params);
// compiled op node returning opresult9264 (depth = 8)
  int op_slot_left_9249 = gc_frame_newslot(opresult9264);
  params[0] = call9255;
  partcv[0] = 1;
  Object opresult9265 = callmethod(opresult9264, "++", 1, partcv, params);
// compiled op node returning opresult9265 (depth = 7)
  int op_slot_left_9246 = gc_frame_newslot(opresult9265);
  params[0] = strlit9247;
  partcv[0] = 1;
  Object opresult9266 = callmethod(opresult9265, "++", 1, partcv, params);
// compiled op node returning opresult9266 (depth = 6)
  int op_slot_right_9245 = gc_frame_newslot(opresult9266);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_9245 = gc_frame_newslot(*var_s);
  params[0] = opresult9266;
  partcv[0] = 1;
  Object opresult9268 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9268 (depth = 5)
  *var_s = opresult9268;
  if (opresult9268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9238 = done;
  } else {
  }
// compiled if node returning if9238 (depth = 3)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply9287(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9289 == NULL) {
    strlit9289 = alloc_String(" ");
    gc_root(strlit9289);
  }
// compiled string node returning strlit9289 (depth = 7)
  int op_slot_right_9288 = gc_frame_newslot(strlit9289);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  int op_slot_right_9291 = gc_frame_newslot(*var_a);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9294 == NULL) {
    strlit9294 = alloc_String(" ");
    gc_root(strlit9294);
  }
// compiled string node returning strlit9294 (depth = 9)
  int op_slot_right_9293 = gc_frame_newslot(strlit9294);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9296 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9298 == NULL) {
    strlit9298 = alloc_String("");
    gc_root(strlit9298);
  }
// compiled string node returning strlit9298 (depth = 10)
  int op_slot_left_9296 = gc_frame_newslot(strlit9298);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9299 = callmethod(strlit9298, "++", 1, partcv, params);
// compiled op node returning opresult9299 (depth = 9)
  int op_slot_left_9293 = gc_frame_newslot(opresult9299);
  params[0] = strlit9294;
  partcv[0] = 1;
  Object opresult9300 = callmethod(opresult9299, "++", 1, partcv, params);
// compiled op node returning opresult9300 (depth = 8)
  int op_slot_left_9291 = gc_frame_newslot(opresult9300);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult9301 = callmethod(opresult9300, "++", 1, partcv, params);
// compiled op node returning opresult9301 (depth = 7)
  int op_slot_left_9288 = gc_frame_newslot(opresult9301);
  params[0] = strlit9289;
  partcv[0] = 1;
  Object opresult9302 = callmethod(opresult9301, "++", 1, partcv, params);
// compiled op node returning opresult9302 (depth = 6)
  *var_s = opresult9302;
  if (opresult9302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9310(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9312 == NULL) {
    strlit9312 = alloc_String(" ");
    gc_root(strlit9312);
  }
// compiled string node returning strlit9312 (depth = 7)
  int op_slot_right_9311 = gc_frame_newslot(strlit9312);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_e (depth = 10)
  partcv[0] = 0;
  Object call9316 = callmethod(*var_e, "nameString",
    1, partcv, params);
  gc_frame_end(callframe9315);
// compiled call node returning call9316 (depth = 9)
// compiled member node returning call9316 (depth = 8)
  int op_slot_right_9314 = gc_frame_newslot(call9316);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9319 == NULL) {
    strlit9319 = alloc_String(" exclude ");
    gc_root(strlit9319);
  }
// compiled string node returning strlit9319 (depth = 9)
  int op_slot_right_9318 = gc_frame_newslot(strlit9319);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_9321 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit9323 == NULL) {
    strlit9323 = alloc_String("");
    gc_root(strlit9323);
  }
// compiled string node returning strlit9323 (depth = 10)
  int op_slot_left_9321 = gc_frame_newslot(strlit9323);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9324 = callmethod(strlit9323, "++", 1, partcv, params);
// compiled op node returning opresult9324 (depth = 9)
  int op_slot_left_9318 = gc_frame_newslot(opresult9324);
  params[0] = strlit9319;
  partcv[0] = 1;
  Object opresult9325 = callmethod(opresult9324, "++", 1, partcv, params);
// compiled op node returning opresult9325 (depth = 8)
  int op_slot_left_9314 = gc_frame_newslot(opresult9325);
  params[0] = call9316;
  partcv[0] = 1;
  Object opresult9326 = callmethod(opresult9325, "++", 1, partcv, params);
// compiled op node returning opresult9326 (depth = 7)
  int op_slot_left_9311 = gc_frame_newslot(opresult9326);
  params[0] = strlit9312;
  partcv[0] = 1;
  Object opresult9327 = callmethod(opresult9326, "++", 1, partcv, params);
// compiled op node returning opresult9327 (depth = 6)
  *var_s = opresult9327;
  if (opresult9327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace9270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9272 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9273 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9272);
// compiled call node returning call9273 (depth = 6)
// compiled member node returning call9273 (depth = 5)
  Object if9271 = done;
struct StackFrameObject *iftmpstackframe9271 = stackframe;
  if (istrue(call9273)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9271);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9274 == NULL) {
    strlit9274 = alloc_String("use ");
    gc_root(strlit9274);
  }
// compiled string node returning strlit9274 (depth = 5)
    gc_frame_newslot(strlit9274);
    if9271 = strlit9274;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9271);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9275 == NULL) {
    strlit9275 = alloc_String("inherit ");
    gc_root(strlit9275);
  }
// compiled string node returning strlit9275 (depth = 5)
    gc_frame_newslot(strlit9275);
    if9271 = strlit9275;
  }
stackframe = iftmpstackframe9271;
// compiled if node returning if9271 (depth = 4)
  *var_s = if9271;
  if (if9271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9277 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num9278 = alloc_Float64(0);
// compiled num node returning num9278 (depth = 6)
  gc_frame_newslot(num9278);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9279 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9280 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9279);
// compiled call node returning call9280 (depth = 7)
// compiled member node returning call9280 (depth = 6)
  params[0] = num9278;
  partcv[0] = 1;
  Object call9281 = callmethod(call9280, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9277);
// compiled call node returning call9281 (depth = 5)
  int op_slot_right_9276 = gc_frame_newslot(call9281);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_9276 = gc_frame_newslot(*var_s);
  params[0] = call9281;
  partcv[0] = 1;
  Object opresult9283 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9283 (depth = 4)
  *var_s = opresult9283;
  if (opresult9283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9285 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9286 = alloc_Block(NULL, NULL, "ast", 2357);
  gc_frame_newslot(block9286);
// method "_apply"
  block_savedest(block9286);
  Object closure9287 = createclosure(2, "_apply");
  setclosureframe(closure9287, stackframe);
  addtoclosure(closure9287, var_s);
  addtoclosure(closure9287, selfslot);
  struct UserObject *uo9287 = (struct UserObject*)block9286;
  uo9287->data[0] = (Object)closure9287;
  Method *meth_meth_ast__apply9287 = addmethod2pos(block9286, "_apply", &meth_ast__apply9287, 0);
  int argcv_meth_ast__apply9287[] = {1};
  meth_meth_ast__apply9287->type = alloc_MethodType(1, argcv_meth_ast__apply9287);
  meth_meth_ast__apply9287->definitionModule = modulename;
  meth_meth_ast__apply9287->definitionLine = 2356;
// compiled block node returning block9286 (depth = 4)
  gc_frame_newslot(block9286);
// call case 6: other member request
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9305 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9306 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9305);
// compiled call node returning call9306 (depth = 5)
// compiled member node returning call9306 (depth = 4)
  params[0] = block9286;
  partcv[0] = 1;
  Object call9307 = callmethod(call9306, "do",
    1, partcv, params);
  gc_frame_end(callframe9285);
// compiled call node returning call9307 (depth = 3)
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9308 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9309 = alloc_Block(NULL, NULL, "ast", 2360);
  gc_frame_newslot(block9309);
// method "_apply"
  block_savedest(block9309);
  Object closure9310 = createclosure(2, "_apply");
  setclosureframe(closure9310, stackframe);
  addtoclosure(closure9310, var_s);
  addtoclosure(closure9310, selfslot);
  struct UserObject *uo9310 = (struct UserObject*)block9309;
  uo9310->data[0] = (Object)closure9310;
  Method *meth_meth_ast__apply9310 = addmethod2pos(block9309, "_apply", &meth_ast__apply9310, 0);
  int argcv_meth_ast__apply9310[] = {1};
  meth_meth_ast__apply9310->type = alloc_MethodType(1, argcv_meth_ast__apply9310);
  meth_meth_ast__apply9310->definitionModule = modulename;
  meth_meth_ast__apply9310->definitionLine = 2357;
// compiled block node returning block9309 (depth = 4)
  gc_frame_newslot(block9309);
// call case 6: other member request
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9331 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9330);
// compiled call node returning call9331 (depth = 5)
// compiled member node returning call9331 (depth = 4)
  params[0] = block9309;
  partcv[0] = 1;
  Object call9332 = callmethod(call9331, "do",
    1, partcv, params);
  gc_frame_end(callframe9308);
// compiled call node returning call9332 (depth = 3)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString9333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9335 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num9336 = alloc_Float64(0);
// compiled num node returning num9336 (depth = 5)
  gc_frame_newslot(num9336);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9338 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9337);
// compiled call node returning call9338 (depth = 6)
// compiled member node returning call9338 (depth = 5)
  params[0] = num9336;
  partcv[0] = 1;
  Object call9339 = callmethod(call9338, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9335);
// compiled call node returning call9339 (depth = 4)
  int op_slot_right_9334 = gc_frame_newslot(call9339);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9342 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9343 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9342);
// compiled call node returning call9343 (depth = 6)
// compiled member node returning call9343 (depth = 5)
  Object if9341 = done;
struct StackFrameObject *iftmpstackframe9341 = stackframe;
  if (istrue(call9343)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9341);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9344 == NULL) {
    strlit9344 = alloc_String("use ");
    gc_root(strlit9344);
  }
// compiled string node returning strlit9344 (depth = 5)
    gc_frame_newslot(strlit9344);
    if9341 = strlit9344;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9341);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9345 == NULL) {
    strlit9345 = alloc_String("inherit ");
    gc_root(strlit9345);
  }
// compiled string node returning strlit9345 (depth = 5)
    gc_frame_newslot(strlit9345);
    if9341 = strlit9345;
  }
stackframe = iftmpstackframe9341;
// compiled if node returning if9341 (depth = 4)
  int op_slot_left_9334 = gc_frame_newslot(if9341);
  params[0] = call9339;
  partcv[0] = 1;
  Object opresult9346 = callmethod(if9341, "++", 1, partcv, params);
// compiled op node returning opresult9346 (depth = 3)
  gc_frame_end(frame);
  return opresult9346;
}
Object meth_ast_nameString9347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9348 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num9349 = alloc_Float64(0);
// compiled num node returning num9349 (depth = 4)
  gc_frame_newslot(num9349);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9351 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9350);
// compiled call node returning call9351 (depth = 5)
// compiled member node returning call9351 (depth = 4)
  params[0] = num9349;
  partcv[0] = 1;
  Object call9352 = callmethod(call9351, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9348);
// compiled call node returning call9352 (depth = 3)
  gc_frame_end(frame);
  return call9352;
}
Object meth_ast_addAlias_40__41_for9353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAlias()for");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias()for");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAlias()for");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for addAlias()for (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_newName = &(stackframe->slots[0]);
  *var_newName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAlias");
  Object *var_oldName = &(stackframe->slots[1]);
  *var_oldName = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for for");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9354 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9355 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newName (depth = 5)
  gc_frame_newslot(*var_newName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldName (depth = 5)
  gc_frame_newslot(*var_oldName);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9356 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9357 = gc_frame_new();
// call case 3: self.outer request
  Object call9358 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9357);
// compiled call node returning call9358 (depth = 8)
// compiled member node returning call9358 (depth = 7)
  partcv[0] = 0;
  Object call9359 = callmethodflags(call9358, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9356);
// compiled call node returning call9359 (depth = 6)
// compiled member node returning call9359 (depth = 5)
  params[0] = *var_newName;
  params[1] = *var_oldName;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9360 = callmethodflags(call9359, "aliasNew()old", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9355);
// compiled call node returning call9360 (depth = 4)
  gc_frame_newslot(call9360);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9362 = callmethodflags(self, "aliases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9361);
// compiled call node returning call9362 (depth = 5)
// compiled member node returning call9362 (depth = 4)
  params[0] = call9360;
  partcv[0] = 1;
  Object call9363 = callmethod(call9362, "push",
    1, partcv, params);
  gc_frame_end(callframe9354);
// compiled call node returning call9363 (depth = 3)
  gc_frame_end(frame);
  return call9363;
}
Object meth_ast_addExclusion9364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addExclusion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addExclusion");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addExclusion (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methName = &(stackframe->slots[0]);
  *var_methName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addExclusion");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9365 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methName (depth = 4)
  gc_frame_newslot(*var_methName);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9366 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9367 = callmethodflags(self, "exclusions", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9366);
// compiled call node returning call9367 (depth = 5)
// compiled member node returning call9367 (depth = 4)
  params[0] = *var_methName;
  partcv[0] = 1;
  Object call9368 = callmethod(call9367, "push",
    1, partcv, params);
  gc_frame_end(callframe9365);
// compiled call node returning call9368 (depth = 3)
  gc_frame_end(frame);
  return call9368;
}
Object meth_ast_shallowCopy9369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9370 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9371 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inheritsNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9372 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9371);
// compiled call node returning call9372 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9373 = callmethod(call9372, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9370);
// compiled call node returning call9373 (depth = 3)
  gc_frame_end(frame);
  return call9373;
}
Object meth_ast_shallowCopyFieldsFrom9374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9375 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9376 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9375);
// compiled call node returning call9376 (depth = 3)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9377 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9379 = callmethod(*var_other, "providedNames",
    1, partcv, params);
  gc_frame_end(callframe9378);
// compiled call node returning call9379 (depth = 5)
// compiled member node returning call9379 (depth = 4)
  gc_frame_newslot(call9379);
// call case 4: self request
  params[0] = call9379;
  partcv[0] = 1;
  Object call9380 = callmethodflags(self, "providedNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9377);
// compiled call node returning call9380 (depth = 3)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9381 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9382 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9383 = callmethod(*var_other, "aliases",
    1, partcv, params);
  gc_frame_end(callframe9382);
// compiled call node returning call9383 (depth = 5)
// compiled member node returning call9383 (depth = 4)
  gc_frame_newslot(call9383);
// call case 4: self request
  params[0] = call9383;
  partcv[0] = 1;
  Object call9384 = callmethodflags(self, "aliases:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9381);
// compiled call node returning call9384 (depth = 3)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9385 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9386 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9387 = callmethod(*var_other, "exclusions",
    1, partcv, params);
  gc_frame_end(callframe9386);
// compiled call node returning call9387 (depth = 5)
// compiled member node returning call9387 (depth = 4)
  gc_frame_newslot(call9387);
// call case 4: self request
  params[0] = call9387;
  partcv[0] = 1;
  Object call9388 = callmethodflags(self, "exclusions:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9385);
// compiled call node returning call9388 (depth = 3)
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9389 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9391 = callmethod(*var_other, "isUse",
    1, partcv, params);
  gc_frame_end(callframe9390);
// compiled call node returning call9391 (depth = 5)
// compiled member node returning call9391 (depth = 4)
  gc_frame_newslot(call9391);
// call case 4: self request
  params[0] = call9391;
  partcv[0] = 1;
  Object call9392 = callmethodflags(self, "isUse:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9389);
// compiled call node returning call9392 (depth = 3)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName9393(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9396 = callmethodflags(self, "isUse", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9395);
// compiled call node returning call9396 (depth = 5)
// compiled member node returning call9396 (depth = 4)
  Object if9394 = done;
  if (istrue(call9396)) {
// starting to compile string node (depth = 4)
  if (strlit9397 == NULL) {
    strlit9397 = alloc_String("use");
    gc_root(strlit9397);
  }
// compiled string node returning strlit9397 (depth = 4)
    gc_frame_newslot(strlit9397);
    if9394 = strlit9397;
  } else {
// starting to compile string node (depth = 4)
  if (strlit9398 == NULL) {
    strlit9398 = alloc_String("inherit");
    gc_root(strlit9398);
  }
// compiled string node returning strlit9398 (depth = 4)
    gc_frame_newslot(strlit9398);
    if9394 = strlit9398;
  }
// compiled if node returning if9394 (depth = 3)
  gc_frame_end(frame);
  return if9394;
}
Object meth_ast_new9042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9043 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9043 = alloc_userobj2(28,24, objclass9043);
  gc_frame_newslot(obj9043);
if (objclass9043 == NULL) {
  glfree(obj9043->class->name);
  obj9043->class->name = "inheritsNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9043, self, 0);
  addmethodreal(obj9043,"outer", &reader_ast_outer_9044);
  Object oldself9043 = self;
  struct StackFrameObject *oldstackframe9043 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9043);
  gc_frame_newslot((Object)stackframe);
  self = obj9043;
  Object *oldselfslot9043 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9043 = (*(struct UserObject *)self).data[0], lowerouter9043 = thisouter9043;
  if (inheritingObject9043) {
    struct UserObject *inho9043 = (struct UserObject *)inheritingObject9043;
    while (inho9043->super != GraceDefaultObject) inho9043 = (struct UserObject *)inho9043->super;
    inho9043->super = obj9043;
    self = inheritingObject9043;
    *selfslot = self;
    lowerouter9043 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9043;
  }
if (objclass9043 == NULL) {
  Method *reader9045 = addmethodrealflags(obj9043, "kind",&reader_ast_kind_9045, MFLAG_DEF);
  reader9045->definitionModule = modulename;
  reader9045->definitionLine = 2299;
}
adddatum2(obj9043, alloc_Undefined(), 1);
if (objclass9043 == NULL) {
  Method *reader9046 = addmethodrealflags(obj9043, "value",&reader_ast_value_9046, 0);
  Method *writer9046 = addmethodrealflags(obj9043, "value:=",&writer_ast_value_9046, 0);
  reader9046->definitionModule = modulename;
  writer9046->definitionModule = modulename;
  reader9046->definitionLine = 2300;
  writer9046->definitionLine = 2300;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 2);
if (objclass9043 == NULL) {
  Method *reader9047 = addmethodrealflags(obj9043, "providedNames",&reader_ast_providedNames_9047, 0);
  Method *writer9047 = addmethodrealflags(obj9043, "providedNames:=",&writer_ast_providedNames_9047, 0);
  reader9047->definitionModule = modulename;
  writer9047->definitionModule = modulename;
  reader9047->definitionLine = 2301;
  writer9047->definitionLine = 2301;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 3);
if (objclass9043 == NULL) {
  Method *reader9048 = addmethodrealflags(obj9043, "aliases",&reader_ast_aliases_9048, 0);
  Method *writer9048 = addmethodrealflags(obj9043, "aliases:=",&writer_ast_aliases_9048, 0);
  reader9048->definitionModule = modulename;
  writer9048->definitionModule = modulename;
  reader9048->definitionLine = 2302;
  writer9048->definitionLine = 2302;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 4);
if (objclass9043 == NULL) {
  Method *reader9049 = addmethodrealflags(obj9043, "exclusions",&reader_ast_exclusions_9049, 0);
  Method *writer9049 = addmethodrealflags(obj9043, "exclusions:=",&writer_ast_exclusions_9049, 0);
  reader9049->definitionModule = modulename;
  writer9049->definitionModule = modulename;
  reader9049->definitionLine = 2303;
  writer9049->definitionLine = 2303;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 5);
if (objclass9043 == NULL) {
  Method *reader9050 = addmethodrealflags(obj9043, "isUse",&reader_ast_isUse_9050, 0);
  Method *writer9050 = addmethodrealflags(obj9043, "isUse:=",&writer_ast_isUse_9050, 0);
  reader9050->definitionModule = modulename;
  writer9050->definitionModule = modulename;
  reader9050->definitionLine = 2304;
  writer9050->definitionLine = 2304;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9051 = (struct UserObject*)obj9043;
  uo9051->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9051 = addmethod2pos(obj9043, "isLegalInTrait", &meth_ast_isLegalInTrait9051, 7);
  int argcv_meth_ast_isLegalInTrait9051[] = {0};
  meth_meth_ast_isLegalInTrait9051->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9051);
  meth_meth_ast_isLegalInTrait9051->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9051->definitionLine = 2306;
// method "isInherits"
  struct UserObject *uo9054 = (struct UserObject*)obj9043;
  uo9054->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9054 = addmethod2pos(obj9043, "isInherits", &meth_ast_isInherits9054, 8);
  int argcv_meth_ast_isInherits9054[] = {0};
  meth_meth_ast_isInherits9054->type = alloc_MethodType(1, argcv_meth_ast_isInherits9054);
  meth_meth_ast_isInherits9054->definitionModule = modulename;
  meth_meth_ast_isInherits9054->definitionLine = 2307;
// method "inheritsFromMember"
  struct UserObject *uo9056 = (struct UserObject*)obj9043;
  uo9056->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9056 = addmethod2pos(obj9043, "inheritsFromMember", &meth_ast_inheritsFromMember9056, 9);
  int argcv_meth_ast_inheritsFromMember9056[] = {0};
  meth_meth_ast_inheritsFromMember9056->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9056);
  meth_meth_ast_inheritsFromMember9056->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9056->definitionLine = 2308;
// method "inheritsFromCall"
  struct UserObject *uo9061 = (struct UserObject*)obj9043;
  uo9061->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9061 = addmethod2pos(obj9043, "inheritsFromCall", &meth_ast_inheritsFromCall9061, 10);
  int argcv_meth_ast_inheritsFromCall9061[] = {0};
  meth_meth_ast_inheritsFromCall9061->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9061);
  meth_meth_ast_inheritsFromCall9061->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9061->definitionLine = 2309;
// method "isExecutable"
  struct UserObject *uo9066 = (struct UserObject*)obj9043;
  uo9066->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9066 = addmethod2pos(obj9043, "isExecutable", &meth_ast_isExecutable9066, 11);
  int argcv_meth_ast_isExecutable9066[] = {0};
  meth_meth_ast_isExecutable9066->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9066);
  meth_meth_ast_isExecutable9066->definitionModule = modulename;
  meth_meth_ast_isExecutable9066->definitionLine = 2310;
// method "accept()from"
  struct UserObject *uo9068 = (struct UserObject*)obj9043;
  uo9068->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9068 = addmethod2pos(obj9043, "accept()from", &meth_ast_accept_40__41_from9068, 12);
  int argcv_meth_ast_accept_40__41_from9068[] = {1, 1};
  meth_meth_ast_accept_40__41_from9068->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9068);
  meth_meth_ast_accept_40__41_from9068->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9068->definitionLine = 2311;
// method "declarationKindWithAncestors"
  block_savedest(obj9043);
  Object closure9102 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9102, stackframe);
  addtoclosure(closure9102, var_k);
  struct UserObject *uo9102 = (struct UserObject*)obj9043;
  uo9102->data[13] = (Object)closure9102;
  Method *meth_meth_ast_declarationKindWithAncestors9102 = addmethod2pos(obj9043, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9102, 13);
  int argcv_meth_ast_declarationKindWithAncestors9102[] = {1};
  meth_meth_ast_declarationKindWithAncestors9102->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9102);
  meth_meth_ast_declarationKindWithAncestors9102->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9102->definitionLine = 2322;
// method "map()ancestors"
  struct UserObject *uo9105 = (struct UserObject*)obj9043;
  uo9105->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9105 = addmethod2pos(obj9043, "map()ancestors", &meth_ast_map_40__41_ancestors9105, 14);
  int argcv_meth_ast_map_40__41_ancestors9105[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9105->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9105);
  meth_meth_ast_map_40__41_ancestors9105->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9105->definitionLine = 2328;
// method "pretty"
  struct UserObject *uo9118 = (struct UserObject*)obj9043;
  uo9118->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty9118 = addmethod2pos(obj9043, "pretty", &meth_ast_pretty9118, 15);
  int argcv_meth_ast_pretty9118[] = {1};
  meth_meth_ast_pretty9118->type = alloc_MethodType(1, argcv_meth_ast_pretty9118);
  meth_meth_ast_pretty9118->definitionModule = modulename;
  meth_meth_ast_pretty9118->definitionLine = 2334;
// method "toGrace"
  struct UserObject *uo9270 = (struct UserObject*)obj9043;
  uo9270->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace9270 = addmethod2pos(obj9043, "toGrace", &meth_ast_toGrace9270, 16);
  int argcv_meth_ast_toGrace9270[] = {1};
  meth_meth_ast_toGrace9270->type = alloc_MethodType(1, argcv_meth_ast_toGrace9270);
meth_meth_ast_toGrace9270->type->types[0] = type_Number;
meth_meth_ast_toGrace9270->type->names[0] = "depth";
  meth_meth_ast_toGrace9270->definitionModule = modulename;
  meth_meth_ast_toGrace9270->definitionLine = 2354;
// method "asString"
  struct UserObject *uo9333 = (struct UserObject*)obj9043;
  uo9333->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9333 = addmethod2pos(obj9043, "asString", &meth_ast_asString9333, 17);
  int argcv_meth_ast_asString9333[] = {0};
  meth_meth_ast_asString9333->type = alloc_MethodType(1, argcv_meth_ast_asString9333);
  meth_meth_ast_asString9333->definitionModule = modulename;
  meth_meth_ast_asString9333->definitionLine = 2365;
// method "nameString"
  struct UserObject *uo9347 = (struct UserObject*)obj9043;
  uo9347->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9347 = addmethod2pos(obj9043, "nameString", &meth_ast_nameString9347, 18);
  int argcv_meth_ast_nameString9347[] = {0};
  meth_meth_ast_nameString9347->type = alloc_MethodType(1, argcv_meth_ast_nameString9347);
  meth_meth_ast_nameString9347->definitionModule = modulename;
  meth_meth_ast_nameString9347->definitionLine = 2368;
// method "addAlias()for"
  struct UserObject *uo9353 = (struct UserObject*)obj9043;
  uo9353->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40__41_for9353 = addmethod2pos(obj9043, "addAlias()for", &meth_ast_addAlias_40__41_for9353, 19);
  int argcv_meth_ast_addAlias_40__41_for9353[] = {1, 1};
  meth_meth_ast_addAlias_40__41_for9353->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40__41_for9353);
  meth_meth_ast_addAlias_40__41_for9353->definitionModule = modulename;
  meth_meth_ast_addAlias_40__41_for9353->definitionLine = 2369;
// method "addExclusion"
  struct UserObject *uo9364 = (struct UserObject*)obj9043;
  uo9364->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion9364 = addmethod2pos(obj9043, "addExclusion", &meth_ast_addExclusion9364, 20);
  int argcv_meth_ast_addExclusion9364[] = {1};
  meth_meth_ast_addExclusion9364->type = alloc_MethodType(1, argcv_meth_ast_addExclusion9364);
  meth_meth_ast_addExclusion9364->definitionModule = modulename;
  meth_meth_ast_addExclusion9364->definitionLine = 2372;
// method "shallowCopy"
  block_savedest(obj9043);
  Object closure9369 = createclosure(2, "shallowCopy");
  setclosureframe(closure9369, stackframe);
  addtoclosure(closure9369, var_nullNode);
  addtoclosure(closure9369, var_inheritsNode);
  struct UserObject *uo9369 = (struct UserObject*)obj9043;
  uo9369->data[21] = (Object)closure9369;
  Method *meth_meth_ast_shallowCopy9369 = addmethod2pos(obj9043, "shallowCopy", &meth_ast_shallowCopy9369, 21);
  int argcv_meth_ast_shallowCopy9369[] = {0};
  meth_meth_ast_shallowCopy9369->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9369);
  meth_meth_ast_shallowCopy9369->definitionModule = modulename;
  meth_meth_ast_shallowCopy9369->definitionLine = 2375;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9374 = (struct UserObject*)obj9043;
  uo9374->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9374 = addmethod2pos(obj9043, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9374, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom9374[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9374->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9374);
  meth_meth_ast_shallowCopyFieldsFrom9374->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9374->definitionLine = 2378;
// method "statementName"
  struct UserObject *uo9393 = (struct UserObject*)obj9043;
  uo9393->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9393 = addmethod2pos(obj9043, "statementName", &meth_ast_statementName9393, 23);
  int argcv_meth_ast_statementName9393[] = {0};
  meth_meth_ast_statementName9393->type = alloc_MethodType(1, argcv_meth_ast_statementName9393);
  meth_meth_ast_statementName9393->definitionModule = modulename;
  meth_meth_ast_statementName9393->definitionLine = 2386;
  sourceObject = obj9043;
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9399 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9400 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9401 = gc_frame_new();
// call case 3: self.outer request
  Object call9402 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 7)
// compiled member node returning call9402 (depth = 6)
  partcv[0] = 0;
  Object call9403 = callmethodflags(call9402, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9400);
// compiled call node returning call9403 (depth = 5)
// compiled member node returning call9403 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9404 = callmethodflags(call9403, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9399);
// compiled call node returning call9404 (depth = 3)
  struct UserObject *obj9043_uo = (struct UserObject *)obj9043;
  obj9043_uo->super = call9404;
  sourceObject = obj9043;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9405 == NULL) {
    strlit9405 = alloc_String("inherits");
    gc_root(strlit9405);
  }
// compiled string node returning strlit9405 (depth = 3)
  adddatum2(obj9043, strlit9405, 1);
  sourceObject = obj9043;
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9043, *var_expr, 2);
  sourceObject = obj9043;
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9406 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9407 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled call node returning call9407 (depth = 4)
// compiled member node returning call9407 (depth = 3)
  adddatum2(obj9043, call9407, 3);
  sourceObject = obj9043;
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9408 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9408 (depth = 3)
  adddatum2(obj9043, array9408, 4);
  sourceObject = obj9043;
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9409 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9409 (depth = 3)
  adddatum2(obj9043, array9409, 5);
  sourceObject = obj9043;
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9410 = alloc_Boolean(0);
// compiled identifier node returning bool9410 (depth = 3)
  adddatum2(obj9043, bool9410, 6);
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  objclass9043 = obj9043->class;
  objclass9043->definitionModule = modulename;
  objclass9043->definitionLine = 2297;
  (*(struct UserObject *)self).data[0] = lowerouter9043;
  self = oldself9043;
  selfslot = oldselfslot9043;
  stackframe = oldstackframe9043;
  gc_frame_end(frame);
  return obj9043;
}
Object meth_ast_new9042_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_inheritsNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9043 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9043 = alloc_userobj2(28,24, objclass9043);
  gc_frame_newslot(obj9043);
if (objclass9043 == NULL) {
  glfree(obj9043->class->name);
  obj9043->class->name = "inheritsNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9043, self, 0);
  addmethodreal(obj9043,"outer", &reader_ast_outer_9044);
  Object oldself9043 = self;
  struct StackFrameObject *oldstackframe9043 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9043);
  gc_frame_newslot((Object)stackframe);
  self = obj9043;
  Object *oldselfslot9043 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9043 = (*(struct UserObject *)self).data[0], lowerouter9043 = thisouter9043;
  if (inheritingObject9043) {
    struct UserObject *inho9043 = (struct UserObject *)inheritingObject9043;
    while (inho9043->super != GraceDefaultObject) inho9043 = (struct UserObject *)inho9043->super;
    inho9043->super = obj9043;
    self = inheritingObject9043;
    *selfslot = self;
    lowerouter9043 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9043;
  }
if (objclass9043 == NULL) {
  Method *reader9045 = addmethodrealflags(obj9043, "kind",&reader_ast_kind_9045, MFLAG_DEF);
  reader9045->definitionModule = modulename;
  reader9045->definitionLine = 2299;
}
adddatum2(obj9043, alloc_Undefined(), 1);
if (objclass9043 == NULL) {
  Method *reader9046 = addmethodrealflags(obj9043, "value",&reader_ast_value_9046, 0);
  Method *writer9046 = addmethodrealflags(obj9043, "value:=",&writer_ast_value_9046, 0);
  reader9046->definitionModule = modulename;
  writer9046->definitionModule = modulename;
  reader9046->definitionLine = 2300;
  writer9046->definitionLine = 2300;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 2);
if (objclass9043 == NULL) {
  Method *reader9047 = addmethodrealflags(obj9043, "providedNames",&reader_ast_providedNames_9047, 0);
  Method *writer9047 = addmethodrealflags(obj9043, "providedNames:=",&writer_ast_providedNames_9047, 0);
  reader9047->definitionModule = modulename;
  writer9047->definitionModule = modulename;
  reader9047->definitionLine = 2301;
  writer9047->definitionLine = 2301;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 3);
if (objclass9043 == NULL) {
  Method *reader9048 = addmethodrealflags(obj9043, "aliases",&reader_ast_aliases_9048, 0);
  Method *writer9048 = addmethodrealflags(obj9043, "aliases:=",&writer_ast_aliases_9048, 0);
  reader9048->definitionModule = modulename;
  writer9048->definitionModule = modulename;
  reader9048->definitionLine = 2302;
  writer9048->definitionLine = 2302;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 4);
if (objclass9043 == NULL) {
  Method *reader9049 = addmethodrealflags(obj9043, "exclusions",&reader_ast_exclusions_9049, 0);
  Method *writer9049 = addmethodrealflags(obj9043, "exclusions:=",&writer_ast_exclusions_9049, 0);
  reader9049->definitionModule = modulename;
  writer9049->definitionModule = modulename;
  reader9049->definitionLine = 2303;
  writer9049->definitionLine = 2303;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 5);
if (objclass9043 == NULL) {
  Method *reader9050 = addmethodrealflags(obj9043, "isUse",&reader_ast_isUse_9050, 0);
  Method *writer9050 = addmethodrealflags(obj9043, "isUse:=",&writer_ast_isUse_9050, 0);
  reader9050->definitionModule = modulename;
  writer9050->definitionModule = modulename;
  reader9050->definitionLine = 2304;
  writer9050->definitionLine = 2304;
}
obj9043->flags |= OFLAG_MUTABLE;
adddatum2(obj9043, alloc_Undefined(), 6);
// method "isLegalInTrait"
  struct UserObject *uo9051 = (struct UserObject*)obj9043;
  uo9051->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9051 = addmethod2pos(obj9043, "isLegalInTrait", &meth_ast_isLegalInTrait9051, 7);
  int argcv_meth_ast_isLegalInTrait9051[] = {0};
  meth_meth_ast_isLegalInTrait9051->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9051);
  meth_meth_ast_isLegalInTrait9051->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9051->definitionLine = 2306;
// method "isInherits"
  struct UserObject *uo9054 = (struct UserObject*)obj9043;
  uo9054->data[8] = emptyclosure;
  Method *meth_meth_ast_isInherits9054 = addmethod2pos(obj9043, "isInherits", &meth_ast_isInherits9054, 8);
  int argcv_meth_ast_isInherits9054[] = {0};
  meth_meth_ast_isInherits9054->type = alloc_MethodType(1, argcv_meth_ast_isInherits9054);
  meth_meth_ast_isInherits9054->definitionModule = modulename;
  meth_meth_ast_isInherits9054->definitionLine = 2307;
// method "inheritsFromMember"
  struct UserObject *uo9056 = (struct UserObject*)obj9043;
  uo9056->data[9] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9056 = addmethod2pos(obj9043, "inheritsFromMember", &meth_ast_inheritsFromMember9056, 9);
  int argcv_meth_ast_inheritsFromMember9056[] = {0};
  meth_meth_ast_inheritsFromMember9056->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9056);
  meth_meth_ast_inheritsFromMember9056->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9056->definitionLine = 2308;
// method "inheritsFromCall"
  struct UserObject *uo9061 = (struct UserObject*)obj9043;
  uo9061->data[10] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9061 = addmethod2pos(obj9043, "inheritsFromCall", &meth_ast_inheritsFromCall9061, 10);
  int argcv_meth_ast_inheritsFromCall9061[] = {0};
  meth_meth_ast_inheritsFromCall9061->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9061);
  meth_meth_ast_inheritsFromCall9061->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9061->definitionLine = 2309;
// method "isExecutable"
  struct UserObject *uo9066 = (struct UserObject*)obj9043;
  uo9066->data[11] = emptyclosure;
  Method *meth_meth_ast_isExecutable9066 = addmethod2pos(obj9043, "isExecutable", &meth_ast_isExecutable9066, 11);
  int argcv_meth_ast_isExecutable9066[] = {0};
  meth_meth_ast_isExecutable9066->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9066);
  meth_meth_ast_isExecutable9066->definitionModule = modulename;
  meth_meth_ast_isExecutable9066->definitionLine = 2310;
// method "accept()from"
  struct UserObject *uo9068 = (struct UserObject*)obj9043;
  uo9068->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9068 = addmethod2pos(obj9043, "accept()from", &meth_ast_accept_40__41_from9068, 12);
  int argcv_meth_ast_accept_40__41_from9068[] = {1, 1};
  meth_meth_ast_accept_40__41_from9068->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9068);
  meth_meth_ast_accept_40__41_from9068->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9068->definitionLine = 2311;
// method "declarationKindWithAncestors"
  block_savedest(obj9043);
  Object closure9102 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9102, stackframe);
  addtoclosure(closure9102, var_k);
  struct UserObject *uo9102 = (struct UserObject*)obj9043;
  uo9102->data[13] = (Object)closure9102;
  Method *meth_meth_ast_declarationKindWithAncestors9102 = addmethod2pos(obj9043, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9102, 13);
  int argcv_meth_ast_declarationKindWithAncestors9102[] = {1};
  meth_meth_ast_declarationKindWithAncestors9102->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9102);
  meth_meth_ast_declarationKindWithAncestors9102->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9102->definitionLine = 2322;
// method "map()ancestors"
  struct UserObject *uo9105 = (struct UserObject*)obj9043;
  uo9105->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9105 = addmethod2pos(obj9043, "map()ancestors", &meth_ast_map_40__41_ancestors9105, 14);
  int argcv_meth_ast_map_40__41_ancestors9105[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9105->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9105);
  meth_meth_ast_map_40__41_ancestors9105->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9105->definitionLine = 2328;
// method "pretty"
  struct UserObject *uo9118 = (struct UserObject*)obj9043;
  uo9118->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty9118 = addmethod2pos(obj9043, "pretty", &meth_ast_pretty9118, 15);
  int argcv_meth_ast_pretty9118[] = {1};
  meth_meth_ast_pretty9118->type = alloc_MethodType(1, argcv_meth_ast_pretty9118);
  meth_meth_ast_pretty9118->definitionModule = modulename;
  meth_meth_ast_pretty9118->definitionLine = 2334;
// method "toGrace"
  struct UserObject *uo9270 = (struct UserObject*)obj9043;
  uo9270->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace9270 = addmethod2pos(obj9043, "toGrace", &meth_ast_toGrace9270, 16);
  int argcv_meth_ast_toGrace9270[] = {1};
  meth_meth_ast_toGrace9270->type = alloc_MethodType(1, argcv_meth_ast_toGrace9270);
meth_meth_ast_toGrace9270->type->types[0] = type_Number;
meth_meth_ast_toGrace9270->type->names[0] = "depth";
  meth_meth_ast_toGrace9270->definitionModule = modulename;
  meth_meth_ast_toGrace9270->definitionLine = 2354;
// method "asString"
  struct UserObject *uo9333 = (struct UserObject*)obj9043;
  uo9333->data[17] = emptyclosure;
  Method *meth_meth_ast_asString9333 = addmethod2pos(obj9043, "asString", &meth_ast_asString9333, 17);
  int argcv_meth_ast_asString9333[] = {0};
  meth_meth_ast_asString9333->type = alloc_MethodType(1, argcv_meth_ast_asString9333);
  meth_meth_ast_asString9333->definitionModule = modulename;
  meth_meth_ast_asString9333->definitionLine = 2365;
// method "nameString"
  struct UserObject *uo9347 = (struct UserObject*)obj9043;
  uo9347->data[18] = emptyclosure;
  Method *meth_meth_ast_nameString9347 = addmethod2pos(obj9043, "nameString", &meth_ast_nameString9347, 18);
  int argcv_meth_ast_nameString9347[] = {0};
  meth_meth_ast_nameString9347->type = alloc_MethodType(1, argcv_meth_ast_nameString9347);
  meth_meth_ast_nameString9347->definitionModule = modulename;
  meth_meth_ast_nameString9347->definitionLine = 2368;
// method "addAlias()for"
  struct UserObject *uo9353 = (struct UserObject*)obj9043;
  uo9353->data[19] = emptyclosure;
  Method *meth_meth_ast_addAlias_40__41_for9353 = addmethod2pos(obj9043, "addAlias()for", &meth_ast_addAlias_40__41_for9353, 19);
  int argcv_meth_ast_addAlias_40__41_for9353[] = {1, 1};
  meth_meth_ast_addAlias_40__41_for9353->type = alloc_MethodType(2, argcv_meth_ast_addAlias_40__41_for9353);
  meth_meth_ast_addAlias_40__41_for9353->definitionModule = modulename;
  meth_meth_ast_addAlias_40__41_for9353->definitionLine = 2369;
// method "addExclusion"
  struct UserObject *uo9364 = (struct UserObject*)obj9043;
  uo9364->data[20] = emptyclosure;
  Method *meth_meth_ast_addExclusion9364 = addmethod2pos(obj9043, "addExclusion", &meth_ast_addExclusion9364, 20);
  int argcv_meth_ast_addExclusion9364[] = {1};
  meth_meth_ast_addExclusion9364->type = alloc_MethodType(1, argcv_meth_ast_addExclusion9364);
  meth_meth_ast_addExclusion9364->definitionModule = modulename;
  meth_meth_ast_addExclusion9364->definitionLine = 2372;
// method "shallowCopy"
  block_savedest(obj9043);
  Object closure9369 = createclosure(2, "shallowCopy");
  setclosureframe(closure9369, stackframe);
  addtoclosure(closure9369, var_nullNode);
  addtoclosure(closure9369, var_inheritsNode);
  struct UserObject *uo9369 = (struct UserObject*)obj9043;
  uo9369->data[21] = (Object)closure9369;
  Method *meth_meth_ast_shallowCopy9369 = addmethod2pos(obj9043, "shallowCopy", &meth_ast_shallowCopy9369, 21);
  int argcv_meth_ast_shallowCopy9369[] = {0};
  meth_meth_ast_shallowCopy9369->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9369);
  meth_meth_ast_shallowCopy9369->definitionModule = modulename;
  meth_meth_ast_shallowCopy9369->definitionLine = 2375;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9374 = (struct UserObject*)obj9043;
  uo9374->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9374 = addmethod2pos(obj9043, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9374, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom9374[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9374->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9374);
  meth_meth_ast_shallowCopyFieldsFrom9374->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9374->definitionLine = 2378;
// method "statementName"
  struct UserObject *uo9393 = (struct UserObject*)obj9043;
  uo9393->data[23] = emptyclosure;
  Method *meth_meth_ast_statementName9393 = addmethod2pos(obj9043, "statementName", &meth_ast_statementName9393, 23);
  int argcv_meth_ast_statementName9393[] = {0};
  meth_meth_ast_statementName9393->type = alloc_MethodType(1, argcv_meth_ast_statementName9393);
  meth_meth_ast_statementName9393->definitionModule = modulename;
  meth_meth_ast_statementName9393->definitionLine = 2386;
  sourceObject = obj9043;
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9399 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9400 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9401 = gc_frame_new();
// call case 3: self.outer request
  Object call9402 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 7)
// compiled member node returning call9402 (depth = 6)
  partcv[0] = 0;
  Object call9403 = callmethodflags(call9402, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9400);
// compiled call node returning call9403 (depth = 5)
// compiled member node returning call9403 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9404 = callmethodflags(call9403, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9399);
// compiled call node returning call9404 (depth = 3)
  struct UserObject *obj9043_uo = (struct UserObject *)obj9043;
  obj9043_uo->super = call9404;
  sourceObject = obj9043;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9405 == NULL) {
    strlit9405 = alloc_String("inherits");
    gc_root(strlit9405);
  }
// compiled string node returning strlit9405 (depth = 3)
  adddatum2(obj9043, strlit9405, 1);
  sourceObject = obj9043;
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_expr (depth = 3)
  adddatum2(obj9043, *var_expr, 2);
  sourceObject = obj9043;
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9406 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9407 = callmethodflags(prelude, "emptySet", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled call node returning call9407 (depth = 4)
// compiled member node returning call9407 (depth = 3)
  adddatum2(obj9043, call9407, 3);
  sourceObject = obj9043;
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9408 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9408 (depth = 3)
  adddatum2(obj9043, array9408, 4);
  sourceObject = obj9043;
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array9409 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9409 (depth = 3)
  adddatum2(obj9043, array9409, 5);
  sourceObject = obj9043;
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9410 = alloc_Boolean(0);
// compiled identifier node returning bool9410 (depth = 3)
  adddatum2(obj9043, bool9410, 6);
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  sourceObject = obj9043;
  objclass9043 = obj9043->class;
  objclass9043->definitionModule = modulename;
  objclass9043->definitionLine = 2297;
  (*(struct UserObject *)self).data[0] = lowerouter9043;
  self = oldself9043;
  selfslot = oldselfslot9043;
  stackframe = oldstackframe9043;
  gc_frame_end(frame);
  return obj9043;
}
Object meth_ast_inheritsNode9412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_AliasPair9415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AliasPair");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AliasPair = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for AliasPair (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for AliasPair");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AliasPair (depth = 3)
  gc_frame_end(frame);
  return *var_AliasPair;
}
Object meth_ast_isExecutable9423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9424 = alloc_Boolean(0);
// compiled identifier node returning bool9424 (depth = 3)
  gc_frame_end(frame);
  return bool9424;
}
Object meth_ast_accept_40__41_from9425(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9426 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9427 = callmethod(*var_visitor, "visitBlank()up",
    2, partcv, params);
  gc_frame_end(callframe9426);
// compiled call node returning call9427 (depth = 3)
  gc_frame_end(frame);
  return call9427;
}
Object meth_ast_map_40__41_ancestors9428(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9430 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9429);
// compiled call node returning call9430 (depth = 5)
// compiled member node returning call9430 (depth = 4)
  *var_n = call9430;
  if (call9430 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9431 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9432 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9431);
// compiled call node returning call9432 (depth = 4)
  *var_newChain = call9432;
  if (call9432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9433 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9434 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9433);
// compiled call node returning call9434 (depth = 3)
  gc_frame_end(frame);
  return call9434;
}
Object meth_ast_nameString9435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9436 == NULL) {
    strlit9436 = alloc_String("");
    gc_root(strlit9436);
  }
// compiled string node returning strlit9436 (depth = 3)
  gc_frame_end(frame);
  return strlit9436;
}
Object meth_ast_asString9437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9438 == NULL) {
    strlit9438 = alloc_String("blank");
    gc_root(strlit9438);
  }
// compiled string node returning strlit9438 (depth = 3)
  gc_frame_end(frame);
  return strlit9438;
}
Object meth_ast_toGrace9439(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9440 == NULL) {
    strlit9440 = alloc_String("");
    gc_root(strlit9440);
  }
// compiled string node returning strlit9440 (depth = 3)
  gc_frame_end(frame);
  return strlit9440;
}
Object meth_ast_shallowCopy9441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9442 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9443 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blankNode (depth = 6)
  partcv[0] = 0;
  Object call9444 = callmethod(*var_blankNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9443);
// compiled call node returning call9444 (depth = 5)
// compiled member node returning call9444 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9445 = callmethod(call9444, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9442);
// compiled call node returning call9445 (depth = 3)
  gc_frame_end(frame);
  return call9445;
}
Object meth_ast_new9418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9419 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9419 = alloc_userobj2(9,10, objclass9419);
  gc_frame_newslot(obj9419);
if (objclass9419 == NULL) {
  glfree(obj9419->class->name);
  obj9419->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9419, self, 0);
  addmethodreal(obj9419,"outer", &reader_ast_outer_9420);
  Object oldself9419 = self;
  struct StackFrameObject *oldstackframe9419 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9419);
  gc_frame_newslot((Object)stackframe);
  self = obj9419;
  Object *oldselfslot9419 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9419 = (*(struct UserObject *)self).data[0], lowerouter9419 = thisouter9419;
  if (inheritingObject9419) {
    struct UserObject *inho9419 = (struct UserObject *)inheritingObject9419;
    while (inho9419->super != GraceDefaultObject) inho9419 = (struct UserObject *)inho9419->super;
    inho9419->super = obj9419;
    self = inheritingObject9419;
    *selfslot = self;
    lowerouter9419 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9419;
  }
if (objclass9419 == NULL) {
  Method *reader9421 = addmethodrealflags(obj9419, "kind",&reader_ast_kind_9421, MFLAG_DEF);
  reader9421->definitionModule = modulename;
  reader9421->definitionLine = 2418;
}
adddatum2(obj9419, alloc_Undefined(), 1);
if (objclass9419 == NULL) {
  Method *reader9422 = addmethodrealflags(obj9419, "value",&reader_ast_value_9422, MFLAG_DEF);
  reader9422->definitionModule = modulename;
  reader9422->definitionLine = 2419;
}
adddatum2(obj9419, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9423 = (struct UserObject*)obj9419;
  uo9423->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9423 = addmethod2pos(obj9419, "isExecutable", &meth_ast_isExecutable9423, 3);
  int argcv_meth_ast_isExecutable9423[] = {0};
  meth_meth_ast_isExecutable9423->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9423);
  meth_meth_ast_isExecutable9423->definitionModule = modulename;
  meth_meth_ast_isExecutable9423->definitionLine = 2420;
// method "accept()from"
  struct UserObject *uo9425 = (struct UserObject*)obj9419;
  uo9425->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9425 = addmethod2pos(obj9419, "accept()from", &meth_ast_accept_40__41_from9425, 4);
  int argcv_meth_ast_accept_40__41_from9425[] = {1, 1};
  meth_meth_ast_accept_40__41_from9425->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9425);
  meth_meth_ast_accept_40__41_from9425->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9425->definitionLine = 2423;
// method "map()ancestors"
  struct UserObject *uo9428 = (struct UserObject*)obj9419;
  uo9428->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9428 = addmethod2pos(obj9419, "map()ancestors", &meth_ast_map_40__41_ancestors9428, 5);
  int argcv_meth_ast_map_40__41_ancestors9428[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9428->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9428);
  meth_meth_ast_map_40__41_ancestors9428->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9428->definitionLine = 2426;
// method "nameString"
  struct UserObject *uo9435 = (struct UserObject*)obj9419;
  uo9435->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9435 = addmethod2pos(obj9419, "nameString", &meth_ast_nameString9435, 6);
  int argcv_meth_ast_nameString9435[] = {0};
  meth_meth_ast_nameString9435->type = alloc_MethodType(1, argcv_meth_ast_nameString9435);
  meth_meth_ast_nameString9435->definitionModule = modulename;
  meth_meth_ast_nameString9435->definitionLine = 2431;
// method "asString"
  struct UserObject *uo9437 = (struct UserObject*)obj9419;
  uo9437->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9437 = addmethod2pos(obj9419, "asString", &meth_ast_asString9437, 7);
  int argcv_meth_ast_asString9437[] = {0};
  meth_meth_ast_asString9437->type = alloc_MethodType(1, argcv_meth_ast_asString9437);
  meth_meth_ast_asString9437->definitionModule = modulename;
  meth_meth_ast_asString9437->definitionLine = 2432;
// method "toGrace"
  struct UserObject *uo9439 = (struct UserObject*)obj9419;
  uo9439->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace9439 = addmethod2pos(obj9419, "toGrace", &meth_ast_toGrace9439, 8);
  int argcv_meth_ast_toGrace9439[] = {1};
  meth_meth_ast_toGrace9439->type = alloc_MethodType(1, argcv_meth_ast_toGrace9439);
meth_meth_ast_toGrace9439->type->types[0] = type_Number;
meth_meth_ast_toGrace9439->type->names[0] = "depth";
  meth_meth_ast_toGrace9439->definitionModule = modulename;
  meth_meth_ast_toGrace9439->definitionLine = 2433;
// method "shallowCopy"
  block_savedest(obj9419);
  Object closure9441 = createclosure(1, "shallowCopy");
  setclosureframe(closure9441, stackframe);
  addtoclosure(closure9441, var_blankNode);
  struct UserObject *uo9441 = (struct UserObject*)obj9419;
  uo9441->data[9] = (Object)closure9441;
  Method *meth_meth_ast_shallowCopy9441 = addmethod2pos(obj9419, "shallowCopy", &meth_ast_shallowCopy9441, 9);
  int argcv_meth_ast_shallowCopy9441[] = {0};
  meth_meth_ast_shallowCopy9441->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9441);
  meth_meth_ast_shallowCopy9441->definitionModule = modulename;
  meth_meth_ast_shallowCopy9441->definitionLine = 2434;
  sourceObject = obj9419;
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9446 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9447 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9448 = gc_frame_new();
// call case 3: self.outer request
  Object call9449 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9448);
// compiled call node returning call9449 (depth = 7)
// compiled member node returning call9449 (depth = 6)
  partcv[0] = 0;
  Object call9450 = callmethodflags(call9449, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9447);
// compiled call node returning call9450 (depth = 5)
// compiled member node returning call9450 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9451 = callmethodflags(call9450, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9446);
// compiled call node returning call9451 (depth = 3)
  struct UserObject *obj9419_uo = (struct UserObject *)obj9419;
  obj9419_uo->super = call9451;
  sourceObject = obj9419;
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9452 == NULL) {
    strlit9452 = alloc_String("blank");
    gc_root(strlit9452);
  }
// compiled string node returning strlit9452 (depth = 3)
  adddatum2(obj9419, strlit9452, 1);
  sourceObject = obj9419;
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9453 == NULL) {
    strlit9453 = alloc_String("blank");
    gc_root(strlit9453);
  }
// compiled string node returning strlit9453 (depth = 3)
  adddatum2(obj9419, strlit9453, 2);
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  objclass9419 = obj9419->class;
  objclass9419->definitionModule = modulename;
  objclass9419->definitionLine = 2416;
  (*(struct UserObject *)self).data[0] = lowerouter9419;
  self = oldself9419;
  selfslot = oldselfslot9419;
  stackframe = oldstackframe9419;
  gc_frame_end(frame);
  return obj9419;
}
Object meth_ast_new9418_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9419 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9419 = alloc_userobj2(9,10, objclass9419);
  gc_frame_newslot(obj9419);
if (objclass9419 == NULL) {
  glfree(obj9419->class->name);
  obj9419->class->name = "blankNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9419, self, 0);
  addmethodreal(obj9419,"outer", &reader_ast_outer_9420);
  Object oldself9419 = self;
  struct StackFrameObject *oldstackframe9419 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9419);
  gc_frame_newslot((Object)stackframe);
  self = obj9419;
  Object *oldselfslot9419 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9419 = (*(struct UserObject *)self).data[0], lowerouter9419 = thisouter9419;
  if (inheritingObject9419) {
    struct UserObject *inho9419 = (struct UserObject *)inheritingObject9419;
    while (inho9419->super != GraceDefaultObject) inho9419 = (struct UserObject *)inho9419->super;
    inho9419->super = obj9419;
    self = inheritingObject9419;
    *selfslot = self;
    lowerouter9419 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9419;
  }
if (objclass9419 == NULL) {
  Method *reader9421 = addmethodrealflags(obj9419, "kind",&reader_ast_kind_9421, MFLAG_DEF);
  reader9421->definitionModule = modulename;
  reader9421->definitionLine = 2418;
}
adddatum2(obj9419, alloc_Undefined(), 1);
if (objclass9419 == NULL) {
  Method *reader9422 = addmethodrealflags(obj9419, "value",&reader_ast_value_9422, MFLAG_DEF);
  reader9422->definitionModule = modulename;
  reader9422->definitionLine = 2419;
}
adddatum2(obj9419, alloc_Undefined(), 2);
// method "isExecutable"
  struct UserObject *uo9423 = (struct UserObject*)obj9419;
  uo9423->data[3] = emptyclosure;
  Method *meth_meth_ast_isExecutable9423 = addmethod2pos(obj9419, "isExecutable", &meth_ast_isExecutable9423, 3);
  int argcv_meth_ast_isExecutable9423[] = {0};
  meth_meth_ast_isExecutable9423->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9423);
  meth_meth_ast_isExecutable9423->definitionModule = modulename;
  meth_meth_ast_isExecutable9423->definitionLine = 2420;
// method "accept()from"
  struct UserObject *uo9425 = (struct UserObject*)obj9419;
  uo9425->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9425 = addmethod2pos(obj9419, "accept()from", &meth_ast_accept_40__41_from9425, 4);
  int argcv_meth_ast_accept_40__41_from9425[] = {1, 1};
  meth_meth_ast_accept_40__41_from9425->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9425);
  meth_meth_ast_accept_40__41_from9425->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9425->definitionLine = 2423;
// method "map()ancestors"
  struct UserObject *uo9428 = (struct UserObject*)obj9419;
  uo9428->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9428 = addmethod2pos(obj9419, "map()ancestors", &meth_ast_map_40__41_ancestors9428, 5);
  int argcv_meth_ast_map_40__41_ancestors9428[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9428->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9428);
  meth_meth_ast_map_40__41_ancestors9428->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9428->definitionLine = 2426;
// method "nameString"
  struct UserObject *uo9435 = (struct UserObject*)obj9419;
  uo9435->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString9435 = addmethod2pos(obj9419, "nameString", &meth_ast_nameString9435, 6);
  int argcv_meth_ast_nameString9435[] = {0};
  meth_meth_ast_nameString9435->type = alloc_MethodType(1, argcv_meth_ast_nameString9435);
  meth_meth_ast_nameString9435->definitionModule = modulename;
  meth_meth_ast_nameString9435->definitionLine = 2431;
// method "asString"
  struct UserObject *uo9437 = (struct UserObject*)obj9419;
  uo9437->data[7] = emptyclosure;
  Method *meth_meth_ast_asString9437 = addmethod2pos(obj9419, "asString", &meth_ast_asString9437, 7);
  int argcv_meth_ast_asString9437[] = {0};
  meth_meth_ast_asString9437->type = alloc_MethodType(1, argcv_meth_ast_asString9437);
  meth_meth_ast_asString9437->definitionModule = modulename;
  meth_meth_ast_asString9437->definitionLine = 2432;
// method "toGrace"
  struct UserObject *uo9439 = (struct UserObject*)obj9419;
  uo9439->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace9439 = addmethod2pos(obj9419, "toGrace", &meth_ast_toGrace9439, 8);
  int argcv_meth_ast_toGrace9439[] = {1};
  meth_meth_ast_toGrace9439->type = alloc_MethodType(1, argcv_meth_ast_toGrace9439);
meth_meth_ast_toGrace9439->type->types[0] = type_Number;
meth_meth_ast_toGrace9439->type->names[0] = "depth";
  meth_meth_ast_toGrace9439->definitionModule = modulename;
  meth_meth_ast_toGrace9439->definitionLine = 2433;
// method "shallowCopy"
  block_savedest(obj9419);
  Object closure9441 = createclosure(1, "shallowCopy");
  setclosureframe(closure9441, stackframe);
  addtoclosure(closure9441, var_blankNode);
  struct UserObject *uo9441 = (struct UserObject*)obj9419;
  uo9441->data[9] = (Object)closure9441;
  Method *meth_meth_ast_shallowCopy9441 = addmethod2pos(obj9419, "shallowCopy", &meth_ast_shallowCopy9441, 9);
  int argcv_meth_ast_shallowCopy9441[] = {0};
  meth_meth_ast_shallowCopy9441->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9441);
  meth_meth_ast_shallowCopy9441->definitionModule = modulename;
  meth_meth_ast_shallowCopy9441->definitionLine = 2434;
  sourceObject = obj9419;
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9446 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9447 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9448 = gc_frame_new();
// call case 3: self.outer request
  Object call9449 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9448);
// compiled call node returning call9449 (depth = 7)
// compiled member node returning call9449 (depth = 6)
  partcv[0] = 0;
  Object call9450 = callmethodflags(call9449, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9447);
// compiled call node returning call9450 (depth = 5)
// compiled member node returning call9450 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9451 = callmethodflags(call9450, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9446);
// compiled call node returning call9451 (depth = 3)
  struct UserObject *obj9419_uo = (struct UserObject *)obj9419;
  obj9419_uo->super = call9451;
  sourceObject = obj9419;
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9452 == NULL) {
    strlit9452 = alloc_String("blank");
    gc_root(strlit9452);
  }
// compiled string node returning strlit9452 (depth = 3)
  adddatum2(obj9419, strlit9452, 1);
  sourceObject = obj9419;
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9453 == NULL) {
    strlit9453 = alloc_String("blank");
    gc_root(strlit9453);
  }
// compiled string node returning strlit9453 (depth = 3)
  adddatum2(obj9419, strlit9453, 2);
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  sourceObject = obj9419;
  objclass9419 = obj9419->class;
  objclass9419->definitionModule = modulename;
  objclass9419->definitionLine = 2416;
  (*(struct UserObject *)self).data[0] = lowerouter9419;
  self = oldself9419;
  selfslot = oldselfslot9419;
  stackframe = oldstackframe9419;
  gc_frame_end(frame);
  return obj9419;
}
Object meth_ast_blankNode9455(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_new9458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9459 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9460 == NULL) {
    strlit9460 = alloc_String("");
    gc_root(strlit9460);
  }
// compiled string node returning strlit9460 (depth = 4)
  gc_frame_newslot(strlit9460);
// starting to compile array node (depth = 4)
  Object array9461 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9461 (depth = 4)
  gc_frame_newslot(array9461);
// call case 4: self request
  params[0] = strlit9460;
  params[1] = array9461;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9462 = callmethodflags(self, "partName()params", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9459);
// compiled call node returning call9462 (depth = 3)
  gc_frame_end(frame);
  return call9462;
}
Object meth_ast_partName_40__41_scope9463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()scope");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName()scope (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9464 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 5)
  Object array9465 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9465 (depth = 5)
  gc_frame_newslot(array9465);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9465;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9466 = callmethodflags(self, "partName()params", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9464);
// compiled call node returning call9466 (depth = 4)
  *var_result = call9466;
  if (call9466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9467 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9468 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9467);
// compiled call node returning call9468 (depth = 3)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName_40__41_params_40__41_scope9469(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName()params()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()scope");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for partName()params()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9470 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ps (depth = 5)
  gc_frame_newslot(*var_ps);
// call case 4: self request
  params[0] = *var_n;
  params[1] = *var_ps;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9471 = callmethodflags(self, "partName()params", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9470);
// compiled call node returning call9471 (depth = 4)
  *var_result = call9471;
  if (call9471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9472 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9473 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9472);
// compiled call node returning call9473 (depth = 3)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_partName9474(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "partName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for partName (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9475 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile array node (depth = 4)
  Object array9476 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9476 (depth = 4)
  gc_frame_newslot(array9476);
// call case 4: self request
  params[0] = *var_n;
  params[1] = array9476;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9477 = callmethodflags(self, "partName()params", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9475);
// compiled call node returning call9477 (depth = 3)
  gc_frame_end(frame);
  return call9477;
}
Object meth_ast__apply9494(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object *var_newChain = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe9495 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newChain (depth = 7)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9496 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9495);
// compiled call node returning call9496 (depth = 6)
  gc_frame_end(frame);
  return call9496;
}
Object meth_ast_accept_40__41_from9486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newChain = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newChain");
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9488 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9489 = callmethod(*var_visitor, "visitSignaturePart()up",
    2, partcv, params);
  gc_frame_end(callframe9488);
// compiled call node returning call9489 (depth = 4)
  Object if9487 = done;
  if (istrue(call9489)) {
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9490 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_as (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call9491 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9490);
// compiled call node returning call9491 (depth = 5)
  *var_newChain = call9491;
  if (call9491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9492 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9493 = alloc_Block(NULL, NULL, "ast", 2467);
  gc_frame_newslot(block9493);
// method "_apply"
  block_savedest(block9493);
  Object closure9494 = createclosure(3, "_apply");
  setclosureframe(closure9494, stackframe);
  addtoclosure(closure9494, var_visitor);
  addtoclosure(closure9494, var_newChain);
  addtoclosure(closure9494, selfslot);
  struct UserObject *uo9494 = (struct UserObject*)block9493;
  uo9494->data[0] = (Object)closure9494;
  Method *meth_meth_ast__apply9494 = addmethod2pos(block9493, "_apply", &meth_ast__apply9494, 0);
  int argcv_meth_ast__apply9494[] = {1};
  meth_meth_ast__apply9494->type = alloc_MethodType(1, argcv_meth_ast__apply9494);
  meth_meth_ast__apply9494->definitionModule = modulename;
  meth_meth_ast__apply9494->definitionLine = 2417;
// compiled block node returning block9493 (depth = 5)
  gc_frame_newslot(block9493);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9498 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9499 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9498);
// compiled call node returning call9499 (depth = 6)
// compiled member node returning call9499 (depth = 5)
  params[0] = block9493;
  partcv[0] = 1;
  Object call9500 = callmethod(call9499, "do",
    1, partcv, params);
  gc_frame_end(callframe9492);
// compiled call node returning call9500 (depth = 4)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9504 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9503);
// compiled call node returning call9504 (depth = 7)
// compiled member node returning call9504 (depth = 6)
  int op_slot_right_9502 = gc_frame_newslot(call9504);
// starting to compile identifier node (depth = 6)
  Object bool9506 = alloc_Boolean(0);
// compiled identifier node returning bool9506 (depth = 6)
  int op_slot_left_9502 = gc_frame_newslot(bool9506);
  params[0] = call9504;
  partcv[0] = 1;
  Object opresult9507 = callmethod(bool9506, "≠", 1, partcv, params);
// compiled op node returning opresult9507 (depth = 5)
  Object if9501 = done;
  if (istrue(opresult9507)) {
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9508 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newChain (depth = 6)
  gc_frame_newslot(*var_newChain);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9510 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9509);
// compiled call node returning call9510 (depth = 7)
// compiled member node returning call9510 (depth = 6)
  params[0] = *var_visitor;
  params[1] = *var_newChain;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9511 = callmethod(call9510, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9508);
// compiled call node returning call9511 (depth = 5)
    gc_frame_newslot(call9511);
    if9501 = call9511;
  } else {
  }
// compiled if node returning if9501 (depth = 4)
    gc_frame_newslot(if9501);
    if9487 = if9501;
  } else {
  }
// compiled if node returning if9487 (depth = 3)
  gc_frame_end(frame);
  return if9487;
}
Object meth_ast_declarationKindWithAncestors9512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "declarationKindWithAncestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method declarationKindWithAncestors");
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for declarationKindWithAncestors (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_as = &(stackframe->slots[0]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for declarationKindWithAncestors");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9513 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  partcv[0] = 0;
  Object call9514 = callmethod(*var_k, "parameter",
    1, partcv, params);
  gc_frame_end(callframe9513);
// compiled call node returning call9514 (depth = 4)
// compiled member node returning call9514 (depth = 3)
  gc_frame_end(frame);
  return call9514;
}
Object meth_ast_map_40__41_ancestors9515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nd = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nd");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9516 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9517 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9516);
// compiled call node returning call9517 (depth = 5)
// compiled member node returning call9517 (depth = 4)
  *var_nd = call9517;
  if (call9517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nd (depth = 5)
  gc_frame_newslot(*var_nd);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_nd;
  partcv[0] = 1;
  Object call9519 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9518);
// compiled call node returning call9519 (depth = 4)
  *var_newChain = call9519;
  if (call9519 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9520 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9521 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9523 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9522);
// compiled call node returning call9523 (depth = 6)
// compiled member node returning call9523 (depth = 5)
  gc_frame_newslot(call9523);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9524 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9525 = gc_frame_new();
// call case 3: self.outer request
  Object call9526 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9525);
// compiled call node returning call9526 (depth = 8)
// compiled member node returning call9526 (depth = 7)
  partcv[0] = 0;
  Object call9527 = callmethodflags(call9526, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9524);
// compiled call node returning call9527 (depth = 6)
// compiled member node returning call9527 (depth = 5)
  params[0] = call9523;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9528 = callmethodflags(call9527, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9521);
// compiled call node returning call9528 (depth = 4)
  gc_frame_newslot(call9528);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9528;
  partcv[0] = 1;
  Object call9529 = callmethod(*var_nd, "params:=",
    1, partcv, params);
  gc_frame_end(callframe9520);
// compiled call node returning call9529 (depth = 3)
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9530 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9531 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9532 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9533 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9532);
// compiled call node returning call9533 (depth = 6)
// compiled member node returning call9533 (depth = 5)
  gc_frame_newslot(call9533);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9534 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9535 = gc_frame_new();
// call case 3: self.outer request
  Object call9536 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9535);
// compiled call node returning call9536 (depth = 8)
// compiled member node returning call9536 (depth = 7)
  partcv[0] = 0;
  Object call9537 = callmethodflags(call9536, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9534);
// compiled call node returning call9537 (depth = 6)
// compiled member node returning call9537 (depth = 5)
  params[0] = call9533;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9538 = callmethodflags(call9537, "maybeMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9531);
// compiled call node returning call9538 (depth = 4)
  gc_frame_newslot(call9538);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  params[0] = call9538;
  partcv[0] = 1;
  Object call9539 = callmethod(*var_nd, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe9530);
// compiled call node returning call9539 (depth = 3)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9540 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_nd;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9541 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9540);
// compiled call node returning call9541 (depth = 3)
  gc_frame_end(frame);
  return call9541;
}
Object meth_ast__apply9550(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9552 == NULL) {
    strlit9552 = alloc_String("  ");
    gc_root(strlit9552);
  }
// compiled string node returning strlit9552 (depth = 7)
  int op_slot_right_9551 = gc_frame_newslot(strlit9552);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9551 = gc_frame_newslot(*var_spc);
  params[0] = strlit9552;
  partcv[0] = 1;
  Object opresult9554 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9554 (depth = 6)
  *var_spc = opresult9554;
  if (opresult9554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9604(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9606 == NULL) {
    strlit9606 = alloc_String("");
    gc_root(strlit9606);
  }
// compiled string node returning strlit9606 (depth = 7)
  int op_slot_right_9605 = gc_frame_newslot(strlit9606);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9609 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9611 = alloc_Float64(2);
// compiled num node returning num9611 (depth = 10)
  int op_slot_right_9610 = gc_frame_newslot(num9611);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_9610 = gc_frame_newslot(*var_depth);
  params[0] = num9611;
  partcv[0] = 1;
  Object sum9613 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9613 (depth = 9)
  gc_frame_newslot(sum9613);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_p (depth = 9)
  params[0] = sum9613;
  partcv[0] = 1;
  Object call9614 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9609);
// compiled call node returning call9614 (depth = 8)
  int op_slot_right_9608 = gc_frame_newslot(call9614);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9617 == NULL) {
    strlit9617 = alloc_String("");
    gc_root(strlit9617);
  }
// compiled string node returning strlit9617 (depth = 9)
  int op_slot_right_9616 = gc_frame_newslot(strlit9617);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9619 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9622 == NULL) {
    strlit9622 = alloc_String("""\x0a""  ");
    gc_root(strlit9622);
  }
// compiled string node returning strlit9622 (depth = 11)
  int op_slot_right_9621 = gc_frame_newslot(strlit9622);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_9624 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit9626 == NULL) {
    strlit9626 = alloc_String("");
    gc_root(strlit9626);
  }
// compiled string node returning strlit9626 (depth = 12)
  int op_slot_left_9624 = gc_frame_newslot(strlit9626);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9627 = callmethod(strlit9626, "++", 1, partcv, params);
// compiled op node returning opresult9627 (depth = 11)
  int op_slot_left_9621 = gc_frame_newslot(opresult9627);
  params[0] = strlit9622;
  partcv[0] = 1;
  Object opresult9628 = callmethod(opresult9627, "++", 1, partcv, params);
// compiled op node returning opresult9628 (depth = 10)
  int op_slot_left_9619 = gc_frame_newslot(opresult9628);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9629 = callmethod(opresult9628, "++", 1, partcv, params);
// compiled op node returning opresult9629 (depth = 9)
  int op_slot_left_9616 = gc_frame_newslot(opresult9629);
  params[0] = strlit9617;
  partcv[0] = 1;
  Object opresult9630 = callmethod(opresult9629, "++", 1, partcv, params);
// compiled op node returning opresult9630 (depth = 8)
  int op_slot_left_9608 = gc_frame_newslot(opresult9630);
  params[0] = call9614;
  partcv[0] = 1;
  Object opresult9631 = callmethod(opresult9630, "++", 1, partcv, params);
// compiled op node returning opresult9631 (depth = 7)
  int op_slot_left_9605 = gc_frame_newslot(opresult9631);
  params[0] = strlit9606;
  partcv[0] = 1;
  Object opresult9632 = callmethod(opresult9631, "++", 1, partcv, params);
// compiled op node returning opresult9632 (depth = 6)
  *var_s = opresult9632;
  if (opresult9632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9542(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9543 == NULL) {
    strlit9543 = alloc_String("");
    gc_root(strlit9543);
  }
// compiled string node returning strlit9543 (depth = 4)
  *var_spc = strlit9543;
  if (strlit9543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9544 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_right_9545 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 5)
  Object num9547 = alloc_Float64(0);
// compiled num node returning num9547 (depth = 5)
  int op_slot_left_9545 = gc_frame_newslot(num9547);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9548 = callmethod(num9547, "..", 1, partcv, params);
// compiled op node returning opresult9548 (depth = 4)
  gc_frame_newslot(opresult9548);
// starting to compile block node (depth = 4)
  Object block9549 = alloc_Block(NULL, NULL, "ast", 2483);
  gc_frame_newslot(block9549);
// method "_apply"
  block_savedest(block9549);
  Object closure9550 = createclosure(2, "_apply");
  setclosureframe(closure9550, stackframe);
  addtoclosure(closure9550, var_spc);
  addtoclosure(closure9550, selfslot);
  struct UserObject *uo9550 = (struct UserObject*)block9549;
  uo9550->data[0] = (Object)closure9550;
  Method *meth_meth_ast__apply9550 = addmethod2pos(block9549, "_apply", &meth_ast__apply9550, 0);
  int argcv_meth_ast__apply9550[] = {1};
  meth_meth_ast__apply9550->type = alloc_MethodType(1, argcv_meth_ast__apply9550);
  meth_meth_ast__apply9550->definitionModule = modulename;
  meth_meth_ast__apply9550->definitionLine = 2478;
// compiled block node returning block9549 (depth = 4)
  gc_frame_newslot(block9549);
// call case 5: prelude request
  params[0] = opresult9548;
  params[1] = block9549;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9557 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9544);
// compiled call node returning call9557 (depth = 3)
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9559 == NULL) {
    strlit9559 = alloc_String("");
    gc_root(strlit9559);
  }
// compiled string node returning strlit9559 (depth = 5)
  int op_slot_right_9558 = gc_frame_newslot(strlit9559);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9563 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9562);
// compiled call node returning call9563 (depth = 7)
// compiled member node returning call9563 (depth = 6)
  int op_slot_right_9561 = gc_frame_newslot(call9563);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9566 == NULL) {
    strlit9566 = alloc_String(": ");
    gc_root(strlit9566);
  }
// compiled string node returning strlit9566 (depth = 7)
  int op_slot_right_9565 = gc_frame_newslot(strlit9566);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9569 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9570 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9569);
// compiled call node returning call9570 (depth = 8)
  int op_slot_right_9568 = gc_frame_newslot(call9570);
// starting to compile string node (depth = 8)
  if (strlit9572 == NULL) {
    strlit9572 = alloc_String("");
    gc_root(strlit9572);
  }
// compiled string node returning strlit9572 (depth = 8)
  int op_slot_left_9568 = gc_frame_newslot(strlit9572);
  params[0] = call9570;
  partcv[0] = 1;
  Object opresult9573 = callmethod(strlit9572, "++", 1, partcv, params);
// compiled op node returning opresult9573 (depth = 7)
  int op_slot_left_9565 = gc_frame_newslot(opresult9573);
  params[0] = strlit9566;
  partcv[0] = 1;
  Object opresult9574 = callmethod(opresult9573, "++", 1, partcv, params);
// compiled op node returning opresult9574 (depth = 6)
  int op_slot_left_9561 = gc_frame_newslot(opresult9574);
  params[0] = call9563;
  partcv[0] = 1;
  Object opresult9575 = callmethod(opresult9574, "++", 1, partcv, params);
// compiled op node returning opresult9575 (depth = 5)
  int op_slot_left_9558 = gc_frame_newslot(opresult9575);
  params[0] = strlit9559;
  partcv[0] = 1;
  Object opresult9576 = callmethod(opresult9575, "++", 1, partcv, params);
// compiled op node returning opresult9576 (depth = 4)
  *var_s = opresult9576;
  if (opresult9576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9578 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9579 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9580 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9581 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9580);
// compiled call node returning call9581 (depth = 9)
// compiled member node returning call9581 (depth = 8)
  partcv[0] = 0;
  Object call9582 = callmethod(call9581, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9579);
// compiled call node returning call9582 (depth = 7)
// compiled member node returning call9582 (depth = 6)
  partcv[0] = 0;
  Object call9583 = callmethod(call9582, "not",
    1, partcv, params);
  gc_frame_end(callframe9578);
// compiled call node returning call9583 (depth = 5)
// compiled member node returning call9583 (depth = 4)
  Object if9577 = done;
  if (istrue(call9583)) {
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9585 == NULL) {
    strlit9585 = alloc_String("Parameters:");
    gc_root(strlit9585);
  }
// compiled string node returning strlit9585 (depth = 6)
  int op_slot_right_9584 = gc_frame_newslot(strlit9585);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9587 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9590 == NULL) {
    strlit9590 = alloc_String("""\x0a""");
    gc_root(strlit9590);
  }
// compiled string node returning strlit9590 (depth = 8)
  int op_slot_right_9589 = gc_frame_newslot(strlit9590);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9592 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9594 == NULL) {
    strlit9594 = alloc_String("");
    gc_root(strlit9594);
  }
// compiled string node returning strlit9594 (depth = 9)
  int op_slot_left_9592 = gc_frame_newslot(strlit9594);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9595 = callmethod(strlit9594, "++", 1, partcv, params);
// compiled op node returning opresult9595 (depth = 8)
  int op_slot_left_9589 = gc_frame_newslot(opresult9595);
  params[0] = strlit9590;
  partcv[0] = 1;
  Object opresult9596 = callmethod(opresult9595, "++", 1, partcv, params);
// compiled op node returning opresult9596 (depth = 7)
  int op_slot_left_9587 = gc_frame_newslot(opresult9596);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9597 = callmethod(opresult9596, "++", 1, partcv, params);
// compiled op node returning opresult9597 (depth = 6)
  int op_slot_left_9584 = gc_frame_newslot(opresult9597);
  params[0] = strlit9585;
  partcv[0] = 1;
  Object opresult9598 = callmethod(opresult9597, "++", 1, partcv, params);
// compiled op node returning opresult9598 (depth = 5)
  *var_s = opresult9598;
  if (opresult9598 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9577 = done;
  } else {
  }
// compiled if node returning if9577 (depth = 3)
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9600 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9601 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9602 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9601);
// compiled call node returning call9602 (depth = 5)
// compiled member node returning call9602 (depth = 4)
  gc_frame_newslot(call9602);
// starting to compile block node (depth = 4)
  Object block9603 = alloc_Block(NULL, NULL, "ast", 2488);
  gc_frame_newslot(block9603);
// method "_apply"
  block_savedest(block9603);
  Object closure9604 = createclosure(4, "_apply");
  setclosureframe(closure9604, stackframe);
  addtoclosure(closure9604, var_depth);
  addtoclosure(closure9604, var_spc);
  addtoclosure(closure9604, var_s);
  addtoclosure(closure9604, selfslot);
  struct UserObject *uo9604 = (struct UserObject*)block9603;
  uo9604->data[0] = (Object)closure9604;
  Method *meth_meth_ast__apply9604 = addmethod2pos(block9603, "_apply", &meth_ast__apply9604, 0);
  int argcv_meth_ast__apply9604[] = {1};
  meth_meth_ast__apply9604->type = alloc_MethodType(1, argcv_meth_ast__apply9604);
  meth_meth_ast__apply9604->definitionModule = modulename;
  meth_meth_ast__apply9604->definitionLine = 2488;
// compiled block node returning block9603 (depth = 4)
  gc_frame_newslot(block9603);
// call case 5: prelude request
  params[0] = call9602;
  params[1] = block9603;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9635 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9600);
// compiled call node returning call9635 (depth = 3)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9638 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9639 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9638);
// compiled call node returning call9639 (depth = 6)
// compiled member node returning call9639 (depth = 5)
  int op_slot_right_9637 = gc_frame_newslot(call9639);
// starting to compile identifier node (depth = 5)
  Object bool9641 = alloc_Boolean(0);
// compiled identifier node returning bool9641 (depth = 5)
  int op_slot_left_9637 = gc_frame_newslot(bool9641);
  params[0] = call9639;
  partcv[0] = 1;
  Object opresult9642 = callmethod(bool9641, "≠", 1, partcv, params);
// compiled op node returning opresult9642 (depth = 4)
  Object if9636 = done;
  if (istrue(opresult9642)) {
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9644 == NULL) {
    strlit9644 = alloc_String("");
    gc_root(strlit9644);
  }
// compiled string node returning strlit9644 (depth = 6)
  int op_slot_right_9643 = gc_frame_newslot(strlit9644);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9647 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9649 = alloc_Float64(1);
// compiled num node returning num9649 (depth = 9)
  int op_slot_right_9648 = gc_frame_newslot(num9649);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_9648 = gc_frame_newslot(*var_depth);
  params[0] = num9649;
  partcv[0] = 1;
  Object sum9651 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9651 (depth = 8)
  gc_frame_newslot(sum9651);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9653 = callmethodflags(self, "typeParams", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9652);
// compiled call node returning call9653 (depth = 9)
// compiled member node returning call9653 (depth = 8)
  params[0] = sum9651;
  partcv[0] = 1;
  Object call9654 = callmethod(call9653, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9647);
// compiled call node returning call9654 (depth = 7)
  int op_slot_right_9646 = gc_frame_newslot(call9654);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9657 == NULL) {
    strlit9657 = alloc_String("TypeParams: ");
    gc_root(strlit9657);
  }
// compiled string node returning strlit9657 (depth = 8)
  int op_slot_right_9656 = gc_frame_newslot(strlit9657);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_9659 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9662 == NULL) {
    strlit9662 = alloc_String("""\x0a""  ");
    gc_root(strlit9662);
  }
// compiled string node returning strlit9662 (depth = 10)
  int op_slot_right_9661 = gc_frame_newslot(strlit9662);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_9664 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit9666 == NULL) {
    strlit9666 = alloc_String("");
    gc_root(strlit9666);
  }
// compiled string node returning strlit9666 (depth = 11)
  int op_slot_left_9664 = gc_frame_newslot(strlit9666);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9667 = callmethod(strlit9666, "++", 1, partcv, params);
// compiled op node returning opresult9667 (depth = 10)
  int op_slot_left_9661 = gc_frame_newslot(opresult9667);
  params[0] = strlit9662;
  partcv[0] = 1;
  Object opresult9668 = callmethod(opresult9667, "++", 1, partcv, params);
// compiled op node returning opresult9668 (depth = 9)
  int op_slot_left_9659 = gc_frame_newslot(opresult9668);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9669 = callmethod(opresult9668, "++", 1, partcv, params);
// compiled op node returning opresult9669 (depth = 8)
  int op_slot_left_9656 = gc_frame_newslot(opresult9669);
  params[0] = strlit9657;
  partcv[0] = 1;
  Object opresult9670 = callmethod(opresult9669, "++", 1, partcv, params);
// compiled op node returning opresult9670 (depth = 7)
  int op_slot_left_9646 = gc_frame_newslot(opresult9670);
  params[0] = call9654;
  partcv[0] = 1;
  Object opresult9671 = callmethod(opresult9670, "++", 1, partcv, params);
// compiled op node returning opresult9671 (depth = 6)
  int op_slot_left_9643 = gc_frame_newslot(opresult9671);
  params[0] = strlit9644;
  partcv[0] = 1;
  Object opresult9672 = callmethod(opresult9671, "++", 1, partcv, params);
// compiled op node returning opresult9672 (depth = 5)
  *var_s = opresult9672;
  if (opresult9672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9636 = done;
  } else {
  }
// compiled if node returning if9636 (depth = 3)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy9674(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9675 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9676 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9678 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9677);
// compiled call node returning call9678 (depth = 6)
// compiled member node returning call9678 (depth = 5)
  gc_frame_newslot(call9678);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9679 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9680 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9679);
// compiled call node returning call9680 (depth = 6)
// compiled member node returning call9680 (depth = 5)
  gc_frame_newslot(call9680);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signaturePart (depth = 5)
  params[0] = call9678;
  params[1] = call9680;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9681 = callmethod(*var_signaturePart, "partName()params",
    2, partcv, params);
  gc_frame_end(callframe9676);
// compiled call node returning call9681 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9682 = callmethod(call9681, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9675);
// compiled call node returning call9682 (depth = 3)
  gc_frame_end(frame);
  return call9682;
}
Object meth_ast_shallowCopyFieldsFrom9683(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9684 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9685 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9684);
// compiled call node returning call9685 (depth = 3)
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9686 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9688 = callmethod(*var_other, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe9687);
// compiled call node returning call9688 (depth = 5)
// compiled member node returning call9688 (depth = 4)
  gc_frame_newslot(call9688);
// call case 4: self request
  params[0] = call9688;
  partcv[0] = 1;
  Object call9689 = callmethodflags(self, "typeParams:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9686);
// compiled call node returning call9689 (depth = 3)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9690 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9692 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe9691);
// compiled call node returning call9692 (depth = 5)
// compiled member node returning call9692 (depth = 4)
  gc_frame_newslot(call9692);
// call case 4: self request
  params[0] = call9692;
  partcv[0] = 1;
  Object call9693 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9690);
// compiled call node returning call9693 (depth = 3)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString9694(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9696 == NULL) {
    strlit9696 = alloc_String("");
    gc_root(strlit9696);
  }
// compiled string node returning strlit9696 (depth = 4)
  int op_slot_right_9695 = gc_frame_newslot(strlit9696);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9700 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9699);
// compiled call node returning call9700 (depth = 6)
// compiled member node returning call9700 (depth = 5)
  int op_slot_right_9698 = gc_frame_newslot(call9700);
// starting to compile string node (depth = 5)
  if (strlit9702 == NULL) {
    strlit9702 = alloc_String("part: ");
    gc_root(strlit9702);
  }
// compiled string node returning strlit9702 (depth = 5)
  int op_slot_left_9698 = gc_frame_newslot(strlit9702);
  params[0] = call9700;
  partcv[0] = 1;
  Object opresult9703 = callmethod(strlit9702, "++", 1, partcv, params);
// compiled op node returning opresult9703 (depth = 4)
  int op_slot_left_9695 = gc_frame_newslot(opresult9703);
  params[0] = strlit9696;
  partcv[0] = 1;
  Object opresult9704 = callmethod(opresult9703, "++", 1, partcv, params);
// compiled op node returning opresult9704 (depth = 3)
  gc_frame_end(frame);
  return opresult9704;
}
Object meth_ast_partName_40__41_params9478(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName()params");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName()params (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9479 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9479 = alloc_userobj2(16,13, objclass9479);
  gc_frame_newslot(obj9479);
if (objclass9479 == NULL) {
  glfree(obj9479->class->name);
  obj9479->class->name = "signaturePart.partName()params";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9479, self, 0);
  addmethodreal(obj9479,"outer", &reader_ast_outer_9480);
  Object oldself9479 = self;
  struct StackFrameObject *oldstackframe9479 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9479);
  gc_frame_newslot((Object)stackframe);
  self = obj9479;
  Object *oldselfslot9479 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9479 = (*(struct UserObject *)self).data[0], lowerouter9479 = thisouter9479;
  if (inheritingObject9479) {
    struct UserObject *inho9479 = (struct UserObject *)inheritingObject9479;
    while (inho9479->super != GraceDefaultObject) inho9479 = (struct UserObject *)inho9479->super;
    inho9479->super = obj9479;
    self = inheritingObject9479;
    *selfslot = self;
    lowerouter9479 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9479;
  }
if (objclass9479 == NULL) {
  Method *reader9481 = addmethodrealflags(obj9479, "kind",&reader_ast_kind_9481, MFLAG_DEF);
  reader9481->definitionModule = modulename;
  reader9481->definitionLine = 2458;
}
adddatum2(obj9479, alloc_Undefined(), 1);
if (objclass9479 == NULL) {
  Method *reader9482 = addmethodrealflags(obj9479, "name",&reader_ast_name_9482, 0);
  Method *writer9482 = addmethodrealflags(obj9479, "name:=",&writer_ast_name_9482, 0);
  reader9482->definitionModule = modulename;
  writer9482->definitionModule = modulename;
  reader9482->definitionLine = 2459;
  writer9482->definitionLine = 2459;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 2);
if (objclass9479 == NULL) {
  Method *reader9483 = addmethodrealflags(obj9479, "params",&reader_ast_params_9483, 0);
  Method *writer9483 = addmethodrealflags(obj9479, "params:=",&writer_ast_params_9483, 0);
  reader9483->definitionModule = modulename;
  writer9483->definitionModule = modulename;
  reader9483->definitionLine = 2460;
  writer9483->definitionLine = 2460;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 3);
if (objclass9479 == NULL) {
  Method *reader9484 = addmethodrealflags(obj9479, "typeParams",&reader_ast_typeParams_9484, 0);
  Method *writer9484 = addmethodrealflags(obj9479, "typeParams:=",&writer_ast_typeParams_9484, 0);
  reader9484->definitionModule = modulename;
  writer9484->definitionModule = modulename;
  reader9484->definitionLine = 2461;
  writer9484->definitionLine = 2461;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 4);
if (objclass9479 == NULL) {
  Method *reader9485 = addmethodrealflags(obj9479, "lineLength",&reader_ast_lineLength_9485, 0);
  Method *writer9485 = addmethodrealflags(obj9479, "lineLength:=",&writer_ast_lineLength_9485, 0);
  reader9485->definitionModule = modulename;
  writer9485->definitionModule = modulename;
  reader9485->definitionLine = 2462;
  writer9485->definitionLine = 2462;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 5);
// method "accept()from"
  struct UserObject *uo9486 = (struct UserObject*)obj9479;
  uo9486->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9486 = addmethod2pos(obj9479, "accept()from", &meth_ast_accept_40__41_from9486, 6);
  int argcv_meth_ast_accept_40__41_from9486[] = {1, 1};
  meth_meth_ast_accept_40__41_from9486->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9486);
  meth_meth_ast_accept_40__41_from9486->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9486->definitionLine = 2464;
// method "declarationKindWithAncestors"
  block_savedest(obj9479);
  Object closure9512 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9512, stackframe);
  addtoclosure(closure9512, var_k);
  struct UserObject *uo9512 = (struct UserObject*)obj9479;
  uo9512->data[7] = (Object)closure9512;
  Method *meth_meth_ast_declarationKindWithAncestors9512 = addmethod2pos(obj9479, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9512, 7);
  int argcv_meth_ast_declarationKindWithAncestors9512[] = {1};
  meth_meth_ast_declarationKindWithAncestors9512->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9512);
  meth_meth_ast_declarationKindWithAncestors9512->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9512->definitionLine = 2473;
// method "map()ancestors"
  struct UserObject *uo9515 = (struct UserObject*)obj9479;
  uo9515->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9515 = addmethod2pos(obj9479, "map()ancestors", &meth_ast_map_40__41_ancestors9515, 8);
  int argcv_meth_ast_map_40__41_ancestors9515[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9515->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9515);
  meth_meth_ast_map_40__41_ancestors9515->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9515->definitionLine = 2474;
// method "pretty"
  struct UserObject *uo9542 = (struct UserObject*)obj9479;
  uo9542->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9542 = addmethod2pos(obj9479, "pretty", &meth_ast_pretty9542, 9);
  int argcv_meth_ast_pretty9542[] = {1};
  meth_meth_ast_pretty9542->type = alloc_MethodType(1, argcv_meth_ast_pretty9542);
  meth_meth_ast_pretty9542->definitionModule = modulename;
  meth_meth_ast_pretty9542->definitionLine = 2481;
// method "shallowCopy"
  block_savedest(obj9479);
  Object closure9674 = createclosure(1, "shallowCopy");
  setclosureframe(closure9674, stackframe);
  addtoclosure(closure9674, var_signaturePart);
  struct UserObject *uo9674 = (struct UserObject*)obj9479;
  uo9674->data[10] = (Object)closure9674;
  Method *meth_meth_ast_shallowCopy9674 = addmethod2pos(obj9479, "shallowCopy", &meth_ast_shallowCopy9674, 10);
  int argcv_meth_ast_shallowCopy9674[] = {0};
  meth_meth_ast_shallowCopy9674->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9674);
  meth_meth_ast_shallowCopy9674->definitionModule = modulename;
  meth_meth_ast_shallowCopy9674->definitionLine = 2496;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9683 = (struct UserObject*)obj9479;
  uo9683->data[11] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9683 = addmethod2pos(obj9479, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9683, 11);
  int argcv_meth_ast_shallowCopyFieldsFrom9683[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9683->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9683);
  meth_meth_ast_shallowCopyFieldsFrom9683->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9683->definitionLine = 2500;
// method "asString"
  struct UserObject *uo9694 = (struct UserObject*)obj9479;
  uo9694->data[12] = emptyclosure;
  Method *meth_meth_ast_asString9694 = addmethod2pos(obj9479, "asString", &meth_ast_asString9694, 12);
  int argcv_meth_ast_asString9694[] = {0};
  meth_meth_ast_asString9694->type = alloc_MethodType(1, argcv_meth_ast_asString9694);
  meth_meth_ast_asString9694->definitionModule = modulename;
  meth_meth_ast_asString9694->definitionLine = 2506;
  sourceObject = obj9479;
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9705 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9706 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9707 = gc_frame_new();
// call case 3: self.outer request
  Object call9708 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9707);
// compiled call node returning call9708 (depth = 7)
// compiled member node returning call9708 (depth = 6)
  partcv[0] = 0;
  Object call9709 = callmethodflags(call9708, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9706);
// compiled call node returning call9709 (depth = 5)
// compiled member node returning call9709 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9710 = callmethodflags(call9709, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9705);
// compiled call node returning call9710 (depth = 3)
  struct UserObject *obj9479_uo = (struct UserObject *)obj9479;
  obj9479_uo->super = call9710;
  sourceObject = obj9479;
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9711 == NULL) {
    strlit9711 = alloc_String("signaturepart");
    gc_root(strlit9711);
  }
// compiled string node returning strlit9711 (depth = 3)
  adddatum2(obj9479, strlit9711, 1);
  sourceObject = obj9479;
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9479, *var_n, 2);
  sourceObject = obj9479;
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9479, *var_ps, 3);
  sourceObject = obj9479;
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9712 = alloc_Boolean(0);
// compiled identifier node returning bool9712 (depth = 3)
  adddatum2(obj9479, bool9712, 4);
  sourceObject = obj9479;
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9713 = alloc_Float64(0);
// compiled num node returning num9713 (depth = 3)
  adddatum2(obj9479, num9713, 5);
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  objclass9479 = obj9479->class;
  objclass9479->definitionModule = modulename;
  objclass9479->definitionLine = 2456;
  (*(struct UserObject *)self).data[0] = lowerouter9479;
  self = oldself9479;
  selfslot = oldselfslot9479;
  stackframe = oldstackframe9479;
  gc_frame_end(frame);
  return obj9479;
}
Object meth_ast_partName_40__41_params9478_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "partName()params()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method partName()params()object");
  Object params[1];
  int partcv[2];
  Object *var_k = getfromclosure(closure, 0);
  Object *var_signaturePart = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for partName()params (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for partName");
  Object *var_ps = &(stackframe->slots[1]);
  *var_ps = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for params");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9479 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9479 = alloc_userobj2(16,13, objclass9479);
  gc_frame_newslot(obj9479);
if (objclass9479 == NULL) {
  glfree(obj9479->class->name);
  obj9479->class->name = "signaturePart.partName()params";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9479, self, 0);
  addmethodreal(obj9479,"outer", &reader_ast_outer_9480);
  Object oldself9479 = self;
  struct StackFrameObject *oldstackframe9479 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9479);
  gc_frame_newslot((Object)stackframe);
  self = obj9479;
  Object *oldselfslot9479 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9479 = (*(struct UserObject *)self).data[0], lowerouter9479 = thisouter9479;
  if (inheritingObject9479) {
    struct UserObject *inho9479 = (struct UserObject *)inheritingObject9479;
    while (inho9479->super != GraceDefaultObject) inho9479 = (struct UserObject *)inho9479->super;
    inho9479->super = obj9479;
    self = inheritingObject9479;
    *selfslot = self;
    lowerouter9479 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9479;
  }
if (objclass9479 == NULL) {
  Method *reader9481 = addmethodrealflags(obj9479, "kind",&reader_ast_kind_9481, MFLAG_DEF);
  reader9481->definitionModule = modulename;
  reader9481->definitionLine = 2458;
}
adddatum2(obj9479, alloc_Undefined(), 1);
if (objclass9479 == NULL) {
  Method *reader9482 = addmethodrealflags(obj9479, "name",&reader_ast_name_9482, 0);
  Method *writer9482 = addmethodrealflags(obj9479, "name:=",&writer_ast_name_9482, 0);
  reader9482->definitionModule = modulename;
  writer9482->definitionModule = modulename;
  reader9482->definitionLine = 2459;
  writer9482->definitionLine = 2459;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 2);
if (objclass9479 == NULL) {
  Method *reader9483 = addmethodrealflags(obj9479, "params",&reader_ast_params_9483, 0);
  Method *writer9483 = addmethodrealflags(obj9479, "params:=",&writer_ast_params_9483, 0);
  reader9483->definitionModule = modulename;
  writer9483->definitionModule = modulename;
  reader9483->definitionLine = 2460;
  writer9483->definitionLine = 2460;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 3);
if (objclass9479 == NULL) {
  Method *reader9484 = addmethodrealflags(obj9479, "typeParams",&reader_ast_typeParams_9484, 0);
  Method *writer9484 = addmethodrealflags(obj9479, "typeParams:=",&writer_ast_typeParams_9484, 0);
  reader9484->definitionModule = modulename;
  writer9484->definitionModule = modulename;
  reader9484->definitionLine = 2461;
  writer9484->definitionLine = 2461;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 4);
if (objclass9479 == NULL) {
  Method *reader9485 = addmethodrealflags(obj9479, "lineLength",&reader_ast_lineLength_9485, 0);
  Method *writer9485 = addmethodrealflags(obj9479, "lineLength:=",&writer_ast_lineLength_9485, 0);
  reader9485->definitionModule = modulename;
  writer9485->definitionModule = modulename;
  reader9485->definitionLine = 2462;
  writer9485->definitionLine = 2462;
}
obj9479->flags |= OFLAG_MUTABLE;
adddatum2(obj9479, alloc_Undefined(), 5);
// method "accept()from"
  struct UserObject *uo9486 = (struct UserObject*)obj9479;
  uo9486->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9486 = addmethod2pos(obj9479, "accept()from", &meth_ast_accept_40__41_from9486, 6);
  int argcv_meth_ast_accept_40__41_from9486[] = {1, 1};
  meth_meth_ast_accept_40__41_from9486->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9486);
  meth_meth_ast_accept_40__41_from9486->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9486->definitionLine = 2464;
// method "declarationKindWithAncestors"
  block_savedest(obj9479);
  Object closure9512 = createclosure(1, "declarationKindWithAncestors");
  setclosureframe(closure9512, stackframe);
  addtoclosure(closure9512, var_k);
  struct UserObject *uo9512 = (struct UserObject*)obj9479;
  uo9512->data[7] = (Object)closure9512;
  Method *meth_meth_ast_declarationKindWithAncestors9512 = addmethod2pos(obj9479, "declarationKindWithAncestors", &meth_ast_declarationKindWithAncestors9512, 7);
  int argcv_meth_ast_declarationKindWithAncestors9512[] = {1};
  meth_meth_ast_declarationKindWithAncestors9512->type = alloc_MethodType(1, argcv_meth_ast_declarationKindWithAncestors9512);
  meth_meth_ast_declarationKindWithAncestors9512->definitionModule = modulename;
  meth_meth_ast_declarationKindWithAncestors9512->definitionLine = 2473;
// method "map()ancestors"
  struct UserObject *uo9515 = (struct UserObject*)obj9479;
  uo9515->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9515 = addmethod2pos(obj9479, "map()ancestors", &meth_ast_map_40__41_ancestors9515, 8);
  int argcv_meth_ast_map_40__41_ancestors9515[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9515->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9515);
  meth_meth_ast_map_40__41_ancestors9515->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9515->definitionLine = 2474;
// method "pretty"
  struct UserObject *uo9542 = (struct UserObject*)obj9479;
  uo9542->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9542 = addmethod2pos(obj9479, "pretty", &meth_ast_pretty9542, 9);
  int argcv_meth_ast_pretty9542[] = {1};
  meth_meth_ast_pretty9542->type = alloc_MethodType(1, argcv_meth_ast_pretty9542);
  meth_meth_ast_pretty9542->definitionModule = modulename;
  meth_meth_ast_pretty9542->definitionLine = 2481;
// method "shallowCopy"
  block_savedest(obj9479);
  Object closure9674 = createclosure(1, "shallowCopy");
  setclosureframe(closure9674, stackframe);
  addtoclosure(closure9674, var_signaturePart);
  struct UserObject *uo9674 = (struct UserObject*)obj9479;
  uo9674->data[10] = (Object)closure9674;
  Method *meth_meth_ast_shallowCopy9674 = addmethod2pos(obj9479, "shallowCopy", &meth_ast_shallowCopy9674, 10);
  int argcv_meth_ast_shallowCopy9674[] = {0};
  meth_meth_ast_shallowCopy9674->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9674);
  meth_meth_ast_shallowCopy9674->definitionModule = modulename;
  meth_meth_ast_shallowCopy9674->definitionLine = 2496;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9683 = (struct UserObject*)obj9479;
  uo9683->data[11] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9683 = addmethod2pos(obj9479, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9683, 11);
  int argcv_meth_ast_shallowCopyFieldsFrom9683[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9683->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9683);
  meth_meth_ast_shallowCopyFieldsFrom9683->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9683->definitionLine = 2500;
// method "asString"
  struct UserObject *uo9694 = (struct UserObject*)obj9479;
  uo9694->data[12] = emptyclosure;
  Method *meth_meth_ast_asString9694 = addmethod2pos(obj9479, "asString", &meth_ast_asString9694, 12);
  int argcv_meth_ast_asString9694[] = {0};
  meth_meth_ast_asString9694->type = alloc_MethodType(1, argcv_meth_ast_asString9694);
  meth_meth_ast_asString9694->definitionModule = modulename;
  meth_meth_ast_asString9694->definitionLine = 2506;
  sourceObject = obj9479;
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9705 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9706 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9707 = gc_frame_new();
// call case 3: self.outer request
  Object call9708 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9707);
// compiled call node returning call9708 (depth = 7)
// compiled member node returning call9708 (depth = 6)
  partcv[0] = 0;
  Object call9709 = callmethodflags(call9708, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9706);
// compiled call node returning call9709 (depth = 5)
// compiled member node returning call9709 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9710 = callmethodflags(call9709, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9705);
// compiled call node returning call9710 (depth = 3)
  struct UserObject *obj9479_uo = (struct UserObject *)obj9479;
  obj9479_uo->super = call9710;
  sourceObject = obj9479;
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9711 == NULL) {
    strlit9711 = alloc_String("signaturepart");
    gc_root(strlit9711);
  }
// compiled string node returning strlit9711 (depth = 3)
  adddatum2(obj9479, strlit9711, 1);
  sourceObject = obj9479;
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  adddatum2(obj9479, *var_n, 2);
  sourceObject = obj9479;
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ps (depth = 3)
  adddatum2(obj9479, *var_ps, 3);
  sourceObject = obj9479;
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9712 = alloc_Boolean(0);
// compiled identifier node returning bool9712 (depth = 3)
  adddatum2(obj9479, bool9712, 4);
  sourceObject = obj9479;
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9713 = alloc_Float64(0);
// compiled num node returning num9713 (depth = 3)
  adddatum2(obj9479, num9713, 5);
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  sourceObject = obj9479;
  objclass9479 = obj9479->class;
  objclass9479->definitionModule = modulename;
  objclass9479->definitionLine = 2456;
  (*(struct UserObject *)self).data[0] = lowerouter9479;
  self = oldself9479;
  selfslot = oldselfslot9479;
  stackframe = oldstackframe9479;
  gc_frame_end(frame);
  return obj9479;
}
Object meth_ast_signaturePart9715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for signaturePart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_new9718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9719 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9720 == NULL) {
    strlit9720 = alloc_String("");
    gc_root(strlit9720);
  }
// compiled string node returning strlit9720 (depth = 4)
  gc_frame_newslot(strlit9720);
// starting to compile array node (depth = 4)
  Object array9721 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9721 (depth = 4)
  gc_frame_newslot(array9721);
// call case 4: self request
  params[0] = strlit9720;
  params[1] = array9721;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9722 = callmethodflags(self, "request()withArgs", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9719);
// compiled call node returning call9722 (depth = 3)
  gc_frame_end(frame);
  return call9722;
}
Object meth_ast_request_40__41_withArgs_40__41_scope9723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "request()withArgs()scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()scope");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs()scope (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_argList = &(stackframe->slots[1]);
  *var_argList = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "result");
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9724 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_argList (depth = 5)
  gc_frame_newslot(*var_argList);
// call case 4: self request
  params[0] = *var_name;
  params[1] = *var_argList;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9725 = callmethodflags(self, "request()withArgs", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9724);
// compiled call node returning call9725 (depth = 4)
  *var_result = call9725;
  if (call9725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9726 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call9727 = callmethod(*var_result, "scope:=",
    1, partcv, params);
  gc_frame_end(callframe9726);
// compiled call node returning call9727 (depth = 3)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_result (depth = 3)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_ast_map_40__41_ancestors9735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9737 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9736);
// compiled call node returning call9737 (depth = 5)
// compiled member node returning call9737 (depth = 4)
  *var_n = call9737;
  if (call9737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9738 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9739 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9738);
// compiled call node returning call9739 (depth = 4)
  *var_newChain = call9739;
  if (call9739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9740 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe9741 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9743 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9742);
// compiled call node returning call9743 (depth = 6)
// compiled member node returning call9743 (depth = 5)
  gc_frame_newslot(call9743);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blk (depth = 5)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newChain (depth = 5)
  gc_frame_newslot(*var_newChain);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9744 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9745 = gc_frame_new();
// call case 3: self.outer request
  Object call9746 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9745);
// compiled call node returning call9746 (depth = 8)
// compiled member node returning call9746 (depth = 7)
  partcv[0] = 0;
  Object call9747 = callmethodflags(call9746, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9744);
// compiled call node returning call9747 (depth = 6)
// compiled member node returning call9747 (depth = 5)
  params[0] = call9743;
  params[1] = *var_blk;
  params[2] = *var_newChain;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9748 = callmethodflags(call9747, "listMap()ancestors", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9741);
// compiled call node returning call9748 (depth = 4)
  gc_frame_newslot(call9748);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = call9748;
  partcv[0] = 1;
  Object call9749 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe9740);
// compiled call node returning call9749 (depth = 3)
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9750 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9751 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9750);
// compiled call node returning call9751 (depth = 3)
  gc_frame_end(frame);
  return call9751;
}
Object meth_ast__apply9760(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9762 == NULL) {
    strlit9762 = alloc_String("  ");
    gc_root(strlit9762);
  }
// compiled string node returning strlit9762 (depth = 7)
  int op_slot_right_9761 = gc_frame_newslot(strlit9762);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_left_9761 = gc_frame_newslot(*var_spc);
  params[0] = strlit9762;
  partcv[0] = 1;
  Object opresult9764 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9764 (depth = 6)
  *var_spc = opresult9764;
  if (opresult9764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9809 == NULL) {
    strlit9809 = alloc_String("");
    gc_root(strlit9809);
  }
// compiled string node returning strlit9809 (depth = 7)
  int op_slot_right_9808 = gc_frame_newslot(strlit9809);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9812 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9814 = alloc_Float64(4);
// compiled num node returning num9814 (depth = 10)
  int op_slot_right_9813 = gc_frame_newslot(num9814);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_9813 = gc_frame_newslot(*var_depth);
  params[0] = num9814;
  partcv[0] = 1;
  Object sum9816 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9816 (depth = 9)
  gc_frame_newslot(sum9816);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  params[0] = sum9816;
  partcv[0] = 1;
  Object call9817 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9812);
// compiled call node returning call9817 (depth = 8)
  int op_slot_right_9811 = gc_frame_newslot(call9817);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9820 == NULL) {
    strlit9820 = alloc_String("");
    gc_root(strlit9820);
  }
// compiled string node returning strlit9820 (depth = 9)
  int op_slot_right_9819 = gc_frame_newslot(strlit9820);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9822 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9825 == NULL) {
    strlit9825 = alloc_String("""\x0a""    ");
    gc_root(strlit9825);
  }
// compiled string node returning strlit9825 (depth = 11)
  int op_slot_right_9824 = gc_frame_newslot(strlit9825);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_9827 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit9829 == NULL) {
    strlit9829 = alloc_String("");
    gc_root(strlit9829);
  }
// compiled string node returning strlit9829 (depth = 12)
  int op_slot_left_9827 = gc_frame_newslot(strlit9829);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9830 = callmethod(strlit9829, "++", 1, partcv, params);
// compiled op node returning opresult9830 (depth = 11)
  int op_slot_left_9824 = gc_frame_newslot(opresult9830);
  params[0] = strlit9825;
  partcv[0] = 1;
  Object opresult9831 = callmethod(opresult9830, "++", 1, partcv, params);
// compiled op node returning opresult9831 (depth = 10)
  int op_slot_left_9822 = gc_frame_newslot(opresult9831);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9832 = callmethod(opresult9831, "++", 1, partcv, params);
// compiled op node returning opresult9832 (depth = 9)
  int op_slot_left_9819 = gc_frame_newslot(opresult9832);
  params[0] = strlit9820;
  partcv[0] = 1;
  Object opresult9833 = callmethod(opresult9832, "++", 1, partcv, params);
// compiled op node returning opresult9833 (depth = 8)
  int op_slot_left_9811 = gc_frame_newslot(opresult9833);
  params[0] = call9817;
  partcv[0] = 1;
  Object opresult9834 = callmethod(opresult9833, "++", 1, partcv, params);
// compiled op node returning opresult9834 (depth = 7)
  int op_slot_left_9808 = gc_frame_newslot(opresult9834);
  params[0] = strlit9809;
  partcv[0] = 1;
  Object opresult9835 = callmethod(opresult9834, "++", 1, partcv, params);
// compiled op node returning opresult9835 (depth = 6)
  *var_s = opresult9835;
  if (opresult9835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9752(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9753 == NULL) {
    strlit9753 = alloc_String("");
    gc_root(strlit9753);
  }
// compiled string node returning strlit9753 (depth = 4)
  *var_spc = strlit9753;
  if (strlit9753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9754 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9756 = alloc_Float64(1);
// compiled num node returning num9756 (depth = 5)
  int op_slot_right_9755 = gc_frame_newslot(num9756);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_9755 = gc_frame_newslot(*var_depth);
  params[0] = num9756;
  partcv[0] = 1;
  Object sum9758 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9758 (depth = 4)
  gc_frame_newslot(sum9758);
// starting to compile block node (depth = 4)
  Object block9759 = alloc_Block(NULL, NULL, "ast", 2536);
  gc_frame_newslot(block9759);
// method "_apply"
  block_savedest(block9759);
  Object closure9760 = createclosure(2, "_apply");
  setclosureframe(closure9760, stackframe);
  addtoclosure(closure9760, var_spc);
  addtoclosure(closure9760, selfslot);
  struct UserObject *uo9760 = (struct UserObject*)block9759;
  uo9760->data[0] = (Object)closure9760;
  Method *meth_meth_ast__apply9760 = addmethod2pos(block9759, "_apply", &meth_ast__apply9760, 0);
  int argcv_meth_ast__apply9760[] = {0};
  meth_meth_ast__apply9760->type = alloc_MethodType(1, argcv_meth_ast__apply9760);
  meth_meth_ast__apply9760->definitionModule = modulename;
  meth_meth_ast__apply9760->definitionLine = 2531;
// compiled block node returning block9759 (depth = 4)
  gc_frame_newslot(block9759);
// call case 5: prelude request
  params[0] = sum9758;
  params[1] = block9759;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9767 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9754);
// compiled call node returning call9767 (depth = 3)
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9769 == NULL) {
    strlit9769 = alloc_String("");
    gc_root(strlit9769);
  }
// compiled string node returning strlit9769 (depth = 5)
  int op_slot_right_9768 = gc_frame_newslot(strlit9769);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9773 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9772);
// compiled call node returning call9773 (depth = 7)
// compiled member node returning call9773 (depth = 6)
  int op_slot_right_9771 = gc_frame_newslot(call9773);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9776 == NULL) {
    strlit9776 = alloc_String(": ");
    gc_root(strlit9776);
  }
// compiled string node returning strlit9776 (depth = 7)
  int op_slot_right_9775 = gc_frame_newslot(strlit9776);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9779 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9780 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9779);
// compiled call node returning call9780 (depth = 8)
  int op_slot_right_9778 = gc_frame_newslot(call9780);
// starting to compile string node (depth = 8)
  if (strlit9782 == NULL) {
    strlit9782 = alloc_String("");
    gc_root(strlit9782);
  }
// compiled string node returning strlit9782 (depth = 8)
  int op_slot_left_9778 = gc_frame_newslot(strlit9782);
  params[0] = call9780;
  partcv[0] = 1;
  Object opresult9783 = callmethod(strlit9782, "++", 1, partcv, params);
// compiled op node returning opresult9783 (depth = 7)
  int op_slot_left_9775 = gc_frame_newslot(opresult9783);
  params[0] = strlit9776;
  partcv[0] = 1;
  Object opresult9784 = callmethod(opresult9783, "++", 1, partcv, params);
// compiled op node returning opresult9784 (depth = 6)
  int op_slot_left_9771 = gc_frame_newslot(opresult9784);
  params[0] = call9773;
  partcv[0] = 1;
  Object opresult9785 = callmethod(opresult9784, "++", 1, partcv, params);
// compiled op node returning opresult9785 (depth = 5)
  int op_slot_left_9768 = gc_frame_newslot(opresult9785);
  params[0] = strlit9769;
  partcv[0] = 1;
  Object opresult9786 = callmethod(opresult9785, "++", 1, partcv, params);
// compiled op node returning opresult9786 (depth = 4)
  *var_s = opresult9786;
  if (opresult9786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9788 == NULL) {
    strlit9788 = alloc_String("Args:");
    gc_root(strlit9788);
  }
// compiled string node returning strlit9788 (depth = 5)
  int op_slot_right_9787 = gc_frame_newslot(strlit9788);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_right_9790 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9793 == NULL) {
    strlit9793 = alloc_String("""\x0a""    ");
    gc_root(strlit9793);
  }
// compiled string node returning strlit9793 (depth = 7)
  int op_slot_right_9792 = gc_frame_newslot(strlit9793);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_right_9795 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 8)
  if (strlit9797 == NULL) {
    strlit9797 = alloc_String("");
    gc_root(strlit9797);
  }
// compiled string node returning strlit9797 (depth = 8)
  int op_slot_left_9795 = gc_frame_newslot(strlit9797);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9798 = callmethod(strlit9797, "++", 1, partcv, params);
// compiled op node returning opresult9798 (depth = 7)
  int op_slot_left_9792 = gc_frame_newslot(opresult9798);
  params[0] = strlit9793;
  partcv[0] = 1;
  Object opresult9799 = callmethod(opresult9798, "++", 1, partcv, params);
// compiled op node returning opresult9799 (depth = 6)
  int op_slot_left_9790 = gc_frame_newslot(opresult9799);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9800 = callmethod(opresult9799, "++", 1, partcv, params);
// compiled op node returning opresult9800 (depth = 5)
  int op_slot_left_9787 = gc_frame_newslot(opresult9800);
  params[0] = strlit9788;
  partcv[0] = 1;
  Object opresult9801 = callmethod(opresult9800, "++", 1, partcv, params);
// compiled op node returning opresult9801 (depth = 4)
  *var_s = opresult9801;
  if (opresult9801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9803 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9805 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9804);
// compiled call node returning call9805 (depth = 5)
// compiled member node returning call9805 (depth = 4)
  gc_frame_newslot(call9805);
// starting to compile block node (depth = 4)
  Object block9806 = alloc_Block(NULL, NULL, "ast", 2541);
  gc_frame_newslot(block9806);
// method "_apply"
  block_savedest(block9806);
  Object closure9807 = createclosure(4, "_apply");
  setclosureframe(closure9807, stackframe);
  addtoclosure(closure9807, var_depth);
  addtoclosure(closure9807, var_spc);
  addtoclosure(closure9807, var_s);
  addtoclosure(closure9807, selfslot);
  struct UserObject *uo9807 = (struct UserObject*)block9806;
  uo9807->data[0] = (Object)closure9807;
  Method *meth_meth_ast__apply9807 = addmethod2pos(block9806, "_apply", &meth_ast__apply9807, 0);
  int argcv_meth_ast__apply9807[] = {1};
  meth_meth_ast__apply9807->type = alloc_MethodType(1, argcv_meth_ast__apply9807);
  meth_meth_ast__apply9807->definitionModule = modulename;
  meth_meth_ast__apply9807->definitionLine = 2541;
// compiled block node returning block9806 (depth = 4)
  gc_frame_newslot(block9806);
// call case 5: prelude request
  params[0] = call9805;
  params[1] = block9806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9838 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9803);
// compiled call node returning call9838 (depth = 3)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopy9839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9840 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe9841 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9842 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9843 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9842);
// compiled call node returning call9843 (depth = 6)
// compiled member node returning call9843 (depth = 5)
  gc_frame_newslot(call9843);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9845 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9844);
// compiled call node returning call9845 (depth = 6)
// compiled member node returning call9845 (depth = 5)
  gc_frame_newslot(call9845);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_callWithPart (depth = 5)
  params[0] = call9843;
  params[1] = call9845;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9846 = callmethod(*var_callWithPart, "request()withArgs",
    2, partcv, params);
  gc_frame_end(callframe9841);
// compiled call node returning call9846 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call9847 = callmethod(call9846, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe9840);
// compiled call node returning call9847 (depth = 3)
  gc_frame_end(frame);
  return call9847;
}
Object meth_ast_shallowCopyFieldsFrom9848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9849 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call9850 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9849);
// compiled call node returning call9850 (depth = 3)
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9851 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call9853 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe9852);
// compiled call node returning call9853 (depth = 5)
// compiled member node returning call9853 (depth = 4)
  gc_frame_newslot(call9853);
// call case 4: self request
  params[0] = call9853;
  partcv[0] = 1;
  Object call9854 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9851);
// compiled call node returning call9854 (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_statementName9855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "statementName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9856 == NULL) {
    strlit9856 = alloc_String("request");
    gc_root(strlit9856);
  }
// compiled string node returning strlit9856 (depth = 3)
  gc_frame_end(frame);
  return strlit9856;
}
Object meth_ast_request_40__41_withArgs9728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request()withArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs");
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9729 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9729 = alloc_userobj2(12,10, objclass9729);
  gc_frame_newslot(obj9729);
if (objclass9729 == NULL) {
  glfree(obj9729->class->name);
  obj9729->class->name = "callWithPart.request()withArgs";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9729, self, 0);
  addmethodreal(obj9729,"outer", &reader_ast_outer_9730);
  Object oldself9729 = self;
  struct StackFrameObject *oldstackframe9729 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9729);
  gc_frame_newslot((Object)stackframe);
  self = obj9729;
  Object *oldselfslot9729 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9729 = (*(struct UserObject *)self).data[0], lowerouter9729 = thisouter9729;
  if (inheritingObject9729) {
    struct UserObject *inho9729 = (struct UserObject *)inheritingObject9729;
    while (inho9729->super != GraceDefaultObject) inho9729 = (struct UserObject *)inho9729->super;
    inho9729->super = obj9729;
    self = inheritingObject9729;
    *selfslot = self;
    lowerouter9729 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9729;
  }
if (objclass9729 == NULL) {
  Method *reader9731 = addmethodrealflags(obj9729, "kind",&reader_ast_kind_9731, MFLAG_DEF);
  reader9731->definitionModule = modulename;
  reader9731->definitionLine = 2523;
}
adddatum2(obj9729, alloc_Undefined(), 1);
if (objclass9729 == NULL) {
  Method *reader9732 = addmethodrealflags(obj9729, "name",&reader_ast_name_9732, 0);
  Method *writer9732 = addmethodrealflags(obj9729, "name:=",&writer_ast_name_9732, 0);
  reader9732->definitionModule = modulename;
  writer9732->definitionModule = modulename;
  reader9732->definitionLine = 2524;
  writer9732->definitionLine = 2524;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 2);
if (objclass9729 == NULL) {
  Method *reader9733 = addmethodrealflags(obj9729, "args",&reader_ast_args_9733, 0);
  Method *writer9733 = addmethodrealflags(obj9729, "args:=",&writer_ast_args_9733, 0);
  reader9733->definitionModule = modulename;
  writer9733->definitionModule = modulename;
  reader9733->definitionLine = 2525;
  writer9733->definitionLine = 2525;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 3);
if (objclass9729 == NULL) {
  Method *reader9734 = addmethodrealflags(obj9729, "lineLength",&reader_ast_lineLength_9734, 0);
  Method *writer9734 = addmethodrealflags(obj9729, "lineLength:=",&writer_ast_lineLength_9734, 0);
  reader9734->definitionModule = modulename;
  writer9734->definitionModule = modulename;
  reader9734->definitionLine = 2526;
  writer9734->definitionLine = 2526;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 4);
// method "map()ancestors"
  struct UserObject *uo9735 = (struct UserObject*)obj9729;
  uo9735->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9735 = addmethod2pos(obj9729, "map()ancestors", &meth_ast_map_40__41_ancestors9735, 5);
  int argcv_meth_ast_map_40__41_ancestors9735[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9735->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9735);
  meth_meth_ast_map_40__41_ancestors9735->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9735->definitionLine = 2528;
// method "pretty"
  struct UserObject *uo9752 = (struct UserObject*)obj9729;
  uo9752->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty9752 = addmethod2pos(obj9729, "pretty", &meth_ast_pretty9752, 6);
  int argcv_meth_ast_pretty9752[] = {1};
  meth_meth_ast_pretty9752->type = alloc_MethodType(1, argcv_meth_ast_pretty9752);
  meth_meth_ast_pretty9752->definitionModule = modulename;
  meth_meth_ast_pretty9752->definitionLine = 2534;
// method "shallowCopy"
  block_savedest(obj9729);
  Object closure9839 = createclosure(1, "shallowCopy");
  setclosureframe(closure9839, stackframe);
  addtoclosure(closure9839, var_callWithPart);
  struct UserObject *uo9839 = (struct UserObject*)obj9729;
  uo9839->data[7] = (Object)closure9839;
  Method *meth_meth_ast_shallowCopy9839 = addmethod2pos(obj9729, "shallowCopy", &meth_ast_shallowCopy9839, 7);
  int argcv_meth_ast_shallowCopy9839[] = {0};
  meth_meth_ast_shallowCopy9839->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9839);
  meth_meth_ast_shallowCopy9839->definitionModule = modulename;
  meth_meth_ast_shallowCopy9839->definitionLine = 2546;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9848 = (struct UserObject*)obj9729;
  uo9848->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9848 = addmethod2pos(obj9729, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9848, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom9848[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9848->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9848);
  meth_meth_ast_shallowCopyFieldsFrom9848->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9848->definitionLine = 2549;
// method "statementName"
  struct UserObject *uo9855 = (struct UserObject*)obj9729;
  uo9855->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName9855 = addmethod2pos(obj9729, "statementName", &meth_ast_statementName9855, 9);
  int argcv_meth_ast_statementName9855[] = {0};
  meth_meth_ast_statementName9855->type = alloc_MethodType(1, argcv_meth_ast_statementName9855);
  meth_meth_ast_statementName9855->definitionModule = modulename;
  meth_meth_ast_statementName9855->definitionLine = 2554;
  sourceObject = obj9729;
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9857 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9858 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9859 = gc_frame_new();
// call case 3: self.outer request
  Object call9860 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9859);
// compiled call node returning call9860 (depth = 7)
// compiled member node returning call9860 (depth = 6)
  partcv[0] = 0;
  Object call9861 = callmethodflags(call9860, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9858);
// compiled call node returning call9861 (depth = 5)
// compiled member node returning call9861 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9862 = callmethodflags(call9861, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9857);
// compiled call node returning call9862 (depth = 3)
  struct UserObject *obj9729_uo = (struct UserObject *)obj9729;
  obj9729_uo->super = call9862;
  sourceObject = obj9729;
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9863 == NULL) {
    strlit9863 = alloc_String("callwithpart");
    gc_root(strlit9863);
  }
// compiled string node returning strlit9863 (depth = 3)
  adddatum2(obj9729, strlit9863, 1);
  sourceObject = obj9729;
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj9729, *var_rPart, 2);
  sourceObject = obj9729;
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj9729, *var_xs, 3);
  sourceObject = obj9729;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9864 = alloc_Float64(0);
// compiled num node returning num9864 (depth = 3)
  adddatum2(obj9729, num9864, 4);
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  objclass9729 = obj9729->class;
  objclass9729->definitionModule = modulename;
  objclass9729->definitionLine = 2521;
  (*(struct UserObject *)self).data[0] = lowerouter9729;
  self = oldself9729;
  selfslot = oldselfslot9729;
  stackframe = oldstackframe9729;
  gc_frame_end(frame);
  return obj9729;
}
Object meth_ast_request_40__41_withArgs9728_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "request()withArgs()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method request()withArgs()object");
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for request()withArgs (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_rPart = &(stackframe->slots[0]);
  *var_rPart = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for request");
  Object *var_xs = &(stackframe->slots[1]);
  *var_xs = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withArgs");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9729 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9729 = alloc_userobj2(12,10, objclass9729);
  gc_frame_newslot(obj9729);
if (objclass9729 == NULL) {
  glfree(obj9729->class->name);
  obj9729->class->name = "callWithPart.request()withArgs";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9729, self, 0);
  addmethodreal(obj9729,"outer", &reader_ast_outer_9730);
  Object oldself9729 = self;
  struct StackFrameObject *oldstackframe9729 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9729);
  gc_frame_newslot((Object)stackframe);
  self = obj9729;
  Object *oldselfslot9729 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9729 = (*(struct UserObject *)self).data[0], lowerouter9729 = thisouter9729;
  if (inheritingObject9729) {
    struct UserObject *inho9729 = (struct UserObject *)inheritingObject9729;
    while (inho9729->super != GraceDefaultObject) inho9729 = (struct UserObject *)inho9729->super;
    inho9729->super = obj9729;
    self = inheritingObject9729;
    *selfslot = self;
    lowerouter9729 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9729;
  }
if (objclass9729 == NULL) {
  Method *reader9731 = addmethodrealflags(obj9729, "kind",&reader_ast_kind_9731, MFLAG_DEF);
  reader9731->definitionModule = modulename;
  reader9731->definitionLine = 2523;
}
adddatum2(obj9729, alloc_Undefined(), 1);
if (objclass9729 == NULL) {
  Method *reader9732 = addmethodrealflags(obj9729, "name",&reader_ast_name_9732, 0);
  Method *writer9732 = addmethodrealflags(obj9729, "name:=",&writer_ast_name_9732, 0);
  reader9732->definitionModule = modulename;
  writer9732->definitionModule = modulename;
  reader9732->definitionLine = 2524;
  writer9732->definitionLine = 2524;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 2);
if (objclass9729 == NULL) {
  Method *reader9733 = addmethodrealflags(obj9729, "args",&reader_ast_args_9733, 0);
  Method *writer9733 = addmethodrealflags(obj9729, "args:=",&writer_ast_args_9733, 0);
  reader9733->definitionModule = modulename;
  writer9733->definitionModule = modulename;
  reader9733->definitionLine = 2525;
  writer9733->definitionLine = 2525;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 3);
if (objclass9729 == NULL) {
  Method *reader9734 = addmethodrealflags(obj9729, "lineLength",&reader_ast_lineLength_9734, 0);
  Method *writer9734 = addmethodrealflags(obj9729, "lineLength:=",&writer_ast_lineLength_9734, 0);
  reader9734->definitionModule = modulename;
  writer9734->definitionModule = modulename;
  reader9734->definitionLine = 2526;
  writer9734->definitionLine = 2526;
}
obj9729->flags |= OFLAG_MUTABLE;
adddatum2(obj9729, alloc_Undefined(), 4);
// method "map()ancestors"
  struct UserObject *uo9735 = (struct UserObject*)obj9729;
  uo9735->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9735 = addmethod2pos(obj9729, "map()ancestors", &meth_ast_map_40__41_ancestors9735, 5);
  int argcv_meth_ast_map_40__41_ancestors9735[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9735->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9735);
  meth_meth_ast_map_40__41_ancestors9735->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9735->definitionLine = 2528;
// method "pretty"
  struct UserObject *uo9752 = (struct UserObject*)obj9729;
  uo9752->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty9752 = addmethod2pos(obj9729, "pretty", &meth_ast_pretty9752, 6);
  int argcv_meth_ast_pretty9752[] = {1};
  meth_meth_ast_pretty9752->type = alloc_MethodType(1, argcv_meth_ast_pretty9752);
  meth_meth_ast_pretty9752->definitionModule = modulename;
  meth_meth_ast_pretty9752->definitionLine = 2534;
// method "shallowCopy"
  block_savedest(obj9729);
  Object closure9839 = createclosure(1, "shallowCopy");
  setclosureframe(closure9839, stackframe);
  addtoclosure(closure9839, var_callWithPart);
  struct UserObject *uo9839 = (struct UserObject*)obj9729;
  uo9839->data[7] = (Object)closure9839;
  Method *meth_meth_ast_shallowCopy9839 = addmethod2pos(obj9729, "shallowCopy", &meth_ast_shallowCopy9839, 7);
  int argcv_meth_ast_shallowCopy9839[] = {0};
  meth_meth_ast_shallowCopy9839->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy9839);
  meth_meth_ast_shallowCopy9839->definitionModule = modulename;
  meth_meth_ast_shallowCopy9839->definitionLine = 2546;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo9848 = (struct UserObject*)obj9729;
  uo9848->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom9848 = addmethod2pos(obj9729, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom9848, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom9848[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom9848->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom9848);
  meth_meth_ast_shallowCopyFieldsFrom9848->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom9848->definitionLine = 2549;
// method "statementName"
  struct UserObject *uo9855 = (struct UserObject*)obj9729;
  uo9855->data[9] = emptyclosure;
  Method *meth_meth_ast_statementName9855 = addmethod2pos(obj9729, "statementName", &meth_ast_statementName9855, 9);
  int argcv_meth_ast_statementName9855[] = {0};
  meth_meth_ast_statementName9855->type = alloc_MethodType(1, argcv_meth_ast_statementName9855);
  meth_meth_ast_statementName9855->definitionModule = modulename;
  meth_meth_ast_statementName9855->definitionLine = 2554;
  sourceObject = obj9729;
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9857 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9858 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9859 = gc_frame_new();
// call case 3: self.outer request
  Object call9860 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9859);
// compiled call node returning call9860 (depth = 7)
// compiled member node returning call9860 (depth = 6)
  partcv[0] = 0;
  Object call9861 = callmethodflags(call9860, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9858);
// compiled call node returning call9861 (depth = 5)
// compiled member node returning call9861 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9862 = callmethodflags(call9861, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9857);
// compiled call node returning call9862 (depth = 3)
  struct UserObject *obj9729_uo = (struct UserObject *)obj9729;
  obj9729_uo->super = call9862;
  sourceObject = obj9729;
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit9863 == NULL) {
    strlit9863 = alloc_String("callwithpart");
    gc_root(strlit9863);
  }
// compiled string node returning strlit9863 (depth = 3)
  adddatum2(obj9729, strlit9863, 1);
  sourceObject = obj9729;
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_rPart (depth = 3)
  adddatum2(obj9729, *var_rPart, 2);
  sourceObject = obj9729;
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_xs (depth = 3)
  adddatum2(obj9729, *var_xs, 3);
  sourceObject = obj9729;
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num9864 = alloc_Float64(0);
// compiled num node returning num9864 (depth = 3)
  adddatum2(obj9729, num9864, 4);
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  sourceObject = obj9729;
  objclass9729 = obj9729->class;
  objclass9729->definitionModule = modulename;
  objclass9729->definitionLine = 2521;
  (*(struct UserObject *)self).data[0] = lowerouter9729;
  self = oldself9729;
  selfslot = oldselfslot9729;
  stackframe = oldstackframe9729;
  gc_frame_end(frame);
  return obj9729;
}
Object meth_ast_callWithPart9866(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callWithPart (depth = 3)
  gc_frame_end(frame);
  return *var_callWithPart;
}
Object meth_ast_isComment9877(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isComment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isComment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isComment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9878 = alloc_Boolean(1);
// compiled identifier node returning bool9878 (depth = 3)
  gc_frame_end(frame);
  return bool9878;
}
Object meth_ast_isLegalInTrait9879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isLegalInTrait");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isLegalInTrait (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isLegalInTrait");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9880 = alloc_Boolean(1);
// compiled identifier node returning bool9880 (depth = 3)
  gc_frame_end(frame);
  return bool9880;
}
Object meth_ast_isExecutable9881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isExecutable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isExecutable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isExecutable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9882 = alloc_Boolean(0);
// compiled identifier node returning bool9882 (depth = 3)
  gc_frame_end(frame);
  return bool9882;
}
Object meth_ast_asString9883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9885 == NULL) {
    strlit9885 = alloc_String("");
    gc_root(strlit9885);
  }
// compiled string node returning strlit9885 (depth = 4)
  int op_slot_right_9884 = gc_frame_newslot(strlit9885);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9888 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9889 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9888);
// compiled call node returning call9889 (depth = 6)
// compiled member node returning call9889 (depth = 5)
  int op_slot_right_9887 = gc_frame_newslot(call9889);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9892 == NULL) {
    strlit9892 = alloc_String("): ");
    gc_root(strlit9892);
  }
// compiled string node returning strlit9892 (depth = 6)
  int op_slot_right_9891 = gc_frame_newslot(strlit9892);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9895 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9896 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9895);
// compiled call node returning call9896 (depth = 8)
// compiled member node returning call9896 (depth = 7)
  int op_slot_right_9894 = gc_frame_newslot(call9896);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9899 == NULL) {
    strlit9899 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit9899);
  }
// compiled string node returning strlit9899 (depth = 8)
  int op_slot_right_9898 = gc_frame_newslot(strlit9899);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9902 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9903 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9902);
// compiled call node returning call9903 (depth = 10)
// compiled member node returning call9903 (depth = 9)
  int op_slot_right_9901 = gc_frame_newslot(call9903);
// starting to compile string node (depth = 9)
  if (strlit9905 == NULL) {
    strlit9905 = alloc_String("comment (");
    gc_root(strlit9905);
  }
// compiled string node returning strlit9905 (depth = 9)
  int op_slot_left_9901 = gc_frame_newslot(strlit9905);
  params[0] = call9903;
  partcv[0] = 1;
  Object opresult9906 = callmethod(strlit9905, "++", 1, partcv, params);
// compiled op node returning opresult9906 (depth = 8)
  int op_slot_left_9898 = gc_frame_newslot(opresult9906);
  params[0] = strlit9899;
  partcv[0] = 1;
  Object opresult9907 = callmethod(opresult9906, "++", 1, partcv, params);
// compiled op node returning opresult9907 (depth = 7)
  int op_slot_left_9894 = gc_frame_newslot(opresult9907);
  params[0] = call9896;
  partcv[0] = 1;
  Object opresult9908 = callmethod(opresult9907, "++", 1, partcv, params);
// compiled op node returning opresult9908 (depth = 6)
  int op_slot_left_9891 = gc_frame_newslot(opresult9908);
  params[0] = strlit9892;
  partcv[0] = 1;
  Object opresult9909 = callmethod(opresult9908, "++", 1, partcv, params);
// compiled op node returning opresult9909 (depth = 5)
  int op_slot_left_9887 = gc_frame_newslot(opresult9909);
  params[0] = call9889;
  partcv[0] = 1;
  Object opresult9910 = callmethod(opresult9909, "++", 1, partcv, params);
// compiled op node returning opresult9910 (depth = 4)
  int op_slot_left_9884 = gc_frame_newslot(opresult9910);
  params[0] = strlit9885;
  partcv[0] = 1;
  Object opresult9911 = callmethod(opresult9910, "++", 1, partcv, params);
// compiled op node returning opresult9911 (depth = 3)
  gc_frame_end(frame);
  return opresult9911;
}
Object meth_ast_extendCommentUsing9912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extendCommentUsing");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extendCommentUsing");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extendCommentUsing (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cmtNode = &(stackframe->slots[0]);
  *var_cmtNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extendCommentUsing");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9913 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cmtNode (depth = 7)
  partcv[0] = 0;
  Object call9916 = callmethod(*var_cmtNode, "value",
    1, partcv, params);
  gc_frame_end(callframe9915);
// compiled call node returning call9916 (depth = 6)
// compiled member node returning call9916 (depth = 5)
  int op_slot_right_9914 = gc_frame_newslot(call9916);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9919 == NULL) {
    strlit9919 = alloc_String(" ");
    gc_root(strlit9919);
  }
// compiled string node returning strlit9919 (depth = 6)
  int op_slot_right_9918 = gc_frame_newslot(strlit9919);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9921 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9922 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9921);
// compiled call node returning call9922 (depth = 7)
// compiled member node returning call9922 (depth = 6)
  int op_slot_left_9918 = gc_frame_newslot(call9922);
  params[0] = strlit9919;
  partcv[0] = 1;
  Object opresult9923 = callmethod(call9922, "++", 1, partcv, params);
// compiled op node returning opresult9923 (depth = 5)
  int op_slot_left_9914 = gc_frame_newslot(opresult9923);
  params[0] = call9916;
  partcv[0] = 1;
  Object opresult9924 = callmethod(opresult9923, "++", 1, partcv, params);
// compiled op node returning opresult9924 (depth = 4)
  gc_frame_newslot(opresult9924);
// call case 4: self request
  params[0] = opresult9924;
  partcv[0] = 1;
  Object call9925 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9913);
// compiled call node returning call9925 (depth = 3)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9926 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cmtNode (depth = 6)
  partcv[0] = 0;
  Object call9928 = callmethod(*var_cmtNode, "endLine",
    1, partcv, params);
  gc_frame_end(callframe9927);
// compiled call node returning call9928 (depth = 5)
// compiled member node returning call9928 (depth = 4)
  gc_frame_newslot(call9928);
// call case 4: self request
  params[0] = call9928;
  partcv[0] = 1;
  Object call9929 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9926);
// compiled call node returning call9929 (depth = 3)
  gc_frame_end(frame);
  return call9929;
}
Object meth_ast_map_40__41_ancestors9930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()ancestors");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map()ancestors");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for map()ancestors (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ancestors");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_newChain = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newChain");
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9931 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9932 = callmethodflags(self, "shallowCopy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9931);
// compiled call node returning call9932 (depth = 5)
// compiled member node returning call9932 (depth = 4)
  *var_n = call9932;
  if (call9932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9933 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_as (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9934 = callmethod(*var_as, "extend",
    1, partcv, params);
  gc_frame_end(callframe9933);
// compiled call node returning call9934 (depth = 4)
  *var_newChain = call9934;
  if (call9934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9935 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  params[0] = *var_n;
  params[1] = *var_as;
  partcv[0] = 2;
  Object call9936 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9935);
// compiled call node returning call9936 (depth = 3)
  gc_frame_end(frame);
  return call9936;
}
Object meth_ast_accept_40__41_from9937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9938 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_as (depth = 4)
  gc_frame_newslot(*var_as);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_visitor (depth = 4)
  params[0] = self;
  params[1] = *var_as;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9939 = callmethod(*var_visitor, "visitComment()up",
    2, partcv, params);
  gc_frame_end(callframe9938);
// compiled call node returning call9939 (depth = 3)
  gc_frame_end(frame);
  return call9939;
}
Object meth_ast__apply9948(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9950 == NULL) {
    strlit9950 = alloc_String("  ");
    gc_root(strlit9950);
  }
// compiled string node returning strlit9950 (depth = 7)
  int op_slot_right_9949 = gc_frame_newslot(strlit9950);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9949 = gc_frame_newslot(*var_s);
  params[0] = strlit9950;
  partcv[0] = 1;
  Object opresult9952 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9952 (depth = 6)
  *var_s = opresult9952;
  if (opresult9952 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
  Object *var_pb = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "pb");
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9941 == NULL) {
    strlit9941 = alloc_String("""\x0a""");
    gc_root(strlit9941);
  }
// compiled string node returning strlit9941 (depth = 4)
  *var_s = strlit9941;
  if (strlit9941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9942 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9944 = alloc_Float64(1);
// compiled num node returning num9944 (depth = 5)
  int op_slot_right_9943 = gc_frame_newslot(num9944);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  int op_slot_left_9943 = gc_frame_newslot(*var_depth);
  params[0] = num9944;
  partcv[0] = 1;
  Object diff9946 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff9946 (depth = 4)
  gc_frame_newslot(diff9946);
// starting to compile block node (depth = 4)
  Object block9947 = alloc_Block(NULL, NULL, "ast", 2584);
  gc_frame_newslot(block9947);
// method "_apply"
  block_savedest(block9947);
  Object closure9948 = createclosure(2, "_apply");
  setclosureframe(closure9948, stackframe);
  addtoclosure(closure9948, var_s);
  addtoclosure(closure9948, selfslot);
  struct UserObject *uo9948 = (struct UserObject*)block9947;
  uo9948->data[0] = (Object)closure9948;
  Method *meth_meth_ast__apply9948 = addmethod2pos(block9947, "_apply", &meth_ast__apply9948, 0);
  int argcv_meth_ast__apply9948[] = {0};
  meth_meth_ast__apply9948->type = alloc_MethodType(1, argcv_meth_ast__apply9948);
  meth_meth_ast__apply9948->definitionModule = modulename;
  meth_meth_ast__apply9948->definitionLine = 2575;
// compiled block node returning block9947 (depth = 4)
  gc_frame_newslot(block9947);
// call case 5: prelude request
  params[0] = diff9946;
  params[1] = block9947;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9955 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9942);
// compiled call node returning call9955 (depth = 3)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9958 = callmethodflags(self, "isPreceededByBlankLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9957);
// compiled call node returning call9958 (depth = 6)
// compiled member node returning call9958 (depth = 5)
  Object if9956 = done;
struct StackFrameObject *iftmpstackframe9956 = stackframe;
  if (istrue(call9958)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9956);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9959 == NULL) {
    strlit9959 = alloc_String(" > blank");
    gc_root(strlit9959);
  }
// compiled string node returning strlit9959 (depth = 5)
    gc_frame_newslot(strlit9959);
    if9956 = strlit9959;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe9956);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit9960 == NULL) {
    strlit9960 = alloc_String("");
    gc_root(strlit9960);
  }
// compiled string node returning strlit9960 (depth = 5)
    gc_frame_newslot(strlit9960);
    if9956 = strlit9960;
  }
stackframe = iftmpstackframe9956;
// compiled if node returning if9956 (depth = 4)
  *var_pb = if9956;
  if (if9956 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9962 == NULL) {
    strlit9962 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit9962);
  }
// compiled string node returning strlit9962 (depth = 4)
  int op_slot_right_9961 = gc_frame_newslot(strlit9962);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9966 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9965);
// compiled call node returning call9966 (depth = 6)
// compiled member node returning call9966 (depth = 5)
  int op_slot_right_9964 = gc_frame_newslot(call9966);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9969 == NULL) {
    strlit9969 = alloc_String("): ""\xe2""""\x80""""\xb9""");
    gc_root(strlit9969);
  }
// compiled string node returning strlit9969 (depth = 6)
  int op_slot_right_9968 = gc_frame_newslot(strlit9969);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9973 = callmethodflags(self, "endLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9972);
// compiled call node returning call9973 (depth = 8)
// compiled member node returning call9973 (depth = 7)
  int op_slot_right_9971 = gc_frame_newslot(call9973);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9976 == NULL) {
    strlit9976 = alloc_String("""\xe2""""\x80""""\x93""");
    gc_root(strlit9976);
  }
// compiled string node returning strlit9976 (depth = 8)
  int op_slot_right_9975 = gc_frame_newslot(strlit9976);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9979 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9980 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9979);
// compiled call node returning call9980 (depth = 10)
// compiled member node returning call9980 (depth = 9)
  int op_slot_right_9978 = gc_frame_newslot(call9980);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9983 == NULL) {
    strlit9983 = alloc_String("(");
    gc_root(strlit9983);
  }
// compiled string node returning strlit9983 (depth = 10)
  int op_slot_right_9982 = gc_frame_newslot(strlit9983);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pb (depth = 11)
  int op_slot_right_9985 = gc_frame_newslot(*var_pb);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9988 == NULL) {
    strlit9988 = alloc_String("Comment");
    gc_root(strlit9988);
  }
// compiled string node returning strlit9988 (depth = 12)
  int op_slot_right_9987 = gc_frame_newslot(strlit9988);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_9990 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit9992 == NULL) {
    strlit9992 = alloc_String("");
    gc_root(strlit9992);
  }
// compiled string node returning strlit9992 (depth = 13)
  int op_slot_left_9990 = gc_frame_newslot(strlit9992);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9993 = callmethod(strlit9992, "++", 1, partcv, params);
// compiled op node returning opresult9993 (depth = 12)
  int op_slot_left_9987 = gc_frame_newslot(opresult9993);
  params[0] = strlit9988;
  partcv[0] = 1;
  Object opresult9994 = callmethod(opresult9993, "++", 1, partcv, params);
// compiled op node returning opresult9994 (depth = 11)
  int op_slot_left_9985 = gc_frame_newslot(opresult9994);
  params[0] = *var_pb;
  partcv[0] = 1;
  Object opresult9995 = callmethod(opresult9994, "++", 1, partcv, params);
// compiled op node returning opresult9995 (depth = 10)
  int op_slot_left_9982 = gc_frame_newslot(opresult9995);
  params[0] = strlit9983;
  partcv[0] = 1;
  Object opresult9996 = callmethod(opresult9995, "++", 1, partcv, params);
// compiled op node returning opresult9996 (depth = 9)
  int op_slot_left_9978 = gc_frame_newslot(opresult9996);
  params[0] = call9980;
  partcv[0] = 1;
  Object opresult9997 = callmethod(opresult9996, "++", 1, partcv, params);
// compiled op node returning opresult9997 (depth = 8)
  int op_slot_left_9975 = gc_frame_newslot(opresult9997);
  params[0] = strlit9976;
  partcv[0] = 1;
  Object opresult9998 = callmethod(opresult9997, "++", 1, partcv, params);
// compiled op node returning opresult9998 (depth = 7)
  int op_slot_left_9971 = gc_frame_newslot(opresult9998);
  params[0] = call9973;
  partcv[0] = 1;
  Object opresult9999 = callmethod(opresult9998, "++", 1, partcv, params);
// compiled op node returning opresult9999 (depth = 6)
  int op_slot_left_9968 = gc_frame_newslot(opresult9999);
  params[0] = strlit9969;
  partcv[0] = 1;
  Object opresult10000 = callmethod(opresult9999, "++", 1, partcv, params);
// compiled op node returning opresult10000 (depth = 5)
  int op_slot_left_9964 = gc_frame_newslot(opresult10000);
  params[0] = call9966;
  partcv[0] = 1;
  Object opresult10001 = callmethod(opresult10000, "++", 1, partcv, params);
// compiled op node returning opresult10001 (depth = 4)
  int op_slot_left_9961 = gc_frame_newslot(opresult10001);
  params[0] = strlit9962;
  partcv[0] = 1;
  Object opresult10002 = callmethod(opresult10001, "++", 1, partcv, params);
// compiled op node returning opresult10002 (depth = 3)
  gc_frame_end(frame);
  return opresult10002;
}
Object meth_ast__apply10020(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10022 == NULL) {
    strlit10022 = alloc_String("    ");
    gc_root(strlit10022);
  }
// compiled string node returning strlit10022 (depth = 8)
  int op_slot_right_10021 = gc_frame_newslot(strlit10022);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_10021 = gc_frame_newslot(*var_spc);
  params[0] = strlit10022;
  partcv[0] = 1;
  Object opresult10024 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10024 (depth = 7)
  *var_spc = opresult10024;
  if (opresult10024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace10003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toGrace");
  Object params[3];
  int partcv[3];
  Object *var_lineLength = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10005 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10006 = callmethodflags(self, "isPartialLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10005);
// compiled call node returning call10006 (depth = 5)
// compiled member node returning call10006 (depth = 4)
  Object if10004 = done;
  if (istrue(call10006)) {
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10008 == NULL) {
    strlit10008 = alloc_String("");
    gc_root(strlit10008);
  }
// compiled string node returning strlit10008 (depth = 5)
  int op_slot_right_10007 = gc_frame_newslot(strlit10008);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10011 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10012 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10011);
// compiled call node returning call10012 (depth = 7)
// compiled member node returning call10012 (depth = 6)
  int op_slot_right_10010 = gc_frame_newslot(call10012);
// starting to compile string node (depth = 6)
  if (strlit10014 == NULL) {
    strlit10014 = alloc_String("// (partial) ");
    gc_root(strlit10014);
  }
// compiled string node returning strlit10014 (depth = 6)
  int op_slot_left_10010 = gc_frame_newslot(strlit10014);
  params[0] = call10012;
  partcv[0] = 1;
  Object opresult10015 = callmethod(strlit10014, "++", 1, partcv, params);
// compiled op node returning opresult10015 (depth = 5)
  int op_slot_left_10007 = gc_frame_newslot(opresult10015);
  params[0] = strlit10008;
  partcv[0] = 1;
  Object opresult10016 = callmethod(opresult10015, "++", 1, partcv, params);
// compiled op node returning opresult10016 (depth = 4)
    gc_frame_newslot(opresult10016);
    if10004 = opresult10016;
  } else {
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10017 == NULL) {
    strlit10017 = alloc_String("");
    gc_root(strlit10017);
  }
// compiled string node returning strlit10017 (depth = 5)
  *var_spc = strlit10017;
  if (strlit10017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10018 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth (depth = 5)
  gc_frame_newslot(*var_depth);
// starting to compile block node (depth = 5)
  Object block10019 = alloc_Block(NULL, NULL, "ast", 2597);
  gc_frame_newslot(block10019);
// method "_apply"
  block_savedest(block10019);
  Object closure10020 = createclosure(2, "_apply");
  setclosureframe(closure10020, stackframe);
  addtoclosure(closure10020, var_spc);
  addtoclosure(closure10020, selfslot);
  struct UserObject *uo10020 = (struct UserObject*)block10019;
  uo10020->data[0] = (Object)closure10020;
  Method *meth_meth_ast__apply10020 = addmethod2pos(block10019, "_apply", &meth_ast__apply10020, 0);
  int argcv_meth_ast__apply10020[] = {0};
  meth_meth_ast__apply10020->type = alloc_MethodType(1, argcv_meth_ast__apply10020);
  meth_meth_ast__apply10020->definitionModule = modulename;
  meth_meth_ast__apply10020->definitionLine = 2594;
// compiled block node returning block10019 (depth = 5)
  gc_frame_newslot(block10019);
// call case 5: prelude request
  params[0] = *var_depth;
  params[1] = block10019;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10027 = callmethodflags(prelude, "repeat()times", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10018);
// compiled call node returning call10027 (depth = 4)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10028 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10030 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10029);
// compiled call node returning call10030 (depth = 6)
// compiled member node returning call10030 (depth = 5)
  gc_frame_newslot(call10030);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineLength (depth = 5)
  gc_frame_newslot(*var_lineLength);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10032 == NULL) {
    strlit10032 = alloc_String("// ");
    gc_root(strlit10032);
  }
// compiled string node returning strlit10032 (depth = 6)
  int op_slot_right_10031 = gc_frame_newslot(strlit10032);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_spc (depth = 6)
  int op_slot_left_10031 = gc_frame_newslot(*var_spc);
  params[0] = strlit10032;
  partcv[0] = 1;
  Object opresult10034 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult10034 (depth = 5)
  gc_frame_newslot(opresult10034);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10035 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10036 = gc_frame_new();
// call case 3: self.outer request
  Object call10037 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10036);
// compiled call node returning call10037 (depth = 8)
// compiled member node returning call10037 (depth = 7)
  partcv[0] = 0;
  Object call10038 = callmethodflags(call10037, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10035);
// compiled call node returning call10038 (depth = 6)
// compiled member node returning call10038 (depth = 5)
  params[0] = call10030;
  params[1] = *var_lineLength;
  params[2] = opresult10034;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10039 = callmethodflags(call10038, "wrap()to()prefix", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10028);
// compiled call node returning call10039 (depth = 4)
    gc_frame_newslot(call10039);
    if10004 = call10039;
  }
// compiled if node returning if10004 (depth = 3)
  gc_frame_end(frame);
  return if10004;
}
Object meth_ast_shallowCopy10040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_commentNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10041 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10042 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_commentNode (depth = 5)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call10043 = callmethod(*var_commentNode, "new",
    1, partcv, params);
  gc_frame_end(callframe10042);
// compiled call node returning call10043 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call10044 = callmethod(call10043, "shallowCopyFieldsFrom",
    1, partcv, params);
  gc_frame_end(callframe10041);
// compiled call node returning call10044 (depth = 3)
  gc_frame_end(frame);
  return call10044;
}
Object meth_ast_shallowCopyFieldsFrom10045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method shallowCopyFieldsFrom");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for shallowCopyFieldsFrom (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for shallowCopyFieldsFrom");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10046 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 1: super request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call10047 = callmethod4(self, "shallowCopyFieldsFrom", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe10046);
// compiled call node returning call10047 (depth = 3)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10048 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10049 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10050 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe10049);
// compiled call node returning call10050 (depth = 5)
// compiled member node returning call10050 (depth = 4)
  gc_frame_newslot(call10050);
// call case 4: self request
  params[0] = call10050;
  partcv[0] = 1;
  Object call10051 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10048);
// compiled call node returning call10051 (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10052 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10054 = callmethod(*var_other, "isPartialLine",
    1, partcv, params);
  gc_frame_end(callframe10053);
// compiled call node returning call10054 (depth = 5)
// compiled member node returning call10054 (depth = 4)
  gc_frame_newslot(call10054);
// call case 4: self request
  params[0] = call10054;
  partcv[0] = 1;
  Object call10055 = callmethodflags(self, "isPartialLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10052);
// compiled call node returning call10055 (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10056 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10057 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call10058 = callmethod(*var_other, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10057);
// compiled call node returning call10058 (depth = 5)
// compiled member node returning call10058 (depth = 4)
  gc_frame_newslot(call10058);
// call case 4: self request
  params[0] = call10058;
  partcv[0] = 1;
  Object call10059 = callmethodflags(self, "endLine:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10056);
// compiled call node returning call10059 (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new9869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9870 = alloc_userobj2(20,17, objclass9870);
  gc_frame_newslot(obj9870);
if (objclass9870 == NULL) {
  glfree(obj9870->class->name);
  obj9870->class->name = "commentNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9870, self, 0);
  addmethodreal(obj9870,"outer", &reader_ast_outer_9871);
  Object oldself9870 = self;
  struct StackFrameObject *oldstackframe9870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9870);
  gc_frame_newslot((Object)stackframe);
  self = obj9870;
  Object *oldselfslot9870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9870 = (*(struct UserObject *)self).data[0], lowerouter9870 = thisouter9870;
  if (inheritingObject9870) {
    struct UserObject *inho9870 = (struct UserObject *)inheritingObject9870;
    while (inho9870->super != GraceDefaultObject) inho9870 = (struct UserObject *)inho9870->super;
    inho9870->super = obj9870;
    self = inheritingObject9870;
    *selfslot = self;
    lowerouter9870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9870;
  }
if (objclass9870 == NULL) {
  Method *reader9872 = addmethodrealflags(obj9870, "kind",&reader_ast_kind_9872, MFLAG_DEF);
  reader9872->definitionModule = modulename;
  reader9872->definitionLine = 2561;
}
adddatum2(obj9870, alloc_Undefined(), 1);
if (objclass9870 == NULL) {
  Method *reader9873 = addmethodrealflags(obj9870, "value",&reader_ast_value_9873, 0);
  Method *writer9873 = addmethodrealflags(obj9870, "value:=",&writer_ast_value_9873, 0);
  reader9873->definitionModule = modulename;
  writer9873->definitionModule = modulename;
  reader9873->definitionLine = 2562;
  writer9873->definitionLine = 2562;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 2);
if (objclass9870 == NULL) {
  Method *reader9874 = addmethodrealflags(obj9870, "isPartialLine",&reader_ast_isPartialLine_9874, 0);
  Method *writer9874 = addmethodrealflags(obj9870, "isPartialLine:=",&writer_ast_isPartialLine_9874, 0);
  reader9874->definitionModule = modulename;
  writer9874->definitionModule = modulename;
  reader9874->definitionLine = 2563;
  writer9874->definitionLine = 2563;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 3);
if (objclass9870 == NULL) {
  Method *reader9875 = addmethodrealflags(obj9870, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_9875, 0);
  Method *writer9875 = addmethodrealflags(obj9870, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_9875, 0);
  reader9875->definitionModule = modulename;
  writer9875->definitionModule = modulename;
  reader9875->definitionLine = 2564;
  writer9875->definitionLine = 2564;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 4);
if (objclass9870 == NULL) {
  Method *reader9876 = addmethodrealflags(obj9870, "endLine",&reader_ast_endLine_9876, 0);
  Method *writer9876 = addmethodrealflags(obj9870, "endLine:=",&writer_ast_endLine_9876, 0);
  reader9876->definitionModule = modulename;
  writer9876->definitionModule = modulename;
  reader9876->definitionLine = 2565;
  writer9876->definitionLine = 2565;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo9877 = (struct UserObject*)obj9870;
  uo9877->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment9877 = addmethod2pos(obj9870, "isComment", &meth_ast_isComment9877, 6);
  int argcv_meth_ast_isComment9877[] = {0};
  meth_meth_ast_isComment9877->type = alloc_MethodType(1, argcv_meth_ast_isComment9877);
  meth_meth_ast_isComment9877->definitionModule = modulename;
  meth_meth_ast_isComment9877->definitionLine = 2566;
// method "isLegalInTrait"
  struct UserObject *uo9879 = (struct UserObject*)obj9870;
  uo9879->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9879 = addmethod2pos(obj9870, "isLegalInTrait", &meth_ast_isLegalInTrait9879, 7);
  int argcv_meth_ast_isLegalInTrait9879[] = {0};
  meth_meth_ast_isLegalInTrait9879->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9879);
  meth_meth_ast_isLegalInTrait9879->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9879->definitionLine = 2567;
// method "isExecutable"
  struct UserObject *uo9881 = (struct UserObject*)obj9870;
  uo9881->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable9881 = addmethod2pos(obj9870, "isExecutable", &meth_ast_isExecutable9881, 8);
  int argcv_meth_ast_isExecutable9881[] = {0};
  meth_meth_ast_isExecutable9881->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9881);
  meth_meth_ast_isExecutable9881->definitionModule = modulename;
  meth_meth_ast_isExecutable9881->definitionLine = 2568;
// method "asString"
  struct UserObject *uo9883 = (struct UserObject*)obj9870;
  uo9883->data[9] = emptyclosure;
  Method *meth_meth_ast_asString9883 = addmethod2pos(obj9870, "asString", &meth_ast_asString9883, 9);
  int argcv_meth_ast_asString9883[] = {0};
  meth_meth_ast_asString9883->type = alloc_MethodType(1, argcv_meth_ast_asString9883);
  meth_meth_ast_asString9883->definitionModule = modulename;
  meth_meth_ast_asString9883->definitionLine = 2569;
// method "extendCommentUsing"
  struct UserObject *uo9912 = (struct UserObject*)obj9870;
  uo9912->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing9912 = addmethod2pos(obj9870, "extendCommentUsing", &meth_ast_extendCommentUsing9912, 10);
  int argcv_meth_ast_extendCommentUsing9912[] = {1};
  meth_meth_ast_extendCommentUsing9912->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing9912);
  meth_meth_ast_extendCommentUsing9912->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing9912->definitionLine = 2570;
// method "map()ancestors"
  struct UserObject *uo9930 = (struct UserObject*)obj9870;
  uo9930->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9930 = addmethod2pos(obj9870, "map()ancestors", &meth_ast_map_40__41_ancestors9930, 11);
  int argcv_meth_ast_map_40__41_ancestors9930[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9930->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9930);
  meth_meth_ast_map_40__41_ancestors9930->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9930->definitionLine = 2574;
// method "accept()from"
  struct UserObject *uo9937 = (struct UserObject*)obj9870;
  uo9937->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9937 = addmethod2pos(obj9870, "accept()from", &meth_ast_accept_40__41_from9937, 12);
  int argcv_meth_ast_accept_40__41_from9937[] = {1, 1};
  meth_meth_ast_accept_40__41_from9937->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9937);
  meth_meth_ast_accept_40__41_from9937->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9937->definitionLine = 2579;
// method "pretty"
  struct UserObject *uo9940 = (struct UserObject*)obj9870;
  uo9940->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty9940 = addmethod2pos(obj9870, "pretty", &meth_ast_pretty9940, 13);
  int argcv_meth_ast_pretty9940[] = {1};
  meth_meth_ast_pretty9940->type = alloc_MethodType(1, argcv_meth_ast_pretty9940);
  meth_meth_ast_pretty9940->definitionModule = modulename;
  meth_meth_ast_pretty9940->definitionLine = 2582;
// method "toGrace"
  block_savedest(obj9870);
  Object closure10003 = createclosure(1, "toGrace");
  setclosureframe(closure10003, stackframe);
  addtoclosure(closure10003, var_lineLength);
  struct UserObject *uo10003 = (struct UserObject*)obj9870;
  uo10003->data[14] = (Object)closure10003;
  Method *meth_meth_ast_toGrace10003 = addmethod2pos(obj9870, "toGrace", &meth_ast_toGrace10003, 14);
  int argcv_meth_ast_toGrace10003[] = {1};
  meth_meth_ast_toGrace10003->type = alloc_MethodType(1, argcv_meth_ast_toGrace10003);
  meth_meth_ast_toGrace10003->definitionModule = modulename;
  meth_meth_ast_toGrace10003->definitionLine = 2590;
// method "shallowCopy"
  block_savedest(obj9870);
  Object closure10040 = createclosure(2, "shallowCopy");
  setclosureframe(closure10040, stackframe);
  addtoclosure(closure10040, var_nullNode);
  addtoclosure(closure10040, var_commentNode);
  struct UserObject *uo10040 = (struct UserObject*)obj9870;
  uo10040->data[15] = (Object)closure10040;
  Method *meth_meth_ast_shallowCopy10040 = addmethod2pos(obj9870, "shallowCopy", &meth_ast_shallowCopy10040, 15);
  int argcv_meth_ast_shallowCopy10040[] = {0};
  meth_meth_ast_shallowCopy10040->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10040);
  meth_meth_ast_shallowCopy10040->definitionModule = modulename;
  meth_meth_ast_shallowCopy10040->definitionLine = 2601;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10045 = (struct UserObject*)obj9870;
  uo10045->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10045 = addmethod2pos(obj9870, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10045, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom10045[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10045->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10045);
  meth_meth_ast_shallowCopyFieldsFrom10045->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10045->definitionLine = 2604;
  sourceObject = obj9870;
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10060 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10061 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10062 = gc_frame_new();
// call case 3: self.outer request
  Object call10063 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10062);
// compiled call node returning call10063 (depth = 7)
// compiled member node returning call10063 (depth = 6)
  partcv[0] = 0;
  Object call10064 = callmethodflags(call10063, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10061);
// compiled call node returning call10064 (depth = 5)
// compiled member node returning call10064 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10065 = callmethodflags(call10064, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10060);
// compiled call node returning call10065 (depth = 3)
  struct UserObject *obj9870_uo = (struct UserObject *)obj9870;
  obj9870_uo->super = call10065;
  sourceObject = obj9870;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10066 == NULL) {
    strlit10066 = alloc_String("comment");
    gc_root(strlit10066);
  }
// compiled string node returning strlit10066 (depth = 3)
  adddatum2(obj9870, strlit10066, 1);
  sourceObject = obj9870;
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj9870, *var_val_39_, 2);
  sourceObject = obj9870;
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10067 = alloc_Boolean(0);
// compiled identifier node returning bool10067 (depth = 3)
  adddatum2(obj9870, bool10067, 3);
  sourceObject = obj9870;
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10068 = alloc_Boolean(0);
// compiled identifier node returning bool10068 (depth = 3)
  adddatum2(obj9870, bool10068, 4);
  sourceObject = obj9870;
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10070 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10069);
// compiled call node returning call10070 (depth = 4)
// compiled member node returning call10070 (depth = 3)
  adddatum2(obj9870, call10070, 5);
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  objclass9870 = obj9870->class;
  objclass9870->definitionModule = modulename;
  objclass9870->definitionLine = 2559;
  (*(struct UserObject *)self).data[0] = lowerouter9870;
  self = oldself9870;
  selfslot = oldselfslot9870;
  stackframe = oldstackframe9870;
  gc_frame_end(frame);
  return obj9870;
}
Object meth_ast_new9869_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_lineLength = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_commentNode = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val_39_ = &(stackframe->slots[0]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9870 = alloc_userobj2(20,17, objclass9870);
  gc_frame_newslot(obj9870);
if (objclass9870 == NULL) {
  glfree(obj9870->class->name);
  obj9870->class->name = "commentNode.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9870, self, 0);
  addmethodreal(obj9870,"outer", &reader_ast_outer_9871);
  Object oldself9870 = self;
  struct StackFrameObject *oldstackframe9870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9870);
  gc_frame_newslot((Object)stackframe);
  self = obj9870;
  Object *oldselfslot9870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9870 = (*(struct UserObject *)self).data[0], lowerouter9870 = thisouter9870;
  if (inheritingObject9870) {
    struct UserObject *inho9870 = (struct UserObject *)inheritingObject9870;
    while (inho9870->super != GraceDefaultObject) inho9870 = (struct UserObject *)inho9870->super;
    inho9870->super = obj9870;
    self = inheritingObject9870;
    *selfslot = self;
    lowerouter9870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9870;
  }
if (objclass9870 == NULL) {
  Method *reader9872 = addmethodrealflags(obj9870, "kind",&reader_ast_kind_9872, MFLAG_DEF);
  reader9872->definitionModule = modulename;
  reader9872->definitionLine = 2561;
}
adddatum2(obj9870, alloc_Undefined(), 1);
if (objclass9870 == NULL) {
  Method *reader9873 = addmethodrealflags(obj9870, "value",&reader_ast_value_9873, 0);
  Method *writer9873 = addmethodrealflags(obj9870, "value:=",&writer_ast_value_9873, 0);
  reader9873->definitionModule = modulename;
  writer9873->definitionModule = modulename;
  reader9873->definitionLine = 2562;
  writer9873->definitionLine = 2562;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 2);
if (objclass9870 == NULL) {
  Method *reader9874 = addmethodrealflags(obj9870, "isPartialLine",&reader_ast_isPartialLine_9874, 0);
  Method *writer9874 = addmethodrealflags(obj9870, "isPartialLine:=",&writer_ast_isPartialLine_9874, 0);
  reader9874->definitionModule = modulename;
  writer9874->definitionModule = modulename;
  reader9874->definitionLine = 2563;
  writer9874->definitionLine = 2563;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 3);
if (objclass9870 == NULL) {
  Method *reader9875 = addmethodrealflags(obj9870, "isPreceededByBlankLine",&reader_ast_isPreceededByBlankLine_9875, 0);
  Method *writer9875 = addmethodrealflags(obj9870, "isPreceededByBlankLine:=",&writer_ast_isPreceededByBlankLine_9875, 0);
  reader9875->definitionModule = modulename;
  writer9875->definitionModule = modulename;
  reader9875->definitionLine = 2564;
  writer9875->definitionLine = 2564;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 4);
if (objclass9870 == NULL) {
  Method *reader9876 = addmethodrealflags(obj9870, "endLine",&reader_ast_endLine_9876, 0);
  Method *writer9876 = addmethodrealflags(obj9870, "endLine:=",&writer_ast_endLine_9876, 0);
  reader9876->definitionModule = modulename;
  writer9876->definitionModule = modulename;
  reader9876->definitionLine = 2565;
  writer9876->definitionLine = 2565;
}
obj9870->flags |= OFLAG_MUTABLE;
adddatum2(obj9870, alloc_Undefined(), 5);
// method "isComment"
  struct UserObject *uo9877 = (struct UserObject*)obj9870;
  uo9877->data[6] = emptyclosure;
  Method *meth_meth_ast_isComment9877 = addmethod2pos(obj9870, "isComment", &meth_ast_isComment9877, 6);
  int argcv_meth_ast_isComment9877[] = {0};
  meth_meth_ast_isComment9877->type = alloc_MethodType(1, argcv_meth_ast_isComment9877);
  meth_meth_ast_isComment9877->definitionModule = modulename;
  meth_meth_ast_isComment9877->definitionLine = 2566;
// method "isLegalInTrait"
  struct UserObject *uo9879 = (struct UserObject*)obj9870;
  uo9879->data[7] = emptyclosure;
  Method *meth_meth_ast_isLegalInTrait9879 = addmethod2pos(obj9870, "isLegalInTrait", &meth_ast_isLegalInTrait9879, 7);
  int argcv_meth_ast_isLegalInTrait9879[] = {0};
  meth_meth_ast_isLegalInTrait9879->type = alloc_MethodType(1, argcv_meth_ast_isLegalInTrait9879);
  meth_meth_ast_isLegalInTrait9879->definitionModule = modulename;
  meth_meth_ast_isLegalInTrait9879->definitionLine = 2567;
// method "isExecutable"
  struct UserObject *uo9881 = (struct UserObject*)obj9870;
  uo9881->data[8] = emptyclosure;
  Method *meth_meth_ast_isExecutable9881 = addmethod2pos(obj9870, "isExecutable", &meth_ast_isExecutable9881, 8);
  int argcv_meth_ast_isExecutable9881[] = {0};
  meth_meth_ast_isExecutable9881->type = alloc_MethodType(1, argcv_meth_ast_isExecutable9881);
  meth_meth_ast_isExecutable9881->definitionModule = modulename;
  meth_meth_ast_isExecutable9881->definitionLine = 2568;
// method "asString"
  struct UserObject *uo9883 = (struct UserObject*)obj9870;
  uo9883->data[9] = emptyclosure;
  Method *meth_meth_ast_asString9883 = addmethod2pos(obj9870, "asString", &meth_ast_asString9883, 9);
  int argcv_meth_ast_asString9883[] = {0};
  meth_meth_ast_asString9883->type = alloc_MethodType(1, argcv_meth_ast_asString9883);
  meth_meth_ast_asString9883->definitionModule = modulename;
  meth_meth_ast_asString9883->definitionLine = 2569;
// method "extendCommentUsing"
  struct UserObject *uo9912 = (struct UserObject*)obj9870;
  uo9912->data[10] = emptyclosure;
  Method *meth_meth_ast_extendCommentUsing9912 = addmethod2pos(obj9870, "extendCommentUsing", &meth_ast_extendCommentUsing9912, 10);
  int argcv_meth_ast_extendCommentUsing9912[] = {1};
  meth_meth_ast_extendCommentUsing9912->type = alloc_MethodType(1, argcv_meth_ast_extendCommentUsing9912);
  meth_meth_ast_extendCommentUsing9912->definitionModule = modulename;
  meth_meth_ast_extendCommentUsing9912->definitionLine = 2570;
// method "map()ancestors"
  struct UserObject *uo9930 = (struct UserObject*)obj9870;
  uo9930->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_ancestors9930 = addmethod2pos(obj9870, "map()ancestors", &meth_ast_map_40__41_ancestors9930, 11);
  int argcv_meth_ast_map_40__41_ancestors9930[] = {1, 1};
  meth_meth_ast_map_40__41_ancestors9930->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_ancestors9930);
  meth_meth_ast_map_40__41_ancestors9930->definitionModule = modulename;
  meth_meth_ast_map_40__41_ancestors9930->definitionLine = 2574;
// method "accept()from"
  struct UserObject *uo9937 = (struct UserObject*)obj9870;
  uo9937->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9937 = addmethod2pos(obj9870, "accept()from", &meth_ast_accept_40__41_from9937, 12);
  int argcv_meth_ast_accept_40__41_from9937[] = {1, 1};
  meth_meth_ast_accept_40__41_from9937->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9937);
  meth_meth_ast_accept_40__41_from9937->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9937->definitionLine = 2579;
// method "pretty"
  struct UserObject *uo9940 = (struct UserObject*)obj9870;
  uo9940->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty9940 = addmethod2pos(obj9870, "pretty", &meth_ast_pretty9940, 13);
  int argcv_meth_ast_pretty9940[] = {1};
  meth_meth_ast_pretty9940->type = alloc_MethodType(1, argcv_meth_ast_pretty9940);
  meth_meth_ast_pretty9940->definitionModule = modulename;
  meth_meth_ast_pretty9940->definitionLine = 2582;
// method "toGrace"
  block_savedest(obj9870);
  Object closure10003 = createclosure(1, "toGrace");
  setclosureframe(closure10003, stackframe);
  addtoclosure(closure10003, var_lineLength);
  struct UserObject *uo10003 = (struct UserObject*)obj9870;
  uo10003->data[14] = (Object)closure10003;
  Method *meth_meth_ast_toGrace10003 = addmethod2pos(obj9870, "toGrace", &meth_ast_toGrace10003, 14);
  int argcv_meth_ast_toGrace10003[] = {1};
  meth_meth_ast_toGrace10003->type = alloc_MethodType(1, argcv_meth_ast_toGrace10003);
  meth_meth_ast_toGrace10003->definitionModule = modulename;
  meth_meth_ast_toGrace10003->definitionLine = 2590;
// method "shallowCopy"
  block_savedest(obj9870);
  Object closure10040 = createclosure(2, "shallowCopy");
  setclosureframe(closure10040, stackframe);
  addtoclosure(closure10040, var_nullNode);
  addtoclosure(closure10040, var_commentNode);
  struct UserObject *uo10040 = (struct UserObject*)obj9870;
  uo10040->data[15] = (Object)closure10040;
  Method *meth_meth_ast_shallowCopy10040 = addmethod2pos(obj9870, "shallowCopy", &meth_ast_shallowCopy10040, 15);
  int argcv_meth_ast_shallowCopy10040[] = {0};
  meth_meth_ast_shallowCopy10040->type = alloc_MethodType(1, argcv_meth_ast_shallowCopy10040);
  meth_meth_ast_shallowCopy10040->definitionModule = modulename;
  meth_meth_ast_shallowCopy10040->definitionLine = 2601;
// method "shallowCopyFieldsFrom"
  struct UserObject *uo10045 = (struct UserObject*)obj9870;
  uo10045->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom10045 = addmethod2pos(obj9870, "shallowCopyFieldsFrom", &meth_ast_shallowCopyFieldsFrom10045, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom10045[] = {1};
  meth_meth_ast_shallowCopyFieldsFrom10045->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyFieldsFrom10045);
  meth_meth_ast_shallowCopyFieldsFrom10045->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom10045->definitionLine = 2604;
  sourceObject = obj9870;
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10060 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10061 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10062 = gc_frame_new();
// call case 3: self.outer request
  Object call10063 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10062);
// compiled call node returning call10063 (depth = 7)
// compiled member node returning call10063 (depth = 6)
  partcv[0] = 0;
  Object call10064 = callmethodflags(call10063, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10061);
// compiled call node returning call10064 (depth = 5)
// compiled member node returning call10064 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10065 = callmethodflags(call10064, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10060);
// compiled call node returning call10065 (depth = 3)
  struct UserObject *obj9870_uo = (struct UserObject *)obj9870;
  obj9870_uo->super = call10065;
  sourceObject = obj9870;
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit10066 == NULL) {
    strlit10066 = alloc_String("comment");
    gc_root(strlit10066);
  }
// compiled string node returning strlit10066 (depth = 3)
  adddatum2(obj9870, strlit10066, 1);
  sourceObject = obj9870;
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val_39_ (depth = 3)
  adddatum2(obj9870, *var_val_39_, 2);
  sourceObject = obj9870;
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10067 = alloc_Boolean(0);
// compiled identifier node returning bool10067 (depth = 3)
  adddatum2(obj9870, bool10067, 3);
  sourceObject = obj9870;
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10068 = alloc_Boolean(0);
// compiled identifier node returning bool10068 (depth = 3)
  adddatum2(obj9870, bool10068, 4);
  sourceObject = obj9870;
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  partcv[0] = 0;
  Object call10070 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe10069);
// compiled call node returning call10070 (depth = 4)
// compiled member node returning call10070 (depth = 3)
  adddatum2(obj9870, call10070, 5);
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  sourceObject = obj9870;
  objclass9870 = obj9870->class;
  objclass9870->definitionModule = modulename;
  objclass9870->definitionLine = 2559;
  (*(struct UserObject *)self).data[0] = lowerouter9870;
  self = oldself9870;
  selfslot = oldselfslot9870;
  stackframe = oldstackframe9870;
  gc_frame_end(frame);
  return obj9870;
}
Object meth_ast_commentNode10072(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "commentNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_commentNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for commentNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for commentNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_commentNode (depth = 3)
  gc_frame_end(frame);
  return *var_commentNode;
}
Object meth_ast_ASTVisitor10075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ASTVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40__41_up10078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for visitCall");
  Object *var_as = &(stackframe->slots[1]);
  *var_as = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10079 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10080 = alloc_Boolean(1);
// compiled identifier node returning bool10080 (depth = 4)
  gc_frame_newslot(bool10080);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  params[0] = bool10080;
  partcv[0] = 1;
  Object call10081 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe10079);
// compiled call node returning call10081 (depth = 3)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool10082 = alloc_Boolean(1);
// compiled identifier node returning bool10082 (depth = 3)
  gc_frame_end(frame);
  return bool10082;
}
Object meth_ast_patternMarkVisitor10087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for patternMarkVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(57, 57);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(57, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
  Object *var_util = alloc_var();
  Object *var_k = alloc_var();
  Object *var_lineLength = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineLength");
  Object *var_ancestorChain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ancestorChain");
  Object *var_emptySeq = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "AstNode");
  Object *var_SymbolTable = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "SymbolTable");
  Object *var_nullNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nullNode");
  Object *var_fakeSymbolTable = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "fakeSymbolTable");
  Object *var_ifNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "ifNode");
  Object *var_blockNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "blockNode");
  Object *var_tryCatchNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tryCatchNode");
  Object *var_matchCaseNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "methodNode");
  Object *var_callNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "callNode");
  Object *var_moduleNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "moduleNode");
  Object *var_objectNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "memberNode");
  Object *var_genericNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "genericNode");
  Object *var_typeParametersNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "typeParametersNode");
  Object *var_identifierNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "identifierNode");
  Object *var_typeType = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "typeType");
  Object *var_unknownType = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "unknownType");
  Object *var_stringNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "stringNode");
  Object *var_numNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "numNode");
  Object *var_opNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "opNode");
  Object *var_bindNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "varDecNode");
  Object *var_importNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "importNode");
  Object *var_dialectNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "inheritsNode");
  Object *var_AliasPair = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "AliasPair");
  Object *var_blankNode = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "signaturePart");
  Object *var_callWithPart = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "callWithPart");
  Object *var_commentNode = &(stackframe->slots[40]);
  setframeelementname(stackframe, 40, "commentNode");
  Object *var_ASTVisitor = &(stackframe->slots[41]);
  setframeelementname(stackframe, 41, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[42]);
  setframeelementname(stackframe, 42, "patternMarkVisitor");
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "listMap()ancestors"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_ast_listMap_40__41_ancestors1 = addmethod2pos(self, "listMap()ancestors", &meth_ast_listMap_40__41_ancestors1, 1);
  int argcv_meth_ast_listMap_40__41_ancestors1[] = {2, 1};
  meth_meth_ast_listMap_40__41_ancestors1->type = alloc_MethodType(2, argcv_meth_ast_listMap_40__41_ancestors1);
  meth_meth_ast_listMap_40__41_ancestors1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_listMap_40__41_ancestors1->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_ancestors1->definitionLine = 18;
// compiled method node returning  (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeMap()ancestors"
  struct UserObject *uo12 = (struct UserObject*)self;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40__41_ancestors12 = addmethod2pos(self, "maybeMap()ancestors", &meth_ast_maybeMap_40__41_ancestors12, 2);
  int argcv_meth_ast_maybeMap_40__41_ancestors12[] = {2, 1};
  meth_meth_ast_maybeMap_40__41_ancestors12->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40__41_ancestors12);
  meth_meth_ast_maybeMap_40__41_ancestors12->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeMap_40__41_ancestors12->definitionModule = modulename;
  meth_meth_ast_maybeMap_40__41_ancestors12->definitionLine = 23;
// compiled method node returning  (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "maybeListMap()ancestors"
  struct UserObject *uo20 = (struct UserObject*)self;
  uo20->data[3] = emptyclosure;
  Method *meth_meth_ast_maybeListMap_40__41_ancestors20 = addmethod2pos(self, "maybeListMap()ancestors", &meth_ast_maybeListMap_40__41_ancestors20, 3);
  int argcv_meth_ast_maybeListMap_40__41_ancestors20[] = {2, 1};
  meth_meth_ast_maybeListMap_40__41_ancestors20->type = alloc_MethodType(2, argcv_meth_ast_maybeListMap_40__41_ancestors20);
  meth_meth_ast_maybeListMap_40__41_ancestors20->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_maybeListMap_40__41_ancestors20->definitionModule = modulename;
  meth_meth_ast_maybeListMap_40__41_ancestors20->definitionLine = 30;
// compiled method node returning  (depth = 1)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseNode"
  block_savedest(self);
  Object closure28 = createclosure(4, "baseNode");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_unknownType);
  addtoclosure(closure28, var_ancestorChain);
  addtoclosure(closure28, var_util);
  addtoclosure(closure28, var_fakeSymbolTable);
  struct UserObject *uo28 = (struct UserObject*)self;
  uo28->data[4] = (Object)closure28;
  Method *meth_meth_ast_baseNode28 = addmethod2pos(self, "baseNode", &meth_ast_baseNode28, 4);
  int argcv_meth_ast_baseNode28[] = {0};
  meth_meth_ast_baseNode28->type = alloc_MethodType(1, argcv_meth_ast_baseNode28);
  meth_meth_ast_baseNode28->definitionModule = modulename;
  meth_meth_ast_baseNode28->definitionLine = 86;
  block_savedest(self);
  Object closure404 = createclosure(4, "baseNode()object");
  setclosureframe(closure404, stackframe);
  addtoclosure(closure404, var_unknownType);
  addtoclosure(closure404, var_ancestorChain);
  addtoclosure(closure404, var_util);
  addtoclosure(closure404, var_fakeSymbolTable);
  Method *meth_meth_ast_baseNode28_object = addmethod2pos(self, "baseNode()object", &meth_ast_baseNode28_object, 4);
  meth_meth_ast_baseNode28_object->definitionModule = modulename;
  meth_meth_ast_baseNode28_object->definitionLine = 86;
// compiled method node returning  (depth = 1)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "aliasNew()old"
  block_savedest(self);
  Object closure405 = createclosure(1, "aliasNew()old");
  setclosureframe(closure405, stackframe);
  addtoclosure(closure405, var_AliasPair);
  struct UserObject *uo405 = (struct UserObject*)self;
  uo405->data[5] = (Object)closure405;
  Method *meth_meth_ast_aliasNew_40__41_old405 = addmethod2pos(self, "aliasNew()old", &meth_ast_aliasNew_40__41_old405, 5);
  int argcv_meth_ast_aliasNew_40__41_old405[] = {1, 1};
  meth_meth_ast_aliasNew_40__41_old405->type = alloc_MethodType(2, argcv_meth_ast_aliasNew_40__41_old405);
  meth_meth_ast_aliasNew_40__41_old405->definitionModule = modulename;
  meth_meth_ast_aliasNew_40__41_old405->definitionLine = 2396;
  block_savedest(self);
  Object closure517 = createclosure(1, "aliasNew()old()object");
  setclosureframe(closure517, stackframe);
  addtoclosure(closure517, var_AliasPair);
  Method *meth_meth_ast_aliasNew_40__41_old405_object = addmethod2pos(self, "aliasNew()old()object", &meth_ast_aliasNew_40__41_old405_object, 5);
  meth_meth_ast_aliasNew_40__41_old405_object->definitionModule = modulename;
  meth_meth_ast_aliasNew_40__41_old405_object->definitionLine = 2396;
// compiled method node returning  (depth = 1)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "wrap()to()prefix"
  struct UserObject *uo518 = (struct UserObject*)self;
  uo518->data[6] = emptyclosure;
  Method *meth_meth_ast_wrap_40__41_to_40__41_prefix518 = addmethod2pos(self, "wrap()to()prefix", &meth_ast_wrap_40__41_to_40__41_prefix518, 6);
  int argcv_meth_ast_wrap_40__41_to_40__41_prefix518[] = {1, 1, 1};
  meth_meth_ast_wrap_40__41_to_40__41_prefix518->type = alloc_MethodType(3, argcv_meth_ast_wrap_40__41_to_40__41_prefix518);
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->types[0] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->names[0] = "str";
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->types[1] = type_Number;
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->names[1] = "l";
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->types[2] = type_String;
meth_meth_ast_wrap_40__41_to_40__41_prefix518->type->names[2] = "margin";
  meth_meth_ast_wrap_40__41_to_40__41_prefix518->definitionModule = modulename;
  meth_meth_ast_wrap_40__41_to_40__41_prefix518->definitionLine = 2614;
// compiled method node returning  (depth = 1)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "baseVisitor"
  struct UserObject *uo688 = (struct UserObject*)self;
  uo688->data[7] = emptyclosure;
  Method *meth_meth_ast_baseVisitor688 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor688, 7);
  int argcv_meth_ast_baseVisitor688[] = {0};
  meth_meth_ast_baseVisitor688->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor688);
  meth_meth_ast_baseVisitor688->definitionModule = modulename;
  meth_meth_ast_baseVisitor688->definitionLine = 2680;
  Method *meth_meth_ast_baseVisitor688_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor688_object, 7);
  int argcv_meth_ast_baseVisitor688_object[] = {0};
  meth_meth_ast_baseVisitor688_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor688_object);
  meth_meth_ast_baseVisitor688_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor688_object->definitionLine = 2680;
// compiled method node returning  (depth = 1)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pluggableVisitor"
  struct UserObject *uo839 = (struct UserObject*)self;
  uo839->data[8] = emptyclosure;
  Method *meth_meth_ast_pluggableVisitor839 = addmethod2pos(self, "pluggableVisitor", &meth_ast_pluggableVisitor839, 8);
  int argcv_meth_ast_pluggableVisitor839[] = {1};
  meth_meth_ast_pluggableVisitor839->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor839);
  meth_meth_ast_pluggableVisitor839->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor839->definitionLine = 2744;
  Method *meth_meth_ast_pluggableVisitor839_object = addmethod2pos(self, "pluggableVisitor()object", &meth_ast_pluggableVisitor839_object, 8);
  int argcv_meth_ast_pluggableVisitor839_object[] = {1};
  meth_meth_ast_pluggableVisitor839_object->type = alloc_MethodType(1, argcv_meth_ast_pluggableVisitor839_object);
  meth_meth_ast_pluggableVisitor839_object->definitionModule = modulename;
  meth_meth_ast_pluggableVisitor839_object->definitionLine = 2744;
// compiled method node returning  (depth = 1)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findAnnotation"
  struct UserObject *uo929 = (struct UserObject*)self;
  uo929->data[9] = emptyclosure;
  Method *meth_meth_ast_findAnnotation929 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation929, 9);
  int argcv_meth_ast_findAnnotation929[] = {2};
  meth_meth_ast_findAnnotation929->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation929);
  meth_meth_ast_findAnnotation929->definitionModule = modulename;
  meth_meth_ast_findAnnotation929->definitionLine = 2792;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of identifierKinds as k
  if (module_identifierKinds == NULL)
    module_identifierKinds = LOAD_MODULE(identifierKinds);
  *var_k = module_identifierKinds;
// compiled import node returning done (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num960 = alloc_Float64(80);
// compiled num node returning num960 (depth = 2)
  *var_lineLength = num960;
  if (num960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lineLength"
  block_savedest(self);
  Object closure961 = createclosure(1, "lineLength");
  setclosureframe(closure961, stackframe);
  addtoclosure(closure961, var_lineLength);
  struct UserObject *uo961 = (struct UserObject*)self;
  uo961->data[10] = (Object)closure961;
  Method *meth_meth_ast_lineLength961 = addmethod2pos(self, "lineLength", &meth_ast_lineLength961, 10);
  int argcv_meth_ast_lineLength961[] = {0};
  meth_meth_ast_lineLength961->type = alloc_MethodType(1, argcv_meth_ast_lineLength961);
  meth_meth_ast_lineLength961->definitionModule = modulename;
  meth_meth_ast_lineLength961->definitionLine = 2794;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject962 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj962 = alloc_userobj2(5,6, objclass962);
  gc_frame_newslot(obj962);
if (objclass962 == NULL) {
  glfree(obj962->class->name);
  obj962->class->name = "ancestorChain";
}
// OBJECT OUTER DEC outer
  adddatum2(obj962, self, 0);
  addmethodreal(obj962,"outer", &reader_ast_outer_963);
  Object oldself962 = self;
  struct StackFrameObject *oldstackframe962 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe962);
  gc_frame_newslot((Object)stackframe);
  self = obj962;
  Object *oldselfslot962 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter962 = (*(struct UserObject *)self).data[0], lowerouter962 = thisouter962;
  if (inheritingObject962) {
    struct UserObject *inho962 = (struct UserObject *)inheritingObject962;
    while (inho962->super != GraceDefaultObject) inho962 = (struct UserObject *)inho962->super;
    inho962->super = obj962;
    self = inheritingObject962;
    *selfslot = self;
    lowerouter962 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter962;
  }
// method "empty"
  struct UserObject *uo964 = (struct UserObject*)obj962;
  uo964->data[1] = emptyclosure;
  Method *meth_meth_ast_empty964 = addmethod2pos(obj962, "empty", &meth_ast_empty964, 1);
  int argcv_meth_ast_empty964[] = {0};
  meth_meth_ast_empty964->type = alloc_MethodType(1, argcv_meth_ast_empty964);
  meth_meth_ast_empty964->definitionModule = modulename;
  meth_meth_ast_empty964->definitionLine = 39;
  Method *meth_meth_ast_empty964_object = addmethod2pos(obj962, "empty()object", &meth_ast_empty964_object, 1);
  int argcv_meth_ast_empty964_object[] = {0};
  meth_meth_ast_empty964_object->type = alloc_MethodType(1, argcv_meth_ast_empty964_object);
  meth_meth_ast_empty964_object->definitionModule = modulename;
  meth_meth_ast_empty964_object->definitionLine = 39;
// method "with"
  struct UserObject *uo977 = (struct UserObject*)obj962;
  uo977->data[2] = emptyclosure;
  Method *meth_meth_ast_with977 = addmethod2pos(obj962, "with", &meth_ast_with977, 2);
  int argcv_meth_ast_with977[] = {1};
  meth_meth_ast_with977->type = alloc_MethodType(1, argcv_meth_ast_with977);
  meth_meth_ast_with977->definitionModule = modulename;
  meth_meth_ast_with977->definitionLine = 44;
// method "cons()onto"
  struct UserObject *uo982 = (struct UserObject*)obj962;
  uo982->data[3] = emptyclosure;
  Method *meth_meth_ast_cons_40__41_onto982 = addmethod2pos(obj962, "cons()onto", &meth_ast_cons_40__41_onto982, 3);
  int argcv_meth_ast_cons_40__41_onto982[] = {1, 1};
  meth_meth_ast_cons_40__41_onto982->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto982);
  meth_meth_ast_cons_40__41_onto982->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto982->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto982->definitionLine = 45;
  Method *meth_meth_ast_cons_40__41_onto982_object = addmethod2pos(obj962, "cons()onto()object", &meth_ast_cons_40__41_onto982_object, 3);
  int argcv_meth_ast_cons_40__41_onto982_object[] = {1, 1};
  meth_meth_ast_cons_40__41_onto982_object->type = alloc_MethodType(2, argcv_meth_ast_cons_40__41_onto982_object);
  meth_meth_ast_cons_40__41_onto982_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_ast_cons_40__41_onto982_object->definitionModule = modulename;
  meth_meth_ast_cons_40__41_onto982_object->definitionLine = 45;
  sourceObject = obj962;
  sourceObject = obj962;
  sourceObject = obj962;
  objclass962 = obj962->class;
  objclass962->definitionModule = modulename;
  objclass962->definitionLine = 38;
  (*(struct UserObject *)self).data[0] = lowerouter962;
  self = oldself962;
  selfslot = oldselfslot962;
  stackframe = oldstackframe962;
// compiled object node returning obj962 (depth = 2)
  *var_ancestorChain = obj962;
  if (obj962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "ancestorChain"
  block_savedest(self);
  Object closure1031 = createclosure(1, "ancestorChain");
  setclosureframe(closure1031, stackframe);
  addtoclosure(closure1031, var_ancestorChain);
  struct UserObject *uo1031 = (struct UserObject*)self;
  uo1031->data[11] = (Object)closure1031;
  Method *meth_meth_ast_ancestorChain1031 = addmethod2pos(self, "ancestorChain", &meth_ast_ancestorChain1031, 11);
  int argcv_meth_ast_ancestorChain1031[] = {0};
  meth_meth_ast_ancestorChain1031->type = alloc_MethodType(1, argcv_meth_ast_ancestorChain1031);
  meth_meth_ast_ancestorChain1031->definitionModule = modulename;
  meth_meth_ast_ancestorChain1031->definitionLine = 60;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1032 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1033 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1032);
// compiled call node returning call1033 (depth = 3)
// compiled member node returning call1033 (depth = 2)
  *var_emptySeq = call1033;
  if (call1033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "emptySeq"
  block_savedest(self);
  Object closure1034 = createclosure(1, "emptySeq");
  setclosureframe(closure1034, stackframe);
  addtoclosure(closure1034, var_emptySeq);
  struct UserObject *uo1034 = (struct UserObject*)self;
  uo1034->data[12] = (Object)closure1034;
  Method *meth_meth_ast_emptySeq1034 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq1034, 12);
  int argcv_meth_ast_emptySeq1034[] = {0};
  meth_meth_ast_emptySeq1034->type = alloc_MethodType(1, argcv_meth_ast_emptySeq1034);
  meth_meth_ast_emptySeq1034->definitionModule = modulename;
  meth_meth_ast_emptySeq1034->definitionLine = 64;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type1036 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type1036, "kind", NULL);
    add_Method((ClassData)type1036, "register", NULL);
    add_Method((ClassData)type1036, "line", NULL);
    add_Method((ClassData)type1036, "line:=", NULL);
    add_Method((ClassData)type1036, "linePos", NULL);
    add_Method((ClassData)type1036, "linePos:=", NULL);
    add_Method((ClassData)type1036, "scope", NULL);
    add_Method((ClassData)type1036, "pretty", NULL);
    add_Method((ClassData)type1036, "comments", NULL);
// compiled typeliteral node returning type1036 (depth = 2)
  *var_AstNode = type1036;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AstNode"
  block_savedest(self);
  Object closure1037 = createclosure(1, "AstNode");
  setclosureframe(closure1037, stackframe);
  addtoclosure(closure1037, var_AstNode);
  struct UserObject *uo1037 = (struct UserObject*)self;
  uo1037->data[13] = (Object)closure1037;
  Method *meth_meth_ast_AstNode1037 = addmethod2pos(self, "AstNode", &meth_ast_AstNode1037, 13);
  int argcv_meth_ast_AstNode1037[] = {0};
  meth_meth_ast_AstNode1037->type = alloc_MethodType(1, argcv_meth_ast_AstNode1037);
  meth_meth_ast_AstNode1037->definitionModule = modulename;
  meth_meth_ast_AstNode1037->definitionLine = 64;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SymbolTable
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SymbolTable = *var_Unknown;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SymbolTable"
  block_savedest(self);
  Object closure1039 = createclosure(1, "SymbolTable");
  setclosureframe(closure1039, stackframe);
  addtoclosure(closure1039, var_SymbolTable);
  struct UserObject *uo1039 = (struct UserObject*)self;
  uo1039->data[14] = (Object)closure1039;
  Method *meth_meth_ast_SymbolTable1039 = addmethod2pos(self, "SymbolTable", &meth_ast_SymbolTable1039, 14);
  int argcv_meth_ast_SymbolTable1039[] = {0};
  meth_meth_ast_SymbolTable1039->type = alloc_MethodType(1, argcv_meth_ast_SymbolTable1039);
  meth_meth_ast_SymbolTable1039->definitionModule = modulename;
  meth_meth_ast_SymbolTable1039->definitionLine = 64;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1040 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1040 = alloc_userobj2(4,5, objclass1040);
  gc_frame_newslot(obj1040);
if (objclass1040 == NULL) {
  glfree(obj1040->class->name);
  obj1040->class->name = "nullNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1040, self, 0);
  addmethodreal(obj1040,"outer", &reader_ast_outer_1041);
  Object oldself1040 = self;
  struct StackFrameObject *oldstackframe1040 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1040);
  gc_frame_newslot((Object)stackframe);
  self = obj1040;
  Object *oldselfslot1040 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1040 = (*(struct UserObject *)self).data[0], lowerouter1040 = thisouter1040;
  if (inheritingObject1040) {
    struct UserObject *inho1040 = (struct UserObject *)inheritingObject1040;
    while (inho1040->super != GraceDefaultObject) inho1040 = (struct UserObject *)inho1040->super;
    inho1040->super = obj1040;
    self = inheritingObject1040;
    *selfslot = self;
    lowerouter1040 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1040;
  }
if (objclass1040 == NULL) {
  Method *reader1042 = addmethodrealflags(obj1040, "kind",&reader_ast_kind_1042, MFLAG_DEF);
  reader1042->definitionModule = modulename;
  reader1042->definitionLine = 190;
}
adddatum2(obj1040, alloc_Undefined(), 1);
// method "toGrace"
  struct UserObject *uo1043 = (struct UserObject*)obj1040;
  uo1043->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace1043 = addmethod2pos(obj1040, "toGrace", &meth_ast_toGrace1043, 2);
  int argcv_meth_ast_toGrace1043[] = {1};
  meth_meth_ast_toGrace1043->type = alloc_MethodType(1, argcv_meth_ast_toGrace1043);
  meth_meth_ast_toGrace1043->definitionModule = modulename;
  meth_meth_ast_toGrace1043->definitionLine = 191;
// method "asString"
  struct UserObject *uo1045 = (struct UserObject*)obj1040;
  uo1045->data[3] = emptyclosure;
  Method *meth_meth_ast_asString1045 = addmethod2pos(obj1040, "asString", &meth_ast_asString1045, 3);
  int argcv_meth_ast_asString1045[] = {0};
  meth_meth_ast_asString1045->type = alloc_MethodType(1, argcv_meth_ast_asString1045);
  meth_meth_ast_asString1045->definitionModule = modulename;
  meth_meth_ast_asString1045->definitionLine = 194;
// method "=="
  struct UserObject *uo1047 = (struct UserObject*)obj1040;
  uo1047->data[4] = emptyclosure;
  Method *meth_meth_ast__61__61_1047 = addmethod2pos(obj1040, "==", &meth_ast__61__61_1047, 4);
  int argcv_meth_ast__61__61_1047[] = {1};
  meth_meth_ast__61__61_1047->type = alloc_MethodType(1, argcv_meth_ast__61__61_1047);
  meth_meth_ast__61__61_1047->definitionModule = modulename;
  meth_meth_ast__61__61_1047->definitionLine = 195;
  sourceObject = obj1040;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1050 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1051 = gc_frame_new();
// call case 3: self.outer request
  Object call1052 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1051);
// compiled call node returning call1052 (depth = 5)
// compiled member node returning call1052 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1053 = callmethodflags(call1052, "baseNode()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1050);
// compiled call node returning call1053 (depth = 3)
  struct UserObject *obj1040_uo = (struct UserObject *)obj1040;
  obj1040_uo->super = call1053;
  sourceObject = obj1040;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit1054 == NULL) {
    strlit1054 = alloc_String("null");
    gc_root(strlit1054);
  }
// compiled string node returning strlit1054 (depth = 3)
  adddatum2(obj1040, strlit1054, 1);
  sourceObject = obj1040;
  sourceObject = obj1040;
  sourceObject = obj1040;
  objclass1040 = obj1040->class;
  objclass1040->definitionModule = modulename;
  objclass1040->definitionLine = 188;
  (*(struct UserObject *)self).data[0] = lowerouter1040;
  self = oldself1040;
  selfslot = oldselfslot1040;
  stackframe = oldstackframe1040;
// compiled object node returning obj1040 (depth = 2)
  *var_nullNode = obj1040;
  if (obj1040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "nullNode"
  block_savedest(self);
  Object closure1055 = createclosure(1, "nullNode");
  setclosureframe(closure1055, stackframe);
  addtoclosure(closure1055, var_nullNode);
  struct UserObject *uo1055 = (struct UserObject*)self;
  uo1055->data[15] = (Object)closure1055;
  Method *meth_meth_ast_nullNode1055 = addmethod2pos(self, "nullNode", &meth_ast_nullNode1055, 15);
  int argcv_meth_ast_nullNode1055[] = {0};
  meth_meth_ast_nullNode1055->type = alloc_MethodType(1, argcv_meth_ast_nullNode1055);
  meth_meth_ast_nullNode1055->definitionModule = modulename;
  meth_meth_ast_nullNode1055->definitionLine = 189;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1056 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1056 = alloc_userobj2(8,8, objclass1056);
  gc_frame_newslot(obj1056);
if (objclass1056 == NULL) {
  glfree(obj1056->class->name);
  obj1056->class->name = "fakeSymbolTable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1056, self, 0);
  addmethodreal(obj1056,"outer", &reader_ast_outer_1057);
  Object oldself1056 = self;
  struct StackFrameObject *oldstackframe1056 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1056);
  gc_frame_newslot((Object)stackframe);
  self = obj1056;
  Object *oldselfslot1056 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1056 = (*(struct UserObject *)self).data[0], lowerouter1056 = thisouter1056;
  if (inheritingObject1056) {
    struct UserObject *inho1056 = (struct UserObject *)inheritingObject1056;
    while (inho1056->super != GraceDefaultObject) inho1056 = (struct UserObject *)inho1056->super;
    inho1056->super = obj1056;
    self = inheritingObject1056;
    *selfslot = self;
    lowerouter1056 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1056;
  }
if (objclass1056 == NULL) {
  Method *reader1058 = addmethodrealflags(obj1056, "node",&reader_ast_node_1058, 0);
  Method *writer1058 = addmethodrealflags(obj1056, "node:=",&writer_ast_node_1058, 0);
  reader1058->definitionModule = modulename;
  writer1058->definitionModule = modulename;
  reader1058->definitionLine = 199;
  writer1058->definitionLine = 199;
}
obj1056->flags |= OFLAG_MUTABLE;
adddatum2(obj1056, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo1059 = (struct UserObject*)obj1056;
  uo1059->data[2] = emptyclosure;
  Method *meth_meth_ast_asString1059 = addmethod2pos(obj1056, "asString", &meth_ast_asString1059, 2);
  int argcv_meth_ast_asString1059[] = {0};
  meth_meth_ast_asString1059->type = alloc_MethodType(1, argcv_meth_ast_asString1059);
  meth_meth_ast_asString1059->definitionModule = modulename;
  meth_meth_ast_asString1059->definitionLine = 200;
// method "addNode()as"
  struct UserObject *uo1061 = (struct UserObject*)obj1056;
  uo1061->data[3] = emptyclosure;
  Method *meth_meth_ast_addNode_40__41_as1061 = addmethod2pos(obj1056, "addNode()as", &meth_ast_addNode_40__41_as1061, 3);
  int argcv_meth_ast_addNode_40__41_as1061[] = {1, 1};
  meth_meth_ast_addNode_40__41_as1061->type = alloc_MethodType(2, argcv_meth_ast_addNode_40__41_as1061);
  meth_meth_ast_addNode_40__41_as1061->definitionModule = modulename;
  meth_meth_ast_addNode_40__41_as1061->definitionLine = 201;
// method "thatDefines()ifNone"
  struct UserObject *uo1090 = (struct UserObject*)obj1056;
  uo1090->data[4] = emptyclosure;
  Method *meth_meth_ast_thatDefines_40__41_ifNone1090 = addmethod2pos(obj1056, "thatDefines()ifNone", &meth_ast_thatDefines_40__41_ifNone1090, 4);
  int argcv_meth_ast_thatDefines_40__41_ifNone1090[] = {1, 1};
  meth_meth_ast_thatDefines_40__41_ifNone1090->type = alloc_MethodType(2, argcv_meth_ast_thatDefines_40__41_ifNone1090);
  meth_meth_ast_thatDefines_40__41_ifNone1090->definitionModule = modulename;
  meth_meth_ast_thatDefines_40__41_ifNone1090->definitionLine = 204;
// method "enclosingObjectScope"
  struct UserObject *uo1103 = (struct UserObject*)obj1056;
  uo1103->data[5] = emptyclosure;
  Method *meth_meth_ast_enclosingObjectScope1103 = addmethod2pos(obj1056, "enclosingObjectScope", &meth_ast_enclosingObjectScope1103, 5);
  int argcv_meth_ast_enclosingObjectScope1103[] = {0};
  meth_meth_ast_enclosingObjectScope1103->type = alloc_MethodType(1, argcv_meth_ast_enclosingObjectScope1103);
  meth_meth_ast_enclosingObjectScope1103->definitionModule = modulename;
  meth_meth_ast_enclosingObjectScope1103->definitionLine = 207;
// method "variety"
  struct UserObject *uo1118 = (struct UserObject*)obj1056;
  uo1118->data[6] = emptyclosure;
  Method *meth_meth_ast_variety1118 = addmethod2pos(obj1056, "variety", &meth_ast_variety1118, 6);
  int argcv_meth_ast_variety1118[] = {0};
  meth_meth_ast_variety1118->type = alloc_MethodType(1, argcv_meth_ast_variety1118);
  meth_meth_ast_variety1118->definitionModule = modulename;
  meth_meth_ast_variety1118->definitionLine = 210;
// method "=="
  struct UserObject *uo1120 = (struct UserObject*)obj1056;
  uo1120->data[7] = emptyclosure;
  Method *meth_meth_ast__61__61_1120 = addmethod2pos(obj1056, "==", &meth_ast__61__61_1120, 7);
  int argcv_meth_ast__61__61_1120[] = {1};
  meth_meth_ast__61__61_1120->type = alloc_MethodType(1, argcv_meth_ast__61__61_1120);
  meth_meth_ast__61__61_1120->definitionModule = modulename;
  meth_meth_ast__61__61_1120->definitionLine = 211;
  sourceObject = obj1056;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  adddatum2(obj1056, *var_nullNode, 1);
  sourceObject = obj1056;
  sourceObject = obj1056;
  sourceObject = obj1056;
  sourceObject = obj1056;
  sourceObject = obj1056;
  sourceObject = obj1056;
  objclass1056 = obj1056->class;
  objclass1056->definitionModule = modulename;
  objclass1056->definitionLine = 198;
  (*(struct UserObject *)self).data[0] = lowerouter1056;
  self = oldself1056;
  selfslot = oldselfslot1056;
  stackframe = oldstackframe1056;
// compiled object node returning obj1056 (depth = 2)
  *var_fakeSymbolTable = obj1056;
  if (obj1056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "fakeSymbolTable"
  block_savedest(self);
  Object closure1123 = createclosure(1, "fakeSymbolTable");
  setclosureframe(closure1123, stackframe);
  addtoclosure(closure1123, var_fakeSymbolTable);
  struct UserObject *uo1123 = (struct UserObject*)self;
  uo1123->data[16] = (Object)closure1123;
  Method *meth_meth_ast_fakeSymbolTable1123 = addmethod2pos(self, "fakeSymbolTable", &meth_ast_fakeSymbolTable1123, 16);
  int argcv_meth_ast_fakeSymbolTable1123[] = {0};
  meth_meth_ast_fakeSymbolTable1123->type = alloc_MethodType(1, argcv_meth_ast_fakeSymbolTable1123);
  meth_meth_ast_fakeSymbolTable1123->definitionModule = modulename;
  meth_meth_ast_fakeSymbolTable1123->definitionLine = 208;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1124 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1124 = alloc_userobj2(2,4, objclass1124);
  gc_frame_newslot(obj1124);
if (objclass1124 == NULL) {
  glfree(obj1124->class->name);
  obj1124->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1124, self, 0);
  addmethodreal(obj1124,"outer", &reader_ast_outer_1125);
  Object oldself1124 = self;
  struct StackFrameObject *oldstackframe1124 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1124);
  gc_frame_newslot((Object)stackframe);
  self = obj1124;
  Object *oldselfslot1124 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1124 = (*(struct UserObject *)self).data[0], lowerouter1124 = thisouter1124;
  if (inheritingObject1124) {
    struct UserObject *inho1124 = (struct UserObject *)inheritingObject1124;
    while (inho1124->super != GraceDefaultObject) inho1124 = (struct UserObject *)inho1124->super;
    inho1124->super = obj1124;
    self = inheritingObject1124;
    *selfslot = self;
    lowerouter1124 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1124;
  }
// method "new"
  block_savedest(obj1124);
  Object closure1126 = createclosure(3, "new");
  setclosureframe(closure1126, stackframe);
  addtoclosure(closure1126, var_util);
  addtoclosure(closure1126, var_nullNode);
  addtoclosure(closure1126, var_ifNode);
  struct UserObject *uo1126 = (struct UserObject*)obj1124;
  uo1126->data[1] = (Object)closure1126;
  Method *meth_meth_ast_new1126 = addmethod2pos(obj1124, "new", &meth_ast_new1126, 1);
  int argcv_meth_ast_new1126[] = {3};
  meth_meth_ast_new1126->type = alloc_MethodType(1, argcv_meth_ast_new1126);
  meth_meth_ast_new1126->definitionModule = modulename;
  meth_meth_ast_new1126->definitionLine = 215;
  block_savedest(obj1124);
  Object closure1481 = createclosure(3, "new()object");
  setclosureframe(closure1481, stackframe);
  addtoclosure(closure1481, var_util);
  addtoclosure(closure1481, var_nullNode);
  addtoclosure(closure1481, var_ifNode);
  Method *meth_meth_ast_new1126_object = addmethod2pos(obj1124, "new()object", &meth_ast_new1126_object, 1);
  meth_meth_ast_new1126_object->definitionModule = modulename;
  meth_meth_ast_new1126_object->definitionLine = 215;
  sourceObject = obj1124;
  objclass1124 = obj1124->class;
  objclass1124->definitionModule = modulename;
  objclass1124->definitionLine = 214;
  (*(struct UserObject *)self).data[0] = lowerouter1124;
  self = oldself1124;
  selfslot = oldselfslot1124;
  stackframe = oldstackframe1124;
// compiled object node returning obj1124 (depth = 2)
  *var_ifNode = obj1124;
  if (obj1124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ifNode"
  block_savedest(self);
  Object closure1482 = createclosure(1, "ifNode");
  setclosureframe(closure1482, stackframe);
  addtoclosure(closure1482, var_ifNode);
  struct UserObject *uo1482 = (struct UserObject*)self;
  uo1482->data[17] = (Object)closure1482;
  Method *meth_meth_ast_ifNode1482 = addmethod2pos(self, "ifNode", &meth_ast_ifNode1482, 17);
  int argcv_meth_ast_ifNode1482[] = {0};
  meth_meth_ast_ifNode1482->type = alloc_MethodType(1, argcv_meth_ast_ifNode1482);
  meth_meth_ast_ifNode1482->definitionModule = modulename;
  meth_meth_ast_ifNode1482->definitionLine = 216;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1483 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1483 = alloc_userobj2(2,4, objclass1483);
  gc_frame_newslot(obj1483);
if (objclass1483 == NULL) {
  glfree(obj1483->class->name);
  obj1483->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1483, self, 0);
  addmethodreal(obj1483,"outer", &reader_ast_outer_1484);
  Object oldself1483 = self;
  struct StackFrameObject *oldstackframe1483 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1483);
  gc_frame_newslot((Object)stackframe);
  self = obj1483;
  Object *oldselfslot1483 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1483 = (*(struct UserObject *)self).data[0], lowerouter1483 = thisouter1483;
  if (inheritingObject1483) {
    struct UserObject *inho1483 = (struct UserObject *)inheritingObject1483;
    while (inho1483->super != GraceDefaultObject) inho1483 = (struct UserObject *)inho1483->super;
    inho1483->super = obj1483;
    self = inheritingObject1483;
    *selfslot = self;
    lowerouter1483 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1483;
  }
// method "new"
  block_savedest(obj1483);
  Object closure1485 = createclosure(4, "new");
  setclosureframe(closure1485, stackframe);
  addtoclosure(closure1485, var_k);
  addtoclosure(closure1485, var_blockNode);
  addtoclosure(closure1485, var_patternMarkVisitor);
  addtoclosure(closure1485, var_ancestorChain);
  struct UserObject *uo1485 = (struct UserObject*)obj1483;
  uo1485->data[1] = (Object)closure1485;
  Method *meth_meth_ast_new1485 = addmethod2pos(obj1483, "new", &meth_ast_new1485, 1);
  int argcv_meth_ast_new1485[] = {2};
  meth_meth_ast_new1485->type = alloc_MethodType(1, argcv_meth_ast_new1485);
  meth_meth_ast_new1485->definitionModule = modulename;
  meth_meth_ast_new1485->definitionLine = 292;
  block_savedest(obj1483);
  Object closure1942 = createclosure(4, "new()object");
  setclosureframe(closure1942, stackframe);
  addtoclosure(closure1942, var_k);
  addtoclosure(closure1942, var_blockNode);
  addtoclosure(closure1942, var_patternMarkVisitor);
  addtoclosure(closure1942, var_ancestorChain);
  Method *meth_meth_ast_new1485_object = addmethod2pos(obj1483, "new()object", &meth_ast_new1485_object, 1);
  meth_meth_ast_new1485_object->definitionModule = modulename;
  meth_meth_ast_new1485_object->definitionLine = 292;
  sourceObject = obj1483;
  objclass1483 = obj1483->class;
  objclass1483->definitionModule = modulename;
  objclass1483->definitionLine = 291;
  (*(struct UserObject *)self).data[0] = lowerouter1483;
  self = oldself1483;
  selfslot = oldselfslot1483;
  stackframe = oldstackframe1483;
// compiled object node returning obj1483 (depth = 2)
  *var_blockNode = obj1483;
  if (obj1483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blockNode"
  block_savedest(self);
  Object closure1943 = createclosure(1, "blockNode");
  setclosureframe(closure1943, stackframe);
  addtoclosure(closure1943, var_blockNode);
  struct UserObject *uo1943 = (struct UserObject*)self;
  uo1943->data[18] = (Object)closure1943;
  Method *meth_meth_ast_blockNode1943 = addmethod2pos(self, "blockNode", &meth_ast_blockNode1943, 18);
  int argcv_meth_ast_blockNode1943[] = {0};
  meth_meth_ast_blockNode1943->type = alloc_MethodType(1, argcv_meth_ast_blockNode1943);
  meth_meth_ast_blockNode1943->definitionModule = modulename;
  meth_meth_ast_blockNode1943->definitionLine = 293;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject1944 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1944 = alloc_userobj2(2,4, objclass1944);
  gc_frame_newslot(obj1944);
if (objclass1944 == NULL) {
  glfree(obj1944->class->name);
  obj1944->class->name = "tryCatchNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1944, self, 0);
  addmethodreal(obj1944,"outer", &reader_ast_outer_1945);
  Object oldself1944 = self;
  struct StackFrameObject *oldstackframe1944 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1944);
  gc_frame_newslot((Object)stackframe);
  self = obj1944;
  Object *oldselfslot1944 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1944 = (*(struct UserObject *)self).data[0], lowerouter1944 = thisouter1944;
  if (inheritingObject1944) {
    struct UserObject *inho1944 = (struct UserObject *)inheritingObject1944;
    while (inho1944->super != GraceDefaultObject) inho1944 = (struct UserObject *)inho1944->super;
    inho1944->super = obj1944;
    self = inheritingObject1944;
    *selfslot = self;
    lowerouter1944 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1944;
  }
// method "new"
  block_savedest(obj1944);
  Object closure1946 = createclosure(3, "new");
  setclosureframe(closure1946, stackframe);
  addtoclosure(closure1946, var_nullNode);
  addtoclosure(closure1946, var_emptySeq);
  addtoclosure(closure1946, var_tryCatchNode);
  struct UserObject *uo1946 = (struct UserObject*)obj1944;
  uo1946->data[1] = (Object)closure1946;
  Method *meth_meth_ast_new1946 = addmethod2pos(obj1944, "new", &meth_ast_new1946, 1);
  int argcv_meth_ast_new1946[] = {3};
  meth_meth_ast_new1946->type = alloc_MethodType(1, argcv_meth_ast_new1946);
  meth_meth_ast_new1946->definitionModule = modulename;
  meth_meth_ast_new1946->definitionLine = 409;
  block_savedest(obj1944);
  Object closure2254 = createclosure(3, "new()object");
  setclosureframe(closure2254, stackframe);
  addtoclosure(closure2254, var_nullNode);
  addtoclosure(closure2254, var_emptySeq);
  addtoclosure(closure2254, var_tryCatchNode);
  Method *meth_meth_ast_new1946_object = addmethod2pos(obj1944, "new()object", &meth_ast_new1946_object, 1);
  meth_meth_ast_new1946_object->definitionModule = modulename;
  meth_meth_ast_new1946_object->definitionLine = 409;
  sourceObject = obj1944;
  objclass1944 = obj1944->class;
  objclass1944->definitionModule = modulename;
  objclass1944->definitionLine = 408;
  (*(struct UserObject *)self).data[0] = lowerouter1944;
  self = oldself1944;
  selfslot = oldselfslot1944;
  stackframe = oldstackframe1944;
// compiled object node returning obj1944 (depth = 2)
  *var_tryCatchNode = obj1944;
  if (obj1944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tryCatchNode"
  block_savedest(self);
  Object closure2255 = createclosure(1, "tryCatchNode");
  setclosureframe(closure2255, stackframe);
  addtoclosure(closure2255, var_tryCatchNode);
  struct UserObject *uo2255 = (struct UserObject*)self;
  uo2255->data[19] = (Object)closure2255;
  Method *meth_meth_ast_tryCatchNode2255 = addmethod2pos(self, "tryCatchNode", &meth_ast_tryCatchNode2255, 19);
  int argcv_meth_ast_tryCatchNode2255[] = {0};
  meth_meth_ast_tryCatchNode2255->type = alloc_MethodType(1, argcv_meth_ast_tryCatchNode2255);
  meth_meth_ast_tryCatchNode2255->definitionModule = modulename;
  meth_meth_ast_tryCatchNode2255->definitionLine = 410;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2256 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2256 = alloc_userobj2(2,4, objclass2256);
  gc_frame_newslot(obj2256);
if (objclass2256 == NULL) {
  glfree(obj2256->class->name);
  obj2256->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2256, self, 0);
  addmethodreal(obj2256,"outer", &reader_ast_outer_2257);
  Object oldself2256 = self;
  struct StackFrameObject *oldstackframe2256 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2256);
  gc_frame_newslot((Object)stackframe);
  self = obj2256;
  Object *oldselfslot2256 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2256 = (*(struct UserObject *)self).data[0], lowerouter2256 = thisouter2256;
  if (inheritingObject2256) {
    struct UserObject *inho2256 = (struct UserObject *)inheritingObject2256;
    while (inho2256->super != GraceDefaultObject) inho2256 = (struct UserObject *)inho2256->super;
    inho2256->super = obj2256;
    self = inheritingObject2256;
    *selfslot = self;
    lowerouter2256 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2256;
  }
// method "new"
  block_savedest(obj2256);
  Object closure2258 = createclosure(3, "new");
  setclosureframe(closure2258, stackframe);
  addtoclosure(closure2258, var_nullNode);
  addtoclosure(closure2258, var_emptySeq);
  addtoclosure(closure2258, var_matchCaseNode);
  struct UserObject *uo2258 = (struct UserObject*)obj2256;
  uo2258->data[1] = (Object)closure2258;
  Method *meth_meth_ast_new2258 = addmethod2pos(obj2256, "new", &meth_ast_new2258, 1);
  int argcv_meth_ast_new2258[] = {3};
  meth_meth_ast_new2258->type = alloc_MethodType(1, argcv_meth_ast_new2258);
  meth_meth_ast_new2258->definitionModule = modulename;
  meth_meth_ast_new2258->definitionLine = 472;
  block_savedest(obj2256);
  Object closure2562 = createclosure(3, "new()object");
  setclosureframe(closure2562, stackframe);
  addtoclosure(closure2562, var_nullNode);
  addtoclosure(closure2562, var_emptySeq);
  addtoclosure(closure2562, var_matchCaseNode);
  Method *meth_meth_ast_new2258_object = addmethod2pos(obj2256, "new()object", &meth_ast_new2258_object, 1);
  meth_meth_ast_new2258_object->definitionModule = modulename;
  meth_meth_ast_new2258_object->definitionLine = 472;
  sourceObject = obj2256;
  objclass2256 = obj2256->class;
  objclass2256->definitionModule = modulename;
  objclass2256->definitionLine = 471;
  (*(struct UserObject *)self).data[0] = lowerouter2256;
  self = oldself2256;
  selfslot = oldselfslot2256;
  stackframe = oldstackframe2256;
// compiled object node returning obj2256 (depth = 2)
  *var_matchCaseNode = obj2256;
  if (obj2256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "matchCaseNode"
  block_savedest(self);
  Object closure2563 = createclosure(1, "matchCaseNode");
  setclosureframe(closure2563, stackframe);
  addtoclosure(closure2563, var_matchCaseNode);
  struct UserObject *uo2563 = (struct UserObject*)self;
  uo2563->data[20] = (Object)closure2563;
  Method *meth_meth_ast_matchCaseNode2563 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode2563, 20);
  int argcv_meth_ast_matchCaseNode2563[] = {0};
  meth_meth_ast_matchCaseNode2563->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode2563);
  meth_meth_ast_matchCaseNode2563->definitionModule = modulename;
  meth_meth_ast_matchCaseNode2563->definitionLine = 473;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2564 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2564 = alloc_userobj2(2,4, objclass2564);
  gc_frame_newslot(obj2564);
if (objclass2564 == NULL) {
  glfree(obj2564->class->name);
  obj2564->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2564, self, 0);
  addmethodreal(obj2564,"outer", &reader_ast_outer_2565);
  Object oldself2564 = self;
  struct StackFrameObject *oldstackframe2564 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2564);
  gc_frame_newslot((Object)stackframe);
  self = obj2564;
  Object *oldselfslot2564 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2564 = (*(struct UserObject *)self).data[0], lowerouter2564 = thisouter2564;
  if (inheritingObject2564) {
    struct UserObject *inho2564 = (struct UserObject *)inheritingObject2564;
    while (inho2564->super != GraceDefaultObject) inho2564 = (struct UserObject *)inho2564->super;
    inho2564->super = obj2564;
    self = inheritingObject2564;
    *selfslot = self;
    lowerouter2564 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2564;
  }
// method "new"
  block_savedest(obj2564);
  Object closure2566 = createclosure(3, "new");
  setclosureframe(closure2566, stackframe);
  addtoclosure(closure2566, var_k);
  addtoclosure(closure2566, var_emptySeq);
  addtoclosure(closure2566, var_methodTypeNode);
  struct UserObject *uo2566 = (struct UserObject*)obj2564;
  uo2566->data[1] = (Object)closure2566;
  Method *meth_meth_ast_new2566 = addmethod2pos(obj2564, "new", &meth_ast_new2566, 1);
  int argcv_meth_ast_new2566[] = {3};
  meth_meth_ast_new2566->type = alloc_MethodType(1, argcv_meth_ast_new2566);
  meth_meth_ast_new2566->definitionModule = modulename;
  meth_meth_ast_new2566->definitionLine = 535;
  block_savedest(obj2564);
  Object closure2985 = createclosure(3, "new()object");
  setclosureframe(closure2985, stackframe);
  addtoclosure(closure2985, var_k);
  addtoclosure(closure2985, var_emptySeq);
  addtoclosure(closure2985, var_methodTypeNode);
  Method *meth_meth_ast_new2566_object = addmethod2pos(obj2564, "new()object", &meth_ast_new2566_object, 1);
  meth_meth_ast_new2566_object->definitionModule = modulename;
  meth_meth_ast_new2566_object->definitionLine = 535;
  sourceObject = obj2564;
  objclass2564 = obj2564->class;
  objclass2564->definitionModule = modulename;
  objclass2564->definitionLine = 534;
  (*(struct UserObject *)self).data[0] = lowerouter2564;
  self = oldself2564;
  selfslot = oldselfslot2564;
  stackframe = oldstackframe2564;
// compiled object node returning obj2564 (depth = 2)
  *var_methodTypeNode = obj2564;
  if (obj2564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "methodTypeNode"
  block_savedest(self);
  Object closure2986 = createclosure(1, "methodTypeNode");
  setclosureframe(closure2986, stackframe);
  addtoclosure(closure2986, var_methodTypeNode);
  struct UserObject *uo2986 = (struct UserObject*)self;
  uo2986->data[21] = (Object)closure2986;
  Method *meth_meth_ast_methodTypeNode2986 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode2986, 21);
  int argcv_meth_ast_methodTypeNode2986[] = {0};
  meth_meth_ast_methodTypeNode2986->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode2986);
  meth_meth_ast_methodTypeNode2986->definitionModule = modulename;
  meth_meth_ast_methodTypeNode2986->definitionLine = 545;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject2987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2987 = alloc_userobj2(2,4, objclass2987);
  gc_frame_newslot(obj2987);
if (objclass2987 == NULL) {
  glfree(obj2987->class->name);
  obj2987->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2987, self, 0);
  addmethodreal(obj2987,"outer", &reader_ast_outer_2988);
  Object oldself2987 = self;
  struct StackFrameObject *oldstackframe2987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2987);
  gc_frame_newslot((Object)stackframe);
  self = obj2987;
  Object *oldselfslot2987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2987 = (*(struct UserObject *)self).data[0], lowerouter2987 = thisouter2987;
  if (inheritingObject2987) {
    struct UserObject *inho2987 = (struct UserObject *)inheritingObject2987;
    while (inho2987->super != GraceDefaultObject) inho2987 = (struct UserObject *)inho2987->super;
    inho2987->super = obj2987;
    self = inheritingObject2987;
    *selfslot = self;
    lowerouter2987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2987;
  }
// method "new"
  block_savedest(obj2987);
  Object closure2989 = createclosure(3, "new");
  setclosureframe(closure2989, stackframe);
  addtoclosure(closure2989, var_k);
  addtoclosure(closure2989, var_emptySeq);
  addtoclosure(closure2989, var_typeLiteralNode);
  struct UserObject *uo2989 = (struct UserObject*)obj2987;
  uo2989->data[1] = (Object)closure2989;
  Method *meth_meth_ast_new2989 = addmethod2pos(obj2987, "new", &meth_ast_new2989, 1);
  int argcv_meth_ast_new2989[] = {2};
  meth_meth_ast_new2989->type = alloc_MethodType(1, argcv_meth_ast_new2989);
  meth_meth_ast_new2989->definitionModule = modulename;
  meth_meth_ast_new2989->definitionLine = 636;
  block_savedest(obj2987);
  Object closure3298 = createclosure(3, "new()object");
  setclosureframe(closure3298, stackframe);
  addtoclosure(closure3298, var_k);
  addtoclosure(closure3298, var_emptySeq);
  addtoclosure(closure3298, var_typeLiteralNode);
  Method *meth_meth_ast_new2989_object = addmethod2pos(obj2987, "new()object", &meth_ast_new2989_object, 1);
  meth_meth_ast_new2989_object->definitionModule = modulename;
  meth_meth_ast_new2989_object->definitionLine = 636;
  sourceObject = obj2987;
  objclass2987 = obj2987->class;
  objclass2987->definitionModule = modulename;
  objclass2987->definitionLine = 635;
  (*(struct UserObject *)self).data[0] = lowerouter2987;
  self = oldself2987;
  selfslot = oldselfslot2987;
  stackframe = oldstackframe2987;
// compiled object node returning obj2987 (depth = 2)
  *var_typeLiteralNode = obj2987;
  if (obj2987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeLiteralNode"
  block_savedest(self);
  Object closure3299 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure3299, stackframe);
  addtoclosure(closure3299, var_typeLiteralNode);
  struct UserObject *uo3299 = (struct UserObject*)self;
  uo3299->data[22] = (Object)closure3299;
  Method *meth_meth_ast_typeLiteralNode3299 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode3299, 22);
  int argcv_meth_ast_typeLiteralNode3299[] = {0};
  meth_meth_ast_typeLiteralNode3299->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode3299);
  meth_meth_ast_typeLiteralNode3299->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode3299->definitionLine = 637;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3300 = alloc_userobj2(2,4, objclass3300);
  gc_frame_newslot(obj3300);
if (objclass3300 == NULL) {
  glfree(obj3300->class->name);
  obj3300->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3300, self, 0);
  addmethodreal(obj3300,"outer", &reader_ast_outer_3301);
  Object oldself3300 = self;
  struct StackFrameObject *oldstackframe3300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3300);
  gc_frame_newslot((Object)stackframe);
  self = obj3300;
  Object *oldselfslot3300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3300 = (*(struct UserObject *)self).data[0], lowerouter3300 = thisouter3300;
  if (inheritingObject3300) {
    struct UserObject *inho3300 = (struct UserObject *)inheritingObject3300;
    while (inho3300->super != GraceDefaultObject) inho3300 = (struct UserObject *)inho3300->super;
    inho3300->super = obj3300;
    self = inheritingObject3300;
    *selfslot = self;
    lowerouter3300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3300;
  }
// method "new"
  block_savedest(obj3300);
  Object closure3302 = createclosure(3, "new");
  setclosureframe(closure3302, stackframe);
  addtoclosure(closure3302, var_k);
  addtoclosure(closure3302, var_nullNode);
  addtoclosure(closure3302, var_typeDecNode);
  struct UserObject *uo3302 = (struct UserObject*)obj3300;
  uo3302->data[1] = (Object)closure3302;
  Method *meth_meth_ast_new3302 = addmethod2pos(obj3300, "new", &meth_ast_new3302, 1);
  int argcv_meth_ast_new3302[] = {2};
  meth_meth_ast_new3302->type = alloc_MethodType(1, argcv_meth_ast_new3302);
  meth_meth_ast_new3302->definitionModule = modulename;
  meth_meth_ast_new3302->definitionLine = 720;
  block_savedest(obj3300);
  Object closure3628 = createclosure(3, "new()object");
  setclosureframe(closure3628, stackframe);
  addtoclosure(closure3628, var_k);
  addtoclosure(closure3628, var_nullNode);
  addtoclosure(closure3628, var_typeDecNode);
  Method *meth_meth_ast_new3302_object = addmethod2pos(obj3300, "new()object", &meth_ast_new3302_object, 1);
  meth_meth_ast_new3302_object->definitionModule = modulename;
  meth_meth_ast_new3302_object->definitionLine = 720;
  sourceObject = obj3300;
  objclass3300 = obj3300->class;
  objclass3300->definitionModule = modulename;
  objclass3300->definitionLine = 719;
  (*(struct UserObject *)self).data[0] = lowerouter3300;
  self = oldself3300;
  selfslot = oldselfslot3300;
  stackframe = oldstackframe3300;
// compiled object node returning obj3300 (depth = 2)
  *var_typeDecNode = obj3300;
  if (obj3300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeDecNode"
  block_savedest(self);
  Object closure3629 = createclosure(1, "typeDecNode");
  setclosureframe(closure3629, stackframe);
  addtoclosure(closure3629, var_typeDecNode);
  struct UserObject *uo3629 = (struct UserObject*)self;
  uo3629->data[23] = (Object)closure3629;
  Method *meth_meth_ast_typeDecNode3629 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode3629, 23);
  int argcv_meth_ast_typeDecNode3629[] = {0};
  meth_meth_ast_typeDecNode3629->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode3629);
  meth_meth_ast_typeDecNode3629->definitionModule = modulename;
  meth_meth_ast_typeDecNode3629->definitionLine = 725;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject3630 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3630 = alloc_userobj2(3,4, objclass3630);
  gc_frame_newslot(obj3630);
if (objclass3630 == NULL) {
  glfree(obj3630->class->name);
  obj3630->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3630, self, 0);
  addmethodreal(obj3630,"outer", &reader_ast_outer_3631);
  Object oldself3630 = self;
  struct StackFrameObject *oldstackframe3630 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3630);
  gc_frame_newslot((Object)stackframe);
  self = obj3630;
  Object *oldselfslot3630 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3630 = (*(struct UserObject *)self).data[0], lowerouter3630 = thisouter3630;
  if (inheritingObject3630) {
    struct UserObject *inho3630 = (struct UserObject *)inheritingObject3630;
    while (inho3630->super != GraceDefaultObject) inho3630 = (struct UserObject *)inho3630->super;
    inho3630->super = obj3630;
    self = inheritingObject3630;
    *selfslot = self;
    lowerouter3630 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3630;
  }
// method "new()scope"
  struct UserObject *uo3632 = (struct UserObject*)obj3630;
  uo3632->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope3632 = addmethod2pos(obj3630, "new()scope", &meth_ast_new_40__41_scope3632, 1);
  int argcv_meth_ast_new_40__41_scope3632[] = {4, 1};
  meth_meth_ast_new_40__41_scope3632->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope3632);
  meth_meth_ast_new_40__41_scope3632->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope3632->definitionLine = 805;
// method "new"
  block_savedest(obj3630);
  Object closure3637 = createclosure(2, "new");
  setclosureframe(closure3637, stackframe);
  addtoclosure(closure3637, var_k);
  addtoclosure(closure3637, var_methodNode);
  struct UserObject *uo3637 = (struct UserObject*)obj3630;
  uo3637->data[2] = (Object)closure3637;
  Method *meth_meth_ast_new3637 = addmethod2pos(obj3630, "new", &meth_ast_new3637, 2);
  int argcv_meth_ast_new3637[] = {4};
  meth_meth_ast_new3637->type = alloc_MethodType(1, argcv_meth_ast_new3637);
  meth_meth_ast_new3637->definitionModule = modulename;
  meth_meth_ast_new3637->definitionLine = 811;
  block_savedest(obj3630);
  Object closure4570 = createclosure(2, "new()object");
  setclosureframe(closure4570, stackframe);
  addtoclosure(closure4570, var_k);
  addtoclosure(closure4570, var_methodNode);
  Method *meth_meth_ast_new3637_object = addmethod2pos(obj3630, "new()object", &meth_ast_new3637_object, 2);
  meth_meth_ast_new3637_object->definitionModule = modulename;
  meth_meth_ast_new3637_object->definitionLine = 811;
  sourceObject = obj3630;
  sourceObject = obj3630;
  objclass3630 = obj3630->class;
  objclass3630->definitionModule = modulename;
  objclass3630->definitionLine = 804;
  (*(struct UserObject *)self).data[0] = lowerouter3630;
  self = oldself3630;
  selfslot = oldselfslot3630;
  stackframe = oldstackframe3630;
// compiled object node returning obj3630 (depth = 2)
  *var_methodNode = obj3630;
  if (obj3630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "methodNode"
  block_savedest(self);
  Object closure4571 = createclosure(1, "methodNode");
  setclosureframe(closure4571, stackframe);
  addtoclosure(closure4571, var_methodNode);
  struct UserObject *uo4571 = (struct UserObject*)self;
  uo4571->data[24] = (Object)closure4571;
  Method *meth_meth_ast_methodNode4571 = addmethod2pos(self, "methodNode", &meth_ast_methodNode4571, 24);
  int argcv_meth_ast_methodNode4571[] = {0};
  meth_meth_ast_methodNode4571->type = alloc_MethodType(1, argcv_meth_ast_methodNode4571);
  meth_meth_ast_methodNode4571->definitionModule = modulename;
  meth_meth_ast_methodNode4571->definitionLine = 826;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject4572 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4572 = alloc_userobj2(3,4, objclass4572);
  gc_frame_newslot(obj4572);
if (objclass4572 == NULL) {
  glfree(obj4572->class->name);
  obj4572->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4572, self, 0);
  addmethodreal(obj4572,"outer", &reader_ast_outer_4573);
  Object oldself4572 = self;
  struct StackFrameObject *oldstackframe4572 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4572);
  gc_frame_newslot((Object)stackframe);
  self = obj4572;
  Object *oldselfslot4572 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4572 = (*(struct UserObject *)self).data[0], lowerouter4572 = thisouter4572;
  if (inheritingObject4572) {
    struct UserObject *inho4572 = (struct UserObject *)inheritingObject4572;
    while (inho4572->super != GraceDefaultObject) inho4572 = (struct UserObject *)inho4572->super;
    inho4572->super = obj4572;
    self = inheritingObject4572;
    *selfslot = self;
    lowerouter4572 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4572;
  }
// method "new()scope"
  struct UserObject *uo4574 = (struct UserObject*)obj4572;
  uo4574->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope4574 = addmethod2pos(obj4572, "new()scope", &meth_ast_new_40__41_scope4574, 1);
  int argcv_meth_ast_new_40__41_scope4574[] = {2, 1};
  meth_meth_ast_new_40__41_scope4574->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope4574);
  meth_meth_ast_new_40__41_scope4574->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope4574->definitionLine = 1011;
// method "new"
  block_savedest(obj4572);
  Object closure4579 = createclosure(1, "new");
  setclosureframe(closure4579, stackframe);
  addtoclosure(closure4579, var_callNode);
  struct UserObject *uo4579 = (struct UserObject*)obj4572;
  uo4579->data[2] = (Object)closure4579;
  Method *meth_meth_ast_new4579 = addmethod2pos(obj4572, "new", &meth_ast_new4579, 2);
  int argcv_meth_ast_new4579[] = {2};
  meth_meth_ast_new4579->type = alloc_MethodType(1, argcv_meth_ast_new4579);
  meth_meth_ast_new4579->definitionModule = modulename;
  meth_meth_ast_new4579->definitionLine = 1016;
  block_savedest(obj4572);
  Object closure5117 = createclosure(1, "new()object");
  setclosureframe(closure5117, stackframe);
  addtoclosure(closure5117, var_callNode);
  Method *meth_meth_ast_new4579_object = addmethod2pos(obj4572, "new()object", &meth_ast_new4579_object, 2);
  meth_meth_ast_new4579_object->definitionModule = modulename;
  meth_meth_ast_new4579_object->definitionLine = 1016;
  sourceObject = obj4572;
  sourceObject = obj4572;
  objclass4572 = obj4572->class;
  objclass4572->definitionModule = modulename;
  objclass4572->definitionLine = 1010;
  (*(struct UserObject *)self).data[0] = lowerouter4572;
  self = oldself4572;
  selfslot = oldselfslot4572;
  stackframe = oldstackframe4572;
// compiled object node returning obj4572 (depth = 2)
  *var_callNode = obj4572;
  if (obj4572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "callNode"
  block_savedest(self);
  Object closure5118 = createclosure(1, "callNode");
  setclosureframe(closure5118, stackframe);
  addtoclosure(closure5118, var_callNode);
  struct UserObject *uo5118 = (struct UserObject*)self;
  uo5118->data[25] = (Object)closure5118;
  Method *meth_meth_ast_callNode5118 = addmethod2pos(self, "callNode", &meth_ast_callNode5118, 25);
  int argcv_meth_ast_callNode5118[] = {0};
  meth_meth_ast_callNode5118->type = alloc_MethodType(1, argcv_meth_ast_callNode5118);
  meth_meth_ast_callNode5118->definitionModule = modulename;
  meth_meth_ast_callNode5118->definitionLine = 1040;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5119 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5119 = alloc_userobj2(4,5, objclass5119);
  gc_frame_newslot(obj5119);
if (objclass5119 == NULL) {
  glfree(obj5119->class->name);
  obj5119->class->name = "moduleNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5119, self, 0);
  addmethodreal(obj5119,"outer", &reader_ast_outer_5120);
  Object oldself5119 = self;
  struct StackFrameObject *oldstackframe5119 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5119);
  gc_frame_newslot((Object)stackframe);
  self = obj5119;
  Object *oldselfslot5119 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5119 = (*(struct UserObject *)self).data[0], lowerouter5119 = thisouter5119;
  if (inheritingObject5119) {
    struct UserObject *inho5119 = (struct UserObject *)inheritingObject5119;
    while (inho5119->super != GraceDefaultObject) inho5119 = (struct UserObject *)inho5119->super;
    inho5119->super = obj5119;
    self = inheritingObject5119;
    *selfslot = self;
    lowerouter5119 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5119;
  }
// method "body()named()scope"
  struct UserObject *uo5121 = (struct UserObject*)obj5119;
  uo5121->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope5121 = addmethod2pos(obj5119, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope5121, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope5121[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope5121->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope5121);
  meth_meth_ast_body_40__41_named_40__41_scope5121->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope5121->definitionLine = 1158;
// method "body()named"
  struct UserObject *uo5128 = (struct UserObject*)obj5119;
  uo5128->data[2] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named5128 = addmethod2pos(obj5119, "body()named", &meth_ast_body_40__41_named5128, 2);
  int argcv_meth_ast_body_40__41_named5128[] = {1, 1};
  meth_meth_ast_body_40__41_named5128->type = alloc_MethodType(2, argcv_meth_ast_body_40__41_named5128);
  meth_meth_ast_body_40__41_named5128->definitionModule = modulename;
  meth_meth_ast_body_40__41_named5128->definitionLine = 1164;
// method "body"
  block_savedest(obj5119);
  Object closure5133 = createclosure(4, "body");
  setclosureframe(closure5133, stackframe);
  addtoclosure(closure5133, var_emptySeq);
  addtoclosure(closure5133, var_moduleNode);
  addtoclosure(closure5133, var_objectNode);
  addtoclosure(closure5133, var_util);
  struct UserObject *uo5133 = (struct UserObject*)obj5119;
  uo5133->data[3] = (Object)closure5133;
  Method *meth_meth_ast_body5133 = addmethod2pos(obj5119, "body", &meth_ast_body5133, 3);
  int argcv_meth_ast_body5133[] = {1};
  meth_meth_ast_body5133->type = alloc_MethodType(1, argcv_meth_ast_body5133);
  meth_meth_ast_body5133->definitionModule = modulename;
  meth_meth_ast_body5133->definitionLine = 1169;
  block_savedest(obj5119);
  Object closure5207 = createclosure(4, "body()object");
  setclosureframe(closure5207, stackframe);
  addtoclosure(closure5207, var_emptySeq);
  addtoclosure(closure5207, var_moduleNode);
  addtoclosure(closure5207, var_objectNode);
  addtoclosure(closure5207, var_util);
  Method *meth_meth_ast_body5133_object = addmethod2pos(obj5119, "body()object", &meth_ast_body5133_object, 3);
  meth_meth_ast_body5133_object->definitionModule = modulename;
  meth_meth_ast_body5133_object->definitionLine = 1169;
  sourceObject = obj5119;
  sourceObject = obj5119;
  sourceObject = obj5119;
  objclass5119 = obj5119->class;
  objclass5119->definitionModule = modulename;
  objclass5119->definitionLine = 1157;
  (*(struct UserObject *)self).data[0] = lowerouter5119;
  self = oldself5119;
  selfslot = oldselfslot5119;
  stackframe = oldstackframe5119;
// compiled object node returning obj5119 (depth = 2)
  *var_moduleNode = obj5119;
  if (obj5119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleNode"
  block_savedest(self);
  Object closure5208 = createclosure(1, "moduleNode");
  setclosureframe(closure5208, stackframe);
  addtoclosure(closure5208, var_moduleNode);
  struct UserObject *uo5208 = (struct UserObject*)self;
  uo5208->data[26] = (Object)closure5208;
  Method *meth_meth_ast_moduleNode5208 = addmethod2pos(self, "moduleNode", &meth_ast_moduleNode5208, 26);
  int argcv_meth_ast_moduleNode5208[] = {0};
  meth_meth_ast_moduleNode5208->type = alloc_MethodType(1, argcv_meth_ast_moduleNode5208);
  meth_meth_ast_moduleNode5208->definitionModule = modulename;
  meth_meth_ast_moduleNode5208->definitionLine = 1172;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5209 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5209 = alloc_userobj2(4,5, objclass5209);
  gc_frame_newslot(obj5209);
if (objclass5209 == NULL) {
  glfree(obj5209->class->name);
  obj5209->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5209, self, 0);
  addmethodreal(obj5209,"outer", &reader_ast_outer_5210);
  Object oldself5209 = self;
  struct StackFrameObject *oldstackframe5209 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5209);
  gc_frame_newslot((Object)stackframe);
  self = obj5209;
  Object *oldselfslot5209 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5209 = (*(struct UserObject *)self).data[0], lowerouter5209 = thisouter5209;
  if (inheritingObject5209) {
    struct UserObject *inho5209 = (struct UserObject *)inheritingObject5209;
    while (inho5209->super != GraceDefaultObject) inho5209 = (struct UserObject *)inho5209->super;
    inho5209->super = obj5209;
    self = inheritingObject5209;
    *selfslot = self;
    lowerouter5209 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5209;
  }
// method "body()named()scope"
  struct UserObject *uo5211 = (struct UserObject*)obj5209;
  uo5211->data[1] = emptyclosure;
  Method *meth_meth_ast_body_40__41_named_40__41_scope5211 = addmethod2pos(obj5209, "body()named()scope", &meth_ast_body_40__41_named_40__41_scope5211, 1);
  int argcv_meth_ast_body_40__41_named_40__41_scope5211[] = {1, 1, 1};
  meth_meth_ast_body_40__41_named_40__41_scope5211->type = alloc_MethodType(3, argcv_meth_ast_body_40__41_named_40__41_scope5211);
  meth_meth_ast_body_40__41_named_40__41_scope5211->definitionModule = modulename;
  meth_meth_ast_body_40__41_named_40__41_scope5211->definitionLine = 1206;
// method "body()named"
  block_savedest(obj5209);
  Object closure5219 = createclosure(1, "body()named");
  setclosureframe(closure5219, stackframe);
  addtoclosure(closure5219, var_fakeSymbolTable);
  struct UserObject *uo5219 = (struct UserObject*)obj5209;
  uo5219->data[2] = (Object)closure5219;
  Method *meth_meth_ast_body_40__41_named5219 = addmethod2pos(obj5209, "body()named", &meth_ast_body_40__41_named5219, 2);
  int argcv_meth_ast_body_40__41_named5219[] = {1, 1};
  meth_meth_ast_body_40__41_named5219->type = alloc_MethodType(2, argcv_meth_ast_body_40__41_named5219);
  meth_meth_ast_body_40__41_named5219->definitionModule = modulename;
  meth_meth_ast_body_40__41_named5219->definitionLine = 1212;
// method "new"
  block_savedest(obj5209);
  Object closure5222 = createclosure(2, "new");
  setclosureframe(closure5222, stackframe);
  addtoclosure(closure5222, var_emptySeq);
  addtoclosure(closure5222, var_objectNode);
  struct UserObject *uo5222 = (struct UserObject*)obj5209;
  uo5222->data[3] = (Object)closure5222;
  Method *meth_meth_ast_new5222 = addmethod2pos(obj5209, "new", &meth_ast_new5222, 3);
  int argcv_meth_ast_new5222[] = {2};
  meth_meth_ast_new5222->type = alloc_MethodType(1, argcv_meth_ast_new5222);
  meth_meth_ast_new5222->definitionModule = modulename;
  meth_meth_ast_new5222->definitionLine = 1215;
  block_savedest(obj5209);
  Object closure5820 = createclosure(2, "new()object");
  setclosureframe(closure5820, stackframe);
  addtoclosure(closure5820, var_emptySeq);
  addtoclosure(closure5820, var_objectNode);
  Method *meth_meth_ast_new5222_object = addmethod2pos(obj5209, "new()object", &meth_ast_new5222_object, 3);
  meth_meth_ast_new5222_object->definitionModule = modulename;
  meth_meth_ast_new5222_object->definitionLine = 1215;
  sourceObject = obj5209;
  sourceObject = obj5209;
  sourceObject = obj5209;
  objclass5209 = obj5209->class;
  objclass5209->definitionModule = modulename;
  objclass5209->definitionLine = 1205;
  (*(struct UserObject *)self).data[0] = lowerouter5209;
  self = oldself5209;
  selfslot = oldselfslot5209;
  stackframe = oldstackframe5209;
// compiled object node returning obj5209 (depth = 2)
  *var_objectNode = obj5209;
  if (obj5209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "objectNode"
  block_savedest(self);
  Object closure5821 = createclosure(1, "objectNode");
  setclosureframe(closure5821, stackframe);
  addtoclosure(closure5821, var_objectNode);
  struct UserObject *uo5821 = (struct UserObject*)self;
  uo5821->data[27] = (Object)closure5821;
  Method *meth_meth_ast_objectNode5821 = addmethod2pos(self, "objectNode", &meth_ast_objectNode5821, 27);
  int argcv_meth_ast_objectNode5821[] = {0};
  meth_meth_ast_objectNode5821->type = alloc_MethodType(1, argcv_meth_ast_objectNode5821);
  meth_meth_ast_objectNode5821->definitionModule = modulename;
  meth_meth_ast_objectNode5821->definitionLine = 1216;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5822 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5822 = alloc_userobj2(2,4, objclass5822);
  gc_frame_newslot(obj5822);
if (objclass5822 == NULL) {
  glfree(obj5822->class->name);
  obj5822->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5822, self, 0);
  addmethodreal(obj5822,"outer", &reader_ast_outer_5823);
  Object oldself5822 = self;
  struct StackFrameObject *oldstackframe5822 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5822);
  gc_frame_newslot((Object)stackframe);
  self = obj5822;
  Object *oldselfslot5822 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5822 = (*(struct UserObject *)self).data[0], lowerouter5822 = thisouter5822;
  if (inheritingObject5822) {
    struct UserObject *inho5822 = (struct UserObject *)inheritingObject5822;
    while (inho5822->super != GraceDefaultObject) inho5822 = (struct UserObject *)inho5822->super;
    inho5822->super = obj5822;
    self = inheritingObject5822;
    *selfslot = self;
    lowerouter5822 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5822;
  }
// method "new"
  block_savedest(obj5822);
  Object closure5824 = createclosure(2, "new");
  setclosureframe(closure5824, stackframe);
  addtoclosure(closure5824, var_emptySeq);
  addtoclosure(closure5824, var_arrayNode);
  struct UserObject *uo5824 = (struct UserObject*)obj5822;
  uo5824->data[1] = (Object)closure5824;
  Method *meth_meth_ast_new5824 = addmethod2pos(obj5822, "new", &meth_ast_new5824, 1);
  int argcv_meth_ast_new5824[] = {1};
  meth_meth_ast_new5824->type = alloc_MethodType(1, argcv_meth_ast_new5824);
  meth_meth_ast_new5824->definitionModule = modulename;
  meth_meth_ast_new5824->definitionLine = 1382;
  block_savedest(obj5822);
  Object closure5955 = createclosure(2, "new()object");
  setclosureframe(closure5955, stackframe);
  addtoclosure(closure5955, var_emptySeq);
  addtoclosure(closure5955, var_arrayNode);
  Method *meth_meth_ast_new5824_object = addmethod2pos(obj5822, "new()object", &meth_ast_new5824_object, 1);
  meth_meth_ast_new5824_object->definitionModule = modulename;
  meth_meth_ast_new5824_object->definitionLine = 1382;
  sourceObject = obj5822;
  objclass5822 = obj5822->class;
  objclass5822->definitionModule = modulename;
  objclass5822->definitionLine = 1381;
  (*(struct UserObject *)self).data[0] = lowerouter5822;
  self = oldself5822;
  selfslot = oldselfslot5822;
  stackframe = oldstackframe5822;
// compiled object node returning obj5822 (depth = 2)
  *var_arrayNode = obj5822;
  if (obj5822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "arrayNode"
  block_savedest(self);
  Object closure5956 = createclosure(1, "arrayNode");
  setclosureframe(closure5956, stackframe);
  addtoclosure(closure5956, var_arrayNode);
  struct UserObject *uo5956 = (struct UserObject*)self;
  uo5956->data[28] = (Object)closure5956;
  Method *meth_meth_ast_arrayNode5956 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode5956, 28);
  int argcv_meth_ast_arrayNode5956[] = {0};
  meth_meth_ast_arrayNode5956->type = alloc_MethodType(1, argcv_meth_ast_arrayNode5956);
  meth_meth_ast_arrayNode5956->definitionModule = modulename;
  meth_meth_ast_arrayNode5956->definitionLine = 1383;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5957 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5957 = alloc_userobj2(3,4, objclass5957);
  gc_frame_newslot(obj5957);
if (objclass5957 == NULL) {
  glfree(obj5957->class->name);
  obj5957->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5957, self, 0);
  addmethodreal(obj5957,"outer", &reader_ast_outer_5958);
  Object oldself5957 = self;
  struct StackFrameObject *oldstackframe5957 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5957);
  gc_frame_newslot((Object)stackframe);
  self = obj5957;
  Object *oldselfslot5957 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5957 = (*(struct UserObject *)self).data[0], lowerouter5957 = thisouter5957;
  if (inheritingObject5957) {
    struct UserObject *inho5957 = (struct UserObject *)inheritingObject5957;
    while (inho5957->super != GraceDefaultObject) inho5957 = (struct UserObject *)inho5957->super;
    inho5957->super = obj5957;
    self = inheritingObject5957;
    *selfslot = self;
    lowerouter5957 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5957;
  }
// method "new()scope"
  struct UserObject *uo5959 = (struct UserObject*)obj5957;
  uo5959->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope5959 = addmethod2pos(obj5957, "new()scope", &meth_ast_new_40__41_scope5959, 1);
  int argcv_meth_ast_new_40__41_scope5959[] = {2, 1};
  meth_meth_ast_new_40__41_scope5959->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope5959);
  meth_meth_ast_new_40__41_scope5959->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope5959->definitionLine = 1428;
// method "new"
  block_savedest(obj5957);
  Object closure5964 = createclosure(4, "new");
  setclosureframe(closure5964, stackframe);
  addtoclosure(closure5964, var_fakeSymbolTable);
  addtoclosure(closure5964, var_identifierNode);
  addtoclosure(closure5964, var_nullNode);
  addtoclosure(closure5964, var_memberNode);
  struct UserObject *uo5964 = (struct UserObject*)obj5957;
  uo5964->data[2] = (Object)closure5964;
  Method *meth_meth_ast_new5964 = addmethod2pos(obj5957, "new", &meth_ast_new5964, 2);
  int argcv_meth_ast_new5964[] = {2};
  meth_meth_ast_new5964->type = alloc_MethodType(1, argcv_meth_ast_new5964);
  meth_meth_ast_new5964->definitionModule = modulename;
  meth_meth_ast_new5964->definitionLine = 1433;
  block_savedest(obj5957);
  Object closure6306 = createclosure(4, "new()object");
  setclosureframe(closure6306, stackframe);
  addtoclosure(closure6306, var_fakeSymbolTable);
  addtoclosure(closure6306, var_identifierNode);
  addtoclosure(closure6306, var_nullNode);
  addtoclosure(closure6306, var_memberNode);
  Method *meth_meth_ast_new5964_object = addmethod2pos(obj5957, "new()object", &meth_ast_new5964_object, 2);
  meth_meth_ast_new5964_object->definitionModule = modulename;
  meth_meth_ast_new5964_object->definitionLine = 1433;
  sourceObject = obj5957;
  sourceObject = obj5957;
  objclass5957 = obj5957->class;
  objclass5957->definitionModule = modulename;
  objclass5957->definitionLine = 1427;
  (*(struct UserObject *)self).data[0] = lowerouter5957;
  self = oldself5957;
  selfslot = oldselfslot5957;
  stackframe = oldstackframe5957;
// compiled object node returning obj5957 (depth = 2)
  *var_memberNode = obj5957;
  if (obj5957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "memberNode"
  block_savedest(self);
  Object closure6307 = createclosure(1, "memberNode");
  setclosureframe(closure6307, stackframe);
  addtoclosure(closure6307, var_memberNode);
  struct UserObject *uo6307 = (struct UserObject*)self;
  uo6307->data[29] = (Object)closure6307;
  Method *meth_meth_ast_memberNode6307 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6307, 29);
  int argcv_meth_ast_memberNode6307[] = {0};
  meth_meth_ast_memberNode6307->type = alloc_MethodType(1, argcv_meth_ast_memberNode6307);
  meth_meth_ast_memberNode6307->definitionModule = modulename;
  meth_meth_ast_memberNode6307->definitionLine = 1435;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6308 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6308 = alloc_userobj2(2,4, objclass6308);
  gc_frame_newslot(obj6308);
if (objclass6308 == NULL) {
  glfree(obj6308->class->name);
  obj6308->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6308, self, 0);
  addmethodreal(obj6308,"outer", &reader_ast_outer_6309);
  Object oldself6308 = self;
  struct StackFrameObject *oldstackframe6308 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6308);
  gc_frame_newslot((Object)stackframe);
  self = obj6308;
  Object *oldselfslot6308 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6308 = (*(struct UserObject *)self).data[0], lowerouter6308 = thisouter6308;
  if (inheritingObject6308) {
    struct UserObject *inho6308 = (struct UserObject *)inheritingObject6308;
    while (inho6308->super != GraceDefaultObject) inho6308 = (struct UserObject *)inho6308->super;
    inho6308->super = obj6308;
    self = inheritingObject6308;
    *selfslot = self;
    lowerouter6308 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6308;
  }
// method "new"
  block_savedest(obj6308);
  Object closure6310 = createclosure(1, "new");
  setclosureframe(closure6310, stackframe);
  addtoclosure(closure6310, var_genericNode);
  struct UserObject *uo6310 = (struct UserObject*)obj6308;
  uo6310->data[1] = (Object)closure6310;
  Method *meth_meth_ast_new6310 = addmethod2pos(obj6308, "new", &meth_ast_new6310, 1);
  int argcv_meth_ast_new6310[] = {2};
  meth_meth_ast_new6310->type = alloc_MethodType(1, argcv_meth_ast_new6310);
  meth_meth_ast_new6310->definitionModule = modulename;
  meth_meth_ast_new6310->definitionLine = 1511;
  block_savedest(obj6308);
  Object closure6467 = createclosure(1, "new()object");
  setclosureframe(closure6467, stackframe);
  addtoclosure(closure6467, var_genericNode);
  Method *meth_meth_ast_new6310_object = addmethod2pos(obj6308, "new()object", &meth_ast_new6310_object, 1);
  meth_meth_ast_new6310_object->definitionModule = modulename;
  meth_meth_ast_new6310_object->definitionLine = 1511;
  sourceObject = obj6308;
  objclass6308 = obj6308->class;
  objclass6308->definitionModule = modulename;
  objclass6308->definitionLine = 1510;
  (*(struct UserObject *)self).data[0] = lowerouter6308;
  self = oldself6308;
  selfslot = oldselfslot6308;
  stackframe = oldstackframe6308;
// compiled object node returning obj6308 (depth = 2)
  *var_genericNode = obj6308;
  if (obj6308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "genericNode"
  block_savedest(self);
  Object closure6468 = createclosure(1, "genericNode");
  setclosureframe(closure6468, stackframe);
  addtoclosure(closure6468, var_genericNode);
  struct UserObject *uo6468 = (struct UserObject*)self;
  uo6468->data[30] = (Object)closure6468;
  Method *meth_meth_ast_genericNode6468 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6468, 30);
  int argcv_meth_ast_genericNode6468[] = {0};
  meth_meth_ast_genericNode6468->type = alloc_MethodType(1, argcv_meth_ast_genericNode6468);
  meth_meth_ast_genericNode6468->definitionModule = modulename;
  meth_meth_ast_genericNode6468->definitionLine = 1513;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6469 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6469 = alloc_userobj2(2,4, objclass6469);
  gc_frame_newslot(obj6469);
if (objclass6469 == NULL) {
  glfree(obj6469->class->name);
  obj6469->class->name = "typeParametersNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6469, self, 0);
  addmethodreal(obj6469,"outer", &reader_ast_outer_6470);
  Object oldself6469 = self;
  struct StackFrameObject *oldstackframe6469 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6469);
  gc_frame_newslot((Object)stackframe);
  self = obj6469;
  Object *oldselfslot6469 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6469 = (*(struct UserObject *)self).data[0], lowerouter6469 = thisouter6469;
  if (inheritingObject6469) {
    struct UserObject *inho6469 = (struct UserObject *)inheritingObject6469;
    while (inho6469->super != GraceDefaultObject) inho6469 = (struct UserObject *)inho6469->super;
    inho6469->super = obj6469;
    self = inheritingObject6469;
    *selfslot = self;
    lowerouter6469 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6469;
  }
// method "new"
  block_savedest(obj6469);
  Object closure6471 = createclosure(3, "new");
  setclosureframe(closure6471, stackframe);
  addtoclosure(closure6471, var_k);
  addtoclosure(closure6471, var_emptySeq);
  addtoclosure(closure6471, var_typeParametersNode);
  struct UserObject *uo6471 = (struct UserObject*)obj6469;
  uo6471->data[1] = (Object)closure6471;
  Method *meth_meth_ast_new6471 = addmethod2pos(obj6469, "new", &meth_ast_new6471, 1);
  int argcv_meth_ast_new6471[] = {1};
  meth_meth_ast_new6471->type = alloc_MethodType(1, argcv_meth_ast_new6471);
  meth_meth_ast_new6471->definitionModule = modulename;
  meth_meth_ast_new6471->definitionLine = 1556;
  block_savedest(obj6469);
  Object closure6630 = createclosure(3, "new()object");
  setclosureframe(closure6630, stackframe);
  addtoclosure(closure6630, var_k);
  addtoclosure(closure6630, var_emptySeq);
  addtoclosure(closure6630, var_typeParametersNode);
  Method *meth_meth_ast_new6471_object = addmethod2pos(obj6469, "new()object", &meth_ast_new6471_object, 1);
  meth_meth_ast_new6471_object->definitionModule = modulename;
  meth_meth_ast_new6471_object->definitionLine = 1556;
  sourceObject = obj6469;
  objclass6469 = obj6469->class;
  objclass6469->definitionModule = modulename;
  objclass6469->definitionLine = 1555;
  (*(struct UserObject *)self).data[0] = lowerouter6469;
  self = oldself6469;
  selfslot = oldselfslot6469;
  stackframe = oldstackframe6469;
// compiled object node returning obj6469 (depth = 2)
  *var_typeParametersNode = obj6469;
  if (obj6469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeParametersNode"
  block_savedest(self);
  Object closure6631 = createclosure(1, "typeParametersNode");
  setclosureframe(closure6631, stackframe);
  addtoclosure(closure6631, var_typeParametersNode);
  struct UserObject *uo6631 = (struct UserObject*)self;
  uo6631->data[31] = (Object)closure6631;
  Method *meth_meth_ast_typeParametersNode6631 = addmethod2pos(self, "typeParametersNode", &meth_ast_typeParametersNode6631, 31);
  int argcv_meth_ast_typeParametersNode6631[] = {0};
  meth_meth_ast_typeParametersNode6631->type = alloc_MethodType(1, argcv_meth_ast_typeParametersNode6631);
  meth_meth_ast_typeParametersNode6631->definitionModule = modulename;
  meth_meth_ast_typeParametersNode6631->definitionLine = 1557;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6632 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6632 = alloc_userobj2(3,4, objclass6632);
  gc_frame_newslot(obj6632);
if (objclass6632 == NULL) {
  glfree(obj6632->class->name);
  obj6632->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6632, self, 0);
  addmethodreal(obj6632,"outer", &reader_ast_outer_6633);
  Object oldself6632 = self;
  struct StackFrameObject *oldstackframe6632 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6632);
  gc_frame_newslot((Object)stackframe);
  self = obj6632;
  Object *oldselfslot6632 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6632 = (*(struct UserObject *)self).data[0], lowerouter6632 = thisouter6632;
  if (inheritingObject6632) {
    struct UserObject *inho6632 = (struct UserObject *)inheritingObject6632;
    while (inho6632->super != GraceDefaultObject) inho6632 = (struct UserObject *)inho6632->super;
    inho6632->super = obj6632;
    self = inheritingObject6632;
    *selfslot = self;
    lowerouter6632 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6632;
  }
// method "new()scope"
  struct UserObject *uo6634 = (struct UserObject*)obj6632;
  uo6634->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope6634 = addmethod2pos(obj6632, "new()scope", &meth_ast_new_40__41_scope6634, 1);
  int argcv_meth_ast_new_40__41_scope6634[] = {2, 1};
  meth_meth_ast_new_40__41_scope6634->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope6634);
  meth_meth_ast_new_40__41_scope6634->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope6634->definitionLine = 1604;
// method "new"
  block_savedest(obj6632);
  Object closure6639 = createclosure(1, "new");
  setclosureframe(closure6639, stackframe);
  addtoclosure(closure6639, var_identifierNode);
  struct UserObject *uo6639 = (struct UserObject*)obj6632;
  uo6639->data[2] = (Object)closure6639;
  Method *meth_meth_ast_new6639 = addmethod2pos(obj6632, "new", &meth_ast_new6639, 2);
  int argcv_meth_ast_new6639[] = {2};
  meth_meth_ast_new6639->type = alloc_MethodType(1, argcv_meth_ast_new6639);
  meth_meth_ast_new6639->definitionModule = modulename;
  meth_meth_ast_new6639->definitionLine = 1610;
  block_savedest(obj6632);
  Object closure7022 = createclosure(1, "new()object");
  setclosureframe(closure7022, stackframe);
  addtoclosure(closure7022, var_identifierNode);
  Method *meth_meth_ast_new6639_object = addmethod2pos(obj6632, "new()object", &meth_ast_new6639_object, 2);
  meth_meth_ast_new6639_object->definitionModule = modulename;
  meth_meth_ast_new6639_object->definitionLine = 1610;
  sourceObject = obj6632;
  sourceObject = obj6632;
  objclass6632 = obj6632->class;
  objclass6632->definitionModule = modulename;
  objclass6632->definitionLine = 1602;
  (*(struct UserObject *)self).data[0] = lowerouter6632;
  self = oldself6632;
  selfslot = oldselfslot6632;
  stackframe = oldstackframe6632;
// compiled object node returning obj6632 (depth = 2)
  *var_identifierNode = obj6632;
  if (obj6632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "identifierNode"
  block_savedest(self);
  Object closure7023 = createclosure(1, "identifierNode");
  setclosureframe(closure7023, stackframe);
  addtoclosure(closure7023, var_identifierNode);
  struct UserObject *uo7023 = (struct UserObject*)self;
  uo7023->data[32] = (Object)closure7023;
  Method *meth_meth_ast_identifierNode7023 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode7023, 32);
  int argcv_meth_ast_identifierNode7023[] = {0};
  meth_meth_ast_identifierNode7023->type = alloc_MethodType(1, argcv_meth_ast_identifierNode7023);
  meth_meth_ast_identifierNode7023->definitionModule = modulename;
  meth_meth_ast_identifierNode7023->definitionLine = 1611;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7024 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7025 == NULL) {
    strlit7025 = alloc_String("Type");
    gc_root(strlit7025);
  }
// compiled string node returning strlit7025 (depth = 3)
  gc_frame_newslot(strlit7025);
// starting to compile identifier node (depth = 3)
  Object bool7026 = alloc_Boolean(0);
// compiled identifier node returning bool7026 (depth = 3)
  gc_frame_newslot(bool7026);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7025;
  params[1] = bool7026;
  partcv[0] = 2;
  Object call7027 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7024);
// compiled call node returning call7027 (depth = 2)
  *var_typeType = call7027;
  if (call7027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "typeType"
  block_savedest(self);
  Object closure7028 = createclosure(1, "typeType");
  setclosureframe(closure7028, stackframe);
  addtoclosure(closure7028, var_typeType);
  struct UserObject *uo7028 = (struct UserObject*)self;
  uo7028->data[33] = (Object)closure7028;
  Method *meth_meth_ast_typeType7028 = addmethod2pos(self, "typeType", &meth_ast_typeType7028, 33);
  int argcv_meth_ast_typeType7028[] = {0};
  meth_meth_ast_typeType7028->type = alloc_MethodType(1, argcv_meth_ast_typeType7028);
  meth_meth_ast_typeType7028->definitionModule = modulename;
  meth_meth_ast_typeType7028->definitionLine = 1611;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7029 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7030 == NULL) {
    strlit7030 = alloc_String("Unknown");
    gc_root(strlit7030);
  }
// compiled string node returning strlit7030 (depth = 3)
  gc_frame_newslot(strlit7030);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7030;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7031 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7029);
// compiled call node returning call7031 (depth = 2)
  *var_unknownType = call7031;
  if (call7031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unknownType"
  block_savedest(self);
  Object closure7032 = createclosure(1, "unknownType");
  setclosureframe(closure7032, stackframe);
  addtoclosure(closure7032, var_unknownType);
  struct UserObject *uo7032 = (struct UserObject*)self;
  uo7032->data[34] = (Object)closure7032;
  Method *meth_meth_ast_unknownType7032 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7032, 34);
  int argcv_meth_ast_unknownType7032[] = {0};
  meth_meth_ast_unknownType7032->type = alloc_MethodType(1, argcv_meth_ast_unknownType7032);
  meth_meth_ast_unknownType7032->definitionModule = modulename;
  meth_meth_ast_unknownType7032->definitionLine = 1611;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7033 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7033 = alloc_userobj2(3,4, objclass7033);
  gc_frame_newslot(obj7033);
if (objclass7033 == NULL) {
  glfree(obj7033->class->name);
  obj7033->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7033, self, 0);
  addmethodreal(obj7033,"outer", &reader_ast_outer_7034);
  Object oldself7033 = self;
  struct StackFrameObject *oldstackframe7033 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7033);
  gc_frame_newslot((Object)stackframe);
  self = obj7033;
  Object *oldselfslot7033 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7033 = (*(struct UserObject *)self).data[0], lowerouter7033 = thisouter7033;
  if (inheritingObject7033) {
    struct UserObject *inho7033 = (struct UserObject *)inheritingObject7033;
    while (inho7033->super != GraceDefaultObject) inho7033 = (struct UserObject *)inho7033->super;
    inho7033->super = obj7033;
    self = inheritingObject7033;
    *selfslot = self;
    lowerouter7033 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7033;
  }
// method "new()scope"
  struct UserObject *uo7035 = (struct UserObject*)obj7033;
  uo7035->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7035 = addmethod2pos(obj7033, "new()scope", &meth_ast_new_40__41_scope7035, 1);
  int argcv_meth_ast_new_40__41_scope7035[] = {1, 1};
  meth_meth_ast_new_40__41_scope7035->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7035);
  meth_meth_ast_new_40__41_scope7035->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7035->definitionLine = 1732;
// method "new"
  block_savedest(obj7033);
  Object closure7040 = createclosure(1, "new");
  setclosureframe(closure7040, stackframe);
  addtoclosure(closure7040, var_stringNode);
  struct UserObject *uo7040 = (struct UserObject*)obj7033;
  uo7040->data[2] = (Object)closure7040;
  Method *meth_meth_ast_new7040 = addmethod2pos(obj7033, "new", &meth_ast_new7040, 2);
  int argcv_meth_ast_new7040[] = {1};
  meth_meth_ast_new7040->type = alloc_MethodType(1, argcv_meth_ast_new7040);
  meth_meth_ast_new7040->definitionModule = modulename;
  meth_meth_ast_new7040->definitionLine = 1738;
  block_savedest(obj7033);
  Object closure7103 = createclosure(1, "new()object");
  setclosureframe(closure7103, stackframe);
  addtoclosure(closure7103, var_stringNode);
  Method *meth_meth_ast_new7040_object = addmethod2pos(obj7033, "new()object", &meth_ast_new7040_object, 2);
  meth_meth_ast_new7040_object->definitionModule = modulename;
  meth_meth_ast_new7040_object->definitionLine = 1738;
  sourceObject = obj7033;
  sourceObject = obj7033;
  objclass7033 = obj7033->class;
  objclass7033->definitionModule = modulename;
  objclass7033->definitionLine = 1731;
  (*(struct UserObject *)self).data[0] = lowerouter7033;
  self = oldself7033;
  selfslot = oldselfslot7033;
  stackframe = oldstackframe7033;
// compiled object node returning obj7033 (depth = 2)
  *var_stringNode = obj7033;
  if (obj7033 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "stringNode"
  block_savedest(self);
  Object closure7104 = createclosure(1, "stringNode");
  setclosureframe(closure7104, stackframe);
  addtoclosure(closure7104, var_stringNode);
  struct UserObject *uo7104 = (struct UserObject*)self;
  uo7104->data[35] = (Object)closure7104;
  Method *meth_meth_ast_stringNode7104 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7104, 35);
  int argcv_meth_ast_stringNode7104[] = {0};
  meth_meth_ast_stringNode7104->type = alloc_MethodType(1, argcv_meth_ast_stringNode7104);
  meth_meth_ast_stringNode7104->definitionModule = modulename;
  meth_meth_ast_stringNode7104->definitionLine = 1739;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7105 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7105 = alloc_userobj2(2,4, objclass7105);
  gc_frame_newslot(obj7105);
if (objclass7105 == NULL) {
  glfree(obj7105->class->name);
  obj7105->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7105, self, 0);
  addmethodreal(obj7105,"outer", &reader_ast_outer_7106);
  Object oldself7105 = self;
  struct StackFrameObject *oldstackframe7105 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7105);
  gc_frame_newslot((Object)stackframe);
  self = obj7105;
  Object *oldselfslot7105 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7105 = (*(struct UserObject *)self).data[0], lowerouter7105 = thisouter7105;
  if (inheritingObject7105) {
    struct UserObject *inho7105 = (struct UserObject *)inheritingObject7105;
    while (inho7105->super != GraceDefaultObject) inho7105 = (struct UserObject *)inho7105->super;
    inho7105->super = obj7105;
    self = inheritingObject7105;
    *selfslot = self;
    lowerouter7105 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7105;
  }
// method "new"
  block_savedest(obj7105);
  Object closure7107 = createclosure(1, "new");
  setclosureframe(closure7107, stackframe);
  addtoclosure(closure7107, var_numNode);
  struct UserObject *uo7107 = (struct UserObject*)obj7105;
  uo7107->data[1] = (Object)closure7107;
  Method *meth_meth_ast_new7107 = addmethod2pos(obj7105, "new", &meth_ast_new7107, 1);
  int argcv_meth_ast_new7107[] = {1};
  meth_meth_ast_new7107->type = alloc_MethodType(1, argcv_meth_ast_new7107);
  meth_meth_ast_new7107->definitionModule = modulename;
  meth_meth_ast_new7107->definitionLine = 1764;
  block_savedest(obj7105);
  Object closure7174 = createclosure(1, "new()object");
  setclosureframe(closure7174, stackframe);
  addtoclosure(closure7174, var_numNode);
  Method *meth_meth_ast_new7107_object = addmethod2pos(obj7105, "new()object", &meth_ast_new7107_object, 1);
  meth_meth_ast_new7107_object->definitionModule = modulename;
  meth_meth_ast_new7107_object->definitionLine = 1764;
  sourceObject = obj7105;
  objclass7105 = obj7105->class;
  objclass7105->definitionModule = modulename;
  objclass7105->definitionLine = 1763;
  (*(struct UserObject *)self).data[0] = lowerouter7105;
  self = oldself7105;
  selfslot = oldselfslot7105;
  stackframe = oldstackframe7105;
// compiled object node returning obj7105 (depth = 2)
  *var_numNode = obj7105;
  if (obj7105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "numNode"
  block_savedest(self);
  Object closure7175 = createclosure(1, "numNode");
  setclosureframe(closure7175, stackframe);
  addtoclosure(closure7175, var_numNode);
  struct UserObject *uo7175 = (struct UserObject*)self;
  uo7175->data[36] = (Object)closure7175;
  Method *meth_meth_ast_numNode7175 = addmethod2pos(self, "numNode", &meth_ast_numNode7175, 36);
  int argcv_meth_ast_numNode7175[] = {0};
  meth_meth_ast_numNode7175->type = alloc_MethodType(1, argcv_meth_ast_numNode7175);
  meth_meth_ast_numNode7175->definitionModule = modulename;
  meth_meth_ast_numNode7175->definitionLine = 1765;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7176 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7176 = alloc_userobj2(2,4, objclass7176);
  gc_frame_newslot(obj7176);
if (objclass7176 == NULL) {
  glfree(obj7176->class->name);
  obj7176->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7176, self, 0);
  addmethodreal(obj7176,"outer", &reader_ast_outer_7177);
  Object oldself7176 = self;
  struct StackFrameObject *oldstackframe7176 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7176);
  gc_frame_newslot((Object)stackframe);
  self = obj7176;
  Object *oldselfslot7176 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7176 = (*(struct UserObject *)self).data[0], lowerouter7176 = thisouter7176;
  if (inheritingObject7176) {
    struct UserObject *inho7176 = (struct UserObject *)inheritingObject7176;
    while (inho7176->super != GraceDefaultObject) inho7176 = (struct UserObject *)inho7176->super;
    inho7176->super = obj7176;
    self = inheritingObject7176;
    *selfslot = self;
    lowerouter7176 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7176;
  }
// method "new"
  block_savedest(obj7176);
  Object closure7178 = createclosure(3, "new");
  setclosureframe(closure7178, stackframe);
  addtoclosure(closure7178, var_identifierNode);
  addtoclosure(closure7178, var_nullNode);
  addtoclosure(closure7178, var_opNode);
  struct UserObject *uo7178 = (struct UserObject*)obj7176;
  uo7178->data[1] = (Object)closure7178;
  Method *meth_meth_ast_new7178 = addmethod2pos(obj7176, "new", &meth_ast_new7178, 1);
  int argcv_meth_ast_new7178[] = {3};
  meth_meth_ast_new7178->type = alloc_MethodType(1, argcv_meth_ast_new7178);
  meth_meth_ast_new7178->definitionModule = modulename;
  meth_meth_ast_new7178->definitionLine = 1790;
  block_savedest(obj7176);
  Object closure7448 = createclosure(3, "new()object");
  setclosureframe(closure7448, stackframe);
  addtoclosure(closure7448, var_identifierNode);
  addtoclosure(closure7448, var_nullNode);
  addtoclosure(closure7448, var_opNode);
  Method *meth_meth_ast_new7178_object = addmethod2pos(obj7176, "new()object", &meth_ast_new7178_object, 1);
  meth_meth_ast_new7178_object->definitionModule = modulename;
  meth_meth_ast_new7178_object->definitionLine = 1790;
  sourceObject = obj7176;
  objclass7176 = obj7176->class;
  objclass7176->definitionModule = modulename;
  objclass7176->definitionLine = 1789;
  (*(struct UserObject *)self).data[0] = lowerouter7176;
  self = oldself7176;
  selfslot = oldselfslot7176;
  stackframe = oldstackframe7176;
// compiled object node returning obj7176 (depth = 2)
  *var_opNode = obj7176;
  if (obj7176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "opNode"
  block_savedest(self);
  Object closure7449 = createclosure(1, "opNode");
  setclosureframe(closure7449, stackframe);
  addtoclosure(closure7449, var_opNode);
  struct UserObject *uo7449 = (struct UserObject*)self;
  uo7449->data[37] = (Object)closure7449;
  Method *meth_meth_ast_opNode7449 = addmethod2pos(self, "opNode", &meth_ast_opNode7449, 37);
  int argcv_meth_ast_opNode7449[] = {0};
  meth_meth_ast_opNode7449->type = alloc_MethodType(1, argcv_meth_ast_opNode7449);
  meth_meth_ast_opNode7449->definitionModule = modulename;
  meth_meth_ast_opNode7449->definitionLine = 1791;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7450 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7450 = alloc_userobj2(2,4, objclass7450);
  gc_frame_newslot(obj7450);
if (objclass7450 == NULL) {
  glfree(obj7450->class->name);
  obj7450->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7450, self, 0);
  addmethodreal(obj7450,"outer", &reader_ast_outer_7451);
  Object oldself7450 = self;
  struct StackFrameObject *oldstackframe7450 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7450);
  gc_frame_newslot((Object)stackframe);
  self = obj7450;
  Object *oldselfslot7450 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7450 = (*(struct UserObject *)self).data[0], lowerouter7450 = thisouter7450;
  if (inheritingObject7450) {
    struct UserObject *inho7450 = (struct UserObject *)inheritingObject7450;
    while (inho7450->super != GraceDefaultObject) inho7450 = (struct UserObject *)inho7450->super;
    inho7450->super = obj7450;
    self = inheritingObject7450;
    *selfslot = self;
    lowerouter7450 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7450;
  }
// method "new"
  block_savedest(obj7450);
  Object closure7452 = createclosure(1, "new");
  setclosureframe(closure7452, stackframe);
  addtoclosure(closure7452, var_bindNode);
  struct UserObject *uo7452 = (struct UserObject*)obj7450;
  uo7452->data[1] = (Object)closure7452;
  Method *meth_meth_ast_new7452 = addmethod2pos(obj7450, "new", &meth_ast_new7452, 1);
  int argcv_meth_ast_new7452[] = {2};
  meth_meth_ast_new7452->type = alloc_MethodType(1, argcv_meth_ast_new7452);
  meth_meth_ast_new7452->definitionModule = modulename;
  meth_meth_ast_new7452->definitionLine = 1857;
  block_savedest(obj7450);
  Object closure7623 = createclosure(1, "new()object");
  setclosureframe(closure7623, stackframe);
  addtoclosure(closure7623, var_bindNode);
  Method *meth_meth_ast_new7452_object = addmethod2pos(obj7450, "new()object", &meth_ast_new7452_object, 1);
  meth_meth_ast_new7452_object->definitionModule = modulename;
  meth_meth_ast_new7452_object->definitionLine = 1857;
  sourceObject = obj7450;
  objclass7450 = obj7450->class;
  objclass7450->definitionModule = modulename;
  objclass7450->definitionLine = 1856;
  (*(struct UserObject *)self).data[0] = lowerouter7450;
  self = oldself7450;
  selfslot = oldselfslot7450;
  stackframe = oldstackframe7450;
// compiled object node returning obj7450 (depth = 2)
  *var_bindNode = obj7450;
  if (obj7450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "bindNode"
  block_savedest(self);
  Object closure7624 = createclosure(1, "bindNode");
  setclosureframe(closure7624, stackframe);
  addtoclosure(closure7624, var_bindNode);
  struct UserObject *uo7624 = (struct UserObject*)self;
  uo7624->data[38] = (Object)closure7624;
  Method *meth_meth_ast_bindNode7624 = addmethod2pos(self, "bindNode", &meth_ast_bindNode7624, 38);
  int argcv_meth_ast_bindNode7624[] = {0};
  meth_meth_ast_bindNode7624->type = alloc_MethodType(1, argcv_meth_ast_bindNode7624);
  meth_meth_ast_bindNode7624->definitionModule = modulename;
  meth_meth_ast_bindNode7624->definitionLine = 1859;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject7625 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7625 = alloc_userobj2(3,4, objclass7625);
  gc_frame_newslot(obj7625);
if (objclass7625 == NULL) {
  glfree(obj7625->class->name);
  obj7625->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7625, self, 0);
  addmethodreal(obj7625,"outer", &reader_ast_outer_7626);
  Object oldself7625 = self;
  struct StackFrameObject *oldstackframe7625 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7625);
  gc_frame_newslot((Object)stackframe);
  self = obj7625;
  Object *oldselfslot7625 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7625 = (*(struct UserObject *)self).data[0], lowerouter7625 = thisouter7625;
  if (inheritingObject7625) {
    struct UserObject *inho7625 = (struct UserObject *)inheritingObject7625;
    while (inho7625->super != GraceDefaultObject) inho7625 = (struct UserObject *)inho7625->super;
    inho7625->super = obj7625;
    self = inheritingObject7625;
    *selfslot = self;
    lowerouter7625 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7625;
  }
// method "new()scope"
  struct UserObject *uo7627 = (struct UserObject*)obj7625;
  uo7627->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope7627 = addmethod2pos(obj7625, "new()scope", &meth_ast_new_40__41_scope7627, 1);
  int argcv_meth_ast_new_40__41_scope7627[] = {3, 1};
  meth_meth_ast_new_40__41_scope7627->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope7627);
  meth_meth_ast_new_40__41_scope7627->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope7627->definitionLine = 1907;
// method "new"
  block_savedest(obj7625);
  Object closure7632 = createclosure(2, "new");
  setclosureframe(closure7632, stackframe);
  addtoclosure(closure7632, var_k);
  addtoclosure(closure7632, var_defDecNode);
  struct UserObject *uo7632 = (struct UserObject*)obj7625;
  uo7632->data[2] = (Object)closure7632;
  Method *meth_meth_ast_new7632 = addmethod2pos(obj7625, "new", &meth_ast_new7632, 2);
  int argcv_meth_ast_new7632[] = {3};
  meth_meth_ast_new7632->type = alloc_MethodType(1, argcv_meth_ast_new7632);
  meth_meth_ast_new7632->definitionModule = modulename;
  meth_meth_ast_new7632->definitionLine = 1913;
  block_savedest(obj7625);
  Object closure8089 = createclosure(2, "new()object");
  setclosureframe(closure8089, stackframe);
  addtoclosure(closure8089, var_k);
  addtoclosure(closure8089, var_defDecNode);
  Method *meth_meth_ast_new7632_object = addmethod2pos(obj7625, "new()object", &meth_ast_new7632_object, 2);
  meth_meth_ast_new7632_object->definitionModule = modulename;
  meth_meth_ast_new7632_object->definitionLine = 1913;
  sourceObject = obj7625;
  sourceObject = obj7625;
  objclass7625 = obj7625->class;
  objclass7625->definitionModule = modulename;
  objclass7625->definitionLine = 1906;
  (*(struct UserObject *)self).data[0] = lowerouter7625;
  self = oldself7625;
  selfslot = oldselfslot7625;
  stackframe = oldstackframe7625;
// compiled object node returning obj7625 (depth = 2)
  *var_defDecNode = obj7625;
  if (obj7625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "defDecNode"
  block_savedest(self);
  Object closure8090 = createclosure(1, "defDecNode");
  setclosureframe(closure8090, stackframe);
  addtoclosure(closure8090, var_defDecNode);
  struct UserObject *uo8090 = (struct UserObject*)self;
  uo8090->data[39] = (Object)closure8090;
  Method *meth_meth_ast_defDecNode8090 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode8090, 39);
  int argcv_meth_ast_defDecNode8090[] = {0};
  meth_meth_ast_defDecNode8090->type = alloc_MethodType(1, argcv_meth_ast_defDecNode8090);
  meth_meth_ast_defDecNode8090->definitionModule = modulename;
  meth_meth_ast_defDecNode8090->definitionLine = 1919;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8091 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8091 = alloc_userobj2(2,4, objclass8091);
  gc_frame_newslot(obj8091);
if (objclass8091 == NULL) {
  glfree(obj8091->class->name);
  obj8091->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8091, self, 0);
  addmethodreal(obj8091,"outer", &reader_ast_outer_8092);
  Object oldself8091 = self;
  struct StackFrameObject *oldstackframe8091 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8091);
  gc_frame_newslot((Object)stackframe);
  self = obj8091;
  Object *oldselfslot8091 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8091 = (*(struct UserObject *)self).data[0], lowerouter8091 = thisouter8091;
  if (inheritingObject8091) {
    struct UserObject *inho8091 = (struct UserObject *)inheritingObject8091;
    while (inho8091->super != GraceDefaultObject) inho8091 = (struct UserObject *)inho8091->super;
    inho8091->super = obj8091;
    self = inheritingObject8091;
    *selfslot = self;
    lowerouter8091 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8091;
  }
// method "new"
  block_savedest(obj8091);
  Object closure8093 = createclosure(2, "new");
  setclosureframe(closure8093, stackframe);
  addtoclosure(closure8093, var_k);
  addtoclosure(closure8093, var_varDecNode);
  struct UserObject *uo8093 = (struct UserObject*)obj8091;
  uo8093->data[1] = (Object)closure8093;
  Method *meth_meth_ast_new8093 = addmethod2pos(obj8091, "new", &meth_ast_new8093, 1);
  int argcv_meth_ast_new8093[] = {3};
  meth_meth_ast_new8093->type = alloc_MethodType(1, argcv_meth_ast_new8093);
  meth_meth_ast_new8093->definitionModule = modulename;
  meth_meth_ast_new8093->definitionLine = 2024;
  block_savedest(obj8091);
  Object closure8547 = createclosure(2, "new()object");
  setclosureframe(closure8547, stackframe);
  addtoclosure(closure8547, var_k);
  addtoclosure(closure8547, var_varDecNode);
  Method *meth_meth_ast_new8093_object = addmethod2pos(obj8091, "new()object", &meth_ast_new8093_object, 1);
  meth_meth_ast_new8093_object->definitionModule = modulename;
  meth_meth_ast_new8093_object->definitionLine = 2024;
  sourceObject = obj8091;
  objclass8091 = obj8091->class;
  objclass8091->definitionModule = modulename;
  objclass8091->definitionLine = 2023;
  (*(struct UserObject *)self).data[0] = lowerouter8091;
  self = oldself8091;
  selfslot = oldselfslot8091;
  stackframe = oldstackframe8091;
// compiled object node returning obj8091 (depth = 2)
  *var_varDecNode = obj8091;
  if (obj8091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "varDecNode"
  block_savedest(self);
  Object closure8548 = createclosure(1, "varDecNode");
  setclosureframe(closure8548, stackframe);
  addtoclosure(closure8548, var_varDecNode);
  struct UserObject *uo8548 = (struct UserObject*)self;
  uo8548->data[40] = (Object)closure8548;
  Method *meth_meth_ast_varDecNode8548 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8548, 40);
  int argcv_meth_ast_varDecNode8548[] = {0};
  meth_meth_ast_varDecNode8548->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8548);
  meth_meth_ast_varDecNode8548->definitionModule = modulename;
  meth_meth_ast_varDecNode8548->definitionLine = 2030;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8549 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8549 = alloc_userobj2(2,4, objclass8549);
  gc_frame_newslot(obj8549);
if (objclass8549 == NULL) {
  glfree(obj8549->class->name);
  obj8549->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8549, self, 0);
  addmethodreal(obj8549,"outer", &reader_ast_outer_8550);
  Object oldself8549 = self;
  struct StackFrameObject *oldstackframe8549 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8549);
  gc_frame_newslot((Object)stackframe);
  self = obj8549;
  Object *oldselfslot8549 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8549 = (*(struct UserObject *)self).data[0], lowerouter8549 = thisouter8549;
  if (inheritingObject8549) {
    struct UserObject *inho8549 = (struct UserObject *)inheritingObject8549;
    while (inho8549->super != GraceDefaultObject) inho8549 = (struct UserObject *)inho8549->super;
    inho8549->super = obj8549;
    self = inheritingObject8549;
    *selfslot = self;
    lowerouter8549 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8549;
  }
// method "new"
  block_savedest(obj8549);
  Object closure8551 = createclosure(3, "new");
  setclosureframe(closure8551, stackframe);
  addtoclosure(closure8551, var_k);
  addtoclosure(closure8551, var_nullNode);
  addtoclosure(closure8551, var_importNode);
  struct UserObject *uo8551 = (struct UserObject*)obj8549;
  uo8551->data[1] = (Object)closure8551;
  Method *meth_meth_ast_new8551 = addmethod2pos(obj8549, "new", &meth_ast_new8551, 1);
  int argcv_meth_ast_new8551[] = {3};
  meth_meth_ast_new8551->type = alloc_MethodType(1, argcv_meth_ast_new8551);
  meth_meth_ast_new8551->definitionModule = modulename;
  meth_meth_ast_new8551->definitionLine = 2132;
  block_savedest(obj8549);
  Object closure8827 = createclosure(3, "new()object");
  setclosureframe(closure8827, stackframe);
  addtoclosure(closure8827, var_k);
  addtoclosure(closure8827, var_nullNode);
  addtoclosure(closure8827, var_importNode);
  Method *meth_meth_ast_new8551_object = addmethod2pos(obj8549, "new()object", &meth_ast_new8551_object, 1);
  meth_meth_ast_new8551_object->definitionModule = modulename;
  meth_meth_ast_new8551_object->definitionLine = 2132;
  sourceObject = obj8549;
  objclass8549 = obj8549->class;
  objclass8549->definitionModule = modulename;
  objclass8549->definitionLine = 2131;
  (*(struct UserObject *)self).data[0] = lowerouter8549;
  self = oldself8549;
  selfslot = oldselfslot8549;
  stackframe = oldstackframe8549;
// compiled object node returning obj8549 (depth = 2)
  *var_importNode = obj8549;
  if (obj8549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "importNode"
  block_savedest(self);
  Object closure8828 = createclosure(1, "importNode");
  setclosureframe(closure8828, stackframe);
  addtoclosure(closure8828, var_importNode);
  struct UserObject *uo8828 = (struct UserObject*)self;
  uo8828->data[41] = (Object)closure8828;
  Method *meth_meth_ast_importNode8828 = addmethod2pos(self, "importNode", &meth_ast_importNode8828, 41);
  int argcv_meth_ast_importNode8828[] = {0};
  meth_meth_ast_importNode8828->type = alloc_MethodType(1, argcv_meth_ast_importNode8828);
  meth_meth_ast_importNode8828->definitionModule = modulename;
  meth_meth_ast_importNode8828->definitionLine = 2133;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8829 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8829 = alloc_userobj2(2,4, objclass8829);
  gc_frame_newslot(obj8829);
if (objclass8829 == NULL) {
  glfree(obj8829->class->name);
  obj8829->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8829, self, 0);
  addmethodreal(obj8829,"outer", &reader_ast_outer_8830);
  Object oldself8829 = self;
  struct StackFrameObject *oldstackframe8829 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8829);
  gc_frame_newslot((Object)stackframe);
  self = obj8829;
  Object *oldselfslot8829 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8829 = (*(struct UserObject *)self).data[0], lowerouter8829 = thisouter8829;
  if (inheritingObject8829) {
    struct UserObject *inho8829 = (struct UserObject *)inheritingObject8829;
    while (inho8829->super != GraceDefaultObject) inho8829 = (struct UserObject *)inho8829->super;
    inho8829->super = obj8829;
    self = inheritingObject8829;
    *selfslot = self;
    lowerouter8829 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8829;
  }
// method "new"
  block_savedest(obj8829);
  Object closure8831 = createclosure(1, "new");
  setclosureframe(closure8831, stackframe);
  addtoclosure(closure8831, var_dialectNode);
  struct UserObject *uo8831 = (struct UserObject*)obj8829;
  uo8831->data[1] = (Object)closure8831;
  Method *meth_meth_ast_new8831 = addmethod2pos(obj8829, "new", &meth_ast_new8831, 1);
  int argcv_meth_ast_new8831[] = {1};
  meth_meth_ast_new8831->type = alloc_MethodType(1, argcv_meth_ast_new8831);
  meth_meth_ast_new8831->definitionModule = modulename;
  meth_meth_ast_new8831->definitionLine = 2209;
  block_savedest(obj8829);
  Object closure8943 = createclosure(1, "new()object");
  setclosureframe(closure8943, stackframe);
  addtoclosure(closure8943, var_dialectNode);
  Method *meth_meth_ast_new8831_object = addmethod2pos(obj8829, "new()object", &meth_ast_new8831_object, 1);
  meth_meth_ast_new8831_object->definitionModule = modulename;
  meth_meth_ast_new8831_object->definitionLine = 2209;
  sourceObject = obj8829;
  objclass8829 = obj8829->class;
  objclass8829->definitionModule = modulename;
  objclass8829->definitionLine = 2208;
  (*(struct UserObject *)self).data[0] = lowerouter8829;
  self = oldself8829;
  selfslot = oldselfslot8829;
  stackframe = oldstackframe8829;
// compiled object node returning obj8829 (depth = 2)
  *var_dialectNode = obj8829;
  if (obj8829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "dialectNode"
  block_savedest(self);
  Object closure8944 = createclosure(1, "dialectNode");
  setclosureframe(closure8944, stackframe);
  addtoclosure(closure8944, var_dialectNode);
  struct UserObject *uo8944 = (struct UserObject*)self;
  uo8944->data[42] = (Object)closure8944;
  Method *meth_meth_ast_dialectNode8944 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode8944, 42);
  int argcv_meth_ast_dialectNode8944[] = {0};
  meth_meth_ast_dialectNode8944->type = alloc_MethodType(1, argcv_meth_ast_dialectNode8944);
  meth_meth_ast_dialectNode8944->definitionModule = modulename;
  meth_meth_ast_dialectNode8944->definitionLine = 2210;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject8945 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8945 = alloc_userobj2(2,4, objclass8945);
  gc_frame_newslot(obj8945);
if (objclass8945 == NULL) {
  glfree(obj8945->class->name);
  obj8945->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8945, self, 0);
  addmethodreal(obj8945,"outer", &reader_ast_outer_8946);
  Object oldself8945 = self;
  struct StackFrameObject *oldstackframe8945 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8945);
  gc_frame_newslot((Object)stackframe);
  self = obj8945;
  Object *oldselfslot8945 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8945 = (*(struct UserObject *)self).data[0], lowerouter8945 = thisouter8945;
  if (inheritingObject8945) {
    struct UserObject *inho8945 = (struct UserObject *)inheritingObject8945;
    while (inho8945->super != GraceDefaultObject) inho8945 = (struct UserObject *)inho8945->super;
    inho8945->super = obj8945;
    self = inheritingObject8945;
    *selfslot = self;
    lowerouter8945 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8945;
  }
// method "new"
  block_savedest(obj8945);
  Object closure8947 = createclosure(2, "new");
  setclosureframe(closure8947, stackframe);
  addtoclosure(closure8947, var_nullNode);
  addtoclosure(closure8947, var_returnNode);
  struct UserObject *uo8947 = (struct UserObject*)obj8945;
  uo8947->data[1] = (Object)closure8947;
  Method *meth_meth_ast_new8947 = addmethod2pos(obj8945, "new", &meth_ast_new8947, 1);
  int argcv_meth_ast_new8947[] = {1};
  meth_meth_ast_new8947->type = alloc_MethodType(1, argcv_meth_ast_new8947);
  meth_meth_ast_new8947->definitionModule = modulename;
  meth_meth_ast_new8947->definitionLine = 2257;
  block_savedest(obj8945);
  Object closure9033 = createclosure(2, "new()object");
  setclosureframe(closure9033, stackframe);
  addtoclosure(closure9033, var_nullNode);
  addtoclosure(closure9033, var_returnNode);
  Method *meth_meth_ast_new8947_object = addmethod2pos(obj8945, "new()object", &meth_ast_new8947_object, 1);
  meth_meth_ast_new8947_object->definitionModule = modulename;
  meth_meth_ast_new8947_object->definitionLine = 2257;
  sourceObject = obj8945;
  objclass8945 = obj8945->class;
  objclass8945->definitionModule = modulename;
  objclass8945->definitionLine = 2256;
  (*(struct UserObject *)self).data[0] = lowerouter8945;
  self = oldself8945;
  selfslot = oldselfslot8945;
  stackframe = oldstackframe8945;
// compiled object node returning obj8945 (depth = 2)
  *var_returnNode = obj8945;
  if (obj8945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "returnNode"
  block_savedest(self);
  Object closure9034 = createclosure(1, "returnNode");
  setclosureframe(closure9034, stackframe);
  addtoclosure(closure9034, var_returnNode);
  struct UserObject *uo9034 = (struct UserObject*)self;
  uo9034->data[43] = (Object)closure9034;
  Method *meth_meth_ast_returnNode9034 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9034, 43);
  int argcv_meth_ast_returnNode9034[] = {0};
  meth_meth_ast_returnNode9034->type = alloc_MethodType(1, argcv_meth_ast_returnNode9034);
  meth_meth_ast_returnNode9034->definitionModule = modulename;
  meth_meth_ast_returnNode9034->definitionLine = 2258;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9035 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9035 = alloc_userobj2(3,4, objclass9035);
  gc_frame_newslot(obj9035);
if (objclass9035 == NULL) {
  glfree(obj9035->class->name);
  obj9035->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9035, self, 0);
  addmethodreal(obj9035,"outer", &reader_ast_outer_9036);
  Object oldself9035 = self;
  struct StackFrameObject *oldstackframe9035 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9035);
  gc_frame_newslot((Object)stackframe);
  self = obj9035;
  Object *oldselfslot9035 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9035 = (*(struct UserObject *)self).data[0], lowerouter9035 = thisouter9035;
  if (inheritingObject9035) {
    struct UserObject *inho9035 = (struct UserObject *)inheritingObject9035;
    while (inho9035->super != GraceDefaultObject) inho9035 = (struct UserObject *)inho9035->super;
    inho9035->super = obj9035;
    self = inheritingObject9035;
    *selfslot = self;
    lowerouter9035 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9035;
  }
// method "new()scope"
  struct UserObject *uo9037 = (struct UserObject*)obj9035;
  uo9037->data[1] = emptyclosure;
  Method *meth_meth_ast_new_40__41_scope9037 = addmethod2pos(obj9035, "new()scope", &meth_ast_new_40__41_scope9037, 1);
  int argcv_meth_ast_new_40__41_scope9037[] = {1, 1};
  meth_meth_ast_new_40__41_scope9037->type = alloc_MethodType(2, argcv_meth_ast_new_40__41_scope9037);
  meth_meth_ast_new_40__41_scope9037->definitionModule = modulename;
  meth_meth_ast_new_40__41_scope9037->definitionLine = 2292;
// method "new"
  block_savedest(obj9035);
  Object closure9042 = createclosure(3, "new");
  setclosureframe(closure9042, stackframe);
  addtoclosure(closure9042, var_k);
  addtoclosure(closure9042, var_nullNode);
  addtoclosure(closure9042, var_inheritsNode);
  struct UserObject *uo9042 = (struct UserObject*)obj9035;
  uo9042->data[2] = (Object)closure9042;
  Method *meth_meth_ast_new9042 = addmethod2pos(obj9035, "new", &meth_ast_new9042, 2);
  int argcv_meth_ast_new9042[] = {1};
  meth_meth_ast_new9042->type = alloc_MethodType(1, argcv_meth_ast_new9042);
  meth_meth_ast_new9042->definitionModule = modulename;
  meth_meth_ast_new9042->definitionLine = 2297;
  block_savedest(obj9035);
  Object closure9411 = createclosure(3, "new()object");
  setclosureframe(closure9411, stackframe);
  addtoclosure(closure9411, var_k);
  addtoclosure(closure9411, var_nullNode);
  addtoclosure(closure9411, var_inheritsNode);
  Method *meth_meth_ast_new9042_object = addmethod2pos(obj9035, "new()object", &meth_ast_new9042_object, 2);
  meth_meth_ast_new9042_object->definitionModule = modulename;
  meth_meth_ast_new9042_object->definitionLine = 2297;
  sourceObject = obj9035;
  sourceObject = obj9035;
  objclass9035 = obj9035->class;
  objclass9035->definitionModule = modulename;
  objclass9035->definitionLine = 2291;
  (*(struct UserObject *)self).data[0] = lowerouter9035;
  self = oldself9035;
  selfslot = oldselfslot9035;
  stackframe = oldstackframe9035;
// compiled object node returning obj9035 (depth = 2)
  *var_inheritsNode = obj9035;
  if (obj9035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "inheritsNode"
  block_savedest(self);
  Object closure9412 = createclosure(1, "inheritsNode");
  setclosureframe(closure9412, stackframe);
  addtoclosure(closure9412, var_inheritsNode);
  struct UserObject *uo9412 = (struct UserObject*)self;
  uo9412->data[44] = (Object)closure9412;
  Method *meth_meth_ast_inheritsNode9412 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9412, 44);
  int argcv_meth_ast_inheritsNode9412[] = {0};
  meth_meth_ast_inheritsNode9412->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9412);
  meth_meth_ast_inheritsNode9412->definitionModule = modulename;
  meth_meth_ast_inheritsNode9412->definitionLine = 2301;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AliasPair
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type9414 = alloc_Type("AliasPair", 2);
    add_Method((ClassData)type9414, "newName", NULL);
    add_Method((ClassData)type9414, "oldName", NULL);
// compiled typeliteral node returning type9414 (depth = 2)
  *var_AliasPair = type9414;
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "AliasPair"
  block_savedest(self);
  Object closure9415 = createclosure(1, "AliasPair");
  setclosureframe(closure9415, stackframe);
  addtoclosure(closure9415, var_AliasPair);
  struct UserObject *uo9415 = (struct UserObject*)self;
  uo9415->data[45] = (Object)closure9415;
  Method *meth_meth_ast_AliasPair9415 = addmethod2pos(self, "AliasPair", &meth_ast_AliasPair9415, 45);
  int argcv_meth_ast_AliasPair9415[] = {0};
  meth_meth_ast_AliasPair9415->type = alloc_MethodType(1, argcv_meth_ast_AliasPair9415);
  meth_meth_ast_AliasPair9415->definitionModule = modulename;
  meth_meth_ast_AliasPair9415->definitionLine = 2301;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9416 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9416 = alloc_userobj2(2,4, objclass9416);
  gc_frame_newslot(obj9416);
if (objclass9416 == NULL) {
  glfree(obj9416->class->name);
  obj9416->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9416, self, 0);
  addmethodreal(obj9416,"outer", &reader_ast_outer_9417);
  Object oldself9416 = self;
  struct StackFrameObject *oldstackframe9416 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9416);
  gc_frame_newslot((Object)stackframe);
  self = obj9416;
  Object *oldselfslot9416 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9416 = (*(struct UserObject *)self).data[0], lowerouter9416 = thisouter9416;
  if (inheritingObject9416) {
    struct UserObject *inho9416 = (struct UserObject *)inheritingObject9416;
    while (inho9416->super != GraceDefaultObject) inho9416 = (struct UserObject *)inho9416->super;
    inho9416->super = obj9416;
    self = inheritingObject9416;
    *selfslot = self;
    lowerouter9416 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9416;
  }
// method "new"
  block_savedest(obj9416);
  Object closure9418 = createclosure(1, "new");
  setclosureframe(closure9418, stackframe);
  addtoclosure(closure9418, var_blankNode);
  struct UserObject *uo9418 = (struct UserObject*)obj9416;
  uo9418->data[1] = (Object)closure9418;
  Method *meth_meth_ast_new9418 = addmethod2pos(obj9416, "new", &meth_ast_new9418, 1);
  int argcv_meth_ast_new9418[] = {0};
  meth_meth_ast_new9418->type = alloc_MethodType(1, argcv_meth_ast_new9418);
  meth_meth_ast_new9418->definitionModule = modulename;
  meth_meth_ast_new9418->definitionLine = 2416;
  block_savedest(obj9416);
  Object closure9454 = createclosure(1, "new()object");
  setclosureframe(closure9454, stackframe);
  addtoclosure(closure9454, var_blankNode);
  Method *meth_meth_ast_new9418_object = addmethod2pos(obj9416, "new()object", &meth_ast_new9418_object, 1);
  meth_meth_ast_new9418_object->definitionModule = modulename;
  meth_meth_ast_new9418_object->definitionLine = 2416;
  sourceObject = obj9416;
  objclass9416 = obj9416->class;
  objclass9416->definitionModule = modulename;
  objclass9416->definitionLine = 2415;
  (*(struct UserObject *)self).data[0] = lowerouter9416;
  self = oldself9416;
  selfslot = oldselfslot9416;
  stackframe = oldstackframe9416;
// compiled object node returning obj9416 (depth = 2)
  *var_blankNode = obj9416;
  if (obj9416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankNode"
  block_savedest(self);
  Object closure9455 = createclosure(1, "blankNode");
  setclosureframe(closure9455, stackframe);
  addtoclosure(closure9455, var_blankNode);
  struct UserObject *uo9455 = (struct UserObject*)self;
  uo9455->data[46] = (Object)closure9455;
  Method *meth_meth_ast_blankNode9455 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9455, 46);
  int argcv_meth_ast_blankNode9455[] = {0};
  meth_meth_ast_blankNode9455->type = alloc_MethodType(1, argcv_meth_ast_blankNode9455);
  meth_meth_ast_blankNode9455->definitionModule = modulename;
  meth_meth_ast_blankNode9455->definitionLine = 2417;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9456 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9456 = alloc_userobj2(6,7, objclass9456);
  gc_frame_newslot(obj9456);
if (objclass9456 == NULL) {
  glfree(obj9456->class->name);
  obj9456->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9456, self, 0);
  addmethodreal(obj9456,"outer", &reader_ast_outer_9457);
  Object oldself9456 = self;
  struct StackFrameObject *oldstackframe9456 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9456);
  gc_frame_newslot((Object)stackframe);
  self = obj9456;
  Object *oldselfslot9456 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9456 = (*(struct UserObject *)self).data[0], lowerouter9456 = thisouter9456;
  if (inheritingObject9456) {
    struct UserObject *inho9456 = (struct UserObject *)inheritingObject9456;
    while (inho9456->super != GraceDefaultObject) inho9456 = (struct UserObject *)inho9456->super;
    inho9456->super = obj9456;
    self = inheritingObject9456;
    *selfslot = self;
    lowerouter9456 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9456;
  }
// method "new"
  struct UserObject *uo9458 = (struct UserObject*)obj9456;
  uo9458->data[1] = emptyclosure;
  Method *meth_meth_ast_new9458 = addmethod2pos(obj9456, "new", &meth_ast_new9458, 1);
  int argcv_meth_ast_new9458[] = {0};
  meth_meth_ast_new9458->type = alloc_MethodType(1, argcv_meth_ast_new9458);
  meth_meth_ast_new9458->definitionModule = modulename;
  meth_meth_ast_new9458->definitionLine = 2440;
// method "partName()scope"
  struct UserObject *uo9463 = (struct UserObject*)obj9456;
  uo9463->data[2] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_scope9463 = addmethod2pos(obj9456, "partName()scope", &meth_ast_partName_40__41_scope9463, 2);
  int argcv_meth_ast_partName_40__41_scope9463[] = {1, 1};
  meth_meth_ast_partName_40__41_scope9463->type = alloc_MethodType(2, argcv_meth_ast_partName_40__41_scope9463);
  meth_meth_ast_partName_40__41_scope9463->definitionModule = modulename;
  meth_meth_ast_partName_40__41_scope9463->definitionLine = 2443;
// method "partName()params()scope"
  struct UserObject *uo9469 = (struct UserObject*)obj9456;
  uo9469->data[3] = emptyclosure;
  Method *meth_meth_ast_partName_40__41_params_40__41_scope9469 = addmethod2pos(obj9456, "partName()params()scope", &meth_ast_partName_40__41_params_40__41_scope9469, 3);
  int argcv_meth_ast_partName_40__41_params_40__41_scope9469[] = {1, 1, 1};
  meth_meth_ast_partName_40__41_params_40__41_scope9469->type = alloc_MethodType(3, argcv_meth_ast_partName_40__41_params_40__41_scope9469);
  meth_meth_ast_partName_40__41_params_40__41_scope9469->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params_40__41_scope9469->definitionLine = 2448;
// method "partName"
  struct UserObject *uo9474 = (struct UserObject*)obj9456;
  uo9474->data[4] = emptyclosure;
  Method *meth_meth_ast_partName9474 = addmethod2pos(obj9456, "partName", &meth_ast_partName9474, 4);
  int argcv_meth_ast_partName9474[] = {1};
  meth_meth_ast_partName9474->type = alloc_MethodType(1, argcv_meth_ast_partName9474);
  meth_meth_ast_partName9474->definitionModule = modulename;
  meth_meth_ast_partName9474->definitionLine = 2453;
// method "partName()params"
  block_savedest(obj9456);
  Object closure9478 = createclosure(2, "partName()params");
  setclosureframe(closure9478, stackframe);
  addtoclosure(closure9478, var_k);
  addtoclosure(closure9478, var_signaturePart);
  struct UserObject *uo9478 = (struct UserObject*)obj9456;
  uo9478->data[5] = (Object)closure9478;
  Method *meth_meth_ast_partName_40__41_params9478 = addmethod2pos(obj9456, "partName()params", &meth_ast_partName_40__41_params9478, 5);
  int argcv_meth_ast_partName_40__41_params9478[] = {1, 1};
  meth_meth_ast_partName_40__41_params9478->type = alloc_MethodType(2, argcv_meth_ast_partName_40__41_params9478);
  meth_meth_ast_partName_40__41_params9478->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params9478->definitionLine = 2456;
  block_savedest(obj9456);
  Object closure9714 = createclosure(2, "partName()params()object");
  setclosureframe(closure9714, stackframe);
  addtoclosure(closure9714, var_k);
  addtoclosure(closure9714, var_signaturePart);
  Method *meth_meth_ast_partName_40__41_params9478_object = addmethod2pos(obj9456, "partName()params()object", &meth_ast_partName_40__41_params9478_object, 5);
  meth_meth_ast_partName_40__41_params9478_object->definitionModule = modulename;
  meth_meth_ast_partName_40__41_params9478_object->definitionLine = 2456;
  sourceObject = obj9456;
  sourceObject = obj9456;
  sourceObject = obj9456;
  sourceObject = obj9456;
  sourceObject = obj9456;
  objclass9456 = obj9456->class;
  objclass9456->definitionModule = modulename;
  objclass9456->definitionLine = 2439;
  (*(struct UserObject *)self).data[0] = lowerouter9456;
  self = oldself9456;
  selfslot = oldselfslot9456;
  stackframe = oldstackframe9456;
// compiled object node returning obj9456 (depth = 2)
  *var_signaturePart = obj9456;
  if (obj9456 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "signaturePart"
  block_savedest(self);
  Object closure9715 = createclosure(1, "signaturePart");
  setclosureframe(closure9715, stackframe);
  addtoclosure(closure9715, var_signaturePart);
  struct UserObject *uo9715 = (struct UserObject*)self;
  uo9715->data[47] = (Object)closure9715;
  Method *meth_meth_ast_signaturePart9715 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart9715, 47);
  int argcv_meth_ast_signaturePart9715[] = {0};
  meth_meth_ast_signaturePart9715->type = alloc_MethodType(1, argcv_meth_ast_signaturePart9715);
  meth_meth_ast_signaturePart9715->definitionModule = modulename;
  meth_meth_ast_signaturePart9715->definitionLine = 2457;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9716 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9716 = alloc_userobj2(4,5, objclass9716);
  gc_frame_newslot(obj9716);
if (objclass9716 == NULL) {
  glfree(obj9716->class->name);
  obj9716->class->name = "callWithPart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9716, self, 0);
  addmethodreal(obj9716,"outer", &reader_ast_outer_9717);
  Object oldself9716 = self;
  struct StackFrameObject *oldstackframe9716 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9716);
  gc_frame_newslot((Object)stackframe);
  self = obj9716;
  Object *oldselfslot9716 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9716 = (*(struct UserObject *)self).data[0], lowerouter9716 = thisouter9716;
  if (inheritingObject9716) {
    struct UserObject *inho9716 = (struct UserObject *)inheritingObject9716;
    while (inho9716->super != GraceDefaultObject) inho9716 = (struct UserObject *)inho9716->super;
    inho9716->super = obj9716;
    self = inheritingObject9716;
    *selfslot = self;
    lowerouter9716 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9716;
  }
// method "new"
  struct UserObject *uo9718 = (struct UserObject*)obj9716;
  uo9718->data[1] = emptyclosure;
  Method *meth_meth_ast_new9718 = addmethod2pos(obj9716, "new", &meth_ast_new9718, 1);
  int argcv_meth_ast_new9718[] = {0};
  meth_meth_ast_new9718->type = alloc_MethodType(1, argcv_meth_ast_new9718);
  meth_meth_ast_new9718->definitionModule = modulename;
  meth_meth_ast_new9718->definitionLine = 2513;
// method "request()withArgs()scope"
  struct UserObject *uo9723 = (struct UserObject*)obj9716;
  uo9723->data[2] = emptyclosure;
  Method *meth_meth_ast_request_40__41_withArgs_40__41_scope9723 = addmethod2pos(obj9716, "request()withArgs()scope", &meth_ast_request_40__41_withArgs_40__41_scope9723, 2);
  int argcv_meth_ast_request_40__41_withArgs_40__41_scope9723[] = {1, 1, 1};
  meth_meth_ast_request_40__41_withArgs_40__41_scope9723->type = alloc_MethodType(3, argcv_meth_ast_request_40__41_withArgs_40__41_scope9723);
  meth_meth_ast_request_40__41_withArgs_40__41_scope9723->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs_40__41_scope9723->definitionLine = 2516;
// method "request()withArgs"
  block_savedest(obj9716);
  Object closure9728 = createclosure(1, "request()withArgs");
  setclosureframe(closure9728, stackframe);
  addtoclosure(closure9728, var_callWithPart);
  struct UserObject *uo9728 = (struct UserObject*)obj9716;
  uo9728->data[3] = (Object)closure9728;
  Method *meth_meth_ast_request_40__41_withArgs9728 = addmethod2pos(obj9716, "request()withArgs", &meth_ast_request_40__41_withArgs9728, 3);
  int argcv_meth_ast_request_40__41_withArgs9728[] = {1, 1};
  meth_meth_ast_request_40__41_withArgs9728->type = alloc_MethodType(2, argcv_meth_ast_request_40__41_withArgs9728);
meth_meth_ast_request_40__41_withArgs9728->type->types[0] = type_String;
meth_meth_ast_request_40__41_withArgs9728->type->names[0] = "rPart";
  meth_meth_ast_request_40__41_withArgs9728->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs9728->definitionLine = 2521;
  block_savedest(obj9716);
  Object closure9865 = createclosure(1, "request()withArgs()object");
  setclosureframe(closure9865, stackframe);
  addtoclosure(closure9865, var_callWithPart);
  Method *meth_meth_ast_request_40__41_withArgs9728_object = addmethod2pos(obj9716, "request()withArgs()object", &meth_ast_request_40__41_withArgs9728_object, 3);
  meth_meth_ast_request_40__41_withArgs9728_object->definitionModule = modulename;
  meth_meth_ast_request_40__41_withArgs9728_object->definitionLine = 2521;
  sourceObject = obj9716;
  sourceObject = obj9716;
  sourceObject = obj9716;
  objclass9716 = obj9716->class;
  objclass9716->definitionModule = modulename;
  objclass9716->definitionLine = 2512;
  (*(struct UserObject *)self).data[0] = lowerouter9716;
  self = oldself9716;
  selfslot = oldselfslot9716;
  stackframe = oldstackframe9716;
// compiled object node returning obj9716 (depth = 2)
  *var_callWithPart = obj9716;
  if (obj9716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "callWithPart"
  block_savedest(self);
  Object closure9866 = createclosure(1, "callWithPart");
  setclosureframe(closure9866, stackframe);
  addtoclosure(closure9866, var_callWithPart);
  struct UserObject *uo9866 = (struct UserObject*)self;
  uo9866->data[48] = (Object)closure9866;
  Method *meth_meth_ast_callWithPart9866 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart9866, 48);
  int argcv_meth_ast_callWithPart9866[] = {0};
  meth_meth_ast_callWithPart9866->type = alloc_MethodType(1, argcv_meth_ast_callWithPart9866);
  meth_meth_ast_callWithPart9866->definitionModule = modulename;
  meth_meth_ast_callWithPart9866->definitionLine = 2522;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9867 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9867 = alloc_userobj2(2,4, objclass9867);
  gc_frame_newslot(obj9867);
if (objclass9867 == NULL) {
  glfree(obj9867->class->name);
  obj9867->class->name = "commentNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9867, self, 0);
  addmethodreal(obj9867,"outer", &reader_ast_outer_9868);
  Object oldself9867 = self;
  struct StackFrameObject *oldstackframe9867 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9867);
  gc_frame_newslot((Object)stackframe);
  self = obj9867;
  Object *oldselfslot9867 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9867 = (*(struct UserObject *)self).data[0], lowerouter9867 = thisouter9867;
  if (inheritingObject9867) {
    struct UserObject *inho9867 = (struct UserObject *)inheritingObject9867;
    while (inho9867->super != GraceDefaultObject) inho9867 = (struct UserObject *)inho9867->super;
    inho9867->super = obj9867;
    self = inheritingObject9867;
    *selfslot = self;
    lowerouter9867 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9867;
  }
// method "new"
  block_savedest(obj9867);
  Object closure9869 = createclosure(4, "new");
  setclosureframe(closure9869, stackframe);
  addtoclosure(closure9869, var_lineLength);
  addtoclosure(closure9869, var_nullNode);
  addtoclosure(closure9869, var_commentNode);
  addtoclosure(closure9869, var_util);
  struct UserObject *uo9869 = (struct UserObject*)obj9867;
  uo9869->data[1] = (Object)closure9869;
  Method *meth_meth_ast_new9869 = addmethod2pos(obj9867, "new", &meth_ast_new9869, 1);
  int argcv_meth_ast_new9869[] = {1};
  meth_meth_ast_new9869->type = alloc_MethodType(1, argcv_meth_ast_new9869);
  meth_meth_ast_new9869->definitionModule = modulename;
  meth_meth_ast_new9869->definitionLine = 2559;
  block_savedest(obj9867);
  Object closure10071 = createclosure(4, "new()object");
  setclosureframe(closure10071, stackframe);
  addtoclosure(closure10071, var_lineLength);
  addtoclosure(closure10071, var_nullNode);
  addtoclosure(closure10071, var_commentNode);
  addtoclosure(closure10071, var_util);
  Method *meth_meth_ast_new9869_object = addmethod2pos(obj9867, "new()object", &meth_ast_new9869_object, 1);
  meth_meth_ast_new9869_object->definitionModule = modulename;
  meth_meth_ast_new9869_object->definitionLine = 2559;
  sourceObject = obj9867;
  objclass9867 = obj9867->class;
  objclass9867->definitionModule = modulename;
  objclass9867->definitionLine = 2558;
  (*(struct UserObject *)self).data[0] = lowerouter9867;
  self = oldself9867;
  selfslot = oldselfslot9867;
  stackframe = oldstackframe9867;
// compiled object node returning obj9867 (depth = 2)
  *var_commentNode = obj9867;
  if (obj9867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "commentNode"
  block_savedest(self);
  Object closure10072 = createclosure(1, "commentNode");
  setclosureframe(closure10072, stackframe);
  addtoclosure(closure10072, var_commentNode);
  struct UserObject *uo10072 = (struct UserObject*)self;
  uo10072->data[49] = (Object)closure10072;
  Method *meth_meth_ast_commentNode10072 = addmethod2pos(self, "commentNode", &meth_ast_commentNode10072, 49);
  int argcv_meth_ast_commentNode10072[] = {0};
  meth_meth_ast_commentNode10072->type = alloc_MethodType(1, argcv_meth_ast_commentNode10072);
  meth_meth_ast_commentNode10072->definitionModule = modulename;
  meth_meth_ast_commentNode10072->definitionLine = 2565;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type10074 = alloc_Type("ASTVisitor", 29);
    add_Method((ClassData)type10074, "visitIf()up", NULL);
    add_Method((ClassData)type10074, "visitBlock()up", NULL);
    add_Method((ClassData)type10074, "visitMatchCase()up", NULL);
    add_Method((ClassData)type10074, "visitTryCatch()up", NULL);
    add_Method((ClassData)type10074, "visitMethodType()up", NULL);
    add_Method((ClassData)type10074, "visitSignaturePart()up", NULL);
    add_Method((ClassData)type10074, "visitTypeLiteral()up", NULL);
    add_Method((ClassData)type10074, "visitTypeParameters()up", NULL);
    add_Method((ClassData)type10074, "visitTypeDec()up", NULL);
    add_Method((ClassData)type10074, "visitMethod()up", NULL);
    add_Method((ClassData)type10074, "visitCall()up", NULL);
    add_Method((ClassData)type10074, "visitObject()up", NULL);
    add_Method((ClassData)type10074, "visitModule()up", NULL);
    add_Method((ClassData)type10074, "visitArray()up", NULL);
    add_Method((ClassData)type10074, "visitMember()up", NULL);
    add_Method((ClassData)type10074, "visitGeneric()up", NULL);
    add_Method((ClassData)type10074, "visitIdentifier()up", NULL);
    add_Method((ClassData)type10074, "visitString()up", NULL);
    add_Method((ClassData)type10074, "visitNum()up", NULL);
    add_Method((ClassData)type10074, "visitOp()up", NULL);
    add_Method((ClassData)type10074, "visitBind()up", NULL);
    add_Method((ClassData)type10074, "visitDefDec()up", NULL);
    add_Method((ClassData)type10074, "visitVarDec()up", NULL);
    add_Method((ClassData)type10074, "visitImport()up", NULL);
    add_Method((ClassData)type10074, "visitReturn()up", NULL);
    add_Method((ClassData)type10074, "visitInherits()up", NULL);
    add_Method((ClassData)type10074, "visitDialect()up", NULL);
    add_Method((ClassData)type10074, "visitBlank()up", NULL);
    add_Method((ClassData)type10074, "visitComment()up", NULL);
// compiled typeliteral node returning type10074 (depth = 2)
  *var_ASTVisitor = type10074;
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ASTVisitor"
  block_savedest(self);
  Object closure10075 = createclosure(1, "ASTVisitor");
  setclosureframe(closure10075, stackframe);
  addtoclosure(closure10075, var_ASTVisitor);
  struct UserObject *uo10075 = (struct UserObject*)self;
  uo10075->data[50] = (Object)closure10075;
  Method *meth_meth_ast_ASTVisitor10075 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor10075, 50);
  int argcv_meth_ast_ASTVisitor10075[] = {0};
  meth_meth_ast_ASTVisitor10075->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor10075);
  meth_meth_ast_ASTVisitor10075->definitionModule = modulename;
  meth_meth_ast_ASTVisitor10075->definitionLine = 2565;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject10076 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj10076 = alloc_userobj2(1,2, objclass10076);
  gc_frame_newslot(obj10076);
if (objclass10076 == NULL) {
  glfree(obj10076->class->name);
  obj10076->class->name = "patternMarkVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj10076, self, 0);
  addmethodreal(obj10076,"outer", &reader_ast_outer_10077);
  Object oldself10076 = self;
  struct StackFrameObject *oldstackframe10076 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe10076);
  gc_frame_newslot((Object)stackframe);
  self = obj10076;
  Object *oldselfslot10076 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter10076 = (*(struct UserObject *)self).data[0], lowerouter10076 = thisouter10076;
  if (inheritingObject10076) {
    struct UserObject *inho10076 = (struct UserObject *)inheritingObject10076;
    while (inho10076->super != GraceDefaultObject) inho10076 = (struct UserObject *)inho10076->super;
    inho10076->super = obj10076;
    self = inheritingObject10076;
    *selfslot = self;
    lowerouter10076 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter10076;
  }
// method "visitCall()up"
  struct UserObject *uo10078 = (struct UserObject*)obj10076;
  uo10078->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up10078 = addmethod2pos(obj10076, "visitCall()up", &meth_ast_visitCall_40__41_up10078, 1);
  int argcv_meth_ast_visitCall_40__41_up10078[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up10078->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up10078);
  meth_meth_ast_visitCall_40__41_up10078->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up10078->definitionLine = 2786;
  sourceObject = obj10076;
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10083 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10084 = gc_frame_new();
// call case 3: self.outer request
  Object call10085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe10084);
// compiled call node returning call10085 (depth = 5)
// compiled member node returning call10085 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call10086 = callmethodflags(call10085, "baseVisitor()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10083);
// compiled call node returning call10086 (depth = 3)
  struct UserObject *obj10076_uo = (struct UserObject *)obj10076;
  obj10076_uo->super = call10086;
  sourceObject = obj10076;
  objclass10076 = obj10076->class;
  objclass10076->definitionModule = modulename;
  objclass10076->definitionLine = 2784;
  (*(struct UserObject *)self).data[0] = lowerouter10076;
  self = oldself10076;
  selfslot = oldselfslot10076;
  stackframe = oldstackframe10076;
// compiled object node returning obj10076 (depth = 2)
  *var_patternMarkVisitor = obj10076;
  if (obj10076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "patternMarkVisitor"
  block_savedest(self);
  Object closure10087 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure10087, stackframe);
  addtoclosure(closure10087, var_patternMarkVisitor);
  struct UserObject *uo10087 = (struct UserObject*)self;
  uo10087->data[51] = (Object)closure10087;
  Method *meth_meth_ast_patternMarkVisitor10087 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor10087, 51);
  int argcv_meth_ast_patternMarkVisitor10087[] = {0};
  meth_meth_ast_patternMarkVisitor10087->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor10087);
  meth_meth_ast_patternMarkVisitor10087->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor10087->definitionLine = 2785;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
