#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e2f5d98abb4529b811183acfa9f4c89618406e0";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"errormessages\" as errormessages",
  "",
  "var blankLocation := 0",
  "var lastLine := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var values := [ ]",
  "var moduleObject",
  "var comments := emptyList   // so we can request `removeAt`",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "var braceIsType := false",
  "",
  "// sym is a module-level field containing the current token",
  "var sym := object {",
  "    def kind is public = \"start\"",
  "    def line is public = 0",
  "    def linePos is public = 0",
  "    def indent is public = 0",
  "    def value is public = \"\"",
  "    def size is public = 0",
  "}",
  "",
  "var lastToken := sym",
  "var previousCommentToken := lastToken",
  "var statementToken := lastToken     // the token starting the current statement",
  "var comment := false",
  "",
  "method noteBlank {",
  "    blankLocation := sym.line - 1",
  "}",
  "",
  "var firstCallOfNext := true",
  "",
  "method next {",
  "    // Advance to the next token in the stream, assigning it to sym.",
  "    // Put the position in the input into util module variables.",
  "",
  "    if (tokens.size > 0) then {",
  "        lastToken := sym",
  "        lastLine := lastToken.line",
  "        lastIndent := lastToken.indent",
  "        sym := tokens.poll",
  "        if (sym.line > (lastLine + 1)) then { noteBlank }",
  "        pushComments",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        errormessages.syntaxError(\"unexpectedly found the end of the input. \" ",
  "            ++ \"This is often caused by a missing '\\}'\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "    }",
  "}",
  "",
  "",
  "method findNextToken(tokenMatcher) {",
  "    // Search for the next token for which the given block returns true.",
  "    // Used for generating suggestions.",
  "",
  "    if (tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok } && { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(false != n) && { false == nextTok }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = set [\"dot\", \"comma\", \"colon\", \"rparen\",",
  "            \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found is public",
  "        var tok is public",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif { n.kind == \"rbrace\" } then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if (n.kind == \"lbrace\") then {",
  "            numOpening := numOpening + 1",
  "        } elseif { n.kind == \"rbrace\" } then {",
  "            numClosing := numClosing + 1 ",
  "        }",
  "        n := n.next",
  "    }",
  "    if (n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif {(n.prev.kind == \"rbrace\") && (numOpening == numClosing)} then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "",
  "method accept(t) {",
  "    // True if the current token has kind t, where",
  "    // t is \"num\", \"string\", \"method\", etc.",
  "    sym.kind == t",
  "}",
  "",
  "method acceptKeyword (kw) {",
  "    if (sym.kind != \"keyword\") then { return false }",
  "    return sym.value == kw",
  "}",
  "",
  "method acceptSameLine (t) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line (either because it's on the same physical line, or because",
  "    // it's on an indented continuation line).",
  "",
  "    (sym.kind == t) && ",
  "        ((lastLine == sym.line) || (sym.indent > lastIndent))",
  "}",
  "method acceptWithoutSpaces (t) {",
  "    // True if the current token is a t, and follows the previous token",
  "    // without any intervening spaces or continuation lines.",
  "",
  "    (sym.kind == t) && ",
  "        (lastLine == sym.line) && (sym.linePos == (lastToken.linePos + lastToken.size))",
  "}",
  "method acceptAfterSpaces (t) {",
  "    // True if the current token is a t, and is separated from the previous token",
  "    // by one or more spaces, or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (lastLine == sym.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    }",
  "    return sym.linePos == (sym.indent + 1)",
  "}",
  "method accept (t) onLineOf (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as other (either because it's on the same physical",
  "    // line, or because it's on an indented continuation line).",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "method acceptAfterSpaces (t) onLineOf (other) {",
  "    // True if the current token is a t, is on the same logical line as other,",
  "    // and is separated from the previous token by one or more spaces, ",
  "    // or a continuation line.",
  "",
  "    if (sym.kind != t) then { return false }",
  "    if (sym.line == other.line) then {",
  "        return sym.linePos != (lastToken.linePos + lastToken.size)",
  "    } else {",
  "        return sym.linePos == (sym.indent + 1)",
  "    }",
  "}",
  "method accept (t) onLineOfLastOr (other) {",
  "    // True if the current token is a t, and it is on the same logical",
  "    // line as the last token, or the other token.",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "method acceptArgumentOnLineOf(tok) {",
  "    // True if the current token can start an argument to a request",
  "    if (accept \"string\" onLineOf(tok)) then { return true }",
  "    if (accept \"num\" onLineOf(tok)) then { return true }",
  "    if (accept \"lbrace\" onLineOf(tok)) then { return true }",
  "    if (acceptAfterSpaces \"lsquare\" onLineOf(tok)) then { return true }",
  "    if (accept \"identifier\" onLineOf(tok)) then { ",
  "        return (sym.value == \"true\") || (sym.value == \"false\")",
  "    }",
  "    return false",
  "}",
  "method tokenOnSameLine {",
  "    // True if there is a token on the current logical line",
  "    (lastLine == sym.line) || (sym.indent > lastIndent)",
  "}",
  "method didConsume(aParsingBlock) {",
  "    // True if executing aParsingBlock consumes at least one token.",
  "    var sz := tokens.size",
  "    aParsingBlock.apply",
  "    tokens.size != sz",
  "}",
  "method ifConsume(ablock)then(tblock) {",
  "    // If ablock consumes at least one token, execute tblock.",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\") && {false != a.dtype}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"an argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if (acceptKeyword \"is\" .not) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = [ ]",
  "    if(didConsume({expression(noBlocks)}).not) then {",
  "        def suggestions = [ ]",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"bind\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "            atRange(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "            withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"bind\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"one or more annotations separated by commas must follow 'is'.\")",
  "                atRange(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (blankLocation == 0) then {",
  "        if ( sym.line <= (lastToken.line + 1) ) then { return }",
  "        if ( sym.line <= (previousCommentToken.line + 1) ) then { return }",
  "    }",
  "    pushComments",
  "    if ((values.size == 0) || ",
  "            ((values.size > 0) && { values.last.kind != \"blank\" })) then {",
  "        if (blankLocation > 0) then {",
  "            util.setPosition(blankLocation, 0)",
  "            blankLocation := 0",
  "        } else {",
  "            util.setPosition(sym.line - 1, 0)",
  "        }",
  "        values.push(ast.blankNode.new)",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept \"identifier\") then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (acceptKeyword \"type\") then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept \"lparen\") then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({typeexpression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev) leading (true)",
  "                    trailing(false) with \"«type expression»\"",
  "            }",
  "            errormessages.syntaxError \"parentheses must contain a valid type expression.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError \"a type expression beginning with a '(' must end with a ')'.\"",
  "                atRange(lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new(emptySequence, thenList)",
  "    def elseBlock = ast.blockNode.new(emptySequence, elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "method block {",
  "    // parse a block",
  "    if (accept \"lbrace\") then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 2",
  "        var startIndent := statementIndent",
  "        var expr1",
  "        var s := sym",
  "        var tmp",
  "        var params := [ ]",
  "        var body := [ ]",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "        // The paren lets us distinguish parameter ‹a› from pattern ‹(a)› .",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters or patterns",
  "                expr1 := values.pop",
  "                if (accept \"colon\") then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression(blocksOK)}).not) then {",
  "                        def suggestions = [ ]",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken( [\"arrow\", \"rbrace\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"a block must have an expression after the ':'.\")",
  "                            atPosition(sym.line, sym.linePos)",
  "                            withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    expr1.dtype := values.pop",
  "                }",
  "                params.push(expr1)",
  "                if (isMatchingBlock.not && expr1.isIdentifier) then {",
  "                    expr1.isBindingOccurrence := true",
  "                } else {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(false != arrow) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    expr1 := values.pop",
  "                    expr1.isBindingOccurrence := true",
  "                    expr1.dtype := optionalTypeAnnotation",
  "                    params.push(expr1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"a block must have one or more parameters followed by '->' and an expression.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif { accept \"semicolon\" } then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif { ((values.last.kind == \"member\")",
  "                        || (values.last.kind == \"identifier\")",
  "                        || (values.last.kind == \"index\"))",
  "                        && accept(\"bind\") } then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept \"semicolon\") then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept \"arrow\") then {",
  "            next",
  "        }",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a block must end with a '}'.\")",
  "                    atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 2",
  "        statementIndent := startIndent",
  "        next",
  "        util.setPosition(btok.line, btok.linePos)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        def opener = if ((sym.kind == \"lparen\") || {sym.kind == \"lbrace\"})",
  "                        then { sym.value } else { \"-missing-\" }",
  "        def closer = if (opener == \"(\") then { \")\" }",
  "                        else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "        if (opener == \"-missing-\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if (false == nextTok) then {",
  "                suggestion.insert(\" («condition») then \\{\")afterToken(btok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif { nextTok.kind == \"lbrace\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («condition») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«condition») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have a condition \" ++",
  "                \"in parentheses or braces after the 'if'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if (false == nextTok) then {",
  "                nextTok := findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a \" ++",
  "                      \"condition in parentheses or braces after the 'if'.\")",
  "                      atPosition(sym.line, sym.linePos)",
  "                      withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atPosition(sym.line, sym.linePos)",
  "                        withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                        leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"an if statement must have a \" ++",
  "                        \"condition in parentheses or braces after the 'if'.\")",
  "                        atRange(sym.line, sym.linePos, nextTok.linePos - 1)",
  "                        withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (sym.value != closer) then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a \"++",
  "                  \"'{opener}' must end with a '{closer}'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 2",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if (closingBrace.found.not) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"an if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if (closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"an if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                def elopener = if ((sym.kind == \"lparen\") || {sym.kind == \"lbrace\"})",
  "                                then { sym.value } else { \"-missing-\" }",
  "                def elcloser = if (elopener == \"(\") then { \")\" }",
  "                                else { if (elopener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "                if (elopener == \"-missing-\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(false == nextTok) then {",
  "                        suggestion.insert(\" («expression») then \\{\")afterToken(statementToken)",
  "                    } elseif { nextTok.kind == \"rparen\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                        }",
  "                    } elseif { nextTok.kind == \"lbrace\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" («expression») then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif { nextTok.kind == \"identifier\" } then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a \" ++",
  "                          \"condition in parentheses or braces after the 'elseif'.\")",
  "                          atPosition(sym.line, sym.linePos)",
  "                          withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        ((t.kind == \"rparen\") || (t.kind == \"rbrace\"))})",
  "                    if(false == nextTok) then {",
  "                        nextTok := findNextValidToken( [\"rparen\"] )",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"an elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"an elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != elcloser) then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"an expression beginning with a \" ++",
  "                        \"'{elopener}' must end with a '{elcloser}'.\")",
  "                        atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found.not) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"an else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found.not) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"an else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            util.setPosition(btok.line, btok.linePos)",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"an if statement must have 'then' after \" ++",
  "                  \"the condition in parentheses.\")",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept \"identifier\") then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept \"op\") then {",
  "        var op := sym.value",
  "        var val",
  "        next",
  "        if (accept \"lparen\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"a prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "        val := values.pop",
  "        var mem := ast.memberNode.new(\"prefix\" ++ op, val)",
  "        var call := ast.callNode.new(mem, [ast.callWithPart.request(mem.value) withArgs( [] )])",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept \"lgeneric\") then {",
  "        def id = values.pop",
  "        def gens = [ ]",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept \"comma\") then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"a type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept \"lbrace\") then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rbrace\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif { nextTok.kind == \"rparen\" } then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif { nextTok.kind == \"identifier\" } then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"a try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    util.setPosition(catchTok.line, catchTok.linePos)",
  "    values.push(ast.tryCatchNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(false == nextTok) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif { nextTok.kind == \"rparen\" } then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif { nextTok.kind == \"identifier\" } then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression(blocksOK)}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken( [\"rparen\"] )",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"a match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept \"lbrace\") then {",
  "            block",
  "        } elseif { accept \"lparen\" } then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = [ ]",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(false == nextTok) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif { nextTok == sym } then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    util.setPosition(matchTok.line, matchTok.linePos)",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"num\") then {",
  "        pushnum",
  "    } elseif { accept \"string\" } then {",
  "        pushstring",
  "    } elseif { accept \"identifier\" && (sym.value == \"match\") } then {",
  "        matchcase",
  "    } elseif { accept(\"identifier\") && (sym.value == \"try\") } then {",
  "        trycatch",
  "    } elseif { accept \"identifier\" } then {",
  "        identifier",
  "    } elseif { acceptKeyword \"object\" } then {",
  "        doobject",
  "    } elseif { acceptKeyword \"type\" } then {",
  "        dotypeLiteral",
  "    } elseif { accept \"lbrace\" } then {",
  "        block",
  "    } elseif { acceptAfterSpaces \"lsquare\" } then {",
  "        doarray",
  "    } elseif { (lastToken.kind != \"identifier\") && (accept \"lsquare\") } then {",
  "        doarray",
  "    } elseif { accept \"op\" } then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept \"lparen\") then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if (didConsume{expression(acceptBlocks)}.not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rparen\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                      leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptWithoutSpaces(\"lsquare\")) then {",
  "        def opening = sym",
  "        next",
  "        def expr = values.pop",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"'[ ... ]' without preceeding space is no longer part of Grace. \" ++",
  "            \"For a Lineup, add a space.  For an indexing operation, use `at(_)` or `at(_)put(_)`.\")",
  "                atPosition(opening.line, opening.linePos)",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif { o == \"/\" } then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept \"op\") then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parametrised so that it",
  "    // can be used for both type- and value- expressions.",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken) && ",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"an expression containing both arithmetic and non-arithmetic operators requires parentheses.\")atPosition(",
  "                lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            util.setPosition(tmp.line, tmp.linePos)",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept \"lparen\") then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if(didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"an expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (!tokenOnSameLine) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines.at(sym.line))afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"comma\", \"rparen\", \"rsquare\", \"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        util.setPosition(tmp.line, tmp.linePos)",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest(acceptBlocks) {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept \"identifier\") then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept \"dot\") then {",
  "                dotrest(acceptBlocks)",
  "            } elseif { accept \"lparen\" || (acceptBlocks && accept \"lbrace\")",
  "                  || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                  || accept(\"lgeneric\") } then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest(acceptBlocks) {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.value",
  "    def btok = sym",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var signature := []",
  "    var part := ast.callWithPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        genericIdents := typeArgs",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        part.name := methn",
  "        tok := sym",
  "        hadcall := true",
  "        parenthesizedArg(part)",
  "    } elseif { acceptBlocks.not && {accept(\"lbrace\")onLineOf(tok)} } then {",
  "        values.push(meth)",
  "    } elseif { acceptArgumentOnLineOf(tok) } then {",
  "        tok := sym",
  "        hadcall := true",
  "        part.name := methn",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif { meth.kind == \"identifier\" } then {",
  "        values.push(meth)",
  "    } elseif { meth.kind == \"member\" } then {",
  "        var root := meth.in",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.in",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            meth.generics := genericIdents",
  "            values.push(meth)",
  "        }",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.in)",
  "                meth.line := methn.line",
  "                meth.linePos := methn.linePos",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        def call = ast.callNode.new(meth, signature)",
  "        call.generics := genericIdents",
  "        values.push(call)",
  "    } elseif {false != genericIdents} then {",
  "        meth.generics := genericIdents",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parenthesizedArg(part) {",
  "    next",
  "    ifConsume {expression(blocksOK)} then {",
  "        // For matching blocks - same as below",
  "        if (accept \"colon\") then {",
  "            def expr = values.pop",
  "            if (expr.kind != \"identifier\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                if(sym.next.kind == \"identifier\") then {",
  "                    suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                checkBadTypeLiteral",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            expr.dtype := values.pop",
  "            values.push(expr)",
  "        }",
  "        while {accept(\"comma\")} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rparen\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            // For matching blocks - same as above",
  "            if (accept \"colon\") then {",
  "                def arg = values.pop",
  "                if (arg.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"only declarations may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                arg.dtype := values.pop",
  "                values.push(arg)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method request beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parse one or more type arguments, if present, and answer them as a list.",
  "    def startToken = sym",
  "    def args = [ ]",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert(\" \")beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError(\"a method request containing a '<' must have a matching '>'. \"",
  "            ++ \"If '<' is intended as an operator, precede it by a space.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leave it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        } else {",
  "            // values.push(values.pop)",
  "        }",
  "    } elseif {didConsume{dotypeLiteral}} then {",
  "        // values.push(values.pop)",
  "    }",
  "}",
  "",
  "method callmprest(meth, signature, tok) {",
  "    // Parses the rest of a multi-part method name.",
  "    // meth is an identifierNode representing the first part of the name.",
  "    // Returns a new identifierNode, representing the full method name,",
  "    // and updates signature.params with the parsed arguments.",
  "    var methname := meth.value",
  "    var nxt",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.callWithPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if (accept \"lparen\") then {",
  "            next    // skip over the `(`",
  "        } elseif { acceptArgumentOnLineOf(lastToken) } then {",
  "            isTerm := true",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"a while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    errormessages.syntaxError(\"a for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if (methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif { methname == \"for()do\" } then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        def isEmpty = accept \"rparen\"",
  "        if (isTerm) then {",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rparen\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"a part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (acceptKeyword \"def\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if (false == nextToken) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif { nextToken == sym } then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"a definition must have a name, '=', \" ++",
  "                  \"and a value after the 'def'.\") atPosition(sym.line, sym.linePos)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        var dtype := optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"a definition must have a value after the '='.\")",
  "                      atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "                      withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif { accept \"bind\" } then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must use '=' instead of ':='. \" ++",
  "                \"A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1) withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a definition must have '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value but uses 'var', not 'def'.\")",
  "                atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(defTok.line, defTok.linePos)",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        o.startToken := defTok",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (acceptKeyword \"var\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if ((false == nextToken) || {nextToken == sym}) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)",
  "                      leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError \"a variable declaration must have a name after the 'var'.\"",
  "                  atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        def anns = doannotation",
  "        if (accept \"bind\") then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [ ] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)",
  "                          leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        util.setPosition(line, pos)",
  "        def o = ast.varDecNode.new(name, val, dtype)",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept \"lsquare\") then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression(blocksOK)} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rsquare\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a Lineup must contain zero or more expressions separated by commas.\")",
  "                        atPosition(sym.line, sym.linePos) withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a Lineup beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (acceptKeyword \"dialect\") then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"a dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "method inheritsOrUses {",
  "    // Parses \"inherit «object expression»\"",
  "",
  "    if (! accept \"keyword\") then { return }",
  "    if ((sym.value == \"inherits\") || (sym.value == \"inherit\") || (sym.value == \"use\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken( [\"rsquare\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            var msg := \"The {btok.value} keyword must be followed by an expression that creates \"",
  "            if (btok.value == \"use\") then {",
  "                msg := msg ++ \"the trait being used.\"",
  "            } else {",
  "                msg := msg ++ \"the object being inherited.\"",
  "            }",
  "            errormessages.syntaxError(msg)",
  "                atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritsNode.new(values.pop)",
  "        if (btok.value == \"use\") then {",
  "            inhNode.isUse := true",
  "        }",
  "        while { inheritsModifier(inhNode) onLineOf(btok) } do { }",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "method inheritsModifier(node) onLineOf(startToken) {",
  "    // parse an alias or excludes modifier on an `inherits` clause",
  "    if (! accept \"keyword\" onLineOf(startToken) ) then { ",
  "        return false",
  "    }",
  "    if (sym.value == \"alias\") then { ",
  "        parseAlias(node) ",
  "    } elseif {sym.value == \"exclude\"} then {",
  "        parseExclude(node)",
  "    } else {",
  "        false",
  "    }",
  "}",
  "",
  "method parseAlias(node) {",
  "    next    // skip the alias keyword",
  "    def newSig = methodsignature(true)",
  "    def newMeth = newSig.m",
  "    if (accept \"op\" && (sym.value == \"=\")) then {",
  "        next",
  "        def oldSig = methodsignature(true)",
  "        def oldMeth = oldSig.m",
  "        oldMeth.isBindingOccurrence := false",
  "        node.addAlias (newMeth) for (oldMeth)",
  "    } else {",
  "        errormessages.syntaxError (\"An alias modifier must take the form \" ++",
  "            \"'newMethodName = oldMethodName'\") ",
  "            atPosition (lastToken.line, lastToken.linePos + lastToken.size)",
  "    }",
  "    return true",
  "}",
  "method parseExclude(node) {",
  "    next    // skip the exclude keyword",
  "    def exSig = methodsignature(true)",
  "    def excludedMeth = exSig.m",
  "    excludedMeth.isBindingOccurrence := false",
  "    node.addExclusion (excludedMeth)",
  "    return true",
  "}",
  "",
  "method doobject {",
  "    // Parse an object constructor.",
  "    // this method is called doobject because \"object\" is a keyword",
  "",
  "    if (acceptKeyword \"object\") then {",
  "        next",
  "        parseObjectConstructorBody \"an object constructor\" ",
  "            startingWith (lastToken) after \"'object'\"",
  "    }",
  "}",
  "",
  "method parseObjectConstructorBody(constructName) startingWith (btok) after (prev) {",
  "    // Parse the body of an object constructor, leaving the node on the",
  "    // values stack.  Common code for parsing object, class, and factory method",
  "    // bodies; constructName says which, so that error messages are correct.",
  "    // btok is the keyword token that started the construct: class, object, or trait.",
  "    def localMinIndentLevel = minIndentLevel",
  "    def anns = doannotation",
  "    if (sym.kind != \"lbrace\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextToken { t -> t.kind == \"rbrace\" }",
  "        if (false == nextTok) then {",
  "            suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "        }",
  "        errormessages.syntaxError \"{constructName} must have a '\\{' after the {prev}.\"",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if (sym.line == statementToken.line) then {",
  "        minIndentLevel := sym.linePos - 2",
  "    } else {",
  "        minIndentLevel := statementToken.indent + 2",
  "    }",
  "    def body = []",
  "    var superObject := false",
  "    def usedTraits = []",
  "    var inPreamble := true  // => processing inherit and use statements",
  "    while {(accept(\"rbrace\")).not && {sym.kind != \"eof\"}} do {",
  "        if (didConsume {inheritsOrUses}) then {",
  "            def parentNode = values.pop",
  "            if (inPreamble) then {",
  "                if (parentNode.isUse) then {",
  "                    usedTraits.add(parentNode)",
  "                } elseif { usedTraits.isEmpty } then {",
  "                    superObject := parentNode",
  "                } else {",
  "                    errormessages.syntaxError(\"'inherit' must come \" ++",
  "                        \"before 'use' in {constructName}\")",
  "                        atRange(parentNode.line, parentNode.linePos,",
  "                        parentNode.linePos + 7)",
  "                }",
  "            } else {",
  "                errormessages.syntaxError(\"'{parentNode.statementName}' must \" ++",
  "                    \"come at the start of {constructName}\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                            parentNode.linePos + parentNode.statementName.size)",
  "            }",
  "        } elseif { didConsume {methoddec} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } elseif { didConsume {statement} } then {",
  "            inPreamble := false",
  "            body.push(values.pop)",
  "        } else {",
  "            errormessages.syntaxError(\"unexpected symbol '{sym.value}' in body \" ++",
  "                \"of of {constructName}\")",
  "                atRange(sym.line, sym.linePos, sym.linePos + sym.value.size - 1)",
  "        }",
  "    }",
  "    next",
  "    util.setPosition(btok.line, btok.linePos)",
  "    def objNode = ast.objectNode.new(body, superObject)",
  "    if (false != anns) then { objNode.annotations.addAll(anns) }",
  "    objNode.usedTraits := usedTraits",
  "    values.push(objNode)",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method doclass {",
  "    // Accepts a class declaration with or without a `dot`",
  "    // Class declarations were formerly of the form:",
  "    //",
  "    //   class objName.methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // Now they are of the form:",
  "    //",
  "    // class methodName (param1, param2) {",
  "    //     inherits <expr>",
  "    //     var x",
  "    //     method y(z) { ... }",
  "    // }",
  "    // The old \"dotted\" form is compiled into a defDecNode that contains",
  "    // an objectNode that contains the class method and an asString method.",
  "    // The current form is compiled into a methodNode that contains",
  "    // an objectNode, i.e., it is treated as syntactic sugar for",
  "    //",
  "    // method methodName (param1, param2) {",
  "    //     object {",
  "    //         inherits <expr>",
  "    //         var x",
  "    //         method y(z) { ... }",
  "    //     }",
  "    // }",
  "",
  "    def btok = sym",
  "    next",
  "    def localMinIndentLevel = minIndentLevel",
  "    if(sym.kind != \"identifier\") then {",
  "        def suggestions = [ ]",
  "        if(sym.kind == \"lbrace\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(lastToken)with(\"object\")",
  "            suggestions.push(suggestion)",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "        }",
  "        errormessages.syntaxError(\"a class must have a name after the 'class'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    var objName := false",
  "    if (tokens.first.kind == \"dot\") then {",
  "        pushidentifier // the name of the class object",
  "        objName := values.pop",
  "        objName.isBindingOccurrence := true",
  "        next    // skip over the dot",
  "    }",
  "    def s = methodsignature(false)",
  "    def csig = s.sig",
  "    def methodName = s.m",
  "    methodName.isBindingOccurrence := true",
  "    def dtype = s.rtype",
  "    parseObjectConstructorBody \"a class\" startingWith (btok) after \"method header\"",
  "    def objNode = values.pop",
  "    util.setPosition(btok.line, btok.linePos)",
  "    def meth = ast.methodNode.new(methodName, csig, [objNode], dtype)",
  "    meth.typeParams := s.typeParams",
  "    meth.usesClassSyntax := true",
  "    meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "    // see comment in dofactoryMethod",
  "    if (false != objName) then {   // deal with (deprecated) dotted class",
  "        objNode.name := objName.nameString ++ \".\" ++ methodName.nameString",
  "        def asStringBody = [ ast.stringNode.new(\"class {objName.nameString}\") ]",
  "        def asStringMeth = ast.methodNode.new(",
  "            ast.identifierNode.new(\"asString\", false), [], asStringBody, false)",
  "        def metaBody = [meth, asStringMeth]",
  "        def metaObj = ast.objectNode.body (metaBody) named \"class {objName.nameString}\"",
  "        def defDec = ast.defDecNode.new(objName, metaObj, ast.unknownType)",
  "        defDec.startToken := btok",
  "        defDec.annotations.add(ast.identifierNode.new(\"public\", false))",
  "        values.push(defDec)",
  "    } else {",
  "        objNode.name := methodName.nameString",
  "        if (btok.value == \"class\") then {",
  "            objNode.inClass := true",
  "        } elseif { btok.value == \"trait\" } then {",
  "            objNode.inTrait := true",
  "        }",
  "        values.push(meth)",
  "    }",
  "    reconcileComments",
  "    minIndentLevel := localMinIndentLevel",
  "}",
  "",
  "method dofactoryMethod {",
  "    // Accept a factory method declaration",
  "    if ((acceptKeyword \"factory\") && {",
  "            tokens.first.kind == \"keyword\"} && {",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if (sym.kind != \"identifier\") then {",
  "            def suggestions = [ ]",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError \"a factory method must have a name after the 'method'.\"",
  "                atPosition (lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestions (suggestions)",
  "        }",
  "        var s := methodsignature(false)",
  "        def csig = s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        def dtype = s.rtype",
  "        parseObjectConstructorBody \"a factory method\" startingWith (btok) after \"method header\"",
  "        def objNode = values.pop",
  "        objNode.name := methodName",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def meth = ast.methodNode.new(methodName, csig, [objNode], dtype)",
  "        meth.typeParams := s.typeParams",
  "        meth.annotations.addAll(objNode.annotations)  // TODO: sort this out!",
  "        // In a class or factory method declaration, there is just one place",
  "        // for annotations.  These might include annotations on the method (such",
  "        // as confidential), and annotations on the object (such as imutable)",
  "        values.push(meth)",
  "        reconcileComments",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "method methoddec {",
  "    // Parse a method declaration",
  "",
  "    if (acceptKeyword \"method\") then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        var stok := sym",
  "        next",
  "        def m = methodsignature(false)",
  "        def meth = m.m",
  "        def signature = m.sig",
  "        def dtype = m.rtype",
  "        def body = []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept \"lbrace\") then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                def kind is public = \"lbrace\"",
  "                var register is public := \"\"",
  "            })  // a dummy token to mark the position in the values stack",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found.not) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"a method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found.not) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"a method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.methodNode.new(meth, signature, body, dtype)",
  "        o.typeParams := m.typeParams",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "",
  "method methodDecRest(tm, sameline) {",
  "    // Process the remainder of a method header. These follow",
  "    // mostly the same rules as calls, but aren't strictly enforced to be on",
  "    // a single line (because they are ended by \"{\"). ",
  "    //",
  "    // tm is a methodNode.  This method returns a replacement method name ",
  "    // identifier, and modifies tm.params in place.",
  "",
  "    var methname := tm.value.value",
  "    var signature := tm.signature",
  "    var nxt",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        methname := methname ++ \"()\"",
  "        var part := ast.signaturePart.new",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"the declaration of a method with multiple \" ++",
  "                  \"parameter lists must have parentheses around each parameter list.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            nxt := values.pop",
  "            nxt.isBindingOccurrence := true",
  "            nxt.dtype := optionalTypeAnnotation",
  "            part.params.push(nxt)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "    def newName = ast.identifierNode.new(methname, false)",
  "    newName.isBindingOccurrence := true",
  "    newName",
  "}",
  "",
  "method optionalTypeAnnotation {",
  "    // Accept a type annotation if present.",
  "    // Returns the type, or false if there is no annotation",
  "    if (accept \"colon\") then {",
  "        next",
  "        if (didConsume { typeexpression }) then {",
  "            values.pop",
  "        } else {",
  "            checkBadTypeLiteral",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"a type name or type expression must follow ':'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } else {",
  "        false",
  "    }",
  "}",
  "method methodsignature(sameline) {",
  "    // Accept a method signature",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a method name must start with an identifier, or be an operator.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                withSuggestion(suggestion)",
  "    }",
  "    pushidentifier",
  "    var meth := values.pop",
  "    meth.isBindingOccurrence := true",
  "    var signature := [ ]",
  "    def part = ast.signaturePart.partName(meth.value)",
  "    part.line := meth.line",
  "    part.linePos := meth.linePos",
  "    signature.push(part)",
  "    if ((meth.value == \"[\") && {sym.kind == \"rsquare\"}) then {",
  "        errormessages.syntaxError(\"methods named '[]' and '[]:=' are no longer part of Grace.\")",
  "            atRange(lastToken.line, lastToken.linePos, sym.linePos)",
  "    }",
  "    var myTypeParams := false",
  "    if (accept \"lgeneric\") then { myTypeParams := typeparameters }",
  "    if (accept \"bind\") then {",
  "        next",
  "        meth.value := meth.value ++ \":=\"",
  "        part.name := part.name ++ \":=\"",
  "    } elseif { accept \"op\"  && (meth.value == \"prefix\") } then {",
  "        meth.value := meth.value ++ sym.value",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    var dtype := false",
  "    if (accept \"lparen\") then {",
  "        def lparen = sym",
  "        part.linePos := sym.linePos",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept \"op\") then {",
  "                next",
  "                errormessages.syntaxError(\"variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making {sym.value} an Iterable.\")",
  "                    atPosition(lastToken.line, lastToken.linePos)",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            dtype := optionalTypeAnnotation",
  "            id.dtype := dtype",
  "            part.params.push(id)",
  "            if (accept \"comma\") then {",
  "                comma := sym",
  "                next",
  "            } elseif { sym.kind != \"rparen\" } then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(false == rparen) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"a part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            var tm := ast.methodNode.new(meth, signature, [], false)",
  "            meth := methodDecRest(tm, sameline)",
  "        }",
  "    }",
  "    if (accept \"arrow\") then {",
  "        // Return dtype",
  "        next",
  "        typeexpression",
  "        dtype := values.pop",
  "    } else {",
  "        dtype := false",
  "    }",
  "    object {",
  "        def m is public = meth",
  "        def sig is public  = signature",
  "        def rtype is public = dtype",
  "        def typeParams is public = myTypeParams",
  "    }",
  "}",
  "",
  "method typeparameters {",
  "    next",
  "    def typeIds = [ ]",
  "    while {accept(\"identifier\")} do {",
  "        identifier",
  "        def id = values.pop",
  "        id.isBindingOccurrence := true",
  "        typeIds.push(id)",
  "        if (accept \"comma\") then {",
  "            next",
  "        }",
  "    }",
  "    typeIds.do { each -> each.isBindingOccurrence := true }",
  "    def result = ast.typeParametersNode.new(typeIds)",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"a list of type parameters starting with '<' must end with '>'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    result",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (acceptKeyword \"import\") then {",
  "        def importline = sym.line",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"an import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        def dtype = optionalTypeAnnotation",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, name, dtype)",
  "        def anns = doannotation",
  "        if (false != anns) then { o.annotations.addAll(anns) }",
  "        values.push(o)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method doreturn {",
  "    // Accept a return statement; 'return' is followed by an optional expression.",
  "    if (acceptKeyword \"return\") then {",
  "        def retTok = sym",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine) && {accept(\"rbrace\").not}) then {",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = [ ]",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"a return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        util.setPosition(retTok.line, retTok.linePos)",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    def methodTypeTok = sym",
  "    var m := methodsignature(true)",
  "    var meth := m.m",
  "    var signature := m.sig",
  "    var dtype := m.rtype",
  "    if (false == dtype) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    util.setPosition(methodTypeTok.line, methodTypeTok.linePos)",
  "    def o = ast.methodTypeNode.new(meth.value, signature, dtype)",
  "    o.typeParams := m.typeParams",
  "    values.push(o)",
  "    reconcileComments",
  "    if (accept \"semicolon\") then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines.at(sym.line).substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    def typeLiteralTok = sym",
  "    if (acceptKeyword \"type\") then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept \"lbrace\") then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (acceptKeyword \"type\") then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setPosition(typeLiteralTok.line, typeLiteralTok.linePos)",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (acceptKeyword \"type\") then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"a type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        util.setPosition(line, pos)",
  "        def nt = ast.typeDecNode.new(values.pop, false)",
  "        if (accept \"lgeneric\") then { nt.typeParams := typeparameters }",
  "        nt.name.isBindingOccurrence := true",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if ((false == nextTok) || {nextTok == sym}) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError \"a type declaration must have an '=' after the type name.\"",
  "                  atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                  withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept \"lbrace\") then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        nt.value := values.pop",
  "        if (false != anns) then {",
  "            nt.annotations.addAll(anns)",
  "        }",
  "        values.push(nt)",
  "        reconcileComments",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif { sym.kind == \"semicolon\" } then {",
  "        // pass",
  "    } elseif {(sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "          || (sym.kind == \"rsquare\")} then {",
  "        // pass",
  "    } elseif { sym.kind == \"eof\" } then {",
  "    } elseif { sym.indent < minIndentLevel } then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = [ ]",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert \" \" atPosition 1 onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { ",
  "                tok := tok.prev ",
  "            }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"the indentation for this line must be \" ++",
  "                  \"at least {minIndentLevel}. This is often caused by a missing '}'.\")",
  "                  atPosition(sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif { sym.indent > (minIndentLevel + 1) } then {",
  "        minIndentLevel := sym.indent",
  "    } elseif { (sym.indent - lastIndent).abs == 1 } then {",
  "        def m1 = \"the indentation for this line can't differ \"",
  "        def m2 = \"from that of the previous line by 1.\\n  To start a block, or \"",
  "        def m3 = \"to signal a continuation line, increase the indent by 2 or more. \"",
  "        def m4 = \"To end a block, or end the continuation, decrease the indent \"",
  "        def m5 = \"to the prior level. Otherwise, use the same indent as the previous line.\"",
  "        def msg = m1 ++ m2 ++ m3 ++ m4 ++ m5",
  "        errormessages.syntaxError(msg) atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "method statement {",
  "    // Accept a statement. A statement is any of the above that may exist",
  "    // at the top level, and includes expressions.",
  "    // A statement may also be a bind statement x := y, which creates a",
  "    // bind AST node out of the expressions on either side (which at this point",
  "    // can be any arbitrary expression).",
  "",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    def btok = sym",
  "    checkIndent",
  "    if (accept \"keyword\") then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif { sym.value == \"def\" } then {",
  "            defdec",
  "        } elseif { sym.value == \"import\" } then {",
  "            doimport",
  "        } elseif { sym.value == \"dialect\" } then {",
  "            dodialect",
  "        } elseif { sym.value == \"type\" } then {",
  "            typedec",
  "        } elseif { sym.value == \"class\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"trait\" } then {",
  "            doclass",
  "        } elseif { sym.value == \"factory\" } then {",
  "            dofactoryMethod",
  "        } elseif { sym.value == \"return\" } then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                if (dest.kind == \"lbrace\") then {",
  "                    print \"sym = {sym}, sym.line = {sym.line}\"",
  "                    ProgrammingError.raise \"popped lbrace token while parsing statement\"",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = [ ]",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken( [\"rbrace\"] )",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"a valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                util.setPosition(btok.line, btok.linePos)",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    reconcileComments",
  "    if (accept \"eof\") then {",
  "        return true",
  "    }",
  "    if (accept \"semicolon\") then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method pushComments {",
  "    // Push a comment onto the comments stack as a commentNode. If",
  "    // there are consecutive comments following, deal with them all.",
  "    // Adjacent comments extend the first; a break of a blank line",
  "    // starts a new comment node.",
  "",
  "    if ( ! accept \"comment\" ) then { return }",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.commentNode.new(sym.value)",
  "    if ((lastToken.line == sym.line) && (lastToken.kind != \"comment\")) then {",
  "        o.isPartialLine := true",
  "    } elseif { lastToken.line < (sym.line - 1) } then {",
  "        o.isPreceededByBlankLine := true",
  "    }",
  "    comments.push(o)",
  "    while { ",
  "        previousCommentToken := sym",
  "        sym := tokens.poll",
  "        if (sym.line > (previousCommentToken.line + 1)) then { noteBlank }",
  "        accept \"comment\"",
  "    } do {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        o := ast.commentNode.new(sym.value)",
  "        if ( comments.last.endLine == (sym.line - 1) ) then {",
  "            comments.last.extendCommentUsing(o)",
  "        } else {",
  "            comments.push(o)",
  "            if ( lastToken.line < (sym.line - 1) ) then {",
  "                o.isPreceededByBlankLine := true",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method reconcileComments {",
  "    // Should be requested after a new node that represents a \"syntactic unit\"",
  "    // to which comments can be attached is pushed onto `values`",
  "    // Finds comments associated with that node, remove thems from comments",
  "    // stack, and puts them in that node's comments attribute.",
  "",
  "    pushComments",
  "    def node = if (values.isEmpty) then {",
  "        moduleObject ",
  "    } else {",
  "        values.last",
  "    }",
  "    if (node.kind == \"lbrace\") then {",
  "        // lbrace nodes are not AST nodes.  They are used to mark the stack for",
  "        // nested expressions.  Hence, no comments should be attached to them.",
  "        return",
  "    }",
  "    def oLine = node.line",
  "    def preComments = emptyList",
  "    def postComments = emptyList",
  "",
  "    var ix := comments.size",
  "    while { ix > 0 } do {",
  "        def each = comments.at(ix)",
  "        def isPostComment = (each.line == oLine) || (each.line == (oLine+1))",
  "        def isPreComment = each.isPreceededByBlankLine && (each.endLine == (oLine-1))",
  "        if (isPostComment) then {",
  "            postComments.push(comments.removeAt(ix))",
  "        } elseif { isPreComment } then {",
  "            preComments.addFirst(comments.removeAt(ix))",
  "        } elseif { each.endLine < (oLine-1) } then {",
  "            ix := 0     // exit from while",
  "        }",
  "        ix := ix - 1",
  "    }",
  "",
  "    def postSz = postComments.size",
  "    def preSz = preComments.size",
  "",
  "    if ((postSz > 1) && (preSz > 1)) then {",
  "        preComments.last.value := preComments.last.value ++ \"\\n\"",
  "    }",
  "    node.addComments(preComments)",
  "    node.addComments(postComments)",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"the '>' operator must be preceded by a space.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = [ ]",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = [ ]",
  "            var suggestion",
  "            if ( (values.size > 0) && { (values.last.kind == \"identifier\") || { values.last.kind == \"member\" }} && { sym.kind == \"identifier\" } ) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken( [\"rbrace\"] )",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines.at(lastToken.line).substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines.at(sym.line).substringFrom(sym.linePos)to(util.lines.at(sym.line).size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "",
  "method parse(toks) {",
  "    // Parse the given list of tokens, toks, returning an AST moduleNode",
  "    // corresponding to it.",
  "",
  "    util.log_verbose \"parsing.\"",
  "    moduleObject := ast.moduleNode.body(values) named (util.modname)",
  "",
  "    if (toks.size == 0) then {",
  "        return moduleObject",
  "    }",
  "    tokens := toks",
  "    next",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError \"the first line must not be indented.\"",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        ifConsume { inheritsOrUses } then {",
  "            def parentNode = values.pop",
  "            if (parentNode.isUse) then {",
  "                moduleObject.usedTraits.add(parentNode)",
  "            } elseif { moduleObject.usedTraits.isEmpty } then {",
  "                moduleObject.superclass := parentNode",
  "            } else {",
  "                errormessages.syntaxError(\"'inherit' must come \" ++",
  "                    \"before 'use' in a module.\")",
  "                    atRange(parentNode.line, parentNode.linePos,",
  "                    parentNode.linePos + 7)",
  "            }",
  "        }",
  "        blank",
  "        statement",
  "        blank",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"invalid statement. This is often \" ++",
  "                \"caused by an extra '}', ')', or ']'.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos + sym.size - 1)",
  "                withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    blank",
  "    statement",
  "    blank",
  "    return moduleObject",
  "}",
  NULL
};
Object reader_parser_outer_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_register_8273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_m_9058(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_sig_9059(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_rtype_9060(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_typeParams_9061(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_outer_11218(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11219(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_parser_line_11220(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_parser_linePos_11221(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_parser_indent_11222(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_parser_value_11223(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_parser_size_11224(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit49;
static Object strlit51;
static Object strlit111;
static Object strlit159;
static Object strlit192;
static Object strlit193;
static Object strlit194;
static Object strlit195;
static Object strlit196;
static Object strlit197;
static Object strlit198;
static Object strlit199;
static Object strlit205;
static ClassData objclass235;
static Object strlit252;
static Object strlit263;
static Object strlit275;
static Object strlit303;
static Object strlit314;
static Object strlit326;
static Object strlit343;
static Object strlit360;
static Object strlit391;
static Object strlit594;
static Object strlit599;
static Object strlit604;
static Object strlit609;
static Object strlit614;
static Object strlit618;
static Object strlit625;
static Object strlit707;
static Object strlit715;
static Object strlit733;
static Object strlit761;
static Object strlit771;
static Object strlit795;
static Object strlit824;
static Object strlit848;
static Object strlit855;
static Object strlit862;
static Object strlit880;
static Object strlit899;
static Object strlit929;
static Object strlit936;
static Object strlit943;
static Object strlit961;
static Object strlit1022;
static Object strlit1074;
static Object strlit1084;
static Object strlit1093;
static Object strlit1114;
static Object strlit1121;
static Object strlit1128;
static Object strlit1131;
static Object strlit1139;
static Object strlit1151;
static Object strlit1154;
static Object strlit1200;
static Object strlit1217;
static Object strlit1235;
static Object strlit1240;
static Object strlit1244;
static Object strlit1253;
static Object strlit1276;
static Object strlit1277;
static Object strlit1284;
static Object strlit1291;
static Object strlit1309;
static Object strlit1341;
static Object strlit1351;
static Object strlit1382;
static Object strlit1387;
static Object strlit1399;
static Object strlit1425;
static Object strlit1435;
static Object strlit1442;
static Object strlit1449;
static Object strlit1452;
static Object strlit1455;
static Object strlit1465;
static Object strlit1475;
static Object strlit1492;
static Object strlit1497;
static Object strlit1507;
static Object strlit1516;
static Object strlit1547;
static Object strlit1554;
static Object strlit1561;
static Object strlit1579;
static Object strlit1601;
static Object strlit1625;
static Object strlit1650;
static Object strlit1671;
static Object strlit1674;
static Object strlit1723;
static Object strlit1730;
static Object strlit1740;
static Object strlit1748;
static Object strlit1756;
static Object strlit1759;
static Object strlit1762;
static Object strlit1765;
static Object strlit1768;
static Object strlit1769;
static Object strlit1772;
static Object strlit1786;
static Object strlit1793;
static Object strlit1802;
static Object strlit1810;
static Object strlit1817;
static Object strlit1842;
static Object strlit1846;
static Object strlit1856;
static Object strlit1859;
static Object strlit1863;
static Object strlit1873;
static Object strlit1876;
static Object strlit1879;
static Object strlit1886;
static Object strlit1896;
static Object strlit1899;
static Object strlit1902;
static Object strlit1909;
static Object strlit1911;
static Object strlit1939;
static Object strlit1962;
static Object strlit1970;
static Object strlit1977;
static Object strlit1981;
static Object strlit1983;
static Object strlit1995;
static Object strlit1999;
static Object strlit2001;
static Object strlit2013;
static Object strlit2017;
static Object strlit2019;
static Object strlit2045;
static Object strlit2050;
static Object strlit2055;
static Object strlit2059;
static Object strlit2065;
static Object strlit2090;
static Object strlit2097;
static Object strlit2104;
static Object strlit2130;
static Object strlit2141;
static Object strlit2146;
static Object strlit2151;
static Object strlit2154;
static Object strlit2188;
static Object strlit2223;
static Object strlit2234;
static Object strlit2239;
static Object strlit2259;
static Object strlit2266;
static Object strlit2280;
static Object strlit2288;
static Object strlit2296;
static Object strlit2299;
static Object strlit2302;
static Object strlit2305;
static Object strlit2308;
static Object strlit2309;
static Object strlit2312;
static Object strlit2326;
static Object strlit2333;
static Object strlit2342;
static Object strlit2350;
static Object strlit2357;
static Object strlit2382;
static Object strlit2386;
static Object strlit2396;
static Object strlit2399;
static Object strlit2403;
static Object strlit2413;
static Object strlit2416;
static Object strlit2419;
static Object strlit2426;
static Object strlit2436;
static Object strlit2439;
static Object strlit2442;
static Object strlit2449;
static Object strlit2451;
static Object strlit2480;
static Object strlit2487;
static Object strlit2511;
static Object strlit2519;
static Object strlit2526;
static Object strlit2529;
static Object strlit2540;
static Object strlit2543;
static Object strlit2554;
static Object strlit2557;
static Object strlit2582;
static Object strlit2587;
static Object strlit2592;
static Object strlit2596;
static Object strlit2602;
static Object strlit2622;
static Object strlit2629;
static Object strlit2642;
static Object strlit2664;
static Object strlit2669;
static Object strlit2680;
static Object strlit2685;
static Object strlit2702;
static Object strlit2705;
static Object strlit2716;
static Object strlit2719;
static Object strlit2722;
static Object strlit2730;
static Object strlit2756;
static Object strlit2767;
static Object strlit2772;
static Object strlit2777;
static Object strlit2780;
static Object strlit2814;
static Object strlit2849;
static Object strlit2860;
static Object strlit2865;
static Object strlit2893;
static Object strlit2900;
static Object strlit2907;
static Object strlit2933;
static Object strlit2944;
static Object strlit2949;
static Object strlit2954;
static Object strlit2957;
static Object strlit2991;
static Object strlit3026;
static Object strlit3037;
static Object strlit3042;
static Object strlit3073;
static Object strlit3095;
static Object strlit3100;
static Object strlit3111;
static Object strlit3116;
static Object strlit3133;
static Object strlit3136;
static Object strlit3147;
static Object strlit3150;
static Object strlit3154;
static Object strlit3156;
static Object strlit3168;
static Object strlit3172;
static Object strlit3184;
static Object strlit3192;
static Object strlit3212;
static Object strlit3219;
static Object strlit3226;
static Object strlit3229;
static Object strlit3237;
static Object strlit3249;
static Object strlit3252;
static Object strlit3282;
static Object strlit3289;
static Object strlit3296;
static Object strlit3302;
static Object strlit3329;
static Object strlit3352;
static Object strlit3374;
static Object strlit3385;
static Object strlit3396;
static Object strlit3407;
static Object strlit3418;
static Object strlit3432;
static Object strlit3472;
static Object strlit3478;
static Object strlit3488;
static Object strlit3495;
static Object strlit3499;
static Object strlit3514;
static Object strlit3524;
static Object strlit3531;
static Object strlit3535;
static Object strlit3559;
static Object strlit3566;
static Object strlit3575;
static Object strlit3581;
static Object strlit3596;
static Object strlit3603;
static Object strlit3621;
static Object strlit3629;
static Object strlit3644;
static Object strlit3648;
static Object strlit3654;
static Object strlit3658;
static Object strlit3668;
static Object strlit3672;
static Object strlit3677;
static Object strlit3683;
static Object strlit3686;
static Object strlit3689;
static Object strlit3722;
static Object strlit3729;
static Object strlit3736;
static Object strlit3739;
static Object strlit3747;
static Object strlit3759;
static Object strlit3762;
static Object strlit3784;
static Object strlit3791;
static Object strlit3801;
static Object strlit3807;
static Object strlit3827;
static Object strlit3834;
static Object strlit3841;
static Object strlit3844;
static Object strlit3852;
static Object strlit3864;
static Object strlit3867;
static Object strlit3893;
static Object strlit3898;
static Object strlit3907;
static Object strlit3917;
static Object strlit3922;
static Object strlit3927;
static Object strlit3932;
static Object strlit3947;
static Object strlit3954;
static Object strlit3962;
static Object strlit3966;
static Object strlit3969;
static Object strlit3971;
static Object strlit3988;
static Object strlit3995;
static Object strlit4002;
static Object strlit4008;
static Object strlit4028;
static Object strlit4035;
static Object strlit4042;
static Object strlit4045;
static Object strlit4053;
static Object strlit4065;
static Object strlit4068;
static Object strlit4094;
static Object strlit4099;
static Object strlit4108;
static Object strlit4118;
static Object strlit4123;
static Object strlit4128;
static Object strlit4133;
static Object strlit4160;
static Object strlit4167;
static Object strlit4176;
static Object strlit4191;
static Object strlit4198;
static Object strlit4215;
static Object strlit4230;
static Object strlit4234;
static Object strlit4244;
static Object strlit4247;
static Object strlit4251;
static Object strlit4257;
static Object strlit4260;
static Object strlit4266;
static Object strlit4295;
static Object strlit4302;
static Object strlit4309;
static Object strlit4312;
static Object strlit4322;
static Object strlit4334;
static Object strlit4337;
static Object strlit4357;
static Object strlit4364;
static Object strlit4374;
static Object strlit4380;
static Object strlit4400;
static Object strlit4407;
static Object strlit4414;
static Object strlit4417;
static Object strlit4425;
static Object strlit4437;
static Object strlit4440;
static Object strlit4466;
static Object strlit4471;
static Object strlit4480;
static Object strlit4490;
static Object strlit4495;
static Object strlit4500;
static Object strlit4505;
static Object strlit4539;
static Object strlit4545;
static Object strlit4552;
static Object strlit4559;
static Object strlit4567;
static Object strlit4574;
static Object strlit4581;
static Object strlit4587;
static Object strlit4593;
static Object strlit4599;
static Object strlit4605;
static Object strlit4612;
static Object strlit4616;
static Object strlit4626;
static Object strlit4641;
static Object strlit4668;
static Object strlit4675;
static Object strlit4682;
static Object strlit4685;
static Object strlit4693;
static Object strlit4705;
static Object strlit4708;
static Object strlit4741;
static Object strlit4764;
static Object strlit4771;
static Object strlit4778;
static Object strlit4784;
static Object strlit4801;
static Object strlit4809;
static Object strlit4819;
static Object strlit4822;
static Object strlit4835;
static Object strlit4837;
static Object strlit4847;
static Object strlit4853;
static Object strlit4874;
static Object strlit4877;
static Object strlit4887;
static Object strlit4890;
static Object strlit4906;
static Object strlit4914;
static Object strlit4922;
static Object strlit4944;
static Object strlit4950;
static Object strlit4956;
static Object strlit4961;
static Object strlit4980;
static Object strlit4991;
static Object strlit4994;
static Object strlit5006;
static Object strlit5011;
static Object strlit5022;
static Object strlit5081;
static Object strlit5096;
static Object strlit5104;
static Object strlit5108;
static Object strlit5118;
static Object strlit5122;
static Object strlit5128;
static Object strlit5132;
static Object strlit5142;
static Object strlit5154;
static Object strlit5157;
static Object strlit5193;
static Object strlit5197;
static Object strlit5217;
static Object strlit5228;
static Object strlit5234;
static Object strlit5264;
static Object strlit5265;
static Object strlit5266;
static Object strlit5267;
static Object strlit5275;
static Object strlit5279;
static Object strlit5289;
static Object strlit5293;
static Object strlit5314;
static Object strlit5321;
static Object strlit5325;
static Object strlit5402;
static Object strlit5411;
static Object strlit5425;
static Object strlit5445;
static Object strlit5452;
static Object strlit5457;
static Object strlit5462;
static Object strlit5467;
static Object strlit5473;
static Object strlit5479;
static Object strlit5503;
static Object strlit5508;
static Object strlit5527;
static Object strlit5534;
static Object strlit5565;
static Object strlit5572;
static Object strlit5594;
static Object strlit5621;
static Object strlit5630;
static Object strlit5641;
static Object strlit5657;
static Object strlit5671;
static Object strlit5687;
static Object strlit5743;
static Object strlit5749;
static Object strlit5760;
static Object strlit5774;
static Object strlit5800;
static Object strlit5829;
static Object strlit5836;
static Object strlit5843;
static Object strlit5861;
static Object strlit5877;
static Object strlit5907;
static Object strlit5914;
static Object strlit5921;
static Object strlit5939;
static Object strlit5947;
static Object strlit5953;
static Object strlit5964;
static Object strlit5978;
static Object strlit6002;
static Object strlit6031;
static Object strlit6038;
static Object strlit6045;
static Object strlit6063;
static Object strlit6087;
static Object strlit6099;
static Object strlit6102;
static Object strlit6136;
static Object strlit6162;
static Object strlit6173;
static Object strlit6183;
static Object strlit6190;
static Object strlit6195;
static Object strlit6197;
static Object strlit6214;
static Object strlit6220;
static Object strlit6253;
static Object strlit6257;
static Object strlit6271;
static Object strlit6293;
static Object strlit6308;
static Object strlit6317;
static Object strlit6323;
static Object strlit6329;
static Object strlit6333;
static Object strlit6341;
static Object strlit6345;
static Object strlit6352;
static Object strlit6360;
static Object strlit6364;
static Object strlit6367;
static Object strlit6375;
static Object strlit6379;
static Object strlit6382;
static Object strlit6389;
static Object strlit6392;
static Object strlit6399;
static Object strlit6406;
static Object strlit6428;
static Object strlit6435;
static Object strlit6442;
static Object strlit6460;
static Object strlit6470;
static Object strlit6501;
static Object strlit6508;
static Object strlit6515;
static Object strlit6533;
static Object strlit6556;
static Object strlit6568;
static Object strlit6571;
static Object strlit6588;
static Object strlit6611;
static Object strlit6621;
static Object strlit6644;
static Object strlit6651;
static Object strlit6666;
static Object strlit6673;
static Object strlit6680;
static Object strlit6684;
static Object strlit6686;
static Object strlit6708;
static Object strlit6715;
static Object strlit6742;
static Object strlit6749;
static Object strlit6752;
static Object strlit6768;
static Object strlit6776;
static Object strlit6786;
static Object strlit6792;
static Object strlit6794;
static Object strlit6813;
static Object strlit6823;
static Object strlit6829;
static Object strlit6831;
static Object strlit6866;
static Object strlit6876;
static Object strlit6898;
static Object strlit6921;
static Object strlit6928;
static Object strlit6931;
static Object strlit6951;
static Object strlit6978;
static Object strlit6985;
static Object strlit7004;
static Object strlit7006;
static Object strlit7024;
static Object strlit7031;
static Object strlit7040;
static Object strlit7050;
static Object strlit7055;
static Object strlit7085;
static Object strlit7102;
static Object strlit7131;
static Object strlit7138;
static Object strlit7145;
static Object strlit7163;
static Object strlit7180;
static Object strlit7190;
static Object strlit7193;
static Object strlit7215;
static Object strlit7221;
static Object strlit7241;
static Object strlit7249;
static Object strlit7255;
static Object strlit7263;
static Object strlit7278;
static Object strlit7296;
static Object strlit7302;
static Object strlit7310;
static Object strlit7317;
static Object strlit7345;
static Object strlit7352;
static Object strlit7359;
static Object strlit7377;
static Object strlit7383;
static Object strlit7388;
static Object strlit7394;
static Object strlit7399;
static Object strlit7432;
static Object strlit7456;
static Object strlit7462;
static Object strlit7471;
static Object strlit7490;
static Object strlit7497;
static Object strlit7514;
static Object strlit7516;
static Object strlit7546;
static Object strlit7551;
static Object strlit7552;
static Object strlit7559;
static Object strlit7572;
static Object strlit7585;
static Object strlit7588;
static Object strlit7592;
static Object strlit7597;
static Object strlit7601;
static Object strlit7651;
static Object strlit7660;
static Object strlit7690;
static Object strlit7694;
static Object strlit7698;
static Object strlit7714;
static Object strlit7718;
static Object strlit7723;
static Object strlit7729;
static Object strlit7778;
static Object strlit7782;
static Object strlit7787;
static Object strlit7793;
static Object strlit7848;
static Object strlit7856;
static Object strlit7866;
static Object strlit7876;
static Object strlit7885;
static Object strlit7890;
static Object strlit7908;
static Object strlit7938;
static Object strlit7939;
static Object strlit7978;
static Object strlit7988;
static Object strlit7994;
static Object strlit8002;
static Object strlit8015;
static Object strlit8021;
static Object strlit8037;
static Object strlit8053;
static Object strlit8063;
static Object strlit8082;
static Object strlit8095;
static Object strlit8105;
static Object strlit8115;
static Object strlit8123;
static Object strlit8133;
static Object strlit8143;
static Object strlit8152;
static Object strlit8157;
static Object strlit8185;
static Object strlit8186;
static Object strlit8221;
static Object strlit8242;
static ClassData objclass8270;
static Object strlit8274;
static Object strlit8275;
static Object strlit8285;
static Object strlit8304;
static Object strlit8328;
static Object strlit8339;
static Object strlit8344;
static Object strlit8372;
static Object strlit8384;
static Object strlit8387;
static Object strlit8391;
static Object strlit8395;
static Object strlit8443;
static Object strlit8448;
static Object strlit8459;
static Object strlit8485;
static Object strlit8493;
static Object strlit8497;
static Object strlit8499;
static Object strlit8515;
static Object strlit8522;
static Object strlit8527;
static Object strlit8535;
static Object strlit8541;
static Object strlit8547;
static Object strlit8573;
static Object strlit8582;
static Object strlit8592;
static Object strlit8595;
static Object strlit8623;
static Object strlit8645;
static Object strlit8661;
static Object strlit8672;
static Object strlit8680;
static Object strlit8687;
static Object strlit8699;
static Object strlit8702;
static Object strlit8746;
static Object strlit8754;
static Object strlit8761;
static Object strlit8772;
static Object strlit8779;
static Object strlit8785;
static Object strlit8793;
static Object strlit8802;
static Object strlit8809;
static Object strlit8835;
static Object strlit8850;
static Object strlit8857;
static Object strlit8862;
static Object strlit8870;
static Object strlit8876;
static Object strlit8882;
static Object strlit8909;
static Object strlit8916;
static Object strlit8923;
static Object strlit8933;
static Object strlit8936;
static Object strlit8951;
static Object strlit8973;
static Object strlit8987;
static Object strlit8992;
static Object strlit9022;
static Object strlit9027;
static Object strlit9045;
static ClassData objclass9056;
static Object strlit9071;
static Object strlit9087;
static Object strlit9107;
static Object strlit9117;
static Object strlit9120;
static Object strlit9136;
static Object strlit9144;
static Object strlit9164;
static Object strlit9172;
static Object strlit9178;
static Object strlit9186;
static Object strlit9201;
static Object strlit9212;
static Object strlit9219;
static Object strlit9240;
static Object strlit9247;
static Object strlit9251;
static Object strlit9257;
static Object strlit9262;
static Object strlit9281;
static Object strlit9301;
static Object strlit9309;
static Object strlit9315;
static Object strlit9324;
static Object strlit9330;
static Object strlit9347;
static Object strlit9386;
static Object strlit9396;
static Object strlit9421;
static Object strlit9428;
static Object strlit9446;
static Object strlit9464;
static Object strlit9485;
static Object strlit9519;
static Object strlit9547;
static Object strlit9554;
static Object strlit9602;
static Object strlit9611;
static Object strlit9618;
static Object strlit9626;
static Object strlit9629;
static Object strlit9637;
static Object strlit9653;
static Object strlit9661;
static Object strlit9694;
static Object strlit9704;
static Object strlit9714;
static Object strlit9717;
static Object strlit9745;
static Object strlit9761;
static Object strlit9768;
static Object strlit9782;
static Object strlit9804;
static Object strlit9809;
static Object strlit9812;
static Object strlit9831;
static Object strlit9860;
static Object strlit9868;
static Object strlit9876;
static Object strlit9883;
static Object strlit9892;
static Object strlit9935;
static Object strlit9979;
static Object strlit9990;
static Object strlit9997;
static Object strlit10014;
static Object strlit10018;
static Object strlit10022;
static Object strlit10054;
static Object strlit10055;
static Object strlit10056;
static Object strlit10057;
static Object strlit10058;
static Object strlit10086;
static Object strlit10090;
static Object strlit10099;
static Object strlit10108;
static Object strlit10117;
static Object strlit10126;
static Object strlit10135;
static Object strlit10144;
static Object strlit10153;
static Object strlit10162;
static Object strlit10182;
static Object strlit10187;
static Object strlit10197;
static Object strlit10206;
static Object strlit10220;
static Object strlit10226;
static Object strlit10233;
static Object strlit10237;
static Object strlit10244;
static Object strlit10267;
static Object strlit10274;
static Object strlit10281;
static Object strlit10299;
static Object strlit10325;
static Object strlit10330;
static Object strlit10350;
static Object strlit10368;
static Object strlit10424;
static Object strlit10489;
static Object strlit10592;
static Object strlit10609;
static Object strlit10619;
static Object strlit10622;
static Object strlit10632;
static Object strlit10642;
static Object strlit10645;
static Object strlit10656;
static Object strlit10666;
static Object strlit10669;
static Object strlit10689;
static Object strlit10697;
static Object strlit10704;
static Object strlit10719;
static Object strlit10730;
static Object strlit10735;
static Object strlit10745;
static Object strlit10755;
static Object strlit10762;
static Object strlit10772;
static Object strlit10783;
static Object strlit10797;
static Object strlit10807;
static Object strlit10834;
static Object strlit10840;
static Object strlit10872;
static Object strlit10878;
static Object strlit10883;
static Object strlit10891;
static Object strlit10907;
static Object strlit10913;
static Object strlit10921;
static Object strlit10998;
static Object strlit11006;
static Object strlit11044;
static Object strlit11097;
static Object strlit11099;
static Object strlit11134;
static Object strlit11136;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass11217;
static Object strlit11225;
static Object strlit11229;
Object meth_parser_noteBlank1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noteBlank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blankLocation = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for noteBlank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for noteBlank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3 = alloc_Float64(1);
// compiled num node returning num3 (depth = 4)
  int op_slot_right_2 = gc_frame_newslot(num3);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5);
// compiled call node returning call6 (depth = 5)
// compiled member node returning call6 (depth = 4)
  int op_slot_left_2 = gc_frame_newslot(call6);
  params[0] = num3;
  partcv[0] = 1;
  Object diff7 = callmethod(call6, "-", 1, partcv, params);
// compiled op node returning diff7 (depth = 3)
  *var_blankLocation = diff7;
  if (diff7 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next9(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_lastLine = getfromclosure(closure, 3);
  Object *var_lastIndent = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num12 = alloc_Float64(0);
// compiled num node returning num12 (depth = 4)
  int op_slot_right_11 = gc_frame_newslot(num12);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe14 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call15 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe14);
// compiled call node returning call15 (depth = 5)
// compiled member node returning call15 (depth = 4)
  int op_slot_left_11 = gc_frame_newslot(call15);
  params[0] = num12;
  partcv[0] = 1;
  Object opresult16 = callmethod(call15, ">", 1, partcv, params);
// compiled op node returning opresult16 (depth = 3)
  Object if10 = done;
  if (istrue(opresult16)) {
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe18 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call19 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe18);
// compiled call node returning call19 (depth = 5)
// compiled member node returning call19 (depth = 4)
  *var_lastLine = call19;
  if (call19 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe21 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call22 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe21);
// compiled call node returning call22 (depth = 5)
// compiled member node returning call22 (depth = 4)
  *var_lastIndent = call22;
  if (call22 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe24 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call25 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe24);
// compiled call node returning call25 (depth = 5)
// compiled member node returning call25 (depth = 4)
  *var_sym = call25;
  if (call25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num30 = alloc_Float64(1);
// compiled num node returning num30 (depth = 6)
  int op_slot_right_29 = gc_frame_newslot(num30);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastLine (depth = 6)
  int op_slot_left_29 = gc_frame_newslot(*var_lastLine);
  params[0] = num30;
  partcv[0] = 1;
  Object sum32 = callmethod(*var_lastLine, "+", 1, partcv, params);
// compiled op node returning sum32 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(sum32);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe34 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call35 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe34);
// compiled call node returning call35 (depth = 6)
// compiled member node returning call35 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(call35);
  params[0] = sum32;
  partcv[0] = 1;
  Object opresult36 = callmethod(call35, ">", 1, partcv, params);
// compiled op node returning opresult36 (depth = 4)
  Object if27 = done;
  if (istrue(opresult36)) {
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe37 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call38 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compiled call node returning call38 (depth = 5)
// compiled member node returning call38 (depth = 4)
    gc_frame_newslot(call38);
    if27 = call38;
  } else {
  }
// compiled if node returning if27 (depth = 3)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe39 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call40 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 4)
// compiled member node returning call40 (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe41 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe42 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call43 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe42);
// compiled call node returning call43 (depth = 5)
// compiled member node returning call43 (depth = 4)
  gc_frame_newslot(call43);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe44 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call45 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 5)
// compiled member node returning call45 (depth = 4)
  gc_frame_newslot(call45);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call43;
  params[1] = call45;
  partcv[0] = 2;
  Object call46 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe41);
// compiled call node returning call46 (depth = 3)
    gc_frame_newslot(call46);
    if10 = call46;
  } else {
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe47 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit49 == NULL) {
    strlit49 = alloc_String("This is often caused by a missing '}'");
    gc_root(strlit49);
  }
// compiled string node returning strlit49 (depth = 5)
  int op_slot_right_48 = gc_frame_newslot(strlit49);
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit51 == NULL) {
    strlit51 = alloc_String("unexpectedly found the end of the input. ");
    gc_root(strlit51);
  }
// compiled string node returning strlit51 (depth = 5)
  int op_slot_left_48 = gc_frame_newslot(strlit51);
  params[0] = strlit49;
  partcv[0] = 1;
  Object opresult52 = callmethod(strlit51, "++", 1, partcv, params);
// compiled op node returning opresult52 (depth = 4)
  gc_frame_newslot(opresult52);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe53 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call54 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe53);
// compiled call node returning call54 (depth = 5)
// compiled member node returning call54 (depth = 4)
  gc_frame_newslot(call54);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe55 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call56 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe55);
// compiled call node returning call56 (depth = 5)
// compiled member node returning call56 (depth = 4)
  gc_frame_newslot(call56);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe57 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call58 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe57);
// compiled call node returning call58 (depth = 5)
// compiled member node returning call58 (depth = 4)
  gc_frame_newslot(call58);
// call case 6: other member request
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult52;
  params[1] = call54;
  params[2] = call56;
  params[3] = call58;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call59 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe47);
// compiled call node returning call59 (depth = 3)
    gc_frame_newslot(call59);
    if10 = call59;
  }
// compiled if node returning if10 (depth = 2)
  gc_frame_end(frame);
  return if10;
}
Object meth_parser__apply70(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe72 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call73 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe72);
// compiled call node returning call73 (depth = 8)
// compiled member node returning call73 (depth = 7)
  int op_slot_right_71 = gc_frame_newslot(call73);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe75 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call76 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe75);
// compiled call node returning call76 (depth = 8)
// compiled member node returning call76 (depth = 7)
  int op_slot_left_71 = gc_frame_newslot(call76);
  params[0] = call73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, "≥", 1, partcv, params);
// compiled op node returning opresult77 (depth = 6)
  gc_frame_end(frame);
  return opresult77;
}
Object meth_parser__apply82(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_83 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 8)
  int op_slot_left_83 = gc_frame_newslot(bool85);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult86 = callmethod(bool85, "==", 1, partcv, params);
// compiled op node returning opresult86 (depth = 7)
  gc_frame_end(frame);
  return opresult86;
}
Object meth_parser__apply67(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block69 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block69);
// method "_apply"
  block_savedest(block69);
  Object closure70 = createclosure(3, "_apply");
  setclosureframe(closure70, stackframe);
  addtoclosure(closure70, var_lastToken);
  addtoclosure(closure70, var_n);
  addtoclosure(closure70, selfslot);
  struct UserObject *uo70 = (struct UserObject*)block69;
  uo70->data[0] = (Object)closure70;
  Method *meth_meth_parser__apply70 = addmethod2pos(block69, "_apply", &meth_parser__apply70, 0);
  int argcv_meth_parser__apply70[] = {0};
  meth_meth_parser__apply70->type = alloc_MethodType(1, argcv_meth_parser__apply70);
  meth_meth_parser__apply70->definitionModule = modulename;
  meth_meth_parser__apply70->definitionLine = 58;
// compiled block node returning block69 (depth = 5)
  int op_slot_right_68 = gc_frame_newslot(block69);
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block81 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block81);
// method "_apply"
  block_savedest(block81);
  Object closure82 = createclosure(2, "_apply");
  setclosureframe(closure82, stackframe);
  addtoclosure(closure82, var_nextTok);
  addtoclosure(closure82, selfslot);
  struct UserObject *uo82 = (struct UserObject*)block81;
  uo82->data[0] = (Object)closure82;
  Method *meth_meth_parser__apply82 = addmethod2pos(block81, "_apply", &meth_parser__apply82, 0);
  int argcv_meth_parser__apply82[] = {0};
  meth_meth_parser__apply82->type = alloc_MethodType(1, argcv_meth_parser__apply82);
  meth_meth_parser__apply82->definitionModule = modulename;
  meth_meth_parser__apply82->definitionLine = 72;
// compiled block node returning block81 (depth = 6)
  int op_slot_right_80 = gc_frame_newslot(block81);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_right_89 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 7)
  Object bool91 = alloc_Boolean(0);
// compiled identifier node returning bool91 (depth = 7)
  int op_slot_left_89 = gc_frame_newslot(bool91);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult92 = callmethod(bool91, "≠", 1, partcv, params);
// compiled op node returning opresult92 (depth = 6)
  int op_slot_left_80 = gc_frame_newslot(opresult92);
  params[0] = block81;
  partcv[0] = 1;
  Object opresult93 = callmethod(opresult92, "&&", 1, partcv, params);
// compiled op node returning opresult93 (depth = 5)
  int op_slot_left_68 = gc_frame_newslot(opresult93);
  params[0] = block69;
  partcv[0] = 1;
  Object opresult94 = callmethod(opresult93, "&&", 1, partcv, params);
// compiled op node returning opresult94 (depth = 4)
  gc_frame_end(frame);
  return opresult94;
}
Object meth_parser__apply97(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe99 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call100 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 5)
  Object if98 = done;
  if (istrue(call100)) {
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if98 = done;
  } else {
  }
// compiled if node returning if98 (depth = 4)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call103 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe102);
// compiled call node returning call103 (depth = 6)
// compiled member node returning call103 (depth = 5)
  *var_n = call103;
  if (call103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextToken");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call63 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe62);
// compiled call node returning call63 (depth = 3)
  Object if61 = done;
  if (istrue(call63)) {
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if61 = undefined;
  } else {
  }
// compiled if node returning if61 (depth = 2)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool64 = alloc_Boolean(0);
// compiled identifier node returning bool64 (depth = 3)
  *var_nextTok = bool64;
  if (bool64 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe65 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block66 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block66);
// method "_apply"
  block_savedest(block66);
  Object closure67 = createclosure(4, "_apply");
  setclosureframe(closure67, stackframe);
  addtoclosure(closure67, var_lastToken);
  addtoclosure(closure67, var_n);
  addtoclosure(closure67, var_nextTok);
  addtoclosure(closure67, selfslot);
  struct UserObject *uo67 = (struct UserObject*)block66;
  uo67->data[0] = (Object)closure67;
  Method *meth_meth_parser__apply67 = addmethod2pos(block66, "_apply", &meth_parser__apply67, 0);
  int argcv_meth_parser__apply67[] = {0};
  meth_meth_parser__apply67->type = alloc_MethodType(1, argcv_meth_parser__apply67);
  meth_meth_parser__apply67->definitionModule = modulename;
  meth_meth_parser__apply67->definitionLine = 58;
// compiled block node returning block66 (depth = 3)
  gc_frame_newslot(block66);
// starting to compile block node (depth = 3)
  Object block96 = alloc_Block(NULL, NULL, "parser", 72);
  gc_frame_newslot(block96);
// method "_apply"
  block_savedest(block96);
  Object closure97 = createclosure(4, "_apply");
  setclosureframe(closure97, stackframe);
  addtoclosure(closure97, var_n);
  addtoclosure(closure97, var_tokenMatcher);
  addtoclosure(closure97, var_nextTok);
  addtoclosure(closure97, selfslot);
  struct UserObject *uo97 = (struct UserObject*)block96;
  uo97->data[0] = (Object)closure97;
  Method *meth_meth_parser__apply97 = addmethod2pos(block96, "_apply", &meth_parser__apply97, 0);
  int argcv_meth_parser__apply97[] = {0};
  meth_meth_parser__apply97->type = alloc_MethodType(1, argcv_meth_parser__apply97);
  meth_meth_parser__apply97->definitionModule = modulename;
  meth_meth_parser__apply97->definitionLine = 72;
// compiled block node returning block96 (depth = 3)
  gc_frame_newslot(block96);
// call case 5: prelude request
  params[0] = block66;
  params[1] = block96;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call106 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe65);
// compiled call node returning call106 (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply141(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_142 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool144 = alloc_Boolean(0);
// compiled identifier node returning bool144 (depth = 7)
  int op_slot_left_142 = gc_frame_newslot(bool144);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult145 = callmethod(bool144, "==", 1, partcv, params);
// compiled op node returning opresult145 (depth = 6)
  gc_frame_end(frame);
  return opresult145;
}
Object meth_parser__apply138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block140 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block140);
// method "_apply"
  block_savedest(block140);
  Object closure141 = createclosure(2, "_apply");
  setclosureframe(closure141, stackframe);
  addtoclosure(closure141, var_nextTok);
  addtoclosure(closure141, selfslot);
  struct UserObject *uo141 = (struct UserObject*)block140;
  uo141->data[0] = (Object)closure141;
  Method *meth_meth_parser__apply141 = addmethod2pos(block140, "_apply", &meth_parser__apply141, 0);
  int argcv_meth_parser__apply141[] = {0};
  meth_meth_parser__apply141->type = alloc_MethodType(1, argcv_meth_parser__apply141);
  meth_meth_parser__apply141->definitionModule = modulename;
  meth_meth_parser__apply141->definitionLine = 82;
// compiled block node returning block140 (depth = 5)
  int op_slot_right_139 = gc_frame_newslot(block140);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_148 = gc_frame_newslot(*var_n);
// starting to compile identifier node (depth = 6)
  Object bool150 = alloc_Boolean(0);
// compiled identifier node returning bool150 (depth = 6)
  int op_slot_left_148 = gc_frame_newslot(bool150);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult151 = callmethod(bool150, "≠", 1, partcv, params);
// compiled op node returning opresult151 (depth = 5)
  int op_slot_left_139 = gc_frame_newslot(opresult151);
  params[0] = block140;
  partcv[0] = 1;
  Object opresult152 = callmethod(opresult151, "&&", 1, partcv, params);
// compiled op node returning opresult152 (depth = 4)
  gc_frame_end(frame);
  return opresult152;
}
Object meth_parser__apply155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit159 == NULL) {
    strlit159 = alloc_String("eof");
    gc_root(strlit159);
  }
// compiled string node returning strlit159 (depth = 7)
  int op_slot_right_158 = gc_frame_newslot(strlit159);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call162 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe161);
// compiled call node returning call162 (depth = 8)
// compiled member node returning call162 (depth = 7)
  int op_slot_left_158 = gc_frame_newslot(call162);
  params[0] = strlit159;
  partcv[0] = 1;
  Object opresult163 = callmethod(call162, "==", 1, partcv, params);
// compiled op node returning opresult163 (depth = 6)
  int op_slot_right_157 = gc_frame_newslot(opresult163);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call168 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe167);
// compiled call node returning call168 (depth = 9)
// compiled member node returning call168 (depth = 8)
  int op_slot_right_166 = gc_frame_newslot(call168);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe170 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call171 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 9)
// compiled member node returning call171 (depth = 8)
  int op_slot_left_166 = gc_frame_newslot(call171);
  params[0] = call168;
  partcv[0] = 1;
  Object opresult172 = callmethod(call171, "≤", 1, partcv, params);
// compiled op node returning opresult172 (depth = 7)
  int op_slot_right_165 = gc_frame_newslot(opresult172);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call176 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe175);
// compiled call node returning call176 (depth = 9)
// compiled member node returning call176 (depth = 8)
  int op_slot_right_174 = gc_frame_newslot(call176);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call179 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 9)
// compiled member node returning call179 (depth = 8)
  int op_slot_left_174 = gc_frame_newslot(call179);
  params[0] = call176;
  partcv[0] = 1;
  Object opresult180 = callmethod(call179, ">", 1, partcv, params);
// compiled op node returning opresult180 (depth = 7)
  int op_slot_left_165 = gc_frame_newslot(opresult180);
  params[0] = opresult172;
  partcv[0] = 1;
  Object opresult181 = callmethod(opresult180, "&&", 1, partcv, params);
// compiled op node returning opresult181 (depth = 6)
  int op_slot_left_157 = gc_frame_newslot(opresult181);
  params[0] = opresult163;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "||", 1, partcv, params);
// compiled op node returning opresult182 (depth = 5)
  Object if156 = done;
  if (istrue(opresult182)) {
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if156 = done;
  } else {
  }
// compiled if node returning if156 (depth = 4)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call185 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe184);
// compiled call node returning call185 (depth = 6)
// compiled member node returning call185 (depth = 5)
  *var_n = call185;
  if (call185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt107(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextTokenIndentedAt");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextTokenIndentedAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextTokenIndentedAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit111 == NULL) {
    strlit111 = alloc_String("eof");
    gc_root(strlit111);
  }
// compiled string node returning strlit111 (depth = 5)
  int op_slot_right_110 = gc_frame_newslot(strlit111);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call114 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe113);
// compiled call node returning call114 (depth = 6)
// compiled member node returning call114 (depth = 5)
  int op_slot_left_110 = gc_frame_newslot(call114);
  params[0] = strlit111;
  partcv[0] = 1;
  Object opresult115 = callmethod(call114, "==", 1, partcv, params);
// compiled op node returning opresult115 (depth = 4)
  int op_slot_right_109 = gc_frame_newslot(opresult115);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call120 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe119);
// compiled call node returning call120 (depth = 7)
// compiled member node returning call120 (depth = 6)
  int op_slot_right_118 = gc_frame_newslot(call120);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call123 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe122);
// compiled call node returning call123 (depth = 7)
// compiled member node returning call123 (depth = 6)
  int op_slot_left_118 = gc_frame_newslot(call123);
  params[0] = call120;
  partcv[0] = 1;
  Object opresult124 = callmethod(call123, "≤", 1, partcv, params);
// compiled op node returning opresult124 (depth = 5)
  int op_slot_right_117 = gc_frame_newslot(opresult124);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call128 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 7)
// compiled member node returning call128 (depth = 6)
  int op_slot_right_126 = gc_frame_newslot(call128);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call131 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 7)
// compiled member node returning call131 (depth = 6)
  int op_slot_left_126 = gc_frame_newslot(call131);
  params[0] = call128;
  partcv[0] = 1;
  Object opresult132 = callmethod(call131, ">", 1, partcv, params);
// compiled op node returning opresult132 (depth = 5)
  int op_slot_left_117 = gc_frame_newslot(opresult132);
  params[0] = opresult124;
  partcv[0] = 1;
  Object opresult133 = callmethod(opresult132, "&&", 1, partcv, params);
// compiled op node returning opresult133 (depth = 4)
  int op_slot_left_109 = gc_frame_newslot(opresult133);
  params[0] = opresult115;
  partcv[0] = 1;
  Object opresult134 = callmethod(opresult133, "||", 1, partcv, params);
// compiled op node returning opresult134 (depth = 3)
  Object if108 = done;
  if (istrue(opresult134)) {
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if108 = undefined;
  } else {
  }
// compiled if node returning if108 (depth = 2)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 3)
  *var_nextTok = bool135;
  if (bool135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe136 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block137 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block137);
// method "_apply"
  block_savedest(block137);
  Object closure138 = createclosure(3, "_apply");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_nextTok);
  addtoclosure(closure138, var_n);
  addtoclosure(closure138, selfslot);
  struct UserObject *uo138 = (struct UserObject*)block137;
  uo138->data[0] = (Object)closure138;
  Method *meth_meth_parser__apply138 = addmethod2pos(block137, "_apply", &meth_parser__apply138, 0);
  int argcv_meth_parser__apply138[] = {0};
  meth_meth_parser__apply138->type = alloc_MethodType(1, argcv_meth_parser__apply138);
  meth_meth_parser__apply138->definitionModule = modulename;
  meth_meth_parser__apply138->definitionLine = 82;
// compiled block node returning block137 (depth = 3)
  gc_frame_newslot(block137);
// starting to compile block node (depth = 3)
  Object block154 = alloc_Block(NULL, NULL, "parser", 87);
  gc_frame_newslot(block154);
// method "_apply"
  block_savedest(block154);
  Object closure155 = createclosure(5, "_apply");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_sym);
  addtoclosure(closure155, var_tok);
  addtoclosure(closure155, var_n);
  addtoclosure(closure155, var_nextTok);
  addtoclosure(closure155, selfslot);
  struct UserObject *uo155 = (struct UserObject*)block154;
  uo155->data[0] = (Object)closure155;
  Method *meth_meth_parser__apply155 = addmethod2pos(block154, "_apply", &meth_parser__apply155, 0);
  int argcv_meth_parser__apply155[] = {0};
  meth_meth_parser__apply155->type = alloc_MethodType(1, argcv_meth_parser__apply155);
  meth_meth_parser__apply155->definitionModule = modulename;
  meth_meth_parser__apply155->definitionLine = 82;
// compiled block node returning block154 (depth = 3)
  gc_frame_newslot(block154);
// call case 5: prelude request
  params[0] = block137;
  params[1] = block154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call188 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe136);
// compiled call node returning call188 (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply203(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit205 == NULL) {
    strlit205 = alloc_String("eof");
    gc_root(strlit205);
  }
// compiled string node returning strlit205 (depth = 5)
  int op_slot_right_204 = gc_frame_newslot(strlit205);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call208 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe207);
// compiled call node returning call208 (depth = 6)
// compiled member node returning call208 (depth = 5)
  int op_slot_left_204 = gc_frame_newslot(call208);
  params[0] = strlit205;
  partcv[0] = 1;
  Object opresult209 = callmethod(call208, "≠", 1, partcv, params);
// compiled op node returning opresult209 (depth = 4)
  gc_frame_end(frame);
  return opresult209;
}
Object meth_parser__apply212(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe214 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  partcv[0] = 0;
  Object call216 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe215);
// compiled call node returning call216 (depth = 7)
// compiled member node returning call216 (depth = 6)
  gc_frame_newslot(call216);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call216;
  partcv[0] = 1;
  Object call217 = callmethod(*var_validFollowTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe214);
// compiled call node returning call217 (depth = 5)
  Object if213 = done;
  if (istrue(call217)) {
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if213 = undefined;
  } else {
  }
// compiled if node returning if213 (depth = 4)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe219 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe220 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validToken (depth = 9)
  partcv[0] = 0;
  Object call222 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe221);
// compiled call node returning call222 (depth = 8)
// compiled member node returning call222 (depth = 7)
  gc_frame_newslot(call222);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call222;
  partcv[0] = 1;
  Object call223 = callmethod(*var_invalidTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe220);
// compiled call node returning call223 (depth = 6)
  partcv[0] = 0;
  Object call224 = callmethod(call223, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe219);
// compiled call node returning call224 (depth = 5)
  Object if218 = done;
  if (istrue(call224)) {
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if218 = undefined;
  } else {
  }
// compiled if node returning if218 (depth = 4)
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call226 = callmethod(*var_validToken, "next",
    1, partcv, params);
  gc_frame_end(callframe225);
// compiled call node returning call226 (depth = 6)
// compiled member node returning call226 (depth = 5)
  *var_validToken = call226;
  if (call226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findNextValidToken");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findNextValidToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findNextValidToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe190 = gc_frame_new();
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array191 = alloc_BuiltinList();
  gc_pause();
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit192 == NULL) {
    strlit192 = alloc_String("dot");
    gc_root(strlit192);
  }
// compiled string node returning strlit192 (depth = 5)
  params[0] = strlit192;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit193 == NULL) {
    strlit193 = alloc_String("comma");
    gc_root(strlit193);
  }
// compiled string node returning strlit193 (depth = 5)
  params[0] = strlit193;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("colon");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 5)
  params[0] = strlit194;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit195 == NULL) {
    strlit195 = alloc_String("rparen");
    gc_root(strlit195);
  }
// compiled string node returning strlit195 (depth = 5)
  params[0] = strlit195;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit196 == NULL) {
    strlit196 = alloc_String("rbrace");
    gc_root(strlit196);
  }
// compiled string node returning strlit196 (depth = 5)
  params[0] = strlit196;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit197 == NULL) {
    strlit197 = alloc_String("rsquare");
    gc_root(strlit197);
  }
// compiled string node returning strlit197 (depth = 5)
  params[0] = strlit197;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit198 == NULL) {
    strlit198 = alloc_String("arrow");
    gc_root(strlit198);
  }
// compiled string node returning strlit198 (depth = 5)
  params[0] = strlit198;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 5)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("bind");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 5)
  params[0] = strlit199;
  partcv[0] = 1;
  callmethodflags(array191, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array191 (depth = 4)
  gc_frame_newslot(array191);
// call case 5: prelude request
  params[0] = array191;
  partcv[0] = 1;
  Object call200 = callmethodflags(prelude, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe190);
// compiled call node returning call200 (depth = 3)
  *var_invalidTokens = call200;
  if (call200 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe201 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block202 = alloc_Block(NULL, NULL, "parser", 101);
  gc_frame_newslot(block202);
// method "_apply"
  block_savedest(block202);
  Object closure203 = createclosure(2, "_apply");
  setclosureframe(closure203, stackframe);
  addtoclosure(closure203, var_validToken);
  addtoclosure(closure203, selfslot);
  struct UserObject *uo203 = (struct UserObject*)block202;
  uo203->data[0] = (Object)closure203;
  Method *meth_meth_parser__apply203 = addmethod2pos(block202, "_apply", &meth_parser__apply203, 0);
  int argcv_meth_parser__apply203[] = {0};
  meth_meth_parser__apply203->type = alloc_MethodType(1, argcv_meth_parser__apply203);
  meth_meth_parser__apply203->definitionModule = modulename;
  meth_meth_parser__apply203->definitionLine = 91;
// compiled block node returning block202 (depth = 3)
  gc_frame_newslot(block202);
// starting to compile block node (depth = 3)
  Object block211 = alloc_Block(NULL, NULL, "parser", 101);
  gc_frame_newslot(block211);
// method "_apply"
  block_savedest(block211);
  Object closure212 = createclosure(4, "_apply");
  setclosureframe(closure212, stackframe);
  addtoclosure(closure212, var_validToken);
  addtoclosure(closure212, var_validFollowTokens);
  addtoclosure(closure212, var_invalidTokens);
  addtoclosure(closure212, selfslot);
  struct UserObject *uo212 = (struct UserObject*)block211;
  uo212->data[0] = (Object)closure212;
  Method *meth_meth_parser__apply212 = addmethod2pos(block211, "_apply", &meth_parser__apply212, 0);
  int argcv_meth_parser__apply212[] = {0};
  meth_meth_parser__apply212->type = alloc_MethodType(1, argcv_meth_parser__apply212);
  meth_meth_parser__apply212->definitionModule = modulename;
  meth_meth_parser__apply212->definitionLine = 101;
// compiled block node returning block211 (depth = 3)
  gc_frame_newslot(block211);
// call case 5: prelude request
  params[0] = block202;
  params[1] = block211;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call229 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe201);
// compiled call node returning call229 (depth = 2)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call245 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe244);
// compiled call node returning call245 (depth = 7)
// compiled member node returning call245 (depth = 6)
  int op_slot_right_243 = gc_frame_newslot(call245);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call248 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe247);
// compiled call node returning call248 (depth = 7)
// compiled member node returning call248 (depth = 6)
  int op_slot_left_243 = gc_frame_newslot(call248);
  params[0] = call245;
  partcv[0] = 1;
  Object opresult249 = callmethod(call248, "==", 1, partcv, params);
// compiled op node returning opresult249 (depth = 5)
  int op_slot_right_242 = gc_frame_newslot(opresult249);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit252 == NULL) {
    strlit252 = alloc_String("eof");
    gc_root(strlit252);
  }
// compiled string node returning strlit252 (depth = 6)
  int op_slot_right_251 = gc_frame_newslot(strlit252);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call255 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe254);
// compiled call node returning call255 (depth = 7)
// compiled member node returning call255 (depth = 6)
  int op_slot_left_251 = gc_frame_newslot(call255);
  params[0] = strlit252;
  partcv[0] = 1;
  Object opresult256 = callmethod(call255, "≠", 1, partcv, params);
// compiled op node returning opresult256 (depth = 5)
  int op_slot_left_242 = gc_frame_newslot(opresult256);
  params[0] = opresult249;
  partcv[0] = 1;
  Object opresult257 = callmethod(opresult256, "&&", 1, partcv, params);
// compiled op node returning opresult257 (depth = 4)
  gc_frame_end(frame);
  return opresult257;
}
Object meth_parser__apply260(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit263 == NULL) {
    strlit263 = alloc_String("lbrace");
    gc_root(strlit263);
  }
// compiled string node returning strlit263 (depth = 6)
  int op_slot_right_262 = gc_frame_newslot(strlit263);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call266 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe265);
// compiled call node returning call266 (depth = 7)
// compiled member node returning call266 (depth = 6)
  int op_slot_left_262 = gc_frame_newslot(call266);
  params[0] = strlit263;
  partcv[0] = 1;
  Object opresult267 = callmethod(call266, "==", 1, partcv, params);
// compiled op node returning opresult267 (depth = 5)
  Object if261 = done;
  if (istrue(opresult267)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num269 = alloc_Float64(1);
// compiled num node returning num269 (depth = 7)
  int op_slot_right_268 = gc_frame_newslot(num269);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_268 = gc_frame_newslot(*var_numOpening);
  params[0] = num269;
  partcv[0] = 1;
  Object sum271 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum271 (depth = 6)
  *var_numOpening = sum271;
  if (sum271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if261 = done;
  } else {
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit275 == NULL) {
    strlit275 = alloc_String("rbrace");
    gc_root(strlit275);
  }
// compiled string node returning strlit275 (depth = 7)
  int op_slot_right_274 = gc_frame_newslot(strlit275);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call278 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe277);
// compiled call node returning call278 (depth = 8)
// compiled member node returning call278 (depth = 7)
  int op_slot_left_274 = gc_frame_newslot(call278);
  params[0] = strlit275;
  partcv[0] = 1;
  Object opresult279 = callmethod(call278, "==", 1, partcv, params);
// compiled op node returning opresult279 (depth = 6)
  Object if273 = done;
  if (istrue(opresult279)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num281 = alloc_Float64(1);
// compiled num node returning num281 (depth = 8)
  int op_slot_right_280 = gc_frame_newslot(num281);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_280 = gc_frame_newslot(*var_numClosing);
  params[0] = num281;
  partcv[0] = 1;
  Object sum283 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum283 (depth = 7)
  *var_numClosing = sum283;
  if (sum283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if273 = done;
  } else {
  }
// compiled if node returning if273 (depth = 5)
    gc_frame_newslot(if273);
    if261 = if273;
  }
// compiled if node returning if261 (depth = 4)
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call286 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe285);
// compiled call node returning call286 (depth = 6)
// compiled member node returning call286 (depth = 5)
  *var_n = call286;
  if (call286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply292(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call296 = callmethod(*var_token, "indent",
    1, partcv, params);
  gc_frame_end(callframe295);
// compiled call node returning call296 (depth = 7)
// compiled member node returning call296 (depth = 6)
  int op_slot_right_294 = gc_frame_newslot(call296);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call299 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe298);
// compiled call node returning call299 (depth = 7)
// compiled member node returning call299 (depth = 6)
  int op_slot_left_294 = gc_frame_newslot(call299);
  params[0] = call296;
  partcv[0] = 1;
  Object opresult300 = callmethod(call299, ">", 1, partcv, params);
// compiled op node returning opresult300 (depth = 5)
  int op_slot_right_293 = gc_frame_newslot(opresult300);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit303 == NULL) {
    strlit303 = alloc_String("eof");
    gc_root(strlit303);
  }
// compiled string node returning strlit303 (depth = 6)
  int op_slot_right_302 = gc_frame_newslot(strlit303);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call306 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe305);
// compiled call node returning call306 (depth = 7)
// compiled member node returning call306 (depth = 6)
  int op_slot_left_302 = gc_frame_newslot(call306);
  params[0] = strlit303;
  partcv[0] = 1;
  Object opresult307 = callmethod(call306, "≠", 1, partcv, params);
// compiled op node returning opresult307 (depth = 5)
  int op_slot_left_293 = gc_frame_newslot(opresult307);
  params[0] = opresult300;
  partcv[0] = 1;
  Object opresult308 = callmethod(opresult307, "&&", 1, partcv, params);
// compiled op node returning opresult308 (depth = 4)
  gc_frame_end(frame);
  return opresult308;
}
Object meth_parser__apply311(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit314 == NULL) {
    strlit314 = alloc_String("lbrace");
    gc_root(strlit314);
  }
// compiled string node returning strlit314 (depth = 6)
  int op_slot_right_313 = gc_frame_newslot(strlit314);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call317 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe316);
// compiled call node returning call317 (depth = 7)
// compiled member node returning call317 (depth = 6)
  int op_slot_left_313 = gc_frame_newslot(call317);
  params[0] = strlit314;
  partcv[0] = 1;
  Object opresult318 = callmethod(call317, "==", 1, partcv, params);
// compiled op node returning opresult318 (depth = 5)
  Object if312 = done;
  if (istrue(opresult318)) {
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num320 = alloc_Float64(1);
// compiled num node returning num320 (depth = 7)
  int op_slot_right_319 = gc_frame_newslot(num320);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_319 = gc_frame_newslot(*var_numOpening);
  params[0] = num320;
  partcv[0] = 1;
  Object sum322 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum322 (depth = 6)
  *var_numOpening = sum322;
  if (sum322 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if312 = done;
  } else {
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit326 == NULL) {
    strlit326 = alloc_String("rbrace");
    gc_root(strlit326);
  }
// compiled string node returning strlit326 (depth = 7)
  int op_slot_right_325 = gc_frame_newslot(strlit326);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call329 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe328);
// compiled call node returning call329 (depth = 8)
// compiled member node returning call329 (depth = 7)
  int op_slot_left_325 = gc_frame_newslot(call329);
  params[0] = strlit326;
  partcv[0] = 1;
  Object opresult330 = callmethod(call329, "==", 1, partcv, params);
// compiled op node returning opresult330 (depth = 6)
  Object if324 = done;
  if (istrue(opresult330)) {
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num332 = alloc_Float64(1);
// compiled num node returning num332 (depth = 8)
  int op_slot_right_331 = gc_frame_newslot(num332);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_331 = gc_frame_newslot(*var_numClosing);
  params[0] = num332;
  partcv[0] = 1;
  Object sum334 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum334 (depth = 7)
  *var_numClosing = sum334;
  if (sum334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if324 = done;
  } else {
  }
// compiled if node returning if324 (depth = 5)
    gc_frame_newslot(if324);
    if312 = if324;
  }
// compiled if node returning if312 (depth = 4)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call337 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe336);
// compiled call node returning call337 (depth = 6)
// compiled member node returning call337 (depth = 5)
  *var_n = call337;
  if (call337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method findClosingBrace");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if231 = done;
struct StackFrameObject *iftmpstackframe231 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe231);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num232 = alloc_Float64(1);
// compiled num node returning num232 (depth = 4)
    gc_frame_newslot(num232);
    if231 = num232;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe231);
  gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num233 = alloc_Float64(0);
// compiled num node returning num233 (depth = 4)
    gc_frame_newslot(num233);
    if231 = num233;
  }
stackframe = iftmpstackframe231;
// compiled if node returning if231 (depth = 3)
  *var_numOpening = if231;
  if (if231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num234 = alloc_Float64(0);
// compiled num node returning num234 (depth = 3)
  *var_numClosing = num234;
  if (num234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject235 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj235 = alloc_userobj2(4,4, objclass235);
  gc_frame_newslot(obj235);
if (objclass235 == NULL) {
  glfree(obj235->class->name);
  obj235->class->name = "result";
}
// OBJECT OUTER DEC outer
  adddatum2(obj235, self, 0);
  addmethodreal(obj235,"outer", &reader_parser_outer_236);
  Object oldself235 = self;
  struct StackFrameObject *oldstackframe235 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe235);
  gc_frame_newslot((Object)stackframe);
  self = obj235;
  Object *oldselfslot235 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter235 = (*(struct UserObject *)self).data[0], lowerouter235 = thisouter235;
  if (inheritingObject235) {
    struct UserObject *inho235 = (struct UserObject *)inheritingObject235;
    while (inho235->super != GraceDefaultObject) inho235 = (struct UserObject *)inho235->super;
    inho235->super = obj235;
    self = inheritingObject235;
    *selfslot = self;
    lowerouter235 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter235;
  }
if (objclass235 == NULL) {
  Method *reader237 = addmethodrealflags(obj235, "found",&reader_parser_found_237, 0);
  Method *writer237 = addmethodrealflags(obj235, "found:=",&writer_parser_found_237, 0);
  reader237->definitionModule = modulename;
  writer237->definitionModule = modulename;
  reader237->definitionLine = 126;
  writer237->definitionLine = 126;
}
obj235->flags |= OFLAG_MUTABLE;
adddatum2(obj235, alloc_Undefined(), 1);
if (objclass235 == NULL) {
  Method *reader238 = addmethodrealflags(obj235, "tok",&reader_parser_tok_238, 0);
  Method *writer238 = addmethodrealflags(obj235, "tok:=",&writer_parser_tok_238, 0);
  reader238->definitionModule = modulename;
  writer238->definitionModule = modulename;
  reader238->definitionLine = 127;
  writer238->definitionLine = 127;
}
obj235->flags |= OFLAG_MUTABLE;
adddatum2(obj235, alloc_Undefined(), 2);
  sourceObject = obj235;
  adddatum2(obj235, undefined, 1);
  sourceObject = obj235;
  adddatum2(obj235, undefined, 2);
  objclass235 = obj235->class;
  objclass235->definitionModule = modulename;
  objclass235->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter235;
  self = oldself235;
  selfslot = oldselfslot235;
  stackframe = oldstackframe235;
// compiled object node returning obj235 (depth = 3)
  *var_result = obj235;
  if (obj235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe239 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block240 = alloc_Block(NULL, NULL, "parser", 130);
  gc_frame_newslot(block240);
// method "_apply"
  block_savedest(block240);
  Object closure241 = createclosure(3, "_apply");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var_token);
  addtoclosure(closure241, var_n);
  addtoclosure(closure241, selfslot);
  struct UserObject *uo241 = (struct UserObject*)block240;
  uo241->data[0] = (Object)closure241;
  Method *meth_meth_parser__apply241 = addmethod2pos(block240, "_apply", &meth_parser__apply241, 0);
  int argcv_meth_parser__apply241[] = {0};
  meth_meth_parser__apply241->type = alloc_MethodType(1, argcv_meth_parser__apply241);
  meth_meth_parser__apply241->definitionModule = modulename;
  meth_meth_parser__apply241->definitionLine = 111;
// compiled block node returning block240 (depth = 3)
  gc_frame_newslot(block240);
// starting to compile block node (depth = 3)
  Object block259 = alloc_Block(NULL, NULL, "parser", 130);
  gc_frame_newslot(block259);
// method "_apply"
  block_savedest(block259);
  Object closure260 = createclosure(4, "_apply");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_n);
  addtoclosure(closure260, var_numOpening);
  addtoclosure(closure260, var_numClosing);
  addtoclosure(closure260, selfslot);
  struct UserObject *uo260 = (struct UserObject*)block259;
  uo260->data[0] = (Object)closure260;
  Method *meth_meth_parser__apply260 = addmethod2pos(block259, "_apply", &meth_parser__apply260, 0);
  int argcv_meth_parser__apply260[] = {0};
  meth_meth_parser__apply260->type = alloc_MethodType(1, argcv_meth_parser__apply260);
  meth_meth_parser__apply260->definitionModule = modulename;
  meth_meth_parser__apply260->definitionLine = 130;
// compiled block node returning block259 (depth = 3)
  gc_frame_newslot(block259);
// call case 5: prelude request
  params[0] = block240;
  params[1] = block259;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call289 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe239);
// compiled call node returning call289 (depth = 2)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe290 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block291 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block291);
// method "_apply"
  block_savedest(block291);
  Object closure292 = createclosure(3, "_apply");
  setclosureframe(closure292, stackframe);
  addtoclosure(closure292, var_token);
  addtoclosure(closure292, var_n);
  addtoclosure(closure292, selfslot);
  struct UserObject *uo292 = (struct UserObject*)block291;
  uo292->data[0] = (Object)closure292;
  Method *meth_meth_parser__apply292 = addmethod2pos(block291, "_apply", &meth_parser__apply292, 0);
  int argcv_meth_parser__apply292[] = {0};
  meth_meth_parser__apply292->type = alloc_MethodType(1, argcv_meth_parser__apply292);
  meth_meth_parser__apply292->definitionModule = modulename;
  meth_meth_parser__apply292->definitionLine = 133;
// compiled block node returning block291 (depth = 3)
  gc_frame_newslot(block291);
// starting to compile block node (depth = 3)
  Object block310 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block310);
// method "_apply"
  block_savedest(block310);
  Object closure311 = createclosure(4, "_apply");
  setclosureframe(closure311, stackframe);
  addtoclosure(closure311, var_n);
  addtoclosure(closure311, var_numOpening);
  addtoclosure(closure311, var_numClosing);
  addtoclosure(closure311, selfslot);
  struct UserObject *uo311 = (struct UserObject*)block310;
  uo311->data[0] = (Object)closure311;
  Method *meth_meth_parser__apply311 = addmethod2pos(block310, "_apply", &meth_parser__apply311, 0);
  int argcv_meth_parser__apply311[] = {0};
  meth_meth_parser__apply311->type = alloc_MethodType(1, argcv_meth_parser__apply311);
  meth_meth_parser__apply311->definitionModule = modulename;
  meth_meth_parser__apply311->definitionLine = 136;
// compiled block node returning block310 (depth = 3)
  gc_frame_newslot(block310);
// call case 5: prelude request
  params[0] = block291;
  params[1] = block310;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call340 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe290);
// compiled call node returning call340 (depth = 2)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit343 == NULL) {
    strlit343 = alloc_String("rbrace");
    gc_root(strlit343);
  }
// compiled string node returning strlit343 (depth = 4)
  int op_slot_right_342 = gc_frame_newslot(strlit343);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe345 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call346 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe345);
// compiled call node returning call346 (depth = 5)
// compiled member node returning call346 (depth = 4)
  int op_slot_left_342 = gc_frame_newslot(call346);
  params[0] = strlit343;
  partcv[0] = 1;
  Object opresult347 = callmethod(call346, "==", 1, partcv, params);
// compiled op node returning opresult347 (depth = 3)
  Object if341 = done;
  if (istrue(opresult347)) {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe348 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool349 = alloc_Boolean(1);
// compiled identifier node returning bool349 (depth = 4)
  gc_frame_newslot(bool349);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = bool349;
  partcv[0] = 1;
  Object call350 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe348);
// compiled call node returning call350 (depth = 3)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe351 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call352 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe351);
// compiled call node returning call352 (depth = 3)
    gc_frame_newslot(call352);
    if341 = call352;
  } else {
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_355 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_355 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult357 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compiled op node returning opresult357 (depth = 5)
  int op_slot_right_354 = gc_frame_newslot(opresult357);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit360 == NULL) {
    strlit360 = alloc_String("rbrace");
    gc_root(strlit360);
  }
// compiled string node returning strlit360 (depth = 6)
  int op_slot_right_359 = gc_frame_newslot(strlit360);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe362 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call364 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe363);
// compiled call node returning call364 (depth = 9)
// compiled member node returning call364 (depth = 8)
  partcv[0] = 0;
  Object call365 = callmethod(call364, "kind",
    1, partcv, params);
  gc_frame_end(callframe362);
// compiled call node returning call365 (depth = 7)
// compiled member node returning call365 (depth = 6)
  int op_slot_left_359 = gc_frame_newslot(call365);
  params[0] = strlit360;
  partcv[0] = 1;
  Object opresult366 = callmethod(call365, "==", 1, partcv, params);
// compiled op node returning opresult366 (depth = 5)
  int op_slot_left_354 = gc_frame_newslot(opresult366);
  params[0] = opresult357;
  partcv[0] = 1;
  Object opresult367 = callmethod(opresult366, "&&", 1, partcv, params);
// compiled op node returning opresult367 (depth = 4)
  Object if353 = done;
  if (istrue(opresult367)) {
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool369 = alloc_Boolean(1);
// compiled identifier node returning bool369 (depth = 5)
  gc_frame_newslot(bool369);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool369;
  partcv[0] = 1;
  Object call370 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe368);
// compiled call node returning call370 (depth = 4)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe371 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe372 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call373 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe372);
// compiled call node returning call373 (depth = 6)
// compiled member node returning call373 (depth = 5)
  gc_frame_newslot(call373);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call373;
  partcv[0] = 1;
  Object call374 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe371);
// compiled call node returning call374 (depth = 4)
    gc_frame_newslot(call374);
    if353 = call374;
  } else {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe375 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool376 = alloc_Boolean(0);
// compiled identifier node returning bool376 (depth = 5)
  gc_frame_newslot(bool376);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool376;
  partcv[0] = 1;
  Object call377 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe375);
// compiled call node returning call377 (depth = 4)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe378 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe379 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call380 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe379);
// compiled call node returning call380 (depth = 6)
// compiled member node returning call380 (depth = 5)
  gc_frame_newslot(call380);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call380;
  partcv[0] = 1;
  Object call381 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe378);
// compiled call node returning call381 (depth = 4)
    gc_frame_newslot(call381);
    if353 = call381;
  }
// compiled if node returning if353 (depth = 3)
    gc_frame_newslot(if353);
    if341 = if353;
  }
// compiled if node returning if341 (depth = 2)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_383 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call386 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe385);
// compiled call node returning call386 (depth = 4)
// compiled member node returning call386 (depth = 3)
  int op_slot_left_383 = gc_frame_newslot(call386);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult387 = callmethod(call386, "==", 1, partcv, params);
// compiled op node returning opresult387 (depth = 2)
  gc_frame_end(frame);
  return opresult387;
}
Object meth_parser_acceptKeyword388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptKeyword");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptKeyword");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptKeyword (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_kw = &(stackframe->slots[0]);
  *var_kw = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptKeyword");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit391 == NULL) {
    strlit391 = alloc_String("keyword");
    gc_root(strlit391);
  }
// compiled string node returning strlit391 (depth = 4)
  int op_slot_right_390 = gc_frame_newslot(strlit391);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call394 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe393);
// compiled call node returning call394 (depth = 5)
// compiled member node returning call394 (depth = 4)
  int op_slot_left_390 = gc_frame_newslot(call394);
  params[0] = strlit391;
  partcv[0] = 1;
  Object opresult395 = callmethod(call394, "≠", 1, partcv, params);
// compiled op node returning opresult395 (depth = 3)
  Object if389 = done;
  if (istrue(opresult395)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool396 = alloc_Boolean(0);
// compiled identifier node returning bool396 (depth = 4)
  return bool396;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if389 = undefined;
  } else {
  }
// compiled if node returning if389 (depth = 2)
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_kw (depth = 4)
  int op_slot_right_397 = gc_frame_newslot(*var_kw);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call400 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call400 (depth = 5)
// compiled member node returning call400 (depth = 4)
  int op_slot_left_397 = gc_frame_newslot(call400);
  params[0] = *var_kw;
  partcv[0] = 1;
  Object opresult401 = callmethod(call400, "==", 1, partcv, params);
// compiled op node returning opresult401 (depth = 3)
  return opresult401;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_acceptSameLine402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptSameLine");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptSameLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_405 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call408 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe407);
// compiled call node returning call408 (depth = 6)
// compiled member node returning call408 (depth = 5)
  int op_slot_left_405 = gc_frame_newslot(call408);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult409 = callmethod(call408, ">", 1, partcv, params);
// compiled op node returning opresult409 (depth = 4)
  int op_slot_right_404 = gc_frame_newslot(opresult409);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call413 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe412);
// compiled call node returning call413 (depth = 6)
// compiled member node returning call413 (depth = 5)
  int op_slot_right_411 = gc_frame_newslot(call413);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_411 = gc_frame_newslot(*var_lastLine);
  params[0] = call413;
  partcv[0] = 1;
  Object opresult415 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult415 (depth = 4)
  int op_slot_left_404 = gc_frame_newslot(opresult415);
  params[0] = opresult409;
  partcv[0] = 1;
  Object opresult416 = callmethod(opresult415, "||", 1, partcv, params);
// compiled op node returning opresult416 (depth = 3)
  int op_slot_right_403 = gc_frame_newslot(opresult416);
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_418 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call421 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe420);
// compiled call node returning call421 (depth = 5)
// compiled member node returning call421 (depth = 4)
  int op_slot_left_418 = gc_frame_newslot(call421);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult422 = callmethod(call421, "==", 1, partcv, params);
// compiled op node returning opresult422 (depth = 3)
  int op_slot_left_403 = gc_frame_newslot(opresult422);
  params[0] = opresult416;
  partcv[0] = 1;
  Object opresult423 = callmethod(opresult422, "&&", 1, partcv, params);
// compiled op node returning opresult423 (depth = 2)
  gc_frame_end(frame);
  return opresult423;
}
Object meth_parser_acceptWithoutSpaces424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptWithoutSpaces");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptWithoutSpaces");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptWithoutSpaces (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptWithoutSpaces");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call429 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe428);
// compiled call node returning call429 (depth = 6)
// compiled member node returning call429 (depth = 5)
  int op_slot_right_427 = gc_frame_newslot(call429);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe431 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call432 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe431);
// compiled call node returning call432 (depth = 6)
// compiled member node returning call432 (depth = 5)
  int op_slot_left_427 = gc_frame_newslot(call432);
  params[0] = call429;
  partcv[0] = 1;
  Object sum433 = callmethod(call432, "+", 1, partcv, params);
// compiled op node returning sum433 (depth = 4)
  int op_slot_right_426 = gc_frame_newslot(sum433);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe435 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call436 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe435);
// compiled call node returning call436 (depth = 5)
// compiled member node returning call436 (depth = 4)
  int op_slot_left_426 = gc_frame_newslot(call436);
  params[0] = sum433;
  partcv[0] = 1;
  Object opresult437 = callmethod(call436, "==", 1, partcv, params);
// compiled op node returning opresult437 (depth = 3)
  int op_slot_right_425 = gc_frame_newslot(opresult437);
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe441 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call442 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe441);
// compiled call node returning call442 (depth = 6)
// compiled member node returning call442 (depth = 5)
  int op_slot_right_440 = gc_frame_newslot(call442);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastLine (depth = 5)
  int op_slot_left_440 = gc_frame_newslot(*var_lastLine);
  params[0] = call442;
  partcv[0] = 1;
  Object opresult444 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult444 (depth = 4)
  int op_slot_right_439 = gc_frame_newslot(opresult444);
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  int op_slot_right_446 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call449 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe448);
// compiled call node returning call449 (depth = 6)
// compiled member node returning call449 (depth = 5)
  int op_slot_left_446 = gc_frame_newslot(call449);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult450 = callmethod(call449, "==", 1, partcv, params);
// compiled op node returning opresult450 (depth = 4)
  int op_slot_left_439 = gc_frame_newslot(opresult450);
  params[0] = opresult444;
  partcv[0] = 1;
  Object opresult451 = callmethod(opresult450, "&&", 1, partcv, params);
// compiled op node returning opresult451 (depth = 3)
  int op_slot_left_425 = gc_frame_newslot(opresult451);
  params[0] = opresult437;
  partcv[0] = 1;
  Object opresult452 = callmethod(opresult451, "&&", 1, partcv, params);
// compiled op node returning opresult452 (depth = 2)
  gc_frame_end(frame);
  return opresult452;
}
Object meth_parser_acceptAfterSpaces453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastLine = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptAfterSpaces");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_455 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call458 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call458 (depth = 5)
// compiled member node returning call458 (depth = 4)
  int op_slot_left_455 = gc_frame_newslot(call458);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult459 = callmethod(call458, "≠", 1, partcv, params);
// compiled op node returning opresult459 (depth = 3)
  Object if454 = done;
  if (istrue(opresult459)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool460 = alloc_Boolean(0);
// compiled identifier node returning bool460 (depth = 4)
  return bool460;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if454 = undefined;
  } else {
  }
// compiled if node returning if454 (depth = 2)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call464 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe463);
// compiled call node returning call464 (depth = 5)
// compiled member node returning call464 (depth = 4)
  int op_slot_right_462 = gc_frame_newslot(call464);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_462 = gc_frame_newslot(*var_lastLine);
  params[0] = call464;
  partcv[0] = 1;
  Object opresult466 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult466 (depth = 3)
  Object if461 = done;
  if (istrue(opresult466)) {
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe469 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call470 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe469);
// compiled call node returning call470 (depth = 7)
// compiled member node returning call470 (depth = 6)
  int op_slot_right_468 = gc_frame_newslot(call470);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe472 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call473 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe472);
// compiled call node returning call473 (depth = 7)
// compiled member node returning call473 (depth = 6)
  int op_slot_left_468 = gc_frame_newslot(call473);
  params[0] = call470;
  partcv[0] = 1;
  Object sum474 = callmethod(call473, "+", 1, partcv, params);
// compiled op node returning sum474 (depth = 5)
  int op_slot_right_467 = gc_frame_newslot(sum474);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call477 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe476);
// compiled call node returning call477 (depth = 6)
// compiled member node returning call477 (depth = 5)
  int op_slot_left_467 = gc_frame_newslot(call477);
  params[0] = sum474;
  partcv[0] = 1;
  Object opresult478 = callmethod(call477, "≠", 1, partcv, params);
// compiled op node returning opresult478 (depth = 4)
  return opresult478;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if461 = undefined;
  } else {
  }
// compiled if node returning if461 (depth = 2)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num481 = alloc_Float64(1);
// compiled num node returning num481 (depth = 5)
  int op_slot_right_480 = gc_frame_newslot(num481);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call484 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe483);
// compiled call node returning call484 (depth = 6)
// compiled member node returning call484 (depth = 5)
  int op_slot_left_480 = gc_frame_newslot(call484);
  params[0] = num481;
  partcv[0] = 1;
  Object sum485 = callmethod(call484, "+", 1, partcv, params);
// compiled op node returning sum485 (depth = 4)
  int op_slot_right_479 = gc_frame_newslot(sum485);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call488 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe487);
// compiled call node returning call488 (depth = 5)
// compiled member node returning call488 (depth = 4)
  int op_slot_left_479 = gc_frame_newslot(call488);
  params[0] = sum485;
  partcv[0] = 1;
  Object opresult489 = callmethod(call488, "==", 1, partcv, params);
// compiled op node returning opresult489 (depth = 3)
  return opresult489;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_accept_40__41_onLineOf490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call495 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe494);
// compiled call node returning call495 (depth = 6)
// compiled member node returning call495 (depth = 5)
  int op_slot_right_493 = gc_frame_newslot(call495);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call498 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe497);
// compiled call node returning call498 (depth = 6)
// compiled member node returning call498 (depth = 5)
  int op_slot_left_493 = gc_frame_newslot(call498);
  params[0] = call495;
  partcv[0] = 1;
  Object opresult499 = callmethod(call498, ">", 1, partcv, params);
// compiled op node returning opresult499 (depth = 4)
  int op_slot_right_492 = gc_frame_newslot(opresult499);
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call503 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe502);
// compiled call node returning call503 (depth = 6)
// compiled member node returning call503 (depth = 5)
  int op_slot_right_501 = gc_frame_newslot(call503);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call506 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe505);
// compiled call node returning call506 (depth = 6)
// compiled member node returning call506 (depth = 5)
  int op_slot_left_501 = gc_frame_newslot(call506);
  params[0] = call503;
  partcv[0] = 1;
  Object opresult507 = callmethod(call506, "==", 1, partcv, params);
// compiled op node returning opresult507 (depth = 4)
  int op_slot_left_492 = gc_frame_newslot(opresult507);
  params[0] = opresult499;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "||", 1, partcv, params);
// compiled op node returning opresult508 (depth = 3)
  int op_slot_right_491 = gc_frame_newslot(opresult508);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_510 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe512 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call513 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe512);
// compiled call node returning call513 (depth = 5)
// compiled member node returning call513 (depth = 4)
  int op_slot_left_510 = gc_frame_newslot(call513);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult514 = callmethod(call513, "==", 1, partcv, params);
// compiled op node returning opresult514 (depth = 3)
  int op_slot_left_491 = gc_frame_newslot(opresult514);
  params[0] = opresult508;
  partcv[0] = 1;
  Object opresult515 = callmethod(opresult514, "&&", 1, partcv, params);
// compiled op node returning opresult515 (depth = 2)
  gc_frame_end(frame);
  return opresult515;
}
Object meth_parser_acceptAfterSpaces_40__41_onLineOf516(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptAfterSpaces()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptAfterSpaces()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for acceptAfterSpaces()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptAfterSpaces");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_518 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call521 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe520);
// compiled call node returning call521 (depth = 5)
// compiled member node returning call521 (depth = 4)
  int op_slot_left_518 = gc_frame_newslot(call521);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult522 = callmethod(call521, "≠", 1, partcv, params);
// compiled op node returning opresult522 (depth = 3)
  Object if517 = done;
  if (istrue(opresult522)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool523 = alloc_Boolean(0);
// compiled identifier node returning bool523 (depth = 4)
  return bool523;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if517 = undefined;
  } else {
  }
// compiled if node returning if517 (depth = 2)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  partcv[0] = 0;
  Object call527 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe526);
// compiled call node returning call527 (depth = 5)
// compiled member node returning call527 (depth = 4)
  int op_slot_right_525 = gc_frame_newslot(call527);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe529 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call530 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe529);
// compiled call node returning call530 (depth = 5)
// compiled member node returning call530 (depth = 4)
  int op_slot_left_525 = gc_frame_newslot(call530);
  params[0] = call527;
  partcv[0] = 1;
  Object opresult531 = callmethod(call530, "==", 1, partcv, params);
// compiled op node returning opresult531 (depth = 3)
  Object if524 = done;
  if (istrue(opresult531)) {
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call535 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe534);
// compiled call node returning call535 (depth = 7)
// compiled member node returning call535 (depth = 6)
  int op_slot_right_533 = gc_frame_newslot(call535);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call538 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe537);
// compiled call node returning call538 (depth = 7)
// compiled member node returning call538 (depth = 6)
  int op_slot_left_533 = gc_frame_newslot(call538);
  params[0] = call535;
  partcv[0] = 1;
  Object sum539 = callmethod(call538, "+", 1, partcv, params);
// compiled op node returning sum539 (depth = 5)
  int op_slot_right_532 = gc_frame_newslot(sum539);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call542 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe541);
// compiled call node returning call542 (depth = 6)
// compiled member node returning call542 (depth = 5)
  int op_slot_left_532 = gc_frame_newslot(call542);
  params[0] = sum539;
  partcv[0] = 1;
  Object opresult543 = callmethod(call542, "≠", 1, partcv, params);
// compiled op node returning opresult543 (depth = 4)
  return opresult543;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if524 = undefined;
  } else {
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num546 = alloc_Float64(1);
// compiled num node returning num546 (depth = 6)
  int op_slot_right_545 = gc_frame_newslot(num546);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call549 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe548);
// compiled call node returning call549 (depth = 7)
// compiled member node returning call549 (depth = 6)
  int op_slot_left_545 = gc_frame_newslot(call549);
  params[0] = num546;
  partcv[0] = 1;
  Object sum550 = callmethod(call549, "+", 1, partcv, params);
// compiled op node returning sum550 (depth = 5)
  int op_slot_right_544 = gc_frame_newslot(sum550);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call553 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe552);
// compiled call node returning call553 (depth = 6)
// compiled member node returning call553 (depth = 5)
  int op_slot_left_544 = gc_frame_newslot(call553);
  params[0] = sum550;
  partcv[0] = 1;
  Object opresult554 = callmethod(call553, "==", 1, partcv, params);
// compiled op node returning opresult554 (depth = 4)
  return opresult554;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if524 = undefined;
  }
// compiled if node returning if524 (depth = 2)
  gc_frame_end(frame);
  return if524;
}
Object meth_parser_accept_40__41_onLineOfLastOr555(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOfLastOr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOfLastOr");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method accept()onLineOfLastOr");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for accept()onLineOfLastOr (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOfLastOr");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call560 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe559);
// compiled call node returning call560 (depth = 6)
// compiled member node returning call560 (depth = 5)
  int op_slot_right_558 = gc_frame_newslot(call560);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call563 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe562);
// compiled call node returning call563 (depth = 6)
// compiled member node returning call563 (depth = 5)
  int op_slot_left_558 = gc_frame_newslot(call563);
  params[0] = call560;
  partcv[0] = 1;
  Object opresult564 = callmethod(call563, "==", 1, partcv, params);
// compiled op node returning opresult564 (depth = 4)
  int op_slot_right_557 = gc_frame_newslot(opresult564);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call569 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe568);
// compiled call node returning call569 (depth = 7)
// compiled member node returning call569 (depth = 6)
  int op_slot_right_567 = gc_frame_newslot(call569);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call572 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe571);
// compiled call node returning call572 (depth = 7)
// compiled member node returning call572 (depth = 6)
  int op_slot_left_567 = gc_frame_newslot(call572);
  params[0] = call569;
  partcv[0] = 1;
  Object opresult573 = callmethod(call572, ">", 1, partcv, params);
// compiled op node returning opresult573 (depth = 5)
  int op_slot_right_566 = gc_frame_newslot(opresult573);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call577 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe576);
// compiled call node returning call577 (depth = 7)
// compiled member node returning call577 (depth = 6)
  int op_slot_right_575 = gc_frame_newslot(call577);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call580 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe579);
// compiled call node returning call580 (depth = 7)
// compiled member node returning call580 (depth = 6)
  int op_slot_left_575 = gc_frame_newslot(call580);
  params[0] = call577;
  partcv[0] = 1;
  Object opresult581 = callmethod(call580, "==", 1, partcv, params);
// compiled op node returning opresult581 (depth = 5)
  int op_slot_left_566 = gc_frame_newslot(opresult581);
  params[0] = opresult573;
  partcv[0] = 1;
  Object opresult582 = callmethod(opresult581, "||", 1, partcv, params);
// compiled op node returning opresult582 (depth = 4)
  int op_slot_left_557 = gc_frame_newslot(opresult582);
  params[0] = opresult564;
  partcv[0] = 1;
  Object opresult583 = callmethod(opresult582, "||", 1, partcv, params);
// compiled op node returning opresult583 (depth = 3)
  int op_slot_right_556 = gc_frame_newslot(opresult583);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_585 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe587 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call588 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe587);
// compiled call node returning call588 (depth = 5)
// compiled member node returning call588 (depth = 4)
  int op_slot_left_585 = gc_frame_newslot(call588);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult589 = callmethod(call588, "==", 1, partcv, params);
// compiled op node returning opresult589 (depth = 3)
  int op_slot_left_556 = gc_frame_newslot(opresult589);
  params[0] = opresult583;
  partcv[0] = 1;
  Object opresult590 = callmethod(opresult589, "&&", 1, partcv, params);
// compiled op node returning opresult590 (depth = 2)
  gc_frame_end(frame);
  return opresult590;
}
Object meth_parser_acceptArgumentOnLineOf591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptArgumentOnLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acceptArgumentOnLineOf");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acceptArgumentOnLineOf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for acceptArgumentOnLineOf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe593 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit594 == NULL) {
    strlit594 = alloc_String("string");
    gc_root(strlit594);
  }
// compiled string node returning strlit594 (depth = 4)
  gc_frame_newslot(strlit594);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit594;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call595 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe593);
// compiled call node returning call595 (depth = 3)
  Object if592 = done;
  if (istrue(call595)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool596 = alloc_Boolean(1);
// compiled identifier node returning bool596 (depth = 4)
  return bool596;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if592 = undefined;
  } else {
  }
// compiled if node returning if592 (depth = 2)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe598 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit599 == NULL) {
    strlit599 = alloc_String("num");
    gc_root(strlit599);
  }
// compiled string node returning strlit599 (depth = 4)
  gc_frame_newslot(strlit599);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit599;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call600 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compiled call node returning call600 (depth = 3)
  Object if597 = done;
  if (istrue(call600)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool601 = alloc_Boolean(1);
// compiled identifier node returning bool601 (depth = 4)
  return bool601;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if597 = undefined;
  } else {
  }
// compiled if node returning if597 (depth = 2)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe603 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("lbrace");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 4)
  gc_frame_newslot(strlit604);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit604;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call605 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe603);
// compiled call node returning call605 (depth = 3)
  Object if602 = done;
  if (istrue(call605)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool606 = alloc_Boolean(1);
// compiled identifier node returning bool606 (depth = 4)
  return bool606;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if602 = undefined;
  } else {
  }
// compiled if node returning if602 (depth = 2)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe608 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit609 == NULL) {
    strlit609 = alloc_String("lsquare");
    gc_root(strlit609);
  }
// compiled string node returning strlit609 (depth = 4)
  gc_frame_newslot(strlit609);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit609;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call610 = callmethodflags(self, "acceptAfterSpaces()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe608);
// compiled call node returning call610 (depth = 3)
  Object if607 = done;
  if (istrue(call610)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool611 = alloc_Boolean(1);
// compiled identifier node returning bool611 (depth = 4)
  return bool611;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if607 = undefined;
  } else {
  }
// compiled if node returning if607 (depth = 2)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe613 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit614 == NULL) {
    strlit614 = alloc_String("identifier");
    gc_root(strlit614);
  }
// compiled string node returning strlit614 (depth = 4)
  gc_frame_newslot(strlit614);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tok (depth = 4)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit614;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call615 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe613);
// compiled call node returning call615 (depth = 3)
  Object if612 = done;
  if (istrue(call615)) {
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit618 == NULL) {
    strlit618 = alloc_String("false");
    gc_root(strlit618);
  }
// compiled string node returning strlit618 (depth = 6)
  int op_slot_right_617 = gc_frame_newslot(strlit618);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call621 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe620);
// compiled call node returning call621 (depth = 7)
// compiled member node returning call621 (depth = 6)
  int op_slot_left_617 = gc_frame_newslot(call621);
  params[0] = strlit618;
  partcv[0] = 1;
  Object opresult622 = callmethod(call621, "==", 1, partcv, params);
// compiled op node returning opresult622 (depth = 5)
  int op_slot_right_616 = gc_frame_newslot(opresult622);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit625 == NULL) {
    strlit625 = alloc_String("true");
    gc_root(strlit625);
  }
// compiled string node returning strlit625 (depth = 6)
  int op_slot_right_624 = gc_frame_newslot(strlit625);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call628 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe627);
// compiled call node returning call628 (depth = 7)
// compiled member node returning call628 (depth = 6)
  int op_slot_left_624 = gc_frame_newslot(call628);
  params[0] = strlit625;
  partcv[0] = 1;
  Object opresult629 = callmethod(call628, "==", 1, partcv, params);
// compiled op node returning opresult629 (depth = 5)
  int op_slot_left_616 = gc_frame_newslot(opresult629);
  params[0] = opresult622;
  partcv[0] = 1;
  Object opresult630 = callmethod(opresult629, "||", 1, partcv, params);
// compiled op node returning opresult630 (depth = 4)
  return opresult630;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if612 = undefined;
  } else {
  }
// compiled if node returning if612 (depth = 2)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool631 = alloc_Boolean(0);
// compiled identifier node returning bool631 (depth = 3)
  return bool631;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_tokenOnSameLine632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastLine = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokenOnSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tokenOnSameLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_634 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call637 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe636);
// compiled call node returning call637 (depth = 5)
// compiled member node returning call637 (depth = 4)
  int op_slot_left_634 = gc_frame_newslot(call637);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult638 = callmethod(call637, ">", 1, partcv, params);
// compiled op node returning opresult638 (depth = 3)
  int op_slot_right_633 = gc_frame_newslot(opresult638);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call642 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe641);
// compiled call node returning call642 (depth = 5)
// compiled member node returning call642 (depth = 4)
  int op_slot_right_640 = gc_frame_newslot(call642);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastLine (depth = 4)
  int op_slot_left_640 = gc_frame_newslot(*var_lastLine);
  params[0] = call642;
  partcv[0] = 1;
  Object opresult644 = callmethod(*var_lastLine, "==", 1, partcv, params);
// compiled op node returning opresult644 (depth = 3)
  int op_slot_left_633 = gc_frame_newslot(opresult644);
  params[0] = opresult638;
  partcv[0] = 1;
  Object opresult645 = callmethod(opresult644, "||", 1, partcv, params);
// compiled op node returning opresult645 (depth = 2)
  gc_frame_end(frame);
  return opresult645;
}
Object meth_parser_didConsume646(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method didConsume");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for didConsume (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aParsingBlock = &(stackframe->slots[0]);
  *var_aParsingBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for didConsume");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call648 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe647);
// compiled call node returning call648 (depth = 4)
// compiled member node returning call648 (depth = 3)
  *var_sz = call648;
  if (call648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_aParsingBlock (depth = 4)
  partcv[0] = 0;
  Object call650 = callmethod(*var_aParsingBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe649);
// compiled call node returning call650 (depth = 3)
// compiled member node returning call650 (depth = 2)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_651 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call654 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe653);
// compiled call node returning call654 (depth = 4)
// compiled member node returning call654 (depth = 3)
  int op_slot_left_651 = gc_frame_newslot(call654);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult655 = callmethod(call654, "≠", 1, partcv, params);
// compiled op node returning opresult655 (depth = 2)
  gc_frame_end(frame);
  return opresult655;
}
Object meth_parser_ifConsume_40__41_then656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume()then");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume()then");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ifConsume()then");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for ifConsume()then (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifConsume");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for then");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe657 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call658 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe657);
// compiled call node returning call658 (depth = 4)
// compiled member node returning call658 (depth = 3)
  *var_sz = call658;
  if (call658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call660 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe659);
// compiled call node returning call660 (depth = 3)
// compiled member node returning call660 (depth = 2)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_662 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call665 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe664);
// compiled call node returning call665 (depth = 5)
// compiled member node returning call665 (depth = 4)
  int op_slot_left_662 = gc_frame_newslot(call665);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult666 = callmethod(call665, "≠", 1, partcv, params);
// compiled op node returning opresult666 (depth = 3)
  Object if661 = done;
  if (istrue(opresult666)) {
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tblock (depth = 5)
  partcv[0] = 0;
  Object call668 = callmethod(*var_tblock, "apply",
    1, partcv, params);
  gc_frame_end(callframe667);
// compiled call node returning call668 (depth = 4)
// compiled member node returning call668 (depth = 3)
    gc_frame_newslot(call668);
    if661 = call668;
  } else {
  }
// compiled if node returning if661 (depth = 2)
  gc_frame_end(frame);
  return if661;
}
Object meth_parser_pushnum669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushnum (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushnum");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe670 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call672 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe671);
// compiled call node returning call672 (depth = 5)
// compiled member node returning call672 (depth = 4)
  gc_frame_newslot(call672);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call674 = callmethod(*var_ast, "numNode",
    1, partcv, params);
  gc_frame_end(callframe673);
// compiled call node returning call674 (depth = 5)
// compiled member node returning call674 (depth = 4)
  params[0] = call672;
  partcv[0] = 1;
  Object call675 = callmethod(call674, "new",
    1, partcv, params);
  gc_frame_end(callframe670);
// compiled call node returning call675 (depth = 3)
  *var_o = call675;
  if (call675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe676 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call677 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe676);
// compiled call node returning call677 (depth = 2)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe678 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call679 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe678);
// compiled call node returning call679 (depth = 3)
// compiled member node returning call679 (depth = 2)
  gc_frame_end(frame);
  return call679;
}
Object meth_parser_pushstring680(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushstring (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushstring");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe681 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call683 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 5)
// compiled member node returning call683 (depth = 4)
  gc_frame_newslot(call683);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe684 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call685 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe684);
// compiled call node returning call685 (depth = 5)
// compiled member node returning call685 (depth = 4)
  params[0] = call683;
  partcv[0] = 1;
  Object call686 = callmethod(call685, "new",
    1, partcv, params);
  gc_frame_end(callframe681);
// compiled call node returning call686 (depth = 3)
  *var_o = call686;
  if (call686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe687 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call688 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe687);
// compiled call node returning call688 (depth = 2)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe689 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call690 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe689);
// compiled call node returning call690 (depth = 3)
// compiled member node returning call690 (depth = 2)
  gc_frame_end(frame);
  return call690;
}
Object meth_parser_pushidentifier691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushidentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushidentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe692 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call694 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe693);
// compiled call node returning call694 (depth = 4)
// compiled member node returning call694 (depth = 3)
  gc_frame_newslot(call694);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call696 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe695);
// compiled call node returning call696 (depth = 4)
// compiled member node returning call696 (depth = 3)
  gc_frame_newslot(call696);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call694;
  params[1] = call696;
  partcv[0] = 2;
  Object call697 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe692);
// compiled call node returning call697 (depth = 2)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe698 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call700 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe699);
// compiled call node returning call700 (depth = 5)
// compiled member node returning call700 (depth = 4)
  gc_frame_newslot(call700);
// starting to compile identifier node (depth = 4)
  Object bool701 = alloc_Boolean(0);
// compiled identifier node returning bool701 (depth = 4)
  gc_frame_newslot(bool701);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call703 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe702);
// compiled call node returning call703 (depth = 5)
// compiled member node returning call703 (depth = 4)
  params[0] = call700;
  params[1] = bool701;
  partcv[0] = 2;
  Object call704 = callmethod(call703, "new",
    1, partcv, params);
  gc_frame_end(callframe698);
// compiled call node returning call704 (depth = 3)
  *var_o = call704;
  if (call704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit707 == NULL) {
    strlit707 = alloc_String("_");
    gc_root(strlit707);
  }
// compiled string node returning strlit707 (depth = 4)
  int op_slot_right_706 = gc_frame_newslot(strlit707);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call710 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe709);
// compiled call node returning call710 (depth = 5)
// compiled member node returning call710 (depth = 4)
  int op_slot_left_706 = gc_frame_newslot(call710);
  params[0] = strlit707;
  partcv[0] = 1;
  Object opresult711 = callmethod(call710, "==", 1, partcv, params);
// compiled op node returning opresult711 (depth = 3)
  Object if705 = done;
  if (istrue(opresult711)) {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe712 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_right_713 = gc_frame_newslot(*var_auto_count);
// starting to compile string node (depth = 5)
  if (strlit715 == NULL) {
    strlit715 = alloc_String("__");
    gc_root(strlit715);
  }
// compiled string node returning strlit715 (depth = 5)
  int op_slot_left_713 = gc_frame_newslot(strlit715);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult716 = callmethod(strlit715, "++", 1, partcv, params);
// compiled op node returning opresult716 (depth = 4)
  gc_frame_newslot(opresult716);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = opresult716;
  partcv[0] = 1;
  Object call717 = callmethod(*var_o, "value:=",
    1, partcv, params);
  gc_frame_end(callframe712);
// compiled call node returning call717 (depth = 3)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe718 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool719 = alloc_Boolean(1);
// compiled identifier node returning bool719 (depth = 4)
  gc_frame_newslot(bool719);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool719;
  partcv[0] = 1;
  Object call720 = callmethod(*var_o, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe718);
// compiled call node returning call720 (depth = 3)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num722 = alloc_Float64(1);
// compiled num node returning num722 (depth = 5)
  int op_slot_right_721 = gc_frame_newslot(num722);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_721 = gc_frame_newslot(*var_auto_count);
  params[0] = num722;
  partcv[0] = 1;
  Object sum724 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum724 (depth = 4)
  *var_auto_count = sum724;
  if (sum724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if705 = done;
  } else {
  }
// compiled if node returning if705 (depth = 2)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe726 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call727 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe726);
// compiled call node returning call727 (depth = 2)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call729 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe728);
// compiled call node returning call729 (depth = 3)
// compiled member node returning call729 (depth = 2)
  gc_frame_end(frame);
  return call729;
}
Object meth_parser__apply751(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call754 = callmethod(*var_a, "dtype",
    1, partcv, params);
  gc_frame_end(callframe753);
// compiled call node returning call754 (depth = 12)
// compiled member node returning call754 (depth = 11)
  int op_slot_right_752 = gc_frame_newslot(call754);
// starting to compile identifier node (depth = 11)
  Object bool756 = alloc_Boolean(0);
// compiled identifier node returning bool756 (depth = 11)
  int op_slot_left_752 = gc_frame_newslot(bool756);
  params[0] = call754;
  partcv[0] = 1;
  Object opresult757 = callmethod(bool756, "≠", 1, partcv, params);
// compiled op node returning opresult757 (depth = 10)
  gc_frame_end(frame);
  return opresult757;
}
Object meth_parser__apply769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit771 == NULL) {
    strlit771 = alloc_String(":");
    gc_root(strlit771);
  }
// compiled string node returning strlit771 (depth = 11)
  int op_slot_right_770 = gc_frame_newslot(strlit771);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe773 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call774 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe773);
// compiled call node returning call774 (depth = 12)
// compiled member node returning call774 (depth = 11)
  int op_slot_left_770 = gc_frame_newslot(call774);
  params[0] = strlit771;
  partcv[0] = 1;
  Object opresult775 = callmethod(call774, "≠", 1, partcv, params);
// compiled op node returning opresult775 (depth = 10)
  gc_frame_end(frame);
  return opresult775;
}
Object meth_parser__apply778(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call780 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe779);
// compiled call node returning call780 (depth = 12)
// compiled member node returning call780 (depth = 11)
  *var_tok = call780;
  if (call780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply747(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block750 = alloc_Block(NULL, NULL, "parser", 282);
  gc_frame_newslot(block750);
// method "_apply"
  block_savedest(block750);
  Object closure751 = createclosure(2, "_apply");
  setclosureframe(closure751, stackframe);
  addtoclosure(closure751, var_a);
  addtoclosure(closure751, selfslot);
  struct UserObject *uo751 = (struct UserObject*)block750;
  uo751->data[0] = (Object)closure751;
  Method *meth_meth_parser__apply751 = addmethod2pos(block750, "_apply", &meth_parser__apply751, 0);
  int argcv_meth_parser__apply751[] = {0};
  meth_meth_parser__apply751->type = alloc_MethodType(1, argcv_meth_parser__apply751);
  meth_meth_parser__apply751->definitionModule = modulename;
  meth_meth_parser__apply751->definitionLine = 281;
// compiled block node returning block750 (depth = 9)
  int op_slot_right_749 = gc_frame_newslot(block750);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit761 == NULL) {
    strlit761 = alloc_String("identifier");
    gc_root(strlit761);
  }
// compiled string node returning strlit761 (depth = 10)
  int op_slot_right_760 = gc_frame_newslot(strlit761);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call764 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe763);
// compiled call node returning call764 (depth = 11)
// compiled member node returning call764 (depth = 10)
  int op_slot_left_760 = gc_frame_newslot(call764);
  params[0] = strlit761;
  partcv[0] = 1;
  Object opresult765 = callmethod(call764, "==", 1, partcv, params);
// compiled op node returning opresult765 (depth = 9)
  int op_slot_left_749 = gc_frame_newslot(opresult765);
  params[0] = block750;
  partcv[0] = 1;
  Object opresult766 = callmethod(opresult765, "&&", 1, partcv, params);
// compiled op node returning opresult766 (depth = 8)
  Object if748 = done;
  if (istrue(opresult766)) {
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe767 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block768 = alloc_Block(NULL, NULL, "parser", 285);
  gc_frame_newslot(block768);
// method "_apply"
  block_savedest(block768);
  Object closure769 = createclosure(2, "_apply");
  setclosureframe(closure769, stackframe);
  addtoclosure(closure769, var_tok);
  addtoclosure(closure769, selfslot);
  struct UserObject *uo769 = (struct UserObject*)block768;
  uo769->data[0] = (Object)closure769;
  Method *meth_meth_parser__apply769 = addmethod2pos(block768, "_apply", &meth_parser__apply769, 0);
  int argcv_meth_parser__apply769[] = {0};
  meth_meth_parser__apply769->type = alloc_MethodType(1, argcv_meth_parser__apply769);
  meth_meth_parser__apply769->definitionModule = modulename;
  meth_meth_parser__apply769->definitionLine = 282;
// compiled block node returning block768 (depth = 9)
  gc_frame_newslot(block768);
// starting to compile block node (depth = 9)
  Object block777 = alloc_Block(NULL, NULL, "parser", 285);
  gc_frame_newslot(block777);
// method "_apply"
  block_savedest(block777);
  Object closure778 = createclosure(2, "_apply");
  setclosureframe(closure778, stackframe);
  addtoclosure(closure778, var_tok);
  addtoclosure(closure778, selfslot);
  struct UserObject *uo778 = (struct UserObject*)block777;
  uo778->data[0] = (Object)closure778;
  Method *meth_meth_parser__apply778 = addmethod2pos(block777, "_apply", &meth_parser__apply778, 0);
  int argcv_meth_parser__apply778[] = {0};
  meth_meth_parser__apply778->type = alloc_MethodType(1, argcv_meth_parser__apply778);
  meth_meth_parser__apply778->definitionModule = modulename;
  meth_meth_parser__apply778->definitionLine = 285;
// compiled block node returning block777 (depth = 9)
  gc_frame_newslot(block777);
// call case 5: prelude request
  params[0] = block768;
  params[1] = block777;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call783 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe767);
// compiled call node returning call783 (depth = 8)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe784 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call786 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe785);
// compiled call node returning call786 (depth = 12)
// compiled member node returning call786 (depth = 11)
  partcv[0] = 0;
  Object call787 = callmethod(call786, "new",
    1, partcv, params);
  gc_frame_end(callframe784);
// compiled call node returning call787 (depth = 10)
// compiled member node returning call787 (depth = 9)
  *var_suggestion = call787;
  if (call787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe788 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call790 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe789);
// compiled call node returning call790 (depth = 10)
// compiled member node returning call790 (depth = 9)
  gc_frame_newslot(call790);
// starting to compile identifier node (depth = 9)
  Object bool791 = alloc_Boolean(1);
// compiled identifier node returning bool791 (depth = 9)
  gc_frame_newslot(bool791);
// starting to compile identifier node (depth = 9)
  Object bool792 = alloc_Boolean(0);
// compiled identifier node returning bool792 (depth = 9)
  gc_frame_newslot(bool792);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call790;
  params[2] = bool791;
  params[3] = bool792;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call793 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe788);
// compiled call node returning call793 (depth = 8)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe794 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit795 == NULL) {
    strlit795 = alloc_String("an argument to an annotation cannot have a type.");
    gc_root(strlit795);
  }
// compiled string node returning strlit795 (depth = 9)
  gc_frame_newslot(strlit795);
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call797 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe796);
// compiled call node returning call797 (depth = 10)
// compiled member node returning call797 (depth = 9)
  gc_frame_newslot(call797);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call799 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe798);
// compiled call node returning call799 (depth = 10)
// compiled member node returning call799 (depth = 9)
  gc_frame_newslot(call799);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num801 = alloc_Float64(1);
// compiled num node returning num801 (depth = 10)
  int op_slot_right_800 = gc_frame_newslot(num801);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe804 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe805 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call806 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe805);
// compiled call node returning call806 (depth = 14)
// compiled member node returning call806 (depth = 13)
  partcv[0] = 0;
  Object call807 = callmethod(call806, "size",
    1, partcv, params);
  gc_frame_end(callframe804);
// compiled call node returning call807 (depth = 12)
// compiled member node returning call807 (depth = 11)
  int op_slot_right_803 = gc_frame_newslot(call807);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe809 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call811 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe810);
// compiled call node returning call811 (depth = 14)
// compiled member node returning call811 (depth = 13)
  partcv[0] = 0;
  Object call812 = callmethod(call811, "linePos",
    1, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call812 (depth = 12)
// compiled member node returning call812 (depth = 11)
  int op_slot_left_803 = gc_frame_newslot(call812);
  params[0] = call807;
  partcv[0] = 1;
  Object sum813 = callmethod(call812, "+", 1, partcv, params);
// compiled op node returning sum813 (depth = 10)
  int op_slot_left_800 = gc_frame_newslot(sum813);
  params[0] = num801;
  partcv[0] = 1;
  Object diff814 = callmethod(sum813, "-", 1, partcv, params);
// compiled op node returning diff814 (depth = 9)
  gc_frame_newslot(diff814);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit795;
  params[1] = call797;
  params[2] = call799;
  params[3] = diff814;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call815 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe794);
// compiled call node returning call815 (depth = 8)
    gc_frame_newslot(call815);
    if748 = call815;
  } else {
  }
// compiled if node returning if748 (depth = 7)
  gc_frame_end(frame);
  return if748;
}
Object meth_parser__apply742(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe743 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  partcv[0] = 0;
  Object call745 = callmethod(*var_p, "args",
    1, partcv, params);
  gc_frame_end(callframe744);
// compiled call node returning call745 (depth = 7)
// compiled member node returning call745 (depth = 6)
  gc_frame_newslot(call745);
// starting to compile block node (depth = 6)
  Object block746 = alloc_Block(NULL, NULL, "parser", 281);
  gc_frame_newslot(block746);
// method "_apply"
  block_savedest(block746);
  Object closure747 = createclosure(3, "_apply");
  setclosureframe(closure747, stackframe);
  addtoclosure(closure747, var_sym);
  addtoclosure(closure747, var_errormessages);
  addtoclosure(closure747, selfslot);
  struct UserObject *uo747 = (struct UserObject*)block746;
  uo747->data[0] = (Object)closure747;
  Method *meth_meth_parser__apply747 = addmethod2pos(block746, "_apply", &meth_parser__apply747, 0);
  int argcv_meth_parser__apply747[] = {1};
  meth_meth_parser__apply747->type = alloc_MethodType(1, argcv_meth_parser__apply747);
  meth_meth_parser__apply747->definitionModule = modulename;
  meth_meth_parser__apply747->definitionLine = 281;
// compiled block node returning block746 (depth = 6)
  gc_frame_newslot(block746);
// call case 5: prelude request
  params[0] = call745;
  params[1] = block746;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call817 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe743);
// compiled call node returning call817 (depth = 5)
  gc_frame_end(frame);
  return call817;
}
Object meth_parser_checkAnnotation730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method checkAnnotation");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for checkAnnotation");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit733 == NULL) {
    strlit733 = alloc_String("call");
    gc_root(strlit733);
  }
// compiled string node returning strlit733 (depth = 4)
  int op_slot_right_732 = gc_frame_newslot(strlit733);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe735 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call736 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 5)
// compiled member node returning call736 (depth = 4)
  int op_slot_left_732 = gc_frame_newslot(call736);
  params[0] = strlit733;
  partcv[0] = 1;
  Object opresult737 = callmethod(call736, "==", 1, partcv, params);
// compiled op node returning opresult737 (depth = 3)
  Object if731 = done;
  if (istrue(opresult737)) {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe738 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call740 = callmethod(*var_ann, "with",
    1, partcv, params);
  gc_frame_end(callframe739);
// compiled call node returning call740 (depth = 5)
// compiled member node returning call740 (depth = 4)
  gc_frame_newslot(call740);
// starting to compile block node (depth = 4)
  Object block741 = alloc_Block(NULL, NULL, "parser", 280);
  gc_frame_newslot(block741);
// method "_apply"
  block_savedest(block741);
  Object closure742 = createclosure(3, "_apply");
  setclosureframe(closure742, stackframe);
  addtoclosure(closure742, var_sym);
  addtoclosure(closure742, var_errormessages);
  addtoclosure(closure742, selfslot);
  struct UserObject *uo742 = (struct UserObject*)block741;
  uo742->data[0] = (Object)closure742;
  Method *meth_meth_parser__apply742 = addmethod2pos(block741, "_apply", &meth_parser__apply742, 0);
  int argcv_meth_parser__apply742[] = {1};
  meth_meth_parser__apply742->type = alloc_MethodType(1, argcv_meth_parser__apply742);
  meth_meth_parser__apply742->definitionModule = modulename;
  meth_meth_parser__apply742->definitionLine = 280;
// compiled block node returning block741 (depth = 4)
  gc_frame_newslot(block741);
// call case 5: prelude request
  params[0] = call740;
  params[1] = block741;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call819 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call819 (depth = 3)
    gc_frame_newslot(call819);
    if731 = call819;
  } else {
  }
// compiled if node returning if731 (depth = 2)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply835(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe836 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call837 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe836);
// compiled call node returning call837 (depth = 7)
  gc_frame_end(frame);
  return call837;
}
Object meth_parser__apply897(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe898 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit899 == NULL) {
    strlit899 = alloc_String("comma");
    gc_root(strlit899);
  }
// compiled string node returning strlit899 (depth = 5)
  gc_frame_newslot(strlit899);
// call case 4: self request
  params[0] = strlit899;
  partcv[0] = 1;
  Object call900 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe898);
// compiled call node returning call900 (depth = 4)
  gc_frame_end(frame);
  return call900;
}
Object meth_parser__apply916(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe917 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_noBlocks (depth = 10)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call918 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe917);
// compiled call node returning call918 (depth = 9)
  gc_frame_end(frame);
  return call918;
}
Object meth_parser__apply903(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe904 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe905 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe906 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call907 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe906);
// compiled call node returning call907 (depth = 7)
// compiled member node returning call907 (depth = 6)
  gc_frame_newslot(call907);
// call case 4: self request
  params[0] = call907;
  partcv[0] = 1;
  Object call908 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled call node returning call908 (depth = 5)
  gc_frame_newslot(call908);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call908;
  partcv[0] = 1;
  Object call909 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe904);
// compiled call node returning call909 (depth = 4)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call911 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe910);
// compiled call node returning call911 (depth = 5)
// compiled member node returning call911 (depth = 4)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe913 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe914 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block915 = alloc_Block(NULL, NULL, "parser", 322);
  gc_frame_newslot(block915);
// method "_apply"
  block_savedest(block915);
  Object closure916 = createclosure(2, "_apply");
  setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_noBlocks);
  addtoclosure(closure916, selfslot);
  struct UserObject *uo916 = (struct UserObject*)block915;
  uo916->data[0] = (Object)closure916;
  Method *meth_meth_parser__apply916 = addmethod2pos(block915, "_apply", &meth_parser__apply916, 0);
  int argcv_meth_parser__apply916[] = {0};
  meth_meth_parser__apply916->type = alloc_MethodType(1, argcv_meth_parser__apply916);
  meth_meth_parser__apply916->definitionModule = modulename;
  meth_meth_parser__apply916->definitionLine = 322;
// compiled block node returning block915 (depth = 8)
  gc_frame_newslot(block915);
// call case 4: self request
  params[0] = block915;
  partcv[0] = 1;
  Object call920 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe914);
// compiled call node returning call920 (depth = 7)
  partcv[0] = 0;
  Object call921 = callmethod(call920, "not",
    1, partcv, params);
  gc_frame_end(callframe913);
// compiled call node returning call921 (depth = 6)
// compiled member node returning call921 (depth = 5)
  Object if912 = done;
  if (istrue(call921)) {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array922 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array922 (depth = 6)
  *var_suggestions = array922;
  if (array922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe923 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call925 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call925 (depth = 9)
// compiled member node returning call925 (depth = 8)
  partcv[0] = 0;
  Object call926 = callmethod(call925, "new",
    1, partcv, params);
  gc_frame_end(callframe923);
// compiled call node returning call926 (depth = 7)
// compiled member node returning call926 (depth = 6)
  *var_suggestion = call926;
  if (call926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe927 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array928 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit929 == NULL) {
    strlit929 = alloc_String("bind");
    gc_root(strlit929);
  }
// compiled string node returning strlit929 (depth = 8)
  params[0] = strlit929;
  partcv[0] = 1;
  callmethodflags(array928, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array928 (depth = 7)
  gc_frame_newslot(array928);
// call case 4: self request
  params[0] = array928;
  partcv[0] = 1;
  Object call930 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe927);
// compiled call node returning call930 (depth = 6)
  *var_nextTok = call930;
  if (call930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_932 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_932 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult934 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult934 (depth = 6)
  Object if931 = done;
  if (istrue(opresult934)) {
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe935 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit936 == NULL) {
    strlit936 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit936);
  }
// compiled string node returning strlit936 (depth = 7)
  gc_frame_newslot(strlit936);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit936;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call937 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe935);
// compiled call node returning call937 (depth = 6)
    gc_frame_newslot(call937);
    if931 = call937;
  } else {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe938 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call940 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe939);
// compiled call node returning call940 (depth = 8)
// compiled member node returning call940 (depth = 7)
  gc_frame_newslot(call940);
// starting to compile identifier node (depth = 7)
  Object bool941 = alloc_Boolean(1);
// compiled identifier node returning bool941 (depth = 7)
  gc_frame_newslot(bool941);
// starting to compile identifier node (depth = 7)
  Object bool942 = alloc_Boolean(0);
// compiled identifier node returning bool942 (depth = 7)
  gc_frame_newslot(bool942);
// starting to compile string node (depth = 7)
  if (strlit943 == NULL) {
    strlit943 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit943);
  }
// compiled string node returning strlit943 (depth = 7)
  gc_frame_newslot(strlit943);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call940;
  params[2] = bool941;
  params[3] = bool942;
  params[4] = strlit943;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call944 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe938);
// compiled call node returning call944 (depth = 6)
    gc_frame_newslot(call944);
    if931 = call944;
  }
// compiled if node returning if931 (depth = 5)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe945 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call946 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call946 (depth = 5)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe947 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe948 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call949 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe948);
// compiled call node returning call949 (depth = 9)
// compiled member node returning call949 (depth = 8)
  partcv[0] = 0;
  Object call950 = callmethod(call949, "new",
    1, partcv, params);
  gc_frame_end(callframe947);
// compiled call node returning call950 (depth = 7)
// compiled member node returning call950 (depth = 6)
  *var_suggestion = call950;
  if (call950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe952 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call954 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe953);
// compiled call node returning call954 (depth = 7)
// compiled member node returning call954 (depth = 6)
  gc_frame_newslot(call954);
// starting to compile identifier node (depth = 6)
  Object bool955 = alloc_Boolean(1);
// compiled identifier node returning bool955 (depth = 6)
  gc_frame_newslot(bool955);
// starting to compile identifier node (depth = 6)
  Object bool956 = alloc_Boolean(0);
// compiled identifier node returning bool956 (depth = 6)
  gc_frame_newslot(bool956);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call954;
  params[2] = bool955;
  params[3] = bool956;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call957 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe952);
// compiled call node returning call957 (depth = 5)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe958 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call959 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe958);
// compiled call node returning call959 (depth = 5)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe960 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit961 == NULL) {
    strlit961 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit961);
  }
// compiled string node returning strlit961 (depth = 6)
  gc_frame_newslot(strlit961);
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call963 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe962);
// compiled call node returning call963 (depth = 7)
// compiled member node returning call963 (depth = 6)
  gc_frame_newslot(call963);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num965 = alloc_Float64(1);
// compiled num node returning num965 (depth = 7)
  int op_slot_right_964 = gc_frame_newslot(num965);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call969 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe968);
// compiled call node returning call969 (depth = 9)
// compiled member node returning call969 (depth = 8)
  int op_slot_right_967 = gc_frame_newslot(call969);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call972 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe971);
// compiled call node returning call972 (depth = 9)
// compiled member node returning call972 (depth = 8)
  int op_slot_left_967 = gc_frame_newslot(call972);
  params[0] = call969;
  partcv[0] = 1;
  Object sum973 = callmethod(call972, "+", 1, partcv, params);
// compiled op node returning sum973 (depth = 7)
  int op_slot_left_964 = gc_frame_newslot(sum973);
  params[0] = num965;
  partcv[0] = 1;
  Object sum974 = callmethod(sum973, "+", 1, partcv, params);
// compiled op node returning sum974 (depth = 6)
  gc_frame_newslot(sum974);
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit961;
  params[1] = call963;
  params[2] = sum974;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call975 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe960);
// compiled call node returning call975 (depth = 5)
    gc_frame_newslot(call975);
    if912 = call975;
  } else {
  }
// compiled if node returning if912 (depth = 4)
  gc_frame_end(frame);
  return if912;
}
Object meth_parser_doannotation820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doannotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doannotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe822 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe823 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit824 == NULL) {
    strlit824 = alloc_String("is");
    gc_root(strlit824);
  }
// compiled string node returning strlit824 (depth = 6)
  gc_frame_newslot(strlit824);
// call case 4: self request
  params[0] = strlit824;
  partcv[0] = 1;
  Object call825 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe823);
// compiled call node returning call825 (depth = 5)
  partcv[0] = 0;
  Object call826 = callmethod(call825, "not",
    1, partcv, params);
  gc_frame_end(callframe822);
// compiled call node returning call826 (depth = 4)
// compiled member node returning call826 (depth = 3)
  Object if821 = done;
  if (istrue(call826)) {
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool827 = alloc_Boolean(0);
// compiled identifier node returning bool827 (depth = 4)
  return bool827;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if821 = undefined;
  } else {
  }
// compiled if node returning if821 (depth = 2)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call829 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe828);
// compiled call node returning call829 (depth = 3)
// compiled member node returning call829 (depth = 2)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array830 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array830 (depth = 3)
  *var_anns = array830;
  if (array830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe832 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe833 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block834 = alloc_Block(NULL, NULL, "parser", 302);
  gc_frame_newslot(block834);
// method "_apply"
  block_savedest(block834);
  Object closure835 = createclosure(2, "_apply");
  setclosureframe(closure835, stackframe);
  addtoclosure(closure835, var_noBlocks);
  addtoclosure(closure835, selfslot);
  struct UserObject *uo835 = (struct UserObject*)block834;
  uo835->data[0] = (Object)closure835;
  Method *meth_meth_parser__apply835 = addmethod2pos(block834, "_apply", &meth_parser__apply835, 0);
  int argcv_meth_parser__apply835[] = {0};
  meth_meth_parser__apply835->type = alloc_MethodType(1, argcv_meth_parser__apply835);
  meth_meth_parser__apply835->definitionModule = modulename;
  meth_meth_parser__apply835->definitionLine = 302;
// compiled block node returning block834 (depth = 6)
  gc_frame_newslot(block834);
// call case 4: self request
  params[0] = block834;
  partcv[0] = 1;
  Object call839 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe833);
// compiled call node returning call839 (depth = 5)
  partcv[0] = 0;
  Object call840 = callmethod(call839, "not",
    1, partcv, params);
  gc_frame_end(callframe832);
// compiled call node returning call840 (depth = 4)
// compiled member node returning call840 (depth = 3)
  Object if831 = done;
  if (istrue(call840)) {
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array841 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array841 (depth = 4)
  *var_suggestions = array841;
  if (array841 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe842 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe843 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call844 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe843);
// compiled call node returning call844 (depth = 7)
// compiled member node returning call844 (depth = 6)
  partcv[0] = 0;
  Object call845 = callmethod(call844, "new",
    1, partcv, params);
  gc_frame_end(callframe842);
// compiled call node returning call845 (depth = 5)
// compiled member node returning call845 (depth = 4)
  *var_suggestion = call845;
  if (call845 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe846 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array847 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit848 == NULL) {
    strlit848 = alloc_String("bind");
    gc_root(strlit848);
  }
// compiled string node returning strlit848 (depth = 6)
  params[0] = strlit848;
  partcv[0] = 1;
  callmethodflags(array847, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array847 (depth = 5)
  gc_frame_newslot(array847);
// call case 4: self request
  params[0] = array847;
  partcv[0] = 1;
  Object call849 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe846);
// compiled call node returning call849 (depth = 4)
  *var_nextTok = call849;
  if (call849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_851 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_851 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult853 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult853 (depth = 4)
  Object if850 = done;
  if (istrue(opresult853)) {
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe854 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit855 == NULL) {
    strlit855 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit855);
  }
// compiled string node returning strlit855 (depth = 5)
  gc_frame_newslot(strlit855);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit855;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call856 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe854);
// compiled call node returning call856 (depth = 4)
    gc_frame_newslot(call856);
    if850 = call856;
  } else {
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe857 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe858 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call859 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe858);
// compiled call node returning call859 (depth = 6)
// compiled member node returning call859 (depth = 5)
  gc_frame_newslot(call859);
// starting to compile identifier node (depth = 5)
  Object bool860 = alloc_Boolean(1);
// compiled identifier node returning bool860 (depth = 5)
  gc_frame_newslot(bool860);
// starting to compile identifier node (depth = 5)
  Object bool861 = alloc_Boolean(0);
// compiled identifier node returning bool861 (depth = 5)
  gc_frame_newslot(bool861);
// starting to compile string node (depth = 5)
  if (strlit862 == NULL) {
    strlit862 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit862);
  }
// compiled string node returning strlit862 (depth = 5)
  gc_frame_newslot(strlit862);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call859;
  params[2] = bool860;
  params[3] = bool861;
  params[4] = strlit862;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call863 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe857);
// compiled call node returning call863 (depth = 4)
    gc_frame_newslot(call863);
    if850 = call863;
  }
// compiled if node returning if850 (depth = 3)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe864 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call865 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe864);
// compiled call node returning call865 (depth = 3)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe866 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe867 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call868 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe867);
// compiled call node returning call868 (depth = 7)
// compiled member node returning call868 (depth = 6)
  partcv[0] = 0;
  Object call869 = callmethod(call868, "new",
    1, partcv, params);
  gc_frame_end(callframe866);
// compiled call node returning call869 (depth = 5)
// compiled member node returning call869 (depth = 4)
  *var_suggestion = call869;
  if (call869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe871 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe872 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call873 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe872);
// compiled call node returning call873 (depth = 5)
// compiled member node returning call873 (depth = 4)
  gc_frame_newslot(call873);
// starting to compile identifier node (depth = 4)
  Object bool874 = alloc_Boolean(1);
// compiled identifier node returning bool874 (depth = 4)
  gc_frame_newslot(bool874);
// starting to compile identifier node (depth = 4)
  Object bool875 = alloc_Boolean(0);
// compiled identifier node returning bool875 (depth = 4)
  gc_frame_newslot(bool875);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_lastToken;
  params[1] = call873;
  params[2] = bool874;
  params[3] = bool875;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call876 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe871);
// compiled call node returning call876 (depth = 3)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe877 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call878 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe877);
// compiled call node returning call878 (depth = 3)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe879 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit880 == NULL) {
    strlit880 = alloc_String("one or more annotations separated by commas must follow 'is'.");
    gc_root(strlit880);
  }
// compiled string node returning strlit880 (depth = 4)
  gc_frame_newslot(strlit880);
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call882 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call882 (depth = 5)
// compiled member node returning call882 (depth = 4)
  gc_frame_newslot(call882);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num884 = alloc_Float64(1);
// compiled num node returning num884 (depth = 5)
  int op_slot_right_883 = gc_frame_newslot(num884);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call888 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe887);
// compiled call node returning call888 (depth = 7)
// compiled member node returning call888 (depth = 6)
  int op_slot_right_886 = gc_frame_newslot(call888);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call891 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe890);
// compiled call node returning call891 (depth = 7)
// compiled member node returning call891 (depth = 6)
  int op_slot_left_886 = gc_frame_newslot(call891);
  params[0] = call888;
  partcv[0] = 1;
  Object sum892 = callmethod(call891, "+", 1, partcv, params);
// compiled op node returning sum892 (depth = 5)
  int op_slot_left_883 = gc_frame_newslot(sum892);
  params[0] = num884;
  partcv[0] = 1;
  Object sum893 = callmethod(sum892, "+", 1, partcv, params);
// compiled op node returning sum893 (depth = 4)
  gc_frame_newslot(sum893);
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit880;
  params[1] = call882;
  params[2] = sum893;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call894 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe879);
// compiled call node returning call894 (depth = 3)
    gc_frame_newslot(call894);
    if831 = call894;
  } else {
  }
// compiled if node returning if831 (depth = 2)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe895 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block896 = alloc_Block(NULL, NULL, "parser", 319);
  gc_frame_newslot(block896);
// method "_apply"
  block_savedest(block896);
  Object closure897 = createclosure(1, "_apply");
  setclosureframe(closure897, stackframe);
  addtoclosure(closure897, selfslot);
  struct UserObject *uo897 = (struct UserObject*)block896;
  uo897->data[0] = (Object)closure897;
  Method *meth_meth_parser__apply897 = addmethod2pos(block896, "_apply", &meth_parser__apply897, 0);
  int argcv_meth_parser__apply897[] = {0};
  meth_meth_parser__apply897->type = alloc_MethodType(1, argcv_meth_parser__apply897);
  meth_meth_parser__apply897->definitionModule = modulename;
  meth_meth_parser__apply897->definitionLine = 316;
// compiled block node returning block896 (depth = 3)
  gc_frame_newslot(block896);
// starting to compile block node (depth = 3)
  Object block902 = alloc_Block(NULL, NULL, "parser", 319);
  gc_frame_newslot(block902);
// method "_apply"
  block_savedest(block902);
  Object closure903 = createclosure(7, "_apply");
  setclosureframe(closure903, stackframe);
  addtoclosure(closure903, var_values);
  addtoclosure(closure903, var_anns);
  addtoclosure(closure903, var_noBlocks);
  addtoclosure(closure903, var_errormessages);
  addtoclosure(closure903, var_sym);
  addtoclosure(closure903, var_lastToken);
  addtoclosure(closure903, selfslot);
  struct UserObject *uo903 = (struct UserObject*)block902;
  uo903->data[0] = (Object)closure903;
  Method *meth_meth_parser__apply903 = addmethod2pos(block902, "_apply", &meth_parser__apply903, 0);
  int argcv_meth_parser__apply903[] = {0};
  meth_meth_parser__apply903->type = alloc_MethodType(1, argcv_meth_parser__apply903);
  meth_meth_parser__apply903->definitionModule = modulename;
  meth_meth_parser__apply903->definitionLine = 316;
// compiled block node returning block902 (depth = 3)
  gc_frame_newslot(block902);
// call case 5: prelude request
  params[0] = block896;
  params[1] = block902;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call977 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe895);
// compiled call node returning call977 (depth = 2)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe978 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe979 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe980 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call981 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe980);
// compiled call node returning call981 (depth = 5)
// compiled member node returning call981 (depth = 4)
  gc_frame_newslot(call981);
// call case 4: self request
  params[0] = call981;
  partcv[0] = 1;
  Object call982 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe979);
// compiled call node returning call982 (depth = 3)
  gc_frame_newslot(call982);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call982;
  partcv[0] = 1;
  Object call983 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe978);
// compiled call node returning call983 (depth = 2)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser__apply1020(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1022 == NULL) {
    strlit1022 = alloc_String("blank");
    gc_root(strlit1022);
  }
// compiled string node returning strlit1022 (depth = 7)
  int op_slot_right_1021 = gc_frame_newslot(strlit1022);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1024 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1026 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1025);
// compiled call node returning call1026 (depth = 10)
// compiled member node returning call1026 (depth = 9)
  partcv[0] = 0;
  Object call1027 = callmethod(call1026, "kind",
    1, partcv, params);
  gc_frame_end(callframe1024);
// compiled call node returning call1027 (depth = 8)
// compiled member node returning call1027 (depth = 7)
  int op_slot_left_1021 = gc_frame_newslot(call1027);
  params[0] = strlit1022;
  partcv[0] = 1;
  Object opresult1028 = callmethod(call1027, "≠", 1, partcv, params);
// compiled op node returning opresult1028 (depth = 6)
  gc_frame_end(frame);
  return opresult1028;
}
Object meth_parser_blank984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_done = getfromclosure(closure, 3);
  Object *var_previousCommentToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num987 = alloc_Float64(0);
// compiled num node returning num987 (depth = 4)
  int op_slot_right_986 = gc_frame_newslot(num987);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blankLocation (depth = 4)
  int op_slot_left_986 = gc_frame_newslot(*var_blankLocation);
  params[0] = num987;
  partcv[0] = 1;
  Object opresult989 = callmethod(*var_blankLocation, "==", 1, partcv, params);
// compiled op node returning opresult989 (depth = 3)
  Object if985 = done;
  if (istrue(opresult989)) {
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num993 = alloc_Float64(1);
// compiled num node returning num993 (depth = 6)
  int op_slot_right_992 = gc_frame_newslot(num993);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call996 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe995);
// compiled call node returning call996 (depth = 7)
// compiled member node returning call996 (depth = 6)
  int op_slot_left_992 = gc_frame_newslot(call996);
  params[0] = num993;
  partcv[0] = 1;
  Object sum997 = callmethod(call996, "+", 1, partcv, params);
// compiled op node returning sum997 (depth = 5)
  int op_slot_right_991 = gc_frame_newslot(sum997);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1000 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe999);
// compiled call node returning call1000 (depth = 6)
// compiled member node returning call1000 (depth = 5)
  int op_slot_left_991 = gc_frame_newslot(call1000);
  params[0] = sum997;
  partcv[0] = 1;
  Object opresult1001 = callmethod(call1000, "≤", 1, partcv, params);
// compiled op node returning opresult1001 (depth = 4)
  Object if990 = done;
  if (istrue(opresult1001)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if990 = undefined;
  } else {
  }
// compiled if node returning if990 (depth = 3)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1005 = alloc_Float64(1);
// compiled num node returning num1005 (depth = 6)
  int op_slot_right_1004 = gc_frame_newslot(num1005);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_previousCommentToken (depth = 8)
  partcv[0] = 0;
  Object call1008 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1007);
// compiled call node returning call1008 (depth = 7)
// compiled member node returning call1008 (depth = 6)
  int op_slot_left_1004 = gc_frame_newslot(call1008);
  params[0] = num1005;
  partcv[0] = 1;
  Object sum1009 = callmethod(call1008, "+", 1, partcv, params);
// compiled op node returning sum1009 (depth = 5)
  int op_slot_right_1003 = gc_frame_newslot(sum1009);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1012 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1011);
// compiled call node returning call1012 (depth = 6)
// compiled member node returning call1012 (depth = 5)
  int op_slot_left_1003 = gc_frame_newslot(call1012);
  params[0] = sum1009;
  partcv[0] = 1;
  Object opresult1013 = callmethod(call1012, "≤", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 4)
  Object if1002 = done;
  if (istrue(opresult1013)) {
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1002 = undefined;
  } else {
  }
// compiled if node returning if1002 (depth = 3)
    gc_frame_newslot(if1002);
    if985 = if1002;
  } else {
  }
// compiled if node returning if985 (depth = 2)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1014 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1015 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1014);
// compiled call node returning call1015 (depth = 3)
// compiled member node returning call1015 (depth = 2)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block1019 = alloc_Block(NULL, NULL, "parser", 351);
  gc_frame_newslot(block1019);
// method "_apply"
  block_savedest(block1019);
  Object closure1020 = createclosure(2, "_apply");
  setclosureframe(closure1020, stackframe);
  addtoclosure(closure1020, var_values);
  addtoclosure(closure1020, selfslot);
  struct UserObject *uo1020 = (struct UserObject*)block1019;
  uo1020->data[0] = (Object)closure1020;
  Method *meth_meth_parser__apply1020 = addmethod2pos(block1019, "_apply", &meth_parser__apply1020, 0);
  int argcv_meth_parser__apply1020[] = {0};
  meth_meth_parser__apply1020->type = alloc_MethodType(1, argcv_meth_parser__apply1020);
  meth_meth_parser__apply1020->definitionModule = modulename;
  meth_meth_parser__apply1020->definitionLine = 349;
// compiled block node returning block1019 (depth = 5)
  int op_slot_right_1018 = gc_frame_newslot(block1019);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1032 = alloc_Float64(0);
// compiled num node returning num1032 (depth = 6)
  int op_slot_right_1031 = gc_frame_newslot(num1032);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1034 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1035 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 7)
// compiled member node returning call1035 (depth = 6)
  int op_slot_left_1031 = gc_frame_newslot(call1035);
  params[0] = num1032;
  partcv[0] = 1;
  Object opresult1036 = callmethod(call1035, ">", 1, partcv, params);
// compiled op node returning opresult1036 (depth = 5)
  int op_slot_left_1018 = gc_frame_newslot(opresult1036);
  params[0] = block1019;
  partcv[0] = 1;
  Object opresult1037 = callmethod(opresult1036, "&&", 1, partcv, params);
// compiled op node returning opresult1037 (depth = 4)
  int op_slot_right_1017 = gc_frame_newslot(opresult1037);
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1040 = alloc_Float64(0);
// compiled num node returning num1040 (depth = 5)
  int op_slot_right_1039 = gc_frame_newslot(num1040);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call1043 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1042);
// compiled call node returning call1043 (depth = 6)
// compiled member node returning call1043 (depth = 5)
  int op_slot_left_1039 = gc_frame_newslot(call1043);
  params[0] = num1040;
  partcv[0] = 1;
  Object opresult1044 = callmethod(call1043, "==", 1, partcv, params);
// compiled op node returning opresult1044 (depth = 4)
  int op_slot_left_1017 = gc_frame_newslot(opresult1044);
  params[0] = opresult1037;
  partcv[0] = 1;
  Object opresult1045 = callmethod(opresult1044, "||", 1, partcv, params);
// compiled op node returning opresult1045 (depth = 3)
  Object if1016 = done;
  if (istrue(opresult1045)) {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1048 = alloc_Float64(0);
// compiled num node returning num1048 (depth = 5)
  int op_slot_right_1047 = gc_frame_newslot(num1048);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  int op_slot_left_1047 = gc_frame_newslot(*var_blankLocation);
  params[0] = num1048;
  partcv[0] = 1;
  Object opresult1050 = callmethod(*var_blankLocation, ">", 1, partcv, params);
// compiled op node returning opresult1050 (depth = 4)
  Object if1046 = done;
  if (istrue(opresult1050)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1051 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blankLocation (depth = 5)
  gc_frame_newslot(*var_blankLocation);
// starting to compile num node (depth = 5)
  Object num1052 = alloc_Float64(0);
// compiled num node returning num1052 (depth = 5)
  gc_frame_newslot(num1052);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_blankLocation;
  params[1] = num1052;
  partcv[0] = 2;
  Object call1053 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1051);
// compiled call node returning call1053 (depth = 4)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1054 = alloc_Float64(0);
// compiled num node returning num1054 (depth = 5)
  *var_blankLocation = num1054;
  if (num1054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1046 = done;
  } else {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1056 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1058 = alloc_Float64(1);
// compiled num node returning num1058 (depth = 6)
  int op_slot_right_1057 = gc_frame_newslot(num1058);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1061 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1060);
// compiled call node returning call1061 (depth = 7)
// compiled member node returning call1061 (depth = 6)
  int op_slot_left_1057 = gc_frame_newslot(call1061);
  params[0] = num1058;
  partcv[0] = 1;
  Object diff1062 = callmethod(call1061, "-", 1, partcv, params);
// compiled op node returning diff1062 (depth = 5)
  gc_frame_newslot(diff1062);
// starting to compile num node (depth = 5)
  Object num1063 = alloc_Float64(0);
// compiled num node returning num1063 (depth = 5)
  gc_frame_newslot(num1063);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = diff1062;
  params[1] = num1063;
  partcv[0] = 2;
  Object call1064 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1056);
// compiled call node returning call1064 (depth = 4)
    gc_frame_newslot(call1064);
    if1046 = call1064;
  }
// compiled if node returning if1046 (depth = 3)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1065 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1066 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1067 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call1068 = callmethod(*var_ast, "blankNode",
    1, partcv, params);
  gc_frame_end(callframe1067);
// compiled call node returning call1068 (depth = 7)
// compiled member node returning call1068 (depth = 6)
  partcv[0] = 0;
  Object call1069 = callmethod(call1068, "new",
    1, partcv, params);
  gc_frame_end(callframe1066);
// compiled call node returning call1069 (depth = 5)
// compiled member node returning call1069 (depth = 4)
  gc_frame_newslot(call1069);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call1069;
  partcv[0] = 1;
  Object call1070 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1065);
// compiled call node returning call1070 (depth = 3)
    gc_frame_newslot(call1070);
    if1016 = call1070;
  } else {
  }
// compiled if node returning if1016 (depth = 2)
  gc_frame_end(frame);
  return if1016;
}
Object meth_parser_dotypeterm1071(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotypeterm (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dotypeterm");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1073 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1074 == NULL) {
    strlit1074 = alloc_String("identifier");
    gc_root(strlit1074);
  }
// compiled string node returning strlit1074 (depth = 4)
  gc_frame_newslot(strlit1074);
// call case 4: self request
  params[0] = strlit1074;
  partcv[0] = 1;
  Object call1075 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1073);
// compiled call node returning call1075 (depth = 3)
  Object if1072 = done;
  if (istrue(call1075)) {
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1077 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1076);
// compiled call node returning call1077 (depth = 4)
// compiled member node returning call1077 (depth = 3)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1079 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1078);
// compiled call node returning call1079 (depth = 4)
// compiled member node returning call1079 (depth = 3)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1080 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1081 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1080);
// compiled call node returning call1081 (depth = 3)
    gc_frame_newslot(call1081);
    if1072 = call1081;
  } else {
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1083 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1084 == NULL) {
    strlit1084 = alloc_String("type");
    gc_root(strlit1084);
  }
// compiled string node returning strlit1084 (depth = 5)
  gc_frame_newslot(strlit1084);
// call case 4: self request
  params[0] = strlit1084;
  partcv[0] = 1;
  Object call1085 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1083);
// compiled call node returning call1085 (depth = 4)
  Object if1082 = done;
  if (istrue(call1085)) {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1087 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1086);
// compiled call node returning call1087 (depth = 5)
// compiled member node returning call1087 (depth = 4)
    gc_frame_newslot(call1087);
    if1082 = call1087;
  } else {
  }
// compiled if node returning if1082 (depth = 3)
    gc_frame_newslot(if1082);
    if1072 = if1082;
  }
// compiled if node returning if1072 (depth = 2)
  gc_frame_end(frame);
  return if1072;
}
Object meth_parser__apply1102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1103 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1104 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1103);
// compiled call node returning call1104 (depth = 9)
// compiled member node returning call1104 (depth = 8)
  gc_frame_end(frame);
  return call1104;
}
Object meth_parser_typeexpression1088(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeexpression (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeexpression");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1090 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1089);
// compiled call node returning call1090 (depth = 4)
// compiled member node returning call1090 (depth = 3)
  *var_sz = call1090;
  if (call1090 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1092 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1093 == NULL) {
    strlit1093 = alloc_String("lparen");
    gc_root(strlit1093);
  }
// compiled string node returning strlit1093 (depth = 4)
  gc_frame_newslot(strlit1093);
// call case 4: self request
  params[0] = strlit1093;
  partcv[0] = 1;
  Object call1094 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1092);
// compiled call node returning call1094 (depth = 3)
  Object if1091 = done;
  if (istrue(call1094)) {
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1096 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1097 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1096);
// compiled call node returning call1097 (depth = 4)
// compiled member node returning call1097 (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1099 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1100 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1101 = alloc_Block(NULL, NULL, "parser", 380);
  gc_frame_newslot(block1101);
// method "_apply"
  block_savedest(block1101);
  Object closure1102 = createclosure(1, "_apply");
  setclosureframe(closure1102, stackframe);
  addtoclosure(closure1102, selfslot);
  struct UserObject *uo1102 = (struct UserObject*)block1101;
  uo1102->data[0] = (Object)closure1102;
  Method *meth_meth_parser__apply1102 = addmethod2pos(block1101, "_apply", &meth_parser__apply1102, 0);
  int argcv_meth_parser__apply1102[] = {0};
  meth_meth_parser__apply1102->type = alloc_MethodType(1, argcv_meth_parser__apply1102);
  meth_meth_parser__apply1102->definitionModule = modulename;
  meth_meth_parser__apply1102->definitionLine = 380;
// compiled block node returning block1101 (depth = 7)
  gc_frame_newslot(block1101);
// call case 4: self request
  params[0] = block1101;
  partcv[0] = 1;
  Object call1106 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled call node returning call1106 (depth = 6)
  partcv[0] = 0;
  Object call1107 = callmethod(call1106, "not",
    1, partcv, params);
  gc_frame_end(callframe1099);
// compiled call node returning call1107 (depth = 5)
// compiled member node returning call1107 (depth = 4)
  Object if1098 = done;
  if (istrue(call1107)) {
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1108 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1110 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1109);
// compiled call node returning call1110 (depth = 8)
// compiled member node returning call1110 (depth = 7)
  partcv[0] = 0;
  Object call1111 = callmethod(call1110, "new",
    1, partcv, params);
  gc_frame_end(callframe1108);
// compiled call node returning call1111 (depth = 6)
// compiled member node returning call1111 (depth = 5)
  *var_suggestion = call1111;
  if (call1111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1112 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array1113 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit1114 == NULL) {
    strlit1114 = alloc_String("rparen");
    gc_root(strlit1114);
  }
// compiled string node returning strlit1114 (depth = 7)
  params[0] = strlit1114;
  partcv[0] = 1;
  callmethodflags(array1113, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1113 (depth = 6)
  gc_frame_newslot(array1113);
// call case 4: self request
  params[0] = array1113;
  partcv[0] = 1;
  Object call1115 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1112);
// compiled call node returning call1115 (depth = 5)
  *var_nextTok = call1115;
  if (call1115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1117 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1117 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1119 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1119 (depth = 5)
  Object if1116 = done;
  if (istrue(opresult1119)) {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1120 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1121 == NULL) {
    strlit1121 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1121);
  }
// compiled string node returning strlit1121 (depth = 6)
  gc_frame_newslot(strlit1121);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1121;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1122 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1120);
// compiled call node returning call1122 (depth = 5)
    gc_frame_newslot(call1122);
    if1116 = call1122;
  } else {
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1125 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1124);
// compiled call node returning call1125 (depth = 7)
// compiled member node returning call1125 (depth = 6)
  gc_frame_newslot(call1125);
// starting to compile identifier node (depth = 6)
  Object bool1126 = alloc_Boolean(1);
// compiled identifier node returning bool1126 (depth = 6)
  gc_frame_newslot(bool1126);
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1127 = alloc_Boolean(0);
// compiled identifier node returning bool1127 (depth = 6)
  gc_frame_newslot(bool1127);
// starting to compile string node (depth = 6)
  if (strlit1128 == NULL) {
    strlit1128 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1128);
  }
// compiled string node returning strlit1128 (depth = 6)
  gc_frame_newslot(strlit1128);
// call case 6: other member request
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1125;
  params[2] = bool1126;
  params[3] = bool1127;
  params[4] = strlit1128;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1129 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1123);
// compiled call node returning call1129 (depth = 5)
    gc_frame_newslot(call1129);
    if1116 = call1129;
  }
// compiled if node returning if1116 (depth = 4)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1130 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1131 == NULL) {
    strlit1131 = alloc_String("parentheses must contain a valid type expression.");
    gc_root(strlit1131);
  }
// compiled string node returning strlit1131 (depth = 5)
  gc_frame_newslot(strlit1131);
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1132 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1133 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1132);
// compiled call node returning call1133 (depth = 6)
// compiled member node returning call1133 (depth = 5)
  gc_frame_newslot(call1133);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1135 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1134);
// compiled call node returning call1135 (depth = 6)
// compiled member node returning call1135 (depth = 5)
  gc_frame_newslot(call1135);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1131;
  params[1] = call1133;
  params[2] = call1135;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1136 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1130);
// compiled call node returning call1136 (depth = 4)
    gc_frame_newslot(call1136);
    if1098 = call1136;
  } else {
  }
// compiled if node returning if1098 (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1139 == NULL) {
    strlit1139 = alloc_String("rparen");
    gc_root(strlit1139);
  }
// compiled string node returning strlit1139 (depth = 5)
  int op_slot_right_1138 = gc_frame_newslot(strlit1139);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1141 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1142 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1141);
// compiled call node returning call1142 (depth = 6)
// compiled member node returning call1142 (depth = 5)
  int op_slot_left_1138 = gc_frame_newslot(call1142);
  params[0] = strlit1139;
  partcv[0] = 1;
  Object opresult1143 = callmethod(call1142, "≠", 1, partcv, params);
// compiled op node returning opresult1143 (depth = 4)
  Object if1137 = done;
  if (istrue(opresult1143)) {
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1145 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1144);
// compiled call node returning call1145 (depth = 5)
// compiled member node returning call1145 (depth = 4)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1146 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1147 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1148 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1147);
// compiled call node returning call1148 (depth = 8)
// compiled member node returning call1148 (depth = 7)
  partcv[0] = 0;
  Object call1149 = callmethod(call1148, "new",
    1, partcv, params);
  gc_frame_end(callframe1146);
// compiled call node returning call1149 (depth = 6)
// compiled member node returning call1149 (depth = 5)
  *var_suggestion = call1149;
  if (call1149 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1150 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1151 == NULL) {
    strlit1151 = alloc_String(")");
    gc_root(strlit1151);
  }
// compiled string node returning strlit1151 (depth = 5)
  gc_frame_newslot(strlit1151);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1151;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1152 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1150);
// compiled call node returning call1152 (depth = 4)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1153 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1154 == NULL) {
    strlit1154 = alloc_String("a type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1154);
  }
// compiled string node returning strlit1154 (depth = 5)
  gc_frame_newslot(strlit1154);
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1156 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1155);
// compiled call node returning call1156 (depth = 6)
// compiled member node returning call1156 (depth = 5)
  gc_frame_newslot(call1156);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1159 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1158);
// compiled call node returning call1159 (depth = 7)
// compiled member node returning call1159 (depth = 6)
  int op_slot_right_1157 = gc_frame_newslot(call1159);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1162 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1161);
// compiled call node returning call1162 (depth = 7)
// compiled member node returning call1162 (depth = 6)
  int op_slot_left_1157 = gc_frame_newslot(call1162);
  params[0] = call1159;
  partcv[0] = 1;
  Object sum1163 = callmethod(call1162, "+", 1, partcv, params);
// compiled op node returning sum1163 (depth = 5)
  gc_frame_newslot(sum1163);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1154;
  params[1] = call1156;
  params[2] = sum1163;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1164 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1153);
// compiled call node returning call1164 (depth = 4)
    gc_frame_newslot(call1164);
    if1137 = call1164;
  } else {
  }
// compiled if node returning if1137 (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1167 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1166);
// compiled call node returning call1167 (depth = 4)
// compiled member node returning call1167 (depth = 3)
    gc_frame_newslot(call1167);
    if1091 = call1167;
  } else {
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1169 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1168);
// compiled call node returning call1169 (depth = 4)
// compiled member node returning call1169 (depth = 3)
    gc_frame_newslot(call1169);
    if1091 = call1169;
  }
// compiled if node returning if1091 (depth = 2)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1171 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1174 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1173);
// compiled call node returning call1174 (depth = 5)
// compiled member node returning call1174 (depth = 4)
  int op_slot_left_1171 = gc_frame_newslot(call1174);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1175 = callmethod(call1174, ">", 1, partcv, params);
// compiled op node returning opresult1175 (depth = 3)
  Object if1170 = done;
  if (istrue(opresult1175)) {
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1176 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1177 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1176);
// compiled call node returning call1177 (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1178 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1179 = callmethodflags(self, "typeexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1178);
// compiled call node returning call1179 (depth = 4)
// compiled member node returning call1179 (depth = 3)
    gc_frame_newslot(call1179);
    if1170 = call1179;
  } else {
  }
// compiled if node returning if1170 (depth = 2)
  gc_frame_end(frame);
  return if1170;
}
Object meth_parser_newIf1180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method newIf");
  Object params[3];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for newIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for newIf");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1181 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1182 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1183 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled call node returning call1183 (depth = 5)
// compiled member node returning call1183 (depth = 4)
  gc_frame_newslot(call1183);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1185 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1184);
// compiled call node returning call1185 (depth = 5)
// compiled member node returning call1185 (depth = 4)
  params[0] = call1183;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1186 = callmethod(call1185, "new",
    1, partcv, params);
  gc_frame_end(callframe1181);
// compiled call node returning call1186 (depth = 3)
  *var_thenBlock = call1186;
  if (call1186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1187 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1188 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call1189 = callmethodflags(prelude, "emptySequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1188);
// compiled call node returning call1189 (depth = 5)
// compiled member node returning call1189 (depth = 4)
  gc_frame_newslot(call1189);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1191 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1190);
// compiled call node returning call1191 (depth = 5)
// compiled member node returning call1191 (depth = 4)
  params[0] = call1189;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1192 = callmethod(call1191, "new",
    1, partcv, params);
  gc_frame_end(callframe1187);
// compiled call node returning call1192 (depth = 3)
  *var_elseBlock = call1192;
  if (call1192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1193 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1195 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe1194);
// compiled call node returning call1195 (depth = 4)
// compiled member node returning call1195 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1196 = callmethod(call1195, "new",
    1, partcv, params);
  gc_frame_end(callframe1193);
// compiled call node returning call1196 (depth = 2)
  gc_frame_end(frame);
  return call1196;
}
Object meth_parser__apply1226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe1227 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1228 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1227);
// compiled call node returning call1228 (depth = 5)
  gc_frame_end(frame);
  return call1228;
}
Object meth_parser__apply1263(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe1264 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1265 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compiled call node returning call1265 (depth = 12)
  gc_frame_end(frame);
  return call1265;
}
Object meth_parser__apply1339(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe1340 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1341 == NULL) {
    strlit1341 = alloc_String("comma");
    gc_root(strlit1341);
  }
// compiled string node returning strlit1341 (depth = 10)
  gc_frame_newslot(strlit1341);
// call case 4: self request
  params[0] = strlit1341;
  partcv[0] = 1;
  Object call1342 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1340);
// compiled call node returning call1342 (depth = 9)
  gc_frame_end(frame);
  return call1342;
}
Object meth_parser__apply1349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1351 == NULL) {
    strlit1351 = alloc_String("arrow");
    gc_root(strlit1351);
  }
// compiled string node returning strlit1351 (depth = 11)
  int op_slot_right_1350 = gc_frame_newslot(strlit1351);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1353 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1354 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1353);
// compiled call node returning call1354 (depth = 12)
// compiled member node returning call1354 (depth = 11)
  int op_slot_left_1350 = gc_frame_newslot(call1354);
  params[0] = strlit1351;
  partcv[0] = 1;
  Object opresult1355 = callmethod(call1354, "==", 1, partcv, params);
// compiled op node returning opresult1355 (depth = 10)
  gc_frame_end(frame);
  return opresult1355;
}
Object meth_parser__apply1397(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1398 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1399 == NULL) {
    strlit1399 = alloc_String("comma");
    gc_root(strlit1399);
  }
// compiled string node returning strlit1399 (depth = 9)
  gc_frame_newslot(strlit1399);
// call case 4: self request
  params[0] = strlit1399;
  partcv[0] = 1;
  Object call1400 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1398);
// compiled call node returning call1400 (depth = 8)
  gc_frame_end(frame);
  return call1400;
}
Object meth_parser__apply1403(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1405 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1404);
// compiled call node returning call1405 (depth = 9)
// compiled member node returning call1405 (depth = 8)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1407 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1406);
// compiled call node returning call1407 (depth = 9)
// compiled member node returning call1407 (depth = 8)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1409 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1408);
// compiled call node returning call1409 (depth = 10)
// compiled member node returning call1409 (depth = 9)
  *var_expr1 = call1409;
  if (call1409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1411 = gc_frame_new();
// starting to compile identifier node (depth = 9)
  Object bool1412 = alloc_Boolean(1);
// compiled identifier node returning bool1412 (depth = 9)
  gc_frame_newslot(bool1412);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = bool1412;
  partcv[0] = 1;
  Object call1413 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1411);
// compiled call node returning call1413 (depth = 8)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1414 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1415 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1416 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1415);
// compiled call node returning call1416 (depth = 10)
// compiled member node returning call1416 (depth = 9)
  gc_frame_newslot(call1416);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = call1416;
  partcv[0] = 1;
  Object call1417 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1414);
// compiled call node returning call1417 (depth = 8)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1418 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1419 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1418);
// compiled call node returning call1419 (depth = 8)
  gc_frame_end(frame);
  return call1419;
}
Object meth_parser__apply1534(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 13)
  int callframe1535 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_blocksOK (depth = 14)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1536 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1535);
// compiled call node returning call1536 (depth = 13)
  gc_frame_end(frame);
  return call1536;
}
Object meth_parser__apply1231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_params = getfromclosure(closure, 7);
  Object *var_isMatchingBlock = getfromclosure(closure, 8);
  Object *var_body = getfromclosure(closure, 9);
  Object *var_indentFreePass = getfromclosure(closure, 10);
  Object *var_btok = getfromclosure(closure, 11);
  Object *var_util = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object self = *(getfromclosure(closure, 14));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1234 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1235 == NULL) {
    strlit1235 = alloc_String("colon");
    gc_root(strlit1235);
  }
// compiled string node returning strlit1235 (depth = 8)
  gc_frame_newslot(strlit1235);
// call case 4: self request
  params[0] = strlit1235;
  partcv[0] = 1;
  Object call1236 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1234);
// compiled call node returning call1236 (depth = 7)
  int op_slot_right_1233 = gc_frame_newslot(call1236);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1239 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1240 == NULL) {
    strlit1240 = alloc_String("arrow");
    gc_root(strlit1240);
  }
// compiled string node returning strlit1240 (depth = 9)
  gc_frame_newslot(strlit1240);
// call case 4: self request
  params[0] = strlit1240;
  partcv[0] = 1;
  Object call1241 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1239);
// compiled call node returning call1241 (depth = 8)
  int op_slot_right_1238 = gc_frame_newslot(call1241);
// starting to compile call node (depth = 8)
  int callframe1243 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1244 == NULL) {
    strlit1244 = alloc_String("comma");
    gc_root(strlit1244);
  }
// compiled string node returning strlit1244 (depth = 9)
  gc_frame_newslot(strlit1244);
// call case 4: self request
  params[0] = strlit1244;
  partcv[0] = 1;
  Object call1245 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1243);
// compiled call node returning call1245 (depth = 8)
  int op_slot_left_1238 = gc_frame_newslot(call1245);
  params[0] = call1241;
  partcv[0] = 1;
  Object opresult1246 = callmethod(call1245, "||", 1, partcv, params);
// compiled op node returning opresult1246 (depth = 7)
  int op_slot_left_1233 = gc_frame_newslot(opresult1246);
  params[0] = call1236;
  partcv[0] = 1;
  Object opresult1247 = callmethod(opresult1246, "||", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 6)
  Object if1232 = done;
  if (istrue(opresult1247)) {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1248 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call1249 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1248);
// compiled call node returning call1249 (depth = 8)
// compiled member node returning call1249 (depth = 7)
  *var_expr1 = call1249;
  if (call1249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1252 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1253 == NULL) {
    strlit1253 = alloc_String("colon");
    gc_root(strlit1253);
  }
// compiled string node returning strlit1253 (depth = 8)
  gc_frame_newslot(strlit1253);
// call case 4: self request
  params[0] = strlit1253;
  partcv[0] = 1;
  Object call1254 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1252);
// compiled call node returning call1254 (depth = 7)
  Object if1251 = done;
  if (istrue(call1254)) {
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1256 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1255);
// compiled call node returning call1256 (depth = 8)
// compiled member node returning call1256 (depth = 7)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1257 = alloc_Boolean(1);
// compiled identifier node returning bool1257 (depth = 8)
  *var_braceIsType = bool1257;
  if (bool1257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1260 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe1261 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block1262 = alloc_Block(NULL, NULL, "parser", 450);
  gc_frame_newslot(block1262);
// method "_apply"
  block_savedest(block1262);
  Object closure1263 = createclosure(2, "_apply");
  setclosureframe(closure1263, stackframe);
  addtoclosure(closure1263, var_blocksOK);
  addtoclosure(closure1263, selfslot);
  struct UserObject *uo1263 = (struct UserObject*)block1262;
  uo1263->data[0] = (Object)closure1263;
  Method *meth_meth_parser__apply1263 = addmethod2pos(block1262, "_apply", &meth_parser__apply1263, 0);
  int argcv_meth_parser__apply1263[] = {0};
  meth_meth_parser__apply1263->type = alloc_MethodType(1, argcv_meth_parser__apply1263);
  meth_meth_parser__apply1263->definitionModule = modulename;
  meth_meth_parser__apply1263->definitionLine = 450;
// compiled block node returning block1262 (depth = 11)
  gc_frame_newslot(block1262);
// call case 4: self request
  params[0] = block1262;
  partcv[0] = 1;
  Object call1267 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compiled call node returning call1267 (depth = 10)
  partcv[0] = 0;
  Object call1268 = callmethod(call1267, "not",
    1, partcv, params);
  gc_frame_end(callframe1260);
// compiled call node returning call1268 (depth = 9)
// compiled member node returning call1268 (depth = 8)
  Object if1259 = done;
  if (istrue(call1268)) {
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array1269 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1269 (depth = 9)
  *var_suggestions = array1269;
  if (array1269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1270 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1271 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1272 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1271);
// compiled call node returning call1272 (depth = 12)
// compiled member node returning call1272 (depth = 11)
  partcv[0] = 0;
  Object call1273 = callmethod(call1272, "new",
    1, partcv, params);
  gc_frame_end(callframe1270);
// compiled call node returning call1273 (depth = 10)
// compiled member node returning call1273 (depth = 9)
  *var_suggestion = call1273;
  if (call1273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1274 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array1275 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit1276 == NULL) {
    strlit1276 = alloc_String("arrow");
    gc_root(strlit1276);
  }
// compiled string node returning strlit1276 (depth = 11)
  params[0] = strlit1276;
  partcv[0] = 1;
  callmethodflags(array1275, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 11)
  if (strlit1277 == NULL) {
    strlit1277 = alloc_String("rbrace");
    gc_root(strlit1277);
  }
// compiled string node returning strlit1277 (depth = 11)
  params[0] = strlit1277;
  partcv[0] = 1;
  callmethodflags(array1275, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1275 (depth = 10)
  gc_frame_newslot(array1275);
// call case 4: self request
  params[0] = array1275;
  partcv[0] = 1;
  Object call1278 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1274);
// compiled call node returning call1278 (depth = 9)
  *var_nextTok = call1278;
  if (call1278 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1280 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1280 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1282 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1282 (depth = 9)
  Object if1279 = done;
  if (istrue(opresult1282)) {
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1283 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1284 == NULL) {
    strlit1284 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1284);
  }
// compiled string node returning strlit1284 (depth = 10)
  gc_frame_newslot(strlit1284);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1284;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1285 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1283);
// compiled call node returning call1285 (depth = 9)
    gc_frame_newslot(call1285);
    if1279 = call1285;
  } else {
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1286 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1288 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1287);
// compiled call node returning call1288 (depth = 11)
// compiled member node returning call1288 (depth = 10)
  gc_frame_newslot(call1288);
// starting to compile identifier node (depth = 10)
  Object bool1289 = alloc_Boolean(1);
// compiled identifier node returning bool1289 (depth = 10)
  gc_frame_newslot(bool1289);
// starting to compile identifier node (depth = 10)
  Object bool1290 = alloc_Boolean(0);
// compiled identifier node returning bool1290 (depth = 10)
  gc_frame_newslot(bool1290);
// starting to compile string node (depth = 10)
  if (strlit1291 == NULL) {
    strlit1291 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1291);
  }
// compiled string node returning strlit1291 (depth = 10)
  gc_frame_newslot(strlit1291);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call1288;
  params[2] = bool1289;
  params[3] = bool1290;
  params[4] = strlit1291;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1292 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1286);
// compiled call node returning call1292 (depth = 9)
    gc_frame_newslot(call1292);
    if1279 = call1292;
  }
// compiled if node returning if1279 (depth = 8)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1293 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1294 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1293);
// compiled call node returning call1294 (depth = 8)
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1295 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1297 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1296);
// compiled call node returning call1297 (depth = 12)
// compiled member node returning call1297 (depth = 11)
  partcv[0] = 0;
  Object call1298 = callmethod(call1297, "new",
    1, partcv, params);
  gc_frame_end(callframe1295);
// compiled call node returning call1298 (depth = 10)
// compiled member node returning call1298 (depth = 9)
  *var_suggestion = call1298;
  if (call1298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1300 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1301 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1302 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1301);
// compiled call node returning call1302 (depth = 10)
// compiled member node returning call1302 (depth = 9)
  gc_frame_newslot(call1302);
// starting to compile identifier node (depth = 9)
  Object bool1303 = alloc_Boolean(1);
// compiled identifier node returning bool1303 (depth = 9)
  gc_frame_newslot(bool1303);
// starting to compile identifier node (depth = 9)
  Object bool1304 = alloc_Boolean(0);
// compiled identifier node returning bool1304 (depth = 9)
  gc_frame_newslot(bool1304);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call1302;
  params[2] = bool1303;
  params[3] = bool1304;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1305 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1300);
// compiled call node returning call1305 (depth = 8)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1306 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1307 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1306);
// compiled call node returning call1307 (depth = 8)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1308 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1309 == NULL) {
    strlit1309 = alloc_String("a block must have an expression after the ':'.");
    gc_root(strlit1309);
  }
// compiled string node returning strlit1309 (depth = 9)
  gc_frame_newslot(strlit1309);
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1311 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1310);
// compiled call node returning call1311 (depth = 10)
// compiled member node returning call1311 (depth = 9)
  gc_frame_newslot(call1311);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1313 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1312);
// compiled call node returning call1313 (depth = 10)
// compiled member node returning call1313 (depth = 9)
  gc_frame_newslot(call1313);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit1309;
  params[1] = call1311;
  params[2] = call1313;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1314 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1308);
// compiled call node returning call1314 (depth = 8)
    gc_frame_newslot(call1314);
    if1259 = call1314;
  } else {
  }
// compiled if node returning if1259 (depth = 7)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1315 = alloc_Boolean(0);
// compiled identifier node returning bool1315 (depth = 8)
  *var_braceIsType = bool1315;
  if (bool1315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1317 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1319 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1318);
// compiled call node returning call1319 (depth = 9)
// compiled member node returning call1319 (depth = 8)
  gc_frame_newslot(call1319);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = call1319;
  partcv[0] = 1;
  Object call1320 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1317);
// compiled call node returning call1320 (depth = 7)
    gc_frame_newslot(call1320);
    if1251 = call1320;
  } else {
  }
// compiled if node returning if1251 (depth = 6)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1321 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr1 (depth = 7)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1322 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 6)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  partcv[0] = 0;
  Object call1326 = callmethod(*var_expr1, "isIdentifier",
    1, partcv, params);
  gc_frame_end(callframe1325);
// compiled call node returning call1326 (depth = 9)
// compiled member node returning call1326 (depth = 8)
  int op_slot_right_1324 = gc_frame_newslot(call1326);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_isMatchingBlock (depth = 10)
  partcv[0] = 0;
  Object call1329 = callmethod(*var_isMatchingBlock, "not",
    1, partcv, params);
  gc_frame_end(callframe1328);
// compiled call node returning call1329 (depth = 9)
// compiled member node returning call1329 (depth = 8)
  int op_slot_left_1324 = gc_frame_newslot(call1329);
  params[0] = call1326;
  partcv[0] = 1;
  Object opresult1330 = callmethod(call1329, "&&", 1, partcv, params);
// compiled op node returning opresult1330 (depth = 7)
  Object if1323 = done;
  if (istrue(opresult1330)) {
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1331 = gc_frame_new();
// starting to compile identifier node (depth = 8)
  Object bool1332 = alloc_Boolean(1);
// compiled identifier node returning bool1332 (depth = 8)
  gc_frame_newslot(bool1332);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_expr1 (depth = 8)
  params[0] = bool1332;
  partcv[0] = 1;
  Object call1333 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1331);
// compiled call node returning call1333 (depth = 7)
    gc_frame_newslot(call1333);
    if1323 = call1333;
  } else {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1334 = alloc_Boolean(1);
// compiled identifier node returning bool1334 (depth = 8)
  *var_isMatchingBlock = bool1334;
  if (bool1334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1323 = done;
  }
// compiled if node returning if1323 (depth = 6)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1338 = alloc_Block(NULL, NULL, "parser", 476);
  gc_frame_newslot(block1338);
// method "_apply"
  block_savedest(block1338);
  Object closure1339 = createclosure(1, "_apply");
  setclosureframe(closure1339, stackframe);
  addtoclosure(closure1339, selfslot);
  struct UserObject *uo1339 = (struct UserObject*)block1338;
  uo1339->data[0] = (Object)closure1339;
  Method *meth_meth_parser__apply1339 = addmethod2pos(block1338, "_apply", &meth_parser__apply1339, 0);
  int argcv_meth_parser__apply1339[] = {0};
  meth_meth_parser__apply1339->type = alloc_MethodType(1, argcv_meth_parser__apply1339);
  meth_meth_parser__apply1339->definitionModule = modulename;
  meth_meth_parser__apply1339->definitionLine = 471;
// compiled block node returning block1338 (depth = 8)
  int op_slot_right_1337 = gc_frame_newslot(block1338);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isMatchingBlock (depth = 8)
  int op_slot_left_1337 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1338;
  partcv[0] = 1;
  Object opresult1345 = callmethod(*var_isMatchingBlock, "&&", 1, partcv, params);
// compiled op node returning opresult1345 (depth = 7)
  Object if1336 = done;
  if (istrue(opresult1345)) {
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array1346 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1346 (depth = 8)
  *var_suggestions = array1346;
  if (array1346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 7)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1347 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1348 = alloc_Block(NULL, NULL, "parser", 479);
  gc_frame_newslot(block1348);
// method "_apply"
  block_savedest(block1348);
  Object closure1349 = createclosure(1, "_apply");
  setclosureframe(closure1349, stackframe);
  addtoclosure(closure1349, selfslot);
  struct UserObject *uo1349 = (struct UserObject*)block1348;
  uo1349->data[0] = (Object)closure1349;
  Method *meth_meth_parser__apply1349 = addmethod2pos(block1348, "_apply", &meth_parser__apply1349, 0);
  int argcv_meth_parser__apply1349[] = {1};
  meth_meth_parser__apply1349->type = alloc_MethodType(1, argcv_meth_parser__apply1349);
  meth_meth_parser__apply1349->definitionModule = modulename;
  meth_meth_parser__apply1349->definitionLine = 471;
// compiled block node returning block1348 (depth = 9)
  gc_frame_newslot(block1348);
// call case 4: self request
  params[0] = block1348;
  partcv[0] = 1;
  Object call1357 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1347);
// compiled call node returning call1357 (depth = 8)
  *var_arrow = call1357;
  if (call1357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arrow (depth = 9)
  int op_slot_right_1359 = gc_frame_newslot(*var_arrow);
// starting to compile identifier node (depth = 9)
  Object bool1361 = alloc_Boolean(0);
// compiled identifier node returning bool1361 (depth = 9)
  int op_slot_left_1359 = gc_frame_newslot(bool1361);
  params[0] = *var_arrow;
  partcv[0] = 1;
  Object opresult1362 = callmethod(bool1361, "≠", 1, partcv, params);
// compiled op node returning opresult1362 (depth = 8)
  Object if1358 = done;
  if (istrue(opresult1362)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1363 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1364 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1365 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compiled call node returning call1365 (depth = 12)
// compiled member node returning call1365 (depth = 11)
  partcv[0] = 0;
  Object call1366 = callmethod(call1365, "new",
    1, partcv, params);
  gc_frame_end(callframe1363);
// compiled call node returning call1366 (depth = 10)
// compiled member node returning call1366 (depth = 9)
  *var_suggestion = call1366;
  if (call1366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1368 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arrow (depth = 11)
  partcv[0] = 0;
  Object call1370 = callmethod(*var_arrow, "prev",
    1, partcv, params);
  gc_frame_end(callframe1369);
// compiled call node returning call1370 (depth = 10)
// compiled member node returning call1370 (depth = 9)
  gc_frame_newslot(call1370);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call1370;
  partcv[0] = 2;
  Object call1371 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe1368);
// compiled call node returning call1371 (depth = 8)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1372 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1373 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1372);
// compiled call node returning call1373 (depth = 8)
    gc_frame_newslot(call1373);
    if1358 = call1373;
  } else {
  }
// compiled if node returning if1358 (depth = 7)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1374 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1376 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1375);
// compiled call node returning call1376 (depth = 11)
// compiled member node returning call1376 (depth = 10)
  partcv[0] = 0;
  Object call1377 = callmethod(call1376, "new",
    1, partcv, params);
  gc_frame_end(callframe1374);
// compiled call node returning call1377 (depth = 9)
// compiled member node returning call1377 (depth = 8)
  *var_suggestion = call1377;
  if (call1377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1379 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool1380 = alloc_Boolean(1);
// compiled identifier node returning bool1380 (depth = 8)
  gc_frame_newslot(bool1380);
// starting to compile identifier node (depth = 8)
  Object bool1381 = alloc_Boolean(0);
// compiled identifier node returning bool1381 (depth = 8)
  gc_frame_newslot(bool1381);
// starting to compile string node (depth = 8)
  if (strlit1382 == NULL) {
    strlit1382 = alloc_String(" |");
    gc_root(strlit1382);
  }
// compiled string node returning strlit1382 (depth = 8)
  gc_frame_newslot(strlit1382);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool1380;
  params[2] = bool1381;
  params[3] = strlit1382;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1383 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1379);
// compiled call node returning call1383 (depth = 7)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1384 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1385 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1384);
// compiled call node returning call1385 (depth = 7)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1386 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1387 == NULL) {
    strlit1387 = alloc_String("a matching block may only have one parameter.");
    gc_root(strlit1387);
  }
// compiled string node returning strlit1387 (depth = 8)
  gc_frame_newslot(strlit1387);
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1388 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1389 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1388);
// compiled call node returning call1389 (depth = 9)
// compiled member node returning call1389 (depth = 8)
  gc_frame_newslot(call1389);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1391 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1390);
// compiled call node returning call1391 (depth = 9)
// compiled member node returning call1391 (depth = 8)
  gc_frame_newslot(call1391);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1392 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1393 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1392);
// compiled call node returning call1393 (depth = 9)
// compiled member node returning call1393 (depth = 8)
  gc_frame_newslot(call1393);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1387;
  params[1] = call1389;
  params[2] = call1391;
  params[3] = call1393;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1394 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1386);
// compiled call node returning call1394 (depth = 7)
    gc_frame_newslot(call1394);
    if1336 = call1394;
  } else {
  }
// compiled if node returning if1336 (depth = 6)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1395 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1396 = alloc_Block(NULL, NULL, "parser", 491);
  gc_frame_newslot(block1396);
// method "_apply"
  block_savedest(block1396);
  Object closure1397 = createclosure(1, "_apply");
  setclosureframe(closure1397, stackframe);
  addtoclosure(closure1397, selfslot);
  struct UserObject *uo1397 = (struct UserObject*)block1396;
  uo1397->data[0] = (Object)closure1397;
  Method *meth_meth_parser__apply1397 = addmethod2pos(block1396, "_apply", &meth_parser__apply1397, 0);
  int argcv_meth_parser__apply1397[] = {0};
  meth_meth_parser__apply1397->type = alloc_MethodType(1, argcv_meth_parser__apply1397);
  meth_meth_parser__apply1397->definitionModule = modulename;
  meth_meth_parser__apply1397->definitionLine = 489;
// compiled block node returning block1396 (depth = 7)
  gc_frame_newslot(block1396);
// starting to compile block node (depth = 7)
  Object block1402 = alloc_Block(NULL, NULL, "parser", 491);
  gc_frame_newslot(block1402);
// method "_apply"
  block_savedest(block1402);
  Object closure1403 = createclosure(4, "_apply");
  setclosureframe(closure1403, stackframe);
  addtoclosure(closure1403, var_values);
  addtoclosure(closure1403, var_expr1);
  addtoclosure(closure1403, var_params);
  addtoclosure(closure1403, selfslot);
  struct UserObject *uo1403 = (struct UserObject*)block1402;
  uo1403->data[0] = (Object)closure1403;
  Method *meth_meth_parser__apply1403 = addmethod2pos(block1402, "_apply", &meth_parser__apply1403, 0);
  int argcv_meth_parser__apply1403[] = {0};
  meth_meth_parser__apply1403->type = alloc_MethodType(1, argcv_meth_parser__apply1403);
  meth_meth_parser__apply1403->definitionModule = modulename;
  meth_meth_parser__apply1403->definitionLine = 489;
// compiled block node returning block1402 (depth = 7)
  gc_frame_newslot(block1402);
// call case 5: prelude request
  params[0] = block1396;
  params[1] = block1402;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1421 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compiled call node returning call1421 (depth = 6)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1423 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe1424 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1425 == NULL) {
    strlit1425 = alloc_String("arrow");
    gc_root(strlit1425);
  }
// compiled string node returning strlit1425 (depth = 10)
  gc_frame_newslot(strlit1425);
// call case 4: self request
  params[0] = strlit1425;
  partcv[0] = 1;
  Object call1426 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1424);
// compiled call node returning call1426 (depth = 9)
  partcv[0] = 0;
  Object call1427 = callmethod(call1426, "not",
    1, partcv, params);
  gc_frame_end(callframe1423);
// compiled call node returning call1427 (depth = 8)
// compiled member node returning call1427 (depth = 7)
  Object if1422 = done;
  if (istrue(call1427)) {
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1428 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1430 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1429);
// compiled call node returning call1430 (depth = 11)
// compiled member node returning call1430 (depth = 10)
  partcv[0] = 0;
  Object call1431 = callmethod(call1430, "new",
    1, partcv, params);
  gc_frame_end(callframe1428);
// compiled call node returning call1431 (depth = 9)
// compiled member node returning call1431 (depth = 8)
  *var_suggestion = call1431;
  if (call1431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("=");
    gc_root(strlit1435);
  }
// compiled string node returning strlit1435 (depth = 10)
  int op_slot_right_1434 = gc_frame_newslot(strlit1435);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1438 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1437);
// compiled call node returning call1438 (depth = 11)
// compiled member node returning call1438 (depth = 10)
  int op_slot_left_1434 = gc_frame_newslot(call1438);
  params[0] = strlit1435;
  partcv[0] = 1;
  Object opresult1439 = callmethod(call1438, "==", 1, partcv, params);
// compiled op node returning opresult1439 (depth = 9)
  int op_slot_right_1433 = gc_frame_newslot(opresult1439);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1442 == NULL) {
    strlit1442 = alloc_String("bind");
    gc_root(strlit1442);
  }
// compiled string node returning strlit1442 (depth = 10)
  int op_slot_right_1441 = gc_frame_newslot(strlit1442);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1445 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1444);
// compiled call node returning call1445 (depth = 11)
// compiled member node returning call1445 (depth = 10)
  int op_slot_left_1441 = gc_frame_newslot(call1445);
  params[0] = strlit1442;
  partcv[0] = 1;
  Object opresult1446 = callmethod(call1445, "==", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 9)
  int op_slot_left_1433 = gc_frame_newslot(opresult1446);
  params[0] = opresult1439;
  partcv[0] = 1;
  Object opresult1447 = callmethod(opresult1446, "||", 1, partcv, params);
// compiled op node returning opresult1447 (depth = 8)
  Object if1432 = done;
  if (istrue(opresult1447)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1448 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 9)
  if (strlit1449 == NULL) {
    strlit1449 = alloc_String("->");
    gc_root(strlit1449);
  }
// compiled string node returning strlit1449 (depth = 9)
  gc_frame_newslot(strlit1449);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = strlit1449;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1450 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe1448);
// compiled call node returning call1450 (depth = 8)
    gc_frame_newslot(call1450);
    if1432 = call1450;
  } else {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1451 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1452 == NULL) {
    strlit1452 = alloc_String(" ->");
    gc_root(strlit1452);
  }
// compiled string node returning strlit1452 (depth = 9)
  gc_frame_newslot(strlit1452);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1452;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1453 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1451);
// compiled call node returning call1453 (depth = 8)
    gc_frame_newslot(call1453);
    if1432 = call1453;
  }
// compiled if node returning if1432 (depth = 7)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1454 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String("a block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1455);
  }
// compiled string node returning strlit1455 (depth = 8)
  gc_frame_newslot(strlit1455);
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1457 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1456);
// compiled call node returning call1457 (depth = 9)
// compiled member node returning call1457 (depth = 8)
  gc_frame_newslot(call1457);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1459 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1458);
// compiled call node returning call1459 (depth = 9)
// compiled member node returning call1459 (depth = 8)
  gc_frame_newslot(call1459);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1455;
  params[1] = call1457;
  params[2] = call1459;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1460 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1454);
// compiled call node returning call1460 (depth = 7)
    gc_frame_newslot(call1460);
    if1422 = call1460;
  } else {
  }
// compiled if node returning if1422 (depth = 6)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1461 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1462 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1461);
// compiled call node returning call1462 (depth = 7)
// compiled member node returning call1462 (depth = 6)
    gc_frame_newslot(call1462);
    if1232 = call1462;
  } else {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1465 == NULL) {
    strlit1465 = alloc_String("semicolon");
    gc_root(strlit1465);
  }
// compiled string node returning strlit1465 (depth = 8)
  gc_frame_newslot(strlit1465);
// call case 4: self request
  params[0] = strlit1465;
  partcv[0] = 1;
  Object call1466 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1464);
// compiled call node returning call1466 (depth = 7)
  Object if1463 = done;
  if (istrue(call1466)) {
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1467 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1469 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1469 (depth = 9)
// compiled member node returning call1469 (depth = 8)
  gc_frame_newslot(call1469);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call1469;
  partcv[0] = 1;
  Object call1470 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1467);
// compiled call node returning call1470 (depth = 7)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1471 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1472 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compiled call node returning call1472 (depth = 8)
// compiled member node returning call1472 (depth = 7)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1474 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1475 == NULL) {
    strlit1475 = alloc_String("semicolon");
    gc_root(strlit1475);
  }
// compiled string node returning strlit1475 (depth = 9)
  gc_frame_newslot(strlit1475);
// call case 4: self request
  params[0] = strlit1475;
  partcv[0] = 1;
  Object call1476 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compiled call node returning call1476 (depth = 8)
  Object if1473 = done;
  if (istrue(call1476)) {
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1478 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1477);
// compiled call node returning call1478 (depth = 9)
// compiled member node returning call1478 (depth = 8)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call1482 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1481);
// compiled call node returning call1482 (depth = 11)
// compiled member node returning call1482 (depth = 10)
  int op_slot_right_1480 = gc_frame_newslot(call1482);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1485 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1484);
// compiled call node returning call1485 (depth = 11)
// compiled member node returning call1485 (depth = 10)
  int op_slot_left_1480 = gc_frame_newslot(call1485);
  params[0] = call1482;
  partcv[0] = 1;
  Object opresult1486 = callmethod(call1485, "==", 1, partcv, params);
// compiled op node returning opresult1486 (depth = 9)
  Object if1479 = done;
  if (istrue(opresult1486)) {
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1487 = alloc_Boolean(1);
// compiled identifier node returning bool1487 (depth = 10)
  *var_indentFreePass = bool1487;
  if (bool1487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1479 = done;
  } else {
  }
// compiled if node returning if1479 (depth = 8)
    gc_frame_newslot(if1479);
    if1473 = if1479;
  } else {
  }
// compiled if node returning if1473 (depth = 7)
    gc_frame_newslot(if1473);
    if1463 = if1473;
  } else {
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1491 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1492 == NULL) {
    strlit1492 = alloc_String("bind");
    gc_root(strlit1492);
  }
// compiled string node returning strlit1492 (depth = 10)
  gc_frame_newslot(strlit1492);
// call case 4: self request
  params[0] = strlit1492;
  partcv[0] = 1;
  Object call1493 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1491);
// compiled call node returning call1493 (depth = 9)
  int op_slot_right_1490 = gc_frame_newslot(call1493);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1497 == NULL) {
    strlit1497 = alloc_String("index");
    gc_root(strlit1497);
  }
// compiled string node returning strlit1497 (depth = 11)
  int op_slot_right_1496 = gc_frame_newslot(strlit1497);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1499 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call1501 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1500);
// compiled call node returning call1501 (depth = 14)
// compiled member node returning call1501 (depth = 13)
  partcv[0] = 0;
  Object call1502 = callmethod(call1501, "kind",
    1, partcv, params);
  gc_frame_end(callframe1499);
// compiled call node returning call1502 (depth = 12)
// compiled member node returning call1502 (depth = 11)
  int op_slot_left_1496 = gc_frame_newslot(call1502);
  params[0] = strlit1497;
  partcv[0] = 1;
  Object opresult1503 = callmethod(call1502, "==", 1, partcv, params);
// compiled op node returning opresult1503 (depth = 10)
  int op_slot_right_1495 = gc_frame_newslot(opresult1503);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1507 == NULL) {
    strlit1507 = alloc_String("identifier");
    gc_root(strlit1507);
  }
// compiled string node returning strlit1507 (depth = 12)
  int op_slot_right_1506 = gc_frame_newslot(strlit1507);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1509 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1511 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1510);
// compiled call node returning call1511 (depth = 15)
// compiled member node returning call1511 (depth = 14)
  partcv[0] = 0;
  Object call1512 = callmethod(call1511, "kind",
    1, partcv, params);
  gc_frame_end(callframe1509);
// compiled call node returning call1512 (depth = 13)
// compiled member node returning call1512 (depth = 12)
  int op_slot_left_1506 = gc_frame_newslot(call1512);
  params[0] = strlit1507;
  partcv[0] = 1;
  Object opresult1513 = callmethod(call1512, "==", 1, partcv, params);
// compiled op node returning opresult1513 (depth = 11)
  int op_slot_right_1505 = gc_frame_newslot(opresult1513);
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1516 == NULL) {
    strlit1516 = alloc_String("member");
    gc_root(strlit1516);
  }
// compiled string node returning strlit1516 (depth = 12)
  int op_slot_right_1515 = gc_frame_newslot(strlit1516);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1518 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1520 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1519);
// compiled call node returning call1520 (depth = 15)
// compiled member node returning call1520 (depth = 14)
  partcv[0] = 0;
  Object call1521 = callmethod(call1520, "kind",
    1, partcv, params);
  gc_frame_end(callframe1518);
// compiled call node returning call1521 (depth = 13)
// compiled member node returning call1521 (depth = 12)
  int op_slot_left_1515 = gc_frame_newslot(call1521);
  params[0] = strlit1516;
  partcv[0] = 1;
  Object opresult1522 = callmethod(call1521, "==", 1, partcv, params);
// compiled op node returning opresult1522 (depth = 11)
  int op_slot_left_1505 = gc_frame_newslot(opresult1522);
  params[0] = opresult1513;
  partcv[0] = 1;
  Object opresult1523 = callmethod(opresult1522, "||", 1, partcv, params);
// compiled op node returning opresult1523 (depth = 10)
  int op_slot_left_1495 = gc_frame_newslot(opresult1523);
  params[0] = opresult1503;
  partcv[0] = 1;
  Object opresult1524 = callmethod(opresult1523, "||", 1, partcv, params);
// compiled op node returning opresult1524 (depth = 9)
  int op_slot_left_1490 = gc_frame_newslot(opresult1524);
  params[0] = call1493;
  partcv[0] = 1;
  Object opresult1525 = callmethod(opresult1524, "&&", 1, partcv, params);
// compiled op node returning opresult1525 (depth = 8)
  Object if1489 = done;
  if (istrue(opresult1525)) {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1527 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1526);
// compiled call node returning call1527 (depth = 10)
// compiled member node returning call1527 (depth = 9)
  *var_lhs = call1527;
  if (call1527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1528 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1529 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1528);
// compiled call node returning call1529 (depth = 9)
// compiled member node returning call1529 (depth = 8)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1531 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe1532 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block1533 = alloc_Block(NULL, NULL, "parser", 526);
  gc_frame_newslot(block1533);
// method "_apply"
  block_savedest(block1533);
  Object closure1534 = createclosure(2, "_apply");
  setclosureframe(closure1534, stackframe);
  addtoclosure(closure1534, var_blocksOK);
  addtoclosure(closure1534, selfslot);
  struct UserObject *uo1534 = (struct UserObject*)block1533;
  uo1534->data[0] = (Object)closure1534;
  Method *meth_meth_parser__apply1534 = addmethod2pos(block1533, "_apply", &meth_parser__apply1534, 0);
  int argcv_meth_parser__apply1534[] = {0};
  meth_meth_parser__apply1534->type = alloc_MethodType(1, argcv_meth_parser__apply1534);
  meth_meth_parser__apply1534->definitionModule = modulename;
  meth_meth_parser__apply1534->definitionLine = 526;
// compiled block node returning block1533 (depth = 12)
  gc_frame_newslot(block1533);
// call case 4: self request
  params[0] = block1533;
  partcv[0] = 1;
  Object call1538 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1532);
// compiled call node returning call1538 (depth = 11)
  partcv[0] = 0;
  Object call1539 = callmethod(call1538, "not",
    1, partcv, params);
  gc_frame_end(callframe1531);
// compiled call node returning call1539 (depth = 10)
// compiled member node returning call1539 (depth = 9)
  Object if1530 = done;
  if (istrue(call1539)) {
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile array node (depth = 10)
  Object array1540 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1540 (depth = 10)
  *var_suggestions = array1540;
  if (array1540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1541 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1543 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1542);
// compiled call node returning call1543 (depth = 13)
// compiled member node returning call1543 (depth = 12)
  partcv[0] = 0;
  Object call1544 = callmethod(call1543, "new",
    1, partcv, params);
  gc_frame_end(callframe1541);
// compiled call node returning call1544 (depth = 11)
// compiled member node returning call1544 (depth = 10)
  *var_suggestion = call1544;
  if (call1544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1545 = gc_frame_new();
// starting to compile array node (depth = 11)
  Object array1546 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 12)
  if (strlit1547 == NULL) {
    strlit1547 = alloc_String("rbrace");
    gc_root(strlit1547);
  }
// compiled string node returning strlit1547 (depth = 12)
  params[0] = strlit1547;
  partcv[0] = 1;
  callmethodflags(array1546, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1546 (depth = 11)
  gc_frame_newslot(array1546);
// call case 4: self request
  params[0] = array1546;
  partcv[0] = 1;
  Object call1548 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1545);
// compiled call node returning call1548 (depth = 10)
  *var_nextTok = call1548;
  if (call1548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_1550 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_1550 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1552 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1552 (depth = 10)
  Object if1549 = done;
  if (istrue(opresult1552)) {
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1553 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1554 == NULL) {
    strlit1554 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1554);
  }
// compiled string node returning strlit1554 (depth = 11)
  gc_frame_newslot(strlit1554);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit1554;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1555 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1553);
// compiled call node returning call1555 (depth = 10)
    gc_frame_newslot(call1555);
    if1549 = call1555;
  } else {
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1556 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call1558 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1557);
// compiled call node returning call1558 (depth = 12)
// compiled member node returning call1558 (depth = 11)
  gc_frame_newslot(call1558);
// starting to compile identifier node (depth = 11)
  Object bool1559 = alloc_Boolean(1);
// compiled identifier node returning bool1559 (depth = 11)
  gc_frame_newslot(bool1559);
// starting to compile identifier node (depth = 11)
  Object bool1560 = alloc_Boolean(0);
// compiled identifier node returning bool1560 (depth = 11)
  gc_frame_newslot(bool1560);
// starting to compile string node (depth = 11)
  if (strlit1561 == NULL) {
    strlit1561 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1561);
  }
// compiled string node returning strlit1561 (depth = 11)
  gc_frame_newslot(strlit1561);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = call1558;
  params[2] = bool1559;
  params[3] = bool1560;
  params[4] = strlit1561;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1562 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1556);
// compiled call node returning call1562 (depth = 10)
    gc_frame_newslot(call1562);
    if1549 = call1562;
  }
// compiled if node returning if1549 (depth = 9)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1563 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1564 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1563);
// compiled call node returning call1564 (depth = 9)
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1565 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1566 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1567 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1566);
// compiled call node returning call1567 (depth = 13)
// compiled member node returning call1567 (depth = 12)
  partcv[0] = 0;
  Object call1568 = callmethod(call1567, "new",
    1, partcv, params);
  gc_frame_end(callframe1565);
// compiled call node returning call1568 (depth = 11)
// compiled member node returning call1568 (depth = 10)
  *var_suggestion = call1568;
  if (call1568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1570 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1572 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1571);
// compiled call node returning call1572 (depth = 11)
// compiled member node returning call1572 (depth = 10)
  gc_frame_newslot(call1572);
// starting to compile identifier node (depth = 10)
  Object bool1573 = alloc_Boolean(1);
// compiled identifier node returning bool1573 (depth = 10)
  gc_frame_newslot(bool1573);
// starting to compile identifier node (depth = 10)
  Object bool1574 = alloc_Boolean(0);
// compiled identifier node returning bool1574 (depth = 10)
  gc_frame_newslot(bool1574);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = call1572;
  params[2] = bool1573;
  params[3] = bool1574;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1575 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1570);
// compiled call node returning call1575 (depth = 9)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1576 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1577 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1576);
// compiled call node returning call1577 (depth = 9)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1578 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1579 == NULL) {
    strlit1579 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit1579);
  }
// compiled string node returning strlit1579 (depth = 10)
  gc_frame_newslot(strlit1579);
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1581 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1580);
// compiled call node returning call1581 (depth = 11)
// compiled member node returning call1581 (depth = 10)
  gc_frame_newslot(call1581);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1583 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1582);
// compiled call node returning call1583 (depth = 11)
// compiled member node returning call1583 (depth = 10)
  gc_frame_newslot(call1583);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit1579;
  params[1] = call1581;
  params[2] = call1583;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1584 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1578);
// compiled call node returning call1584 (depth = 9)
    gc_frame_newslot(call1584);
    if1530 = call1584;
  } else {
  }
// compiled if node returning if1530 (depth = 8)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1585 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1586 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1585);
// compiled call node returning call1586 (depth = 10)
// compiled member node returning call1586 (depth = 9)
  *var_rhs = call1586;
  if (call1586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1587 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1589 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1588);
// compiled call node returning call1589 (depth = 10)
// compiled member node returning call1589 (depth = 9)
  gc_frame_newslot(call1589);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1591 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1590);
// compiled call node returning call1591 (depth = 10)
// compiled member node returning call1591 (depth = 9)
  gc_frame_newslot(call1591);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  params[0] = call1589;
  params[1] = call1591;
  partcv[0] = 2;
  Object call1592 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1587);
// compiled call node returning call1592 (depth = 8)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1593 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1594 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lhs (depth = 10)
  gc_frame_newslot(*var_lhs);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rhs (depth = 10)
  gc_frame_newslot(*var_rhs);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ast (depth = 12)
  partcv[0] = 0;
  Object call1596 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe1595);
// compiled call node returning call1596 (depth = 11)
// compiled member node returning call1596 (depth = 10)
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1597 = callmethod(call1596, "new",
    1, partcv, params);
  gc_frame_end(callframe1594);
// compiled call node returning call1597 (depth = 9)
  gc_frame_newslot(call1597);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1597;
  partcv[0] = 1;
  Object call1598 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1593);
// compiled call node returning call1598 (depth = 8)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1600 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1601 == NULL) {
    strlit1601 = alloc_String("semicolon");
    gc_root(strlit1601);
  }
// compiled string node returning strlit1601 (depth = 10)
  gc_frame_newslot(strlit1601);
// call case 4: self request
  params[0] = strlit1601;
  partcv[0] = 1;
  Object call1602 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1600);
// compiled call node returning call1602 (depth = 9)
  Object if1599 = done;
  if (istrue(call1602)) {
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1604 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1603);
// compiled call node returning call1604 (depth = 10)
// compiled member node returning call1604 (depth = 9)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  partcv[0] = 0;
  Object call1608 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1607);
// compiled call node returning call1608 (depth = 12)
// compiled member node returning call1608 (depth = 11)
  int op_slot_right_1606 = gc_frame_newslot(call1608);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call1611 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1610);
// compiled call node returning call1611 (depth = 12)
// compiled member node returning call1611 (depth = 11)
  int op_slot_left_1606 = gc_frame_newslot(call1611);
  params[0] = call1608;
  partcv[0] = 1;
  Object opresult1612 = callmethod(call1611, "==", 1, partcv, params);
// compiled op node returning opresult1612 (depth = 10)
  Object if1605 = done;
  if (istrue(opresult1612)) {
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool1613 = alloc_Boolean(1);
// compiled identifier node returning bool1613 (depth = 11)
  *var_indentFreePass = bool1613;
  if (bool1613 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1605 = done;
  } else {
  }
// compiled if node returning if1605 (depth = 9)
    gc_frame_newslot(if1605);
    if1599 = if1605;
  } else {
  }
// compiled if node returning if1599 (depth = 8)
    gc_frame_newslot(if1599);
    if1489 = if1599;
  } else {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1616 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled call node returning call1616 (depth = 9)
// compiled member node returning call1616 (depth = 8)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1617 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1618 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1619 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1618);
// compiled call node returning call1619 (depth = 10)
// compiled member node returning call1619 (depth = 9)
  gc_frame_newslot(call1619);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1619;
  partcv[0] = 1;
  Object call1620 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1617);
// compiled call node returning call1620 (depth = 8)
    gc_frame_newslot(call1620);
    if1489 = call1620;
  }
// compiled if node returning if1489 (depth = 7)
    gc_frame_newslot(if1489);
    if1463 = if1489;
  }
// compiled if node returning if1463 (depth = 6)
    gc_frame_newslot(if1463);
    if1232 = if1463;
  }
// compiled if node returning if1232 (depth = 5)
  gc_frame_end(frame);
  return if1232;
}
Object meth_parser__apply1647(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1648 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe1649 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1650 == NULL) {
    strlit1650 = alloc_String("rbrace");
    gc_root(strlit1650);
  }
// compiled string node returning strlit1650 (depth = 8)
  gc_frame_newslot(strlit1650);
// call case 4: self request
  params[0] = strlit1650;
  partcv[0] = 1;
  Object call1651 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1649);
// compiled call node returning call1651 (depth = 7)
  partcv[0] = 0;
  Object call1652 = callmethod(call1651, "not",
    1, partcv, params);
  gc_frame_end(callframe1648);
// compiled call node returning call1652 (depth = 6)
// compiled member node returning call1652 (depth = 5)
  gc_frame_end(frame);
  return call1652;
}
Object meth_parser__apply1660(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1662 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1661);
// compiled call node returning call1662 (depth = 11)
// compiled member node returning call1662 (depth = 10)
  gc_frame_end(frame);
  return call1662;
}
Object meth_parser__apply1655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1657 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1658 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1659 = alloc_Block(NULL, NULL, "parser", 566);
  gc_frame_newslot(block1659);
// method "_apply"
  block_savedest(block1659);
  Object closure1660 = createclosure(1, "_apply");
  setclosureframe(closure1660, stackframe);
  addtoclosure(closure1660, selfslot);
  struct UserObject *uo1660 = (struct UserObject*)block1659;
  uo1660->data[0] = (Object)closure1660;
  Method *meth_meth_parser__apply1660 = addmethod2pos(block1659, "_apply", &meth_parser__apply1660, 0);
  int argcv_meth_parser__apply1660[] = {0};
  meth_meth_parser__apply1660->type = alloc_MethodType(1, argcv_meth_parser__apply1660);
  meth_meth_parser__apply1660->definitionModule = modulename;
  meth_meth_parser__apply1660->definitionLine = 566;
// compiled block node returning block1659 (depth = 9)
  gc_frame_newslot(block1659);
// call case 4: self request
  params[0] = block1659;
  partcv[0] = 1;
  Object call1664 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1658);
// compiled call node returning call1664 (depth = 8)
  partcv[0] = 0;
  Object call1665 = callmethod(call1664, "not",
    1, partcv, params);
  gc_frame_end(callframe1657);
// compiled call node returning call1665 (depth = 7)
// compiled member node returning call1665 (depth = 6)
  Object if1656 = done;
  if (istrue(call1665)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1666 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1668 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1667);
// compiled call node returning call1668 (depth = 10)
// compiled member node returning call1668 (depth = 9)
  partcv[0] = 0;
  Object call1669 = callmethod(call1668, "new",
    1, partcv, params);
  gc_frame_end(callframe1666);
// compiled call node returning call1669 (depth = 8)
// compiled member node returning call1669 (depth = 7)
  *var_suggestion = call1669;
  if (call1669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1670 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1671 == NULL) {
    strlit1671 = alloc_String("}");
    gc_root(strlit1671);
  }
// compiled string node returning strlit1671 (depth = 7)
  gc_frame_newslot(strlit1671);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1671;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1672 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1670);
// compiled call node returning call1672 (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1673 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1674 == NULL) {
    strlit1674 = alloc_String("a block must end with a '}'.");
    gc_root(strlit1674);
  }
// compiled string node returning strlit1674 (depth = 7)
  gc_frame_newslot(strlit1674);
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1676 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1675);
// compiled call node returning call1676 (depth = 8)
// compiled member node returning call1676 (depth = 7)
  gc_frame_newslot(call1676);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1678 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1677);
// compiled call node returning call1678 (depth = 8)
// compiled member node returning call1678 (depth = 7)
  gc_frame_newslot(call1678);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1674;
  params[1] = call1676;
  params[2] = call1678;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1679 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1673);
// compiled call node returning call1679 (depth = 6)
    gc_frame_newslot(call1679);
    if1656 = call1679;
  } else {
  }
// compiled if node returning if1656 (depth = 5)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1681 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1680);
// compiled call node returning call1681 (depth = 7)
// compiled member node returning call1681 (depth = 6)
  *var_tmp = call1681;
  if (call1681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1683 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1684 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1683);
// compiled call node returning call1684 (depth = 5)
  gc_frame_end(frame);
  return call1684;
}
Object meth_parser_block1197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_braceIsType = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  Object *var_util = getfromclosure(closure, 9);
  Object *var_ast = getfromclosure(closure, 10);
  Object *var_minIndentLevel = getfromclosure(closure, 11);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for block (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for block");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_expr1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "expr1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1199 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1200 == NULL) {
    strlit1200 = alloc_String("lbrace");
    gc_root(strlit1200);
  }
// compiled string node returning strlit1200 (depth = 4)
  gc_frame_newslot(strlit1200);
// call case 4: self request
  params[0] = strlit1200;
  partcv[0] = 1;
  Object call1201 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1199);
// compiled call node returning call1201 (depth = 3)
  Object if1198 = done;
  if (istrue(call1201)) {
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1202 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1203 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1202);
// compiled call node returning call1203 (depth = 4)
// compiled member node returning call1203 (depth = 3)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1205 = alloc_Float64(2);
// compiled num node returning num1205 (depth = 5)
  int op_slot_right_1204 = gc_frame_newslot(num1205);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1204 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1205;
  partcv[0] = 1;
  Object sum1207 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1207 (depth = 4)
  *var_minInd = sum1207;
  if (sum1207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_expr1 = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1208 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1208 (depth = 4)
  *var_params = array1208;
  if (array1208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array1209 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1209 (depth = 4)
  *var_body = array1209;
  if (array1209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1210 = alloc_Boolean(1);
// compiled identifier node returning bool1210 (depth = 4)
  *var_havearrow = bool1210;
  if (bool1210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1211 = alloc_Boolean(0);
// compiled identifier node returning bool1211 (depth = 4)
  *var_found = bool1211;
  if (bool1211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1212 = alloc_Float64(0);
// compiled num node returning num1212 (depth = 4)
  *var_i = num1212;
  if (num1212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool1213 = alloc_Boolean(0);
// compiled identifier node returning bool1213 (depth = 4)
  *var_isMatchingBlock = bool1213;
  if (bool1213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1217 == NULL) {
    strlit1217 = alloc_String("lparen");
    gc_root(strlit1217);
  }
// compiled string node returning strlit1217 (depth = 5)
  int op_slot_right_1216 = gc_frame_newslot(strlit1217);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1220 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1219);
// compiled call node returning call1220 (depth = 6)
// compiled member node returning call1220 (depth = 5)
  int op_slot_left_1216 = gc_frame_newslot(call1220);
  params[0] = strlit1217;
  partcv[0] = 1;
  Object opresult1221 = callmethod(call1220, "==", 1, partcv, params);
// compiled op node returning opresult1221 (depth = 4)
  Object if1215 = done;
  if (istrue(opresult1221)) {
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1222 = alloc_Boolean(1);
// compiled identifier node returning bool1222 (depth = 5)
  *var_isMatchingBlock = bool1222;
  if (bool1222 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1215 = done;
  } else {
  }
// compiled if node returning if1215 (depth = 3)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1224 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1225 = alloc_Block(NULL, NULL, "parser", 441);
  gc_frame_newslot(block1225);
// method "_apply"
  block_savedest(block1225);
  Object closure1226 = createclosure(2, "_apply");
  setclosureframe(closure1226, stackframe);
  addtoclosure(closure1226, var_blocksOK);
  addtoclosure(closure1226, selfslot);
  struct UserObject *uo1226 = (struct UserObject*)block1225;
  uo1226->data[0] = (Object)closure1226;
  Method *meth_meth_parser__apply1226 = addmethod2pos(block1225, "_apply", &meth_parser__apply1226, 0);
  int argcv_meth_parser__apply1226[] = {0};
  meth_meth_parser__apply1226->type = alloc_MethodType(1, argcv_meth_parser__apply1226);
  meth_meth_parser__apply1226->definitionModule = modulename;
  meth_meth_parser__apply1226->definitionLine = 436;
// compiled block node returning block1225 (depth = 4)
  gc_frame_newslot(block1225);
// starting to compile block node (depth = 4)
  Object block1230 = alloc_Block(NULL, NULL, "parser", 441);
  gc_frame_newslot(block1230);
// method "_apply"
  block_savedest(block1230);
  Object closure1231 = createclosure(15, "_apply");
  setclosureframe(closure1231, stackframe);
  addtoclosure(closure1231, var_values);
  addtoclosure(closure1231, var_expr1);
  addtoclosure(closure1231, var_braceIsType);
  addtoclosure(closure1231, var_blocksOK);
  addtoclosure(closure1231, var_errormessages);
  addtoclosure(closure1231, var_sym);
  addtoclosure(closure1231, var_lastToken);
  addtoclosure(closure1231, var_params);
  addtoclosure(closure1231, var_isMatchingBlock);
  addtoclosure(closure1231, var_body);
  addtoclosure(closure1231, var_indentFreePass);
  addtoclosure(closure1231, var_btok);
  addtoclosure(closure1231, var_util);
  addtoclosure(closure1231, var_ast);
  addtoclosure(closure1231, selfslot);
  struct UserObject *uo1231 = (struct UserObject*)block1230;
  uo1231->data[0] = (Object)closure1231;
  Method *meth_meth_parser__apply1231 = addmethod2pos(block1230, "_apply", &meth_parser__apply1231, 0);
  int argcv_meth_parser__apply1231[] = {0};
  meth_meth_parser__apply1231->type = alloc_MethodType(1, argcv_meth_parser__apply1231);
  meth_meth_parser__apply1231->definitionModule = modulename;
  meth_meth_parser__apply1231->definitionLine = 436;
// compiled block node returning block1230 (depth = 4)
  gc_frame_newslot(block1230);
// call case 4: self request
  params[0] = block1225;
  params[1] = block1230;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1622 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1224);
// compiled call node returning call1622 (depth = 3)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1624 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1625 == NULL) {
    strlit1625 = alloc_String("arrow");
    gc_root(strlit1625);
  }
// compiled string node returning strlit1625 (depth = 5)
  gc_frame_newslot(strlit1625);
// call case 4: self request
  params[0] = strlit1625;
  partcv[0] = 1;
  Object call1626 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1624);
// compiled call node returning call1626 (depth = 4)
  Object if1623 = done;
  if (istrue(call1626)) {
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1628 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled call node returning call1628 (depth = 5)
// compiled member node returning call1628 (depth = 4)
    gc_frame_newslot(call1628);
    if1623 = call1628;
  } else {
  }
// compiled if node returning if1623 (depth = 3)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1632 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1631);
// compiled call node returning call1632 (depth = 6)
// compiled member node returning call1632 (depth = 5)
  int op_slot_right_1630 = gc_frame_newslot(call1632);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1635 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1634);
// compiled call node returning call1635 (depth = 6)
// compiled member node returning call1635 (depth = 5)
  int op_slot_left_1630 = gc_frame_newslot(call1635);
  params[0] = call1632;
  partcv[0] = 1;
  Object opresult1636 = callmethod(call1635, "==", 1, partcv, params);
// compiled op node returning opresult1636 (depth = 4)
  Object if1629 = done;
  if (istrue(opresult1636)) {
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1638 = alloc_Float64(1);
// compiled num node returning num1638 (depth = 6)
  int op_slot_right_1637 = gc_frame_newslot(num1638);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1641 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1640);
// compiled call node returning call1641 (depth = 7)
// compiled member node returning call1641 (depth = 6)
  int op_slot_left_1637 = gc_frame_newslot(call1641);
  params[0] = num1638;
  partcv[0] = 1;
  Object diff1642 = callmethod(call1641, "-", 1, partcv, params);
// compiled op node returning diff1642 (depth = 5)
  *var_minIndentLevel = diff1642;
  if (diff1642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1629 = done;
  } else {
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1629 = done;
  }
// compiled if node returning if1629 (depth = 3)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1645 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1646 = alloc_Block(NULL, NULL, "parser", 564);
  gc_frame_newslot(block1646);
// method "_apply"
  block_savedest(block1646);
  Object closure1647 = createclosure(1, "_apply");
  setclosureframe(closure1647, stackframe);
  addtoclosure(closure1647, selfslot);
  struct UserObject *uo1647 = (struct UserObject*)block1646;
  uo1647->data[0] = (Object)closure1647;
  Method *meth_meth_parser__apply1647 = addmethod2pos(block1646, "_apply", &meth_parser__apply1647, 0);
  int argcv_meth_parser__apply1647[] = {0};
  meth_meth_parser__apply1647->type = alloc_MethodType(1, argcv_meth_parser__apply1647);
  meth_meth_parser__apply1647->definitionModule = modulename;
  meth_meth_parser__apply1647->definitionLine = 560;
// compiled block node returning block1646 (depth = 4)
  gc_frame_newslot(block1646);
// starting to compile block node (depth = 4)
  Object block1654 = alloc_Block(NULL, NULL, "parser", 564);
  gc_frame_newslot(block1654);
// method "_apply"
  block_savedest(block1654);
  Object closure1655 = createclosure(7, "_apply");
  setclosureframe(closure1655, stackframe);
  addtoclosure(closure1655, var_errormessages);
  addtoclosure(closure1655, var_lastToken);
  addtoclosure(closure1655, var_sym);
  addtoclosure(closure1655, var_values);
  addtoclosure(closure1655, var_tmp);
  addtoclosure(closure1655, var_body);
  addtoclosure(closure1655, selfslot);
  struct UserObject *uo1655 = (struct UserObject*)block1654;
  uo1655->data[0] = (Object)closure1655;
  Method *meth_meth_parser__apply1655 = addmethod2pos(block1654, "_apply", &meth_parser__apply1655, 0);
  int argcv_meth_parser__apply1655[] = {0};
  meth_meth_parser__apply1655->type = alloc_MethodType(1, argcv_meth_parser__apply1655);
  meth_meth_parser__apply1655->definitionModule = modulename;
  meth_meth_parser__apply1655->definitionLine = 564;
// compiled block node returning block1654 (depth = 4)
  gc_frame_newslot(block1654);
// call case 5: prelude request
  params[0] = block1646;
  params[1] = block1654;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1686 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compiled call node returning call1686 (depth = 3)
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1688 = alloc_Float64(2);
// compiled num node returning num1688 (depth = 5)
  int op_slot_right_1687 = gc_frame_newslot(num1688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  int op_slot_left_1687 = gc_frame_newslot(*var_minInd);
  params[0] = num1688;
  partcv[0] = 1;
  Object diff1690 = callmethod(*var_minInd, "-", 1, partcv, params);
// compiled op node returning diff1690 (depth = 4)
  *var_minIndentLevel = diff1690;
  if (diff1690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1694 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1693);
// compiled call node returning call1694 (depth = 4)
// compiled member node returning call1694 (depth = 3)
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1695 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1697 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1696);
// compiled call node returning call1697 (depth = 5)
// compiled member node returning call1697 (depth = 4)
  gc_frame_newslot(call1697);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1699 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1698);
// compiled call node returning call1699 (depth = 5)
// compiled member node returning call1699 (depth = 4)
  gc_frame_newslot(call1699);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call1697;
  params[1] = call1699;
  partcv[0] = 2;
  Object call1700 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe1695);
// compiled call node returning call1700 (depth = 3)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1701 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call1703 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1702);
// compiled call node returning call1703 (depth = 6)
// compiled member node returning call1703 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1704 = callmethod(call1703, "new",
    1, partcv, params);
  gc_frame_end(callframe1701);
// compiled call node returning call1704 (depth = 4)
  *var_o = call1704;
  if (call1704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_isMatchingBlock (depth = 4)
  Object if1705 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1708 = alloc_Float64(0);
// compiled num node returning num1708 (depth = 6)
  int op_slot_right_1707 = gc_frame_newslot(num1708);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1711 = callmethod(*var_params, "size",
    1, partcv, params);
  gc_frame_end(callframe1710);
// compiled call node returning call1711 (depth = 7)
// compiled member node returning call1711 (depth = 6)
  int op_slot_left_1707 = gc_frame_newslot(call1711);
  params[0] = num1708;
  partcv[0] = 1;
  Object opresult1712 = callmethod(call1711, ">", 1, partcv, params);
// compiled op node returning opresult1712 (depth = 5)
  Object if1706 = done;
  if (istrue(opresult1712)) {
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1713 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1714 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1715 = callmethod(*var_params, "first",
    1, partcv, params);
  gc_frame_end(callframe1714);
// compiled call node returning call1715 (depth = 7)
// compiled member node returning call1715 (depth = 6)
  gc_frame_newslot(call1715);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = call1715;
  partcv[0] = 1;
  Object call1716 = callmethod(*var_o, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1713);
// compiled call node returning call1716 (depth = 5)
    gc_frame_newslot(call1716);
    if1706 = call1716;
  } else {
  }
// compiled if node returning if1706 (depth = 4)
    gc_frame_newslot(if1706);
    if1705 = if1706;
  } else {
  }
// compiled if node returning if1705 (depth = 3)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1717 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1718 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1717);
// compiled call node returning call1718 (depth = 3)
    gc_frame_newslot(call1718);
    if1198 = call1718;
  } else {
  }
// compiled if node returning if1198 (depth = 2)
  gc_frame_end(frame);
  return if1198;
}
Object meth_parser__apply1738(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1740 == NULL) {
    strlit1740 = alloc_String("lbrace");
    gc_root(strlit1740);
  }
// compiled string node returning strlit1740 (depth = 8)
  int op_slot_right_1739 = gc_frame_newslot(strlit1740);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1743 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1742);
// compiled call node returning call1743 (depth = 9)
// compiled member node returning call1743 (depth = 8)
  int op_slot_left_1739 = gc_frame_newslot(call1743);
  params[0] = strlit1740;
  partcv[0] = 1;
  Object opresult1744 = callmethod(call1743, "==", 1, partcv, params);
// compiled op node returning opresult1744 (depth = 7)
  gc_frame_end(frame);
  return opresult1744;
}
Object meth_parser__apply1781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1786 == NULL) {
    strlit1786 = alloc_String("then");
    gc_root(strlit1786);
  }
// compiled string node returning strlit1786 (depth = 11)
  int op_slot_right_1785 = gc_frame_newslot(strlit1786);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1789 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe1788);
// compiled call node returning call1789 (depth = 12)
// compiled member node returning call1789 (depth = 11)
  int op_slot_left_1785 = gc_frame_newslot(call1789);
  params[0] = strlit1786;
  partcv[0] = 1;
  Object opresult1790 = callmethod(call1789, "==", 1, partcv, params);
// compiled op node returning opresult1790 (depth = 10)
  int op_slot_right_1784 = gc_frame_newslot(opresult1790);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1793 == NULL) {
    strlit1793 = alloc_String("identifier");
    gc_root(strlit1793);
  }
// compiled string node returning strlit1793 (depth = 11)
  int op_slot_right_1792 = gc_frame_newslot(strlit1793);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1796 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1795);
// compiled call node returning call1796 (depth = 12)
// compiled member node returning call1796 (depth = 11)
  int op_slot_left_1792 = gc_frame_newslot(call1796);
  params[0] = strlit1793;
  partcv[0] = 1;
  Object opresult1797 = callmethod(call1796, "==", 1, partcv, params);
// compiled op node returning opresult1797 (depth = 10)
  int op_slot_left_1784 = gc_frame_newslot(opresult1797);
  params[0] = opresult1790;
  partcv[0] = 1;
  Object opresult1798 = callmethod(opresult1797, "&&", 1, partcv, params);
// compiled op node returning opresult1798 (depth = 9)
  int op_slot_right_1783 = gc_frame_newslot(opresult1798);
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1802 == NULL) {
    strlit1802 = alloc_String("lbrace");
    gc_root(strlit1802);
  }
// compiled string node returning strlit1802 (depth = 11)
  int op_slot_right_1801 = gc_frame_newslot(strlit1802);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1805 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 12)
// compiled member node returning call1805 (depth = 11)
  int op_slot_left_1801 = gc_frame_newslot(call1805);
  params[0] = strlit1802;
  partcv[0] = 1;
  Object opresult1806 = callmethod(call1805, "==", 1, partcv, params);
// compiled op node returning opresult1806 (depth = 10)
  int op_slot_right_1800 = gc_frame_newslot(opresult1806);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("rbrace");
    gc_root(strlit1810);
  }
// compiled string node returning strlit1810 (depth = 12)
  int op_slot_right_1809 = gc_frame_newslot(strlit1810);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call1813 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1812);
// compiled call node returning call1813 (depth = 13)
// compiled member node returning call1813 (depth = 12)
  int op_slot_left_1809 = gc_frame_newslot(call1813);
  params[0] = strlit1810;
  partcv[0] = 1;
  Object opresult1814 = callmethod(call1813, "==", 1, partcv, params);
// compiled op node returning opresult1814 (depth = 11)
  int op_slot_right_1808 = gc_frame_newslot(opresult1814);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String("rparen");
    gc_root(strlit1817);
  }
// compiled string node returning strlit1817 (depth = 12)
  int op_slot_right_1816 = gc_frame_newslot(strlit1817);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call1820 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1819);
// compiled call node returning call1820 (depth = 13)
// compiled member node returning call1820 (depth = 12)
  int op_slot_left_1816 = gc_frame_newslot(call1820);
  params[0] = strlit1817;
  partcv[0] = 1;
  Object opresult1821 = callmethod(call1820, "==", 1, partcv, params);
// compiled op node returning opresult1821 (depth = 11)
  int op_slot_left_1808 = gc_frame_newslot(opresult1821);
  params[0] = opresult1814;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "||", 1, partcv, params);
// compiled op node returning opresult1822 (depth = 10)
  int op_slot_left_1800 = gc_frame_newslot(opresult1822);
  params[0] = opresult1806;
  partcv[0] = 1;
  Object opresult1823 = callmethod(opresult1822, "||", 1, partcv, params);
// compiled op node returning opresult1823 (depth = 9)
  int op_slot_left_1783 = gc_frame_newslot(opresult1823);
  params[0] = opresult1798;
  partcv[0] = 1;
  Object opresult1824 = callmethod(opresult1823, "||", 1, partcv, params);
// compiled op node returning opresult1824 (depth = 8)
  int op_slot_right_1782 = gc_frame_newslot(opresult1824);
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1827 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1828 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1827);
// compiled call node returning call1828 (depth = 10)
// compiled member node returning call1828 (depth = 9)
  int op_slot_right_1826 = gc_frame_newslot(call1828);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1831 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1830);
// compiled call node returning call1831 (depth = 10)
// compiled member node returning call1831 (depth = 9)
  int op_slot_left_1826 = gc_frame_newslot(call1831);
  params[0] = call1828;
  partcv[0] = 1;
  Object opresult1832 = callmethod(call1831, "==", 1, partcv, params);
// compiled op node returning opresult1832 (depth = 8)
  int op_slot_left_1782 = gc_frame_newslot(opresult1832);
  params[0] = opresult1824;
  partcv[0] = 1;
  Object opresult1833 = callmethod(opresult1832, "&&", 1, partcv, params);
// compiled op node returning opresult1833 (depth = 7)
  gc_frame_end(frame);
  return opresult1833;
}
Object meth_parser__apply1924(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1925 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1926 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1925);
// compiled call node returning call1926 (depth = 8)
  gc_frame_end(frame);
  return call1926;
}
Object meth_parser__apply1936(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1939 == NULL) {
    strlit1939 = alloc_String("rparen");
    gc_root(strlit1939);
  }
// compiled string node returning strlit1939 (depth = 9)
  int op_slot_right_1938 = gc_frame_newslot(strlit1939);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1942 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1941);
// compiled call node returning call1942 (depth = 10)
// compiled member node returning call1942 (depth = 9)
  int op_slot_left_1938 = gc_frame_newslot(call1942);
  params[0] = strlit1939;
  partcv[0] = 1;
  Object opresult1943 = callmethod(call1942, "==", 1, partcv, params);
// compiled op node returning opresult1943 (depth = 8)
  int op_slot_right_1937 = gc_frame_newslot(opresult1943);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call1947 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1946);
// compiled call node returning call1947 (depth = 10)
// compiled member node returning call1947 (depth = 9)
  int op_slot_right_1945 = gc_frame_newslot(call1947);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1950 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1949);
// compiled call node returning call1950 (depth = 10)
// compiled member node returning call1950 (depth = 9)
  int op_slot_left_1945 = gc_frame_newslot(call1950);
  params[0] = call1947;
  partcv[0] = 1;
  Object opresult1951 = callmethod(call1950, "==", 1, partcv, params);
// compiled op node returning opresult1951 (depth = 8)
  int op_slot_left_1937 = gc_frame_newslot(opresult1951);
  params[0] = opresult1943;
  partcv[0] = 1;
  Object opresult1952 = callmethod(opresult1951, "&&", 1, partcv, params);
// compiled op node returning opresult1952 (depth = 7)
  gc_frame_end(frame);
  return opresult1952;
}
Object meth_parser__apply2185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2186 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2187 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2188 == NULL) {
    strlit2188 = alloc_String("rbrace");
    gc_root(strlit2188);
  }
// compiled string node returning strlit2188 (depth = 9)
  gc_frame_newslot(strlit2188);
// call case 4: self request
  params[0] = strlit2188;
  partcv[0] = 1;
  Object call2189 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled call node returning call2189 (depth = 8)
  partcv[0] = 0;
  Object call2190 = callmethod(call2189, "not",
    1, partcv, params);
  gc_frame_end(callframe2186);
// compiled call node returning call2190 (depth = 7)
// compiled member node returning call2190 (depth = 6)
  gc_frame_end(frame);
  return call2190;
}
Object meth_parser__apply2198(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2199 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2200 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2199);
// compiled call node returning call2200 (depth = 12)
// compiled member node returning call2200 (depth = 11)
  gc_frame_end(frame);
  return call2200;
}
Object meth_parser__apply2193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2195 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2196 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2197 = alloc_Block(NULL, NULL, "parser", 717);
  gc_frame_newslot(block2197);
// method "_apply"
  block_savedest(block2197);
  Object closure2198 = createclosure(1, "_apply");
  setclosureframe(closure2198, stackframe);
  addtoclosure(closure2198, selfslot);
  struct UserObject *uo2198 = (struct UserObject*)block2197;
  uo2198->data[0] = (Object)closure2198;
  Method *meth_meth_parser__apply2198 = addmethod2pos(block2197, "_apply", &meth_parser__apply2198, 0);
  int argcv_meth_parser__apply2198[] = {0};
  meth_meth_parser__apply2198->type = alloc_MethodType(1, argcv_meth_parser__apply2198);
  meth_meth_parser__apply2198->definitionModule = modulename;
  meth_meth_parser__apply2198->definitionLine = 717;
// compiled block node returning block2197 (depth = 10)
  gc_frame_newslot(block2197);
// call case 4: self request
  params[0] = block2197;
  partcv[0] = 1;
  Object call2202 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2202 (depth = 9)
  partcv[0] = 0;
  Object call2203 = callmethod(call2202, "not",
    1, partcv, params);
  gc_frame_end(callframe2195);
// compiled call node returning call2203 (depth = 8)
// compiled member node returning call2203 (depth = 7)
  Object if2194 = done;
  if (istrue(call2203)) {
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2204 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2206 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2205);
// compiled call node returning call2206 (depth = 11)
// compiled member node returning call2206 (depth = 10)
  partcv[0] = 0;
  Object call2207 = callmethod(call2206, "new",
    1, partcv, params);
  gc_frame_end(callframe2204);
// compiled call node returning call2207 (depth = 9)
// compiled member node returning call2207 (depth = 8)
  *var_suggestion = call2207;
  if (call2207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2208 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2209 = alloc_Boolean(0);
// compiled identifier node returning bool2209 (depth = 9)
  gc_frame_newslot(bool2209);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2209;
  partcv[0] = 2;
  Object call2210 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2208);
// compiled call node returning call2210 (depth = 8)
  *var_closingBrace = call2210;
  if (call2210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2212 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2214 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2213);
// compiled call node returning call2214 (depth = 11)
// compiled member node returning call2214 (depth = 10)
  partcv[0] = 0;
  Object call2215 = callmethod(call2214, "not",
    1, partcv, params);
  gc_frame_end(callframe2212);
// compiled call node returning call2215 (depth = 9)
// compiled member node returning call2215 (depth = 8)
  Object if2211 = done;
  if (istrue(call2215)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2217 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2220 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2219);
// compiled call node returning call2220 (depth = 11)
// compiled member node returning call2220 (depth = 10)
  int op_slot_left_2217 = gc_frame_newslot(call2220);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2221 = callmethod(call2220, "==", 1, partcv, params);
// compiled op node returning opresult2221 (depth = 9)
  Object if2216 = done;
  if (istrue(opresult2221)) {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2222 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String("}");
    gc_root(strlit2223);
  }
// compiled string node returning strlit2223 (depth = 10)
  gc_frame_newslot(strlit2223);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2223;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2224 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2222);
// compiled call node returning call2224 (depth = 9)
    gc_frame_newslot(call2224);
    if2216 = call2224;
  } else {
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2225 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2227 = alloc_Float64(0.1);
// compiled num node returning num2227 (depth = 11)
  int op_slot_right_2226 = gc_frame_newslot(num2227);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2229 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2231 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2230);
// compiled call node returning call2231 (depth = 14)
// compiled member node returning call2231 (depth = 13)
  partcv[0] = 0;
  Object call2232 = callmethod(call2231, "line",
    1, partcv, params);
  gc_frame_end(callframe2229);
// compiled call node returning call2232 (depth = 12)
// compiled member node returning call2232 (depth = 11)
  int op_slot_left_2226 = gc_frame_newslot(call2232);
  params[0] = num2227;
  partcv[0] = 1;
  Object sum2233 = callmethod(call2232, "+", 1, partcv, params);
// compiled op node returning sum2233 (depth = 10)
  gc_frame_newslot(sum2233);
// starting to compile string node (depth = 10)
  if (strlit2234 == NULL) {
    strlit2234 = alloc_String("}");
    gc_root(strlit2234);
  }
// compiled string node returning strlit2234 (depth = 10)
  gc_frame_newslot(strlit2234);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2233;
  params[1] = strlit2234;
  partcv[0] = 2;
  Object call2235 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2225);
// compiled call node returning call2235 (depth = 9)
    gc_frame_newslot(call2235);
    if2216 = call2235;
  }
// compiled if node returning if2216 (depth = 8)
    gc_frame_newslot(if2216);
    if2211 = if2216;
  } else {
  }
// compiled if node returning if2211 (depth = 7)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2236 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2237 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2236);
// compiled call node returning call2237 (depth = 7)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2238 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2239 == NULL) {
    strlit2239 = alloc_String("an if statement must end with a '}'.");
    gc_root(strlit2239);
  }
// compiled string node returning strlit2239 (depth = 8)
  gc_frame_newslot(strlit2239);
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2241 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2240);
// compiled call node returning call2241 (depth = 9)
// compiled member node returning call2241 (depth = 8)
  gc_frame_newslot(call2241);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2243 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2242);
// compiled call node returning call2243 (depth = 9)
// compiled member node returning call2243 (depth = 8)
  gc_frame_newslot(call2243);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2239;
  params[1] = call2241;
  params[2] = call2243;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2244 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2238);
// compiled call node returning call2244 (depth = 7)
    gc_frame_newslot(call2244);
    if2194 = call2244;
  } else {
  }
// compiled if node returning if2194 (depth = 6)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2246 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2245);
// compiled call node returning call2246 (depth = 8)
// compiled member node returning call2246 (depth = 7)
  *var_v = call2246;
  if (call2246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2248 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2249 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe2248);
// compiled call node returning call2249 (depth = 6)
  gc_frame_end(frame);
  return call2249;
}
Object meth_parser__apply2256(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2259 == NULL) {
    strlit2259 = alloc_String("elseif");
    gc_root(strlit2259);
  }
// compiled string node returning strlit2259 (depth = 8)
  int op_slot_right_2258 = gc_frame_newslot(strlit2259);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2262 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2261);
// compiled call node returning call2262 (depth = 9)
// compiled member node returning call2262 (depth = 8)
  int op_slot_left_2258 = gc_frame_newslot(call2262);
  params[0] = strlit2259;
  partcv[0] = 1;
  Object opresult2263 = callmethod(call2262, "==", 1, partcv, params);
// compiled op node returning opresult2263 (depth = 7)
  int op_slot_right_2257 = gc_frame_newslot(opresult2263);
// starting to compile call node (depth = 7)
  int callframe2265 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2266 == NULL) {
    strlit2266 = alloc_String("identifier");
    gc_root(strlit2266);
  }
// compiled string node returning strlit2266 (depth = 8)
  gc_frame_newslot(strlit2266);
// call case 4: self request
  params[0] = strlit2266;
  partcv[0] = 1;
  Object call2267 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2265);
// compiled call node returning call2267 (depth = 7)
  int op_slot_left_2257 = gc_frame_newslot(call2267);
  params[0] = opresult2263;
  partcv[0] = 1;
  Object opresult2268 = callmethod(call2267, "&&", 1, partcv, params);
// compiled op node returning opresult2268 (depth = 6)
  gc_frame_end(frame);
  return opresult2268;
}
Object meth_parser__apply2278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("lbrace");
    gc_root(strlit2280);
  }
// compiled string node returning strlit2280 (depth = 11)
  int op_slot_right_2279 = gc_frame_newslot(strlit2280);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call2283 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2282);
// compiled call node returning call2283 (depth = 12)
// compiled member node returning call2283 (depth = 11)
  int op_slot_left_2279 = gc_frame_newslot(call2283);
  params[0] = strlit2280;
  partcv[0] = 1;
  Object opresult2284 = callmethod(call2283, "==", 1, partcv, params);
// compiled op node returning opresult2284 (depth = 10)
  gc_frame_end(frame);
  return opresult2284;
}
Object meth_parser__apply2321(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2326 == NULL) {
    strlit2326 = alloc_String("then");
    gc_root(strlit2326);
  }
// compiled string node returning strlit2326 (depth = 14)
  int op_slot_right_2325 = gc_frame_newslot(strlit2326);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2329 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe2328);
// compiled call node returning call2329 (depth = 15)
// compiled member node returning call2329 (depth = 14)
  int op_slot_left_2325 = gc_frame_newslot(call2329);
  params[0] = strlit2326;
  partcv[0] = 1;
  Object opresult2330 = callmethod(call2329, "==", 1, partcv, params);
// compiled op node returning opresult2330 (depth = 13)
  int op_slot_right_2324 = gc_frame_newslot(opresult2330);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2333 == NULL) {
    strlit2333 = alloc_String("identifier");
    gc_root(strlit2333);
  }
// compiled string node returning strlit2333 (depth = 14)
  int op_slot_right_2332 = gc_frame_newslot(strlit2333);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2336 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2335);
// compiled call node returning call2336 (depth = 15)
// compiled member node returning call2336 (depth = 14)
  int op_slot_left_2332 = gc_frame_newslot(call2336);
  params[0] = strlit2333;
  partcv[0] = 1;
  Object opresult2337 = callmethod(call2336, "==", 1, partcv, params);
// compiled op node returning opresult2337 (depth = 13)
  int op_slot_left_2324 = gc_frame_newslot(opresult2337);
  params[0] = opresult2330;
  partcv[0] = 1;
  Object opresult2338 = callmethod(opresult2337, "&&", 1, partcv, params);
// compiled op node returning opresult2338 (depth = 12)
  int op_slot_right_2323 = gc_frame_newslot(opresult2338);
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2342 == NULL) {
    strlit2342 = alloc_String("lbrace");
    gc_root(strlit2342);
  }
// compiled string node returning strlit2342 (depth = 14)
  int op_slot_right_2341 = gc_frame_newslot(strlit2342);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2345 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2344);
// compiled call node returning call2345 (depth = 15)
// compiled member node returning call2345 (depth = 14)
  int op_slot_left_2341 = gc_frame_newslot(call2345);
  params[0] = strlit2342;
  partcv[0] = 1;
  Object opresult2346 = callmethod(call2345, "==", 1, partcv, params);
// compiled op node returning opresult2346 (depth = 13)
  int op_slot_right_2340 = gc_frame_newslot(opresult2346);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2350 == NULL) {
    strlit2350 = alloc_String("rbrace");
    gc_root(strlit2350);
  }
// compiled string node returning strlit2350 (depth = 15)
  int op_slot_right_2349 = gc_frame_newslot(strlit2350);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2353 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2352);
// compiled call node returning call2353 (depth = 16)
// compiled member node returning call2353 (depth = 15)
  int op_slot_left_2349 = gc_frame_newslot(call2353);
  params[0] = strlit2350;
  partcv[0] = 1;
  Object opresult2354 = callmethod(call2353, "==", 1, partcv, params);
// compiled op node returning opresult2354 (depth = 14)
  int op_slot_right_2348 = gc_frame_newslot(opresult2354);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2357 == NULL) {
    strlit2357 = alloc_String("rparen");
    gc_root(strlit2357);
  }
// compiled string node returning strlit2357 (depth = 15)
  int op_slot_right_2356 = gc_frame_newslot(strlit2357);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2360 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2359);
// compiled call node returning call2360 (depth = 16)
// compiled member node returning call2360 (depth = 15)
  int op_slot_left_2356 = gc_frame_newslot(call2360);
  params[0] = strlit2357;
  partcv[0] = 1;
  Object opresult2361 = callmethod(call2360, "==", 1, partcv, params);
// compiled op node returning opresult2361 (depth = 14)
  int op_slot_left_2348 = gc_frame_newslot(opresult2361);
  params[0] = opresult2354;
  partcv[0] = 1;
  Object opresult2362 = callmethod(opresult2361, "||", 1, partcv, params);
// compiled op node returning opresult2362 (depth = 13)
  int op_slot_left_2340 = gc_frame_newslot(opresult2362);
  params[0] = opresult2346;
  partcv[0] = 1;
  Object opresult2363 = callmethod(opresult2362, "||", 1, partcv, params);
// compiled op node returning opresult2363 (depth = 12)
  int op_slot_left_2323 = gc_frame_newslot(opresult2363);
  params[0] = opresult2338;
  partcv[0] = 1;
  Object opresult2364 = callmethod(opresult2363, "||", 1, partcv, params);
// compiled op node returning opresult2364 (depth = 11)
  int op_slot_right_2322 = gc_frame_newslot(opresult2364);
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2367 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_statementToken (depth = 14)
  partcv[0] = 0;
  Object call2368 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2367);
// compiled call node returning call2368 (depth = 13)
// compiled member node returning call2368 (depth = 12)
  int op_slot_right_2366 = gc_frame_newslot(call2368);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2371 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2370);
// compiled call node returning call2371 (depth = 13)
// compiled member node returning call2371 (depth = 12)
  int op_slot_left_2366 = gc_frame_newslot(call2371);
  params[0] = call2368;
  partcv[0] = 1;
  Object opresult2372 = callmethod(call2371, "==", 1, partcv, params);
// compiled op node returning opresult2372 (depth = 11)
  int op_slot_left_2322 = gc_frame_newslot(opresult2372);
  params[0] = opresult2364;
  partcv[0] = 1;
  Object opresult2373 = callmethod(opresult2372, "&&", 1, partcv, params);
// compiled op node returning opresult2373 (depth = 10)
  gc_frame_end(frame);
  return opresult2373;
}
Object meth_parser__apply2464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe2465 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2466 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2465);
// compiled call node returning call2466 (depth = 11)
  gc_frame_end(frame);
  return call2466;
}
Object meth_parser__apply2476(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2480 == NULL) {
    strlit2480 = alloc_String("rbrace");
    gc_root(strlit2480);
  }
// compiled string node returning strlit2480 (depth = 13)
  int op_slot_right_2479 = gc_frame_newslot(strlit2480);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2483 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2482);
// compiled call node returning call2483 (depth = 14)
// compiled member node returning call2483 (depth = 13)
  int op_slot_left_2479 = gc_frame_newslot(call2483);
  params[0] = strlit2480;
  partcv[0] = 1;
  Object opresult2484 = callmethod(call2483, "==", 1, partcv, params);
// compiled op node returning opresult2484 (depth = 12)
  int op_slot_right_2478 = gc_frame_newslot(opresult2484);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2487 == NULL) {
    strlit2487 = alloc_String("rparen");
    gc_root(strlit2487);
  }
// compiled string node returning strlit2487 (depth = 13)
  int op_slot_right_2486 = gc_frame_newslot(strlit2487);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2490 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2489);
// compiled call node returning call2490 (depth = 14)
// compiled member node returning call2490 (depth = 13)
  int op_slot_left_2486 = gc_frame_newslot(call2490);
  params[0] = strlit2487;
  partcv[0] = 1;
  Object opresult2491 = callmethod(call2490, "==", 1, partcv, params);
// compiled op node returning opresult2491 (depth = 12)
  int op_slot_left_2478 = gc_frame_newslot(opresult2491);
  params[0] = opresult2484;
  partcv[0] = 1;
  Object opresult2492 = callmethod(opresult2491, "||", 1, partcv, params);
// compiled op node returning opresult2492 (depth = 11)
  int op_slot_right_2477 = gc_frame_newslot(opresult2492);
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lastToken (depth = 14)
  partcv[0] = 0;
  Object call2496 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2495);
// compiled call node returning call2496 (depth = 13)
// compiled member node returning call2496 (depth = 12)
  int op_slot_right_2494 = gc_frame_newslot(call2496);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2499 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2498);
// compiled call node returning call2499 (depth = 13)
// compiled member node returning call2499 (depth = 12)
  int op_slot_left_2494 = gc_frame_newslot(call2499);
  params[0] = call2496;
  partcv[0] = 1;
  Object opresult2500 = callmethod(call2499, "==", 1, partcv, params);
// compiled op node returning opresult2500 (depth = 11)
  int op_slot_left_2477 = gc_frame_newslot(opresult2500);
  params[0] = opresult2492;
  partcv[0] = 1;
  Object opresult2501 = callmethod(opresult2500, "&&", 1, partcv, params);
// compiled op node returning opresult2501 (depth = 10)
  gc_frame_end(frame);
  return opresult2501;
}
Object meth_parser__apply2811(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2812 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2813 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2814 == NULL) {
    strlit2814 = alloc_String("rbrace");
    gc_root(strlit2814);
  }
// compiled string node returning strlit2814 (depth = 11)
  gc_frame_newslot(strlit2814);
// call case 4: self request
  params[0] = strlit2814;
  partcv[0] = 1;
  Object call2815 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2813);
// compiled call node returning call2815 (depth = 10)
  partcv[0] = 0;
  Object call2816 = callmethod(call2815, "not",
    1, partcv, params);
  gc_frame_end(callframe2812);
// compiled call node returning call2816 (depth = 9)
// compiled member node returning call2816 (depth = 8)
  gc_frame_end(frame);
  return call2816;
}
Object meth_parser__apply2824(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2825 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2826 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2825);
// compiled call node returning call2826 (depth = 14)
// compiled member node returning call2826 (depth = 13)
  gc_frame_end(frame);
  return call2826;
}
Object meth_parser__apply2819(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2821 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2822 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block2823 = alloc_Block(NULL, NULL, "parser", 879);
  gc_frame_newslot(block2823);
// method "_apply"
  block_savedest(block2823);
  Object closure2824 = createclosure(1, "_apply");
  setclosureframe(closure2824, stackframe);
  addtoclosure(closure2824, selfslot);
  struct UserObject *uo2824 = (struct UserObject*)block2823;
  uo2824->data[0] = (Object)closure2824;
  Method *meth_meth_parser__apply2824 = addmethod2pos(block2823, "_apply", &meth_parser__apply2824, 0);
  int argcv_meth_parser__apply2824[] = {0};
  meth_meth_parser__apply2824->type = alloc_MethodType(1, argcv_meth_parser__apply2824);
  meth_meth_parser__apply2824->definitionModule = modulename;
  meth_meth_parser__apply2824->definitionLine = 879;
// compiled block node returning block2823 (depth = 12)
  gc_frame_newslot(block2823);
// call case 4: self request
  params[0] = block2823;
  partcv[0] = 1;
  Object call2828 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2822);
// compiled call node returning call2828 (depth = 11)
  partcv[0] = 0;
  Object call2829 = callmethod(call2828, "not",
    1, partcv, params);
  gc_frame_end(callframe2821);
// compiled call node returning call2829 (depth = 10)
// compiled member node returning call2829 (depth = 9)
  Object if2820 = done;
  if (istrue(call2829)) {
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2830 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2832 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2831);
// compiled call node returning call2832 (depth = 13)
// compiled member node returning call2832 (depth = 12)
  partcv[0] = 0;
  Object call2833 = callmethod(call2832, "new",
    1, partcv, params);
  gc_frame_end(callframe2830);
// compiled call node returning call2833 (depth = 11)
// compiled member node returning call2833 (depth = 10)
  *var_suggestion = call2833;
  if (call2833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2834 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2835 = alloc_Boolean(0);
// compiled identifier node returning bool2835 (depth = 11)
  gc_frame_newslot(bool2835);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2835;
  partcv[0] = 2;
  Object call2836 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2834);
// compiled call node returning call2836 (depth = 10)
  *var_closingBrace = call2836;
  if (call2836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2838 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2840 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2839);
// compiled call node returning call2840 (depth = 13)
// compiled member node returning call2840 (depth = 12)
  partcv[0] = 0;
  Object call2841 = callmethod(call2840, "not",
    1, partcv, params);
  gc_frame_end(callframe2838);
// compiled call node returning call2841 (depth = 11)
// compiled member node returning call2841 (depth = 10)
  Object if2837 = done;
  if (istrue(call2841)) {
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2843 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2846 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2845);
// compiled call node returning call2846 (depth = 13)
// compiled member node returning call2846 (depth = 12)
  int op_slot_left_2843 = gc_frame_newslot(call2846);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2847 = callmethod(call2846, "==", 1, partcv, params);
// compiled op node returning opresult2847 (depth = 11)
  Object if2842 = done;
  if (istrue(opresult2847)) {
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2848 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2849 == NULL) {
    strlit2849 = alloc_String("}");
    gc_root(strlit2849);
  }
// compiled string node returning strlit2849 (depth = 12)
  gc_frame_newslot(strlit2849);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2849;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2850 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2848);
// compiled call node returning call2850 (depth = 11)
    gc_frame_newslot(call2850);
    if2842 = call2850;
  } else {
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2851 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2853 = alloc_Float64(0.1);
// compiled num node returning num2853 (depth = 13)
  int op_slot_right_2852 = gc_frame_newslot(num2853);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2855 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_closingBrace (depth = 17)
  partcv[0] = 0;
  Object call2857 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2856);
// compiled call node returning call2857 (depth = 16)
// compiled member node returning call2857 (depth = 15)
  partcv[0] = 0;
  Object call2858 = callmethod(call2857, "line",
    1, partcv, params);
  gc_frame_end(callframe2855);
// compiled call node returning call2858 (depth = 14)
// compiled member node returning call2858 (depth = 13)
  int op_slot_left_2852 = gc_frame_newslot(call2858);
  params[0] = num2853;
  partcv[0] = 1;
  Object sum2859 = callmethod(call2858, "+", 1, partcv, params);
// compiled op node returning sum2859 (depth = 12)
  gc_frame_newslot(sum2859);
// starting to compile string node (depth = 12)
  if (strlit2860 == NULL) {
    strlit2860 = alloc_String("}");
    gc_root(strlit2860);
  }
// compiled string node returning strlit2860 (depth = 12)
  gc_frame_newslot(strlit2860);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2859;
  params[1] = strlit2860;
  partcv[0] = 2;
  Object call2861 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2851);
// compiled call node returning call2861 (depth = 11)
    gc_frame_newslot(call2861);
    if2842 = call2861;
  }
// compiled if node returning if2842 (depth = 10)
    gc_frame_newslot(if2842);
    if2837 = if2842;
  } else {
  }
// compiled if node returning if2837 (depth = 9)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2862 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2863 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2862);
// compiled call node returning call2863 (depth = 9)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2864 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2865 == NULL) {
    strlit2865 = alloc_String("an elseif statement must end with a '}'.");
    gc_root(strlit2865);
  }
// compiled string node returning strlit2865 (depth = 10)
  gc_frame_newslot(strlit2865);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2867 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2866);
// compiled call node returning call2867 (depth = 11)
// compiled member node returning call2867 (depth = 10)
  gc_frame_newslot(call2867);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2869 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2868);
// compiled call node returning call2869 (depth = 11)
// compiled member node returning call2869 (depth = 10)
  gc_frame_newslot(call2869);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2865;
  params[1] = call2867;
  params[2] = call2869;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2870 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2864);
// compiled call node returning call2870 (depth = 9)
    gc_frame_newslot(call2870);
    if2820 = call2870;
  } else {
  }
// compiled if node returning if2820 (depth = 8)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call2872 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2871);
// compiled call node returning call2872 (depth = 10)
// compiled member node returning call2872 (depth = 9)
  *var_v = call2872;
  if (call2872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2874 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2875 = callmethod(*var_ebody, "push",
    1, partcv, params);
  gc_frame_end(callframe2874);
// compiled call node returning call2875 (depth = 8)
  gc_frame_end(frame);
  return call2875;
}
Object meth_parser__apply2271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_elopener = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "elopener");
  Object *var_elcloser = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "elcloser");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "closingBrace");
// starting to compile bind node (depth = 6)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2273 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2274 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2273);
// compiled call node returning call2274 (depth = 7)
// compiled member node returning call2274 (depth = 6)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block2277 = alloc_Block(NULL, NULL, "parser", 745);
  gc_frame_newslot(block2277);
// method "_apply"
  block_savedest(block2277);
  Object closure2278 = createclosure(2, "_apply");
  setclosureframe(closure2278, stackframe);
  addtoclosure(closure2278, var_sym);
  addtoclosure(closure2278, selfslot);
  struct UserObject *uo2278 = (struct UserObject*)block2277;
  uo2278->data[0] = (Object)closure2278;
  Method *meth_meth_parser__apply2278 = addmethod2pos(block2277, "_apply", &meth_parser__apply2278, 0);
  int argcv_meth_parser__apply2278[] = {0};
  meth_meth_parser__apply2278->type = alloc_MethodType(1, argcv_meth_parser__apply2278);
  meth_meth_parser__apply2278->definitionModule = modulename;
  meth_meth_parser__apply2278->definitionLine = 744;
// compiled block node returning block2277 (depth = 9)
  int op_slot_right_2276 = gc_frame_newslot(block2277);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2288 == NULL) {
    strlit2288 = alloc_String("lparen");
    gc_root(strlit2288);
  }
// compiled string node returning strlit2288 (depth = 10)
  int op_slot_right_2287 = gc_frame_newslot(strlit2288);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2291 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2290);
// compiled call node returning call2291 (depth = 11)
// compiled member node returning call2291 (depth = 10)
  int op_slot_left_2287 = gc_frame_newslot(call2291);
  params[0] = strlit2288;
  partcv[0] = 1;
  Object opresult2292 = callmethod(call2291, "==", 1, partcv, params);
// compiled op node returning opresult2292 (depth = 9)
  int op_slot_left_2276 = gc_frame_newslot(opresult2292);
  params[0] = block2277;
  partcv[0] = 1;
  Object opresult2293 = callmethod(opresult2292, "||", 1, partcv, params);
// compiled op node returning opresult2293 (depth = 8)
  Object if2275 = done;
struct StackFrameObject *iftmpstackframe2275 = stackframe;
  if (istrue(opresult2293)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2275);
gc_frame_newslot((Object)stackframe);
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2294 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2295 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2294);
// compiled call node returning call2295 (depth = 9)
// compiled member node returning call2295 (depth = 8)
    gc_frame_newslot(call2295);
    if2275 = call2295;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2275);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2296 == NULL) {
    strlit2296 = alloc_String("-missing-");
    gc_root(strlit2296);
  }
// compiled string node returning strlit2296 (depth = 8)
    gc_frame_newslot(strlit2296);
    if2275 = strlit2296;
  }
stackframe = iftmpstackframe2275;
// compiled if node returning if2275 (depth = 7)
  *var_elopener = if2275;
  if (if2275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2299 == NULL) {
    strlit2299 = alloc_String("(");
    gc_root(strlit2299);
  }
// compiled string node returning strlit2299 (depth = 9)
  int op_slot_right_2298 = gc_frame_newslot(strlit2299);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_elopener (depth = 9)
  int op_slot_left_2298 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2299;
  partcv[0] = 1;
  Object opresult2301 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2301 (depth = 8)
  Object if2297 = done;
struct StackFrameObject *iftmpstackframe2297 = stackframe;
  if (istrue(opresult2301)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2297);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2302 == NULL) {
    strlit2302 = alloc_String(")");
    gc_root(strlit2302);
  }
// compiled string node returning strlit2302 (depth = 8)
    gc_frame_newslot(strlit2302);
    if2297 = strlit2302;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2297);
  gc_frame_newslot((Object)stackframe);
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2305 == NULL) {
    strlit2305 = alloc_String("{");
    gc_root(strlit2305);
  }
// compiled string node returning strlit2305 (depth = 10)
  int op_slot_right_2304 = gc_frame_newslot(strlit2305);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_elopener (depth = 10)
  int op_slot_left_2304 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2305;
  partcv[0] = 1;
  Object opresult2307 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2307 (depth = 9)
  Object if2303 = done;
  if (istrue(opresult2307)) {
// starting to compile string node (depth = 9)
  if (strlit2308 == NULL) {
    strlit2308 = alloc_String("}");
    gc_root(strlit2308);
  }
// compiled string node returning strlit2308 (depth = 9)
    gc_frame_newslot(strlit2308);
    if2303 = strlit2308;
  } else {
// starting to compile string node (depth = 9)
  if (strlit2309 == NULL) {
    strlit2309 = alloc_String("-nothing-");
    gc_root(strlit2309);
  }
// compiled string node returning strlit2309 (depth = 9)
    gc_frame_newslot(strlit2309);
    if2303 = strlit2309;
  }
// compiled if node returning if2303 (depth = 8)
    gc_frame_newslot(if2303);
    if2297 = if2303;
  }
stackframe = iftmpstackframe2297;
// compiled if node returning if2297 (depth = 7)
  *var_elcloser = if2297;
  if (if2297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2312 == NULL) {
    strlit2312 = alloc_String("-missing-");
    gc_root(strlit2312);
  }
// compiled string node returning strlit2312 (depth = 8)
  int op_slot_right_2311 = gc_frame_newslot(strlit2312);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elopener (depth = 8)
  int op_slot_left_2311 = gc_frame_newslot(*var_elopener);
  params[0] = strlit2312;
  partcv[0] = 1;
  Object opresult2314 = callmethod(*var_elopener, "==", 1, partcv, params);
// compiled op node returning opresult2314 (depth = 7)
  Object if2310 = done;
  if (istrue(opresult2314)) {
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2315 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2316 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2317 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2316);
// compiled call node returning call2317 (depth = 11)
// compiled member node returning call2317 (depth = 10)
  partcv[0] = 0;
  Object call2318 = callmethod(call2317, "new",
    1, partcv, params);
  gc_frame_end(callframe2315);
// compiled call node returning call2318 (depth = 9)
// compiled member node returning call2318 (depth = 8)
  *var_suggestion = call2318;
  if (call2318 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2319 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2320 = alloc_Block(NULL, NULL, "parser", 752);
  gc_frame_newslot(block2320);
// method "_apply"
  block_savedest(block2320);
  Object closure2321 = createclosure(2, "_apply");
  setclosureframe(closure2321, stackframe);
  addtoclosure(closure2321, var_statementToken);
  addtoclosure(closure2321, selfslot);
  struct UserObject *uo2321 = (struct UserObject*)block2320;
  uo2321->data[0] = (Object)closure2321;
  Method *meth_meth_parser__apply2321 = addmethod2pos(block2320, "_apply", &meth_parser__apply2321, 0);
  int argcv_meth_parser__apply2321[] = {1};
  meth_meth_parser__apply2321->type = alloc_MethodType(1, argcv_meth_parser__apply2321);
  meth_meth_parser__apply2321->definitionModule = modulename;
  meth_meth_parser__apply2321->definitionLine = 750;
// compiled block node returning block2320 (depth = 9)
  gc_frame_newslot(block2320);
// call case 4: self request
  params[0] = block2320;
  partcv[0] = 1;
  Object call2375 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2319);
// compiled call node returning call2375 (depth = 8)
  *var_nextTok = call2375;
  if (call2375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2377 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2379 = alloc_Boolean(0);
// compiled identifier node returning bool2379 (depth = 9)
  int op_slot_left_2377 = gc_frame_newslot(bool2379);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2380 = callmethod(bool2379, "==", 1, partcv, params);
// compiled op node returning opresult2380 (depth = 8)
  Object if2376 = done;
  if (istrue(opresult2380)) {
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2381 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2382 == NULL) {
    strlit2382 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2382);
  }
// compiled string node returning strlit2382 (depth = 9)
  gc_frame_newslot(strlit2382);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2382;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2383 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2381);
// compiled call node returning call2383 (depth = 8)
    gc_frame_newslot(call2383);
    if2376 = call2383;
  } else {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2386 == NULL) {
    strlit2386 = alloc_String("rparen");
    gc_root(strlit2386);
  }
// compiled string node returning strlit2386 (depth = 10)
  int op_slot_right_2385 = gc_frame_newslot(strlit2386);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2388 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2389 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2388);
// compiled call node returning call2389 (depth = 11)
// compiled member node returning call2389 (depth = 10)
  int op_slot_left_2385 = gc_frame_newslot(call2389);
  params[0] = strlit2386;
  partcv[0] = 1;
  Object opresult2390 = callmethod(call2389, "==", 1, partcv, params);
// compiled op node returning opresult2390 (depth = 9)
  Object if2384 = done;
  if (istrue(opresult2390)) {
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2392 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2392 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2394 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2394 (depth = 10)
  Object if2391 = done;
  if (istrue(opresult2394)) {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2395 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2396 == NULL) {
    strlit2396 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2396);
  }
// compiled string node returning strlit2396 (depth = 11)
  gc_frame_newslot(strlit2396);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2396;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2397 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2395);
// compiled call node returning call2397 (depth = 10)
    gc_frame_newslot(call2397);
    if2391 = call2397;
  } else {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2398 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2399 == NULL) {
    strlit2399 = alloc_String("(");
    gc_root(strlit2399);
  }
// compiled string node returning strlit2399 (depth = 11)
  gc_frame_newslot(strlit2399);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2399;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2400 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2398);
// compiled call node returning call2400 (depth = 10)
    gc_frame_newslot(call2400);
    if2391 = call2400;
  }
// compiled if node returning if2391 (depth = 9)
    gc_frame_newslot(if2391);
    if2384 = if2391;
  } else {
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2403 == NULL) {
    strlit2403 = alloc_String("lbrace");
    gc_root(strlit2403);
  }
// compiled string node returning strlit2403 (depth = 11)
  int op_slot_right_2402 = gc_frame_newslot(strlit2403);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2406 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2405);
// compiled call node returning call2406 (depth = 12)
// compiled member node returning call2406 (depth = 11)
  int op_slot_left_2402 = gc_frame_newslot(call2406);
  params[0] = strlit2403;
  partcv[0] = 1;
  Object opresult2407 = callmethod(call2406, "==", 1, partcv, params);
// compiled op node returning opresult2407 (depth = 10)
  Object if2401 = done;
  if (istrue(opresult2407)) {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2409 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2409 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2411 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2411 (depth = 11)
  Object if2408 = done;
  if (istrue(opresult2411)) {
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2412 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2413 == NULL) {
    strlit2413 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit2413);
  }
// compiled string node returning strlit2413 (depth = 12)
  gc_frame_newslot(strlit2413);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2413;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2414 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2412);
// compiled call node returning call2414 (depth = 11)
    gc_frame_newslot(call2414);
    if2408 = call2414;
  } else {
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2415 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2416 == NULL) {
    strlit2416 = alloc_String("(");
    gc_root(strlit2416);
  }
// compiled string node returning strlit2416 (depth = 12)
  gc_frame_newslot(strlit2416);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2416;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2417 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2415);
// compiled call node returning call2417 (depth = 11)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2418 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2419 == NULL) {
    strlit2419 = alloc_String(") then");
    gc_root(strlit2419);
  }
// compiled string node returning strlit2419 (depth = 12)
  gc_frame_newslot(strlit2419);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2421 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2420);
// compiled call node returning call2421 (depth = 13)
// compiled member node returning call2421 (depth = 12)
  gc_frame_newslot(call2421);
// starting to compile identifier node (depth = 12)
  Object bool2422 = alloc_Boolean(1);
// compiled identifier node returning bool2422 (depth = 12)
  gc_frame_newslot(bool2422);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2419;
  params[1] = call2421;
  params[2] = bool2422;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2423 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2418);
// compiled call node returning call2423 (depth = 11)
    gc_frame_newslot(call2423);
    if2408 = call2423;
  }
// compiled if node returning if2408 (depth = 10)
    gc_frame_newslot(if2408);
    if2401 = if2408;
  } else {
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2426 == NULL) {
    strlit2426 = alloc_String("identifier");
    gc_root(strlit2426);
  }
// compiled string node returning strlit2426 (depth = 12)
  int op_slot_right_2425 = gc_frame_newslot(strlit2426);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2429 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2428);
// compiled call node returning call2429 (depth = 13)
// compiled member node returning call2429 (depth = 12)
  int op_slot_left_2425 = gc_frame_newslot(call2429);
  params[0] = strlit2426;
  partcv[0] = 1;
  Object opresult2430 = callmethod(call2429, "==", 1, partcv, params);
// compiled op node returning opresult2430 (depth = 11)
  Object if2424 = done;
  if (istrue(opresult2430)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2432 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2432 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2434 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2434 (depth = 12)
  Object if2431 = done;
  if (istrue(opresult2434)) {
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2435 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2436 == NULL) {
    strlit2436 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit2436);
  }
// compiled string node returning strlit2436 (depth = 13)
  gc_frame_newslot(strlit2436);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2436;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2437 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2435);
// compiled call node returning call2437 (depth = 12)
    gc_frame_newslot(call2437);
    if2431 = call2437;
  } else {
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2438 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2439 == NULL) {
    strlit2439 = alloc_String("(");
    gc_root(strlit2439);
  }
// compiled string node returning strlit2439 (depth = 13)
  gc_frame_newslot(strlit2439);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2439;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2440 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2438);
// compiled call node returning call2440 (depth = 12)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2441 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2442 == NULL) {
    strlit2442 = alloc_String(")");
    gc_root(strlit2442);
  }
// compiled string node returning strlit2442 (depth = 13)
  gc_frame_newslot(strlit2442);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2443 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextTok (depth = 15)
  partcv[0] = 0;
  Object call2444 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2443);
// compiled call node returning call2444 (depth = 14)
// compiled member node returning call2444 (depth = 13)
  gc_frame_newslot(call2444);
// starting to compile identifier node (depth = 13)
  Object bool2445 = alloc_Boolean(1);
// compiled identifier node returning bool2445 (depth = 13)
  gc_frame_newslot(bool2445);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2442;
  params[1] = call2444;
  params[2] = bool2445;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2446 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2441);
// compiled call node returning call2446 (depth = 12)
    gc_frame_newslot(call2446);
    if2431 = call2446;
  }
// compiled if node returning if2431 (depth = 11)
    gc_frame_newslot(if2431);
    if2424 = if2431;
  } else {
  }
// compiled if node returning if2424 (depth = 10)
    gc_frame_newslot(if2424);
    if2401 = if2424;
  }
// compiled if node returning if2401 (depth = 9)
    gc_frame_newslot(if2401);
    if2384 = if2401;
  }
// compiled if node returning if2384 (depth = 8)
    gc_frame_newslot(if2384);
    if2376 = if2384;
  }
// compiled if node returning if2376 (depth = 7)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2447 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2449 == NULL) {
    strlit2449 = alloc_String("condition in parentheses or braces after the 'elseif'.");
    gc_root(strlit2449);
  }
// compiled string node returning strlit2449 (depth = 9)
  int op_slot_right_2448 = gc_frame_newslot(strlit2449);
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2451 == NULL) {
    strlit2451 = alloc_String("an elseif statement must have a ");
    gc_root(strlit2451);
  }
// compiled string node returning strlit2451 (depth = 9)
  int op_slot_left_2448 = gc_frame_newslot(strlit2451);
  params[0] = strlit2449;
  partcv[0] = 1;
  Object opresult2452 = callmethod(strlit2451, "++", 1, partcv, params);
// compiled op node returning opresult2452 (depth = 8)
  gc_frame_newslot(opresult2452);
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2454 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2453);
// compiled call node returning call2454 (depth = 9)
// compiled member node returning call2454 (depth = 8)
  gc_frame_newslot(call2454);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2456 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2455);
// compiled call node returning call2456 (depth = 9)
// compiled member node returning call2456 (depth = 8)
  gc_frame_newslot(call2456);
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2452;
  params[1] = call2454;
  params[2] = call2456;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2457 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2447);
// compiled call node returning call2457 (depth = 7)
    gc_frame_newslot(call2457);
    if2310 = call2457;
  } else {
  }
// compiled if node returning if2310 (depth = 6)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2458 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2459 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2458);
// compiled call node returning call2459 (depth = 7)
// compiled member node returning call2459 (depth = 6)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2461 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2462 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2463 = alloc_Block(NULL, NULL, "parser", 784);
  gc_frame_newslot(block2463);
// method "_apply"
  block_savedest(block2463);
  Object closure2464 = createclosure(2, "_apply");
  setclosureframe(closure2464, stackframe);
  addtoclosure(closure2464, var_blocksOK);
  addtoclosure(closure2464, selfslot);
  struct UserObject *uo2464 = (struct UserObject*)block2463;
  uo2464->data[0] = (Object)closure2464;
  Method *meth_meth_parser__apply2464 = addmethod2pos(block2463, "_apply", &meth_parser__apply2464, 0);
  int argcv_meth_parser__apply2464[] = {0};
  meth_meth_parser__apply2464->type = alloc_MethodType(1, argcv_meth_parser__apply2464);
  meth_meth_parser__apply2464->definitionModule = modulename;
  meth_meth_parser__apply2464->definitionLine = 784;
// compiled block node returning block2463 (depth = 10)
  gc_frame_newslot(block2463);
// call case 4: self request
  params[0] = block2463;
  partcv[0] = 1;
  Object call2468 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compiled call node returning call2468 (depth = 9)
  partcv[0] = 0;
  Object call2469 = callmethod(call2468, "not",
    1, partcv, params);
  gc_frame_end(callframe2461);
// compiled call node returning call2469 (depth = 8)
// compiled member node returning call2469 (depth = 7)
  Object if2460 = done;
  if (istrue(call2469)) {
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2470 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2472 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2471);
// compiled call node returning call2472 (depth = 11)
// compiled member node returning call2472 (depth = 10)
  partcv[0] = 0;
  Object call2473 = callmethod(call2472, "new",
    1, partcv, params);
  gc_frame_end(callframe2470);
// compiled call node returning call2473 (depth = 9)
// compiled member node returning call2473 (depth = 8)
  *var_suggestion = call2473;
  if (call2473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2474 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2475 = alloc_Block(NULL, NULL, "parser", 787);
  gc_frame_newslot(block2475);
// method "_apply"
  block_savedest(block2475);
  Object closure2476 = createclosure(2, "_apply");
  setclosureframe(closure2476, stackframe);
  addtoclosure(closure2476, var_lastToken);
  addtoclosure(closure2476, selfslot);
  struct UserObject *uo2476 = (struct UserObject*)block2475;
  uo2476->data[0] = (Object)closure2476;
  Method *meth_meth_parser__apply2476 = addmethod2pos(block2475, "_apply", &meth_parser__apply2476, 0);
  int argcv_meth_parser__apply2476[] = {1};
  meth_meth_parser__apply2476->type = alloc_MethodType(1, argcv_meth_parser__apply2476);
  meth_meth_parser__apply2476->definitionModule = modulename;
  meth_meth_parser__apply2476->definitionLine = 785;
// compiled block node returning block2475 (depth = 9)
  gc_frame_newslot(block2475);
// call case 4: self request
  params[0] = block2475;
  partcv[0] = 1;
  Object call2503 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2474);
// compiled call node returning call2503 (depth = 8)
  *var_nextTok = call2503;
  if (call2503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_right_2505 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 9)
  Object bool2507 = alloc_Boolean(0);
// compiled identifier node returning bool2507 (depth = 9)
  int op_slot_left_2505 = gc_frame_newslot(bool2507);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult2508 = callmethod(bool2507, "==", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 8)
  Object if2504 = done;
  if (istrue(opresult2508)) {
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2509 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array2510 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit2511 == NULL) {
    strlit2511 = alloc_String("rparen");
    gc_root(strlit2511);
  }
// compiled string node returning strlit2511 (depth = 11)
  params[0] = strlit2511;
  partcv[0] = 1;
  callmethodflags(array2510, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array2510 (depth = 10)
  gc_frame_newslot(array2510);
// call case 4: self request
  params[0] = array2510;
  partcv[0] = 1;
  Object call2512 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2509);
// compiled call node returning call2512 (depth = 9)
  *var_nextTok = call2512;
  if (call2512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2515 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2515 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2517 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2517 (depth = 9)
  Object if2514 = done;
  if (istrue(opresult2517)) {
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2518 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2519 == NULL) {
    strlit2519 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2519);
  }
// compiled string node returning strlit2519 (depth = 10)
  gc_frame_newslot(strlit2519);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2519;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2520 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2518);
// compiled call node returning call2520 (depth = 9)
    gc_frame_newslot(call2520);
    if2514 = call2520;
  } else {
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2521 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2522 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2523 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2522);
// compiled call node returning call2523 (depth = 11)
// compiled member node returning call2523 (depth = 10)
  gc_frame_newslot(call2523);
// starting to compile identifier node (depth = 10)
  Object bool2524 = alloc_Boolean(1);
// compiled identifier node returning bool2524 (depth = 10)
  gc_frame_newslot(bool2524);
// starting to compile identifier node (depth = 10)
  Object bool2525 = alloc_Boolean(0);
// compiled identifier node returning bool2525 (depth = 10)
  gc_frame_newslot(bool2525);
// starting to compile string node (depth = 10)
  if (strlit2526 == NULL) {
    strlit2526 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2526);
  }
// compiled string node returning strlit2526 (depth = 10)
  gc_frame_newslot(strlit2526);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2523;
  params[2] = bool2524;
  params[3] = bool2525;
  params[4] = strlit2526;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2527 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2521);
// compiled call node returning call2527 (depth = 9)
    gc_frame_newslot(call2527);
    if2514 = call2527;
  }
// compiled if node returning if2514 (depth = 8)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2528 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2529 == NULL) {
    strlit2529 = alloc_String("an elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2529);
  }
// compiled string node returning strlit2529 (depth = 9)
  gc_frame_newslot(strlit2529);
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2531 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2530);
// compiled call node returning call2531 (depth = 10)
// compiled member node returning call2531 (depth = 9)
  gc_frame_newslot(call2531);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2533 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2532);
// compiled call node returning call2533 (depth = 10)
// compiled member node returning call2533 (depth = 9)
  gc_frame_newslot(call2533);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2529;
  params[1] = call2531;
  params[2] = call2533;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2534 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2528);
// compiled call node returning call2534 (depth = 8)
    gc_frame_newslot(call2534);
    if2504 = call2534;
  } else {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2536 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2536 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2538 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2538 (depth = 9)
  Object if2535 = done;
  if (istrue(opresult2538)) {
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2539 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2540 == NULL) {
    strlit2540 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2540);
  }
// compiled string node returning strlit2540 (depth = 10)
  gc_frame_newslot(strlit2540);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2540;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2541 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2539);
// compiled call node returning call2541 (depth = 9)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2542 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2543 == NULL) {
    strlit2543 = alloc_String("an elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2543);
  }
// compiled string node returning strlit2543 (depth = 10)
  gc_frame_newslot(strlit2543);
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2545 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2544);
// compiled call node returning call2545 (depth = 11)
// compiled member node returning call2545 (depth = 10)
  gc_frame_newslot(call2545);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2547 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2546);
// compiled call node returning call2547 (depth = 11)
// compiled member node returning call2547 (depth = 10)
  gc_frame_newslot(call2547);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2543;
  params[1] = call2545;
  params[2] = call2547;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2548 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2542);
// compiled call node returning call2548 (depth = 9)
    gc_frame_newslot(call2548);
    if2535 = call2548;
  } else {
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2549 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2551 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2550);
// compiled call node returning call2551 (depth = 11)
// compiled member node returning call2551 (depth = 10)
  gc_frame_newslot(call2551);
// starting to compile identifier node (depth = 10)
  Object bool2552 = alloc_Boolean(0);
// compiled identifier node returning bool2552 (depth = 10)
  gc_frame_newslot(bool2552);
// starting to compile identifier node (depth = 10)
  Object bool2553 = alloc_Boolean(1);
// compiled identifier node returning bool2553 (depth = 10)
  gc_frame_newslot(bool2553);
// starting to compile string node (depth = 10)
  if (strlit2554 == NULL) {
    strlit2554 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2554);
  }
// compiled string node returning strlit2554 (depth = 10)
  gc_frame_newslot(strlit2554);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2551;
  params[2] = bool2552;
  params[3] = bool2553;
  params[4] = strlit2554;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2555 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2549);
// compiled call node returning call2555 (depth = 9)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2556 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2557 == NULL) {
    strlit2557 = alloc_String("4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2557);
  }
// compiled string node returning strlit2557 (depth = 10)
  gc_frame_newslot(strlit2557);
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2558 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2559 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2558);
// compiled call node returning call2559 (depth = 11)
// compiled member node returning call2559 (depth = 10)
  gc_frame_newslot(call2559);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2560 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2561 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2560);
// compiled call node returning call2561 (depth = 11)
// compiled member node returning call2561 (depth = 10)
  gc_frame_newslot(call2561);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2563 = alloc_Float64(1);
// compiled num node returning num2563 (depth = 11)
  int op_slot_right_2562 = gc_frame_newslot(num2563);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2566 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2565);
// compiled call node returning call2566 (depth = 12)
// compiled member node returning call2566 (depth = 11)
  int op_slot_left_2562 = gc_frame_newslot(call2566);
  params[0] = num2563;
  partcv[0] = 1;
  Object diff2567 = callmethod(call2566, "-", 1, partcv, params);
// compiled op node returning diff2567 (depth = 10)
  gc_frame_newslot(diff2567);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2557;
  params[1] = call2559;
  params[2] = call2561;
  params[3] = diff2567;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2568 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2556);
// compiled call node returning call2568 (depth = 9)
    gc_frame_newslot(call2568);
    if2535 = call2568;
  }
// compiled if node returning if2535 (depth = 8)
    gc_frame_newslot(if2535);
    if2504 = if2535;
  }
// compiled if node returning if2504 (depth = 7)
    gc_frame_newslot(if2504);
    if2460 = if2504;
  } else {
  }
// compiled if node returning if2460 (depth = 6)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elcloser (depth = 8)
  int op_slot_right_2570 = gc_frame_newslot(*var_elcloser);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2573 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2572);
// compiled call node returning call2573 (depth = 9)
// compiled member node returning call2573 (depth = 8)
  int op_slot_left_2570 = gc_frame_newslot(call2573);
  params[0] = *var_elcloser;
  partcv[0] = 1;
  Object opresult2574 = callmethod(call2573, "≠", 1, partcv, params);
// compiled op node returning opresult2574 (depth = 7)
  Object if2569 = done;
  if (istrue(opresult2574)) {
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2576 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2575);
// compiled call node returning call2576 (depth = 8)
// compiled member node returning call2576 (depth = 7)
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2577 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2578 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2579 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2578);
// compiled call node returning call2579 (depth = 11)
// compiled member node returning call2579 (depth = 10)
  partcv[0] = 0;
  Object call2580 = callmethod(call2579, "new",
    1, partcv, params);
  gc_frame_end(callframe2577);
// compiled call node returning call2580 (depth = 9)
// compiled member node returning call2580 (depth = 8)
  *var_suggestion = call2580;
  if (call2580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2581 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2582 == NULL) {
    strlit2582 = alloc_String(")");
    gc_root(strlit2582);
  }
// compiled string node returning strlit2582 (depth = 8)
  gc_frame_newslot(strlit2582);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2582;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2583 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2581);
// compiled call node returning call2583 (depth = 7)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2584 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2587 == NULL) {
    strlit2587 = alloc_String("'.");
    gc_root(strlit2587);
  }
// compiled string node returning strlit2587 (depth = 10)
  int op_slot_right_2586 = gc_frame_newslot(strlit2587);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_elcloser (depth = 11)
  int op_slot_right_2589 = gc_frame_newslot(*var_elcloser);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2592 == NULL) {
    strlit2592 = alloc_String("' must end with a '");
    gc_root(strlit2592);
  }
// compiled string node returning strlit2592 (depth = 12)
  int op_slot_right_2591 = gc_frame_newslot(strlit2592);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_elopener (depth = 13)
  int op_slot_right_2594 = gc_frame_newslot(*var_elopener);
// starting to compile string node (depth = 13)
  if (strlit2596 == NULL) {
    strlit2596 = alloc_String("'");
    gc_root(strlit2596);
  }
// compiled string node returning strlit2596 (depth = 13)
  int op_slot_left_2594 = gc_frame_newslot(strlit2596);
  params[0] = *var_elopener;
  partcv[0] = 1;
  Object opresult2597 = callmethod(strlit2596, "++", 1, partcv, params);
// compiled op node returning opresult2597 (depth = 12)
  int op_slot_left_2591 = gc_frame_newslot(opresult2597);
  params[0] = strlit2592;
  partcv[0] = 1;
  Object opresult2598 = callmethod(opresult2597, "++", 1, partcv, params);
// compiled op node returning opresult2598 (depth = 11)
  int op_slot_left_2589 = gc_frame_newslot(opresult2598);
  params[0] = *var_elcloser;
  partcv[0] = 1;
  Object opresult2599 = callmethod(opresult2598, "++", 1, partcv, params);
// compiled op node returning opresult2599 (depth = 10)
  int op_slot_left_2586 = gc_frame_newslot(opresult2599);
  params[0] = strlit2587;
  partcv[0] = 1;
  Object opresult2600 = callmethod(opresult2599, "++", 1, partcv, params);
// compiled op node returning opresult2600 (depth = 9)
  int op_slot_right_2585 = gc_frame_newslot(opresult2600);
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2602 == NULL) {
    strlit2602 = alloc_String("an expression beginning with a ");
    gc_root(strlit2602);
  }
// compiled string node returning strlit2602 (depth = 9)
  int op_slot_left_2585 = gc_frame_newslot(strlit2602);
  params[0] = opresult2600;
  partcv[0] = 1;
  Object opresult2603 = callmethod(strlit2602, "++", 1, partcv, params);
// compiled op node returning opresult2603 (depth = 8)
  gc_frame_newslot(opresult2603);
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2605 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2604);
// compiled call node returning call2605 (depth = 9)
// compiled member node returning call2605 (depth = 8)
  gc_frame_newslot(call2605);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2608 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2607);
// compiled call node returning call2608 (depth = 10)
// compiled member node returning call2608 (depth = 9)
  int op_slot_right_2606 = gc_frame_newslot(call2608);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2611 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2610);
// compiled call node returning call2611 (depth = 10)
// compiled member node returning call2611 (depth = 9)
  int op_slot_left_2606 = gc_frame_newslot(call2611);
  params[0] = call2608;
  partcv[0] = 1;
  Object sum2612 = callmethod(call2611, "+", 1, partcv, params);
// compiled op node returning sum2612 (depth = 8)
  gc_frame_newslot(sum2612);
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2603;
  params[1] = call2605;
  params[2] = sum2612;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2613 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2584);
// compiled call node returning call2613 (depth = 7)
    gc_frame_newslot(call2613);
    if2569 = call2613;
  } else {
  }
// compiled if node returning if2569 (depth = 6)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2614 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2615 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2614);
// compiled call node returning call2615 (depth = 7)
// compiled member node returning call2615 (depth = 6)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2617 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2616);
// compiled call node returning call2617 (depth = 8)
// compiled member node returning call2617 (depth = 7)
  *var_econd = call2617;
  if (call2617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2622 == NULL) {
    strlit2622 = alloc_String("then");
    gc_root(strlit2622);
  }
// compiled string node returning strlit2622 (depth = 9)
  int op_slot_right_2621 = gc_frame_newslot(strlit2622);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2624 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2625 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2624);
// compiled call node returning call2625 (depth = 10)
// compiled member node returning call2625 (depth = 9)
  int op_slot_left_2621 = gc_frame_newslot(call2625);
  params[0] = strlit2622;
  partcv[0] = 1;
  Object opresult2626 = callmethod(call2625, "==", 1, partcv, params);
// compiled op node returning opresult2626 (depth = 8)
  int op_slot_right_2620 = gc_frame_newslot(opresult2626);
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2628 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2629 == NULL) {
    strlit2629 = alloc_String("identifier");
    gc_root(strlit2629);
  }
// compiled string node returning strlit2629 (depth = 9)
  gc_frame_newslot(strlit2629);
// call case 4: self request
  params[0] = strlit2629;
  partcv[0] = 1;
  Object call2630 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2628);
// compiled call node returning call2630 (depth = 8)
  int op_slot_left_2620 = gc_frame_newslot(call2630);
  params[0] = opresult2626;
  partcv[0] = 1;
  Object opresult2631 = callmethod(call2630, "&&", 1, partcv, params);
// compiled op node returning opresult2631 (depth = 7)
  Object if2619 = done;
  if (istrue(opresult2631)) {
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2632 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2633 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2632);
// compiled call node returning call2633 (depth = 8)
// compiled member node returning call2633 (depth = 7)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile array node (depth = 8)
  Object array2634 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2634 (depth = 8)
  *var_ebody = array2634;
  if (array2634 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2619 = done;
  } else {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2636 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2638 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2637);
// compiled call node returning call2638 (depth = 11)
// compiled member node returning call2638 (depth = 10)
  partcv[0] = 0;
  Object call2639 = callmethod(call2638, "new",
    1, partcv, params);
  gc_frame_end(callframe2636);
// compiled call node returning call2639 (depth = 9)
// compiled member node returning call2639 (depth = 8)
  *var_suggestion = call2639;
  if (call2639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2642 == NULL) {
    strlit2642 = alloc_String("lbrace");
    gc_root(strlit2642);
  }
// compiled string node returning strlit2642 (depth = 9)
  int op_slot_right_2641 = gc_frame_newslot(strlit2642);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2644 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2645 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2644);
// compiled call node returning call2645 (depth = 10)
// compiled member node returning call2645 (depth = 9)
  int op_slot_left_2641 = gc_frame_newslot(call2645);
  params[0] = strlit2642;
  partcv[0] = 1;
  Object opresult2646 = callmethod(call2645, "==", 1, partcv, params);
// compiled op node returning opresult2646 (depth = 8)
  Object if2640 = done;
  if (istrue(opresult2646)) {
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2647 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2648 = alloc_Boolean(0);
// compiled identifier node returning bool2648 (depth = 10)
  gc_frame_newslot(bool2648);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2648;
  partcv[0] = 2;
  Object call2649 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2647);
// compiled call node returning call2649 (depth = 9)
  *var_closingBrace = call2649;
  if (call2649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2651 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2653 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2652);
// compiled call node returning call2653 (depth = 12)
// compiled member node returning call2653 (depth = 11)
  partcv[0] = 0;
  Object call2654 = callmethod(call2653, "not",
    1, partcv, params);
  gc_frame_end(callframe2651);
// compiled call node returning call2654 (depth = 10)
// compiled member node returning call2654 (depth = 9)
  Object if2650 = done;
  if (istrue(call2654)) {
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2656 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2659 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2658);
// compiled call node returning call2659 (depth = 12)
// compiled member node returning call2659 (depth = 11)
  int op_slot_left_2656 = gc_frame_newslot(call2659);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2660 = callmethod(call2659, "==", 1, partcv, params);
// compiled op node returning opresult2660 (depth = 10)
  Object if2655 = done;
  if (istrue(opresult2660)) {
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2661 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2662 = alloc_Boolean(1);
// compiled identifier node returning bool2662 (depth = 11)
  gc_frame_newslot(bool2662);
// starting to compile identifier node (depth = 11)
  Object bool2663 = alloc_Boolean(0);
// compiled identifier node returning bool2663 (depth = 11)
  gc_frame_newslot(bool2663);
// starting to compile string node (depth = 11)
  if (strlit2664 == NULL) {
    strlit2664 = alloc_String(" then {}");
    gc_root(strlit2664);
  }
// compiled string node returning strlit2664 (depth = 11)
  gc_frame_newslot(strlit2664);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2662;
  params[2] = bool2663;
  params[3] = strlit2664;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2665 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2661);
// compiled call node returning call2665 (depth = 10)
    gc_frame_newslot(call2665);
    if2655 = call2665;
  } else {
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2666 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2667 = alloc_Boolean(1);
// compiled identifier node returning bool2667 (depth = 11)
  gc_frame_newslot(bool2667);
// starting to compile identifier node (depth = 11)
  Object bool2668 = alloc_Boolean(0);
// compiled identifier node returning bool2668 (depth = 11)
  gc_frame_newslot(bool2668);
// starting to compile string node (depth = 11)
  if (strlit2669 == NULL) {
    strlit2669 = alloc_String(" then {");
    gc_root(strlit2669);
  }
// compiled string node returning strlit2669 (depth = 11)
  gc_frame_newslot(strlit2669);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2667;
  params[2] = bool2668;
  params[3] = strlit2669;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2670 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2666);
// compiled call node returning call2670 (depth = 10)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2671 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2673 = alloc_Float64(0.1);
// compiled num node returning num2673 (depth = 12)
  int op_slot_right_2672 = gc_frame_newslot(num2673);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2675 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2677 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2676);
// compiled call node returning call2677 (depth = 15)
// compiled member node returning call2677 (depth = 14)
  partcv[0] = 0;
  Object call2678 = callmethod(call2677, "line",
    1, partcv, params);
  gc_frame_end(callframe2675);
// compiled call node returning call2678 (depth = 13)
// compiled member node returning call2678 (depth = 12)
  int op_slot_left_2672 = gc_frame_newslot(call2678);
  params[0] = num2673;
  partcv[0] = 1;
  Object sum2679 = callmethod(call2678, "+", 1, partcv, params);
// compiled op node returning sum2679 (depth = 11)
  gc_frame_newslot(sum2679);
// starting to compile string node (depth = 11)
  if (strlit2680 == NULL) {
    strlit2680 = alloc_String("}");
    gc_root(strlit2680);
  }
// compiled string node returning strlit2680 (depth = 11)
  gc_frame_newslot(strlit2680);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2679;
  params[1] = strlit2680;
  partcv[0] = 2;
  Object call2681 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2671);
// compiled call node returning call2681 (depth = 10)
    gc_frame_newslot(call2681);
    if2655 = call2681;
  }
// compiled if node returning if2655 (depth = 9)
    gc_frame_newslot(if2655);
    if2650 = if2655;
  } else {
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2682 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2683 = alloc_Boolean(1);
// compiled identifier node returning bool2683 (depth = 10)
  gc_frame_newslot(bool2683);
// starting to compile identifier node (depth = 10)
  Object bool2684 = alloc_Boolean(0);
// compiled identifier node returning bool2684 (depth = 10)
  gc_frame_newslot(bool2684);
// starting to compile string node (depth = 10)
  if (strlit2685 == NULL) {
    strlit2685 = alloc_String(" then {");
    gc_root(strlit2685);
  }
// compiled string node returning strlit2685 (depth = 10)
  gc_frame_newslot(strlit2685);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2683;
  params[2] = bool2684;
  params[3] = strlit2685;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2686 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2682);
// compiled call node returning call2686 (depth = 9)
    gc_frame_newslot(call2686);
    if2650 = call2686;
  }
// compiled if node returning if2650 (depth = 8)
    gc_frame_newslot(if2650);
    if2640 = if2650;
  } else {
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2687 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2688 = alloc_Boolean(1);
// compiled identifier node returning bool2688 (depth = 10)
  gc_frame_newslot(bool2688);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2688;
  partcv[0] = 2;
  Object call2689 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2687);
// compiled call node returning call2689 (depth = 9)
  *var_closingBrace = call2689;
  if (call2689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2691 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2693 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2692);
// compiled call node returning call2693 (depth = 12)
// compiled member node returning call2693 (depth = 11)
  partcv[0] = 0;
  Object call2694 = callmethod(call2693, "not",
    1, partcv, params);
  gc_frame_end(callframe2691);
// compiled call node returning call2694 (depth = 10)
// compiled member node returning call2694 (depth = 9)
  Object if2690 = done;
  if (istrue(call2694)) {
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2696 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2699 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2698);
// compiled call node returning call2699 (depth = 12)
// compiled member node returning call2699 (depth = 11)
  int op_slot_left_2696 = gc_frame_newslot(call2699);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2700 = callmethod(call2699, "==", 1, partcv, params);
// compiled op node returning opresult2700 (depth = 10)
  Object if2695 = done;
  if (istrue(opresult2700)) {
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2701 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2702 == NULL) {
    strlit2702 = alloc_String(" then {}");
    gc_root(strlit2702);
  }
// compiled string node returning strlit2702 (depth = 11)
  gc_frame_newslot(strlit2702);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2702;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2703 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2701);
// compiled call node returning call2703 (depth = 10)
    gc_frame_newslot(call2703);
    if2695 = call2703;
  } else {
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2704 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2705 == NULL) {
    strlit2705 = alloc_String(" then {");
    gc_root(strlit2705);
  }
// compiled string node returning strlit2705 (depth = 11)
  gc_frame_newslot(strlit2705);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2705;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2706 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2704);
// compiled call node returning call2706 (depth = 10)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2707 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2709 = alloc_Float64(0.1);
// compiled num node returning num2709 (depth = 12)
  int op_slot_right_2708 = gc_frame_newslot(num2709);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2711 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2713 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2712);
// compiled call node returning call2713 (depth = 15)
// compiled member node returning call2713 (depth = 14)
  partcv[0] = 0;
  Object call2714 = callmethod(call2713, "line",
    1, partcv, params);
  gc_frame_end(callframe2711);
// compiled call node returning call2714 (depth = 13)
// compiled member node returning call2714 (depth = 12)
  int op_slot_left_2708 = gc_frame_newslot(call2714);
  params[0] = num2709;
  partcv[0] = 1;
  Object sum2715 = callmethod(call2714, "+", 1, partcv, params);
// compiled op node returning sum2715 (depth = 11)
  gc_frame_newslot(sum2715);
// starting to compile string node (depth = 11)
  if (strlit2716 == NULL) {
    strlit2716 = alloc_String("}");
    gc_root(strlit2716);
  }
// compiled string node returning strlit2716 (depth = 11)
  gc_frame_newslot(strlit2716);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2715;
  params[1] = strlit2716;
  partcv[0] = 2;
  Object call2717 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2707);
// compiled call node returning call2717 (depth = 10)
    gc_frame_newslot(call2717);
    if2695 = call2717;
  }
// compiled if node returning if2695 (depth = 9)
    gc_frame_newslot(if2695);
    if2690 = if2695;
  } else {
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2718 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2719 == NULL) {
    strlit2719 = alloc_String(" then {");
    gc_root(strlit2719);
  }
// compiled string node returning strlit2719 (depth = 10)
  gc_frame_newslot(strlit2719);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2719;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2720 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2718);
// compiled call node returning call2720 (depth = 9)
    gc_frame_newslot(call2720);
    if2690 = call2720;
  }
// compiled if node returning if2690 (depth = 8)
    gc_frame_newslot(if2690);
    if2640 = if2690;
  }
// compiled if node returning if2640 (depth = 7)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2721 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2722 == NULL) {
    strlit2722 = alloc_String("an elseif statement must have 'then' after the expression in parentheses.");
    gc_root(strlit2722);
  }
// compiled string node returning strlit2722 (depth = 8)
  gc_frame_newslot(strlit2722);
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2723 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2724 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2723);
// compiled call node returning call2724 (depth = 9)
// compiled member node returning call2724 (depth = 8)
  gc_frame_newslot(call2724);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2726 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2725);
// compiled call node returning call2726 (depth = 9)
// compiled member node returning call2726 (depth = 8)
  gc_frame_newslot(call2726);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2722;
  params[1] = call2724;
  params[2] = call2726;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2727 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2721);
// compiled call node returning call2727 (depth = 7)
    gc_frame_newslot(call2727);
    if2619 = call2727;
  }
// compiled if node returning if2619 (depth = 6)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("lbrace");
    gc_root(strlit2730);
  }
// compiled string node returning strlit2730 (depth = 8)
  int op_slot_right_2729 = gc_frame_newslot(strlit2730);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2733 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2732);
// compiled call node returning call2733 (depth = 9)
// compiled member node returning call2733 (depth = 8)
  int op_slot_left_2729 = gc_frame_newslot(call2733);
  params[0] = strlit2730;
  partcv[0] = 1;
  Object opresult2734 = callmethod(call2733, "≠", 1, partcv, params);
// compiled op node returning opresult2734 (depth = 7)
  Object if2728 = done;
  if (istrue(opresult2734)) {
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2735 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2737 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2736);
// compiled call node returning call2737 (depth = 11)
// compiled member node returning call2737 (depth = 10)
  partcv[0] = 0;
  Object call2738 = callmethod(call2737, "new",
    1, partcv, params);
  gc_frame_end(callframe2735);
// compiled call node returning call2738 (depth = 9)
// compiled member node returning call2738 (depth = 8)
  *var_suggestion = call2738;
  if (call2738 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2739 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2740 = alloc_Boolean(1);
// compiled identifier node returning bool2740 (depth = 9)
  gc_frame_newslot(bool2740);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2740;
  partcv[0] = 2;
  Object call2741 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2739);
// compiled call node returning call2741 (depth = 8)
  *var_closingBrace = call2741;
  if (call2741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2743 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2745 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2744);
// compiled call node returning call2745 (depth = 11)
// compiled member node returning call2745 (depth = 10)
  partcv[0] = 0;
  Object call2746 = callmethod(call2745, "not",
    1, partcv, params);
  gc_frame_end(callframe2743);
// compiled call node returning call2746 (depth = 9)
// compiled member node returning call2746 (depth = 8)
  Object if2742 = done;
  if (istrue(call2746)) {
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2748 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2751 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2750);
// compiled call node returning call2751 (depth = 11)
// compiled member node returning call2751 (depth = 10)
  int op_slot_left_2748 = gc_frame_newslot(call2751);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2752 = callmethod(call2751, "==", 1, partcv, params);
// compiled op node returning opresult2752 (depth = 9)
  Object if2747 = done;
  if (istrue(opresult2752)) {
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2753 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2754 = alloc_Boolean(0);
// compiled identifier node returning bool2754 (depth = 10)
  gc_frame_newslot(bool2754);
// starting to compile identifier node (depth = 10)
  Object bool2755 = alloc_Boolean(1);
// compiled identifier node returning bool2755 (depth = 10)
  gc_frame_newslot(bool2755);
// starting to compile string node (depth = 10)
  if (strlit2756 == NULL) {
    strlit2756 = alloc_String("then {}");
    gc_root(strlit2756);
  }
// compiled string node returning strlit2756 (depth = 10)
  gc_frame_newslot(strlit2756);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2754;
  params[2] = bool2755;
  params[3] = strlit2756;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2757 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2753);
// compiled call node returning call2757 (depth = 9)
    gc_frame_newslot(call2757);
    if2747 = call2757;
  } else {
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2758 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2760 = alloc_Float64(0.1);
// compiled num node returning num2760 (depth = 11)
  int op_slot_right_2759 = gc_frame_newslot(num2760);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2764 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2763);
// compiled call node returning call2764 (depth = 14)
// compiled member node returning call2764 (depth = 13)
  partcv[0] = 0;
  Object call2765 = callmethod(call2764, "line",
    1, partcv, params);
  gc_frame_end(callframe2762);
// compiled call node returning call2765 (depth = 12)
// compiled member node returning call2765 (depth = 11)
  int op_slot_left_2759 = gc_frame_newslot(call2765);
  params[0] = num2760;
  partcv[0] = 1;
  Object sum2766 = callmethod(call2765, "+", 1, partcv, params);
// compiled op node returning sum2766 (depth = 10)
  gc_frame_newslot(sum2766);
// starting to compile string node (depth = 10)
  if (strlit2767 == NULL) {
    strlit2767 = alloc_String("}");
    gc_root(strlit2767);
  }
// compiled string node returning strlit2767 (depth = 10)
  gc_frame_newslot(strlit2767);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2766;
  params[1] = strlit2767;
  partcv[0] = 2;
  Object call2768 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2758);
// compiled call node returning call2768 (depth = 9)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2769 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2770 = alloc_Boolean(0);
// compiled identifier node returning bool2770 (depth = 10)
  gc_frame_newslot(bool2770);
// starting to compile identifier node (depth = 10)
  Object bool2771 = alloc_Boolean(1);
// compiled identifier node returning bool2771 (depth = 10)
  gc_frame_newslot(bool2771);
// starting to compile string node (depth = 10)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String("then {");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 10)
  gc_frame_newslot(strlit2772);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2770;
  params[2] = bool2771;
  params[3] = strlit2772;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2773 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2769);
// compiled call node returning call2773 (depth = 9)
    gc_frame_newslot(call2773);
    if2747 = call2773;
  }
// compiled if node returning if2747 (depth = 8)
    gc_frame_newslot(if2747);
    if2742 = if2747;
  } else {
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2774 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2775 = alloc_Boolean(0);
// compiled identifier node returning bool2775 (depth = 9)
  gc_frame_newslot(bool2775);
// starting to compile identifier node (depth = 9)
  Object bool2776 = alloc_Boolean(1);
// compiled identifier node returning bool2776 (depth = 9)
  gc_frame_newslot(bool2776);
// starting to compile string node (depth = 9)
  if (strlit2777 == NULL) {
    strlit2777 = alloc_String("then {");
    gc_root(strlit2777);
  }
// compiled string node returning strlit2777 (depth = 9)
  gc_frame_newslot(strlit2777);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2775;
  params[2] = bool2776;
  params[3] = strlit2777;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2778 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2774);
// compiled call node returning call2778 (depth = 8)
    gc_frame_newslot(call2778);
    if2742 = call2778;
  }
// compiled if node returning if2742 (depth = 7)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2779 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2780 == NULL) {
    strlit2780 = alloc_String("an elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2780);
  }
// compiled string node returning strlit2780 (depth = 8)
  gc_frame_newslot(strlit2780);
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2782 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2781);
// compiled call node returning call2782 (depth = 9)
// compiled member node returning call2782 (depth = 8)
  gc_frame_newslot(call2782);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2785 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2784);
// compiled call node returning call2785 (depth = 10)
// compiled member node returning call2785 (depth = 9)
  int op_slot_right_2783 = gc_frame_newslot(call2785);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2788 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2787);
// compiled call node returning call2788 (depth = 10)
// compiled member node returning call2788 (depth = 9)
  int op_slot_left_2783 = gc_frame_newslot(call2788);
  params[0] = call2785;
  partcv[0] = 1;
  Object sum2789 = callmethod(call2788, "+", 1, partcv, params);
// compiled op node returning sum2789 (depth = 8)
  gc_frame_newslot(sum2789);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2780;
  params[1] = call2782;
  params[2] = sum2789;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2790 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2779);
// compiled call node returning call2790 (depth = 7)
    gc_frame_newslot(call2790);
    if2728 = call2790;
  } else {
  }
// compiled if node returning if2728 (depth = 6)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2792 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2791);
// compiled call node returning call2792 (depth = 7)
// compiled member node returning call2792 (depth = 6)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2796 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2795);
// compiled call node returning call2796 (depth = 9)
// compiled member node returning call2796 (depth = 8)
  int op_slot_right_2794 = gc_frame_newslot(call2796);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2799 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2798);
// compiled call node returning call2799 (depth = 9)
// compiled member node returning call2799 (depth = 8)
  int op_slot_left_2794 = gc_frame_newslot(call2799);
  params[0] = call2796;
  partcv[0] = 1;
  Object opresult2800 = callmethod(call2799, "==", 1, partcv, params);
// compiled op node returning opresult2800 (depth = 7)
  Object if2793 = done;
  if (istrue(opresult2800)) {
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2802 = alloc_Float64(1);
// compiled num node returning num2802 (depth = 9)
  int op_slot_right_2801 = gc_frame_newslot(num2802);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2805 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2804);
// compiled call node returning call2805 (depth = 10)
// compiled member node returning call2805 (depth = 9)
  int op_slot_left_2801 = gc_frame_newslot(call2805);
  params[0] = num2802;
  partcv[0] = 1;
  Object diff2806 = callmethod(call2805, "-", 1, partcv, params);
// compiled op node returning diff2806 (depth = 8)
  *var_minIndentLevel = diff2806;
  if (diff2806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2793 = done;
  } else {
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2793 = done;
  }
// compiled if node returning if2793 (depth = 6)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2809 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2810 = alloc_Block(NULL, NULL, "parser", 878);
  gc_frame_newslot(block2810);
// method "_apply"
  block_savedest(block2810);
  Object closure2811 = createclosure(1, "_apply");
  setclosureframe(closure2811, stackframe);
  addtoclosure(closure2811, selfslot);
  struct UserObject *uo2811 = (struct UserObject*)block2810;
  uo2811->data[0] = (Object)closure2811;
  Method *meth_meth_parser__apply2811 = addmethod2pos(block2810, "_apply", &meth_parser__apply2811, 0);
  int argcv_meth_parser__apply2811[] = {0};
  meth_meth_parser__apply2811->type = alloc_MethodType(1, argcv_meth_parser__apply2811);
  meth_meth_parser__apply2811->definitionModule = modulename;
  meth_meth_parser__apply2811->definitionLine = 874;
// compiled block node returning block2810 (depth = 7)
  gc_frame_newslot(block2810);
// starting to compile block node (depth = 7)
  Object block2818 = alloc_Block(NULL, NULL, "parser", 878);
  gc_frame_newslot(block2818);
// method "_apply"
  block_savedest(block2818);
  Object closure2819 = createclosure(8, "_apply");
  setclosureframe(closure2819, stackframe);
  addtoclosure(closure2819, var_errormessages);
  addtoclosure(closure2819, var_btok);
  addtoclosure(closure2819, var_lastToken);
  addtoclosure(closure2819, var_sym);
  addtoclosure(closure2819, var_values);
  addtoclosure(closure2819, var_v);
  addtoclosure(closure2819, var_ebody);
  addtoclosure(closure2819, selfslot);
  struct UserObject *uo2819 = (struct UserObject*)block2818;
  uo2819->data[0] = (Object)closure2819;
  Method *meth_meth_parser__apply2819 = addmethod2pos(block2818, "_apply", &meth_parser__apply2819, 0);
  int argcv_meth_parser__apply2819[] = {0};
  meth_meth_parser__apply2819->type = alloc_MethodType(1, argcv_meth_parser__apply2819);
  meth_meth_parser__apply2819->definitionModule = modulename;
  meth_meth_parser__apply2819->definitionLine = 878;
// compiled block node returning block2818 (depth = 7)
  gc_frame_newslot(block2818);
// call case 5: prelude request
  params[0] = block2810;
  params[1] = block2818;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2877 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2809);
// compiled call node returning call2877 (depth = 6)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2879 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2878);
// compiled call node returning call2879 (depth = 7)
// compiled member node returning call2879 (depth = 6)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile array node (depth = 7)
  Object array2880 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2880 (depth = 7)
  *var_newelse = array2880;
  if (array2880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2882 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 4: self request
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2883 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2882);
// compiled call node returning call2883 (depth = 7)
  *var_eif = call2883;
  if (call2883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2885 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2886 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2885);
// compiled call node returning call2886 (depth = 6)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply2988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2989 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2990 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2991 == NULL) {
    strlit2991 = alloc_String("rbrace");
    gc_root(strlit2991);
  }
// compiled string node returning strlit2991 (depth = 10)
  gc_frame_newslot(strlit2991);
// call case 4: self request
  params[0] = strlit2991;
  partcv[0] = 1;
  Object call2992 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2990);
// compiled call node returning call2992 (depth = 9)
  partcv[0] = 0;
  Object call2993 = callmethod(call2992, "not",
    1, partcv, params);
  gc_frame_end(callframe2989);
// compiled call node returning call2993 (depth = 8)
// compiled member node returning call2993 (depth = 7)
  gc_frame_end(frame);
  return call2993;
}
Object meth_parser__apply3001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3002 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3003 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 13)
// compiled member node returning call3003 (depth = 12)
  gc_frame_end(frame);
  return call3003;
}
Object meth_parser__apply2996(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2998 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2999 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block3000 = alloc_Block(NULL, NULL, "parser", 933);
  gc_frame_newslot(block3000);
// method "_apply"
  block_savedest(block3000);
  Object closure3001 = createclosure(1, "_apply");
  setclosureframe(closure3001, stackframe);
  addtoclosure(closure3001, selfslot);
  struct UserObject *uo3001 = (struct UserObject*)block3000;
  uo3001->data[0] = (Object)closure3001;
  Method *meth_meth_parser__apply3001 = addmethod2pos(block3000, "_apply", &meth_parser__apply3001, 0);
  int argcv_meth_parser__apply3001[] = {0};
  meth_meth_parser__apply3001->type = alloc_MethodType(1, argcv_meth_parser__apply3001);
  meth_meth_parser__apply3001->definitionModule = modulename;
  meth_meth_parser__apply3001->definitionLine = 933;
// compiled block node returning block3000 (depth = 11)
  gc_frame_newslot(block3000);
// call case 4: self request
  params[0] = block3000;
  partcv[0] = 1;
  Object call3005 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2999);
// compiled call node returning call3005 (depth = 10)
  partcv[0] = 0;
  Object call3006 = callmethod(call3005, "not",
    1, partcv, params);
  gc_frame_end(callframe2998);
// compiled call node returning call3006 (depth = 9)
// compiled member node returning call3006 (depth = 8)
  Object if2997 = done;
  if (istrue(call3006)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3007 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3009 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3008);
// compiled call node returning call3009 (depth = 12)
// compiled member node returning call3009 (depth = 11)
  partcv[0] = 0;
  Object call3010 = callmethod(call3009, "new",
    1, partcv, params);
  gc_frame_end(callframe3007);
// compiled call node returning call3010 (depth = 10)
// compiled member node returning call3010 (depth = 9)
  *var_suggestion = call3010;
  if (call3010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3011 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool3012 = alloc_Boolean(0);
// compiled identifier node returning bool3012 (depth = 10)
  gc_frame_newslot(bool3012);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3012;
  partcv[0] = 2;
  Object call3013 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3011);
// compiled call node returning call3013 (depth = 9)
  *var_closingBrace = call3013;
  if (call3013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3015 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3017 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3016);
// compiled call node returning call3017 (depth = 12)
// compiled member node returning call3017 (depth = 11)
  partcv[0] = 0;
  Object call3018 = callmethod(call3017, "not",
    1, partcv, params);
  gc_frame_end(callframe3015);
// compiled call node returning call3018 (depth = 10)
// compiled member node returning call3018 (depth = 9)
  Object if3014 = done;
  if (istrue(call3018)) {
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_3020 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3023 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3022);
// compiled call node returning call3023 (depth = 12)
// compiled member node returning call3023 (depth = 11)
  int op_slot_left_3020 = gc_frame_newslot(call3023);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3024 = callmethod(call3023, "==", 1, partcv, params);
// compiled op node returning opresult3024 (depth = 10)
  Object if3019 = done;
  if (istrue(opresult3024)) {
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3025 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3026 == NULL) {
    strlit3026 = alloc_String("}");
    gc_root(strlit3026);
  }
// compiled string node returning strlit3026 (depth = 11)
  gc_frame_newslot(strlit3026);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit3026;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3027 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3025);
// compiled call node returning call3027 (depth = 10)
    gc_frame_newslot(call3027);
    if3019 = call3027;
  } else {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3028 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3030 = alloc_Float64(0.1);
// compiled num node returning num3030 (depth = 12)
  int op_slot_right_3029 = gc_frame_newslot(num3030);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3032 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe3033 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call3034 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3033);
// compiled call node returning call3034 (depth = 15)
// compiled member node returning call3034 (depth = 14)
  partcv[0] = 0;
  Object call3035 = callmethod(call3034, "line",
    1, partcv, params);
  gc_frame_end(callframe3032);
// compiled call node returning call3035 (depth = 13)
// compiled member node returning call3035 (depth = 12)
  int op_slot_left_3029 = gc_frame_newslot(call3035);
  params[0] = num3030;
  partcv[0] = 1;
  Object sum3036 = callmethod(call3035, "+", 1, partcv, params);
// compiled op node returning sum3036 (depth = 11)
  gc_frame_newslot(sum3036);
// starting to compile string node (depth = 11)
  if (strlit3037 == NULL) {
    strlit3037 = alloc_String("}");
    gc_root(strlit3037);
  }
// compiled string node returning strlit3037 (depth = 11)
  gc_frame_newslot(strlit3037);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3036;
  params[1] = strlit3037;
  partcv[0] = 2;
  Object call3038 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3028);
// compiled call node returning call3038 (depth = 10)
    gc_frame_newslot(call3038);
    if3019 = call3038;
  }
// compiled if node returning if3019 (depth = 9)
    gc_frame_newslot(if3019);
    if3014 = if3019;
  } else {
  }
// compiled if node returning if3014 (depth = 8)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3039 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call3040 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3039);
// compiled call node returning call3040 (depth = 8)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3041 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3042 == NULL) {
    strlit3042 = alloc_String("an else statement must end with a '}'.");
    gc_root(strlit3042);
  }
// compiled string node returning strlit3042 (depth = 9)
  gc_frame_newslot(strlit3042);
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3043 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3044 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3043);
// compiled call node returning call3044 (depth = 10)
// compiled member node returning call3044 (depth = 9)
  gc_frame_newslot(call3044);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3046 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3045);
// compiled call node returning call3046 (depth = 10)
// compiled member node returning call3046 (depth = 9)
  gc_frame_newslot(call3046);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3042;
  params[1] = call3044;
  params[2] = call3046;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3047 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3041);
// compiled call node returning call3047 (depth = 8)
    gc_frame_newslot(call3047);
    if2997 = call3047;
  } else {
  }
// compiled if node returning if2997 (depth = 7)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3049 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3048);
// compiled call node returning call3049 (depth = 9)
// compiled member node returning call3049 (depth = 8)
  *var_v = call3049;
  if (call3049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3051 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3052 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe3051);
// compiled call node returning call3052 (depth = 7)
  gc_frame_end(frame);
  return call3052;
}
Object meth_parser_doif1719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(29, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  Object *var_util = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doif (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doif");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_opener = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "opener");
  Object *var_closer = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "closer");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_cond = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cond");
  Object *var_body = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "body");
  Object *var_elseblock = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "elseblock");
  Object *var_curelse = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "curelse");
  Object *var_v = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "v");
  Object *var_localMin = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "minInd");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_econd = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "econd");
  Object *var_eif = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "eif");
  Object *var_newelse = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "newelse");
  Object *var_ebody = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "ebody");
  Object *var_o = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "o");
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1723 == NULL) {
    strlit1723 = alloc_String("if");
    gc_root(strlit1723);
  }
// compiled string node returning strlit1723 (depth = 5)
  int op_slot_right_1722 = gc_frame_newslot(strlit1723);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1726 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1725);
// compiled call node returning call1726 (depth = 6)
// compiled member node returning call1726 (depth = 5)
  int op_slot_left_1722 = gc_frame_newslot(call1726);
  params[0] = strlit1723;
  partcv[0] = 1;
  Object opresult1727 = callmethod(call1726, "==", 1, partcv, params);
// compiled op node returning opresult1727 (depth = 4)
  int op_slot_right_1721 = gc_frame_newslot(opresult1727);
// starting to compile call node (depth = 4)
  int callframe1729 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1730 == NULL) {
    strlit1730 = alloc_String("identifier");
    gc_root(strlit1730);
  }
// compiled string node returning strlit1730 (depth = 5)
  gc_frame_newslot(strlit1730);
// call case 4: self request
  params[0] = strlit1730;
  partcv[0] = 1;
  Object call1731 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1729);
// compiled call node returning call1731 (depth = 4)
  int op_slot_left_1721 = gc_frame_newslot(call1731);
  params[0] = opresult1727;
  partcv[0] = 1;
  Object opresult1732 = callmethod(call1731, "&&", 1, partcv, params);
// compiled op node returning opresult1732 (depth = 3)
  Object if1720 = done;
  if (istrue(opresult1732)) {
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1733 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1734 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1733);
// compiled call node returning call1734 (depth = 4)
// compiled member node returning call1734 (depth = 3)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block1737 = alloc_Block(NULL, NULL, "parser", 596);
  gc_frame_newslot(block1737);
// method "_apply"
  block_savedest(block1737);
  Object closure1738 = createclosure(2, "_apply");
  setclosureframe(closure1738, stackframe);
  addtoclosure(closure1738, var_sym);
  addtoclosure(closure1738, selfslot);
  struct UserObject *uo1738 = (struct UserObject*)block1737;
  uo1738->data[0] = (Object)closure1738;
  Method *meth_meth_parser__apply1738 = addmethod2pos(block1737, "_apply", &meth_parser__apply1738, 0);
  int argcv_meth_parser__apply1738[] = {0};
  meth_meth_parser__apply1738->type = alloc_MethodType(1, argcv_meth_parser__apply1738);
  meth_meth_parser__apply1738->definitionModule = modulename;
  meth_meth_parser__apply1738->definitionLine = 595;
// compiled block node returning block1737 (depth = 6)
  int op_slot_right_1736 = gc_frame_newslot(block1737);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1748 == NULL) {
    strlit1748 = alloc_String("lparen");
    gc_root(strlit1748);
  }
// compiled string node returning strlit1748 (depth = 7)
  int op_slot_right_1747 = gc_frame_newslot(strlit1748);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1751 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1750);
// compiled call node returning call1751 (depth = 8)
// compiled member node returning call1751 (depth = 7)
  int op_slot_left_1747 = gc_frame_newslot(call1751);
  params[0] = strlit1748;
  partcv[0] = 1;
  Object opresult1752 = callmethod(call1751, "==", 1, partcv, params);
// compiled op node returning opresult1752 (depth = 6)
  int op_slot_left_1736 = gc_frame_newslot(opresult1752);
  params[0] = block1737;
  partcv[0] = 1;
  Object opresult1753 = callmethod(opresult1752, "||", 1, partcv, params);
// compiled op node returning opresult1753 (depth = 5)
  Object if1735 = done;
struct StackFrameObject *iftmpstackframe1735 = stackframe;
  if (istrue(opresult1753)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1735);
gc_frame_newslot((Object)stackframe);
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1754 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1755 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1754);
// compiled call node returning call1755 (depth = 6)
// compiled member node returning call1755 (depth = 5)
    gc_frame_newslot(call1755);
    if1735 = call1755;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1735);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1756 == NULL) {
    strlit1756 = alloc_String("-missing-");
    gc_root(strlit1756);
  }
// compiled string node returning strlit1756 (depth = 5)
    gc_frame_newslot(strlit1756);
    if1735 = strlit1756;
  }
stackframe = iftmpstackframe1735;
// compiled if node returning if1735 (depth = 4)
  *var_opener = if1735;
  if (if1735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String("(");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 6)
  int op_slot_right_1758 = gc_frame_newslot(strlit1759);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opener (depth = 6)
  int op_slot_left_1758 = gc_frame_newslot(*var_opener);
  params[0] = strlit1759;
  partcv[0] = 1;
  Object opresult1761 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1761 (depth = 5)
  Object if1757 = done;
struct StackFrameObject *iftmpstackframe1757 = stackframe;
  if (istrue(opresult1761)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1757);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 5)
  if (strlit1762 == NULL) {
    strlit1762 = alloc_String(")");
    gc_root(strlit1762);
  }
// compiled string node returning strlit1762 (depth = 5)
    gc_frame_newslot(strlit1762);
    if1757 = strlit1762;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1757);
  gc_frame_newslot((Object)stackframe);
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1765 == NULL) {
    strlit1765 = alloc_String("{");
    gc_root(strlit1765);
  }
// compiled string node returning strlit1765 (depth = 7)
  int op_slot_right_1764 = gc_frame_newslot(strlit1765);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_opener (depth = 7)
  int op_slot_left_1764 = gc_frame_newslot(*var_opener);
  params[0] = strlit1765;
  partcv[0] = 1;
  Object opresult1767 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1767 (depth = 6)
  Object if1763 = done;
  if (istrue(opresult1767)) {
// starting to compile string node (depth = 6)
  if (strlit1768 == NULL) {
    strlit1768 = alloc_String("}");
    gc_root(strlit1768);
  }
// compiled string node returning strlit1768 (depth = 6)
    gc_frame_newslot(strlit1768);
    if1763 = strlit1768;
  } else {
// starting to compile string node (depth = 6)
  if (strlit1769 == NULL) {
    strlit1769 = alloc_String("-nothing-");
    gc_root(strlit1769);
  }
// compiled string node returning strlit1769 (depth = 6)
    gc_frame_newslot(strlit1769);
    if1763 = strlit1769;
  }
// compiled if node returning if1763 (depth = 5)
    gc_frame_newslot(if1763);
    if1757 = if1763;
  }
stackframe = iftmpstackframe1757;
// compiled if node returning if1757 (depth = 4)
  *var_closer = if1757;
  if (if1757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("-missing-");
    gc_root(strlit1772);
  }
// compiled string node returning strlit1772 (depth = 5)
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_opener (depth = 5)
  int op_slot_left_1771 = gc_frame_newslot(*var_opener);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1774 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult1774 (depth = 4)
  Object if1770 = done;
  if (istrue(opresult1774)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1775 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1776 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1777 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1776);
// compiled call node returning call1777 (depth = 8)
// compiled member node returning call1777 (depth = 7)
  partcv[0] = 0;
  Object call1778 = callmethod(call1777, "new",
    1, partcv, params);
  gc_frame_end(callframe1775);
// compiled call node returning call1778 (depth = 6)
// compiled member node returning call1778 (depth = 5)
  *var_suggestion = call1778;
  if (call1778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1779 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1780 = alloc_Block(NULL, NULL, "parser", 603);
  gc_frame_newslot(block1780);
// method "_apply"
  block_savedest(block1780);
  Object closure1781 = createclosure(2, "_apply");
  setclosureframe(closure1781, stackframe);
  addtoclosure(closure1781, var_btok);
  addtoclosure(closure1781, selfslot);
  struct UserObject *uo1781 = (struct UserObject*)block1780;
  uo1781->data[0] = (Object)closure1781;
  Method *meth_meth_parser__apply1781 = addmethod2pos(block1780, "_apply", &meth_parser__apply1781, 0);
  int argcv_meth_parser__apply1781[] = {1};
  meth_meth_parser__apply1781->type = alloc_MethodType(1, argcv_meth_parser__apply1781);
  meth_meth_parser__apply1781->definitionModule = modulename;
  meth_meth_parser__apply1781->definitionLine = 601;
// compiled block node returning block1780 (depth = 6)
  gc_frame_newslot(block1780);
// call case 4: self request
  params[0] = block1780;
  partcv[0] = 1;
  Object call1835 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1779);
// compiled call node returning call1835 (depth = 5)
  *var_nextTok = call1835;
  if (call1835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1837 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1839 = alloc_Boolean(0);
// compiled identifier node returning bool1839 (depth = 6)
  int op_slot_left_1837 = gc_frame_newslot(bool1839);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1840 = callmethod(bool1839, "==", 1, partcv, params);
// compiled op node returning opresult1840 (depth = 5)
  Object if1836 = done;
  if (istrue(opresult1840)) {
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1841 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1842 == NULL) {
    strlit1842 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then {");
    gc_root(strlit1842);
  }
// compiled string node returning strlit1842 (depth = 6)
  gc_frame_newslot(strlit1842);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1842;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1843 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1841);
// compiled call node returning call1843 (depth = 5)
    gc_frame_newslot(call1843);
    if1836 = call1843;
  } else {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1846 == NULL) {
    strlit1846 = alloc_String("rparen");
    gc_root(strlit1846);
  }
// compiled string node returning strlit1846 (depth = 7)
  int op_slot_right_1845 = gc_frame_newslot(strlit1846);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1848 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1849 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1848);
// compiled call node returning call1849 (depth = 8)
// compiled member node returning call1849 (depth = 7)
  int op_slot_left_1845 = gc_frame_newslot(call1849);
  params[0] = strlit1846;
  partcv[0] = 1;
  Object opresult1850 = callmethod(call1849, "==", 1, partcv, params);
// compiled op node returning opresult1850 (depth = 6)
  Object if1844 = done;
  if (istrue(opresult1850)) {
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1852 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1852 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1854 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1854 (depth = 7)
  Object if1851 = done;
  if (istrue(opresult1854)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1855 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1856 == NULL) {
    strlit1856 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb""");
    gc_root(strlit1856);
  }
// compiled string node returning strlit1856 (depth = 8)
  gc_frame_newslot(strlit1856);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1856;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1857 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1855);
// compiled call node returning call1857 (depth = 7)
    gc_frame_newslot(call1857);
    if1851 = call1857;
  } else {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1858 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1859 == NULL) {
    strlit1859 = alloc_String("(");
    gc_root(strlit1859);
  }
// compiled string node returning strlit1859 (depth = 8)
  gc_frame_newslot(strlit1859);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1859;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1860 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1858);
// compiled call node returning call1860 (depth = 7)
    gc_frame_newslot(call1860);
    if1851 = call1860;
  }
// compiled if node returning if1851 (depth = 6)
    gc_frame_newslot(if1851);
    if1844 = if1851;
  } else {
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1863 == NULL) {
    strlit1863 = alloc_String("lbrace");
    gc_root(strlit1863);
  }
// compiled string node returning strlit1863 (depth = 8)
  int op_slot_right_1862 = gc_frame_newslot(strlit1863);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1866 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1865);
// compiled call node returning call1866 (depth = 9)
// compiled member node returning call1866 (depth = 8)
  int op_slot_left_1862 = gc_frame_newslot(call1866);
  params[0] = strlit1863;
  partcv[0] = 1;
  Object opresult1867 = callmethod(call1866, "==", 1, partcv, params);
// compiled op node returning opresult1867 (depth = 7)
  Object if1861 = done;
  if (istrue(opresult1867)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1869 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1869 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1871 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1871 (depth = 8)
  Object if1868 = done;
  if (istrue(opresult1871)) {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1872 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1873 == NULL) {
    strlit1873 = alloc_String(" (""\xc2""""\xab""condition""\xc2""""\xbb"") then");
    gc_root(strlit1873);
  }
// compiled string node returning strlit1873 (depth = 9)
  gc_frame_newslot(strlit1873);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1873;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1874 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1872);
// compiled call node returning call1874 (depth = 8)
    gc_frame_newslot(call1874);
    if1868 = call1874;
  } else {
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1875 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1876 == NULL) {
    strlit1876 = alloc_String("(");
    gc_root(strlit1876);
  }
// compiled string node returning strlit1876 (depth = 9)
  gc_frame_newslot(strlit1876);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1876;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1877 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1875);
// compiled call node returning call1877 (depth = 8)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1878 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1879 == NULL) {
    strlit1879 = alloc_String(") then");
    gc_root(strlit1879);
  }
// compiled string node returning strlit1879 (depth = 9)
  gc_frame_newslot(strlit1879);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1880 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1881 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1880);
// compiled call node returning call1881 (depth = 10)
// compiled member node returning call1881 (depth = 9)
  gc_frame_newslot(call1881);
// starting to compile identifier node (depth = 9)
  Object bool1882 = alloc_Boolean(1);
// compiled identifier node returning bool1882 (depth = 9)
  gc_frame_newslot(bool1882);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1879;
  params[1] = call1881;
  params[2] = bool1882;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1883 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1878);
// compiled call node returning call1883 (depth = 8)
    gc_frame_newslot(call1883);
    if1868 = call1883;
  }
// compiled if node returning if1868 (depth = 7)
    gc_frame_newslot(if1868);
    if1861 = if1868;
  } else {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1886 == NULL) {
    strlit1886 = alloc_String("identifier");
    gc_root(strlit1886);
  }
// compiled string node returning strlit1886 (depth = 9)
  int op_slot_right_1885 = gc_frame_newslot(strlit1886);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1889 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1888);
// compiled call node returning call1889 (depth = 10)
// compiled member node returning call1889 (depth = 9)
  int op_slot_left_1885 = gc_frame_newslot(call1889);
  params[0] = strlit1886;
  partcv[0] = 1;
  Object opresult1890 = callmethod(call1889, "==", 1, partcv, params);
// compiled op node returning opresult1890 (depth = 8)
  Object if1884 = done;
  if (istrue(opresult1890)) {
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1892 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1892 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1894 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 9)
  Object if1891 = done;
  if (istrue(opresult1894)) {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1895 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1896 == NULL) {
    strlit1896 = alloc_String("(""\xc2""""\xab""condition""\xc2""""\xbb"") ");
    gc_root(strlit1896);
  }
// compiled string node returning strlit1896 (depth = 10)
  gc_frame_newslot(strlit1896);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1896;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1897 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1895);
// compiled call node returning call1897 (depth = 9)
    gc_frame_newslot(call1897);
    if1891 = call1897;
  } else {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1898 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1899 == NULL) {
    strlit1899 = alloc_String("(");
    gc_root(strlit1899);
  }
// compiled string node returning strlit1899 (depth = 10)
  gc_frame_newslot(strlit1899);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1899;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1900 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1898);
// compiled call node returning call1900 (depth = 9)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1901 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1902 == NULL) {
    strlit1902 = alloc_String(")");
    gc_root(strlit1902);
  }
// compiled string node returning strlit1902 (depth = 10)
  gc_frame_newslot(strlit1902);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1904 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compiled call node returning call1904 (depth = 11)
// compiled member node returning call1904 (depth = 10)
  gc_frame_newslot(call1904);
// starting to compile identifier node (depth = 10)
  Object bool1905 = alloc_Boolean(1);
// compiled identifier node returning bool1905 (depth = 10)
  gc_frame_newslot(bool1905);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1902;
  params[1] = call1904;
  params[2] = bool1905;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1906 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1901);
// compiled call node returning call1906 (depth = 9)
    gc_frame_newslot(call1906);
    if1891 = call1906;
  }
// compiled if node returning if1891 (depth = 8)
    gc_frame_newslot(if1891);
    if1884 = if1891;
  } else {
  }
// compiled if node returning if1884 (depth = 7)
    gc_frame_newslot(if1884);
    if1861 = if1884;
  }
// compiled if node returning if1861 (depth = 6)
    gc_frame_newslot(if1861);
    if1844 = if1861;
  }
// compiled if node returning if1844 (depth = 5)
    gc_frame_newslot(if1844);
    if1836 = if1844;
  }
// compiled if node returning if1836 (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1907 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1909 == NULL) {
    strlit1909 = alloc_String("in parentheses or braces after the 'if'.");
    gc_root(strlit1909);
  }
// compiled string node returning strlit1909 (depth = 6)
  int op_slot_right_1908 = gc_frame_newslot(strlit1909);
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1911 == NULL) {
    strlit1911 = alloc_String("an if statement must have a condition ");
    gc_root(strlit1911);
  }
// compiled string node returning strlit1911 (depth = 6)
  int op_slot_left_1908 = gc_frame_newslot(strlit1911);
  params[0] = strlit1909;
  partcv[0] = 1;
  Object opresult1912 = callmethod(strlit1911, "++", 1, partcv, params);
// compiled op node returning opresult1912 (depth = 5)
  gc_frame_newslot(opresult1912);
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1914 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1913);
// compiled call node returning call1914 (depth = 6)
// compiled member node returning call1914 (depth = 5)
  gc_frame_newslot(call1914);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1916 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1915);
// compiled call node returning call1916 (depth = 6)
// compiled member node returning call1916 (depth = 5)
  gc_frame_newslot(call1916);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult1912;
  params[1] = call1914;
  params[2] = call1916;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1917 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1907);
// compiled call node returning call1917 (depth = 4)
    gc_frame_newslot(call1917);
    if1770 = call1917;
  } else {
  }
// compiled if node returning if1770 (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1918 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1919 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1918);
// compiled call node returning call1919 (depth = 4)
// compiled member node returning call1919 (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1921 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1922 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1923 = alloc_Block(NULL, NULL, "parser", 634);
  gc_frame_newslot(block1923);
// method "_apply"
  block_savedest(block1923);
  Object closure1924 = createclosure(2, "_apply");
  setclosureframe(closure1924, stackframe);
  addtoclosure(closure1924, var_blocksOK);
  addtoclosure(closure1924, selfslot);
  struct UserObject *uo1924 = (struct UserObject*)block1923;
  uo1924->data[0] = (Object)closure1924;
  Method *meth_meth_parser__apply1924 = addmethod2pos(block1923, "_apply", &meth_parser__apply1924, 0);
  int argcv_meth_parser__apply1924[] = {0};
  meth_meth_parser__apply1924->type = alloc_MethodType(1, argcv_meth_parser__apply1924);
  meth_meth_parser__apply1924->definitionModule = modulename;
  meth_meth_parser__apply1924->definitionLine = 634;
// compiled block node returning block1923 (depth = 7)
  gc_frame_newslot(block1923);
// call case 4: self request
  params[0] = block1923;
  partcv[0] = 1;
  Object call1928 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1922);
// compiled call node returning call1928 (depth = 6)
  partcv[0] = 0;
  Object call1929 = callmethod(call1928, "not",
    1, partcv, params);
  gc_frame_end(callframe1921);
// compiled call node returning call1929 (depth = 5)
// compiled member node returning call1929 (depth = 4)
  Object if1920 = done;
  if (istrue(call1929)) {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1930 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1932 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1931);
// compiled call node returning call1932 (depth = 8)
// compiled member node returning call1932 (depth = 7)
  partcv[0] = 0;
  Object call1933 = callmethod(call1932, "new",
    1, partcv, params);
  gc_frame_end(callframe1930);
// compiled call node returning call1933 (depth = 6)
// compiled member node returning call1933 (depth = 5)
  *var_suggestion = call1933;
  if (call1933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1934 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1935 = alloc_Block(NULL, NULL, "parser", 637);
  gc_frame_newslot(block1935);
// method "_apply"
  block_savedest(block1935);
  Object closure1936 = createclosure(2, "_apply");
  setclosureframe(closure1936, stackframe);
  addtoclosure(closure1936, var_lastToken);
  addtoclosure(closure1936, selfslot);
  struct UserObject *uo1936 = (struct UserObject*)block1935;
  uo1936->data[0] = (Object)closure1936;
  Method *meth_meth_parser__apply1936 = addmethod2pos(block1935, "_apply", &meth_parser__apply1936, 0);
  int argcv_meth_parser__apply1936[] = {1};
  meth_meth_parser__apply1936->type = alloc_MethodType(1, argcv_meth_parser__apply1936);
  meth_meth_parser__apply1936->definitionModule = modulename;
  meth_meth_parser__apply1936->definitionLine = 635;
// compiled block node returning block1935 (depth = 6)
  gc_frame_newslot(block1935);
// call case 4: self request
  params[0] = block1935;
  partcv[0] = 1;
  Object call1954 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1954 (depth = 5)
  *var_nextTok = call1954;
  if (call1954 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_1956 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool1958 = alloc_Boolean(0);
// compiled identifier node returning bool1958 (depth = 6)
  int op_slot_left_1956 = gc_frame_newslot(bool1958);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult1959 = callmethod(bool1958, "==", 1, partcv, params);
// compiled op node returning opresult1959 (depth = 5)
  Object if1955 = done;
  if (istrue(opresult1959)) {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1960 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array1961 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit1962 == NULL) {
    strlit1962 = alloc_String("rparen");
    gc_root(strlit1962);
  }
// compiled string node returning strlit1962 (depth = 8)
  params[0] = strlit1962;
  partcv[0] = 1;
  callmethodflags(array1961, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array1961 (depth = 7)
  gc_frame_newslot(array1961);
// call case 4: self request
  params[0] = array1961;
  partcv[0] = 1;
  Object call1963 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1960);
// compiled call node returning call1963 (depth = 6)
  *var_nextTok = call1963;
  if (call1963 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1966 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1966 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1968 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1968 (depth = 6)
  Object if1965 = done;
  if (istrue(opresult1968)) {
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1969 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1970 == NULL) {
    strlit1970 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1970);
  }
// compiled string node returning strlit1970 (depth = 7)
  gc_frame_newslot(strlit1970);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1970;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1971 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1969);
// compiled call node returning call1971 (depth = 6)
    gc_frame_newslot(call1971);
    if1965 = call1971;
  } else {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1972 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1974 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1973);
// compiled call node returning call1974 (depth = 8)
// compiled member node returning call1974 (depth = 7)
  gc_frame_newslot(call1974);
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1975 = alloc_Boolean(1);
// compiled identifier node returning bool1975 (depth = 7)
  gc_frame_newslot(bool1975);
// starting to compile identifier node (depth = 7)
  Object bool1976 = alloc_Boolean(0);
// compiled identifier node returning bool1976 (depth = 7)
  gc_frame_newslot(bool1976);
// starting to compile string node (depth = 7)
  if (strlit1977 == NULL) {
    strlit1977 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1977);
  }
// compiled string node returning strlit1977 (depth = 7)
  gc_frame_newslot(strlit1977);
// call case 6: other member request
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1974;
  params[2] = bool1975;
  params[3] = bool1976;
  params[4] = strlit1977;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1978 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1972);
// compiled call node returning call1978 (depth = 6)
    gc_frame_newslot(call1978);
    if1965 = call1978;
  }
// compiled if node returning if1965 (depth = 5)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1979 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1981 == NULL) {
    strlit1981 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1981);
  }
// compiled string node returning strlit1981 (depth = 7)
  int op_slot_right_1980 = gc_frame_newslot(strlit1981);
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1983 == NULL) {
    strlit1983 = alloc_String("an if statement must have a ");
    gc_root(strlit1983);
  }
// compiled string node returning strlit1983 (depth = 7)
  int op_slot_left_1980 = gc_frame_newslot(strlit1983);
  params[0] = strlit1981;
  partcv[0] = 1;
  Object opresult1984 = callmethod(strlit1983, "++", 1, partcv, params);
// compiled op node returning opresult1984 (depth = 6)
  gc_frame_newslot(opresult1984);
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1986 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1985);
// compiled call node returning call1986 (depth = 7)
// compiled member node returning call1986 (depth = 6)
  gc_frame_newslot(call1986);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1988 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1987);
// compiled call node returning call1988 (depth = 7)
// compiled member node returning call1988 (depth = 6)
  gc_frame_newslot(call1988);
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult1984;
  params[1] = call1986;
  params[2] = call1988;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1989 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1979);
// compiled call node returning call1989 (depth = 5)
    gc_frame_newslot(call1989);
    if1955 = call1989;
  } else {
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1991 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1991 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1993 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1993 (depth = 6)
  Object if1990 = done;
  if (istrue(opresult1993)) {
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1994 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1995 == NULL) {
    strlit1995 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1995);
  }
// compiled string node returning strlit1995 (depth = 7)
  gc_frame_newslot(strlit1995);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1995;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1996 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1994);
// compiled call node returning call1996 (depth = 6)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1997 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1999 == NULL) {
    strlit1999 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit1999);
  }
// compiled string node returning strlit1999 (depth = 8)
  int op_slot_right_1998 = gc_frame_newslot(strlit1999);
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("an if statement must have a ");
    gc_root(strlit2001);
  }
// compiled string node returning strlit2001 (depth = 8)
  int op_slot_left_1998 = gc_frame_newslot(strlit2001);
  params[0] = strlit1999;
  partcv[0] = 1;
  Object opresult2002 = callmethod(strlit2001, "++", 1, partcv, params);
// compiled op node returning opresult2002 (depth = 7)
  gc_frame_newslot(opresult2002);
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2004 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2003);
// compiled call node returning call2004 (depth = 8)
// compiled member node returning call2004 (depth = 7)
  gc_frame_newslot(call2004);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2006 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2005);
// compiled call node returning call2006 (depth = 8)
// compiled member node returning call2006 (depth = 7)
  gc_frame_newslot(call2006);
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2002;
  params[1] = call2004;
  params[2] = call2006;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2007 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1997);
// compiled call node returning call2007 (depth = 6)
    gc_frame_newslot(call2007);
    if1990 = call2007;
  } else {
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2008 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call2010 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2009);
// compiled call node returning call2010 (depth = 8)
// compiled member node returning call2010 (depth = 7)
  gc_frame_newslot(call2010);
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool2011 = alloc_Boolean(0);
// compiled identifier node returning bool2011 (depth = 7)
  gc_frame_newslot(bool2011);
// starting to compile identifier node (depth = 7)
  Object bool2012 = alloc_Boolean(1);
// compiled identifier node returning bool2012 (depth = 7)
  gc_frame_newslot(bool2012);
// starting to compile string node (depth = 7)
  if (strlit2013 == NULL) {
    strlit2013 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2013);
  }
// compiled string node returning strlit2013 (depth = 7)
  gc_frame_newslot(strlit2013);
// call case 6: other member request
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call2010;
  params[2] = bool2011;
  params[3] = bool2012;
  params[4] = strlit2013;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2014 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2008);
// compiled call node returning call2014 (depth = 6)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2015 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2017 == NULL) {
    strlit2017 = alloc_String("condition in parentheses or braces after the 'if'.");
    gc_root(strlit2017);
  }
// compiled string node returning strlit2017 (depth = 8)
  int op_slot_right_2016 = gc_frame_newslot(strlit2017);
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("an if statement must have a ");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 8)
  int op_slot_left_2016 = gc_frame_newslot(strlit2019);
  params[0] = strlit2017;
  partcv[0] = 1;
  Object opresult2020 = callmethod(strlit2019, "++", 1, partcv, params);
// compiled op node returning opresult2020 (depth = 7)
  gc_frame_newslot(opresult2020);
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2022 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2021);
// compiled call node returning call2022 (depth = 8)
// compiled member node returning call2022 (depth = 7)
  gc_frame_newslot(call2022);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2024 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 8)
// compiled member node returning call2024 (depth = 7)
  gc_frame_newslot(call2024);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2026 = alloc_Float64(1);
// compiled num node returning num2026 (depth = 8)
  int op_slot_right_2025 = gc_frame_newslot(num2026);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call2029 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2028);
// compiled call node returning call2029 (depth = 9)
// compiled member node returning call2029 (depth = 8)
  int op_slot_left_2025 = gc_frame_newslot(call2029);
  params[0] = num2026;
  partcv[0] = 1;
  Object diff2030 = callmethod(call2029, "-", 1, partcv, params);
// compiled op node returning diff2030 (depth = 7)
  gc_frame_newslot(diff2030);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2020;
  params[1] = call2022;
  params[2] = call2024;
  params[3] = diff2030;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2031 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2015);
// compiled call node returning call2031 (depth = 6)
    gc_frame_newslot(call2031);
    if1990 = call2031;
  }
// compiled if node returning if1990 (depth = 5)
    gc_frame_newslot(if1990);
    if1955 = if1990;
  }
// compiled if node returning if1955 (depth = 4)
    gc_frame_newslot(if1955);
    if1920 = if1955;
  } else {
  }
// compiled if node returning if1920 (depth = 3)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_closer (depth = 5)
  int op_slot_right_2033 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2035 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call2036 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2035);
// compiled call node returning call2036 (depth = 6)
// compiled member node returning call2036 (depth = 5)
  int op_slot_left_2033 = gc_frame_newslot(call2036);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2037 = callmethod(call2036, "≠", 1, partcv, params);
// compiled op node returning opresult2037 (depth = 4)
  Object if2032 = done;
  if (istrue(opresult2037)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2039 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2038);
// compiled call node returning call2039 (depth = 5)
// compiled member node returning call2039 (depth = 4)
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2040 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2041 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2042 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2041);
// compiled call node returning call2042 (depth = 8)
// compiled member node returning call2042 (depth = 7)
  partcv[0] = 0;
  Object call2043 = callmethod(call2042, "new",
    1, partcv, params);
  gc_frame_end(callframe2040);
// compiled call node returning call2043 (depth = 6)
// compiled member node returning call2043 (depth = 5)
  *var_suggestion = call2043;
  if (call2043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2044 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2045 == NULL) {
    strlit2045 = alloc_String(")");
    gc_root(strlit2045);
  }
// compiled string node returning strlit2045 (depth = 5)
  gc_frame_newslot(strlit2045);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit2045;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2046 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2044);
// compiled call node returning call2046 (depth = 4)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2047 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2050 == NULL) {
    strlit2050 = alloc_String("'.");
    gc_root(strlit2050);
  }
// compiled string node returning strlit2050 (depth = 7)
  int op_slot_right_2049 = gc_frame_newslot(strlit2050);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_2052 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2055 == NULL) {
    strlit2055 = alloc_String("' must end with a '");
    gc_root(strlit2055);
  }
// compiled string node returning strlit2055 (depth = 9)
  int op_slot_right_2054 = gc_frame_newslot(strlit2055);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_right_2057 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 10)
  if (strlit2059 == NULL) {
    strlit2059 = alloc_String("'");
    gc_root(strlit2059);
  }
// compiled string node returning strlit2059 (depth = 10)
  int op_slot_left_2057 = gc_frame_newslot(strlit2059);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2060 = callmethod(strlit2059, "++", 1, partcv, params);
// compiled op node returning opresult2060 (depth = 9)
  int op_slot_left_2054 = gc_frame_newslot(opresult2060);
  params[0] = strlit2055;
  partcv[0] = 1;
  Object opresult2061 = callmethod(opresult2060, "++", 1, partcv, params);
// compiled op node returning opresult2061 (depth = 8)
  int op_slot_left_2052 = gc_frame_newslot(opresult2061);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2062 = callmethod(opresult2061, "++", 1, partcv, params);
// compiled op node returning opresult2062 (depth = 7)
  int op_slot_left_2049 = gc_frame_newslot(opresult2062);
  params[0] = strlit2050;
  partcv[0] = 1;
  Object opresult2063 = callmethod(opresult2062, "++", 1, partcv, params);
// compiled op node returning opresult2063 (depth = 6)
  int op_slot_right_2048 = gc_frame_newslot(opresult2063);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2065 == NULL) {
    strlit2065 = alloc_String("an expression beginning with a ");
    gc_root(strlit2065);
  }
// compiled string node returning strlit2065 (depth = 6)
  int op_slot_left_2048 = gc_frame_newslot(strlit2065);
  params[0] = opresult2063;
  partcv[0] = 1;
  Object opresult2066 = callmethod(strlit2065, "++", 1, partcv, params);
// compiled op node returning opresult2066 (depth = 5)
  gc_frame_newslot(opresult2066);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2067 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call2068 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2067);
// compiled call node returning call2068 (depth = 6)
// compiled member node returning call2068 (depth = 5)
  gc_frame_newslot(call2068);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2071 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2070);
// compiled call node returning call2071 (depth = 7)
// compiled member node returning call2071 (depth = 6)
  int op_slot_right_2069 = gc_frame_newslot(call2071);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2073 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2074 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2073);
// compiled call node returning call2074 (depth = 7)
// compiled member node returning call2074 (depth = 6)
  int op_slot_left_2069 = gc_frame_newslot(call2074);
  params[0] = call2071;
  partcv[0] = 1;
  Object sum2075 = callmethod(call2074, "+", 1, partcv, params);
// compiled op node returning sum2075 (depth = 5)
  gc_frame_newslot(sum2075);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult2066;
  params[1] = call2068;
  params[2] = sum2075;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2076 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2047);
// compiled call node returning call2076 (depth = 4)
    gc_frame_newslot(call2076);
    if2032 = call2076;
  } else {
  }
// compiled if node returning if2032 (depth = 3)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2078 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2077);
// compiled call node returning call2078 (depth = 4)
// compiled member node returning call2078 (depth = 3)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2079 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call2080 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2079);
// compiled call node returning call2080 (depth = 5)
// compiled member node returning call2080 (depth = 4)
  *var_cond = call2080;
  if (call2080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2081 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2081 (depth = 4)
  *var_body = array2081;
  if (array2081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array2082 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2082 (depth = 4)
  *var_elseblock = array2082;
  if (array2082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2084 = alloc_Float64(2);
// compiled num node returning num2084 (depth = 5)
  int op_slot_right_2083 = gc_frame_newslot(num2084);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_2083 = gc_frame_newslot(*var_statementIndent);
  params[0] = num2084;
  partcv[0] = 1;
  Object sum2086 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum2086 (depth = 4)
  *var_minInd = sum2086;
  if (sum2086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("then");
    gc_root(strlit2090);
  }
// compiled string node returning strlit2090 (depth = 6)
  int op_slot_right_2089 = gc_frame_newslot(strlit2090);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2092 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2093 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2092);
// compiled call node returning call2093 (depth = 7)
// compiled member node returning call2093 (depth = 6)
  int op_slot_left_2089 = gc_frame_newslot(call2093);
  params[0] = strlit2090;
  partcv[0] = 1;
  Object opresult2094 = callmethod(call2093, "==", 1, partcv, params);
// compiled op node returning opresult2094 (depth = 5)
  int op_slot_right_2088 = gc_frame_newslot(opresult2094);
// starting to compile call node (depth = 5)
  int callframe2096 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2097 == NULL) {
    strlit2097 = alloc_String("identifier");
    gc_root(strlit2097);
  }
// compiled string node returning strlit2097 (depth = 6)
  gc_frame_newslot(strlit2097);
// call case 4: self request
  params[0] = strlit2097;
  partcv[0] = 1;
  Object call2098 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2096);
// compiled call node returning call2098 (depth = 5)
  int op_slot_left_2088 = gc_frame_newslot(call2098);
  params[0] = opresult2094;
  partcv[0] = 1;
  Object opresult2099 = callmethod(call2098, "&&", 1, partcv, params);
// compiled op node returning opresult2099 (depth = 4)
  Object if2087 = done;
  if (istrue(opresult2099)) {
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2101 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2100);
// compiled call node returning call2101 (depth = 5)
// compiled member node returning call2101 (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2104 == NULL) {
    strlit2104 = alloc_String("lbrace");
    gc_root(strlit2104);
  }
// compiled string node returning strlit2104 (depth = 6)
  int op_slot_right_2103 = gc_frame_newslot(strlit2104);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2107 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2106);
// compiled call node returning call2107 (depth = 7)
// compiled member node returning call2107 (depth = 6)
  int op_slot_left_2103 = gc_frame_newslot(call2107);
  params[0] = strlit2104;
  partcv[0] = 1;
  Object opresult2108 = callmethod(call2107, "≠", 1, partcv, params);
// compiled op node returning opresult2108 (depth = 5)
  Object if2102 = done;
  if (istrue(opresult2108)) {
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2109 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call2111 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2110);
// compiled call node returning call2111 (depth = 9)
// compiled member node returning call2111 (depth = 8)
  partcv[0] = 0;
  Object call2112 = callmethod(call2111, "new",
    1, partcv, params);
  gc_frame_end(callframe2109);
// compiled call node returning call2112 (depth = 7)
// compiled member node returning call2112 (depth = 6)
  *var_suggestion = call2112;
  if (call2112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2114 = alloc_Boolean(1);
// compiled identifier node returning bool2114 (depth = 7)
  gc_frame_newslot(bool2114);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2114;
  partcv[0] = 2;
  Object call2115 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2113);
// compiled call node returning call2115 (depth = 6)
  *var_closingBrace = call2115;
  if (call2115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2117 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2118 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2119 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2118);
// compiled call node returning call2119 (depth = 9)
// compiled member node returning call2119 (depth = 8)
  partcv[0] = 0;
  Object call2120 = callmethod(call2119, "not",
    1, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2120 (depth = 7)
// compiled member node returning call2120 (depth = 6)
  Object if2116 = done;
  if (istrue(call2120)) {
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2122 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2125 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2124);
// compiled call node returning call2125 (depth = 9)
// compiled member node returning call2125 (depth = 8)
  int op_slot_left_2122 = gc_frame_newslot(call2125);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2126 = callmethod(call2125, "==", 1, partcv, params);
// compiled op node returning opresult2126 (depth = 7)
  Object if2121 = done;
  if (istrue(opresult2126)) {
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2127 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2128 = alloc_Boolean(0);
// compiled identifier node returning bool2128 (depth = 8)
  gc_frame_newslot(bool2128);
// starting to compile identifier node (depth = 8)
  Object bool2129 = alloc_Boolean(1);
// compiled identifier node returning bool2129 (depth = 8)
  gc_frame_newslot(bool2129);
// starting to compile string node (depth = 8)
  if (strlit2130 == NULL) {
    strlit2130 = alloc_String("then {}");
    gc_root(strlit2130);
  }
// compiled string node returning strlit2130 (depth = 8)
  gc_frame_newslot(strlit2130);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2128;
  params[2] = bool2129;
  params[3] = strlit2130;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2131 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2127);
// compiled call node returning call2131 (depth = 7)
    gc_frame_newslot(call2131);
    if2121 = call2131;
  } else {
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2132 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2134 = alloc_Float64(0.1);
// compiled num node returning num2134 (depth = 9)
  int op_slot_right_2133 = gc_frame_newslot(num2134);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2136 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2138 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2137);
// compiled call node returning call2138 (depth = 12)
// compiled member node returning call2138 (depth = 11)
  partcv[0] = 0;
  Object call2139 = callmethod(call2138, "line",
    1, partcv, params);
  gc_frame_end(callframe2136);
// compiled call node returning call2139 (depth = 10)
// compiled member node returning call2139 (depth = 9)
  int op_slot_left_2133 = gc_frame_newslot(call2139);
  params[0] = num2134;
  partcv[0] = 1;
  Object sum2140 = callmethod(call2139, "+", 1, partcv, params);
// compiled op node returning sum2140 (depth = 8)
  gc_frame_newslot(sum2140);
// starting to compile string node (depth = 8)
  if (strlit2141 == NULL) {
    strlit2141 = alloc_String("}");
    gc_root(strlit2141);
  }
// compiled string node returning strlit2141 (depth = 8)
  gc_frame_newslot(strlit2141);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2140;
  params[1] = strlit2141;
  partcv[0] = 2;
  Object call2142 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2132);
// compiled call node returning call2142 (depth = 7)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2143 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2144 = alloc_Boolean(0);
// compiled identifier node returning bool2144 (depth = 8)
  gc_frame_newslot(bool2144);
// starting to compile identifier node (depth = 8)
  Object bool2145 = alloc_Boolean(1);
// compiled identifier node returning bool2145 (depth = 8)
  gc_frame_newslot(bool2145);
// starting to compile string node (depth = 8)
  if (strlit2146 == NULL) {
    strlit2146 = alloc_String("then {");
    gc_root(strlit2146);
  }
// compiled string node returning strlit2146 (depth = 8)
  gc_frame_newslot(strlit2146);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2144;
  params[2] = bool2145;
  params[3] = strlit2146;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2147 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2143);
// compiled call node returning call2147 (depth = 7)
    gc_frame_newslot(call2147);
    if2121 = call2147;
  }
// compiled if node returning if2121 (depth = 6)
    gc_frame_newslot(if2121);
    if2116 = if2121;
  } else {
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2148 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool2149 = alloc_Boolean(0);
// compiled identifier node returning bool2149 (depth = 7)
  gc_frame_newslot(bool2149);
// starting to compile identifier node (depth = 7)
  Object bool2150 = alloc_Boolean(1);
// compiled identifier node returning bool2150 (depth = 7)
  gc_frame_newslot(bool2150);
// starting to compile string node (depth = 7)
  if (strlit2151 == NULL) {
    strlit2151 = alloc_String("then {");
    gc_root(strlit2151);
  }
// compiled string node returning strlit2151 (depth = 7)
  gc_frame_newslot(strlit2151);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool2149;
  params[2] = bool2150;
  params[3] = strlit2151;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2152 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2148);
// compiled call node returning call2152 (depth = 6)
    gc_frame_newslot(call2152);
    if2116 = call2152;
  }
// compiled if node returning if2116 (depth = 5)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2153 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2154 == NULL) {
    strlit2154 = alloc_String("an if statement must have a '{' after the 'then'.");
    gc_root(strlit2154);
  }
// compiled string node returning strlit2154 (depth = 6)
  gc_frame_newslot(strlit2154);
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2156 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2155);
// compiled call node returning call2156 (depth = 7)
// compiled member node returning call2156 (depth = 6)
  gc_frame_newslot(call2156);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2159 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2158);
// compiled call node returning call2159 (depth = 8)
// compiled member node returning call2159 (depth = 7)
  int op_slot_right_2157 = gc_frame_newslot(call2159);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2162 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2161);
// compiled call node returning call2162 (depth = 8)
// compiled member node returning call2162 (depth = 7)
  int op_slot_left_2157 = gc_frame_newslot(call2162);
  params[0] = call2159;
  partcv[0] = 1;
  Object sum2163 = callmethod(call2162, "+", 1, partcv, params);
// compiled op node returning sum2163 (depth = 6)
  gc_frame_newslot(sum2163);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2154;
  params[1] = call2156;
  params[2] = sum2163;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2164 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2153);
// compiled call node returning call2164 (depth = 5)
    gc_frame_newslot(call2164);
    if2102 = call2164;
  } else {
  }
// compiled if node returning if2102 (depth = 4)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2166 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2165);
// compiled call node returning call2166 (depth = 5)
// compiled member node returning call2166 (depth = 4)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2170 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2169);
// compiled call node returning call2170 (depth = 7)
// compiled member node returning call2170 (depth = 6)
  int op_slot_right_2168 = gc_frame_newslot(call2170);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2173 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2172);
// compiled call node returning call2173 (depth = 7)
// compiled member node returning call2173 (depth = 6)
  int op_slot_left_2168 = gc_frame_newslot(call2173);
  params[0] = call2170;
  partcv[0] = 1;
  Object opresult2174 = callmethod(call2173, "==", 1, partcv, params);
// compiled op node returning opresult2174 (depth = 5)
  Object if2167 = done;
  if (istrue(opresult2174)) {
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2176 = alloc_Float64(1);
// compiled num node returning num2176 (depth = 7)
  int op_slot_right_2175 = gc_frame_newslot(num2176);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2179 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2178);
// compiled call node returning call2179 (depth = 8)
// compiled member node returning call2179 (depth = 7)
  int op_slot_left_2175 = gc_frame_newslot(call2179);
  params[0] = num2176;
  partcv[0] = 1;
  Object diff2180 = callmethod(call2179, "-", 1, partcv, params);
// compiled op node returning diff2180 (depth = 6)
  *var_minIndentLevel = diff2180;
  if (diff2180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2167 = done;
  } else {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2167 = done;
  }
// compiled if node returning if2167 (depth = 4)
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2183 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2184 = alloc_Block(NULL, NULL, "parser", 716);
  gc_frame_newslot(block2184);
// method "_apply"
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_parser__apply2185 = addmethod2pos(block2184, "_apply", &meth_parser__apply2185, 0);
  int argcv_meth_parser__apply2185[] = {0};
  meth_meth_parser__apply2185->type = alloc_MethodType(1, argcv_meth_parser__apply2185);
  meth_meth_parser__apply2185->definitionModule = modulename;
  meth_meth_parser__apply2185->definitionLine = 712;
// compiled block node returning block2184 (depth = 5)
  gc_frame_newslot(block2184);
// starting to compile block node (depth = 5)
  Object block2192 = alloc_Block(NULL, NULL, "parser", 716);
  gc_frame_newslot(block2192);
// method "_apply"
  block_savedest(block2192);
  Object closure2193 = createclosure(8, "_apply");
  setclosureframe(closure2193, stackframe);
  addtoclosure(closure2193, var_errormessages);
  addtoclosure(closure2193, var_btok);
  addtoclosure(closure2193, var_lastToken);
  addtoclosure(closure2193, var_sym);
  addtoclosure(closure2193, var_values);
  addtoclosure(closure2193, var_v);
  addtoclosure(closure2193, var_body);
  addtoclosure(closure2193, selfslot);
  struct UserObject *uo2193 = (struct UserObject*)block2192;
  uo2193->data[0] = (Object)closure2193;
  Method *meth_meth_parser__apply2193 = addmethod2pos(block2192, "_apply", &meth_parser__apply2193, 0);
  int argcv_meth_parser__apply2193[] = {0};
  meth_meth_parser__apply2193->type = alloc_MethodType(1, argcv_meth_parser__apply2193);
  meth_meth_parser__apply2193->definitionModule = modulename;
  meth_meth_parser__apply2193->definitionLine = 716;
// compiled block node returning block2192 (depth = 5)
  gc_frame_newslot(block2192);
// call case 5: prelude request
  params[0] = block2184;
  params[1] = block2192;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2251 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2251 (depth = 4)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2253 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2252);
// compiled call node returning call2253 (depth = 5)
// compiled member node returning call2253 (depth = 4)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2254 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2255 = alloc_Block(NULL, NULL, "parser", 739);
  gc_frame_newslot(block2255);
// method "_apply"
  block_savedest(block2255);
  Object closure2256 = createclosure(2, "_apply");
  setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_sym);
  addtoclosure(closure2256, selfslot);
  struct UserObject *uo2256 = (struct UserObject*)block2255;
  uo2256->data[0] = (Object)closure2256;
  Method *meth_meth_parser__apply2256 = addmethod2pos(block2255, "_apply", &meth_parser__apply2256, 0);
  int argcv_meth_parser__apply2256[] = {0};
  meth_meth_parser__apply2256->type = alloc_MethodType(1, argcv_meth_parser__apply2256);
  meth_meth_parser__apply2256->definitionModule = modulename;
  meth_meth_parser__apply2256->definitionLine = 734;
// compiled block node returning block2255 (depth = 5)
  gc_frame_newslot(block2255);
// starting to compile block node (depth = 5)
  Object block2270 = alloc_Block(NULL, NULL, "parser", 739);
  gc_frame_newslot(block2270);
// method "_apply"
  block_savedest(block2270);
  Object closure2271 = createclosure(16, "_apply");
  setclosureframe(closure2271, stackframe);
  addtoclosure(closure2271, var_sym);
  addtoclosure(closure2271, var_statementToken);
  addtoclosure(closure2271, var_errormessages);
  addtoclosure(closure2271, var_blocksOK);
  addtoclosure(closure2271, var_lastToken);
  addtoclosure(closure2271, var_values);
  addtoclosure(closure2271, var_econd);
  addtoclosure(closure2271, var_ebody);
  addtoclosure(closure2271, var_btok);
  addtoclosure(closure2271, var_minIndentLevel);
  addtoclosure(closure2271, var_minInd);
  addtoclosure(closure2271, var_v);
  addtoclosure(closure2271, var_newelse);
  addtoclosure(closure2271, var_eif);
  addtoclosure(closure2271, var_curelse);
  addtoclosure(closure2271, selfslot);
  struct UserObject *uo2271 = (struct UserObject*)block2270;
  uo2271->data[0] = (Object)closure2271;
  Method *meth_meth_parser__apply2271 = addmethod2pos(block2270, "_apply", &meth_parser__apply2271, 0);
  int argcv_meth_parser__apply2271[] = {0};
  meth_meth_parser__apply2271->type = alloc_MethodType(1, argcv_meth_parser__apply2271);
  meth_meth_parser__apply2271->definitionModule = modulename;
  meth_meth_parser__apply2271->definitionLine = 739;
// compiled block node returning block2270 (depth = 5)
  gc_frame_newslot(block2270);
// call case 5: prelude request
  params[0] = block2255;
  params[1] = block2270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2889 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2254);
// compiled call node returning call2889 (depth = 4)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2893 == NULL) {
    strlit2893 = alloc_String("else");
    gc_root(strlit2893);
  }
// compiled string node returning strlit2893 (depth = 7)
  int op_slot_right_2892 = gc_frame_newslot(strlit2893);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2896 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2895);
// compiled call node returning call2896 (depth = 8)
// compiled member node returning call2896 (depth = 7)
  int op_slot_left_2892 = gc_frame_newslot(call2896);
  params[0] = strlit2893;
  partcv[0] = 1;
  Object opresult2897 = callmethod(call2896, "==", 1, partcv, params);
// compiled op node returning opresult2897 (depth = 6)
  int op_slot_right_2891 = gc_frame_newslot(opresult2897);
// starting to compile call node (depth = 6)
  int callframe2899 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2900 == NULL) {
    strlit2900 = alloc_String("identifier");
    gc_root(strlit2900);
  }
// compiled string node returning strlit2900 (depth = 7)
  gc_frame_newslot(strlit2900);
// call case 4: self request
  params[0] = strlit2900;
  partcv[0] = 1;
  Object call2901 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2899);
// compiled call node returning call2901 (depth = 6)
  int op_slot_left_2891 = gc_frame_newslot(call2901);
  params[0] = opresult2897;
  partcv[0] = 1;
  Object opresult2902 = callmethod(call2901, "&&", 1, partcv, params);
// compiled op node returning opresult2902 (depth = 5)
  Object if2890 = done;
  if (istrue(opresult2902)) {
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2903 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2904 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2903);
// compiled call node returning call2904 (depth = 6)
// compiled member node returning call2904 (depth = 5)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2907 == NULL) {
    strlit2907 = alloc_String("lbrace");
    gc_root(strlit2907);
  }
// compiled string node returning strlit2907 (depth = 7)
  int op_slot_right_2906 = gc_frame_newslot(strlit2907);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2910 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2909);
// compiled call node returning call2910 (depth = 8)
// compiled member node returning call2910 (depth = 7)
  int op_slot_left_2906 = gc_frame_newslot(call2910);
  params[0] = strlit2907;
  partcv[0] = 1;
  Object opresult2911 = callmethod(call2910, "≠", 1, partcv, params);
// compiled op node returning opresult2911 (depth = 6)
  Object if2905 = done;
  if (istrue(opresult2911)) {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2912 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2914 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2913);
// compiled call node returning call2914 (depth = 10)
// compiled member node returning call2914 (depth = 9)
  partcv[0] = 0;
  Object call2915 = callmethod(call2914, "new",
    1, partcv, params);
  gc_frame_end(callframe2912);
// compiled call node returning call2915 (depth = 8)
// compiled member node returning call2915 (depth = 7)
  *var_suggestion = call2915;
  if (call2915 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2916 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2917 = alloc_Boolean(1);
// compiled identifier node returning bool2917 (depth = 8)
  gc_frame_newslot(bool2917);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2917;
  partcv[0] = 2;
  Object call2918 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2916);
// compiled call node returning call2918 (depth = 7)
  *var_closingBrace = call2918;
  if (call2918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2920 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2922 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2921);
// compiled call node returning call2922 (depth = 10)
// compiled member node returning call2922 (depth = 9)
  partcv[0] = 0;
  Object call2923 = callmethod(call2922, "not",
    1, partcv, params);
  gc_frame_end(callframe2920);
// compiled call node returning call2923 (depth = 8)
// compiled member node returning call2923 (depth = 7)
  Object if2919 = done;
  if (istrue(call2923)) {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2925 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2928 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2927);
// compiled call node returning call2928 (depth = 10)
// compiled member node returning call2928 (depth = 9)
  int op_slot_left_2925 = gc_frame_newslot(call2928);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2929 = callmethod(call2928, "==", 1, partcv, params);
// compiled op node returning opresult2929 (depth = 8)
  Object if2924 = done;
  if (istrue(opresult2929)) {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2930 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2931 = alloc_Boolean(0);
// compiled identifier node returning bool2931 (depth = 9)
  gc_frame_newslot(bool2931);
// starting to compile identifier node (depth = 9)
  Object bool2932 = alloc_Boolean(1);
// compiled identifier node returning bool2932 (depth = 9)
  gc_frame_newslot(bool2932);
// starting to compile string node (depth = 9)
  if (strlit2933 == NULL) {
    strlit2933 = alloc_String("else {}");
    gc_root(strlit2933);
  }
// compiled string node returning strlit2933 (depth = 9)
  gc_frame_newslot(strlit2933);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2931;
  params[2] = bool2932;
  params[3] = strlit2933;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2934 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2930);
// compiled call node returning call2934 (depth = 8)
    gc_frame_newslot(call2934);
    if2924 = call2934;
  } else {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2935 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2937 = alloc_Float64(0.1);
// compiled num node returning num2937 (depth = 10)
  int op_slot_right_2936 = gc_frame_newslot(num2937);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2939 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2941 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2940);
// compiled call node returning call2941 (depth = 13)
// compiled member node returning call2941 (depth = 12)
  partcv[0] = 0;
  Object call2942 = callmethod(call2941, "line",
    1, partcv, params);
  gc_frame_end(callframe2939);
// compiled call node returning call2942 (depth = 11)
// compiled member node returning call2942 (depth = 10)
  int op_slot_left_2936 = gc_frame_newslot(call2942);
  params[0] = num2937;
  partcv[0] = 1;
  Object sum2943 = callmethod(call2942, "+", 1, partcv, params);
// compiled op node returning sum2943 (depth = 9)
  gc_frame_newslot(sum2943);
// starting to compile string node (depth = 9)
  if (strlit2944 == NULL) {
    strlit2944 = alloc_String("}");
    gc_root(strlit2944);
  }
// compiled string node returning strlit2944 (depth = 9)
  gc_frame_newslot(strlit2944);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2943;
  params[1] = strlit2944;
  partcv[0] = 2;
  Object call2945 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2935);
// compiled call node returning call2945 (depth = 8)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2946 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2947 = alloc_Boolean(0);
// compiled identifier node returning bool2947 (depth = 9)
  gc_frame_newslot(bool2947);
// starting to compile identifier node (depth = 9)
  Object bool2948 = alloc_Boolean(1);
// compiled identifier node returning bool2948 (depth = 9)
  gc_frame_newslot(bool2948);
// starting to compile string node (depth = 9)
  if (strlit2949 == NULL) {
    strlit2949 = alloc_String("else {");
    gc_root(strlit2949);
  }
// compiled string node returning strlit2949 (depth = 9)
  gc_frame_newslot(strlit2949);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2947;
  params[2] = bool2948;
  params[3] = strlit2949;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2950 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2946);
// compiled call node returning call2950 (depth = 8)
    gc_frame_newslot(call2950);
    if2924 = call2950;
  }
// compiled if node returning if2924 (depth = 7)
    gc_frame_newslot(if2924);
    if2919 = if2924;
  } else {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2951 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2952 = alloc_Boolean(0);
// compiled identifier node returning bool2952 (depth = 8)
  gc_frame_newslot(bool2952);
// starting to compile identifier node (depth = 8)
  Object bool2953 = alloc_Boolean(1);
// compiled identifier node returning bool2953 (depth = 8)
  gc_frame_newslot(bool2953);
// starting to compile string node (depth = 8)
  if (strlit2954 == NULL) {
    strlit2954 = alloc_String("else {");
    gc_root(strlit2954);
  }
// compiled string node returning strlit2954 (depth = 8)
  gc_frame_newslot(strlit2954);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2952;
  params[2] = bool2953;
  params[3] = strlit2954;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2955 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2951);
// compiled call node returning call2955 (depth = 7)
    gc_frame_newslot(call2955);
    if2919 = call2955;
  }
// compiled if node returning if2919 (depth = 6)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2956 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2957 == NULL) {
    strlit2957 = alloc_String("an else statement must have a '{' after the 'else'.");
    gc_root(strlit2957);
  }
// compiled string node returning strlit2957 (depth = 7)
  gc_frame_newslot(strlit2957);
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2959 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2958);
// compiled call node returning call2959 (depth = 8)
// compiled member node returning call2959 (depth = 7)
  gc_frame_newslot(call2959);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2962 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2961);
// compiled call node returning call2962 (depth = 9)
// compiled member node returning call2962 (depth = 8)
  int op_slot_right_2960 = gc_frame_newslot(call2962);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2965 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2964);
// compiled call node returning call2965 (depth = 9)
// compiled member node returning call2965 (depth = 8)
  int op_slot_left_2960 = gc_frame_newslot(call2965);
  params[0] = call2962;
  partcv[0] = 1;
  Object sum2966 = callmethod(call2965, "+", 1, partcv, params);
// compiled op node returning sum2966 (depth = 7)
  gc_frame_newslot(sum2966);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2957;
  params[1] = call2959;
  params[2] = sum2966;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2967 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2956);
// compiled call node returning call2967 (depth = 6)
    gc_frame_newslot(call2967);
    if2905 = call2967;
  } else {
  }
// compiled if node returning if2905 (depth = 5)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2968 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2969 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2968);
// compiled call node returning call2969 (depth = 6)
// compiled member node returning call2969 (depth = 5)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2973 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2972);
// compiled call node returning call2973 (depth = 8)
// compiled member node returning call2973 (depth = 7)
  int op_slot_right_2971 = gc_frame_newslot(call2973);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2976 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2975);
// compiled call node returning call2976 (depth = 8)
// compiled member node returning call2976 (depth = 7)
  int op_slot_left_2971 = gc_frame_newslot(call2976);
  params[0] = call2973;
  partcv[0] = 1;
  Object opresult2977 = callmethod(call2976, "==", 1, partcv, params);
// compiled op node returning opresult2977 (depth = 6)
  Object if2970 = done;
  if (istrue(opresult2977)) {
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2979 = alloc_Float64(1);
// compiled num node returning num2979 (depth = 8)
  int op_slot_right_2978 = gc_frame_newslot(num2979);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2982 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2981);
// compiled call node returning call2982 (depth = 9)
// compiled member node returning call2982 (depth = 8)
  int op_slot_left_2978 = gc_frame_newslot(call2982);
  params[0] = num2979;
  partcv[0] = 1;
  Object diff2983 = callmethod(call2982, "-", 1, partcv, params);
// compiled op node returning diff2983 (depth = 7)
  *var_minIndentLevel = diff2983;
  if (diff2983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2970 = done;
  } else {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2970 = done;
  }
// compiled if node returning if2970 (depth = 5)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2986 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2987 = alloc_Block(NULL, NULL, "parser", 932);
  gc_frame_newslot(block2987);
// method "_apply"
  block_savedest(block2987);
  Object closure2988 = createclosure(1, "_apply");
  setclosureframe(closure2988, stackframe);
  addtoclosure(closure2988, selfslot);
  struct UserObject *uo2988 = (struct UserObject*)block2987;
  uo2988->data[0] = (Object)closure2988;
  Method *meth_meth_parser__apply2988 = addmethod2pos(block2987, "_apply", &meth_parser__apply2988, 0);
  int argcv_meth_parser__apply2988[] = {0};
  meth_meth_parser__apply2988->type = alloc_MethodType(1, argcv_meth_parser__apply2988);
  meth_meth_parser__apply2988->definitionModule = modulename;
  meth_meth_parser__apply2988->definitionLine = 928;
// compiled block node returning block2987 (depth = 6)
  gc_frame_newslot(block2987);
// starting to compile block node (depth = 6)
  Object block2995 = alloc_Block(NULL, NULL, "parser", 932);
  gc_frame_newslot(block2995);
// method "_apply"
  block_savedest(block2995);
  Object closure2996 = createclosure(8, "_apply");
  setclosureframe(closure2996, stackframe);
  addtoclosure(closure2996, var_errormessages);
  addtoclosure(closure2996, var_btok);
  addtoclosure(closure2996, var_lastToken);
  addtoclosure(closure2996, var_sym);
  addtoclosure(closure2996, var_values);
  addtoclosure(closure2996, var_v);
  addtoclosure(closure2996, var_curelse);
  addtoclosure(closure2996, selfslot);
  struct UserObject *uo2996 = (struct UserObject*)block2995;
  uo2996->data[0] = (Object)closure2996;
  Method *meth_meth_parser__apply2996 = addmethod2pos(block2995, "_apply", &meth_parser__apply2996, 0);
  int argcv_meth_parser__apply2996[] = {0};
  meth_meth_parser__apply2996->type = alloc_MethodType(1, argcv_meth_parser__apply2996);
  meth_meth_parser__apply2996->definitionModule = modulename;
  meth_meth_parser__apply2996->definitionLine = 932;
// compiled block node returning block2995 (depth = 6)
  gc_frame_newslot(block2995);
// call case 5: prelude request
  params[0] = block2987;
  params[1] = block2995;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3054 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2986);
// compiled call node returning call3054 (depth = 5)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3055 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3056 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3055);
// compiled call node returning call3056 (depth = 6)
// compiled member node returning call3056 (depth = 5)
    gc_frame_newslot(call3056);
    if2890 = call3056;
  } else {
  }
// compiled if node returning if2890 (depth = 4)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3057 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3058 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call3059 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe3058);
// compiled call node returning call3059 (depth = 6)
// compiled member node returning call3059 (depth = 5)
  gc_frame_newslot(call3059);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call3061 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3061 (depth = 6)
// compiled member node returning call3061 (depth = 5)
  gc_frame_newslot(call3061);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call3059;
  params[1] = call3061;
  partcv[0] = 2;
  Object call3062 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe3057);
// compiled call node returning call3062 (depth = 4)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3063 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 4: self request
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call3064 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compiled call node returning call3064 (depth = 5)
  *var_o = call3064;
  if (call3064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3065 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call3066 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3065);
// compiled call node returning call3066 (depth = 4)
    gc_frame_newslot(call3066);
    if2087 = call3066;
  } else {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3067 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3069 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3068);
// compiled call node returning call3069 (depth = 8)
// compiled member node returning call3069 (depth = 7)
  partcv[0] = 0;
  Object call3070 = callmethod(call3069, "new",
    1, partcv, params);
  gc_frame_end(callframe3067);
// compiled call node returning call3070 (depth = 6)
// compiled member node returning call3070 (depth = 5)
  *var_suggestion = call3070;
  if (call3070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3073 == NULL) {
    strlit3073 = alloc_String("lbrace");
    gc_root(strlit3073);
  }
// compiled string node returning strlit3073 (depth = 6)
  int op_slot_right_3072 = gc_frame_newslot(strlit3073);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3076 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3075);
// compiled call node returning call3076 (depth = 7)
// compiled member node returning call3076 (depth = 6)
  int op_slot_left_3072 = gc_frame_newslot(call3076);
  params[0] = strlit3073;
  partcv[0] = 1;
  Object opresult3077 = callmethod(call3076, "==", 1, partcv, params);
// compiled op node returning opresult3077 (depth = 5)
  Object if3071 = done;
  if (istrue(opresult3077)) {
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3078 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3079 = alloc_Boolean(0);
// compiled identifier node returning bool3079 (depth = 7)
  gc_frame_newslot(bool3079);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3079;
  partcv[0] = 2;
  Object call3080 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3078);
// compiled call node returning call3080 (depth = 6)
  *var_closingBrace = call3080;
  if (call3080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3082 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3084 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3083);
// compiled call node returning call3084 (depth = 9)
// compiled member node returning call3084 (depth = 8)
  partcv[0] = 0;
  Object call3085 = callmethod(call3084, "not",
    1, partcv, params);
  gc_frame_end(callframe3082);
// compiled call node returning call3085 (depth = 7)
// compiled member node returning call3085 (depth = 6)
  Object if3081 = done;
  if (istrue(call3085)) {
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3087 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3090 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3089);
// compiled call node returning call3090 (depth = 9)
// compiled member node returning call3090 (depth = 8)
  int op_slot_left_3087 = gc_frame_newslot(call3090);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3091 = callmethod(call3090, "==", 1, partcv, params);
// compiled op node returning opresult3091 (depth = 7)
  Object if3086 = done;
  if (istrue(opresult3091)) {
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3092 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3093 = alloc_Boolean(1);
// compiled identifier node returning bool3093 (depth = 8)
  gc_frame_newslot(bool3093);
// starting to compile identifier node (depth = 8)
  Object bool3094 = alloc_Boolean(0);
// compiled identifier node returning bool3094 (depth = 8)
  gc_frame_newslot(bool3094);
// starting to compile string node (depth = 8)
  if (strlit3095 == NULL) {
    strlit3095 = alloc_String(" then {}");
    gc_root(strlit3095);
  }
// compiled string node returning strlit3095 (depth = 8)
  gc_frame_newslot(strlit3095);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3093;
  params[2] = bool3094;
  params[3] = strlit3095;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3096 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3092);
// compiled call node returning call3096 (depth = 7)
    gc_frame_newslot(call3096);
    if3086 = call3096;
  } else {
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3097 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool3098 = alloc_Boolean(1);
// compiled identifier node returning bool3098 (depth = 8)
  gc_frame_newslot(bool3098);
// starting to compile identifier node (depth = 8)
  Object bool3099 = alloc_Boolean(0);
// compiled identifier node returning bool3099 (depth = 8)
  gc_frame_newslot(bool3099);
// starting to compile string node (depth = 8)
  if (strlit3100 == NULL) {
    strlit3100 = alloc_String(" then {");
    gc_root(strlit3100);
  }
// compiled string node returning strlit3100 (depth = 8)
  gc_frame_newslot(strlit3100);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool3098;
  params[2] = bool3099;
  params[3] = strlit3100;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3101 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3097);
// compiled call node returning call3101 (depth = 7)
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3102 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3104 = alloc_Float64(0.1);
// compiled num node returning num3104 (depth = 9)
  int op_slot_right_3103 = gc_frame_newslot(num3104);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3106 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3108 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3107);
// compiled call node returning call3108 (depth = 12)
// compiled member node returning call3108 (depth = 11)
  partcv[0] = 0;
  Object call3109 = callmethod(call3108, "line",
    1, partcv, params);
  gc_frame_end(callframe3106);
// compiled call node returning call3109 (depth = 10)
// compiled member node returning call3109 (depth = 9)
  int op_slot_left_3103 = gc_frame_newslot(call3109);
  params[0] = num3104;
  partcv[0] = 1;
  Object sum3110 = callmethod(call3109, "+", 1, partcv, params);
// compiled op node returning sum3110 (depth = 8)
  gc_frame_newslot(sum3110);
// starting to compile string node (depth = 8)
  if (strlit3111 == NULL) {
    strlit3111 = alloc_String("}");
    gc_root(strlit3111);
  }
// compiled string node returning strlit3111 (depth = 8)
  gc_frame_newslot(strlit3111);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3110;
  params[1] = strlit3111;
  partcv[0] = 2;
  Object call3112 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3102);
// compiled call node returning call3112 (depth = 7)
    gc_frame_newslot(call3112);
    if3086 = call3112;
  }
// compiled if node returning if3086 (depth = 6)
    gc_frame_newslot(if3086);
    if3081 = if3086;
  } else {
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3113 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool3114 = alloc_Boolean(1);
// compiled identifier node returning bool3114 (depth = 7)
  gc_frame_newslot(bool3114);
// starting to compile identifier node (depth = 7)
  Object bool3115 = alloc_Boolean(0);
// compiled identifier node returning bool3115 (depth = 7)
  gc_frame_newslot(bool3115);
// starting to compile string node (depth = 7)
  if (strlit3116 == NULL) {
    strlit3116 = alloc_String(" then {");
    gc_root(strlit3116);
  }
// compiled string node returning strlit3116 (depth = 7)
  gc_frame_newslot(strlit3116);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool3114;
  params[2] = bool3115;
  params[3] = strlit3116;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3117 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3113);
// compiled call node returning call3117 (depth = 6)
    gc_frame_newslot(call3117);
    if3081 = call3117;
  }
// compiled if node returning if3081 (depth = 5)
    gc_frame_newslot(if3081);
    if3071 = if3081;
  } else {
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3118 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool3119 = alloc_Boolean(1);
// compiled identifier node returning bool3119 (depth = 7)
  gc_frame_newslot(bool3119);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool3119;
  partcv[0] = 2;
  Object call3120 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3120 (depth = 6)
  *var_closingBrace = call3120;
  if (call3120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3122 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3124 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3123);
// compiled call node returning call3124 (depth = 9)
// compiled member node returning call3124 (depth = 8)
  partcv[0] = 0;
  Object call3125 = callmethod(call3124, "not",
    1, partcv, params);
  gc_frame_end(callframe3122);
// compiled call node returning call3125 (depth = 7)
// compiled member node returning call3125 (depth = 6)
  Object if3121 = done;
  if (istrue(call3125)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_3127 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3129 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call3130 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3129);
// compiled call node returning call3130 (depth = 9)
// compiled member node returning call3130 (depth = 8)
  int op_slot_left_3127 = gc_frame_newslot(call3130);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3131 = callmethod(call3130, "==", 1, partcv, params);
// compiled op node returning opresult3131 (depth = 7)
  Object if3126 = done;
  if (istrue(opresult3131)) {
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3132 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3133 == NULL) {
    strlit3133 = alloc_String(" then {}");
    gc_root(strlit3133);
  }
// compiled string node returning strlit3133 (depth = 8)
  gc_frame_newslot(strlit3133);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3133;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3134 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3132);
// compiled call node returning call3134 (depth = 7)
    gc_frame_newslot(call3134);
    if3126 = call3134;
  } else {
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3135 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3136 == NULL) {
    strlit3136 = alloc_String(" then {");
    gc_root(strlit3136);
  }
// compiled string node returning strlit3136 (depth = 8)
  gc_frame_newslot(strlit3136);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3136;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3137 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3135);
// compiled call node returning call3137 (depth = 7)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3138 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3140 = alloc_Float64(0.1);
// compiled num node returning num3140 (depth = 9)
  int op_slot_right_3139 = gc_frame_newslot(num3140);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3142 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3144 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3143);
// compiled call node returning call3144 (depth = 12)
// compiled member node returning call3144 (depth = 11)
  partcv[0] = 0;
  Object call3145 = callmethod(call3144, "line",
    1, partcv, params);
  gc_frame_end(callframe3142);
// compiled call node returning call3145 (depth = 10)
// compiled member node returning call3145 (depth = 9)
  int op_slot_left_3139 = gc_frame_newslot(call3145);
  params[0] = num3140;
  partcv[0] = 1;
  Object sum3146 = callmethod(call3145, "+", 1, partcv, params);
// compiled op node returning sum3146 (depth = 8)
  gc_frame_newslot(sum3146);
// starting to compile string node (depth = 8)
  if (strlit3147 == NULL) {
    strlit3147 = alloc_String("}");
    gc_root(strlit3147);
  }
// compiled string node returning strlit3147 (depth = 8)
  gc_frame_newslot(strlit3147);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3146;
  params[1] = strlit3147;
  partcv[0] = 2;
  Object call3148 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3138);
// compiled call node returning call3148 (depth = 7)
    gc_frame_newslot(call3148);
    if3126 = call3148;
  }
// compiled if node returning if3126 (depth = 6)
    gc_frame_newslot(if3126);
    if3121 = if3126;
  } else {
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3149 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3150 == NULL) {
    strlit3150 = alloc_String(" then {");
    gc_root(strlit3150);
  }
// compiled string node returning strlit3150 (depth = 7)
  gc_frame_newslot(strlit3150);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3150;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3151 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3149);
// compiled call node returning call3151 (depth = 6)
    gc_frame_newslot(call3151);
    if3121 = call3151;
  }
// compiled if node returning if3121 (depth = 5)
    gc_frame_newslot(if3121);
    if3071 = if3121;
  }
// compiled if node returning if3071 (depth = 4)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3152 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3154 == NULL) {
    strlit3154 = alloc_String("the condition in parentheses.");
    gc_root(strlit3154);
  }
// compiled string node returning strlit3154 (depth = 6)
  int op_slot_right_3153 = gc_frame_newslot(strlit3154);
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3156 == NULL) {
    strlit3156 = alloc_String("an if statement must have 'then' after ");
    gc_root(strlit3156);
  }
// compiled string node returning strlit3156 (depth = 6)
  int op_slot_left_3153 = gc_frame_newslot(strlit3156);
  params[0] = strlit3154;
  partcv[0] = 1;
  Object opresult3157 = callmethod(strlit3156, "++", 1, partcv, params);
// compiled op node returning opresult3157 (depth = 5)
  gc_frame_newslot(opresult3157);
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3159 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3158);
// compiled call node returning call3159 (depth = 6)
// compiled member node returning call3159 (depth = 5)
  gc_frame_newslot(call3159);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3161 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 6)
// compiled member node returning call3161 (depth = 5)
  gc_frame_newslot(call3161);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult3157;
  params[1] = call3159;
  params[2] = call3161;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3162 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3152);
// compiled call node returning call3162 (depth = 4)
    gc_frame_newslot(call3162);
    if2087 = call3162;
  }
// compiled if node returning if2087 (depth = 3)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1720 = done;
  } else {
  }
// compiled if node returning if1720 (depth = 2)
  gc_frame_end(frame);
  return if1720;
}
Object meth_parser_identifier3165(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for identifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for identifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3167 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3168 == NULL) {
    strlit3168 = alloc_String("identifier");
    gc_root(strlit3168);
  }
// compiled string node returning strlit3168 (depth = 4)
  gc_frame_newslot(strlit3168);
// call case 4: self request
  params[0] = strlit3168;
  partcv[0] = 1;
  Object call3169 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3167);
// compiled call node returning call3169 (depth = 3)
  Object if3166 = done;
  if (istrue(call3169)) {
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3172 == NULL) {
    strlit3172 = alloc_String("if");
    gc_root(strlit3172);
  }
// compiled string node returning strlit3172 (depth = 5)
  int op_slot_right_3171 = gc_frame_newslot(strlit3172);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3175 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3174);
// compiled call node returning call3175 (depth = 6)
// compiled member node returning call3175 (depth = 5)
  int op_slot_left_3171 = gc_frame_newslot(call3175);
  params[0] = strlit3172;
  partcv[0] = 1;
  Object opresult3176 = callmethod(call3175, "==", 1, partcv, params);
// compiled op node returning opresult3176 (depth = 4)
  Object if3170 = done;
  if (istrue(opresult3176)) {
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3178 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3177);
// compiled call node returning call3178 (depth = 5)
// compiled member node returning call3178 (depth = 4)
    gc_frame_newslot(call3178);
    if3170 = call3178;
  } else {
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3179 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3180 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3179);
// compiled call node returning call3180 (depth = 5)
// compiled member node returning call3180 (depth = 4)
    gc_frame_newslot(call3180);
    if3170 = call3180;
  }
// compiled if node returning if3170 (depth = 3)
    gc_frame_newslot(if3170);
    if3166 = if3170;
  } else {
  }
// compiled if node returning if3166 (depth = 2)
  gc_frame_end(frame);
  return if3166;
}
Object meth_parser__apply3200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe3201 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3202 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3201);
// compiled call node returning call3202 (depth = 9)
  gc_frame_end(frame);
  return call3202;
}
Object meth_parser__apply3269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3271 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3270);
// compiled call node returning call3271 (depth = 10)
// compiled member node returning call3271 (depth = 9)
  gc_frame_end(frame);
  return call3271;
}
Object meth_parser_prefixop3181(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for prefixop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for prefixop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_mem = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "mem");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3183 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3184 == NULL) {
    strlit3184 = alloc_String("op");
    gc_root(strlit3184);
  }
// compiled string node returning strlit3184 (depth = 4)
  gc_frame_newslot(strlit3184);
// call case 4: self request
  params[0] = strlit3184;
  partcv[0] = 1;
  Object call3185 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3183);
// compiled call node returning call3185 (depth = 3)
  Object if3182 = done;
  if (istrue(call3185)) {
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3187 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3186);
// compiled call node returning call3187 (depth = 5)
// compiled member node returning call3187 (depth = 4)
  *var_op = call3187;
  if (call3187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_val = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3189 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3188);
// compiled call node returning call3189 (depth = 4)
// compiled member node returning call3189 (depth = 3)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3191 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3192 == NULL) {
    strlit3192 = alloc_String("lparen");
    gc_root(strlit3192);
  }
// compiled string node returning strlit3192 (depth = 5)
  gc_frame_newslot(strlit3192);
// call case 4: self request
  params[0] = strlit3192;
  partcv[0] = 1;
  Object call3193 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3191);
// compiled call node returning call3193 (depth = 4)
  Object if3190 = done;
  if (istrue(call3193)) {
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3195 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3194);
// compiled call node returning call3195 (depth = 5)
// compiled member node returning call3195 (depth = 4)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3197 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3198 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3199 = alloc_Block(NULL, NULL, "parser", 1011);
  gc_frame_newslot(block3199);
// method "_apply"
  block_savedest(block3199);
  Object closure3200 = createclosure(2, "_apply");
  setclosureframe(closure3200, stackframe);
  addtoclosure(closure3200, var_blocksOK);
  addtoclosure(closure3200, selfslot);
  struct UserObject *uo3200 = (struct UserObject*)block3199;
  uo3200->data[0] = (Object)closure3200;
  Method *meth_meth_parser__apply3200 = addmethod2pos(block3199, "_apply", &meth_parser__apply3200, 0);
  int argcv_meth_parser__apply3200[] = {0};
  meth_meth_parser__apply3200->type = alloc_MethodType(1, argcv_meth_parser__apply3200);
  meth_meth_parser__apply3200->definitionModule = modulename;
  meth_meth_parser__apply3200->definitionLine = 1011;
// compiled block node returning block3199 (depth = 8)
  gc_frame_newslot(block3199);
// call case 4: self request
  params[0] = block3199;
  partcv[0] = 1;
  Object call3204 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3198);
// compiled call node returning call3204 (depth = 7)
  partcv[0] = 0;
  Object call3205 = callmethod(call3204, "not",
    1, partcv, params);
  gc_frame_end(callframe3197);
// compiled call node returning call3205 (depth = 6)
// compiled member node returning call3205 (depth = 5)
  Object if3196 = done;
  if (istrue(call3205)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3206 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3208 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3207);
// compiled call node returning call3208 (depth = 9)
// compiled member node returning call3208 (depth = 8)
  partcv[0] = 0;
  Object call3209 = callmethod(call3208, "new",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compiled call node returning call3209 (depth = 7)
// compiled member node returning call3209 (depth = 6)
  *var_suggestion = call3209;
  if (call3209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3210 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3211 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3212 == NULL) {
    strlit3212 = alloc_String("rparen");
    gc_root(strlit3212);
  }
// compiled string node returning strlit3212 (depth = 8)
  params[0] = strlit3212;
  partcv[0] = 1;
  callmethodflags(array3211, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3211 (depth = 7)
  gc_frame_newslot(array3211);
// call case 4: self request
  params[0] = array3211;
  partcv[0] = 1;
  Object call3213 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled call node returning call3213 (depth = 6)
  *var_nextTok = call3213;
  if (call3213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3215 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3215 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3217 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3217 (depth = 6)
  Object if3214 = done;
  if (istrue(opresult3217)) {
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3218 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3219 == NULL) {
    strlit3219 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3219);
  }
// compiled string node returning strlit3219 (depth = 7)
  gc_frame_newslot(strlit3219);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3219;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3220 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3218);
// compiled call node returning call3220 (depth = 6)
    gc_frame_newslot(call3220);
    if3214 = call3220;
  } else {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3221 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3223 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3222);
// compiled call node returning call3223 (depth = 8)
// compiled member node returning call3223 (depth = 7)
  gc_frame_newslot(call3223);
// starting to compile identifier node (depth = 7)
  Object bool3224 = alloc_Boolean(1);
// compiled identifier node returning bool3224 (depth = 7)
  gc_frame_newslot(bool3224);
// starting to compile identifier node (depth = 7)
  Object bool3225 = alloc_Boolean(0);
// compiled identifier node returning bool3225 (depth = 7)
  gc_frame_newslot(bool3225);
// starting to compile string node (depth = 7)
  if (strlit3226 == NULL) {
    strlit3226 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3226);
  }
// compiled string node returning strlit3226 (depth = 7)
  gc_frame_newslot(strlit3226);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3223;
  params[2] = bool3224;
  params[3] = bool3225;
  params[4] = strlit3226;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3227 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3221);
// compiled call node returning call3227 (depth = 6)
    gc_frame_newslot(call3227);
    if3214 = call3227;
  }
// compiled if node returning if3214 (depth = 5)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3228 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3229 == NULL) {
    strlit3229 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit3229);
  }
// compiled string node returning strlit3229 (depth = 6)
  gc_frame_newslot(strlit3229);
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3231 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3230);
// compiled call node returning call3231 (depth = 7)
// compiled member node returning call3231 (depth = 6)
  gc_frame_newslot(call3231);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3233 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3232);
// compiled call node returning call3233 (depth = 7)
// compiled member node returning call3233 (depth = 6)
  gc_frame_newslot(call3233);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3229;
  params[1] = call3231;
  params[2] = call3233;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3234 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3228);
// compiled call node returning call3234 (depth = 5)
    gc_frame_newslot(call3234);
    if3196 = call3234;
  } else {
  }
// compiled if node returning if3196 (depth = 4)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("rparen");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 6)
  int op_slot_right_3236 = gc_frame_newslot(strlit3237);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3240 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3239);
// compiled call node returning call3240 (depth = 7)
// compiled member node returning call3240 (depth = 6)
  int op_slot_left_3236 = gc_frame_newslot(call3240);
  params[0] = strlit3237;
  partcv[0] = 1;
  Object opresult3241 = callmethod(call3240, "≠", 1, partcv, params);
// compiled op node returning opresult3241 (depth = 5)
  Object if3235 = done;
  if (istrue(opresult3241)) {
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3243 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3242);
// compiled call node returning call3243 (depth = 6)
// compiled member node returning call3243 (depth = 5)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3244 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3246 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3245);
// compiled call node returning call3246 (depth = 9)
// compiled member node returning call3246 (depth = 8)
  partcv[0] = 0;
  Object call3247 = callmethod(call3246, "new",
    1, partcv, params);
  gc_frame_end(callframe3244);
// compiled call node returning call3247 (depth = 7)
// compiled member node returning call3247 (depth = 6)
  *var_suggestion = call3247;
  if (call3247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3248 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3249 == NULL) {
    strlit3249 = alloc_String(")");
    gc_root(strlit3249);
  }
// compiled string node returning strlit3249 (depth = 6)
  gc_frame_newslot(strlit3249);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3249;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3250 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3248);
// compiled call node returning call3250 (depth = 5)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3251 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3252 == NULL) {
    strlit3252 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3252);
  }
// compiled string node returning strlit3252 (depth = 6)
  gc_frame_newslot(strlit3252);
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3254 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3253);
// compiled call node returning call3254 (depth = 7)
// compiled member node returning call3254 (depth = 6)
  gc_frame_newslot(call3254);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3256 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3257 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3256);
// compiled call node returning call3257 (depth = 8)
// compiled member node returning call3257 (depth = 7)
  int op_slot_right_3255 = gc_frame_newslot(call3257);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3260 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3259);
// compiled call node returning call3260 (depth = 8)
// compiled member node returning call3260 (depth = 7)
  int op_slot_left_3255 = gc_frame_newslot(call3260);
  params[0] = call3257;
  partcv[0] = 1;
  Object sum3261 = callmethod(call3260, "+", 1, partcv, params);
// compiled op node returning sum3261 (depth = 6)
  gc_frame_newslot(sum3261);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3252;
  params[1] = call3254;
  params[2] = sum3261;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3262 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3251);
// compiled call node returning call3262 (depth = 5)
    gc_frame_newslot(call3262);
    if3235 = call3262;
  } else {
  }
// compiled if node returning if3235 (depth = 4)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3264 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3263);
// compiled call node returning call3264 (depth = 5)
// compiled member node returning call3264 (depth = 4)
    gc_frame_newslot(call3264);
    if3190 = call3264;
  } else {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3266 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3267 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3268 = alloc_Block(NULL, NULL, "parser", 1031);
  gc_frame_newslot(block3268);
// method "_apply"
  block_savedest(block3268);
  Object closure3269 = createclosure(1, "_apply");
  setclosureframe(closure3269, stackframe);
  addtoclosure(closure3269, selfslot);
  struct UserObject *uo3269 = (struct UserObject*)block3268;
  uo3269->data[0] = (Object)closure3269;
  Method *meth_meth_parser__apply3269 = addmethod2pos(block3268, "_apply", &meth_parser__apply3269, 0);
  int argcv_meth_parser__apply3269[] = {0};
  meth_meth_parser__apply3269->type = alloc_MethodType(1, argcv_meth_parser__apply3269);
  meth_meth_parser__apply3269->definitionModule = modulename;
  meth_meth_parser__apply3269->definitionLine = 1031;
// compiled block node returning block3268 (depth = 8)
  gc_frame_newslot(block3268);
// call case 4: self request
  params[0] = block3268;
  partcv[0] = 1;
  Object call3273 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3267);
// compiled call node returning call3273 (depth = 7)
  partcv[0] = 0;
  Object call3274 = callmethod(call3273, "not",
    1, partcv, params);
  gc_frame_end(callframe3266);
// compiled call node returning call3274 (depth = 6)
// compiled member node returning call3274 (depth = 5)
  Object if3265 = done;
  if (istrue(call3274)) {
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array3275 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3275 (depth = 6)
  *var_suggestions = array3275;
  if (array3275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3276 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3278 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3277);
// compiled call node returning call3278 (depth = 9)
// compiled member node returning call3278 (depth = 8)
  partcv[0] = 0;
  Object call3279 = callmethod(call3278, "new",
    1, partcv, params);
  gc_frame_end(callframe3276);
// compiled call node returning call3279 (depth = 7)
// compiled member node returning call3279 (depth = 6)
  *var_suggestion = call3279;
  if (call3279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3280 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array3281 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit3282 == NULL) {
    strlit3282 = alloc_String("rparen");
    gc_root(strlit3282);
  }
// compiled string node returning strlit3282 (depth = 8)
  params[0] = strlit3282;
  partcv[0] = 1;
  callmethodflags(array3281, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3281 (depth = 7)
  gc_frame_newslot(array3281);
// call case 4: self request
  params[0] = array3281;
  partcv[0] = 1;
  Object call3283 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3280);
// compiled call node returning call3283 (depth = 6)
  *var_nextTok = call3283;
  if (call3283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3285 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3285 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3287 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3287 (depth = 6)
  Object if3284 = done;
  if (istrue(opresult3287)) {
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3288 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3289);
  }
// compiled string node returning strlit3289 (depth = 7)
  gc_frame_newslot(strlit3289);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3289;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3290 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3288);
// compiled call node returning call3290 (depth = 6)
    gc_frame_newslot(call3290);
    if3284 = call3290;
  } else {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3291 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3293 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3292);
// compiled call node returning call3293 (depth = 8)
// compiled member node returning call3293 (depth = 7)
  gc_frame_newslot(call3293);
// starting to compile identifier node (depth = 7)
  Object bool3294 = alloc_Boolean(1);
// compiled identifier node returning bool3294 (depth = 7)
  gc_frame_newslot(bool3294);
// starting to compile identifier node (depth = 7)
  Object bool3295 = alloc_Boolean(0);
// compiled identifier node returning bool3295 (depth = 7)
  gc_frame_newslot(bool3295);
// starting to compile string node (depth = 7)
  if (strlit3296 == NULL) {
    strlit3296 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3296);
  }
// compiled string node returning strlit3296 (depth = 7)
  gc_frame_newslot(strlit3296);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3293;
  params[2] = bool3294;
  params[3] = bool3295;
  params[4] = strlit3296;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3297 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3291);
// compiled call node returning call3297 (depth = 6)
    gc_frame_newslot(call3297);
    if3284 = call3297;
  }
// compiled if node returning if3284 (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3298 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3299 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3298);
// compiled call node returning call3299 (depth = 5)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3302 == NULL) {
    strlit3302 = alloc_String("bind");
    gc_root(strlit3302);
  }
// compiled string node returning strlit3302 (depth = 7)
  int op_slot_right_3301 = gc_frame_newslot(strlit3302);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3304 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3306 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3305);
// compiled call node returning call3306 (depth = 10)
// compiled member node returning call3306 (depth = 9)
  partcv[0] = 0;
  Object call3307 = callmethod(call3306, "kind",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compiled call node returning call3307 (depth = 8)
// compiled member node returning call3307 (depth = 7)
  int op_slot_left_3301 = gc_frame_newslot(call3307);
  params[0] = strlit3302;
  partcv[0] = 1;
  Object opresult3308 = callmethod(call3307, "==", 1, partcv, params);
// compiled op node returning opresult3308 (depth = 6)
  Object if3300 = done;
  if (istrue(opresult3308)) {
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3309 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3311 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3310);
// compiled call node returning call3311 (depth = 10)
// compiled member node returning call3311 (depth = 9)
  partcv[0] = 0;
  Object call3312 = callmethod(call3311, "new",
    1, partcv, params);
  gc_frame_end(callframe3309);
// compiled call node returning call3312 (depth = 8)
// compiled member node returning call3312 (depth = 7)
  *var_suggestion = call3312;
  if (call3312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3314 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3316 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3315);
// compiled call node returning call3316 (depth = 8)
// compiled member node returning call3316 (depth = 7)
  gc_frame_newslot(call3316);
// starting to compile identifier node (depth = 7)
  Object bool3317 = alloc_Boolean(1);
// compiled identifier node returning bool3317 (depth = 7)
  gc_frame_newslot(bool3317);
// starting to compile identifier node (depth = 7)
  Object bool3318 = alloc_Boolean(0);
// compiled identifier node returning bool3318 (depth = 7)
  gc_frame_newslot(bool3318);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3316;
  params[2] = bool3317;
  params[3] = bool3318;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3319 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3314);
// compiled call node returning call3319 (depth = 6)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3320 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3321 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3322 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3321);
// compiled call node returning call3322 (depth = 8)
// compiled member node returning call3322 (depth = 7)
  gc_frame_newslot(call3322);
// starting to compile identifier node (depth = 7)
  Object bool3323 = alloc_Boolean(1);
// compiled identifier node returning bool3323 (depth = 7)
  gc_frame_newslot(bool3323);
// starting to compile identifier node (depth = 7)
  Object bool3324 = alloc_Boolean(0);
// compiled identifier node returning bool3324 (depth = 7)
  gc_frame_newslot(bool3324);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3322;
  params[1] = bool3323;
  params[2] = bool3324;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3325 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3320);
// compiled call node returning call3325 (depth = 6)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3326 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3327 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3326);
// compiled call node returning call3327 (depth = 6)
    gc_frame_newslot(call3327);
    if3300 = call3327;
  } else {
  }
// compiled if node returning if3300 (depth = 5)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3328 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3329 == NULL) {
    strlit3329 = alloc_String("a prefix operator must be followed by an expression.");
    gc_root(strlit3329);
  }
// compiled string node returning strlit3329 (depth = 6)
  gc_frame_newslot(strlit3329);
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3331 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3330);
// compiled call node returning call3331 (depth = 7)
// compiled member node returning call3331 (depth = 6)
  gc_frame_newslot(call3331);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3334 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3333);
// compiled call node returning call3334 (depth = 8)
// compiled member node returning call3334 (depth = 7)
  int op_slot_right_3332 = gc_frame_newslot(call3334);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3337 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3336);
// compiled call node returning call3337 (depth = 8)
// compiled member node returning call3337 (depth = 7)
  int op_slot_left_3332 = gc_frame_newslot(call3337);
  params[0] = call3334;
  partcv[0] = 1;
  Object sum3338 = callmethod(call3337, "+", 1, partcv, params);
// compiled op node returning sum3338 (depth = 6)
  gc_frame_newslot(sum3338);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3329;
  params[1] = call3331;
  params[2] = sum3338;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3339 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3328);
// compiled call node returning call3339 (depth = 5)
    gc_frame_newslot(call3339);
    if3265 = call3339;
  } else {
  }
// compiled if node returning if3265 (depth = 4)
    gc_frame_newslot(if3265);
    if3190 = if3265;
  }
// compiled if node returning if3190 (depth = 3)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3340 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3341 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3340);
// compiled call node returning call3341 (depth = 3)
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3342 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3343 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3342);
// compiled call node returning call3343 (depth = 3)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3345 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3344);
// compiled call node returning call3345 (depth = 4)
// compiled member node returning call3345 (depth = 3)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3347 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3346);
// compiled call node returning call3347 (depth = 5)
// compiled member node returning call3347 (depth = 4)
  *var_val = call3347;
  if (call3347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3349 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_op (depth = 6)
  int op_slot_right_3350 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 6)
  if (strlit3352 == NULL) {
    strlit3352 = alloc_String("prefix");
    gc_root(strlit3352);
  }
// compiled string node returning strlit3352 (depth = 6)
  int op_slot_left_3350 = gc_frame_newslot(strlit3352);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3353 = callmethod(strlit3352, "++", 1, partcv, params);
// compiled op node returning opresult3353 (depth = 5)
  gc_frame_newslot(opresult3353);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3355 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3354);
// compiled call node returning call3355 (depth = 6)
// compiled member node returning call3355 (depth = 5)
  params[0] = opresult3353;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call3356 = callmethod(call3355, "new",
    1, partcv, params);
  gc_frame_end(callframe3349);
// compiled call node returning call3356 (depth = 4)
  *var_mem = call3356;
  if (call3356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3357 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mem (depth = 5)
  gc_frame_newslot(*var_mem);
// starting to compile array node (depth = 5)
  Object array3358 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3359 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3360 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mem (depth = 9)
  partcv[0] = 0;
  Object call3361 = callmethod(*var_mem, "value",
    1, partcv, params);
  gc_frame_end(callframe3360);
// compiled call node returning call3361 (depth = 8)
// compiled member node returning call3361 (depth = 7)
  gc_frame_newslot(call3361);
// starting to compile array node (depth = 7)
  Object array3362 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3362 (depth = 7)
  gc_frame_newslot(array3362);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call3364 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe3363);
// compiled call node returning call3364 (depth = 8)
// compiled member node returning call3364 (depth = 7)
  params[0] = call3361;
  params[1] = array3362;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3365 = callmethod(call3364, "request()withArgs",
    2, partcv, params);
  gc_frame_end(callframe3359);
// compiled call node returning call3365 (depth = 6)
  params[0] = call3365;
  partcv[0] = 1;
  callmethodflags(array3358, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3358 (depth = 5)
  gc_frame_newslot(array3358);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3367 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe3366);
// compiled call node returning call3367 (depth = 6)
// compiled member node returning call3367 (depth = 5)
  params[0] = *var_mem;
  params[1] = array3358;
  partcv[0] = 2;
  Object call3368 = callmethod(call3367, "new",
    1, partcv, params);
  gc_frame_end(callframe3357);
// compiled call node returning call3368 (depth = 4)
  *var_call = call3368;
  if (call3368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3369 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3370 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3369);
// compiled call node returning call3370 (depth = 3)
    gc_frame_newslot(call3370);
    if3182 = call3370;
  } else {
  }
// compiled if node returning if3182 (depth = 2)
  gc_frame_end(frame);
  return if3182;
}
Object meth_parser__apply3383(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3384 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3385 == NULL) {
    strlit3385 = alloc_String("identifier");
    gc_root(strlit3385);
  }
// compiled string node returning strlit3385 (depth = 6)
  gc_frame_newslot(strlit3385);
// call case 4: self request
  params[0] = strlit3385;
  partcv[0] = 1;
  Object call3386 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled call node returning call3386 (depth = 5)
  gc_frame_end(frame);
  return call3386;
}
Object meth_parser__apply3394(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3395 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3396 == NULL) {
    strlit3396 = alloc_String("dot");
    gc_root(strlit3396);
  }
// compiled string node returning strlit3396 (depth = 8)
  gc_frame_newslot(strlit3396);
// call case 4: self request
  params[0] = strlit3396;
  partcv[0] = 1;
  Object call3397 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3395);
// compiled call node returning call3397 (depth = 7)
  gc_frame_end(frame);
  return call3397;
}
Object meth_parser__apply3400(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3401 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3402 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3401);
// compiled call node returning call3402 (depth = 8)
// compiled member node returning call3402 (depth = 7)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3403 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3404 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3403);
// compiled call node returning call3404 (depth = 9)
// compiled member node returning call3404 (depth = 8)
  *var_memberIn = call3404;
  if (call3404 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3407 == NULL) {
    strlit3407 = alloc_String("identifier");
    gc_root(strlit3407);
  }
// compiled string node returning strlit3407 (depth = 9)
  int op_slot_right_3406 = gc_frame_newslot(strlit3407);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3410 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3409);
// compiled call node returning call3410 (depth = 10)
// compiled member node returning call3410 (depth = 9)
  int op_slot_left_3406 = gc_frame_newslot(call3410);
  params[0] = strlit3407;
  partcv[0] = 1;
  Object opresult3411 = callmethod(call3410, "≠", 1, partcv, params);
// compiled op node returning opresult3411 (depth = 8)
  Object if3405 = done;
  if (istrue(opresult3411)) {
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array3412 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3412 (depth = 9)
  *var_suggestions = array3412;
  if (array3412 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3413 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3415 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3414);
// compiled call node returning call3415 (depth = 12)
// compiled member node returning call3415 (depth = 11)
  partcv[0] = 0;
  Object call3416 = callmethod(call3415, "new",
    1, partcv, params);
  gc_frame_end(callframe3413);
// compiled call node returning call3416 (depth = 10)
// compiled member node returning call3416 (depth = 9)
  *var_suggestion = call3416;
  if (call3416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3417 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3418 == NULL) {
    strlit3418 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3418);
  }
// compiled string node returning strlit3418 (depth = 9)
  gc_frame_newslot(strlit3418);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3418;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3419 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3417);
// compiled call node returning call3419 (depth = 8)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3420 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3421 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3420);
// compiled call node returning call3421 (depth = 8)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3422 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3424 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3423);
// compiled call node returning call3424 (depth = 12)
// compiled member node returning call3424 (depth = 11)
  partcv[0] = 0;
  Object call3425 = callmethod(call3424, "new",
    1, partcv, params);
  gc_frame_end(callframe3422);
// compiled call node returning call3425 (depth = 10)
// compiled member node returning call3425 (depth = 9)
  *var_suggestion = call3425;
  if (call3425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3427 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3428 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3427);
// compiled call node returning call3428 (depth = 8)
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3429 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3430 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3429);
// compiled call node returning call3430 (depth = 8)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3431 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3432 == NULL) {
    strlit3432 = alloc_String("a type name must follow the '.'.");
    gc_root(strlit3432);
  }
// compiled string node returning strlit3432 (depth = 9)
  gc_frame_newslot(strlit3432);
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3434 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3433);
// compiled call node returning call3434 (depth = 10)
// compiled member node returning call3434 (depth = 9)
  gc_frame_newslot(call3434);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3436 = alloc_Float64(1);
// compiled num node returning num3436 (depth = 10)
  int op_slot_right_3435 = gc_frame_newslot(num3436);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call3439 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3438);
// compiled call node returning call3439 (depth = 11)
// compiled member node returning call3439 (depth = 10)
  int op_slot_left_3435 = gc_frame_newslot(call3439);
  params[0] = num3436;
  partcv[0] = 1;
  Object sum3440 = callmethod(call3439, "+", 1, partcv, params);
// compiled op node returning sum3440 (depth = 9)
  gc_frame_newslot(sum3440);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3432;
  params[1] = call3434;
  params[2] = sum3440;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3441 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3431);
// compiled call node returning call3441 (depth = 8)
    gc_frame_newslot(call3441);
    if3405 = call3441;
  } else {
  }
// compiled if node returning if3405 (depth = 7)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3443 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3442);
// compiled call node returning call3443 (depth = 8)
// compiled member node returning call3443 (depth = 7)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3445 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3444);
// compiled call node returning call3445 (depth = 9)
// compiled member node returning call3445 (depth = 8)
  *var_memberName = call3445;
  if (call3445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3446 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3448 = callmethod(*var_memberName, "value",
    1, partcv, params);
  gc_frame_end(callframe3447);
// compiled call node returning call3448 (depth = 10)
// compiled member node returning call3448 (depth = 9)
  gc_frame_newslot(call3448);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ast (depth = 11)
  partcv[0] = 0;
  Object call3450 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3449);
// compiled call node returning call3450 (depth = 10)
// compiled member node returning call3450 (depth = 9)
  params[0] = call3448;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3451 = callmethod(call3450, "new",
    1, partcv, params);
  gc_frame_end(callframe3446);
// compiled call node returning call3451 (depth = 8)
  *var_memberNd = call3451;
  if (call3451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3452 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  partcv[0] = 0;
  Object call3454 = callmethod(*var_memberName, "line",
    1, partcv, params);
  gc_frame_end(callframe3453);
// compiled call node returning call3454 (depth = 9)
// compiled member node returning call3454 (depth = 8)
  gc_frame_newslot(call3454);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3454;
  partcv[0] = 1;
  Object call3455 = callmethod(*var_memberNd, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3452);
// compiled call node returning call3455 (depth = 7)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3456 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_memberName (depth = 10)
  partcv[0] = 0;
  Object call3458 = callmethod(*var_memberName, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 9)
// compiled member node returning call3458 (depth = 8)
  gc_frame_newslot(call3458);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  params[0] = call3458;
  partcv[0] = 1;
  Object call3459 = callmethod(*var_memberNd, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe3456);
// compiled call node returning call3459 (depth = 7)
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3460 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3461 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3460);
// compiled call node returning call3461 (depth = 7)
  gc_frame_end(frame);
  return call3461;
}
Object meth_parser__apply3389(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3390 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3391 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3390);
// compiled call node returning call3391 (depth = 6)
// compiled member node returning call3391 (depth = 5)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3392 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3393 = alloc_Block(NULL, NULL, "parser", 1069);
  gc_frame_newslot(block3393);
// method "_apply"
  block_savedest(block3393);
  Object closure3394 = createclosure(1, "_apply");
  setclosureframe(closure3394, stackframe);
  addtoclosure(closure3394, selfslot);
  struct UserObject *uo3394 = (struct UserObject*)block3393;
  uo3394->data[0] = (Object)closure3394;
  Method *meth_meth_parser__apply3394 = addmethod2pos(block3393, "_apply", &meth_parser__apply3394, 0);
  int argcv_meth_parser__apply3394[] = {0};
  meth_meth_parser__apply3394->type = alloc_MethodType(1, argcv_meth_parser__apply3394);
  meth_meth_parser__apply3394->definitionModule = modulename;
  meth_meth_parser__apply3394->definitionLine = 1068;
// compiled block node returning block3393 (depth = 6)
  gc_frame_newslot(block3393);
// starting to compile block node (depth = 6)
  Object block3399 = alloc_Block(NULL, NULL, "parser", 1069);
  gc_frame_newslot(block3399);
// method "_apply"
  block_savedest(block3399);
  Object closure3400 = createclosure(6, "_apply");
  setclosureframe(closure3400, stackframe);
  addtoclosure(closure3400, var_values);
  addtoclosure(closure3400, var_sym);
  addtoclosure(closure3400, var_errormessages);
  addtoclosure(closure3400, var_lastToken);
  addtoclosure(closure3400, var_ast);
  addtoclosure(closure3400, selfslot);
  struct UserObject *uo3400 = (struct UserObject*)block3399;
  uo3400->data[0] = (Object)closure3400;
  Method *meth_meth_parser__apply3400 = addmethod2pos(block3399, "_apply", &meth_parser__apply3400, 0);
  int argcv_meth_parser__apply3400[] = {0};
  meth_meth_parser__apply3400->type = alloc_MethodType(1, argcv_meth_parser__apply3400);
  meth_meth_parser__apply3400->definitionModule = modulename;
  meth_meth_parser__apply3400->definitionLine = 1068;
// compiled block node returning block3399 (depth = 6)
  gc_frame_newslot(block3399);
// call case 5: prelude request
  params[0] = block3393;
  params[1] = block3399;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3463 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3392);
// compiled call node returning call3463 (depth = 5)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3465 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3464);
// compiled call node returning call3465 (depth = 6)
// compiled member node returning call3465 (depth = 5)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3466 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call3468 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3467);
// compiled call node returning call3468 (depth = 7)
// compiled member node returning call3468 (depth = 6)
  gc_frame_newslot(call3468);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3468;
  partcv[0] = 1;
  Object call3469 = callmethod(*var_gens, "push",
    1, partcv, params);
  gc_frame_end(callframe3466);
// compiled call node returning call3469 (depth = 5)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3471 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3472 == NULL) {
    strlit3472 = alloc_String("comma");
    gc_root(strlit3472);
  }
// compiled string node returning strlit3472 (depth = 7)
  gc_frame_newslot(strlit3472);
// call case 4: self request
  params[0] = strlit3472;
  partcv[0] = 1;
  Object call3473 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3471);
// compiled call node returning call3473 (depth = 6)
  Object if3470 = done;
  if (istrue(call3473)) {
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3474 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3475 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3474);
// compiled call node returning call3475 (depth = 7)
// compiled member node returning call3475 (depth = 6)
    gc_frame_newslot(call3475);
    if3470 = call3475;
  } else {
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("rgeneric");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 8)
  int op_slot_right_3477 = gc_frame_newslot(strlit3478);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3481 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 9)
// compiled member node returning call3481 (depth = 8)
  int op_slot_left_3477 = gc_frame_newslot(call3481);
  params[0] = strlit3478;
  partcv[0] = 1;
  Object opresult3482 = callmethod(call3481, "≠", 1, partcv, params);
// compiled op node returning opresult3482 (depth = 7)
  Object if3476 = done;
  if (istrue(opresult3482)) {
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3483 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3485 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3484);
// compiled call node returning call3485 (depth = 11)
// compiled member node returning call3485 (depth = 10)
  partcv[0] = 0;
  Object call3486 = callmethod(call3485, "new",
    1, partcv, params);
  gc_frame_end(callframe3483);
// compiled call node returning call3486 (depth = 9)
// compiled member node returning call3486 (depth = 8)
  *var_suggestion = call3486;
  if (call3486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3487 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3488 == NULL) {
    strlit3488 = alloc_String(">");
    gc_root(strlit3488);
  }
// compiled string node returning strlit3488 (depth = 8)
  gc_frame_newslot(strlit3488);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3488;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3489 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3487);
// compiled call node returning call3489 (depth = 7)
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3490 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3492 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3491);
// compiled call node returning call3492 (depth = 11)
// compiled member node returning call3492 (depth = 10)
  partcv[0] = 0;
  Object call3493 = callmethod(call3492, "new",
    1, partcv, params);
  gc_frame_end(callframe3490);
// compiled call node returning call3493 (depth = 9)
// compiled member node returning call3493 (depth = 8)
  *var_suggestion2 = call3493;
  if (call3493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3494 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3495 == NULL) {
    strlit3495 = alloc_String(" ");
    gc_root(strlit3495);
  }
// compiled string node returning strlit3495 (depth = 8)
  gc_frame_newslot(strlit3495);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3495;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3496 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3494);
// compiled call node returning call3496 (depth = 7)
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array3497 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3497, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3497, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3497 (depth = 8)
  *var_suggestions = array3497;
  if (array3497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3498 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3499 == NULL) {
    strlit3499 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3499);
  }
// compiled string node returning strlit3499 (depth = 8)
  gc_frame_newslot(strlit3499);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3501 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3500);
// compiled call node returning call3501 (depth = 9)
// compiled member node returning call3501 (depth = 8)
  gc_frame_newslot(call3501);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3503 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3504 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3503);
// compiled call node returning call3504 (depth = 10)
// compiled member node returning call3504 (depth = 9)
  int op_slot_right_3502 = gc_frame_newslot(call3504);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3507 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3506);
// compiled call node returning call3507 (depth = 10)
// compiled member node returning call3507 (depth = 9)
  int op_slot_left_3502 = gc_frame_newslot(call3507);
  params[0] = call3504;
  partcv[0] = 1;
  Object sum3508 = callmethod(call3507, "+", 1, partcv, params);
// compiled op node returning sum3508 (depth = 8)
  gc_frame_newslot(sum3508);
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3499;
  params[1] = call3501;
  params[2] = sum3508;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3509 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3498);
// compiled call node returning call3509 (depth = 7)
    gc_frame_newslot(call3509);
    if3476 = call3509;
  } else {
  }
// compiled if node returning if3476 (depth = 6)
    gc_frame_newslot(if3476);
    if3470 = if3476;
  }
// compiled if node returning if3470 (depth = 5)
  gc_frame_end(frame);
  return if3470;
}
Object meth_parser_generic3371(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for generic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for generic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3373 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3374 == NULL) {
    strlit3374 = alloc_String("lgeneric");
    gc_root(strlit3374);
  }
// compiled string node returning strlit3374 (depth = 4)
  gc_frame_newslot(strlit3374);
// call case 4: self request
  params[0] = strlit3374;
  partcv[0] = 1;
  Object call3375 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3373);
// compiled call node returning call3375 (depth = 3)
  Object if3372 = done;
  if (istrue(call3375)) {
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3377 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3376);
// compiled call node returning call3377 (depth = 5)
// compiled member node returning call3377 (depth = 4)
  *var_id = call3377;
  if (call3377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array3378 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3378 (depth = 4)
  *var_gens = array3378;
  if (array3378 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3380 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3379);
// compiled call node returning call3380 (depth = 4)
// compiled member node returning call3380 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3381 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3382 = alloc_Block(NULL, NULL, "parser", 1067);
  gc_frame_newslot(block3382);
// method "_apply"
  block_savedest(block3382);
  Object closure3383 = createclosure(1, "_apply");
  setclosureframe(closure3383, stackframe);
  addtoclosure(closure3383, selfslot);
  struct UserObject *uo3383 = (struct UserObject*)block3382;
  uo3383->data[0] = (Object)closure3383;
  Method *meth_meth_parser__apply3383 = addmethod2pos(block3382, "_apply", &meth_parser__apply3383, 0);
  int argcv_meth_parser__apply3383[] = {0};
  meth_meth_parser__apply3383->type = alloc_MethodType(1, argcv_meth_parser__apply3383);
  meth_meth_parser__apply3383->definitionModule = modulename;
  meth_meth_parser__apply3383->definitionLine = 1066;
// compiled block node returning block3382 (depth = 4)
  gc_frame_newslot(block3382);
// starting to compile block node (depth = 4)
  Object block3388 = alloc_Block(NULL, NULL, "parser", 1067);
  gc_frame_newslot(block3388);
// method "_apply"
  block_savedest(block3388);
  Object closure3389 = createclosure(8, "_apply");
  setclosureframe(closure3389, stackframe);
  addtoclosure(closure3389, var_values);
  addtoclosure(closure3389, var_sym);
  addtoclosure(closure3389, var_errormessages);
  addtoclosure(closure3389, var_lastToken);
  addtoclosure(closure3389, var_ast);
  addtoclosure(closure3389, var_gens);
  addtoclosure(closure3389, var_startToken);
  addtoclosure(closure3389, selfslot);
  struct UserObject *uo3389 = (struct UserObject*)block3388;
  uo3389->data[0] = (Object)closure3389;
  Method *meth_meth_parser__apply3389 = addmethod2pos(block3388, "_apply", &meth_parser__apply3389, 0);
  int argcv_meth_parser__apply3389[] = {0};
  meth_meth_parser__apply3389->type = alloc_MethodType(1, argcv_meth_parser__apply3389);
  meth_meth_parser__apply3389->definitionModule = modulename;
  meth_meth_parser__apply3389->definitionLine = 1066;
// compiled block node returning block3388 (depth = 4)
  gc_frame_newslot(block3388);
// call case 5: prelude request
  params[0] = block3382;
  params[1] = block3388;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3511 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3381);
// compiled call node returning call3511 (depth = 3)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3514 == NULL) {
    strlit3514 = alloc_String("rgeneric");
    gc_root(strlit3514);
  }
// compiled string node returning strlit3514 (depth = 5)
  int op_slot_right_3513 = gc_frame_newslot(strlit3514);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3517 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3516);
// compiled call node returning call3517 (depth = 6)
// compiled member node returning call3517 (depth = 5)
  int op_slot_left_3513 = gc_frame_newslot(call3517);
  params[0] = strlit3514;
  partcv[0] = 1;
  Object opresult3518 = callmethod(call3517, "≠", 1, partcv, params);
// compiled op node returning opresult3518 (depth = 4)
  Object if3512 = done;
  if (istrue(opresult3518)) {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3519 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3521 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3520);
// compiled call node returning call3521 (depth = 8)
// compiled member node returning call3521 (depth = 7)
  partcv[0] = 0;
  Object call3522 = callmethod(call3521, "new",
    1, partcv, params);
  gc_frame_end(callframe3519);
// compiled call node returning call3522 (depth = 6)
// compiled member node returning call3522 (depth = 5)
  *var_suggestion = call3522;
  if (call3522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3523 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3524 == NULL) {
    strlit3524 = alloc_String(">");
    gc_root(strlit3524);
  }
// compiled string node returning strlit3524 (depth = 5)
  gc_frame_newslot(strlit3524);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3524;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3525 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3523);
// compiled call node returning call3525 (depth = 4)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3526 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3528 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3527);
// compiled call node returning call3528 (depth = 8)
// compiled member node returning call3528 (depth = 7)
  partcv[0] = 0;
  Object call3529 = callmethod(call3528, "new",
    1, partcv, params);
  gc_frame_end(callframe3526);
// compiled call node returning call3529 (depth = 6)
// compiled member node returning call3529 (depth = 5)
  *var_suggestion2 = call3529;
  if (call3529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3530 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3531 == NULL) {
    strlit3531 = alloc_String(" ");
    gc_root(strlit3531);
  }
// compiled string node returning strlit3531 (depth = 5)
  gc_frame_newslot(strlit3531);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3531;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3532 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3530);
// compiled call node returning call3532 (depth = 4)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array3533 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array3533, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array3533, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3533 (depth = 5)
  *var_suggestions = array3533;
  if (array3533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3534 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3535 == NULL) {
    strlit3535 = alloc_String("a type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3535);
  }
// compiled string node returning strlit3535 (depth = 5)
  gc_frame_newslot(strlit3535);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3537 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3536);
// compiled call node returning call3537 (depth = 6)
// compiled member node returning call3537 (depth = 5)
  gc_frame_newslot(call3537);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3540 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3539);
// compiled call node returning call3540 (depth = 7)
// compiled member node returning call3540 (depth = 6)
  int op_slot_right_3538 = gc_frame_newslot(call3540);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3543 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3542);
// compiled call node returning call3543 (depth = 7)
// compiled member node returning call3543 (depth = 6)
  int op_slot_left_3538 = gc_frame_newslot(call3543);
  params[0] = call3540;
  partcv[0] = 1;
  Object sum3544 = callmethod(call3543, "+", 1, partcv, params);
// compiled op node returning sum3544 (depth = 5)
  gc_frame_newslot(sum3544);
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3535;
  params[1] = call3537;
  params[2] = sum3544;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3545 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3534);
// compiled call node returning call3545 (depth = 4)
    gc_frame_newslot(call3545);
    if3512 = call3545;
  } else {
  }
// compiled if node returning if3512 (depth = 3)
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3546 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3547 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3546);
// compiled call node returning call3547 (depth = 4)
// compiled member node returning call3547 (depth = 3)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3548 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3549 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3551 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe3550);
// compiled call node returning call3551 (depth = 6)
// compiled member node returning call3551 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3552 = callmethod(call3551, "new",
    1, partcv, params);
  gc_frame_end(callframe3549);
// compiled call node returning call3552 (depth = 4)
  gc_frame_newslot(call3552);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3552;
  partcv[0] = 1;
  Object call3553 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3548);
// compiled call node returning call3553 (depth = 3)
    gc_frame_newslot(call3553);
    if3372 = call3553;
  } else {
  }
// compiled if node returning if3372 (depth = 2)
  gc_frame_end(frame);
  return if3372;
}
Object meth_parser__apply3592(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("catch");
    gc_root(strlit3596);
  }
// compiled string node returning strlit3596 (depth = 10)
  int op_slot_right_3595 = gc_frame_newslot(strlit3596);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3599 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe3598);
// compiled call node returning call3599 (depth = 11)
// compiled member node returning call3599 (depth = 10)
  int op_slot_left_3595 = gc_frame_newslot(call3599);
  params[0] = strlit3596;
  partcv[0] = 1;
  Object opresult3600 = callmethod(call3599, "==", 1, partcv, params);
// compiled op node returning opresult3600 (depth = 9)
  int op_slot_right_3594 = gc_frame_newslot(opresult3600);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3603 == NULL) {
    strlit3603 = alloc_String("identifier");
    gc_root(strlit3603);
  }
// compiled string node returning strlit3603 (depth = 10)
  int op_slot_right_3602 = gc_frame_newslot(strlit3603);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3606 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3605);
// compiled call node returning call3606 (depth = 11)
// compiled member node returning call3606 (depth = 10)
  int op_slot_left_3602 = gc_frame_newslot(call3606);
  params[0] = strlit3603;
  partcv[0] = 1;
  Object opresult3607 = callmethod(call3606, "==", 1, partcv, params);
// compiled op node returning opresult3607 (depth = 9)
  int op_slot_left_3594 = gc_frame_newslot(opresult3607);
  params[0] = opresult3600;
  partcv[0] = 1;
  Object opresult3608 = callmethod(opresult3607, "&&", 1, partcv, params);
// compiled op node returning opresult3608 (depth = 8)
  int op_slot_right_3593 = gc_frame_newslot(opresult3608);
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call3614 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3613);
// compiled call node returning call3614 (depth = 12)
// compiled member node returning call3614 (depth = 11)
  int op_slot_right_3612 = gc_frame_newslot(call3614);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3617 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe3616);
// compiled call node returning call3617 (depth = 12)
// compiled member node returning call3617 (depth = 11)
  int op_slot_left_3612 = gc_frame_newslot(call3617);
  params[0] = call3614;
  partcv[0] = 1;
  Object opresult3618 = callmethod(call3617, "==", 1, partcv, params);
// compiled op node returning opresult3618 (depth = 10)
  int op_slot_right_3611 = gc_frame_newslot(opresult3618);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("rparen");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 11)
  int op_slot_right_3620 = gc_frame_newslot(strlit3621);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3624 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3623);
// compiled call node returning call3624 (depth = 12)
// compiled member node returning call3624 (depth = 11)
  int op_slot_left_3620 = gc_frame_newslot(call3624);
  params[0] = strlit3621;
  partcv[0] = 1;
  Object opresult3625 = callmethod(call3624, "==", 1, partcv, params);
// compiled op node returning opresult3625 (depth = 10)
  int op_slot_left_3611 = gc_frame_newslot(opresult3625);
  params[0] = opresult3618;
  partcv[0] = 1;
  Object opresult3626 = callmethod(opresult3625, "&&", 1, partcv, params);
// compiled op node returning opresult3626 (depth = 9)
  int op_slot_right_3610 = gc_frame_newslot(opresult3626);
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3629 == NULL) {
    strlit3629 = alloc_String("rbrace");
    gc_root(strlit3629);
  }
// compiled string node returning strlit3629 (depth = 10)
  int op_slot_right_3628 = gc_frame_newslot(strlit3629);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3632 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3631);
// compiled call node returning call3632 (depth = 11)
// compiled member node returning call3632 (depth = 10)
  int op_slot_left_3628 = gc_frame_newslot(call3632);
  params[0] = strlit3629;
  partcv[0] = 1;
  Object opresult3633 = callmethod(call3632, "==", 1, partcv, params);
// compiled op node returning opresult3633 (depth = 9)
  int op_slot_left_3610 = gc_frame_newslot(opresult3633);
  params[0] = opresult3626;
  partcv[0] = 1;
  Object opresult3634 = callmethod(opresult3633, "||", 1, partcv, params);
// compiled op node returning opresult3634 (depth = 8)
  int op_slot_left_3593 = gc_frame_newslot(opresult3634);
  params[0] = opresult3608;
  partcv[0] = 1;
  Object opresult3635 = callmethod(opresult3634, "||", 1, partcv, params);
// compiled op node returning opresult3635 (depth = 7)
  gc_frame_end(frame);
  return opresult3635;
}
Object meth_parser__apply3710(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3711 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3712 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3711);
// compiled call node returning call3712 (depth = 8)
  gc_frame_end(frame);
  return call3712;
}
Object meth_parser__apply3781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3784 == NULL) {
    strlit3784 = alloc_String("catch");
    gc_root(strlit3784);
  }
// compiled string node returning strlit3784 (depth = 6)
  int op_slot_right_3783 = gc_frame_newslot(strlit3784);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3787 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3786);
// compiled call node returning call3787 (depth = 7)
// compiled member node returning call3787 (depth = 6)
  int op_slot_left_3783 = gc_frame_newslot(call3787);
  params[0] = strlit3784;
  partcv[0] = 1;
  Object opresult3788 = callmethod(call3787, "==", 1, partcv, params);
// compiled op node returning opresult3788 (depth = 5)
  int op_slot_right_3782 = gc_frame_newslot(opresult3788);
// starting to compile call node (depth = 5)
  int callframe3790 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3791 == NULL) {
    strlit3791 = alloc_String("identifier");
    gc_root(strlit3791);
  }
// compiled string node returning strlit3791 (depth = 6)
  gc_frame_newslot(strlit3791);
// call case 4: self request
  params[0] = strlit3791;
  partcv[0] = 1;
  Object call3792 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3790);
// compiled call node returning call3792 (depth = 5)
  int op_slot_left_3782 = gc_frame_newslot(call3792);
  params[0] = opresult3788;
  partcv[0] = 1;
  Object opresult3793 = callmethod(call3792, "&&", 1, partcv, params);
// compiled op node returning opresult3793 (depth = 4)
  gc_frame_end(frame);
  return opresult3793;
}
Object meth_parser__apply3815(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe3816 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3817 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3816);
// compiled call node returning call3817 (depth = 11)
  gc_frame_end(frame);
  return call3817;
}
Object meth_parser__apply3796(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3798 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3797);
// compiled call node returning call3798 (depth = 5)
// compiled member node returning call3798 (depth = 4)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3800 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3801 == NULL) {
    strlit3801 = alloc_String("lbrace");
    gc_root(strlit3801);
  }
// compiled string node returning strlit3801 (depth = 6)
  gc_frame_newslot(strlit3801);
// call case 4: self request
  params[0] = strlit3801;
  partcv[0] = 1;
  Object call3802 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3800);
// compiled call node returning call3802 (depth = 5)
  Object if3799 = done;
  if (istrue(call3802)) {
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3803 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3804 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3803);
// compiled call node returning call3804 (depth = 6)
// compiled member node returning call3804 (depth = 5)
    gc_frame_newslot(call3804);
    if3799 = call3804;
  } else {
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3806 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3807 == NULL) {
    strlit3807 = alloc_String("lparen");
    gc_root(strlit3807);
  }
// compiled string node returning strlit3807 (depth = 7)
  gc_frame_newslot(strlit3807);
// call case 4: self request
  params[0] = strlit3807;
  partcv[0] = 1;
  Object call3808 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3806);
// compiled call node returning call3808 (depth = 6)
  Object if3805 = done;
  if (istrue(call3808)) {
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3809 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3810 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3809);
// compiled call node returning call3810 (depth = 7)
// compiled member node returning call3810 (depth = 6)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3812 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3813 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3814 = alloc_Block(NULL, NULL, "parser", 1184);
  gc_frame_newslot(block3814);
// method "_apply"
  block_savedest(block3814);
  Object closure3815 = createclosure(2, "_apply");
  setclosureframe(closure3815, stackframe);
  addtoclosure(closure3815, var_blocksOK);
  addtoclosure(closure3815, selfslot);
  struct UserObject *uo3815 = (struct UserObject*)block3814;
  uo3815->data[0] = (Object)closure3815;
  Method *meth_meth_parser__apply3815 = addmethod2pos(block3814, "_apply", &meth_parser__apply3815, 0);
  int argcv_meth_parser__apply3815[] = {0};
  meth_meth_parser__apply3815->type = alloc_MethodType(1, argcv_meth_parser__apply3815);
  meth_meth_parser__apply3815->definitionModule = modulename;
  meth_meth_parser__apply3815->definitionLine = 1184;
// compiled block node returning block3814 (depth = 10)
  gc_frame_newslot(block3814);
// call case 4: self request
  params[0] = block3814;
  partcv[0] = 1;
  Object call3819 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3813);
// compiled call node returning call3819 (depth = 9)
  partcv[0] = 0;
  Object call3820 = callmethod(call3819, "not",
    1, partcv, params);
  gc_frame_end(callframe3812);
// compiled call node returning call3820 (depth = 8)
// compiled member node returning call3820 (depth = 7)
  Object if3811 = done;
  if (istrue(call3820)) {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3821 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3823 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3822);
// compiled call node returning call3823 (depth = 11)
// compiled member node returning call3823 (depth = 10)
  partcv[0] = 0;
  Object call3824 = callmethod(call3823, "new",
    1, partcv, params);
  gc_frame_end(callframe3821);
// compiled call node returning call3824 (depth = 9)
// compiled member node returning call3824 (depth = 8)
  *var_suggestion = call3824;
  if (call3824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3825 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array3826 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit3827 == NULL) {
    strlit3827 = alloc_String("rparen");
    gc_root(strlit3827);
  }
// compiled string node returning strlit3827 (depth = 10)
  params[0] = strlit3827;
  partcv[0] = 1;
  callmethodflags(array3826, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3826 (depth = 9)
  gc_frame_newslot(array3826);
// call case 4: self request
  params[0] = array3826;
  partcv[0] = 1;
  Object call3828 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3825);
// compiled call node returning call3828 (depth = 8)
  *var_nextTok = call3828;
  if (call3828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3830 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3830 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3832 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 8)
  Object if3829 = done;
  if (istrue(opresult3832)) {
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3833 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3834 == NULL) {
    strlit3834 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3834);
  }
// compiled string node returning strlit3834 (depth = 9)
  gc_frame_newslot(strlit3834);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3834;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3835 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3833);
// compiled call node returning call3835 (depth = 8)
    gc_frame_newslot(call3835);
    if3829 = call3835;
  } else {
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3836 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3838 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3837);
// compiled call node returning call3838 (depth = 10)
// compiled member node returning call3838 (depth = 9)
  gc_frame_newslot(call3838);
// starting to compile identifier node (depth = 9)
  Object bool3839 = alloc_Boolean(1);
// compiled identifier node returning bool3839 (depth = 9)
  gc_frame_newslot(bool3839);
// starting to compile identifier node (depth = 9)
  Object bool3840 = alloc_Boolean(0);
// compiled identifier node returning bool3840 (depth = 9)
  gc_frame_newslot(bool3840);
// starting to compile string node (depth = 9)
  if (strlit3841 == NULL) {
    strlit3841 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3841);
  }
// compiled string node returning strlit3841 (depth = 9)
  gc_frame_newslot(strlit3841);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3838;
  params[2] = bool3839;
  params[3] = bool3840;
  params[4] = strlit3841;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3842 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3836);
// compiled call node returning call3842 (depth = 8)
    gc_frame_newslot(call3842);
    if3829 = call3842;
  }
// compiled if node returning if3829 (depth = 7)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3843 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3844 == NULL) {
    strlit3844 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3844);
  }
// compiled string node returning strlit3844 (depth = 8)
  gc_frame_newslot(strlit3844);
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3846 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3845);
// compiled call node returning call3846 (depth = 9)
// compiled member node returning call3846 (depth = 8)
  gc_frame_newslot(call3846);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3848 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3847);
// compiled call node returning call3848 (depth = 9)
// compiled member node returning call3848 (depth = 8)
  gc_frame_newslot(call3848);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3844;
  params[1] = call3846;
  params[2] = call3848;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3849 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3843);
// compiled call node returning call3849 (depth = 7)
    gc_frame_newslot(call3849);
    if3811 = call3849;
  } else {
  }
// compiled if node returning if3811 (depth = 6)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3852 == NULL) {
    strlit3852 = alloc_String("rparen");
    gc_root(strlit3852);
  }
// compiled string node returning strlit3852 (depth = 8)
  int op_slot_right_3851 = gc_frame_newslot(strlit3852);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3854 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3855 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3854);
// compiled call node returning call3855 (depth = 9)
// compiled member node returning call3855 (depth = 8)
  int op_slot_left_3851 = gc_frame_newslot(call3855);
  params[0] = strlit3852;
  partcv[0] = 1;
  Object opresult3856 = callmethod(call3855, "≠", 1, partcv, params);
// compiled op node returning opresult3856 (depth = 7)
  Object if3850 = done;
  if (istrue(opresult3856)) {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3858 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3857);
// compiled call node returning call3858 (depth = 8)
// compiled member node returning call3858 (depth = 7)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3859 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3861 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3860);
// compiled call node returning call3861 (depth = 11)
// compiled member node returning call3861 (depth = 10)
  partcv[0] = 0;
  Object call3862 = callmethod(call3861, "new",
    1, partcv, params);
  gc_frame_end(callframe3859);
// compiled call node returning call3862 (depth = 9)
// compiled member node returning call3862 (depth = 8)
  *var_suggestion = call3862;
  if (call3862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3863 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3864 == NULL) {
    strlit3864 = alloc_String(")");
    gc_root(strlit3864);
  }
// compiled string node returning strlit3864 (depth = 8)
  gc_frame_newslot(strlit3864);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3864;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3865 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3863);
// compiled call node returning call3865 (depth = 7)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3866 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3867 == NULL) {
    strlit3867 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3867);
  }
// compiled string node returning strlit3867 (depth = 8)
  gc_frame_newslot(strlit3867);
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3869 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3868);
// compiled call node returning call3869 (depth = 9)
// compiled member node returning call3869 (depth = 8)
  gc_frame_newslot(call3869);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3872 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3871);
// compiled call node returning call3872 (depth = 10)
// compiled member node returning call3872 (depth = 9)
  int op_slot_right_3870 = gc_frame_newslot(call3872);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3875 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3874);
// compiled call node returning call3875 (depth = 10)
// compiled member node returning call3875 (depth = 9)
  int op_slot_left_3870 = gc_frame_newslot(call3875);
  params[0] = call3872;
  partcv[0] = 1;
  Object sum3876 = callmethod(call3875, "+", 1, partcv, params);
// compiled op node returning sum3876 (depth = 8)
  gc_frame_newslot(sum3876);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3867;
  params[1] = call3869;
  params[2] = sum3876;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3877 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3866);
// compiled call node returning call3877 (depth = 7)
    gc_frame_newslot(call3877);
    if3850 = call3877;
  } else {
  }
// compiled if node returning if3850 (depth = 6)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3879 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3878);
// compiled call node returning call3879 (depth = 7)
// compiled member node returning call3879 (depth = 6)
    gc_frame_newslot(call3879);
    if3805 = call3879;
  } else {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array3880 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3880 (depth = 7)
  *var_suggestions = array3880;
  if (array3880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3881 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3882 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3881);
// compiled call node returning call3882 (depth = 7)
  *var_nextTok = call3882;
  if (call3882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3883 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3884 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3885 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3884);
// compiled call node returning call3885 (depth = 10)
// compiled member node returning call3885 (depth = 9)
  partcv[0] = 0;
  Object call3886 = callmethod(call3885, "new",
    1, partcv, params);
  gc_frame_end(callframe3883);
// compiled call node returning call3886 (depth = 8)
// compiled member node returning call3886 (depth = 7)
  *var_suggestion = call3886;
  if (call3886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_3888 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool3890 = alloc_Boolean(0);
// compiled identifier node returning bool3890 (depth = 8)
  int op_slot_left_3888 = gc_frame_newslot(bool3890);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3891 = callmethod(bool3890, "==", 1, partcv, params);
// compiled op node returning opresult3891 (depth = 7)
  Object if3887 = done;
  if (istrue(opresult3891)) {
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3892 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3893 == NULL) {
    strlit3893 = alloc_String(" }");
    gc_root(strlit3893);
  }
// compiled string node returning strlit3893 (depth = 8)
  gc_frame_newslot(strlit3893);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call3895 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe3894);
// compiled call node returning call3895 (depth = 9)
// compiled member node returning call3895 (depth = 8)
  gc_frame_newslot(call3895);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3893;
  params[1] = call3895;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3896 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3892);
// compiled call node returning call3896 (depth = 7)
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3897 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3898 == NULL) {
    strlit3898 = alloc_String(" {");
    gc_root(strlit3898);
  }
// compiled string node returning strlit3898 (depth = 8)
  gc_frame_newslot(strlit3898);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3898;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3899 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3897);
// compiled call node returning call3899 (depth = 7)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3900 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3901 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3900);
// compiled call node returning call3901 (depth = 7)
    gc_frame_newslot(call3901);
    if3887 = call3901;
  } else {
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3903 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3903 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3905 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3905 (depth = 8)
  Object if3902 = done;
  if (istrue(opresult3905)) {
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3906 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3907 == NULL) {
    strlit3907 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3907);
  }
// compiled string node returning strlit3907 (depth = 9)
  gc_frame_newslot(strlit3907);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3907;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3908 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3906);
// compiled call node returning call3908 (depth = 8)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3909 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3910 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3909);
// compiled call node returning call3910 (depth = 8)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3911 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3912 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3913 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3912);
// compiled call node returning call3913 (depth = 12)
// compiled member node returning call3913 (depth = 11)
  partcv[0] = 0;
  Object call3914 = callmethod(call3913, "new",
    1, partcv, params);
  gc_frame_end(callframe3911);
// compiled call node returning call3914 (depth = 10)
// compiled member node returning call3914 (depth = 9)
  *var_suggestion = call3914;
  if (call3914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3916 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 9)
  gc_frame_newslot(strlit3917);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3917;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3918 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3916);
// compiled call node returning call3918 (depth = 8)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3919 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3920 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3919);
// compiled call node returning call3920 (depth = 8)
    gc_frame_newslot(call3920);
    if3902 = call3920;
  } else {
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3921 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3922 == NULL) {
    strlit3922 = alloc_String(" }");
    gc_root(strlit3922);
  }
// compiled string node returning strlit3922 (depth = 9)
  gc_frame_newslot(strlit3922);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3923 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3924 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3923);
// compiled call node returning call3924 (depth = 10)
// compiled member node returning call3924 (depth = 9)
  gc_frame_newslot(call3924);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3922;
  params[1] = call3924;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3925 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3921);
// compiled call node returning call3925 (depth = 8)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3926 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3927 == NULL) {
    strlit3927 = alloc_String(" {");
    gc_root(strlit3927);
  }
// compiled string node returning strlit3927 (depth = 9)
  gc_frame_newslot(strlit3927);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3927;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3928 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3926);
// compiled call node returning call3928 (depth = 8)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3929 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3930 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3929);
// compiled call node returning call3930 (depth = 8)
    gc_frame_newslot(call3930);
    if3902 = call3930;
  }
// compiled if node returning if3902 (depth = 7)
    gc_frame_newslot(if3902);
    if3887 = if3902;
  }
// compiled if node returning if3887 (depth = 6)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3931 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3932 == NULL) {
    strlit3932 = alloc_String("a try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3932);
  }
// compiled string node returning strlit3932 (depth = 7)
  gc_frame_newslot(strlit3932);
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3934 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3933);
// compiled call node returning call3934 (depth = 8)
// compiled member node returning call3934 (depth = 7)
  gc_frame_newslot(call3934);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3936 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3935);
// compiled call node returning call3936 (depth = 8)
// compiled member node returning call3936 (depth = 7)
  gc_frame_newslot(call3936);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3932;
  params[1] = call3934;
  params[2] = call3936;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3937 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3931);
// compiled call node returning call3937 (depth = 6)
    gc_frame_newslot(call3937);
    if3805 = call3937;
  }
// compiled if node returning if3805 (depth = 5)
    gc_frame_newslot(if3805);
    if3799 = if3805;
  }
// compiled if node returning if3799 (depth = 4)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3938 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call3940 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3939);
// compiled call node returning call3940 (depth = 6)
// compiled member node returning call3940 (depth = 5)
  gc_frame_newslot(call3940);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3940;
  partcv[0] = 1;
  Object call3941 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe3938);
// compiled call node returning call3941 (depth = 4)
  gc_frame_end(frame);
  return call3941;
}
Object meth_parser__apply4016(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe4017 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4018 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4017);
// compiled call node returning call4018 (depth = 10)
  gc_frame_end(frame);
  return call4018;
}
Object meth_parser_trycatch3554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for trycatch (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for trycatch");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3556 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3559 == NULL) {
    strlit3559 = alloc_String("try");
    gc_root(strlit3559);
  }
// compiled string node returning strlit3559 (depth = 6)
  int op_slot_right_3558 = gc_frame_newslot(strlit3559);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3562 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3561);
// compiled call node returning call3562 (depth = 7)
// compiled member node returning call3562 (depth = 6)
  int op_slot_left_3558 = gc_frame_newslot(call3562);
  params[0] = strlit3559;
  partcv[0] = 1;
  Object opresult3563 = callmethod(call3562, "==", 1, partcv, params);
// compiled op node returning opresult3563 (depth = 5)
  int op_slot_right_3557 = gc_frame_newslot(opresult3563);
// starting to compile call node (depth = 5)
  int callframe3565 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3566 == NULL) {
    strlit3566 = alloc_String("identifier");
    gc_root(strlit3566);
  }
// compiled string node returning strlit3566 (depth = 6)
  gc_frame_newslot(strlit3566);
// call case 4: self request
  params[0] = strlit3566;
  partcv[0] = 1;
  Object call3567 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3565);
// compiled call node returning call3567 (depth = 5)
  int op_slot_left_3557 = gc_frame_newslot(call3567);
  params[0] = opresult3563;
  partcv[0] = 1;
  Object opresult3568 = callmethod(call3567, "&&", 1, partcv, params);
// compiled op node returning opresult3568 (depth = 4)
  partcv[0] = 0;
  Object call3569 = callmethod(opresult3568, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3556);
// compiled call node returning call3569 (depth = 3)
  Object if3555 = done;
  if (istrue(call3569)) {
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3570 = alloc_Float64(0);
// compiled num node returning num3570 (depth = 4)
  return num3570;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3555 = undefined;
  } else {
  }
// compiled if node returning if3555 (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3572 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3571);
// compiled call node returning call3572 (depth = 3)
// compiled member node returning call3572 (depth = 2)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3574 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3575 == NULL) {
    strlit3575 = alloc_String("lbrace");
    gc_root(strlit3575);
  }
// compiled string node returning strlit3575 (depth = 4)
  gc_frame_newslot(strlit3575);
// call case 4: self request
  params[0] = strlit3575;
  partcv[0] = 1;
  Object call3576 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3574);
// compiled call node returning call3576 (depth = 3)
  Object if3573 = done;
  if (istrue(call3576)) {
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3577 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3578 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3577);
// compiled call node returning call3578 (depth = 4)
// compiled member node returning call3578 (depth = 3)
    gc_frame_newslot(call3578);
    if3573 = call3578;
  } else {
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3581 == NULL) {
    strlit3581 = alloc_String("lparen");
    gc_root(strlit3581);
  }
// compiled string node returning strlit3581 (depth = 5)
  int op_slot_right_3580 = gc_frame_newslot(strlit3581);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3584 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3583);
// compiled call node returning call3584 (depth = 6)
// compiled member node returning call3584 (depth = 5)
  int op_slot_left_3580 = gc_frame_newslot(call3584);
  params[0] = strlit3581;
  partcv[0] = 1;
  Object opresult3585 = callmethod(call3584, "≠", 1, partcv, params);
// compiled op node returning opresult3585 (depth = 4)
  Object if3579 = done;
  if (istrue(opresult3585)) {
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3586 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3587 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3588 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3587);
// compiled call node returning call3588 (depth = 8)
// compiled member node returning call3588 (depth = 7)
  partcv[0] = 0;
  Object call3589 = callmethod(call3588, "new",
    1, partcv, params);
  gc_frame_end(callframe3586);
// compiled call node returning call3589 (depth = 6)
// compiled member node returning call3589 (depth = 5)
  *var_suggestion = call3589;
  if (call3589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3590 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3591 = alloc_Block(NULL, NULL, "parser", 1134);
  gc_frame_newslot(block3591);
// method "_apply"
  block_savedest(block3591);
  Object closure3592 = createclosure(2, "_apply");
  setclosureframe(closure3592, stackframe);
  addtoclosure(closure3592, var_catchTok);
  addtoclosure(closure3592, selfslot);
  struct UserObject *uo3592 = (struct UserObject*)block3591;
  uo3592->data[0] = (Object)closure3592;
  Method *meth_meth_parser__apply3592 = addmethod2pos(block3591, "_apply", &meth_parser__apply3592, 0);
  int argcv_meth_parser__apply3592[] = {1};
  meth_meth_parser__apply3592->type = alloc_MethodType(1, argcv_meth_parser__apply3592);
  meth_meth_parser__apply3592->definitionModule = modulename;
  meth_meth_parser__apply3592->definitionLine = 1132;
// compiled block node returning block3591 (depth = 6)
  gc_frame_newslot(block3591);
// call case 4: self request
  params[0] = block3591;
  partcv[0] = 1;
  Object call3637 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3590);
// compiled call node returning call3637 (depth = 5)
  *var_nextTok = call3637;
  if (call3637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_right_3639 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool3641 = alloc_Boolean(0);
// compiled identifier node returning bool3641 (depth = 6)
  int op_slot_left_3639 = gc_frame_newslot(bool3641);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult3642 = callmethod(bool3641, "==", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 5)
  Object if3638 = done;
  if (istrue(opresult3642)) {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3643 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3644 == NULL) {
    strlit3644 = alloc_String(" {}");
    gc_root(strlit3644);
  }
// compiled string node returning strlit3644 (depth = 6)
  gc_frame_newslot(strlit3644);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3644;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3645 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3643);
// compiled call node returning call3645 (depth = 5)
    gc_frame_newslot(call3645);
    if3638 = call3645;
  } else {
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3648 == NULL) {
    strlit3648 = alloc_String("rbrace");
    gc_root(strlit3648);
  }
// compiled string node returning strlit3648 (depth = 7)
  int op_slot_right_3647 = gc_frame_newslot(strlit3648);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3651 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3650);
// compiled call node returning call3651 (depth = 8)
// compiled member node returning call3651 (depth = 7)
  int op_slot_left_3647 = gc_frame_newslot(call3651);
  params[0] = strlit3648;
  partcv[0] = 1;
  Object opresult3652 = callmethod(call3651, "==", 1, partcv, params);
// compiled op node returning opresult3652 (depth = 6)
  Object if3646 = done;
  if (istrue(opresult3652)) {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3653 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3654 == NULL) {
    strlit3654 = alloc_String(" {");
    gc_root(strlit3654);
  }
// compiled string node returning strlit3654 (depth = 7)
  gc_frame_newslot(strlit3654);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3654;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3655 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3653);
// compiled call node returning call3655 (depth = 6)
    gc_frame_newslot(call3655);
    if3646 = call3655;
  } else {
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3658 == NULL) {
    strlit3658 = alloc_String("rparen");
    gc_root(strlit3658);
  }
// compiled string node returning strlit3658 (depth = 8)
  int op_slot_right_3657 = gc_frame_newslot(strlit3658);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3661 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 9)
// compiled member node returning call3661 (depth = 8)
  int op_slot_left_3657 = gc_frame_newslot(call3661);
  params[0] = strlit3658;
  partcv[0] = 1;
  Object opresult3662 = callmethod(call3661, "==", 1, partcv, params);
// compiled op node returning opresult3662 (depth = 7)
  Object if3656 = done;
  if (istrue(opresult3662)) {
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3664 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3664 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3666 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3666 (depth = 8)
  Object if3663 = done;
  if (istrue(opresult3666)) {
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3667 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3668 == NULL) {
    strlit3668 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3668);
  }
// compiled string node returning strlit3668 (depth = 9)
  gc_frame_newslot(strlit3668);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3669 = alloc_Boolean(1);
// compiled identifier node returning bool3669 (depth = 9)
  gc_frame_newslot(bool3669);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3668;
  params[1] = *var_lastToken;
  params[2] = bool3669;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3670 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3667);
// compiled call node returning call3670 (depth = 8)
    gc_frame_newslot(call3670);
    if3663 = call3670;
  } else {
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3671 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3672 == NULL) {
    strlit3672 = alloc_String("(");
    gc_root(strlit3672);
  }
// compiled string node returning strlit3672 (depth = 9)
  gc_frame_newslot(strlit3672);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3673 = alloc_Boolean(1);
// compiled identifier node returning bool3673 (depth = 9)
  gc_frame_newslot(bool3673);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3672;
  params[1] = *var_lastToken;
  params[2] = bool3673;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3674 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3671);
// compiled call node returning call3674 (depth = 8)
    gc_frame_newslot(call3674);
    if3663 = call3674;
  }
// compiled if node returning if3663 (depth = 7)
    gc_frame_newslot(if3663);
    if3656 = if3663;
  } else {
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3677 == NULL) {
    strlit3677 = alloc_String("identifier");
    gc_root(strlit3677);
  }
// compiled string node returning strlit3677 (depth = 9)
  int op_slot_right_3676 = gc_frame_newslot(strlit3677);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3680 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3679);
// compiled call node returning call3680 (depth = 10)
// compiled member node returning call3680 (depth = 9)
  int op_slot_left_3676 = gc_frame_newslot(call3680);
  params[0] = strlit3677;
  partcv[0] = 1;
  Object opresult3681 = callmethod(call3680, "==", 1, partcv, params);
// compiled op node returning opresult3681 (depth = 8)
  Object if3675 = done;
  if (istrue(opresult3681)) {
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3682 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3683 == NULL) {
    strlit3683 = alloc_String(" {");
    gc_root(strlit3683);
  }
// compiled string node returning strlit3683 (depth = 9)
  gc_frame_newslot(strlit3683);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3683;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3684 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3682);
// compiled call node returning call3684 (depth = 8)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3685 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3686 == NULL) {
    strlit3686 = alloc_String("} ");
    gc_root(strlit3686);
  }
// compiled string node returning strlit3686 (depth = 9)
  gc_frame_newslot(strlit3686);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3686;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3687 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3685);
// compiled call node returning call3687 (depth = 8)
    gc_frame_newslot(call3687);
    if3675 = call3687;
  } else {
  }
// compiled if node returning if3675 (depth = 7)
    gc_frame_newslot(if3675);
    if3656 = if3675;
  }
// compiled if node returning if3656 (depth = 6)
    gc_frame_newslot(if3656);
    if3646 = if3656;
  }
// compiled if node returning if3646 (depth = 5)
    gc_frame_newslot(if3646);
    if3638 = if3646;
  }
// compiled if node returning if3638 (depth = 4)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3688 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3689 == NULL) {
    strlit3689 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3689);
  }
// compiled string node returning strlit3689 (depth = 5)
  gc_frame_newslot(strlit3689);
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call3691 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3690);
// compiled call node returning call3691 (depth = 6)
// compiled member node returning call3691 (depth = 5)
  gc_frame_newslot(call3691);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3693 = alloc_Float64(1);
// compiled num node returning num3693 (depth = 6)
  int op_slot_right_3692 = gc_frame_newslot(num3693);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3697 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe3696);
// compiled call node returning call3697 (depth = 8)
// compiled member node returning call3697 (depth = 7)
  int op_slot_right_3695 = gc_frame_newslot(call3697);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3700 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3699);
// compiled call node returning call3700 (depth = 8)
// compiled member node returning call3700 (depth = 7)
  int op_slot_left_3695 = gc_frame_newslot(call3700);
  params[0] = call3697;
  partcv[0] = 1;
  Object sum3701 = callmethod(call3700, "+", 1, partcv, params);
// compiled op node returning sum3701 (depth = 6)
  int op_slot_left_3692 = gc_frame_newslot(sum3701);
  params[0] = num3693;
  partcv[0] = 1;
  Object sum3702 = callmethod(sum3701, "+", 1, partcv, params);
// compiled op node returning sum3702 (depth = 5)
  gc_frame_newslot(sum3702);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3689;
  params[1] = call3691;
  params[2] = sum3702;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3703 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3688);
// compiled call node returning call3703 (depth = 4)
    gc_frame_newslot(call3703);
    if3579 = call3703;
  } else {
  }
// compiled if node returning if3579 (depth = 3)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3704 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3705 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3704);
// compiled call node returning call3705 (depth = 4)
// compiled member node returning call3705 (depth = 3)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3707 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3708 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3709 = alloc_Block(NULL, NULL, "parser", 1155);
  gc_frame_newslot(block3709);
// method "_apply"
  block_savedest(block3709);
  Object closure3710 = createclosure(2, "_apply");
  setclosureframe(closure3710, stackframe);
  addtoclosure(closure3710, var_blocksOK);
  addtoclosure(closure3710, selfslot);
  struct UserObject *uo3710 = (struct UserObject*)block3709;
  uo3710->data[0] = (Object)closure3710;
  Method *meth_meth_parser__apply3710 = addmethod2pos(block3709, "_apply", &meth_parser__apply3710, 0);
  int argcv_meth_parser__apply3710[] = {0};
  meth_meth_parser__apply3710->type = alloc_MethodType(1, argcv_meth_parser__apply3710);
  meth_meth_parser__apply3710->definitionModule = modulename;
  meth_meth_parser__apply3710->definitionLine = 1155;
// compiled block node returning block3709 (depth = 7)
  gc_frame_newslot(block3709);
// call case 4: self request
  params[0] = block3709;
  partcv[0] = 1;
  Object call3714 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3708);
// compiled call node returning call3714 (depth = 6)
  partcv[0] = 0;
  Object call3715 = callmethod(call3714, "not",
    1, partcv, params);
  gc_frame_end(callframe3707);
// compiled call node returning call3715 (depth = 5)
// compiled member node returning call3715 (depth = 4)
  Object if3706 = done;
  if (istrue(call3715)) {
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3716 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3717 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3718 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3717);
// compiled call node returning call3718 (depth = 8)
// compiled member node returning call3718 (depth = 7)
  partcv[0] = 0;
  Object call3719 = callmethod(call3718, "new",
    1, partcv, params);
  gc_frame_end(callframe3716);
// compiled call node returning call3719 (depth = 6)
// compiled member node returning call3719 (depth = 5)
  *var_suggestion = call3719;
  if (call3719 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3720 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array3721 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit3722 == NULL) {
    strlit3722 = alloc_String("rparen");
    gc_root(strlit3722);
  }
// compiled string node returning strlit3722 (depth = 7)
  params[0] = strlit3722;
  partcv[0] = 1;
  callmethodflags(array3721, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array3721 (depth = 6)
  gc_frame_newslot(array3721);
// call case 4: self request
  params[0] = array3721;
  partcv[0] = 1;
  Object call3723 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3720);
// compiled call node returning call3723 (depth = 5)
  *var_nextTok = call3723;
  if (call3723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3725 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3725 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3727 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3727 (depth = 5)
  Object if3724 = done;
  if (istrue(opresult3727)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3728 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3729 == NULL) {
    strlit3729 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3729);
  }
// compiled string node returning strlit3729 (depth = 6)
  gc_frame_newslot(strlit3729);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3729;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3730 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3728);
// compiled call node returning call3730 (depth = 5)
    gc_frame_newslot(call3730);
    if3724 = call3730;
  } else {
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3731 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3733 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3732);
// compiled call node returning call3733 (depth = 7)
// compiled member node returning call3733 (depth = 6)
  gc_frame_newslot(call3733);
// starting to compile identifier node (depth = 6)
  Object bool3734 = alloc_Boolean(1);
// compiled identifier node returning bool3734 (depth = 6)
  gc_frame_newslot(bool3734);
// starting to compile identifier node (depth = 6)
  Object bool3735 = alloc_Boolean(0);
// compiled identifier node returning bool3735 (depth = 6)
  gc_frame_newslot(bool3735);
// starting to compile string node (depth = 6)
  if (strlit3736 == NULL) {
    strlit3736 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3736);
  }
// compiled string node returning strlit3736 (depth = 6)
  gc_frame_newslot(strlit3736);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3733;
  params[2] = bool3734;
  params[3] = bool3735;
  params[4] = strlit3736;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3737 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3731);
// compiled call node returning call3737 (depth = 5)
    gc_frame_newslot(call3737);
    if3724 = call3737;
  }
// compiled if node returning if3724 (depth = 4)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3738 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3739 == NULL) {
    strlit3739 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3739);
  }
// compiled string node returning strlit3739 (depth = 5)
  gc_frame_newslot(strlit3739);
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3741 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3740);
// compiled call node returning call3741 (depth = 6)
// compiled member node returning call3741 (depth = 5)
  gc_frame_newslot(call3741);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3743 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3742);
// compiled call node returning call3743 (depth = 6)
// compiled member node returning call3743 (depth = 5)
  gc_frame_newslot(call3743);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3739;
  params[1] = call3741;
  params[2] = call3743;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3744 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3738);
// compiled call node returning call3744 (depth = 4)
    gc_frame_newslot(call3744);
    if3706 = call3744;
  } else {
  }
// compiled if node returning if3706 (depth = 3)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3747 == NULL) {
    strlit3747 = alloc_String("rparen");
    gc_root(strlit3747);
  }
// compiled string node returning strlit3747 (depth = 5)
  int op_slot_right_3746 = gc_frame_newslot(strlit3747);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3750 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3749);
// compiled call node returning call3750 (depth = 6)
// compiled member node returning call3750 (depth = 5)
  int op_slot_left_3746 = gc_frame_newslot(call3750);
  params[0] = strlit3747;
  partcv[0] = 1;
  Object opresult3751 = callmethod(call3750, "≠", 1, partcv, params);
// compiled op node returning opresult3751 (depth = 4)
  Object if3745 = done;
  if (istrue(opresult3751)) {
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3753 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3752);
// compiled call node returning call3753 (depth = 5)
// compiled member node returning call3753 (depth = 4)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3754 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3756 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3755);
// compiled call node returning call3756 (depth = 8)
// compiled member node returning call3756 (depth = 7)
  partcv[0] = 0;
  Object call3757 = callmethod(call3756, "new",
    1, partcv, params);
  gc_frame_end(callframe3754);
// compiled call node returning call3757 (depth = 6)
// compiled member node returning call3757 (depth = 5)
  *var_suggestion = call3757;
  if (call3757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3758 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3759 == NULL) {
    strlit3759 = alloc_String(")");
    gc_root(strlit3759);
  }
// compiled string node returning strlit3759 (depth = 5)
  gc_frame_newslot(strlit3759);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3759;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3760 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3758);
// compiled call node returning call3760 (depth = 4)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3761 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3762 == NULL) {
    strlit3762 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3762);
  }
// compiled string node returning strlit3762 (depth = 5)
  gc_frame_newslot(strlit3762);
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3764 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3763);
// compiled call node returning call3764 (depth = 6)
// compiled member node returning call3764 (depth = 5)
  gc_frame_newslot(call3764);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3767 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3766);
// compiled call node returning call3767 (depth = 7)
// compiled member node returning call3767 (depth = 6)
  int op_slot_right_3765 = gc_frame_newslot(call3767);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3770 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3769);
// compiled call node returning call3770 (depth = 7)
// compiled member node returning call3770 (depth = 6)
  int op_slot_left_3765 = gc_frame_newslot(call3770);
  params[0] = call3767;
  partcv[0] = 1;
  Object sum3771 = callmethod(call3770, "+", 1, partcv, params);
// compiled op node returning sum3771 (depth = 5)
  gc_frame_newslot(sum3771);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3762;
  params[1] = call3764;
  params[2] = sum3771;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3772 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3761);
// compiled call node returning call3772 (depth = 4)
    gc_frame_newslot(call3772);
    if3745 = call3772;
  } else {
  }
// compiled if node returning if3745 (depth = 3)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3773 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3774 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3773);
// compiled call node returning call3774 (depth = 4)
// compiled member node returning call3774 (depth = 3)
    gc_frame_newslot(call3774);
    if3573 = call3774;
  }
// compiled if node returning if3573 (depth = 2)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3776 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3775);
// compiled call node returning call3776 (depth = 4)
// compiled member node returning call3776 (depth = 3)
  *var_mainblock = call3776;
  if (call3776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array3777 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3777 (depth = 3)
  *var_cases = array3777;
  if (array3777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3778 = alloc_Boolean(0);
// compiled identifier node returning bool3778 (depth = 3)
  *var_finally = bool3778;
  if (bool3778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3779 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3780 = alloc_Block(NULL, NULL, "parser", 1178);
  gc_frame_newslot(block3780);
// method "_apply"
  block_savedest(block3780);
  Object closure3781 = createclosure(2, "_apply");
  setclosureframe(closure3781, stackframe);
  addtoclosure(closure3781, var_sym);
  addtoclosure(closure3781, selfslot);
  struct UserObject *uo3781 = (struct UserObject*)block3780;
  uo3781->data[0] = (Object)closure3781;
  Method *meth_meth_parser__apply3781 = addmethod2pos(block3780, "_apply", &meth_parser__apply3781, 0);
  int argcv_meth_parser__apply3781[] = {0};
  meth_meth_parser__apply3781->type = alloc_MethodType(1, argcv_meth_parser__apply3781);
  meth_meth_parser__apply3781->definitionModule = modulename;
  meth_meth_parser__apply3781->definitionLine = 1175;
// compiled block node returning block3780 (depth = 3)
  gc_frame_newslot(block3780);
// starting to compile block node (depth = 3)
  Object block3795 = alloc_Block(NULL, NULL, "parser", 1178);
  gc_frame_newslot(block3795);
// method "_apply"
  block_savedest(block3795);
  Object closure3796 = createclosure(8, "_apply");
  setclosureframe(closure3796, stackframe);
  addtoclosure(closure3796, var_blocksOK);
  addtoclosure(closure3796, var_errormessages);
  addtoclosure(closure3796, var_sym);
  addtoclosure(closure3796, var_lastToken);
  addtoclosure(closure3796, var_tokens);
  addtoclosure(closure3796, var_values);
  addtoclosure(closure3796, var_cases);
  addtoclosure(closure3796, selfslot);
  struct UserObject *uo3796 = (struct UserObject*)block3795;
  uo3796->data[0] = (Object)closure3796;
  Method *meth_meth_parser__apply3796 = addmethod2pos(block3795, "_apply", &meth_parser__apply3796, 0);
  int argcv_meth_parser__apply3796[] = {0};
  meth_meth_parser__apply3796->type = alloc_MethodType(1, argcv_meth_parser__apply3796);
  meth_meth_parser__apply3796->definitionModule = modulename;
  meth_meth_parser__apply3796->definitionLine = 1178;
// compiled block node returning block3795 (depth = 3)
  gc_frame_newslot(block3795);
// call case 5: prelude request
  params[0] = block3780;
  params[1] = block3795;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3943 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3779);
// compiled call node returning call3943 (depth = 2)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("case");
    gc_root(strlit3947);
  }
// compiled string node returning strlit3947 (depth = 5)
  int op_slot_right_3946 = gc_frame_newslot(strlit3947);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3950 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3949);
// compiled call node returning call3950 (depth = 6)
// compiled member node returning call3950 (depth = 5)
  int op_slot_left_3946 = gc_frame_newslot(call3950);
  params[0] = strlit3947;
  partcv[0] = 1;
  Object opresult3951 = callmethod(call3950, "==", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 4)
  int op_slot_right_3945 = gc_frame_newslot(opresult3951);
// starting to compile call node (depth = 4)
  int callframe3953 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3954 == NULL) {
    strlit3954 = alloc_String("identifier");
    gc_root(strlit3954);
  }
// compiled string node returning strlit3954 (depth = 5)
  gc_frame_newslot(strlit3954);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  gc_frame_newslot(*var_catchTok);
// call case 4: self request
  params[0] = strlit3954;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3955 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3953);
// compiled call node returning call3955 (depth = 4)
  int op_slot_left_3945 = gc_frame_newslot(call3955);
  params[0] = opresult3951;
  partcv[0] = 1;
  Object opresult3956 = callmethod(call3955, "&&", 1, partcv, params);
// compiled op node returning opresult3956 (depth = 3)
  Object if3944 = done;
  if (istrue(opresult3956)) {
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3957 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call3959 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3958);
// compiled call node returning call3959 (depth = 7)
// compiled member node returning call3959 (depth = 6)
  partcv[0] = 0;
  Object call3960 = callmethod(call3959, "new",
    1, partcv, params);
  gc_frame_end(callframe3957);
// compiled call node returning call3960 (depth = 5)
// compiled member node returning call3960 (depth = 4)
  *var_suggestion = call3960;
  if (call3960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3961 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3962 == NULL) {
    strlit3962 = alloc_String("catch");
    gc_root(strlit3962);
  }
// compiled string node returning strlit3962 (depth = 4)
  gc_frame_newslot(strlit3962);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3962;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3963 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe3961);
// compiled call node returning call3963 (depth = 3)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3964 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3966 == NULL) {
    strlit3966 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3966);
  }
// compiled string node returning strlit3966 (depth = 5)
  int op_slot_right_3965 = gc_frame_newslot(strlit3966);
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3969 == NULL) {
    strlit3969 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3969);
  }
// compiled string node returning strlit3969 (depth = 6)
  int op_slot_right_3968 = gc_frame_newslot(strlit3969);
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3971 == NULL) {
    strlit3971 = alloc_String("a try-catch statement starts with a ");
    gc_root(strlit3971);
  }
// compiled string node returning strlit3971 (depth = 6)
  int op_slot_left_3968 = gc_frame_newslot(strlit3971);
  params[0] = strlit3969;
  partcv[0] = 1;
  Object opresult3972 = callmethod(strlit3971, "++", 1, partcv, params);
// compiled op node returning opresult3972 (depth = 5)
  int op_slot_left_3965 = gc_frame_newslot(opresult3972);
  params[0] = strlit3966;
  partcv[0] = 1;
  Object opresult3973 = callmethod(opresult3972, "++", 1, partcv, params);
// compiled op node returning opresult3973 (depth = 4)
  gc_frame_newslot(opresult3973);
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3975 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3974);
// compiled call node returning call3975 (depth = 5)
// compiled member node returning call3975 (depth = 4)
  gc_frame_newslot(call3975);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3977 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3977 (depth = 5)
// compiled member node returning call3977 (depth = 4)
  gc_frame_newslot(call3977);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3979 = alloc_Float64(3);
// compiled num node returning num3979 (depth = 5)
  int op_slot_right_3978 = gc_frame_newslot(num3979);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3982 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3981);
// compiled call node returning call3982 (depth = 6)
// compiled member node returning call3982 (depth = 5)
  int op_slot_left_3978 = gc_frame_newslot(call3982);
  params[0] = num3979;
  partcv[0] = 1;
  Object sum3983 = callmethod(call3982, "+", 1, partcv, params);
// compiled op node returning sum3983 (depth = 4)
  gc_frame_newslot(sum3983);
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3973;
  params[1] = call3975;
  params[2] = call3977;
  params[3] = sum3983;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3984 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3964);
// compiled call node returning call3984 (depth = 3)
    gc_frame_newslot(call3984);
    if3944 = call3984;
  } else {
  }
// compiled if node returning if3944 (depth = 2)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3988 == NULL) {
    strlit3988 = alloc_String("finally");
    gc_root(strlit3988);
  }
// compiled string node returning strlit3988 (depth = 5)
  int op_slot_right_3987 = gc_frame_newslot(strlit3988);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3990 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3991 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3990);
// compiled call node returning call3991 (depth = 6)
// compiled member node returning call3991 (depth = 5)
  int op_slot_left_3987 = gc_frame_newslot(call3991);
  params[0] = strlit3988;
  partcv[0] = 1;
  Object opresult3992 = callmethod(call3991, "==", 1, partcv, params);
// compiled op node returning opresult3992 (depth = 4)
  int op_slot_right_3986 = gc_frame_newslot(opresult3992);
// starting to compile call node (depth = 4)
  int callframe3994 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3995 == NULL) {
    strlit3995 = alloc_String("identifier");
    gc_root(strlit3995);
  }
// compiled string node returning strlit3995 (depth = 5)
  gc_frame_newslot(strlit3995);
// call case 4: self request
  params[0] = strlit3995;
  partcv[0] = 1;
  Object call3996 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3994);
// compiled call node returning call3996 (depth = 4)
  int op_slot_left_3986 = gc_frame_newslot(call3996);
  params[0] = opresult3992;
  partcv[0] = 1;
  Object opresult3997 = callmethod(call3996, "&&", 1, partcv, params);
// compiled op node returning opresult3997 (depth = 3)
  Object if3985 = done;
  if (istrue(opresult3997)) {
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3999 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compiled call node returning call3999 (depth = 4)
// compiled member node returning call3999 (depth = 3)
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4001 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4002 == NULL) {
    strlit4002 = alloc_String("lbrace");
    gc_root(strlit4002);
  }
// compiled string node returning strlit4002 (depth = 5)
  gc_frame_newslot(strlit4002);
// call case 4: self request
  params[0] = strlit4002;
  partcv[0] = 1;
  Object call4003 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4001);
// compiled call node returning call4003 (depth = 4)
  Object if4000 = done;
  if (istrue(call4003)) {
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4004 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4005 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4004);
// compiled call node returning call4005 (depth = 5)
// compiled member node returning call4005 (depth = 4)
    gc_frame_newslot(call4005);
    if4000 = call4005;
  } else {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4007 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4008 == NULL) {
    strlit4008 = alloc_String("lparen");
    gc_root(strlit4008);
  }
// compiled string node returning strlit4008 (depth = 6)
  gc_frame_newslot(strlit4008);
// call case 4: self request
  params[0] = strlit4008;
  partcv[0] = 1;
  Object call4009 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4007);
// compiled call node returning call4009 (depth = 5)
  Object if4006 = done;
  if (istrue(call4009)) {
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4011 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4010);
// compiled call node returning call4011 (depth = 6)
// compiled member node returning call4011 (depth = 5)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4013 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe4014 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block4015 = alloc_Block(NULL, NULL, "parser", 1242);
  gc_frame_newslot(block4015);
// method "_apply"
  block_savedest(block4015);
  Object closure4016 = createclosure(2, "_apply");
  setclosureframe(closure4016, stackframe);
  addtoclosure(closure4016, var_blocksOK);
  addtoclosure(closure4016, selfslot);
  struct UserObject *uo4016 = (struct UserObject*)block4015;
  uo4016->data[0] = (Object)closure4016;
  Method *meth_meth_parser__apply4016 = addmethod2pos(block4015, "_apply", &meth_parser__apply4016, 0);
  int argcv_meth_parser__apply4016[] = {0};
  meth_meth_parser__apply4016->type = alloc_MethodType(1, argcv_meth_parser__apply4016);
  meth_meth_parser__apply4016->definitionModule = modulename;
  meth_meth_parser__apply4016->definitionLine = 1242;
// compiled block node returning block4015 (depth = 9)
  gc_frame_newslot(block4015);
// call case 4: self request
  params[0] = block4015;
  partcv[0] = 1;
  Object call4020 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4014);
// compiled call node returning call4020 (depth = 8)
  partcv[0] = 0;
  Object call4021 = callmethod(call4020, "not",
    1, partcv, params);
  gc_frame_end(callframe4013);
// compiled call node returning call4021 (depth = 7)
// compiled member node returning call4021 (depth = 6)
  Object if4012 = done;
  if (istrue(call4021)) {
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4022 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4024 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4023);
// compiled call node returning call4024 (depth = 10)
// compiled member node returning call4024 (depth = 9)
  partcv[0] = 0;
  Object call4025 = callmethod(call4024, "new",
    1, partcv, params);
  gc_frame_end(callframe4022);
// compiled call node returning call4025 (depth = 8)
// compiled member node returning call4025 (depth = 7)
  *var_suggestion = call4025;
  if (call4025 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4026 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array4027 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit4028 == NULL) {
    strlit4028 = alloc_String("rparen");
    gc_root(strlit4028);
  }
// compiled string node returning strlit4028 (depth = 9)
  params[0] = strlit4028;
  partcv[0] = 1;
  callmethodflags(array4027, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4027 (depth = 8)
  gc_frame_newslot(array4027);
// call case 4: self request
  params[0] = array4027;
  partcv[0] = 1;
  Object call4029 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4026);
// compiled call node returning call4029 (depth = 7)
  *var_nextTok = call4029;
  if (call4029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4031 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4031 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4033 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4033 (depth = 7)
  Object if4030 = done;
  if (istrue(opresult4033)) {
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4034 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4035 == NULL) {
    strlit4035 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4035);
  }
// compiled string node returning strlit4035 (depth = 8)
  gc_frame_newslot(strlit4035);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4035;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4036 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4034);
// compiled call node returning call4036 (depth = 7)
    gc_frame_newslot(call4036);
    if4030 = call4036;
  } else {
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4037 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4039 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4038);
// compiled call node returning call4039 (depth = 9)
// compiled member node returning call4039 (depth = 8)
  gc_frame_newslot(call4039);
// starting to compile identifier node (depth = 8)
  Object bool4040 = alloc_Boolean(1);
// compiled identifier node returning bool4040 (depth = 8)
  gc_frame_newslot(bool4040);
// starting to compile identifier node (depth = 8)
  Object bool4041 = alloc_Boolean(0);
// compiled identifier node returning bool4041 (depth = 8)
  gc_frame_newslot(bool4041);
// starting to compile string node (depth = 8)
  if (strlit4042 == NULL) {
    strlit4042 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4042);
  }
// compiled string node returning strlit4042 (depth = 8)
  gc_frame_newslot(strlit4042);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4039;
  params[2] = bool4040;
  params[3] = bool4041;
  params[4] = strlit4042;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4043 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4037);
// compiled call node returning call4043 (depth = 7)
    gc_frame_newslot(call4043);
    if4030 = call4043;
  }
// compiled if node returning if4030 (depth = 6)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4044 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("a catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4045);
  }
// compiled string node returning strlit4045 (depth = 7)
  gc_frame_newslot(strlit4045);
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4047 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4046);
// compiled call node returning call4047 (depth = 8)
// compiled member node returning call4047 (depth = 7)
  gc_frame_newslot(call4047);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4049 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4048);
// compiled call node returning call4049 (depth = 8)
// compiled member node returning call4049 (depth = 7)
  gc_frame_newslot(call4049);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4045;
  params[1] = call4047;
  params[2] = call4049;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4050 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4044);
// compiled call node returning call4050 (depth = 6)
    gc_frame_newslot(call4050);
    if4012 = call4050;
  } else {
  }
// compiled if node returning if4012 (depth = 5)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4053 == NULL) {
    strlit4053 = alloc_String("rparen");
    gc_root(strlit4053);
  }
// compiled string node returning strlit4053 (depth = 7)
  int op_slot_right_4052 = gc_frame_newslot(strlit4053);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4056 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4055);
// compiled call node returning call4056 (depth = 8)
// compiled member node returning call4056 (depth = 7)
  int op_slot_left_4052 = gc_frame_newslot(call4056);
  params[0] = strlit4053;
  partcv[0] = 1;
  Object opresult4057 = callmethod(call4056, "≠", 1, partcv, params);
// compiled op node returning opresult4057 (depth = 6)
  Object if4051 = done;
  if (istrue(opresult4057)) {
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4059 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4058);
// compiled call node returning call4059 (depth = 7)
// compiled member node returning call4059 (depth = 6)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4060 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4061 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4062 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4061);
// compiled call node returning call4062 (depth = 10)
// compiled member node returning call4062 (depth = 9)
  partcv[0] = 0;
  Object call4063 = callmethod(call4062, "new",
    1, partcv, params);
  gc_frame_end(callframe4060);
// compiled call node returning call4063 (depth = 8)
// compiled member node returning call4063 (depth = 7)
  *var_suggestion = call4063;
  if (call4063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4064 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4065 == NULL) {
    strlit4065 = alloc_String(")");
    gc_root(strlit4065);
  }
// compiled string node returning strlit4065 (depth = 7)
  gc_frame_newslot(strlit4065);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4065;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4066 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4064);
// compiled call node returning call4066 (depth = 6)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4067 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4068 == NULL) {
    strlit4068 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4068);
  }
// compiled string node returning strlit4068 (depth = 7)
  gc_frame_newslot(strlit4068);
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4070 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4069);
// compiled call node returning call4070 (depth = 8)
// compiled member node returning call4070 (depth = 7)
  gc_frame_newslot(call4070);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4073 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4072);
// compiled call node returning call4073 (depth = 9)
// compiled member node returning call4073 (depth = 8)
  int op_slot_right_4071 = gc_frame_newslot(call4073);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4076 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4075);
// compiled call node returning call4076 (depth = 9)
// compiled member node returning call4076 (depth = 8)
  int op_slot_left_4071 = gc_frame_newslot(call4076);
  params[0] = call4073;
  partcv[0] = 1;
  Object sum4077 = callmethod(call4076, "+", 1, partcv, params);
// compiled op node returning sum4077 (depth = 7)
  gc_frame_newslot(sum4077);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4068;
  params[1] = call4070;
  params[2] = sum4077;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4078 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4067);
// compiled call node returning call4078 (depth = 6)
    gc_frame_newslot(call4078);
    if4051 = call4078;
  } else {
  }
// compiled if node returning if4051 (depth = 5)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4080 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4079);
// compiled call node returning call4080 (depth = 6)
// compiled member node returning call4080 (depth = 5)
    gc_frame_newslot(call4080);
    if4006 = call4080;
  } else {
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4081 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4081 (depth = 6)
  *var_suggestions = array4081;
  if (array4081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4082 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4083 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4082);
// compiled call node returning call4083 (depth = 6)
  *var_nextTok = call4083;
  if (call4083 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4084 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4086 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4085);
// compiled call node returning call4086 (depth = 9)
// compiled member node returning call4086 (depth = 8)
  partcv[0] = 0;
  Object call4087 = callmethod(call4086, "new",
    1, partcv, params);
  gc_frame_end(callframe4084);
// compiled call node returning call4087 (depth = 7)
// compiled member node returning call4087 (depth = 6)
  *var_suggestion = call4087;
  if (call4087 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_4089 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool4091 = alloc_Boolean(0);
// compiled identifier node returning bool4091 (depth = 7)
  int op_slot_left_4089 = gc_frame_newslot(bool4091);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4092 = callmethod(bool4091, "==", 1, partcv, params);
// compiled op node returning opresult4092 (depth = 6)
  Object if4088 = done;
  if (istrue(opresult4092)) {
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4093 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4094 == NULL) {
    strlit4094 = alloc_String(" }");
    gc_root(strlit4094);
  }
// compiled string node returning strlit4094 (depth = 7)
  gc_frame_newslot(strlit4094);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call4096 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4095);
// compiled call node returning call4096 (depth = 8)
// compiled member node returning call4096 (depth = 7)
  gc_frame_newslot(call4096);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4094;
  params[1] = call4096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4097 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4093);
// compiled call node returning call4097 (depth = 6)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4098 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String(" {");
    gc_root(strlit4099);
  }
// compiled string node returning strlit4099 (depth = 7)
  gc_frame_newslot(strlit4099);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4099;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4100 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4098);
// compiled call node returning call4100 (depth = 6)
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4101 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4102 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4101);
// compiled call node returning call4102 (depth = 6)
    gc_frame_newslot(call4102);
    if4088 = call4102;
  } else {
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4104 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4104 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4106 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4106 (depth = 7)
  Object if4103 = done;
  if (istrue(opresult4106)) {
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4107 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4108 == NULL) {
    strlit4108 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4108);
  }
// compiled string node returning strlit4108 (depth = 8)
  gc_frame_newslot(strlit4108);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4108;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4109 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4107);
// compiled call node returning call4109 (depth = 7)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4110 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4111 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4110);
// compiled call node returning call4111 (depth = 7)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4112 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4114 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4113);
// compiled call node returning call4114 (depth = 11)
// compiled member node returning call4114 (depth = 10)
  partcv[0] = 0;
  Object call4115 = callmethod(call4114, "new",
    1, partcv, params);
  gc_frame_end(callframe4112);
// compiled call node returning call4115 (depth = 9)
// compiled member node returning call4115 (depth = 8)
  *var_suggestion = call4115;
  if (call4115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4117 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4118 == NULL) {
    strlit4118 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4118);
  }
// compiled string node returning strlit4118 (depth = 8)
  gc_frame_newslot(strlit4118);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4118;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4119 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4117);
// compiled call node returning call4119 (depth = 7)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4120 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4121 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4120);
// compiled call node returning call4121 (depth = 7)
    gc_frame_newslot(call4121);
    if4103 = call4121;
  } else {
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4122 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4123 == NULL) {
    strlit4123 = alloc_String(" }");
    gc_root(strlit4123);
  }
// compiled string node returning strlit4123 (depth = 8)
  gc_frame_newslot(strlit4123);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4125 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4124);
// compiled call node returning call4125 (depth = 9)
// compiled member node returning call4125 (depth = 8)
  gc_frame_newslot(call4125);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4123;
  params[1] = call4125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4126 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4122);
// compiled call node returning call4126 (depth = 7)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4127 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4128 == NULL) {
    strlit4128 = alloc_String(" {");
    gc_root(strlit4128);
  }
// compiled string node returning strlit4128 (depth = 8)
  gc_frame_newslot(strlit4128);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4128;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4129 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4127);
// compiled call node returning call4129 (depth = 7)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4130 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4131 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4130);
// compiled call node returning call4131 (depth = 7)
    gc_frame_newslot(call4131);
    if4103 = call4131;
  }
// compiled if node returning if4103 (depth = 6)
    gc_frame_newslot(if4103);
    if4088 = if4103;
  }
// compiled if node returning if4088 (depth = 5)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4132 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4133 == NULL) {
    strlit4133 = alloc_String("a try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4133);
  }
// compiled string node returning strlit4133 (depth = 6)
  gc_frame_newslot(strlit4133);
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4135 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4134);
// compiled call node returning call4135 (depth = 7)
// compiled member node returning call4135 (depth = 6)
  gc_frame_newslot(call4135);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4137 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4136);
// compiled call node returning call4137 (depth = 7)
// compiled member node returning call4137 (depth = 6)
  gc_frame_newslot(call4137);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4133;
  params[1] = call4135;
  params[2] = call4137;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4138 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4132);
// compiled call node returning call4138 (depth = 5)
    gc_frame_newslot(call4138);
    if4006 = call4138;
  }
// compiled if node returning if4006 (depth = 4)
    gc_frame_newslot(if4006);
    if4000 = if4006;
  }
// compiled if node returning if4000 (depth = 3)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4139 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4140 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4139);
// compiled call node returning call4140 (depth = 5)
// compiled member node returning call4140 (depth = 4)
  *var_finally = call4140;
  if (call4140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3985 = done;
  } else {
  }
// compiled if node returning if3985 (depth = 2)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4142 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4144 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4143);
// compiled call node returning call4144 (depth = 4)
// compiled member node returning call4144 (depth = 3)
  gc_frame_newslot(call4144);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  partcv[0] = 0;
  Object call4146 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4145);
// compiled call node returning call4146 (depth = 4)
// compiled member node returning call4146 (depth = 3)
  gc_frame_newslot(call4146);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4144;
  params[1] = call4146;
  partcv[0] = 2;
  Object call4147 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4142);
// compiled call node returning call4147 (depth = 2)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4148 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4149 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4151 = callmethod(*var_ast, "tryCatchNode",
    1, partcv, params);
  gc_frame_end(callframe4150);
// compiled call node returning call4151 (depth = 5)
// compiled member node returning call4151 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4152 = callmethod(call4151, "new",
    1, partcv, params);
  gc_frame_end(callframe4149);
// compiled call node returning call4152 (depth = 3)
  gc_frame_newslot(call4152);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4152;
  partcv[0] = 1;
  Object call4153 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4148);
// compiled call node returning call4153 (depth = 2)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4191 == NULL) {
    strlit4191 = alloc_String("case");
    gc_root(strlit4191);
  }
// compiled string node returning strlit4191 (depth = 9)
  int op_slot_right_4190 = gc_frame_newslot(strlit4191);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4193 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4194 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4193);
// compiled call node returning call4194 (depth = 10)
// compiled member node returning call4194 (depth = 9)
  int op_slot_left_4190 = gc_frame_newslot(call4194);
  params[0] = strlit4191;
  partcv[0] = 1;
  Object opresult4195 = callmethod(call4194, "==", 1, partcv, params);
// compiled op node returning opresult4195 (depth = 8)
  int op_slot_right_4189 = gc_frame_newslot(opresult4195);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4198 == NULL) {
    strlit4198 = alloc_String("identifier");
    gc_root(strlit4198);
  }
// compiled string node returning strlit4198 (depth = 9)
  int op_slot_right_4197 = gc_frame_newslot(strlit4198);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4201 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4200);
// compiled call node returning call4201 (depth = 10)
// compiled member node returning call4201 (depth = 9)
  int op_slot_left_4197 = gc_frame_newslot(call4201);
  params[0] = strlit4198;
  partcv[0] = 1;
  Object opresult4202 = callmethod(call4201, "==", 1, partcv, params);
// compiled op node returning opresult4202 (depth = 8)
  int op_slot_left_4189 = gc_frame_newslot(opresult4202);
  params[0] = opresult4195;
  partcv[0] = 1;
  Object opresult4203 = callmethod(opresult4202, "&&", 1, partcv, params);
// compiled op node returning opresult4203 (depth = 7)
  int op_slot_right_4188 = gc_frame_newslot(opresult4203);
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_matchTok (depth = 11)
  partcv[0] = 0;
  Object call4208 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4207);
// compiled call node returning call4208 (depth = 10)
// compiled member node returning call4208 (depth = 9)
  int op_slot_right_4206 = gc_frame_newslot(call4208);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4211 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4210);
// compiled call node returning call4211 (depth = 10)
// compiled member node returning call4211 (depth = 9)
  int op_slot_left_4206 = gc_frame_newslot(call4211);
  params[0] = call4208;
  partcv[0] = 1;
  Object opresult4212 = callmethod(call4211, "==", 1, partcv, params);
// compiled op node returning opresult4212 (depth = 8)
  int op_slot_right_4205 = gc_frame_newslot(opresult4212);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4215 == NULL) {
    strlit4215 = alloc_String("rparen");
    gc_root(strlit4215);
  }
// compiled string node returning strlit4215 (depth = 9)
  int op_slot_right_4214 = gc_frame_newslot(strlit4215);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4217 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4218 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 10)
// compiled member node returning call4218 (depth = 9)
  int op_slot_left_4214 = gc_frame_newslot(call4218);
  params[0] = strlit4215;
  partcv[0] = 1;
  Object opresult4219 = callmethod(call4218, "==", 1, partcv, params);
// compiled op node returning opresult4219 (depth = 8)
  int op_slot_left_4205 = gc_frame_newslot(opresult4219);
  params[0] = opresult4212;
  partcv[0] = 1;
  Object opresult4220 = callmethod(opresult4219, "&&", 1, partcv, params);
// compiled op node returning opresult4220 (depth = 7)
  int op_slot_left_4188 = gc_frame_newslot(opresult4220);
  params[0] = opresult4203;
  partcv[0] = 1;
  Object opresult4221 = callmethod(opresult4220, "||", 1, partcv, params);
// compiled op node returning opresult4221 (depth = 6)
  gc_frame_end(frame);
  return opresult4221;
}
Object meth_parser__apply4283(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4284 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4285 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4284);
// compiled call node returning call4285 (depth = 7)
  gc_frame_end(frame);
  return call4285;
}
Object meth_parser__apply4354(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4357 == NULL) {
    strlit4357 = alloc_String("case");
    gc_root(strlit4357);
  }
// compiled string node returning strlit4357 (depth = 6)
  int op_slot_right_4356 = gc_frame_newslot(strlit4357);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4360 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4360 (depth = 7)
// compiled member node returning call4360 (depth = 6)
  int op_slot_left_4356 = gc_frame_newslot(call4360);
  params[0] = strlit4357;
  partcv[0] = 1;
  Object opresult4361 = callmethod(call4360, "==", 1, partcv, params);
// compiled op node returning opresult4361 (depth = 5)
  int op_slot_right_4355 = gc_frame_newslot(opresult4361);
// starting to compile call node (depth = 5)
  int callframe4363 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4364 == NULL) {
    strlit4364 = alloc_String("identifier");
    gc_root(strlit4364);
  }
// compiled string node returning strlit4364 (depth = 6)
  gc_frame_newslot(strlit4364);
// call case 4: self request
  params[0] = strlit4364;
  partcv[0] = 1;
  Object call4365 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4363);
// compiled call node returning call4365 (depth = 5)
  int op_slot_left_4355 = gc_frame_newslot(call4365);
  params[0] = opresult4361;
  partcv[0] = 1;
  Object opresult4366 = callmethod(call4365, "&&", 1, partcv, params);
// compiled op node returning opresult4366 (depth = 4)
  gc_frame_end(frame);
  return opresult4366;
}
Object meth_parser__apply4388(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4389 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4390 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4389);
// compiled call node returning call4390 (depth = 11)
  gc_frame_end(frame);
  return call4390;
}
Object meth_parser__apply4369(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4370 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4371 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4370);
// compiled call node returning call4371 (depth = 5)
// compiled member node returning call4371 (depth = 4)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4373 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4374 == NULL) {
    strlit4374 = alloc_String("lbrace");
    gc_root(strlit4374);
  }
// compiled string node returning strlit4374 (depth = 6)
  gc_frame_newslot(strlit4374);
// call case 4: self request
  params[0] = strlit4374;
  partcv[0] = 1;
  Object call4375 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4373);
// compiled call node returning call4375 (depth = 5)
  Object if4372 = done;
  if (istrue(call4375)) {
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4377 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4376);
// compiled call node returning call4377 (depth = 6)
// compiled member node returning call4377 (depth = 5)
    gc_frame_newslot(call4377);
    if4372 = call4377;
  } else {
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4379 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4380 == NULL) {
    strlit4380 = alloc_String("lparen");
    gc_root(strlit4380);
  }
// compiled string node returning strlit4380 (depth = 7)
  gc_frame_newslot(strlit4380);
// call case 4: self request
  params[0] = strlit4380;
  partcv[0] = 1;
  Object call4381 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4379);
// compiled call node returning call4381 (depth = 6)
  Object if4378 = done;
  if (istrue(call4381)) {
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4382 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4383 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4382);
// compiled call node returning call4383 (depth = 7)
// compiled member node returning call4383 (depth = 6)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4385 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4386 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4387 = alloc_Block(NULL, NULL, "parser", 1345);
  gc_frame_newslot(block4387);
// method "_apply"
  block_savedest(block4387);
  Object closure4388 = createclosure(2, "_apply");
  setclosureframe(closure4388, stackframe);
  addtoclosure(closure4388, var_blocksOK);
  addtoclosure(closure4388, selfslot);
  struct UserObject *uo4388 = (struct UserObject*)block4387;
  uo4388->data[0] = (Object)closure4388;
  Method *meth_meth_parser__apply4388 = addmethod2pos(block4387, "_apply", &meth_parser__apply4388, 0);
  int argcv_meth_parser__apply4388[] = {0};
  meth_meth_parser__apply4388->type = alloc_MethodType(1, argcv_meth_parser__apply4388);
  meth_meth_parser__apply4388->definitionModule = modulename;
  meth_meth_parser__apply4388->definitionLine = 1345;
// compiled block node returning block4387 (depth = 10)
  gc_frame_newslot(block4387);
// call case 4: self request
  params[0] = block4387;
  partcv[0] = 1;
  Object call4392 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4386);
// compiled call node returning call4392 (depth = 9)
  partcv[0] = 0;
  Object call4393 = callmethod(call4392, "not",
    1, partcv, params);
  gc_frame_end(callframe4385);
// compiled call node returning call4393 (depth = 8)
// compiled member node returning call4393 (depth = 7)
  Object if4384 = done;
  if (istrue(call4393)) {
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4394 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4396 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4395);
// compiled call node returning call4396 (depth = 11)
// compiled member node returning call4396 (depth = 10)
  partcv[0] = 0;
  Object call4397 = callmethod(call4396, "new",
    1, partcv, params);
  gc_frame_end(callframe4394);
// compiled call node returning call4397 (depth = 9)
// compiled member node returning call4397 (depth = 8)
  *var_suggestion = call4397;
  if (call4397 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4398 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array4399 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit4400 == NULL) {
    strlit4400 = alloc_String("rparen");
    gc_root(strlit4400);
  }
// compiled string node returning strlit4400 (depth = 10)
  params[0] = strlit4400;
  partcv[0] = 1;
  callmethodflags(array4399, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4399 (depth = 9)
  gc_frame_newslot(array4399);
// call case 4: self request
  params[0] = array4399;
  partcv[0] = 1;
  Object call4401 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4398);
// compiled call node returning call4401 (depth = 8)
  *var_nextTok = call4401;
  if (call4401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4403 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4403 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4405 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4405 (depth = 8)
  Object if4402 = done;
  if (istrue(opresult4405)) {
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4406 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4407 == NULL) {
    strlit4407 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4407);
  }
// compiled string node returning strlit4407 (depth = 9)
  gc_frame_newslot(strlit4407);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4407;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4408 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4406);
// compiled call node returning call4408 (depth = 8)
    gc_frame_newslot(call4408);
    if4402 = call4408;
  } else {
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4409 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4410 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4411 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4410);
// compiled call node returning call4411 (depth = 10)
// compiled member node returning call4411 (depth = 9)
  gc_frame_newslot(call4411);
// starting to compile identifier node (depth = 9)
  Object bool4412 = alloc_Boolean(1);
// compiled identifier node returning bool4412 (depth = 9)
  gc_frame_newslot(bool4412);
// starting to compile identifier node (depth = 9)
  Object bool4413 = alloc_Boolean(0);
// compiled identifier node returning bool4413 (depth = 9)
  gc_frame_newslot(bool4413);
// starting to compile string node (depth = 9)
  if (strlit4414 == NULL) {
    strlit4414 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4414);
  }
// compiled string node returning strlit4414 (depth = 9)
  gc_frame_newslot(strlit4414);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4411;
  params[2] = bool4412;
  params[3] = bool4413;
  params[4] = strlit4414;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4415 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4409);
// compiled call node returning call4415 (depth = 8)
    gc_frame_newslot(call4415);
    if4402 = call4415;
  }
// compiled if node returning if4402 (depth = 7)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4416 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4417 == NULL) {
    strlit4417 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4417);
  }
// compiled string node returning strlit4417 (depth = 8)
  gc_frame_newslot(strlit4417);
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4419 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4418);
// compiled call node returning call4419 (depth = 9)
// compiled member node returning call4419 (depth = 8)
  gc_frame_newslot(call4419);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4421 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4420);
// compiled call node returning call4421 (depth = 9)
// compiled member node returning call4421 (depth = 8)
  gc_frame_newslot(call4421);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4417;
  params[1] = call4419;
  params[2] = call4421;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4422 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4416);
// compiled call node returning call4422 (depth = 7)
    gc_frame_newslot(call4422);
    if4384 = call4422;
  } else {
  }
// compiled if node returning if4384 (depth = 6)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4425 == NULL) {
    strlit4425 = alloc_String("rparen");
    gc_root(strlit4425);
  }
// compiled string node returning strlit4425 (depth = 8)
  int op_slot_right_4424 = gc_frame_newslot(strlit4425);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4428 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4427);
// compiled call node returning call4428 (depth = 9)
// compiled member node returning call4428 (depth = 8)
  int op_slot_left_4424 = gc_frame_newslot(call4428);
  params[0] = strlit4425;
  partcv[0] = 1;
  Object opresult4429 = callmethod(call4428, "≠", 1, partcv, params);
// compiled op node returning opresult4429 (depth = 7)
  Object if4423 = done;
  if (istrue(opresult4429)) {
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4430 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4431 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4430);
// compiled call node returning call4431 (depth = 8)
// compiled member node returning call4431 (depth = 7)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4434 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4433);
// compiled call node returning call4434 (depth = 11)
// compiled member node returning call4434 (depth = 10)
  partcv[0] = 0;
  Object call4435 = callmethod(call4434, "new",
    1, partcv, params);
  gc_frame_end(callframe4432);
// compiled call node returning call4435 (depth = 9)
// compiled member node returning call4435 (depth = 8)
  *var_suggestion = call4435;
  if (call4435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4436 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4437 == NULL) {
    strlit4437 = alloc_String(")");
    gc_root(strlit4437);
  }
// compiled string node returning strlit4437 (depth = 8)
  gc_frame_newslot(strlit4437);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4437;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4438 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4436);
// compiled call node returning call4438 (depth = 7)
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4439 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4440 == NULL) {
    strlit4440 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4440);
  }
// compiled string node returning strlit4440 (depth = 8)
  gc_frame_newslot(strlit4440);
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4441 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4442 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4441);
// compiled call node returning call4442 (depth = 9)
// compiled member node returning call4442 (depth = 8)
  gc_frame_newslot(call4442);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4445 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4444);
// compiled call node returning call4445 (depth = 10)
// compiled member node returning call4445 (depth = 9)
  int op_slot_right_4443 = gc_frame_newslot(call4445);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4448 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4447);
// compiled call node returning call4448 (depth = 10)
// compiled member node returning call4448 (depth = 9)
  int op_slot_left_4443 = gc_frame_newslot(call4448);
  params[0] = call4445;
  partcv[0] = 1;
  Object sum4449 = callmethod(call4448, "+", 1, partcv, params);
// compiled op node returning sum4449 (depth = 8)
  gc_frame_newslot(sum4449);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4440;
  params[1] = call4442;
  params[2] = sum4449;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4450 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4439);
// compiled call node returning call4450 (depth = 7)
    gc_frame_newslot(call4450);
    if4423 = call4450;
  } else {
  }
// compiled if node returning if4423 (depth = 6)
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4451 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4452 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4451);
// compiled call node returning call4452 (depth = 7)
// compiled member node returning call4452 (depth = 6)
    gc_frame_newslot(call4452);
    if4378 = call4452;
  } else {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array4453 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4453 (depth = 7)
  *var_suggestions = array4453;
  if (array4453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4454 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4455 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4454);
// compiled call node returning call4455 (depth = 7)
  *var_nextTok = call4455;
  if (call4455 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4456 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4458 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4457);
// compiled call node returning call4458 (depth = 10)
// compiled member node returning call4458 (depth = 9)
  partcv[0] = 0;
  Object call4459 = callmethod(call4458, "new",
    1, partcv, params);
  gc_frame_end(callframe4456);
// compiled call node returning call4459 (depth = 8)
// compiled member node returning call4459 (depth = 7)
  *var_suggestion = call4459;
  if (call4459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_right_4461 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 8)
  Object bool4463 = alloc_Boolean(0);
// compiled identifier node returning bool4463 (depth = 8)
  int op_slot_left_4461 = gc_frame_newslot(bool4463);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4464 = callmethod(bool4463, "==", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 7)
  Object if4460 = done;
  if (istrue(opresult4464)) {
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4465 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4466 == NULL) {
    strlit4466 = alloc_String(" }");
    gc_root(strlit4466);
  }
// compiled string node returning strlit4466 (depth = 8)
  gc_frame_newslot(strlit4466);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4468 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4467);
// compiled call node returning call4468 (depth = 9)
// compiled member node returning call4468 (depth = 8)
  gc_frame_newslot(call4468);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4466;
  params[1] = call4468;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4469 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4465);
// compiled call node returning call4469 (depth = 7)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4470 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4471 == NULL) {
    strlit4471 = alloc_String(" {");
    gc_root(strlit4471);
  }
// compiled string node returning strlit4471 (depth = 8)
  gc_frame_newslot(strlit4471);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4471;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4472 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4470);
// compiled call node returning call4472 (depth = 7)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4473 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4474 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4473);
// compiled call node returning call4474 (depth = 7)
    gc_frame_newslot(call4474);
    if4460 = call4474;
  } else {
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4476 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4476 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4478 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4478 (depth = 8)
  Object if4475 = done;
  if (istrue(opresult4478)) {
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4479 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4480 == NULL) {
    strlit4480 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4480);
  }
// compiled string node returning strlit4480 (depth = 9)
  gc_frame_newslot(strlit4480);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4480;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4481 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4479);
// compiled call node returning call4481 (depth = 8)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4482 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4483 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4482);
// compiled call node returning call4483 (depth = 8)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4484 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4486 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4485);
// compiled call node returning call4486 (depth = 12)
// compiled member node returning call4486 (depth = 11)
  partcv[0] = 0;
  Object call4487 = callmethod(call4486, "new",
    1, partcv, params);
  gc_frame_end(callframe4484);
// compiled call node returning call4487 (depth = 10)
// compiled member node returning call4487 (depth = 9)
  *var_suggestion = call4487;
  if (call4487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4489 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4490 == NULL) {
    strlit4490 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4490);
  }
// compiled string node returning strlit4490 (depth = 9)
  gc_frame_newslot(strlit4490);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4490;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4491 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4489);
// compiled call node returning call4491 (depth = 8)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4492 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4493 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4492);
// compiled call node returning call4493 (depth = 8)
    gc_frame_newslot(call4493);
    if4475 = call4493;
  } else {
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4494 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4495 == NULL) {
    strlit4495 = alloc_String(" }");
    gc_root(strlit4495);
  }
// compiled string node returning strlit4495 (depth = 9)
  gc_frame_newslot(strlit4495);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4497 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4496);
// compiled call node returning call4497 (depth = 10)
// compiled member node returning call4497 (depth = 9)
  gc_frame_newslot(call4497);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4495;
  params[1] = call4497;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4498 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4494);
// compiled call node returning call4498 (depth = 8)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4499 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4500 == NULL) {
    strlit4500 = alloc_String(" {");
    gc_root(strlit4500);
  }
// compiled string node returning strlit4500 (depth = 9)
  gc_frame_newslot(strlit4500);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4500;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4501 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4499);
// compiled call node returning call4501 (depth = 8)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4502 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4503 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4502);
// compiled call node returning call4503 (depth = 8)
    gc_frame_newslot(call4503);
    if4475 = call4503;
  }
// compiled if node returning if4475 (depth = 7)
    gc_frame_newslot(if4475);
    if4460 = if4475;
  }
// compiled if node returning if4460 (depth = 6)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4504 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4505 == NULL) {
    strlit4505 = alloc_String("a match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4505);
  }
// compiled string node returning strlit4505 (depth = 7)
  gc_frame_newslot(strlit4505);
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4507 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4506);
// compiled call node returning call4507 (depth = 8)
// compiled member node returning call4507 (depth = 7)
  gc_frame_newslot(call4507);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4509 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4508);
// compiled call node returning call4509 (depth = 8)
// compiled member node returning call4509 (depth = 7)
  gc_frame_newslot(call4509);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4505;
  params[1] = call4507;
  params[2] = call4509;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4510 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4504);
// compiled call node returning call4510 (depth = 6)
    gc_frame_newslot(call4510);
    if4378 = call4510;
  }
// compiled if node returning if4378 (depth = 5)
    gc_frame_newslot(if4378);
    if4372 = if4378;
  }
// compiled if node returning if4372 (depth = 4)
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4511 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4512 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4513 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4512);
// compiled call node returning call4513 (depth = 6)
// compiled member node returning call4513 (depth = 5)
  gc_frame_newslot(call4513);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4513;
  partcv[0] = 1;
  Object call4514 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4511);
// compiled call node returning call4514 (depth = 4)
  gc_frame_end(frame);
  return call4514;
}
Object meth_parser_matchcase4155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for matchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for matchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4157 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4160 == NULL) {
    strlit4160 = alloc_String("match");
    gc_root(strlit4160);
  }
// compiled string node returning strlit4160 (depth = 6)
  int op_slot_right_4159 = gc_frame_newslot(strlit4160);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4162 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4163 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4162);
// compiled call node returning call4163 (depth = 7)
// compiled member node returning call4163 (depth = 6)
  int op_slot_left_4159 = gc_frame_newslot(call4163);
  params[0] = strlit4160;
  partcv[0] = 1;
  Object opresult4164 = callmethod(call4163, "==", 1, partcv, params);
// compiled op node returning opresult4164 (depth = 5)
  int op_slot_right_4158 = gc_frame_newslot(opresult4164);
// starting to compile call node (depth = 5)
  int callframe4166 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4167 == NULL) {
    strlit4167 = alloc_String("identifier");
    gc_root(strlit4167);
  }
// compiled string node returning strlit4167 (depth = 6)
  gc_frame_newslot(strlit4167);
// call case 4: self request
  params[0] = strlit4167;
  partcv[0] = 1;
  Object call4168 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4166);
// compiled call node returning call4168 (depth = 5)
  int op_slot_left_4158 = gc_frame_newslot(call4168);
  params[0] = opresult4164;
  partcv[0] = 1;
  Object opresult4169 = callmethod(call4168, "&&", 1, partcv, params);
// compiled op node returning opresult4169 (depth = 4)
  partcv[0] = 0;
  Object call4170 = callmethod(opresult4169, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4157);
// compiled call node returning call4170 (depth = 3)
  Object if4156 = done;
  if (istrue(call4170)) {
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4171 = alloc_Float64(0);
// compiled num node returning num4171 (depth = 4)
  return num4171;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4156 = undefined;
  } else {
  }
// compiled if node returning if4156 (depth = 2)
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4173 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4172);
// compiled call node returning call4173 (depth = 3)
// compiled member node returning call4173 (depth = 2)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("lparen");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 4)
  int op_slot_right_4175 = gc_frame_newslot(strlit4176);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4179 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4178);
// compiled call node returning call4179 (depth = 5)
// compiled member node returning call4179 (depth = 4)
  int op_slot_left_4175 = gc_frame_newslot(call4179);
  params[0] = strlit4176;
  partcv[0] = 1;
  Object opresult4180 = callmethod(call4179, "≠", 1, partcv, params);
// compiled op node returning opresult4180 (depth = 3)
  Object if4174 = done;
  if (istrue(opresult4180)) {
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4181 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4183 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4182);
// compiled call node returning call4183 (depth = 7)
// compiled member node returning call4183 (depth = 6)
  partcv[0] = 0;
  Object call4184 = callmethod(call4183, "new",
    1, partcv, params);
  gc_frame_end(callframe4181);
// compiled call node returning call4184 (depth = 5)
// compiled member node returning call4184 (depth = 4)
  *var_suggestion = call4184;
  if (call4184 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4185 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4186 = alloc_Block(NULL, NULL, "parser", 1299);
  gc_frame_newslot(block4186);
// method "_apply"
  block_savedest(block4186);
  Object closure4187 = createclosure(2, "_apply");
  setclosureframe(closure4187, stackframe);
  addtoclosure(closure4187, var_matchTok);
  addtoclosure(closure4187, selfslot);
  struct UserObject *uo4187 = (struct UserObject*)block4186;
  uo4187->data[0] = (Object)closure4187;
  Method *meth_meth_parser__apply4187 = addmethod2pos(block4186, "_apply", &meth_parser__apply4187, 0);
  int argcv_meth_parser__apply4187[] = {1};
  meth_meth_parser__apply4187->type = alloc_MethodType(1, argcv_meth_parser__apply4187);
  meth_meth_parser__apply4187->definitionModule = modulename;
  meth_meth_parser__apply4187->definitionLine = 1297;
// compiled block node returning block4186 (depth = 5)
  gc_frame_newslot(block4186);
// call case 4: self request
  params[0] = block4186;
  partcv[0] = 1;
  Object call4223 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4185);
// compiled call node returning call4223 (depth = 4)
  *var_nextTok = call4223;
  if (call4223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_4225 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool4227 = alloc_Boolean(0);
// compiled identifier node returning bool4227 (depth = 5)
  int op_slot_left_4225 = gc_frame_newslot(bool4227);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult4228 = callmethod(bool4227, "==", 1, partcv, params);
// compiled op node returning opresult4228 (depth = 4)
  Object if4224 = done;
  if (istrue(opresult4228)) {
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4229 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4230 == NULL) {
    strlit4230 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4230);
  }
// compiled string node returning strlit4230 (depth = 5)
  gc_frame_newslot(strlit4230);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4230;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4231 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4229);
// compiled call node returning call4231 (depth = 4)
    gc_frame_newslot(call4231);
    if4224 = call4231;
  } else {
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4234 == NULL) {
    strlit4234 = alloc_String("rparen");
    gc_root(strlit4234);
  }
// compiled string node returning strlit4234 (depth = 6)
  int op_slot_right_4233 = gc_frame_newslot(strlit4234);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4237 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4236);
// compiled call node returning call4237 (depth = 7)
// compiled member node returning call4237 (depth = 6)
  int op_slot_left_4233 = gc_frame_newslot(call4237);
  params[0] = strlit4234;
  partcv[0] = 1;
  Object opresult4238 = callmethod(call4237, "==", 1, partcv, params);
// compiled op node returning opresult4238 (depth = 5)
  Object if4232 = done;
  if (istrue(opresult4238)) {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_4240 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4240 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4242 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4242 (depth = 6)
  Object if4239 = done;
  if (istrue(opresult4242)) {
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4243 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4244 == NULL) {
    strlit4244 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4244);
  }
// compiled string node returning strlit4244 (depth = 7)
  gc_frame_newslot(strlit4244);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4244;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4245 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4243);
// compiled call node returning call4245 (depth = 6)
    gc_frame_newslot(call4245);
    if4239 = call4245;
  } else {
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4246 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4247 == NULL) {
    strlit4247 = alloc_String("(");
    gc_root(strlit4247);
  }
// compiled string node returning strlit4247 (depth = 7)
  gc_frame_newslot(strlit4247);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4247;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4248 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4246);
// compiled call node returning call4248 (depth = 6)
    gc_frame_newslot(call4248);
    if4239 = call4248;
  }
// compiled if node returning if4239 (depth = 5)
    gc_frame_newslot(if4239);
    if4232 = if4239;
  } else {
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4251 == NULL) {
    strlit4251 = alloc_String("identifier");
    gc_root(strlit4251);
  }
// compiled string node returning strlit4251 (depth = 7)
  int op_slot_right_4250 = gc_frame_newslot(strlit4251);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4254 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4253);
// compiled call node returning call4254 (depth = 8)
// compiled member node returning call4254 (depth = 7)
  int op_slot_left_4250 = gc_frame_newslot(call4254);
  params[0] = strlit4251;
  partcv[0] = 1;
  Object opresult4255 = callmethod(call4254, "==", 1, partcv, params);
// compiled op node returning opresult4255 (depth = 6)
  Object if4249 = done;
  if (istrue(opresult4255)) {
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4256 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4257 == NULL) {
    strlit4257 = alloc_String("(");
    gc_root(strlit4257);
  }
// compiled string node returning strlit4257 (depth = 7)
  gc_frame_newslot(strlit4257);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4257;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4258 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4256);
// compiled call node returning call4258 (depth = 6)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4259 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4260 == NULL) {
    strlit4260 = alloc_String(")");
    gc_root(strlit4260);
  }
// compiled string node returning strlit4260 (depth = 7)
  gc_frame_newslot(strlit4260);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4262 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4261);
// compiled call node returning call4262 (depth = 8)
// compiled member node returning call4262 (depth = 7)
  gc_frame_newslot(call4262);
// starting to compile identifier node (depth = 7)
  Object bool4263 = alloc_Boolean(1);
// compiled identifier node returning bool4263 (depth = 7)
  gc_frame_newslot(bool4263);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4260;
  params[1] = call4262;
  params[2] = bool4263;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4264 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4259);
// compiled call node returning call4264 (depth = 6)
    gc_frame_newslot(call4264);
    if4249 = call4264;
  } else {
  }
// compiled if node returning if4249 (depth = 5)
    gc_frame_newslot(if4249);
    if4232 = if4249;
  }
// compiled if node returning if4232 (depth = 4)
    gc_frame_newslot(if4232);
    if4224 = if4232;
  }
// compiled if node returning if4224 (depth = 3)
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4265 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4266 == NULL) {
    strlit4266 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4266);
  }
// compiled string node returning strlit4266 (depth = 4)
  gc_frame_newslot(strlit4266);
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4267 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4268 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4267);
// compiled call node returning call4268 (depth = 5)
// compiled member node returning call4268 (depth = 4)
  gc_frame_newslot(call4268);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4271 = callmethod(*var_matchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4270);
// compiled call node returning call4271 (depth = 6)
// compiled member node returning call4271 (depth = 5)
  int op_slot_right_4269 = gc_frame_newslot(call4271);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4274 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4273);
// compiled call node returning call4274 (depth = 6)
// compiled member node returning call4274 (depth = 5)
  int op_slot_left_4269 = gc_frame_newslot(call4274);
  params[0] = call4271;
  partcv[0] = 1;
  Object sum4275 = callmethod(call4274, "+", 1, partcv, params);
// compiled op node returning sum4275 (depth = 4)
  gc_frame_newslot(sum4275);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4266;
  params[1] = call4268;
  params[2] = sum4275;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4276 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4265);
// compiled call node returning call4276 (depth = 3)
    gc_frame_newslot(call4276);
    if4174 = call4276;
  } else {
  }
// compiled if node returning if4174 (depth = 2)
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4278 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4277);
// compiled call node returning call4278 (depth = 3)
// compiled member node returning call4278 (depth = 2)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4280 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4281 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4282 = alloc_Block(NULL, NULL, "parser", 1317);
  gc_frame_newslot(block4282);
// method "_apply"
  block_savedest(block4282);
  Object closure4283 = createclosure(2, "_apply");
  setclosureframe(closure4283, stackframe);
  addtoclosure(closure4283, var_blocksOK);
  addtoclosure(closure4283, selfslot);
  struct UserObject *uo4283 = (struct UserObject*)block4282;
  uo4283->data[0] = (Object)closure4283;
  Method *meth_meth_parser__apply4283 = addmethod2pos(block4282, "_apply", &meth_parser__apply4283, 0);
  int argcv_meth_parser__apply4283[] = {0};
  meth_meth_parser__apply4283->type = alloc_MethodType(1, argcv_meth_parser__apply4283);
  meth_meth_parser__apply4283->definitionModule = modulename;
  meth_meth_parser__apply4283->definitionLine = 1317;
// compiled block node returning block4282 (depth = 6)
  gc_frame_newslot(block4282);
// call case 4: self request
  params[0] = block4282;
  partcv[0] = 1;
  Object call4287 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4281);
// compiled call node returning call4287 (depth = 5)
  partcv[0] = 0;
  Object call4288 = callmethod(call4287, "not",
    1, partcv, params);
  gc_frame_end(callframe4280);
// compiled call node returning call4288 (depth = 4)
// compiled member node returning call4288 (depth = 3)
  Object if4279 = done;
  if (istrue(call4288)) {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4289 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4291 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4290);
// compiled call node returning call4291 (depth = 7)
// compiled member node returning call4291 (depth = 6)
  partcv[0] = 0;
  Object call4292 = callmethod(call4291, "new",
    1, partcv, params);
  gc_frame_end(callframe4289);
// compiled call node returning call4292 (depth = 5)
// compiled member node returning call4292 (depth = 4)
  *var_suggestion = call4292;
  if (call4292 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4293 = gc_frame_new();
// starting to compile array node (depth = 5)
  Object array4294 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 6)
  if (strlit4295 == NULL) {
    strlit4295 = alloc_String("rparen");
    gc_root(strlit4295);
  }
// compiled string node returning strlit4295 (depth = 6)
  params[0] = strlit4295;
  partcv[0] = 1;
  callmethodflags(array4294, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4294 (depth = 5)
  gc_frame_newslot(array4294);
// call case 4: self request
  params[0] = array4294;
  partcv[0] = 1;
  Object call4296 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4293);
// compiled call node returning call4296 (depth = 4)
  *var_nextTok = call4296;
  if (call4296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4298 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4298 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4300 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4300 (depth = 4)
  Object if4297 = done;
  if (istrue(opresult4300)) {
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4301 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4302 == NULL) {
    strlit4302 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4302);
  }
// compiled string node returning strlit4302 (depth = 5)
  gc_frame_newslot(strlit4302);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4302;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4303 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4301);
// compiled call node returning call4303 (depth = 4)
    gc_frame_newslot(call4303);
    if4297 = call4303;
  } else {
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4304 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call4306 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4305);
// compiled call node returning call4306 (depth = 6)
// compiled member node returning call4306 (depth = 5)
  gc_frame_newslot(call4306);
// starting to compile identifier node (depth = 5)
  Object bool4307 = alloc_Boolean(1);
// compiled identifier node returning bool4307 (depth = 5)
  gc_frame_newslot(bool4307);
// starting to compile identifier node (depth = 5)
  Object bool4308 = alloc_Boolean(0);
// compiled identifier node returning bool4308 (depth = 5)
  gc_frame_newslot(bool4308);
// starting to compile string node (depth = 5)
  if (strlit4309 == NULL) {
    strlit4309 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4309);
  }
// compiled string node returning strlit4309 (depth = 5)
  gc_frame_newslot(strlit4309);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4306;
  params[2] = bool4307;
  params[3] = bool4308;
  params[4] = strlit4309;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4310 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4304);
// compiled call node returning call4310 (depth = 4)
    gc_frame_newslot(call4310);
    if4297 = call4310;
  }
// compiled if node returning if4297 (depth = 3)
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4311 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4312 == NULL) {
    strlit4312 = alloc_String("a match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4312);
  }
// compiled string node returning strlit4312 (depth = 4)
  gc_frame_newslot(strlit4312);
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4314 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4313);
// compiled call node returning call4314 (depth = 5)
// compiled member node returning call4314 (depth = 4)
  gc_frame_newslot(call4314);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4315 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4316 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4315);
// compiled call node returning call4316 (depth = 5)
// compiled member node returning call4316 (depth = 4)
  gc_frame_newslot(call4316);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4312;
  params[1] = call4314;
  params[2] = call4316;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4317 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4311);
// compiled call node returning call4317 (depth = 3)
    gc_frame_newslot(call4317);
    if4279 = call4317;
  } else {
  }
// compiled if node returning if4279 (depth = 2)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4319 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4318);
// compiled call node returning call4319 (depth = 4)
// compiled member node returning call4319 (depth = 3)
  *var_matchee = call4319;
  if (call4319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4322 == NULL) {
    strlit4322 = alloc_String("rparen");
    gc_root(strlit4322);
  }
// compiled string node returning strlit4322 (depth = 4)
  int op_slot_right_4321 = gc_frame_newslot(strlit4322);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4325 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 5)
// compiled member node returning call4325 (depth = 4)
  int op_slot_left_4321 = gc_frame_newslot(call4325);
  params[0] = strlit4322;
  partcv[0] = 1;
  Object opresult4326 = callmethod(call4325, "≠", 1, partcv, params);
// compiled op node returning opresult4326 (depth = 3)
  Object if4320 = done;
  if (istrue(opresult4326)) {
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4328 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4327);
// compiled call node returning call4328 (depth = 4)
// compiled member node returning call4328 (depth = 3)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4329 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4331 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4330);
// compiled call node returning call4331 (depth = 7)
// compiled member node returning call4331 (depth = 6)
  partcv[0] = 0;
  Object call4332 = callmethod(call4331, "new",
    1, partcv, params);
  gc_frame_end(callframe4329);
// compiled call node returning call4332 (depth = 5)
// compiled member node returning call4332 (depth = 4)
  *var_suggestion = call4332;
  if (call4332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4333 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4334 == NULL) {
    strlit4334 = alloc_String(")");
    gc_root(strlit4334);
  }
// compiled string node returning strlit4334 (depth = 4)
  gc_frame_newslot(strlit4334);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4334;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4335 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4333);
// compiled call node returning call4335 (depth = 3)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4336 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4337 == NULL) {
    strlit4337 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4337);
  }
// compiled string node returning strlit4337 (depth = 4)
  gc_frame_newslot(strlit4337);
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4338 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4339 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4338);
// compiled call node returning call4339 (depth = 5)
// compiled member node returning call4339 (depth = 4)
  gc_frame_newslot(call4339);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4342 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4341);
// compiled call node returning call4342 (depth = 6)
// compiled member node returning call4342 (depth = 5)
  int op_slot_right_4340 = gc_frame_newslot(call4342);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4345 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4344);
// compiled call node returning call4345 (depth = 6)
// compiled member node returning call4345 (depth = 5)
  int op_slot_left_4340 = gc_frame_newslot(call4345);
  params[0] = call4342;
  partcv[0] = 1;
  Object sum4346 = callmethod(call4345, "+", 1, partcv, params);
// compiled op node returning sum4346 (depth = 4)
  gc_frame_newslot(sum4346);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4337;
  params[1] = call4339;
  params[2] = sum4346;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4347 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4336);
// compiled call node returning call4347 (depth = 3)
    gc_frame_newslot(call4347);
    if4320 = call4347;
  } else {
  }
// compiled if node returning if4320 (depth = 2)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4349 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4348);
// compiled call node returning call4349 (depth = 3)
// compiled member node returning call4349 (depth = 2)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4350 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4350 (depth = 3)
  *var_cases = array4350;
  if (array4350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4351 = alloc_Boolean(0);
// compiled identifier node returning bool4351 (depth = 3)
  *var_elsecase = bool4351;
  if (bool4351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4352 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4353 = alloc_Block(NULL, NULL, "parser", 1339);
  gc_frame_newslot(block4353);
// method "_apply"
  block_savedest(block4353);
  Object closure4354 = createclosure(2, "_apply");
  setclosureframe(closure4354, stackframe);
  addtoclosure(closure4354, var_sym);
  addtoclosure(closure4354, selfslot);
  struct UserObject *uo4354 = (struct UserObject*)block4353;
  uo4354->data[0] = (Object)closure4354;
  Method *meth_meth_parser__apply4354 = addmethod2pos(block4353, "_apply", &meth_parser__apply4354, 0);
  int argcv_meth_parser__apply4354[] = {0};
  meth_meth_parser__apply4354->type = alloc_MethodType(1, argcv_meth_parser__apply4354);
  meth_meth_parser__apply4354->definitionModule = modulename;
  meth_meth_parser__apply4354->definitionLine = 1336;
// compiled block node returning block4353 (depth = 3)
  gc_frame_newslot(block4353);
// starting to compile block node (depth = 3)
  Object block4368 = alloc_Block(NULL, NULL, "parser", 1339);
  gc_frame_newslot(block4368);
// method "_apply"
  block_savedest(block4368);
  Object closure4369 = createclosure(8, "_apply");
  setclosureframe(closure4369, stackframe);
  addtoclosure(closure4369, var_blocksOK);
  addtoclosure(closure4369, var_errormessages);
  addtoclosure(closure4369, var_sym);
  addtoclosure(closure4369, var_lastToken);
  addtoclosure(closure4369, var_tokens);
  addtoclosure(closure4369, var_values);
  addtoclosure(closure4369, var_cases);
  addtoclosure(closure4369, selfslot);
  struct UserObject *uo4369 = (struct UserObject*)block4368;
  uo4369->data[0] = (Object)closure4369;
  Method *meth_meth_parser__apply4369 = addmethod2pos(block4368, "_apply", &meth_parser__apply4369, 0);
  int argcv_meth_parser__apply4369[] = {0};
  meth_meth_parser__apply4369->type = alloc_MethodType(1, argcv_meth_parser__apply4369);
  meth_meth_parser__apply4369->definitionModule = modulename;
  meth_meth_parser__apply4369->definitionLine = 1339;
// compiled block node returning block4368 (depth = 3)
  gc_frame_newslot(block4368);
// call case 5: prelude request
  params[0] = block4353;
  params[1] = block4368;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4516 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4352);
// compiled call node returning call4516 (depth = 2)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4517 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4519 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4518);
// compiled call node returning call4519 (depth = 4)
// compiled member node returning call4519 (depth = 3)
  gc_frame_newslot(call4519);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  partcv[0] = 0;
  Object call4521 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4520);
// compiled call node returning call4521 (depth = 4)
// compiled member node returning call4521 (depth = 3)
  gc_frame_newslot(call4521);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4519;
  params[1] = call4521;
  partcv[0] = 2;
  Object call4522 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4517);
// compiled call node returning call4522 (depth = 2)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4523 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4524 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase (depth = 4)
  gc_frame_newslot(*var_elsecase);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4526 = callmethod(*var_ast, "matchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4525);
// compiled call node returning call4526 (depth = 5)
// compiled member node returning call4526 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call4527 = callmethod(call4526, "new",
    1, partcv, params);
  gc_frame_end(callframe4524);
// compiled call node returning call4527 (depth = 3)
  gc_frame_newslot(call4527);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4527;
  partcv[0] = 1;
  Object call4528 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4523);
// compiled call node returning call4528 (depth = 2)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_term4530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for term (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for term");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4531 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4533 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4532);
// compiled call node returning call4533 (depth = 4)
// compiled member node returning call4533 (depth = 3)
  gc_frame_newslot(call4533);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4535 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4534);
// compiled call node returning call4535 (depth = 4)
// compiled member node returning call4535 (depth = 3)
  gc_frame_newslot(call4535);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4533;
  params[1] = call4535;
  partcv[0] = 2;
  Object call4536 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4531);
// compiled call node returning call4536 (depth = 2)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4538 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4539 == NULL) {
    strlit4539 = alloc_String("num");
    gc_root(strlit4539);
  }
// compiled string node returning strlit4539 (depth = 4)
  gc_frame_newslot(strlit4539);
// call case 4: self request
  params[0] = strlit4539;
  partcv[0] = 1;
  Object call4540 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4538);
// compiled call node returning call4540 (depth = 3)
  Object if4537 = done;
  if (istrue(call4540)) {
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4542 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4541);
// compiled call node returning call4542 (depth = 4)
// compiled member node returning call4542 (depth = 3)
    gc_frame_newslot(call4542);
    if4537 = call4542;
  } else {
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4544 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4545 == NULL) {
    strlit4545 = alloc_String("string");
    gc_root(strlit4545);
  }
// compiled string node returning strlit4545 (depth = 5)
  gc_frame_newslot(strlit4545);
// call case 4: self request
  params[0] = strlit4545;
  partcv[0] = 1;
  Object call4546 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4544);
// compiled call node returning call4546 (depth = 4)
  Object if4543 = done;
  if (istrue(call4546)) {
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4548 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 5)
// compiled member node returning call4548 (depth = 4)
    gc_frame_newslot(call4548);
    if4543 = call4548;
  } else {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4552 == NULL) {
    strlit4552 = alloc_String("match");
    gc_root(strlit4552);
  }
// compiled string node returning strlit4552 (depth = 7)
  int op_slot_right_4551 = gc_frame_newslot(strlit4552);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4555 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4554);
// compiled call node returning call4555 (depth = 8)
// compiled member node returning call4555 (depth = 7)
  int op_slot_left_4551 = gc_frame_newslot(call4555);
  params[0] = strlit4552;
  partcv[0] = 1;
  Object opresult4556 = callmethod(call4555, "==", 1, partcv, params);
// compiled op node returning opresult4556 (depth = 6)
  int op_slot_right_4550 = gc_frame_newslot(opresult4556);
// starting to compile call node (depth = 6)
  int callframe4558 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4559 == NULL) {
    strlit4559 = alloc_String("identifier");
    gc_root(strlit4559);
  }
// compiled string node returning strlit4559 (depth = 7)
  gc_frame_newslot(strlit4559);
// call case 4: self request
  params[0] = strlit4559;
  partcv[0] = 1;
  Object call4560 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4558);
// compiled call node returning call4560 (depth = 6)
  int op_slot_left_4550 = gc_frame_newslot(call4560);
  params[0] = opresult4556;
  partcv[0] = 1;
  Object opresult4561 = callmethod(call4560, "&&", 1, partcv, params);
// compiled op node returning opresult4561 (depth = 5)
  Object if4549 = done;
  if (istrue(opresult4561)) {
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4563 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4562);
// compiled call node returning call4563 (depth = 6)
// compiled member node returning call4563 (depth = 5)
    gc_frame_newslot(call4563);
    if4549 = call4563;
  } else {
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4567 == NULL) {
    strlit4567 = alloc_String("try");
    gc_root(strlit4567);
  }
// compiled string node returning strlit4567 (depth = 8)
  int op_slot_right_4566 = gc_frame_newslot(strlit4567);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4570 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4569);
// compiled call node returning call4570 (depth = 9)
// compiled member node returning call4570 (depth = 8)
  int op_slot_left_4566 = gc_frame_newslot(call4570);
  params[0] = strlit4567;
  partcv[0] = 1;
  Object opresult4571 = callmethod(call4570, "==", 1, partcv, params);
// compiled op node returning opresult4571 (depth = 7)
  int op_slot_right_4565 = gc_frame_newslot(opresult4571);
// starting to compile call node (depth = 7)
  int callframe4573 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4574 == NULL) {
    strlit4574 = alloc_String("identifier");
    gc_root(strlit4574);
  }
// compiled string node returning strlit4574 (depth = 8)
  gc_frame_newslot(strlit4574);
// call case 4: self request
  params[0] = strlit4574;
  partcv[0] = 1;
  Object call4575 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4573);
// compiled call node returning call4575 (depth = 7)
  int op_slot_left_4565 = gc_frame_newslot(call4575);
  params[0] = opresult4571;
  partcv[0] = 1;
  Object opresult4576 = callmethod(call4575, "&&", 1, partcv, params);
// compiled op node returning opresult4576 (depth = 6)
  Object if4564 = done;
  if (istrue(opresult4576)) {
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4577 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4578 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4577);
// compiled call node returning call4578 (depth = 7)
// compiled member node returning call4578 (depth = 6)
    gc_frame_newslot(call4578);
    if4564 = call4578;
  } else {
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4580 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4581 == NULL) {
    strlit4581 = alloc_String("identifier");
    gc_root(strlit4581);
  }
// compiled string node returning strlit4581 (depth = 8)
  gc_frame_newslot(strlit4581);
// call case 4: self request
  params[0] = strlit4581;
  partcv[0] = 1;
  Object call4582 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4580);
// compiled call node returning call4582 (depth = 7)
  Object if4579 = done;
  if (istrue(call4582)) {
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4584 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4583);
// compiled call node returning call4584 (depth = 8)
// compiled member node returning call4584 (depth = 7)
    gc_frame_newslot(call4584);
    if4579 = call4584;
  } else {
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4586 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4587 == NULL) {
    strlit4587 = alloc_String("object");
    gc_root(strlit4587);
  }
// compiled string node returning strlit4587 (depth = 9)
  gc_frame_newslot(strlit4587);
// call case 4: self request
  params[0] = strlit4587;
  partcv[0] = 1;
  Object call4588 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4586);
// compiled call node returning call4588 (depth = 8)
  Object if4585 = done;
  if (istrue(call4588)) {
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4589 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4590 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4589);
// compiled call node returning call4590 (depth = 9)
// compiled member node returning call4590 (depth = 8)
    gc_frame_newslot(call4590);
    if4585 = call4590;
  } else {
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4592 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4593 == NULL) {
    strlit4593 = alloc_String("type");
    gc_root(strlit4593);
  }
// compiled string node returning strlit4593 (depth = 10)
  gc_frame_newslot(strlit4593);
// call case 4: self request
  params[0] = strlit4593;
  partcv[0] = 1;
  Object call4594 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4592);
// compiled call node returning call4594 (depth = 9)
  Object if4591 = done;
  if (istrue(call4594)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4596 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4595);
// compiled call node returning call4596 (depth = 10)
// compiled member node returning call4596 (depth = 9)
    gc_frame_newslot(call4596);
    if4591 = call4596;
  } else {
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe4598 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit4599 == NULL) {
    strlit4599 = alloc_String("lbrace");
    gc_root(strlit4599);
  }
// compiled string node returning strlit4599 (depth = 11)
  gc_frame_newslot(strlit4599);
// call case 4: self request
  params[0] = strlit4599;
  partcv[0] = 1;
  Object call4600 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4598);
// compiled call node returning call4600 (depth = 10)
  Object if4597 = done;
  if (istrue(call4600)) {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4601 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4602 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4601);
// compiled call node returning call4602 (depth = 11)
// compiled member node returning call4602 (depth = 10)
    gc_frame_newslot(call4602);
    if4597 = call4602;
  } else {
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe4604 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit4605 == NULL) {
    strlit4605 = alloc_String("lsquare");
    gc_root(strlit4605);
  }
// compiled string node returning strlit4605 (depth = 12)
  gc_frame_newslot(strlit4605);
// call case 4: self request
  params[0] = strlit4605;
  partcv[0] = 1;
  Object call4606 = callmethodflags(self, "acceptAfterSpaces", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4604);
// compiled call node returning call4606 (depth = 11)
  Object if4603 = done;
  if (istrue(call4606)) {
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4607 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4608 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4607);
// compiled call node returning call4608 (depth = 12)
// compiled member node returning call4608 (depth = 11)
    gc_frame_newslot(call4608);
    if4603 = call4608;
  } else {
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4611 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4612 == NULL) {
    strlit4612 = alloc_String("lsquare");
    gc_root(strlit4612);
  }
// compiled string node returning strlit4612 (depth = 14)
  gc_frame_newslot(strlit4612);
// call case 4: self request
  params[0] = strlit4612;
  partcv[0] = 1;
  Object call4613 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4611);
// compiled call node returning call4613 (depth = 13)
  int op_slot_right_4610 = gc_frame_newslot(call4613);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit4616 == NULL) {
    strlit4616 = alloc_String("identifier");
    gc_root(strlit4616);
  }
// compiled string node returning strlit4616 (depth = 14)
  int op_slot_right_4615 = gc_frame_newslot(strlit4616);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe4618 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lastToken (depth = 16)
  partcv[0] = 0;
  Object call4619 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe4618);
// compiled call node returning call4619 (depth = 15)
// compiled member node returning call4619 (depth = 14)
  int op_slot_left_4615 = gc_frame_newslot(call4619);
  params[0] = strlit4616;
  partcv[0] = 1;
  Object opresult4620 = callmethod(call4619, "≠", 1, partcv, params);
// compiled op node returning opresult4620 (depth = 13)
  int op_slot_left_4610 = gc_frame_newslot(opresult4620);
  params[0] = call4613;
  partcv[0] = 1;
  Object opresult4621 = callmethod(opresult4620, "&&", 1, partcv, params);
// compiled op node returning opresult4621 (depth = 12)
  Object if4609 = done;
  if (istrue(opresult4621)) {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4623 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4622);
// compiled call node returning call4623 (depth = 13)
// compiled member node returning call4623 (depth = 12)
    gc_frame_newslot(call4623);
    if4609 = call4623;
  } else {
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe4625 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit4626 == NULL) {
    strlit4626 = alloc_String("op");
    gc_root(strlit4626);
  }
// compiled string node returning strlit4626 (depth = 14)
  gc_frame_newslot(strlit4626);
// call case 4: self request
  params[0] = strlit4626;
  partcv[0] = 1;
  Object call4627 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4625);
// compiled call node returning call4627 (depth = 13)
  Object if4624 = done;
  if (istrue(call4627)) {
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4628 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4629 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4628);
// compiled call node returning call4629 (depth = 14)
// compiled member node returning call4629 (depth = 13)
    gc_frame_newslot(call4629);
    if4624 = call4629;
  } else {
  }
// compiled if node returning if4624 (depth = 12)
    gc_frame_newslot(if4624);
    if4609 = if4624;
  }
// compiled if node returning if4609 (depth = 11)
    gc_frame_newslot(if4609);
    if4603 = if4609;
  }
// compiled if node returning if4603 (depth = 10)
    gc_frame_newslot(if4603);
    if4597 = if4603;
  }
// compiled if node returning if4597 (depth = 9)
    gc_frame_newslot(if4597);
    if4591 = if4597;
  }
// compiled if node returning if4591 (depth = 8)
    gc_frame_newslot(if4591);
    if4585 = if4591;
  }
// compiled if node returning if4585 (depth = 7)
    gc_frame_newslot(if4585);
    if4579 = if4585;
  }
// compiled if node returning if4579 (depth = 6)
    gc_frame_newslot(if4579);
    if4564 = if4579;
  }
// compiled if node returning if4564 (depth = 5)
    gc_frame_newslot(if4564);
    if4549 = if4564;
  }
// compiled if node returning if4549 (depth = 4)
    gc_frame_newslot(if4549);
    if4543 = if4549;
  }
// compiled if node returning if4543 (depth = 3)
    gc_frame_newslot(if4543);
    if4537 = if4543;
  }
// compiled if node returning if4537 (depth = 2)
  gc_frame_end(frame);
  return if4537;
}
Object meth_parser__apply4656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4657 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_acceptBlocks (depth = 9)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4658 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4657);
// compiled call node returning call4658 (depth = 8)
  gc_frame_end(frame);
  return call4658;
}
Object meth_parser_expression4630(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expression");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expression (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for expression");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4632 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe4631);
// compiled call node returning call4632 (depth = 4)
// compiled member node returning call4632 (depth = 3)
  *var_sz = call4632;
  if (call4632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4633 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4635 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4634);
// compiled call node returning call4635 (depth = 4)
// compiled member node returning call4635 (depth = 3)
  gc_frame_newslot(call4635);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4637 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4636);
// compiled call node returning call4637 (depth = 4)
// compiled member node returning call4637 (depth = 3)
  gc_frame_newslot(call4637);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4635;
  params[1] = call4637;
  partcv[0] = 2;
  Object call4638 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4633);
// compiled call node returning call4638 (depth = 2)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4640 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4641 == NULL) {
    strlit4641 = alloc_String("lparen");
    gc_root(strlit4641);
  }
// compiled string node returning strlit4641 (depth = 4)
  gc_frame_newslot(strlit4641);
// call case 4: self request
  params[0] = strlit4641;
  partcv[0] = 1;
  Object call4642 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4640);
// compiled call node returning call4642 (depth = 3)
  Object if4639 = done;
  if (istrue(call4642)) {
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4644 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4646 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4645);
// compiled call node returning call4646 (depth = 5)
// compiled member node returning call4646 (depth = 4)
  gc_frame_newslot(call4646);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4648 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4647);
// compiled call node returning call4648 (depth = 5)
// compiled member node returning call4648 (depth = 4)
  gc_frame_newslot(call4648);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call4646;
  params[1] = call4648;
  partcv[0] = 2;
  Object call4649 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4644);
// compiled call node returning call4649 (depth = 3)
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4651 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4650);
// compiled call node returning call4651 (depth = 4)
// compiled member node returning call4651 (depth = 3)
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4653 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4654 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4655 = alloc_Block(NULL, NULL, "parser", 1434);
  gc_frame_newslot(block4655);
// method "_apply"
  block_savedest(block4655);
  Object closure4656 = createclosure(2, "_apply");
  setclosureframe(closure4656, stackframe);
  addtoclosure(closure4656, var_acceptBlocks);
  addtoclosure(closure4656, selfslot);
  struct UserObject *uo4656 = (struct UserObject*)block4655;
  uo4656->data[0] = (Object)closure4656;
  Method *meth_meth_parser__apply4656 = addmethod2pos(block4655, "_apply", &meth_parser__apply4656, 0);
  int argcv_meth_parser__apply4656[] = {0};
  meth_meth_parser__apply4656->type = alloc_MethodType(1, argcv_meth_parser__apply4656);
  meth_meth_parser__apply4656->definitionModule = modulename;
  meth_meth_parser__apply4656->definitionLine = 1434;
// compiled block node returning block4655 (depth = 7)
  gc_frame_newslot(block4655);
// call case 4: self request
  params[0] = block4655;
  partcv[0] = 1;
  Object call4660 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4654);
// compiled call node returning call4660 (depth = 6)
  partcv[0] = 0;
  Object call4661 = callmethod(call4660, "not",
    1, partcv, params);
  gc_frame_end(callframe4653);
// compiled call node returning call4661 (depth = 5)
// compiled member node returning call4661 (depth = 4)
  Object if4652 = done;
  if (istrue(call4661)) {
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4662 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4663 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4664 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4663);
// compiled call node returning call4664 (depth = 8)
// compiled member node returning call4664 (depth = 7)
  partcv[0] = 0;
  Object call4665 = callmethod(call4664, "new",
    1, partcv, params);
  gc_frame_end(callframe4662);
// compiled call node returning call4665 (depth = 6)
// compiled member node returning call4665 (depth = 5)
  *var_suggestion = call4665;
  if (call4665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4666 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4667 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4668 == NULL) {
    strlit4668 = alloc_String("rparen");
    gc_root(strlit4668);
  }
// compiled string node returning strlit4668 (depth = 7)
  params[0] = strlit4668;
  partcv[0] = 1;
  callmethodflags(array4667, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4667 (depth = 6)
  gc_frame_newslot(array4667);
// call case 4: self request
  params[0] = array4667;
  partcv[0] = 1;
  Object call4669 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4666);
// compiled call node returning call4669 (depth = 5)
  *var_nextTok = call4669;
  if (call4669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4671 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4671 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4673 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4673 (depth = 5)
  Object if4670 = done;
  if (istrue(opresult4673)) {
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4674 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4675 == NULL) {
    strlit4675 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4675);
  }
// compiled string node returning strlit4675 (depth = 6)
  gc_frame_newslot(strlit4675);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4675;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4676 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4674);
// compiled call node returning call4676 (depth = 5)
    gc_frame_newslot(call4676);
    if4670 = call4676;
  } else {
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4677 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4679 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4678);
// compiled call node returning call4679 (depth = 7)
// compiled member node returning call4679 (depth = 6)
  gc_frame_newslot(call4679);
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool4680 = alloc_Boolean(1);
// compiled identifier node returning bool4680 (depth = 6)
  gc_frame_newslot(bool4680);
// starting to compile identifier node (depth = 6)
  Object bool4681 = alloc_Boolean(0);
// compiled identifier node returning bool4681 (depth = 6)
  gc_frame_newslot(bool4681);
// starting to compile string node (depth = 6)
  if (strlit4682 == NULL) {
    strlit4682 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4682);
  }
// compiled string node returning strlit4682 (depth = 6)
  gc_frame_newslot(strlit4682);
// call case 6: other member request
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4679;
  params[2] = bool4680;
  params[3] = bool4681;
  params[4] = strlit4682;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4683 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4677);
// compiled call node returning call4683 (depth = 5)
    gc_frame_newslot(call4683);
    if4670 = call4683;
  }
// compiled if node returning if4670 (depth = 4)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4684 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4685 == NULL) {
    strlit4685 = alloc_String("parentheses must contain a valid expression.");
    gc_root(strlit4685);
  }
// compiled string node returning strlit4685 (depth = 5)
  gc_frame_newslot(strlit4685);
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4687 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4686);
// compiled call node returning call4687 (depth = 6)
// compiled member node returning call4687 (depth = 5)
  gc_frame_newslot(call4687);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4689 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4688);
// compiled call node returning call4689 (depth = 6)
// compiled member node returning call4689 (depth = 5)
  gc_frame_newslot(call4689);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4685;
  params[1] = call4687;
  params[2] = call4689;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4690 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4684);
// compiled call node returning call4690 (depth = 4)
    gc_frame_newslot(call4690);
    if4652 = call4690;
  } else {
  }
// compiled if node returning if4652 (depth = 3)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4693 == NULL) {
    strlit4693 = alloc_String("rparen");
    gc_root(strlit4693);
  }
// compiled string node returning strlit4693 (depth = 5)
  int op_slot_right_4692 = gc_frame_newslot(strlit4693);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4696 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4695);
// compiled call node returning call4696 (depth = 6)
// compiled member node returning call4696 (depth = 5)
  int op_slot_left_4692 = gc_frame_newslot(call4696);
  params[0] = strlit4693;
  partcv[0] = 1;
  Object opresult4697 = callmethod(call4696, "≠", 1, partcv, params);
// compiled op node returning opresult4697 (depth = 4)
  Object if4691 = done;
  if (istrue(opresult4697)) {
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4699 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4698);
// compiled call node returning call4699 (depth = 5)
// compiled member node returning call4699 (depth = 4)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4700 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4702 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4701);
// compiled call node returning call4702 (depth = 8)
// compiled member node returning call4702 (depth = 7)
  partcv[0] = 0;
  Object call4703 = callmethod(call4702, "new",
    1, partcv, params);
  gc_frame_end(callframe4700);
// compiled call node returning call4703 (depth = 6)
// compiled member node returning call4703 (depth = 5)
  *var_suggestion = call4703;
  if (call4703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4704 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4705 == NULL) {
    strlit4705 = alloc_String(")");
    gc_root(strlit4705);
  }
// compiled string node returning strlit4705 (depth = 5)
  gc_frame_newslot(strlit4705);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4705;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4706 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4704);
// compiled call node returning call4706 (depth = 4)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4707 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4708 == NULL) {
    strlit4708 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4708);
  }
// compiled string node returning strlit4708 (depth = 5)
  gc_frame_newslot(strlit4708);
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4710 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4709);
// compiled call node returning call4710 (depth = 6)
// compiled member node returning call4710 (depth = 5)
  gc_frame_newslot(call4710);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4713 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4712);
// compiled call node returning call4713 (depth = 7)
// compiled member node returning call4713 (depth = 6)
  int op_slot_right_4711 = gc_frame_newslot(call4713);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4716 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4715);
// compiled call node returning call4716 (depth = 7)
// compiled member node returning call4716 (depth = 6)
  int op_slot_left_4711 = gc_frame_newslot(call4716);
  params[0] = call4713;
  partcv[0] = 1;
  Object sum4717 = callmethod(call4716, "+", 1, partcv, params);
// compiled op node returning sum4717 (depth = 5)
  gc_frame_newslot(sum4717);
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4708;
  params[1] = call4710;
  params[2] = sum4717;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4718 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4707);
// compiled call node returning call4718 (depth = 4)
    gc_frame_newslot(call4718);
    if4691 = call4718;
  } else {
  }
// compiled if node returning if4691 (depth = 3)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4720 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4721 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4720);
// compiled call node returning call4721 (depth = 4)
// compiled member node returning call4721 (depth = 3)
    gc_frame_newslot(call4721);
    if4639 = call4721;
  } else {
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4723 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4722);
// compiled call node returning call4723 (depth = 4)
// compiled member node returning call4723 (depth = 3)
    gc_frame_newslot(call4723);
    if4639 = call4723;
  }
// compiled if node returning if4639 (depth = 2)
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_4725 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4728 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe4727);
// compiled call node returning call4728 (depth = 5)
// compiled member node returning call4728 (depth = 4)
  int op_slot_left_4725 = gc_frame_newslot(call4728);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult4729 = callmethod(call4728, ">", 1, partcv, params);
// compiled op node returning opresult4729 (depth = 3)
  Object if4724 = done;
  if (istrue(opresult4729)) {
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4730 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4731 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4730);
// compiled call node returning call4731 (depth = 3)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4732 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call4733 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4732);
// compiled call node returning call4733 (depth = 3)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4734 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4735 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4734);
// compiled call node returning call4735 (depth = 4)
// compiled member node returning call4735 (depth = 3)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4736 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4737 = callmethodflags(self, "valueexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4736);
// compiled call node returning call4737 (depth = 4)
// compiled member node returning call4737 (depth = 3)
    gc_frame_newslot(call4737);
    if4724 = call4737;
  } else {
  }
// compiled if node returning if4724 (depth = 2)
  gc_frame_end(frame);
  return if4724;
}
Object meth_parser__apply4751(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4752 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4753 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4752);
// compiled call node returning call4753 (depth = 8)
  gc_frame_end(frame);
  return call4753;
}
Object meth_parser_postfixsquare4738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for postfixsquare (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for postfixsquare");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_opening = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "opening");
  Object *var_expr = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "expr");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4740 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4741 == NULL) {
    strlit4741 = alloc_String("lsquare");
    gc_root(strlit4741);
  }
// compiled string node returning strlit4741 (depth = 4)
  gc_frame_newslot(strlit4741);
// call case 4: self request
  params[0] = strlit4741;
  partcv[0] = 1;
  Object call4742 = callmethodflags(self, "acceptWithoutSpaces", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4740);
// compiled call node returning call4742 (depth = 3)
  Object if4739 = done;
  if (istrue(call4742)) {
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_opening = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4744 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4743);
// compiled call node returning call4744 (depth = 4)
// compiled member node returning call4744 (depth = 3)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4746 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4745);
// compiled call node returning call4746 (depth = 5)
// compiled member node returning call4746 (depth = 4)
  *var_expr = call4746;
  if (call4746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4748 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4749 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4750 = alloc_Block(NULL, NULL, "parser", 1474);
  gc_frame_newslot(block4750);
// method "_apply"
  block_savedest(block4750);
  Object closure4751 = createclosure(2, "_apply");
  setclosureframe(closure4751, stackframe);
  addtoclosure(closure4751, var_blocksOK);
  addtoclosure(closure4751, selfslot);
  struct UserObject *uo4751 = (struct UserObject*)block4750;
  uo4751->data[0] = (Object)closure4751;
  Method *meth_meth_parser__apply4751 = addmethod2pos(block4750, "_apply", &meth_parser__apply4751, 0);
  int argcv_meth_parser__apply4751[] = {0};
  meth_meth_parser__apply4751->type = alloc_MethodType(1, argcv_meth_parser__apply4751);
  meth_meth_parser__apply4751->definitionModule = modulename;
  meth_meth_parser__apply4751->definitionLine = 1474;
// compiled block node returning block4750 (depth = 7)
  gc_frame_newslot(block4750);
// call case 4: self request
  params[0] = block4750;
  partcv[0] = 1;
  Object call4755 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4749);
// compiled call node returning call4755 (depth = 6)
  partcv[0] = 0;
  Object call4756 = callmethod(call4755, "not",
    1, partcv, params);
  gc_frame_end(callframe4748);
// compiled call node returning call4756 (depth = 5)
// compiled member node returning call4756 (depth = 4)
  Object if4747 = done;
  if (istrue(call4756)) {
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array4757 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4757 (depth = 5)
  *var_suggestions = array4757;
  if (array4757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4758 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4760 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4759);
// compiled call node returning call4760 (depth = 8)
// compiled member node returning call4760 (depth = 7)
  partcv[0] = 0;
  Object call4761 = callmethod(call4760, "new",
    1, partcv, params);
  gc_frame_end(callframe4758);
// compiled call node returning call4761 (depth = 6)
// compiled member node returning call4761 (depth = 5)
  *var_suggestion = call4761;
  if (call4761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4762 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array4763 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit4764 == NULL) {
    strlit4764 = alloc_String("rsquare");
    gc_root(strlit4764);
  }
// compiled string node returning strlit4764 (depth = 7)
  params[0] = strlit4764;
  partcv[0] = 1;
  callmethodflags(array4763, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array4763 (depth = 6)
  gc_frame_newslot(array4763);
// call case 4: self request
  params[0] = array4763;
  partcv[0] = 1;
  Object call4765 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4762);
// compiled call node returning call4765 (depth = 5)
  *var_nextTok = call4765;
  if (call4765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4767 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4767 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4769 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4769 (depth = 5)
  Object if4766 = done;
  if (istrue(opresult4769)) {
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4770 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4771 == NULL) {
    strlit4771 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4771);
  }
// compiled string node returning strlit4771 (depth = 6)
  gc_frame_newslot(strlit4771);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4771;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4772 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4770);
// compiled call node returning call4772 (depth = 5)
    gc_frame_newslot(call4772);
    if4766 = call4772;
  } else {
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4773 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4775 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4774);
// compiled call node returning call4775 (depth = 7)
// compiled member node returning call4775 (depth = 6)
  gc_frame_newslot(call4775);
// starting to compile identifier node (depth = 6)
  Object bool4776 = alloc_Boolean(1);
// compiled identifier node returning bool4776 (depth = 6)
  gc_frame_newslot(bool4776);
// starting to compile identifier node (depth = 6)
  Object bool4777 = alloc_Boolean(0);
// compiled identifier node returning bool4777 (depth = 6)
  gc_frame_newslot(bool4777);
// starting to compile string node (depth = 6)
  if (strlit4778 == NULL) {
    strlit4778 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit4778);
  }
// compiled string node returning strlit4778 (depth = 6)
  gc_frame_newslot(strlit4778);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4775;
  params[2] = bool4776;
  params[3] = bool4777;
  params[4] = strlit4778;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4779 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4773);
// compiled call node returning call4779 (depth = 5)
    gc_frame_newslot(call4779);
    if4766 = call4779;
  }
// compiled if node returning if4766 (depth = 4)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4780 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4781 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4780);
// compiled call node returning call4781 (depth = 4)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4784 == NULL) {
    strlit4784 = alloc_String("rsquare");
    gc_root(strlit4784);
  }
// compiled string node returning strlit4784 (depth = 6)
  int op_slot_right_4783 = gc_frame_newslot(strlit4784);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4787 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4786);
// compiled call node returning call4787 (depth = 7)
// compiled member node returning call4787 (depth = 6)
  int op_slot_left_4783 = gc_frame_newslot(call4787);
  params[0] = strlit4784;
  partcv[0] = 1;
  Object opresult4788 = callmethod(call4787, "==", 1, partcv, params);
// compiled op node returning opresult4788 (depth = 5)
  Object if4782 = done;
  if (istrue(opresult4788)) {
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4789 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4791 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4790);
// compiled call node returning call4791 (depth = 9)
// compiled member node returning call4791 (depth = 8)
  partcv[0] = 0;
  Object call4792 = callmethod(call4791, "new",
    1, partcv, params);
  gc_frame_end(callframe4789);
// compiled call node returning call4792 (depth = 7)
// compiled member node returning call4792 (depth = 6)
  *var_suggestion = call4792;
  if (call4792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4794 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool4795 = alloc_Boolean(1);
// compiled identifier node returning bool4795 (depth = 6)
  gc_frame_newslot(bool4795);
// starting to compile identifier node (depth = 6)
  Object bool4796 = alloc_Boolean(0);
// compiled identifier node returning bool4796 (depth = 6)
  gc_frame_newslot(bool4796);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool4795;
  params[3] = bool4796;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4797 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe4794);
// compiled call node returning call4797 (depth = 5)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4798 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4799 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4798);
// compiled call node returning call4799 (depth = 5)
    gc_frame_newslot(call4799);
    if4782 = call4799;
  } else {
  }
// compiled if node returning if4782 (depth = 4)
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4800 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4801 == NULL) {
    strlit4801 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4801);
  }
// compiled string node returning strlit4801 (depth = 5)
  gc_frame_newslot(strlit4801);
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4802 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4803 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4802);
// compiled call node returning call4803 (depth = 6)
// compiled member node returning call4803 (depth = 5)
  gc_frame_newslot(call4803);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4805 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4804);
// compiled call node returning call4805 (depth = 6)
// compiled member node returning call4805 (depth = 5)
  gc_frame_newslot(call4805);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4801;
  params[1] = call4803;
  params[2] = call4805;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4806 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4800);
// compiled call node returning call4806 (depth = 4)
    gc_frame_newslot(call4806);
    if4747 = call4806;
  } else {
  }
// compiled if node returning if4747 (depth = 3)
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4809 == NULL) {
    strlit4809 = alloc_String("rsquare");
    gc_root(strlit4809);
  }
// compiled string node returning strlit4809 (depth = 5)
  int op_slot_right_4808 = gc_frame_newslot(strlit4809);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4811 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4812 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4811);
// compiled call node returning call4812 (depth = 6)
// compiled member node returning call4812 (depth = 5)
  int op_slot_left_4808 = gc_frame_newslot(call4812);
  params[0] = strlit4809;
  partcv[0] = 1;
  Object opresult4813 = callmethod(call4812, "≠", 1, partcv, params);
// compiled op node returning opresult4813 (depth = 4)
  Object if4807 = done;
  if (istrue(opresult4813)) {
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4814 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4815 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4816 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4815);
// compiled call node returning call4816 (depth = 8)
// compiled member node returning call4816 (depth = 7)
  partcv[0] = 0;
  Object call4817 = callmethod(call4816, "new",
    1, partcv, params);
  gc_frame_end(callframe4814);
// compiled call node returning call4817 (depth = 6)
// compiled member node returning call4817 (depth = 5)
  *var_suggestion = call4817;
  if (call4817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4818 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String("]");
    gc_root(strlit4819);
  }
// compiled string node returning strlit4819 (depth = 5)
  gc_frame_newslot(strlit4819);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4819;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4820 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4818);
// compiled call node returning call4820 (depth = 4)
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4821 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4822 == NULL) {
    strlit4822 = alloc_String("a '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit4822);
  }
// compiled string node returning strlit4822 (depth = 5)
  gc_frame_newslot(strlit4822);
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4824 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4823);
// compiled call node returning call4824 (depth = 6)
// compiled member node returning call4824 (depth = 5)
  gc_frame_newslot(call4824);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4827 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4826);
// compiled call node returning call4827 (depth = 7)
// compiled member node returning call4827 (depth = 6)
  int op_slot_right_4825 = gc_frame_newslot(call4827);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4829 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4830 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4829);
// compiled call node returning call4830 (depth = 7)
// compiled member node returning call4830 (depth = 6)
  int op_slot_left_4825 = gc_frame_newslot(call4830);
  params[0] = call4827;
  partcv[0] = 1;
  Object sum4831 = callmethod(call4830, "+", 1, partcv, params);
// compiled op node returning sum4831 (depth = 5)
  gc_frame_newslot(sum4831);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4822;
  params[1] = call4824;
  params[2] = sum4831;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4832 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4821);
// compiled call node returning call4832 (depth = 4)
    gc_frame_newslot(call4832);
    if4807 = call4832;
  } else {
  }
// compiled if node returning if4807 (depth = 3)
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4833 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4835 == NULL) {
    strlit4835 = alloc_String("For a Lineup, add a space.  For an indexing operation, use `at(_)` or `at(_)put(_)`.");
    gc_root(strlit4835);
  }
// compiled string node returning strlit4835 (depth = 5)
  int op_slot_right_4834 = gc_frame_newslot(strlit4835);
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4837 == NULL) {
    strlit4837 = alloc_String("'[ ... ]' without preceeding space is no longer part of Grace. ");
    gc_root(strlit4837);
  }
// compiled string node returning strlit4837 (depth = 5)
  int op_slot_left_4834 = gc_frame_newslot(strlit4837);
  params[0] = strlit4835;
  partcv[0] = 1;
  Object opresult4838 = callmethod(strlit4837, "++", 1, partcv, params);
// compiled op node returning opresult4838 (depth = 4)
  gc_frame_newslot(opresult4838);
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opening (depth = 6)
  partcv[0] = 0;
  Object call4840 = callmethod(*var_opening, "line",
    1, partcv, params);
  gc_frame_end(callframe4839);
// compiled call node returning call4840 (depth = 5)
// compiled member node returning call4840 (depth = 4)
  gc_frame_newslot(call4840);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4841 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opening (depth = 6)
  partcv[0] = 0;
  Object call4842 = callmethod(*var_opening, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4841);
// compiled call node returning call4842 (depth = 5)
// compiled member node returning call4842 (depth = 4)
  gc_frame_newslot(call4842);
// call case 6: other member request
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult4838;
  params[1] = call4840;
  params[2] = call4842;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call4843 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe4833);
// compiled call node returning call4843 (depth = 3)
    gc_frame_newslot(call4843);
    if4739 = call4843;
  } else {
  }
// compiled if node returning if4739 (depth = 2)
  gc_frame_end(frame);
  return if4739;
}
Object meth_parser_oprec4844(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method oprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for oprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for oprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4847 == NULL) {
    strlit4847 = alloc_String("*");
    gc_root(strlit4847);
  }
// compiled string node returning strlit4847 (depth = 4)
  int op_slot_right_4846 = gc_frame_newslot(strlit4847);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_4846 = gc_frame_newslot(*var_o);
  params[0] = strlit4847;
  partcv[0] = 1;
  Object opresult4849 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult4849 (depth = 3)
  Object if4845 = done;
  if (istrue(opresult4849)) {
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4850 = alloc_Float64(10);
// compiled num node returning num4850 (depth = 4)
  return num4850;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4845 = undefined;
  } else {
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4853 == NULL) {
    strlit4853 = alloc_String("/");
    gc_root(strlit4853);
  }
// compiled string node returning strlit4853 (depth = 5)
  int op_slot_right_4852 = gc_frame_newslot(strlit4853);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_4852 = gc_frame_newslot(*var_o);
  params[0] = strlit4853;
  partcv[0] = 1;
  Object opresult4855 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult4855 (depth = 4)
  Object if4851 = done;
  if (istrue(opresult4855)) {
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4856 = alloc_Float64(10);
// compiled num node returning num4856 (depth = 5)
  return num4856;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if4851 = undefined;
  } else {
  }
// compiled if node returning if4851 (depth = 3)
    gc_frame_newslot(if4851);
    if4845 = if4851;
  }
// compiled if node returning if4845 (depth = 2)
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4857 = alloc_Float64(5);
// compiled num node returning num4857 (depth = 3)
  return num4857;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec4858(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method toprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for toprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1518
  setline(1518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4861 = alloc_Float64(0);
// compiled num node returning num4861 (depth = 4)
  int op_slot_right_4860 = gc_frame_newslot(num4861);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4863 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call4864 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe4863);
// compiled call node returning call4864 (depth = 5)
// compiled member node returning call4864 (depth = 4)
  int op_slot_left_4860 = gc_frame_newslot(call4864);
  params[0] = num4861;
  partcv[0] = 1;
  Object opresult4865 = callmethod(call4864, ">", 1, partcv, params);
// compiled op node returning opresult4865 (depth = 3)
  Object if4859 = done;
  if (istrue(opresult4865)) {
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call4867 = callmethod(*var_ops, "last",
    1, partcv, params);
  gc_frame_end(callframe4866);
// compiled call node returning call4867 (depth = 5)
// compiled member node returning call4867 (depth = 4)
  *var_o = call4867;
  if (call4867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4868 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4869 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled call node returning call4869 (depth = 4)
  return call4869;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4859 = undefined;
  } else {
  }
// compiled if node returning if4859 (depth = 2)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4870 = alloc_Float64(0);
// compiled num node returning num4870 (depth = 2)
  gc_frame_end(frame);
  return num4870;
}
Object meth_parser__apply4879(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4881 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4880);
// compiled call node returning call4881 (depth = 6)
// compiled member node returning call4881 (depth = 5)
  gc_frame_end(frame);
  return call4881;
}
Object meth_parser_typeexpressionrest4871(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4873 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4874 == NULL) {
    strlit4874 = alloc_String("op");
    gc_root(strlit4874);
  }
// compiled string node returning strlit4874 (depth = 4)
  gc_frame_newslot(strlit4874);
// call case 4: self request
  params[0] = strlit4874;
  partcv[0] = 1;
  Object call4875 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4873);
// compiled call node returning call4875 (depth = 3)
  Object if4872 = done;
  if (istrue(call4875)) {
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4876 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4877 == NULL) {
    strlit4877 = alloc_String("type expression");
    gc_root(strlit4877);
  }
// compiled string node returning strlit4877 (depth = 4)
  gc_frame_newslot(strlit4877);
// starting to compile block node (depth = 4)
  Object block4878 = alloc_Block(NULL, NULL, "parser", 1528);
  gc_frame_newslot(block4878);
// method "_apply"
  block_savedest(block4878);
  Object closure4879 = createclosure(1, "_apply");
  setclosureframe(closure4879, stackframe);
  addtoclosure(closure4879, selfslot);
  struct UserObject *uo4879 = (struct UserObject*)block4878;
  uo4879->data[0] = (Object)closure4879;
  Method *meth_meth_parser__apply4879 = addmethod2pos(block4878, "_apply", &meth_parser__apply4879, 0);
  int argcv_meth_parser__apply4879[] = {0};
  meth_meth_parser__apply4879->type = alloc_MethodType(1, argcv_meth_parser__apply4879);
  meth_meth_parser__apply4879->definitionModule = modulename;
  meth_meth_parser__apply4879->definitionLine = 1519;
// compiled block node returning block4878 (depth = 4)
  gc_frame_newslot(block4878);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = strlit4877;
  params[1] = block4878;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4883 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4876);
// compiled call node returning call4883 (depth = 3)
    gc_frame_newslot(call4883);
    if4872 = call4883;
  } else {
  }
// compiled if node returning if4872 (depth = 2)
  gc_frame_end(frame);
  return if4872;
}
Object meth_parser__apply4892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe4893 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4894 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4893);
// compiled call node returning call4894 (depth = 5)
  gc_frame_end(frame);
  return call4894;
}
Object meth_parser_valueexpressionrest4884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valueexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for valueexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4886 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4887 == NULL) {
    strlit4887 = alloc_String("op");
    gc_root(strlit4887);
  }
// compiled string node returning strlit4887 (depth = 4)
  gc_frame_newslot(strlit4887);
// call case 4: self request
  params[0] = strlit4887;
  partcv[0] = 1;
  Object call4888 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4886);
// compiled call node returning call4888 (depth = 3)
  Object if4885 = done;
  if (istrue(call4888)) {
// Begin line 1534
  setline(1534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4889 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4890 == NULL) {
    strlit4890 = alloc_String("expression");
    gc_root(strlit4890);
  }
// compiled string node returning strlit4890 (depth = 4)
  gc_frame_newslot(strlit4890);
// starting to compile block node (depth = 4)
  Object block4891 = alloc_Block(NULL, NULL, "parser", 1534);
  gc_frame_newslot(block4891);
// method "_apply"
  block_savedest(block4891);
  Object closure4892 = createclosure(2, "_apply");
  setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_blocksOK);
  addtoclosure(closure4892, selfslot);
  struct UserObject *uo4892 = (struct UserObject*)block4891;
  uo4892->data[0] = (Object)closure4892;
  Method *meth_meth_parser__apply4892 = addmethod2pos(block4891, "_apply", &meth_parser__apply4892, 0);
  int argcv_meth_parser__apply4892[] = {0};
  meth_meth_parser__apply4892->type = alloc_MethodType(1, argcv_meth_parser__apply4892);
  meth_meth_parser__apply4892->definitionModule = modulename;
  meth_meth_parser__apply4892->definitionLine = 1528;
// compiled block node returning block4891 (depth = 4)
  gc_frame_newslot(block4891);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = strlit4890;
  params[1] = block4891;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4896 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4889);
// compiled call node returning call4896 (depth = 3)
    gc_frame_newslot(call4896);
    if4885 = call4896;
  } else {
  }
// compiled if node returning if4885 (depth = 2)
  gc_frame_end(frame);
  return if4885;
}
Object meth_parser__apply4912(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4914 == NULL) {
    strlit4914 = alloc_String("=");
    gc_root(strlit4914);
  }
// compiled string node returning strlit4914 (depth = 7)
  int op_slot_right_4913 = gc_frame_newslot(strlit4914);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4916 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4917 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4916);
// compiled call node returning call4917 (depth = 8)
// compiled member node returning call4917 (depth = 7)
  int op_slot_left_4913 = gc_frame_newslot(call4917);
  params[0] = strlit4914;
  partcv[0] = 1;
  Object opresult4918 = callmethod(call4917, "≠", 1, partcv, params);
// compiled op node returning opresult4918 (depth = 6)
  gc_frame_end(frame);
  return opresult4918;
}
Object meth_parser__apply4909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block4911 = alloc_Block(NULL, NULL, "parser", 1556);
  gc_frame_newslot(block4911);
// method "_apply"
  block_savedest(block4911);
  Object closure4912 = createclosure(2, "_apply");
  setclosureframe(closure4912, stackframe);
  addtoclosure(closure4912, var_sym);
  addtoclosure(closure4912, selfslot);
  struct UserObject *uo4912 = (struct UserObject*)block4911;
  uo4912->data[0] = (Object)closure4912;
  Method *meth_meth_parser__apply4912 = addmethod2pos(block4911, "_apply", &meth_parser__apply4912, 0);
  int argcv_meth_parser__apply4912[] = {0};
  meth_meth_parser__apply4912->type = alloc_MethodType(1, argcv_meth_parser__apply4912);
  meth_meth_parser__apply4912->definitionModule = modulename;
  meth_meth_parser__apply4912->definitionLine = 1549;
// compiled block node returning block4911 (depth = 5)
  int op_slot_right_4910 = gc_frame_newslot(block4911);
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4921 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4922 == NULL) {
    strlit4922 = alloc_String("op");
    gc_root(strlit4922);
  }
// compiled string node returning strlit4922 (depth = 6)
  gc_frame_newslot(strlit4922);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 4: self request
  params[0] = strlit4922;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4923 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4921);
// compiled call node returning call4923 (depth = 5)
  int op_slot_left_4910 = gc_frame_newslot(call4923);
  params[0] = block4911;
  partcv[0] = 1;
  Object opresult4924 = callmethod(call4923, "&&", 1, partcv, params);
// compiled op node returning opresult4924 (depth = 4)
  gc_frame_end(frame);
  return opresult4924;
}
Object meth_parser__apply5035(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5038 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 4: self request
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call5039 = callmethodflags(self, "toprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5038);
// compiled call node returning call5039 (depth = 8)
  int op_slot_right_5037 = gc_frame_newslot(call5039);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_5037 = gc_frame_newslot(*var_prec);
  params[0] = call5039;
  partcv[0] = 1;
  Object opresult5041 = callmethod(*var_prec, "≤", 1, partcv, params);
// compiled op node returning opresult5041 (depth = 7)
  int op_slot_right_5036 = gc_frame_newslot(opresult5041);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5044 = alloc_Float64(0);
// compiled num node returning num5044 (depth = 8)
  int op_slot_right_5043 = gc_frame_newslot(num5044);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ops (depth = 10)
  partcv[0] = 0;
  Object call5047 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5046);
// compiled call node returning call5047 (depth = 9)
// compiled member node returning call5047 (depth = 8)
  int op_slot_left_5043 = gc_frame_newslot(call5047);
  params[0] = num5044;
  partcv[0] = 1;
  Object opresult5048 = callmethod(call5047, ">", 1, partcv, params);
// compiled op node returning opresult5048 (depth = 7)
  int op_slot_left_5036 = gc_frame_newslot(opresult5048);
  params[0] = opresult5041;
  partcv[0] = 1;
  Object opresult5049 = callmethod(opresult5048, "&&", 1, partcv, params);
// compiled op node returning opresult5049 (depth = 6)
  gc_frame_end(frame);
  return opresult5049;
}
Object meth_parser__apply5052(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  partcv[0] = 0;
  Object call5054 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5053);
// compiled call node returning call5054 (depth = 8)
// compiled member node returning call5054 (depth = 7)
  *var_o2 = call5054;
  if (call5054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5057 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5056);
// compiled call node returning call5057 (depth = 8)
// compiled member node returning call5057 (depth = 7)
  *var_tmp2 = call5057;
  if (call5057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5060 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5059);
// compiled call node returning call5060 (depth = 8)
// compiled member node returning call5060 (depth = 7)
  *var_tmp = call5060;
  if (call5060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5062 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5064 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5063);
// compiled call node returning call5064 (depth = 8)
// compiled member node returning call5064 (depth = 7)
  gc_frame_newslot(call5064);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tmp (depth = 9)
  partcv[0] = 0;
  Object call5066 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5065);
// compiled call node returning call5066 (depth = 8)
// compiled member node returning call5066 (depth = 7)
  gc_frame_newslot(call5066);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call5064;
  params[1] = call5066;
  partcv[0] = 2;
  Object call5067 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5062);
// compiled call node returning call5067 (depth = 6)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5068 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call5070 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5069);
// compiled call node returning call5070 (depth = 9)
// compiled member node returning call5070 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5071 = callmethod(call5070, "new",
    1, partcv, params);
  gc_frame_end(callframe5068);
// compiled call node returning call5071 (depth = 7)
  *var_tmp = call5071;
  if (call5071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5073 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5074 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5073);
// compiled call node returning call5074 (depth = 6)
  gc_frame_end(frame);
  return call5074;
}
Object meth_parser__apply5251(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5252 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5253 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5252);
// compiled call node returning call5253 (depth = 11)
// compiled member node returning call5253 (depth = 10)
  gc_frame_end(frame);
  return call5253;
}
Object meth_parser__apply4927(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_util = getfromclosure(closure, 13);
  Object *var_ast = getfromclosure(closure, 14);
  Object *var_recurse = getfromclosure(closure, 15);
  Object *var_name = getfromclosure(closure, 16);
  Object *var_acceptBlocks = getfromclosure(closure, 17);
  Object *var_values = getfromclosure(closure, 18);
  Object self = *(getfromclosure(closure, 19));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4929 = alloc_Float64(1);
// compiled num node returning num4929 (depth = 6)
  int op_slot_right_4928 = gc_frame_newslot(num4929);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_4928 = gc_frame_newslot(*var_opcount);
  params[0] = num4929;
  partcv[0] = 1;
  Object sum4931 = callmethod(*var_opcount, "+", 1, partcv, params);
// compiled op node returning sum4931 (depth = 5)
  *var_opcount = sum4931;
  if (sum4931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4934 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4933);
// compiled call node returning call4934 (depth = 6)
// compiled member node returning call4934 (depth = 5)
  *var_o = call4934;
  if (call4934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4936 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4937 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4936);
// compiled call node returning call4937 (depth = 5)
// compiled member node returning call4937 (depth = 4)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4938 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call4939 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4938);
// compiled call node returning call4939 (depth = 5)
  *var_prec = call4939;
  if (call4939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4944 == NULL) {
    strlit4944 = alloc_String("-");
    gc_root(strlit4944);
  }
// compiled string node returning strlit4944 (depth = 7)
  int op_slot_right_4943 = gc_frame_newslot(strlit4944);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_4943 = gc_frame_newslot(*var_o);
  params[0] = strlit4944;
  partcv[0] = 1;
  Object opresult4946 = callmethod(*var_o, "≠", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 6)
  int op_slot_right_4942 = gc_frame_newslot(opresult4946);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4950 == NULL) {
    strlit4950 = alloc_String("+");
    gc_root(strlit4950);
  }
// compiled string node returning strlit4950 (depth = 8)
  int op_slot_right_4949 = gc_frame_newslot(strlit4950);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_4949 = gc_frame_newslot(*var_o);
  params[0] = strlit4950;
  partcv[0] = 1;
  Object opresult4952 = callmethod(*var_o, "≠", 1, partcv, params);
// compiled op node returning opresult4952 (depth = 7)
  int op_slot_right_4948 = gc_frame_newslot(opresult4952);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4956 == NULL) {
    strlit4956 = alloc_String("/");
    gc_root(strlit4956);
  }
// compiled string node returning strlit4956 (depth = 9)
  int op_slot_right_4955 = gc_frame_newslot(strlit4956);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4955 = gc_frame_newslot(*var_o);
  params[0] = strlit4956;
  partcv[0] = 1;
  Object opresult4958 = callmethod(*var_o, "≠", 1, partcv, params);
// compiled op node returning opresult4958 (depth = 8)
  int op_slot_right_4954 = gc_frame_newslot(opresult4958);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4961 == NULL) {
    strlit4961 = alloc_String("*");
    gc_root(strlit4961);
  }
// compiled string node returning strlit4961 (depth = 9)
  int op_slot_right_4960 = gc_frame_newslot(strlit4961);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_4960 = gc_frame_newslot(*var_o);
  params[0] = strlit4961;
  partcv[0] = 1;
  Object opresult4963 = callmethod(*var_o, "≠", 1, partcv, params);
// compiled op node returning opresult4963 (depth = 8)
  int op_slot_left_4954 = gc_frame_newslot(opresult4963);
  params[0] = opresult4958;
  partcv[0] = 1;
  Object opresult4964 = callmethod(opresult4963, "&&", 1, partcv, params);
// compiled op node returning opresult4964 (depth = 7)
  int op_slot_left_4948 = gc_frame_newslot(opresult4964);
  params[0] = opresult4952;
  partcv[0] = 1;
  Object opresult4965 = callmethod(opresult4964, "&&", 1, partcv, params);
// compiled op node returning opresult4965 (depth = 6)
  int op_slot_left_4942 = gc_frame_newslot(opresult4965);
  params[0] = opresult4946;
  partcv[0] = 1;
  Object opresult4966 = callmethod(opresult4965, "&&", 1, partcv, params);
// compiled op node returning opresult4966 (depth = 5)
  Object if4941 = done;
  if (istrue(opresult4966)) {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4967 = alloc_Boolean(0);
// compiled identifier node returning bool4967 (depth = 6)
  *var_allarith = bool4967;
  if (bool4967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4941 = done;
  } else {
  }
// compiled if node returning if4941 (depth = 4)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_allarith (depth = 8)
  partcv[0] = 0;
  Object call4972 = callmethod(*var_allarith, "not",
    1, partcv, params);
  gc_frame_end(callframe4971);
// compiled call node returning call4972 (depth = 7)
// compiled member node returning call4972 (depth = 6)
  int op_slot_right_4970 = gc_frame_newslot(call4972);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_4975 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4975 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult4977 = callmethod(*var_opdtype, "≠", 1, partcv, params);
// compiled op node returning opresult4977 (depth = 7)
  int op_slot_right_4974 = gc_frame_newslot(opresult4977);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4980 == NULL) {
    strlit4980 = alloc_String("");
    gc_root(strlit4980);
  }
// compiled string node returning strlit4980 (depth = 8)
  int op_slot_right_4979 = gc_frame_newslot(strlit4980);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_4979 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit4980;
  partcv[0] = 1;
  Object opresult4982 = callmethod(*var_opdtype, "≠", 1, partcv, params);
// compiled op node returning opresult4982 (depth = 7)
  int op_slot_left_4974 = gc_frame_newslot(opresult4982);
  params[0] = opresult4977;
  partcv[0] = 1;
  Object opresult4983 = callmethod(opresult4982, "&&", 1, partcv, params);
// compiled op node returning opresult4983 (depth = 6)
  int op_slot_left_4970 = gc_frame_newslot(opresult4983);
  params[0] = call4972;
  partcv[0] = 1;
  Object opresult4984 = callmethod(opresult4983, "&&", 1, partcv, params);
// compiled op node returning opresult4984 (depth = 5)
  Object if4969 = done;
  if (istrue(opresult4984)) {
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array4985 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4985 (depth = 6)
  *var_suggestions = array4985;
  if (array4985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4986 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4988 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4987);
// compiled call node returning call4988 (depth = 9)
// compiled member node returning call4988 (depth = 8)
  partcv[0] = 0;
  Object call4989 = callmethod(call4988, "new",
    1, partcv, params);
  gc_frame_end(callframe4986);
// compiled call node returning call4989 (depth = 7)
// compiled member node returning call4989 (depth = 6)
  *var_suggestion = call4989;
  if (call4989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4990 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4991 == NULL) {
    strlit4991 = alloc_String(")");
    gc_root(strlit4991);
  }
// compiled string node returning strlit4991 (depth = 6)
  gc_frame_newslot(strlit4991);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4991;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4992 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4990);
// compiled call node returning call4992 (depth = 5)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4993 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4994 == NULL) {
    strlit4994 = alloc_String("(");
    gc_root(strlit4994);
  }
// compiled string node returning strlit4994 (depth = 6)
  gc_frame_newslot(strlit4994);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4996 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe4995);
// compiled call node returning call4996 (depth = 7)
// compiled member node returning call4996 (depth = 6)
  gc_frame_newslot(call4996);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4994;
  params[1] = call4996;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4997 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4993);
// compiled call node returning call4997 (depth = 5)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4998 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4998);
// compiled call node returning call4999 (depth = 5)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5000 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5002 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5001);
// compiled call node returning call5002 (depth = 9)
// compiled member node returning call5002 (depth = 8)
  partcv[0] = 0;
  Object call5003 = callmethod(call5002, "new",
    1, partcv, params);
  gc_frame_end(callframe5000);
// compiled call node returning call5003 (depth = 7)
// compiled member node returning call5003 (depth = 6)
  *var_suggestion = call5003;
  if (call5003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5005 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5006 == NULL) {
    strlit5006 = alloc_String(")");
    gc_root(strlit5006);
  }
// compiled string node returning strlit5006 (depth = 6)
  gc_frame_newslot(strlit5006);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5008 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5007);
// compiled call node returning call5008 (depth = 7)
// compiled member node returning call5008 (depth = 6)
  gc_frame_newslot(call5008);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5006;
  params[1] = call5008;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5009 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5005);
// compiled call node returning call5009 (depth = 5)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5010 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5011 == NULL) {
    strlit5011 = alloc_String("(");
    gc_root(strlit5011);
  }
// compiled string node returning strlit5011 (depth = 6)
  gc_frame_newslot(strlit5011);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5012 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5013 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call5015 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5014);
// compiled call node returning call5015 (depth = 11)
// compiled member node returning call5015 (depth = 10)
  partcv[0] = 0;
  Object call5016 = callmethod(call5015, "prev",
    1, partcv, params);
  gc_frame_end(callframe5013);
// compiled call node returning call5016 (depth = 9)
// compiled member node returning call5016 (depth = 8)
  partcv[0] = 0;
  Object call5017 = callmethod(call5016, "prev",
    1, partcv, params);
  gc_frame_end(callframe5012);
// compiled call node returning call5017 (depth = 7)
// compiled member node returning call5017 (depth = 6)
  gc_frame_newslot(call5017);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5011;
  params[1] = call5017;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5018 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5010);
// compiled call node returning call5018 (depth = 5)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5019 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5020 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5019);
// compiled call node returning call5020 (depth = 5)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5021 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5022 == NULL) {
    strlit5022 = alloc_String("an expression containing both arithmetic and non-arithmetic operators requires parentheses.");
    gc_root(strlit5022);
  }
// compiled string node returning strlit5022 (depth = 6)
  gc_frame_newslot(strlit5022);
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5023 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5025 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5024);
// compiled call node returning call5025 (depth = 9)
// compiled member node returning call5025 (depth = 8)
  partcv[0] = 0;
  Object call5026 = callmethod(call5025, "line",
    1, partcv, params);
  gc_frame_end(callframe5023);
// compiled call node returning call5026 (depth = 7)
// compiled member node returning call5026 (depth = 6)
  gc_frame_newslot(call5026);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5027 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5029 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5028);
// compiled call node returning call5029 (depth = 9)
// compiled member node returning call5029 (depth = 8)
  partcv[0] = 0;
  Object call5030 = callmethod(call5029, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compiled call node returning call5030 (depth = 7)
// compiled member node returning call5030 (depth = 6)
  gc_frame_newslot(call5030);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit5022;
  params[1] = call5026;
  params[2] = call5030;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5031 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5021);
// compiled call node returning call5031 (depth = 5)
    gc_frame_newslot(call5031);
    if4969 = call5031;
  } else {
  }
// compiled if node returning if4969 (depth = 4)
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5033 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5034 = alloc_Block(NULL, NULL, "parser", 1581);
  gc_frame_newslot(block5034);
// method "_apply"
  block_savedest(block5034);
  Object closure5035 = createclosure(3, "_apply");
  setclosureframe(closure5035, stackframe);
  addtoclosure(closure5035, var_ops);
  addtoclosure(closure5035, var_prec);
  addtoclosure(closure5035, selfslot);
  struct UserObject *uo5035 = (struct UserObject*)block5034;
  uo5035->data[0] = (Object)closure5035;
  Method *meth_meth_parser__apply5035 = addmethod2pos(block5034, "_apply", &meth_parser__apply5035, 0);
  int argcv_meth_parser__apply5035[] = {0};
  meth_meth_parser__apply5035->type = alloc_MethodType(1, argcv_meth_parser__apply5035);
  meth_meth_parser__apply5035->definitionModule = modulename;
  meth_meth_parser__apply5035->definitionLine = 1578;
// compiled block node returning block5034 (depth = 5)
  gc_frame_newslot(block5034);
// starting to compile block node (depth = 5)
  Object block5051 = alloc_Block(NULL, NULL, "parser", 1581);
  gc_frame_newslot(block5051);
// method "_apply"
  block_savedest(block5051);
  Object closure5052 = createclosure(8, "_apply");
  setclosureframe(closure5052, stackframe);
  addtoclosure(closure5052, var_ops);
  addtoclosure(closure5052, var_o2);
  addtoclosure(closure5052, var_terms);
  addtoclosure(closure5052, var_tmp2);
  addtoclosure(closure5052, var_tmp);
  addtoclosure(closure5052, var_util);
  addtoclosure(closure5052, var_ast);
  addtoclosure(closure5052, selfslot);
  struct UserObject *uo5052 = (struct UserObject*)block5051;
  uo5052->data[0] = (Object)closure5052;
  Method *meth_meth_parser__apply5052 = addmethod2pos(block5051, "_apply", &meth_parser__apply5052, 0);
  int argcv_meth_parser__apply5052[] = {0};
  meth_meth_parser__apply5052->type = alloc_MethodType(1, argcv_meth_parser__apply5052);
  meth_meth_parser__apply5052->definitionModule = modulename;
  meth_meth_parser__apply5052->definitionLine = 1581;
// compiled block node returning block5051 (depth = 5)
  gc_frame_newslot(block5051);
// call case 5: prelude request
  params[0] = block5034;
  params[1] = block5051;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5076 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5033);
// compiled call node returning call5076 (depth = 4)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5077 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5078 = callmethod(*var_ops, "push",
    1, partcv, params);
  gc_frame_end(callframe5077);
// compiled call node returning call5078 (depth = 4)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5080 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5081 == NULL) {
    strlit5081 = alloc_String("lparen");
    gc_root(strlit5081);
  }
// compiled string node returning strlit5081 (depth = 6)
  gc_frame_newslot(strlit5081);
// call case 4: self request
  params[0] = strlit5081;
  partcv[0] = 1;
  Object call5082 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5080);
// compiled call node returning call5082 (depth = 5)
  Object if5079 = done;
  if (istrue(call5082)) {
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5083 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5084 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5083);
// compiled call node returning call5084 (depth = 6)
// compiled member node returning call5084 (depth = 5)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5086 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5087 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_recurse (depth = 9)
  gc_frame_newslot(*var_recurse);
// call case 4: self request
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call5088 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5087);
// compiled call node returning call5088 (depth = 8)
  partcv[0] = 0;
  Object call5089 = callmethod(call5088, "not",
    1, partcv, params);
  gc_frame_end(callframe5086);
// compiled call node returning call5089 (depth = 7)
// compiled member node returning call5089 (depth = 6)
  Object if5085 = done;
  if (istrue(call5089)) {
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5090 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5092 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5091);
// compiled call node returning call5092 (depth = 10)
// compiled member node returning call5092 (depth = 9)
  partcv[0] = 0;
  Object call5093 = callmethod(call5092, "new",
    1, partcv, params);
  gc_frame_end(callframe5090);
// compiled call node returning call5093 (depth = 8)
// compiled member node returning call5093 (depth = 7)
  *var_suggestion = call5093;
  if (call5093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5094 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5095 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5096 == NULL) {
    strlit5096 = alloc_String("rparen");
    gc_root(strlit5096);
  }
// compiled string node returning strlit5096 (depth = 9)
  params[0] = strlit5096;
  partcv[0] = 1;
  callmethodflags(array5095, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5095 (depth = 8)
  gc_frame_newslot(array5095);
// call case 4: self request
  params[0] = array5095;
  partcv[0] = 1;
  Object call5097 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5094);
// compiled call node returning call5097 (depth = 7)
  *var_nextTok = call5097;
  if (call5097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5099 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5099 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5101 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5101 (depth = 7)
  Object if5098 = done;
  if (istrue(opresult5101)) {
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5102 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5104 == NULL) {
    strlit5104 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5104);
  }
// compiled string node returning strlit5104 (depth = 9)
  int op_slot_right_5103 = gc_frame_newslot(strlit5104);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5106 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5108 == NULL) {
    strlit5108 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5108);
  }
// compiled string node returning strlit5108 (depth = 10)
  int op_slot_left_5106 = gc_frame_newslot(strlit5108);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5109 = callmethod(strlit5108, "++", 1, partcv, params);
// compiled op node returning opresult5109 (depth = 9)
  int op_slot_left_5103 = gc_frame_newslot(opresult5109);
  params[0] = strlit5104;
  partcv[0] = 1;
  Object opresult5110 = callmethod(opresult5109, "++", 1, partcv, params);
// compiled op node returning opresult5110 (depth = 8)
  gc_frame_newslot(opresult5110);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5110;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5111 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5102);
// compiled call node returning call5111 (depth = 7)
    gc_frame_newslot(call5111);
    if5098 = call5111;
  } else {
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5112 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5114 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5113);
// compiled call node returning call5114 (depth = 9)
// compiled member node returning call5114 (depth = 8)
  gc_frame_newslot(call5114);
// starting to compile identifier node (depth = 8)
  Object bool5115 = alloc_Boolean(1);
// compiled identifier node returning bool5115 (depth = 8)
  gc_frame_newslot(bool5115);
// starting to compile identifier node (depth = 8)
  Object bool5116 = alloc_Boolean(0);
// compiled identifier node returning bool5116 (depth = 8)
  gc_frame_newslot(bool5116);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5118 == NULL) {
    strlit5118 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5118);
  }
// compiled string node returning strlit5118 (depth = 9)
  int op_slot_right_5117 = gc_frame_newslot(strlit5118);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5120 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5122);
  }
// compiled string node returning strlit5122 (depth = 10)
  int op_slot_left_5120 = gc_frame_newslot(strlit5122);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5123 = callmethod(strlit5122, "++", 1, partcv, params);
// compiled op node returning opresult5123 (depth = 9)
  int op_slot_left_5117 = gc_frame_newslot(opresult5123);
  params[0] = strlit5118;
  partcv[0] = 1;
  Object opresult5124 = callmethod(opresult5123, "++", 1, partcv, params);
// compiled op node returning opresult5124 (depth = 8)
  gc_frame_newslot(opresult5124);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5114;
  params[2] = bool5115;
  params[3] = bool5116;
  params[4] = opresult5124;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5125 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5112);
// compiled call node returning call5125 (depth = 7)
    gc_frame_newslot(call5125);
    if5098 = call5125;
  }
// compiled if node returning if5098 (depth = 6)
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5126 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5128 == NULL) {
    strlit5128 = alloc_String(".");
    gc_root(strlit5128);
  }
// compiled string node returning strlit5128 (depth = 8)
  int op_slot_right_5127 = gc_frame_newslot(strlit5128);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5130 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5132 == NULL) {
    strlit5132 = alloc_String("parentheses must contain a valid ");
    gc_root(strlit5132);
  }
// compiled string node returning strlit5132 (depth = 9)
  int op_slot_left_5130 = gc_frame_newslot(strlit5132);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5133 = callmethod(strlit5132, "++", 1, partcv, params);
// compiled op node returning opresult5133 (depth = 8)
  int op_slot_left_5127 = gc_frame_newslot(opresult5133);
  params[0] = strlit5128;
  partcv[0] = 1;
  Object opresult5134 = callmethod(opresult5133, "++", 1, partcv, params);
// compiled op node returning opresult5134 (depth = 7)
  gc_frame_newslot(opresult5134);
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5135 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5136 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5135);
// compiled call node returning call5136 (depth = 8)
// compiled member node returning call5136 (depth = 7)
  gc_frame_newslot(call5136);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5138 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5137);
// compiled call node returning call5138 (depth = 8)
// compiled member node returning call5138 (depth = 7)
  gc_frame_newslot(call5138);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5134;
  params[1] = call5136;
  params[2] = call5138;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5139 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5126);
// compiled call node returning call5139 (depth = 6)
    gc_frame_newslot(call5139);
    if5085 = call5139;
  } else {
  }
// compiled if node returning if5085 (depth = 5)
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5142 == NULL) {
    strlit5142 = alloc_String("rparen");
    gc_root(strlit5142);
  }
// compiled string node returning strlit5142 (depth = 7)
  int op_slot_right_5141 = gc_frame_newslot(strlit5142);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5144 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5145 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5144);
// compiled call node returning call5145 (depth = 8)
// compiled member node returning call5145 (depth = 7)
  int op_slot_left_5141 = gc_frame_newslot(call5145);
  params[0] = strlit5142;
  partcv[0] = 1;
  Object opresult5146 = callmethod(call5145, "≠", 1, partcv, params);
// compiled op node returning opresult5146 (depth = 6)
  Object if5140 = done;
  if (istrue(opresult5146)) {
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5148 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5147);
// compiled call node returning call5148 (depth = 7)
// compiled member node returning call5148 (depth = 6)
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5149 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5151 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5150);
// compiled call node returning call5151 (depth = 10)
// compiled member node returning call5151 (depth = 9)
  partcv[0] = 0;
  Object call5152 = callmethod(call5151, "new",
    1, partcv, params);
  gc_frame_end(callframe5149);
// compiled call node returning call5152 (depth = 8)
// compiled member node returning call5152 (depth = 7)
  *var_suggestion = call5152;
  if (call5152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5153 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5154 == NULL) {
    strlit5154 = alloc_String(")");
    gc_root(strlit5154);
  }
// compiled string node returning strlit5154 (depth = 7)
  gc_frame_newslot(strlit5154);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5154;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5155 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5153);
// compiled call node returning call5155 (depth = 6)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5156 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5157 == NULL) {
    strlit5157 = alloc_String("an expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5157);
  }
// compiled string node returning strlit5157 (depth = 7)
  gc_frame_newslot(strlit5157);
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5159 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5158);
// compiled call node returning call5159 (depth = 8)
// compiled member node returning call5159 (depth = 7)
  gc_frame_newslot(call5159);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5162 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5161);
// compiled call node returning call5162 (depth = 9)
// compiled member node returning call5162 (depth = 8)
  int op_slot_right_5160 = gc_frame_newslot(call5162);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5165 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5164);
// compiled call node returning call5165 (depth = 9)
// compiled member node returning call5165 (depth = 8)
  int op_slot_left_5160 = gc_frame_newslot(call5165);
  params[0] = call5162;
  partcv[0] = 1;
  Object sum5166 = callmethod(call5165, "+", 1, partcv, params);
// compiled op node returning sum5166 (depth = 7)
  gc_frame_newslot(sum5166);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5157;
  params[1] = call5159;
  params[2] = sum5166;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5167 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5156);
// compiled call node returning call5167 (depth = 6)
    gc_frame_newslot(call5167);
    if5140 = call5167;
  } else {
  }
// compiled if node returning if5140 (depth = 5)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5168 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5169 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5168);
// compiled call node returning call5169 (depth = 6)
// compiled member node returning call5169 (depth = 5)
    gc_frame_newslot(call5169);
    if5079 = call5169;
  } else {
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5171 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5172 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5173 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5172);
// compiled call node returning call5173 (depth = 8)
// compiled member node returning call5173 (depth = 7)
  partcv[0] = 0;
  Object call5174 = callmethod(call5173, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5171);
// compiled call node returning call5174 (depth = 6)
  Object if5170 = done;
  if (istrue(call5174)) {
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5175 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5175 (depth = 7)
  *var_suggestions = array5175;
  if (array5175 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5176 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5178 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5177);
// compiled call node returning call5178 (depth = 10)
// compiled member node returning call5178 (depth = 9)
  partcv[0] = 0;
  Object call5179 = callmethod(call5178, "new",
    1, partcv, params);
  gc_frame_end(callframe5176);
// compiled call node returning call5179 (depth = 8)
// compiled member node returning call5179 (depth = 7)
  *var_suggestion = call5179;
  if (call5179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5180 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool5181 = alloc_Boolean(1);
// compiled identifier node returning bool5181 (depth = 7)
  gc_frame_newslot(bool5181);
// starting to compile identifier node (depth = 7)
  Object bool5182 = alloc_Boolean(0);
// compiled identifier node returning bool5182 (depth = 7)
  gc_frame_newslot(bool5182);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool5181;
  params[2] = bool5182;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5183 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5180);
// compiled call node returning call5183 (depth = 6)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5184 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5185 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5184);
// compiled call node returning call5185 (depth = 6)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5186 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5188 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5187);
// compiled call node returning call5188 (depth = 10)
// compiled member node returning call5188 (depth = 9)
  partcv[0] = 0;
  Object call5189 = callmethod(call5188, "new",
    1, partcv, params);
  gc_frame_end(callframe5186);
// compiled call node returning call5189 (depth = 8)
// compiled member node returning call5189 (depth = 7)
  *var_suggestion = call5189;
  if (call5189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5191 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5193 == NULL) {
    strlit5193 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5193);
  }
// compiled string node returning strlit5193 (depth = 8)
  int op_slot_right_5192 = gc_frame_newslot(strlit5193);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5195 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5197 == NULL) {
    strlit5197 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5197);
  }
// compiled string node returning strlit5197 (depth = 9)
  int op_slot_left_5195 = gc_frame_newslot(strlit5197);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5198 = callmethod(strlit5197, "++", 1, partcv, params);
// compiled op node returning opresult5198 (depth = 8)
  int op_slot_left_5192 = gc_frame_newslot(opresult5198);
  params[0] = strlit5193;
  partcv[0] = 1;
  Object opresult5199 = callmethod(opresult5198, "++", 1, partcv, params);
// compiled op node returning opresult5199 (depth = 7)
  gc_frame_newslot(opresult5199);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5199;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5200 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5191);
// compiled call node returning call5200 (depth = 6)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5201 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5202 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5201);
// compiled call node returning call5202 (depth = 6)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5203 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5205 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5204);
// compiled call node returning call5205 (depth = 10)
// compiled member node returning call5205 (depth = 9)
  partcv[0] = 0;
  Object call5206 = callmethod(call5205, "new",
    1, partcv, params);
  gc_frame_end(callframe5203);
// compiled call node returning call5206 (depth = 8)
// compiled member node returning call5206 (depth = 7)
  *var_suggestion = call5206;
  if (call5206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5208 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5210 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call5212 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5211);
// compiled call node returning call5212 (depth = 10)
// compiled member node returning call5212 (depth = 9)
  gc_frame_newslot(call5212);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call5214 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5213);
// compiled call node returning call5214 (depth = 10)
// compiled member node returning call5214 (depth = 9)
  params[0] = call5212;
  partcv[0] = 1;
  Object call5215 = callmethod(call5214, "at",
    1, partcv, params);
  gc_frame_end(callframe5210);
// compiled call node returning call5215 (depth = 8)
  int op_slot_right_5209 = gc_frame_newslot(call5215);
// starting to compile string node (depth = 8)
  if (strlit5217 == NULL) {
    strlit5217 = alloc_String(" ");
    gc_root(strlit5217);
  }
// compiled string node returning strlit5217 (depth = 8)
  int op_slot_left_5209 = gc_frame_newslot(strlit5217);
  params[0] = call5215;
  partcv[0] = 1;
  Object opresult5218 = callmethod(strlit5217, "++", 1, partcv, params);
// compiled op node returning opresult5218 (depth = 7)
  gc_frame_newslot(opresult5218);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5218;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5219 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5208);
// compiled call node returning call5219 (depth = 6)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5220 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5222 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5221);
// compiled call node returning call5222 (depth = 8)
// compiled member node returning call5222 (depth = 7)
  gc_frame_newslot(call5222);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call5222;
  partcv[0] = 1;
  Object call5223 = callmethod(*var_suggestion, "deleteLine",
    1, partcv, params);
  gc_frame_end(callframe5220);
// compiled call node returning call5223 (depth = 6)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5224 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5225 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5224);
// compiled call node returning call5225 (depth = 6)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5226 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5228 == NULL) {
    strlit5228 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5228);
  }
// compiled string node returning strlit5228 (depth = 8)
  int op_slot_right_5227 = gc_frame_newslot(strlit5228);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5232 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5231);
// compiled call node returning call5232 (depth = 10)
// compiled member node returning call5232 (depth = 9)
  int op_slot_right_5230 = gc_frame_newslot(call5232);
// starting to compile string node (depth = 9)
  if (strlit5234 == NULL) {
    strlit5234 = alloc_String("a valid expression must follow '");
    gc_root(strlit5234);
  }
// compiled string node returning strlit5234 (depth = 9)
  int op_slot_left_5230 = gc_frame_newslot(strlit5234);
  params[0] = call5232;
  partcv[0] = 1;
  Object opresult5235 = callmethod(strlit5234, "++", 1, partcv, params);
// compiled op node returning opresult5235 (depth = 8)
  int op_slot_left_5227 = gc_frame_newslot(opresult5235);
  params[0] = strlit5228;
  partcv[0] = 1;
  Object opresult5236 = callmethod(opresult5235, "++", 1, partcv, params);
// compiled op node returning opresult5236 (depth = 7)
  gc_frame_newslot(opresult5236);
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5238 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5237);
// compiled call node returning call5238 (depth = 8)
// compiled member node returning call5238 (depth = 7)
  gc_frame_newslot(call5238);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5241 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5240);
// compiled call node returning call5241 (depth = 9)
// compiled member node returning call5241 (depth = 8)
  int op_slot_right_5239 = gc_frame_newslot(call5241);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5244 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5243);
// compiled call node returning call5244 (depth = 9)
// compiled member node returning call5244 (depth = 8)
  int op_slot_left_5239 = gc_frame_newslot(call5244);
  params[0] = call5241;
  partcv[0] = 1;
  Object sum5245 = callmethod(call5244, "+", 1, partcv, params);
// compiled op node returning sum5245 (depth = 7)
  gc_frame_newslot(sum5245);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5236;
  params[1] = call5238;
  params[2] = sum5245;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5246 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5226);
// compiled call node returning call5246 (depth = 6)
    gc_frame_newslot(call5246);
    if5170 = call5246;
  } else {
  }
// compiled if node returning if5170 (depth = 5)
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5248 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5249 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5250 = alloc_Block(NULL, NULL, "parser", 1638);
  gc_frame_newslot(block5250);
// method "_apply"
  block_savedest(block5250);
  Object closure5251 = createclosure(1, "_apply");
  setclosureframe(closure5251, stackframe);
  addtoclosure(closure5251, selfslot);
  struct UserObject *uo5251 = (struct UserObject*)block5250;
  uo5251->data[0] = (Object)closure5251;
  Method *meth_meth_parser__apply5251 = addmethod2pos(block5250, "_apply", &meth_parser__apply5251, 0);
  int argcv_meth_parser__apply5251[] = {0};
  meth_meth_parser__apply5251->type = alloc_MethodType(1, argcv_meth_parser__apply5251);
  meth_meth_parser__apply5251->definitionModule = modulename;
  meth_meth_parser__apply5251->definitionLine = 1638;
// compiled block node returning block5250 (depth = 9)
  gc_frame_newslot(block5250);
// call case 4: self request
  params[0] = block5250;
  partcv[0] = 1;
  Object call5255 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5249);
// compiled call node returning call5255 (depth = 8)
  partcv[0] = 0;
  Object call5256 = callmethod(call5255, "not",
    1, partcv, params);
  gc_frame_end(callframe5248);
// compiled call node returning call5256 (depth = 7)
// compiled member node returning call5256 (depth = 6)
  Object if5247 = done;
  if (istrue(call5256)) {
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5257 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5257 (depth = 7)
  *var_suggestions = array5257;
  if (array5257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5258 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5260 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5259);
// compiled call node returning call5260 (depth = 10)
// compiled member node returning call5260 (depth = 9)
  partcv[0] = 0;
  Object call5261 = callmethod(call5260, "new",
    1, partcv, params);
  gc_frame_end(callframe5258);
// compiled call node returning call5261 (depth = 8)
// compiled member node returning call5261 (depth = 7)
  *var_suggestion = call5261;
  if (call5261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5262 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5263 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5264 == NULL) {
    strlit5264 = alloc_String("comma");
    gc_root(strlit5264);
  }
// compiled string node returning strlit5264 (depth = 9)
  params[0] = strlit5264;
  partcv[0] = 1;
  callmethodflags(array5263, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5265 == NULL) {
    strlit5265 = alloc_String("rparen");
    gc_root(strlit5265);
  }
// compiled string node returning strlit5265 (depth = 9)
  params[0] = strlit5265;
  partcv[0] = 1;
  callmethodflags(array5263, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5266 == NULL) {
    strlit5266 = alloc_String("rsquare");
    gc_root(strlit5266);
  }
// compiled string node returning strlit5266 (depth = 9)
  params[0] = strlit5266;
  partcv[0] = 1;
  callmethodflags(array5263, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile string node (depth = 9)
  if (strlit5267 == NULL) {
    strlit5267 = alloc_String("rbrace");
    gc_root(strlit5267);
  }
// compiled string node returning strlit5267 (depth = 9)
  params[0] = strlit5267;
  partcv[0] = 1;
  callmethodflags(array5263, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5263 (depth = 8)
  gc_frame_newslot(array5263);
// call case 4: self request
  params[0] = array5263;
  partcv[0] = 1;
  Object call5268 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5262);
// compiled call node returning call5268 (depth = 7)
  *var_nextTok = call5268;
  if (call5268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5270 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5270 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5272 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5272 (depth = 7)
  Object if5269 = done;
  if (istrue(opresult5272)) {
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5273 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5275 == NULL) {
    strlit5275 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5275);
  }
// compiled string node returning strlit5275 (depth = 9)
  int op_slot_right_5274 = gc_frame_newslot(strlit5275);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5277 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5279 == NULL) {
    strlit5279 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5279);
  }
// compiled string node returning strlit5279 (depth = 10)
  int op_slot_left_5277 = gc_frame_newslot(strlit5279);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5280 = callmethod(strlit5279, "++", 1, partcv, params);
// compiled op node returning opresult5280 (depth = 9)
  int op_slot_left_5274 = gc_frame_newslot(opresult5280);
  params[0] = strlit5275;
  partcv[0] = 1;
  Object opresult5281 = callmethod(opresult5280, "++", 1, partcv, params);
// compiled op node returning opresult5281 (depth = 8)
  gc_frame_newslot(opresult5281);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5281;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5282 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5273);
// compiled call node returning call5282 (depth = 7)
    gc_frame_newslot(call5282);
    if5269 = call5282;
  } else {
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5283 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5284 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5285 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5284);
// compiled call node returning call5285 (depth = 9)
// compiled member node returning call5285 (depth = 8)
  gc_frame_newslot(call5285);
// starting to compile identifier node (depth = 8)
  Object bool5286 = alloc_Boolean(1);
// compiled identifier node returning bool5286 (depth = 8)
  gc_frame_newslot(bool5286);
// starting to compile identifier node (depth = 8)
  Object bool5287 = alloc_Boolean(0);
// compiled identifier node returning bool5287 (depth = 8)
  gc_frame_newslot(bool5287);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5289 == NULL) {
    strlit5289 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5289);
  }
// compiled string node returning strlit5289 (depth = 9)
  int op_slot_right_5288 = gc_frame_newslot(strlit5289);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5291 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5293 == NULL) {
    strlit5293 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5293);
  }
// compiled string node returning strlit5293 (depth = 10)
  int op_slot_left_5291 = gc_frame_newslot(strlit5293);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5294 = callmethod(strlit5293, "++", 1, partcv, params);
// compiled op node returning opresult5294 (depth = 9)
  int op_slot_left_5288 = gc_frame_newslot(opresult5294);
  params[0] = strlit5289;
  partcv[0] = 1;
  Object opresult5295 = callmethod(opresult5294, "++", 1, partcv, params);
// compiled op node returning opresult5295 (depth = 8)
  gc_frame_newslot(opresult5295);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5285;
  params[2] = bool5286;
  params[3] = bool5287;
  params[4] = opresult5295;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5296 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5283);
// compiled call node returning call5296 (depth = 7)
    gc_frame_newslot(call5296);
    if5269 = call5296;
  }
// compiled if node returning if5269 (depth = 6)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5297 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5298 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5297);
// compiled call node returning call5298 (depth = 6)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5299 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5301 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5300);
// compiled call node returning call5301 (depth = 10)
// compiled member node returning call5301 (depth = 9)
  partcv[0] = 0;
  Object call5302 = callmethod(call5301, "new",
    1, partcv, params);
  gc_frame_end(callframe5299);
// compiled call node returning call5302 (depth = 8)
// compiled member node returning call5302 (depth = 7)
  *var_suggestion = call5302;
  if (call5302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5304 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5306 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5305);
// compiled call node returning call5306 (depth = 8)
// compiled member node returning call5306 (depth = 7)
  gc_frame_newslot(call5306);
// starting to compile identifier node (depth = 7)
  Object bool5307 = alloc_Boolean(1);
// compiled identifier node returning bool5307 (depth = 7)
  gc_frame_newslot(bool5307);
// starting to compile identifier node (depth = 7)
  Object bool5308 = alloc_Boolean(0);
// compiled identifier node returning bool5308 (depth = 7)
  gc_frame_newslot(bool5308);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5306;
  params[2] = bool5307;
  params[3] = bool5308;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5309 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5304);
// compiled call node returning call5309 (depth = 6)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5310 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5311 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5310);
// compiled call node returning call5311 (depth = 6)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5312 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5314 == NULL) {
    strlit5314 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5314);
  }
// compiled string node returning strlit5314 (depth = 8)
  int op_slot_right_5313 = gc_frame_newslot(strlit5314);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5318 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5317);
// compiled call node returning call5318 (depth = 10)
// compiled member node returning call5318 (depth = 9)
  int op_slot_right_5316 = gc_frame_newslot(call5318);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5321 == NULL) {
    strlit5321 = alloc_String(" must follow '");
    gc_root(strlit5321);
  }
// compiled string node returning strlit5321 (depth = 10)
  int op_slot_right_5320 = gc_frame_newslot(strlit5321);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_5323 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit5325 == NULL) {
    strlit5325 = alloc_String("a valid ");
    gc_root(strlit5325);
  }
// compiled string node returning strlit5325 (depth = 11)
  int op_slot_left_5323 = gc_frame_newslot(strlit5325);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5326 = callmethod(strlit5325, "++", 1, partcv, params);
// compiled op node returning opresult5326 (depth = 10)
  int op_slot_left_5320 = gc_frame_newslot(opresult5326);
  params[0] = strlit5321;
  partcv[0] = 1;
  Object opresult5327 = callmethod(opresult5326, "++", 1, partcv, params);
// compiled op node returning opresult5327 (depth = 9)
  int op_slot_left_5316 = gc_frame_newslot(opresult5327);
  params[0] = call5318;
  partcv[0] = 1;
  Object opresult5328 = callmethod(opresult5327, "++", 1, partcv, params);
// compiled op node returning opresult5328 (depth = 8)
  int op_slot_left_5313 = gc_frame_newslot(opresult5328);
  params[0] = strlit5314;
  partcv[0] = 1;
  Object opresult5329 = callmethod(opresult5328, "++", 1, partcv, params);
// compiled op node returning opresult5329 (depth = 7)
  gc_frame_newslot(opresult5329);
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5331 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5330);
// compiled call node returning call5331 (depth = 8)
// compiled member node returning call5331 (depth = 7)
  gc_frame_newslot(call5331);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5334 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5333);
// compiled call node returning call5334 (depth = 9)
// compiled member node returning call5334 (depth = 8)
  int op_slot_right_5332 = gc_frame_newslot(call5334);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5337 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5336);
// compiled call node returning call5337 (depth = 9)
// compiled member node returning call5337 (depth = 8)
  int op_slot_left_5332 = gc_frame_newslot(call5337);
  params[0] = call5334;
  partcv[0] = 1;
  Object sum5338 = callmethod(call5337, "+", 1, partcv, params);
// compiled op node returning sum5338 (depth = 7)
  gc_frame_newslot(sum5338);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5329;
  params[1] = call5331;
  params[2] = sum5338;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5339 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5312);
// compiled call node returning call5339 (depth = 6)
    gc_frame_newslot(call5339);
    if5247 = call5339;
  } else {
  }
// compiled if node returning if5247 (depth = 5)
    gc_frame_newslot(if5247);
    if5079 = if5247;
  }
// compiled if node returning if5079 (depth = 4)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5340 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5341 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5340);
// compiled call node returning call5341 (depth = 4)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5342 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5343 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5342);
// compiled call node returning call5343 (depth = 4)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5345 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5344);
// compiled call node returning call5345 (depth = 5)
// compiled member node returning call5345 (depth = 4)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5347 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5346);
// compiled call node returning call5347 (depth = 6)
// compiled member node returning call5347 (depth = 5)
  *var_tmp = call5347;
  if (call5347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5349 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5350 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5349);
// compiled call node returning call5350 (depth = 4)
  gc_frame_end(frame);
  return call5350;
}
Object meth_parser__apply5355(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5357 = alloc_Float64(0);
// compiled num node returning num5357 (depth = 5)
  int op_slot_right_5356 = gc_frame_newslot(num5357);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5359 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5360 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5359);
// compiled call node returning call5360 (depth = 6)
// compiled member node returning call5360 (depth = 5)
  int op_slot_left_5356 = gc_frame_newslot(call5360);
  params[0] = num5357;
  partcv[0] = 1;
  Object opresult5361 = callmethod(call5360, ">", 1, partcv, params);
// compiled op node returning opresult5361 (depth = 4)
  gc_frame_end(frame);
  return opresult5361;
}
Object meth_parser__apply5364(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5365 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5366 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5365);
// compiled call node returning call5366 (depth = 6)
// compiled member node returning call5366 (depth = 5)
  *var_o = call5366;
  if (call5366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5369 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5368);
// compiled call node returning call5369 (depth = 6)
// compiled member node returning call5369 (depth = 5)
  *var_tmp2 = call5369;
  if (call5369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5372 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5371);
// compiled call node returning call5372 (depth = 6)
// compiled member node returning call5372 (depth = 5)
  *var_tmp = call5372;
  if (call5372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5374 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5376 = callmethod(*var_tmp, "line",
    1, partcv, params);
  gc_frame_end(callframe5375);
// compiled call node returning call5376 (depth = 6)
// compiled member node returning call5376 (depth = 5)
  gc_frame_newslot(call5376);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5377 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  partcv[0] = 0;
  Object call5378 = callmethod(*var_tmp, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5377);
// compiled call node returning call5378 (depth = 6)
// compiled member node returning call5378 (depth = 5)
  gc_frame_newslot(call5378);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5376;
  params[1] = call5378;
  partcv[0] = 2;
  Object call5379 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5374);
// compiled call node returning call5379 (depth = 4)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5380 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5382 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5381);
// compiled call node returning call5382 (depth = 7)
// compiled member node returning call5382 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5383 = callmethod(call5382, "new",
    1, partcv, params);
  gc_frame_end(callframe5380);
// compiled call node returning call5383 (depth = 5)
  *var_tmp = call5383;
  if (call5383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5385 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5386 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5385);
// compiled call node returning call5386 (depth = 4)
  gc_frame_end(frame);
  return call5386;
}
Object meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest()recursingWith()blocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expressionrest()recursingWith()blocks");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for expressionrest()recursingWith()blocks (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for expressionrest");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for recursingWith");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for blocks");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "terms");
  Object *var_ops = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ops");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_o2 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o2");
  Object *var_tmp2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tmp2");
  Object *var_tmp = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp");
  Object *var_prec = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prec");
  Object *var_allarith = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "allarith");
  Object *var_opcount = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "opcount");
  Object *var_opdtype = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opdtype");
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4898 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4898 (depth = 3)
  *var_terms = array4898;
  if (array4898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array4899 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4899 (depth = 3)
  *var_ops = array4899;
  if (array4899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4901 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4900);
// compiled call node returning call4901 (depth = 4)
// compiled member node returning call4901 (depth = 3)
  *var_tmp = call4901;
  if (call4901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4902 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call4903 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe4902);
// compiled call node returning call4903 (depth = 2)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4904 = alloc_Boolean(1);
// compiled identifier node returning bool4904 (depth = 3)
  *var_allarith = bool4904;
  if (bool4904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4905 = alloc_Float64(0);
// compiled num node returning num4905 (depth = 3)
  *var_opcount = num4905;
  if (num4905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4906 == NULL) {
    strlit4906 = alloc_String("");
    gc_root(strlit4906);
  }
// compiled string node returning strlit4906 (depth = 3)
  *var_opdtype = strlit4906;
  if (strlit4906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4907 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4908 = alloc_Block(NULL, NULL, "parser", 1555);
  gc_frame_newslot(block4908);
// method "_apply"
  block_savedest(block4908);
  Object closure4909 = createclosure(3, "_apply");
  setclosureframe(closure4909, stackframe);
  addtoclosure(closure4909, var_sym);
  addtoclosure(closure4909, var_statementToken);
  addtoclosure(closure4909, selfslot);
  struct UserObject *uo4909 = (struct UserObject*)block4908;
  uo4909->data[0] = (Object)closure4909;
  Method *meth_meth_parser__apply4909 = addmethod2pos(block4908, "_apply", &meth_parser__apply4909, 0);
  int argcv_meth_parser__apply4909[] = {0};
  meth_meth_parser__apply4909->type = alloc_MethodType(1, argcv_meth_parser__apply4909);
  meth_meth_parser__apply4909->definitionModule = modulename;
  meth_meth_parser__apply4909->definitionLine = 1549;
// compiled block node returning block4908 (depth = 3)
  gc_frame_newslot(block4908);
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4926 = alloc_Block(NULL, NULL, "parser", 1556);
  gc_frame_newslot(block4926);
// method "_apply"
  block_savedest(block4926);
  Object closure4927 = createclosure(20, "_apply");
  setclosureframe(closure4927, stackframe);
  addtoclosure(closure4927, var_opcount);
  addtoclosure(closure4927, var_sym);
  addtoclosure(closure4927, var_o);
  addtoclosure(closure4927, var_prec);
  addtoclosure(closure4927, var_allarith);
  addtoclosure(closure4927, var_opdtype);
  addtoclosure(closure4927, var_errormessages);
  addtoclosure(closure4927, var_lastToken);
  addtoclosure(closure4927, var_ops);
  addtoclosure(closure4927, var_o2);
  addtoclosure(closure4927, var_terms);
  addtoclosure(closure4927, var_tmp2);
  addtoclosure(closure4927, var_tmp);
  addtoclosure(closure4927, var_util);
  addtoclosure(closure4927, var_ast);
  addtoclosure(closure4927, var_recurse);
  addtoclosure(closure4927, var_name);
  addtoclosure(closure4927, var_acceptBlocks);
  addtoclosure(closure4927, var_values);
  addtoclosure(closure4927, selfslot);
  struct UserObject *uo4927 = (struct UserObject*)block4926;
  uo4927->data[0] = (Object)closure4927;
  Method *meth_meth_parser__apply4927 = addmethod2pos(block4926, "_apply", &meth_parser__apply4927, 0);
  int argcv_meth_parser__apply4927[] = {0};
  meth_meth_parser__apply4927->type = alloc_MethodType(1, argcv_meth_parser__apply4927);
  meth_meth_parser__apply4927->definitionModule = modulename;
  meth_meth_parser__apply4927->definitionLine = 1556;
// compiled block node returning block4926 (depth = 3)
  gc_frame_newslot(block4926);
// call case 5: prelude request
  params[0] = block4908;
  params[1] = block4926;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5352 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4907);
// compiled call node returning call5352 (depth = 2)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5353 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5354 = alloc_Block(NULL, NULL, "parser", 1666);
  gc_frame_newslot(block5354);
// method "_apply"
  block_savedest(block5354);
  Object closure5355 = createclosure(2, "_apply");
  setclosureframe(closure5355, stackframe);
  addtoclosure(closure5355, var_ops);
  addtoclosure(closure5355, selfslot);
  struct UserObject *uo5355 = (struct UserObject*)block5354;
  uo5355->data[0] = (Object)closure5355;
  Method *meth_meth_parser__apply5355 = addmethod2pos(block5354, "_apply", &meth_parser__apply5355, 0);
  int argcv_meth_parser__apply5355[] = {0};
  meth_meth_parser__apply5355->type = alloc_MethodType(1, argcv_meth_parser__apply5355);
  meth_meth_parser__apply5355->definitionModule = modulename;
  meth_meth_parser__apply5355->definitionLine = 1663;
// compiled block node returning block5354 (depth = 3)
  gc_frame_newslot(block5354);
// starting to compile block node (depth = 3)
  Object block5363 = alloc_Block(NULL, NULL, "parser", 1666);
  gc_frame_newslot(block5363);
// method "_apply"
  block_savedest(block5363);
  Object closure5364 = createclosure(8, "_apply");
  setclosureframe(closure5364, stackframe);
  addtoclosure(closure5364, var_ops);
  addtoclosure(closure5364, var_o);
  addtoclosure(closure5364, var_terms);
  addtoclosure(closure5364, var_tmp2);
  addtoclosure(closure5364, var_tmp);
  addtoclosure(closure5364, var_util);
  addtoclosure(closure5364, var_ast);
  addtoclosure(closure5364, selfslot);
  struct UserObject *uo5364 = (struct UserObject*)block5363;
  uo5364->data[0] = (Object)closure5364;
  Method *meth_meth_parser__apply5364 = addmethod2pos(block5363, "_apply", &meth_parser__apply5364, 0);
  int argcv_meth_parser__apply5364[] = {0};
  meth_meth_parser__apply5364->type = alloc_MethodType(1, argcv_meth_parser__apply5364);
  meth_meth_parser__apply5364->definitionModule = modulename;
  meth_meth_parser__apply5364->definitionLine = 1666;
// compiled block node returning block5363 (depth = 3)
  gc_frame_newslot(block5363);
// call case 5: prelude request
  params[0] = block5354;
  params[1] = block5363;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5388 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5353);
// compiled call node returning call5388 (depth = 2)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  partcv[0] = 0;
  Object call5390 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5389);
// compiled call node returning call5390 (depth = 4)
// compiled member node returning call5390 (depth = 3)
  *var_tmp = call5390;
  if (call5390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5392 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5393 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5392);
// compiled call node returning call5393 (depth = 2)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5396 = alloc_Float64(0);
// compiled num node returning num5396 (depth = 4)
  int op_slot_right_5395 = gc_frame_newslot(num5396);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5398 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5399 = callmethod(*var_terms, "size",
    1, partcv, params);
  gc_frame_end(callframe5398);
// compiled call node returning call5399 (depth = 5)
// compiled member node returning call5399 (depth = 4)
  int op_slot_left_5395 = gc_frame_newslot(call5399);
  params[0] = num5396;
  partcv[0] = 1;
  Object opresult5400 = callmethod(call5399, ">", 1, partcv, params);
// compiled op node returning opresult5400 (depth = 3)
  Object if5394 = done;
  if (istrue(opresult5400)) {
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5401 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5402 == NULL) {
    strlit5402 = alloc_String("values left on term stack.");
    gc_root(strlit5402);
  }
// compiled string node returning strlit5402 (depth = 4)
  gc_frame_newslot(strlit5402);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5403 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5404 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5403);
// compiled call node returning call5404 (depth = 5)
// compiled member node returning call5404 (depth = 4)
  gc_frame_newslot(call5404);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5406 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5405);
// compiled call node returning call5406 (depth = 5)
// compiled member node returning call5406 (depth = 4)
  gc_frame_newslot(call5406);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5402;
  params[1] = call5404;
  params[2] = call5406;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5407 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe5401);
// compiled call node returning call5407 (depth = 3)
    gc_frame_newslot(call5407);
    if5394 = call5407;
  } else {
  }
// compiled if node returning if5394 (depth = 2)
  gc_frame_end(frame);
  return if5394;
}
Object meth_parser_dotrest5408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method dotrest");
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for dotrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lookuptarget");
  Object *var_dro = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dro");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5410 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5411 == NULL) {
    strlit5411 = alloc_String("dot");
    gc_root(strlit5411);
  }
// compiled string node returning strlit5411 (depth = 4)
  gc_frame_newslot(strlit5411);
// call case 4: self request
  params[0] = strlit5411;
  partcv[0] = 1;
  Object call5412 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5410);
// compiled call node returning call5412 (depth = 3)
  Object if5409 = done;
  if (istrue(call5412)) {
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5413 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5415 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5414);
// compiled call node returning call5415 (depth = 5)
// compiled member node returning call5415 (depth = 4)
  gc_frame_newslot(call5415);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5417 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5416);
// compiled call node returning call5417 (depth = 5)
// compiled member node returning call5417 (depth = 4)
  gc_frame_newslot(call5417);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5415;
  params[1] = call5417;
  partcv[0] = 2;
  Object call5418 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5413);
// compiled call node returning call5418 (depth = 3)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5420 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5419);
// compiled call node returning call5420 (depth = 5)
// compiled member node returning call5420 (depth = 4)
  *var_lookuptarget = call5420;
  if (call5420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5422 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5421);
// compiled call node returning call5422 (depth = 4)
// compiled member node returning call5422 (depth = 3)
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5424 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5425 == NULL) {
    strlit5425 = alloc_String("identifier");
    gc_root(strlit5425);
  }
// compiled string node returning strlit5425 (depth = 5)
  gc_frame_newslot(strlit5425);
// call case 4: self request
  params[0] = strlit5425;
  partcv[0] = 1;
  Object call5426 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5424);
// compiled call node returning call5426 (depth = 4)
  Object if5423 = done;
  if (istrue(call5426)) {
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5427 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5429 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5428);
// compiled call node returning call5429 (depth = 6)
// compiled member node returning call5429 (depth = 5)
  gc_frame_newslot(call5429);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5431 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5430);
// compiled call node returning call5431 (depth = 6)
// compiled member node returning call5431 (depth = 5)
  gc_frame_newslot(call5431);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5429;
  params[1] = call5431;
  partcv[0] = 2;
  Object call5432 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5427);
// compiled call node returning call5432 (depth = 4)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5433 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5435 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5434);
// compiled call node returning call5435 (depth = 7)
// compiled member node returning call5435 (depth = 6)
  gc_frame_newslot(call5435);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5437 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5436);
// compiled call node returning call5437 (depth = 7)
// compiled member node returning call5437 (depth = 6)
  params[0] = call5435;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5438 = callmethod(call5437, "new",
    1, partcv, params);
  gc_frame_end(callframe5433);
// compiled call node returning call5438 (depth = 5)
  *var_dro = call5438;
  if (call5438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5439 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5440 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5439);
// compiled call node returning call5440 (depth = 4)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5441 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5442 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5441);
// compiled call node returning call5442 (depth = 5)
// compiled member node returning call5442 (depth = 4)
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5444 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5445 == NULL) {
    strlit5445 = alloc_String("dot");
    gc_root(strlit5445);
  }
// compiled string node returning strlit5445 (depth = 6)
  gc_frame_newslot(strlit5445);
// call case 4: self request
  params[0] = strlit5445;
  partcv[0] = 1;
  Object call5446 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5444);
// compiled call node returning call5446 (depth = 5)
  Object if5443 = done;
  if (istrue(call5446)) {
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5447 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5448 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5447);
// compiled call node returning call5448 (depth = 5)
    gc_frame_newslot(call5448);
    if5443 = call5448;
  } else {
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5451 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5452 == NULL) {
    strlit5452 = alloc_String("lgeneric");
    gc_root(strlit5452);
  }
// compiled string node returning strlit5452 (depth = 8)
  gc_frame_newslot(strlit5452);
// call case 4: self request
  params[0] = strlit5452;
  partcv[0] = 1;
  Object call5453 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5451);
// compiled call node returning call5453 (depth = 7)
  int op_slot_right_5450 = gc_frame_newslot(call5453);
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5456 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5457 == NULL) {
    strlit5457 = alloc_String("lsquare");
    gc_root(strlit5457);
  }
// compiled string node returning strlit5457 (depth = 9)
  gc_frame_newslot(strlit5457);
// call case 4: self request
  params[0] = strlit5457;
  partcv[0] = 1;
  Object call5458 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5456);
// compiled call node returning call5458 (depth = 8)
  int op_slot_right_5455 = gc_frame_newslot(call5458);
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5461 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5462 == NULL) {
    strlit5462 = alloc_String("string");
    gc_root(strlit5462);
  }
// compiled string node returning strlit5462 (depth = 10)
  gc_frame_newslot(strlit5462);
// call case 4: self request
  params[0] = strlit5462;
  partcv[0] = 1;
  Object call5463 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5461);
// compiled call node returning call5463 (depth = 9)
  int op_slot_right_5460 = gc_frame_newslot(call5463);
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe5466 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5467 == NULL) {
    strlit5467 = alloc_String("num");
    gc_root(strlit5467);
  }
// compiled string node returning strlit5467 (depth = 11)
  gc_frame_newslot(strlit5467);
// call case 4: self request
  params[0] = strlit5467;
  partcv[0] = 1;
  Object call5468 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5466);
// compiled call node returning call5468 (depth = 10)
  int op_slot_right_5465 = gc_frame_newslot(call5468);
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5472 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5473 == NULL) {
    strlit5473 = alloc_String("lbrace");
    gc_root(strlit5473);
  }
// compiled string node returning strlit5473 (depth = 13)
  gc_frame_newslot(strlit5473);
// call case 4: self request
  params[0] = strlit5473;
  partcv[0] = 1;
  Object call5474 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5472);
// compiled call node returning call5474 (depth = 12)
  int op_slot_right_5471 = gc_frame_newslot(call5474);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_acceptBlocks (depth = 12)
  int op_slot_left_5471 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5474;
  partcv[0] = 1;
  Object opresult5476 = callmethod(*var_acceptBlocks, "&&", 1, partcv, params);
// compiled op node returning opresult5476 (depth = 11)
  int op_slot_right_5470 = gc_frame_newslot(opresult5476);
// starting to compile call node (depth = 11)
  int callframe5478 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5479 == NULL) {
    strlit5479 = alloc_String("lparen");
    gc_root(strlit5479);
  }
// compiled string node returning strlit5479 (depth = 12)
  gc_frame_newslot(strlit5479);
// call case 4: self request
  params[0] = strlit5479;
  partcv[0] = 1;
  Object call5480 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5478);
// compiled call node returning call5480 (depth = 11)
  int op_slot_left_5470 = gc_frame_newslot(call5480);
  params[0] = opresult5476;
  partcv[0] = 1;
  Object opresult5481 = callmethod(call5480, "||", 1, partcv, params);
// compiled op node returning opresult5481 (depth = 10)
  int op_slot_left_5465 = gc_frame_newslot(opresult5481);
  params[0] = call5468;
  partcv[0] = 1;
  Object opresult5482 = callmethod(opresult5481, "||", 1, partcv, params);
// compiled op node returning opresult5482 (depth = 9)
  int op_slot_left_5460 = gc_frame_newslot(opresult5482);
  params[0] = call5463;
  partcv[0] = 1;
  Object opresult5483 = callmethod(opresult5482, "||", 1, partcv, params);
// compiled op node returning opresult5483 (depth = 8)
  int op_slot_left_5455 = gc_frame_newslot(opresult5483);
  params[0] = call5458;
  partcv[0] = 1;
  Object opresult5484 = callmethod(opresult5483, "||", 1, partcv, params);
// compiled op node returning opresult5484 (depth = 7)
  int op_slot_left_5450 = gc_frame_newslot(opresult5484);
  params[0] = call5453;
  partcv[0] = 1;
  Object opresult5485 = callmethod(opresult5484, "||", 1, partcv, params);
// compiled op node returning opresult5485 (depth = 6)
  Object if5449 = done;
  if (istrue(opresult5485)) {
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5486 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5487 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5486);
// compiled call node returning call5487 (depth = 6)
    gc_frame_newslot(call5487);
    if5449 = call5487;
  } else {
  }
// compiled if node returning if5449 (depth = 5)
    gc_frame_newslot(if5449);
    if5443 = if5449;
  }
// compiled if node returning if5443 (depth = 4)
    gc_frame_newslot(if5443);
    if5423 = if5443;
  } else {
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array5488 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5488 (depth = 5)
  *var_suggestions = array5488;
  if (array5488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5489 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5490 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5491 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5490);
// compiled call node returning call5491 (depth = 8)
// compiled member node returning call5491 (depth = 7)
  partcv[0] = 0;
  Object call5492 = callmethod(call5491, "new",
    1, partcv, params);
  gc_frame_end(callframe5489);
// compiled call node returning call5492 (depth = 6)
// compiled member node returning call5492 (depth = 5)
  *var_suggestion = call5492;
  if (call5492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5493 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5494 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5493);
// compiled call node returning call5494 (depth = 4)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5495 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5496 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5495);
// compiled call node returning call5496 (depth = 4)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5497 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5499 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5498);
// compiled call node returning call5499 (depth = 8)
// compiled member node returning call5499 (depth = 7)
  partcv[0] = 0;
  Object call5500 = callmethod(call5499, "new",
    1, partcv, params);
  gc_frame_end(callframe5497);
// compiled call node returning call5500 (depth = 6)
// compiled member node returning call5500 (depth = 5)
  *var_suggestion = call5500;
  if (call5500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5502 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5503 == NULL) {
    strlit5503 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5503);
  }
// compiled string node returning strlit5503 (depth = 5)
  gc_frame_newslot(strlit5503);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5503;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5504 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5502);
// compiled call node returning call5504 (depth = 4)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5505 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5506 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5505);
// compiled call node returning call5506 (depth = 4)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5507 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5508 == NULL) {
    strlit5508 = alloc_String("a field or method name must follow a '.'.");
    gc_root(strlit5508);
  }
// compiled string node returning strlit5508 (depth = 5)
  gc_frame_newslot(strlit5508);
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5510 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5509);
// compiled call node returning call5510 (depth = 6)
// compiled member node returning call5510 (depth = 5)
  gc_frame_newslot(call5510);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5512 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 6)
// compiled member node returning call5512 (depth = 5)
  gc_frame_newslot(call5512);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5508;
  params[1] = call5510;
  params[2] = call5512;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5513 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5507);
// compiled call node returning call5513 (depth = 4)
    gc_frame_newslot(call5513);
    if5423 = call5513;
  }
// compiled if node returning if5423 (depth = 3)
    gc_frame_newslot(if5423);
    if5409 = if5423;
  } else {
  }
// compiled if node returning if5409 (depth = 2)
  gc_frame_end(frame);
  return if5409;
}
Object meth_parser__apply5592(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5593 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5594 == NULL) {
    strlit5594 = alloc_String("lbrace");
    gc_root(strlit5594);
  }
// compiled string node returning strlit5594 (depth = 7)
  gc_frame_newslot(strlit5594);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5594;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5595 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5593);
// compiled call node returning call5595 (depth = 6)
  gc_frame_end(frame);
  return call5595;
}
Object meth_parser__apply5639(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5641 == NULL) {
    strlit5641 = alloc_String("member");
    gc_root(strlit5641);
  }
// compiled string node returning strlit5641 (depth = 10)
  int op_slot_right_5640 = gc_frame_newslot(strlit5641);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call5644 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe5643);
// compiled call node returning call5644 (depth = 11)
// compiled member node returning call5644 (depth = 10)
  int op_slot_left_5640 = gc_frame_newslot(call5644);
  params[0] = strlit5641;
  partcv[0] = 1;
  Object opresult5645 = callmethod(call5644, "==", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 9)
  gc_frame_end(frame);
  return opresult5645;
}
Object meth_parser__apply5648(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 9)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  *var_outroot = *var_root;
  if (*var_root == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call5651 = callmethod(*var_root, "in",
    1, partcv, params);
  gc_frame_end(callframe5650);
// compiled call node returning call5651 (depth = 11)
// compiled member node returning call5651 (depth = 10)
  *var_root = call5651;
  if (call5651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest5514(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method callrest");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for callrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_btok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "btok");
  Object *var_signature = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "signature");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_hadcall = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "hadcall");
  Object *var_tok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tok");
  Object *var_startInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "startInd");
  Object *var_genericIdents = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "genericIdents");
  Object *var_ar = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ar");
  Object *var_root = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "root");
  Object *var_outroot = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "meth'");
  Object *var_call = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "call");
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5517 = alloc_Float64(0);
// compiled num node returning num5517 (depth = 4)
  int op_slot_right_5516 = gc_frame_newslot(num5517);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5520 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5519);
// compiled call node returning call5520 (depth = 5)
// compiled member node returning call5520 (depth = 4)
  int op_slot_left_5516 = gc_frame_newslot(call5520);
  params[0] = num5517;
  partcv[0] = 1;
  Object opresult5521 = callmethod(call5520, "==", 1, partcv, params);
// compiled op node returning opresult5521 (depth = 3)
  Object if5515 = done;
  if (istrue(opresult5521)) {
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5522 = alloc_Float64(0);
// compiled num node returning num5522 (depth = 4)
  return num5522;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5515 = undefined;
  } else {
  }
// compiled if node returning if5515 (depth = 2)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5524 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5523);
// compiled call node returning call5524 (depth = 4)
// compiled member node returning call5524 (depth = 3)
  *var_meth = call5524;
  if (call5524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5527 == NULL) {
    strlit5527 = alloc_String("identifier");
    gc_root(strlit5527);
  }
// compiled string node returning strlit5527 (depth = 4)
  int op_slot_right_5526 = gc_frame_newslot(strlit5527);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5529 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5530 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5529);
// compiled call node returning call5530 (depth = 5)
// compiled member node returning call5530 (depth = 4)
  int op_slot_left_5526 = gc_frame_newslot(call5530);
  params[0] = strlit5527;
  partcv[0] = 1;
  Object opresult5531 = callmethod(call5530, "≠", 1, partcv, params);
// compiled op node returning opresult5531 (depth = 3)
  Object if5525 = done;
  if (istrue(opresult5531)) {
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5534 == NULL) {
    strlit5534 = alloc_String("member");
    gc_root(strlit5534);
  }
// compiled string node returning strlit5534 (depth = 5)
  int op_slot_right_5533 = gc_frame_newslot(strlit5534);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call5537 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5536);
// compiled call node returning call5537 (depth = 6)
// compiled member node returning call5537 (depth = 5)
  int op_slot_left_5533 = gc_frame_newslot(call5537);
  params[0] = strlit5534;
  partcv[0] = 1;
  Object opresult5538 = callmethod(call5537, "≠", 1, partcv, params);
// compiled op node returning opresult5538 (depth = 4)
  Object if5532 = done;
  if (istrue(opresult5538)) {
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5539 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5540 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5539);
// compiled call node returning call5540 (depth = 4)
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5541 = alloc_Float64(0);
// compiled num node returning num5541 (depth = 5)
  return num5541;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5532 = undefined;
  } else {
  }
// compiled if node returning if5532 (depth = 3)
    gc_frame_newslot(if5532);
    if5525 = if5532;
  } else {
  }
// compiled if node returning if5525 (depth = 2)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5543 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe5542);
// compiled call node returning call5543 (depth = 4)
// compiled member node returning call5543 (depth = 3)
  *var_lnum = call5543;
  if (call5543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5545 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5544);
// compiled call node returning call5545 (depth = 4)
// compiled member node returning call5545 (depth = 3)
  *var_lpos = call5545;
  if (call5545 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5546 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5547 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe5546);
// compiled call node returning call5547 (depth = 4)
// compiled member node returning call5547 (depth = 3)
  *var_methn = call5547;
  if (call5547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5548 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5550 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5549);
// compiled call node returning call5550 (depth = 4)
// compiled member node returning call5550 (depth = 3)
  gc_frame_newslot(call5550);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5552 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5551);
// compiled call node returning call5552 (depth = 4)
// compiled member node returning call5552 (depth = 3)
  gc_frame_newslot(call5552);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5550;
  params[1] = call5552;
  partcv[0] = 2;
  Object call5553 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5548);
// compiled call node returning call5553 (depth = 2)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array5554 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5554 (depth = 3)
  *var_signature = array5554;
  if (array5554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5555 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5557 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe5556);
// compiled call node returning call5557 (depth = 6)
// compiled member node returning call5557 (depth = 5)
  partcv[0] = 0;
  Object call5558 = callmethod(call5557, "new",
    1, partcv, params);
  gc_frame_end(callframe5555);
// compiled call node returning call5558 (depth = 4)
// compiled member node returning call5558 (depth = 3)
  *var_part = call5558;
  if (call5558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5559 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5560 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe5559);
// compiled call node returning call5560 (depth = 2)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5561 = alloc_Boolean(0);
// compiled identifier node returning bool5561 (depth = 3)
  *var_hadcall = bool5561;
  if (bool5561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5562 = alloc_Boolean(0);
// compiled identifier node returning bool5562 (depth = 3)
  *var_genericIdents = bool5562;
  if (bool5562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5564 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5565 == NULL) {
    strlit5565 = alloc_String("lgeneric");
    gc_root(strlit5565);
  }
// compiled string node returning strlit5565 (depth = 4)
  gc_frame_newslot(strlit5565);
// call case 4: self request
  params[0] = strlit5565;
  partcv[0] = 1;
  Object call5566 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5564);
// compiled call node returning call5566 (depth = 3)
  Object if5563 = done;
  if (istrue(call5566)) {
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5567 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5568 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5567);
// compiled call node returning call5568 (depth = 5)
// compiled member node returning call5568 (depth = 4)
  *var_genericIdents = call5568;
  if (call5568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5563 = done;
  } else {
  }
// compiled if node returning if5563 (depth = 2)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5571 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5572 == NULL) {
    strlit5572 = alloc_String("lparen");
    gc_root(strlit5572);
  }
// compiled string node returning strlit5572 (depth = 4)
  gc_frame_newslot(strlit5572);
// call case 4: self request
  params[0] = strlit5572;
  partcv[0] = 1;
  Object call5573 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5571);
// compiled call node returning call5573 (depth = 3)
  Object if5570 = done;
  if (istrue(call5573)) {
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5574 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5575 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5576 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5575);
// compiled call node returning call5576 (depth = 5)
// compiled member node returning call5576 (depth = 4)
  gc_frame_newslot(call5576);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5576;
  partcv[0] = 1;
  Object call5577 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5574);
// compiled call node returning call5577 (depth = 3)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5578 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5580 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5579);
// compiled call node returning call5580 (depth = 5)
// compiled member node returning call5580 (depth = 4)
  gc_frame_newslot(call5580);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call5580;
  partcv[0] = 1;
  Object call5581 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5578);
// compiled call node returning call5581 (depth = 3)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5582 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methn (depth = 4)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5583 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5582);
// compiled call node returning call5583 (depth = 3)
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5585 = alloc_Boolean(1);
// compiled identifier node returning bool5585 (depth = 4)
  *var_hadcall = bool5585;
  if (bool5585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5587 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5588 = callmethodflags(self, "parenthesizedArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5587);
// compiled call node returning call5588 (depth = 3)
    gc_frame_newslot(call5588);
    if5570 = call5588;
  } else {
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block5591 = alloc_Block(NULL, NULL, "parser", 1752);
  gc_frame_newslot(block5591);
// method "_apply"
  block_savedest(block5591);
  Object closure5592 = createclosure(2, "_apply");
  setclosureframe(closure5592, stackframe);
  addtoclosure(closure5592, var_tok);
  addtoclosure(closure5592, selfslot);
  struct UserObject *uo5592 = (struct UserObject*)block5591;
  uo5592->data[0] = (Object)closure5592;
  Method *meth_meth_parser__apply5592 = addmethod2pos(block5591, "_apply", &meth_parser__apply5592, 0);
  int argcv_meth_parser__apply5592[] = {0};
  meth_meth_parser__apply5592->type = alloc_MethodType(1, argcv_meth_parser__apply5592);
  meth_meth_parser__apply5592->definitionModule = modulename;
  meth_meth_parser__apply5592->definitionLine = 1747;
// compiled block node returning block5591 (depth = 5)
  int op_slot_right_5590 = gc_frame_newslot(block5591);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  partcv[0] = 0;
  Object call5599 = callmethod(*var_acceptBlocks, "not",
    1, partcv, params);
  gc_frame_end(callframe5598);
// compiled call node returning call5599 (depth = 6)
// compiled member node returning call5599 (depth = 5)
  int op_slot_left_5590 = gc_frame_newslot(call5599);
  params[0] = block5591;
  partcv[0] = 1;
  Object opresult5600 = callmethod(call5599, "&&", 1, partcv, params);
// compiled op node returning opresult5600 (depth = 4)
  Object if5589 = done;
  if (istrue(opresult5600)) {
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5601 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5602 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5601);
// compiled call node returning call5602 (depth = 4)
    gc_frame_newslot(call5602);
    if5589 = call5602;
  } else {
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5604 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call5605 = callmethodflags(self, "acceptArgumentOnLineOf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5604);
// compiled call node returning call5605 (depth = 5)
  Object if5603 = done;
  if (istrue(call5605)) {
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5607 = alloc_Boolean(1);
// compiled identifier node returning bool5607 (depth = 6)
  *var_hadcall = bool5607;
  if (bool5607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5609 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5610 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5609);
// compiled call node returning call5610 (depth = 5)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5612 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5611);
// compiled call node returning call5612 (depth = 6)
// compiled member node returning call5612 (depth = 5)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call5614 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5613);
// compiled call node returning call5614 (depth = 7)
// compiled member node returning call5614 (depth = 6)
  *var_ar = call5614;
  if (call5614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5615 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ar (depth = 6)
  gc_frame_newslot(*var_ar);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call5617 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5616);
// compiled call node returning call5617 (depth = 7)
// compiled member node returning call5617 (depth = 6)
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call5618 = callmethod(call5617, "push",
    1, partcv, params);
  gc_frame_end(callframe5615);
// compiled call node returning call5618 (depth = 5)
    gc_frame_newslot(call5618);
    if5603 = call5618;
  } else {
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5621 == NULL) {
    strlit5621 = alloc_String("identifier");
    gc_root(strlit5621);
  }
// compiled string node returning strlit5621 (depth = 7)
  int op_slot_right_5620 = gc_frame_newslot(strlit5621);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call5624 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5623);
// compiled call node returning call5624 (depth = 8)
// compiled member node returning call5624 (depth = 7)
  int op_slot_left_5620 = gc_frame_newslot(call5624);
  params[0] = strlit5621;
  partcv[0] = 1;
  Object opresult5625 = callmethod(call5624, "==", 1, partcv, params);
// compiled op node returning opresult5625 (depth = 6)
  Object if5619 = done;
  if (istrue(opresult5625)) {
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5626 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5627 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5626);
// compiled call node returning call5627 (depth = 6)
    gc_frame_newslot(call5627);
    if5619 = call5627;
  } else {
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5630 == NULL) {
    strlit5630 = alloc_String("member");
    gc_root(strlit5630);
  }
// compiled string node returning strlit5630 (depth = 8)
  int op_slot_right_5629 = gc_frame_newslot(strlit5630);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call5633 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5632);
// compiled call node returning call5633 (depth = 9)
// compiled member node returning call5633 (depth = 8)
  int op_slot_left_5629 = gc_frame_newslot(call5633);
  params[0] = strlit5630;
  partcv[0] = 1;
  Object opresult5634 = callmethod(call5633, "==", 1, partcv, params);
// compiled op node returning opresult5634 (depth = 7)
  Object if5628 = done;
  if (istrue(opresult5634)) {
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call5636 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe5635);
// compiled call node returning call5636 (depth = 9)
// compiled member node returning call5636 (depth = 8)
  *var_root = call5636;
  if (call5636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5637 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block5638 = alloc_Block(NULL, NULL, "parser", 1766);
  gc_frame_newslot(block5638);
// method "_apply"
  block_savedest(block5638);
  Object closure5639 = createclosure(2, "_apply");
  setclosureframe(closure5639, stackframe);
  addtoclosure(closure5639, var_root);
  addtoclosure(closure5639, selfslot);
  struct UserObject *uo5639 = (struct UserObject*)block5638;
  uo5639->data[0] = (Object)closure5639;
  Method *meth_meth_parser__apply5639 = addmethod2pos(block5638, "_apply", &meth_parser__apply5639, 0);
  int argcv_meth_parser__apply5639[] = {0};
  meth_meth_parser__apply5639->type = alloc_MethodType(1, argcv_meth_parser__apply5639);
  meth_meth_parser__apply5639->definitionModule = modulename;
  meth_meth_parser__apply5639->definitionLine = 1764;
// compiled block node returning block5638 (depth = 8)
  gc_frame_newslot(block5638);
// starting to compile block node (depth = 8)
  Object block5647 = alloc_Block(NULL, NULL, "parser", 1766);
  gc_frame_newslot(block5647);
// method "_apply"
  block_savedest(block5647);
  Object closure5648 = createclosure(3, "_apply");
  setclosureframe(closure5648, stackframe);
  addtoclosure(closure5648, var_root);
  addtoclosure(closure5648, var_outroot);
  addtoclosure(closure5648, selfslot);
  struct UserObject *uo5648 = (struct UserObject*)block5647;
  uo5648->data[0] = (Object)closure5648;
  Method *meth_meth_parser__apply5648 = addmethod2pos(block5647, "_apply", &meth_parser__apply5648, 0);
  int argcv_meth_parser__apply5648[] = {0};
  meth_meth_parser__apply5648->type = alloc_MethodType(1, argcv_meth_parser__apply5648);
  meth_meth_parser__apply5648->definitionModule = modulename;
  meth_meth_parser__apply5648->definitionLine = 1766;
// compiled block node returning block5647 (depth = 8)
  gc_frame_newslot(block5647);
// call case 5: prelude request
  params[0] = block5638;
  params[1] = block5647;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5654 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5637);
// compiled call node returning call5654 (depth = 7)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5657 == NULL) {
    strlit5657 = alloc_String("identifier");
    gc_root(strlit5657);
  }
// compiled string node returning strlit5657 (depth = 9)
  int op_slot_right_5656 = gc_frame_newslot(strlit5657);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5659 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  partcv[0] = 0;
  Object call5660 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe5659);
// compiled call node returning call5660 (depth = 10)
// compiled member node returning call5660 (depth = 9)
  int op_slot_left_5656 = gc_frame_newslot(call5660);
  params[0] = strlit5657;
  partcv[0] = 1;
  Object opresult5661 = callmethod(call5660, "==", 1, partcv, params);
// compiled op node returning opresult5661 (depth = 8)
  Object if5655 = done;
  if (istrue(opresult5661)) {
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5662 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5663 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5662);
// compiled call node returning call5663 (depth = 8)
    gc_frame_newslot(call5663);
    if5655 = call5663;
  } else {
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5664 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_genericIdents (depth = 9)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5665 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5664);
// compiled call node returning call5665 (depth = 8)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5666 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5667 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5666);
// compiled call node returning call5667 (depth = 8)
    gc_frame_newslot(call5667);
    if5655 = call5667;
  }
// compiled if node returning if5655 (depth = 7)
    gc_frame_newslot(if5655);
    if5628 = if5655;
  } else {
  }
// compiled if node returning if5628 (depth = 6)
    gc_frame_newslot(if5628);
    if5619 = if5628;
  }
// compiled if node returning if5619 (depth = 5)
    gc_frame_newslot(if5619);
    if5603 = if5619;
  }
// compiled if node returning if5603 (depth = 4)
    gc_frame_newslot(if5603);
    if5589 = if5603;
  }
// compiled if node returning if5589 (depth = 3)
    gc_frame_newslot(if5589);
    if5570 = if5589;
  }
// compiled if node returning if5570 (depth = 2)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_hadcall (depth = 3)
  Object if5668 = done;
  if (istrue(*var_hadcall)) {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5670 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5671 == NULL) {
    strlit5671 = alloc_String("identifier");
    gc_root(strlit5671);
  }
// compiled string node returning strlit5671 (depth = 5)
  gc_frame_newslot(strlit5671);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit5671;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5672 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5670);
// compiled call node returning call5672 (depth = 4)
  Object if5669 = done;
  if (istrue(call5672)) {
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5673 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// starting to compile identifier node (depth = 6)
  Object bool5674 = alloc_Boolean(0);
// compiled identifier node returning bool5674 (depth = 6)
  gc_frame_newslot(bool5674);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5676 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe5675);
// compiled call node returning call5676 (depth = 7)
// compiled member node returning call5676 (depth = 6)
  params[0] = *var_methn;
  params[1] = bool5674;
  partcv[0] = 2;
  Object call5677 = callmethod(call5676, "new",
    1, partcv, params);
  gc_frame_end(callframe5673);
// compiled call node returning call5677 (depth = 5)
  *var_meth_39_ = call5677;
  if (call5677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5678 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lnum (depth = 5)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5679 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5678);
// compiled call node returning call5679 (depth = 4)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5680 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lpos (depth = 5)
  gc_frame_newslot(*var_lpos);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth_39_ (depth = 5)
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call5681 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5680);
// compiled call node returning call5681 (depth = 4)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5682 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  gc_frame_newslot(*var_meth_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call5683 = callmethodflags(self, "callmprest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5682);
// compiled call node returning call5683 (depth = 5)
  *var_methn = call5683;
  if (call5683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5687 == NULL) {
    strlit5687 = alloc_String("member");
    gc_root(strlit5687);
  }
// compiled string node returning strlit5687 (depth = 6)
  int op_slot_right_5686 = gc_frame_newslot(strlit5687);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call5690 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5689);
// compiled call node returning call5690 (depth = 7)
// compiled member node returning call5690 (depth = 6)
  int op_slot_left_5686 = gc_frame_newslot(call5690);
  params[0] = strlit5687;
  partcv[0] = 1;
  Object opresult5691 = callmethod(call5690, "==", 1, partcv, params);
// compiled op node returning opresult5691 (depth = 5)
  Object if5685 = done;
  if (istrue(opresult5691)) {
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5692 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call5694 = callmethod(*var_methn, "value",
    1, partcv, params);
  gc_frame_end(callframe5693);
// compiled call node returning call5694 (depth = 8)
// compiled member node returning call5694 (depth = 7)
  gc_frame_newslot(call5694);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call5696 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe5695);
// compiled call node returning call5696 (depth = 8)
// compiled member node returning call5696 (depth = 7)
  gc_frame_newslot(call5696);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5697 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call5698 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5697);
// compiled call node returning call5698 (depth = 8)
// compiled member node returning call5698 (depth = 7)
  params[0] = call5694;
  params[1] = call5696;
  partcv[0] = 2;
  Object call5699 = callmethod(call5698, "new",
    1, partcv, params);
  gc_frame_end(callframe5692);
// compiled call node returning call5699 (depth = 6)
  *var_meth = call5699;
  if (call5699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5701 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methn (depth = 8)
  partcv[0] = 0;
  Object call5703 = callmethod(*var_methn, "line",
    1, partcv, params);
  gc_frame_end(callframe5702);
// compiled call node returning call5703 (depth = 7)
// compiled member node returning call5703 (depth = 6)
  gc_frame_newslot(call5703);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5703;
  partcv[0] = 1;
  Object call5704 = callmethod(*var_meth, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5701);
// compiled call node returning call5704 (depth = 5)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5705 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methn (depth = 8)
  partcv[0] = 0;
  Object call5707 = callmethod(*var_methn, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5706);
// compiled call node returning call5707 (depth = 7)
// compiled member node returning call5707 (depth = 6)
  gc_frame_newslot(call5707);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = call5707;
  partcv[0] = 1;
  Object call5708 = callmethod(*var_meth, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5705);
// compiled call node returning call5708 (depth = 5)
    gc_frame_newslot(call5708);
    if5685 = call5708;
  } else {
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5685 = done;
  }
// compiled if node returning if5685 (depth = 4)
    gc_frame_newslot(if5685);
    if5669 = if5685;
  } else {
  }
// compiled if node returning if5669 (depth = 3)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5710 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lnum (depth = 4)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call5711 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe5710);
// compiled call node returning call5711 (depth = 3)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5712 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5714 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe5713);
// compiled call node returning call5714 (depth = 6)
// compiled member node returning call5714 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call5715 = callmethod(call5714, "new",
    1, partcv, params);
  gc_frame_end(callframe5712);
// compiled call node returning call5715 (depth = 4)
  *var_call = call5715;
  if (call5715 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5716 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genericIdents (depth = 4)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5717 = callmethod(*var_call, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5716);
// compiled call node returning call5717 (depth = 3)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5718 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call5719 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5718);
// compiled call node returning call5719 (depth = 3)
    gc_frame_newslot(call5719);
    if5668 = call5719;
  } else {
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  int op_slot_right_5721 = gc_frame_newslot(*var_genericIdents);
// starting to compile identifier node (depth = 5)
  Object bool5723 = alloc_Boolean(0);
// compiled identifier node returning bool5723 (depth = 5)
  int op_slot_left_5721 = gc_frame_newslot(bool5723);
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object opresult5724 = callmethod(bool5723, "≠", 1, partcv, params);
// compiled op node returning opresult5724 (depth = 4)
  Object if5720 = done;
  if (istrue(opresult5724)) {
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5725 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call5726 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe5725);
// compiled call node returning call5726 (depth = 4)
    gc_frame_newslot(call5726);
    if5720 = call5726;
  } else {
  }
// compiled if node returning if5720 (depth = 3)
    gc_frame_newslot(if5720);
    if5668 = if5720;
  }
// compiled if node returning if5668 (depth = 2)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startInd (depth = 3)
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5728 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5729 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5728);
// compiled call node returning call5729 (depth = 2)
  gc_frame_end(frame);
  return call5729;
}
Object meth_parser__apply5735(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5736 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blocksOK (depth = 5)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5737 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5736);
// compiled call node returning call5737 (depth = 4)
  gc_frame_end(frame);
  return call5737;
}
Object meth_parser__apply5814(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe5815 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5816 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5815);
// compiled call node returning call5816 (depth = 10)
  gc_frame_end(frame);
  return call5816;
}
Object meth_parser__apply5875(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe5876 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5877 == NULL) {
    strlit5877 = alloc_String("comma");
    gc_root(strlit5877);
  }
// compiled string node returning strlit5877 (depth = 7)
  gc_frame_newslot(strlit5877);
// call case 4: self request
  params[0] = strlit5877;
  partcv[0] = 1;
  Object call5878 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5876);
// compiled call node returning call5878 (depth = 6)
  gc_frame_end(frame);
  return call5878;
}
Object meth_parser__apply5894(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe5895 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5896 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5895);
// compiled call node returning call5896 (depth = 11)
  gc_frame_end(frame);
  return call5896;
}
Object meth_parser__apply6016(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6017 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6018 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6017);
// compiled call node returning call6018 (depth = 12)
  gc_frame_end(frame);
  return call6018;
}
Object meth_parser__apply5881(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arg = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arg");
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5882 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call5884 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5883);
// compiled call node returning call5884 (depth = 8)
// compiled member node returning call5884 (depth = 7)
  gc_frame_newslot(call5884);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call5886 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe5885);
// compiled call node returning call5886 (depth = 8)
// compiled member node returning call5886 (depth = 7)
  params[0] = call5884;
  partcv[0] = 1;
  Object call5887 = callmethod(call5886, "push",
    1, partcv, params);
  gc_frame_end(callframe5882);
// compiled call node returning call5887 (depth = 6)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5888 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5889 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5888);
// compiled call node returning call5889 (depth = 7)
// compiled member node returning call5889 (depth = 6)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5891 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe5892 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block5893 = alloc_Block(NULL, NULL, "parser", 1848);
  gc_frame_newslot(block5893);
// method "_apply"
  block_savedest(block5893);
  Object closure5894 = createclosure(2, "_apply");
  setclosureframe(closure5894, stackframe);
  addtoclosure(closure5894, var_blocksOK);
  addtoclosure(closure5894, selfslot);
  struct UserObject *uo5894 = (struct UserObject*)block5893;
  uo5894->data[0] = (Object)closure5894;
  Method *meth_meth_parser__apply5894 = addmethod2pos(block5893, "_apply", &meth_parser__apply5894, 0);
  int argcv_meth_parser__apply5894[] = {0};
  meth_meth_parser__apply5894->type = alloc_MethodType(1, argcv_meth_parser__apply5894);
  meth_meth_parser__apply5894->definitionModule = modulename;
  meth_meth_parser__apply5894->definitionLine = 1848;
// compiled block node returning block5893 (depth = 10)
  gc_frame_newslot(block5893);
// call case 4: self request
  params[0] = block5893;
  partcv[0] = 1;
  Object call5898 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5892);
// compiled call node returning call5898 (depth = 9)
  partcv[0] = 0;
  Object call5899 = callmethod(call5898, "not",
    1, partcv, params);
  gc_frame_end(callframe5891);
// compiled call node returning call5899 (depth = 8)
// compiled member node returning call5899 (depth = 7)
  Object if5890 = done;
  if (istrue(call5899)) {
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array5900 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5900 (depth = 8)
  *var_suggestions = array5900;
  if (array5900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call5903 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5902);
// compiled call node returning call5903 (depth = 11)
// compiled member node returning call5903 (depth = 10)
  partcv[0] = 0;
  Object call5904 = callmethod(call5903, "new",
    1, partcv, params);
  gc_frame_end(callframe5901);
// compiled call node returning call5904 (depth = 9)
// compiled member node returning call5904 (depth = 8)
  *var_suggestion = call5904;
  if (call5904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5905 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array5906 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit5907 == NULL) {
    strlit5907 = alloc_String("rparen");
    gc_root(strlit5907);
  }
// compiled string node returning strlit5907 (depth = 10)
  params[0] = strlit5907;
  partcv[0] = 1;
  callmethodflags(array5906, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5906 (depth = 9)
  gc_frame_newslot(array5906);
// call case 4: self request
  params[0] = array5906;
  partcv[0] = 1;
  Object call5908 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5905);
// compiled call node returning call5908 (depth = 8)
  *var_nextTok = call5908;
  if (call5908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_5910 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_5910 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5912 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5912 (depth = 8)
  Object if5909 = done;
  if (istrue(opresult5912)) {
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5913 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5914 == NULL) {
    strlit5914 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5914);
  }
// compiled string node returning strlit5914 (depth = 9)
  gc_frame_newslot(strlit5914);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit5914;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5915 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5913);
// compiled call node returning call5915 (depth = 8)
    gc_frame_newslot(call5915);
    if5909 = call5915;
  } else {
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5916 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call5918 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5917);
// compiled call node returning call5918 (depth = 10)
// compiled member node returning call5918 (depth = 9)
  gc_frame_newslot(call5918);
// starting to compile identifier node (depth = 9)
  Object bool5919 = alloc_Boolean(1);
// compiled identifier node returning bool5919 (depth = 9)
  gc_frame_newslot(bool5919);
// starting to compile identifier node (depth = 9)
  Object bool5920 = alloc_Boolean(0);
// compiled identifier node returning bool5920 (depth = 9)
  gc_frame_newslot(bool5920);
// starting to compile string node (depth = 9)
  if (strlit5921 == NULL) {
    strlit5921 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5921);
  }
// compiled string node returning strlit5921 (depth = 9)
  gc_frame_newslot(strlit5921);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call5918;
  params[2] = bool5919;
  params[3] = bool5920;
  params[4] = strlit5921;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5922 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5916);
// compiled call node returning call5922 (depth = 8)
    gc_frame_newslot(call5922);
    if5909 = call5922;
  }
// compiled if node returning if5909 (depth = 7)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5923 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5924 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5923);
// compiled call node returning call5924 (depth = 7)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5926 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call5927 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5926);
// compiled call node returning call5927 (depth = 11)
// compiled member node returning call5927 (depth = 10)
  partcv[0] = 0;
  Object call5928 = callmethod(call5927, "new",
    1, partcv, params);
  gc_frame_end(callframe5925);
// compiled call node returning call5928 (depth = 9)
// compiled member node returning call5928 (depth = 8)
  *var_suggestion = call5928;
  if (call5928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5930 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5932 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5931);
// compiled call node returning call5932 (depth = 9)
// compiled member node returning call5932 (depth = 8)
  gc_frame_newslot(call5932);
// starting to compile identifier node (depth = 8)
  Object bool5933 = alloc_Boolean(1);
// compiled identifier node returning bool5933 (depth = 8)
  gc_frame_newslot(bool5933);
// starting to compile identifier node (depth = 8)
  Object bool5934 = alloc_Boolean(0);
// compiled identifier node returning bool5934 (depth = 8)
  gc_frame_newslot(bool5934);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call5932;
  params[2] = bool5933;
  params[3] = bool5934;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5935 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5930);
// compiled call node returning call5935 (depth = 7)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5936 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5937 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5936);
// compiled call node returning call5937 (depth = 7)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5938 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5939 == NULL) {
    strlit5939 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit5939);
  }
// compiled string node returning strlit5939 (depth = 8)
  gc_frame_newslot(strlit5939);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5941 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5940);
// compiled call node returning call5941 (depth = 9)
// compiled member node returning call5941 (depth = 8)
  gc_frame_newslot(call5941);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5942 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5943 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5942);
// compiled call node returning call5943 (depth = 9)
// compiled member node returning call5943 (depth = 8)
  gc_frame_newslot(call5943);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5939;
  params[1] = call5941;
  params[2] = call5943;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5944 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5938);
// compiled call node returning call5944 (depth = 7)
    gc_frame_newslot(call5944);
    if5890 = call5944;
  } else {
  }
// compiled if node returning if5890 (depth = 6)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5946 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5947 == NULL) {
    strlit5947 = alloc_String("colon");
    gc_root(strlit5947);
  }
// compiled string node returning strlit5947 (depth = 8)
  gc_frame_newslot(strlit5947);
// call case 4: self request
  params[0] = strlit5947;
  partcv[0] = 1;
  Object call5948 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5946);
// compiled call node returning call5948 (depth = 7)
  Object if5945 = done;
  if (istrue(call5948)) {
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call5950 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5949);
// compiled call node returning call5950 (depth = 9)
// compiled member node returning call5950 (depth = 8)
  *var_arg = call5950;
  if (call5950 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5953 == NULL) {
    strlit5953 = alloc_String("identifier");
    gc_root(strlit5953);
  }
// compiled string node returning strlit5953 (depth = 9)
  int op_slot_right_5952 = gc_frame_newslot(strlit5953);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  partcv[0] = 0;
  Object call5956 = callmethod(*var_arg, "kind",
    1, partcv, params);
  gc_frame_end(callframe5955);
// compiled call node returning call5956 (depth = 10)
// compiled member node returning call5956 (depth = 9)
  int op_slot_left_5952 = gc_frame_newslot(call5956);
  params[0] = strlit5953;
  partcv[0] = 1;
  Object opresult5957 = callmethod(call5956, "≠", 1, partcv, params);
// compiled op node returning opresult5957 (depth = 8)
  Object if5951 = done;
  if (istrue(opresult5957)) {
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5958 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call5960 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5959);
// compiled call node returning call5960 (depth = 12)
// compiled member node returning call5960 (depth = 11)
  partcv[0] = 0;
  Object call5961 = callmethod(call5960, "new",
    1, partcv, params);
  gc_frame_end(callframe5958);
// compiled call node returning call5961 (depth = 10)
// compiled member node returning call5961 (depth = 9)
  *var_suggestion = call5961;
  if (call5961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5964 == NULL) {
    strlit5964 = alloc_String("identifier");
    gc_root(strlit5964);
  }
// compiled string node returning strlit5964 (depth = 10)
  int op_slot_right_5963 = gc_frame_newslot(strlit5964);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5966 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5968 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5967);
// compiled call node returning call5968 (depth = 13)
// compiled member node returning call5968 (depth = 12)
  partcv[0] = 0;
  Object call5969 = callmethod(call5968, "kind",
    1, partcv, params);
  gc_frame_end(callframe5966);
// compiled call node returning call5969 (depth = 11)
// compiled member node returning call5969 (depth = 10)
  int op_slot_left_5963 = gc_frame_newslot(call5969);
  params[0] = strlit5964;
  partcv[0] = 1;
  Object opresult5970 = callmethod(call5969, "==", 1, partcv, params);
// compiled op node returning opresult5970 (depth = 9)
  Object if5962 = done;
  if (istrue(opresult5970)) {
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5971 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5973 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5972);
// compiled call node returning call5973 (depth = 11)
// compiled member node returning call5973 (depth = 10)
  gc_frame_newslot(call5973);
// starting to compile identifier node (depth = 10)
  Object bool5974 = alloc_Boolean(1);
// compiled identifier node returning bool5974 (depth = 10)
  gc_frame_newslot(bool5974);
// starting to compile identifier node (depth = 10)
  Object bool5975 = alloc_Boolean(0);
// compiled identifier node returning bool5975 (depth = 10)
  gc_frame_newslot(bool5975);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call5973;
  params[2] = bool5974;
  params[3] = bool5975;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5976 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5971);
// compiled call node returning call5976 (depth = 9)
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5977 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5978 == NULL) {
    strlit5978 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit5978);
  }
// compiled string node returning strlit5978 (depth = 10)
  gc_frame_newslot(strlit5978);
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5980 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5979);
// compiled call node returning call5980 (depth = 11)
// compiled member node returning call5980 (depth = 10)
  gc_frame_newslot(call5980);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5982 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5981);
// compiled call node returning call5982 (depth = 11)
// compiled member node returning call5982 (depth = 10)
  gc_frame_newslot(call5982);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num5984 = alloc_Float64(1);
// compiled num node returning num5984 (depth = 11)
  int op_slot_right_5983 = gc_frame_newslot(num5984);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5987 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call5989 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5988);
// compiled call node returning call5989 (depth = 15)
// compiled member node returning call5989 (depth = 14)
  partcv[0] = 0;
  Object call5990 = callmethod(call5989, "size",
    1, partcv, params);
  gc_frame_end(callframe5987);
// compiled call node returning call5990 (depth = 13)
// compiled member node returning call5990 (depth = 12)
  int op_slot_right_5986 = gc_frame_newslot(call5990);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5992 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call5994 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5993);
// compiled call node returning call5994 (depth = 15)
// compiled member node returning call5994 (depth = 14)
  partcv[0] = 0;
  Object call5995 = callmethod(call5994, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5992);
// compiled call node returning call5995 (depth = 13)
// compiled member node returning call5995 (depth = 12)
  int op_slot_left_5986 = gc_frame_newslot(call5995);
  params[0] = call5990;
  partcv[0] = 1;
  Object sum5996 = callmethod(call5995, "+", 1, partcv, params);
// compiled op node returning sum5996 (depth = 11)
  int op_slot_left_5983 = gc_frame_newslot(sum5996);
  params[0] = num5984;
  partcv[0] = 1;
  Object diff5997 = callmethod(sum5996, "-", 1, partcv, params);
// compiled op node returning diff5997 (depth = 10)
  gc_frame_newslot(diff5997);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit5978;
  params[1] = call5980;
  params[2] = call5982;
  params[3] = diff5997;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5998 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5977);
// compiled call node returning call5998 (depth = 9)
    gc_frame_newslot(call5998);
    if5962 = call5998;
  } else {
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe5999 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6000 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5999);
// compiled call node returning call6000 (depth = 9)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6001 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6002 == NULL) {
    strlit6002 = alloc_String("only declarations may be followed by a ':' and a type.");
    gc_root(strlit6002);
  }
// compiled string node returning strlit6002 (depth = 10)
  gc_frame_newslot(strlit6002);
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6004 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6003);
// compiled call node returning call6004 (depth = 11)
// compiled member node returning call6004 (depth = 10)
  gc_frame_newslot(call6004);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6006 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6005);
// compiled call node returning call6006 (depth = 11)
// compiled member node returning call6006 (depth = 10)
  gc_frame_newslot(call6006);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6008 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6007);
// compiled call node returning call6008 (depth = 11)
// compiled member node returning call6008 (depth = 10)
  gc_frame_newslot(call6008);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6002;
  params[1] = call6004;
  params[2] = call6006;
  params[3] = call6008;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6009 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6001);
// compiled call node returning call6009 (depth = 9)
    gc_frame_newslot(call6009);
    if5962 = call6009;
  }
// compiled if node returning if5962 (depth = 8)
    gc_frame_newslot(if5962);
    if5951 = if5962;
  } else {
  }
// compiled if node returning if5951 (depth = 7)
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6011 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6010);
// compiled call node returning call6011 (depth = 8)
// compiled member node returning call6011 (depth = 7)
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6013 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6014 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6015 = alloc_Block(NULL, NULL, "parser", 1880);
  gc_frame_newslot(block6015);
// method "_apply"
  block_savedest(block6015);
  Object closure6016 = createclosure(2, "_apply");
  setclosureframe(closure6016, stackframe);
  addtoclosure(closure6016, var_blocksOK);
  addtoclosure(closure6016, selfslot);
  struct UserObject *uo6016 = (struct UserObject*)block6015;
  uo6016->data[0] = (Object)closure6016;
  Method *meth_meth_parser__apply6016 = addmethod2pos(block6015, "_apply", &meth_parser__apply6016, 0);
  int argcv_meth_parser__apply6016[] = {0};
  meth_meth_parser__apply6016->type = alloc_MethodType(1, argcv_meth_parser__apply6016);
  meth_meth_parser__apply6016->definitionModule = modulename;
  meth_meth_parser__apply6016->definitionLine = 1880;
// compiled block node returning block6015 (depth = 11)
  gc_frame_newslot(block6015);
// call case 4: self request
  params[0] = block6015;
  partcv[0] = 1;
  Object call6020 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6014);
// compiled call node returning call6020 (depth = 10)
  partcv[0] = 0;
  Object call6021 = callmethod(call6020, "not",
    1, partcv, params);
  gc_frame_end(callframe6013);
// compiled call node returning call6021 (depth = 9)
// compiled member node returning call6021 (depth = 8)
  Object if6012 = done;
  if (istrue(call6021)) {
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6022 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6023 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6022);
// compiled call node returning call6023 (depth = 9)
// compiled member node returning call6023 (depth = 8)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array6024 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6024 (depth = 9)
  *var_suggestions = array6024;
  if (array6024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6025 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6027 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6026);
// compiled call node returning call6027 (depth = 12)
// compiled member node returning call6027 (depth = 11)
  partcv[0] = 0;
  Object call6028 = callmethod(call6027, "new",
    1, partcv, params);
  gc_frame_end(callframe6025);
// compiled call node returning call6028 (depth = 10)
// compiled member node returning call6028 (depth = 9)
  *var_suggestion = call6028;
  if (call6028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6029 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array6030 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit6031 == NULL) {
    strlit6031 = alloc_String("rparen");
    gc_root(strlit6031);
  }
// compiled string node returning strlit6031 (depth = 11)
  params[0] = strlit6031;
  partcv[0] = 1;
  callmethodflags(array6030, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6030 (depth = 10)
  gc_frame_newslot(array6030);
// call case 4: self request
  params[0] = array6030;
  partcv[0] = 1;
  Object call6032 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6029);
// compiled call node returning call6032 (depth = 9)
  *var_nextTok = call6032;
  if (call6032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6034 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6034 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6036 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6036 (depth = 9)
  Object if6033 = done;
  if (istrue(opresult6036)) {
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6037 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6038 == NULL) {
    strlit6038 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6038);
  }
// compiled string node returning strlit6038 (depth = 10)
  gc_frame_newslot(strlit6038);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6038;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6039 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6037);
// compiled call node returning call6039 (depth = 9)
    gc_frame_newslot(call6039);
    if6033 = call6039;
  } else {
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6040 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6041 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6042 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6041);
// compiled call node returning call6042 (depth = 11)
// compiled member node returning call6042 (depth = 10)
  gc_frame_newslot(call6042);
// starting to compile identifier node (depth = 10)
  Object bool6043 = alloc_Boolean(1);
// compiled identifier node returning bool6043 (depth = 10)
  gc_frame_newslot(bool6043);
// starting to compile identifier node (depth = 10)
  Object bool6044 = alloc_Boolean(0);
// compiled identifier node returning bool6044 (depth = 10)
  gc_frame_newslot(bool6044);
// starting to compile string node (depth = 10)
  if (strlit6045 == NULL) {
    strlit6045 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6045);
  }
// compiled string node returning strlit6045 (depth = 10)
  gc_frame_newslot(strlit6045);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6042;
  params[2] = bool6043;
  params[3] = bool6044;
  params[4] = strlit6045;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6046 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6040);
// compiled call node returning call6046 (depth = 9)
    gc_frame_newslot(call6046);
    if6033 = call6046;
  }
// compiled if node returning if6033 (depth = 8)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6047 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6048 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6047);
// compiled call node returning call6048 (depth = 8)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6049 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6050 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6051 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6050);
// compiled call node returning call6051 (depth = 12)
// compiled member node returning call6051 (depth = 11)
  partcv[0] = 0;
  Object call6052 = callmethod(call6051, "new",
    1, partcv, params);
  gc_frame_end(callframe6049);
// compiled call node returning call6052 (depth = 10)
// compiled member node returning call6052 (depth = 9)
  *var_suggestion = call6052;
  if (call6052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6054 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6056 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6055);
// compiled call node returning call6056 (depth = 10)
// compiled member node returning call6056 (depth = 9)
  gc_frame_newslot(call6056);
// starting to compile identifier node (depth = 9)
  Object bool6057 = alloc_Boolean(1);
// compiled identifier node returning bool6057 (depth = 9)
  gc_frame_newslot(bool6057);
// starting to compile identifier node (depth = 9)
  Object bool6058 = alloc_Boolean(0);
// compiled identifier node returning bool6058 (depth = 9)
  gc_frame_newslot(bool6058);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6056;
  params[2] = bool6057;
  params[3] = bool6058;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6059 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6054);
// compiled call node returning call6059 (depth = 8)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6060 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6061 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6060);
// compiled call node returning call6061 (depth = 8)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6062 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6063 == NULL) {
    strlit6063 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit6063);
  }
// compiled string node returning strlit6063 (depth = 9)
  gc_frame_newslot(strlit6063);
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6065 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6064);
// compiled call node returning call6065 (depth = 10)
// compiled member node returning call6065 (depth = 9)
  gc_frame_newslot(call6065);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6066 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6067 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6066);
// compiled call node returning call6067 (depth = 10)
// compiled member node returning call6067 (depth = 9)
  gc_frame_newslot(call6067);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6063;
  params[1] = call6065;
  params[2] = call6067;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6068 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6062);
// compiled call node returning call6068 (depth = 8)
    gc_frame_newslot(call6068);
    if6012 = call6068;
  } else {
  }
// compiled if node returning if6012 (depth = 7)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6069 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6071 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6070);
// compiled call node returning call6071 (depth = 9)
// compiled member node returning call6071 (depth = 8)
  gc_frame_newslot(call6071);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  params[0] = call6071;
  partcv[0] = 1;
  Object call6072 = callmethod(*var_arg, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6069);
// compiled call node returning call6072 (depth = 7)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6073 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call6074 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6073);
// compiled call node returning call6074 (depth = 7)
    gc_frame_newslot(call6074);
    if5945 = call6074;
  } else {
  }
// compiled if node returning if5945 (depth = 6)
  gc_frame_end(frame);
  return if5945;
}
Object meth_parser__apply5740(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5742 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5743 == NULL) {
    strlit5743 = alloc_String("colon");
    gc_root(strlit5743);
  }
// compiled string node returning strlit5743 (depth = 6)
  gc_frame_newslot(strlit5743);
// call case 4: self request
  params[0] = strlit5743;
  partcv[0] = 1;
  Object call5744 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5742);
// compiled call node returning call5744 (depth = 5)
  Object if5741 = done;
  if (istrue(call5744)) {
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call5746 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5745);
// compiled call node returning call5746 (depth = 7)
// compiled member node returning call5746 (depth = 6)
  *var_expr = call5746;
  if (call5746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5749 == NULL) {
    strlit5749 = alloc_String("identifier");
    gc_root(strlit5749);
  }
// compiled string node returning strlit5749 (depth = 7)
  int op_slot_right_5748 = gc_frame_newslot(strlit5749);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr (depth = 9)
  partcv[0] = 0;
  Object call5752 = callmethod(*var_expr, "kind",
    1, partcv, params);
  gc_frame_end(callframe5751);
// compiled call node returning call5752 (depth = 8)
// compiled member node returning call5752 (depth = 7)
  int op_slot_left_5748 = gc_frame_newslot(call5752);
  params[0] = strlit5749;
  partcv[0] = 1;
  Object opresult5753 = callmethod(call5752, "≠", 1, partcv, params);
// compiled op node returning opresult5753 (depth = 6)
  Object if5747 = done;
  if (istrue(opresult5753)) {
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5754 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5756 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5755);
// compiled call node returning call5756 (depth = 10)
// compiled member node returning call5756 (depth = 9)
  partcv[0] = 0;
  Object call5757 = callmethod(call5756, "new",
    1, partcv, params);
  gc_frame_end(callframe5754);
// compiled call node returning call5757 (depth = 8)
// compiled member node returning call5757 (depth = 7)
  *var_suggestion = call5757;
  if (call5757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5760 == NULL) {
    strlit5760 = alloc_String("identifier");
    gc_root(strlit5760);
  }
// compiled string node returning strlit5760 (depth = 8)
  int op_slot_right_5759 = gc_frame_newslot(strlit5760);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call5764 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5763);
// compiled call node returning call5764 (depth = 11)
// compiled member node returning call5764 (depth = 10)
  partcv[0] = 0;
  Object call5765 = callmethod(call5764, "kind",
    1, partcv, params);
  gc_frame_end(callframe5762);
// compiled call node returning call5765 (depth = 9)
// compiled member node returning call5765 (depth = 8)
  int op_slot_left_5759 = gc_frame_newslot(call5765);
  params[0] = strlit5760;
  partcv[0] = 1;
  Object opresult5766 = callmethod(call5765, "==", 1, partcv, params);
// compiled op node returning opresult5766 (depth = 7)
  Object if5758 = done;
  if (istrue(opresult5766)) {
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5767 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5768 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5769 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5768);
// compiled call node returning call5769 (depth = 9)
// compiled member node returning call5769 (depth = 8)
  gc_frame_newslot(call5769);
// starting to compile identifier node (depth = 8)
  Object bool5770 = alloc_Boolean(1);
// compiled identifier node returning bool5770 (depth = 8)
  gc_frame_newslot(bool5770);
// starting to compile identifier node (depth = 8)
  Object bool5771 = alloc_Boolean(0);
// compiled identifier node returning bool5771 (depth = 8)
  gc_frame_newslot(bool5771);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5769;
  params[2] = bool5770;
  params[3] = bool5771;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5772 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5767);
// compiled call node returning call5772 (depth = 7)
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5773 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5774 == NULL) {
    strlit5774 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5774);
  }
// compiled string node returning strlit5774 (depth = 8)
  gc_frame_newslot(strlit5774);
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5776 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5775);
// compiled call node returning call5776 (depth = 9)
// compiled member node returning call5776 (depth = 8)
  gc_frame_newslot(call5776);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5778 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5777);
// compiled call node returning call5778 (depth = 9)
// compiled member node returning call5778 (depth = 8)
  gc_frame_newslot(call5778);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5780 = alloc_Float64(1);
// compiled num node returning num5780 (depth = 9)
  int op_slot_right_5779 = gc_frame_newslot(num5780);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5783 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5785 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5784);
// compiled call node returning call5785 (depth = 13)
// compiled member node returning call5785 (depth = 12)
  partcv[0] = 0;
  Object call5786 = callmethod(call5785, "size",
    1, partcv, params);
  gc_frame_end(callframe5783);
// compiled call node returning call5786 (depth = 11)
// compiled member node returning call5786 (depth = 10)
  int op_slot_right_5782 = gc_frame_newslot(call5786);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5788 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5790 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe5789);
// compiled call node returning call5790 (depth = 13)
// compiled member node returning call5790 (depth = 12)
  partcv[0] = 0;
  Object call5791 = callmethod(call5790, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5788);
// compiled call node returning call5791 (depth = 11)
// compiled member node returning call5791 (depth = 10)
  int op_slot_left_5782 = gc_frame_newslot(call5791);
  params[0] = call5786;
  partcv[0] = 1;
  Object sum5792 = callmethod(call5791, "+", 1, partcv, params);
// compiled op node returning sum5792 (depth = 9)
  int op_slot_left_5779 = gc_frame_newslot(sum5792);
  params[0] = num5780;
  partcv[0] = 1;
  Object diff5793 = callmethod(sum5792, "-", 1, partcv, params);
// compiled op node returning diff5793 (depth = 8)
  gc_frame_newslot(diff5793);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5774;
  params[1] = call5776;
  params[2] = call5778;
  params[3] = diff5793;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5794 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5773);
// compiled call node returning call5794 (depth = 7)
    gc_frame_newslot(call5794);
    if5758 = call5794;
  } else {
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5795 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool5796 = alloc_Boolean(1);
// compiled identifier node returning bool5796 (depth = 8)
  gc_frame_newslot(bool5796);
// starting to compile identifier node (depth = 8)
  Object bool5797 = alloc_Boolean(0);
// compiled identifier node returning bool5797 (depth = 8)
  gc_frame_newslot(bool5797);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool5796;
  params[2] = bool5797;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5798 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5795);
// compiled call node returning call5798 (depth = 7)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5799 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5800 == NULL) {
    strlit5800 = alloc_String("only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit5800);
  }
// compiled string node returning strlit5800 (depth = 8)
  gc_frame_newslot(strlit5800);
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5801 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5802 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5801);
// compiled call node returning call5802 (depth = 9)
// compiled member node returning call5802 (depth = 8)
  gc_frame_newslot(call5802);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5804 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5803);
// compiled call node returning call5804 (depth = 9)
// compiled member node returning call5804 (depth = 8)
  gc_frame_newslot(call5804);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5805 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call5806 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5805);
// compiled call node returning call5806 (depth = 9)
// compiled member node returning call5806 (depth = 8)
  gc_frame_newslot(call5806);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit5800;
  params[1] = call5802;
  params[2] = call5804;
  params[3] = call5806;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call5807 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5799);
// compiled call node returning call5807 (depth = 7)
    gc_frame_newslot(call5807);
    if5758 = call5807;
  }
// compiled if node returning if5758 (depth = 6)
    gc_frame_newslot(if5758);
    if5747 = if5758;
  } else {
  }
// compiled if node returning if5747 (depth = 5)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5808 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5809 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5808);
// compiled call node returning call5809 (depth = 6)
// compiled member node returning call5809 (depth = 5)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5811 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5812 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5813 = alloc_Block(NULL, NULL, "parser", 1825);
  gc_frame_newslot(block5813);
// method "_apply"
  block_savedest(block5813);
  Object closure5814 = createclosure(2, "_apply");
  setclosureframe(closure5814, stackframe);
  addtoclosure(closure5814, var_blocksOK);
  addtoclosure(closure5814, selfslot);
  struct UserObject *uo5814 = (struct UserObject*)block5813;
  uo5814->data[0] = (Object)closure5814;
  Method *meth_meth_parser__apply5814 = addmethod2pos(block5813, "_apply", &meth_parser__apply5814, 0);
  int argcv_meth_parser__apply5814[] = {0};
  meth_meth_parser__apply5814->type = alloc_MethodType(1, argcv_meth_parser__apply5814);
  meth_meth_parser__apply5814->definitionModule = modulename;
  meth_meth_parser__apply5814->definitionLine = 1825;
// compiled block node returning block5813 (depth = 9)
  gc_frame_newslot(block5813);
// call case 4: self request
  params[0] = block5813;
  partcv[0] = 1;
  Object call5818 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5812);
// compiled call node returning call5818 (depth = 8)
  partcv[0] = 0;
  Object call5819 = callmethod(call5818, "not",
    1, partcv, params);
  gc_frame_end(callframe5811);
// compiled call node returning call5819 (depth = 7)
// compiled member node returning call5819 (depth = 6)
  Object if5810 = done;
  if (istrue(call5819)) {
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5820 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5821 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5820);
// compiled call node returning call5821 (depth = 7)
// compiled member node returning call5821 (depth = 6)
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile array node (depth = 7)
  Object array5822 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5822 (depth = 7)
  *var_suggestions = array5822;
  if (array5822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5825 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5824);
// compiled call node returning call5825 (depth = 10)
// compiled member node returning call5825 (depth = 9)
  partcv[0] = 0;
  Object call5826 = callmethod(call5825, "new",
    1, partcv, params);
  gc_frame_end(callframe5823);
// compiled call node returning call5826 (depth = 8)
// compiled member node returning call5826 (depth = 7)
  *var_suggestion = call5826;
  if (call5826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5827 = gc_frame_new();
// starting to compile array node (depth = 8)
  Object array5828 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 9)
  if (strlit5829 == NULL) {
    strlit5829 = alloc_String("rparen");
    gc_root(strlit5829);
  }
// compiled string node returning strlit5829 (depth = 9)
  params[0] = strlit5829;
  partcv[0] = 1;
  callmethodflags(array5828, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array5828 (depth = 8)
  gc_frame_newslot(array5828);
// call case 4: self request
  params[0] = array5828;
  partcv[0] = 1;
  Object call5830 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5827);
// compiled call node returning call5830 (depth = 7)
  *var_nextTok = call5830;
  if (call5830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5832 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5832 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5834 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5834 (depth = 7)
  Object if5831 = done;
  if (istrue(opresult5834)) {
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5835 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5836 == NULL) {
    strlit5836 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5836);
  }
// compiled string node returning strlit5836 (depth = 8)
  gc_frame_newslot(strlit5836);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit5836;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5837 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5835);
// compiled call node returning call5837 (depth = 7)
    gc_frame_newslot(call5837);
    if5831 = call5837;
  } else {
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5838 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5840 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5839);
// compiled call node returning call5840 (depth = 9)
// compiled member node returning call5840 (depth = 8)
  gc_frame_newslot(call5840);
// starting to compile identifier node (depth = 8)
  Object bool5841 = alloc_Boolean(1);
// compiled identifier node returning bool5841 (depth = 8)
  gc_frame_newslot(bool5841);
// starting to compile identifier node (depth = 8)
  Object bool5842 = alloc_Boolean(0);
// compiled identifier node returning bool5842 (depth = 8)
  gc_frame_newslot(bool5842);
// starting to compile string node (depth = 8)
  if (strlit5843 == NULL) {
    strlit5843 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit5843);
  }
// compiled string node returning strlit5843 (depth = 8)
  gc_frame_newslot(strlit5843);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5840;
  params[2] = bool5841;
  params[3] = bool5842;
  params[4] = strlit5843;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5844 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5838);
// compiled call node returning call5844 (depth = 7)
    gc_frame_newslot(call5844);
    if5831 = call5844;
  }
// compiled if node returning if5831 (depth = 6)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5845 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5846 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5845);
// compiled call node returning call5846 (depth = 6)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5847 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5848 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5849 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5848);
// compiled call node returning call5849 (depth = 10)
// compiled member node returning call5849 (depth = 9)
  partcv[0] = 0;
  Object call5850 = callmethod(call5849, "new",
    1, partcv, params);
  gc_frame_end(callframe5847);
// compiled call node returning call5850 (depth = 8)
// compiled member node returning call5850 (depth = 7)
  *var_suggestion = call5850;
  if (call5850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5852 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5854 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5853);
// compiled call node returning call5854 (depth = 8)
// compiled member node returning call5854 (depth = 7)
  gc_frame_newslot(call5854);
// starting to compile identifier node (depth = 7)
  Object bool5855 = alloc_Boolean(1);
// compiled identifier node returning bool5855 (depth = 7)
  gc_frame_newslot(bool5855);
// starting to compile identifier node (depth = 7)
  Object bool5856 = alloc_Boolean(0);
// compiled identifier node returning bool5856 (depth = 7)
  gc_frame_newslot(bool5856);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5854;
  params[2] = bool5855;
  params[3] = bool5856;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5857 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5852);
// compiled call node returning call5857 (depth = 6)
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5858 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5859 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5858);
// compiled call node returning call5859 (depth = 6)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5860 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5861 == NULL) {
    strlit5861 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit5861);
  }
// compiled string node returning strlit5861 (depth = 7)
  gc_frame_newslot(strlit5861);
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5863 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5862);
// compiled call node returning call5863 (depth = 8)
// compiled member node returning call5863 (depth = 7)
  gc_frame_newslot(call5863);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5865 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5864);
// compiled call node returning call5865 (depth = 8)
// compiled member node returning call5865 (depth = 7)
  gc_frame_newslot(call5865);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5861;
  params[1] = call5863;
  params[2] = call5865;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5866 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5860);
// compiled call node returning call5866 (depth = 6)
    gc_frame_newslot(call5866);
    if5810 = call5866;
  } else {
  }
// compiled if node returning if5810 (depth = 5)
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5867 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call5869 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5868);
// compiled call node returning call5869 (depth = 7)
// compiled member node returning call5869 (depth = 6)
  gc_frame_newslot(call5869);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  params[0] = call5869;
  partcv[0] = 1;
  Object call5870 = callmethod(*var_expr, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe5867);
// compiled call node returning call5870 (depth = 5)
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5871 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  gc_frame_newslot(*var_expr);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call5872 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5871);
// compiled call node returning call5872 (depth = 5)
    gc_frame_newslot(call5872);
    if5741 = call5872;
  } else {
  }
// compiled if node returning if5741 (depth = 4)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5873 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5874 = alloc_Block(NULL, NULL, "parser", 1845);
  gc_frame_newslot(block5874);
// method "_apply"
  block_savedest(block5874);
  Object closure5875 = createclosure(1, "_apply");
  setclosureframe(closure5875, stackframe);
  addtoclosure(closure5875, selfslot);
  struct UserObject *uo5875 = (struct UserObject*)block5874;
  uo5875->data[0] = (Object)closure5875;
  Method *meth_meth_parser__apply5875 = addmethod2pos(block5874, "_apply", &meth_parser__apply5875, 0);
  int argcv_meth_parser__apply5875[] = {0};
  meth_meth_parser__apply5875->type = alloc_MethodType(1, argcv_meth_parser__apply5875);
  meth_meth_parser__apply5875->definitionModule = modulename;
  meth_meth_parser__apply5875->definitionLine = 1842;
// compiled block node returning block5874 (depth = 5)
  gc_frame_newslot(block5874);
// starting to compile block node (depth = 5)
  Object block5880 = alloc_Block(NULL, NULL, "parser", 1845);
  gc_frame_newslot(block5880);
// method "_apply"
  block_savedest(block5880);
  Object closure5881 = createclosure(7, "_apply");
  setclosureframe(closure5881, stackframe);
  addtoclosure(closure5881, var_values);
  addtoclosure(closure5881, var_part);
  addtoclosure(closure5881, var_blocksOK);
  addtoclosure(closure5881, var_errormessages);
  addtoclosure(closure5881, var_sym);
  addtoclosure(closure5881, var_lastToken);
  addtoclosure(closure5881, selfslot);
  struct UserObject *uo5881 = (struct UserObject*)block5880;
  uo5881->data[0] = (Object)closure5881;
  Method *meth_meth_parser__apply5881 = addmethod2pos(block5880, "_apply", &meth_parser__apply5881, 0);
  int argcv_meth_parser__apply5881[] = {0};
  meth_meth_parser__apply5881->type = alloc_MethodType(1, argcv_meth_parser__apply5881);
  meth_meth_parser__apply5881->definitionModule = modulename;
  meth_meth_parser__apply5881->definitionLine = 1842;
// compiled block node returning block5880 (depth = 5)
  gc_frame_newslot(block5880);
// call case 5: prelude request
  params[0] = block5874;
  params[1] = block5880;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6076 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5873);
// compiled call node returning call6076 (depth = 4)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6077 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6079 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6078);
// compiled call node returning call6079 (depth = 6)
// compiled member node returning call6079 (depth = 5)
  gc_frame_newslot(call6079);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6081 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6080);
// compiled call node returning call6081 (depth = 6)
// compiled member node returning call6081 (depth = 5)
  params[0] = call6079;
  partcv[0] = 1;
  Object call6082 = callmethod(call6081, "push",
    1, partcv, params);
  gc_frame_end(callframe6077);
// compiled call node returning call6082 (depth = 4)
  gc_frame_end(frame);
  return call6082;
}
Object meth_parser_parenthesizedArg5730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parenthesizedArg");
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parenthesizedArg (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parenthesizedArg");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5731 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5732 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5731);
// compiled call node returning call5732 (depth = 3)
// compiled member node returning call5732 (depth = 2)
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5733 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5734 = alloc_Block(NULL, NULL, "parser", 1808);
  gc_frame_newslot(block5734);
// method "_apply"
  block_savedest(block5734);
  Object closure5735 = createclosure(2, "_apply");
  setclosureframe(closure5735, stackframe);
  addtoclosure(closure5735, var_blocksOK);
  addtoclosure(closure5735, selfslot);
  struct UserObject *uo5735 = (struct UserObject*)block5734;
  uo5735->data[0] = (Object)closure5735;
  Method *meth_meth_parser__apply5735 = addmethod2pos(block5734, "_apply", &meth_parser__apply5735, 0);
  int argcv_meth_parser__apply5735[] = {0};
  meth_meth_parser__apply5735->type = alloc_MethodType(1, argcv_meth_parser__apply5735);
  meth_meth_parser__apply5735->definitionModule = modulename;
  meth_meth_parser__apply5735->definitionLine = 1807;
// compiled block node returning block5734 (depth = 3)
  gc_frame_newslot(block5734);
// starting to compile block node (depth = 3)
  Object block5739 = alloc_Block(NULL, NULL, "parser", 1808);
  gc_frame_newslot(block5739);
// method "_apply"
  block_savedest(block5739);
  Object closure5740 = createclosure(7, "_apply");
  setclosureframe(closure5740, stackframe);
  addtoclosure(closure5740, var_values);
  addtoclosure(closure5740, var_errormessages);
  addtoclosure(closure5740, var_sym);
  addtoclosure(closure5740, var_blocksOK);
  addtoclosure(closure5740, var_lastToken);
  addtoclosure(closure5740, var_part);
  addtoclosure(closure5740, selfslot);
  struct UserObject *uo5740 = (struct UserObject*)block5739;
  uo5740->data[0] = (Object)closure5740;
  Method *meth_meth_parser__apply5740 = addmethod2pos(block5739, "_apply", &meth_parser__apply5740, 0);
  int argcv_meth_parser__apply5740[] = {0};
  meth_meth_parser__apply5740->type = alloc_MethodType(1, argcv_meth_parser__apply5740);
  meth_meth_parser__apply5740->definitionModule = modulename;
  meth_meth_parser__apply5740->definitionLine = 1807;
// compiled block node returning block5739 (depth = 3)
  gc_frame_newslot(block5739);
// call case 4: self request
  params[0] = block5734;
  params[1] = block5739;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6084 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5733);
// compiled call node returning call6084 (depth = 2)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6087 == NULL) {
    strlit6087 = alloc_String("rparen");
    gc_root(strlit6087);
  }
// compiled string node returning strlit6087 (depth = 4)
  int op_slot_right_6086 = gc_frame_newslot(strlit6087);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6089 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6090 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6089);
// compiled call node returning call6090 (depth = 5)
// compiled member node returning call6090 (depth = 4)
  int op_slot_left_6086 = gc_frame_newslot(call6090);
  params[0] = strlit6087;
  partcv[0] = 1;
  Object opresult6091 = callmethod(call6090, "≠", 1, partcv, params);
// compiled op node returning opresult6091 (depth = 3)
  Object if6085 = done;
  if (istrue(opresult6091)) {
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6092 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6093 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6092);
// compiled call node returning call6093 (depth = 4)
// compiled member node returning call6093 (depth = 3)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6094 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6096 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6095);
// compiled call node returning call6096 (depth = 7)
// compiled member node returning call6096 (depth = 6)
  partcv[0] = 0;
  Object call6097 = callmethod(call6096, "new",
    1, partcv, params);
  gc_frame_end(callframe6094);
// compiled call node returning call6097 (depth = 5)
// compiled member node returning call6097 (depth = 4)
  *var_suggestion = call6097;
  if (call6097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6098 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6099 == NULL) {
    strlit6099 = alloc_String(")");
    gc_root(strlit6099);
  }
// compiled string node returning strlit6099 (depth = 4)
  gc_frame_newslot(strlit6099);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6099;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6100 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6098);
// compiled call node returning call6100 (depth = 3)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6101 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6102 == NULL) {
    strlit6102 = alloc_String("a method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6102);
  }
// compiled string node returning strlit6102 (depth = 4)
  gc_frame_newslot(strlit6102);
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6104 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6103);
// compiled call node returning call6104 (depth = 5)
// compiled member node returning call6104 (depth = 4)
  gc_frame_newslot(call6104);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6107 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6106);
// compiled call node returning call6107 (depth = 6)
// compiled member node returning call6107 (depth = 5)
  int op_slot_right_6105 = gc_frame_newslot(call6107);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6110 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6109);
// compiled call node returning call6110 (depth = 6)
// compiled member node returning call6110 (depth = 5)
  int op_slot_left_6105 = gc_frame_newslot(call6110);
  params[0] = call6107;
  partcv[0] = 1;
  Object sum6111 = callmethod(call6110, "+", 1, partcv, params);
// compiled op node returning sum6111 (depth = 4)
  gc_frame_newslot(sum6111);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6102;
  params[1] = call6104;
  params[2] = sum6111;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6112 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6101);
// compiled call node returning call6112 (depth = 3)
    gc_frame_newslot(call6112);
    if6085 = call6112;
  } else {
  }
// compiled if node returning if6085 (depth = 2)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call6116 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe6115);
// compiled call node returning call6116 (depth = 5)
// compiled member node returning call6116 (depth = 4)
  int op_slot_right_6114 = gc_frame_newslot(call6116);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6118 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6119 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6118);
// compiled call node returning call6119 (depth = 5)
// compiled member node returning call6119 (depth = 4)
  int op_slot_left_6114 = gc_frame_newslot(call6119);
  params[0] = call6116;
  partcv[0] = 1;
  Object opresult6120 = callmethod(call6119, "==", 1, partcv, params);
// compiled op node returning opresult6120 (depth = 3)
  Object if6113 = done;
  if (istrue(opresult6120)) {
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6121 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6124 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6123);
// compiled call node returning call6124 (depth = 6)
// compiled member node returning call6124 (depth = 5)
  int op_slot_right_6122 = gc_frame_newslot(call6124);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6127 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6126);
// compiled call node returning call6127 (depth = 6)
// compiled member node returning call6127 (depth = 5)
  int op_slot_left_6122 = gc_frame_newslot(call6127);
  params[0] = call6124;
  partcv[0] = 1;
  Object diff6128 = callmethod(call6127, "-", 1, partcv, params);
// compiled op node returning diff6128 (depth = 4)
  gc_frame_newslot(diff6128);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = diff6128;
  partcv[0] = 1;
  Object call6129 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe6121);
// compiled call node returning call6129 (depth = 3)
    gc_frame_newslot(call6129);
    if6113 = call6129;
  } else {
  }
// compiled if node returning if6113 (depth = 2)
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6130 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6131 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6130);
// compiled call node returning call6131 (depth = 3)
// compiled member node returning call6131 (depth = 2)
  gc_frame_end(frame);
  return call6131;
}
Object meth_parser__apply6148(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6150 = callmethodflags(self, "typeArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6149);
// compiled call node returning call6150 (depth = 7)
// compiled member node returning call6150 (depth = 6)
  gc_frame_end(frame);
  return call6150;
}
Object meth_parser__apply6145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6146 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6147 = alloc_Block(NULL, NULL, "parser", 1922);
  gc_frame_newslot(block6147);
// method "_apply"
  block_savedest(block6147);
  Object closure6148 = createclosure(1, "_apply");
  setclosureframe(closure6148, stackframe);
  addtoclosure(closure6148, selfslot);
  struct UserObject *uo6148 = (struct UserObject*)block6147;
  uo6148->data[0] = (Object)closure6148;
  Method *meth_meth_parser__apply6148 = addmethod2pos(block6147, "_apply", &meth_parser__apply6148, 0);
  int argcv_meth_parser__apply6148[] = {0};
  meth_meth_parser__apply6148->type = alloc_MethodType(1, argcv_meth_parser__apply6148);
  meth_meth_parser__apply6148->definitionModule = modulename;
  meth_meth_parser__apply6148->definitionLine = 1921;
// compiled block node returning block6147 (depth = 5)
  gc_frame_newslot(block6147);
// call case 4: self request
  params[0] = block6147;
  partcv[0] = 1;
  Object call6152 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6146);
// compiled call node returning call6152 (depth = 4)
  gc_frame_end(frame);
  return call6152;
}
Object meth_parser__apply6155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6156 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6157 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6158 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6157);
// compiled call node returning call6158 (depth = 6)
// compiled member node returning call6158 (depth = 5)
  gc_frame_newslot(call6158);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call6158;
  partcv[0] = 1;
  Object call6159 = callmethod(*var_args, "add",
    1, partcv, params);
  gc_frame_end(callframe6156);
// compiled call node returning call6159 (depth = 4)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6162 == NULL) {
    strlit6162 = alloc_String("comma");
    gc_root(strlit6162);
  }
// compiled string node returning strlit6162 (depth = 6)
  int op_slot_right_6161 = gc_frame_newslot(strlit6162);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6165 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6164);
// compiled call node returning call6165 (depth = 7)
// compiled member node returning call6165 (depth = 6)
  int op_slot_left_6161 = gc_frame_newslot(call6165);
  params[0] = strlit6162;
  partcv[0] = 1;
  Object opresult6166 = callmethod(call6165, "==", 1, partcv, params);
// compiled op node returning opresult6166 (depth = 5)
  Object if6160 = done;
  if (istrue(opresult6166)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6168 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6167);
// compiled call node returning call6168 (depth = 6)
// compiled member node returning call6168 (depth = 5)
    gc_frame_newslot(call6168);
    if6160 = call6168;
  } else {
  }
// compiled if node returning if6160 (depth = 4)
  gc_frame_end(frame);
  return if6160;
}
Object meth_parser_typeArgs6132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeArgs (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeArgs");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_startToken = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startToken");
  Object *var_args = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "args");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array6133 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6133 (depth = 3)
  *var_args = array6133;
  if (array6133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6136 == NULL) {
    strlit6136 = alloc_String("lgeneric");
    gc_root(strlit6136);
  }
// compiled string node returning strlit6136 (depth = 4)
  int op_slot_right_6135 = gc_frame_newslot(strlit6136);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6139 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6138);
// compiled call node returning call6139 (depth = 5)
// compiled member node returning call6139 (depth = 4)
  int op_slot_left_6135 = gc_frame_newslot(call6139);
  params[0] = strlit6136;
  partcv[0] = 1;
  Object opresult6140 = callmethod(call6139, "≠", 1, partcv, params);
// compiled op node returning opresult6140 (depth = 3)
  Object if6134 = done;
  if (istrue(opresult6140)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6134 = undefined;
  } else {
  }
// compiled if node returning if6134 (depth = 2)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6142 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6141);
// compiled call node returning call6142 (depth = 3)
// compiled member node returning call6142 (depth = 2)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6143 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6144 = alloc_Block(NULL, NULL, "parser", 1922);
  gc_frame_newslot(block6144);
// method "_apply"
  block_savedest(block6144);
  Object closure6145 = createclosure(1, "_apply");
  setclosureframe(closure6145, stackframe);
  addtoclosure(closure6145, selfslot);
  struct UserObject *uo6145 = (struct UserObject*)block6144;
  uo6145->data[0] = (Object)closure6145;
  Method *meth_meth_parser__apply6145 = addmethod2pos(block6144, "_apply", &meth_parser__apply6145, 0);
  int argcv_meth_parser__apply6145[] = {0};
  meth_meth_parser__apply6145->type = alloc_MethodType(1, argcv_meth_parser__apply6145);
  meth_meth_parser__apply6145->definitionModule = modulename;
  meth_meth_parser__apply6145->definitionLine = 1921;
// compiled block node returning block6144 (depth = 3)
  gc_frame_newslot(block6144);
// starting to compile block node (depth = 3)
  Object block6154 = alloc_Block(NULL, NULL, "parser", 1922);
  gc_frame_newslot(block6154);
// method "_apply"
  block_savedest(block6154);
  Object closure6155 = createclosure(4, "_apply");
  setclosureframe(closure6155, stackframe);
  addtoclosure(closure6155, var_values);
  addtoclosure(closure6155, var_args);
  addtoclosure(closure6155, var_sym);
  addtoclosure(closure6155, selfslot);
  struct UserObject *uo6155 = (struct UserObject*)block6154;
  uo6155->data[0] = (Object)closure6155;
  Method *meth_meth_parser__apply6155 = addmethod2pos(block6154, "_apply", &meth_parser__apply6155, 0);
  int argcv_meth_parser__apply6155[] = {0};
  meth_meth_parser__apply6155->type = alloc_MethodType(1, argcv_meth_parser__apply6155);
  meth_meth_parser__apply6155->definitionModule = modulename;
  meth_meth_parser__apply6155->definitionLine = 1922;
// compiled block node returning block6154 (depth = 3)
  gc_frame_newslot(block6154);
// call case 5: prelude request
  params[0] = block6144;
  params[1] = block6154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6170 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6143);
// compiled call node returning call6170 (depth = 2)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6173 == NULL) {
    strlit6173 = alloc_String("rgeneric");
    gc_root(strlit6173);
  }
// compiled string node returning strlit6173 (depth = 4)
  int op_slot_right_6172 = gc_frame_newslot(strlit6173);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6176 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6175);
// compiled call node returning call6176 (depth = 5)
// compiled member node returning call6176 (depth = 4)
  int op_slot_left_6172 = gc_frame_newslot(call6176);
  params[0] = strlit6173;
  partcv[0] = 1;
  Object opresult6177 = callmethod(call6176, "≠", 1, partcv, params);
// compiled op node returning opresult6177 (depth = 3)
  Object if6171 = done;
  if (istrue(opresult6177)) {
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6178 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6179 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6180 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6179);
// compiled call node returning call6180 (depth = 7)
// compiled member node returning call6180 (depth = 6)
  partcv[0] = 0;
  Object call6181 = callmethod(call6180, "new",
    1, partcv, params);
  gc_frame_end(callframe6178);
// compiled call node returning call6181 (depth = 5)
// compiled member node returning call6181 (depth = 4)
  *var_suggestion = call6181;
  if (call6181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6182 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6183 == NULL) {
    strlit6183 = alloc_String(">");
    gc_root(strlit6183);
  }
// compiled string node returning strlit6183 (depth = 4)
  gc_frame_newslot(strlit6183);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6183;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6184 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6182);
// compiled call node returning call6184 (depth = 3)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6185 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6187 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6186);
// compiled call node returning call6187 (depth = 7)
// compiled member node returning call6187 (depth = 6)
  partcv[0] = 0;
  Object call6188 = callmethod(call6187, "new",
    1, partcv, params);
  gc_frame_end(callframe6185);
// compiled call node returning call6188 (depth = 5)
// compiled member node returning call6188 (depth = 4)
  *var_suggestion2 = call6188;
  if (call6188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6189 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6190 == NULL) {
    strlit6190 = alloc_String(" ");
    gc_root(strlit6190);
  }
// compiled string node returning strlit6190 (depth = 4)
  gc_frame_newslot(strlit6190);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit6190;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6191 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe6189);
// compiled call node returning call6191 (depth = 3)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array6192 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethodflags(array6192, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethodflags(array6192, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6192 (depth = 4)
  *var_suggestions = array6192;
  if (array6192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6193 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6195 == NULL) {
    strlit6195 = alloc_String("If '<' is intended as an operator, precede it by a space.");
    gc_root(strlit6195);
  }
// compiled string node returning strlit6195 (depth = 5)
  int op_slot_right_6194 = gc_frame_newslot(strlit6195);
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6197 == NULL) {
    strlit6197 = alloc_String("a method request containing a '<' must have a matching '>'. ");
    gc_root(strlit6197);
  }
// compiled string node returning strlit6197 (depth = 5)
  int op_slot_left_6194 = gc_frame_newslot(strlit6197);
  params[0] = strlit6195;
  partcv[0] = 1;
  Object opresult6198 = callmethod(strlit6197, "++", 1, partcv, params);
// compiled op node returning opresult6198 (depth = 4)
  gc_frame_newslot(opresult6198);
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6200 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6199);
// compiled call node returning call6200 (depth = 5)
// compiled member node returning call6200 (depth = 4)
  gc_frame_newslot(call6200);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6202 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6203 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6202);
// compiled call node returning call6203 (depth = 6)
// compiled member node returning call6203 (depth = 5)
  int op_slot_right_6201 = gc_frame_newslot(call6203);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6206 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6205);
// compiled call node returning call6206 (depth = 6)
// compiled member node returning call6206 (depth = 5)
  int op_slot_left_6201 = gc_frame_newslot(call6206);
  params[0] = call6203;
  partcv[0] = 1;
  Object sum6207 = callmethod(call6206, "+", 1, partcv, params);
// compiled op node returning sum6207 (depth = 4)
  gc_frame_newslot(sum6207);
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6198;
  params[1] = call6200;
  params[2] = sum6207;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6208 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6193);
// compiled call node returning call6208 (depth = 3)
    gc_frame_newslot(call6208);
    if6171 = call6208;
  } else {
  }
// compiled if node returning if6171 (depth = 2)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6209 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6210 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6209);
// compiled call node returning call6210 (depth = 3)
// compiled member node returning call6210 (depth = 2)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply6238(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6239 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6240 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6239);
// compiled call node returning call6240 (depth = 7)
// compiled member node returning call6240 (depth = 6)
  gc_frame_end(frame);
  return call6240;
}
Object meth_parser_typeArg6211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeArg (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeArg");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6213 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6214 == NULL) {
    strlit6214 = alloc_String("identifier");
    gc_root(strlit6214);
  }
// compiled string node returning strlit6214 (depth = 4)
  gc_frame_newslot(strlit6214);
// call case 4: self request
  params[0] = strlit6214;
  partcv[0] = 1;
  Object call6215 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6213);
// compiled call node returning call6215 (depth = 3)
  Object if6212 = done;
  if (istrue(call6215)) {
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6216 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6217 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6216);
// compiled call node returning call6217 (depth = 4)
// compiled member node returning call6217 (depth = 3)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6220 == NULL) {
    strlit6220 = alloc_String("lgeneric");
    gc_root(strlit6220);
  }
// compiled string node returning strlit6220 (depth = 5)
  int op_slot_right_6219 = gc_frame_newslot(strlit6220);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6223 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6222);
// compiled call node returning call6223 (depth = 6)
// compiled member node returning call6223 (depth = 5)
  int op_slot_left_6219 = gc_frame_newslot(call6223);
  params[0] = strlit6220;
  partcv[0] = 1;
  Object opresult6224 = callmethod(call6223, "==", 1, partcv, params);
// compiled op node returning opresult6224 (depth = 4)
  Object if6218 = done;
  if (istrue(opresult6224)) {
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6225 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe6226 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6228 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6227);
// compiled call node returning call6228 (depth = 7)
// compiled member node returning call6228 (depth = 6)
  gc_frame_newslot(call6228);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6230 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6229);
// compiled call node returning call6230 (depth = 7)
// compiled member node returning call6230 (depth = 6)
  gc_frame_newslot(call6230);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6232 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe6231);
// compiled call node returning call6232 (depth = 7)
// compiled member node returning call6232 (depth = 6)
  params[0] = call6228;
  params[1] = call6230;
  partcv[0] = 2;
  Object call6233 = callmethod(call6232, "new",
    1, partcv, params);
  gc_frame_end(callframe6226);
// compiled call node returning call6233 (depth = 5)
  gc_frame_newslot(call6233);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call6233;
  partcv[0] = 1;
  Object call6234 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6225);
// compiled call node returning call6234 (depth = 4)
    gc_frame_newslot(call6234);
    if6218 = call6234;
  } else {
  }
// compiled if node returning if6218 (depth = 3)
    gc_frame_newslot(if6218);
    if6212 = if6218;
  } else {
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6236 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6237 = alloc_Block(NULL, NULL, "parser", 1952);
  gc_frame_newslot(block6237);
// method "_apply"
  block_savedest(block6237);
  Object closure6238 = createclosure(1, "_apply");
  setclosureframe(closure6238, stackframe);
  addtoclosure(closure6238, selfslot);
  struct UserObject *uo6238 = (struct UserObject*)block6237;
  uo6238->data[0] = (Object)closure6238;
  Method *meth_meth_parser__apply6238 = addmethod2pos(block6237, "_apply", &meth_parser__apply6238, 0);
  int argcv_meth_parser__apply6238[] = {0};
  meth_meth_parser__apply6238->type = alloc_MethodType(1, argcv_meth_parser__apply6238);
  meth_meth_parser__apply6238->definitionModule = modulename;
  meth_meth_parser__apply6238->definitionLine = 1948;
// compiled block node returning block6237 (depth = 5)
  gc_frame_newslot(block6237);
// call case 4: self request
  params[0] = block6237;
  partcv[0] = 1;
  Object call6242 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6236);
// compiled call node returning call6242 (depth = 4)
  Object if6235 = done;
  if (istrue(call6242)) {
    gc_frame_newslot(done);
    if6235 = done;
  } else {
  }
// compiled if node returning if6235 (depth = 3)
    gc_frame_newslot(if6235);
    if6212 = if6235;
  }
// compiled if node returning if6212 (depth = 2)
  gc_frame_end(frame);
  return if6212;
}
Object meth_parser__apply6250(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6252 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6253 == NULL) {
    strlit6253 = alloc_String("identifier");
    gc_root(strlit6253);
  }
// compiled string node returning strlit6253 (depth = 6)
  gc_frame_newslot(strlit6253);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = strlit6253;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6254 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6252);
// compiled call node returning call6254 (depth = 5)
  int op_slot_right_6251 = gc_frame_newslot(call6254);
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6256 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6257 == NULL) {
    strlit6257 = alloc_String("identifier");
    gc_root(strlit6257);
  }
// compiled string node returning strlit6257 (depth = 6)
  gc_frame_newslot(strlit6257);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6257;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6258 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6256);
// compiled call node returning call6258 (depth = 5)
  int op_slot_left_6251 = gc_frame_newslot(call6258);
  params[0] = call6254;
  partcv[0] = 1;
  Object opresult6259 = callmethod(call6258, "||", 1, partcv, params);
// compiled op node returning opresult6259 (depth = 4)
  gc_frame_end(frame);
  return opresult6259;
}
Object meth_parser__apply6415(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6416 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6417 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6416);
// compiled call node returning call6417 (depth = 11)
  gc_frame_end(frame);
  return call6417;
}
Object meth_parser__apply6468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6469 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6470 == NULL) {
    strlit6470 = alloc_String("comma");
    gc_root(strlit6470);
  }
// compiled string node returning strlit6470 (depth = 8)
  gc_frame_newslot(strlit6470);
// call case 4: self request
  params[0] = strlit6470;
  partcv[0] = 1;
  Object call6471 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6469);
// compiled call node returning call6471 (depth = 7)
  gc_frame_end(frame);
  return call6471;
}
Object meth_parser__apply6488(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6489 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6490 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6489);
// compiled call node returning call6490 (depth = 12)
  gc_frame_end(frame);
  return call6490;
}
Object meth_parser__apply6474(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6475 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6476 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6475);
// compiled call node returning call6476 (depth = 9)
// compiled member node returning call6476 (depth = 8)
  *var_nxt = call6476;
  if (call6476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6478 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call6480 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6479);
// compiled call node returning call6480 (depth = 9)
// compiled member node returning call6480 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6481 = callmethod(call6480, "push",
    1, partcv, params);
  gc_frame_end(callframe6478);
// compiled call node returning call6481 (depth = 7)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6482 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6483 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6482);
// compiled call node returning call6483 (depth = 8)
// compiled member node returning call6483 (depth = 7)
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6485 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6486 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6487 = alloc_Block(NULL, NULL, "parser", 2037);
  gc_frame_newslot(block6487);
// method "_apply"
  block_savedest(block6487);
  Object closure6488 = createclosure(2, "_apply");
  setclosureframe(closure6488, stackframe);
  addtoclosure(closure6488, var_blocksOK);
  addtoclosure(closure6488, selfslot);
  struct UserObject *uo6488 = (struct UserObject*)block6487;
  uo6488->data[0] = (Object)closure6488;
  Method *meth_meth_parser__apply6488 = addmethod2pos(block6487, "_apply", &meth_parser__apply6488, 0);
  int argcv_meth_parser__apply6488[] = {0};
  meth_meth_parser__apply6488->type = alloc_MethodType(1, argcv_meth_parser__apply6488);
  meth_meth_parser__apply6488->definitionModule = modulename;
  meth_meth_parser__apply6488->definitionLine = 2037;
// compiled block node returning block6487 (depth = 11)
  gc_frame_newslot(block6487);
// call case 4: self request
  params[0] = block6487;
  partcv[0] = 1;
  Object call6492 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6486);
// compiled call node returning call6492 (depth = 10)
  partcv[0] = 0;
  Object call6493 = callmethod(call6492, "not",
    1, partcv, params);
  gc_frame_end(callframe6485);
// compiled call node returning call6493 (depth = 9)
// compiled member node returning call6493 (depth = 8)
  Object if6484 = done;
  if (istrue(call6493)) {
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array6494 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6494 (depth = 9)
  *var_suggestions = array6494;
  if (array6494 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6495 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6497 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6496);
// compiled call node returning call6497 (depth = 12)
// compiled member node returning call6497 (depth = 11)
  partcv[0] = 0;
  Object call6498 = callmethod(call6497, "new",
    1, partcv, params);
  gc_frame_end(callframe6495);
// compiled call node returning call6498 (depth = 10)
// compiled member node returning call6498 (depth = 9)
  *var_suggestion = call6498;
  if (call6498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6499 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array6500 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit6501 == NULL) {
    strlit6501 = alloc_String("rparen");
    gc_root(strlit6501);
  }
// compiled string node returning strlit6501 (depth = 11)
  params[0] = strlit6501;
  partcv[0] = 1;
  callmethodflags(array6500, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6500 (depth = 10)
  gc_frame_newslot(array6500);
// call case 4: self request
  params[0] = array6500;
  partcv[0] = 1;
  Object call6502 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6499);
// compiled call node returning call6502 (depth = 9)
  *var_nextTok = call6502;
  if (call6502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6504 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6504 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6506 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6506 (depth = 9)
  Object if6503 = done;
  if (istrue(opresult6506)) {
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6507 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6508 == NULL) {
    strlit6508 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6508);
  }
// compiled string node returning strlit6508 (depth = 10)
  gc_frame_newslot(strlit6508);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6508;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6509 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6507);
// compiled call node returning call6509 (depth = 9)
    gc_frame_newslot(call6509);
    if6503 = call6509;
  } else {
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6510 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6512 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6511);
// compiled call node returning call6512 (depth = 11)
// compiled member node returning call6512 (depth = 10)
  gc_frame_newslot(call6512);
// starting to compile identifier node (depth = 10)
  Object bool6513 = alloc_Boolean(1);
// compiled identifier node returning bool6513 (depth = 10)
  gc_frame_newslot(bool6513);
// starting to compile identifier node (depth = 10)
  Object bool6514 = alloc_Boolean(0);
// compiled identifier node returning bool6514 (depth = 10)
  gc_frame_newslot(bool6514);
// starting to compile string node (depth = 10)
  if (strlit6515 == NULL) {
    strlit6515 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6515);
  }
// compiled string node returning strlit6515 (depth = 10)
  gc_frame_newslot(strlit6515);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6512;
  params[2] = bool6513;
  params[3] = bool6514;
  params[4] = strlit6515;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6516 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6510);
// compiled call node returning call6516 (depth = 9)
    gc_frame_newslot(call6516);
    if6503 = call6516;
  }
// compiled if node returning if6503 (depth = 8)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6517 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6518 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6517);
// compiled call node returning call6518 (depth = 8)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6519 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6521 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6520);
// compiled call node returning call6521 (depth = 12)
// compiled member node returning call6521 (depth = 11)
  partcv[0] = 0;
  Object call6522 = callmethod(call6521, "new",
    1, partcv, params);
  gc_frame_end(callframe6519);
// compiled call node returning call6522 (depth = 10)
// compiled member node returning call6522 (depth = 9)
  *var_suggestion = call6522;
  if (call6522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6524 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6526 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6525);
// compiled call node returning call6526 (depth = 10)
// compiled member node returning call6526 (depth = 9)
  gc_frame_newslot(call6526);
// starting to compile identifier node (depth = 9)
  Object bool6527 = alloc_Boolean(1);
// compiled identifier node returning bool6527 (depth = 9)
  gc_frame_newslot(bool6527);
// starting to compile identifier node (depth = 9)
  Object bool6528 = alloc_Boolean(0);
// compiled identifier node returning bool6528 (depth = 9)
  gc_frame_newslot(bool6528);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6526;
  params[2] = bool6527;
  params[3] = bool6528;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6529 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6524);
// compiled call node returning call6529 (depth = 8)
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6530 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6531 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6530);
// compiled call node returning call6531 (depth = 8)
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6532 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6533 == NULL) {
    strlit6533 = alloc_String("a method request must have an expression after a ','.");
    gc_root(strlit6533);
  }
// compiled string node returning strlit6533 (depth = 9)
  gc_frame_newslot(strlit6533);
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6535 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6534);
// compiled call node returning call6535 (depth = 10)
// compiled member node returning call6535 (depth = 9)
  gc_frame_newslot(call6535);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6537 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6536);
// compiled call node returning call6537 (depth = 10)
// compiled member node returning call6537 (depth = 9)
  gc_frame_newslot(call6537);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6533;
  params[1] = call6535;
  params[2] = call6537;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6538 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6532);
// compiled call node returning call6538 (depth = 8)
    gc_frame_newslot(call6538);
    if6484 = call6538;
  } else {
  }
// compiled if node returning if6484 (depth = 7)
  gc_frame_end(frame);
  return if6484;
}
Object meth_parser__apply6262(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_errormessages = getfromclosure(closure, 7);
  Object *var_sym = getfromclosure(closure, 8);
  Object *var_blocksOK = getfromclosure(closure, 9);
  Object self = *(getfromclosure(closure, 10));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// starting to compile bind node (depth = 4)
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6263 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6264 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6265 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6264);
// compiled call node returning call6265 (depth = 8)
// compiled member node returning call6265 (depth = 7)
  partcv[0] = 0;
  Object call6266 = callmethod(call6265, "new",
    1, partcv, params);
  gc_frame_end(callframe6263);
// compiled call node returning call6266 (depth = 6)
// compiled member node returning call6266 (depth = 5)
  *var_part = call6266;
  if (call6266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6268 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6269 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6268);
// compiled call node returning call6269 (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6271 == NULL) {
    strlit6271 = alloc_String("()");
    gc_root(strlit6271);
  }
// compiled string node returning strlit6271 (depth = 6)
  int op_slot_right_6270 = gc_frame_newslot(strlit6271);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6270 = gc_frame_newslot(*var_methname);
  params[0] = strlit6271;
  partcv[0] = 1;
  Object opresult6273 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6273 (depth = 5)
  *var_methname = opresult6273;
  if (opresult6273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6276 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6275);
// compiled call node returning call6276 (depth = 5)
// compiled member node returning call6276 (depth = 4)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6278 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6277);
// compiled call node returning call6278 (depth = 6)
// compiled member node returning call6278 (depth = 5)
  *var_nxt = call6278;
  if (call6278 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6282 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6281);
// compiled call node returning call6282 (depth = 7)
// compiled member node returning call6282 (depth = 6)
  int op_slot_right_6280 = gc_frame_newslot(call6282);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6280 = gc_frame_newslot(*var_methname);
  params[0] = call6282;
  partcv[0] = 1;
  Object opresult6284 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6284 (depth = 5)
  *var_methname = opresult6284;
  if (opresult6284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6286 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  partcv[0] = 0;
  Object call6288 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6287);
// compiled call node returning call6288 (depth = 6)
// compiled member node returning call6288 (depth = 5)
  gc_frame_newslot(call6288);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call6288;
  partcv[0] = 1;
  Object call6289 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6286);
// compiled call node returning call6289 (depth = 4)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6290 = alloc_Boolean(0);
// compiled identifier node returning bool6290 (depth = 5)
  *var_isTerm = bool6290;
  if (bool6290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6292 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6293 == NULL) {
    strlit6293 = alloc_String("lparen");
    gc_root(strlit6293);
  }
// compiled string node returning strlit6293 (depth = 6)
  gc_frame_newslot(strlit6293);
// call case 4: self request
  params[0] = strlit6293;
  partcv[0] = 1;
  Object call6294 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6292);
// compiled call node returning call6294 (depth = 5)
  Object if6291 = done;
  if (istrue(call6294)) {
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6296 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6295);
// compiled call node returning call6296 (depth = 6)
// compiled member node returning call6296 (depth = 5)
    gc_frame_newslot(call6296);
    if6291 = call6296;
  } else {
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6298 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call6299 = callmethodflags(self, "acceptArgumentOnLineOf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6298);
// compiled call node returning call6299 (depth = 6)
  Object if6297 = done;
  if (istrue(call6299)) {
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6300 = alloc_Boolean(1);
// compiled identifier node returning bool6300 (depth = 7)
  *var_isTerm = bool6300;
  if (bool6300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6297 = done;
  } else {
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6302 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6304 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6303);
// compiled call node returning call6304 (depth = 10)
// compiled member node returning call6304 (depth = 9)
  partcv[0] = 0;
  Object call6305 = callmethod(call6304, "new",
    1, partcv, params);
  gc_frame_end(callframe6302);
// compiled call node returning call6305 (depth = 8)
// compiled member node returning call6305 (depth = 7)
  *var_suggestion = call6305;
  if (call6305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6308 == NULL) {
    strlit6308 = alloc_String("identifier");
    gc_root(strlit6308);
  }
// compiled string node returning strlit6308 (depth = 8)
  int op_slot_right_6307 = gc_frame_newslot(strlit6308);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6311 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6310);
// compiled call node returning call6311 (depth = 9)
// compiled member node returning call6311 (depth = 8)
  int op_slot_left_6307 = gc_frame_newslot(call6311);
  params[0] = strlit6308;
  partcv[0] = 1;
  Object opresult6312 = callmethod(call6311, "==", 1, partcv, params);
// compiled op node returning opresult6312 (depth = 7)
  Object if6306 = done;
  if (istrue(opresult6312)) {
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6313 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool6314 = alloc_Boolean(1);
// compiled identifier node returning bool6314 (depth = 8)
  gc_frame_newslot(bool6314);
// starting to compile identifier node (depth = 8)
  Object bool6315 = alloc_Boolean(0);
// compiled identifier node returning bool6315 (depth = 8)
  gc_frame_newslot(bool6315);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6317 == NULL) {
    strlit6317 = alloc_String(")");
    gc_root(strlit6317);
  }
// compiled string node returning strlit6317 (depth = 9)
  int op_slot_right_6316 = gc_frame_newslot(strlit6317);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6320 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6321 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6320);
// compiled call node returning call6321 (depth = 11)
// compiled member node returning call6321 (depth = 10)
  int op_slot_right_6319 = gc_frame_newslot(call6321);
// starting to compile string node (depth = 10)
  if (strlit6323 == NULL) {
    strlit6323 = alloc_String("(");
    gc_root(strlit6323);
  }
// compiled string node returning strlit6323 (depth = 10)
  int op_slot_left_6319 = gc_frame_newslot(strlit6323);
  params[0] = call6321;
  partcv[0] = 1;
  Object opresult6324 = callmethod(strlit6323, "++", 1, partcv, params);
// compiled op node returning opresult6324 (depth = 9)
  int op_slot_left_6316 = gc_frame_newslot(opresult6324);
  params[0] = strlit6317;
  partcv[0] = 1;
  Object opresult6325 = callmethod(opresult6324, "++", 1, partcv, params);
// compiled op node returning opresult6325 (depth = 8)
  gc_frame_newslot(opresult6325);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool6314;
  params[2] = bool6315;
  params[3] = opresult6325;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6326 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6313);
// compiled call node returning call6326 (depth = 7)
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6329 == NULL) {
    strlit6329 = alloc_String("while()do");
    gc_root(strlit6329);
  }
// compiled string node returning strlit6329 (depth = 9)
  int op_slot_right_6328 = gc_frame_newslot(strlit6329);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6328 = gc_frame_newslot(*var_methname);
  params[0] = strlit6329;
  partcv[0] = 1;
  Object opresult6331 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6331 (depth = 8)
  Object if6327 = done;
  if (istrue(opresult6331)) {
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6332 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6333 == NULL) {
    strlit6333 = alloc_String("a while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6333);
  }
// compiled string node returning strlit6333 (depth = 9)
  gc_frame_newslot(strlit6333);
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6334 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6335 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6334);
// compiled call node returning call6335 (depth = 10)
// compiled member node returning call6335 (depth = 9)
  gc_frame_newslot(call6335);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6337 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6336);
// compiled call node returning call6337 (depth = 10)
// compiled member node returning call6337 (depth = 9)
  gc_frame_newslot(call6337);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6333;
  params[1] = call6335;
  params[2] = call6337;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6338 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6332);
// compiled call node returning call6338 (depth = 8)
    gc_frame_newslot(call6338);
    if6327 = call6338;
  } else {
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6341 == NULL) {
    strlit6341 = alloc_String("for()do");
    gc_root(strlit6341);
  }
// compiled string node returning strlit6341 (depth = 10)
  int op_slot_right_6340 = gc_frame_newslot(strlit6341);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6340 = gc_frame_newslot(*var_methname);
  params[0] = strlit6341;
  partcv[0] = 1;
  Object opresult6343 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6343 (depth = 9)
  Object if6339 = done;
  if (istrue(opresult6343)) {
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6344 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6345 == NULL) {
    strlit6345 = alloc_String("a for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6345);
  }
// compiled string node returning strlit6345 (depth = 10)
  gc_frame_newslot(strlit6345);
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6347 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6346);
// compiled call node returning call6347 (depth = 11)
// compiled member node returning call6347 (depth = 10)
  gc_frame_newslot(call6347);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6349 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6348);
// compiled call node returning call6349 (depth = 11)
// compiled member node returning call6349 (depth = 10)
  gc_frame_newslot(call6349);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6345;
  params[1] = call6347;
  params[2] = call6349;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6350 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6344);
// compiled call node returning call6350 (depth = 9)
    gc_frame_newslot(call6350);
    if6339 = call6350;
  } else {
  }
// compiled if node returning if6339 (depth = 8)
    gc_frame_newslot(if6339);
    if6327 = if6339;
  }
// compiled if node returning if6327 (depth = 7)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6351 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6352 == NULL) {
    strlit6352 = alloc_String("each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.");
    gc_root(strlit6352);
  }
// compiled string node returning strlit6352 (depth = 8)
  gc_frame_newslot(strlit6352);
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6353 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6354 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6353);
// compiled call node returning call6354 (depth = 9)
// compiled member node returning call6354 (depth = 8)
  gc_frame_newslot(call6354);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6356 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6355);
// compiled call node returning call6356 (depth = 9)
// compiled member node returning call6356 (depth = 8)
  gc_frame_newslot(call6356);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6352;
  params[1] = call6354;
  params[2] = call6356;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6357 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6351);
// compiled call node returning call6357 (depth = 7)
    gc_frame_newslot(call6357);
    if6306 = call6357;
  } else {
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6360 == NULL) {
    strlit6360 = alloc_String("while()do");
    gc_root(strlit6360);
  }
// compiled string node returning strlit6360 (depth = 9)
  int op_slot_right_6359 = gc_frame_newslot(strlit6360);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6359 = gc_frame_newslot(*var_methname);
  params[0] = strlit6360;
  partcv[0] = 1;
  Object opresult6362 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6362 (depth = 8)
  Object if6358 = done;
  if (istrue(opresult6362)) {
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6363 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6364 == NULL) {
    strlit6364 = alloc_String(" {}");
    gc_root(strlit6364);
  }
// compiled string node returning strlit6364 (depth = 9)
  gc_frame_newslot(strlit6364);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6364;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6365 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6363);
// compiled call node returning call6365 (depth = 8)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6366 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6367 == NULL) {
    strlit6367 = alloc_String("a while loop must have a body.");
    gc_root(strlit6367);
  }
// compiled string node returning strlit6367 (depth = 9)
  gc_frame_newslot(strlit6367);
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6369 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6368);
// compiled call node returning call6369 (depth = 10)
// compiled member node returning call6369 (depth = 9)
  gc_frame_newslot(call6369);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6371 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6370);
// compiled call node returning call6371 (depth = 10)
// compiled member node returning call6371 (depth = 9)
  gc_frame_newslot(call6371);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6367;
  params[1] = call6369;
  params[2] = call6371;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6372 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6366);
// compiled call node returning call6372 (depth = 8)
    gc_frame_newslot(call6372);
    if6358 = call6372;
  } else {
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6375 == NULL) {
    strlit6375 = alloc_String("for()do");
    gc_root(strlit6375);
  }
// compiled string node returning strlit6375 (depth = 10)
  int op_slot_right_6374 = gc_frame_newslot(strlit6375);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_methname (depth = 10)
  int op_slot_left_6374 = gc_frame_newslot(*var_methname);
  params[0] = strlit6375;
  partcv[0] = 1;
  Object opresult6377 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6377 (depth = 9)
  Object if6373 = done;
  if (istrue(opresult6377)) {
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6378 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6379 == NULL) {
    strlit6379 = alloc_String(" {}");
    gc_root(strlit6379);
  }
// compiled string node returning strlit6379 (depth = 10)
  gc_frame_newslot(strlit6379);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6379;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6380 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6378);
// compiled call node returning call6380 (depth = 9)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6381 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6382 == NULL) {
    strlit6382 = alloc_String("a for loop must have a body.");
    gc_root(strlit6382);
  }
// compiled string node returning strlit6382 (depth = 10)
  gc_frame_newslot(strlit6382);
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6383 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6384 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6383);
// compiled call node returning call6384 (depth = 11)
// compiled member node returning call6384 (depth = 10)
  gc_frame_newslot(call6384);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6386 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6385);
// compiled call node returning call6386 (depth = 11)
// compiled member node returning call6386 (depth = 10)
  gc_frame_newslot(call6386);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6382;
  params[1] = call6384;
  params[2] = call6386;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6387 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6381);
// compiled call node returning call6387 (depth = 9)
    gc_frame_newslot(call6387);
    if6373 = call6387;
  } else {
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6388 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6389 == NULL) {
    strlit6389 = alloc_String("()");
    gc_root(strlit6389);
  }
// compiled string node returning strlit6389 (depth = 10)
  gc_frame_newslot(strlit6389);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6389;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6390 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6388);
// compiled call node returning call6390 (depth = 9)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6391 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6392 == NULL) {
    strlit6392 = alloc_String("a multi-part method request must end with '()'.");
    gc_root(strlit6392);
  }
// compiled string node returning strlit6392 (depth = 10)
  gc_frame_newslot(strlit6392);
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6394 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6393);
// compiled call node returning call6394 (depth = 11)
// compiled member node returning call6394 (depth = 10)
  gc_frame_newslot(call6394);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6396 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6395);
// compiled call node returning call6396 (depth = 11)
// compiled member node returning call6396 (depth = 10)
  gc_frame_newslot(call6396);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6392;
  params[1] = call6394;
  params[2] = call6396;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6397 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6391);
// compiled call node returning call6397 (depth = 9)
    gc_frame_newslot(call6397);
    if6373 = call6397;
  }
// compiled if node returning if6373 (depth = 8)
    gc_frame_newslot(if6373);
    if6358 = if6373;
  }
// compiled if node returning if6358 (depth = 7)
    gc_frame_newslot(if6358);
    if6306 = if6358;
  }
// compiled if node returning if6306 (depth = 6)
    gc_frame_newslot(if6306);
    if6297 = if6306;
  }
// compiled if node returning if6297 (depth = 5)
    gc_frame_newslot(if6297);
    if6291 = if6297;
  }
// compiled if node returning if6291 (depth = 4)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6398 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6399 == NULL) {
    strlit6399 = alloc_String("rparen");
    gc_root(strlit6399);
  }
// compiled string node returning strlit6399 (depth = 6)
  gc_frame_newslot(strlit6399);
// call case 4: self request
  params[0] = strlit6399;
  partcv[0] = 1;
  Object call6400 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6398);
// compiled call node returning call6400 (depth = 5)
  *var_isEmpty = call6400;
  if (call6400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isTerm (depth = 5)
  Object if6401 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6403 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6402);
// compiled call node returning call6403 (depth = 6)
// compiled member node returning call6403 (depth = 5)
    gc_frame_newslot(call6403);
    if6401 = call6403;
  } else {
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6406 == NULL) {
    strlit6406 = alloc_String("rparen");
    gc_root(strlit6406);
  }
// compiled string node returning strlit6406 (depth = 7)
  int op_slot_right_6405 = gc_frame_newslot(strlit6406);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6409 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6408);
// compiled call node returning call6409 (depth = 8)
// compiled member node returning call6409 (depth = 7)
  int op_slot_left_6405 = gc_frame_newslot(call6409);
  params[0] = strlit6406;
  partcv[0] = 1;
  Object opresult6410 = callmethod(call6409, "≠", 1, partcv, params);
// compiled op node returning opresult6410 (depth = 6)
  Object if6404 = done;
  if (istrue(opresult6410)) {
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6412 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6413 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6414 = alloc_Block(NULL, NULL, "parser", 2016);
  gc_frame_newslot(block6414);
// method "_apply"
  block_savedest(block6414);
  Object closure6415 = createclosure(2, "_apply");
  setclosureframe(closure6415, stackframe);
  addtoclosure(closure6415, var_blocksOK);
  addtoclosure(closure6415, selfslot);
  struct UserObject *uo6415 = (struct UserObject*)block6414;
  uo6415->data[0] = (Object)closure6415;
  Method *meth_meth_parser__apply6415 = addmethod2pos(block6414, "_apply", &meth_parser__apply6415, 0);
  int argcv_meth_parser__apply6415[] = {0};
  meth_meth_parser__apply6415->type = alloc_MethodType(1, argcv_meth_parser__apply6415);
  meth_meth_parser__apply6415->definitionModule = modulename;
  meth_meth_parser__apply6415->definitionLine = 2016;
// compiled block node returning block6414 (depth = 10)
  gc_frame_newslot(block6414);
// call case 4: self request
  params[0] = block6414;
  partcv[0] = 1;
  Object call6419 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6413);
// compiled call node returning call6419 (depth = 9)
  partcv[0] = 0;
  Object call6420 = callmethod(call6419, "not",
    1, partcv, params);
  gc_frame_end(callframe6412);
// compiled call node returning call6420 (depth = 8)
// compiled member node returning call6420 (depth = 7)
  Object if6411 = done;
  if (istrue(call6420)) {
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array6421 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6421 (depth = 8)
  *var_suggestions = array6421;
  if (array6421 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6422 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6424 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6423);
// compiled call node returning call6424 (depth = 11)
// compiled member node returning call6424 (depth = 10)
  partcv[0] = 0;
  Object call6425 = callmethod(call6424, "new",
    1, partcv, params);
  gc_frame_end(callframe6422);
// compiled call node returning call6425 (depth = 9)
// compiled member node returning call6425 (depth = 8)
  *var_suggestion = call6425;
  if (call6425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6426 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array6427 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit6428 == NULL) {
    strlit6428 = alloc_String("rparen");
    gc_root(strlit6428);
  }
// compiled string node returning strlit6428 (depth = 10)
  params[0] = strlit6428;
  partcv[0] = 1;
  callmethodflags(array6427, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array6427 (depth = 9)
  gc_frame_newslot(array6427);
// call case 4: self request
  params[0] = array6427;
  partcv[0] = 1;
  Object call6429 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6426);
// compiled call node returning call6429 (depth = 8)
  *var_nextTok = call6429;
  if (call6429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6431 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6431 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6433 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6433 (depth = 8)
  Object if6430 = done;
  if (istrue(opresult6433)) {
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6434 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6435 == NULL) {
    strlit6435 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6435);
  }
// compiled string node returning strlit6435 (depth = 9)
  gc_frame_newslot(strlit6435);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6435;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6436 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6434);
// compiled call node returning call6436 (depth = 8)
    gc_frame_newslot(call6436);
    if6430 = call6436;
  } else {
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6437 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6439 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6438);
// compiled call node returning call6439 (depth = 10)
// compiled member node returning call6439 (depth = 9)
  gc_frame_newslot(call6439);
// starting to compile identifier node (depth = 9)
  Object bool6440 = alloc_Boolean(1);
// compiled identifier node returning bool6440 (depth = 9)
  gc_frame_newslot(bool6440);
// starting to compile identifier node (depth = 9)
  Object bool6441 = alloc_Boolean(0);
// compiled identifier node returning bool6441 (depth = 9)
  gc_frame_newslot(bool6441);
// starting to compile string node (depth = 9)
  if (strlit6442 == NULL) {
    strlit6442 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6442);
  }
// compiled string node returning strlit6442 (depth = 9)
  gc_frame_newslot(strlit6442);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6439;
  params[2] = bool6440;
  params[3] = bool6441;
  params[4] = strlit6442;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6443 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6437);
// compiled call node returning call6443 (depth = 8)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6444 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6445 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6444);
// compiled call node returning call6445 (depth = 8)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6446 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6448 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6447);
// compiled call node returning call6448 (depth = 12)
// compiled member node returning call6448 (depth = 11)
  partcv[0] = 0;
  Object call6449 = callmethod(call6448, "new",
    1, partcv, params);
  gc_frame_end(callframe6446);
// compiled call node returning call6449 (depth = 10)
// compiled member node returning call6449 (depth = 9)
  *var_suggestion = call6449;
  if (call6449 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6451 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6453 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6452);
// compiled call node returning call6453 (depth = 10)
// compiled member node returning call6453 (depth = 9)
  gc_frame_newslot(call6453);
// starting to compile identifier node (depth = 9)
  Object bool6454 = alloc_Boolean(1);
// compiled identifier node returning bool6454 (depth = 9)
  gc_frame_newslot(bool6454);
// starting to compile identifier node (depth = 9)
  Object bool6455 = alloc_Boolean(0);
// compiled identifier node returning bool6455 (depth = 9)
  gc_frame_newslot(bool6455);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6453;
  params[2] = bool6454;
  params[3] = bool6455;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6456 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6451);
// compiled call node returning call6456 (depth = 8)
    gc_frame_newslot(call6456);
    if6430 = call6456;
  }
// compiled if node returning if6430 (depth = 7)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6457 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6458 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6457);
// compiled call node returning call6458 (depth = 7)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6459 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6460 == NULL) {
    strlit6460 = alloc_String("a method request must have an expression or a ')' after a '('.");
    gc_root(strlit6460);
  }
// compiled string node returning strlit6460 (depth = 8)
  gc_frame_newslot(strlit6460);
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6462 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6461);
// compiled call node returning call6462 (depth = 9)
// compiled member node returning call6462 (depth = 8)
  gc_frame_newslot(call6462);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6464 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6463);
// compiled call node returning call6464 (depth = 9)
// compiled member node returning call6464 (depth = 8)
  gc_frame_newslot(call6464);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6460;
  params[1] = call6462;
  params[2] = call6464;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6465 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6459);
// compiled call node returning call6465 (depth = 7)
    gc_frame_newslot(call6465);
    if6411 = call6465;
  } else {
  }
// compiled if node returning if6411 (depth = 6)
    gc_frame_newslot(if6411);
    if6404 = if6411;
  } else {
  }
// compiled if node returning if6404 (depth = 5)
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6466 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6467 = alloc_Block(NULL, NULL, "parser", 2033);
  gc_frame_newslot(block6467);
// method "_apply"
  block_savedest(block6467);
  Object closure6468 = createclosure(1, "_apply");
  setclosureframe(closure6468, stackframe);
  addtoclosure(closure6468, selfslot);
  struct UserObject *uo6468 = (struct UserObject*)block6467;
  uo6468->data[0] = (Object)closure6468;
  Method *meth_meth_parser__apply6468 = addmethod2pos(block6467, "_apply", &meth_parser__apply6468, 0);
  int argcv_meth_parser__apply6468[] = {0};
  meth_meth_parser__apply6468->type = alloc_MethodType(1, argcv_meth_parser__apply6468);
  meth_meth_parser__apply6468->definitionModule = modulename;
  meth_meth_parser__apply6468->definitionLine = 2030;
// compiled block node returning block6467 (depth = 6)
  gc_frame_newslot(block6467);
// starting to compile block node (depth = 6)
  Object block6473 = alloc_Block(NULL, NULL, "parser", 2033);
  gc_frame_newslot(block6473);
// method "_apply"
  block_savedest(block6473);
  Object closure6474 = createclosure(8, "_apply");
  setclosureframe(closure6474, stackframe);
  addtoclosure(closure6474, var_values);
  addtoclosure(closure6474, var_nxt);
  addtoclosure(closure6474, var_part);
  addtoclosure(closure6474, var_blocksOK);
  addtoclosure(closure6474, var_errormessages);
  addtoclosure(closure6474, var_sym);
  addtoclosure(closure6474, var_lastToken);
  addtoclosure(closure6474, selfslot);
  struct UserObject *uo6474 = (struct UserObject*)block6473;
  uo6474->data[0] = (Object)closure6474;
  Method *meth_meth_parser__apply6474 = addmethod2pos(block6473, "_apply", &meth_parser__apply6474, 0);
  int argcv_meth_parser__apply6474[] = {0};
  meth_meth_parser__apply6474->type = alloc_MethodType(1, argcv_meth_parser__apply6474);
  meth_meth_parser__apply6474->definitionModule = modulename;
  meth_meth_parser__apply6474->definitionLine = 2030;
// compiled block node returning block6473 (depth = 6)
  gc_frame_newslot(block6473);
// call case 5: prelude request
  params[0] = block6467;
  params[1] = block6473;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6540 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6466);
// compiled call node returning call6540 (depth = 5)
    gc_frame_newslot(call6540);
    if6401 = call6540;
  }
// compiled if node returning if6401 (depth = 4)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isEmpty (depth = 6)
  partcv[0] = 0;
  Object call6543 = callmethod(*var_isEmpty, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe6542);
// compiled call node returning call6543 (depth = 5)
  Object if6541 = done;
  if (istrue(call6543)) {
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6545 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6544);
// compiled call node returning call6545 (depth = 7)
// compiled member node returning call6545 (depth = 6)
  *var_nxt = call6545;
  if (call6545 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6547 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6549 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6548);
// compiled call node returning call6549 (depth = 7)
// compiled member node returning call6549 (depth = 6)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6550 = callmethod(call6549, "push",
    1, partcv, params);
  gc_frame_end(callframe6547);
// compiled call node returning call6550 (depth = 5)
    gc_frame_newslot(call6550);
    if6541 = call6550;
  } else {
  }
// compiled if node returning if6541 (depth = 4)
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_isTerm (depth = 7)
  partcv[0] = 0;
  Object call6553 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe6552);
// compiled call node returning call6553 (depth = 6)
// compiled member node returning call6553 (depth = 5)
  Object if6551 = done;
  if (istrue(call6553)) {
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6556 == NULL) {
    strlit6556 = alloc_String("rparen");
    gc_root(strlit6556);
  }
// compiled string node returning strlit6556 (depth = 7)
  int op_slot_right_6555 = gc_frame_newslot(strlit6556);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6558 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6559 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6558);
// compiled call node returning call6559 (depth = 8)
// compiled member node returning call6559 (depth = 7)
  int op_slot_left_6555 = gc_frame_newslot(call6559);
  params[0] = strlit6556;
  partcv[0] = 1;
  Object opresult6560 = callmethod(call6559, "≠", 1, partcv, params);
// compiled op node returning opresult6560 (depth = 6)
  Object if6554 = done;
  if (istrue(opresult6560)) {
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6561 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6562 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6561);
// compiled call node returning call6562 (depth = 7)
// compiled member node returning call6562 (depth = 6)
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6563 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6564 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6565 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6564);
// compiled call node returning call6565 (depth = 10)
// compiled member node returning call6565 (depth = 9)
  partcv[0] = 0;
  Object call6566 = callmethod(call6565, "new",
    1, partcv, params);
  gc_frame_end(callframe6563);
// compiled call node returning call6566 (depth = 8)
// compiled member node returning call6566 (depth = 7)
  *var_suggestion = call6566;
  if (call6566 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6567 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6568 == NULL) {
    strlit6568 = alloc_String(")");
    gc_root(strlit6568);
  }
// compiled string node returning strlit6568 (depth = 7)
  gc_frame_newslot(strlit6568);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6568;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6569 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6567);
// compiled call node returning call6569 (depth = 6)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6570 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6571 == NULL) {
    strlit6571 = alloc_String("a part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6571);
  }
// compiled string node returning strlit6571 (depth = 7)
  gc_frame_newslot(strlit6571);
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6573 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6572);
// compiled call node returning call6573 (depth = 8)
// compiled member node returning call6573 (depth = 7)
  gc_frame_newslot(call6573);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6575 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call6576 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6575);
// compiled call node returning call6576 (depth = 9)
// compiled member node returning call6576 (depth = 8)
  int op_slot_right_6574 = gc_frame_newslot(call6576);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6578 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call6579 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6578);
// compiled call node returning call6579 (depth = 9)
// compiled member node returning call6579 (depth = 8)
  int op_slot_left_6574 = gc_frame_newslot(call6579);
  params[0] = call6576;
  partcv[0] = 1;
  Object sum6580 = callmethod(call6579, "+", 1, partcv, params);
// compiled op node returning sum6580 (depth = 7)
  gc_frame_newslot(sum6580);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6571;
  params[1] = call6573;
  params[2] = sum6580;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6581 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6570);
// compiled call node returning call6581 (depth = 6)
    gc_frame_newslot(call6581);
    if6554 = call6581;
  } else {
  }
// compiled if node returning if6554 (depth = 5)
    gc_frame_newslot(if6554);
    if6551 = if6554;
  } else {
  }
// compiled if node returning if6551 (depth = 4)
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isTerm (depth = 8)
  partcv[0] = 0;
  Object call6585 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe6584);
// compiled call node returning call6585 (depth = 7)
// compiled member node returning call6585 (depth = 6)
  int op_slot_right_6583 = gc_frame_newslot(call6585);
// starting to compile call node (depth = 6)
  int callframe6587 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6588 == NULL) {
    strlit6588 = alloc_String("rparen");
    gc_root(strlit6588);
  }
// compiled string node returning strlit6588 (depth = 7)
  gc_frame_newslot(strlit6588);
// call case 4: self request
  params[0] = strlit6588;
  partcv[0] = 1;
  Object call6589 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6587);
// compiled call node returning call6589 (depth = 6)
  int op_slot_left_6583 = gc_frame_newslot(call6589);
  params[0] = call6585;
  partcv[0] = 1;
  Object opresult6590 = callmethod(call6589, "&&", 1, partcv, params);
// compiled op node returning opresult6590 (depth = 5)
  Object if6582 = done;
  if (istrue(opresult6590)) {
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6592 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6591);
// compiled call node returning call6592 (depth = 6)
// compiled member node returning call6592 (depth = 5)
    gc_frame_newslot(call6592);
    if6582 = call6592;
  } else {
  }
// compiled if node returning if6582 (depth = 4)
  gc_frame_end(frame);
  return if6582;
}
Object meth_parser_callmprest6243(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method callmprest");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for callmprest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for callmprest");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_lp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lp");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_meth_39_ = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "meth'");
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6245 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6244);
// compiled call node returning call6245 (depth = 4)
// compiled member node returning call6245 (depth = 3)
  *var_methname = call6245;
  if (call6245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6246 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6247 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6246);
// compiled call node returning call6247 (depth = 4)
// compiled member node returning call6247 (depth = 3)
  *var_lp = call6247;
  if (call6247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_part = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6248 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6249 = alloc_Block(NULL, NULL, "parser", 1966);
  gc_frame_newslot(block6249);
// method "_apply"
  block_savedest(block6249);
  Object closure6250 = createclosure(3, "_apply");
  setclosureframe(closure6250, stackframe);
  addtoclosure(closure6250, var_lastToken);
  addtoclosure(closure6250, var_tok);
  addtoclosure(closure6250, selfslot);
  struct UserObject *uo6250 = (struct UserObject*)block6249;
  uo6250->data[0] = (Object)closure6250;
  Method *meth_meth_parser__apply6250 = addmethod2pos(block6249, "_apply", &meth_parser__apply6250, 0);
  int argcv_meth_parser__apply6250[] = {0};
  meth_meth_parser__apply6250->type = alloc_MethodType(1, argcv_meth_parser__apply6250);
  meth_meth_parser__apply6250->definitionModule = modulename;
  meth_meth_parser__apply6250->definitionLine = 1964;
// compiled block node returning block6249 (depth = 3)
  gc_frame_newslot(block6249);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6261 = alloc_Block(NULL, NULL, "parser", 1967);
  gc_frame_newslot(block6261);
// method "_apply"
  block_savedest(block6261);
  Object closure6262 = createclosure(11, "_apply");
  setclosureframe(closure6262, stackframe);
  addtoclosure(closure6262, var_ast);
  addtoclosure(closure6262, var_part);
  addtoclosure(closure6262, var_signature);
  addtoclosure(closure6262, var_methname);
  addtoclosure(closure6262, var_values);
  addtoclosure(closure6262, var_nxt);
  addtoclosure(closure6262, var_lastToken);
  addtoclosure(closure6262, var_errormessages);
  addtoclosure(closure6262, var_sym);
  addtoclosure(closure6262, var_blocksOK);
  addtoclosure(closure6262, selfslot);
  struct UserObject *uo6262 = (struct UserObject*)block6261;
  uo6262->data[0] = (Object)closure6262;
  Method *meth_meth_parser__apply6262 = addmethod2pos(block6261, "_apply", &meth_parser__apply6262, 0);
  int argcv_meth_parser__apply6262[] = {0};
  meth_meth_parser__apply6262->type = alloc_MethodType(1, argcv_meth_parser__apply6262);
  meth_meth_parser__apply6262->definitionModule = modulename;
  meth_meth_parser__apply6262->definitionLine = 1964;
// compiled block node returning block6261 (depth = 3)
  gc_frame_newslot(block6261);
// call case 5: prelude request
  params[0] = block6249;
  params[1] = block6261;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6594 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6248);
// compiled call node returning call6594 (depth = 2)
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6595 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool6596 = alloc_Boolean(0);
// compiled identifier node returning bool6596 (depth = 4)
  gc_frame_newslot(bool6596);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call6598 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe6597);
// compiled call node returning call6598 (depth = 5)
// compiled member node returning call6598 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool6596;
  partcv[0] = 2;
  Object call6599 = callmethod(call6598, "new",
    1, partcv, params);
  gc_frame_end(callframe6595);
// compiled call node returning call6599 (depth = 3)
  *var_meth_39_ = call6599;
  if (call6599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6600 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6601 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6602 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe6601);
// compiled call node returning call6602 (depth = 4)
// compiled member node returning call6602 (depth = 3)
  gc_frame_newslot(call6602);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6602;
  partcv[0] = 1;
  Object call6603 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6600);
// compiled call node returning call6603 (depth = 2)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6604 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6606 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6605);
// compiled call node returning call6606 (depth = 4)
// compiled member node returning call6606 (depth = 3)
  gc_frame_newslot(call6606);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth_39_ (depth = 3)
  params[0] = call6606;
  partcv[0] = 1;
  Object call6607 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6604);
// compiled call node returning call6607 (depth = 2)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth_39_ (depth = 2)
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply6632(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6636 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6635);
// compiled call node returning call6636 (depth = 10)
// compiled member node returning call6636 (depth = 9)
  int op_slot_right_6634 = gc_frame_newslot(call6636);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call6639 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe6638);
// compiled call node returning call6639 (depth = 10)
// compiled member node returning call6639 (depth = 9)
  int op_slot_left_6634 = gc_frame_newslot(call6639);
  params[0] = call6636;
  partcv[0] = 1;
  Object opresult6640 = callmethod(call6639, "==", 1, partcv, params);
// compiled op node returning opresult6640 (depth = 8)
  int op_slot_right_6633 = gc_frame_newslot(opresult6640);
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6644 == NULL) {
    strlit6644 = alloc_String("=");
    gc_root(strlit6644);
  }
// compiled string node returning strlit6644 (depth = 10)
  int op_slot_right_6643 = gc_frame_newslot(strlit6644);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call6647 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe6646);
// compiled call node returning call6647 (depth = 11)
// compiled member node returning call6647 (depth = 10)
  int op_slot_left_6643 = gc_frame_newslot(call6647);
  params[0] = strlit6644;
  partcv[0] = 1;
  Object opresult6648 = callmethod(call6647, "==", 1, partcv, params);
// compiled op node returning opresult6648 (depth = 9)
  int op_slot_right_6642 = gc_frame_newslot(opresult6648);
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6651 == NULL) {
    strlit6651 = alloc_String("op");
    gc_root(strlit6651);
  }
// compiled string node returning strlit6651 (depth = 10)
  int op_slot_right_6650 = gc_frame_newslot(strlit6651);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call6654 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe6653);
// compiled call node returning call6654 (depth = 11)
// compiled member node returning call6654 (depth = 10)
  int op_slot_left_6650 = gc_frame_newslot(call6654);
  params[0] = strlit6651;
  partcv[0] = 1;
  Object opresult6655 = callmethod(call6654, "==", 1, partcv, params);
// compiled op node returning opresult6655 (depth = 9)
  int op_slot_left_6642 = gc_frame_newslot(opresult6655);
  params[0] = opresult6648;
  partcv[0] = 1;
  Object opresult6656 = callmethod(opresult6655, "&&", 1, partcv, params);
// compiled op node returning opresult6656 (depth = 8)
  int op_slot_left_6633 = gc_frame_newslot(opresult6656);
  params[0] = opresult6640;
  partcv[0] = 1;
  Object opresult6657 = callmethod(opresult6656, "&&", 1, partcv, params);
// compiled op node returning opresult6657 (depth = 7)
  gc_frame_end(frame);
  return opresult6657;
}
Object meth_parser__apply6724(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe6725 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6726 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6725);
// compiled call node returning call6726 (depth = 9)
  gc_frame_end(frame);
  return call6726;
}
Object meth_parser_defdec6608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for defdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for defdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6610 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6611 == NULL) {
    strlit6611 = alloc_String("def");
    gc_root(strlit6611);
  }
// compiled string node returning strlit6611 (depth = 4)
  gc_frame_newslot(strlit6611);
// call case 4: self request
  params[0] = strlit6611;
  partcv[0] = 1;
  Object call6612 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6610);
// compiled call node returning call6612 (depth = 3)
  Object if6609 = done;
  if (istrue(call6612)) {
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6613 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6614 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6613);
// compiled call node returning call6614 (depth = 5)
// compiled member node returning call6614 (depth = 4)
  *var_line = call6614;
  if (call6614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6616 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6615);
// compiled call node returning call6616 (depth = 5)
// compiled member node returning call6616 (depth = 4)
  *var_pos = call6616;
  if (call6616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6617 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6618 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6617);
// compiled call node returning call6618 (depth = 4)
// compiled member node returning call6618 (depth = 3)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6621 == NULL) {
    strlit6621 = alloc_String("identifier");
    gc_root(strlit6621);
  }
// compiled string node returning strlit6621 (depth = 5)
  int op_slot_right_6620 = gc_frame_newslot(strlit6621);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6624 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6623);
// compiled call node returning call6624 (depth = 6)
// compiled member node returning call6624 (depth = 5)
  int op_slot_left_6620 = gc_frame_newslot(call6624);
  params[0] = strlit6621;
  partcv[0] = 1;
  Object opresult6625 = callmethod(call6624, "≠", 1, partcv, params);
// compiled op node returning opresult6625 (depth = 4)
  Object if6619 = done;
  if (istrue(opresult6625)) {
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6626 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call6628 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6627);
// compiled call node returning call6628 (depth = 8)
// compiled member node returning call6628 (depth = 7)
  partcv[0] = 0;
  Object call6629 = callmethod(call6628, "new",
    1, partcv, params);
  gc_frame_end(callframe6626);
// compiled call node returning call6629 (depth = 6)
// compiled member node returning call6629 (depth = 5)
  *var_suggestion = call6629;
  if (call6629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6630 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6631 = alloc_Block(NULL, NULL, "parser", 2087);
  gc_frame_newslot(block6631);
// method "_apply"
  block_savedest(block6631);
  Object closure6632 = createclosure(2, "_apply");
  setclosureframe(closure6632, stackframe);
  addtoclosure(closure6632, var_sym);
  addtoclosure(closure6632, selfslot);
  struct UserObject *uo6632 = (struct UserObject*)block6631;
  uo6632->data[0] = (Object)closure6632;
  Method *meth_meth_parser__apply6632 = addmethod2pos(block6631, "_apply", &meth_parser__apply6632, 0);
  int argcv_meth_parser__apply6632[] = {1};
  meth_meth_parser__apply6632->type = alloc_MethodType(1, argcv_meth_parser__apply6632);
  meth_meth_parser__apply6632->definitionModule = modulename;
  meth_meth_parser__apply6632->definitionLine = 2086;
// compiled block node returning block6631 (depth = 6)
  gc_frame_newslot(block6631);
// call case 4: self request
  params[0] = block6631;
  partcv[0] = 1;
  Object call6659 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6630);
// compiled call node returning call6659 (depth = 5)
  *var_nextToken = call6659;
  if (call6659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  int op_slot_right_6661 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 6)
  Object bool6663 = alloc_Boolean(0);
// compiled identifier node returning bool6663 (depth = 6)
  int op_slot_left_6661 = gc_frame_newslot(bool6663);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult6664 = callmethod(bool6663, "==", 1, partcv, params);
// compiled op node returning opresult6664 (depth = 5)
  Object if6660 = done;
  if (istrue(opresult6664)) {
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6665 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6666 == NULL) {
    strlit6666 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit6666);
  }
// compiled string node returning strlit6666 (depth = 6)
  gc_frame_newslot(strlit6666);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6666;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6667 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6665);
// compiled call node returning call6667 (depth = 5)
    gc_frame_newslot(call6667);
    if6660 = call6667;
  } else {
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6669 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_6669 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6671 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult6671 (depth = 6)
  Object if6668 = done;
  if (istrue(opresult6671)) {
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6672 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6673 == NULL) {
    strlit6673 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit6673);
  }
// compiled string node returning strlit6673 (depth = 7)
  gc_frame_newslot(strlit6673);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6673;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6674 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6672);
// compiled call node returning call6674 (depth = 6)
    gc_frame_newslot(call6674);
    if6668 = call6674;
  } else {
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6675 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextToken (depth = 9)
  partcv[0] = 0;
  Object call6677 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe6676);
// compiled call node returning call6677 (depth = 8)
// compiled member node returning call6677 (depth = 7)
  gc_frame_newslot(call6677);
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6678 = alloc_Boolean(0);
// compiled identifier node returning bool6678 (depth = 7)
  gc_frame_newslot(bool6678);
// starting to compile identifier node (depth = 7)
  Object bool6679 = alloc_Boolean(1);
// compiled identifier node returning bool6679 (depth = 7)
  gc_frame_newslot(bool6679);
// starting to compile string node (depth = 7)
  if (strlit6680 == NULL) {
    strlit6680 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit6680);
  }
// compiled string node returning strlit6680 (depth = 7)
  gc_frame_newslot(strlit6680);
// call case 6: other member request
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6677;
  params[2] = bool6678;
  params[3] = bool6679;
  params[4] = strlit6680;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6681 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6675);
// compiled call node returning call6681 (depth = 6)
    gc_frame_newslot(call6681);
    if6668 = call6681;
  }
// compiled if node returning if6668 (depth = 5)
    gc_frame_newslot(if6668);
    if6660 = if6668;
  }
// compiled if node returning if6660 (depth = 4)
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6682 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6684 == NULL) {
    strlit6684 = alloc_String("and a value after the 'def'.");
    gc_root(strlit6684);
  }
// compiled string node returning strlit6684 (depth = 6)
  int op_slot_right_6683 = gc_frame_newslot(strlit6684);
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6686 == NULL) {
    strlit6686 = alloc_String("a definition must have a name, '=', ");
    gc_root(strlit6686);
  }
// compiled string node returning strlit6686 (depth = 6)
  int op_slot_left_6683 = gc_frame_newslot(strlit6686);
  params[0] = strlit6684;
  partcv[0] = 1;
  Object opresult6687 = callmethod(strlit6686, "++", 1, partcv, params);
// compiled op node returning opresult6687 (depth = 5)
  gc_frame_newslot(opresult6687);
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6689 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6688);
// compiled call node returning call6689 (depth = 6)
// compiled member node returning call6689 (depth = 5)
  gc_frame_newslot(call6689);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6691 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6690);
// compiled call node returning call6691 (depth = 6)
// compiled member node returning call6691 (depth = 5)
  gc_frame_newslot(call6691);
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = opresult6687;
  params[1] = call6689;
  params[2] = call6691;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6692 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6682);
// compiled call node returning call6692 (depth = 4)
    gc_frame_newslot(call6692);
    if6619 = call6692;
  } else {
  }
// compiled if node returning if6619 (depth = 3)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6693 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6694 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6693);
// compiled call node returning call6694 (depth = 4)
// compiled member node returning call6694 (depth = 3)
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6695 = alloc_Boolean(0);
// compiled identifier node returning bool6695 (depth = 4)
  *var_val = bool6695;
  if (bool6695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6697 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6696);
// compiled call node returning call6697 (depth = 5)
// compiled member node returning call6697 (depth = 4)
  *var_name = call6697;
  if (call6697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6698 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6699 = alloc_Boolean(1);
// compiled identifier node returning bool6699 (depth = 4)
  gc_frame_newslot(bool6699);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool6699;
  partcv[0] = 1;
  Object call6700 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe6698);
// compiled call node returning call6700 (depth = 3)
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6701 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6702 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6701);
// compiled call node returning call6702 (depth = 5)
// compiled member node returning call6702 (depth = 4)
  *var_dtype = call6702;
  if (call6702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2106
  setline(2106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6703 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6704 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6703);
// compiled call node returning call6704 (depth = 5)
// compiled member node returning call6704 (depth = 4)
  *var_anns = call6704;
  if (call6704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6708 == NULL) {
    strlit6708 = alloc_String("=");
    gc_root(strlit6708);
  }
// compiled string node returning strlit6708 (depth = 6)
  int op_slot_right_6707 = gc_frame_newslot(strlit6708);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6711 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6710);
// compiled call node returning call6711 (depth = 7)
// compiled member node returning call6711 (depth = 6)
  int op_slot_left_6707 = gc_frame_newslot(call6711);
  params[0] = strlit6708;
  partcv[0] = 1;
  Object opresult6712 = callmethod(call6711, "==", 1, partcv, params);
// compiled op node returning opresult6712 (depth = 5)
  int op_slot_right_6706 = gc_frame_newslot(opresult6712);
// starting to compile call node (depth = 5)
  int callframe6714 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6715 == NULL) {
    strlit6715 = alloc_String("op");
    gc_root(strlit6715);
  }
// compiled string node returning strlit6715 (depth = 6)
  gc_frame_newslot(strlit6715);
// call case 4: self request
  params[0] = strlit6715;
  partcv[0] = 1;
  Object call6716 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6714);
// compiled call node returning call6716 (depth = 5)
  int op_slot_left_6706 = gc_frame_newslot(call6716);
  params[0] = opresult6712;
  partcv[0] = 1;
  Object opresult6717 = callmethod(call6716, "&&", 1, partcv, params);
// compiled op node returning opresult6717 (depth = 4)
  Object if6705 = done;
  if (istrue(opresult6717)) {
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6718 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6719 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6718);
// compiled call node returning call6719 (depth = 5)
// compiled member node returning call6719 (depth = 4)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6721 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe6722 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6723 = alloc_Block(NULL, NULL, "parser", 2109);
  gc_frame_newslot(block6723);
// method "_apply"
  block_savedest(block6723);
  Object closure6724 = createclosure(2, "_apply");
  setclosureframe(closure6724, stackframe);
  addtoclosure(closure6724, var_blocksOK);
  addtoclosure(closure6724, selfslot);
  struct UserObject *uo6724 = (struct UserObject*)block6723;
  uo6724->data[0] = (Object)closure6724;
  Method *meth_meth_parser__apply6724 = addmethod2pos(block6723, "_apply", &meth_parser__apply6724, 0);
  int argcv_meth_parser__apply6724[] = {0};
  meth_meth_parser__apply6724->type = alloc_MethodType(1, argcv_meth_parser__apply6724);
  meth_meth_parser__apply6724->definitionModule = modulename;
  meth_meth_parser__apply6724->definitionLine = 2109;
// compiled block node returning block6723 (depth = 8)
  gc_frame_newslot(block6723);
// call case 4: self request
  params[0] = block6723;
  partcv[0] = 1;
  Object call6728 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6722);
// compiled call node returning call6728 (depth = 7)
  partcv[0] = 0;
  Object call6729 = callmethod(call6728, "not",
    1, partcv, params);
  gc_frame_end(callframe6721);
// compiled call node returning call6729 (depth = 6)
// compiled member node returning call6729 (depth = 5)
  Object if6720 = done;
  if (istrue(call6729)) {
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6730 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6732 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6731);
// compiled call node returning call6732 (depth = 9)
// compiled member node returning call6732 (depth = 8)
  partcv[0] = 0;
  Object call6733 = callmethod(call6732, "new",
    1, partcv, params);
  gc_frame_end(callframe6730);
// compiled call node returning call6733 (depth = 7)
// compiled member node returning call6733 (depth = 6)
  *var_suggestion = call6733;
  if (call6733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6734 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array6735 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6735 (depth = 7)
  gc_frame_newslot(array6735);
// call case 4: self request
  params[0] = array6735;
  partcv[0] = 1;
  Object call6736 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6734);
// compiled call node returning call6736 (depth = 6)
  *var_nextTok = call6736;
  if (call6736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6738 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_6738 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6740 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6740 (depth = 6)
  Object if6737 = done;
  if (istrue(opresult6740)) {
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6741 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6742 == NULL) {
    strlit6742 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6742);
  }
// compiled string node returning strlit6742 (depth = 7)
  gc_frame_newslot(strlit6742);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6742;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6743 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6741);
// compiled call node returning call6743 (depth = 6)
    gc_frame_newslot(call6743);
    if6737 = call6743;
  } else {
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6744 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6746 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6745);
// compiled call node returning call6746 (depth = 8)
// compiled member node returning call6746 (depth = 7)
  gc_frame_newslot(call6746);
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6747 = alloc_Boolean(1);
// compiled identifier node returning bool6747 (depth = 7)
  gc_frame_newslot(bool6747);
// starting to compile identifier node (depth = 7)
  Object bool6748 = alloc_Boolean(0);
// compiled identifier node returning bool6748 (depth = 7)
  gc_frame_newslot(bool6748);
// starting to compile string node (depth = 7)
  if (strlit6749 == NULL) {
    strlit6749 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6749);
  }
// compiled string node returning strlit6749 (depth = 7)
  gc_frame_newslot(strlit6749);
// call case 6: other member request
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6746;
  params[2] = bool6747;
  params[3] = bool6748;
  params[4] = strlit6749;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6750 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6744);
// compiled call node returning call6750 (depth = 6)
    gc_frame_newslot(call6750);
    if6737 = call6750;
  }
// compiled if node returning if6737 (depth = 5)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6751 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6752 == NULL) {
    strlit6752 = alloc_String("a definition must have a value after the '='.");
    gc_root(strlit6752);
  }
// compiled string node returning strlit6752 (depth = 6)
  gc_frame_newslot(strlit6752);
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call6754 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6753);
// compiled call node returning call6754 (depth = 7)
// compiled member node returning call6754 (depth = 6)
  gc_frame_newslot(call6754);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6757 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6756);
// compiled call node returning call6757 (depth = 8)
// compiled member node returning call6757 (depth = 7)
  int op_slot_right_6755 = gc_frame_newslot(call6757);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6759 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call6760 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6759);
// compiled call node returning call6760 (depth = 8)
// compiled member node returning call6760 (depth = 7)
  int op_slot_left_6755 = gc_frame_newslot(call6760);
  params[0] = call6757;
  partcv[0] = 1;
  Object sum6761 = callmethod(call6760, "+", 1, partcv, params);
// compiled op node returning sum6761 (depth = 6)
  gc_frame_newslot(sum6761);
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit6752;
  params[1] = call6754;
  params[2] = sum6761;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6762 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6751);
// compiled call node returning call6762 (depth = 5)
    gc_frame_newslot(call6762);
    if6720 = call6762;
  } else {
  }
// compiled if node returning if6720 (depth = 4)
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6764 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6763);
// compiled call node returning call6764 (depth = 6)
// compiled member node returning call6764 (depth = 5)
  *var_val = call6764;
  if (call6764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6705 = done;
  } else {
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6767 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6768 == NULL) {
    strlit6768 = alloc_String("bind");
    gc_root(strlit6768);
  }
// compiled string node returning strlit6768 (depth = 6)
  gc_frame_newslot(strlit6768);
// call case 4: self request
  params[0] = strlit6768;
  partcv[0] = 1;
  Object call6769 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6767);
// compiled call node returning call6769 (depth = 5)
  Object if6766 = done;
  if (istrue(call6769)) {
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6770 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6770 (depth = 6)
  *var_suggestions = array6770;
  if (array6770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6771 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6772 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6773 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6772);
// compiled call node returning call6773 (depth = 9)
// compiled member node returning call6773 (depth = 8)
  partcv[0] = 0;
  Object call6774 = callmethod(call6773, "new",
    1, partcv, params);
  gc_frame_end(callframe6771);
// compiled call node returning call6774 (depth = 7)
// compiled member node returning call6774 (depth = 6)
  *var_suggestion = call6774;
  if (call6774 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6775 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit6776 == NULL) {
    strlit6776 = alloc_String("=");
    gc_root(strlit6776);
  }
// compiled string node returning strlit6776 (depth = 6)
  gc_frame_newslot(strlit6776);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit6776;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6777 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6775);
// compiled call node returning call6777 (depth = 5)
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6778 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6779 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6778);
// compiled call node returning call6779 (depth = 5)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6780 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6782 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6781);
// compiled call node returning call6782 (depth = 9)
// compiled member node returning call6782 (depth = 8)
  partcv[0] = 0;
  Object call6783 = callmethod(call6782, "new",
    1, partcv, params);
  gc_frame_end(callframe6780);
// compiled call node returning call6783 (depth = 7)
// compiled member node returning call6783 (depth = 6)
  *var_suggestion = call6783;
  if (call6783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6785 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6786 == NULL) {
    strlit6786 = alloc_String("var");
    gc_root(strlit6786);
  }
// compiled string node returning strlit6786 (depth = 6)
  gc_frame_newslot(strlit6786);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6786;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6787 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6785);
// compiled call node returning call6787 (depth = 5)
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6788 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6789 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6788);
// compiled call node returning call6789 (depth = 5)
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6790 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6792 == NULL) {
    strlit6792 = alloc_String("A variable declaration uses 'var' and ':='.");
    gc_root(strlit6792);
  }
// compiled string node returning strlit6792 (depth = 7)
  int op_slot_right_6791 = gc_frame_newslot(strlit6792);
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6794 == NULL) {
    strlit6794 = alloc_String("a definition must use '=' instead of ':='. ");
    gc_root(strlit6794);
  }
// compiled string node returning strlit6794 (depth = 7)
  int op_slot_left_6791 = gc_frame_newslot(strlit6794);
  params[0] = strlit6792;
  partcv[0] = 1;
  Object opresult6795 = callmethod(strlit6794, "++", 1, partcv, params);
// compiled op node returning opresult6795 (depth = 6)
  gc_frame_newslot(opresult6795);
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6797 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6796);
// compiled call node returning call6797 (depth = 7)
// compiled member node returning call6797 (depth = 6)
  gc_frame_newslot(call6797);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6799 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6798);
// compiled call node returning call6799 (depth = 7)
// compiled member node returning call6799 (depth = 6)
  gc_frame_newslot(call6799);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num6801 = alloc_Float64(1);
// compiled num node returning num6801 (depth = 7)
  int op_slot_right_6800 = gc_frame_newslot(num6801);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6804 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6803);
// compiled call node returning call6804 (depth = 8)
// compiled member node returning call6804 (depth = 7)
  int op_slot_left_6800 = gc_frame_newslot(call6804);
  params[0] = num6801;
  partcv[0] = 1;
  Object sum6805 = callmethod(call6804, "+", 1, partcv, params);
// compiled op node returning sum6805 (depth = 6)
  gc_frame_newslot(sum6805);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6795;
  params[1] = call6797;
  params[2] = call6799;
  params[3] = sum6805;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6806 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6790);
// compiled call node returning call6806 (depth = 5)
    gc_frame_newslot(call6806);
    if6766 = call6806;
  } else {
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6807 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6807 (depth = 6)
  *var_suggestions = array6807;
  if (array6807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6808 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6810 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6809);
// compiled call node returning call6810 (depth = 9)
// compiled member node returning call6810 (depth = 8)
  partcv[0] = 0;
  Object call6811 = callmethod(call6810, "new",
    1, partcv, params);
  gc_frame_end(callframe6808);
// compiled call node returning call6811 (depth = 7)
// compiled member node returning call6811 (depth = 6)
  *var_suggestion = call6811;
  if (call6811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6812 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6813 == NULL) {
    strlit6813 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6813);
  }
// compiled string node returning strlit6813 (depth = 6)
  gc_frame_newslot(strlit6813);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6813;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6814 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6812);
// compiled call node returning call6814 (depth = 5)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6815 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6816 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6815);
// compiled call node returning call6816 (depth = 5)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6817 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6818 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6819 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6818);
// compiled call node returning call6819 (depth = 9)
// compiled member node returning call6819 (depth = 8)
  partcv[0] = 0;
  Object call6820 = callmethod(call6819, "new",
    1, partcv, params);
  gc_frame_end(callframe6817);
// compiled call node returning call6820 (depth = 7)
// compiled member node returning call6820 (depth = 6)
  *var_suggestion = call6820;
  if (call6820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6822 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit6823 == NULL) {
    strlit6823 = alloc_String("var");
    gc_root(strlit6823);
  }
// compiled string node returning strlit6823 (depth = 6)
  gc_frame_newslot(strlit6823);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit6823;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6824 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe6822);
// compiled call node returning call6824 (depth = 5)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6825 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6826 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6825);
// compiled call node returning call6826 (depth = 5)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6827 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6829 == NULL) {
    strlit6829 = alloc_String("A variable declaration does not require a value but uses 'var', not 'def'.");
    gc_root(strlit6829);
  }
// compiled string node returning strlit6829 (depth = 7)
  int op_slot_right_6828 = gc_frame_newslot(strlit6829);
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6831 == NULL) {
    strlit6831 = alloc_String("a definition must have '=' and a value after the name. ");
    gc_root(strlit6831);
  }
// compiled string node returning strlit6831 (depth = 7)
  int op_slot_left_6828 = gc_frame_newslot(strlit6831);
  params[0] = strlit6829;
  partcv[0] = 1;
  Object opresult6832 = callmethod(strlit6831, "++", 1, partcv, params);
// compiled op node returning opresult6832 (depth = 6)
  gc_frame_newslot(opresult6832);
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6833 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6834 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6833);
// compiled call node returning call6834 (depth = 7)
// compiled member node returning call6834 (depth = 6)
  gc_frame_newslot(call6834);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6835 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6836 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6835);
// compiled call node returning call6836 (depth = 7)
// compiled member node returning call6836 (depth = 6)
  gc_frame_newslot(call6836);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult6832;
  params[1] = call6834;
  params[2] = call6836;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6837 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6827);
// compiled call node returning call6837 (depth = 5)
    gc_frame_newslot(call6837);
    if6766 = call6837;
  }
// compiled if node returning if6766 (depth = 4)
    gc_frame_newslot(if6766);
    if6705 = if6766;
  }
// compiled if node returning if6705 (depth = 3)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6838 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6839 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call6840 = callmethod(*var_defTok, "line",
    1, partcv, params);
  gc_frame_end(callframe6839);
// compiled call node returning call6840 (depth = 5)
// compiled member node returning call6840 (depth = 4)
  gc_frame_newslot(call6840);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6841 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  partcv[0] = 0;
  Object call6842 = callmethod(*var_defTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6841);
// compiled call node returning call6842 (depth = 5)
// compiled member node returning call6842 (depth = 4)
  gc_frame_newslot(call6842);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call6840;
  params[1] = call6842;
  partcv[0] = 2;
  Object call6843 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe6838);
// compiled call node returning call6843 (depth = 3)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6844 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6845 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6846 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe6845);
// compiled call node returning call6846 (depth = 6)
// compiled member node returning call6846 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call6847 = callmethod(call6846, "new",
    1, partcv, params);
  gc_frame_end(callframe6844);
// compiled call node returning call6847 (depth = 4)
  *var_o = call6847;
  if (call6847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_6849 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool6851 = alloc_Boolean(0);
// compiled identifier node returning bool6851 (depth = 5)
  int op_slot_left_6849 = gc_frame_newslot(bool6851);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult6852 = callmethod(bool6851, "≠", 1, partcv, params);
// compiled op node returning opresult6852 (depth = 4)
  Object if6848 = done;
  if (istrue(opresult6852)) {
// starting to compile call node (depth = 4)
  int callframe6853 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6854 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call6855 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe6854);
// compiled call node returning call6855 (depth = 6)
// compiled member node returning call6855 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call6856 = callmethod(call6855, "addAll",
    1, partcv, params);
  gc_frame_end(callframe6853);
// compiled call node returning call6856 (depth = 4)
    gc_frame_newslot(call6856);
    if6848 = call6856;
  } else {
  }
// compiled if node returning if6848 (depth = 3)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6857 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defTok (depth = 4)
  gc_frame_newslot(*var_defTok);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call6858 = callmethod(*var_o, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe6857);
// compiled call node returning call6858 (depth = 3)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6859 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call6860 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6859);
// compiled call node returning call6860 (depth = 3)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6861 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6862 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6861);
// compiled call node returning call6862 (depth = 4)
// compiled member node returning call6862 (depth = 3)
    gc_frame_newslot(call6862);
    if6609 = call6862;
  } else {
  }
// compiled if node returning if6609 (depth = 2)
  gc_frame_end(frame);
  return if6609;
}
Object meth_parser__apply6887(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6891 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6890);
// compiled call node returning call6891 (depth = 10)
// compiled member node returning call6891 (depth = 9)
  int op_slot_right_6889 = gc_frame_newslot(call6891);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call6894 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe6893);
// compiled call node returning call6894 (depth = 10)
// compiled member node returning call6894 (depth = 9)
  int op_slot_left_6889 = gc_frame_newslot(call6894);
  params[0] = call6891;
  partcv[0] = 1;
  Object opresult6895 = callmethod(call6894, "==", 1, partcv, params);
// compiled op node returning opresult6895 (depth = 8)
  int op_slot_right_6888 = gc_frame_newslot(opresult6895);
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6898 == NULL) {
    strlit6898 = alloc_String("bind");
    gc_root(strlit6898);
  }
// compiled string node returning strlit6898 (depth = 9)
  int op_slot_right_6897 = gc_frame_newslot(strlit6898);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call6901 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe6900);
// compiled call node returning call6901 (depth = 10)
// compiled member node returning call6901 (depth = 9)
  int op_slot_left_6897 = gc_frame_newslot(call6901);
  params[0] = strlit6898;
  partcv[0] = 1;
  Object opresult6902 = callmethod(call6901, "==", 1, partcv, params);
// compiled op node returning opresult6902 (depth = 8)
  int op_slot_left_6888 = gc_frame_newslot(opresult6902);
  params[0] = opresult6895;
  partcv[0] = 1;
  Object opresult6903 = callmethod(opresult6902, "&&", 1, partcv, params);
// compiled op node returning opresult6903 (depth = 7)
  gc_frame_end(frame);
  return opresult6903;
}
Object meth_parser__apply6909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_6910 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_6910 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6912 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult6912 (depth = 7)
  gc_frame_end(frame);
  return opresult6912;
}
Object meth_parser__apply6959(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe6960 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6961 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6960);
// compiled call node returning call6961 (depth = 9)
  gc_frame_end(frame);
  return call6961;
}
Object meth_parser_vardec6863(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for vardec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for vardec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_name = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "name");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6865 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6866 == NULL) {
    strlit6866 = alloc_String("var");
    gc_root(strlit6866);
  }
// compiled string node returning strlit6866 (depth = 4)
  gc_frame_newslot(strlit6866);
// call case 4: self request
  params[0] = strlit6866;
  partcv[0] = 1;
  Object call6867 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6865);
// compiled call node returning call6867 (depth = 3)
  Object if6864 = done;
  if (istrue(call6867)) {
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6869 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6868);
// compiled call node returning call6869 (depth = 5)
// compiled member node returning call6869 (depth = 4)
  *var_line = call6869;
  if (call6869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6871 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6870);
// compiled call node returning call6871 (depth = 5)
// compiled member node returning call6871 (depth = 4)
  *var_pos = call6871;
  if (call6871 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6873 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6872);
// compiled call node returning call6873 (depth = 4)
// compiled member node returning call6873 (depth = 3)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6876 == NULL) {
    strlit6876 = alloc_String("identifier");
    gc_root(strlit6876);
  }
// compiled string node returning strlit6876 (depth = 5)
  int op_slot_right_6875 = gc_frame_newslot(strlit6876);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6879 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6878);
// compiled call node returning call6879 (depth = 6)
// compiled member node returning call6879 (depth = 5)
  int op_slot_left_6875 = gc_frame_newslot(call6879);
  params[0] = strlit6876;
  partcv[0] = 1;
  Object opresult6880 = callmethod(call6879, "≠", 1, partcv, params);
// compiled op node returning opresult6880 (depth = 4)
  Object if6874 = done;
  if (istrue(opresult6880)) {
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6881 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6882 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call6883 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6882);
// compiled call node returning call6883 (depth = 8)
// compiled member node returning call6883 (depth = 7)
  partcv[0] = 0;
  Object call6884 = callmethod(call6883, "new",
    1, partcv, params);
  gc_frame_end(callframe6881);
// compiled call node returning call6884 (depth = 6)
// compiled member node returning call6884 (depth = 5)
  *var_suggestion = call6884;
  if (call6884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6885 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6886 = alloc_Block(NULL, NULL, "parser", 2164);
  gc_frame_newslot(block6886);
// method "_apply"
  block_savedest(block6886);
  Object closure6887 = createclosure(2, "_apply");
  setclosureframe(closure6887, stackframe);
  addtoclosure(closure6887, var_sym);
  addtoclosure(closure6887, selfslot);
  struct UserObject *uo6887 = (struct UserObject*)block6886;
  uo6887->data[0] = (Object)closure6887;
  Method *meth_meth_parser__apply6887 = addmethod2pos(block6886, "_apply", &meth_parser__apply6887, 0);
  int argcv_meth_parser__apply6887[] = {1};
  meth_meth_parser__apply6887->type = alloc_MethodType(1, argcv_meth_parser__apply6887);
  meth_meth_parser__apply6887->definitionModule = modulename;
  meth_meth_parser__apply6887->definitionLine = 2163;
// compiled block node returning block6886 (depth = 6)
  gc_frame_newslot(block6886);
// call case 4: self request
  params[0] = block6886;
  partcv[0] = 1;
  Object call6905 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6885);
// compiled call node returning call6905 (depth = 5)
  *var_nextToken = call6905;
  if (call6905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block6908 = alloc_Block(NULL, NULL, "parser", 2166);
  gc_frame_newslot(block6908);
// method "_apply"
  block_savedest(block6908);
  Object closure6909 = createclosure(3, "_apply");
  setclosureframe(closure6909, stackframe);
  addtoclosure(closure6909, var_sym);
  addtoclosure(closure6909, var_nextToken);
  addtoclosure(closure6909, selfslot);
  struct UserObject *uo6909 = (struct UserObject*)block6908;
  uo6909->data[0] = (Object)closure6909;
  Method *meth_meth_parser__apply6909 = addmethod2pos(block6908, "_apply", &meth_parser__apply6909, 0);
  int argcv_meth_parser__apply6909[] = {0};
  meth_meth_parser__apply6909->type = alloc_MethodType(1, argcv_meth_parser__apply6909);
  meth_meth_parser__apply6909->definitionModule = modulename;
  meth_meth_parser__apply6909->definitionLine = 2164;
// compiled block node returning block6908 (depth = 6)
  int op_slot_right_6907 = gc_frame_newslot(block6908);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_right_6915 = gc_frame_newslot(*var_nextToken);
// starting to compile identifier node (depth = 7)
  Object bool6917 = alloc_Boolean(0);
// compiled identifier node returning bool6917 (depth = 7)
  int op_slot_left_6915 = gc_frame_newslot(bool6917);
  params[0] = *var_nextToken;
  partcv[0] = 1;
  Object opresult6918 = callmethod(bool6917, "==", 1, partcv, params);
// compiled op node returning opresult6918 (depth = 6)
  int op_slot_left_6907 = gc_frame_newslot(opresult6918);
  params[0] = block6908;
  partcv[0] = 1;
  Object opresult6919 = callmethod(opresult6918, "||", 1, partcv, params);
// compiled op node returning opresult6919 (depth = 5)
  Object if6906 = done;
  if (istrue(opresult6919)) {
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6920 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6921 == NULL) {
    strlit6921 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit6921);
  }
// compiled string node returning strlit6921 (depth = 6)
  gc_frame_newslot(strlit6921);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit6921;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6922 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6920);
// compiled call node returning call6922 (depth = 5)
    gc_frame_newslot(call6922);
    if6906 = call6922;
  } else {
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6923 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  partcv[0] = 0;
  Object call6925 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe6924);
// compiled call node returning call6925 (depth = 7)
// compiled member node returning call6925 (depth = 6)
  gc_frame_newslot(call6925);
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6926 = alloc_Boolean(0);
// compiled identifier node returning bool6926 (depth = 6)
  gc_frame_newslot(bool6926);
// starting to compile identifier node (depth = 6)
  Object bool6927 = alloc_Boolean(1);
// compiled identifier node returning bool6927 (depth = 6)
  gc_frame_newslot(bool6927);
// starting to compile string node (depth = 6)
  if (strlit6928 == NULL) {
    strlit6928 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit6928);
  }
// compiled string node returning strlit6928 (depth = 6)
  gc_frame_newslot(strlit6928);
// call case 6: other member request
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call6925;
  params[2] = bool6926;
  params[3] = bool6927;
  params[4] = strlit6928;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6929 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6923);
// compiled call node returning call6929 (depth = 5)
    gc_frame_newslot(call6929);
    if6906 = call6929;
  }
// compiled if node returning if6906 (depth = 4)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6930 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6931 == NULL) {
    strlit6931 = alloc_String("a variable declaration must have a name after the 'var'.");
    gc_root(strlit6931);
  }
// compiled string node returning strlit6931 (depth = 5)
  gc_frame_newslot(strlit6931);
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6933 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6932);
// compiled call node returning call6933 (depth = 6)
// compiled member node returning call6933 (depth = 5)
  gc_frame_newslot(call6933);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6935 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6934);
// compiled call node returning call6935 (depth = 6)
// compiled member node returning call6935 (depth = 5)
  gc_frame_newslot(call6935);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit6931;
  params[1] = call6933;
  params[2] = call6935;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6936 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6930);
// compiled call node returning call6936 (depth = 4)
    gc_frame_newslot(call6936);
    if6874 = call6936;
  } else {
  }
// compiled if node returning if6874 (depth = 3)
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6937 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6938 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6937);
// compiled call node returning call6938 (depth = 4)
// compiled member node returning call6938 (depth = 3)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool6939 = alloc_Boolean(0);
// compiled identifier node returning bool6939 (depth = 4)
  *var_val = bool6939;
  if (bool6939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call6941 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6940);
// compiled call node returning call6941 (depth = 5)
// compiled member node returning call6941 (depth = 4)
  *var_name = call6941;
  if (call6941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6942 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool6943 = alloc_Boolean(1);
// compiled identifier node returning bool6943 (depth = 4)
  gc_frame_newslot(bool6943);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool6943;
  partcv[0] = 1;
  Object call6944 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe6942);
// compiled call node returning call6944 (depth = 3)
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6945 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6946 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6945);
// compiled call node returning call6946 (depth = 5)
// compiled member node returning call6946 (depth = 4)
  *var_dtype = call6946;
  if (call6946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2180
  setline(2180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6947 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6948 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6947);
// compiled call node returning call6948 (depth = 5)
// compiled member node returning call6948 (depth = 4)
  *var_anns = call6948;
  if (call6948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6950 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6951 == NULL) {
    strlit6951 = alloc_String("bind");
    gc_root(strlit6951);
  }
// compiled string node returning strlit6951 (depth = 5)
  gc_frame_newslot(strlit6951);
// call case 4: self request
  params[0] = strlit6951;
  partcv[0] = 1;
  Object call6952 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6950);
// compiled call node returning call6952 (depth = 4)
  Object if6949 = done;
  if (istrue(call6952)) {
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6953 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6954 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6953);
// compiled call node returning call6954 (depth = 5)
// compiled member node returning call6954 (depth = 4)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6956 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe6957 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6958 = alloc_Block(NULL, NULL, "parser", 2183);
  gc_frame_newslot(block6958);
// method "_apply"
  block_savedest(block6958);
  Object closure6959 = createclosure(2, "_apply");
  setclosureframe(closure6959, stackframe);
  addtoclosure(closure6959, var_blocksOK);
  addtoclosure(closure6959, selfslot);
  struct UserObject *uo6959 = (struct UserObject*)block6958;
  uo6959->data[0] = (Object)closure6959;
  Method *meth_meth_parser__apply6959 = addmethod2pos(block6958, "_apply", &meth_parser__apply6959, 0);
  int argcv_meth_parser__apply6959[] = {0};
  meth_meth_parser__apply6959->type = alloc_MethodType(1, argcv_meth_parser__apply6959);
  meth_meth_parser__apply6959->definitionModule = modulename;
  meth_meth_parser__apply6959->definitionLine = 2183;
// compiled block node returning block6958 (depth = 8)
  gc_frame_newslot(block6958);
// call case 4: self request
  params[0] = block6958;
  partcv[0] = 1;
  Object call6963 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6957);
// compiled call node returning call6963 (depth = 7)
  partcv[0] = 0;
  Object call6964 = callmethod(call6963, "not",
    1, partcv, params);
  gc_frame_end(callframe6956);
// compiled call node returning call6964 (depth = 6)
// compiled member node returning call6964 (depth = 5)
  Object if6955 = done;
  if (istrue(call6964)) {
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array6965 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6965 (depth = 6)
  *var_suggestions = array6965;
  if (array6965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6966 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6968 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6967);
// compiled call node returning call6968 (depth = 9)
// compiled member node returning call6968 (depth = 8)
  partcv[0] = 0;
  Object call6969 = callmethod(call6968, "new",
    1, partcv, params);
  gc_frame_end(callframe6966);
// compiled call node returning call6969 (depth = 7)
// compiled member node returning call6969 (depth = 6)
  *var_suggestion = call6969;
  if (call6969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6970 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array6971 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6971 (depth = 7)
  gc_frame_newslot(array6971);
// call case 4: self request
  params[0] = array6971;
  partcv[0] = 1;
  Object call6972 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6970);
// compiled call node returning call6972 (depth = 6)
  *var_nextTok = call6972;
  if (call6972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_6974 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_6974 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6976 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6976 (depth = 6)
  Object if6973 = done;
  if (istrue(opresult6976)) {
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6977 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6978 == NULL) {
    strlit6978 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6978);
  }
// compiled string node returning strlit6978 (depth = 7)
  gc_frame_newslot(strlit6978);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit6978;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6979 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6977);
// compiled call node returning call6979 (depth = 6)
    gc_frame_newslot(call6979);
    if6973 = call6979;
  } else {
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6980 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6982 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6981);
// compiled call node returning call6982 (depth = 8)
// compiled member node returning call6982 (depth = 7)
  gc_frame_newslot(call6982);
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool6983 = alloc_Boolean(1);
// compiled identifier node returning bool6983 (depth = 7)
  gc_frame_newslot(bool6983);
// starting to compile identifier node (depth = 7)
  Object bool6984 = alloc_Boolean(0);
// compiled identifier node returning bool6984 (depth = 7)
  gc_frame_newslot(bool6984);
// starting to compile string node (depth = 7)
  if (strlit6985 == NULL) {
    strlit6985 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6985);
  }
// compiled string node returning strlit6985 (depth = 7)
  gc_frame_newslot(strlit6985);
// call case 6: other member request
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call6982;
  params[2] = bool6983;
  params[3] = bool6984;
  params[4] = strlit6985;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6986 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6980);
// compiled call node returning call6986 (depth = 6)
    gc_frame_newslot(call6986);
    if6973 = call6986;
  }
// compiled if node returning if6973 (depth = 5)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6987 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6988 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6987);
// compiled call node returning call6988 (depth = 5)
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6989 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6990 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6991 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6990);
// compiled call node returning call6991 (depth = 9)
// compiled member node returning call6991 (depth = 8)
  partcv[0] = 0;
  Object call6992 = callmethod(call6991, "new",
    1, partcv, params);
  gc_frame_end(callframe6989);
// compiled call node returning call6992 (depth = 7)
// compiled member node returning call6992 (depth = 6)
  *var_suggestion = call6992;
  if (call6992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6994 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call6996 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6995);
// compiled call node returning call6996 (depth = 7)
// compiled member node returning call6996 (depth = 6)
  gc_frame_newslot(call6996);
// starting to compile identifier node (depth = 6)
  Object bool6997 = alloc_Boolean(1);
// compiled identifier node returning bool6997 (depth = 6)
  gc_frame_newslot(bool6997);
// starting to compile identifier node (depth = 6)
  Object bool6998 = alloc_Boolean(0);
// compiled identifier node returning bool6998 (depth = 6)
  gc_frame_newslot(bool6998);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call6996;
  params[2] = bool6997;
  params[3] = bool6998;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6999 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6994);
// compiled call node returning call6999 (depth = 5)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7000 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7001 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7000);
// compiled call node returning call7001 (depth = 5)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7002 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7004 == NULL) {
    strlit7004 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit7004);
  }
// compiled string node returning strlit7004 (depth = 7)
  int op_slot_right_7003 = gc_frame_newslot(strlit7004);
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7006 == NULL) {
    strlit7006 = alloc_String("a variable declaration must have a value after the ':='. ");
    gc_root(strlit7006);
  }
// compiled string node returning strlit7006 (depth = 7)
  int op_slot_left_7003 = gc_frame_newslot(strlit7006);
  params[0] = strlit7004;
  partcv[0] = 1;
  Object opresult7007 = callmethod(strlit7006, "++", 1, partcv, params);
// compiled op node returning opresult7007 (depth = 6)
  gc_frame_newslot(opresult7007);
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7009 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7008);
// compiled call node returning call7009 (depth = 7)
// compiled member node returning call7009 (depth = 6)
  gc_frame_newslot(call7009);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7012 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7011);
// compiled call node returning call7012 (depth = 8)
// compiled member node returning call7012 (depth = 7)
  int op_slot_right_7010 = gc_frame_newslot(call7012);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7014 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7015 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7014);
// compiled call node returning call7015 (depth = 8)
// compiled member node returning call7015 (depth = 7)
  int op_slot_left_7010 = gc_frame_newslot(call7015);
  params[0] = call7012;
  partcv[0] = 1;
  Object sum7016 = callmethod(call7015, "+", 1, partcv, params);
// compiled op node returning sum7016 (depth = 6)
  gc_frame_newslot(sum7016);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7007;
  params[1] = call7009;
  params[2] = sum7016;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7017 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7002);
// compiled call node returning call7017 (depth = 5)
    gc_frame_newslot(call7017);
    if6955 = call7017;
  } else {
  }
// compiled if node returning if6955 (depth = 4)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7018 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7019 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7018);
// compiled call node returning call7019 (depth = 6)
// compiled member node returning call7019 (depth = 5)
  *var_val = call7019;
  if (call7019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6949 = done;
  } else {
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7024 == NULL) {
    strlit7024 = alloc_String("=");
    gc_root(strlit7024);
  }
// compiled string node returning strlit7024 (depth = 7)
  int op_slot_right_7023 = gc_frame_newslot(strlit7024);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7027 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7026);
// compiled call node returning call7027 (depth = 8)
// compiled member node returning call7027 (depth = 7)
  int op_slot_left_7023 = gc_frame_newslot(call7027);
  params[0] = strlit7024;
  partcv[0] = 1;
  Object opresult7028 = callmethod(call7027, "==", 1, partcv, params);
// compiled op node returning opresult7028 (depth = 6)
  int op_slot_right_7022 = gc_frame_newslot(opresult7028);
// starting to compile call node (depth = 6)
  int callframe7030 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7031 == NULL) {
    strlit7031 = alloc_String("op");
    gc_root(strlit7031);
  }
// compiled string node returning strlit7031 (depth = 7)
  gc_frame_newslot(strlit7031);
// call case 4: self request
  params[0] = strlit7031;
  partcv[0] = 1;
  Object call7032 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7030);
// compiled call node returning call7032 (depth = 6)
  int op_slot_left_7022 = gc_frame_newslot(call7032);
  params[0] = opresult7028;
  partcv[0] = 1;
  Object opresult7033 = callmethod(call7032, "&&", 1, partcv, params);
// compiled op node returning opresult7033 (depth = 5)
  Object if7021 = done;
  if (istrue(opresult7033)) {
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array7034 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7034 (depth = 6)
  *var_suggestions = array7034;
  if (array7034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7035 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7036 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7037 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7036);
// compiled call node returning call7037 (depth = 9)
// compiled member node returning call7037 (depth = 8)
  partcv[0] = 0;
  Object call7038 = callmethod(call7037, "new",
    1, partcv, params);
  gc_frame_end(callframe7035);
// compiled call node returning call7038 (depth = 7)
// compiled member node returning call7038 (depth = 6)
  *var_suggestion = call7038;
  if (call7038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7039 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7040 == NULL) {
    strlit7040 = alloc_String(":=");
    gc_root(strlit7040);
  }
// compiled string node returning strlit7040 (depth = 6)
  gc_frame_newslot(strlit7040);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7040;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7041 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7039);
// compiled call node returning call7041 (depth = 5)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7042 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7043 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7042);
// compiled call node returning call7043 (depth = 5)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7044 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7046 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7045);
// compiled call node returning call7046 (depth = 9)
// compiled member node returning call7046 (depth = 8)
  partcv[0] = 0;
  Object call7047 = callmethod(call7046, "new",
    1, partcv, params);
  gc_frame_end(callframe7044);
// compiled call node returning call7047 (depth = 7)
// compiled member node returning call7047 (depth = 6)
  *var_suggestion = call7047;
  if (call7047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7049 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit7050 == NULL) {
    strlit7050 = alloc_String("def");
    gc_root(strlit7050);
  }
// compiled string node returning strlit7050 (depth = 6)
  gc_frame_newslot(strlit7050);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit7050;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7051 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7049);
// compiled call node returning call7051 (depth = 5)
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7052 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7053 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7052);
// compiled call node returning call7053 (depth = 5)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7054 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7055 == NULL) {
    strlit7055 = alloc_String("a variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit7055);
  }
// compiled string node returning strlit7055 (depth = 6)
  gc_frame_newslot(strlit7055);
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7057 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7056);
// compiled call node returning call7057 (depth = 7)
// compiled member node returning call7057 (depth = 6)
  gc_frame_newslot(call7057);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7058 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7059 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7058);
// compiled call node returning call7059 (depth = 7)
// compiled member node returning call7059 (depth = 6)
  gc_frame_newslot(call7059);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7061 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7060);
// compiled call node returning call7061 (depth = 7)
// compiled member node returning call7061 (depth = 6)
  gc_frame_newslot(call7061);
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7055;
  params[1] = call7057;
  params[2] = call7059;
  params[3] = call7061;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7062 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7054);
// compiled call node returning call7062 (depth = 5)
    gc_frame_newslot(call7062);
    if7021 = call7062;
  } else {
  }
// compiled if node returning if7021 (depth = 4)
    gc_frame_newslot(if7021);
    if6949 = if7021;
  }
// compiled if node returning if6949 (depth = 3)
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7063 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call7064 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7063);
// compiled call node returning call7064 (depth = 3)
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7065 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7066 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7067 = callmethod(*var_ast, "varDecNode",
    1, partcv, params);
  gc_frame_end(callframe7066);
// compiled call node returning call7067 (depth = 6)
// compiled member node returning call7067 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7068 = callmethod(call7067, "new",
    1, partcv, params);
  gc_frame_end(callframe7065);
// compiled call node returning call7068 (depth = 4)
  *var_o = call7068;
  if (call7068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_7070 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool7072 = alloc_Boolean(0);
// compiled identifier node returning bool7072 (depth = 5)
  int op_slot_left_7070 = gc_frame_newslot(bool7072);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7073 = callmethod(bool7072, "≠", 1, partcv, params);
// compiled op node returning opresult7073 (depth = 4)
  Object if7069 = done;
  if (istrue(opresult7073)) {
// starting to compile call node (depth = 4)
  int callframe7074 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7076 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7075);
// compiled call node returning call7076 (depth = 6)
// compiled member node returning call7076 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7077 = callmethod(call7076, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7074);
// compiled call node returning call7077 (depth = 4)
    gc_frame_newslot(call7077);
    if7069 = call7077;
  } else {
  }
// compiled if node returning if7069 (depth = 3)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7078 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7079 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7078);
// compiled call node returning call7079 (depth = 3)
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7080 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7081 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7080);
// compiled call node returning call7081 (depth = 4)
// compiled member node returning call7081 (depth = 3)
    gc_frame_newslot(call7081);
    if6864 = call7081;
  } else {
  }
// compiled if node returning if6864 (depth = 2)
  gc_frame_end(frame);
  return if6864;
}
Object meth_parser__apply7092(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7093 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7094 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7093);
// compiled call node returning call7094 (depth = 5)
  gc_frame_end(frame);
  return call7094;
}
Object meth_parser__apply7100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7101 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7102 == NULL) {
    strlit7102 = alloc_String("comma");
    gc_root(strlit7102);
  }
// compiled string node returning strlit7102 (depth = 8)
  gc_frame_newslot(strlit7102);
// call case 4: self request
  params[0] = strlit7102;
  partcv[0] = 1;
  Object call7103 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7101);
// compiled call node returning call7103 (depth = 7)
  gc_frame_end(frame);
  return call7103;
}
Object meth_parser__apply7118(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7119 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7120 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7119);
// compiled call node returning call7120 (depth = 12)
  gc_frame_end(frame);
  return call7120;
}
Object meth_parser__apply7106(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// starting to compile bind node (depth = 7)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7108 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7107);
// compiled call node returning call7108 (depth = 9)
// compiled member node returning call7108 (depth = 8)
  *var_tmp = call7108;
  if (call7108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7110 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7111 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7110);
// compiled call node returning call7111 (depth = 7)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7113 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7112);
// compiled call node returning call7113 (depth = 8)
// compiled member node returning call7113 (depth = 7)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7115 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe7116 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7117 = alloc_Block(NULL, NULL, "parser", 2235);
  gc_frame_newslot(block7117);
// method "_apply"
  block_savedest(block7117);
  Object closure7118 = createclosure(2, "_apply");
  setclosureframe(closure7118, stackframe);
  addtoclosure(closure7118, var_blocksOK);
  addtoclosure(closure7118, selfslot);
  struct UserObject *uo7118 = (struct UserObject*)block7117;
  uo7118->data[0] = (Object)closure7118;
  Method *meth_meth_parser__apply7118 = addmethod2pos(block7117, "_apply", &meth_parser__apply7118, 0);
  int argcv_meth_parser__apply7118[] = {0};
  meth_meth_parser__apply7118->type = alloc_MethodType(1, argcv_meth_parser__apply7118);
  meth_meth_parser__apply7118->definitionModule = modulename;
  meth_meth_parser__apply7118->definitionLine = 2235;
// compiled block node returning block7117 (depth = 11)
  gc_frame_newslot(block7117);
// call case 4: self request
  params[0] = block7117;
  partcv[0] = 1;
  Object call7122 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7116);
// compiled call node returning call7122 (depth = 10)
  partcv[0] = 0;
  Object call7123 = callmethod(call7122, "not",
    1, partcv, params);
  gc_frame_end(callframe7115);
// compiled call node returning call7123 (depth = 9)
// compiled member node returning call7123 (depth = 8)
  Object if7114 = done;
  if (istrue(call7123)) {
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array7124 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7124 (depth = 9)
  *var_suggestions = array7124;
  if (array7124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7125 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7127 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7126);
// compiled call node returning call7127 (depth = 12)
// compiled member node returning call7127 (depth = 11)
  partcv[0] = 0;
  Object call7128 = callmethod(call7127, "new",
    1, partcv, params);
  gc_frame_end(callframe7125);
// compiled call node returning call7128 (depth = 10)
// compiled member node returning call7128 (depth = 9)
  *var_suggestion = call7128;
  if (call7128 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7129 = gc_frame_new();
// starting to compile array node (depth = 10)
  Object array7130 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 11)
  if (strlit7131 == NULL) {
    strlit7131 = alloc_String("rsquare");
    gc_root(strlit7131);
  }
// compiled string node returning strlit7131 (depth = 11)
  params[0] = strlit7131;
  partcv[0] = 1;
  callmethodflags(array7130, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7130 (depth = 10)
  gc_frame_newslot(array7130);
// call case 4: self request
  params[0] = array7130;
  partcv[0] = 1;
  Object call7132 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7129);
// compiled call node returning call7132 (depth = 9)
  *var_nextTok = call7132;
  if (call7132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7134 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7134 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7136 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7136 (depth = 9)
  Object if7133 = done;
  if (istrue(opresult7136)) {
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7137 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7138 == NULL) {
    strlit7138 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7138);
  }
// compiled string node returning strlit7138 (depth = 10)
  gc_frame_newslot(strlit7138);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7138;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7139 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7137);
// compiled call node returning call7139 (depth = 9)
    gc_frame_newslot(call7139);
    if7133 = call7139;
  } else {
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7140 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7141 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7142 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7141);
// compiled call node returning call7142 (depth = 11)
// compiled member node returning call7142 (depth = 10)
  gc_frame_newslot(call7142);
// starting to compile identifier node (depth = 10)
  Object bool7143 = alloc_Boolean(1);
// compiled identifier node returning bool7143 (depth = 10)
  gc_frame_newslot(bool7143);
// starting to compile identifier node (depth = 10)
  Object bool7144 = alloc_Boolean(0);
// compiled identifier node returning bool7144 (depth = 10)
  gc_frame_newslot(bool7144);
// starting to compile string node (depth = 10)
  if (strlit7145 == NULL) {
    strlit7145 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7145);
  }
// compiled string node returning strlit7145 (depth = 10)
  gc_frame_newslot(strlit7145);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7142;
  params[2] = bool7143;
  params[3] = bool7144;
  params[4] = strlit7145;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7146 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7140);
// compiled call node returning call7146 (depth = 9)
    gc_frame_newslot(call7146);
    if7133 = call7146;
  }
// compiled if node returning if7133 (depth = 8)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7147 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7148 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7147);
// compiled call node returning call7148 (depth = 8)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7149 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7151 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7150);
// compiled call node returning call7151 (depth = 12)
// compiled member node returning call7151 (depth = 11)
  partcv[0] = 0;
  Object call7152 = callmethod(call7151, "new",
    1, partcv, params);
  gc_frame_end(callframe7149);
// compiled call node returning call7152 (depth = 10)
// compiled member node returning call7152 (depth = 9)
  *var_suggestion = call7152;
  if (call7152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7154 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7156 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7155);
// compiled call node returning call7156 (depth = 10)
// compiled member node returning call7156 (depth = 9)
  gc_frame_newslot(call7156);
// starting to compile identifier node (depth = 9)
  Object bool7157 = alloc_Boolean(1);
// compiled identifier node returning bool7157 (depth = 9)
  gc_frame_newslot(bool7157);
// starting to compile identifier node (depth = 9)
  Object bool7158 = alloc_Boolean(0);
// compiled identifier node returning bool7158 (depth = 9)
  gc_frame_newslot(bool7158);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7156;
  params[2] = bool7157;
  params[3] = bool7158;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7159 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7154);
// compiled call node returning call7159 (depth = 8)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7160 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7161 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7160);
// compiled call node returning call7161 (depth = 8)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7162 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7163 == NULL) {
    strlit7163 = alloc_String("a Lineup must contain zero or more expressions separated by commas.");
    gc_root(strlit7163);
  }
// compiled string node returning strlit7163 (depth = 9)
  gc_frame_newslot(strlit7163);
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7165 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7164);
// compiled call node returning call7165 (depth = 10)
// compiled member node returning call7165 (depth = 9)
  gc_frame_newslot(call7165);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7167 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7166);
// compiled call node returning call7167 (depth = 10)
// compiled member node returning call7167 (depth = 9)
  gc_frame_newslot(call7167);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7163;
  params[1] = call7165;
  params[2] = call7167;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7168 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7162);
// compiled call node returning call7168 (depth = 8)
    gc_frame_newslot(call7168);
    if7114 = call7168;
  } else {
  }
// compiled if node returning if7114 (depth = 7)
  gc_frame_end(frame);
  return if7114;
}
Object meth_parser__apply7097(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7098 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7099 = alloc_Block(NULL, NULL, "parser", 2231);
  gc_frame_newslot(block7099);
// method "_apply"
  block_savedest(block7099);
  Object closure7100 = createclosure(1, "_apply");
  setclosureframe(closure7100, stackframe);
  addtoclosure(closure7100, selfslot);
  struct UserObject *uo7100 = (struct UserObject*)block7099;
  uo7100->data[0] = (Object)closure7100;
  Method *meth_meth_parser__apply7100 = addmethod2pos(block7099, "_apply", &meth_parser__apply7100, 0);
  int argcv_meth_parser__apply7100[] = {0};
  meth_meth_parser__apply7100->type = alloc_MethodType(1, argcv_meth_parser__apply7100);
  meth_meth_parser__apply7100->definitionModule = modulename;
  meth_meth_parser__apply7100->definitionLine = 2227;
// compiled block node returning block7099 (depth = 6)
  gc_frame_newslot(block7099);
// starting to compile block node (depth = 6)
  Object block7105 = alloc_Block(NULL, NULL, "parser", 2231);
  gc_frame_newslot(block7105);
// method "_apply"
  block_savedest(block7105);
  Object closure7106 = createclosure(8, "_apply");
  setclosureframe(closure7106, stackframe);
  addtoclosure(closure7106, var_values);
  addtoclosure(closure7106, var_tmp);
  addtoclosure(closure7106, var_params);
  addtoclosure(closure7106, var_blocksOK);
  addtoclosure(closure7106, var_errormessages);
  addtoclosure(closure7106, var_sym);
  addtoclosure(closure7106, var_lastToken);
  addtoclosure(closure7106, selfslot);
  struct UserObject *uo7106 = (struct UserObject*)block7105;
  uo7106->data[0] = (Object)closure7106;
  Method *meth_meth_parser__apply7106 = addmethod2pos(block7105, "_apply", &meth_parser__apply7106, 0);
  int argcv_meth_parser__apply7106[] = {0};
  meth_meth_parser__apply7106->type = alloc_MethodType(1, argcv_meth_parser__apply7106);
  meth_meth_parser__apply7106->definitionModule = modulename;
  meth_meth_parser__apply7106->definitionLine = 2227;
// compiled block node returning block7105 (depth = 6)
  gc_frame_newslot(block7105);
// call case 5: prelude request
  params[0] = block7099;
  params[1] = block7105;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7170 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7098);
// compiled call node returning call7170 (depth = 5)
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7172 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7171);
// compiled call node returning call7172 (depth = 7)
// compiled member node returning call7172 (depth = 6)
  *var_tmp = call7172;
  if (call7172 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7174 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7175 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7174);
// compiled call node returning call7175 (depth = 5)
  gc_frame_end(frame);
  return call7175;
}
Object meth_parser_doarray7082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doarray (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doarray");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7084 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7085 == NULL) {
    strlit7085 = alloc_String("lsquare");
    gc_root(strlit7085);
  }
// compiled string node returning strlit7085 (depth = 4)
  gc_frame_newslot(strlit7085);
// call case 4: self request
  params[0] = strlit7085;
  partcv[0] = 1;
  Object call7086 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7084);
// compiled call node returning call7086 (depth = 3)
  Object if7083 = done;
  if (istrue(call7086)) {
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7088 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7087);
// compiled call node returning call7088 (depth = 4)
// compiled member node returning call7088 (depth = 3)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7089 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7089 (depth = 4)
  *var_params = array7089;
  if (array7089 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7090 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7091 = alloc_Block(NULL, NULL, "parser", 2230);
  gc_frame_newslot(block7091);
// method "_apply"
  block_savedest(block7091);
  Object closure7092 = createclosure(2, "_apply");
  setclosureframe(closure7092, stackframe);
  addtoclosure(closure7092, var_blocksOK);
  addtoclosure(closure7092, selfslot);
  struct UserObject *uo7092 = (struct UserObject*)block7091;
  uo7092->data[0] = (Object)closure7092;
  Method *meth_meth_parser__apply7092 = addmethod2pos(block7091, "_apply", &meth_parser__apply7092, 0);
  int argcv_meth_parser__apply7092[] = {0};
  meth_meth_parser__apply7092->type = alloc_MethodType(1, argcv_meth_parser__apply7092);
  meth_meth_parser__apply7092->definitionModule = modulename;
  meth_meth_parser__apply7092->definitionLine = 2227;
// compiled block node returning block7091 (depth = 4)
  gc_frame_newslot(block7091);
// starting to compile block node (depth = 4)
  Object block7096 = alloc_Block(NULL, NULL, "parser", 2230);
  gc_frame_newslot(block7096);
// method "_apply"
  block_savedest(block7096);
  Object closure7097 = createclosure(8, "_apply");
  setclosureframe(closure7097, stackframe);
  addtoclosure(closure7097, var_values);
  addtoclosure(closure7097, var_tmp);
  addtoclosure(closure7097, var_params);
  addtoclosure(closure7097, var_blocksOK);
  addtoclosure(closure7097, var_errormessages);
  addtoclosure(closure7097, var_sym);
  addtoclosure(closure7097, var_lastToken);
  addtoclosure(closure7097, selfslot);
  struct UserObject *uo7097 = (struct UserObject*)block7096;
  uo7097->data[0] = (Object)closure7097;
  Method *meth_meth_parser__apply7097 = addmethod2pos(block7096, "_apply", &meth_parser__apply7097, 0);
  int argcv_meth_parser__apply7097[] = {0};
  meth_meth_parser__apply7097->type = alloc_MethodType(1, argcv_meth_parser__apply7097);
  meth_meth_parser__apply7097->definitionModule = modulename;
  meth_meth_parser__apply7097->definitionLine = 2227;
// compiled block node returning block7096 (depth = 4)
  gc_frame_newslot(block7096);
// call case 4: self request
  params[0] = block7091;
  params[1] = block7096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7177 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7090);
// compiled call node returning call7177 (depth = 3)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7180 == NULL) {
    strlit7180 = alloc_String("rsquare");
    gc_root(strlit7180);
  }
// compiled string node returning strlit7180 (depth = 5)
  int op_slot_right_7179 = gc_frame_newslot(strlit7180);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7183 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7182);
// compiled call node returning call7183 (depth = 6)
// compiled member node returning call7183 (depth = 5)
  int op_slot_left_7179 = gc_frame_newslot(call7183);
  params[0] = strlit7180;
  partcv[0] = 1;
  Object opresult7184 = callmethod(call7183, "≠", 1, partcv, params);
// compiled op node returning opresult7184 (depth = 4)
  Object if7178 = done;
  if (istrue(opresult7184)) {
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7185 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7187 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7186);
// compiled call node returning call7187 (depth = 8)
// compiled member node returning call7187 (depth = 7)
  partcv[0] = 0;
  Object call7188 = callmethod(call7187, "new",
    1, partcv, params);
  gc_frame_end(callframe7185);
// compiled call node returning call7188 (depth = 6)
// compiled member node returning call7188 (depth = 5)
  *var_suggestion = call7188;
  if (call7188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7189 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7190 == NULL) {
    strlit7190 = alloc_String("]");
    gc_root(strlit7190);
  }
// compiled string node returning strlit7190 (depth = 5)
  gc_frame_newslot(strlit7190);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7190;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7191 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7189);
// compiled call node returning call7191 (depth = 4)
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7192 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7193 == NULL) {
    strlit7193 = alloc_String("a Lineup beginning with a '[' must end with a ']'.");
    gc_root(strlit7193);
  }
// compiled string node returning strlit7193 (depth = 5)
  gc_frame_newslot(strlit7193);
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7195 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7194);
// compiled call node returning call7195 (depth = 6)
// compiled member node returning call7195 (depth = 5)
  gc_frame_newslot(call7195);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7197 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7198 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7197);
// compiled call node returning call7198 (depth = 7)
// compiled member node returning call7198 (depth = 6)
  int op_slot_right_7196 = gc_frame_newslot(call7198);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7201 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7200);
// compiled call node returning call7201 (depth = 7)
// compiled member node returning call7201 (depth = 6)
  int op_slot_left_7196 = gc_frame_newslot(call7201);
  params[0] = call7198;
  partcv[0] = 1;
  Object sum7202 = callmethod(call7201, "+", 1, partcv, params);
// compiled op node returning sum7202 (depth = 5)
  gc_frame_newslot(sum7202);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7193;
  params[1] = call7195;
  params[2] = sum7202;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7203 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7192);
// compiled call node returning call7203 (depth = 4)
    gc_frame_newslot(call7203);
    if7178 = call7203;
  } else {
  }
// compiled if node returning if7178 (depth = 3)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7204 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7206 = callmethod(*var_ast, "arrayNode",
    1, partcv, params);
  gc_frame_end(callframe7205);
// compiled call node returning call7206 (depth = 6)
// compiled member node returning call7206 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7207 = callmethod(call7206, "new",
    1, partcv, params);
  gc_frame_end(callframe7204);
// compiled call node returning call7207 (depth = 4)
  *var_o = call7207;
  if (call7207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7208 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7209 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7208);
// compiled call node returning call7209 (depth = 3)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7211 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7210);
// compiled call node returning call7211 (depth = 4)
// compiled member node returning call7211 (depth = 3)
    gc_frame_newslot(call7211);
    if7083 = call7211;
  } else {
  }
// compiled if node returning if7083 (depth = 2)
  gc_frame_end(frame);
  return if7083;
}
Object meth_parser_dodialect7212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dodialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dodialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7214 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7215 == NULL) {
    strlit7215 = alloc_String("dialect");
    gc_root(strlit7215);
  }
// compiled string node returning strlit7215 (depth = 4)
  gc_frame_newslot(strlit7215);
// call case 4: self request
  params[0] = strlit7215;
  partcv[0] = 1;
  Object call7216 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7214);
// compiled call node returning call7216 (depth = 3)
  Object if7213 = done;
  if (istrue(call7216)) {
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7218 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7217);
// compiled call node returning call7218 (depth = 4)
// compiled member node returning call7218 (depth = 3)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7221 == NULL) {
    strlit7221 = alloc_String("string");
    gc_root(strlit7221);
  }
// compiled string node returning strlit7221 (depth = 5)
  int op_slot_right_7220 = gc_frame_newslot(strlit7221);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7224 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7223);
// compiled call node returning call7224 (depth = 6)
// compiled member node returning call7224 (depth = 5)
  int op_slot_left_7220 = gc_frame_newslot(call7224);
  params[0] = strlit7221;
  partcv[0] = 1;
  Object opresult7225 = callmethod(call7224, "≠", 1, partcv, params);
// compiled op node returning opresult7225 (depth = 4)
  Object if7219 = done;
  if (istrue(opresult7225)) {
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7226 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7228 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7227);
// compiled call node returning call7228 (depth = 8)
// compiled member node returning call7228 (depth = 7)
  partcv[0] = 0;
  Object call7229 = callmethod(call7228, "new",
    1, partcv, params);
  gc_frame_end(callframe7226);
// compiled call node returning call7229 (depth = 6)
// compiled member node returning call7229 (depth = 5)
  *var_suggestion = call7229;
  if (call7229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7233 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7234 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7233);
// compiled call node returning call7234 (depth = 8)
// compiled member node returning call7234 (depth = 7)
  int op_slot_right_7232 = gc_frame_newslot(call7234);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7237 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7236);
// compiled call node returning call7237 (depth = 8)
// compiled member node returning call7237 (depth = 7)
  int op_slot_left_7232 = gc_frame_newslot(call7237);
  params[0] = call7234;
  partcv[0] = 1;
  Object opresult7238 = callmethod(call7237, "==", 1, partcv, params);
// compiled op node returning opresult7238 (depth = 6)
  int op_slot_right_7231 = gc_frame_newslot(opresult7238);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7241 == NULL) {
    strlit7241 = alloc_String("identifier");
    gc_root(strlit7241);
  }
// compiled string node returning strlit7241 (depth = 7)
  int op_slot_right_7240 = gc_frame_newslot(strlit7241);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7244 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7243);
// compiled call node returning call7244 (depth = 8)
// compiled member node returning call7244 (depth = 7)
  int op_slot_left_7240 = gc_frame_newslot(call7244);
  params[0] = strlit7241;
  partcv[0] = 1;
  Object opresult7245 = callmethod(call7244, "==", 1, partcv, params);
// compiled op node returning opresult7245 (depth = 6)
  int op_slot_left_7231 = gc_frame_newslot(opresult7245);
  params[0] = opresult7238;
  partcv[0] = 1;
  Object opresult7246 = callmethod(opresult7245, "&&", 1, partcv, params);
// compiled op node returning opresult7246 (depth = 5)
  Object if7230 = done;
  if (istrue(opresult7246)) {
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7247 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7249 == NULL) {
    strlit7249 = alloc_String("""\x22""");
    gc_root(strlit7249);
  }
// compiled string node returning strlit7249 (depth = 7)
  int op_slot_right_7248 = gc_frame_newslot(strlit7249);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7253 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7252);
// compiled call node returning call7253 (depth = 9)
// compiled member node returning call7253 (depth = 8)
  int op_slot_right_7251 = gc_frame_newslot(call7253);
// starting to compile string node (depth = 8)
  if (strlit7255 == NULL) {
    strlit7255 = alloc_String("""\x22""");
    gc_root(strlit7255);
  }
// compiled string node returning strlit7255 (depth = 8)
  int op_slot_left_7251 = gc_frame_newslot(strlit7255);
  params[0] = call7253;
  partcv[0] = 1;
  Object opresult7256 = callmethod(strlit7255, "++", 1, partcv, params);
// compiled op node returning opresult7256 (depth = 7)
  int op_slot_left_7248 = gc_frame_newslot(opresult7256);
  params[0] = strlit7249;
  partcv[0] = 1;
  Object opresult7257 = callmethod(opresult7256, "++", 1, partcv, params);
// compiled op node returning opresult7257 (depth = 6)
  gc_frame_newslot(opresult7257);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7257;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7258 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7247);
// compiled call node returning call7258 (depth = 5)
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7260 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7259);
// compiled call node returning call7260 (depth = 7)
// compiled member node returning call7260 (depth = 6)
  *var_errorPos = call7260;
  if (call7260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7230 = done;
  } else {
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7262 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7263 == NULL) {
    strlit7263 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7263);
  }
// compiled string node returning strlit7263 (depth = 6)
  gc_frame_newslot(strlit7263);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7263;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7264 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7262);
// compiled call node returning call7264 (depth = 5)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7266 = alloc_Float64(1);
// compiled num node returning num7266 (depth = 7)
  int op_slot_right_7265 = gc_frame_newslot(num7266);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7269 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7270 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7269);
// compiled call node returning call7270 (depth = 9)
// compiled member node returning call7270 (depth = 8)
  int op_slot_right_7268 = gc_frame_newslot(call7270);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7273 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7272);
// compiled call node returning call7273 (depth = 9)
// compiled member node returning call7273 (depth = 8)
  int op_slot_left_7268 = gc_frame_newslot(call7273);
  params[0] = call7270;
  partcv[0] = 1;
  Object sum7274 = callmethod(call7273, "+", 1, partcv, params);
// compiled op node returning sum7274 (depth = 7)
  int op_slot_left_7265 = gc_frame_newslot(sum7274);
  params[0] = num7266;
  partcv[0] = 1;
  Object sum7275 = callmethod(sum7274, "+", 1, partcv, params);
// compiled op node returning sum7275 (depth = 6)
  *var_errorPos = sum7275;
  if (sum7275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7230 = done;
  }
// compiled if node returning if7230 (depth = 4)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7277 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7278 == NULL) {
    strlit7278 = alloc_String("a dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7278);
  }
// compiled string node returning strlit7278 (depth = 5)
  gc_frame_newslot(strlit7278);
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7280 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 6)
// compiled member node returning call7280 (depth = 5)
  gc_frame_newslot(call7280);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7278;
  params[1] = call7280;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7281 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7277);
// compiled call node returning call7281 (depth = 4)
    gc_frame_newslot(call7281);
    if7219 = call7281;
  } else {
  }
// compiled if node returning if7219 (depth = 3)
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7282 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7283 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7284 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7285 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7284);
// compiled call node returning call7285 (depth = 6)
// compiled member node returning call7285 (depth = 5)
  gc_frame_newslot(call7285);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7287 = callmethod(*var_ast, "dialectNode",
    1, partcv, params);
  gc_frame_end(callframe7286);
// compiled call node returning call7287 (depth = 6)
// compiled member node returning call7287 (depth = 5)
  params[0] = call7285;
  partcv[0] = 1;
  Object call7288 = callmethod(call7287, "new",
    1, partcv, params);
  gc_frame_end(callframe7283);
// compiled call node returning call7288 (depth = 4)
  gc_frame_newslot(call7288);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call7288;
  partcv[0] = 1;
  Object call7289 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7282);
// compiled call node returning call7289 (depth = 3)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7291 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7290);
// compiled call node returning call7291 (depth = 4)
// compiled member node returning call7291 (depth = 3)
    gc_frame_newslot(call7291);
    if7213 = call7291;
  } else {
  }
// compiled if node returning if7213 (depth = 2)
  gc_frame_end(frame);
  return if7213;
}
Object meth_parser__apply7332(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe7333 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_noBlocks (depth = 9)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call7334 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7333);
// compiled call node returning call7334 (depth = 8)
  gc_frame_end(frame);
  return call7334;
}
Object meth_parser__apply7442(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_inhNode = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7443 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inhNode (depth = 6)
  gc_frame_newslot(*var_inhNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 4: self request
  params[0] = *var_inhNode;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7444 = callmethodflags(self, "inheritsModifier()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7443);
// compiled call node returning call7444 (depth = 5)
  gc_frame_end(frame);
  return call7444;
}
Object meth_parser__apply7447(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_parser_inheritsOrUses7292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsOrUses");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for inheritsOrUses (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for inheritsOrUses");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_msg = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "msg");
  Object *var_inhNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inhNode");
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7294 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7295 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7296 == NULL) {
    strlit7296 = alloc_String("keyword");
    gc_root(strlit7296);
  }
// compiled string node returning strlit7296 (depth = 5)
  gc_frame_newslot(strlit7296);
// call case 4: self request
  params[0] = strlit7296;
  partcv[0] = 1;
  Object call7297 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7295);
// compiled call node returning call7297 (depth = 4)
  partcv[0] = 0;
  Object call7298 = callmethod(call7297, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7294);
// compiled call node returning call7298 (depth = 3)
  Object if7293 = done;
  if (istrue(call7298)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7293 = undefined;
  } else {
  }
// compiled if node returning if7293 (depth = 2)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7302 == NULL) {
    strlit7302 = alloc_String("use");
    gc_root(strlit7302);
  }
// compiled string node returning strlit7302 (depth = 5)
  int op_slot_right_7301 = gc_frame_newslot(strlit7302);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7305 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7304);
// compiled call node returning call7305 (depth = 6)
// compiled member node returning call7305 (depth = 5)
  int op_slot_left_7301 = gc_frame_newslot(call7305);
  params[0] = strlit7302;
  partcv[0] = 1;
  Object opresult7306 = callmethod(call7305, "==", 1, partcv, params);
// compiled op node returning opresult7306 (depth = 4)
  int op_slot_right_7300 = gc_frame_newslot(opresult7306);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7310 == NULL) {
    strlit7310 = alloc_String("inherit");
    gc_root(strlit7310);
  }
// compiled string node returning strlit7310 (depth = 6)
  int op_slot_right_7309 = gc_frame_newslot(strlit7310);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7313 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7312);
// compiled call node returning call7313 (depth = 7)
// compiled member node returning call7313 (depth = 6)
  int op_slot_left_7309 = gc_frame_newslot(call7313);
  params[0] = strlit7310;
  partcv[0] = 1;
  Object opresult7314 = callmethod(call7313, "==", 1, partcv, params);
// compiled op node returning opresult7314 (depth = 5)
  int op_slot_right_7308 = gc_frame_newslot(opresult7314);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7317 == NULL) {
    strlit7317 = alloc_String("inherits");
    gc_root(strlit7317);
  }
// compiled string node returning strlit7317 (depth = 6)
  int op_slot_right_7316 = gc_frame_newslot(strlit7317);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7320 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7319);
// compiled call node returning call7320 (depth = 7)
// compiled member node returning call7320 (depth = 6)
  int op_slot_left_7316 = gc_frame_newslot(call7320);
  params[0] = strlit7317;
  partcv[0] = 1;
  Object opresult7321 = callmethod(call7320, "==", 1, partcv, params);
// compiled op node returning opresult7321 (depth = 5)
  int op_slot_left_7308 = gc_frame_newslot(opresult7321);
  params[0] = opresult7314;
  partcv[0] = 1;
  Object opresult7322 = callmethod(opresult7321, "||", 1, partcv, params);
// compiled op node returning opresult7322 (depth = 4)
  int op_slot_left_7300 = gc_frame_newslot(opresult7322);
  params[0] = opresult7306;
  partcv[0] = 1;
  Object opresult7323 = callmethod(opresult7322, "||", 1, partcv, params);
// compiled op node returning opresult7323 (depth = 3)
  Object if7299 = done;
  if (istrue(opresult7323)) {
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7325 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7324);
// compiled call node returning call7325 (depth = 4)
// compiled member node returning call7325 (depth = 3)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7326 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7327 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7326);
// compiled call node returning call7327 (depth = 4)
// compiled member node returning call7327 (depth = 3)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7329 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe7330 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7331 = alloc_Block(NULL, NULL, "parser", 2297);
  gc_frame_newslot(block7331);
// method "_apply"
  block_savedest(block7331);
  Object closure7332 = createclosure(2, "_apply");
  setclosureframe(closure7332, stackframe);
  addtoclosure(closure7332, var_noBlocks);
  addtoclosure(closure7332, selfslot);
  struct UserObject *uo7332 = (struct UserObject*)block7331;
  uo7332->data[0] = (Object)closure7332;
  Method *meth_meth_parser__apply7332 = addmethod2pos(block7331, "_apply", &meth_parser__apply7332, 0);
  int argcv_meth_parser__apply7332[] = {0};
  meth_meth_parser__apply7332->type = alloc_MethodType(1, argcv_meth_parser__apply7332);
  meth_meth_parser__apply7332->definitionModule = modulename;
  meth_meth_parser__apply7332->definitionLine = 2297;
// compiled block node returning block7331 (depth = 7)
  gc_frame_newslot(block7331);
// call case 4: self request
  params[0] = block7331;
  partcv[0] = 1;
  Object call7336 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7330);
// compiled call node returning call7336 (depth = 6)
  partcv[0] = 0;
  Object call7337 = callmethod(call7336, "not",
    1, partcv, params);
  gc_frame_end(callframe7329);
// compiled call node returning call7337 (depth = 5)
// compiled member node returning call7337 (depth = 4)
  Object if7328 = done;
  if (istrue(call7337)) {
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array7338 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7338 (depth = 5)
  *var_suggestions = array7338;
  if (array7338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7339 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7341 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7340);
// compiled call node returning call7341 (depth = 8)
// compiled member node returning call7341 (depth = 7)
  partcv[0] = 0;
  Object call7342 = callmethod(call7341, "new",
    1, partcv, params);
  gc_frame_end(callframe7339);
// compiled call node returning call7342 (depth = 6)
// compiled member node returning call7342 (depth = 5)
  *var_suggestion = call7342;
  if (call7342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7343 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array7344 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit7345 == NULL) {
    strlit7345 = alloc_String("rsquare");
    gc_root(strlit7345);
  }
// compiled string node returning strlit7345 (depth = 7)
  params[0] = strlit7345;
  partcv[0] = 1;
  callmethodflags(array7344, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7344 (depth = 6)
  gc_frame_newslot(array7344);
// call case 4: self request
  params[0] = array7344;
  partcv[0] = 1;
  Object call7346 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7343);
// compiled call node returning call7346 (depth = 5)
  *var_nextTok = call7346;
  if (call7346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_7348 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7348 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7350 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7350 (depth = 5)
  Object if7347 = done;
  if (istrue(opresult7350)) {
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7351 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7352 == NULL) {
    strlit7352 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7352);
  }
// compiled string node returning strlit7352 (depth = 6)
  gc_frame_newslot(strlit7352);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7352;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7353 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7351);
// compiled call node returning call7353 (depth = 5)
    gc_frame_newslot(call7353);
    if7347 = call7353;
  } else {
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7354 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7356 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7355);
// compiled call node returning call7356 (depth = 7)
// compiled member node returning call7356 (depth = 6)
  gc_frame_newslot(call7356);
// starting to compile identifier node (depth = 6)
  Object bool7357 = alloc_Boolean(1);
// compiled identifier node returning bool7357 (depth = 6)
  gc_frame_newslot(bool7357);
// starting to compile identifier node (depth = 6)
  Object bool7358 = alloc_Boolean(0);
// compiled identifier node returning bool7358 (depth = 6)
  gc_frame_newslot(bool7358);
// starting to compile string node (depth = 6)
  if (strlit7359 == NULL) {
    strlit7359 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7359);
  }
// compiled string node returning strlit7359 (depth = 6)
  gc_frame_newslot(strlit7359);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7356;
  params[2] = bool7357;
  params[3] = bool7358;
  params[4] = strlit7359;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7360 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7354);
// compiled call node returning call7360 (depth = 5)
    gc_frame_newslot(call7360);
    if7347 = call7360;
  }
// compiled if node returning if7347 (depth = 4)
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7361 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7362 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7361);
// compiled call node returning call7362 (depth = 4)
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7363 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7364 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7365 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7364);
// compiled call node returning call7365 (depth = 8)
// compiled member node returning call7365 (depth = 7)
  partcv[0] = 0;
  Object call7366 = callmethod(call7365, "new",
    1, partcv, params);
  gc_frame_end(callframe7363);
// compiled call node returning call7366 (depth = 6)
// compiled member node returning call7366 (depth = 5)
  *var_suggestion = call7366;
  if (call7366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7368 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7369 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call7370 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7369);
// compiled call node returning call7370 (depth = 6)
// compiled member node returning call7370 (depth = 5)
  gc_frame_newslot(call7370);
// starting to compile identifier node (depth = 5)
  Object bool7371 = alloc_Boolean(1);
// compiled identifier node returning bool7371 (depth = 5)
  gc_frame_newslot(bool7371);
// starting to compile identifier node (depth = 5)
  Object bool7372 = alloc_Boolean(0);
// compiled identifier node returning bool7372 (depth = 5)
  gc_frame_newslot(bool7372);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call7370;
  params[2] = bool7371;
  params[3] = bool7372;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7373 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7368);
// compiled call node returning call7373 (depth = 4)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7374 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7375 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7374);
// compiled call node returning call7375 (depth = 4)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7377 == NULL) {
    strlit7377 = alloc_String(" keyword must be followed by an expression that creates ");
    gc_root(strlit7377);
  }
// compiled string node returning strlit7377 (depth = 6)
  int op_slot_right_7376 = gc_frame_newslot(strlit7377);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call7381 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7380);
// compiled call node returning call7381 (depth = 8)
// compiled member node returning call7381 (depth = 7)
  int op_slot_right_7379 = gc_frame_newslot(call7381);
// starting to compile string node (depth = 7)
  if (strlit7383 == NULL) {
    strlit7383 = alloc_String("The ");
    gc_root(strlit7383);
  }
// compiled string node returning strlit7383 (depth = 7)
  int op_slot_left_7379 = gc_frame_newslot(strlit7383);
  params[0] = call7381;
  partcv[0] = 1;
  Object opresult7384 = callmethod(strlit7383, "++", 1, partcv, params);
// compiled op node returning opresult7384 (depth = 6)
  int op_slot_left_7376 = gc_frame_newslot(opresult7384);
  params[0] = strlit7377;
  partcv[0] = 1;
  Object opresult7385 = callmethod(opresult7384, "++", 1, partcv, params);
// compiled op node returning opresult7385 (depth = 5)
  *var_msg = opresult7385;
  if (opresult7385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7388 == NULL) {
    strlit7388 = alloc_String("use");
    gc_root(strlit7388);
  }
// compiled string node returning strlit7388 (depth = 6)
  int op_slot_right_7387 = gc_frame_newslot(strlit7388);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call7391 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7390);
// compiled call node returning call7391 (depth = 7)
// compiled member node returning call7391 (depth = 6)
  int op_slot_left_7387 = gc_frame_newslot(call7391);
  params[0] = strlit7388;
  partcv[0] = 1;
  Object opresult7392 = callmethod(call7391, "==", 1, partcv, params);
// compiled op node returning opresult7392 (depth = 5)
  Object if7386 = done;
  if (istrue(opresult7392)) {
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7394 == NULL) {
    strlit7394 = alloc_String("the trait being used.");
    gc_root(strlit7394);
  }
// compiled string node returning strlit7394 (depth = 7)
  int op_slot_right_7393 = gc_frame_newslot(strlit7394);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7393 = gc_frame_newslot(*var_msg);
  params[0] = strlit7394;
  partcv[0] = 1;
  Object opresult7396 = callmethod(*var_msg, "++", 1, partcv, params);
// compiled op node returning opresult7396 (depth = 6)
  *var_msg = opresult7396;
  if (opresult7396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7386 = done;
  } else {
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7399 == NULL) {
    strlit7399 = alloc_String("the object being inherited.");
    gc_root(strlit7399);
  }
// compiled string node returning strlit7399 (depth = 7)
  int op_slot_right_7398 = gc_frame_newslot(strlit7399);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_msg (depth = 7)
  int op_slot_left_7398 = gc_frame_newslot(*var_msg);
  params[0] = strlit7399;
  partcv[0] = 1;
  Object opresult7401 = callmethod(*var_msg, "++", 1, partcv, params);
// compiled op node returning opresult7401 (depth = 6)
  *var_msg = opresult7401;
  if (opresult7401 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7386 = done;
  }
// compiled if node returning if7386 (depth = 4)
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7403 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_msg (depth = 5)
  gc_frame_newslot(*var_msg);
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7404 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7405 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7404);
// compiled call node returning call7405 (depth = 6)
// compiled member node returning call7405 (depth = 5)
  gc_frame_newslot(call7405);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7407 = alloc_Float64(1);
// compiled num node returning num7407 (depth = 6)
  int op_slot_right_7406 = gc_frame_newslot(num7407);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7410 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7411 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7410);
// compiled call node returning call7411 (depth = 8)
// compiled member node returning call7411 (depth = 7)
  int op_slot_right_7409 = gc_frame_newslot(call7411);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7414 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7413);
// compiled call node returning call7414 (depth = 8)
// compiled member node returning call7414 (depth = 7)
  int op_slot_left_7409 = gc_frame_newslot(call7414);
  params[0] = call7411;
  partcv[0] = 1;
  Object sum7415 = callmethod(call7414, "+", 1, partcv, params);
// compiled op node returning sum7415 (depth = 6)
  int op_slot_left_7406 = gc_frame_newslot(sum7415);
  params[0] = num7407;
  partcv[0] = 1;
  Object sum7416 = callmethod(sum7415, "+", 1, partcv, params);
// compiled op node returning sum7416 (depth = 5)
  gc_frame_newslot(sum7416);
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = *var_msg;
  params[1] = call7405;
  params[2] = sum7416;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7417 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7403);
// compiled call node returning call7417 (depth = 4)
    gc_frame_newslot(call7417);
    if7328 = call7417;
  } else {
  }
// compiled if node returning if7328 (depth = 3)
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7418 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7420 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7419);
// compiled call node returning call7420 (depth = 5)
// compiled member node returning call7420 (depth = 4)
  gc_frame_newslot(call7420);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7422 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7421);
// compiled call node returning call7422 (depth = 5)
// compiled member node returning call7422 (depth = 4)
  gc_frame_newslot(call7422);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7420;
  params[1] = call7422;
  partcv[0] = 2;
  Object call7423 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7418);
// compiled call node returning call7423 (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7424 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7425 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7426 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7425);
// compiled call node returning call7426 (depth = 6)
// compiled member node returning call7426 (depth = 5)
  gc_frame_newslot(call7426);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7428 = callmethod(*var_ast, "inheritsNode",
    1, partcv, params);
  gc_frame_end(callframe7427);
// compiled call node returning call7428 (depth = 6)
// compiled member node returning call7428 (depth = 5)
  params[0] = call7426;
  partcv[0] = 1;
  Object call7429 = callmethod(call7428, "new",
    1, partcv, params);
  gc_frame_end(callframe7424);
// compiled call node returning call7429 (depth = 4)
  *var_inhNode = call7429;
  if (call7429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7432 == NULL) {
    strlit7432 = alloc_String("use");
    gc_root(strlit7432);
  }
// compiled string node returning strlit7432 (depth = 5)
  int op_slot_right_7431 = gc_frame_newslot(strlit7432);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call7435 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe7434);
// compiled call node returning call7435 (depth = 6)
// compiled member node returning call7435 (depth = 5)
  int op_slot_left_7431 = gc_frame_newslot(call7435);
  params[0] = strlit7432;
  partcv[0] = 1;
  Object opresult7436 = callmethod(call7435, "==", 1, partcv, params);
// compiled op node returning opresult7436 (depth = 4)
  Object if7430 = done;
  if (istrue(opresult7436)) {
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7437 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7438 = alloc_Boolean(1);
// compiled identifier node returning bool7438 (depth = 5)
  gc_frame_newslot(bool7438);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inhNode (depth = 5)
  params[0] = bool7438;
  partcv[0] = 1;
  Object call7439 = callmethod(*var_inhNode, "isUse:=",
    1, partcv, params);
  gc_frame_end(callframe7437);
// compiled call node returning call7439 (depth = 4)
    gc_frame_newslot(call7439);
    if7430 = call7439;
  } else {
  }
// compiled if node returning if7430 (depth = 3)
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7440 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7441 = alloc_Block(NULL, NULL, "parser", 2325);
  gc_frame_newslot(block7441);
// method "_apply"
  block_savedest(block7441);
  Object closure7442 = createclosure(3, "_apply");
  setclosureframe(closure7442, stackframe);
  addtoclosure(closure7442, var_inhNode);
  addtoclosure(closure7442, var_btok);
  addtoclosure(closure7442, selfslot);
  struct UserObject *uo7442 = (struct UserObject*)block7441;
  uo7442->data[0] = (Object)closure7442;
  Method *meth_meth_parser__apply7442 = addmethod2pos(block7441, "_apply", &meth_parser__apply7442, 0);
  int argcv_meth_parser__apply7442[] = {0};
  meth_meth_parser__apply7442->type = alloc_MethodType(1, argcv_meth_parser__apply7442);
  meth_meth_parser__apply7442->definitionModule = modulename;
  meth_meth_parser__apply7442->definitionLine = 2322;
// compiled block node returning block7441 (depth = 4)
  gc_frame_newslot(block7441);
// starting to compile block node (depth = 4)
  Object block7446 = alloc_Block(NULL, NULL, "parser", 2325);
  gc_frame_newslot(block7446);
// method "_apply"
  block_savedest(block7446);
  Object closure7447 = createclosure(1, "_apply");
  setclosureframe(closure7447, stackframe);
  addtoclosure(closure7447, selfslot);
  struct UserObject *uo7447 = (struct UserObject*)block7446;
  uo7447->data[0] = (Object)closure7447;
  Method *meth_meth_parser__apply7447 = addmethod2pos(block7446, "_apply", &meth_parser__apply7447, 0);
  int argcv_meth_parser__apply7447[] = {0};
  meth_meth_parser__apply7447->type = alloc_MethodType(1, argcv_meth_parser__apply7447);
  meth_meth_parser__apply7447->definitionModule = modulename;
  meth_meth_parser__apply7447->definitionLine = 2322;
// compiled block node returning block7446 (depth = 4)
  gc_frame_newslot(block7446);
// call case 5: prelude request
  params[0] = block7441;
  params[1] = block7446;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7449 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7440);
// compiled call node returning call7449 (depth = 3)
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7450 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call7451 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7450);
// compiled call node returning call7451 (depth = 3)
    gc_frame_newslot(call7451);
    if7299 = call7451;
  } else {
  }
// compiled if node returning if7299 (depth = 2)
  gc_frame_end(frame);
  return if7299;
}
Object meth_parser_inheritsModifier_40__41_onLineOf7452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsModifier()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method inheritsModifier()onLineOf");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for inheritsModifier()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for inheritsModifier");
  Object *var_startToken = &(stackframe->slots[1]);
  *var_startToken = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7454 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe7455 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7456 == NULL) {
    strlit7456 = alloc_String("keyword");
    gc_root(strlit7456);
  }
// compiled string node returning strlit7456 (depth = 5)
  gc_frame_newslot(strlit7456);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 4: self request
  params[0] = strlit7456;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7457 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7455);
// compiled call node returning call7457 (depth = 4)
  partcv[0] = 0;
  Object call7458 = callmethod(call7457, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7454);
// compiled call node returning call7458 (depth = 3)
  Object if7453 = done;
  if (istrue(call7458)) {
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool7459 = alloc_Boolean(0);
// compiled identifier node returning bool7459 (depth = 4)
  return bool7459;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if7453 = undefined;
  } else {
  }
// compiled if node returning if7453 (depth = 2)
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7462 == NULL) {
    strlit7462 = alloc_String("alias");
    gc_root(strlit7462);
  }
// compiled string node returning strlit7462 (depth = 4)
  int op_slot_right_7461 = gc_frame_newslot(strlit7462);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7465 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7464);
// compiled call node returning call7465 (depth = 5)
// compiled member node returning call7465 (depth = 4)
  int op_slot_left_7461 = gc_frame_newslot(call7465);
  params[0] = strlit7462;
  partcv[0] = 1;
  Object opresult7466 = callmethod(call7465, "==", 1, partcv, params);
// compiled op node returning opresult7466 (depth = 3)
  Object if7460 = done;
  if (istrue(opresult7466)) {
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7467 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7468 = callmethodflags(self, "parseAlias", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7467);
// compiled call node returning call7468 (depth = 3)
    gc_frame_newslot(call7468);
    if7460 = call7468;
  } else {
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7471 == NULL) {
    strlit7471 = alloc_String("exclude");
    gc_root(strlit7471);
  }
// compiled string node returning strlit7471 (depth = 5)
  int op_slot_right_7470 = gc_frame_newslot(strlit7471);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7474 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7473);
// compiled call node returning call7474 (depth = 6)
// compiled member node returning call7474 (depth = 5)
  int op_slot_left_7470 = gc_frame_newslot(call7474);
  params[0] = strlit7471;
  partcv[0] = 1;
  Object opresult7475 = callmethod(call7474, "==", 1, partcv, params);
// compiled op node returning opresult7475 (depth = 4)
  Object if7469 = done;
  if (istrue(opresult7475)) {
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7476 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  gc_frame_newslot(*var_node);
// call case 4: self request
  params[0] = *var_node;
  partcv[0] = 1;
  Object call7477 = callmethodflags(self, "parseExclude", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7476);
// compiled call node returning call7477 (depth = 4)
    gc_frame_newslot(call7477);
    if7469 = call7477;
  } else {
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7478 = alloc_Boolean(0);
// compiled identifier node returning bool7478 (depth = 4)
    gc_frame_newslot(bool7478);
    if7469 = bool7478;
  }
// compiled if node returning if7469 (depth = 3)
    gc_frame_newslot(if7469);
    if7460 = if7469;
  }
// compiled if node returning if7460 (depth = 2)
  gc_frame_end(frame);
  return if7460;
}
Object meth_parser_parseAlias7479(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseAlias");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseAlias");
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseAlias (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseAlias");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newSig = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newSig");
  Object *var_newMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "newMeth");
  Object *var_oldSig = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "oldSig");
  Object *var_oldMeth = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "oldMeth");
// Begin line 2345
  setline(2345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7481 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7480);
// compiled call node returning call7481 (depth = 3)
// compiled member node returning call7481 (depth = 2)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7482 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7483 = alloc_Boolean(1);
// compiled identifier node returning bool7483 (depth = 4)
  gc_frame_newslot(bool7483);
// call case 4: self request
  params[0] = bool7483;
  partcv[0] = 1;
  Object call7484 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7482);
// compiled call node returning call7484 (depth = 3)
  *var_newSig = call7484;
  if (call7484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newSig (depth = 5)
  partcv[0] = 0;
  Object call7486 = callmethod(*var_newSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7485);
// compiled call node returning call7486 (depth = 4)
// compiled member node returning call7486 (depth = 3)
  *var_newMeth = call7486;
  if (call7486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7490 == NULL) {
    strlit7490 = alloc_String("=");
    gc_root(strlit7490);
  }
// compiled string node returning strlit7490 (depth = 5)
  int op_slot_right_7489 = gc_frame_newslot(strlit7490);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7492 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7493 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7492);
// compiled call node returning call7493 (depth = 6)
// compiled member node returning call7493 (depth = 5)
  int op_slot_left_7489 = gc_frame_newslot(call7493);
  params[0] = strlit7490;
  partcv[0] = 1;
  Object opresult7494 = callmethod(call7493, "==", 1, partcv, params);
// compiled op node returning opresult7494 (depth = 4)
  int op_slot_right_7488 = gc_frame_newslot(opresult7494);
// starting to compile call node (depth = 4)
  int callframe7496 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7497 == NULL) {
    strlit7497 = alloc_String("op");
    gc_root(strlit7497);
  }
// compiled string node returning strlit7497 (depth = 5)
  gc_frame_newslot(strlit7497);
// call case 4: self request
  params[0] = strlit7497;
  partcv[0] = 1;
  Object call7498 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7496);
// compiled call node returning call7498 (depth = 4)
  int op_slot_left_7488 = gc_frame_newslot(call7498);
  params[0] = opresult7494;
  partcv[0] = 1;
  Object opresult7499 = callmethod(call7498, "&&", 1, partcv, params);
// compiled op node returning opresult7499 (depth = 3)
  Object if7487 = done;
  if (istrue(opresult7499)) {
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7501 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7500);
// compiled call node returning call7501 (depth = 4)
// compiled member node returning call7501 (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7502 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool7503 = alloc_Boolean(1);
// compiled identifier node returning bool7503 (depth = 5)
  gc_frame_newslot(bool7503);
// call case 4: self request
  params[0] = bool7503;
  partcv[0] = 1;
  Object call7504 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7502);
// compiled call node returning call7504 (depth = 4)
  *var_oldSig = call7504;
  if (call7504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldSig (depth = 6)
  partcv[0] = 0;
  Object call7506 = callmethod(*var_oldSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7505);
// compiled call node returning call7506 (depth = 5)
// compiled member node returning call7506 (depth = 4)
  *var_oldMeth = call7506;
  if (call7506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7507 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7508 = alloc_Boolean(0);
// compiled identifier node returning bool7508 (depth = 4)
  gc_frame_newslot(bool7508);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMeth (depth = 4)
  params[0] = bool7508;
  partcv[0] = 1;
  Object call7509 = callmethod(*var_oldMeth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7507);
// compiled call node returning call7509 (depth = 3)
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7510 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newMeth (depth = 4)
  gc_frame_newslot(*var_newMeth);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_oldMeth (depth = 4)
  gc_frame_newslot(*var_oldMeth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  params[0] = *var_newMeth;
  params[1] = *var_oldMeth;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7511 = callmethod(*var_node, "addAlias()for",
    2, partcv, params);
  gc_frame_end(callframe7510);
// compiled call node returning call7511 (depth = 3)
    gc_frame_newslot(call7511);
    if7487 = call7511;
  } else {
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7512 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7514 == NULL) {
    strlit7514 = alloc_String("'newMethodName = oldMethodName'");
    gc_root(strlit7514);
  }
// compiled string node returning strlit7514 (depth = 5)
  int op_slot_right_7513 = gc_frame_newslot(strlit7514);
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7516 == NULL) {
    strlit7516 = alloc_String("An alias modifier must take the form ");
    gc_root(strlit7516);
  }
// compiled string node returning strlit7516 (depth = 5)
  int op_slot_left_7513 = gc_frame_newslot(strlit7516);
  params[0] = strlit7514;
  partcv[0] = 1;
  Object opresult7517 = callmethod(strlit7516, "++", 1, partcv, params);
// compiled op node returning opresult7517 (depth = 4)
  gc_frame_newslot(opresult7517);
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7519 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7518);
// compiled call node returning call7519 (depth = 5)
// compiled member node returning call7519 (depth = 4)
  gc_frame_newslot(call7519);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7522 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7521);
// compiled call node returning call7522 (depth = 6)
// compiled member node returning call7522 (depth = 5)
  int op_slot_right_7520 = gc_frame_newslot(call7522);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7525 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7524);
// compiled call node returning call7525 (depth = 6)
// compiled member node returning call7525 (depth = 5)
  int op_slot_left_7520 = gc_frame_newslot(call7525);
  params[0] = call7522;
  partcv[0] = 1;
  Object sum7526 = callmethod(call7525, "+", 1, partcv, params);
// compiled op node returning sum7526 (depth = 4)
  gc_frame_newslot(sum7526);
// call case 6: other member request
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7517;
  params[1] = call7519;
  params[2] = sum7526;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call7527 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe7512);
// compiled call node returning call7527 (depth = 3)
    gc_frame_newslot(call7527);
    if7487 = call7527;
  }
// compiled if node returning if7487 (depth = 2)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7528 = alloc_Boolean(1);
// compiled identifier node returning bool7528 (depth = 3)
  return bool7528;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_parseExclude7529(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parseExclude");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseExclude");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parseExclude (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseExclude");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_exSig = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "exSig");
  Object *var_excludedMeth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "excludedMeth");
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7531 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7530);
// compiled call node returning call7531 (depth = 3)
// compiled member node returning call7531 (depth = 2)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7532 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7533 = alloc_Boolean(1);
// compiled identifier node returning bool7533 (depth = 4)
  gc_frame_newslot(bool7533);
// call case 4: self request
  params[0] = bool7533;
  partcv[0] = 1;
  Object call7534 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7532);
// compiled call node returning call7534 (depth = 3)
  *var_exSig = call7534;
  if (call7534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_exSig (depth = 5)
  partcv[0] = 0;
  Object call7536 = callmethod(*var_exSig, "m",
    1, partcv, params);
  gc_frame_end(callframe7535);
// compiled call node returning call7536 (depth = 4)
// compiled member node returning call7536 (depth = 3)
  *var_excludedMeth = call7536;
  if (call7536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7537 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool7538 = alloc_Boolean(0);
// compiled identifier node returning bool7538 (depth = 3)
  gc_frame_newslot(bool7538);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_excludedMeth (depth = 3)
  params[0] = bool7538;
  partcv[0] = 1;
  Object call7539 = callmethod(*var_excludedMeth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7537);
// compiled call node returning call7539 (depth = 2)
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7540 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_excludedMeth (depth = 3)
  gc_frame_newslot(*var_excludedMeth);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_excludedMeth;
  partcv[0] = 1;
  Object call7541 = callmethod(*var_node, "addExclusion",
    1, partcv, params);
  gc_frame_end(callframe7540);
// compiled call node returning call7541 (depth = 2)
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7542 = alloc_Boolean(1);
// compiled identifier node returning bool7542 (depth = 3)
  return bool7542;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_doobject7543(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doobject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doobject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7545 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7546 == NULL) {
    strlit7546 = alloc_String("object");
    gc_root(strlit7546);
  }
// compiled string node returning strlit7546 (depth = 4)
  gc_frame_newslot(strlit7546);
// call case 4: self request
  params[0] = strlit7546;
  partcv[0] = 1;
  Object call7547 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7545);
// compiled call node returning call7547 (depth = 3)
  Object if7544 = done;
  if (istrue(call7547)) {
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7548 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7549 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7548);
// compiled call node returning call7549 (depth = 4)
// compiled member node returning call7549 (depth = 3)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7550 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7551 == NULL) {
    strlit7551 = alloc_String("an object constructor");
    gc_root(strlit7551);
  }
// compiled string node returning strlit7551 (depth = 4)
  gc_frame_newslot(strlit7551);
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 4)
  if (strlit7552 == NULL) {
    strlit7552 = alloc_String("'object'");
    gc_root(strlit7552);
  }
// compiled string node returning strlit7552 (depth = 4)
  gc_frame_newslot(strlit7552);
// call case 4: self request
  params[0] = strlit7551;
  params[1] = *var_lastToken;
  params[2] = strlit7552;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7553 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7550);
// compiled call node returning call7553 (depth = 3)
    gc_frame_newslot(call7553);
    if7544 = call7553;
  } else {
  }
// compiled if node returning if7544 (depth = 2)
  gc_frame_end(frame);
  return if7544;
}
Object meth_parser__apply7570(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7572 == NULL) {
    strlit7572 = alloc_String("rbrace");
    gc_root(strlit7572);
  }
// compiled string node returning strlit7572 (depth = 7)
  int op_slot_right_7571 = gc_frame_newslot(strlit7572);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  partcv[0] = 0;
  Object call7575 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7574);
// compiled call node returning call7575 (depth = 8)
// compiled member node returning call7575 (depth = 7)
  int op_slot_left_7571 = gc_frame_newslot(call7575);
  params[0] = strlit7572;
  partcv[0] = 1;
  Object opresult7576 = callmethod(call7575, "==", 1, partcv, params);
// compiled op node returning opresult7576 (depth = 6)
  gc_frame_end(frame);
  return opresult7576;
}
Object meth_parser__apply7649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7651 == NULL) {
    strlit7651 = alloc_String("eof");
    gc_root(strlit7651);
  }
// compiled string node returning strlit7651 (depth = 7)
  int op_slot_right_7650 = gc_frame_newslot(strlit7651);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7654 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7653);
// compiled call node returning call7654 (depth = 8)
// compiled member node returning call7654 (depth = 7)
  int op_slot_left_7650 = gc_frame_newslot(call7654);
  params[0] = strlit7651;
  partcv[0] = 1;
  Object opresult7655 = callmethod(call7654, "≠", 1, partcv, params);
// compiled op node returning opresult7655 (depth = 6)
  gc_frame_end(frame);
  return opresult7655;
}
Object meth_parser__apply7646(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block7648 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7648);
// method "_apply"
  block_savedest(block7648);
  Object closure7649 = createclosure(2, "_apply");
  setclosureframe(closure7649, stackframe);
  addtoclosure(closure7649, var_sym);
  addtoclosure(closure7649, selfslot);
  struct UserObject *uo7649 = (struct UserObject*)block7648;
  uo7649->data[0] = (Object)closure7649;
  Method *meth_meth_parser__apply7649 = addmethod2pos(block7648, "_apply", &meth_parser__apply7649, 0);
  int argcv_meth_parser__apply7649[] = {0};
  meth_meth_parser__apply7649->type = alloc_MethodType(1, argcv_meth_parser__apply7649);
  meth_meth_parser__apply7649->definitionModule = modulename;
  meth_meth_parser__apply7649->definitionLine = 2404;
// compiled block node returning block7648 (depth = 5)
  int op_slot_right_7647 = gc_frame_newslot(block7648);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7658 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7659 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7660 == NULL) {
    strlit7660 = alloc_String("rbrace");
    gc_root(strlit7660);
  }
// compiled string node returning strlit7660 (depth = 8)
  gc_frame_newslot(strlit7660);
// call case 4: self request
  params[0] = strlit7660;
  partcv[0] = 1;
  Object call7661 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7659);
// compiled call node returning call7661 (depth = 7)
  partcv[0] = 0;
  Object call7662 = callmethod(call7661, "not",
    1, partcv, params);
  gc_frame_end(callframe7658);
// compiled call node returning call7662 (depth = 6)
// compiled member node returning call7662 (depth = 5)
  int op_slot_left_7647 = gc_frame_newslot(call7662);
  params[0] = block7648;
  partcv[0] = 1;
  Object opresult7663 = callmethod(call7662, "&&", 1, partcv, params);
// compiled op node returning opresult7663 (depth = 4)
  gc_frame_end(frame);
  return opresult7663;
}
Object meth_parser__apply7670(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7672 = callmethodflags(self, "inheritsOrUses", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7671);
// compiled call node returning call7672 (depth = 8)
// compiled member node returning call7672 (depth = 7)
  gc_frame_end(frame);
  return call7672;
}
Object meth_parser__apply7750(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7751 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7752 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7751);
// compiled call node returning call7752 (depth = 9)
// compiled member node returning call7752 (depth = 8)
  gc_frame_end(frame);
  return call7752;
}
Object meth_parser__apply7764(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7766 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7765);
// compiled call node returning call7766 (depth = 10)
// compiled member node returning call7766 (depth = 9)
  gc_frame_end(frame);
  return call7766;
}
Object meth_parser__apply7666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_inPreamble = getfromclosure(closure, 1);
  Object *var_usedTraits = getfromclosure(closure, 2);
  Object *var_superObject = getfromclosure(closure, 3);
  Object *var_constructName = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7668 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7669 = alloc_Block(NULL, NULL, "parser", 2411);
  gc_frame_newslot(block7669);
// method "_apply"
  block_savedest(block7669);
  Object closure7670 = createclosure(1, "_apply");
  setclosureframe(closure7670, stackframe);
  addtoclosure(closure7670, selfslot);
  struct UserObject *uo7670 = (struct UserObject*)block7669;
  uo7670->data[0] = (Object)closure7670;
  Method *meth_meth_parser__apply7670 = addmethod2pos(block7669, "_apply", &meth_parser__apply7670, 0);
  int argcv_meth_parser__apply7670[] = {0};
  meth_meth_parser__apply7670->type = alloc_MethodType(1, argcv_meth_parser__apply7670);
  meth_meth_parser__apply7670->definitionModule = modulename;
  meth_meth_parser__apply7670->definitionLine = 2410;
// compiled block node returning block7669 (depth = 6)
  gc_frame_newslot(block7669);
// call case 4: self request
  params[0] = block7669;
  partcv[0] = 1;
  Object call7674 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7668);
// compiled call node returning call7674 (depth = 5)
  Object if7667 = done;
  if (istrue(call7674)) {
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7676 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7675);
// compiled call node returning call7676 (depth = 7)
// compiled member node returning call7676 (depth = 6)
  *var_parentNode = call7676;
  if (call7676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inPreamble (depth = 6)
  Object if7677 = done;
  if (istrue(*var_inPreamble)) {
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7680 = callmethod(*var_parentNode, "isUse",
    1, partcv, params);
  gc_frame_end(callframe7679);
// compiled call node returning call7680 (depth = 8)
// compiled member node returning call7680 (depth = 7)
  Object if7678 = done;
  if (istrue(call7680)) {
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7681 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_usedTraits (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call7682 = callmethod(*var_usedTraits, "add",
    1, partcv, params);
  gc_frame_end(callframe7681);
// compiled call node returning call7682 (depth = 7)
    gc_frame_newslot(call7682);
    if7678 = call7682;
  } else {
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7684 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_usedTraits (depth = 10)
  partcv[0] = 0;
  Object call7685 = callmethod(*var_usedTraits, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe7684);
// compiled call node returning call7685 (depth = 9)
// compiled member node returning call7685 (depth = 8)
  Object if7683 = done;
  if (istrue(call7685)) {
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  *var_superObject = *var_parentNode;
  if (*var_parentNode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if7683 = done;
  } else {
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7687 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7690 == NULL) {
    strlit7690 = alloc_String("");
    gc_root(strlit7690);
  }
// compiled string node returning strlit7690 (depth = 11)
  int op_slot_right_7689 = gc_frame_newslot(strlit7690);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_constructName (depth = 12)
  int op_slot_right_7692 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 12)
  if (strlit7694 == NULL) {
    strlit7694 = alloc_String("before 'use' in ");
    gc_root(strlit7694);
  }
// compiled string node returning strlit7694 (depth = 12)
  int op_slot_left_7692 = gc_frame_newslot(strlit7694);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7695 = callmethod(strlit7694, "++", 1, partcv, params);
// compiled op node returning opresult7695 (depth = 11)
  int op_slot_left_7689 = gc_frame_newslot(opresult7695);
  params[0] = strlit7690;
  partcv[0] = 1;
  Object opresult7696 = callmethod(opresult7695, "++", 1, partcv, params);
// compiled op node returning opresult7696 (depth = 10)
  int op_slot_right_7688 = gc_frame_newslot(opresult7696);
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7698 == NULL) {
    strlit7698 = alloc_String("'inherit' must come ");
    gc_root(strlit7698);
  }
// compiled string node returning strlit7698 (depth = 10)
  int op_slot_left_7688 = gc_frame_newslot(strlit7698);
  params[0] = opresult7696;
  partcv[0] = 1;
  Object opresult7699 = callmethod(strlit7698, "++", 1, partcv, params);
// compiled op node returning opresult7699 (depth = 9)
  gc_frame_newslot(opresult7699);
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call7701 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe7700);
// compiled call node returning call7701 (depth = 10)
// compiled member node returning call7701 (depth = 9)
  gc_frame_newslot(call7701);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7702 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call7703 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7702);
// compiled call node returning call7703 (depth = 10)
// compiled member node returning call7703 (depth = 9)
  gc_frame_newslot(call7703);
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num7705 = alloc_Float64(7);
// compiled num node returning num7705 (depth = 10)
  int op_slot_right_7704 = gc_frame_newslot(num7705);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7708 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7707);
// compiled call node returning call7708 (depth = 11)
// compiled member node returning call7708 (depth = 10)
  int op_slot_left_7704 = gc_frame_newslot(call7708);
  params[0] = num7705;
  partcv[0] = 1;
  Object sum7709 = callmethod(call7708, "+", 1, partcv, params);
// compiled op node returning sum7709 (depth = 9)
  gc_frame_newslot(sum7709);
// call case 6: other member request
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult7699;
  params[1] = call7701;
  params[2] = call7703;
  params[3] = sum7709;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7710 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe7687);
// compiled call node returning call7710 (depth = 8)
    gc_frame_newslot(call7710);
    if7683 = call7710;
  }
// compiled if node returning if7683 (depth = 7)
    gc_frame_newslot(if7683);
    if7678 = if7683;
  }
// compiled if node returning if7678 (depth = 6)
    gc_frame_newslot(if7678);
    if7677 = if7678;
  } else {
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7711 = gc_frame_new();
// starting to compile op node (depth = 7)
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7714 == NULL) {
    strlit7714 = alloc_String("");
    gc_root(strlit7714);
  }
// compiled string node returning strlit7714 (depth = 9)
  int op_slot_right_7713 = gc_frame_newslot(strlit7714);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_constructName (depth = 10)
  int op_slot_right_7716 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 10)
  if (strlit7718 == NULL) {
    strlit7718 = alloc_String("come at the start of ");
    gc_root(strlit7718);
  }
// compiled string node returning strlit7718 (depth = 10)
  int op_slot_left_7716 = gc_frame_newslot(strlit7718);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7719 = callmethod(strlit7718, "++", 1, partcv, params);
// compiled op node returning opresult7719 (depth = 9)
  int op_slot_left_7713 = gc_frame_newslot(opresult7719);
  params[0] = strlit7714;
  partcv[0] = 1;
  Object opresult7720 = callmethod(opresult7719, "++", 1, partcv, params);
// compiled op node returning opresult7720 (depth = 8)
  int op_slot_right_7712 = gc_frame_newslot(opresult7720);
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7723 == NULL) {
    strlit7723 = alloc_String("' must ");
    gc_root(strlit7723);
  }
// compiled string node returning strlit7723 (depth = 9)
  int op_slot_right_7722 = gc_frame_newslot(strlit7723);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7727 = callmethod(*var_parentNode, "statementName",
    1, partcv, params);
  gc_frame_end(callframe7726);
// compiled call node returning call7727 (depth = 11)
// compiled member node returning call7727 (depth = 10)
  int op_slot_right_7725 = gc_frame_newslot(call7727);
// starting to compile string node (depth = 10)
  if (strlit7729 == NULL) {
    strlit7729 = alloc_String("'");
    gc_root(strlit7729);
  }
// compiled string node returning strlit7729 (depth = 10)
  int op_slot_left_7725 = gc_frame_newslot(strlit7729);
  params[0] = call7727;
  partcv[0] = 1;
  Object opresult7730 = callmethod(strlit7729, "++", 1, partcv, params);
// compiled op node returning opresult7730 (depth = 9)
  int op_slot_left_7722 = gc_frame_newslot(opresult7730);
  params[0] = strlit7723;
  partcv[0] = 1;
  Object opresult7731 = callmethod(opresult7730, "++", 1, partcv, params);
// compiled op node returning opresult7731 (depth = 8)
  int op_slot_left_7712 = gc_frame_newslot(opresult7731);
  params[0] = opresult7720;
  partcv[0] = 1;
  Object opresult7732 = callmethod(opresult7731, "++", 1, partcv, params);
// compiled op node returning opresult7732 (depth = 7)
  gc_frame_newslot(opresult7732);
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7734 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe7733);
// compiled call node returning call7734 (depth = 8)
// compiled member node returning call7734 (depth = 7)
  gc_frame_newslot(call7734);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7735 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call7736 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7735);
// compiled call node returning call7736 (depth = 8)
// compiled member node returning call7736 (depth = 7)
  gc_frame_newslot(call7736);
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7738 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call7740 = callmethod(*var_parentNode, "statementName",
    1, partcv, params);
  gc_frame_end(callframe7739);
// compiled call node returning call7740 (depth = 11)
// compiled member node returning call7740 (depth = 10)
  partcv[0] = 0;
  Object call7741 = callmethod(call7740, "size",
    1, partcv, params);
  gc_frame_end(callframe7738);
// compiled call node returning call7741 (depth = 9)
// compiled member node returning call7741 (depth = 8)
  int op_slot_right_7737 = gc_frame_newslot(call7741);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7743 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_parentNode (depth = 10)
  partcv[0] = 0;
  Object call7744 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7743);
// compiled call node returning call7744 (depth = 9)
// compiled member node returning call7744 (depth = 8)
  int op_slot_left_7737 = gc_frame_newslot(call7744);
  params[0] = call7741;
  partcv[0] = 1;
  Object sum7745 = callmethod(call7744, "+", 1, partcv, params);
// compiled op node returning sum7745 (depth = 7)
  gc_frame_newslot(sum7745);
// call case 6: other member request
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult7732;
  params[1] = call7734;
  params[2] = call7736;
  params[3] = sum7745;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7746 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe7711);
// compiled call node returning call7746 (depth = 6)
    gc_frame_newslot(call7746);
    if7677 = call7746;
  }
// compiled if node returning if7677 (depth = 5)
    gc_frame_newslot(if7677);
    if7667 = if7677;
  } else {
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7748 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7749 = alloc_Block(NULL, NULL, "parser", 2430);
  gc_frame_newslot(block7749);
// method "_apply"
  block_savedest(block7749);
  Object closure7750 = createclosure(1, "_apply");
  setclosureframe(closure7750, stackframe);
  addtoclosure(closure7750, selfslot);
  struct UserObject *uo7750 = (struct UserObject*)block7749;
  uo7750->data[0] = (Object)closure7750;
  Method *meth_meth_parser__apply7750 = addmethod2pos(block7749, "_apply", &meth_parser__apply7750, 0);
  int argcv_meth_parser__apply7750[] = {0};
  meth_meth_parser__apply7750->type = alloc_MethodType(1, argcv_meth_parser__apply7750);
  meth_meth_parser__apply7750->definitionModule = modulename;
  meth_meth_parser__apply7750->definitionLine = 2428;
// compiled block node returning block7749 (depth = 7)
  gc_frame_newslot(block7749);
// call case 4: self request
  params[0] = block7749;
  partcv[0] = 1;
  Object call7754 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7748);
// compiled call node returning call7754 (depth = 6)
  Object if7747 = done;
  if (istrue(call7754)) {
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7755 = alloc_Boolean(0);
// compiled identifier node returning bool7755 (depth = 7)
  *var_inPreamble = bool7755;
  if (bool7755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7757 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call7759 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7758);
// compiled call node returning call7759 (depth = 8)
// compiled member node returning call7759 (depth = 7)
  gc_frame_newslot(call7759);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = call7759;
  partcv[0] = 1;
  Object call7760 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe7757);
// compiled call node returning call7760 (depth = 6)
    gc_frame_newslot(call7760);
    if7747 = call7760;
  } else {
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7762 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7763 = alloc_Block(NULL, NULL, "parser", 2433);
  gc_frame_newslot(block7763);
// method "_apply"
  block_savedest(block7763);
  Object closure7764 = createclosure(1, "_apply");
  setclosureframe(closure7764, stackframe);
  addtoclosure(closure7764, selfslot);
  struct UserObject *uo7764 = (struct UserObject*)block7763;
  uo7764->data[0] = (Object)closure7764;
  Method *meth_meth_parser__apply7764 = addmethod2pos(block7763, "_apply", &meth_parser__apply7764, 0);
  int argcv_meth_parser__apply7764[] = {0};
  meth_meth_parser__apply7764->type = alloc_MethodType(1, argcv_meth_parser__apply7764);
  meth_meth_parser__apply7764->definitionModule = modulename;
  meth_meth_parser__apply7764->definitionLine = 2432;
// compiled block node returning block7763 (depth = 8)
  gc_frame_newslot(block7763);
// call case 4: self request
  params[0] = block7763;
  partcv[0] = 1;
  Object call7768 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7762);
// compiled call node returning call7768 (depth = 7)
  Object if7761 = done;
  if (istrue(call7768)) {
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool7769 = alloc_Boolean(0);
// compiled identifier node returning bool7769 (depth = 8)
  *var_inPreamble = bool7769;
  if (bool7769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7771 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7772 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7773 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7772);
// compiled call node returning call7773 (depth = 9)
// compiled member node returning call7773 (depth = 8)
  gc_frame_newslot(call7773);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call7773;
  partcv[0] = 1;
  Object call7774 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe7771);
// compiled call node returning call7774 (depth = 7)
    gc_frame_newslot(call7774);
    if7761 = call7774;
  } else {
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7775 = gc_frame_new();
// starting to compile op node (depth = 8)
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7778 == NULL) {
    strlit7778 = alloc_String("");
    gc_root(strlit7778);
  }
// compiled string node returning strlit7778 (depth = 10)
  int op_slot_right_7777 = gc_frame_newslot(strlit7778);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_constructName (depth = 11)
  int op_slot_right_7780 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 11)
  if (strlit7782 == NULL) {
    strlit7782 = alloc_String("of of ");
    gc_root(strlit7782);
  }
// compiled string node returning strlit7782 (depth = 11)
  int op_slot_left_7780 = gc_frame_newslot(strlit7782);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7783 = callmethod(strlit7782, "++", 1, partcv, params);
// compiled op node returning opresult7783 (depth = 10)
  int op_slot_left_7777 = gc_frame_newslot(opresult7783);
  params[0] = strlit7778;
  partcv[0] = 1;
  Object opresult7784 = callmethod(opresult7783, "++", 1, partcv, params);
// compiled op node returning opresult7784 (depth = 9)
  int op_slot_right_7776 = gc_frame_newslot(opresult7784);
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7787 == NULL) {
    strlit7787 = alloc_String("' in body ");
    gc_root(strlit7787);
  }
// compiled string node returning strlit7787 (depth = 10)
  int op_slot_right_7786 = gc_frame_newslot(strlit7787);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call7791 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7790);
// compiled call node returning call7791 (depth = 12)
// compiled member node returning call7791 (depth = 11)
  int op_slot_right_7789 = gc_frame_newslot(call7791);
// starting to compile string node (depth = 11)
  if (strlit7793 == NULL) {
    strlit7793 = alloc_String("unexpected symbol '");
    gc_root(strlit7793);
  }
// compiled string node returning strlit7793 (depth = 11)
  int op_slot_left_7789 = gc_frame_newslot(strlit7793);
  params[0] = call7791;
  partcv[0] = 1;
  Object opresult7794 = callmethod(strlit7793, "++", 1, partcv, params);
// compiled op node returning opresult7794 (depth = 10)
  int op_slot_left_7786 = gc_frame_newslot(opresult7794);
  params[0] = strlit7787;
  partcv[0] = 1;
  Object opresult7795 = callmethod(opresult7794, "++", 1, partcv, params);
// compiled op node returning opresult7795 (depth = 9)
  int op_slot_left_7776 = gc_frame_newslot(opresult7795);
  params[0] = opresult7784;
  partcv[0] = 1;
  Object opresult7796 = callmethod(opresult7795, "++", 1, partcv, params);
// compiled op node returning opresult7796 (depth = 8)
  gc_frame_newslot(opresult7796);
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7798 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7797);
// compiled call node returning call7798 (depth = 9)
// compiled member node returning call7798 (depth = 8)
  gc_frame_newslot(call7798);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7800 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7799);
// compiled call node returning call7800 (depth = 9)
// compiled member node returning call7800 (depth = 8)
  gc_frame_newslot(call7800);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7802 = alloc_Float64(1);
// compiled num node returning num7802 (depth = 9)
  int op_slot_right_7801 = gc_frame_newslot(num7802);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7805 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe7806 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call7807 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7806);
// compiled call node returning call7807 (depth = 13)
// compiled member node returning call7807 (depth = 12)
  partcv[0] = 0;
  Object call7808 = callmethod(call7807, "size",
    1, partcv, params);
  gc_frame_end(callframe7805);
// compiled call node returning call7808 (depth = 11)
// compiled member node returning call7808 (depth = 10)
  int op_slot_right_7804 = gc_frame_newslot(call7808);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call7811 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7810);
// compiled call node returning call7811 (depth = 11)
// compiled member node returning call7811 (depth = 10)
  int op_slot_left_7804 = gc_frame_newslot(call7811);
  params[0] = call7808;
  partcv[0] = 1;
  Object sum7812 = callmethod(call7811, "+", 1, partcv, params);
// compiled op node returning sum7812 (depth = 9)
  int op_slot_left_7801 = gc_frame_newslot(sum7812);
  params[0] = num7802;
  partcv[0] = 1;
  Object diff7813 = callmethod(sum7812, "-", 1, partcv, params);
// compiled op node returning diff7813 (depth = 8)
  gc_frame_newslot(diff7813);
// call case 6: other member request
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult7796;
  params[1] = call7798;
  params[2] = call7800;
  params[3] = diff7813;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call7814 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe7775);
// compiled call node returning call7814 (depth = 7)
    gc_frame_newslot(call7814);
    if7761 = call7814;
  }
// compiled if node returning if7761 (depth = 6)
    gc_frame_newslot(if7761);
    if7747 = if7761;
  }
// compiled if node returning if7747 (depth = 5)
    gc_frame_newslot(if7747);
    if7667 = if7747;
  }
// compiled if node returning if7667 (depth = 4)
  gc_frame_end(frame);
  return if7667;
}
Object meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parseObjectConstructorBody()startingWith()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parseObjectConstructorBody()startingWith()after");
  Object params[4];
  int partcv[3];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_statementToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for parseObjectConstructorBody()startingWith()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_constructName = &(stackframe->slots[0]);
  *var_constructName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parseObjectConstructorBody");
  Object *var_btok = &(stackframe->slots[1]);
  *var_btok = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for startingWith");
  Object *var_prev = &(stackframe->slots[2]);
  *var_prev = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localMinIndentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "localMinIndentLevel");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_superObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "superObject");
  Object *var_usedTraits = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "usedTraits");
  Object *var_inPreamble = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "inPreamble");
  Object *var_objNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "objNode");
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7556 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7555);
// compiled call node returning call7556 (depth = 4)
// compiled member node returning call7556 (depth = 3)
  *var_anns = call7556;
  if (call7556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7559 == NULL) {
    strlit7559 = alloc_String("lbrace");
    gc_root(strlit7559);
  }
// compiled string node returning strlit7559 (depth = 4)
  int op_slot_right_7558 = gc_frame_newslot(strlit7559);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7562 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7561);
// compiled call node returning call7562 (depth = 5)
// compiled member node returning call7562 (depth = 4)
  int op_slot_left_7558 = gc_frame_newslot(call7562);
  params[0] = strlit7559;
  partcv[0] = 1;
  Object opresult7563 = callmethod(call7562, "≠", 1, partcv, params);
// compiled op node returning opresult7563 (depth = 3)
  Object if7557 = done;
  if (istrue(opresult7563)) {
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7564 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call7566 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7565);
// compiled call node returning call7566 (depth = 7)
// compiled member node returning call7566 (depth = 6)
  partcv[0] = 0;
  Object call7567 = callmethod(call7566, "new",
    1, partcv, params);
  gc_frame_end(callframe7564);
// compiled call node returning call7567 (depth = 5)
// compiled member node returning call7567 (depth = 4)
  *var_suggestion = call7567;
  if (call7567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7568 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block7569 = alloc_Block(NULL, NULL, "parser", 2390);
  gc_frame_newslot(block7569);
// method "_apply"
  block_savedest(block7569);
  Object closure7570 = createclosure(1, "_apply");
  setclosureframe(closure7570, stackframe);
  addtoclosure(closure7570, selfslot);
  struct UserObject *uo7570 = (struct UserObject*)block7569;
  uo7570->data[0] = (Object)closure7570;
  Method *meth_meth_parser__apply7570 = addmethod2pos(block7569, "_apply", &meth_parser__apply7570, 0);
  int argcv_meth_parser__apply7570[] = {1};
  meth_meth_parser__apply7570->type = alloc_MethodType(1, argcv_meth_parser__apply7570);
  meth_meth_parser__apply7570->definitionModule = modulename;
  meth_meth_parser__apply7570->definitionLine = 2389;
// compiled block node returning block7569 (depth = 5)
  gc_frame_newslot(block7569);
// call case 4: self request
  params[0] = block7569;
  partcv[0] = 1;
  Object call7578 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7568);
// compiled call node returning call7578 (depth = 4)
  *var_nextTok = call7578;
  if (call7578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_right_7580 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 5)
  Object bool7582 = alloc_Boolean(0);
// compiled identifier node returning bool7582 (depth = 5)
  int op_slot_left_7580 = gc_frame_newslot(bool7582);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult7583 = callmethod(bool7582, "==", 1, partcv, params);
// compiled op node returning opresult7583 (depth = 4)
  Object if7579 = done;
  if (istrue(opresult7583)) {
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7584 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7585 == NULL) {
    strlit7585 = alloc_String(" {}");
    gc_root(strlit7585);
  }
// compiled string node returning strlit7585 (depth = 5)
  gc_frame_newslot(strlit7585);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7585;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7586 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7584);
// compiled call node returning call7586 (depth = 4)
    gc_frame_newslot(call7586);
    if7579 = call7586;
  } else {
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7587 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7588 == NULL) {
    strlit7588 = alloc_String(" {");
    gc_root(strlit7588);
  }
// compiled string node returning strlit7588 (depth = 5)
  gc_frame_newslot(strlit7588);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7588;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7589 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7587);
// compiled call node returning call7589 (depth = 4)
    gc_frame_newslot(call7589);
    if7579 = call7589;
  }
// compiled if node returning if7579 (depth = 3)
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7590 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7592 == NULL) {
    strlit7592 = alloc_String(".");
    gc_root(strlit7592);
  }
// compiled string node returning strlit7592 (depth = 5)
  int op_slot_right_7591 = gc_frame_newslot(strlit7592);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_prev (depth = 6)
  int op_slot_right_7594 = gc_frame_newslot(*var_prev);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7597 == NULL) {
    strlit7597 = alloc_String(" must have a '{' after the ");
    gc_root(strlit7597);
  }
// compiled string node returning strlit7597 (depth = 7)
  int op_slot_right_7596 = gc_frame_newslot(strlit7597);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_constructName (depth = 8)
  int op_slot_right_7599 = gc_frame_newslot(*var_constructName);
// starting to compile string node (depth = 8)
  if (strlit7601 == NULL) {
    strlit7601 = alloc_String("");
    gc_root(strlit7601);
  }
// compiled string node returning strlit7601 (depth = 8)
  int op_slot_left_7599 = gc_frame_newslot(strlit7601);
  params[0] = *var_constructName;
  partcv[0] = 1;
  Object opresult7602 = callmethod(strlit7601, "++", 1, partcv, params);
// compiled op node returning opresult7602 (depth = 7)
  int op_slot_left_7596 = gc_frame_newslot(opresult7602);
  params[0] = strlit7597;
  partcv[0] = 1;
  Object opresult7603 = callmethod(opresult7602, "++", 1, partcv, params);
// compiled op node returning opresult7603 (depth = 6)
  int op_slot_left_7594 = gc_frame_newslot(opresult7603);
  params[0] = *var_prev;
  partcv[0] = 1;
  Object opresult7604 = callmethod(opresult7603, "++", 1, partcv, params);
// compiled op node returning opresult7604 (depth = 5)
  int op_slot_left_7591 = gc_frame_newslot(opresult7604);
  params[0] = strlit7592;
  partcv[0] = 1;
  Object opresult7605 = callmethod(opresult7604, "++", 1, partcv, params);
// compiled op node returning opresult7605 (depth = 4)
  gc_frame_newslot(opresult7605);
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7607 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7606);
// compiled call node returning call7607 (depth = 5)
// compiled member node returning call7607 (depth = 4)
  gc_frame_newslot(call7607);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7610 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7609);
// compiled call node returning call7610 (depth = 6)
// compiled member node returning call7610 (depth = 5)
  int op_slot_right_7608 = gc_frame_newslot(call7610);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7613 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7612);
// compiled call node returning call7613 (depth = 6)
// compiled member node returning call7613 (depth = 5)
  int op_slot_left_7608 = gc_frame_newslot(call7613);
  params[0] = call7610;
  partcv[0] = 1;
  Object sum7614 = callmethod(call7613, "+", 1, partcv, params);
// compiled op node returning sum7614 (depth = 4)
  gc_frame_newslot(sum7614);
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult7605;
  params[1] = call7607;
  params[2] = sum7614;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7615 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7590);
// compiled call node returning call7615 (depth = 3)
    gc_frame_newslot(call7615);
    if7557 = call7615;
  } else {
  }
// compiled if node returning if7557 (depth = 2)
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7616 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7617 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7616);
// compiled call node returning call7617 (depth = 3)
// compiled member node returning call7617 (depth = 2)
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  partcv[0] = 0;
  Object call7621 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7620);
// compiled call node returning call7621 (depth = 5)
// compiled member node returning call7621 (depth = 4)
  int op_slot_right_7619 = gc_frame_newslot(call7621);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7624 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7623);
// compiled call node returning call7624 (depth = 5)
// compiled member node returning call7624 (depth = 4)
  int op_slot_left_7619 = gc_frame_newslot(call7624);
  params[0] = call7621;
  partcv[0] = 1;
  Object opresult7625 = callmethod(call7624, "==", 1, partcv, params);
// compiled op node returning opresult7625 (depth = 3)
  Object if7618 = done;
  if (istrue(opresult7625)) {
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7627 = alloc_Float64(2);
// compiled num node returning num7627 (depth = 5)
  int op_slot_right_7626 = gc_frame_newslot(num7627);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7630 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7629);
// compiled call node returning call7630 (depth = 6)
// compiled member node returning call7630 (depth = 5)
  int op_slot_left_7626 = gc_frame_newslot(call7630);
  params[0] = num7627;
  partcv[0] = 1;
  Object diff7631 = callmethod(call7630, "-", 1, partcv, params);
// compiled op node returning diff7631 (depth = 4)
  *var_minIndentLevel = diff7631;
  if (diff7631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7618 = done;
  } else {
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7634 = alloc_Float64(2);
// compiled num node returning num7634 (depth = 5)
  int op_slot_right_7633 = gc_frame_newslot(num7634);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call7637 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe7636);
// compiled call node returning call7637 (depth = 6)
// compiled member node returning call7637 (depth = 5)
  int op_slot_left_7633 = gc_frame_newslot(call7637);
  params[0] = num7634;
  partcv[0] = 1;
  Object sum7638 = callmethod(call7637, "+", 1, partcv, params);
// compiled op node returning sum7638 (depth = 4)
  *var_minIndentLevel = sum7638;
  if (sum7638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7618 = done;
  }
// compiled if node returning if7618 (depth = 2)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7640 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7640 (depth = 3)
  *var_body = array7640;
  if (array7640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7641 = alloc_Boolean(0);
// compiled identifier node returning bool7641 (depth = 3)
  *var_superObject = bool7641;
  if (bool7641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array7642 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7642 (depth = 3)
  *var_usedTraits = array7642;
  if (array7642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7643 = alloc_Boolean(1);
// compiled identifier node returning bool7643 (depth = 3)
  *var_inPreamble = bool7643;
  if (bool7643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7644 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block7645 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7645);
// method "_apply"
  block_savedest(block7645);
  Object closure7646 = createclosure(2, "_apply");
  setclosureframe(closure7646, stackframe);
  addtoclosure(closure7646, var_sym);
  addtoclosure(closure7646, selfslot);
  struct UserObject *uo7646 = (struct UserObject*)block7645;
  uo7646->data[0] = (Object)closure7646;
  Method *meth_meth_parser__apply7646 = addmethod2pos(block7645, "_apply", &meth_parser__apply7646, 0);
  int argcv_meth_parser__apply7646[] = {0};
  meth_meth_parser__apply7646->type = alloc_MethodType(1, argcv_meth_parser__apply7646);
  meth_meth_parser__apply7646->definitionModule = modulename;
  meth_meth_parser__apply7646->definitionLine = 2404;
// compiled block node returning block7645 (depth = 3)
  gc_frame_newslot(block7645);
// starting to compile block node (depth = 3)
  Object block7665 = alloc_Block(NULL, NULL, "parser", 2410);
  gc_frame_newslot(block7665);
// method "_apply"
  block_savedest(block7665);
  Object closure7666 = createclosure(9, "_apply");
  setclosureframe(closure7666, stackframe);
  addtoclosure(closure7666, var_values);
  addtoclosure(closure7666, var_inPreamble);
  addtoclosure(closure7666, var_usedTraits);
  addtoclosure(closure7666, var_superObject);
  addtoclosure(closure7666, var_constructName);
  addtoclosure(closure7666, var_errormessages);
  addtoclosure(closure7666, var_body);
  addtoclosure(closure7666, var_sym);
  addtoclosure(closure7666, selfslot);
  struct UserObject *uo7666 = (struct UserObject*)block7665;
  uo7666->data[0] = (Object)closure7666;
  Method *meth_meth_parser__apply7666 = addmethod2pos(block7665, "_apply", &meth_parser__apply7666, 0);
  int argcv_meth_parser__apply7666[] = {0};
  meth_meth_parser__apply7666->type = alloc_MethodType(1, argcv_meth_parser__apply7666);
  meth_meth_parser__apply7666->definitionModule = modulename;
  meth_meth_parser__apply7666->definitionLine = 2410;
// compiled block node returning block7665 (depth = 3)
  gc_frame_newslot(block7665);
// call case 5: prelude request
  params[0] = block7645;
  params[1] = block7665;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7816 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7644);
// compiled call node returning call7816 (depth = 2)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7817 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7818 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7817);
// compiled call node returning call7818 (depth = 3)
// compiled member node returning call7818 (depth = 2)
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7819 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7821 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7820);
// compiled call node returning call7821 (depth = 4)
// compiled member node returning call7821 (depth = 3)
  gc_frame_newslot(call7821);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7823 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7822);
// compiled call node returning call7823 (depth = 4)
// compiled member node returning call7823 (depth = 3)
  gc_frame_newslot(call7823);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call7821;
  params[1] = call7823;
  partcv[0] = 2;
  Object call7824 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7819);
// compiled call node returning call7824 (depth = 2)
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7825 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superObject (depth = 4)
  gc_frame_newslot(*var_superObject);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7827 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe7826);
// compiled call node returning call7827 (depth = 5)
// compiled member node returning call7827 (depth = 4)
  params[0] = *var_body;
  params[1] = *var_superObject;
  partcv[0] = 2;
  Object call7828 = callmethod(call7827, "new",
    1, partcv, params);
  gc_frame_end(callframe7825);
// compiled call node returning call7828 (depth = 3)
  *var_objNode = call7828;
  if (call7828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  int op_slot_right_7830 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 4)
  Object bool7832 = alloc_Boolean(0);
// compiled identifier node returning bool7832 (depth = 4)
  int op_slot_left_7830 = gc_frame_newslot(bool7832);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult7833 = callmethod(bool7832, "≠", 1, partcv, params);
// compiled op node returning opresult7833 (depth = 3)
  Object if7829 = done;
  if (istrue(opresult7833)) {
// starting to compile call node (depth = 3)
  int callframe7834 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_anns (depth = 4)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7835 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  partcv[0] = 0;
  Object call7836 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7835);
// compiled call node returning call7836 (depth = 5)
// compiled member node returning call7836 (depth = 4)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7837 = callmethod(call7836, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7834);
// compiled call node returning call7837 (depth = 3)
    gc_frame_newslot(call7837);
    if7829 = call7837;
  } else {
  }
// compiled if node returning if7829 (depth = 2)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7838 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_usedTraits (depth = 3)
  gc_frame_newslot(*var_usedTraits);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  params[0] = *var_usedTraits;
  partcv[0] = 1;
  Object call7839 = callmethod(*var_objNode, "usedTraits:=",
    1, partcv, params);
  gc_frame_end(callframe7838);
// compiled call node returning call7839 (depth = 2)
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7840 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objNode (depth = 3)
  gc_frame_newslot(*var_objNode);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_objNode;
  partcv[0] = 1;
  Object call7841 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7840);
// compiled call node returning call7841 (depth = 2)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_doclass7843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doclass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doclass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_objName = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "objName");
  Object *var_s = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "s");
  Object *var_csig = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "csig");
  Object *var_methodName = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodName");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_objNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "objNode");
  Object *var_meth = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "meth");
  Object *var_asStringBody = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "asStringBody");
  Object *var_asStringMeth = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "asStringMeth");
  Object *var_metaBody = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "metaBody");
  Object *var_metaObj = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "metaObj");
  Object *var_defDec = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defDec");
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7844 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7845 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7844);
// compiled call node returning call7845 (depth = 3)
// compiled member node returning call7845 (depth = 2)
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7848 == NULL) {
    strlit7848 = alloc_String("identifier");
    gc_root(strlit7848);
  }
// compiled string node returning strlit7848 (depth = 4)
  int op_slot_right_7847 = gc_frame_newslot(strlit7848);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7851 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7850);
// compiled call node returning call7851 (depth = 5)
// compiled member node returning call7851 (depth = 4)
  int op_slot_left_7847 = gc_frame_newslot(call7851);
  params[0] = strlit7848;
  partcv[0] = 1;
  Object opresult7852 = callmethod(call7851, "≠", 1, partcv, params);
// compiled op node returning opresult7852 (depth = 3)
  Object if7846 = done;
  if (istrue(opresult7852)) {
// Begin line 2484
  setline(2484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7853 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7853 (depth = 4)
  *var_suggestions = array7853;
  if (array7853 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7856 == NULL) {
    strlit7856 = alloc_String("lbrace");
    gc_root(strlit7856);
  }
// compiled string node returning strlit7856 (depth = 5)
  int op_slot_right_7855 = gc_frame_newslot(strlit7856);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7858 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7859 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7858);
// compiled call node returning call7859 (depth = 6)
// compiled member node returning call7859 (depth = 5)
  int op_slot_left_7855 = gc_frame_newslot(call7859);
  params[0] = strlit7856;
  partcv[0] = 1;
  Object opresult7860 = callmethod(call7859, "==", 1, partcv, params);
// compiled op node returning opresult7860 (depth = 4)
  Object if7854 = done;
  if (istrue(opresult7860)) {
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7861 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7863 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7862);
// compiled call node returning call7863 (depth = 8)
// compiled member node returning call7863 (depth = 7)
  partcv[0] = 0;
  Object call7864 = callmethod(call7863, "new",
    1, partcv, params);
  gc_frame_end(callframe7861);
// compiled call node returning call7864 (depth = 6)
// compiled member node returning call7864 (depth = 5)
  *var_suggestion = call7864;
  if (call7864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7865 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7866 == NULL) {
    strlit7866 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit7866);
  }
// compiled string node returning strlit7866 (depth = 5)
  gc_frame_newslot(strlit7866);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7866;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7867 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7865);
// compiled call node returning call7867 (depth = 4)
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7868 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7869 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7868);
// compiled call node returning call7869 (depth = 4)
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7870 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7872 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7871);
// compiled call node returning call7872 (depth = 8)
// compiled member node returning call7872 (depth = 7)
  partcv[0] = 0;
  Object call7873 = callmethod(call7872, "new",
    1, partcv, params);
  gc_frame_end(callframe7870);
// compiled call node returning call7873 (depth = 6)
// compiled member node returning call7873 (depth = 5)
  *var_suggestion = call7873;
  if (call7873 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7875 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 5)
  if (strlit7876 == NULL) {
    strlit7876 = alloc_String("object");
    gc_root(strlit7876);
  }
// compiled string node returning strlit7876 (depth = 5)
  gc_frame_newslot(strlit7876);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = strlit7876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7877 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7875);
// compiled call node returning call7877 (depth = 4)
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7878 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7879 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7878);
// compiled call node returning call7879 (depth = 4)
    gc_frame_newslot(call7879);
    if7854 = call7879;
  } else {
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7880 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7882 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7881);
// compiled call node returning call7882 (depth = 8)
// compiled member node returning call7882 (depth = 7)
  partcv[0] = 0;
  Object call7883 = callmethod(call7882, "new",
    1, partcv, params);
  gc_frame_end(callframe7880);
// compiled call node returning call7883 (depth = 6)
// compiled member node returning call7883 (depth = 5)
  *var_suggestion = call7883;
  if (call7883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7884 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7885 == NULL) {
    strlit7885 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit7885);
  }
// compiled string node returning strlit7885 (depth = 5)
  gc_frame_newslot(strlit7885);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7885;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7886 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7884);
// compiled call node returning call7886 (depth = 4)
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7887 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7888 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7887);
// compiled call node returning call7888 (depth = 4)
    gc_frame_newslot(call7888);
    if7854 = call7888;
  }
// compiled if node returning if7854 (depth = 3)
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7889 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7890 == NULL) {
    strlit7890 = alloc_String("a class must have a name after the 'class'.");
    gc_root(strlit7890);
  }
// compiled string node returning strlit7890 (depth = 4)
  gc_frame_newslot(strlit7890);
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call7892 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7891);
// compiled call node returning call7892 (depth = 5)
// compiled member node returning call7892 (depth = 4)
  gc_frame_newslot(call7892);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num7894 = alloc_Float64(1);
// compiled num node returning num7894 (depth = 5)
  int op_slot_right_7893 = gc_frame_newslot(num7894);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7897 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7898 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7897);
// compiled call node returning call7898 (depth = 7)
// compiled member node returning call7898 (depth = 6)
  int op_slot_right_7896 = gc_frame_newslot(call7898);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7901 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7900);
// compiled call node returning call7901 (depth = 7)
// compiled member node returning call7901 (depth = 6)
  int op_slot_left_7896 = gc_frame_newslot(call7901);
  params[0] = call7898;
  partcv[0] = 1;
  Object sum7902 = callmethod(call7901, "+", 1, partcv, params);
// compiled op node returning sum7902 (depth = 5)
  int op_slot_left_7893 = gc_frame_newslot(sum7902);
  params[0] = num7894;
  partcv[0] = 1;
  Object sum7903 = callmethod(sum7902, "+", 1, partcv, params);
// compiled op node returning sum7903 (depth = 4)
  gc_frame_newslot(sum7903);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit7890;
  params[1] = call7892;
  params[2] = sum7903;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7904 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7889);
// compiled call node returning call7904 (depth = 3)
    gc_frame_newslot(call7904);
    if7846 = call7904;
  } else {
  }
// compiled if node returning if7846 (depth = 2)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool7905 = alloc_Boolean(0);
// compiled identifier node returning bool7905 (depth = 3)
  *var_objName = bool7905;
  if (bool7905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit7908 == NULL) {
    strlit7908 = alloc_String("dot");
    gc_root(strlit7908);
  }
// compiled string node returning strlit7908 (depth = 4)
  int op_slot_right_7907 = gc_frame_newslot(strlit7908);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7910 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call7912 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe7911);
// compiled call node returning call7912 (depth = 7)
// compiled member node returning call7912 (depth = 6)
  partcv[0] = 0;
  Object call7913 = callmethod(call7912, "kind",
    1, partcv, params);
  gc_frame_end(callframe7910);
// compiled call node returning call7913 (depth = 5)
// compiled member node returning call7913 (depth = 4)
  int op_slot_left_7907 = gc_frame_newslot(call7913);
  params[0] = strlit7908;
  partcv[0] = 1;
  Object opresult7914 = callmethod(call7913, "==", 1, partcv, params);
// compiled op node returning opresult7914 (depth = 3)
  Object if7906 = done;
  if (istrue(opresult7914)) {
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7915 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7916 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7915);
// compiled call node returning call7916 (depth = 4)
// compiled member node returning call7916 (depth = 3)
// Begin line 2503
  setline(2503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7918 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7917);
// compiled call node returning call7918 (depth = 5)
// compiled member node returning call7918 (depth = 4)
  *var_objName = call7918;
  if (call7918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7920 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7921 = alloc_Boolean(1);
// compiled identifier node returning bool7921 (depth = 4)
  gc_frame_newslot(bool7921);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  params[0] = bool7921;
  partcv[0] = 1;
  Object call7922 = callmethod(*var_objName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7920);
// compiled call node returning call7922 (depth = 3)
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7923 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7924 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7923);
// compiled call node returning call7924 (depth = 4)
// compiled member node returning call7924 (depth = 3)
    gc_frame_newslot(call7924);
    if7906 = call7924;
  } else {
  }
// compiled if node returning if7906 (depth = 2)
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7925 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool7926 = alloc_Boolean(0);
// compiled identifier node returning bool7926 (depth = 4)
  gc_frame_newslot(bool7926);
// call case 4: self request
  params[0] = bool7926;
  partcv[0] = 1;
  Object call7927 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7925);
// compiled call node returning call7927 (depth = 3)
  *var_s = call7927;
  if (call7927 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call7929 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe7928);
// compiled call node returning call7929 (depth = 4)
// compiled member node returning call7929 (depth = 3)
  *var_csig = call7929;
  if (call7929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call7931 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe7930);
// compiled call node returning call7931 (depth = 4)
// compiled member node returning call7931 (depth = 3)
  *var_methodName = call7931;
  if (call7931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7932 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool7933 = alloc_Boolean(1);
// compiled identifier node returning bool7933 (depth = 3)
  gc_frame_newslot(bool7933);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodName (depth = 3)
  params[0] = bool7933;
  partcv[0] = 1;
  Object call7934 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7932);
// compiled call node returning call7934 (depth = 2)
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call7936 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe7935);
// compiled call node returning call7936 (depth = 4)
// compiled member node returning call7936 (depth = 3)
  *var_dtype = call7936;
  if (call7936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7937 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7938 == NULL) {
    strlit7938 = alloc_String("a class");
    gc_root(strlit7938);
  }
// compiled string node returning strlit7938 (depth = 3)
  gc_frame_newslot(strlit7938);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_btok (depth = 3)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 3)
  if (strlit7939 == NULL) {
    strlit7939 = alloc_String("method header");
    gc_root(strlit7939);
  }
// compiled string node returning strlit7939 (depth = 3)
  gc_frame_newslot(strlit7939);
// call case 4: self request
  params[0] = strlit7938;
  params[1] = *var_btok;
  params[2] = strlit7939;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7940 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7937);
// compiled call node returning call7940 (depth = 2)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call7942 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7941);
// compiled call node returning call7942 (depth = 4)
// compiled member node returning call7942 (depth = 3)
  *var_objNode = call7942;
  if (call7942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7943 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7945 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7944);
// compiled call node returning call7945 (depth = 4)
// compiled member node returning call7945 (depth = 3)
  gc_frame_newslot(call7945);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_btok (depth = 5)
  partcv[0] = 0;
  Object call7947 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7946);
// compiled call node returning call7947 (depth = 4)
// compiled member node returning call7947 (depth = 3)
  gc_frame_newslot(call7947);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call7945;
  params[1] = call7947;
  partcv[0] = 2;
  Object call7948 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7943);
// compiled call node returning call7948 (depth = 2)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7949 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_csig (depth = 4)
  gc_frame_newslot(*var_csig);
// starting to compile array node (depth = 4)
  Object array7950 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array7950, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7950 (depth = 4)
  gc_frame_newslot(array7950);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7952 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe7951);
// compiled call node returning call7952 (depth = 5)
// compiled member node returning call7952 (depth = 4)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array7950;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call7953 = callmethod(call7952, "new",
    1, partcv, params);
  gc_frame_end(callframe7949);
// compiled call node returning call7953 (depth = 3)
  *var_meth = call7953;
  if (call7953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7954 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  partcv[0] = 0;
  Object call7956 = callmethod(*var_s, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe7955);
// compiled call node returning call7956 (depth = 4)
// compiled member node returning call7956 (depth = 3)
  gc_frame_newslot(call7956);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = call7956;
  partcv[0] = 1;
  Object call7957 = callmethod(*var_meth, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe7954);
// compiled call node returning call7957 (depth = 2)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7958 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool7959 = alloc_Boolean(1);
// compiled identifier node returning bool7959 (depth = 3)
  gc_frame_newslot(bool7959);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool7959;
  partcv[0] = 1;
  Object call7960 = callmethod(*var_meth, "usesClassSyntax:=",
    1, partcv, params);
  gc_frame_end(callframe7958);
// compiled call node returning call7960 (depth = 2)
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe7961 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  partcv[0] = 0;
  Object call7963 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7962);
// compiled call node returning call7963 (depth = 4)
// compiled member node returning call7963 (depth = 3)
  gc_frame_newslot(call7963);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call7965 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7964);
// compiled call node returning call7965 (depth = 4)
// compiled member node returning call7965 (depth = 3)
  params[0] = call7963;
  partcv[0] = 1;
  Object call7966 = callmethod(call7965, "addAll",
    1, partcv, params);
  gc_frame_end(callframe7961);
// compiled call node returning call7966 (depth = 2)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objName (depth = 4)
  int op_slot_right_7968 = gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 4)
  Object bool7970 = alloc_Boolean(0);
// compiled identifier node returning bool7970 (depth = 4)
  int op_slot_left_7968 = gc_frame_newslot(bool7970);
  params[0] = *var_objName;
  partcv[0] = 1;
  Object opresult7971 = callmethod(bool7970, "≠", 1, partcv, params);
// compiled op node returning opresult7971 (depth = 3)
  Object if7967 = done;
  if (istrue(opresult7971)) {
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7972 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methodName (depth = 7)
  partcv[0] = 0;
  Object call7975 = callmethod(*var_methodName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe7974);
// compiled call node returning call7975 (depth = 6)
// compiled member node returning call7975 (depth = 5)
  int op_slot_right_7973 = gc_frame_newslot(call7975);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7978 == NULL) {
    strlit7978 = alloc_String(".");
    gc_root(strlit7978);
  }
// compiled string node returning strlit7978 (depth = 6)
  int op_slot_right_7977 = gc_frame_newslot(strlit7978);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7980 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_objName (depth = 8)
  partcv[0] = 0;
  Object call7981 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe7980);
// compiled call node returning call7981 (depth = 7)
// compiled member node returning call7981 (depth = 6)
  int op_slot_left_7977 = gc_frame_newslot(call7981);
  params[0] = strlit7978;
  partcv[0] = 1;
  Object opresult7982 = callmethod(call7981, "++", 1, partcv, params);
// compiled op node returning opresult7982 (depth = 5)
  int op_slot_left_7973 = gc_frame_newslot(opresult7982);
  params[0] = call7975;
  partcv[0] = 1;
  Object opresult7983 = callmethod(opresult7982, "++", 1, partcv, params);
// compiled op node returning opresult7983 (depth = 4)
  gc_frame_newslot(opresult7983);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = opresult7983;
  partcv[0] = 1;
  Object call7984 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe7972);
// compiled call node returning call7984 (depth = 3)
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array7985 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 5)
  int callframe7986 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7988 == NULL) {
    strlit7988 = alloc_String("");
    gc_root(strlit7988);
  }
// compiled string node returning strlit7988 (depth = 7)
  int op_slot_right_7987 = gc_frame_newslot(strlit7988);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_objName (depth = 10)
  partcv[0] = 0;
  Object call7992 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe7991);
// compiled call node returning call7992 (depth = 9)
// compiled member node returning call7992 (depth = 8)
  int op_slot_right_7990 = gc_frame_newslot(call7992);
// starting to compile string node (depth = 8)
  if (strlit7994 == NULL) {
    strlit7994 = alloc_String("class ");
    gc_root(strlit7994);
  }
// compiled string node returning strlit7994 (depth = 8)
  int op_slot_left_7990 = gc_frame_newslot(strlit7994);
  params[0] = call7992;
  partcv[0] = 1;
  Object opresult7995 = callmethod(strlit7994, "++", 1, partcv, params);
// compiled op node returning opresult7995 (depth = 7)
  int op_slot_left_7987 = gc_frame_newslot(opresult7995);
  params[0] = strlit7988;
  partcv[0] = 1;
  Object opresult7996 = callmethod(opresult7995, "++", 1, partcv, params);
// compiled op node returning opresult7996 (depth = 6)
  gc_frame_newslot(opresult7996);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call7998 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe7997);
// compiled call node returning call7998 (depth = 7)
// compiled member node returning call7998 (depth = 6)
  params[0] = opresult7996;
  partcv[0] = 1;
  Object call7999 = callmethod(call7998, "new",
    1, partcv, params);
  gc_frame_end(callframe7986);
// compiled call node returning call7999 (depth = 5)
  params[0] = call7999;
  partcv[0] = 1;
  callmethodflags(array7985, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array7985 (depth = 4)
  *var_asStringBody = array7985;
  if (array7985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8000 = gc_frame_new();
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8001 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8002 == NULL) {
    strlit8002 = alloc_String("asString");
    gc_root(strlit8002);
  }
// compiled string node returning strlit8002 (depth = 6)
  gc_frame_newslot(strlit8002);
// starting to compile identifier node (depth = 6)
  Object bool8003 = alloc_Boolean(0);
// compiled identifier node returning bool8003 (depth = 6)
  gc_frame_newslot(bool8003);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8004 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8005 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8004);
// compiled call node returning call8005 (depth = 7)
// compiled member node returning call8005 (depth = 6)
  params[0] = strlit8002;
  params[1] = bool8003;
  partcv[0] = 2;
  Object call8006 = callmethod(call8005, "new",
    1, partcv, params);
  gc_frame_end(callframe8001);
// compiled call node returning call8006 (depth = 5)
  gc_frame_newslot(call8006);
// starting to compile array node (depth = 5)
  Object array8007 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8007 (depth = 5)
  gc_frame_newslot(array8007);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringBody (depth = 5)
  gc_frame_newslot(*var_asStringBody);
// starting to compile identifier node (depth = 5)
  Object bool8008 = alloc_Boolean(0);
// compiled identifier node returning bool8008 (depth = 5)
  gc_frame_newslot(bool8008);
// call case 6: other member request
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8010 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8009);
// compiled call node returning call8010 (depth = 6)
// compiled member node returning call8010 (depth = 5)
  params[0] = call8006;
  params[1] = array8007;
  params[2] = *var_asStringBody;
  params[3] = bool8008;
  partcv[0] = 4;
  Object call8011 = callmethod(call8010, "new",
    1, partcv, params);
  gc_frame_end(callframe8000);
// compiled call node returning call8011 (depth = 4)
  *var_asStringMeth = call8011;
  if (call8011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8012 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  callmethodflags(array8012, "push", 1, partcv, params, CFLAG_SELF);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_asStringMeth (depth = 5)
  params[0] = *var_asStringMeth;
  partcv[0] = 1;
  callmethodflags(array8012, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8012 (depth = 4)
  *var_metaBody = array8012;
  if (array8012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8013 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaBody (depth = 5)
  gc_frame_newslot(*var_metaBody);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8015 == NULL) {
    strlit8015 = alloc_String("");
    gc_root(strlit8015);
  }
// compiled string node returning strlit8015 (depth = 6)
  int op_slot_right_8014 = gc_frame_newslot(strlit8015);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8018 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_objName (depth = 9)
  partcv[0] = 0;
  Object call8019 = callmethod(*var_objName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8018);
// compiled call node returning call8019 (depth = 8)
// compiled member node returning call8019 (depth = 7)
  int op_slot_right_8017 = gc_frame_newslot(call8019);
// starting to compile string node (depth = 7)
  if (strlit8021 == NULL) {
    strlit8021 = alloc_String("class ");
    gc_root(strlit8021);
  }
// compiled string node returning strlit8021 (depth = 7)
  int op_slot_left_8017 = gc_frame_newslot(strlit8021);
  params[0] = call8019;
  partcv[0] = 1;
  Object opresult8022 = callmethod(strlit8021, "++", 1, partcv, params);
// compiled op node returning opresult8022 (depth = 6)
  int op_slot_left_8014 = gc_frame_newslot(opresult8022);
  params[0] = strlit8015;
  partcv[0] = 1;
  Object opresult8023 = callmethod(opresult8022, "++", 1, partcv, params);
// compiled op node returning opresult8023 (depth = 5)
  gc_frame_newslot(opresult8023);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8025 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8024);
// compiled call node returning call8025 (depth = 6)
// compiled member node returning call8025 (depth = 5)
  params[0] = *var_metaBody;
  params[1] = opresult8023;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8026 = callmethod(call8025, "body()named",
    2, partcv, params);
  gc_frame_end(callframe8013);
// compiled call node returning call8026 (depth = 4)
  *var_metaObj = call8026;
  if (call8026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8027 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objName (depth = 5)
  gc_frame_newslot(*var_objName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_metaObj (depth = 5)
  gc_frame_newslot(*var_metaObj);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8028 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8029 = callmethod(*var_ast, "unknownType",
    1, partcv, params);
  gc_frame_end(callframe8028);
// compiled call node returning call8029 (depth = 6)
// compiled member node returning call8029 (depth = 5)
  gc_frame_newslot(call8029);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8030 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8031 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe8030);
// compiled call node returning call8031 (depth = 6)
// compiled member node returning call8031 (depth = 5)
  params[0] = *var_objName;
  params[1] = *var_metaObj;
  params[2] = call8029;
  partcv[0] = 3;
  Object call8032 = callmethod(call8031, "new",
    1, partcv, params);
  gc_frame_end(callframe8027);
// compiled call node returning call8032 (depth = 4)
  *var_defDec = call8032;
  if (call8032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8033 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  params[0] = *var_btok;
  partcv[0] = 1;
  Object call8034 = callmethod(*var_defDec, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe8033);
// compiled call node returning call8034 (depth = 3)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8035 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe8036 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8037 == NULL) {
    strlit8037 = alloc_String("public");
    gc_root(strlit8037);
  }
// compiled string node returning strlit8037 (depth = 5)
  gc_frame_newslot(strlit8037);
// starting to compile identifier node (depth = 5)
  Object bool8038 = alloc_Boolean(0);
// compiled identifier node returning bool8038 (depth = 5)
  gc_frame_newslot(bool8038);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8040 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8039);
// compiled call node returning call8040 (depth = 6)
// compiled member node returning call8040 (depth = 5)
  params[0] = strlit8037;
  params[1] = bool8038;
  partcv[0] = 2;
  Object call8041 = callmethod(call8040, "new",
    1, partcv, params);
  gc_frame_end(callframe8036);
// compiled call node returning call8041 (depth = 4)
  gc_frame_newslot(call8041);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defDec (depth = 6)
  partcv[0] = 0;
  Object call8043 = callmethod(*var_defDec, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8042);
// compiled call node returning call8043 (depth = 5)
// compiled member node returning call8043 (depth = 4)
  params[0] = call8041;
  partcv[0] = 1;
  Object call8044 = callmethod(call8043, "add",
    1, partcv, params);
  gc_frame_end(callframe8035);
// compiled call node returning call8044 (depth = 3)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8045 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defDec (depth = 4)
  gc_frame_newslot(*var_defDec);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_defDec;
  partcv[0] = 1;
  Object call8046 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8045);
// compiled call node returning call8046 (depth = 3)
    gc_frame_newslot(call8046);
    if7967 = call8046;
  } else {
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8047 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  partcv[0] = 0;
  Object call8049 = callmethod(*var_methodName, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8048);
// compiled call node returning call8049 (depth = 5)
// compiled member node returning call8049 (depth = 4)
  gc_frame_newslot(call8049);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = call8049;
  partcv[0] = 1;
  Object call8050 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8047);
// compiled call node returning call8050 (depth = 3)
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8053 == NULL) {
    strlit8053 = alloc_String("class");
    gc_root(strlit8053);
  }
// compiled string node returning strlit8053 (depth = 5)
  int op_slot_right_8052 = gc_frame_newslot(strlit8053);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  partcv[0] = 0;
  Object call8056 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe8055);
// compiled call node returning call8056 (depth = 6)
// compiled member node returning call8056 (depth = 5)
  int op_slot_left_8052 = gc_frame_newslot(call8056);
  params[0] = strlit8053;
  partcv[0] = 1;
  Object opresult8057 = callmethod(call8056, "==", 1, partcv, params);
// compiled op node returning opresult8057 (depth = 4)
  Object if8051 = done;
  if (istrue(opresult8057)) {
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8058 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8059 = alloc_Boolean(1);
// compiled identifier node returning bool8059 (depth = 5)
  gc_frame_newslot(bool8059);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_objNode (depth = 5)
  params[0] = bool8059;
  partcv[0] = 1;
  Object call8060 = callmethod(*var_objNode, "inClass:=",
    1, partcv, params);
  gc_frame_end(callframe8058);
// compiled call node returning call8060 (depth = 4)
    gc_frame_newslot(call8060);
    if8051 = call8060;
  } else {
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8063 == NULL) {
    strlit8063 = alloc_String("trait");
    gc_root(strlit8063);
  }
// compiled string node returning strlit8063 (depth = 6)
  int op_slot_right_8062 = gc_frame_newslot(strlit8063);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  partcv[0] = 0;
  Object call8066 = callmethod(*var_btok, "value",
    1, partcv, params);
  gc_frame_end(callframe8065);
// compiled call node returning call8066 (depth = 7)
// compiled member node returning call8066 (depth = 6)
  int op_slot_left_8062 = gc_frame_newslot(call8066);
  params[0] = strlit8063;
  partcv[0] = 1;
  Object opresult8067 = callmethod(call8066, "==", 1, partcv, params);
// compiled op node returning opresult8067 (depth = 5)
  Object if8061 = done;
  if (istrue(opresult8067)) {
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8068 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8069 = alloc_Boolean(1);
// compiled identifier node returning bool8069 (depth = 6)
  gc_frame_newslot(bool8069);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = bool8069;
  partcv[0] = 1;
  Object call8070 = callmethod(*var_objNode, "inTrait:=",
    1, partcv, params);
  gc_frame_end(callframe8068);
// compiled call node returning call8070 (depth = 5)
    gc_frame_newslot(call8070);
    if8061 = call8070;
  } else {
  }
// compiled if node returning if8061 (depth = 4)
    gc_frame_newslot(if8061);
    if8051 = if8061;
  }
// compiled if node returning if8051 (depth = 3)
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8071 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8072 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8071);
// compiled call node returning call8072 (depth = 3)
    gc_frame_newslot(call8072);
    if7967 = call8072;
  }
// compiled if node returning if7967 (depth = 2)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8073 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8074 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8073);
// compiled call node returning call8074 (depth = 3)
// compiled member node returning call8074 (depth = 2)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localMinIndentLevel (depth = 3)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8080(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8082 == NULL) {
    strlit8082 = alloc_String("method");
    gc_root(strlit8082);
  }
// compiled string node returning strlit8082 (depth = 6)
  int op_slot_right_8081 = gc_frame_newslot(strlit8082);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8084 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8086 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8085);
// compiled call node returning call8086 (depth = 9)
// compiled member node returning call8086 (depth = 8)
  partcv[0] = 0;
  Object call8087 = callmethod(call8086, "value",
    1, partcv, params);
  gc_frame_end(callframe8084);
// compiled call node returning call8087 (depth = 7)
// compiled member node returning call8087 (depth = 6)
  int op_slot_left_8081 = gc_frame_newslot(call8087);
  params[0] = strlit8082;
  partcv[0] = 1;
  Object opresult8088 = callmethod(call8087, "==", 1, partcv, params);
// compiled op node returning opresult8088 (depth = 5)
  gc_frame_end(frame);
  return opresult8088;
}
Object meth_parser__apply8093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8095 == NULL) {
    strlit8095 = alloc_String("keyword");
    gc_root(strlit8095);
  }
// compiled string node returning strlit8095 (depth = 7)
  int op_slot_right_8094 = gc_frame_newslot(strlit8095);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8097 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  partcv[0] = 0;
  Object call8099 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8098);
// compiled call node returning call8099 (depth = 10)
// compiled member node returning call8099 (depth = 9)
  partcv[0] = 0;
  Object call8100 = callmethod(call8099, "kind",
    1, partcv, params);
  gc_frame_end(callframe8097);
// compiled call node returning call8100 (depth = 8)
// compiled member node returning call8100 (depth = 7)
  int op_slot_left_8094 = gc_frame_newslot(call8100);
  params[0] = strlit8095;
  partcv[0] = 1;
  Object opresult8101 = callmethod(call8100, "==", 1, partcv, params);
// compiled op node returning opresult8101 (depth = 6)
  gc_frame_end(frame);
  return opresult8101;
}
Object meth_parser_dofactoryMethod8076(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dofactoryMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dofactoryMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_csig = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "csig");
  Object *var_methodName = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "methodName");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_objNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "objNode");
  Object *var_meth = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "meth");
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8079 = alloc_Block(NULL, NULL, "parser", 2547);
  gc_frame_newslot(block8079);
// method "_apply"
  block_savedest(block8079);
  Object closure8080 = createclosure(2, "_apply");
  setclosureframe(closure8080, stackframe);
  addtoclosure(closure8080, var_tokens);
  addtoclosure(closure8080, selfslot);
  struct UserObject *uo8080 = (struct UserObject*)block8079;
  uo8080->data[0] = (Object)closure8080;
  Method *meth_meth_parser__apply8080 = addmethod2pos(block8079, "_apply", &meth_parser__apply8080, 0);
  int argcv_meth_parser__apply8080[] = {0};
  meth_meth_parser__apply8080->type = alloc_MethodType(1, argcv_meth_parser__apply8080);
  meth_meth_parser__apply8080->definitionModule = modulename;
  meth_meth_parser__apply8080->definitionLine = 2540;
// compiled block node returning block8079 (depth = 4)
  int op_slot_right_8078 = gc_frame_newslot(block8079);
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block8092 = alloc_Block(NULL, NULL, "parser", 2546);
  gc_frame_newslot(block8092);
// method "_apply"
  block_savedest(block8092);
  Object closure8093 = createclosure(2, "_apply");
  setclosureframe(closure8093, stackframe);
  addtoclosure(closure8093, var_tokens);
  addtoclosure(closure8093, selfslot);
  struct UserObject *uo8093 = (struct UserObject*)block8092;
  uo8093->data[0] = (Object)closure8093;
  Method *meth_meth_parser__apply8093 = addmethod2pos(block8092, "_apply", &meth_parser__apply8093, 0);
  int argcv_meth_parser__apply8093[] = {0};
  meth_meth_parser__apply8093->type = alloc_MethodType(1, argcv_meth_parser__apply8093);
  meth_meth_parser__apply8093->definitionModule = modulename;
  meth_meth_parser__apply8093->definitionLine = 2548;
// compiled block node returning block8092 (depth = 5)
  int op_slot_right_8091 = gc_frame_newslot(block8092);
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8104 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8105 == NULL) {
    strlit8105 = alloc_String("factory");
    gc_root(strlit8105);
  }
// compiled string node returning strlit8105 (depth = 6)
  gc_frame_newslot(strlit8105);
// call case 4: self request
  params[0] = strlit8105;
  partcv[0] = 1;
  Object call8106 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8104);
// compiled call node returning call8106 (depth = 5)
  int op_slot_left_8091 = gc_frame_newslot(call8106);
  params[0] = block8092;
  partcv[0] = 1;
  Object opresult8107 = callmethod(call8106, "&&", 1, partcv, params);
// compiled op node returning opresult8107 (depth = 4)
  int op_slot_left_8078 = gc_frame_newslot(opresult8107);
  params[0] = block8079;
  partcv[0] = 1;
  Object opresult8108 = callmethod(opresult8107, "&&", 1, partcv, params);
// compiled op node returning opresult8108 (depth = 3)
  Object if8077 = done;
  if (istrue(opresult8108)) {
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8109 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8110 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8109);
// compiled call node returning call8110 (depth = 4)
// compiled member node returning call8110 (depth = 3)
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8112 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8111);
// compiled call node returning call8112 (depth = 4)
// compiled member node returning call8112 (depth = 3)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8115 == NULL) {
    strlit8115 = alloc_String("identifier");
    gc_root(strlit8115);
  }
// compiled string node returning strlit8115 (depth = 5)
  int op_slot_right_8114 = gc_frame_newslot(strlit8115);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8118 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8117);
// compiled call node returning call8118 (depth = 6)
// compiled member node returning call8118 (depth = 5)
  int op_slot_left_8114 = gc_frame_newslot(call8118);
  params[0] = strlit8115;
  partcv[0] = 1;
  Object opresult8119 = callmethod(call8118, "≠", 1, partcv, params);
// compiled op node returning opresult8119 (depth = 4)
  Object if8113 = done;
  if (istrue(opresult8119)) {
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array8120 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8120 (depth = 5)
  *var_suggestions = array8120;
  if (array8120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8123 == NULL) {
    strlit8123 = alloc_String("lbrace");
    gc_root(strlit8123);
  }
// compiled string node returning strlit8123 (depth = 6)
  int op_slot_right_8122 = gc_frame_newslot(strlit8123);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8125 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8126 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8125);
// compiled call node returning call8126 (depth = 7)
// compiled member node returning call8126 (depth = 6)
  int op_slot_left_8122 = gc_frame_newslot(call8126);
  params[0] = strlit8123;
  partcv[0] = 1;
  Object opresult8127 = callmethod(call8126, "==", 1, partcv, params);
// compiled op node returning opresult8127 (depth = 5)
  Object if8121 = done;
  if (istrue(opresult8127)) {
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8128 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8129 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8130 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8129);
// compiled call node returning call8130 (depth = 9)
// compiled member node returning call8130 (depth = 8)
  partcv[0] = 0;
  Object call8131 = callmethod(call8130, "new",
    1, partcv, params);
  gc_frame_end(callframe8128);
// compiled call node returning call8131 (depth = 7)
// compiled member node returning call8131 (depth = 6)
  *var_suggestion = call8131;
  if (call8131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8132 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8133 == NULL) {
    strlit8133 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8133);
  }
// compiled string node returning strlit8133 (depth = 6)
  gc_frame_newslot(strlit8133);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8133;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8134 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8132);
// compiled call node returning call8134 (depth = 5)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8135 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8136 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8135);
// compiled call node returning call8136 (depth = 5)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8137 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8139 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8138);
// compiled call node returning call8139 (depth = 9)
// compiled member node returning call8139 (depth = 8)
  partcv[0] = 0;
  Object call8140 = callmethod(call8139, "new",
    1, partcv, params);
  gc_frame_end(callframe8137);
// compiled call node returning call8140 (depth = 7)
// compiled member node returning call8140 (depth = 6)
  *var_suggestion = call8140;
  if (call8140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8142 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8143 == NULL) {
    strlit8143 = alloc_String("object");
    gc_root(strlit8143);
  }
// compiled string node returning strlit8143 (depth = 6)
  gc_frame_newslot(strlit8143);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8143;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8144 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8142);
// compiled call node returning call8144 (depth = 5)
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8145 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8146 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8145);
// compiled call node returning call8146 (depth = 5)
    gc_frame_newslot(call8146);
    if8121 = call8146;
  } else {
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8147 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8149 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8148);
// compiled call node returning call8149 (depth = 9)
// compiled member node returning call8149 (depth = 8)
  partcv[0] = 0;
  Object call8150 = callmethod(call8149, "new",
    1, partcv, params);
  gc_frame_end(callframe8147);
// compiled call node returning call8150 (depth = 7)
// compiled member node returning call8150 (depth = 6)
  *var_suggestion = call8150;
  if (call8150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8151 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8152 == NULL) {
    strlit8152 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit8152);
  }
// compiled string node returning strlit8152 (depth = 6)
  gc_frame_newslot(strlit8152);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8152;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8153 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8151);
// compiled call node returning call8153 (depth = 5)
// Begin line 2565
  setline(2565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8154 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8155 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8154);
// compiled call node returning call8155 (depth = 5)
    gc_frame_newslot(call8155);
    if8121 = call8155;
  }
// compiled if node returning if8121 (depth = 4)
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8156 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8157 == NULL) {
    strlit8157 = alloc_String("a factory method must have a name after the 'method'.");
    gc_root(strlit8157);
  }
// compiled string node returning strlit8157 (depth = 5)
  gc_frame_newslot(strlit8157);
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8158 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8159 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8158);
// compiled call node returning call8159 (depth = 6)
// compiled member node returning call8159 (depth = 5)
  gc_frame_newslot(call8159);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8161 = alloc_Float64(1);
// compiled num node returning num8161 (depth = 6)
  int op_slot_right_8160 = gc_frame_newslot(num8161);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8165 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8164);
// compiled call node returning call8165 (depth = 8)
// compiled member node returning call8165 (depth = 7)
  int op_slot_right_8163 = gc_frame_newslot(call8165);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8168 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8167);
// compiled call node returning call8168 (depth = 8)
// compiled member node returning call8168 (depth = 7)
  int op_slot_left_8163 = gc_frame_newslot(call8168);
  params[0] = call8165;
  partcv[0] = 1;
  Object sum8169 = callmethod(call8168, "+", 1, partcv, params);
// compiled op node returning sum8169 (depth = 6)
  int op_slot_left_8160 = gc_frame_newslot(sum8169);
  params[0] = num8161;
  partcv[0] = 1;
  Object sum8170 = callmethod(sum8169, "+", 1, partcv, params);
// compiled op node returning sum8170 (depth = 5)
  gc_frame_newslot(sum8170);
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8157;
  params[1] = call8159;
  params[2] = sum8170;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8171 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8156);
// compiled call node returning call8171 (depth = 4)
    gc_frame_newslot(call8171);
    if8113 = call8171;
  } else {
  }
// compiled if node returning if8113 (depth = 3)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8172 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8173 = alloc_Boolean(0);
// compiled identifier node returning bool8173 (depth = 5)
  gc_frame_newslot(bool8173);
// call case 4: self request
  params[0] = bool8173;
  partcv[0] = 1;
  Object call8174 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8172);
// compiled call node returning call8174 (depth = 4)
  *var_s = call8174;
  if (call8174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8176 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8175);
// compiled call node returning call8176 (depth = 5)
// compiled member node returning call8176 (depth = 4)
  *var_csig = call8176;
  if (call8176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8178 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8177);
// compiled call node returning call8178 (depth = 5)
// compiled member node returning call8178 (depth = 4)
  *var_methodName = call8178;
  if (call8178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8179 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool8180 = alloc_Boolean(1);
// compiled identifier node returning bool8180 (depth = 4)
  gc_frame_newslot(bool8180);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  params[0] = bool8180;
  partcv[0] = 1;
  Object call8181 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8179);
// compiled call node returning call8181 (depth = 3)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8183 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8182);
// compiled call node returning call8183 (depth = 5)
// compiled member node returning call8183 (depth = 4)
  *var_dtype = call8183;
  if (call8183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8184 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8185 == NULL) {
    strlit8185 = alloc_String("a factory method");
    gc_root(strlit8185);
  }
// compiled string node returning strlit8185 (depth = 4)
  gc_frame_newslot(strlit8185);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_btok (depth = 4)
  gc_frame_newslot(*var_btok);
// starting to compile string node (depth = 4)
  if (strlit8186 == NULL) {
    strlit8186 = alloc_String("method header");
    gc_root(strlit8186);
  }
// compiled string node returning strlit8186 (depth = 4)
  gc_frame_newslot(strlit8186);
// call case 4: self request
  params[0] = strlit8185;
  params[1] = *var_btok;
  params[2] = strlit8186;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8187 = callmethodflags(self, "parseObjectConstructorBody()startingWith()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8184);
// compiled call node returning call8187 (depth = 3)
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8188 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8189 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8188);
// compiled call node returning call8189 (depth = 5)
// compiled member node returning call8189 (depth = 4)
  *var_objNode = call8189;
  if (call8189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8190 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methodName (depth = 4)
  gc_frame_newslot(*var_methodName);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_objNode (depth = 4)
  params[0] = *var_methodName;
  partcv[0] = 1;
  Object call8191 = callmethod(*var_objNode, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8190);
// compiled call node returning call8191 (depth = 3)
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8192 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8193 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8194 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8193);
// compiled call node returning call8194 (depth = 5)
// compiled member node returning call8194 (depth = 4)
  gc_frame_newslot(call8194);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8196 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8195);
// compiled call node returning call8196 (depth = 5)
// compiled member node returning call8196 (depth = 4)
  gc_frame_newslot(call8196);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8194;
  params[1] = call8196;
  partcv[0] = 2;
  Object call8197 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe8192);
// compiled call node returning call8197 (depth = 3)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8198 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_csig (depth = 5)
  gc_frame_newslot(*var_csig);
// starting to compile array node (depth = 5)
  Object array8199 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  params[0] = *var_objNode;
  partcv[0] = 1;
  callmethodflags(array8199, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array8199 (depth = 5)
  gc_frame_newslot(array8199);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8201 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8200);
// compiled call node returning call8201 (depth = 6)
// compiled member node returning call8201 (depth = 5)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array8199;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8202 = callmethod(call8201, "new",
    1, partcv, params);
  gc_frame_end(callframe8198);
// compiled call node returning call8202 (depth = 4)
  *var_meth = call8202;
  if (call8202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8203 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8205 = callmethod(*var_s, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compiled call node returning call8205 (depth = 5)
// compiled member node returning call8205 (depth = 4)
  gc_frame_newslot(call8205);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = call8205;
  partcv[0] = 1;
  Object call8206 = callmethod(*var_meth, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe8203);
// compiled call node returning call8206 (depth = 3)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8207 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objNode (depth = 6)
  partcv[0] = 0;
  Object call8209 = callmethod(*var_objNode, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8208);
// compiled call node returning call8209 (depth = 5)
// compiled member node returning call8209 (depth = 4)
  gc_frame_newslot(call8209);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8211 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8210);
// compiled call node returning call8211 (depth = 5)
// compiled member node returning call8211 (depth = 4)
  params[0] = call8209;
  partcv[0] = 1;
  Object call8212 = callmethod(call8211, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8207);
// compiled call node returning call8212 (depth = 3)
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8213 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8214 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8213);
// compiled call node returning call8214 (depth = 3)
// Begin line 2587
  setline(2587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8216 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8215);
// compiled call node returning call8216 (depth = 4)
// compiled member node returning call8216 (depth = 3)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8077 = done;
  } else {
  }
// compiled if node returning if8077 (depth = 2)
  gc_frame_end(frame);
  return if8077;
}
Object meth_parser__apply8283(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8285 == NULL) {
    strlit8285 = alloc_String("lbrace");
    gc_root(strlit8285);
  }
// compiled string node returning strlit8285 (depth = 7)
  int op_slot_right_8284 = gc_frame_newslot(strlit8285);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call8288 = callmethod(*var_s, "kind",
    1, partcv, params);
  gc_frame_end(callframe8287);
// compiled call node returning call8288 (depth = 8)
// compiled member node returning call8288 (depth = 7)
  int op_slot_left_8284 = gc_frame_newslot(call8288);
  params[0] = strlit8285;
  partcv[0] = 1;
  Object opresult8289 = callmethod(call8288, "≠", 1, partcv, params);
// compiled op node returning opresult8289 (depth = 6)
  gc_frame_end(frame);
  return opresult8289;
}
Object meth_parser__apply8292(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8293 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8294 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8293);
// compiled call node returning call8294 (depth = 6)
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8295 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8296 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8295);
// compiled call node returning call8296 (depth = 7)
// compiled member node returning call8296 (depth = 6)
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8298 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8297);
// compiled call node returning call8298 (depth = 8)
// compiled member node returning call8298 (depth = 7)
  *var_s = call8298;
  if (call8298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8218(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methoddec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for methoddec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_m = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m");
  Object *var_meth = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "meth");
  Object *var_signature = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "signature");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_body = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "body");
  Object *var_localMin = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "localMin");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_s = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "s");
  Object *var_suggestion = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "closingBrace");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8220 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8221 == NULL) {
    strlit8221 = alloc_String("method");
    gc_root(strlit8221);
  }
// compiled string node returning strlit8221 (depth = 4)
  gc_frame_newslot(strlit8221);
// call case 4: self request
  params[0] = strlit8221;
  partcv[0] = 1;
  Object call8222 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8220);
// compiled call node returning call8222 (depth = 3)
  Object if8219 = done;
  if (istrue(call8222)) {
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8224 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8223);
// compiled call node returning call8224 (depth = 4)
// compiled member node returning call8224 (depth = 3)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8227 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8226);
// compiled call node returning call8227 (depth = 4)
// compiled member node returning call8227 (depth = 3)
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8228 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8229 = alloc_Boolean(0);
// compiled identifier node returning bool8229 (depth = 5)
  gc_frame_newslot(bool8229);
// call case 4: self request
  params[0] = bool8229;
  partcv[0] = 1;
  Object call8230 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8228);
// compiled call node returning call8230 (depth = 4)
  *var_m = call8230;
  if (call8230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8232 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe8231);
// compiled call node returning call8232 (depth = 5)
// compiled member node returning call8232 (depth = 4)
  *var_meth = call8232;
  if (call8232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8233 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8234 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe8233);
// compiled call node returning call8234 (depth = 5)
// compiled member node returning call8234 (depth = 4)
  *var_signature = call8234;
  if (call8234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8236 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8235);
// compiled call node returning call8236 (depth = 5)
// compiled member node returning call8236 (depth = 4)
  *var_dtype = call8236;
  if (call8236 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array8237 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8237 (depth = 4)
  *var_body = array8237;
  if (array8237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8239 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8238);
// compiled call node returning call8239 (depth = 5)
// compiled member node returning call8239 (depth = 4)
  *var_anns = call8239;
  if (call8239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8241 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8242 == NULL) {
    strlit8242 = alloc_String("lbrace");
    gc_root(strlit8242);
  }
// compiled string node returning strlit8242 (depth = 5)
  gc_frame_newslot(strlit8242);
// call case 4: self request
  params[0] = strlit8242;
  partcv[0] = 1;
  Object call8243 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8241);
// compiled call node returning call8243 (depth = 4)
  Object if8240 = done;
  if (istrue(call8243)) {
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8244 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8245 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8244);
// compiled call node returning call8245 (depth = 5)
// compiled member node returning call8245 (depth = 4)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8249 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stok (depth = 8)
  partcv[0] = 0;
  Object call8250 = callmethod(*var_stok, "line",
    1, partcv, params);
  gc_frame_end(callframe8249);
// compiled call node returning call8250 (depth = 7)
// compiled member node returning call8250 (depth = 6)
  int op_slot_right_8248 = gc_frame_newslot(call8250);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8253 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8252);
// compiled call node returning call8253 (depth = 7)
// compiled member node returning call8253 (depth = 6)
  int op_slot_left_8248 = gc_frame_newslot(call8253);
  params[0] = call8250;
  partcv[0] = 1;
  Object opresult8254 = callmethod(call8253, "==", 1, partcv, params);
// compiled op node returning opresult8254 (depth = 5)
  Object if8247 = done;
  if (istrue(opresult8254)) {
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8256 = alloc_Float64(1);
// compiled num node returning num8256 (depth = 7)
  int op_slot_right_8255 = gc_frame_newslot(num8256);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8259 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8258);
// compiled call node returning call8259 (depth = 8)
// compiled member node returning call8259 (depth = 7)
  int op_slot_left_8255 = gc_frame_newslot(call8259);
  params[0] = num8256;
  partcv[0] = 1;
  Object diff8260 = callmethod(call8259, "-", 1, partcv, params);
// compiled op node returning diff8260 (depth = 6)
  *var_minIndentLevel = diff8260;
  if (diff8260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8247 = done;
  } else {
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8263 = alloc_Float64(1);
// compiled num node returning num8263 (depth = 7)
  int op_slot_right_8262 = gc_frame_newslot(num8263);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_stok (depth = 9)
  partcv[0] = 0;
  Object call8266 = callmethod(*var_stok, "indent",
    1, partcv, params);
  gc_frame_end(callframe8265);
// compiled call node returning call8266 (depth = 8)
// compiled member node returning call8266 (depth = 7)
  int op_slot_left_8262 = gc_frame_newslot(call8266);
  params[0] = num8263;
  partcv[0] = 1;
  Object sum8267 = callmethod(call8266, "+", 1, partcv, params);
// compiled op node returning sum8267 (depth = 6)
  *var_minIndentLevel = sum8267;
  if (sum8267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8247 = done;
  }
// compiled if node returning if8247 (depth = 4)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8269 = gc_frame_new();
// starting to compile object node (depth = 5)
  Object inheritingObject8270 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8270 = alloc_userobj2(3,4, objclass8270);
  gc_frame_newslot(obj8270);
// OBJECT OUTER DEC outer
  adddatum2(obj8270, self, 0);
  addmethodreal(obj8270,"outer", &reader_parser_outer_8271);
  Object oldself8270 = self;
  struct StackFrameObject *oldstackframe8270 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8270);
  gc_frame_newslot((Object)stackframe);
  self = obj8270;
  Object *oldselfslot8270 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8270 = (*(struct UserObject *)self).data[0], lowerouter8270 = thisouter8270;
  if (inheritingObject8270) {
    struct UserObject *inho8270 = (struct UserObject *)inheritingObject8270;
    while (inho8270->super != GraceDefaultObject) inho8270 = (struct UserObject *)inho8270->super;
    inho8270->super = obj8270;
    self = inheritingObject8270;
    *selfslot = self;
    lowerouter8270 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8270;
  }
if (objclass8270 == NULL) {
  Method *reader8272 = addmethodrealflags(obj8270, "kind",&reader_parser_kind_8272, MFLAG_DEF);
  reader8272->definitionModule = modulename;
  reader8272->definitionLine = 2617;
}
adddatum2(obj8270, alloc_Undefined(), 1);
if (objclass8270 == NULL) {
  Method *reader8273 = addmethodrealflags(obj8270, "register",&reader_parser_register_8273, 0);
  Method *writer8273 = addmethodrealflags(obj8270, "register:=",&writer_parser_register_8273, 0);
  reader8273->definitionModule = modulename;
  writer8273->definitionModule = modulename;
  reader8273->definitionLine = 2618;
  writer8273->definitionLine = 2618;
}
obj8270->flags |= OFLAG_MUTABLE;
adddatum2(obj8270, alloc_Undefined(), 2);
  sourceObject = obj8270;
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8274 == NULL) {
    strlit8274 = alloc_String("lbrace");
    gc_root(strlit8274);
  }
// compiled string node returning strlit8274 (depth = 6)
  adddatum2(obj8270, strlit8274, 1);
  sourceObject = obj8270;
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8275 == NULL) {
    strlit8275 = alloc_String("");
    gc_root(strlit8275);
  }
// compiled string node returning strlit8275 (depth = 6)
  adddatum2(obj8270, strlit8275, 2);
  objclass8270 = obj8270->class;
  objclass8270->definitionModule = modulename;
  objclass8270->definitionLine = 2616;
  (*(struct UserObject *)self).data[0] = lowerouter8270;
  self = oldself8270;
  selfslot = oldselfslot8270;
  stackframe = oldstackframe8270;
// compiled object node returning obj8270 (depth = 5)
  gc_frame_newslot(obj8270);
// call case 6: other member request
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = obj8270;
  partcv[0] = 1;
  Object call8276 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8269);
// compiled call node returning call8276 (depth = 4)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8278 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8277);
// compiled call node returning call8278 (depth = 5)
// compiled member node returning call8278 (depth = 4)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8280 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8279);
// compiled call node returning call8280 (depth = 6)
// compiled member node returning call8280 (depth = 5)
  *var_s = call8280;
  if (call8280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8281 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8282 = alloc_Block(NULL, NULL, "parser", 2622);
  gc_frame_newslot(block8282);
// method "_apply"
  block_savedest(block8282);
  Object closure8283 = createclosure(2, "_apply");
  setclosureframe(closure8283, stackframe);
  addtoclosure(closure8283, var_s);
  addtoclosure(closure8283, selfslot);
  struct UserObject *uo8283 = (struct UserObject*)block8282;
  uo8283->data[0] = (Object)closure8283;
  Method *meth_meth_parser__apply8283 = addmethod2pos(block8282, "_apply", &meth_parser__apply8283, 0);
  int argcv_meth_parser__apply8283[] = {0};
  meth_meth_parser__apply8283->type = alloc_MethodType(1, argcv_meth_parser__apply8283);
  meth_meth_parser__apply8283->definitionModule = modulename;
  meth_meth_parser__apply8283->definitionLine = 2621;
// compiled block node returning block8282 (depth = 5)
  gc_frame_newslot(block8282);
// starting to compile block node (depth = 5)
  Object block8291 = alloc_Block(NULL, NULL, "parser", 2622);
  gc_frame_newslot(block8291);
// method "_apply"
  block_savedest(block8291);
  Object closure8292 = createclosure(4, "_apply");
  setclosureframe(closure8292, stackframe);
  addtoclosure(closure8292, var_s);
  addtoclosure(closure8292, var_body);
  addtoclosure(closure8292, var_values);
  addtoclosure(closure8292, selfslot);
  struct UserObject *uo8292 = (struct UserObject*)block8291;
  uo8292->data[0] = (Object)closure8292;
  Method *meth_meth_parser__apply8292 = addmethod2pos(block8291, "_apply", &meth_parser__apply8292, 0);
  int argcv_meth_parser__apply8292[] = {0};
  meth_meth_parser__apply8292->type = alloc_MethodType(1, argcv_meth_parser__apply8292);
  meth_meth_parser__apply8292->definitionModule = modulename;
  meth_meth_parser__apply8292->definitionLine = 2622;
// compiled block node returning block8291 (depth = 5)
  gc_frame_newslot(block8291);
// call case 5: prelude request
  params[0] = block8282;
  params[1] = block8291;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8301 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8281);
// compiled call node returning call8301 (depth = 4)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8304 == NULL) {
    strlit8304 = alloc_String("rbrace");
    gc_root(strlit8304);
  }
// compiled string node returning strlit8304 (depth = 6)
  int op_slot_right_8303 = gc_frame_newslot(strlit8304);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8307 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8306);
// compiled call node returning call8307 (depth = 7)
// compiled member node returning call8307 (depth = 6)
  int op_slot_left_8303 = gc_frame_newslot(call8307);
  params[0] = strlit8304;
  partcv[0] = 1;
  Object opresult8308 = callmethod(call8307, "≠", 1, partcv, params);
// compiled op node returning opresult8308 (depth = 5)
  Object if8302 = done;
  if (istrue(opresult8308)) {
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8309 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8311 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8310);
// compiled call node returning call8311 (depth = 9)
// compiled member node returning call8311 (depth = 8)
  partcv[0] = 0;
  Object call8312 = callmethod(call8311, "new",
    1, partcv, params);
  gc_frame_end(callframe8309);
// compiled call node returning call8312 (depth = 7)
// compiled member node returning call8312 (depth = 6)
  *var_suggestion = call8312;
  if (call8312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8313 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool8314 = alloc_Boolean(0);
// compiled identifier node returning bool8314 (depth = 7)
  gc_frame_newslot(bool8314);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8314;
  partcv[0] = 2;
  Object call8315 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8313);
// compiled call node returning call8315 (depth = 6)
  *var_closingBrace = call8315;
  if (call8315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8317 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call8319 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8318);
// compiled call node returning call8319 (depth = 9)
// compiled member node returning call8319 (depth = 8)
  partcv[0] = 0;
  Object call8320 = callmethod(call8319, "not",
    1, partcv, params);
  gc_frame_end(callframe8317);
// compiled call node returning call8320 (depth = 7)
// compiled member node returning call8320 (depth = 6)
  Object if8316 = done;
  if (istrue(call8320)) {
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8322 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call8325 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8324);
// compiled call node returning call8325 (depth = 9)
// compiled member node returning call8325 (depth = 8)
  int op_slot_left_8322 = gc_frame_newslot(call8325);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8326 = callmethod(call8325, "==", 1, partcv, params);
// compiled op node returning opresult8326 (depth = 7)
  Object if8321 = done;
  if (istrue(opresult8326)) {
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8327 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8328 == NULL) {
    strlit8328 = alloc_String("}");
    gc_root(strlit8328);
  }
// compiled string node returning strlit8328 (depth = 8)
  gc_frame_newslot(strlit8328);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8328;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8329 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8327);
// compiled call node returning call8329 (depth = 7)
    gc_frame_newslot(call8329);
    if8321 = call8329;
  } else {
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8330 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8332 = alloc_Float64(0.1);
// compiled num node returning num8332 (depth = 9)
  int op_slot_right_8331 = gc_frame_newslot(num8332);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8334 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call8336 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8335);
// compiled call node returning call8336 (depth = 12)
// compiled member node returning call8336 (depth = 11)
  partcv[0] = 0;
  Object call8337 = callmethod(call8336, "line",
    1, partcv, params);
  gc_frame_end(callframe8334);
// compiled call node returning call8337 (depth = 10)
// compiled member node returning call8337 (depth = 9)
  int op_slot_left_8331 = gc_frame_newslot(call8337);
  params[0] = num8332;
  partcv[0] = 1;
  Object sum8338 = callmethod(call8337, "+", 1, partcv, params);
// compiled op node returning sum8338 (depth = 8)
  gc_frame_newslot(sum8338);
// starting to compile string node (depth = 8)
  if (strlit8339 == NULL) {
    strlit8339 = alloc_String("}");
    gc_root(strlit8339);
  }
// compiled string node returning strlit8339 (depth = 8)
  gc_frame_newslot(strlit8339);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum8338;
  params[1] = strlit8339;
  partcv[0] = 2;
  Object call8340 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8330);
// compiled call node returning call8340 (depth = 7)
    gc_frame_newslot(call8340);
    if8321 = call8340;
  }
// compiled if node returning if8321 (depth = 6)
    gc_frame_newslot(if8321);
    if8316 = if8321;
  } else {
  }
// compiled if node returning if8316 (depth = 5)
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8341 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8342 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8341);
// compiled call node returning call8342 (depth = 5)
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8343 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8344 == NULL) {
    strlit8344 = alloc_String("a method must end with a '}'.");
    gc_root(strlit8344);
  }
// compiled string node returning strlit8344 (depth = 6)
  gc_frame_newslot(strlit8344);
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8345 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8346 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8345);
// compiled call node returning call8346 (depth = 7)
// compiled member node returning call8346 (depth = 6)
  gc_frame_newslot(call8346);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8347 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8348 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8347);
// compiled call node returning call8348 (depth = 7)
// compiled member node returning call8348 (depth = 6)
  gc_frame_newslot(call8348);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8344;
  params[1] = call8346;
  params[2] = call8348;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8349 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8343);
// compiled call node returning call8349 (depth = 5)
    gc_frame_newslot(call8349);
    if8302 = call8349;
  } else {
  }
// compiled if node returning if8302 (depth = 4)
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8350 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8351 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8350);
// compiled call node returning call8351 (depth = 5)
// compiled member node returning call8351 (depth = 4)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8240 = done;
  } else {
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8353 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8355 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8354);
// compiled call node returning call8355 (depth = 8)
// compiled member node returning call8355 (depth = 7)
  partcv[0] = 0;
  Object call8356 = callmethod(call8355, "new",
    1, partcv, params);
  gc_frame_end(callframe8353);
// compiled call node returning call8356 (depth = 6)
// compiled member node returning call8356 (depth = 5)
  *var_suggestion = call8356;
  if (call8356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8357 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool8358 = alloc_Boolean(1);
// compiled identifier node returning bool8358 (depth = 6)
  gc_frame_newslot(bool8358);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8358;
  partcv[0] = 2;
  Object call8359 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8357);
// compiled call node returning call8359 (depth = 5)
  *var_closingBrace = call8359;
  if (call8359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8361 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8363 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8362);
// compiled call node returning call8363 (depth = 8)
// compiled member node returning call8363 (depth = 7)
  partcv[0] = 0;
  Object call8364 = callmethod(call8363, "not",
    1, partcv, params);
  gc_frame_end(callframe8361);
// compiled call node returning call8364 (depth = 6)
// compiled member node returning call8364 (depth = 5)
  Object if8360 = done;
  if (istrue(call8364)) {
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_8366 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8369 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8368);
// compiled call node returning call8369 (depth = 8)
// compiled member node returning call8369 (depth = 7)
  int op_slot_left_8366 = gc_frame_newslot(call8369);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult8370 = callmethod(call8369, "==", 1, partcv, params);
// compiled op node returning opresult8370 (depth = 6)
  Object if8365 = done;
  if (istrue(opresult8370)) {
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8371 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8372 == NULL) {
    strlit8372 = alloc_String(" {}");
    gc_root(strlit8372);
  }
// compiled string node returning strlit8372 (depth = 7)
  gc_frame_newslot(strlit8372);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8373 = alloc_Boolean(1);
// compiled identifier node returning bool8373 (depth = 7)
  gc_frame_newslot(bool8373);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8372;
  params[1] = *var_lastToken;
  params[2] = bool8373;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8374 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8371);
// compiled call node returning call8374 (depth = 6)
    gc_frame_newslot(call8374);
    if8365 = call8374;
  } else {
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8375 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8377 = alloc_Float64(0.1);
// compiled num node returning num8377 (depth = 8)
  int op_slot_right_8376 = gc_frame_newslot(num8377);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8379 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call8381 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8380);
// compiled call node returning call8381 (depth = 11)
// compiled member node returning call8381 (depth = 10)
  partcv[0] = 0;
  Object call8382 = callmethod(call8381, "line",
    1, partcv, params);
  gc_frame_end(callframe8379);
// compiled call node returning call8382 (depth = 9)
// compiled member node returning call8382 (depth = 8)
  int op_slot_left_8376 = gc_frame_newslot(call8382);
  params[0] = num8377;
  partcv[0] = 1;
  Object sum8383 = callmethod(call8382, "+", 1, partcv, params);
// compiled op node returning sum8383 (depth = 7)
  gc_frame_newslot(sum8383);
// starting to compile string node (depth = 7)
  if (strlit8384 == NULL) {
    strlit8384 = alloc_String("}");
    gc_root(strlit8384);
  }
// compiled string node returning strlit8384 (depth = 7)
  gc_frame_newslot(strlit8384);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum8383;
  params[1] = strlit8384;
  partcv[0] = 2;
  Object call8385 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8375);
// compiled call node returning call8385 (depth = 6)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8386 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8387 == NULL) {
    strlit8387 = alloc_String(" {");
    gc_root(strlit8387);
  }
// compiled string node returning strlit8387 (depth = 7)
  gc_frame_newslot(strlit8387);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8388 = alloc_Boolean(1);
// compiled identifier node returning bool8388 (depth = 7)
  gc_frame_newslot(bool8388);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8387;
  params[1] = *var_lastToken;
  params[2] = bool8388;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8389 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8386);
// compiled call node returning call8389 (depth = 6)
    gc_frame_newslot(call8389);
    if8365 = call8389;
  }
// compiled if node returning if8365 (depth = 5)
    gc_frame_newslot(if8365);
    if8360 = if8365;
  } else {
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8390 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8391 == NULL) {
    strlit8391 = alloc_String(" {");
    gc_root(strlit8391);
  }
// compiled string node returning strlit8391 (depth = 6)
  gc_frame_newslot(strlit8391);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool8392 = alloc_Boolean(1);
// compiled identifier node returning bool8392 (depth = 6)
  gc_frame_newslot(bool8392);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8391;
  params[1] = *var_lastToken;
  params[2] = bool8392;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8393 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8390);
// compiled call node returning call8393 (depth = 5)
    gc_frame_newslot(call8393);
    if8360 = call8393;
  }
// compiled if node returning if8360 (depth = 4)
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8394 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8395 == NULL) {
    strlit8395 = alloc_String("a method must have a '{' after the name.");
    gc_root(strlit8395);
  }
// compiled string node returning strlit8395 (depth = 5)
  gc_frame_newslot(strlit8395);
// Begin line 2660
  setline(2660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8397 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8396);
// compiled call node returning call8397 (depth = 6)
// compiled member node returning call8397 (depth = 5)
  gc_frame_newslot(call8397);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8400 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8399);
// compiled call node returning call8400 (depth = 7)
// compiled member node returning call8400 (depth = 6)
  int op_slot_right_8398 = gc_frame_newslot(call8400);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8403 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8402);
// compiled call node returning call8403 (depth = 7)
// compiled member node returning call8403 (depth = 6)
  int op_slot_left_8398 = gc_frame_newslot(call8403);
  params[0] = call8400;
  partcv[0] = 1;
  Object sum8404 = callmethod(call8403, "+", 1, partcv, params);
// compiled op node returning sum8404 (depth = 5)
  gc_frame_newslot(sum8404);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2659
  setline(2659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8395;
  params[1] = call8397;
  params[2] = sum8404;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8405 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8394);
// compiled call node returning call8405 (depth = 4)
    gc_frame_newslot(call8405);
    if8240 = call8405;
  }
// compiled if node returning if8240 (depth = 3)
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8406 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8408 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8407);
// compiled call node returning call8408 (depth = 5)
// compiled member node returning call8408 (depth = 4)
  gc_frame_newslot(call8408);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8408;
  partcv[0] = 1;
  Object call8409 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8406);
// compiled call node returning call8409 (depth = 3)
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8410 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8411 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8412 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8411);
// compiled call node returning call8412 (depth = 6)
// compiled member node returning call8412 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8413 = callmethod(call8412, "new",
    1, partcv, params);
  gc_frame_end(callframe8410);
// compiled call node returning call8413 (depth = 4)
  *var_o = call8413;
  if (call8413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8414 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8416 = callmethod(*var_m, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe8415);
// compiled call node returning call8416 (depth = 5)
// compiled member node returning call8416 (depth = 4)
  gc_frame_newslot(call8416);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = call8416;
  partcv[0] = 1;
  Object call8417 = callmethod(*var_o, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe8414);
// compiled call node returning call8417 (depth = 3)
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8419 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8421 = alloc_Boolean(0);
// compiled identifier node returning bool8421 (depth = 5)
  int op_slot_left_8419 = gc_frame_newslot(bool8421);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8422 = callmethod(bool8421, "≠", 1, partcv, params);
// compiled op node returning opresult8422 (depth = 4)
  Object if8418 = done;
  if (istrue(opresult8422)) {
// starting to compile call node (depth = 4)
  int callframe8423 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call8425 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8424);
// compiled call node returning call8425 (depth = 6)
// compiled member node returning call8425 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8426 = callmethod(call8425, "addAll",
    1, partcv, params);
  gc_frame_end(callframe8423);
// compiled call node returning call8426 (depth = 4)
    gc_frame_newslot(call8426);
    if8418 = call8426;
  } else {
  }
// compiled if node returning if8418 (depth = 3)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8427 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8428 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8427);
// compiled call node returning call8428 (depth = 3)
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8430 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8429);
// compiled call node returning call8430 (depth = 4)
// compiled member node returning call8430 (depth = 3)
    gc_frame_newslot(call8430);
    if8219 = call8430;
  } else {
  }
// compiled if node returning if8219 (depth = 2)
  gc_frame_end(frame);
  return if8219;
}
Object meth_parser__apply8440(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8442 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8443 == NULL) {
    strlit8443 = alloc_String("identifier");
    gc_root(strlit8443);
  }
// compiled string node returning strlit8443 (depth = 6)
  gc_frame_newslot(strlit8443);
// call case 4: self request
  params[0] = strlit8443;
  partcv[0] = 1;
  Object call8444 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compiled call node returning call8444 (depth = 5)
  int op_slot_right_8441 = gc_frame_newslot(call8444);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8447 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8448 == NULL) {
    strlit8448 = alloc_String("identifier");
    gc_root(strlit8448);
  }
// compiled string node returning strlit8448 (depth = 7)
  gc_frame_newslot(strlit8448);
// call case 4: self request
  params[0] = strlit8448;
  partcv[0] = 1;
  Object call8449 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8447);
// compiled call node returning call8449 (depth = 6)
  int op_slot_right_8446 = gc_frame_newslot(call8449);
// starting to compile call node (depth = 6)
  int callframe8451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call8452 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8451);
// compiled call node returning call8452 (depth = 6)
  int op_slot_left_8446 = gc_frame_newslot(call8452);
  params[0] = call8449;
  partcv[0] = 1;
  Object opresult8453 = callmethod(call8452, "&&", 1, partcv, params);
// compiled op node returning opresult8453 (depth = 5)
  int op_slot_left_8441 = gc_frame_newslot(opresult8453);
  params[0] = call8444;
  partcv[0] = 1;
  Object opresult8454 = callmethod(opresult8453, "||", 1, partcv, params);
// compiled op node returning opresult8454 (depth = 4)
  gc_frame_end(frame);
  return opresult8454;
}
Object meth_parser__apply8511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8515 == NULL) {
    strlit8515 = alloc_String("*");
    gc_root(strlit8515);
  }
// compiled string node returning strlit8515 (depth = 9)
  int op_slot_right_8514 = gc_frame_newslot(strlit8515);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8518 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8517);
// compiled call node returning call8518 (depth = 10)
// compiled member node returning call8518 (depth = 9)
  int op_slot_left_8514 = gc_frame_newslot(call8518);
  params[0] = strlit8515;
  partcv[0] = 1;
  Object opresult8519 = callmethod(call8518, "==", 1, partcv, params);
// compiled op node returning opresult8519 (depth = 8)
  int op_slot_right_8513 = gc_frame_newslot(opresult8519);
// starting to compile call node (depth = 8)
  int callframe8521 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8522 == NULL) {
    strlit8522 = alloc_String("op");
    gc_root(strlit8522);
  }
// compiled string node returning strlit8522 (depth = 9)
  gc_frame_newslot(strlit8522);
// call case 4: self request
  params[0] = strlit8522;
  partcv[0] = 1;
  Object call8523 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8521);
// compiled call node returning call8523 (depth = 8)
  int op_slot_left_8513 = gc_frame_newslot(call8523);
  params[0] = opresult8519;
  partcv[0] = 1;
  Object opresult8524 = callmethod(call8523, "&&", 1, partcv, params);
// compiled op node returning opresult8524 (depth = 7)
  int op_slot_right_8512 = gc_frame_newslot(opresult8524);
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8526 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8527 == NULL) {
    strlit8527 = alloc_String("identifier");
    gc_root(strlit8527);
  }
// compiled string node returning strlit8527 (depth = 8)
  gc_frame_newslot(strlit8527);
// call case 4: self request
  params[0] = strlit8527;
  partcv[0] = 1;
  Object call8528 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8526);
// compiled call node returning call8528 (depth = 7)
  int op_slot_left_8512 = gc_frame_newslot(call8528);
  params[0] = opresult8524;
  partcv[0] = 1;
  Object opresult8529 = callmethod(call8528, "||", 1, partcv, params);
// compiled op node returning opresult8529 (depth = 6)
  gc_frame_end(frame);
  return opresult8529;
}
Object meth_parser__apply8532(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_nxt = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object *var_comma = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8534 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8535 == NULL) {
    strlit8535 = alloc_String("op");
    gc_root(strlit8535);
  }
// compiled string node returning strlit8535 (depth = 8)
  gc_frame_newslot(strlit8535);
// call case 4: self request
  params[0] = strlit8535;
  partcv[0] = 1;
  Object call8536 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8534);
// compiled call node returning call8536 (depth = 7)
  Object if8533 = done;
  if (istrue(call8536)) {
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8537 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8538 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8537);
// compiled call node returning call8538 (depth = 8)
// compiled member node returning call8538 (depth = 7)
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8539 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8541 == NULL) {
    strlit8541 = alloc_String(" an Iterable.");
    gc_root(strlit8541);
  }
// compiled string node returning strlit8541 (depth = 9)
  int op_slot_right_8540 = gc_frame_newslot(strlit8541);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8545 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8544);
// compiled call node returning call8545 (depth = 11)
// compiled member node returning call8545 (depth = 10)
  int op_slot_right_8543 = gc_frame_newslot(call8545);
// starting to compile string node (depth = 10)
  if (strlit8547 == NULL) {
    strlit8547 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit8547);
  }
// compiled string node returning strlit8547 (depth = 10)
  int op_slot_left_8543 = gc_frame_newslot(strlit8547);
  params[0] = call8545;
  partcv[0] = 1;
  Object opresult8548 = callmethod(strlit8547, "++", 1, partcv, params);
// compiled op node returning opresult8548 (depth = 9)
  int op_slot_left_8540 = gc_frame_newslot(opresult8548);
  params[0] = strlit8541;
  partcv[0] = 1;
  Object opresult8549 = callmethod(opresult8548, "++", 1, partcv, params);
// compiled op node returning opresult8549 (depth = 8)
  gc_frame_newslot(opresult8549);
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call8551 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8550);
// compiled call node returning call8551 (depth = 9)
// compiled member node returning call8551 (depth = 8)
  gc_frame_newslot(call8551);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call8553 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8552);
// compiled call node returning call8553 (depth = 9)
// compiled member node returning call8553 (depth = 8)
  gc_frame_newslot(call8553);
// call case 6: other member request
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult8549;
  params[1] = call8551;
  params[2] = call8553;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call8554 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe8539);
// compiled call node returning call8554 (depth = 7)
    gc_frame_newslot(call8554);
    if8533 = call8554;
  } else {
  }
// compiled if node returning if8533 (depth = 6)
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8556 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8555);
// compiled call node returning call8556 (depth = 7)
// compiled member node returning call8556 (depth = 6)
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8558 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8557);
// compiled call node returning call8558 (depth = 8)
// compiled member node returning call8558 (depth = 7)
  *var_nxt = call8558;
  if (call8558 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8560 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool8561 = alloc_Boolean(1);
// compiled identifier node returning bool8561 (depth = 7)
  gc_frame_newslot(bool8561);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = bool8561;
  partcv[0] = 1;
  Object call8562 = callmethod(*var_nxt, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8560);
// compiled call node returning call8562 (depth = 6)
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8563 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8565 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8564);
// compiled call node returning call8565 (depth = 8)
// compiled member node returning call8565 (depth = 7)
  gc_frame_newslot(call8565);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  params[0] = call8565;
  partcv[0] = 1;
  Object call8566 = callmethod(*var_nxt, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8563);
// compiled call node returning call8566 (depth = 6)
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8567 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call8569 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe8568);
// compiled call node returning call8569 (depth = 8)
// compiled member node returning call8569 (depth = 7)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call8570 = callmethod(call8569, "push",
    1, partcv, params);
  gc_frame_end(callframe8567);
// compiled call node returning call8570 (depth = 6)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8572 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8573 == NULL) {
    strlit8573 = alloc_String("comma");
    gc_root(strlit8573);
  }
// compiled string node returning strlit8573 (depth = 8)
  gc_frame_newslot(strlit8573);
// call case 4: self request
  params[0] = strlit8573;
  partcv[0] = 1;
  Object call8574 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8572);
// compiled call node returning call8574 (depth = 7)
  Object if8571 = done;
  if (istrue(call8574)) {
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2713
  setline(2713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8577 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8576);
// compiled call node returning call8577 (depth = 8)
// compiled member node returning call8577 (depth = 7)
    gc_frame_newslot(call8577);
    if8571 = call8577;
  } else {
  }
// compiled if node returning if8571 (depth = 6)
  gc_frame_end(frame);
  return if8571;
}
Object meth_parser__apply8457(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_methname = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_nxt = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_signature = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_comma = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "comma");
// starting to compile bind node (depth = 4)
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8459 == NULL) {
    strlit8459 = alloc_String("()");
    gc_root(strlit8459);
  }
// compiled string node returning strlit8459 (depth = 6)
  int op_slot_right_8458 = gc_frame_newslot(strlit8459);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_8458 = gc_frame_newslot(*var_methname);
  params[0] = strlit8459;
  partcv[0] = 1;
  Object opresult8461 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult8461 (depth = 5)
  *var_methname = opresult8461;
  if (opresult8461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8463 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8464 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8465 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8464);
// compiled call node returning call8465 (depth = 8)
// compiled member node returning call8465 (depth = 7)
  partcv[0] = 0;
  Object call8466 = callmethod(call8465, "new",
    1, partcv, params);
  gc_frame_end(callframe8463);
// compiled call node returning call8466 (depth = 6)
// compiled member node returning call8466 (depth = 5)
  *var_part = call8466;
  if (call8466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8467 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8468 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8467);
// compiled call node returning call8468 (depth = 5)
// compiled member node returning call8468 (depth = 4)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8469 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8470 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8469);
// compiled call node returning call8470 (depth = 6)
// compiled member node returning call8470 (depth = 5)
  *var_nxt = call8470;
  if (call8470 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call8474 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8473);
// compiled call node returning call8474 (depth = 7)
// compiled member node returning call8474 (depth = 6)
  int op_slot_right_8472 = gc_frame_newslot(call8474);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_8472 = gc_frame_newslot(*var_methname);
  params[0] = call8474;
  partcv[0] = 1;
  Object opresult8476 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult8476 (depth = 5)
  *var_methname = opresult8476;
  if (opresult8476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8478 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nxt (depth = 7)
  partcv[0] = 0;
  Object call8480 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8479);
// compiled call node returning call8480 (depth = 6)
// compiled member node returning call8480 (depth = 5)
  gc_frame_newslot(call8480);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call8480;
  partcv[0] = 1;
  Object call8481 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8478);
// compiled call node returning call8481 (depth = 4)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8483 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8484 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8485 == NULL) {
    strlit8485 = alloc_String("lparen");
    gc_root(strlit8485);
  }
// compiled string node returning strlit8485 (depth = 8)
  gc_frame_newslot(strlit8485);
// call case 4: self request
  params[0] = strlit8485;
  partcv[0] = 1;
  Object call8486 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8484);
// compiled call node returning call8486 (depth = 7)
  partcv[0] = 0;
  Object call8487 = callmethod(call8486, "not",
    1, partcv, params);
  gc_frame_end(callframe8483);
// compiled call node returning call8487 (depth = 6)
// compiled member node returning call8487 (depth = 5)
  Object if8482 = done;
  if (istrue(call8487)) {
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8488 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8489 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8490 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8489);
// compiled call node returning call8490 (depth = 9)
// compiled member node returning call8490 (depth = 8)
  partcv[0] = 0;
  Object call8491 = callmethod(call8490, "new",
    1, partcv, params);
  gc_frame_end(callframe8488);
// compiled call node returning call8491 (depth = 7)
// compiled member node returning call8491 (depth = 6)
  *var_suggestion = call8491;
  if (call8491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8492 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8493 == NULL) {
    strlit8493 = alloc_String("()");
    gc_root(strlit8493);
  }
// compiled string node returning strlit8493 (depth = 6)
  gc_frame_newslot(strlit8493);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8493;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8494 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8492);
// compiled call node returning call8494 (depth = 5)
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8495 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8497 == NULL) {
    strlit8497 = alloc_String("parameter lists must have parentheses around each parameter list.");
    gc_root(strlit8497);
  }
// compiled string node returning strlit8497 (depth = 7)
  int op_slot_right_8496 = gc_frame_newslot(strlit8497);
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8499 == NULL) {
    strlit8499 = alloc_String("the declaration of a method with multiple ");
    gc_root(strlit8499);
  }
// compiled string node returning strlit8499 (depth = 7)
  int op_slot_left_8496 = gc_frame_newslot(strlit8499);
  params[0] = strlit8497;
  partcv[0] = 1;
  Object opresult8500 = callmethod(strlit8499, "++", 1, partcv, params);
// compiled op node returning opresult8500 (depth = 6)
  gc_frame_newslot(opresult8500);
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8501 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8502 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8501);
// compiled call node returning call8502 (depth = 7)
// compiled member node returning call8502 (depth = 6)
  gc_frame_newslot(call8502);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8503 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8504 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8503);
// compiled call node returning call8504 (depth = 7)
// compiled member node returning call8504 (depth = 6)
  gc_frame_newslot(call8504);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult8500;
  params[1] = call8502;
  params[2] = call8504;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8505 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8495);
// compiled call node returning call8505 (depth = 5)
    gc_frame_newslot(call8505);
    if8482 = call8505;
  } else {
  }
// compiled if node returning if8482 (depth = 4)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8506 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8507 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8506);
// compiled call node returning call8507 (depth = 5)
// compiled member node returning call8507 (depth = 4)
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8508 = alloc_Boolean(0);
// compiled identifier node returning bool8508 (depth = 5)
  *var_comma = bool8508;
  if (bool8508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8509 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8510 = alloc_Block(NULL, NULL, "parser", 2699);
  gc_frame_newslot(block8510);
// method "_apply"
  block_savedest(block8510);
  Object closure8511 = createclosure(2, "_apply");
  setclosureframe(closure8511, stackframe);
  addtoclosure(closure8511, var_sym);
  addtoclosure(closure8511, selfslot);
  struct UserObject *uo8511 = (struct UserObject*)block8510;
  uo8511->data[0] = (Object)closure8511;
  Method *meth_meth_parser__apply8511 = addmethod2pos(block8510, "_apply", &meth_parser__apply8511, 0);
  int argcv_meth_parser__apply8511[] = {0};
  meth_meth_parser__apply8511->type = alloc_MethodType(1, argcv_meth_parser__apply8511);
  meth_meth_parser__apply8511->definitionModule = modulename;
  meth_meth_parser__apply8511->definitionLine = 2697;
// compiled block node returning block8510 (depth = 5)
  gc_frame_newslot(block8510);
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block8531 = alloc_Block(NULL, NULL, "parser", 2700);
  gc_frame_newslot(block8531);
// method "_apply"
  block_savedest(block8531);
  Object closure8532 = createclosure(8, "_apply");
  setclosureframe(closure8532, stackframe);
  addtoclosure(closure8532, var_sym);
  addtoclosure(closure8532, var_lastToken);
  addtoclosure(closure8532, var_errormessages);
  addtoclosure(closure8532, var_values);
  addtoclosure(closure8532, var_nxt);
  addtoclosure(closure8532, var_part);
  addtoclosure(closure8532, var_comma);
  addtoclosure(closure8532, selfslot);
  struct UserObject *uo8532 = (struct UserObject*)block8531;
  uo8532->data[0] = (Object)closure8532;
  Method *meth_meth_parser__apply8532 = addmethod2pos(block8531, "_apply", &meth_parser__apply8532, 0);
  int argcv_meth_parser__apply8532[] = {0};
  meth_meth_parser__apply8532->type = alloc_MethodType(1, argcv_meth_parser__apply8532);
  meth_meth_parser__apply8532->definitionModule = modulename;
  meth_meth_parser__apply8532->definitionLine = 2700;
// compiled block node returning block8531 (depth = 5)
  gc_frame_newslot(block8531);
// call case 5: prelude request
  params[0] = block8510;
  params[1] = block8531;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8579 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8509);
// compiled call node returning call8579 (depth = 4)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8582 == NULL) {
    strlit8582 = alloc_String("rparen");
    gc_root(strlit8582);
  }
// compiled string node returning strlit8582 (depth = 6)
  int op_slot_right_8581 = gc_frame_newslot(strlit8582);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8585 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8584);
// compiled call node returning call8585 (depth = 7)
// compiled member node returning call8585 (depth = 6)
  int op_slot_left_8581 = gc_frame_newslot(call8585);
  params[0] = strlit8582;
  partcv[0] = 1;
  Object opresult8586 = callmethod(call8585, "≠", 1, partcv, params);
// compiled op node returning opresult8586 (depth = 5)
  Object if8580 = done;
  if (istrue(opresult8586)) {
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8587 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8589 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8588);
// compiled call node returning call8589 (depth = 9)
// compiled member node returning call8589 (depth = 8)
  partcv[0] = 0;
  Object call8590 = callmethod(call8589, "new",
    1, partcv, params);
  gc_frame_end(callframe8587);
// compiled call node returning call8590 (depth = 7)
// compiled member node returning call8590 (depth = 6)
  *var_suggestion = call8590;
  if (call8590 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8591 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8592 == NULL) {
    strlit8592 = alloc_String(")");
    gc_root(strlit8592);
  }
// compiled string node returning strlit8592 (depth = 6)
  gc_frame_newslot(strlit8592);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8592;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8593 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8591);
// compiled call node returning call8593 (depth = 5)
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8594 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8595 == NULL) {
    strlit8595 = alloc_String("a part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit8595);
  }
// compiled string node returning strlit8595 (depth = 6)
  gc_frame_newslot(strlit8595);
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8597 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8596);
// compiled call node returning call8597 (depth = 7)
// compiled member node returning call8597 (depth = 6)
  gc_frame_newslot(call8597);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8600 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8599);
// compiled call node returning call8600 (depth = 8)
// compiled member node returning call8600 (depth = 7)
  int op_slot_right_8598 = gc_frame_newslot(call8600);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8603 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8602);
// compiled call node returning call8603 (depth = 8)
// compiled member node returning call8603 (depth = 7)
  int op_slot_left_8598 = gc_frame_newslot(call8603);
  params[0] = call8600;
  partcv[0] = 1;
  Object sum8604 = callmethod(call8603, "+", 1, partcv, params);
// compiled op node returning sum8604 (depth = 6)
  gc_frame_newslot(sum8604);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8595;
  params[1] = call8597;
  params[2] = sum8604;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8605 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8594);
// compiled call node returning call8605 (depth = 5)
    gc_frame_newslot(call8605);
    if8580 = call8605;
  } else {
  }
// compiled if node returning if8580 (depth = 4)
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8607 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8606);
// compiled call node returning call8607 (depth = 5)
// compiled member node returning call8607 (depth = 4)
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8608 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call8609 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe8608);
// compiled call node returning call8609 (depth = 4)
  gc_frame_end(frame);
  return call8609;
}
Object meth_parser_methodDecRest8431(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodDecRest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method methodDecRest");
  Object params[2];
  int partcv[2];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodDecRest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for methodDecRest");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methname");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_newName = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newName");
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tm (depth = 7)
  partcv[0] = 0;
  Object call8434 = callmethod(*var_tm, "value",
    1, partcv, params);
  gc_frame_end(callframe8433);
// compiled call node returning call8434 (depth = 6)
// compiled member node returning call8434 (depth = 5)
  partcv[0] = 0;
  Object call8435 = callmethod(call8434, "value",
    1, partcv, params);
  gc_frame_end(callframe8432);
// compiled call node returning call8435 (depth = 4)
// compiled member node returning call8435 (depth = 3)
  *var_methname = call8435;
  if (call8435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2681
  setline(2681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tm (depth = 5)
  partcv[0] = 0;
  Object call8437 = callmethod(*var_tm, "signature",
    1, partcv, params);
  gc_frame_end(callframe8436);
// compiled call node returning call8437 (depth = 4)
// compiled member node returning call8437 (depth = 3)
  *var_signature = call8437;
  if (call8437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8438 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8439 = alloc_Block(NULL, NULL, "parser", 2683);
  gc_frame_newslot(block8439);
// method "_apply"
  block_savedest(block8439);
  Object closure8440 = createclosure(2, "_apply");
  setclosureframe(closure8440, stackframe);
  addtoclosure(closure8440, var_sameline);
  addtoclosure(closure8440, selfslot);
  struct UserObject *uo8440 = (struct UserObject*)block8439;
  uo8440->data[0] = (Object)closure8440;
  Method *meth_meth_parser__apply8440 = addmethod2pos(block8439, "_apply", &meth_parser__apply8440, 0);
  int argcv_meth_parser__apply8440[] = {0};
  meth_meth_parser__apply8440->type = alloc_MethodType(1, argcv_meth_parser__apply8440);
  meth_meth_parser__apply8440->definitionModule = modulename;
  meth_meth_parser__apply8440->definitionLine = 2681;
// compiled block node returning block8439 (depth = 3)
  gc_frame_newslot(block8439);
// starting to compile block node (depth = 3)
  Object block8456 = alloc_Block(NULL, NULL, "parser", 2683);
  gc_frame_newslot(block8456);
// method "_apply"
  block_savedest(block8456);
  Object closure8457 = createclosure(9, "_apply");
  setclosureframe(closure8457, stackframe);
  addtoclosure(closure8457, var_methname);
  addtoclosure(closure8457, var_ast);
  addtoclosure(closure8457, var_values);
  addtoclosure(closure8457, var_nxt);
  addtoclosure(closure8457, var_errormessages);
  addtoclosure(closure8457, var_lastToken);
  addtoclosure(closure8457, var_sym);
  addtoclosure(closure8457, var_signature);
  addtoclosure(closure8457, selfslot);
  struct UserObject *uo8457 = (struct UserObject*)block8456;
  uo8457->data[0] = (Object)closure8457;
  Method *meth_meth_parser__apply8457 = addmethod2pos(block8456, "_apply", &meth_parser__apply8457, 0);
  int argcv_meth_parser__apply8457[] = {0};
  meth_meth_parser__apply8457->type = alloc_MethodType(1, argcv_meth_parser__apply8457);
  meth_meth_parser__apply8457->definitionModule = modulename;
  meth_meth_parser__apply8457->definitionLine = 2681;
// compiled block node returning block8456 (depth = 3)
  gc_frame_newslot(block8456);
// call case 5: prelude request
  params[0] = block8439;
  params[1] = block8456;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8611 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8438);
// compiled call node returning call8611 (depth = 2)
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8612 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool8613 = alloc_Boolean(0);
// compiled identifier node returning bool8613 (depth = 4)
  gc_frame_newslot(bool8613);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8615 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8614);
// compiled call node returning call8615 (depth = 5)
// compiled member node returning call8615 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool8613;
  partcv[0] = 2;
  Object call8616 = callmethod(call8615, "new",
    1, partcv, params);
  gc_frame_end(callframe8612);
// compiled call node returning call8616 (depth = 3)
  *var_newName = call8616;
  if (call8616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8617 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8618 = alloc_Boolean(1);
// compiled identifier node returning bool8618 (depth = 3)
  gc_frame_newslot(bool8618);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newName (depth = 3)
  params[0] = bool8618;
  partcv[0] = 1;
  Object call8619 = callmethod(*var_newName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8617);
// compiled call node returning call8619 (depth = 2)
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newName (depth = 2)
  gc_frame_end(frame);
  return *var_newName;
}
Object meth_parser__apply8630(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8632 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8631);
// compiled call node returning call8632 (depth = 7)
// compiled member node returning call8632 (depth = 6)
  gc_frame_end(frame);
  return call8632;
}
Object meth_parser_optionalTypeAnnotation8620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "optionalTypeAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for optionalTypeAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for optionalTypeAnnotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8622 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8623 == NULL) {
    strlit8623 = alloc_String("colon");
    gc_root(strlit8623);
  }
// compiled string node returning strlit8623 (depth = 4)
  gc_frame_newslot(strlit8623);
// call case 4: self request
  params[0] = strlit8623;
  partcv[0] = 1;
  Object call8624 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8622);
// compiled call node returning call8624 (depth = 3)
  Object if8621 = done;
  if (istrue(call8624)) {
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8625 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8626 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8625);
// compiled call node returning call8626 (depth = 4)
// compiled member node returning call8626 (depth = 3)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8628 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8629 = alloc_Block(NULL, NULL, "parser", 2735);
  gc_frame_newslot(block8629);
// method "_apply"
  block_savedest(block8629);
  Object closure8630 = createclosure(1, "_apply");
  setclosureframe(closure8630, stackframe);
  addtoclosure(closure8630, selfslot);
  struct UserObject *uo8630 = (struct UserObject*)block8629;
  uo8630->data[0] = (Object)closure8630;
  Method *meth_meth_parser__apply8630 = addmethod2pos(block8629, "_apply", &meth_parser__apply8630, 0);
  int argcv_meth_parser__apply8630[] = {0};
  meth_meth_parser__apply8630->type = alloc_MethodType(1, argcv_meth_parser__apply8630);
  meth_meth_parser__apply8630->definitionModule = modulename;
  meth_meth_parser__apply8630->definitionLine = 2734;
// compiled block node returning block8629 (depth = 5)
  gc_frame_newslot(block8629);
// call case 4: self request
  params[0] = block8629;
  partcv[0] = 1;
  Object call8634 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8628);
// compiled call node returning call8634 (depth = 4)
  Object if8627 = done;
  if (istrue(call8634)) {
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8636 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8635);
// compiled call node returning call8636 (depth = 5)
// compiled member node returning call8636 (depth = 4)
    gc_frame_newslot(call8636);
    if8627 = call8636;
  } else {
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8638 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8637);
// compiled call node returning call8638 (depth = 5)
// compiled member node returning call8638 (depth = 4)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array8639 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8639 (depth = 5)
  *var_suggestions = array8639;
  if (array8639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8640 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8642 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8641);
// compiled call node returning call8642 (depth = 8)
// compiled member node returning call8642 (depth = 7)
  partcv[0] = 0;
  Object call8643 = callmethod(call8642, "new",
    1, partcv, params);
  gc_frame_end(callframe8640);
// compiled call node returning call8643 (depth = 6)
// compiled member node returning call8643 (depth = 5)
  *var_suggestion = call8643;
  if (call8643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8644 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8645 == NULL) {
    strlit8645 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit8645);
  }
// compiled string node returning strlit8645 (depth = 5)
  gc_frame_newslot(strlit8645);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8645;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8646 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8644);
// compiled call node returning call8646 (depth = 4)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8647 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8648 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8647);
// compiled call node returning call8648 (depth = 4)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8649 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8651 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8650);
// compiled call node returning call8651 (depth = 8)
// compiled member node returning call8651 (depth = 7)
  partcv[0] = 0;
  Object call8652 = callmethod(call8651, "new",
    1, partcv, params);
  gc_frame_end(callframe8649);
// compiled call node returning call8652 (depth = 6)
// compiled member node returning call8652 (depth = 5)
  *var_suggestion = call8652;
  if (call8652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8654 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 5)
  Object bool8655 = alloc_Boolean(1);
// compiled identifier node returning bool8655 (depth = 5)
  gc_frame_newslot(bool8655);
// starting to compile identifier node (depth = 5)
  Object bool8656 = alloc_Boolean(0);
// compiled identifier node returning bool8656 (depth = 5)
  gc_frame_newslot(bool8656);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = bool8655;
  params[2] = bool8656;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8657 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe8654);
// compiled call node returning call8657 (depth = 4)
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8658 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8659 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8658);
// compiled call node returning call8659 (depth = 4)
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8660 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8661 == NULL) {
    strlit8661 = alloc_String("a type name or type expression must follow ':'.");
    gc_root(strlit8661);
  }
// compiled string node returning strlit8661 (depth = 5)
  gc_frame_newslot(strlit8661);
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8663 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8662);
// compiled call node returning call8663 (depth = 6)
// compiled member node returning call8663 (depth = 5)
  gc_frame_newslot(call8663);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8665 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8664);
// compiled call node returning call8665 (depth = 6)
// compiled member node returning call8665 (depth = 5)
  gc_frame_newslot(call8665);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8661;
  params[1] = call8663;
  params[2] = call8665;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8666 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8660);
// compiled call node returning call8666 (depth = 4)
    gc_frame_newslot(call8666);
    if8627 = call8666;
  }
// compiled if node returning if8627 (depth = 3)
    gc_frame_newslot(if8627);
    if8621 = if8627;
  } else {
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool8667 = alloc_Boolean(0);
// compiled identifier node returning bool8667 (depth = 3)
    gc_frame_newslot(bool8667);
    if8621 = bool8667;
  }
// compiled if node returning if8621 (depth = 2)
  gc_frame_end(frame);
  return if8621;
}
Object meth_parser__apply8744(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8746 == NULL) {
    strlit8746 = alloc_String("rsquare");
    gc_root(strlit8746);
  }
// compiled string node returning strlit8746 (depth = 6)
  int op_slot_right_8745 = gc_frame_newslot(strlit8746);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8748 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8749 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8748);
// compiled call node returning call8749 (depth = 7)
// compiled member node returning call8749 (depth = 6)
  int op_slot_left_8745 = gc_frame_newslot(call8749);
  params[0] = strlit8746;
  partcv[0] = 1;
  Object opresult8750 = callmethod(call8749, "==", 1, partcv, params);
// compiled op node returning opresult8750 (depth = 5)
  gc_frame_end(frame);
  return opresult8750;
}
Object meth_parser__apply8846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8850 == NULL) {
    strlit8850 = alloc_String("*");
    gc_root(strlit8850);
  }
// compiled string node returning strlit8850 (depth = 8)
  int op_slot_right_8849 = gc_frame_newslot(strlit8850);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8852 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8853 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8852);
// compiled call node returning call8853 (depth = 9)
// compiled member node returning call8853 (depth = 8)
  int op_slot_left_8849 = gc_frame_newslot(call8853);
  params[0] = strlit8850;
  partcv[0] = 1;
  Object opresult8854 = callmethod(call8853, "==", 1, partcv, params);
// compiled op node returning opresult8854 (depth = 7)
  int op_slot_right_8848 = gc_frame_newslot(opresult8854);
// starting to compile call node (depth = 7)
  int callframe8856 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8857 == NULL) {
    strlit8857 = alloc_String("op");
    gc_root(strlit8857);
  }
// compiled string node returning strlit8857 (depth = 8)
  gc_frame_newslot(strlit8857);
// call case 4: self request
  params[0] = strlit8857;
  partcv[0] = 1;
  Object call8858 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8856);
// compiled call node returning call8858 (depth = 7)
  int op_slot_left_8848 = gc_frame_newslot(call8858);
  params[0] = opresult8854;
  partcv[0] = 1;
  Object opresult8859 = callmethod(call8858, "&&", 1, partcv, params);
// compiled op node returning opresult8859 (depth = 6)
  int op_slot_right_8847 = gc_frame_newslot(opresult8859);
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8861 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8862 == NULL) {
    strlit8862 = alloc_String("identifier");
    gc_root(strlit8862);
  }
// compiled string node returning strlit8862 (depth = 7)
  gc_frame_newslot(strlit8862);
// call case 4: self request
  params[0] = strlit8862;
  partcv[0] = 1;
  Object call8863 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8861);
// compiled call node returning call8863 (depth = 6)
  int op_slot_left_8847 = gc_frame_newslot(call8863);
  params[0] = opresult8859;
  partcv[0] = 1;
  Object opresult8864 = callmethod(call8863, "||", 1, partcv, params);
// compiled op node returning opresult8864 (depth = 5)
  gc_frame_end(frame);
  return opresult8864;
}
Object meth_parser__apply8867(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_id = getfromclosure(closure, 4);
  Object *var_dtype = getfromclosure(closure, 5);
  Object *var_part = getfromclosure(closure, 6);
  Object *var_comma = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8869 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8870 == NULL) {
    strlit8870 = alloc_String("op");
    gc_root(strlit8870);
  }
// compiled string node returning strlit8870 (depth = 7)
  gc_frame_newslot(strlit8870);
// call case 4: self request
  params[0] = strlit8870;
  partcv[0] = 1;
  Object call8871 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8869);
// compiled call node returning call8871 (depth = 6)
  Object if8868 = done;
  if (istrue(call8871)) {
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8873 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8872);
// compiled call node returning call8873 (depth = 7)
// compiled member node returning call8873 (depth = 6)
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8874 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8876 == NULL) {
    strlit8876 = alloc_String(" an Iterable.");
    gc_root(strlit8876);
  }
// compiled string node returning strlit8876 (depth = 8)
  int op_slot_right_8875 = gc_frame_newslot(strlit8876);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8880 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 10)
// compiled member node returning call8880 (depth = 9)
  int op_slot_right_8878 = gc_frame_newslot(call8880);
// starting to compile string node (depth = 9)
  if (strlit8882 == NULL) {
    strlit8882 = alloc_String("variable length parameters (parameters prefixed by '*') are no longer part of Grace.  Consider making ");
    gc_root(strlit8882);
  }
// compiled string node returning strlit8882 (depth = 9)
  int op_slot_left_8878 = gc_frame_newslot(strlit8882);
  params[0] = call8880;
  partcv[0] = 1;
  Object opresult8883 = callmethod(strlit8882, "++", 1, partcv, params);
// compiled op node returning opresult8883 (depth = 8)
  int op_slot_left_8875 = gc_frame_newslot(opresult8883);
  params[0] = strlit8876;
  partcv[0] = 1;
  Object opresult8884 = callmethod(opresult8883, "++", 1, partcv, params);
// compiled op node returning opresult8884 (depth = 7)
  gc_frame_newslot(opresult8884);
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8886 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8885);
// compiled call node returning call8886 (depth = 8)
// compiled member node returning call8886 (depth = 7)
  gc_frame_newslot(call8886);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8888 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8887);
// compiled call node returning call8888 (depth = 8)
// compiled member node returning call8888 (depth = 7)
  gc_frame_newslot(call8888);
// call case 6: other member request
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult8884;
  params[1] = call8886;
  params[2] = call8888;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call8889 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe8874);
// compiled call node returning call8889 (depth = 6)
    gc_frame_newslot(call8889);
    if8868 = call8889;
  } else {
  }
// compiled if node returning if8868 (depth = 5)
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8890 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8891 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8890);
// compiled call node returning call8891 (depth = 6)
// compiled member node returning call8891 (depth = 5)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8893 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8892);
// compiled call node returning call8893 (depth = 7)
// compiled member node returning call8893 (depth = 6)
  *var_id = call8893;
  if (call8893 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8895 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool8896 = alloc_Boolean(1);
// compiled identifier node returning bool8896 (depth = 6)
  gc_frame_newslot(bool8896);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = bool8896;
  partcv[0] = 1;
  Object call8897 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8895);
// compiled call node returning call8897 (depth = 5)
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8899 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8898);
// compiled call node returning call8899 (depth = 7)
// compiled member node returning call8899 (depth = 6)
  *var_dtype = call8899;
  if (call8899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8901 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object call8902 = callmethod(*var_id, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8901);
// compiled call node returning call8902 (depth = 5)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8903 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call8905 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe8904);
// compiled call node returning call8905 (depth = 7)
// compiled member node returning call8905 (depth = 6)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call8906 = callmethod(call8905, "push",
    1, partcv, params);
  gc_frame_end(callframe8903);
// compiled call node returning call8906 (depth = 5)
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8908 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8909 == NULL) {
    strlit8909 = alloc_String("comma");
    gc_root(strlit8909);
  }
// compiled string node returning strlit8909 (depth = 7)
  gc_frame_newslot(strlit8909);
// call case 4: self request
  params[0] = strlit8909;
  partcv[0] = 1;
  Object call8910 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8908);
// compiled call node returning call8910 (depth = 6)
  Object if8907 = done;
  if (istrue(call8910)) {
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8913 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8912);
// compiled call node returning call8913 (depth = 7)
// compiled member node returning call8913 (depth = 6)
    gc_frame_newslot(call8913);
    if8907 = call8913;
  } else {
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8916 == NULL) {
    strlit8916 = alloc_String("rparen");
    gc_root(strlit8916);
  }
// compiled string node returning strlit8916 (depth = 8)
  int op_slot_right_8915 = gc_frame_newslot(strlit8916);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8919 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8918);
// compiled call node returning call8919 (depth = 9)
// compiled member node returning call8919 (depth = 8)
  int op_slot_left_8915 = gc_frame_newslot(call8919);
  params[0] = strlit8916;
  partcv[0] = 1;
  Object opresult8920 = callmethod(call8919, "≠", 1, partcv, params);
// compiled op node returning opresult8920 (depth = 7)
  Object if8914 = done;
  if (istrue(opresult8920)) {
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8923 == NULL) {
    strlit8923 = alloc_String("rparen");
    gc_root(strlit8923);
  }
// compiled string node returning strlit8923 (depth = 9)
  int op_slot_right_8922 = gc_frame_newslot(strlit8923);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call8926 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8925);
// compiled call node returning call8926 (depth = 10)
// compiled member node returning call8926 (depth = 9)
  int op_slot_left_8922 = gc_frame_newslot(call8926);
  params[0] = strlit8923;
  partcv[0] = 1;
  Object opresult8927 = callmethod(call8926, "≠", 1, partcv, params);
// compiled op node returning opresult8927 (depth = 8)
  Object if8921 = done;
  if (istrue(opresult8927)) {
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8928 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call8930 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8929);
// compiled call node returning call8930 (depth = 12)
// compiled member node returning call8930 (depth = 11)
  partcv[0] = 0;
  Object call8931 = callmethod(call8930, "new",
    1, partcv, params);
  gc_frame_end(callframe8928);
// compiled call node returning call8931 (depth = 10)
// compiled member node returning call8931 (depth = 9)
  *var_suggestion = call8931;
  if (call8931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8932 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8933 == NULL) {
    strlit8933 = alloc_String(")");
    gc_root(strlit8933);
  }
// compiled string node returning strlit8933 (depth = 9)
  gc_frame_newslot(strlit8933);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit8933;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8934 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8932);
// compiled call node returning call8934 (depth = 8)
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe8935 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8936 == NULL) {
    strlit8936 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit8936);
  }
// compiled string node returning strlit8936 (depth = 9)
  gc_frame_newslot(strlit8936);
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8938 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8937);
// compiled call node returning call8938 (depth = 10)
// compiled member node returning call8938 (depth = 9)
  gc_frame_newslot(call8938);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8941 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8940);
// compiled call node returning call8941 (depth = 11)
// compiled member node returning call8941 (depth = 10)
  int op_slot_right_8939 = gc_frame_newslot(call8941);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call8944 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8943);
// compiled call node returning call8944 (depth = 11)
// compiled member node returning call8944 (depth = 10)
  int op_slot_left_8939 = gc_frame_newslot(call8944);
  params[0] = call8941;
  partcv[0] = 1;
  Object sum8945 = callmethod(call8944, "+", 1, partcv, params);
// compiled op node returning sum8945 (depth = 9)
  gc_frame_newslot(sum8945);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit8936;
  params[1] = call8938;
  params[2] = sum8945;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8946 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8935);
// compiled call node returning call8946 (depth = 8)
    gc_frame_newslot(call8946);
    if8921 = call8946;
  } else {
  }
// compiled if node returning if8921 (depth = 7)
    gc_frame_newslot(if8921);
    if8914 = if8921;
  } else {
  }
// compiled if node returning if8914 (depth = 6)
    gc_frame_newslot(if8914);
    if8907 = if8914;
  }
// compiled if node returning if8907 (depth = 5)
  gc_frame_end(frame);
  return if8907;
}
Object meth_parser__apply8962(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8965 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8966 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8965);
// compiled call node returning call8966 (depth = 10)
// compiled member node returning call8966 (depth = 9)
  int op_slot_right_8964 = gc_frame_newslot(call8966);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call8969 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe8968);
// compiled call node returning call8969 (depth = 10)
// compiled member node returning call8969 (depth = 9)
  int op_slot_left_8964 = gc_frame_newslot(call8969);
  params[0] = call8966;
  partcv[0] = 1;
  Object opresult8970 = callmethod(call8969, "==", 1, partcv, params);
// compiled op node returning opresult8970 (depth = 8)
  int op_slot_right_8963 = gc_frame_newslot(opresult8970);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8973 == NULL) {
    strlit8973 = alloc_String("rparen");
    gc_root(strlit8973);
  }
// compiled string node returning strlit8973 (depth = 9)
  int op_slot_right_8972 = gc_frame_newslot(strlit8973);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8975 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call8976 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe8975);
// compiled call node returning call8976 (depth = 10)
// compiled member node returning call8976 (depth = 9)
  int op_slot_left_8972 = gc_frame_newslot(call8976);
  params[0] = strlit8973;
  partcv[0] = 1;
  Object opresult8977 = callmethod(call8976, "==", 1, partcv, params);
// compiled op node returning opresult8977 (depth = 8)
  int op_slot_left_8963 = gc_frame_newslot(opresult8977);
  params[0] = opresult8970;
  partcv[0] = 1;
  Object opresult8978 = callmethod(opresult8977, "&&", 1, partcv, params);
// compiled op node returning opresult8978 (depth = 7)
  gc_frame_end(frame);
  return opresult8978;
}
Object meth_parser_methodsignature8668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_myTypeParams = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "myTypeParams");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_lparen = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "lparen");
  Object *var_id = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "id");
  Object *var_comma = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "comma");
  Object *var_rparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "rparen");
  Object *var_tm = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "tm");
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8672 == NULL) {
    strlit8672 = alloc_String("lsquare");
    gc_root(strlit8672);
  }
// compiled string node returning strlit8672 (depth = 5)
  int op_slot_right_8671 = gc_frame_newslot(strlit8672);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8674 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8675 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8674);
// compiled call node returning call8675 (depth = 6)
// compiled member node returning call8675 (depth = 5)
  int op_slot_left_8671 = gc_frame_newslot(call8675);
  params[0] = strlit8672;
  partcv[0] = 1;
  Object opresult8676 = callmethod(call8675, "≠", 1, partcv, params);
// compiled op node returning opresult8676 (depth = 4)
  int op_slot_right_8670 = gc_frame_newslot(opresult8676);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8680 == NULL) {
    strlit8680 = alloc_String("op");
    gc_root(strlit8680);
  }
// compiled string node returning strlit8680 (depth = 6)
  int op_slot_right_8679 = gc_frame_newslot(strlit8680);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8683 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8682);
// compiled call node returning call8683 (depth = 7)
// compiled member node returning call8683 (depth = 6)
  int op_slot_left_8679 = gc_frame_newslot(call8683);
  params[0] = strlit8680;
  partcv[0] = 1;
  Object opresult8684 = callmethod(call8683, "≠", 1, partcv, params);
// compiled op node returning opresult8684 (depth = 5)
  int op_slot_right_8678 = gc_frame_newslot(opresult8684);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8687 == NULL) {
    strlit8687 = alloc_String("identifier");
    gc_root(strlit8687);
  }
// compiled string node returning strlit8687 (depth = 6)
  int op_slot_right_8686 = gc_frame_newslot(strlit8687);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8690 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8689);
// compiled call node returning call8690 (depth = 7)
// compiled member node returning call8690 (depth = 6)
  int op_slot_left_8686 = gc_frame_newslot(call8690);
  params[0] = strlit8687;
  partcv[0] = 1;
  Object opresult8691 = callmethod(call8690, "≠", 1, partcv, params);
// compiled op node returning opresult8691 (depth = 5)
  int op_slot_left_8678 = gc_frame_newslot(opresult8691);
  params[0] = opresult8684;
  partcv[0] = 1;
  Object opresult8692 = callmethod(opresult8691, "&&", 1, partcv, params);
// compiled op node returning opresult8692 (depth = 4)
  int op_slot_left_8670 = gc_frame_newslot(opresult8692);
  params[0] = opresult8676;
  partcv[0] = 1;
  Object opresult8693 = callmethod(opresult8692, "&&", 1, partcv, params);
// compiled op node returning opresult8693 (depth = 3)
  Object if8669 = done;
  if (istrue(opresult8693)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8696 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 7)
// compiled member node returning call8696 (depth = 6)
  partcv[0] = 0;
  Object call8697 = callmethod(call8696, "new",
    1, partcv, params);
  gc_frame_end(callframe8694);
// compiled call node returning call8697 (depth = 5)
// compiled member node returning call8697 (depth = 4)
  *var_suggestion = call8697;
  if (call8697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8698 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8699 == NULL) {
    strlit8699 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8699);
  }
// compiled string node returning strlit8699 (depth = 4)
  gc_frame_newslot(strlit8699);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8699;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8700 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8698);
// compiled call node returning call8700 (depth = 3)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8701 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8702 == NULL) {
    strlit8702 = alloc_String("a method name must start with an identifier, or be an operator.");
    gc_root(strlit8702);
  }
// compiled string node returning strlit8702 (depth = 4)
  gc_frame_newslot(strlit8702);
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8703 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8704 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8703);
// compiled call node returning call8704 (depth = 5)
// compiled member node returning call8704 (depth = 4)
  gc_frame_newslot(call8704);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8706 = alloc_Float64(1);
// compiled num node returning num8706 (depth = 5)
  int op_slot_right_8705 = gc_frame_newslot(num8706);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8710 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 7)
// compiled member node returning call8710 (depth = 6)
  int op_slot_right_8708 = gc_frame_newslot(call8710);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8713 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8712);
// compiled call node returning call8713 (depth = 7)
// compiled member node returning call8713 (depth = 6)
  int op_slot_left_8708 = gc_frame_newslot(call8713);
  params[0] = call8710;
  partcv[0] = 1;
  Object sum8714 = callmethod(call8713, "+", 1, partcv, params);
// compiled op node returning sum8714 (depth = 5)
  int op_slot_left_8705 = gc_frame_newslot(sum8714);
  params[0] = num8706;
  partcv[0] = 1;
  Object sum8715 = callmethod(sum8714, "+", 1, partcv, params);
// compiled op node returning sum8715 (depth = 4)
  gc_frame_newslot(sum8715);
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8702;
  params[1] = call8704;
  params[2] = sum8715;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8716 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8701);
// compiled call node returning call8716 (depth = 3)
    gc_frame_newslot(call8716);
    if8669 = call8716;
  } else {
  }
// compiled if node returning if8669 (depth = 2)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8718 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8717);
// compiled call node returning call8718 (depth = 3)
// compiled member node returning call8718 (depth = 2)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8720 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8719);
// compiled call node returning call8720 (depth = 4)
// compiled member node returning call8720 (depth = 3)
  *var_meth = call8720;
  if (call8720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8721 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8722 = alloc_Boolean(1);
// compiled identifier node returning bool8722 (depth = 3)
  gc_frame_newslot(bool8722);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool8722;
  partcv[0] = 1;
  Object call8723 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8721);
// compiled call node returning call8723 (depth = 2)
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array8724 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8724 (depth = 3)
  *var_signature = array8724;
  if (array8724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8725 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8727 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8726);
// compiled call node returning call8727 (depth = 5)
// compiled member node returning call8727 (depth = 4)
  gc_frame_newslot(call8727);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8729 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8728);
// compiled call node returning call8729 (depth = 5)
// compiled member node returning call8729 (depth = 4)
  params[0] = call8727;
  partcv[0] = 1;
  Object call8730 = callmethod(call8729, "partName",
    1, partcv, params);
  gc_frame_end(callframe8725);
// compiled call node returning call8730 (depth = 3)
  *var_part = call8730;
  if (call8730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8731 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call8733 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe8732);
// compiled call node returning call8733 (depth = 4)
// compiled member node returning call8733 (depth = 3)
  gc_frame_newslot(call8733);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call8733;
  partcv[0] = 1;
  Object call8734 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe8731);
// compiled call node returning call8734 (depth = 2)
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8735 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call8737 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8736);
// compiled call node returning call8737 (depth = 4)
// compiled member node returning call8737 (depth = 3)
  gc_frame_newslot(call8737);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call8737;
  partcv[0] = 1;
  Object call8738 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe8735);
// compiled call node returning call8738 (depth = 2)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8739 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call8740 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe8739);
// compiled call node returning call8740 (depth = 2)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block8743 = alloc_Block(NULL, NULL, "parser", 2770);
  gc_frame_newslot(block8743);
// method "_apply"
  block_savedest(block8743);
  Object closure8744 = createclosure(2, "_apply");
  setclosureframe(closure8744, stackframe);
  addtoclosure(closure8744, var_sym);
  addtoclosure(closure8744, selfslot);
  struct UserObject *uo8744 = (struct UserObject*)block8743;
  uo8744->data[0] = (Object)closure8744;
  Method *meth_meth_parser__apply8744 = addmethod2pos(block8743, "_apply", &meth_parser__apply8744, 0);
  int argcv_meth_parser__apply8744[] = {0};
  meth_meth_parser__apply8744->type = alloc_MethodType(1, argcv_meth_parser__apply8744);
  meth_meth_parser__apply8744->definitionModule = modulename;
  meth_meth_parser__apply8744->definitionLine = 2768;
// compiled block node returning block8743 (depth = 4)
  int op_slot_right_8742 = gc_frame_newslot(block8743);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8754 == NULL) {
    strlit8754 = alloc_String("[");
    gc_root(strlit8754);
  }
// compiled string node returning strlit8754 (depth = 5)
  int op_slot_right_8753 = gc_frame_newslot(strlit8754);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8757 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8756);
// compiled call node returning call8757 (depth = 6)
// compiled member node returning call8757 (depth = 5)
  int op_slot_left_8753 = gc_frame_newslot(call8757);
  params[0] = strlit8754;
  partcv[0] = 1;
  Object opresult8758 = callmethod(call8757, "==", 1, partcv, params);
// compiled op node returning opresult8758 (depth = 4)
  int op_slot_left_8742 = gc_frame_newslot(opresult8758);
  params[0] = block8743;
  partcv[0] = 1;
  Object opresult8759 = callmethod(opresult8758, "&&", 1, partcv, params);
// compiled op node returning opresult8759 (depth = 3)
  Object if8741 = done;
  if (istrue(opresult8759)) {
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8760 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8761 == NULL) {
    strlit8761 = alloc_String("methods named '[]' and '[]:=' are no longer part of Grace.");
    gc_root(strlit8761);
  }
// compiled string node returning strlit8761 (depth = 4)
  gc_frame_newslot(strlit8761);
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8763 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8762);
// compiled call node returning call8763 (depth = 5)
// compiled member node returning call8763 (depth = 4)
  gc_frame_newslot(call8763);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8765 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8764);
// compiled call node returning call8765 (depth = 5)
// compiled member node returning call8765 (depth = 4)
  gc_frame_newslot(call8765);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8767 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8766);
// compiled call node returning call8767 (depth = 5)
// compiled member node returning call8767 (depth = 4)
  gc_frame_newslot(call8767);
// call case 6: other member request
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8761;
  params[1] = call8763;
  params[2] = call8765;
  params[3] = call8767;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call8768 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe8760);
// compiled call node returning call8768 (depth = 3)
    gc_frame_newslot(call8768);
    if8741 = call8768;
  } else {
  }
// compiled if node returning if8741 (depth = 2)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool8769 = alloc_Boolean(0);
// compiled identifier node returning bool8769 (depth = 3)
  *var_myTypeParams = bool8769;
  if (bool8769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8771 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8772 == NULL) {
    strlit8772 = alloc_String("lgeneric");
    gc_root(strlit8772);
  }
// compiled string node returning strlit8772 (depth = 4)
  gc_frame_newslot(strlit8772);
// call case 4: self request
  params[0] = strlit8772;
  partcv[0] = 1;
  Object call8773 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8771);
// compiled call node returning call8773 (depth = 3)
  Object if8770 = done;
  if (istrue(call8773)) {
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8775 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8774);
// compiled call node returning call8775 (depth = 5)
// compiled member node returning call8775 (depth = 4)
  *var_myTypeParams = call8775;
  if (call8775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8770 = done;
  } else {
  }
// compiled if node returning if8770 (depth = 2)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8778 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8779 == NULL) {
    strlit8779 = alloc_String("bind");
    gc_root(strlit8779);
  }
// compiled string node returning strlit8779 (depth = 4)
  gc_frame_newslot(strlit8779);
// call case 4: self request
  params[0] = strlit8779;
  partcv[0] = 1;
  Object call8780 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8778);
// compiled call node returning call8780 (depth = 3)
  Object if8777 = done;
  if (istrue(call8780)) {
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8781 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8782 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8781);
// compiled call node returning call8782 (depth = 4)
// compiled member node returning call8782 (depth = 3)
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8783 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8785 == NULL) {
    strlit8785 = alloc_String(":=");
    gc_root(strlit8785);
  }
// compiled string node returning strlit8785 (depth = 5)
  int op_slot_right_8784 = gc_frame_newslot(strlit8785);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8788 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8787);
// compiled call node returning call8788 (depth = 6)
// compiled member node returning call8788 (depth = 5)
  int op_slot_left_8784 = gc_frame_newslot(call8788);
  params[0] = strlit8785;
  partcv[0] = 1;
  Object opresult8789 = callmethod(call8788, "++", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 4)
  gc_frame_newslot(opresult8789);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = opresult8789;
  partcv[0] = 1;
  Object call8790 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8783);
// compiled call node returning call8790 (depth = 3)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8791 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8793 == NULL) {
    strlit8793 = alloc_String(":=");
    gc_root(strlit8793);
  }
// compiled string node returning strlit8793 (depth = 5)
  int op_slot_right_8792 = gc_frame_newslot(strlit8793);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call8796 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe8795);
// compiled call node returning call8796 (depth = 6)
// compiled member node returning call8796 (depth = 5)
  int op_slot_left_8792 = gc_frame_newslot(call8796);
  params[0] = strlit8793;
  partcv[0] = 1;
  Object opresult8797 = callmethod(call8796, "++", 1, partcv, params);
// compiled op node returning opresult8797 (depth = 4)
  gc_frame_newslot(opresult8797);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult8797;
  partcv[0] = 1;
  Object call8798 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8791);
// compiled call node returning call8798 (depth = 3)
    gc_frame_newslot(call8798);
    if8777 = call8798;
  } else {
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8802 == NULL) {
    strlit8802 = alloc_String("prefix");
    gc_root(strlit8802);
  }
// compiled string node returning strlit8802 (depth = 6)
  int op_slot_right_8801 = gc_frame_newslot(strlit8802);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8805 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8804);
// compiled call node returning call8805 (depth = 7)
// compiled member node returning call8805 (depth = 6)
  int op_slot_left_8801 = gc_frame_newslot(call8805);
  params[0] = strlit8802;
  partcv[0] = 1;
  Object opresult8806 = callmethod(call8805, "==", 1, partcv, params);
// compiled op node returning opresult8806 (depth = 5)
  int op_slot_right_8800 = gc_frame_newslot(opresult8806);
// starting to compile call node (depth = 5)
  int callframe8808 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8809 == NULL) {
    strlit8809 = alloc_String("op");
    gc_root(strlit8809);
  }
// compiled string node returning strlit8809 (depth = 6)
  gc_frame_newslot(strlit8809);
// call case 4: self request
  params[0] = strlit8809;
  partcv[0] = 1;
  Object call8810 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8808);
// compiled call node returning call8810 (depth = 5)
  int op_slot_left_8800 = gc_frame_newslot(call8810);
  params[0] = opresult8806;
  partcv[0] = 1;
  Object opresult8811 = callmethod(call8810, "&&", 1, partcv, params);
// compiled op node returning opresult8811 (depth = 4)
  Object if8799 = done;
  if (istrue(opresult8811)) {
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8812 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8815 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8814);
// compiled call node returning call8815 (depth = 7)
// compiled member node returning call8815 (depth = 6)
  int op_slot_right_8813 = gc_frame_newslot(call8815);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8817 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8818 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8817);
// compiled call node returning call8818 (depth = 7)
// compiled member node returning call8818 (depth = 6)
  int op_slot_left_8813 = gc_frame_newslot(call8818);
  params[0] = call8815;
  partcv[0] = 1;
  Object opresult8819 = callmethod(call8818, "++", 1, partcv, params);
// compiled op node returning opresult8819 (depth = 5)
  gc_frame_newslot(opresult8819);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult8819;
  partcv[0] = 1;
  Object call8820 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8812);
// compiled call node returning call8820 (depth = 4)
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8821 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8824 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8823);
// compiled call node returning call8824 (depth = 7)
// compiled member node returning call8824 (depth = 6)
  int op_slot_right_8822 = gc_frame_newslot(call8824);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call8827 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe8826);
// compiled call node returning call8827 (depth = 7)
// compiled member node returning call8827 (depth = 6)
  int op_slot_left_8822 = gc_frame_newslot(call8827);
  params[0] = call8824;
  partcv[0] = 1;
  Object opresult8828 = callmethod(call8827, "++", 1, partcv, params);
// compiled op node returning opresult8828 (depth = 5)
  gc_frame_newslot(opresult8828);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult8828;
  partcv[0] = 1;
  Object call8829 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8821);
// compiled call node returning call8829 (depth = 4)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8830 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8831 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8830);
// compiled call node returning call8831 (depth = 5)
// compiled member node returning call8831 (depth = 4)
    gc_frame_newslot(call8831);
    if8799 = call8831;
  } else {
  }
// compiled if node returning if8799 (depth = 3)
    gc_frame_newslot(if8799);
    if8777 = if8799;
  }
// compiled if node returning if8777 (depth = 2)
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool8832 = alloc_Boolean(0);
// compiled identifier node returning bool8832 (depth = 3)
  *var_dtype = bool8832;
  if (bool8832 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8834 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8835 == NULL) {
    strlit8835 = alloc_String("lparen");
    gc_root(strlit8835);
  }
// compiled string node returning strlit8835 (depth = 4)
  gc_frame_newslot(strlit8835);
// call case 4: self request
  params[0] = strlit8835;
  partcv[0] = 1;
  Object call8836 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8834);
// compiled call node returning call8836 (depth = 3)
  Object if8833 = done;
  if (istrue(call8836)) {
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8837 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8839 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8838);
// compiled call node returning call8839 (depth = 5)
// compiled member node returning call8839 (depth = 4)
  gc_frame_newslot(call8839);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call8839;
  partcv[0] = 1;
  Object call8840 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe8837);
// compiled call node returning call8840 (depth = 3)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8842 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8841);
// compiled call node returning call8842 (depth = 4)
// compiled member node returning call8842 (depth = 3)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8843 = alloc_Boolean(0);
// compiled identifier node returning bool8843 (depth = 4)
  *var_comma = bool8843;
  if (bool8843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8844 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8845 = alloc_Block(NULL, NULL, "parser", 2792);
  gc_frame_newslot(block8845);
// method "_apply"
  block_savedest(block8845);
  Object closure8846 = createclosure(2, "_apply");
  setclosureframe(closure8846, stackframe);
  addtoclosure(closure8846, var_sym);
  addtoclosure(closure8846, selfslot);
  struct UserObject *uo8846 = (struct UserObject*)block8845;
  uo8846->data[0] = (Object)closure8846;
  Method *meth_meth_parser__apply8846 = addmethod2pos(block8845, "_apply", &meth_parser__apply8846, 0);
  int argcv_meth_parser__apply8846[] = {0};
  meth_meth_parser__apply8846->type = alloc_MethodType(1, argcv_meth_parser__apply8846);
  meth_meth_parser__apply8846->definitionModule = modulename;
  meth_meth_parser__apply8846->definitionLine = 2789;
// compiled block node returning block8845 (depth = 4)
  gc_frame_newslot(block8845);
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8866 = alloc_Block(NULL, NULL, "parser", 2793);
  gc_frame_newslot(block8866);
// method "_apply"
  block_savedest(block8866);
  Object closure8867 = createclosure(9, "_apply");
  setclosureframe(closure8867, stackframe);
  addtoclosure(closure8867, var_sym);
  addtoclosure(closure8867, var_lastToken);
  addtoclosure(closure8867, var_errormessages);
  addtoclosure(closure8867, var_values);
  addtoclosure(closure8867, var_id);
  addtoclosure(closure8867, var_dtype);
  addtoclosure(closure8867, var_part);
  addtoclosure(closure8867, var_comma);
  addtoclosure(closure8867, selfslot);
  struct UserObject *uo8867 = (struct UserObject*)block8866;
  uo8867->data[0] = (Object)closure8867;
  Method *meth_meth_parser__apply8867 = addmethod2pos(block8866, "_apply", &meth_parser__apply8867, 0);
  int argcv_meth_parser__apply8867[] = {0};
  meth_meth_parser__apply8867->type = alloc_MethodType(1, argcv_meth_parser__apply8867);
  meth_meth_parser__apply8867->definitionModule = modulename;
  meth_meth_parser__apply8867->definitionLine = 2793;
// compiled block node returning block8866 (depth = 4)
  gc_frame_newslot(block8866);
// call case 5: prelude request
  params[0] = block8845;
  params[1] = block8866;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8948 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8844);
// compiled call node returning call8948 (depth = 3)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8951 == NULL) {
    strlit8951 = alloc_String("rparen");
    gc_root(strlit8951);
  }
// compiled string node returning strlit8951 (depth = 5)
  int op_slot_right_8950 = gc_frame_newslot(strlit8951);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8954 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8953);
// compiled call node returning call8954 (depth = 6)
// compiled member node returning call8954 (depth = 5)
  int op_slot_left_8950 = gc_frame_newslot(call8954);
  params[0] = strlit8951;
  partcv[0] = 1;
  Object opresult8955 = callmethod(call8954, "≠", 1, partcv, params);
// compiled op node returning opresult8955 (depth = 4)
  Object if8949 = done;
  if (istrue(opresult8955)) {
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8956 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8958 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8957);
// compiled call node returning call8958 (depth = 8)
// compiled member node returning call8958 (depth = 7)
  partcv[0] = 0;
  Object call8959 = callmethod(call8958, "new",
    1, partcv, params);
  gc_frame_end(callframe8956);
// compiled call node returning call8959 (depth = 6)
// compiled member node returning call8959 (depth = 5)
  *var_suggestion = call8959;
  if (call8959 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8960 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8961 = alloc_Block(NULL, NULL, "parser", 2821);
  gc_frame_newslot(block8961);
// method "_apply"
  block_savedest(block8961);
  Object closure8962 = createclosure(2, "_apply");
  setclosureframe(closure8962, stackframe);
  addtoclosure(closure8962, var_lastToken);
  addtoclosure(closure8962, selfslot);
  struct UserObject *uo8962 = (struct UserObject*)block8961;
  uo8962->data[0] = (Object)closure8962;
  Method *meth_meth_parser__apply8962 = addmethod2pos(block8961, "_apply", &meth_parser__apply8962, 0);
  int argcv_meth_parser__apply8962[] = {1};
  meth_meth_parser__apply8962->type = alloc_MethodType(1, argcv_meth_parser__apply8962);
  meth_meth_parser__apply8962->definitionModule = modulename;
  meth_meth_parser__apply8962->definitionLine = 2820;
// compiled block node returning block8961 (depth = 6)
  gc_frame_newslot(block8961);
// call case 4: self request
  params[0] = block8961;
  partcv[0] = 1;
  Object call8980 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8960);
// compiled call node returning call8980 (depth = 5)
  *var_rparen = call8980;
  if (call8980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_right_8982 = gc_frame_newslot(*var_rparen);
// starting to compile identifier node (depth = 6)
  Object bool8984 = alloc_Boolean(0);
// compiled identifier node returning bool8984 (depth = 6)
  int op_slot_left_8982 = gc_frame_newslot(bool8984);
  params[0] = *var_rparen;
  partcv[0] = 1;
  Object opresult8985 = callmethod(bool8984, "==", 1, partcv, params);
// compiled op node returning opresult8985 (depth = 5)
  Object if8981 = done;
  if (istrue(opresult8985)) {
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8986 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8987 == NULL) {
    strlit8987 = alloc_String(")");
    gc_root(strlit8987);
  }
// compiled string node returning strlit8987 (depth = 6)
  gc_frame_newslot(strlit8987);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8987;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8988 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8986);
// compiled call node returning call8988 (depth = 5)
    gc_frame_newslot(call8988);
    if8981 = call8988;
  } else {
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8989 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8990 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 5)
    gc_frame_newslot(call8990);
    if8981 = call8990;
  }
// compiled if node returning if8981 (depth = 4)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8991 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8992 == NULL) {
    strlit8992 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit8992);
  }
// compiled string node returning strlit8992 (depth = 5)
  gc_frame_newslot(strlit8992);
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8994 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 6)
// compiled member node returning call8994 (depth = 5)
  gc_frame_newslot(call8994);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8996 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8995);
// compiled call node returning call8996 (depth = 6)
// compiled member node returning call8996 (depth = 5)
  gc_frame_newslot(call8996);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8998 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8997);
// compiled call node returning call8998 (depth = 6)
// compiled member node returning call8998 (depth = 5)
  gc_frame_newslot(call8998);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8992;
  params[1] = call8994;
  params[2] = call8996;
  params[3] = call8998;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8999 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8991);
// compiled call node returning call8999 (depth = 4)
    gc_frame_newslot(call8999);
    if8949 = call8999;
  } else {
  }
// compiled if node returning if8949 (depth = 3)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9003 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9002);
// compiled call node returning call9003 (depth = 6)
// compiled member node returning call9003 (depth = 5)
  int op_slot_right_9001 = gc_frame_newslot(call9003);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9006 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9005);
// compiled call node returning call9006 (depth = 6)
// compiled member node returning call9006 (depth = 5)
  int op_slot_left_9001 = gc_frame_newslot(call9006);
  params[0] = call9003;
  partcv[0] = 1;
  Object opresult9007 = callmethod(call9006, "==", 1, partcv, params);
// compiled op node returning opresult9007 (depth = 4)
  Object if9000 = done;
  if (istrue(opresult9007)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9008 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9011 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9010);
// compiled call node returning call9011 (depth = 7)
// compiled member node returning call9011 (depth = 6)
  int op_slot_right_9009 = gc_frame_newslot(call9011);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9014 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9013);
// compiled call node returning call9014 (depth = 7)
// compiled member node returning call9014 (depth = 6)
  int op_slot_left_9009 = gc_frame_newslot(call9014);
  params[0] = call9011;
  partcv[0] = 1;
  Object diff9015 = callmethod(call9014, "-", 1, partcv, params);
// compiled op node returning diff9015 (depth = 5)
  gc_frame_newslot(diff9015);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff9015;
  partcv[0] = 1;
  Object call9016 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9008);
// compiled call node returning call9016 (depth = 4)
    gc_frame_newslot(call9016);
    if9000 = call9016;
  } else {
  }
// compiled if node returning if9000 (depth = 3)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9018 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9017);
// compiled call node returning call9018 (depth = 4)
// compiled member node returning call9018 (depth = 3)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9021 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9022 == NULL) {
    strlit9022 = alloc_String("identifier");
    gc_root(strlit9022);
  }
// compiled string node returning strlit9022 (depth = 6)
  gc_frame_newslot(strlit9022);
// call case 4: self request
  params[0] = strlit9022;
  partcv[0] = 1;
  Object call9023 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9021);
// compiled call node returning call9023 (depth = 5)
  int op_slot_right_9020 = gc_frame_newslot(call9023);
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9026 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9027 == NULL) {
    strlit9027 = alloc_String("identifier");
    gc_root(strlit9027);
  }
// compiled string node returning strlit9027 (depth = 7)
  gc_frame_newslot(strlit9027);
// call case 4: self request
  params[0] = strlit9027;
  partcv[0] = 1;
  Object call9028 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9026);
// compiled call node returning call9028 (depth = 6)
  int op_slot_right_9025 = gc_frame_newslot(call9028);
// starting to compile call node (depth = 6)
  int callframe9030 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9031 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9030);
// compiled call node returning call9031 (depth = 6)
  int op_slot_left_9025 = gc_frame_newslot(call9031);
  params[0] = call9028;
  partcv[0] = 1;
  Object opresult9032 = callmethod(call9031, "&&", 1, partcv, params);
// compiled op node returning opresult9032 (depth = 5)
  int op_slot_left_9020 = gc_frame_newslot(opresult9032);
  params[0] = call9023;
  partcv[0] = 1;
  Object opresult9033 = callmethod(opresult9032, "||", 1, partcv, params);
// compiled op node returning opresult9033 (depth = 4)
  Object if9019 = done;
  if (istrue(opresult9033)) {
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9034 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array9035 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9035 (depth = 6)
  gc_frame_newslot(array9035);
// starting to compile identifier node (depth = 6)
  Object bool9036 = alloc_Boolean(0);
// compiled identifier node returning bool9036 (depth = 6)
  gc_frame_newslot(bool9036);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9038 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9037);
// compiled call node returning call9038 (depth = 7)
// compiled member node returning call9038 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9035;
  params[3] = bool9036;
  partcv[0] = 4;
  Object call9039 = callmethod(call9038, "new",
    1, partcv, params);
  gc_frame_end(callframe9034);
// compiled call node returning call9039 (depth = 5)
  *var_tm = call9039;
  if (call9039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9040 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9041 = callmethodflags(self, "methodDecRest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9040);
// compiled call node returning call9041 (depth = 5)
  *var_meth = call9041;
  if (call9041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9019 = done;
  } else {
  }
// compiled if node returning if9019 (depth = 3)
    gc_frame_newslot(if9019);
    if8833 = if9019;
  } else {
  }
// compiled if node returning if8833 (depth = 2)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9044 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String("arrow");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 4)
  gc_frame_newslot(strlit9045);
// call case 4: self request
  params[0] = strlit9045;
  partcv[0] = 1;
  Object call9046 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9044);
// compiled call node returning call9046 (depth = 3)
  Object if9043 = done;
  if (istrue(call9046)) {
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9048 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 4)
// compiled member node returning call9048 (depth = 3)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9050 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9049);
// compiled call node returning call9050 (depth = 4)
// compiled member node returning call9050 (depth = 3)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9052 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9051);
// compiled call node returning call9052 (depth = 5)
// compiled member node returning call9052 (depth = 4)
  *var_dtype = call9052;
  if (call9052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9043 = done;
  } else {
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9054 = alloc_Boolean(0);
// compiled identifier node returning bool9054 (depth = 4)
  *var_dtype = bool9054;
  if (bool9054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9043 = done;
  }
// compiled if node returning if9043 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9056 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9056 = alloc_userobj2(4,5, objclass9056);
  gc_frame_newslot(obj9056);
if (objclass9056 == NULL) {
  glfree(obj9056->class->name);
  obj9056->class->name = "parser.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9056, self, 0);
  addmethodreal(obj9056,"outer", &reader_parser_outer_9057);
  Object oldself9056 = self;
  struct StackFrameObject *oldstackframe9056 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9056);
  gc_frame_newslot((Object)stackframe);
  self = obj9056;
  Object *oldselfslot9056 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9056 = (*(struct UserObject *)self).data[0], lowerouter9056 = thisouter9056;
  if (inheritingObject9056) {
    struct UserObject *inho9056 = (struct UserObject *)inheritingObject9056;
    while (inho9056->super != GraceDefaultObject) inho9056 = (struct UserObject *)inho9056->super;
    inho9056->super = obj9056;
    self = inheritingObject9056;
    *selfslot = self;
    lowerouter9056 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9056;
  }
if (objclass9056 == NULL) {
  Method *reader9058 = addmethodrealflags(obj9056, "m",&reader_parser_m_9058, MFLAG_DEF);
  reader9058->definitionModule = modulename;
  reader9058->definitionLine = 2851;
}
adddatum2(obj9056, alloc_Undefined(), 1);
if (objclass9056 == NULL) {
  Method *reader9059 = addmethodrealflags(obj9056, "sig",&reader_parser_sig_9059, MFLAG_DEF);
  reader9059->definitionModule = modulename;
  reader9059->definitionLine = 2852;
}
adddatum2(obj9056, alloc_Undefined(), 2);
if (objclass9056 == NULL) {
  Method *reader9060 = addmethodrealflags(obj9056, "rtype",&reader_parser_rtype_9060, MFLAG_DEF);
  reader9060->definitionModule = modulename;
  reader9060->definitionLine = 2853;
}
adddatum2(obj9056, alloc_Undefined(), 3);
if (objclass9056 == NULL) {
  Method *reader9061 = addmethodrealflags(obj9056, "typeParams",&reader_parser_typeParams_9061, MFLAG_DEF);
  reader9061->definitionModule = modulename;
  reader9061->definitionLine = 2854;
}
adddatum2(obj9056, alloc_Undefined(), 4);
  sourceObject = obj9056;
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth (depth = 2)
  adddatum2(obj9056, *var_meth, 1);
  sourceObject = obj9056;
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_signature (depth = 2)
  adddatum2(obj9056, *var_signature, 2);
  sourceObject = obj9056;
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_dtype (depth = 2)
  adddatum2(obj9056, *var_dtype, 3);
  sourceObject = obj9056;
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_myTypeParams (depth = 2)
  adddatum2(obj9056, *var_myTypeParams, 4);
  objclass9056 = obj9056->class;
  objclass9056->definitionModule = modulename;
  objclass9056->definitionLine = 2850;
  (*(struct UserObject *)self).data[0] = lowerouter9056;
  self = oldself9056;
  selfslot = oldselfslot9056;
  stackframe = oldstackframe9056;
  gc_frame_end(frame);
  return obj9056;
}
Object meth_parser_methodsignature8668_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method methodsignature()object");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_myTypeParams = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "myTypeParams");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_lparen = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "lparen");
  Object *var_id = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "id");
  Object *var_comma = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "comma");
  Object *var_rparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "rparen");
  Object *var_tm = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "tm");
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8672 == NULL) {
    strlit8672 = alloc_String("lsquare");
    gc_root(strlit8672);
  }
// compiled string node returning strlit8672 (depth = 5)
  int op_slot_right_8671 = gc_frame_newslot(strlit8672);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8674 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8675 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8674);
// compiled call node returning call8675 (depth = 6)
// compiled member node returning call8675 (depth = 5)
  int op_slot_left_8671 = gc_frame_newslot(call8675);
  params[0] = strlit8672;
  partcv[0] = 1;
  Object opresult8676 = callmethod(call8675, "≠", 1, partcv, params);
// compiled op node returning opresult8676 (depth = 4)
  int op_slot_right_8670 = gc_frame_newslot(opresult8676);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8680 == NULL) {
    strlit8680 = alloc_String("op");
    gc_root(strlit8680);
  }
// compiled string node returning strlit8680 (depth = 6)
  int op_slot_right_8679 = gc_frame_newslot(strlit8680);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8683 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8682);
// compiled call node returning call8683 (depth = 7)
// compiled member node returning call8683 (depth = 6)
  int op_slot_left_8679 = gc_frame_newslot(call8683);
  params[0] = strlit8680;
  partcv[0] = 1;
  Object opresult8684 = callmethod(call8683, "≠", 1, partcv, params);
// compiled op node returning opresult8684 (depth = 5)
  int op_slot_right_8678 = gc_frame_newslot(opresult8684);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8687 == NULL) {
    strlit8687 = alloc_String("identifier");
    gc_root(strlit8687);
  }
// compiled string node returning strlit8687 (depth = 6)
  int op_slot_right_8686 = gc_frame_newslot(strlit8687);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8690 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8689);
// compiled call node returning call8690 (depth = 7)
// compiled member node returning call8690 (depth = 6)
  int op_slot_left_8686 = gc_frame_newslot(call8690);
  params[0] = strlit8687;
  partcv[0] = 1;
  Object opresult8691 = callmethod(call8690, "≠", 1, partcv, params);
// compiled op node returning opresult8691 (depth = 5)
  int op_slot_left_8678 = gc_frame_newslot(opresult8691);
  params[0] = opresult8684;
  partcv[0] = 1;
  Object opresult8692 = callmethod(opresult8691, "&&", 1, partcv, params);
// compiled op node returning opresult8692 (depth = 4)
  int op_slot_left_8670 = gc_frame_newslot(opresult8692);
  params[0] = opresult8676;
  partcv[0] = 1;
  Object opresult8693 = callmethod(opresult8692, "&&", 1, partcv, params);
// compiled op node returning opresult8693 (depth = 3)
  Object if8669 = done;
  if (istrue(opresult8693)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call8696 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 7)
// compiled member node returning call8696 (depth = 6)
  partcv[0] = 0;
  Object call8697 = callmethod(call8696, "new",
    1, partcv, params);
  gc_frame_end(callframe8694);
// compiled call node returning call8697 (depth = 5)
// compiled member node returning call8697 (depth = 4)
  *var_suggestion = call8697;
  if (call8697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8698 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8699 == NULL) {
    strlit8699 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8699);
  }
// compiled string node returning strlit8699 (depth = 4)
  gc_frame_newslot(strlit8699);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit8699;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8700 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8698);
// compiled call node returning call8700 (depth = 3)
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8701 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8702 == NULL) {
    strlit8702 = alloc_String("a method name must start with an identifier, or be an operator.");
    gc_root(strlit8702);
  }
// compiled string node returning strlit8702 (depth = 4)
  gc_frame_newslot(strlit8702);
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8703 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8704 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8703);
// compiled call node returning call8704 (depth = 5)
// compiled member node returning call8704 (depth = 4)
  gc_frame_newslot(call8704);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num8706 = alloc_Float64(1);
// compiled num node returning num8706 (depth = 5)
  int op_slot_right_8705 = gc_frame_newslot(num8706);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8710 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8709);
// compiled call node returning call8710 (depth = 7)
// compiled member node returning call8710 (depth = 6)
  int op_slot_right_8708 = gc_frame_newslot(call8710);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8713 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8712);
// compiled call node returning call8713 (depth = 7)
// compiled member node returning call8713 (depth = 6)
  int op_slot_left_8708 = gc_frame_newslot(call8713);
  params[0] = call8710;
  partcv[0] = 1;
  Object sum8714 = callmethod(call8713, "+", 1, partcv, params);
// compiled op node returning sum8714 (depth = 5)
  int op_slot_left_8705 = gc_frame_newslot(sum8714);
  params[0] = num8706;
  partcv[0] = 1;
  Object sum8715 = callmethod(sum8714, "+", 1, partcv, params);
// compiled op node returning sum8715 (depth = 4)
  gc_frame_newslot(sum8715);
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8702;
  params[1] = call8704;
  params[2] = sum8715;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8716 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8701);
// compiled call node returning call8716 (depth = 3)
    gc_frame_newslot(call8716);
    if8669 = call8716;
  } else {
  }
// compiled if node returning if8669 (depth = 2)
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8718 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8717);
// compiled call node returning call8718 (depth = 3)
// compiled member node returning call8718 (depth = 2)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call8720 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8719);
// compiled call node returning call8720 (depth = 4)
// compiled member node returning call8720 (depth = 3)
  *var_meth = call8720;
  if (call8720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8721 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool8722 = alloc_Boolean(1);
// compiled identifier node returning bool8722 (depth = 3)
  gc_frame_newslot(bool8722);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_meth (depth = 3)
  params[0] = bool8722;
  partcv[0] = 1;
  Object call8723 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8721);
// compiled call node returning call8723 (depth = 2)
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array8724 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8724 (depth = 3)
  *var_signature = array8724;
  if (array8724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8725 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call8727 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8726);
// compiled call node returning call8727 (depth = 5)
// compiled member node returning call8727 (depth = 4)
  gc_frame_newslot(call8727);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call8729 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8728);
// compiled call node returning call8729 (depth = 5)
// compiled member node returning call8729 (depth = 4)
  params[0] = call8727;
  partcv[0] = 1;
  Object call8730 = callmethod(call8729, "partName",
    1, partcv, params);
  gc_frame_end(callframe8725);
// compiled call node returning call8730 (depth = 3)
  *var_part = call8730;
  if (call8730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2767
  setline(2767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8731 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call8733 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe8732);
// compiled call node returning call8733 (depth = 4)
// compiled member node returning call8733 (depth = 3)
  gc_frame_newslot(call8733);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call8733;
  partcv[0] = 1;
  Object call8734 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe8731);
// compiled call node returning call8734 (depth = 2)
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8735 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call8737 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8736);
// compiled call node returning call8737 (depth = 4)
// compiled member node returning call8737 (depth = 3)
  gc_frame_newslot(call8737);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  params[0] = call8737;
  partcv[0] = 1;
  Object call8738 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe8735);
// compiled call node returning call8738 (depth = 2)
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe8739 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call8740 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe8739);
// compiled call node returning call8740 (depth = 2)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile block node (depth = 4)
  Object block8743 = alloc_Block(NULL, NULL, "parser", 2770);
  gc_frame_newslot(block8743);
// method "_apply"
  block_savedest(block8743);
  Object closure8744 = createclosure(2, "_apply");
  setclosureframe(closure8744, stackframe);
  addtoclosure(closure8744, var_sym);
  addtoclosure(closure8744, selfslot);
  struct UserObject *uo8744 = (struct UserObject*)block8743;
  uo8744->data[0] = (Object)closure8744;
  Method *meth_meth_parser__apply8744 = addmethod2pos(block8743, "_apply", &meth_parser__apply8744, 0);
  int argcv_meth_parser__apply8744[] = {0};
  meth_meth_parser__apply8744->type = alloc_MethodType(1, argcv_meth_parser__apply8744);
  meth_meth_parser__apply8744->definitionModule = modulename;
  meth_meth_parser__apply8744->definitionLine = 2768;
// compiled block node returning block8743 (depth = 4)
  int op_slot_right_8742 = gc_frame_newslot(block8743);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8754 == NULL) {
    strlit8754 = alloc_String("[");
    gc_root(strlit8754);
  }
// compiled string node returning strlit8754 (depth = 5)
  int op_slot_right_8753 = gc_frame_newslot(strlit8754);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8757 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8756);
// compiled call node returning call8757 (depth = 6)
// compiled member node returning call8757 (depth = 5)
  int op_slot_left_8753 = gc_frame_newslot(call8757);
  params[0] = strlit8754;
  partcv[0] = 1;
  Object opresult8758 = callmethod(call8757, "==", 1, partcv, params);
// compiled op node returning opresult8758 (depth = 4)
  int op_slot_left_8742 = gc_frame_newslot(opresult8758);
  params[0] = block8743;
  partcv[0] = 1;
  Object opresult8759 = callmethod(opresult8758, "&&", 1, partcv, params);
// compiled op node returning opresult8759 (depth = 3)
  Object if8741 = done;
  if (istrue(opresult8759)) {
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8760 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8761 == NULL) {
    strlit8761 = alloc_String("methods named '[]' and '[]:=' are no longer part of Grace.");
    gc_root(strlit8761);
  }
// compiled string node returning strlit8761 (depth = 4)
  gc_frame_newslot(strlit8761);
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8763 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8762);
// compiled call node returning call8763 (depth = 5)
// compiled member node returning call8763 (depth = 4)
  gc_frame_newslot(call8763);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call8765 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8764);
// compiled call node returning call8765 (depth = 5)
// compiled member node returning call8765 (depth = 4)
  gc_frame_newslot(call8765);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8767 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8766);
// compiled call node returning call8767 (depth = 5)
// compiled member node returning call8767 (depth = 4)
  gc_frame_newslot(call8767);
// call case 6: other member request
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit8761;
  params[1] = call8763;
  params[2] = call8765;
  params[3] = call8767;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call8768 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe8760);
// compiled call node returning call8768 (depth = 3)
    gc_frame_newslot(call8768);
    if8741 = call8768;
  } else {
  }
// compiled if node returning if8741 (depth = 2)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool8769 = alloc_Boolean(0);
// compiled identifier node returning bool8769 (depth = 3)
  *var_myTypeParams = bool8769;
  if (bool8769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8771 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8772 == NULL) {
    strlit8772 = alloc_String("lgeneric");
    gc_root(strlit8772);
  }
// compiled string node returning strlit8772 (depth = 4)
  gc_frame_newslot(strlit8772);
// call case 4: self request
  params[0] = strlit8772;
  partcv[0] = 1;
  Object call8773 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8771);
// compiled call node returning call8773 (depth = 3)
  Object if8770 = done;
  if (istrue(call8773)) {
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8775 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8774);
// compiled call node returning call8775 (depth = 5)
// compiled member node returning call8775 (depth = 4)
  *var_myTypeParams = call8775;
  if (call8775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8770 = done;
  } else {
  }
// compiled if node returning if8770 (depth = 2)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8778 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8779 == NULL) {
    strlit8779 = alloc_String("bind");
    gc_root(strlit8779);
  }
// compiled string node returning strlit8779 (depth = 4)
  gc_frame_newslot(strlit8779);
// call case 4: self request
  params[0] = strlit8779;
  partcv[0] = 1;
  Object call8780 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8778);
// compiled call node returning call8780 (depth = 3)
  Object if8777 = done;
  if (istrue(call8780)) {
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8781 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8782 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8781);
// compiled call node returning call8782 (depth = 4)
// compiled member node returning call8782 (depth = 3)
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8783 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8785 == NULL) {
    strlit8785 = alloc_String(":=");
    gc_root(strlit8785);
  }
// compiled string node returning strlit8785 (depth = 5)
  int op_slot_right_8784 = gc_frame_newslot(strlit8785);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8788 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8787);
// compiled call node returning call8788 (depth = 6)
// compiled member node returning call8788 (depth = 5)
  int op_slot_left_8784 = gc_frame_newslot(call8788);
  params[0] = strlit8785;
  partcv[0] = 1;
  Object opresult8789 = callmethod(call8788, "++", 1, partcv, params);
// compiled op node returning opresult8789 (depth = 4)
  gc_frame_newslot(opresult8789);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = opresult8789;
  partcv[0] = 1;
  Object call8790 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8783);
// compiled call node returning call8790 (depth = 3)
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8791 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8793 == NULL) {
    strlit8793 = alloc_String(":=");
    gc_root(strlit8793);
  }
// compiled string node returning strlit8793 (depth = 5)
  int op_slot_right_8792 = gc_frame_newslot(strlit8793);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call8796 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe8795);
// compiled call node returning call8796 (depth = 6)
// compiled member node returning call8796 (depth = 5)
  int op_slot_left_8792 = gc_frame_newslot(call8796);
  params[0] = strlit8793;
  partcv[0] = 1;
  Object opresult8797 = callmethod(call8796, "++", 1, partcv, params);
// compiled op node returning opresult8797 (depth = 4)
  gc_frame_newslot(opresult8797);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = opresult8797;
  partcv[0] = 1;
  Object call8798 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8791);
// compiled call node returning call8798 (depth = 3)
    gc_frame_newslot(call8798);
    if8777 = call8798;
  } else {
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8802 == NULL) {
    strlit8802 = alloc_String("prefix");
    gc_root(strlit8802);
  }
// compiled string node returning strlit8802 (depth = 6)
  int op_slot_right_8801 = gc_frame_newslot(strlit8802);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8804 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8805 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8804);
// compiled call node returning call8805 (depth = 7)
// compiled member node returning call8805 (depth = 6)
  int op_slot_left_8801 = gc_frame_newslot(call8805);
  params[0] = strlit8802;
  partcv[0] = 1;
  Object opresult8806 = callmethod(call8805, "==", 1, partcv, params);
// compiled op node returning opresult8806 (depth = 5)
  int op_slot_right_8800 = gc_frame_newslot(opresult8806);
// starting to compile call node (depth = 5)
  int callframe8808 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8809 == NULL) {
    strlit8809 = alloc_String("op");
    gc_root(strlit8809);
  }
// compiled string node returning strlit8809 (depth = 6)
  gc_frame_newslot(strlit8809);
// call case 4: self request
  params[0] = strlit8809;
  partcv[0] = 1;
  Object call8810 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8808);
// compiled call node returning call8810 (depth = 5)
  int op_slot_left_8800 = gc_frame_newslot(call8810);
  params[0] = opresult8806;
  partcv[0] = 1;
  Object opresult8811 = callmethod(call8810, "&&", 1, partcv, params);
// compiled op node returning opresult8811 (depth = 4)
  Object if8799 = done;
  if (istrue(opresult8811)) {
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8812 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8815 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8814);
// compiled call node returning call8815 (depth = 7)
// compiled member node returning call8815 (depth = 6)
  int op_slot_right_8813 = gc_frame_newslot(call8815);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8817 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8818 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe8817);
// compiled call node returning call8818 (depth = 7)
// compiled member node returning call8818 (depth = 6)
  int op_slot_left_8813 = gc_frame_newslot(call8818);
  params[0] = call8815;
  partcv[0] = 1;
  Object opresult8819 = callmethod(call8818, "++", 1, partcv, params);
// compiled op node returning opresult8819 (depth = 5)
  gc_frame_newslot(opresult8819);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult8819;
  partcv[0] = 1;
  Object call8820 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8812);
// compiled call node returning call8820 (depth = 4)
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8821 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8824 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8823);
// compiled call node returning call8824 (depth = 7)
// compiled member node returning call8824 (depth = 6)
  int op_slot_right_8822 = gc_frame_newslot(call8824);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call8827 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe8826);
// compiled call node returning call8827 (depth = 7)
// compiled member node returning call8827 (depth = 6)
  int op_slot_left_8822 = gc_frame_newslot(call8827);
  params[0] = call8824;
  partcv[0] = 1;
  Object opresult8828 = callmethod(call8827, "++", 1, partcv, params);
// compiled op node returning opresult8828 (depth = 5)
  gc_frame_newslot(opresult8828);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult8828;
  partcv[0] = 1;
  Object call8829 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8821);
// compiled call node returning call8829 (depth = 4)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8830 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8831 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8830);
// compiled call node returning call8831 (depth = 5)
// compiled member node returning call8831 (depth = 4)
    gc_frame_newslot(call8831);
    if8799 = call8831;
  } else {
  }
// compiled if node returning if8799 (depth = 3)
    gc_frame_newslot(if8799);
    if8777 = if8799;
  }
// compiled if node returning if8777 (depth = 2)
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool8832 = alloc_Boolean(0);
// compiled identifier node returning bool8832 (depth = 3)
  *var_dtype = bool8832;
  if (bool8832 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe8834 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit8835 == NULL) {
    strlit8835 = alloc_String("lparen");
    gc_root(strlit8835);
  }
// compiled string node returning strlit8835 (depth = 4)
  gc_frame_newslot(strlit8835);
// call case 4: self request
  params[0] = strlit8835;
  partcv[0] = 1;
  Object call8836 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8834);
// compiled call node returning call8836 (depth = 3)
  Object if8833 = done;
  if (istrue(call8836)) {
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8837 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call8839 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8838);
// compiled call node returning call8839 (depth = 5)
// compiled member node returning call8839 (depth = 4)
  gc_frame_newslot(call8839);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  params[0] = call8839;
  partcv[0] = 1;
  Object call8840 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe8837);
// compiled call node returning call8840 (depth = 3)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8841 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8842 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8841);
// compiled call node returning call8842 (depth = 4)
// compiled member node returning call8842 (depth = 3)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool8843 = alloc_Boolean(0);
// compiled identifier node returning bool8843 (depth = 4)
  *var_comma = bool8843;
  if (bool8843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8844 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8845 = alloc_Block(NULL, NULL, "parser", 2792);
  gc_frame_newslot(block8845);
// method "_apply"
  block_savedest(block8845);
  Object closure8846 = createclosure(2, "_apply");
  setclosureframe(closure8846, stackframe);
  addtoclosure(closure8846, var_sym);
  addtoclosure(closure8846, selfslot);
  struct UserObject *uo8846 = (struct UserObject*)block8845;
  uo8846->data[0] = (Object)closure8846;
  Method *meth_meth_parser__apply8846 = addmethod2pos(block8845, "_apply", &meth_parser__apply8846, 0);
  int argcv_meth_parser__apply8846[] = {0};
  meth_meth_parser__apply8846->type = alloc_MethodType(1, argcv_meth_parser__apply8846);
  meth_meth_parser__apply8846->definitionModule = modulename;
  meth_meth_parser__apply8846->definitionLine = 2789;
// compiled block node returning block8845 (depth = 4)
  gc_frame_newslot(block8845);
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block8866 = alloc_Block(NULL, NULL, "parser", 2793);
  gc_frame_newslot(block8866);
// method "_apply"
  block_savedest(block8866);
  Object closure8867 = createclosure(9, "_apply");
  setclosureframe(closure8867, stackframe);
  addtoclosure(closure8867, var_sym);
  addtoclosure(closure8867, var_lastToken);
  addtoclosure(closure8867, var_errormessages);
  addtoclosure(closure8867, var_values);
  addtoclosure(closure8867, var_id);
  addtoclosure(closure8867, var_dtype);
  addtoclosure(closure8867, var_part);
  addtoclosure(closure8867, var_comma);
  addtoclosure(closure8867, selfslot);
  struct UserObject *uo8867 = (struct UserObject*)block8866;
  uo8867->data[0] = (Object)closure8867;
  Method *meth_meth_parser__apply8867 = addmethod2pos(block8866, "_apply", &meth_parser__apply8867, 0);
  int argcv_meth_parser__apply8867[] = {0};
  meth_meth_parser__apply8867->type = alloc_MethodType(1, argcv_meth_parser__apply8867);
  meth_meth_parser__apply8867->definitionModule = modulename;
  meth_meth_parser__apply8867->definitionLine = 2793;
// compiled block node returning block8866 (depth = 4)
  gc_frame_newslot(block8866);
// call case 5: prelude request
  params[0] = block8845;
  params[1] = block8866;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8948 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8844);
// compiled call node returning call8948 (depth = 3)
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8951 == NULL) {
    strlit8951 = alloc_String("rparen");
    gc_root(strlit8951);
  }
// compiled string node returning strlit8951 (depth = 5)
  int op_slot_right_8950 = gc_frame_newslot(strlit8951);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8954 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8953);
// compiled call node returning call8954 (depth = 6)
// compiled member node returning call8954 (depth = 5)
  int op_slot_left_8950 = gc_frame_newslot(call8954);
  params[0] = strlit8951;
  partcv[0] = 1;
  Object opresult8955 = callmethod(call8954, "≠", 1, partcv, params);
// compiled op node returning opresult8955 (depth = 4)
  Object if8949 = done;
  if (istrue(opresult8955)) {
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8956 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8958 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8957);
// compiled call node returning call8958 (depth = 8)
// compiled member node returning call8958 (depth = 7)
  partcv[0] = 0;
  Object call8959 = callmethod(call8958, "new",
    1, partcv, params);
  gc_frame_end(callframe8956);
// compiled call node returning call8959 (depth = 6)
// compiled member node returning call8959 (depth = 5)
  *var_suggestion = call8959;
  if (call8959 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8960 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8961 = alloc_Block(NULL, NULL, "parser", 2821);
  gc_frame_newslot(block8961);
// method "_apply"
  block_savedest(block8961);
  Object closure8962 = createclosure(2, "_apply");
  setclosureframe(closure8962, stackframe);
  addtoclosure(closure8962, var_lastToken);
  addtoclosure(closure8962, selfslot);
  struct UserObject *uo8962 = (struct UserObject*)block8961;
  uo8962->data[0] = (Object)closure8962;
  Method *meth_meth_parser__apply8962 = addmethod2pos(block8961, "_apply", &meth_parser__apply8962, 0);
  int argcv_meth_parser__apply8962[] = {1};
  meth_meth_parser__apply8962->type = alloc_MethodType(1, argcv_meth_parser__apply8962);
  meth_meth_parser__apply8962->definitionModule = modulename;
  meth_meth_parser__apply8962->definitionLine = 2820;
// compiled block node returning block8961 (depth = 6)
  gc_frame_newslot(block8961);
// call case 4: self request
  params[0] = block8961;
  partcv[0] = 1;
  Object call8980 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8960);
// compiled call node returning call8980 (depth = 5)
  *var_rparen = call8980;
  if (call8980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_right_8982 = gc_frame_newslot(*var_rparen);
// starting to compile identifier node (depth = 6)
  Object bool8984 = alloc_Boolean(0);
// compiled identifier node returning bool8984 (depth = 6)
  int op_slot_left_8982 = gc_frame_newslot(bool8984);
  params[0] = *var_rparen;
  partcv[0] = 1;
  Object opresult8985 = callmethod(bool8984, "==", 1, partcv, params);
// compiled op node returning opresult8985 (depth = 5)
  Object if8981 = done;
  if (istrue(opresult8985)) {
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8986 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8987 == NULL) {
    strlit8987 = alloc_String(")");
    gc_root(strlit8987);
  }
// compiled string node returning strlit8987 (depth = 6)
  gc_frame_newslot(strlit8987);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8987;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8988 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8986);
// compiled call node returning call8988 (depth = 5)
    gc_frame_newslot(call8988);
    if8981 = call8988;
  } else {
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8989 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8990 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 5)
    gc_frame_newslot(call8990);
    if8981 = call8990;
  }
// compiled if node returning if8981 (depth = 4)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8991 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8992 == NULL) {
    strlit8992 = alloc_String("a part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit8992);
  }
// compiled string node returning strlit8992 (depth = 5)
  gc_frame_newslot(strlit8992);
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8994 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 6)
// compiled member node returning call8994 (depth = 5)
  gc_frame_newslot(call8994);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8995 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8996 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8995);
// compiled call node returning call8996 (depth = 6)
// compiled member node returning call8996 (depth = 5)
  gc_frame_newslot(call8996);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8998 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8997);
// compiled call node returning call8998 (depth = 6)
// compiled member node returning call8998 (depth = 5)
  gc_frame_newslot(call8998);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8992;
  params[1] = call8994;
  params[2] = call8996;
  params[3] = call8998;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8999 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8991);
// compiled call node returning call8999 (depth = 4)
    gc_frame_newslot(call8999);
    if8949 = call8999;
  } else {
  }
// compiled if node returning if8949 (depth = 3)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9002 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9003 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9002);
// compiled call node returning call9003 (depth = 6)
// compiled member node returning call9003 (depth = 5)
  int op_slot_right_9001 = gc_frame_newslot(call9003);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9006 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9005);
// compiled call node returning call9006 (depth = 6)
// compiled member node returning call9006 (depth = 5)
  int op_slot_left_9001 = gc_frame_newslot(call9006);
  params[0] = call9003;
  partcv[0] = 1;
  Object opresult9007 = callmethod(call9006, "==", 1, partcv, params);
// compiled op node returning opresult9007 (depth = 4)
  Object if9000 = done;
  if (istrue(opresult9007)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9008 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9011 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9010);
// compiled call node returning call9011 (depth = 7)
// compiled member node returning call9011 (depth = 6)
  int op_slot_right_9009 = gc_frame_newslot(call9011);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9014 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9013);
// compiled call node returning call9014 (depth = 7)
// compiled member node returning call9014 (depth = 6)
  int op_slot_left_9009 = gc_frame_newslot(call9014);
  params[0] = call9011;
  partcv[0] = 1;
  Object diff9015 = callmethod(call9014, "-", 1, partcv, params);
// compiled op node returning diff9015 (depth = 5)
  gc_frame_newslot(diff9015);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff9015;
  partcv[0] = 1;
  Object call9016 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9008);
// compiled call node returning call9016 (depth = 4)
    gc_frame_newslot(call9016);
    if9000 = call9016;
  } else {
  }
// compiled if node returning if9000 (depth = 3)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9018 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9017);
// compiled call node returning call9018 (depth = 4)
// compiled member node returning call9018 (depth = 3)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9021 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9022 == NULL) {
    strlit9022 = alloc_String("identifier");
    gc_root(strlit9022);
  }
// compiled string node returning strlit9022 (depth = 6)
  gc_frame_newslot(strlit9022);
// call case 4: self request
  params[0] = strlit9022;
  partcv[0] = 1;
  Object call9023 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9021);
// compiled call node returning call9023 (depth = 5)
  int op_slot_right_9020 = gc_frame_newslot(call9023);
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9026 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9027 == NULL) {
    strlit9027 = alloc_String("identifier");
    gc_root(strlit9027);
  }
// compiled string node returning strlit9027 (depth = 7)
  gc_frame_newslot(strlit9027);
// call case 4: self request
  params[0] = strlit9027;
  partcv[0] = 1;
  Object call9028 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9026);
// compiled call node returning call9028 (depth = 6)
  int op_slot_right_9025 = gc_frame_newslot(call9028);
// starting to compile call node (depth = 6)
  int callframe9030 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9031 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9030);
// compiled call node returning call9031 (depth = 6)
  int op_slot_left_9025 = gc_frame_newslot(call9031);
  params[0] = call9028;
  partcv[0] = 1;
  Object opresult9032 = callmethod(call9031, "&&", 1, partcv, params);
// compiled op node returning opresult9032 (depth = 5)
  int op_slot_left_9020 = gc_frame_newslot(opresult9032);
  params[0] = call9023;
  partcv[0] = 1;
  Object opresult9033 = callmethod(opresult9032, "||", 1, partcv, params);
// compiled op node returning opresult9033 (depth = 4)
  Object if9019 = done;
  if (istrue(opresult9033)) {
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9034 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array9035 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9035 (depth = 6)
  gc_frame_newslot(array9035);
// starting to compile identifier node (depth = 6)
  Object bool9036 = alloc_Boolean(0);
// compiled identifier node returning bool9036 (depth = 6)
  gc_frame_newslot(bool9036);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9038 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9037);
// compiled call node returning call9038 (depth = 7)
// compiled member node returning call9038 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9035;
  params[3] = bool9036;
  partcv[0] = 4;
  Object call9039 = callmethod(call9038, "new",
    1, partcv, params);
  gc_frame_end(callframe9034);
// compiled call node returning call9039 (depth = 5)
  *var_tm = call9039;
  if (call9039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9040 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9041 = callmethodflags(self, "methodDecRest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9040);
// compiled call node returning call9041 (depth = 5)
  *var_meth = call9041;
  if (call9041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9019 = done;
  } else {
  }
// compiled if node returning if9019 (depth = 3)
    gc_frame_newslot(if9019);
    if8833 = if9019;
  } else {
  }
// compiled if node returning if8833 (depth = 2)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9044 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9045 == NULL) {
    strlit9045 = alloc_String("arrow");
    gc_root(strlit9045);
  }
// compiled string node returning strlit9045 (depth = 4)
  gc_frame_newslot(strlit9045);
// call case 4: self request
  params[0] = strlit9045;
  partcv[0] = 1;
  Object call9046 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9044);
// compiled call node returning call9046 (depth = 3)
  Object if9043 = done;
  if (istrue(call9046)) {
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9048 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9047);
// compiled call node returning call9048 (depth = 4)
// compiled member node returning call9048 (depth = 3)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9049 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9050 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9049);
// compiled call node returning call9050 (depth = 4)
// compiled member node returning call9050 (depth = 3)
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9052 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9051);
// compiled call node returning call9052 (depth = 5)
// compiled member node returning call9052 (depth = 4)
  *var_dtype = call9052;
  if (call9052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9043 = done;
  } else {
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9054 = alloc_Boolean(0);
// compiled identifier node returning bool9054 (depth = 4)
  *var_dtype = bool9054;
  if (bool9054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9043 = done;
  }
// compiled if node returning if9043 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9056 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9056 = alloc_userobj2(4,5, objclass9056);
  gc_frame_newslot(obj9056);
if (objclass9056 == NULL) {
  glfree(obj9056->class->name);
  obj9056->class->name = "parser.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9056, self, 0);
  addmethodreal(obj9056,"outer", &reader_parser_outer_9057);
  Object oldself9056 = self;
  struct StackFrameObject *oldstackframe9056 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9056);
  gc_frame_newslot((Object)stackframe);
  self = obj9056;
  Object *oldselfslot9056 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9056 = (*(struct UserObject *)self).data[0], lowerouter9056 = thisouter9056;
  if (inheritingObject9056) {
    struct UserObject *inho9056 = (struct UserObject *)inheritingObject9056;
    while (inho9056->super != GraceDefaultObject) inho9056 = (struct UserObject *)inho9056->super;
    inho9056->super = obj9056;
    self = inheritingObject9056;
    *selfslot = self;
    lowerouter9056 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9056;
  }
if (objclass9056 == NULL) {
  Method *reader9058 = addmethodrealflags(obj9056, "m",&reader_parser_m_9058, MFLAG_DEF);
  reader9058->definitionModule = modulename;
  reader9058->definitionLine = 2851;
}
adddatum2(obj9056, alloc_Undefined(), 1);
if (objclass9056 == NULL) {
  Method *reader9059 = addmethodrealflags(obj9056, "sig",&reader_parser_sig_9059, MFLAG_DEF);
  reader9059->definitionModule = modulename;
  reader9059->definitionLine = 2852;
}
adddatum2(obj9056, alloc_Undefined(), 2);
if (objclass9056 == NULL) {
  Method *reader9060 = addmethodrealflags(obj9056, "rtype",&reader_parser_rtype_9060, MFLAG_DEF);
  reader9060->definitionModule = modulename;
  reader9060->definitionLine = 2853;
}
adddatum2(obj9056, alloc_Undefined(), 3);
if (objclass9056 == NULL) {
  Method *reader9061 = addmethodrealflags(obj9056, "typeParams",&reader_parser_typeParams_9061, MFLAG_DEF);
  reader9061->definitionModule = modulename;
  reader9061->definitionLine = 2854;
}
adddatum2(obj9056, alloc_Undefined(), 4);
  sourceObject = obj9056;
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth (depth = 2)
  adddatum2(obj9056, *var_meth, 1);
  sourceObject = obj9056;
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_signature (depth = 2)
  adddatum2(obj9056, *var_signature, 2);
  sourceObject = obj9056;
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_dtype (depth = 2)
  adddatum2(obj9056, *var_dtype, 3);
  sourceObject = obj9056;
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_myTypeParams (depth = 2)
  adddatum2(obj9056, *var_myTypeParams, 4);
  objclass9056 = obj9056->class;
  objclass9056->definitionModule = modulename;
  objclass9056->definitionLine = 2850;
  (*(struct UserObject *)self).data[0] = lowerouter9056;
  self = oldself9056;
  selfslot = oldselfslot9056;
  stackframe = oldstackframe9056;
  gc_frame_end(frame);
  return obj9056;
}
Object meth_parser__apply9069(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe9070 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9071 == NULL) {
    strlit9071 = alloc_String("identifier");
    gc_root(strlit9071);
  }
// compiled string node returning strlit9071 (depth = 5)
  gc_frame_newslot(strlit9071);
// call case 4: self request
  params[0] = strlit9071;
  partcv[0] = 1;
  Object call9072 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9070);
// compiled call node returning call9072 (depth = 4)
  gc_frame_end(frame);
  return call9072;
}
Object meth_parser__apply9075(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_typeIds = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9077 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9076);
// compiled call node returning call9077 (depth = 5)
// compiled member node returning call9077 (depth = 4)
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9079 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9078);
// compiled call node returning call9079 (depth = 6)
// compiled member node returning call9079 (depth = 5)
  *var_id = call9079;
  if (call9079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9080 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9081 = alloc_Boolean(1);
// compiled identifier node returning bool9081 (depth = 5)
  gc_frame_newslot(bool9081);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  params[0] = bool9081;
  partcv[0] = 1;
  Object call9082 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9080);
// compiled call node returning call9082 (depth = 4)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9083 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_typeIds (depth = 5)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9084 = callmethod(*var_typeIds, "push",
    1, partcv, params);
  gc_frame_end(callframe9083);
// compiled call node returning call9084 (depth = 4)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9086 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9087 == NULL) {
    strlit9087 = alloc_String("comma");
    gc_root(strlit9087);
  }
// compiled string node returning strlit9087 (depth = 6)
  gc_frame_newslot(strlit9087);
// call case 4: self request
  params[0] = strlit9087;
  partcv[0] = 1;
  Object call9088 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9086);
// compiled call node returning call9088 (depth = 5)
  Object if9085 = done;
  if (istrue(call9088)) {
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9089 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9090 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9089);
// compiled call node returning call9090 (depth = 6)
// compiled member node returning call9090 (depth = 5)
    gc_frame_newslot(call9090);
    if9085 = call9090;
  } else {
  }
// compiled if node returning if9085 (depth = 4)
  gc_frame_end(frame);
  return if9085;
}
Object meth_parser__apply9095(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe9096 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool9097 = alloc_Boolean(1);
// compiled identifier node returning bool9097 (depth = 5)
  gc_frame_newslot(bool9097);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  params[0] = bool9097;
  partcv[0] = 1;
  Object call9098 = callmethod(*var_each, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9096);
// compiled call node returning call9098 (depth = 4)
  gc_frame_end(frame);
  return call9098;
}
Object meth_parser_typeparameters9063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeparameters");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typeparameters (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typeparameters");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeIds = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeIds");
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9065 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9064);
// compiled call node returning call9065 (depth = 3)
// compiled member node returning call9065 (depth = 2)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array9066 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9066 (depth = 3)
  *var_typeIds = array9066;
  if (array9066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9067 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9068 = alloc_Block(NULL, NULL, "parser", 2861);
  gc_frame_newslot(block9068);
// method "_apply"
  block_savedest(block9068);
  Object closure9069 = createclosure(1, "_apply");
  setclosureframe(closure9069, stackframe);
  addtoclosure(closure9069, selfslot);
  struct UserObject *uo9069 = (struct UserObject*)block9068;
  uo9069->data[0] = (Object)closure9069;
  Method *meth_meth_parser__apply9069 = addmethod2pos(block9068, "_apply", &meth_parser__apply9069, 0);
  int argcv_meth_parser__apply9069[] = {0};
  meth_meth_parser__apply9069->type = alloc_MethodType(1, argcv_meth_parser__apply9069);
  meth_meth_parser__apply9069->definitionModule = modulename;
  meth_meth_parser__apply9069->definitionLine = 2859;
// compiled block node returning block9068 (depth = 3)
  gc_frame_newslot(block9068);
// starting to compile block node (depth = 3)
  Object block9074 = alloc_Block(NULL, NULL, "parser", 2861);
  gc_frame_newslot(block9074);
// method "_apply"
  block_savedest(block9074);
  Object closure9075 = createclosure(3, "_apply");
  setclosureframe(closure9075, stackframe);
  addtoclosure(closure9075, var_values);
  addtoclosure(closure9075, var_typeIds);
  addtoclosure(closure9075, selfslot);
  struct UserObject *uo9075 = (struct UserObject*)block9074;
  uo9075->data[0] = (Object)closure9075;
  Method *meth_meth_parser__apply9075 = addmethod2pos(block9074, "_apply", &meth_parser__apply9075, 0);
  int argcv_meth_parser__apply9075[] = {0};
  meth_meth_parser__apply9075->type = alloc_MethodType(1, argcv_meth_parser__apply9075);
  meth_meth_parser__apply9075->definitionModule = modulename;
  meth_meth_parser__apply9075->definitionLine = 2859;
// compiled block node returning block9074 (depth = 3)
  gc_frame_newslot(block9074);
// call case 5: prelude request
  params[0] = block9068;
  params[1] = block9074;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9092 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9067);
// compiled call node returning call9092 (depth = 2)
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9093 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block9094 = alloc_Block(NULL, NULL, "parser", 2870);
  gc_frame_newslot(block9094);
// method "_apply"
  block_savedest(block9094);
  Object closure9095 = createclosure(1, "_apply");
  setclosureframe(closure9095, stackframe);
  addtoclosure(closure9095, selfslot);
  struct UserObject *uo9095 = (struct UserObject*)block9094;
  uo9095->data[0] = (Object)closure9095;
  Method *meth_meth_parser__apply9095 = addmethod2pos(block9094, "_apply", &meth_parser__apply9095, 0);
  int argcv_meth_parser__apply9095[] = {1};
  meth_meth_parser__apply9095->type = alloc_MethodType(1, argcv_meth_parser__apply9095);
  meth_meth_parser__apply9095->definitionModule = modulename;
  meth_meth_parser__apply9095->definitionLine = 2867;
// compiled block node returning block9094 (depth = 3)
  gc_frame_newslot(block9094);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeIds (depth = 3)
  params[0] = block9094;
  partcv[0] = 1;
  Object call9100 = callmethod(*var_typeIds, "do",
    1, partcv, params);
  gc_frame_end(callframe9093);
// compiled call node returning call9100 (depth = 2)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9101 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeIds (depth = 4)
  gc_frame_newslot(*var_typeIds);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9103 = callmethod(*var_ast, "typeParametersNode",
    1, partcv, params);
  gc_frame_end(callframe9102);
// compiled call node returning call9103 (depth = 5)
// compiled member node returning call9103 (depth = 4)
  params[0] = *var_typeIds;
  partcv[0] = 1;
  Object call9104 = callmethod(call9103, "new",
    1, partcv, params);
  gc_frame_end(callframe9101);
// compiled call node returning call9104 (depth = 3)
  *var_result = call9104;
  if (call9104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9107 == NULL) {
    strlit9107 = alloc_String("rgeneric");
    gc_root(strlit9107);
  }
// compiled string node returning strlit9107 (depth = 4)
  int op_slot_right_9106 = gc_frame_newslot(strlit9107);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9110 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9109);
// compiled call node returning call9110 (depth = 5)
// compiled member node returning call9110 (depth = 4)
  int op_slot_left_9106 = gc_frame_newslot(call9110);
  params[0] = strlit9107;
  partcv[0] = 1;
  Object opresult9111 = callmethod(call9110, "≠", 1, partcv, params);
// compiled op node returning opresult9111 (depth = 3)
  Object if9105 = done;
  if (istrue(opresult9111)) {
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9112 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9114 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9113);
// compiled call node returning call9114 (depth = 7)
// compiled member node returning call9114 (depth = 6)
  partcv[0] = 0;
  Object call9115 = callmethod(call9114, "new",
    1, partcv, params);
  gc_frame_end(callframe9112);
// compiled call node returning call9115 (depth = 5)
// compiled member node returning call9115 (depth = 4)
  *var_suggestion = call9115;
  if (call9115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9116 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9117 == NULL) {
    strlit9117 = alloc_String(">");
    gc_root(strlit9117);
  }
// compiled string node returning strlit9117 (depth = 4)
  gc_frame_newslot(strlit9117);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit9117;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9118 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9116);
// compiled call node returning call9118 (depth = 3)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9119 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9120 == NULL) {
    strlit9120 = alloc_String("a list of type parameters starting with '<' must end with '>'.");
    gc_root(strlit9120);
  }
// compiled string node returning strlit9120 (depth = 4)
  gc_frame_newslot(strlit9120);
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9122 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9121);
// compiled call node returning call9122 (depth = 5)
// compiled member node returning call9122 (depth = 4)
  gc_frame_newslot(call9122);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9125 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9124);
// compiled call node returning call9125 (depth = 6)
// compiled member node returning call9125 (depth = 5)
  int op_slot_right_9123 = gc_frame_newslot(call9125);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9128 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compiled call node returning call9128 (depth = 6)
// compiled member node returning call9128 (depth = 5)
  int op_slot_left_9123 = gc_frame_newslot(call9128);
  params[0] = call9125;
  partcv[0] = 1;
  Object sum9129 = callmethod(call9128, "+", 1, partcv, params);
// compiled op node returning sum9129 (depth = 4)
  gc_frame_newslot(sum9129);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9120;
  params[1] = call9122;
  params[2] = sum9129;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9130 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9119);
// compiled call node returning call9130 (depth = 3)
    gc_frame_newslot(call9130);
    if9105 = call9130;
  } else {
  }
// compiled if node returning if9105 (depth = 2)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9132 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9131);
// compiled call node returning call9132 (depth = 3)
// compiled member node returning call9132 (depth = 2)
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_doimport9133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doimport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doimport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_name = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "name");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9135 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9136 == NULL) {
    strlit9136 = alloc_String("import");
    gc_root(strlit9136);
  }
// compiled string node returning strlit9136 (depth = 4)
  gc_frame_newslot(strlit9136);
// call case 4: self request
  params[0] = strlit9136;
  partcv[0] = 1;
  Object call9137 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9135);
// compiled call node returning call9137 (depth = 3)
  Object if9134 = done;
  if (istrue(call9137)) {
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9139 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9138);
// compiled call node returning call9139 (depth = 5)
// compiled member node returning call9139 (depth = 4)
  *var_importline = call9139;
  if (call9139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9141 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9140);
// compiled call node returning call9141 (depth = 4)
// compiled member node returning call9141 (depth = 3)
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9144 == NULL) {
    strlit9144 = alloc_String("string");
    gc_root(strlit9144);
  }
// compiled string node returning strlit9144 (depth = 5)
  int op_slot_right_9143 = gc_frame_newslot(strlit9144);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9147 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9146);
// compiled call node returning call9147 (depth = 6)
// compiled member node returning call9147 (depth = 5)
  int op_slot_left_9143 = gc_frame_newslot(call9147);
  params[0] = strlit9144;
  partcv[0] = 1;
  Object opresult9148 = callmethod(call9147, "≠", 1, partcv, params);
// compiled op node returning opresult9148 (depth = 4)
  Object if9142 = done;
  if (istrue(opresult9148)) {
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9149 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9151 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9150);
// compiled call node returning call9151 (depth = 8)
// compiled member node returning call9151 (depth = 7)
  partcv[0] = 0;
  Object call9152 = callmethod(call9151, "new",
    1, partcv, params);
  gc_frame_end(callframe9149);
// compiled call node returning call9152 (depth = 6)
// compiled member node returning call9152 (depth = 5)
  *var_suggestion = call9152;
  if (call9152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9157 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9156);
// compiled call node returning call9157 (depth = 8)
// compiled member node returning call9157 (depth = 7)
  int op_slot_right_9155 = gc_frame_newslot(call9157);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9160 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9159);
// compiled call node returning call9160 (depth = 8)
// compiled member node returning call9160 (depth = 7)
  int op_slot_left_9155 = gc_frame_newslot(call9160);
  params[0] = call9157;
  partcv[0] = 1;
  Object opresult9161 = callmethod(call9160, "==", 1, partcv, params);
// compiled op node returning opresult9161 (depth = 6)
  int op_slot_right_9154 = gc_frame_newslot(opresult9161);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9164 == NULL) {
    strlit9164 = alloc_String("identifier");
    gc_root(strlit9164);
  }
// compiled string node returning strlit9164 (depth = 7)
  int op_slot_right_9163 = gc_frame_newslot(strlit9164);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9167 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9166);
// compiled call node returning call9167 (depth = 8)
// compiled member node returning call9167 (depth = 7)
  int op_slot_left_9163 = gc_frame_newslot(call9167);
  params[0] = strlit9164;
  partcv[0] = 1;
  Object opresult9168 = callmethod(call9167, "==", 1, partcv, params);
// compiled op node returning opresult9168 (depth = 6)
  int op_slot_left_9154 = gc_frame_newslot(opresult9168);
  params[0] = opresult9161;
  partcv[0] = 1;
  Object opresult9169 = callmethod(opresult9168, "&&", 1, partcv, params);
// compiled op node returning opresult9169 (depth = 5)
  Object if9153 = done;
  if (istrue(opresult9169)) {
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9170 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9172 == NULL) {
    strlit9172 = alloc_String("""\x22""");
    gc_root(strlit9172);
  }
// compiled string node returning strlit9172 (depth = 7)
  int op_slot_right_9171 = gc_frame_newslot(strlit9172);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9176 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9175);
// compiled call node returning call9176 (depth = 9)
// compiled member node returning call9176 (depth = 8)
  int op_slot_right_9174 = gc_frame_newslot(call9176);
// starting to compile string node (depth = 8)
  if (strlit9178 == NULL) {
    strlit9178 = alloc_String("""\x22""");
    gc_root(strlit9178);
  }
// compiled string node returning strlit9178 (depth = 8)
  int op_slot_left_9174 = gc_frame_newslot(strlit9178);
  params[0] = call9176;
  partcv[0] = 1;
  Object opresult9179 = callmethod(strlit9178, "++", 1, partcv, params);
// compiled op node returning opresult9179 (depth = 7)
  int op_slot_left_9171 = gc_frame_newslot(opresult9179);
  params[0] = strlit9172;
  partcv[0] = 1;
  Object opresult9180 = callmethod(opresult9179, "++", 1, partcv, params);
// compiled op node returning opresult9180 (depth = 6)
  gc_frame_newslot(opresult9180);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9180;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9181 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9170);
// compiled call node returning call9181 (depth = 5)
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9183 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9182);
// compiled call node returning call9183 (depth = 7)
// compiled member node returning call9183 (depth = 6)
  *var_errorPos = call9183;
  if (call9183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9153 = done;
  } else {
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9185 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9186 == NULL) {
    strlit9186 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit9186);
  }
// compiled string node returning strlit9186 (depth = 6)
  gc_frame_newslot(strlit9186);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9186;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9187 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9185);
// compiled call node returning call9187 (depth = 5)
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9189 = alloc_Float64(1);
// compiled num node returning num9189 (depth = 7)
  int op_slot_right_9188 = gc_frame_newslot(num9189);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9193 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9192);
// compiled call node returning call9193 (depth = 9)
// compiled member node returning call9193 (depth = 8)
  int op_slot_right_9191 = gc_frame_newslot(call9193);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9196 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9195);
// compiled call node returning call9196 (depth = 9)
// compiled member node returning call9196 (depth = 8)
  int op_slot_left_9191 = gc_frame_newslot(call9196);
  params[0] = call9193;
  partcv[0] = 1;
  Object sum9197 = callmethod(call9196, "+", 1, partcv, params);
// compiled op node returning sum9197 (depth = 7)
  int op_slot_left_9188 = gc_frame_newslot(sum9197);
  params[0] = num9189;
  partcv[0] = 1;
  Object sum9198 = callmethod(sum9197, "+", 1, partcv, params);
// compiled op node returning sum9198 (depth = 6)
  *var_errorPos = sum9198;
  if (sum9198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9153 = done;
  }
// compiled if node returning if9153 (depth = 4)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9200 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9201 == NULL) {
    strlit9201 = alloc_String("an import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit9201);
  }
// compiled string node returning strlit9201 (depth = 5)
  gc_frame_newslot(strlit9201);
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9202 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9203 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9202);
// compiled call node returning call9203 (depth = 6)
// compiled member node returning call9203 (depth = 5)
  gc_frame_newslot(call9203);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9201;
  params[1] = call9203;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9204 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9200);
// compiled call node returning call9204 (depth = 4)
    gc_frame_newslot(call9204);
    if9142 = call9204;
  } else {
  }
// compiled if node returning if9142 (depth = 3)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9206 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9205);
// compiled call node returning call9206 (depth = 4)
// compiled member node returning call9206 (depth = 3)
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9208 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9207);
// compiled call node returning call9208 (depth = 5)
// compiled member node returning call9208 (depth = 4)
  *var_p = call9208;
  if (call9208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9212 == NULL) {
    strlit9212 = alloc_String("as");
    gc_root(strlit9212);
  }
// compiled string node returning strlit9212 (depth = 6)
  int op_slot_right_9211 = gc_frame_newslot(strlit9212);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9214 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9215 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9214);
// compiled call node returning call9215 (depth = 7)
// compiled member node returning call9215 (depth = 6)
  int op_slot_left_9211 = gc_frame_newslot(call9215);
  params[0] = strlit9212;
  partcv[0] = 1;
  Object opresult9216 = callmethod(call9215, "≠", 1, partcv, params);
// compiled op node returning opresult9216 (depth = 5)
  int op_slot_right_9210 = gc_frame_newslot(opresult9216);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9219 == NULL) {
    strlit9219 = alloc_String("identifier");
    gc_root(strlit9219);
  }
// compiled string node returning strlit9219 (depth = 6)
  int op_slot_right_9218 = gc_frame_newslot(strlit9219);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9222 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9221);
// compiled call node returning call9222 (depth = 7)
// compiled member node returning call9222 (depth = 6)
  int op_slot_left_9218 = gc_frame_newslot(call9222);
  params[0] = strlit9219;
  partcv[0] = 1;
  Object opresult9223 = callmethod(call9222, "≠", 1, partcv, params);
// compiled op node returning opresult9223 (depth = 5)
  int op_slot_left_9210 = gc_frame_newslot(opresult9223);
  params[0] = opresult9216;
  partcv[0] = 1;
  Object opresult9224 = callmethod(opresult9223, "||", 1, partcv, params);
// compiled op node returning opresult9224 (depth = 4)
  Object if9209 = done;
  if (istrue(opresult9224)) {
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9225 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9226 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9227 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9226);
// compiled call node returning call9227 (depth = 8)
// compiled member node returning call9227 (depth = 7)
  partcv[0] = 0;
  Object call9228 = callmethod(call9227, "new",
    1, partcv, params);
  gc_frame_end(callframe9225);
// compiled call node returning call9228 (depth = 6)
// compiled member node returning call9228 (depth = 5)
  *var_suggestion = call9228;
  if (call9228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9233 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9232);
// compiled call node returning call9233 (depth = 8)
// compiled member node returning call9233 (depth = 7)
  int op_slot_right_9231 = gc_frame_newslot(call9233);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9236 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9235);
// compiled call node returning call9236 (depth = 8)
// compiled member node returning call9236 (depth = 7)
  int op_slot_left_9231 = gc_frame_newslot(call9236);
  params[0] = call9233;
  partcv[0] = 1;
  Object opresult9237 = callmethod(call9236, "==", 1, partcv, params);
// compiled op node returning opresult9237 (depth = 6)
  int op_slot_right_9230 = gc_frame_newslot(opresult9237);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9240 == NULL) {
    strlit9240 = alloc_String("identifier");
    gc_root(strlit9240);
  }
// compiled string node returning strlit9240 (depth = 7)
  int op_slot_right_9239 = gc_frame_newslot(strlit9240);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9243 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9242);
// compiled call node returning call9243 (depth = 8)
// compiled member node returning call9243 (depth = 7)
  int op_slot_left_9239 = gc_frame_newslot(call9243);
  params[0] = strlit9240;
  partcv[0] = 1;
  Object opresult9244 = callmethod(call9243, "==", 1, partcv, params);
// compiled op node returning opresult9244 (depth = 6)
  int op_slot_left_9230 = gc_frame_newslot(opresult9244);
  params[0] = opresult9237;
  partcv[0] = 1;
  Object opresult9245 = callmethod(opresult9244, "&&", 1, partcv, params);
// compiled op node returning opresult9245 (depth = 5)
  Object if9229 = done;
  if (istrue(opresult9245)) {
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9246 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9247 == NULL) {
    strlit9247 = alloc_String(" as");
    gc_root(strlit9247);
  }
// compiled string node returning strlit9247 (depth = 6)
  gc_frame_newslot(strlit9247);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9247;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9248 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9246);
// compiled call node returning call9248 (depth = 5)
    gc_frame_newslot(call9248);
    if9229 = call9248;
  } else {
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9249 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9251 == NULL) {
    strlit9251 = alloc_String("");
    gc_root(strlit9251);
  }
// compiled string node returning strlit9251 (depth = 7)
  int op_slot_right_9250 = gc_frame_newslot(strlit9251);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call9255 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9254);
// compiled call node returning call9255 (depth = 9)
// compiled member node returning call9255 (depth = 8)
  int op_slot_right_9253 = gc_frame_newslot(call9255);
// starting to compile string node (depth = 8)
  if (strlit9257 == NULL) {
    strlit9257 = alloc_String(" as ");
    gc_root(strlit9257);
  }
// compiled string node returning strlit9257 (depth = 8)
  int op_slot_left_9253 = gc_frame_newslot(strlit9257);
  params[0] = call9255;
  partcv[0] = 1;
  Object opresult9258 = callmethod(strlit9257, "++", 1, partcv, params);
// compiled op node returning opresult9258 (depth = 7)
  int op_slot_left_9250 = gc_frame_newslot(opresult9258);
  params[0] = strlit9251;
  partcv[0] = 1;
  Object opresult9259 = callmethod(opresult9258, "++", 1, partcv, params);
// compiled op node returning opresult9259 (depth = 6)
  gc_frame_newslot(opresult9259);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9259;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9260 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9249);
// compiled call node returning call9260 (depth = 5)
    gc_frame_newslot(call9260);
    if9229 = call9260;
  }
// compiled if node returning if9229 (depth = 4)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9261 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9262 == NULL) {
    strlit9262 = alloc_String("an import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit9262);
  }
// compiled string node returning strlit9262 (depth = 5)
  gc_frame_newslot(strlit9262);
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9263 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9264 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9263);
// compiled call node returning call9264 (depth = 6)
// compiled member node returning call9264 (depth = 5)
  gc_frame_newslot(call9264);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9266 = alloc_Float64(1);
// compiled num node returning num9266 (depth = 6)
  int op_slot_right_9265 = gc_frame_newslot(num9266);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9269 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9270 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9269);
// compiled call node returning call9270 (depth = 8)
// compiled member node returning call9270 (depth = 7)
  int op_slot_right_9268 = gc_frame_newslot(call9270);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9273 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9272);
// compiled call node returning call9273 (depth = 8)
// compiled member node returning call9273 (depth = 7)
  int op_slot_left_9268 = gc_frame_newslot(call9273);
  params[0] = call9270;
  partcv[0] = 1;
  Object sum9274 = callmethod(call9273, "+", 1, partcv, params);
// compiled op node returning sum9274 (depth = 6)
  int op_slot_left_9265 = gc_frame_newslot(sum9274);
  params[0] = num9266;
  partcv[0] = 1;
  Object sum9275 = callmethod(sum9274, "+", 1, partcv, params);
// compiled op node returning sum9275 (depth = 5)
  gc_frame_newslot(sum9275);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9262;
  params[1] = call9264;
  params[2] = sum9275;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9276 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9261);
// compiled call node returning call9276 (depth = 4)
    gc_frame_newslot(call9276);
    if9209 = call9276;
  } else {
  }
// compiled if node returning if9209 (depth = 3)
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9278 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9277);
// compiled call node returning call9278 (depth = 4)
// compiled member node returning call9278 (depth = 3)
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9281 == NULL) {
    strlit9281 = alloc_String("identifier");
    gc_root(strlit9281);
  }
// compiled string node returning strlit9281 (depth = 5)
  int op_slot_right_9280 = gc_frame_newslot(strlit9281);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9284 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9283);
// compiled call node returning call9284 (depth = 6)
// compiled member node returning call9284 (depth = 5)
  int op_slot_left_9280 = gc_frame_newslot(call9284);
  params[0] = strlit9281;
  partcv[0] = 1;
  Object opresult9285 = callmethod(call9284, "≠", 1, partcv, params);
// compiled op node returning opresult9285 (depth = 4)
  Object if9279 = done;
  if (istrue(opresult9285)) {
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9286 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9288 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9287);
// compiled call node returning call9288 (depth = 8)
// compiled member node returning call9288 (depth = 7)
  partcv[0] = 0;
  Object call9289 = callmethod(call9288, "new",
    1, partcv, params);
  gc_frame_end(callframe9286);
// compiled call node returning call9289 (depth = 6)
// compiled member node returning call9289 (depth = 5)
  *var_suggestion = call9289;
  if (call9289 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9294 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9293);
// compiled call node returning call9294 (depth = 8)
// compiled member node returning call9294 (depth = 7)
  int op_slot_right_9292 = gc_frame_newslot(call9294);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9297 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9296);
// compiled call node returning call9297 (depth = 8)
// compiled member node returning call9297 (depth = 7)
  int op_slot_left_9292 = gc_frame_newslot(call9297);
  params[0] = call9294;
  partcv[0] = 1;
  Object opresult9298 = callmethod(call9297, "==", 1, partcv, params);
// compiled op node returning opresult9298 (depth = 6)
  int op_slot_right_9291 = gc_frame_newslot(opresult9298);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9301 == NULL) {
    strlit9301 = alloc_String("string");
    gc_root(strlit9301);
  }
// compiled string node returning strlit9301 (depth = 7)
  int op_slot_right_9300 = gc_frame_newslot(strlit9301);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9304 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9303);
// compiled call node returning call9304 (depth = 8)
// compiled member node returning call9304 (depth = 7)
  int op_slot_left_9300 = gc_frame_newslot(call9304);
  params[0] = strlit9301;
  partcv[0] = 1;
  Object opresult9305 = callmethod(call9304, "==", 1, partcv, params);
// compiled op node returning opresult9305 (depth = 6)
  int op_slot_left_9291 = gc_frame_newslot(opresult9305);
  params[0] = opresult9298;
  partcv[0] = 1;
  Object opresult9306 = callmethod(opresult9305, "&&", 1, partcv, params);
// compiled op node returning opresult9306 (depth = 5)
  Object if9290 = done;
  if (istrue(opresult9306)) {
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9307 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9309 == NULL) {
    strlit9309 = alloc_String("");
    gc_root(strlit9309);
  }
// compiled string node returning strlit9309 (depth = 7)
  int op_slot_right_9308 = gc_frame_newslot(strlit9309);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9313 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9312);
// compiled call node returning call9313 (depth = 9)
// compiled member node returning call9313 (depth = 8)
  int op_slot_right_9311 = gc_frame_newslot(call9313);
// starting to compile string node (depth = 8)
  if (strlit9315 == NULL) {
    strlit9315 = alloc_String("");
    gc_root(strlit9315);
  }
// compiled string node returning strlit9315 (depth = 8)
  int op_slot_left_9311 = gc_frame_newslot(strlit9315);
  params[0] = call9313;
  partcv[0] = 1;
  Object opresult9316 = callmethod(strlit9315, "++", 1, partcv, params);
// compiled op node returning opresult9316 (depth = 7)
  int op_slot_left_9308 = gc_frame_newslot(opresult9316);
  params[0] = strlit9309;
  partcv[0] = 1;
  Object opresult9317 = callmethod(opresult9316, "++", 1, partcv, params);
// compiled op node returning opresult9317 (depth = 6)
  gc_frame_newslot(opresult9317);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult9317;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9318 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9307);
// compiled call node returning call9318 (depth = 5)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9320 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9319);
// compiled call node returning call9320 (depth = 7)
// compiled member node returning call9320 (depth = 6)
  *var_errorPos = call9320;
  if (call9320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9290 = done;
  } else {
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9322 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9324 == NULL) {
    strlit9324 = alloc_String("");
    gc_root(strlit9324);
  }
// compiled string node returning strlit9324 (depth = 7)
  int op_slot_right_9323 = gc_frame_newslot(strlit9324);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call9328 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9327);
// compiled call node returning call9328 (depth = 9)
// compiled member node returning call9328 (depth = 8)
  int op_slot_right_9326 = gc_frame_newslot(call9328);
// starting to compile string node (depth = 8)
  if (strlit9330 == NULL) {
    strlit9330 = alloc_String(" ");
    gc_root(strlit9330);
  }
// compiled string node returning strlit9330 (depth = 8)
  int op_slot_left_9326 = gc_frame_newslot(strlit9330);
  params[0] = call9328;
  partcv[0] = 1;
  Object opresult9331 = callmethod(strlit9330, "++", 1, partcv, params);
// compiled op node returning opresult9331 (depth = 7)
  int op_slot_left_9323 = gc_frame_newslot(opresult9331);
  params[0] = strlit9324;
  partcv[0] = 1;
  Object opresult9332 = callmethod(opresult9331, "++", 1, partcv, params);
// compiled op node returning opresult9332 (depth = 6)
  gc_frame_newslot(opresult9332);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult9332;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9333 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9322);
// compiled call node returning call9333 (depth = 5)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9335 = alloc_Float64(1);
// compiled num node returning num9335 (depth = 7)
  int op_slot_right_9334 = gc_frame_newslot(num9335);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9338 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9339 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9338);
// compiled call node returning call9339 (depth = 9)
// compiled member node returning call9339 (depth = 8)
  int op_slot_right_9337 = gc_frame_newslot(call9339);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9342 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9341);
// compiled call node returning call9342 (depth = 9)
// compiled member node returning call9342 (depth = 8)
  int op_slot_left_9337 = gc_frame_newslot(call9342);
  params[0] = call9339;
  partcv[0] = 1;
  Object sum9343 = callmethod(call9342, "+", 1, partcv, params);
// compiled op node returning sum9343 (depth = 7)
  int op_slot_left_9334 = gc_frame_newslot(sum9343);
  params[0] = num9335;
  partcv[0] = 1;
  Object sum9344 = callmethod(sum9343, "+", 1, partcv, params);
// compiled op node returning sum9344 (depth = 6)
  *var_errorPos = sum9344;
  if (sum9344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9290 = done;
  }
// compiled if node returning if9290 (depth = 4)
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9346 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9347 == NULL) {
    strlit9347 = alloc_String("an import statement must have an identifier after 'as'.");
    gc_root(strlit9347);
  }
// compiled string node returning strlit9347 (depth = 5)
  gc_frame_newslot(strlit9347);
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9349 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9348);
// compiled call node returning call9349 (depth = 6)
// compiled member node returning call9349 (depth = 5)
  gc_frame_newslot(call9349);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9347;
  params[1] = call9349;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9350 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9346);
// compiled call node returning call9350 (depth = 4)
    gc_frame_newslot(call9350);
    if9279 = call9350;
  } else {
  }
// compiled if node returning if9279 (depth = 3)
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9352 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9351);
// compiled call node returning call9352 (depth = 4)
// compiled member node returning call9352 (depth = 3)
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9353 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9354 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9353);
// compiled call node returning call9354 (depth = 5)
// compiled member node returning call9354 (depth = 4)
  *var_name = call9354;
  if (call9354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9355 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9356 = alloc_Boolean(1);
// compiled identifier node returning bool9356 (depth = 4)
  gc_frame_newslot(bool9356);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  params[0] = bool9356;
  partcv[0] = 1;
  Object call9357 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9355);
// compiled call node returning call9357 (depth = 3)
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9359 = callmethodflags(self, "optionalTypeAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9358);
// compiled call node returning call9359 (depth = 5)
// compiled member node returning call9359 (depth = 4)
  *var_dtype = call9359;
  if (call9359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9360 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_importline (depth = 4)
  gc_frame_newslot(*var_importline);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call9361 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe9360);
// compiled call node returning call9361 (depth = 3)
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9362 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call9364 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9363);
// compiled call node returning call9364 (depth = 6)
// compiled member node returning call9364 (depth = 5)
  gc_frame_newslot(call9364);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9365 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9366 = callmethod(*var_ast, "importNode",
    1, partcv, params);
  gc_frame_end(callframe9365);
// compiled call node returning call9366 (depth = 6)
// compiled member node returning call9366 (depth = 5)
  params[0] = call9364;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call9367 = callmethod(call9366, "new",
    1, partcv, params);
  gc_frame_end(callframe9362);
// compiled call node returning call9367 (depth = 4)
  *var_o = call9367;
  if (call9367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2933
  setline(2933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9368 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9369 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9368);
// compiled call node returning call9369 (depth = 5)
// compiled member node returning call9369 (depth = 4)
  *var_anns = call9369;
  if (call9369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_9371 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool9373 = alloc_Boolean(0);
// compiled identifier node returning bool9373 (depth = 5)
  int op_slot_left_9371 = gc_frame_newslot(bool9373);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult9374 = callmethod(bool9373, "≠", 1, partcv, params);
// compiled op node returning opresult9374 (depth = 4)
  Object if9370 = done;
  if (istrue(opresult9374)) {
// starting to compile call node (depth = 4)
  int callframe9375 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call9377 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe9376);
// compiled call node returning call9377 (depth = 6)
// compiled member node returning call9377 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9378 = callmethod(call9377, "addAll",
    1, partcv, params);
  gc_frame_end(callframe9375);
// compiled call node returning call9378 (depth = 4)
    gc_frame_newslot(call9378);
    if9370 = call9378;
  } else {
  }
// compiled if node returning if9370 (depth = 3)
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9379 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9380 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9379);
// compiled call node returning call9380 (depth = 3)
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9381 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9382 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9381);
// compiled call node returning call9382 (depth = 4)
// compiled member node returning call9382 (depth = 3)
    gc_frame_newslot(call9382);
    if9134 = call9382;
  } else {
  }
// compiled if node returning if9134 (depth = 2)
  gc_frame_end(frame);
  return if9134;
}
Object meth_parser__apply9393(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9394 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe9395 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9396 == NULL) {
    strlit9396 = alloc_String("rbrace");
    gc_root(strlit9396);
  }
// compiled string node returning strlit9396 (depth = 9)
  gc_frame_newslot(strlit9396);
// call case 4: self request
  params[0] = strlit9396;
  partcv[0] = 1;
  Object call9397 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9395);
// compiled call node returning call9397 (depth = 8)
  partcv[0] = 0;
  Object call9398 = callmethod(call9397, "not",
    1, partcv, params);
  gc_frame_end(callframe9394);
// compiled call node returning call9398 (depth = 7)
// compiled member node returning call9398 (depth = 6)
  gc_frame_end(frame);
  return call9398;
}
Object meth_parser__apply9408(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe9409 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call9410 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9409);
// compiled call node returning call9410 (depth = 9)
  gc_frame_end(frame);
  return call9410;
}
Object meth_parser_doreturn9383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for doreturn (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for doreturn");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retTok");
  Object *var_retval = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "retval");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9385 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9386 == NULL) {
    strlit9386 = alloc_String("return");
    gc_root(strlit9386);
  }
// compiled string node returning strlit9386 (depth = 4)
  gc_frame_newslot(strlit9386);
// call case 4: self request
  params[0] = strlit9386;
  partcv[0] = 1;
  Object call9387 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9385);
// compiled call node returning call9387 (depth = 3)
  Object if9384 = done;
  if (istrue(call9387)) {
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_retTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9389 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9388);
// compiled call node returning call9389 (depth = 4)
// compiled member node returning call9389 (depth = 3)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block9392 = alloc_Block(NULL, NULL, "parser", 2946);
  gc_frame_newslot(block9392);
// method "_apply"
  block_savedest(block9392);
  Object closure9393 = createclosure(1, "_apply");
  setclosureframe(closure9393, stackframe);
  addtoclosure(closure9393, selfslot);
  struct UserObject *uo9393 = (struct UserObject*)block9392;
  uo9393->data[0] = (Object)closure9393;
  Method *meth_meth_parser__apply9393 = addmethod2pos(block9392, "_apply", &meth_parser__apply9393, 0);
  int argcv_meth_parser__apply9393[] = {0};
  meth_meth_parser__apply9393->type = alloc_MethodType(1, argcv_meth_parser__apply9393);
  meth_meth_parser__apply9393->definitionModule = modulename;
  meth_meth_parser__apply9393->definitionLine = 2944;
// compiled block node returning block9392 (depth = 5)
  int op_slot_right_9391 = gc_frame_newslot(block9392);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9401 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9402 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 6)
// compiled member node returning call9402 (depth = 5)
  int op_slot_left_9391 = gc_frame_newslot(call9402);
  params[0] = block9392;
  partcv[0] = 1;
  Object opresult9403 = callmethod(call9402, "&&", 1, partcv, params);
// compiled op node returning opresult9403 (depth = 4)
  Object if9390 = done;
  if (istrue(opresult9403)) {
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9405 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe9406 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block9407 = alloc_Block(NULL, NULL, "parser", 2947);
  gc_frame_newslot(block9407);
// method "_apply"
  block_savedest(block9407);
  Object closure9408 = createclosure(2, "_apply");
  setclosureframe(closure9408, stackframe);
  addtoclosure(closure9408, var_blocksOK);
  addtoclosure(closure9408, selfslot);
  struct UserObject *uo9408 = (struct UserObject*)block9407;
  uo9408->data[0] = (Object)closure9408;
  Method *meth_meth_parser__apply9408 = addmethod2pos(block9407, "_apply", &meth_parser__apply9408, 0);
  int argcv_meth_parser__apply9408[] = {0};
  meth_meth_parser__apply9408->type = alloc_MethodType(1, argcv_meth_parser__apply9408);
  meth_meth_parser__apply9408->definitionModule = modulename;
  meth_meth_parser__apply9408->definitionLine = 2947;
// compiled block node returning block9407 (depth = 8)
  gc_frame_newslot(block9407);
// call case 4: self request
  params[0] = block9407;
  partcv[0] = 1;
  Object call9412 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9406);
// compiled call node returning call9412 (depth = 7)
  partcv[0] = 0;
  Object call9413 = callmethod(call9412, "not",
    1, partcv, params);
  gc_frame_end(callframe9405);
// compiled call node returning call9413 (depth = 6)
// compiled member node returning call9413 (depth = 5)
  Object if9404 = done;
  if (istrue(call9413)) {
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile array node (depth = 6)
  Object array9414 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9414 (depth = 6)
  *var_suggestions = array9414;
  if (array9414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9415 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9417 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9416);
// compiled call node returning call9417 (depth = 9)
// compiled member node returning call9417 (depth = 8)
  partcv[0] = 0;
  Object call9418 = callmethod(call9417, "new",
    1, partcv, params);
  gc_frame_end(callframe9415);
// compiled call node returning call9418 (depth = 7)
// compiled member node returning call9418 (depth = 6)
  *var_suggestion = call9418;
  if (call9418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9419 = gc_frame_new();
// starting to compile array node (depth = 7)
  Object array9420 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 8)
  if (strlit9421 == NULL) {
    strlit9421 = alloc_String("rbrace");
    gc_root(strlit9421);
  }
// compiled string node returning strlit9421 (depth = 8)
  params[0] = strlit9421;
  partcv[0] = 1;
  callmethodflags(array9420, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array9420 (depth = 7)
  gc_frame_newslot(array9420);
// call case 4: self request
  params[0] = array9420;
  partcv[0] = 1;
  Object call9422 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9419);
// compiled call node returning call9422 (depth = 6)
  *var_nextTok = call9422;
  if (call9422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_9424 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_9424 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9426 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult9426 (depth = 6)
  Object if9423 = done;
  if (istrue(opresult9426)) {
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9427 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9428 == NULL) {
    strlit9428 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9428);
  }
// compiled string node returning strlit9428 (depth = 7)
  gc_frame_newslot(strlit9428);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit9428;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9429 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9427);
// compiled call node returning call9429 (depth = 6)
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9430 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9431 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9430);
// compiled call node returning call9431 (depth = 6)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call9434 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9433);
// compiled call node returning call9434 (depth = 10)
// compiled member node returning call9434 (depth = 9)
  partcv[0] = 0;
  Object call9435 = callmethod(call9434, "new",
    1, partcv, params);
  gc_frame_end(callframe9432);
// compiled call node returning call9435 (depth = 8)
// compiled member node returning call9435 (depth = 7)
  *var_suggestion = call9435;
  if (call9435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9437 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool9438 = alloc_Boolean(1);
// compiled identifier node returning bool9438 (depth = 7)
  gc_frame_newslot(bool9438);
// starting to compile identifier node (depth = 7)
  Object bool9439 = alloc_Boolean(0);
// compiled identifier node returning bool9439 (depth = 7)
  gc_frame_newslot(bool9439);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool9438;
  params[2] = bool9439;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9440 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9437);
// compiled call node returning call9440 (depth = 6)
    gc_frame_newslot(call9440);
    if9423 = call9440;
  } else {
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9441 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9442 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call9443 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9442);
// compiled call node returning call9443 (depth = 8)
// compiled member node returning call9443 (depth = 7)
  gc_frame_newslot(call9443);
// starting to compile identifier node (depth = 7)
  Object bool9444 = alloc_Boolean(1);
// compiled identifier node returning bool9444 (depth = 7)
  gc_frame_newslot(bool9444);
// starting to compile identifier node (depth = 7)
  Object bool9445 = alloc_Boolean(0);
// compiled identifier node returning bool9445 (depth = 7)
  gc_frame_newslot(bool9445);
// starting to compile string node (depth = 7)
  if (strlit9446 == NULL) {
    strlit9446 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit9446);
  }
// compiled string node returning strlit9446 (depth = 7)
  gc_frame_newslot(strlit9446);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9443;
  params[2] = bool9444;
  params[3] = bool9445;
  params[4] = strlit9446;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call9447 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe9441);
// compiled call node returning call9447 (depth = 6)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9448 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9449 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9448);
// compiled call node returning call9449 (depth = 6)
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9450 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call9452 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9451);
// compiled call node returning call9452 (depth = 10)
// compiled member node returning call9452 (depth = 9)
  partcv[0] = 0;
  Object call9453 = callmethod(call9452, "new",
    1, partcv, params);
  gc_frame_end(callframe9450);
// compiled call node returning call9453 (depth = 8)
// compiled member node returning call9453 (depth = 7)
  *var_suggestion = call9453;
  if (call9453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9455 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call9457 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9456);
// compiled call node returning call9457 (depth = 8)
// compiled member node returning call9457 (depth = 7)
  gc_frame_newslot(call9457);
// starting to compile identifier node (depth = 7)
  Object bool9458 = alloc_Boolean(1);
// compiled identifier node returning bool9458 (depth = 7)
  gc_frame_newslot(bool9458);
// starting to compile identifier node (depth = 7)
  Object bool9459 = alloc_Boolean(0);
// compiled identifier node returning bool9459 (depth = 7)
  gc_frame_newslot(bool9459);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call9457;
  params[2] = bool9458;
  params[3] = bool9459;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9460 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9455);
// compiled call node returning call9460 (depth = 6)
    gc_frame_newslot(call9460);
    if9423 = call9460;
  }
// compiled if node returning if9423 (depth = 5)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9461 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9462 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9461);
// compiled call node returning call9462 (depth = 5)
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9463 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("a return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit9464);
  }
// compiled string node returning strlit9464 (depth = 6)
  gc_frame_newslot(strlit9464);
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9465 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9466 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9465);
// compiled call node returning call9466 (depth = 7)
// compiled member node returning call9466 (depth = 6)
  gc_frame_newslot(call9466);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9468 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9467);
// compiled call node returning call9468 (depth = 7)
// compiled member node returning call9468 (depth = 6)
  gc_frame_newslot(call9468);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9470 = alloc_Float64(1);
// compiled num node returning num9470 (depth = 7)
  int op_slot_right_9469 = gc_frame_newslot(num9470);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9474 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe9473);
// compiled call node returning call9474 (depth = 9)
// compiled member node returning call9474 (depth = 8)
  int op_slot_right_9472 = gc_frame_newslot(call9474);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9477 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9476);
// compiled call node returning call9477 (depth = 9)
// compiled member node returning call9477 (depth = 8)
  int op_slot_left_9472 = gc_frame_newslot(call9477);
  params[0] = call9474;
  partcv[0] = 1;
  Object sum9478 = callmethod(call9477, "+", 1, partcv, params);
// compiled op node returning sum9478 (depth = 7)
  int op_slot_left_9469 = gc_frame_newslot(sum9478);
  params[0] = num9470;
  partcv[0] = 1;
  Object diff9479 = callmethod(sum9478, "-", 1, partcv, params);
// compiled op node returning diff9479 (depth = 6)
  gc_frame_newslot(diff9479);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9464;
  params[1] = call9466;
  params[2] = call9468;
  params[3] = diff9479;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9480 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9463);
// compiled call node returning call9480 (depth = 5)
    gc_frame_newslot(call9480);
    if9404 = call9480;
  } else {
  }
// compiled if node returning if9404 (depth = 4)
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9482 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9481);
// compiled call node returning call9482 (depth = 6)
// compiled member node returning call9482 (depth = 5)
  *var_retval = call9482;
  if (call9482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9390 = done;
  } else {
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9484 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9485 == NULL) {
    strlit9485 = alloc_String("done");
    gc_root(strlit9485);
  }
// compiled string node returning strlit9485 (depth = 6)
  gc_frame_newslot(strlit9485);
// starting to compile identifier node (depth = 6)
  Object bool9486 = alloc_Boolean(0);
// compiled identifier node returning bool9486 (depth = 6)
  gc_frame_newslot(bool9486);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9488 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe9487);
// compiled call node returning call9488 (depth = 7)
// compiled member node returning call9488 (depth = 6)
  params[0] = strlit9485;
  params[1] = bool9486;
  partcv[0] = 2;
  Object call9489 = callmethod(call9488, "new",
    1, partcv, params);
  gc_frame_end(callframe9484);
// compiled call node returning call9489 (depth = 5)
  *var_retval = call9489;
  if (call9489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9390 = done;
  }
// compiled if node returning if9390 (depth = 3)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9491 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9492 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call9493 = callmethod(*var_retTok, "line",
    1, partcv, params);
  gc_frame_end(callframe9492);
// compiled call node returning call9493 (depth = 5)
// compiled member node returning call9493 (depth = 4)
  gc_frame_newslot(call9493);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_retTok (depth = 6)
  partcv[0] = 0;
  Object call9495 = callmethod(*var_retTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9494);
// compiled call node returning call9495 (depth = 5)
// compiled member node returning call9495 (depth = 4)
  gc_frame_newslot(call9495);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call9493;
  params[1] = call9495;
  partcv[0] = 2;
  Object call9496 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe9491);
// compiled call node returning call9496 (depth = 3)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9497 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9498 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9499 = callmethod(*var_ast, "returnNode",
    1, partcv, params);
  gc_frame_end(callframe9498);
// compiled call node returning call9499 (depth = 6)
// compiled member node returning call9499 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call9500 = callmethod(call9499, "new",
    1, partcv, params);
  gc_frame_end(callframe9497);
// compiled call node returning call9500 (depth = 4)
  *var_o = call9500;
  if (call9500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9501 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9502 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9501);
// compiled call node returning call9502 (depth = 3)
    gc_frame_newslot(call9502);
    if9384 = call9502;
  } else {
  }
// compiled if node returning if9384 (depth = 2)
  gc_frame_end(frame);
  return if9384;
}
Object meth_parser_domethodtype9503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for domethodtype (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for domethodtype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methodTypeTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "methodTypeTok");
  Object *var_m = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "m");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_dtype = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "dtype");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
  Object *var_newLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "newLine");
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_methodTypeTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9504 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9505 = alloc_Boolean(1);
// compiled identifier node returning bool9505 (depth = 4)
  gc_frame_newslot(bool9505);
// call case 4: self request
  params[0] = bool9505;
  partcv[0] = 1;
  Object call9506 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9504);
// compiled call node returning call9506 (depth = 3)
  *var_m = call9506;
  if (call9506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9507 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call9508 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe9507);
// compiled call node returning call9508 (depth = 4)
// compiled member node returning call9508 (depth = 3)
  *var_meth = call9508;
  if (call9508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call9510 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe9509);
// compiled call node returning call9510 (depth = 4)
// compiled member node returning call9510 (depth = 3)
  *var_signature = call9510;
  if (call9510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call9512 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe9511);
// compiled call node returning call9512 (depth = 4)
// compiled member node returning call9512 (depth = 3)
  *var_dtype = call9512;
  if (call9512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  int op_slot_right_9514 = gc_frame_newslot(*var_dtype);
// starting to compile identifier node (depth = 4)
  Object bool9516 = alloc_Boolean(0);
// compiled identifier node returning bool9516 (depth = 4)
  int op_slot_left_9514 = gc_frame_newslot(bool9516);
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object opresult9517 = callmethod(bool9516, "==", 1, partcv, params);
// compiled op node returning opresult9517 (depth = 3)
  Object if9513 = done;
  if (istrue(opresult9517)) {
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9518 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9519 == NULL) {
    strlit9519 = alloc_String("Done");
    gc_root(strlit9519);
  }
// compiled string node returning strlit9519 (depth = 5)
  gc_frame_newslot(strlit9519);
// starting to compile identifier node (depth = 5)
  Object bool9520 = alloc_Boolean(0);
// compiled identifier node returning bool9520 (depth = 5)
  gc_frame_newslot(bool9520);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9522 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe9521);
// compiled call node returning call9522 (depth = 6)
// compiled member node returning call9522 (depth = 5)
  params[0] = strlit9519;
  params[1] = bool9520;
  partcv[0] = 2;
  Object call9523 = callmethod(call9522, "new",
    1, partcv, params);
  gc_frame_end(callframe9518);
// compiled call node returning call9523 (depth = 4)
  *var_dtype = call9523;
  if (call9523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9513 = done;
  } else {
  }
// compiled if node returning if9513 (depth = 2)
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9525 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call9527 = callmethod(*var_methodTypeTok, "line",
    1, partcv, params);
  gc_frame_end(callframe9526);
// compiled call node returning call9527 (depth = 4)
// compiled member node returning call9527 (depth = 3)
  gc_frame_newslot(call9527);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9528 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodTypeTok (depth = 5)
  partcv[0] = 0;
  Object call9529 = callmethod(*var_methodTypeTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9528);
// compiled call node returning call9529 (depth = 4)
// compiled member node returning call9529 (depth = 3)
  gc_frame_newslot(call9529);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call9527;
  params[1] = call9529;
  partcv[0] = 2;
  Object call9530 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe9525);
// compiled call node returning call9530 (depth = 2)
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9531 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9533 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9532);
// compiled call node returning call9533 (depth = 5)
// compiled member node returning call9533 (depth = 4)
  gc_frame_newslot(call9533);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9535 = callmethod(*var_ast, "methodTypeNode",
    1, partcv, params);
  gc_frame_end(callframe9534);
// compiled call node returning call9535 (depth = 5)
// compiled member node returning call9535 (depth = 4)
  params[0] = call9533;
  params[1] = *var_signature;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call9536 = callmethod(call9535, "new",
    1, partcv, params);
  gc_frame_end(callframe9531);
// compiled call node returning call9536 (depth = 3)
  *var_o = call9536;
  if (call9536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2988
  setline(2988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9537 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call9539 = callmethod(*var_m, "typeParams",
    1, partcv, params);
  gc_frame_end(callframe9538);
// compiled call node returning call9539 (depth = 4)
// compiled member node returning call9539 (depth = 3)
  gc_frame_newslot(call9539);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  params[0] = call9539;
  partcv[0] = 1;
  Object call9540 = callmethod(*var_o, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe9537);
// compiled call node returning call9540 (depth = 2)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9541 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call9542 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9541);
// compiled call node returning call9542 (depth = 2)
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9544 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9543);
// compiled call node returning call9544 (depth = 3)
// compiled member node returning call9544 (depth = 2)
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9546 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9547 == NULL) {
    strlit9547 = alloc_String("semicolon");
    gc_root(strlit9547);
  }
// compiled string node returning strlit9547 (depth = 4)
  gc_frame_newslot(strlit9547);
// call case 4: self request
  params[0] = strlit9547;
  partcv[0] = 1;
  Object call9548 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9546);
// compiled call node returning call9548 (depth = 3)
  Object if9545 = done;
  if (istrue(call9548)) {
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9549 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9550 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9549);
// compiled call node returning call9550 (depth = 4)
// compiled member node returning call9550 (depth = 3)
    gc_frame_newslot(call9550);
    if9545 = call9550;
  } else {
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9552 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9553 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9554 == NULL) {
    strlit9554 = alloc_String("rbrace");
    gc_root(strlit9554);
  }
// compiled string node returning strlit9554 (depth = 6)
  gc_frame_newslot(strlit9554);
// call case 4: self request
  params[0] = strlit9554;
  partcv[0] = 1;
  Object call9555 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9553);
// compiled call node returning call9555 (depth = 5)
  partcv[0] = 0;
  Object call9556 = callmethod(call9555, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9552);
// compiled call node returning call9556 (depth = 4)
  Object if9551 = done;
  if (istrue(call9556)) {
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9560 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9559);
// compiled call node returning call9560 (depth = 7)
// compiled member node returning call9560 (depth = 6)
  int op_slot_right_9558 = gc_frame_newslot(call9560);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9563 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9562);
// compiled call node returning call9563 (depth = 7)
// compiled member node returning call9563 (depth = 6)
  int op_slot_left_9558 = gc_frame_newslot(call9563);
  params[0] = call9560;
  partcv[0] = 1;
  Object opresult9564 = callmethod(call9563, "==", 1, partcv, params);
// compiled op node returning opresult9564 (depth = 5)
  Object if9557 = done;
  if (istrue(opresult9564)) {
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9565 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9566 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9567 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9566);
// compiled call node returning call9567 (depth = 9)
// compiled member node returning call9567 (depth = 8)
  partcv[0] = 0;
  Object call9568 = callmethod(call9567, "new",
    1, partcv, params);
  gc_frame_end(callframe9565);
// compiled call node returning call9568 (depth = 7)
// compiled member node returning call9568 (depth = 6)
  *var_suggestion = call9568;
  if (call9568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9571 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9570);
// compiled call node returning call9571 (depth = 8)
// compiled member node returning call9571 (depth = 7)
  int op_slot_right_9569 = gc_frame_newslot(call9571);
// starting to compile call node (depth = 7)
  int callframe9573 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num9574 = alloc_Float64(1);
// compiled num node returning num9574 (depth = 8)
  gc_frame_newslot(num9574);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num9576 = alloc_Float64(1);
// compiled num node returning num9576 (depth = 9)
  int op_slot_right_9575 = gc_frame_newslot(num9576);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9578 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9579 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9578);
// compiled call node returning call9579 (depth = 10)
// compiled member node returning call9579 (depth = 9)
  int op_slot_left_9575 = gc_frame_newslot(call9579);
  params[0] = num9576;
  partcv[0] = 1;
  Object diff9580 = callmethod(call9579, "-", 1, partcv, params);
// compiled op node returning diff9580 (depth = 8)
  gc_frame_newslot(diff9580);
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe9581 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9583 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9582);
// compiled call node returning call9583 (depth = 10)
// compiled member node returning call9583 (depth = 9)
  gc_frame_newslot(call9583);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9584 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call9585 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe9584);
// compiled call node returning call9585 (depth = 10)
// compiled member node returning call9585 (depth = 9)
  params[0] = call9583;
  partcv[0] = 1;
  Object call9586 = callmethod(call9585, "at",
    1, partcv, params);
  gc_frame_end(callframe9581);
// compiled call node returning call9586 (depth = 8)
  params[0] = num9574;
  params[1] = diff9580;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9587 = callmethod(call9586, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe9573);
// compiled call node returning call9587 (depth = 7)
  int op_slot_left_9569 = gc_frame_newslot(call9587);
  params[0] = call9571;
  partcv[0] = 1;
  Object opresult9588 = callmethod(call9587, "++", 1, partcv, params);
// compiled op node returning opresult9588 (depth = 6)
  *var_newLine = opresult9588;
  if (opresult9588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9589 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9591 = alloc_Float64(0.1);
// compiled num node returning num9591 (depth = 7)
  int op_slot_right_9590 = gc_frame_newslot(num9591);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9593 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9594 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9593);
// compiled call node returning call9594 (depth = 8)
// compiled member node returning call9594 (depth = 7)
  int op_slot_left_9590 = gc_frame_newslot(call9594);
  params[0] = num9591;
  partcv[0] = 1;
  Object sum9595 = callmethod(call9594, "+", 1, partcv, params);
// compiled op node returning sum9595 (depth = 6)
  gc_frame_newslot(sum9595);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum9595;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call9596 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe9589);
// compiled call node returning call9596 (depth = 5)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9597 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool9598 = alloc_Boolean(1);
// compiled identifier node returning bool9598 (depth = 6)
  gc_frame_newslot(bool9598);
// starting to compile identifier node (depth = 6)
  Object bool9599 = alloc_Boolean(1);
// compiled identifier node returning bool9599 (depth = 6)
  gc_frame_newslot(bool9599);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool9598;
  params[2] = bool9599;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9600 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9597);
// compiled call node returning call9600 (depth = 5)
// Begin line 3000
  setline(3000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9601 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9602 == NULL) {
    strlit9602 = alloc_String("methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit9602);
  }
// compiled string node returning strlit9602 (depth = 6)
  gc_frame_newslot(strlit9602);
// Begin line 3001
  setline(3001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9603 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9604 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9603);
// compiled call node returning call9604 (depth = 7)
// compiled member node returning call9604 (depth = 6)
  gc_frame_newslot(call9604);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9606 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9605);
// compiled call node returning call9606 (depth = 7)
// compiled member node returning call9606 (depth = 6)
  gc_frame_newslot(call9606);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3000
  setline(3000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9602;
  params[1] = call9604;
  params[2] = call9606;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9607 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9601);
// compiled call node returning call9607 (depth = 5)
    gc_frame_newslot(call9607);
    if9557 = call9607;
  } else {
  }
// compiled if node returning if9557 (depth = 4)
    gc_frame_newslot(if9557);
    if9551 = if9557;
  } else {
  }
// compiled if node returning if9551 (depth = 3)
    gc_frame_newslot(if9551);
    if9545 = if9551;
  }
// compiled if node returning if9545 (depth = 2)
  gc_frame_end(frame);
  return if9545;
}
Object meth_parser__apply9650(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9651 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe9652 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9653 == NULL) {
    strlit9653 = alloc_String("rbrace");
    gc_root(strlit9653);
  }
// compiled string node returning strlit9653 (depth = 8)
  gc_frame_newslot(strlit9653);
// call case 4: self request
  params[0] = strlit9653;
  partcv[0] = 1;
  Object call9654 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9652);
// compiled call node returning call9654 (depth = 7)
  partcv[0] = 0;
  Object call9655 = callmethod(call9654, "not",
    1, partcv, params);
  gc_frame_end(callframe9651);
// compiled call node returning call9655 (depth = 6)
// compiled member node returning call9655 (depth = 5)
  gc_frame_end(frame);
  return call9655;
}
Object meth_parser__apply9658(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_types = getfromclosure(closure, 1);
  Object *var_meths = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9660 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9661 == NULL) {
    strlit9661 = alloc_String("type");
    gc_root(strlit9661);
  }
// compiled string node returning strlit9661 (depth = 7)
  gc_frame_newslot(strlit9661);
// call case 4: self request
  params[0] = strlit9661;
  partcv[0] = 1;
  Object call9662 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9660);
// compiled call node returning call9662 (depth = 6)
  Object if9659 = done;
  if (istrue(call9662)) {
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9664 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9663);
// compiled call node returning call9664 (depth = 7)
// compiled member node returning call9664 (depth = 6)
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9665 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9667 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9666);
// compiled call node returning call9667 (depth = 8)
// compiled member node returning call9667 (depth = 7)
  gc_frame_newslot(call9667);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call9667;
  partcv[0] = 1;
  Object call9668 = callmethod(*var_types, "push",
    1, partcv, params);
  gc_frame_end(callframe9665);
// compiled call node returning call9668 (depth = 6)
    gc_frame_newslot(call9668);
    if9659 = call9668;
  } else {
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9670 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9669);
// compiled call node returning call9670 (depth = 7)
// compiled member node returning call9670 (depth = 6)
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9671 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9673 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9672);
// compiled call node returning call9673 (depth = 8)
// compiled member node returning call9673 (depth = 7)
  gc_frame_newslot(call9673);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call9673;
  partcv[0] = 1;
  Object call9674 = callmethod(*var_meths, "push",
    1, partcv, params);
  gc_frame_end(callframe9671);
// compiled call node returning call9674 (depth = 6)
    gc_frame_newslot(call9674);
    if9659 = call9674;
  }
// compiled if node returning if9659 (depth = 5)
  gc_frame_end(frame);
  return if9659;
}
Object meth_parser_dotypeLiteral9608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dotypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dotypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_typeLiteralTok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "typeLiteralTok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meths = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meths");
  Object *var_types = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "types");
  Object *var_mc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mc");
  Object *var_t = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "t");
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_typeLiteralTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9610 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9611 == NULL) {
    strlit9611 = alloc_String("type");
    gc_root(strlit9611);
  }
// compiled string node returning strlit9611 (depth = 4)
  gc_frame_newslot(strlit9611);
// call case 4: self request
  params[0] = strlit9611;
  partcv[0] = 1;
  Object call9612 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9610);
// compiled call node returning call9612 (depth = 3)
  Object if9609 = done;
  if (istrue(call9612)) {
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9613 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9614 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9613);
// compiled call node returning call9614 (depth = 4)
// compiled member node returning call9614 (depth = 3)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9616 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9617 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9618 == NULL) {
    strlit9618 = alloc_String("lbrace");
    gc_root(strlit9618);
  }
// compiled string node returning strlit9618 (depth = 6)
  gc_frame_newslot(strlit9618);
// call case 4: self request
  params[0] = strlit9618;
  partcv[0] = 1;
  Object call9619 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9617);
// compiled call node returning call9619 (depth = 5)
  partcv[0] = 0;
  Object call9620 = callmethod(call9619, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9616);
// compiled call node returning call9620 (depth = 4)
  Object if9615 = done;
  if (istrue(call9620)) {
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9621 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9623 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9622);
// compiled call node returning call9623 (depth = 8)
// compiled member node returning call9623 (depth = 7)
  partcv[0] = 0;
  Object call9624 = callmethod(call9623, "new",
    1, partcv, params);
  gc_frame_end(callframe9621);
// compiled call node returning call9624 (depth = 6)
// compiled member node returning call9624 (depth = 5)
  *var_suggestion = call9624;
  if (call9624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9625 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit9626 == NULL) {
    strlit9626 = alloc_String("{");
    gc_root(strlit9626);
  }
// compiled string node returning strlit9626 (depth = 5)
  gc_frame_newslot(strlit9626);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit9626;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9627 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9625);
// compiled call node returning call9627 (depth = 4)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9628 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9629 == NULL) {
    strlit9629 = alloc_String("type literals must open with a brace.");
    gc_root(strlit9629);
  }
// compiled string node returning strlit9629 (depth = 5)
  gc_frame_newslot(strlit9629);
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9631 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9630);
// compiled call node returning call9631 (depth = 6)
// compiled member node returning call9631 (depth = 5)
  gc_frame_newslot(call9631);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9633 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9632);
// compiled call node returning call9633 (depth = 6)
// compiled member node returning call9633 (depth = 5)
  gc_frame_newslot(call9633);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9629;
  params[1] = call9631;
  params[2] = call9633;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9634 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9628);
// compiled call node returning call9634 (depth = 4)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if9615 = undefined;
  } else {
  }
// compiled if node returning if9615 (depth = 3)
    gc_frame_newslot(if9615);
    if9609 = if9615;
  } else {
  }
// compiled if node returning if9609 (depth = 2)
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9636 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9637 == NULL) {
    strlit9637 = alloc_String("lbrace");
    gc_root(strlit9637);
  }
// compiled string node returning strlit9637 (depth = 4)
  gc_frame_newslot(strlit9637);
// call case 4: self request
  params[0] = strlit9637;
  partcv[0] = 1;
  Object call9638 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9636);
// compiled call node returning call9638 (depth = 3)
  Object if9635 = done;
  if (istrue(call9638)) {
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array9639 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9639 (depth = 4)
  *var_meths = array9639;
  if (array9639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile array node (depth = 4)
  Object array9640 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9640 (depth = 4)
  *var_types = array9640;
  if (array9640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num9642 = alloc_Float64(1);
// compiled num node returning num9642 (depth = 5)
  int op_slot_right_9641 = gc_frame_newslot(num9642);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_9641 = gc_frame_newslot(*var_auto_count);
  params[0] = num9642;
  partcv[0] = 1;
  Object sum9644 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum9644 (depth = 4)
  *var_auto_count = sum9644;
  if (sum9644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9646 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9647 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9646);
// compiled call node returning call9647 (depth = 4)
// compiled member node returning call9647 (depth = 3)
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9648 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9649 = alloc_Block(NULL, NULL, "parser", 3026);
  gc_frame_newslot(block9649);
// method "_apply"
  block_savedest(block9649);
  Object closure9650 = createclosure(1, "_apply");
  setclosureframe(closure9650, stackframe);
  addtoclosure(closure9650, selfslot);
  struct UserObject *uo9650 = (struct UserObject*)block9649;
  uo9650->data[0] = (Object)closure9650;
  Method *meth_meth_parser__apply9650 = addmethod2pos(block9649, "_apply", &meth_parser__apply9650, 0);
  int argcv_meth_parser__apply9650[] = {0};
  meth_meth_parser__apply9650->type = alloc_MethodType(1, argcv_meth_parser__apply9650);
  meth_meth_parser__apply9650->definitionModule = modulename;
  meth_meth_parser__apply9650->definitionLine = 3025;
// compiled block node returning block9649 (depth = 4)
  gc_frame_newslot(block9649);
// starting to compile block node (depth = 4)
  Object block9657 = alloc_Block(NULL, NULL, "parser", 3026);
  gc_frame_newslot(block9657);
// method "_apply"
  block_savedest(block9657);
  Object closure9658 = createclosure(4, "_apply");
  setclosureframe(closure9658, stackframe);
  addtoclosure(closure9658, var_values);
  addtoclosure(closure9658, var_types);
  addtoclosure(closure9658, var_meths);
  addtoclosure(closure9658, selfslot);
  struct UserObject *uo9658 = (struct UserObject*)block9657;
  uo9658->data[0] = (Object)closure9658;
  Method *meth_meth_parser__apply9658 = addmethod2pos(block9657, "_apply", &meth_parser__apply9658, 0);
  int argcv_meth_parser__apply9658[] = {0};
  meth_meth_parser__apply9658->type = alloc_MethodType(1, argcv_meth_parser__apply9658);
  meth_meth_parser__apply9658->definitionModule = modulename;
  meth_meth_parser__apply9658->definitionLine = 3026;
// compiled block node returning block9657 (depth = 4)
  gc_frame_newslot(block9657);
// call case 5: prelude request
  params[0] = block9649;
  params[1] = block9657;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9676 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9648);
// compiled call node returning call9676 (depth = 3)
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9678 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9677);
// compiled call node returning call9678 (depth = 4)
// compiled member node returning call9678 (depth = 3)
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9679 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call9681 = callmethod(*var_typeLiteralTok, "line",
    1, partcv, params);
  gc_frame_end(callframe9680);
// compiled call node returning call9681 (depth = 5)
// compiled member node returning call9681 (depth = 4)
  gc_frame_newslot(call9681);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralTok (depth = 6)
  partcv[0] = 0;
  Object call9683 = callmethod(*var_typeLiteralTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9682);
// compiled call node returning call9683 (depth = 5)
// compiled member node returning call9683 (depth = 4)
  gc_frame_newslot(call9683);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call9681;
  params[1] = call9683;
  partcv[0] = 2;
  Object call9684 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe9679);
// compiled call node returning call9684 (depth = 3)
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9685 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9687 = callmethod(*var_ast, "typeLiteralNode",
    1, partcv, params);
  gc_frame_end(callframe9686);
// compiled call node returning call9687 (depth = 6)
// compiled member node returning call9687 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call9688 = callmethod(call9687, "new",
    1, partcv, params);
  gc_frame_end(callframe9685);
// compiled call node returning call9688 (depth = 4)
  *var_t = call9688;
  if (call9688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9689 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call9690 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9689);
// compiled call node returning call9690 (depth = 3)
    gc_frame_newslot(call9690);
    if9635 = call9690;
  } else {
  }
// compiled if node returning if9635 (depth = 2)
  gc_frame_end(frame);
  return if9635;
}
Object meth_parser__apply9780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9782 == NULL) {
    strlit9782 = alloc_String("lbrace");
    gc_root(strlit9782);
  }
// compiled string node returning strlit9782 (depth = 8)
  int op_slot_right_9781 = gc_frame_newslot(strlit9782);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call9785 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9784);
// compiled call node returning call9785 (depth = 9)
// compiled member node returning call9785 (depth = 8)
  int op_slot_left_9781 = gc_frame_newslot(call9785);
  params[0] = strlit9782;
  partcv[0] = 1;
  Object opresult9786 = callmethod(call9785, "==", 1, partcv, params);
// compiled op node returning opresult9786 (depth = 7)
  gc_frame_end(frame);
  return opresult9786;
}
Object meth_parser__apply9792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_9793 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_9793 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult9795 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult9795 (depth = 7)
  gc_frame_end(frame);
  return opresult9795;
}
Object meth_parser_typedec9691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_noBlocks = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for typedec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for typedec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nt");
  Object *var_anns = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "anns");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9693 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9694 == NULL) {
    strlit9694 = alloc_String("type");
    gc_root(strlit9694);
  }
// compiled string node returning strlit9694 (depth = 4)
  gc_frame_newslot(strlit9694);
// call case 4: self request
  params[0] = strlit9694;
  partcv[0] = 1;
  Object call9695 = callmethodflags(self, "acceptKeyword", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9693);
// compiled call node returning call9695 (depth = 3)
  Object if9692 = done;
  if (istrue(call9695)) {
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9697 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9696);
// compiled call node returning call9697 (depth = 5)
// compiled member node returning call9697 (depth = 4)
  *var_line = call9697;
  if (call9697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call9699 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9698);
// compiled call node returning call9699 (depth = 5)
// compiled member node returning call9699 (depth = 4)
  *var_pos = call9699;
  if (call9699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3047
  setline(3047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9701 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9700);
// compiled call node returning call9701 (depth = 4)
// compiled member node returning call9701 (depth = 3)
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9704 == NULL) {
    strlit9704 = alloc_String("identifier");
    gc_root(strlit9704);
  }
// compiled string node returning strlit9704 (depth = 5)
  int op_slot_right_9703 = gc_frame_newslot(strlit9704);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9707 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9706);
// compiled call node returning call9707 (depth = 6)
// compiled member node returning call9707 (depth = 5)
  int op_slot_left_9703 = gc_frame_newslot(call9707);
  params[0] = strlit9704;
  partcv[0] = 1;
  Object opresult9708 = callmethod(call9707, "≠", 1, partcv, params);
// compiled op node returning opresult9708 (depth = 4)
  Object if9702 = done;
  if (istrue(opresult9708)) {
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9709 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9711 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9710);
// compiled call node returning call9711 (depth = 8)
// compiled member node returning call9711 (depth = 7)
  partcv[0] = 0;
  Object call9712 = callmethod(call9711, "new",
    1, partcv, params);
  gc_frame_end(callframe9709);
// compiled call node returning call9712 (depth = 6)
// compiled member node returning call9712 (depth = 5)
  *var_suggestion = call9712;
  if (call9712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9713 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9714 == NULL) {
    strlit9714 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit9714);
  }
// compiled string node returning strlit9714 (depth = 5)
  gc_frame_newslot(strlit9714);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit9714;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9715 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9713);
// compiled call node returning call9715 (depth = 4)
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9716 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9717 == NULL) {
    strlit9717 = alloc_String("a type declaration must have a name after the 'type'.");
    gc_root(strlit9717);
  }
// compiled string node returning strlit9717 (depth = 5)
  gc_frame_newslot(strlit9717);
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9719 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9718);
// compiled call node returning call9719 (depth = 6)
// compiled member node returning call9719 (depth = 5)
  gc_frame_newslot(call9719);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9721 = alloc_Float64(1);
// compiled num node returning num9721 (depth = 6)
  int op_slot_right_9720 = gc_frame_newslot(num9721);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9725 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9724);
// compiled call node returning call9725 (depth = 8)
// compiled member node returning call9725 (depth = 7)
  int op_slot_right_9723 = gc_frame_newslot(call9725);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9728 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9727);
// compiled call node returning call9728 (depth = 8)
// compiled member node returning call9728 (depth = 7)
  int op_slot_left_9723 = gc_frame_newslot(call9728);
  params[0] = call9725;
  partcv[0] = 1;
  Object sum9729 = callmethod(call9728, "+", 1, partcv, params);
// compiled op node returning sum9729 (depth = 6)
  int op_slot_left_9720 = gc_frame_newslot(sum9729);
  params[0] = num9721;
  partcv[0] = 1;
  Object sum9730 = callmethod(sum9729, "+", 1, partcv, params);
// compiled op node returning sum9730 (depth = 5)
  gc_frame_newslot(sum9730);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3051
  setline(3051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9717;
  params[1] = call9719;
  params[2] = sum9730;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9731 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9716);
// compiled call node returning call9731 (depth = 4)
    gc_frame_newslot(call9731);
    if9702 = call9731;
  } else {
  }
// compiled if node returning if9702 (depth = 3)
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9733 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9732);
// compiled call node returning call9733 (depth = 4)
// compiled member node returning call9733 (depth = 3)
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9734 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_line;
  params[1] = *var_pos;
  partcv[0] = 2;
  Object call9735 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe9734);
// compiled call node returning call9735 (depth = 3)
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9736 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9738 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9737);
// compiled call node returning call9738 (depth = 6)
// compiled member node returning call9738 (depth = 5)
  gc_frame_newslot(call9738);
// starting to compile identifier node (depth = 5)
  Object bool9739 = alloc_Boolean(0);
// compiled identifier node returning bool9739 (depth = 5)
  gc_frame_newslot(bool9739);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call9741 = callmethod(*var_ast, "typeDecNode",
    1, partcv, params);
  gc_frame_end(callframe9740);
// compiled call node returning call9741 (depth = 6)
// compiled member node returning call9741 (depth = 5)
  params[0] = call9738;
  params[1] = bool9739;
  partcv[0] = 2;
  Object call9742 = callmethod(call9741, "new",
    1, partcv, params);
  gc_frame_end(callframe9736);
// compiled call node returning call9742 (depth = 4)
  *var_nt = call9742;
  if (call9742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9744 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9745 == NULL) {
    strlit9745 = alloc_String("lgeneric");
    gc_root(strlit9745);
  }
// compiled string node returning strlit9745 (depth = 5)
  gc_frame_newslot(strlit9745);
// call case 4: self request
  params[0] = strlit9745;
  partcv[0] = 1;
  Object call9746 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9744);
// compiled call node returning call9746 (depth = 4)
  Object if9743 = done;
  if (istrue(call9746)) {
// starting to compile call node (depth = 4)
  int callframe9747 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9749 = callmethodflags(self, "typeparameters", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9748);
// compiled call node returning call9749 (depth = 6)
// compiled member node returning call9749 (depth = 5)
  gc_frame_newslot(call9749);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = call9749;
  partcv[0] = 1;
  Object call9750 = callmethod(*var_nt, "typeParams:=",
    1, partcv, params);
  gc_frame_end(callframe9747);
// compiled call node returning call9750 (depth = 4)
    gc_frame_newslot(call9750);
    if9743 = call9750;
  } else {
  }
// compiled if node returning if9743 (depth = 3)
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9751 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool9752 = alloc_Boolean(1);
// compiled identifier node returning bool9752 (depth = 4)
  gc_frame_newslot(bool9752);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nt (depth = 6)
  partcv[0] = 0;
  Object call9754 = callmethod(*var_nt, "name",
    1, partcv, params);
  gc_frame_end(callframe9753);
// compiled call node returning call9754 (depth = 5)
// compiled member node returning call9754 (depth = 4)
  params[0] = bool9752;
  partcv[0] = 1;
  Object call9755 = callmethod(call9754, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9751);
// compiled call node returning call9755 (depth = 3)
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9756 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9757 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9756);
// compiled call node returning call9757 (depth = 5)
// compiled member node returning call9757 (depth = 4)
  *var_anns = call9757;
  if (call9757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9761 == NULL) {
    strlit9761 = alloc_String("=");
    gc_root(strlit9761);
  }
// compiled string node returning strlit9761 (depth = 6)
  int op_slot_right_9760 = gc_frame_newslot(strlit9761);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9764 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compiled call node returning call9764 (depth = 7)
// compiled member node returning call9764 (depth = 6)
  int op_slot_left_9760 = gc_frame_newslot(call9764);
  params[0] = strlit9761;
  partcv[0] = 1;
  Object opresult9765 = callmethod(call9764, "≠", 1, partcv, params);
// compiled op node returning opresult9765 (depth = 5)
  int op_slot_right_9759 = gc_frame_newslot(opresult9765);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9768 == NULL) {
    strlit9768 = alloc_String("op");
    gc_root(strlit9768);
  }
// compiled string node returning strlit9768 (depth = 6)
  int op_slot_right_9767 = gc_frame_newslot(strlit9768);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9771 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9770);
// compiled call node returning call9771 (depth = 7)
// compiled member node returning call9771 (depth = 6)
  int op_slot_left_9767 = gc_frame_newslot(call9771);
  params[0] = strlit9768;
  partcv[0] = 1;
  Object opresult9772 = callmethod(call9771, "≠", 1, partcv, params);
// compiled op node returning opresult9772 (depth = 5)
  int op_slot_left_9759 = gc_frame_newslot(opresult9772);
  params[0] = opresult9765;
  partcv[0] = 1;
  Object opresult9773 = callmethod(opresult9772, "||", 1, partcv, params);
// compiled op node returning opresult9773 (depth = 4)
  Object if9758 = done;
  if (istrue(opresult9773)) {
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9774 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9776 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9775);
// compiled call node returning call9776 (depth = 8)
// compiled member node returning call9776 (depth = 7)
  partcv[0] = 0;
  Object call9777 = callmethod(call9776, "new",
    1, partcv, params);
  gc_frame_end(callframe9774);
// compiled call node returning call9777 (depth = 6)
// compiled member node returning call9777 (depth = 5)
  *var_suggestion = call9777;
  if (call9777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9778 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9779 = alloc_Block(NULL, NULL, "parser", 3062);
  gc_frame_newslot(block9779);
// method "_apply"
  block_savedest(block9779);
  Object closure9780 = createclosure(1, "_apply");
  setclosureframe(closure9780, stackframe);
  addtoclosure(closure9780, selfslot);
  struct UserObject *uo9780 = (struct UserObject*)block9779;
  uo9780->data[0] = (Object)closure9780;
  Method *meth_meth_parser__apply9780 = addmethod2pos(block9779, "_apply", &meth_parser__apply9780, 0);
  int argcv_meth_parser__apply9780[] = {1};
  meth_meth_parser__apply9780->type = alloc_MethodType(1, argcv_meth_parser__apply9780);
  meth_meth_parser__apply9780->definitionModule = modulename;
  meth_meth_parser__apply9780->definitionLine = 3061;
// compiled block node returning block9779 (depth = 6)
  gc_frame_newslot(block9779);
// call case 4: self request
  params[0] = block9779;
  partcv[0] = 1;
  Object call9788 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9778);
// compiled call node returning call9788 (depth = 5)
  *var_nextTok = call9788;
  if (call9788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block9791 = alloc_Block(NULL, NULL, "parser", 3063);
  gc_frame_newslot(block9791);
// method "_apply"
  block_savedest(block9791);
  Object closure9792 = createclosure(3, "_apply");
  setclosureframe(closure9792, stackframe);
  addtoclosure(closure9792, var_sym);
  addtoclosure(closure9792, var_nextTok);
  addtoclosure(closure9792, selfslot);
  struct UserObject *uo9792 = (struct UserObject*)block9791;
  uo9792->data[0] = (Object)closure9792;
  Method *meth_meth_parser__apply9792 = addmethod2pos(block9791, "_apply", &meth_parser__apply9792, 0);
  int argcv_meth_parser__apply9792[] = {0};
  meth_meth_parser__apply9792->type = alloc_MethodType(1, argcv_meth_parser__apply9792);
  meth_meth_parser__apply9792->definitionModule = modulename;
  meth_meth_parser__apply9792->definitionLine = 3062;
// compiled block node returning block9791 (depth = 6)
  int op_slot_right_9790 = gc_frame_newslot(block9791);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_right_9798 = gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 7)
  Object bool9800 = alloc_Boolean(0);
// compiled identifier node returning bool9800 (depth = 7)
  int op_slot_left_9798 = gc_frame_newslot(bool9800);
  params[0] = *var_nextTok;
  partcv[0] = 1;
  Object opresult9801 = callmethod(bool9800, "==", 1, partcv, params);
// compiled op node returning opresult9801 (depth = 6)
  int op_slot_left_9790 = gc_frame_newslot(opresult9801);
  params[0] = block9791;
  partcv[0] = 1;
  Object opresult9802 = callmethod(opresult9801, "||", 1, partcv, params);
// compiled op node returning opresult9802 (depth = 5)
  Object if9789 = done;
  if (istrue(opresult9802)) {
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9803 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9804 == NULL) {
    strlit9804 = alloc_String(" =");
    gc_root(strlit9804);
  }
// compiled string node returning strlit9804 (depth = 6)
  gc_frame_newslot(strlit9804);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9804;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9805 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9803);
// compiled call node returning call9805 (depth = 5)
    gc_frame_newslot(call9805);
    if9789 = call9805;
  } else {
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9806 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call9808 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9807);
// compiled call node returning call9808 (depth = 7)
// compiled member node returning call9808 (depth = 6)
  gc_frame_newslot(call9808);
// starting to compile string node (depth = 6)
  if (strlit9809 == NULL) {
    strlit9809 = alloc_String("=");
    gc_root(strlit9809);
  }
// compiled string node returning strlit9809 (depth = 6)
  gc_frame_newslot(strlit9809);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call9808;
  params[2] = strlit9809;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9810 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9806);
// compiled call node returning call9810 (depth = 5)
    gc_frame_newslot(call9810);
    if9789 = call9810;
  }
// compiled if node returning if9789 (depth = 4)
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9811 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9812 == NULL) {
    strlit9812 = alloc_String("a type declaration must have an '=' after the type name.");
    gc_root(strlit9812);
  }
// compiled string node returning strlit9812 (depth = 5)
  gc_frame_newslot(strlit9812);
// Begin line 3069
  setline(3069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9814 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9813);
// compiled call node returning call9814 (depth = 6)
// compiled member node returning call9814 (depth = 5)
  gc_frame_newslot(call9814);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9816 = alloc_Float64(1);
// compiled num node returning num9816 (depth = 6)
  int op_slot_right_9815 = gc_frame_newslot(num9816);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9820 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9819);
// compiled call node returning call9820 (depth = 8)
// compiled member node returning call9820 (depth = 7)
  int op_slot_right_9818 = gc_frame_newslot(call9820);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9823 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9822);
// compiled call node returning call9823 (depth = 8)
// compiled member node returning call9823 (depth = 7)
  int op_slot_left_9818 = gc_frame_newslot(call9823);
  params[0] = call9820;
  partcv[0] = 1;
  Object sum9824 = callmethod(call9823, "+", 1, partcv, params);
// compiled op node returning sum9824 (depth = 6)
  int op_slot_left_9815 = gc_frame_newslot(sum9824);
  params[0] = num9816;
  partcv[0] = 1;
  Object sum9825 = callmethod(sum9824, "+", 1, partcv, params);
// compiled op node returning sum9825 (depth = 5)
  gc_frame_newslot(sum9825);
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9812;
  params[1] = call9814;
  params[2] = sum9825;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9826 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9811);
// compiled call node returning call9826 (depth = 4)
    gc_frame_newslot(call9826);
    if9758 = call9826;
  } else {
  }
// compiled if node returning if9758 (depth = 3)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9828 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9827);
// compiled call node returning call9828 (depth = 4)
// compiled member node returning call9828 (depth = 3)
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9830 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9831 == NULL) {
    strlit9831 = alloc_String("lbrace");
    gc_root(strlit9831);
  }
// compiled string node returning strlit9831 (depth = 5)
  gc_frame_newslot(strlit9831);
// call case 4: self request
  params[0] = strlit9831;
  partcv[0] = 1;
  Object call9832 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9830);
// compiled call node returning call9832 (depth = 4)
  Object if9829 = done;
  if (istrue(call9832)) {
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9834 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9833);
// compiled call node returning call9834 (depth = 5)
// compiled member node returning call9834 (depth = 4)
    gc_frame_newslot(call9834);
    if9829 = call9834;
  } else {
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9835 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call9836 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9835);
// compiled call node returning call9836 (depth = 4)
    gc_frame_newslot(call9836);
    if9829 = call9836;
  }
// compiled if node returning if9829 (depth = 3)
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9837 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9839 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9838);
// compiled call node returning call9839 (depth = 5)
// compiled member node returning call9839 (depth = 4)
  gc_frame_newslot(call9839);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  params[0] = call9839;
  partcv[0] = 1;
  Object call9840 = callmethod(*var_nt, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9837);
// compiled call node returning call9840 (depth = 3)
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_9842 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool9844 = alloc_Boolean(0);
// compiled identifier node returning bool9844 (depth = 5)
  int op_slot_left_9842 = gc_frame_newslot(bool9844);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult9845 = callmethod(bool9844, "≠", 1, partcv, params);
// compiled op node returning opresult9845 (depth = 4)
  Object if9841 = done;
  if (istrue(opresult9845)) {
// Begin line 3081
  setline(3081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9846 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nt (depth = 7)
  partcv[0] = 0;
  Object call9848 = callmethod(*var_nt, "annotations",
    1, partcv, params);
  gc_frame_end(callframe9847);
// compiled call node returning call9848 (depth = 6)
// compiled member node returning call9848 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call9849 = callmethod(call9848, "addAll",
    1, partcv, params);
  gc_frame_end(callframe9846);
// compiled call node returning call9849 (depth = 4)
    gc_frame_newslot(call9849);
    if9841 = call9849;
  } else {
  }
// compiled if node returning if9841 (depth = 3)
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9850 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call9851 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe9850);
// compiled call node returning call9851 (depth = 3)
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9852 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9853 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9852);
// compiled call node returning call9853 (depth = 4)
// compiled member node returning call9853 (depth = 3)
    gc_frame_newslot(call9853);
    if9692 = call9853;
  } else {
  }
// compiled if node returning if9692 (depth = 2)
  gc_frame_end(frame);
  return if9692;
}
Object meth_parser__apply9933(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe9934 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit9935 == NULL) {
    strlit9935 = alloc_String(" ");
    gc_root(strlit9935);
  }
// compiled string node returning strlit9935 (depth = 11)
  gc_frame_newslot(strlit9935);
// starting to compile num node (depth = 11)
  Object num9936 = alloc_Float64(1);
// compiled num node returning num9936 (depth = 11)
  gc_frame_newslot(num9936);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call9938 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9937);
// compiled call node returning call9938 (depth = 12)
// compiled member node returning call9938 (depth = 11)
  gc_frame_newslot(call9938);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit9935;
  params[1] = num9936;
  params[2] = call9938;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9939 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe9934);
// compiled call node returning call9939 (depth = 10)
  gc_frame_end(frame);
  return call9939;
}
Object meth_parser__apply9951(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_9953 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call9956 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe9955);
// compiled call node returning call9956 (depth = 13)
// compiled member node returning call9956 (depth = 12)
  int op_slot_left_9953 = gc_frame_newslot(call9956);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9957 = callmethod(call9956, "≥", 1, partcv, params);
// compiled op node returning opresult9957 (depth = 11)
  int op_slot_right_9952 = gc_frame_newslot(opresult9957);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num9961 = alloc_Float64(1);
// compiled num node returning num9961 (depth = 13)
  int op_slot_right_9960 = gc_frame_newslot(num9961);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe9963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call9964 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe9963);
// compiled call node returning call9964 (depth = 14)
// compiled member node returning call9964 (depth = 13)
  int op_slot_left_9960 = gc_frame_newslot(call9964);
  params[0] = num9961;
  partcv[0] = 1;
  Object sum9965 = callmethod(call9964, "+", 1, partcv, params);
// compiled op node returning sum9965 (depth = 12)
  int op_slot_right_9959 = gc_frame_newslot(sum9965);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call9968 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9967);
// compiled call node returning call9968 (depth = 13)
// compiled member node returning call9968 (depth = 12)
  int op_slot_left_9959 = gc_frame_newslot(call9968);
  params[0] = sum9965;
  partcv[0] = 1;
  Object opresult9969 = callmethod(call9968, "≠", 1, partcv, params);
// compiled op node returning opresult9969 (depth = 11)
  int op_slot_left_9952 = gc_frame_newslot(opresult9969);
  params[0] = opresult9957;
  partcv[0] = 1;
  Object opresult9970 = callmethod(opresult9969, "||", 1, partcv, params);
// compiled op node returning opresult9970 (depth = 10)
  gc_frame_end(frame);
  return opresult9970;
}
Object meth_parser__apply9973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call9975 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe9974);
// compiled call node returning call9975 (depth = 12)
// compiled member node returning call9975 (depth = 11)
  *var_tok = call9975;
  if (call9975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply9988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9990 == NULL) {
    strlit9990 = alloc_String(" ");
    gc_root(strlit9990);
  }
// compiled string node returning strlit9990 (depth = 12)
  int op_slot_right_9989 = gc_frame_newslot(strlit9990);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_9989 = gc_frame_newslot(*var_line);
  params[0] = strlit9990;
  partcv[0] = 1;
  Object opresult9992 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult9992 (depth = 11)
  *var_line = opresult9992;
  if (opresult9992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent9854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_lastIndent = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_m1 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "m1");
  Object *var_m2 = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "m2");
  Object *var_m3 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "m3");
  Object *var_m4 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "m4");
  Object *var_m5 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "m5");
  Object *var_msg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "msg");
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if9855 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool9856 = alloc_Boolean(0);
// compiled identifier node returning bool9856 (depth = 4)
  *var_indentFreePass = bool9856;
  if (bool9856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9855 = done;
  } else {
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9860 == NULL) {
    strlit9860 = alloc_String("semicolon");
    gc_root(strlit9860);
  }
// compiled string node returning strlit9860 (depth = 5)
  int op_slot_right_9859 = gc_frame_newslot(strlit9860);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9863 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9862);
// compiled call node returning call9863 (depth = 6)
// compiled member node returning call9863 (depth = 5)
  int op_slot_left_9859 = gc_frame_newslot(call9863);
  params[0] = strlit9860;
  partcv[0] = 1;
  Object opresult9864 = callmethod(call9863, "==", 1, partcv, params);
// compiled op node returning opresult9864 (depth = 4)
  Object if9858 = done;
  if (istrue(opresult9864)) {
    gc_frame_newslot(done);
    if9858 = done;
  } else {
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9868 == NULL) {
    strlit9868 = alloc_String("rsquare");
    gc_root(strlit9868);
  }
// compiled string node returning strlit9868 (depth = 7)
  int op_slot_right_9867 = gc_frame_newslot(strlit9868);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9871 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9870);
// compiled call node returning call9871 (depth = 8)
// compiled member node returning call9871 (depth = 7)
  int op_slot_left_9867 = gc_frame_newslot(call9871);
  params[0] = strlit9868;
  partcv[0] = 1;
  Object opresult9872 = callmethod(call9871, "==", 1, partcv, params);
// compiled op node returning opresult9872 (depth = 6)
  int op_slot_right_9866 = gc_frame_newslot(opresult9872);
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9876 == NULL) {
    strlit9876 = alloc_String("rparen");
    gc_root(strlit9876);
  }
// compiled string node returning strlit9876 (depth = 8)
  int op_slot_right_9875 = gc_frame_newslot(strlit9876);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9879 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9878);
// compiled call node returning call9879 (depth = 9)
// compiled member node returning call9879 (depth = 8)
  int op_slot_left_9875 = gc_frame_newslot(call9879);
  params[0] = strlit9876;
  partcv[0] = 1;
  Object opresult9880 = callmethod(call9879, "==", 1, partcv, params);
// compiled op node returning opresult9880 (depth = 7)
  int op_slot_right_9874 = gc_frame_newslot(opresult9880);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9883 == NULL) {
    strlit9883 = alloc_String("rbrace");
    gc_root(strlit9883);
  }
// compiled string node returning strlit9883 (depth = 8)
  int op_slot_right_9882 = gc_frame_newslot(strlit9883);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9886 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9885);
// compiled call node returning call9886 (depth = 9)
// compiled member node returning call9886 (depth = 8)
  int op_slot_left_9882 = gc_frame_newslot(call9886);
  params[0] = strlit9883;
  partcv[0] = 1;
  Object opresult9887 = callmethod(call9886, "==", 1, partcv, params);
// compiled op node returning opresult9887 (depth = 7)
  int op_slot_left_9874 = gc_frame_newslot(opresult9887);
  params[0] = opresult9880;
  partcv[0] = 1;
  Object opresult9888 = callmethod(opresult9887, "||", 1, partcv, params);
// compiled op node returning opresult9888 (depth = 6)
  int op_slot_left_9866 = gc_frame_newslot(opresult9888);
  params[0] = opresult9872;
  partcv[0] = 1;
  Object opresult9889 = callmethod(opresult9888, "||", 1, partcv, params);
// compiled op node returning opresult9889 (depth = 5)
  Object if9865 = done;
  if (istrue(opresult9889)) {
    gc_frame_newslot(done);
    if9865 = done;
  } else {
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9892 == NULL) {
    strlit9892 = alloc_String("eof");
    gc_root(strlit9892);
  }
// compiled string node returning strlit9892 (depth = 7)
  int op_slot_right_9891 = gc_frame_newslot(strlit9892);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9895 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9894);
// compiled call node returning call9895 (depth = 8)
// compiled member node returning call9895 (depth = 7)
  int op_slot_left_9891 = gc_frame_newslot(call9895);
  params[0] = strlit9892;
  partcv[0] = 1;
  Object opresult9896 = callmethod(call9895, "==", 1, partcv, params);
// compiled op node returning opresult9896 (depth = 6)
  Object if9890 = done;
  if (istrue(opresult9896)) {
    gc_frame_newslot(done);
    if9890 = done;
  } else {
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_9898 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9901 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe9900);
// compiled call node returning call9901 (depth = 9)
// compiled member node returning call9901 (depth = 8)
  int op_slot_left_9898 = gc_frame_newslot(call9901);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9902 = callmethod(call9901, "<", 1, partcv, params);
// compiled op node returning opresult9902 (depth = 7)
  Object if9897 = done;
  if (istrue(opresult9902)) {
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_9904 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9907 = alloc_Float64(1);
// compiled num node returning num9907 (depth = 10)
  int op_slot_right_9906 = gc_frame_newslot(num9907);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9910 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9909);
// compiled call node returning call9910 (depth = 11)
// compiled member node returning call9910 (depth = 10)
  int op_slot_left_9906 = gc_frame_newslot(call9910);
  params[0] = num9907;
  partcv[0] = 1;
  Object diff9911 = callmethod(call9910, "-", 1, partcv, params);
// compiled op node returning diff9911 (depth = 9)
  int op_slot_left_9904 = gc_frame_newslot(diff9911);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult9912 = callmethod(diff9911, "≠", 1, partcv, params);
// compiled op node returning opresult9912 (depth = 8)
  Object if9903 = done;
  if (istrue(opresult9912)) {
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile array node (depth = 9)
  Object array9913 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9913 (depth = 9)
  *var_suggestions = array9913;
  if (array9913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9914 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9916 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9915);
// compiled call node returning call9916 (depth = 12)
// compiled member node returning call9916 (depth = 11)
  partcv[0] = 0;
  Object call9917 = callmethod(call9916, "new",
    1, partcv, params);
  gc_frame_end(callframe9914);
// compiled call node returning call9917 (depth = 10)
// compiled member node returning call9917 (depth = 9)
  *var_suggestion = call9917;
  if (call9917 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9918 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num9922 = alloc_Float64(1);
// compiled num node returning num9922 (depth = 12)
  int op_slot_right_9921 = gc_frame_newslot(num9922);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call9925 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9924);
// compiled call node returning call9925 (depth = 13)
// compiled member node returning call9925 (depth = 12)
  int op_slot_left_9921 = gc_frame_newslot(call9925);
  params[0] = num9922;
  partcv[0] = 1;
  Object diff9926 = callmethod(call9925, "-", 1, partcv, params);
// compiled op node returning diff9926 (depth = 11)
  int op_slot_right_9920 = gc_frame_newslot(diff9926);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_9920 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff9926;
  partcv[0] = 1;
  Object diff9928 = callmethod(*var_minIndentLevel, "-", 1, partcv, params);
// compiled op node returning diff9928 (depth = 10)
  int op_slot_right_9919 = gc_frame_newslot(diff9928);
// starting to compile num node (depth = 10)
  Object num9930 = alloc_Float64(1);
// compiled num node returning num9930 (depth = 10)
  int op_slot_left_9919 = gc_frame_newslot(num9930);
  params[0] = diff9928;
  partcv[0] = 1;
  Object opresult9931 = callmethod(num9930, "..", 1, partcv, params);
// compiled op node returning opresult9931 (depth = 9)
  gc_frame_newslot(opresult9931);
// starting to compile block node (depth = 9)
  Object block9932 = alloc_Block(NULL, NULL, "parser", 3101);
  gc_frame_newslot(block9932);
// method "_apply"
  block_savedest(block9932);
  Object closure9933 = createclosure(3, "_apply");
  setclosureframe(closure9933, stackframe);
  addtoclosure(closure9933, var_sym);
  addtoclosure(closure9933, var_suggestion);
  addtoclosure(closure9933, selfslot);
  struct UserObject *uo9933 = (struct UserObject*)block9932;
  uo9933->data[0] = (Object)closure9933;
  Method *meth_meth_parser__apply9933 = addmethod2pos(block9932, "_apply", &meth_parser__apply9933, 0);
  int argcv_meth_parser__apply9933[] = {1};
  meth_meth_parser__apply9933->type = alloc_MethodType(1, argcv_meth_parser__apply9933);
  meth_meth_parser__apply9933->definitionModule = modulename;
  meth_meth_parser__apply9933->definitionLine = 3101;
// compiled block node returning block9932 (depth = 9)
  gc_frame_newslot(block9932);
// call case 5: prelude request
  params[0] = opresult9931;
  params[1] = block9932;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9941 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9918);
// compiled call node returning call9941 (depth = 8)
// Begin line 3104
  setline(3104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9942 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9943 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9942);
// compiled call node returning call9943 (depth = 8)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9944 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9945 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9946 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9945);
// compiled call node returning call9946 (depth = 12)
// compiled member node returning call9946 (depth = 11)
  partcv[0] = 0;
  Object call9947 = callmethod(call9946, "new",
    1, partcv, params);
  gc_frame_end(callframe9944);
// compiled call node returning call9947 (depth = 10)
// compiled member node returning call9947 (depth = 9)
  *var_suggestion = call9947;
  if (call9947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3108
  setline(3108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9949 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block9950 = alloc_Block(NULL, NULL, "parser", 3108);
  gc_frame_newslot(block9950);
// method "_apply"
  block_savedest(block9950);
  Object closure9951 = createclosure(3, "_apply");
  setclosureframe(closure9951, stackframe);
  addtoclosure(closure9951, var_minIndentLevel);
  addtoclosure(closure9951, var_tok);
  addtoclosure(closure9951, selfslot);
  struct UserObject *uo9951 = (struct UserObject*)block9950;
  uo9951->data[0] = (Object)closure9951;
  Method *meth_meth_parser__apply9951 = addmethod2pos(block9950, "_apply", &meth_parser__apply9951, 0);
  int argcv_meth_parser__apply9951[] = {0};
  meth_meth_parser__apply9951->type = alloc_MethodType(1, argcv_meth_parser__apply9951);
  meth_meth_parser__apply9951->definitionModule = modulename;
  meth_meth_parser__apply9951->definitionLine = 3105;
// compiled block node returning block9950 (depth = 9)
  gc_frame_newslot(block9950);
// starting to compile block node (depth = 9)
  Object block9972 = alloc_Block(NULL, NULL, "parser", 3108);
  gc_frame_newslot(block9972);
// method "_apply"
  block_savedest(block9972);
  Object closure9973 = createclosure(2, "_apply");
  setclosureframe(closure9973, stackframe);
  addtoclosure(closure9973, var_tok);
  addtoclosure(closure9973, selfslot);
  struct UserObject *uo9973 = (struct UserObject*)block9972;
  uo9973->data[0] = (Object)closure9973;
  Method *meth_meth_parser__apply9973 = addmethod2pos(block9972, "_apply", &meth_parser__apply9973, 0);
  int argcv_meth_parser__apply9973[] = {0};
  meth_meth_parser__apply9973->type = alloc_MethodType(1, argcv_meth_parser__apply9973);
  meth_meth_parser__apply9973->definitionModule = modulename;
  meth_meth_parser__apply9973->definitionLine = 3108;
// compiled block node returning block9972 (depth = 9)
  gc_frame_newslot(block9972);
// call case 5: prelude request
  params[0] = block9950;
  params[1] = block9972;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9978 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9949);
// compiled call node returning call9978 (depth = 8)
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9979 == NULL) {
    strlit9979 = alloc_String("");
    gc_root(strlit9979);
  }
// compiled string node returning strlit9979 (depth = 9)
  *var_line = strlit9979;
  if (strlit9979 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9980 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9982 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call9983 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe9982);
// compiled call node returning call9983 (depth = 11)
// compiled member node returning call9983 (depth = 10)
  int op_slot_right_9981 = gc_frame_newslot(call9983);
// starting to compile num node (depth = 10)
  Object num9985 = alloc_Float64(1);
// compiled num node returning num9985 (depth = 10)
  int op_slot_left_9981 = gc_frame_newslot(num9985);
  params[0] = call9983;
  partcv[0] = 1;
  Object opresult9986 = callmethod(num9985, "..", 1, partcv, params);
// compiled op node returning opresult9986 (depth = 9)
  gc_frame_newslot(opresult9986);
// starting to compile block node (depth = 9)
  Object block9987 = alloc_Block(NULL, NULL, "parser", 3112);
  gc_frame_newslot(block9987);
// method "_apply"
  block_savedest(block9987);
  Object closure9988 = createclosure(2, "_apply");
  setclosureframe(closure9988, stackframe);
  addtoclosure(closure9988, var_line);
  addtoclosure(closure9988, selfslot);
  struct UserObject *uo9988 = (struct UserObject*)block9987;
  uo9988->data[0] = (Object)closure9988;
  Method *meth_meth_parser__apply9988 = addmethod2pos(block9987, "_apply", &meth_parser__apply9988, 0);
  int argcv_meth_parser__apply9988[] = {1};
  meth_meth_parser__apply9988->type = alloc_MethodType(1, argcv_meth_parser__apply9988);
  meth_meth_parser__apply9988->definitionModule = modulename;
  meth_meth_parser__apply9988->definitionLine = 3112;
// compiled block node returning block9987 (depth = 9)
  gc_frame_newslot(block9987);
// call case 5: prelude request
  params[0] = opresult9986;
  params[1] = block9987;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9995 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9980);
// compiled call node returning call9995 (depth = 8)
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9997 == NULL) {
    strlit9997 = alloc_String("}");
    gc_root(strlit9997);
  }
// compiled string node returning strlit9997 (depth = 10)
  int op_slot_right_9996 = gc_frame_newslot(strlit9997);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_9996 = gc_frame_newslot(*var_line);
  params[0] = strlit9997;
  partcv[0] = 1;
  Object opresult9999 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult9999 (depth = 9)
  *var_line = opresult9999;
  if (opresult9999 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10001 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10003 = alloc_Float64(0.9);
// compiled num node returning num10003 (depth = 10)
  int op_slot_right_10002 = gc_frame_newslot(num10003);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10006 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10005);
// compiled call node returning call10006 (depth = 11)
// compiled member node returning call10006 (depth = 10)
  int op_slot_left_10002 = gc_frame_newslot(call10006);
  params[0] = num10003;
  partcv[0] = 1;
  Object diff10007 = callmethod(call10006, "-", 1, partcv, params);
// compiled op node returning diff10007 (depth = 9)
  gc_frame_newslot(diff10007);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff10007;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call10008 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10001);
// compiled call node returning call10008 (depth = 8)
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10009 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10010 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10009);
// compiled call node returning call10010 (depth = 8)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10011 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10014 == NULL) {
    strlit10014 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit10014);
  }
// compiled string node returning strlit10014 (depth = 11)
  int op_slot_right_10013 = gc_frame_newslot(strlit10014);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_10016 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 12)
  if (strlit10018 == NULL) {
    strlit10018 = alloc_String("at least ");
    gc_root(strlit10018);
  }
// compiled string node returning strlit10018 (depth = 12)
  int op_slot_left_10016 = gc_frame_newslot(strlit10018);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10019 = callmethod(strlit10018, "++", 1, partcv, params);
// compiled op node returning opresult10019 (depth = 11)
  int op_slot_left_10013 = gc_frame_newslot(opresult10019);
  params[0] = strlit10014;
  partcv[0] = 1;
  Object opresult10020 = callmethod(opresult10019, "++", 1, partcv, params);
// compiled op node returning opresult10020 (depth = 10)
  int op_slot_right_10012 = gc_frame_newslot(opresult10020);
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit10022 == NULL) {
    strlit10022 = alloc_String("the indentation for this line must be ");
    gc_root(strlit10022);
  }
// compiled string node returning strlit10022 (depth = 10)
  int op_slot_left_10012 = gc_frame_newslot(strlit10022);
  params[0] = opresult10020;
  partcv[0] = 1;
  Object opresult10023 = callmethod(strlit10022, "++", 1, partcv, params);
// compiled op node returning opresult10023 (depth = 9)
  gc_frame_newslot(opresult10023);
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10025 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10024);
// compiled call node returning call10025 (depth = 10)
// compiled member node returning call10025 (depth = 9)
  gc_frame_newslot(call10025);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10027 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10026);
// compiled call node returning call10027 (depth = 10)
// compiled member node returning call10027 (depth = 9)
  gc_frame_newslot(call10027);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult10023;
  params[1] = call10025;
  params[2] = call10027;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10028 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10011);
// compiled call node returning call10028 (depth = 8)
    gc_frame_newslot(call10028);
    if9903 = call10028;
  } else {
  }
// compiled if node returning if9903 (depth = 7)
    gc_frame_newslot(if9903);
    if9897 = if9903;
  } else {
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10032 = alloc_Float64(1);
// compiled num node returning num10032 (depth = 10)
  int op_slot_right_10031 = gc_frame_newslot(num10032);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_minIndentLevel (depth = 10)
  int op_slot_left_10031 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = num10032;
  partcv[0] = 1;
  Object sum10034 = callmethod(*var_minIndentLevel, "+", 1, partcv, params);
// compiled op node returning sum10034 (depth = 9)
  int op_slot_right_10030 = gc_frame_newslot(sum10034);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10036 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10037 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10036);
// compiled call node returning call10037 (depth = 10)
// compiled member node returning call10037 (depth = 9)
  int op_slot_left_10030 = gc_frame_newslot(call10037);
  params[0] = sum10034;
  partcv[0] = 1;
  Object opresult10038 = callmethod(call10037, ">", 1, partcv, params);
// compiled op node returning opresult10038 (depth = 8)
  Object if10029 = done;
  if (istrue(opresult10038)) {
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10040 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10039);
// compiled call node returning call10040 (depth = 10)
// compiled member node returning call10040 (depth = 9)
  *var_minIndentLevel = call10040;
  if (call10040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if10029 = done;
  } else {
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10044 = alloc_Float64(1);
// compiled num node returning num10044 (depth = 10)
  int op_slot_right_10043 = gc_frame_newslot(num10044);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10046 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastIndent (depth = 13)
  int op_slot_right_10047 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10049 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_sym (depth = 15)
  partcv[0] = 0;
  Object call10050 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10049);
// compiled call node returning call10050 (depth = 14)
// compiled member node returning call10050 (depth = 13)
  int op_slot_left_10047 = gc_frame_newslot(call10050);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object diff10051 = callmethod(call10050, "-", 1, partcv, params);
// compiled op node returning diff10051 (depth = 12)
  partcv[0] = 0;
  Object call10052 = callmethod(diff10051, "abs",
    1, partcv, params);
  gc_frame_end(callframe10046);
// compiled call node returning call10052 (depth = 11)
// compiled member node returning call10052 (depth = 10)
  int op_slot_left_10043 = gc_frame_newslot(call10052);
  params[0] = num10044;
  partcv[0] = 1;
  Object opresult10053 = callmethod(call10052, "==", 1, partcv, params);
// compiled op node returning opresult10053 (depth = 9)
  Object if10042 = done;
  if (istrue(opresult10053)) {
// Begin line 3125
  setline(3125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10054 == NULL) {
    strlit10054 = alloc_String("the indentation for this line can't differ ");
    gc_root(strlit10054);
  }
// compiled string node returning strlit10054 (depth = 10)
  *var_m1 = strlit10054;
  if (strlit10054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10055 == NULL) {
    strlit10055 = alloc_String("from that of the previous line by 1.""\x0a""  To start a block, or ");
    gc_root(strlit10055);
  }
// compiled string node returning strlit10055 (depth = 10)
  *var_m2 = strlit10055;
  if (strlit10055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10056 == NULL) {
    strlit10056 = alloc_String("to signal a continuation line, increase the indent by 2 or more. ");
    gc_root(strlit10056);
  }
// compiled string node returning strlit10056 (depth = 10)
  *var_m3 = strlit10056;
  if (strlit10056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10057 == NULL) {
    strlit10057 = alloc_String("To end a block, or end the continuation, decrease the indent ");
    gc_root(strlit10057);
  }
// compiled string node returning strlit10057 (depth = 10)
  *var_m4 = strlit10057;
  if (strlit10057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10058 == NULL) {
    strlit10058 = alloc_String("to the prior level. Otherwise, use the same indent as the previous line.");
    gc_root(strlit10058);
  }
// compiled string node returning strlit10058 (depth = 10)
  *var_m5 = strlit10058;
  if (strlit10058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_m5 (depth = 11)
  int op_slot_right_10059 = gc_frame_newslot(*var_m5);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_m4 (depth = 12)
  int op_slot_right_10061 = gc_frame_newslot(*var_m4);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_m3 (depth = 13)
  int op_slot_right_10063 = gc_frame_newslot(*var_m3);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m2 (depth = 14)
  int op_slot_right_10065 = gc_frame_newslot(*var_m2);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_m1 (depth = 14)
  int op_slot_left_10065 = gc_frame_newslot(*var_m1);
  params[0] = *var_m2;
  partcv[0] = 1;
  Object opresult10067 = callmethod(*var_m1, "++", 1, partcv, params);
// compiled op node returning opresult10067 (depth = 13)
  int op_slot_left_10063 = gc_frame_newslot(opresult10067);
  params[0] = *var_m3;
  partcv[0] = 1;
  Object opresult10068 = callmethod(opresult10067, "++", 1, partcv, params);
// compiled op node returning opresult10068 (depth = 12)
  int op_slot_left_10061 = gc_frame_newslot(opresult10068);
  params[0] = *var_m4;
  partcv[0] = 1;
  Object opresult10069 = callmethod(opresult10068, "++", 1, partcv, params);
// compiled op node returning opresult10069 (depth = 11)
  int op_slot_left_10059 = gc_frame_newslot(opresult10069);
  params[0] = *var_m5;
  partcv[0] = 1;
  Object opresult10070 = callmethod(opresult10069, "++", 1, partcv, params);
// compiled op node returning opresult10070 (depth = 10)
  *var_msg = opresult10070;
  if (opresult10070 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe10071 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_msg (depth = 10)
  gc_frame_newslot(*var_msg);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10073 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10072);
// compiled call node returning call10073 (depth = 11)
// compiled member node returning call10073 (depth = 10)
  gc_frame_newslot(call10073);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10074 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10075 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10074);
// compiled call node returning call10075 (depth = 11)
// compiled member node returning call10075 (depth = 10)
  gc_frame_newslot(call10075);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = *var_msg;
  params[1] = call10073;
  params[2] = call10075;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call10076 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe10071);
// compiled call node returning call10076 (depth = 9)
    gc_frame_newslot(call10076);
    if10042 = call10076;
  } else {
  }
// compiled if node returning if10042 (depth = 8)
    gc_frame_newslot(if10042);
    if10029 = if10042;
  }
// compiled if node returning if10029 (depth = 7)
    gc_frame_newslot(if10029);
    if9897 = if10029;
  }
// compiled if node returning if9897 (depth = 6)
    gc_frame_newslot(if9897);
    if9890 = if9897;
  }
// compiled if node returning if9890 (depth = 5)
    gc_frame_newslot(if9890);
    if9865 = if9890;
  }
// compiled if node returning if9865 (depth = 4)
    gc_frame_newslot(if9865);
    if9858 = if9865;
  }
// compiled if node returning if9858 (depth = 3)
    gc_frame_newslot(if9858);
    if9855 = if9858;
  }
// compiled if node returning if9855 (depth = 2)
  gc_frame_end(frame);
  return if9855;
}
Object meth_parser__apply10173(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe10174 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10175 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10174);
// compiled call node returning call10175 (depth = 5)
  gc_frame_end(frame);
  return call10175;
}
Object meth_parser__apply10254(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe10255 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10256 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10255);
// compiled call node returning call10256 (depth = 11)
  gc_frame_end(frame);
  return call10256;
}
Object meth_parser__apply10178(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_btok = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3173
  setline(3173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10181 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10182 == NULL) {
    strlit10182 = alloc_String("bind");
    gc_root(strlit10182);
  }
// compiled string node returning strlit10182 (depth = 8)
  gc_frame_newslot(strlit10182);
// call case 4: self request
  params[0] = strlit10182;
  partcv[0] = 1;
  Object call10183 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10181);
// compiled call node returning call10183 (depth = 7)
  int op_slot_right_10180 = gc_frame_newslot(call10183);
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10187 == NULL) {
    strlit10187 = alloc_String("index");
    gc_root(strlit10187);
  }
// compiled string node returning strlit10187 (depth = 9)
  int op_slot_right_10186 = gc_frame_newslot(strlit10187);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10189 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call10191 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10190);
// compiled call node returning call10191 (depth = 12)
// compiled member node returning call10191 (depth = 11)
  partcv[0] = 0;
  Object call10192 = callmethod(call10191, "kind",
    1, partcv, params);
  gc_frame_end(callframe10189);
// compiled call node returning call10192 (depth = 10)
// compiled member node returning call10192 (depth = 9)
  int op_slot_left_10186 = gc_frame_newslot(call10192);
  params[0] = strlit10187;
  partcv[0] = 1;
  Object opresult10193 = callmethod(call10192, "==", 1, partcv, params);
// compiled op node returning opresult10193 (depth = 8)
  int op_slot_right_10185 = gc_frame_newslot(opresult10193);
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10197 == NULL) {
    strlit10197 = alloc_String("member");
    gc_root(strlit10197);
  }
// compiled string node returning strlit10197 (depth = 10)
  int op_slot_right_10196 = gc_frame_newslot(strlit10197);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10199 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call10201 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10200);
// compiled call node returning call10201 (depth = 13)
// compiled member node returning call10201 (depth = 12)
  partcv[0] = 0;
  Object call10202 = callmethod(call10201, "kind",
    1, partcv, params);
  gc_frame_end(callframe10199);
// compiled call node returning call10202 (depth = 11)
// compiled member node returning call10202 (depth = 10)
  int op_slot_left_10196 = gc_frame_newslot(call10202);
  params[0] = strlit10197;
  partcv[0] = 1;
  Object opresult10203 = callmethod(call10202, "==", 1, partcv, params);
// compiled op node returning opresult10203 (depth = 9)
  int op_slot_right_10195 = gc_frame_newslot(opresult10203);
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10206 == NULL) {
    strlit10206 = alloc_String("identifier");
    gc_root(strlit10206);
  }
// compiled string node returning strlit10206 (depth = 10)
  int op_slot_right_10205 = gc_frame_newslot(strlit10206);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10208 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10209 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call10210 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10209);
// compiled call node returning call10210 (depth = 13)
// compiled member node returning call10210 (depth = 12)
  partcv[0] = 0;
  Object call10211 = callmethod(call10210, "kind",
    1, partcv, params);
  gc_frame_end(callframe10208);
// compiled call node returning call10211 (depth = 11)
// compiled member node returning call10211 (depth = 10)
  int op_slot_left_10205 = gc_frame_newslot(call10211);
  params[0] = strlit10206;
  partcv[0] = 1;
  Object opresult10212 = callmethod(call10211, "==", 1, partcv, params);
// compiled op node returning opresult10212 (depth = 9)
  int op_slot_left_10195 = gc_frame_newslot(opresult10212);
  params[0] = opresult10203;
  partcv[0] = 1;
  Object opresult10213 = callmethod(opresult10212, "||", 1, partcv, params);
// compiled op node returning opresult10213 (depth = 8)
  int op_slot_left_10185 = gc_frame_newslot(opresult10213);
  params[0] = opresult10193;
  partcv[0] = 1;
  Object opresult10214 = callmethod(opresult10213, "||", 1, partcv, params);
// compiled op node returning opresult10214 (depth = 7)
  int op_slot_left_10180 = gc_frame_newslot(opresult10214);
  params[0] = call10183;
  partcv[0] = 1;
  Object opresult10215 = callmethod(opresult10214, "&&", 1, partcv, params);
// compiled op node returning opresult10215 (depth = 6)
  Object if10179 = done;
  if (istrue(opresult10215)) {
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10216 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10217 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10216);
// compiled call node returning call10217 (depth = 8)
// compiled member node returning call10217 (depth = 7)
  *var_dest = call10217;
  if (call10217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10220 == NULL) {
    strlit10220 = alloc_String("lbrace");
    gc_root(strlit10220);
  }
// compiled string node returning strlit10220 (depth = 8)
  int op_slot_right_10219 = gc_frame_newslot(strlit10220);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_dest (depth = 10)
  partcv[0] = 0;
  Object call10223 = callmethod(*var_dest, "kind",
    1, partcv, params);
  gc_frame_end(callframe10222);
// compiled call node returning call10223 (depth = 9)
// compiled member node returning call10223 (depth = 8)
  int op_slot_left_10219 = gc_frame_newslot(call10223);
  params[0] = strlit10220;
  partcv[0] = 1;
  Object opresult10224 = callmethod(call10223, "==", 1, partcv, params);
// compiled op node returning opresult10224 (depth = 7)
  Object if10218 = done;
  if (istrue(opresult10224)) {
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10226 == NULL) {
    strlit10226 = alloc_String("");
    gc_root(strlit10226);
  }
// compiled string node returning strlit10226 (depth = 9)
  int op_slot_right_10225 = gc_frame_newslot(strlit10226);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10230 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10229);
// compiled call node returning call10230 (depth = 11)
// compiled member node returning call10230 (depth = 10)
  int op_slot_right_10228 = gc_frame_newslot(call10230);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10233 == NULL) {
    strlit10233 = alloc_String(", sym.line = ");
    gc_root(strlit10233);
  }
// compiled string node returning strlit10233 (depth = 11)
  int op_slot_right_10232 = gc_frame_newslot(strlit10233);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_10235 = gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 12)
  if (strlit10237 == NULL) {
    strlit10237 = alloc_String("sym = ");
    gc_root(strlit10237);
  }
// compiled string node returning strlit10237 (depth = 12)
  int op_slot_left_10235 = gc_frame_newslot(strlit10237);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10238 = callmethod(strlit10237, "++", 1, partcv, params);
// compiled op node returning opresult10238 (depth = 11)
  int op_slot_left_10232 = gc_frame_newslot(opresult10238);
  params[0] = strlit10233;
  partcv[0] = 1;
  Object opresult10239 = callmethod(opresult10238, "++", 1, partcv, params);
// compiled op node returning opresult10239 (depth = 10)
  int op_slot_left_10228 = gc_frame_newslot(opresult10239);
  params[0] = call10230;
  partcv[0] = 1;
  Object opresult10240 = callmethod(opresult10239, "++", 1, partcv, params);
// compiled op node returning opresult10240 (depth = 9)
  int op_slot_left_10225 = gc_frame_newslot(opresult10240);
  params[0] = strlit10226;
  partcv[0] = 1;
  Object opresult10241 = callmethod(opresult10240, "++", 1, partcv, params);
// compiled op node returning opresult10241 (depth = 8)
  params[0] = opresult10241;
  Object call10242 = gracelib_print(NULL, 1,  params);
// compiled call node returning call10242 (depth = 7)
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10243 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10244 == NULL) {
    strlit10244 = alloc_String("popped lbrace token while parsing statement");
    gc_root(strlit10244);
  }
// compiled string node returning strlit10244 (depth = 8)
  gc_frame_newslot(strlit10244);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10245 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10246 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10245);
// compiled call node returning call10246 (depth = 9)
// compiled member node returning call10246 (depth = 8)
  params[0] = strlit10244;
  partcv[0] = 1;
  Object call10247 = callmethod(call10246, "raise",
    1, partcv, params);
  gc_frame_end(callframe10243);
// compiled call node returning call10247 (depth = 7)
    gc_frame_newslot(call10247);
    if10218 = call10247;
  } else {
  }
// compiled if node returning if10218 (depth = 6)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10248 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10249 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10248);
// compiled call node returning call10249 (depth = 7)
// compiled member node returning call10249 (depth = 6)
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10251 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe10252 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block10253 = alloc_Block(NULL, NULL, "parser", 3180);
  gc_frame_newslot(block10253);
// method "_apply"
  block_savedest(block10253);
  Object closure10254 = createclosure(2, "_apply");
  setclosureframe(closure10254, stackframe);
  addtoclosure(closure10254, var_blocksOK);
  addtoclosure(closure10254, selfslot);
  struct UserObject *uo10254 = (struct UserObject*)block10253;
  uo10254->data[0] = (Object)closure10254;
  Method *meth_meth_parser__apply10254 = addmethod2pos(block10253, "_apply", &meth_parser__apply10254, 0);
  int argcv_meth_parser__apply10254[] = {0};
  meth_meth_parser__apply10254->type = alloc_MethodType(1, argcv_meth_parser__apply10254);
  meth_meth_parser__apply10254->definitionModule = modulename;
  meth_meth_parser__apply10254->definitionLine = 3180;
// compiled block node returning block10253 (depth = 10)
  gc_frame_newslot(block10253);
// call case 4: self request
  params[0] = block10253;
  partcv[0] = 1;
  Object call10258 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10252);
// compiled call node returning call10258 (depth = 9)
  partcv[0] = 0;
  Object call10259 = callmethod(call10258, "not",
    1, partcv, params);
  gc_frame_end(callframe10251);
// compiled call node returning call10259 (depth = 8)
// compiled member node returning call10259 (depth = 7)
  Object if10250 = done;
  if (istrue(call10259)) {
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile array node (depth = 8)
  Object array10260 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10260 (depth = 8)
  *var_suggestions = array10260;
  if (array10260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10261 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10262 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call10263 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10262);
// compiled call node returning call10263 (depth = 11)
// compiled member node returning call10263 (depth = 10)
  partcv[0] = 0;
  Object call10264 = callmethod(call10263, "new",
    1, partcv, params);
  gc_frame_end(callframe10261);
// compiled call node returning call10264 (depth = 9)
// compiled member node returning call10264 (depth = 8)
  *var_suggestion = call10264;
  if (call10264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10265 = gc_frame_new();
// starting to compile array node (depth = 9)
  Object array10266 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 10)
  if (strlit10267 == NULL) {
    strlit10267 = alloc_String("rbrace");
    gc_root(strlit10267);
  }
// compiled string node returning strlit10267 (depth = 10)
  params[0] = strlit10267;
  partcv[0] = 1;
  callmethodflags(array10266, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array10266 (depth = 9)
  gc_frame_newslot(array10266);
// call case 4: self request
  params[0] = array10266;
  partcv[0] = 1;
  Object call10268 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10265);
// compiled call node returning call10268 (depth = 8)
  *var_nextTok = call10268;
  if (call10268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_10270 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_10270 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10272 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10272 (depth = 8)
  Object if10269 = done;
  if (istrue(opresult10272)) {
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10273 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit10274 == NULL) {
    strlit10274 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10274);
  }
// compiled string node returning strlit10274 (depth = 9)
  gc_frame_newslot(strlit10274);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit10274;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10275 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10273);
// compiled call node returning call10275 (depth = 8)
    gc_frame_newslot(call10275);
    if10269 = call10275;
  } else {
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10276 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10277 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call10278 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10277);
// compiled call node returning call10278 (depth = 10)
// compiled member node returning call10278 (depth = 9)
  gc_frame_newslot(call10278);
// starting to compile identifier node (depth = 9)
  Object bool10279 = alloc_Boolean(1);
// compiled identifier node returning bool10279 (depth = 9)
  gc_frame_newslot(bool10279);
// starting to compile identifier node (depth = 9)
  Object bool10280 = alloc_Boolean(0);
// compiled identifier node returning bool10280 (depth = 9)
  gc_frame_newslot(bool10280);
// starting to compile string node (depth = 9)
  if (strlit10281 == NULL) {
    strlit10281 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10281);
  }
// compiled string node returning strlit10281 (depth = 9)
  gc_frame_newslot(strlit10281);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call10278;
  params[2] = bool10279;
  params[3] = bool10280;
  params[4] = strlit10281;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10282 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10276);
// compiled call node returning call10282 (depth = 8)
    gc_frame_newslot(call10282);
    if10269 = call10282;
  }
// compiled if node returning if10269 (depth = 7)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10283 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10284 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10283);
// compiled call node returning call10284 (depth = 7)
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10285 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call10287 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10286);
// compiled call node returning call10287 (depth = 11)
// compiled member node returning call10287 (depth = 10)
  partcv[0] = 0;
  Object call10288 = callmethod(call10287, "new",
    1, partcv, params);
  gc_frame_end(callframe10285);
// compiled call node returning call10288 (depth = 9)
// compiled member node returning call10288 (depth = 8)
  *var_suggestion = call10288;
  if (call10288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10290 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10291 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call10292 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10291);
// compiled call node returning call10292 (depth = 9)
// compiled member node returning call10292 (depth = 8)
  gc_frame_newslot(call10292);
// starting to compile identifier node (depth = 8)
  Object bool10293 = alloc_Boolean(1);
// compiled identifier node returning bool10293 (depth = 8)
  gc_frame_newslot(bool10293);
// starting to compile identifier node (depth = 8)
  Object bool10294 = alloc_Boolean(0);
// compiled identifier node returning bool10294 (depth = 8)
  gc_frame_newslot(bool10294);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call10292;
  params[2] = bool10293;
  params[3] = bool10294;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10295 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10290);
// compiled call node returning call10295 (depth = 7)
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10296 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10297 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10296);
// compiled call node returning call10297 (depth = 7)
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10298 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10299 == NULL) {
    strlit10299 = alloc_String("a valid expression must follow ':='.");
    gc_root(strlit10299);
  }
// compiled string node returning strlit10299 (depth = 8)
  gc_frame_newslot(strlit10299);
// Begin line 3194
  setline(3194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10301 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10300);
// compiled call node returning call10301 (depth = 9)
// compiled member node returning call10301 (depth = 8)
  gc_frame_newslot(call10301);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10303 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10302);
// compiled call node returning call10303 (depth = 9)
// compiled member node returning call10303 (depth = 8)
  gc_frame_newslot(call10303);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit10299;
  params[1] = call10301;
  params[2] = call10303;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10304 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10298);
// compiled call node returning call10304 (depth = 7)
    gc_frame_newslot(call10304);
    if10250 = call10304;
  } else {
  }
// compiled if node returning if10250 (depth = 6)
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10306 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10305);
// compiled call node returning call10306 (depth = 8)
// compiled member node returning call10306 (depth = 7)
  *var_val = call10306;
  if (call10306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10307 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call10309 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe10308);
// compiled call node returning call10309 (depth = 8)
// compiled member node returning call10309 (depth = 7)
  gc_frame_newslot(call10309);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  partcv[0] = 0;
  Object call10311 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10310);
// compiled call node returning call10311 (depth = 8)
// compiled member node returning call10311 (depth = 7)
  gc_frame_newslot(call10311);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  params[0] = call10309;
  params[1] = call10311;
  partcv[0] = 2;
  Object call10312 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10307);
// compiled call node returning call10312 (depth = 6)
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10313 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_val (depth = 8)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call10315 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe10314);
// compiled call node returning call10315 (depth = 9)
// compiled member node returning call10315 (depth = 8)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call10316 = callmethod(call10315, "new",
    1, partcv, params);
  gc_frame_end(callframe10313);
// compiled call node returning call10316 (depth = 7)
  *var_o = call10316;
  if (call10316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10317 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10318 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10317);
// compiled call node returning call10318 (depth = 6)
    gc_frame_newslot(call10318);
    if10179 = call10318;
  } else {
  }
// compiled if node returning if10179 (depth = 5)
  gc_frame_end(frame);
  return if10179;
}
Object meth_parser_statement10077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_indentFreePass = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_oldLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldLine");
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10079 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10078);
// compiled call node returning call10079 (depth = 4)
// compiled member node returning call10079 (depth = 3)
  *var_statementIndent = call10079;
  if (call10079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3143
  setline(3143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10083 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10082);
// compiled call node returning call10083 (depth = 3)
// compiled member node returning call10083 (depth = 2)
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10085 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10086 == NULL) {
    strlit10086 = alloc_String("keyword");
    gc_root(strlit10086);
  }
// compiled string node returning strlit10086 (depth = 4)
  gc_frame_newslot(strlit10086);
// call case 4: self request
  params[0] = strlit10086;
  partcv[0] = 1;
  Object call10087 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10085);
// compiled call node returning call10087 (depth = 3)
  Object if10084 = done;
  if (istrue(call10087)) {
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10090 == NULL) {
    strlit10090 = alloc_String("var");
    gc_root(strlit10090);
  }
// compiled string node returning strlit10090 (depth = 5)
  int op_slot_right_10089 = gc_frame_newslot(strlit10090);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10092 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10093 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10092);
// compiled call node returning call10093 (depth = 6)
// compiled member node returning call10093 (depth = 5)
  int op_slot_left_10089 = gc_frame_newslot(call10093);
  params[0] = strlit10090;
  partcv[0] = 1;
  Object opresult10094 = callmethod(call10093, "==", 1, partcv, params);
// compiled op node returning opresult10094 (depth = 4)
  Object if10088 = done;
  if (istrue(opresult10094)) {
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10096 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10095);
// compiled call node returning call10096 (depth = 5)
// compiled member node returning call10096 (depth = 4)
    gc_frame_newslot(call10096);
    if10088 = call10096;
  } else {
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10099 == NULL) {
    strlit10099 = alloc_String("def");
    gc_root(strlit10099);
  }
// compiled string node returning strlit10099 (depth = 6)
  int op_slot_right_10098 = gc_frame_newslot(strlit10099);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10101 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10102 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10101);
// compiled call node returning call10102 (depth = 7)
// compiled member node returning call10102 (depth = 6)
  int op_slot_left_10098 = gc_frame_newslot(call10102);
  params[0] = strlit10099;
  partcv[0] = 1;
  Object opresult10103 = callmethod(call10102, "==", 1, partcv, params);
// compiled op node returning opresult10103 (depth = 5)
  Object if10097 = done;
  if (istrue(opresult10103)) {
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10104 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10105 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10104);
// compiled call node returning call10105 (depth = 6)
// compiled member node returning call10105 (depth = 5)
    gc_frame_newslot(call10105);
    if10097 = call10105;
  } else {
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10108 == NULL) {
    strlit10108 = alloc_String("import");
    gc_root(strlit10108);
  }
// compiled string node returning strlit10108 (depth = 7)
  int op_slot_right_10107 = gc_frame_newslot(strlit10108);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10111 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10110);
// compiled call node returning call10111 (depth = 8)
// compiled member node returning call10111 (depth = 7)
  int op_slot_left_10107 = gc_frame_newslot(call10111);
  params[0] = strlit10108;
  partcv[0] = 1;
  Object opresult10112 = callmethod(call10111, "==", 1, partcv, params);
// compiled op node returning opresult10112 (depth = 6)
  Object if10106 = done;
  if (istrue(opresult10112)) {
// Begin line 3152
  setline(3152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10113 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10114 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10113);
// compiled call node returning call10114 (depth = 7)
// compiled member node returning call10114 (depth = 6)
    gc_frame_newslot(call10114);
    if10106 = call10114;
  } else {
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10117 == NULL) {
    strlit10117 = alloc_String("dialect");
    gc_root(strlit10117);
  }
// compiled string node returning strlit10117 (depth = 8)
  int op_slot_right_10116 = gc_frame_newslot(strlit10117);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10120 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10119);
// compiled call node returning call10120 (depth = 9)
// compiled member node returning call10120 (depth = 8)
  int op_slot_left_10116 = gc_frame_newslot(call10120);
  params[0] = strlit10117;
  partcv[0] = 1;
  Object opresult10121 = callmethod(call10120, "==", 1, partcv, params);
// compiled op node returning opresult10121 (depth = 7)
  Object if10115 = done;
  if (istrue(opresult10121)) {
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10123 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10122);
// compiled call node returning call10123 (depth = 8)
// compiled member node returning call10123 (depth = 7)
    gc_frame_newslot(call10123);
    if10115 = call10123;
  } else {
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10126 == NULL) {
    strlit10126 = alloc_String("type");
    gc_root(strlit10126);
  }
// compiled string node returning strlit10126 (depth = 9)
  int op_slot_right_10125 = gc_frame_newslot(strlit10126);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10129 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10128);
// compiled call node returning call10129 (depth = 10)
// compiled member node returning call10129 (depth = 9)
  int op_slot_left_10125 = gc_frame_newslot(call10129);
  params[0] = strlit10126;
  partcv[0] = 1;
  Object opresult10130 = callmethod(call10129, "==", 1, partcv, params);
// compiled op node returning opresult10130 (depth = 8)
  Object if10124 = done;
  if (istrue(opresult10130)) {
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10132 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10131);
// compiled call node returning call10132 (depth = 9)
// compiled member node returning call10132 (depth = 8)
    gc_frame_newslot(call10132);
    if10124 = call10132;
  } else {
// Begin line 3159
  setline(3159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10135 == NULL) {
    strlit10135 = alloc_String("class");
    gc_root(strlit10135);
  }
// compiled string node returning strlit10135 (depth = 10)
  int op_slot_right_10134 = gc_frame_newslot(strlit10135);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10138 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10137);
// compiled call node returning call10138 (depth = 11)
// compiled member node returning call10138 (depth = 10)
  int op_slot_left_10134 = gc_frame_newslot(call10138);
  params[0] = strlit10135;
  partcv[0] = 1;
  Object opresult10139 = callmethod(call10138, "==", 1, partcv, params);
// compiled op node returning opresult10139 (depth = 9)
  Object if10133 = done;
  if (istrue(opresult10139)) {
// Begin line 3158
  setline(3158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10141 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10140);
// compiled call node returning call10141 (depth = 10)
// compiled member node returning call10141 (depth = 9)
    gc_frame_newslot(call10141);
    if10133 = call10141;
  } else {
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 3159
  setline(3159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10144 == NULL) {
    strlit10144 = alloc_String("trait");
    gc_root(strlit10144);
  }
// compiled string node returning strlit10144 (depth = 11)
  int op_slot_right_10143 = gc_frame_newslot(strlit10144);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call10147 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10146);
// compiled call node returning call10147 (depth = 12)
// compiled member node returning call10147 (depth = 11)
  int op_slot_left_10143 = gc_frame_newslot(call10147);
  params[0] = strlit10144;
  partcv[0] = 1;
  Object opresult10148 = callmethod(call10147, "==", 1, partcv, params);
// compiled op node returning opresult10148 (depth = 10)
  Object if10142 = done;
  if (istrue(opresult10148)) {
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10150 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10149);
// compiled call node returning call10150 (depth = 11)
// compiled member node returning call10150 (depth = 10)
    gc_frame_newslot(call10150);
    if10142 = call10150;
  } else {
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit10153 == NULL) {
    strlit10153 = alloc_String("factory");
    gc_root(strlit10153);
  }
// compiled string node returning strlit10153 (depth = 12)
  int op_slot_right_10152 = gc_frame_newslot(strlit10153);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call10156 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10155);
// compiled call node returning call10156 (depth = 13)
// compiled member node returning call10156 (depth = 12)
  int op_slot_left_10152 = gc_frame_newslot(call10156);
  params[0] = strlit10153;
  partcv[0] = 1;
  Object opresult10157 = callmethod(call10156, "==", 1, partcv, params);
// compiled op node returning opresult10157 (depth = 11)
  Object if10151 = done;
  if (istrue(opresult10157)) {
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10159 = callmethodflags(self, "dofactoryMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10158);
// compiled call node returning call10159 (depth = 12)
// compiled member node returning call10159 (depth = 11)
    gc_frame_newslot(call10159);
    if10151 = call10159;
  } else {
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit10162 == NULL) {
    strlit10162 = alloc_String("return");
    gc_root(strlit10162);
  }
// compiled string node returning strlit10162 (depth = 13)
  int op_slot_right_10161 = gc_frame_newslot(strlit10162);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10164 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_sym (depth = 15)
  partcv[0] = 0;
  Object call10165 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10164);
// compiled call node returning call10165 (depth = 14)
// compiled member node returning call10165 (depth = 13)
  int op_slot_left_10161 = gc_frame_newslot(call10165);
  params[0] = strlit10162;
  partcv[0] = 1;
  Object opresult10166 = callmethod(call10165, "==", 1, partcv, params);
// compiled op node returning opresult10166 (depth = 12)
  Object if10160 = done;
  if (istrue(opresult10166)) {
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10168 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10167);
// compiled call node returning call10168 (depth = 13)
// compiled member node returning call10168 (depth = 12)
    gc_frame_newslot(call10168);
    if10160 = call10168;
  } else {
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe10169 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10170 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10169);
// compiled call node returning call10170 (depth = 12)
    gc_frame_newslot(call10170);
    if10160 = call10170;
  }
// compiled if node returning if10160 (depth = 11)
    gc_frame_newslot(if10160);
    if10151 = if10160;
  }
// compiled if node returning if10151 (depth = 10)
    gc_frame_newslot(if10151);
    if10142 = if10151;
  }
// compiled if node returning if10142 (depth = 9)
    gc_frame_newslot(if10142);
    if10133 = if10142;
  }
// compiled if node returning if10133 (depth = 8)
    gc_frame_newslot(if10133);
    if10124 = if10133;
  }
// compiled if node returning if10124 (depth = 7)
    gc_frame_newslot(if10124);
    if10115 = if10124;
  }
// compiled if node returning if10115 (depth = 6)
    gc_frame_newslot(if10115);
    if10106 = if10115;
  }
// compiled if node returning if10106 (depth = 5)
    gc_frame_newslot(if10106);
    if10097 = if10106;
  }
// compiled if node returning if10097 (depth = 4)
    gc_frame_newslot(if10097);
    if10088 = if10097;
  }
// compiled if node returning if10088 (depth = 3)
    gc_frame_newslot(if10088);
    if10084 = if10088;
  } else {
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10171 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10172 = alloc_Block(NULL, NULL, "parser", 3169);
  gc_frame_newslot(block10172);
// method "_apply"
  block_savedest(block10172);
  Object closure10173 = createclosure(2, "_apply");
  setclosureframe(closure10173, stackframe);
  addtoclosure(closure10173, var_blocksOK);
  addtoclosure(closure10173, selfslot);
  struct UserObject *uo10173 = (struct UserObject*)block10172;
  uo10173->data[0] = (Object)closure10173;
  Method *meth_meth_parser__apply10173 = addmethod2pos(block10172, "_apply", &meth_parser__apply10173, 0);
  int argcv_meth_parser__apply10173[] = {0};
  meth_meth_parser__apply10173->type = alloc_MethodType(1, argcv_meth_parser__apply10173);
  meth_meth_parser__apply10173->definitionModule = modulename;
  meth_meth_parser__apply10173->definitionLine = 3164;
// compiled block node returning block10172 (depth = 4)
  gc_frame_newslot(block10172);
// starting to compile block node (depth = 4)
  Object block10177 = alloc_Block(NULL, NULL, "parser", 3169);
  gc_frame_newslot(block10177);
// method "_apply"
  block_savedest(block10177);
  Object closure10178 = createclosure(9, "_apply");
  setclosureframe(closure10178, stackframe);
  addtoclosure(closure10178, var_values);
  addtoclosure(closure10178, var_sym);
  addtoclosure(closure10178, var_blocksOK);
  addtoclosure(closure10178, var_errormessages);
  addtoclosure(closure10178, var_lastToken);
  addtoclosure(closure10178, var_btok);
  addtoclosure(closure10178, var_util);
  addtoclosure(closure10178, var_ast);
  addtoclosure(closure10178, selfslot);
  struct UserObject *uo10178 = (struct UserObject*)block10177;
  uo10178->data[0] = (Object)closure10178;
  Method *meth_meth_parser__apply10178 = addmethod2pos(block10177, "_apply", &meth_parser__apply10178, 0);
  int argcv_meth_parser__apply10178[] = {0};
  meth_meth_parser__apply10178->type = alloc_MethodType(1, argcv_meth_parser__apply10178);
  meth_meth_parser__apply10178->definitionModule = modulename;
  meth_meth_parser__apply10178->definitionLine = 3164;
// compiled block node returning block10177 (depth = 4)
  gc_frame_newslot(block10177);
// call case 4: self request
  params[0] = block10172;
  params[1] = block10177;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10320 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10171);
// compiled call node returning call10320 (depth = 3)
    gc_frame_newslot(call10320);
    if10084 = call10320;
  }
// compiled if node returning if10084 (depth = 2)
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10322 = callmethodflags(self, "reconcileComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10321);
// compiled call node returning call10322 (depth = 3)
// compiled member node returning call10322 (depth = 2)
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10324 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10325 == NULL) {
    strlit10325 = alloc_String("eof");
    gc_root(strlit10325);
  }
// compiled string node returning strlit10325 (depth = 4)
  gc_frame_newslot(strlit10325);
// call case 4: self request
  params[0] = strlit10325;
  partcv[0] = 1;
  Object call10326 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10324);
// compiled call node returning call10326 (depth = 3)
  Object if10323 = done;
  if (istrue(call10326)) {
// Begin line 3205
  setline(3205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10327 = alloc_Boolean(1);
// compiled identifier node returning bool10327 (depth = 4)
  return bool10327;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10323 = undefined;
  } else {
  }
// compiled if node returning if10323 (depth = 2)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10329 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10330 == NULL) {
    strlit10330 = alloc_String("semicolon");
    gc_root(strlit10330);
  }
// compiled string node returning strlit10330 (depth = 4)
  gc_frame_newslot(strlit10330);
// call case 4: self request
  params[0] = strlit10330;
  partcv[0] = 1;
  Object call10331 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10329);
// compiled call node returning call10331 (depth = 3)
  Object if10328 = done;
  if (istrue(call10331)) {
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10333 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10332);
// compiled call node returning call10333 (depth = 5)
// compiled member node returning call10333 (depth = 4)
  *var_oldLine = call10333;
  if (call10333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10335 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10334);
// compiled call node returning call10335 (depth = 4)
// compiled member node returning call10335 (depth = 3)
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_10337 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10339 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10340 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10339);
// compiled call node returning call10340 (depth = 6)
// compiled member node returning call10340 (depth = 5)
  int op_slot_left_10337 = gc_frame_newslot(call10340);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult10341 = callmethod(call10340, "==", 1, partcv, params);
// compiled op node returning opresult10341 (depth = 4)
  Object if10336 = done;
  if (istrue(opresult10341)) {
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10342 = alloc_Boolean(1);
// compiled identifier node returning bool10342 (depth = 5)
  *var_indentFreePass = bool10342;
  if (bool10342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10336 = done;
  } else {
  }
// compiled if node returning if10336 (depth = 3)
    gc_frame_newslot(if10336);
    if10328 = if10336;
  } else {
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10344 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10345 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10344);
// compiled call node returning call10345 (depth = 4)
// compiled member node returning call10345 (depth = 3)
    gc_frame_newslot(call10345);
    if10328 = call10345;
  }
// compiled if node returning if10328 (depth = 2)
  gc_frame_end(frame);
  return if10328;
}
Object meth_parser__apply10404(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_previousCommentToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 3234
  setline(3234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  *var_previousCommentToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call10407 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe10406);
// compiled call node returning call10407 (depth = 6)
// compiled member node returning call10407 (depth = 5)
  *var_sym = call10407;
  if (call10407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10412 = alloc_Float64(1);
// compiled num node returning num10412 (depth = 7)
  int op_slot_right_10411 = gc_frame_newslot(num10412);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_previousCommentToken (depth = 9)
  partcv[0] = 0;
  Object call10415 = callmethod(*var_previousCommentToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10414);
// compiled call node returning call10415 (depth = 8)
// compiled member node returning call10415 (depth = 7)
  int op_slot_left_10411 = gc_frame_newslot(call10415);
  params[0] = num10412;
  partcv[0] = 1;
  Object sum10416 = callmethod(call10415, "+", 1, partcv, params);
// compiled op node returning sum10416 (depth = 6)
  int op_slot_right_10410 = gc_frame_newslot(sum10416);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10419 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10418);
// compiled call node returning call10419 (depth = 7)
// compiled member node returning call10419 (depth = 6)
  int op_slot_left_10410 = gc_frame_newslot(call10419);
  params[0] = sum10416;
  partcv[0] = 1;
  Object opresult10420 = callmethod(call10419, ">", 1, partcv, params);
// compiled op node returning opresult10420 (depth = 5)
  Object if10409 = done;
  if (istrue(opresult10420)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10422 = callmethodflags(self, "noteBlank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10421);
// compiled call node returning call10422 (depth = 6)
// compiled member node returning call10422 (depth = 5)
    gc_frame_newslot(call10422);
    if10409 = call10422;
  } else {
  }
// compiled if node returning if10409 (depth = 4)
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10423 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10424 == NULL) {
    strlit10424 = alloc_String("comment");
    gc_root(strlit10424);
  }
// compiled string node returning strlit10424 (depth = 5)
  gc_frame_newslot(strlit10424);
// call case 4: self request
  params[0] = strlit10424;
  partcv[0] = 1;
  Object call10425 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10423);
// compiled call node returning call10425 (depth = 4)
  gc_frame_end(frame);
  return call10425;
}
Object meth_parser__apply10428(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_o = getfromclosure(closure, 3);
  Object *var_comments = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10429 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10431 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10430);
// compiled call node returning call10431 (depth = 6)
// compiled member node returning call10431 (depth = 5)
  gc_frame_newslot(call10431);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10432 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10433 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10432);
// compiled call node returning call10433 (depth = 6)
// compiled member node returning call10433 (depth = 5)
  gc_frame_newslot(call10433);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call10431;
  params[1] = call10433;
  partcv[0] = 2;
  Object call10434 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10429);
// compiled call node returning call10434 (depth = 4)
// Begin line 3240
  setline(3240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10435 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10436 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10437 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10436);
// compiled call node returning call10437 (depth = 7)
// compiled member node returning call10437 (depth = 6)
  gc_frame_newslot(call10437);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10439 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe10438);
// compiled call node returning call10439 (depth = 7)
// compiled member node returning call10439 (depth = 6)
  params[0] = call10437;
  partcv[0] = 1;
  Object call10440 = callmethod(call10439, "new",
    1, partcv, params);
  gc_frame_end(callframe10435);
// compiled call node returning call10440 (depth = 5)
  *var_o = call10440;
  if (call10440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10445 = alloc_Float64(1);
// compiled num node returning num10445 (depth = 7)
  int op_slot_right_10444 = gc_frame_newslot(num10445);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10448 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10447);
// compiled call node returning call10448 (depth = 8)
// compiled member node returning call10448 (depth = 7)
  int op_slot_left_10444 = gc_frame_newslot(call10448);
  params[0] = num10445;
  partcv[0] = 1;
  Object diff10449 = callmethod(call10448, "-", 1, partcv, params);
// compiled op node returning diff10449 (depth = 6)
  int op_slot_right_10443 = gc_frame_newslot(diff10449);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10451 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comments (depth = 10)
  partcv[0] = 0;
  Object call10453 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe10452);
// compiled call node returning call10453 (depth = 9)
// compiled member node returning call10453 (depth = 8)
  partcv[0] = 0;
  Object call10454 = callmethod(call10453, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10451);
// compiled call node returning call10454 (depth = 7)
// compiled member node returning call10454 (depth = 6)
  int op_slot_left_10443 = gc_frame_newslot(call10454);
  params[0] = diff10449;
  partcv[0] = 1;
  Object opresult10455 = callmethod(call10454, "==", 1, partcv, params);
// compiled op node returning opresult10455 (depth = 5)
  Object if10442 = done;
  if (istrue(opresult10455)) {
// Begin line 3242
  setline(3242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10456 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  partcv[0] = 0;
  Object call10458 = callmethod(*var_comments, "last",
    1, partcv, params);
  gc_frame_end(callframe10457);
// compiled call node returning call10458 (depth = 7)
// compiled member node returning call10458 (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10459 = callmethod(call10458, "extendCommentUsing",
    1, partcv, params);
  gc_frame_end(callframe10456);
// compiled call node returning call10459 (depth = 5)
    gc_frame_newslot(call10459);
    if10442 = call10459;
  } else {
// Begin line 3244
  setline(3244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10460 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10461 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe10460);
// compiled call node returning call10461 (depth = 5)
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10465 = alloc_Float64(1);
// compiled num node returning num10465 (depth = 8)
  int op_slot_right_10464 = gc_frame_newslot(num10465);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10468 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10467);
// compiled call node returning call10468 (depth = 9)
// compiled member node returning call10468 (depth = 8)
  int op_slot_left_10464 = gc_frame_newslot(call10468);
  params[0] = num10465;
  partcv[0] = 1;
  Object diff10469 = callmethod(call10468, "-", 1, partcv, params);
// compiled op node returning diff10469 (depth = 7)
  int op_slot_right_10463 = gc_frame_newslot(diff10469);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10472 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10471);
// compiled call node returning call10472 (depth = 8)
// compiled member node returning call10472 (depth = 7)
  int op_slot_left_10463 = gc_frame_newslot(call10472);
  params[0] = diff10469;
  partcv[0] = 1;
  Object opresult10473 = callmethod(call10472, "<", 1, partcv, params);
// compiled op node returning opresult10473 (depth = 6)
  Object if10462 = done;
  if (istrue(opresult10473)) {
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10474 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool10475 = alloc_Boolean(1);
// compiled identifier node returning bool10475 (depth = 7)
  gc_frame_newslot(bool10475);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = bool10475;
  partcv[0] = 1;
  Object call10476 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe10474);
// compiled call node returning call10476 (depth = 6)
    gc_frame_newslot(call10476);
    if10462 = call10476;
  } else {
  }
// compiled if node returning if10462 (depth = 5)
    gc_frame_newslot(if10462);
    if10442 = if10462;
  }
// compiled if node returning if10442 (depth = 4)
  gc_frame_end(frame);
  return if10442;
}
Object meth_parser_pushComments10346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_comments = getfromclosure(closure, 5);
  Object *var_previousCommentToken = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pushComments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pushComments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10348 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10349 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10350 == NULL) {
    strlit10350 = alloc_String("comment");
    gc_root(strlit10350);
  }
// compiled string node returning strlit10350 (depth = 5)
  gc_frame_newslot(strlit10350);
// call case 4: self request
  params[0] = strlit10350;
  partcv[0] = 1;
  Object call10351 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10349);
// compiled call node returning call10351 (depth = 4)
  partcv[0] = 0;
  Object call10352 = callmethod(call10351, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10348);
// compiled call node returning call10352 (depth = 3)
  Object if10347 = done;
  if (istrue(call10352)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10347 = undefined;
  } else {
  }
// compiled if node returning if10347 (depth = 2)
// Begin line 3225
  setline(3225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10353 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10355 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10354);
// compiled call node returning call10355 (depth = 4)
// compiled member node returning call10355 (depth = 3)
  gc_frame_newslot(call10355);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10357 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10356);
// compiled call node returning call10357 (depth = 4)
// compiled member node returning call10357 (depth = 3)
  gc_frame_newslot(call10357);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call10355;
  params[1] = call10357;
  partcv[0] = 2;
  Object call10358 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe10353);
// compiled call node returning call10358 (depth = 2)
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10359 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10360 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10361 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10360);
// compiled call node returning call10361 (depth = 5)
// compiled member node returning call10361 (depth = 4)
  gc_frame_newslot(call10361);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10363 = callmethod(*var_ast, "commentNode",
    1, partcv, params);
  gc_frame_end(callframe10362);
// compiled call node returning call10363 (depth = 5)
// compiled member node returning call10363 (depth = 4)
  params[0] = call10361;
  partcv[0] = 1;
  Object call10364 = callmethod(call10363, "new",
    1, partcv, params);
  gc_frame_end(callframe10359);
// compiled call node returning call10364 (depth = 3)
  *var_o = call10364;
  if (call10364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10368 == NULL) {
    strlit10368 = alloc_String("comment");
    gc_root(strlit10368);
  }
// compiled string node returning strlit10368 (depth = 5)
  int op_slot_right_10367 = gc_frame_newslot(strlit10368);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10371 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe10370);
// compiled call node returning call10371 (depth = 6)
// compiled member node returning call10371 (depth = 5)
  int op_slot_left_10367 = gc_frame_newslot(call10371);
  params[0] = strlit10368;
  partcv[0] = 1;
  Object opresult10372 = callmethod(call10371, "≠", 1, partcv, params);
// compiled op node returning opresult10372 (depth = 4)
  int op_slot_right_10366 = gc_frame_newslot(opresult10372);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10375 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10376 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10375);
// compiled call node returning call10376 (depth = 6)
// compiled member node returning call10376 (depth = 5)
  int op_slot_right_10374 = gc_frame_newslot(call10376);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10379 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10378);
// compiled call node returning call10379 (depth = 6)
// compiled member node returning call10379 (depth = 5)
  int op_slot_left_10374 = gc_frame_newslot(call10379);
  params[0] = call10376;
  partcv[0] = 1;
  Object opresult10380 = callmethod(call10379, "==", 1, partcv, params);
// compiled op node returning opresult10380 (depth = 4)
  int op_slot_left_10366 = gc_frame_newslot(opresult10380);
  params[0] = opresult10372;
  partcv[0] = 1;
  Object opresult10381 = callmethod(opresult10380, "&&", 1, partcv, params);
// compiled op node returning opresult10381 (depth = 3)
  Object if10365 = done;
  if (istrue(opresult10381)) {
// Begin line 3228
  setline(3228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10382 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10383 = alloc_Boolean(1);
// compiled identifier node returning bool10383 (depth = 4)
  gc_frame_newslot(bool10383);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = bool10383;
  partcv[0] = 1;
  Object call10384 = callmethod(*var_o, "isPartialLine:=",
    1, partcv, params);
  gc_frame_end(callframe10382);
// compiled call node returning call10384 (depth = 3)
    gc_frame_newslot(call10384);
    if10365 = call10384;
  } else {
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3229
  setline(3229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10388 = alloc_Float64(1);
// compiled num node returning num10388 (depth = 6)
  int op_slot_right_10387 = gc_frame_newslot(num10388);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10391 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10390);
// compiled call node returning call10391 (depth = 7)
// compiled member node returning call10391 (depth = 6)
  int op_slot_left_10387 = gc_frame_newslot(call10391);
  params[0] = num10388;
  partcv[0] = 1;
  Object diff10392 = callmethod(call10391, "-", 1, partcv, params);
// compiled op node returning diff10392 (depth = 5)
  int op_slot_right_10386 = gc_frame_newslot(diff10392);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10395 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10394);
// compiled call node returning call10395 (depth = 6)
// compiled member node returning call10395 (depth = 5)
  int op_slot_left_10386 = gc_frame_newslot(call10395);
  params[0] = diff10392;
  partcv[0] = 1;
  Object opresult10396 = callmethod(call10395, "<", 1, partcv, params);
// compiled op node returning opresult10396 (depth = 4)
  Object if10385 = done;
  if (istrue(opresult10396)) {
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10397 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool10398 = alloc_Boolean(1);
// compiled identifier node returning bool10398 (depth = 5)
  gc_frame_newslot(bool10398);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool10398;
  partcv[0] = 1;
  Object call10399 = callmethod(*var_o, "isPreceededByBlankLine:=",
    1, partcv, params);
  gc_frame_end(callframe10397);
// compiled call node returning call10399 (depth = 4)
    gc_frame_newslot(call10399);
    if10385 = call10399;
  } else {
  }
// compiled if node returning if10385 (depth = 3)
    gc_frame_newslot(if10385);
    if10365 = if10385;
  }
// compiled if node returning if10365 (depth = 2)
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10400 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10401 = callmethod(*var_comments, "push",
    1, partcv, params);
  gc_frame_end(callframe10400);
// compiled call node returning call10401 (depth = 2)
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10402 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10403 = alloc_Block(NULL, NULL, "parser", 3233);
  gc_frame_newslot(block10403);
// method "_apply"
  block_savedest(block10403);
  Object closure10404 = createclosure(4, "_apply");
  setclosureframe(closure10404, stackframe);
  addtoclosure(closure10404, var_sym);
  addtoclosure(closure10404, var_previousCommentToken);
  addtoclosure(closure10404, var_tokens);
  addtoclosure(closure10404, selfslot);
  struct UserObject *uo10404 = (struct UserObject*)block10403;
  uo10404->data[0] = (Object)closure10404;
  Method *meth_meth_parser__apply10404 = addmethod2pos(block10403, "_apply", &meth_parser__apply10404, 0);
  int argcv_meth_parser__apply10404[] = {0};
  meth_meth_parser__apply10404->type = alloc_MethodType(1, argcv_meth_parser__apply10404);
  meth_meth_parser__apply10404->definitionModule = modulename;
  meth_meth_parser__apply10404->definitionLine = 3229;
// compiled block node returning block10403 (depth = 3)
  gc_frame_newslot(block10403);
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block10427 = alloc_Block(NULL, NULL, "parser", 3238);
  gc_frame_newslot(block10427);
// method "_apply"
  block_savedest(block10427);
  Object closure10428 = createclosure(7, "_apply");
  setclosureframe(closure10428, stackframe);
  addtoclosure(closure10428, var_sym);
  addtoclosure(closure10428, var_util);
  addtoclosure(closure10428, var_ast);
  addtoclosure(closure10428, var_o);
  addtoclosure(closure10428, var_comments);
  addtoclosure(closure10428, var_lastToken);
  addtoclosure(closure10428, selfslot);
  struct UserObject *uo10428 = (struct UserObject*)block10427;
  uo10428->data[0] = (Object)closure10428;
  Method *meth_meth_parser__apply10428 = addmethod2pos(block10427, "_apply", &meth_parser__apply10428, 0);
  int argcv_meth_parser__apply10428[] = {0};
  meth_meth_parser__apply10428->type = alloc_MethodType(1, argcv_meth_parser__apply10428);
  meth_meth_parser__apply10428->definitionModule = modulename;
  meth_meth_parser__apply10428->definitionLine = 3236;
// compiled block node returning block10427 (depth = 3)
  gc_frame_newslot(block10427);
// call case 5: prelude request
  params[0] = block10403;
  params[1] = block10427;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10478 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10402);
// compiled call node returning call10478 (depth = 2)
  gc_frame_end(frame);
  return call10478;
}
Object meth_parser__apply10504(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10506 = alloc_Float64(0);
// compiled num node returning num10506 (depth = 5)
  int op_slot_right_10505 = gc_frame_newslot(num10506);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_10505 = gc_frame_newslot(*var_ix);
  params[0] = num10506;
  partcv[0] = 1;
  Object opresult10508 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult10508 (depth = 4)
  gc_frame_end(frame);
  return opresult10508;
}
Object meth_parser__apply10511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_comments = getfromclosure(closure, 1);
  Object *var_oLine = getfromclosure(closure, 2);
  Object *var_postComments = getfromclosure(closure, 3);
  Object *var_preComments = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
  Object *var_isPostComment = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isPostComment");
  Object *var_isPreComment = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isPreComment");
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10512 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_comments (depth = 6)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10513 = callmethod(*var_comments, "at",
    1, partcv, params);
  gc_frame_end(callframe10512);
// compiled call node returning call10513 (depth = 5)
  *var_each = call10513;
  if (call10513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10517 = alloc_Float64(1);
// compiled num node returning num10517 (depth = 8)
  int op_slot_right_10516 = gc_frame_newslot(num10517);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_10516 = gc_frame_newslot(*var_oLine);
  params[0] = num10517;
  partcv[0] = 1;
  Object sum10519 = callmethod(*var_oLine, "+", 1, partcv, params);
// compiled op node returning sum10519 (depth = 7)
  int op_slot_right_10515 = gc_frame_newslot(sum10519);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call10522 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe10521);
// compiled call node returning call10522 (depth = 8)
// compiled member node returning call10522 (depth = 7)
  int op_slot_left_10515 = gc_frame_newslot(call10522);
  params[0] = sum10519;
  partcv[0] = 1;
  Object opresult10523 = callmethod(call10522, "==", 1, partcv, params);
// compiled op node returning opresult10523 (depth = 6)
  int op_slot_right_10514 = gc_frame_newslot(opresult10523);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oLine (depth = 7)
  int op_slot_right_10525 = gc_frame_newslot(*var_oLine);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10527 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call10528 = callmethod(*var_each, "line",
    1, partcv, params);
  gc_frame_end(callframe10527);
// compiled call node returning call10528 (depth = 8)
// compiled member node returning call10528 (depth = 7)
  int op_slot_left_10525 = gc_frame_newslot(call10528);
  params[0] = *var_oLine;
  partcv[0] = 1;
  Object opresult10529 = callmethod(call10528, "==", 1, partcv, params);
// compiled op node returning opresult10529 (depth = 6)
  int op_slot_left_10514 = gc_frame_newslot(opresult10529);
  params[0] = opresult10523;
  partcv[0] = 1;
  Object opresult10530 = callmethod(opresult10529, "||", 1, partcv, params);
// compiled op node returning opresult10530 (depth = 5)
  *var_isPostComment = opresult10530;
  if (opresult10530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10534 = alloc_Float64(1);
// compiled num node returning num10534 (depth = 8)
  int op_slot_right_10533 = gc_frame_newslot(num10534);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oLine (depth = 8)
  int op_slot_left_10533 = gc_frame_newslot(*var_oLine);
  params[0] = num10534;
  partcv[0] = 1;
  Object diff10536 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff10536 (depth = 7)
  int op_slot_right_10532 = gc_frame_newslot(diff10536);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call10539 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10538);
// compiled call node returning call10539 (depth = 8)
// compiled member node returning call10539 (depth = 7)
  int op_slot_left_10532 = gc_frame_newslot(call10539);
  params[0] = diff10536;
  partcv[0] = 1;
  Object opresult10540 = callmethod(call10539, "==", 1, partcv, params);
// compiled op node returning opresult10540 (depth = 6)
  int op_slot_right_10531 = gc_frame_newslot(opresult10540);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call10543 = callmethod(*var_each, "isPreceededByBlankLine",
    1, partcv, params);
  gc_frame_end(callframe10542);
// compiled call node returning call10543 (depth = 7)
// compiled member node returning call10543 (depth = 6)
  int op_slot_left_10531 = gc_frame_newslot(call10543);
  params[0] = opresult10540;
  partcv[0] = 1;
  Object opresult10544 = callmethod(call10543, "&&", 1, partcv, params);
// compiled op node returning opresult10544 (depth = 5)
  *var_isPreComment = opresult10544;
  if (opresult10544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isPostComment (depth = 5)
  Object if10545 = done;
  if (istrue(*var_isPostComment)) {
// Begin line 3279
  setline(3279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10546 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe10547 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_comments (depth = 7)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10548 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe10547);
// compiled call node returning call10548 (depth = 6)
  gc_frame_newslot(call10548);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_postComments (depth = 6)
  params[0] = call10548;
  partcv[0] = 1;
  Object call10549 = callmethod(*var_postComments, "push",
    1, partcv, params);
  gc_frame_end(callframe10546);
// compiled call node returning call10549 (depth = 5)
    gc_frame_newslot(call10549);
    if10545 = call10549;
  } else {
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isPreComment (depth = 6)
  Object if10550 = done;
  if (istrue(*var_isPreComment)) {
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10551 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe10552 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comments (depth = 8)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call10553 = callmethod(*var_comments, "removeAt",
    1, partcv, params);
  gc_frame_end(callframe10552);
// compiled call node returning call10553 (depth = 7)
  gc_frame_newslot(call10553);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_preComments (depth = 7)
  params[0] = call10553;
  partcv[0] = 1;
  Object call10554 = callmethod(*var_preComments, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe10551);
// compiled call node returning call10554 (depth = 6)
    gc_frame_newslot(call10554);
    if10550 = call10554;
  } else {
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10558 = alloc_Float64(1);
// compiled num node returning num10558 (depth = 9)
  int op_slot_right_10557 = gc_frame_newslot(num10558);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_oLine (depth = 9)
  int op_slot_left_10557 = gc_frame_newslot(*var_oLine);
  params[0] = num10558;
  partcv[0] = 1;
  Object diff10560 = callmethod(*var_oLine, "-", 1, partcv, params);
// compiled op node returning diff10560 (depth = 8)
  int op_slot_right_10556 = gc_frame_newslot(diff10560);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  partcv[0] = 0;
  Object call10563 = callmethod(*var_each, "endLine",
    1, partcv, params);
  gc_frame_end(callframe10562);
// compiled call node returning call10563 (depth = 9)
// compiled member node returning call10563 (depth = 8)
  int op_slot_left_10556 = gc_frame_newslot(call10563);
  params[0] = diff10560;
  partcv[0] = 1;
  Object opresult10564 = callmethod(call10563, "<", 1, partcv, params);
// compiled op node returning opresult10564 (depth = 7)
  Object if10555 = done;
  if (istrue(opresult10564)) {
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10565 = alloc_Float64(0);
// compiled num node returning num10565 (depth = 8)
  *var_ix = num10565;
  if (num10565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if10555 = done;
  } else {
  }
// compiled if node returning if10555 (depth = 6)
    gc_frame_newslot(if10555);
    if10550 = if10555;
  }
// compiled if node returning if10550 (depth = 5)
    gc_frame_newslot(if10550);
    if10545 = if10550;
  }
// compiled if node returning if10545 (depth = 4)
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10568 = alloc_Float64(1);
// compiled num node returning num10568 (depth = 6)
  int op_slot_right_10567 = gc_frame_newslot(num10568);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_10567 = gc_frame_newslot(*var_ix);
  params[0] = num10568;
  partcv[0] = 1;
  Object diff10570 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff10570 (depth = 5)
  *var_ix = diff10570;
  if (diff10570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_reconcileComments10479(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reconcileComments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_comments = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reconcileComments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reconcileComments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
  Object *var_oLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oLine");
  Object *var_preComments = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "preComments");
  Object *var_postComments = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "postComments");
  Object *var_ix = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ix");
  Object *var_postSz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "postSz");
  Object *var_preSz = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "preSz");
// Begin line 3258
  setline(3258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10481 = callmethodflags(self, "pushComments", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10480);
// compiled call node returning call10481 (depth = 3)
// compiled member node returning call10481 (depth = 2)
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10484 = callmethod(*var_values, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe10483);
// compiled call node returning call10484 (depth = 5)
// compiled member node returning call10484 (depth = 4)
  Object if10482 = done;
struct StackFrameObject *iftmpstackframe10482 = stackframe;
  if (istrue(call10484)) {
stackframe = alloc_StackFrame(0, iftmpstackframe10482);
gc_frame_newslot((Object)stackframe);
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
    gc_frame_newslot(*var_moduleObject);
    if10482 = *var_moduleObject;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe10482);
  gc_frame_newslot((Object)stackframe);
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10486 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10485);
// compiled call node returning call10486 (depth = 5)
// compiled member node returning call10486 (depth = 4)
    gc_frame_newslot(call10486);
    if10482 = call10486;
  }
stackframe = iftmpstackframe10482;
// compiled if node returning if10482 (depth = 3)
  *var_node = if10482;
  if (if10482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10489 == NULL) {
    strlit10489 = alloc_String("lbrace");
    gc_root(strlit10489);
  }
// compiled string node returning strlit10489 (depth = 4)
  int op_slot_right_10488 = gc_frame_newslot(strlit10489);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_node (depth = 6)
  partcv[0] = 0;
  Object call10492 = callmethod(*var_node, "kind",
    1, partcv, params);
  gc_frame_end(callframe10491);
// compiled call node returning call10492 (depth = 5)
// compiled member node returning call10492 (depth = 4)
  int op_slot_left_10488 = gc_frame_newslot(call10492);
  params[0] = strlit10489;
  partcv[0] = 1;
  Object opresult10493 = callmethod(call10492, "==", 1, partcv, params);
// compiled op node returning opresult10493 (depth = 3)
  Object if10487 = done;
  if (istrue(opresult10493)) {
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if10487 = undefined;
  } else {
  }
// compiled if node returning if10487 (depth = 2)
// Begin line 3269
  setline(3269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call10495 = callmethod(*var_node, "line",
    1, partcv, params);
  gc_frame_end(callframe10494);
// compiled call node returning call10495 (depth = 4)
// compiled member node returning call10495 (depth = 3)
  *var_oLine = call10495;
  if (call10495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10496 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10497 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10496);
// compiled call node returning call10497 (depth = 4)
// compiled member node returning call10497 (depth = 3)
  *var_preComments = call10497;
  if (call10497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10498 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10499 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10498);
// compiled call node returning call10499 (depth = 4)
// compiled member node returning call10499 (depth = 3)
  *var_postComments = call10499;
  if (call10499 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_comments (depth = 5)
  partcv[0] = 0;
  Object call10501 = callmethod(*var_comments, "size",
    1, partcv, params);
  gc_frame_end(callframe10500);
// compiled call node returning call10501 (depth = 4)
// compiled member node returning call10501 (depth = 3)
  *var_ix = call10501;
  if (call10501 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10502 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block10503 = alloc_Block(NULL, NULL, "parser", 3274);
  gc_frame_newslot(block10503);
// method "_apply"
  block_savedest(block10503);
  Object closure10504 = createclosure(2, "_apply");
  setclosureframe(closure10504, stackframe);
  addtoclosure(closure10504, var_ix);
  addtoclosure(closure10504, selfslot);
  struct UserObject *uo10504 = (struct UserObject*)block10503;
  uo10504->data[0] = (Object)closure10504;
  Method *meth_meth_parser__apply10504 = addmethod2pos(block10503, "_apply", &meth_parser__apply10504, 0);
  int argcv_meth_parser__apply10504[] = {0};
  meth_meth_parser__apply10504->type = alloc_MethodType(1, argcv_meth_parser__apply10504);
  meth_meth_parser__apply10504->definitionModule = modulename;
  meth_meth_parser__apply10504->definitionLine = 3273;
// compiled block node returning block10503 (depth = 3)
  gc_frame_newslot(block10503);
// starting to compile block node (depth = 3)
  Object block10510 = alloc_Block(NULL, NULL, "parser", 3274);
  gc_frame_newslot(block10510);
// method "_apply"
  block_savedest(block10510);
  Object closure10511 = createclosure(6, "_apply");
  setclosureframe(closure10511, stackframe);
  addtoclosure(closure10511, var_ix);
  addtoclosure(closure10511, var_comments);
  addtoclosure(closure10511, var_oLine);
  addtoclosure(closure10511, var_postComments);
  addtoclosure(closure10511, var_preComments);
  addtoclosure(closure10511, selfslot);
  struct UserObject *uo10511 = (struct UserObject*)block10510;
  uo10511->data[0] = (Object)closure10511;
  Method *meth_meth_parser__apply10511 = addmethod2pos(block10510, "_apply", &meth_parser__apply10511, 0);
  int argcv_meth_parser__apply10511[] = {0};
  meth_meth_parser__apply10511->type = alloc_MethodType(1, argcv_meth_parser__apply10511);
  meth_meth_parser__apply10511->definitionModule = modulename;
  meth_meth_parser__apply10511->definitionLine = 3273;
// compiled block node returning block10510 (depth = 3)
  gc_frame_newslot(block10510);
// call case 5: prelude request
  params[0] = block10503;
  params[1] = block10510;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10573 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10502);
// compiled call node returning call10573 (depth = 2)
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10574 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postComments (depth = 5)
  partcv[0] = 0;
  Object call10575 = callmethod(*var_postComments, "size",
    1, partcv, params);
  gc_frame_end(callframe10574);
// compiled call node returning call10575 (depth = 4)
// compiled member node returning call10575 (depth = 3)
  *var_postSz = call10575;
  if (call10575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preComments (depth = 5)
  partcv[0] = 0;
  Object call10577 = callmethod(*var_preComments, "size",
    1, partcv, params);
  gc_frame_end(callframe10576);
// compiled call node returning call10577 (depth = 4)
// compiled member node returning call10577 (depth = 3)
  *var_preSz = call10577;
  if (call10577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10581 = alloc_Float64(1);
// compiled num node returning num10581 (depth = 5)
  int op_slot_right_10580 = gc_frame_newslot(num10581);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_preSz (depth = 5)
  int op_slot_left_10580 = gc_frame_newslot(*var_preSz);
  params[0] = num10581;
  partcv[0] = 1;
  Object opresult10583 = callmethod(*var_preSz, ">", 1, partcv, params);
// compiled op node returning opresult10583 (depth = 4)
  int op_slot_right_10579 = gc_frame_newslot(opresult10583);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num10586 = alloc_Float64(1);
// compiled num node returning num10586 (depth = 5)
  int op_slot_right_10585 = gc_frame_newslot(num10586);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_postSz (depth = 5)
  int op_slot_left_10585 = gc_frame_newslot(*var_postSz);
  params[0] = num10586;
  partcv[0] = 1;
  Object opresult10588 = callmethod(*var_postSz, ">", 1, partcv, params);
// compiled op node returning opresult10588 (depth = 4)
  int op_slot_left_10579 = gc_frame_newslot(opresult10588);
  params[0] = opresult10583;
  partcv[0] = 1;
  Object opresult10589 = callmethod(opresult10588, "&&", 1, partcv, params);
// compiled op node returning opresult10589 (depth = 3)
  Object if10578 = done;
  if (istrue(opresult10589)) {
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10590 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10592 == NULL) {
    strlit10592 = alloc_String("""\x0a""");
    gc_root(strlit10592);
  }
// compiled string node returning strlit10592 (depth = 5)
  int op_slot_right_10591 = gc_frame_newslot(strlit10592);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10594 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_preComments (depth = 9)
  partcv[0] = 0;
  Object call10596 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe10595);
// compiled call node returning call10596 (depth = 8)
// compiled member node returning call10596 (depth = 7)
  partcv[0] = 0;
  Object call10597 = callmethod(call10596, "value",
    1, partcv, params);
  gc_frame_end(callframe10594);
// compiled call node returning call10597 (depth = 6)
// compiled member node returning call10597 (depth = 5)
  int op_slot_left_10591 = gc_frame_newslot(call10597);
  params[0] = strlit10592;
  partcv[0] = 1;
  Object opresult10598 = callmethod(call10597, "++", 1, partcv, params);
// compiled op node returning opresult10598 (depth = 4)
  gc_frame_newslot(opresult10598);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_preComments (depth = 6)
  partcv[0] = 0;
  Object call10600 = callmethod(*var_preComments, "last",
    1, partcv, params);
  gc_frame_end(callframe10599);
// compiled call node returning call10600 (depth = 5)
// compiled member node returning call10600 (depth = 4)
  params[0] = opresult10598;
  partcv[0] = 1;
  Object call10601 = callmethod(call10600, "value:=",
    1, partcv, params);
  gc_frame_end(callframe10590);
// compiled call node returning call10601 (depth = 3)
    gc_frame_newslot(call10601);
    if10578 = call10601;
  } else {
  }
// compiled if node returning if10578 (depth = 2)
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10602 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_preComments (depth = 3)
  gc_frame_newslot(*var_preComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_preComments;
  partcv[0] = 1;
  Object call10603 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe10602);
// compiled call node returning call10603 (depth = 2)
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10604 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_postComments (depth = 3)
  gc_frame_newslot(*var_postComments);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_node (depth = 3)
  params[0] = *var_postComments;
  partcv[0] = 1;
  Object call10605 = callmethod(*var_node, "addComments",
    1, partcv, params);
  gc_frame_end(callframe10604);
// compiled call node returning call10605 (depth = 2)
  gc_frame_end(frame);
  return call10605;
}
Object meth_parser_checkBadOperators10606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkBadOperators (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkBadOperators");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3299
  setline(3299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10609 == NULL) {
    strlit10609 = alloc_String("=");
    gc_root(strlit10609);
  }
// compiled string node returning strlit10609 (depth = 4)
  int op_slot_right_10608 = gc_frame_newslot(strlit10609);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10611 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10612 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10611);
// compiled call node returning call10612 (depth = 5)
// compiled member node returning call10612 (depth = 4)
  int op_slot_left_10608 = gc_frame_newslot(call10612);
  params[0] = strlit10609;
  partcv[0] = 1;
  Object opresult10613 = callmethod(call10612, "==", 1, partcv, params);
// compiled op node returning opresult10613 (depth = 3)
  Object if10607 = done;
  if (istrue(opresult10613)) {
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10614 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call10616 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10615);
// compiled call node returning call10616 (depth = 7)
// compiled member node returning call10616 (depth = 6)
  partcv[0] = 0;
  Object call10617 = callmethod(call10616, "new",
    1, partcv, params);
  gc_frame_end(callframe10614);
// compiled call node returning call10617 (depth = 5)
// compiled member node returning call10617 (depth = 4)
  *var_sugg = call10617;
  if (call10617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3301
  setline(3301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10618 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10619 == NULL) {
    strlit10619 = alloc_String("=");
    gc_root(strlit10619);
  }
// compiled string node returning strlit10619 (depth = 4)
  gc_frame_newslot(strlit10619);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10619;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10620 = callmethod(*var_sugg, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10618);
// compiled call node returning call10620 (depth = 3)
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10621 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10622 == NULL) {
    strlit10622 = alloc_String("use '==' to test equality, not '='.");
    gc_root(strlit10622);
  }
// compiled string node returning strlit10622 (depth = 4)
  gc_frame_newslot(strlit10622);
// Begin line 3303
  setline(3303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10624 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10623);
// compiled call node returning call10624 (depth = 5)
// compiled member node returning call10624 (depth = 4)
  gc_frame_newslot(call10624);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10625 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10626 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10625);
// compiled call node returning call10626 (depth = 5)
// compiled member node returning call10626 (depth = 4)
  gc_frame_newslot(call10626);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10627 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10628 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10627);
// compiled call node returning call10628 (depth = 5)
// compiled member node returning call10628 (depth = 4)
  gc_frame_newslot(call10628);
// Begin line 3304
  setline(3304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10622;
  params[1] = call10624;
  params[2] = call10626;
  params[3] = call10628;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10629 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10621);
// compiled call node returning call10629 (depth = 3)
    gc_frame_newslot(call10629);
    if10607 = call10629;
  } else {
  }
// compiled if node returning if10607 (depth = 2)
// Begin line 3306
  setline(3306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10632 == NULL) {
    strlit10632 = alloc_String("rgeneric");
    gc_root(strlit10632);
  }
// compiled string node returning strlit10632 (depth = 4)
  int op_slot_right_10631 = gc_frame_newslot(strlit10632);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10635 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10634);
// compiled call node returning call10635 (depth = 5)
// compiled member node returning call10635 (depth = 4)
  int op_slot_left_10631 = gc_frame_newslot(call10635);
  params[0] = strlit10632;
  partcv[0] = 1;
  Object opresult10636 = callmethod(call10635, "==", 1, partcv, params);
// compiled op node returning opresult10636 (depth = 3)
  Object if10630 = done;
  if (istrue(opresult10636)) {
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10637 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call10639 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10638);
// compiled call node returning call10639 (depth = 7)
// compiled member node returning call10639 (depth = 6)
  partcv[0] = 0;
  Object call10640 = callmethod(call10639, "new",
    1, partcv, params);
  gc_frame_end(callframe10637);
// compiled call node returning call10640 (depth = 5)
// compiled member node returning call10640 (depth = 4)
  *var_sugg = call10640;
  if (call10640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10641 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10642 == NULL) {
    strlit10642 = alloc_String(" ");
    gc_root(strlit10642);
  }
// compiled string node returning strlit10642 (depth = 4)
  gc_frame_newslot(strlit10642);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10642;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10643 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe10641);
// compiled call node returning call10643 (depth = 3)
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10644 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10645 == NULL) {
    strlit10645 = alloc_String("the '>' operator must be preceded by a space.");
    gc_root(strlit10645);
  }
// compiled string node returning strlit10645 (depth = 4)
  gc_frame_newslot(strlit10645);
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10647 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10646);
// compiled call node returning call10647 (depth = 5)
// compiled member node returning call10647 (depth = 4)
  gc_frame_newslot(call10647);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10649 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10648);
// compiled call node returning call10649 (depth = 5)
// compiled member node returning call10649 (depth = 4)
  gc_frame_newslot(call10649);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10651 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10650);
// compiled call node returning call10651 (depth = 5)
// compiled member node returning call10651 (depth = 4)
  gc_frame_newslot(call10651);
// Begin line 3311
  setline(3311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10645;
  params[1] = call10647;
  params[2] = call10649;
  params[3] = call10651;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10652 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10644);
// compiled call node returning call10652 (depth = 3)
    gc_frame_newslot(call10652);
    if10630 = call10652;
  } else {
  }
// compiled if node returning if10630 (depth = 2)
  gc_frame_end(frame);
  return if10630;
}
Object meth_parser_checkBadTypeLiteral10653(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkBadTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkBadTypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit10656 == NULL) {
    strlit10656 = alloc_String("lbrace");
    gc_root(strlit10656);
  }
// compiled string node returning strlit10656 (depth = 4)
  int op_slot_right_10655 = gc_frame_newslot(strlit10656);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10659 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10658);
// compiled call node returning call10659 (depth = 5)
// compiled member node returning call10659 (depth = 4)
  int op_slot_left_10655 = gc_frame_newslot(call10659);
  params[0] = strlit10656;
  partcv[0] = 1;
  Object opresult10660 = callmethod(call10659, "==", 1, partcv, params);
// compiled op node returning opresult10660 (depth = 3)
  Object if10654 = done;
  if (istrue(opresult10660)) {
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10661 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call10663 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10662);
// compiled call node returning call10663 (depth = 7)
// compiled member node returning call10663 (depth = 6)
  partcv[0] = 0;
  Object call10664 = callmethod(call10663, "new",
    1, partcv, params);
  gc_frame_end(callframe10661);
// compiled call node returning call10664 (depth = 5)
// compiled member node returning call10664 (depth = 4)
  *var_sugg = call10664;
  if (call10664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10665 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10666 == NULL) {
    strlit10666 = alloc_String("type ");
    gc_root(strlit10666);
  }
// compiled string node returning strlit10666 (depth = 4)
  gc_frame_newslot(strlit10666);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit10666;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10667 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe10665);
// compiled call node returning call10667 (depth = 3)
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10668 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10669 == NULL) {
    strlit10669 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit10669);
  }
// compiled string node returning strlit10669 (depth = 4)
  gc_frame_newslot(strlit10669);
// Begin line 3320
  setline(3320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10670 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10671 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10670);
// compiled call node returning call10671 (depth = 5)
// compiled member node returning call10671 (depth = 4)
  gc_frame_newslot(call10671);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10673 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10672);
// compiled call node returning call10673 (depth = 5)
// compiled member node returning call10673 (depth = 4)
  gc_frame_newslot(call10673);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10674 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10675 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10674);
// compiled call node returning call10675 (depth = 5)
// compiled member node returning call10675 (depth = 4)
  gc_frame_newslot(call10675);
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit10669;
  params[1] = call10671;
  params[2] = call10673;
  params[3] = call10675;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10676 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10668);
// compiled call node returning call10676 (depth = 3)
    gc_frame_newslot(call10676);
    if10654 = call10676;
  } else {
  }
// compiled if node returning if10654 (depth = 2)
  gc_frame_end(frame);
  return if10654;
}
Object meth_parser__apply10781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10783 == NULL) {
    strlit10783 = alloc_String("identifier");
    gc_root(strlit10783);
  }
// compiled string node returning strlit10783 (depth = 8)
  int op_slot_right_10782 = gc_frame_newslot(strlit10783);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10786 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10785);
// compiled call node returning call10786 (depth = 9)
// compiled member node returning call10786 (depth = 8)
  int op_slot_left_10782 = gc_frame_newslot(call10786);
  params[0] = strlit10783;
  partcv[0] = 1;
  Object opresult10787 = callmethod(call10786, "==", 1, partcv, params);
// compiled op node returning opresult10787 (depth = 7)
  gc_frame_end(frame);
  return opresult10787;
}
Object meth_parser__apply10795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit10797 == NULL) {
    strlit10797 = alloc_String("member");
    gc_root(strlit10797);
  }
// compiled string node returning strlit10797 (depth = 11)
  int op_slot_right_10796 = gc_frame_newslot(strlit10797);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10799 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call10801 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10800);
// compiled call node returning call10801 (depth = 14)
// compiled member node returning call10801 (depth = 13)
  partcv[0] = 0;
  Object call10802 = callmethod(call10801, "kind",
    1, partcv, params);
  gc_frame_end(callframe10799);
// compiled call node returning call10802 (depth = 12)
// compiled member node returning call10802 (depth = 11)
  int op_slot_left_10796 = gc_frame_newslot(call10802);
  params[0] = strlit10797;
  partcv[0] = 1;
  Object opresult10803 = callmethod(call10802, "==", 1, partcv, params);
// compiled op node returning opresult10803 (depth = 10)
  gc_frame_end(frame);
  return opresult10803;
}
Object meth_parser__apply10792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block10794 = alloc_Block(NULL, NULL, "parser", 3351);
  gc_frame_newslot(block10794);
// method "_apply"
  block_savedest(block10794);
  Object closure10795 = createclosure(2, "_apply");
  setclosureframe(closure10795, stackframe);
  addtoclosure(closure10795, var_values);
  addtoclosure(closure10795, selfslot);
  struct UserObject *uo10795 = (struct UserObject*)block10794;
  uo10795->data[0] = (Object)closure10795;
  Method *meth_meth_parser__apply10795 = addmethod2pos(block10794, "_apply", &meth_parser__apply10795, 0);
  int argcv_meth_parser__apply10795[] = {0};
  meth_meth_parser__apply10795->type = alloc_MethodType(1, argcv_meth_parser__apply10795);
  meth_meth_parser__apply10795->definitionModule = modulename;
  meth_meth_parser__apply10795->definitionLine = 3351;
// compiled block node returning block10794 (depth = 9)
  int op_slot_right_10793 = gc_frame_newslot(block10794);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10807 == NULL) {
    strlit10807 = alloc_String("identifier");
    gc_root(strlit10807);
  }
// compiled string node returning strlit10807 (depth = 10)
  int op_slot_right_10806 = gc_frame_newslot(strlit10807);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10809 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call10811 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10810);
// compiled call node returning call10811 (depth = 13)
// compiled member node returning call10811 (depth = 12)
  partcv[0] = 0;
  Object call10812 = callmethod(call10811, "kind",
    1, partcv, params);
  gc_frame_end(callframe10809);
// compiled call node returning call10812 (depth = 11)
// compiled member node returning call10812 (depth = 10)
  int op_slot_left_10806 = gc_frame_newslot(call10812);
  params[0] = strlit10807;
  partcv[0] = 1;
  Object opresult10813 = callmethod(call10812, "==", 1, partcv, params);
// compiled op node returning opresult10813 (depth = 9)
  int op_slot_left_10793 = gc_frame_newslot(opresult10813);
  params[0] = block10794;
  partcv[0] = 1;
  Object opresult10814 = callmethod(opresult10813, "||", 1, partcv, params);
// compiled op node returning opresult10814 (depth = 8)
  gc_frame_end(frame);
  return opresult10814;
}
Object meth_parser_checkUnexpectedTokenAfterStatement10677(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for checkUnexpectedTokenAfterStatement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for checkUnexpectedTokenAfterStatement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3326
  setline(3326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10680 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call10681 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10680);
// compiled call node returning call10681 (depth = 5)
// compiled member node returning call10681 (depth = 4)
  int op_slot_right_10679 = gc_frame_newslot(call10681);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10683 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10684 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10683);
// compiled call node returning call10684 (depth = 5)
// compiled member node returning call10684 (depth = 4)
  int op_slot_left_10679 = gc_frame_newslot(call10684);
  params[0] = call10681;
  partcv[0] = 1;
  Object opresult10685 = callmethod(call10684, "==", 1, partcv, params);
// compiled op node returning opresult10685 (depth = 3)
  Object if10678 = done;
  if (istrue(opresult10685)) {
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10689 == NULL) {
    strlit10689 = alloc_String("identifier");
    gc_root(strlit10689);
  }
// compiled string node returning strlit10689 (depth = 6)
  int op_slot_right_10688 = gc_frame_newslot(strlit10689);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call10692 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe10691);
// compiled call node returning call10692 (depth = 7)
// compiled member node returning call10692 (depth = 6)
  int op_slot_left_10688 = gc_frame_newslot(call10692);
  params[0] = strlit10689;
  partcv[0] = 1;
  Object opresult10693 = callmethod(call10692, "==", 1, partcv, params);
// compiled op node returning opresult10693 (depth = 5)
  int op_slot_right_10687 = gc_frame_newslot(opresult10693);
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10697 == NULL) {
    strlit10697 = alloc_String("=");
    gc_root(strlit10697);
  }
// compiled string node returning strlit10697 (depth = 7)
  int op_slot_right_10696 = gc_frame_newslot(strlit10697);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10700 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10699);
// compiled call node returning call10700 (depth = 8)
// compiled member node returning call10700 (depth = 7)
  int op_slot_left_10696 = gc_frame_newslot(call10700);
  params[0] = strlit10697;
  partcv[0] = 1;
  Object opresult10701 = callmethod(call10700, "==", 1, partcv, params);
// compiled op node returning opresult10701 (depth = 6)
  int op_slot_right_10695 = gc_frame_newslot(opresult10701);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10704 == NULL) {
    strlit10704 = alloc_String("op");
    gc_root(strlit10704);
  }
// compiled string node returning strlit10704 (depth = 7)
  int op_slot_right_10703 = gc_frame_newslot(strlit10704);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10707 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10706);
// compiled call node returning call10707 (depth = 8)
// compiled member node returning call10707 (depth = 7)
  int op_slot_left_10703 = gc_frame_newslot(call10707);
  params[0] = strlit10704;
  partcv[0] = 1;
  Object opresult10708 = callmethod(call10707, "==", 1, partcv, params);
// compiled op node returning opresult10708 (depth = 6)
  int op_slot_left_10695 = gc_frame_newslot(opresult10708);
  params[0] = opresult10701;
  partcv[0] = 1;
  Object opresult10709 = callmethod(opresult10708, "&&", 1, partcv, params);
// compiled op node returning opresult10709 (depth = 5)
  int op_slot_left_10687 = gc_frame_newslot(opresult10709);
  params[0] = opresult10693;
  partcv[0] = 1;
  Object opresult10710 = callmethod(opresult10709, "&&", 1, partcv, params);
// compiled op node returning opresult10710 (depth = 4)
  Object if10686 = done;
  if (istrue(opresult10710)) {
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10711 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10712 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10713 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10712);
// compiled call node returning call10713 (depth = 8)
// compiled member node returning call10713 (depth = 7)
  partcv[0] = 0;
  Object call10714 = callmethod(call10713, "new",
    1, partcv, params);
  gc_frame_end(callframe10711);
// compiled call node returning call10714 (depth = 6)
// compiled member node returning call10714 (depth = 5)
  *var_sugg = call10714;
  if (call10714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3330
  setline(3330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array10715 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10715 (depth = 5)
  *var_suggestions = array10715;
  if (array10715 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3331
  setline(3331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10716 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool10717 = alloc_Boolean(0);
// compiled identifier node returning bool10717 (depth = 5)
  gc_frame_newslot(bool10717);
// starting to compile identifier node (depth = 5)
  Object bool10718 = alloc_Boolean(0);
// compiled identifier node returning bool10718 (depth = 5)
  gc_frame_newslot(bool10718);
// starting to compile string node (depth = 5)
  if (strlit10719 == NULL) {
    strlit10719 = alloc_String(":=");
    gc_root(strlit10719);
  }
// compiled string node returning strlit10719 (depth = 5)
  gc_frame_newslot(strlit10719);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool10717;
  params[2] = bool10718;
  params[3] = strlit10719;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10720 = callmethod(*var_sugg, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10716);
// compiled call node returning call10720 (depth = 4)
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10721 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call10722 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10721);
// compiled call node returning call10722 (depth = 4)
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10723 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10725 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10724);
// compiled call node returning call10725 (depth = 8)
// compiled member node returning call10725 (depth = 7)
  partcv[0] = 0;
  Object call10726 = callmethod(call10725, "new",
    1, partcv, params);
  gc_frame_end(callframe10723);
// compiled call node returning call10726 (depth = 6)
// compiled member node returning call10726 (depth = 5)
  *var_sugg2 = call10726;
  if (call10726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3334
  setline(3334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10727 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool10728 = alloc_Boolean(0);
// compiled identifier node returning bool10728 (depth = 5)
  gc_frame_newslot(bool10728);
// starting to compile identifier node (depth = 5)
  Object bool10729 = alloc_Boolean(0);
// compiled identifier node returning bool10729 (depth = 5)
  gc_frame_newslot(bool10729);
// starting to compile string node (depth = 5)
  if (strlit10730 == NULL) {
    strlit10730 = alloc_String("==");
    gc_root(strlit10730);
  }
// compiled string node returning strlit10730 (depth = 5)
  gc_frame_newslot(strlit10730);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool10728;
  params[2] = bool10729;
  params[3] = strlit10730;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10731 = callmethod(*var_sugg2, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10727);
// compiled call node returning call10731 (depth = 4)
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10732 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call10733 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10732);
// compiled call node returning call10733 (depth = 4)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10734 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10735 == NULL) {
    strlit10735 = alloc_String("assignment uses ':=', not '='.");
    gc_root(strlit10735);
  }
// compiled string node returning strlit10735 (depth = 5)
  gc_frame_newslot(strlit10735);
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10737 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10736);
// compiled call node returning call10737 (depth = 6)
// compiled member node returning call10737 (depth = 5)
  gc_frame_newslot(call10737);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10738 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10739 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10738);
// compiled call node returning call10739 (depth = 6)
// compiled member node returning call10739 (depth = 5)
  gc_frame_newslot(call10739);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10741 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10740);
// compiled call node returning call10741 (depth = 6)
// compiled member node returning call10741 (depth = 5)
  gc_frame_newslot(call10741);
// Begin line 3338
  setline(3338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10735;
  params[1] = call10737;
  params[2] = call10739;
  params[3] = call10741;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10742 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10734);
// compiled call node returning call10742 (depth = 4)
    gc_frame_newslot(call10742);
    if10686 = call10742;
  } else {
  }
// compiled if node returning if10686 (depth = 3)
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10745 == NULL) {
    strlit10745 = alloc_String("rgeneric");
    gc_root(strlit10745);
  }
// compiled string node returning strlit10745 (depth = 5)
  int op_slot_right_10744 = gc_frame_newslot(strlit10745);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10747 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10748 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10747);
// compiled call node returning call10748 (depth = 6)
// compiled member node returning call10748 (depth = 5)
  int op_slot_left_10744 = gc_frame_newslot(call10748);
  params[0] = strlit10745;
  partcv[0] = 1;
  Object opresult10749 = callmethod(call10748, "==", 1, partcv, params);
// compiled op node returning opresult10749 (depth = 4)
  Object if10743 = done;
  if (istrue(opresult10749)) {
// Begin line 3341
  setline(3341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10750 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10752 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10751);
// compiled call node returning call10752 (depth = 8)
// compiled member node returning call10752 (depth = 7)
  partcv[0] = 0;
  Object call10753 = callmethod(call10752, "new",
    1, partcv, params);
  gc_frame_end(callframe10750);
// compiled call node returning call10753 (depth = 6)
// compiled member node returning call10753 (depth = 5)
  *var_sugg = call10753;
  if (call10753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3342
  setline(3342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10754 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10755 == NULL) {
    strlit10755 = alloc_String(" ");
    gc_root(strlit10755);
  }
// compiled string node returning strlit10755 (depth = 5)
  gc_frame_newslot(strlit10755);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10757 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10756);
// compiled call node returning call10757 (depth = 6)
// compiled member node returning call10757 (depth = 5)
  gc_frame_newslot(call10757);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10759 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10758);
// compiled call node returning call10759 (depth = 6)
// compiled member node returning call10759 (depth = 5)
  gc_frame_newslot(call10759);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = strlit10755;
  params[1] = call10757;
  params[2] = call10759;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10760 = callmethod(*var_sugg, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe10754);
// compiled call node returning call10760 (depth = 4)
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10761 = gc_frame_new();
// Begin line 3344
  setline(3344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit10762 == NULL) {
    strlit10762 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit10762);
  }
// compiled string node returning strlit10762 (depth = 5)
  gc_frame_newslot(strlit10762);
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10764 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10763);
// compiled call node returning call10764 (depth = 6)
// compiled member node returning call10764 (depth = 5)
  gc_frame_newslot(call10764);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10765 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10766 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10765);
// compiled call node returning call10766 (depth = 6)
// compiled member node returning call10766 (depth = 5)
  gc_frame_newslot(call10766);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10767 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10768 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10767);
// compiled call node returning call10768 (depth = 6)
// compiled member node returning call10768 (depth = 5)
  gc_frame_newslot(call10768);
// Begin line 3346
  setline(3346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10762;
  params[1] = call10764;
  params[2] = call10766;
  params[3] = call10768;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10769 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10761);
// compiled call node returning call10769 (depth = 4)
    gc_frame_newslot(call10769);
    if10743 = call10769;
  } else {
  }
// compiled if node returning if10743 (depth = 3)
// Begin line 3348
  setline(3348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10772 == NULL) {
    strlit10772 = alloc_String("rbrace");
    gc_root(strlit10772);
  }
// compiled string node returning strlit10772 (depth = 5)
  int op_slot_right_10771 = gc_frame_newslot(strlit10772);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10775 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10774);
// compiled call node returning call10775 (depth = 6)
// compiled member node returning call10775 (depth = 5)
  int op_slot_left_10771 = gc_frame_newslot(call10775);
  params[0] = strlit10772;
  partcv[0] = 1;
  Object opresult10776 = callmethod(call10775, "≠", 1, partcv, params);
// compiled op node returning opresult10776 (depth = 4)
  Object if10770 = done;
  if (istrue(opresult10776)) {
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile array node (depth = 5)
  Object array10777 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10777 (depth = 5)
  *var_suggestions = array10777;
  if (array10777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block10780 = alloc_Block(NULL, NULL, "parser", 3351);
  gc_frame_newslot(block10780);
// method "_apply"
  block_savedest(block10780);
  Object closure10781 = createclosure(2, "_apply");
  setclosureframe(closure10781, stackframe);
  addtoclosure(closure10781, var_sym);
  addtoclosure(closure10781, selfslot);
  struct UserObject *uo10781 = (struct UserObject*)block10780;
  uo10781->data[0] = (Object)closure10781;
  Method *meth_meth_parser__apply10781 = addmethod2pos(block10780, "_apply", &meth_parser__apply10781, 0);
  int argcv_meth_parser__apply10781[] = {0};
  meth_meth_parser__apply10781->type = alloc_MethodType(1, argcv_meth_parser__apply10781);
  meth_meth_parser__apply10781->definitionModule = modulename;
  meth_meth_parser__apply10781->definitionLine = 3348;
// compiled block node returning block10780 (depth = 6)
  int op_slot_right_10779 = gc_frame_newslot(block10780);
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block10791 = alloc_Block(NULL, NULL, "parser", 3351);
  gc_frame_newslot(block10791);
// method "_apply"
  block_savedest(block10791);
  Object closure10792 = createclosure(2, "_apply");
  setclosureframe(closure10792, stackframe);
  addtoclosure(closure10792, var_values);
  addtoclosure(closure10792, selfslot);
  struct UserObject *uo10792 = (struct UserObject*)block10791;
  uo10792->data[0] = (Object)closure10792;
  Method *meth_meth_parser__apply10792 = addmethod2pos(block10791, "_apply", &meth_parser__apply10792, 0);
  int argcv_meth_parser__apply10792[] = {0};
  meth_meth_parser__apply10792->type = alloc_MethodType(1, argcv_meth_parser__apply10792);
  meth_meth_parser__apply10792->definitionModule = modulename;
  meth_meth_parser__apply10792->definitionLine = 3351;
// compiled block node returning block10791 (depth = 7)
  int op_slot_right_10790 = gc_frame_newslot(block10791);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10818 = alloc_Float64(0);
// compiled num node returning num10818 (depth = 8)
  int op_slot_right_10817 = gc_frame_newslot(num10818);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call10821 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe10820);
// compiled call node returning call10821 (depth = 9)
// compiled member node returning call10821 (depth = 8)
  int op_slot_left_10817 = gc_frame_newslot(call10821);
  params[0] = num10818;
  partcv[0] = 1;
  Object opresult10822 = callmethod(call10821, ">", 1, partcv, params);
// compiled op node returning opresult10822 (depth = 7)
  int op_slot_left_10790 = gc_frame_newslot(opresult10822);
  params[0] = block10791;
  partcv[0] = 1;
  Object opresult10823 = callmethod(opresult10822, "&&", 1, partcv, params);
// compiled op node returning opresult10823 (depth = 6)
  int op_slot_left_10779 = gc_frame_newslot(opresult10823);
  params[0] = block10780;
  partcv[0] = 1;
  Object opresult10824 = callmethod(opresult10823, "&&", 1, partcv, params);
// compiled op node returning opresult10824 (depth = 5)
  Object if10778 = done;
  if (istrue(opresult10824)) {
// Begin line 3352
  setline(3352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10825 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10827 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10826);
// compiled call node returning call10827 (depth = 9)
// compiled member node returning call10827 (depth = 8)
  partcv[0] = 0;
  Object call10828 = callmethod(call10827, "new",
    1, partcv, params);
  gc_frame_end(callframe10825);
// compiled call node returning call10828 (depth = 7)
// compiled member node returning call10828 (depth = 6)
  *var_suggestion = call10828;
  if (call10828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3353
  setline(3353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10830 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool10831 = alloc_Boolean(1);
// compiled identifier node returning bool10831 (depth = 6)
  gc_frame_newslot(bool10831);
// starting to compile identifier node (depth = 6)
  Object bool10832 = alloc_Boolean(0);
// compiled identifier node returning bool10832 (depth = 6)
  gc_frame_newslot(bool10832);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10834 == NULL) {
    strlit10834 = alloc_String(")");
    gc_root(strlit10834);
  }
// compiled string node returning strlit10834 (depth = 7)
  int op_slot_right_10833 = gc_frame_newslot(strlit10834);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10838 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10837);
// compiled call node returning call10838 (depth = 9)
// compiled member node returning call10838 (depth = 8)
  int op_slot_right_10836 = gc_frame_newslot(call10838);
// starting to compile string node (depth = 8)
  if (strlit10840 == NULL) {
    strlit10840 = alloc_String("(");
    gc_root(strlit10840);
  }
// compiled string node returning strlit10840 (depth = 8)
  int op_slot_left_10836 = gc_frame_newslot(strlit10840);
  params[0] = call10838;
  partcv[0] = 1;
  Object opresult10841 = callmethod(strlit10840, "++", 1, partcv, params);
// compiled op node returning opresult10841 (depth = 7)
  int op_slot_left_10833 = gc_frame_newslot(opresult10841);
  params[0] = strlit10834;
  partcv[0] = 1;
  Object opresult10842 = callmethod(opresult10841, "++", 1, partcv, params);
// compiled op node returning opresult10842 (depth = 6)
  gc_frame_newslot(opresult10842);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool10831;
  params[2] = bool10832;
  params[3] = opresult10842;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10843 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10830);
// compiled call node returning call10843 (depth = 5)
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10844 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10845 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10844);
// compiled call node returning call10845 (depth = 5)
// Begin line 3355
  setline(3355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10848 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10849 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe10848);
// compiled call node returning call10849 (depth = 8)
// compiled member node returning call10849 (depth = 7)
  int op_slot_right_10847 = gc_frame_newslot(call10849);
// starting to compile identifier node (depth = 7)
  Object bool10851 = alloc_Boolean(0);
// compiled identifier node returning bool10851 (depth = 7)
  int op_slot_left_10847 = gc_frame_newslot(bool10851);
  params[0] = call10849;
  partcv[0] = 1;
  Object opresult10852 = callmethod(bool10851, "≠", 1, partcv, params);
// compiled op node returning opresult10852 (depth = 6)
  Object if10846 = done;
  if (istrue(opresult10852)) {
// Begin line 3356
  setline(3356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10854 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe10853);
// compiled call node returning call10854 (depth = 8)
// compiled member node returning call10854 (depth = 7)
  *var_n = call10854;
  if (call10854 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3357
  setline(3357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10857 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10858 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10857);
// compiled call node returning call10858 (depth = 9)
// compiled member node returning call10858 (depth = 8)
  int op_slot_right_10856 = gc_frame_newslot(call10858);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call10861 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe10860);
// compiled call node returning call10861 (depth = 9)
// compiled member node returning call10861 (depth = 8)
  int op_slot_left_10856 = gc_frame_newslot(call10861);
  params[0] = call10858;
  partcv[0] = 1;
  Object opresult10862 = callmethod(call10861, "==", 1, partcv, params);
// compiled op node returning opresult10862 (depth = 7)
  Object if10855 = done;
  if (istrue(opresult10862)) {
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10863 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call10865 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10864);
// compiled call node returning call10865 (depth = 11)
// compiled member node returning call10865 (depth = 10)
  partcv[0] = 0;
  Object call10866 = callmethod(call10865, "new",
    1, partcv, params);
  gc_frame_end(callframe10863);
// compiled call node returning call10866 (depth = 9)
// compiled member node returning call10866 (depth = 8)
  *var_suggestion = call10866;
  if (call10866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10868 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool10869 = alloc_Boolean(1);
// compiled identifier node returning bool10869 (depth = 8)
  gc_frame_newslot(bool10869);
// starting to compile identifier node (depth = 8)
  Object bool10870 = alloc_Boolean(0);
// compiled identifier node returning bool10870 (depth = 8)
  gc_frame_newslot(bool10870);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10872 == NULL) {
    strlit10872 = alloc_String("");
    gc_root(strlit10872);
  }
// compiled string node returning strlit10872 (depth = 9)
  int op_slot_right_10871 = gc_frame_newslot(strlit10872);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10876 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10875);
// compiled call node returning call10876 (depth = 11)
// compiled member node returning call10876 (depth = 10)
  int op_slot_right_10874 = gc_frame_newslot(call10876);
// starting to compile string node (depth = 10)
  if (strlit10878 == NULL) {
    strlit10878 = alloc_String("(");
    gc_root(strlit10878);
  }
// compiled string node returning strlit10878 (depth = 10)
  int op_slot_left_10874 = gc_frame_newslot(strlit10878);
  params[0] = call10876;
  partcv[0] = 1;
  Object opresult10879 = callmethod(strlit10878, "++", 1, partcv, params);
// compiled op node returning opresult10879 (depth = 9)
  int op_slot_left_10871 = gc_frame_newslot(opresult10879);
  params[0] = strlit10872;
  partcv[0] = 1;
  Object opresult10880 = callmethod(opresult10879, "++", 1, partcv, params);
// compiled op node returning opresult10880 (depth = 8)
  gc_frame_newslot(opresult10880);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool10869;
  params[2] = bool10870;
  params[3] = opresult10880;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10881 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10868);
// compiled call node returning call10881 (depth = 7)
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10882 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10883 == NULL) {
    strlit10883 = alloc_String(")");
    gc_root(strlit10883);
  }
// compiled string node returning strlit10883 (depth = 8)
  gc_frame_newslot(strlit10883);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10884 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10885 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10884);
// compiled call node returning call10885 (depth = 9)
// compiled member node returning call10885 (depth = 8)
  gc_frame_newslot(call10885);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit10883;
  params[1] = call10885;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10886 = callmethod(*var_suggestion, "append()onLine",
    2, partcv, params);
  gc_frame_end(callframe10882);
// compiled call node returning call10886 (depth = 7)
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe10887 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10888 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10887);
// compiled call node returning call10888 (depth = 7)
    gc_frame_newslot(call10888);
    if10855 = call10888;
  } else {
  }
// compiled if node returning if10855 (depth = 6)
    gc_frame_newslot(if10855);
    if10846 = if10855;
  } else {
  }
// compiled if node returning if10846 (depth = 5)
// Begin line 3364
  setline(3364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10891 == NULL) {
    strlit10891 = alloc_String("identifier");
    gc_root(strlit10891);
  }
// compiled string node returning strlit10891 (depth = 7)
  int op_slot_right_10890 = gc_frame_newslot(strlit10891);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10893 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call10895 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10894);
// compiled call node returning call10895 (depth = 10)
// compiled member node returning call10895 (depth = 9)
  partcv[0] = 0;
  Object call10896 = callmethod(call10895, "kind",
    1, partcv, params);
  gc_frame_end(callframe10893);
// compiled call node returning call10896 (depth = 8)
// compiled member node returning call10896 (depth = 7)
  int op_slot_left_10890 = gc_frame_newslot(call10896);
  params[0] = strlit10891;
  partcv[0] = 1;
  Object opresult10897 = callmethod(call10896, "==", 1, partcv, params);
// compiled op node returning opresult10897 (depth = 6)
  Object if10889 = done;
  if (istrue(opresult10897)) {
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10898 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call10900 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10899);
// compiled call node returning call10900 (depth = 10)
// compiled member node returning call10900 (depth = 9)
  partcv[0] = 0;
  Object call10901 = callmethod(call10900, "new",
    1, partcv, params);
  gc_frame_end(callframe10898);
// compiled call node returning call10901 (depth = 8)
// compiled member node returning call10901 (depth = 7)
  *var_suggestion = call10901;
  if (call10901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10903 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool10904 = alloc_Boolean(0);
// compiled identifier node returning bool10904 (depth = 7)
  gc_frame_newslot(bool10904);
// starting to compile identifier node (depth = 7)
  Object bool10905 = alloc_Boolean(0);
// compiled identifier node returning bool10905 (depth = 7)
  gc_frame_newslot(bool10905);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10907 == NULL) {
    strlit10907 = alloc_String("""\x22""");
    gc_root(strlit10907);
  }
// compiled string node returning strlit10907 (depth = 8)
  int op_slot_right_10906 = gc_frame_newslot(strlit10907);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10910 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10911 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10910);
// compiled call node returning call10911 (depth = 10)
// compiled member node returning call10911 (depth = 9)
  int op_slot_right_10909 = gc_frame_newslot(call10911);
// starting to compile string node (depth = 9)
  if (strlit10913 == NULL) {
    strlit10913 = alloc_String("""\x22""");
    gc_root(strlit10913);
  }
// compiled string node returning strlit10913 (depth = 9)
  int op_slot_left_10909 = gc_frame_newslot(strlit10913);
  params[0] = call10911;
  partcv[0] = 1;
  Object opresult10914 = callmethod(strlit10913, "++", 1, partcv, params);
// compiled op node returning opresult10914 (depth = 8)
  int op_slot_left_10906 = gc_frame_newslot(opresult10914);
  params[0] = strlit10907;
  partcv[0] = 1;
  Object opresult10915 = callmethod(opresult10914, "++", 1, partcv, params);
// compiled op node returning opresult10915 (depth = 7)
  gc_frame_newslot(opresult10915);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool10904;
  params[2] = bool10905;
  params[3] = opresult10915;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10916 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10903);
// compiled call node returning call10916 (depth = 6)
// Begin line 3367
  setline(3367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10917 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10918 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10917);
// compiled call node returning call10918 (depth = 6)
    gc_frame_newslot(call10918);
    if10889 = call10918;
  } else {
  }
// compiled if node returning if10889 (depth = 5)
    gc_frame_newslot(if10889);
    if10778 = if10889;
  } else {
  }
// compiled if node returning if10778 (depth = 4)
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10919 = gc_frame_new();
// starting to compile array node (depth = 6)
  Object array10920 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 7)
  if (strlit10921 == NULL) {
    strlit10921 = alloc_String("rbrace");
    gc_root(strlit10921);
  }
// compiled string node returning strlit10921 (depth = 7)
  params[0] = strlit10921;
  partcv[0] = 1;
  callmethodflags(array10920, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array10920 (depth = 6)
  gc_frame_newslot(array10920);
// call case 4: self request
  params[0] = array10920;
  partcv[0] = 1;
  Object call10922 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10919);
// compiled call node returning call10922 (depth = 5)
  *var_nextTok = call10922;
  if (call10922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3371
  setline(3371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_10924 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_10924 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10926 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10926 (depth = 5)
  Object if10923 = done;
  if (istrue(opresult10926)) {
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10927 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10929 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10928);
// compiled call node returning call10929 (depth = 9)
// compiled member node returning call10929 (depth = 8)
  partcv[0] = 0;
  Object call10930 = callmethod(call10929, "new",
    1, partcv, params);
  gc_frame_end(callframe10927);
// compiled call node returning call10930 (depth = 7)
// compiled member node returning call10930 (depth = 6)
  *var_suggestion = call10930;
  if (call10930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3373
  setline(3373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10932 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call10934 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10933);
// compiled call node returning call10934 (depth = 7)
// compiled member node returning call10934 (depth = 6)
  gc_frame_newslot(call10934);
// starting to compile call node (depth = 6)
  int callframe10935 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num10936 = alloc_Float64(1);
// compiled num node returning num10936 (depth = 7)
  gc_frame_newslot(num10936);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num10938 = alloc_Float64(1);
// compiled num node returning num10938 (depth = 8)
  int op_slot_right_10937 = gc_frame_newslot(num10938);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call10942 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10941);
// compiled call node returning call10942 (depth = 10)
// compiled member node returning call10942 (depth = 9)
  int op_slot_right_10940 = gc_frame_newslot(call10942);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call10945 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10944);
// compiled call node returning call10945 (depth = 10)
// compiled member node returning call10945 (depth = 9)
  int op_slot_left_10940 = gc_frame_newslot(call10945);
  params[0] = call10942;
  partcv[0] = 1;
  Object sum10946 = callmethod(call10945, "+", 1, partcv, params);
// compiled op node returning sum10946 (depth = 8)
  int op_slot_left_10937 = gc_frame_newslot(sum10946);
  params[0] = num10938;
  partcv[0] = 1;
  Object diff10947 = callmethod(sum10946, "-", 1, partcv, params);
// compiled op node returning diff10947 (depth = 7)
  gc_frame_newslot(diff10947);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10948 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10949 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10950 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10949);
// compiled call node returning call10950 (depth = 9)
// compiled member node returning call10950 (depth = 8)
  gc_frame_newslot(call10950);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call10952 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10951);
// compiled call node returning call10952 (depth = 9)
// compiled member node returning call10952 (depth = 8)
  params[0] = call10950;
  partcv[0] = 1;
  Object call10953 = callmethod(call10952, "at",
    1, partcv, params);
  gc_frame_end(callframe10948);
// compiled call node returning call10953 (depth = 7)
  params[0] = num10936;
  params[1] = diff10947;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10954 = callmethod(call10953, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10935);
// compiled call node returning call10954 (depth = 6)
  gc_frame_newslot(call10954);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call10934;
  params[1] = call10954;
  partcv[0] = 2;
  Object call10955 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10932);
// compiled call node returning call10955 (depth = 5)
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10956 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10958 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10957);
// compiled call node returning call10958 (depth = 8)
// compiled member node returning call10958 (depth = 7)
  gc_frame_newslot(call10958);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10959 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe10960 = gc_frame_new();
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10962 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10961);
// compiled call node returning call10962 (depth = 11)
// compiled member node returning call10962 (depth = 10)
  gc_frame_newslot(call10962);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call10964 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10963);
// compiled call node returning call10964 (depth = 11)
// compiled member node returning call10964 (depth = 10)
  params[0] = call10962;
  partcv[0] = 1;
  Object call10965 = callmethod(call10964, "at",
    1, partcv, params);
  gc_frame_end(callframe10960);
// compiled call node returning call10965 (depth = 9)
  partcv[0] = 0;
  Object call10966 = callmethod(call10965, "size",
    1, partcv, params);
  gc_frame_end(callframe10959);
// compiled call node returning call10966 (depth = 8)
// compiled member node returning call10966 (depth = 7)
  gc_frame_newslot(call10966);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10967 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10969 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10968);
// compiled call node returning call10969 (depth = 9)
// compiled member node returning call10969 (depth = 8)
  gc_frame_newslot(call10969);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call10971 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10970);
// compiled call node returning call10971 (depth = 9)
// compiled member node returning call10971 (depth = 8)
  params[0] = call10969;
  partcv[0] = 1;
  Object call10972 = callmethod(call10971, "at",
    1, partcv, params);
  gc_frame_end(callframe10967);
// compiled call node returning call10972 (depth = 7)
  params[0] = call10958;
  params[1] = call10966;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10973 = callmethod(call10972, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10956);
// compiled call node returning call10973 (depth = 6)
  *var_newLine = call10973;
  if (call10973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10974 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10976 = alloc_Float64(0.1);
// compiled num node returning num10976 (depth = 7)
  int op_slot_right_10975 = gc_frame_newslot(num10976);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10979 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10978);
// compiled call node returning call10979 (depth = 8)
// compiled member node returning call10979 (depth = 7)
  int op_slot_left_10975 = gc_frame_newslot(call10979);
  params[0] = num10976;
  partcv[0] = 1;
  Object sum10980 = callmethod(call10979, "+", 1, partcv, params);
// compiled op node returning sum10980 (depth = 6)
  gc_frame_newslot(sum10980);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum10980;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10981 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10974);
// compiled call node returning call10981 (depth = 5)
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10982 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10983 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10982);
// compiled call node returning call10983 (depth = 5)
    gc_frame_newslot(call10983);
    if10923 = call10983;
  } else {
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10984 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10986 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10985);
// compiled call node returning call10986 (depth = 9)
// compiled member node returning call10986 (depth = 8)
  partcv[0] = 0;
  Object call10987 = callmethod(call10986, "new",
    1, partcv, params);
  gc_frame_end(callframe10984);
// compiled call node returning call10987 (depth = 7)
// compiled member node returning call10987 (depth = 6)
  *var_suggestion = call10987;
  if (call10987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10989 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10990 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call10991 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10990);
// compiled call node returning call10991 (depth = 7)
// compiled member node returning call10991 (depth = 6)
  gc_frame_newslot(call10991);
// starting to compile identifier node (depth = 6)
  Object bool10992 = alloc_Boolean(1);
// compiled identifier node returning bool10992 (depth = 6)
  gc_frame_newslot(bool10992);
// starting to compile identifier node (depth = 6)
  Object bool10993 = alloc_Boolean(0);
// compiled identifier node returning bool10993 (depth = 6)
  gc_frame_newslot(bool10993);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call10991;
  params[2] = bool10992;
  params[3] = bool10993;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10994 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10989);
// compiled call node returning call10994 (depth = 5)
// Begin line 3380
  setline(3380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10995 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10996 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10995);
// compiled call node returning call10996 (depth = 5)
    gc_frame_newslot(call10996);
    if10923 = call10996;
  }
// compiled if node returning if10923 (depth = 4)
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10997 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10998 == NULL) {
    strlit10998 = alloc_String("multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit10998);
  }
// compiled string node returning strlit10998 (depth = 5)
  gc_frame_newslot(strlit10998);
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11000 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10999);
// compiled call node returning call11000 (depth = 6)
// compiled member node returning call11000 (depth = 5)
  gc_frame_newslot(call11000);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11002 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11001);
// compiled call node returning call11002 (depth = 6)
// compiled member node returning call11002 (depth = 5)
  gc_frame_newslot(call11002);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10998;
  params[1] = call11000;
  params[2] = call11002;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11003 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10997);
// compiled call node returning call11003 (depth = 4)
    gc_frame_newslot(call11003);
    if10770 = call11003;
  } else {
  }
// compiled if node returning if10770 (depth = 3)
    gc_frame_newslot(if10770);
    if10678 = if10770;
  } else {
  }
// compiled if node returning if10678 (depth = 2)
  gc_frame_end(frame);
  return if10678;
}
Object meth_parser__apply11055(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11057 = alloc_Float64(0);
// compiled num node returning num11057 (depth = 5)
  int op_slot_right_11056 = gc_frame_newslot(num11057);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11060 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11059);
// compiled call node returning call11060 (depth = 6)
// compiled member node returning call11060 (depth = 5)
  int op_slot_left_11056 = gc_frame_newslot(call11060);
  params[0] = num11057;
  partcv[0] = 1;
  Object opresult11061 = callmethod(call11060, ">", 1, partcv, params);
// compiled op node returning opresult11061 (depth = 4)
  gc_frame_end(frame);
  return opresult11061;
}
Object meth_parser__apply11073(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11074 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11075 = callmethodflags(self, "inheritsOrUses", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11074);
// compiled call node returning call11075 (depth = 7)
// compiled member node returning call11075 (depth = 6)
  gc_frame_end(frame);
  return call11075;
}
Object meth_parser__apply11078(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_parentNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "parentNode");
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11079 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11080 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11079);
// compiled call node returning call11080 (depth = 8)
// compiled member node returning call11080 (depth = 7)
  *var_parentNode = call11080;
  if (call11080 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3415
  setline(3415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11082 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  partcv[0] = 0;
  Object call11083 = callmethod(*var_parentNode, "isUse",
    1, partcv, params);
  gc_frame_end(callframe11082);
// compiled call node returning call11083 (depth = 8)
// compiled member node returning call11083 (depth = 7)
  Object if11081 = done;
  if (istrue(call11083)) {
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11084 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_parentNode (depth = 8)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11085 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_moduleObject (depth = 10)
  partcv[0] = 0;
  Object call11086 = callmethod(*var_moduleObject, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe11085);
// compiled call node returning call11086 (depth = 9)
// compiled member node returning call11086 (depth = 8)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call11087 = callmethod(call11086, "add",
    1, partcv, params);
  gc_frame_end(callframe11084);
// compiled call node returning call11087 (depth = 7)
    gc_frame_newslot(call11087);
    if11081 = call11087;
  } else {
// Begin line 3419
  setline(3419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3417
  setline(3417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11089 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_moduleObject (depth = 12)
  partcv[0] = 0;
  Object call11091 = callmethod(*var_moduleObject, "usedTraits",
    1, partcv, params);
  gc_frame_end(callframe11090);
// compiled call node returning call11091 (depth = 11)
// compiled member node returning call11091 (depth = 10)
  partcv[0] = 0;
  Object call11092 = callmethod(call11091, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe11089);
// compiled call node returning call11092 (depth = 9)
// compiled member node returning call11092 (depth = 8)
  Object if11088 = done;
  if (istrue(call11092)) {
// Begin line 3418
  setline(3418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11093 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_parentNode (depth = 9)
  gc_frame_newslot(*var_parentNode);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_moduleObject (depth = 9)
  params[0] = *var_parentNode;
  partcv[0] = 1;
  Object call11094 = callmethod(*var_moduleObject, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe11093);
// compiled call node returning call11094 (depth = 8)
    gc_frame_newslot(call11094);
    if11088 = call11094;
  } else {
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11095 = gc_frame_new();
// starting to compile op node (depth = 9)
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit11097 == NULL) {
    strlit11097 = alloc_String("before 'use' in a module.");
    gc_root(strlit11097);
  }
// compiled string node returning strlit11097 (depth = 10)
  int op_slot_right_11096 = gc_frame_newslot(strlit11097);
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit11099 == NULL) {
    strlit11099 = alloc_String("'inherit' must come ");
    gc_root(strlit11099);
  }
// compiled string node returning strlit11099 (depth = 10)
  int op_slot_left_11096 = gc_frame_newslot(strlit11099);
  params[0] = strlit11097;
  partcv[0] = 1;
  Object opresult11100 = callmethod(strlit11099, "++", 1, partcv, params);
// compiled op node returning opresult11100 (depth = 9)
  gc_frame_newslot(opresult11100);
// Begin line 3422
  setline(3422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11101 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call11102 = callmethod(*var_parentNode, "line",
    1, partcv, params);
  gc_frame_end(callframe11101);
// compiled call node returning call11102 (depth = 10)
// compiled member node returning call11102 (depth = 9)
  gc_frame_newslot(call11102);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11103 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_parentNode (depth = 11)
  partcv[0] = 0;
  Object call11104 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11103);
// compiled call node returning call11104 (depth = 10)
// compiled member node returning call11104 (depth = 9)
  gc_frame_newslot(call11104);
// Begin line 3423
  setline(3423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num11106 = alloc_Float64(7);
// compiled num node returning num11106 (depth = 10)
  int op_slot_right_11105 = gc_frame_newslot(num11106);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_parentNode (depth = 12)
  partcv[0] = 0;
  Object call11109 = callmethod(*var_parentNode, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11108);
// compiled call node returning call11109 (depth = 11)
// compiled member node returning call11109 (depth = 10)
  int op_slot_left_11105 = gc_frame_newslot(call11109);
  params[0] = num11106;
  partcv[0] = 1;
  Object sum11110 = callmethod(call11109, "+", 1, partcv, params);
// compiled op node returning sum11110 (depth = 9)
  gc_frame_newslot(sum11110);
// call case 6: other member request
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult11100;
  params[1] = call11102;
  params[2] = call11104;
  params[3] = sum11110;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call11111 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe11095);
// compiled call node returning call11111 (depth = 8)
    gc_frame_newslot(call11111);
    if11088 = call11111;
  }
// compiled if node returning if11088 (depth = 7)
    gc_frame_newslot(if11088);
    if11081 = if11088;
  }
// compiled if node returning if11081 (depth = 6)
  gc_frame_end(frame);
  return if11081;
}
Object meth_parser__apply11064(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_moduleObject = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_oldlength = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3410
  setline(3410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11066 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11065);
// compiled call node returning call11066 (depth = 5)
// compiled member node returning call11066 (depth = 4)
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11068 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11067);
// compiled call node returning call11068 (depth = 5)
// compiled member node returning call11068 (depth = 4)
// Begin line 3412
  setline(3412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11069 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11070 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11069);
// compiled call node returning call11070 (depth = 5)
// compiled member node returning call11070 (depth = 4)
// Begin line 3413
  setline(3413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11071 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block11072 = alloc_Block(NULL, NULL, "parser", 3413);
  gc_frame_newslot(block11072);
// method "_apply"
  block_savedest(block11072);
  Object closure11073 = createclosure(1, "_apply");
  setclosureframe(closure11073, stackframe);
  addtoclosure(closure11073, selfslot);
  struct UserObject *uo11073 = (struct UserObject*)block11072;
  uo11073->data[0] = (Object)closure11073;
  Method *meth_meth_parser__apply11073 = addmethod2pos(block11072, "_apply", &meth_parser__apply11073, 0);
  int argcv_meth_parser__apply11073[] = {0};
  meth_meth_parser__apply11073->type = alloc_MethodType(1, argcv_meth_parser__apply11073);
  meth_meth_parser__apply11073->definitionModule = modulename;
  meth_meth_parser__apply11073->definitionLine = 3412;
// compiled block node returning block11072 (depth = 5)
  gc_frame_newslot(block11072);
// starting to compile block node (depth = 5)
  Object block11077 = alloc_Block(NULL, NULL, "parser", 3413);
  gc_frame_newslot(block11077);
// method "_apply"
  block_savedest(block11077);
  Object closure11078 = createclosure(4, "_apply");
  setclosureframe(closure11078, stackframe);
  addtoclosure(closure11078, var_values);
  addtoclosure(closure11078, var_moduleObject);
  addtoclosure(closure11078, var_errormessages);
  addtoclosure(closure11078, selfslot);
  struct UserObject *uo11078 = (struct UserObject*)block11077;
  uo11078->data[0] = (Object)closure11078;
  Method *meth_meth_parser__apply11078 = addmethod2pos(block11077, "_apply", &meth_parser__apply11078, 0);
  int argcv_meth_parser__apply11078[] = {0};
  meth_meth_parser__apply11078->type = alloc_MethodType(1, argcv_meth_parser__apply11078);
  meth_meth_parser__apply11078->definitionModule = modulename;
  meth_meth_parser__apply11078->definitionLine = 3413;
// compiled block node returning block11077 (depth = 5)
  gc_frame_newslot(block11077);
// call case 4: self request
  params[0] = block11072;
  params[1] = block11077;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11113 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11071);
// compiled call node returning call11113 (depth = 4)
// Begin line 3426
  setline(3426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11115 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11114);
// compiled call node returning call11115 (depth = 5)
// compiled member node returning call11115 (depth = 4)
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11117 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11116);
// compiled call node returning call11117 (depth = 5)
// compiled member node returning call11117 (depth = 4)
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11119 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11118);
// compiled call node returning call11119 (depth = 5)
// compiled member node returning call11119 (depth = 4)
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_11121 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call11124 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11123);
// compiled call node returning call11124 (depth = 7)
// compiled member node returning call11124 (depth = 6)
  int op_slot_left_11121 = gc_frame_newslot(call11124);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult11125 = callmethod(call11124, "==", 1, partcv, params);
// compiled op node returning opresult11125 (depth = 5)
  Object if11120 = done;
  if (istrue(opresult11125)) {
// Begin line 3430
  setline(3430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11126 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11128 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11127);
// compiled call node returning call11128 (depth = 9)
// compiled member node returning call11128 (depth = 8)
  partcv[0] = 0;
  Object call11129 = callmethod(call11128, "new",
    1, partcv, params);
  gc_frame_end(callframe11126);
// compiled call node returning call11129 (depth = 7)
// compiled member node returning call11129 (depth = 6)
  *var_suggestion = call11129;
  if (call11129 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3431
  setline(3431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11130 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call11131 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe11130);
// compiled call node returning call11131 (depth = 5)
// Begin line 3432
  setline(3432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11132 = gc_frame_new();
// starting to compile op node (depth = 6)
// Begin line 3433
  setline(3433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit11134 == NULL) {
    strlit11134 = alloc_String("caused by an extra '}', ')', or ']'.");
    gc_root(strlit11134);
  }
// compiled string node returning strlit11134 (depth = 7)
  int op_slot_right_11133 = gc_frame_newslot(strlit11134);
// Begin line 3432
  setline(3432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit11136 == NULL) {
    strlit11136 = alloc_String("invalid statement. This is often ");
    gc_root(strlit11136);
  }
// compiled string node returning strlit11136 (depth = 7)
  int op_slot_left_11133 = gc_frame_newslot(strlit11136);
  params[0] = strlit11134;
  partcv[0] = 1;
  Object opresult11137 = callmethod(strlit11136, "++", 1, partcv, params);
// compiled op node returning opresult11137 (depth = 6)
  gc_frame_newslot(opresult11137);
// Begin line 3434
  setline(3434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11139 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11138);
// compiled call node returning call11139 (depth = 7)
// compiled member node returning call11139 (depth = 6)
  gc_frame_newslot(call11139);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11141 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11140);
// compiled call node returning call11141 (depth = 7)
// compiled member node returning call11141 (depth = 6)
  gc_frame_newslot(call11141);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11143 = alloc_Float64(1);
// compiled num node returning num11143 (depth = 7)
  int op_slot_right_11142 = gc_frame_newslot(num11143);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11147 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe11146);
// compiled call node returning call11147 (depth = 9)
// compiled member node returning call11147 (depth = 8)
  int op_slot_right_11145 = gc_frame_newslot(call11147);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11150 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11149);
// compiled call node returning call11150 (depth = 9)
// compiled member node returning call11150 (depth = 8)
  int op_slot_left_11145 = gc_frame_newslot(call11150);
  params[0] = call11147;
  partcv[0] = 1;
  Object sum11151 = callmethod(call11150, "+", 1, partcv, params);
// compiled op node returning sum11151 (depth = 7)
  int op_slot_left_11142 = gc_frame_newslot(sum11151);
  params[0] = num11143;
  partcv[0] = 1;
  Object diff11152 = callmethod(sum11151, "-", 1, partcv, params);
// compiled op node returning diff11152 (depth = 6)
  gc_frame_newslot(diff11152);
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3432
  setline(3432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult11137;
  params[1] = call11139;
  params[2] = call11141;
  params[3] = diff11152;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11153 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11132);
// compiled call node returning call11153 (depth = 5)
    gc_frame_newslot(call11153);
    if11120 = call11153;
  } else {
  }
// compiled if node returning if11120 (depth = 4)
// Begin line 3437
  setline(3437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11155 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11154);
// compiled call node returning call11155 (depth = 6)
// compiled member node returning call11155 (depth = 5)
  *var_oldlength = call11155;
  if (call11155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse11004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method parse");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_moduleObject = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3393
  setline(3393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11005 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit11006 == NULL) {
    strlit11006 = alloc_String("parsing.");
    gc_root(strlit11006);
  }
// compiled string node returning strlit11006 (depth = 3)
  gc_frame_newslot(strlit11006);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit11006;
  partcv[0] = 1;
  Object call11007 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11005);
// compiled call node returning call11007 (depth = 2)
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11008 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  gc_frame_newslot(*var_values);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11010 = callmethod(*var_util, "modname",
    1, partcv, params);
  gc_frame_end(callframe11009);
// compiled call node returning call11010 (depth = 5)
// compiled member node returning call11010 (depth = 4)
  gc_frame_newslot(call11010);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call11012 = callmethod(*var_ast, "moduleNode",
    1, partcv, params);
  gc_frame_end(callframe11011);
// compiled call node returning call11012 (depth = 5)
// compiled member node returning call11012 (depth = 4)
  params[0] = *var_values;
  params[1] = call11010;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11013 = callmethod(call11012, "body()named",
    2, partcv, params);
  gc_frame_end(callframe11008);
// compiled call node returning call11013 (depth = 3)
  *var_moduleObject = call11013;
  if (call11013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11017 = alloc_Float64(0);
// compiled num node returning num11017 (depth = 4)
  int op_slot_right_11016 = gc_frame_newslot(num11017);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_toks (depth = 6)
  partcv[0] = 0;
  Object call11020 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe11019);
// compiled call node returning call11020 (depth = 5)
// compiled member node returning call11020 (depth = 4)
  int op_slot_left_11016 = gc_frame_newslot(call11020);
  params[0] = num11017;
  partcv[0] = 1;
  Object opresult11021 = callmethod(call11020, "==", 1, partcv, params);
// compiled op node returning opresult11021 (depth = 3)
  Object if11015 = done;
  if (istrue(opresult11021)) {
// Begin line 3397
  setline(3397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_moduleObject (depth = 4)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11015 = undefined;
  } else {
  }
// compiled if node returning if11015 (depth = 2)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3400
  setline(3400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11024 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11023);
// compiled call node returning call11024 (depth = 3)
// compiled member node returning call11024 (depth = 2)
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11027 = alloc_Float64(0);
// compiled num node returning num11027 (depth = 4)
  int op_slot_right_11026 = gc_frame_newslot(num11027);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11030 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11029);
// compiled call node returning call11030 (depth = 5)
// compiled member node returning call11030 (depth = 4)
  int op_slot_left_11026 = gc_frame_newslot(call11030);
  params[0] = num11027;
  partcv[0] = 1;
  Object opresult11031 = callmethod(call11030, ">", 1, partcv, params);
// compiled op node returning opresult11031 (depth = 3)
  Object if11025 = done;
  if (istrue(opresult11031)) {
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11032 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11033 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11034 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11033);
// compiled call node returning call11034 (depth = 7)
// compiled member node returning call11034 (depth = 6)
  partcv[0] = 0;
  Object call11035 = callmethod(call11034, "new",
    1, partcv, params);
  gc_frame_end(callframe11032);
// compiled call node returning call11035 (depth = 5)
// compiled member node returning call11035 (depth = 4)
  *var_sugg = call11035;
  if (call11035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3403
  setline(3403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11036 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num11037 = alloc_Float64(1);
// compiled num node returning num11037 (depth = 4)
  gc_frame_newslot(num11037);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11039 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11038);
// compiled call node returning call11039 (depth = 5)
// compiled member node returning call11039 (depth = 4)
  gc_frame_newslot(call11039);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11040 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11041 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11040);
// compiled call node returning call11041 (depth = 5)
// compiled member node returning call11041 (depth = 4)
  gc_frame_newslot(call11041);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num11037;
  params[1] = call11039;
  params[2] = call11041;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call11042 = callmethod(*var_sugg, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe11036);
// compiled call node returning call11042 (depth = 3)
// Begin line 3404
  setline(3404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11043 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11044 == NULL) {
    strlit11044 = alloc_String("the first line must not be indented.");
    gc_root(strlit11044);
  }
// compiled string node returning strlit11044 (depth = 4)
  gc_frame_newslot(strlit11044);
// Begin line 3405
  setline(3405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11045 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11046 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11045);
// compiled call node returning call11046 (depth = 5)
// compiled member node returning call11046 (depth = 4)
  gc_frame_newslot(call11046);
// starting to compile num node (depth = 4)
  Object num11047 = alloc_Float64(1);
// compiled num node returning num11047 (depth = 4)
  gc_frame_newslot(num11047);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11049 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11048);
// compiled call node returning call11049 (depth = 5)
// compiled member node returning call11049 (depth = 4)
  gc_frame_newslot(call11049);
// Begin line 3406
  setline(3406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3404
  setline(3404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11044;
  params[1] = call11046;
  params[2] = num11047;
  params[3] = call11049;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11050 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11043);
// compiled call node returning call11050 (depth = 3)
    gc_frame_newslot(call11050);
    if11025 = call11050;
  } else {
  }
// compiled if node returning if11025 (depth = 2)
// Begin line 3408
  setline(3408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call11052 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11051);
// compiled call node returning call11052 (depth = 4)
// compiled member node returning call11052 (depth = 3)
  *var_oldlength = call11052;
  if (call11052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3409
  setline(3409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11053 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11054 = alloc_Block(NULL, NULL, "parser", 3409);
  gc_frame_newslot(block11054);
// method "_apply"
  block_savedest(block11054);
  Object closure11055 = createclosure(2, "_apply");
  setclosureframe(closure11055, stackframe);
  addtoclosure(closure11055, var_tokens);
  addtoclosure(closure11055, selfslot);
  struct UserObject *uo11055 = (struct UserObject*)block11054;
  uo11055->data[0] = (Object)closure11055;
  Method *meth_meth_parser__apply11055 = addmethod2pos(block11054, "_apply", &meth_parser__apply11055, 0);
  int argcv_meth_parser__apply11055[] = {0};
  meth_meth_parser__apply11055->type = alloc_MethodType(1, argcv_meth_parser__apply11055);
  meth_meth_parser__apply11055->definitionModule = modulename;
  meth_meth_parser__apply11055->definitionLine = 3408;
// compiled block node returning block11054 (depth = 3)
  gc_frame_newslot(block11054);
// starting to compile block node (depth = 3)
  Object block11063 = alloc_Block(NULL, NULL, "parser", 3409);
  gc_frame_newslot(block11063);
// method "_apply"
  block_savedest(block11063);
  Object closure11064 = createclosure(7, "_apply");
  setclosureframe(closure11064, stackframe);
  addtoclosure(closure11064, var_values);
  addtoclosure(closure11064, var_moduleObject);
  addtoclosure(closure11064, var_errormessages);
  addtoclosure(closure11064, var_oldlength);
  addtoclosure(closure11064, var_tokens);
  addtoclosure(closure11064, var_sym);
  addtoclosure(closure11064, selfslot);
  struct UserObject *uo11064 = (struct UserObject*)block11063;
  uo11064->data[0] = (Object)closure11064;
  Method *meth_meth_parser__apply11064 = addmethod2pos(block11063, "_apply", &meth_parser__apply11064, 0);
  int argcv_meth_parser__apply11064[] = {0};
  meth_meth_parser__apply11064->type = alloc_MethodType(1, argcv_meth_parser__apply11064);
  meth_meth_parser__apply11064->definitionModule = modulename;
  meth_meth_parser__apply11064->definitionLine = 3409;
// compiled block node returning block11063 (depth = 3)
  gc_frame_newslot(block11063);
// call case 5: prelude request
  params[0] = block11054;
  params[1] = block11063;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11158 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11053);
// compiled call node returning call11158 (depth = 2)
// Begin line 3439
  setline(3439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11160 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11159);
// compiled call node returning call11160 (depth = 3)
// compiled member node returning call11160 (depth = 2)
// Begin line 3440
  setline(3440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11161 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11162 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11161);
// compiled call node returning call11162 (depth = 3)
// compiled member node returning call11162 (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11164 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11163);
// compiled call node returning call11164 (depth = 3)
// compiled member node returning call11164 (depth = 2)
// Begin line 3442
  setline(3442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  return *var_moduleObject;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_blankLocation11166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankLocation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blankLocation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankLocation (depth = 3)
  gc_frame_end(frame);
  return *var_blankLocation;
}
Object meth_parser_blankLocation_58__61_11167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankLocation:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method blankLocation:=");
  Object params[1];
  int partcv[1];
  Object *var_blankLocation = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blankLocation:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for blankLocation:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_blankLocation = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastLine11170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastLine (depth = 3)
  gc_frame_end(frame);
  return *var_lastLine;
}
Object meth_parser_lastLine_58__61_11171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastLine:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastLine:=");
  Object params[1];
  int partcv[1];
  Object *var_lastLine = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastLine:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastLine:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastLine = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent11174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61_11175(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastIndent:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass11178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for indentFreePass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61_11179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indentFreePass:=");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indentFreePass:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for indentFreePass:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel11182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for minIndentLevel");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61_11183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method minIndentLevel:=");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for minIndentLevel:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for minIndentLevel:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent11186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61_11187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for statementIndent:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens11190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for tokens");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61_11191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tokens:=");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for tokens:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values11194(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61_11195(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method values:=");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for values:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_moduleObject11197(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for moduleObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_moduleObject (depth = 3)
  gc_frame_end(frame);
  return *var_moduleObject;
}
Object meth_parser_moduleObject_58__61_11198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "moduleObject:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method moduleObject:=");
  Object params[1];
  int partcv[1];
  Object *var_moduleObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for moduleObject:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for moduleObject:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_moduleObject = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comments11202(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for comments");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comments (depth = 3)
  gc_frame_end(frame);
  return *var_comments;
}
Object meth_parser_comments_58__61_11203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comments:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comments:=");
  Object params[1];
  int partcv[1];
  Object *var_comments = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comments:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for comments:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comments = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count11206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for auto_count");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61_11207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method auto_count:=");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for auto_count:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for auto_count:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_noBlocks11210(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for noBlocks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for noBlocks");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_blocksOK11212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for blocksOK (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for blocksOK");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_braceIsType11214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for braceIsType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for braceIsType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_braceIsType (depth = 3)
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61_11215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method braceIsType:=");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for braceIsType:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for braceIsType:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_sym11231(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 105, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sym");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61_11232(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 106, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sym:=");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sym:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sym:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken11234(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 107, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for lastToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61_11235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 108, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lastToken:=");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lastToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lastToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_previousCommentToken11237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 109, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for previousCommentToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_previousCommentToken (depth = 3)
  gc_frame_end(frame);
  return *var_previousCommentToken;
}
Object meth_parser_previousCommentToken_58__61_11238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 110, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "previousCommentToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method previousCommentToken:=");
  Object params[1];
  int partcv[1];
  Object *var_previousCommentToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for previousCommentToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for previousCommentToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_previousCommentToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken11240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 111, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for statementToken");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61_11241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 112, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method statementToken:=");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for statementToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for statementToken:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment11244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 113, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for comment");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61_11245(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 114, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method comment:=");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for comment:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for comment:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_firstCallOfNext11248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 115, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for firstCallOfNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for firstCallOfNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_firstCallOfNext (depth = 3)
  gc_frame_end(frame);
  return *var_firstCallOfNext;
}
Object meth_parser_firstCallOfNext_58__61_11249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 116, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "firstCallOfNext:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method firstCallOfNext:=");
  Object params[1];
  int partcv[1];
  Object *var_firstCallOfNext = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for firstCallOfNext:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for firstCallOfNext:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_firstCallOfNext = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(119, 119);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(119, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
  Object *var_ast = alloc_var();
  Object *var_util = alloc_var();
  Object *var_errormessages = alloc_var();
  Object *var_blankLocation = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "blankLocation");
  Object *var_lastLine = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastLine");
  Object *var_lastIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "statementIndent");
  Object *var_tokens = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "tokens");
  Object *var_values = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "values");
  Object *var_moduleObject = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "moduleObject");
  Object *var_comments = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "comments");
  Object *var_auto_count = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "blocksOK");
  Object *var_braceIsType = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "braceIsType");
  Object *var_sym = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "sym");
  Object *var_lastToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "lastToken");
  Object *var_previousCommentToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "previousCommentToken");
  Object *var_statementToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "statementToken");
  Object *var_comment = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "comment");
  Object *var_firstCallOfNext = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "firstCallOfNext");
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "noteBlank"
  block_savedest(self);
  Object closure1 = createclosure(2, "noteBlank");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_sym);
  addtoclosure(closure1, var_blankLocation);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_parser_noteBlank1 = addmethod2pos(self, "noteBlank", &meth_parser_noteBlank1, 1);
  int argcv_meth_parser_noteBlank1[] = {0};
  meth_meth_parser_noteBlank1->type = alloc_MethodType(1, argcv_meth_parser_noteBlank1);
  meth_meth_parser_noteBlank1->definitionModule = modulename;
  meth_meth_parser_noteBlank1->definitionLine = 37;
// compiled method node returning  (depth = 1)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "next"
  block_savedest(self);
  Object closure9 = createclosure(7, "next");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_tokens);
  addtoclosure(closure9, var_sym);
  addtoclosure(closure9, var_lastToken);
  addtoclosure(closure9, var_lastLine);
  addtoclosure(closure9, var_lastIndent);
  addtoclosure(closure9, var_util);
  addtoclosure(closure9, var_errormessages);
  struct UserObject *uo9 = (struct UserObject*)self;
  uo9->data[2] = (Object)closure9;
  Method *meth_meth_parser_next9 = addmethod2pos(self, "next", &meth_parser_next9, 2);
  int argcv_meth_parser_next9[] = {0};
  meth_meth_parser_next9->type = alloc_MethodType(1, argcv_meth_parser_next9);
  meth_meth_parser_next9->definitionModule = modulename;
  meth_meth_parser_next9->definitionLine = 43;
// compiled method node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextToken"
  block_savedest(self);
  Object closure60 = createclosure(2, "findNextToken");
  setclosureframe(closure60, stackframe);
  addtoclosure(closure60, var_sym);
  addtoclosure(closure60, var_lastToken);
  struct UserObject *uo60 = (struct UserObject*)self;
  uo60->data[3] = (Object)closure60;
  Method *meth_meth_parser_findNextToken60 = addmethod2pos(self, "findNextToken", &meth_parser_findNextToken60, 3);
  int argcv_meth_parser_findNextToken60[] = {1};
  meth_meth_parser_findNextToken60->type = alloc_MethodType(1, argcv_meth_parser_findNextToken60);
  meth_meth_parser_findNextToken60->definitionModule = modulename;
  meth_meth_parser_findNextToken60->definitionLine = 63;
// compiled method node returning  (depth = 1)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextTokenIndentedAt"
  block_savedest(self);
  Object closure107 = createclosure(1, "findNextTokenIndentedAt");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, var_sym);
  struct UserObject *uo107 = (struct UserObject*)self;
  uo107->data[4] = (Object)closure107;
  Method *meth_meth_parser_findNextTokenIndentedAt107 = addmethod2pos(self, "findNextTokenIndentedAt", &meth_parser_findNextTokenIndentedAt107, 4);
  int argcv_meth_parser_findNextTokenIndentedAt107[] = {1};
  meth_meth_parser_findNextTokenIndentedAt107->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt107);
  meth_meth_parser_findNextTokenIndentedAt107->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt107->definitionLine = 81;
// compiled method node returning  (depth = 1)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findNextValidToken"
  block_savedest(self);
  Object closure189 = createclosure(1, "findNextValidToken");
  setclosureframe(closure189, stackframe);
  addtoclosure(closure189, var_sym);
  struct UserObject *uo189 = (struct UserObject*)self;
  uo189->data[5] = (Object)closure189;
  Method *meth_meth_parser_findNextValidToken189 = addmethod2pos(self, "findNextValidToken", &meth_parser_findNextValidToken189, 5);
  int argcv_meth_parser_findNextValidToken189[] = {1};
  meth_meth_parser_findNextValidToken189->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken189);
  meth_meth_parser_findNextValidToken189->definitionModule = modulename;
  meth_meth_parser_findNextValidToken189->definitionLine = 96;
// compiled method node returning  (depth = 1)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "findClosingBrace"
  block_savedest(self);
  Object closure230 = createclosure(1, "findClosingBrace");
  setclosureframe(closure230, stackframe);
  addtoclosure(closure230, var_sym);
  struct UserObject *uo230 = (struct UserObject*)self;
  uo230->data[6] = (Object)closure230;
  Method *meth_meth_parser_findClosingBrace230 = addmethod2pos(self, "findClosingBrace", &meth_parser_findClosingBrace230, 6);
  int argcv_meth_parser_findClosingBrace230[] = {2};
  meth_meth_parser_findClosingBrace230->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace230);
  meth_meth_parser_findClosingBrace230->definitionModule = modulename;
  meth_meth_parser_findClosingBrace230->definitionLine = 121;
// compiled method node returning  (depth = 1)
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept"
  block_savedest(self);
  Object closure382 = createclosure(1, "accept");
  setclosureframe(closure382, stackframe);
  addtoclosure(closure382, var_sym);
  struct UserObject *uo382 = (struct UserObject*)self;
  uo382->data[7] = (Object)closure382;
  Method *meth_meth_parser_accept382 = addmethod2pos(self, "accept", &meth_parser_accept382, 7);
  int argcv_meth_parser_accept382[] = {1};
  meth_meth_parser_accept382->type = alloc_MethodType(1, argcv_meth_parser_accept382);
  meth_meth_parser_accept382->definitionModule = modulename;
  meth_meth_parser_accept382->definitionLine = 159;
// compiled method node returning  (depth = 1)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptKeyword"
  block_savedest(self);
  Object closure388 = createclosure(1, "acceptKeyword");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_sym);
  struct UserObject *uo388 = (struct UserObject*)self;
  uo388->data[8] = (Object)closure388;
  Method *meth_meth_parser_acceptKeyword388 = addmethod2pos(self, "acceptKeyword", &meth_parser_acceptKeyword388, 8);
  int argcv_meth_parser_acceptKeyword388[] = {1};
  meth_meth_parser_acceptKeyword388->type = alloc_MethodType(1, argcv_meth_parser_acceptKeyword388);
  meth_meth_parser_acceptKeyword388->definitionModule = modulename;
  meth_meth_parser_acceptKeyword388->definitionLine = 165;
// compiled method node returning  (depth = 1)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptSameLine"
  block_savedest(self);
  Object closure402 = createclosure(3, "acceptSameLine");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_lastIndent);
  addtoclosure(closure402, var_sym);
  addtoclosure(closure402, var_lastLine);
  struct UserObject *uo402 = (struct UserObject*)self;
  uo402->data[9] = (Object)closure402;
  Method *meth_meth_parser_acceptSameLine402 = addmethod2pos(self, "acceptSameLine", &meth_parser_acceptSameLine402, 9);
  int argcv_meth_parser_acceptSameLine402[] = {1};
  meth_meth_parser_acceptSameLine402->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine402);
  meth_meth_parser_acceptSameLine402->definitionModule = modulename;
  meth_meth_parser_acceptSameLine402->definitionLine = 170;
// compiled method node returning  (depth = 1)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptWithoutSpaces"
  block_savedest(self);
  Object closure424 = createclosure(3, "acceptWithoutSpaces");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_lastToken);
  addtoclosure(closure424, var_sym);
  addtoclosure(closure424, var_lastLine);
  struct UserObject *uo424 = (struct UserObject*)self;
  uo424->data[10] = (Object)closure424;
  Method *meth_meth_parser_acceptWithoutSpaces424 = addmethod2pos(self, "acceptWithoutSpaces", &meth_parser_acceptWithoutSpaces424, 10);
  int argcv_meth_parser_acceptWithoutSpaces424[] = {1};
  meth_meth_parser_acceptWithoutSpaces424->type = alloc_MethodType(1, argcv_meth_parser_acceptWithoutSpaces424);
  meth_meth_parser_acceptWithoutSpaces424->definitionModule = modulename;
  meth_meth_parser_acceptWithoutSpaces424->definitionLine = 178;
// compiled method node returning  (depth = 1)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces"
  block_savedest(self);
  Object closure453 = createclosure(3, "acceptAfterSpaces");
  setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_sym);
  addtoclosure(closure453, var_lastLine);
  addtoclosure(closure453, var_lastToken);
  struct UserObject *uo453 = (struct UserObject*)self;
  uo453->data[11] = (Object)closure453;
  Method *meth_meth_parser_acceptAfterSpaces453 = addmethod2pos(self, "acceptAfterSpaces", &meth_parser_acceptAfterSpaces453, 11);
  int argcv_meth_parser_acceptAfterSpaces453[] = {1};
  meth_meth_parser_acceptAfterSpaces453->type = alloc_MethodType(1, argcv_meth_parser_acceptAfterSpaces453);
  meth_meth_parser_acceptAfterSpaces453->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces453->definitionLine = 185;
// compiled method node returning  (depth = 1)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept()onLineOf"
  block_savedest(self);
  Object closure490 = createclosure(1, "accept()onLineOf");
  setclosureframe(closure490, stackframe);
  addtoclosure(closure490, var_sym);
  struct UserObject *uo490 = (struct UserObject*)self;
  uo490->data[12] = (Object)closure490;
  Method *meth_meth_parser_accept_40__41_onLineOf490 = addmethod2pos(self, "accept()onLineOf", &meth_parser_accept_40__41_onLineOf490, 12);
  int argcv_meth_parser_accept_40__41_onLineOf490[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOf490->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOf490);
  meth_meth_parser_accept_40__41_onLineOf490->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOf490->definitionLine = 195;
// compiled method node returning  (depth = 1)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptAfterSpaces()onLineOf"
  block_savedest(self);
  Object closure516 = createclosure(2, "acceptAfterSpaces()onLineOf");
  setclosureframe(closure516, stackframe);
  addtoclosure(closure516, var_sym);
  addtoclosure(closure516, var_lastToken);
  struct UserObject *uo516 = (struct UserObject*)self;
  uo516->data[13] = (Object)closure516;
  Method *meth_meth_parser_acceptAfterSpaces_40__41_onLineOf516 = addmethod2pos(self, "acceptAfterSpaces()onLineOf", &meth_parser_acceptAfterSpaces_40__41_onLineOf516, 13);
  int argcv_meth_parser_acceptAfterSpaces_40__41_onLineOf516[] = {1, 1};
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf516->type = alloc_MethodType(2, argcv_meth_parser_acceptAfterSpaces_40__41_onLineOf516);
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf516->definitionModule = modulename;
  meth_meth_parser_acceptAfterSpaces_40__41_onLineOf516->definitionLine = 202;
// compiled method node returning  (depth = 1)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "accept()onLineOfLastOr"
  block_savedest(self);
  Object closure555 = createclosure(2, "accept()onLineOfLastOr");
  setclosureframe(closure555, stackframe);
  addtoclosure(closure555, var_sym);
  addtoclosure(closure555, var_lastToken);
  struct UserObject *uo555 = (struct UserObject*)self;
  uo555->data[14] = (Object)closure555;
  Method *meth_meth_parser_accept_40__41_onLineOfLastOr555 = addmethod2pos(self, "accept()onLineOfLastOr", &meth_parser_accept_40__41_onLineOfLastOr555, 14);
  int argcv_meth_parser_accept_40__41_onLineOfLastOr555[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOfLastOr555->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOfLastOr555);
  meth_meth_parser_accept_40__41_onLineOfLastOr555->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOfLastOr555->definitionLine = 214;
// compiled method node returning  (depth = 1)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acceptArgumentOnLineOf"
  block_savedest(self);
  Object closure591 = createclosure(1, "acceptArgumentOnLineOf");
  setclosureframe(closure591, stackframe);
  addtoclosure(closure591, var_sym);
  struct UserObject *uo591 = (struct UserObject*)self;
  uo591->data[15] = (Object)closure591;
  Method *meth_meth_parser_acceptArgumentOnLineOf591 = addmethod2pos(self, "acceptArgumentOnLineOf", &meth_parser_acceptArgumentOnLineOf591, 15);
  int argcv_meth_parser_acceptArgumentOnLineOf591[] = {1};
  meth_meth_parser_acceptArgumentOnLineOf591->type = alloc_MethodType(1, argcv_meth_parser_acceptArgumentOnLineOf591);
  meth_meth_parser_acceptArgumentOnLineOf591->definitionModule = modulename;
  meth_meth_parser_acceptArgumentOnLineOf591->definitionLine = 220;
// compiled method node returning  (depth = 1)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tokenOnSameLine"
  block_savedest(self);
  Object closure632 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure632, stackframe);
  addtoclosure(closure632, var_lastIndent);
  addtoclosure(closure632, var_sym);
  addtoclosure(closure632, var_lastLine);
  struct UserObject *uo632 = (struct UserObject*)self;
  uo632->data[16] = (Object)closure632;
  Method *meth_meth_parser_tokenOnSameLine632 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine632, 16);
  int argcv_meth_parser_tokenOnSameLine632[] = {0};
  meth_meth_parser_tokenOnSameLine632->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine632);
  meth_meth_parser_tokenOnSameLine632->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine632->definitionLine = 231;
// compiled method node returning  (depth = 1)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "didConsume"
  block_savedest(self);
  Object closure646 = createclosure(1, "didConsume");
  setclosureframe(closure646, stackframe);
  addtoclosure(closure646, var_tokens);
  struct UserObject *uo646 = (struct UserObject*)self;
  uo646->data[17] = (Object)closure646;
  Method *meth_meth_parser_didConsume646 = addmethod2pos(self, "didConsume", &meth_parser_didConsume646, 17);
  int argcv_meth_parser_didConsume646[] = {1};
  meth_meth_parser_didConsume646->type = alloc_MethodType(1, argcv_meth_parser_didConsume646);
  meth_meth_parser_didConsume646->definitionModule = modulename;
  meth_meth_parser_didConsume646->definitionLine = 235;
// compiled method node returning  (depth = 1)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "ifConsume()then"
  block_savedest(self);
  Object closure656 = createclosure(1, "ifConsume()then");
  setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_tokens);
  struct UserObject *uo656 = (struct UserObject*)self;
  uo656->data[18] = (Object)closure656;
  Method *meth_meth_parser_ifConsume_40__41_then656 = addmethod2pos(self, "ifConsume()then", &meth_parser_ifConsume_40__41_then656, 18);
  int argcv_meth_parser_ifConsume_40__41_then656[] = {1, 1};
  meth_meth_parser_ifConsume_40__41_then656->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40__41_then656);
  meth_meth_parser_ifConsume_40__41_then656->definitionModule = modulename;
  meth_meth_parser_ifConsume_40__41_then656->definitionLine = 241;
// compiled method node returning  (depth = 1)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushnum"
  block_savedest(self);
  Object closure669 = createclosure(3, "pushnum");
  setclosureframe(closure669, stackframe);
  addtoclosure(closure669, var_sym);
  addtoclosure(closure669, var_ast);
  addtoclosure(closure669, var_values);
  struct UserObject *uo669 = (struct UserObject*)self;
  uo669->data[19] = (Object)closure669;
  Method *meth_meth_parser_pushnum669 = addmethod2pos(self, "pushnum", &meth_parser_pushnum669, 19);
  int argcv_meth_parser_pushnum669[] = {0};
  meth_meth_parser_pushnum669->type = alloc_MethodType(1, argcv_meth_parser_pushnum669);
  meth_meth_parser_pushnum669->definitionModule = modulename;
  meth_meth_parser_pushnum669->definitionLine = 251;
// compiled method node returning  (depth = 1)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushstring"
  block_savedest(self);
  Object closure680 = createclosure(3, "pushstring");
  setclosureframe(closure680, stackframe);
  addtoclosure(closure680, var_sym);
  addtoclosure(closure680, var_ast);
  addtoclosure(closure680, var_values);
  struct UserObject *uo680 = (struct UserObject*)self;
  uo680->data[20] = (Object)closure680;
  Method *meth_meth_parser_pushstring680 = addmethod2pos(self, "pushstring", &meth_parser_pushstring680, 20);
  int argcv_meth_parser_pushstring680[] = {0};
  meth_meth_parser_pushstring680->type = alloc_MethodType(1, argcv_meth_parser_pushstring680);
  meth_meth_parser_pushstring680->definitionModule = modulename;
  meth_meth_parser_pushstring680->definitionLine = 258;
// compiled method node returning  (depth = 1)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushidentifier"
  block_savedest(self);
  Object closure691 = createclosure(5, "pushidentifier");
  setclosureframe(closure691, stackframe);
  addtoclosure(closure691, var_sym);
  addtoclosure(closure691, var_util);
  addtoclosure(closure691, var_ast);
  addtoclosure(closure691, var_auto_count);
  addtoclosure(closure691, var_values);
  struct UserObject *uo691 = (struct UserObject*)self;
  uo691->data[21] = (Object)closure691;
  Method *meth_meth_parser_pushidentifier691 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier691, 21);
  int argcv_meth_parser_pushidentifier691[] = {0};
  meth_meth_parser_pushidentifier691->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier691);
  meth_meth_parser_pushidentifier691->definitionModule = modulename;
  meth_meth_parser_pushidentifier691->definitionLine = 266;
// compiled method node returning  (depth = 1)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkAnnotation"
  block_savedest(self);
  Object closure730 = createclosure(2, "checkAnnotation");
  setclosureframe(closure730, stackframe);
  addtoclosure(closure730, var_sym);
  addtoclosure(closure730, var_errormessages);
  struct UserObject *uo730 = (struct UserObject*)self;
  uo730->data[22] = (Object)closure730;
  Method *meth_meth_parser_checkAnnotation730 = addmethod2pos(self, "checkAnnotation", &meth_parser_checkAnnotation730, 22);
  int argcv_meth_parser_checkAnnotation730[] = {1};
  meth_meth_parser_checkAnnotation730->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation730);
  meth_meth_parser_checkAnnotation730->definitionModule = modulename;
  meth_meth_parser_checkAnnotation730->definitionLine = 278;
// compiled method node returning  (depth = 1)
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doannotation"
  block_savedest(self);
  Object closure820 = createclosure(5, "doannotation");
  setclosureframe(closure820, stackframe);
  addtoclosure(closure820, var_noBlocks);
  addtoclosure(closure820, var_errormessages);
  addtoclosure(closure820, var_sym);
  addtoclosure(closure820, var_lastToken);
  addtoclosure(closure820, var_values);
  struct UserObject *uo820 = (struct UserObject*)self;
  uo820->data[23] = (Object)closure820;
  Method *meth_meth_parser_doannotation820 = addmethod2pos(self, "doannotation", &meth_parser_doannotation820, 23);
  int argcv_meth_parser_doannotation820[] = {0};
  meth_meth_parser_doannotation820->type = alloc_MethodType(1, argcv_meth_parser_doannotation820);
  meth_meth_parser_doannotation820->definitionModule = modulename;
  meth_meth_parser_doannotation820->definitionLine = 296;
// compiled method node returning  (depth = 1)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "blank"
  block_savedest(self);
  Object closure984 = createclosure(8, "blank");
  setclosureframe(closure984, stackframe);
  addtoclosure(closure984, var_blankLocation);
  addtoclosure(closure984, var_lastToken);
  addtoclosure(closure984, var_sym);
  addtoclosure(closure984, var_done);
  addtoclosure(closure984, var_previousCommentToken);
  addtoclosure(closure984, var_values);
  addtoclosure(closure984, var_util);
  addtoclosure(closure984, var_ast);
  struct UserObject *uo984 = (struct UserObject*)self;
  uo984->data[24] = (Object)closure984;
  Method *meth_meth_parser_blank984 = addmethod2pos(self, "blank", &meth_parser_blank984, 24);
  int argcv_meth_parser_blank984[] = {0};
  meth_meth_parser_blank984->type = alloc_MethodType(1, argcv_meth_parser_blank984);
  meth_meth_parser_blank984->definitionModule = modulename;
  meth_meth_parser_blank984->definitionLine = 344;
// compiled method node returning  (depth = 1)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeterm"
  block_savedest(self);
  Object closure1071 = createclosure(1, "dotypeterm");
  setclosureframe(closure1071, stackframe);
  addtoclosure(closure1071, var_noBlocks);
  struct UserObject *uo1071 = (struct UserObject*)self;
  uo1071->data[25] = (Object)closure1071;
  Method *meth_meth_parser_dotypeterm1071 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm1071, 25);
  int argcv_meth_parser_dotypeterm1071[] = {0};
  meth_meth_parser_dotypeterm1071->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm1071);
  meth_meth_parser_dotypeterm1071->definitionModule = modulename;
  meth_meth_parser_dotypeterm1071->definitionLine = 362;
// compiled method node returning  (depth = 1)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpression"
  block_savedest(self);
  Object closure1088 = createclosure(6, "typeexpression");
  setclosureframe(closure1088, stackframe);
  addtoclosure(closure1088, var_values);
  addtoclosure(closure1088, var_statementToken);
  addtoclosure(closure1088, var_sym);
  addtoclosure(closure1088, var_errormessages);
  addtoclosure(closure1088, var_lastToken);
  addtoclosure(closure1088, var_noBlocks);
  struct UserObject *uo1088 = (struct UserObject*)self;
  uo1088->data[26] = (Object)closure1088;
  Method *meth_meth_parser_typeexpression1088 = addmethod2pos(self, "typeexpression", &meth_parser_typeexpression1088, 26);
  int argcv_meth_parser_typeexpression1088[] = {0};
  meth_meth_parser_typeexpression1088->type = alloc_MethodType(1, argcv_meth_parser_typeexpression1088);
  meth_meth_parser_typeexpression1088->definitionModule = modulename;
  meth_meth_parser_typeexpression1088->definitionLine = 374;
// compiled method node returning  (depth = 1)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "newIf"
  block_savedest(self);
  Object closure1180 = createclosure(1, "newIf");
  setclosureframe(closure1180, stackframe);
  addtoclosure(closure1180, var_ast);
  struct UserObject *uo1180 = (struct UserObject*)self;
  uo1180->data[27] = (Object)closure1180;
  Method *meth_meth_parser_newIf1180 = addmethod2pos(self, "newIf", &meth_parser_newIf1180, 27);
  int argcv_meth_parser_newIf1180[] = {3};
  meth_meth_parser_newIf1180->type = alloc_MethodType(1, argcv_meth_parser_newIf1180);
  meth_meth_parser_newIf1180->definitionModule = modulename;
  meth_meth_parser_newIf1180->definitionLine = 413;
// compiled method node returning  (depth = 1)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "block"
  block_savedest(self);
  Object closure1197 = createclosure(12, "block");
  setclosureframe(closure1197, stackframe);
  addtoclosure(closure1197, var_sym);
  addtoclosure(closure1197, var_statementIndent);
  addtoclosure(closure1197, var_statementToken);
  addtoclosure(closure1197, var_blocksOK);
  addtoclosure(closure1197, var_values);
  addtoclosure(closure1197, var_braceIsType);
  addtoclosure(closure1197, var_errormessages);
  addtoclosure(closure1197, var_lastToken);
  addtoclosure(closure1197, var_indentFreePass);
  addtoclosure(closure1197, var_util);
  addtoclosure(closure1197, var_ast);
  addtoclosure(closure1197, var_minIndentLevel);
  struct UserObject *uo1197 = (struct UserObject*)self;
  uo1197->data[28] = (Object)closure1197;
  Method *meth_meth_parser_block1197 = addmethod2pos(self, "block", &meth_parser_block1197, 28);
  int argcv_meth_parser_block1197[] = {0};
  meth_meth_parser_block1197->type = alloc_MethodType(1, argcv_meth_parser_block1197);
  meth_meth_parser_block1197->definitionModule = modulename;
  meth_meth_parser_block1197->definitionLine = 419;
// compiled method node returning  (depth = 1)
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doif"
  block_savedest(self);
  Object closure1719 = createclosure(9, "doif");
  setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, var_sym);
  addtoclosure(closure1719, var_errormessages);
  addtoclosure(closure1719, var_blocksOK);
  addtoclosure(closure1719, var_lastToken);
  addtoclosure(closure1719, var_values);
  addtoclosure(closure1719, var_minIndentLevel);
  addtoclosure(closure1719, var_statementIndent);
  addtoclosure(closure1719, var_statementToken);
  addtoclosure(closure1719, var_util);
  struct UserObject *uo1719 = (struct UserObject*)self;
  uo1719->data[29] = (Object)closure1719;
  Method *meth_meth_parser_doif1719 = addmethod2pos(self, "doif", &meth_parser_doif1719, 29);
  int argcv_meth_parser_doif1719[] = {0};
  meth_meth_parser_doif1719->type = alloc_MethodType(1, argcv_meth_parser_doif1719);
  meth_meth_parser_doif1719->definitionModule = modulename;
  meth_meth_parser_doif1719->definitionLine = 592;
// compiled method node returning  (depth = 1)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "identifier"
  block_savedest(self);
  Object closure3165 = createclosure(1, "identifier");
  setclosureframe(closure3165, stackframe);
  addtoclosure(closure3165, var_sym);
  struct UserObject *uo3165 = (struct UserObject*)self;
  uo3165->data[30] = (Object)closure3165;
  Method *meth_meth_parser_identifier3165 = addmethod2pos(self, "identifier", &meth_parser_identifier3165, 30);
  int argcv_meth_parser_identifier3165[] = {0};
  meth_meth_parser_identifier3165->type = alloc_MethodType(1, argcv_meth_parser_identifier3165);
  meth_meth_parser_identifier3165->definitionModule = modulename;
  meth_meth_parser_identifier3165->definitionLine = 994;
// compiled method node returning  (depth = 1)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "prefixop"
  block_savedest(self);
  Object closure3181 = createclosure(6, "prefixop");
  setclosureframe(closure3181, stackframe);
  addtoclosure(closure3181, var_sym);
  addtoclosure(closure3181, var_blocksOK);
  addtoclosure(closure3181, var_errormessages);
  addtoclosure(closure3181, var_lastToken);
  addtoclosure(closure3181, var_values);
  addtoclosure(closure3181, var_ast);
  struct UserObject *uo3181 = (struct UserObject*)self;
  uo3181->data[31] = (Object)closure3181;
  Method *meth_meth_parser_prefixop3181 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3181, 31);
  int argcv_meth_parser_prefixop3181[] = {0};
  meth_meth_parser_prefixop3181->type = alloc_MethodType(1, argcv_meth_parser_prefixop3181);
  meth_meth_parser_prefixop3181->definitionModule = modulename;
  meth_meth_parser_prefixop3181->definitionLine = 1004;
// compiled method node returning  (depth = 1)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "generic"
  block_savedest(self);
  Object closure3371 = createclosure(5, "generic");
  setclosureframe(closure3371, stackframe);
  addtoclosure(closure3371, var_values);
  addtoclosure(closure3371, var_sym);
  addtoclosure(closure3371, var_errormessages);
  addtoclosure(closure3371, var_lastToken);
  addtoclosure(closure3371, var_ast);
  struct UserObject *uo3371 = (struct UserObject*)self;
  uo3371->data[32] = (Object)closure3371;
  Method *meth_meth_parser_generic3371 = addmethod2pos(self, "generic", &meth_parser_generic3371, 32);
  int argcv_meth_parser_generic3371[] = {0};
  meth_meth_parser_generic3371->type = alloc_MethodType(1, argcv_meth_parser_generic3371);
  meth_meth_parser_generic3371->definitionModule = modulename;
  meth_meth_parser_generic3371->definitionLine = 1061;
// compiled method node returning  (depth = 1)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "trycatch"
  block_savedest(self);
  Object closure3554 = createclosure(9, "trycatch");
  setclosureframe(closure3554, stackframe);
  addtoclosure(closure3554, var_sym);
  addtoclosure(closure3554, var_minIndentLevel);
  addtoclosure(closure3554, var_errormessages);
  addtoclosure(closure3554, var_lastToken);
  addtoclosure(closure3554, var_blocksOK);
  addtoclosure(closure3554, var_values);
  addtoclosure(closure3554, var_tokens);
  addtoclosure(closure3554, var_util);
  addtoclosure(closure3554, var_ast);
  struct UserObject *uo3554 = (struct UserObject*)self;
  uo3554->data[33] = (Object)closure3554;
  Method *meth_meth_parser_trycatch3554 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3554, 33);
  int argcv_meth_parser_trycatch3554[] = {0};
  meth_meth_parser_trycatch3554->type = alloc_MethodType(1, argcv_meth_parser_trycatch3554);
  meth_meth_parser_trycatch3554->definitionModule = modulename;
  meth_meth_parser_trycatch3554->definitionLine = 1121;
// compiled method node returning  (depth = 1)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "matchcase"
  block_savedest(self);
  Object closure4155 = createclosure(9, "matchcase");
  setclosureframe(closure4155, stackframe);
  addtoclosure(closure4155, var_sym);
  addtoclosure(closure4155, var_minIndentLevel);
  addtoclosure(closure4155, var_errormessages);
  addtoclosure(closure4155, var_blocksOK);
  addtoclosure(closure4155, var_lastToken);
  addtoclosure(closure4155, var_values);
  addtoclosure(closure4155, var_tokens);
  addtoclosure(closure4155, var_util);
  addtoclosure(closure4155, var_ast);
  struct UserObject *uo4155 = (struct UserObject*)self;
  uo4155->data[34] = (Object)closure4155;
  Method *meth_meth_parser_matchcase4155 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4155, 34);
  int argcv_meth_parser_matchcase4155[] = {0};
  meth_meth_parser_matchcase4155->type = alloc_MethodType(1, argcv_meth_parser_matchcase4155);
  meth_meth_parser_matchcase4155->definitionModule = modulename;
  meth_meth_parser_matchcase4155->definitionLine = 1289;
// compiled method node returning  (depth = 1)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "term"
  block_savedest(self);
  Object closure4530 = createclosure(3, "term");
  setclosureframe(closure4530, stackframe);
  addtoclosure(closure4530, var_sym);
  addtoclosure(closure4530, var_util);
  addtoclosure(closure4530, var_lastToken);
  struct UserObject *uo4530 = (struct UserObject*)self;
  uo4530->data[35] = (Object)closure4530;
  Method *meth_meth_parser_term4530 = addmethod2pos(self, "term", &meth_parser_term4530, 35);
  int argcv_meth_parser_term4530[] = {0};
  meth_meth_parser_term4530->type = alloc_MethodType(1, argcv_meth_parser_term4530);
  meth_meth_parser_term4530->definitionModule = modulename;
  meth_meth_parser_term4530->definitionLine = 1394;
// compiled method node returning  (depth = 1)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expression"
  block_savedest(self);
  Object closure4630 = createclosure(6, "expression");
  setclosureframe(closure4630, stackframe);
  addtoclosure(closure4630, var_values);
  addtoclosure(closure4630, var_sym);
  addtoclosure(closure4630, var_util);
  addtoclosure(closure4630, var_statementToken);
  addtoclosure(closure4630, var_errormessages);
  addtoclosure(closure4630, var_lastToken);
  struct UserObject *uo4630 = (struct UserObject*)self;
  uo4630->data[36] = (Object)closure4630;
  Method *meth_meth_parser_expression4630 = addmethod2pos(self, "expression", &meth_parser_expression4630, 36);
  int argcv_meth_parser_expression4630[] = {1};
  meth_meth_parser_expression4630->type = alloc_MethodType(1, argcv_meth_parser_expression4630);
  meth_meth_parser_expression4630->definitionModule = modulename;
  meth_meth_parser_expression4630->definitionLine = 1426;
// compiled method node returning  (depth = 1)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "postfixsquare"
  block_savedest(self);
  Object closure4738 = createclosure(5, "postfixsquare");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, var_sym);
  addtoclosure(closure4738, var_values);
  addtoclosure(closure4738, var_blocksOK);
  addtoclosure(closure4738, var_errormessages);
  addtoclosure(closure4738, var_lastToken);
  struct UserObject *uo4738 = (struct UserObject*)self;
  uo4738->data[37] = (Object)closure4738;
  Method *meth_meth_parser_postfixsquare4738 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare4738, 37);
  int argcv_meth_parser_postfixsquare4738[] = {0};
  meth_meth_parser_postfixsquare4738->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare4738);
  meth_meth_parser_postfixsquare4738->definitionModule = modulename;
  meth_meth_parser_postfixsquare4738->definitionLine = 1469;
// compiled method node returning  (depth = 1)
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "oprec"
  struct UserObject *uo4844 = (struct UserObject*)self;
  uo4844->data[38] = emptyclosure;
  Method *meth_meth_parser_oprec4844 = addmethod2pos(self, "oprec", &meth_parser_oprec4844, 38);
  int argcv_meth_parser_oprec4844[] = {1};
  meth_meth_parser_oprec4844->type = alloc_MethodType(1, argcv_meth_parser_oprec4844);
  meth_meth_parser_oprec4844->definitionModule = modulename;
  meth_meth_parser_oprec4844->definitionLine = 1507;
// compiled method node returning  (depth = 1)
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "toprec"
  struct UserObject *uo4858 = (struct UserObject*)self;
  uo4858->data[39] = emptyclosure;
  Method *meth_meth_parser_toprec4858 = addmethod2pos(self, "toprec", &meth_parser_toprec4858, 39);
  int argcv_meth_parser_toprec4858[] = {1};
  meth_meth_parser_toprec4858->type = alloc_MethodType(1, argcv_meth_parser_toprec4858);
  meth_meth_parser_toprec4858->definitionModule = modulename;
  meth_meth_parser_toprec4858->definitionLine = 1517;
// compiled method node returning  (depth = 1)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeexpressionrest"
  block_savedest(self);
  Object closure4871 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure4871, stackframe);
  addtoclosure(closure4871, var_noBlocks);
  struct UserObject *uo4871 = (struct UserObject*)self;
  uo4871->data[40] = (Object)closure4871;
  Method *meth_meth_parser_typeexpressionrest4871 = addmethod2pos(self, "typeexpressionrest", &meth_parser_typeexpressionrest4871, 40);
  int argcv_meth_parser_typeexpressionrest4871[] = {0};
  meth_meth_parser_typeexpressionrest4871->type = alloc_MethodType(1, argcv_meth_parser_typeexpressionrest4871);
  meth_meth_parser_typeexpressionrest4871->definitionModule = modulename;
  meth_meth_parser_typeexpressionrest4871->definitionLine = 1526;
// compiled method node returning  (depth = 1)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "valueexpressionrest"
  block_savedest(self);
  Object closure4884 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure4884, stackframe);
  addtoclosure(closure4884, var_blocksOK);
  struct UserObject *uo4884 = (struct UserObject*)self;
  uo4884->data[41] = (Object)closure4884;
  Method *meth_meth_parser_valueexpressionrest4884 = addmethod2pos(self, "valueexpressionrest", &meth_parser_valueexpressionrest4884, 41);
  int argcv_meth_parser_valueexpressionrest4884[] = {0};
  meth_meth_parser_valueexpressionrest4884->type = alloc_MethodType(1, argcv_meth_parser_valueexpressionrest4884);
  meth_meth_parser_valueexpressionrest4884->definitionModule = modulename;
  meth_meth_parser_valueexpressionrest4884->definitionLine = 1532;
// compiled method node returning  (depth = 1)
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "expressionrest()recursingWith()blocks"
  block_savedest(self);
  Object closure4897 = createclosure(7, "expressionrest()recursingWith()blocks");
  setclosureframe(closure4897, stackframe);
  addtoclosure(closure4897, var_values);
  addtoclosure(closure4897, var_sym);
  addtoclosure(closure4897, var_statementToken);
  addtoclosure(closure4897, var_errormessages);
  addtoclosure(closure4897, var_lastToken);
  addtoclosure(closure4897, var_util);
  addtoclosure(closure4897, var_ast);
  struct UserObject *uo4897 = (struct UserObject*)self;
  uo4897->data[42] = (Object)closure4897;
  Method *meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897 = addmethod2pos(self, "expressionrest()recursingWith()blocks", &meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897, 42);
  int argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897[] = {1, 1, 1};
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897->type = alloc_MethodType(3, argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897);
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897->definitionModule = modulename;
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks4897->definitionLine = 1538;
// compiled method node returning  (depth = 1)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotrest"
  block_savedest(self);
  Object closure5408 = createclosure(6, "dotrest");
  setclosureframe(closure5408, stackframe);
  addtoclosure(closure5408, var_sym);
  addtoclosure(closure5408, var_util);
  addtoclosure(closure5408, var_values);
  addtoclosure(closure5408, var_ast);
  addtoclosure(closure5408, var_errormessages);
  addtoclosure(closure5408, var_lastToken);
  struct UserObject *uo5408 = (struct UserObject*)self;
  uo5408->data[43] = (Object)closure5408;
  Method *meth_meth_parser_dotrest5408 = addmethod2pos(self, "dotrest", &meth_parser_dotrest5408, 43);
  int argcv_meth_parser_dotrest5408[] = {1};
  meth_meth_parser_dotrest5408->type = alloc_MethodType(1, argcv_meth_parser_dotrest5408);
  meth_meth_parser_dotrest5408->definitionModule = modulename;
  meth_meth_parser_dotrest5408->definitionLine = 1685;
// compiled method node returning  (depth = 1)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callrest"
  block_savedest(self);
  Object closure5514 = createclosure(6, "callrest");
  setclosureframe(closure5514, stackframe);
  addtoclosure(closure5514, var_values);
  addtoclosure(closure5514, var_sym);
  addtoclosure(closure5514, var_util);
  addtoclosure(closure5514, var_ast);
  addtoclosure(closure5514, var_lastToken);
  addtoclosure(closure5514, var_minIndentLevel);
  struct UserObject *uo5514 = (struct UserObject*)self;
  uo5514->data[44] = (Object)closure5514;
  Method *meth_meth_parser_callrest5514 = addmethod2pos(self, "callrest", &meth_parser_callrest5514, 44);
  int argcv_meth_parser_callrest5514[] = {1};
  meth_meth_parser_callrest5514->type = alloc_MethodType(1, argcv_meth_parser_callrest5514);
  meth_meth_parser_callrest5514->definitionModule = modulename;
  meth_meth_parser_callrest5514->definitionLine = 1719;
// compiled method node returning  (depth = 1)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parenthesizedArg"
  block_savedest(self);
  Object closure5730 = createclosure(5, "parenthesizedArg");
  setclosureframe(closure5730, stackframe);
  addtoclosure(closure5730, var_blocksOK);
  addtoclosure(closure5730, var_values);
  addtoclosure(closure5730, var_errormessages);
  addtoclosure(closure5730, var_sym);
  addtoclosure(closure5730, var_lastToken);
  struct UserObject *uo5730 = (struct UserObject*)self;
  uo5730->data[45] = (Object)closure5730;
  Method *meth_meth_parser_parenthesizedArg5730 = addmethod2pos(self, "parenthesizedArg", &meth_parser_parenthesizedArg5730, 45);
  int argcv_meth_parser_parenthesizedArg5730[] = {1};
  meth_meth_parser_parenthesizedArg5730->type = alloc_MethodType(1, argcv_meth_parser_parenthesizedArg5730);
  meth_meth_parser_parenthesizedArg5730->definitionModule = modulename;
  meth_meth_parser_parenthesizedArg5730->definitionLine = 1806;
// compiled method node returning  (depth = 1)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArgs"
  block_savedest(self);
  Object closure6132 = createclosure(4, "typeArgs");
  setclosureframe(closure6132, stackframe);
  addtoclosure(closure6132, var_sym);
  addtoclosure(closure6132, var_values);
  addtoclosure(closure6132, var_errormessages);
  addtoclosure(closure6132, var_lastToken);
  struct UserObject *uo6132 = (struct UserObject*)self;
  uo6132->data[46] = (Object)closure6132;
  Method *meth_meth_parser_typeArgs6132 = addmethod2pos(self, "typeArgs", &meth_parser_typeArgs6132, 46);
  int argcv_meth_parser_typeArgs6132[] = {0};
  meth_meth_parser_typeArgs6132->type = alloc_MethodType(1, argcv_meth_parser_typeArgs6132);
  meth_meth_parser_typeArgs6132->definitionModule = modulename;
  meth_meth_parser_typeArgs6132->definitionLine = 1916;
// compiled method node returning  (depth = 1)
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeArg"
  block_savedest(self);
  Object closure6211 = createclosure(3, "typeArg");
  setclosureframe(closure6211, stackframe);
  addtoclosure(closure6211, var_sym);
  addtoclosure(closure6211, var_values);
  addtoclosure(closure6211, var_ast);
  struct UserObject *uo6211 = (struct UserObject*)self;
  uo6211->data[47] = (Object)closure6211;
  Method *meth_meth_parser_typeArg6211 = addmethod2pos(self, "typeArg", &meth_parser_typeArg6211, 47);
  int argcv_meth_parser_typeArg6211[] = {0};
  meth_meth_parser_typeArg6211->type = alloc_MethodType(1, argcv_meth_parser_typeArg6211);
  meth_meth_parser_typeArg6211->definitionModule = modulename;
  meth_meth_parser_typeArg6211->definitionLine = 1941;
// compiled method node returning  (depth = 1)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "callmprest"
  block_savedest(self);
  Object closure6243 = createclosure(6, "callmprest");
  setclosureframe(closure6243, stackframe);
  addtoclosure(closure6243, var_lastToken);
  addtoclosure(closure6243, var_ast);
  addtoclosure(closure6243, var_values);
  addtoclosure(closure6243, var_errormessages);
  addtoclosure(closure6243, var_sym);
  addtoclosure(closure6243, var_blocksOK);
  struct UserObject *uo6243 = (struct UserObject*)self;
  uo6243->data[48] = (Object)closure6243;
  Method *meth_meth_parser_callmprest6243 = addmethod2pos(self, "callmprest", &meth_parser_callmprest6243, 48);
  int argcv_meth_parser_callmprest6243[] = {3};
  meth_meth_parser_callmprest6243->type = alloc_MethodType(1, argcv_meth_parser_callmprest6243);
  meth_meth_parser_callmprest6243->definitionModule = modulename;
  meth_meth_parser_callmprest6243->definitionLine = 1957;
// compiled method node returning  (depth = 1)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "defdec"
  block_savedest(self);
  Object closure6608 = createclosure(7, "defdec");
  setclosureframe(closure6608, stackframe);
  addtoclosure(closure6608, var_sym);
  addtoclosure(closure6608, var_errormessages);
  addtoclosure(closure6608, var_lastToken);
  addtoclosure(closure6608, var_values);
  addtoclosure(closure6608, var_blocksOK);
  addtoclosure(closure6608, var_util);
  addtoclosure(closure6608, var_ast);
  struct UserObject *uo6608 = (struct UserObject*)self;
  uo6608->data[49] = (Object)closure6608;
  Method *meth_meth_parser_defdec6608 = addmethod2pos(self, "defdec", &meth_parser_defdec6608, 49);
  int argcv_meth_parser_defdec6608[] = {0};
  meth_meth_parser_defdec6608->type = alloc_MethodType(1, argcv_meth_parser_defdec6608);
  meth_meth_parser_defdec6608->definitionModule = modulename;
  meth_meth_parser_defdec6608->definitionLine = 2079;
// compiled method node returning  (depth = 1)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "vardec"
  block_savedest(self);
  Object closure6863 = createclosure(7, "vardec");
  setclosureframe(closure6863, stackframe);
  addtoclosure(closure6863, var_sym);
  addtoclosure(closure6863, var_errormessages);
  addtoclosure(closure6863, var_lastToken);
  addtoclosure(closure6863, var_values);
  addtoclosure(closure6863, var_blocksOK);
  addtoclosure(closure6863, var_util);
  addtoclosure(closure6863, var_ast);
  struct UserObject *uo6863 = (struct UserObject*)self;
  uo6863->data[50] = (Object)closure6863;
  Method *meth_meth_parser_vardec6863 = addmethod2pos(self, "vardec", &meth_parser_vardec6863, 50);
  int argcv_meth_parser_vardec6863[] = {0};
  meth_meth_parser_vardec6863->type = alloc_MethodType(1, argcv_meth_parser_vardec6863);
  meth_meth_parser_vardec6863->definitionModule = modulename;
  meth_meth_parser_vardec6863->definitionLine = 2156;
// compiled method node returning  (depth = 1)
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doarray"
  block_savedest(self);
  Object closure7082 = createclosure(6, "doarray");
  setclosureframe(closure7082, stackframe);
  addtoclosure(closure7082, var_blocksOK);
  addtoclosure(closure7082, var_values);
  addtoclosure(closure7082, var_errormessages);
  addtoclosure(closure7082, var_sym);
  addtoclosure(closure7082, var_lastToken);
  addtoclosure(closure7082, var_ast);
  struct UserObject *uo7082 = (struct UserObject*)self;
  uo7082->data[51] = (Object)closure7082;
  Method *meth_meth_parser_doarray7082 = addmethod2pos(self, "doarray", &meth_parser_doarray7082, 51);
  int argcv_meth_parser_doarray7082[] = {0};
  meth_meth_parser_doarray7082->type = alloc_MethodType(1, argcv_meth_parser_doarray7082);
  meth_meth_parser_doarray7082->definitionModule = modulename;
  meth_meth_parser_doarray7082->definitionLine = 2225;
// compiled method node returning  (depth = 1)
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dodialect"
  block_savedest(self);
  Object closure7212 = createclosure(5, "dodialect");
  setclosureframe(closure7212, stackframe);
  addtoclosure(closure7212, var_sym);
  addtoclosure(closure7212, var_errormessages);
  addtoclosure(closure7212, var_lastToken);
  addtoclosure(closure7212, var_ast);
  addtoclosure(closure7212, var_values);
  struct UserObject *uo7212 = (struct UserObject*)self;
  uo7212->data[52] = (Object)closure7212;
  Method *meth_meth_parser_dodialect7212 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7212, 52);
  int argcv_meth_parser_dodialect7212[] = {0};
  meth_meth_parser_dodialect7212->type = alloc_MethodType(1, argcv_meth_parser_dodialect7212);
  meth_meth_parser_dodialect7212->definitionModule = modulename;
  meth_meth_parser_dodialect7212->definitionLine = 2268;
// compiled method node returning  (depth = 1)
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsOrUses"
  block_savedest(self);
  Object closure7292 = createclosure(8, "inheritsOrUses");
  setclosureframe(closure7292, stackframe);
  addtoclosure(closure7292, var_done);
  addtoclosure(closure7292, var_sym);
  addtoclosure(closure7292, var_noBlocks);
  addtoclosure(closure7292, var_errormessages);
  addtoclosure(closure7292, var_lastToken);
  addtoclosure(closure7292, var_util);
  addtoclosure(closure7292, var_values);
  addtoclosure(closure7292, var_ast);
  struct UserObject *uo7292 = (struct UserObject*)self;
  uo7292->data[53] = (Object)closure7292;
  Method *meth_meth_parser_inheritsOrUses7292 = addmethod2pos(self, "inheritsOrUses", &meth_parser_inheritsOrUses7292, 53);
  int argcv_meth_parser_inheritsOrUses7292[] = {0};
  meth_meth_parser_inheritsOrUses7292->type = alloc_MethodType(1, argcv_meth_parser_inheritsOrUses7292);
  meth_meth_parser_inheritsOrUses7292->definitionModule = modulename;
  meth_meth_parser_inheritsOrUses7292->definitionLine = 2289;
// compiled method node returning  (depth = 1)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "inheritsModifier()onLineOf"
  block_savedest(self);
  Object closure7452 = createclosure(1, "inheritsModifier()onLineOf");
  setclosureframe(closure7452, stackframe);
  addtoclosure(closure7452, var_sym);
  struct UserObject *uo7452 = (struct UserObject*)self;
  uo7452->data[54] = (Object)closure7452;
  Method *meth_meth_parser_inheritsModifier_40__41_onLineOf7452 = addmethod2pos(self, "inheritsModifier()onLineOf", &meth_parser_inheritsModifier_40__41_onLineOf7452, 54);
  int argcv_meth_parser_inheritsModifier_40__41_onLineOf7452[] = {1, 1};
  meth_meth_parser_inheritsModifier_40__41_onLineOf7452->type = alloc_MethodType(2, argcv_meth_parser_inheritsModifier_40__41_onLineOf7452);
  meth_meth_parser_inheritsModifier_40__41_onLineOf7452->definitionModule = modulename;
  meth_meth_parser_inheritsModifier_40__41_onLineOf7452->definitionLine = 2330;
// compiled method node returning  (depth = 1)
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseAlias"
  block_savedest(self);
  Object closure7479 = createclosure(3, "parseAlias");
  setclosureframe(closure7479, stackframe);
  addtoclosure(closure7479, var_sym);
  addtoclosure(closure7479, var_lastToken);
  addtoclosure(closure7479, var_errormessages);
  struct UserObject *uo7479 = (struct UserObject*)self;
  uo7479->data[55] = (Object)closure7479;
  Method *meth_meth_parser_parseAlias7479 = addmethod2pos(self, "parseAlias", &meth_parser_parseAlias7479, 55);
  int argcv_meth_parser_parseAlias7479[] = {1};
  meth_meth_parser_parseAlias7479->type = alloc_MethodType(1, argcv_meth_parser_parseAlias7479);
  meth_meth_parser_parseAlias7479->definitionModule = modulename;
  meth_meth_parser_parseAlias7479->definitionLine = 2344;
// compiled method node returning  (depth = 1)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseExclude"
  struct UserObject *uo7529 = (struct UserObject*)self;
  uo7529->data[56] = emptyclosure;
  Method *meth_meth_parser_parseExclude7529 = addmethod2pos(self, "parseExclude", &meth_parser_parseExclude7529, 56);
  int argcv_meth_parser_parseExclude7529[] = {1};
  meth_meth_parser_parseExclude7529->type = alloc_MethodType(1, argcv_meth_parser_parseExclude7529);
  meth_meth_parser_parseExclude7529->definitionModule = modulename;
  meth_meth_parser_parseExclude7529->definitionLine = 2361;
// compiled method node returning  (depth = 1)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doobject"
  block_savedest(self);
  Object closure7543 = createclosure(1, "doobject");
  setclosureframe(closure7543, stackframe);
  addtoclosure(closure7543, var_lastToken);
  struct UserObject *uo7543 = (struct UserObject*)self;
  uo7543->data[57] = (Object)closure7543;
  Method *meth_meth_parser_doobject7543 = addmethod2pos(self, "doobject", &meth_parser_doobject7543, 57);
  int argcv_meth_parser_doobject7543[] = {0};
  meth_meth_parser_doobject7543->type = alloc_MethodType(1, argcv_meth_parser_doobject7543);
  meth_meth_parser_doobject7543->definitionModule = modulename;
  meth_meth_parser_doobject7543->definitionLine = 2370;
// compiled method node returning  (depth = 1)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parseObjectConstructorBody()startingWith()after"
  block_savedest(self);
  Object closure7554 = createclosure(8, "parseObjectConstructorBody()startingWith()after");
  setclosureframe(closure7554, stackframe);
  addtoclosure(closure7554, var_minIndentLevel);
  addtoclosure(closure7554, var_sym);
  addtoclosure(closure7554, var_errormessages);
  addtoclosure(closure7554, var_lastToken);
  addtoclosure(closure7554, var_statementToken);
  addtoclosure(closure7554, var_values);
  addtoclosure(closure7554, var_util);
  addtoclosure(closure7554, var_ast);
  struct UserObject *uo7554 = (struct UserObject*)self;
  uo7554->data[58] = (Object)closure7554;
  Method *meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554 = addmethod2pos(self, "parseObjectConstructorBody()startingWith()after", &meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554, 58);
  int argcv_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554[] = {1, 1, 1};
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554->type = alloc_MethodType(3, argcv_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554);
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554->definitionModule = modulename;
  meth_meth_parser_parseObjectConstructorBody_40__41_startingWith_40__41_after7554->definitionLine = 2381;
// compiled method node returning  (depth = 1)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doclass"
  block_savedest(self);
  Object closure7843 = createclosure(8, "doclass");
  setclosureframe(closure7843, stackframe);
  addtoclosure(closure7843, var_sym);
  addtoclosure(closure7843, var_minIndentLevel);
  addtoclosure(closure7843, var_errormessages);
  addtoclosure(closure7843, var_lastToken);
  addtoclosure(closure7843, var_tokens);
  addtoclosure(closure7843, var_values);
  addtoclosure(closure7843, var_util);
  addtoclosure(closure7843, var_ast);
  struct UserObject *uo7843 = (struct UserObject*)self;
  uo7843->data[59] = (Object)closure7843;
  Method *meth_meth_parser_doclass7843 = addmethod2pos(self, "doclass", &meth_parser_doclass7843, 59);
  int argcv_meth_parser_doclass7843[] = {0};
  meth_meth_parser_doclass7843->type = alloc_MethodType(1, argcv_meth_parser_doclass7843);
  meth_meth_parser_doclass7843->definitionModule = modulename;
  meth_meth_parser_doclass7843->definitionLine = 2451;
// compiled method node returning  (depth = 1)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dofactoryMethod"
  block_savedest(self);
  Object closure8076 = createclosure(8, "dofactoryMethod");
  setclosureframe(closure8076, stackframe);
  addtoclosure(closure8076, var_tokens);
  addtoclosure(closure8076, var_sym);
  addtoclosure(closure8076, var_minIndentLevel);
  addtoclosure(closure8076, var_errormessages);
  addtoclosure(closure8076, var_lastToken);
  addtoclosure(closure8076, var_values);
  addtoclosure(closure8076, var_util);
  addtoclosure(closure8076, var_ast);
  struct UserObject *uo8076 = (struct UserObject*)self;
  uo8076->data[60] = (Object)closure8076;
  Method *meth_meth_parser_dofactoryMethod8076 = addmethod2pos(self, "dofactoryMethod", &meth_parser_dofactoryMethod8076, 60);
  int argcv_meth_parser_dofactoryMethod8076[] = {0};
  meth_meth_parser_dofactoryMethod8076->type = alloc_MethodType(1, argcv_meth_parser_dofactoryMethod8076);
  meth_meth_parser_dofactoryMethod8076->definitionModule = modulename;
  meth_meth_parser_dofactoryMethod8076->definitionLine = 2544;
// compiled method node returning  (depth = 1)
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methoddec"
  block_savedest(self);
  Object closure8218 = createclosure(8, "methoddec");
  setclosureframe(closure8218, stackframe);
  addtoclosure(closure8218, var_sym);
  addtoclosure(closure8218, var_statementToken);
  addtoclosure(closure8218, var_minIndentLevel);
  addtoclosure(closure8218, var_values);
  addtoclosure(closure8218, var_errormessages);
  addtoclosure(closure8218, var_lastToken);
  addtoclosure(closure8218, var_util);
  addtoclosure(closure8218, var_ast);
  struct UserObject *uo8218 = (struct UserObject*)self;
  uo8218->data[61] = (Object)closure8218;
  Method *meth_meth_parser_methoddec8218 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8218, 61);
  int argcv_meth_parser_methoddec8218[] = {0};
  meth_meth_parser_methoddec8218->type = alloc_MethodType(1, argcv_meth_parser_methoddec8218);
  meth_meth_parser_methoddec8218->definitionModule = modulename;
  meth_meth_parser_methoddec8218->definitionLine = 2592;
// compiled method node returning  (depth = 1)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodDecRest"
  block_savedest(self);
  Object closure8431 = createclosure(5, "methodDecRest");
  setclosureframe(closure8431, stackframe);
  addtoclosure(closure8431, var_ast);
  addtoclosure(closure8431, var_values);
  addtoclosure(closure8431, var_errormessages);
  addtoclosure(closure8431, var_lastToken);
  addtoclosure(closure8431, var_sym);
  struct UserObject *uo8431 = (struct UserObject*)self;
  uo8431->data[62] = (Object)closure8431;
  Method *meth_meth_parser_methodDecRest8431 = addmethod2pos(self, "methodDecRest", &meth_parser_methodDecRest8431, 62);
  int argcv_meth_parser_methodDecRest8431[] = {2};
  meth_meth_parser_methodDecRest8431->type = alloc_MethodType(1, argcv_meth_parser_methodDecRest8431);
  meth_meth_parser_methodDecRest8431->definitionModule = modulename;
  meth_meth_parser_methodDecRest8431->definitionLine = 2672;
// compiled method node returning  (depth = 1)
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "optionalTypeAnnotation"
  block_savedest(self);
  Object closure8620 = createclosure(4, "optionalTypeAnnotation");
  setclosureframe(closure8620, stackframe);
  addtoclosure(closure8620, var_values);
  addtoclosure(closure8620, var_errormessages);
  addtoclosure(closure8620, var_lastToken);
  addtoclosure(closure8620, var_sym);
  struct UserObject *uo8620 = (struct UserObject*)self;
  uo8620->data[63] = (Object)closure8620;
  Method *meth_meth_parser_optionalTypeAnnotation8620 = addmethod2pos(self, "optionalTypeAnnotation", &meth_parser_optionalTypeAnnotation8620, 63);
  int argcv_meth_parser_optionalTypeAnnotation8620[] = {0};
  meth_meth_parser_optionalTypeAnnotation8620->type = alloc_MethodType(1, argcv_meth_parser_optionalTypeAnnotation8620);
  meth_meth_parser_optionalTypeAnnotation8620->definitionModule = modulename;
  meth_meth_parser_optionalTypeAnnotation8620->definitionLine = 2730;
// compiled method node returning  (depth = 1)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "methodsignature"
  block_savedest(self);
  Object closure8668 = createclosure(5, "methodsignature");
  setclosureframe(closure8668, stackframe);
  addtoclosure(closure8668, var_sym);
  addtoclosure(closure8668, var_errormessages);
  addtoclosure(closure8668, var_lastToken);
  addtoclosure(closure8668, var_values);
  addtoclosure(closure8668, var_ast);
  struct UserObject *uo8668 = (struct UserObject*)self;
  uo8668->data[64] = (Object)closure8668;
  Method *meth_meth_parser_methodsignature8668 = addmethod2pos(self, "methodsignature", &meth_parser_methodsignature8668, 64);
  int argcv_meth_parser_methodsignature8668[] = {1};
  meth_meth_parser_methodsignature8668->type = alloc_MethodType(1, argcv_meth_parser_methodsignature8668);
  meth_meth_parser_methodsignature8668->definitionModule = modulename;
  meth_meth_parser_methodsignature8668->definitionLine = 2753;
  block_savedest(self);
  Object closure9062 = createclosure(5, "methodsignature()object");
  setclosureframe(closure9062, stackframe);
  addtoclosure(closure9062, var_sym);
  addtoclosure(closure9062, var_errormessages);
  addtoclosure(closure9062, var_lastToken);
  addtoclosure(closure9062, var_values);
  addtoclosure(closure9062, var_ast);
  Method *meth_meth_parser_methodsignature8668_object = addmethod2pos(self, "methodsignature()object", &meth_parser_methodsignature8668_object, 64);
  meth_meth_parser_methodsignature8668_object->definitionModule = modulename;
  meth_meth_parser_methodsignature8668_object->definitionLine = 2753;
// compiled method node returning  (depth = 1)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typeparameters"
  block_savedest(self);
  Object closure9063 = createclosure(5, "typeparameters");
  setclosureframe(closure9063, stackframe);
  addtoclosure(closure9063, var_values);
  addtoclosure(closure9063, var_ast);
  addtoclosure(closure9063, var_sym);
  addtoclosure(closure9063, var_errormessages);
  addtoclosure(closure9063, var_lastToken);
  struct UserObject *uo9063 = (struct UserObject*)self;
  uo9063->data[65] = (Object)closure9063;
  Method *meth_meth_parser_typeparameters9063 = addmethod2pos(self, "typeparameters", &meth_parser_typeparameters9063, 65);
  int argcv_meth_parser_typeparameters9063[] = {0};
  meth_meth_parser_typeparameters9063->type = alloc_MethodType(1, argcv_meth_parser_typeparameters9063);
  meth_meth_parser_typeparameters9063->definitionModule = modulename;
  meth_meth_parser_typeparameters9063->definitionLine = 2858;
// compiled method node returning  (depth = 1)
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doimport"
  block_savedest(self);
  Object closure9133 = createclosure(6, "doimport");
  setclosureframe(closure9133, stackframe);
  addtoclosure(closure9133, var_sym);
  addtoclosure(closure9133, var_errormessages);
  addtoclosure(closure9133, var_lastToken);
  addtoclosure(closure9133, var_values);
  addtoclosure(closure9133, var_util);
  addtoclosure(closure9133, var_ast);
  struct UserObject *uo9133 = (struct UserObject*)self;
  uo9133->data[66] = (Object)closure9133;
  Method *meth_meth_parser_doimport9133 = addmethod2pos(self, "doimport", &meth_parser_doimport9133, 66);
  int argcv_meth_parser_doimport9133[] = {0};
  meth_meth_parser_doimport9133->type = alloc_MethodType(1, argcv_meth_parser_doimport9133);
  meth_meth_parser_doimport9133->definitionModule = modulename;
  meth_meth_parser_doimport9133->definitionLine = 2882;
// compiled method node returning  (depth = 1)
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "doreturn"
  block_savedest(self);
  Object closure9383 = createclosure(7, "doreturn");
  setclosureframe(closure9383, stackframe);
  addtoclosure(closure9383, var_sym);
  addtoclosure(closure9383, var_blocksOK);
  addtoclosure(closure9383, var_errormessages);
  addtoclosure(closure9383, var_lastToken);
  addtoclosure(closure9383, var_values);
  addtoclosure(closure9383, var_ast);
  addtoclosure(closure9383, var_util);
  struct UserObject *uo9383 = (struct UserObject*)self;
  uo9383->data[67] = (Object)closure9383;
  Method *meth_meth_parser_doreturn9383 = addmethod2pos(self, "doreturn", &meth_parser_doreturn9383, 67);
  int argcv_meth_parser_doreturn9383[] = {0};
  meth_meth_parser_doreturn9383->type = alloc_MethodType(1, argcv_meth_parser_doreturn9383);
  meth_meth_parser_doreturn9383->definitionModule = modulename;
  meth_meth_parser_doreturn9383->definitionLine = 2940;
// compiled method node returning  (depth = 1)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "domethodtype"
  block_savedest(self);
  Object closure9503 = createclosure(6, "domethodtype");
  setclosureframe(closure9503, stackframe);
  addtoclosure(closure9503, var_sym);
  addtoclosure(closure9503, var_ast);
  addtoclosure(closure9503, var_util);
  addtoclosure(closure9503, var_values);
  addtoclosure(closure9503, var_lastToken);
  addtoclosure(closure9503, var_errormessages);
  struct UserObject *uo9503 = (struct UserObject*)self;
  uo9503->data[68] = (Object)closure9503;
  Method *meth_meth_parser_domethodtype9503 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype9503, 68);
  int argcv_meth_parser_domethodtype9503[] = {0};
  meth_meth_parser_domethodtype9503->type = alloc_MethodType(1, argcv_meth_parser_domethodtype9503);
  meth_meth_parser_domethodtype9503->definitionModule = modulename;
  meth_meth_parser_domethodtype9503->definitionLine = 2976;
// compiled method node returning  (depth = 1)
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dotypeLiteral"
  block_savedest(self);
  Object closure9608 = createclosure(7, "dotypeLiteral");
  setclosureframe(closure9608, stackframe);
  addtoclosure(closure9608, var_sym);
  addtoclosure(closure9608, var_errormessages);
  addtoclosure(closure9608, var_done);
  addtoclosure(closure9608, var_auto_count);
  addtoclosure(closure9608, var_values);
  addtoclosure(closure9608, var_util);
  addtoclosure(closure9608, var_ast);
  struct UserObject *uo9608 = (struct UserObject*)self;
  uo9608->data[69] = (Object)closure9608;
  Method *meth_meth_parser_dotypeLiteral9608 = addmethod2pos(self, "dotypeLiteral", &meth_parser_dotypeLiteral9608, 69);
  int argcv_meth_parser_dotypeLiteral9608[] = {0};
  meth_meth_parser_dotypeLiteral9608->type = alloc_MethodType(1, argcv_meth_parser_dotypeLiteral9608);
  meth_meth_parser_dotypeLiteral9608->definitionModule = modulename;
  meth_meth_parser_dotypeLiteral9608->definitionLine = 3007;
// compiled method node returning  (depth = 1)
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "typedec"
  block_savedest(self);
  Object closure9691 = createclosure(7, "typedec");
  setclosureframe(closure9691, stackframe);
  addtoclosure(closure9691, var_sym);
  addtoclosure(closure9691, var_errormessages);
  addtoclosure(closure9691, var_lastToken);
  addtoclosure(closure9691, var_util);
  addtoclosure(closure9691, var_values);
  addtoclosure(closure9691, var_ast);
  addtoclosure(closure9691, var_noBlocks);
  struct UserObject *uo9691 = (struct UserObject*)self;
  uo9691->data[70] = (Object)closure9691;
  Method *meth_meth_parser_typedec9691 = addmethod2pos(self, "typedec", &meth_parser_typedec9691, 70);
  int argcv_meth_parser_typedec9691[] = {0};
  meth_meth_parser_typedec9691->type = alloc_MethodType(1, argcv_meth_parser_typedec9691);
  meth_meth_parser_typedec9691->definitionModule = modulename;
  meth_meth_parser_typedec9691->definitionLine = 3042;
// compiled method node returning  (depth = 1)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkIndent"
  block_savedest(self);
  Object closure9854 = createclosure(6, "checkIndent");
  setclosureframe(closure9854, stackframe);
  addtoclosure(closure9854, var_indentFreePass);
  addtoclosure(closure9854, var_sym);
  addtoclosure(closure9854, var_minIndentLevel);
  addtoclosure(closure9854, var_errormessages);
  addtoclosure(closure9854, var_lastToken);
  addtoclosure(closure9854, var_lastIndent);
  struct UserObject *uo9854 = (struct UserObject*)self;
  uo9854->data[71] = (Object)closure9854;
  Method *meth_meth_parser_checkIndent9854 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent9854, 71);
  int argcv_meth_parser_checkIndent9854[] = {0};
  meth_meth_parser_checkIndent9854->type = alloc_MethodType(1, argcv_meth_parser_checkIndent9854);
  meth_meth_parser_checkIndent9854->definitionModule = modulename;
  meth_meth_parser_checkIndent9854->definitionLine = 3088;
// compiled method node returning  (depth = 1)
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "statement"
  block_savedest(self);
  Object closure10077 = createclosure(10, "statement");
  setclosureframe(closure10077, stackframe);
  addtoclosure(closure10077, var_sym);
  addtoclosure(closure10077, var_statementIndent);
  addtoclosure(closure10077, var_statementToken);
  addtoclosure(closure10077, var_blocksOK);
  addtoclosure(closure10077, var_values);
  addtoclosure(closure10077, var_errormessages);
  addtoclosure(closure10077, var_lastToken);
  addtoclosure(closure10077, var_util);
  addtoclosure(closure10077, var_ast);
  addtoclosure(closure10077, var_indentFreePass);
  struct UserObject *uo10077 = (struct UserObject*)self;
  uo10077->data[72] = (Object)closure10077;
  Method *meth_meth_parser_statement10077 = addmethod2pos(self, "statement", &meth_parser_statement10077, 72);
  int argcv_meth_parser_statement10077[] = {0};
  meth_meth_parser_statement10077->type = alloc_MethodType(1, argcv_meth_parser_statement10077);
  meth_meth_parser_statement10077->definitionModule = modulename;
  meth_meth_parser_statement10077->definitionLine = 3135;
// compiled method node returning  (depth = 1)
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pushComments"
  block_savedest(self);
  Object closure10346 = createclosure(8, "pushComments");
  setclosureframe(closure10346, stackframe);
  addtoclosure(closure10346, var_done);
  addtoclosure(closure10346, var_sym);
  addtoclosure(closure10346, var_util);
  addtoclosure(closure10346, var_ast);
  addtoclosure(closure10346, var_lastToken);
  addtoclosure(closure10346, var_comments);
  addtoclosure(closure10346, var_previousCommentToken);
  addtoclosure(closure10346, var_tokens);
  struct UserObject *uo10346 = (struct UserObject*)self;
  uo10346->data[73] = (Object)closure10346;
  Method *meth_meth_parser_pushComments10346 = addmethod2pos(self, "pushComments", &meth_parser_pushComments10346, 73);
  int argcv_meth_parser_pushComments10346[] = {0};
  meth_meth_parser_pushComments10346->type = alloc_MethodType(1, argcv_meth_parser_pushComments10346);
  meth_meth_parser_pushComments10346->definitionModule = modulename;
  meth_meth_parser_pushComments10346->definitionLine = 3218;
// compiled method node returning  (depth = 1)
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "reconcileComments"
  block_savedest(self);
  Object closure10479 = createclosure(4, "reconcileComments");
  setclosureframe(closure10479, stackframe);
  addtoclosure(closure10479, var_values);
  addtoclosure(closure10479, var_moduleObject);
  addtoclosure(closure10479, var_done);
  addtoclosure(closure10479, var_comments);
  struct UserObject *uo10479 = (struct UserObject*)self;
  uo10479->data[74] = (Object)closure10479;
  Method *meth_meth_parser_reconcileComments10479 = addmethod2pos(self, "reconcileComments", &meth_parser_reconcileComments10479, 74);
  int argcv_meth_parser_reconcileComments10479[] = {0};
  meth_meth_parser_reconcileComments10479->type = alloc_MethodType(1, argcv_meth_parser_reconcileComments10479);
  meth_meth_parser_reconcileComments10479->definitionModule = modulename;
  meth_meth_parser_reconcileComments10479->definitionLine = 3252;
// compiled method node returning  (depth = 1)
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadOperators"
  block_savedest(self);
  Object closure10606 = createclosure(2, "checkBadOperators");
  setclosureframe(closure10606, stackframe);
  addtoclosure(closure10606, var_sym);
  addtoclosure(closure10606, var_errormessages);
  struct UserObject *uo10606 = (struct UserObject*)self;
  uo10606->data[75] = (Object)closure10606;
  Method *meth_meth_parser_checkBadOperators10606 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators10606, 75);
  int argcv_meth_parser_checkBadOperators10606[] = {0};
  meth_meth_parser_checkBadOperators10606->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators10606);
  meth_meth_parser_checkBadOperators10606->definitionModule = modulename;
  meth_meth_parser_checkBadOperators10606->definitionLine = 3298;
// compiled method node returning  (depth = 1)
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkBadTypeLiteral"
  block_savedest(self);
  Object closure10653 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure10653, stackframe);
  addtoclosure(closure10653, var_sym);
  addtoclosure(closure10653, var_errormessages);
  struct UserObject *uo10653 = (struct UserObject*)self;
  uo10653->data[76] = (Object)closure10653;
  Method *meth_meth_parser_checkBadTypeLiteral10653 = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_checkBadTypeLiteral10653, 76);
  int argcv_meth_parser_checkBadTypeLiteral10653[] = {0};
  meth_meth_parser_checkBadTypeLiteral10653->type = alloc_MethodType(1, argcv_meth_parser_checkBadTypeLiteral10653);
  meth_meth_parser_checkBadTypeLiteral10653->definitionModule = modulename;
  meth_meth_parser_checkBadTypeLiteral10653->definitionLine = 3315;
// compiled method node returning  (depth = 1)
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "checkUnexpectedTokenAfterStatement"
  block_savedest(self);
  Object closure10677 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure10677, stackframe);
  addtoclosure(closure10677, var_lastToken);
  addtoclosure(closure10677, var_sym);
  addtoclosure(closure10677, var_errormessages);
  addtoclosure(closure10677, var_values);
  addtoclosure(closure10677, var_util);
  struct UserObject *uo10677 = (struct UserObject*)self;
  uo10677->data[77] = (Object)closure10677;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement10677 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement10677, 77);
  int argcv_meth_parser_checkUnexpectedTokenAfterStatement10677[] = {0};
  meth_meth_parser_checkUnexpectedTokenAfterStatement10677->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement10677);
  meth_meth_parser_checkUnexpectedTokenAfterStatement10677->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement10677->definitionLine = 3325;
// compiled method node returning  (depth = 1)
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "parse"
  block_savedest(self);
  Object closure11004 = createclosure(7, "parse");
  setclosureframe(closure11004, stackframe);
  addtoclosure(closure11004, var_util);
  addtoclosure(closure11004, var_values);
  addtoclosure(closure11004, var_ast);
  addtoclosure(closure11004, var_moduleObject);
  addtoclosure(closure11004, var_tokens);
  addtoclosure(closure11004, var_sym);
  addtoclosure(closure11004, var_errormessages);
  struct UserObject *uo11004 = (struct UserObject*)self;
  uo11004->data[78] = (Object)closure11004;
  Method *meth_meth_parser_parse11004 = addmethod2pos(self, "parse", &meth_parser_parse11004, 78);
  int argcv_meth_parser_parse11004[] = {1};
  meth_meth_parser_parse11004->type = alloc_MethodType(1, argcv_meth_parser_parse11004);
  meth_meth_parser_parse11004->definitionModule = modulename;
  meth_meth_parser_parse11004->definitionLine = 3389;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = LOAD_MODULE(ast);
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = LOAD_MODULE(errormessages);
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11165 = alloc_Float64(0);
// compiled num node returning num11165 (depth = 2)
  *var_blankLocation = num11165;
  if (num11165 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation"
  block_savedest(self);
  Object closure11166 = createclosure(1, "blankLocation");
  setclosureframe(closure11166, stackframe);
  addtoclosure(closure11166, var_blankLocation);
  struct UserObject *uo11166 = (struct UserObject*)self;
  uo11166->data[79] = (Object)closure11166;
  Method *meth_meth_parser_blankLocation11166 = addmethod2pos(self, "blankLocation", &meth_parser_blankLocation11166, 79);
  int argcv_meth_parser_blankLocation11166[] = {0};
  meth_meth_parser_blankLocation11166->type = alloc_MethodType(1, argcv_meth_parser_blankLocation11166);
  meth_meth_parser_blankLocation11166->definitionModule = modulename;
  meth_meth_parser_blankLocation11166->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blankLocation:="
  block_savedest(self);
  Object closure11167 = createclosure(1, "blankLocation:=");
  setclosureframe(closure11167, stackframe);
  addtoclosure(closure11167, var_blankLocation);
  struct UserObject *uo11167 = (struct UserObject*)self;
  uo11167->data[80] = (Object)closure11167;
  Method *meth_meth_parser_blankLocation_58__61_11167 = addmethod2pos(self, "blankLocation:=", &meth_parser_blankLocation_58__61_11167, 80);
  int argcv_meth_parser_blankLocation_58__61_11167[] = {1};
  meth_meth_parser_blankLocation_58__61_11167->type = alloc_MethodType(1, argcv_meth_parser_blankLocation_58__61_11167);
  meth_meth_parser_blankLocation_58__61_11167->definitionModule = modulename;
  meth_meth_parser_blankLocation_58__61_11167->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11169 = alloc_Float64(0);
// compiled num node returning num11169 (depth = 2)
  *var_lastLine = num11169;
  if (num11169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine"
  block_savedest(self);
  Object closure11170 = createclosure(1, "lastLine");
  setclosureframe(closure11170, stackframe);
  addtoclosure(closure11170, var_lastLine);
  struct UserObject *uo11170 = (struct UserObject*)self;
  uo11170->data[81] = (Object)closure11170;
  Method *meth_meth_parser_lastLine11170 = addmethod2pos(self, "lastLine", &meth_parser_lastLine11170, 81);
  int argcv_meth_parser_lastLine11170[] = {0};
  meth_meth_parser_lastLine11170->type = alloc_MethodType(1, argcv_meth_parser_lastLine11170);
  meth_meth_parser_lastLine11170->definitionModule = modulename;
  meth_meth_parser_lastLine11170->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastLine:="
  block_savedest(self);
  Object closure11171 = createclosure(1, "lastLine:=");
  setclosureframe(closure11171, stackframe);
  addtoclosure(closure11171, var_lastLine);
  struct UserObject *uo11171 = (struct UserObject*)self;
  uo11171->data[82] = (Object)closure11171;
  Method *meth_meth_parser_lastLine_58__61_11171 = addmethod2pos(self, "lastLine:=", &meth_parser_lastLine_58__61_11171, 82);
  int argcv_meth_parser_lastLine_58__61_11171[] = {1};
  meth_meth_parser_lastLine_58__61_11171->type = alloc_MethodType(1, argcv_meth_parser_lastLine_58__61_11171);
  meth_meth_parser_lastLine_58__61_11171->definitionModule = modulename;
  meth_meth_parser_lastLine_58__61_11171->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11173 = alloc_Float64(0);
// compiled num node returning num11173 (depth = 2)
  *var_lastIndent = num11173;
  if (num11173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent"
  block_savedest(self);
  Object closure11174 = createclosure(1, "lastIndent");
  setclosureframe(closure11174, stackframe);
  addtoclosure(closure11174, var_lastIndent);
  struct UserObject *uo11174 = (struct UserObject*)self;
  uo11174->data[83] = (Object)closure11174;
  Method *meth_meth_parser_lastIndent11174 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent11174, 83);
  int argcv_meth_parser_lastIndent11174[] = {0};
  meth_meth_parser_lastIndent11174->type = alloc_MethodType(1, argcv_meth_parser_lastIndent11174);
  meth_meth_parser_lastIndent11174->definitionModule = modulename;
  meth_meth_parser_lastIndent11174->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastIndent:="
  block_savedest(self);
  Object closure11175 = createclosure(1, "lastIndent:=");
  setclosureframe(closure11175, stackframe);
  addtoclosure(closure11175, var_lastIndent);
  struct UserObject *uo11175 = (struct UserObject*)self;
  uo11175->data[84] = (Object)closure11175;
  Method *meth_meth_parser_lastIndent_58__61_11175 = addmethod2pos(self, "lastIndent:=", &meth_parser_lastIndent_58__61_11175, 84);
  int argcv_meth_parser_lastIndent_58__61_11175[] = {1};
  meth_meth_parser_lastIndent_58__61_11175->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61_11175);
  meth_meth_parser_lastIndent_58__61_11175->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61_11175->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11177 = alloc_Boolean(0);
// compiled identifier node returning bool11177 (depth = 2)
  *var_indentFreePass = bool11177;
  if (bool11177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass"
  block_savedest(self);
  Object closure11178 = createclosure(1, "indentFreePass");
  setclosureframe(closure11178, stackframe);
  addtoclosure(closure11178, var_indentFreePass);
  struct UserObject *uo11178 = (struct UserObject*)self;
  uo11178->data[85] = (Object)closure11178;
  Method *meth_meth_parser_indentFreePass11178 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass11178, 85);
  int argcv_meth_parser_indentFreePass11178[] = {0};
  meth_meth_parser_indentFreePass11178->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass11178);
  meth_meth_parser_indentFreePass11178->definitionModule = modulename;
  meth_meth_parser_indentFreePass11178->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indentFreePass:="
  block_savedest(self);
  Object closure11179 = createclosure(1, "indentFreePass:=");
  setclosureframe(closure11179, stackframe);
  addtoclosure(closure11179, var_indentFreePass);
  struct UserObject *uo11179 = (struct UserObject*)self;
  uo11179->data[86] = (Object)closure11179;
  Method *meth_meth_parser_indentFreePass_58__61_11179 = addmethod2pos(self, "indentFreePass:=", &meth_parser_indentFreePass_58__61_11179, 86);
  int argcv_meth_parser_indentFreePass_58__61_11179[] = {1};
  meth_meth_parser_indentFreePass_58__61_11179->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61_11179);
  meth_meth_parser_indentFreePass_58__61_11179->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61_11179->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11181 = alloc_Float64(0);
// compiled num node returning num11181 (depth = 2)
  *var_minIndentLevel = num11181;
  if (num11181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel"
  block_savedest(self);
  Object closure11182 = createclosure(1, "minIndentLevel");
  setclosureframe(closure11182, stackframe);
  addtoclosure(closure11182, var_minIndentLevel);
  struct UserObject *uo11182 = (struct UserObject*)self;
  uo11182->data[87] = (Object)closure11182;
  Method *meth_meth_parser_minIndentLevel11182 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel11182, 87);
  int argcv_meth_parser_minIndentLevel11182[] = {0};
  meth_meth_parser_minIndentLevel11182->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel11182);
  meth_meth_parser_minIndentLevel11182->definitionModule = modulename;
  meth_meth_parser_minIndentLevel11182->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "minIndentLevel:="
  block_savedest(self);
  Object closure11183 = createclosure(1, "minIndentLevel:=");
  setclosureframe(closure11183, stackframe);
  addtoclosure(closure11183, var_minIndentLevel);
  struct UserObject *uo11183 = (struct UserObject*)self;
  uo11183->data[88] = (Object)closure11183;
  Method *meth_meth_parser_minIndentLevel_58__61_11183 = addmethod2pos(self, "minIndentLevel:=", &meth_parser_minIndentLevel_58__61_11183, 88);
  int argcv_meth_parser_minIndentLevel_58__61_11183[] = {1};
  meth_meth_parser_minIndentLevel_58__61_11183->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61_11183);
  meth_meth_parser_minIndentLevel_58__61_11183->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61_11183->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11185 = alloc_Float64(0);
// compiled num node returning num11185 (depth = 2)
  *var_statementIndent = num11185;
  if (num11185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent"
  block_savedest(self);
  Object closure11186 = createclosure(1, "statementIndent");
  setclosureframe(closure11186, stackframe);
  addtoclosure(closure11186, var_statementIndent);
  struct UserObject *uo11186 = (struct UserObject*)self;
  uo11186->data[89] = (Object)closure11186;
  Method *meth_meth_parser_statementIndent11186 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent11186, 89);
  int argcv_meth_parser_statementIndent11186[] = {0};
  meth_meth_parser_statementIndent11186->type = alloc_MethodType(1, argcv_meth_parser_statementIndent11186);
  meth_meth_parser_statementIndent11186->definitionModule = modulename;
  meth_meth_parser_statementIndent11186->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementIndent:="
  block_savedest(self);
  Object closure11187 = createclosure(1, "statementIndent:=");
  setclosureframe(closure11187, stackframe);
  addtoclosure(closure11187, var_statementIndent);
  struct UserObject *uo11187 = (struct UserObject*)self;
  uo11187->data[90] = (Object)closure11187;
  Method *meth_meth_parser_statementIndent_58__61_11187 = addmethod2pos(self, "statementIndent:=", &meth_parser_statementIndent_58__61_11187, 90);
  int argcv_meth_parser_statementIndent_58__61_11187[] = {1};
  meth_meth_parser_statementIndent_58__61_11187->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61_11187);
  meth_meth_parser_statementIndent_58__61_11187->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61_11187->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11189 = alloc_Boolean(0);
// compiled identifier node returning bool11189 (depth = 2)
  *var_tokens = bool11189;
  if (bool11189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens"
  block_savedest(self);
  Object closure11190 = createclosure(1, "tokens");
  setclosureframe(closure11190, stackframe);
  addtoclosure(closure11190, var_tokens);
  struct UserObject *uo11190 = (struct UserObject*)self;
  uo11190->data[91] = (Object)closure11190;
  Method *meth_meth_parser_tokens11190 = addmethod2pos(self, "tokens", &meth_parser_tokens11190, 91);
  int argcv_meth_parser_tokens11190[] = {0};
  meth_meth_parser_tokens11190->type = alloc_MethodType(1, argcv_meth_parser_tokens11190);
  meth_meth_parser_tokens11190->definitionModule = modulename;
  meth_meth_parser_tokens11190->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "tokens:="
  block_savedest(self);
  Object closure11191 = createclosure(1, "tokens:=");
  setclosureframe(closure11191, stackframe);
  addtoclosure(closure11191, var_tokens);
  struct UserObject *uo11191 = (struct UserObject*)self;
  uo11191->data[92] = (Object)closure11191;
  Method *meth_meth_parser_tokens_58__61_11191 = addmethod2pos(self, "tokens:=", &meth_parser_tokens_58__61_11191, 92);
  int argcv_meth_parser_tokens_58__61_11191[] = {1};
  meth_meth_parser_tokens_58__61_11191->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61_11191);
  meth_meth_parser_tokens_58__61_11191->definitionModule = modulename;
  meth_meth_parser_tokens_58__61_11191->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile array node (depth = 2)
  Object array11193 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11193 (depth = 2)
  *var_values = array11193;
  if (array11193 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values"
  block_savedest(self);
  Object closure11194 = createclosure(1, "values");
  setclosureframe(closure11194, stackframe);
  addtoclosure(closure11194, var_values);
  struct UserObject *uo11194 = (struct UserObject*)self;
  uo11194->data[93] = (Object)closure11194;
  Method *meth_meth_parser_values11194 = addmethod2pos(self, "values", &meth_parser_values11194, 93);
  int argcv_meth_parser_values11194[] = {0};
  meth_meth_parser_values11194->type = alloc_MethodType(1, argcv_meth_parser_values11194);
  meth_meth_parser_values11194->definitionModule = modulename;
  meth_meth_parser_values11194->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "values:="
  block_savedest(self);
  Object closure11195 = createclosure(1, "values:=");
  setclosureframe(closure11195, stackframe);
  addtoclosure(closure11195, var_values);
  struct UserObject *uo11195 = (struct UserObject*)self;
  uo11195->data[94] = (Object)closure11195;
  Method *meth_meth_parser_values_58__61_11195 = addmethod2pos(self, "values:=", &meth_parser_values_58__61_11195, 94);
  int argcv_meth_parser_values_58__61_11195[] = {1};
  meth_meth_parser_values_58__61_11195->type = alloc_MethodType(1, argcv_meth_parser_values_58__61_11195);
  meth_meth_parser_values_58__61_11195->definitionModule = modulename;
  meth_meth_parser_values_58__61_11195->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_moduleObject = undefined;
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject"
  block_savedest(self);
  Object closure11197 = createclosure(1, "moduleObject");
  setclosureframe(closure11197, stackframe);
  addtoclosure(closure11197, var_moduleObject);
  struct UserObject *uo11197 = (struct UserObject*)self;
  uo11197->data[95] = (Object)closure11197;
  Method *meth_meth_parser_moduleObject11197 = addmethod2pos(self, "moduleObject", &meth_parser_moduleObject11197, 95);
  int argcv_meth_parser_moduleObject11197[] = {0};
  meth_meth_parser_moduleObject11197->type = alloc_MethodType(1, argcv_meth_parser_moduleObject11197);
  meth_meth_parser_moduleObject11197->definitionModule = modulename;
  meth_meth_parser_moduleObject11197->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "moduleObject:="
  block_savedest(self);
  Object closure11198 = createclosure(1, "moduleObject:=");
  setclosureframe(closure11198, stackframe);
  addtoclosure(closure11198, var_moduleObject);
  struct UserObject *uo11198 = (struct UserObject*)self;
  uo11198->data[96] = (Object)closure11198;
  Method *meth_meth_parser_moduleObject_58__61_11198 = addmethod2pos(self, "moduleObject:=", &meth_parser_moduleObject_58__61_11198, 96);
  int argcv_meth_parser_moduleObject_58__61_11198[] = {1};
  meth_meth_parser_moduleObject_58__61_11198->type = alloc_MethodType(1, argcv_meth_parser_moduleObject_58__61_11198);
  meth_meth_parser_moduleObject_58__61_11198->definitionModule = modulename;
  meth_meth_parser_moduleObject_58__61_11198->definitionLine = 3441;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11200 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call11201 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11200);
// compiled call node returning call11201 (depth = 3)
// compiled member node returning call11201 (depth = 2)
  *var_comments = call11201;
  if (call11201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "comments"
  block_savedest(self);
  Object closure11202 = createclosure(1, "comments");
  setclosureframe(closure11202, stackframe);
  addtoclosure(closure11202, var_comments);
  struct UserObject *uo11202 = (struct UserObject*)self;
  uo11202->data[97] = (Object)closure11202;
  Method *meth_meth_parser_comments11202 = addmethod2pos(self, "comments", &meth_parser_comments11202, 97);
  int argcv_meth_parser_comments11202[] = {0};
  meth_meth_parser_comments11202->type = alloc_MethodType(1, argcv_meth_parser_comments11202);
  meth_meth_parser_comments11202->definitionModule = modulename;
  meth_meth_parser_comments11202->definitionLine = 16;
// compiled method node returning  (depth = 2)
// starting to compile method node (depth = 2)
// method "comments:="
  block_savedest(self);
  Object closure11203 = createclosure(1, "comments:=");
  setclosureframe(closure11203, stackframe);
  addtoclosure(closure11203, var_comments);
  struct UserObject *uo11203 = (struct UserObject*)self;
  uo11203->data[98] = (Object)closure11203;
  Method *meth_meth_parser_comments_58__61_11203 = addmethod2pos(self, "comments:=", &meth_parser_comments_58__61_11203, 98);
  int argcv_meth_parser_comments_58__61_11203[] = {1};
  meth_meth_parser_comments_58__61_11203->type = alloc_MethodType(1, argcv_meth_parser_comments_58__61_11203);
  meth_meth_parser_comments_58__61_11203->definitionModule = modulename;
  meth_meth_parser_comments_58__61_11203->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile num node (depth = 2)
  Object num11205 = alloc_Float64(0);
// compiled num node returning num11205 (depth = 2)
  *var_auto_count = num11205;
  if (num11205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count"
  block_savedest(self);
  Object closure11206 = createclosure(1, "auto_count");
  setclosureframe(closure11206, stackframe);
  addtoclosure(closure11206, var_auto_count);
  struct UserObject *uo11206 = (struct UserObject*)self;
  uo11206->data[99] = (Object)closure11206;
  Method *meth_meth_parser_auto_count11206 = addmethod2pos(self, "auto_count", &meth_parser_auto_count11206, 99);
  int argcv_meth_parser_auto_count11206[] = {0};
  meth_meth_parser_auto_count11206->type = alloc_MethodType(1, argcv_meth_parser_auto_count11206);
  meth_meth_parser_auto_count11206->definitionModule = modulename;
  meth_meth_parser_auto_count11206->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "auto_count:="
  block_savedest(self);
  Object closure11207 = createclosure(1, "auto_count:=");
  setclosureframe(closure11207, stackframe);
  addtoclosure(closure11207, var_auto_count);
  struct UserObject *uo11207 = (struct UserObject*)self;
  uo11207->data[100] = (Object)closure11207;
  Method *meth_meth_parser_auto_count_58__61_11207 = addmethod2pos(self, "auto_count:=", &meth_parser_auto_count_58__61_11207, 100);
  int argcv_meth_parser_auto_count_58__61_11207[] = {1};
  meth_meth_parser_auto_count_58__61_11207->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61_11207);
  meth_meth_parser_auto_count_58__61_11207->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61_11207->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11209 = alloc_Boolean(0);
// compiled identifier node returning bool11209 (depth = 2)
  *var_noBlocks = bool11209;
  if (bool11209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "noBlocks"
  block_savedest(self);
  Object closure11210 = createclosure(1, "noBlocks");
  setclosureframe(closure11210, stackframe);
  addtoclosure(closure11210, var_noBlocks);
  struct UserObject *uo11210 = (struct UserObject*)self;
  uo11210->data[101] = (Object)closure11210;
  Method *meth_meth_parser_noBlocks11210 = addmethod2pos(self, "noBlocks", &meth_parser_noBlocks11210, 101);
  int argcv_meth_parser_noBlocks11210[] = {0};
  meth_meth_parser_noBlocks11210->type = alloc_MethodType(1, argcv_meth_parser_noBlocks11210);
  meth_meth_parser_noBlocks11210->definitionModule = modulename;
  meth_meth_parser_noBlocks11210->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11211 = alloc_Boolean(1);
// compiled identifier node returning bool11211 (depth = 2)
  *var_blocksOK = bool11211;
  if (bool11211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "blocksOK"
  block_savedest(self);
  Object closure11212 = createclosure(1, "blocksOK");
  setclosureframe(closure11212, stackframe);
  addtoclosure(closure11212, var_blocksOK);
  struct UserObject *uo11212 = (struct UserObject*)self;
  uo11212->data[102] = (Object)closure11212;
  Method *meth_meth_parser_blocksOK11212 = addmethod2pos(self, "blocksOK", &meth_parser_blocksOK11212, 102);
  int argcv_meth_parser_blocksOK11212[] = {0};
  meth_meth_parser_blocksOK11212->type = alloc_MethodType(1, argcv_meth_parser_blocksOK11212);
  meth_meth_parser_blocksOK11212->definitionModule = modulename;
  meth_meth_parser_blocksOK11212->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11213 = alloc_Boolean(0);
// compiled identifier node returning bool11213 (depth = 2)
  *var_braceIsType = bool11213;
  if (bool11213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType"
  block_savedest(self);
  Object closure11214 = createclosure(1, "braceIsType");
  setclosureframe(closure11214, stackframe);
  addtoclosure(closure11214, var_braceIsType);
  struct UserObject *uo11214 = (struct UserObject*)self;
  uo11214->data[103] = (Object)closure11214;
  Method *meth_meth_parser_braceIsType11214 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType11214, 103);
  int argcv_meth_parser_braceIsType11214[] = {0};
  meth_meth_parser_braceIsType11214->type = alloc_MethodType(1, argcv_meth_parser_braceIsType11214);
  meth_meth_parser_braceIsType11214->definitionModule = modulename;
  meth_meth_parser_braceIsType11214->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "braceIsType:="
  block_savedest(self);
  Object closure11215 = createclosure(1, "braceIsType:=");
  setclosureframe(closure11215, stackframe);
  addtoclosure(closure11215, var_braceIsType);
  struct UserObject *uo11215 = (struct UserObject*)self;
  uo11215->data[104] = (Object)closure11215;
  Method *meth_meth_parser_braceIsType_58__61_11215 = addmethod2pos(self, "braceIsType:=", &meth_parser_braceIsType_58__61_11215, 104);
  int argcv_meth_parser_braceIsType_58__61_11215[] = {1};
  meth_meth_parser_braceIsType_58__61_11215->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61_11215);
  meth_meth_parser_braceIsType_58__61_11215->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61_11215->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11217 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11217 = alloc_userobj2(6,7, objclass11217);
  gc_frame_newslot(obj11217);
// OBJECT OUTER DEC outer
  adddatum2(obj11217, self, 0);
  addmethodreal(obj11217,"outer", &reader_parser_outer_11218);
  Object oldself11217 = self;
  struct StackFrameObject *oldstackframe11217 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11217);
  gc_frame_newslot((Object)stackframe);
  self = obj11217;
  Object *oldselfslot11217 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11217 = (*(struct UserObject *)self).data[0], lowerouter11217 = thisouter11217;
  if (inheritingObject11217) {
    struct UserObject *inho11217 = (struct UserObject *)inheritingObject11217;
    while (inho11217->super != GraceDefaultObject) inho11217 = (struct UserObject *)inho11217->super;
    inho11217->super = obj11217;
    self = inheritingObject11217;
    *selfslot = self;
    lowerouter11217 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11217;
  }
if (objclass11217 == NULL) {
  Method *reader11219 = addmethodrealflags(obj11217, "kind",&reader_parser_kind_11219, MFLAG_DEF);
  reader11219->definitionModule = modulename;
  reader11219->definitionLine = 24;
}
adddatum2(obj11217, alloc_Undefined(), 1);
if (objclass11217 == NULL) {
  Method *reader11220 = addmethodrealflags(obj11217, "line",&reader_parser_line_11220, MFLAG_DEF);
  reader11220->definitionModule = modulename;
  reader11220->definitionLine = 25;
}
adddatum2(obj11217, alloc_Undefined(), 2);
if (objclass11217 == NULL) {
  Method *reader11221 = addmethodrealflags(obj11217, "linePos",&reader_parser_linePos_11221, MFLAG_DEF);
  reader11221->definitionModule = modulename;
  reader11221->definitionLine = 26;
}
adddatum2(obj11217, alloc_Undefined(), 3);
if (objclass11217 == NULL) {
  Method *reader11222 = addmethodrealflags(obj11217, "indent",&reader_parser_indent_11222, MFLAG_DEF);
  reader11222->definitionModule = modulename;
  reader11222->definitionLine = 27;
}
adddatum2(obj11217, alloc_Undefined(), 4);
if (objclass11217 == NULL) {
  Method *reader11223 = addmethodrealflags(obj11217, "value",&reader_parser_value_11223, MFLAG_DEF);
  reader11223->definitionModule = modulename;
  reader11223->definitionLine = 28;
}
adddatum2(obj11217, alloc_Undefined(), 5);
if (objclass11217 == NULL) {
  Method *reader11224 = addmethodrealflags(obj11217, "size",&reader_parser_size_11224, MFLAG_DEF);
  reader11224->definitionModule = modulename;
  reader11224->definitionLine = 29;
}
adddatum2(obj11217, alloc_Undefined(), 6);
  sourceObject = obj11217;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11225 == NULL) {
    strlit11225 = alloc_String("start");
    gc_root(strlit11225);
  }
// compiled string node returning strlit11225 (depth = 3)
  adddatum2(obj11217, strlit11225, 1);
  sourceObject = obj11217;
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11226 = alloc_Float64(0);
// compiled num node returning num11226 (depth = 3)
  adddatum2(obj11217, num11226, 2);
  sourceObject = obj11217;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11227 = alloc_Float64(0);
// compiled num node returning num11227 (depth = 3)
  adddatum2(obj11217, num11227, 3);
  sourceObject = obj11217;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11228 = alloc_Float64(0);
// compiled num node returning num11228 (depth = 3)
  adddatum2(obj11217, num11228, 4);
  sourceObject = obj11217;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11229 == NULL) {
    strlit11229 = alloc_String("");
    gc_root(strlit11229);
  }
// compiled string node returning strlit11229 (depth = 3)
  adddatum2(obj11217, strlit11229, 5);
  sourceObject = obj11217;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11230 = alloc_Float64(0);
// compiled num node returning num11230 (depth = 3)
  adddatum2(obj11217, num11230, 6);
  objclass11217 = obj11217->class;
  objclass11217->definitionModule = modulename;
  objclass11217->definitionLine = 23;
  (*(struct UserObject *)self).data[0] = lowerouter11217;
  self = oldself11217;
  selfslot = oldselfslot11217;
  stackframe = oldstackframe11217;
// compiled object node returning obj11217 (depth = 2)
  *var_sym = obj11217;
  if (obj11217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym"
  block_savedest(self);
  Object closure11231 = createclosure(1, "sym");
  setclosureframe(closure11231, stackframe);
  addtoclosure(closure11231, var_sym);
  struct UserObject *uo11231 = (struct UserObject*)self;
  uo11231->data[105] = (Object)closure11231;
  Method *meth_meth_parser_sym11231 = addmethod2pos(self, "sym", &meth_parser_sym11231, 105);
  int argcv_meth_parser_sym11231[] = {0};
  meth_meth_parser_sym11231->type = alloc_MethodType(1, argcv_meth_parser_sym11231);
  meth_meth_parser_sym11231->definitionModule = modulename;
  meth_meth_parser_sym11231->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "sym:="
  block_savedest(self);
  Object closure11232 = createclosure(1, "sym:=");
  setclosureframe(closure11232, stackframe);
  addtoclosure(closure11232, var_sym);
  struct UserObject *uo11232 = (struct UserObject*)self;
  uo11232->data[106] = (Object)closure11232;
  Method *meth_meth_parser_sym_58__61_11232 = addmethod2pos(self, "sym:=", &meth_parser_sym_58__61_11232, 106);
  int argcv_meth_parser_sym_58__61_11232[] = {1};
  meth_meth_parser_sym_58__61_11232->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61_11232);
  meth_meth_parser_sym_58__61_11232->definitionModule = modulename;
  meth_meth_parser_sym_58__61_11232->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sym (depth = 2)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken"
  block_savedest(self);
  Object closure11234 = createclosure(1, "lastToken");
  setclosureframe(closure11234, stackframe);
  addtoclosure(closure11234, var_lastToken);
  struct UserObject *uo11234 = (struct UserObject*)self;
  uo11234->data[107] = (Object)closure11234;
  Method *meth_meth_parser_lastToken11234 = addmethod2pos(self, "lastToken", &meth_parser_lastToken11234, 107);
  int argcv_meth_parser_lastToken11234[] = {0};
  meth_meth_parser_lastToken11234->type = alloc_MethodType(1, argcv_meth_parser_lastToken11234);
  meth_meth_parser_lastToken11234->definitionModule = modulename;
  meth_meth_parser_lastToken11234->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "lastToken:="
  block_savedest(self);
  Object closure11235 = createclosure(1, "lastToken:=");
  setclosureframe(closure11235, stackframe);
  addtoclosure(closure11235, var_lastToken);
  struct UserObject *uo11235 = (struct UserObject*)self;
  uo11235->data[108] = (Object)closure11235;
  Method *meth_meth_parser_lastToken_58__61_11235 = addmethod2pos(self, "lastToken:=", &meth_parser_lastToken_58__61_11235, 108);
  int argcv_meth_parser_lastToken_58__61_11235[] = {1};
  meth_meth_parser_lastToken_58__61_11235->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61_11235);
  meth_meth_parser_lastToken_58__61_11235->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61_11235->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_previousCommentToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken"
  block_savedest(self);
  Object closure11237 = createclosure(1, "previousCommentToken");
  setclosureframe(closure11237, stackframe);
  addtoclosure(closure11237, var_previousCommentToken);
  struct UserObject *uo11237 = (struct UserObject*)self;
  uo11237->data[109] = (Object)closure11237;
  Method *meth_meth_parser_previousCommentToken11237 = addmethod2pos(self, "previousCommentToken", &meth_parser_previousCommentToken11237, 109);
  int argcv_meth_parser_previousCommentToken11237[] = {0};
  meth_meth_parser_previousCommentToken11237->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken11237);
  meth_meth_parser_previousCommentToken11237->definitionModule = modulename;
  meth_meth_parser_previousCommentToken11237->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "previousCommentToken:="
  block_savedest(self);
  Object closure11238 = createclosure(1, "previousCommentToken:=");
  setclosureframe(closure11238, stackframe);
  addtoclosure(closure11238, var_previousCommentToken);
  struct UserObject *uo11238 = (struct UserObject*)self;
  uo11238->data[110] = (Object)closure11238;
  Method *meth_meth_parser_previousCommentToken_58__61_11238 = addmethod2pos(self, "previousCommentToken:=", &meth_parser_previousCommentToken_58__61_11238, 110);
  int argcv_meth_parser_previousCommentToken_58__61_11238[] = {1};
  meth_meth_parser_previousCommentToken_58__61_11238->type = alloc_MethodType(1, argcv_meth_parser_previousCommentToken_58__61_11238);
  meth_meth_parser_previousCommentToken_58__61_11238->definitionModule = modulename;
  meth_meth_parser_previousCommentToken_58__61_11238->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken"
  block_savedest(self);
  Object closure11240 = createclosure(1, "statementToken");
  setclosureframe(closure11240, stackframe);
  addtoclosure(closure11240, var_statementToken);
  struct UserObject *uo11240 = (struct UserObject*)self;
  uo11240->data[111] = (Object)closure11240;
  Method *meth_meth_parser_statementToken11240 = addmethod2pos(self, "statementToken", &meth_parser_statementToken11240, 111);
  int argcv_meth_parser_statementToken11240[] = {0};
  meth_meth_parser_statementToken11240->type = alloc_MethodType(1, argcv_meth_parser_statementToken11240);
  meth_meth_parser_statementToken11240->definitionModule = modulename;
  meth_meth_parser_statementToken11240->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "statementToken:="
  block_savedest(self);
  Object closure11241 = createclosure(1, "statementToken:=");
  setclosureframe(closure11241, stackframe);
  addtoclosure(closure11241, var_statementToken);
  struct UserObject *uo11241 = (struct UserObject*)self;
  uo11241->data[112] = (Object)closure11241;
  Method *meth_meth_parser_statementToken_58__61_11241 = addmethod2pos(self, "statementToken:=", &meth_parser_statementToken_58__61_11241, 112);
  int argcv_meth_parser_statementToken_58__61_11241[] = {1};
  meth_meth_parser_statementToken_58__61_11241->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61_11241);
  meth_meth_parser_statementToken_58__61_11241->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61_11241->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11243 = alloc_Boolean(0);
// compiled identifier node returning bool11243 (depth = 2)
  *var_comment = bool11243;
  if (bool11243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment"
  block_savedest(self);
  Object closure11244 = createclosure(1, "comment");
  setclosureframe(closure11244, stackframe);
  addtoclosure(closure11244, var_comment);
  struct UserObject *uo11244 = (struct UserObject*)self;
  uo11244->data[113] = (Object)closure11244;
  Method *meth_meth_parser_comment11244 = addmethod2pos(self, "comment", &meth_parser_comment11244, 113);
  int argcv_meth_parser_comment11244[] = {0};
  meth_meth_parser_comment11244->type = alloc_MethodType(1, argcv_meth_parser_comment11244);
  meth_meth_parser_comment11244->definitionModule = modulename;
  meth_meth_parser_comment11244->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "comment:="
  block_savedest(self);
  Object closure11245 = createclosure(1, "comment:=");
  setclosureframe(closure11245, stackframe);
  addtoclosure(closure11245, var_comment);
  struct UserObject *uo11245 = (struct UserObject*)self;
  uo11245->data[114] = (Object)closure11245;
  Method *meth_meth_parser_comment_58__61_11245 = addmethod2pos(self, "comment:=", &meth_parser_comment_58__61_11245, 114);
  int argcv_meth_parser_comment_58__61_11245[] = {1};
  meth_meth_parser_comment_58__61_11245->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61_11245);
  meth_meth_parser_comment_58__61_11245->definitionModule = modulename;
  meth_meth_parser_comment_58__61_11245->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile identifier node (depth = 2)
  Object bool11247 = alloc_Boolean(1);
// compiled identifier node returning bool11247 (depth = 2)
  *var_firstCallOfNext = bool11247;
  if (bool11247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext"
  block_savedest(self);
  Object closure11248 = createclosure(1, "firstCallOfNext");
  setclosureframe(closure11248, stackframe);
  addtoclosure(closure11248, var_firstCallOfNext);
  struct UserObject *uo11248 = (struct UserObject*)self;
  uo11248->data[115] = (Object)closure11248;
  Method *meth_meth_parser_firstCallOfNext11248 = addmethod2pos(self, "firstCallOfNext", &meth_parser_firstCallOfNext11248, 115);
  int argcv_meth_parser_firstCallOfNext11248[] = {0};
  meth_meth_parser_firstCallOfNext11248->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext11248);
  meth_meth_parser_firstCallOfNext11248->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext11248->definitionLine = 16;
// compiled method node returning  (depth = 2)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "firstCallOfNext:="
  block_savedest(self);
  Object closure11249 = createclosure(1, "firstCallOfNext:=");
  setclosureframe(closure11249, stackframe);
  addtoclosure(closure11249, var_firstCallOfNext);
  struct UserObject *uo11249 = (struct UserObject*)self;
  uo11249->data[116] = (Object)closure11249;
  Method *meth_meth_parser_firstCallOfNext_58__61_11249 = addmethod2pos(self, "firstCallOfNext:=", &meth_parser_firstCallOfNext_58__61_11249, 116);
  int argcv_meth_parser_firstCallOfNext_58__61_11249[] = {1};
  meth_meth_parser_firstCallOfNext_58__61_11249->type = alloc_MethodType(1, argcv_meth_parser_firstCallOfNext_58__61_11249);
  meth_meth_parser_firstCallOfNext_58__61_11249->definitionModule = modulename;
  meth_meth_parser_firstCallOfNext_58__61_11249->definitionLine = 16;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2975
  setline(2975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3134
  setline(3134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3395
  setline(3395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
