#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "1e2f5d98abb4529b811183acfa9f4c89618406e0";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "stringMap";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "// This module defines a class new that implements a mapping from strings to objects",
  "// Its interface is strange, but is designed to mimic that of mgcollecitons.map.new",
  "// For a general-purpose mapping obejct, use dictonary from standardGrace.",
  "//",
  "// The implementation for C is based on that from mgcollections; that for JS uses",
  "// native code, since hashing is built-in to JavaScript objects.",
  "// External iterators are not implemented.  Instead, the internal iterators",
  "// keysDo and valuesDo are provided.",
  "",
  "def unused = object {",
  "    inherits Singleton.named \"unused\"",
  "    def key is public = self",
  "}",
  "",
  "class new {",
  "    var elems := 0",
  "    var inner := primitiveArray.new(4)",
  "    for (0..(inner.size-1)) do {i->",
  "        inner.at(i)put(unused)",
  "    }",
  "    native \"js\" code ‹this.data.inner = { };›  ",
  "        // override the primitiveArray with an empty object",
  "",
  "    method size {",
  "        // The number of bindings that I contain.",
  "        native \"js\" code ‹var s = Object.keys(this.data.inner).length;",
  "              return new GraceNum(s);›",
  "        elems",
  "    }",
  "",
  "    method put(k, v) {",
  "        // binds the value v and the key k, which must be a String.",
  "        // Returns self, for chaining.",
  "        native \"js\" code ‹this.data.inner[var_k._value] = var_v;",
  "                        return this;›",
  "        var t := findPosition(k)",
  "        if (unused == inner.at(t)) then {",
  "            elems := elems + 1",
  "        }",
  "        inner.at(t)put(k::v)",
  "        if (elems > (inner.size / 2)) then {",
  "            expand",
  "        }",
  "        self",
  "    }",
  "    method get(k) {",
  "        // answers the value associated with the key k.  If there is none",
  "        // raises the NoSuchObject exception.",
  "        native \"js\" code ‹if (this.data.inner.hasOwnProperty(var_k._value))",
  "                return this.data.inner[var_k._value];",
  "            var nso = callmethod(var___95__prelude, \"NoSuchObject\", [0]);",
  "            var exceptionMsg = new GraceString(\"no value for key \" + var_k._value);",
  "            throw new GraceExceptionPacket(nso, exceptionMsg);›",
  "        var t := findPosition(k)",
  "        var c := inner.at(t)",
  "        if (unused == c) then {",
  "            NoSuchObject.raise \"no value for key {k}\"",
  "        }",
  "        return c.value",
  "    }",
  "    method get(k) ifAbsent (absentBlock) {",
  "        // answers the value associated with the key k.  If there is none",
  "        // evaluates absentBlock and returns its result.",
  "        native \"js\" code ‹if (this.data.inner.hasOwnProperty(var_k._value))",
  "                return this.data.inner[var_k._value];",
  "            return callmethod(var_absentBlock, \"apply\", [0]);›",
  "        var t := findPosition(k)",
  "        var c := inner.at(t)",
  "        if (unused == c)",
  "            then { return absentBlock.apply }",
  "            else { return c.value }",
  "    }",
  "    method contains(k) {",
  "        // true if I contain the key k",
  "        native \"js\" code ‹if (this.data.inner.hasOwnProperty(var_k._value))",
  "                return GraceTrue;",
  "            else return GraceFalse;›",
  "        var t := findPosition(k)",
  "        if (inner.at(t).key == k) then {",
  "            return true",
  "        }",
  "        return false",
  "    }",
  "    method findPosition(x) is confidential {",
  "        def h = x.hash",
  "        def s = inner.size",
  "        var t := h % s",
  "        var jump := 5",
  "        while { unused ≠ inner.at(t) } do {",
  "            if (inner.at(t).key == x) then {",
  "                return t",
  "            }",
  "            if (jump != 0) then {",
  "                t := (t * 3 + 1) % s",
  "                jump := jump - 1",
  "            } else {",
  "                t := (t + 1) % s",
  "            }",
  "        }",
  "        return t",
  "    }",
  "    method asString {",
  "        native \"js\" code ‹var s = \"\";",
  "            var inner = this.data.inner;",
  "            var keys = Object.keys(inner);",
  "            for (var ix = 0; ix < keys.length; ix++) {",
  "                var key = keys[ix];",
  "                if (s === \"\") {",
  "                    s = key + \"::\";",
  "                } else {",
  "                    s = s + \", \" + key + \"::\";",
  "                }",
  "                s = s + callmethod(inner[key], \"asString\", [0])._value;",
  "            }",
  "            s = \"map.new[\" + s + \"]\";",
  "            return new GraceString(s);›",
  "        var s := \"\"",
  "        for (0..(inner.size-1)) do {i->",
  "            def a = inner.at(i)",
  "            if (a != unused) then {",
  "                if (s == \"\") then {",
  "                    s := \"{a.key}::{a.value}\"",
  "                } else {",
  "                    s := s ++ \", {a.key}::{a.value}\"",
  "                }",
  "            }",
  "        }",
  "        \"map.new[\" ++ s ++ \"]\"",
  "    }",
  "    method asDebugString {",
  "        asString",
  "    }",
  "    method keysAndValuesDo(action) {",
  "        // internal iterator over my keys and values.",
  "        native \"js\" code ‹var s = \"\";",
  "            var inner = this.data.inner;",
  "            var keys = Object.keys(inner);",
  "            for (var ix = 0; ix < keys.length; ix++) {",
  "                var key = keys[ix];",
  "                callmethod(var_action, \"apply\", [2], new GraceString(key), inner[key]);",
  "            }",
  "            return GraceDone;›",
  "        var count := 1",
  "        var idx := 0",
  "        while {count <= size} do {",
  "            while { unused == inner.at(idx) } do {",
  "                idx := idx + 1",
  "            }",
  "            def a = inner.at(idx)",
  "            action.apply(a.key, a.value)",
  "            count := count + 1",
  "            idx := idx + 1",
  "        }",
  "    }",
  "    method do(action) {",
  "        // internal iterator over my values.",
  "        native \"js\" code ‹",
  "            var inner = this.data.inner;",
  "            var keys = Object.keys(inner);",
  "            for (var ix = 0; ix < keys.length; ix++) {",
  "                var key = keys[ix];",
  "                callmethod(var_action, \"apply\", [1], inner[key]);",
  "            }",
  "            return GraceDone;›",
  "        var count := 1",
  "        var idx := 0",
  "        while {count <= size} do {",
  "            while { unused == inner.at(idx) } do {",
  "                idx := idx + 1",
  "            }",
  "            action.apply (inner.at(idx).value)",
  "            count := count + 1",
  "            idx := idx + 1",
  "        }",
  "    }",
  "    ",
  "    method keysDo(action) {",
  "        native \"js\" code ‹",
  "            var inner = this.data.inner;",
  "            var keys = Object.keys(inner);",
  "            for (var ix = 0; ix < keys.length; ix++) {",
  "                var key = keys[ix];",
  "                callmethod(var_action, \"apply\", [1], new GraceString(key));",
  "            }",
  "            return GraceDone;›",
  "        var count := 1",
  "        var idx := 0",
  "        while {count <= size} do {",
  "            while { unused == inner.at(idx) } do {",
  "                idx := idx + 1",
  "            }",
  "            action.apply (inner.at(idx).key)",
  "            count := count + 1",
  "            idx := idx + 1",
  "        }",
  "    }",
  "    ",
  "    method valuesDo(action) { do(action) }",
  "",
  "    method expand is confidential {",
  "        def c = inner.size",
  "        def n = c * 2",
  "        def oldInner = inner",
  "        inner := primitiveArray.new(n)",
  "        for (0..(inner.size-1)) do {i->",
  "            inner.at(i)put(unused)",
  "        }",
  "        elems := 0",
  "        for (0..(oldInner.size-1)) do {i->",
  "            def a = oldInner.at(i)",
  "            if (a != unused) then {",
  "                put(a.key, a.value)",
  "            }",
  "        }",
  "    }",
  "    method asList {",
  "        // the contents of this stringMap as a list of bindings",
  "        def result = emptyList",
  "        native \"js\" code ‹",
  "            var inner = this.data.inner;",
  "            var keys = Object.keys(inner);",
  "            for (var ix = 0; ix < keys.length; ix++) {",
  "                var key = keys[ix];",
  "                var keyStr = new GraceString(key);",
  "                var binding = callmethod(GraceBindingClass(), \"key()value\", ",
  "                                                    [1, 1], keyStr, inner[key]);",
  "                callmethod(var_result, \"add\", [1], binding);",
  "            }",
  "            return var_result;›",
  "        var count := 1",
  "        var idx := 0",
  "        while {count <= size} do {",
  "            while { unused == inner.at(idx) } do {",
  "                idx := idx + 1",
  "            }",
  "            result.add (inner.at(idx))",
  "            count := count + 1",
  "            idx := idx + 1",
  "        }",
  "        result",
  "    }",
  "}",
  NULL
};
Object reader_stringMap_outer_3(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_stringMap_elems_4(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_stringMap_elems_4(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_stringMap_inner_5(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_stringMap_inner_5(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_stringMap_outer_576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_stringMap_key_577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
static ClassData objclass2;
static Object strlit64;
static Object strlit68;
static Object strlit173;
static Object strlit199;
static Object strlit203;
static Object strlit210;
static Object strlit216;
static Object strlit224;
static Object strlit231;
static Object strlit237;
static Object strlit248;
static Object strlit252;
static ClassData objclass575;
static Object strlit579;
Object meth_stringMap_size6(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8 = callmethodflags(self, "elems", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7);
// compiled call node returning call8 (depth = 3)
// compiled member node returning call8 (depth = 2)
  gc_frame_end(frame);
  return call8;
}
Object meth_stringMap_put9(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method put");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for put (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call11 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10);
// compiled call node returning call11 (depth = 3)
  *var_t = call11;
  if (call11 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe14 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe15 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call16 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe15);
// compiled call node returning call16 (depth = 6)
// compiled member node returning call16 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call17 = callmethod(call16, "at",
    1, partcv, params);
  gc_frame_end(callframe14);
// compiled call node returning call17 (depth = 4)
  int op_slot_right_13 = gc_frame_newslot(call17);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unused (depth = 4)
  int op_slot_left_13 = gc_frame_newslot(*var_unused);
  params[0] = call17;
  partcv[0] = 1;
  Object opresult19 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult19 (depth = 3)
  Object if12 = done;
  if (istrue(opresult19)) {
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe20 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num22 = alloc_Float64(1);
// compiled num node returning num22 (depth = 5)
  int op_slot_right_21 = gc_frame_newslot(num22);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe24 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call25 = callmethodflags(self, "elems", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe24);
// compiled call node returning call25 (depth = 6)
// compiled member node returning call25 (depth = 5)
  int op_slot_left_21 = gc_frame_newslot(call25);
  params[0] = num22;
  partcv[0] = 1;
  Object sum26 = callmethod(call25, "+", 1, partcv, params);
// compiled op node returning sum26 (depth = 4)
  gc_frame_newslot(sum26);
// call case 4: self request
  params[0] = sum26;
  partcv[0] = 1;
  Object call27 = callmethodflags(self, "elems:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe20);
// compiled call node returning call27 (depth = 3)
    gc_frame_newslot(call27);
    if12 = call27;
  } else {
  }
// compiled if node returning if12 (depth = 2)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe28 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_v (depth = 4)
  int op_slot_right_29 = gc_frame_newslot(*var_v);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_left_29 = gc_frame_newslot(*var_k);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult31 = callmethod(*var_k, "::", 1, partcv, params);
// compiled op node returning opresult31 (depth = 3)
  gc_frame_newslot(opresult31);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe32 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call33 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe32);
// compiled call node returning call33 (depth = 4)
// compiled member node returning call33 (depth = 3)
  params[0] = *var_t;
  params[1] = opresult31;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call34 = callmethod(call33, "at()put",
    2, partcv, params);
  gc_frame_end(callframe28);
// compiled call node returning call34 (depth = 2)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num38 = alloc_Float64(2);
// compiled num node returning num38 (depth = 5)
  int op_slot_right_37 = gc_frame_newslot(num38);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe40 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe41 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call42 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe41);
// compiled call node returning call42 (depth = 8)
// compiled member node returning call42 (depth = 7)
  partcv[0] = 0;
  Object call43 = callmethod(call42, "size",
    1, partcv, params);
  gc_frame_end(callframe40);
// compiled call node returning call43 (depth = 6)
// compiled member node returning call43 (depth = 5)
  int op_slot_left_37 = gc_frame_newslot(call43);
  params[0] = num38;
  partcv[0] = 1;
  Object quotient44 = callmethod(call43, "/", 1, partcv, params);
// compiled op node returning quotient44 (depth = 4)
  int op_slot_right_36 = gc_frame_newslot(quotient44);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe46 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call47 = callmethodflags(self, "elems", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compiled call node returning call47 (depth = 5)
// compiled member node returning call47 (depth = 4)
  int op_slot_left_36 = gc_frame_newslot(call47);
  params[0] = quotient44;
  partcv[0] = 1;
  Object opresult48 = callmethod(call47, ">", 1, partcv, params);
// compiled op node returning opresult48 (depth = 3)
  Object if35 = done;
  if (istrue(opresult48)) {
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe49 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call50 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe49);
// compiled call node returning call50 (depth = 4)
// compiled member node returning call50 (depth = 3)
    gc_frame_newslot(call50);
    if35 = call50;
  } else {
  }
// compiled if node returning if35 (depth = 2)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_stringMap_get51(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "get");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method get");
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for get (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for get");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
  Object *var_c = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "c");
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe52 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call53 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe52);
// compiled call node returning call53 (depth = 3)
  *var_t = call53;
  if (call53 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe54 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe55 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call56 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe55);
// compiled call node returning call56 (depth = 5)
// compiled member node returning call56 (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call57 = callmethod(call56, "at",
    1, partcv, params);
  gc_frame_end(callframe54);
// compiled call node returning call57 (depth = 3)
  *var_c = call57;
  if (call57 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_59 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unused (depth = 4)
  int op_slot_left_59 = gc_frame_newslot(*var_unused);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult61 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult61 (depth = 3)
  Object if58 = done;
  if (istrue(opresult61)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit64 == NULL) {
    strlit64 = alloc_String("");
    gc_root(strlit64);
  }
// compiled string node returning strlit64 (depth = 5)
  int op_slot_right_63 = gc_frame_newslot(strlit64);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_66 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 6)
  if (strlit68 == NULL) {
    strlit68 = alloc_String("no value for key ");
    gc_root(strlit68);
  }
// compiled string node returning strlit68 (depth = 6)
  int op_slot_left_66 = gc_frame_newslot(strlit68);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult69 = callmethod(strlit68, "++", 1, partcv, params);
// compiled op node returning opresult69 (depth = 5)
  int op_slot_left_63 = gc_frame_newslot(opresult69);
  params[0] = strlit64;
  partcv[0] = 1;
  Object opresult70 = callmethod(opresult69, "++", 1, partcv, params);
// compiled op node returning opresult70 (depth = 4)
  gc_frame_newslot(opresult70);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe71 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call72 = callmethodflags(prelude, "NoSuchObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe71);
// compiled call node returning call72 (depth = 5)
// compiled member node returning call72 (depth = 4)
  params[0] = opresult70;
  partcv[0] = 1;
  Object call73 = callmethod(call72, "raise",
    1, partcv, params);
  gc_frame_end(callframe62);
// compiled call node returning call73 (depth = 3)
    gc_frame_newslot(call73);
    if58 = call73;
  } else {
  }
// compiled if node returning if58 (depth = 2)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe74 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  partcv[0] = 0;
  Object call75 = callmethod(*var_c, "value",
    1, partcv, params);
  gc_frame_end(callframe74);
// compiled call node returning call75 (depth = 4)
// compiled member node returning call75 (depth = 3)
  return call75;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_stringMap_get_40__41_ifAbsent76(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "get()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method get()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method get()ifAbsent");
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for get()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for get");
  Object *var_absentBlock = &(stackframe->slots[1]);
  *var_absentBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
  Object *var_c = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "c");
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe77 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call78 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe77);
// compiled call node returning call78 (depth = 3)
  *var_t = call78;
  if (call78 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe79 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe80 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call81 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe80);
// compiled call node returning call81 (depth = 5)
// compiled member node returning call81 (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call82 = callmethod(call81, "at",
    1, partcv, params);
  gc_frame_end(callframe79);
// compiled call node returning call82 (depth = 3)
  *var_c = call82;
  if (call82 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_84 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_unused (depth = 4)
  int op_slot_left_84 = gc_frame_newslot(*var_unused);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult86 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult86 (depth = 3)
  Object if83 = done;
  if (istrue(opresult86)) {
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe87 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_absentBlock (depth = 6)
  partcv[0] = 0;
  Object call88 = callmethod(*var_absentBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe87);
// compiled call node returning call88 (depth = 5)
// compiled member node returning call88 (depth = 4)
  return call88;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if83 = undefined;
  } else {
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe89 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  partcv[0] = 0;
  Object call90 = callmethod(*var_c, "value",
    1, partcv, params);
  gc_frame_end(callframe89);
// compiled call node returning call90 (depth = 5)
// compiled member node returning call90 (depth = 4)
  return call90;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if83 = undefined;
  }
// compiled if node returning if83 (depth = 2)
  gc_frame_end(frame);
  return if83;
}
Object meth_stringMap_contains91(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe92 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call93 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe92);
// compiled call node returning call93 (depth = 3)
  *var_t = call93;
  if (call93 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_95 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe97 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe98 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe99 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call100 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 8)
// compiled member node returning call100 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call101 = callmethod(call100, "at",
    1, partcv, params);
  gc_frame_end(callframe98);
// compiled call node returning call101 (depth = 6)
  partcv[0] = 0;
  Object call102 = callmethod(call101, "key",
    1, partcv, params);
  gc_frame_end(callframe97);
// compiled call node returning call102 (depth = 5)
// compiled member node returning call102 (depth = 4)
  int op_slot_left_95 = gc_frame_newslot(call102);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult103 = callmethod(call102, "==", 1, partcv, params);
// compiled op node returning opresult103 (depth = 3)
  Object if94 = done;
  if (istrue(opresult103)) {
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool104 = alloc_Boolean(1);
// compiled identifier node returning bool104 (depth = 4)
  return bool104;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if94 = undefined;
  } else {
  }
// compiled if node returning if94 (depth = 2)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool105 = alloc_Boolean(0);
// compiled identifier node returning bool105 (depth = 3)
  return bool105;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_stringMap__apply119(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe121 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call123 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe122);
// compiled call node returning call123 (depth = 7)
// compiled member node returning call123 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call124 = callmethod(call123, "at",
    1, partcv, params);
  gc_frame_end(callframe121);
// compiled call node returning call124 (depth = 5)
  int op_slot_right_120 = gc_frame_newslot(call124);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_120 = gc_frame_newslot(*var_unused);
  params[0] = call124;
  partcv[0] = 1;
  Object opresult126 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult126 (depth = 4)
  gc_frame_end(frame);
  return opresult126;
}
Object meth_stringMap__apply129(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_131 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe133 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe134 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call136 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe135);
// compiled call node returning call136 (depth = 10)
// compiled member node returning call136 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call137 = callmethod(call136, "at",
    1, partcv, params);
  gc_frame_end(callframe134);
// compiled call node returning call137 (depth = 8)
  partcv[0] = 0;
  Object call138 = callmethod(call137, "key",
    1, partcv, params);
  gc_frame_end(callframe133);
// compiled call node returning call138 (depth = 7)
// compiled member node returning call138 (depth = 6)
  int op_slot_left_131 = gc_frame_newslot(call138);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult139 = callmethod(call138, "==", 1, partcv, params);
// compiled op node returning opresult139 (depth = 5)
  Object if130 = done;
  if (istrue(opresult139)) {
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if130 = undefined;
  } else {
  }
// compiled if node returning if130 (depth = 4)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num142 = alloc_Float64(0);
// compiled num node returning num142 (depth = 6)
  int op_slot_right_141 = gc_frame_newslot(num142);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_141 = gc_frame_newslot(*var_jump);
  params[0] = num142;
  partcv[0] = 1;
  Object opresult144 = callmethod(*var_jump, "≠", 1, partcv, params);
// compiled op node returning opresult144 (depth = 5)
  Object if140 = done;
  if (istrue(opresult144)) {
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_145 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num148 = alloc_Float64(1);
// compiled num node returning num148 (depth = 8)
  int op_slot_right_147 = gc_frame_newslot(num148);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num151 = alloc_Float64(3);
// compiled num node returning num151 (depth = 9)
  int op_slot_right_150 = gc_frame_newslot(num151);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_150 = gc_frame_newslot(*var_t);
  params[0] = num151;
  partcv[0] = 1;
  Object prod153 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod153 (depth = 8)
  int op_slot_left_147 = gc_frame_newslot(prod153);
  params[0] = num148;
  partcv[0] = 1;
  Object sum154 = callmethod(prod153, "+", 1, partcv, params);
// compiled op node returning sum154 (depth = 7)
  int op_slot_left_145 = gc_frame_newslot(sum154);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus155 = callmethod(sum154, "%", 1, partcv, params);
// compiled op node returning modulus155 (depth = 6)
  *var_t = modulus155;
  if (modulus155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num158 = alloc_Float64(1);
// compiled num node returning num158 (depth = 7)
  int op_slot_right_157 = gc_frame_newslot(num158);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_157 = gc_frame_newslot(*var_jump);
  params[0] = num158;
  partcv[0] = 1;
  Object diff160 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff160 (depth = 6)
  *var_jump = diff160;
  if (diff160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if140 = done;
  } else {
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_162 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num165 = alloc_Float64(1);
// compiled num node returning num165 (depth = 8)
  int op_slot_right_164 = gc_frame_newslot(num165);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_164 = gc_frame_newslot(*var_t);
  params[0] = num165;
  partcv[0] = 1;
  Object sum167 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum167 (depth = 7)
  int op_slot_left_162 = gc_frame_newslot(sum167);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus168 = callmethod(sum167, "%", 1, partcv, params);
// compiled op node returning modulus168 (depth = 6)
  *var_t = modulus168;
  if (modulus168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if140 = done;
  }
// compiled if node returning if140 (depth = 4)
  gc_frame_end(frame);
  return if140;
}
Object meth_stringMap_findPosition106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findPosition");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call108 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe107);
// compiled call node returning call108 (depth = 4)
// compiled member node returning call108 (depth = 3)
  *var_h = call108;
  if (call108 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe109 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call111 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe110);
// compiled call node returning call111 (depth = 6)
// compiled member node returning call111 (depth = 5)
  partcv[0] = 0;
  Object call112 = callmethod(call111, "size",
    1, partcv, params);
  gc_frame_end(callframe109);
// compiled call node returning call112 (depth = 4)
// compiled member node returning call112 (depth = 3)
  *var_s = call112;
  if (call112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_113 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_113 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus115 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus115 (depth = 3)
  *var_t = modulus115;
  if (modulus115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num116 = alloc_Float64(5);
// compiled num node returning num116 (depth = 3)
  *var_jump = num116;
  if (num116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe117 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block118 = alloc_Block(NULL, NULL, "stringMap", 89);
  gc_frame_newslot(block118);
// method "_apply"
  block_savedest(block118);
  Object closure119 = createclosure(3, "_apply");
  setclosureframe(closure119, stackframe);
  addtoclosure(closure119, var_t);
  addtoclosure(closure119, var_unused);
  addtoclosure(closure119, selfslot);
  struct UserObject *uo119 = (struct UserObject*)block118;
  uo119->data[0] = (Object)closure119;
  Method *meth_meth_stringMap__apply119 = addmethod2pos(block118, "_apply", &meth_stringMap__apply119, 0);
  int argcv_meth_stringMap__apply119[] = {0};
  meth_meth_stringMap__apply119->type = alloc_MethodType(1, argcv_meth_stringMap__apply119);
  meth_meth_stringMap__apply119->definitionModule = modulename;
  meth_meth_stringMap__apply119->definitionLine = 86;
// compiled block node returning block118 (depth = 3)
  gc_frame_newslot(block118);
// starting to compile block node (depth = 3)
  Object block128 = alloc_Block(NULL, NULL, "stringMap", 89);
  gc_frame_newslot(block128);
// method "_apply"
  block_savedest(block128);
  Object closure129 = createclosure(5, "_apply");
  setclosureframe(closure129, stackframe);
  addtoclosure(closure129, var_x);
  addtoclosure(closure129, var_t);
  addtoclosure(closure129, var_jump);
  addtoclosure(closure129, var_s);
  addtoclosure(closure129, selfslot);
  struct UserObject *uo129 = (struct UserObject*)block128;
  uo129->data[0] = (Object)closure129;
  Method *meth_meth_stringMap__apply129 = addmethod2pos(block128, "_apply", &meth_stringMap__apply129, 0);
  int argcv_meth_stringMap__apply129[] = {0};
  meth_meth_stringMap__apply129->type = alloc_MethodType(1, argcv_meth_stringMap__apply129);
  meth_meth_stringMap__apply129->definitionModule = modulename;
  meth_meth_stringMap__apply129->definitionLine = 89;
// compiled block node returning block128 (depth = 3)
  gc_frame_newslot(block128);
// call case 5: prelude request
  params[0] = block118;
  params[1] = block128;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call171 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe117);
// compiled call node returning call171 (depth = 2)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_stringMap__apply188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe189 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe190 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call191 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe190);
// compiled call node returning call191 (depth = 7)
// compiled member node returning call191 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call192 = callmethod(call191, "at",
    1, partcv, params);
  gc_frame_end(callframe189);
// compiled call node returning call192 (depth = 5)
  *var_a = call192;
  if (call192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_right_194 = gc_frame_newslot(*var_unused);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_a (depth = 6)
  int op_slot_left_194 = gc_frame_newslot(*var_a);
  params[0] = *var_unused;
  partcv[0] = 1;
  Object opresult196 = callmethod(*var_a, "≠", 1, partcv, params);
// compiled op node returning opresult196 (depth = 5)
  Object if193 = done;
  if (istrue(opresult196)) {
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 7)
  int op_slot_right_198 = gc_frame_newslot(strlit199);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_198 = gc_frame_newslot(*var_s);
  params[0] = strlit199;
  partcv[0] = 1;
  Object opresult201 = callmethod(*var_s, "==", 1, partcv, params);
// compiled op node returning opresult201 (depth = 6)
  Object if197 = done;
  if (istrue(opresult201)) {
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit203 == NULL) {
    strlit203 = alloc_String("");
    gc_root(strlit203);
  }
// compiled string node returning strlit203 (depth = 8)
  int op_slot_right_202 = gc_frame_newslot(strlit203);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe206 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call207 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe206);
// compiled call node returning call207 (depth = 10)
// compiled member node returning call207 (depth = 9)
  int op_slot_right_205 = gc_frame_newslot(call207);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit210 == NULL) {
    strlit210 = alloc_String("::");
    gc_root(strlit210);
  }
// compiled string node returning strlit210 (depth = 10)
  int op_slot_right_209 = gc_frame_newslot(strlit210);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call214 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 12)
// compiled member node returning call214 (depth = 11)
  int op_slot_right_212 = gc_frame_newslot(call214);
// starting to compile string node (depth = 11)
  if (strlit216 == NULL) {
    strlit216 = alloc_String("");
    gc_root(strlit216);
  }
// compiled string node returning strlit216 (depth = 11)
  int op_slot_left_212 = gc_frame_newslot(strlit216);
  params[0] = call214;
  partcv[0] = 1;
  Object opresult217 = callmethod(strlit216, "++", 1, partcv, params);
// compiled op node returning opresult217 (depth = 10)
  int op_slot_left_209 = gc_frame_newslot(opresult217);
  params[0] = strlit210;
  partcv[0] = 1;
  Object opresult218 = callmethod(opresult217, "++", 1, partcv, params);
// compiled op node returning opresult218 (depth = 9)
  int op_slot_left_205 = gc_frame_newslot(opresult218);
  params[0] = call207;
  partcv[0] = 1;
  Object opresult219 = callmethod(opresult218, "++", 1, partcv, params);
// compiled op node returning opresult219 (depth = 8)
  int op_slot_left_202 = gc_frame_newslot(opresult219);
  params[0] = strlit203;
  partcv[0] = 1;
  Object opresult220 = callmethod(opresult219, "++", 1, partcv, params);
// compiled op node returning opresult220 (depth = 7)
  *var_s = opresult220;
  if (opresult220 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if197 = done;
  } else {
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit224 == NULL) {
    strlit224 = alloc_String("");
    gc_root(strlit224);
  }
// compiled string node returning strlit224 (depth = 9)
  int op_slot_right_223 = gc_frame_newslot(strlit224);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe227 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call228 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 11)
// compiled member node returning call228 (depth = 10)
  int op_slot_right_226 = gc_frame_newslot(call228);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit231 == NULL) {
    strlit231 = alloc_String("::");
    gc_root(strlit231);
  }
// compiled string node returning strlit231 (depth = 11)
  int op_slot_right_230 = gc_frame_newslot(strlit231);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_a (depth = 14)
  partcv[0] = 0;
  Object call235 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe234);
// compiled call node returning call235 (depth = 13)
// compiled member node returning call235 (depth = 12)
  int op_slot_right_233 = gc_frame_newslot(call235);
// starting to compile string node (depth = 12)
  if (strlit237 == NULL) {
    strlit237 = alloc_String(", ");
    gc_root(strlit237);
  }
// compiled string node returning strlit237 (depth = 12)
  int op_slot_left_233 = gc_frame_newslot(strlit237);
  params[0] = call235;
  partcv[0] = 1;
  Object opresult238 = callmethod(strlit237, "++", 1, partcv, params);
// compiled op node returning opresult238 (depth = 11)
  int op_slot_left_230 = gc_frame_newslot(opresult238);
  params[0] = strlit231;
  partcv[0] = 1;
  Object opresult239 = callmethod(opresult238, "++", 1, partcv, params);
// compiled op node returning opresult239 (depth = 10)
  int op_slot_left_226 = gc_frame_newslot(opresult239);
  params[0] = call228;
  partcv[0] = 1;
  Object opresult240 = callmethod(opresult239, "++", 1, partcv, params);
// compiled op node returning opresult240 (depth = 9)
  int op_slot_left_223 = gc_frame_newslot(opresult240);
  params[0] = strlit224;
  partcv[0] = 1;
  Object opresult241 = callmethod(opresult240, "++", 1, partcv, params);
// compiled op node returning opresult241 (depth = 8)
  int op_slot_right_222 = gc_frame_newslot(opresult241);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_222 = gc_frame_newslot(*var_s);
  params[0] = opresult241;
  partcv[0] = 1;
  Object opresult243 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult243 (depth = 7)
  *var_s = opresult243;
  if (opresult243 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if197 = done;
  }
// compiled if node returning if197 (depth = 5)
    gc_frame_newslot(if197);
    if193 = if197;
  } else {
  }
// compiled if node returning if193 (depth = 4)
  gc_frame_end(frame);
  return if193;
}
Object meth_stringMap_asString172(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit173 == NULL) {
    strlit173 = alloc_String("");
    gc_root(strlit173);
  }
// compiled string node returning strlit173 (depth = 3)
  *var_s = strlit173;
  if (strlit173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe174 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num177 = alloc_Float64(1);
// compiled num node returning num177 (depth = 5)
  int op_slot_right_176 = gc_frame_newslot(num177);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe179 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call181 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe180);
// compiled call node returning call181 (depth = 8)
// compiled member node returning call181 (depth = 7)
  partcv[0] = 0;
  Object call182 = callmethod(call181, "size",
    1, partcv, params);
  gc_frame_end(callframe179);
// compiled call node returning call182 (depth = 6)
// compiled member node returning call182 (depth = 5)
  int op_slot_left_176 = gc_frame_newslot(call182);
  params[0] = num177;
  partcv[0] = 1;
  Object diff183 = callmethod(call182, "-", 1, partcv, params);
// compiled op node returning diff183 (depth = 4)
  int op_slot_right_175 = gc_frame_newslot(diff183);
// starting to compile num node (depth = 4)
  Object num185 = alloc_Float64(0);
// compiled num node returning num185 (depth = 4)
  int op_slot_left_175 = gc_frame_newslot(num185);
  params[0] = diff183;
  partcv[0] = 1;
  Object opresult186 = callmethod(num185, "..", 1, partcv, params);
// compiled op node returning opresult186 (depth = 3)
  gc_frame_newslot(opresult186);
// starting to compile block node (depth = 3)
  Object block187 = alloc_Block(NULL, NULL, "stringMap", 118);
  gc_frame_newslot(block187);
// method "_apply"
  block_savedest(block187);
  Object closure188 = createclosure(3, "_apply");
  setclosureframe(closure188, stackframe);
  addtoclosure(closure188, var_unused);
  addtoclosure(closure188, var_s);
  addtoclosure(closure188, selfslot);
  struct UserObject *uo188 = (struct UserObject*)block187;
  uo188->data[0] = (Object)closure188;
  Method *meth_meth_stringMap__apply188 = addmethod2pos(block187, "_apply", &meth_stringMap__apply188, 0);
  int argcv_meth_stringMap__apply188[] = {1};
  meth_meth_stringMap__apply188->type = alloc_MethodType(1, argcv_meth_stringMap__apply188);
  meth_meth_stringMap__apply188->definitionModule = modulename;
  meth_meth_stringMap__apply188->definitionLine = 118;
// compiled block node returning block187 (depth = 3)
  gc_frame_newslot(block187);
// call case 5: prelude request
  params[0] = opresult186;
  params[1] = block187;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call246 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe174);
// compiled call node returning call246 (depth = 2)
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit248 == NULL) {
    strlit248 = alloc_String("]");
    gc_root(strlit248);
  }
// compiled string node returning strlit248 (depth = 3)
  int op_slot_right_247 = gc_frame_newslot(strlit248);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_250 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 4)
  if (strlit252 == NULL) {
    strlit252 = alloc_String("map.new[");
    gc_root(strlit252);
  }
// compiled string node returning strlit252 (depth = 4)
  int op_slot_left_250 = gc_frame_newslot(strlit252);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult253 = callmethod(strlit252, "++", 1, partcv, params);
// compiled op node returning opresult253 (depth = 3)
  int op_slot_left_247 = gc_frame_newslot(opresult253);
  params[0] = strlit248;
  partcv[0] = 1;
  Object opresult254 = callmethod(opresult253, "++", 1, partcv, params);
// compiled op node returning opresult254 (depth = 2)
  gc_frame_end(frame);
  return opresult254;
}
Object meth_stringMap_asDebugString255(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call257 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe256);
// compiled call node returning call257 (depth = 3)
// compiled member node returning call257 (depth = 2)
  gc_frame_end(frame);
  return call257;
}
Object meth_stringMap__apply263(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_count = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe265 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call266 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe265);
// compiled call node returning call266 (depth = 6)
// compiled member node returning call266 (depth = 5)
  int op_slot_right_264 = gc_frame_newslot(call266);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_count (depth = 5)
  int op_slot_left_264 = gc_frame_newslot(*var_count);
  params[0] = call266;
  partcv[0] = 1;
  Object opresult268 = callmethod(*var_count, "≤", 1, partcv, params);
// compiled op node returning opresult268 (depth = 4)
  gc_frame_end(frame);
  return opresult268;
}
Object meth_stringMap__apply274(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe276 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call278 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe277);
// compiled call node returning call278 (depth = 9)
// compiled member node returning call278 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call279 = callmethod(call278, "at",
    1, partcv, params);
  gc_frame_end(callframe276);
// compiled call node returning call279 (depth = 7)
  int op_slot_right_275 = gc_frame_newslot(call279);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_275 = gc_frame_newslot(*var_unused);
  params[0] = call279;
  partcv[0] = 1;
  Object opresult281 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult281 (depth = 6)
  gc_frame_end(frame);
  return opresult281;
}
Object meth_stringMap__apply284(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num286 = alloc_Float64(1);
// compiled num node returning num286 (depth = 8)
  int op_slot_right_285 = gc_frame_newslot(num286);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  int op_slot_left_285 = gc_frame_newslot(*var_idx);
  params[0] = num286;
  partcv[0] = 1;
  Object sum288 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum288 (depth = 7)
  *var_idx = sum288;
  if (sum288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap__apply271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_action = getfromclosure(closure, 2);
  Object *var_count = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "a");
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe272 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block273 = alloc_Block(NULL, NULL, "stringMap", 146);
  gc_frame_newslot(block273);
// method "_apply"
  block_savedest(block273);
  Object closure274 = createclosure(3, "_apply");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_idx);
  addtoclosure(closure274, var_unused);
  addtoclosure(closure274, selfslot);
  struct UserObject *uo274 = (struct UserObject*)block273;
  uo274->data[0] = (Object)closure274;
  Method *meth_meth_stringMap__apply274 = addmethod2pos(block273, "_apply", &meth_stringMap__apply274, 0);
  int argcv_meth_stringMap__apply274[] = {0};
  meth_meth_stringMap__apply274->type = alloc_MethodType(1, argcv_meth_stringMap__apply274);
  meth_meth_stringMap__apply274->definitionModule = modulename;
  meth_meth_stringMap__apply274->definitionLine = 145;
// compiled block node returning block273 (depth = 5)
  gc_frame_newslot(block273);
// starting to compile block node (depth = 5)
  Object block283 = alloc_Block(NULL, NULL, "stringMap", 146);
  gc_frame_newslot(block283);
// method "_apply"
  block_savedest(block283);
  Object closure284 = createclosure(2, "_apply");
  setclosureframe(closure284, stackframe);
  addtoclosure(closure284, var_idx);
  addtoclosure(closure284, selfslot);
  struct UserObject *uo284 = (struct UserObject*)block283;
  uo284->data[0] = (Object)closure284;
  Method *meth_meth_stringMap__apply284 = addmethod2pos(block283, "_apply", &meth_stringMap__apply284, 0);
  int argcv_meth_stringMap__apply284[] = {0};
  meth_meth_stringMap__apply284->type = alloc_MethodType(1, argcv_meth_stringMap__apply284);
  meth_meth_stringMap__apply284->definitionModule = modulename;
  meth_meth_stringMap__apply284->definitionLine = 146;
// compiled block node returning block283 (depth = 5)
  gc_frame_newslot(block283);
// call case 5: prelude request
  params[0] = block273;
  params[1] = block283;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call291 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe272);
// compiled call node returning call291 (depth = 4)
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe292 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe293 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call294 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe293);
// compiled call node returning call294 (depth = 7)
// compiled member node returning call294 (depth = 6)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call295 = callmethod(call294, "at",
    1, partcv, params);
  gc_frame_end(callframe292);
// compiled call node returning call295 (depth = 5)
  *var_a = call295;
  if (call295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe296 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe297 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call298 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe297);
// compiled call node returning call298 (depth = 6)
// compiled member node returning call298 (depth = 5)
  gc_frame_newslot(call298);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  partcv[0] = 0;
  Object call300 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 6)
// compiled member node returning call300 (depth = 5)
  gc_frame_newslot(call300);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call298;
  params[1] = call300;
  partcv[0] = 2;
  Object call301 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe296);
// compiled call node returning call301 (depth = 4)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num303 = alloc_Float64(1);
// compiled num node returning num303 (depth = 6)
  int op_slot_right_302 = gc_frame_newslot(num303);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_302 = gc_frame_newslot(*var_count);
  params[0] = num303;
  partcv[0] = 1;
  Object sum305 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum305 (depth = 5)
  *var_count = sum305;
  if (sum305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num308 = alloc_Float64(1);
// compiled num node returning num308 (depth = 6)
  int op_slot_right_307 = gc_frame_newslot(num308);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  int op_slot_left_307 = gc_frame_newslot(*var_idx);
  params[0] = num308;
  partcv[0] = 1;
  Object sum310 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum310 (depth = 5)
  *var_idx = sum310;
  if (sum310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap_keysAndValuesDo258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_count = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "count");
  Object *var_idx = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "idx");
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num259 = alloc_Float64(1);
// compiled num node returning num259 (depth = 3)
  *var_count = num259;
  if (num259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num260 = alloc_Float64(0);
// compiled num node returning num260 (depth = 3)
  *var_idx = num260;
  if (num260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe261 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block262 = alloc_Block(NULL, NULL, "stringMap", 145);
  gc_frame_newslot(block262);
// method "_apply"
  block_savedest(block262);
  Object closure263 = createclosure(2, "_apply");
  setclosureframe(closure263, stackframe);
  addtoclosure(closure263, var_count);
  addtoclosure(closure263, selfslot);
  struct UserObject *uo263 = (struct UserObject*)block262;
  uo263->data[0] = (Object)closure263;
  Method *meth_meth_stringMap__apply263 = addmethod2pos(block262, "_apply", &meth_stringMap__apply263, 0);
  int argcv_meth_stringMap__apply263[] = {0};
  meth_meth_stringMap__apply263->type = alloc_MethodType(1, argcv_meth_stringMap__apply263);
  meth_meth_stringMap__apply263->definitionModule = modulename;
  meth_meth_stringMap__apply263->definitionLine = 131;
// compiled block node returning block262 (depth = 3)
  gc_frame_newslot(block262);
// starting to compile block node (depth = 3)
  Object block270 = alloc_Block(NULL, NULL, "stringMap", 145);
  gc_frame_newslot(block270);
// method "_apply"
  block_savedest(block270);
  Object closure271 = createclosure(5, "_apply");
  setclosureframe(closure271, stackframe);
  addtoclosure(closure271, var_idx);
  addtoclosure(closure271, var_unused);
  addtoclosure(closure271, var_action);
  addtoclosure(closure271, var_count);
  addtoclosure(closure271, selfslot);
  struct UserObject *uo271 = (struct UserObject*)block270;
  uo271->data[0] = (Object)closure271;
  Method *meth_meth_stringMap__apply271 = addmethod2pos(block270, "_apply", &meth_stringMap__apply271, 0);
  int argcv_meth_stringMap__apply271[] = {0};
  meth_meth_stringMap__apply271->type = alloc_MethodType(1, argcv_meth_stringMap__apply271);
  meth_meth_stringMap__apply271->definitionModule = modulename;
  meth_meth_stringMap__apply271->definitionLine = 145;
// compiled block node returning block270 (depth = 3)
  gc_frame_newslot(block270);
// call case 5: prelude request
  params[0] = block262;
  params[1] = block270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call313 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe261);
// compiled call node returning call313 (depth = 2)
  gc_frame_end(frame);
  return call313;
}
Object meth_stringMap__apply319(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_count = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call322 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe321);
// compiled call node returning call322 (depth = 6)
// compiled member node returning call322 (depth = 5)
  int op_slot_right_320 = gc_frame_newslot(call322);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_count (depth = 5)
  int op_slot_left_320 = gc_frame_newslot(*var_count);
  params[0] = call322;
  partcv[0] = 1;
  Object opresult324 = callmethod(*var_count, "≤", 1, partcv, params);
// compiled op node returning opresult324 (depth = 4)
  gc_frame_end(frame);
  return opresult324;
}
Object meth_stringMap__apply330(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe332 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call334 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe333);
// compiled call node returning call334 (depth = 9)
// compiled member node returning call334 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call335 = callmethod(call334, "at",
    1, partcv, params);
  gc_frame_end(callframe332);
// compiled call node returning call335 (depth = 7)
  int op_slot_right_331 = gc_frame_newslot(call335);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_331 = gc_frame_newslot(*var_unused);
  params[0] = call335;
  partcv[0] = 1;
  Object opresult337 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult337 (depth = 6)
  gc_frame_end(frame);
  return opresult337;
}
Object meth_stringMap__apply340(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num342 = alloc_Float64(1);
// compiled num node returning num342 (depth = 8)
  int op_slot_right_341 = gc_frame_newslot(num342);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  int op_slot_left_341 = gc_frame_newslot(*var_idx);
  params[0] = num342;
  partcv[0] = 1;
  Object sum344 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum344 (depth = 7)
  *var_idx = sum344;
  if (sum344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap__apply327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_action = getfromclosure(closure, 2);
  Object *var_count = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe328 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block329 = alloc_Block(NULL, NULL, "stringMap", 168);
  gc_frame_newslot(block329);
// method "_apply"
  block_savedest(block329);
  Object closure330 = createclosure(3, "_apply");
  setclosureframe(closure330, stackframe);
  addtoclosure(closure330, var_idx);
  addtoclosure(closure330, var_unused);
  addtoclosure(closure330, selfslot);
  struct UserObject *uo330 = (struct UserObject*)block329;
  uo330->data[0] = (Object)closure330;
  Method *meth_meth_stringMap__apply330 = addmethod2pos(block329, "_apply", &meth_stringMap__apply330, 0);
  int argcv_meth_stringMap__apply330[] = {0};
  meth_meth_stringMap__apply330->type = alloc_MethodType(1, argcv_meth_stringMap__apply330);
  meth_meth_stringMap__apply330->definitionModule = modulename;
  meth_meth_stringMap__apply330->definitionLine = 167;
// compiled block node returning block329 (depth = 5)
  gc_frame_newslot(block329);
// starting to compile block node (depth = 5)
  Object block339 = alloc_Block(NULL, NULL, "stringMap", 168);
  gc_frame_newslot(block339);
// method "_apply"
  block_savedest(block339);
  Object closure340 = createclosure(2, "_apply");
  setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_idx);
  addtoclosure(closure340, selfslot);
  struct UserObject *uo340 = (struct UserObject*)block339;
  uo340->data[0] = (Object)closure340;
  Method *meth_meth_stringMap__apply340 = addmethod2pos(block339, "_apply", &meth_stringMap__apply340, 0);
  int argcv_meth_stringMap__apply340[] = {0};
  meth_meth_stringMap__apply340->type = alloc_MethodType(1, argcv_meth_stringMap__apply340);
  meth_meth_stringMap__apply340->definitionModule = modulename;
  meth_meth_stringMap__apply340->definitionLine = 168;
// compiled block node returning block339 (depth = 5)
  gc_frame_newslot(block339);
// call case 5: prelude request
  params[0] = block329;
  params[1] = block339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call347 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe328);
// compiled call node returning call347 (depth = 4)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe348 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe349 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe350 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call352 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe351);
// compiled call node returning call352 (depth = 9)
// compiled member node returning call352 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call353 = callmethod(call352, "at",
    1, partcv, params);
  gc_frame_end(callframe350);
// compiled call node returning call353 (depth = 7)
  partcv[0] = 0;
  Object call354 = callmethod(call353, "value",
    1, partcv, params);
  gc_frame_end(callframe349);
// compiled call node returning call354 (depth = 6)
// compiled member node returning call354 (depth = 5)
  gc_frame_newslot(call354);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call354;
  partcv[0] = 1;
  Object call355 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe348);
// compiled call node returning call355 (depth = 4)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num357 = alloc_Float64(1);
// compiled num node returning num357 (depth = 6)
  int op_slot_right_356 = gc_frame_newslot(num357);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_356 = gc_frame_newslot(*var_count);
  params[0] = num357;
  partcv[0] = 1;
  Object sum359 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum359 (depth = 5)
  *var_count = sum359;
  if (sum359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num362 = alloc_Float64(1);
// compiled num node returning num362 (depth = 6)
  int op_slot_right_361 = gc_frame_newslot(num362);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  int op_slot_left_361 = gc_frame_newslot(*var_idx);
  params[0] = num362;
  partcv[0] = 1;
  Object sum364 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum364 (depth = 5)
  *var_idx = sum364;
  if (sum364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap_do314(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_count = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "count");
  Object *var_idx = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "idx");
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num315 = alloc_Float64(1);
// compiled num node returning num315 (depth = 3)
  *var_count = num315;
  if (num315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num316 = alloc_Float64(0);
// compiled num node returning num316 (depth = 3)
  *var_idx = num316;
  if (num316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe317 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block318 = alloc_Block(NULL, NULL, "stringMap", 167);
  gc_frame_newslot(block318);
// method "_apply"
  block_savedest(block318);
  Object closure319 = createclosure(2, "_apply");
  setclosureframe(closure319, stackframe);
  addtoclosure(closure319, var_count);
  addtoclosure(closure319, selfslot);
  struct UserObject *uo319 = (struct UserObject*)block318;
  uo319->data[0] = (Object)closure319;
  Method *meth_meth_stringMap__apply319 = addmethod2pos(block318, "_apply", &meth_stringMap__apply319, 0);
  int argcv_meth_stringMap__apply319[] = {0};
  meth_meth_stringMap__apply319->type = alloc_MethodType(1, argcv_meth_stringMap__apply319);
  meth_meth_stringMap__apply319->definitionModule = modulename;
  meth_meth_stringMap__apply319->definitionLine = 150;
// compiled block node returning block318 (depth = 3)
  gc_frame_newslot(block318);
// starting to compile block node (depth = 3)
  Object block326 = alloc_Block(NULL, NULL, "stringMap", 167);
  gc_frame_newslot(block326);
// method "_apply"
  block_savedest(block326);
  Object closure327 = createclosure(5, "_apply");
  setclosureframe(closure327, stackframe);
  addtoclosure(closure327, var_idx);
  addtoclosure(closure327, var_unused);
  addtoclosure(closure327, var_action);
  addtoclosure(closure327, var_count);
  addtoclosure(closure327, selfslot);
  struct UserObject *uo327 = (struct UserObject*)block326;
  uo327->data[0] = (Object)closure327;
  Method *meth_meth_stringMap__apply327 = addmethod2pos(block326, "_apply", &meth_stringMap__apply327, 0);
  int argcv_meth_stringMap__apply327[] = {0};
  meth_meth_stringMap__apply327->type = alloc_MethodType(1, argcv_meth_stringMap__apply327);
  meth_meth_stringMap__apply327->definitionModule = modulename;
  meth_meth_stringMap__apply327->definitionLine = 167;
// compiled block node returning block326 (depth = 3)
  gc_frame_newslot(block326);
// call case 5: prelude request
  params[0] = block318;
  params[1] = block326;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call367 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe317);
// compiled call node returning call367 (depth = 2)
  gc_frame_end(frame);
  return call367;
}
Object meth_stringMap__apply373(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_count = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call376 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe375);
// compiled call node returning call376 (depth = 6)
// compiled member node returning call376 (depth = 5)
  int op_slot_right_374 = gc_frame_newslot(call376);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_count (depth = 5)
  int op_slot_left_374 = gc_frame_newslot(*var_count);
  params[0] = call376;
  partcv[0] = 1;
  Object opresult378 = callmethod(*var_count, "≤", 1, partcv, params);
// compiled op node returning opresult378 (depth = 4)
  gc_frame_end(frame);
  return opresult378;
}
Object meth_stringMap__apply384(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe386 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call388 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe387);
// compiled call node returning call388 (depth = 9)
// compiled member node returning call388 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call389 = callmethod(call388, "at",
    1, partcv, params);
  gc_frame_end(callframe386);
// compiled call node returning call389 (depth = 7)
  int op_slot_right_385 = gc_frame_newslot(call389);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_385 = gc_frame_newslot(*var_unused);
  params[0] = call389;
  partcv[0] = 1;
  Object opresult391 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult391 (depth = 6)
  gc_frame_end(frame);
  return opresult391;
}
Object meth_stringMap__apply394(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num396 = alloc_Float64(1);
// compiled num node returning num396 (depth = 8)
  int op_slot_right_395 = gc_frame_newslot(num396);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  int op_slot_left_395 = gc_frame_newslot(*var_idx);
  params[0] = num396;
  partcv[0] = 1;
  Object sum398 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum398 (depth = 7)
  *var_idx = sum398;
  if (sum398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap__apply381(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_action = getfromclosure(closure, 2);
  Object *var_count = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe382 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block383 = alloc_Block(NULL, NULL, "stringMap", 189);
  gc_frame_newslot(block383);
// method "_apply"
  block_savedest(block383);
  Object closure384 = createclosure(3, "_apply");
  setclosureframe(closure384, stackframe);
  addtoclosure(closure384, var_idx);
  addtoclosure(closure384, var_unused);
  addtoclosure(closure384, selfslot);
  struct UserObject *uo384 = (struct UserObject*)block383;
  uo384->data[0] = (Object)closure384;
  Method *meth_meth_stringMap__apply384 = addmethod2pos(block383, "_apply", &meth_stringMap__apply384, 0);
  int argcv_meth_stringMap__apply384[] = {0};
  meth_meth_stringMap__apply384->type = alloc_MethodType(1, argcv_meth_stringMap__apply384);
  meth_meth_stringMap__apply384->definitionModule = modulename;
  meth_meth_stringMap__apply384->definitionLine = 188;
// compiled block node returning block383 (depth = 5)
  gc_frame_newslot(block383);
// starting to compile block node (depth = 5)
  Object block393 = alloc_Block(NULL, NULL, "stringMap", 189);
  gc_frame_newslot(block393);
// method "_apply"
  block_savedest(block393);
  Object closure394 = createclosure(2, "_apply");
  setclosureframe(closure394, stackframe);
  addtoclosure(closure394, var_idx);
  addtoclosure(closure394, selfslot);
  struct UserObject *uo394 = (struct UserObject*)block393;
  uo394->data[0] = (Object)closure394;
  Method *meth_meth_stringMap__apply394 = addmethod2pos(block393, "_apply", &meth_stringMap__apply394, 0);
  int argcv_meth_stringMap__apply394[] = {0};
  meth_meth_stringMap__apply394->type = alloc_MethodType(1, argcv_meth_stringMap__apply394);
  meth_meth_stringMap__apply394->definitionModule = modulename;
  meth_meth_stringMap__apply394->definitionLine = 189;
// compiled block node returning block393 (depth = 5)
  gc_frame_newslot(block393);
// call case 5: prelude request
  params[0] = block383;
  params[1] = block393;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call401 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe382);
// compiled call node returning call401 (depth = 4)
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe402 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe403 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe404 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe405 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call406 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe405);
// compiled call node returning call406 (depth = 9)
// compiled member node returning call406 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call407 = callmethod(call406, "at",
    1, partcv, params);
  gc_frame_end(callframe404);
// compiled call node returning call407 (depth = 7)
  partcv[0] = 0;
  Object call408 = callmethod(call407, "key",
    1, partcv, params);
  gc_frame_end(callframe403);
// compiled call node returning call408 (depth = 6)
// compiled member node returning call408 (depth = 5)
  gc_frame_newslot(call408);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  params[0] = call408;
  partcv[0] = 1;
  Object call409 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe402);
// compiled call node returning call409 (depth = 4)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num411 = alloc_Float64(1);
// compiled num node returning num411 (depth = 6)
  int op_slot_right_410 = gc_frame_newslot(num411);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_410 = gc_frame_newslot(*var_count);
  params[0] = num411;
  partcv[0] = 1;
  Object sum413 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum413 (depth = 5)
  *var_count = sum413;
  if (sum413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num416 = alloc_Float64(1);
// compiled num node returning num416 (depth = 6)
  int op_slot_right_415 = gc_frame_newslot(num416);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  int op_slot_left_415 = gc_frame_newslot(*var_idx);
  params[0] = num416;
  partcv[0] = 1;
  Object sum418 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum418 (depth = 5)
  *var_idx = sum418;
  if (sum418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap_keysDo368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysDo");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_count = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "count");
  Object *var_idx = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "idx");
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num369 = alloc_Float64(1);
// compiled num node returning num369 (depth = 3)
  *var_count = num369;
  if (num369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num370 = alloc_Float64(0);
// compiled num node returning num370 (depth = 3)
  *var_idx = num370;
  if (num370 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe371 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block372 = alloc_Block(NULL, NULL, "stringMap", 188);
  gc_frame_newslot(block372);
// method "_apply"
  block_savedest(block372);
  Object closure373 = createclosure(2, "_apply");
  setclosureframe(closure373, stackframe);
  addtoclosure(closure373, var_count);
  addtoclosure(closure373, selfslot);
  struct UserObject *uo373 = (struct UserObject*)block372;
  uo373->data[0] = (Object)closure373;
  Method *meth_meth_stringMap__apply373 = addmethod2pos(block372, "_apply", &meth_stringMap__apply373, 0);
  int argcv_meth_stringMap__apply373[] = {0};
  meth_meth_stringMap__apply373->type = alloc_MethodType(1, argcv_meth_stringMap__apply373);
  meth_meth_stringMap__apply373->definitionModule = modulename;
  meth_meth_stringMap__apply373->definitionLine = 171;
// compiled block node returning block372 (depth = 3)
  gc_frame_newslot(block372);
// starting to compile block node (depth = 3)
  Object block380 = alloc_Block(NULL, NULL, "stringMap", 188);
  gc_frame_newslot(block380);
// method "_apply"
  block_savedest(block380);
  Object closure381 = createclosure(5, "_apply");
  setclosureframe(closure381, stackframe);
  addtoclosure(closure381, var_idx);
  addtoclosure(closure381, var_unused);
  addtoclosure(closure381, var_action);
  addtoclosure(closure381, var_count);
  addtoclosure(closure381, selfslot);
  struct UserObject *uo381 = (struct UserObject*)block380;
  uo381->data[0] = (Object)closure381;
  Method *meth_meth_stringMap__apply381 = addmethod2pos(block380, "_apply", &meth_stringMap__apply381, 0);
  int argcv_meth_stringMap__apply381[] = {0};
  meth_meth_stringMap__apply381->type = alloc_MethodType(1, argcv_meth_stringMap__apply381);
  meth_meth_stringMap__apply381->definitionModule = modulename;
  meth_meth_stringMap__apply381->definitionLine = 188;
// compiled block node returning block380 (depth = 3)
  gc_frame_newslot(block380);
// call case 5: prelude request
  params[0] = block372;
  params[1] = block380;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call421 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe371);
// compiled call node returning call421 (depth = 2)
  gc_frame_end(frame);
  return call421;
}
Object meth_stringMap_valuesDo422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "valuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method valuesDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for valuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe423 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  gc_frame_newslot(*var_action);
// call case 4: self request
  params[0] = *var_action;
  partcv[0] = 1;
  Object call424 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe423);
// compiled call node returning call424 (depth = 2)
  gc_frame_end(frame);
  return call424;
}
Object meth_stringMap__apply456(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe457 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe458 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call459 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe458);
// compiled call node returning call459 (depth = 6)
// compiled member node returning call459 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call460 = callmethod(call459, "at()put",
    2, partcv, params);
  gc_frame_end(callframe457);
// compiled call node returning call460 (depth = 4)
  gc_frame_end(frame);
  return call460;
}
Object meth_stringMap__apply478(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe479 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call480 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe479);
// compiled call node returning call480 (depth = 5)
  *var_a = call480;
  if (call480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_right_482 = gc_frame_newslot(*var_unused);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_a (depth = 6)
  int op_slot_left_482 = gc_frame_newslot(*var_a);
  params[0] = *var_unused;
  partcv[0] = 1;
  Object opresult484 = callmethod(*var_a, "≠", 1, partcv, params);
// compiled op node returning opresult484 (depth = 5)
  Object if481 = done;
  if (istrue(opresult484)) {
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe485 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call487 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe486);
// compiled call node returning call487 (depth = 7)
// compiled member node returning call487 (depth = 6)
  gc_frame_newslot(call487);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call489 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe488);
// compiled call node returning call489 (depth = 7)
// compiled member node returning call489 (depth = 6)
  gc_frame_newslot(call489);
// call case 4: self request
  params[0] = call487;
  params[1] = call489;
  partcv[0] = 2;
  Object call490 = callmethodflags(self, "put", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe485);
// compiled call node returning call490 (depth = 5)
    gc_frame_newslot(call490);
    if481 = call490;
  } else {
  }
// compiled if node returning if481 (depth = 4)
  gc_frame_end(frame);
  return if481;
}
Object meth_stringMap_expand425(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expand (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for expand");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe426 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call428 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe427);
// compiled call node returning call428 (depth = 6)
// compiled member node returning call428 (depth = 5)
  partcv[0] = 0;
  Object call429 = callmethod(call428, "size",
    1, partcv, params);
  gc_frame_end(callframe426);
// compiled call node returning call429 (depth = 4)
// compiled member node returning call429 (depth = 3)
  *var_c = call429;
  if (call429 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num431 = alloc_Float64(2);
// compiled num node returning num431 (depth = 4)
  int op_slot_right_430 = gc_frame_newslot(num431);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_430 = gc_frame_newslot(*var_c);
  params[0] = num431;
  partcv[0] = 1;
  Object prod433 = callmethod(*var_c, "*", 1, partcv, params);
// compiled op node returning prod433 (depth = 3)
  *var_n = prod433;
  if (prod433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe434 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call435 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe434);
// compiled call node returning call435 (depth = 4)
// compiled member node returning call435 (depth = 3)
  *var_oldInner = call435;
  if (call435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe436 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe437 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe438 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call439 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe438);
// compiled call node returning call439 (depth = 5)
// compiled member node returning call439 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call440 = callmethod(call439, "new",
    1, partcv, params);
  gc_frame_end(callframe437);
// compiled call node returning call440 (depth = 3)
  gc_frame_newslot(call440);
// call case 4: self request
  params[0] = call440;
  partcv[0] = 1;
  Object call441 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe436);
// compiled call node returning call441 (depth = 2)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe442 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num445 = alloc_Float64(1);
// compiled num node returning num445 (depth = 5)
  int op_slot_right_444 = gc_frame_newslot(num445);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe447 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe448 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call449 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe448);
// compiled call node returning call449 (depth = 8)
// compiled member node returning call449 (depth = 7)
  partcv[0] = 0;
  Object call450 = callmethod(call449, "size",
    1, partcv, params);
  gc_frame_end(callframe447);
// compiled call node returning call450 (depth = 6)
// compiled member node returning call450 (depth = 5)
  int op_slot_left_444 = gc_frame_newslot(call450);
  params[0] = num445;
  partcv[0] = 1;
  Object diff451 = callmethod(call450, "-", 1, partcv, params);
// compiled op node returning diff451 (depth = 4)
  int op_slot_right_443 = gc_frame_newslot(diff451);
// starting to compile num node (depth = 4)
  Object num453 = alloc_Float64(0);
// compiled num node returning num453 (depth = 4)
  int op_slot_left_443 = gc_frame_newslot(num453);
  params[0] = diff451;
  partcv[0] = 1;
  Object opresult454 = callmethod(num453, "..", 1, partcv, params);
// compiled op node returning opresult454 (depth = 3)
  gc_frame_newslot(opresult454);
// starting to compile block node (depth = 3)
  Object block455 = alloc_Block(NULL, NULL, "stringMap", 205);
  gc_frame_newslot(block455);
// method "_apply"
  block_savedest(block455);
  Object closure456 = createclosure(2, "_apply");
  setclosureframe(closure456, stackframe);
  addtoclosure(closure456, var_unused);
  addtoclosure(closure456, selfslot);
  struct UserObject *uo456 = (struct UserObject*)block455;
  uo456->data[0] = (Object)closure456;
  Method *meth_meth_stringMap__apply456 = addmethod2pos(block455, "_apply", &meth_stringMap__apply456, 0);
  int argcv_meth_stringMap__apply456[] = {1};
  meth_meth_stringMap__apply456->type = alloc_MethodType(1, argcv_meth_stringMap__apply456);
  meth_meth_stringMap__apply456->definitionModule = modulename;
  meth_meth_stringMap__apply456->definitionLine = 205;
// compiled block node returning block455 (depth = 3)
  gc_frame_newslot(block455);
// call case 5: prelude request
  params[0] = opresult454;
  params[1] = block455;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call462 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe442);
// compiled call node returning call462 (depth = 2)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe463 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num464 = alloc_Float64(0);
// compiled num node returning num464 (depth = 3)
  gc_frame_newslot(num464);
// call case 4: self request
  params[0] = num464;
  partcv[0] = 1;
  Object call465 = callmethodflags(self, "elems:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe463);
// compiled call node returning call465 (depth = 2)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe466 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num469 = alloc_Float64(1);
// compiled num node returning num469 (depth = 5)
  int op_slot_right_468 = gc_frame_newslot(num469);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  partcv[0] = 0;
  Object call472 = callmethod(*var_oldInner, "size",
    1, partcv, params);
  gc_frame_end(callframe471);
// compiled call node returning call472 (depth = 6)
// compiled member node returning call472 (depth = 5)
  int op_slot_left_468 = gc_frame_newslot(call472);
  params[0] = num469;
  partcv[0] = 1;
  Object diff473 = callmethod(call472, "-", 1, partcv, params);
// compiled op node returning diff473 (depth = 4)
  int op_slot_right_467 = gc_frame_newslot(diff473);
// starting to compile num node (depth = 4)
  Object num475 = alloc_Float64(0);
// compiled num node returning num475 (depth = 4)
  int op_slot_left_467 = gc_frame_newslot(num475);
  params[0] = diff473;
  partcv[0] = 1;
  Object opresult476 = callmethod(num475, "..", 1, partcv, params);
// compiled op node returning opresult476 (depth = 3)
  gc_frame_newslot(opresult476);
// starting to compile block node (depth = 3)
  Object block477 = alloc_Block(NULL, NULL, "stringMap", 209);
  gc_frame_newslot(block477);
// method "_apply"
  block_savedest(block477);
  Object closure478 = createclosure(3, "_apply");
  setclosureframe(closure478, stackframe);
  addtoclosure(closure478, var_oldInner);
  addtoclosure(closure478, var_unused);
  addtoclosure(closure478, selfslot);
  struct UserObject *uo478 = (struct UserObject*)block477;
  uo478->data[0] = (Object)closure478;
  Method *meth_meth_stringMap__apply478 = addmethod2pos(block477, "_apply", &meth_stringMap__apply478, 0);
  int argcv_meth_stringMap__apply478[] = {1};
  meth_meth_stringMap__apply478->type = alloc_MethodType(1, argcv_meth_stringMap__apply478);
  meth_meth_stringMap__apply478->definitionModule = modulename;
  meth_meth_stringMap__apply478->definitionLine = 209;
// compiled block node returning block477 (depth = 3)
  gc_frame_newslot(block477);
// call case 5: prelude request
  params[0] = opresult476;
  params[1] = block477;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call492 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe466);
// compiled call node returning call492 (depth = 2)
  gc_frame_end(frame);
  return call492;
}
Object meth_stringMap__apply500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_count = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call503 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe502);
// compiled call node returning call503 (depth = 6)
// compiled member node returning call503 (depth = 5)
  int op_slot_right_501 = gc_frame_newslot(call503);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_count (depth = 5)
  int op_slot_left_501 = gc_frame_newslot(*var_count);
  params[0] = call503;
  partcv[0] = 1;
  Object opresult505 = callmethod(*var_count, "≤", 1, partcv, params);
// compiled op node returning opresult505 (depth = 4)
  gc_frame_end(frame);
  return opresult505;
}
Object meth_stringMap__apply511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe513 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe514 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call515 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe514);
// compiled call node returning call515 (depth = 9)
// compiled member node returning call515 (depth = 8)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call516 = callmethod(call515, "at",
    1, partcv, params);
  gc_frame_end(callframe513);
// compiled call node returning call516 (depth = 7)
  int op_slot_right_512 = gc_frame_newslot(call516);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_512 = gc_frame_newslot(*var_unused);
  params[0] = call516;
  partcv[0] = 1;
  Object opresult518 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult518 (depth = 6)
  gc_frame_end(frame);
  return opresult518;
}
Object meth_stringMap__apply521(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_idx = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num523 = alloc_Float64(1);
// compiled num node returning num523 (depth = 8)
  int op_slot_right_522 = gc_frame_newslot(num523);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_idx (depth = 8)
  int op_slot_left_522 = gc_frame_newslot(*var_idx);
  params[0] = num523;
  partcv[0] = 1;
  Object sum525 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum525 (depth = 7)
  *var_idx = sum525;
  if (sum525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap__apply508(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_idx = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_result = getfromclosure(closure, 2);
  Object *var_count = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe509 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block510 = alloc_Block(NULL, NULL, "stringMap", 233);
  gc_frame_newslot(block510);
// method "_apply"
  block_savedest(block510);
  Object closure511 = createclosure(3, "_apply");
  setclosureframe(closure511, stackframe);
  addtoclosure(closure511, var_idx);
  addtoclosure(closure511, var_unused);
  addtoclosure(closure511, selfslot);
  struct UserObject *uo511 = (struct UserObject*)block510;
  uo511->data[0] = (Object)closure511;
  Method *meth_meth_stringMap__apply511 = addmethod2pos(block510, "_apply", &meth_stringMap__apply511, 0);
  int argcv_meth_stringMap__apply511[] = {0};
  meth_meth_stringMap__apply511->type = alloc_MethodType(1, argcv_meth_stringMap__apply511);
  meth_meth_stringMap__apply511->definitionModule = modulename;
  meth_meth_stringMap__apply511->definitionLine = 232;
// compiled block node returning block510 (depth = 5)
  gc_frame_newslot(block510);
// starting to compile block node (depth = 5)
  Object block520 = alloc_Block(NULL, NULL, "stringMap", 233);
  gc_frame_newslot(block520);
// method "_apply"
  block_savedest(block520);
  Object closure521 = createclosure(2, "_apply");
  setclosureframe(closure521, stackframe);
  addtoclosure(closure521, var_idx);
  addtoclosure(closure521, selfslot);
  struct UserObject *uo521 = (struct UserObject*)block520;
  uo521->data[0] = (Object)closure521;
  Method *meth_meth_stringMap__apply521 = addmethod2pos(block520, "_apply", &meth_stringMap__apply521, 0);
  int argcv_meth_stringMap__apply521[] = {0};
  meth_meth_stringMap__apply521->type = alloc_MethodType(1, argcv_meth_stringMap__apply521);
  meth_meth_stringMap__apply521->definitionModule = modulename;
  meth_meth_stringMap__apply521->definitionLine = 233;
// compiled block node returning block520 (depth = 5)
  gc_frame_newslot(block520);
// call case 5: prelude request
  params[0] = block510;
  params[1] = block520;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call528 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compiled call node returning call528 (depth = 4)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe529 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe530 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  gc_frame_newslot(*var_idx);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call532 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe531);
// compiled call node returning call532 (depth = 7)
// compiled member node returning call532 (depth = 6)
  params[0] = *var_idx;
  partcv[0] = 1;
  Object call533 = callmethod(call532, "at",
    1, partcv, params);
  gc_frame_end(callframe530);
// compiled call node returning call533 (depth = 5)
  gc_frame_newslot(call533);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = call533;
  partcv[0] = 1;
  Object call534 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe529);
// compiled call node returning call534 (depth = 4)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num536 = alloc_Float64(1);
// compiled num node returning num536 (depth = 6)
  int op_slot_right_535 = gc_frame_newslot(num536);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_count (depth = 6)
  int op_slot_left_535 = gc_frame_newslot(*var_count);
  params[0] = num536;
  partcv[0] = 1;
  Object sum538 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum538 (depth = 5)
  *var_count = sum538;
  if (sum538 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num541 = alloc_Float64(1);
// compiled num node returning num541 (depth = 6)
  int op_slot_right_540 = gc_frame_newslot(num541);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_idx (depth = 6)
  int op_slot_left_540 = gc_frame_newslot(*var_idx);
  params[0] = num541;
  partcv[0] = 1;
  Object sum543 = callmethod(*var_idx, "+", 1, partcv, params);
// compiled op node returning sum543 (depth = 5)
  *var_idx = sum543;
  if (sum543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_stringMap_asList493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asList (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asList");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
  Object *var_count = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "count");
  Object *var_idx = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "idx");
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe494 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call495 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe494);
// compiled call node returning call495 (depth = 4)
// compiled member node returning call495 (depth = 3)
  *var_result = call495;
  if (call495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num496 = alloc_Float64(1);
// compiled num node returning num496 (depth = 3)
  *var_count = num496;
  if (num496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num497 = alloc_Float64(0);
// compiled num node returning num497 (depth = 3)
  *var_idx = num497;
  if (num497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe498 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block499 = alloc_Block(NULL, NULL, "stringMap", 232);
  gc_frame_newslot(block499);
// method "_apply"
  block_savedest(block499);
  Object closure500 = createclosure(2, "_apply");
  setclosureframe(closure500, stackframe);
  addtoclosure(closure500, var_count);
  addtoclosure(closure500, selfslot);
  struct UserObject *uo500 = (struct UserObject*)block499;
  uo500->data[0] = (Object)closure500;
  Method *meth_meth_stringMap__apply500 = addmethod2pos(block499, "_apply", &meth_stringMap__apply500, 0);
  int argcv_meth_stringMap__apply500[] = {0};
  meth_meth_stringMap__apply500->type = alloc_MethodType(1, argcv_meth_stringMap__apply500);
  meth_meth_stringMap__apply500->definitionModule = modulename;
  meth_meth_stringMap__apply500->definitionLine = 218;
// compiled block node returning block499 (depth = 3)
  gc_frame_newslot(block499);
// starting to compile block node (depth = 3)
  Object block507 = alloc_Block(NULL, NULL, "stringMap", 232);
  gc_frame_newslot(block507);
// method "_apply"
  block_savedest(block507);
  Object closure508 = createclosure(5, "_apply");
  setclosureframe(closure508, stackframe);
  addtoclosure(closure508, var_idx);
  addtoclosure(closure508, var_unused);
  addtoclosure(closure508, var_result);
  addtoclosure(closure508, var_count);
  addtoclosure(closure508, selfslot);
  struct UserObject *uo508 = (struct UserObject*)block507;
  uo508->data[0] = (Object)closure508;
  Method *meth_meth_stringMap__apply508 = addmethod2pos(block507, "_apply", &meth_stringMap__apply508, 0);
  int argcv_meth_stringMap__apply508[] = {0};
  meth_meth_stringMap__apply508->type = alloc_MethodType(1, argcv_meth_stringMap__apply508);
  meth_meth_stringMap__apply508->definitionModule = modulename;
  meth_meth_stringMap__apply508->definitionLine = 232;
// compiled block node returning block507 (depth = 3)
  gc_frame_newslot(block507);
// call case 5: prelude request
  params[0] = block499;
  params[1] = block507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call546 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe498);
// compiled call node returning call546 (depth = 2)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_stringMap__apply567(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe568 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe569 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call570 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe569);
// compiled call node returning call570 (depth = 6)
// compiled member node returning call570 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call571 = callmethod(call570, "at()put",
    2, partcv, params);
  gc_frame_end(callframe568);
// compiled call node returning call571 (depth = 4)
  gc_frame_end(frame);
  return call571;
}
Object meth_stringMap_new1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2 = alloc_userobj2(20,19, objclass2);
  gc_frame_newslot(obj2);
if (objclass2 == NULL) {
  glfree(obj2->class->name);
  obj2->class->name = "stringMap.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2, self, 0);
  addmethodreal(obj2,"outer", &reader_stringMap_outer_3);
  Object oldself2 = self;
  struct StackFrameObject *oldstackframe2 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2);
  gc_frame_newslot((Object)stackframe);
  self = obj2;
  Object *oldselfslot2 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2 = (*(struct UserObject *)self).data[0], lowerouter2 = thisouter2;
  if (inheritingObject2) {
    struct UserObject *inho2 = (struct UserObject *)inheritingObject2;
    while (inho2->super != GraceDefaultObject) inho2 = (struct UserObject *)inho2->super;
    inho2->super = obj2;
    self = inheritingObject2;
    *selfslot = self;
    lowerouter2 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2;
  }
if (objclass2 == NULL) {
  Method *reader4 = addmethodrealflags(obj2, "elems",&reader_stringMap_elems_4, MFLAG_CONFIDENTIAL);
  Method *writer4 = addmethodrealflags(obj2, "elems:=",&writer_stringMap_elems_4, MFLAG_CONFIDENTIAL);
  reader4->definitionModule = modulename;
  writer4->definitionModule = modulename;
  reader4->definitionLine = 16;
  writer4->definitionLine = 16;
}
obj2->flags |= OFLAG_MUTABLE;
adddatum2(obj2, alloc_Undefined(), 1);
if (objclass2 == NULL) {
  Method *reader5 = addmethodrealflags(obj2, "inner",&reader_stringMap_inner_5, MFLAG_CONFIDENTIAL);
  Method *writer5 = addmethodrealflags(obj2, "inner:=",&writer_stringMap_inner_5, MFLAG_CONFIDENTIAL);
  reader5->definitionModule = modulename;
  writer5->definitionModule = modulename;
  reader5->definitionLine = 17;
  writer5->definitionLine = 17;
}
obj2->flags |= OFLAG_MUTABLE;
adddatum2(obj2, alloc_Undefined(), 2);
// method "size"
  struct UserObject *uo6 = (struct UserObject*)obj2;
  uo6->data[3] = emptyclosure;
  Method *meth_meth_stringMap_size6 = addmethod2pos(obj2, "size", &meth_stringMap_size6, 3);
  int argcv_meth_stringMap_size6[] = {0};
  meth_meth_stringMap_size6->type = alloc_MethodType(1, argcv_meth_stringMap_size6);
  meth_meth_stringMap_size6->definitionModule = modulename;
  meth_meth_stringMap_size6->definitionLine = 24;
// method "put"
  block_savedest(obj2);
  Object closure9 = createclosure(1, "put");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_unused);
  struct UserObject *uo9 = (struct UserObject*)obj2;
  uo9->data[4] = (Object)closure9;
  Method *meth_meth_stringMap_put9 = addmethod2pos(obj2, "put", &meth_stringMap_put9, 4);
  int argcv_meth_stringMap_put9[] = {2};
  meth_meth_stringMap_put9->type = alloc_MethodType(1, argcv_meth_stringMap_put9);
  meth_meth_stringMap_put9->definitionModule = modulename;
  meth_meth_stringMap_put9->definitionLine = 31;
// method "get"
  block_savedest(obj2);
  Object closure51 = createclosure(1, "get");
  setclosureframe(closure51, stackframe);
  addtoclosure(closure51, var_unused);
  struct UserObject *uo51 = (struct UserObject*)obj2;
  uo51->data[5] = (Object)closure51;
  Method *meth_meth_stringMap_get51 = addmethod2pos(obj2, "get", &meth_stringMap_get51, 5);
  int argcv_meth_stringMap_get51[] = {1};
  meth_meth_stringMap_get51->type = alloc_MethodType(1, argcv_meth_stringMap_get51);
  meth_meth_stringMap_get51->definitionModule = modulename;
  meth_meth_stringMap_get51->definitionLine = 46;
// method "get()ifAbsent"
  block_savedest(obj2);
  Object closure76 = createclosure(1, "get()ifAbsent");
  setclosureframe(closure76, stackframe);
  addtoclosure(closure76, var_unused);
  struct UserObject *uo76 = (struct UserObject*)obj2;
  uo76->data[6] = (Object)closure76;
  Method *meth_meth_stringMap_get_40__41_ifAbsent76 = addmethod2pos(obj2, "get()ifAbsent", &meth_stringMap_get_40__41_ifAbsent76, 6);
  int argcv_meth_stringMap_get_40__41_ifAbsent76[] = {1, 1};
  meth_meth_stringMap_get_40__41_ifAbsent76->type = alloc_MethodType(2, argcv_meth_stringMap_get_40__41_ifAbsent76);
  meth_meth_stringMap_get_40__41_ifAbsent76->definitionModule = modulename;
  meth_meth_stringMap_get_40__41_ifAbsent76->definitionLine = 61;
// method "contains"
  struct UserObject *uo91 = (struct UserObject*)obj2;
  uo91->data[7] = emptyclosure;
  Method *meth_meth_stringMap_contains91 = addmethod2pos(obj2, "contains", &meth_stringMap_contains91, 7);
  int argcv_meth_stringMap_contains91[] = {1};
  meth_meth_stringMap_contains91->type = alloc_MethodType(1, argcv_meth_stringMap_contains91);
  meth_meth_stringMap_contains91->definitionModule = modulename;
  meth_meth_stringMap_contains91->definitionLine = 73;
// method "findPosition"
  block_savedest(obj2);
  Object closure106 = createclosure(1, "findPosition");
  setclosureframe(closure106, stackframe);
  addtoclosure(closure106, var_unused);
  struct UserObject *uo106 = (struct UserObject*)obj2;
  uo106->data[8] = (Object)closure106;
  Method *meth_meth_stringMap_findPosition106 = addmethod2pos(obj2, "findPosition", &meth_stringMap_findPosition106, 8);
  int argcv_meth_stringMap_findPosition106[] = {1};
  meth_meth_stringMap_findPosition106->type = alloc_MethodType(1, argcv_meth_stringMap_findPosition106);
  meth_meth_stringMap_findPosition106->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_stringMap_findPosition106->definitionModule = modulename;
  meth_meth_stringMap_findPosition106->definitionLine = 84;
// method "asString"
  block_savedest(obj2);
  Object closure172 = createclosure(1, "asString");
  setclosureframe(closure172, stackframe);
  addtoclosure(closure172, var_unused);
  struct UserObject *uo172 = (struct UserObject*)obj2;
  uo172->data[9] = (Object)closure172;
  Method *meth_meth_stringMap_asString172 = addmethod2pos(obj2, "asString", &meth_stringMap_asString172, 9);
  int argcv_meth_stringMap_asString172[] = {0};
  meth_meth_stringMap_asString172->type = alloc_MethodType(1, argcv_meth_stringMap_asString172);
  meth_meth_stringMap_asString172->definitionModule = modulename;
  meth_meth_stringMap_asString172->definitionLine = 102;
// method "asDebugString"
  struct UserObject *uo255 = (struct UserObject*)obj2;
  uo255->data[10] = emptyclosure;
  Method *meth_meth_stringMap_asDebugString255 = addmethod2pos(obj2, "asDebugString", &meth_stringMap_asDebugString255, 10);
  int argcv_meth_stringMap_asDebugString255[] = {0};
  meth_meth_stringMap_asDebugString255->type = alloc_MethodType(1, argcv_meth_stringMap_asDebugString255);
  meth_meth_stringMap_asDebugString255->definitionModule = modulename;
  meth_meth_stringMap_asDebugString255->definitionLine = 130;
// method "keysAndValuesDo"
  block_savedest(obj2);
  Object closure258 = createclosure(1, "keysAndValuesDo");
  setclosureframe(closure258, stackframe);
  addtoclosure(closure258, var_unused);
  struct UserObject *uo258 = (struct UserObject*)obj2;
  uo258->data[11] = (Object)closure258;
  Method *meth_meth_stringMap_keysAndValuesDo258 = addmethod2pos(obj2, "keysAndValuesDo", &meth_stringMap_keysAndValuesDo258, 11);
  int argcv_meth_stringMap_keysAndValuesDo258[] = {1};
  meth_meth_stringMap_keysAndValuesDo258->type = alloc_MethodType(1, argcv_meth_stringMap_keysAndValuesDo258);
  meth_meth_stringMap_keysAndValuesDo258->definitionModule = modulename;
  meth_meth_stringMap_keysAndValuesDo258->definitionLine = 133;
// method "do"
  block_savedest(obj2);
  Object closure314 = createclosure(1, "do");
  setclosureframe(closure314, stackframe);
  addtoclosure(closure314, var_unused);
  struct UserObject *uo314 = (struct UserObject*)obj2;
  uo314->data[12] = (Object)closure314;
  Method *meth_meth_stringMap_do314 = addmethod2pos(obj2, "do", &meth_stringMap_do314, 12);
  int argcv_meth_stringMap_do314[] = {1};
  meth_meth_stringMap_do314->type = alloc_MethodType(1, argcv_meth_stringMap_do314);
  meth_meth_stringMap_do314->definitionModule = modulename;
  meth_meth_stringMap_do314->definitionLine = 155;
// method "keysDo"
  block_savedest(obj2);
  Object closure368 = createclosure(1, "keysDo");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_unused);
  struct UserObject *uo368 = (struct UserObject*)obj2;
  uo368->data[13] = (Object)closure368;
  Method *meth_meth_stringMap_keysDo368 = addmethod2pos(obj2, "keysDo", &meth_stringMap_keysDo368, 13);
  int argcv_meth_stringMap_keysDo368[] = {1};
  meth_meth_stringMap_keysDo368->type = alloc_MethodType(1, argcv_meth_stringMap_keysDo368);
  meth_meth_stringMap_keysDo368->definitionModule = modulename;
  meth_meth_stringMap_keysDo368->definitionLine = 177;
// method "valuesDo"
  struct UserObject *uo422 = (struct UserObject*)obj2;
  uo422->data[14] = emptyclosure;
  Method *meth_meth_stringMap_valuesDo422 = addmethod2pos(obj2, "valuesDo", &meth_stringMap_valuesDo422, 14);
  int argcv_meth_stringMap_valuesDo422[] = {1};
  meth_meth_stringMap_valuesDo422->type = alloc_MethodType(1, argcv_meth_stringMap_valuesDo422);
  meth_meth_stringMap_valuesDo422->definitionModule = modulename;
  meth_meth_stringMap_valuesDo422->definitionLine = 198;
// method "expand"
  block_savedest(obj2);
  Object closure425 = createclosure(1, "expand");
  setclosureframe(closure425, stackframe);
  addtoclosure(closure425, var_unused);
  struct UserObject *uo425 = (struct UserObject*)obj2;
  uo425->data[15] = (Object)closure425;
  Method *meth_meth_stringMap_expand425 = addmethod2pos(obj2, "expand", &meth_stringMap_expand425, 15);
  int argcv_meth_stringMap_expand425[] = {0};
  meth_meth_stringMap_expand425->type = alloc_MethodType(1, argcv_meth_stringMap_expand425);
  meth_meth_stringMap_expand425->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_stringMap_expand425->definitionModule = modulename;
  meth_meth_stringMap_expand425->definitionLine = 200;
// method "asList"
  block_savedest(obj2);
  Object closure493 = createclosure(1, "asList");
  setclosureframe(closure493, stackframe);
  addtoclosure(closure493, var_unused);
  struct UserObject *uo493 = (struct UserObject*)obj2;
  uo493->data[16] = (Object)closure493;
  Method *meth_meth_stringMap_asList493 = addmethod2pos(obj2, "asList", &meth_stringMap_asList493, 16);
  int argcv_meth_stringMap_asList493[] = {0};
  meth_meth_stringMap_asList493->type = alloc_MethodType(1, argcv_meth_stringMap_asList493);
  meth_meth_stringMap_asList493->definitionModule = modulename;
  meth_meth_stringMap_asList493->definitionLine = 216;
  sourceObject = obj2;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num547 = alloc_Float64(0);
// compiled num node returning num547 (depth = 2)
  adddatum2(obj2, num547, 1);
  sourceObject = obj2;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe548 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num549 = alloc_Float64(4);
// compiled num node returning num549 (depth = 3)
  gc_frame_newslot(num549);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe550 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call551 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 4)
// compiled member node returning call551 (depth = 3)
  params[0] = num549;
  partcv[0] = 1;
  Object call552 = callmethod(call551, "new",
    1, partcv, params);
  gc_frame_end(callframe548);
// compiled call node returning call552 (depth = 2)
  adddatum2(obj2, call552, 2);
  sourceObject = obj2;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe553 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num556 = alloc_Float64(1);
// compiled num node returning num556 (depth = 5)
  int op_slot_right_555 = gc_frame_newslot(num556);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe558 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call560 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe559);
// compiled call node returning call560 (depth = 8)
// compiled member node returning call560 (depth = 7)
  partcv[0] = 0;
  Object call561 = callmethod(call560, "size",
    1, partcv, params);
  gc_frame_end(callframe558);
// compiled call node returning call561 (depth = 6)
// compiled member node returning call561 (depth = 5)
  int op_slot_left_555 = gc_frame_newslot(call561);
  params[0] = num556;
  partcv[0] = 1;
  Object diff562 = callmethod(call561, "-", 1, partcv, params);
// compiled op node returning diff562 (depth = 4)
  int op_slot_right_554 = gc_frame_newslot(diff562);
// starting to compile num node (depth = 4)
  Object num564 = alloc_Float64(0);
// compiled num node returning num564 (depth = 4)
  int op_slot_left_554 = gc_frame_newslot(num564);
  params[0] = diff562;
  partcv[0] = 1;
  Object opresult565 = callmethod(num564, "..", 1, partcv, params);
// compiled op node returning opresult565 (depth = 3)
  gc_frame_newslot(opresult565);
// starting to compile block node (depth = 3)
  Object block566 = alloc_Block(NULL, NULL, "stringMap", 18);
  gc_frame_newslot(block566);
// method "_apply"
  block_savedest(block566);
  Object closure567 = createclosure(2, "_apply");
  setclosureframe(closure567, stackframe);
  addtoclosure(closure567, var_unused);
  addtoclosure(closure567, selfslot);
  struct UserObject *uo567 = (struct UserObject*)block566;
  uo567->data[0] = (Object)closure567;
  Method *meth_meth_stringMap__apply567 = addmethod2pos(block566, "_apply", &meth_stringMap__apply567, 0);
  int argcv_meth_stringMap__apply567[] = {1};
  meth_meth_stringMap__apply567->type = alloc_MethodType(1, argcv_meth_stringMap__apply567);
  meth_meth_stringMap__apply567->definitionModule = modulename;
  meth_meth_stringMap__apply567->definitionLine = 18;
// compiled block node returning block566 (depth = 3)
  gc_frame_newslot(block566);
// call case 5: prelude request
  params[0] = opresult565;
  params[1] = block566;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call573 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe553);
// compiled call node returning call573 (depth = 2)
  sourceObject = obj2;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  objclass2 = obj2->class;
  objclass2->definitionModule = modulename;
  objclass2->definitionLine = 15;
  (*(struct UserObject *)self).data[0] = lowerouter2;
  self = oldself2;
  selfslot = oldselfslot2;
  stackframe = oldstackframe2;
  gc_frame_end(frame);
  return obj2;
}
Object meth_stringMap_new1_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2 = alloc_userobj2(20,19, objclass2);
  gc_frame_newslot(obj2);
if (objclass2 == NULL) {
  glfree(obj2->class->name);
  obj2->class->name = "stringMap.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2, self, 0);
  addmethodreal(obj2,"outer", &reader_stringMap_outer_3);
  Object oldself2 = self;
  struct StackFrameObject *oldstackframe2 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2);
  gc_frame_newslot((Object)stackframe);
  self = obj2;
  Object *oldselfslot2 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2 = (*(struct UserObject *)self).data[0], lowerouter2 = thisouter2;
  if (inheritingObject2) {
    struct UserObject *inho2 = (struct UserObject *)inheritingObject2;
    while (inho2->super != GraceDefaultObject) inho2 = (struct UserObject *)inho2->super;
    inho2->super = obj2;
    self = inheritingObject2;
    *selfslot = self;
    lowerouter2 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2;
  }
if (objclass2 == NULL) {
  Method *reader4 = addmethodrealflags(obj2, "elems",&reader_stringMap_elems_4, MFLAG_CONFIDENTIAL);
  Method *writer4 = addmethodrealflags(obj2, "elems:=",&writer_stringMap_elems_4, MFLAG_CONFIDENTIAL);
  reader4->definitionModule = modulename;
  writer4->definitionModule = modulename;
  reader4->definitionLine = 16;
  writer4->definitionLine = 16;
}
obj2->flags |= OFLAG_MUTABLE;
adddatum2(obj2, alloc_Undefined(), 1);
if (objclass2 == NULL) {
  Method *reader5 = addmethodrealflags(obj2, "inner",&reader_stringMap_inner_5, MFLAG_CONFIDENTIAL);
  Method *writer5 = addmethodrealflags(obj2, "inner:=",&writer_stringMap_inner_5, MFLAG_CONFIDENTIAL);
  reader5->definitionModule = modulename;
  writer5->definitionModule = modulename;
  reader5->definitionLine = 17;
  writer5->definitionLine = 17;
}
obj2->flags |= OFLAG_MUTABLE;
adddatum2(obj2, alloc_Undefined(), 2);
// method "size"
  struct UserObject *uo6 = (struct UserObject*)obj2;
  uo6->data[3] = emptyclosure;
  Method *meth_meth_stringMap_size6 = addmethod2pos(obj2, "size", &meth_stringMap_size6, 3);
  int argcv_meth_stringMap_size6[] = {0};
  meth_meth_stringMap_size6->type = alloc_MethodType(1, argcv_meth_stringMap_size6);
  meth_meth_stringMap_size6->definitionModule = modulename;
  meth_meth_stringMap_size6->definitionLine = 24;
// method "put"
  block_savedest(obj2);
  Object closure9 = createclosure(1, "put");
  setclosureframe(closure9, stackframe);
  addtoclosure(closure9, var_unused);
  struct UserObject *uo9 = (struct UserObject*)obj2;
  uo9->data[4] = (Object)closure9;
  Method *meth_meth_stringMap_put9 = addmethod2pos(obj2, "put", &meth_stringMap_put9, 4);
  int argcv_meth_stringMap_put9[] = {2};
  meth_meth_stringMap_put9->type = alloc_MethodType(1, argcv_meth_stringMap_put9);
  meth_meth_stringMap_put9->definitionModule = modulename;
  meth_meth_stringMap_put9->definitionLine = 31;
// method "get"
  block_savedest(obj2);
  Object closure51 = createclosure(1, "get");
  setclosureframe(closure51, stackframe);
  addtoclosure(closure51, var_unused);
  struct UserObject *uo51 = (struct UserObject*)obj2;
  uo51->data[5] = (Object)closure51;
  Method *meth_meth_stringMap_get51 = addmethod2pos(obj2, "get", &meth_stringMap_get51, 5);
  int argcv_meth_stringMap_get51[] = {1};
  meth_meth_stringMap_get51->type = alloc_MethodType(1, argcv_meth_stringMap_get51);
  meth_meth_stringMap_get51->definitionModule = modulename;
  meth_meth_stringMap_get51->definitionLine = 46;
// method "get()ifAbsent"
  block_savedest(obj2);
  Object closure76 = createclosure(1, "get()ifAbsent");
  setclosureframe(closure76, stackframe);
  addtoclosure(closure76, var_unused);
  struct UserObject *uo76 = (struct UserObject*)obj2;
  uo76->data[6] = (Object)closure76;
  Method *meth_meth_stringMap_get_40__41_ifAbsent76 = addmethod2pos(obj2, "get()ifAbsent", &meth_stringMap_get_40__41_ifAbsent76, 6);
  int argcv_meth_stringMap_get_40__41_ifAbsent76[] = {1, 1};
  meth_meth_stringMap_get_40__41_ifAbsent76->type = alloc_MethodType(2, argcv_meth_stringMap_get_40__41_ifAbsent76);
  meth_meth_stringMap_get_40__41_ifAbsent76->definitionModule = modulename;
  meth_meth_stringMap_get_40__41_ifAbsent76->definitionLine = 61;
// method "contains"
  struct UserObject *uo91 = (struct UserObject*)obj2;
  uo91->data[7] = emptyclosure;
  Method *meth_meth_stringMap_contains91 = addmethod2pos(obj2, "contains", &meth_stringMap_contains91, 7);
  int argcv_meth_stringMap_contains91[] = {1};
  meth_meth_stringMap_contains91->type = alloc_MethodType(1, argcv_meth_stringMap_contains91);
  meth_meth_stringMap_contains91->definitionModule = modulename;
  meth_meth_stringMap_contains91->definitionLine = 73;
// method "findPosition"
  block_savedest(obj2);
  Object closure106 = createclosure(1, "findPosition");
  setclosureframe(closure106, stackframe);
  addtoclosure(closure106, var_unused);
  struct UserObject *uo106 = (struct UserObject*)obj2;
  uo106->data[8] = (Object)closure106;
  Method *meth_meth_stringMap_findPosition106 = addmethod2pos(obj2, "findPosition", &meth_stringMap_findPosition106, 8);
  int argcv_meth_stringMap_findPosition106[] = {1};
  meth_meth_stringMap_findPosition106->type = alloc_MethodType(1, argcv_meth_stringMap_findPosition106);
  meth_meth_stringMap_findPosition106->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_stringMap_findPosition106->definitionModule = modulename;
  meth_meth_stringMap_findPosition106->definitionLine = 84;
// method "asString"
  block_savedest(obj2);
  Object closure172 = createclosure(1, "asString");
  setclosureframe(closure172, stackframe);
  addtoclosure(closure172, var_unused);
  struct UserObject *uo172 = (struct UserObject*)obj2;
  uo172->data[9] = (Object)closure172;
  Method *meth_meth_stringMap_asString172 = addmethod2pos(obj2, "asString", &meth_stringMap_asString172, 9);
  int argcv_meth_stringMap_asString172[] = {0};
  meth_meth_stringMap_asString172->type = alloc_MethodType(1, argcv_meth_stringMap_asString172);
  meth_meth_stringMap_asString172->definitionModule = modulename;
  meth_meth_stringMap_asString172->definitionLine = 102;
// method "asDebugString"
  struct UserObject *uo255 = (struct UserObject*)obj2;
  uo255->data[10] = emptyclosure;
  Method *meth_meth_stringMap_asDebugString255 = addmethod2pos(obj2, "asDebugString", &meth_stringMap_asDebugString255, 10);
  int argcv_meth_stringMap_asDebugString255[] = {0};
  meth_meth_stringMap_asDebugString255->type = alloc_MethodType(1, argcv_meth_stringMap_asDebugString255);
  meth_meth_stringMap_asDebugString255->definitionModule = modulename;
  meth_meth_stringMap_asDebugString255->definitionLine = 130;
// method "keysAndValuesDo"
  block_savedest(obj2);
  Object closure258 = createclosure(1, "keysAndValuesDo");
  setclosureframe(closure258, stackframe);
  addtoclosure(closure258, var_unused);
  struct UserObject *uo258 = (struct UserObject*)obj2;
  uo258->data[11] = (Object)closure258;
  Method *meth_meth_stringMap_keysAndValuesDo258 = addmethod2pos(obj2, "keysAndValuesDo", &meth_stringMap_keysAndValuesDo258, 11);
  int argcv_meth_stringMap_keysAndValuesDo258[] = {1};
  meth_meth_stringMap_keysAndValuesDo258->type = alloc_MethodType(1, argcv_meth_stringMap_keysAndValuesDo258);
  meth_meth_stringMap_keysAndValuesDo258->definitionModule = modulename;
  meth_meth_stringMap_keysAndValuesDo258->definitionLine = 133;
// method "do"
  block_savedest(obj2);
  Object closure314 = createclosure(1, "do");
  setclosureframe(closure314, stackframe);
  addtoclosure(closure314, var_unused);
  struct UserObject *uo314 = (struct UserObject*)obj2;
  uo314->data[12] = (Object)closure314;
  Method *meth_meth_stringMap_do314 = addmethod2pos(obj2, "do", &meth_stringMap_do314, 12);
  int argcv_meth_stringMap_do314[] = {1};
  meth_meth_stringMap_do314->type = alloc_MethodType(1, argcv_meth_stringMap_do314);
  meth_meth_stringMap_do314->definitionModule = modulename;
  meth_meth_stringMap_do314->definitionLine = 155;
// method "keysDo"
  block_savedest(obj2);
  Object closure368 = createclosure(1, "keysDo");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_unused);
  struct UserObject *uo368 = (struct UserObject*)obj2;
  uo368->data[13] = (Object)closure368;
  Method *meth_meth_stringMap_keysDo368 = addmethod2pos(obj2, "keysDo", &meth_stringMap_keysDo368, 13);
  int argcv_meth_stringMap_keysDo368[] = {1};
  meth_meth_stringMap_keysDo368->type = alloc_MethodType(1, argcv_meth_stringMap_keysDo368);
  meth_meth_stringMap_keysDo368->definitionModule = modulename;
  meth_meth_stringMap_keysDo368->definitionLine = 177;
// method "valuesDo"
  struct UserObject *uo422 = (struct UserObject*)obj2;
  uo422->data[14] = emptyclosure;
  Method *meth_meth_stringMap_valuesDo422 = addmethod2pos(obj2, "valuesDo", &meth_stringMap_valuesDo422, 14);
  int argcv_meth_stringMap_valuesDo422[] = {1};
  meth_meth_stringMap_valuesDo422->type = alloc_MethodType(1, argcv_meth_stringMap_valuesDo422);
  meth_meth_stringMap_valuesDo422->definitionModule = modulename;
  meth_meth_stringMap_valuesDo422->definitionLine = 198;
// method "expand"
  block_savedest(obj2);
  Object closure425 = createclosure(1, "expand");
  setclosureframe(closure425, stackframe);
  addtoclosure(closure425, var_unused);
  struct UserObject *uo425 = (struct UserObject*)obj2;
  uo425->data[15] = (Object)closure425;
  Method *meth_meth_stringMap_expand425 = addmethod2pos(obj2, "expand", &meth_stringMap_expand425, 15);
  int argcv_meth_stringMap_expand425[] = {0};
  meth_meth_stringMap_expand425->type = alloc_MethodType(1, argcv_meth_stringMap_expand425);
  meth_meth_stringMap_expand425->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_stringMap_expand425->definitionModule = modulename;
  meth_meth_stringMap_expand425->definitionLine = 200;
// method "asList"
  block_savedest(obj2);
  Object closure493 = createclosure(1, "asList");
  setclosureframe(closure493, stackframe);
  addtoclosure(closure493, var_unused);
  struct UserObject *uo493 = (struct UserObject*)obj2;
  uo493->data[16] = (Object)closure493;
  Method *meth_meth_stringMap_asList493 = addmethod2pos(obj2, "asList", &meth_stringMap_asList493, 16);
  int argcv_meth_stringMap_asList493[] = {0};
  meth_meth_stringMap_asList493->type = alloc_MethodType(1, argcv_meth_stringMap_asList493);
  meth_meth_stringMap_asList493->definitionModule = modulename;
  meth_meth_stringMap_asList493->definitionLine = 216;
  sourceObject = obj2;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num547 = alloc_Float64(0);
// compiled num node returning num547 (depth = 2)
  adddatum2(obj2, num547, 1);
  sourceObject = obj2;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe548 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num549 = alloc_Float64(4);
// compiled num node returning num549 (depth = 3)
  gc_frame_newslot(num549);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe550 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call551 = callmethodflags(prelude, "primitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 4)
// compiled member node returning call551 (depth = 3)
  params[0] = num549;
  partcv[0] = 1;
  Object call552 = callmethod(call551, "new",
    1, partcv, params);
  gc_frame_end(callframe548);
// compiled call node returning call552 (depth = 2)
  adddatum2(obj2, call552, 2);
  sourceObject = obj2;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe553 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num556 = alloc_Float64(1);
// compiled num node returning num556 (depth = 5)
  int op_slot_right_555 = gc_frame_newslot(num556);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe558 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call560 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe559);
// compiled call node returning call560 (depth = 8)
// compiled member node returning call560 (depth = 7)
  partcv[0] = 0;
  Object call561 = callmethod(call560, "size",
    1, partcv, params);
  gc_frame_end(callframe558);
// compiled call node returning call561 (depth = 6)
// compiled member node returning call561 (depth = 5)
  int op_slot_left_555 = gc_frame_newslot(call561);
  params[0] = num556;
  partcv[0] = 1;
  Object diff562 = callmethod(call561, "-", 1, partcv, params);
// compiled op node returning diff562 (depth = 4)
  int op_slot_right_554 = gc_frame_newslot(diff562);
// starting to compile num node (depth = 4)
  Object num564 = alloc_Float64(0);
// compiled num node returning num564 (depth = 4)
  int op_slot_left_554 = gc_frame_newslot(num564);
  params[0] = diff562;
  partcv[0] = 1;
  Object opresult565 = callmethod(num564, "..", 1, partcv, params);
// compiled op node returning opresult565 (depth = 3)
  gc_frame_newslot(opresult565);
// starting to compile block node (depth = 3)
  Object block566 = alloc_Block(NULL, NULL, "stringMap", 18);
  gc_frame_newslot(block566);
// method "_apply"
  block_savedest(block566);
  Object closure567 = createclosure(2, "_apply");
  setclosureframe(closure567, stackframe);
  addtoclosure(closure567, var_unused);
  addtoclosure(closure567, selfslot);
  struct UserObject *uo567 = (struct UserObject*)block566;
  uo567->data[0] = (Object)closure567;
  Method *meth_meth_stringMap__apply567 = addmethod2pos(block566, "_apply", &meth_stringMap__apply567, 0);
  int argcv_meth_stringMap__apply567[] = {1};
  meth_meth_stringMap__apply567->type = alloc_MethodType(1, argcv_meth_stringMap__apply567);
  meth_meth_stringMap__apply567->definitionModule = modulename;
  meth_meth_stringMap__apply567->definitionLine = 18;
// compiled block node returning block566 (depth = 3)
  gc_frame_newslot(block566);
// call case 5: prelude request
  params[0] = opresult565;
  params[1] = block566;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call573 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe553);
// compiled call node returning call573 (depth = 2)
  sourceObject = obj2;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  sourceObject = obj2;
  objclass2 = obj2->class;
  objclass2->definitionModule = modulename;
  objclass2->definitionLine = 15;
  (*(struct UserObject *)self).data[0] = lowerouter2;
  self = oldself2;
  selfslot = oldselfslot2;
  stackframe = oldstackframe2;
  gc_frame_end(frame);
  return obj2;
}
Object meth_stringMap_unused583(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unused");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for unused (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for unused");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unused (depth = 3)
  gc_frame_end(frame);
  return *var_unused;
}
Object module_stringMap_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(5, 5);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<stringMap>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[2];
  int partcv[2];
  Object *var_unused = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "unused");
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "new"
  block_savedest(self);
  Object closure1 = createclosure(1, "new");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_unused);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_stringMap_new1 = addmethod2pos(self, "new", &meth_stringMap_new1, 1);
  int argcv_meth_stringMap_new1[] = {0};
  meth_meth_stringMap_new1->type = alloc_MethodType(1, argcv_meth_stringMap_new1);
  meth_meth_stringMap_new1->definitionModule = modulename;
  meth_meth_stringMap_new1->definitionLine = 15;
  block_savedest(self);
  Object closure574 = createclosure(1, "new()object");
  setclosureframe(closure574, stackframe);
  addtoclosure(closure574, var_unused);
  Method *meth_meth_stringMap_new1_object = addmethod2pos(self, "new()object", &meth_stringMap_new1_object, 1);
  meth_meth_stringMap_new1_object->definitionModule = modulename;
  meth_meth_stringMap_new1_object->definitionLine = 15;
// compiled method node returning  (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject575 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj575 = alloc_userobj2(1,2, objclass575);
  gc_frame_newslot(obj575);
if (objclass575 == NULL) {
  glfree(obj575->class->name);
  obj575->class->name = "unused";
}
// OBJECT OUTER DEC outer
  adddatum2(obj575, self, 0);
  addmethodreal(obj575,"outer", &reader_stringMap_outer_576);
  Object oldself575 = self;
  struct StackFrameObject *oldstackframe575 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe575);
  gc_frame_newslot((Object)stackframe);
  self = obj575;
  Object *oldselfslot575 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter575 = (*(struct UserObject *)self).data[0], lowerouter575 = thisouter575;
  if (inheritingObject575) {
    struct UserObject *inho575 = (struct UserObject *)inheritingObject575;
    while (inho575->super != GraceDefaultObject) inho575 = (struct UserObject *)inho575->super;
    inho575->super = obj575;
    self = inheritingObject575;
    *selfslot = self;
    lowerouter575 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter575;
  }
if (objclass575 == NULL) {
  Method *reader577 = addmethodrealflags(obj575, "key",&reader_stringMap_key_577, MFLAG_DEF);
  reader577->definitionModule = modulename;
  reader577->definitionLine = 12;
}
adddatum2(obj575, alloc_Undefined(), 1);
  sourceObject = obj575;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe578 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit579 == NULL) {
    strlit579 = alloc_String("unused");
    gc_root(strlit579);
  }
// compiled string node returning strlit579 (depth = 4)
  gc_frame_newslot(strlit579);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe580 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call581 = callmethodflags(prelude, "Singleton", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe580);
// compiled call node returning call581 (depth = 5)
// compiled member node returning call581 (depth = 4)
  params[0] = strlit579;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call582 = callmethod(call581, "named()object",
    2, partcv, params);
  gc_frame_end(callframe578);
// compiled call node returning call582 (depth = 3)
  struct UserObject *obj575_uo = (struct UserObject *)obj575;
  obj575_uo->super = call582;
  sourceObject = obj575;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj575, self, 1);
  objclass575 = obj575->class;
  objclass575->definitionModule = modulename;
  objclass575->definitionLine = 10;
  (*(struct UserObject *)self).data[0] = lowerouter575;
  self = oldself575;
  selfslot = oldselfslot575;
  stackframe = oldstackframe575;
// compiled object node returning obj575 (depth = 2)
  *var_unused = obj575;
  if (obj575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unused"
  block_savedest(self);
  Object closure583 = createclosure(1, "unused");
  setclosureframe(closure583, stackframe);
  addtoclosure(closure583, var_unused);
  struct UserObject *uo583 = (struct UserObject*)self;
  uo583->data[2] = (Object)closure583;
  Method *meth_meth_stringMap_unused583 = addmethod2pos(self, "unused", &meth_stringMap_unused583, 2);
  int argcv_meth_stringMap_unused583[] = {0};
  meth_meth_stringMap_unused583->type = alloc_MethodType(1, argcv_meth_stringMap_unused583);
  meth_meth_stringMap_unused583->definitionModule = modulename;
  meth_meth_stringMap_unused583->definitionLine = 11;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
